#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "1e6315be77eff662cf99876c2ac8964a81f2abc7";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "ast";
Object module_standardGrace_init();
extern Object module_standardGrace;
Object module_ast = NULL;
static char *originalSourceLines[] = {
  "#pragma noTypeChecks",
  "#pragma ExtendedLineups",
  "import \"util\" as util",
  "import \"identifierKinds\" as k",
  "",
  "// This module contains classes and pseudo-classes for all the AST nodes used",
  "// in the parser. Because of the limitations of the class syntax, classes that",
  "// need more than one method are written as object literals containing methods.",
  "// Each node has a different signature according to its function, but the",
  "// common interface is given by type ASTNode",
  "//",
  "// Most nodes also contain a \"value\" field, with varied type, holding the `main value`",
  "// in the node.  This field is confusing and should be appropriately re-named in",
  "// each case. Some nodes contain other fields for their specific use: while has",
  "// both a value (the condition) and a body, for example.",
  "",
  "type Position = type {",
  "    line -> Number",
  "    column -> Number",
  "    > -> Boolean",
  "    ≥ -> Boolean",
  "    == -> Boolean",
  "    < -> Boolean",
  "    ≤ -> Boolean",
  "}",
  "type Range = type {",
  "    start -> Position",
  "    end -> Position",
  "}",
  "class line (l:Number) column (c:Number) -> Position {",
  "    def line is public = l",
  "    def column is public = c",
  "    method > (other:Position) -> Boolean {",
  "        if (line > other.line) then { return true }",
  "        if (line < other.line) then { return false }",
  "        (column > other.column)",
  "    }",
  "    method ≥ (other:Position) -> Boolean {",
  "        if (line > other.line) then { return true }",
  "        if (line < other.line) then { return false }",
  "        (column ≥ other.column)",
  "    }",
  "    method == (other:Position) -> Boolean {",
  "        (line == other.line) && (column == other.column)",
  "    }",
  "    method ≤ (other:Position) -> Boolean {",
  "        (other > self).not",
  "    }",
  "    method < (other:Position) -> Boolean {",
  "        (other ≥ self).not",
  "    }",
  "    method asString { \"{line}:{column}\" }",
  "}",
  "class start (s:Position) end (e:Position) -> Range {",
  "    def start is public = s",
  "    def end is public = e",
  "    method asString {",
  "        if (start.line == end.line) then {",
  "            \"{start}-{end.column}\"",
  "        } elseif { end.line == noPosition } then {",
  "            start.asString",
  "        } else {",
  "            \"{start}-{end}\"",
  "        }",
  "    }",
  "    method == (other) {",
  "        (start == other.start) && (end == other.end)",
  "    }",
  "}",
  "def noPosition is public = line 0 column 0",
  "def emptyRange is public = start (noPosition) end (noPosition)",
  "",
  "method positionOfNext (needle:String) after (pos:Position) -> Position {",
  "    def sourceLines = util.lines",
  "    var lineNr := pos.line",
  "    if (lineNr == 0) then { return noPosition }",
  "    var found := sourceLines.at(lineNr).indexOf (needle) startingAt (pos.column + 1)",
  "    while { found == 0 } do {",
  "        lineNr := lineNr + 1",
  "        if (lineNr > sourceLines.size) then { return noPosition }",
  "        found := sourceLines.at(lineNr).indexOf (needle)",
  "    }",
  "    line (lineNr) column (found)",
  "}",
  "",
  "method positionOfNext (needle1:String) or (needle2:String)",
  "          after (pos:Position) -> Position {",
  "    def sourceLines = util.lines",
  "    var lineNr := pos.line",
  "    if (lineNr == 0) then { return noPosition }",
  "    var found := sourceLines.at(lineNr).indexOf (needle1) startingAt (pos.column + 1)",
  "    if (found == 0) then {",
  "        found := sourceLines.at(lineNr).indexOf (needle2) startingAt (pos.column + 1)",
  "    }",
  "    while { found == 0 } do {",
  "        lineNr := lineNr + 1",
  "        if (lineNr > sourceLines.size) then { return noPosition }",
  "        found := sourceLines.at(lineNr).indexOf (needle1)",
  "        if (found == 0) then {",
  "            found := sourceLines.at(lineNr).indexOf (needle2)",
  "        }",
  "    }",
  "    line (lineNr) column (found)",
  "}",
  "",
  "def lineLength is public = 80",
  "def uninitialized = Singleton.named \"uninitialized\"",
  "method listMap(l, b) ancestors(as) is confidential {",
  "    def newList = [ ]",
  "    l.do { nd -> newList.addLast(nd.map(b) ancestors(as)) }",
  "    newList",
  "}",
  "method maybeMap(n, b) ancestors(as) is confidential {",
  "    if (false != n) then {",
  "        n.map(b) ancestors(as)",
  "    } else {",
  "        n",
  "    }",
  "}",
  "method maybeListMap(n, b) ancestors(as) is confidential {",
  "    if (false != n) then {",
  "        listMap(n, b) ancestors(as)",
  "    } else {",
  "        n",
  "    }",
  "}",
  "",
  "def ancestorChain is public = object {",
  "    class empty {",
  "        method isEmpty { true }",
  "        method asString { \"ancestorChain ▫\" }",
  "        method extend(n) { cons(n) onto(self) }",
  "    }",
  "    method with(n) { empty.extend(n) }",
  "    class cons(p) onto(as) is confidential {",
  "        method forebears { as }",
  "        method isEmpty { false }",
  "        method parent { p }",
  "        method grandparent { forebears.parent }",
  "",
  "        method asString {",
  "            var a := self",
  "            var s := \"ancestorChain \"",
  "            while { a.isEmpty.not } do {",
  "                s := s ++ a.parent ++ \"➤\"",
  "                a := a.forebears",
  "            }",
  "            s ++ \"▫\"",
  "        }",
  "        method suchThat(cond) ifAbsent (action) {",
  "            var a := self",
  "            while { a.isEmpty.not } do {",
  "                if (cond.apply(a.parent)) then { return a.parent }",
  "                a := a.forebears",
  "            }",
  "            action.apply",
  "        }",
  "        method extend(n) { cons(n) onto(self) }",
  "    }",
  "}",
  "",
  "def emptySeq = emptySequence",
  "",
  "type AstNode = type {",
  "    kind -> String",
  "        // Used for pseudo-instanceof tests, and for printing",
  "    register -> String",
  "        // Used in the code generator to name the resulting object",
  "    line -> Number",
  "        // The source line the node came from; the first line is 1",
  "    line:=(ln:Number)",
  "    column -> Number",
  "    linePos -> Number",
  "        // linePos and column are aliases; the first column is 1",
  "    linePos:=(lp:Number)",
  "    scope -> SymbolTable",
  "        // The symbolTable for names defined in this node and its sub-nodes",
  "    pretty(n:Number) -> String",
  "        // Pretty-print-string of node at depth n",
  "    comments -> AstNode",
  "        // Comments associated with this node",
  "    range -> Range",
  "        // The source range represented by this node",
  "    start -> Position",
  "        // The start of the source range represented by this node",
  "    end -> Position",
  "        // The end of the source range represented by this node",
  "}",
  "",
  "type SymbolTable = Unknown",
  "",
  "class baseNode {",
  "    // the superclass of all AST nodes",
  "    var register is public := \"\"",
  "    var line is public := util.linenum",
  "    var linePos is public := util.linepos",
  "    var symbolTable := fakeSymbolTable",
  "    var comments is public := false",
  "",
  "    method setLine (l) col (c) {",
  "        line := l",
  "        linePos := c",
  "        self",
  "    }",
  "    method setPositionFrom (tokenOrNode) {",
  "        line := tokenOrNode.line",
  "        linePos := tokenOrNode.linePos",
  "        self",
  "    }",
  "    method setStart(p: Position) {",
  "        line := p.line",
  "        linePos := p.column",
  "        self",
  "    }",
  "    method column { linePos }   // so that AstNode conforms to Position",
  "    method start { line (line) column (linePos) }",
  "    method end -> Position { line (line) column (linePos + self.value.size - 1) }",
  "    method range { start (start) end (end) }",
  "    method kind { abstract }",
  "    method ==(other) { self.isMe(other) }       // for usesAsType",
  "    method isAppliedOccurenceOfIdentifier { false }",
  "    method isMatchingBlock { false }",
  "    method isFieldDec { false }",
  "    method isInherits { false }",
  "    method isLegalInTrait { false }",
  "    method isMember { false }",
  "    method isMethod { false }",
  "    method isExecutable { true }",
  "    method isCall { false }",
  "    method isComment { false }",
  "    method isClass { false }    // is a method that returns a fresh object",
  "    method inClass { false }    // object in a syntactic class definiton",
  "    method isTrait { false }    // is a method that returns a trait object",
  "    method inTrait { false }    // object in a syntactic trait definition",
  "    method isBind { false }",
  "    method isReturn { false }",
  "    method isSelf { false }",
  "    method isSuper { false }",
  "    method isPrelude { false }",
  "    method isOuter { false }",
  "    method isSelfOrOuter { false }",
  "    method isBlock { false }",
  "    method isObject { false }",
  "    method isIdentifier { false }",
  "    method isDialect { false }",
  "    method isImport { false }",
  "    method isTypeDec { false }",
  "    method isExternal { false }",
  "    method isFresh { false }",
  "    method isConstant { false }",
  "    method canInherit { false }",
  "    method returnsObject { false }",
  "    method isImplicit { false }",
  "    method usesAsType(aNode) { false }",
  "    method hash { line.hash * linePos.hash }",
  "    method asString { \"{kind} {nameString}\" }",
  "    method nameString { \"?\" }",
  "    method isWritable { true }",
  "    method isReadable { true }",
  "    method isPublic { true }",
  "    method isConfidential { isPublic.not }",
  "    method decType {",
  "        if (false == self.dtype) then {",
  "            return unknownType",
  "        }",
  "        return self.dtype",
  "    }",
  "    method isSimple { true }  // needs no parens when used as receiver",
  "    method isDelimited { false }  // needs no parens when used as argument",
  "    method description { kind }",
  "    method accept(visitor) {",
  "        self.accept(visitor) from (ancestorChain.empty)",
  "    }",
  "    method scope { symbolTable }",
  "",
  "    method scope:=(st) {",
  "        // override this method in subobjects that open a new scope. In such",
  "        // subobjects, and only in such subobjects, there should be a 2-way",
  "        // conection between the node and the symbol table that defines its scope.",
  "        symbolTable := st",
  "    }",
  "    method setScope(st) {",
  "        // sets the symboltable, and answers self, for chaining.",
  "        scope := st",
  "        self",
  "    }",
  "    method shallowCopyFieldsFrom(other) {",
  "        register := other.register",
  "        line := other.line",
  "        linePos := other.linePos",
  "        scope := other.scope",
  "        postCopy(other)",
  "        self",
  "    }",
  "    method postCopy(other) {",
  "        // hook method, to be overridden by sub-objects if desired",
  "    }",
  "",
  "    method prettyPrefix(depth) {",
  "        def spc = \"  \" * (depth+1)",
  "        if ((scope.node == self) && {util.target == \"symbols\"}) then {",
  "            \"{range} {description}\\n{spc}Symbols({scope.variety}): {scope}{scope.elementScopesAsString}\"",
  "        } elseif {scope.variety == \"fake\"} then {",
  "            \"{range} {description}\"",
  "        } else {",
  "            \"{range} {description} {scope.asDebugString}\"",
  "        }",
  "    }",
  "    method basePretty(depth) { prettyPrefix(depth) }",
  "    method pretty(depth) { basePretty(depth) }",
  "    method deepCopy {",
  "        self.map { each -> each } ancestors(ancestorChain.empty)",
  "    }",
  "    method enclosingObject {",
  "        def obj = scope.enclosingObjectScope.node",
  "        obj",
  "    }",
  "    method addComment(cmtNode) {",
  "        if (false == comments) then {",
  "            comments := cmtNode",
  "        } else {",
  "            comments.extendCommentUsing(cmtNode)",
  "        }",
  "    }",
  "    method addComments(cmtNodeList) {",
  "        cmtNodeList.do { each -> addComment(each) }",
  "    }",
  "    method statementName { kind }",
  "}",
  "",
  "def implicit is public = object {",
  "    inherit baseNode",
  "    line := 0",
  "    linePos := 0",
  "    def kind is public = \"implicit\"",
  "    def nameString is public = \"implicit\"",
  "    method range { emptyRange }",
  "    method isImplicit { true }",
  "    method toGrace(depth) { \"implicit\" }",
  "    method asString { \"the implicit receiver\" }",
  "    method == (other) { self.isMe(other) }",
  "    method map(blk) ancestors(as) { self }",
  "    method accept(visitor) from (as) {",
  "        visitor.visitImplicit(self) up (as)",
  "    }",
  "    method pretty(depth) { \"implicit\" }",
  "}",
  "",
  "def nullNode is public = object {",
  "    inherit baseNode",
  "    def kind is public = \"null\"",
  "    method toGrace(depth) {",
  "        \"// null\"",
  "    }",
  "    method range { emptyRange }",
  "    method asString { \"the nullNode\" }",
  "    method == (other) { self.isMe(other) }",
  "}",
  "",
  "def fakeSymbolTable is public = object {",
  "    var node is public := nullNode",
  "    method asString { \"the fakeSymbolTable\" }",
  "    method addNode (n) as (kind) {",
  "        ProgrammingError.raise \"fakeSymbolTable(on node {node}).addNode({n}) as \\\"{kind}\\\" requested\"",
  "    }",
  "    method thatDefines (name) ifNone (action) {",
  "        ProgrammingError.raise \"fakeSymbolTable.thatDefines({name}).\"",
  "    }",
  "    method enclosingObjectScope {",
  "        ProgrammingError.raise \"fakeSymbolTable.enclosingObjectScope on node {node}\"",
  "    }",
  "    method variety { \"fake\" }",
  "    method ==(other) { self.isMe(other) }",
  "}",
  "",
  "def ifNode is public = object {",
  "  class new(cond, thenblock', elseblock') {",
  "    inherit baseNode",
  "    def kind is public = \"if\"",
  "    var value is public := cond",
  "    var thenblock is public := thenblock'",
  "    var elseblock is public := elseblock'",
  "    var handledIdentifiers is public := false",
  "    method isSimple { false }  // needs parens when used as reciever",
  "    method accept(visitor : AstVisitor) from(as) {",
  "        if (visitor.visitIf(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            value.accept(visitor) from(newChain)",
  "            thenblock.accept(visitor) from(newChain)",
  "            elseblock.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method end -> Position { elseblock.end }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.thenblock := thenblock.map(blk) ancestors(newChain)",
  "        n.elseblock := elseblock.map(blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        def spc = \"  \" * (depth+1)",
  "        var s := basePretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth+1)",
  "        s := s ++ \"\\n\"",
  "        if (util.target == \"symbols\") then {",
  "            s := s ++ spc ++ \"Then: {thenblock.pretty(depth+2)}\\n\"",
  "            s := s ++ spc ++ \"Else: {elseblock.pretty(depth+2)}\"",
  "        } else {",
  "            s := s ++ spc ++ \"Then:\"",
  "            for (self.thenblock.body) do { ix ->",
  "                s := s ++ \"\\n  \"++ spc ++ ix.pretty(depth+2)",
  "            }",
  "            s := s ++ \"\\n\"",
  "            s := s ++ spc ++ \"Else:\"",
  "            for (self.elseblock.body) do { ix ->",
  "                s := s ++ \"\\n  \"++ spc ++ ix.pretty(depth+2)",
  "            }",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        def spc = \"    \" * depth",
  "        var s := \"if ({self.value.toGrace(0)}) then \\{\"",
  "        for (self.thenblock.body) do { ix ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ ix.toGrace(depth + 1)",
  "        }",
  "        if (self.elseblock.isntEmpty) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"\\} else \\{\"",
  "            for (self.elseblock.body) do { ix ->",
  "                s := s ++ \"\\n\" ++ spc ++ \"    \" ++ ix.toGrace(depth + 1)",
  "            }",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        ifNode.new(nullNode, nullNode, nullNode).shallowCopyFieldsFrom(self)",
  "    }",
  "    method postCopy(other) {",
  "        handledIdentifiers := other.handledIdentifiers",
  "        self",
  "    }",
  "  }",
  "}",
  "def blockNode is public = object {",
  "  class new(params', body') {",
  "    inherit baseNode",
  "    def kind is public = \"block\"",
  "    def value is public = \"block\"",
  "    var params is public := params'",
  "    var body is public := body'",
  "    def selfclosure is public = true",
  "    var matchingPattern is public := false",
  "    var extraRuntimeData is public := false",
  "    for (params') do {p->",
  "        p.accept(patternMarkVisitor) from(ancestorChain.with(self))",
  "    }",
  "    method isBlock { true }",
  "    method isDelimited { true }",
  "    method isEmpty { body.size == 0 }",
  "    method isntEmpty { body.size > 0 }",
  "    method scope:=(st) {",
  "        // sets up the 2-way conection between this node",
  "        // and the synmol table that defines the scope that I open.",
  "        symbolTable := st",
  "        st.node := self",
  "    }",
  "    method declarationKindWithAncestors(as) { k.parameter }",
  "    method isMatchingBlock { params.size == 1 }",
  "    method returnsObject {",
  "        (body.size > 0) && { body.last.returnsObject }",
  "    }",
  "    method returnedObjectScope {",
  "        // precondition: returnsObject",
  "        body.last.returnedObjectScope",
  "    }",
  "    method parametersDo(b) {",
  "        params.do(b)",
  "    }",
  "    method end -> Position {",
  "        if (body.size > 0) then { return body.last.end }",
  "        if (params.isEmpty) then {",
  "            positionOfNext \"}\" after (start)",
  "        } else {",
  "            positionOfNext \"}\" after (params.last.end)",
  "        }",
  "    }",
  "    method accept(visitor : AstVisitor) from(as) {",
  "        if (visitor.visitBlock(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            for (self.params) do { mx ->",
  "                mx.accept(visitor) from(newChain)",
  "            }",
  "            for (self.body) do { mx ->",
  "                mx.accept(visitor) from(newChain)",
  "            }",
  "            if (false != self.matchingPattern) then {",
  "                self.matchingPattern.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.params := listMap(params, blk) ancestors(newChain)",
  "        n.body := listMap(body, blk) ancestors(newChain)",
  "        n.matchingPattern := maybeMap(matchingPattern, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        def spc = \"  \" * (depth+1)",
  "        var s := basePretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ \"Parameters:\"",
  "        for (self.params) do { mx ->",
  "            s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+1)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ \"Body:\"",
  "        for (self.body) do { mx ->",
  "            s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+1)",
  "        }",
  "        if (false != self.matchingPattern) then {",
  "            s := s ++ \"\\n\"",
  "            s := s ++ spc ++ \"Pattern:\"",
  "            s := s ++ \"\\n  \"++ spc ++ self.matchingPattern.pretty(depth+1)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        def spc = \"    \" * depth",
  "        var s := \"\\{\"",
  "        if (self.params.size > 0) then {",
  "            s := s ++ \" \"",
  "            for (self.params.indices) do { i ->",
  "                var p := self.params.at(i)",
  "                if (false != self.matchingPattern) then {",
  "                    s := s ++ \"(\" ++ p.toGrace(0) ++ \")\"",
  "                } else {",
  "                    s := s ++ p.toGrace(0)",
  "                }",
  "                if (i < self.params.size) then {",
  "                    s := s ++ \", \"",
  "                } else {",
  "                    s := s ++ \" →\"",
  "                }",
  "            }",
  "        }",
  "        for (self.body) do { mx ->",
  "            s := s ++ \"\\n\" ++ spc ++ mx.toGrace(depth + 1)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        repeat (depth - 1) times { s := s ++ \"    \" }",
  "        s ++ \"\\}\"",
  "    }",
  "    method shallowCopy {",
  "        blockNode.new(params, body).shallowCopyFieldsFrom(self)",
  "    }",
  "    method postCopy(other) {",
  "        matchingPattern := other.matchingPattern",
  "        extraRuntimeData := other.extraRuntimeData",
  "        self",
  "    }",
  "  }",
  "}",
  "def tryCatchNode is public = object {",
  "  class new(block, cases', finally') {",
  "    inherit baseNode",
  "    def kind is public = \"trycatch\"",
  "    var value is public := block",
  "    var cases is public := cases'",
  "    var finally is public := finally'",
  "    method isSimple { false }  // needs parens when used as reciever",
  "    method end -> Position {",
  "        if (false ≠ finally) then { return finally.end }",
  "        if (cases.isEmpty.not) then { return cases.last.end }",
  "        return value.end",
  "    }",
  "    method accept(visitor : AstVisitor) from(as) {",
  "        if (visitor.visitTryCatch(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "            for (self.cases) do { mx ->",
  "                mx.accept(visitor) from(newChain)",
  "            }",
  "            if (false != self.finally) then {",
  "                self.finally.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.cases := listMap(cases, blk) ancestors(newChain)",
  "        n.finally := maybeMap(finally, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        def spc = \"  \" * (depth+1)",
  "        var s := \"{basePretty(depth)}\\n\"",
  "        s := s ++ spc ++ value.pretty(depth + 2)",
  "        for (self.cases) do { mx ->",
  "            s := s ++ \"\\n{spc}Case:\\n{spc}  {mx.pretty(depth+2)}\"",
  "        }",
  "        if (false != self.finally) then {",
  "            s := s ++ \"\\n{spc}Finally:\\n{spc}  {self.finally.pretty(depth+2)}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        def spc = \"    \" * depth",
  "        var s := \"try \" ++ self.value.toGrace(depth + 1) ++ \" \"",
  "        for (self.cases) do { case ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"catch \" ++ case.toGrace(depth + 1)",
  "        }",
  "        if (false != self.finally) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"finally \" ++ self.finally.toGrace(depth + 1)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        tryCatchNode.new(nullNode, emptySeq, false).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def matchCaseNode is public = object {",
  "  class new(matchee', cases') {",
  "    inherit baseNode",
  "    def kind is public = \"matchcase\"",
  "    var value is public := matchee'",
  "    var cases is public := cases'",
  "    method isSimple { false }  // needs parens when used as reciever",
  "    method end -> Position {",
  "        if (cases.isEmpty.not) then { return cases.last.end }",
  "        return value.end",
  "    }",
  "    method matchee { value }",
  "    method accept(visitor : AstVisitor) from(as) {",
  "        if (visitor.visitMatchCase(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "            for (self.cases) do { mx ->",
  "                mx.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.cases := listMap(cases, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        def spc = \"  \" * (depth+1)",
  "        var s := basePretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ matchee.pretty(depth + 2)",
  "        for (self.cases) do { mx ->",
  "            s := s ++ \"\\n{spc}Case:\\n{spc}  {mx.pretty(depth+2)}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        def spc = \"    \" * depth",
  "        var s := \"match(\" ++ self.value.toGrace(0) ++ \")\"",
  "        for (self.cases) do { case ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"case \" ++ case.toGrace(depth + 2)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        matchCaseNode.new(nullNode, emptySeq).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def methodTypeNode is public = object {",
  "  class new(signature', rtype') {",
  "    // Represents the signature of a method in a type literal.",
  "    // signature' is a collection of signaturePart objects, which",
  "    // contain the parts of this method's name and the parameter lists;",
  "    // rtype' is the return type of this method, or false if not specified.",
  "",
  "    inherit baseNode",
  "    def kind is public = \"methodtype\"",
  "    var signature is public := signature'",
  "    var rtype is public := rtype'",
  "    var typeParams is public := false",
  "    var cachedIdentifier := uninitialized",
  "",
  "    method end -> Position {",
  "        if (false ≠ rtype) then { return rtype.end }",
  "        signature.last.end",
  "    }",
  "",
  "    method nameString {",
  "        // the name of the method being defined, in numeric form",
  "        signature.fold { acc, each -> acc ++ each.nameString }",
  "            startingWith \"\"",
  "    }",
  "",
  "    method canonicalName {",
  "        // the name of the method being defined, in underscore form",
  "        signature.fold { acc, each -> acc ++ each.canonicalName }",
  "            startingWith \"\"",
  "    }",
  "",
  "    method value {",
  "        if (uninitialized == cachedIdentifier) then {",
  "            cachedIdentifier := identifierNode.new(nameString, false)",
  "            cachedIdentifier.line := signature.first.line",
  "            cachedIdentifier.linePos := signature.first.linePos",
  "            cachedIdentifier.end := signature.last.end",
  "            cachedIdentifier.isBindingOccurrence := true",
  "        }",
  "        cachedIdentifier",
  "    }",
  "    method isExecutable { false }",
  "    method parametersDo(b) {",
  "        signature.do { part ->",
  "            part.params.do { each -> b.apply(each) }",
  "        }",
  "    }",
  "    method scope:=(st) {",
  "        // sets up the 2-way conection between this node",
  "        // and the symbol table that defines the scope that I open.",
  "        symbolTable := st",
  "        st.node := self",
  "    }",
  "    method declarationKindWithAncestors(as) { k.typedec }",
  "    method accept(visitor : AstVisitor) from(as) {",
  "        if (visitor.visitMethodType(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            if (false != typeParams) then {",
  "                typeParams.accept(visitor) from(newChain)",
  "            }",
  "            if (false != rtype) then {",
  "                rtype.accept(visitor) from(newChain)",
  "            }",
  "            for (signature) do { part ->",
  "                part.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.rtype := maybeMap(rtype, blk) ancestors(newChain)",
  "        n.signature := listMap(signature, blk) ancestors(newChain)",
  "        n.typeParams := maybeMap(typeParams, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        def spc = \"  \" * (depth+1)",
  "        var s := basePretty(depth) ++ \"\\n\"",
  "        s := \"{s}{spc}Name: {value}\\n\"",
  "        if (false != rtype) then {",
  "            s := \"{s}{spc}Returns:\\n  {spc}{rtype.pretty(depth + 2)}\"",
  "        }",
  "        if (false != typeParams) then {",
  "            s := \"{s}\\n{spc}TypeParams:\\n\"",
  "            s := s ++ typeParams.pretty(depth + 2)",
  "        }",
  "        s := \"{s}\\n{spc}Signature:\"",
  "        for (signature) do { part ->",
  "            s := \"{s}\\n  {spc}{part.pretty(depth + 2)}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"\"",
  "        signature.do { part -> s:= s ++ part.toGrace(depth + 1) }",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        methodTypeNode.new(signature, rtype).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def typeLiteralNode is public = object {",
  "  class new(methods', types') {",
  "    inherit baseNode",
  "    def kind is public = \"typeliteral\"",
  "    var methods is public := methods'",
  "    var types is public := types'",
  "    var nominal is public := false",
  "    var anonymous is public := true",
  "    var value is public := \"‹anon›\"",
  "",
  "    method name { value }",
  "    method name:=(n) {",
  "        value := n",
  "        anonymous := false",
  "    }",
  "    method asString {",
  "        \"typeliteral: methods = {methods}, types = {types}\"",
  "    }",
  "    method declarationKindWithAncestors(as) { k.typedec }",
  "    method isExecutable { false }",
  "",
  "    method end -> Position {",
  "        def tEnd = if (types.isEmpty) then {noPosition} else {types.last.end}",
  "        def mEnd = if (methods.isEmpty) then {noPosition} else {methods.last.end}",
  "        positionOfNext \"}\" after (max(tEnd, mEnd))",
  "    }",
  "",
  "    method accept(visitor : AstVisitor) from(as) {",
  "        if (visitor.visitTypeLiteral(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            for (self.methods) do { each ->",
  "                each.accept(visitor) from(newChain)",
  "            }",
  "            for (self.types) do { each ->",
  "                each.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.methods := listMap(methods, blk) ancestors (as)",
  "        n.types := listMap(types, blk) ancestors (as)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        def spc = \"  \" * (depth+1)",
  "        var s := basePretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ \"Types:\"",
  "        for (types) do { each ->",
  "            s := s ++ \"\\n  \"++ spc ++ each.pretty(depth+2)",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"Methods:\"",
  "        for (methods) do { each ->",
  "            s := s ++ \"\\n  \"++ spc ++ each.pretty(depth+2)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        def spc = \"    \" * depth",
  "        var s := \"type\"",
  "        s := s ++ \" = \\{\"",
  "        for (self.methods) do { each ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ each.toGrace(depth + 1)",
  "        }",
  "        for (self.types) do { each ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ each.toGrace(depth + 1)",
  "        }",
  "        s ++ \"\\}\"",
  "    }",
  "    method shallowCopy {",
  "        typeLiteralNode.new(emptySeq, emptySeq).shallowCopyFieldsFrom(self)",
  "    }",
  "    method postCopy(other) {",
  "        nominal := other.nominal",
  "        anonymous := other.anonymous",
  "        value := other.value",
  "        self",
  "    }",
  "  }",
  "}",
  "",
  "def typeDecNode is public = object {",
  "  class new(name', typeValue) {",
  "    inherit baseNode",
  "    def kind is public = \"typedec\"",
  "    var name is public := name'",
  "    var value is public := typeValue",
  "    var parentKind is public := \"unset\"",
  "    def nameString is public = name.value",
  "    var annotations is public := [ ]",
  "    var typeParams is public := false",
  "",
  "    method end -> Position { value.end }",
  "    method isLegalInTrait { true }",
  "    method isTypeDec { true }",
  "    method scope:=(st) {",
  "        // sets up the 2-way conection between this node",
  "        // and the synmol table that defines the scope that I open.",
  "        symbolTable := st",
  "        st.node := self",
  "    }",
  "",
  "    method isExecutable { true }",
  "    method declarationKindWithAncestors(as) { k.typeparam }",
  "    method isConfidential {",
  "        if (annotations.size == 0) then { return false }",
  "        findAnnotation(self, \"confidential\")",
  "    }",
  "    method isPublic { isConfidential.not }",
  "    method isWritable { false }",
  "    method isReadable { isPublic }",
  "",
  "    method accept(visitor : AstVisitor) from(as) {",
  "        if (visitor.visitTypeDec(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            name.accept(visitor) from(newChain)",
  "            if (false != typeParams) then {",
  "                typeParams.accept(visitor) from(newChain)",
  "            }",
  "            annotations.do { each -> each.accept(visitor) from(newChain) }",
  "            value.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.name := name.map(blk) ancestors(newChain)",
  "        n.typeParams := maybeMap(typeParams, blk) ancestors(newChain)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        def spc = \"  \" * (depth+1)",
  "        var s := basePretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.name.pretty(depth + 1) ++ \"\\n\"",
  "        if (false != typeParams) then {",
  "            s := \"{s}{spc}Type parameters:\\n{typeParams.pretty(depth + 2)}\\n\"",
  "        }",
  "        s := s ++ spc ++ \"Value:\"",
  "        s := s ++ value.pretty(depth+2)",
  "        s := s ++ \"\\n\"",
  "        if (false != comments) then {",
  "            s := s ++ comments.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        def spc = \"    \" * depth",
  "        var s := \"\"",
  "        s := \"type {self.name}\"",
  "        if (false != typeParams) then {",
  "            typeParams.toGrace(0)",
  "        }",
  "        s ++ \" = \" ++ value.toGrace(depth + 2)",
  "    }",
  "    method shallowCopy {",
  "        typeDecNode.new(name, nullNode).shallowCopyFieldsFrom(self)",
  "    }",
  "    method postCopy(other) {",
  "        parentKind := other.parentKind",
  "        self",
  "    }",
  "  }",
  "}",
  "",
  "def methodNode is public = object {",
  "    method new(signature, body, dtype) scope(s) {",
  "        def result = new(signature, body, dtype)",
  "        result.scope := s",
  "        result",
  "    }",
  "",
  "    class new(signature', body', dtype') {",
  "        // Represents a method declaration",
  "        // The name of the method is constructed from signature',",
  "        // which is a sequence of signatureParts;",
  "        // body is a sequence of statements and declarations.",
  "        // dtype is the declared return type of the method, or false.",
  "",
  "        inherit baseNode",
  "        def kind is public = \"method\"",
  "        var signature is public := signature'",
  "        var body is public := body'",
  "        var dtype is public := dtype'",
  "        var typeParams is public := false",
  "        var selfclosure is public := false",
  "        var annotations is public := [ ]",
  "        var isFresh is public := false      // a method is 'fresh' if it answers a new object",
  "        var usesClassSyntax is public := false",
  "        var cachedIdentifier := uninitialized",
  "        var isBindingOccurence is readable := true",
  "            // the only exception is the oldMethodName in an alias clause",
  "",
  "        method end -> Position {",
  "            if (body.isEmpty.not) then {",
  "                if (usesClassSyntax) then { return body.last.end }",
  "                return positionOfNext \"}\" after (body.last.end)",
  "            }",
  "            if (false ≠ dtype) then {",
  "                return positionOfNext \"}\" after (dtype.end)",
  "            }",
  "            return positionOfNext \"}\" after (signature.last.end)",
  "        }",
  "        method ilkName {",
  "            // a string describing the ilk of the objects returned by this method",
  "            if (isFresh && {body.last.isObject}) then {",
  "                body.last.name",
  "            } else {",
  "                canonicalName",
  "            }",
  "        }",
  "        method appliedOccurence {",
  "            isBindingOccurence := false",
  "            if (uninitialized ≠ cachedIdentifier) then {",
  "                cachedIdentifier.isBindingOccurence := false",
  "            }",
  "            self",
  "        }",
  "        method numParams {",
  "            signature.fold { acc, p -> acc + p.numParams } startingWith 0",
  "        }",
  "        method parametersDo(b) {",
  "            signature.do { part ->",
  "                part.params.do { each -> b.apply(each) }",
  "            }",
  "        }",
  "        method endPos {",
  "            def lastPart = signature.last",
  "            lastPart.linePos + lastPart.name.size - 1",
  "        }",
  "",
  "        method nameString {",
  "            signature.fold { acc, each -> acc ++ each.nameString }",
  "                startingWith \"\"",
  "        }",
  "        method asIdentifier {",
  "            if (uninitialized == cachedIdentifier) then {",
  "                cachedIdentifier := identifierNode.new(nameString, false)",
  "                cachedIdentifier.line := signature.first.line",
  "                cachedIdentifier.linePos := signature.first.linePos",
  "                cachedIdentifier.isBindingOccurrence := isBindingOccurence",
  "                cachedIdentifier.end := signature.last.end",
  "                cachedIdentifier.canonicalName := canonicalName",
  "            }",
  "            cachedIdentifier",
  "        }",
  "        method value { asIdentifier }",
  "        method canonicalName {",
  "            signature.fold { acc, each -> acc ++ each.canonicalName }",
  "                startingWith \"\"",
  "        }",
  "        method hasParams { signature.first.params.isEmpty.not }",
  "        method numParamLists {",
  "            // the number of my parameter lists.  If I have a single",
  "            // part to my name, there may be 0 or 1",
  "            def sigSz = signature.size",
  "            if (sigSz > 1) then { return sigSz }",
  "            if {signature.first.params.isEmpty} then { return 0 }",
  "            return 1",
  "        }",
  "        method hasTypeParams { false ≠ signature.first.typeParams }",
  "        method isMethod { true }",
  "        method isExecutable { false }",
  "        method isLegalInTrait { true }",
  "        method isClass { isFresh || usesClassSyntax }",
  "        method isTrait {",
  "            if (isFresh) then {",
  "                body.last.isTrait",
  "            } else {",
  "                false",
  "            }",
  "        }",
  "        method needsArgChecks {",
  "            signature.do { part ->",
  "                part.params.do { p ->",
  "                    if ((false != p.dtype) && {",
  "                            p.dtype.nameString != \"Unknown\" }) then {",
  "                        return true",
  "                    }",
  "                }",
  "            }",
  "            return false",
  "        }",
  "        method scope:=(st) {",
  "            // sets up the 2-way conection between this node",
  "            // and the synmol table that defines the scope that I open.",
  "            symbolTable := st",
  "            st.node := self",
  "        }",
  "        method declarationKindWithAncestors(as) { k.parameter }",
  "        method isConfidential {",
  "            if (annotations.size == 0) then { return false }",
  "            findAnnotation(self, \"confidential\")",
  "        }",
  "        method isPublic { isConfidential.not }",
  "        method isWritable { false }",
  "        method isReadable { isPublic }",
  "        method usesAsType(aNode) {",
  "            aNode == dtype",
  "        }",
  "        method returnsObject {",
  "            body.isEmpty.not && {body.last.returnsObject}",
  "        }",
  "        method returnedObjectScope {",
  "            // precondition: returnsObject",
  "            body.last.returnedObjectScope",
  "        }",
  "        method resultExpression {   // precondition: body is not empty",
  "            if (body.isEmpty) then { ProgrammingError.raise \"method has no body\" }",
  "            var last := body.last",
  "            if (last.isReturn) then { last := last.value }",
  "            last",
  "        }",
  "        method accept(visitor : AstVisitor) from(as) {",
  "            if (visitor.visitMethod(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                self.value.accept(visitor) from(newChain)",
  "                if (false != typeParams) then {",
  "                    typeParams.accept(visitor) from(newChain)",
  "                }",
  "                for (self.signature) do { part ->",
  "                    for (part.params) do { p ->",
  "                        p.accept(visitor) from(newChain)",
  "                    }",
  "                }",
  "                if (false != dtype) then {",
  "                    dtype.accept(visitor) from(newChain)",
  "                }",
  "                for (self.annotations) do { ann ->",
  "                    ann.accept(visitor) from(newChain)",
  "                }",
  "                for (self.body) do { mx ->",
  "                    mx.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "        }",
  "        method map(blk) ancestors(as){",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.body := listMap(body, blk) ancestors(newChain)",
  "            n.typeParams := maybeMap(typeParams, blk) ancestors(newChain)",
  "            n.signature := listMap(signature, blk) ancestors(newChain)",
  "            n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "            n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            def spc = \"  \" * (depth+1)",
  "            var s := basePretty(depth) ++ \"\\n\"",
  "            s := s ++ spc ++ \"Name: \" ++ value.pretty(depth+1) ++ \"\\n\"",
  "            if (false != self.dtype) then {",
  "                s := s ++ spc ++ \"Returns:\\n\" ++ spc ++ \"  \"",
  "                s := s ++ self.dtype.pretty(depth + 2) ++ \"\\n\"",
  "            }",
  "            if (isBindingOccurence.not) then { s := s ++ spc ++ \"Applied\\n\" }",
  "            if (isFresh) then { s := s ++ spc ++ \"Fresh\\n\" }",
  "            s := \"{s}{spc}Signature:\"",
  "            for (signature) do { part ->",
  "                s := \"{s}\\n  {spc}Part: {part.name}\"",
  "                s := \"{s}\\n    {spc}Parameters:\"",
  "                for (part.params) do { p ->",
  "                    s := \"{s}\\n      {spc}{p.pretty(depth + 4)}\"",
  "                }",
  "            }",
  "            s := s ++ \"\\n\"",
  "            if (false != typeParams) then {",
  "                s := \"{s}{spc}Generics:\"",
  "                typeParams.do {g->",
  "                    s := \"{s}\\n{spc}  {g.pretty(0)}\"",
  "                }",
  "                s := s ++ \"\\n\"",
  "            }",
  "            if (annotations.size > 0) then {",
  "                s := \"{s}{spc}Annotations:\"",
  "                for (annotations) do {an->",
  "                    s := \"{s}\\n{spc}  {an.pretty(depth + 2)}\"",
  "                }",
  "                s := s ++ \"\\n\"",
  "            }",
  "            s := s ++ spc ++ \"Body:\"",
  "            for (self.body) do { mx ->",
  "                s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+2)",
  "            }",
  "            if (false != comments) then {",
  "                s := s ++ comments.pretty(depth+2)",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            def spc = \"    \" * depth",
  "            var s := \"method \"",
  "            var firstPart := true",
  "            for (self.signature) do { part ->",
  "                s := s ++ part.name",
  "                if (firstPart && {false != typeParams}) then {",
  "                    s := s ++ typeParams.toGrace(depth + 1)",
  "                }",
  "                firstPart := false",
  "                if (part.params.size > 0) then {",
  "                    s := s ++ \"(\"",
  "                    for (part.params.indices) do { pnr ->",
  "                        var p := part.params.at(pnr)",
  "                        s := s ++ p.toGrace(depth + 1)",
  "                        if (pnr < part.params.size) then {",
  "                            s := s ++ \", \"",
  "                        }",
  "                    }",
  "                    s := s ++ \")\"",
  "                }",
  "            }",
  "            if (false != self.dtype) then {",
  "                s := s ++ \" -> {self.dtype.toGrace(0)}\"",
  "            }",
  "            if (self.annotations.size > 0) then {",
  "                s := s ++ \" is \"",
  "                s := s ++ self.annotations.fold{ a,b ->",
  "                    if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) }",
  "                        startingWith \"\"",
  "            }",
  "            s := s ++ \" \\{\"",
  "            if (false != comments) then {",
  "                s := s ++ comments.toGrace(depth + 1)",
  "            }",
  "            for (self.body) do { mx ->",
  "                s := s ++ \"\\n\" ++ spc ++ \"    \" ++ mx.toGrace(depth + 1)",
  "            }",
  "            s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            methodNode.new(signature, body, dtype).shallowCopyFieldsFrom(self)",
  "        }",
  "        method postCopy(other) {",
  "            isFresh := other.isFresh",
  "            selfclosure := other.selfclosure",
  "            if (other.isBindingOccurence.not) then {",
  "                self.appliedOccurence",
  "            }",
  "            self",
  "        }",
  "    }",
  "}",
  "def callNode is public = object {",
  "    method new(receiver, parts) scope(s) {",
  "        def result = new(receiver, parts)",
  "        result.scope := s",
  "        result",
  "    }",
  "    class new(receiver', parts') {",
  "        // requested as callNode.new(receiver':AstNode, parts:List)",
  "        // Represents a method request with arguments.",
  "        // The argument list is in `parts`, as a sequence of `requestPart`s.",
  "",
  "        inherit baseNode",
  "        def kind is public = \"call\"",
  "        var parts is public := parts'            // [ requestPart ]",
  "        var generics is public := false",
  "        var isPattern is public := false",
  "        var receiver is public := receiver'    // formerly `value`",
  "        var isSelfRequest is public := false",
  "        var isTailCall is public := false      // is possibly the result of a method",
  "        var isFresh is public := false         // calls a fresh method",
  "        var cachedIdentifier := uninitialized",
  "        var endPos is public := noPosition",
  "",
  "        method end -> Position {",
  "            if (endPos == noPosition) then {",
  "                if (isRequestOfPrefixOperator) then {",
  "                    util.log 60 verbose \"guessing at end of {pretty 1} with {receiver.end}\"",
  "                    receiver.end",
  "                } else {",
  "                    util.log 60 verbose \"guessing at end of {pretty 1} with {parts.last.end}\"",
  "                    parts.last.end",
  "                }",
  "            } else {",
  "                endPos",
  "            }",
  "        }",
  "        method end:=(newPos) { endPos := newPos }",
  "        method isRequestOfPrefixOperator { parts.first.name.startsWith \"prefix\" }",
  "        method onSelf {",
  "            // mark as a self-request.  Answers self for chaining.",
  "            isSelfRequest := true",
  "            self",
  "        }",
  "",
  "        method nameString {",
  "            // the name of the method being requested, in numeric form",
  "            parts.fold { acc, each -> acc ++ each.nameString } startingWith \"\"",
  "        }",
  "",
  "        method canonicalName {",
  "            // the name of the method being requested, in underscore form",
  "            parts.fold { acc, each -> acc ++ each.canonicalName }",
  "                startingWith \"\"",
  "        }",
  "",
  "        method isCall { true }",
  "        method returnsObject {",
  "            // we recognize two special calls as returning a fresh object",
  "            // self.copy, and prelude.clone(_)",
  "            if (isCopy) then { return true }",
  "            if (isClone) then { return true }",
  "            isFresh",
  "        }",
  "        method isCopy {",
  "            ((receiver.isImplicit || receiver.isSelf) &&",
  "                (nameString == \"copy\"))",
  "        }",
  "        method isClone {",
  "            ((receiver.isImplicit || receiver.isPrelude) &&",
  "                  (nameString == \"clone(1)\"))",
  "        }",
  "        method returnedObjectScope {",
  "            // precondition: returnsObject",
  "            self.scope",
  "        }",
  "        method arguments {",
  "            def result = [ ]",
  "            for (parts) do { part ->",
  "                for (part.args) do { arg -> result.push(arg) }",
  "            }",
  "            result",
  "        }",
  "",
  "        method argumentsDo(action) {",
  "            for (parts) do { part ->",
  "                for (part.args) do { arg -> action.apply(arg) }",
  "            }",
  "        }",
  "",
  "        method numArgs {",
  "            parts.fold { acc, part -> acc + part.args.size } startingWith 0",
  "        }",
  "",
  "        method numTypeArgs {",
  "            if (false == generics) then { 0 } else { generics.size }",
  "        }",
  "",
  "        method accept(visitor : AstVisitor) from(as) {",
  "            if (visitor.visitCall(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                self.receiver.accept(visitor) from(newChain)",
  "                for (self.parts) do { part ->",
  "                    for (part.args) do { arg ->",
  "                        arg.accept(visitor) from(newChain)",
  "                    }",
  "                }",
  "                if (false != generics) then {",
  "                    generics.do { each ->",
  "                        each.accept(visitor) from(newChain)",
  "                    }",
  "                }",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.receiver := receiver.map(blk) ancestors(newChain)",
  "            n.parts := listMap(parts, blk) ancestors(newChain)",
  "            n.generics := maybeListMap(generics, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            def spc = \"  \" * (depth+1)",
  "            var s := basePretty(depth)",
  "            s := s ++ if (isSelfRequest) then { \" on self\\n\" } else { \"\\n\" }",
  "            s := s ++ spc ++ \"Receiver: {receiver.pretty(depth + 1)}\\n\"",
  "            s := s ++ spc ++ \"Method Name: {nameString}\\n\"",
  "            if (false != generics) then {",
  "                s := s ++ spc ++ \"  Generics:\\n\"",
  "                for (generics) do {g->",
  "                    s := s ++ spc ++ \"    \" ++ g.pretty(depth + 2) ++ \"\\n\"",
  "                }",
  "            }",
  "            s := s ++ spc ++ \"Parts:\"",
  "            for (self.parts) do { part ->",
  "                s := s ++ \"\\n  \" ++ spc ++ part.pretty(depth + 2)",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            if (isRequestOfPrefixOperator) then {",
  "                def opSymbol = parts.first.name.substringFrom 7",
  "                return \"{opSymbol} {self.receiver.toGrace 0}\"",
  "            }",
  "            var s := \"\"",
  "            if (receiver.isImplicit.not) then {",
  "                if (receiver.isSimple) then {",
  "                    s := \"{receiver.toGrace (depth + 1)}.\"",
  "                } else {",
  "                    s := \"({receiver.toGrace (depth + 1)}).\"",
  "                }",
  "            }",
  "            parts.do { part -> s := s ++ part.toGrace(depth + 1) }",
  "                separatedBy { s := s ++ \" \" }",
  "            s",
  "        }",
  "        method asIdentifier {",
  "            // make and return an identifiderNode for my request",
  "",
  "            if (uninitialized == cachedIdentifier) then {",
  "                if (fakeSymbolTable == scope) then {",
  "                    ProgrammingError.raise",
  "                        \"asIdentifier requested on {pretty 0} when scope was fake\"",
  "                }",
  "                cachedIdentifier := identifierNode.new(nameString, false) scope (scope)",
  "                cachedIdentifier.inRequest := true",
  "                cachedIdentifier.line := parts.first.line",
  "                cachedIdentifier.linePos := parts.first.linePos",
  "            }",
  "            cachedIdentifier",
  "        }",
  "        method asString { \"call {toGrace 0}\" }",
  "        method shallowCopy {",
  "            callNode.new(receiver, parts).shallowCopyFieldsFrom(self)",
  "        }",
  "        method postCopy(other) {",
  "            isPattern := other.isPattern",
  "            isSelfRequest := other.isSelfRequest",
  "            isTailCall := other.isTailCall",
  "            isFresh := other.isFresh",
  "            endPos := other.endPos",
  "            self",
  "        }",
  "        method statementName { \"request\" }",
  "    }",
  "}",
  "def moduleNode is public = object {",
  "    method body(b) named(n) scope(s) {",
  "        def result = body(b)",
  "        result.name := n",
  "        result.scope := s",
  "        result",
  "    }",
  "    method body(b) named(n) {",
  "        def result = body(b)",
  "        result.name := n",
  "        result",
  "    }",
  "    class body(b) {",
  "        inherit objectNode.new(b, false)",
  "        def kind is public = \"module\"",
  "        def sourceLines = util.lines",
  "        var theDialect is public := dialectNode.new \"standardGrace\"",
  "        theDialect.setStart(noPosition)     // dialect is implicit",
  "        setStart(noPosition)                // so is the module",
  "        var imports is public := [ ]",
  "",
  "        method end -> Position {",
  "            line (util.lines.size) column (util.lines.last.size)",
  "        }",
  "        method isModule { true }",
  "        method isTrait { false }",
  "        method returnsObject { false }",
  "        method importsDo(action) {",
  "            value.do { o ->",
  "                if (o.isExternal) then { action.apply(o) }",
  "            }",
  "        }",
  "        method externalsDo(action) {",
  "            if (theDialect.value ≠ \"none\") then {",
  "                action.apply(theDialect)",
  "            }",
  "            value.do { o ->",
  "                if (o.isExternal) then { action.apply(o) }",
  "            }",
  "        }",
  "        method accept(visitor : AstVisitor) from(as) {",
  "            if (visitor.visitModule(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                theDialect.accept(visitor) from (newChain)",
  "                if (false != self.superclass) then {",
  "                    self.superclass.accept(visitor) from(newChain)",
  "                }",
  "                for (self.value) do { x ->",
  "                    x.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.theDialect := theDialect.map(blk) ancestors(newChain)",
  "            n.value := listMap(value, blk) ancestors(newChain)",
  "            n.superclass := maybeMap(superclass, blk) ancestors(newChain)",
  "            n.usedTraits := listMap(usedTraits, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method basePretty(depth) {",
  "            def spc = \"  \" * (depth+1)",
  "            prettyPrefix(depth) ++ \"\\n\" ++",
  "                \"{spc}{theDialect.toGrace 0}\"",
  "        }",
  "        method shallowCopy {",
  "            moduleNode.body(emptySeq).shallowCopyFieldsFrom(self)",
  "        }",
  "        method postCopy(other) {",
  "            imports := other.imports",
  "            theDialect := other.theDialect",
  "            // copy the field of moduleNode",
  "",
  "            name := other.name",
  "            value := other.value",
  "            superclass := other.superclass",
  "            usedTraits := other.usedTraits",
  "            inClass := other.inClass",
  "            inTrait := other.inTrait",
  "            annotations := other.annotations",
  "            // copy the fields of objectNode — should be an alias to objectNode.postCopy",
  "",
  "            self",
  "        }",
  "    }",
  "}",
  "def objectNode is public = object {",
  "    method body(b) named(n) scope(s) {",
  "        def result = new(b, false)",
  "        result.name := n",
  "        result.scope := s",
  "        result",
  "    }",
  "    method body(b) named(n) {",
  "        body(b) named(n) scope(fakeSymbolTable)",
  "    }",
  "    class new(b, superclass') {",
  "        inherit baseNode",
  "        def kind is public = \"object\"",
  "        var value is public := b",
  "        var superclass is public := superclass'",
  "        var usedTraits is public := [ ]",
  "        var name is public := \"object\"",
  "        var inClass is public := false",
  "        var inTrait is public := false",
  "        var myLocalNames := false",
  "        var annotations is public := [ ]",
  "",
  "        method end -> Position {",
  "            if (value.isEmpty.not) then {",
  "                return positionOfNext \"}\" after (value.last.end)",
  "            }",
  "            def iEnd = if (false == superclass) then { noPosition } else { superclass.end }",
  "            def tEnd = if (usedTraits.isEmpty) then { noPosition } else { usedTraits.end }",
  "            if (iEnd ≠ tEnd) then {",
  "                positionOfNext \"}\" after (max(iEnd, tEnd))",
  "            } else {",
  "                positionOfNext \"}\" after (start)",
  "            }",
  "        }",
  "        method description -> String {",
  "            if (isTrait) then {",
  "                \"{kind} (trait)\"",
  "            } elseif { inClass } then {",
  "                \"{kind} (class)\"",
  "            } else {",
  "                kind",
  "            }",
  "        }",
  "        method isFresh { true }     // the epitome of freshness!",
  "        method isTrait {",
  "            // answers true if this object qualifies to be a trait, whether",
  "            // or not it was declared with the trait syntax",
  "",
  "            if (inTrait) then { return true }",
  "            if (false != superclass) then { return false }",
  "            value.do { each ->",
  "                if (each.isLegalInTrait.not) then { return false }",
  "            }",
  "            return true",
  "        }",
  "",
  "        method localNames -> Set⟦String⟧ {",
  "            // answers the names of all of the methods defined directly in",
  "            // this object.  Inherited names are _not_ included.",
  "            if (false == myLocalNames) then {",
  "                myLocalNames := emptySet",
  "                value.do { node ->",
  "                    if (node.isFieldDec || node.isMethod) then {",
  "                        myLocalNames.add(node.nameString)",
  "                    }",
  "                }",
  "            }",
  "            myLocalNames",
  "        }",
  "",
  "        method parentsDo(action) {",
  "            // iterate over my superclass and my used traits",
  "",
  "            if (false != superclass) then { action.apply(superclass) }",
  "            usedTraits.do { t -> action.apply(t) }",
  "        }",
  "",
  "        method methodsDo(action) {",
  "            // iterate over my method declarations",
  "",
  "            value.do { o ->",
  "                if (o.isMethod) then { action.apply(o) }",
  "            }",
  "        }",
  "",
  "        method executableComponentsDo(action) {",
  "            // iterate over my executable code, including",
  "            // field declarations (since they may have initializers)",
  "            value.do { o ->",
  "                if (o.isExecutable) then { action.apply(o) }",
  "            }",
  "        }",
  "",
  "        method scope:=(st) {",
  "            // sets up the 2-way conection between this node",
  "            // and the symbol table that defines the scope that I open.",
  "            symbolTable := st",
  "            st.node := self",
  "        }",
  "        method body { value }",
  "        method returnsObject { true }",
  "        method returnedObjectScope { scope }",
  "        method canInherit { inTrait.not }   // an object can inherit if not in a trait",
  "        method canUse { true }",
  "        method isObject { true }",
  "        method accept(visitor : AstVisitor) from(as) {",
  "            if (visitor.visitObject(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                if (false != superclass) then {",
  "                    superclass.accept(visitor) from(newChain)",
  "                }",
  "                usedTraits.do { t -> t.accept(visitor) from(newChain) }",
  "                value.do { x -> x.accept(visitor) from(newChain) }",
  "            }",
  "        }",
  "        method nameString {",
  "            if (name == \"object\") then {",
  "                \"object_on_line_{line}\"",
  "            } else {",
  "                name",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.value := listMap(value, blk) ancestors(newChain)",
  "            n.superclass := maybeMap(superclass, blk) ancestors(newChain)",
  "            n.usedTraits := listMap(usedTraits, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth') {",
  "            var depth := depth'",
  "            def spc = \"  \" * (depth+1)",
  "            var s := basePretty(depth)",
  "            s := \"{s}\\n{spc}Name: {self.name}\"",
  "            if (false != self.superclass) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Superclass: \" ++",
  "                        self.superclass.pretty(depth + 1)",
  "            }",
  "            if (usedTraits.isEmpty.not) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Traits:\"",
  "                usedTraits.do { t ->",
  "                    s := \"{s}\\n{spc}  {t.pretty(depth + 1)}\"",
  "                }",
  "            }",
  "            value.do { x ->",
  "                s := s ++ \"\\n\"++ spc ++ x.pretty(depth + 1)",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            def spc = \"    \" * depth",
  "            var s := \"object \\{\"",
  "            if (inTrait) then { s := s ++ \"   // trait\" }",
  "            if (inClass) then { s := s ++ \"   // class\" }",
  "            if (false != superclass) then {",
  "                s := s ++ \"\\n\" ++ superclass.toGrace(depth + 1)",
  "            }",
  "            usedTraits.do { t -> s := s ++ \"\\n\" ++ t.toGrace(depth + 1) }",
  "            value.do { x ->",
  "                s := s ++ \"\\n\" ++ spc ++ \"    \" ++ x.toGrace(depth + 1)",
  "            }",
  "            s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            objectNode.new(emptySeq, false).shallowCopyFieldsFrom(self)",
  "        }",
  "        method postCopy(other) {",
  "            name := other.name",
  "            value := other.value",
  "            superclass := other.superclass",
  "            usedTraits := other.usedTraits",
  "            inClass := other.inClass",
  "            inTrait := other.inTrait",
  "            annotations := other.annotations",
  "            self",
  "        }",
  "        method asString {",
  "            kind ++ \" \" ++ nameString",
  "        }",
  "    }",
  "}",
  "def arrayNode is public = object {",
  "  class new(values) {",
  "    inherit baseNode",
  "    def kind is public = \"array\"",
  "    var value is public := values",
  "    method end -> Position {",
  "        if (value.isEmpty) then {",
  "            positionOfNext \"]\" after (start)",
  "        } else {",
  "            positionOfNext \"]\" after (value.last.end)",
  "        }",
  "    }",
  "    method accept(visitor : AstVisitor) from(as) {",
  "        if (visitor.visitArray(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            for (self.value) do { ax ->",
  "                ax.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := listMap(value, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        def spc = \"  \" * (depth+1)",
  "        var s := basePretty(depth)",
  "        for (self.value) do { ax ->",
  "            s := s ++ \"\\n\"++ spc ++ ax.pretty(depth+1)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"[\"",
  "        for (self.value.indices) do { i ->",
  "            s := s ++ self.value.at(i).toGrace(0)",
  "            if (i < self.value.size) then {",
  "                s := s ++ \", \"",
  "            }",
  "        }",
  "        s := s ++ \"]\"",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        arrayNode.new(emptySeq).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "class outerNode(nodes) {",
  "    // references an object outside the current object.",
  "    // nodes, a sequence of objectNodes, tells us which one.",
  "    // The object that we refer to is the one OUTSIDE nodes.last",
  "    inherit baseNode",
  "    def kind is public = \"outer\"",
  "    def theObjects is public = nodes",
  "    method numberOfLevels { theObjects.size }",
  "    method asString { \"‹object outside that at line {theObjects.last.line}›\" }",
  "    method pretty(depth) { basePretty(depth) ++ asString }",
  "    method accept(visitor) from (as) {",
  "        visitor.visitOuter(self) up (as)",
  "        // don't visit theObject, since this would introduce a cycle",
  "    }",
  "    method toGrace(depth) {",
  "        \"outer\" ++ (\".outer\" * (theObjects.size - 1))",
  "    }",
  "    method isOuter { true }",
  "    method isSelfOrOuter { true }",
  "    method shallowCopy {",
  "        outerNode(theObjects).shallowCopyFieldsFrom(self)",
  "    }",
  "    method map (blk) ancestors (as) {",
  "        var nd := shallowCopy",
  "        blk.apply(nd, as)",
  "    }",
  "    def end is public = if (line == 0) then { noPosition } else {",
  "        line (line) column (linePos + 4)",
  "    }",
  "}",
  "def memberNode is public = object {",
  "    method new(request, receiver) scope(s) {",
  "        // Represents a dotted request ‹receiver›.‹request› with no arguments.",
  "        def result = new(request, receiver)",
  "        result.scope := s",
  "        result",
  "    }",
  "    class new(request, receiver') {",
  "        // Represents a dotted request ‹receiver›.‹request› with no arguments.",
  "        inherit baseNode",
  "        def kind is public = \"member\"",
  "        var value:String is public := request",
  "        var receiver is public := receiver'",
  "        var generics is public := false",
  "        var isSelfRequest is public := false",
  "        var isTailCall is public := false",
  "        method end -> Position {",
  "            line (reqPos.line) column (reqPos.column + request.size - 1)",
  "        }",
  "        method onSelf {",
  "            isSelfRequest := true",
  "            self",
  "        }",
  "        method reqPos is confidential {",
  "            // the position of the start of the ‹request› in this ‹receiver›.‹request›",
  "            if (receiver.isImplicit) then {",
  "                start",
  "            } else {",
  "                positionOfNext (request) after (receiver.end)",
  "            }",
  "        }",
  "        method nameString { value }",
  "        method canonicalName { value }",
  "        method isMember { true }",
  "        method isCall { true }",
  "",
  "        method parts { list [requestPart.request(nameString).setStart(reqPos)] }",
  "        method arguments { emptySeq }",
  "        method argumentsDo(action) { }",
  "        method numArgs { 0 }",
  "        method numTypeArgs {",
  "            if (false == generics) then { 0 } else { generics.size }",
  "        }",
  "",
  "        method accept(visitor : AstVisitor) from(as) {",
  "            if (visitor.visitMember(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                if (false != generics) then {",
  "                    generics.do { each -> each.accept(visitor) from(newChain) }",
  "                }",
  "                receiver.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "        method isSelfOrOuter {",
  "            receiver.isSelfOrOuter",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.receiver := receiver.map(blk) ancestors(newChain)",
  "            n.generics := maybeListMap(generics, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            def spc = \"  \" * (depth+1)",
  "            var s := basePretty(depth)",
  "            s := s ++ if (isSelfRequest) then { \" on self \" } else { \" \" }",
  "            s := s ++ \"‹\" ++ self.value ++ \"›\\n\"",
  "            s := s ++ spc ++ receiver.pretty(depth)",
  "            if (false != generics) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"  Generics:\"",
  "                for (generics) do {g->",
  "                    s := s ++ \"\\n\" ++ spc ++ \"    \" ++ g.pretty(0)",
  "                }",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var s := self.receiver.toGrace(depth) ++ \".\" ++ self.value",
  "            if (false != generics) then {",
  "                s := s ++ \"⟦\"",
  "                for (1..(generics.size - 1)) do {ix ->",
  "                    s := s ++ generics.at(ix).toGrace(depth + 1) ++ \", \"",
  "                }",
  "                s := s ++ generics.last.toGrace(depth + 1) ++ \"⟧\"",
  "            }",
  "            s",
  "        }",
  "        method asString { toGrace 0 }",
  "        method asIdentifier {",
  "            // make and return an identifiderNode for my request",
  "            if (fakeSymbolTable == scope) then {",
  "                ProgrammingError.raise \"asIdentifier requested on {pretty 0} when scope was fake\"",
  "            }",
  "            def resultNode = identifierNode.new (nameString, false) scope (scope)",
  "            resultNode.inRequest := true",
  "            resultNode.line := line",
  "            resultNode.linePos := linePos",
  "            return resultNode",
  "        }",
  "        method shallowCopy {",
  "            memberNode.new(nameString, receiver).shallowCopyFieldsFrom(self)",
  "        }",
  "        method statementName { \"expression\" }",
  "        method postCopy(other) {",
  "            generics := other.generics",
  "            isSelfRequest := other.isSelfRequest",
  "            isTailCall := other.isTailCall",
  "            self",
  "        }",
  "    }",
  "}",
  "def genericNode is public = object {",
  "  class new(base, arguments) {",
  "    // represents an application of a parameterized type to some arguments.",
  "    inherit baseNode",
  "    def kind is public = \"generic\"",
  "    var value is public := base",
  "        // in a generic application, `value` is the applied type",
  "        // e.g. in List⟦Number⟧, value is Identifier‹List›",
  "    var args is public := arguments",
  "    method end -> Position { positionOfNext \"⟧\" after (args.last.end) }",
  "    method nameString { value.nameString }",
  "    method asString { toGrace 0 }",
  "    method accept(visitor : AstVisitor) from(as) {",
  "        if (visitor.visitGeneric(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "            for (self.args) do { p ->",
  "                p.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.args := listMap(args, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var s := \"{basePretty(depth)}({value.pretty(depth)})⟦\"",
  "        args.do { each -> s := s ++ each.pretty(depth+2) }",
  "            separatedBy { s := s ++ \", \" }",
  "        s ++ \"⟧\"",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := nameString ++ \"⟦\"",
  "        args.do { each -> s := s ++ each.toGrace(0) }",
  "            separatedBy { s := s ++ \", \" }",
  "        s ++ \"⟧\"",
  "    }",
  "    method shallowCopy {",
  "        genericNode.new(value, args).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "",
  "def typeParametersNode is public = object {",
  "  class new(params') {",
  "    inherit baseNode",
  "    def kind is public = \"typeparams\"",
  "    var params is public := params'",
  "    method asString { toGrace 0 }",
  "    method declarationKindWithAncestors(as) { k.typeparam }",
  "    method end -> Position {",
  "        positionOfNext \"]]\" or \"⟧\" after (params.last.end)",
  "    }",
  "",
  "    method accept(visitor : AstVisitor) from(as) {",
  "        if (visitor.visitTypeParameters(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            params.do { p ->",
  "                p.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method do(blk) {",
  "        params.do(blk)",
  "    }",
  "    method size { params.size }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.params := listMap(params, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        def spc = \"  \" * (depth+1)",
  "        var s := spc ++ basePretty(depth) ++ \"⟦\"",
  "        params.do { each -> s := s ++ each.pretty(depth+2) }",
  "            separatedBy { s := s ++ \", \" }",
  "        s ++ \"⟧\"",
  "    }",
  "    method toGrace(depth:Number) -> String {",
  "        var s := \"⟦\"",
  "        params.do { each -> s := \"{s}{each.toGrace(depth)}\" }",
  "            separatedBy { s := s ++ \", \" }",
  "        s ++ \"⟧\"",
  "    }",
  "    method shallowCopy {",
  "        typeParametersNode.new(emptySeq).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def identifierNode is public = object {",
  "",
  "    method new(name, dtype) scope(s) {",
  "        def result = new(name, dtype)",
  "        result.scope := s",
  "        result",
  "    }",
  "",
  "    var wildcardCount := 0",
  "    method wildcard(dtype) {",
  "        wildcardCount := wildcardCount + 1",
  "        def idNode = new(\"__{wildcardCount}\", dtype)",
  "        idNode.wildcard := true",
  "        idNode.end := line (idNode.line) column (idNode.linePos)",
  "        idNode",
  "    }",
  "",
  "    class new(name', dtype') {",
  "        inherit baseNode",
  "        def kind is public = \"identifier\"",
  "        var value is public := name'",
  "        var wildcard is public := false",
  "        var dtype is public := dtype'",
  "        var isBindingOccurrence is public := false",
  "        var isAssigned is public := false",
  "        var inRequest is public := false",
  "        var generics is public := false",
  "        var isDeclaredByParent is public := false",
  "        var end:Position is public := line (line) column (linePos + value.size - 1)",
  "",
  "        method name { value }",
  "        method name:=(nu) {",
  "            value := nu",
  "            end := line (line) column (linePos + nu.size - 1)",
  "        }",
  "        method nameString { value }",
  "        var canonicalName is public := value",
  "        method quoted { value.quoted }",
  "        method isIdentifier { true }",
  "",
  "        method isSelf { \"self\" == value }",
  "        method isSuper { \"super\" == value }",
  "        method isPrelude { \"prelude\" == value }",
  "        method isOuter { \"outer\" == value }",
  "        method isSelfOrOuter {",
  "            if (isSelf) then { return true }",
  "            if (isOuter) then { return true }",
  "            return false",
  "        }",
  "        method isAppliedOccurenceOfIdentifier {",
  "            if (wildcard) then {",
  "                false",
  "            } else {",
  "                isBindingOccurrence.not",
  "            }",
  "        }",
  "        method declarationKindWithAncestors(as) {",
  "            as.parent.declarationKindWithAncestors(as)",
  "        }",
  "        method inTypePositionWithAncestors(as) {",
  "            // am I used by my parent node as a type?",
  "            // This is a hack, used as a subsitute for having information in the .gct",
  "            // telling us which identifiers represent types",
  "            if (as.isEmpty) then { return false }",
  "            as.parent.usesAsType(self)",
  "        }",
  "        method usesAsType(aNode) {",
  "            aNode == dtype",
  "        }",
  "        method accept(visitor : AstVisitor) from(as) {",
  "            if (visitor.visitIdentifier(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                if (false != self.dtype) then {",
  "                    self.dtype.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            def spc = \"  \" * (depth+1)",
  "            var s := basePretty(depth)",
  "            if ( wildcard ) then {",
  "                s := s ++ \" Wildcard\"",
  "            } elseif { isBindingOccurrence } then {",
  "                s := s ++ \"Binding‹{value}›\"",
  "            } else {",
  "                s := s ++ \"‹{value}›\"",
  "            }",
  "            if (false != self.dtype) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"  Type: \"",
  "                s := s ++ self.dtype.pretty(depth + 2)",
  "            }",
  "            if (false != generics) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Generics:\"",
  "                for (generics) do {g->",
  "                    s := s ++ \"\\n\" ++ spc ++ \"  \" ++ g.pretty(depth + 2)",
  "                }",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var s",
  "            if(self.wildcard) then {",
  "                s := \"_\"",
  "            } else {",
  "                s := self.value",
  "            }",
  "            if (false != self.dtype) then {",
  "                s := s ++ \":\" ++ self.dtype.toGrace(depth + 1)",
  "            }",
  "            if (false != generics) then {",
  "                s := s ++ \"⟦\"",
  "                for (1..(generics.size - 1)) do {ix ->",
  "                    s := s ++ generics.at(ix).toGrace(depth + 1) ++ \", \"",
  "                }",
  "                s := s ++ generics.last.toGrace(depth + 1) ++ \"⟧\"",
  "            }",
  "            s",
  "        }",
  "",
  "        method asString {",
  "            if (isBindingOccurrence) then {",
  "                \"identifierBinding‹{value}›\"",
  "            } else {",
  "                \"identifier‹{value}›\"",
  "            }",
  "        }",
  "        method shallowCopy {",
  "            identifierNode.new(value, dtype).shallowCopyFieldsFrom(self)",
  "        }",
  "        method postCopy(other) {",
  "            wildcard := other.wildcard",
  "            isBindingOccurrence := other.isBindingOccurrence",
  "            isDeclaredByParent := other.isDeclaredByParent",
  "            isAssigned := other.isAssigned",
  "            inRequest := other.inRequest",
  "            end := other.end",
  "            canonicalName := other.canonicalName",
  "            self",
  "        }",
  "        method statementName { \"expression\" }",
  "    }",
  "}",
  "",
  "def typeType is public = identifierNode.new(\"Type\", false)",
  "def unknownType is public = identifierNode.new(\"Unknown\", typeType)",
  "",
  "def stringNode is public = object {",
  "    method new(v) scope(s) {",
  "        def result = new(v)",
  "        result.scope := s",
  "        result",
  "    }",
  "",
  "    class new(v) {",
  "        inherit baseNode",
  "        def kind is public = \"string\"",
  "        var value is public := v",
  "        var end is public := line (line) column (linePos + v.size + 1)",
  "            // +1 to allow for quotes",
  "",
  "        method accept(visitor : AstVisitor) from(as) {",
  "            visitor.visitString(self) up(as)",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            \"{basePretty(depth)}({self.value})\"",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            def q = \"\\\"\"",
  "            q ++ value.quoted ++ q",
  "        }",
  "        method asString { \"string {toGrace 0}\" }",
  "        method shallowCopy {",
  "            stringNode.new(value).shallowCopyFieldsFrom(self)",
  "        }",
  "        method postCopy(other) {",
  "            end := other.end",
  "            self",
  "        }",
  "        method statementName { \"expression\" }",
  "        method isDelimited { true }",
  "        method isConstant { true }",
  "    }",
  "}",
  "def numNode is public = object {",
  "    class new(val) {",
  "        inherit baseNode",
  "        def kind is public = \"num\"",
  "        var value is public := val",
  "        method accept(visitor : AstVisitor) from(as) {",
  "            visitor.visitNum(self) up(as)",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            \"{basePretty(depth)}({self.value})\"",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            self.value.asString",
  "        }",
  "        method asString { \"num {value}\" }",
  "        method shallowCopy {",
  "            numNode.new(value).shallowCopyFieldsFrom(self)",
  "        }",
  "        method statementName { \"expression\" }",
  "        method isDelimited { true }",
  "        method isConstant { true }",
  "    }",
  "}",
  "def opNode is public = object {",
  "  class new(op, l, r) {",
  "    inherit baseNode",
  "    def kind is public = \"op\"",
  "    def value is public = op     // a String",
  "    var left is public := l",
  "    var right is public := r",
  "    var isTailCall is public := false      // is possibly the result of a method",
  "    var isSelfRequest is public := false",
  "",
  "    method start -> Position { left.start }",
  "    method end -> Position { right.end }",
  "    method onSelf {",
  "        isSelfRequest := true",
  "        self",
  "    }",
  "    method opPos is confidential {",
  "        // the position of the start of the ‹op› in this ‹left› ‹op› ‹right›",
  "        positionOfNext (value) after (left.end)",
  "    }",
  "    method isSimple { false }    // needs parens when used as reciever",
  "    method nameString { value ++ \"(1)\" }",
  "    method canonicalName { value ++ \"(_)\" }",
  "    method receiver { left }",
  "    method isCall { true }",
  "",
  "    method parts { list [requestPart.request (value) withArgs [right] .setStart(opPos)] }",
  "    method arguments { [ right ] }",
  "    method argumentsDo(action) { action.apply(right) }",
  "    method numArgs { 1 }",
  "    method numTypeArgs { 0 }",
  "",
  "    method accept(visitor : AstVisitor) from(as) {",
  "        if (visitor.visitOp(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.left.accept(visitor) from(newChain)",
  "            self.right.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.left := left.map(blk) ancestors(newChain)",
  "        n.right := right.map(blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        def spc = \"  \" * (depth+1)",
  "        var s := \"{basePretty(depth)}‹{self.nameString}›\"",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.left.pretty(depth + 1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.right.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"\"",
  "        if ((self.left.kind == \"op\") && {self.left.value != self.value}) then {",
  "            s := \"(\" ++ self.left.toGrace(0) ++ \")\"",
  "        } else {",
  "            s := self.left.toGrace(0)",
  "        }",
  "        if (self.value == \"..\") then {",
  "            s := s ++ self.value",
  "        } else {",
  "            s := s ++ \" \" ++ self.value ++ \" \"",
  "        }",
  "        if ((self.right.kind == \"op\") && {self.right.value != self.value}) then {",
  "            s := s ++ \"(\" ++ self.right.toGrace(0) ++ \")\"",
  "        } else {",
  "            s := s ++ self.right.toGrace(0)",
  "        }",
  "        s",
  "    }",
  "    method asIdentifier {",
  "        // make an identifiderNode with the same properties as me",
  "        def resultNode = identifierNode.new (nameString, false) scope (scope)",
  "        resultNode.inRequest := true",
  "        resultNode.line := line",
  "        resultNode.linePos := linePos",
  "        return resultNode",
  "    }",
  "    method shallowCopy {",
  "        opNode.new(value, nullNode, nullNode).shallowCopyFieldsFrom(self)",
  "    }",
  "    method postCopy(other) {",
  "        isTailCall := other.isTailCall",
  "        isSelfRequest := other.isSelfRequest",
  "        self",
  "    }",
  "  }",
  "}",
  "def bindNode is public = object {",
  "  class new(dest', val') {",
  "    // an assignment, or a request of a setter-method",
  "    inherit baseNode",
  "    def kind is public = \"bind\"",
  "    var dest is public := dest'",
  "    var value is public := val'",
  "",
  "    method end -> Position { value.end }",
  "    method nameString { value ++ \":=(1)\" }",
  "    method canonicalName { value ++ \":=(_)\" }",
  "    method isBind { true }",
  "    method asString { \"bind {value}\" }",
  "    method accept(visitor : AstVisitor) from(as) {",
  "        if (visitor.visitBind(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.dest.accept(visitor) from(newChain)",
  "            self.value.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.dest := dest.map(blk) ancestors(newChain)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        def spc = \"  \" * (depth+1)",
  "        var s := basePretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.dest.pretty(depth + 1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        def spc = \"    \" * depth",
  "        var s := self.dest.toGrace(depth + 1)",
  "        s := s ++ \" := \" ++ self.value.toGrace(depth + 1)",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        bindNode.new(dest, value).shallowCopyFieldsFrom(self)",
  "    }",
  "    method statementName { \"assignment or assigment request\" }",
  "  }",
  "}",
  "def defDecNode is public = object {",
  "    method new(name', val, dtype') scope(s) {",
  "        def result = new(name', val, dtype')",
  "        result.scope := s",
  "        result",
  "    }",
  "",
  "    class new(name', val, dtype') {",
  "        inherit baseNode",
  "        def kind is public = \"defdec\"",
  "        var name is public := name'",
  "        var value is public := val",
  "        var dtype is public := dtype'",
  "        var parentKind is public := \"unset\"",
  "        def nameString is public = name.nameString",
  "        var annotations is public := [ ]",
  "        var startToken is public := false",
  "",
  "        method end -> Position { value.end }",
  "        method isPublic {",
  "            // defs are confidential by default",
  "            if (annotations.size == 0) then { return false }",
  "            if (findAnnotation(self, \"public\")) then { return true }",
  "            findAnnotation(self, \"readable\")",
  "        }",
  "        method isFieldDec { true }",
  "        method isWritable { false }",
  "        method isReadable { isPublic }",
  "",
  "        method returnsObject {",
  "            value.returnsObject",
  "        }",
  "        method returnedObjectScope {",
  "            // precondition: returnsObject",
  "            value.returnedObjectScope",
  "        }",
  "        method usesAsType(aNode) {",
  "            aNode == dtype",
  "        }",
  "        method declarationKindWithAncestors(as) { k.defdec }",
  "",
  "        method accept(visitor : AstVisitor) from(as) {",
  "            if (visitor.visitDefDec(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                self.name.accept(visitor) from(newChain)",
  "                if (false != self.dtype) then {",
  "                    self.dtype.accept(visitor) from(newChain)",
  "                }",
  "                for (self.annotations) do { ann ->",
  "                    ann.accept(visitor) from(newChain)",
  "                }",
  "                value.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.name := name.map(blk) ancestors(newChain)",
  "            n.value := value.map(blk) ancestors(newChain)",
  "            n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "            n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            def spc = \"  \" * (depth+1)",
  "            var s := basePretty(depth) ++ \"\\n\"",
  "            s := s ++ spc ++ self.name.pretty(depth)",
  "            if (false != dtype) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Type: \" ++ self.dtype.pretty(depth + 2)",
  "            }",
  "            if (false != value) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Value: \" ++ value.pretty(depth + 2)",
  "            }",
  "            if (annotations.isEmpty.not) then {",
  "                s := s ++ \"\\n{spc}Annotations:\"",
  "                annotations.do { ann ->",
  "                    s := \"{s} {ann.pretty(depth + 2)}\"",
  "                }",
  "            }",
  "            if (false != comments) then {",
  "                s := s ++ comments.pretty(depth+2)",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            def spc = \"    \" * depth",
  "            var s := \"def {self.name.toGrace(0)}\"",
  "            if ( (false != self.dtype) && {",
  "                    self.dtype.value != \"Unknown\" }) then {",
  "                s := s ++ \" : \" ++ self.dtype.toGrace(0)",
  "            }",
  "            if (self.annotations.size > 0) then {",
  "                s := s ++ \" is \"",
  "                s := s ++ self.annotations.fold{ a,b ->",
  "                    if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) }",
  "                        startingWith \"\"",
  "            }",
  "            if (false != self.value) then {",
  "                s := s ++ \" = \" ++ self.value.toGrace(depth)",
  "            }",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            defDecNode.new(name, value, dtype).shallowCopyFieldsFrom(self)",
  "        }",
  "        method postCopy(other) {",
  "            startToken := other.startToken",
  "            parentKind := other.parentKind",
  "            self",
  "        }",
  "        method statementName { \"definition\" }",
  "    }",
  "}",
  "def varDecNode is public = object {",
  "  class new(name', val', dtype') {",
  "    inherit baseNode",
  "    def kind is public = \"vardec\"",
  "    var name is public := name'",
  "    var value is public := val'",
  "    var dtype is public := dtype'",
  "    var parentKind is public := \"unset\"",
  "    def nameString is public = name.value",
  "    var annotations is public := [ ]",
  "",
  "    method end -> Position {",
  "        if (false ≠ value) then { return value.end }",
  "        if (annotations.isEmpty.not) then { return annotations.last.end }",
  "        if (false ≠ dtype) then { return dtype.end }",
  "        return name.end",
  "    }",
  "    method isPublic {",
  "        // vars are confidential by default",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        findAnnotation(self, \"readable\")",
  "    }",
  "    method isWritable {",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        if (findAnnotation(self, \"writable\")) then { return true }",
  "        false",
  "    }",
  "    method isReadable {",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        if (findAnnotation(self, \"readable\")) then { return true }",
  "        false",
  "    }",
  "    method isFieldDec { true }",
  "",
  "    method usesAsType(aNode) {",
  "        aNode == dtype",
  "    }",
  "",
  "    method declarationKindWithAncestors(as) { k.vardec }",
  "",
  "    method accept(visitor : AstVisitor) from(as) {",
  "        if (visitor.visitVarDec(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.name.accept(visitor) from(newChain)",
  "            if (false != self.dtype) then {",
  "                self.dtype.accept(visitor) from(newChain)",
  "            }",
  "            for (self.annotations) do { ann ->",
  "                ann.accept(visitor) from(newChain)",
  "            }",
  "            if (false != self.value) then {",
  "                self.value.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.name := name.map(blk) ancestors(newChain)",
  "        n.value := maybeMap(value, blk) ancestors(newChain)",
  "        n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "        n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        def spc = \"  \" * (depth+1)",
  "        var s := basePretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.name.pretty(depth + 1)",
  "        if (false != self.dtype) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Type: \"",
  "            s := s ++ self.dtype.pretty(depth + 2)",
  "        }",
  "        if (false != self.value) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Value: \"",
  "            s := s ++ self.value.pretty(depth + 2)",
  "        }",
  "        if (false != comments) then {",
  "            s := s ++ comments.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        def spc = \"    \" * depth",
  "        var s := \"var {self.name.toGrace(0)}\"",
  "        if ( (false != self.dtype) && {",
  "                self.dtype.value != \"Unknown\" }) then {",
  "            s := s ++ \" : \" ++ self.dtype.toGrace(0)",
  "        }",
  "        if (self.annotations.size > 0) then {",
  "            s := s ++ \" is \"",
  "            s := s ++ self.annotations.fold{ a,b ->",
  "                if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) }",
  "                    startingWith \"\"",
  "        }",
  "        if (false != self.value) then {",
  "            s := s ++ \" := \" ++ self.value.toGrace(depth)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        varDecNode.new(name, value, dtype).shallowCopyFieldsFrom(self)",
  "    }",
  "    method postCopy(other) {",
  "        parentKind := other.parentKind",
  "        self",
  "    }",
  "    method statementName { \"variable declaration\" }",
  "",
  "  }",
  "}",
  "def importNode is public = object {",
  "  class new(path', name', dtype') {",
  "    inherit baseNode",
  "    def kind is public = \"import\"",
  "    var value is public := name'",
  "    var path is public := path'",
  "    var annotations is public := [ ]",
  "    var dtype is public := dtype'",
  "    method end -> Position { value.end }",
  "    method isImport { true }",
  "    method isExternal { true }",
  "    method isExecutable { false }",
  "    method name { value }",
  "    method nameString { value.nameString }",
  "    method isPublic {",
  "        // imports, like defs, are confidential by default",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        findAnnotation(self, \"readable\")",
  "    }",
  "    method moduleName {",
  "        var bnm := \"\"",
  "        for (path) do {c->",
  "            if (c == \"/\") then {",
  "                bnm := \"\"",
  "            } else {",
  "                bnm := bnm ++ c",
  "            }",
  "        }",
  "        bnm",
  "    }",
  "    method isWritable { false }",
  "    method isReadable { isPublic }",
  "    method declarationKindWithAncestors(as) { k.defdec }",
  "    method usesAsType(aNode) {",
  "        aNode == dtype",
  "    }",
  "    method accept(visitor : AstVisitor) from(as) {",
  "        if (visitor.visitImport(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            for (self.annotations) do { ann ->",
  "                ann.accept(visitor) from(newChain)",
  "            }",
  "            self.value.accept(visitor) from(newChain)",
  "            if (false != self.dtype) then {",
  "                self.dtype.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "        n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        def spc = \"  \" * (depth+1)",
  "        var s := basePretty(depth) ++ \"\\n\"",
  "        s := s ++ \"{spc}Path: {path}\\n\"",
  "        s := s ++ \"{spc}Identifier: {value}\\n\"",
  "        if (annotations.size > 0) then {",
  "            s := s ++ \"{spc}Anotations: {annotations}\\n\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"import \\\"{self.path}\\\" as {nameString}\"",
  "    }",
  "    method shallowCopy {",
  "        importNode.new(path, nullNode, false).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def dialectNode is public = object {",
  "  method fromToken(stringTok) {",
  "    def result = new(stringTok.value)",
  "    result.end := line (stringTok.line) column (stringTok.linePos + stringTok.size - 1)",
  "    result",
  "  }",
  "  class new(pathString) {",
  "    inherit baseNode",
  "    def kind is public = \"dialect\"",
  "    var value is public := pathString",
  "    var end is public := noPosition",
  "",
  "    method isDialect { true }",
  "    method isExternal { true }",
  "    method isExecutable { false }",
  "    method moduleName {",
  "        var bnm := \"\"",
  "        for (value) do {c->",
  "            if (c == \"/\") then {",
  "                bnm := \"\"",
  "            } else {",
  "                bnm := bnm ++ c",
  "            }",
  "        }",
  "        bnm",
  "    }",
  "    method path {",
  "        value",
  "    }",
  "    method accept(visitor : AstVisitor) from(as) {",
  "        visitor.visitDialect(self) up(as)",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        def spc = \"  \" * (depth+1)",
  "        var s := basePretty(depth) ++ \"\\n\"",
  "        s := s ++ \"{spc}Path: {self.value}\\n\"",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"dialect \\\"{self.value}\\\"\"",
  "    }",
  "    method shallowCopy {",
  "        dialectNode.new(value).shallowCopyFieldsFrom(self)",
  "    }",
  "    method postCopy(other) {",
  "        end := other.end",
  "        self",
  "    }",
  "  }",
  "}",
  "def returnNode is public = object {",
  "  class new(expr) {",
  "    inherit baseNode",
  "    def kind is public = \"return\"",
  "    var value is public := expr",
  "    var dtype is public := false  // the enclosing method's declared return type",
  "",
  "    method end -> Position {",
  "        if (noPosition ≠ value.end) then {",
  "            value.end",
  "        } else {",
  "            line (line) column (linePos + 5)",
  "        }",
  "    }",
  "    method isReturn { true }",
  "    method accept(visitor : AstVisitor) from(as) {",
  "        if (visitor.visitReturn(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        def spc = \"  \" * (depth+1)",
  "        var s := basePretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        if (false ≠ dtype) then { s := \"{s} (type {dtype.toGrace 0})\" }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"return \" ++ self.value.toGrace(depth)",
  "    }",
  "    method shallowCopy {",
  "        returnNode.new(value).shallowCopyFieldsFrom(self)",
  "    }",
  "    method postCopy(other) {",
  "        dtype := other.dtype",
  "        self",
  "    }",
  "    method returnsObject { value.returnsObject }",
  "    method returnedObjectScope {",
  "        // precondition: returns object",
  "        value.returnedObjectScope",
  "    }",
  "    method resultExpression { value }",
  "  }",
  "}",
  "def inheritNode is public = object {",
  "    method new(expr) scope(s) {",
  "        def result = new(expr)",
  "        result.scope := s",
  "        result",
  "    }",
  "    class new(expr) {",
  "        inherit baseNode",
  "        def kind is public = \"inherit\"",
  "        var value is public := expr",
  "        var providedNames is public := emptySet",
  "        var aliases is public := [ ]",
  "        var exclusions is public := [ ]",
  "        var isUse is public := false  // this is a `use trait` clause, not an inherit",
  "",
  "        method end -> Position { value.end }",
  "        method isLegalInTrait { isUse }",
  "        method isInherits { true }",
  "        method inheritFromMember { value.isMember }",
  "        method inheritFromCall { value.isCall }",
  "        method isExecutable { false }",
  "        method accept(visitor : AstVisitor) from(as) {",
  "            if (visitor.visitInherits(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                value.accept(visitor) from(newChain)",
  "                aliases.do { a ->",
  "                    a.newName.accept(visitor) from(newChain)",
  "                    a.oldName.accept(visitor) from(newChain)",
  "                }",
  "                exclusions.do { e -> e.accept(visitor) from(newChain) }",
  "            }",
  "        }",
  "        method declarationKindWithAncestors(as) {",
  "            // identifiers declared in an inherit statement are aliases for",
  "            // methods.  We treat them as methods, because (unlike inherited names)",
  "            // they can't be overridden by local methods.",
  "            k.methdec",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.value := value.map(blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            def spc = \"  \" * (depth+1)",
  "            var s := basePretty(depth)",
  "            if (isUse) then { s := \"{s} (use)\" }",
  "            s := s ++ \"\\n\" ++ spc ++ self.value.pretty(depth + 1)",
  "            aliases.do { a ->",
  "                s := \"{s}\\n{a.pretty(depth)}\"",
  "            }",
  "            if (exclusions.isEmpty.not) then { s := \"{s}\\n{spc}\" }",
  "            exclusions.do { e ->",
  "                s := \"{s} exclude {e} \"",
  "            }",
  "            if (providedNames.isEmpty.not) then {",
  "                s := s ++ \"\\n{spc}Provided names: {list(providedNames).sort}\"",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var s := \"\"",
  "            repeat (depth) times {",
  "                s := s ++ \"    \"",
  "            }",
  "            s := s ++ if (isUse) then { \"use \" } else { \"inherit \" }",
  "            s := s ++ self.value.toGrace(0)",
  "            aliases.do { a ->",
  "                s := \"{s} {a} \"",
  "            }",
  "            exclusions.do { e ->",
  "                s := \"{s} exclude {e.nameString} \"",
  "            }",
  "            s",
  "        }",
  "        method asString {",
  "            if (isUse) then { \"use \" } else { \"inherit \" } ++ value.toGrace 0",
  "        }",
  "        method nameString { value.toGrace(0) }",
  "        method addAlias (newName) for (oldName) {",
  "            aliases.push(aliasNew(newName) old(oldName))",
  "        }",
  "        method addExclusion(ident) {",
  "            exclusions.push(ident)",
  "        }",
  "        method shallowCopy {",
  "            inheritNode.new(nullNode).shallowCopyFieldsFrom(self)",
  "        }",
  "        method postCopy(other) {",
  "            providedNames := other.providedNames",
  "            aliases := other.aliases",
  "            exclusions := other.exclusions",
  "            isUse := other.isUse",
  "            self",
  "        }",
  "        method statementName {",
  "            if (isUse) then { \"use\" } else { \"inherit\" }",
  "        }",
  "    }",
  "}",
  "type AliasPair = {",
  "    newName",
  "    oldName",
  "}",
  "",
  "class aliasNew(n) old(o) {",
  "    method newName {n}",
  "    method oldName {o}",
  "    method asString { \"alias {n.nameString} = {o.nameString}\" }",
  "    method pretty(depth) {",
  "        def spc = \"  \" * (depth+1)",
  "        \"{spc}  alias {n.pretty(depth)} = {o.pretty(depth)}\"",
  "    }",
  "    method hash { (n.hash * 1171) + o.hash }",
  "    method isExecutable { false }",
  "    method == (other) {",
  "        match (other)",
  "            case { that:AliasPair -> (n == that.newName) && (o == that.oldName) }",
  "            case { _ -> false }",
  "    }",
  "}",
  "def signaturePart is public = object {",
  "    method new {",
  "        partName \"\" params []",
  "    }",
  "    method partName(n) scope(s) {",
  "        def result = partName(n) params []",
  "        result.scope := s",
  "        result",
  "    }",
  "    method partName(n) params(ps) scope(s) {",
  "        def result = partName(n) params(ps)",
  "        result.scope := s",
  "        result",
  "    }",
  "    method partName(n) {",
  "        partName(n) params []",
  "    }",
  "    class partName(n) params(ps) {",
  "        inherit baseNode",
  "        def kind is public = \"signaturepart\"",
  "        var name is public := n",
  "        var params is public := ps",
  "        var typeParams is public := false",
  "        var lineLength is public := 0",
  "",
  "        method end -> Position {",
  "            if (params.isEmpty.not) then {",
  "                return positionOfNext \")\" after (params.last.end)",
  "            }",
  "            if (false ≠ typeParams) then {",
  "                return positionOfNext \"⟧\" after (typeParams.last.end)",
  "            }",
  "            return line (line) column (linePos + name.size - 1)",
  "        }",
  "        method numParams { params.size }",
  "        method nameString {",
  "            if (params.isEmpty) then {return name}",
  "            name ++ \"(\" ++ params.size ++ \")\"",
  "        }",
  "        method canonicalName {",
  "            if (params.isEmpty) then {return name}",
  "            var underScores := \"\"",
  "            params.do { _ -> underScores := underScores ++ \"_\" }",
  "                separatedBy { underScores := underScores ++ \",\" }",
  "            name ++ \"(\" ++ underScores ++ \")\"",
  "        }",
  "",
  "        method accept(visitor : AstVisitor) from(as) {",
  "            if (visitor.visitSignaturePart(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                params.do { p -> p.accept(visitor) from(newChain) }",
  "                if (false != typeParams) then {",
  "                    typeParams.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "        }",
  "        method declarationKindWithAncestors(as) { k.parameter }",
  "        method map(blk) ancestors(as) {",
  "            var nd := shallowCopy",
  "            def newChain = as.extend(nd)",
  "            nd.params := listMap(params, blk) ancestors(newChain)",
  "            nd.typeParams := maybeMap(typeParams, blk) ancestors(newChain)",
  "            blk.apply(nd, as)",
  "        }",
  "        method pretty(depth) {",
  "            def spc = \"  \" * (depth+1)",
  "            var s := \"{basePretty(depth)}: {name}\"",
  "            if (params.isEmpty.not) then { s := \"{s}\\n{spc}Parameters:\" }",
  "            for (params) do { p ->",
  "                s := \"{s}\\n  {spc}{p.pretty(depth + 2)}\"",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth) {",
  "            var s := name",
  "            if (params.isEmpty.not) then {",
  "                s := s ++ \"(\"",
  "                params.do { each -> s := each.toGrace(depth + 1) }",
  "                    separatedBy { s := s ++ \", \" }",
  "                s := s ++ \")\"",
  "            }",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            signaturePart.partName(name) params(params)",
  "                .shallowCopyFieldsFrom(self)",
  "        }",
  "        method postCopy(other) {",
  "            typeParams := other.typeParams",
  "            lineLength := other.lineLength",
  "            self",
  "        }",
  "        method asString {",
  "            \"part: {nameString}\"",
  "        }",
  "    }",
  "}",
  "",
  "def requestPart is public = object {",
  "    method new { request \"\" withArgs [] }",
  "    method request(name) { request(name) withArgs [] }",
  "    method request(name) withArgs(argList) scope (s) {",
  "        def result = request(name) withArgs(argList)",
  "        result.scope := s",
  "        result",
  "    }",
  "    class request(rPart) withArgs(xs) {",
  "        inherit baseNode",
  "        def kind is public = \"callwithpart\"",
  "        var name is public := rPart",
  "        var args is public := xs",
  "        var typeArgs := emptySeq",
  "        var lineLength is public := 0",
  "",
  "        method end -> Position {",
  "            if (args.isEmpty.not) then {",
  "                return args.last.end  // there may or may not be a following `)`",
  "            }",
  "            if (typeArgs.isEmpty.not) then {",
  "                return positionOfNext \"⟧\" after (typeArgs.last.end)",
  "            }",
  "            return line (line) column (linePos + name.size - 1)",
  "        }",
  "        method nameString {",
  "            if (args.size == 0) then {return name}",
  "            name ++ \"(\" ++ args.size ++ \")\"",
  "        }",
  "",
  "        method canonicalName {",
  "            if (args.size == 0) then {return name}",
  "            var underScores := \"\"",
  "            args.do { _ -> underScores := underScores ++ \"_\" }",
  "                separatedBy { underScores := underScores ++ \",\" }",
  "            name ++ \"(\" ++ underScores ++ \")\"",
  "        }",
  "",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.args := listMap(args, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            def spc = \"  \" * (depth+1)",
  "            var s := \"{basePretty(depth)}: {name}\"",
  "            s := \"{s}\\n{spc}Args:\"",
  "            for (args) do { a ->",
  "                s := \"{s}\\n  {spc}{a.pretty(depth + 3)}\"",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth) {",
  "            var s := name",
  "            if (typeArgs.size > 0) then {",
  "                s := s ++ \"⟦\"",
  "                typeArgs.do { tArg ->",
  "                    s := s ++ tArg.toGrace(depth + 1)",
  "                } separatedBy { s := s ++ \", \" }",
  "                s := s ++ \"⟧\"",
  "            }",
  "            if (args.size > 0) then {",
  "                def needsParens = (args.size > 1) || (args.first.isDelimited.not)",
  "                s := s ++ if (needsParens) then { \"(\" } else { \" \" }",
  "                args.do { arg ->",
  "                    s := s ++ arg.toGrace(depth)",
  "                } separatedBy {",
  "                    s := s ++ \", \"",
  "                }",
  "                if (needsParens) then { s := s ++ \")\" }",
  "            }",
  "            s",
  "        }",
  "",
  "        method shallowCopy {",
  "            requestPart.request(name) withArgs(args).shallowCopyFieldsFrom(self)",
  "        }",
  "        method postCopy(other) {",
  "            lineLength := other.lineLength",
  "            self",
  "        }",
  "        method statementName { \"request\" }",
  "    }",
  "}",
  "",
  "def commentNode is public = object {",
  "    class new(val') {",
  "        inherit baseNode",
  "        def kind is public = \"comment\"",
  "        var value is public := val'",
  "        var isPartialLine:Boolean is public := false",
  "        var isPreceededByBlankLine is public := false",
  "        var endLine is public := util.linenum",
  "",
  "        method end -> Position { line (endLine) column (util.lines.at(endLine).size) }",
  "        method isComment { true }",
  "        method isLegalInTrait { true }",
  "        method isExecutable { false }",
  "        method asString { \"comment ({line}–{endLine}): {value}\" }",
  "        method extendCommentUsing(cmtNode) {",
  "            value := value ++ \" \" ++ cmtNode.value",
  "            endLine := cmtNode.endLine",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            blk.apply(n, as)",
  "        }",
  "        method accept(visitor : AstVisitor) from(as) {",
  "            visitor.visitComment(self) up(as)",
  "        }",
  "        method pretty(depth) {",
  "            var s := \"\\n\"",
  "            repeat (depth-1) times {",
  "                s := s ++ \"  \"",
  "            }",
  "            def pb = if (isPreceededByBlankLine) then { \" > blank\" } else { \"\" }",
  "            \"{s}Comment{pb}({line}–{endLine}): ‹{value}›\"",
  "        }",
  "        method toGrace(depth) {",
  "            // Partial line comments don't start with a newline, whereas",
  "            // full-line comments do.  No newline at end in either case.",
  "            if (isPartialLine) then {",
  "                \"// (partial) {value}\"",
  "            } else {",
  "                def spc = \"    \" * depth",
  "                wrap(value) to (lineLength) prefix (spc ++ \"// \")",
  "            }",
  "        }",
  "        method shallowCopy {",
  "            commentNode.new(nullNode).shallowCopyFieldsFrom(self)",
  "        }",
  "        method postCopy(other) {",
  "            value := other.value",
  "            isPartialLine := other.isPartialLine",
  "            isPreceededByBlankLine := other.isPreceededByBlankLine",
  "            endLine := other.endLine",
  "            self",
  "        }",
  "    }",
  "}",
  "",
  "method wrap(str) to (l:Number) prefix (margin) {",
  "    def ind = margin.size",
  "    def len = max(ind + 4, l)",
  "    if ((ind + str.size) <= len) then {",
  "        return \"\\n\" ++ margin ++ str",
  "    }",
  "    var currBreak",
  "    var trimmedLine",
  "",
  "    try {",
  "        currBreak := str.lastIndexOf \" \" startingAt (len - ind)",
  "            ifAbsent {len - ind}",
  "        trimmedLine := str.substringFrom (1) to (currBreak).trim",
  "    } catch { ex:NoSuchMethod ->  // C string libraries lack methods",
  "        currBreak := min(len - ind, str.size)",
  "        (1..currBreak).do { ix ->",
  "            if (str.at(ix) == \" \") then { currBreak := ix }",
  "        }",
  "        var end := currBreak",
  "        while {(end >= 1) && {str.at(end) == \" \"}} do {",
  "            end := end - 1",
  "        }",
  "        var start := 1",
  "        while {(start <= str.size) && {str.at(start) == \" \"}} do {",
  "            start := start + 1",
  "        }",
  "        trimmedLine := str.substringFrom (start) to (end)",
  "    }",
  "    \"\\n\" ++ margin ++ trimmedLine ++",
  "        wrap(str.substringFrom (currBreak+1) to (str.size))",
  "            to (l) prefix (margin)",
  "}",
  "",
  "",
  "type AstVisitor = {",
  "    visitIf(o) up(as) -> Boolean",
  "    visitBlock(o) up(as) -> Boolean",
  "    visitMatchCase(o) up(as) -> Boolean",
  "    visitTryCatch(o) up(as) -> Boolean",
  "    visitMethodType(o) up(as) -> Boolean",
  "    visitSignaturePart(o) up(as) -> Boolean",
  "    visitTypeLiteral(o) up(as) -> Boolean",
  "    visitTypeParameters(o) up(as) -> Boolean",
  "    visitTypeDec(o) up(as) -> Boolean",
  "    visitMethod(o) up(as) -> Boolean",
  "    visitCall(o) up(as) -> Boolean",
  "    visitObject(o) up(as) -> Boolean",
  "    visitModule(o) up(as) -> Boolean",
  "    visitArray(o) up(as) -> Boolean",
  "    visitMember(o) up(as) -> Boolean",
  "    visitGeneric(o) up(as) -> Boolean",
  "    visitIdentifier(o) up(as) -> Boolean",
  "    visitString(o) up(as) -> Boolean",
  "    visitNum(o) up(as) -> Boolean",
  "    visitOp(o) up(as) -> Boolean",
  "    visitBind(o) up(as) -> Boolean",
  "    visitDefDec(o) up(as) -> Boolean",
  "    visitVarDec(o) up(as) -> Boolean",
  "    visitImport(o) up(as) -> Boolean",
  "    visitReturn(o) up(as) -> Boolean",
  "    visitInherits(o) up(as) -> Boolean",
  "    visitDialect(o) up(as) -> Boolean",
  "    visitComment(o) up(as) -> Boolean",
  "    visitImplicit(o) up(as) -> Boolean",
  "    visitOuter(o) up(as) -> Boolean",
  "}",
  "",
  "class baseVisitor -> AstVisitor {",
  "    method visitIf(o) up(as) { visitIf(o) }",
  "    method visitBlock(o) up(as) { visitBlock(o) }",
  "    method visitMatchCase(o) up(as) { visitMatchCase(o) }",
  "    method visitTryCatch(o) up(as) { visitTryCatch(o) }",
  "    method visitMethodType(o) up(as) { visitMethodType(o) }",
  "    method visitSignaturePart(o) up(as) { visitSignaturePart(o) }",
  "    method visitTypeDec(o) up(as) { visitTypeDec(o) }",
  "    method visitTypeLiteral(o) up(as) { visitTypeLiteral(o) }",
  "    method visitTypeParameters(o) up(as) { visitTypeParameters(o) }",
  "    method visitMethod(o) up(as) { visitMethod(o) }",
  "    method visitCall(o) up(as) { visitCall(o) }",
  "    method visitObject(o) up(as) { visitObject(o) }",
  "    method visitModule(o) up(as) { visitObject(o) }",
  "    method visitArray(o) up(as) { visitArray(o) }",
  "    method visitMember(o) up(as) { visitMember(o) }",
  "    method visitGeneric(o) up(as) { visitGeneric(o) }",
  "    method visitIdentifier(o) up(as) { visitIdentifier(o) }",
  "    method visitString(o) up(as) { visitString(o) }",
  "    method visitNum(o) up(as) { visitNum(o) }",
  "    method visitOp(o) up(as) { visitOp(o) }",
  "    method visitBind(o) up(as) { visitBind(o) }",
  "    method visitDefDec(o) up(as) { visitDefDec(o) }",
  "    method visitVarDec(o) up(as) { visitVarDec(o) }",
  "    method visitImport(o) up(as) { visitImport(o) }",
  "    method visitReturn(o) up(as) { visitReturn(o) }",
  "    method visitInherits(o) up(as) { visitInherits(o) }",
  "    method visitDialect(o) up(as) { visitDialect(o) }",
  "    method visitComment(o) up(as) { visitComment(o) }",
  "    method visitImplicit(o) up(as) { visitImplicit(o) }",
  "    method visitOuter(o) up(as) -> Boolean { visitOuter(o) }",
  "",
  "    method visitIf(o) -> Boolean { true }",
  "    method visitBlock(o) -> Boolean { true }",
  "    method visitMatchCase(o) -> Boolean { true }",
  "    method visitTryCatch(o) -> Boolean { true }",
  "    method visitMethodType(o) -> Boolean { true }",
  "    method visitSignaturePart(o) -> Boolean { true }",
  "    method visitTypeDec(o) -> Boolean { true }",
  "    method visitTypeLiteral(o) -> Boolean { true }",
  "    method visitTypeParameters(o) -> Boolean { true }",
  "    method visitMethod(o) -> Boolean { true }",
  "    method visitCall(o) -> Boolean { true }",
  "    method visitObject(o) -> Boolean { true }",
  "    method visitModule(o) -> Boolean { true }",
  "    method visitArray(o) -> Boolean { true }",
  "    method visitMember(o) -> Boolean { true }",
  "    method visitGeneric(o) -> Boolean { true }",
  "    method visitIdentifier(o) -> Boolean { true }",
  "    method visitString(o) -> Boolean { true }",
  "    method visitNum(o) -> Boolean { true }",
  "    method visitOp(o) -> Boolean { true }",
  "    method visitBind(o) -> Boolean { true }",
  "    method visitDefDec(o) -> Boolean { true }",
  "    method visitVarDec(o) -> Boolean { true }",
  "    method visitImport(o) -> Boolean { true }",
  "    method visitReturn(o) -> Boolean { true }",
  "    method visitInherits(o) -> Boolean { true }",
  "    method visitDialect(o) -> Boolean { true }",
  "    method visitComment(o) -> Boolean { true }",
  "    method visitImplicit(o) -> Boolean { true }",
  "    method visitOuter(o) -> Boolean { true }",
  "",
  "    method asString { \"an AST visitor\" }",
  "}",
  "",
  "class pluggableVisitor(visitation:Predicate2⟦AstNode, Object⟧) -> AstVisitor {",
  "    // Manufactures a default visitor, given a 2-parameter block.",
  "    // Typically, some of the methods will be overridden.",
  "    // The visitation predicate will be applied with the AST node as the first argument",
  "    // and the ancestor chain as the second, and should answer true if",
  "    // the visitation is to continue and false if it is to go no deeper.",
  "",
  "    method visitIf(o) up(as) { visitation.apply (o, as) }",
  "    method visitBlock(o) up(as) { visitation.apply (o, as) }",
  "    method visitMatchCase(o) up(as) { visitation.apply (o, as) }",
  "    method visitTryCatch(o) up(as) { visitation.apply (o, as) }",
  "    method visitMethodType(o) up(as) { visitation.apply (o, as) }",
  "    method visitSignaturePart(o) up(as) { visitation.apply (o, as) }",
  "    method visitTypeDec(o) up(as) { visitation.apply (o, as) }",
  "    method visitTypeLiteral(o) up(as) { visitation.apply (o, as) }",
  "    method visitMethod(o) up(as) { visitation.apply (o, as) }",
  "    method visitCall(o) up(as) { visitation.apply (o, as) }",
  "    method visitObject(o) up(as) { visitation.apply (o, as) }",
  "    method visitModule(o) up(as) { visitation.apply (o, as) }",
  "    method visitArray(o) up(as) { visitation.apply (o, as) }",
  "    method visitMember(o) up(as) { visitation.apply (o, as) }",
  "    method visitGeneric(o) up(as) { visitation.apply (o, as) }",
  "    method visitIdentifier(o) up(as) { visitation.apply (o, as) }",
  "    method visitString(o) up(as) { visitation.apply (o, as) }",
  "    method visitNum(o) up(as) { visitation.apply (o, as) }",
  "    method visitOp(o) up(as) { visitation.apply (o, as) }",
  "    method visitBind(o) up(as) { visitation.apply (o, as) }",
  "    method visitDefDec(o) up(as) { visitation.apply (o, as) }",
  "    method visitVarDec(o) up(as) { visitation.apply (o, as) }",
  "    method visitImport(o) up(as) { visitation.apply (o, as) }",
  "    method visitReturn(o) up(as) { visitation.apply (o, as) }",
  "    method visitInherits(o) up(as) { visitation.apply (o, as) }",
  "    method visitDialect(o) up(as) { visitation.apply (o, as) }",
  "    method visitComment(o) up(as) { visitation.apply (o, as) }",
  "    method visitImplicit(o) up(as) { visitation.apply (o, as) }",
  "    method visitOuter(o) up(as) { visitation.apply (o, as) }",
  "",
  "    method asString { \"a pluggable AST visitor\" }",
  "}",
  "",
  "",
  "def patternMarkVisitor = object {",
  "    inherit baseVisitor",
  "    method visitCall(c) up(as) {",
  "        c.isPattern := true",
  "        true",
  "    }",
  "}",
  "",
  "method findAnnotation(node, annName) {",
  "    for (node.annotations) do {ann->",
  "        if ((ann.kind == \"identifier\") && {",
  "            ann.value == annName }) then {",
  "            return object {",
  "                inherit true",
  "                def value is public = ann",
  "            }",
  "        }",
  "    }",
  "    false",
  "}",
  NULL
};
Object reader_ast_outer_3(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_line_4(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_column_5(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_outer_111(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_start_112(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_end_113(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_outer_353(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_register_354(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_ast_register_354(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_ast_line_355(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_line_355(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_linePos_356(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_linePos_356(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_symbolTable_357(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_symbolTable_357(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_comments_358(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_comments_358(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_786(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_787(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_theObjects_788(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_end_853(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[12];
}
Object reader_ast_outer_877(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1153(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1309(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1425(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_value_1426(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_outer_1455(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1458(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1476(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1558(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1559(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_nameString_1560(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_outer_1589(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1590(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_outer_1604(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_node_1605(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_ast_node_1605(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_ast_outer_1672(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1675(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1676(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_1677(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_1677(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_thenblock_1678(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_thenblock_1678(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_elseblock_1679(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_elseblock_1679(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_handledIdentifiers_1680(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_handledIdentifiers_1680(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_2016(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_2019(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_2020(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_2021(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_params_2022(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_params_2022(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_body_2023(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_body_2023(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_selfclosure_2024(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_matchingPattern_2025(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_matchingPattern_2025(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_extraRuntimeData_2026(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_extraRuntimeData_2026(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_outer_2481(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_2484(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_2485(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_2486(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_2486(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_cases_2487(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_cases_2487(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_finally_2488(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_finally_2488(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_2788(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_2791(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_2792(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_2793(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_2793(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_cases_2794(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_cases_2794(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_2986(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_2989(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_2990(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_signature_2991(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_signature_2991(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_rtype_2992(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_rtype_2992(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_typeParams_2993(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_typeParams_2993(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_cachedIdentifier_2994(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_cachedIdentifier_2994(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_3388(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_3391(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_3392(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_methods_3393(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_methods_3393(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_types_3394(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_types_3394(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_nominal_3395(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_nominal_3395(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_anonymous_3396(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_anonymous_3396(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_value_3397(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_value_3397(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_3689(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_3692(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_3693(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_3694(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_3694(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_3695(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_3695(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_parentKind_3696(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_parentKind_3696(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_nameString_3697(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_annotations_3698(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_annotations_3698(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_typeParams_3699(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_typeParams_3699(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_outer_3993(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_4001(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_4002(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_signature_4003(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_signature_4003(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_body_4004(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_body_4004(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_4005(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_4005(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_typeParams_4006(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_typeParams_4006(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_selfclosure_4007(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_selfclosure_4007(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_annotations_4008(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_annotations_4008(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_isFresh_4009(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_isFresh_4009(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_usesClassSyntax_4010(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object writer_ast_usesClassSyntax_4010(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[9] = args[0];
  return done;
}
Object reader_ast_cachedIdentifier_4011(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[10];
}
Object writer_ast_cachedIdentifier_4011(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[10] = args[0];
  return done;
}
Object reader_ast_isBindingOccurence_4012(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[11];
}
Object writer_ast_isBindingOccurence_4012(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[11] = args[0];
  return done;
}
Object reader_ast_outer_5187(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5195(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5196(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_parts_5197(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_parts_5197(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_generics_5198(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_generics_5198(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_isPattern_5199(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_isPattern_5199(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_receiver_5200(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_receiver_5200(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_isSelfRequest_5201(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_isSelfRequest_5201(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_isTailCall_5202(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_isTailCall_5202(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_isFresh_5203(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_isFresh_5203(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_cachedIdentifier_5204(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object writer_ast_cachedIdentifier_5204(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[9] = args[0];
  return done;
}
Object reader_ast_endPos_5205(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[10];
}
Object writer_ast_endPos_5205(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[10] = args[0];
  return done;
}
Object reader_ast_outer_5873(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5888(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5889(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_sourceLines_5890(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_theDialect_5891(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_theDialect_5891(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_imports_5892(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_imports_5892(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_6111(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6125(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6126(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6127(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_6127(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_superclass_6128(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_superclass_6128(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_usedTraits_6129(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_usedTraits_6129(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_name_6130(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_name_6130(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_inClass_6131(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_inClass_6131(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_inTrait_6132(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_inTrait_6132(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_myLocalNames_6133(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_myLocalNames_6133(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_annotations_6134(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object writer_ast_annotations_6134(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[9] = args[0];
  return done;
}
Object reader_ast_outer_6738(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6741(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6742(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6743(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_6743(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_6878(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6886(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6887(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6888(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_6888(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_receiver_6889(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_receiver_6889(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_generics_6890(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_generics_6890(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_isSelfRequest_6891(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_isSelfRequest_6891(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_isTailCall_6892(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_isTailCall_6892(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_7265(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7268(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7269(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7270(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_7270(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_args_7271(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_args_7271(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_7428(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7431(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7432(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_params_7433(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_params_7433(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_7587(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_wildcardCount_7593(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_wildcardCount_7593(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_7628(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7629(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7630(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_7630(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_wildcard_7631(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_wildcard_7631(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_7632(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_7632(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_isBindingOccurrence_7633(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_isBindingOccurrence_7633(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_isAssigned_7634(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_isAssigned_7634(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_inRequest_7635(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_inRequest_7635(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_generics_7636(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_generics_7636(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_isDeclaredByParent_7637(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object writer_ast_isDeclaredByParent_7637(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[9] = args[0];
  return done;
}
Object reader_ast_end_7638(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[10];
}
Object writer_ast_end_7638(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[10] = args[0];
  return done;
}
Object reader_ast_canonicalName_7665(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[14];
}
Object writer_ast_canonicalName_7665(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[14] = args[0];
  return done;
}
Object reader_ast_outer_8100(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_8108(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_8109(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_8110(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_8110(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_end_8111(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_end_8111(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_8205(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_8208(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_8209(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_8210(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_8210(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_8276(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_8279(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_8280(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_8281(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_left_8282(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_left_8282(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_right_8283(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_right_8283(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_isTailCall_8284(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_isTailCall_8284(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_isSelfRequest_8285(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_isSelfRequest_8285(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_8625(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_8628(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_8629(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_dest_8630(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_dest_8630(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_8631(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_8631(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_8793(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_8801(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_8802(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_8803(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_8803(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_8804(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_8804(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_8805(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_8805(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_parentKind_8806(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_parentKind_8806(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_nameString_8807(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object reader_ast_annotations_8808(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_annotations_8808(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_startToken_8809(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_startToken_8809(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_outer_9226(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9229(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9230(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_9231(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_9231(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_9232(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_9232(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_9233(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_9233(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_parentKind_9234(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_parentKind_9234(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_nameString_9235(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object reader_ast_annotations_9236(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_annotations_9236(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_outer_9677(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9680(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9681(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_9682(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_9682(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_path_9683(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_path_9683(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_annotations_9684(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_annotations_9684(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_dtype_9685(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_dtype_9685(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_9935(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9960(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9961(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_9962(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_9962(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_end_9963(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_end_9963(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_10068(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_10071(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_10072(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_10073(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_10073(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_dtype_10074(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_dtype_10074(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_10228(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_10236(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_10237(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_10238(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_10238(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_providedNames_10239(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_providedNames_10239(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_aliases_10240(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_aliases_10240(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_exclusions_10241(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_exclusions_10241(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_isUse_10242(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_isUse_10242(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_10612(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_10635(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_10636(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_10637(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_10637(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_params_10638(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_params_10638(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_typeParams_10639(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_typeParams_10639(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_lineLength_10640(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_lineLength_10640(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_10977(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_10994(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_10995(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_10996(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_10996(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_args_10997(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_args_10997(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_typeArgs_10998(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_typeArgs_10998(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_lineLength_10999(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_lineLength_10999(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_11347(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_11350(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_11351(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_11352(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_11352(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_isPartialLine_11353(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_isPartialLine_11353(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_isPreceededByBlankLine_11354(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_isPreceededByBlankLine_11354(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_endLine_11355(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_endLine_11355(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_11556(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
static ClassData objclass2;
static Object strlit90;
static Object strlit97;
static Object strlit103;
static ClassData objclass110;
static Object strlit128;
static Object strlit137;
static Object strlit143;
static Object strlit161;
static Object strlit168;
static Object strlit174;
static ClassData objclass352;
static Object strlit505;
static Object strlit512;
static Object strlit518;
static Object strlit524;
static Object strlit594;
static Object strlit601;
static Object strlit617;
static Object strlit626;
static Object strlit633;
static Object strlit642;
static Object strlit647;
static Object strlit654;
static Object strlit660;
static Object strlit675;
static Object strlit683;
static Object strlit690;
static Object strlit696;
static Object strlit702;
static Object strlit711;
static Object strlit718;
static Object strlit724;
static Object strlit777;
static ClassData objclass785;
static Object strlit796;
static Object strlit806;
static Object strlit832;
static Object strlit835;
static Object strlit856;
static ClassData objclass876;
static Object strlit882;
static Object strlit889;
static Object strlit895;
static Object strlit907;
static Object strlit910;
static Object strlit917;
static Object strlit924;
static Object strlit928;
static Object strlit969;
static Object strlit1003;
static Object strlit1010;
static Object strlit1044;
static Object strlit1063;
static Object strlit1093;
static Object strlit1122;
static Object strlit1147;
static ClassData objclass1152;
static Object strlit1305;
static ClassData objclass1308;
static Object strlit1398;
static Object strlit1418;
static ClassData objclass1424;
Object module_util;
Object module_util_init();
Object module_identifierKinds;
Object module_identifierKinds_init();
static Object strlit1449;
static ClassData objclass1454;
static ClassData objclass1457;
static Object strlit1462;
static ClassData objclass1475;
static Object strlit1487;
static Object strlit1499;
static Object strlit1514;
static ClassData objclass1557;
static Object strlit1565;
static Object strlit1567;
static Object strlit1576;
static Object strlit1585;
static Object strlit1586;
static ClassData objclass1588;
static Object strlit1592;
static Object strlit1595;
static Object strlit1601;
static ClassData objclass1603;
static Object strlit1607;
static Object strlit1611;
static Object strlit1616;
static Object strlit1621;
static Object strlit1627;
static Object strlit1640;
static Object strlit1644;
static Object strlit1653;
static Object strlit1659;
static Object strlit1666;
static ClassData objclass1671;
static ClassData objclass1674;
static Object strlit1738;
static Object strlit1741;
static Object strlit1762;
static Object strlit1768;
static Object strlit1775;
static Object strlit1787;
static Object strlit1798;
static Object strlit1810;
static Object strlit1820;
static Object strlit1845;
static Object strlit1854;
static Object strlit1859;
static Object strlit1884;
static Object strlit1895;
static Object strlit1898;
static Object strlit1907;
static Object strlit1926;
static Object strlit1931;
static Object strlit1946;
static Object strlit1951;
static Object strlit1973;
static Object strlit1978;
static Object strlit1988;
static Object strlit1993;
static Object strlit2011;
static ClassData objclass2015;
static ClassData objclass2018;
static Object strlit2121;
static Object strlit2126;
static Object strlit2201;
static Object strlit2204;
static Object strlit2210;
static Object strlit2233;
static Object strlit2242;
static Object strlit2247;
static Object strlit2270;
static Object strlit2286;
static Object strlit2291;
static Object strlit2311;
static Object strlit2320;
static Object strlit2322;
static Object strlit2333;
static Object strlit2356;
static Object strlit2364;
static Object strlit2386;
static Object strlit2391;
static Object strlit2413;
static Object strlit2422;
static Object strlit2434;
static Object strlit2441;
static Object strlit2464;
static Object strlit2465;
static ClassData objclass2480;
static ClassData objclass2483;
static Object strlit2582;
static Object strlit2585;
static Object strlit2591;
static Object strlit2616;
static Object strlit2627;
static Object strlit2632;
static Object strlit2636;
static Object strlit2657;
static Object strlit2670;
static Object strlit2675;
static Object strlit2679;
static Object strlit2692;
static Object strlit2695;
static Object strlit2707;
static Object strlit2724;
static Object strlit2727;
static Object strlit2732;
static Object strlit2760;
static Object strlit2763;
static Object strlit2768;
static Object strlit2784;
static ClassData objclass2787;
static ClassData objclass2790;
static Object strlit2863;
static Object strlit2866;
static Object strlit2893;
static Object strlit2904;
static Object strlit2909;
static Object strlit2913;
static Object strlit2928;
static Object strlit2931;
static Object strlit2940;
static Object strlit2957;
static Object strlit2960;
static Object strlit2965;
static Object strlit2982;
static ClassData objclass2985;
static ClassData objclass2988;
static Object strlit3023;
static Object strlit3037;
static Object strlit3188;
static Object strlit3191;
static Object strlit3197;
static Object strlit3204;
static Object strlit3209;
static Object strlit3213;
static Object strlit3229;
static Object strlit3242;
static Object strlit3247;
static Object strlit3252;
static Object strlit3256;
static Object strlit3274;
static Object strlit3279;
static Object strlit3283;
static Object strlit3302;
static Object strlit3307;
static Object strlit3311;
static Object strlit3323;
static Object strlit3334;
static Object strlit3339;
static Object strlit3343;
static Object strlit3354;
static Object strlit3383;
static ClassData objclass3387;
static ClassData objclass3390;
static Object strlit3409;
static Object strlit3416;
static Object strlit3422;
static Object strlit3456;
static Object strlit3510;
static Object strlit3513;
static Object strlit3519;
static Object strlit3542;
static Object strlit3551;
static Object strlit3556;
static Object strlit3578;
static Object strlit3587;
static Object strlit3594;
static Object strlit3596;
static Object strlit3598;
static Object strlit3616;
static Object strlit3621;
static Object strlit3644;
static Object strlit3649;
static Object strlit3659;
static Object strlit3682;
static Object strlit3685;
static ClassData objclass3688;
static ClassData objclass3691;
static Object strlit3731;
static Object strlit3815;
static Object strlit3818;
static Object strlit3824;
static Object strlit3850;
static Object strlit3863;
static Object strlit3868;
static Object strlit3872;
static Object strlit3881;
static Object strlit3901;
static Object strlit3927;
static Object strlit3929;
static Object strlit3931;
static Object strlit3937;
static Object strlit3964;
static Object strlit3982;
static Object strlit3983;
static ClassData objclass3992;
static ClassData objclass4000;
static Object strlit4031;
static Object strlit4047;
static Object strlit4054;
static Object strlit4160;
static Object strlit4235;
static Object strlit4319;
static Object strlit4365;
static Object strlit4416;
static Object strlit4540;
static Object strlit4543;
static Object strlit4549;
static Object strlit4562;
static Object strlit4579;
static Object strlit4584;
static Object strlit4594;
static Object strlit4615;
static Object strlit4626;
static Object strlit4634;
static Object strlit4639;
static Object strlit4643;
static Object strlit4655;
static Object strlit4662;
static Object strlit4667;
static Object strlit4671;
static Object strlit4680;
static Object strlit4685;
static Object strlit4689;
static Object strlit4701;
static Object strlit4712;
static Object strlit4717;
static Object strlit4721;
static Object strlit4734;
static Object strlit4746;
static Object strlit4751;
static Object strlit4755;
static Object strlit4765;
static Object strlit4773;
static Object strlit4778;
static Object strlit4782;
static Object strlit4795;
static Object strlit4809;
static Object strlit4814;
static Object strlit4818;
static Object strlit4830;
static Object strlit4841;
static Object strlit4846;
static Object strlit4850;
static Object strlit4861;
static Object strlit4866;
static Object strlit4889;
static Object strlit4919;
static Object strlit4921;
static Object strlit4971;
static Object strlit5005;
static Object strlit5012;
static Object strlit5027;
static Object strlit5036;
static Object strlit5052;
static Object strlit5067;
static Object strlit5071;
static Object strlit5074;
static Object strlit5077;
static Object strlit5085;
static Object strlit5122;
static Object strlit5127;
static Object strlit5137;
static Object strlit5142;
static Object strlit5177;
static ClassData objclass5186;
static ClassData objclass5194;
static Object strlit5219;
static Object strlit5228;
static Object strlit5235;
static Object strlit5248;
static Object strlit5259;
static Object strlit5266;
static Object strlit5285;
static Object strlit5307;
static Object strlit5321;
static Object strlit5341;
static Object strlit5362;
static Object strlit5521;
static Object strlit5529;
static Object strlit5530;
static Object strlit5536;
static Object strlit5548;
static Object strlit5559;
static Object strlit5565;
static Object strlit5582;
static Object strlit5595;
static Object strlit5606;
static Object strlit5618;
static Object strlit5641;
static Object strlit5663;
static Object strlit5673;
static Object strlit5677;
static Object strlit5682;
static Object strlit5696;
static Object strlit5708;
static Object strlit5713;
static Object strlit5725;
static Object strlit5746;
static Object strlit5769;
static Object strlit5776;
static Object strlit5820;
static Object strlit5827;
static Object strlit5861;
static Object strlit5864;
static ClassData objclass5872;
static ClassData objclass5887;
static Object strlit5928;
static Object strlit6019;
static Object strlit6023;
static Object strlit6033;
static Object strlit6037;
static Object strlit6044;
static Object strlit6095;
static Object strlit6099;
static ClassData objclass6110;
static ClassData objclass6124;
static Object strlit6144;
static Object strlit6177;
static Object strlit6182;
static Object strlit6191;
static Object strlit6197;
static Object strlit6204;
static Object strlit6210;
static Object strlit6386;
static Object strlit6392;
static Object strlit6398;
static Object strlit6435;
static Object strlit6440;
static Object strlit6447;
static Object strlit6452;
static Object strlit6456;
static Object strlit6482;
static Object strlit6487;
static Object strlit6502;
static Object strlit6507;
static Object strlit6517;
static Object strlit6528;
static Object strlit6533;
static Object strlit6537;
static Object strlit6563;
static Object strlit6576;
static Object strlit6578;
static Object strlit6583;
static Object strlit6591;
static Object strlit6613;
static Object strlit6630;
static Object strlit6651;
static Object strlit6656;
static Object strlit6668;
static Object strlit6673;
static Object strlit6720;
static Object strlit6728;
static Object strlit6730;
static ClassData objclass6737;
static ClassData objclass6740;
static Object strlit6751;
static Object strlit6756;
static Object strlit6799;
static Object strlit6819;
static Object strlit6828;
static Object strlit6856;
static Object strlit6863;
static Object strlit6874;
static ClassData objclass6877;
static ClassData objclass6885;
static Object strlit7027;
static Object strlit7035;
static Object strlit7036;
static Object strlit7041;
static Object strlit7048;
static Object strlit7073;
static Object strlit7078;
static Object strlit7095;
static Object strlit7100;
static Object strlit7115;
static Object strlit7131;
static Object strlit7151;
static Object strlit7171;
static Object strlit7201;
static Object strlit7208;
static Object strlit7242;
static Object strlit7258;
static ClassData objclass7264;
static ClassData objclass7267;
static Object strlit7274;
static Object strlit7331;
static Object strlit7340;
static Object strlit7346;
static Object strlit7368;
static Object strlit7377;
static Object strlit7382;
static Object strlit7401;
static Object strlit7410;
static Object strlit7424;
static ClassData objclass7427;
static ClassData objclass7430;
static Object strlit7443;
static Object strlit7444;
static Object strlit7497;
static Object strlit7500;
static Object strlit7525;
static Object strlit7534;
static Object strlit7538;
static Object strlit7543;
static Object strlit7550;
static Object strlit7554;
static Object strlit7564;
static Object strlit7573;
static Object strlit7583;
static ClassData objclass7586;
static Object strlit7605;
static Object strlit7611;
static ClassData objclass7627;
static Object strlit7678;
static Object strlit7685;
static Object strlit7692;
static Object strlit7699;
static Object strlit7777;
static Object strlit7785;
static Object strlit7794;
static Object strlit7800;
static Object strlit7808;
static Object strlit7814;
static Object strlit7828;
static Object strlit7833;
static Object strlit7859;
static Object strlit7864;
static Object strlit7884;
static Object strlit7889;
static Object strlit7902;
static Object strlit7925;
static Object strlit7938;
static Object strlit7958;
static Object strlit7978;
static Object strlit8000;
static Object strlit8006;
static Object strlit8010;
static Object strlit8016;
static Object strlit8058;
static Object strlit8061;
static Object strlit8091;
static Object strlit8096;
static ClassData objclass8099;
static ClassData objclass8107;
static Object strlit8124;
static Object strlit8131;
static Object strlit8137;
static Object strlit8143;
static Object strlit8156;
static Object strlit8163;
static Object strlit8179;
static Object strlit8186;
static ClassData objclass8204;
static ClassData objclass8207;
static Object strlit8223;
static Object strlit8230;
static Object strlit8236;
static Object strlit8248;
static Object strlit8254;
static Object strlit8265;
static Object strlit8272;
static ClassData objclass8275;
static ClassData objclass8278;
static Object strlit8313;
static Object strlit8320;
static Object strlit8398;
static Object strlit8401;
static Object strlit8408;
static Object strlit8414;
static Object strlit8420;
static Object strlit8440;
static Object strlit8460;
static Object strlit8477;
static Object strlit8486;
static Object strlit8495;
static Object strlit8507;
static Object strlit8519;
static Object strlit8526;
static Object strlit8548;
static Object strlit8557;
static Object strlit8567;
static Object strlit8619;
static ClassData objclass8624;
static ClassData objclass8627;
static Object strlit8639;
static Object strlit8646;
static Object strlit8655;
static Object strlit8661;
static Object strlit8704;
static Object strlit8707;
static Object strlit8728;
static Object strlit8750;
static Object strlit8771;
static Object strlit8786;
static Object strlit8789;
static ClassData objclass8792;
static ClassData objclass8800;
static Object strlit8828;
static Object strlit8832;
static Object strlit8932;
static Object strlit8935;
static Object strlit8969;
static Object strlit8974;
static Object strlit8999;
static Object strlit9004;
static Object strlit9020;
static Object strlit9024;
static Object strlit9034;
static Object strlit9045;
static Object strlit9049;
static Object strlit9081;
static Object strlit9084;
static Object strlit9093;
static Object strlit9101;
static Object strlit9125;
static Object strlit9140;
static Object strlit9155;
static Object strlit9159;
static Object strlit9162;
static Object strlit9165;
static Object strlit9186;
static Object strlit9212;
static Object strlit9215;
static Object strlit9216;
static ClassData objclass9225;
static ClassData objclass9228;
static Object strlit9290;
static Object strlit9294;
static Object strlit9309;
static Object strlit9314;
static Object strlit9331;
static Object strlit9336;
static Object strlit9430;
static Object strlit9433;
static Object strlit9461;
static Object strlit9466;
static Object strlit9492;
static Object strlit9497;
static Object strlit9537;
static Object strlit9540;
static Object strlit9549;
static Object strlit9557;
static Object strlit9581;
static Object strlit9596;
static Object strlit9611;
static Object strlit9615;
static Object strlit9618;
static Object strlit9621;
static Object strlit9642;
static Object strlit9664;
static Object strlit9667;
static Object strlit9668;
static ClassData objclass9676;
static ClassData objclass9679;
static Object strlit9718;
static Object strlit9722;
static Object strlit9725;
static Object strlit9733;
static Object strlit9736;
static Object strlit9820;
static Object strlit9823;
static Object strlit9830;
static Object strlit9837;
static Object strlit9841;
static Object strlit9851;
static Object strlit9858;
static Object strlit9862;
static Object strlit9881;
static Object strlit9888;
static Object strlit9892;
static Object strlit9902;
static Object strlit9909;
static Object strlit9915;
static Object strlit9930;
static ClassData objclass9934;
static ClassData objclass9959;
static Object strlit9971;
static Object strlit9979;
static Object strlit9982;
static Object strlit10010;
static Object strlit10013;
static Object strlit10020;
static Object strlit10027;
static Object strlit10031;
static Object strlit10041;
static Object strlit10047;
static Object strlit10064;
static ClassData objclass10067;
static ClassData objclass10070;
static Object strlit10136;
static Object strlit10139;
static Object strlit10167;
static Object strlit10177;
static Object strlit10181;
static Object strlit10194;
static Object strlit10223;
static ClassData objclass10227;
static ClassData objclass10235;
static Object strlit10322;
static Object strlit10330;
static Object strlit10334;
static Object strlit10351;
static Object strlit10361;
static Object strlit10368;
static Object strlit10372;
static Object strlit10390;
static Object strlit10395;
static Object strlit10399;
static Object strlit10409;
static Object strlit10414;
static Object strlit10418;
static Object strlit10437;
static Object strlit10448;
static Object strlit10452;
static Object strlit10461;
static Object strlit10466;
static Object strlit10476;
static Object strlit10477;
static Object strlit10494;
static Object strlit10499;
static Object strlit10503;
static Object strlit10517;
static Object strlit10524;
static Object strlit10528;
static Object strlit10549;
static Object strlit10550;
static Object strlit10596;
static Object strlit10597;
static Object strlit10600;
static ClassData objclass10611;
static Object strlit10615;
static ClassData objclass10634;
static Object strlit10650;
static Object strlit10666;
static Object strlit10705;
static Object strlit10714;
static Object strlit10729;
static Object strlit10734;
static Object strlit10742;
static Object strlit10751;
static Object strlit10756;
static Object strlit10818;
static Object strlit10821;
static Object strlit10828;
static Object strlit10834;
static Object strlit10847;
static Object strlit10852;
static Object strlit10856;
static Object strlit10868;
static Object strlit10879;
static Object strlit10884;
static Object strlit10888;
static Object strlit10909;
static Object strlit10927;
static Object strlit10936;
static Object strlit10960;
static Object strlit10966;
static Object strlit10971;
static ClassData objclass10976;
static Object strlit10980;
static ClassData objclass10993;
static Object strlit11022;
static Object strlit11060;
static Object strlit11069;
static Object strlit11088;
static Object strlit11093;
static Object strlit11101;
static Object strlit11110;
static Object strlit11115;
static Object strlit11142;
static Object strlit11145;
static Object strlit11152;
static Object strlit11158;
static Object strlit11164;
static Object strlit11169;
static Object strlit11173;
static Object strlit11185;
static Object strlit11196;
static Object strlit11201;
static Object strlit11205;
static Object strlit11228;
static Object strlit11249;
static Object strlit11258;
static Object strlit11292;
static Object strlit11293;
static Object strlit11310;
static Object strlit11320;
static Object strlit11339;
static Object strlit11342;
static ClassData objclass11346;
static ClassData objclass11349;
static Object strlit11377;
static Object strlit11384;
static Object strlit11391;
static Object strlit11397;
static Object strlit11411;
static Object strlit11433;
static Object strlit11442;
static Object strlit11451;
static Object strlit11452;
static Object strlit11454;
static Object strlit11461;
static Object strlit11468;
static Object strlit11475;
static Object strlit11480;
static Object strlit11484;
static Object strlit11500;
static Object strlit11506;
static Object strlit11511;
static Object strlit11517;
static Object strlit11545;
static ClassData objclass11555;
Object meth_ast_6__62__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, ">(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method >(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for >(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part >(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 34
  setline(34);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call10 = callmethodflags(*var_other, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9);
// compiled member node returning call10 (depth = 4)
  int op_slot_right_8 = gc_frame_newslot(call10);
// starting to compile member node (depth = 4)
  int callframe12 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call13 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe12);
// compiled member node returning call13 (depth = 4)
  int op_slot_left_8 = gc_frame_newslot(call13);
  params[0] = call10;
  partcv[0] = 1;
  Object opresult14 = callmethod(call13, ">(1)", 1, partcv, params);
// compiled op node returning opresult14 (depth = 3)
  Object if7 = done;
  if (istrue(opresult14)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool15 = alloc_Boolean(1);
// compiled identifier node returning bool15 (depth = 4)
  return bool15;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if7 = undefined;
  } else {
  }
// compiled if node returning if7 (depth = 2)
// Begin line 35
  setline(35);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe18 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call19 = callmethodflags(*var_other, "line", 1, partcv, params, 0);
  gc_frame_end(callframe18);
// compiled member node returning call19 (depth = 4)
  int op_slot_right_17 = gc_frame_newslot(call19);
// starting to compile member node (depth = 4)
  int callframe21 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call22 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe21);
// compiled member node returning call22 (depth = 4)
  int op_slot_left_17 = gc_frame_newslot(call22);
  params[0] = call19;
  partcv[0] = 1;
  Object opresult23 = callmethod(call22, "<(1)", 1, partcv, params);
// compiled op node returning opresult23 (depth = 3)
  Object if16 = done;
  if (istrue(opresult23)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool24 = alloc_Boolean(0);
// compiled identifier node returning bool24 (depth = 4)
  return bool24;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if16 = undefined;
  } else {
  }
// compiled if node returning if16 (depth = 2)
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe26 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  partcv[0] = 0;
  Object call27 = callmethodflags(*var_other, "column", 1, partcv, params, 0);
  gc_frame_end(callframe26);
// compiled member node returning call27 (depth = 3)
  int op_slot_right_25 = gc_frame_newslot(call27);
// starting to compile member node (depth = 3)
  int callframe29 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call30 = callmethodflags(self, "column", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe29);
// compiled member node returning call30 (depth = 3)
  int op_slot_left_25 = gc_frame_newslot(call30);
  params[0] = call27;
  partcv[0] = 1;
  Object opresult31 = callmethod(call30, ">(1)", 1, partcv, params);
// compiled op node returning opresult31 (depth = 2)
  gc_frame_end(frame);
  return opresult31;
}
Object meth_ast_32__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa5_34__34__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, """\xe2""""\x89""""\xa5""(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ≥(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ≥(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ≥(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe35 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call36 = callmethodflags(*var_other, "line", 1, partcv, params, 0);
  gc_frame_end(callframe35);
// compiled member node returning call36 (depth = 4)
  int op_slot_right_34 = gc_frame_newslot(call36);
// starting to compile member node (depth = 4)
  int callframe38 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call39 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe38);
// compiled member node returning call39 (depth = 4)
  int op_slot_left_34 = gc_frame_newslot(call39);
  params[0] = call36;
  partcv[0] = 1;
  Object opresult40 = callmethod(call39, ">(1)", 1, partcv, params);
// compiled op node returning opresult40 (depth = 3)
  Object if33 = done;
  if (istrue(opresult40)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool41 = alloc_Boolean(1);
// compiled identifier node returning bool41 (depth = 4)
  return bool41;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if33 = undefined;
  } else {
  }
// compiled if node returning if33 (depth = 2)
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe44 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call45 = callmethodflags(*var_other, "line", 1, partcv, params, 0);
  gc_frame_end(callframe44);
// compiled member node returning call45 (depth = 4)
  int op_slot_right_43 = gc_frame_newslot(call45);
// starting to compile member node (depth = 4)
  int callframe47 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call48 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe47);
// compiled member node returning call48 (depth = 4)
  int op_slot_left_43 = gc_frame_newslot(call48);
  params[0] = call45;
  partcv[0] = 1;
  Object opresult49 = callmethod(call48, "<(1)", 1, partcv, params);
// compiled op node returning opresult49 (depth = 3)
  Object if42 = done;
  if (istrue(opresult49)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool50 = alloc_Boolean(0);
// compiled identifier node returning bool50 (depth = 4)
  return bool50;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if42 = undefined;
  } else {
  }
// compiled if node returning if42 (depth = 2)
// Begin line 41
  setline(41);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe52 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  partcv[0] = 0;
  Object call53 = callmethodflags(*var_other, "column", 1, partcv, params, 0);
  gc_frame_end(callframe52);
// compiled member node returning call53 (depth = 3)
  int op_slot_right_51 = gc_frame_newslot(call53);
// starting to compile member node (depth = 3)
  int callframe55 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call56 = callmethodflags(self, "column", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe55);
// compiled member node returning call56 (depth = 3)
  int op_slot_left_51 = gc_frame_newslot(call56);
  params[0] = call53;
  partcv[0] = 1;
  Object opresult57 = callmethod(call56, "≥(1)", 1, partcv, params);
// compiled op node returning opresult57 (depth = 2)
  gc_frame_end(frame);
  return opresult57;
}
Object meth_ast_58__61__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 44
  setline(44);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe61 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call62 = callmethodflags(*var_other, "column", 1, partcv, params, 0);
  gc_frame_end(callframe61);
// compiled member node returning call62 (depth = 4)
  int op_slot_right_60 = gc_frame_newslot(call62);
// starting to compile member node (depth = 4)
  int callframe64 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call65 = callmethodflags(self, "column", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe64);
// compiled member node returning call65 (depth = 4)
  int op_slot_left_60 = gc_frame_newslot(call65);
  params[0] = call62;
  partcv[0] = 1;
  Object opresult66 = callmethod(call65, "==(1)", 1, partcv, params);
// compiled op node returning opresult66 (depth = 3)
  int op_slot_right_59 = gc_frame_newslot(opresult66);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe69 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call70 = callmethodflags(*var_other, "line", 1, partcv, params, 0);
  gc_frame_end(callframe69);
// compiled member node returning call70 (depth = 4)
  int op_slot_right_68 = gc_frame_newslot(call70);
// starting to compile member node (depth = 4)
  int callframe72 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call73 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe72);
// compiled member node returning call73 (depth = 4)
  int op_slot_left_68 = gc_frame_newslot(call73);
  params[0] = call70;
  partcv[0] = 1;
  Object opresult74 = callmethod(call73, "==(1)", 1, partcv, params);
// compiled op node returning opresult74 (depth = 3)
  int op_slot_left_59 = gc_frame_newslot(opresult74);
  params[0] = opresult66;
  partcv[0] = 1;
  Object opresult75 = callmethod(opresult74, "&&(1)", 1, partcv, params);
// compiled op node returning opresult75 (depth = 2)
  gc_frame_end(frame);
  return opresult75;
}
Object meth_ast_76__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa4_34__34__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, """\xe2""""\x89""""\xa4""(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ≤(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ≤(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ≤(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 47
  setline(47);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe77 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  int op_slot_right_78 = gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  int op_slot_left_78 = gc_frame_newslot(*var_other);
  params[0] = self;
  partcv[0] = 1;
  Object opresult80 = callmethod(*var_other, ">(1)", 1, partcv, params);
// compiled op node returning opresult80 (depth = 3)
  partcv[0] = 0;
  Object call81 = callmethodflags(opresult80, "not", 1, partcv, params, 0);
  gc_frame_end(callframe77);
// compiled member node returning call81 (depth = 2)
  gc_frame_end(frame);
  return call81;
}
Object meth_ast_82__60__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "<(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method <(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for <(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part <(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 50
  setline(50);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe83 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  int op_slot_right_84 = gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  int op_slot_left_84 = gc_frame_newslot(*var_other);
  params[0] = self;
  partcv[0] = 1;
  Object opresult86 = callmethod(*var_other, "≥(1)", 1, partcv, params);
// compiled op node returning opresult86 (depth = 3)
  partcv[0] = 0;
  Object call87 = callmethodflags(opresult86, "not", 1, partcv, params, 0);
  gc_frame_end(callframe83);
// compiled member node returning call87 (depth = 2)
  gc_frame_end(frame);
  return call87;
}
Object meth_ast_88_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 52
  setline(52);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit90 == NULL) {
    strlit90 = alloc_String("");
    gc_root(strlit90);
  }
// compiled string node returning strlit90 (depth = 3)
  int op_slot_right_89 = gc_frame_newslot(strlit90);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe93 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call94 = callmethodflags(self, "column", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe93);
// compiled member node returning call94 (depth = 4)
  int op_slot_right_92 = gc_frame_newslot(call94);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit97 == NULL) {
    strlit97 = alloc_String(":");
    gc_root(strlit97);
  }
// compiled string node returning strlit97 (depth = 5)
  int op_slot_right_96 = gc_frame_newslot(strlit97);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe100 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call101 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe100);
// compiled member node returning call101 (depth = 6)
  int op_slot_right_99 = gc_frame_newslot(call101);
// starting to compile string node (depth = 6)
  if (strlit103 == NULL) {
    strlit103 = alloc_String("");
    gc_root(strlit103);
  }
// compiled string node returning strlit103 (depth = 6)
  int op_slot_left_99 = gc_frame_newslot(strlit103);
  params[0] = call101;
  partcv[0] = 1;
  Object opresult104 = callmethod(strlit103, "++(1)", 1, partcv, params);
// compiled op node returning opresult104 (depth = 5)
  int op_slot_left_96 = gc_frame_newslot(opresult104);
  params[0] = strlit97;
  partcv[0] = 1;
  Object opresult105 = callmethod(opresult104, "++(1)", 1, partcv, params);
// compiled op node returning opresult105 (depth = 4)
  int op_slot_left_92 = gc_frame_newslot(opresult105);
  params[0] = call94;
  partcv[0] = 1;
  Object opresult106 = callmethod(opresult105, "++(1)", 1, partcv, params);
// compiled op node returning opresult106 (depth = 3)
  int op_slot_left_89 = gc_frame_newslot(opresult106);
  params[0] = strlit90;
  partcv[0] = 1;
  Object opresult107 = callmethod(opresult106, "++(1)", 1, partcv, params);
// compiled op node returning opresult107 (depth = 2)
  gc_frame_end(frame);
  return opresult107;
}
Object meth_ast_1_line_40_1_41_column_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "line(1)column(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method line(_)column(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method line(_)column(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for line(_)column(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part line(_)");
  Object *var_c = &(stackframe->slots[1]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part column(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2 = alloc_userobj2(8,9, objclass2);
  gc_frame_newslot(obj2);
  if (objclass2 == NULL) {
    glfree(obj2->class->name);
    obj2->class->name = "line(_)column(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2, self, 0);
  addmethodreal(obj2,"outer", &reader_ast_outer_3);
  Object oldself2 = self;
  struct StackFrameObject *oldstackframe2 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2);
  gc_frame_newslot((Object)stackframe);
  self = obj2;
  Object *oldselfslot2 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2 = (*(struct UserObject *)self).data[0], lowerouter2 = thisouter2;
  if (inheritingObject2) {
    struct UserObject *inho2 = (struct UserObject *)inheritingObject2;
    while (inho2->super != GraceDefaultObject) inho2 = (struct UserObject *)inho2->super;
    inho2->super = obj2;
    self = inheritingObject2;
    *selfslot = self;
    lowerouter2 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2;
  }
  if (objclass2 == NULL) {
  Method *reader4 = addmethodrealflags(obj2, "line",&reader_ast_line_4, MFLAG_DEF);
  reader4->definitionModule = modulename;
  reader4->definitionLine = 31;
  }
  adddatum2(obj2, alloc_Undefined(), 1);
  if (objclass2 == NULL) {
  Method *reader5 = addmethodrealflags(obj2, "column",&reader_ast_column_5, MFLAG_DEF);
  reader5->definitionModule = modulename;
  reader5->definitionLine = 32;
  }
  adddatum2(obj2, alloc_Undefined(), 2);
// method ">(_)"
  struct UserObject *uo6 = (struct UserObject*)obj2;
  uo6->data[3] = emptyclosure;
  Method *meth_meth_ast_6__62__40_1_41_ = addmethod2pos(obj2, ">(1)", &meth_ast_6__62__40_1_41_, 3);
  int argcv_meth_ast_6__62__40_1_41_[] = {1};
  meth_meth_ast_6__62__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6__62__40_1_41_);
  meth_meth_ast_6__62__40_1_41_->definitionModule = modulename;
  meth_meth_ast_6__62__40_1_41_->definitionLine = 33;
// method "≥(_)"
  struct UserObject *uo32 = (struct UserObject*)obj2;
  uo32->data[4] = emptyclosure;
  Method *meth_meth_ast_32__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa5_34__34__40_1_41_ = addmethod2pos(obj2, """\xe2""""\x89""""\xa5""(1)", &meth_ast_32__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa5_34__34__40_1_41_, 4);
  int argcv_meth_ast_32__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa5_34__34__40_1_41_[] = {1};
  meth_meth_ast_32__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa5_34__34__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_32__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa5_34__34__40_1_41_);
  meth_meth_ast_32__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa5_34__34__40_1_41_->definitionModule = modulename;
  meth_meth_ast_32__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa5_34__34__40_1_41_->definitionLine = 38;
// method "==(_)"
  struct UserObject *uo58 = (struct UserObject*)obj2;
  uo58->data[5] = emptyclosure;
  Method *meth_meth_ast_58__61__61__40_1_41_ = addmethod2pos(obj2, "==(1)", &meth_ast_58__61__61__40_1_41_, 5);
  int argcv_meth_ast_58__61__61__40_1_41_[] = {1};
  meth_meth_ast_58__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_58__61__61__40_1_41_);
  meth_meth_ast_58__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_58__61__61__40_1_41_->definitionLine = 43;
// method "≤(_)"
  struct UserObject *uo76 = (struct UserObject*)obj2;
  uo76->data[6] = emptyclosure;
  Method *meth_meth_ast_76__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa4_34__34__40_1_41_ = addmethod2pos(obj2, """\xe2""""\x89""""\xa4""(1)", &meth_ast_76__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa4_34__34__40_1_41_, 6);
  int argcv_meth_ast_76__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa4_34__34__40_1_41_[] = {1};
  meth_meth_ast_76__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa4_34__34__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_76__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa4_34__34__40_1_41_);
  meth_meth_ast_76__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa4_34__34__40_1_41_->definitionModule = modulename;
  meth_meth_ast_76__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa4_34__34__40_1_41_->definitionLine = 46;
// method "<(_)"
  struct UserObject *uo82 = (struct UserObject*)obj2;
  uo82->data[7] = emptyclosure;
  Method *meth_meth_ast_82__60__40_1_41_ = addmethod2pos(obj2, "<(1)", &meth_ast_82__60__40_1_41_, 7);
  int argcv_meth_ast_82__60__40_1_41_[] = {1};
  meth_meth_ast_82__60__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_82__60__40_1_41_);
  meth_meth_ast_82__60__40_1_41_->definitionModule = modulename;
  meth_meth_ast_82__60__40_1_41_->definitionLine = 49;
// method "asString"
  struct UserObject *uo88 = (struct UserObject*)obj2;
  uo88->data[8] = emptyclosure;
  Method *meth_meth_ast_88_asString = addmethod2pos(obj2, "asString", &meth_ast_88_asString, 8);
  int argcv_meth_ast_88_asString[] = {0};
  meth_meth_ast_88_asString->type = alloc_MethodType(1, argcv_meth_ast_88_asString);
  meth_meth_ast_88_asString->definitionModule = modulename;
  meth_meth_ast_88_asString->definitionLine = 52;
  sourceObject = obj2;
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_l (depth = 2)
  adddatum2(obj2, *var_l, 1);
  sourceObject = obj2;
// Begin line 32
  setline(32);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_c (depth = 2)
  adddatum2(obj2, *var_c, 2);
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  objclass2 = obj2->class;
  objclass2->definitionModule = modulename;
  objclass2->definitionLine = 30;
  (*(struct UserObject *)self).data[0] = lowerouter2;
  self = oldself2;
  selfslot = oldselfslot2;
  stackframe = oldstackframe2;
  gc_frame_end(frame);
  return obj2;
}
Object meth_ast_1_line_40_1_41_column_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "line(1)column(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method line(_)column(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method line(_)column(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for line(_)column(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part line(_)");
  Object *var_c = &(stackframe->slots[1]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part column(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2 = alloc_userobj2(8,9, objclass2);
  gc_frame_newslot(obj2);
  if (objclass2 == NULL) {
    glfree(obj2->class->name);
    obj2->class->name = "line(_)column(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2, self, 0);
  addmethodreal(obj2,"outer", &reader_ast_outer_3);
  Object oldself2 = self;
  struct StackFrameObject *oldstackframe2 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2);
  gc_frame_newslot((Object)stackframe);
  self = obj2;
  Object *oldselfslot2 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2 = (*(struct UserObject *)self).data[0], lowerouter2 = thisouter2;
  if (inheritingObject2) {
    struct UserObject *inho2 = (struct UserObject *)inheritingObject2;
    while (inho2->super != GraceDefaultObject) inho2 = (struct UserObject *)inho2->super;
    inho2->super = obj2;
    self = inheritingObject2;
    *selfslot = self;
    lowerouter2 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2;
  }
  if (objclass2 == NULL) {
  Method *reader4 = addmethodrealflags(obj2, "line",&reader_ast_line_4, MFLAG_DEF);
  reader4->definitionModule = modulename;
  reader4->definitionLine = 31;
  }
  adddatum2(obj2, alloc_Undefined(), 1);
  if (objclass2 == NULL) {
  Method *reader5 = addmethodrealflags(obj2, "column",&reader_ast_column_5, MFLAG_DEF);
  reader5->definitionModule = modulename;
  reader5->definitionLine = 32;
  }
  adddatum2(obj2, alloc_Undefined(), 2);
// method ">(_)"
  struct UserObject *uo6 = (struct UserObject*)obj2;
  uo6->data[3] = emptyclosure;
  Method *meth_meth_ast_6__62__40_1_41_ = addmethod2pos(obj2, ">(1)", &meth_ast_6__62__40_1_41_, 3);
  int argcv_meth_ast_6__62__40_1_41_[] = {1};
  meth_meth_ast_6__62__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6__62__40_1_41_);
  meth_meth_ast_6__62__40_1_41_->definitionModule = modulename;
  meth_meth_ast_6__62__40_1_41_->definitionLine = 33;
// method "≥(_)"
  struct UserObject *uo32 = (struct UserObject*)obj2;
  uo32->data[4] = emptyclosure;
  Method *meth_meth_ast_32__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa5_34__34__40_1_41_ = addmethod2pos(obj2, """\xe2""""\x89""""\xa5""(1)", &meth_ast_32__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa5_34__34__40_1_41_, 4);
  int argcv_meth_ast_32__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa5_34__34__40_1_41_[] = {1};
  meth_meth_ast_32__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa5_34__34__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_32__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa5_34__34__40_1_41_);
  meth_meth_ast_32__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa5_34__34__40_1_41_->definitionModule = modulename;
  meth_meth_ast_32__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa5_34__34__40_1_41_->definitionLine = 38;
// method "==(_)"
  struct UserObject *uo58 = (struct UserObject*)obj2;
  uo58->data[5] = emptyclosure;
  Method *meth_meth_ast_58__61__61__40_1_41_ = addmethod2pos(obj2, "==(1)", &meth_ast_58__61__61__40_1_41_, 5);
  int argcv_meth_ast_58__61__61__40_1_41_[] = {1};
  meth_meth_ast_58__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_58__61__61__40_1_41_);
  meth_meth_ast_58__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_58__61__61__40_1_41_->definitionLine = 43;
// method "≤(_)"
  struct UserObject *uo76 = (struct UserObject*)obj2;
  uo76->data[6] = emptyclosure;
  Method *meth_meth_ast_76__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa4_34__34__40_1_41_ = addmethod2pos(obj2, """\xe2""""\x89""""\xa4""(1)", &meth_ast_76__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa4_34__34__40_1_41_, 6);
  int argcv_meth_ast_76__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa4_34__34__40_1_41_[] = {1};
  meth_meth_ast_76__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa4_34__34__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_76__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa4_34__34__40_1_41_);
  meth_meth_ast_76__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa4_34__34__40_1_41_->definitionModule = modulename;
  meth_meth_ast_76__34__34__92_xe2_34__34__34__34__92_x89_34__34__34__34__92_xa4_34__34__40_1_41_->definitionLine = 46;
// method "<(_)"
  struct UserObject *uo82 = (struct UserObject*)obj2;
  uo82->data[7] = emptyclosure;
  Method *meth_meth_ast_82__60__40_1_41_ = addmethod2pos(obj2, "<(1)", &meth_ast_82__60__40_1_41_, 7);
  int argcv_meth_ast_82__60__40_1_41_[] = {1};
  meth_meth_ast_82__60__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_82__60__40_1_41_);
  meth_meth_ast_82__60__40_1_41_->definitionModule = modulename;
  meth_meth_ast_82__60__40_1_41_->definitionLine = 49;
// method "asString"
  struct UserObject *uo88 = (struct UserObject*)obj2;
  uo88->data[8] = emptyclosure;
  Method *meth_meth_ast_88_asString = addmethod2pos(obj2, "asString", &meth_ast_88_asString, 8);
  int argcv_meth_ast_88_asString[] = {0};
  meth_meth_ast_88_asString->type = alloc_MethodType(1, argcv_meth_ast_88_asString);
  meth_meth_ast_88_asString->definitionModule = modulename;
  meth_meth_ast_88_asString->definitionLine = 52;
  sourceObject = obj2;
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_l (depth = 2)
  adddatum2(obj2, *var_l, 1);
  sourceObject = obj2;
// Begin line 32
  setline(32);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_c (depth = 2)
  adddatum2(obj2, *var_c, 2);
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  objclass2 = obj2->class;
  objclass2->definitionModule = modulename;
  objclass2->definitionLine = 30;
  (*(struct UserObject *)self).data[0] = lowerouter2;
  self = oldself2;
  selfslot = oldselfslot2;
  stackframe = oldstackframe2;
  gc_frame_end(frame);
  return obj2;
}
Object meth_ast_114_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noPosition = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 58
  setline(58);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe117 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe118 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call119 = callmethodflags(self, "end", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe118);
// compiled member node returning call119 (depth = 5)
  partcv[0] = 0;
  Object call120 = callmethodflags(call119, "line", 1, partcv, params, 0);
  gc_frame_end(callframe117);
// compiled member node returning call120 (depth = 4)
  int op_slot_right_116 = gc_frame_newslot(call120);
// starting to compile member node (depth = 4)
  int callframe122 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe123 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call124 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe123);
// compiled member node returning call124 (depth = 5)
  partcv[0] = 0;
  Object call125 = callmethodflags(call124, "line", 1, partcv, params, 0);
  gc_frame_end(callframe122);
// compiled member node returning call125 (depth = 4)
  int op_slot_left_116 = gc_frame_newslot(call125);
  params[0] = call120;
  partcv[0] = 1;
  Object opresult126 = callmethod(call125, "==(1)", 1, partcv, params);
// compiled op node returning opresult126 (depth = 3)
  Object if115 = done;
  if (istrue(opresult126)) {
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit128 == NULL) {
    strlit128 = alloc_String("");
    gc_root(strlit128);
  }
// compiled string node returning strlit128 (depth = 4)
  int op_slot_right_127 = gc_frame_newslot(strlit128);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe131 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe132 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call133 = callmethodflags(self, "end", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe132);
// compiled member node returning call133 (depth = 6)
  partcv[0] = 0;
  Object call134 = callmethodflags(call133, "column", 1, partcv, params, 0);
  gc_frame_end(callframe131);
// compiled member node returning call134 (depth = 5)
  int op_slot_right_130 = gc_frame_newslot(call134);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit137 == NULL) {
    strlit137 = alloc_String("-");
    gc_root(strlit137);
  }
// compiled string node returning strlit137 (depth = 6)
  int op_slot_right_136 = gc_frame_newslot(strlit137);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe140 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call141 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe140);
// compiled member node returning call141 (depth = 7)
  int op_slot_right_139 = gc_frame_newslot(call141);
// starting to compile string node (depth = 7)
  if (strlit143 == NULL) {
    strlit143 = alloc_String("");
    gc_root(strlit143);
  }
// compiled string node returning strlit143 (depth = 7)
  int op_slot_left_139 = gc_frame_newslot(strlit143);
  params[0] = call141;
  partcv[0] = 1;
  Object opresult144 = callmethod(strlit143, "++(1)", 1, partcv, params);
// compiled op node returning opresult144 (depth = 6)
  int op_slot_left_136 = gc_frame_newslot(opresult144);
  params[0] = strlit137;
  partcv[0] = 1;
  Object opresult145 = callmethod(opresult144, "++(1)", 1, partcv, params);
// compiled op node returning opresult145 (depth = 5)
  int op_slot_left_130 = gc_frame_newslot(opresult145);
  params[0] = call134;
  partcv[0] = 1;
  Object opresult146 = callmethod(opresult145, "++(1)", 1, partcv, params);
// compiled op node returning opresult146 (depth = 4)
  int op_slot_left_127 = gc_frame_newslot(opresult146);
  params[0] = strlit128;
  partcv[0] = 1;
  Object opresult147 = callmethod(opresult146, "++(1)", 1, partcv, params);
// compiled op node returning opresult147 (depth = 3)
    gc_frame_newslot(opresult147);
    if115 = opresult147;
  } else {
// Begin line 62
  setline(62);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_noPosition (depth = 5)
  int op_slot_right_149 = gc_frame_newslot(*var_noPosition);
// starting to compile member node (depth = 5)
  int callframe151 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe152 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call153 = callmethodflags(self, "end", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe152);
// compiled member node returning call153 (depth = 6)
  partcv[0] = 0;
  Object call154 = callmethodflags(call153, "line", 1, partcv, params, 0);
  gc_frame_end(callframe151);
// compiled member node returning call154 (depth = 5)
  int op_slot_left_149 = gc_frame_newslot(call154);
  params[0] = *var_noPosition;
  partcv[0] = 1;
  Object opresult155 = callmethod(call154, "==(1)", 1, partcv, params);
// compiled op node returning opresult155 (depth = 4)
  Object if148 = done;
  if (istrue(opresult155)) {
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe156 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe157 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call158 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe157);
// compiled member node returning call158 (depth = 5)
  partcv[0] = 0;
  Object call159 = callmethodflags(call158, "asString", 1, partcv, params, 0);
  gc_frame_end(callframe156);
// compiled member node returning call159 (depth = 4)
    gc_frame_newslot(call159);
    if148 = call159;
  } else {
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit161 == NULL) {
    strlit161 = alloc_String("");
    gc_root(strlit161);
  }
// compiled string node returning strlit161 (depth = 5)
  int op_slot_right_160 = gc_frame_newslot(strlit161);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe164 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call165 = callmethodflags(self, "end", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe164);
// compiled member node returning call165 (depth = 6)
  int op_slot_right_163 = gc_frame_newslot(call165);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit168 == NULL) {
    strlit168 = alloc_String("-");
    gc_root(strlit168);
  }
// compiled string node returning strlit168 (depth = 7)
  int op_slot_right_167 = gc_frame_newslot(strlit168);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe171 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call172 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe171);
// compiled member node returning call172 (depth = 8)
  int op_slot_right_170 = gc_frame_newslot(call172);
// starting to compile string node (depth = 8)
  if (strlit174 == NULL) {
    strlit174 = alloc_String("");
    gc_root(strlit174);
  }
// compiled string node returning strlit174 (depth = 8)
  int op_slot_left_170 = gc_frame_newslot(strlit174);
  params[0] = call172;
  partcv[0] = 1;
  Object opresult175 = callmethod(strlit174, "++(1)", 1, partcv, params);
// compiled op node returning opresult175 (depth = 7)
  int op_slot_left_167 = gc_frame_newslot(opresult175);
  params[0] = strlit168;
  partcv[0] = 1;
  Object opresult176 = callmethod(opresult175, "++(1)", 1, partcv, params);
// compiled op node returning opresult176 (depth = 6)
  int op_slot_left_163 = gc_frame_newslot(opresult176);
  params[0] = call165;
  partcv[0] = 1;
  Object opresult177 = callmethod(opresult176, "++(1)", 1, partcv, params);
// compiled op node returning opresult177 (depth = 5)
  int op_slot_left_160 = gc_frame_newslot(opresult177);
  params[0] = strlit161;
  partcv[0] = 1;
  Object opresult178 = callmethod(opresult177, "++(1)", 1, partcv, params);
// compiled op node returning opresult178 (depth = 4)
    gc_frame_newslot(opresult178);
    if148 = opresult178;
  }
// compiled if node returning if148 (depth = 3)
    gc_frame_newslot(if148);
    if115 = if148;
  }
// compiled if node returning if115 (depth = 2)
  gc_frame_end(frame);
  return if115;
}
Object meth_ast_179__61__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe182 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call183 = callmethodflags(*var_other, "end", 1, partcv, params, 0);
  gc_frame_end(callframe182);
// compiled member node returning call183 (depth = 4)
  int op_slot_right_181 = gc_frame_newslot(call183);
// starting to compile member node (depth = 4)
  int callframe185 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call186 = callmethodflags(self, "end", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe185);
// compiled member node returning call186 (depth = 4)
  int op_slot_left_181 = gc_frame_newslot(call186);
  params[0] = call183;
  partcv[0] = 1;
  Object opresult187 = callmethod(call186, "==(1)", 1, partcv, params);
// compiled op node returning opresult187 (depth = 3)
  int op_slot_right_180 = gc_frame_newslot(opresult187);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe190 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call191 = callmethodflags(*var_other, "start", 1, partcv, params, 0);
  gc_frame_end(callframe190);
// compiled member node returning call191 (depth = 4)
  int op_slot_right_189 = gc_frame_newslot(call191);
// starting to compile member node (depth = 4)
  int callframe193 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call194 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe193);
// compiled member node returning call194 (depth = 4)
  int op_slot_left_189 = gc_frame_newslot(call194);
  params[0] = call191;
  partcv[0] = 1;
  Object opresult195 = callmethod(call194, "==(1)", 1, partcv, params);
// compiled op node returning opresult195 (depth = 3)
  int op_slot_left_180 = gc_frame_newslot(opresult195);
  params[0] = opresult187;
  partcv[0] = 1;
  Object opresult196 = callmethod(opresult195, "&&(1)", 1, partcv, params);
// compiled op node returning opresult196 (depth = 2)
  gc_frame_end(frame);
  return opresult196;
}
Object meth_ast_109_start_40_1_41_end_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "start(1)end(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method start(_)end(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method start(_)end(_)");
  Object params[1];
  int partcv[1];
  Object *var_noPosition = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for start(_)end(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part start(_)");
  Object *var_e = &(stackframe->slots[1]);
  *var_e = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part end(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject110 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj110 = alloc_userobj2(4,5, objclass110);
  gc_frame_newslot(obj110);
  if (objclass110 == NULL) {
    glfree(obj110->class->name);
    obj110->class->name = "start(_)end(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj110, self, 0);
  addmethodreal(obj110,"outer", &reader_ast_outer_111);
  Object oldself110 = self;
  struct StackFrameObject *oldstackframe110 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe110);
  gc_frame_newslot((Object)stackframe);
  self = obj110;
  Object *oldselfslot110 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter110 = (*(struct UserObject *)self).data[0], lowerouter110 = thisouter110;
  if (inheritingObject110) {
    struct UserObject *inho110 = (struct UserObject *)inheritingObject110;
    while (inho110->super != GraceDefaultObject) inho110 = (struct UserObject *)inho110->super;
    inho110->super = obj110;
    self = inheritingObject110;
    *selfslot = self;
    lowerouter110 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter110;
  }
  if (objclass110 == NULL) {
  Method *reader112 = addmethodrealflags(obj110, "start",&reader_ast_start_112, MFLAG_DEF);
  reader112->definitionModule = modulename;
  reader112->definitionLine = 55;
  }
  adddatum2(obj110, alloc_Undefined(), 1);
  if (objclass110 == NULL) {
  Method *reader113 = addmethodrealflags(obj110, "end",&reader_ast_end_113, MFLAG_DEF);
  reader113->definitionModule = modulename;
  reader113->definitionLine = 56;
  }
  adddatum2(obj110, alloc_Undefined(), 2);
// method "asString"
  block_savedest(obj110);
  Object closure114 = createclosure(1, "asString");
  setclosureframe(closure114, stackframe);
  addtoclosure(closure114, var_noPosition);
  struct UserObject *uo114 = (struct UserObject*)obj110;
  uo114->data[3] = (Object)closure114;
  Method *meth_meth_ast_114_asString = addmethod2pos(obj110, "asString", &meth_ast_114_asString, 3);
  int argcv_meth_ast_114_asString[] = {0};
  meth_meth_ast_114_asString->type = alloc_MethodType(1, argcv_meth_ast_114_asString);
  meth_meth_ast_114_asString->definitionModule = modulename;
  meth_meth_ast_114_asString->definitionLine = 57;
// method "==(_)"
  struct UserObject *uo179 = (struct UserObject*)obj110;
  uo179->data[4] = emptyclosure;
  Method *meth_meth_ast_179__61__61__40_1_41_ = addmethod2pos(obj110, "==(1)", &meth_ast_179__61__61__40_1_41_, 4);
  int argcv_meth_ast_179__61__61__40_1_41_[] = {1};
  meth_meth_ast_179__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_179__61__61__40_1_41_);
  meth_meth_ast_179__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_179__61__61__40_1_41_->definitionLine = 66;
  sourceObject = obj110;
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_s (depth = 2)
  adddatum2(obj110, *var_s, 1);
  sourceObject = obj110;
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_e (depth = 2)
  adddatum2(obj110, *var_e, 2);
  sourceObject = obj110;
  sourceObject = obj110;
  objclass110 = obj110->class;
  objclass110->definitionModule = modulename;
  objclass110->definitionLine = 54;
  (*(struct UserObject *)self).data[0] = lowerouter110;
  self = oldself110;
  selfslot = oldselfslot110;
  stackframe = oldstackframe110;
  gc_frame_end(frame);
  return obj110;
}
Object meth_ast_109_start_40_1_41_end_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "start(1)end(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method start(_)end(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method start(_)end(_)");
  Object params[1];
  int partcv[1];
  Object *var_noPosition = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for start(_)end(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part start(_)");
  Object *var_e = &(stackframe->slots[1]);
  *var_e = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part end(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject110 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj110 = alloc_userobj2(4,5, objclass110);
  gc_frame_newslot(obj110);
  if (objclass110 == NULL) {
    glfree(obj110->class->name);
    obj110->class->name = "start(_)end(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj110, self, 0);
  addmethodreal(obj110,"outer", &reader_ast_outer_111);
  Object oldself110 = self;
  struct StackFrameObject *oldstackframe110 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe110);
  gc_frame_newslot((Object)stackframe);
  self = obj110;
  Object *oldselfslot110 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter110 = (*(struct UserObject *)self).data[0], lowerouter110 = thisouter110;
  if (inheritingObject110) {
    struct UserObject *inho110 = (struct UserObject *)inheritingObject110;
    while (inho110->super != GraceDefaultObject) inho110 = (struct UserObject *)inho110->super;
    inho110->super = obj110;
    self = inheritingObject110;
    *selfslot = self;
    lowerouter110 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter110;
  }
  if (objclass110 == NULL) {
  Method *reader112 = addmethodrealflags(obj110, "start",&reader_ast_start_112, MFLAG_DEF);
  reader112->definitionModule = modulename;
  reader112->definitionLine = 55;
  }
  adddatum2(obj110, alloc_Undefined(), 1);
  if (objclass110 == NULL) {
  Method *reader113 = addmethodrealflags(obj110, "end",&reader_ast_end_113, MFLAG_DEF);
  reader113->definitionModule = modulename;
  reader113->definitionLine = 56;
  }
  adddatum2(obj110, alloc_Undefined(), 2);
// method "asString"
  block_savedest(obj110);
  Object closure114 = createclosure(1, "asString");
  setclosureframe(closure114, stackframe);
  addtoclosure(closure114, var_noPosition);
  struct UserObject *uo114 = (struct UserObject*)obj110;
  uo114->data[3] = (Object)closure114;
  Method *meth_meth_ast_114_asString = addmethod2pos(obj110, "asString", &meth_ast_114_asString, 3);
  int argcv_meth_ast_114_asString[] = {0};
  meth_meth_ast_114_asString->type = alloc_MethodType(1, argcv_meth_ast_114_asString);
  meth_meth_ast_114_asString->definitionModule = modulename;
  meth_meth_ast_114_asString->definitionLine = 57;
// method "==(_)"
  struct UserObject *uo179 = (struct UserObject*)obj110;
  uo179->data[4] = emptyclosure;
  Method *meth_meth_ast_179__61__61__40_1_41_ = addmethod2pos(obj110, "==(1)", &meth_ast_179__61__61__40_1_41_, 4);
  int argcv_meth_ast_179__61__61__40_1_41_[] = {1};
  meth_meth_ast_179__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_179__61__61__40_1_41_);
  meth_meth_ast_179__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_179__61__61__40_1_41_->definitionLine = 66;
  sourceObject = obj110;
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_s (depth = 2)
  adddatum2(obj110, *var_s, 1);
  sourceObject = obj110;
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_e (depth = 2)
  adddatum2(obj110, *var_e, 2);
  sourceObject = obj110;
  sourceObject = obj110;
  objclass110 = obj110->class;
  objclass110->definitionModule = modulename;
  objclass110->definitionLine = 54;
  (*(struct UserObject *)self).data[0] = lowerouter110;
  self = oldself110;
  selfslot = oldselfslot110;
  stackframe = oldstackframe110;
  gc_frame_end(frame);
  return obj110;
}
Object meth_ast_220__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_found = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num222 = alloc_Float64(0);
// compiled num node returning num222 (depth = 5)
  int op_slot_right_221 = gc_frame_newslot(num222);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_found (depth = 5)
  int op_slot_left_221 = gc_frame_newslot(*var_found);
  params[0] = num222;
  partcv[0] = 1;
  Object opresult224 = callmethod(*var_found, "==(1)", 1, partcv, params);
// compiled op node returning opresult224 (depth = 4)
  gc_frame_end(frame);
  return opresult224;
}
Object meth_ast_227__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lineNr = getfromclosure(closure, 0);
  Object *var_sourceLines = getfromclosure(closure, 1);
  Object *var_noPosition = getfromclosure(closure, 2);
  Object *var_needle = getfromclosure(closure, 3);
  Object *var_found = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num229 = alloc_Float64(1);
// compiled num node returning num229 (depth = 6)
  int op_slot_right_228 = gc_frame_newslot(num229);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lineNr (depth = 6)
  int op_slot_left_228 = gc_frame_newslot(*var_lineNr);
  params[0] = num229;
  partcv[0] = 1;
  Object sum231 = callmethod(*var_lineNr, "+(1)", 1, partcv, params);
// compiled op node returning sum231 (depth = 5)
  *var_lineNr = sum231;
  if (sum231 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 80
  setline(80);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe235 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sourceLines (depth = 7)
  partcv[0] = 0;
  Object call236 = callmethodflags(*var_sourceLines, "size", 1, partcv, params, 0);
  gc_frame_end(callframe235);
// compiled member node returning call236 (depth = 6)
  int op_slot_right_234 = gc_frame_newslot(call236);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lineNr (depth = 6)
  int op_slot_left_234 = gc_frame_newslot(*var_lineNr);
  params[0] = call236;
  partcv[0] = 1;
  Object opresult238 = callmethod(*var_lineNr, ">(1)", 1, partcv, params);
// compiled op node returning opresult238 (depth = 5)
  Object if233 = done;
  if (istrue(opresult238)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_noPosition (depth = 6)
  block_return(realself, *var_noPosition);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if233 = undefined;
  } else {
  }
// compiled if node returning if233 (depth = 4)
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe239 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_needle (depth = 6)
  gc_frame_newslot(*var_needle);
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe240 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lineNr (depth = 7)
  gc_frame_newslot(*var_lineNr);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sourceLines (depth = 7)
  params[0] = *var_lineNr;
  partcv[0] = 1;
  Object call241 = callmethodflags(*var_sourceLines, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe240);
// compiled call node returning call241 (depth = 6)
  params[0] = *var_needle;
  partcv[0] = 1;
  Object call242 = callmethodflags(call241, "indexOf(1)", 1, partcv, params, 0);
  gc_frame_end(callframe239);
// compiled call node returning call242 (depth = 5)
  *var_found = call242;
  if (call242 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_198_positionOfNext_40_1_41_after_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "positionOfNext(1)after(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method positionOfNext(_)after(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method positionOfNext(_)after(_)");
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_noPosition = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for positionOfNext(_)after(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_needle = &(stackframe->slots[0]);
  *var_needle = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part positionOfNext(_)");
  Object *var_pos = &(stackframe->slots[1]);
  *var_pos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part after(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_sourceLines = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "sourceLines");
  Object *var_lineNr = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "lineNr");
// definebindings:
// definebindings:
  Object *var_found = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "found");
// Begin line 74
  setline(74);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe199 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  partcv[0] = 0;
  Object call200 = callmethodflags(*var_util, "lines", 1, partcv, params, 0);
  gc_frame_end(callframe199);
// compiled member node returning call200 (depth = 3)
  *var_sourceLines = call200;
  if (call200 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe201 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  partcv[0] = 0;
  Object call202 = callmethodflags(*var_pos, "line", 1, partcv, params, 0);
  gc_frame_end(callframe201);
// compiled member node returning call202 (depth = 3)
  *var_lineNr = call202;
  if (call202 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num205 = alloc_Float64(0);
// compiled num node returning num205 (depth = 4)
  int op_slot_right_204 = gc_frame_newslot(num205);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lineNr (depth = 4)
  int op_slot_left_204 = gc_frame_newslot(*var_lineNr);
  params[0] = num205;
  partcv[0] = 1;
  Object opresult207 = callmethod(*var_lineNr, "==(1)", 1, partcv, params);
// compiled op node returning opresult207 (depth = 3)
  Object if203 = done;
  if (istrue(opresult207)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noPosition (depth = 4)
  return *var_noPosition;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if203 = undefined;
  } else {
  }
// compiled if node returning if203 (depth = 2)
// Begin line 77
  setline(77);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe208 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_needle (depth = 4)
  gc_frame_newslot(*var_needle);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num210 = alloc_Float64(1);
// compiled num node returning num210 (depth = 5)
  int op_slot_right_209 = gc_frame_newslot(num210);
// starting to compile member node (depth = 5)
  int callframe212 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pos (depth = 6)
  partcv[0] = 0;
  Object call213 = callmethodflags(*var_pos, "column", 1, partcv, params, 0);
  gc_frame_end(callframe212);
// compiled member node returning call213 (depth = 5)
  int op_slot_left_209 = gc_frame_newslot(call213);
  params[0] = num210;
  partcv[0] = 1;
  Object sum214 = callmethod(call213, "+(1)", 1, partcv, params);
// compiled op node returning sum214 (depth = 4)
  gc_frame_newslot(sum214);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe215 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNr (depth = 5)
  gc_frame_newslot(*var_lineNr);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sourceLines (depth = 5)
  params[0] = *var_lineNr;
  partcv[0] = 1;
  Object call216 = callmethodflags(*var_sourceLines, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe215);
// compiled call node returning call216 (depth = 4)
  params[0] = *var_needle;
  params[1] = sum214;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call217 = callmethodflags(call216, "indexOf(1)startingAt(1)", 2, partcv, params, 0);
  gc_frame_end(callframe208);
// compiled call node returning call217 (depth = 3)
  *var_found = call217;
  if (call217 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe218 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block219 = alloc_Block(NULL, NULL, "ast", 78);
  gc_frame_newslot(block219);
// method "_apply"
  block_savedest(block219);
  Object closure220 = createclosure(2, "_apply");
  setclosureframe(closure220, stackframe);
  addtoclosure(closure220, var_found);
  addtoclosure(closure220, selfslot);
  struct UserObject *uo220 = (struct UserObject*)block219;
  uo220->data[0] = (Object)closure220;
  Method *meth_meth_ast_220__apply = addmethod2pos(block219, "_apply", &meth_ast_220__apply, 0);
  int argcv_meth_ast_220__apply[] = {0};
  meth_meth_ast_220__apply->type = alloc_MethodType(1, argcv_meth_ast_220__apply);
  meth_meth_ast_220__apply->definitionModule = modulename;
  meth_meth_ast_220__apply->definitionLine = 3050;
// compiled block node returning block219 (depth = 3)
  gc_frame_newslot(block219);
// starting to compile block node (depth = 3)
  Object block226 = alloc_Block(NULL, NULL, "ast", 78);
  gc_frame_newslot(block226);
// method "_apply"
  block_savedest(block226);
  Object closure227 = createclosure(6, "_apply");
  setclosureframe(closure227, stackframe);
  addtoclosure(closure227, var_lineNr);
  addtoclosure(closure227, var_sourceLines);
  addtoclosure(closure227, var_noPosition);
  addtoclosure(closure227, var_needle);
  addtoclosure(closure227, var_found);
  addtoclosure(closure227, selfslot);
  struct UserObject *uo227 = (struct UserObject*)block226;
  uo227->data[0] = (Object)closure227;
  Method *meth_meth_ast_227__apply = addmethod2pos(block226, "_apply", &meth_ast_227__apply, 0);
  int argcv_meth_ast_227__apply[] = {0};
  meth_meth_ast_227__apply->type = alloc_MethodType(1, argcv_meth_ast_227__apply);
  meth_meth_ast_227__apply->definitionModule = modulename;
  meth_meth_ast_227__apply->definitionLine = 3050;
// compiled block node returning block226 (depth = 3)
  gc_frame_newslot(block226);
// call case 5: prelude request
  params[0] = block219;
  params[1] = block226;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call245 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe218);
// compiled call node returning call245 (depth = 2)
// Begin line 83
  setline(83);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe246 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lineNr (depth = 3)
  gc_frame_newslot(*var_lineNr);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_found (depth = 3)
  gc_frame_newslot(*var_found);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_ast (depth = 3)
  params[0] = *var_lineNr;
  params[1] = *var_found;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call247 = callmethodflags(module_ast, "line(1)column(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe246);
// compiled call node returning call247 (depth = 2)
  gc_frame_end(frame);
  return call247;
}
Object meth_ast_286__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_found = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num288 = alloc_Float64(0);
// compiled num node returning num288 (depth = 5)
  int op_slot_right_287 = gc_frame_newslot(num288);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_found (depth = 5)
  int op_slot_left_287 = gc_frame_newslot(*var_found);
  params[0] = num288;
  partcv[0] = 1;
  Object opresult290 = callmethod(*var_found, "==(1)", 1, partcv, params);
// compiled op node returning opresult290 (depth = 4)
  gc_frame_end(frame);
  return opresult290;
}
Object meth_ast_293__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lineNr = getfromclosure(closure, 0);
  Object *var_sourceLines = getfromclosure(closure, 1);
  Object *var_noPosition = getfromclosure(closure, 2);
  Object *var_needle1 = getfromclosure(closure, 3);
  Object *var_found = getfromclosure(closure, 4);
  Object *var_needle2 = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num295 = alloc_Float64(1);
// compiled num node returning num295 (depth = 6)
  int op_slot_right_294 = gc_frame_newslot(num295);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lineNr (depth = 6)
  int op_slot_left_294 = gc_frame_newslot(*var_lineNr);
  params[0] = num295;
  partcv[0] = 1;
  Object sum297 = callmethod(*var_lineNr, "+(1)", 1, partcv, params);
// compiled op node returning sum297 (depth = 5)
  *var_lineNr = sum297;
  if (sum297 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe301 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sourceLines (depth = 7)
  partcv[0] = 0;
  Object call302 = callmethodflags(*var_sourceLines, "size", 1, partcv, params, 0);
  gc_frame_end(callframe301);
// compiled member node returning call302 (depth = 6)
  int op_slot_right_300 = gc_frame_newslot(call302);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lineNr (depth = 6)
  int op_slot_left_300 = gc_frame_newslot(*var_lineNr);
  params[0] = call302;
  partcv[0] = 1;
  Object opresult304 = callmethod(*var_lineNr, ">(1)", 1, partcv, params);
// compiled op node returning opresult304 (depth = 5)
  Object if299 = done;
  if (istrue(opresult304)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_noPosition (depth = 6)
  block_return(realself, *var_noPosition);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if299 = undefined;
  } else {
  }
// compiled if node returning if299 (depth = 4)
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe305 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_needle1 (depth = 6)
  gc_frame_newslot(*var_needle1);
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe306 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lineNr (depth = 7)
  gc_frame_newslot(*var_lineNr);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sourceLines (depth = 7)
  params[0] = *var_lineNr;
  partcv[0] = 1;
  Object call307 = callmethodflags(*var_sourceLines, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe306);
// compiled call node returning call307 (depth = 6)
  params[0] = *var_needle1;
  partcv[0] = 1;
  Object call308 = callmethodflags(call307, "indexOf(1)", 1, partcv, params, 0);
  gc_frame_end(callframe305);
// compiled call node returning call308 (depth = 5)
  *var_found = call308;
  if (call308 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num312 = alloc_Float64(0);
// compiled num node returning num312 (depth = 6)
  int op_slot_right_311 = gc_frame_newslot(num312);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_found (depth = 6)
  int op_slot_left_311 = gc_frame_newslot(*var_found);
  params[0] = num312;
  partcv[0] = 1;
  Object opresult314 = callmethod(*var_found, "==(1)", 1, partcv, params);
// compiled op node returning opresult314 (depth = 5)
  Object if310 = done;
  if (istrue(opresult314)) {
// Begin line 100
  setline(100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe315 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_needle2 (depth = 7)
  gc_frame_newslot(*var_needle2);
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe316 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNr (depth = 8)
  gc_frame_newslot(*var_lineNr);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sourceLines (depth = 8)
  params[0] = *var_lineNr;
  partcv[0] = 1;
  Object call317 = callmethodflags(*var_sourceLines, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe316);
// compiled call node returning call317 (depth = 7)
  params[0] = *var_needle2;
  partcv[0] = 1;
  Object call318 = callmethodflags(call317, "indexOf(1)", 1, partcv, params, 0);
  gc_frame_end(callframe315);
// compiled call node returning call318 (depth = 6)
  *var_found = call318;
  if (call318 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if310 = done;
  } else {
  }
// compiled if node returning if310 (depth = 4)
  gc_frame_end(frame);
  return if310;
}
Object meth_ast_248_positionOfNext_40_1_41_or_40_1_41_after_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "positionOfNext(1)or(1)after(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method positionOfNext(_)or(_)after(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method positionOfNext(_)or(_)after(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method positionOfNext(_)or(_)after(_)");
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_noPosition = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for positionOfNext(_)or(_)after(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_needle1 = &(stackframe->slots[0]);
  *var_needle1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part positionOfNext(_)");
  Object *var_needle2 = &(stackframe->slots[1]);
  *var_needle2 = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part or(_)");
  Object *var_pos = &(stackframe->slots[2]);
  *var_pos = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part after(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_sourceLines = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "sourceLines");
  Object *var_lineNr = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "lineNr");
// definebindings:
// definebindings:
  Object *var_found = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "found");
// definebindings:
// definebindings:
// Begin line 88
  setline(88);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe249 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  partcv[0] = 0;
  Object call250 = callmethodflags(*var_util, "lines", 1, partcv, params, 0);
  gc_frame_end(callframe249);
// compiled member node returning call250 (depth = 3)
  *var_sourceLines = call250;
  if (call250 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe251 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  partcv[0] = 0;
  Object call252 = callmethodflags(*var_pos, "line", 1, partcv, params, 0);
  gc_frame_end(callframe251);
// compiled member node returning call252 (depth = 3)
  *var_lineNr = call252;
  if (call252 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num255 = alloc_Float64(0);
// compiled num node returning num255 (depth = 4)
  int op_slot_right_254 = gc_frame_newslot(num255);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lineNr (depth = 4)
  int op_slot_left_254 = gc_frame_newslot(*var_lineNr);
  params[0] = num255;
  partcv[0] = 1;
  Object opresult257 = callmethod(*var_lineNr, "==(1)", 1, partcv, params);
// compiled op node returning opresult257 (depth = 3)
  Object if253 = done;
  if (istrue(opresult257)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noPosition (depth = 4)
  return *var_noPosition;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if253 = undefined;
  } else {
  }
// compiled if node returning if253 (depth = 2)
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe258 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_needle1 (depth = 4)
  gc_frame_newslot(*var_needle1);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num260 = alloc_Float64(1);
// compiled num node returning num260 (depth = 5)
  int op_slot_right_259 = gc_frame_newslot(num260);
// starting to compile member node (depth = 5)
  int callframe262 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pos (depth = 6)
  partcv[0] = 0;
  Object call263 = callmethodflags(*var_pos, "column", 1, partcv, params, 0);
  gc_frame_end(callframe262);
// compiled member node returning call263 (depth = 5)
  int op_slot_left_259 = gc_frame_newslot(call263);
  params[0] = num260;
  partcv[0] = 1;
  Object sum264 = callmethod(call263, "+(1)", 1, partcv, params);
// compiled op node returning sum264 (depth = 4)
  gc_frame_newslot(sum264);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe265 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNr (depth = 5)
  gc_frame_newslot(*var_lineNr);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sourceLines (depth = 5)
  params[0] = *var_lineNr;
  partcv[0] = 1;
  Object call266 = callmethodflags(*var_sourceLines, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe265);
// compiled call node returning call266 (depth = 4)
  params[0] = *var_needle1;
  params[1] = sum264;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call267 = callmethodflags(call266, "indexOf(1)startingAt(1)", 2, partcv, params, 0);
  gc_frame_end(callframe258);
// compiled call node returning call267 (depth = 3)
  *var_found = call267;
  if (call267 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num270 = alloc_Float64(0);
// compiled num node returning num270 (depth = 4)
  int op_slot_right_269 = gc_frame_newslot(num270);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_found (depth = 4)
  int op_slot_left_269 = gc_frame_newslot(*var_found);
  params[0] = num270;
  partcv[0] = 1;
  Object opresult272 = callmethod(*var_found, "==(1)", 1, partcv, params);
// compiled op node returning opresult272 (depth = 3)
  Object if268 = done;
  if (istrue(opresult272)) {
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe273 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_needle2 (depth = 5)
  gc_frame_newslot(*var_needle2);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num275 = alloc_Float64(1);
// compiled num node returning num275 (depth = 6)
  int op_slot_right_274 = gc_frame_newslot(num275);
// starting to compile member node (depth = 6)
  int callframe277 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_pos (depth = 7)
  partcv[0] = 0;
  Object call278 = callmethodflags(*var_pos, "column", 1, partcv, params, 0);
  gc_frame_end(callframe277);
// compiled member node returning call278 (depth = 6)
  int op_slot_left_274 = gc_frame_newslot(call278);
  params[0] = num275;
  partcv[0] = 1;
  Object sum279 = callmethod(call278, "+(1)", 1, partcv, params);
// compiled op node returning sum279 (depth = 5)
  gc_frame_newslot(sum279);
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe280 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lineNr (depth = 6)
  gc_frame_newslot(*var_lineNr);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sourceLines (depth = 6)
  params[0] = *var_lineNr;
  partcv[0] = 1;
  Object call281 = callmethodflags(*var_sourceLines, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe280);
// compiled call node returning call281 (depth = 5)
  params[0] = *var_needle2;
  params[1] = sum279;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call282 = callmethodflags(call281, "indexOf(1)startingAt(1)", 2, partcv, params, 0);
  gc_frame_end(callframe273);
// compiled call node returning call282 (depth = 4)
  *var_found = call282;
  if (call282 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if268 = done;
  } else {
  }
// compiled if node returning if268 (depth = 2)
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe284 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block285 = alloc_Block(NULL, NULL, "ast", 95);
  gc_frame_newslot(block285);
// method "_apply"
  block_savedest(block285);
  Object closure286 = createclosure(2, "_apply");
  setclosureframe(closure286, stackframe);
  addtoclosure(closure286, var_found);
  addtoclosure(closure286, selfslot);
  struct UserObject *uo286 = (struct UserObject*)block285;
  uo286->data[0] = (Object)closure286;
  Method *meth_meth_ast_286__apply = addmethod2pos(block285, "_apply", &meth_ast_286__apply, 0);
  int argcv_meth_ast_286__apply[] = {0};
  meth_meth_ast_286__apply->type = alloc_MethodType(1, argcv_meth_ast_286__apply);
  meth_meth_ast_286__apply->definitionModule = modulename;
  meth_meth_ast_286__apply->definitionLine = 3050;
// compiled block node returning block285 (depth = 3)
  gc_frame_newslot(block285);
// starting to compile block node (depth = 3)
  Object block292 = alloc_Block(NULL, NULL, "ast", 95);
  gc_frame_newslot(block292);
// method "_apply"
  block_savedest(block292);
  Object closure293 = createclosure(7, "_apply");
  setclosureframe(closure293, stackframe);
  addtoclosure(closure293, var_lineNr);
  addtoclosure(closure293, var_sourceLines);
  addtoclosure(closure293, var_noPosition);
  addtoclosure(closure293, var_needle1);
  addtoclosure(closure293, var_found);
  addtoclosure(closure293, var_needle2);
  addtoclosure(closure293, selfslot);
  struct UserObject *uo293 = (struct UserObject*)block292;
  uo293->data[0] = (Object)closure293;
  Method *meth_meth_ast_293__apply = addmethod2pos(block292, "_apply", &meth_ast_293__apply, 0);
  int argcv_meth_ast_293__apply[] = {0};
  meth_meth_ast_293__apply->type = alloc_MethodType(1, argcv_meth_ast_293__apply);
  meth_meth_ast_293__apply->definitionModule = modulename;
  meth_meth_ast_293__apply->definitionLine = 3050;
// compiled block node returning block292 (depth = 3)
  gc_frame_newslot(block292);
// call case 5: prelude request
  params[0] = block285;
  params[1] = block292;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call321 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe284);
// compiled call node returning call321 (depth = 2)
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe322 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lineNr (depth = 3)
  gc_frame_newslot(*var_lineNr);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_found (depth = 3)
  gc_frame_newslot(*var_found);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_ast (depth = 3)
  params[0] = *var_lineNr;
  params[1] = *var_found;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call323 = callmethodflags(module_ast, "line(1)column(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe322);
// compiled call node returning call323 (depth = 2)
  gc_frame_end(frame);
  return call323;
}
Object meth_ast_328__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_b = getfromclosure(closure, 0);
  Object *var_as = getfromclosure(closure, 1);
  Object *var_newList = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_nd = &(stackframe->slots[0]);
  *var_nd = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 4)
  int callframe329 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe330 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_b (depth = 6)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nd (depth = 6)
  params[0] = *var_b;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call331 = callmethodflags(*var_nd, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe330);
// compiled call node returning call331 (depth = 5)
  gc_frame_newslot(call331);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newList (depth = 5)
  params[0] = call331;
  partcv[0] = 1;
  Object call332 = callmethodflags(*var_newList, "addLast(1)", 1, partcv, params, 0);
  gc_frame_end(callframe329);
// compiled call node returning call332 (depth = 4)
  gc_frame_end(frame);
  return call332;
}
Object meth_ast_324_listMap_40_2_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "listMap(2)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method listMap(_,_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method listMap(_,_)ancestors(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for listMap(_,_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part listMap(_,_)");
  Object *var_as = &(stackframe->slots[2]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_newList = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newList");
// Begin line 109
  setline(109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array325 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array325 (depth = 3)
  *var_newList = array325;
  if (array325 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe326 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block327 = alloc_Block(NULL, NULL, "ast", 110);
  gc_frame_newslot(block327);
// method "_apply(_)"
  block_savedest(block327);
  Object closure328 = createclosure(4, "_apply(1)");
  setclosureframe(closure328, stackframe);
  addtoclosure(closure328, var_b);
  addtoclosure(closure328, var_as);
  addtoclosure(closure328, var_newList);
  addtoclosure(closure328, selfslot);
  struct UserObject *uo328 = (struct UserObject*)block327;
  uo328->data[0] = (Object)closure328;
  Method *meth_meth_ast_328__apply_40_1_41_ = addmethod2pos(block327, "_apply(1)", &meth_ast_328__apply_40_1_41_, 0);
  int argcv_meth_ast_328__apply_40_1_41_[] = {1};
  meth_meth_ast_328__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_328__apply_40_1_41_);
  meth_meth_ast_328__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_328__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block327 (depth = 3)
  gc_frame_newslot(block327);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  params[0] = block327;
  partcv[0] = 1;
  Object call334 = callmethodflags(*var_l, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe326);
// compiled call node returning call334 (depth = 2)
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_newList (depth = 2)
  gc_frame_end(frame);
  return *var_newList;
}
Object meth_ast_335_maybeMap_40_2_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "maybeMap(2)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method maybeMap(_,_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method maybeMap(_,_)ancestors(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for maybeMap(_,_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part maybeMap(_,_)");
  Object *var_as = &(stackframe->slots[2]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 114
  setline(114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_right_337 = gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
  Object bool339 = alloc_Boolean(0);
// compiled identifier node returning bool339 (depth = 4)
  int op_slot_left_337 = gc_frame_newslot(bool339);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult340 = callmethod(bool339, "≠(1)", 1, partcv, params);
// compiled op node returning opresult340 (depth = 3)
  Object if336 = done;
  if (istrue(opresult340)) {
// Begin line 115
  setline(115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe341 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = *var_b;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call342 = callmethodflags(*var_n, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe341);
// compiled call node returning call342 (depth = 3)
    gc_frame_newslot(call342);
    if336 = call342;
  } else {
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
    gc_frame_newslot(*var_n);
    if336 = *var_n;
  }
// compiled if node returning if336 (depth = 2)
  gc_frame_end(frame);
  return if336;
}
Object meth_ast_343_maybeListMap_40_2_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "maybeListMap(2)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method maybeListMap(_,_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method maybeListMap(_,_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for maybeListMap(_,_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part maybeListMap(_,_)");
  Object *var_as = &(stackframe->slots[2]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_right_345 = gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
  Object bool347 = alloc_Boolean(0);
// compiled identifier node returning bool347 (depth = 4)
  int op_slot_left_345 = gc_frame_newslot(bool347);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult348 = callmethod(bool347, "≠(1)", 1, partcv, params);
// compiled op node returning opresult348 (depth = 3)
  Object if344 = done;
  if (istrue(opresult348)) {
// Begin line 122
  setline(122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe349 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = *var_n;
  params[1] = *var_b;
  params[2] = *var_as;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call350 = callmethodflags(module_ast, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe349);
// compiled call node returning call350 (depth = 3)
    gc_frame_newslot(call350);
    if344 = call350;
  } else {
// Begin line 124
  setline(124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
    gc_frame_newslot(*var_n);
    if344 = *var_n;
  }
// compiled if node returning if344 (depth = 2)
  gc_frame_end(frame);
  return if344;
}
Object meth_ast_359_setLine_40_1_41_col_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "setLine(1)col(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method setLine(_)col(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method setLine(_)col(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for setLine(_)col(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part setLine(_)");
  Object *var_c = &(stackframe->slots[1]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part col(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 201
  setline(201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe360 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  gc_frame_newslot(*var_l);
// call case 4: self request
  params[0] = *var_l;
  partcv[0] = 1;
  Object call361 = callmethodflags(self, "line:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe360);
// compiled call node returning call361 (depth = 2)
// Begin line 202
  setline(202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe362 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 4: self request
  params[0] = *var_c;
  partcv[0] = 1;
  Object call363 = callmethodflags(self, "linePos:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe362);
// compiled call node returning call363 (depth = 2)
// Begin line 203
  setline(203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_364_setPositionFrom_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "setPositionFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method setPositionFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for setPositionFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tokenOrNode = &(stackframe->slots[0]);
  *var_tokenOrNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part setPositionFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe365 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe366 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokenOrNode (depth = 4)
  partcv[0] = 0;
  Object call367 = callmethodflags(*var_tokenOrNode, "line", 1, partcv, params, 0);
  gc_frame_end(callframe366);
// compiled member node returning call367 (depth = 3)
  gc_frame_newslot(call367);
// call case 4: self request
  params[0] = call367;
  partcv[0] = 1;
  Object call368 = callmethodflags(self, "line:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe365);
// compiled call node returning call368 (depth = 2)
// Begin line 207
  setline(207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe369 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe370 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokenOrNode (depth = 4)
  partcv[0] = 0;
  Object call371 = callmethodflags(*var_tokenOrNode, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe370);
// compiled member node returning call371 (depth = 3)
  gc_frame_newslot(call371);
// call case 4: self request
  params[0] = call371;
  partcv[0] = 1;
  Object call372 = callmethodflags(self, "linePos:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe369);
// compiled call node returning call372 (depth = 2)
// Begin line 208
  setline(208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_373_setStart_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "setStart(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method setStart(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for setStart(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part setStart(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 211
  setline(211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe374 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe375 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_p (depth = 4)
  partcv[0] = 0;
  Object call376 = callmethodflags(*var_p, "line", 1, partcv, params, 0);
  gc_frame_end(callframe375);
// compiled member node returning call376 (depth = 3)
  gc_frame_newslot(call376);
// call case 4: self request
  params[0] = call376;
  partcv[0] = 1;
  Object call377 = callmethodflags(self, "line:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe374);
// compiled call node returning call377 (depth = 2)
// Begin line 212
  setline(212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe378 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe379 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_p (depth = 4)
  partcv[0] = 0;
  Object call380 = callmethodflags(*var_p, "column", 1, partcv, params, 0);
  gc_frame_end(callframe379);
// compiled member node returning call380 (depth = 3)
  gc_frame_newslot(call380);
// call case 4: self request
  params[0] = call380;
  partcv[0] = 1;
  Object call381 = callmethodflags(self, "linePos:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe378);
// compiled call node returning call381 (depth = 2)
// Begin line 213
  setline(213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_382_column(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "column");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 215
  setline(215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe383 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call384 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe383);
// compiled member node returning call384 (depth = 2)
  gc_frame_end(frame);
  return call384;
}
Object meth_ast_385_start(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "start");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 216
  setline(216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe386 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe387 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call388 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe387);
// compiled member node returning call388 (depth = 3)
  gc_frame_newslot(call388);
// starting to compile member node (depth = 3)
  int callframe389 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call390 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe389);
// compiled member node returning call390 (depth = 3)
  gc_frame_newslot(call390);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_ast (depth = 3)
  params[0] = call388;
  params[1] = call390;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call391 = callmethodflags(module_ast, "line(1)column(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe386);
// compiled call node returning call391 (depth = 2)
  gc_frame_end(frame);
  return call391;
}
Object meth_ast_392_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe393 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe394 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call395 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe394);
// compiled member node returning call395 (depth = 3)
  gc_frame_newslot(call395);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num397 = alloc_Float64(1);
// compiled num node returning num397 (depth = 4)
  int op_slot_right_396 = gc_frame_newslot(num397);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe400 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe401 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call402 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe401);
// compiled member node returning call402 (depth = 6)
  partcv[0] = 0;
  Object call403 = callmethodflags(call402, "size", 1, partcv, params, 0);
  gc_frame_end(callframe400);
// compiled member node returning call403 (depth = 5)
  int op_slot_right_399 = gc_frame_newslot(call403);
// starting to compile member node (depth = 5)
  int callframe405 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call406 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe405);
// compiled member node returning call406 (depth = 5)
  int op_slot_left_399 = gc_frame_newslot(call406);
  params[0] = call403;
  partcv[0] = 1;
  Object sum407 = callmethod(call406, "+(1)", 1, partcv, params);
// compiled op node returning sum407 (depth = 4)
  int op_slot_left_396 = gc_frame_newslot(sum407);
  params[0] = num397;
  partcv[0] = 1;
  Object diff408 = callmethod(sum407, "-(1)", 1, partcv, params);
// compiled op node returning diff408 (depth = 3)
  gc_frame_newslot(diff408);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_ast (depth = 3)
  params[0] = call395;
  params[1] = diff408;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call409 = callmethodflags(module_ast, "line(1)column(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe393);
// compiled call node returning call409 (depth = 2)
  gc_frame_end(frame);
  return call409;
}
Object meth_ast_410_range(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "range");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe411 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe412 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call413 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe412);
// compiled member node returning call413 (depth = 3)
  gc_frame_newslot(call413);
// starting to compile member node (depth = 3)
  int callframe414 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call415 = callmethodflags(self, "end", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe414);
// compiled member node returning call415 (depth = 3)
  gc_frame_newslot(call415);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_ast (depth = 3)
  params[0] = call413;
  params[1] = call415;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call416 = callmethodflags(module_ast, "start(1)end(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe411);
// compiled call node returning call416 (depth = 2)
  gc_frame_end(frame);
  return call416;
}
Object meth_ast_417_kind(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "kind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe418 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call419 = callmethodflags(prelude, "abstract", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe418);
// compiled member node returning call419 (depth = 2)
  gc_frame_end(frame);
  return call419;
}
Object meth_ast_420__61__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 220
  setline(220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe421 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 4: self request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call422 = callmethodflags(self, "isMe(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe421);
// compiled call node returning call422 (depth = 2)
  gc_frame_end(frame);
  return call422;
}
Object meth_ast_423_isAppliedOccurenceOfIdentifier(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isAppliedOccurenceOfIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 221
  setline(221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool424 = alloc_Boolean(0);
// compiled identifier node returning bool424 (depth = 2)
  gc_frame_end(frame);
  return bool424;
}
Object meth_ast_425_isMatchingBlock(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMatchingBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool426 = alloc_Boolean(0);
// compiled identifier node returning bool426 (depth = 2)
  gc_frame_end(frame);
  return bool426;
}
Object meth_ast_427_isFieldDec(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isFieldDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 223
  setline(223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool428 = alloc_Boolean(0);
// compiled identifier node returning bool428 (depth = 2)
  gc_frame_end(frame);
  return bool428;
}
Object meth_ast_429_isInherits(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isInherits");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 224
  setline(224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool430 = alloc_Boolean(0);
// compiled identifier node returning bool430 (depth = 2)
  gc_frame_end(frame);
  return bool430;
}
Object meth_ast_431_isLegalInTrait(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isLegalInTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool432 = alloc_Boolean(0);
// compiled identifier node returning bool432 (depth = 2)
  gc_frame_end(frame);
  return bool432;
}
Object meth_ast_433_isMember(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 226
  setline(226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool434 = alloc_Boolean(0);
// compiled identifier node returning bool434 (depth = 2)
  gc_frame_end(frame);
  return bool434;
}
Object meth_ast_435_isMethod(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMethod");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 227
  setline(227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool436 = alloc_Boolean(0);
// compiled identifier node returning bool436 (depth = 2)
  gc_frame_end(frame);
  return bool436;
}
Object meth_ast_437_isExecutable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool438 = alloc_Boolean(1);
// compiled identifier node returning bool438 (depth = 2)
  gc_frame_end(frame);
  return bool438;
}
Object meth_ast_439_isCall(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool440 = alloc_Boolean(0);
// compiled identifier node returning bool440 (depth = 2)
  gc_frame_end(frame);
  return bool440;
}
Object meth_ast_441_isComment(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isComment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 230
  setline(230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool442 = alloc_Boolean(0);
// compiled identifier node returning bool442 (depth = 2)
  gc_frame_end(frame);
  return bool442;
}
Object meth_ast_443_isClass(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isClass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 231
  setline(231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool444 = alloc_Boolean(0);
// compiled identifier node returning bool444 (depth = 2)
  gc_frame_end(frame);
  return bool444;
}
Object meth_ast_445_inClass(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inClass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool446 = alloc_Boolean(0);
// compiled identifier node returning bool446 (depth = 2)
  gc_frame_end(frame);
  return bool446;
}
Object meth_ast_447_isTrait(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool448 = alloc_Boolean(0);
// compiled identifier node returning bool448 (depth = 2)
  gc_frame_end(frame);
  return bool448;
}
Object meth_ast_449_inTrait(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 234
  setline(234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool450 = alloc_Boolean(0);
// compiled identifier node returning bool450 (depth = 2)
  gc_frame_end(frame);
  return bool450;
}
Object meth_ast_451_isBind(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isBind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 235
  setline(235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool452 = alloc_Boolean(0);
// compiled identifier node returning bool452 (depth = 2)
  gc_frame_end(frame);
  return bool452;
}
Object meth_ast_453_isReturn(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReturn");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 236
  setline(236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool454 = alloc_Boolean(0);
// compiled identifier node returning bool454 (depth = 2)
  gc_frame_end(frame);
  return bool454;
}
Object meth_ast_455_isSelf(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSelf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool456 = alloc_Boolean(0);
// compiled identifier node returning bool456 (depth = 2)
  gc_frame_end(frame);
  return bool456;
}
Object meth_ast_457_isSuper(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSuper");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 238
  setline(238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool458 = alloc_Boolean(0);
// compiled identifier node returning bool458 (depth = 2)
  gc_frame_end(frame);
  return bool458;
}
Object meth_ast_459_isPrelude(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPrelude");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 239
  setline(239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool460 = alloc_Boolean(0);
// compiled identifier node returning bool460 (depth = 2)
  gc_frame_end(frame);
  return bool460;
}
Object meth_ast_461_isOuter(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isOuter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 240
  setline(240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool462 = alloc_Boolean(0);
// compiled identifier node returning bool462 (depth = 2)
  gc_frame_end(frame);
  return bool462;
}
Object meth_ast_463_isSelfOrOuter(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSelfOrOuter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool464 = alloc_Boolean(0);
// compiled identifier node returning bool464 (depth = 2)
  gc_frame_end(frame);
  return bool464;
}
Object meth_ast_465_isBlock(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 242
  setline(242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool466 = alloc_Boolean(0);
// compiled identifier node returning bool466 (depth = 2)
  gc_frame_end(frame);
  return bool466;
}
Object meth_ast_467_isObject(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool468 = alloc_Boolean(0);
// compiled identifier node returning bool468 (depth = 2)
  gc_frame_end(frame);
  return bool468;
}
Object meth_ast_469_isIdentifier(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 244
  setline(244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool470 = alloc_Boolean(0);
// compiled identifier node returning bool470 (depth = 2)
  gc_frame_end(frame);
  return bool470;
}
Object meth_ast_471_isDialect(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isDialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool472 = alloc_Boolean(0);
// compiled identifier node returning bool472 (depth = 2)
  gc_frame_end(frame);
  return bool472;
}
Object meth_ast_473_isImport(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isImport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool474 = alloc_Boolean(0);
// compiled identifier node returning bool474 (depth = 2)
  gc_frame_end(frame);
  return bool474;
}
Object meth_ast_475_isTypeDec(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTypeDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 247
  setline(247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool476 = alloc_Boolean(0);
// compiled identifier node returning bool476 (depth = 2)
  gc_frame_end(frame);
  return bool476;
}
Object meth_ast_477_isExternal(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExternal");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 248
  setline(248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool478 = alloc_Boolean(0);
// compiled identifier node returning bool478 (depth = 2)
  gc_frame_end(frame);
  return bool478;
}
Object meth_ast_479_isFresh(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isFresh");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool480 = alloc_Boolean(0);
// compiled identifier node returning bool480 (depth = 2)
  gc_frame_end(frame);
  return bool480;
}
Object meth_ast_481_isConstant(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isConstant");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 250
  setline(250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool482 = alloc_Boolean(0);
// compiled identifier node returning bool482 (depth = 2)
  gc_frame_end(frame);
  return bool482;
}
Object meth_ast_483_canInherit(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canInherit");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool484 = alloc_Boolean(0);
// compiled identifier node returning bool484 (depth = 2)
  gc_frame_end(frame);
  return bool484;
}
Object meth_ast_485_returnsObject(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool486 = alloc_Boolean(0);
// compiled identifier node returning bool486 (depth = 2)
  gc_frame_end(frame);
  return bool486;
}
Object meth_ast_487_isImplicit(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isImplicit");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool488 = alloc_Boolean(0);
// compiled identifier node returning bool488 (depth = 2)
  gc_frame_end(frame);
  return bool488;
}
Object meth_ast_489_usesAsType_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part usesAsType(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool490 = alloc_Boolean(0);
// compiled identifier node returning bool490 (depth = 2)
  gc_frame_end(frame);
  return bool490;
}
Object meth_ast_491_hash(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hash");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 255
  setline(255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe493 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe494 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call495 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe494);
// compiled member node returning call495 (depth = 4)
  partcv[0] = 0;
  Object call496 = callmethodflags(call495, "hash", 1, partcv, params, 0);
  gc_frame_end(callframe493);
// compiled member node returning call496 (depth = 3)
  int op_slot_right_492 = gc_frame_newslot(call496);
// starting to compile member node (depth = 3)
  int callframe498 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe499 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call500 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe499);
// compiled member node returning call500 (depth = 4)
  partcv[0] = 0;
  Object call501 = callmethodflags(call500, "hash", 1, partcv, params, 0);
  gc_frame_end(callframe498);
// compiled member node returning call501 (depth = 3)
  int op_slot_left_492 = gc_frame_newslot(call501);
  params[0] = call496;
  partcv[0] = 1;
  Object prod502 = callmethod(call501, "*(1)", 1, partcv, params);
// compiled op node returning prod502 (depth = 2)
  gc_frame_end(frame);
  return prod502;
}
Object meth_ast_503_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 256
  setline(256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit505 == NULL) {
    strlit505 = alloc_String("");
    gc_root(strlit505);
  }
// compiled string node returning strlit505 (depth = 3)
  int op_slot_right_504 = gc_frame_newslot(strlit505);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe508 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call509 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe508);
// compiled member node returning call509 (depth = 4)
  int op_slot_right_507 = gc_frame_newslot(call509);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit512 == NULL) {
    strlit512 = alloc_String(" ");
    gc_root(strlit512);
  }
// compiled string node returning strlit512 (depth = 5)
  int op_slot_right_511 = gc_frame_newslot(strlit512);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe515 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call516 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe515);
// compiled member node returning call516 (depth = 6)
  int op_slot_right_514 = gc_frame_newslot(call516);
// starting to compile string node (depth = 6)
  if (strlit518 == NULL) {
    strlit518 = alloc_String("");
    gc_root(strlit518);
  }
// compiled string node returning strlit518 (depth = 6)
  int op_slot_left_514 = gc_frame_newslot(strlit518);
  params[0] = call516;
  partcv[0] = 1;
  Object opresult519 = callmethod(strlit518, "++(1)", 1, partcv, params);
// compiled op node returning opresult519 (depth = 5)
  int op_slot_left_511 = gc_frame_newslot(opresult519);
  params[0] = strlit512;
  partcv[0] = 1;
  Object opresult520 = callmethod(opresult519, "++(1)", 1, partcv, params);
// compiled op node returning opresult520 (depth = 4)
  int op_slot_left_507 = gc_frame_newslot(opresult520);
  params[0] = call509;
  partcv[0] = 1;
  Object opresult521 = callmethod(opresult520, "++(1)", 1, partcv, params);
// compiled op node returning opresult521 (depth = 3)
  int op_slot_left_504 = gc_frame_newslot(opresult521);
  params[0] = strlit505;
  partcv[0] = 1;
  Object opresult522 = callmethod(opresult521, "++(1)", 1, partcv, params);
// compiled op node returning opresult522 (depth = 2)
  gc_frame_end(frame);
  return opresult522;
}
Object meth_ast_523_nameString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 257
  setline(257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit524 == NULL) {
    strlit524 = alloc_String("?");
    gc_root(strlit524);
  }
// compiled string node returning strlit524 (depth = 2)
  gc_frame_end(frame);
  return strlit524;
}
Object meth_ast_525_isWritable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 258
  setline(258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool526 = alloc_Boolean(1);
// compiled identifier node returning bool526 (depth = 2)
  gc_frame_end(frame);
  return bool526;
}
Object meth_ast_527_isReadable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool528 = alloc_Boolean(1);
// compiled identifier node returning bool528 (depth = 2)
  gc_frame_end(frame);
  return bool528;
}
Object meth_ast_529_isPublic(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 260
  setline(260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool530 = alloc_Boolean(1);
// compiled identifier node returning bool530 (depth = 2)
  gc_frame_end(frame);
  return bool530;
}
Object meth_ast_531_isConfidential(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isConfidential");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe532 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe533 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call534 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe533);
// compiled member node returning call534 (depth = 3)
  partcv[0] = 0;
  Object call535 = callmethodflags(call534, "not", 1, partcv, params, 0);
  gc_frame_end(callframe532);
// compiled member node returning call535 (depth = 2)
  gc_frame_end(frame);
  return call535;
}
Object meth_ast_536_decType(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 56, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "decType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe539 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call540 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe539);
// compiled member node returning call540 (depth = 4)
  int op_slot_right_538 = gc_frame_newslot(call540);
// starting to compile identifier node (depth = 4)
  Object bool542 = alloc_Boolean(0);
// compiled identifier node returning bool542 (depth = 4)
  int op_slot_left_538 = gc_frame_newslot(bool542);
  params[0] = call540;
  partcv[0] = 1;
  Object opresult543 = callmethod(bool542, "==(1)", 1, partcv, params);
// compiled op node returning opresult543 (depth = 3)
  Object if537 = done;
  if (istrue(opresult543)) {
// Begin line 264
  setline(264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unknownType (depth = 4)
  return *var_unknownType;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if537 = undefined;
  } else {
  }
// compiled if node returning if537 (depth = 2)
// Begin line 266
  setline(266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe544 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call545 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe544);
// compiled member node returning call545 (depth = 3)
  return call545;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_546_isSimple(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 268
  setline(268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool547 = alloc_Boolean(1);
// compiled identifier node returning bool547 (depth = 2)
  gc_frame_end(frame);
  return bool547;
}
Object meth_ast_548_isDelimited(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isDelimited");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 269
  setline(269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool549 = alloc_Boolean(0);
// compiled identifier node returning bool549 (depth = 2)
  gc_frame_end(frame);
  return bool549;
}
Object meth_ast_550_description(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "description");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe551 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call552 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe551);
// compiled member node returning call552 (depth = 2)
  gc_frame_end(frame);
  return call552;
}
Object meth_ast_553_accept_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 60, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)");
  Object params[2];
  int partcv[2];
  Object *var_ancestorChain = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for accept(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 272
  setline(272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe554 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitor (depth = 3)
  gc_frame_newslot(*var_visitor);
// starting to compile member node (depth = 3)
  int callframe555 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ancestorChain (depth = 4)
  partcv[0] = 0;
  Object call556 = callmethodflags(*var_ancestorChain, "empty", 1, partcv, params, 0);
  gc_frame_end(callframe555);
// compiled member node returning call556 (depth = 3)
  gc_frame_newslot(call556);
// call case 4: self request
  params[0] = *var_visitor;
  params[1] = call556;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call557 = callmethodflags(self, "accept(1)from(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe554);
// compiled call node returning call557 (depth = 2)
  gc_frame_end(frame);
  return call557;
}
Object meth_ast_558_scope(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 274
  setline(274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe559 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call560 = callmethodflags(self, "symbolTable", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe559);
// compiled member node returning call560 (depth = 2)
  gc_frame_end(frame);
  return call560;
}
Object meth_ast_561_scope_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 280
  setline(280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe562 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_st (depth = 3)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call563 = callmethodflags(self, "symbolTable:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe562);
// compiled call node returning call563 (depth = 2)
  gc_frame_end(frame);
  return call563;
}
Object meth_ast_564_setScope_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "setScope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method setScope(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for setScope(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part setScope(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 284
  setline(284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe565 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_st (depth = 3)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call566 = callmethodflags(self, "scope:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe565);
// compiled call node returning call566 (depth = 2)
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_567_shallowCopyFieldsFrom_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 288
  setline(288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe568 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe569 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  partcv[0] = 0;
  Object call570 = callmethodflags(*var_other, "register", 1, partcv, params, 0);
  gc_frame_end(callframe569);
// compiled member node returning call570 (depth = 3)
  gc_frame_newslot(call570);
// call case 4: self request
  params[0] = call570;
  partcv[0] = 1;
  Object call571 = callmethodflags(self, "register:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe568);
// compiled call node returning call571 (depth = 2)
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe572 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe573 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  partcv[0] = 0;
  Object call574 = callmethodflags(*var_other, "line", 1, partcv, params, 0);
  gc_frame_end(callframe573);
// compiled member node returning call574 (depth = 3)
  gc_frame_newslot(call574);
// call case 4: self request
  params[0] = call574;
  partcv[0] = 1;
  Object call575 = callmethodflags(self, "line:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe572);
// compiled call node returning call575 (depth = 2)
// Begin line 290
  setline(290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe576 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe577 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  partcv[0] = 0;
  Object call578 = callmethodflags(*var_other, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe577);
// compiled member node returning call578 (depth = 3)
  gc_frame_newslot(call578);
// call case 4: self request
  params[0] = call578;
  partcv[0] = 1;
  Object call579 = callmethodflags(self, "linePos:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe576);
// compiled call node returning call579 (depth = 2)
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe580 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe581 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  partcv[0] = 0;
  Object call582 = callmethodflags(*var_other, "scope", 1, partcv, params, 0);
  gc_frame_end(callframe581);
// compiled member node returning call582 (depth = 3)
  gc_frame_newslot(call582);
// call case 4: self request
  params[0] = call582;
  partcv[0] = 1;
  Object call583 = callmethodflags(self, "scope:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe580);
// compiled call node returning call583 (depth = 2)
// Begin line 292
  setline(292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe584 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 4: self request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call585 = callmethodflags(self, "postCopy(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe584);
// compiled call node returning call585 (depth = 2)
// Begin line 293
  setline(293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_586_postCopy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "postCopy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method postCopy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for postCopy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part postCopy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  gc_frame_end(frame);
  return done;
}
Object meth_ast_599__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit601 == NULL) {
    strlit601 = alloc_String("symbols");
    gc_root(strlit601);
  }
// compiled string node returning strlit601 (depth = 6)
  int op_slot_right_600 = gc_frame_newslot(strlit601);
// starting to compile member node (depth = 6)
  int callframe603 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call604 = callmethodflags(*var_util, "target", 1, partcv, params, 0);
  gc_frame_end(callframe603);
// compiled member node returning call604 (depth = 6)
  int op_slot_left_600 = gc_frame_newslot(call604);
  params[0] = strlit601;
  partcv[0] = 1;
  Object opresult605 = callmethod(call604, "==(1)", 1, partcv, params);
// compiled op node returning opresult605 (depth = 5)
  gc_frame_end(frame);
  return opresult605;
}
Object meth_ast_587_prettyPrefix_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 66, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "prettyPrefix(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method prettyPrefix(_)");
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for prettyPrefix(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part prettyPrefix(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 300
  setline(300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num590 = alloc_Float64(1);
// compiled num node returning num590 (depth = 5)
  int op_slot_right_589 = gc_frame_newslot(num590);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_left_589 = gc_frame_newslot(*var_depth);
  params[0] = num590;
  partcv[0] = 1;
  Object sum592 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum592 (depth = 4)
  int op_slot_right_588 = gc_frame_newslot(sum592);
// starting to compile string node (depth = 4)
  if (strlit594 == NULL) {
    strlit594 = alloc_String("  ");
    gc_root(strlit594);
  }
// compiled string node returning strlit594 (depth = 4)
  int op_slot_left_588 = gc_frame_newslot(strlit594);
  params[0] = sum592;
  partcv[0] = 1;
  Object prod595 = callmethod(strlit594, "*(1)", 1, partcv, params);
// compiled op node returning prod595 (depth = 3)
  *var_spc = prod595;
  if (prod595 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 301
  setline(301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile block node (depth = 4)
  Object block598 = alloc_Block(NULL, NULL, "ast", 301);
  gc_frame_newslot(block598);
// method "_apply"
  block_savedest(block598);
  Object closure599 = createclosure(2, "_apply");
  setclosureframe(closure599, stackframe);
  addtoclosure(closure599, var_util);
  addtoclosure(closure599, selfslot);
  struct UserObject *uo599 = (struct UserObject*)block598;
  uo599->data[0] = (Object)closure599;
  Method *meth_meth_ast_599__apply = addmethod2pos(block598, "_apply", &meth_ast_599__apply, 0);
  int argcv_meth_ast_599__apply[] = {0};
  meth_meth_ast_599__apply->type = alloc_MethodType(1, argcv_meth_ast_599__apply);
  meth_meth_ast_599__apply->definitionModule = modulename;
  meth_meth_ast_599__apply->definitionLine = 3050;
// compiled block node returning block598 (depth = 4)
  int op_slot_right_597 = gc_frame_newslot(block598);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  int op_slot_right_608 = gc_frame_newslot(self);
// starting to compile member node (depth = 5)
  int callframe610 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe611 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call612 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe611);
// compiled member node returning call612 (depth = 6)
  partcv[0] = 0;
  Object call613 = callmethodflags(call612, "node", 1, partcv, params, 0);
  gc_frame_end(callframe610);
// compiled member node returning call613 (depth = 5)
  int op_slot_left_608 = gc_frame_newslot(call613);
  params[0] = self;
  partcv[0] = 1;
  Object opresult614 = callmethod(call613, "==(1)", 1, partcv, params);
// compiled op node returning opresult614 (depth = 4)
  int op_slot_left_597 = gc_frame_newslot(opresult614);
  params[0] = block598;
  partcv[0] = 1;
  Object opresult615 = callmethod(opresult614, "&&(1)", 1, partcv, params);
// compiled op node returning opresult615 (depth = 3)
  Object if596 = done;
  if (istrue(opresult615)) {
// Begin line 302
  setline(302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit617 == NULL) {
    strlit617 = alloc_String("");
    gc_root(strlit617);
  }
// compiled string node returning strlit617 (depth = 4)
  int op_slot_right_616 = gc_frame_newslot(strlit617);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe620 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe621 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call622 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe621);
// compiled member node returning call622 (depth = 6)
  partcv[0] = 0;
  Object call623 = callmethodflags(call622, "elementScopesAsString", 1, partcv, params, 0);
  gc_frame_end(callframe620);
// compiled member node returning call623 (depth = 5)
  int op_slot_right_619 = gc_frame_newslot(call623);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit626 == NULL) {
    strlit626 = alloc_String("");
    gc_root(strlit626);
  }
// compiled string node returning strlit626 (depth = 6)
  int op_slot_right_625 = gc_frame_newslot(strlit626);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe629 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call630 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe629);
// compiled member node returning call630 (depth = 7)
  int op_slot_right_628 = gc_frame_newslot(call630);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit633 == NULL) {
    strlit633 = alloc_String("): ");
    gc_root(strlit633);
  }
// compiled string node returning strlit633 (depth = 8)
  int op_slot_right_632 = gc_frame_newslot(strlit633);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe636 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe637 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call638 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe637);
// compiled member node returning call638 (depth = 10)
  partcv[0] = 0;
  Object call639 = callmethodflags(call638, "variety", 1, partcv, params, 0);
  gc_frame_end(callframe636);
// compiled member node returning call639 (depth = 9)
  int op_slot_right_635 = gc_frame_newslot(call639);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit642 == NULL) {
    strlit642 = alloc_String("Symbols(");
    gc_root(strlit642);
  }
// compiled string node returning strlit642 (depth = 10)
  int op_slot_right_641 = gc_frame_newslot(strlit642);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_644 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit647 == NULL) {
    strlit647 = alloc_String("""\x0a""");
    gc_root(strlit647);
  }
// compiled string node returning strlit647 (depth = 12)
  int op_slot_right_646 = gc_frame_newslot(strlit647);
// starting to compile op node (depth = 12)
// starting to compile member node (depth = 13)
  int callframe650 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call651 = callmethodflags(self, "description", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe650);
// compiled member node returning call651 (depth = 13)
  int op_slot_right_649 = gc_frame_newslot(call651);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit654 == NULL) {
    strlit654 = alloc_String(" ");
    gc_root(strlit654);
  }
// compiled string node returning strlit654 (depth = 14)
  int op_slot_right_653 = gc_frame_newslot(strlit654);
// starting to compile op node (depth = 14)
// starting to compile member node (depth = 15)
  int callframe657 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call658 = callmethodflags(self, "range", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe657);
// compiled member node returning call658 (depth = 15)
  int op_slot_right_656 = gc_frame_newslot(call658);
// starting to compile string node (depth = 15)
  if (strlit660 == NULL) {
    strlit660 = alloc_String("");
    gc_root(strlit660);
  }
// compiled string node returning strlit660 (depth = 15)
  int op_slot_left_656 = gc_frame_newslot(strlit660);
  params[0] = call658;
  partcv[0] = 1;
  Object opresult661 = callmethod(strlit660, "++(1)", 1, partcv, params);
// compiled op node returning opresult661 (depth = 14)
  int op_slot_left_653 = gc_frame_newslot(opresult661);
  params[0] = strlit654;
  partcv[0] = 1;
  Object opresult662 = callmethod(opresult661, "++(1)", 1, partcv, params);
// compiled op node returning opresult662 (depth = 13)
  int op_slot_left_649 = gc_frame_newslot(opresult662);
  params[0] = call651;
  partcv[0] = 1;
  Object opresult663 = callmethod(opresult662, "++(1)", 1, partcv, params);
// compiled op node returning opresult663 (depth = 12)
  int op_slot_left_646 = gc_frame_newslot(opresult663);
  params[0] = strlit647;
  partcv[0] = 1;
  Object opresult664 = callmethod(opresult663, "++(1)", 1, partcv, params);
// compiled op node returning opresult664 (depth = 11)
  int op_slot_left_644 = gc_frame_newslot(opresult664);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult665 = callmethod(opresult664, "++(1)", 1, partcv, params);
// compiled op node returning opresult665 (depth = 10)
  int op_slot_left_641 = gc_frame_newslot(opresult665);
  params[0] = strlit642;
  partcv[0] = 1;
  Object opresult666 = callmethod(opresult665, "++(1)", 1, partcv, params);
// compiled op node returning opresult666 (depth = 9)
  int op_slot_left_635 = gc_frame_newslot(opresult666);
  params[0] = call639;
  partcv[0] = 1;
  Object opresult667 = callmethod(opresult666, "++(1)", 1, partcv, params);
// compiled op node returning opresult667 (depth = 8)
  int op_slot_left_632 = gc_frame_newslot(opresult667);
  params[0] = strlit633;
  partcv[0] = 1;
  Object opresult668 = callmethod(opresult667, "++(1)", 1, partcv, params);
// compiled op node returning opresult668 (depth = 7)
  int op_slot_left_628 = gc_frame_newslot(opresult668);
  params[0] = call630;
  partcv[0] = 1;
  Object opresult669 = callmethod(opresult668, "++(1)", 1, partcv, params);
// compiled op node returning opresult669 (depth = 6)
  int op_slot_left_625 = gc_frame_newslot(opresult669);
  params[0] = strlit626;
  partcv[0] = 1;
  Object opresult670 = callmethod(opresult669, "++(1)", 1, partcv, params);
// compiled op node returning opresult670 (depth = 5)
  int op_slot_left_619 = gc_frame_newslot(opresult670);
  params[0] = call623;
  partcv[0] = 1;
  Object opresult671 = callmethod(opresult670, "++(1)", 1, partcv, params);
// compiled op node returning opresult671 (depth = 4)
  int op_slot_left_616 = gc_frame_newslot(opresult671);
  params[0] = strlit617;
  partcv[0] = 1;
  Object opresult672 = callmethod(opresult671, "++(1)", 1, partcv, params);
// compiled op node returning opresult672 (depth = 3)
    gc_frame_newslot(opresult672);
    if596 = opresult672;
  } else {
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 303
  setline(303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit675 == NULL) {
    strlit675 = alloc_String("fake");
    gc_root(strlit675);
  }
// compiled string node returning strlit675 (depth = 5)
  int op_slot_right_674 = gc_frame_newslot(strlit675);
// starting to compile member node (depth = 5)
  int callframe677 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe678 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call679 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe678);
// compiled member node returning call679 (depth = 6)
  partcv[0] = 0;
  Object call680 = callmethodflags(call679, "variety", 1, partcv, params, 0);
  gc_frame_end(callframe677);
// compiled member node returning call680 (depth = 5)
  int op_slot_left_674 = gc_frame_newslot(call680);
  params[0] = strlit675;
  partcv[0] = 1;
  Object opresult681 = callmethod(call680, "==(1)", 1, partcv, params);
// compiled op node returning opresult681 (depth = 4)
  Object if673 = done;
  if (istrue(opresult681)) {
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit683 == NULL) {
    strlit683 = alloc_String("");
    gc_root(strlit683);
  }
// compiled string node returning strlit683 (depth = 5)
  int op_slot_right_682 = gc_frame_newslot(strlit683);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe686 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call687 = callmethodflags(self, "description", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe686);
// compiled member node returning call687 (depth = 6)
  int op_slot_right_685 = gc_frame_newslot(call687);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit690 == NULL) {
    strlit690 = alloc_String(" ");
    gc_root(strlit690);
  }
// compiled string node returning strlit690 (depth = 7)
  int op_slot_right_689 = gc_frame_newslot(strlit690);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe693 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call694 = callmethodflags(self, "range", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe693);
// compiled member node returning call694 (depth = 8)
  int op_slot_right_692 = gc_frame_newslot(call694);
// starting to compile string node (depth = 8)
  if (strlit696 == NULL) {
    strlit696 = alloc_String("");
    gc_root(strlit696);
  }
// compiled string node returning strlit696 (depth = 8)
  int op_slot_left_692 = gc_frame_newslot(strlit696);
  params[0] = call694;
  partcv[0] = 1;
  Object opresult697 = callmethod(strlit696, "++(1)", 1, partcv, params);
// compiled op node returning opresult697 (depth = 7)
  int op_slot_left_689 = gc_frame_newslot(opresult697);
  params[0] = strlit690;
  partcv[0] = 1;
  Object opresult698 = callmethod(opresult697, "++(1)", 1, partcv, params);
// compiled op node returning opresult698 (depth = 6)
  int op_slot_left_685 = gc_frame_newslot(opresult698);
  params[0] = call687;
  partcv[0] = 1;
  Object opresult699 = callmethod(opresult698, "++(1)", 1, partcv, params);
// compiled op node returning opresult699 (depth = 5)
  int op_slot_left_682 = gc_frame_newslot(opresult699);
  params[0] = strlit683;
  partcv[0] = 1;
  Object opresult700 = callmethod(opresult699, "++(1)", 1, partcv, params);
// compiled op node returning opresult700 (depth = 4)
    gc_frame_newslot(opresult700);
    if673 = opresult700;
  } else {
// Begin line 306
  setline(306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit702 == NULL) {
    strlit702 = alloc_String("");
    gc_root(strlit702);
  }
// compiled string node returning strlit702 (depth = 5)
  int op_slot_right_701 = gc_frame_newslot(strlit702);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe705 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe706 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call707 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe706);
// compiled member node returning call707 (depth = 7)
  partcv[0] = 0;
  Object call708 = callmethodflags(call707, "asDebugString", 1, partcv, params, 0);
  gc_frame_end(callframe705);
// compiled member node returning call708 (depth = 6)
  int op_slot_right_704 = gc_frame_newslot(call708);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit711 == NULL) {
    strlit711 = alloc_String(" ");
    gc_root(strlit711);
  }
// compiled string node returning strlit711 (depth = 7)
  int op_slot_right_710 = gc_frame_newslot(strlit711);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe714 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call715 = callmethodflags(self, "description", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe714);
// compiled member node returning call715 (depth = 8)
  int op_slot_right_713 = gc_frame_newslot(call715);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit718 == NULL) {
    strlit718 = alloc_String(" ");
    gc_root(strlit718);
  }
// compiled string node returning strlit718 (depth = 9)
  int op_slot_right_717 = gc_frame_newslot(strlit718);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe721 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call722 = callmethodflags(self, "range", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe721);
// compiled member node returning call722 (depth = 10)
  int op_slot_right_720 = gc_frame_newslot(call722);
// starting to compile string node (depth = 10)
  if (strlit724 == NULL) {
    strlit724 = alloc_String("");
    gc_root(strlit724);
  }
// compiled string node returning strlit724 (depth = 10)
  int op_slot_left_720 = gc_frame_newslot(strlit724);
  params[0] = call722;
  partcv[0] = 1;
  Object opresult725 = callmethod(strlit724, "++(1)", 1, partcv, params);
// compiled op node returning opresult725 (depth = 9)
  int op_slot_left_717 = gc_frame_newslot(opresult725);
  params[0] = strlit718;
  partcv[0] = 1;
  Object opresult726 = callmethod(opresult725, "++(1)", 1, partcv, params);
// compiled op node returning opresult726 (depth = 8)
  int op_slot_left_713 = gc_frame_newslot(opresult726);
  params[0] = call715;
  partcv[0] = 1;
  Object opresult727 = callmethod(opresult726, "++(1)", 1, partcv, params);
// compiled op node returning opresult727 (depth = 7)
  int op_slot_left_710 = gc_frame_newslot(opresult727);
  params[0] = strlit711;
  partcv[0] = 1;
  Object opresult728 = callmethod(opresult727, "++(1)", 1, partcv, params);
// compiled op node returning opresult728 (depth = 6)
  int op_slot_left_704 = gc_frame_newslot(opresult728);
  params[0] = call708;
  partcv[0] = 1;
  Object opresult729 = callmethod(opresult728, "++(1)", 1, partcv, params);
// compiled op node returning opresult729 (depth = 5)
  int op_slot_left_701 = gc_frame_newslot(opresult729);
  params[0] = strlit702;
  partcv[0] = 1;
  Object opresult730 = callmethod(opresult729, "++(1)", 1, partcv, params);
// compiled op node returning opresult730 (depth = 4)
    gc_frame_newslot(opresult730);
    if673 = opresult730;
  }
// compiled if node returning if673 (depth = 3)
    gc_frame_newslot(if673);
    if596 = if673;
  }
// compiled if node returning if596 (depth = 2)
  gc_frame_end(frame);
  return if596;
}
Object meth_ast_731_basePretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "basePretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method basePretty(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for basePretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part basePretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 309
  setline(309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe732 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_depth (depth = 3)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call733 = callmethodflags(self, "prettyPrefix(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe732);
// compiled call node returning call733 (depth = 2)
  gc_frame_end(frame);
  return call733;
}
Object meth_ast_734_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 310
  setline(310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe735 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_depth (depth = 3)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call736 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe735);
// compiled call node returning call736 (depth = 2)
  gc_frame_end(frame);
  return call736;
}
Object meth_ast_740__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_each (depth = 4)
  gc_frame_end(frame);
  return *var_each;
}
Object meth_ast_737_deepCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 69, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "deepCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_ancestorChain = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 312
  setline(312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe738 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block739 = alloc_Block(NULL, NULL, "ast", 312);
  gc_frame_newslot(block739);
// method "_apply(_)"
  block_savedest(block739);
  Object closure740 = createclosure(1, "_apply(1)");
  setclosureframe(closure740, stackframe);
  addtoclosure(closure740, selfslot);
  struct UserObject *uo740 = (struct UserObject*)block739;
  uo740->data[0] = (Object)closure740;
  Method *meth_meth_ast_740__apply_40_1_41_ = addmethod2pos(block739, "_apply(1)", &meth_ast_740__apply_40_1_41_, 0);
  int argcv_meth_ast_740__apply_40_1_41_[] = {1};
  meth_meth_ast_740__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_740__apply_40_1_41_);
  meth_meth_ast_740__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_740__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block739 (depth = 3)
  gc_frame_newslot(block739);
// starting to compile member node (depth = 3)
  int callframe742 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ancestorChain (depth = 4)
  partcv[0] = 0;
  Object call743 = callmethodflags(*var_ancestorChain, "empty", 1, partcv, params, 0);
  gc_frame_end(callframe742);
// compiled member node returning call743 (depth = 3)
  gc_frame_newslot(call743);
// call case 4: self request
  params[0] = block739;
  params[1] = call743;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call744 = callmethodflags(self, "map(1)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe738);
// compiled call node returning call744 (depth = 2)
  gc_frame_end(frame);
  return call744;
}
Object meth_ast_745_enclosingObject(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "enclosingObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_obj = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "obj");
// Begin line 315
  setline(315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe746 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe747 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe748 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call749 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe748);
// compiled member node returning call749 (depth = 5)
  partcv[0] = 0;
  Object call750 = callmethodflags(call749, "enclosingObjectScope", 1, partcv, params, 0);
  gc_frame_end(callframe747);
// compiled member node returning call750 (depth = 4)
  partcv[0] = 0;
  Object call751 = callmethodflags(call750, "node", 1, partcv, params, 0);
  gc_frame_end(callframe746);
// compiled member node returning call751 (depth = 3)
  *var_obj = call751;
  if (call751 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 316
  setline(316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_obj (depth = 2)
  gc_frame_end(frame);
  return *var_obj;
}
Object meth_ast_752_addComment_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addComment(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addComment(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addComment(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cmtNode = &(stackframe->slots[0]);
  *var_cmtNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addComment(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 319
  setline(319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe755 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call756 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe755);
// compiled member node returning call756 (depth = 4)
  int op_slot_right_754 = gc_frame_newslot(call756);
// starting to compile identifier node (depth = 4)
  Object bool758 = alloc_Boolean(0);
// compiled identifier node returning bool758 (depth = 4)
  int op_slot_left_754 = gc_frame_newslot(bool758);
  params[0] = call756;
  partcv[0] = 1;
  Object opresult759 = callmethod(bool758, "==(1)", 1, partcv, params);
// compiled op node returning opresult759 (depth = 3)
  Object if753 = done;
  if (istrue(opresult759)) {
// Begin line 320
  setline(320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe760 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cmtNode (depth = 4)
  gc_frame_newslot(*var_cmtNode);
// call case 4: self request
  params[0] = *var_cmtNode;
  partcv[0] = 1;
  Object call761 = callmethodflags(self, "comments:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe760);
// compiled call node returning call761 (depth = 3)
    gc_frame_newslot(call761);
    if753 = call761;
  } else {
// Begin line 322
  setline(322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe762 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cmtNode (depth = 4)
  gc_frame_newslot(*var_cmtNode);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe763 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call764 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe763);
// compiled member node returning call764 (depth = 4)
  params[0] = *var_cmtNode;
  partcv[0] = 1;
  Object call765 = callmethodflags(call764, "extendCommentUsing(1)", 1, partcv, params, 0);
  gc_frame_end(callframe762);
// compiled call node returning call765 (depth = 3)
    gc_frame_newslot(call765);
    if753 = call765;
  }
// compiled if node returning if753 (depth = 2)
  gc_frame_end(frame);
  return if753;
}
Object meth_ast_769__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 4)
  int callframe770 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 4: self request
  params[0] = *var_each;
  partcv[0] = 1;
  Object call771 = callmethodflags(self, "addComment(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe770);
// compiled call node returning call771 (depth = 4)
  gc_frame_end(frame);
  return call771;
}
Object meth_ast_766_addComments_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addComments(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addComments(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addComments(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cmtNodeList = &(stackframe->slots[0]);
  *var_cmtNodeList = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addComments(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 326
  setline(326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe767 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block768 = alloc_Block(NULL, NULL, "ast", 326);
  gc_frame_newslot(block768);
// method "_apply(_)"
  block_savedest(block768);
  Object closure769 = createclosure(1, "_apply(1)");
  setclosureframe(closure769, stackframe);
  addtoclosure(closure769, selfslot);
  struct UserObject *uo769 = (struct UserObject*)block768;
  uo769->data[0] = (Object)closure769;
  Method *meth_meth_ast_769__apply_40_1_41_ = addmethod2pos(block768, "_apply(1)", &meth_ast_769__apply_40_1_41_, 0);
  int argcv_meth_ast_769__apply_40_1_41_[] = {1};
  meth_meth_ast_769__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_769__apply_40_1_41_);
  meth_meth_ast_769__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_769__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block768 (depth = 3)
  gc_frame_newslot(block768);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cmtNodeList (depth = 3)
  params[0] = block768;
  partcv[0] = 1;
  Object call773 = callmethodflags(*var_cmtNodeList, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe767);
// compiled call node returning call773 (depth = 2)
  gc_frame_end(frame);
  return call773;
}
Object meth_ast_774_statementName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe775 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call776 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe775);
// compiled member node returning call776 (depth = 2)
  gc_frame_end(frame);
  return call776;
}
Object meth_ast_351_baseNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "baseNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  Object *var_ancestorChain = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_fakeSymbolTable = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject352 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj352 = alloc_userobj2(78,74, objclass352);
  gc_frame_newslot(obj352);
  if (objclass352 == NULL) {
    glfree(obj352->class->name);
    obj352->class->name = "baseNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj352, self, 0);
  addmethodreal(obj352,"outer", &reader_ast_outer_353);
  Object oldself352 = self;
  struct StackFrameObject *oldstackframe352 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe352);
  gc_frame_newslot((Object)stackframe);
  self = obj352;
  Object *oldselfslot352 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter352 = (*(struct UserObject *)self).data[0], lowerouter352 = thisouter352;
  if (inheritingObject352) {
    struct UserObject *inho352 = (struct UserObject *)inheritingObject352;
    while (inho352->super != GraceDefaultObject) inho352 = (struct UserObject *)inho352->super;
    inho352->super = obj352;
    self = inheritingObject352;
    *selfslot = self;
    lowerouter352 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter352;
  }
  if (objclass352 == NULL) {
    Method *reader354 = addmethodrealflags(obj352, "register", &reader_ast_register_354, 0);
    Method *writer354 = addmethodrealflags(obj352, "register:=(1)", &writer_ast_register_354, 0);
    reader354->definitionModule = modulename;
    writer354->definitionModule = modulename;
    reader354->definitionLine = 194;
    writer354->definitionLine = 194;
  }
  obj352->flags |= OFLAG_MUTABLE;
  adddatum2(obj352, alloc_Undefined(), 1);
  if (objclass352 == NULL) {
    Method *reader355 = addmethodrealflags(obj352, "line", &reader_ast_line_355, 0);
    Method *writer355 = addmethodrealflags(obj352, "line:=(1)", &writer_ast_line_355, 0);
    reader355->definitionModule = modulename;
    writer355->definitionModule = modulename;
    reader355->definitionLine = 195;
    writer355->definitionLine = 195;
  }
  obj352->flags |= OFLAG_MUTABLE;
  adddatum2(obj352, alloc_Undefined(), 2);
  if (objclass352 == NULL) {
    Method *reader356 = addmethodrealflags(obj352, "linePos", &reader_ast_linePos_356, 0);
    Method *writer356 = addmethodrealflags(obj352, "linePos:=(1)", &writer_ast_linePos_356, 0);
    reader356->definitionModule = modulename;
    writer356->definitionModule = modulename;
    reader356->definitionLine = 196;
    writer356->definitionLine = 196;
  }
  obj352->flags |= OFLAG_MUTABLE;
  adddatum2(obj352, alloc_Undefined(), 3);
  if (objclass352 == NULL) {
    Method *reader357 = addmethodrealflags(obj352, "symbolTable", &reader_ast_symbolTable_357, MFLAG_CONFIDENTIAL);
    Method *writer357 = addmethodrealflags(obj352, "symbolTable:=(1)", &writer_ast_symbolTable_357, MFLAG_CONFIDENTIAL);
    reader357->definitionModule = modulename;
    writer357->definitionModule = modulename;
    reader357->definitionLine = 197;
    writer357->definitionLine = 197;
  }
  obj352->flags |= OFLAG_MUTABLE;
  adddatum2(obj352, alloc_Undefined(), 4);
  if (objclass352 == NULL) {
    Method *reader358 = addmethodrealflags(obj352, "comments", &reader_ast_comments_358, 0);
    Method *writer358 = addmethodrealflags(obj352, "comments:=(1)", &writer_ast_comments_358, 0);
    reader358->definitionModule = modulename;
    writer358->definitionModule = modulename;
    reader358->definitionLine = 198;
    writer358->definitionLine = 198;
  }
  obj352->flags |= OFLAG_MUTABLE;
  adddatum2(obj352, alloc_Undefined(), 5);
// method "setLine(_)col(_)"
  struct UserObject *uo359 = (struct UserObject*)obj352;
  uo359->data[6] = emptyclosure;
  Method *meth_meth_ast_359_setLine_40_1_41_col_40_1_41_ = addmethod2pos(obj352, "setLine(1)col(1)", &meth_ast_359_setLine_40_1_41_col_40_1_41_, 6);
  int argcv_meth_ast_359_setLine_40_1_41_col_40_1_41_[] = {1, 1};
  meth_meth_ast_359_setLine_40_1_41_col_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_359_setLine_40_1_41_col_40_1_41_);
  meth_meth_ast_359_setLine_40_1_41_col_40_1_41_->definitionModule = modulename;
  meth_meth_ast_359_setLine_40_1_41_col_40_1_41_->definitionLine = 200;
// method "setPositionFrom(_)"
  struct UserObject *uo364 = (struct UserObject*)obj352;
  uo364->data[7] = emptyclosure;
  Method *meth_meth_ast_364_setPositionFrom_40_1_41_ = addmethod2pos(obj352, "setPositionFrom(1)", &meth_ast_364_setPositionFrom_40_1_41_, 7);
  int argcv_meth_ast_364_setPositionFrom_40_1_41_[] = {1};
  meth_meth_ast_364_setPositionFrom_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_364_setPositionFrom_40_1_41_);
  meth_meth_ast_364_setPositionFrom_40_1_41_->definitionModule = modulename;
  meth_meth_ast_364_setPositionFrom_40_1_41_->definitionLine = 205;
// method "setStart(_)"
  struct UserObject *uo373 = (struct UserObject*)obj352;
  uo373->data[8] = emptyclosure;
  Method *meth_meth_ast_373_setStart_40_1_41_ = addmethod2pos(obj352, "setStart(1)", &meth_ast_373_setStart_40_1_41_, 8);
  int argcv_meth_ast_373_setStart_40_1_41_[] = {1};
  meth_meth_ast_373_setStart_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_373_setStart_40_1_41_);
  meth_meth_ast_373_setStart_40_1_41_->definitionModule = modulename;
  meth_meth_ast_373_setStart_40_1_41_->definitionLine = 210;
// method "column"
  struct UserObject *uo382 = (struct UserObject*)obj352;
  uo382->data[9] = emptyclosure;
  Method *meth_meth_ast_382_column = addmethod2pos(obj352, "column", &meth_ast_382_column, 9);
  int argcv_meth_ast_382_column[] = {0};
  meth_meth_ast_382_column->type = alloc_MethodType(1, argcv_meth_ast_382_column);
  meth_meth_ast_382_column->definitionModule = modulename;
  meth_meth_ast_382_column->definitionLine = 215;
// method "start"
  struct UserObject *uo385 = (struct UserObject*)obj352;
  uo385->data[10] = emptyclosure;
  Method *meth_meth_ast_385_start = addmethod2pos(obj352, "start", &meth_ast_385_start, 10);
  int argcv_meth_ast_385_start[] = {0};
  meth_meth_ast_385_start->type = alloc_MethodType(1, argcv_meth_ast_385_start);
  meth_meth_ast_385_start->definitionModule = modulename;
  meth_meth_ast_385_start->definitionLine = 216;
// method "end"
  struct UserObject *uo392 = (struct UserObject*)obj352;
  uo392->data[11] = emptyclosure;
  Method *meth_meth_ast_392_end = addmethod2pos(obj352, "end", &meth_ast_392_end, 11);
  int argcv_meth_ast_392_end[] = {0};
  meth_meth_ast_392_end->type = alloc_MethodType(1, argcv_meth_ast_392_end);
  meth_meth_ast_392_end->definitionModule = modulename;
  meth_meth_ast_392_end->definitionLine = 217;
// method "range"
  struct UserObject *uo410 = (struct UserObject*)obj352;
  uo410->data[12] = emptyclosure;
  Method *meth_meth_ast_410_range = addmethod2pos(obj352, "range", &meth_ast_410_range, 12);
  int argcv_meth_ast_410_range[] = {0};
  meth_meth_ast_410_range->type = alloc_MethodType(1, argcv_meth_ast_410_range);
  meth_meth_ast_410_range->definitionModule = modulename;
  meth_meth_ast_410_range->definitionLine = 218;
// method "kind"
  struct UserObject *uo417 = (struct UserObject*)obj352;
  uo417->data[13] = emptyclosure;
  Method *meth_meth_ast_417_kind = addmethod2pos(obj352, "kind", &meth_ast_417_kind, 13);
  int argcv_meth_ast_417_kind[] = {0};
  meth_meth_ast_417_kind->type = alloc_MethodType(1, argcv_meth_ast_417_kind);
  meth_meth_ast_417_kind->definitionModule = modulename;
  meth_meth_ast_417_kind->definitionLine = 219;
// method "==(_)"
  struct UserObject *uo420 = (struct UserObject*)obj352;
  uo420->data[14] = emptyclosure;
  Method *meth_meth_ast_420__61__61__40_1_41_ = addmethod2pos(obj352, "==(1)", &meth_ast_420__61__61__40_1_41_, 14);
  int argcv_meth_ast_420__61__61__40_1_41_[] = {1};
  meth_meth_ast_420__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_420__61__61__40_1_41_);
  meth_meth_ast_420__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_420__61__61__40_1_41_->definitionLine = 220;
// method "isAppliedOccurenceOfIdentifier"
  struct UserObject *uo423 = (struct UserObject*)obj352;
  uo423->data[15] = emptyclosure;
  Method *meth_meth_ast_423_isAppliedOccurenceOfIdentifier = addmethod2pos(obj352, "isAppliedOccurenceOfIdentifier", &meth_ast_423_isAppliedOccurenceOfIdentifier, 15);
  int argcv_meth_ast_423_isAppliedOccurenceOfIdentifier[] = {0};
  meth_meth_ast_423_isAppliedOccurenceOfIdentifier->type = alloc_MethodType(1, argcv_meth_ast_423_isAppliedOccurenceOfIdentifier);
  meth_meth_ast_423_isAppliedOccurenceOfIdentifier->definitionModule = modulename;
  meth_meth_ast_423_isAppliedOccurenceOfIdentifier->definitionLine = 221;
// method "isMatchingBlock"
  struct UserObject *uo425 = (struct UserObject*)obj352;
  uo425->data[16] = emptyclosure;
  Method *meth_meth_ast_425_isMatchingBlock = addmethod2pos(obj352, "isMatchingBlock", &meth_ast_425_isMatchingBlock, 16);
  int argcv_meth_ast_425_isMatchingBlock[] = {0};
  meth_meth_ast_425_isMatchingBlock->type = alloc_MethodType(1, argcv_meth_ast_425_isMatchingBlock);
  meth_meth_ast_425_isMatchingBlock->definitionModule = modulename;
  meth_meth_ast_425_isMatchingBlock->definitionLine = 222;
// method "isFieldDec"
  struct UserObject *uo427 = (struct UserObject*)obj352;
  uo427->data[17] = emptyclosure;
  Method *meth_meth_ast_427_isFieldDec = addmethod2pos(obj352, "isFieldDec", &meth_ast_427_isFieldDec, 17);
  int argcv_meth_ast_427_isFieldDec[] = {0};
  meth_meth_ast_427_isFieldDec->type = alloc_MethodType(1, argcv_meth_ast_427_isFieldDec);
  meth_meth_ast_427_isFieldDec->definitionModule = modulename;
  meth_meth_ast_427_isFieldDec->definitionLine = 223;
// method "isInherits"
  struct UserObject *uo429 = (struct UserObject*)obj352;
  uo429->data[18] = emptyclosure;
  Method *meth_meth_ast_429_isInherits = addmethod2pos(obj352, "isInherits", &meth_ast_429_isInherits, 18);
  int argcv_meth_ast_429_isInherits[] = {0};
  meth_meth_ast_429_isInherits->type = alloc_MethodType(1, argcv_meth_ast_429_isInherits);
  meth_meth_ast_429_isInherits->definitionModule = modulename;
  meth_meth_ast_429_isInherits->definitionLine = 224;
// method "isLegalInTrait"
  struct UserObject *uo431 = (struct UserObject*)obj352;
  uo431->data[19] = emptyclosure;
  Method *meth_meth_ast_431_isLegalInTrait = addmethod2pos(obj352, "isLegalInTrait", &meth_ast_431_isLegalInTrait, 19);
  int argcv_meth_ast_431_isLegalInTrait[] = {0};
  meth_meth_ast_431_isLegalInTrait->type = alloc_MethodType(1, argcv_meth_ast_431_isLegalInTrait);
  meth_meth_ast_431_isLegalInTrait->definitionModule = modulename;
  meth_meth_ast_431_isLegalInTrait->definitionLine = 225;
// method "isMember"
  struct UserObject *uo433 = (struct UserObject*)obj352;
  uo433->data[20] = emptyclosure;
  Method *meth_meth_ast_433_isMember = addmethod2pos(obj352, "isMember", &meth_ast_433_isMember, 20);
  int argcv_meth_ast_433_isMember[] = {0};
  meth_meth_ast_433_isMember->type = alloc_MethodType(1, argcv_meth_ast_433_isMember);
  meth_meth_ast_433_isMember->definitionModule = modulename;
  meth_meth_ast_433_isMember->definitionLine = 226;
// method "isMethod"
  struct UserObject *uo435 = (struct UserObject*)obj352;
  uo435->data[21] = emptyclosure;
  Method *meth_meth_ast_435_isMethod = addmethod2pos(obj352, "isMethod", &meth_ast_435_isMethod, 21);
  int argcv_meth_ast_435_isMethod[] = {0};
  meth_meth_ast_435_isMethod->type = alloc_MethodType(1, argcv_meth_ast_435_isMethod);
  meth_meth_ast_435_isMethod->definitionModule = modulename;
  meth_meth_ast_435_isMethod->definitionLine = 227;
// method "isExecutable"
  struct UserObject *uo437 = (struct UserObject*)obj352;
  uo437->data[22] = emptyclosure;
  Method *meth_meth_ast_437_isExecutable = addmethod2pos(obj352, "isExecutable", &meth_ast_437_isExecutable, 22);
  int argcv_meth_ast_437_isExecutable[] = {0};
  meth_meth_ast_437_isExecutable->type = alloc_MethodType(1, argcv_meth_ast_437_isExecutable);
  meth_meth_ast_437_isExecutable->definitionModule = modulename;
  meth_meth_ast_437_isExecutable->definitionLine = 228;
// method "isCall"
  struct UserObject *uo439 = (struct UserObject*)obj352;
  uo439->data[23] = emptyclosure;
  Method *meth_meth_ast_439_isCall = addmethod2pos(obj352, "isCall", &meth_ast_439_isCall, 23);
  int argcv_meth_ast_439_isCall[] = {0};
  meth_meth_ast_439_isCall->type = alloc_MethodType(1, argcv_meth_ast_439_isCall);
  meth_meth_ast_439_isCall->definitionModule = modulename;
  meth_meth_ast_439_isCall->definitionLine = 229;
// method "isComment"
  struct UserObject *uo441 = (struct UserObject*)obj352;
  uo441->data[24] = emptyclosure;
  Method *meth_meth_ast_441_isComment = addmethod2pos(obj352, "isComment", &meth_ast_441_isComment, 24);
  int argcv_meth_ast_441_isComment[] = {0};
  meth_meth_ast_441_isComment->type = alloc_MethodType(1, argcv_meth_ast_441_isComment);
  meth_meth_ast_441_isComment->definitionModule = modulename;
  meth_meth_ast_441_isComment->definitionLine = 230;
// method "isClass"
  struct UserObject *uo443 = (struct UserObject*)obj352;
  uo443->data[25] = emptyclosure;
  Method *meth_meth_ast_443_isClass = addmethod2pos(obj352, "isClass", &meth_ast_443_isClass, 25);
  int argcv_meth_ast_443_isClass[] = {0};
  meth_meth_ast_443_isClass->type = alloc_MethodType(1, argcv_meth_ast_443_isClass);
  meth_meth_ast_443_isClass->definitionModule = modulename;
  meth_meth_ast_443_isClass->definitionLine = 231;
// method "inClass"
  struct UserObject *uo445 = (struct UserObject*)obj352;
  uo445->data[26] = emptyclosure;
  Method *meth_meth_ast_445_inClass = addmethod2pos(obj352, "inClass", &meth_ast_445_inClass, 26);
  int argcv_meth_ast_445_inClass[] = {0};
  meth_meth_ast_445_inClass->type = alloc_MethodType(1, argcv_meth_ast_445_inClass);
  meth_meth_ast_445_inClass->definitionModule = modulename;
  meth_meth_ast_445_inClass->definitionLine = 232;
// method "isTrait"
  struct UserObject *uo447 = (struct UserObject*)obj352;
  uo447->data[27] = emptyclosure;
  Method *meth_meth_ast_447_isTrait = addmethod2pos(obj352, "isTrait", &meth_ast_447_isTrait, 27);
  int argcv_meth_ast_447_isTrait[] = {0};
  meth_meth_ast_447_isTrait->type = alloc_MethodType(1, argcv_meth_ast_447_isTrait);
  meth_meth_ast_447_isTrait->definitionModule = modulename;
  meth_meth_ast_447_isTrait->definitionLine = 233;
// method "inTrait"
  struct UserObject *uo449 = (struct UserObject*)obj352;
  uo449->data[28] = emptyclosure;
  Method *meth_meth_ast_449_inTrait = addmethod2pos(obj352, "inTrait", &meth_ast_449_inTrait, 28);
  int argcv_meth_ast_449_inTrait[] = {0};
  meth_meth_ast_449_inTrait->type = alloc_MethodType(1, argcv_meth_ast_449_inTrait);
  meth_meth_ast_449_inTrait->definitionModule = modulename;
  meth_meth_ast_449_inTrait->definitionLine = 234;
// method "isBind"
  struct UserObject *uo451 = (struct UserObject*)obj352;
  uo451->data[29] = emptyclosure;
  Method *meth_meth_ast_451_isBind = addmethod2pos(obj352, "isBind", &meth_ast_451_isBind, 29);
  int argcv_meth_ast_451_isBind[] = {0};
  meth_meth_ast_451_isBind->type = alloc_MethodType(1, argcv_meth_ast_451_isBind);
  meth_meth_ast_451_isBind->definitionModule = modulename;
  meth_meth_ast_451_isBind->definitionLine = 235;
// method "isReturn"
  struct UserObject *uo453 = (struct UserObject*)obj352;
  uo453->data[30] = emptyclosure;
  Method *meth_meth_ast_453_isReturn = addmethod2pos(obj352, "isReturn", &meth_ast_453_isReturn, 30);
  int argcv_meth_ast_453_isReturn[] = {0};
  meth_meth_ast_453_isReturn->type = alloc_MethodType(1, argcv_meth_ast_453_isReturn);
  meth_meth_ast_453_isReturn->definitionModule = modulename;
  meth_meth_ast_453_isReturn->definitionLine = 236;
// method "isSelf"
  struct UserObject *uo455 = (struct UserObject*)obj352;
  uo455->data[31] = emptyclosure;
  Method *meth_meth_ast_455_isSelf = addmethod2pos(obj352, "isSelf", &meth_ast_455_isSelf, 31);
  int argcv_meth_ast_455_isSelf[] = {0};
  meth_meth_ast_455_isSelf->type = alloc_MethodType(1, argcv_meth_ast_455_isSelf);
  meth_meth_ast_455_isSelf->definitionModule = modulename;
  meth_meth_ast_455_isSelf->definitionLine = 237;
// method "isSuper"
  struct UserObject *uo457 = (struct UserObject*)obj352;
  uo457->data[32] = emptyclosure;
  Method *meth_meth_ast_457_isSuper = addmethod2pos(obj352, "isSuper", &meth_ast_457_isSuper, 32);
  int argcv_meth_ast_457_isSuper[] = {0};
  meth_meth_ast_457_isSuper->type = alloc_MethodType(1, argcv_meth_ast_457_isSuper);
  meth_meth_ast_457_isSuper->definitionModule = modulename;
  meth_meth_ast_457_isSuper->definitionLine = 238;
// method "isPrelude"
  struct UserObject *uo459 = (struct UserObject*)obj352;
  uo459->data[33] = emptyclosure;
  Method *meth_meth_ast_459_isPrelude = addmethod2pos(obj352, "isPrelude", &meth_ast_459_isPrelude, 33);
  int argcv_meth_ast_459_isPrelude[] = {0};
  meth_meth_ast_459_isPrelude->type = alloc_MethodType(1, argcv_meth_ast_459_isPrelude);
  meth_meth_ast_459_isPrelude->definitionModule = modulename;
  meth_meth_ast_459_isPrelude->definitionLine = 239;
// method "isOuter"
  struct UserObject *uo461 = (struct UserObject*)obj352;
  uo461->data[34] = emptyclosure;
  Method *meth_meth_ast_461_isOuter = addmethod2pos(obj352, "isOuter", &meth_ast_461_isOuter, 34);
  int argcv_meth_ast_461_isOuter[] = {0};
  meth_meth_ast_461_isOuter->type = alloc_MethodType(1, argcv_meth_ast_461_isOuter);
  meth_meth_ast_461_isOuter->definitionModule = modulename;
  meth_meth_ast_461_isOuter->definitionLine = 240;
// method "isSelfOrOuter"
  struct UserObject *uo463 = (struct UserObject*)obj352;
  uo463->data[35] = emptyclosure;
  Method *meth_meth_ast_463_isSelfOrOuter = addmethod2pos(obj352, "isSelfOrOuter", &meth_ast_463_isSelfOrOuter, 35);
  int argcv_meth_ast_463_isSelfOrOuter[] = {0};
  meth_meth_ast_463_isSelfOrOuter->type = alloc_MethodType(1, argcv_meth_ast_463_isSelfOrOuter);
  meth_meth_ast_463_isSelfOrOuter->definitionModule = modulename;
  meth_meth_ast_463_isSelfOrOuter->definitionLine = 241;
// method "isBlock"
  struct UserObject *uo465 = (struct UserObject*)obj352;
  uo465->data[36] = emptyclosure;
  Method *meth_meth_ast_465_isBlock = addmethod2pos(obj352, "isBlock", &meth_ast_465_isBlock, 36);
  int argcv_meth_ast_465_isBlock[] = {0};
  meth_meth_ast_465_isBlock->type = alloc_MethodType(1, argcv_meth_ast_465_isBlock);
  meth_meth_ast_465_isBlock->definitionModule = modulename;
  meth_meth_ast_465_isBlock->definitionLine = 242;
// method "isObject"
  struct UserObject *uo467 = (struct UserObject*)obj352;
  uo467->data[37] = emptyclosure;
  Method *meth_meth_ast_467_isObject = addmethod2pos(obj352, "isObject", &meth_ast_467_isObject, 37);
  int argcv_meth_ast_467_isObject[] = {0};
  meth_meth_ast_467_isObject->type = alloc_MethodType(1, argcv_meth_ast_467_isObject);
  meth_meth_ast_467_isObject->definitionModule = modulename;
  meth_meth_ast_467_isObject->definitionLine = 243;
// method "isIdentifier"
  struct UserObject *uo469 = (struct UserObject*)obj352;
  uo469->data[38] = emptyclosure;
  Method *meth_meth_ast_469_isIdentifier = addmethod2pos(obj352, "isIdentifier", &meth_ast_469_isIdentifier, 38);
  int argcv_meth_ast_469_isIdentifier[] = {0};
  meth_meth_ast_469_isIdentifier->type = alloc_MethodType(1, argcv_meth_ast_469_isIdentifier);
  meth_meth_ast_469_isIdentifier->definitionModule = modulename;
  meth_meth_ast_469_isIdentifier->definitionLine = 244;
// method "isDialect"
  struct UserObject *uo471 = (struct UserObject*)obj352;
  uo471->data[39] = emptyclosure;
  Method *meth_meth_ast_471_isDialect = addmethod2pos(obj352, "isDialect", &meth_ast_471_isDialect, 39);
  int argcv_meth_ast_471_isDialect[] = {0};
  meth_meth_ast_471_isDialect->type = alloc_MethodType(1, argcv_meth_ast_471_isDialect);
  meth_meth_ast_471_isDialect->definitionModule = modulename;
  meth_meth_ast_471_isDialect->definitionLine = 245;
// method "isImport"
  struct UserObject *uo473 = (struct UserObject*)obj352;
  uo473->data[40] = emptyclosure;
  Method *meth_meth_ast_473_isImport = addmethod2pos(obj352, "isImport", &meth_ast_473_isImport, 40);
  int argcv_meth_ast_473_isImport[] = {0};
  meth_meth_ast_473_isImport->type = alloc_MethodType(1, argcv_meth_ast_473_isImport);
  meth_meth_ast_473_isImport->definitionModule = modulename;
  meth_meth_ast_473_isImport->definitionLine = 246;
// method "isTypeDec"
  struct UserObject *uo475 = (struct UserObject*)obj352;
  uo475->data[41] = emptyclosure;
  Method *meth_meth_ast_475_isTypeDec = addmethod2pos(obj352, "isTypeDec", &meth_ast_475_isTypeDec, 41);
  int argcv_meth_ast_475_isTypeDec[] = {0};
  meth_meth_ast_475_isTypeDec->type = alloc_MethodType(1, argcv_meth_ast_475_isTypeDec);
  meth_meth_ast_475_isTypeDec->definitionModule = modulename;
  meth_meth_ast_475_isTypeDec->definitionLine = 247;
// method "isExternal"
  struct UserObject *uo477 = (struct UserObject*)obj352;
  uo477->data[42] = emptyclosure;
  Method *meth_meth_ast_477_isExternal = addmethod2pos(obj352, "isExternal", &meth_ast_477_isExternal, 42);
  int argcv_meth_ast_477_isExternal[] = {0};
  meth_meth_ast_477_isExternal->type = alloc_MethodType(1, argcv_meth_ast_477_isExternal);
  meth_meth_ast_477_isExternal->definitionModule = modulename;
  meth_meth_ast_477_isExternal->definitionLine = 248;
// method "isFresh"
  struct UserObject *uo479 = (struct UserObject*)obj352;
  uo479->data[43] = emptyclosure;
  Method *meth_meth_ast_479_isFresh = addmethod2pos(obj352, "isFresh", &meth_ast_479_isFresh, 43);
  int argcv_meth_ast_479_isFresh[] = {0};
  meth_meth_ast_479_isFresh->type = alloc_MethodType(1, argcv_meth_ast_479_isFresh);
  meth_meth_ast_479_isFresh->definitionModule = modulename;
  meth_meth_ast_479_isFresh->definitionLine = 249;
// method "isConstant"
  struct UserObject *uo481 = (struct UserObject*)obj352;
  uo481->data[44] = emptyclosure;
  Method *meth_meth_ast_481_isConstant = addmethod2pos(obj352, "isConstant", &meth_ast_481_isConstant, 44);
  int argcv_meth_ast_481_isConstant[] = {0};
  meth_meth_ast_481_isConstant->type = alloc_MethodType(1, argcv_meth_ast_481_isConstant);
  meth_meth_ast_481_isConstant->definitionModule = modulename;
  meth_meth_ast_481_isConstant->definitionLine = 250;
// method "canInherit"
  struct UserObject *uo483 = (struct UserObject*)obj352;
  uo483->data[45] = emptyclosure;
  Method *meth_meth_ast_483_canInherit = addmethod2pos(obj352, "canInherit", &meth_ast_483_canInherit, 45);
  int argcv_meth_ast_483_canInherit[] = {0};
  meth_meth_ast_483_canInherit->type = alloc_MethodType(1, argcv_meth_ast_483_canInherit);
  meth_meth_ast_483_canInherit->definitionModule = modulename;
  meth_meth_ast_483_canInherit->definitionLine = 251;
// method "returnsObject"
  struct UserObject *uo485 = (struct UserObject*)obj352;
  uo485->data[46] = emptyclosure;
  Method *meth_meth_ast_485_returnsObject = addmethod2pos(obj352, "returnsObject", &meth_ast_485_returnsObject, 46);
  int argcv_meth_ast_485_returnsObject[] = {0};
  meth_meth_ast_485_returnsObject->type = alloc_MethodType(1, argcv_meth_ast_485_returnsObject);
  meth_meth_ast_485_returnsObject->definitionModule = modulename;
  meth_meth_ast_485_returnsObject->definitionLine = 252;
// method "isImplicit"
  struct UserObject *uo487 = (struct UserObject*)obj352;
  uo487->data[47] = emptyclosure;
  Method *meth_meth_ast_487_isImplicit = addmethod2pos(obj352, "isImplicit", &meth_ast_487_isImplicit, 47);
  int argcv_meth_ast_487_isImplicit[] = {0};
  meth_meth_ast_487_isImplicit->type = alloc_MethodType(1, argcv_meth_ast_487_isImplicit);
  meth_meth_ast_487_isImplicit->definitionModule = modulename;
  meth_meth_ast_487_isImplicit->definitionLine = 253;
// method "usesAsType(_)"
  struct UserObject *uo489 = (struct UserObject*)obj352;
  uo489->data[48] = emptyclosure;
  Method *meth_meth_ast_489_usesAsType_40_1_41_ = addmethod2pos(obj352, "usesAsType(1)", &meth_ast_489_usesAsType_40_1_41_, 48);
  int argcv_meth_ast_489_usesAsType_40_1_41_[] = {1};
  meth_meth_ast_489_usesAsType_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_489_usesAsType_40_1_41_);
  meth_meth_ast_489_usesAsType_40_1_41_->definitionModule = modulename;
  meth_meth_ast_489_usesAsType_40_1_41_->definitionLine = 254;
// method "hash"
  struct UserObject *uo491 = (struct UserObject*)obj352;
  uo491->data[49] = emptyclosure;
  Method *meth_meth_ast_491_hash = addmethod2pos(obj352, "hash", &meth_ast_491_hash, 49);
  int argcv_meth_ast_491_hash[] = {0};
  meth_meth_ast_491_hash->type = alloc_MethodType(1, argcv_meth_ast_491_hash);
  meth_meth_ast_491_hash->definitionModule = modulename;
  meth_meth_ast_491_hash->definitionLine = 255;
// method "asString"
  struct UserObject *uo503 = (struct UserObject*)obj352;
  uo503->data[50] = emptyclosure;
  Method *meth_meth_ast_503_asString = addmethod2pos(obj352, "asString", &meth_ast_503_asString, 50);
  int argcv_meth_ast_503_asString[] = {0};
  meth_meth_ast_503_asString->type = alloc_MethodType(1, argcv_meth_ast_503_asString);
  meth_meth_ast_503_asString->definitionModule = modulename;
  meth_meth_ast_503_asString->definitionLine = 256;
// method "nameString"
  struct UserObject *uo523 = (struct UserObject*)obj352;
  uo523->data[51] = emptyclosure;
  Method *meth_meth_ast_523_nameString = addmethod2pos(obj352, "nameString", &meth_ast_523_nameString, 51);
  int argcv_meth_ast_523_nameString[] = {0};
  meth_meth_ast_523_nameString->type = alloc_MethodType(1, argcv_meth_ast_523_nameString);
  meth_meth_ast_523_nameString->definitionModule = modulename;
  meth_meth_ast_523_nameString->definitionLine = 257;
// method "isWritable"
  struct UserObject *uo525 = (struct UserObject*)obj352;
  uo525->data[52] = emptyclosure;
  Method *meth_meth_ast_525_isWritable = addmethod2pos(obj352, "isWritable", &meth_ast_525_isWritable, 52);
  int argcv_meth_ast_525_isWritable[] = {0};
  meth_meth_ast_525_isWritable->type = alloc_MethodType(1, argcv_meth_ast_525_isWritable);
  meth_meth_ast_525_isWritable->definitionModule = modulename;
  meth_meth_ast_525_isWritable->definitionLine = 258;
// method "isReadable"
  struct UserObject *uo527 = (struct UserObject*)obj352;
  uo527->data[53] = emptyclosure;
  Method *meth_meth_ast_527_isReadable = addmethod2pos(obj352, "isReadable", &meth_ast_527_isReadable, 53);
  int argcv_meth_ast_527_isReadable[] = {0};
  meth_meth_ast_527_isReadable->type = alloc_MethodType(1, argcv_meth_ast_527_isReadable);
  meth_meth_ast_527_isReadable->definitionModule = modulename;
  meth_meth_ast_527_isReadable->definitionLine = 259;
// method "isPublic"
  struct UserObject *uo529 = (struct UserObject*)obj352;
  uo529->data[54] = emptyclosure;
  Method *meth_meth_ast_529_isPublic = addmethod2pos(obj352, "isPublic", &meth_ast_529_isPublic, 54);
  int argcv_meth_ast_529_isPublic[] = {0};
  meth_meth_ast_529_isPublic->type = alloc_MethodType(1, argcv_meth_ast_529_isPublic);
  meth_meth_ast_529_isPublic->definitionModule = modulename;
  meth_meth_ast_529_isPublic->definitionLine = 260;
// method "isConfidential"
  struct UserObject *uo531 = (struct UserObject*)obj352;
  uo531->data[55] = emptyclosure;
  Method *meth_meth_ast_531_isConfidential = addmethod2pos(obj352, "isConfidential", &meth_ast_531_isConfidential, 55);
  int argcv_meth_ast_531_isConfidential[] = {0};
  meth_meth_ast_531_isConfidential->type = alloc_MethodType(1, argcv_meth_ast_531_isConfidential);
  meth_meth_ast_531_isConfidential->definitionModule = modulename;
  meth_meth_ast_531_isConfidential->definitionLine = 261;
// method "decType"
  block_savedest(obj352);
  Object closure536 = createclosure(1, "decType");
  setclosureframe(closure536, stackframe);
  addtoclosure(closure536, var_unknownType);
  struct UserObject *uo536 = (struct UserObject*)obj352;
  uo536->data[56] = (Object)closure536;
  Method *meth_meth_ast_536_decType = addmethod2pos(obj352, "decType", &meth_ast_536_decType, 56);
  int argcv_meth_ast_536_decType[] = {0};
  meth_meth_ast_536_decType->type = alloc_MethodType(1, argcv_meth_ast_536_decType);
  meth_meth_ast_536_decType->definitionModule = modulename;
  meth_meth_ast_536_decType->definitionLine = 262;
// method "isSimple"
  struct UserObject *uo546 = (struct UserObject*)obj352;
  uo546->data[57] = emptyclosure;
  Method *meth_meth_ast_546_isSimple = addmethod2pos(obj352, "isSimple", &meth_ast_546_isSimple, 57);
  int argcv_meth_ast_546_isSimple[] = {0};
  meth_meth_ast_546_isSimple->type = alloc_MethodType(1, argcv_meth_ast_546_isSimple);
  meth_meth_ast_546_isSimple->definitionModule = modulename;
  meth_meth_ast_546_isSimple->definitionLine = 268;
// method "isDelimited"
  struct UserObject *uo548 = (struct UserObject*)obj352;
  uo548->data[58] = emptyclosure;
  Method *meth_meth_ast_548_isDelimited = addmethod2pos(obj352, "isDelimited", &meth_ast_548_isDelimited, 58);
  int argcv_meth_ast_548_isDelimited[] = {0};
  meth_meth_ast_548_isDelimited->type = alloc_MethodType(1, argcv_meth_ast_548_isDelimited);
  meth_meth_ast_548_isDelimited->definitionModule = modulename;
  meth_meth_ast_548_isDelimited->definitionLine = 269;
// method "description"
  struct UserObject *uo550 = (struct UserObject*)obj352;
  uo550->data[59] = emptyclosure;
  Method *meth_meth_ast_550_description = addmethod2pos(obj352, "description", &meth_ast_550_description, 59);
  int argcv_meth_ast_550_description[] = {0};
  meth_meth_ast_550_description->type = alloc_MethodType(1, argcv_meth_ast_550_description);
  meth_meth_ast_550_description->definitionModule = modulename;
  meth_meth_ast_550_description->definitionLine = 270;
// method "accept(_)"
  block_savedest(obj352);
  Object closure553 = createclosure(1, "accept(1)");
  setclosureframe(closure553, stackframe);
  addtoclosure(closure553, var_ancestorChain);
  struct UserObject *uo553 = (struct UserObject*)obj352;
  uo553->data[60] = (Object)closure553;
  Method *meth_meth_ast_553_accept_40_1_41_ = addmethod2pos(obj352, "accept(1)", &meth_ast_553_accept_40_1_41_, 60);
  int argcv_meth_ast_553_accept_40_1_41_[] = {1};
  meth_meth_ast_553_accept_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_553_accept_40_1_41_);
  meth_meth_ast_553_accept_40_1_41_->definitionModule = modulename;
  meth_meth_ast_553_accept_40_1_41_->definitionLine = 271;
// method "scope"
  struct UserObject *uo558 = (struct UserObject*)obj352;
  uo558->data[61] = emptyclosure;
  Method *meth_meth_ast_558_scope = addmethod2pos(obj352, "scope", &meth_ast_558_scope, 61);
  int argcv_meth_ast_558_scope[] = {0};
  meth_meth_ast_558_scope->type = alloc_MethodType(1, argcv_meth_ast_558_scope);
  meth_meth_ast_558_scope->definitionModule = modulename;
  meth_meth_ast_558_scope->definitionLine = 274;
// method "scope:=(_)"
  struct UserObject *uo561 = (struct UserObject*)obj352;
  uo561->data[62] = emptyclosure;
  Method *meth_meth_ast_561_scope_58__61__40_1_41_ = addmethod2pos(obj352, "scope:=(1)", &meth_ast_561_scope_58__61__40_1_41_, 62);
  int argcv_meth_ast_561_scope_58__61__40_1_41_[] = {1};
  meth_meth_ast_561_scope_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_561_scope_58__61__40_1_41_);
  meth_meth_ast_561_scope_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_561_scope_58__61__40_1_41_->definitionLine = 276;
// method "setScope(_)"
  struct UserObject *uo564 = (struct UserObject*)obj352;
  uo564->data[63] = emptyclosure;
  Method *meth_meth_ast_564_setScope_40_1_41_ = addmethod2pos(obj352, "setScope(1)", &meth_ast_564_setScope_40_1_41_, 63);
  int argcv_meth_ast_564_setScope_40_1_41_[] = {1};
  meth_meth_ast_564_setScope_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_564_setScope_40_1_41_);
  meth_meth_ast_564_setScope_40_1_41_->definitionModule = modulename;
  meth_meth_ast_564_setScope_40_1_41_->definitionLine = 282;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo567 = (struct UserObject*)obj352;
  uo567->data[64] = emptyclosure;
  Method *meth_meth_ast_567_shallowCopyFieldsFrom_40_1_41_ = addmethod2pos(obj352, "shallowCopyFieldsFrom(1)", &meth_ast_567_shallowCopyFieldsFrom_40_1_41_, 64);
  int argcv_meth_ast_567_shallowCopyFieldsFrom_40_1_41_[] = {1};
  meth_meth_ast_567_shallowCopyFieldsFrom_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_567_shallowCopyFieldsFrom_40_1_41_);
  meth_meth_ast_567_shallowCopyFieldsFrom_40_1_41_->definitionModule = modulename;
  meth_meth_ast_567_shallowCopyFieldsFrom_40_1_41_->definitionLine = 287;
// method "postCopy(_)"
  struct UserObject *uo586 = (struct UserObject*)obj352;
  uo586->data[65] = emptyclosure;
  Method *meth_meth_ast_586_postCopy_40_1_41_ = addmethod2pos(obj352, "postCopy(1)", &meth_ast_586_postCopy_40_1_41_, 65);
  int argcv_meth_ast_586_postCopy_40_1_41_[] = {1};
  meth_meth_ast_586_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_586_postCopy_40_1_41_);
  meth_meth_ast_586_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_586_postCopy_40_1_41_->definitionLine = 295;
// method "prettyPrefix(_)"
  block_savedest(obj352);
  Object closure587 = createclosure(1, "prettyPrefix(1)");
  setclosureframe(closure587, stackframe);
  addtoclosure(closure587, var_util);
  struct UserObject *uo587 = (struct UserObject*)obj352;
  uo587->data[66] = (Object)closure587;
  Method *meth_meth_ast_587_prettyPrefix_40_1_41_ = addmethod2pos(obj352, "prettyPrefix(1)", &meth_ast_587_prettyPrefix_40_1_41_, 66);
  int argcv_meth_ast_587_prettyPrefix_40_1_41_[] = {1};
  meth_meth_ast_587_prettyPrefix_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_587_prettyPrefix_40_1_41_);
  meth_meth_ast_587_prettyPrefix_40_1_41_->definitionModule = modulename;
  meth_meth_ast_587_prettyPrefix_40_1_41_->definitionLine = 299;
// method "basePretty(_)"
  struct UserObject *uo731 = (struct UserObject*)obj352;
  uo731->data[67] = emptyclosure;
  Method *meth_meth_ast_731_basePretty_40_1_41_ = addmethod2pos(obj352, "basePretty(1)", &meth_ast_731_basePretty_40_1_41_, 67);
  int argcv_meth_ast_731_basePretty_40_1_41_[] = {1};
  meth_meth_ast_731_basePretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_731_basePretty_40_1_41_);
  meth_meth_ast_731_basePretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_731_basePretty_40_1_41_->definitionLine = 309;
// method "pretty(_)"
  struct UserObject *uo734 = (struct UserObject*)obj352;
  uo734->data[68] = emptyclosure;
  Method *meth_meth_ast_734_pretty_40_1_41_ = addmethod2pos(obj352, "pretty(1)", &meth_ast_734_pretty_40_1_41_, 68);
  int argcv_meth_ast_734_pretty_40_1_41_[] = {1};
  meth_meth_ast_734_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_734_pretty_40_1_41_);
  meth_meth_ast_734_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_734_pretty_40_1_41_->definitionLine = 310;
// method "deepCopy"
  block_savedest(obj352);
  Object closure737 = createclosure(1, "deepCopy");
  setclosureframe(closure737, stackframe);
  addtoclosure(closure737, var_ancestorChain);
  struct UserObject *uo737 = (struct UserObject*)obj352;
  uo737->data[69] = (Object)closure737;
  Method *meth_meth_ast_737_deepCopy = addmethod2pos(obj352, "deepCopy", &meth_ast_737_deepCopy, 69);
  int argcv_meth_ast_737_deepCopy[] = {0};
  meth_meth_ast_737_deepCopy->type = alloc_MethodType(1, argcv_meth_ast_737_deepCopy);
  meth_meth_ast_737_deepCopy->definitionModule = modulename;
  meth_meth_ast_737_deepCopy->definitionLine = 311;
// method "enclosingObject"
  struct UserObject *uo745 = (struct UserObject*)obj352;
  uo745->data[70] = emptyclosure;
  Method *meth_meth_ast_745_enclosingObject = addmethod2pos(obj352, "enclosingObject", &meth_ast_745_enclosingObject, 70);
  int argcv_meth_ast_745_enclosingObject[] = {0};
  meth_meth_ast_745_enclosingObject->type = alloc_MethodType(1, argcv_meth_ast_745_enclosingObject);
  meth_meth_ast_745_enclosingObject->definitionModule = modulename;
  meth_meth_ast_745_enclosingObject->definitionLine = 314;
// method "addComment(_)"
  struct UserObject *uo752 = (struct UserObject*)obj352;
  uo752->data[71] = emptyclosure;
  Method *meth_meth_ast_752_addComment_40_1_41_ = addmethod2pos(obj352, "addComment(1)", &meth_ast_752_addComment_40_1_41_, 71);
  int argcv_meth_ast_752_addComment_40_1_41_[] = {1};
  meth_meth_ast_752_addComment_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_752_addComment_40_1_41_);
  meth_meth_ast_752_addComment_40_1_41_->definitionModule = modulename;
  meth_meth_ast_752_addComment_40_1_41_->definitionLine = 318;
// method "addComments(_)"
  struct UserObject *uo766 = (struct UserObject*)obj352;
  uo766->data[72] = emptyclosure;
  Method *meth_meth_ast_766_addComments_40_1_41_ = addmethod2pos(obj352, "addComments(1)", &meth_ast_766_addComments_40_1_41_, 72);
  int argcv_meth_ast_766_addComments_40_1_41_[] = {1};
  meth_meth_ast_766_addComments_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_766_addComments_40_1_41_);
  meth_meth_ast_766_addComments_40_1_41_->definitionModule = modulename;
  meth_meth_ast_766_addComments_40_1_41_->definitionLine = 325;
// method "statementName"
  struct UserObject *uo774 = (struct UserObject*)obj352;
  uo774->data[73] = emptyclosure;
  Method *meth_meth_ast_774_statementName = addmethod2pos(obj352, "statementName", &meth_ast_774_statementName, 73);
  int argcv_meth_ast_774_statementName[] = {0};
  meth_meth_ast_774_statementName->type = alloc_MethodType(1, argcv_meth_ast_774_statementName);
  meth_meth_ast_774_statementName->definitionModule = modulename;
  meth_meth_ast_774_statementName->definitionLine = 328;
  sourceObject = obj352;
// Begin line 194
  setline(194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit777 == NULL) {
    strlit777 = alloc_String("");
    gc_root(strlit777);
  }
// compiled string node returning strlit777 (depth = 2)
  adddatum2(obj352, strlit777, 1);
  sourceObject = obj352;
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe778 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  partcv[0] = 0;
  Object call779 = callmethodflags(*var_util, "linenum", 1, partcv, params, 0);
  gc_frame_end(callframe778);
// compiled member node returning call779 (depth = 2)
  adddatum2(obj352, call779, 2);
  sourceObject = obj352;
// Begin line 196
  setline(196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe780 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  partcv[0] = 0;
  Object call781 = callmethodflags(*var_util, "linepos", 1, partcv, params, 0);
  gc_frame_end(callframe780);
// compiled member node returning call781 (depth = 2)
  adddatum2(obj352, call781, 3);
  sourceObject = obj352;
// Begin line 197
  setline(197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_fakeSymbolTable (depth = 2)
  adddatum2(obj352, *var_fakeSymbolTable, 4);
  sourceObject = obj352;
// Begin line 198
  setline(198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool782 = alloc_Boolean(0);
// compiled identifier node returning bool782 (depth = 2)
  adddatum2(obj352, bool782, 5);
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  objclass352 = obj352->class;
  objclass352->definitionModule = modulename;
  objclass352->definitionLine = 192;
  (*(struct UserObject *)self).data[0] = lowerouter352;
  self = oldself352;
  selfslot = oldselfslot352;
  stackframe = oldstackframe352;
  gc_frame_end(frame);
  return obj352;
}
Object meth_ast_351_baseNode_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "baseNode$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  Object *var_ancestorChain = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_fakeSymbolTable = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject352 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj352 = alloc_userobj2(78,74, objclass352);
  gc_frame_newslot(obj352);
  if (objclass352 == NULL) {
    glfree(obj352->class->name);
    obj352->class->name = "baseNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj352, self, 0);
  addmethodreal(obj352,"outer", &reader_ast_outer_353);
  Object oldself352 = self;
  struct StackFrameObject *oldstackframe352 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe352);
  gc_frame_newslot((Object)stackframe);
  self = obj352;
  Object *oldselfslot352 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter352 = (*(struct UserObject *)self).data[0], lowerouter352 = thisouter352;
  if (inheritingObject352) {
    struct UserObject *inho352 = (struct UserObject *)inheritingObject352;
    while (inho352->super != GraceDefaultObject) inho352 = (struct UserObject *)inho352->super;
    inho352->super = obj352;
    self = inheritingObject352;
    *selfslot = self;
    lowerouter352 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter352;
  }
  if (objclass352 == NULL) {
    Method *reader354 = addmethodrealflags(obj352, "register", &reader_ast_register_354, 0);
    Method *writer354 = addmethodrealflags(obj352, "register:=(1)", &writer_ast_register_354, 0);
    reader354->definitionModule = modulename;
    writer354->definitionModule = modulename;
    reader354->definitionLine = 194;
    writer354->definitionLine = 194;
  }
  obj352->flags |= OFLAG_MUTABLE;
  adddatum2(obj352, alloc_Undefined(), 1);
  if (objclass352 == NULL) {
    Method *reader355 = addmethodrealflags(obj352, "line", &reader_ast_line_355, 0);
    Method *writer355 = addmethodrealflags(obj352, "line:=(1)", &writer_ast_line_355, 0);
    reader355->definitionModule = modulename;
    writer355->definitionModule = modulename;
    reader355->definitionLine = 195;
    writer355->definitionLine = 195;
  }
  obj352->flags |= OFLAG_MUTABLE;
  adddatum2(obj352, alloc_Undefined(), 2);
  if (objclass352 == NULL) {
    Method *reader356 = addmethodrealflags(obj352, "linePos", &reader_ast_linePos_356, 0);
    Method *writer356 = addmethodrealflags(obj352, "linePos:=(1)", &writer_ast_linePos_356, 0);
    reader356->definitionModule = modulename;
    writer356->definitionModule = modulename;
    reader356->definitionLine = 196;
    writer356->definitionLine = 196;
  }
  obj352->flags |= OFLAG_MUTABLE;
  adddatum2(obj352, alloc_Undefined(), 3);
  if (objclass352 == NULL) {
    Method *reader357 = addmethodrealflags(obj352, "symbolTable", &reader_ast_symbolTable_357, MFLAG_CONFIDENTIAL);
    Method *writer357 = addmethodrealflags(obj352, "symbolTable:=(1)", &writer_ast_symbolTable_357, MFLAG_CONFIDENTIAL);
    reader357->definitionModule = modulename;
    writer357->definitionModule = modulename;
    reader357->definitionLine = 197;
    writer357->definitionLine = 197;
  }
  obj352->flags |= OFLAG_MUTABLE;
  adddatum2(obj352, alloc_Undefined(), 4);
  if (objclass352 == NULL) {
    Method *reader358 = addmethodrealflags(obj352, "comments", &reader_ast_comments_358, 0);
    Method *writer358 = addmethodrealflags(obj352, "comments:=(1)", &writer_ast_comments_358, 0);
    reader358->definitionModule = modulename;
    writer358->definitionModule = modulename;
    reader358->definitionLine = 198;
    writer358->definitionLine = 198;
  }
  obj352->flags |= OFLAG_MUTABLE;
  adddatum2(obj352, alloc_Undefined(), 5);
// method "setLine(_)col(_)"
  struct UserObject *uo359 = (struct UserObject*)obj352;
  uo359->data[6] = emptyclosure;
  Method *meth_meth_ast_359_setLine_40_1_41_col_40_1_41_ = addmethod2pos(obj352, "setLine(1)col(1)", &meth_ast_359_setLine_40_1_41_col_40_1_41_, 6);
  int argcv_meth_ast_359_setLine_40_1_41_col_40_1_41_[] = {1, 1};
  meth_meth_ast_359_setLine_40_1_41_col_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_359_setLine_40_1_41_col_40_1_41_);
  meth_meth_ast_359_setLine_40_1_41_col_40_1_41_->definitionModule = modulename;
  meth_meth_ast_359_setLine_40_1_41_col_40_1_41_->definitionLine = 200;
// method "setPositionFrom(_)"
  struct UserObject *uo364 = (struct UserObject*)obj352;
  uo364->data[7] = emptyclosure;
  Method *meth_meth_ast_364_setPositionFrom_40_1_41_ = addmethod2pos(obj352, "setPositionFrom(1)", &meth_ast_364_setPositionFrom_40_1_41_, 7);
  int argcv_meth_ast_364_setPositionFrom_40_1_41_[] = {1};
  meth_meth_ast_364_setPositionFrom_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_364_setPositionFrom_40_1_41_);
  meth_meth_ast_364_setPositionFrom_40_1_41_->definitionModule = modulename;
  meth_meth_ast_364_setPositionFrom_40_1_41_->definitionLine = 205;
// method "setStart(_)"
  struct UserObject *uo373 = (struct UserObject*)obj352;
  uo373->data[8] = emptyclosure;
  Method *meth_meth_ast_373_setStart_40_1_41_ = addmethod2pos(obj352, "setStart(1)", &meth_ast_373_setStart_40_1_41_, 8);
  int argcv_meth_ast_373_setStart_40_1_41_[] = {1};
  meth_meth_ast_373_setStart_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_373_setStart_40_1_41_);
  meth_meth_ast_373_setStart_40_1_41_->definitionModule = modulename;
  meth_meth_ast_373_setStart_40_1_41_->definitionLine = 210;
// method "column"
  struct UserObject *uo382 = (struct UserObject*)obj352;
  uo382->data[9] = emptyclosure;
  Method *meth_meth_ast_382_column = addmethod2pos(obj352, "column", &meth_ast_382_column, 9);
  int argcv_meth_ast_382_column[] = {0};
  meth_meth_ast_382_column->type = alloc_MethodType(1, argcv_meth_ast_382_column);
  meth_meth_ast_382_column->definitionModule = modulename;
  meth_meth_ast_382_column->definitionLine = 215;
// method "start"
  struct UserObject *uo385 = (struct UserObject*)obj352;
  uo385->data[10] = emptyclosure;
  Method *meth_meth_ast_385_start = addmethod2pos(obj352, "start", &meth_ast_385_start, 10);
  int argcv_meth_ast_385_start[] = {0};
  meth_meth_ast_385_start->type = alloc_MethodType(1, argcv_meth_ast_385_start);
  meth_meth_ast_385_start->definitionModule = modulename;
  meth_meth_ast_385_start->definitionLine = 216;
// method "end"
  struct UserObject *uo392 = (struct UserObject*)obj352;
  uo392->data[11] = emptyclosure;
  Method *meth_meth_ast_392_end = addmethod2pos(obj352, "end", &meth_ast_392_end, 11);
  int argcv_meth_ast_392_end[] = {0};
  meth_meth_ast_392_end->type = alloc_MethodType(1, argcv_meth_ast_392_end);
  meth_meth_ast_392_end->definitionModule = modulename;
  meth_meth_ast_392_end->definitionLine = 217;
// method "range"
  struct UserObject *uo410 = (struct UserObject*)obj352;
  uo410->data[12] = emptyclosure;
  Method *meth_meth_ast_410_range = addmethod2pos(obj352, "range", &meth_ast_410_range, 12);
  int argcv_meth_ast_410_range[] = {0};
  meth_meth_ast_410_range->type = alloc_MethodType(1, argcv_meth_ast_410_range);
  meth_meth_ast_410_range->definitionModule = modulename;
  meth_meth_ast_410_range->definitionLine = 218;
// method "kind"
  struct UserObject *uo417 = (struct UserObject*)obj352;
  uo417->data[13] = emptyclosure;
  Method *meth_meth_ast_417_kind = addmethod2pos(obj352, "kind", &meth_ast_417_kind, 13);
  int argcv_meth_ast_417_kind[] = {0};
  meth_meth_ast_417_kind->type = alloc_MethodType(1, argcv_meth_ast_417_kind);
  meth_meth_ast_417_kind->definitionModule = modulename;
  meth_meth_ast_417_kind->definitionLine = 219;
// method "==(_)"
  struct UserObject *uo420 = (struct UserObject*)obj352;
  uo420->data[14] = emptyclosure;
  Method *meth_meth_ast_420__61__61__40_1_41_ = addmethod2pos(obj352, "==(1)", &meth_ast_420__61__61__40_1_41_, 14);
  int argcv_meth_ast_420__61__61__40_1_41_[] = {1};
  meth_meth_ast_420__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_420__61__61__40_1_41_);
  meth_meth_ast_420__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_420__61__61__40_1_41_->definitionLine = 220;
// method "isAppliedOccurenceOfIdentifier"
  struct UserObject *uo423 = (struct UserObject*)obj352;
  uo423->data[15] = emptyclosure;
  Method *meth_meth_ast_423_isAppliedOccurenceOfIdentifier = addmethod2pos(obj352, "isAppliedOccurenceOfIdentifier", &meth_ast_423_isAppliedOccurenceOfIdentifier, 15);
  int argcv_meth_ast_423_isAppliedOccurenceOfIdentifier[] = {0};
  meth_meth_ast_423_isAppliedOccurenceOfIdentifier->type = alloc_MethodType(1, argcv_meth_ast_423_isAppliedOccurenceOfIdentifier);
  meth_meth_ast_423_isAppliedOccurenceOfIdentifier->definitionModule = modulename;
  meth_meth_ast_423_isAppliedOccurenceOfIdentifier->definitionLine = 221;
// method "isMatchingBlock"
  struct UserObject *uo425 = (struct UserObject*)obj352;
  uo425->data[16] = emptyclosure;
  Method *meth_meth_ast_425_isMatchingBlock = addmethod2pos(obj352, "isMatchingBlock", &meth_ast_425_isMatchingBlock, 16);
  int argcv_meth_ast_425_isMatchingBlock[] = {0};
  meth_meth_ast_425_isMatchingBlock->type = alloc_MethodType(1, argcv_meth_ast_425_isMatchingBlock);
  meth_meth_ast_425_isMatchingBlock->definitionModule = modulename;
  meth_meth_ast_425_isMatchingBlock->definitionLine = 222;
// method "isFieldDec"
  struct UserObject *uo427 = (struct UserObject*)obj352;
  uo427->data[17] = emptyclosure;
  Method *meth_meth_ast_427_isFieldDec = addmethod2pos(obj352, "isFieldDec", &meth_ast_427_isFieldDec, 17);
  int argcv_meth_ast_427_isFieldDec[] = {0};
  meth_meth_ast_427_isFieldDec->type = alloc_MethodType(1, argcv_meth_ast_427_isFieldDec);
  meth_meth_ast_427_isFieldDec->definitionModule = modulename;
  meth_meth_ast_427_isFieldDec->definitionLine = 223;
// method "isInherits"
  struct UserObject *uo429 = (struct UserObject*)obj352;
  uo429->data[18] = emptyclosure;
  Method *meth_meth_ast_429_isInherits = addmethod2pos(obj352, "isInherits", &meth_ast_429_isInherits, 18);
  int argcv_meth_ast_429_isInherits[] = {0};
  meth_meth_ast_429_isInherits->type = alloc_MethodType(1, argcv_meth_ast_429_isInherits);
  meth_meth_ast_429_isInherits->definitionModule = modulename;
  meth_meth_ast_429_isInherits->definitionLine = 224;
// method "isLegalInTrait"
  struct UserObject *uo431 = (struct UserObject*)obj352;
  uo431->data[19] = emptyclosure;
  Method *meth_meth_ast_431_isLegalInTrait = addmethod2pos(obj352, "isLegalInTrait", &meth_ast_431_isLegalInTrait, 19);
  int argcv_meth_ast_431_isLegalInTrait[] = {0};
  meth_meth_ast_431_isLegalInTrait->type = alloc_MethodType(1, argcv_meth_ast_431_isLegalInTrait);
  meth_meth_ast_431_isLegalInTrait->definitionModule = modulename;
  meth_meth_ast_431_isLegalInTrait->definitionLine = 225;
// method "isMember"
  struct UserObject *uo433 = (struct UserObject*)obj352;
  uo433->data[20] = emptyclosure;
  Method *meth_meth_ast_433_isMember = addmethod2pos(obj352, "isMember", &meth_ast_433_isMember, 20);
  int argcv_meth_ast_433_isMember[] = {0};
  meth_meth_ast_433_isMember->type = alloc_MethodType(1, argcv_meth_ast_433_isMember);
  meth_meth_ast_433_isMember->definitionModule = modulename;
  meth_meth_ast_433_isMember->definitionLine = 226;
// method "isMethod"
  struct UserObject *uo435 = (struct UserObject*)obj352;
  uo435->data[21] = emptyclosure;
  Method *meth_meth_ast_435_isMethod = addmethod2pos(obj352, "isMethod", &meth_ast_435_isMethod, 21);
  int argcv_meth_ast_435_isMethod[] = {0};
  meth_meth_ast_435_isMethod->type = alloc_MethodType(1, argcv_meth_ast_435_isMethod);
  meth_meth_ast_435_isMethod->definitionModule = modulename;
  meth_meth_ast_435_isMethod->definitionLine = 227;
// method "isExecutable"
  struct UserObject *uo437 = (struct UserObject*)obj352;
  uo437->data[22] = emptyclosure;
  Method *meth_meth_ast_437_isExecutable = addmethod2pos(obj352, "isExecutable", &meth_ast_437_isExecutable, 22);
  int argcv_meth_ast_437_isExecutable[] = {0};
  meth_meth_ast_437_isExecutable->type = alloc_MethodType(1, argcv_meth_ast_437_isExecutable);
  meth_meth_ast_437_isExecutable->definitionModule = modulename;
  meth_meth_ast_437_isExecutable->definitionLine = 228;
// method "isCall"
  struct UserObject *uo439 = (struct UserObject*)obj352;
  uo439->data[23] = emptyclosure;
  Method *meth_meth_ast_439_isCall = addmethod2pos(obj352, "isCall", &meth_ast_439_isCall, 23);
  int argcv_meth_ast_439_isCall[] = {0};
  meth_meth_ast_439_isCall->type = alloc_MethodType(1, argcv_meth_ast_439_isCall);
  meth_meth_ast_439_isCall->definitionModule = modulename;
  meth_meth_ast_439_isCall->definitionLine = 229;
// method "isComment"
  struct UserObject *uo441 = (struct UserObject*)obj352;
  uo441->data[24] = emptyclosure;
  Method *meth_meth_ast_441_isComment = addmethod2pos(obj352, "isComment", &meth_ast_441_isComment, 24);
  int argcv_meth_ast_441_isComment[] = {0};
  meth_meth_ast_441_isComment->type = alloc_MethodType(1, argcv_meth_ast_441_isComment);
  meth_meth_ast_441_isComment->definitionModule = modulename;
  meth_meth_ast_441_isComment->definitionLine = 230;
// method "isClass"
  struct UserObject *uo443 = (struct UserObject*)obj352;
  uo443->data[25] = emptyclosure;
  Method *meth_meth_ast_443_isClass = addmethod2pos(obj352, "isClass", &meth_ast_443_isClass, 25);
  int argcv_meth_ast_443_isClass[] = {0};
  meth_meth_ast_443_isClass->type = alloc_MethodType(1, argcv_meth_ast_443_isClass);
  meth_meth_ast_443_isClass->definitionModule = modulename;
  meth_meth_ast_443_isClass->definitionLine = 231;
// method "inClass"
  struct UserObject *uo445 = (struct UserObject*)obj352;
  uo445->data[26] = emptyclosure;
  Method *meth_meth_ast_445_inClass = addmethod2pos(obj352, "inClass", &meth_ast_445_inClass, 26);
  int argcv_meth_ast_445_inClass[] = {0};
  meth_meth_ast_445_inClass->type = alloc_MethodType(1, argcv_meth_ast_445_inClass);
  meth_meth_ast_445_inClass->definitionModule = modulename;
  meth_meth_ast_445_inClass->definitionLine = 232;
// method "isTrait"
  struct UserObject *uo447 = (struct UserObject*)obj352;
  uo447->data[27] = emptyclosure;
  Method *meth_meth_ast_447_isTrait = addmethod2pos(obj352, "isTrait", &meth_ast_447_isTrait, 27);
  int argcv_meth_ast_447_isTrait[] = {0};
  meth_meth_ast_447_isTrait->type = alloc_MethodType(1, argcv_meth_ast_447_isTrait);
  meth_meth_ast_447_isTrait->definitionModule = modulename;
  meth_meth_ast_447_isTrait->definitionLine = 233;
// method "inTrait"
  struct UserObject *uo449 = (struct UserObject*)obj352;
  uo449->data[28] = emptyclosure;
  Method *meth_meth_ast_449_inTrait = addmethod2pos(obj352, "inTrait", &meth_ast_449_inTrait, 28);
  int argcv_meth_ast_449_inTrait[] = {0};
  meth_meth_ast_449_inTrait->type = alloc_MethodType(1, argcv_meth_ast_449_inTrait);
  meth_meth_ast_449_inTrait->definitionModule = modulename;
  meth_meth_ast_449_inTrait->definitionLine = 234;
// method "isBind"
  struct UserObject *uo451 = (struct UserObject*)obj352;
  uo451->data[29] = emptyclosure;
  Method *meth_meth_ast_451_isBind = addmethod2pos(obj352, "isBind", &meth_ast_451_isBind, 29);
  int argcv_meth_ast_451_isBind[] = {0};
  meth_meth_ast_451_isBind->type = alloc_MethodType(1, argcv_meth_ast_451_isBind);
  meth_meth_ast_451_isBind->definitionModule = modulename;
  meth_meth_ast_451_isBind->definitionLine = 235;
// method "isReturn"
  struct UserObject *uo453 = (struct UserObject*)obj352;
  uo453->data[30] = emptyclosure;
  Method *meth_meth_ast_453_isReturn = addmethod2pos(obj352, "isReturn", &meth_ast_453_isReturn, 30);
  int argcv_meth_ast_453_isReturn[] = {0};
  meth_meth_ast_453_isReturn->type = alloc_MethodType(1, argcv_meth_ast_453_isReturn);
  meth_meth_ast_453_isReturn->definitionModule = modulename;
  meth_meth_ast_453_isReturn->definitionLine = 236;
// method "isSelf"
  struct UserObject *uo455 = (struct UserObject*)obj352;
  uo455->data[31] = emptyclosure;
  Method *meth_meth_ast_455_isSelf = addmethod2pos(obj352, "isSelf", &meth_ast_455_isSelf, 31);
  int argcv_meth_ast_455_isSelf[] = {0};
  meth_meth_ast_455_isSelf->type = alloc_MethodType(1, argcv_meth_ast_455_isSelf);
  meth_meth_ast_455_isSelf->definitionModule = modulename;
  meth_meth_ast_455_isSelf->definitionLine = 237;
// method "isSuper"
  struct UserObject *uo457 = (struct UserObject*)obj352;
  uo457->data[32] = emptyclosure;
  Method *meth_meth_ast_457_isSuper = addmethod2pos(obj352, "isSuper", &meth_ast_457_isSuper, 32);
  int argcv_meth_ast_457_isSuper[] = {0};
  meth_meth_ast_457_isSuper->type = alloc_MethodType(1, argcv_meth_ast_457_isSuper);
  meth_meth_ast_457_isSuper->definitionModule = modulename;
  meth_meth_ast_457_isSuper->definitionLine = 238;
// method "isPrelude"
  struct UserObject *uo459 = (struct UserObject*)obj352;
  uo459->data[33] = emptyclosure;
  Method *meth_meth_ast_459_isPrelude = addmethod2pos(obj352, "isPrelude", &meth_ast_459_isPrelude, 33);
  int argcv_meth_ast_459_isPrelude[] = {0};
  meth_meth_ast_459_isPrelude->type = alloc_MethodType(1, argcv_meth_ast_459_isPrelude);
  meth_meth_ast_459_isPrelude->definitionModule = modulename;
  meth_meth_ast_459_isPrelude->definitionLine = 239;
// method "isOuter"
  struct UserObject *uo461 = (struct UserObject*)obj352;
  uo461->data[34] = emptyclosure;
  Method *meth_meth_ast_461_isOuter = addmethod2pos(obj352, "isOuter", &meth_ast_461_isOuter, 34);
  int argcv_meth_ast_461_isOuter[] = {0};
  meth_meth_ast_461_isOuter->type = alloc_MethodType(1, argcv_meth_ast_461_isOuter);
  meth_meth_ast_461_isOuter->definitionModule = modulename;
  meth_meth_ast_461_isOuter->definitionLine = 240;
// method "isSelfOrOuter"
  struct UserObject *uo463 = (struct UserObject*)obj352;
  uo463->data[35] = emptyclosure;
  Method *meth_meth_ast_463_isSelfOrOuter = addmethod2pos(obj352, "isSelfOrOuter", &meth_ast_463_isSelfOrOuter, 35);
  int argcv_meth_ast_463_isSelfOrOuter[] = {0};
  meth_meth_ast_463_isSelfOrOuter->type = alloc_MethodType(1, argcv_meth_ast_463_isSelfOrOuter);
  meth_meth_ast_463_isSelfOrOuter->definitionModule = modulename;
  meth_meth_ast_463_isSelfOrOuter->definitionLine = 241;
// method "isBlock"
  struct UserObject *uo465 = (struct UserObject*)obj352;
  uo465->data[36] = emptyclosure;
  Method *meth_meth_ast_465_isBlock = addmethod2pos(obj352, "isBlock", &meth_ast_465_isBlock, 36);
  int argcv_meth_ast_465_isBlock[] = {0};
  meth_meth_ast_465_isBlock->type = alloc_MethodType(1, argcv_meth_ast_465_isBlock);
  meth_meth_ast_465_isBlock->definitionModule = modulename;
  meth_meth_ast_465_isBlock->definitionLine = 242;
// method "isObject"
  struct UserObject *uo467 = (struct UserObject*)obj352;
  uo467->data[37] = emptyclosure;
  Method *meth_meth_ast_467_isObject = addmethod2pos(obj352, "isObject", &meth_ast_467_isObject, 37);
  int argcv_meth_ast_467_isObject[] = {0};
  meth_meth_ast_467_isObject->type = alloc_MethodType(1, argcv_meth_ast_467_isObject);
  meth_meth_ast_467_isObject->definitionModule = modulename;
  meth_meth_ast_467_isObject->definitionLine = 243;
// method "isIdentifier"
  struct UserObject *uo469 = (struct UserObject*)obj352;
  uo469->data[38] = emptyclosure;
  Method *meth_meth_ast_469_isIdentifier = addmethod2pos(obj352, "isIdentifier", &meth_ast_469_isIdentifier, 38);
  int argcv_meth_ast_469_isIdentifier[] = {0};
  meth_meth_ast_469_isIdentifier->type = alloc_MethodType(1, argcv_meth_ast_469_isIdentifier);
  meth_meth_ast_469_isIdentifier->definitionModule = modulename;
  meth_meth_ast_469_isIdentifier->definitionLine = 244;
// method "isDialect"
  struct UserObject *uo471 = (struct UserObject*)obj352;
  uo471->data[39] = emptyclosure;
  Method *meth_meth_ast_471_isDialect = addmethod2pos(obj352, "isDialect", &meth_ast_471_isDialect, 39);
  int argcv_meth_ast_471_isDialect[] = {0};
  meth_meth_ast_471_isDialect->type = alloc_MethodType(1, argcv_meth_ast_471_isDialect);
  meth_meth_ast_471_isDialect->definitionModule = modulename;
  meth_meth_ast_471_isDialect->definitionLine = 245;
// method "isImport"
  struct UserObject *uo473 = (struct UserObject*)obj352;
  uo473->data[40] = emptyclosure;
  Method *meth_meth_ast_473_isImport = addmethod2pos(obj352, "isImport", &meth_ast_473_isImport, 40);
  int argcv_meth_ast_473_isImport[] = {0};
  meth_meth_ast_473_isImport->type = alloc_MethodType(1, argcv_meth_ast_473_isImport);
  meth_meth_ast_473_isImport->definitionModule = modulename;
  meth_meth_ast_473_isImport->definitionLine = 246;
// method "isTypeDec"
  struct UserObject *uo475 = (struct UserObject*)obj352;
  uo475->data[41] = emptyclosure;
  Method *meth_meth_ast_475_isTypeDec = addmethod2pos(obj352, "isTypeDec", &meth_ast_475_isTypeDec, 41);
  int argcv_meth_ast_475_isTypeDec[] = {0};
  meth_meth_ast_475_isTypeDec->type = alloc_MethodType(1, argcv_meth_ast_475_isTypeDec);
  meth_meth_ast_475_isTypeDec->definitionModule = modulename;
  meth_meth_ast_475_isTypeDec->definitionLine = 247;
// method "isExternal"
  struct UserObject *uo477 = (struct UserObject*)obj352;
  uo477->data[42] = emptyclosure;
  Method *meth_meth_ast_477_isExternal = addmethod2pos(obj352, "isExternal", &meth_ast_477_isExternal, 42);
  int argcv_meth_ast_477_isExternal[] = {0};
  meth_meth_ast_477_isExternal->type = alloc_MethodType(1, argcv_meth_ast_477_isExternal);
  meth_meth_ast_477_isExternal->definitionModule = modulename;
  meth_meth_ast_477_isExternal->definitionLine = 248;
// method "isFresh"
  struct UserObject *uo479 = (struct UserObject*)obj352;
  uo479->data[43] = emptyclosure;
  Method *meth_meth_ast_479_isFresh = addmethod2pos(obj352, "isFresh", &meth_ast_479_isFresh, 43);
  int argcv_meth_ast_479_isFresh[] = {0};
  meth_meth_ast_479_isFresh->type = alloc_MethodType(1, argcv_meth_ast_479_isFresh);
  meth_meth_ast_479_isFresh->definitionModule = modulename;
  meth_meth_ast_479_isFresh->definitionLine = 249;
// method "isConstant"
  struct UserObject *uo481 = (struct UserObject*)obj352;
  uo481->data[44] = emptyclosure;
  Method *meth_meth_ast_481_isConstant = addmethod2pos(obj352, "isConstant", &meth_ast_481_isConstant, 44);
  int argcv_meth_ast_481_isConstant[] = {0};
  meth_meth_ast_481_isConstant->type = alloc_MethodType(1, argcv_meth_ast_481_isConstant);
  meth_meth_ast_481_isConstant->definitionModule = modulename;
  meth_meth_ast_481_isConstant->definitionLine = 250;
// method "canInherit"
  struct UserObject *uo483 = (struct UserObject*)obj352;
  uo483->data[45] = emptyclosure;
  Method *meth_meth_ast_483_canInherit = addmethod2pos(obj352, "canInherit", &meth_ast_483_canInherit, 45);
  int argcv_meth_ast_483_canInherit[] = {0};
  meth_meth_ast_483_canInherit->type = alloc_MethodType(1, argcv_meth_ast_483_canInherit);
  meth_meth_ast_483_canInherit->definitionModule = modulename;
  meth_meth_ast_483_canInherit->definitionLine = 251;
// method "returnsObject"
  struct UserObject *uo485 = (struct UserObject*)obj352;
  uo485->data[46] = emptyclosure;
  Method *meth_meth_ast_485_returnsObject = addmethod2pos(obj352, "returnsObject", &meth_ast_485_returnsObject, 46);
  int argcv_meth_ast_485_returnsObject[] = {0};
  meth_meth_ast_485_returnsObject->type = alloc_MethodType(1, argcv_meth_ast_485_returnsObject);
  meth_meth_ast_485_returnsObject->definitionModule = modulename;
  meth_meth_ast_485_returnsObject->definitionLine = 252;
// method "isImplicit"
  struct UserObject *uo487 = (struct UserObject*)obj352;
  uo487->data[47] = emptyclosure;
  Method *meth_meth_ast_487_isImplicit = addmethod2pos(obj352, "isImplicit", &meth_ast_487_isImplicit, 47);
  int argcv_meth_ast_487_isImplicit[] = {0};
  meth_meth_ast_487_isImplicit->type = alloc_MethodType(1, argcv_meth_ast_487_isImplicit);
  meth_meth_ast_487_isImplicit->definitionModule = modulename;
  meth_meth_ast_487_isImplicit->definitionLine = 253;
// method "usesAsType(_)"
  struct UserObject *uo489 = (struct UserObject*)obj352;
  uo489->data[48] = emptyclosure;
  Method *meth_meth_ast_489_usesAsType_40_1_41_ = addmethod2pos(obj352, "usesAsType(1)", &meth_ast_489_usesAsType_40_1_41_, 48);
  int argcv_meth_ast_489_usesAsType_40_1_41_[] = {1};
  meth_meth_ast_489_usesAsType_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_489_usesAsType_40_1_41_);
  meth_meth_ast_489_usesAsType_40_1_41_->definitionModule = modulename;
  meth_meth_ast_489_usesAsType_40_1_41_->definitionLine = 254;
// method "hash"
  struct UserObject *uo491 = (struct UserObject*)obj352;
  uo491->data[49] = emptyclosure;
  Method *meth_meth_ast_491_hash = addmethod2pos(obj352, "hash", &meth_ast_491_hash, 49);
  int argcv_meth_ast_491_hash[] = {0};
  meth_meth_ast_491_hash->type = alloc_MethodType(1, argcv_meth_ast_491_hash);
  meth_meth_ast_491_hash->definitionModule = modulename;
  meth_meth_ast_491_hash->definitionLine = 255;
// method "asString"
  struct UserObject *uo503 = (struct UserObject*)obj352;
  uo503->data[50] = emptyclosure;
  Method *meth_meth_ast_503_asString = addmethod2pos(obj352, "asString", &meth_ast_503_asString, 50);
  int argcv_meth_ast_503_asString[] = {0};
  meth_meth_ast_503_asString->type = alloc_MethodType(1, argcv_meth_ast_503_asString);
  meth_meth_ast_503_asString->definitionModule = modulename;
  meth_meth_ast_503_asString->definitionLine = 256;
// method "nameString"
  struct UserObject *uo523 = (struct UserObject*)obj352;
  uo523->data[51] = emptyclosure;
  Method *meth_meth_ast_523_nameString = addmethod2pos(obj352, "nameString", &meth_ast_523_nameString, 51);
  int argcv_meth_ast_523_nameString[] = {0};
  meth_meth_ast_523_nameString->type = alloc_MethodType(1, argcv_meth_ast_523_nameString);
  meth_meth_ast_523_nameString->definitionModule = modulename;
  meth_meth_ast_523_nameString->definitionLine = 257;
// method "isWritable"
  struct UserObject *uo525 = (struct UserObject*)obj352;
  uo525->data[52] = emptyclosure;
  Method *meth_meth_ast_525_isWritable = addmethod2pos(obj352, "isWritable", &meth_ast_525_isWritable, 52);
  int argcv_meth_ast_525_isWritable[] = {0};
  meth_meth_ast_525_isWritable->type = alloc_MethodType(1, argcv_meth_ast_525_isWritable);
  meth_meth_ast_525_isWritable->definitionModule = modulename;
  meth_meth_ast_525_isWritable->definitionLine = 258;
// method "isReadable"
  struct UserObject *uo527 = (struct UserObject*)obj352;
  uo527->data[53] = emptyclosure;
  Method *meth_meth_ast_527_isReadable = addmethod2pos(obj352, "isReadable", &meth_ast_527_isReadable, 53);
  int argcv_meth_ast_527_isReadable[] = {0};
  meth_meth_ast_527_isReadable->type = alloc_MethodType(1, argcv_meth_ast_527_isReadable);
  meth_meth_ast_527_isReadable->definitionModule = modulename;
  meth_meth_ast_527_isReadable->definitionLine = 259;
// method "isPublic"
  struct UserObject *uo529 = (struct UserObject*)obj352;
  uo529->data[54] = emptyclosure;
  Method *meth_meth_ast_529_isPublic = addmethod2pos(obj352, "isPublic", &meth_ast_529_isPublic, 54);
  int argcv_meth_ast_529_isPublic[] = {0};
  meth_meth_ast_529_isPublic->type = alloc_MethodType(1, argcv_meth_ast_529_isPublic);
  meth_meth_ast_529_isPublic->definitionModule = modulename;
  meth_meth_ast_529_isPublic->definitionLine = 260;
// method "isConfidential"
  struct UserObject *uo531 = (struct UserObject*)obj352;
  uo531->data[55] = emptyclosure;
  Method *meth_meth_ast_531_isConfidential = addmethod2pos(obj352, "isConfidential", &meth_ast_531_isConfidential, 55);
  int argcv_meth_ast_531_isConfidential[] = {0};
  meth_meth_ast_531_isConfidential->type = alloc_MethodType(1, argcv_meth_ast_531_isConfidential);
  meth_meth_ast_531_isConfidential->definitionModule = modulename;
  meth_meth_ast_531_isConfidential->definitionLine = 261;
// method "decType"
  block_savedest(obj352);
  Object closure536 = createclosure(1, "decType");
  setclosureframe(closure536, stackframe);
  addtoclosure(closure536, var_unknownType);
  struct UserObject *uo536 = (struct UserObject*)obj352;
  uo536->data[56] = (Object)closure536;
  Method *meth_meth_ast_536_decType = addmethod2pos(obj352, "decType", &meth_ast_536_decType, 56);
  int argcv_meth_ast_536_decType[] = {0};
  meth_meth_ast_536_decType->type = alloc_MethodType(1, argcv_meth_ast_536_decType);
  meth_meth_ast_536_decType->definitionModule = modulename;
  meth_meth_ast_536_decType->definitionLine = 262;
// method "isSimple"
  struct UserObject *uo546 = (struct UserObject*)obj352;
  uo546->data[57] = emptyclosure;
  Method *meth_meth_ast_546_isSimple = addmethod2pos(obj352, "isSimple", &meth_ast_546_isSimple, 57);
  int argcv_meth_ast_546_isSimple[] = {0};
  meth_meth_ast_546_isSimple->type = alloc_MethodType(1, argcv_meth_ast_546_isSimple);
  meth_meth_ast_546_isSimple->definitionModule = modulename;
  meth_meth_ast_546_isSimple->definitionLine = 268;
// method "isDelimited"
  struct UserObject *uo548 = (struct UserObject*)obj352;
  uo548->data[58] = emptyclosure;
  Method *meth_meth_ast_548_isDelimited = addmethod2pos(obj352, "isDelimited", &meth_ast_548_isDelimited, 58);
  int argcv_meth_ast_548_isDelimited[] = {0};
  meth_meth_ast_548_isDelimited->type = alloc_MethodType(1, argcv_meth_ast_548_isDelimited);
  meth_meth_ast_548_isDelimited->definitionModule = modulename;
  meth_meth_ast_548_isDelimited->definitionLine = 269;
// method "description"
  struct UserObject *uo550 = (struct UserObject*)obj352;
  uo550->data[59] = emptyclosure;
  Method *meth_meth_ast_550_description = addmethod2pos(obj352, "description", &meth_ast_550_description, 59);
  int argcv_meth_ast_550_description[] = {0};
  meth_meth_ast_550_description->type = alloc_MethodType(1, argcv_meth_ast_550_description);
  meth_meth_ast_550_description->definitionModule = modulename;
  meth_meth_ast_550_description->definitionLine = 270;
// method "accept(_)"
  block_savedest(obj352);
  Object closure553 = createclosure(1, "accept(1)");
  setclosureframe(closure553, stackframe);
  addtoclosure(closure553, var_ancestorChain);
  struct UserObject *uo553 = (struct UserObject*)obj352;
  uo553->data[60] = (Object)closure553;
  Method *meth_meth_ast_553_accept_40_1_41_ = addmethod2pos(obj352, "accept(1)", &meth_ast_553_accept_40_1_41_, 60);
  int argcv_meth_ast_553_accept_40_1_41_[] = {1};
  meth_meth_ast_553_accept_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_553_accept_40_1_41_);
  meth_meth_ast_553_accept_40_1_41_->definitionModule = modulename;
  meth_meth_ast_553_accept_40_1_41_->definitionLine = 271;
// method "scope"
  struct UserObject *uo558 = (struct UserObject*)obj352;
  uo558->data[61] = emptyclosure;
  Method *meth_meth_ast_558_scope = addmethod2pos(obj352, "scope", &meth_ast_558_scope, 61);
  int argcv_meth_ast_558_scope[] = {0};
  meth_meth_ast_558_scope->type = alloc_MethodType(1, argcv_meth_ast_558_scope);
  meth_meth_ast_558_scope->definitionModule = modulename;
  meth_meth_ast_558_scope->definitionLine = 274;
// method "scope:=(_)"
  struct UserObject *uo561 = (struct UserObject*)obj352;
  uo561->data[62] = emptyclosure;
  Method *meth_meth_ast_561_scope_58__61__40_1_41_ = addmethod2pos(obj352, "scope:=(1)", &meth_ast_561_scope_58__61__40_1_41_, 62);
  int argcv_meth_ast_561_scope_58__61__40_1_41_[] = {1};
  meth_meth_ast_561_scope_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_561_scope_58__61__40_1_41_);
  meth_meth_ast_561_scope_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_561_scope_58__61__40_1_41_->definitionLine = 276;
// method "setScope(_)"
  struct UserObject *uo564 = (struct UserObject*)obj352;
  uo564->data[63] = emptyclosure;
  Method *meth_meth_ast_564_setScope_40_1_41_ = addmethod2pos(obj352, "setScope(1)", &meth_ast_564_setScope_40_1_41_, 63);
  int argcv_meth_ast_564_setScope_40_1_41_[] = {1};
  meth_meth_ast_564_setScope_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_564_setScope_40_1_41_);
  meth_meth_ast_564_setScope_40_1_41_->definitionModule = modulename;
  meth_meth_ast_564_setScope_40_1_41_->definitionLine = 282;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo567 = (struct UserObject*)obj352;
  uo567->data[64] = emptyclosure;
  Method *meth_meth_ast_567_shallowCopyFieldsFrom_40_1_41_ = addmethod2pos(obj352, "shallowCopyFieldsFrom(1)", &meth_ast_567_shallowCopyFieldsFrom_40_1_41_, 64);
  int argcv_meth_ast_567_shallowCopyFieldsFrom_40_1_41_[] = {1};
  meth_meth_ast_567_shallowCopyFieldsFrom_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_567_shallowCopyFieldsFrom_40_1_41_);
  meth_meth_ast_567_shallowCopyFieldsFrom_40_1_41_->definitionModule = modulename;
  meth_meth_ast_567_shallowCopyFieldsFrom_40_1_41_->definitionLine = 287;
// method "postCopy(_)"
  struct UserObject *uo586 = (struct UserObject*)obj352;
  uo586->data[65] = emptyclosure;
  Method *meth_meth_ast_586_postCopy_40_1_41_ = addmethod2pos(obj352, "postCopy(1)", &meth_ast_586_postCopy_40_1_41_, 65);
  int argcv_meth_ast_586_postCopy_40_1_41_[] = {1};
  meth_meth_ast_586_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_586_postCopy_40_1_41_);
  meth_meth_ast_586_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_586_postCopy_40_1_41_->definitionLine = 295;
// method "prettyPrefix(_)"
  block_savedest(obj352);
  Object closure587 = createclosure(1, "prettyPrefix(1)");
  setclosureframe(closure587, stackframe);
  addtoclosure(closure587, var_util);
  struct UserObject *uo587 = (struct UserObject*)obj352;
  uo587->data[66] = (Object)closure587;
  Method *meth_meth_ast_587_prettyPrefix_40_1_41_ = addmethod2pos(obj352, "prettyPrefix(1)", &meth_ast_587_prettyPrefix_40_1_41_, 66);
  int argcv_meth_ast_587_prettyPrefix_40_1_41_[] = {1};
  meth_meth_ast_587_prettyPrefix_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_587_prettyPrefix_40_1_41_);
  meth_meth_ast_587_prettyPrefix_40_1_41_->definitionModule = modulename;
  meth_meth_ast_587_prettyPrefix_40_1_41_->definitionLine = 299;
// method "basePretty(_)"
  struct UserObject *uo731 = (struct UserObject*)obj352;
  uo731->data[67] = emptyclosure;
  Method *meth_meth_ast_731_basePretty_40_1_41_ = addmethod2pos(obj352, "basePretty(1)", &meth_ast_731_basePretty_40_1_41_, 67);
  int argcv_meth_ast_731_basePretty_40_1_41_[] = {1};
  meth_meth_ast_731_basePretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_731_basePretty_40_1_41_);
  meth_meth_ast_731_basePretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_731_basePretty_40_1_41_->definitionLine = 309;
// method "pretty(_)"
  struct UserObject *uo734 = (struct UserObject*)obj352;
  uo734->data[68] = emptyclosure;
  Method *meth_meth_ast_734_pretty_40_1_41_ = addmethod2pos(obj352, "pretty(1)", &meth_ast_734_pretty_40_1_41_, 68);
  int argcv_meth_ast_734_pretty_40_1_41_[] = {1};
  meth_meth_ast_734_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_734_pretty_40_1_41_);
  meth_meth_ast_734_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_734_pretty_40_1_41_->definitionLine = 310;
// method "deepCopy"
  block_savedest(obj352);
  Object closure737 = createclosure(1, "deepCopy");
  setclosureframe(closure737, stackframe);
  addtoclosure(closure737, var_ancestorChain);
  struct UserObject *uo737 = (struct UserObject*)obj352;
  uo737->data[69] = (Object)closure737;
  Method *meth_meth_ast_737_deepCopy = addmethod2pos(obj352, "deepCopy", &meth_ast_737_deepCopy, 69);
  int argcv_meth_ast_737_deepCopy[] = {0};
  meth_meth_ast_737_deepCopy->type = alloc_MethodType(1, argcv_meth_ast_737_deepCopy);
  meth_meth_ast_737_deepCopy->definitionModule = modulename;
  meth_meth_ast_737_deepCopy->definitionLine = 311;
// method "enclosingObject"
  struct UserObject *uo745 = (struct UserObject*)obj352;
  uo745->data[70] = emptyclosure;
  Method *meth_meth_ast_745_enclosingObject = addmethod2pos(obj352, "enclosingObject", &meth_ast_745_enclosingObject, 70);
  int argcv_meth_ast_745_enclosingObject[] = {0};
  meth_meth_ast_745_enclosingObject->type = alloc_MethodType(1, argcv_meth_ast_745_enclosingObject);
  meth_meth_ast_745_enclosingObject->definitionModule = modulename;
  meth_meth_ast_745_enclosingObject->definitionLine = 314;
// method "addComment(_)"
  struct UserObject *uo752 = (struct UserObject*)obj352;
  uo752->data[71] = emptyclosure;
  Method *meth_meth_ast_752_addComment_40_1_41_ = addmethod2pos(obj352, "addComment(1)", &meth_ast_752_addComment_40_1_41_, 71);
  int argcv_meth_ast_752_addComment_40_1_41_[] = {1};
  meth_meth_ast_752_addComment_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_752_addComment_40_1_41_);
  meth_meth_ast_752_addComment_40_1_41_->definitionModule = modulename;
  meth_meth_ast_752_addComment_40_1_41_->definitionLine = 318;
// method "addComments(_)"
  struct UserObject *uo766 = (struct UserObject*)obj352;
  uo766->data[72] = emptyclosure;
  Method *meth_meth_ast_766_addComments_40_1_41_ = addmethod2pos(obj352, "addComments(1)", &meth_ast_766_addComments_40_1_41_, 72);
  int argcv_meth_ast_766_addComments_40_1_41_[] = {1};
  meth_meth_ast_766_addComments_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_766_addComments_40_1_41_);
  meth_meth_ast_766_addComments_40_1_41_->definitionModule = modulename;
  meth_meth_ast_766_addComments_40_1_41_->definitionLine = 325;
// method "statementName"
  struct UserObject *uo774 = (struct UserObject*)obj352;
  uo774->data[73] = emptyclosure;
  Method *meth_meth_ast_774_statementName = addmethod2pos(obj352, "statementName", &meth_ast_774_statementName, 73);
  int argcv_meth_ast_774_statementName[] = {0};
  meth_meth_ast_774_statementName->type = alloc_MethodType(1, argcv_meth_ast_774_statementName);
  meth_meth_ast_774_statementName->definitionModule = modulename;
  meth_meth_ast_774_statementName->definitionLine = 328;
  sourceObject = obj352;
// Begin line 194
  setline(194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit777 == NULL) {
    strlit777 = alloc_String("");
    gc_root(strlit777);
  }
// compiled string node returning strlit777 (depth = 2)
  adddatum2(obj352, strlit777, 1);
  sourceObject = obj352;
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe778 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  partcv[0] = 0;
  Object call779 = callmethodflags(*var_util, "linenum", 1, partcv, params, 0);
  gc_frame_end(callframe778);
// compiled member node returning call779 (depth = 2)
  adddatum2(obj352, call779, 2);
  sourceObject = obj352;
// Begin line 196
  setline(196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe780 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  partcv[0] = 0;
  Object call781 = callmethodflags(*var_util, "linepos", 1, partcv, params, 0);
  gc_frame_end(callframe780);
// compiled member node returning call781 (depth = 2)
  adddatum2(obj352, call781, 3);
  sourceObject = obj352;
// Begin line 197
  setline(197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_fakeSymbolTable (depth = 2)
  adddatum2(obj352, *var_fakeSymbolTable, 4);
  sourceObject = obj352;
// Begin line 198
  setline(198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool782 = alloc_Boolean(0);
// compiled identifier node returning bool782 (depth = 2)
  adddatum2(obj352, bool782, 5);
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  sourceObject = obj352;
  objclass352 = obj352->class;
  objclass352->definitionModule = modulename;
  objclass352->definitionLine = 192;
  (*(struct UserObject *)self).data[0] = lowerouter352;
  self = oldself352;
  selfslot = oldselfslot352;
  stackframe = oldstackframe352;
  gc_frame_end(frame);
  return obj352;
}
Object meth_ast_789_numberOfLevels(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "numberOfLevels");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe790 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe791 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call792 = callmethodflags(self, "theObjects", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe791);
// compiled member node returning call792 (depth = 3)
  partcv[0] = 0;
  Object call793 = callmethodflags(call792, "size", 1, partcv, params, 0);
  gc_frame_end(callframe790);
// compiled member node returning call793 (depth = 2)
  gc_frame_end(frame);
  return call793;
}
Object meth_ast_794_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1740
  setline(1740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit796 == NULL) {
    strlit796 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit796);
  }
// compiled string node returning strlit796 (depth = 3)
  int op_slot_right_795 = gc_frame_newslot(strlit796);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe799 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe800 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe801 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call802 = callmethodflags(self, "theObjects", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe801);
// compiled member node returning call802 (depth = 6)
  partcv[0] = 0;
  Object call803 = callmethodflags(call802, "last", 1, partcv, params, 0);
  gc_frame_end(callframe800);
// compiled member node returning call803 (depth = 5)
  partcv[0] = 0;
  Object call804 = callmethodflags(call803, "line", 1, partcv, params, 0);
  gc_frame_end(callframe799);
// compiled member node returning call804 (depth = 4)
  int op_slot_right_798 = gc_frame_newslot(call804);
// starting to compile string node (depth = 4)
  if (strlit806 == NULL) {
    strlit806 = alloc_String("""\xe2""""\x80""""\xb9""object outside that at line ");
    gc_root(strlit806);
  }
// compiled string node returning strlit806 (depth = 4)
  int op_slot_left_798 = gc_frame_newslot(strlit806);
  params[0] = call804;
  partcv[0] = 1;
  Object opresult807 = callmethod(strlit806, "++(1)", 1, partcv, params);
// compiled op node returning opresult807 (depth = 3)
  int op_slot_left_795 = gc_frame_newslot(opresult807);
  params[0] = strlit796;
  partcv[0] = 1;
  Object opresult808 = callmethod(opresult807, "++(1)", 1, partcv, params);
// compiled op node returning opresult808 (depth = 2)
  gc_frame_end(frame);
  return opresult808;
}
Object meth_ast_809_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1741
  setline(1741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe811 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call812 = callmethodflags(self, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe811);
// compiled member node returning call812 (depth = 3)
  int op_slot_right_810 = gc_frame_newslot(call812);
// starting to compile call node (depth = 3)
  int callframe814 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth (depth = 4)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call815 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe814);
// compiled call node returning call815 (depth = 3)
  int op_slot_left_810 = gc_frame_newslot(call815);
  params[0] = call812;
  partcv[0] = 1;
  Object opresult816 = callmethod(call815, "++(1)", 1, partcv, params);
// compiled op node returning opresult816 (depth = 2)
  gc_frame_end(frame);
  return opresult816;
}
Object meth_ast_817_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1743
  setline(1743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe818 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitor (depth = 3)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call819 = callmethodflags(*var_visitor, "visitOuter(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe818);
// compiled call node returning call819 (depth = 2)
  gc_frame_end(frame);
  return call819;
}
Object meth_ast_820_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1747
  setline(1747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num824 = alloc_Float64(1);
// compiled num node returning num824 (depth = 5)
  int op_slot_right_823 = gc_frame_newslot(num824);
// starting to compile member node (depth = 5)
  int callframe826 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe827 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call828 = callmethodflags(self, "theObjects", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe827);
// compiled member node returning call828 (depth = 6)
  partcv[0] = 0;
  Object call829 = callmethodflags(call828, "size", 1, partcv, params, 0);
  gc_frame_end(callframe826);
// compiled member node returning call829 (depth = 5)
  int op_slot_left_823 = gc_frame_newslot(call829);
  params[0] = num824;
  partcv[0] = 1;
  Object diff830 = callmethod(call829, "-(1)", 1, partcv, params);
// compiled op node returning diff830 (depth = 4)
  int op_slot_right_822 = gc_frame_newslot(diff830);
// starting to compile string node (depth = 4)
  if (strlit832 == NULL) {
    strlit832 = alloc_String(".outer");
    gc_root(strlit832);
  }
// compiled string node returning strlit832 (depth = 4)
  int op_slot_left_822 = gc_frame_newslot(strlit832);
  params[0] = diff830;
  partcv[0] = 1;
  Object prod833 = callmethod(strlit832, "*(1)", 1, partcv, params);
// compiled op node returning prod833 (depth = 3)
  int op_slot_right_821 = gc_frame_newslot(prod833);
// starting to compile string node (depth = 3)
  if (strlit835 == NULL) {
    strlit835 = alloc_String("outer");
    gc_root(strlit835);
  }
// compiled string node returning strlit835 (depth = 3)
  int op_slot_left_821 = gc_frame_newslot(strlit835);
  params[0] = prod833;
  partcv[0] = 1;
  Object opresult836 = callmethod(strlit835, "++(1)", 1, partcv, params);
// compiled op node returning opresult836 (depth = 2)
  gc_frame_end(frame);
  return opresult836;
}
Object meth_ast_837_isOuter(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isOuter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1749
  setline(1749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool838 = alloc_Boolean(1);
// compiled identifier node returning bool838 (depth = 2)
  gc_frame_end(frame);
  return bool838;
}
Object meth_ast_839_isSelfOrOuter(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSelfOrOuter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1750
  setline(1750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool840 = alloc_Boolean(1);
// compiled identifier node returning bool840 (depth = 2)
  gc_frame_end(frame);
  return bool840;
}
Object meth_ast_841_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1752
  setline(1752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe842 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 3)
  int callframe843 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe844 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call845 = callmethodflags(self, "theObjects", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe844);
// compiled member node returning call845 (depth = 4)
  gc_frame_newslot(call845);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = call845;
  partcv[0] = 1;
  Object call846 = callmethodflags(module_ast, "outerNode(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe843);
// compiled call node returning call846 (depth = 3)
  params[0] = self;
  partcv[0] = 1;
  Object call847 = callmethodflags(call846, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe842);
// compiled call node returning call847 (depth = 2)
  gc_frame_end(frame);
  return call847;
}
Object meth_ast_848_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_nd = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nd");
// Begin line 1755
  setline(1755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe849 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call850 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe849);
// compiled member node returning call850 (depth = 3)
  *var_nd = call850;
  if (call850 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1756
  setline(1756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe851 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_nd (depth = 3)
  gc_frame_newslot(*var_nd);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blk (depth = 3)
  params[0] = *var_nd;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call852 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe851);
// compiled call node returning call852 (depth = 2)
  gc_frame_end(frame);
  return call852;
}
Object meth_ast_784_outerNode_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "outerNode(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method outerNode(_)");
  Object params[2];
  int partcv[2];
  Object *var_noPosition = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for outerNode(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_nodes = &(stackframe->slots[0]);
  *var_nodes = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part outerNode(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject785 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj785 = alloc_userobj2(12,13, objclass785);
  gc_frame_newslot(obj785);
  if (objclass785 == NULL) {
    glfree(obj785->class->name);
    obj785->class->name = "outerNode(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj785, self, 0);
  addmethodreal(obj785,"outer", &reader_ast_outer_786);
  Object oldself785 = self;
  struct StackFrameObject *oldstackframe785 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe785);
  gc_frame_newslot((Object)stackframe);
  self = obj785;
  Object *oldselfslot785 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter785 = (*(struct UserObject *)self).data[0], lowerouter785 = thisouter785;
  if (inheritingObject785) {
    struct UserObject *inho785 = (struct UserObject *)inheritingObject785;
    while (inho785->super != GraceDefaultObject) inho785 = (struct UserObject *)inho785->super;
    inho785->super = obj785;
    self = inheritingObject785;
    *selfslot = self;
    lowerouter785 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter785;
  }
  if (objclass785 == NULL) {
  Method *reader787 = addmethodrealflags(obj785, "kind",&reader_ast_kind_787, MFLAG_DEF);
  reader787->definitionModule = modulename;
  reader787->definitionLine = 1737;
  }
  adddatum2(obj785, alloc_Undefined(), 1);
  if (objclass785 == NULL) {
  Method *reader788 = addmethodrealflags(obj785, "theObjects",&reader_ast_theObjects_788, MFLAG_DEF);
  reader788->definitionModule = modulename;
  reader788->definitionLine = 1738;
  }
  adddatum2(obj785, alloc_Undefined(), 2);
// method "numberOfLevels"
  struct UserObject *uo789 = (struct UserObject*)obj785;
  uo789->data[3] = emptyclosure;
  Method *meth_meth_ast_789_numberOfLevels = addmethod2pos(obj785, "numberOfLevels", &meth_ast_789_numberOfLevels, 3);
  int argcv_meth_ast_789_numberOfLevels[] = {0};
  meth_meth_ast_789_numberOfLevels->type = alloc_MethodType(1, argcv_meth_ast_789_numberOfLevels);
  meth_meth_ast_789_numberOfLevels->definitionModule = modulename;
  meth_meth_ast_789_numberOfLevels->definitionLine = 1739;
// method "asString"
  struct UserObject *uo794 = (struct UserObject*)obj785;
  uo794->data[4] = emptyclosure;
  Method *meth_meth_ast_794_asString = addmethod2pos(obj785, "asString", &meth_ast_794_asString, 4);
  int argcv_meth_ast_794_asString[] = {0};
  meth_meth_ast_794_asString->type = alloc_MethodType(1, argcv_meth_ast_794_asString);
  meth_meth_ast_794_asString->definitionModule = modulename;
  meth_meth_ast_794_asString->definitionLine = 1740;
// method "pretty(_)"
  struct UserObject *uo809 = (struct UserObject*)obj785;
  uo809->data[5] = emptyclosure;
  Method *meth_meth_ast_809_pretty_40_1_41_ = addmethod2pos(obj785, "pretty(1)", &meth_ast_809_pretty_40_1_41_, 5);
  int argcv_meth_ast_809_pretty_40_1_41_[] = {1};
  meth_meth_ast_809_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_809_pretty_40_1_41_);
  meth_meth_ast_809_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_809_pretty_40_1_41_->definitionLine = 1741;
// method "accept(_)from(_)"
  struct UserObject *uo817 = (struct UserObject*)obj785;
  uo817->data[6] = emptyclosure;
  Method *meth_meth_ast_817_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj785, "accept(1)from(1)", &meth_ast_817_accept_40_1_41_from_40_1_41_, 6);
  int argcv_meth_ast_817_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_817_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_817_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_817_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_817_accept_40_1_41_from_40_1_41_->definitionLine = 1742;
// method "toGrace(_)"
  struct UserObject *uo820 = (struct UserObject*)obj785;
  uo820->data[7] = emptyclosure;
  Method *meth_meth_ast_820_toGrace_40_1_41_ = addmethod2pos(obj785, "toGrace(1)", &meth_ast_820_toGrace_40_1_41_, 7);
  int argcv_meth_ast_820_toGrace_40_1_41_[] = {1};
  meth_meth_ast_820_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_820_toGrace_40_1_41_);
  meth_meth_ast_820_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_820_toGrace_40_1_41_->definitionLine = 1746;
// method "isOuter"
  struct UserObject *uo837 = (struct UserObject*)obj785;
  uo837->data[8] = emptyclosure;
  Method *meth_meth_ast_837_isOuter = addmethod2pos(obj785, "isOuter", &meth_ast_837_isOuter, 8);
  int argcv_meth_ast_837_isOuter[] = {0};
  meth_meth_ast_837_isOuter->type = alloc_MethodType(1, argcv_meth_ast_837_isOuter);
  meth_meth_ast_837_isOuter->definitionModule = modulename;
  meth_meth_ast_837_isOuter->definitionLine = 1749;
// method "isSelfOrOuter"
  struct UserObject *uo839 = (struct UserObject*)obj785;
  uo839->data[9] = emptyclosure;
  Method *meth_meth_ast_839_isSelfOrOuter = addmethod2pos(obj785, "isSelfOrOuter", &meth_ast_839_isSelfOrOuter, 9);
  int argcv_meth_ast_839_isSelfOrOuter[] = {0};
  meth_meth_ast_839_isSelfOrOuter->type = alloc_MethodType(1, argcv_meth_ast_839_isSelfOrOuter);
  meth_meth_ast_839_isSelfOrOuter->definitionModule = modulename;
  meth_meth_ast_839_isSelfOrOuter->definitionLine = 1750;
// method "shallowCopy"
  struct UserObject *uo841 = (struct UserObject*)obj785;
  uo841->data[10] = emptyclosure;
  Method *meth_meth_ast_841_shallowCopy = addmethod2pos(obj785, "shallowCopy", &meth_ast_841_shallowCopy, 10);
  int argcv_meth_ast_841_shallowCopy[] = {0};
  meth_meth_ast_841_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_841_shallowCopy);
  meth_meth_ast_841_shallowCopy->definitionModule = modulename;
  meth_meth_ast_841_shallowCopy->definitionLine = 1751;
// method "map(_)ancestors(_)"
  struct UserObject *uo848 = (struct UserObject*)obj785;
  uo848->data[11] = emptyclosure;
  Method *meth_meth_ast_848_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj785, "map(1)ancestors(1)", &meth_ast_848_map_40_1_41_ancestors_40_1_41_, 11);
  int argcv_meth_ast_848_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_848_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_848_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_848_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_848_map_40_1_41_ancestors_40_1_41_->definitionLine = 1754;
  if (objclass785 == NULL) {
  Method *reader853 = addmethodrealflags(obj785, "end",&reader_ast_end_853, MFLAG_DEF);
  reader853->definitionModule = modulename;
  reader853->definitionLine = 1758;
  }
  adddatum2(obj785, alloc_Undefined(), 12);
  sourceObject = obj785;
// Begin line 1736
  setline(1736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe854 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_ast (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call855 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe854);
// compiled call node returning call855 (depth = 2)
  struct UserObject *obj785_uo = (struct UserObject *)obj785;
  obj785_uo->super = call855;
  sourceObject = obj785;
// Begin line 1737
  setline(1737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit856 == NULL) {
    strlit856 = alloc_String("outer");
    gc_root(strlit856);
  }
// compiled string node returning strlit856 (depth = 2)
  adddatum2(obj785, strlit856, 1);
  sourceObject = obj785;
// Begin line 1738
  setline(1738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_nodes (depth = 2)
  adddatum2(obj785, *var_nodes, 2);
  sourceObject = obj785;
  sourceObject = obj785;
  sourceObject = obj785;
  sourceObject = obj785;
  sourceObject = obj785;
  sourceObject = obj785;
  sourceObject = obj785;
  sourceObject = obj785;
  sourceObject = obj785;
  sourceObject = obj785;
// Begin line 1758
  setline(1758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num859 = alloc_Float64(0);
// compiled num node returning num859 (depth = 4)
  int op_slot_right_858 = gc_frame_newslot(num859);
// starting to compile member node (depth = 4)
  int callframe861 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call862 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe861);
// compiled member node returning call862 (depth = 4)
  int op_slot_left_858 = gc_frame_newslot(call862);
  params[0] = num859;
  partcv[0] = 1;
  Object opresult863 = callmethod(call862, "==(1)", 1, partcv, params);
// compiled op node returning opresult863 (depth = 3)
  Object if857 = done;
struct StackFrameObject *iftmpstackframe857 = stackframe;
  if (istrue(opresult863)) {
stackframe = alloc_StackFrame(0, iftmpstackframe857);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_noPosition (depth = 3)
    gc_frame_newslot(*var_noPosition);
    if857 = *var_noPosition;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe857);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 1759
  setline(1759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe864 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe865 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call866 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe865);
// compiled member node returning call866 (depth = 4)
  gc_frame_newslot(call866);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num868 = alloc_Float64(4);
// compiled num node returning num868 (depth = 5)
  int op_slot_right_867 = gc_frame_newslot(num868);
// starting to compile member node (depth = 5)
  int callframe870 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call871 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe870);
// compiled member node returning call871 (depth = 5)
  int op_slot_left_867 = gc_frame_newslot(call871);
  params[0] = num868;
  partcv[0] = 1;
  Object sum872 = callmethod(call871, "+(1)", 1, partcv, params);
// compiled op node returning sum872 (depth = 4)
  gc_frame_newslot(sum872);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = call866;
  params[1] = sum872;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call873 = callmethodflags(module_ast, "line(1)column(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe864);
// compiled call node returning call873 (depth = 3)
    gc_frame_newslot(call873);
    if857 = call873;
  }
stackframe = iftmpstackframe857;
// compiled if node returning if857 (depth = 2)
  adddatum2(obj785, if857, 12);
  objclass785 = obj785->class;
  objclass785->definitionModule = modulename;
  objclass785->definitionLine = 1732;
  (*(struct UserObject *)self).data[0] = lowerouter785;
  self = oldself785;
  selfslot = oldselfslot785;
  stackframe = oldstackframe785;
  gc_frame_end(frame);
  return obj785;
}
Object meth_ast_784_outerNode_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "outerNode(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method outerNode(_)");
  Object params[2];
  int partcv[2];
  Object *var_noPosition = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for outerNode(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_nodes = &(stackframe->slots[0]);
  *var_nodes = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part outerNode(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject785 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj785 = alloc_userobj2(12,13, objclass785);
  gc_frame_newslot(obj785);
  if (objclass785 == NULL) {
    glfree(obj785->class->name);
    obj785->class->name = "outerNode(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj785, self, 0);
  addmethodreal(obj785,"outer", &reader_ast_outer_786);
  Object oldself785 = self;
  struct StackFrameObject *oldstackframe785 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe785);
  gc_frame_newslot((Object)stackframe);
  self = obj785;
  Object *oldselfslot785 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter785 = (*(struct UserObject *)self).data[0], lowerouter785 = thisouter785;
  if (inheritingObject785) {
    struct UserObject *inho785 = (struct UserObject *)inheritingObject785;
    while (inho785->super != GraceDefaultObject) inho785 = (struct UserObject *)inho785->super;
    inho785->super = obj785;
    self = inheritingObject785;
    *selfslot = self;
    lowerouter785 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter785;
  }
  if (objclass785 == NULL) {
  Method *reader787 = addmethodrealflags(obj785, "kind",&reader_ast_kind_787, MFLAG_DEF);
  reader787->definitionModule = modulename;
  reader787->definitionLine = 1737;
  }
  adddatum2(obj785, alloc_Undefined(), 1);
  if (objclass785 == NULL) {
  Method *reader788 = addmethodrealflags(obj785, "theObjects",&reader_ast_theObjects_788, MFLAG_DEF);
  reader788->definitionModule = modulename;
  reader788->definitionLine = 1738;
  }
  adddatum2(obj785, alloc_Undefined(), 2);
// method "numberOfLevels"
  struct UserObject *uo789 = (struct UserObject*)obj785;
  uo789->data[3] = emptyclosure;
  Method *meth_meth_ast_789_numberOfLevels = addmethod2pos(obj785, "numberOfLevels", &meth_ast_789_numberOfLevels, 3);
  int argcv_meth_ast_789_numberOfLevels[] = {0};
  meth_meth_ast_789_numberOfLevels->type = alloc_MethodType(1, argcv_meth_ast_789_numberOfLevels);
  meth_meth_ast_789_numberOfLevels->definitionModule = modulename;
  meth_meth_ast_789_numberOfLevels->definitionLine = 1739;
// method "asString"
  struct UserObject *uo794 = (struct UserObject*)obj785;
  uo794->data[4] = emptyclosure;
  Method *meth_meth_ast_794_asString = addmethod2pos(obj785, "asString", &meth_ast_794_asString, 4);
  int argcv_meth_ast_794_asString[] = {0};
  meth_meth_ast_794_asString->type = alloc_MethodType(1, argcv_meth_ast_794_asString);
  meth_meth_ast_794_asString->definitionModule = modulename;
  meth_meth_ast_794_asString->definitionLine = 1740;
// method "pretty(_)"
  struct UserObject *uo809 = (struct UserObject*)obj785;
  uo809->data[5] = emptyclosure;
  Method *meth_meth_ast_809_pretty_40_1_41_ = addmethod2pos(obj785, "pretty(1)", &meth_ast_809_pretty_40_1_41_, 5);
  int argcv_meth_ast_809_pretty_40_1_41_[] = {1};
  meth_meth_ast_809_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_809_pretty_40_1_41_);
  meth_meth_ast_809_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_809_pretty_40_1_41_->definitionLine = 1741;
// method "accept(_)from(_)"
  struct UserObject *uo817 = (struct UserObject*)obj785;
  uo817->data[6] = emptyclosure;
  Method *meth_meth_ast_817_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj785, "accept(1)from(1)", &meth_ast_817_accept_40_1_41_from_40_1_41_, 6);
  int argcv_meth_ast_817_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_817_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_817_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_817_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_817_accept_40_1_41_from_40_1_41_->definitionLine = 1742;
// method "toGrace(_)"
  struct UserObject *uo820 = (struct UserObject*)obj785;
  uo820->data[7] = emptyclosure;
  Method *meth_meth_ast_820_toGrace_40_1_41_ = addmethod2pos(obj785, "toGrace(1)", &meth_ast_820_toGrace_40_1_41_, 7);
  int argcv_meth_ast_820_toGrace_40_1_41_[] = {1};
  meth_meth_ast_820_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_820_toGrace_40_1_41_);
  meth_meth_ast_820_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_820_toGrace_40_1_41_->definitionLine = 1746;
// method "isOuter"
  struct UserObject *uo837 = (struct UserObject*)obj785;
  uo837->data[8] = emptyclosure;
  Method *meth_meth_ast_837_isOuter = addmethod2pos(obj785, "isOuter", &meth_ast_837_isOuter, 8);
  int argcv_meth_ast_837_isOuter[] = {0};
  meth_meth_ast_837_isOuter->type = alloc_MethodType(1, argcv_meth_ast_837_isOuter);
  meth_meth_ast_837_isOuter->definitionModule = modulename;
  meth_meth_ast_837_isOuter->definitionLine = 1749;
// method "isSelfOrOuter"
  struct UserObject *uo839 = (struct UserObject*)obj785;
  uo839->data[9] = emptyclosure;
  Method *meth_meth_ast_839_isSelfOrOuter = addmethod2pos(obj785, "isSelfOrOuter", &meth_ast_839_isSelfOrOuter, 9);
  int argcv_meth_ast_839_isSelfOrOuter[] = {0};
  meth_meth_ast_839_isSelfOrOuter->type = alloc_MethodType(1, argcv_meth_ast_839_isSelfOrOuter);
  meth_meth_ast_839_isSelfOrOuter->definitionModule = modulename;
  meth_meth_ast_839_isSelfOrOuter->definitionLine = 1750;
// method "shallowCopy"
  struct UserObject *uo841 = (struct UserObject*)obj785;
  uo841->data[10] = emptyclosure;
  Method *meth_meth_ast_841_shallowCopy = addmethod2pos(obj785, "shallowCopy", &meth_ast_841_shallowCopy, 10);
  int argcv_meth_ast_841_shallowCopy[] = {0};
  meth_meth_ast_841_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_841_shallowCopy);
  meth_meth_ast_841_shallowCopy->definitionModule = modulename;
  meth_meth_ast_841_shallowCopy->definitionLine = 1751;
// method "map(_)ancestors(_)"
  struct UserObject *uo848 = (struct UserObject*)obj785;
  uo848->data[11] = emptyclosure;
  Method *meth_meth_ast_848_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj785, "map(1)ancestors(1)", &meth_ast_848_map_40_1_41_ancestors_40_1_41_, 11);
  int argcv_meth_ast_848_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_848_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_848_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_848_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_848_map_40_1_41_ancestors_40_1_41_->definitionLine = 1754;
  if (objclass785 == NULL) {
  Method *reader853 = addmethodrealflags(obj785, "end",&reader_ast_end_853, MFLAG_DEF);
  reader853->definitionModule = modulename;
  reader853->definitionLine = 1758;
  }
  adddatum2(obj785, alloc_Undefined(), 12);
  sourceObject = obj785;
// Begin line 1736
  setline(1736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe854 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_ast (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call855 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe854);
// compiled call node returning call855 (depth = 2)
  struct UserObject *obj785_uo = (struct UserObject *)obj785;
  obj785_uo->super = call855;
  sourceObject = obj785;
// Begin line 1737
  setline(1737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit856 == NULL) {
    strlit856 = alloc_String("outer");
    gc_root(strlit856);
  }
// compiled string node returning strlit856 (depth = 2)
  adddatum2(obj785, strlit856, 1);
  sourceObject = obj785;
// Begin line 1738
  setline(1738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_nodes (depth = 2)
  adddatum2(obj785, *var_nodes, 2);
  sourceObject = obj785;
  sourceObject = obj785;
  sourceObject = obj785;
  sourceObject = obj785;
  sourceObject = obj785;
  sourceObject = obj785;
  sourceObject = obj785;
  sourceObject = obj785;
  sourceObject = obj785;
  sourceObject = obj785;
// Begin line 1758
  setline(1758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num859 = alloc_Float64(0);
// compiled num node returning num859 (depth = 4)
  int op_slot_right_858 = gc_frame_newslot(num859);
// starting to compile member node (depth = 4)
  int callframe861 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call862 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe861);
// compiled member node returning call862 (depth = 4)
  int op_slot_left_858 = gc_frame_newslot(call862);
  params[0] = num859;
  partcv[0] = 1;
  Object opresult863 = callmethod(call862, "==(1)", 1, partcv, params);
// compiled op node returning opresult863 (depth = 3)
  Object if857 = done;
struct StackFrameObject *iftmpstackframe857 = stackframe;
  if (istrue(opresult863)) {
stackframe = alloc_StackFrame(0, iftmpstackframe857);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_noPosition (depth = 3)
    gc_frame_newslot(*var_noPosition);
    if857 = *var_noPosition;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe857);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 1759
  setline(1759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe864 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe865 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call866 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe865);
// compiled member node returning call866 (depth = 4)
  gc_frame_newslot(call866);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num868 = alloc_Float64(4);
// compiled num node returning num868 (depth = 5)
  int op_slot_right_867 = gc_frame_newslot(num868);
// starting to compile member node (depth = 5)
  int callframe870 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call871 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe870);
// compiled member node returning call871 (depth = 5)
  int op_slot_left_867 = gc_frame_newslot(call871);
  params[0] = num868;
  partcv[0] = 1;
  Object sum872 = callmethod(call871, "+(1)", 1, partcv, params);
// compiled op node returning sum872 (depth = 4)
  gc_frame_newslot(sum872);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = call866;
  params[1] = sum872;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call873 = callmethodflags(module_ast, "line(1)column(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe864);
// compiled call node returning call873 (depth = 3)
    gc_frame_newslot(call873);
    if857 = call873;
  }
stackframe = iftmpstackframe857;
// compiled if node returning if857 (depth = 2)
  adddatum2(obj785, if857, 12);
  objclass785 = obj785->class;
  objclass785->definitionModule = modulename;
  objclass785->definitionLine = 1732;
  (*(struct UserObject *)self).data[0] = lowerouter785;
  self = oldself785;
  selfslot = oldselfslot785;
  stackframe = oldstackframe785;
  gc_frame_end(frame);
  return obj785;
}
Object meth_ast_878_newName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "newName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2844
  setline(2844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_n (depth = 2)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast_879_oldName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "oldName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2845
  setline(2845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_o (depth = 2)
  gc_frame_end(frame);
  return *var_o;
}
Object meth_ast_880_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2846
  setline(2846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit882 == NULL) {
    strlit882 = alloc_String("");
    gc_root(strlit882);
  }
// compiled string node returning strlit882 (depth = 3)
  int op_slot_right_881 = gc_frame_newslot(strlit882);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe885 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  partcv[0] = 0;
  Object call886 = callmethodflags(*var_o, "nameString", 1, partcv, params, 0);
  gc_frame_end(callframe885);
// compiled member node returning call886 (depth = 4)
  int op_slot_right_884 = gc_frame_newslot(call886);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit889 == NULL) {
    strlit889 = alloc_String(" = ");
    gc_root(strlit889);
  }
// compiled string node returning strlit889 (depth = 5)
  int op_slot_right_888 = gc_frame_newslot(strlit889);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe892 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call893 = callmethodflags(*var_n, "nameString", 1, partcv, params, 0);
  gc_frame_end(callframe892);
// compiled member node returning call893 (depth = 6)
  int op_slot_right_891 = gc_frame_newslot(call893);
// starting to compile string node (depth = 6)
  if (strlit895 == NULL) {
    strlit895 = alloc_String("alias ");
    gc_root(strlit895);
  }
// compiled string node returning strlit895 (depth = 6)
  int op_slot_left_891 = gc_frame_newslot(strlit895);
  params[0] = call893;
  partcv[0] = 1;
  Object opresult896 = callmethod(strlit895, "++(1)", 1, partcv, params);
// compiled op node returning opresult896 (depth = 5)
  int op_slot_left_888 = gc_frame_newslot(opresult896);
  params[0] = strlit889;
  partcv[0] = 1;
  Object opresult897 = callmethod(opresult896, "++(1)", 1, partcv, params);
// compiled op node returning opresult897 (depth = 4)
  int op_slot_left_884 = gc_frame_newslot(opresult897);
  params[0] = call886;
  partcv[0] = 1;
  Object opresult898 = callmethod(opresult897, "++(1)", 1, partcv, params);
// compiled op node returning opresult898 (depth = 3)
  int op_slot_left_881 = gc_frame_newslot(opresult898);
  params[0] = strlit882;
  partcv[0] = 1;
  Object opresult899 = callmethod(opresult898, "++(1)", 1, partcv, params);
// compiled op node returning opresult899 (depth = 2)
  gc_frame_end(frame);
  return opresult899;
}
Object meth_ast_900_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[1];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
// Begin line 2848
  setline(2848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num903 = alloc_Float64(1);
// compiled num node returning num903 (depth = 5)
  int op_slot_right_902 = gc_frame_newslot(num903);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_left_902 = gc_frame_newslot(*var_depth);
  params[0] = num903;
  partcv[0] = 1;
  Object sum905 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum905 (depth = 4)
  int op_slot_right_901 = gc_frame_newslot(sum905);
// starting to compile string node (depth = 4)
  if (strlit907 == NULL) {
    strlit907 = alloc_String("  ");
    gc_root(strlit907);
  }
// compiled string node returning strlit907 (depth = 4)
  int op_slot_left_901 = gc_frame_newslot(strlit907);
  params[0] = sum905;
  partcv[0] = 1;
  Object prod908 = callmethod(strlit907, "*(1)", 1, partcv, params);
// compiled op node returning prod908 (depth = 3)
  *var_spc = prod908;
  if (prod908 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2849
  setline(2849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit910 == NULL) {
    strlit910 = alloc_String("");
    gc_root(strlit910);
  }
// compiled string node returning strlit910 (depth = 3)
  int op_slot_right_909 = gc_frame_newslot(strlit910);
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe913 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call914 = callmethodflags(*var_o, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe913);
// compiled call node returning call914 (depth = 4)
  int op_slot_right_912 = gc_frame_newslot(call914);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit917 == NULL) {
    strlit917 = alloc_String(" = ");
    gc_root(strlit917);
  }
// compiled string node returning strlit917 (depth = 5)
  int op_slot_right_916 = gc_frame_newslot(strlit917);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe920 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call921 = callmethodflags(*var_n, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe920);
// compiled call node returning call921 (depth = 6)
  int op_slot_right_919 = gc_frame_newslot(call921);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit924 == NULL) {
    strlit924 = alloc_String("  alias ");
    gc_root(strlit924);
  }
// compiled string node returning strlit924 (depth = 7)
  int op_slot_right_923 = gc_frame_newslot(strlit924);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_926 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 8)
  if (strlit928 == NULL) {
    strlit928 = alloc_String("");
    gc_root(strlit928);
  }
// compiled string node returning strlit928 (depth = 8)
  int op_slot_left_926 = gc_frame_newslot(strlit928);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult929 = callmethod(strlit928, "++(1)", 1, partcv, params);
// compiled op node returning opresult929 (depth = 7)
  int op_slot_left_923 = gc_frame_newslot(opresult929);
  params[0] = strlit924;
  partcv[0] = 1;
  Object opresult930 = callmethod(opresult929, "++(1)", 1, partcv, params);
// compiled op node returning opresult930 (depth = 6)
  int op_slot_left_919 = gc_frame_newslot(opresult930);
  params[0] = call921;
  partcv[0] = 1;
  Object opresult931 = callmethod(opresult930, "++(1)", 1, partcv, params);
// compiled op node returning opresult931 (depth = 5)
  int op_slot_left_916 = gc_frame_newslot(opresult931);
  params[0] = strlit917;
  partcv[0] = 1;
  Object opresult932 = callmethod(opresult931, "++(1)", 1, partcv, params);
// compiled op node returning opresult932 (depth = 4)
  int op_slot_left_912 = gc_frame_newslot(opresult932);
  params[0] = call914;
  partcv[0] = 1;
  Object opresult933 = callmethod(opresult932, "++(1)", 1, partcv, params);
// compiled op node returning opresult933 (depth = 3)
  int op_slot_left_909 = gc_frame_newslot(opresult933);
  params[0] = strlit910;
  partcv[0] = 1;
  Object opresult934 = callmethod(opresult933, "++(1)", 1, partcv, params);
// compiled op node returning opresult934 (depth = 2)
  gc_frame_end(frame);
  return opresult934;
}
Object meth_ast_935_hash(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hash");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2851
  setline(2851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe937 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  partcv[0] = 0;
  Object call938 = callmethodflags(*var_o, "hash", 1, partcv, params, 0);
  gc_frame_end(callframe937);
// compiled member node returning call938 (depth = 3)
  int op_slot_right_936 = gc_frame_newslot(call938);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num941 = alloc_Float64(1171);
// compiled num node returning num941 (depth = 4)
  int op_slot_right_940 = gc_frame_newslot(num941);
// starting to compile member node (depth = 4)
  int callframe943 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  partcv[0] = 0;
  Object call944 = callmethodflags(*var_n, "hash", 1, partcv, params, 0);
  gc_frame_end(callframe943);
// compiled member node returning call944 (depth = 4)
  int op_slot_left_940 = gc_frame_newslot(call944);
  params[0] = num941;
  partcv[0] = 1;
  Object prod945 = callmethod(call944, "*(1)", 1, partcv, params);
// compiled op node returning prod945 (depth = 3)
  int op_slot_left_936 = gc_frame_newslot(prod945);
  params[0] = call938;
  partcv[0] = 1;
  Object sum946 = callmethod(prod945, "+(1)", 1, partcv, params);
// compiled op node returning sum946 (depth = 2)
  gc_frame_end(frame);
  return sum946;
}
Object meth_ast_947_isExecutable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2852
  setline(2852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool948 = alloc_Boolean(0);
// compiled identifier node returning bool948 (depth = 2)
  gc_frame_end(frame);
  return bool948;
}
Object meth_ast_952__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_that = &(stackframe->slots[0]);
  *var_that = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe955 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_that (depth = 7)
  partcv[0] = 0;
  Object call956 = callmethodflags(*var_that, "oldName", 1, partcv, params, 0);
  gc_frame_end(callframe955);
// compiled member node returning call956 (depth = 6)
  int op_slot_right_954 = gc_frame_newslot(call956);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  int op_slot_left_954 = gc_frame_newslot(*var_o);
  params[0] = call956;
  partcv[0] = 1;
  Object opresult958 = callmethod(*var_o, "==(1)", 1, partcv, params);
// compiled op node returning opresult958 (depth = 5)
  int op_slot_right_953 = gc_frame_newslot(opresult958);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe961 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_that (depth = 7)
  partcv[0] = 0;
  Object call962 = callmethodflags(*var_that, "newName", 1, partcv, params, 0);
  gc_frame_end(callframe961);
// compiled member node returning call962 (depth = 6)
  int op_slot_right_960 = gc_frame_newslot(call962);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_960 = gc_frame_newslot(*var_n);
  params[0] = call962;
  partcv[0] = 1;
  Object opresult964 = callmethod(*var_n, "==(1)", 1, partcv, params);
// compiled op node returning opresult964 (depth = 5)
  int op_slot_left_953 = gc_frame_newslot(opresult964);
  params[0] = opresult958;
  partcv[0] = 1;
  Object opresult965 = callmethod(opresult964, "&&(1)", 1, partcv, params);
// compiled op node returning opresult965 (depth = 4)
  gc_frame_end(frame);
  return opresult965;
}
Object meth_ast_977__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___1 = &(stackframe->slots[0]);
  *var___1 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile identifier node (depth = 4)
  Object bool978 = alloc_Boolean(0);
// compiled identifier node returning bool978 (depth = 4)
  gc_frame_end(frame);
  return bool978;
}
Object meth_ast_949__61__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object *var_AliasPair = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2854
  setline(2854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  int frame950 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 2855
  setline(2855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block951 = alloc_Block(NULL, NULL, "ast", 2855);
  gc_frame_newslot(block951);
// method "_apply(_)"
  block_savedest(block951);
  Object closure952 = createclosure(3, "_apply(1)");
  setclosureframe(closure952, stackframe);
  addtoclosure(closure952, var_o);
  addtoclosure(closure952, var_n);
  addtoclosure(closure952, selfslot);
  struct UserObject *uo952 = (struct UserObject*)block951;
  uo952->data[0] = (Object)closure952;
  Method *meth_meth_ast_952__apply_40_1_41_ = addmethod2pos(block951, "_apply(1)", &meth_ast_952__apply_40_1_41_, 0);
  int argcv_meth_ast_952__apply_40_1_41_[] = {1};
  meth_meth_ast_952__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_952__apply_40_1_41_);
  meth_meth_ast_952__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_952__apply_40_1_41_->definitionLine = 3050;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe967 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe968 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit969 == NULL) {
    strlit969 = alloc_String("that");
    gc_root(strlit969);
  }
// compiled string node returning strlit969 (depth = 6)
  gc_frame_newslot(strlit969);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe970 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call971 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe970);
// compiled member node returning call971 (depth = 6)
  params[0] = strlit969;
  partcv[0] = 1;
  Object call972 = callmethodflags(call971, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe968);
// compiled call node returning call972 (depth = 5)
  gc_frame_newslot(call972);
// Begin line 2855
  setline(2855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_AliasPair (depth = 5)
  gc_frame_newslot(*var_AliasPair);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe973 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call974 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe973);
// compiled member node returning call974 (depth = 5)
  params[0] = call972;
  params[1] = *var_AliasPair;
  partcv[0] = 2;
  Object call975 = callmethodflags(call974, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe967);
// compiled call node returning call975 (depth = 4)
((struct UserObject *)block951)->data[1] = call975;
// compiled block node returning block951 (depth = 3)
  gc_frame_newslot(block951);
// Begin line 2856
  setline(2856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block976 = alloc_Block(NULL, NULL, "ast", 2856);
  gc_frame_newslot(block976);
// method "_apply(_)"
  block_savedest(block976);
  Object closure977 = createclosure(1, "_apply(1)");
  setclosureframe(closure977, stackframe);
  addtoclosure(closure977, selfslot);
  struct UserObject *uo977 = (struct UserObject*)block976;
  uo977->data[0] = (Object)closure977;
  Method *meth_meth_ast_977__apply_40_1_41_ = addmethod2pos(block976, "_apply(1)", &meth_ast_977__apply_40_1_41_, 0);
  int argcv_meth_ast_977__apply_40_1_41_[] = {1};
  meth_meth_ast_977__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_977__apply_40_1_41_);
  meth_meth_ast_977__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_977__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block976 (depth = 3)
  gc_frame_newslot(block976);
  params[0] = block951;
  params[1] = block976;
  Object matchres950 = matchCase(*var_other, params, 2);
  gc_frame_end(frame950);
// compiled matchcase node returning matchres950 (depth = 2)
  gc_frame_end(frame);
  return matchres950;
}
Object meth_ast_875_aliasNew_40_1_41_old_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "aliasNew(1)old(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method aliasNew(_)old(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method aliasNew(_)old(_)");
  Object params[1];
  int partcv[1];
  Object *var_AliasPair = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for aliasNew(_)old(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part aliasNew(_)");
  Object *var_o = &(stackframe->slots[1]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part old(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject876 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj876 = alloc_userobj2(7,8, objclass876);
  gc_frame_newslot(obj876);
  if (objclass876 == NULL) {
    glfree(obj876->class->name);
    obj876->class->name = "aliasNew(_)old(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj876, self, 0);
  addmethodreal(obj876,"outer", &reader_ast_outer_877);
  Object oldself876 = self;
  struct StackFrameObject *oldstackframe876 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe876);
  gc_frame_newslot((Object)stackframe);
  self = obj876;
  Object *oldselfslot876 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter876 = (*(struct UserObject *)self).data[0], lowerouter876 = thisouter876;
  if (inheritingObject876) {
    struct UserObject *inho876 = (struct UserObject *)inheritingObject876;
    while (inho876->super != GraceDefaultObject) inho876 = (struct UserObject *)inho876->super;
    inho876->super = obj876;
    self = inheritingObject876;
    *selfslot = self;
    lowerouter876 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter876;
  }
// method "newName"
  block_savedest(obj876);
  Object closure878 = createclosure(1, "newName");
  setclosureframe(closure878, stackframe);
  addtoclosure(closure878, var_n);
  struct UserObject *uo878 = (struct UserObject*)obj876;
  uo878->data[1] = (Object)closure878;
  Method *meth_meth_ast_878_newName = addmethod2pos(obj876, "newName", &meth_ast_878_newName, 1);
  int argcv_meth_ast_878_newName[] = {0};
  meth_meth_ast_878_newName->type = alloc_MethodType(1, argcv_meth_ast_878_newName);
  meth_meth_ast_878_newName->definitionModule = modulename;
  meth_meth_ast_878_newName->definitionLine = 2844;
// method "oldName"
  block_savedest(obj876);
  Object closure879 = createclosure(1, "oldName");
  setclosureframe(closure879, stackframe);
  addtoclosure(closure879, var_o);
  struct UserObject *uo879 = (struct UserObject*)obj876;
  uo879->data[2] = (Object)closure879;
  Method *meth_meth_ast_879_oldName = addmethod2pos(obj876, "oldName", &meth_ast_879_oldName, 2);
  int argcv_meth_ast_879_oldName[] = {0};
  meth_meth_ast_879_oldName->type = alloc_MethodType(1, argcv_meth_ast_879_oldName);
  meth_meth_ast_879_oldName->definitionModule = modulename;
  meth_meth_ast_879_oldName->definitionLine = 2845;
// method "asString"
  block_savedest(obj876);
  Object closure880 = createclosure(2, "asString");
  setclosureframe(closure880, stackframe);
  addtoclosure(closure880, var_o);
  addtoclosure(closure880, var_n);
  struct UserObject *uo880 = (struct UserObject*)obj876;
  uo880->data[3] = (Object)closure880;
  Method *meth_meth_ast_880_asString = addmethod2pos(obj876, "asString", &meth_ast_880_asString, 3);
  int argcv_meth_ast_880_asString[] = {0};
  meth_meth_ast_880_asString->type = alloc_MethodType(1, argcv_meth_ast_880_asString);
  meth_meth_ast_880_asString->definitionModule = modulename;
  meth_meth_ast_880_asString->definitionLine = 2846;
// method "pretty(_)"
  block_savedest(obj876);
  Object closure900 = createclosure(2, "pretty(1)");
  setclosureframe(closure900, stackframe);
  addtoclosure(closure900, var_o);
  addtoclosure(closure900, var_n);
  struct UserObject *uo900 = (struct UserObject*)obj876;
  uo900->data[4] = (Object)closure900;
  Method *meth_meth_ast_900_pretty_40_1_41_ = addmethod2pos(obj876, "pretty(1)", &meth_ast_900_pretty_40_1_41_, 4);
  int argcv_meth_ast_900_pretty_40_1_41_[] = {1};
  meth_meth_ast_900_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_900_pretty_40_1_41_);
  meth_meth_ast_900_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_900_pretty_40_1_41_->definitionLine = 2847;
// method "hash"
  block_savedest(obj876);
  Object closure935 = createclosure(2, "hash");
  setclosureframe(closure935, stackframe);
  addtoclosure(closure935, var_o);
  addtoclosure(closure935, var_n);
  struct UserObject *uo935 = (struct UserObject*)obj876;
  uo935->data[5] = (Object)closure935;
  Method *meth_meth_ast_935_hash = addmethod2pos(obj876, "hash", &meth_ast_935_hash, 5);
  int argcv_meth_ast_935_hash[] = {0};
  meth_meth_ast_935_hash->type = alloc_MethodType(1, argcv_meth_ast_935_hash);
  meth_meth_ast_935_hash->definitionModule = modulename;
  meth_meth_ast_935_hash->definitionLine = 2851;
// method "isExecutable"
  struct UserObject *uo947 = (struct UserObject*)obj876;
  uo947->data[6] = emptyclosure;
  Method *meth_meth_ast_947_isExecutable = addmethod2pos(obj876, "isExecutable", &meth_ast_947_isExecutable, 6);
  int argcv_meth_ast_947_isExecutable[] = {0};
  meth_meth_ast_947_isExecutable->type = alloc_MethodType(1, argcv_meth_ast_947_isExecutable);
  meth_meth_ast_947_isExecutable->definitionModule = modulename;
  meth_meth_ast_947_isExecutable->definitionLine = 2852;
// method "==(_)"
  block_savedest(obj876);
  Object closure949 = createclosure(3, "==(1)");
  setclosureframe(closure949, stackframe);
  addtoclosure(closure949, var_o);
  addtoclosure(closure949, var_n);
  addtoclosure(closure949, var_AliasPair);
  struct UserObject *uo949 = (struct UserObject*)obj876;
  uo949->data[7] = (Object)closure949;
  Method *meth_meth_ast_949__61__61__40_1_41_ = addmethod2pos(obj876, "==(1)", &meth_ast_949__61__61__40_1_41_, 7);
  int argcv_meth_ast_949__61__61__40_1_41_[] = {1};
  meth_meth_ast_949__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_949__61__61__40_1_41_);
  meth_meth_ast_949__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_949__61__61__40_1_41_->definitionLine = 2853;
  sourceObject = obj876;
  sourceObject = obj876;
  sourceObject = obj876;
  sourceObject = obj876;
  sourceObject = obj876;
  sourceObject = obj876;
  sourceObject = obj876;
  objclass876 = obj876->class;
  objclass876->definitionModule = modulename;
  objclass876->definitionLine = 2843;
  (*(struct UserObject *)self).data[0] = lowerouter876;
  self = oldself876;
  selfslot = oldselfslot876;
  stackframe = oldstackframe876;
  gc_frame_end(frame);
  return obj876;
}
Object meth_ast_875_aliasNew_40_1_41_old_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "aliasNew(1)old(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method aliasNew(_)old(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method aliasNew(_)old(_)");
  Object params[1];
  int partcv[1];
  Object *var_AliasPair = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for aliasNew(_)old(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part aliasNew(_)");
  Object *var_o = &(stackframe->slots[1]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part old(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject876 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj876 = alloc_userobj2(7,8, objclass876);
  gc_frame_newslot(obj876);
  if (objclass876 == NULL) {
    glfree(obj876->class->name);
    obj876->class->name = "aliasNew(_)old(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj876, self, 0);
  addmethodreal(obj876,"outer", &reader_ast_outer_877);
  Object oldself876 = self;
  struct StackFrameObject *oldstackframe876 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe876);
  gc_frame_newslot((Object)stackframe);
  self = obj876;
  Object *oldselfslot876 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter876 = (*(struct UserObject *)self).data[0], lowerouter876 = thisouter876;
  if (inheritingObject876) {
    struct UserObject *inho876 = (struct UserObject *)inheritingObject876;
    while (inho876->super != GraceDefaultObject) inho876 = (struct UserObject *)inho876->super;
    inho876->super = obj876;
    self = inheritingObject876;
    *selfslot = self;
    lowerouter876 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter876;
  }
// method "newName"
  block_savedest(obj876);
  Object closure878 = createclosure(1, "newName");
  setclosureframe(closure878, stackframe);
  addtoclosure(closure878, var_n);
  struct UserObject *uo878 = (struct UserObject*)obj876;
  uo878->data[1] = (Object)closure878;
  Method *meth_meth_ast_878_newName = addmethod2pos(obj876, "newName", &meth_ast_878_newName, 1);
  int argcv_meth_ast_878_newName[] = {0};
  meth_meth_ast_878_newName->type = alloc_MethodType(1, argcv_meth_ast_878_newName);
  meth_meth_ast_878_newName->definitionModule = modulename;
  meth_meth_ast_878_newName->definitionLine = 2844;
// method "oldName"
  block_savedest(obj876);
  Object closure879 = createclosure(1, "oldName");
  setclosureframe(closure879, stackframe);
  addtoclosure(closure879, var_o);
  struct UserObject *uo879 = (struct UserObject*)obj876;
  uo879->data[2] = (Object)closure879;
  Method *meth_meth_ast_879_oldName = addmethod2pos(obj876, "oldName", &meth_ast_879_oldName, 2);
  int argcv_meth_ast_879_oldName[] = {0};
  meth_meth_ast_879_oldName->type = alloc_MethodType(1, argcv_meth_ast_879_oldName);
  meth_meth_ast_879_oldName->definitionModule = modulename;
  meth_meth_ast_879_oldName->definitionLine = 2845;
// method "asString"
  block_savedest(obj876);
  Object closure880 = createclosure(2, "asString");
  setclosureframe(closure880, stackframe);
  addtoclosure(closure880, var_o);
  addtoclosure(closure880, var_n);
  struct UserObject *uo880 = (struct UserObject*)obj876;
  uo880->data[3] = (Object)closure880;
  Method *meth_meth_ast_880_asString = addmethod2pos(obj876, "asString", &meth_ast_880_asString, 3);
  int argcv_meth_ast_880_asString[] = {0};
  meth_meth_ast_880_asString->type = alloc_MethodType(1, argcv_meth_ast_880_asString);
  meth_meth_ast_880_asString->definitionModule = modulename;
  meth_meth_ast_880_asString->definitionLine = 2846;
// method "pretty(_)"
  block_savedest(obj876);
  Object closure900 = createclosure(2, "pretty(1)");
  setclosureframe(closure900, stackframe);
  addtoclosure(closure900, var_o);
  addtoclosure(closure900, var_n);
  struct UserObject *uo900 = (struct UserObject*)obj876;
  uo900->data[4] = (Object)closure900;
  Method *meth_meth_ast_900_pretty_40_1_41_ = addmethod2pos(obj876, "pretty(1)", &meth_ast_900_pretty_40_1_41_, 4);
  int argcv_meth_ast_900_pretty_40_1_41_[] = {1};
  meth_meth_ast_900_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_900_pretty_40_1_41_);
  meth_meth_ast_900_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_900_pretty_40_1_41_->definitionLine = 2847;
// method "hash"
  block_savedest(obj876);
  Object closure935 = createclosure(2, "hash");
  setclosureframe(closure935, stackframe);
  addtoclosure(closure935, var_o);
  addtoclosure(closure935, var_n);
  struct UserObject *uo935 = (struct UserObject*)obj876;
  uo935->data[5] = (Object)closure935;
  Method *meth_meth_ast_935_hash = addmethod2pos(obj876, "hash", &meth_ast_935_hash, 5);
  int argcv_meth_ast_935_hash[] = {0};
  meth_meth_ast_935_hash->type = alloc_MethodType(1, argcv_meth_ast_935_hash);
  meth_meth_ast_935_hash->definitionModule = modulename;
  meth_meth_ast_935_hash->definitionLine = 2851;
// method "isExecutable"
  struct UserObject *uo947 = (struct UserObject*)obj876;
  uo947->data[6] = emptyclosure;
  Method *meth_meth_ast_947_isExecutable = addmethod2pos(obj876, "isExecutable", &meth_ast_947_isExecutable, 6);
  int argcv_meth_ast_947_isExecutable[] = {0};
  meth_meth_ast_947_isExecutable->type = alloc_MethodType(1, argcv_meth_ast_947_isExecutable);
  meth_meth_ast_947_isExecutable->definitionModule = modulename;
  meth_meth_ast_947_isExecutable->definitionLine = 2852;
// method "==(_)"
  block_savedest(obj876);
  Object closure949 = createclosure(3, "==(1)");
  setclosureframe(closure949, stackframe);
  addtoclosure(closure949, var_o);
  addtoclosure(closure949, var_n);
  addtoclosure(closure949, var_AliasPair);
  struct UserObject *uo949 = (struct UserObject*)obj876;
  uo949->data[7] = (Object)closure949;
  Method *meth_meth_ast_949__61__61__40_1_41_ = addmethod2pos(obj876, "==(1)", &meth_ast_949__61__61__40_1_41_, 7);
  int argcv_meth_ast_949__61__61__40_1_41_[] = {1};
  meth_meth_ast_949__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_949__61__61__40_1_41_);
  meth_meth_ast_949__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_949__61__61__40_1_41_->definitionLine = 2853;
  sourceObject = obj876;
  sourceObject = obj876;
  sourceObject = obj876;
  sourceObject = obj876;
  sourceObject = obj876;
  sourceObject = obj876;
  sourceObject = obj876;
  objclass876 = obj876->class;
  objclass876->definitionModule = modulename;
  objclass876->definitionLine = 2843;
  (*(struct UserObject *)self).data[0] = lowerouter876;
  self = oldself876;
  selfslot = oldselfslot876;
  stackframe = oldstackframe876;
  gc_frame_end(frame);
  return obj876;
}
Object meth_ast_1015__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ind = getfromclosure(closure, 0);
  Object *var_len = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ind (depth = 8)
  int op_slot_right_1016 = gc_frame_newslot(*var_ind);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_len (depth = 8)
  int op_slot_left_1016 = gc_frame_newslot(*var_len);
  params[0] = *var_ind;
  partcv[0] = 1;
  Object diff1018 = callmethod(*var_len, "-(1)", 1, partcv, params);
// compiled op node returning diff1018 (depth = 7)
  gc_frame_end(frame);
  return diff1018;
}
Object meth_ast_1008__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_ind = getfromclosure(closure, 0);
  Object *var_len = getfromclosure(closure, 1);
  Object *var_str = getfromclosure(closure, 2);
  Object *var_currBreak = getfromclosure(closure, 3);
  Object *var_trimmedLine = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3110
  setline(3110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1009 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1010 == NULL) {
    strlit1010 = alloc_String(" ");
    gc_root(strlit1010);
  }
// compiled string node returning strlit1010 (depth = 6)
  gc_frame_newslot(strlit1010);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ind (depth = 7)
  int op_slot_right_1011 = gc_frame_newslot(*var_ind);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_len (depth = 7)
  int op_slot_left_1011 = gc_frame_newslot(*var_len);
  params[0] = *var_ind;
  partcv[0] = 1;
  Object diff1013 = callmethod(*var_len, "-(1)", 1, partcv, params);
// compiled op node returning diff1013 (depth = 6)
  gc_frame_newslot(diff1013);
// Begin line 3111
  setline(3111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 6)
  Object block1014 = alloc_Block(NULL, NULL, "ast", 3111);
  gc_frame_newslot(block1014);
// method "_apply"
  block_savedest(block1014);
  Object closure1015 = createclosure(3, "_apply");
  setclosureframe(closure1015, stackframe);
  addtoclosure(closure1015, var_ind);
  addtoclosure(closure1015, var_len);
  addtoclosure(closure1015, selfslot);
  struct UserObject *uo1015 = (struct UserObject*)block1014;
  uo1015->data[0] = (Object)closure1015;
  Method *meth_meth_ast_1015__apply = addmethod2pos(block1014, "_apply", &meth_ast_1015__apply, 0);
  int argcv_meth_ast_1015__apply[] = {0};
  meth_meth_ast_1015__apply->type = alloc_MethodType(1, argcv_meth_ast_1015__apply);
  meth_meth_ast_1015__apply->definitionModule = modulename;
  meth_meth_ast_1015__apply->definitionLine = 3050;
// compiled block node returning block1014 (depth = 6)
  gc_frame_newslot(block1014);
// call case 6: other requests
// Begin line 3110
  setline(3110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_str (depth = 6)
  params[0] = strlit1010;
  params[1] = diff1013;
  params[2] = block1014;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1020 = callmethodflags(*var_str, "lastIndexOf(1)startingAt(1)ifAbsent(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1009);
// compiled call node returning call1020 (depth = 5)
  *var_currBreak = call1020;
  if (call1020 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 3112
  setline(3112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1022 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe1023 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num1024 = alloc_Float64(1);
// compiled num node returning num1024 (depth = 7)
  gc_frame_newslot(num1024);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_currBreak (depth = 7)
  gc_frame_newslot(*var_currBreak);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_str (depth = 7)
  params[0] = num1024;
  params[1] = *var_currBreak;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1025 = callmethodflags(*var_str, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1023);
// compiled call node returning call1025 (depth = 6)
  partcv[0] = 0;
  Object call1026 = callmethodflags(call1025, "trim", 1, partcv, params, 0);
  gc_frame_end(callframe1022);
// compiled member node returning call1026 (depth = 5)
  *var_trimmedLine = call1026;
  if (call1026 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_1041__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_str = getfromclosure(closure, 0);
  Object *var_currBreak = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 3116
  setline(3116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1044 == NULL) {
    strlit1044 = alloc_String(" ");
    gc_root(strlit1044);
  }
// compiled string node returning strlit1044 (depth = 8)
  int op_slot_right_1043 = gc_frame_newslot(strlit1044);
// starting to compile call node (depth = 8)
  int callframe1046 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  gc_frame_newslot(*var_ix);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_str (depth = 9)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call1047 = callmethodflags(*var_str, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1046);
// compiled call node returning call1047 (depth = 8)
  int op_slot_left_1043 = gc_frame_newslot(call1047);
  params[0] = strlit1044;
  partcv[0] = 1;
  Object opresult1048 = callmethod(call1047, "==(1)", 1, partcv, params);
// compiled op node returning opresult1048 (depth = 7)
  Object if1042 = done;
  if (istrue(opresult1048)) {
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  *var_currBreak = *var_ix;
  if (*var_ix == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1042 = done;
  } else {
  }
// compiled if node returning if1042 (depth = 6)
  gc_frame_end(frame);
  return if1042;
}
Object meth_ast_1061__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_end = getfromclosure(closure, 0);
  Object *var_str = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1063 == NULL) {
    strlit1063 = alloc_String(" ");
    gc_root(strlit1063);
  }
// compiled string node returning strlit1063 (depth = 9)
  int op_slot_right_1062 = gc_frame_newslot(strlit1063);
// starting to compile call node (depth = 9)
  int callframe1065 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_end (depth = 10)
  gc_frame_newslot(*var_end);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_str (depth = 10)
  params[0] = *var_end;
  partcv[0] = 1;
  Object call1066 = callmethodflags(*var_str, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1065);
// compiled call node returning call1066 (depth = 9)
  int op_slot_left_1062 = gc_frame_newslot(call1066);
  params[0] = strlit1063;
  partcv[0] = 1;
  Object opresult1067 = callmethod(call1066, "==(1)", 1, partcv, params);
// compiled op node returning opresult1067 (depth = 8)
  gc_frame_end(frame);
  return opresult1067;
}
Object meth_ast_1058__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_end = getfromclosure(closure, 0);
  Object *var_str = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// starting to compile block node (depth = 7)
  Object block1060 = alloc_Block(NULL, NULL, "ast", 3119);
  gc_frame_newslot(block1060);
// method "_apply"
  block_savedest(block1060);
  Object closure1061 = createclosure(3, "_apply");
  setclosureframe(closure1061, stackframe);
  addtoclosure(closure1061, var_end);
  addtoclosure(closure1061, var_str);
  addtoclosure(closure1061, selfslot);
  struct UserObject *uo1061 = (struct UserObject*)block1060;
  uo1061->data[0] = (Object)closure1061;
  Method *meth_meth_ast_1061__apply = addmethod2pos(block1060, "_apply", &meth_ast_1061__apply, 0);
  int argcv_meth_ast_1061__apply[] = {0};
  meth_meth_ast_1061__apply->type = alloc_MethodType(1, argcv_meth_ast_1061__apply);
  meth_meth_ast_1061__apply->definitionModule = modulename;
  meth_meth_ast_1061__apply->definitionLine = 3050;
// compiled block node returning block1060 (depth = 7)
  int op_slot_right_1059 = gc_frame_newslot(block1060);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1071 = alloc_Float64(1);
// compiled num node returning num1071 (depth = 8)
  int op_slot_right_1070 = gc_frame_newslot(num1071);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_end (depth = 8)
  int op_slot_left_1070 = gc_frame_newslot(*var_end);
  params[0] = num1071;
  partcv[0] = 1;
  Object opresult1073 = callmethod(*var_end, "≥(1)", 1, partcv, params);
// compiled op node returning opresult1073 (depth = 7)
  int op_slot_left_1059 = gc_frame_newslot(opresult1073);
  params[0] = block1060;
  partcv[0] = 1;
  Object opresult1074 = callmethod(opresult1073, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1074 (depth = 6)
  gc_frame_end(frame);
  return opresult1074;
}
Object meth_ast_1077__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_end = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3120
  setline(3120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1079 = alloc_Float64(1);
// compiled num node returning num1079 (depth = 8)
  int op_slot_right_1078 = gc_frame_newslot(num1079);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_end (depth = 8)
  int op_slot_left_1078 = gc_frame_newslot(*var_end);
  params[0] = num1079;
  partcv[0] = 1;
  Object diff1081 = callmethod(*var_end, "-(1)", 1, partcv, params);
// compiled op node returning diff1081 (depth = 7)
  *var_end = diff1081;
  if (diff1081 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_1091__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_start = getfromclosure(closure, 0);
  Object *var_str = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1093 == NULL) {
    strlit1093 = alloc_String(" ");
    gc_root(strlit1093);
  }
// compiled string node returning strlit1093 (depth = 9)
  int op_slot_right_1092 = gc_frame_newslot(strlit1093);
// starting to compile call node (depth = 9)
  int callframe1095 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_start (depth = 10)
  gc_frame_newslot(*var_start);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_str (depth = 10)
  params[0] = *var_start;
  partcv[0] = 1;
  Object call1096 = callmethodflags(*var_str, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1095);
// compiled call node returning call1096 (depth = 9)
  int op_slot_left_1092 = gc_frame_newslot(call1096);
  params[0] = strlit1093;
  partcv[0] = 1;
  Object opresult1097 = callmethod(call1096, "==(1)", 1, partcv, params);
// compiled op node returning opresult1097 (depth = 8)
  gc_frame_end(frame);
  return opresult1097;
}
Object meth_ast_1088__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_start = getfromclosure(closure, 0);
  Object *var_str = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// starting to compile block node (depth = 7)
  Object block1090 = alloc_Block(NULL, NULL, "ast", 3123);
  gc_frame_newslot(block1090);
// method "_apply"
  block_savedest(block1090);
  Object closure1091 = createclosure(3, "_apply");
  setclosureframe(closure1091, stackframe);
  addtoclosure(closure1091, var_start);
  addtoclosure(closure1091, var_str);
  addtoclosure(closure1091, selfslot);
  struct UserObject *uo1091 = (struct UserObject*)block1090;
  uo1091->data[0] = (Object)closure1091;
  Method *meth_meth_ast_1091__apply = addmethod2pos(block1090, "_apply", &meth_ast_1091__apply, 0);
  int argcv_meth_ast_1091__apply[] = {0};
  meth_meth_ast_1091__apply->type = alloc_MethodType(1, argcv_meth_ast_1091__apply);
  meth_meth_ast_1091__apply->definitionModule = modulename;
  meth_meth_ast_1091__apply->definitionLine = 3050;
// compiled block node returning block1090 (depth = 7)
  int op_slot_right_1089 = gc_frame_newslot(block1090);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1101 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_str (depth = 9)
  partcv[0] = 0;
  Object call1102 = callmethodflags(*var_str, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1101);
// compiled member node returning call1102 (depth = 8)
  int op_slot_right_1100 = gc_frame_newslot(call1102);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_start (depth = 8)
  int op_slot_left_1100 = gc_frame_newslot(*var_start);
  params[0] = call1102;
  partcv[0] = 1;
  Object opresult1104 = callmethod(*var_start, "≤(1)", 1, partcv, params);
// compiled op node returning opresult1104 (depth = 7)
  int op_slot_left_1089 = gc_frame_newslot(opresult1104);
  params[0] = block1090;
  partcv[0] = 1;
  Object opresult1105 = callmethod(opresult1104, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1105 (depth = 6)
  gc_frame_end(frame);
  return opresult1105;
}
Object meth_ast_1108__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_start = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3124
  setline(3124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1110 = alloc_Float64(1);
// compiled num node returning num1110 (depth = 8)
  int op_slot_right_1109 = gc_frame_newslot(num1110);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_start (depth = 8)
  int op_slot_left_1109 = gc_frame_newslot(*var_start);
  params[0] = num1110;
  partcv[0] = 1;
  Object sum1112 = callmethod(*var_start, "+(1)", 1, partcv, params);
// compiled op node returning sum1112 (depth = 7)
  *var_start = sum1112;
  if (sum1112 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_1030__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_ind = getfromclosure(closure, 0);
  Object *var_len = getfromclosure(closure, 1);
  Object *var_str = getfromclosure(closure, 2);
  Object *var_currBreak = getfromclosure(closure, 3);
  Object *var_trimmedLine = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ex = &(stackframe->slots[0]);
  *var_ex = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_end = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "end");
  Object *var_start = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "start");
// Begin line 3114
  setline(3114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1031 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ind (depth = 7)
  int op_slot_right_1032 = gc_frame_newslot(*var_ind);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_len (depth = 7)
  int op_slot_left_1032 = gc_frame_newslot(*var_len);
  params[0] = *var_ind;
  partcv[0] = 1;
  Object diff1034 = callmethod(*var_len, "-(1)", 1, partcv, params);
// compiled op node returning diff1034 (depth = 6)
  gc_frame_newslot(diff1034);
// starting to compile member node (depth = 6)
  int callframe1035 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_str (depth = 7)
  partcv[0] = 0;
  Object call1036 = callmethodflags(*var_str, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1035);
// compiled member node returning call1036 (depth = 6)
  gc_frame_newslot(call1036);
// call case 5: prelude request
  params[0] = diff1034;
  params[1] = call1036;
  partcv[0] = 2;
  Object call1037 = callmethodflags(prelude, "min(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1031);
// compiled call node returning call1037 (depth = 5)
  *var_currBreak = call1037;
  if (call1037 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 3115
  setline(3115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1039 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block1040 = alloc_Block(NULL, NULL, "ast", 3115);
  gc_frame_newslot(block1040);
// method "_apply(_)"
  block_savedest(block1040);
  Object closure1041 = createclosure(3, "_apply(1)");
  setclosureframe(closure1041, stackframe);
  addtoclosure(closure1041, var_str);
  addtoclosure(closure1041, var_currBreak);
  addtoclosure(closure1041, selfslot);
  struct UserObject *uo1041 = (struct UserObject*)block1040;
  uo1041->data[0] = (Object)closure1041;
  Method *meth_meth_ast_1041__apply_40_1_41_ = addmethod2pos(block1040, "_apply(1)", &meth_ast_1041__apply_40_1_41_, 0);
  int argcv_meth_ast_1041__apply_40_1_41_[] = {1};
  meth_meth_ast_1041__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1041__apply_40_1_41_);
  meth_meth_ast_1041__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1041__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block1040 (depth = 5)
  gc_frame_newslot(block1040);
// call case 6: other requests
// Begin line 3115
  setline(3115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_currBreak (depth = 6)
  int op_slot_right_1051 = gc_frame_newslot(*var_currBreak);
// starting to compile num node (depth = 6)
  Object num1053 = alloc_Float64(1);
// compiled num node returning num1053 (depth = 6)
  int op_slot_left_1051 = gc_frame_newslot(num1053);
  params[0] = *var_currBreak;
  partcv[0] = 1;
  Object opresult1054 = callmethod(num1053, "..(1)", 1, partcv, params);
// compiled op node returning opresult1054 (depth = 5)
  params[0] = block1040;
  partcv[0] = 1;
  Object call1055 = callmethodflags(opresult1054, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1039);
// compiled call node returning call1055 (depth = 4)
// Begin line 3118
  setline(3118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_currBreak (depth = 5)
  *var_end = *var_currBreak;
  if (*var_currBreak == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 3119
  setline(3119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1056 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block1057 = alloc_Block(NULL, NULL, "ast", 3119);
  gc_frame_newslot(block1057);
// method "_apply"
  block_savedest(block1057);
  Object closure1058 = createclosure(3, "_apply");
  setclosureframe(closure1058, stackframe);
  addtoclosure(closure1058, var_end);
  addtoclosure(closure1058, var_str);
  addtoclosure(closure1058, selfslot);
  struct UserObject *uo1058 = (struct UserObject*)block1057;
  uo1058->data[0] = (Object)closure1058;
  Method *meth_meth_ast_1058__apply = addmethod2pos(block1057, "_apply", &meth_ast_1058__apply, 0);
  int argcv_meth_ast_1058__apply[] = {0};
  meth_meth_ast_1058__apply->type = alloc_MethodType(1, argcv_meth_ast_1058__apply);
  meth_meth_ast_1058__apply->definitionModule = modulename;
  meth_meth_ast_1058__apply->definitionLine = 3050;
// compiled block node returning block1057 (depth = 5)
  gc_frame_newslot(block1057);
// starting to compile block node (depth = 5)
  Object block1076 = alloc_Block(NULL, NULL, "ast", 3119);
  gc_frame_newslot(block1076);
// method "_apply"
  block_savedest(block1076);
  Object closure1077 = createclosure(2, "_apply");
  setclosureframe(closure1077, stackframe);
  addtoclosure(closure1077, var_end);
  addtoclosure(closure1077, selfslot);
  struct UserObject *uo1077 = (struct UserObject*)block1076;
  uo1077->data[0] = (Object)closure1077;
  Method *meth_meth_ast_1077__apply = addmethod2pos(block1076, "_apply", &meth_ast_1077__apply, 0);
  int argcv_meth_ast_1077__apply[] = {0};
  meth_meth_ast_1077__apply->type = alloc_MethodType(1, argcv_meth_ast_1077__apply);
  meth_meth_ast_1077__apply->definitionModule = modulename;
  meth_meth_ast_1077__apply->definitionLine = 3050;
// compiled block node returning block1076 (depth = 5)
  gc_frame_newslot(block1076);
// call case 5: prelude request
  params[0] = block1057;
  params[1] = block1076;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1084 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1056);
// compiled call node returning call1084 (depth = 4)
// Begin line 3122
  setline(3122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1085 = alloc_Float64(1);
// compiled num node returning num1085 (depth = 5)
  *var_start = num1085;
  if (num1085 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 3123
  setline(3123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1086 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block1087 = alloc_Block(NULL, NULL, "ast", 3123);
  gc_frame_newslot(block1087);
// method "_apply"
  block_savedest(block1087);
  Object closure1088 = createclosure(3, "_apply");
  setclosureframe(closure1088, stackframe);
  addtoclosure(closure1088, var_start);
  addtoclosure(closure1088, var_str);
  addtoclosure(closure1088, selfslot);
  struct UserObject *uo1088 = (struct UserObject*)block1087;
  uo1088->data[0] = (Object)closure1088;
  Method *meth_meth_ast_1088__apply = addmethod2pos(block1087, "_apply", &meth_ast_1088__apply, 0);
  int argcv_meth_ast_1088__apply[] = {0};
  meth_meth_ast_1088__apply->type = alloc_MethodType(1, argcv_meth_ast_1088__apply);
  meth_meth_ast_1088__apply->definitionModule = modulename;
  meth_meth_ast_1088__apply->definitionLine = 3050;
// compiled block node returning block1087 (depth = 5)
  gc_frame_newslot(block1087);
// starting to compile block node (depth = 5)
  Object block1107 = alloc_Block(NULL, NULL, "ast", 3123);
  gc_frame_newslot(block1107);
// method "_apply"
  block_savedest(block1107);
  Object closure1108 = createclosure(2, "_apply");
  setclosureframe(closure1108, stackframe);
  addtoclosure(closure1108, var_start);
  addtoclosure(closure1108, selfslot);
  struct UserObject *uo1108 = (struct UserObject*)block1107;
  uo1108->data[0] = (Object)closure1108;
  Method *meth_meth_ast_1108__apply = addmethod2pos(block1107, "_apply", &meth_ast_1108__apply, 0);
  int argcv_meth_ast_1108__apply[] = {0};
  meth_meth_ast_1108__apply->type = alloc_MethodType(1, argcv_meth_ast_1108__apply);
  meth_meth_ast_1108__apply->definitionModule = modulename;
  meth_meth_ast_1108__apply->definitionLine = 3050;
// compiled block node returning block1107 (depth = 5)
  gc_frame_newslot(block1107);
// call case 5: prelude request
  params[0] = block1087;
  params[1] = block1107;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1115 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1086);
// compiled call node returning call1115 (depth = 4)
// Begin line 3126
  setline(3126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1116 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_start (depth = 6)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_end (depth = 6)
  gc_frame_newslot(*var_end);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_str (depth = 6)
  params[0] = *var_start;
  params[1] = *var_end;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1117 = callmethodflags(*var_str, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1116);
// compiled call node returning call1117 (depth = 5)
  *var_trimmedLine = call1117;
  if (call1117 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_981_wrap_40_1_41_to_40_1_41_prefix_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(8, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "wrap(1)to(1)prefix(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method wrap(_)to(_)prefix(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method wrap(_)to(_)prefix(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method wrap(_)to(_)prefix(_)");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for wrap(_)to(_)prefix(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_str = &(stackframe->slots[0]);
  *var_str = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part wrap(_)");
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part to(_)");
  Object *var_margin = &(stackframe->slots[2]);
  *var_margin = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part prefix(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_ind = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "ind");
  Object *var_len = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "len");
// definebindings:
// definebindings:
  Object *var_currBreak = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "currBreak");
  Object *var_trimmedLine = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "trimmedLine");
// Begin line 3101
  setline(3101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe982 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_margin (depth = 4)
  partcv[0] = 0;
  Object call983 = callmethodflags(*var_margin, "size", 1, partcv, params, 0);
  gc_frame_end(callframe982);
// compiled member node returning call983 (depth = 3)
  *var_ind = call983;
  if (call983 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 3102
  setline(3102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe984 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num986 = alloc_Float64(4);
// compiled num node returning num986 (depth = 5)
  int op_slot_right_985 = gc_frame_newslot(num986);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ind (depth = 5)
  int op_slot_left_985 = gc_frame_newslot(*var_ind);
  params[0] = num986;
  partcv[0] = 1;
  Object sum988 = callmethod(*var_ind, "+(1)", 1, partcv, params);
// compiled op node returning sum988 (depth = 4)
  gc_frame_newslot(sum988);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_l (depth = 4)
  gc_frame_newslot(*var_l);
// call case 5: prelude request
  params[0] = sum988;
  params[1] = *var_l;
  partcv[0] = 2;
  Object call989 = callmethodflags(prelude, "max(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe984);
// compiled call node returning call989 (depth = 3)
  *var_len = call989;
  if (call989 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 3103
  setline(3103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_len (depth = 4)
  int op_slot_right_991 = gc_frame_newslot(*var_len);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe994 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_str (depth = 6)
  partcv[0] = 0;
  Object call995 = callmethodflags(*var_str, "size", 1, partcv, params, 0);
  gc_frame_end(callframe994);
// compiled member node returning call995 (depth = 5)
  int op_slot_right_993 = gc_frame_newslot(call995);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ind (depth = 5)
  int op_slot_left_993 = gc_frame_newslot(*var_ind);
  params[0] = call995;
  partcv[0] = 1;
  Object sum997 = callmethod(*var_ind, "+(1)", 1, partcv, params);
// compiled op node returning sum997 (depth = 4)
  int op_slot_left_991 = gc_frame_newslot(sum997);
  params[0] = *var_len;
  partcv[0] = 1;
  Object opresult998 = callmethod(sum997, "≤(1)", 1, partcv, params);
// compiled op node returning opresult998 (depth = 3)
  Object if990 = done;
  if (istrue(opresult998)) {
// Begin line 3104
  setline(3104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_str (depth = 5)
  int op_slot_right_999 = gc_frame_newslot(*var_str);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_margin (depth = 6)
  int op_slot_right_1001 = gc_frame_newslot(*var_margin);
// starting to compile string node (depth = 6)
  if (strlit1003 == NULL) {
    strlit1003 = alloc_String("""\x0a""");
    gc_root(strlit1003);
  }
// compiled string node returning strlit1003 (depth = 6)
  int op_slot_left_1001 = gc_frame_newslot(strlit1003);
  params[0] = *var_margin;
  partcv[0] = 1;
  Object opresult1004 = callmethod(strlit1003, "++(1)", 1, partcv, params);
// compiled op node returning opresult1004 (depth = 5)
  int op_slot_left_999 = gc_frame_newslot(opresult1004);
  params[0] = *var_str;
  partcv[0] = 1;
  Object opresult1005 = callmethod(opresult1004, "++(1)", 1, partcv, params);
// compiled op node returning opresult1005 (depth = 4)
  return opresult1005;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if990 = undefined;
  } else {
  }
// compiled if node returning if990 (depth = 2)
// Begin line 3106
  setline(3106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_currBreak = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 3107
  setline(3107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_trimmedLine = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 3109
  setline(3109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile trycatch node (depth = 2)
// starting to compile block node (depth = 3)
  Object block1007 = alloc_Block(NULL, NULL, "ast", 3109);
  gc_frame_newslot(block1007);
// method "_apply"
  block_savedest(block1007);
  Object closure1008 = createclosure(6, "_apply");
  setclosureframe(closure1008, stackframe);
  addtoclosure(closure1008, var_ind);
  addtoclosure(closure1008, var_len);
  addtoclosure(closure1008, var_str);
  addtoclosure(closure1008, var_currBreak);
  addtoclosure(closure1008, var_trimmedLine);
  addtoclosure(closure1008, selfslot);
  struct UserObject *uo1008 = (struct UserObject*)block1007;
  uo1008->data[0] = (Object)closure1008;
  Method *meth_meth_ast_1008__apply = addmethod2pos(block1007, "_apply", &meth_ast_1008__apply, 0);
  int argcv_meth_ast_1008__apply[] = {0};
  meth_meth_ast_1008__apply->type = alloc_MethodType(1, argcv_meth_ast_1008__apply);
  meth_meth_ast_1008__apply->definitionModule = modulename;
  meth_meth_ast_1008__apply->definitionLine = 3050;
// compiled block node returning block1007 (depth = 3)
  int frame1006 = gc_frame_new();
  gc_frame_newslot(block1007);
// Begin line 3113
  setline(3113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block1029 = alloc_Block(NULL, NULL, "ast", 3113);
  gc_frame_newslot(block1029);
// method "_apply(_)"
  block_savedest(block1029);
  Object closure1030 = createclosure(6, "_apply(1)");
  setclosureframe(closure1030, stackframe);
  addtoclosure(closure1030, var_ind);
  addtoclosure(closure1030, var_len);
  addtoclosure(closure1030, var_str);
  addtoclosure(closure1030, var_currBreak);
  addtoclosure(closure1030, var_trimmedLine);
  addtoclosure(closure1030, selfslot);
  struct UserObject *uo1030 = (struct UserObject*)block1029;
  uo1030->data[0] = (Object)closure1030;
  Method *meth_meth_ast_1030__apply_40_1_41_ = addmethod2pos(block1029, "_apply(1)", &meth_ast_1030__apply_40_1_41_, 0);
  int argcv_meth_ast_1030__apply_40_1_41_[] = {1};
  meth_meth_ast_1030__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1030__apply_40_1_41_);
  meth_meth_ast_1030__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1030__apply_40_1_41_->definitionLine = 3050;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1120 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe1121 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1122 == NULL) {
    strlit1122 = alloc_String("ex");
    gc_root(strlit1122);
  }
// compiled string node returning strlit1122 (depth = 6)
  gc_frame_newslot(strlit1122);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1123 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1124 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1123);
// compiled member node returning call1124 (depth = 6)
  params[0] = strlit1122;
  partcv[0] = 1;
  Object call1125 = callmethodflags(call1124, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1121);
// compiled call node returning call1125 (depth = 5)
  gc_frame_newslot(call1125);
// Begin line 3113
  setline(3113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1126 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1127 = callmethodflags(prelude, "NoSuchMethod", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1126);
// compiled member node returning call1127 (depth = 5)
  gc_frame_newslot(call1127);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1128 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1129 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1128);
// compiled member node returning call1129 (depth = 5)
  params[0] = call1125;
  params[1] = call1127;
  partcv[0] = 2;
  Object call1130 = callmethodflags(call1129, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1120);
// compiled call node returning call1130 (depth = 4)
((struct UserObject *)block1029)->data[1] = call1130;
// compiled block node returning block1029 (depth = 3)
  gc_frame_newslot(block1029);
  params[0] = block1029;
  setline(3109);
  Object catchres1006 = tryCatch(block1007, params, 1,NULL);
  gc_frame_end(frame1006);
// compiled trycatch node returning catchres1006 (depth = 2)
// Begin line 3128
  setline(3128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// Begin line 3129
  setline(3129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1132 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1133 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1135 = alloc_Float64(1);
// compiled num node returning num1135 (depth = 6)
  int op_slot_right_1134 = gc_frame_newslot(num1135);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_currBreak (depth = 6)
  int op_slot_left_1134 = gc_frame_newslot(*var_currBreak);
  params[0] = num1135;
  partcv[0] = 1;
  Object sum1137 = callmethod(*var_currBreak, "+(1)", 1, partcv, params);
// compiled op node returning sum1137 (depth = 5)
  gc_frame_newslot(sum1137);
// starting to compile member node (depth = 5)
  int callframe1138 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_str (depth = 6)
  partcv[0] = 0;
  Object call1139 = callmethodflags(*var_str, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1138);
// compiled member node returning call1139 (depth = 5)
  gc_frame_newslot(call1139);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_str (depth = 5)
  params[0] = sum1137;
  params[1] = call1139;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1140 = callmethodflags(*var_str, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1133);
// compiled call node returning call1140 (depth = 4)
  gc_frame_newslot(call1140);
// Begin line 3130
  setline(3130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_l (depth = 4)
  gc_frame_newslot(*var_l);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_margin (depth = 4)
  gc_frame_newslot(*var_margin);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = call1140;
  params[1] = *var_l;
  params[2] = *var_margin;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1141 = callmethodflags(module_ast, "wrap(1)to(1)prefix(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1132);
// compiled call node returning call1141 (depth = 3)
  int op_slot_right_1131 = gc_frame_newslot(call1141);
// Begin line 3128
  setline(3128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_trimmedLine (depth = 4)
  int op_slot_right_1143 = gc_frame_newslot(*var_trimmedLine);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_margin (depth = 5)
  int op_slot_right_1145 = gc_frame_newslot(*var_margin);
// starting to compile string node (depth = 5)
  if (strlit1147 == NULL) {
    strlit1147 = alloc_String("""\x0a""");
    gc_root(strlit1147);
  }
// compiled string node returning strlit1147 (depth = 5)
  int op_slot_left_1145 = gc_frame_newslot(strlit1147);
  params[0] = *var_margin;
  partcv[0] = 1;
  Object opresult1148 = callmethod(strlit1147, "++(1)", 1, partcv, params);
// compiled op node returning opresult1148 (depth = 4)
  int op_slot_left_1143 = gc_frame_newslot(opresult1148);
  params[0] = *var_trimmedLine;
  partcv[0] = 1;
  Object opresult1149 = callmethod(opresult1148, "++(1)", 1, partcv, params);
// compiled op node returning opresult1149 (depth = 3)
  int op_slot_left_1131 = gc_frame_newslot(opresult1149);
  params[0] = call1141;
  partcv[0] = 1;
  Object opresult1150 = callmethod(opresult1149, "++(1)", 1, partcv, params);
// compiled op node returning opresult1150 (depth = 2)
  gc_frame_end(frame);
  return opresult1150;
}
Object meth_ast_1154_visitIf_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIf(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIf(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIf(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitIf(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitIf(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3168
  setline(3168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1155 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1156 = callmethodflags(self, "visitIf(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1155);
// compiled call node returning call1156 (depth = 2)
  gc_frame_end(frame);
  return call1156;
}
Object meth_ast_1157_visitBlock_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlock(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlock(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlock(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBlock(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitBlock(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3169
  setline(3169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1158 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1159 = callmethodflags(self, "visitBlock(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1158);
// compiled call node returning call1159 (depth = 2)
  gc_frame_end(frame);
  return call1159;
}
Object meth_ast_1160_visitMatchCase_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMatchCase(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMatchCase(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMatchCase(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMatchCase(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMatchCase(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3170
  setline(3170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1161 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1162 = callmethodflags(self, "visitMatchCase(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1161);
// compiled call node returning call1162 (depth = 2)
  gc_frame_end(frame);
  return call1162;
}
Object meth_ast_1163_visitTryCatch_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTryCatch(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTryCatch(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTryCatch(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTryCatch(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTryCatch(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3171
  setline(3171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1164 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1165 = callmethodflags(self, "visitTryCatch(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1164);
// compiled call node returning call1165 (depth = 2)
  gc_frame_end(frame);
  return call1165;
}
Object meth_ast_1166_visitMethodType_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethodType(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethodType(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethodType(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMethodType(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMethodType(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3172
  setline(3172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1167 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1168 = callmethodflags(self, "visitMethodType(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1167);
// compiled call node returning call1168 (depth = 2)
  gc_frame_end(frame);
  return call1168;
}
Object meth_ast_1169_visitSignaturePart_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitSignaturePart(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitSignaturePart(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitSignaturePart(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitSignaturePart(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitSignaturePart(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3173
  setline(3173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1170 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1171 = callmethodflags(self, "visitSignaturePart(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1170);
// compiled call node returning call1171 (depth = 2)
  gc_frame_end(frame);
  return call1171;
}
Object meth_ast_1172_visitTypeDec_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeDec(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeDec(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeDec(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeDec(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTypeDec(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3174
  setline(3174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1173 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1174 = callmethodflags(self, "visitTypeDec(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1173);
// compiled call node returning call1174 (depth = 2)
  gc_frame_end(frame);
  return call1174;
}
Object meth_ast_1175_visitTypeLiteral_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeLiteral(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeLiteral(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeLiteral(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeLiteral(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTypeLiteral(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3175
  setline(3175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1176 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1177 = callmethodflags(self, "visitTypeLiteral(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1176);
// compiled call node returning call1177 (depth = 2)
  gc_frame_end(frame);
  return call1177;
}
Object meth_ast_1178_visitTypeParameters_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeParameters(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeParameters(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeParameters(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeParameters(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTypeParameters(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3176
  setline(3176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1179 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1180 = callmethodflags(self, "visitTypeParameters(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1179);
// compiled call node returning call1180 (depth = 2)
  gc_frame_end(frame);
  return call1180;
}
Object meth_ast_1181_visitMethod_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethod(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethod(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethod(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMethod(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMethod(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3177
  setline(3177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1182 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1183 = callmethodflags(self, "visitMethod(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1182);
// compiled call node returning call1183 (depth = 2)
  gc_frame_end(frame);
  return call1183;
}
Object meth_ast_1184_visitCall_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitCall(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitCall(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3178
  setline(3178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1185 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1186 = callmethodflags(self, "visitCall(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1185);
// compiled call node returning call1186 (depth = 2)
  gc_frame_end(frame);
  return call1186;
}
Object meth_ast_1187_visitObject_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitObject(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitObject(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitObject(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitObject(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitObject(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3179
  setline(3179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1188 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1189 = callmethodflags(self, "visitObject(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1188);
// compiled call node returning call1189 (depth = 2)
  gc_frame_end(frame);
  return call1189;
}
Object meth_ast_1190_visitModule_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitModule(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitModule(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitModule(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitModule(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitModule(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3180
  setline(3180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1191 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1192 = callmethodflags(self, "visitObject(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1191);
// compiled call node returning call1192 (depth = 2)
  gc_frame_end(frame);
  return call1192;
}
Object meth_ast_1193_visitArray_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitArray(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitArray(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitArray(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitArray(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitArray(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3181
  setline(3181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1194 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1195 = callmethodflags(self, "visitArray(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1194);
// compiled call node returning call1195 (depth = 2)
  gc_frame_end(frame);
  return call1195;
}
Object meth_ast_1196_visitMember_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMember(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMember(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMember(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMember(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMember(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3182
  setline(3182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1197 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1198 = callmethodflags(self, "visitMember(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1197);
// compiled call node returning call1198 (depth = 2)
  gc_frame_end(frame);
  return call1198;
}
Object meth_ast_1199_visitGeneric_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitGeneric(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitGeneric(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitGeneric(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitGeneric(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitGeneric(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3183
  setline(3183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1200 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1201 = callmethodflags(self, "visitGeneric(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1200);
// compiled call node returning call1201 (depth = 2)
  gc_frame_end(frame);
  return call1201;
}
Object meth_ast_1202_visitIdentifier_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIdentifier(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIdentifier(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIdentifier(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitIdentifier(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitIdentifier(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3184
  setline(3184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1203 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1204 = callmethodflags(self, "visitIdentifier(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1203);
// compiled call node returning call1204 (depth = 2)
  gc_frame_end(frame);
  return call1204;
}
Object meth_ast_1205_visitString_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitString(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitString(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitString(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitString(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitString(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3185
  setline(3185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1206 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1207 = callmethodflags(self, "visitString(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1206);
// compiled call node returning call1207 (depth = 2)
  gc_frame_end(frame);
  return call1207;
}
Object meth_ast_1208_visitNum_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitNum(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitNum(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitNum(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitNum(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitNum(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3186
  setline(3186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1209 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1210 = callmethodflags(self, "visitNum(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1209);
// compiled call node returning call1210 (depth = 2)
  gc_frame_end(frame);
  return call1210;
}
Object meth_ast_1211_visitOp_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitOp(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOp(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOp(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitOp(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitOp(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3187
  setline(3187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1212 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1213 = callmethodflags(self, "visitOp(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1212);
// compiled call node returning call1213 (depth = 2)
  gc_frame_end(frame);
  return call1213;
}
Object meth_ast_1214_visitBind_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBind(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBind(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBind(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBind(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitBind(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3188
  setline(3188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1215 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1216 = callmethodflags(self, "visitBind(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1215);
// compiled call node returning call1216 (depth = 2)
  gc_frame_end(frame);
  return call1216;
}
Object meth_ast_1217_visitDefDec_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDefDec(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDefDec(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDefDec(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitDefDec(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitDefDec(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3189
  setline(3189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1218 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1219 = callmethodflags(self, "visitDefDec(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1218);
// compiled call node returning call1219 (depth = 2)
  gc_frame_end(frame);
  return call1219;
}
Object meth_ast_1220_visitVarDec_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitVarDec(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitVarDec(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitVarDec(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitVarDec(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitVarDec(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3190
  setline(3190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1221 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1222 = callmethodflags(self, "visitVarDec(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1221);
// compiled call node returning call1222 (depth = 2)
  gc_frame_end(frame);
  return call1222;
}
Object meth_ast_1223_visitImport_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitImport(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImport(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImport(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitImport(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitImport(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3191
  setline(3191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1224 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1225 = callmethodflags(self, "visitImport(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1224);
// compiled call node returning call1225 (depth = 2)
  gc_frame_end(frame);
  return call1225;
}
Object meth_ast_1226_visitReturn_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitReturn(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitReturn(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitReturn(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitReturn(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitReturn(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3192
  setline(3192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1227 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1228 = callmethodflags(self, "visitReturn(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1227);
// compiled call node returning call1228 (depth = 2)
  gc_frame_end(frame);
  return call1228;
}
Object meth_ast_1229_visitInherits_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitInherits(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitInherits(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitInherits(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitInherits(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitInherits(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3193
  setline(3193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1230 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1231 = callmethodflags(self, "visitInherits(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1230);
// compiled call node returning call1231 (depth = 2)
  gc_frame_end(frame);
  return call1231;
}
Object meth_ast_1232_visitDialect_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDialect(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDialect(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDialect(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitDialect(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitDialect(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3194
  setline(3194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1233 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1234 = callmethodflags(self, "visitDialect(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1233);
// compiled call node returning call1234 (depth = 2)
  gc_frame_end(frame);
  return call1234;
}
Object meth_ast_1235_visitComment_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitComment(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitComment(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitComment(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitComment(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitComment(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3195
  setline(3195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1236 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1237 = callmethodflags(self, "visitComment(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1236);
// compiled call node returning call1237 (depth = 2)
  gc_frame_end(frame);
  return call1237;
}
Object meth_ast_1238_visitImplicit_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitImplicit(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImplicit(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImplicit(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitImplicit(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitImplicit(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3196
  setline(3196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1239 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1240 = callmethodflags(self, "visitImplicit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1239);
// compiled call node returning call1240 (depth = 2)
  gc_frame_end(frame);
  return call1240;
}
Object meth_ast_1241_visitOuter_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitOuter(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOuter(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOuter(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitOuter(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitOuter(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3197
  setline(3197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1242 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1243 = callmethodflags(self, "visitOuter(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1242);
// compiled call node returning call1243 (depth = 2)
  gc_frame_end(frame);
  return call1243;
}
Object meth_ast_1244_visitIf_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIf(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIf(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitIf(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitIf(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3199
  setline(3199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1245 = alloc_Boolean(1);
// compiled identifier node returning bool1245 (depth = 2)
  gc_frame_end(frame);
  return bool1245;
}
Object meth_ast_1246_visitBlock_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlock(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlock(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitBlock(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitBlock(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3200
  setline(3200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1247 = alloc_Boolean(1);
// compiled identifier node returning bool1247 (depth = 2)
  gc_frame_end(frame);
  return bool1247;
}
Object meth_ast_1248_visitMatchCase_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMatchCase(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMatchCase(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitMatchCase(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMatchCase(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3201
  setline(3201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1249 = alloc_Boolean(1);
// compiled identifier node returning bool1249 (depth = 2)
  gc_frame_end(frame);
  return bool1249;
}
Object meth_ast_1250_visitTryCatch_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTryCatch(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTryCatch(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitTryCatch(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTryCatch(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3202
  setline(3202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1251 = alloc_Boolean(1);
// compiled identifier node returning bool1251 (depth = 2)
  gc_frame_end(frame);
  return bool1251;
}
Object meth_ast_1252_visitMethodType_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethodType(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethodType(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitMethodType(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMethodType(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3203
  setline(3203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1253 = alloc_Boolean(1);
// compiled identifier node returning bool1253 (depth = 2)
  gc_frame_end(frame);
  return bool1253;
}
Object meth_ast_1254_visitSignaturePart_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitSignaturePart(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitSignaturePart(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitSignaturePart(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitSignaturePart(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3204
  setline(3204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1255 = alloc_Boolean(1);
// compiled identifier node returning bool1255 (depth = 2)
  gc_frame_end(frame);
  return bool1255;
}
Object meth_ast_1256_visitTypeDec_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeDec(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeDec(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeDec(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTypeDec(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3205
  setline(3205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1257 = alloc_Boolean(1);
// compiled identifier node returning bool1257 (depth = 2)
  gc_frame_end(frame);
  return bool1257;
}
Object meth_ast_1258_visitTypeLiteral_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeLiteral(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeLiteral(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeLiteral(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTypeLiteral(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3206
  setline(3206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1259 = alloc_Boolean(1);
// compiled identifier node returning bool1259 (depth = 2)
  gc_frame_end(frame);
  return bool1259;
}
Object meth_ast_1260_visitTypeParameters_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeParameters(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeParameters(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeParameters(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTypeParameters(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3207
  setline(3207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1261 = alloc_Boolean(1);
// compiled identifier node returning bool1261 (depth = 2)
  gc_frame_end(frame);
  return bool1261;
}
Object meth_ast_1262_visitMethod_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethod(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethod(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitMethod(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMethod(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1263 = alloc_Boolean(1);
// compiled identifier node returning bool1263 (depth = 2)
  gc_frame_end(frame);
  return bool1263;
}
Object meth_ast_1264_visitCall_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitCall(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitCall(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3209
  setline(3209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1265 = alloc_Boolean(1);
// compiled identifier node returning bool1265 (depth = 2)
  gc_frame_end(frame);
  return bool1265;
}
Object meth_ast_1266_visitObject_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitObject(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitObject(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitObject(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitObject(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3210
  setline(3210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1267 = alloc_Boolean(1);
// compiled identifier node returning bool1267 (depth = 2)
  gc_frame_end(frame);
  return bool1267;
}
Object meth_ast_1268_visitModule_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitModule(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitModule(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitModule(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitModule(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3211
  setline(3211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1269 = alloc_Boolean(1);
// compiled identifier node returning bool1269 (depth = 2)
  gc_frame_end(frame);
  return bool1269;
}
Object meth_ast_1270_visitArray_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitArray(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitArray(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitArray(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitArray(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3212
  setline(3212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1271 = alloc_Boolean(1);
// compiled identifier node returning bool1271 (depth = 2)
  gc_frame_end(frame);
  return bool1271;
}
Object meth_ast_1272_visitMember_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMember(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMember(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitMember(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMember(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3213
  setline(3213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1273 = alloc_Boolean(1);
// compiled identifier node returning bool1273 (depth = 2)
  gc_frame_end(frame);
  return bool1273;
}
Object meth_ast_1274_visitGeneric_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitGeneric(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitGeneric(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitGeneric(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitGeneric(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3214
  setline(3214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1275 = alloc_Boolean(1);
// compiled identifier node returning bool1275 (depth = 2)
  gc_frame_end(frame);
  return bool1275;
}
Object meth_ast_1276_visitIdentifier_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIdentifier(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIdentifier(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitIdentifier(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitIdentifier(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3215
  setline(3215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1277 = alloc_Boolean(1);
// compiled identifier node returning bool1277 (depth = 2)
  gc_frame_end(frame);
  return bool1277;
}
Object meth_ast_1278_visitString_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitString(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitString(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitString(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitString(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3216
  setline(3216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1279 = alloc_Boolean(1);
// compiled identifier node returning bool1279 (depth = 2)
  gc_frame_end(frame);
  return bool1279;
}
Object meth_ast_1280_visitNum_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitNum(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitNum(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitNum(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitNum(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3217
  setline(3217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1281 = alloc_Boolean(1);
// compiled identifier node returning bool1281 (depth = 2)
  gc_frame_end(frame);
  return bool1281;
}
Object meth_ast_1282_visitOp_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitOp(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOp(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitOp(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitOp(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3218
  setline(3218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1283 = alloc_Boolean(1);
// compiled identifier node returning bool1283 (depth = 2)
  gc_frame_end(frame);
  return bool1283;
}
Object meth_ast_1284_visitBind_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBind(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBind(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitBind(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitBind(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3219
  setline(3219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1285 = alloc_Boolean(1);
// compiled identifier node returning bool1285 (depth = 2)
  gc_frame_end(frame);
  return bool1285;
}
Object meth_ast_1286_visitDefDec_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDefDec(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDefDec(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitDefDec(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitDefDec(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3220
  setline(3220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1287 = alloc_Boolean(1);
// compiled identifier node returning bool1287 (depth = 2)
  gc_frame_end(frame);
  return bool1287;
}
Object meth_ast_1288_visitVarDec_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitVarDec(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitVarDec(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitVarDec(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitVarDec(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3221
  setline(3221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1289 = alloc_Boolean(1);
// compiled identifier node returning bool1289 (depth = 2)
  gc_frame_end(frame);
  return bool1289;
}
Object meth_ast_1290_visitImport_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitImport(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImport(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitImport(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitImport(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3222
  setline(3222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1291 = alloc_Boolean(1);
// compiled identifier node returning bool1291 (depth = 2)
  gc_frame_end(frame);
  return bool1291;
}
Object meth_ast_1292_visitReturn_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitReturn(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitReturn(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitReturn(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitReturn(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3223
  setline(3223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1293 = alloc_Boolean(1);
// compiled identifier node returning bool1293 (depth = 2)
  gc_frame_end(frame);
  return bool1293;
}
Object meth_ast_1294_visitInherits_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitInherits(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitInherits(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitInherits(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitInherits(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3224
  setline(3224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1295 = alloc_Boolean(1);
// compiled identifier node returning bool1295 (depth = 2)
  gc_frame_end(frame);
  return bool1295;
}
Object meth_ast_1296_visitDialect_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDialect(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDialect(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitDialect(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitDialect(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3225
  setline(3225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1297 = alloc_Boolean(1);
// compiled identifier node returning bool1297 (depth = 2)
  gc_frame_end(frame);
  return bool1297;
}
Object meth_ast_1298_visitComment_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitComment(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitComment(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitComment(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitComment(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3226
  setline(3226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1299 = alloc_Boolean(1);
// compiled identifier node returning bool1299 (depth = 2)
  gc_frame_end(frame);
  return bool1299;
}
Object meth_ast_1300_visitImplicit_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitImplicit(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImplicit(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitImplicit(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitImplicit(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3227
  setline(3227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1301 = alloc_Boolean(1);
// compiled identifier node returning bool1301 (depth = 2)
  gc_frame_end(frame);
  return bool1301;
}
Object meth_ast_1302_visitOuter_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitOuter(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOuter(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitOuter(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitOuter(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3228
  setline(3228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1303 = alloc_Boolean(1);
// compiled identifier node returning bool1303 (depth = 2)
  gc_frame_end(frame);
  return bool1303;
}
Object meth_ast_1304_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3230
  setline(3230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit1305 == NULL) {
    strlit1305 = alloc_String("an AST visitor");
    gc_root(strlit1305);
  }
// compiled string node returning strlit1305 (depth = 2)
  gc_frame_end(frame);
  return strlit1305;
}
Object meth_ast_1151_baseVisitor(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "baseVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1152 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1152 = alloc_userobj2(61,62, objclass1152);
  gc_frame_newslot(obj1152);
  if (objclass1152 == NULL) {
    glfree(obj1152->class->name);
    obj1152->class->name = "baseVisitor";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj1152, self, 0);
  addmethodreal(obj1152,"outer", &reader_ast_outer_1153);
  Object oldself1152 = self;
  struct StackFrameObject *oldstackframe1152 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1152);
  gc_frame_newslot((Object)stackframe);
  self = obj1152;
  Object *oldselfslot1152 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1152 = (*(struct UserObject *)self).data[0], lowerouter1152 = thisouter1152;
  if (inheritingObject1152) {
    struct UserObject *inho1152 = (struct UserObject *)inheritingObject1152;
    while (inho1152->super != GraceDefaultObject) inho1152 = (struct UserObject *)inho1152->super;
    inho1152->super = obj1152;
    self = inheritingObject1152;
    *selfslot = self;
    lowerouter1152 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1152;
  }
// method "visitIf(_)up(_)"
  struct UserObject *uo1154 = (struct UserObject*)obj1152;
  uo1154->data[1] = emptyclosure;
  Method *meth_meth_ast_1154_visitIf_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitIf(1)up(1)", &meth_ast_1154_visitIf_40_1_41_up_40_1_41_, 1);
  int argcv_meth_ast_1154_visitIf_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1154_visitIf_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1154_visitIf_40_1_41_up_40_1_41_);
  meth_meth_ast_1154_visitIf_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1154_visitIf_40_1_41_up_40_1_41_->definitionLine = 3168;
// method "visitBlock(_)up(_)"
  struct UserObject *uo1157 = (struct UserObject*)obj1152;
  uo1157->data[2] = emptyclosure;
  Method *meth_meth_ast_1157_visitBlock_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitBlock(1)up(1)", &meth_ast_1157_visitBlock_40_1_41_up_40_1_41_, 2);
  int argcv_meth_ast_1157_visitBlock_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1157_visitBlock_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1157_visitBlock_40_1_41_up_40_1_41_);
  meth_meth_ast_1157_visitBlock_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1157_visitBlock_40_1_41_up_40_1_41_->definitionLine = 3169;
// method "visitMatchCase(_)up(_)"
  struct UserObject *uo1160 = (struct UserObject*)obj1152;
  uo1160->data[3] = emptyclosure;
  Method *meth_meth_ast_1160_visitMatchCase_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitMatchCase(1)up(1)", &meth_ast_1160_visitMatchCase_40_1_41_up_40_1_41_, 3);
  int argcv_meth_ast_1160_visitMatchCase_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1160_visitMatchCase_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1160_visitMatchCase_40_1_41_up_40_1_41_);
  meth_meth_ast_1160_visitMatchCase_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1160_visitMatchCase_40_1_41_up_40_1_41_->definitionLine = 3170;
// method "visitTryCatch(_)up(_)"
  struct UserObject *uo1163 = (struct UserObject*)obj1152;
  uo1163->data[4] = emptyclosure;
  Method *meth_meth_ast_1163_visitTryCatch_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitTryCatch(1)up(1)", &meth_ast_1163_visitTryCatch_40_1_41_up_40_1_41_, 4);
  int argcv_meth_ast_1163_visitTryCatch_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1163_visitTryCatch_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1163_visitTryCatch_40_1_41_up_40_1_41_);
  meth_meth_ast_1163_visitTryCatch_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1163_visitTryCatch_40_1_41_up_40_1_41_->definitionLine = 3171;
// method "visitMethodType(_)up(_)"
  struct UserObject *uo1166 = (struct UserObject*)obj1152;
  uo1166->data[5] = emptyclosure;
  Method *meth_meth_ast_1166_visitMethodType_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitMethodType(1)up(1)", &meth_ast_1166_visitMethodType_40_1_41_up_40_1_41_, 5);
  int argcv_meth_ast_1166_visitMethodType_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1166_visitMethodType_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1166_visitMethodType_40_1_41_up_40_1_41_);
  meth_meth_ast_1166_visitMethodType_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1166_visitMethodType_40_1_41_up_40_1_41_->definitionLine = 3172;
// method "visitSignaturePart(_)up(_)"
  struct UserObject *uo1169 = (struct UserObject*)obj1152;
  uo1169->data[6] = emptyclosure;
  Method *meth_meth_ast_1169_visitSignaturePart_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitSignaturePart(1)up(1)", &meth_ast_1169_visitSignaturePart_40_1_41_up_40_1_41_, 6);
  int argcv_meth_ast_1169_visitSignaturePart_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1169_visitSignaturePart_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1169_visitSignaturePart_40_1_41_up_40_1_41_);
  meth_meth_ast_1169_visitSignaturePart_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1169_visitSignaturePart_40_1_41_up_40_1_41_->definitionLine = 3173;
// method "visitTypeDec(_)up(_)"
  struct UserObject *uo1172 = (struct UserObject*)obj1152;
  uo1172->data[7] = emptyclosure;
  Method *meth_meth_ast_1172_visitTypeDec_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitTypeDec(1)up(1)", &meth_ast_1172_visitTypeDec_40_1_41_up_40_1_41_, 7);
  int argcv_meth_ast_1172_visitTypeDec_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1172_visitTypeDec_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1172_visitTypeDec_40_1_41_up_40_1_41_);
  meth_meth_ast_1172_visitTypeDec_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1172_visitTypeDec_40_1_41_up_40_1_41_->definitionLine = 3174;
// method "visitTypeLiteral(_)up(_)"
  struct UserObject *uo1175 = (struct UserObject*)obj1152;
  uo1175->data[8] = emptyclosure;
  Method *meth_meth_ast_1175_visitTypeLiteral_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitTypeLiteral(1)up(1)", &meth_ast_1175_visitTypeLiteral_40_1_41_up_40_1_41_, 8);
  int argcv_meth_ast_1175_visitTypeLiteral_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1175_visitTypeLiteral_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1175_visitTypeLiteral_40_1_41_up_40_1_41_);
  meth_meth_ast_1175_visitTypeLiteral_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1175_visitTypeLiteral_40_1_41_up_40_1_41_->definitionLine = 3175;
// method "visitTypeParameters(_)up(_)"
  struct UserObject *uo1178 = (struct UserObject*)obj1152;
  uo1178->data[9] = emptyclosure;
  Method *meth_meth_ast_1178_visitTypeParameters_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitTypeParameters(1)up(1)", &meth_ast_1178_visitTypeParameters_40_1_41_up_40_1_41_, 9);
  int argcv_meth_ast_1178_visitTypeParameters_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1178_visitTypeParameters_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1178_visitTypeParameters_40_1_41_up_40_1_41_);
  meth_meth_ast_1178_visitTypeParameters_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1178_visitTypeParameters_40_1_41_up_40_1_41_->definitionLine = 3176;
// method "visitMethod(_)up(_)"
  struct UserObject *uo1181 = (struct UserObject*)obj1152;
  uo1181->data[10] = emptyclosure;
  Method *meth_meth_ast_1181_visitMethod_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitMethod(1)up(1)", &meth_ast_1181_visitMethod_40_1_41_up_40_1_41_, 10);
  int argcv_meth_ast_1181_visitMethod_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1181_visitMethod_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1181_visitMethod_40_1_41_up_40_1_41_);
  meth_meth_ast_1181_visitMethod_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1181_visitMethod_40_1_41_up_40_1_41_->definitionLine = 3177;
// method "visitCall(_)up(_)"
  struct UserObject *uo1184 = (struct UserObject*)obj1152;
  uo1184->data[11] = emptyclosure;
  Method *meth_meth_ast_1184_visitCall_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitCall(1)up(1)", &meth_ast_1184_visitCall_40_1_41_up_40_1_41_, 11);
  int argcv_meth_ast_1184_visitCall_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1184_visitCall_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1184_visitCall_40_1_41_up_40_1_41_);
  meth_meth_ast_1184_visitCall_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1184_visitCall_40_1_41_up_40_1_41_->definitionLine = 3178;
// method "visitObject(_)up(_)"
  struct UserObject *uo1187 = (struct UserObject*)obj1152;
  uo1187->data[12] = emptyclosure;
  Method *meth_meth_ast_1187_visitObject_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitObject(1)up(1)", &meth_ast_1187_visitObject_40_1_41_up_40_1_41_, 12);
  int argcv_meth_ast_1187_visitObject_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1187_visitObject_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1187_visitObject_40_1_41_up_40_1_41_);
  meth_meth_ast_1187_visitObject_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1187_visitObject_40_1_41_up_40_1_41_->definitionLine = 3179;
// method "visitModule(_)up(_)"
  struct UserObject *uo1190 = (struct UserObject*)obj1152;
  uo1190->data[13] = emptyclosure;
  Method *meth_meth_ast_1190_visitModule_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitModule(1)up(1)", &meth_ast_1190_visitModule_40_1_41_up_40_1_41_, 13);
  int argcv_meth_ast_1190_visitModule_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1190_visitModule_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1190_visitModule_40_1_41_up_40_1_41_);
  meth_meth_ast_1190_visitModule_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1190_visitModule_40_1_41_up_40_1_41_->definitionLine = 3180;
// method "visitArray(_)up(_)"
  struct UserObject *uo1193 = (struct UserObject*)obj1152;
  uo1193->data[14] = emptyclosure;
  Method *meth_meth_ast_1193_visitArray_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitArray(1)up(1)", &meth_ast_1193_visitArray_40_1_41_up_40_1_41_, 14);
  int argcv_meth_ast_1193_visitArray_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1193_visitArray_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1193_visitArray_40_1_41_up_40_1_41_);
  meth_meth_ast_1193_visitArray_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1193_visitArray_40_1_41_up_40_1_41_->definitionLine = 3181;
// method "visitMember(_)up(_)"
  struct UserObject *uo1196 = (struct UserObject*)obj1152;
  uo1196->data[15] = emptyclosure;
  Method *meth_meth_ast_1196_visitMember_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitMember(1)up(1)", &meth_ast_1196_visitMember_40_1_41_up_40_1_41_, 15);
  int argcv_meth_ast_1196_visitMember_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1196_visitMember_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1196_visitMember_40_1_41_up_40_1_41_);
  meth_meth_ast_1196_visitMember_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1196_visitMember_40_1_41_up_40_1_41_->definitionLine = 3182;
// method "visitGeneric(_)up(_)"
  struct UserObject *uo1199 = (struct UserObject*)obj1152;
  uo1199->data[16] = emptyclosure;
  Method *meth_meth_ast_1199_visitGeneric_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitGeneric(1)up(1)", &meth_ast_1199_visitGeneric_40_1_41_up_40_1_41_, 16);
  int argcv_meth_ast_1199_visitGeneric_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1199_visitGeneric_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1199_visitGeneric_40_1_41_up_40_1_41_);
  meth_meth_ast_1199_visitGeneric_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1199_visitGeneric_40_1_41_up_40_1_41_->definitionLine = 3183;
// method "visitIdentifier(_)up(_)"
  struct UserObject *uo1202 = (struct UserObject*)obj1152;
  uo1202->data[17] = emptyclosure;
  Method *meth_meth_ast_1202_visitIdentifier_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitIdentifier(1)up(1)", &meth_ast_1202_visitIdentifier_40_1_41_up_40_1_41_, 17);
  int argcv_meth_ast_1202_visitIdentifier_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1202_visitIdentifier_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1202_visitIdentifier_40_1_41_up_40_1_41_);
  meth_meth_ast_1202_visitIdentifier_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1202_visitIdentifier_40_1_41_up_40_1_41_->definitionLine = 3184;
// method "visitString(_)up(_)"
  struct UserObject *uo1205 = (struct UserObject*)obj1152;
  uo1205->data[18] = emptyclosure;
  Method *meth_meth_ast_1205_visitString_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitString(1)up(1)", &meth_ast_1205_visitString_40_1_41_up_40_1_41_, 18);
  int argcv_meth_ast_1205_visitString_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1205_visitString_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1205_visitString_40_1_41_up_40_1_41_);
  meth_meth_ast_1205_visitString_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1205_visitString_40_1_41_up_40_1_41_->definitionLine = 3185;
// method "visitNum(_)up(_)"
  struct UserObject *uo1208 = (struct UserObject*)obj1152;
  uo1208->data[19] = emptyclosure;
  Method *meth_meth_ast_1208_visitNum_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitNum(1)up(1)", &meth_ast_1208_visitNum_40_1_41_up_40_1_41_, 19);
  int argcv_meth_ast_1208_visitNum_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1208_visitNum_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1208_visitNum_40_1_41_up_40_1_41_);
  meth_meth_ast_1208_visitNum_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1208_visitNum_40_1_41_up_40_1_41_->definitionLine = 3186;
// method "visitOp(_)up(_)"
  struct UserObject *uo1211 = (struct UserObject*)obj1152;
  uo1211->data[20] = emptyclosure;
  Method *meth_meth_ast_1211_visitOp_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitOp(1)up(1)", &meth_ast_1211_visitOp_40_1_41_up_40_1_41_, 20);
  int argcv_meth_ast_1211_visitOp_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1211_visitOp_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1211_visitOp_40_1_41_up_40_1_41_);
  meth_meth_ast_1211_visitOp_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1211_visitOp_40_1_41_up_40_1_41_->definitionLine = 3187;
// method "visitBind(_)up(_)"
  struct UserObject *uo1214 = (struct UserObject*)obj1152;
  uo1214->data[21] = emptyclosure;
  Method *meth_meth_ast_1214_visitBind_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitBind(1)up(1)", &meth_ast_1214_visitBind_40_1_41_up_40_1_41_, 21);
  int argcv_meth_ast_1214_visitBind_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1214_visitBind_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1214_visitBind_40_1_41_up_40_1_41_);
  meth_meth_ast_1214_visitBind_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1214_visitBind_40_1_41_up_40_1_41_->definitionLine = 3188;
// method "visitDefDec(_)up(_)"
  struct UserObject *uo1217 = (struct UserObject*)obj1152;
  uo1217->data[22] = emptyclosure;
  Method *meth_meth_ast_1217_visitDefDec_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitDefDec(1)up(1)", &meth_ast_1217_visitDefDec_40_1_41_up_40_1_41_, 22);
  int argcv_meth_ast_1217_visitDefDec_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1217_visitDefDec_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1217_visitDefDec_40_1_41_up_40_1_41_);
  meth_meth_ast_1217_visitDefDec_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1217_visitDefDec_40_1_41_up_40_1_41_->definitionLine = 3189;
// method "visitVarDec(_)up(_)"
  struct UserObject *uo1220 = (struct UserObject*)obj1152;
  uo1220->data[23] = emptyclosure;
  Method *meth_meth_ast_1220_visitVarDec_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitVarDec(1)up(1)", &meth_ast_1220_visitVarDec_40_1_41_up_40_1_41_, 23);
  int argcv_meth_ast_1220_visitVarDec_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1220_visitVarDec_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1220_visitVarDec_40_1_41_up_40_1_41_);
  meth_meth_ast_1220_visitVarDec_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1220_visitVarDec_40_1_41_up_40_1_41_->definitionLine = 3190;
// method "visitImport(_)up(_)"
  struct UserObject *uo1223 = (struct UserObject*)obj1152;
  uo1223->data[24] = emptyclosure;
  Method *meth_meth_ast_1223_visitImport_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitImport(1)up(1)", &meth_ast_1223_visitImport_40_1_41_up_40_1_41_, 24);
  int argcv_meth_ast_1223_visitImport_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1223_visitImport_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1223_visitImport_40_1_41_up_40_1_41_);
  meth_meth_ast_1223_visitImport_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1223_visitImport_40_1_41_up_40_1_41_->definitionLine = 3191;
// method "visitReturn(_)up(_)"
  struct UserObject *uo1226 = (struct UserObject*)obj1152;
  uo1226->data[25] = emptyclosure;
  Method *meth_meth_ast_1226_visitReturn_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitReturn(1)up(1)", &meth_ast_1226_visitReturn_40_1_41_up_40_1_41_, 25);
  int argcv_meth_ast_1226_visitReturn_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1226_visitReturn_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1226_visitReturn_40_1_41_up_40_1_41_);
  meth_meth_ast_1226_visitReturn_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1226_visitReturn_40_1_41_up_40_1_41_->definitionLine = 3192;
// method "visitInherits(_)up(_)"
  struct UserObject *uo1229 = (struct UserObject*)obj1152;
  uo1229->data[26] = emptyclosure;
  Method *meth_meth_ast_1229_visitInherits_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitInherits(1)up(1)", &meth_ast_1229_visitInherits_40_1_41_up_40_1_41_, 26);
  int argcv_meth_ast_1229_visitInherits_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1229_visitInherits_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1229_visitInherits_40_1_41_up_40_1_41_);
  meth_meth_ast_1229_visitInherits_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1229_visitInherits_40_1_41_up_40_1_41_->definitionLine = 3193;
// method "visitDialect(_)up(_)"
  struct UserObject *uo1232 = (struct UserObject*)obj1152;
  uo1232->data[27] = emptyclosure;
  Method *meth_meth_ast_1232_visitDialect_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitDialect(1)up(1)", &meth_ast_1232_visitDialect_40_1_41_up_40_1_41_, 27);
  int argcv_meth_ast_1232_visitDialect_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1232_visitDialect_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1232_visitDialect_40_1_41_up_40_1_41_);
  meth_meth_ast_1232_visitDialect_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1232_visitDialect_40_1_41_up_40_1_41_->definitionLine = 3194;
// method "visitComment(_)up(_)"
  struct UserObject *uo1235 = (struct UserObject*)obj1152;
  uo1235->data[28] = emptyclosure;
  Method *meth_meth_ast_1235_visitComment_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitComment(1)up(1)", &meth_ast_1235_visitComment_40_1_41_up_40_1_41_, 28);
  int argcv_meth_ast_1235_visitComment_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1235_visitComment_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1235_visitComment_40_1_41_up_40_1_41_);
  meth_meth_ast_1235_visitComment_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1235_visitComment_40_1_41_up_40_1_41_->definitionLine = 3195;
// method "visitImplicit(_)up(_)"
  struct UserObject *uo1238 = (struct UserObject*)obj1152;
  uo1238->data[29] = emptyclosure;
  Method *meth_meth_ast_1238_visitImplicit_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitImplicit(1)up(1)", &meth_ast_1238_visitImplicit_40_1_41_up_40_1_41_, 29);
  int argcv_meth_ast_1238_visitImplicit_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1238_visitImplicit_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1238_visitImplicit_40_1_41_up_40_1_41_);
  meth_meth_ast_1238_visitImplicit_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1238_visitImplicit_40_1_41_up_40_1_41_->definitionLine = 3196;
// method "visitOuter(_)up(_)"
  struct UserObject *uo1241 = (struct UserObject*)obj1152;
  uo1241->data[30] = emptyclosure;
  Method *meth_meth_ast_1241_visitOuter_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitOuter(1)up(1)", &meth_ast_1241_visitOuter_40_1_41_up_40_1_41_, 30);
  int argcv_meth_ast_1241_visitOuter_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1241_visitOuter_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1241_visitOuter_40_1_41_up_40_1_41_);
  meth_meth_ast_1241_visitOuter_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1241_visitOuter_40_1_41_up_40_1_41_->definitionLine = 3197;
// method "visitIf(_)"
  struct UserObject *uo1244 = (struct UserObject*)obj1152;
  uo1244->data[31] = emptyclosure;
  Method *meth_meth_ast_1244_visitIf_40_1_41_ = addmethod2pos(obj1152, "visitIf(1)", &meth_ast_1244_visitIf_40_1_41_, 31);
  int argcv_meth_ast_1244_visitIf_40_1_41_[] = {1};
  meth_meth_ast_1244_visitIf_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1244_visitIf_40_1_41_);
  meth_meth_ast_1244_visitIf_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1244_visitIf_40_1_41_->definitionLine = 3199;
// method "visitBlock(_)"
  struct UserObject *uo1246 = (struct UserObject*)obj1152;
  uo1246->data[32] = emptyclosure;
  Method *meth_meth_ast_1246_visitBlock_40_1_41_ = addmethod2pos(obj1152, "visitBlock(1)", &meth_ast_1246_visitBlock_40_1_41_, 32);
  int argcv_meth_ast_1246_visitBlock_40_1_41_[] = {1};
  meth_meth_ast_1246_visitBlock_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1246_visitBlock_40_1_41_);
  meth_meth_ast_1246_visitBlock_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1246_visitBlock_40_1_41_->definitionLine = 3200;
// method "visitMatchCase(_)"
  struct UserObject *uo1248 = (struct UserObject*)obj1152;
  uo1248->data[33] = emptyclosure;
  Method *meth_meth_ast_1248_visitMatchCase_40_1_41_ = addmethod2pos(obj1152, "visitMatchCase(1)", &meth_ast_1248_visitMatchCase_40_1_41_, 33);
  int argcv_meth_ast_1248_visitMatchCase_40_1_41_[] = {1};
  meth_meth_ast_1248_visitMatchCase_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1248_visitMatchCase_40_1_41_);
  meth_meth_ast_1248_visitMatchCase_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1248_visitMatchCase_40_1_41_->definitionLine = 3201;
// method "visitTryCatch(_)"
  struct UserObject *uo1250 = (struct UserObject*)obj1152;
  uo1250->data[34] = emptyclosure;
  Method *meth_meth_ast_1250_visitTryCatch_40_1_41_ = addmethod2pos(obj1152, "visitTryCatch(1)", &meth_ast_1250_visitTryCatch_40_1_41_, 34);
  int argcv_meth_ast_1250_visitTryCatch_40_1_41_[] = {1};
  meth_meth_ast_1250_visitTryCatch_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1250_visitTryCatch_40_1_41_);
  meth_meth_ast_1250_visitTryCatch_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1250_visitTryCatch_40_1_41_->definitionLine = 3202;
// method "visitMethodType(_)"
  struct UserObject *uo1252 = (struct UserObject*)obj1152;
  uo1252->data[35] = emptyclosure;
  Method *meth_meth_ast_1252_visitMethodType_40_1_41_ = addmethod2pos(obj1152, "visitMethodType(1)", &meth_ast_1252_visitMethodType_40_1_41_, 35);
  int argcv_meth_ast_1252_visitMethodType_40_1_41_[] = {1};
  meth_meth_ast_1252_visitMethodType_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1252_visitMethodType_40_1_41_);
  meth_meth_ast_1252_visitMethodType_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1252_visitMethodType_40_1_41_->definitionLine = 3203;
// method "visitSignaturePart(_)"
  struct UserObject *uo1254 = (struct UserObject*)obj1152;
  uo1254->data[36] = emptyclosure;
  Method *meth_meth_ast_1254_visitSignaturePart_40_1_41_ = addmethod2pos(obj1152, "visitSignaturePart(1)", &meth_ast_1254_visitSignaturePart_40_1_41_, 36);
  int argcv_meth_ast_1254_visitSignaturePart_40_1_41_[] = {1};
  meth_meth_ast_1254_visitSignaturePart_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1254_visitSignaturePart_40_1_41_);
  meth_meth_ast_1254_visitSignaturePart_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1254_visitSignaturePart_40_1_41_->definitionLine = 3204;
// method "visitTypeDec(_)"
  struct UserObject *uo1256 = (struct UserObject*)obj1152;
  uo1256->data[37] = emptyclosure;
  Method *meth_meth_ast_1256_visitTypeDec_40_1_41_ = addmethod2pos(obj1152, "visitTypeDec(1)", &meth_ast_1256_visitTypeDec_40_1_41_, 37);
  int argcv_meth_ast_1256_visitTypeDec_40_1_41_[] = {1};
  meth_meth_ast_1256_visitTypeDec_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1256_visitTypeDec_40_1_41_);
  meth_meth_ast_1256_visitTypeDec_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1256_visitTypeDec_40_1_41_->definitionLine = 3205;
// method "visitTypeLiteral(_)"
  struct UserObject *uo1258 = (struct UserObject*)obj1152;
  uo1258->data[38] = emptyclosure;
  Method *meth_meth_ast_1258_visitTypeLiteral_40_1_41_ = addmethod2pos(obj1152, "visitTypeLiteral(1)", &meth_ast_1258_visitTypeLiteral_40_1_41_, 38);
  int argcv_meth_ast_1258_visitTypeLiteral_40_1_41_[] = {1};
  meth_meth_ast_1258_visitTypeLiteral_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1258_visitTypeLiteral_40_1_41_);
  meth_meth_ast_1258_visitTypeLiteral_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1258_visitTypeLiteral_40_1_41_->definitionLine = 3206;
// method "visitTypeParameters(_)"
  struct UserObject *uo1260 = (struct UserObject*)obj1152;
  uo1260->data[39] = emptyclosure;
  Method *meth_meth_ast_1260_visitTypeParameters_40_1_41_ = addmethod2pos(obj1152, "visitTypeParameters(1)", &meth_ast_1260_visitTypeParameters_40_1_41_, 39);
  int argcv_meth_ast_1260_visitTypeParameters_40_1_41_[] = {1};
  meth_meth_ast_1260_visitTypeParameters_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1260_visitTypeParameters_40_1_41_);
  meth_meth_ast_1260_visitTypeParameters_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1260_visitTypeParameters_40_1_41_->definitionLine = 3207;
// method "visitMethod(_)"
  struct UserObject *uo1262 = (struct UserObject*)obj1152;
  uo1262->data[40] = emptyclosure;
  Method *meth_meth_ast_1262_visitMethod_40_1_41_ = addmethod2pos(obj1152, "visitMethod(1)", &meth_ast_1262_visitMethod_40_1_41_, 40);
  int argcv_meth_ast_1262_visitMethod_40_1_41_[] = {1};
  meth_meth_ast_1262_visitMethod_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1262_visitMethod_40_1_41_);
  meth_meth_ast_1262_visitMethod_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1262_visitMethod_40_1_41_->definitionLine = 3208;
// method "visitCall(_)"
  struct UserObject *uo1264 = (struct UserObject*)obj1152;
  uo1264->data[41] = emptyclosure;
  Method *meth_meth_ast_1264_visitCall_40_1_41_ = addmethod2pos(obj1152, "visitCall(1)", &meth_ast_1264_visitCall_40_1_41_, 41);
  int argcv_meth_ast_1264_visitCall_40_1_41_[] = {1};
  meth_meth_ast_1264_visitCall_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1264_visitCall_40_1_41_);
  meth_meth_ast_1264_visitCall_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1264_visitCall_40_1_41_->definitionLine = 3209;
// method "visitObject(_)"
  struct UserObject *uo1266 = (struct UserObject*)obj1152;
  uo1266->data[42] = emptyclosure;
  Method *meth_meth_ast_1266_visitObject_40_1_41_ = addmethod2pos(obj1152, "visitObject(1)", &meth_ast_1266_visitObject_40_1_41_, 42);
  int argcv_meth_ast_1266_visitObject_40_1_41_[] = {1};
  meth_meth_ast_1266_visitObject_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1266_visitObject_40_1_41_);
  meth_meth_ast_1266_visitObject_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1266_visitObject_40_1_41_->definitionLine = 3210;
// method "visitModule(_)"
  struct UserObject *uo1268 = (struct UserObject*)obj1152;
  uo1268->data[43] = emptyclosure;
  Method *meth_meth_ast_1268_visitModule_40_1_41_ = addmethod2pos(obj1152, "visitModule(1)", &meth_ast_1268_visitModule_40_1_41_, 43);
  int argcv_meth_ast_1268_visitModule_40_1_41_[] = {1};
  meth_meth_ast_1268_visitModule_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1268_visitModule_40_1_41_);
  meth_meth_ast_1268_visitModule_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1268_visitModule_40_1_41_->definitionLine = 3211;
// method "visitArray(_)"
  struct UserObject *uo1270 = (struct UserObject*)obj1152;
  uo1270->data[44] = emptyclosure;
  Method *meth_meth_ast_1270_visitArray_40_1_41_ = addmethod2pos(obj1152, "visitArray(1)", &meth_ast_1270_visitArray_40_1_41_, 44);
  int argcv_meth_ast_1270_visitArray_40_1_41_[] = {1};
  meth_meth_ast_1270_visitArray_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1270_visitArray_40_1_41_);
  meth_meth_ast_1270_visitArray_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1270_visitArray_40_1_41_->definitionLine = 3212;
// method "visitMember(_)"
  struct UserObject *uo1272 = (struct UserObject*)obj1152;
  uo1272->data[45] = emptyclosure;
  Method *meth_meth_ast_1272_visitMember_40_1_41_ = addmethod2pos(obj1152, "visitMember(1)", &meth_ast_1272_visitMember_40_1_41_, 45);
  int argcv_meth_ast_1272_visitMember_40_1_41_[] = {1};
  meth_meth_ast_1272_visitMember_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1272_visitMember_40_1_41_);
  meth_meth_ast_1272_visitMember_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1272_visitMember_40_1_41_->definitionLine = 3213;
// method "visitGeneric(_)"
  struct UserObject *uo1274 = (struct UserObject*)obj1152;
  uo1274->data[46] = emptyclosure;
  Method *meth_meth_ast_1274_visitGeneric_40_1_41_ = addmethod2pos(obj1152, "visitGeneric(1)", &meth_ast_1274_visitGeneric_40_1_41_, 46);
  int argcv_meth_ast_1274_visitGeneric_40_1_41_[] = {1};
  meth_meth_ast_1274_visitGeneric_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1274_visitGeneric_40_1_41_);
  meth_meth_ast_1274_visitGeneric_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1274_visitGeneric_40_1_41_->definitionLine = 3214;
// method "visitIdentifier(_)"
  struct UserObject *uo1276 = (struct UserObject*)obj1152;
  uo1276->data[47] = emptyclosure;
  Method *meth_meth_ast_1276_visitIdentifier_40_1_41_ = addmethod2pos(obj1152, "visitIdentifier(1)", &meth_ast_1276_visitIdentifier_40_1_41_, 47);
  int argcv_meth_ast_1276_visitIdentifier_40_1_41_[] = {1};
  meth_meth_ast_1276_visitIdentifier_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1276_visitIdentifier_40_1_41_);
  meth_meth_ast_1276_visitIdentifier_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1276_visitIdentifier_40_1_41_->definitionLine = 3215;
// method "visitString(_)"
  struct UserObject *uo1278 = (struct UserObject*)obj1152;
  uo1278->data[48] = emptyclosure;
  Method *meth_meth_ast_1278_visitString_40_1_41_ = addmethod2pos(obj1152, "visitString(1)", &meth_ast_1278_visitString_40_1_41_, 48);
  int argcv_meth_ast_1278_visitString_40_1_41_[] = {1};
  meth_meth_ast_1278_visitString_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1278_visitString_40_1_41_);
  meth_meth_ast_1278_visitString_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1278_visitString_40_1_41_->definitionLine = 3216;
// method "visitNum(_)"
  struct UserObject *uo1280 = (struct UserObject*)obj1152;
  uo1280->data[49] = emptyclosure;
  Method *meth_meth_ast_1280_visitNum_40_1_41_ = addmethod2pos(obj1152, "visitNum(1)", &meth_ast_1280_visitNum_40_1_41_, 49);
  int argcv_meth_ast_1280_visitNum_40_1_41_[] = {1};
  meth_meth_ast_1280_visitNum_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1280_visitNum_40_1_41_);
  meth_meth_ast_1280_visitNum_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1280_visitNum_40_1_41_->definitionLine = 3217;
// method "visitOp(_)"
  struct UserObject *uo1282 = (struct UserObject*)obj1152;
  uo1282->data[50] = emptyclosure;
  Method *meth_meth_ast_1282_visitOp_40_1_41_ = addmethod2pos(obj1152, "visitOp(1)", &meth_ast_1282_visitOp_40_1_41_, 50);
  int argcv_meth_ast_1282_visitOp_40_1_41_[] = {1};
  meth_meth_ast_1282_visitOp_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1282_visitOp_40_1_41_);
  meth_meth_ast_1282_visitOp_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1282_visitOp_40_1_41_->definitionLine = 3218;
// method "visitBind(_)"
  struct UserObject *uo1284 = (struct UserObject*)obj1152;
  uo1284->data[51] = emptyclosure;
  Method *meth_meth_ast_1284_visitBind_40_1_41_ = addmethod2pos(obj1152, "visitBind(1)", &meth_ast_1284_visitBind_40_1_41_, 51);
  int argcv_meth_ast_1284_visitBind_40_1_41_[] = {1};
  meth_meth_ast_1284_visitBind_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1284_visitBind_40_1_41_);
  meth_meth_ast_1284_visitBind_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1284_visitBind_40_1_41_->definitionLine = 3219;
// method "visitDefDec(_)"
  struct UserObject *uo1286 = (struct UserObject*)obj1152;
  uo1286->data[52] = emptyclosure;
  Method *meth_meth_ast_1286_visitDefDec_40_1_41_ = addmethod2pos(obj1152, "visitDefDec(1)", &meth_ast_1286_visitDefDec_40_1_41_, 52);
  int argcv_meth_ast_1286_visitDefDec_40_1_41_[] = {1};
  meth_meth_ast_1286_visitDefDec_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1286_visitDefDec_40_1_41_);
  meth_meth_ast_1286_visitDefDec_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1286_visitDefDec_40_1_41_->definitionLine = 3220;
// method "visitVarDec(_)"
  struct UserObject *uo1288 = (struct UserObject*)obj1152;
  uo1288->data[53] = emptyclosure;
  Method *meth_meth_ast_1288_visitVarDec_40_1_41_ = addmethod2pos(obj1152, "visitVarDec(1)", &meth_ast_1288_visitVarDec_40_1_41_, 53);
  int argcv_meth_ast_1288_visitVarDec_40_1_41_[] = {1};
  meth_meth_ast_1288_visitVarDec_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1288_visitVarDec_40_1_41_);
  meth_meth_ast_1288_visitVarDec_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1288_visitVarDec_40_1_41_->definitionLine = 3221;
// method "visitImport(_)"
  struct UserObject *uo1290 = (struct UserObject*)obj1152;
  uo1290->data[54] = emptyclosure;
  Method *meth_meth_ast_1290_visitImport_40_1_41_ = addmethod2pos(obj1152, "visitImport(1)", &meth_ast_1290_visitImport_40_1_41_, 54);
  int argcv_meth_ast_1290_visitImport_40_1_41_[] = {1};
  meth_meth_ast_1290_visitImport_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1290_visitImport_40_1_41_);
  meth_meth_ast_1290_visitImport_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1290_visitImport_40_1_41_->definitionLine = 3222;
// method "visitReturn(_)"
  struct UserObject *uo1292 = (struct UserObject*)obj1152;
  uo1292->data[55] = emptyclosure;
  Method *meth_meth_ast_1292_visitReturn_40_1_41_ = addmethod2pos(obj1152, "visitReturn(1)", &meth_ast_1292_visitReturn_40_1_41_, 55);
  int argcv_meth_ast_1292_visitReturn_40_1_41_[] = {1};
  meth_meth_ast_1292_visitReturn_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1292_visitReturn_40_1_41_);
  meth_meth_ast_1292_visitReturn_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1292_visitReturn_40_1_41_->definitionLine = 3223;
// method "visitInherits(_)"
  struct UserObject *uo1294 = (struct UserObject*)obj1152;
  uo1294->data[56] = emptyclosure;
  Method *meth_meth_ast_1294_visitInherits_40_1_41_ = addmethod2pos(obj1152, "visitInherits(1)", &meth_ast_1294_visitInherits_40_1_41_, 56);
  int argcv_meth_ast_1294_visitInherits_40_1_41_[] = {1};
  meth_meth_ast_1294_visitInherits_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1294_visitInherits_40_1_41_);
  meth_meth_ast_1294_visitInherits_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1294_visitInherits_40_1_41_->definitionLine = 3224;
// method "visitDialect(_)"
  struct UserObject *uo1296 = (struct UserObject*)obj1152;
  uo1296->data[57] = emptyclosure;
  Method *meth_meth_ast_1296_visitDialect_40_1_41_ = addmethod2pos(obj1152, "visitDialect(1)", &meth_ast_1296_visitDialect_40_1_41_, 57);
  int argcv_meth_ast_1296_visitDialect_40_1_41_[] = {1};
  meth_meth_ast_1296_visitDialect_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1296_visitDialect_40_1_41_);
  meth_meth_ast_1296_visitDialect_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1296_visitDialect_40_1_41_->definitionLine = 3225;
// method "visitComment(_)"
  struct UserObject *uo1298 = (struct UserObject*)obj1152;
  uo1298->data[58] = emptyclosure;
  Method *meth_meth_ast_1298_visitComment_40_1_41_ = addmethod2pos(obj1152, "visitComment(1)", &meth_ast_1298_visitComment_40_1_41_, 58);
  int argcv_meth_ast_1298_visitComment_40_1_41_[] = {1};
  meth_meth_ast_1298_visitComment_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1298_visitComment_40_1_41_);
  meth_meth_ast_1298_visitComment_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1298_visitComment_40_1_41_->definitionLine = 3226;
// method "visitImplicit(_)"
  struct UserObject *uo1300 = (struct UserObject*)obj1152;
  uo1300->data[59] = emptyclosure;
  Method *meth_meth_ast_1300_visitImplicit_40_1_41_ = addmethod2pos(obj1152, "visitImplicit(1)", &meth_ast_1300_visitImplicit_40_1_41_, 59);
  int argcv_meth_ast_1300_visitImplicit_40_1_41_[] = {1};
  meth_meth_ast_1300_visitImplicit_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1300_visitImplicit_40_1_41_);
  meth_meth_ast_1300_visitImplicit_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1300_visitImplicit_40_1_41_->definitionLine = 3227;
// method "visitOuter(_)"
  struct UserObject *uo1302 = (struct UserObject*)obj1152;
  uo1302->data[60] = emptyclosure;
  Method *meth_meth_ast_1302_visitOuter_40_1_41_ = addmethod2pos(obj1152, "visitOuter(1)", &meth_ast_1302_visitOuter_40_1_41_, 60);
  int argcv_meth_ast_1302_visitOuter_40_1_41_[] = {1};
  meth_meth_ast_1302_visitOuter_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1302_visitOuter_40_1_41_);
  meth_meth_ast_1302_visitOuter_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1302_visitOuter_40_1_41_->definitionLine = 3228;
// method "asString"
  struct UserObject *uo1304 = (struct UserObject*)obj1152;
  uo1304->data[61] = emptyclosure;
  Method *meth_meth_ast_1304_asString = addmethod2pos(obj1152, "asString", &meth_ast_1304_asString, 61);
  int argcv_meth_ast_1304_asString[] = {0};
  meth_meth_ast_1304_asString->type = alloc_MethodType(1, argcv_meth_ast_1304_asString);
  meth_meth_ast_1304_asString->definitionModule = modulename;
  meth_meth_ast_1304_asString->definitionLine = 3230;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  objclass1152 = obj1152->class;
  objclass1152->definitionModule = modulename;
  objclass1152->definitionLine = 3167;
  (*(struct UserObject *)self).data[0] = lowerouter1152;
  self = oldself1152;
  selfslot = oldselfslot1152;
  stackframe = oldstackframe1152;
  gc_frame_end(frame);
  return obj1152;
}
Object meth_ast_1151_baseVisitor_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "baseVisitor$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1152 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1152 = alloc_userobj2(61,62, objclass1152);
  gc_frame_newslot(obj1152);
  if (objclass1152 == NULL) {
    glfree(obj1152->class->name);
    obj1152->class->name = "baseVisitor";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj1152, self, 0);
  addmethodreal(obj1152,"outer", &reader_ast_outer_1153);
  Object oldself1152 = self;
  struct StackFrameObject *oldstackframe1152 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1152);
  gc_frame_newslot((Object)stackframe);
  self = obj1152;
  Object *oldselfslot1152 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1152 = (*(struct UserObject *)self).data[0], lowerouter1152 = thisouter1152;
  if (inheritingObject1152) {
    struct UserObject *inho1152 = (struct UserObject *)inheritingObject1152;
    while (inho1152->super != GraceDefaultObject) inho1152 = (struct UserObject *)inho1152->super;
    inho1152->super = obj1152;
    self = inheritingObject1152;
    *selfslot = self;
    lowerouter1152 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1152;
  }
// method "visitIf(_)up(_)"
  struct UserObject *uo1154 = (struct UserObject*)obj1152;
  uo1154->data[1] = emptyclosure;
  Method *meth_meth_ast_1154_visitIf_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitIf(1)up(1)", &meth_ast_1154_visitIf_40_1_41_up_40_1_41_, 1);
  int argcv_meth_ast_1154_visitIf_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1154_visitIf_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1154_visitIf_40_1_41_up_40_1_41_);
  meth_meth_ast_1154_visitIf_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1154_visitIf_40_1_41_up_40_1_41_->definitionLine = 3168;
// method "visitBlock(_)up(_)"
  struct UserObject *uo1157 = (struct UserObject*)obj1152;
  uo1157->data[2] = emptyclosure;
  Method *meth_meth_ast_1157_visitBlock_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitBlock(1)up(1)", &meth_ast_1157_visitBlock_40_1_41_up_40_1_41_, 2);
  int argcv_meth_ast_1157_visitBlock_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1157_visitBlock_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1157_visitBlock_40_1_41_up_40_1_41_);
  meth_meth_ast_1157_visitBlock_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1157_visitBlock_40_1_41_up_40_1_41_->definitionLine = 3169;
// method "visitMatchCase(_)up(_)"
  struct UserObject *uo1160 = (struct UserObject*)obj1152;
  uo1160->data[3] = emptyclosure;
  Method *meth_meth_ast_1160_visitMatchCase_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitMatchCase(1)up(1)", &meth_ast_1160_visitMatchCase_40_1_41_up_40_1_41_, 3);
  int argcv_meth_ast_1160_visitMatchCase_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1160_visitMatchCase_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1160_visitMatchCase_40_1_41_up_40_1_41_);
  meth_meth_ast_1160_visitMatchCase_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1160_visitMatchCase_40_1_41_up_40_1_41_->definitionLine = 3170;
// method "visitTryCatch(_)up(_)"
  struct UserObject *uo1163 = (struct UserObject*)obj1152;
  uo1163->data[4] = emptyclosure;
  Method *meth_meth_ast_1163_visitTryCatch_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitTryCatch(1)up(1)", &meth_ast_1163_visitTryCatch_40_1_41_up_40_1_41_, 4);
  int argcv_meth_ast_1163_visitTryCatch_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1163_visitTryCatch_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1163_visitTryCatch_40_1_41_up_40_1_41_);
  meth_meth_ast_1163_visitTryCatch_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1163_visitTryCatch_40_1_41_up_40_1_41_->definitionLine = 3171;
// method "visitMethodType(_)up(_)"
  struct UserObject *uo1166 = (struct UserObject*)obj1152;
  uo1166->data[5] = emptyclosure;
  Method *meth_meth_ast_1166_visitMethodType_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitMethodType(1)up(1)", &meth_ast_1166_visitMethodType_40_1_41_up_40_1_41_, 5);
  int argcv_meth_ast_1166_visitMethodType_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1166_visitMethodType_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1166_visitMethodType_40_1_41_up_40_1_41_);
  meth_meth_ast_1166_visitMethodType_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1166_visitMethodType_40_1_41_up_40_1_41_->definitionLine = 3172;
// method "visitSignaturePart(_)up(_)"
  struct UserObject *uo1169 = (struct UserObject*)obj1152;
  uo1169->data[6] = emptyclosure;
  Method *meth_meth_ast_1169_visitSignaturePart_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitSignaturePart(1)up(1)", &meth_ast_1169_visitSignaturePart_40_1_41_up_40_1_41_, 6);
  int argcv_meth_ast_1169_visitSignaturePart_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1169_visitSignaturePart_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1169_visitSignaturePart_40_1_41_up_40_1_41_);
  meth_meth_ast_1169_visitSignaturePart_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1169_visitSignaturePart_40_1_41_up_40_1_41_->definitionLine = 3173;
// method "visitTypeDec(_)up(_)"
  struct UserObject *uo1172 = (struct UserObject*)obj1152;
  uo1172->data[7] = emptyclosure;
  Method *meth_meth_ast_1172_visitTypeDec_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitTypeDec(1)up(1)", &meth_ast_1172_visitTypeDec_40_1_41_up_40_1_41_, 7);
  int argcv_meth_ast_1172_visitTypeDec_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1172_visitTypeDec_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1172_visitTypeDec_40_1_41_up_40_1_41_);
  meth_meth_ast_1172_visitTypeDec_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1172_visitTypeDec_40_1_41_up_40_1_41_->definitionLine = 3174;
// method "visitTypeLiteral(_)up(_)"
  struct UserObject *uo1175 = (struct UserObject*)obj1152;
  uo1175->data[8] = emptyclosure;
  Method *meth_meth_ast_1175_visitTypeLiteral_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitTypeLiteral(1)up(1)", &meth_ast_1175_visitTypeLiteral_40_1_41_up_40_1_41_, 8);
  int argcv_meth_ast_1175_visitTypeLiteral_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1175_visitTypeLiteral_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1175_visitTypeLiteral_40_1_41_up_40_1_41_);
  meth_meth_ast_1175_visitTypeLiteral_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1175_visitTypeLiteral_40_1_41_up_40_1_41_->definitionLine = 3175;
// method "visitTypeParameters(_)up(_)"
  struct UserObject *uo1178 = (struct UserObject*)obj1152;
  uo1178->data[9] = emptyclosure;
  Method *meth_meth_ast_1178_visitTypeParameters_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitTypeParameters(1)up(1)", &meth_ast_1178_visitTypeParameters_40_1_41_up_40_1_41_, 9);
  int argcv_meth_ast_1178_visitTypeParameters_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1178_visitTypeParameters_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1178_visitTypeParameters_40_1_41_up_40_1_41_);
  meth_meth_ast_1178_visitTypeParameters_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1178_visitTypeParameters_40_1_41_up_40_1_41_->definitionLine = 3176;
// method "visitMethod(_)up(_)"
  struct UserObject *uo1181 = (struct UserObject*)obj1152;
  uo1181->data[10] = emptyclosure;
  Method *meth_meth_ast_1181_visitMethod_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitMethod(1)up(1)", &meth_ast_1181_visitMethod_40_1_41_up_40_1_41_, 10);
  int argcv_meth_ast_1181_visitMethod_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1181_visitMethod_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1181_visitMethod_40_1_41_up_40_1_41_);
  meth_meth_ast_1181_visitMethod_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1181_visitMethod_40_1_41_up_40_1_41_->definitionLine = 3177;
// method "visitCall(_)up(_)"
  struct UserObject *uo1184 = (struct UserObject*)obj1152;
  uo1184->data[11] = emptyclosure;
  Method *meth_meth_ast_1184_visitCall_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitCall(1)up(1)", &meth_ast_1184_visitCall_40_1_41_up_40_1_41_, 11);
  int argcv_meth_ast_1184_visitCall_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1184_visitCall_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1184_visitCall_40_1_41_up_40_1_41_);
  meth_meth_ast_1184_visitCall_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1184_visitCall_40_1_41_up_40_1_41_->definitionLine = 3178;
// method "visitObject(_)up(_)"
  struct UserObject *uo1187 = (struct UserObject*)obj1152;
  uo1187->data[12] = emptyclosure;
  Method *meth_meth_ast_1187_visitObject_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitObject(1)up(1)", &meth_ast_1187_visitObject_40_1_41_up_40_1_41_, 12);
  int argcv_meth_ast_1187_visitObject_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1187_visitObject_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1187_visitObject_40_1_41_up_40_1_41_);
  meth_meth_ast_1187_visitObject_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1187_visitObject_40_1_41_up_40_1_41_->definitionLine = 3179;
// method "visitModule(_)up(_)"
  struct UserObject *uo1190 = (struct UserObject*)obj1152;
  uo1190->data[13] = emptyclosure;
  Method *meth_meth_ast_1190_visitModule_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitModule(1)up(1)", &meth_ast_1190_visitModule_40_1_41_up_40_1_41_, 13);
  int argcv_meth_ast_1190_visitModule_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1190_visitModule_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1190_visitModule_40_1_41_up_40_1_41_);
  meth_meth_ast_1190_visitModule_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1190_visitModule_40_1_41_up_40_1_41_->definitionLine = 3180;
// method "visitArray(_)up(_)"
  struct UserObject *uo1193 = (struct UserObject*)obj1152;
  uo1193->data[14] = emptyclosure;
  Method *meth_meth_ast_1193_visitArray_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitArray(1)up(1)", &meth_ast_1193_visitArray_40_1_41_up_40_1_41_, 14);
  int argcv_meth_ast_1193_visitArray_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1193_visitArray_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1193_visitArray_40_1_41_up_40_1_41_);
  meth_meth_ast_1193_visitArray_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1193_visitArray_40_1_41_up_40_1_41_->definitionLine = 3181;
// method "visitMember(_)up(_)"
  struct UserObject *uo1196 = (struct UserObject*)obj1152;
  uo1196->data[15] = emptyclosure;
  Method *meth_meth_ast_1196_visitMember_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitMember(1)up(1)", &meth_ast_1196_visitMember_40_1_41_up_40_1_41_, 15);
  int argcv_meth_ast_1196_visitMember_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1196_visitMember_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1196_visitMember_40_1_41_up_40_1_41_);
  meth_meth_ast_1196_visitMember_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1196_visitMember_40_1_41_up_40_1_41_->definitionLine = 3182;
// method "visitGeneric(_)up(_)"
  struct UserObject *uo1199 = (struct UserObject*)obj1152;
  uo1199->data[16] = emptyclosure;
  Method *meth_meth_ast_1199_visitGeneric_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitGeneric(1)up(1)", &meth_ast_1199_visitGeneric_40_1_41_up_40_1_41_, 16);
  int argcv_meth_ast_1199_visitGeneric_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1199_visitGeneric_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1199_visitGeneric_40_1_41_up_40_1_41_);
  meth_meth_ast_1199_visitGeneric_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1199_visitGeneric_40_1_41_up_40_1_41_->definitionLine = 3183;
// method "visitIdentifier(_)up(_)"
  struct UserObject *uo1202 = (struct UserObject*)obj1152;
  uo1202->data[17] = emptyclosure;
  Method *meth_meth_ast_1202_visitIdentifier_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitIdentifier(1)up(1)", &meth_ast_1202_visitIdentifier_40_1_41_up_40_1_41_, 17);
  int argcv_meth_ast_1202_visitIdentifier_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1202_visitIdentifier_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1202_visitIdentifier_40_1_41_up_40_1_41_);
  meth_meth_ast_1202_visitIdentifier_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1202_visitIdentifier_40_1_41_up_40_1_41_->definitionLine = 3184;
// method "visitString(_)up(_)"
  struct UserObject *uo1205 = (struct UserObject*)obj1152;
  uo1205->data[18] = emptyclosure;
  Method *meth_meth_ast_1205_visitString_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitString(1)up(1)", &meth_ast_1205_visitString_40_1_41_up_40_1_41_, 18);
  int argcv_meth_ast_1205_visitString_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1205_visitString_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1205_visitString_40_1_41_up_40_1_41_);
  meth_meth_ast_1205_visitString_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1205_visitString_40_1_41_up_40_1_41_->definitionLine = 3185;
// method "visitNum(_)up(_)"
  struct UserObject *uo1208 = (struct UserObject*)obj1152;
  uo1208->data[19] = emptyclosure;
  Method *meth_meth_ast_1208_visitNum_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitNum(1)up(1)", &meth_ast_1208_visitNum_40_1_41_up_40_1_41_, 19);
  int argcv_meth_ast_1208_visitNum_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1208_visitNum_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1208_visitNum_40_1_41_up_40_1_41_);
  meth_meth_ast_1208_visitNum_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1208_visitNum_40_1_41_up_40_1_41_->definitionLine = 3186;
// method "visitOp(_)up(_)"
  struct UserObject *uo1211 = (struct UserObject*)obj1152;
  uo1211->data[20] = emptyclosure;
  Method *meth_meth_ast_1211_visitOp_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitOp(1)up(1)", &meth_ast_1211_visitOp_40_1_41_up_40_1_41_, 20);
  int argcv_meth_ast_1211_visitOp_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1211_visitOp_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1211_visitOp_40_1_41_up_40_1_41_);
  meth_meth_ast_1211_visitOp_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1211_visitOp_40_1_41_up_40_1_41_->definitionLine = 3187;
// method "visitBind(_)up(_)"
  struct UserObject *uo1214 = (struct UserObject*)obj1152;
  uo1214->data[21] = emptyclosure;
  Method *meth_meth_ast_1214_visitBind_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitBind(1)up(1)", &meth_ast_1214_visitBind_40_1_41_up_40_1_41_, 21);
  int argcv_meth_ast_1214_visitBind_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1214_visitBind_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1214_visitBind_40_1_41_up_40_1_41_);
  meth_meth_ast_1214_visitBind_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1214_visitBind_40_1_41_up_40_1_41_->definitionLine = 3188;
// method "visitDefDec(_)up(_)"
  struct UserObject *uo1217 = (struct UserObject*)obj1152;
  uo1217->data[22] = emptyclosure;
  Method *meth_meth_ast_1217_visitDefDec_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitDefDec(1)up(1)", &meth_ast_1217_visitDefDec_40_1_41_up_40_1_41_, 22);
  int argcv_meth_ast_1217_visitDefDec_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1217_visitDefDec_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1217_visitDefDec_40_1_41_up_40_1_41_);
  meth_meth_ast_1217_visitDefDec_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1217_visitDefDec_40_1_41_up_40_1_41_->definitionLine = 3189;
// method "visitVarDec(_)up(_)"
  struct UserObject *uo1220 = (struct UserObject*)obj1152;
  uo1220->data[23] = emptyclosure;
  Method *meth_meth_ast_1220_visitVarDec_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitVarDec(1)up(1)", &meth_ast_1220_visitVarDec_40_1_41_up_40_1_41_, 23);
  int argcv_meth_ast_1220_visitVarDec_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1220_visitVarDec_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1220_visitVarDec_40_1_41_up_40_1_41_);
  meth_meth_ast_1220_visitVarDec_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1220_visitVarDec_40_1_41_up_40_1_41_->definitionLine = 3190;
// method "visitImport(_)up(_)"
  struct UserObject *uo1223 = (struct UserObject*)obj1152;
  uo1223->data[24] = emptyclosure;
  Method *meth_meth_ast_1223_visitImport_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitImport(1)up(1)", &meth_ast_1223_visitImport_40_1_41_up_40_1_41_, 24);
  int argcv_meth_ast_1223_visitImport_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1223_visitImport_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1223_visitImport_40_1_41_up_40_1_41_);
  meth_meth_ast_1223_visitImport_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1223_visitImport_40_1_41_up_40_1_41_->definitionLine = 3191;
// method "visitReturn(_)up(_)"
  struct UserObject *uo1226 = (struct UserObject*)obj1152;
  uo1226->data[25] = emptyclosure;
  Method *meth_meth_ast_1226_visitReturn_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitReturn(1)up(1)", &meth_ast_1226_visitReturn_40_1_41_up_40_1_41_, 25);
  int argcv_meth_ast_1226_visitReturn_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1226_visitReturn_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1226_visitReturn_40_1_41_up_40_1_41_);
  meth_meth_ast_1226_visitReturn_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1226_visitReturn_40_1_41_up_40_1_41_->definitionLine = 3192;
// method "visitInherits(_)up(_)"
  struct UserObject *uo1229 = (struct UserObject*)obj1152;
  uo1229->data[26] = emptyclosure;
  Method *meth_meth_ast_1229_visitInherits_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitInherits(1)up(1)", &meth_ast_1229_visitInherits_40_1_41_up_40_1_41_, 26);
  int argcv_meth_ast_1229_visitInherits_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1229_visitInherits_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1229_visitInherits_40_1_41_up_40_1_41_);
  meth_meth_ast_1229_visitInherits_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1229_visitInherits_40_1_41_up_40_1_41_->definitionLine = 3193;
// method "visitDialect(_)up(_)"
  struct UserObject *uo1232 = (struct UserObject*)obj1152;
  uo1232->data[27] = emptyclosure;
  Method *meth_meth_ast_1232_visitDialect_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitDialect(1)up(1)", &meth_ast_1232_visitDialect_40_1_41_up_40_1_41_, 27);
  int argcv_meth_ast_1232_visitDialect_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1232_visitDialect_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1232_visitDialect_40_1_41_up_40_1_41_);
  meth_meth_ast_1232_visitDialect_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1232_visitDialect_40_1_41_up_40_1_41_->definitionLine = 3194;
// method "visitComment(_)up(_)"
  struct UserObject *uo1235 = (struct UserObject*)obj1152;
  uo1235->data[28] = emptyclosure;
  Method *meth_meth_ast_1235_visitComment_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitComment(1)up(1)", &meth_ast_1235_visitComment_40_1_41_up_40_1_41_, 28);
  int argcv_meth_ast_1235_visitComment_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1235_visitComment_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1235_visitComment_40_1_41_up_40_1_41_);
  meth_meth_ast_1235_visitComment_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1235_visitComment_40_1_41_up_40_1_41_->definitionLine = 3195;
// method "visitImplicit(_)up(_)"
  struct UserObject *uo1238 = (struct UserObject*)obj1152;
  uo1238->data[29] = emptyclosure;
  Method *meth_meth_ast_1238_visitImplicit_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitImplicit(1)up(1)", &meth_ast_1238_visitImplicit_40_1_41_up_40_1_41_, 29);
  int argcv_meth_ast_1238_visitImplicit_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1238_visitImplicit_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1238_visitImplicit_40_1_41_up_40_1_41_);
  meth_meth_ast_1238_visitImplicit_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1238_visitImplicit_40_1_41_up_40_1_41_->definitionLine = 3196;
// method "visitOuter(_)up(_)"
  struct UserObject *uo1241 = (struct UserObject*)obj1152;
  uo1241->data[30] = emptyclosure;
  Method *meth_meth_ast_1241_visitOuter_40_1_41_up_40_1_41_ = addmethod2pos(obj1152, "visitOuter(1)up(1)", &meth_ast_1241_visitOuter_40_1_41_up_40_1_41_, 30);
  int argcv_meth_ast_1241_visitOuter_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1241_visitOuter_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1241_visitOuter_40_1_41_up_40_1_41_);
  meth_meth_ast_1241_visitOuter_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1241_visitOuter_40_1_41_up_40_1_41_->definitionLine = 3197;
// method "visitIf(_)"
  struct UserObject *uo1244 = (struct UserObject*)obj1152;
  uo1244->data[31] = emptyclosure;
  Method *meth_meth_ast_1244_visitIf_40_1_41_ = addmethod2pos(obj1152, "visitIf(1)", &meth_ast_1244_visitIf_40_1_41_, 31);
  int argcv_meth_ast_1244_visitIf_40_1_41_[] = {1};
  meth_meth_ast_1244_visitIf_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1244_visitIf_40_1_41_);
  meth_meth_ast_1244_visitIf_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1244_visitIf_40_1_41_->definitionLine = 3199;
// method "visitBlock(_)"
  struct UserObject *uo1246 = (struct UserObject*)obj1152;
  uo1246->data[32] = emptyclosure;
  Method *meth_meth_ast_1246_visitBlock_40_1_41_ = addmethod2pos(obj1152, "visitBlock(1)", &meth_ast_1246_visitBlock_40_1_41_, 32);
  int argcv_meth_ast_1246_visitBlock_40_1_41_[] = {1};
  meth_meth_ast_1246_visitBlock_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1246_visitBlock_40_1_41_);
  meth_meth_ast_1246_visitBlock_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1246_visitBlock_40_1_41_->definitionLine = 3200;
// method "visitMatchCase(_)"
  struct UserObject *uo1248 = (struct UserObject*)obj1152;
  uo1248->data[33] = emptyclosure;
  Method *meth_meth_ast_1248_visitMatchCase_40_1_41_ = addmethod2pos(obj1152, "visitMatchCase(1)", &meth_ast_1248_visitMatchCase_40_1_41_, 33);
  int argcv_meth_ast_1248_visitMatchCase_40_1_41_[] = {1};
  meth_meth_ast_1248_visitMatchCase_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1248_visitMatchCase_40_1_41_);
  meth_meth_ast_1248_visitMatchCase_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1248_visitMatchCase_40_1_41_->definitionLine = 3201;
// method "visitTryCatch(_)"
  struct UserObject *uo1250 = (struct UserObject*)obj1152;
  uo1250->data[34] = emptyclosure;
  Method *meth_meth_ast_1250_visitTryCatch_40_1_41_ = addmethod2pos(obj1152, "visitTryCatch(1)", &meth_ast_1250_visitTryCatch_40_1_41_, 34);
  int argcv_meth_ast_1250_visitTryCatch_40_1_41_[] = {1};
  meth_meth_ast_1250_visitTryCatch_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1250_visitTryCatch_40_1_41_);
  meth_meth_ast_1250_visitTryCatch_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1250_visitTryCatch_40_1_41_->definitionLine = 3202;
// method "visitMethodType(_)"
  struct UserObject *uo1252 = (struct UserObject*)obj1152;
  uo1252->data[35] = emptyclosure;
  Method *meth_meth_ast_1252_visitMethodType_40_1_41_ = addmethod2pos(obj1152, "visitMethodType(1)", &meth_ast_1252_visitMethodType_40_1_41_, 35);
  int argcv_meth_ast_1252_visitMethodType_40_1_41_[] = {1};
  meth_meth_ast_1252_visitMethodType_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1252_visitMethodType_40_1_41_);
  meth_meth_ast_1252_visitMethodType_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1252_visitMethodType_40_1_41_->definitionLine = 3203;
// method "visitSignaturePart(_)"
  struct UserObject *uo1254 = (struct UserObject*)obj1152;
  uo1254->data[36] = emptyclosure;
  Method *meth_meth_ast_1254_visitSignaturePart_40_1_41_ = addmethod2pos(obj1152, "visitSignaturePart(1)", &meth_ast_1254_visitSignaturePart_40_1_41_, 36);
  int argcv_meth_ast_1254_visitSignaturePart_40_1_41_[] = {1};
  meth_meth_ast_1254_visitSignaturePart_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1254_visitSignaturePart_40_1_41_);
  meth_meth_ast_1254_visitSignaturePart_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1254_visitSignaturePart_40_1_41_->definitionLine = 3204;
// method "visitTypeDec(_)"
  struct UserObject *uo1256 = (struct UserObject*)obj1152;
  uo1256->data[37] = emptyclosure;
  Method *meth_meth_ast_1256_visitTypeDec_40_1_41_ = addmethod2pos(obj1152, "visitTypeDec(1)", &meth_ast_1256_visitTypeDec_40_1_41_, 37);
  int argcv_meth_ast_1256_visitTypeDec_40_1_41_[] = {1};
  meth_meth_ast_1256_visitTypeDec_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1256_visitTypeDec_40_1_41_);
  meth_meth_ast_1256_visitTypeDec_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1256_visitTypeDec_40_1_41_->definitionLine = 3205;
// method "visitTypeLiteral(_)"
  struct UserObject *uo1258 = (struct UserObject*)obj1152;
  uo1258->data[38] = emptyclosure;
  Method *meth_meth_ast_1258_visitTypeLiteral_40_1_41_ = addmethod2pos(obj1152, "visitTypeLiteral(1)", &meth_ast_1258_visitTypeLiteral_40_1_41_, 38);
  int argcv_meth_ast_1258_visitTypeLiteral_40_1_41_[] = {1};
  meth_meth_ast_1258_visitTypeLiteral_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1258_visitTypeLiteral_40_1_41_);
  meth_meth_ast_1258_visitTypeLiteral_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1258_visitTypeLiteral_40_1_41_->definitionLine = 3206;
// method "visitTypeParameters(_)"
  struct UserObject *uo1260 = (struct UserObject*)obj1152;
  uo1260->data[39] = emptyclosure;
  Method *meth_meth_ast_1260_visitTypeParameters_40_1_41_ = addmethod2pos(obj1152, "visitTypeParameters(1)", &meth_ast_1260_visitTypeParameters_40_1_41_, 39);
  int argcv_meth_ast_1260_visitTypeParameters_40_1_41_[] = {1};
  meth_meth_ast_1260_visitTypeParameters_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1260_visitTypeParameters_40_1_41_);
  meth_meth_ast_1260_visitTypeParameters_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1260_visitTypeParameters_40_1_41_->definitionLine = 3207;
// method "visitMethod(_)"
  struct UserObject *uo1262 = (struct UserObject*)obj1152;
  uo1262->data[40] = emptyclosure;
  Method *meth_meth_ast_1262_visitMethod_40_1_41_ = addmethod2pos(obj1152, "visitMethod(1)", &meth_ast_1262_visitMethod_40_1_41_, 40);
  int argcv_meth_ast_1262_visitMethod_40_1_41_[] = {1};
  meth_meth_ast_1262_visitMethod_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1262_visitMethod_40_1_41_);
  meth_meth_ast_1262_visitMethod_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1262_visitMethod_40_1_41_->definitionLine = 3208;
// method "visitCall(_)"
  struct UserObject *uo1264 = (struct UserObject*)obj1152;
  uo1264->data[41] = emptyclosure;
  Method *meth_meth_ast_1264_visitCall_40_1_41_ = addmethod2pos(obj1152, "visitCall(1)", &meth_ast_1264_visitCall_40_1_41_, 41);
  int argcv_meth_ast_1264_visitCall_40_1_41_[] = {1};
  meth_meth_ast_1264_visitCall_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1264_visitCall_40_1_41_);
  meth_meth_ast_1264_visitCall_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1264_visitCall_40_1_41_->definitionLine = 3209;
// method "visitObject(_)"
  struct UserObject *uo1266 = (struct UserObject*)obj1152;
  uo1266->data[42] = emptyclosure;
  Method *meth_meth_ast_1266_visitObject_40_1_41_ = addmethod2pos(obj1152, "visitObject(1)", &meth_ast_1266_visitObject_40_1_41_, 42);
  int argcv_meth_ast_1266_visitObject_40_1_41_[] = {1};
  meth_meth_ast_1266_visitObject_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1266_visitObject_40_1_41_);
  meth_meth_ast_1266_visitObject_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1266_visitObject_40_1_41_->definitionLine = 3210;
// method "visitModule(_)"
  struct UserObject *uo1268 = (struct UserObject*)obj1152;
  uo1268->data[43] = emptyclosure;
  Method *meth_meth_ast_1268_visitModule_40_1_41_ = addmethod2pos(obj1152, "visitModule(1)", &meth_ast_1268_visitModule_40_1_41_, 43);
  int argcv_meth_ast_1268_visitModule_40_1_41_[] = {1};
  meth_meth_ast_1268_visitModule_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1268_visitModule_40_1_41_);
  meth_meth_ast_1268_visitModule_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1268_visitModule_40_1_41_->definitionLine = 3211;
// method "visitArray(_)"
  struct UserObject *uo1270 = (struct UserObject*)obj1152;
  uo1270->data[44] = emptyclosure;
  Method *meth_meth_ast_1270_visitArray_40_1_41_ = addmethod2pos(obj1152, "visitArray(1)", &meth_ast_1270_visitArray_40_1_41_, 44);
  int argcv_meth_ast_1270_visitArray_40_1_41_[] = {1};
  meth_meth_ast_1270_visitArray_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1270_visitArray_40_1_41_);
  meth_meth_ast_1270_visitArray_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1270_visitArray_40_1_41_->definitionLine = 3212;
// method "visitMember(_)"
  struct UserObject *uo1272 = (struct UserObject*)obj1152;
  uo1272->data[45] = emptyclosure;
  Method *meth_meth_ast_1272_visitMember_40_1_41_ = addmethod2pos(obj1152, "visitMember(1)", &meth_ast_1272_visitMember_40_1_41_, 45);
  int argcv_meth_ast_1272_visitMember_40_1_41_[] = {1};
  meth_meth_ast_1272_visitMember_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1272_visitMember_40_1_41_);
  meth_meth_ast_1272_visitMember_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1272_visitMember_40_1_41_->definitionLine = 3213;
// method "visitGeneric(_)"
  struct UserObject *uo1274 = (struct UserObject*)obj1152;
  uo1274->data[46] = emptyclosure;
  Method *meth_meth_ast_1274_visitGeneric_40_1_41_ = addmethod2pos(obj1152, "visitGeneric(1)", &meth_ast_1274_visitGeneric_40_1_41_, 46);
  int argcv_meth_ast_1274_visitGeneric_40_1_41_[] = {1};
  meth_meth_ast_1274_visitGeneric_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1274_visitGeneric_40_1_41_);
  meth_meth_ast_1274_visitGeneric_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1274_visitGeneric_40_1_41_->definitionLine = 3214;
// method "visitIdentifier(_)"
  struct UserObject *uo1276 = (struct UserObject*)obj1152;
  uo1276->data[47] = emptyclosure;
  Method *meth_meth_ast_1276_visitIdentifier_40_1_41_ = addmethod2pos(obj1152, "visitIdentifier(1)", &meth_ast_1276_visitIdentifier_40_1_41_, 47);
  int argcv_meth_ast_1276_visitIdentifier_40_1_41_[] = {1};
  meth_meth_ast_1276_visitIdentifier_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1276_visitIdentifier_40_1_41_);
  meth_meth_ast_1276_visitIdentifier_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1276_visitIdentifier_40_1_41_->definitionLine = 3215;
// method "visitString(_)"
  struct UserObject *uo1278 = (struct UserObject*)obj1152;
  uo1278->data[48] = emptyclosure;
  Method *meth_meth_ast_1278_visitString_40_1_41_ = addmethod2pos(obj1152, "visitString(1)", &meth_ast_1278_visitString_40_1_41_, 48);
  int argcv_meth_ast_1278_visitString_40_1_41_[] = {1};
  meth_meth_ast_1278_visitString_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1278_visitString_40_1_41_);
  meth_meth_ast_1278_visitString_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1278_visitString_40_1_41_->definitionLine = 3216;
// method "visitNum(_)"
  struct UserObject *uo1280 = (struct UserObject*)obj1152;
  uo1280->data[49] = emptyclosure;
  Method *meth_meth_ast_1280_visitNum_40_1_41_ = addmethod2pos(obj1152, "visitNum(1)", &meth_ast_1280_visitNum_40_1_41_, 49);
  int argcv_meth_ast_1280_visitNum_40_1_41_[] = {1};
  meth_meth_ast_1280_visitNum_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1280_visitNum_40_1_41_);
  meth_meth_ast_1280_visitNum_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1280_visitNum_40_1_41_->definitionLine = 3217;
// method "visitOp(_)"
  struct UserObject *uo1282 = (struct UserObject*)obj1152;
  uo1282->data[50] = emptyclosure;
  Method *meth_meth_ast_1282_visitOp_40_1_41_ = addmethod2pos(obj1152, "visitOp(1)", &meth_ast_1282_visitOp_40_1_41_, 50);
  int argcv_meth_ast_1282_visitOp_40_1_41_[] = {1};
  meth_meth_ast_1282_visitOp_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1282_visitOp_40_1_41_);
  meth_meth_ast_1282_visitOp_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1282_visitOp_40_1_41_->definitionLine = 3218;
// method "visitBind(_)"
  struct UserObject *uo1284 = (struct UserObject*)obj1152;
  uo1284->data[51] = emptyclosure;
  Method *meth_meth_ast_1284_visitBind_40_1_41_ = addmethod2pos(obj1152, "visitBind(1)", &meth_ast_1284_visitBind_40_1_41_, 51);
  int argcv_meth_ast_1284_visitBind_40_1_41_[] = {1};
  meth_meth_ast_1284_visitBind_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1284_visitBind_40_1_41_);
  meth_meth_ast_1284_visitBind_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1284_visitBind_40_1_41_->definitionLine = 3219;
// method "visitDefDec(_)"
  struct UserObject *uo1286 = (struct UserObject*)obj1152;
  uo1286->data[52] = emptyclosure;
  Method *meth_meth_ast_1286_visitDefDec_40_1_41_ = addmethod2pos(obj1152, "visitDefDec(1)", &meth_ast_1286_visitDefDec_40_1_41_, 52);
  int argcv_meth_ast_1286_visitDefDec_40_1_41_[] = {1};
  meth_meth_ast_1286_visitDefDec_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1286_visitDefDec_40_1_41_);
  meth_meth_ast_1286_visitDefDec_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1286_visitDefDec_40_1_41_->definitionLine = 3220;
// method "visitVarDec(_)"
  struct UserObject *uo1288 = (struct UserObject*)obj1152;
  uo1288->data[53] = emptyclosure;
  Method *meth_meth_ast_1288_visitVarDec_40_1_41_ = addmethod2pos(obj1152, "visitVarDec(1)", &meth_ast_1288_visitVarDec_40_1_41_, 53);
  int argcv_meth_ast_1288_visitVarDec_40_1_41_[] = {1};
  meth_meth_ast_1288_visitVarDec_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1288_visitVarDec_40_1_41_);
  meth_meth_ast_1288_visitVarDec_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1288_visitVarDec_40_1_41_->definitionLine = 3221;
// method "visitImport(_)"
  struct UserObject *uo1290 = (struct UserObject*)obj1152;
  uo1290->data[54] = emptyclosure;
  Method *meth_meth_ast_1290_visitImport_40_1_41_ = addmethod2pos(obj1152, "visitImport(1)", &meth_ast_1290_visitImport_40_1_41_, 54);
  int argcv_meth_ast_1290_visitImport_40_1_41_[] = {1};
  meth_meth_ast_1290_visitImport_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1290_visitImport_40_1_41_);
  meth_meth_ast_1290_visitImport_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1290_visitImport_40_1_41_->definitionLine = 3222;
// method "visitReturn(_)"
  struct UserObject *uo1292 = (struct UserObject*)obj1152;
  uo1292->data[55] = emptyclosure;
  Method *meth_meth_ast_1292_visitReturn_40_1_41_ = addmethod2pos(obj1152, "visitReturn(1)", &meth_ast_1292_visitReturn_40_1_41_, 55);
  int argcv_meth_ast_1292_visitReturn_40_1_41_[] = {1};
  meth_meth_ast_1292_visitReturn_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1292_visitReturn_40_1_41_);
  meth_meth_ast_1292_visitReturn_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1292_visitReturn_40_1_41_->definitionLine = 3223;
// method "visitInherits(_)"
  struct UserObject *uo1294 = (struct UserObject*)obj1152;
  uo1294->data[56] = emptyclosure;
  Method *meth_meth_ast_1294_visitInherits_40_1_41_ = addmethod2pos(obj1152, "visitInherits(1)", &meth_ast_1294_visitInherits_40_1_41_, 56);
  int argcv_meth_ast_1294_visitInherits_40_1_41_[] = {1};
  meth_meth_ast_1294_visitInherits_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1294_visitInherits_40_1_41_);
  meth_meth_ast_1294_visitInherits_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1294_visitInherits_40_1_41_->definitionLine = 3224;
// method "visitDialect(_)"
  struct UserObject *uo1296 = (struct UserObject*)obj1152;
  uo1296->data[57] = emptyclosure;
  Method *meth_meth_ast_1296_visitDialect_40_1_41_ = addmethod2pos(obj1152, "visitDialect(1)", &meth_ast_1296_visitDialect_40_1_41_, 57);
  int argcv_meth_ast_1296_visitDialect_40_1_41_[] = {1};
  meth_meth_ast_1296_visitDialect_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1296_visitDialect_40_1_41_);
  meth_meth_ast_1296_visitDialect_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1296_visitDialect_40_1_41_->definitionLine = 3225;
// method "visitComment(_)"
  struct UserObject *uo1298 = (struct UserObject*)obj1152;
  uo1298->data[58] = emptyclosure;
  Method *meth_meth_ast_1298_visitComment_40_1_41_ = addmethod2pos(obj1152, "visitComment(1)", &meth_ast_1298_visitComment_40_1_41_, 58);
  int argcv_meth_ast_1298_visitComment_40_1_41_[] = {1};
  meth_meth_ast_1298_visitComment_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1298_visitComment_40_1_41_);
  meth_meth_ast_1298_visitComment_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1298_visitComment_40_1_41_->definitionLine = 3226;
// method "visitImplicit(_)"
  struct UserObject *uo1300 = (struct UserObject*)obj1152;
  uo1300->data[59] = emptyclosure;
  Method *meth_meth_ast_1300_visitImplicit_40_1_41_ = addmethod2pos(obj1152, "visitImplicit(1)", &meth_ast_1300_visitImplicit_40_1_41_, 59);
  int argcv_meth_ast_1300_visitImplicit_40_1_41_[] = {1};
  meth_meth_ast_1300_visitImplicit_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1300_visitImplicit_40_1_41_);
  meth_meth_ast_1300_visitImplicit_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1300_visitImplicit_40_1_41_->definitionLine = 3227;
// method "visitOuter(_)"
  struct UserObject *uo1302 = (struct UserObject*)obj1152;
  uo1302->data[60] = emptyclosure;
  Method *meth_meth_ast_1302_visitOuter_40_1_41_ = addmethod2pos(obj1152, "visitOuter(1)", &meth_ast_1302_visitOuter_40_1_41_, 60);
  int argcv_meth_ast_1302_visitOuter_40_1_41_[] = {1};
  meth_meth_ast_1302_visitOuter_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1302_visitOuter_40_1_41_);
  meth_meth_ast_1302_visitOuter_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1302_visitOuter_40_1_41_->definitionLine = 3228;
// method "asString"
  struct UserObject *uo1304 = (struct UserObject*)obj1152;
  uo1304->data[61] = emptyclosure;
  Method *meth_meth_ast_1304_asString = addmethod2pos(obj1152, "asString", &meth_ast_1304_asString, 61);
  int argcv_meth_ast_1304_asString[] = {0};
  meth_meth_ast_1304_asString->type = alloc_MethodType(1, argcv_meth_ast_1304_asString);
  meth_meth_ast_1304_asString->definitionModule = modulename;
  meth_meth_ast_1304_asString->definitionLine = 3230;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  sourceObject = obj1152;
  objclass1152 = obj1152->class;
  objclass1152->definitionModule = modulename;
  objclass1152->definitionLine = 3167;
  (*(struct UserObject *)self).data[0] = lowerouter1152;
  self = oldself1152;
  selfslot = oldselfslot1152;
  stackframe = oldstackframe1152;
  gc_frame_end(frame);
  return obj1152;
}
Object meth_ast_1310_visitIf_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitIf(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIf(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIf(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitIf(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitIf(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3240
  setline(3240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1311 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1312 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1311);
// compiled call node returning call1312 (depth = 2)
  gc_frame_end(frame);
  return call1312;
}
Object meth_ast_1313_visitBlock_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitBlock(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlock(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlock(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBlock(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitBlock(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3241
  setline(3241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1314 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1315 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1314);
// compiled call node returning call1315 (depth = 2)
  gc_frame_end(frame);
  return call1315;
}
Object meth_ast_1316_visitMatchCase_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitMatchCase(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMatchCase(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMatchCase(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMatchCase(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMatchCase(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3242
  setline(3242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1317 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1318 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1317);
// compiled call node returning call1318 (depth = 2)
  gc_frame_end(frame);
  return call1318;
}
Object meth_ast_1319_visitTryCatch_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitTryCatch(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTryCatch(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTryCatch(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTryCatch(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTryCatch(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3243
  setline(3243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1320 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1321 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1320);
// compiled call node returning call1321 (depth = 2)
  gc_frame_end(frame);
  return call1321;
}
Object meth_ast_1322_visitMethodType_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitMethodType(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethodType(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethodType(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMethodType(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMethodType(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3244
  setline(3244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1323 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1324 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1323);
// compiled call node returning call1324 (depth = 2)
  gc_frame_end(frame);
  return call1324;
}
Object meth_ast_1325_visitSignaturePart_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitSignaturePart(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitSignaturePart(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitSignaturePart(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitSignaturePart(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitSignaturePart(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3245
  setline(3245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1326 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1327 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1326);
// compiled call node returning call1327 (depth = 2)
  gc_frame_end(frame);
  return call1327;
}
Object meth_ast_1328_visitTypeDec_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitTypeDec(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeDec(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeDec(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeDec(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTypeDec(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3246
  setline(3246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1329 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1330 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1329);
// compiled call node returning call1330 (depth = 2)
  gc_frame_end(frame);
  return call1330;
}
Object meth_ast_1331_visitTypeLiteral_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitTypeLiteral(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeLiteral(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeLiteral(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeLiteral(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTypeLiteral(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3247
  setline(3247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1332 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1333 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1332);
// compiled call node returning call1333 (depth = 2)
  gc_frame_end(frame);
  return call1333;
}
Object meth_ast_1334_visitMethod_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitMethod(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethod(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethod(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMethod(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMethod(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3248
  setline(3248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1335 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1336 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1335);
// compiled call node returning call1336 (depth = 2)
  gc_frame_end(frame);
  return call1336;
}
Object meth_ast_1337_visitCall_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitCall(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitCall(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitCall(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3249
  setline(3249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1338 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1339 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1338);
// compiled call node returning call1339 (depth = 2)
  gc_frame_end(frame);
  return call1339;
}
Object meth_ast_1340_visitObject_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitObject(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitObject(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitObject(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitObject(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitObject(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3250
  setline(3250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1341 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1342 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1341);
// compiled call node returning call1342 (depth = 2)
  gc_frame_end(frame);
  return call1342;
}
Object meth_ast_1343_visitModule_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitModule(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitModule(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitModule(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitModule(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitModule(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3251
  setline(3251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1344 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1345 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1344);
// compiled call node returning call1345 (depth = 2)
  gc_frame_end(frame);
  return call1345;
}
Object meth_ast_1346_visitArray_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitArray(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitArray(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitArray(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitArray(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitArray(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3252
  setline(3252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1347 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1348 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1347);
// compiled call node returning call1348 (depth = 2)
  gc_frame_end(frame);
  return call1348;
}
Object meth_ast_1349_visitMember_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitMember(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMember(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMember(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMember(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMember(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3253
  setline(3253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1350 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1351 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1350);
// compiled call node returning call1351 (depth = 2)
  gc_frame_end(frame);
  return call1351;
}
Object meth_ast_1352_visitGeneric_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitGeneric(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitGeneric(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitGeneric(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitGeneric(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitGeneric(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3254
  setline(3254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1353 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1354 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1353);
// compiled call node returning call1354 (depth = 2)
  gc_frame_end(frame);
  return call1354;
}
Object meth_ast_1355_visitIdentifier_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitIdentifier(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIdentifier(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIdentifier(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitIdentifier(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitIdentifier(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3255
  setline(3255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1356 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1357 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1356);
// compiled call node returning call1357 (depth = 2)
  gc_frame_end(frame);
  return call1357;
}
Object meth_ast_1358_visitString_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitString(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitString(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitString(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitString(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitString(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3256
  setline(3256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1359 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1360 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1359);
// compiled call node returning call1360 (depth = 2)
  gc_frame_end(frame);
  return call1360;
}
Object meth_ast_1361_visitNum_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitNum(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitNum(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitNum(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitNum(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitNum(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3257
  setline(3257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1362 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1363 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1362);
// compiled call node returning call1363 (depth = 2)
  gc_frame_end(frame);
  return call1363;
}
Object meth_ast_1364_visitOp_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitOp(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOp(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOp(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitOp(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitOp(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3258
  setline(3258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1365 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1366 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1365);
// compiled call node returning call1366 (depth = 2)
  gc_frame_end(frame);
  return call1366;
}
Object meth_ast_1367_visitBind_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitBind(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBind(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBind(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBind(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitBind(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3259
  setline(3259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1368 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1369 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1368);
// compiled call node returning call1369 (depth = 2)
  gc_frame_end(frame);
  return call1369;
}
Object meth_ast_1370_visitDefDec_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitDefDec(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDefDec(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDefDec(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitDefDec(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitDefDec(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3260
  setline(3260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1371 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1372 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1371);
// compiled call node returning call1372 (depth = 2)
  gc_frame_end(frame);
  return call1372;
}
Object meth_ast_1373_visitVarDec_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitVarDec(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitVarDec(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitVarDec(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitVarDec(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitVarDec(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3261
  setline(3261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1374 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1375 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1374);
// compiled call node returning call1375 (depth = 2)
  gc_frame_end(frame);
  return call1375;
}
Object meth_ast_1376_visitImport_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitImport(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImport(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImport(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitImport(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitImport(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3262
  setline(3262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1377 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1378 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1377);
// compiled call node returning call1378 (depth = 2)
  gc_frame_end(frame);
  return call1378;
}
Object meth_ast_1379_visitReturn_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitReturn(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitReturn(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitReturn(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitReturn(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitReturn(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3263
  setline(3263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1380 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1381 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1380);
// compiled call node returning call1381 (depth = 2)
  gc_frame_end(frame);
  return call1381;
}
Object meth_ast_1382_visitInherits_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitInherits(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitInherits(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitInherits(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitInherits(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitInherits(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3264
  setline(3264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1383 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1384 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1383);
// compiled call node returning call1384 (depth = 2)
  gc_frame_end(frame);
  return call1384;
}
Object meth_ast_1385_visitDialect_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitDialect(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDialect(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDialect(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitDialect(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitDialect(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3265
  setline(3265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1386 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1387 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1386);
// compiled call node returning call1387 (depth = 2)
  gc_frame_end(frame);
  return call1387;
}
Object meth_ast_1388_visitComment_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitComment(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitComment(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitComment(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitComment(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitComment(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3266
  setline(3266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1389 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1390 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1389);
// compiled call node returning call1390 (depth = 2)
  gc_frame_end(frame);
  return call1390;
}
Object meth_ast_1391_visitImplicit_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitImplicit(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImplicit(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImplicit(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitImplicit(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitImplicit(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3267
  setline(3267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1392 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1393 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1392);
// compiled call node returning call1393 (depth = 2)
  gc_frame_end(frame);
  return call1393;
}
Object meth_ast_1394_visitOuter_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitOuter(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOuter(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOuter(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitOuter(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitOuter(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3268
  setline(3268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1395 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1396 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1395);
// compiled call node returning call1396 (depth = 2)
  gc_frame_end(frame);
  return call1396;
}
Object meth_ast_1397_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3270
  setline(3270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit1398 == NULL) {
    strlit1398 = alloc_String("a pluggable AST visitor");
    gc_root(strlit1398);
  }
// compiled string node returning strlit1398 (depth = 2)
  gc_frame_end(frame);
  return strlit1398;
}
Object meth_ast_1307_pluggableVisitor_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pluggableVisitor(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pluggableVisitor(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pluggableVisitor(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitation = &(stackframe->slots[0]);
  *var_visitation = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pluggableVisitor(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1308 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1308 = alloc_userobj2(30,31, objclass1308);
  gc_frame_newslot(obj1308);
  if (objclass1308 == NULL) {
    glfree(obj1308->class->name);
    obj1308->class->name = "pluggableVisitor(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj1308, self, 0);
  addmethodreal(obj1308,"outer", &reader_ast_outer_1309);
  Object oldself1308 = self;
  struct StackFrameObject *oldstackframe1308 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1308);
  gc_frame_newslot((Object)stackframe);
  self = obj1308;
  Object *oldselfslot1308 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1308 = (*(struct UserObject *)self).data[0], lowerouter1308 = thisouter1308;
  if (inheritingObject1308) {
    struct UserObject *inho1308 = (struct UserObject *)inheritingObject1308;
    while (inho1308->super != GraceDefaultObject) inho1308 = (struct UserObject *)inho1308->super;
    inho1308->super = obj1308;
    self = inheritingObject1308;
    *selfslot = self;
    lowerouter1308 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1308;
  }
// method "visitIf(_)up(_)"
  block_savedest(obj1308);
  Object closure1310 = createclosure(1, "visitIf(1)up(1)");
  setclosureframe(closure1310, stackframe);
  addtoclosure(closure1310, var_visitation);
  struct UserObject *uo1310 = (struct UserObject*)obj1308;
  uo1310->data[1] = (Object)closure1310;
  Method *meth_meth_ast_1310_visitIf_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitIf(1)up(1)", &meth_ast_1310_visitIf_40_1_41_up_40_1_41_, 1);
  int argcv_meth_ast_1310_visitIf_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1310_visitIf_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1310_visitIf_40_1_41_up_40_1_41_);
  meth_meth_ast_1310_visitIf_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1310_visitIf_40_1_41_up_40_1_41_->definitionLine = 3240;
// method "visitBlock(_)up(_)"
  block_savedest(obj1308);
  Object closure1313 = createclosure(1, "visitBlock(1)up(1)");
  setclosureframe(closure1313, stackframe);
  addtoclosure(closure1313, var_visitation);
  struct UserObject *uo1313 = (struct UserObject*)obj1308;
  uo1313->data[2] = (Object)closure1313;
  Method *meth_meth_ast_1313_visitBlock_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitBlock(1)up(1)", &meth_ast_1313_visitBlock_40_1_41_up_40_1_41_, 2);
  int argcv_meth_ast_1313_visitBlock_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1313_visitBlock_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1313_visitBlock_40_1_41_up_40_1_41_);
  meth_meth_ast_1313_visitBlock_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1313_visitBlock_40_1_41_up_40_1_41_->definitionLine = 3241;
// method "visitMatchCase(_)up(_)"
  block_savedest(obj1308);
  Object closure1316 = createclosure(1, "visitMatchCase(1)up(1)");
  setclosureframe(closure1316, stackframe);
  addtoclosure(closure1316, var_visitation);
  struct UserObject *uo1316 = (struct UserObject*)obj1308;
  uo1316->data[3] = (Object)closure1316;
  Method *meth_meth_ast_1316_visitMatchCase_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitMatchCase(1)up(1)", &meth_ast_1316_visitMatchCase_40_1_41_up_40_1_41_, 3);
  int argcv_meth_ast_1316_visitMatchCase_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1316_visitMatchCase_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1316_visitMatchCase_40_1_41_up_40_1_41_);
  meth_meth_ast_1316_visitMatchCase_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1316_visitMatchCase_40_1_41_up_40_1_41_->definitionLine = 3242;
// method "visitTryCatch(_)up(_)"
  block_savedest(obj1308);
  Object closure1319 = createclosure(1, "visitTryCatch(1)up(1)");
  setclosureframe(closure1319, stackframe);
  addtoclosure(closure1319, var_visitation);
  struct UserObject *uo1319 = (struct UserObject*)obj1308;
  uo1319->data[4] = (Object)closure1319;
  Method *meth_meth_ast_1319_visitTryCatch_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitTryCatch(1)up(1)", &meth_ast_1319_visitTryCatch_40_1_41_up_40_1_41_, 4);
  int argcv_meth_ast_1319_visitTryCatch_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1319_visitTryCatch_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1319_visitTryCatch_40_1_41_up_40_1_41_);
  meth_meth_ast_1319_visitTryCatch_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1319_visitTryCatch_40_1_41_up_40_1_41_->definitionLine = 3243;
// method "visitMethodType(_)up(_)"
  block_savedest(obj1308);
  Object closure1322 = createclosure(1, "visitMethodType(1)up(1)");
  setclosureframe(closure1322, stackframe);
  addtoclosure(closure1322, var_visitation);
  struct UserObject *uo1322 = (struct UserObject*)obj1308;
  uo1322->data[5] = (Object)closure1322;
  Method *meth_meth_ast_1322_visitMethodType_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitMethodType(1)up(1)", &meth_ast_1322_visitMethodType_40_1_41_up_40_1_41_, 5);
  int argcv_meth_ast_1322_visitMethodType_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1322_visitMethodType_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1322_visitMethodType_40_1_41_up_40_1_41_);
  meth_meth_ast_1322_visitMethodType_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1322_visitMethodType_40_1_41_up_40_1_41_->definitionLine = 3244;
// method "visitSignaturePart(_)up(_)"
  block_savedest(obj1308);
  Object closure1325 = createclosure(1, "visitSignaturePart(1)up(1)");
  setclosureframe(closure1325, stackframe);
  addtoclosure(closure1325, var_visitation);
  struct UserObject *uo1325 = (struct UserObject*)obj1308;
  uo1325->data[6] = (Object)closure1325;
  Method *meth_meth_ast_1325_visitSignaturePart_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitSignaturePart(1)up(1)", &meth_ast_1325_visitSignaturePart_40_1_41_up_40_1_41_, 6);
  int argcv_meth_ast_1325_visitSignaturePart_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1325_visitSignaturePart_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1325_visitSignaturePart_40_1_41_up_40_1_41_);
  meth_meth_ast_1325_visitSignaturePart_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1325_visitSignaturePart_40_1_41_up_40_1_41_->definitionLine = 3245;
// method "visitTypeDec(_)up(_)"
  block_savedest(obj1308);
  Object closure1328 = createclosure(1, "visitTypeDec(1)up(1)");
  setclosureframe(closure1328, stackframe);
  addtoclosure(closure1328, var_visitation);
  struct UserObject *uo1328 = (struct UserObject*)obj1308;
  uo1328->data[7] = (Object)closure1328;
  Method *meth_meth_ast_1328_visitTypeDec_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitTypeDec(1)up(1)", &meth_ast_1328_visitTypeDec_40_1_41_up_40_1_41_, 7);
  int argcv_meth_ast_1328_visitTypeDec_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1328_visitTypeDec_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1328_visitTypeDec_40_1_41_up_40_1_41_);
  meth_meth_ast_1328_visitTypeDec_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1328_visitTypeDec_40_1_41_up_40_1_41_->definitionLine = 3246;
// method "visitTypeLiteral(_)up(_)"
  block_savedest(obj1308);
  Object closure1331 = createclosure(1, "visitTypeLiteral(1)up(1)");
  setclosureframe(closure1331, stackframe);
  addtoclosure(closure1331, var_visitation);
  struct UserObject *uo1331 = (struct UserObject*)obj1308;
  uo1331->data[8] = (Object)closure1331;
  Method *meth_meth_ast_1331_visitTypeLiteral_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitTypeLiteral(1)up(1)", &meth_ast_1331_visitTypeLiteral_40_1_41_up_40_1_41_, 8);
  int argcv_meth_ast_1331_visitTypeLiteral_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1331_visitTypeLiteral_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1331_visitTypeLiteral_40_1_41_up_40_1_41_);
  meth_meth_ast_1331_visitTypeLiteral_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1331_visitTypeLiteral_40_1_41_up_40_1_41_->definitionLine = 3247;
// method "visitMethod(_)up(_)"
  block_savedest(obj1308);
  Object closure1334 = createclosure(1, "visitMethod(1)up(1)");
  setclosureframe(closure1334, stackframe);
  addtoclosure(closure1334, var_visitation);
  struct UserObject *uo1334 = (struct UserObject*)obj1308;
  uo1334->data[9] = (Object)closure1334;
  Method *meth_meth_ast_1334_visitMethod_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitMethod(1)up(1)", &meth_ast_1334_visitMethod_40_1_41_up_40_1_41_, 9);
  int argcv_meth_ast_1334_visitMethod_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1334_visitMethod_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1334_visitMethod_40_1_41_up_40_1_41_);
  meth_meth_ast_1334_visitMethod_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1334_visitMethod_40_1_41_up_40_1_41_->definitionLine = 3248;
// method "visitCall(_)up(_)"
  block_savedest(obj1308);
  Object closure1337 = createclosure(1, "visitCall(1)up(1)");
  setclosureframe(closure1337, stackframe);
  addtoclosure(closure1337, var_visitation);
  struct UserObject *uo1337 = (struct UserObject*)obj1308;
  uo1337->data[10] = (Object)closure1337;
  Method *meth_meth_ast_1337_visitCall_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitCall(1)up(1)", &meth_ast_1337_visitCall_40_1_41_up_40_1_41_, 10);
  int argcv_meth_ast_1337_visitCall_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1337_visitCall_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1337_visitCall_40_1_41_up_40_1_41_);
  meth_meth_ast_1337_visitCall_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1337_visitCall_40_1_41_up_40_1_41_->definitionLine = 3249;
// method "visitObject(_)up(_)"
  block_savedest(obj1308);
  Object closure1340 = createclosure(1, "visitObject(1)up(1)");
  setclosureframe(closure1340, stackframe);
  addtoclosure(closure1340, var_visitation);
  struct UserObject *uo1340 = (struct UserObject*)obj1308;
  uo1340->data[11] = (Object)closure1340;
  Method *meth_meth_ast_1340_visitObject_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitObject(1)up(1)", &meth_ast_1340_visitObject_40_1_41_up_40_1_41_, 11);
  int argcv_meth_ast_1340_visitObject_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1340_visitObject_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1340_visitObject_40_1_41_up_40_1_41_);
  meth_meth_ast_1340_visitObject_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1340_visitObject_40_1_41_up_40_1_41_->definitionLine = 3250;
// method "visitModule(_)up(_)"
  block_savedest(obj1308);
  Object closure1343 = createclosure(1, "visitModule(1)up(1)");
  setclosureframe(closure1343, stackframe);
  addtoclosure(closure1343, var_visitation);
  struct UserObject *uo1343 = (struct UserObject*)obj1308;
  uo1343->data[12] = (Object)closure1343;
  Method *meth_meth_ast_1343_visitModule_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitModule(1)up(1)", &meth_ast_1343_visitModule_40_1_41_up_40_1_41_, 12);
  int argcv_meth_ast_1343_visitModule_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1343_visitModule_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1343_visitModule_40_1_41_up_40_1_41_);
  meth_meth_ast_1343_visitModule_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1343_visitModule_40_1_41_up_40_1_41_->definitionLine = 3251;
// method "visitArray(_)up(_)"
  block_savedest(obj1308);
  Object closure1346 = createclosure(1, "visitArray(1)up(1)");
  setclosureframe(closure1346, stackframe);
  addtoclosure(closure1346, var_visitation);
  struct UserObject *uo1346 = (struct UserObject*)obj1308;
  uo1346->data[13] = (Object)closure1346;
  Method *meth_meth_ast_1346_visitArray_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitArray(1)up(1)", &meth_ast_1346_visitArray_40_1_41_up_40_1_41_, 13);
  int argcv_meth_ast_1346_visitArray_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1346_visitArray_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1346_visitArray_40_1_41_up_40_1_41_);
  meth_meth_ast_1346_visitArray_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1346_visitArray_40_1_41_up_40_1_41_->definitionLine = 3252;
// method "visitMember(_)up(_)"
  block_savedest(obj1308);
  Object closure1349 = createclosure(1, "visitMember(1)up(1)");
  setclosureframe(closure1349, stackframe);
  addtoclosure(closure1349, var_visitation);
  struct UserObject *uo1349 = (struct UserObject*)obj1308;
  uo1349->data[14] = (Object)closure1349;
  Method *meth_meth_ast_1349_visitMember_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitMember(1)up(1)", &meth_ast_1349_visitMember_40_1_41_up_40_1_41_, 14);
  int argcv_meth_ast_1349_visitMember_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1349_visitMember_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1349_visitMember_40_1_41_up_40_1_41_);
  meth_meth_ast_1349_visitMember_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1349_visitMember_40_1_41_up_40_1_41_->definitionLine = 3253;
// method "visitGeneric(_)up(_)"
  block_savedest(obj1308);
  Object closure1352 = createclosure(1, "visitGeneric(1)up(1)");
  setclosureframe(closure1352, stackframe);
  addtoclosure(closure1352, var_visitation);
  struct UserObject *uo1352 = (struct UserObject*)obj1308;
  uo1352->data[15] = (Object)closure1352;
  Method *meth_meth_ast_1352_visitGeneric_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitGeneric(1)up(1)", &meth_ast_1352_visitGeneric_40_1_41_up_40_1_41_, 15);
  int argcv_meth_ast_1352_visitGeneric_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1352_visitGeneric_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1352_visitGeneric_40_1_41_up_40_1_41_);
  meth_meth_ast_1352_visitGeneric_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1352_visitGeneric_40_1_41_up_40_1_41_->definitionLine = 3254;
// method "visitIdentifier(_)up(_)"
  block_savedest(obj1308);
  Object closure1355 = createclosure(1, "visitIdentifier(1)up(1)");
  setclosureframe(closure1355, stackframe);
  addtoclosure(closure1355, var_visitation);
  struct UserObject *uo1355 = (struct UserObject*)obj1308;
  uo1355->data[16] = (Object)closure1355;
  Method *meth_meth_ast_1355_visitIdentifier_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitIdentifier(1)up(1)", &meth_ast_1355_visitIdentifier_40_1_41_up_40_1_41_, 16);
  int argcv_meth_ast_1355_visitIdentifier_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1355_visitIdentifier_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1355_visitIdentifier_40_1_41_up_40_1_41_);
  meth_meth_ast_1355_visitIdentifier_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1355_visitIdentifier_40_1_41_up_40_1_41_->definitionLine = 3255;
// method "visitString(_)up(_)"
  block_savedest(obj1308);
  Object closure1358 = createclosure(1, "visitString(1)up(1)");
  setclosureframe(closure1358, stackframe);
  addtoclosure(closure1358, var_visitation);
  struct UserObject *uo1358 = (struct UserObject*)obj1308;
  uo1358->data[17] = (Object)closure1358;
  Method *meth_meth_ast_1358_visitString_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitString(1)up(1)", &meth_ast_1358_visitString_40_1_41_up_40_1_41_, 17);
  int argcv_meth_ast_1358_visitString_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1358_visitString_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1358_visitString_40_1_41_up_40_1_41_);
  meth_meth_ast_1358_visitString_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1358_visitString_40_1_41_up_40_1_41_->definitionLine = 3256;
// method "visitNum(_)up(_)"
  block_savedest(obj1308);
  Object closure1361 = createclosure(1, "visitNum(1)up(1)");
  setclosureframe(closure1361, stackframe);
  addtoclosure(closure1361, var_visitation);
  struct UserObject *uo1361 = (struct UserObject*)obj1308;
  uo1361->data[18] = (Object)closure1361;
  Method *meth_meth_ast_1361_visitNum_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitNum(1)up(1)", &meth_ast_1361_visitNum_40_1_41_up_40_1_41_, 18);
  int argcv_meth_ast_1361_visitNum_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1361_visitNum_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1361_visitNum_40_1_41_up_40_1_41_);
  meth_meth_ast_1361_visitNum_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1361_visitNum_40_1_41_up_40_1_41_->definitionLine = 3257;
// method "visitOp(_)up(_)"
  block_savedest(obj1308);
  Object closure1364 = createclosure(1, "visitOp(1)up(1)");
  setclosureframe(closure1364, stackframe);
  addtoclosure(closure1364, var_visitation);
  struct UserObject *uo1364 = (struct UserObject*)obj1308;
  uo1364->data[19] = (Object)closure1364;
  Method *meth_meth_ast_1364_visitOp_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitOp(1)up(1)", &meth_ast_1364_visitOp_40_1_41_up_40_1_41_, 19);
  int argcv_meth_ast_1364_visitOp_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1364_visitOp_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1364_visitOp_40_1_41_up_40_1_41_);
  meth_meth_ast_1364_visitOp_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1364_visitOp_40_1_41_up_40_1_41_->definitionLine = 3258;
// method "visitBind(_)up(_)"
  block_savedest(obj1308);
  Object closure1367 = createclosure(1, "visitBind(1)up(1)");
  setclosureframe(closure1367, stackframe);
  addtoclosure(closure1367, var_visitation);
  struct UserObject *uo1367 = (struct UserObject*)obj1308;
  uo1367->data[20] = (Object)closure1367;
  Method *meth_meth_ast_1367_visitBind_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitBind(1)up(1)", &meth_ast_1367_visitBind_40_1_41_up_40_1_41_, 20);
  int argcv_meth_ast_1367_visitBind_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1367_visitBind_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1367_visitBind_40_1_41_up_40_1_41_);
  meth_meth_ast_1367_visitBind_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1367_visitBind_40_1_41_up_40_1_41_->definitionLine = 3259;
// method "visitDefDec(_)up(_)"
  block_savedest(obj1308);
  Object closure1370 = createclosure(1, "visitDefDec(1)up(1)");
  setclosureframe(closure1370, stackframe);
  addtoclosure(closure1370, var_visitation);
  struct UserObject *uo1370 = (struct UserObject*)obj1308;
  uo1370->data[21] = (Object)closure1370;
  Method *meth_meth_ast_1370_visitDefDec_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitDefDec(1)up(1)", &meth_ast_1370_visitDefDec_40_1_41_up_40_1_41_, 21);
  int argcv_meth_ast_1370_visitDefDec_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1370_visitDefDec_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1370_visitDefDec_40_1_41_up_40_1_41_);
  meth_meth_ast_1370_visitDefDec_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1370_visitDefDec_40_1_41_up_40_1_41_->definitionLine = 3260;
// method "visitVarDec(_)up(_)"
  block_savedest(obj1308);
  Object closure1373 = createclosure(1, "visitVarDec(1)up(1)");
  setclosureframe(closure1373, stackframe);
  addtoclosure(closure1373, var_visitation);
  struct UserObject *uo1373 = (struct UserObject*)obj1308;
  uo1373->data[22] = (Object)closure1373;
  Method *meth_meth_ast_1373_visitVarDec_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitVarDec(1)up(1)", &meth_ast_1373_visitVarDec_40_1_41_up_40_1_41_, 22);
  int argcv_meth_ast_1373_visitVarDec_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1373_visitVarDec_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1373_visitVarDec_40_1_41_up_40_1_41_);
  meth_meth_ast_1373_visitVarDec_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1373_visitVarDec_40_1_41_up_40_1_41_->definitionLine = 3261;
// method "visitImport(_)up(_)"
  block_savedest(obj1308);
  Object closure1376 = createclosure(1, "visitImport(1)up(1)");
  setclosureframe(closure1376, stackframe);
  addtoclosure(closure1376, var_visitation);
  struct UserObject *uo1376 = (struct UserObject*)obj1308;
  uo1376->data[23] = (Object)closure1376;
  Method *meth_meth_ast_1376_visitImport_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitImport(1)up(1)", &meth_ast_1376_visitImport_40_1_41_up_40_1_41_, 23);
  int argcv_meth_ast_1376_visitImport_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1376_visitImport_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1376_visitImport_40_1_41_up_40_1_41_);
  meth_meth_ast_1376_visitImport_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1376_visitImport_40_1_41_up_40_1_41_->definitionLine = 3262;
// method "visitReturn(_)up(_)"
  block_savedest(obj1308);
  Object closure1379 = createclosure(1, "visitReturn(1)up(1)");
  setclosureframe(closure1379, stackframe);
  addtoclosure(closure1379, var_visitation);
  struct UserObject *uo1379 = (struct UserObject*)obj1308;
  uo1379->data[24] = (Object)closure1379;
  Method *meth_meth_ast_1379_visitReturn_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitReturn(1)up(1)", &meth_ast_1379_visitReturn_40_1_41_up_40_1_41_, 24);
  int argcv_meth_ast_1379_visitReturn_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1379_visitReturn_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1379_visitReturn_40_1_41_up_40_1_41_);
  meth_meth_ast_1379_visitReturn_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1379_visitReturn_40_1_41_up_40_1_41_->definitionLine = 3263;
// method "visitInherits(_)up(_)"
  block_savedest(obj1308);
  Object closure1382 = createclosure(1, "visitInherits(1)up(1)");
  setclosureframe(closure1382, stackframe);
  addtoclosure(closure1382, var_visitation);
  struct UserObject *uo1382 = (struct UserObject*)obj1308;
  uo1382->data[25] = (Object)closure1382;
  Method *meth_meth_ast_1382_visitInherits_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitInherits(1)up(1)", &meth_ast_1382_visitInherits_40_1_41_up_40_1_41_, 25);
  int argcv_meth_ast_1382_visitInherits_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1382_visitInherits_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1382_visitInherits_40_1_41_up_40_1_41_);
  meth_meth_ast_1382_visitInherits_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1382_visitInherits_40_1_41_up_40_1_41_->definitionLine = 3264;
// method "visitDialect(_)up(_)"
  block_savedest(obj1308);
  Object closure1385 = createclosure(1, "visitDialect(1)up(1)");
  setclosureframe(closure1385, stackframe);
  addtoclosure(closure1385, var_visitation);
  struct UserObject *uo1385 = (struct UserObject*)obj1308;
  uo1385->data[26] = (Object)closure1385;
  Method *meth_meth_ast_1385_visitDialect_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitDialect(1)up(1)", &meth_ast_1385_visitDialect_40_1_41_up_40_1_41_, 26);
  int argcv_meth_ast_1385_visitDialect_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1385_visitDialect_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1385_visitDialect_40_1_41_up_40_1_41_);
  meth_meth_ast_1385_visitDialect_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1385_visitDialect_40_1_41_up_40_1_41_->definitionLine = 3265;
// method "visitComment(_)up(_)"
  block_savedest(obj1308);
  Object closure1388 = createclosure(1, "visitComment(1)up(1)");
  setclosureframe(closure1388, stackframe);
  addtoclosure(closure1388, var_visitation);
  struct UserObject *uo1388 = (struct UserObject*)obj1308;
  uo1388->data[27] = (Object)closure1388;
  Method *meth_meth_ast_1388_visitComment_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitComment(1)up(1)", &meth_ast_1388_visitComment_40_1_41_up_40_1_41_, 27);
  int argcv_meth_ast_1388_visitComment_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1388_visitComment_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1388_visitComment_40_1_41_up_40_1_41_);
  meth_meth_ast_1388_visitComment_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1388_visitComment_40_1_41_up_40_1_41_->definitionLine = 3266;
// method "visitImplicit(_)up(_)"
  block_savedest(obj1308);
  Object closure1391 = createclosure(1, "visitImplicit(1)up(1)");
  setclosureframe(closure1391, stackframe);
  addtoclosure(closure1391, var_visitation);
  struct UserObject *uo1391 = (struct UserObject*)obj1308;
  uo1391->data[28] = (Object)closure1391;
  Method *meth_meth_ast_1391_visitImplicit_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitImplicit(1)up(1)", &meth_ast_1391_visitImplicit_40_1_41_up_40_1_41_, 28);
  int argcv_meth_ast_1391_visitImplicit_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1391_visitImplicit_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1391_visitImplicit_40_1_41_up_40_1_41_);
  meth_meth_ast_1391_visitImplicit_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1391_visitImplicit_40_1_41_up_40_1_41_->definitionLine = 3267;
// method "visitOuter(_)up(_)"
  block_savedest(obj1308);
  Object closure1394 = createclosure(1, "visitOuter(1)up(1)");
  setclosureframe(closure1394, stackframe);
  addtoclosure(closure1394, var_visitation);
  struct UserObject *uo1394 = (struct UserObject*)obj1308;
  uo1394->data[29] = (Object)closure1394;
  Method *meth_meth_ast_1394_visitOuter_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitOuter(1)up(1)", &meth_ast_1394_visitOuter_40_1_41_up_40_1_41_, 29);
  int argcv_meth_ast_1394_visitOuter_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1394_visitOuter_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1394_visitOuter_40_1_41_up_40_1_41_);
  meth_meth_ast_1394_visitOuter_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1394_visitOuter_40_1_41_up_40_1_41_->definitionLine = 3268;
// method "asString"
  struct UserObject *uo1397 = (struct UserObject*)obj1308;
  uo1397->data[30] = emptyclosure;
  Method *meth_meth_ast_1397_asString = addmethod2pos(obj1308, "asString", &meth_ast_1397_asString, 30);
  int argcv_meth_ast_1397_asString[] = {0};
  meth_meth_ast_1397_asString->type = alloc_MethodType(1, argcv_meth_ast_1397_asString);
  meth_meth_ast_1397_asString->definitionModule = modulename;
  meth_meth_ast_1397_asString->definitionLine = 3270;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  objclass1308 = obj1308->class;
  objclass1308->definitionModule = modulename;
  objclass1308->definitionLine = 3233;
  (*(struct UserObject *)self).data[0] = lowerouter1308;
  self = oldself1308;
  selfslot = oldselfslot1308;
  stackframe = oldstackframe1308;
  gc_frame_end(frame);
  return obj1308;
}
Object meth_ast_1307_pluggableVisitor_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pluggableVisitor(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method pluggableVisitor(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pluggableVisitor(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitation = &(stackframe->slots[0]);
  *var_visitation = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pluggableVisitor(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1308 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1308 = alloc_userobj2(30,31, objclass1308);
  gc_frame_newslot(obj1308);
  if (objclass1308 == NULL) {
    glfree(obj1308->class->name);
    obj1308->class->name = "pluggableVisitor(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj1308, self, 0);
  addmethodreal(obj1308,"outer", &reader_ast_outer_1309);
  Object oldself1308 = self;
  struct StackFrameObject *oldstackframe1308 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1308);
  gc_frame_newslot((Object)stackframe);
  self = obj1308;
  Object *oldselfslot1308 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1308 = (*(struct UserObject *)self).data[0], lowerouter1308 = thisouter1308;
  if (inheritingObject1308) {
    struct UserObject *inho1308 = (struct UserObject *)inheritingObject1308;
    while (inho1308->super != GraceDefaultObject) inho1308 = (struct UserObject *)inho1308->super;
    inho1308->super = obj1308;
    self = inheritingObject1308;
    *selfslot = self;
    lowerouter1308 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1308;
  }
// method "visitIf(_)up(_)"
  block_savedest(obj1308);
  Object closure1310 = createclosure(1, "visitIf(1)up(1)");
  setclosureframe(closure1310, stackframe);
  addtoclosure(closure1310, var_visitation);
  struct UserObject *uo1310 = (struct UserObject*)obj1308;
  uo1310->data[1] = (Object)closure1310;
  Method *meth_meth_ast_1310_visitIf_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitIf(1)up(1)", &meth_ast_1310_visitIf_40_1_41_up_40_1_41_, 1);
  int argcv_meth_ast_1310_visitIf_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1310_visitIf_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1310_visitIf_40_1_41_up_40_1_41_);
  meth_meth_ast_1310_visitIf_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1310_visitIf_40_1_41_up_40_1_41_->definitionLine = 3240;
// method "visitBlock(_)up(_)"
  block_savedest(obj1308);
  Object closure1313 = createclosure(1, "visitBlock(1)up(1)");
  setclosureframe(closure1313, stackframe);
  addtoclosure(closure1313, var_visitation);
  struct UserObject *uo1313 = (struct UserObject*)obj1308;
  uo1313->data[2] = (Object)closure1313;
  Method *meth_meth_ast_1313_visitBlock_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitBlock(1)up(1)", &meth_ast_1313_visitBlock_40_1_41_up_40_1_41_, 2);
  int argcv_meth_ast_1313_visitBlock_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1313_visitBlock_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1313_visitBlock_40_1_41_up_40_1_41_);
  meth_meth_ast_1313_visitBlock_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1313_visitBlock_40_1_41_up_40_1_41_->definitionLine = 3241;
// method "visitMatchCase(_)up(_)"
  block_savedest(obj1308);
  Object closure1316 = createclosure(1, "visitMatchCase(1)up(1)");
  setclosureframe(closure1316, stackframe);
  addtoclosure(closure1316, var_visitation);
  struct UserObject *uo1316 = (struct UserObject*)obj1308;
  uo1316->data[3] = (Object)closure1316;
  Method *meth_meth_ast_1316_visitMatchCase_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitMatchCase(1)up(1)", &meth_ast_1316_visitMatchCase_40_1_41_up_40_1_41_, 3);
  int argcv_meth_ast_1316_visitMatchCase_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1316_visitMatchCase_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1316_visitMatchCase_40_1_41_up_40_1_41_);
  meth_meth_ast_1316_visitMatchCase_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1316_visitMatchCase_40_1_41_up_40_1_41_->definitionLine = 3242;
// method "visitTryCatch(_)up(_)"
  block_savedest(obj1308);
  Object closure1319 = createclosure(1, "visitTryCatch(1)up(1)");
  setclosureframe(closure1319, stackframe);
  addtoclosure(closure1319, var_visitation);
  struct UserObject *uo1319 = (struct UserObject*)obj1308;
  uo1319->data[4] = (Object)closure1319;
  Method *meth_meth_ast_1319_visitTryCatch_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitTryCatch(1)up(1)", &meth_ast_1319_visitTryCatch_40_1_41_up_40_1_41_, 4);
  int argcv_meth_ast_1319_visitTryCatch_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1319_visitTryCatch_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1319_visitTryCatch_40_1_41_up_40_1_41_);
  meth_meth_ast_1319_visitTryCatch_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1319_visitTryCatch_40_1_41_up_40_1_41_->definitionLine = 3243;
// method "visitMethodType(_)up(_)"
  block_savedest(obj1308);
  Object closure1322 = createclosure(1, "visitMethodType(1)up(1)");
  setclosureframe(closure1322, stackframe);
  addtoclosure(closure1322, var_visitation);
  struct UserObject *uo1322 = (struct UserObject*)obj1308;
  uo1322->data[5] = (Object)closure1322;
  Method *meth_meth_ast_1322_visitMethodType_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitMethodType(1)up(1)", &meth_ast_1322_visitMethodType_40_1_41_up_40_1_41_, 5);
  int argcv_meth_ast_1322_visitMethodType_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1322_visitMethodType_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1322_visitMethodType_40_1_41_up_40_1_41_);
  meth_meth_ast_1322_visitMethodType_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1322_visitMethodType_40_1_41_up_40_1_41_->definitionLine = 3244;
// method "visitSignaturePart(_)up(_)"
  block_savedest(obj1308);
  Object closure1325 = createclosure(1, "visitSignaturePart(1)up(1)");
  setclosureframe(closure1325, stackframe);
  addtoclosure(closure1325, var_visitation);
  struct UserObject *uo1325 = (struct UserObject*)obj1308;
  uo1325->data[6] = (Object)closure1325;
  Method *meth_meth_ast_1325_visitSignaturePart_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitSignaturePart(1)up(1)", &meth_ast_1325_visitSignaturePart_40_1_41_up_40_1_41_, 6);
  int argcv_meth_ast_1325_visitSignaturePart_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1325_visitSignaturePart_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1325_visitSignaturePart_40_1_41_up_40_1_41_);
  meth_meth_ast_1325_visitSignaturePart_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1325_visitSignaturePart_40_1_41_up_40_1_41_->definitionLine = 3245;
// method "visitTypeDec(_)up(_)"
  block_savedest(obj1308);
  Object closure1328 = createclosure(1, "visitTypeDec(1)up(1)");
  setclosureframe(closure1328, stackframe);
  addtoclosure(closure1328, var_visitation);
  struct UserObject *uo1328 = (struct UserObject*)obj1308;
  uo1328->data[7] = (Object)closure1328;
  Method *meth_meth_ast_1328_visitTypeDec_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitTypeDec(1)up(1)", &meth_ast_1328_visitTypeDec_40_1_41_up_40_1_41_, 7);
  int argcv_meth_ast_1328_visitTypeDec_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1328_visitTypeDec_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1328_visitTypeDec_40_1_41_up_40_1_41_);
  meth_meth_ast_1328_visitTypeDec_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1328_visitTypeDec_40_1_41_up_40_1_41_->definitionLine = 3246;
// method "visitTypeLiteral(_)up(_)"
  block_savedest(obj1308);
  Object closure1331 = createclosure(1, "visitTypeLiteral(1)up(1)");
  setclosureframe(closure1331, stackframe);
  addtoclosure(closure1331, var_visitation);
  struct UserObject *uo1331 = (struct UserObject*)obj1308;
  uo1331->data[8] = (Object)closure1331;
  Method *meth_meth_ast_1331_visitTypeLiteral_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitTypeLiteral(1)up(1)", &meth_ast_1331_visitTypeLiteral_40_1_41_up_40_1_41_, 8);
  int argcv_meth_ast_1331_visitTypeLiteral_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1331_visitTypeLiteral_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1331_visitTypeLiteral_40_1_41_up_40_1_41_);
  meth_meth_ast_1331_visitTypeLiteral_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1331_visitTypeLiteral_40_1_41_up_40_1_41_->definitionLine = 3247;
// method "visitMethod(_)up(_)"
  block_savedest(obj1308);
  Object closure1334 = createclosure(1, "visitMethod(1)up(1)");
  setclosureframe(closure1334, stackframe);
  addtoclosure(closure1334, var_visitation);
  struct UserObject *uo1334 = (struct UserObject*)obj1308;
  uo1334->data[9] = (Object)closure1334;
  Method *meth_meth_ast_1334_visitMethod_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitMethod(1)up(1)", &meth_ast_1334_visitMethod_40_1_41_up_40_1_41_, 9);
  int argcv_meth_ast_1334_visitMethod_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1334_visitMethod_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1334_visitMethod_40_1_41_up_40_1_41_);
  meth_meth_ast_1334_visitMethod_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1334_visitMethod_40_1_41_up_40_1_41_->definitionLine = 3248;
// method "visitCall(_)up(_)"
  block_savedest(obj1308);
  Object closure1337 = createclosure(1, "visitCall(1)up(1)");
  setclosureframe(closure1337, stackframe);
  addtoclosure(closure1337, var_visitation);
  struct UserObject *uo1337 = (struct UserObject*)obj1308;
  uo1337->data[10] = (Object)closure1337;
  Method *meth_meth_ast_1337_visitCall_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitCall(1)up(1)", &meth_ast_1337_visitCall_40_1_41_up_40_1_41_, 10);
  int argcv_meth_ast_1337_visitCall_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1337_visitCall_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1337_visitCall_40_1_41_up_40_1_41_);
  meth_meth_ast_1337_visitCall_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1337_visitCall_40_1_41_up_40_1_41_->definitionLine = 3249;
// method "visitObject(_)up(_)"
  block_savedest(obj1308);
  Object closure1340 = createclosure(1, "visitObject(1)up(1)");
  setclosureframe(closure1340, stackframe);
  addtoclosure(closure1340, var_visitation);
  struct UserObject *uo1340 = (struct UserObject*)obj1308;
  uo1340->data[11] = (Object)closure1340;
  Method *meth_meth_ast_1340_visitObject_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitObject(1)up(1)", &meth_ast_1340_visitObject_40_1_41_up_40_1_41_, 11);
  int argcv_meth_ast_1340_visitObject_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1340_visitObject_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1340_visitObject_40_1_41_up_40_1_41_);
  meth_meth_ast_1340_visitObject_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1340_visitObject_40_1_41_up_40_1_41_->definitionLine = 3250;
// method "visitModule(_)up(_)"
  block_savedest(obj1308);
  Object closure1343 = createclosure(1, "visitModule(1)up(1)");
  setclosureframe(closure1343, stackframe);
  addtoclosure(closure1343, var_visitation);
  struct UserObject *uo1343 = (struct UserObject*)obj1308;
  uo1343->data[12] = (Object)closure1343;
  Method *meth_meth_ast_1343_visitModule_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitModule(1)up(1)", &meth_ast_1343_visitModule_40_1_41_up_40_1_41_, 12);
  int argcv_meth_ast_1343_visitModule_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1343_visitModule_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1343_visitModule_40_1_41_up_40_1_41_);
  meth_meth_ast_1343_visitModule_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1343_visitModule_40_1_41_up_40_1_41_->definitionLine = 3251;
// method "visitArray(_)up(_)"
  block_savedest(obj1308);
  Object closure1346 = createclosure(1, "visitArray(1)up(1)");
  setclosureframe(closure1346, stackframe);
  addtoclosure(closure1346, var_visitation);
  struct UserObject *uo1346 = (struct UserObject*)obj1308;
  uo1346->data[13] = (Object)closure1346;
  Method *meth_meth_ast_1346_visitArray_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitArray(1)up(1)", &meth_ast_1346_visitArray_40_1_41_up_40_1_41_, 13);
  int argcv_meth_ast_1346_visitArray_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1346_visitArray_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1346_visitArray_40_1_41_up_40_1_41_);
  meth_meth_ast_1346_visitArray_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1346_visitArray_40_1_41_up_40_1_41_->definitionLine = 3252;
// method "visitMember(_)up(_)"
  block_savedest(obj1308);
  Object closure1349 = createclosure(1, "visitMember(1)up(1)");
  setclosureframe(closure1349, stackframe);
  addtoclosure(closure1349, var_visitation);
  struct UserObject *uo1349 = (struct UserObject*)obj1308;
  uo1349->data[14] = (Object)closure1349;
  Method *meth_meth_ast_1349_visitMember_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitMember(1)up(1)", &meth_ast_1349_visitMember_40_1_41_up_40_1_41_, 14);
  int argcv_meth_ast_1349_visitMember_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1349_visitMember_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1349_visitMember_40_1_41_up_40_1_41_);
  meth_meth_ast_1349_visitMember_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1349_visitMember_40_1_41_up_40_1_41_->definitionLine = 3253;
// method "visitGeneric(_)up(_)"
  block_savedest(obj1308);
  Object closure1352 = createclosure(1, "visitGeneric(1)up(1)");
  setclosureframe(closure1352, stackframe);
  addtoclosure(closure1352, var_visitation);
  struct UserObject *uo1352 = (struct UserObject*)obj1308;
  uo1352->data[15] = (Object)closure1352;
  Method *meth_meth_ast_1352_visitGeneric_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitGeneric(1)up(1)", &meth_ast_1352_visitGeneric_40_1_41_up_40_1_41_, 15);
  int argcv_meth_ast_1352_visitGeneric_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1352_visitGeneric_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1352_visitGeneric_40_1_41_up_40_1_41_);
  meth_meth_ast_1352_visitGeneric_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1352_visitGeneric_40_1_41_up_40_1_41_->definitionLine = 3254;
// method "visitIdentifier(_)up(_)"
  block_savedest(obj1308);
  Object closure1355 = createclosure(1, "visitIdentifier(1)up(1)");
  setclosureframe(closure1355, stackframe);
  addtoclosure(closure1355, var_visitation);
  struct UserObject *uo1355 = (struct UserObject*)obj1308;
  uo1355->data[16] = (Object)closure1355;
  Method *meth_meth_ast_1355_visitIdentifier_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitIdentifier(1)up(1)", &meth_ast_1355_visitIdentifier_40_1_41_up_40_1_41_, 16);
  int argcv_meth_ast_1355_visitIdentifier_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1355_visitIdentifier_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1355_visitIdentifier_40_1_41_up_40_1_41_);
  meth_meth_ast_1355_visitIdentifier_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1355_visitIdentifier_40_1_41_up_40_1_41_->definitionLine = 3255;
// method "visitString(_)up(_)"
  block_savedest(obj1308);
  Object closure1358 = createclosure(1, "visitString(1)up(1)");
  setclosureframe(closure1358, stackframe);
  addtoclosure(closure1358, var_visitation);
  struct UserObject *uo1358 = (struct UserObject*)obj1308;
  uo1358->data[17] = (Object)closure1358;
  Method *meth_meth_ast_1358_visitString_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitString(1)up(1)", &meth_ast_1358_visitString_40_1_41_up_40_1_41_, 17);
  int argcv_meth_ast_1358_visitString_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1358_visitString_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1358_visitString_40_1_41_up_40_1_41_);
  meth_meth_ast_1358_visitString_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1358_visitString_40_1_41_up_40_1_41_->definitionLine = 3256;
// method "visitNum(_)up(_)"
  block_savedest(obj1308);
  Object closure1361 = createclosure(1, "visitNum(1)up(1)");
  setclosureframe(closure1361, stackframe);
  addtoclosure(closure1361, var_visitation);
  struct UserObject *uo1361 = (struct UserObject*)obj1308;
  uo1361->data[18] = (Object)closure1361;
  Method *meth_meth_ast_1361_visitNum_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitNum(1)up(1)", &meth_ast_1361_visitNum_40_1_41_up_40_1_41_, 18);
  int argcv_meth_ast_1361_visitNum_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1361_visitNum_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1361_visitNum_40_1_41_up_40_1_41_);
  meth_meth_ast_1361_visitNum_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1361_visitNum_40_1_41_up_40_1_41_->definitionLine = 3257;
// method "visitOp(_)up(_)"
  block_savedest(obj1308);
  Object closure1364 = createclosure(1, "visitOp(1)up(1)");
  setclosureframe(closure1364, stackframe);
  addtoclosure(closure1364, var_visitation);
  struct UserObject *uo1364 = (struct UserObject*)obj1308;
  uo1364->data[19] = (Object)closure1364;
  Method *meth_meth_ast_1364_visitOp_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitOp(1)up(1)", &meth_ast_1364_visitOp_40_1_41_up_40_1_41_, 19);
  int argcv_meth_ast_1364_visitOp_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1364_visitOp_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1364_visitOp_40_1_41_up_40_1_41_);
  meth_meth_ast_1364_visitOp_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1364_visitOp_40_1_41_up_40_1_41_->definitionLine = 3258;
// method "visitBind(_)up(_)"
  block_savedest(obj1308);
  Object closure1367 = createclosure(1, "visitBind(1)up(1)");
  setclosureframe(closure1367, stackframe);
  addtoclosure(closure1367, var_visitation);
  struct UserObject *uo1367 = (struct UserObject*)obj1308;
  uo1367->data[20] = (Object)closure1367;
  Method *meth_meth_ast_1367_visitBind_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitBind(1)up(1)", &meth_ast_1367_visitBind_40_1_41_up_40_1_41_, 20);
  int argcv_meth_ast_1367_visitBind_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1367_visitBind_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1367_visitBind_40_1_41_up_40_1_41_);
  meth_meth_ast_1367_visitBind_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1367_visitBind_40_1_41_up_40_1_41_->definitionLine = 3259;
// method "visitDefDec(_)up(_)"
  block_savedest(obj1308);
  Object closure1370 = createclosure(1, "visitDefDec(1)up(1)");
  setclosureframe(closure1370, stackframe);
  addtoclosure(closure1370, var_visitation);
  struct UserObject *uo1370 = (struct UserObject*)obj1308;
  uo1370->data[21] = (Object)closure1370;
  Method *meth_meth_ast_1370_visitDefDec_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitDefDec(1)up(1)", &meth_ast_1370_visitDefDec_40_1_41_up_40_1_41_, 21);
  int argcv_meth_ast_1370_visitDefDec_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1370_visitDefDec_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1370_visitDefDec_40_1_41_up_40_1_41_);
  meth_meth_ast_1370_visitDefDec_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1370_visitDefDec_40_1_41_up_40_1_41_->definitionLine = 3260;
// method "visitVarDec(_)up(_)"
  block_savedest(obj1308);
  Object closure1373 = createclosure(1, "visitVarDec(1)up(1)");
  setclosureframe(closure1373, stackframe);
  addtoclosure(closure1373, var_visitation);
  struct UserObject *uo1373 = (struct UserObject*)obj1308;
  uo1373->data[22] = (Object)closure1373;
  Method *meth_meth_ast_1373_visitVarDec_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitVarDec(1)up(1)", &meth_ast_1373_visitVarDec_40_1_41_up_40_1_41_, 22);
  int argcv_meth_ast_1373_visitVarDec_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1373_visitVarDec_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1373_visitVarDec_40_1_41_up_40_1_41_);
  meth_meth_ast_1373_visitVarDec_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1373_visitVarDec_40_1_41_up_40_1_41_->definitionLine = 3261;
// method "visitImport(_)up(_)"
  block_savedest(obj1308);
  Object closure1376 = createclosure(1, "visitImport(1)up(1)");
  setclosureframe(closure1376, stackframe);
  addtoclosure(closure1376, var_visitation);
  struct UserObject *uo1376 = (struct UserObject*)obj1308;
  uo1376->data[23] = (Object)closure1376;
  Method *meth_meth_ast_1376_visitImport_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitImport(1)up(1)", &meth_ast_1376_visitImport_40_1_41_up_40_1_41_, 23);
  int argcv_meth_ast_1376_visitImport_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1376_visitImport_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1376_visitImport_40_1_41_up_40_1_41_);
  meth_meth_ast_1376_visitImport_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1376_visitImport_40_1_41_up_40_1_41_->definitionLine = 3262;
// method "visitReturn(_)up(_)"
  block_savedest(obj1308);
  Object closure1379 = createclosure(1, "visitReturn(1)up(1)");
  setclosureframe(closure1379, stackframe);
  addtoclosure(closure1379, var_visitation);
  struct UserObject *uo1379 = (struct UserObject*)obj1308;
  uo1379->data[24] = (Object)closure1379;
  Method *meth_meth_ast_1379_visitReturn_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitReturn(1)up(1)", &meth_ast_1379_visitReturn_40_1_41_up_40_1_41_, 24);
  int argcv_meth_ast_1379_visitReturn_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1379_visitReturn_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1379_visitReturn_40_1_41_up_40_1_41_);
  meth_meth_ast_1379_visitReturn_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1379_visitReturn_40_1_41_up_40_1_41_->definitionLine = 3263;
// method "visitInherits(_)up(_)"
  block_savedest(obj1308);
  Object closure1382 = createclosure(1, "visitInherits(1)up(1)");
  setclosureframe(closure1382, stackframe);
  addtoclosure(closure1382, var_visitation);
  struct UserObject *uo1382 = (struct UserObject*)obj1308;
  uo1382->data[25] = (Object)closure1382;
  Method *meth_meth_ast_1382_visitInherits_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitInherits(1)up(1)", &meth_ast_1382_visitInherits_40_1_41_up_40_1_41_, 25);
  int argcv_meth_ast_1382_visitInherits_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1382_visitInherits_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1382_visitInherits_40_1_41_up_40_1_41_);
  meth_meth_ast_1382_visitInherits_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1382_visitInherits_40_1_41_up_40_1_41_->definitionLine = 3264;
// method "visitDialect(_)up(_)"
  block_savedest(obj1308);
  Object closure1385 = createclosure(1, "visitDialect(1)up(1)");
  setclosureframe(closure1385, stackframe);
  addtoclosure(closure1385, var_visitation);
  struct UserObject *uo1385 = (struct UserObject*)obj1308;
  uo1385->data[26] = (Object)closure1385;
  Method *meth_meth_ast_1385_visitDialect_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitDialect(1)up(1)", &meth_ast_1385_visitDialect_40_1_41_up_40_1_41_, 26);
  int argcv_meth_ast_1385_visitDialect_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1385_visitDialect_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1385_visitDialect_40_1_41_up_40_1_41_);
  meth_meth_ast_1385_visitDialect_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1385_visitDialect_40_1_41_up_40_1_41_->definitionLine = 3265;
// method "visitComment(_)up(_)"
  block_savedest(obj1308);
  Object closure1388 = createclosure(1, "visitComment(1)up(1)");
  setclosureframe(closure1388, stackframe);
  addtoclosure(closure1388, var_visitation);
  struct UserObject *uo1388 = (struct UserObject*)obj1308;
  uo1388->data[27] = (Object)closure1388;
  Method *meth_meth_ast_1388_visitComment_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitComment(1)up(1)", &meth_ast_1388_visitComment_40_1_41_up_40_1_41_, 27);
  int argcv_meth_ast_1388_visitComment_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1388_visitComment_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1388_visitComment_40_1_41_up_40_1_41_);
  meth_meth_ast_1388_visitComment_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1388_visitComment_40_1_41_up_40_1_41_->definitionLine = 3266;
// method "visitImplicit(_)up(_)"
  block_savedest(obj1308);
  Object closure1391 = createclosure(1, "visitImplicit(1)up(1)");
  setclosureframe(closure1391, stackframe);
  addtoclosure(closure1391, var_visitation);
  struct UserObject *uo1391 = (struct UserObject*)obj1308;
  uo1391->data[28] = (Object)closure1391;
  Method *meth_meth_ast_1391_visitImplicit_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitImplicit(1)up(1)", &meth_ast_1391_visitImplicit_40_1_41_up_40_1_41_, 28);
  int argcv_meth_ast_1391_visitImplicit_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1391_visitImplicit_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1391_visitImplicit_40_1_41_up_40_1_41_);
  meth_meth_ast_1391_visitImplicit_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1391_visitImplicit_40_1_41_up_40_1_41_->definitionLine = 3267;
// method "visitOuter(_)up(_)"
  block_savedest(obj1308);
  Object closure1394 = createclosure(1, "visitOuter(1)up(1)");
  setclosureframe(closure1394, stackframe);
  addtoclosure(closure1394, var_visitation);
  struct UserObject *uo1394 = (struct UserObject*)obj1308;
  uo1394->data[29] = (Object)closure1394;
  Method *meth_meth_ast_1394_visitOuter_40_1_41_up_40_1_41_ = addmethod2pos(obj1308, "visitOuter(1)up(1)", &meth_ast_1394_visitOuter_40_1_41_up_40_1_41_, 29);
  int argcv_meth_ast_1394_visitOuter_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_1394_visitOuter_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1394_visitOuter_40_1_41_up_40_1_41_);
  meth_meth_ast_1394_visitOuter_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1394_visitOuter_40_1_41_up_40_1_41_->definitionLine = 3268;
// method "asString"
  struct UserObject *uo1397 = (struct UserObject*)obj1308;
  uo1397->data[30] = emptyclosure;
  Method *meth_meth_ast_1397_asString = addmethod2pos(obj1308, "asString", &meth_ast_1397_asString, 30);
  int argcv_meth_ast_1397_asString[] = {0};
  meth_meth_ast_1397_asString->type = alloc_MethodType(1, argcv_meth_ast_1397_asString);
  meth_meth_ast_1397_asString->definitionModule = modulename;
  meth_meth_ast_1397_asString->definitionLine = 3270;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  sourceObject = obj1308;
  objclass1308 = obj1308->class;
  objclass1308->definitionModule = modulename;
  objclass1308->definitionLine = 3233;
  (*(struct UserObject *)self).data[0] = lowerouter1308;
  self = oldself1308;
  selfslot = oldselfslot1308;
  stackframe = oldstackframe1308;
  gc_frame_end(frame);
  return obj1308;
}
Object meth_ast_1409__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_annName = getfromclosure(closure, 0);
  Object *var_ann = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3285
  setline(3285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_annName (depth = 8)
  int op_slot_right_1410 = gc_frame_newslot(*var_annName);
// starting to compile member node (depth = 8)
  int callframe1412 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ann (depth = 9)
  partcv[0] = 0;
  Object call1413 = callmethodflags(*var_ann, "value", 1, partcv, params, 0);
  gc_frame_end(callframe1412);
// compiled member node returning call1413 (depth = 8)
  int op_slot_left_1410 = gc_frame_newslot(call1413);
  params[0] = *var_annName;
  partcv[0] = 1;
  Object opresult1414 = callmethod(call1413, "==(1)", 1, partcv, params);
// compiled op node returning opresult1414 (depth = 7)
  gc_frame_end(frame);
  return opresult1414;
}
Object meth_ast_1405__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[2];
  Object *var_annName = getfromclosure(closure, 0);
  Object *var__prelude = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 3284
  setline(3284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block1408 = alloc_Block(NULL, NULL, "ast", 3284);
  gc_frame_newslot(block1408);
// method "_apply"
  block_savedest(block1408);
  Object closure1409 = createclosure(3, "_apply");
  setclosureframe(closure1409, stackframe);
  addtoclosure(closure1409, var_annName);
  addtoclosure(closure1409, var_ann);
  addtoclosure(closure1409, selfslot);
  struct UserObject *uo1409 = (struct UserObject*)block1408;
  uo1409->data[0] = (Object)closure1409;
  Method *meth_meth_ast_1409__apply = addmethod2pos(block1408, "_apply", &meth_ast_1409__apply, 0);
  int argcv_meth_ast_1409__apply[] = {0};
  meth_meth_ast_1409__apply->type = alloc_MethodType(1, argcv_meth_ast_1409__apply);
  meth_meth_ast_1409__apply->definitionModule = modulename;
  meth_meth_ast_1409__apply->definitionLine = 3050;
// compiled block node returning block1408 (depth = 6)
  int op_slot_right_1407 = gc_frame_newslot(block1408);
// Begin line 3284
  setline(3284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1418 == NULL) {
    strlit1418 = alloc_String("identifier");
    gc_root(strlit1418);
  }
// compiled string node returning strlit1418 (depth = 7)
  int op_slot_right_1417 = gc_frame_newslot(strlit1418);
// starting to compile member node (depth = 7)
  int callframe1420 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ann (depth = 8)
  partcv[0] = 0;
  Object call1421 = callmethodflags(*var_ann, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe1420);
// compiled member node returning call1421 (depth = 7)
  int op_slot_left_1417 = gc_frame_newslot(call1421);
  params[0] = strlit1418;
  partcv[0] = 1;
  Object opresult1422 = callmethod(call1421, "==(1)", 1, partcv, params);
// compiled op node returning opresult1422 (depth = 6)
  int op_slot_left_1407 = gc_frame_newslot(opresult1422);
  params[0] = block1408;
  partcv[0] = 1;
  Object opresult1423 = callmethod(opresult1422, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1423 (depth = 5)
  Object if1406 = done;
  if (istrue(opresult1423)) {
// Begin line 3286
  setline(3286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile object node (depth = 6)
  Object inheritingObject1424 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1424 = alloc_userobj2(1,2, objclass1424);
  gc_frame_newslot(obj1424);
// OBJECT OUTER DEC outer
  adddatum2(obj1424, self, 0);
  addmethodreal(obj1424,"outer", &reader_ast_outer_1425);
  Object oldself1424 = self;
  struct StackFrameObject *oldstackframe1424 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1424);
  gc_frame_newslot((Object)stackframe);
  self = obj1424;
  Object *oldselfslot1424 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1424 = (*(struct UserObject *)self).data[0], lowerouter1424 = thisouter1424;
  if (inheritingObject1424) {
    struct UserObject *inho1424 = (struct UserObject *)inheritingObject1424;
    while (inho1424->super != GraceDefaultObject) inho1424 = (struct UserObject *)inho1424->super;
    inho1424->super = obj1424;
    self = inheritingObject1424;
    *selfslot = self;
    lowerouter1424 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1424;
  }
  if (objclass1424 == NULL) {
  Method *reader1426 = addmethodrealflags(obj1424, "value",&reader_ast_value_1426, MFLAG_DEF);
  reader1426->definitionModule = modulename;
  reader1426->definitionLine = 3288;
  }
  adddatum2(obj1424, alloc_Undefined(), 1);
  sourceObject = obj1424;
// Begin line 3287
  setline(3287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1427 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning self (depth = 8)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var__prelude (depth = 8)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1428 = callmethodflags(*var__prelude, "true$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1427);
// compiled call node returning call1428 (depth = 7)
  struct UserObject *obj1424_uo = (struct UserObject *)obj1424;
  obj1424_uo->super = call1428;
  sourceObject = obj1424;
// Begin line 3288
  setline(3288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  adddatum2(obj1424, *var_ann, 1);
  objclass1424 = obj1424->class;
  objclass1424->definitionModule = modulename;
  objclass1424->definitionLine = 3286;
  (*(struct UserObject *)self).data[0] = lowerouter1424;
  self = oldself1424;
  selfslot = oldselfslot1424;
  stackframe = oldstackframe1424;
// compiled object node returning obj1424 (depth = 6)
  block_return(realself, obj1424);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if1406 = undefined;
  } else {
  }
// compiled if node returning if1406 (depth = 4)
  gc_frame_end(frame);
  return if1406;
}
Object meth_ast_1400_findAnnotation_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findAnnotation(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method findAnnotation(_,_)");
  Object params[2];
  int partcv[2];
  Object *var__prelude = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findAnnotation(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  Object *var_annName = &(stackframe->slots[1]);
  *var_annName = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part findAnnotation(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3283
  setline(3283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1401 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe1402 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_node (depth = 4)
  partcv[0] = 0;
  Object call1403 = callmethodflags(*var_node, "annotations", 1, partcv, params, 0);
  gc_frame_end(callframe1402);
// compiled member node returning call1403 (depth = 3)
  gc_frame_newslot(call1403);
// starting to compile block node (depth = 3)
  Object block1404 = alloc_Block(NULL, NULL, "ast", 3283);
  gc_frame_newslot(block1404);
// method "_apply(_)"
  block_savedest(block1404);
  Object closure1405 = createclosure(3, "_apply(1)");
  setclosureframe(closure1405, stackframe);
  addtoclosure(closure1405, var_annName);
  addtoclosure(closure1405, var__prelude);
  addtoclosure(closure1405, selfslot);
  struct UserObject *uo1405 = (struct UserObject*)block1404;
  uo1405->data[0] = (Object)closure1405;
  Method *meth_meth_ast_1405__apply_40_1_41_ = addmethod2pos(block1404, "_apply(1)", &meth_ast_1405__apply_40_1_41_, 0);
  int argcv_meth_ast_1405__apply_40_1_41_[] = {1};
  meth_meth_ast_1405__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1405__apply_40_1_41_);
  meth_meth_ast_1405__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1405__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block1404 (depth = 3)
  gc_frame_newslot(block1404);
// call case 5: prelude request
  params[0] = call1403;
  params[1] = block1404;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1430 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1401);
// compiled call node returning call1430 (depth = 2)
// Begin line 3292
  setline(3292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool1431 = alloc_Boolean(0);
// compiled identifier node returning bool1431 (depth = 2)
  gc_frame_end(frame);
  return bool1431;
}
Object meth_ast_1434_Position(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Position");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Position = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Position (depth = 3)
  gc_frame_end(frame);
  return *var_Position;
}
Object meth_ast_1437_Range(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Range");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Range = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Range (depth = 3)
  gc_frame_end(frame);
  return *var_Range;
}
Object meth_ast_1442_noPosition(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "noPosition");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noPosition = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 70
  setline(70);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_noPosition (depth = 3)
  gc_frame_end(frame);
  return *var_noPosition;
}
Object meth_ast_1445_emptyRange(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "emptyRange");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptyRange = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 71
  setline(71);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptyRange (depth = 3)
  gc_frame_end(frame);
  return *var_emptyRange;
}
Object meth_ast_1447_lineLength(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lineLength");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lineLength = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 106
  setline(106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lineLength (depth = 3)
  gc_frame_end(frame);
  return *var_lineLength;
}
Object meth_ast_1453_uninitialized(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "uninitialized");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_uninitialized = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 107
  setline(107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_uninitialized (depth = 3)
  gc_frame_end(frame);
  return *var_uninitialized;
}
Object meth_ast_1459_isEmpty(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 130
  setline(130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1460 = alloc_Boolean(1);
// compiled identifier node returning bool1460 (depth = 3)
  gc_frame_end(frame);
  return bool1460;
}
Object meth_ast_1461_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 131
  setline(131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1462 == NULL) {
    strlit1462 = alloc_String("ancestorChain ""\xe2""""\x96""""\xab""");
    gc_root(strlit1462);
  }
// compiled string node returning strlit1462 (depth = 3)
  gc_frame_end(frame);
  return strlit1462;
}
Object meth_ast_1463_extend_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "extend(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method extend(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for extend(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part extend(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 132
  setline(132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1464 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1465 = gc_frame_new();
// call case 3: self.outer request
  Object call1466 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1465);
// compiled member node returning call1466 (depth = 4)
  params[0] = *var_n;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1467 = callmethodflags(call1466, "cons(1)onto(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1464);
// compiled call node returning call1467 (depth = 3)
  gc_frame_end(frame);
  return call1467;
}
Object meth_ast_1456_empty(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "empty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1457 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1457 = alloc_userobj2(3,4, objclass1457);
  gc_frame_newslot(obj1457);
  if (objclass1457 == NULL) {
    glfree(obj1457->class->name);
    obj1457->class->name = "ancestorChain.empty";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj1457, self, 0);
  addmethodreal(obj1457,"outer", &reader_ast_outer_1458);
  Object oldself1457 = self;
  struct StackFrameObject *oldstackframe1457 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1457);
  gc_frame_newslot((Object)stackframe);
  self = obj1457;
  Object *oldselfslot1457 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1457 = (*(struct UserObject *)self).data[0], lowerouter1457 = thisouter1457;
  if (inheritingObject1457) {
    struct UserObject *inho1457 = (struct UserObject *)inheritingObject1457;
    while (inho1457->super != GraceDefaultObject) inho1457 = (struct UserObject *)inho1457->super;
    inho1457->super = obj1457;
    self = inheritingObject1457;
    *selfslot = self;
    lowerouter1457 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1457;
  }
// method "isEmpty"
  struct UserObject *uo1459 = (struct UserObject*)obj1457;
  uo1459->data[1] = emptyclosure;
  Method *meth_meth_ast_1459_isEmpty = addmethod2pos(obj1457, "isEmpty", &meth_ast_1459_isEmpty, 1);
  int argcv_meth_ast_1459_isEmpty[] = {0};
  meth_meth_ast_1459_isEmpty->type = alloc_MethodType(1, argcv_meth_ast_1459_isEmpty);
  meth_meth_ast_1459_isEmpty->definitionModule = modulename;
  meth_meth_ast_1459_isEmpty->definitionLine = 130;
// method "asString"
  struct UserObject *uo1461 = (struct UserObject*)obj1457;
  uo1461->data[2] = emptyclosure;
  Method *meth_meth_ast_1461_asString = addmethod2pos(obj1457, "asString", &meth_ast_1461_asString, 2);
  int argcv_meth_ast_1461_asString[] = {0};
  meth_meth_ast_1461_asString->type = alloc_MethodType(1, argcv_meth_ast_1461_asString);
  meth_meth_ast_1461_asString->definitionModule = modulename;
  meth_meth_ast_1461_asString->definitionLine = 131;
// method "extend(_)"
  struct UserObject *uo1463 = (struct UserObject*)obj1457;
  uo1463->data[3] = emptyclosure;
  Method *meth_meth_ast_1463_extend_40_1_41_ = addmethod2pos(obj1457, "extend(1)", &meth_ast_1463_extend_40_1_41_, 3);
  int argcv_meth_ast_1463_extend_40_1_41_[] = {1};
  meth_meth_ast_1463_extend_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1463_extend_40_1_41_);
  meth_meth_ast_1463_extend_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1463_extend_40_1_41_->definitionLine = 132;
  sourceObject = obj1457;
  sourceObject = obj1457;
  sourceObject = obj1457;
  objclass1457 = obj1457->class;
  objclass1457->definitionModule = modulename;
  objclass1457->definitionLine = 129;
  (*(struct UserObject *)self).data[0] = lowerouter1457;
  self = oldself1457;
  selfslot = oldselfslot1457;
  stackframe = oldstackframe1457;
  gc_frame_end(frame);
  return obj1457;
}
Object meth_ast_1456_empty_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "empty$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1457 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1457 = alloc_userobj2(3,4, objclass1457);
  gc_frame_newslot(obj1457);
  if (objclass1457 == NULL) {
    glfree(obj1457->class->name);
    obj1457->class->name = "ancestorChain.empty";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj1457, self, 0);
  addmethodreal(obj1457,"outer", &reader_ast_outer_1458);
  Object oldself1457 = self;
  struct StackFrameObject *oldstackframe1457 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1457);
  gc_frame_newslot((Object)stackframe);
  self = obj1457;
  Object *oldselfslot1457 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1457 = (*(struct UserObject *)self).data[0], lowerouter1457 = thisouter1457;
  if (inheritingObject1457) {
    struct UserObject *inho1457 = (struct UserObject *)inheritingObject1457;
    while (inho1457->super != GraceDefaultObject) inho1457 = (struct UserObject *)inho1457->super;
    inho1457->super = obj1457;
    self = inheritingObject1457;
    *selfslot = self;
    lowerouter1457 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1457;
  }
// method "isEmpty"
  struct UserObject *uo1459 = (struct UserObject*)obj1457;
  uo1459->data[1] = emptyclosure;
  Method *meth_meth_ast_1459_isEmpty = addmethod2pos(obj1457, "isEmpty", &meth_ast_1459_isEmpty, 1);
  int argcv_meth_ast_1459_isEmpty[] = {0};
  meth_meth_ast_1459_isEmpty->type = alloc_MethodType(1, argcv_meth_ast_1459_isEmpty);
  meth_meth_ast_1459_isEmpty->definitionModule = modulename;
  meth_meth_ast_1459_isEmpty->definitionLine = 130;
// method "asString"
  struct UserObject *uo1461 = (struct UserObject*)obj1457;
  uo1461->data[2] = emptyclosure;
  Method *meth_meth_ast_1461_asString = addmethod2pos(obj1457, "asString", &meth_ast_1461_asString, 2);
  int argcv_meth_ast_1461_asString[] = {0};
  meth_meth_ast_1461_asString->type = alloc_MethodType(1, argcv_meth_ast_1461_asString);
  meth_meth_ast_1461_asString->definitionModule = modulename;
  meth_meth_ast_1461_asString->definitionLine = 131;
// method "extend(_)"
  struct UserObject *uo1463 = (struct UserObject*)obj1457;
  uo1463->data[3] = emptyclosure;
  Method *meth_meth_ast_1463_extend_40_1_41_ = addmethod2pos(obj1457, "extend(1)", &meth_ast_1463_extend_40_1_41_, 3);
  int argcv_meth_ast_1463_extend_40_1_41_[] = {1};
  meth_meth_ast_1463_extend_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1463_extend_40_1_41_);
  meth_meth_ast_1463_extend_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1463_extend_40_1_41_->definitionLine = 132;
  sourceObject = obj1457;
  sourceObject = obj1457;
  sourceObject = obj1457;
  objclass1457 = obj1457->class;
  objclass1457->definitionModule = modulename;
  objclass1457->definitionLine = 129;
  (*(struct UserObject *)self).data[0] = lowerouter1457;
  self = oldself1457;
  selfslot = oldselfslot1457;
  stackframe = oldstackframe1457;
  gc_frame_end(frame);
  return obj1457;
}
Object meth_ast_1469_with_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "with(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method with(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for with(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part with(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 134
  setline(134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1470 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1471 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1472 = callmethodflags(self, "empty", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1471);
// compiled member node returning call1472 (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1473 = callmethodflags(call1472, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1470);
// compiled call node returning call1473 (depth = 3)
  gc_frame_end(frame);
  return call1473;
}
Object meth_ast_1477_forebears(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "forebears");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_as = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_end(frame);
  return *var_as;
}
Object meth_ast_1478_isEmpty(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 137
  setline(137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1479 = alloc_Boolean(0);
// compiled identifier node returning bool1479 (depth = 3)
  gc_frame_end(frame);
  return bool1479;
}
Object meth_ast_1480_parent(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_p = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 138
  setline(138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_p (depth = 3)
  gc_frame_end(frame);
  return *var_p;
}
Object meth_ast_1481_grandparent(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "grandparent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1482 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1483 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1484 = callmethodflags(self, "forebears", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1483);
// compiled member node returning call1484 (depth = 4)
  partcv[0] = 0;
  Object call1485 = callmethodflags(call1484, "parent", 1, partcv, params, 0);
  gc_frame_end(callframe1482);
// compiled member node returning call1485 (depth = 3)
  gc_frame_end(frame);
  return call1485;
}
Object meth_ast_1490__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 5)
  int callframe1491 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1492 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  partcv[0] = 0;
  Object call1493 = callmethodflags(*var_a, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe1492);
// compiled member node returning call1493 (depth = 6)
  partcv[0] = 0;
  Object call1494 = callmethodflags(call1493, "not", 1, partcv, params, 0);
  gc_frame_end(callframe1491);
// compiled member node returning call1494 (depth = 5)
  gc_frame_end(frame);
  return call1494;
}
Object meth_ast_1497__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1499 == NULL) {
    strlit1499 = alloc_String("""\xe2""""\x9e""""\xa4""");
    gc_root(strlit1499);
  }
// compiled string node returning strlit1499 (depth = 7)
  int op_slot_right_1498 = gc_frame_newslot(strlit1499);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1502 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  partcv[0] = 0;
  Object call1503 = callmethodflags(*var_a, "parent", 1, partcv, params, 0);
  gc_frame_end(callframe1502);
// compiled member node returning call1503 (depth = 8)
  int op_slot_right_1501 = gc_frame_newslot(call1503);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1501 = gc_frame_newslot(*var_s);
  params[0] = call1503;
  partcv[0] = 1;
  Object opresult1505 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1505 (depth = 7)
  int op_slot_left_1498 = gc_frame_newslot(opresult1505);
  params[0] = strlit1499;
  partcv[0] = 1;
  Object opresult1506 = callmethod(opresult1505, "++(1)", 1, partcv, params);
// compiled op node returning opresult1506 (depth = 6)
  *var_s = opresult1506;
  if (opresult1506 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1508 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  partcv[0] = 0;
  Object call1509 = callmethodflags(*var_a, "forebears", 1, partcv, params, 0);
  gc_frame_end(callframe1508);
// compiled member node returning call1509 (depth = 6)
  *var_a = call1509;
  if (call1509 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_1486_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_a = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "a");
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  *var_a = self;
  if (self == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1487 == NULL) {
    strlit1487 = alloc_String("ancestorChain ");
    gc_root(strlit1487);
  }
// compiled string node returning strlit1487 (depth = 4)
  *var_s = strlit1487;
  if (strlit1487 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 144
  setline(144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1488 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block1489 = alloc_Block(NULL, NULL, "ast", 144);
  gc_frame_newslot(block1489);
// method "_apply"
  block_savedest(block1489);
  Object closure1490 = createclosure(2, "_apply");
  setclosureframe(closure1490, stackframe);
  addtoclosure(closure1490, var_a);
  addtoclosure(closure1490, selfslot);
  struct UserObject *uo1490 = (struct UserObject*)block1489;
  uo1490->data[0] = (Object)closure1490;
  Method *meth_meth_ast_1490__apply = addmethod2pos(block1489, "_apply", &meth_ast_1490__apply, 0);
  int argcv_meth_ast_1490__apply[] = {0};
  meth_meth_ast_1490__apply->type = alloc_MethodType(1, argcv_meth_ast_1490__apply);
  meth_meth_ast_1490__apply->definitionModule = modulename;
  meth_meth_ast_1490__apply->definitionLine = 3050;
// compiled block node returning block1489 (depth = 4)
  gc_frame_newslot(block1489);
// starting to compile block node (depth = 4)
  Object block1496 = alloc_Block(NULL, NULL, "ast", 144);
  gc_frame_newslot(block1496);
// method "_apply"
  block_savedest(block1496);
  Object closure1497 = createclosure(3, "_apply");
  setclosureframe(closure1497, stackframe);
  addtoclosure(closure1497, var_a);
  addtoclosure(closure1497, var_s);
  addtoclosure(closure1497, selfslot);
  struct UserObject *uo1497 = (struct UserObject*)block1496;
  uo1497->data[0] = (Object)closure1497;
  Method *meth_meth_ast_1497__apply = addmethod2pos(block1496, "_apply", &meth_ast_1497__apply, 0);
  int argcv_meth_ast_1497__apply[] = {0};
  meth_meth_ast_1497__apply->type = alloc_MethodType(1, argcv_meth_ast_1497__apply);
  meth_meth_ast_1497__apply->definitionModule = modulename;
  meth_meth_ast_1497__apply->definitionLine = 3050;
// compiled block node returning block1496 (depth = 4)
  gc_frame_newslot(block1496);
// call case 5: prelude request
  params[0] = block1489;
  params[1] = block1496;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1512 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1488);
// compiled call node returning call1512 (depth = 3)
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1514 == NULL) {
    strlit1514 = alloc_String("""\xe2""""\x96""""\xab""");
    gc_root(strlit1514);
  }
// compiled string node returning strlit1514 (depth = 4)
  int op_slot_right_1513 = gc_frame_newslot(strlit1514);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_1513 = gc_frame_newslot(*var_s);
  params[0] = strlit1514;
  partcv[0] = 1;
  Object opresult1516 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1516 (depth = 3)
  gc_frame_end(frame);
  return opresult1516;
}
Object meth_ast_1520__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 5)
  int callframe1521 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1522 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  partcv[0] = 0;
  Object call1523 = callmethodflags(*var_a, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe1522);
// compiled member node returning call1523 (depth = 6)
  partcv[0] = 0;
  Object call1524 = callmethodflags(call1523, "not", 1, partcv, params, 0);
  gc_frame_end(callframe1521);
// compiled member node returning call1524 (depth = 5)
  gc_frame_end(frame);
  return call1524;
}
Object meth_ast_1527__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object *var_cond = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1529 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe1530 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call1531 = callmethodflags(*var_a, "parent", 1, partcv, params, 0);
  gc_frame_end(callframe1530);
// compiled member node returning call1531 (depth = 7)
  gc_frame_newslot(call1531);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_cond (depth = 7)
  params[0] = call1531;
  partcv[0] = 1;
  Object call1532 = callmethodflags(*var_cond, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1529);
// compiled call node returning call1532 (depth = 6)
  Object if1528 = done;
  if (istrue(call1532)) {
// starting to compile return node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe1533 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call1534 = callmethodflags(*var_a, "parent", 1, partcv, params, 0);
  gc_frame_end(callframe1533);
// compiled member node returning call1534 (depth = 7)
  block_return(realself, call1534);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if1528 = undefined;
  } else {
  }
// compiled if node returning if1528 (depth = 5)
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1535 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  partcv[0] = 0;
  Object call1536 = callmethodflags(*var_a, "forebears", 1, partcv, params, 0);
  gc_frame_end(callframe1535);
// compiled member node returning call1536 (depth = 6)
  *var_a = call1536;
  if (call1536 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_1517_suchThat_40_1_41_ifAbsent_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "suchThat(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method suchThat(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method suchThat(_)ifAbsent(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for suchThat(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part suchThat(_)");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_a = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "a");
// Begin line 151
  setline(151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  *var_a = self;
  if (self == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1518 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block1519 = alloc_Block(NULL, NULL, "ast", 152);
  gc_frame_newslot(block1519);
// method "_apply"
  block_savedest(block1519);
  Object closure1520 = createclosure(2, "_apply");
  setclosureframe(closure1520, stackframe);
  addtoclosure(closure1520, var_a);
  addtoclosure(closure1520, selfslot);
  struct UserObject *uo1520 = (struct UserObject*)block1519;
  uo1520->data[0] = (Object)closure1520;
  Method *meth_meth_ast_1520__apply = addmethod2pos(block1519, "_apply", &meth_ast_1520__apply, 0);
  int argcv_meth_ast_1520__apply[] = {0};
  meth_meth_ast_1520__apply->type = alloc_MethodType(1, argcv_meth_ast_1520__apply);
  meth_meth_ast_1520__apply->definitionModule = modulename;
  meth_meth_ast_1520__apply->definitionLine = 3050;
// compiled block node returning block1519 (depth = 4)
  gc_frame_newslot(block1519);
// starting to compile block node (depth = 4)
  Object block1526 = alloc_Block(NULL, NULL, "ast", 152);
  gc_frame_newslot(block1526);
// method "_apply"
  block_savedest(block1526);
  Object closure1527 = createclosure(3, "_apply");
  setclosureframe(closure1527, stackframe);
  addtoclosure(closure1527, var_a);
  addtoclosure(closure1527, var_cond);
  addtoclosure(closure1527, selfslot);
  struct UserObject *uo1527 = (struct UserObject*)block1526;
  uo1527->data[0] = (Object)closure1527;
  Method *meth_meth_ast_1527__apply = addmethod2pos(block1526, "_apply", &meth_ast_1527__apply, 0);
  int argcv_meth_ast_1527__apply[] = {0};
  meth_meth_ast_1527__apply->type = alloc_MethodType(1, argcv_meth_ast_1527__apply);
  meth_meth_ast_1527__apply->definitionModule = modulename;
  meth_meth_ast_1527__apply->definitionLine = 3050;
// compiled block node returning block1526 (depth = 4)
  gc_frame_newslot(block1526);
// call case 5: prelude request
  params[0] = block1519;
  params[1] = block1526;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1539 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1518);
// compiled call node returning call1539 (depth = 3)
// Begin line 156
  setline(156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1540 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_action (depth = 4)
  partcv[0] = 0;
  Object call1541 = callmethodflags(*var_action, "apply", 1, partcv, params, 0);
  gc_frame_end(callframe1540);
// compiled member node returning call1541 (depth = 3)
  gc_frame_end(frame);
  return call1541;
}
Object meth_ast_1542_extend_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "extend(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method extend(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for extend(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part extend(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 158
  setline(158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1543 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1544 = gc_frame_new();
// call case 3: self.outer request
  Object call1545 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1544);
// compiled member node returning call1545 (depth = 4)
  params[0] = *var_n;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1546 = callmethodflags(call1545, "cons(1)onto(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1543);
// compiled call node returning call1546 (depth = 3)
  gc_frame_end(frame);
  return call1546;
}
Object meth_ast_1474_cons_40_1_41_onto_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "cons(1)onto(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method cons(_)onto(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method cons(_)onto(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for cons(_)onto(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part cons(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onto(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1475 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1475 = alloc_userobj2(7,8, objclass1475);
  gc_frame_newslot(obj1475);
  if (objclass1475 == NULL) {
    glfree(obj1475->class->name);
    obj1475->class->name = "ancestorChain.cons(_)onto(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj1475, self, 0);
  addmethodreal(obj1475,"outer", &reader_ast_outer_1476);
  Object oldself1475 = self;
  struct StackFrameObject *oldstackframe1475 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1475);
  gc_frame_newslot((Object)stackframe);
  self = obj1475;
  Object *oldselfslot1475 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1475 = (*(struct UserObject *)self).data[0], lowerouter1475 = thisouter1475;
  if (inheritingObject1475) {
    struct UserObject *inho1475 = (struct UserObject *)inheritingObject1475;
    while (inho1475->super != GraceDefaultObject) inho1475 = (struct UserObject *)inho1475->super;
    inho1475->super = obj1475;
    self = inheritingObject1475;
    *selfslot = self;
    lowerouter1475 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1475;
  }
// method "forebears"
  block_savedest(obj1475);
  Object closure1477 = createclosure(1, "forebears");
  setclosureframe(closure1477, stackframe);
  addtoclosure(closure1477, var_as);
  struct UserObject *uo1477 = (struct UserObject*)obj1475;
  uo1477->data[1] = (Object)closure1477;
  Method *meth_meth_ast_1477_forebears = addmethod2pos(obj1475, "forebears", &meth_ast_1477_forebears, 1);
  int argcv_meth_ast_1477_forebears[] = {0};
  meth_meth_ast_1477_forebears->type = alloc_MethodType(1, argcv_meth_ast_1477_forebears);
  meth_meth_ast_1477_forebears->definitionModule = modulename;
  meth_meth_ast_1477_forebears->definitionLine = 136;
// method "isEmpty"
  struct UserObject *uo1478 = (struct UserObject*)obj1475;
  uo1478->data[2] = emptyclosure;
  Method *meth_meth_ast_1478_isEmpty = addmethod2pos(obj1475, "isEmpty", &meth_ast_1478_isEmpty, 2);
  int argcv_meth_ast_1478_isEmpty[] = {0};
  meth_meth_ast_1478_isEmpty->type = alloc_MethodType(1, argcv_meth_ast_1478_isEmpty);
  meth_meth_ast_1478_isEmpty->definitionModule = modulename;
  meth_meth_ast_1478_isEmpty->definitionLine = 137;
// method "parent"
  block_savedest(obj1475);
  Object closure1480 = createclosure(1, "parent");
  setclosureframe(closure1480, stackframe);
  addtoclosure(closure1480, var_p);
  struct UserObject *uo1480 = (struct UserObject*)obj1475;
  uo1480->data[3] = (Object)closure1480;
  Method *meth_meth_ast_1480_parent = addmethod2pos(obj1475, "parent", &meth_ast_1480_parent, 3);
  int argcv_meth_ast_1480_parent[] = {0};
  meth_meth_ast_1480_parent->type = alloc_MethodType(1, argcv_meth_ast_1480_parent);
  meth_meth_ast_1480_parent->definitionModule = modulename;
  meth_meth_ast_1480_parent->definitionLine = 138;
// method "grandparent"
  struct UserObject *uo1481 = (struct UserObject*)obj1475;
  uo1481->data[4] = emptyclosure;
  Method *meth_meth_ast_1481_grandparent = addmethod2pos(obj1475, "grandparent", &meth_ast_1481_grandparent, 4);
  int argcv_meth_ast_1481_grandparent[] = {0};
  meth_meth_ast_1481_grandparent->type = alloc_MethodType(1, argcv_meth_ast_1481_grandparent);
  meth_meth_ast_1481_grandparent->definitionModule = modulename;
  meth_meth_ast_1481_grandparent->definitionLine = 139;
// method "asString"
  struct UserObject *uo1486 = (struct UserObject*)obj1475;
  uo1486->data[5] = emptyclosure;
  Method *meth_meth_ast_1486_asString = addmethod2pos(obj1475, "asString", &meth_ast_1486_asString, 5);
  int argcv_meth_ast_1486_asString[] = {0};
  meth_meth_ast_1486_asString->type = alloc_MethodType(1, argcv_meth_ast_1486_asString);
  meth_meth_ast_1486_asString->definitionModule = modulename;
  meth_meth_ast_1486_asString->definitionLine = 141;
// method "suchThat(_)ifAbsent(_)"
  struct UserObject *uo1517 = (struct UserObject*)obj1475;
  uo1517->data[6] = emptyclosure;
  Method *meth_meth_ast_1517_suchThat_40_1_41_ifAbsent_40_1_41_ = addmethod2pos(obj1475, "suchThat(1)ifAbsent(1)", &meth_ast_1517_suchThat_40_1_41_ifAbsent_40_1_41_, 6);
  int argcv_meth_ast_1517_suchThat_40_1_41_ifAbsent_40_1_41_[] = {1, 1};
  meth_meth_ast_1517_suchThat_40_1_41_ifAbsent_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1517_suchThat_40_1_41_ifAbsent_40_1_41_);
  meth_meth_ast_1517_suchThat_40_1_41_ifAbsent_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1517_suchThat_40_1_41_ifAbsent_40_1_41_->definitionLine = 150;
// method "extend(_)"
  struct UserObject *uo1542 = (struct UserObject*)obj1475;
  uo1542->data[7] = emptyclosure;
  Method *meth_meth_ast_1542_extend_40_1_41_ = addmethod2pos(obj1475, "extend(1)", &meth_ast_1542_extend_40_1_41_, 7);
  int argcv_meth_ast_1542_extend_40_1_41_[] = {1};
  meth_meth_ast_1542_extend_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1542_extend_40_1_41_);
  meth_meth_ast_1542_extend_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1542_extend_40_1_41_->definitionLine = 158;
  sourceObject = obj1475;
  sourceObject = obj1475;
  sourceObject = obj1475;
  sourceObject = obj1475;
  sourceObject = obj1475;
  sourceObject = obj1475;
  sourceObject = obj1475;
  objclass1475 = obj1475->class;
  objclass1475->definitionModule = modulename;
  objclass1475->definitionLine = 135;
  (*(struct UserObject *)self).data[0] = lowerouter1475;
  self = oldself1475;
  selfslot = oldselfslot1475;
  stackframe = oldstackframe1475;
  gc_frame_end(frame);
  return obj1475;
}
Object meth_ast_1474_cons_40_1_41_onto_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "cons(1)onto(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method cons(_)onto(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method cons(_)onto(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for cons(_)onto(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part cons(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onto(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1475 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1475 = alloc_userobj2(7,8, objclass1475);
  gc_frame_newslot(obj1475);
  if (objclass1475 == NULL) {
    glfree(obj1475->class->name);
    obj1475->class->name = "ancestorChain.cons(_)onto(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj1475, self, 0);
  addmethodreal(obj1475,"outer", &reader_ast_outer_1476);
  Object oldself1475 = self;
  struct StackFrameObject *oldstackframe1475 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1475);
  gc_frame_newslot((Object)stackframe);
  self = obj1475;
  Object *oldselfslot1475 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1475 = (*(struct UserObject *)self).data[0], lowerouter1475 = thisouter1475;
  if (inheritingObject1475) {
    struct UserObject *inho1475 = (struct UserObject *)inheritingObject1475;
    while (inho1475->super != GraceDefaultObject) inho1475 = (struct UserObject *)inho1475->super;
    inho1475->super = obj1475;
    self = inheritingObject1475;
    *selfslot = self;
    lowerouter1475 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1475;
  }
// method "forebears"
  block_savedest(obj1475);
  Object closure1477 = createclosure(1, "forebears");
  setclosureframe(closure1477, stackframe);
  addtoclosure(closure1477, var_as);
  struct UserObject *uo1477 = (struct UserObject*)obj1475;
  uo1477->data[1] = (Object)closure1477;
  Method *meth_meth_ast_1477_forebears = addmethod2pos(obj1475, "forebears", &meth_ast_1477_forebears, 1);
  int argcv_meth_ast_1477_forebears[] = {0};
  meth_meth_ast_1477_forebears->type = alloc_MethodType(1, argcv_meth_ast_1477_forebears);
  meth_meth_ast_1477_forebears->definitionModule = modulename;
  meth_meth_ast_1477_forebears->definitionLine = 136;
// method "isEmpty"
  struct UserObject *uo1478 = (struct UserObject*)obj1475;
  uo1478->data[2] = emptyclosure;
  Method *meth_meth_ast_1478_isEmpty = addmethod2pos(obj1475, "isEmpty", &meth_ast_1478_isEmpty, 2);
  int argcv_meth_ast_1478_isEmpty[] = {0};
  meth_meth_ast_1478_isEmpty->type = alloc_MethodType(1, argcv_meth_ast_1478_isEmpty);
  meth_meth_ast_1478_isEmpty->definitionModule = modulename;
  meth_meth_ast_1478_isEmpty->definitionLine = 137;
// method "parent"
  block_savedest(obj1475);
  Object closure1480 = createclosure(1, "parent");
  setclosureframe(closure1480, stackframe);
  addtoclosure(closure1480, var_p);
  struct UserObject *uo1480 = (struct UserObject*)obj1475;
  uo1480->data[3] = (Object)closure1480;
  Method *meth_meth_ast_1480_parent = addmethod2pos(obj1475, "parent", &meth_ast_1480_parent, 3);
  int argcv_meth_ast_1480_parent[] = {0};
  meth_meth_ast_1480_parent->type = alloc_MethodType(1, argcv_meth_ast_1480_parent);
  meth_meth_ast_1480_parent->definitionModule = modulename;
  meth_meth_ast_1480_parent->definitionLine = 138;
// method "grandparent"
  struct UserObject *uo1481 = (struct UserObject*)obj1475;
  uo1481->data[4] = emptyclosure;
  Method *meth_meth_ast_1481_grandparent = addmethod2pos(obj1475, "grandparent", &meth_ast_1481_grandparent, 4);
  int argcv_meth_ast_1481_grandparent[] = {0};
  meth_meth_ast_1481_grandparent->type = alloc_MethodType(1, argcv_meth_ast_1481_grandparent);
  meth_meth_ast_1481_grandparent->definitionModule = modulename;
  meth_meth_ast_1481_grandparent->definitionLine = 139;
// method "asString"
  struct UserObject *uo1486 = (struct UserObject*)obj1475;
  uo1486->data[5] = emptyclosure;
  Method *meth_meth_ast_1486_asString = addmethod2pos(obj1475, "asString", &meth_ast_1486_asString, 5);
  int argcv_meth_ast_1486_asString[] = {0};
  meth_meth_ast_1486_asString->type = alloc_MethodType(1, argcv_meth_ast_1486_asString);
  meth_meth_ast_1486_asString->definitionModule = modulename;
  meth_meth_ast_1486_asString->definitionLine = 141;
// method "suchThat(_)ifAbsent(_)"
  struct UserObject *uo1517 = (struct UserObject*)obj1475;
  uo1517->data[6] = emptyclosure;
  Method *meth_meth_ast_1517_suchThat_40_1_41_ifAbsent_40_1_41_ = addmethod2pos(obj1475, "suchThat(1)ifAbsent(1)", &meth_ast_1517_suchThat_40_1_41_ifAbsent_40_1_41_, 6);
  int argcv_meth_ast_1517_suchThat_40_1_41_ifAbsent_40_1_41_[] = {1, 1};
  meth_meth_ast_1517_suchThat_40_1_41_ifAbsent_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1517_suchThat_40_1_41_ifAbsent_40_1_41_);
  meth_meth_ast_1517_suchThat_40_1_41_ifAbsent_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1517_suchThat_40_1_41_ifAbsent_40_1_41_->definitionLine = 150;
// method "extend(_)"
  struct UserObject *uo1542 = (struct UserObject*)obj1475;
  uo1542->data[7] = emptyclosure;
  Method *meth_meth_ast_1542_extend_40_1_41_ = addmethod2pos(obj1475, "extend(1)", &meth_ast_1542_extend_40_1_41_, 7);
  int argcv_meth_ast_1542_extend_40_1_41_[] = {1};
  meth_meth_ast_1542_extend_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1542_extend_40_1_41_);
  meth_meth_ast_1542_extend_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1542_extend_40_1_41_->definitionLine = 158;
  sourceObject = obj1475;
  sourceObject = obj1475;
  sourceObject = obj1475;
  sourceObject = obj1475;
  sourceObject = obj1475;
  sourceObject = obj1475;
  sourceObject = obj1475;
  objclass1475 = obj1475->class;
  objclass1475->definitionModule = modulename;
  objclass1475->definitionLine = 135;
  (*(struct UserObject *)self).data[0] = lowerouter1475;
  self = oldself1475;
  selfslot = oldselfslot1475;
  stackframe = oldstackframe1475;
  gc_frame_end(frame);
  return obj1475;
}
Object meth_ast_1548_ancestorChain(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ancestorChain");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ancestorChain = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 128
  setline(128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ancestorChain (depth = 3)
  gc_frame_end(frame);
  return *var_ancestorChain;
}
Object meth_ast_1551_emptySeq(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "emptySeq");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 162
  setline(162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySeq (depth = 3)
  gc_frame_end(frame);
  return *var_emptySeq;
}
Object meth_ast_1554_AstNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "AstNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_AstNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 164
  setline(164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_AstNode (depth = 3)
  gc_frame_end(frame);
  return *var_AstNode;
}
Object meth_ast_1556_SymbolTable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "SymbolTable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SymbolTable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 190
  setline(190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SymbolTable (depth = 3)
  gc_frame_end(frame);
  return *var_SymbolTable;
}
Object meth_ast_1561_range(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "range");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptyRange = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 337
  setline(337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptyRange (depth = 3)
  gc_frame_end(frame);
  return *var_emptyRange;
}
Object meth_ast_1562_isImplicit(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isImplicit");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 338
  setline(338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1563 = alloc_Boolean(1);
// compiled identifier node returning bool1563 (depth = 3)
  gc_frame_end(frame);
  return bool1563;
}
Object meth_ast_1564_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 339
  setline(339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1565 == NULL) {
    strlit1565 = alloc_String("implicit");
    gc_root(strlit1565);
  }
// compiled string node returning strlit1565 (depth = 3)
  gc_frame_end(frame);
  return strlit1565;
}
Object meth_ast_1566_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 340
  setline(340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1567 == NULL) {
    strlit1567 = alloc_String("the implicit receiver");
    gc_root(strlit1567);
  }
// compiled string node returning strlit1567 (depth = 3)
  gc_frame_end(frame);
  return strlit1567;
}
Object meth_ast_1568__61__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1569 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 4: self request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call1570 = callmethodflags(self, "isMe(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1569);
// compiled call node returning call1570 (depth = 3)
  gc_frame_end(frame);
  return call1570;
}
Object meth_ast_1571_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_1572_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 344
  setline(344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1573 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1574 = callmethodflags(*var_visitor, "visitImplicit(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1573);
// compiled call node returning call1574 (depth = 3)
  gc_frame_end(frame);
  return call1574;
}
Object meth_ast_1575_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 346
  setline(346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1576 == NULL) {
    strlit1576 = alloc_String("implicit");
    gc_root(strlit1576);
  }
// compiled string node returning strlit1576 (depth = 3)
  gc_frame_end(frame);
  return strlit1576;
}
Object meth_ast_1587_implicit(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "implicit");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_implicit = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_implicit (depth = 3)
  gc_frame_end(frame);
  return *var_implicit;
}
Object meth_ast_1591_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 353
  setline(353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1592 == NULL) {
    strlit1592 = alloc_String("// null");
    gc_root(strlit1592);
  }
// compiled string node returning strlit1592 (depth = 3)
  gc_frame_end(frame);
  return strlit1592;
}
Object meth_ast_1593_range(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "range");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptyRange = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 355
  setline(355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptyRange (depth = 3)
  gc_frame_end(frame);
  return *var_emptyRange;
}
Object meth_ast_1594_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 356
  setline(356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1595 == NULL) {
    strlit1595 = alloc_String("the nullNode");
    gc_root(strlit1595);
  }
// compiled string node returning strlit1595 (depth = 3)
  gc_frame_end(frame);
  return strlit1595;
}
Object meth_ast_1596__61__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 357
  setline(357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1597 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 4: self request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call1598 = callmethodflags(self, "isMe(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1597);
// compiled call node returning call1598 (depth = 3)
  gc_frame_end(frame);
  return call1598;
}
Object meth_ast_1602_nullNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "nullNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_nullNode (depth = 3)
  gc_frame_end(frame);
  return *var_nullNode;
}
Object meth_ast_1606_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1607 == NULL) {
    strlit1607 = alloc_String("the fakeSymbolTable");
    gc_root(strlit1607);
  }
// compiled string node returning strlit1607 (depth = 3)
  gc_frame_end(frame);
  return strlit1607;
}
Object meth_ast_1608_addNode_40_1_41_as_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addNode(1)as(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addNode(_)as(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addNode(_)as(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for addNode(_)as(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addNode(_)");
  Object *var_kind = &(stackframe->slots[1]);
  *var_kind = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part as(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1609 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1611 == NULL) {
    strlit1611 = alloc_String("""\x22"" requested");
    gc_root(strlit1611);
  }
// compiled string node returning strlit1611 (depth = 5)
  int op_slot_right_1610 = gc_frame_newslot(strlit1611);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_kind (depth = 6)
  int op_slot_right_1613 = gc_frame_newslot(*var_kind);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1616 == NULL) {
    strlit1616 = alloc_String(") as ""\x22""");
    gc_root(strlit1616);
  }
// compiled string node returning strlit1616 (depth = 7)
  int op_slot_right_1615 = gc_frame_newslot(strlit1616);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_right_1618 = gc_frame_newslot(*var_n);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1621 == NULL) {
    strlit1621 = alloc_String(").addNode(");
    gc_root(strlit1621);
  }
// compiled string node returning strlit1621 (depth = 9)
  int op_slot_right_1620 = gc_frame_newslot(strlit1621);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe1624 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1625 = callmethodflags(self, "node", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1624);
// compiled member node returning call1625 (depth = 10)
  int op_slot_right_1623 = gc_frame_newslot(call1625);
// starting to compile string node (depth = 10)
  if (strlit1627 == NULL) {
    strlit1627 = alloc_String("fakeSymbolTable(on node ");
    gc_root(strlit1627);
  }
// compiled string node returning strlit1627 (depth = 10)
  int op_slot_left_1623 = gc_frame_newslot(strlit1627);
  params[0] = call1625;
  partcv[0] = 1;
  Object opresult1628 = callmethod(strlit1627, "++(1)", 1, partcv, params);
// compiled op node returning opresult1628 (depth = 9)
  int op_slot_left_1620 = gc_frame_newslot(opresult1628);
  params[0] = strlit1621;
  partcv[0] = 1;
  Object opresult1629 = callmethod(opresult1628, "++(1)", 1, partcv, params);
// compiled op node returning opresult1629 (depth = 8)
  int op_slot_left_1618 = gc_frame_newslot(opresult1629);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult1630 = callmethod(opresult1629, "++(1)", 1, partcv, params);
// compiled op node returning opresult1630 (depth = 7)
  int op_slot_left_1615 = gc_frame_newslot(opresult1630);
  params[0] = strlit1616;
  partcv[0] = 1;
  Object opresult1631 = callmethod(opresult1630, "++(1)", 1, partcv, params);
// compiled op node returning opresult1631 (depth = 6)
  int op_slot_left_1613 = gc_frame_newslot(opresult1631);
  params[0] = *var_kind;
  partcv[0] = 1;
  Object opresult1632 = callmethod(opresult1631, "++(1)", 1, partcv, params);
// compiled op node returning opresult1632 (depth = 5)
  int op_slot_left_1610 = gc_frame_newslot(opresult1632);
  params[0] = strlit1611;
  partcv[0] = 1;
  Object opresult1633 = callmethod(opresult1632, "++(1)", 1, partcv, params);
// compiled op node returning opresult1633 (depth = 4)
  gc_frame_newslot(opresult1633);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1634 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1635 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1634);
// compiled member node returning call1635 (depth = 4)
  params[0] = opresult1633;
  partcv[0] = 1;
  Object call1636 = callmethodflags(call1635, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1609);
// compiled call node returning call1636 (depth = 3)
  gc_frame_end(frame);
  return call1636;
}
Object meth_ast_1637_thatDefines_40_1_41_ifNone_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "thatDefines(1)ifNone(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method thatDefines(_)ifNone(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method thatDefines(_)ifNone(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for thatDefines(_)ifNone(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part thatDefines(_)");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifNone(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 367
  setline(367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1638 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1640 == NULL) {
    strlit1640 = alloc_String(").");
    gc_root(strlit1640);
  }
// compiled string node returning strlit1640 (depth = 5)
  int op_slot_right_1639 = gc_frame_newslot(strlit1640);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_name (depth = 6)
  int op_slot_right_1642 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 6)
  if (strlit1644 == NULL) {
    strlit1644 = alloc_String("fakeSymbolTable.thatDefines(");
    gc_root(strlit1644);
  }
// compiled string node returning strlit1644 (depth = 6)
  int op_slot_left_1642 = gc_frame_newslot(strlit1644);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult1645 = callmethod(strlit1644, "++(1)", 1, partcv, params);
// compiled op node returning opresult1645 (depth = 5)
  int op_slot_left_1639 = gc_frame_newslot(opresult1645);
  params[0] = strlit1640;
  partcv[0] = 1;
  Object opresult1646 = callmethod(opresult1645, "++(1)", 1, partcv, params);
// compiled op node returning opresult1646 (depth = 4)
  gc_frame_newslot(opresult1646);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1647 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1648 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1647);
// compiled member node returning call1648 (depth = 4)
  params[0] = opresult1646;
  partcv[0] = 1;
  Object call1649 = callmethodflags(call1648, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1638);
// compiled call node returning call1649 (depth = 3)
  gc_frame_end(frame);
  return call1649;
}
Object meth_ast_1650_enclosingObjectScope(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "enclosingObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 370
  setline(370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1651 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1653 == NULL) {
    strlit1653 = alloc_String("");
    gc_root(strlit1653);
  }
// compiled string node returning strlit1653 (depth = 5)
  int op_slot_right_1652 = gc_frame_newslot(strlit1653);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1656 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1657 = callmethodflags(self, "node", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1656);
// compiled member node returning call1657 (depth = 6)
  int op_slot_right_1655 = gc_frame_newslot(call1657);
// starting to compile string node (depth = 6)
  if (strlit1659 == NULL) {
    strlit1659 = alloc_String("fakeSymbolTable.enclosingObjectScope on node ");
    gc_root(strlit1659);
  }
// compiled string node returning strlit1659 (depth = 6)
  int op_slot_left_1655 = gc_frame_newslot(strlit1659);
  params[0] = call1657;
  partcv[0] = 1;
  Object opresult1660 = callmethod(strlit1659, "++(1)", 1, partcv, params);
// compiled op node returning opresult1660 (depth = 5)
  int op_slot_left_1652 = gc_frame_newslot(opresult1660);
  params[0] = strlit1653;
  partcv[0] = 1;
  Object opresult1661 = callmethod(opresult1660, "++(1)", 1, partcv, params);
// compiled op node returning opresult1661 (depth = 4)
  gc_frame_newslot(opresult1661);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1662 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1663 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1662);
// compiled member node returning call1663 (depth = 4)
  params[0] = opresult1661;
  partcv[0] = 1;
  Object call1664 = callmethodflags(call1663, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1651);
// compiled call node returning call1664 (depth = 3)
  gc_frame_end(frame);
  return call1664;
}
Object meth_ast_1665_variety(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "variety");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 372
  setline(372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1666 == NULL) {
    strlit1666 = alloc_String("fake");
    gc_root(strlit1666);
  }
// compiled string node returning strlit1666 (depth = 3)
  gc_frame_end(frame);
  return strlit1666;
}
Object meth_ast_1667__61__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 373
  setline(373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1668 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 4: self request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call1669 = callmethodflags(self, "isMe(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1668);
// compiled call node returning call1669 (depth = 3)
  gc_frame_end(frame);
  return call1669;
}
Object meth_ast_1670_fakeSymbolTable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "fakeSymbolTable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_fakeSymbolTable (depth = 3)
  gc_frame_end(frame);
  return *var_fakeSymbolTable;
}
Object meth_ast_1681_isSimple(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 384
  setline(384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1682 = alloc_Boolean(0);
// compiled identifier node returning bool1682 (depth = 3)
  gc_frame_end(frame);
  return bool1682;
}
Object meth_ast_1683_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// definebindings:
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1685 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1686 = callmethodflags(*var_visitor, "visitIf(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1685);
// compiled call node returning call1686 (depth = 4)
  Object if1684 = done;
  if (istrue(call1686)) {
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1687 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call1688 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1687);
// compiled call node returning call1688 (depth = 5)
  *var_newChain = call1688;
  if (call1688 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 388
  setline(388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1689 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1690 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1691 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1690);
// compiled member node returning call1691 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1692 = callmethodflags(call1691, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1689);
// compiled call node returning call1692 (depth = 4)
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1693 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1694 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1695 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1694);
// compiled member node returning call1695 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1696 = callmethodflags(call1695, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1693);
// compiled call node returning call1696 (depth = 4)
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1697 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1698 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1699 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1698);
// compiled member node returning call1699 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1700 = callmethodflags(call1699, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1697);
// compiled call node returning call1700 (depth = 4)
    gc_frame_newslot(call1700);
    if1684 = call1700;
  } else {
  }
// compiled if node returning if1684 (depth = 3)
  gc_frame_end(frame);
  return if1684;
}
Object meth_ast_1701_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 393
  setline(393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1702 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1703 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1704 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1703);
// compiled member node returning call1704 (depth = 4)
  partcv[0] = 0;
  Object call1705 = callmethodflags(call1704, "end", 1, partcv, params, 0);
  gc_frame_end(callframe1702);
// compiled member node returning call1705 (depth = 3)
  gc_frame_end(frame);
  return call1705;
}
Object meth_ast_1706_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1707 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1708 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1707);
// compiled member node returning call1708 (depth = 4)
  *var_n = call1708;
  if (call1708 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 396
  setline(396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1709 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1710 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1709);
// compiled call node returning call1710 (depth = 4)
  *var_newChain = call1710;
  if (call1710 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 397
  setline(397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1711 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1712 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1713 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1714 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1713);
// compiled member node returning call1714 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1715 = callmethodflags(call1714, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1712);
// compiled call node returning call1715 (depth = 4)
  gc_frame_newslot(call1715);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1715;
  partcv[0] = 1;
  Object call1716 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1711);
// compiled call node returning call1716 (depth = 3)
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1717 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1718 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1719 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1720 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1719);
// compiled member node returning call1720 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1721 = callmethodflags(call1720, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1718);
// compiled call node returning call1721 (depth = 4)
  gc_frame_newslot(call1721);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1721;
  partcv[0] = 1;
  Object call1722 = callmethodflags(*var_n, "thenblock:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1717);
// compiled call node returning call1722 (depth = 3)
// Begin line 399
  setline(399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1723 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1724 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1725 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1726 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1725);
// compiled member node returning call1726 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1727 = callmethodflags(call1726, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1724);
// compiled call node returning call1727 (depth = 4)
  gc_frame_newslot(call1727);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1727;
  partcv[0] = 1;
  Object call1728 = callmethodflags(*var_n, "elseblock:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1723);
// compiled call node returning call1728 (depth = 3)
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1729 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1730 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1729);
// compiled call node returning call1730 (depth = 3)
  gc_frame_end(frame);
  return call1730;
}
Object meth_ast_1833__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 413
  setline(413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1835 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1837 = alloc_Float64(2);
// compiled num node returning num1837 (depth = 10)
  int op_slot_right_1836 = gc_frame_newslot(num1837);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1836 = gc_frame_newslot(*var_depth);
  params[0] = num1837;
  partcv[0] = 1;
  Object sum1839 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1839 (depth = 9)
  gc_frame_newslot(sum1839);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  params[0] = sum1839;
  partcv[0] = 1;
  Object call1840 = callmethodflags(*var_ix, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1835);
// compiled call node returning call1840 (depth = 8)
  int op_slot_right_1834 = gc_frame_newslot(call1840);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_1842 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1845 == NULL) {
    strlit1845 = alloc_String("""\x0a""  ");
    gc_root(strlit1845);
  }
// compiled string node returning strlit1845 (depth = 10)
  int op_slot_right_1844 = gc_frame_newslot(strlit1845);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1844 = gc_frame_newslot(*var_s);
  params[0] = strlit1845;
  partcv[0] = 1;
  Object opresult1847 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1847 (depth = 9)
  int op_slot_left_1842 = gc_frame_newslot(opresult1847);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1848 = callmethod(opresult1847, "++(1)", 1, partcv, params);
// compiled op node returning opresult1848 (depth = 8)
  int op_slot_left_1834 = gc_frame_newslot(opresult1848);
  params[0] = call1840;
  partcv[0] = 1;
  Object opresult1849 = callmethod(opresult1848, "++(1)", 1, partcv, params);
// compiled op node returning opresult1849 (depth = 7)
  *var_s = opresult1849;
  if (opresult1849 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_1872__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 418
  setline(418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1874 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1876 = alloc_Float64(2);
// compiled num node returning num1876 (depth = 10)
  int op_slot_right_1875 = gc_frame_newslot(num1876);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1875 = gc_frame_newslot(*var_depth);
  params[0] = num1876;
  partcv[0] = 1;
  Object sum1878 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1878 (depth = 9)
  gc_frame_newslot(sum1878);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  params[0] = sum1878;
  partcv[0] = 1;
  Object call1879 = callmethodflags(*var_ix, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1874);
// compiled call node returning call1879 (depth = 8)
  int op_slot_right_1873 = gc_frame_newslot(call1879);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_1881 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1884 == NULL) {
    strlit1884 = alloc_String("""\x0a""  ");
    gc_root(strlit1884);
  }
// compiled string node returning strlit1884 (depth = 10)
  int op_slot_right_1883 = gc_frame_newslot(strlit1884);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1883 = gc_frame_newslot(*var_s);
  params[0] = strlit1884;
  partcv[0] = 1;
  Object opresult1886 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1886 (depth = 9)
  int op_slot_left_1881 = gc_frame_newslot(opresult1886);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1887 = callmethod(opresult1886, "++(1)", 1, partcv, params);
// compiled op node returning opresult1887 (depth = 8)
  int op_slot_left_1873 = gc_frame_newslot(opresult1887);
  params[0] = call1879;
  partcv[0] = 1;
  Object opresult1888 = callmethod(opresult1887, "++(1)", 1, partcv, params);
// compiled op node returning opresult1888 (depth = 7)
  *var_s = opresult1888;
  if (opresult1888 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_1731_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// definebindings:
// definebindings:
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1734 = alloc_Float64(1);
// compiled num node returning num1734 (depth = 6)
  int op_slot_right_1733 = gc_frame_newslot(num1734);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_1733 = gc_frame_newslot(*var_depth);
  params[0] = num1734;
  partcv[0] = 1;
  Object sum1736 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1736 (depth = 5)
  int op_slot_right_1732 = gc_frame_newslot(sum1736);
// starting to compile string node (depth = 5)
  if (strlit1738 == NULL) {
    strlit1738 = alloc_String("  ");
    gc_root(strlit1738);
  }
// compiled string node returning strlit1738 (depth = 5)
  int op_slot_left_1732 = gc_frame_newslot(strlit1738);
  params[0] = sum1736;
  partcv[0] = 1;
  Object prod1739 = callmethod(strlit1738, "*(1)", 1, partcv, params);
// compiled op node returning prod1739 (depth = 4)
  *var_spc = prod1739;
  if (prod1739 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 404
  setline(404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1741 == NULL) {
    strlit1741 = alloc_String("""\x0a""");
    gc_root(strlit1741);
  }
// compiled string node returning strlit1741 (depth = 5)
  int op_slot_right_1740 = gc_frame_newslot(strlit1741);
// starting to compile call node (depth = 5)
  int callframe1743 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call1744 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1743);
// compiled call node returning call1744 (depth = 5)
  int op_slot_left_1740 = gc_frame_newslot(call1744);
  params[0] = strlit1741;
  partcv[0] = 1;
  Object opresult1745 = callmethod(call1744, "++(1)", 1, partcv, params);
// compiled op node returning opresult1745 (depth = 4)
  *var_s = opresult1745;
  if (opresult1745 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1747 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1749 = alloc_Float64(1);
// compiled num node returning num1749 (depth = 7)
  int op_slot_right_1748 = gc_frame_newslot(num1749);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_1748 = gc_frame_newslot(*var_depth);
  params[0] = num1749;
  partcv[0] = 1;
  Object sum1751 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1751 (depth = 6)
  gc_frame_newslot(sum1751);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1752 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1753 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1752);
// compiled member node returning call1753 (depth = 6)
  params[0] = sum1751;
  partcv[0] = 1;
  Object call1754 = callmethodflags(call1753, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1747);
// compiled call node returning call1754 (depth = 5)
  int op_slot_right_1746 = gc_frame_newslot(call1754);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_1756 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1756 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1758 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1758 (depth = 5)
  int op_slot_left_1746 = gc_frame_newslot(opresult1758);
  params[0] = call1754;
  partcv[0] = 1;
  Object opresult1759 = callmethod(opresult1758, "++(1)", 1, partcv, params);
// compiled op node returning opresult1759 (depth = 4)
  *var_s = opresult1759;
  if (opresult1759 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 406
  setline(406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1762 == NULL) {
    strlit1762 = alloc_String("""\x0a""");
    gc_root(strlit1762);
  }
// compiled string node returning strlit1762 (depth = 5)
  int op_slot_right_1761 = gc_frame_newslot(strlit1762);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_1761 = gc_frame_newslot(*var_s);
  params[0] = strlit1762;
  partcv[0] = 1;
  Object opresult1764 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1764 (depth = 4)
  *var_s = opresult1764;
  if (opresult1764 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 407
  setline(407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1768 == NULL) {
    strlit1768 = alloc_String("symbols");
    gc_root(strlit1768);
  }
// compiled string node returning strlit1768 (depth = 5)
  int op_slot_right_1767 = gc_frame_newslot(strlit1768);
// starting to compile member node (depth = 5)
  int callframe1770 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call1771 = callmethodflags(*var_util, "target", 1, partcv, params, 0);
  gc_frame_end(callframe1770);
// compiled member node returning call1771 (depth = 5)
  int op_slot_left_1767 = gc_frame_newslot(call1771);
  params[0] = strlit1768;
  partcv[0] = 1;
  Object opresult1772 = callmethod(call1771, "==(1)", 1, partcv, params);
// compiled op node returning opresult1772 (depth = 4)
  Object if1766 = done;
  if (istrue(opresult1772)) {
// Begin line 408
  setline(408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1775 == NULL) {
    strlit1775 = alloc_String("""\x0a""");
    gc_root(strlit1775);
  }
// compiled string node returning strlit1775 (depth = 7)
  int op_slot_right_1774 = gc_frame_newslot(strlit1775);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1778 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1780 = alloc_Float64(2);
// compiled num node returning num1780 (depth = 10)
  int op_slot_right_1779 = gc_frame_newslot(num1780);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1779 = gc_frame_newslot(*var_depth);
  params[0] = num1780;
  partcv[0] = 1;
  Object sum1782 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1782 (depth = 9)
  gc_frame_newslot(sum1782);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1783 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1784 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1783);
// compiled member node returning call1784 (depth = 9)
  params[0] = sum1782;
  partcv[0] = 1;
  Object call1785 = callmethodflags(call1784, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1778);
// compiled call node returning call1785 (depth = 8)
  int op_slot_right_1777 = gc_frame_newslot(call1785);
// starting to compile string node (depth = 8)
  if (strlit1787 == NULL) {
    strlit1787 = alloc_String("Then: ");
    gc_root(strlit1787);
  }
// compiled string node returning strlit1787 (depth = 8)
  int op_slot_left_1777 = gc_frame_newslot(strlit1787);
  params[0] = call1785;
  partcv[0] = 1;
  Object opresult1788 = callmethod(strlit1787, "++(1)", 1, partcv, params);
// compiled op node returning opresult1788 (depth = 7)
  int op_slot_left_1774 = gc_frame_newslot(opresult1788);
  params[0] = strlit1775;
  partcv[0] = 1;
  Object opresult1789 = callmethod(opresult1788, "++(1)", 1, partcv, params);
// compiled op node returning opresult1789 (depth = 6)
  int op_slot_right_1773 = gc_frame_newslot(opresult1789);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1791 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1791 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1793 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1793 (depth = 6)
  int op_slot_left_1773 = gc_frame_newslot(opresult1793);
  params[0] = opresult1789;
  partcv[0] = 1;
  Object opresult1794 = callmethod(opresult1793, "++(1)", 1, partcv, params);
// compiled op node returning opresult1794 (depth = 5)
  *var_s = opresult1794;
  if (opresult1794 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 409
  setline(409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1798 == NULL) {
    strlit1798 = alloc_String("");
    gc_root(strlit1798);
  }
// compiled string node returning strlit1798 (depth = 7)
  int op_slot_right_1797 = gc_frame_newslot(strlit1798);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1801 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1803 = alloc_Float64(2);
// compiled num node returning num1803 (depth = 10)
  int op_slot_right_1802 = gc_frame_newslot(num1803);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1802 = gc_frame_newslot(*var_depth);
  params[0] = num1803;
  partcv[0] = 1;
  Object sum1805 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1805 (depth = 9)
  gc_frame_newslot(sum1805);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1806 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1807 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1806);
// compiled member node returning call1807 (depth = 9)
  params[0] = sum1805;
  partcv[0] = 1;
  Object call1808 = callmethodflags(call1807, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1801);
// compiled call node returning call1808 (depth = 8)
  int op_slot_right_1800 = gc_frame_newslot(call1808);
// starting to compile string node (depth = 8)
  if (strlit1810 == NULL) {
    strlit1810 = alloc_String("Else: ");
    gc_root(strlit1810);
  }
// compiled string node returning strlit1810 (depth = 8)
  int op_slot_left_1800 = gc_frame_newslot(strlit1810);
  params[0] = call1808;
  partcv[0] = 1;
  Object opresult1811 = callmethod(strlit1810, "++(1)", 1, partcv, params);
// compiled op node returning opresult1811 (depth = 7)
  int op_slot_left_1797 = gc_frame_newslot(opresult1811);
  params[0] = strlit1798;
  partcv[0] = 1;
  Object opresult1812 = callmethod(opresult1811, "++(1)", 1, partcv, params);
// compiled op node returning opresult1812 (depth = 6)
  int op_slot_right_1796 = gc_frame_newslot(opresult1812);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1814 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1814 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1816 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1816 (depth = 6)
  int op_slot_left_1796 = gc_frame_newslot(opresult1816);
  params[0] = opresult1812;
  partcv[0] = 1;
  Object opresult1817 = callmethod(opresult1816, "++(1)", 1, partcv, params);
// compiled op node returning opresult1817 (depth = 5)
  *var_s = opresult1817;
  if (opresult1817 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1766 = done;
  } else {
// Begin line 411
  setline(411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1820 == NULL) {
    strlit1820 = alloc_String("Then:");
    gc_root(strlit1820);
  }
// compiled string node returning strlit1820 (depth = 6)
  int op_slot_right_1819 = gc_frame_newslot(strlit1820);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1822 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1822 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1824 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1824 (depth = 6)
  int op_slot_left_1819 = gc_frame_newslot(opresult1824);
  params[0] = strlit1820;
  partcv[0] = 1;
  Object opresult1825 = callmethod(opresult1824, "++(1)", 1, partcv, params);
// compiled op node returning opresult1825 (depth = 5)
  *var_s = opresult1825;
  if (opresult1825 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1827 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1828 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1829 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1830 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1829);
// compiled member node returning call1830 (depth = 6)
  partcv[0] = 0;
  Object call1831 = callmethodflags(call1830, "body", 1, partcv, params, 0);
  gc_frame_end(callframe1828);
// compiled member node returning call1831 (depth = 5)
  gc_frame_newslot(call1831);
// starting to compile block node (depth = 5)
  Object block1832 = alloc_Block(NULL, NULL, "ast", 412);
  gc_frame_newslot(block1832);
// method "_apply(_)"
  block_savedest(block1832);
  Object closure1833 = createclosure(4, "_apply(1)");
  setclosureframe(closure1833, stackframe);
  addtoclosure(closure1833, var_depth);
  addtoclosure(closure1833, var_spc);
  addtoclosure(closure1833, var_s);
  addtoclosure(closure1833, selfslot);
  struct UserObject *uo1833 = (struct UserObject*)block1832;
  uo1833->data[0] = (Object)closure1833;
  Method *meth_meth_ast_1833__apply_40_1_41_ = addmethod2pos(block1832, "_apply(1)", &meth_ast_1833__apply_40_1_41_, 0);
  int argcv_meth_ast_1833__apply_40_1_41_[] = {1};
  meth_meth_ast_1833__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1833__apply_40_1_41_);
  meth_meth_ast_1833__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1833__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block1832 (depth = 5)
  gc_frame_newslot(block1832);
// call case 5: prelude request
  params[0] = call1831;
  params[1] = block1832;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1852 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1827);
// compiled call node returning call1852 (depth = 4)
// Begin line 415
  setline(415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1854 == NULL) {
    strlit1854 = alloc_String("""\x0a""");
    gc_root(strlit1854);
  }
// compiled string node returning strlit1854 (depth = 6)
  int op_slot_right_1853 = gc_frame_newslot(strlit1854);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1853 = gc_frame_newslot(*var_s);
  params[0] = strlit1854;
  partcv[0] = 1;
  Object opresult1856 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1856 (depth = 5)
  *var_s = opresult1856;
  if (opresult1856 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1859 == NULL) {
    strlit1859 = alloc_String("Else:");
    gc_root(strlit1859);
  }
// compiled string node returning strlit1859 (depth = 6)
  int op_slot_right_1858 = gc_frame_newslot(strlit1859);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1861 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1861 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1863 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1863 (depth = 6)
  int op_slot_left_1858 = gc_frame_newslot(opresult1863);
  params[0] = strlit1859;
  partcv[0] = 1;
  Object opresult1864 = callmethod(opresult1863, "++(1)", 1, partcv, params);
// compiled op node returning opresult1864 (depth = 5)
  *var_s = opresult1864;
  if (opresult1864 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 417
  setline(417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1866 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1867 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1868 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1869 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1868);
// compiled member node returning call1869 (depth = 6)
  partcv[0] = 0;
  Object call1870 = callmethodflags(call1869, "body", 1, partcv, params, 0);
  gc_frame_end(callframe1867);
// compiled member node returning call1870 (depth = 5)
  gc_frame_newslot(call1870);
// starting to compile block node (depth = 5)
  Object block1871 = alloc_Block(NULL, NULL, "ast", 417);
  gc_frame_newslot(block1871);
// method "_apply(_)"
  block_savedest(block1871);
  Object closure1872 = createclosure(4, "_apply(1)");
  setclosureframe(closure1872, stackframe);
  addtoclosure(closure1872, var_depth);
  addtoclosure(closure1872, var_spc);
  addtoclosure(closure1872, var_s);
  addtoclosure(closure1872, selfslot);
  struct UserObject *uo1872 = (struct UserObject*)block1871;
  uo1872->data[0] = (Object)closure1872;
  Method *meth_meth_ast_1872__apply_40_1_41_ = addmethod2pos(block1871, "_apply(1)", &meth_ast_1872__apply_40_1_41_, 0);
  int argcv_meth_ast_1872__apply_40_1_41_[] = {1};
  meth_meth_ast_1872__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1872__apply_40_1_41_);
  meth_meth_ast_1872__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1872__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block1871 (depth = 5)
  gc_frame_newslot(block1871);
// call case 5: prelude request
  params[0] = call1870;
  params[1] = block1871;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1891 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1866);
// compiled call node returning call1891 (depth = 4)
    gc_frame_newslot(call1891);
    if1766 = call1891;
  }
// compiled if node returning if1766 (depth = 3)
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_1916__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 427
  setline(427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1918 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1920 = alloc_Float64(1);
// compiled num node returning num1920 (depth = 9)
  int op_slot_right_1919 = gc_frame_newslot(num1920);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_1919 = gc_frame_newslot(*var_depth);
  params[0] = num1920;
  partcv[0] = 1;
  Object sum1922 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1922 (depth = 8)
  gc_frame_newslot(sum1922);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  params[0] = sum1922;
  partcv[0] = 1;
  Object call1923 = callmethodflags(*var_ix, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1918);
// compiled call node returning call1923 (depth = 7)
  int op_slot_right_1917 = gc_frame_newslot(call1923);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1926 == NULL) {
    strlit1926 = alloc_String("    ");
    gc_root(strlit1926);
  }
// compiled string node returning strlit1926 (depth = 8)
  int op_slot_right_1925 = gc_frame_newslot(strlit1926);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_1928 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1931 == NULL) {
    strlit1931 = alloc_String("""\x0a""");
    gc_root(strlit1931);
  }
// compiled string node returning strlit1931 (depth = 10)
  int op_slot_right_1930 = gc_frame_newslot(strlit1931);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1930 = gc_frame_newslot(*var_s);
  params[0] = strlit1931;
  partcv[0] = 1;
  Object opresult1933 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1933 (depth = 9)
  int op_slot_left_1928 = gc_frame_newslot(opresult1933);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1934 = callmethod(opresult1933, "++(1)", 1, partcv, params);
// compiled op node returning opresult1934 (depth = 8)
  int op_slot_left_1925 = gc_frame_newslot(opresult1934);
  params[0] = strlit1926;
  partcv[0] = 1;
  Object opresult1935 = callmethod(opresult1934, "++(1)", 1, partcv, params);
// compiled op node returning opresult1935 (depth = 7)
  int op_slot_left_1917 = gc_frame_newslot(opresult1935);
  params[0] = call1923;
  partcv[0] = 1;
  Object opresult1936 = callmethod(opresult1935, "++(1)", 1, partcv, params);
// compiled op node returning opresult1936 (depth = 6)
  *var_s = opresult1936;
  if (opresult1936 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_1963__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 432
  setline(432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1965 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1967 = alloc_Float64(1);
// compiled num node returning num1967 (depth = 10)
  int op_slot_right_1966 = gc_frame_newslot(num1967);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1966 = gc_frame_newslot(*var_depth);
  params[0] = num1967;
  partcv[0] = 1;
  Object sum1969 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1969 (depth = 9)
  gc_frame_newslot(sum1969);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  params[0] = sum1969;
  partcv[0] = 1;
  Object call1970 = callmethodflags(*var_ix, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1965);
// compiled call node returning call1970 (depth = 8)
  int op_slot_right_1964 = gc_frame_newslot(call1970);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1973 == NULL) {
    strlit1973 = alloc_String("    ");
    gc_root(strlit1973);
  }
// compiled string node returning strlit1973 (depth = 9)
  int op_slot_right_1972 = gc_frame_newslot(strlit1973);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_1975 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1978 == NULL) {
    strlit1978 = alloc_String("""\x0a""");
    gc_root(strlit1978);
  }
// compiled string node returning strlit1978 (depth = 11)
  int op_slot_right_1977 = gc_frame_newslot(strlit1978);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_1977 = gc_frame_newslot(*var_s);
  params[0] = strlit1978;
  partcv[0] = 1;
  Object opresult1980 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1980 (depth = 10)
  int op_slot_left_1975 = gc_frame_newslot(opresult1980);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1981 = callmethod(opresult1980, "++(1)", 1, partcv, params);
// compiled op node returning opresult1981 (depth = 9)
  int op_slot_left_1972 = gc_frame_newslot(opresult1981);
  params[0] = strlit1973;
  partcv[0] = 1;
  Object opresult1982 = callmethod(opresult1981, "++(1)", 1, partcv, params);
// compiled op node returning opresult1982 (depth = 8)
  int op_slot_left_1964 = gc_frame_newslot(opresult1982);
  params[0] = call1970;
  partcv[0] = 1;
  Object opresult1983 = callmethod(opresult1982, "++(1)", 1, partcv, params);
// compiled op node returning opresult1983 (depth = 7)
  *var_s = opresult1983;
  if (opresult1983 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_1892_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// definebindings:
// definebindings:
// Begin line 424
  setline(424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_1893 = gc_frame_newslot(*var_depth);
// starting to compile string node (depth = 5)
  if (strlit1895 == NULL) {
    strlit1895 = alloc_String("    ");
    gc_root(strlit1895);
  }
// compiled string node returning strlit1895 (depth = 5)
  int op_slot_left_1893 = gc_frame_newslot(strlit1895);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object prod1896 = callmethod(strlit1895, "*(1)", 1, partcv, params);
// compiled op node returning prod1896 (depth = 4)
  *var_spc = prod1896;
  if (prod1896 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 425
  setline(425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1898 == NULL) {
    strlit1898 = alloc_String(") then {");
    gc_root(strlit1898);
  }
// compiled string node returning strlit1898 (depth = 5)
  int op_slot_right_1897 = gc_frame_newslot(strlit1898);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1901 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num1902 = alloc_Float64(0);
// compiled num node returning num1902 (depth = 7)
  gc_frame_newslot(num1902);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1903 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1904 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1903);
// compiled member node returning call1904 (depth = 7)
  params[0] = num1902;
  partcv[0] = 1;
  Object call1905 = callmethodflags(call1904, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1901);
// compiled call node returning call1905 (depth = 6)
  int op_slot_right_1900 = gc_frame_newslot(call1905);
// starting to compile string node (depth = 6)
  if (strlit1907 == NULL) {
    strlit1907 = alloc_String("if (");
    gc_root(strlit1907);
  }
// compiled string node returning strlit1907 (depth = 6)
  int op_slot_left_1900 = gc_frame_newslot(strlit1907);
  params[0] = call1905;
  partcv[0] = 1;
  Object opresult1908 = callmethod(strlit1907, "++(1)", 1, partcv, params);
// compiled op node returning opresult1908 (depth = 5)
  int op_slot_left_1897 = gc_frame_newslot(opresult1908);
  params[0] = strlit1898;
  partcv[0] = 1;
  Object opresult1909 = callmethod(opresult1908, "++(1)", 1, partcv, params);
// compiled op node returning opresult1909 (depth = 4)
  *var_s = opresult1909;
  if (opresult1909 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 426
  setline(426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1910 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1911 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1912 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1913 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1912);
// compiled member node returning call1913 (depth = 5)
  partcv[0] = 0;
  Object call1914 = callmethodflags(call1913, "body", 1, partcv, params, 0);
  gc_frame_end(callframe1911);
// compiled member node returning call1914 (depth = 4)
  gc_frame_newslot(call1914);
// starting to compile block node (depth = 4)
  Object block1915 = alloc_Block(NULL, NULL, "ast", 426);
  gc_frame_newslot(block1915);
// method "_apply(_)"
  block_savedest(block1915);
  Object closure1916 = createclosure(4, "_apply(1)");
  setclosureframe(closure1916, stackframe);
  addtoclosure(closure1916, var_depth);
  addtoclosure(closure1916, var_spc);
  addtoclosure(closure1916, var_s);
  addtoclosure(closure1916, selfslot);
  struct UserObject *uo1916 = (struct UserObject*)block1915;
  uo1916->data[0] = (Object)closure1916;
  Method *meth_meth_ast_1916__apply_40_1_41_ = addmethod2pos(block1915, "_apply(1)", &meth_ast_1916__apply_40_1_41_, 0);
  int argcv_meth_ast_1916__apply_40_1_41_[] = {1};
  meth_meth_ast_1916__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1916__apply_40_1_41_);
  meth_meth_ast_1916__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1916__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block1915 (depth = 4)
  gc_frame_newslot(block1915);
// call case 5: prelude request
  params[0] = call1914;
  params[1] = block1915;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1939 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1910);
// compiled call node returning call1939 (depth = 3)
// Begin line 429
  setline(429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1941 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1942 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1943 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1942);
// compiled member node returning call1943 (depth = 5)
  partcv[0] = 0;
  Object call1944 = callmethodflags(call1943, "isntEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe1941);
// compiled member node returning call1944 (depth = 4)
  Object if1940 = done;
  if (istrue(call1944)) {
// Begin line 430
  setline(430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1946 == NULL) {
    strlit1946 = alloc_String("} else {");
    gc_root(strlit1946);
  }
// compiled string node returning strlit1946 (depth = 6)
  int op_slot_right_1945 = gc_frame_newslot(strlit1946);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1948 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1951 == NULL) {
    strlit1951 = alloc_String("""\x0a""");
    gc_root(strlit1951);
  }
// compiled string node returning strlit1951 (depth = 8)
  int op_slot_right_1950 = gc_frame_newslot(strlit1951);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1950 = gc_frame_newslot(*var_s);
  params[0] = strlit1951;
  partcv[0] = 1;
  Object opresult1953 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1953 (depth = 7)
  int op_slot_left_1948 = gc_frame_newslot(opresult1953);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1954 = callmethod(opresult1953, "++(1)", 1, partcv, params);
// compiled op node returning opresult1954 (depth = 6)
  int op_slot_left_1945 = gc_frame_newslot(opresult1954);
  params[0] = strlit1946;
  partcv[0] = 1;
  Object opresult1955 = callmethod(opresult1954, "++(1)", 1, partcv, params);
// compiled op node returning opresult1955 (depth = 5)
  *var_s = opresult1955;
  if (opresult1955 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 431
  setline(431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1957 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1958 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1959 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1960 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1959);
// compiled member node returning call1960 (depth = 6)
  partcv[0] = 0;
  Object call1961 = callmethodflags(call1960, "body", 1, partcv, params, 0);
  gc_frame_end(callframe1958);
// compiled member node returning call1961 (depth = 5)
  gc_frame_newslot(call1961);
// starting to compile block node (depth = 5)
  Object block1962 = alloc_Block(NULL, NULL, "ast", 431);
  gc_frame_newslot(block1962);
// method "_apply(_)"
  block_savedest(block1962);
  Object closure1963 = createclosure(4, "_apply(1)");
  setclosureframe(closure1963, stackframe);
  addtoclosure(closure1963, var_depth);
  addtoclosure(closure1963, var_spc);
  addtoclosure(closure1963, var_s);
  addtoclosure(closure1963, selfslot);
  struct UserObject *uo1963 = (struct UserObject*)block1962;
  uo1963->data[0] = (Object)closure1963;
  Method *meth_meth_ast_1963__apply_40_1_41_ = addmethod2pos(block1962, "_apply(1)", &meth_ast_1963__apply_40_1_41_, 0);
  int argcv_meth_ast_1963__apply_40_1_41_[] = {1};
  meth_meth_ast_1963__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1963__apply_40_1_41_);
  meth_meth_ast_1963__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1963__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block1962 (depth = 5)
  gc_frame_newslot(block1962);
// call case 5: prelude request
  params[0] = call1961;
  params[1] = block1962;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1986 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1957);
// compiled call node returning call1986 (depth = 4)
    gc_frame_newslot(call1986);
    if1940 = call1986;
  } else {
  }
// compiled if node returning if1940 (depth = 3)
// Begin line 435
  setline(435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1988 == NULL) {
    strlit1988 = alloc_String("}");
    gc_root(strlit1988);
  }
// compiled string node returning strlit1988 (depth = 5)
  int op_slot_right_1987 = gc_frame_newslot(strlit1988);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_1990 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1993 == NULL) {
    strlit1993 = alloc_String("""\x0a""");
    gc_root(strlit1993);
  }
// compiled string node returning strlit1993 (depth = 7)
  int op_slot_right_1992 = gc_frame_newslot(strlit1993);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1992 = gc_frame_newslot(*var_s);
  params[0] = strlit1993;
  partcv[0] = 1;
  Object opresult1995 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1995 (depth = 6)
  int op_slot_left_1990 = gc_frame_newslot(opresult1995);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1996 = callmethod(opresult1995, "++(1)", 1, partcv, params);
// compiled op node returning opresult1996 (depth = 5)
  int op_slot_left_1987 = gc_frame_newslot(opresult1996);
  params[0] = strlit1988;
  partcv[0] = 1;
  Object opresult1997 = callmethod(opresult1996, "++(1)", 1, partcv, params);
// compiled op node returning opresult1997 (depth = 4)
  *var_s = opresult1997;
  if (opresult1997 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 436
  setline(436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_1999_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_ifNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 439
  setline(439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2000 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe2001 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ifNode (depth = 5)
  params[0] = *var_nullNode;
  params[1] = *var_nullNode;
  params[2] = *var_nullNode;
  partcv[0] = 3;
  Object call2002 = callmethodflags(*var_ifNode, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe2001);
// compiled call node returning call2002 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call2003 = callmethodflags(call2002, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2000);
// compiled call node returning call2003 (depth = 3)
  gc_frame_end(frame);
  return call2003;
}
Object meth_ast_2004_postCopy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "postCopy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method postCopy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for postCopy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part postCopy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 442
  setline(442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2005 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2006 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call2007 = callmethodflags(*var_other, "handledIdentifiers", 1, partcv, params, 0);
  gc_frame_end(callframe2006);
// compiled member node returning call2007 (depth = 4)
  gc_frame_newslot(call2007);
// call case 4: self request
  params[0] = call2007;
  partcv[0] = 1;
  Object call2008 = callmethodflags(self, "handledIdentifiers:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2005);
// compiled call node returning call2008 (depth = 3)
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_1673_new_40_3_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_ifNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_thenblock_39_ = &(stackframe->slots[1]);
  *var_thenblock_39_ = args[curarg];
  curarg++;
  Object *var_elseblock_39_ = &(stackframe->slots[2]);
  *var_elseblock_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1674 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1674 = alloc_userobj2(17,14, objclass1674);
  gc_frame_newslot(obj1674);
  if (objclass1674 == NULL) {
    glfree(obj1674->class->name);
    obj1674->class->name = "ifNode.new(_,_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj1674, self, 0);
  addmethodreal(obj1674,"outer", &reader_ast_outer_1675);
  Object oldself1674 = self;
  struct StackFrameObject *oldstackframe1674 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1674);
  gc_frame_newslot((Object)stackframe);
  self = obj1674;
  Object *oldselfslot1674 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1674 = (*(struct UserObject *)self).data[0], lowerouter1674 = thisouter1674;
  if (inheritingObject1674) {
    struct UserObject *inho1674 = (struct UserObject *)inheritingObject1674;
    while (inho1674->super != GraceDefaultObject) inho1674 = (struct UserObject *)inho1674->super;
    inho1674->super = obj1674;
    self = inheritingObject1674;
    *selfslot = self;
    lowerouter1674 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1674;
  }
  if (objclass1674 == NULL) {
  Method *reader1676 = addmethodrealflags(obj1674, "kind",&reader_ast_kind_1676, MFLAG_DEF);
  reader1676->definitionModule = modulename;
  reader1676->definitionLine = 379;
  }
  adddatum2(obj1674, alloc_Undefined(), 1);
  if (objclass1674 == NULL) {
    Method *reader1677 = addmethodrealflags(obj1674, "value", &reader_ast_value_1677, 0);
    Method *writer1677 = addmethodrealflags(obj1674, "value:=(1)", &writer_ast_value_1677, 0);
    reader1677->definitionModule = modulename;
    writer1677->definitionModule = modulename;
    reader1677->definitionLine = 380;
    writer1677->definitionLine = 380;
  }
  obj1674->flags |= OFLAG_MUTABLE;
  adddatum2(obj1674, alloc_Undefined(), 2);
  if (objclass1674 == NULL) {
    Method *reader1678 = addmethodrealflags(obj1674, "thenblock", &reader_ast_thenblock_1678, 0);
    Method *writer1678 = addmethodrealflags(obj1674, "thenblock:=(1)", &writer_ast_thenblock_1678, 0);
    reader1678->definitionModule = modulename;
    writer1678->definitionModule = modulename;
    reader1678->definitionLine = 381;
    writer1678->definitionLine = 381;
  }
  obj1674->flags |= OFLAG_MUTABLE;
  adddatum2(obj1674, alloc_Undefined(), 3);
  if (objclass1674 == NULL) {
    Method *reader1679 = addmethodrealflags(obj1674, "elseblock", &reader_ast_elseblock_1679, 0);
    Method *writer1679 = addmethodrealflags(obj1674, "elseblock:=(1)", &writer_ast_elseblock_1679, 0);
    reader1679->definitionModule = modulename;
    writer1679->definitionModule = modulename;
    reader1679->definitionLine = 382;
    writer1679->definitionLine = 382;
  }
  obj1674->flags |= OFLAG_MUTABLE;
  adddatum2(obj1674, alloc_Undefined(), 4);
  if (objclass1674 == NULL) {
    Method *reader1680 = addmethodrealflags(obj1674, "handledIdentifiers", &reader_ast_handledIdentifiers_1680, 0);
    Method *writer1680 = addmethodrealflags(obj1674, "handledIdentifiers:=(1)", &writer_ast_handledIdentifiers_1680, 0);
    reader1680->definitionModule = modulename;
    writer1680->definitionModule = modulename;
    reader1680->definitionLine = 383;
    writer1680->definitionLine = 383;
  }
  obj1674->flags |= OFLAG_MUTABLE;
  adddatum2(obj1674, alloc_Undefined(), 5);
// method "isSimple"
  struct UserObject *uo1681 = (struct UserObject*)obj1674;
  uo1681->data[6] = emptyclosure;
  Method *meth_meth_ast_1681_isSimple = addmethod2pos(obj1674, "isSimple", &meth_ast_1681_isSimple, 6);
  int argcv_meth_ast_1681_isSimple[] = {0};
  meth_meth_ast_1681_isSimple->type = alloc_MethodType(1, argcv_meth_ast_1681_isSimple);
  meth_meth_ast_1681_isSimple->definitionModule = modulename;
  meth_meth_ast_1681_isSimple->definitionLine = 384;
// method "accept(_)from(_)"
  struct UserObject *uo1683 = (struct UserObject*)obj1674;
  uo1683->data[7] = emptyclosure;
  Method *meth_meth_ast_1683_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj1674, "accept(1)from(1)", &meth_ast_1683_accept_40_1_41_from_40_1_41_, 7);
  int argcv_meth_ast_1683_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_1683_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1683_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_1683_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1683_accept_40_1_41_from_40_1_41_->definitionLine = 385;
// method "end"
  struct UserObject *uo1701 = (struct UserObject*)obj1674;
  uo1701->data[8] = emptyclosure;
  Method *meth_meth_ast_1701_end = addmethod2pos(obj1674, "end", &meth_ast_1701_end, 8);
  int argcv_meth_ast_1701_end[] = {0};
  meth_meth_ast_1701_end->type = alloc_MethodType(1, argcv_meth_ast_1701_end);
  meth_meth_ast_1701_end->definitionModule = modulename;
  meth_meth_ast_1701_end->definitionLine = 393;
// method "map(_)ancestors(_)"
  struct UserObject *uo1706 = (struct UserObject*)obj1674;
  uo1706->data[9] = emptyclosure;
  Method *meth_meth_ast_1706_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj1674, "map(1)ancestors(1)", &meth_ast_1706_map_40_1_41_ancestors_40_1_41_, 9);
  int argcv_meth_ast_1706_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_1706_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1706_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_1706_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1706_map_40_1_41_ancestors_40_1_41_->definitionLine = 394;
// method "pretty(_)"
  block_savedest(obj1674);
  Object closure1731 = createclosure(1, "pretty(1)");
  setclosureframe(closure1731, stackframe);
  addtoclosure(closure1731, var_util);
  struct UserObject *uo1731 = (struct UserObject*)obj1674;
  uo1731->data[10] = (Object)closure1731;
  Method *meth_meth_ast_1731_pretty_40_1_41_ = addmethod2pos(obj1674, "pretty(1)", &meth_ast_1731_pretty_40_1_41_, 10);
  int argcv_meth_ast_1731_pretty_40_1_41_[] = {1};
  meth_meth_ast_1731_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1731_pretty_40_1_41_);
  meth_meth_ast_1731_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1731_pretty_40_1_41_->definitionLine = 402;
// method "toGrace(_)"
  struct UserObject *uo1892 = (struct UserObject*)obj1674;
  uo1892->data[11] = emptyclosure;
  Method *meth_meth_ast_1892_toGrace_40_1_41_ = addmethod2pos(obj1674, "toGrace(1)", &meth_ast_1892_toGrace_40_1_41_, 11);
  int argcv_meth_ast_1892_toGrace_40_1_41_[] = {1};
  meth_meth_ast_1892_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1892_toGrace_40_1_41_);
meth_meth_ast_1892_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_1892_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_1892_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1892_toGrace_40_1_41_->definitionLine = 423;
// method "shallowCopy"
  block_savedest(obj1674);
  Object closure1999 = createclosure(2, "shallowCopy");
  setclosureframe(closure1999, stackframe);
  addtoclosure(closure1999, var_nullNode);
  addtoclosure(closure1999, var_ifNode);
  struct UserObject *uo1999 = (struct UserObject*)obj1674;
  uo1999->data[12] = (Object)closure1999;
  Method *meth_meth_ast_1999_shallowCopy = addmethod2pos(obj1674, "shallowCopy", &meth_ast_1999_shallowCopy, 12);
  int argcv_meth_ast_1999_shallowCopy[] = {0};
  meth_meth_ast_1999_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_1999_shallowCopy);
  meth_meth_ast_1999_shallowCopy->definitionModule = modulename;
  meth_meth_ast_1999_shallowCopy->definitionLine = 438;
// method "postCopy(_)"
  struct UserObject *uo2004 = (struct UserObject*)obj1674;
  uo2004->data[13] = emptyclosure;
  Method *meth_meth_ast_2004_postCopy_40_1_41_ = addmethod2pos(obj1674, "postCopy(1)", &meth_ast_2004_postCopy_40_1_41_, 13);
  int argcv_meth_ast_2004_postCopy_40_1_41_[] = {1};
  meth_meth_ast_2004_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2004_postCopy_40_1_41_);
  meth_meth_ast_2004_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2004_postCopy_40_1_41_->definitionLine = 441;
  sourceObject = obj1674;
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2009 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2010 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2009);
// compiled call node returning call2010 (depth = 3)
  struct UserObject *obj1674_uo = (struct UserObject *)obj1674;
  obj1674_uo->super = call2010;
  sourceObject = obj1674;
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2011 == NULL) {
    strlit2011 = alloc_String("if");
    gc_root(strlit2011);
  }
// compiled string node returning strlit2011 (depth = 3)
  adddatum2(obj1674, strlit2011, 1);
  sourceObject = obj1674;
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cond (depth = 3)
  adddatum2(obj1674, *var_cond, 2);
  sourceObject = obj1674;
// Begin line 381
  setline(381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_thenblock_39_ (depth = 3)
  adddatum2(obj1674, *var_thenblock_39_, 3);
  sourceObject = obj1674;
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elseblock_39_ (depth = 3)
  adddatum2(obj1674, *var_elseblock_39_, 4);
  sourceObject = obj1674;
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2012 = alloc_Boolean(0);
// compiled identifier node returning bool2012 (depth = 3)
  adddatum2(obj1674, bool2012, 5);
  sourceObject = obj1674;
  sourceObject = obj1674;
  sourceObject = obj1674;
  sourceObject = obj1674;
  sourceObject = obj1674;
  sourceObject = obj1674;
  sourceObject = obj1674;
  sourceObject = obj1674;
  objclass1674 = obj1674->class;
  objclass1674->definitionModule = modulename;
  objclass1674->definitionLine = 377;
  (*(struct UserObject *)self).data[0] = lowerouter1674;
  self = oldself1674;
  selfslot = oldselfslot1674;
  stackframe = oldstackframe1674;
  gc_frame_end(frame);
  return obj1674;
}
Object meth_ast_1673_new_40_3_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_ifNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_thenblock_39_ = &(stackframe->slots[1]);
  *var_thenblock_39_ = args[curarg];
  curarg++;
  Object *var_elseblock_39_ = &(stackframe->slots[2]);
  *var_elseblock_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1674 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1674 = alloc_userobj2(17,14, objclass1674);
  gc_frame_newslot(obj1674);
  if (objclass1674 == NULL) {
    glfree(obj1674->class->name);
    obj1674->class->name = "ifNode.new(_,_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj1674, self, 0);
  addmethodreal(obj1674,"outer", &reader_ast_outer_1675);
  Object oldself1674 = self;
  struct StackFrameObject *oldstackframe1674 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1674);
  gc_frame_newslot((Object)stackframe);
  self = obj1674;
  Object *oldselfslot1674 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1674 = (*(struct UserObject *)self).data[0], lowerouter1674 = thisouter1674;
  if (inheritingObject1674) {
    struct UserObject *inho1674 = (struct UserObject *)inheritingObject1674;
    while (inho1674->super != GraceDefaultObject) inho1674 = (struct UserObject *)inho1674->super;
    inho1674->super = obj1674;
    self = inheritingObject1674;
    *selfslot = self;
    lowerouter1674 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1674;
  }
  if (objclass1674 == NULL) {
  Method *reader1676 = addmethodrealflags(obj1674, "kind",&reader_ast_kind_1676, MFLAG_DEF);
  reader1676->definitionModule = modulename;
  reader1676->definitionLine = 379;
  }
  adddatum2(obj1674, alloc_Undefined(), 1);
  if (objclass1674 == NULL) {
    Method *reader1677 = addmethodrealflags(obj1674, "value", &reader_ast_value_1677, 0);
    Method *writer1677 = addmethodrealflags(obj1674, "value:=(1)", &writer_ast_value_1677, 0);
    reader1677->definitionModule = modulename;
    writer1677->definitionModule = modulename;
    reader1677->definitionLine = 380;
    writer1677->definitionLine = 380;
  }
  obj1674->flags |= OFLAG_MUTABLE;
  adddatum2(obj1674, alloc_Undefined(), 2);
  if (objclass1674 == NULL) {
    Method *reader1678 = addmethodrealflags(obj1674, "thenblock", &reader_ast_thenblock_1678, 0);
    Method *writer1678 = addmethodrealflags(obj1674, "thenblock:=(1)", &writer_ast_thenblock_1678, 0);
    reader1678->definitionModule = modulename;
    writer1678->definitionModule = modulename;
    reader1678->definitionLine = 381;
    writer1678->definitionLine = 381;
  }
  obj1674->flags |= OFLAG_MUTABLE;
  adddatum2(obj1674, alloc_Undefined(), 3);
  if (objclass1674 == NULL) {
    Method *reader1679 = addmethodrealflags(obj1674, "elseblock", &reader_ast_elseblock_1679, 0);
    Method *writer1679 = addmethodrealflags(obj1674, "elseblock:=(1)", &writer_ast_elseblock_1679, 0);
    reader1679->definitionModule = modulename;
    writer1679->definitionModule = modulename;
    reader1679->definitionLine = 382;
    writer1679->definitionLine = 382;
  }
  obj1674->flags |= OFLAG_MUTABLE;
  adddatum2(obj1674, alloc_Undefined(), 4);
  if (objclass1674 == NULL) {
    Method *reader1680 = addmethodrealflags(obj1674, "handledIdentifiers", &reader_ast_handledIdentifiers_1680, 0);
    Method *writer1680 = addmethodrealflags(obj1674, "handledIdentifiers:=(1)", &writer_ast_handledIdentifiers_1680, 0);
    reader1680->definitionModule = modulename;
    writer1680->definitionModule = modulename;
    reader1680->definitionLine = 383;
    writer1680->definitionLine = 383;
  }
  obj1674->flags |= OFLAG_MUTABLE;
  adddatum2(obj1674, alloc_Undefined(), 5);
// method "isSimple"
  struct UserObject *uo1681 = (struct UserObject*)obj1674;
  uo1681->data[6] = emptyclosure;
  Method *meth_meth_ast_1681_isSimple = addmethod2pos(obj1674, "isSimple", &meth_ast_1681_isSimple, 6);
  int argcv_meth_ast_1681_isSimple[] = {0};
  meth_meth_ast_1681_isSimple->type = alloc_MethodType(1, argcv_meth_ast_1681_isSimple);
  meth_meth_ast_1681_isSimple->definitionModule = modulename;
  meth_meth_ast_1681_isSimple->definitionLine = 384;
// method "accept(_)from(_)"
  struct UserObject *uo1683 = (struct UserObject*)obj1674;
  uo1683->data[7] = emptyclosure;
  Method *meth_meth_ast_1683_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj1674, "accept(1)from(1)", &meth_ast_1683_accept_40_1_41_from_40_1_41_, 7);
  int argcv_meth_ast_1683_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_1683_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1683_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_1683_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1683_accept_40_1_41_from_40_1_41_->definitionLine = 385;
// method "end"
  struct UserObject *uo1701 = (struct UserObject*)obj1674;
  uo1701->data[8] = emptyclosure;
  Method *meth_meth_ast_1701_end = addmethod2pos(obj1674, "end", &meth_ast_1701_end, 8);
  int argcv_meth_ast_1701_end[] = {0};
  meth_meth_ast_1701_end->type = alloc_MethodType(1, argcv_meth_ast_1701_end);
  meth_meth_ast_1701_end->definitionModule = modulename;
  meth_meth_ast_1701_end->definitionLine = 393;
// method "map(_)ancestors(_)"
  struct UserObject *uo1706 = (struct UserObject*)obj1674;
  uo1706->data[9] = emptyclosure;
  Method *meth_meth_ast_1706_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj1674, "map(1)ancestors(1)", &meth_ast_1706_map_40_1_41_ancestors_40_1_41_, 9);
  int argcv_meth_ast_1706_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_1706_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1706_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_1706_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1706_map_40_1_41_ancestors_40_1_41_->definitionLine = 394;
// method "pretty(_)"
  block_savedest(obj1674);
  Object closure1731 = createclosure(1, "pretty(1)");
  setclosureframe(closure1731, stackframe);
  addtoclosure(closure1731, var_util);
  struct UserObject *uo1731 = (struct UserObject*)obj1674;
  uo1731->data[10] = (Object)closure1731;
  Method *meth_meth_ast_1731_pretty_40_1_41_ = addmethod2pos(obj1674, "pretty(1)", &meth_ast_1731_pretty_40_1_41_, 10);
  int argcv_meth_ast_1731_pretty_40_1_41_[] = {1};
  meth_meth_ast_1731_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1731_pretty_40_1_41_);
  meth_meth_ast_1731_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1731_pretty_40_1_41_->definitionLine = 402;
// method "toGrace(_)"
  struct UserObject *uo1892 = (struct UserObject*)obj1674;
  uo1892->data[11] = emptyclosure;
  Method *meth_meth_ast_1892_toGrace_40_1_41_ = addmethod2pos(obj1674, "toGrace(1)", &meth_ast_1892_toGrace_40_1_41_, 11);
  int argcv_meth_ast_1892_toGrace_40_1_41_[] = {1};
  meth_meth_ast_1892_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1892_toGrace_40_1_41_);
meth_meth_ast_1892_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_1892_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_1892_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1892_toGrace_40_1_41_->definitionLine = 423;
// method "shallowCopy"
  block_savedest(obj1674);
  Object closure1999 = createclosure(2, "shallowCopy");
  setclosureframe(closure1999, stackframe);
  addtoclosure(closure1999, var_nullNode);
  addtoclosure(closure1999, var_ifNode);
  struct UserObject *uo1999 = (struct UserObject*)obj1674;
  uo1999->data[12] = (Object)closure1999;
  Method *meth_meth_ast_1999_shallowCopy = addmethod2pos(obj1674, "shallowCopy", &meth_ast_1999_shallowCopy, 12);
  int argcv_meth_ast_1999_shallowCopy[] = {0};
  meth_meth_ast_1999_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_1999_shallowCopy);
  meth_meth_ast_1999_shallowCopy->definitionModule = modulename;
  meth_meth_ast_1999_shallowCopy->definitionLine = 438;
// method "postCopy(_)"
  struct UserObject *uo2004 = (struct UserObject*)obj1674;
  uo2004->data[13] = emptyclosure;
  Method *meth_meth_ast_2004_postCopy_40_1_41_ = addmethod2pos(obj1674, "postCopy(1)", &meth_ast_2004_postCopy_40_1_41_, 13);
  int argcv_meth_ast_2004_postCopy_40_1_41_[] = {1};
  meth_meth_ast_2004_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2004_postCopy_40_1_41_);
  meth_meth_ast_2004_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2004_postCopy_40_1_41_->definitionLine = 441;
  sourceObject = obj1674;
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2009 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2010 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2009);
// compiled call node returning call2010 (depth = 3)
  struct UserObject *obj1674_uo = (struct UserObject *)obj1674;
  obj1674_uo->super = call2010;
  sourceObject = obj1674;
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2011 == NULL) {
    strlit2011 = alloc_String("if");
    gc_root(strlit2011);
  }
// compiled string node returning strlit2011 (depth = 3)
  adddatum2(obj1674, strlit2011, 1);
  sourceObject = obj1674;
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cond (depth = 3)
  adddatum2(obj1674, *var_cond, 2);
  sourceObject = obj1674;
// Begin line 381
  setline(381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_thenblock_39_ (depth = 3)
  adddatum2(obj1674, *var_thenblock_39_, 3);
  sourceObject = obj1674;
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elseblock_39_ (depth = 3)
  adddatum2(obj1674, *var_elseblock_39_, 4);
  sourceObject = obj1674;
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2012 = alloc_Boolean(0);
// compiled identifier node returning bool2012 (depth = 3)
  adddatum2(obj1674, bool2012, 5);
  sourceObject = obj1674;
  sourceObject = obj1674;
  sourceObject = obj1674;
  sourceObject = obj1674;
  sourceObject = obj1674;
  sourceObject = obj1674;
  sourceObject = obj1674;
  sourceObject = obj1674;
  objclass1674 = obj1674->class;
  objclass1674->definitionModule = modulename;
  objclass1674->definitionLine = 377;
  (*(struct UserObject *)self).data[0] = lowerouter1674;
  self = oldself1674;
  selfslot = oldselfslot1674;
  stackframe = oldstackframe1674;
  gc_frame_end(frame);
  return obj1674;
}
Object meth_ast_2014_ifNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ifNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ifNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ifNode (depth = 3)
  gc_frame_end(frame);
  return *var_ifNode;
}
Object meth_ast_2027_isBlock(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 460
  setline(460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2028 = alloc_Boolean(1);
// compiled identifier node returning bool2028 (depth = 3)
  gc_frame_end(frame);
  return bool2028;
}
Object meth_ast_2029_isDelimited(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isDelimited");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 461
  setline(461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2030 = alloc_Boolean(1);
// compiled identifier node returning bool2030 (depth = 3)
  gc_frame_end(frame);
  return bool2030;
}
Object meth_ast_2031_isEmpty(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 462
  setline(462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2033 = alloc_Float64(0);
// compiled num node returning num2033 (depth = 4)
  int op_slot_right_2032 = gc_frame_newslot(num2033);
// starting to compile member node (depth = 4)
  int callframe2035 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2036 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2037 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2036);
// compiled member node returning call2037 (depth = 5)
  partcv[0] = 0;
  Object call2038 = callmethodflags(call2037, "size", 1, partcv, params, 0);
  gc_frame_end(callframe2035);
// compiled member node returning call2038 (depth = 4)
  int op_slot_left_2032 = gc_frame_newslot(call2038);
  params[0] = num2033;
  partcv[0] = 1;
  Object opresult2039 = callmethod(call2038, "==(1)", 1, partcv, params);
// compiled op node returning opresult2039 (depth = 3)
  gc_frame_end(frame);
  return opresult2039;
}
Object meth_ast_2040_isntEmpty(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isntEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 463
  setline(463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2042 = alloc_Float64(0);
// compiled num node returning num2042 (depth = 4)
  int op_slot_right_2041 = gc_frame_newslot(num2042);
// starting to compile member node (depth = 4)
  int callframe2044 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2045 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2046 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2045);
// compiled member node returning call2046 (depth = 5)
  partcv[0] = 0;
  Object call2047 = callmethodflags(call2046, "size", 1, partcv, params, 0);
  gc_frame_end(callframe2044);
// compiled member node returning call2047 (depth = 4)
  int op_slot_left_2041 = gc_frame_newslot(call2047);
  params[0] = num2042;
  partcv[0] = 1;
  Object opresult2048 = callmethod(call2047, ">(1)", 1, partcv, params);
// compiled op node returning opresult2048 (depth = 3)
  gc_frame_end(frame);
  return opresult2048;
}
Object meth_ast_2049_scope_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 467
  setline(467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2050 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call2051 = callmethodflags(self, "symbolTable:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2050);
// compiled call node returning call2051 (depth = 3)
// Begin line 468
  setline(468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2052 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call2053 = callmethodflags(*var_st, "node:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2052);
// compiled call node returning call2053 (depth = 3)
  gc_frame_end(frame);
  return call2053;
}
Object meth_ast_2054_declarationKindWithAncestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe2055 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  partcv[0] = 0;
  Object call2056 = callmethodflags(*var_k, "parameter", 1, partcv, params, 0);
  gc_frame_end(callframe2055);
// compiled member node returning call2056 (depth = 3)
  gc_frame_end(frame);
  return call2056;
}
Object meth_ast_2057_isMatchingBlock(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMatchingBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 471
  setline(471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2059 = alloc_Float64(1);
// compiled num node returning num2059 (depth = 4)
  int op_slot_right_2058 = gc_frame_newslot(num2059);
// starting to compile member node (depth = 4)
  int callframe2061 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2062 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2063 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2062);
// compiled member node returning call2063 (depth = 5)
  partcv[0] = 0;
  Object call2064 = callmethodflags(call2063, "size", 1, partcv, params, 0);
  gc_frame_end(callframe2061);
// compiled member node returning call2064 (depth = 4)
  int op_slot_left_2058 = gc_frame_newslot(call2064);
  params[0] = num2059;
  partcv[0] = 1;
  Object opresult2065 = callmethod(call2064, "==(1)", 1, partcv, params);
// compiled op node returning opresult2065 (depth = 3)
  gc_frame_end(frame);
  return opresult2065;
}
Object meth_ast_2069__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 5)
  int callframe2070 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2071 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2072 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2073 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2072);
// compiled member node returning call2073 (depth = 7)
  partcv[0] = 0;
  Object call2074 = callmethodflags(call2073, "last", 1, partcv, params, 0);
  gc_frame_end(callframe2071);
// compiled member node returning call2074 (depth = 6)
  partcv[0] = 0;
  Object call2075 = callmethodflags(call2074, "returnsObject", 1, partcv, params, 0);
  gc_frame_end(callframe2070);
// compiled member node returning call2075 (depth = 5)
  gc_frame_end(frame);
  return call2075;
}
Object meth_ast_2066_returnsObject(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 473
  setline(473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile block node (depth = 4)
  Object block2068 = alloc_Block(NULL, NULL, "ast", 473);
  gc_frame_newslot(block2068);
// method "_apply"
  block_savedest(block2068);
  Object closure2069 = createclosure(1, "_apply");
  setclosureframe(closure2069, stackframe);
  addtoclosure(closure2069, selfslot);
  struct UserObject *uo2069 = (struct UserObject*)block2068;
  uo2069->data[0] = (Object)closure2069;
  Method *meth_meth_ast_2069__apply = addmethod2pos(block2068, "_apply", &meth_ast_2069__apply, 0);
  int argcv_meth_ast_2069__apply[] = {0};
  meth_meth_ast_2069__apply->type = alloc_MethodType(1, argcv_meth_ast_2069__apply);
  meth_meth_ast_2069__apply->definitionModule = modulename;
  meth_meth_ast_2069__apply->definitionLine = 3050;
// compiled block node returning block2068 (depth = 4)
  int op_slot_right_2067 = gc_frame_newslot(block2068);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2079 = alloc_Float64(0);
// compiled num node returning num2079 (depth = 5)
  int op_slot_right_2078 = gc_frame_newslot(num2079);
// starting to compile member node (depth = 5)
  int callframe2081 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2082 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2083 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2082);
// compiled member node returning call2083 (depth = 6)
  partcv[0] = 0;
  Object call2084 = callmethodflags(call2083, "size", 1, partcv, params, 0);
  gc_frame_end(callframe2081);
// compiled member node returning call2084 (depth = 5)
  int op_slot_left_2078 = gc_frame_newslot(call2084);
  params[0] = num2079;
  partcv[0] = 1;
  Object opresult2085 = callmethod(call2084, ">(1)", 1, partcv, params);
// compiled op node returning opresult2085 (depth = 4)
  int op_slot_left_2067 = gc_frame_newslot(opresult2085);
  params[0] = block2068;
  partcv[0] = 1;
  Object opresult2086 = callmethod(opresult2085, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2086 (depth = 3)
  gc_frame_end(frame);
  return opresult2086;
}
Object meth_ast_2087_returnedObjectScope(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe2088 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2089 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2090 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2091 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2090);
// compiled member node returning call2091 (depth = 5)
  partcv[0] = 0;
  Object call2092 = callmethodflags(call2091, "last", 1, partcv, params, 0);
  gc_frame_end(callframe2089);
// compiled member node returning call2092 (depth = 4)
  partcv[0] = 0;
  Object call2093 = callmethodflags(call2092, "returnedObjectScope", 1, partcv, params, 0);
  gc_frame_end(callframe2088);
// compiled member node returning call2093 (depth = 3)
  gc_frame_end(frame);
  return call2093;
}
Object meth_ast_2094_parametersDo_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parametersDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parametersDo(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parametersDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parametersDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 480
  setline(480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2095 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2096 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2097 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2096);
// compiled member node returning call2097 (depth = 4)
  params[0] = *var_b;
  partcv[0] = 1;
  Object call2098 = callmethodflags(call2097, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2095);
// compiled call node returning call2098 (depth = 3)
  gc_frame_end(frame);
  return call2098;
}
Object meth_ast_2099_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2102 = alloc_Float64(0);
// compiled num node returning num2102 (depth = 5)
  int op_slot_right_2101 = gc_frame_newslot(num2102);
// starting to compile member node (depth = 5)
  int callframe2104 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2105 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2106 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2105);
// compiled member node returning call2106 (depth = 6)
  partcv[0] = 0;
  Object call2107 = callmethodflags(call2106, "size", 1, partcv, params, 0);
  gc_frame_end(callframe2104);
// compiled member node returning call2107 (depth = 5)
  int op_slot_left_2101 = gc_frame_newslot(call2107);
  params[0] = num2102;
  partcv[0] = 1;
  Object opresult2108 = callmethod(call2107, ">(1)", 1, partcv, params);
// compiled op node returning opresult2108 (depth = 4)
  Object if2100 = done;
  if (istrue(opresult2108)) {
// starting to compile return node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2109 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2110 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2111 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2112 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2111);
// compiled member node returning call2112 (depth = 7)
  partcv[0] = 0;
  Object call2113 = callmethodflags(call2112, "last", 1, partcv, params, 0);
  gc_frame_end(callframe2110);
// compiled member node returning call2113 (depth = 6)
  partcv[0] = 0;
  Object call2114 = callmethodflags(call2113, "end", 1, partcv, params, 0);
  gc_frame_end(callframe2109);
// compiled member node returning call2114 (depth = 5)
  return call2114;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if2100 = undefined;
  } else {
  }
// compiled if node returning if2100 (depth = 3)
// Begin line 484
  setline(484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2116 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2117 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2118 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2117);
// compiled member node returning call2118 (depth = 5)
  partcv[0] = 0;
  Object call2119 = callmethodflags(call2118, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe2116);
// compiled member node returning call2119 (depth = 4)
  Object if2115 = done;
  if (istrue(call2119)) {
// Begin line 485
  setline(485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2120 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit2121 == NULL) {
    strlit2121 = alloc_String("}");
    gc_root(strlit2121);
  }
// compiled string node returning strlit2121 (depth = 5)
  gc_frame_newslot(strlit2121);
// starting to compile member node (depth = 5)
  int callframe2122 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2123 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2122);
// compiled member node returning call2123 (depth = 5)
  gc_frame_newslot(call2123);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = strlit2121;
  params[1] = call2123;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2124 = callmethodflags(module_ast, "positionOfNext(1)after(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2120);
// compiled call node returning call2124 (depth = 4)
    gc_frame_newslot(call2124);
    if2115 = call2124;
  } else {
// Begin line 487
  setline(487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2125 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit2126 == NULL) {
    strlit2126 = alloc_String("}");
    gc_root(strlit2126);
  }
// compiled string node returning strlit2126 (depth = 5)
  gc_frame_newslot(strlit2126);
// starting to compile member node (depth = 5)
  int callframe2127 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2128 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2129 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2130 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2129);
// compiled member node returning call2130 (depth = 7)
  partcv[0] = 0;
  Object call2131 = callmethodflags(call2130, "last", 1, partcv, params, 0);
  gc_frame_end(callframe2128);
// compiled member node returning call2131 (depth = 6)
  partcv[0] = 0;
  Object call2132 = callmethodflags(call2131, "end", 1, partcv, params, 0);
  gc_frame_end(callframe2127);
// compiled member node returning call2132 (depth = 5)
  gc_frame_newslot(call2132);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = strlit2126;
  params[1] = call2132;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2133 = callmethodflags(module_ast, "positionOfNext(1)after(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2125);
// compiled call node returning call2133 (depth = 4)
    gc_frame_newslot(call2133);
    if2115 = call2133;
  }
// compiled if node returning if2115 (depth = 3)
  gc_frame_end(frame);
  return if2115;
}
Object meth_ast_2144__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 494
  setline(494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2145 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2146 = callmethodflags(*var_mx, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2145);
// compiled call node returning call2146 (depth = 6)
  gc_frame_end(frame);
  return call2146;
}
Object meth_ast_2153__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 497
  setline(497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2154 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2155 = callmethodflags(*var_mx, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2154);
// compiled call node returning call2155 (depth = 6)
  gc_frame_end(frame);
  return call2155;
}
Object meth_ast_2134_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// definebindings:
// definebindings:
// definebindings:
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2136 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2137 = callmethodflags(*var_visitor, "visitBlock(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2136);
// compiled call node returning call2137 (depth = 4)
  Object if2135 = done;
  if (istrue(call2137)) {
// Begin line 492
  setline(492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2138 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call2139 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2138);
// compiled call node returning call2139 (depth = 5)
  *var_newChain = call2139;
  if (call2139 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 493
  setline(493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2140 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2141 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2142 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2141);
// compiled member node returning call2142 (depth = 5)
  gc_frame_newslot(call2142);
// starting to compile block node (depth = 5)
  Object block2143 = alloc_Block(NULL, NULL, "ast", 493);
  gc_frame_newslot(block2143);
// method "_apply(_)"
  block_savedest(block2143);
  Object closure2144 = createclosure(3, "_apply(1)");
  setclosureframe(closure2144, stackframe);
  addtoclosure(closure2144, var_visitor);
  addtoclosure(closure2144, var_newChain);
  addtoclosure(closure2144, selfslot);
  struct UserObject *uo2144 = (struct UserObject*)block2143;
  uo2144->data[0] = (Object)closure2144;
  Method *meth_meth_ast_2144__apply_40_1_41_ = addmethod2pos(block2143, "_apply(1)", &meth_ast_2144__apply_40_1_41_, 0);
  int argcv_meth_ast_2144__apply_40_1_41_[] = {1};
  meth_meth_ast_2144__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2144__apply_40_1_41_);
  meth_meth_ast_2144__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2144__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block2143 (depth = 5)
  gc_frame_newslot(block2143);
// call case 5: prelude request
  params[0] = call2142;
  params[1] = block2143;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2148 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2140);
// compiled call node returning call2148 (depth = 4)
// Begin line 496
  setline(496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2149 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2150 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2151 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2150);
// compiled member node returning call2151 (depth = 5)
  gc_frame_newslot(call2151);
// starting to compile block node (depth = 5)
  Object block2152 = alloc_Block(NULL, NULL, "ast", 496);
  gc_frame_newslot(block2152);
// method "_apply(_)"
  block_savedest(block2152);
  Object closure2153 = createclosure(3, "_apply(1)");
  setclosureframe(closure2153, stackframe);
  addtoclosure(closure2153, var_visitor);
  addtoclosure(closure2153, var_newChain);
  addtoclosure(closure2153, selfslot);
  struct UserObject *uo2153 = (struct UserObject*)block2152;
  uo2153->data[0] = (Object)closure2153;
  Method *meth_meth_ast_2153__apply_40_1_41_ = addmethod2pos(block2152, "_apply(1)", &meth_ast_2153__apply_40_1_41_, 0);
  int argcv_meth_ast_2153__apply_40_1_41_[] = {1};
  meth_meth_ast_2153__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2153__apply_40_1_41_);
  meth_meth_ast_2153__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2153__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block2152 (depth = 5)
  gc_frame_newslot(block2152);
// call case 5: prelude request
  params[0] = call2151;
  params[1] = block2152;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2157 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2149);
// compiled call node returning call2157 (depth = 4)
// Begin line 499
  setline(499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2160 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2161 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2160);
// compiled member node returning call2161 (depth = 6)
  int op_slot_right_2159 = gc_frame_newslot(call2161);
// starting to compile identifier node (depth = 6)
  Object bool2163 = alloc_Boolean(0);
// compiled identifier node returning bool2163 (depth = 6)
  int op_slot_left_2159 = gc_frame_newslot(bool2163);
  params[0] = call2161;
  partcv[0] = 1;
  Object opresult2164 = callmethod(bool2163, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2164 (depth = 5)
  Object if2158 = done;
  if (istrue(opresult2164)) {
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2165 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2166 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2167 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2166);
// compiled member node returning call2167 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2168 = callmethodflags(call2167, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2165);
// compiled call node returning call2168 (depth = 5)
    gc_frame_newslot(call2168);
    if2158 = call2168;
  } else {
  }
// compiled if node returning if2158 (depth = 4)
    gc_frame_newslot(if2158);
    if2135 = if2158;
  } else {
  }
// compiled if node returning if2135 (depth = 3)
  gc_frame_end(frame);
  return if2135;
}
Object meth_ast_2169_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 505
  setline(505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2170 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2171 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2170);
// compiled member node returning call2171 (depth = 4)
  *var_n = call2171;
  if (call2171 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2172 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2173 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2172);
// compiled call node returning call2173 (depth = 4)
  *var_newChain = call2173;
  if (call2173 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2174 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2175 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2176 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2177 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2176);
// compiled member node returning call2177 (depth = 5)
  gc_frame_newslot(call2177);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call2177;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2178 = callmethodflags(module_ast, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2175);
// compiled call node returning call2178 (depth = 4)
  gc_frame_newslot(call2178);
// call case 6: other requests
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2178;
  partcv[0] = 1;
  Object call2179 = callmethodflags(*var_n, "params:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2174);
// compiled call node returning call2179 (depth = 3)
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2180 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2181 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2182 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2183 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2182);
// compiled member node returning call2183 (depth = 5)
  gc_frame_newslot(call2183);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call2183;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2184 = callmethodflags(module_ast, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2181);
// compiled call node returning call2184 (depth = 4)
  gc_frame_newslot(call2184);
// call case 6: other requests
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2184;
  partcv[0] = 1;
  Object call2185 = callmethodflags(*var_n, "body:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2180);
// compiled call node returning call2185 (depth = 3)
// Begin line 509
  setline(509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2186 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2187 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2188 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2189 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2188);
// compiled member node returning call2189 (depth = 5)
  gc_frame_newslot(call2189);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call2189;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2190 = callmethodflags(module_ast, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2187);
// compiled call node returning call2190 (depth = 4)
  gc_frame_newslot(call2190);
// call case 6: other requests
// Begin line 509
  setline(509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2190;
  partcv[0] = 1;
  Object call2191 = callmethodflags(*var_n, "matchingPattern:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2186);
// compiled call node returning call2191 (depth = 3)
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2192 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call2193 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2192);
// compiled call node returning call2193 (depth = 3)
  gc_frame_end(frame);
  return call2193;
}
Object meth_ast_2221__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 517
  setline(517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2223 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2225 = alloc_Float64(1);
// compiled num node returning num2225 (depth = 9)
  int op_slot_right_2224 = gc_frame_newslot(num2225);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2224 = gc_frame_newslot(*var_depth);
  params[0] = num2225;
  partcv[0] = 1;
  Object sum2227 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2227 (depth = 8)
  gc_frame_newslot(sum2227);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum2227;
  partcv[0] = 1;
  Object call2228 = callmethodflags(*var_mx, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2223);
// compiled call node returning call2228 (depth = 7)
  int op_slot_right_2222 = gc_frame_newslot(call2228);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_2230 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2233 == NULL) {
    strlit2233 = alloc_String("""\x0a""  ");
    gc_root(strlit2233);
  }
// compiled string node returning strlit2233 (depth = 9)
  int op_slot_right_2232 = gc_frame_newslot(strlit2233);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_2232 = gc_frame_newslot(*var_s);
  params[0] = strlit2233;
  partcv[0] = 1;
  Object opresult2235 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2235 (depth = 8)
  int op_slot_left_2230 = gc_frame_newslot(opresult2235);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2236 = callmethod(opresult2235, "++(1)", 1, partcv, params);
// compiled op node returning opresult2236 (depth = 7)
  int op_slot_left_2222 = gc_frame_newslot(opresult2236);
  params[0] = call2228;
  partcv[0] = 1;
  Object opresult2237 = callmethod(opresult2236, "++(1)", 1, partcv, params);
// compiled op node returning opresult2237 (depth = 6)
  *var_s = opresult2237;
  if (opresult2237 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_2258__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 522
  setline(522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2260 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2262 = alloc_Float64(1);
// compiled num node returning num2262 (depth = 9)
  int op_slot_right_2261 = gc_frame_newslot(num2262);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2261 = gc_frame_newslot(*var_depth);
  params[0] = num2262;
  partcv[0] = 1;
  Object sum2264 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2264 (depth = 8)
  gc_frame_newslot(sum2264);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum2264;
  partcv[0] = 1;
  Object call2265 = callmethodflags(*var_mx, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2260);
// compiled call node returning call2265 (depth = 7)
  int op_slot_right_2259 = gc_frame_newslot(call2265);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_2267 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2270 == NULL) {
    strlit2270 = alloc_String("""\x0a""  ");
    gc_root(strlit2270);
  }
// compiled string node returning strlit2270 (depth = 9)
  int op_slot_right_2269 = gc_frame_newslot(strlit2270);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_2269 = gc_frame_newslot(*var_s);
  params[0] = strlit2270;
  partcv[0] = 1;
  Object opresult2272 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2272 (depth = 8)
  int op_slot_left_2267 = gc_frame_newslot(opresult2272);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2273 = callmethod(opresult2272, "++(1)", 1, partcv, params);
// compiled op node returning opresult2273 (depth = 7)
  int op_slot_left_2259 = gc_frame_newslot(opresult2273);
  params[0] = call2265;
  partcv[0] = 1;
  Object opresult2274 = callmethod(opresult2273, "++(1)", 1, partcv, params);
// compiled op node returning opresult2274 (depth = 6)
  *var_s = opresult2274;
  if (opresult2274 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_2194_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// definebindings:
// definebindings:
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2197 = alloc_Float64(1);
// compiled num node returning num2197 (depth = 6)
  int op_slot_right_2196 = gc_frame_newslot(num2197);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_2196 = gc_frame_newslot(*var_depth);
  params[0] = num2197;
  partcv[0] = 1;
  Object sum2199 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2199 (depth = 5)
  int op_slot_right_2195 = gc_frame_newslot(sum2199);
// starting to compile string node (depth = 5)
  if (strlit2201 == NULL) {
    strlit2201 = alloc_String("  ");
    gc_root(strlit2201);
  }
// compiled string node returning strlit2201 (depth = 5)
  int op_slot_left_2195 = gc_frame_newslot(strlit2201);
  params[0] = sum2199;
  partcv[0] = 1;
  Object prod2202 = callmethod(strlit2201, "*(1)", 1, partcv, params);
// compiled op node returning prod2202 (depth = 4)
  *var_spc = prod2202;
  if (prod2202 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 514
  setline(514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2204 == NULL) {
    strlit2204 = alloc_String("""\x0a""");
    gc_root(strlit2204);
  }
// compiled string node returning strlit2204 (depth = 5)
  int op_slot_right_2203 = gc_frame_newslot(strlit2204);
// starting to compile call node (depth = 5)
  int callframe2206 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call2207 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2206);
// compiled call node returning call2207 (depth = 5)
  int op_slot_left_2203 = gc_frame_newslot(call2207);
  params[0] = strlit2204;
  partcv[0] = 1;
  Object opresult2208 = callmethod(call2207, "++(1)", 1, partcv, params);
// compiled op node returning opresult2208 (depth = 4)
  *var_s = opresult2208;
  if (opresult2208 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 515
  setline(515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2210 == NULL) {
    strlit2210 = alloc_String("Parameters:");
    gc_root(strlit2210);
  }
// compiled string node returning strlit2210 (depth = 5)
  int op_slot_right_2209 = gc_frame_newslot(strlit2210);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_2212 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2212 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2214 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2214 (depth = 5)
  int op_slot_left_2209 = gc_frame_newslot(opresult2214);
  params[0] = strlit2210;
  partcv[0] = 1;
  Object opresult2215 = callmethod(opresult2214, "++(1)", 1, partcv, params);
// compiled op node returning opresult2215 (depth = 4)
  *var_s = opresult2215;
  if (opresult2215 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 516
  setline(516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2217 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2218 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2219 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2218);
// compiled member node returning call2219 (depth = 4)
  gc_frame_newslot(call2219);
// starting to compile block node (depth = 4)
  Object block2220 = alloc_Block(NULL, NULL, "ast", 516);
  gc_frame_newslot(block2220);
// method "_apply(_)"
  block_savedest(block2220);
  Object closure2221 = createclosure(4, "_apply(1)");
  setclosureframe(closure2221, stackframe);
  addtoclosure(closure2221, var_depth);
  addtoclosure(closure2221, var_spc);
  addtoclosure(closure2221, var_s);
  addtoclosure(closure2221, selfslot);
  struct UserObject *uo2221 = (struct UserObject*)block2220;
  uo2221->data[0] = (Object)closure2221;
  Method *meth_meth_ast_2221__apply_40_1_41_ = addmethod2pos(block2220, "_apply(1)", &meth_ast_2221__apply_40_1_41_, 0);
  int argcv_meth_ast_2221__apply_40_1_41_[] = {1};
  meth_meth_ast_2221__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2221__apply_40_1_41_);
  meth_meth_ast_2221__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2221__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block2220 (depth = 4)
  gc_frame_newslot(block2220);
// call case 5: prelude request
  params[0] = call2219;
  params[1] = block2220;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2240 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2217);
// compiled call node returning call2240 (depth = 3)
// Begin line 519
  setline(519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2242 == NULL) {
    strlit2242 = alloc_String("""\x0a""");
    gc_root(strlit2242);
  }
// compiled string node returning strlit2242 (depth = 5)
  int op_slot_right_2241 = gc_frame_newslot(strlit2242);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_2241 = gc_frame_newslot(*var_s);
  params[0] = strlit2242;
  partcv[0] = 1;
  Object opresult2244 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2244 (depth = 4)
  *var_s = opresult2244;
  if (opresult2244 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2247 == NULL) {
    strlit2247 = alloc_String("Body:");
    gc_root(strlit2247);
  }
// compiled string node returning strlit2247 (depth = 5)
  int op_slot_right_2246 = gc_frame_newslot(strlit2247);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_2249 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2249 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2251 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2251 (depth = 5)
  int op_slot_left_2246 = gc_frame_newslot(opresult2251);
  params[0] = strlit2247;
  partcv[0] = 1;
  Object opresult2252 = callmethod(opresult2251, "++(1)", 1, partcv, params);
// compiled op node returning opresult2252 (depth = 4)
  *var_s = opresult2252;
  if (opresult2252 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 521
  setline(521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2254 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2255 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2256 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2255);
// compiled member node returning call2256 (depth = 4)
  gc_frame_newslot(call2256);
// starting to compile block node (depth = 4)
  Object block2257 = alloc_Block(NULL, NULL, "ast", 521);
  gc_frame_newslot(block2257);
// method "_apply(_)"
  block_savedest(block2257);
  Object closure2258 = createclosure(4, "_apply(1)");
  setclosureframe(closure2258, stackframe);
  addtoclosure(closure2258, var_depth);
  addtoclosure(closure2258, var_spc);
  addtoclosure(closure2258, var_s);
  addtoclosure(closure2258, selfslot);
  struct UserObject *uo2258 = (struct UserObject*)block2257;
  uo2258->data[0] = (Object)closure2258;
  Method *meth_meth_ast_2258__apply_40_1_41_ = addmethod2pos(block2257, "_apply(1)", &meth_ast_2258__apply_40_1_41_, 0);
  int argcv_meth_ast_2258__apply_40_1_41_[] = {1};
  meth_meth_ast_2258__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2258__apply_40_1_41_);
  meth_meth_ast_2258__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2258__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block2257 (depth = 4)
  gc_frame_newslot(block2257);
// call case 5: prelude request
  params[0] = call2256;
  params[1] = block2257;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2277 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2254);
// compiled call node returning call2277 (depth = 3)
// Begin line 524
  setline(524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2280 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2281 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2280);
// compiled member node returning call2281 (depth = 5)
  int op_slot_right_2279 = gc_frame_newslot(call2281);
// starting to compile identifier node (depth = 5)
  Object bool2283 = alloc_Boolean(0);
// compiled identifier node returning bool2283 (depth = 5)
  int op_slot_left_2279 = gc_frame_newslot(bool2283);
  params[0] = call2281;
  partcv[0] = 1;
  Object opresult2284 = callmethod(bool2283, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2284 (depth = 4)
  Object if2278 = done;
  if (istrue(opresult2284)) {
// Begin line 525
  setline(525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2286 == NULL) {
    strlit2286 = alloc_String("""\x0a""");
    gc_root(strlit2286);
  }
// compiled string node returning strlit2286 (depth = 6)
  int op_slot_right_2285 = gc_frame_newslot(strlit2286);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2285 = gc_frame_newslot(*var_s);
  params[0] = strlit2286;
  partcv[0] = 1;
  Object opresult2288 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2288 (depth = 5)
  *var_s = opresult2288;
  if (opresult2288 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 526
  setline(526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2291 == NULL) {
    strlit2291 = alloc_String("Pattern:");
    gc_root(strlit2291);
  }
// compiled string node returning strlit2291 (depth = 6)
  int op_slot_right_2290 = gc_frame_newslot(strlit2291);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_2293 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_2293 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2295 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2295 (depth = 6)
  int op_slot_left_2290 = gc_frame_newslot(opresult2295);
  params[0] = strlit2291;
  partcv[0] = 1;
  Object opresult2296 = callmethod(opresult2295, "++(1)", 1, partcv, params);
// compiled op node returning opresult2296 (depth = 5)
  *var_s = opresult2296;
  if (opresult2296 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 527
  setline(527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2299 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2301 = alloc_Float64(1);
// compiled num node returning num2301 (depth = 8)
  int op_slot_right_2300 = gc_frame_newslot(num2301);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_2300 = gc_frame_newslot(*var_depth);
  params[0] = num2301;
  partcv[0] = 1;
  Object sum2303 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2303 (depth = 7)
  gc_frame_newslot(sum2303);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2304 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2305 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2304);
// compiled member node returning call2305 (depth = 7)
  params[0] = sum2303;
  partcv[0] = 1;
  Object call2306 = callmethodflags(call2305, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2299);
// compiled call node returning call2306 (depth = 6)
  int op_slot_right_2298 = gc_frame_newslot(call2306);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_2308 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2311 == NULL) {
    strlit2311 = alloc_String("""\x0a""  ");
    gc_root(strlit2311);
  }
// compiled string node returning strlit2311 (depth = 8)
  int op_slot_right_2310 = gc_frame_newslot(strlit2311);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_2310 = gc_frame_newslot(*var_s);
  params[0] = strlit2311;
  partcv[0] = 1;
  Object opresult2313 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2313 (depth = 7)
  int op_slot_left_2308 = gc_frame_newslot(opresult2313);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2314 = callmethod(opresult2313, "++(1)", 1, partcv, params);
// compiled op node returning opresult2314 (depth = 6)
  int op_slot_left_2298 = gc_frame_newslot(opresult2314);
  params[0] = call2306;
  partcv[0] = 1;
  Object opresult2315 = callmethod(opresult2314, "++(1)", 1, partcv, params);
// compiled op node returning opresult2315 (depth = 5)
  *var_s = opresult2315;
  if (opresult2315 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2278 = done;
  } else {
  }
// compiled if node returning if2278 (depth = 3)
// Begin line 529
  setline(529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_2343__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 537
  setline(537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2344 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe2345 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2346 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2345);
// compiled member node returning call2346 (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2347 = callmethodflags(call2346, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2344);
// compiled call node returning call2347 (depth = 7)
  *var_p = call2347;
  if (call2347 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 538
  setline(538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2350 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2351 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2350);
// compiled member node returning call2351 (depth = 8)
  int op_slot_right_2349 = gc_frame_newslot(call2351);
// starting to compile identifier node (depth = 8)
  Object bool2353 = alloc_Boolean(0);
// compiled identifier node returning bool2353 (depth = 8)
  int op_slot_left_2349 = gc_frame_newslot(bool2353);
  params[0] = call2351;
  partcv[0] = 1;
  Object opresult2354 = callmethod(bool2353, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2354 (depth = 7)
  Object if2348 = done;
  if (istrue(opresult2354)) {
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2356 == NULL) {
    strlit2356 = alloc_String(")");
    gc_root(strlit2356);
  }
// compiled string node returning strlit2356 (depth = 9)
  int op_slot_right_2355 = gc_frame_newslot(strlit2356);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2359 = gc_frame_new();
// starting to compile num node (depth = 11)
  Object num2360 = alloc_Float64(0);
// compiled num node returning num2360 (depth = 11)
  gc_frame_newslot(num2360);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_p (depth = 11)
  params[0] = num2360;
  partcv[0] = 1;
  Object call2361 = callmethodflags(*var_p, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2359);
// compiled call node returning call2361 (depth = 10)
  int op_slot_right_2358 = gc_frame_newslot(call2361);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2364 == NULL) {
    strlit2364 = alloc_String("(");
    gc_root(strlit2364);
  }
// compiled string node returning strlit2364 (depth = 11)
  int op_slot_right_2363 = gc_frame_newslot(strlit2364);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_2363 = gc_frame_newslot(*var_s);
  params[0] = strlit2364;
  partcv[0] = 1;
  Object opresult2366 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2366 (depth = 10)
  int op_slot_left_2358 = gc_frame_newslot(opresult2366);
  params[0] = call2361;
  partcv[0] = 1;
  Object opresult2367 = callmethod(opresult2366, "++(1)", 1, partcv, params);
// compiled op node returning opresult2367 (depth = 9)
  int op_slot_left_2355 = gc_frame_newslot(opresult2367);
  params[0] = strlit2356;
  partcv[0] = 1;
  Object opresult2368 = callmethod(opresult2367, "++(1)", 1, partcv, params);
// compiled op node returning opresult2368 (depth = 8)
  *var_s = opresult2368;
  if (opresult2368 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2348 = done;
  } else {
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2371 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num2372 = alloc_Float64(0);
// compiled num node returning num2372 (depth = 10)
  gc_frame_newslot(num2372);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_p (depth = 10)
  params[0] = num2372;
  partcv[0] = 1;
  Object call2373 = callmethodflags(*var_p, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2371);
// compiled call node returning call2373 (depth = 9)
  int op_slot_right_2370 = gc_frame_newslot(call2373);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_2370 = gc_frame_newslot(*var_s);
  params[0] = call2373;
  partcv[0] = 1;
  Object opresult2375 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2375 (depth = 8)
  *var_s = opresult2375;
  if (opresult2375 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2348 = done;
  }
// compiled if node returning if2348 (depth = 6)
// Begin line 543
  setline(543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2379 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2380 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2381 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2380);
// compiled member node returning call2381 (depth = 9)
  partcv[0] = 0;
  Object call2382 = callmethodflags(call2381, "size", 1, partcv, params, 0);
  gc_frame_end(callframe2379);
// compiled member node returning call2382 (depth = 8)
  int op_slot_right_2378 = gc_frame_newslot(call2382);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  int op_slot_left_2378 = gc_frame_newslot(*var_i);
  params[0] = call2382;
  partcv[0] = 1;
  Object opresult2384 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult2384 (depth = 7)
  Object if2377 = done;
  if (istrue(opresult2384)) {
// Begin line 544
  setline(544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2386 == NULL) {
    strlit2386 = alloc_String(", ");
    gc_root(strlit2386);
  }
// compiled string node returning strlit2386 (depth = 9)
  int op_slot_right_2385 = gc_frame_newslot(strlit2386);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_2385 = gc_frame_newslot(*var_s);
  params[0] = strlit2386;
  partcv[0] = 1;
  Object opresult2388 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2388 (depth = 8)
  *var_s = opresult2388;
  if (opresult2388 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2377 = done;
  } else {
// Begin line 546
  setline(546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2391 == NULL) {
    strlit2391 = alloc_String(" ""\xe2""""\x86""""\x92""");
    gc_root(strlit2391);
  }
// compiled string node returning strlit2391 (depth = 9)
  int op_slot_right_2390 = gc_frame_newslot(strlit2391);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_2390 = gc_frame_newslot(*var_s);
  params[0] = strlit2391;
  partcv[0] = 1;
  Object opresult2393 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2393 (depth = 8)
  *var_s = opresult2393;
  if (opresult2393 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2377 = done;
  }
// compiled if node returning if2377 (depth = 6)
  gc_frame_end(frame);
  return if2377;
}
Object meth_ast_2401__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 551
  setline(551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2403 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2405 = alloc_Float64(1);
// compiled num node returning num2405 (depth = 9)
  int op_slot_right_2404 = gc_frame_newslot(num2405);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2404 = gc_frame_newslot(*var_depth);
  params[0] = num2405;
  partcv[0] = 1;
  Object sum2407 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2407 (depth = 8)
  gc_frame_newslot(sum2407);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum2407;
  partcv[0] = 1;
  Object call2408 = callmethodflags(*var_mx, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2403);
// compiled call node returning call2408 (depth = 7)
  int op_slot_right_2402 = gc_frame_newslot(call2408);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_2410 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2413 == NULL) {
    strlit2413 = alloc_String("""\x0a""");
    gc_root(strlit2413);
  }
// compiled string node returning strlit2413 (depth = 9)
  int op_slot_right_2412 = gc_frame_newslot(strlit2413);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_2412 = gc_frame_newslot(*var_s);
  params[0] = strlit2413;
  partcv[0] = 1;
  Object opresult2415 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2415 (depth = 8)
  int op_slot_left_2410 = gc_frame_newslot(opresult2415);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2416 = callmethod(opresult2415, "++(1)", 1, partcv, params);
// compiled op node returning opresult2416 (depth = 7)
  int op_slot_left_2402 = gc_frame_newslot(opresult2416);
  params[0] = call2408;
  partcv[0] = 1;
  Object opresult2417 = callmethod(opresult2416, "++(1)", 1, partcv, params);
// compiled op node returning opresult2417 (depth = 6)
  *var_s = opresult2417;
  if (opresult2417 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_2432__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2434 == NULL) {
    strlit2434 = alloc_String("    ");
    gc_root(strlit2434);
  }
// compiled string node returning strlit2434 (depth = 7)
  int op_slot_right_2433 = gc_frame_newslot(strlit2434);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_2433 = gc_frame_newslot(*var_s);
  params[0] = strlit2434;
  partcv[0] = 1;
  Object opresult2436 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2436 (depth = 6)
  *var_s = opresult2436;
  if (opresult2436 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_2317_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// definebindings:
// definebindings:
// Begin line 532
  setline(532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_2318 = gc_frame_newslot(*var_depth);
// starting to compile string node (depth = 5)
  if (strlit2320 == NULL) {
    strlit2320 = alloc_String("    ");
    gc_root(strlit2320);
  }
// compiled string node returning strlit2320 (depth = 5)
  int op_slot_left_2318 = gc_frame_newslot(strlit2320);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object prod2321 = callmethod(strlit2320, "*(1)", 1, partcv, params);
// compiled op node returning prod2321 (depth = 4)
  *var_spc = prod2321;
  if (prod2321 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2322 == NULL) {
    strlit2322 = alloc_String("{");
    gc_root(strlit2322);
  }
// compiled string node returning strlit2322 (depth = 4)
  *var_s = strlit2322;
  if (strlit2322 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2325 = alloc_Float64(0);
// compiled num node returning num2325 (depth = 5)
  int op_slot_right_2324 = gc_frame_newslot(num2325);
// starting to compile member node (depth = 5)
  int callframe2327 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2328 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2329 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2328);
// compiled member node returning call2329 (depth = 6)
  partcv[0] = 0;
  Object call2330 = callmethodflags(call2329, "size", 1, partcv, params, 0);
  gc_frame_end(callframe2327);
// compiled member node returning call2330 (depth = 5)
  int op_slot_left_2324 = gc_frame_newslot(call2330);
  params[0] = num2325;
  partcv[0] = 1;
  Object opresult2331 = callmethod(call2330, ">(1)", 1, partcv, params);
// compiled op node returning opresult2331 (depth = 4)
  Object if2323 = done;
  if (istrue(opresult2331)) {
// Begin line 535
  setline(535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2333 == NULL) {
    strlit2333 = alloc_String(" ");
    gc_root(strlit2333);
  }
// compiled string node returning strlit2333 (depth = 6)
  int op_slot_right_2332 = gc_frame_newslot(strlit2333);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2332 = gc_frame_newslot(*var_s);
  params[0] = strlit2333;
  partcv[0] = 1;
  Object opresult2335 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2335 (depth = 5)
  *var_s = opresult2335;
  if (opresult2335 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 536
  setline(536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2337 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2338 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2339 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2340 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2339);
// compiled member node returning call2340 (depth = 6)
  partcv[0] = 0;
  Object call2341 = callmethodflags(call2340, "indices", 1, partcv, params, 0);
  gc_frame_end(callframe2338);
// compiled member node returning call2341 (depth = 5)
  gc_frame_newslot(call2341);
// starting to compile block node (depth = 5)
  Object block2342 = alloc_Block(NULL, NULL, "ast", 536);
  gc_frame_newslot(block2342);
// method "_apply(_)"
  block_savedest(block2342);
  Object closure2343 = createclosure(2, "_apply(1)");
  setclosureframe(closure2343, stackframe);
  addtoclosure(closure2343, var_s);
  addtoclosure(closure2343, selfslot);
  struct UserObject *uo2343 = (struct UserObject*)block2342;
  uo2343->data[0] = (Object)closure2343;
  Method *meth_meth_ast_2343__apply_40_1_41_ = addmethod2pos(block2342, "_apply(1)", &meth_ast_2343__apply_40_1_41_, 0);
  int argcv_meth_ast_2343__apply_40_1_41_[] = {1};
  meth_meth_ast_2343__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2343__apply_40_1_41_);
  meth_meth_ast_2343__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2343__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block2342 (depth = 5)
  gc_frame_newslot(block2342);
// call case 5: prelude request
  params[0] = call2341;
  params[1] = block2342;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2396 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2337);
// compiled call node returning call2396 (depth = 4)
    gc_frame_newslot(call2396);
    if2323 = call2396;
  } else {
  }
// compiled if node returning if2323 (depth = 3)
// Begin line 550
  setline(550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2397 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2398 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2399 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2398);
// compiled member node returning call2399 (depth = 4)
  gc_frame_newslot(call2399);
// starting to compile block node (depth = 4)
  Object block2400 = alloc_Block(NULL, NULL, "ast", 550);
  gc_frame_newslot(block2400);
// method "_apply(_)"
  block_savedest(block2400);
  Object closure2401 = createclosure(4, "_apply(1)");
  setclosureframe(closure2401, stackframe);
  addtoclosure(closure2401, var_depth);
  addtoclosure(closure2401, var_spc);
  addtoclosure(closure2401, var_s);
  addtoclosure(closure2401, selfslot);
  struct UserObject *uo2401 = (struct UserObject*)block2400;
  uo2401->data[0] = (Object)closure2401;
  Method *meth_meth_ast_2401__apply_40_1_41_ = addmethod2pos(block2400, "_apply(1)", &meth_ast_2401__apply_40_1_41_, 0);
  int argcv_meth_ast_2401__apply_40_1_41_[] = {1};
  meth_meth_ast_2401__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2401__apply_40_1_41_);
  meth_meth_ast_2401__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2401__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block2400 (depth = 4)
  gc_frame_newslot(block2400);
// call case 5: prelude request
  params[0] = call2399;
  params[1] = block2400;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2420 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2397);
// compiled call node returning call2420 (depth = 3)
// Begin line 553
  setline(553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2422 == NULL) {
    strlit2422 = alloc_String("""\x0a""");
    gc_root(strlit2422);
  }
// compiled string node returning strlit2422 (depth = 5)
  int op_slot_right_2421 = gc_frame_newslot(strlit2422);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_2421 = gc_frame_newslot(*var_s);
  params[0] = strlit2422;
  partcv[0] = 1;
  Object opresult2424 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2424 (depth = 4)
  *var_s = opresult2424;
  if (opresult2424 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2426 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2428 = alloc_Float64(1);
// compiled num node returning num2428 (depth = 5)
  int op_slot_right_2427 = gc_frame_newslot(num2428);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_left_2427 = gc_frame_newslot(*var_depth);
  params[0] = num2428;
  partcv[0] = 1;
  Object diff2430 = callmethod(*var_depth, "-(1)", 1, partcv, params);
// compiled op node returning diff2430 (depth = 4)
  gc_frame_newslot(diff2430);
// starting to compile block node (depth = 4)
  Object block2431 = alloc_Block(NULL, NULL, "ast", 554);
  gc_frame_newslot(block2431);
// method "_apply"
  block_savedest(block2431);
  Object closure2432 = createclosure(2, "_apply");
  setclosureframe(closure2432, stackframe);
  addtoclosure(closure2432, var_s);
  addtoclosure(closure2432, selfslot);
  struct UserObject *uo2432 = (struct UserObject*)block2431;
  uo2432->data[0] = (Object)closure2432;
  Method *meth_meth_ast_2432__apply = addmethod2pos(block2431, "_apply", &meth_ast_2432__apply, 0);
  int argcv_meth_ast_2432__apply[] = {0};
  meth_meth_ast_2432__apply->type = alloc_MethodType(1, argcv_meth_ast_2432__apply);
  meth_meth_ast_2432__apply->definitionModule = modulename;
  meth_meth_ast_2432__apply->definitionLine = 3050;
// compiled block node returning block2431 (depth = 4)
  gc_frame_newslot(block2431);
// call case 5: prelude request
  params[0] = diff2430;
  params[1] = block2431;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2439 = callmethodflags(prelude, "repeat(1)times(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2426);
// compiled call node returning call2439 (depth = 3)
// Begin line 555
  setline(555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2441 == NULL) {
    strlit2441 = alloc_String("}");
    gc_root(strlit2441);
  }
// compiled string node returning strlit2441 (depth = 4)
  int op_slot_right_2440 = gc_frame_newslot(strlit2441);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_2440 = gc_frame_newslot(*var_s);
  params[0] = strlit2441;
  partcv[0] = 1;
  Object opresult2443 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2443 (depth = 3)
  gc_frame_end(frame);
  return opresult2443;
}
Object meth_ast_2444_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_blockNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 558
  setline(558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2445 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe2446 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2447 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2448 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2447);
// compiled member node returning call2448 (depth = 5)
  gc_frame_newslot(call2448);
// starting to compile member node (depth = 5)
  int callframe2449 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2450 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2449);
// compiled member node returning call2450 (depth = 5)
  gc_frame_newslot(call2450);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blockNode (depth = 5)
  params[0] = call2448;
  params[1] = call2450;
  partcv[0] = 2;
  Object call2451 = callmethodflags(*var_blockNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2446);
// compiled call node returning call2451 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call2452 = callmethodflags(call2451, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2445);
// compiled call node returning call2452 (depth = 3)
  gc_frame_end(frame);
  return call2452;
}
Object meth_ast_2453_postCopy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "postCopy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method postCopy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for postCopy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part postCopy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 561
  setline(561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2454 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2455 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call2456 = callmethodflags(*var_other, "matchingPattern", 1, partcv, params, 0);
  gc_frame_end(callframe2455);
// compiled member node returning call2456 (depth = 4)
  gc_frame_newslot(call2456);
// call case 4: self request
  params[0] = call2456;
  partcv[0] = 1;
  Object call2457 = callmethodflags(self, "matchingPattern:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2454);
// compiled call node returning call2457 (depth = 3)
// Begin line 562
  setline(562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2458 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2459 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call2460 = callmethodflags(*var_other, "extraRuntimeData", 1, partcv, params, 0);
  gc_frame_end(callframe2459);
// compiled member node returning call2460 (depth = 4)
  gc_frame_newslot(call2460);
// call case 4: self request
  params[0] = call2460;
  partcv[0] = 1;
  Object call2461 = callmethodflags(self, "extraRuntimeData:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2458);
// compiled call node returning call2461 (depth = 3)
// Begin line 563
  setline(563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_2471__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_patternMarkVisitor = getfromclosure(closure, 0);
  Object *var_ancestorChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2472 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_patternMarkVisitor (depth = 6)
  gc_frame_newslot(*var_patternMarkVisitor);
// starting to compile call node (depth = 6)
  int callframe2473 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ancestorChain (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call2474 = callmethodflags(*var_ancestorChain, "with(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2473);
// compiled call node returning call2474 (depth = 6)
  gc_frame_newslot(call2474);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  params[0] = *var_patternMarkVisitor;
  params[1] = call2474;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2475 = callmethodflags(*var_p, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2472);
// compiled call node returning call2475 (depth = 5)
  gc_frame_end(frame);
  return call2475;
}
Object meth_ast_2017_new_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_blockNode = getfromclosure(closure, 1);
  Object *var_patternMarkVisitor = getfromclosure(closure, 2);
  Object *var_ancestorChain = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2018 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2018 = alloc_userobj2(29,26, objclass2018);
  gc_frame_newslot(obj2018);
  if (objclass2018 == NULL) {
    glfree(obj2018->class->name);
    obj2018->class->name = "blockNode.new(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2018, self, 0);
  addmethodreal(obj2018,"outer", &reader_ast_outer_2019);
  Object oldself2018 = self;
  struct StackFrameObject *oldstackframe2018 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2018);
  gc_frame_newslot((Object)stackframe);
  self = obj2018;
  Object *oldselfslot2018 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2018 = (*(struct UserObject *)self).data[0], lowerouter2018 = thisouter2018;
  if (inheritingObject2018) {
    struct UserObject *inho2018 = (struct UserObject *)inheritingObject2018;
    while (inho2018->super != GraceDefaultObject) inho2018 = (struct UserObject *)inho2018->super;
    inho2018->super = obj2018;
    self = inheritingObject2018;
    *selfslot = self;
    lowerouter2018 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2018;
  }
  if (objclass2018 == NULL) {
  Method *reader2020 = addmethodrealflags(obj2018, "kind",&reader_ast_kind_2020, MFLAG_DEF);
  reader2020->definitionModule = modulename;
  reader2020->definitionLine = 450;
  }
  adddatum2(obj2018, alloc_Undefined(), 1);
  if (objclass2018 == NULL) {
  Method *reader2021 = addmethodrealflags(obj2018, "value",&reader_ast_value_2021, MFLAG_DEF);
  reader2021->definitionModule = modulename;
  reader2021->definitionLine = 451;
  }
  adddatum2(obj2018, alloc_Undefined(), 2);
  if (objclass2018 == NULL) {
    Method *reader2022 = addmethodrealflags(obj2018, "params", &reader_ast_params_2022, 0);
    Method *writer2022 = addmethodrealflags(obj2018, "params:=(1)", &writer_ast_params_2022, 0);
    reader2022->definitionModule = modulename;
    writer2022->definitionModule = modulename;
    reader2022->definitionLine = 452;
    writer2022->definitionLine = 452;
  }
  obj2018->flags |= OFLAG_MUTABLE;
  adddatum2(obj2018, alloc_Undefined(), 3);
  if (objclass2018 == NULL) {
    Method *reader2023 = addmethodrealflags(obj2018, "body", &reader_ast_body_2023, 0);
    Method *writer2023 = addmethodrealflags(obj2018, "body:=(1)", &writer_ast_body_2023, 0);
    reader2023->definitionModule = modulename;
    writer2023->definitionModule = modulename;
    reader2023->definitionLine = 453;
    writer2023->definitionLine = 453;
  }
  obj2018->flags |= OFLAG_MUTABLE;
  adddatum2(obj2018, alloc_Undefined(), 4);
  if (objclass2018 == NULL) {
  Method *reader2024 = addmethodrealflags(obj2018, "selfclosure",&reader_ast_selfclosure_2024, MFLAG_DEF);
  reader2024->definitionModule = modulename;
  reader2024->definitionLine = 454;
  }
  adddatum2(obj2018, alloc_Undefined(), 5);
  if (objclass2018 == NULL) {
    Method *reader2025 = addmethodrealflags(obj2018, "matchingPattern", &reader_ast_matchingPattern_2025, 0);
    Method *writer2025 = addmethodrealflags(obj2018, "matchingPattern:=(1)", &writer_ast_matchingPattern_2025, 0);
    reader2025->definitionModule = modulename;
    writer2025->definitionModule = modulename;
    reader2025->definitionLine = 455;
    writer2025->definitionLine = 455;
  }
  obj2018->flags |= OFLAG_MUTABLE;
  adddatum2(obj2018, alloc_Undefined(), 6);
  if (objclass2018 == NULL) {
    Method *reader2026 = addmethodrealflags(obj2018, "extraRuntimeData", &reader_ast_extraRuntimeData_2026, 0);
    Method *writer2026 = addmethodrealflags(obj2018, "extraRuntimeData:=(1)", &writer_ast_extraRuntimeData_2026, 0);
    reader2026->definitionModule = modulename;
    writer2026->definitionModule = modulename;
    reader2026->definitionLine = 456;
    writer2026->definitionLine = 456;
  }
  obj2018->flags |= OFLAG_MUTABLE;
  adddatum2(obj2018, alloc_Undefined(), 7);
// method "isBlock"
  struct UserObject *uo2027 = (struct UserObject*)obj2018;
  uo2027->data[8] = emptyclosure;
  Method *meth_meth_ast_2027_isBlock = addmethod2pos(obj2018, "isBlock", &meth_ast_2027_isBlock, 8);
  int argcv_meth_ast_2027_isBlock[] = {0};
  meth_meth_ast_2027_isBlock->type = alloc_MethodType(1, argcv_meth_ast_2027_isBlock);
  meth_meth_ast_2027_isBlock->definitionModule = modulename;
  meth_meth_ast_2027_isBlock->definitionLine = 460;
// method "isDelimited"
  struct UserObject *uo2029 = (struct UserObject*)obj2018;
  uo2029->data[9] = emptyclosure;
  Method *meth_meth_ast_2029_isDelimited = addmethod2pos(obj2018, "isDelimited", &meth_ast_2029_isDelimited, 9);
  int argcv_meth_ast_2029_isDelimited[] = {0};
  meth_meth_ast_2029_isDelimited->type = alloc_MethodType(1, argcv_meth_ast_2029_isDelimited);
  meth_meth_ast_2029_isDelimited->definitionModule = modulename;
  meth_meth_ast_2029_isDelimited->definitionLine = 461;
// method "isEmpty"
  struct UserObject *uo2031 = (struct UserObject*)obj2018;
  uo2031->data[10] = emptyclosure;
  Method *meth_meth_ast_2031_isEmpty = addmethod2pos(obj2018, "isEmpty", &meth_ast_2031_isEmpty, 10);
  int argcv_meth_ast_2031_isEmpty[] = {0};
  meth_meth_ast_2031_isEmpty->type = alloc_MethodType(1, argcv_meth_ast_2031_isEmpty);
  meth_meth_ast_2031_isEmpty->definitionModule = modulename;
  meth_meth_ast_2031_isEmpty->definitionLine = 462;
// method "isntEmpty"
  struct UserObject *uo2040 = (struct UserObject*)obj2018;
  uo2040->data[11] = emptyclosure;
  Method *meth_meth_ast_2040_isntEmpty = addmethod2pos(obj2018, "isntEmpty", &meth_ast_2040_isntEmpty, 11);
  int argcv_meth_ast_2040_isntEmpty[] = {0};
  meth_meth_ast_2040_isntEmpty->type = alloc_MethodType(1, argcv_meth_ast_2040_isntEmpty);
  meth_meth_ast_2040_isntEmpty->definitionModule = modulename;
  meth_meth_ast_2040_isntEmpty->definitionLine = 463;
// method "scope:=(_)"
  struct UserObject *uo2049 = (struct UserObject*)obj2018;
  uo2049->data[12] = emptyclosure;
  Method *meth_meth_ast_2049_scope_58__61__40_1_41_ = addmethod2pos(obj2018, "scope:=(1)", &meth_ast_2049_scope_58__61__40_1_41_, 12);
  int argcv_meth_ast_2049_scope_58__61__40_1_41_[] = {1};
  meth_meth_ast_2049_scope_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2049_scope_58__61__40_1_41_);
  meth_meth_ast_2049_scope_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_2049_scope_58__61__40_1_41_->definitionLine = 464;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj2018);
  Object closure2054 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure2054, stackframe);
  addtoclosure(closure2054, var_k);
  struct UserObject *uo2054 = (struct UserObject*)obj2018;
  uo2054->data[13] = (Object)closure2054;
  Method *meth_meth_ast_2054_declarationKindWithAncestors_40_1_41_ = addmethod2pos(obj2018, "declarationKindWithAncestors(1)", &meth_ast_2054_declarationKindWithAncestors_40_1_41_, 13);
  int argcv_meth_ast_2054_declarationKindWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_2054_declarationKindWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2054_declarationKindWithAncestors_40_1_41_);
  meth_meth_ast_2054_declarationKindWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2054_declarationKindWithAncestors_40_1_41_->definitionLine = 470;
// method "isMatchingBlock"
  struct UserObject *uo2057 = (struct UserObject*)obj2018;
  uo2057->data[14] = emptyclosure;
  Method *meth_meth_ast_2057_isMatchingBlock = addmethod2pos(obj2018, "isMatchingBlock", &meth_ast_2057_isMatchingBlock, 14);
  int argcv_meth_ast_2057_isMatchingBlock[] = {0};
  meth_meth_ast_2057_isMatchingBlock->type = alloc_MethodType(1, argcv_meth_ast_2057_isMatchingBlock);
  meth_meth_ast_2057_isMatchingBlock->definitionModule = modulename;
  meth_meth_ast_2057_isMatchingBlock->definitionLine = 471;
// method "returnsObject"
  struct UserObject *uo2066 = (struct UserObject*)obj2018;
  uo2066->data[15] = emptyclosure;
  Method *meth_meth_ast_2066_returnsObject = addmethod2pos(obj2018, "returnsObject", &meth_ast_2066_returnsObject, 15);
  int argcv_meth_ast_2066_returnsObject[] = {0};
  meth_meth_ast_2066_returnsObject->type = alloc_MethodType(1, argcv_meth_ast_2066_returnsObject);
  meth_meth_ast_2066_returnsObject->definitionModule = modulename;
  meth_meth_ast_2066_returnsObject->definitionLine = 472;
// method "returnedObjectScope"
  struct UserObject *uo2087 = (struct UserObject*)obj2018;
  uo2087->data[16] = emptyclosure;
  Method *meth_meth_ast_2087_returnedObjectScope = addmethod2pos(obj2018, "returnedObjectScope", &meth_ast_2087_returnedObjectScope, 16);
  int argcv_meth_ast_2087_returnedObjectScope[] = {0};
  meth_meth_ast_2087_returnedObjectScope->type = alloc_MethodType(1, argcv_meth_ast_2087_returnedObjectScope);
  meth_meth_ast_2087_returnedObjectScope->definitionModule = modulename;
  meth_meth_ast_2087_returnedObjectScope->definitionLine = 475;
// method "parametersDo(_)"
  struct UserObject *uo2094 = (struct UserObject*)obj2018;
  uo2094->data[17] = emptyclosure;
  Method *meth_meth_ast_2094_parametersDo_40_1_41_ = addmethod2pos(obj2018, "parametersDo(1)", &meth_ast_2094_parametersDo_40_1_41_, 17);
  int argcv_meth_ast_2094_parametersDo_40_1_41_[] = {1};
  meth_meth_ast_2094_parametersDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2094_parametersDo_40_1_41_);
  meth_meth_ast_2094_parametersDo_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2094_parametersDo_40_1_41_->definitionLine = 479;
// method "end"
  struct UserObject *uo2099 = (struct UserObject*)obj2018;
  uo2099->data[18] = emptyclosure;
  Method *meth_meth_ast_2099_end = addmethod2pos(obj2018, "end", &meth_ast_2099_end, 18);
  int argcv_meth_ast_2099_end[] = {0};
  meth_meth_ast_2099_end->type = alloc_MethodType(1, argcv_meth_ast_2099_end);
  meth_meth_ast_2099_end->definitionModule = modulename;
  meth_meth_ast_2099_end->definitionLine = 482;
// method "accept(_)from(_)"
  struct UserObject *uo2134 = (struct UserObject*)obj2018;
  uo2134->data[19] = emptyclosure;
  Method *meth_meth_ast_2134_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj2018, "accept(1)from(1)", &meth_ast_2134_accept_40_1_41_from_40_1_41_, 19);
  int argcv_meth_ast_2134_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_2134_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_2134_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_2134_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2134_accept_40_1_41_from_40_1_41_->definitionLine = 490;
// method "map(_)ancestors(_)"
  struct UserObject *uo2169 = (struct UserObject*)obj2018;
  uo2169->data[20] = emptyclosure;
  Method *meth_meth_ast_2169_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj2018, "map(1)ancestors(1)", &meth_ast_2169_map_40_1_41_ancestors_40_1_41_, 20);
  int argcv_meth_ast_2169_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_2169_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_2169_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_2169_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2169_map_40_1_41_ancestors_40_1_41_->definitionLine = 504;
// method "pretty(_)"
  struct UserObject *uo2194 = (struct UserObject*)obj2018;
  uo2194->data[21] = emptyclosure;
  Method *meth_meth_ast_2194_pretty_40_1_41_ = addmethod2pos(obj2018, "pretty(1)", &meth_ast_2194_pretty_40_1_41_, 21);
  int argcv_meth_ast_2194_pretty_40_1_41_[] = {1};
  meth_meth_ast_2194_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2194_pretty_40_1_41_);
  meth_meth_ast_2194_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2194_pretty_40_1_41_->definitionLine = 512;
// method "toGrace(_)"
  struct UserObject *uo2317 = (struct UserObject*)obj2018;
  uo2317->data[22] = emptyclosure;
  Method *meth_meth_ast_2317_toGrace_40_1_41_ = addmethod2pos(obj2018, "toGrace(1)", &meth_ast_2317_toGrace_40_1_41_, 22);
  int argcv_meth_ast_2317_toGrace_40_1_41_[] = {1};
  meth_meth_ast_2317_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2317_toGrace_40_1_41_);
meth_meth_ast_2317_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_2317_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_2317_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2317_toGrace_40_1_41_->definitionLine = 531;
// method "shallowCopy"
  block_savedest(obj2018);
  Object closure2444 = createclosure(1, "shallowCopy");
  setclosureframe(closure2444, stackframe);
  addtoclosure(closure2444, var_blockNode);
  struct UserObject *uo2444 = (struct UserObject*)obj2018;
  uo2444->data[23] = (Object)closure2444;
  Method *meth_meth_ast_2444_shallowCopy = addmethod2pos(obj2018, "shallowCopy", &meth_ast_2444_shallowCopy, 23);
  int argcv_meth_ast_2444_shallowCopy[] = {0};
  meth_meth_ast_2444_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_2444_shallowCopy);
  meth_meth_ast_2444_shallowCopy->definitionModule = modulename;
  meth_meth_ast_2444_shallowCopy->definitionLine = 557;
// method "postCopy(_)"
  struct UserObject *uo2453 = (struct UserObject*)obj2018;
  uo2453->data[24] = emptyclosure;
  Method *meth_meth_ast_2453_postCopy_40_1_41_ = addmethod2pos(obj2018, "postCopy(1)", &meth_ast_2453_postCopy_40_1_41_, 24);
  int argcv_meth_ast_2453_postCopy_40_1_41_[] = {1};
  meth_meth_ast_2453_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2453_postCopy_40_1_41_);
  meth_meth_ast_2453_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2453_postCopy_40_1_41_->definitionLine = 560;
  sourceObject = obj2018;
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2462 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2463 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2462);
// compiled call node returning call2463 (depth = 3)
  struct UserObject *obj2018_uo = (struct UserObject *)obj2018;
  obj2018_uo->super = call2463;
  sourceObject = obj2018;
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2464 == NULL) {
    strlit2464 = alloc_String("block");
    gc_root(strlit2464);
  }
// compiled string node returning strlit2464 (depth = 3)
  adddatum2(obj2018, strlit2464, 1);
  sourceObject = obj2018;
// Begin line 451
  setline(451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2465 == NULL) {
    strlit2465 = alloc_String("block");
    gc_root(strlit2465);
  }
// compiled string node returning strlit2465 (depth = 3)
  adddatum2(obj2018, strlit2465, 2);
  sourceObject = obj2018;
// Begin line 452
  setline(452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_params_39_ (depth = 3)
  adddatum2(obj2018, *var_params_39_, 3);
  sourceObject = obj2018;
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_body_39_ (depth = 3)
  adddatum2(obj2018, *var_body_39_, 4);
  sourceObject = obj2018;
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2466 = alloc_Boolean(1);
// compiled identifier node returning bool2466 (depth = 3)
  adddatum2(obj2018, bool2466, 5);
  sourceObject = obj2018;
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2467 = alloc_Boolean(0);
// compiled identifier node returning bool2467 (depth = 3)
  adddatum2(obj2018, bool2467, 6);
  sourceObject = obj2018;
// Begin line 456
  setline(456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2468 = alloc_Boolean(0);
// compiled identifier node returning bool2468 (depth = 3)
  adddatum2(obj2018, bool2468, 7);
  sourceObject = obj2018;
// Begin line 457
  setline(457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2469 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_params_39_ (depth = 4)
  gc_frame_newslot(*var_params_39_);
// starting to compile block node (depth = 4)
  Object block2470 = alloc_Block(NULL, NULL, "ast", 457);
  gc_frame_newslot(block2470);
// method "_apply(_)"
  block_savedest(block2470);
  Object closure2471 = createclosure(3, "_apply(1)");
  setclosureframe(closure2471, stackframe);
  addtoclosure(closure2471, var_patternMarkVisitor);
  addtoclosure(closure2471, var_ancestorChain);
  addtoclosure(closure2471, selfslot);
  struct UserObject *uo2471 = (struct UserObject*)block2470;
  uo2471->data[0] = (Object)closure2471;
  Method *meth_meth_ast_2471__apply_40_1_41_ = addmethod2pos(block2470, "_apply(1)", &meth_ast_2471__apply_40_1_41_, 0);
  int argcv_meth_ast_2471__apply_40_1_41_[] = {1};
  meth_meth_ast_2471__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2471__apply_40_1_41_);
  meth_meth_ast_2471__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2471__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block2470 (depth = 4)
  gc_frame_newslot(block2470);
// call case 5: prelude request
  params[0] = *var_params_39_;
  params[1] = block2470;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2477 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2469);
// compiled call node returning call2477 (depth = 3)
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  objclass2018 = obj2018->class;
  objclass2018->definitionModule = modulename;
  objclass2018->definitionLine = 448;
  (*(struct UserObject *)self).data[0] = lowerouter2018;
  self = oldself2018;
  selfslot = oldselfslot2018;
  stackframe = oldstackframe2018;
  gc_frame_end(frame);
  return obj2018;
}
Object meth_ast_2017_new_40_2_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_blockNode = getfromclosure(closure, 1);
  Object *var_patternMarkVisitor = getfromclosure(closure, 2);
  Object *var_ancestorChain = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2018 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2018 = alloc_userobj2(29,26, objclass2018);
  gc_frame_newslot(obj2018);
  if (objclass2018 == NULL) {
    glfree(obj2018->class->name);
    obj2018->class->name = "blockNode.new(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2018, self, 0);
  addmethodreal(obj2018,"outer", &reader_ast_outer_2019);
  Object oldself2018 = self;
  struct StackFrameObject *oldstackframe2018 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2018);
  gc_frame_newslot((Object)stackframe);
  self = obj2018;
  Object *oldselfslot2018 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2018 = (*(struct UserObject *)self).data[0], lowerouter2018 = thisouter2018;
  if (inheritingObject2018) {
    struct UserObject *inho2018 = (struct UserObject *)inheritingObject2018;
    while (inho2018->super != GraceDefaultObject) inho2018 = (struct UserObject *)inho2018->super;
    inho2018->super = obj2018;
    self = inheritingObject2018;
    *selfslot = self;
    lowerouter2018 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2018;
  }
  if (objclass2018 == NULL) {
  Method *reader2020 = addmethodrealflags(obj2018, "kind",&reader_ast_kind_2020, MFLAG_DEF);
  reader2020->definitionModule = modulename;
  reader2020->definitionLine = 450;
  }
  adddatum2(obj2018, alloc_Undefined(), 1);
  if (objclass2018 == NULL) {
  Method *reader2021 = addmethodrealflags(obj2018, "value",&reader_ast_value_2021, MFLAG_DEF);
  reader2021->definitionModule = modulename;
  reader2021->definitionLine = 451;
  }
  adddatum2(obj2018, alloc_Undefined(), 2);
  if (objclass2018 == NULL) {
    Method *reader2022 = addmethodrealflags(obj2018, "params", &reader_ast_params_2022, 0);
    Method *writer2022 = addmethodrealflags(obj2018, "params:=(1)", &writer_ast_params_2022, 0);
    reader2022->definitionModule = modulename;
    writer2022->definitionModule = modulename;
    reader2022->definitionLine = 452;
    writer2022->definitionLine = 452;
  }
  obj2018->flags |= OFLAG_MUTABLE;
  adddatum2(obj2018, alloc_Undefined(), 3);
  if (objclass2018 == NULL) {
    Method *reader2023 = addmethodrealflags(obj2018, "body", &reader_ast_body_2023, 0);
    Method *writer2023 = addmethodrealflags(obj2018, "body:=(1)", &writer_ast_body_2023, 0);
    reader2023->definitionModule = modulename;
    writer2023->definitionModule = modulename;
    reader2023->definitionLine = 453;
    writer2023->definitionLine = 453;
  }
  obj2018->flags |= OFLAG_MUTABLE;
  adddatum2(obj2018, alloc_Undefined(), 4);
  if (objclass2018 == NULL) {
  Method *reader2024 = addmethodrealflags(obj2018, "selfclosure",&reader_ast_selfclosure_2024, MFLAG_DEF);
  reader2024->definitionModule = modulename;
  reader2024->definitionLine = 454;
  }
  adddatum2(obj2018, alloc_Undefined(), 5);
  if (objclass2018 == NULL) {
    Method *reader2025 = addmethodrealflags(obj2018, "matchingPattern", &reader_ast_matchingPattern_2025, 0);
    Method *writer2025 = addmethodrealflags(obj2018, "matchingPattern:=(1)", &writer_ast_matchingPattern_2025, 0);
    reader2025->definitionModule = modulename;
    writer2025->definitionModule = modulename;
    reader2025->definitionLine = 455;
    writer2025->definitionLine = 455;
  }
  obj2018->flags |= OFLAG_MUTABLE;
  adddatum2(obj2018, alloc_Undefined(), 6);
  if (objclass2018 == NULL) {
    Method *reader2026 = addmethodrealflags(obj2018, "extraRuntimeData", &reader_ast_extraRuntimeData_2026, 0);
    Method *writer2026 = addmethodrealflags(obj2018, "extraRuntimeData:=(1)", &writer_ast_extraRuntimeData_2026, 0);
    reader2026->definitionModule = modulename;
    writer2026->definitionModule = modulename;
    reader2026->definitionLine = 456;
    writer2026->definitionLine = 456;
  }
  obj2018->flags |= OFLAG_MUTABLE;
  adddatum2(obj2018, alloc_Undefined(), 7);
// method "isBlock"
  struct UserObject *uo2027 = (struct UserObject*)obj2018;
  uo2027->data[8] = emptyclosure;
  Method *meth_meth_ast_2027_isBlock = addmethod2pos(obj2018, "isBlock", &meth_ast_2027_isBlock, 8);
  int argcv_meth_ast_2027_isBlock[] = {0};
  meth_meth_ast_2027_isBlock->type = alloc_MethodType(1, argcv_meth_ast_2027_isBlock);
  meth_meth_ast_2027_isBlock->definitionModule = modulename;
  meth_meth_ast_2027_isBlock->definitionLine = 460;
// method "isDelimited"
  struct UserObject *uo2029 = (struct UserObject*)obj2018;
  uo2029->data[9] = emptyclosure;
  Method *meth_meth_ast_2029_isDelimited = addmethod2pos(obj2018, "isDelimited", &meth_ast_2029_isDelimited, 9);
  int argcv_meth_ast_2029_isDelimited[] = {0};
  meth_meth_ast_2029_isDelimited->type = alloc_MethodType(1, argcv_meth_ast_2029_isDelimited);
  meth_meth_ast_2029_isDelimited->definitionModule = modulename;
  meth_meth_ast_2029_isDelimited->definitionLine = 461;
// method "isEmpty"
  struct UserObject *uo2031 = (struct UserObject*)obj2018;
  uo2031->data[10] = emptyclosure;
  Method *meth_meth_ast_2031_isEmpty = addmethod2pos(obj2018, "isEmpty", &meth_ast_2031_isEmpty, 10);
  int argcv_meth_ast_2031_isEmpty[] = {0};
  meth_meth_ast_2031_isEmpty->type = alloc_MethodType(1, argcv_meth_ast_2031_isEmpty);
  meth_meth_ast_2031_isEmpty->definitionModule = modulename;
  meth_meth_ast_2031_isEmpty->definitionLine = 462;
// method "isntEmpty"
  struct UserObject *uo2040 = (struct UserObject*)obj2018;
  uo2040->data[11] = emptyclosure;
  Method *meth_meth_ast_2040_isntEmpty = addmethod2pos(obj2018, "isntEmpty", &meth_ast_2040_isntEmpty, 11);
  int argcv_meth_ast_2040_isntEmpty[] = {0};
  meth_meth_ast_2040_isntEmpty->type = alloc_MethodType(1, argcv_meth_ast_2040_isntEmpty);
  meth_meth_ast_2040_isntEmpty->definitionModule = modulename;
  meth_meth_ast_2040_isntEmpty->definitionLine = 463;
// method "scope:=(_)"
  struct UserObject *uo2049 = (struct UserObject*)obj2018;
  uo2049->data[12] = emptyclosure;
  Method *meth_meth_ast_2049_scope_58__61__40_1_41_ = addmethod2pos(obj2018, "scope:=(1)", &meth_ast_2049_scope_58__61__40_1_41_, 12);
  int argcv_meth_ast_2049_scope_58__61__40_1_41_[] = {1};
  meth_meth_ast_2049_scope_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2049_scope_58__61__40_1_41_);
  meth_meth_ast_2049_scope_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_2049_scope_58__61__40_1_41_->definitionLine = 464;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj2018);
  Object closure2054 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure2054, stackframe);
  addtoclosure(closure2054, var_k);
  struct UserObject *uo2054 = (struct UserObject*)obj2018;
  uo2054->data[13] = (Object)closure2054;
  Method *meth_meth_ast_2054_declarationKindWithAncestors_40_1_41_ = addmethod2pos(obj2018, "declarationKindWithAncestors(1)", &meth_ast_2054_declarationKindWithAncestors_40_1_41_, 13);
  int argcv_meth_ast_2054_declarationKindWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_2054_declarationKindWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2054_declarationKindWithAncestors_40_1_41_);
  meth_meth_ast_2054_declarationKindWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2054_declarationKindWithAncestors_40_1_41_->definitionLine = 470;
// method "isMatchingBlock"
  struct UserObject *uo2057 = (struct UserObject*)obj2018;
  uo2057->data[14] = emptyclosure;
  Method *meth_meth_ast_2057_isMatchingBlock = addmethod2pos(obj2018, "isMatchingBlock", &meth_ast_2057_isMatchingBlock, 14);
  int argcv_meth_ast_2057_isMatchingBlock[] = {0};
  meth_meth_ast_2057_isMatchingBlock->type = alloc_MethodType(1, argcv_meth_ast_2057_isMatchingBlock);
  meth_meth_ast_2057_isMatchingBlock->definitionModule = modulename;
  meth_meth_ast_2057_isMatchingBlock->definitionLine = 471;
// method "returnsObject"
  struct UserObject *uo2066 = (struct UserObject*)obj2018;
  uo2066->data[15] = emptyclosure;
  Method *meth_meth_ast_2066_returnsObject = addmethod2pos(obj2018, "returnsObject", &meth_ast_2066_returnsObject, 15);
  int argcv_meth_ast_2066_returnsObject[] = {0};
  meth_meth_ast_2066_returnsObject->type = alloc_MethodType(1, argcv_meth_ast_2066_returnsObject);
  meth_meth_ast_2066_returnsObject->definitionModule = modulename;
  meth_meth_ast_2066_returnsObject->definitionLine = 472;
// method "returnedObjectScope"
  struct UserObject *uo2087 = (struct UserObject*)obj2018;
  uo2087->data[16] = emptyclosure;
  Method *meth_meth_ast_2087_returnedObjectScope = addmethod2pos(obj2018, "returnedObjectScope", &meth_ast_2087_returnedObjectScope, 16);
  int argcv_meth_ast_2087_returnedObjectScope[] = {0};
  meth_meth_ast_2087_returnedObjectScope->type = alloc_MethodType(1, argcv_meth_ast_2087_returnedObjectScope);
  meth_meth_ast_2087_returnedObjectScope->definitionModule = modulename;
  meth_meth_ast_2087_returnedObjectScope->definitionLine = 475;
// method "parametersDo(_)"
  struct UserObject *uo2094 = (struct UserObject*)obj2018;
  uo2094->data[17] = emptyclosure;
  Method *meth_meth_ast_2094_parametersDo_40_1_41_ = addmethod2pos(obj2018, "parametersDo(1)", &meth_ast_2094_parametersDo_40_1_41_, 17);
  int argcv_meth_ast_2094_parametersDo_40_1_41_[] = {1};
  meth_meth_ast_2094_parametersDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2094_parametersDo_40_1_41_);
  meth_meth_ast_2094_parametersDo_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2094_parametersDo_40_1_41_->definitionLine = 479;
// method "end"
  struct UserObject *uo2099 = (struct UserObject*)obj2018;
  uo2099->data[18] = emptyclosure;
  Method *meth_meth_ast_2099_end = addmethod2pos(obj2018, "end", &meth_ast_2099_end, 18);
  int argcv_meth_ast_2099_end[] = {0};
  meth_meth_ast_2099_end->type = alloc_MethodType(1, argcv_meth_ast_2099_end);
  meth_meth_ast_2099_end->definitionModule = modulename;
  meth_meth_ast_2099_end->definitionLine = 482;
// method "accept(_)from(_)"
  struct UserObject *uo2134 = (struct UserObject*)obj2018;
  uo2134->data[19] = emptyclosure;
  Method *meth_meth_ast_2134_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj2018, "accept(1)from(1)", &meth_ast_2134_accept_40_1_41_from_40_1_41_, 19);
  int argcv_meth_ast_2134_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_2134_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_2134_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_2134_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2134_accept_40_1_41_from_40_1_41_->definitionLine = 490;
// method "map(_)ancestors(_)"
  struct UserObject *uo2169 = (struct UserObject*)obj2018;
  uo2169->data[20] = emptyclosure;
  Method *meth_meth_ast_2169_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj2018, "map(1)ancestors(1)", &meth_ast_2169_map_40_1_41_ancestors_40_1_41_, 20);
  int argcv_meth_ast_2169_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_2169_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_2169_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_2169_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2169_map_40_1_41_ancestors_40_1_41_->definitionLine = 504;
// method "pretty(_)"
  struct UserObject *uo2194 = (struct UserObject*)obj2018;
  uo2194->data[21] = emptyclosure;
  Method *meth_meth_ast_2194_pretty_40_1_41_ = addmethod2pos(obj2018, "pretty(1)", &meth_ast_2194_pretty_40_1_41_, 21);
  int argcv_meth_ast_2194_pretty_40_1_41_[] = {1};
  meth_meth_ast_2194_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2194_pretty_40_1_41_);
  meth_meth_ast_2194_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2194_pretty_40_1_41_->definitionLine = 512;
// method "toGrace(_)"
  struct UserObject *uo2317 = (struct UserObject*)obj2018;
  uo2317->data[22] = emptyclosure;
  Method *meth_meth_ast_2317_toGrace_40_1_41_ = addmethod2pos(obj2018, "toGrace(1)", &meth_ast_2317_toGrace_40_1_41_, 22);
  int argcv_meth_ast_2317_toGrace_40_1_41_[] = {1};
  meth_meth_ast_2317_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2317_toGrace_40_1_41_);
meth_meth_ast_2317_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_2317_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_2317_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2317_toGrace_40_1_41_->definitionLine = 531;
// method "shallowCopy"
  block_savedest(obj2018);
  Object closure2444 = createclosure(1, "shallowCopy");
  setclosureframe(closure2444, stackframe);
  addtoclosure(closure2444, var_blockNode);
  struct UserObject *uo2444 = (struct UserObject*)obj2018;
  uo2444->data[23] = (Object)closure2444;
  Method *meth_meth_ast_2444_shallowCopy = addmethod2pos(obj2018, "shallowCopy", &meth_ast_2444_shallowCopy, 23);
  int argcv_meth_ast_2444_shallowCopy[] = {0};
  meth_meth_ast_2444_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_2444_shallowCopy);
  meth_meth_ast_2444_shallowCopy->definitionModule = modulename;
  meth_meth_ast_2444_shallowCopy->definitionLine = 557;
// method "postCopy(_)"
  struct UserObject *uo2453 = (struct UserObject*)obj2018;
  uo2453->data[24] = emptyclosure;
  Method *meth_meth_ast_2453_postCopy_40_1_41_ = addmethod2pos(obj2018, "postCopy(1)", &meth_ast_2453_postCopy_40_1_41_, 24);
  int argcv_meth_ast_2453_postCopy_40_1_41_[] = {1};
  meth_meth_ast_2453_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2453_postCopy_40_1_41_);
  meth_meth_ast_2453_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2453_postCopy_40_1_41_->definitionLine = 560;
  sourceObject = obj2018;
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2462 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2463 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2462);
// compiled call node returning call2463 (depth = 3)
  struct UserObject *obj2018_uo = (struct UserObject *)obj2018;
  obj2018_uo->super = call2463;
  sourceObject = obj2018;
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2464 == NULL) {
    strlit2464 = alloc_String("block");
    gc_root(strlit2464);
  }
// compiled string node returning strlit2464 (depth = 3)
  adddatum2(obj2018, strlit2464, 1);
  sourceObject = obj2018;
// Begin line 451
  setline(451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2465 == NULL) {
    strlit2465 = alloc_String("block");
    gc_root(strlit2465);
  }
// compiled string node returning strlit2465 (depth = 3)
  adddatum2(obj2018, strlit2465, 2);
  sourceObject = obj2018;
// Begin line 452
  setline(452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_params_39_ (depth = 3)
  adddatum2(obj2018, *var_params_39_, 3);
  sourceObject = obj2018;
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_body_39_ (depth = 3)
  adddatum2(obj2018, *var_body_39_, 4);
  sourceObject = obj2018;
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2466 = alloc_Boolean(1);
// compiled identifier node returning bool2466 (depth = 3)
  adddatum2(obj2018, bool2466, 5);
  sourceObject = obj2018;
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2467 = alloc_Boolean(0);
// compiled identifier node returning bool2467 (depth = 3)
  adddatum2(obj2018, bool2467, 6);
  sourceObject = obj2018;
// Begin line 456
  setline(456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2468 = alloc_Boolean(0);
// compiled identifier node returning bool2468 (depth = 3)
  adddatum2(obj2018, bool2468, 7);
  sourceObject = obj2018;
// Begin line 457
  setline(457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2469 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_params_39_ (depth = 4)
  gc_frame_newslot(*var_params_39_);
// starting to compile block node (depth = 4)
  Object block2470 = alloc_Block(NULL, NULL, "ast", 457);
  gc_frame_newslot(block2470);
// method "_apply(_)"
  block_savedest(block2470);
  Object closure2471 = createclosure(3, "_apply(1)");
  setclosureframe(closure2471, stackframe);
  addtoclosure(closure2471, var_patternMarkVisitor);
  addtoclosure(closure2471, var_ancestorChain);
  addtoclosure(closure2471, selfslot);
  struct UserObject *uo2471 = (struct UserObject*)block2470;
  uo2471->data[0] = (Object)closure2471;
  Method *meth_meth_ast_2471__apply_40_1_41_ = addmethod2pos(block2470, "_apply(1)", &meth_ast_2471__apply_40_1_41_, 0);
  int argcv_meth_ast_2471__apply_40_1_41_[] = {1};
  meth_meth_ast_2471__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2471__apply_40_1_41_);
  meth_meth_ast_2471__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2471__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block2470 (depth = 4)
  gc_frame_newslot(block2470);
// call case 5: prelude request
  params[0] = *var_params_39_;
  params[1] = block2470;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2477 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2469);
// compiled call node returning call2477 (depth = 3)
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  sourceObject = obj2018;
  objclass2018 = obj2018->class;
  objclass2018->definitionModule = modulename;
  objclass2018->definitionLine = 448;
  (*(struct UserObject *)self).data[0] = lowerouter2018;
  self = oldself2018;
  selfslot = oldselfslot2018;
  stackframe = oldstackframe2018;
  gc_frame_end(frame);
  return obj2018;
}
Object meth_ast_2479_blockNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blockNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blockNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 447
  setline(447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blockNode (depth = 3)
  gc_frame_end(frame);
  return *var_blockNode;
}
Object meth_ast_2489_isSimple(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 574
  setline(574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2490 = alloc_Boolean(0);
// compiled identifier node returning bool2490 (depth = 3)
  gc_frame_end(frame);
  return bool2490;
}
Object meth_ast_2491_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 576
  setline(576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2494 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2495 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2494);
// compiled member node returning call2495 (depth = 5)
  int op_slot_right_2493 = gc_frame_newslot(call2495);
// starting to compile identifier node (depth = 5)
  Object bool2497 = alloc_Boolean(0);
// compiled identifier node returning bool2497 (depth = 5)
  int op_slot_left_2493 = gc_frame_newslot(bool2497);
  params[0] = call2495;
  partcv[0] = 1;
  Object opresult2498 = callmethod(bool2497, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2498 (depth = 4)
  Object if2492 = done;
  if (istrue(opresult2498)) {
// starting to compile return node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2499 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2500 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2501 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2500);
// compiled member node returning call2501 (depth = 6)
  partcv[0] = 0;
  Object call2502 = callmethodflags(call2501, "end", 1, partcv, params, 0);
  gc_frame_end(callframe2499);
// compiled member node returning call2502 (depth = 5)
  return call2502;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if2492 = undefined;
  } else {
  }
// compiled if node returning if2492 (depth = 3)
// Begin line 577
  setline(577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2504 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2505 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2506 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2507 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2506);
// compiled member node returning call2507 (depth = 6)
  partcv[0] = 0;
  Object call2508 = callmethodflags(call2507, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe2505);
// compiled member node returning call2508 (depth = 5)
  partcv[0] = 0;
  Object call2509 = callmethodflags(call2508, "not", 1, partcv, params, 0);
  gc_frame_end(callframe2504);
// compiled member node returning call2509 (depth = 4)
  Object if2503 = done;
  if (istrue(call2509)) {
// starting to compile return node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2510 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2511 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2512 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2513 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2512);
// compiled member node returning call2513 (depth = 7)
  partcv[0] = 0;
  Object call2514 = callmethodflags(call2513, "last", 1, partcv, params, 0);
  gc_frame_end(callframe2511);
// compiled member node returning call2514 (depth = 6)
  partcv[0] = 0;
  Object call2515 = callmethodflags(call2514, "end", 1, partcv, params, 0);
  gc_frame_end(callframe2510);
// compiled member node returning call2515 (depth = 5)
  return call2515;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if2503 = undefined;
  } else {
  }
// compiled if node returning if2503 (depth = 3)
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2516 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2517 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2518 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2517);
// compiled member node returning call2518 (depth = 5)
  partcv[0] = 0;
  Object call2519 = callmethodflags(call2518, "end", 1, partcv, params, 0);
  gc_frame_end(callframe2516);
// compiled member node returning call2519 (depth = 4)
  return call2519;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_2534__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 585
  setline(585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2535 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2536 = callmethodflags(*var_mx, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2535);
// compiled call node returning call2536 (depth = 6)
  gc_frame_end(frame);
  return call2536;
}
Object meth_ast_2520_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// definebindings:
// definebindings:
// definebindings:
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2522 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2523 = callmethodflags(*var_visitor, "visitTryCatch(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2522);
// compiled call node returning call2523 (depth = 4)
  Object if2521 = done;
  if (istrue(call2523)) {
// Begin line 582
  setline(582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2524 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call2525 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2524);
// compiled call node returning call2525 (depth = 5)
  *var_newChain = call2525;
  if (call2525 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 583
  setline(583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2526 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2527 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2528 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2527);
// compiled member node returning call2528 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2529 = callmethodflags(call2528, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2526);
// compiled call node returning call2529 (depth = 4)
// Begin line 584
  setline(584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2530 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2531 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2532 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2531);
// compiled member node returning call2532 (depth = 5)
  gc_frame_newslot(call2532);
// starting to compile block node (depth = 5)
  Object block2533 = alloc_Block(NULL, NULL, "ast", 584);
  gc_frame_newslot(block2533);
// method "_apply(_)"
  block_savedest(block2533);
  Object closure2534 = createclosure(3, "_apply(1)");
  setclosureframe(closure2534, stackframe);
  addtoclosure(closure2534, var_visitor);
  addtoclosure(closure2534, var_newChain);
  addtoclosure(closure2534, selfslot);
  struct UserObject *uo2534 = (struct UserObject*)block2533;
  uo2534->data[0] = (Object)closure2534;
  Method *meth_meth_ast_2534__apply_40_1_41_ = addmethod2pos(block2533, "_apply(1)", &meth_ast_2534__apply_40_1_41_, 0);
  int argcv_meth_ast_2534__apply_40_1_41_[] = {1};
  meth_meth_ast_2534__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2534__apply_40_1_41_);
  meth_meth_ast_2534__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2534__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block2533 (depth = 5)
  gc_frame_newslot(block2533);
// call case 5: prelude request
  params[0] = call2532;
  params[1] = block2533;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2538 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2530);
// compiled call node returning call2538 (depth = 4)
// Begin line 587
  setline(587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2541 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2542 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2541);
// compiled member node returning call2542 (depth = 6)
  int op_slot_right_2540 = gc_frame_newslot(call2542);
// starting to compile identifier node (depth = 6)
  Object bool2544 = alloc_Boolean(0);
// compiled identifier node returning bool2544 (depth = 6)
  int op_slot_left_2540 = gc_frame_newslot(bool2544);
  params[0] = call2542;
  partcv[0] = 1;
  Object opresult2545 = callmethod(bool2544, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2545 (depth = 5)
  Object if2539 = done;
  if (istrue(opresult2545)) {
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2546 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2547 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2548 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2547);
// compiled member node returning call2548 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2549 = callmethodflags(call2548, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2546);
// compiled call node returning call2549 (depth = 5)
    gc_frame_newslot(call2549);
    if2539 = call2549;
  } else {
  }
// compiled if node returning if2539 (depth = 4)
    gc_frame_newslot(if2539);
    if2521 = if2539;
  } else {
  }
// compiled if node returning if2521 (depth = 3)
  gc_frame_end(frame);
  return if2521;
}
Object meth_ast_2550_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 593
  setline(593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2551 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2552 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2551);
// compiled member node returning call2552 (depth = 4)
  *var_n = call2552;
  if (call2552 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 594
  setline(594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2553 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2554 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2553);
// compiled call node returning call2554 (depth = 4)
  *var_newChain = call2554;
  if (call2554 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 595
  setline(595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2555 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2556 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2557 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2558 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2557);
// compiled member node returning call2558 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2559 = callmethodflags(call2558, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2556);
// compiled call node returning call2559 (depth = 4)
  gc_frame_newslot(call2559);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2559;
  partcv[0] = 1;
  Object call2560 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2555);
// compiled call node returning call2560 (depth = 3)
// Begin line 596
  setline(596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2561 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2562 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2563 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2564 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2563);
// compiled member node returning call2564 (depth = 5)
  gc_frame_newslot(call2564);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call2564;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2565 = callmethodflags(module_ast, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2562);
// compiled call node returning call2565 (depth = 4)
  gc_frame_newslot(call2565);
// call case 6: other requests
// Begin line 596
  setline(596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2565;
  partcv[0] = 1;
  Object call2566 = callmethodflags(*var_n, "cases:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2561);
// compiled call node returning call2566 (depth = 3)
// Begin line 597
  setline(597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2567 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2568 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2569 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2570 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2569);
// compiled member node returning call2570 (depth = 5)
  gc_frame_newslot(call2570);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call2570;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2571 = callmethodflags(module_ast, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2568);
// compiled call node returning call2571 (depth = 4)
  gc_frame_newslot(call2571);
// call case 6: other requests
// Begin line 597
  setline(597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2571;
  partcv[0] = 1;
  Object call2572 = callmethodflags(*var_n, "finally:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2567);
// compiled call node returning call2572 (depth = 3)
// Begin line 598
  setline(598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2573 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call2574 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2573);
// compiled call node returning call2574 (depth = 3)
  gc_frame_end(frame);
  return call2574;
}
Object meth_ast_2613__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 605
  setline(605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2616 == NULL) {
    strlit2616 = alloc_String("");
    gc_root(strlit2616);
  }
// compiled string node returning strlit2616 (depth = 8)
  int op_slot_right_2615 = gc_frame_newslot(strlit2616);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2619 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2621 = alloc_Float64(2);
// compiled num node returning num2621 (depth = 11)
  int op_slot_right_2620 = gc_frame_newslot(num2621);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_2620 = gc_frame_newslot(*var_depth);
  params[0] = num2621;
  partcv[0] = 1;
  Object sum2623 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2623 (depth = 10)
  gc_frame_newslot(sum2623);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mx (depth = 10)
  params[0] = sum2623;
  partcv[0] = 1;
  Object call2624 = callmethodflags(*var_mx, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2619);
// compiled call node returning call2624 (depth = 9)
  int op_slot_right_2618 = gc_frame_newslot(call2624);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2627 == NULL) {
    strlit2627 = alloc_String("  ");
    gc_root(strlit2627);
  }
// compiled string node returning strlit2627 (depth = 10)
  int op_slot_right_2626 = gc_frame_newslot(strlit2627);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_2629 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2632 == NULL) {
    strlit2632 = alloc_String("Case:""\x0a""");
    gc_root(strlit2632);
  }
// compiled string node returning strlit2632 (depth = 12)
  int op_slot_right_2631 = gc_frame_newslot(strlit2632);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_2634 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 13)
  if (strlit2636 == NULL) {
    strlit2636 = alloc_String("""\x0a""");
    gc_root(strlit2636);
  }
// compiled string node returning strlit2636 (depth = 13)
  int op_slot_left_2634 = gc_frame_newslot(strlit2636);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2637 = callmethod(strlit2636, "++(1)", 1, partcv, params);
// compiled op node returning opresult2637 (depth = 12)
  int op_slot_left_2631 = gc_frame_newslot(opresult2637);
  params[0] = strlit2632;
  partcv[0] = 1;
  Object opresult2638 = callmethod(opresult2637, "++(1)", 1, partcv, params);
// compiled op node returning opresult2638 (depth = 11)
  int op_slot_left_2629 = gc_frame_newslot(opresult2638);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2639 = callmethod(opresult2638, "++(1)", 1, partcv, params);
// compiled op node returning opresult2639 (depth = 10)
  int op_slot_left_2626 = gc_frame_newslot(opresult2639);
  params[0] = strlit2627;
  partcv[0] = 1;
  Object opresult2640 = callmethod(opresult2639, "++(1)", 1, partcv, params);
// compiled op node returning opresult2640 (depth = 9)
  int op_slot_left_2618 = gc_frame_newslot(opresult2640);
  params[0] = call2624;
  partcv[0] = 1;
  Object opresult2641 = callmethod(opresult2640, "++(1)", 1, partcv, params);
// compiled op node returning opresult2641 (depth = 8)
  int op_slot_left_2615 = gc_frame_newslot(opresult2641);
  params[0] = strlit2616;
  partcv[0] = 1;
  Object opresult2642 = callmethod(opresult2641, "++(1)", 1, partcv, params);
// compiled op node returning opresult2642 (depth = 7)
  int op_slot_right_2614 = gc_frame_newslot(opresult2642);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_2614 = gc_frame_newslot(*var_s);
  params[0] = opresult2642;
  partcv[0] = 1;
  Object opresult2644 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2644 (depth = 6)
  *var_s = opresult2644;
  if (opresult2644 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_2575_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// definebindings:
// definebindings:
// Begin line 601
  setline(601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2578 = alloc_Float64(1);
// compiled num node returning num2578 (depth = 6)
  int op_slot_right_2577 = gc_frame_newslot(num2578);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_2577 = gc_frame_newslot(*var_depth);
  params[0] = num2578;
  partcv[0] = 1;
  Object sum2580 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2580 (depth = 5)
  int op_slot_right_2576 = gc_frame_newslot(sum2580);
// starting to compile string node (depth = 5)
  if (strlit2582 == NULL) {
    strlit2582 = alloc_String("  ");
    gc_root(strlit2582);
  }
// compiled string node returning strlit2582 (depth = 5)
  int op_slot_left_2576 = gc_frame_newslot(strlit2582);
  params[0] = sum2580;
  partcv[0] = 1;
  Object prod2583 = callmethod(strlit2582, "*(1)", 1, partcv, params);
// compiled op node returning prod2583 (depth = 4)
  *var_spc = prod2583;
  if (prod2583 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 602
  setline(602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2585 == NULL) {
    strlit2585 = alloc_String("""\x0a""");
    gc_root(strlit2585);
  }
// compiled string node returning strlit2585 (depth = 5)
  int op_slot_right_2584 = gc_frame_newslot(strlit2585);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2588 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call2589 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2588);
// compiled call node returning call2589 (depth = 6)
  int op_slot_right_2587 = gc_frame_newslot(call2589);
// starting to compile string node (depth = 6)
  if (strlit2591 == NULL) {
    strlit2591 = alloc_String("");
    gc_root(strlit2591);
  }
// compiled string node returning strlit2591 (depth = 6)
  int op_slot_left_2587 = gc_frame_newslot(strlit2591);
  params[0] = call2589;
  partcv[0] = 1;
  Object opresult2592 = callmethod(strlit2591, "++(1)", 1, partcv, params);
// compiled op node returning opresult2592 (depth = 5)
  int op_slot_left_2584 = gc_frame_newslot(opresult2592);
  params[0] = strlit2585;
  partcv[0] = 1;
  Object opresult2593 = callmethod(opresult2592, "++(1)", 1, partcv, params);
// compiled op node returning opresult2593 (depth = 4)
  *var_s = opresult2593;
  if (opresult2593 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 603
  setline(603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2595 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2597 = alloc_Float64(2);
// compiled num node returning num2597 (depth = 7)
  int op_slot_right_2596 = gc_frame_newslot(num2597);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_2596 = gc_frame_newslot(*var_depth);
  params[0] = num2597;
  partcv[0] = 1;
  Object sum2599 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2599 (depth = 6)
  gc_frame_newslot(sum2599);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2600 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2601 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2600);
// compiled member node returning call2601 (depth = 6)
  params[0] = sum2599;
  partcv[0] = 1;
  Object call2602 = callmethodflags(call2601, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2595);
// compiled call node returning call2602 (depth = 5)
  int op_slot_right_2594 = gc_frame_newslot(call2602);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_2604 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2604 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2606 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2606 (depth = 5)
  int op_slot_left_2594 = gc_frame_newslot(opresult2606);
  params[0] = call2602;
  partcv[0] = 1;
  Object opresult2607 = callmethod(opresult2606, "++(1)", 1, partcv, params);
// compiled op node returning opresult2607 (depth = 4)
  *var_s = opresult2607;
  if (opresult2607 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 604
  setline(604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2609 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2610 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2611 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2610);
// compiled member node returning call2611 (depth = 4)
  gc_frame_newslot(call2611);
// starting to compile block node (depth = 4)
  Object block2612 = alloc_Block(NULL, NULL, "ast", 604);
  gc_frame_newslot(block2612);
// method "_apply(_)"
  block_savedest(block2612);
  Object closure2613 = createclosure(4, "_apply(1)");
  setclosureframe(closure2613, stackframe);
  addtoclosure(closure2613, var_depth);
  addtoclosure(closure2613, var_spc);
  addtoclosure(closure2613, var_s);
  addtoclosure(closure2613, selfslot);
  struct UserObject *uo2613 = (struct UserObject*)block2612;
  uo2613->data[0] = (Object)closure2613;
  Method *meth_meth_ast_2613__apply_40_1_41_ = addmethod2pos(block2612, "_apply(1)", &meth_ast_2613__apply_40_1_41_, 0);
  int argcv_meth_ast_2613__apply_40_1_41_[] = {1};
  meth_meth_ast_2613__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2613__apply_40_1_41_);
  meth_meth_ast_2613__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2613__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block2612 (depth = 4)
  gc_frame_newslot(block2612);
// call case 5: prelude request
  params[0] = call2611;
  params[1] = block2612;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2647 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2609);
// compiled call node returning call2647 (depth = 3)
// Begin line 607
  setline(607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2650 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2651 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2650);
// compiled member node returning call2651 (depth = 5)
  int op_slot_right_2649 = gc_frame_newslot(call2651);
// starting to compile identifier node (depth = 5)
  Object bool2653 = alloc_Boolean(0);
// compiled identifier node returning bool2653 (depth = 5)
  int op_slot_left_2649 = gc_frame_newslot(bool2653);
  params[0] = call2651;
  partcv[0] = 1;
  Object opresult2654 = callmethod(bool2653, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2654 (depth = 4)
  Object if2648 = done;
  if (istrue(opresult2654)) {
// Begin line 608
  setline(608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2657 == NULL) {
    strlit2657 = alloc_String("");
    gc_root(strlit2657);
  }
// compiled string node returning strlit2657 (depth = 7)
  int op_slot_right_2656 = gc_frame_newslot(strlit2657);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2660 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2662 = alloc_Float64(2);
// compiled num node returning num2662 (depth = 10)
  int op_slot_right_2661 = gc_frame_newslot(num2662);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_2661 = gc_frame_newslot(*var_depth);
  params[0] = num2662;
  partcv[0] = 1;
  Object sum2664 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2664 (depth = 9)
  gc_frame_newslot(sum2664);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2665 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2666 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2665);
// compiled member node returning call2666 (depth = 9)
  params[0] = sum2664;
  partcv[0] = 1;
  Object call2667 = callmethodflags(call2666, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2660);
// compiled call node returning call2667 (depth = 8)
  int op_slot_right_2659 = gc_frame_newslot(call2667);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2670 == NULL) {
    strlit2670 = alloc_String("  ");
    gc_root(strlit2670);
  }
// compiled string node returning strlit2670 (depth = 9)
  int op_slot_right_2669 = gc_frame_newslot(strlit2670);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2672 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2675 == NULL) {
    strlit2675 = alloc_String("Finally:""\x0a""");
    gc_root(strlit2675);
  }
// compiled string node returning strlit2675 (depth = 11)
  int op_slot_right_2674 = gc_frame_newslot(strlit2675);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_2677 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 12)
  if (strlit2679 == NULL) {
    strlit2679 = alloc_String("""\x0a""");
    gc_root(strlit2679);
  }
// compiled string node returning strlit2679 (depth = 12)
  int op_slot_left_2677 = gc_frame_newslot(strlit2679);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2680 = callmethod(strlit2679, "++(1)", 1, partcv, params);
// compiled op node returning opresult2680 (depth = 11)
  int op_slot_left_2674 = gc_frame_newslot(opresult2680);
  params[0] = strlit2675;
  partcv[0] = 1;
  Object opresult2681 = callmethod(opresult2680, "++(1)", 1, partcv, params);
// compiled op node returning opresult2681 (depth = 10)
  int op_slot_left_2672 = gc_frame_newslot(opresult2681);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2682 = callmethod(opresult2681, "++(1)", 1, partcv, params);
// compiled op node returning opresult2682 (depth = 9)
  int op_slot_left_2669 = gc_frame_newslot(opresult2682);
  params[0] = strlit2670;
  partcv[0] = 1;
  Object opresult2683 = callmethod(opresult2682, "++(1)", 1, partcv, params);
// compiled op node returning opresult2683 (depth = 8)
  int op_slot_left_2659 = gc_frame_newslot(opresult2683);
  params[0] = call2667;
  partcv[0] = 1;
  Object opresult2684 = callmethod(opresult2683, "++(1)", 1, partcv, params);
// compiled op node returning opresult2684 (depth = 7)
  int op_slot_left_2656 = gc_frame_newslot(opresult2684);
  params[0] = strlit2657;
  partcv[0] = 1;
  Object opresult2685 = callmethod(opresult2684, "++(1)", 1, partcv, params);
// compiled op node returning opresult2685 (depth = 6)
  int op_slot_right_2655 = gc_frame_newslot(opresult2685);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2655 = gc_frame_newslot(*var_s);
  params[0] = opresult2685;
  partcv[0] = 1;
  Object opresult2687 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2687 (depth = 5)
  *var_s = opresult2687;
  if (opresult2687 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2648 = done;
  } else {
  }
// compiled if node returning if2648 (depth = 3)
// Begin line 610
  setline(610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_2714__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_case = &(stackframe->slots[0]);
  *var_case = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 616
  setline(616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2716 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2718 = alloc_Float64(1);
// compiled num node returning num2718 (depth = 9)
  int op_slot_right_2717 = gc_frame_newslot(num2718);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2717 = gc_frame_newslot(*var_depth);
  params[0] = num2718;
  partcv[0] = 1;
  Object sum2720 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2720 (depth = 8)
  gc_frame_newslot(sum2720);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_case (depth = 8)
  params[0] = sum2720;
  partcv[0] = 1;
  Object call2721 = callmethodflags(*var_case, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2716);
// compiled call node returning call2721 (depth = 7)
  int op_slot_right_2715 = gc_frame_newslot(call2721);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2724 == NULL) {
    strlit2724 = alloc_String("catch ");
    gc_root(strlit2724);
  }
// compiled string node returning strlit2724 (depth = 8)
  int op_slot_right_2723 = gc_frame_newslot(strlit2724);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2727 == NULL) {
    strlit2727 = alloc_String("    ");
    gc_root(strlit2727);
  }
// compiled string node returning strlit2727 (depth = 9)
  int op_slot_right_2726 = gc_frame_newslot(strlit2727);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2729 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2732 == NULL) {
    strlit2732 = alloc_String("""\x0a""");
    gc_root(strlit2732);
  }
// compiled string node returning strlit2732 (depth = 11)
  int op_slot_right_2731 = gc_frame_newslot(strlit2732);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_2731 = gc_frame_newslot(*var_s);
  params[0] = strlit2732;
  partcv[0] = 1;
  Object opresult2734 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2734 (depth = 10)
  int op_slot_left_2729 = gc_frame_newslot(opresult2734);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2735 = callmethod(opresult2734, "++(1)", 1, partcv, params);
// compiled op node returning opresult2735 (depth = 9)
  int op_slot_left_2726 = gc_frame_newslot(opresult2735);
  params[0] = strlit2727;
  partcv[0] = 1;
  Object opresult2736 = callmethod(opresult2735, "++(1)", 1, partcv, params);
// compiled op node returning opresult2736 (depth = 8)
  int op_slot_left_2723 = gc_frame_newslot(opresult2736);
  params[0] = strlit2724;
  partcv[0] = 1;
  Object opresult2737 = callmethod(opresult2736, "++(1)", 1, partcv, params);
// compiled op node returning opresult2737 (depth = 7)
  int op_slot_left_2715 = gc_frame_newslot(opresult2737);
  params[0] = call2721;
  partcv[0] = 1;
  Object opresult2738 = callmethod(opresult2737, "++(1)", 1, partcv, params);
// compiled op node returning opresult2738 (depth = 6)
  *var_s = opresult2738;
  if (opresult2738 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_2689_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// definebindings:
// definebindings:
// Begin line 613
  setline(613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_2690 = gc_frame_newslot(*var_depth);
// starting to compile string node (depth = 5)
  if (strlit2692 == NULL) {
    strlit2692 = alloc_String("    ");
    gc_root(strlit2692);
  }
// compiled string node returning strlit2692 (depth = 5)
  int op_slot_left_2690 = gc_frame_newslot(strlit2692);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object prod2693 = callmethod(strlit2692, "*(1)", 1, partcv, params);
// compiled op node returning prod2693 (depth = 4)
  *var_spc = prod2693;
  if (prod2693 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 614
  setline(614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2695 == NULL) {
    strlit2695 = alloc_String(" ");
    gc_root(strlit2695);
  }
// compiled string node returning strlit2695 (depth = 5)
  int op_slot_right_2694 = gc_frame_newslot(strlit2695);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2698 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2700 = alloc_Float64(1);
// compiled num node returning num2700 (depth = 8)
  int op_slot_right_2699 = gc_frame_newslot(num2700);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_2699 = gc_frame_newslot(*var_depth);
  params[0] = num2700;
  partcv[0] = 1;
  Object sum2702 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2702 (depth = 7)
  gc_frame_newslot(sum2702);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2703 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2704 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2703);
// compiled member node returning call2704 (depth = 7)
  params[0] = sum2702;
  partcv[0] = 1;
  Object call2705 = callmethodflags(call2704, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2698);
// compiled call node returning call2705 (depth = 6)
  int op_slot_right_2697 = gc_frame_newslot(call2705);
// starting to compile string node (depth = 6)
  if (strlit2707 == NULL) {
    strlit2707 = alloc_String("try ");
    gc_root(strlit2707);
  }
// compiled string node returning strlit2707 (depth = 6)
  int op_slot_left_2697 = gc_frame_newslot(strlit2707);
  params[0] = call2705;
  partcv[0] = 1;
  Object opresult2708 = callmethod(strlit2707, "++(1)", 1, partcv, params);
// compiled op node returning opresult2708 (depth = 5)
  int op_slot_left_2694 = gc_frame_newslot(opresult2708);
  params[0] = strlit2695;
  partcv[0] = 1;
  Object opresult2709 = callmethod(opresult2708, "++(1)", 1, partcv, params);
// compiled op node returning opresult2709 (depth = 4)
  *var_s = opresult2709;
  if (opresult2709 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 615
  setline(615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2710 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2711 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2712 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2711);
// compiled member node returning call2712 (depth = 4)
  gc_frame_newslot(call2712);
// starting to compile block node (depth = 4)
  Object block2713 = alloc_Block(NULL, NULL, "ast", 615);
  gc_frame_newslot(block2713);
// method "_apply(_)"
  block_savedest(block2713);
  Object closure2714 = createclosure(4, "_apply(1)");
  setclosureframe(closure2714, stackframe);
  addtoclosure(closure2714, var_depth);
  addtoclosure(closure2714, var_spc);
  addtoclosure(closure2714, var_s);
  addtoclosure(closure2714, selfslot);
  struct UserObject *uo2714 = (struct UserObject*)block2713;
  uo2714->data[0] = (Object)closure2714;
  Method *meth_meth_ast_2714__apply_40_1_41_ = addmethod2pos(block2713, "_apply(1)", &meth_ast_2714__apply_40_1_41_, 0);
  int argcv_meth_ast_2714__apply_40_1_41_[] = {1};
  meth_meth_ast_2714__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2714__apply_40_1_41_);
  meth_meth_ast_2714__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2714__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block2713 (depth = 4)
  gc_frame_newslot(block2713);
// call case 5: prelude request
  params[0] = call2712;
  params[1] = block2713;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2741 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2710);
// compiled call node returning call2741 (depth = 3)
// Begin line 618
  setline(618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2744 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2745 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2744);
// compiled member node returning call2745 (depth = 5)
  int op_slot_right_2743 = gc_frame_newslot(call2745);
// starting to compile identifier node (depth = 5)
  Object bool2747 = alloc_Boolean(0);
// compiled identifier node returning bool2747 (depth = 5)
  int op_slot_left_2743 = gc_frame_newslot(bool2747);
  params[0] = call2745;
  partcv[0] = 1;
  Object opresult2748 = callmethod(bool2747, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2748 (depth = 4)
  Object if2742 = done;
  if (istrue(opresult2748)) {
// Begin line 619
  setline(619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2750 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2752 = alloc_Float64(1);
// compiled num node returning num2752 (depth = 8)
  int op_slot_right_2751 = gc_frame_newslot(num2752);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_2751 = gc_frame_newslot(*var_depth);
  params[0] = num2752;
  partcv[0] = 1;
  Object sum2754 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2754 (depth = 7)
  gc_frame_newslot(sum2754);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2755 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2756 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2755);
// compiled member node returning call2756 (depth = 7)
  params[0] = sum2754;
  partcv[0] = 1;
  Object call2757 = callmethodflags(call2756, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2750);
// compiled call node returning call2757 (depth = 6)
  int op_slot_right_2749 = gc_frame_newslot(call2757);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2760 == NULL) {
    strlit2760 = alloc_String("finally ");
    gc_root(strlit2760);
  }
// compiled string node returning strlit2760 (depth = 7)
  int op_slot_right_2759 = gc_frame_newslot(strlit2760);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2763 == NULL) {
    strlit2763 = alloc_String("    ");
    gc_root(strlit2763);
  }
// compiled string node returning strlit2763 (depth = 8)
  int op_slot_right_2762 = gc_frame_newslot(strlit2763);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_2765 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2768 == NULL) {
    strlit2768 = alloc_String("""\x0a""");
    gc_root(strlit2768);
  }
// compiled string node returning strlit2768 (depth = 10)
  int op_slot_right_2767 = gc_frame_newslot(strlit2768);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_2767 = gc_frame_newslot(*var_s);
  params[0] = strlit2768;
  partcv[0] = 1;
  Object opresult2770 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2770 (depth = 9)
  int op_slot_left_2765 = gc_frame_newslot(opresult2770);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2771 = callmethod(opresult2770, "++(1)", 1, partcv, params);
// compiled op node returning opresult2771 (depth = 8)
  int op_slot_left_2762 = gc_frame_newslot(opresult2771);
  params[0] = strlit2763;
  partcv[0] = 1;
  Object opresult2772 = callmethod(opresult2771, "++(1)", 1, partcv, params);
// compiled op node returning opresult2772 (depth = 7)
  int op_slot_left_2759 = gc_frame_newslot(opresult2772);
  params[0] = strlit2760;
  partcv[0] = 1;
  Object opresult2773 = callmethod(opresult2772, "++(1)", 1, partcv, params);
// compiled op node returning opresult2773 (depth = 6)
  int op_slot_left_2749 = gc_frame_newslot(opresult2773);
  params[0] = call2757;
  partcv[0] = 1;
  Object opresult2774 = callmethod(opresult2773, "++(1)", 1, partcv, params);
// compiled op node returning opresult2774 (depth = 5)
  *var_s = opresult2774;
  if (opresult2774 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2742 = done;
  } else {
  }
// compiled if node returning if2742 (depth = 3)
// Begin line 621
  setline(621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_2776_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_tryCatchNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 624
  setline(624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2777 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe2778 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 5)
  Object bool2779 = alloc_Boolean(0);
// compiled identifier node returning bool2779 (depth = 5)
  gc_frame_newslot(bool2779);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tryCatchNode (depth = 5)
  params[0] = *var_nullNode;
  params[1] = *var_emptySeq;
  params[2] = bool2779;
  partcv[0] = 3;
  Object call2780 = callmethodflags(*var_tryCatchNode, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe2778);
// compiled call node returning call2780 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call2781 = callmethodflags(call2780, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2777);
// compiled call node returning call2781 (depth = 3)
  gc_frame_end(frame);
  return call2781;
}
Object meth_ast_2482_new_40_3_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_tryCatchNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block = &(stackframe->slots[0]);
  *var_block = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_finally_39_ = &(stackframe->slots[2]);
  *var_finally_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2483 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2483 = alloc_userobj2(14,12, objclass2483);
  gc_frame_newslot(obj2483);
  if (objclass2483 == NULL) {
    glfree(obj2483->class->name);
    obj2483->class->name = "tryCatchNode.new(_,_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2483, self, 0);
  addmethodreal(obj2483,"outer", &reader_ast_outer_2484);
  Object oldself2483 = self;
  struct StackFrameObject *oldstackframe2483 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2483);
  gc_frame_newslot((Object)stackframe);
  self = obj2483;
  Object *oldselfslot2483 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2483 = (*(struct UserObject *)self).data[0], lowerouter2483 = thisouter2483;
  if (inheritingObject2483) {
    struct UserObject *inho2483 = (struct UserObject *)inheritingObject2483;
    while (inho2483->super != GraceDefaultObject) inho2483 = (struct UserObject *)inho2483->super;
    inho2483->super = obj2483;
    self = inheritingObject2483;
    *selfslot = self;
    lowerouter2483 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2483;
  }
  if (objclass2483 == NULL) {
  Method *reader2485 = addmethodrealflags(obj2483, "kind",&reader_ast_kind_2485, MFLAG_DEF);
  reader2485->definitionModule = modulename;
  reader2485->definitionLine = 570;
  }
  adddatum2(obj2483, alloc_Undefined(), 1);
  if (objclass2483 == NULL) {
    Method *reader2486 = addmethodrealflags(obj2483, "value", &reader_ast_value_2486, 0);
    Method *writer2486 = addmethodrealflags(obj2483, "value:=(1)", &writer_ast_value_2486, 0);
    reader2486->definitionModule = modulename;
    writer2486->definitionModule = modulename;
    reader2486->definitionLine = 571;
    writer2486->definitionLine = 571;
  }
  obj2483->flags |= OFLAG_MUTABLE;
  adddatum2(obj2483, alloc_Undefined(), 2);
  if (objclass2483 == NULL) {
    Method *reader2487 = addmethodrealflags(obj2483, "cases", &reader_ast_cases_2487, 0);
    Method *writer2487 = addmethodrealflags(obj2483, "cases:=(1)", &writer_ast_cases_2487, 0);
    reader2487->definitionModule = modulename;
    writer2487->definitionModule = modulename;
    reader2487->definitionLine = 572;
    writer2487->definitionLine = 572;
  }
  obj2483->flags |= OFLAG_MUTABLE;
  adddatum2(obj2483, alloc_Undefined(), 3);
  if (objclass2483 == NULL) {
    Method *reader2488 = addmethodrealflags(obj2483, "finally", &reader_ast_finally_2488, 0);
    Method *writer2488 = addmethodrealflags(obj2483, "finally:=(1)", &writer_ast_finally_2488, 0);
    reader2488->definitionModule = modulename;
    writer2488->definitionModule = modulename;
    reader2488->definitionLine = 573;
    writer2488->definitionLine = 573;
  }
  obj2483->flags |= OFLAG_MUTABLE;
  adddatum2(obj2483, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo2489 = (struct UserObject*)obj2483;
  uo2489->data[5] = emptyclosure;
  Method *meth_meth_ast_2489_isSimple = addmethod2pos(obj2483, "isSimple", &meth_ast_2489_isSimple, 5);
  int argcv_meth_ast_2489_isSimple[] = {0};
  meth_meth_ast_2489_isSimple->type = alloc_MethodType(1, argcv_meth_ast_2489_isSimple);
  meth_meth_ast_2489_isSimple->definitionModule = modulename;
  meth_meth_ast_2489_isSimple->definitionLine = 574;
// method "end"
  struct UserObject *uo2491 = (struct UserObject*)obj2483;
  uo2491->data[6] = emptyclosure;
  Method *meth_meth_ast_2491_end = addmethod2pos(obj2483, "end", &meth_ast_2491_end, 6);
  int argcv_meth_ast_2491_end[] = {0};
  meth_meth_ast_2491_end->type = alloc_MethodType(1, argcv_meth_ast_2491_end);
  meth_meth_ast_2491_end->definitionModule = modulename;
  meth_meth_ast_2491_end->definitionLine = 575;
// method "accept(_)from(_)"
  struct UserObject *uo2520 = (struct UserObject*)obj2483;
  uo2520->data[7] = emptyclosure;
  Method *meth_meth_ast_2520_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj2483, "accept(1)from(1)", &meth_ast_2520_accept_40_1_41_from_40_1_41_, 7);
  int argcv_meth_ast_2520_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_2520_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_2520_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_2520_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2520_accept_40_1_41_from_40_1_41_->definitionLine = 580;
// method "map(_)ancestors(_)"
  struct UserObject *uo2550 = (struct UserObject*)obj2483;
  uo2550->data[8] = emptyclosure;
  Method *meth_meth_ast_2550_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj2483, "map(1)ancestors(1)", &meth_ast_2550_map_40_1_41_ancestors_40_1_41_, 8);
  int argcv_meth_ast_2550_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_2550_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_2550_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_2550_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2550_map_40_1_41_ancestors_40_1_41_->definitionLine = 592;
// method "pretty(_)"
  struct UserObject *uo2575 = (struct UserObject*)obj2483;
  uo2575->data[9] = emptyclosure;
  Method *meth_meth_ast_2575_pretty_40_1_41_ = addmethod2pos(obj2483, "pretty(1)", &meth_ast_2575_pretty_40_1_41_, 9);
  int argcv_meth_ast_2575_pretty_40_1_41_[] = {1};
  meth_meth_ast_2575_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2575_pretty_40_1_41_);
  meth_meth_ast_2575_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2575_pretty_40_1_41_->definitionLine = 600;
// method "toGrace(_)"
  struct UserObject *uo2689 = (struct UserObject*)obj2483;
  uo2689->data[10] = emptyclosure;
  Method *meth_meth_ast_2689_toGrace_40_1_41_ = addmethod2pos(obj2483, "toGrace(1)", &meth_ast_2689_toGrace_40_1_41_, 10);
  int argcv_meth_ast_2689_toGrace_40_1_41_[] = {1};
  meth_meth_ast_2689_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2689_toGrace_40_1_41_);
meth_meth_ast_2689_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_2689_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_2689_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2689_toGrace_40_1_41_->definitionLine = 612;
// method "shallowCopy"
  block_savedest(obj2483);
  Object closure2776 = createclosure(3, "shallowCopy");
  setclosureframe(closure2776, stackframe);
  addtoclosure(closure2776, var_nullNode);
  addtoclosure(closure2776, var_emptySeq);
  addtoclosure(closure2776, var_tryCatchNode);
  struct UserObject *uo2776 = (struct UserObject*)obj2483;
  uo2776->data[11] = (Object)closure2776;
  Method *meth_meth_ast_2776_shallowCopy = addmethod2pos(obj2483, "shallowCopy", &meth_ast_2776_shallowCopy, 11);
  int argcv_meth_ast_2776_shallowCopy[] = {0};
  meth_meth_ast_2776_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_2776_shallowCopy);
  meth_meth_ast_2776_shallowCopy->definitionModule = modulename;
  meth_meth_ast_2776_shallowCopy->definitionLine = 623;
  sourceObject = obj2483;
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2782 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2783 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2782);
// compiled call node returning call2783 (depth = 3)
  struct UserObject *obj2483_uo = (struct UserObject *)obj2483;
  obj2483_uo->super = call2783;
  sourceObject = obj2483;
// Begin line 570
  setline(570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2784 == NULL) {
    strlit2784 = alloc_String("trycatch");
    gc_root(strlit2784);
  }
// compiled string node returning strlit2784 (depth = 3)
  adddatum2(obj2483, strlit2784, 1);
  sourceObject = obj2483;
// Begin line 571
  setline(571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_block (depth = 3)
  adddatum2(obj2483, *var_block, 2);
  sourceObject = obj2483;
// Begin line 572
  setline(572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cases_39_ (depth = 3)
  adddatum2(obj2483, *var_cases_39_, 3);
  sourceObject = obj2483;
// Begin line 573
  setline(573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_finally_39_ (depth = 3)
  adddatum2(obj2483, *var_finally_39_, 4);
  sourceObject = obj2483;
  sourceObject = obj2483;
  sourceObject = obj2483;
  sourceObject = obj2483;
  sourceObject = obj2483;
  sourceObject = obj2483;
  sourceObject = obj2483;
  objclass2483 = obj2483->class;
  objclass2483->definitionModule = modulename;
  objclass2483->definitionLine = 568;
  (*(struct UserObject *)self).data[0] = lowerouter2483;
  self = oldself2483;
  selfslot = oldselfslot2483;
  stackframe = oldstackframe2483;
  gc_frame_end(frame);
  return obj2483;
}
Object meth_ast_2482_new_40_3_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_tryCatchNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block = &(stackframe->slots[0]);
  *var_block = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_finally_39_ = &(stackframe->slots[2]);
  *var_finally_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2483 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2483 = alloc_userobj2(14,12, objclass2483);
  gc_frame_newslot(obj2483);
  if (objclass2483 == NULL) {
    glfree(obj2483->class->name);
    obj2483->class->name = "tryCatchNode.new(_,_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2483, self, 0);
  addmethodreal(obj2483,"outer", &reader_ast_outer_2484);
  Object oldself2483 = self;
  struct StackFrameObject *oldstackframe2483 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2483);
  gc_frame_newslot((Object)stackframe);
  self = obj2483;
  Object *oldselfslot2483 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2483 = (*(struct UserObject *)self).data[0], lowerouter2483 = thisouter2483;
  if (inheritingObject2483) {
    struct UserObject *inho2483 = (struct UserObject *)inheritingObject2483;
    while (inho2483->super != GraceDefaultObject) inho2483 = (struct UserObject *)inho2483->super;
    inho2483->super = obj2483;
    self = inheritingObject2483;
    *selfslot = self;
    lowerouter2483 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2483;
  }
  if (objclass2483 == NULL) {
  Method *reader2485 = addmethodrealflags(obj2483, "kind",&reader_ast_kind_2485, MFLAG_DEF);
  reader2485->definitionModule = modulename;
  reader2485->definitionLine = 570;
  }
  adddatum2(obj2483, alloc_Undefined(), 1);
  if (objclass2483 == NULL) {
    Method *reader2486 = addmethodrealflags(obj2483, "value", &reader_ast_value_2486, 0);
    Method *writer2486 = addmethodrealflags(obj2483, "value:=(1)", &writer_ast_value_2486, 0);
    reader2486->definitionModule = modulename;
    writer2486->definitionModule = modulename;
    reader2486->definitionLine = 571;
    writer2486->definitionLine = 571;
  }
  obj2483->flags |= OFLAG_MUTABLE;
  adddatum2(obj2483, alloc_Undefined(), 2);
  if (objclass2483 == NULL) {
    Method *reader2487 = addmethodrealflags(obj2483, "cases", &reader_ast_cases_2487, 0);
    Method *writer2487 = addmethodrealflags(obj2483, "cases:=(1)", &writer_ast_cases_2487, 0);
    reader2487->definitionModule = modulename;
    writer2487->definitionModule = modulename;
    reader2487->definitionLine = 572;
    writer2487->definitionLine = 572;
  }
  obj2483->flags |= OFLAG_MUTABLE;
  adddatum2(obj2483, alloc_Undefined(), 3);
  if (objclass2483 == NULL) {
    Method *reader2488 = addmethodrealflags(obj2483, "finally", &reader_ast_finally_2488, 0);
    Method *writer2488 = addmethodrealflags(obj2483, "finally:=(1)", &writer_ast_finally_2488, 0);
    reader2488->definitionModule = modulename;
    writer2488->definitionModule = modulename;
    reader2488->definitionLine = 573;
    writer2488->definitionLine = 573;
  }
  obj2483->flags |= OFLAG_MUTABLE;
  adddatum2(obj2483, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo2489 = (struct UserObject*)obj2483;
  uo2489->data[5] = emptyclosure;
  Method *meth_meth_ast_2489_isSimple = addmethod2pos(obj2483, "isSimple", &meth_ast_2489_isSimple, 5);
  int argcv_meth_ast_2489_isSimple[] = {0};
  meth_meth_ast_2489_isSimple->type = alloc_MethodType(1, argcv_meth_ast_2489_isSimple);
  meth_meth_ast_2489_isSimple->definitionModule = modulename;
  meth_meth_ast_2489_isSimple->definitionLine = 574;
// method "end"
  struct UserObject *uo2491 = (struct UserObject*)obj2483;
  uo2491->data[6] = emptyclosure;
  Method *meth_meth_ast_2491_end = addmethod2pos(obj2483, "end", &meth_ast_2491_end, 6);
  int argcv_meth_ast_2491_end[] = {0};
  meth_meth_ast_2491_end->type = alloc_MethodType(1, argcv_meth_ast_2491_end);
  meth_meth_ast_2491_end->definitionModule = modulename;
  meth_meth_ast_2491_end->definitionLine = 575;
// method "accept(_)from(_)"
  struct UserObject *uo2520 = (struct UserObject*)obj2483;
  uo2520->data[7] = emptyclosure;
  Method *meth_meth_ast_2520_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj2483, "accept(1)from(1)", &meth_ast_2520_accept_40_1_41_from_40_1_41_, 7);
  int argcv_meth_ast_2520_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_2520_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_2520_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_2520_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2520_accept_40_1_41_from_40_1_41_->definitionLine = 580;
// method "map(_)ancestors(_)"
  struct UserObject *uo2550 = (struct UserObject*)obj2483;
  uo2550->data[8] = emptyclosure;
  Method *meth_meth_ast_2550_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj2483, "map(1)ancestors(1)", &meth_ast_2550_map_40_1_41_ancestors_40_1_41_, 8);
  int argcv_meth_ast_2550_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_2550_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_2550_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_2550_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2550_map_40_1_41_ancestors_40_1_41_->definitionLine = 592;
// method "pretty(_)"
  struct UserObject *uo2575 = (struct UserObject*)obj2483;
  uo2575->data[9] = emptyclosure;
  Method *meth_meth_ast_2575_pretty_40_1_41_ = addmethod2pos(obj2483, "pretty(1)", &meth_ast_2575_pretty_40_1_41_, 9);
  int argcv_meth_ast_2575_pretty_40_1_41_[] = {1};
  meth_meth_ast_2575_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2575_pretty_40_1_41_);
  meth_meth_ast_2575_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2575_pretty_40_1_41_->definitionLine = 600;
// method "toGrace(_)"
  struct UserObject *uo2689 = (struct UserObject*)obj2483;
  uo2689->data[10] = emptyclosure;
  Method *meth_meth_ast_2689_toGrace_40_1_41_ = addmethod2pos(obj2483, "toGrace(1)", &meth_ast_2689_toGrace_40_1_41_, 10);
  int argcv_meth_ast_2689_toGrace_40_1_41_[] = {1};
  meth_meth_ast_2689_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2689_toGrace_40_1_41_);
meth_meth_ast_2689_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_2689_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_2689_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2689_toGrace_40_1_41_->definitionLine = 612;
// method "shallowCopy"
  block_savedest(obj2483);
  Object closure2776 = createclosure(3, "shallowCopy");
  setclosureframe(closure2776, stackframe);
  addtoclosure(closure2776, var_nullNode);
  addtoclosure(closure2776, var_emptySeq);
  addtoclosure(closure2776, var_tryCatchNode);
  struct UserObject *uo2776 = (struct UserObject*)obj2483;
  uo2776->data[11] = (Object)closure2776;
  Method *meth_meth_ast_2776_shallowCopy = addmethod2pos(obj2483, "shallowCopy", &meth_ast_2776_shallowCopy, 11);
  int argcv_meth_ast_2776_shallowCopy[] = {0};
  meth_meth_ast_2776_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_2776_shallowCopy);
  meth_meth_ast_2776_shallowCopy->definitionModule = modulename;
  meth_meth_ast_2776_shallowCopy->definitionLine = 623;
  sourceObject = obj2483;
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2782 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2783 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2782);
// compiled call node returning call2783 (depth = 3)
  struct UserObject *obj2483_uo = (struct UserObject *)obj2483;
  obj2483_uo->super = call2783;
  sourceObject = obj2483;
// Begin line 570
  setline(570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2784 == NULL) {
    strlit2784 = alloc_String("trycatch");
    gc_root(strlit2784);
  }
// compiled string node returning strlit2784 (depth = 3)
  adddatum2(obj2483, strlit2784, 1);
  sourceObject = obj2483;
// Begin line 571
  setline(571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_block (depth = 3)
  adddatum2(obj2483, *var_block, 2);
  sourceObject = obj2483;
// Begin line 572
  setline(572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cases_39_ (depth = 3)
  adddatum2(obj2483, *var_cases_39_, 3);
  sourceObject = obj2483;
// Begin line 573
  setline(573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_finally_39_ (depth = 3)
  adddatum2(obj2483, *var_finally_39_, 4);
  sourceObject = obj2483;
  sourceObject = obj2483;
  sourceObject = obj2483;
  sourceObject = obj2483;
  sourceObject = obj2483;
  sourceObject = obj2483;
  sourceObject = obj2483;
  objclass2483 = obj2483->class;
  objclass2483->definitionModule = modulename;
  objclass2483->definitionLine = 568;
  (*(struct UserObject *)self).data[0] = lowerouter2483;
  self = oldself2483;
  selfslot = oldselfslot2483;
  stackframe = oldstackframe2483;
  gc_frame_end(frame);
  return obj2483;
}
Object meth_ast_2786_tryCatchNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tryCatchNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tryCatchNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tryCatchNode (depth = 3)
  gc_frame_end(frame);
  return *var_tryCatchNode;
}
Object meth_ast_2795_isSimple(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 634
  setline(634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2796 = alloc_Boolean(0);
// compiled identifier node returning bool2796 (depth = 3)
  gc_frame_end(frame);
  return bool2796;
}
Object meth_ast_2797_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 636
  setline(636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2799 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2800 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2801 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2802 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2801);
// compiled member node returning call2802 (depth = 6)
  partcv[0] = 0;
  Object call2803 = callmethodflags(call2802, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe2800);
// compiled member node returning call2803 (depth = 5)
  partcv[0] = 0;
  Object call2804 = callmethodflags(call2803, "not", 1, partcv, params, 0);
  gc_frame_end(callframe2799);
// compiled member node returning call2804 (depth = 4)
  Object if2798 = done;
  if (istrue(call2804)) {
// starting to compile return node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2805 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2806 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2807 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2808 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2807);
// compiled member node returning call2808 (depth = 7)
  partcv[0] = 0;
  Object call2809 = callmethodflags(call2808, "last", 1, partcv, params, 0);
  gc_frame_end(callframe2806);
// compiled member node returning call2809 (depth = 6)
  partcv[0] = 0;
  Object call2810 = callmethodflags(call2809, "end", 1, partcv, params, 0);
  gc_frame_end(callframe2805);
// compiled member node returning call2810 (depth = 5)
  return call2810;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if2798 = undefined;
  } else {
  }
// compiled if node returning if2798 (depth = 3)
// Begin line 637
  setline(637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2811 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2812 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2813 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2812);
// compiled member node returning call2813 (depth = 5)
  partcv[0] = 0;
  Object call2814 = callmethodflags(call2813, "end", 1, partcv, params, 0);
  gc_frame_end(callframe2811);
// compiled member node returning call2814 (depth = 4)
  return call2814;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_2815_matchee(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "matchee");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 639
  setline(639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe2816 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2817 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2816);
// compiled member node returning call2817 (depth = 3)
  gc_frame_end(frame);
  return call2817;
}
Object meth_ast_2832__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 645
  setline(645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2833 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2834 = callmethodflags(*var_mx, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2833);
// compiled call node returning call2834 (depth = 6)
  gc_frame_end(frame);
  return call2834;
}
Object meth_ast_2818_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// definebindings:
// Begin line 641
  setline(641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2820 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2821 = callmethodflags(*var_visitor, "visitMatchCase(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2820);
// compiled call node returning call2821 (depth = 4)
  Object if2819 = done;
  if (istrue(call2821)) {
// Begin line 642
  setline(642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2822 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call2823 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2822);
// compiled call node returning call2823 (depth = 5)
  *var_newChain = call2823;
  if (call2823 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 643
  setline(643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2824 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2825 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2826 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2825);
// compiled member node returning call2826 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2827 = callmethodflags(call2826, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2824);
// compiled call node returning call2827 (depth = 4)
// Begin line 644
  setline(644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2828 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2829 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2830 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2829);
// compiled member node returning call2830 (depth = 5)
  gc_frame_newslot(call2830);
// starting to compile block node (depth = 5)
  Object block2831 = alloc_Block(NULL, NULL, "ast", 644);
  gc_frame_newslot(block2831);
// method "_apply(_)"
  block_savedest(block2831);
  Object closure2832 = createclosure(3, "_apply(1)");
  setclosureframe(closure2832, stackframe);
  addtoclosure(closure2832, var_visitor);
  addtoclosure(closure2832, var_newChain);
  addtoclosure(closure2832, selfslot);
  struct UserObject *uo2832 = (struct UserObject*)block2831;
  uo2832->data[0] = (Object)closure2832;
  Method *meth_meth_ast_2832__apply_40_1_41_ = addmethod2pos(block2831, "_apply(1)", &meth_ast_2832__apply_40_1_41_, 0);
  int argcv_meth_ast_2832__apply_40_1_41_[] = {1};
  meth_meth_ast_2832__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2832__apply_40_1_41_);
  meth_meth_ast_2832__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2832__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block2831 (depth = 5)
  gc_frame_newslot(block2831);
// call case 5: prelude request
  params[0] = call2830;
  params[1] = block2831;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2836 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2828);
// compiled call node returning call2836 (depth = 4)
    gc_frame_newslot(call2836);
    if2819 = call2836;
  } else {
  }
// compiled if node returning if2819 (depth = 3)
  gc_frame_end(frame);
  return if2819;
}
Object meth_ast_2837_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 650
  setline(650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2838 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2839 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2838);
// compiled member node returning call2839 (depth = 4)
  *var_n = call2839;
  if (call2839 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 651
  setline(651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2840 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2841 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2840);
// compiled call node returning call2841 (depth = 4)
  *var_newChain = call2841;
  if (call2841 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 652
  setline(652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2842 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2843 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2844 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2845 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2844);
// compiled member node returning call2845 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2846 = callmethodflags(call2845, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2843);
// compiled call node returning call2846 (depth = 4)
  gc_frame_newslot(call2846);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2846;
  partcv[0] = 1;
  Object call2847 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2842);
// compiled call node returning call2847 (depth = 3)
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2848 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2849 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2850 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2851 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2850);
// compiled member node returning call2851 (depth = 5)
  gc_frame_newslot(call2851);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call2851;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2852 = callmethodflags(module_ast, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2849);
// compiled call node returning call2852 (depth = 4)
  gc_frame_newslot(call2852);
// call case 6: other requests
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2852;
  partcv[0] = 1;
  Object call2853 = callmethodflags(*var_n, "cases:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2848);
// compiled call node returning call2853 (depth = 3)
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2854 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call2855 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2854);
// compiled call node returning call2855 (depth = 3)
  gc_frame_end(frame);
  return call2855;
}
Object meth_ast_2890__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 661
  setline(661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2893 == NULL) {
    strlit2893 = alloc_String("");
    gc_root(strlit2893);
  }
// compiled string node returning strlit2893 (depth = 8)
  int op_slot_right_2892 = gc_frame_newslot(strlit2893);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2896 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2898 = alloc_Float64(2);
// compiled num node returning num2898 (depth = 11)
  int op_slot_right_2897 = gc_frame_newslot(num2898);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_2897 = gc_frame_newslot(*var_depth);
  params[0] = num2898;
  partcv[0] = 1;
  Object sum2900 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2900 (depth = 10)
  gc_frame_newslot(sum2900);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mx (depth = 10)
  params[0] = sum2900;
  partcv[0] = 1;
  Object call2901 = callmethodflags(*var_mx, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2896);
// compiled call node returning call2901 (depth = 9)
  int op_slot_right_2895 = gc_frame_newslot(call2901);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2904 == NULL) {
    strlit2904 = alloc_String("  ");
    gc_root(strlit2904);
  }
// compiled string node returning strlit2904 (depth = 10)
  int op_slot_right_2903 = gc_frame_newslot(strlit2904);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_2906 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2909 == NULL) {
    strlit2909 = alloc_String("Case:""\x0a""");
    gc_root(strlit2909);
  }
// compiled string node returning strlit2909 (depth = 12)
  int op_slot_right_2908 = gc_frame_newslot(strlit2909);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_2911 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 13)
  if (strlit2913 == NULL) {
    strlit2913 = alloc_String("""\x0a""");
    gc_root(strlit2913);
  }
// compiled string node returning strlit2913 (depth = 13)
  int op_slot_left_2911 = gc_frame_newslot(strlit2913);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2914 = callmethod(strlit2913, "++(1)", 1, partcv, params);
// compiled op node returning opresult2914 (depth = 12)
  int op_slot_left_2908 = gc_frame_newslot(opresult2914);
  params[0] = strlit2909;
  partcv[0] = 1;
  Object opresult2915 = callmethod(opresult2914, "++(1)", 1, partcv, params);
// compiled op node returning opresult2915 (depth = 11)
  int op_slot_left_2906 = gc_frame_newslot(opresult2915);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2916 = callmethod(opresult2915, "++(1)", 1, partcv, params);
// compiled op node returning opresult2916 (depth = 10)
  int op_slot_left_2903 = gc_frame_newslot(opresult2916);
  params[0] = strlit2904;
  partcv[0] = 1;
  Object opresult2917 = callmethod(opresult2916, "++(1)", 1, partcv, params);
// compiled op node returning opresult2917 (depth = 9)
  int op_slot_left_2895 = gc_frame_newslot(opresult2917);
  params[0] = call2901;
  partcv[0] = 1;
  Object opresult2918 = callmethod(opresult2917, "++(1)", 1, partcv, params);
// compiled op node returning opresult2918 (depth = 8)
  int op_slot_left_2892 = gc_frame_newslot(opresult2918);
  params[0] = strlit2893;
  partcv[0] = 1;
  Object opresult2919 = callmethod(opresult2918, "++(1)", 1, partcv, params);
// compiled op node returning opresult2919 (depth = 7)
  int op_slot_right_2891 = gc_frame_newslot(opresult2919);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_2891 = gc_frame_newslot(*var_s);
  params[0] = opresult2919;
  partcv[0] = 1;
  Object opresult2921 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2921 (depth = 6)
  *var_s = opresult2921;
  if (opresult2921 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_2856_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 657
  setline(657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2859 = alloc_Float64(1);
// compiled num node returning num2859 (depth = 6)
  int op_slot_right_2858 = gc_frame_newslot(num2859);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_2858 = gc_frame_newslot(*var_depth);
  params[0] = num2859;
  partcv[0] = 1;
  Object sum2861 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2861 (depth = 5)
  int op_slot_right_2857 = gc_frame_newslot(sum2861);
// starting to compile string node (depth = 5)
  if (strlit2863 == NULL) {
    strlit2863 = alloc_String("  ");
    gc_root(strlit2863);
  }
// compiled string node returning strlit2863 (depth = 5)
  int op_slot_left_2857 = gc_frame_newslot(strlit2863);
  params[0] = sum2861;
  partcv[0] = 1;
  Object prod2864 = callmethod(strlit2863, "*(1)", 1, partcv, params);
// compiled op node returning prod2864 (depth = 4)
  *var_spc = prod2864;
  if (prod2864 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2866 == NULL) {
    strlit2866 = alloc_String("""\x0a""");
    gc_root(strlit2866);
  }
// compiled string node returning strlit2866 (depth = 5)
  int op_slot_right_2865 = gc_frame_newslot(strlit2866);
// starting to compile call node (depth = 5)
  int callframe2868 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call2869 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2868);
// compiled call node returning call2869 (depth = 5)
  int op_slot_left_2865 = gc_frame_newslot(call2869);
  params[0] = strlit2866;
  partcv[0] = 1;
  Object opresult2870 = callmethod(call2869, "++(1)", 1, partcv, params);
// compiled op node returning opresult2870 (depth = 4)
  *var_s = opresult2870;
  if (opresult2870 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 659
  setline(659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2872 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2874 = alloc_Float64(2);
// compiled num node returning num2874 (depth = 7)
  int op_slot_right_2873 = gc_frame_newslot(num2874);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_2873 = gc_frame_newslot(*var_depth);
  params[0] = num2874;
  partcv[0] = 1;
  Object sum2876 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2876 (depth = 6)
  gc_frame_newslot(sum2876);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2877 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2878 = callmethodflags(self, "matchee", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2877);
// compiled member node returning call2878 (depth = 6)
  params[0] = sum2876;
  partcv[0] = 1;
  Object call2879 = callmethodflags(call2878, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2872);
// compiled call node returning call2879 (depth = 5)
  int op_slot_right_2871 = gc_frame_newslot(call2879);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_2881 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2881 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2883 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2883 (depth = 5)
  int op_slot_left_2871 = gc_frame_newslot(opresult2883);
  params[0] = call2879;
  partcv[0] = 1;
  Object opresult2884 = callmethod(opresult2883, "++(1)", 1, partcv, params);
// compiled op node returning opresult2884 (depth = 4)
  *var_s = opresult2884;
  if (opresult2884 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 660
  setline(660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2886 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2887 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2888 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2887);
// compiled member node returning call2888 (depth = 4)
  gc_frame_newslot(call2888);
// starting to compile block node (depth = 4)
  Object block2889 = alloc_Block(NULL, NULL, "ast", 660);
  gc_frame_newslot(block2889);
// method "_apply(_)"
  block_savedest(block2889);
  Object closure2890 = createclosure(4, "_apply(1)");
  setclosureframe(closure2890, stackframe);
  addtoclosure(closure2890, var_depth);
  addtoclosure(closure2890, var_spc);
  addtoclosure(closure2890, var_s);
  addtoclosure(closure2890, selfslot);
  struct UserObject *uo2890 = (struct UserObject*)block2889;
  uo2890->data[0] = (Object)closure2890;
  Method *meth_meth_ast_2890__apply_40_1_41_ = addmethod2pos(block2889, "_apply(1)", &meth_ast_2890__apply_40_1_41_, 0);
  int argcv_meth_ast_2890__apply_40_1_41_[] = {1};
  meth_meth_ast_2890__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2890__apply_40_1_41_);
  meth_meth_ast_2890__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2890__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block2889 (depth = 4)
  gc_frame_newslot(block2889);
// call case 5: prelude request
  params[0] = call2888;
  params[1] = block2889;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2924 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2886);
// compiled call node returning call2924 (depth = 3)
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_2947__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_case = &(stackframe->slots[0]);
  *var_case = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 669
  setline(669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2949 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2951 = alloc_Float64(2);
// compiled num node returning num2951 (depth = 9)
  int op_slot_right_2950 = gc_frame_newslot(num2951);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2950 = gc_frame_newslot(*var_depth);
  params[0] = num2951;
  partcv[0] = 1;
  Object sum2953 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2953 (depth = 8)
  gc_frame_newslot(sum2953);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_case (depth = 8)
  params[0] = sum2953;
  partcv[0] = 1;
  Object call2954 = callmethodflags(*var_case, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2949);
// compiled call node returning call2954 (depth = 7)
  int op_slot_right_2948 = gc_frame_newslot(call2954);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2957 == NULL) {
    strlit2957 = alloc_String("case ");
    gc_root(strlit2957);
  }
// compiled string node returning strlit2957 (depth = 8)
  int op_slot_right_2956 = gc_frame_newslot(strlit2957);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2960 == NULL) {
    strlit2960 = alloc_String("    ");
    gc_root(strlit2960);
  }
// compiled string node returning strlit2960 (depth = 9)
  int op_slot_right_2959 = gc_frame_newslot(strlit2960);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2962 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2965 == NULL) {
    strlit2965 = alloc_String("""\x0a""");
    gc_root(strlit2965);
  }
// compiled string node returning strlit2965 (depth = 11)
  int op_slot_right_2964 = gc_frame_newslot(strlit2965);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_2964 = gc_frame_newslot(*var_s);
  params[0] = strlit2965;
  partcv[0] = 1;
  Object opresult2967 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2967 (depth = 10)
  int op_slot_left_2962 = gc_frame_newslot(opresult2967);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2968 = callmethod(opresult2967, "++(1)", 1, partcv, params);
// compiled op node returning opresult2968 (depth = 9)
  int op_slot_left_2959 = gc_frame_newslot(opresult2968);
  params[0] = strlit2960;
  partcv[0] = 1;
  Object opresult2969 = callmethod(opresult2968, "++(1)", 1, partcv, params);
// compiled op node returning opresult2969 (depth = 8)
  int op_slot_left_2956 = gc_frame_newslot(opresult2969);
  params[0] = strlit2957;
  partcv[0] = 1;
  Object opresult2970 = callmethod(opresult2969, "++(1)", 1, partcv, params);
// compiled op node returning opresult2970 (depth = 7)
  int op_slot_left_2948 = gc_frame_newslot(opresult2970);
  params[0] = call2954;
  partcv[0] = 1;
  Object opresult2971 = callmethod(opresult2970, "++(1)", 1, partcv, params);
// compiled op node returning opresult2971 (depth = 6)
  *var_s = opresult2971;
  if (opresult2971 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_2925_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 666
  setline(666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_2926 = gc_frame_newslot(*var_depth);
// starting to compile string node (depth = 5)
  if (strlit2928 == NULL) {
    strlit2928 = alloc_String("    ");
    gc_root(strlit2928);
  }
// compiled string node returning strlit2928 (depth = 5)
  int op_slot_left_2926 = gc_frame_newslot(strlit2928);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object prod2929 = callmethod(strlit2928, "*(1)", 1, partcv, params);
// compiled op node returning prod2929 (depth = 4)
  *var_spc = prod2929;
  if (prod2929 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2931 == NULL) {
    strlit2931 = alloc_String(")");
    gc_root(strlit2931);
  }
// compiled string node returning strlit2931 (depth = 5)
  int op_slot_right_2930 = gc_frame_newslot(strlit2931);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2934 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num2935 = alloc_Float64(0);
// compiled num node returning num2935 (depth = 7)
  gc_frame_newslot(num2935);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2936 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2937 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2936);
// compiled member node returning call2937 (depth = 7)
  params[0] = num2935;
  partcv[0] = 1;
  Object call2938 = callmethodflags(call2937, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2934);
// compiled call node returning call2938 (depth = 6)
  int op_slot_right_2933 = gc_frame_newslot(call2938);
// starting to compile string node (depth = 6)
  if (strlit2940 == NULL) {
    strlit2940 = alloc_String("match(");
    gc_root(strlit2940);
  }
// compiled string node returning strlit2940 (depth = 6)
  int op_slot_left_2933 = gc_frame_newslot(strlit2940);
  params[0] = call2938;
  partcv[0] = 1;
  Object opresult2941 = callmethod(strlit2940, "++(1)", 1, partcv, params);
// compiled op node returning opresult2941 (depth = 5)
  int op_slot_left_2930 = gc_frame_newslot(opresult2941);
  params[0] = strlit2931;
  partcv[0] = 1;
  Object opresult2942 = callmethod(opresult2941, "++(1)", 1, partcv, params);
// compiled op node returning opresult2942 (depth = 4)
  *var_s = opresult2942;
  if (opresult2942 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2943 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2944 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2945 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2944);
// compiled member node returning call2945 (depth = 4)
  gc_frame_newslot(call2945);
// starting to compile block node (depth = 4)
  Object block2946 = alloc_Block(NULL, NULL, "ast", 668);
  gc_frame_newslot(block2946);
// method "_apply(_)"
  block_savedest(block2946);
  Object closure2947 = createclosure(4, "_apply(1)");
  setclosureframe(closure2947, stackframe);
  addtoclosure(closure2947, var_depth);
  addtoclosure(closure2947, var_spc);
  addtoclosure(closure2947, var_s);
  addtoclosure(closure2947, selfslot);
  struct UserObject *uo2947 = (struct UserObject*)block2946;
  uo2947->data[0] = (Object)closure2947;
  Method *meth_meth_ast_2947__apply_40_1_41_ = addmethod2pos(block2946, "_apply(1)", &meth_ast_2947__apply_40_1_41_, 0);
  int argcv_meth_ast_2947__apply_40_1_41_[] = {1};
  meth_meth_ast_2947__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2947__apply_40_1_41_);
  meth_meth_ast_2947__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2947__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block2946 (depth = 4)
  gc_frame_newslot(block2946);
// call case 5: prelude request
  params[0] = call2945;
  params[1] = block2946;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2974 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2943);
// compiled call node returning call2974 (depth = 3)
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_2975_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_matchCaseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 674
  setline(674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2976 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe2977 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_matchCaseNode (depth = 5)
  params[0] = *var_nullNode;
  params[1] = *var_emptySeq;
  partcv[0] = 2;
  Object call2978 = callmethodflags(*var_matchCaseNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2977);
// compiled call node returning call2978 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call2979 = callmethodflags(call2978, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2976);
// compiled call node returning call2979 (depth = 3)
  gc_frame_end(frame);
  return call2979;
}
Object meth_ast_2789_new_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_matchCaseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_matchee_39_ = &(stackframe->slots[0]);
  *var_matchee_39_ = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2790 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2790 = alloc_userobj2(13,12, objclass2790);
  gc_frame_newslot(obj2790);
  if (objclass2790 == NULL) {
    glfree(obj2790->class->name);
    obj2790->class->name = "matchCaseNode.new(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2790, self, 0);
  addmethodreal(obj2790,"outer", &reader_ast_outer_2791);
  Object oldself2790 = self;
  struct StackFrameObject *oldstackframe2790 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2790);
  gc_frame_newslot((Object)stackframe);
  self = obj2790;
  Object *oldselfslot2790 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2790 = (*(struct UserObject *)self).data[0], lowerouter2790 = thisouter2790;
  if (inheritingObject2790) {
    struct UserObject *inho2790 = (struct UserObject *)inheritingObject2790;
    while (inho2790->super != GraceDefaultObject) inho2790 = (struct UserObject *)inho2790->super;
    inho2790->super = obj2790;
    self = inheritingObject2790;
    *selfslot = self;
    lowerouter2790 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2790;
  }
  if (objclass2790 == NULL) {
  Method *reader2792 = addmethodrealflags(obj2790, "kind",&reader_ast_kind_2792, MFLAG_DEF);
  reader2792->definitionModule = modulename;
  reader2792->definitionLine = 631;
  }
  adddatum2(obj2790, alloc_Undefined(), 1);
  if (objclass2790 == NULL) {
    Method *reader2793 = addmethodrealflags(obj2790, "value", &reader_ast_value_2793, 0);
    Method *writer2793 = addmethodrealflags(obj2790, "value:=(1)", &writer_ast_value_2793, 0);
    reader2793->definitionModule = modulename;
    writer2793->definitionModule = modulename;
    reader2793->definitionLine = 632;
    writer2793->definitionLine = 632;
  }
  obj2790->flags |= OFLAG_MUTABLE;
  adddatum2(obj2790, alloc_Undefined(), 2);
  if (objclass2790 == NULL) {
    Method *reader2794 = addmethodrealflags(obj2790, "cases", &reader_ast_cases_2794, 0);
    Method *writer2794 = addmethodrealflags(obj2790, "cases:=(1)", &writer_ast_cases_2794, 0);
    reader2794->definitionModule = modulename;
    writer2794->definitionModule = modulename;
    reader2794->definitionLine = 633;
    writer2794->definitionLine = 633;
  }
  obj2790->flags |= OFLAG_MUTABLE;
  adddatum2(obj2790, alloc_Undefined(), 3);
// method "isSimple"
  struct UserObject *uo2795 = (struct UserObject*)obj2790;
  uo2795->data[4] = emptyclosure;
  Method *meth_meth_ast_2795_isSimple = addmethod2pos(obj2790, "isSimple", &meth_ast_2795_isSimple, 4);
  int argcv_meth_ast_2795_isSimple[] = {0};
  meth_meth_ast_2795_isSimple->type = alloc_MethodType(1, argcv_meth_ast_2795_isSimple);
  meth_meth_ast_2795_isSimple->definitionModule = modulename;
  meth_meth_ast_2795_isSimple->definitionLine = 634;
// method "end"
  struct UserObject *uo2797 = (struct UserObject*)obj2790;
  uo2797->data[5] = emptyclosure;
  Method *meth_meth_ast_2797_end = addmethod2pos(obj2790, "end", &meth_ast_2797_end, 5);
  int argcv_meth_ast_2797_end[] = {0};
  meth_meth_ast_2797_end->type = alloc_MethodType(1, argcv_meth_ast_2797_end);
  meth_meth_ast_2797_end->definitionModule = modulename;
  meth_meth_ast_2797_end->definitionLine = 635;
// method "matchee"
  struct UserObject *uo2815 = (struct UserObject*)obj2790;
  uo2815->data[6] = emptyclosure;
  Method *meth_meth_ast_2815_matchee = addmethod2pos(obj2790, "matchee", &meth_ast_2815_matchee, 6);
  int argcv_meth_ast_2815_matchee[] = {0};
  meth_meth_ast_2815_matchee->type = alloc_MethodType(1, argcv_meth_ast_2815_matchee);
  meth_meth_ast_2815_matchee->definitionModule = modulename;
  meth_meth_ast_2815_matchee->definitionLine = 639;
// method "accept(_)from(_)"
  struct UserObject *uo2818 = (struct UserObject*)obj2790;
  uo2818->data[7] = emptyclosure;
  Method *meth_meth_ast_2818_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj2790, "accept(1)from(1)", &meth_ast_2818_accept_40_1_41_from_40_1_41_, 7);
  int argcv_meth_ast_2818_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_2818_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_2818_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_2818_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2818_accept_40_1_41_from_40_1_41_->definitionLine = 640;
// method "map(_)ancestors(_)"
  struct UserObject *uo2837 = (struct UserObject*)obj2790;
  uo2837->data[8] = emptyclosure;
  Method *meth_meth_ast_2837_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj2790, "map(1)ancestors(1)", &meth_ast_2837_map_40_1_41_ancestors_40_1_41_, 8);
  int argcv_meth_ast_2837_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_2837_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_2837_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_2837_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2837_map_40_1_41_ancestors_40_1_41_->definitionLine = 649;
// method "pretty(_)"
  struct UserObject *uo2856 = (struct UserObject*)obj2790;
  uo2856->data[9] = emptyclosure;
  Method *meth_meth_ast_2856_pretty_40_1_41_ = addmethod2pos(obj2790, "pretty(1)", &meth_ast_2856_pretty_40_1_41_, 9);
  int argcv_meth_ast_2856_pretty_40_1_41_[] = {1};
  meth_meth_ast_2856_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2856_pretty_40_1_41_);
  meth_meth_ast_2856_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2856_pretty_40_1_41_->definitionLine = 656;
// method "toGrace(_)"
  struct UserObject *uo2925 = (struct UserObject*)obj2790;
  uo2925->data[10] = emptyclosure;
  Method *meth_meth_ast_2925_toGrace_40_1_41_ = addmethod2pos(obj2790, "toGrace(1)", &meth_ast_2925_toGrace_40_1_41_, 10);
  int argcv_meth_ast_2925_toGrace_40_1_41_[] = {1};
  meth_meth_ast_2925_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2925_toGrace_40_1_41_);
meth_meth_ast_2925_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_2925_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_2925_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2925_toGrace_40_1_41_->definitionLine = 665;
// method "shallowCopy"
  block_savedest(obj2790);
  Object closure2975 = createclosure(3, "shallowCopy");
  setclosureframe(closure2975, stackframe);
  addtoclosure(closure2975, var_nullNode);
  addtoclosure(closure2975, var_emptySeq);
  addtoclosure(closure2975, var_matchCaseNode);
  struct UserObject *uo2975 = (struct UserObject*)obj2790;
  uo2975->data[11] = (Object)closure2975;
  Method *meth_meth_ast_2975_shallowCopy = addmethod2pos(obj2790, "shallowCopy", &meth_ast_2975_shallowCopy, 11);
  int argcv_meth_ast_2975_shallowCopy[] = {0};
  meth_meth_ast_2975_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_2975_shallowCopy);
  meth_meth_ast_2975_shallowCopy->definitionModule = modulename;
  meth_meth_ast_2975_shallowCopy->definitionLine = 673;
  sourceObject = obj2790;
// Begin line 630
  setline(630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2980 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2981 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2980);
// compiled call node returning call2981 (depth = 3)
  struct UserObject *obj2790_uo = (struct UserObject *)obj2790;
  obj2790_uo->super = call2981;
  sourceObject = obj2790;
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2982 == NULL) {
    strlit2982 = alloc_String("matchcase");
    gc_root(strlit2982);
  }
// compiled string node returning strlit2982 (depth = 3)
  adddatum2(obj2790, strlit2982, 1);
  sourceObject = obj2790;
// Begin line 632
  setline(632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_matchee_39_ (depth = 3)
  adddatum2(obj2790, *var_matchee_39_, 2);
  sourceObject = obj2790;
// Begin line 633
  setline(633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cases_39_ (depth = 3)
  adddatum2(obj2790, *var_cases_39_, 3);
  sourceObject = obj2790;
  sourceObject = obj2790;
  sourceObject = obj2790;
  sourceObject = obj2790;
  sourceObject = obj2790;
  sourceObject = obj2790;
  sourceObject = obj2790;
  sourceObject = obj2790;
  objclass2790 = obj2790->class;
  objclass2790->definitionModule = modulename;
  objclass2790->definitionLine = 629;
  (*(struct UserObject *)self).data[0] = lowerouter2790;
  self = oldself2790;
  selfslot = oldselfslot2790;
  stackframe = oldstackframe2790;
  gc_frame_end(frame);
  return obj2790;
}
Object meth_ast_2789_new_40_2_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_matchCaseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_matchee_39_ = &(stackframe->slots[0]);
  *var_matchee_39_ = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2790 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2790 = alloc_userobj2(13,12, objclass2790);
  gc_frame_newslot(obj2790);
  if (objclass2790 == NULL) {
    glfree(obj2790->class->name);
    obj2790->class->name = "matchCaseNode.new(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2790, self, 0);
  addmethodreal(obj2790,"outer", &reader_ast_outer_2791);
  Object oldself2790 = self;
  struct StackFrameObject *oldstackframe2790 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2790);
  gc_frame_newslot((Object)stackframe);
  self = obj2790;
  Object *oldselfslot2790 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2790 = (*(struct UserObject *)self).data[0], lowerouter2790 = thisouter2790;
  if (inheritingObject2790) {
    struct UserObject *inho2790 = (struct UserObject *)inheritingObject2790;
    while (inho2790->super != GraceDefaultObject) inho2790 = (struct UserObject *)inho2790->super;
    inho2790->super = obj2790;
    self = inheritingObject2790;
    *selfslot = self;
    lowerouter2790 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2790;
  }
  if (objclass2790 == NULL) {
  Method *reader2792 = addmethodrealflags(obj2790, "kind",&reader_ast_kind_2792, MFLAG_DEF);
  reader2792->definitionModule = modulename;
  reader2792->definitionLine = 631;
  }
  adddatum2(obj2790, alloc_Undefined(), 1);
  if (objclass2790 == NULL) {
    Method *reader2793 = addmethodrealflags(obj2790, "value", &reader_ast_value_2793, 0);
    Method *writer2793 = addmethodrealflags(obj2790, "value:=(1)", &writer_ast_value_2793, 0);
    reader2793->definitionModule = modulename;
    writer2793->definitionModule = modulename;
    reader2793->definitionLine = 632;
    writer2793->definitionLine = 632;
  }
  obj2790->flags |= OFLAG_MUTABLE;
  adddatum2(obj2790, alloc_Undefined(), 2);
  if (objclass2790 == NULL) {
    Method *reader2794 = addmethodrealflags(obj2790, "cases", &reader_ast_cases_2794, 0);
    Method *writer2794 = addmethodrealflags(obj2790, "cases:=(1)", &writer_ast_cases_2794, 0);
    reader2794->definitionModule = modulename;
    writer2794->definitionModule = modulename;
    reader2794->definitionLine = 633;
    writer2794->definitionLine = 633;
  }
  obj2790->flags |= OFLAG_MUTABLE;
  adddatum2(obj2790, alloc_Undefined(), 3);
// method "isSimple"
  struct UserObject *uo2795 = (struct UserObject*)obj2790;
  uo2795->data[4] = emptyclosure;
  Method *meth_meth_ast_2795_isSimple = addmethod2pos(obj2790, "isSimple", &meth_ast_2795_isSimple, 4);
  int argcv_meth_ast_2795_isSimple[] = {0};
  meth_meth_ast_2795_isSimple->type = alloc_MethodType(1, argcv_meth_ast_2795_isSimple);
  meth_meth_ast_2795_isSimple->definitionModule = modulename;
  meth_meth_ast_2795_isSimple->definitionLine = 634;
// method "end"
  struct UserObject *uo2797 = (struct UserObject*)obj2790;
  uo2797->data[5] = emptyclosure;
  Method *meth_meth_ast_2797_end = addmethod2pos(obj2790, "end", &meth_ast_2797_end, 5);
  int argcv_meth_ast_2797_end[] = {0};
  meth_meth_ast_2797_end->type = alloc_MethodType(1, argcv_meth_ast_2797_end);
  meth_meth_ast_2797_end->definitionModule = modulename;
  meth_meth_ast_2797_end->definitionLine = 635;
// method "matchee"
  struct UserObject *uo2815 = (struct UserObject*)obj2790;
  uo2815->data[6] = emptyclosure;
  Method *meth_meth_ast_2815_matchee = addmethod2pos(obj2790, "matchee", &meth_ast_2815_matchee, 6);
  int argcv_meth_ast_2815_matchee[] = {0};
  meth_meth_ast_2815_matchee->type = alloc_MethodType(1, argcv_meth_ast_2815_matchee);
  meth_meth_ast_2815_matchee->definitionModule = modulename;
  meth_meth_ast_2815_matchee->definitionLine = 639;
// method "accept(_)from(_)"
  struct UserObject *uo2818 = (struct UserObject*)obj2790;
  uo2818->data[7] = emptyclosure;
  Method *meth_meth_ast_2818_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj2790, "accept(1)from(1)", &meth_ast_2818_accept_40_1_41_from_40_1_41_, 7);
  int argcv_meth_ast_2818_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_2818_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_2818_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_2818_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2818_accept_40_1_41_from_40_1_41_->definitionLine = 640;
// method "map(_)ancestors(_)"
  struct UserObject *uo2837 = (struct UserObject*)obj2790;
  uo2837->data[8] = emptyclosure;
  Method *meth_meth_ast_2837_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj2790, "map(1)ancestors(1)", &meth_ast_2837_map_40_1_41_ancestors_40_1_41_, 8);
  int argcv_meth_ast_2837_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_2837_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_2837_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_2837_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2837_map_40_1_41_ancestors_40_1_41_->definitionLine = 649;
// method "pretty(_)"
  struct UserObject *uo2856 = (struct UserObject*)obj2790;
  uo2856->data[9] = emptyclosure;
  Method *meth_meth_ast_2856_pretty_40_1_41_ = addmethod2pos(obj2790, "pretty(1)", &meth_ast_2856_pretty_40_1_41_, 9);
  int argcv_meth_ast_2856_pretty_40_1_41_[] = {1};
  meth_meth_ast_2856_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2856_pretty_40_1_41_);
  meth_meth_ast_2856_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2856_pretty_40_1_41_->definitionLine = 656;
// method "toGrace(_)"
  struct UserObject *uo2925 = (struct UserObject*)obj2790;
  uo2925->data[10] = emptyclosure;
  Method *meth_meth_ast_2925_toGrace_40_1_41_ = addmethod2pos(obj2790, "toGrace(1)", &meth_ast_2925_toGrace_40_1_41_, 10);
  int argcv_meth_ast_2925_toGrace_40_1_41_[] = {1};
  meth_meth_ast_2925_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_2925_toGrace_40_1_41_);
meth_meth_ast_2925_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_2925_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_2925_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_2925_toGrace_40_1_41_->definitionLine = 665;
// method "shallowCopy"
  block_savedest(obj2790);
  Object closure2975 = createclosure(3, "shallowCopy");
  setclosureframe(closure2975, stackframe);
  addtoclosure(closure2975, var_nullNode);
  addtoclosure(closure2975, var_emptySeq);
  addtoclosure(closure2975, var_matchCaseNode);
  struct UserObject *uo2975 = (struct UserObject*)obj2790;
  uo2975->data[11] = (Object)closure2975;
  Method *meth_meth_ast_2975_shallowCopy = addmethod2pos(obj2790, "shallowCopy", &meth_ast_2975_shallowCopy, 11);
  int argcv_meth_ast_2975_shallowCopy[] = {0};
  meth_meth_ast_2975_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_2975_shallowCopy);
  meth_meth_ast_2975_shallowCopy->definitionModule = modulename;
  meth_meth_ast_2975_shallowCopy->definitionLine = 673;
  sourceObject = obj2790;
// Begin line 630
  setline(630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2980 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2981 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2980);
// compiled call node returning call2981 (depth = 3)
  struct UserObject *obj2790_uo = (struct UserObject *)obj2790;
  obj2790_uo->super = call2981;
  sourceObject = obj2790;
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2982 == NULL) {
    strlit2982 = alloc_String("matchcase");
    gc_root(strlit2982);
  }
// compiled string node returning strlit2982 (depth = 3)
  adddatum2(obj2790, strlit2982, 1);
  sourceObject = obj2790;
// Begin line 632
  setline(632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_matchee_39_ (depth = 3)
  adddatum2(obj2790, *var_matchee_39_, 2);
  sourceObject = obj2790;
// Begin line 633
  setline(633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cases_39_ (depth = 3)
  adddatum2(obj2790, *var_cases_39_, 3);
  sourceObject = obj2790;
  sourceObject = obj2790;
  sourceObject = obj2790;
  sourceObject = obj2790;
  sourceObject = obj2790;
  sourceObject = obj2790;
  sourceObject = obj2790;
  sourceObject = obj2790;
  objclass2790 = obj2790->class;
  objclass2790->definitionModule = modulename;
  objclass2790->definitionLine = 629;
  (*(struct UserObject *)self).data[0] = lowerouter2790;
  self = oldself2790;
  selfslot = oldselfslot2790;
  stackframe = oldstackframe2790;
  gc_frame_end(frame);
  return obj2790;
}
Object meth_ast_2984_matchCaseNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "matchCaseNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_matchCaseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 628
  setline(628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_matchCaseNode (depth = 3)
  gc_frame_end(frame);
  return *var_matchCaseNode;
}
Object meth_ast_2995_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2998 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2999 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2998);
// compiled member node returning call2999 (depth = 5)
  int op_slot_right_2997 = gc_frame_newslot(call2999);
// starting to compile identifier node (depth = 5)
  Object bool3001 = alloc_Boolean(0);
// compiled identifier node returning bool3001 (depth = 5)
  int op_slot_left_2997 = gc_frame_newslot(bool3001);
  params[0] = call2999;
  partcv[0] = 1;
  Object opresult3002 = callmethod(bool3001, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3002 (depth = 4)
  Object if2996 = done;
  if (istrue(opresult3002)) {
// starting to compile return node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3003 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3004 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3005 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3004);
// compiled member node returning call3005 (depth = 6)
  partcv[0] = 0;
  Object call3006 = callmethodflags(call3005, "end", 1, partcv, params, 0);
  gc_frame_end(callframe3003);
// compiled member node returning call3006 (depth = 5)
  return call3006;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if2996 = undefined;
  } else {
  }
// compiled if node returning if2996 (depth = 3)
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3007 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3008 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3009 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3010 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3009);
// compiled member node returning call3010 (depth = 5)
  partcv[0] = 0;
  Object call3011 = callmethodflags(call3010, "last", 1, partcv, params, 0);
  gc_frame_end(callframe3008);
// compiled member node returning call3011 (depth = 4)
  partcv[0] = 0;
  Object call3012 = callmethodflags(call3011, "end", 1, partcv, params, 0);
  gc_frame_end(callframe3007);
// compiled member node returning call3012 (depth = 3)
  gc_frame_end(frame);
  return call3012;
}
Object meth_ast_3016__apply_40_2_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_acc = &(stackframe->slots[0]);
  *var_acc = args[curarg];
  curarg++;
  Object *var_each = &(stackframe->slots[1]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3018 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  partcv[0] = 0;
  Object call3019 = callmethodflags(*var_each, "nameString", 1, partcv, params, 0);
  gc_frame_end(callframe3018);
// compiled member node returning call3019 (depth = 6)
  int op_slot_right_3017 = gc_frame_newslot(call3019);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acc (depth = 6)
  int op_slot_left_3017 = gc_frame_newslot(*var_acc);
  params[0] = call3019;
  partcv[0] = 1;
  Object opresult3021 = callmethod(*var_acc, "++(1)", 1, partcv, params);
// compiled op node returning opresult3021 (depth = 5)
  gc_frame_end(frame);
  return opresult3021;
}
Object meth_ast_3013_nameString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 699
  setline(699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3014 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3015 = alloc_Block(NULL, NULL, "ast", 699);
  gc_frame_newslot(block3015);
// method "_apply(_,_)"
  block_savedest(block3015);
  Object closure3016 = createclosure(1, "_apply(2)");
  setclosureframe(closure3016, stackframe);
  addtoclosure(closure3016, selfslot);
  struct UserObject *uo3016 = (struct UserObject*)block3015;
  uo3016->data[0] = (Object)closure3016;
  Method *meth_meth_ast_3016__apply_40_2_41_ = addmethod2pos(block3015, "_apply(2)", &meth_ast_3016__apply_40_2_41_, 0);
  int argcv_meth_ast_3016__apply_40_2_41_[] = {2};
  meth_meth_ast_3016__apply_40_2_41_->type = alloc_MethodType(1, argcv_meth_ast_3016__apply_40_2_41_);
  meth_meth_ast_3016__apply_40_2_41_->definitionModule = modulename;
  meth_meth_ast_3016__apply_40_2_41_->definitionLine = 3050;
// compiled block node returning block3015 (depth = 4)
  gc_frame_newslot(block3015);
// Begin line 700
  setline(700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit3023 == NULL) {
    strlit3023 = alloc_String("");
    gc_root(strlit3023);
  }
// compiled string node returning strlit3023 (depth = 4)
  gc_frame_newslot(strlit3023);
// call case 6: other requests
// Begin line 699
  setline(699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3024 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3025 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3024);
// compiled member node returning call3025 (depth = 4)
  params[0] = block3015;
  params[1] = strlit3023;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3026 = callmethodflags(call3025, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3014);
// compiled call node returning call3026 (depth = 3)
  gc_frame_end(frame);
  return call3026;
}
Object meth_ast_3030__apply_40_2_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_acc = &(stackframe->slots[0]);
  *var_acc = args[curarg];
  curarg++;
  Object *var_each = &(stackframe->slots[1]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3032 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  partcv[0] = 0;
  Object call3033 = callmethodflags(*var_each, "canonicalName", 1, partcv, params, 0);
  gc_frame_end(callframe3032);
// compiled member node returning call3033 (depth = 6)
  int op_slot_right_3031 = gc_frame_newslot(call3033);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acc (depth = 6)
  int op_slot_left_3031 = gc_frame_newslot(*var_acc);
  params[0] = call3033;
  partcv[0] = 1;
  Object opresult3035 = callmethod(*var_acc, "++(1)", 1, partcv, params);
// compiled op node returning opresult3035 (depth = 5)
  gc_frame_end(frame);
  return opresult3035;
}
Object meth_ast_3027_canonicalName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canonicalName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 705
  setline(705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3028 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3029 = alloc_Block(NULL, NULL, "ast", 705);
  gc_frame_newslot(block3029);
// method "_apply(_,_)"
  block_savedest(block3029);
  Object closure3030 = createclosure(1, "_apply(2)");
  setclosureframe(closure3030, stackframe);
  addtoclosure(closure3030, selfslot);
  struct UserObject *uo3030 = (struct UserObject*)block3029;
  uo3030->data[0] = (Object)closure3030;
  Method *meth_meth_ast_3030__apply_40_2_41_ = addmethod2pos(block3029, "_apply(2)", &meth_ast_3030__apply_40_2_41_, 0);
  int argcv_meth_ast_3030__apply_40_2_41_[] = {2};
  meth_meth_ast_3030__apply_40_2_41_->type = alloc_MethodType(1, argcv_meth_ast_3030__apply_40_2_41_);
  meth_meth_ast_3030__apply_40_2_41_->definitionModule = modulename;
  meth_meth_ast_3030__apply_40_2_41_->definitionLine = 3050;
// compiled block node returning block3029 (depth = 4)
  gc_frame_newslot(block3029);
// Begin line 706
  setline(706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit3037 == NULL) {
    strlit3037 = alloc_String("");
    gc_root(strlit3037);
  }
// compiled string node returning strlit3037 (depth = 4)
  gc_frame_newslot(strlit3037);
// call case 6: other requests
// Begin line 705
  setline(705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3038 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3039 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3038);
// compiled member node returning call3039 (depth = 4)
  params[0] = block3029;
  params[1] = strlit3037;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3040 = callmethodflags(call3039, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3028);
// compiled call node returning call3040 (depth = 3)
  gc_frame_end(frame);
  return call3040;
}
Object meth_ast_3041_value(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "value");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_uninitialized = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 710
  setline(710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3044 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3045 = callmethodflags(self, "cachedIdentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3044);
// compiled member node returning call3045 (depth = 5)
  int op_slot_right_3043 = gc_frame_newslot(call3045);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_uninitialized (depth = 5)
  int op_slot_left_3043 = gc_frame_newslot(*var_uninitialized);
  params[0] = call3045;
  partcv[0] = 1;
  Object opresult3047 = callmethod(*var_uninitialized, "==(1)", 1, partcv, params);
// compiled op node returning opresult3047 (depth = 4)
  Object if3042 = done;
  if (istrue(opresult3047)) {
// Begin line 711
  setline(711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3048 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe3049 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe3050 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3051 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3050);
// compiled member node returning call3051 (depth = 6)
  gc_frame_newslot(call3051);
// starting to compile identifier node (depth = 6)
  Object bool3052 = alloc_Boolean(0);
// compiled identifier node returning bool3052 (depth = 6)
  gc_frame_newslot(bool3052);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_identifierNode (depth = 6)
  params[0] = call3051;
  params[1] = bool3052;
  partcv[0] = 2;
  Object call3053 = callmethodflags(*var_identifierNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3049);
// compiled call node returning call3053 (depth = 5)
  gc_frame_newslot(call3053);
// call case 4: self request
  params[0] = call3053;
  partcv[0] = 1;
  Object call3054 = callmethodflags(self, "cachedIdentifier:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3048);
// compiled call node returning call3054 (depth = 4)
// Begin line 712
  setline(712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3055 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3056 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3057 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3058 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3059 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3058);
// compiled member node returning call3059 (depth = 7)
  partcv[0] = 0;
  Object call3060 = callmethodflags(call3059, "first", 1, partcv, params, 0);
  gc_frame_end(callframe3057);
// compiled member node returning call3060 (depth = 6)
  partcv[0] = 0;
  Object call3061 = callmethodflags(call3060, "line", 1, partcv, params, 0);
  gc_frame_end(callframe3056);
// compiled member node returning call3061 (depth = 5)
  gc_frame_newslot(call3061);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3062 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3063 = callmethodflags(self, "cachedIdentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3062);
// compiled member node returning call3063 (depth = 5)
  params[0] = call3061;
  partcv[0] = 1;
  Object call3064 = callmethodflags(call3063, "line:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3055);
// compiled call node returning call3064 (depth = 4)
// Begin line 713
  setline(713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3065 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3066 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3067 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3068 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3069 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3068);
// compiled member node returning call3069 (depth = 7)
  partcv[0] = 0;
  Object call3070 = callmethodflags(call3069, "first", 1, partcv, params, 0);
  gc_frame_end(callframe3067);
// compiled member node returning call3070 (depth = 6)
  partcv[0] = 0;
  Object call3071 = callmethodflags(call3070, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe3066);
// compiled member node returning call3071 (depth = 5)
  gc_frame_newslot(call3071);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3072 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3073 = callmethodflags(self, "cachedIdentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3072);
// compiled member node returning call3073 (depth = 5)
  params[0] = call3071;
  partcv[0] = 1;
  Object call3074 = callmethodflags(call3073, "linePos:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3065);
// compiled call node returning call3074 (depth = 4)
// Begin line 714
  setline(714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3075 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3076 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3077 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3078 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3079 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3078);
// compiled member node returning call3079 (depth = 7)
  partcv[0] = 0;
  Object call3080 = callmethodflags(call3079, "last", 1, partcv, params, 0);
  gc_frame_end(callframe3077);
// compiled member node returning call3080 (depth = 6)
  partcv[0] = 0;
  Object call3081 = callmethodflags(call3080, "end", 1, partcv, params, 0);
  gc_frame_end(callframe3076);
// compiled member node returning call3081 (depth = 5)
  gc_frame_newslot(call3081);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3082 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3083 = callmethodflags(self, "cachedIdentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3082);
// compiled member node returning call3083 (depth = 5)
  params[0] = call3081;
  partcv[0] = 1;
  Object call3084 = callmethodflags(call3083, "end:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3075);
// compiled call node returning call3084 (depth = 4)
// Begin line 715
  setline(715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3085 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool3086 = alloc_Boolean(1);
// compiled identifier node returning bool3086 (depth = 5)
  gc_frame_newslot(bool3086);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3087 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3088 = callmethodflags(self, "cachedIdentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3087);
// compiled member node returning call3088 (depth = 5)
  params[0] = bool3086;
  partcv[0] = 1;
  Object call3089 = callmethodflags(call3088, "isBindingOccurrence:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3085);
// compiled call node returning call3089 (depth = 4)
    gc_frame_newslot(call3089);
    if3042 = call3089;
  } else {
  }
// compiled if node returning if3042 (depth = 3)
// Begin line 717
  setline(717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3090 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3091 = callmethodflags(self, "cachedIdentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3090);
// compiled member node returning call3091 (depth = 3)
  gc_frame_end(frame);
  return call3091;
}
Object meth_ast_3092_isExecutable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 719
  setline(719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3093 = alloc_Boolean(0);
// compiled identifier node returning bool3093 (depth = 3)
  gc_frame_end(frame);
  return bool3093;
}
Object meth_ast_3100__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_b = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 7)
  int callframe3101 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_b (depth = 8)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call3102 = callmethodflags(*var_b, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3101);
// compiled call node returning call3102 (depth = 7)
  gc_frame_end(frame);
  return call3102;
}
Object meth_ast_3097__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_b = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 722
  setline(722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3098 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3099 = alloc_Block(NULL, NULL, "ast", 722);
  gc_frame_newslot(block3099);
// method "_apply(_)"
  block_savedest(block3099);
  Object closure3100 = createclosure(2, "_apply(1)");
  setclosureframe(closure3100, stackframe);
  addtoclosure(closure3100, var_b);
  addtoclosure(closure3100, selfslot);
  struct UserObject *uo3100 = (struct UserObject*)block3099;
  uo3100->data[0] = (Object)closure3100;
  Method *meth_meth_ast_3100__apply_40_1_41_ = addmethod2pos(block3099, "_apply(1)", &meth_ast_3100__apply_40_1_41_, 0);
  int argcv_meth_ast_3100__apply_40_1_41_[] = {1};
  meth_meth_ast_3100__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3100__apply_40_1_41_);
  meth_meth_ast_3100__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3100__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block3099 (depth = 6)
  gc_frame_newslot(block3099);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3104 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call3105 = callmethodflags(*var_part, "params", 1, partcv, params, 0);
  gc_frame_end(callframe3104);
// compiled member node returning call3105 (depth = 6)
  params[0] = block3099;
  partcv[0] = 1;
  Object call3106 = callmethodflags(call3105, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3098);
// compiled call node returning call3106 (depth = 5)
  gc_frame_end(frame);
  return call3106;
}
Object meth_ast_3094_parametersDo_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parametersDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parametersDo(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parametersDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parametersDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 721
  setline(721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3095 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3096 = alloc_Block(NULL, NULL, "ast", 721);
  gc_frame_newslot(block3096);
// method "_apply(_)"
  block_savedest(block3096);
  Object closure3097 = createclosure(2, "_apply(1)");
  setclosureframe(closure3097, stackframe);
  addtoclosure(closure3097, var_b);
  addtoclosure(closure3097, selfslot);
  struct UserObject *uo3097 = (struct UserObject*)block3096;
  uo3097->data[0] = (Object)closure3097;
  Method *meth_meth_ast_3097__apply_40_1_41_ = addmethod2pos(block3096, "_apply(1)", &meth_ast_3097__apply_40_1_41_, 0);
  int argcv_meth_ast_3097__apply_40_1_41_[] = {1};
  meth_meth_ast_3097__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3097__apply_40_1_41_);
  meth_meth_ast_3097__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3097__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block3096 (depth = 4)
  gc_frame_newslot(block3096);
// call case 6: other requests
// Begin line 721
  setline(721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3108 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3109 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3108);
// compiled member node returning call3109 (depth = 4)
  params[0] = block3096;
  partcv[0] = 1;
  Object call3110 = callmethodflags(call3109, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3095);
// compiled call node returning call3110 (depth = 3)
  gc_frame_end(frame);
  return call3110;
}
Object meth_ast_3111_scope_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3112 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call3113 = callmethodflags(self, "symbolTable:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3112);
// compiled call node returning call3113 (depth = 3)
// Begin line 729
  setline(729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3114 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call3115 = callmethodflags(*var_st, "node:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3114);
// compiled call node returning call3115 (depth = 3)
  gc_frame_end(frame);
  return call3115;
}
Object meth_ast_3116_declarationKindWithAncestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 731
  setline(731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3117 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  partcv[0] = 0;
  Object call3118 = callmethodflags(*var_k, "typedec", 1, partcv, params, 0);
  gc_frame_end(callframe3117);
// compiled member node returning call3118 (depth = 3)
  gc_frame_end(frame);
  return call3118;
}
Object meth_ast_3151__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 742
  setline(742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3152 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3153 = callmethodflags(*var_part, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3152);
// compiled call node returning call3153 (depth = 6)
  gc_frame_end(frame);
  return call3153;
}
Object meth_ast_3119_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 733
  setline(733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3121 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3122 = callmethodflags(*var_visitor, "visitMethodType(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3121);
// compiled call node returning call3122 (depth = 4)
  Object if3120 = done;
  if (istrue(call3122)) {
// Begin line 734
  setline(734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3123 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call3124 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3123);
// compiled call node returning call3124 (depth = 5)
  *var_newChain = call3124;
  if (call3124 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 735
  setline(735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3127 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3128 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3127);
// compiled member node returning call3128 (depth = 6)
  int op_slot_right_3126 = gc_frame_newslot(call3128);
// starting to compile identifier node (depth = 6)
  Object bool3130 = alloc_Boolean(0);
// compiled identifier node returning bool3130 (depth = 6)
  int op_slot_left_3126 = gc_frame_newslot(bool3130);
  params[0] = call3128;
  partcv[0] = 1;
  Object opresult3131 = callmethod(bool3130, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3131 (depth = 5)
  Object if3125 = done;
  if (istrue(opresult3131)) {
// Begin line 736
  setline(736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3132 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3133 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3134 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3133);
// compiled member node returning call3134 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3135 = callmethodflags(call3134, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3132);
// compiled call node returning call3135 (depth = 5)
    gc_frame_newslot(call3135);
    if3125 = call3135;
  } else {
  }
// compiled if node returning if3125 (depth = 4)
// Begin line 738
  setline(738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3138 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3139 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3138);
// compiled member node returning call3139 (depth = 6)
  int op_slot_right_3137 = gc_frame_newslot(call3139);
// starting to compile identifier node (depth = 6)
  Object bool3141 = alloc_Boolean(0);
// compiled identifier node returning bool3141 (depth = 6)
  int op_slot_left_3137 = gc_frame_newslot(bool3141);
  params[0] = call3139;
  partcv[0] = 1;
  Object opresult3142 = callmethod(bool3141, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3142 (depth = 5)
  Object if3136 = done;
  if (istrue(opresult3142)) {
// Begin line 739
  setline(739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3143 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3144 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3145 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3144);
// compiled member node returning call3145 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3146 = callmethodflags(call3145, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3143);
// compiled call node returning call3146 (depth = 5)
    gc_frame_newslot(call3146);
    if3136 = call3146;
  } else {
  }
// compiled if node returning if3136 (depth = 4)
// Begin line 741
  setline(741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3147 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3148 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3149 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3148);
// compiled member node returning call3149 (depth = 5)
  gc_frame_newslot(call3149);
// starting to compile block node (depth = 5)
  Object block3150 = alloc_Block(NULL, NULL, "ast", 741);
  gc_frame_newslot(block3150);
// method "_apply(_)"
  block_savedest(block3150);
  Object closure3151 = createclosure(3, "_apply(1)");
  setclosureframe(closure3151, stackframe);
  addtoclosure(closure3151, var_visitor);
  addtoclosure(closure3151, var_newChain);
  addtoclosure(closure3151, selfslot);
  struct UserObject *uo3151 = (struct UserObject*)block3150;
  uo3151->data[0] = (Object)closure3151;
  Method *meth_meth_ast_3151__apply_40_1_41_ = addmethod2pos(block3150, "_apply(1)", &meth_ast_3151__apply_40_1_41_, 0);
  int argcv_meth_ast_3151__apply_40_1_41_[] = {1};
  meth_meth_ast_3151__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3151__apply_40_1_41_);
  meth_meth_ast_3151__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3151__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block3150 (depth = 5)
  gc_frame_newslot(block3150);
// call case 5: prelude request
  params[0] = call3149;
  params[1] = block3150;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3155 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3147);
// compiled call node returning call3155 (depth = 4)
    gc_frame_newslot(call3155);
    if3120 = call3155;
  } else {
  }
// compiled if node returning if3120 (depth = 3)
  gc_frame_end(frame);
  return if3120;
}
Object meth_ast_3156_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 747
  setline(747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3157 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3158 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3157);
// compiled member node returning call3158 (depth = 4)
  *var_n = call3158;
  if (call3158 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 748
  setline(748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3159 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3160 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3159);
// compiled call node returning call3160 (depth = 4)
  *var_newChain = call3160;
  if (call3160 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3161 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3162 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3163 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3164 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3163);
// compiled member node returning call3164 (depth = 5)
  gc_frame_newslot(call3164);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call3164;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3165 = callmethodflags(module_ast, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3162);
// compiled call node returning call3165 (depth = 4)
  gc_frame_newslot(call3165);
// call case 6: other requests
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3165;
  partcv[0] = 1;
  Object call3166 = callmethodflags(*var_n, "rtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3161);
// compiled call node returning call3166 (depth = 3)
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3167 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3168 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3169 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3170 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3169);
// compiled member node returning call3170 (depth = 5)
  gc_frame_newslot(call3170);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call3170;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3171 = callmethodflags(module_ast, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3168);
// compiled call node returning call3171 (depth = 4)
  gc_frame_newslot(call3171);
// call case 6: other requests
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3171;
  partcv[0] = 1;
  Object call3172 = callmethodflags(*var_n, "signature:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3167);
// compiled call node returning call3172 (depth = 3)
// Begin line 751
  setline(751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3173 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3174 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3175 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3176 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3175);
// compiled member node returning call3176 (depth = 5)
  gc_frame_newslot(call3176);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call3176;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3177 = callmethodflags(module_ast, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3174);
// compiled call node returning call3177 (depth = 4)
  gc_frame_newslot(call3177);
// call case 6: other requests
// Begin line 751
  setline(751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3177;
  partcv[0] = 1;
  Object call3178 = callmethodflags(*var_n, "typeParams:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3173);
// compiled call node returning call3178 (depth = 3)
// Begin line 752
  setline(752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3179 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call3180 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3179);
// compiled call node returning call3180 (depth = 3)
  gc_frame_end(frame);
  return call3180;
}
Object meth_ast_3321__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 767
  setline(767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3323 == NULL) {
    strlit3323 = alloc_String("");
    gc_root(strlit3323);
  }
// compiled string node returning strlit3323 (depth = 7)
  int op_slot_right_3322 = gc_frame_newslot(strlit3323);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3326 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num3328 = alloc_Float64(2);
// compiled num node returning num3328 (depth = 10)
  int op_slot_right_3327 = gc_frame_newslot(num3328);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_3327 = gc_frame_newslot(*var_depth);
  params[0] = num3328;
  partcv[0] = 1;
  Object sum3330 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3330 (depth = 9)
  gc_frame_newslot(sum3330);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  params[0] = sum3330;
  partcv[0] = 1;
  Object call3331 = callmethodflags(*var_part, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3326);
// compiled call node returning call3331 (depth = 8)
  int op_slot_right_3325 = gc_frame_newslot(call3331);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3334 == NULL) {
    strlit3334 = alloc_String("");
    gc_root(strlit3334);
  }
// compiled string node returning strlit3334 (depth = 9)
  int op_slot_right_3333 = gc_frame_newslot(strlit3334);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_3336 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3339 == NULL) {
    strlit3339 = alloc_String("""\x0a""  ");
    gc_root(strlit3339);
  }
// compiled string node returning strlit3339 (depth = 11)
  int op_slot_right_3338 = gc_frame_newslot(strlit3339);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_right_3341 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 12)
  if (strlit3343 == NULL) {
    strlit3343 = alloc_String("");
    gc_root(strlit3343);
  }
// compiled string node returning strlit3343 (depth = 12)
  int op_slot_left_3341 = gc_frame_newslot(strlit3343);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3344 = callmethod(strlit3343, "++(1)", 1, partcv, params);
// compiled op node returning opresult3344 (depth = 11)
  int op_slot_left_3338 = gc_frame_newslot(opresult3344);
  params[0] = strlit3339;
  partcv[0] = 1;
  Object opresult3345 = callmethod(opresult3344, "++(1)", 1, partcv, params);
// compiled op node returning opresult3345 (depth = 10)
  int op_slot_left_3336 = gc_frame_newslot(opresult3345);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3346 = callmethod(opresult3345, "++(1)", 1, partcv, params);
// compiled op node returning opresult3346 (depth = 9)
  int op_slot_left_3333 = gc_frame_newslot(opresult3346);
  params[0] = strlit3334;
  partcv[0] = 1;
  Object opresult3347 = callmethod(opresult3346, "++(1)", 1, partcv, params);
// compiled op node returning opresult3347 (depth = 8)
  int op_slot_left_3325 = gc_frame_newslot(opresult3347);
  params[0] = call3331;
  partcv[0] = 1;
  Object opresult3348 = callmethod(opresult3347, "++(1)", 1, partcv, params);
// compiled op node returning opresult3348 (depth = 7)
  int op_slot_left_3322 = gc_frame_newslot(opresult3348);
  params[0] = strlit3323;
  partcv[0] = 1;
  Object opresult3349 = callmethod(opresult3348, "++(1)", 1, partcv, params);
// compiled op node returning opresult3349 (depth = 6)
  *var_s = opresult3349;
  if (opresult3349 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_3181_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 755
  setline(755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3184 = alloc_Float64(1);
// compiled num node returning num3184 (depth = 6)
  int op_slot_right_3183 = gc_frame_newslot(num3184);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_3183 = gc_frame_newslot(*var_depth);
  params[0] = num3184;
  partcv[0] = 1;
  Object sum3186 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3186 (depth = 5)
  int op_slot_right_3182 = gc_frame_newslot(sum3186);
// starting to compile string node (depth = 5)
  if (strlit3188 == NULL) {
    strlit3188 = alloc_String("  ");
    gc_root(strlit3188);
  }
// compiled string node returning strlit3188 (depth = 5)
  int op_slot_left_3182 = gc_frame_newslot(strlit3188);
  params[0] = sum3186;
  partcv[0] = 1;
  Object prod3189 = callmethod(strlit3188, "*(1)", 1, partcv, params);
// compiled op node returning prod3189 (depth = 4)
  *var_spc = prod3189;
  if (prod3189 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 756
  setline(756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3191 == NULL) {
    strlit3191 = alloc_String("""\x0a""");
    gc_root(strlit3191);
  }
// compiled string node returning strlit3191 (depth = 5)
  int op_slot_right_3190 = gc_frame_newslot(strlit3191);
// starting to compile call node (depth = 5)
  int callframe3193 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call3194 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3193);
// compiled call node returning call3194 (depth = 5)
  int op_slot_left_3190 = gc_frame_newslot(call3194);
  params[0] = strlit3191;
  partcv[0] = 1;
  Object opresult3195 = callmethod(call3194, "++(1)", 1, partcv, params);
// compiled op node returning opresult3195 (depth = 4)
  *var_s = opresult3195;
  if (opresult3195 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 757
  setline(757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3197 == NULL) {
    strlit3197 = alloc_String("""\x0a""");
    gc_root(strlit3197);
  }
// compiled string node returning strlit3197 (depth = 5)
  int op_slot_right_3196 = gc_frame_newslot(strlit3197);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3200 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3201 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3200);
// compiled member node returning call3201 (depth = 6)
  int op_slot_right_3199 = gc_frame_newslot(call3201);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3204 == NULL) {
    strlit3204 = alloc_String("Name: ");
    gc_root(strlit3204);
  }
// compiled string node returning strlit3204 (depth = 7)
  int op_slot_right_3203 = gc_frame_newslot(strlit3204);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_3206 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3209 == NULL) {
    strlit3209 = alloc_String("");
    gc_root(strlit3209);
  }
// compiled string node returning strlit3209 (depth = 9)
  int op_slot_right_3208 = gc_frame_newslot(strlit3209);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_3211 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit3213 == NULL) {
    strlit3213 = alloc_String("");
    gc_root(strlit3213);
  }
// compiled string node returning strlit3213 (depth = 10)
  int op_slot_left_3211 = gc_frame_newslot(strlit3213);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3214 = callmethod(strlit3213, "++(1)", 1, partcv, params);
// compiled op node returning opresult3214 (depth = 9)
  int op_slot_left_3208 = gc_frame_newslot(opresult3214);
  params[0] = strlit3209;
  partcv[0] = 1;
  Object opresult3215 = callmethod(opresult3214, "++(1)", 1, partcv, params);
// compiled op node returning opresult3215 (depth = 8)
  int op_slot_left_3206 = gc_frame_newslot(opresult3215);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3216 = callmethod(opresult3215, "++(1)", 1, partcv, params);
// compiled op node returning opresult3216 (depth = 7)
  int op_slot_left_3203 = gc_frame_newslot(opresult3216);
  params[0] = strlit3204;
  partcv[0] = 1;
  Object opresult3217 = callmethod(opresult3216, "++(1)", 1, partcv, params);
// compiled op node returning opresult3217 (depth = 6)
  int op_slot_left_3199 = gc_frame_newslot(opresult3217);
  params[0] = call3201;
  partcv[0] = 1;
  Object opresult3218 = callmethod(opresult3217, "++(1)", 1, partcv, params);
// compiled op node returning opresult3218 (depth = 5)
  int op_slot_left_3196 = gc_frame_newslot(opresult3218);
  params[0] = strlit3197;
  partcv[0] = 1;
  Object opresult3219 = callmethod(opresult3218, "++(1)", 1, partcv, params);
// compiled op node returning opresult3219 (depth = 4)
  *var_s = opresult3219;
  if (opresult3219 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 758
  setline(758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3223 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3224 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3223);
// compiled member node returning call3224 (depth = 5)
  int op_slot_right_3222 = gc_frame_newslot(call3224);
// starting to compile identifier node (depth = 5)
  Object bool3226 = alloc_Boolean(0);
// compiled identifier node returning bool3226 (depth = 5)
  int op_slot_left_3222 = gc_frame_newslot(bool3226);
  params[0] = call3224;
  partcv[0] = 1;
  Object opresult3227 = callmethod(bool3226, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3227 (depth = 4)
  Object if3221 = done;
  if (istrue(opresult3227)) {
// Begin line 759
  setline(759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3229 == NULL) {
    strlit3229 = alloc_String("");
    gc_root(strlit3229);
  }
// compiled string node returning strlit3229 (depth = 6)
  int op_slot_right_3228 = gc_frame_newslot(strlit3229);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3232 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3234 = alloc_Float64(2);
// compiled num node returning num3234 (depth = 9)
  int op_slot_right_3233 = gc_frame_newslot(num3234);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3233 = gc_frame_newslot(*var_depth);
  params[0] = num3234;
  partcv[0] = 1;
  Object sum3236 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3236 (depth = 8)
  gc_frame_newslot(sum3236);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3237 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3238 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3237);
// compiled member node returning call3238 (depth = 8)
  params[0] = sum3236;
  partcv[0] = 1;
  Object call3239 = callmethodflags(call3238, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3232);
// compiled call node returning call3239 (depth = 7)
  int op_slot_right_3231 = gc_frame_newslot(call3239);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3242 == NULL) {
    strlit3242 = alloc_String("");
    gc_root(strlit3242);
  }
// compiled string node returning strlit3242 (depth = 8)
  int op_slot_right_3241 = gc_frame_newslot(strlit3242);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_3244 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3247 == NULL) {
    strlit3247 = alloc_String("Returns:""\x0a""  ");
    gc_root(strlit3247);
  }
// compiled string node returning strlit3247 (depth = 10)
  int op_slot_right_3246 = gc_frame_newslot(strlit3247);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_3249 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit3252 == NULL) {
    strlit3252 = alloc_String("");
    gc_root(strlit3252);
  }
// compiled string node returning strlit3252 (depth = 12)
  int op_slot_right_3251 = gc_frame_newslot(strlit3252);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_3254 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit3256 == NULL) {
    strlit3256 = alloc_String("");
    gc_root(strlit3256);
  }
// compiled string node returning strlit3256 (depth = 13)
  int op_slot_left_3254 = gc_frame_newslot(strlit3256);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3257 = callmethod(strlit3256, "++(1)", 1, partcv, params);
// compiled op node returning opresult3257 (depth = 12)
  int op_slot_left_3251 = gc_frame_newslot(opresult3257);
  params[0] = strlit3252;
  partcv[0] = 1;
  Object opresult3258 = callmethod(opresult3257, "++(1)", 1, partcv, params);
// compiled op node returning opresult3258 (depth = 11)
  int op_slot_left_3249 = gc_frame_newslot(opresult3258);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3259 = callmethod(opresult3258, "++(1)", 1, partcv, params);
// compiled op node returning opresult3259 (depth = 10)
  int op_slot_left_3246 = gc_frame_newslot(opresult3259);
  params[0] = strlit3247;
  partcv[0] = 1;
  Object opresult3260 = callmethod(opresult3259, "++(1)", 1, partcv, params);
// compiled op node returning opresult3260 (depth = 9)
  int op_slot_left_3244 = gc_frame_newslot(opresult3260);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3261 = callmethod(opresult3260, "++(1)", 1, partcv, params);
// compiled op node returning opresult3261 (depth = 8)
  int op_slot_left_3241 = gc_frame_newslot(opresult3261);
  params[0] = strlit3242;
  partcv[0] = 1;
  Object opresult3262 = callmethod(opresult3261, "++(1)", 1, partcv, params);
// compiled op node returning opresult3262 (depth = 7)
  int op_slot_left_3231 = gc_frame_newslot(opresult3262);
  params[0] = call3239;
  partcv[0] = 1;
  Object opresult3263 = callmethod(opresult3262, "++(1)", 1, partcv, params);
// compiled op node returning opresult3263 (depth = 6)
  int op_slot_left_3228 = gc_frame_newslot(opresult3263);
  params[0] = strlit3229;
  partcv[0] = 1;
  Object opresult3264 = callmethod(opresult3263, "++(1)", 1, partcv, params);
// compiled op node returning opresult3264 (depth = 5)
  *var_s = opresult3264;
  if (opresult3264 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if3221 = done;
  } else {
  }
// compiled if node returning if3221 (depth = 3)
// Begin line 761
  setline(761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3268 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3269 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3268);
// compiled member node returning call3269 (depth = 5)
  int op_slot_right_3267 = gc_frame_newslot(call3269);
// starting to compile identifier node (depth = 5)
  Object bool3271 = alloc_Boolean(0);
// compiled identifier node returning bool3271 (depth = 5)
  int op_slot_left_3267 = gc_frame_newslot(bool3271);
  params[0] = call3269;
  partcv[0] = 1;
  Object opresult3272 = callmethod(bool3271, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3272 (depth = 4)
  Object if3266 = done;
  if (istrue(opresult3272)) {
// Begin line 762
  setline(762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3274 == NULL) {
    strlit3274 = alloc_String("TypeParams:""\x0a""");
    gc_root(strlit3274);
  }
// compiled string node returning strlit3274 (depth = 6)
  int op_slot_right_3273 = gc_frame_newslot(strlit3274);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_3276 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3279 == NULL) {
    strlit3279 = alloc_String("""\x0a""");
    gc_root(strlit3279);
  }
// compiled string node returning strlit3279 (depth = 8)
  int op_slot_right_3278 = gc_frame_newslot(strlit3279);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_3281 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit3283 == NULL) {
    strlit3283 = alloc_String("");
    gc_root(strlit3283);
  }
// compiled string node returning strlit3283 (depth = 9)
  int op_slot_left_3281 = gc_frame_newslot(strlit3283);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3284 = callmethod(strlit3283, "++(1)", 1, partcv, params);
// compiled op node returning opresult3284 (depth = 8)
  int op_slot_left_3278 = gc_frame_newslot(opresult3284);
  params[0] = strlit3279;
  partcv[0] = 1;
  Object opresult3285 = callmethod(opresult3284, "++(1)", 1, partcv, params);
// compiled op node returning opresult3285 (depth = 7)
  int op_slot_left_3276 = gc_frame_newslot(opresult3285);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3286 = callmethod(opresult3285, "++(1)", 1, partcv, params);
// compiled op node returning opresult3286 (depth = 6)
  int op_slot_left_3273 = gc_frame_newslot(opresult3286);
  params[0] = strlit3274;
  partcv[0] = 1;
  Object opresult3287 = callmethod(opresult3286, "++(1)", 1, partcv, params);
// compiled op node returning opresult3287 (depth = 5)
  *var_s = opresult3287;
  if (opresult3287 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 763
  setline(763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3290 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3292 = alloc_Float64(2);
// compiled num node returning num3292 (depth = 8)
  int op_slot_right_3291 = gc_frame_newslot(num3292);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_3291 = gc_frame_newslot(*var_depth);
  params[0] = num3292;
  partcv[0] = 1;
  Object sum3294 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3294 (depth = 7)
  gc_frame_newslot(sum3294);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3295 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3296 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3295);
// compiled member node returning call3296 (depth = 7)
  params[0] = sum3294;
  partcv[0] = 1;
  Object call3297 = callmethodflags(call3296, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3290);
// compiled call node returning call3297 (depth = 6)
  int op_slot_right_3289 = gc_frame_newslot(call3297);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_3289 = gc_frame_newslot(*var_s);
  params[0] = call3297;
  partcv[0] = 1;
  Object opresult3299 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3299 (depth = 5)
  *var_s = opresult3299;
  if (opresult3299 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if3266 = done;
  } else {
  }
// compiled if node returning if3266 (depth = 3)
// Begin line 765
  setline(765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3302 == NULL) {
    strlit3302 = alloc_String("Signature:");
    gc_root(strlit3302);
  }
// compiled string node returning strlit3302 (depth = 5)
  int op_slot_right_3301 = gc_frame_newslot(strlit3302);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_3304 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3307 == NULL) {
    strlit3307 = alloc_String("""\x0a""");
    gc_root(strlit3307);
  }
// compiled string node returning strlit3307 (depth = 7)
  int op_slot_right_3306 = gc_frame_newslot(strlit3307);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_right_3309 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 8)
  if (strlit3311 == NULL) {
    strlit3311 = alloc_String("");
    gc_root(strlit3311);
  }
// compiled string node returning strlit3311 (depth = 8)
  int op_slot_left_3309 = gc_frame_newslot(strlit3311);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3312 = callmethod(strlit3311, "++(1)", 1, partcv, params);
// compiled op node returning opresult3312 (depth = 7)
  int op_slot_left_3306 = gc_frame_newslot(opresult3312);
  params[0] = strlit3307;
  partcv[0] = 1;
  Object opresult3313 = callmethod(opresult3312, "++(1)", 1, partcv, params);
// compiled op node returning opresult3313 (depth = 6)
  int op_slot_left_3304 = gc_frame_newslot(opresult3313);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3314 = callmethod(opresult3313, "++(1)", 1, partcv, params);
// compiled op node returning opresult3314 (depth = 5)
  int op_slot_left_3301 = gc_frame_newslot(opresult3314);
  params[0] = strlit3302;
  partcv[0] = 1;
  Object opresult3315 = callmethod(opresult3314, "++(1)", 1, partcv, params);
// compiled op node returning opresult3315 (depth = 4)
  *var_s = opresult3315;
  if (opresult3315 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 766
  setline(766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3317 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3318 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3319 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3318);
// compiled member node returning call3319 (depth = 4)
  gc_frame_newslot(call3319);
// starting to compile block node (depth = 4)
  Object block3320 = alloc_Block(NULL, NULL, "ast", 766);
  gc_frame_newslot(block3320);
// method "_apply(_)"
  block_savedest(block3320);
  Object closure3321 = createclosure(4, "_apply(1)");
  setclosureframe(closure3321, stackframe);
  addtoclosure(closure3321, var_depth);
  addtoclosure(closure3321, var_spc);
  addtoclosure(closure3321, var_s);
  addtoclosure(closure3321, selfslot);
  struct UserObject *uo3321 = (struct UserObject*)block3320;
  uo3321->data[0] = (Object)closure3321;
  Method *meth_meth_ast_3321__apply_40_1_41_ = addmethod2pos(block3320, "_apply(1)", &meth_ast_3321__apply_40_1_41_, 0);
  int argcv_meth_ast_3321__apply_40_1_41_[] = {1};
  meth_meth_ast_3321__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3321__apply_40_1_41_);
  meth_meth_ast_3321__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3321__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block3320 (depth = 4)
  gc_frame_newslot(block3320);
// call case 5: prelude request
  params[0] = call3319;
  params[1] = block3320;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3352 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3317);
// compiled call node returning call3352 (depth = 3)
// Begin line 769
  setline(769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_3357__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3359 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3361 = alloc_Float64(1);
// compiled num node returning num3361 (depth = 9)
  int op_slot_right_3360 = gc_frame_newslot(num3361);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3360 = gc_frame_newslot(*var_depth);
  params[0] = num3361;
  partcv[0] = 1;
  Object sum3363 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3363 (depth = 8)
  gc_frame_newslot(sum3363);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  params[0] = sum3363;
  partcv[0] = 1;
  Object call3364 = callmethodflags(*var_part, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3359);
// compiled call node returning call3364 (depth = 7)
  int op_slot_right_3358 = gc_frame_newslot(call3364);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3358 = gc_frame_newslot(*var_s);
  params[0] = call3364;
  partcv[0] = 1;
  Object opresult3366 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3366 (depth = 6)
  *var_s = opresult3366;
  if (opresult3366 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_3353_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 772
  setline(772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3354 == NULL) {
    strlit3354 = alloc_String("");
    gc_root(strlit3354);
  }
// compiled string node returning strlit3354 (depth = 4)
  *var_s = strlit3354;
  if (strlit3354 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 773
  setline(773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3355 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3356 = alloc_Block(NULL, NULL, "ast", 773);
  gc_frame_newslot(block3356);
// method "_apply(_)"
  block_savedest(block3356);
  Object closure3357 = createclosure(3, "_apply(1)");
  setclosureframe(closure3357, stackframe);
  addtoclosure(closure3357, var_depth);
  addtoclosure(closure3357, var_s);
  addtoclosure(closure3357, selfslot);
  struct UserObject *uo3357 = (struct UserObject*)block3356;
  uo3357->data[0] = (Object)closure3357;
  Method *meth_meth_ast_3357__apply_40_1_41_ = addmethod2pos(block3356, "_apply(1)", &meth_ast_3357__apply_40_1_41_, 0);
  int argcv_meth_ast_3357__apply_40_1_41_[] = {1};
  meth_meth_ast_3357__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3357__apply_40_1_41_);
  meth_meth_ast_3357__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3357__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block3356 (depth = 4)
  gc_frame_newslot(block3356);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3369 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3370 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3369);
// compiled member node returning call3370 (depth = 4)
  params[0] = block3356;
  partcv[0] = 1;
  Object call3371 = callmethodflags(call3370, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3355);
// compiled call node returning call3371 (depth = 3)
// Begin line 774
  setline(774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_3372_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_methodTypeNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 777
  setline(777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3373 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe3374 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3375 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3376 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3375);
// compiled member node returning call3376 (depth = 5)
  gc_frame_newslot(call3376);
// starting to compile member node (depth = 5)
  int callframe3377 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3378 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3377);
// compiled member node returning call3378 (depth = 5)
  gc_frame_newslot(call3378);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methodTypeNode (depth = 5)
  params[0] = call3376;
  params[1] = call3378;
  partcv[0] = 2;
  Object call3379 = callmethodflags(*var_methodTypeNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3374);
// compiled call node returning call3379 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call3380 = callmethodflags(call3379, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3373);
// compiled call node returning call3380 (depth = 3)
  gc_frame_end(frame);
  return call3380;
}
Object meth_ast_2987_new_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_uninitialized = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_k = getfromclosure(closure, 2);
  Object *var_methodTypeNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_signature_39_ = &(stackframe->slots[0]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_rtype_39_ = &(stackframe->slots[1]);
  *var_rtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2988 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2988 = alloc_userobj2(22,19, objclass2988);
  gc_frame_newslot(obj2988);
  if (objclass2988 == NULL) {
    glfree(obj2988->class->name);
    obj2988->class->name = "methodTypeNode.new(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2988, self, 0);
  addmethodreal(obj2988,"outer", &reader_ast_outer_2989);
  Object oldself2988 = self;
  struct StackFrameObject *oldstackframe2988 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2988);
  gc_frame_newslot((Object)stackframe);
  self = obj2988;
  Object *oldselfslot2988 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2988 = (*(struct UserObject *)self).data[0], lowerouter2988 = thisouter2988;
  if (inheritingObject2988) {
    struct UserObject *inho2988 = (struct UserObject *)inheritingObject2988;
    while (inho2988->super != GraceDefaultObject) inho2988 = (struct UserObject *)inho2988->super;
    inho2988->super = obj2988;
    self = inheritingObject2988;
    *selfslot = self;
    lowerouter2988 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2988;
  }
  if (objclass2988 == NULL) {
  Method *reader2990 = addmethodrealflags(obj2988, "kind",&reader_ast_kind_2990, MFLAG_DEF);
  reader2990->definitionModule = modulename;
  reader2990->definitionLine = 686;
  }
  adddatum2(obj2988, alloc_Undefined(), 1);
  if (objclass2988 == NULL) {
    Method *reader2991 = addmethodrealflags(obj2988, "signature", &reader_ast_signature_2991, 0);
    Method *writer2991 = addmethodrealflags(obj2988, "signature:=(1)", &writer_ast_signature_2991, 0);
    reader2991->definitionModule = modulename;
    writer2991->definitionModule = modulename;
    reader2991->definitionLine = 687;
    writer2991->definitionLine = 687;
  }
  obj2988->flags |= OFLAG_MUTABLE;
  adddatum2(obj2988, alloc_Undefined(), 2);
  if (objclass2988 == NULL) {
    Method *reader2992 = addmethodrealflags(obj2988, "rtype", &reader_ast_rtype_2992, 0);
    Method *writer2992 = addmethodrealflags(obj2988, "rtype:=(1)", &writer_ast_rtype_2992, 0);
    reader2992->definitionModule = modulename;
    writer2992->definitionModule = modulename;
    reader2992->definitionLine = 688;
    writer2992->definitionLine = 688;
  }
  obj2988->flags |= OFLAG_MUTABLE;
  adddatum2(obj2988, alloc_Undefined(), 3);
  if (objclass2988 == NULL) {
    Method *reader2993 = addmethodrealflags(obj2988, "typeParams", &reader_ast_typeParams_2993, 0);
    Method *writer2993 = addmethodrealflags(obj2988, "typeParams:=(1)", &writer_ast_typeParams_2993, 0);
    reader2993->definitionModule = modulename;
    writer2993->definitionModule = modulename;
    reader2993->definitionLine = 689;
    writer2993->definitionLine = 689;
  }
  obj2988->flags |= OFLAG_MUTABLE;
  adddatum2(obj2988, alloc_Undefined(), 4);
  if (objclass2988 == NULL) {
    Method *reader2994 = addmethodrealflags(obj2988, "cachedIdentifier", &reader_ast_cachedIdentifier_2994, MFLAG_CONFIDENTIAL);
    Method *writer2994 = addmethodrealflags(obj2988, "cachedIdentifier:=(1)", &writer_ast_cachedIdentifier_2994, MFLAG_CONFIDENTIAL);
    reader2994->definitionModule = modulename;
    writer2994->definitionModule = modulename;
    reader2994->definitionLine = 690;
    writer2994->definitionLine = 690;
  }
  obj2988->flags |= OFLAG_MUTABLE;
  adddatum2(obj2988, alloc_Undefined(), 5);
// method "end"
  struct UserObject *uo2995 = (struct UserObject*)obj2988;
  uo2995->data[6] = emptyclosure;
  Method *meth_meth_ast_2995_end = addmethod2pos(obj2988, "end", &meth_ast_2995_end, 6);
  int argcv_meth_ast_2995_end[] = {0};
  meth_meth_ast_2995_end->type = alloc_MethodType(1, argcv_meth_ast_2995_end);
  meth_meth_ast_2995_end->definitionModule = modulename;
  meth_meth_ast_2995_end->definitionLine = 692;
// method "nameString"
  struct UserObject *uo3013 = (struct UserObject*)obj2988;
  uo3013->data[7] = emptyclosure;
  Method *meth_meth_ast_3013_nameString = addmethod2pos(obj2988, "nameString", &meth_ast_3013_nameString, 7);
  int argcv_meth_ast_3013_nameString[] = {0};
  meth_meth_ast_3013_nameString->type = alloc_MethodType(1, argcv_meth_ast_3013_nameString);
  meth_meth_ast_3013_nameString->definitionModule = modulename;
  meth_meth_ast_3013_nameString->definitionLine = 697;
// method "canonicalName"
  struct UserObject *uo3027 = (struct UserObject*)obj2988;
  uo3027->data[8] = emptyclosure;
  Method *meth_meth_ast_3027_canonicalName = addmethod2pos(obj2988, "canonicalName", &meth_ast_3027_canonicalName, 8);
  int argcv_meth_ast_3027_canonicalName[] = {0};
  meth_meth_ast_3027_canonicalName->type = alloc_MethodType(1, argcv_meth_ast_3027_canonicalName);
  meth_meth_ast_3027_canonicalName->definitionModule = modulename;
  meth_meth_ast_3027_canonicalName->definitionLine = 703;
// method "value"
  block_savedest(obj2988);
  Object closure3041 = createclosure(2, "value");
  setclosureframe(closure3041, stackframe);
  addtoclosure(closure3041, var_uninitialized);
  addtoclosure(closure3041, var_identifierNode);
  struct UserObject *uo3041 = (struct UserObject*)obj2988;
  uo3041->data[9] = (Object)closure3041;
  Method *meth_meth_ast_3041_value = addmethod2pos(obj2988, "value", &meth_ast_3041_value, 9);
  int argcv_meth_ast_3041_value[] = {0};
  meth_meth_ast_3041_value->type = alloc_MethodType(1, argcv_meth_ast_3041_value);
  meth_meth_ast_3041_value->definitionModule = modulename;
  meth_meth_ast_3041_value->definitionLine = 709;
// method "isExecutable"
  struct UserObject *uo3092 = (struct UserObject*)obj2988;
  uo3092->data[10] = emptyclosure;
  Method *meth_meth_ast_3092_isExecutable = addmethod2pos(obj2988, "isExecutable", &meth_ast_3092_isExecutable, 10);
  int argcv_meth_ast_3092_isExecutable[] = {0};
  meth_meth_ast_3092_isExecutable->type = alloc_MethodType(1, argcv_meth_ast_3092_isExecutable);
  meth_meth_ast_3092_isExecutable->definitionModule = modulename;
  meth_meth_ast_3092_isExecutable->definitionLine = 719;
// method "parametersDo(_)"
  struct UserObject *uo3094 = (struct UserObject*)obj2988;
  uo3094->data[11] = emptyclosure;
  Method *meth_meth_ast_3094_parametersDo_40_1_41_ = addmethod2pos(obj2988, "parametersDo(1)", &meth_ast_3094_parametersDo_40_1_41_, 11);
  int argcv_meth_ast_3094_parametersDo_40_1_41_[] = {1};
  meth_meth_ast_3094_parametersDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3094_parametersDo_40_1_41_);
  meth_meth_ast_3094_parametersDo_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3094_parametersDo_40_1_41_->definitionLine = 720;
// method "scope:=(_)"
  struct UserObject *uo3111 = (struct UserObject*)obj2988;
  uo3111->data[12] = emptyclosure;
  Method *meth_meth_ast_3111_scope_58__61__40_1_41_ = addmethod2pos(obj2988, "scope:=(1)", &meth_ast_3111_scope_58__61__40_1_41_, 12);
  int argcv_meth_ast_3111_scope_58__61__40_1_41_[] = {1};
  meth_meth_ast_3111_scope_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3111_scope_58__61__40_1_41_);
  meth_meth_ast_3111_scope_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_3111_scope_58__61__40_1_41_->definitionLine = 725;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj2988);
  Object closure3116 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure3116, stackframe);
  addtoclosure(closure3116, var_k);
  struct UserObject *uo3116 = (struct UserObject*)obj2988;
  uo3116->data[13] = (Object)closure3116;
  Method *meth_meth_ast_3116_declarationKindWithAncestors_40_1_41_ = addmethod2pos(obj2988, "declarationKindWithAncestors(1)", &meth_ast_3116_declarationKindWithAncestors_40_1_41_, 13);
  int argcv_meth_ast_3116_declarationKindWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_3116_declarationKindWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3116_declarationKindWithAncestors_40_1_41_);
  meth_meth_ast_3116_declarationKindWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3116_declarationKindWithAncestors_40_1_41_->definitionLine = 731;
// method "accept(_)from(_)"
  struct UserObject *uo3119 = (struct UserObject*)obj2988;
  uo3119->data[14] = emptyclosure;
  Method *meth_meth_ast_3119_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj2988, "accept(1)from(1)", &meth_ast_3119_accept_40_1_41_from_40_1_41_, 14);
  int argcv_meth_ast_3119_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_3119_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_3119_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_3119_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3119_accept_40_1_41_from_40_1_41_->definitionLine = 732;
// method "map(_)ancestors(_)"
  struct UserObject *uo3156 = (struct UserObject*)obj2988;
  uo3156->data[15] = emptyclosure;
  Method *meth_meth_ast_3156_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj2988, "map(1)ancestors(1)", &meth_ast_3156_map_40_1_41_ancestors_40_1_41_, 15);
  int argcv_meth_ast_3156_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_3156_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_3156_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_3156_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3156_map_40_1_41_ancestors_40_1_41_->definitionLine = 746;
// method "pretty(_)"
  struct UserObject *uo3181 = (struct UserObject*)obj2988;
  uo3181->data[16] = emptyclosure;
  Method *meth_meth_ast_3181_pretty_40_1_41_ = addmethod2pos(obj2988, "pretty(1)", &meth_ast_3181_pretty_40_1_41_, 16);
  int argcv_meth_ast_3181_pretty_40_1_41_[] = {1};
  meth_meth_ast_3181_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3181_pretty_40_1_41_);
  meth_meth_ast_3181_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3181_pretty_40_1_41_->definitionLine = 754;
// method "toGrace(_)"
  struct UserObject *uo3353 = (struct UserObject*)obj2988;
  uo3353->data[17] = emptyclosure;
  Method *meth_meth_ast_3353_toGrace_40_1_41_ = addmethod2pos(obj2988, "toGrace(1)", &meth_ast_3353_toGrace_40_1_41_, 17);
  int argcv_meth_ast_3353_toGrace_40_1_41_[] = {1};
  meth_meth_ast_3353_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3353_toGrace_40_1_41_);
meth_meth_ast_3353_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_3353_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_3353_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3353_toGrace_40_1_41_->definitionLine = 771;
// method "shallowCopy"
  block_savedest(obj2988);
  Object closure3372 = createclosure(1, "shallowCopy");
  setclosureframe(closure3372, stackframe);
  addtoclosure(closure3372, var_methodTypeNode);
  struct UserObject *uo3372 = (struct UserObject*)obj2988;
  uo3372->data[18] = (Object)closure3372;
  Method *meth_meth_ast_3372_shallowCopy = addmethod2pos(obj2988, "shallowCopy", &meth_ast_3372_shallowCopy, 18);
  int argcv_meth_ast_3372_shallowCopy[] = {0};
  meth_meth_ast_3372_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_3372_shallowCopy);
  meth_meth_ast_3372_shallowCopy->definitionModule = modulename;
  meth_meth_ast_3372_shallowCopy->definitionLine = 776;
  sourceObject = obj2988;
// Begin line 685
  setline(685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3381 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3382 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3381);
// compiled call node returning call3382 (depth = 3)
  struct UserObject *obj2988_uo = (struct UserObject *)obj2988;
  obj2988_uo->super = call3382;
  sourceObject = obj2988;
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3383 == NULL) {
    strlit3383 = alloc_String("methodtype");
    gc_root(strlit3383);
  }
// compiled string node returning strlit3383 (depth = 3)
  adddatum2(obj2988, strlit3383, 1);
  sourceObject = obj2988;
// Begin line 687
  setline(687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature_39_ (depth = 3)
  adddatum2(obj2988, *var_signature_39_, 2);
  sourceObject = obj2988;
// Begin line 688
  setline(688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_rtype_39_ (depth = 3)
  adddatum2(obj2988, *var_rtype_39_, 3);
  sourceObject = obj2988;
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3384 = alloc_Boolean(0);
// compiled identifier node returning bool3384 (depth = 3)
  adddatum2(obj2988, bool3384, 4);
  sourceObject = obj2988;
// Begin line 690
  setline(690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_uninitialized (depth = 3)
  adddatum2(obj2988, *var_uninitialized, 5);
  sourceObject = obj2988;
  sourceObject = obj2988;
  sourceObject = obj2988;
  sourceObject = obj2988;
  sourceObject = obj2988;
  sourceObject = obj2988;
  sourceObject = obj2988;
  sourceObject = obj2988;
  sourceObject = obj2988;
  sourceObject = obj2988;
  sourceObject = obj2988;
  sourceObject = obj2988;
  sourceObject = obj2988;
  objclass2988 = obj2988->class;
  objclass2988->definitionModule = modulename;
  objclass2988->definitionLine = 679;
  (*(struct UserObject *)self).data[0] = lowerouter2988;
  self = oldself2988;
  selfslot = oldselfslot2988;
  stackframe = oldstackframe2988;
  gc_frame_end(frame);
  return obj2988;
}
Object meth_ast_2987_new_40_2_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_uninitialized = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_k = getfromclosure(closure, 2);
  Object *var_methodTypeNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_signature_39_ = &(stackframe->slots[0]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_rtype_39_ = &(stackframe->slots[1]);
  *var_rtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2988 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2988 = alloc_userobj2(22,19, objclass2988);
  gc_frame_newslot(obj2988);
  if (objclass2988 == NULL) {
    glfree(obj2988->class->name);
    obj2988->class->name = "methodTypeNode.new(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2988, self, 0);
  addmethodreal(obj2988,"outer", &reader_ast_outer_2989);
  Object oldself2988 = self;
  struct StackFrameObject *oldstackframe2988 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2988);
  gc_frame_newslot((Object)stackframe);
  self = obj2988;
  Object *oldselfslot2988 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2988 = (*(struct UserObject *)self).data[0], lowerouter2988 = thisouter2988;
  if (inheritingObject2988) {
    struct UserObject *inho2988 = (struct UserObject *)inheritingObject2988;
    while (inho2988->super != GraceDefaultObject) inho2988 = (struct UserObject *)inho2988->super;
    inho2988->super = obj2988;
    self = inheritingObject2988;
    *selfslot = self;
    lowerouter2988 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2988;
  }
  if (objclass2988 == NULL) {
  Method *reader2990 = addmethodrealflags(obj2988, "kind",&reader_ast_kind_2990, MFLAG_DEF);
  reader2990->definitionModule = modulename;
  reader2990->definitionLine = 686;
  }
  adddatum2(obj2988, alloc_Undefined(), 1);
  if (objclass2988 == NULL) {
    Method *reader2991 = addmethodrealflags(obj2988, "signature", &reader_ast_signature_2991, 0);
    Method *writer2991 = addmethodrealflags(obj2988, "signature:=(1)", &writer_ast_signature_2991, 0);
    reader2991->definitionModule = modulename;
    writer2991->definitionModule = modulename;
    reader2991->definitionLine = 687;
    writer2991->definitionLine = 687;
  }
  obj2988->flags |= OFLAG_MUTABLE;
  adddatum2(obj2988, alloc_Undefined(), 2);
  if (objclass2988 == NULL) {
    Method *reader2992 = addmethodrealflags(obj2988, "rtype", &reader_ast_rtype_2992, 0);
    Method *writer2992 = addmethodrealflags(obj2988, "rtype:=(1)", &writer_ast_rtype_2992, 0);
    reader2992->definitionModule = modulename;
    writer2992->definitionModule = modulename;
    reader2992->definitionLine = 688;
    writer2992->definitionLine = 688;
  }
  obj2988->flags |= OFLAG_MUTABLE;
  adddatum2(obj2988, alloc_Undefined(), 3);
  if (objclass2988 == NULL) {
    Method *reader2993 = addmethodrealflags(obj2988, "typeParams", &reader_ast_typeParams_2993, 0);
    Method *writer2993 = addmethodrealflags(obj2988, "typeParams:=(1)", &writer_ast_typeParams_2993, 0);
    reader2993->definitionModule = modulename;
    writer2993->definitionModule = modulename;
    reader2993->definitionLine = 689;
    writer2993->definitionLine = 689;
  }
  obj2988->flags |= OFLAG_MUTABLE;
  adddatum2(obj2988, alloc_Undefined(), 4);
  if (objclass2988 == NULL) {
    Method *reader2994 = addmethodrealflags(obj2988, "cachedIdentifier", &reader_ast_cachedIdentifier_2994, MFLAG_CONFIDENTIAL);
    Method *writer2994 = addmethodrealflags(obj2988, "cachedIdentifier:=(1)", &writer_ast_cachedIdentifier_2994, MFLAG_CONFIDENTIAL);
    reader2994->definitionModule = modulename;
    writer2994->definitionModule = modulename;
    reader2994->definitionLine = 690;
    writer2994->definitionLine = 690;
  }
  obj2988->flags |= OFLAG_MUTABLE;
  adddatum2(obj2988, alloc_Undefined(), 5);
// method "end"
  struct UserObject *uo2995 = (struct UserObject*)obj2988;
  uo2995->data[6] = emptyclosure;
  Method *meth_meth_ast_2995_end = addmethod2pos(obj2988, "end", &meth_ast_2995_end, 6);
  int argcv_meth_ast_2995_end[] = {0};
  meth_meth_ast_2995_end->type = alloc_MethodType(1, argcv_meth_ast_2995_end);
  meth_meth_ast_2995_end->definitionModule = modulename;
  meth_meth_ast_2995_end->definitionLine = 692;
// method "nameString"
  struct UserObject *uo3013 = (struct UserObject*)obj2988;
  uo3013->data[7] = emptyclosure;
  Method *meth_meth_ast_3013_nameString = addmethod2pos(obj2988, "nameString", &meth_ast_3013_nameString, 7);
  int argcv_meth_ast_3013_nameString[] = {0};
  meth_meth_ast_3013_nameString->type = alloc_MethodType(1, argcv_meth_ast_3013_nameString);
  meth_meth_ast_3013_nameString->definitionModule = modulename;
  meth_meth_ast_3013_nameString->definitionLine = 697;
// method "canonicalName"
  struct UserObject *uo3027 = (struct UserObject*)obj2988;
  uo3027->data[8] = emptyclosure;
  Method *meth_meth_ast_3027_canonicalName = addmethod2pos(obj2988, "canonicalName", &meth_ast_3027_canonicalName, 8);
  int argcv_meth_ast_3027_canonicalName[] = {0};
  meth_meth_ast_3027_canonicalName->type = alloc_MethodType(1, argcv_meth_ast_3027_canonicalName);
  meth_meth_ast_3027_canonicalName->definitionModule = modulename;
  meth_meth_ast_3027_canonicalName->definitionLine = 703;
// method "value"
  block_savedest(obj2988);
  Object closure3041 = createclosure(2, "value");
  setclosureframe(closure3041, stackframe);
  addtoclosure(closure3041, var_uninitialized);
  addtoclosure(closure3041, var_identifierNode);
  struct UserObject *uo3041 = (struct UserObject*)obj2988;
  uo3041->data[9] = (Object)closure3041;
  Method *meth_meth_ast_3041_value = addmethod2pos(obj2988, "value", &meth_ast_3041_value, 9);
  int argcv_meth_ast_3041_value[] = {0};
  meth_meth_ast_3041_value->type = alloc_MethodType(1, argcv_meth_ast_3041_value);
  meth_meth_ast_3041_value->definitionModule = modulename;
  meth_meth_ast_3041_value->definitionLine = 709;
// method "isExecutable"
  struct UserObject *uo3092 = (struct UserObject*)obj2988;
  uo3092->data[10] = emptyclosure;
  Method *meth_meth_ast_3092_isExecutable = addmethod2pos(obj2988, "isExecutable", &meth_ast_3092_isExecutable, 10);
  int argcv_meth_ast_3092_isExecutable[] = {0};
  meth_meth_ast_3092_isExecutable->type = alloc_MethodType(1, argcv_meth_ast_3092_isExecutable);
  meth_meth_ast_3092_isExecutable->definitionModule = modulename;
  meth_meth_ast_3092_isExecutable->definitionLine = 719;
// method "parametersDo(_)"
  struct UserObject *uo3094 = (struct UserObject*)obj2988;
  uo3094->data[11] = emptyclosure;
  Method *meth_meth_ast_3094_parametersDo_40_1_41_ = addmethod2pos(obj2988, "parametersDo(1)", &meth_ast_3094_parametersDo_40_1_41_, 11);
  int argcv_meth_ast_3094_parametersDo_40_1_41_[] = {1};
  meth_meth_ast_3094_parametersDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3094_parametersDo_40_1_41_);
  meth_meth_ast_3094_parametersDo_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3094_parametersDo_40_1_41_->definitionLine = 720;
// method "scope:=(_)"
  struct UserObject *uo3111 = (struct UserObject*)obj2988;
  uo3111->data[12] = emptyclosure;
  Method *meth_meth_ast_3111_scope_58__61__40_1_41_ = addmethod2pos(obj2988, "scope:=(1)", &meth_ast_3111_scope_58__61__40_1_41_, 12);
  int argcv_meth_ast_3111_scope_58__61__40_1_41_[] = {1};
  meth_meth_ast_3111_scope_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3111_scope_58__61__40_1_41_);
  meth_meth_ast_3111_scope_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_3111_scope_58__61__40_1_41_->definitionLine = 725;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj2988);
  Object closure3116 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure3116, stackframe);
  addtoclosure(closure3116, var_k);
  struct UserObject *uo3116 = (struct UserObject*)obj2988;
  uo3116->data[13] = (Object)closure3116;
  Method *meth_meth_ast_3116_declarationKindWithAncestors_40_1_41_ = addmethod2pos(obj2988, "declarationKindWithAncestors(1)", &meth_ast_3116_declarationKindWithAncestors_40_1_41_, 13);
  int argcv_meth_ast_3116_declarationKindWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_3116_declarationKindWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3116_declarationKindWithAncestors_40_1_41_);
  meth_meth_ast_3116_declarationKindWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3116_declarationKindWithAncestors_40_1_41_->definitionLine = 731;
// method "accept(_)from(_)"
  struct UserObject *uo3119 = (struct UserObject*)obj2988;
  uo3119->data[14] = emptyclosure;
  Method *meth_meth_ast_3119_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj2988, "accept(1)from(1)", &meth_ast_3119_accept_40_1_41_from_40_1_41_, 14);
  int argcv_meth_ast_3119_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_3119_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_3119_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_3119_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3119_accept_40_1_41_from_40_1_41_->definitionLine = 732;
// method "map(_)ancestors(_)"
  struct UserObject *uo3156 = (struct UserObject*)obj2988;
  uo3156->data[15] = emptyclosure;
  Method *meth_meth_ast_3156_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj2988, "map(1)ancestors(1)", &meth_ast_3156_map_40_1_41_ancestors_40_1_41_, 15);
  int argcv_meth_ast_3156_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_3156_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_3156_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_3156_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3156_map_40_1_41_ancestors_40_1_41_->definitionLine = 746;
// method "pretty(_)"
  struct UserObject *uo3181 = (struct UserObject*)obj2988;
  uo3181->data[16] = emptyclosure;
  Method *meth_meth_ast_3181_pretty_40_1_41_ = addmethod2pos(obj2988, "pretty(1)", &meth_ast_3181_pretty_40_1_41_, 16);
  int argcv_meth_ast_3181_pretty_40_1_41_[] = {1};
  meth_meth_ast_3181_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3181_pretty_40_1_41_);
  meth_meth_ast_3181_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3181_pretty_40_1_41_->definitionLine = 754;
// method "toGrace(_)"
  struct UserObject *uo3353 = (struct UserObject*)obj2988;
  uo3353->data[17] = emptyclosure;
  Method *meth_meth_ast_3353_toGrace_40_1_41_ = addmethod2pos(obj2988, "toGrace(1)", &meth_ast_3353_toGrace_40_1_41_, 17);
  int argcv_meth_ast_3353_toGrace_40_1_41_[] = {1};
  meth_meth_ast_3353_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3353_toGrace_40_1_41_);
meth_meth_ast_3353_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_3353_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_3353_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3353_toGrace_40_1_41_->definitionLine = 771;
// method "shallowCopy"
  block_savedest(obj2988);
  Object closure3372 = createclosure(1, "shallowCopy");
  setclosureframe(closure3372, stackframe);
  addtoclosure(closure3372, var_methodTypeNode);
  struct UserObject *uo3372 = (struct UserObject*)obj2988;
  uo3372->data[18] = (Object)closure3372;
  Method *meth_meth_ast_3372_shallowCopy = addmethod2pos(obj2988, "shallowCopy", &meth_ast_3372_shallowCopy, 18);
  int argcv_meth_ast_3372_shallowCopy[] = {0};
  meth_meth_ast_3372_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_3372_shallowCopy);
  meth_meth_ast_3372_shallowCopy->definitionModule = modulename;
  meth_meth_ast_3372_shallowCopy->definitionLine = 776;
  sourceObject = obj2988;
// Begin line 685
  setline(685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3381 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3382 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3381);
// compiled call node returning call3382 (depth = 3)
  struct UserObject *obj2988_uo = (struct UserObject *)obj2988;
  obj2988_uo->super = call3382;
  sourceObject = obj2988;
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3383 == NULL) {
    strlit3383 = alloc_String("methodtype");
    gc_root(strlit3383);
  }
// compiled string node returning strlit3383 (depth = 3)
  adddatum2(obj2988, strlit3383, 1);
  sourceObject = obj2988;
// Begin line 687
  setline(687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature_39_ (depth = 3)
  adddatum2(obj2988, *var_signature_39_, 2);
  sourceObject = obj2988;
// Begin line 688
  setline(688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_rtype_39_ (depth = 3)
  adddatum2(obj2988, *var_rtype_39_, 3);
  sourceObject = obj2988;
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3384 = alloc_Boolean(0);
// compiled identifier node returning bool3384 (depth = 3)
  adddatum2(obj2988, bool3384, 4);
  sourceObject = obj2988;
// Begin line 690
  setline(690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_uninitialized (depth = 3)
  adddatum2(obj2988, *var_uninitialized, 5);
  sourceObject = obj2988;
  sourceObject = obj2988;
  sourceObject = obj2988;
  sourceObject = obj2988;
  sourceObject = obj2988;
  sourceObject = obj2988;
  sourceObject = obj2988;
  sourceObject = obj2988;
  sourceObject = obj2988;
  sourceObject = obj2988;
  sourceObject = obj2988;
  sourceObject = obj2988;
  sourceObject = obj2988;
  objclass2988 = obj2988->class;
  objclass2988->definitionModule = modulename;
  objclass2988->definitionLine = 679;
  (*(struct UserObject *)self).data[0] = lowerouter2988;
  self = oldself2988;
  selfslot = oldselfslot2988;
  stackframe = oldstackframe2988;
  gc_frame_end(frame);
  return obj2988;
}
Object meth_ast_3386_methodTypeNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodTypeNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_methodTypeNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 678
  setline(678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methodTypeNode (depth = 3)
  gc_frame_end(frame);
  return *var_methodTypeNode;
}
Object meth_ast_3398_name(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 791
  setline(791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3399 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3400 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3399);
// compiled member node returning call3400 (depth = 3)
  gc_frame_end(frame);
  return call3400;
}
Object meth_ast_3401_name_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method name:=(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for name:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part name:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 793
  setline(793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3402 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3403 = callmethodflags(self, "value:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3402);
// compiled call node returning call3403 (depth = 3)
// Begin line 794
  setline(794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3404 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool3405 = alloc_Boolean(0);
// compiled identifier node returning bool3405 (depth = 4)
  gc_frame_newslot(bool3405);
// call case 4: self request
  params[0] = bool3405;
  partcv[0] = 1;
  Object call3406 = callmethodflags(self, "anonymous:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3404);
// compiled call node returning call3406 (depth = 3)
  gc_frame_end(frame);
  return call3406;
}
Object meth_ast_3407_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 797
  setline(797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3409 == NULL) {
    strlit3409 = alloc_String("");
    gc_root(strlit3409);
  }
// compiled string node returning strlit3409 (depth = 4)
  int op_slot_right_3408 = gc_frame_newslot(strlit3409);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3412 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3413 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3412);
// compiled member node returning call3413 (depth = 5)
  int op_slot_right_3411 = gc_frame_newslot(call3413);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3416 == NULL) {
    strlit3416 = alloc_String(", types = ");
    gc_root(strlit3416);
  }
// compiled string node returning strlit3416 (depth = 6)
  int op_slot_right_3415 = gc_frame_newslot(strlit3416);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe3419 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3420 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3419);
// compiled member node returning call3420 (depth = 7)
  int op_slot_right_3418 = gc_frame_newslot(call3420);
// starting to compile string node (depth = 7)
  if (strlit3422 == NULL) {
    strlit3422 = alloc_String("typeliteral: methods = ");
    gc_root(strlit3422);
  }
// compiled string node returning strlit3422 (depth = 7)
  int op_slot_left_3418 = gc_frame_newslot(strlit3422);
  params[0] = call3420;
  partcv[0] = 1;
  Object opresult3423 = callmethod(strlit3422, "++(1)", 1, partcv, params);
// compiled op node returning opresult3423 (depth = 6)
  int op_slot_left_3415 = gc_frame_newslot(opresult3423);
  params[0] = strlit3416;
  partcv[0] = 1;
  Object opresult3424 = callmethod(opresult3423, "++(1)", 1, partcv, params);
// compiled op node returning opresult3424 (depth = 5)
  int op_slot_left_3411 = gc_frame_newslot(opresult3424);
  params[0] = call3413;
  partcv[0] = 1;
  Object opresult3425 = callmethod(opresult3424, "++(1)", 1, partcv, params);
// compiled op node returning opresult3425 (depth = 4)
  int op_slot_left_3408 = gc_frame_newslot(opresult3425);
  params[0] = strlit3409;
  partcv[0] = 1;
  Object opresult3426 = callmethod(opresult3425, "++(1)", 1, partcv, params);
// compiled op node returning opresult3426 (depth = 3)
  gc_frame_end(frame);
  return opresult3426;
}
Object meth_ast_3427_declarationKindWithAncestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 799
  setline(799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3428 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  partcv[0] = 0;
  Object call3429 = callmethodflags(*var_k, "typedec", 1, partcv, params, 0);
  gc_frame_end(callframe3428);
// compiled member node returning call3429 (depth = 3)
  gc_frame_end(frame);
  return call3429;
}
Object meth_ast_3430_isExecutable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 800
  setline(800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3431 = alloc_Boolean(0);
// compiled identifier node returning bool3431 (depth = 3)
  gc_frame_end(frame);
  return bool3431;
}
Object meth_ast_3432_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_noPosition = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_tEnd = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "tEnd");
  Object *var_mEnd = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "mEnd");
// Begin line 803
  setline(803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3434 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3435 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3436 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3435);
// compiled member node returning call3436 (depth = 6)
  partcv[0] = 0;
  Object call3437 = callmethodflags(call3436, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe3434);
// compiled member node returning call3437 (depth = 5)
  Object if3433 = done;
struct StackFrameObject *iftmpstackframe3433 = stackframe;
  if (istrue(call3437)) {
stackframe = alloc_StackFrame(0, iftmpstackframe3433);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_noPosition (depth = 5)
    gc_frame_newslot(*var_noPosition);
    if3433 = *var_noPosition;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe3433);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile member node (depth = 5)
  int callframe3438 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3439 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3440 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3441 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3440);
// compiled member node returning call3441 (depth = 7)
  partcv[0] = 0;
  Object call3442 = callmethodflags(call3441, "last", 1, partcv, params, 0);
  gc_frame_end(callframe3439);
// compiled member node returning call3442 (depth = 6)
  partcv[0] = 0;
  Object call3443 = callmethodflags(call3442, "end", 1, partcv, params, 0);
  gc_frame_end(callframe3438);
// compiled member node returning call3443 (depth = 5)
    gc_frame_newslot(call3443);
    if3433 = call3443;
  }
stackframe = iftmpstackframe3433;
// compiled if node returning if3433 (depth = 4)
  *var_tEnd = if3433;
  if (if3433 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 804
  setline(804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3445 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3446 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3447 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3446);
// compiled member node returning call3447 (depth = 6)
  partcv[0] = 0;
  Object call3448 = callmethodflags(call3447, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe3445);
// compiled member node returning call3448 (depth = 5)
  Object if3444 = done;
struct StackFrameObject *iftmpstackframe3444 = stackframe;
  if (istrue(call3448)) {
stackframe = alloc_StackFrame(0, iftmpstackframe3444);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_noPosition (depth = 5)
    gc_frame_newslot(*var_noPosition);
    if3444 = *var_noPosition;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe3444);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile member node (depth = 5)
  int callframe3449 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3450 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3451 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3452 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3451);
// compiled member node returning call3452 (depth = 7)
  partcv[0] = 0;
  Object call3453 = callmethodflags(call3452, "last", 1, partcv, params, 0);
  gc_frame_end(callframe3450);
// compiled member node returning call3453 (depth = 6)
  partcv[0] = 0;
  Object call3454 = callmethodflags(call3453, "end", 1, partcv, params, 0);
  gc_frame_end(callframe3449);
// compiled member node returning call3454 (depth = 5)
    gc_frame_newslot(call3454);
    if3444 = call3454;
  }
stackframe = iftmpstackframe3444;
// compiled if node returning if3444 (depth = 4)
  *var_mEnd = if3444;
  if (if3444 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 805
  setline(805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3455 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3456 == NULL) {
    strlit3456 = alloc_String("}");
    gc_root(strlit3456);
  }
// compiled string node returning strlit3456 (depth = 4)
  gc_frame_newslot(strlit3456);
// starting to compile call node (depth = 4)
  int callframe3457 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tEnd (depth = 5)
  gc_frame_newslot(*var_tEnd);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_mEnd (depth = 5)
  gc_frame_newslot(*var_mEnd);
// call case 5: prelude request
  params[0] = *var_tEnd;
  params[1] = *var_mEnd;
  partcv[0] = 2;
  Object call3458 = callmethodflags(prelude, "max(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3457);
// compiled call node returning call3458 (depth = 4)
  gc_frame_newslot(call3458);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = strlit3456;
  params[1] = call3458;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3459 = callmethodflags(module_ast, "positionOfNext(1)after(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3455);
// compiled call node returning call3459 (depth = 3)
  gc_frame_end(frame);
  return call3459;
}
Object meth_ast_3470__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 812
  setline(812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3471 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3472 = callmethodflags(*var_each, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3471);
// compiled call node returning call3472 (depth = 6)
  gc_frame_end(frame);
  return call3472;
}
Object meth_ast_3479__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 815
  setline(815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3480 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3481 = callmethodflags(*var_each, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3480);
// compiled call node returning call3481 (depth = 6)
  gc_frame_end(frame);
  return call3481;
}
Object meth_ast_3460_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// definebindings:
// Begin line 809
  setline(809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3462 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3463 = callmethodflags(*var_visitor, "visitTypeLiteral(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3462);
// compiled call node returning call3463 (depth = 4)
  Object if3461 = done;
  if (istrue(call3463)) {
// Begin line 810
  setline(810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3464 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call3465 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3464);
// compiled call node returning call3465 (depth = 5)
  *var_newChain = call3465;
  if (call3465 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 811
  setline(811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3466 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3467 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3468 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3467);
// compiled member node returning call3468 (depth = 5)
  gc_frame_newslot(call3468);
// starting to compile block node (depth = 5)
  Object block3469 = alloc_Block(NULL, NULL, "ast", 811);
  gc_frame_newslot(block3469);
// method "_apply(_)"
  block_savedest(block3469);
  Object closure3470 = createclosure(3, "_apply(1)");
  setclosureframe(closure3470, stackframe);
  addtoclosure(closure3470, var_visitor);
  addtoclosure(closure3470, var_newChain);
  addtoclosure(closure3470, selfslot);
  struct UserObject *uo3470 = (struct UserObject*)block3469;
  uo3470->data[0] = (Object)closure3470;
  Method *meth_meth_ast_3470__apply_40_1_41_ = addmethod2pos(block3469, "_apply(1)", &meth_ast_3470__apply_40_1_41_, 0);
  int argcv_meth_ast_3470__apply_40_1_41_[] = {1};
  meth_meth_ast_3470__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3470__apply_40_1_41_);
  meth_meth_ast_3470__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3470__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block3469 (depth = 5)
  gc_frame_newslot(block3469);
// call case 5: prelude request
  params[0] = call3468;
  params[1] = block3469;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3474 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3466);
// compiled call node returning call3474 (depth = 4)
// Begin line 814
  setline(814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3475 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3476 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3477 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3476);
// compiled member node returning call3477 (depth = 5)
  gc_frame_newslot(call3477);
// starting to compile block node (depth = 5)
  Object block3478 = alloc_Block(NULL, NULL, "ast", 814);
  gc_frame_newslot(block3478);
// method "_apply(_)"
  block_savedest(block3478);
  Object closure3479 = createclosure(3, "_apply(1)");
  setclosureframe(closure3479, stackframe);
  addtoclosure(closure3479, var_visitor);
  addtoclosure(closure3479, var_newChain);
  addtoclosure(closure3479, selfslot);
  struct UserObject *uo3479 = (struct UserObject*)block3478;
  uo3479->data[0] = (Object)closure3479;
  Method *meth_meth_ast_3479__apply_40_1_41_ = addmethod2pos(block3478, "_apply(1)", &meth_ast_3479__apply_40_1_41_, 0);
  int argcv_meth_ast_3479__apply_40_1_41_[] = {1};
  meth_meth_ast_3479__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3479__apply_40_1_41_);
  meth_meth_ast_3479__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3479__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block3478 (depth = 5)
  gc_frame_newslot(block3478);
// call case 5: prelude request
  params[0] = call3477;
  params[1] = block3478;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3483 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3475);
// compiled call node returning call3483 (depth = 4)
    gc_frame_newslot(call3483);
    if3461 = call3483;
  } else {
  }
// compiled if node returning if3461 (depth = 3)
  gc_frame_end(frame);
  return if3461;
}
Object meth_ast_3484_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 820
  setline(820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3485 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3486 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3485);
// compiled member node returning call3486 (depth = 4)
  *var_n = call3486;
  if (call3486 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 821
  setline(821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3487 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3488 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3487);
// compiled call node returning call3488 (depth = 4)
  *var_newChain = call3488;
  if (call3488 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 822
  setline(822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3489 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3490 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3491 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3492 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3491);
// compiled member node returning call3492 (depth = 5)
  gc_frame_newslot(call3492);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call3492;
  params[1] = *var_blk;
  params[2] = *var_as;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3493 = callmethodflags(module_ast, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3490);
// compiled call node returning call3493 (depth = 4)
  gc_frame_newslot(call3493);
// call case 6: other requests
// Begin line 822
  setline(822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3493;
  partcv[0] = 1;
  Object call3494 = callmethodflags(*var_n, "methods:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3489);
// compiled call node returning call3494 (depth = 3)
// Begin line 823
  setline(823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3495 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3496 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3497 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3498 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3497);
// compiled member node returning call3498 (depth = 5)
  gc_frame_newslot(call3498);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call3498;
  params[1] = *var_blk;
  params[2] = *var_as;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3499 = callmethodflags(module_ast, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3496);
// compiled call node returning call3499 (depth = 4)
  gc_frame_newslot(call3499);
// call case 6: other requests
// Begin line 823
  setline(823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3499;
  partcv[0] = 1;
  Object call3500 = callmethodflags(*var_n, "types:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3495);
// compiled call node returning call3500 (depth = 3)
// Begin line 824
  setline(824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3501 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call3502 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3501);
// compiled call node returning call3502 (depth = 3)
  gc_frame_end(frame);
  return call3502;
}
Object meth_ast_3530__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 831
  setline(831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3532 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3534 = alloc_Float64(2);
// compiled num node returning num3534 (depth = 9)
  int op_slot_right_3533 = gc_frame_newslot(num3534);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3533 = gc_frame_newslot(*var_depth);
  params[0] = num3534;
  partcv[0] = 1;
  Object sum3536 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3536 (depth = 8)
  gc_frame_newslot(sum3536);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum3536;
  partcv[0] = 1;
  Object call3537 = callmethodflags(*var_each, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3532);
// compiled call node returning call3537 (depth = 7)
  int op_slot_right_3531 = gc_frame_newslot(call3537);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_3539 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3542 == NULL) {
    strlit3542 = alloc_String("""\x0a""  ");
    gc_root(strlit3542);
  }
// compiled string node returning strlit3542 (depth = 9)
  int op_slot_right_3541 = gc_frame_newslot(strlit3542);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_3541 = gc_frame_newslot(*var_s);
  params[0] = strlit3542;
  partcv[0] = 1;
  Object opresult3544 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3544 (depth = 8)
  int op_slot_left_3539 = gc_frame_newslot(opresult3544);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3545 = callmethod(opresult3544, "++(1)", 1, partcv, params);
// compiled op node returning opresult3545 (depth = 7)
  int op_slot_left_3531 = gc_frame_newslot(opresult3545);
  params[0] = call3537;
  partcv[0] = 1;
  Object opresult3546 = callmethod(opresult3545, "++(1)", 1, partcv, params);
// compiled op node returning opresult3546 (depth = 6)
  *var_s = opresult3546;
  if (opresult3546 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_3566__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 835
  setline(835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3568 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3570 = alloc_Float64(2);
// compiled num node returning num3570 (depth = 9)
  int op_slot_right_3569 = gc_frame_newslot(num3570);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3569 = gc_frame_newslot(*var_depth);
  params[0] = num3570;
  partcv[0] = 1;
  Object sum3572 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3572 (depth = 8)
  gc_frame_newslot(sum3572);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum3572;
  partcv[0] = 1;
  Object call3573 = callmethodflags(*var_each, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3568);
// compiled call node returning call3573 (depth = 7)
  int op_slot_right_3567 = gc_frame_newslot(call3573);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_3575 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3578 == NULL) {
    strlit3578 = alloc_String("""\x0a""  ");
    gc_root(strlit3578);
  }
// compiled string node returning strlit3578 (depth = 9)
  int op_slot_right_3577 = gc_frame_newslot(strlit3578);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_3577 = gc_frame_newslot(*var_s);
  params[0] = strlit3578;
  partcv[0] = 1;
  Object opresult3580 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3580 (depth = 8)
  int op_slot_left_3575 = gc_frame_newslot(opresult3580);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3581 = callmethod(opresult3580, "++(1)", 1, partcv, params);
// compiled op node returning opresult3581 (depth = 7)
  int op_slot_left_3567 = gc_frame_newslot(opresult3581);
  params[0] = call3573;
  partcv[0] = 1;
  Object opresult3582 = callmethod(opresult3581, "++(1)", 1, partcv, params);
// compiled op node returning opresult3582 (depth = 6)
  *var_s = opresult3582;
  if (opresult3582 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_3503_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 827
  setline(827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3506 = alloc_Float64(1);
// compiled num node returning num3506 (depth = 6)
  int op_slot_right_3505 = gc_frame_newslot(num3506);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_3505 = gc_frame_newslot(*var_depth);
  params[0] = num3506;
  partcv[0] = 1;
  Object sum3508 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3508 (depth = 5)
  int op_slot_right_3504 = gc_frame_newslot(sum3508);
// starting to compile string node (depth = 5)
  if (strlit3510 == NULL) {
    strlit3510 = alloc_String("  ");
    gc_root(strlit3510);
  }
// compiled string node returning strlit3510 (depth = 5)
  int op_slot_left_3504 = gc_frame_newslot(strlit3510);
  params[0] = sum3508;
  partcv[0] = 1;
  Object prod3511 = callmethod(strlit3510, "*(1)", 1, partcv, params);
// compiled op node returning prod3511 (depth = 4)
  *var_spc = prod3511;
  if (prod3511 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 828
  setline(828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3513 == NULL) {
    strlit3513 = alloc_String("""\x0a""");
    gc_root(strlit3513);
  }
// compiled string node returning strlit3513 (depth = 5)
  int op_slot_right_3512 = gc_frame_newslot(strlit3513);
// starting to compile call node (depth = 5)
  int callframe3515 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call3516 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3515);
// compiled call node returning call3516 (depth = 5)
  int op_slot_left_3512 = gc_frame_newslot(call3516);
  params[0] = strlit3513;
  partcv[0] = 1;
  Object opresult3517 = callmethod(call3516, "++(1)", 1, partcv, params);
// compiled op node returning opresult3517 (depth = 4)
  *var_s = opresult3517;
  if (opresult3517 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 829
  setline(829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3519 == NULL) {
    strlit3519 = alloc_String("Types:");
    gc_root(strlit3519);
  }
// compiled string node returning strlit3519 (depth = 5)
  int op_slot_right_3518 = gc_frame_newslot(strlit3519);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_3521 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_3521 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3523 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3523 (depth = 5)
  int op_slot_left_3518 = gc_frame_newslot(opresult3523);
  params[0] = strlit3519;
  partcv[0] = 1;
  Object opresult3524 = callmethod(opresult3523, "++(1)", 1, partcv, params);
// compiled op node returning opresult3524 (depth = 4)
  *var_s = opresult3524;
  if (opresult3524 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 830
  setline(830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3526 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3527 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3528 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3527);
// compiled member node returning call3528 (depth = 4)
  gc_frame_newslot(call3528);
// starting to compile block node (depth = 4)
  Object block3529 = alloc_Block(NULL, NULL, "ast", 830);
  gc_frame_newslot(block3529);
// method "_apply(_)"
  block_savedest(block3529);
  Object closure3530 = createclosure(4, "_apply(1)");
  setclosureframe(closure3530, stackframe);
  addtoclosure(closure3530, var_depth);
  addtoclosure(closure3530, var_spc);
  addtoclosure(closure3530, var_s);
  addtoclosure(closure3530, selfslot);
  struct UserObject *uo3530 = (struct UserObject*)block3529;
  uo3530->data[0] = (Object)closure3530;
  Method *meth_meth_ast_3530__apply_40_1_41_ = addmethod2pos(block3529, "_apply(1)", &meth_ast_3530__apply_40_1_41_, 0);
  int argcv_meth_ast_3530__apply_40_1_41_[] = {1};
  meth_meth_ast_3530__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3530__apply_40_1_41_);
  meth_meth_ast_3530__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3530__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block3529 (depth = 4)
  gc_frame_newslot(block3529);
// call case 5: prelude request
  params[0] = call3528;
  params[1] = block3529;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3549 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3526);
// compiled call node returning call3549 (depth = 3)
// Begin line 833
  setline(833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3551 == NULL) {
    strlit3551 = alloc_String("Methods:");
    gc_root(strlit3551);
  }
// compiled string node returning strlit3551 (depth = 5)
  int op_slot_right_3550 = gc_frame_newslot(strlit3551);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_3553 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3556 == NULL) {
    strlit3556 = alloc_String("""\x0a""");
    gc_root(strlit3556);
  }
// compiled string node returning strlit3556 (depth = 7)
  int op_slot_right_3555 = gc_frame_newslot(strlit3556);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3555 = gc_frame_newslot(*var_s);
  params[0] = strlit3556;
  partcv[0] = 1;
  Object opresult3558 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3558 (depth = 6)
  int op_slot_left_3553 = gc_frame_newslot(opresult3558);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3559 = callmethod(opresult3558, "++(1)", 1, partcv, params);
// compiled op node returning opresult3559 (depth = 5)
  int op_slot_left_3550 = gc_frame_newslot(opresult3559);
  params[0] = strlit3551;
  partcv[0] = 1;
  Object opresult3560 = callmethod(opresult3559, "++(1)", 1, partcv, params);
// compiled op node returning opresult3560 (depth = 4)
  *var_s = opresult3560;
  if (opresult3560 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 834
  setline(834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3562 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3563 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3564 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3563);
// compiled member node returning call3564 (depth = 4)
  gc_frame_newslot(call3564);
// starting to compile block node (depth = 4)
  Object block3565 = alloc_Block(NULL, NULL, "ast", 834);
  gc_frame_newslot(block3565);
// method "_apply(_)"
  block_savedest(block3565);
  Object closure3566 = createclosure(4, "_apply(1)");
  setclosureframe(closure3566, stackframe);
  addtoclosure(closure3566, var_depth);
  addtoclosure(closure3566, var_spc);
  addtoclosure(closure3566, var_s);
  addtoclosure(closure3566, selfslot);
  struct UserObject *uo3566 = (struct UserObject*)block3565;
  uo3566->data[0] = (Object)closure3566;
  Method *meth_meth_ast_3566__apply_40_1_41_ = addmethod2pos(block3565, "_apply(1)", &meth_ast_3566__apply_40_1_41_, 0);
  int argcv_meth_ast_3566__apply_40_1_41_[] = {1};
  meth_meth_ast_3566__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3566__apply_40_1_41_);
  meth_meth_ast_3566__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3566__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block3565 (depth = 4)
  gc_frame_newslot(block3565);
// call case 5: prelude request
  params[0] = call3564;
  params[1] = block3565;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3585 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3562);
// compiled call node returning call3585 (depth = 3)
// Begin line 837
  setline(837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3587 == NULL) {
    strlit3587 = alloc_String("""\x0a""");
    gc_root(strlit3587);
  }
// compiled string node returning strlit3587 (depth = 5)
  int op_slot_right_3586 = gc_frame_newslot(strlit3587);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3586 = gc_frame_newslot(*var_s);
  params[0] = strlit3587;
  partcv[0] = 1;
  Object opresult3589 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3589 (depth = 4)
  *var_s = opresult3589;
  if (opresult3589 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 838
  setline(838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_3606__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 845
  setline(845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3608 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3610 = alloc_Float64(1);
// compiled num node returning num3610 (depth = 9)
  int op_slot_right_3609 = gc_frame_newslot(num3610);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3609 = gc_frame_newslot(*var_depth);
  params[0] = num3610;
  partcv[0] = 1;
  Object sum3612 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3612 (depth = 8)
  gc_frame_newslot(sum3612);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum3612;
  partcv[0] = 1;
  Object call3613 = callmethodflags(*var_each, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3608);
// compiled call node returning call3613 (depth = 7)
  int op_slot_right_3607 = gc_frame_newslot(call3613);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3616 == NULL) {
    strlit3616 = alloc_String("    ");
    gc_root(strlit3616);
  }
// compiled string node returning strlit3616 (depth = 8)
  int op_slot_right_3615 = gc_frame_newslot(strlit3616);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_3618 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3621 == NULL) {
    strlit3621 = alloc_String("""\x0a""");
    gc_root(strlit3621);
  }
// compiled string node returning strlit3621 (depth = 10)
  int op_slot_right_3620 = gc_frame_newslot(strlit3621);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_3620 = gc_frame_newslot(*var_s);
  params[0] = strlit3621;
  partcv[0] = 1;
  Object opresult3623 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3623 (depth = 9)
  int op_slot_left_3618 = gc_frame_newslot(opresult3623);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3624 = callmethod(opresult3623, "++(1)", 1, partcv, params);
// compiled op node returning opresult3624 (depth = 8)
  int op_slot_left_3615 = gc_frame_newslot(opresult3624);
  params[0] = strlit3616;
  partcv[0] = 1;
  Object opresult3625 = callmethod(opresult3624, "++(1)", 1, partcv, params);
// compiled op node returning opresult3625 (depth = 7)
  int op_slot_left_3607 = gc_frame_newslot(opresult3625);
  params[0] = call3613;
  partcv[0] = 1;
  Object opresult3626 = callmethod(opresult3625, "++(1)", 1, partcv, params);
// compiled op node returning opresult3626 (depth = 6)
  *var_s = opresult3626;
  if (opresult3626 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_3634__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3636 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3638 = alloc_Float64(1);
// compiled num node returning num3638 (depth = 9)
  int op_slot_right_3637 = gc_frame_newslot(num3638);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3637 = gc_frame_newslot(*var_depth);
  params[0] = num3638;
  partcv[0] = 1;
  Object sum3640 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3640 (depth = 8)
  gc_frame_newslot(sum3640);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum3640;
  partcv[0] = 1;
  Object call3641 = callmethodflags(*var_each, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3636);
// compiled call node returning call3641 (depth = 7)
  int op_slot_right_3635 = gc_frame_newslot(call3641);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3644 == NULL) {
    strlit3644 = alloc_String("    ");
    gc_root(strlit3644);
  }
// compiled string node returning strlit3644 (depth = 8)
  int op_slot_right_3643 = gc_frame_newslot(strlit3644);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_3646 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3649 == NULL) {
    strlit3649 = alloc_String("""\x0a""");
    gc_root(strlit3649);
  }
// compiled string node returning strlit3649 (depth = 10)
  int op_slot_right_3648 = gc_frame_newslot(strlit3649);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_3648 = gc_frame_newslot(*var_s);
  params[0] = strlit3649;
  partcv[0] = 1;
  Object opresult3651 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3651 (depth = 9)
  int op_slot_left_3646 = gc_frame_newslot(opresult3651);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3652 = callmethod(opresult3651, "++(1)", 1, partcv, params);
// compiled op node returning opresult3652 (depth = 8)
  int op_slot_left_3643 = gc_frame_newslot(opresult3652);
  params[0] = strlit3644;
  partcv[0] = 1;
  Object opresult3653 = callmethod(opresult3652, "++(1)", 1, partcv, params);
// compiled op node returning opresult3653 (depth = 7)
  int op_slot_left_3635 = gc_frame_newslot(opresult3653);
  params[0] = call3641;
  partcv[0] = 1;
  Object opresult3654 = callmethod(opresult3653, "++(1)", 1, partcv, params);
// compiled op node returning opresult3654 (depth = 6)
  *var_s = opresult3654;
  if (opresult3654 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_3591_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 841
  setline(841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_3592 = gc_frame_newslot(*var_depth);
// starting to compile string node (depth = 5)
  if (strlit3594 == NULL) {
    strlit3594 = alloc_String("    ");
    gc_root(strlit3594);
  }
// compiled string node returning strlit3594 (depth = 5)
  int op_slot_left_3592 = gc_frame_newslot(strlit3594);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object prod3595 = callmethod(strlit3594, "*(1)", 1, partcv, params);
// compiled op node returning prod3595 (depth = 4)
  *var_spc = prod3595;
  if (prod3595 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 842
  setline(842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3596 == NULL) {
    strlit3596 = alloc_String("type");
    gc_root(strlit3596);
  }
// compiled string node returning strlit3596 (depth = 4)
  *var_s = strlit3596;
  if (strlit3596 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 843
  setline(843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3598 == NULL) {
    strlit3598 = alloc_String(" = {");
    gc_root(strlit3598);
  }
// compiled string node returning strlit3598 (depth = 5)
  int op_slot_right_3597 = gc_frame_newslot(strlit3598);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3597 = gc_frame_newslot(*var_s);
  params[0] = strlit3598;
  partcv[0] = 1;
  Object opresult3600 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3600 (depth = 4)
  *var_s = opresult3600;
  if (opresult3600 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 844
  setline(844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3602 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3603 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3604 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3603);
// compiled member node returning call3604 (depth = 4)
  gc_frame_newslot(call3604);
// starting to compile block node (depth = 4)
  Object block3605 = alloc_Block(NULL, NULL, "ast", 844);
  gc_frame_newslot(block3605);
// method "_apply(_)"
  block_savedest(block3605);
  Object closure3606 = createclosure(4, "_apply(1)");
  setclosureframe(closure3606, stackframe);
  addtoclosure(closure3606, var_depth);
  addtoclosure(closure3606, var_spc);
  addtoclosure(closure3606, var_s);
  addtoclosure(closure3606, selfslot);
  struct UserObject *uo3606 = (struct UserObject*)block3605;
  uo3606->data[0] = (Object)closure3606;
  Method *meth_meth_ast_3606__apply_40_1_41_ = addmethod2pos(block3605, "_apply(1)", &meth_ast_3606__apply_40_1_41_, 0);
  int argcv_meth_ast_3606__apply_40_1_41_[] = {1};
  meth_meth_ast_3606__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3606__apply_40_1_41_);
  meth_meth_ast_3606__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3606__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block3605 (depth = 4)
  gc_frame_newslot(block3605);
// call case 5: prelude request
  params[0] = call3604;
  params[1] = block3605;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3629 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3602);
// compiled call node returning call3629 (depth = 3)
// Begin line 847
  setline(847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3630 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3631 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3632 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3631);
// compiled member node returning call3632 (depth = 4)
  gc_frame_newslot(call3632);
// starting to compile block node (depth = 4)
  Object block3633 = alloc_Block(NULL, NULL, "ast", 847);
  gc_frame_newslot(block3633);
// method "_apply(_)"
  block_savedest(block3633);
  Object closure3634 = createclosure(4, "_apply(1)");
  setclosureframe(closure3634, stackframe);
  addtoclosure(closure3634, var_depth);
  addtoclosure(closure3634, var_spc);
  addtoclosure(closure3634, var_s);
  addtoclosure(closure3634, selfslot);
  struct UserObject *uo3634 = (struct UserObject*)block3633;
  uo3634->data[0] = (Object)closure3634;
  Method *meth_meth_ast_3634__apply_40_1_41_ = addmethod2pos(block3633, "_apply(1)", &meth_ast_3634__apply_40_1_41_, 0);
  int argcv_meth_ast_3634__apply_40_1_41_[] = {1};
  meth_meth_ast_3634__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3634__apply_40_1_41_);
  meth_meth_ast_3634__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3634__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block3633 (depth = 4)
  gc_frame_newslot(block3633);
// call case 5: prelude request
  params[0] = call3632;
  params[1] = block3633;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3657 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3630);
// compiled call node returning call3657 (depth = 3)
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3659 == NULL) {
    strlit3659 = alloc_String("}");
    gc_root(strlit3659);
  }
// compiled string node returning strlit3659 (depth = 4)
  int op_slot_right_3658 = gc_frame_newslot(strlit3659);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_3658 = gc_frame_newslot(*var_s);
  params[0] = strlit3659;
  partcv[0] = 1;
  Object opresult3661 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3661 (depth = 3)
  gc_frame_end(frame);
  return opresult3661;
}
Object meth_ast_3662_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_typeLiteralNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 853
  setline(853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3663 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe3664 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeLiteralNode (depth = 5)
  params[0] = *var_emptySeq;
  params[1] = *var_emptySeq;
  partcv[0] = 2;
  Object call3665 = callmethodflags(*var_typeLiteralNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3664);
// compiled call node returning call3665 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call3666 = callmethodflags(call3665, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3663);
// compiled call node returning call3666 (depth = 3)
  gc_frame_end(frame);
  return call3666;
}
Object meth_ast_3667_postCopy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "postCopy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method postCopy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for postCopy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part postCopy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 856
  setline(856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3668 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3669 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call3670 = callmethodflags(*var_other, "nominal", 1, partcv, params, 0);
  gc_frame_end(callframe3669);
// compiled member node returning call3670 (depth = 4)
  gc_frame_newslot(call3670);
// call case 4: self request
  params[0] = call3670;
  partcv[0] = 1;
  Object call3671 = callmethodflags(self, "nominal:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3668);
// compiled call node returning call3671 (depth = 3)
// Begin line 857
  setline(857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3672 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3673 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call3674 = callmethodflags(*var_other, "anonymous", 1, partcv, params, 0);
  gc_frame_end(callframe3673);
// compiled member node returning call3674 (depth = 4)
  gc_frame_newslot(call3674);
// call case 4: self request
  params[0] = call3674;
  partcv[0] = 1;
  Object call3675 = callmethodflags(self, "anonymous:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3672);
// compiled call node returning call3675 (depth = 3)
// Begin line 858
  setline(858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3676 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3677 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call3678 = callmethodflags(*var_other, "value", 1, partcv, params, 0);
  gc_frame_end(callframe3677);
// compiled member node returning call3678 (depth = 4)
  gc_frame_newslot(call3678);
// call case 4: self request
  params[0] = call3678;
  partcv[0] = 1;
  Object call3679 = callmethodflags(self, "value:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3676);
// compiled call node returning call3679 (depth = 3)
// Begin line 859
  setline(859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_3389_new_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_noPosition = getfromclosure(closure, 1);
  Object *var_emptySeq = getfromclosure(closure, 2);
  Object *var_typeLiteralNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_methods_39_ = &(stackframe->slots[0]);
  *var_methods_39_ = args[curarg];
  curarg++;
  Object *var_types_39_ = &(stackframe->slots[1]);
  *var_types_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3390 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3390 = alloc_userobj2(23,19, objclass3390);
  gc_frame_newslot(obj3390);
  if (objclass3390 == NULL) {
    glfree(obj3390->class->name);
    obj3390->class->name = "typeLiteralNode.new(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3390, self, 0);
  addmethodreal(obj3390,"outer", &reader_ast_outer_3391);
  Object oldself3390 = self;
  struct StackFrameObject *oldstackframe3390 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3390);
  gc_frame_newslot((Object)stackframe);
  self = obj3390;
  Object *oldselfslot3390 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3390 = (*(struct UserObject *)self).data[0], lowerouter3390 = thisouter3390;
  if (inheritingObject3390) {
    struct UserObject *inho3390 = (struct UserObject *)inheritingObject3390;
    while (inho3390->super != GraceDefaultObject) inho3390 = (struct UserObject *)inho3390->super;
    inho3390->super = obj3390;
    self = inheritingObject3390;
    *selfslot = self;
    lowerouter3390 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3390;
  }
  if (objclass3390 == NULL) {
  Method *reader3392 = addmethodrealflags(obj3390, "kind",&reader_ast_kind_3392, MFLAG_DEF);
  reader3392->definitionModule = modulename;
  reader3392->definitionLine = 784;
  }
  adddatum2(obj3390, alloc_Undefined(), 1);
  if (objclass3390 == NULL) {
    Method *reader3393 = addmethodrealflags(obj3390, "methods", &reader_ast_methods_3393, 0);
    Method *writer3393 = addmethodrealflags(obj3390, "methods:=(1)", &writer_ast_methods_3393, 0);
    reader3393->definitionModule = modulename;
    writer3393->definitionModule = modulename;
    reader3393->definitionLine = 785;
    writer3393->definitionLine = 785;
  }
  obj3390->flags |= OFLAG_MUTABLE;
  adddatum2(obj3390, alloc_Undefined(), 2);
  if (objclass3390 == NULL) {
    Method *reader3394 = addmethodrealflags(obj3390, "types", &reader_ast_types_3394, 0);
    Method *writer3394 = addmethodrealflags(obj3390, "types:=(1)", &writer_ast_types_3394, 0);
    reader3394->definitionModule = modulename;
    writer3394->definitionModule = modulename;
    reader3394->definitionLine = 786;
    writer3394->definitionLine = 786;
  }
  obj3390->flags |= OFLAG_MUTABLE;
  adddatum2(obj3390, alloc_Undefined(), 3);
  if (objclass3390 == NULL) {
    Method *reader3395 = addmethodrealflags(obj3390, "nominal", &reader_ast_nominal_3395, 0);
    Method *writer3395 = addmethodrealflags(obj3390, "nominal:=(1)", &writer_ast_nominal_3395, 0);
    reader3395->definitionModule = modulename;
    writer3395->definitionModule = modulename;
    reader3395->definitionLine = 787;
    writer3395->definitionLine = 787;
  }
  obj3390->flags |= OFLAG_MUTABLE;
  adddatum2(obj3390, alloc_Undefined(), 4);
  if (objclass3390 == NULL) {
    Method *reader3396 = addmethodrealflags(obj3390, "anonymous", &reader_ast_anonymous_3396, 0);
    Method *writer3396 = addmethodrealflags(obj3390, "anonymous:=(1)", &writer_ast_anonymous_3396, 0);
    reader3396->definitionModule = modulename;
    writer3396->definitionModule = modulename;
    reader3396->definitionLine = 788;
    writer3396->definitionLine = 788;
  }
  obj3390->flags |= OFLAG_MUTABLE;
  adddatum2(obj3390, alloc_Undefined(), 5);
  if (objclass3390 == NULL) {
    Method *reader3397 = addmethodrealflags(obj3390, "value", &reader_ast_value_3397, 0);
    Method *writer3397 = addmethodrealflags(obj3390, "value:=(1)", &writer_ast_value_3397, 0);
    reader3397->definitionModule = modulename;
    writer3397->definitionModule = modulename;
    reader3397->definitionLine = 789;
    writer3397->definitionLine = 789;
  }
  obj3390->flags |= OFLAG_MUTABLE;
  adddatum2(obj3390, alloc_Undefined(), 6);
// method "name"
  struct UserObject *uo3398 = (struct UserObject*)obj3390;
  uo3398->data[7] = emptyclosure;
  Method *meth_meth_ast_3398_name = addmethod2pos(obj3390, "name", &meth_ast_3398_name, 7);
  int argcv_meth_ast_3398_name[] = {0};
  meth_meth_ast_3398_name->type = alloc_MethodType(1, argcv_meth_ast_3398_name);
  meth_meth_ast_3398_name->definitionModule = modulename;
  meth_meth_ast_3398_name->definitionLine = 791;
// method "name:=(_)"
  struct UserObject *uo3401 = (struct UserObject*)obj3390;
  uo3401->data[8] = emptyclosure;
  Method *meth_meth_ast_3401_name_58__61__40_1_41_ = addmethod2pos(obj3390, "name:=(1)", &meth_ast_3401_name_58__61__40_1_41_, 8);
  int argcv_meth_ast_3401_name_58__61__40_1_41_[] = {1};
  meth_meth_ast_3401_name_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3401_name_58__61__40_1_41_);
  meth_meth_ast_3401_name_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_3401_name_58__61__40_1_41_->definitionLine = 792;
// method "asString"
  struct UserObject *uo3407 = (struct UserObject*)obj3390;
  uo3407->data[9] = emptyclosure;
  Method *meth_meth_ast_3407_asString = addmethod2pos(obj3390, "asString", &meth_ast_3407_asString, 9);
  int argcv_meth_ast_3407_asString[] = {0};
  meth_meth_ast_3407_asString->type = alloc_MethodType(1, argcv_meth_ast_3407_asString);
  meth_meth_ast_3407_asString->definitionModule = modulename;
  meth_meth_ast_3407_asString->definitionLine = 796;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj3390);
  Object closure3427 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure3427, stackframe);
  addtoclosure(closure3427, var_k);
  struct UserObject *uo3427 = (struct UserObject*)obj3390;
  uo3427->data[10] = (Object)closure3427;
  Method *meth_meth_ast_3427_declarationKindWithAncestors_40_1_41_ = addmethod2pos(obj3390, "declarationKindWithAncestors(1)", &meth_ast_3427_declarationKindWithAncestors_40_1_41_, 10);
  int argcv_meth_ast_3427_declarationKindWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_3427_declarationKindWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3427_declarationKindWithAncestors_40_1_41_);
  meth_meth_ast_3427_declarationKindWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3427_declarationKindWithAncestors_40_1_41_->definitionLine = 799;
// method "isExecutable"
  struct UserObject *uo3430 = (struct UserObject*)obj3390;
  uo3430->data[11] = emptyclosure;
  Method *meth_meth_ast_3430_isExecutable = addmethod2pos(obj3390, "isExecutable", &meth_ast_3430_isExecutable, 11);
  int argcv_meth_ast_3430_isExecutable[] = {0};
  meth_meth_ast_3430_isExecutable->type = alloc_MethodType(1, argcv_meth_ast_3430_isExecutable);
  meth_meth_ast_3430_isExecutable->definitionModule = modulename;
  meth_meth_ast_3430_isExecutable->definitionLine = 800;
// method "end"
  block_savedest(obj3390);
  Object closure3432 = createclosure(1, "end");
  setclosureframe(closure3432, stackframe);
  addtoclosure(closure3432, var_noPosition);
  struct UserObject *uo3432 = (struct UserObject*)obj3390;
  uo3432->data[12] = (Object)closure3432;
  Method *meth_meth_ast_3432_end = addmethod2pos(obj3390, "end", &meth_ast_3432_end, 12);
  int argcv_meth_ast_3432_end[] = {0};
  meth_meth_ast_3432_end->type = alloc_MethodType(1, argcv_meth_ast_3432_end);
  meth_meth_ast_3432_end->definitionModule = modulename;
  meth_meth_ast_3432_end->definitionLine = 802;
// method "accept(_)from(_)"
  struct UserObject *uo3460 = (struct UserObject*)obj3390;
  uo3460->data[13] = emptyclosure;
  Method *meth_meth_ast_3460_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj3390, "accept(1)from(1)", &meth_ast_3460_accept_40_1_41_from_40_1_41_, 13);
  int argcv_meth_ast_3460_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_3460_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_3460_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_3460_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3460_accept_40_1_41_from_40_1_41_->definitionLine = 808;
// method "map(_)ancestors(_)"
  struct UserObject *uo3484 = (struct UserObject*)obj3390;
  uo3484->data[14] = emptyclosure;
  Method *meth_meth_ast_3484_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj3390, "map(1)ancestors(1)", &meth_ast_3484_map_40_1_41_ancestors_40_1_41_, 14);
  int argcv_meth_ast_3484_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_3484_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_3484_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_3484_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3484_map_40_1_41_ancestors_40_1_41_->definitionLine = 819;
// method "pretty(_)"
  struct UserObject *uo3503 = (struct UserObject*)obj3390;
  uo3503->data[15] = emptyclosure;
  Method *meth_meth_ast_3503_pretty_40_1_41_ = addmethod2pos(obj3390, "pretty(1)", &meth_ast_3503_pretty_40_1_41_, 15);
  int argcv_meth_ast_3503_pretty_40_1_41_[] = {1};
  meth_meth_ast_3503_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3503_pretty_40_1_41_);
  meth_meth_ast_3503_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3503_pretty_40_1_41_->definitionLine = 826;
// method "toGrace(_)"
  struct UserObject *uo3591 = (struct UserObject*)obj3390;
  uo3591->data[16] = emptyclosure;
  Method *meth_meth_ast_3591_toGrace_40_1_41_ = addmethod2pos(obj3390, "toGrace(1)", &meth_ast_3591_toGrace_40_1_41_, 16);
  int argcv_meth_ast_3591_toGrace_40_1_41_[] = {1};
  meth_meth_ast_3591_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3591_toGrace_40_1_41_);
meth_meth_ast_3591_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_3591_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_3591_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3591_toGrace_40_1_41_->definitionLine = 840;
// method "shallowCopy"
  block_savedest(obj3390);
  Object closure3662 = createclosure(2, "shallowCopy");
  setclosureframe(closure3662, stackframe);
  addtoclosure(closure3662, var_emptySeq);
  addtoclosure(closure3662, var_typeLiteralNode);
  struct UserObject *uo3662 = (struct UserObject*)obj3390;
  uo3662->data[17] = (Object)closure3662;
  Method *meth_meth_ast_3662_shallowCopy = addmethod2pos(obj3390, "shallowCopy", &meth_ast_3662_shallowCopy, 17);
  int argcv_meth_ast_3662_shallowCopy[] = {0};
  meth_meth_ast_3662_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_3662_shallowCopy);
  meth_meth_ast_3662_shallowCopy->definitionModule = modulename;
  meth_meth_ast_3662_shallowCopy->definitionLine = 852;
// method "postCopy(_)"
  struct UserObject *uo3667 = (struct UserObject*)obj3390;
  uo3667->data[18] = emptyclosure;
  Method *meth_meth_ast_3667_postCopy_40_1_41_ = addmethod2pos(obj3390, "postCopy(1)", &meth_ast_3667_postCopy_40_1_41_, 18);
  int argcv_meth_ast_3667_postCopy_40_1_41_[] = {1};
  meth_meth_ast_3667_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3667_postCopy_40_1_41_);
  meth_meth_ast_3667_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3667_postCopy_40_1_41_->definitionLine = 855;
  sourceObject = obj3390;
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3680 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3681 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3680);
// compiled call node returning call3681 (depth = 3)
  struct UserObject *obj3390_uo = (struct UserObject *)obj3390;
  obj3390_uo->super = call3681;
  sourceObject = obj3390;
// Begin line 784
  setline(784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3682 == NULL) {
    strlit3682 = alloc_String("typeliteral");
    gc_root(strlit3682);
  }
// compiled string node returning strlit3682 (depth = 3)
  adddatum2(obj3390, strlit3682, 1);
  sourceObject = obj3390;
// Begin line 785
  setline(785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methods_39_ (depth = 3)
  adddatum2(obj3390, *var_methods_39_, 2);
  sourceObject = obj3390;
// Begin line 786
  setline(786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_types_39_ (depth = 3)
  adddatum2(obj3390, *var_types_39_, 3);
  sourceObject = obj3390;
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3683 = alloc_Boolean(0);
// compiled identifier node returning bool3683 (depth = 3)
  adddatum2(obj3390, bool3683, 4);
  sourceObject = obj3390;
// Begin line 788
  setline(788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3684 = alloc_Boolean(1);
// compiled identifier node returning bool3684 (depth = 3)
  adddatum2(obj3390, bool3684, 5);
  sourceObject = obj3390;
// Begin line 789
  setline(789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3685 == NULL) {
    strlit3685 = alloc_String("""\xe2""""\x80""""\xb9""anon""\xe2""""\x80""""\xba""");
    gc_root(strlit3685);
  }
// compiled string node returning strlit3685 (depth = 3)
  adddatum2(obj3390, strlit3685, 6);
  sourceObject = obj3390;
  sourceObject = obj3390;
  sourceObject = obj3390;
  sourceObject = obj3390;
  sourceObject = obj3390;
  sourceObject = obj3390;
  sourceObject = obj3390;
  sourceObject = obj3390;
  sourceObject = obj3390;
  sourceObject = obj3390;
  sourceObject = obj3390;
  sourceObject = obj3390;
  objclass3390 = obj3390->class;
  objclass3390->definitionModule = modulename;
  objclass3390->definitionLine = 782;
  (*(struct UserObject *)self).data[0] = lowerouter3390;
  self = oldself3390;
  selfslot = oldselfslot3390;
  stackframe = oldstackframe3390;
  gc_frame_end(frame);
  return obj3390;
}
Object meth_ast_3389_new_40_2_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_noPosition = getfromclosure(closure, 1);
  Object *var_emptySeq = getfromclosure(closure, 2);
  Object *var_typeLiteralNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_methods_39_ = &(stackframe->slots[0]);
  *var_methods_39_ = args[curarg];
  curarg++;
  Object *var_types_39_ = &(stackframe->slots[1]);
  *var_types_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3390 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3390 = alloc_userobj2(23,19, objclass3390);
  gc_frame_newslot(obj3390);
  if (objclass3390 == NULL) {
    glfree(obj3390->class->name);
    obj3390->class->name = "typeLiteralNode.new(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3390, self, 0);
  addmethodreal(obj3390,"outer", &reader_ast_outer_3391);
  Object oldself3390 = self;
  struct StackFrameObject *oldstackframe3390 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3390);
  gc_frame_newslot((Object)stackframe);
  self = obj3390;
  Object *oldselfslot3390 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3390 = (*(struct UserObject *)self).data[0], lowerouter3390 = thisouter3390;
  if (inheritingObject3390) {
    struct UserObject *inho3390 = (struct UserObject *)inheritingObject3390;
    while (inho3390->super != GraceDefaultObject) inho3390 = (struct UserObject *)inho3390->super;
    inho3390->super = obj3390;
    self = inheritingObject3390;
    *selfslot = self;
    lowerouter3390 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3390;
  }
  if (objclass3390 == NULL) {
  Method *reader3392 = addmethodrealflags(obj3390, "kind",&reader_ast_kind_3392, MFLAG_DEF);
  reader3392->definitionModule = modulename;
  reader3392->definitionLine = 784;
  }
  adddatum2(obj3390, alloc_Undefined(), 1);
  if (objclass3390 == NULL) {
    Method *reader3393 = addmethodrealflags(obj3390, "methods", &reader_ast_methods_3393, 0);
    Method *writer3393 = addmethodrealflags(obj3390, "methods:=(1)", &writer_ast_methods_3393, 0);
    reader3393->definitionModule = modulename;
    writer3393->definitionModule = modulename;
    reader3393->definitionLine = 785;
    writer3393->definitionLine = 785;
  }
  obj3390->flags |= OFLAG_MUTABLE;
  adddatum2(obj3390, alloc_Undefined(), 2);
  if (objclass3390 == NULL) {
    Method *reader3394 = addmethodrealflags(obj3390, "types", &reader_ast_types_3394, 0);
    Method *writer3394 = addmethodrealflags(obj3390, "types:=(1)", &writer_ast_types_3394, 0);
    reader3394->definitionModule = modulename;
    writer3394->definitionModule = modulename;
    reader3394->definitionLine = 786;
    writer3394->definitionLine = 786;
  }
  obj3390->flags |= OFLAG_MUTABLE;
  adddatum2(obj3390, alloc_Undefined(), 3);
  if (objclass3390 == NULL) {
    Method *reader3395 = addmethodrealflags(obj3390, "nominal", &reader_ast_nominal_3395, 0);
    Method *writer3395 = addmethodrealflags(obj3390, "nominal:=(1)", &writer_ast_nominal_3395, 0);
    reader3395->definitionModule = modulename;
    writer3395->definitionModule = modulename;
    reader3395->definitionLine = 787;
    writer3395->definitionLine = 787;
  }
  obj3390->flags |= OFLAG_MUTABLE;
  adddatum2(obj3390, alloc_Undefined(), 4);
  if (objclass3390 == NULL) {
    Method *reader3396 = addmethodrealflags(obj3390, "anonymous", &reader_ast_anonymous_3396, 0);
    Method *writer3396 = addmethodrealflags(obj3390, "anonymous:=(1)", &writer_ast_anonymous_3396, 0);
    reader3396->definitionModule = modulename;
    writer3396->definitionModule = modulename;
    reader3396->definitionLine = 788;
    writer3396->definitionLine = 788;
  }
  obj3390->flags |= OFLAG_MUTABLE;
  adddatum2(obj3390, alloc_Undefined(), 5);
  if (objclass3390 == NULL) {
    Method *reader3397 = addmethodrealflags(obj3390, "value", &reader_ast_value_3397, 0);
    Method *writer3397 = addmethodrealflags(obj3390, "value:=(1)", &writer_ast_value_3397, 0);
    reader3397->definitionModule = modulename;
    writer3397->definitionModule = modulename;
    reader3397->definitionLine = 789;
    writer3397->definitionLine = 789;
  }
  obj3390->flags |= OFLAG_MUTABLE;
  adddatum2(obj3390, alloc_Undefined(), 6);
// method "name"
  struct UserObject *uo3398 = (struct UserObject*)obj3390;
  uo3398->data[7] = emptyclosure;
  Method *meth_meth_ast_3398_name = addmethod2pos(obj3390, "name", &meth_ast_3398_name, 7);
  int argcv_meth_ast_3398_name[] = {0};
  meth_meth_ast_3398_name->type = alloc_MethodType(1, argcv_meth_ast_3398_name);
  meth_meth_ast_3398_name->definitionModule = modulename;
  meth_meth_ast_3398_name->definitionLine = 791;
// method "name:=(_)"
  struct UserObject *uo3401 = (struct UserObject*)obj3390;
  uo3401->data[8] = emptyclosure;
  Method *meth_meth_ast_3401_name_58__61__40_1_41_ = addmethod2pos(obj3390, "name:=(1)", &meth_ast_3401_name_58__61__40_1_41_, 8);
  int argcv_meth_ast_3401_name_58__61__40_1_41_[] = {1};
  meth_meth_ast_3401_name_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3401_name_58__61__40_1_41_);
  meth_meth_ast_3401_name_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_3401_name_58__61__40_1_41_->definitionLine = 792;
// method "asString"
  struct UserObject *uo3407 = (struct UserObject*)obj3390;
  uo3407->data[9] = emptyclosure;
  Method *meth_meth_ast_3407_asString = addmethod2pos(obj3390, "asString", &meth_ast_3407_asString, 9);
  int argcv_meth_ast_3407_asString[] = {0};
  meth_meth_ast_3407_asString->type = alloc_MethodType(1, argcv_meth_ast_3407_asString);
  meth_meth_ast_3407_asString->definitionModule = modulename;
  meth_meth_ast_3407_asString->definitionLine = 796;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj3390);
  Object closure3427 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure3427, stackframe);
  addtoclosure(closure3427, var_k);
  struct UserObject *uo3427 = (struct UserObject*)obj3390;
  uo3427->data[10] = (Object)closure3427;
  Method *meth_meth_ast_3427_declarationKindWithAncestors_40_1_41_ = addmethod2pos(obj3390, "declarationKindWithAncestors(1)", &meth_ast_3427_declarationKindWithAncestors_40_1_41_, 10);
  int argcv_meth_ast_3427_declarationKindWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_3427_declarationKindWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3427_declarationKindWithAncestors_40_1_41_);
  meth_meth_ast_3427_declarationKindWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3427_declarationKindWithAncestors_40_1_41_->definitionLine = 799;
// method "isExecutable"
  struct UserObject *uo3430 = (struct UserObject*)obj3390;
  uo3430->data[11] = emptyclosure;
  Method *meth_meth_ast_3430_isExecutable = addmethod2pos(obj3390, "isExecutable", &meth_ast_3430_isExecutable, 11);
  int argcv_meth_ast_3430_isExecutable[] = {0};
  meth_meth_ast_3430_isExecutable->type = alloc_MethodType(1, argcv_meth_ast_3430_isExecutable);
  meth_meth_ast_3430_isExecutable->definitionModule = modulename;
  meth_meth_ast_3430_isExecutable->definitionLine = 800;
// method "end"
  block_savedest(obj3390);
  Object closure3432 = createclosure(1, "end");
  setclosureframe(closure3432, stackframe);
  addtoclosure(closure3432, var_noPosition);
  struct UserObject *uo3432 = (struct UserObject*)obj3390;
  uo3432->data[12] = (Object)closure3432;
  Method *meth_meth_ast_3432_end = addmethod2pos(obj3390, "end", &meth_ast_3432_end, 12);
  int argcv_meth_ast_3432_end[] = {0};
  meth_meth_ast_3432_end->type = alloc_MethodType(1, argcv_meth_ast_3432_end);
  meth_meth_ast_3432_end->definitionModule = modulename;
  meth_meth_ast_3432_end->definitionLine = 802;
// method "accept(_)from(_)"
  struct UserObject *uo3460 = (struct UserObject*)obj3390;
  uo3460->data[13] = emptyclosure;
  Method *meth_meth_ast_3460_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj3390, "accept(1)from(1)", &meth_ast_3460_accept_40_1_41_from_40_1_41_, 13);
  int argcv_meth_ast_3460_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_3460_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_3460_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_3460_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3460_accept_40_1_41_from_40_1_41_->definitionLine = 808;
// method "map(_)ancestors(_)"
  struct UserObject *uo3484 = (struct UserObject*)obj3390;
  uo3484->data[14] = emptyclosure;
  Method *meth_meth_ast_3484_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj3390, "map(1)ancestors(1)", &meth_ast_3484_map_40_1_41_ancestors_40_1_41_, 14);
  int argcv_meth_ast_3484_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_3484_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_3484_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_3484_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3484_map_40_1_41_ancestors_40_1_41_->definitionLine = 819;
// method "pretty(_)"
  struct UserObject *uo3503 = (struct UserObject*)obj3390;
  uo3503->data[15] = emptyclosure;
  Method *meth_meth_ast_3503_pretty_40_1_41_ = addmethod2pos(obj3390, "pretty(1)", &meth_ast_3503_pretty_40_1_41_, 15);
  int argcv_meth_ast_3503_pretty_40_1_41_[] = {1};
  meth_meth_ast_3503_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3503_pretty_40_1_41_);
  meth_meth_ast_3503_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3503_pretty_40_1_41_->definitionLine = 826;
// method "toGrace(_)"
  struct UserObject *uo3591 = (struct UserObject*)obj3390;
  uo3591->data[16] = emptyclosure;
  Method *meth_meth_ast_3591_toGrace_40_1_41_ = addmethod2pos(obj3390, "toGrace(1)", &meth_ast_3591_toGrace_40_1_41_, 16);
  int argcv_meth_ast_3591_toGrace_40_1_41_[] = {1};
  meth_meth_ast_3591_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3591_toGrace_40_1_41_);
meth_meth_ast_3591_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_3591_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_3591_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3591_toGrace_40_1_41_->definitionLine = 840;
// method "shallowCopy"
  block_savedest(obj3390);
  Object closure3662 = createclosure(2, "shallowCopy");
  setclosureframe(closure3662, stackframe);
  addtoclosure(closure3662, var_emptySeq);
  addtoclosure(closure3662, var_typeLiteralNode);
  struct UserObject *uo3662 = (struct UserObject*)obj3390;
  uo3662->data[17] = (Object)closure3662;
  Method *meth_meth_ast_3662_shallowCopy = addmethod2pos(obj3390, "shallowCopy", &meth_ast_3662_shallowCopy, 17);
  int argcv_meth_ast_3662_shallowCopy[] = {0};
  meth_meth_ast_3662_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_3662_shallowCopy);
  meth_meth_ast_3662_shallowCopy->definitionModule = modulename;
  meth_meth_ast_3662_shallowCopy->definitionLine = 852;
// method "postCopy(_)"
  struct UserObject *uo3667 = (struct UserObject*)obj3390;
  uo3667->data[18] = emptyclosure;
  Method *meth_meth_ast_3667_postCopy_40_1_41_ = addmethod2pos(obj3390, "postCopy(1)", &meth_ast_3667_postCopy_40_1_41_, 18);
  int argcv_meth_ast_3667_postCopy_40_1_41_[] = {1};
  meth_meth_ast_3667_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3667_postCopy_40_1_41_);
  meth_meth_ast_3667_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3667_postCopy_40_1_41_->definitionLine = 855;
  sourceObject = obj3390;
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3680 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3681 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3680);
// compiled call node returning call3681 (depth = 3)
  struct UserObject *obj3390_uo = (struct UserObject *)obj3390;
  obj3390_uo->super = call3681;
  sourceObject = obj3390;
// Begin line 784
  setline(784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3682 == NULL) {
    strlit3682 = alloc_String("typeliteral");
    gc_root(strlit3682);
  }
// compiled string node returning strlit3682 (depth = 3)
  adddatum2(obj3390, strlit3682, 1);
  sourceObject = obj3390;
// Begin line 785
  setline(785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methods_39_ (depth = 3)
  adddatum2(obj3390, *var_methods_39_, 2);
  sourceObject = obj3390;
// Begin line 786
  setline(786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_types_39_ (depth = 3)
  adddatum2(obj3390, *var_types_39_, 3);
  sourceObject = obj3390;
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3683 = alloc_Boolean(0);
// compiled identifier node returning bool3683 (depth = 3)
  adddatum2(obj3390, bool3683, 4);
  sourceObject = obj3390;
// Begin line 788
  setline(788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3684 = alloc_Boolean(1);
// compiled identifier node returning bool3684 (depth = 3)
  adddatum2(obj3390, bool3684, 5);
  sourceObject = obj3390;
// Begin line 789
  setline(789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3685 == NULL) {
    strlit3685 = alloc_String("""\xe2""""\x80""""\xb9""anon""\xe2""""\x80""""\xba""");
    gc_root(strlit3685);
  }
// compiled string node returning strlit3685 (depth = 3)
  adddatum2(obj3390, strlit3685, 6);
  sourceObject = obj3390;
  sourceObject = obj3390;
  sourceObject = obj3390;
  sourceObject = obj3390;
  sourceObject = obj3390;
  sourceObject = obj3390;
  sourceObject = obj3390;
  sourceObject = obj3390;
  sourceObject = obj3390;
  sourceObject = obj3390;
  sourceObject = obj3390;
  sourceObject = obj3390;
  objclass3390 = obj3390->class;
  objclass3390->definitionModule = modulename;
  objclass3390->definitionLine = 782;
  (*(struct UserObject *)self).data[0] = lowerouter3390;
  self = oldself3390;
  selfslot = oldselfslot3390;
  stackframe = oldstackframe3390;
  gc_frame_end(frame);
  return obj3390;
}
Object meth_ast_3687_typeLiteralNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 33, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeLiteralNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeLiteralNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 781
  setline(781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeLiteralNode (depth = 3)
  gc_frame_end(frame);
  return *var_typeLiteralNode;
}
Object meth_ast_3700_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 875
  setline(875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3701 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3702 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3703 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3702);
// compiled member node returning call3703 (depth = 4)
  partcv[0] = 0;
  Object call3704 = callmethodflags(call3703, "end", 1, partcv, params, 0);
  gc_frame_end(callframe3701);
// compiled member node returning call3704 (depth = 3)
  gc_frame_end(frame);
  return call3704;
}
Object meth_ast_3705_isLegalInTrait(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isLegalInTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 876
  setline(876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3706 = alloc_Boolean(1);
// compiled identifier node returning bool3706 (depth = 3)
  gc_frame_end(frame);
  return bool3706;
}
Object meth_ast_3707_isTypeDec(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTypeDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 877
  setline(877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3708 = alloc_Boolean(1);
// compiled identifier node returning bool3708 (depth = 3)
  gc_frame_end(frame);
  return bool3708;
}
Object meth_ast_3709_scope_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 881
  setline(881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3710 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call3711 = callmethodflags(self, "symbolTable:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3710);
// compiled call node returning call3711 (depth = 3)
// Begin line 882
  setline(882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3712 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call3713 = callmethodflags(*var_st, "node:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3712);
// compiled call node returning call3713 (depth = 3)
  gc_frame_end(frame);
  return call3713;
}
Object meth_ast_3714_isExecutable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 885
  setline(885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3715 = alloc_Boolean(1);
// compiled identifier node returning bool3715 (depth = 3)
  gc_frame_end(frame);
  return bool3715;
}
Object meth_ast_3716_declarationKindWithAncestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 886
  setline(886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3717 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  partcv[0] = 0;
  Object call3718 = callmethodflags(*var_k, "typeparam", 1, partcv, params, 0);
  gc_frame_end(callframe3717);
// compiled member node returning call3718 (depth = 3)
  gc_frame_end(frame);
  return call3718;
}
Object meth_ast_3719_isConfidential(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isConfidential");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3722 = alloc_Float64(0);
// compiled num node returning num3722 (depth = 5)
  int op_slot_right_3721 = gc_frame_newslot(num3722);
// starting to compile member node (depth = 5)
  int callframe3724 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3725 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3726 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3725);
// compiled member node returning call3726 (depth = 6)
  partcv[0] = 0;
  Object call3727 = callmethodflags(call3726, "size", 1, partcv, params, 0);
  gc_frame_end(callframe3724);
// compiled member node returning call3727 (depth = 5)
  int op_slot_left_3721 = gc_frame_newslot(call3727);
  params[0] = num3722;
  partcv[0] = 1;
  Object opresult3728 = callmethod(call3727, "==(1)", 1, partcv, params);
// compiled op node returning opresult3728 (depth = 4)
  Object if3720 = done;
  if (istrue(opresult3728)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool3729 = alloc_Boolean(0);
// compiled identifier node returning bool3729 (depth = 5)
  return bool3729;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if3720 = undefined;
  } else {
  }
// compiled if node returning if3720 (depth = 3)
// Begin line 889
  setline(889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3730 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit3731 == NULL) {
    strlit3731 = alloc_String("confidential");
    gc_root(strlit3731);
  }
// compiled string node returning strlit3731 (depth = 4)
  gc_frame_newslot(strlit3731);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  params[1] = strlit3731;
  partcv[0] = 2;
  Object call3732 = callmethodflags(module_ast, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3730);
// compiled call node returning call3732 (depth = 3)
  gc_frame_end(frame);
  return call3732;
}
Object meth_ast_3733_isPublic(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3734 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3735 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3736 = callmethodflags(self, "isConfidential", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3735);
// compiled member node returning call3736 (depth = 4)
  partcv[0] = 0;
  Object call3737 = callmethodflags(call3736, "not", 1, partcv, params, 0);
  gc_frame_end(callframe3734);
// compiled member node returning call3737 (depth = 3)
  gc_frame_end(frame);
  return call3737;
}
Object meth_ast_3738_isWritable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 892
  setline(892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3739 = alloc_Boolean(0);
// compiled identifier node returning bool3739 (depth = 3)
  gc_frame_end(frame);
  return bool3739;
}
Object meth_ast_3740_isReadable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 893
  setline(893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3741 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3742 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3741);
// compiled member node returning call3742 (depth = 3)
  gc_frame_end(frame);
  return call3742;
}
Object meth_ast_3766__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 6)
  int callframe3767 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3768 = callmethodflags(*var_each, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3767);
// compiled call node returning call3768 (depth = 6)
  gc_frame_end(frame);
  return call3768;
}
Object meth_ast_3743_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// definebindings:
// definebindings:
// definebindings:
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3745 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3746 = callmethodflags(*var_visitor, "visitTypeDec(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3745);
// compiled call node returning call3746 (depth = 4)
  Object if3744 = done;
  if (istrue(call3746)) {
// Begin line 897
  setline(897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3747 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call3748 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3747);
// compiled call node returning call3748 (depth = 5)
  *var_newChain = call3748;
  if (call3748 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 898
  setline(898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3749 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3750 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3751 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3750);
// compiled member node returning call3751 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3752 = callmethodflags(call3751, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3749);
// compiled call node returning call3752 (depth = 4)
// Begin line 899
  setline(899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3755 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3756 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3755);
// compiled member node returning call3756 (depth = 6)
  int op_slot_right_3754 = gc_frame_newslot(call3756);
// starting to compile identifier node (depth = 6)
  Object bool3758 = alloc_Boolean(0);
// compiled identifier node returning bool3758 (depth = 6)
  int op_slot_left_3754 = gc_frame_newslot(bool3758);
  params[0] = call3756;
  partcv[0] = 1;
  Object opresult3759 = callmethod(bool3758, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3759 (depth = 5)
  Object if3753 = done;
  if (istrue(opresult3759)) {
// Begin line 900
  setline(900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3760 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3761 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3762 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3761);
// compiled member node returning call3762 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3763 = callmethodflags(call3762, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3760);
// compiled call node returning call3763 (depth = 5)
    gc_frame_newslot(call3763);
    if3753 = call3763;
  } else {
  }
// compiled if node returning if3753 (depth = 4)
// Begin line 902
  setline(902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3764 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block3765 = alloc_Block(NULL, NULL, "ast", 902);
  gc_frame_newslot(block3765);
// method "_apply(_)"
  block_savedest(block3765);
  Object closure3766 = createclosure(3, "_apply(1)");
  setclosureframe(closure3766, stackframe);
  addtoclosure(closure3766, var_visitor);
  addtoclosure(closure3766, var_newChain);
  addtoclosure(closure3766, selfslot);
  struct UserObject *uo3766 = (struct UserObject*)block3765;
  uo3766->data[0] = (Object)closure3766;
  Method *meth_meth_ast_3766__apply_40_1_41_ = addmethod2pos(block3765, "_apply(1)", &meth_ast_3766__apply_40_1_41_, 0);
  int argcv_meth_ast_3766__apply_40_1_41_[] = {1};
  meth_meth_ast_3766__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3766__apply_40_1_41_);
  meth_meth_ast_3766__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3766__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block3765 (depth = 5)
  gc_frame_newslot(block3765);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3770 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3771 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3770);
// compiled member node returning call3771 (depth = 5)
  params[0] = block3765;
  partcv[0] = 1;
  Object call3772 = callmethodflags(call3771, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3764);
// compiled call node returning call3772 (depth = 4)
// Begin line 903
  setline(903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3773 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3774 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3775 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3774);
// compiled member node returning call3775 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3776 = callmethodflags(call3775, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3773);
// compiled call node returning call3776 (depth = 4)
    gc_frame_newslot(call3776);
    if3744 = call3776;
  } else {
  }
// compiled if node returning if3744 (depth = 3)
  gc_frame_end(frame);
  return if3744;
}
Object meth_ast_3777_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 907
  setline(907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3778 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3779 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3778);
// compiled member node returning call3779 (depth = 4)
  *var_n = call3779;
  if (call3779 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 908
  setline(908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3780 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3781 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3780);
// compiled call node returning call3781 (depth = 4)
  *var_newChain = call3781;
  if (call3781 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 909
  setline(909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3782 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3783 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3784 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3785 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3784);
// compiled member node returning call3785 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3786 = callmethodflags(call3785, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3783);
// compiled call node returning call3786 (depth = 4)
  gc_frame_newslot(call3786);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3786;
  partcv[0] = 1;
  Object call3787 = callmethodflags(*var_n, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3782);
// compiled call node returning call3787 (depth = 3)
// Begin line 910
  setline(910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3788 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3789 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3790 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3791 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3790);
// compiled member node returning call3791 (depth = 5)
  gc_frame_newslot(call3791);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call3791;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3792 = callmethodflags(module_ast, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3789);
// compiled call node returning call3792 (depth = 4)
  gc_frame_newslot(call3792);
// call case 6: other requests
// Begin line 910
  setline(910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3792;
  partcv[0] = 1;
  Object call3793 = callmethodflags(*var_n, "typeParams:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3788);
// compiled call node returning call3793 (depth = 3)
// Begin line 911
  setline(911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3794 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3795 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3796 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3797 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3796);
// compiled member node returning call3797 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3798 = callmethodflags(call3797, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3795);
// compiled call node returning call3798 (depth = 4)
  gc_frame_newslot(call3798);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3798;
  partcv[0] = 1;
  Object call3799 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3794);
// compiled call node returning call3799 (depth = 3)
// Begin line 912
  setline(912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3800 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3801 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3802 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3803 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3802);
// compiled member node returning call3803 (depth = 5)
  gc_frame_newslot(call3803);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call3803;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3804 = callmethodflags(module_ast, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3801);
// compiled call node returning call3804 (depth = 4)
  gc_frame_newslot(call3804);
// call case 6: other requests
// Begin line 912
  setline(912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3804;
  partcv[0] = 1;
  Object call3805 = callmethodflags(*var_n, "annotations:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3800);
// compiled call node returning call3805 (depth = 3)
// Begin line 913
  setline(913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3806 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call3807 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3806);
// compiled call node returning call3807 (depth = 3)
  gc_frame_end(frame);
  return call3807;
}
Object meth_ast_3808_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 916
  setline(916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3811 = alloc_Float64(1);
// compiled num node returning num3811 (depth = 6)
  int op_slot_right_3810 = gc_frame_newslot(num3811);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_3810 = gc_frame_newslot(*var_depth);
  params[0] = num3811;
  partcv[0] = 1;
  Object sum3813 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3813 (depth = 5)
  int op_slot_right_3809 = gc_frame_newslot(sum3813);
// starting to compile string node (depth = 5)
  if (strlit3815 == NULL) {
    strlit3815 = alloc_String("  ");
    gc_root(strlit3815);
  }
// compiled string node returning strlit3815 (depth = 5)
  int op_slot_left_3809 = gc_frame_newslot(strlit3815);
  params[0] = sum3813;
  partcv[0] = 1;
  Object prod3816 = callmethod(strlit3815, "*(1)", 1, partcv, params);
// compiled op node returning prod3816 (depth = 4)
  *var_spc = prod3816;
  if (prod3816 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 917
  setline(917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3818 == NULL) {
    strlit3818 = alloc_String("""\x0a""");
    gc_root(strlit3818);
  }
// compiled string node returning strlit3818 (depth = 5)
  int op_slot_right_3817 = gc_frame_newslot(strlit3818);
// starting to compile call node (depth = 5)
  int callframe3820 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call3821 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3820);
// compiled call node returning call3821 (depth = 5)
  int op_slot_left_3817 = gc_frame_newslot(call3821);
  params[0] = strlit3818;
  partcv[0] = 1;
  Object opresult3822 = callmethod(call3821, "++(1)", 1, partcv, params);
// compiled op node returning opresult3822 (depth = 4)
  *var_s = opresult3822;
  if (opresult3822 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 918
  setline(918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3824 == NULL) {
    strlit3824 = alloc_String("""\x0a""");
    gc_root(strlit3824);
  }
// compiled string node returning strlit3824 (depth = 5)
  int op_slot_right_3823 = gc_frame_newslot(strlit3824);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3827 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3829 = alloc_Float64(1);
// compiled num node returning num3829 (depth = 8)
  int op_slot_right_3828 = gc_frame_newslot(num3829);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_3828 = gc_frame_newslot(*var_depth);
  params[0] = num3829;
  partcv[0] = 1;
  Object sum3831 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3831 (depth = 7)
  gc_frame_newslot(sum3831);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3832 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3833 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3832);
// compiled member node returning call3833 (depth = 7)
  params[0] = sum3831;
  partcv[0] = 1;
  Object call3834 = callmethodflags(call3833, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3827);
// compiled call node returning call3834 (depth = 6)
  int op_slot_right_3826 = gc_frame_newslot(call3834);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_3836 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3836 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3838 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3838 (depth = 6)
  int op_slot_left_3826 = gc_frame_newslot(opresult3838);
  params[0] = call3834;
  partcv[0] = 1;
  Object opresult3839 = callmethod(opresult3838, "++(1)", 1, partcv, params);
// compiled op node returning opresult3839 (depth = 5)
  int op_slot_left_3823 = gc_frame_newslot(opresult3839);
  params[0] = strlit3824;
  partcv[0] = 1;
  Object opresult3840 = callmethod(opresult3839, "++(1)", 1, partcv, params);
// compiled op node returning opresult3840 (depth = 4)
  *var_s = opresult3840;
  if (opresult3840 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 919
  setline(919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3844 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3845 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3844);
// compiled member node returning call3845 (depth = 5)
  int op_slot_right_3843 = gc_frame_newslot(call3845);
// starting to compile identifier node (depth = 5)
  Object bool3847 = alloc_Boolean(0);
// compiled identifier node returning bool3847 (depth = 5)
  int op_slot_left_3843 = gc_frame_newslot(bool3847);
  params[0] = call3845;
  partcv[0] = 1;
  Object opresult3848 = callmethod(bool3847, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3848 (depth = 4)
  Object if3842 = done;
  if (istrue(opresult3848)) {
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3850 == NULL) {
    strlit3850 = alloc_String("""\x0a""");
    gc_root(strlit3850);
  }
// compiled string node returning strlit3850 (depth = 6)
  int op_slot_right_3849 = gc_frame_newslot(strlit3850);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3853 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3855 = alloc_Float64(2);
// compiled num node returning num3855 (depth = 9)
  int op_slot_right_3854 = gc_frame_newslot(num3855);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3854 = gc_frame_newslot(*var_depth);
  params[0] = num3855;
  partcv[0] = 1;
  Object sum3857 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3857 (depth = 8)
  gc_frame_newslot(sum3857);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3858 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3859 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3858);
// compiled member node returning call3859 (depth = 8)
  params[0] = sum3857;
  partcv[0] = 1;
  Object call3860 = callmethodflags(call3859, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3853);
// compiled call node returning call3860 (depth = 7)
  int op_slot_right_3852 = gc_frame_newslot(call3860);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3863 == NULL) {
    strlit3863 = alloc_String("Type parameters:""\x0a""");
    gc_root(strlit3863);
  }
// compiled string node returning strlit3863 (depth = 8)
  int op_slot_right_3862 = gc_frame_newslot(strlit3863);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_3865 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3868 == NULL) {
    strlit3868 = alloc_String("");
    gc_root(strlit3868);
  }
// compiled string node returning strlit3868 (depth = 10)
  int op_slot_right_3867 = gc_frame_newslot(strlit3868);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_3870 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit3872 == NULL) {
    strlit3872 = alloc_String("");
    gc_root(strlit3872);
  }
// compiled string node returning strlit3872 (depth = 11)
  int op_slot_left_3870 = gc_frame_newslot(strlit3872);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3873 = callmethod(strlit3872, "++(1)", 1, partcv, params);
// compiled op node returning opresult3873 (depth = 10)
  int op_slot_left_3867 = gc_frame_newslot(opresult3873);
  params[0] = strlit3868;
  partcv[0] = 1;
  Object opresult3874 = callmethod(opresult3873, "++(1)", 1, partcv, params);
// compiled op node returning opresult3874 (depth = 9)
  int op_slot_left_3865 = gc_frame_newslot(opresult3874);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3875 = callmethod(opresult3874, "++(1)", 1, partcv, params);
// compiled op node returning opresult3875 (depth = 8)
  int op_slot_left_3862 = gc_frame_newslot(opresult3875);
  params[0] = strlit3863;
  partcv[0] = 1;
  Object opresult3876 = callmethod(opresult3875, "++(1)", 1, partcv, params);
// compiled op node returning opresult3876 (depth = 7)
  int op_slot_left_3852 = gc_frame_newslot(opresult3876);
  params[0] = call3860;
  partcv[0] = 1;
  Object opresult3877 = callmethod(opresult3876, "++(1)", 1, partcv, params);
// compiled op node returning opresult3877 (depth = 6)
  int op_slot_left_3849 = gc_frame_newslot(opresult3877);
  params[0] = strlit3850;
  partcv[0] = 1;
  Object opresult3878 = callmethod(opresult3877, "++(1)", 1, partcv, params);
// compiled op node returning opresult3878 (depth = 5)
  *var_s = opresult3878;
  if (opresult3878 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if3842 = done;
  } else {
  }
// compiled if node returning if3842 (depth = 3)
// Begin line 922
  setline(922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3881 == NULL) {
    strlit3881 = alloc_String("Value:");
    gc_root(strlit3881);
  }
// compiled string node returning strlit3881 (depth = 5)
  int op_slot_right_3880 = gc_frame_newslot(strlit3881);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_3883 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_3883 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3885 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3885 (depth = 5)
  int op_slot_left_3880 = gc_frame_newslot(opresult3885);
  params[0] = strlit3881;
  partcv[0] = 1;
  Object opresult3886 = callmethod(opresult3885, "++(1)", 1, partcv, params);
// compiled op node returning opresult3886 (depth = 4)
  *var_s = opresult3886;
  if (opresult3886 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3889 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3891 = alloc_Float64(2);
// compiled num node returning num3891 (depth = 7)
  int op_slot_right_3890 = gc_frame_newslot(num3891);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_3890 = gc_frame_newslot(*var_depth);
  params[0] = num3891;
  partcv[0] = 1;
  Object sum3893 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3893 (depth = 6)
  gc_frame_newslot(sum3893);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3894 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3895 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3894);
// compiled member node returning call3895 (depth = 6)
  params[0] = sum3893;
  partcv[0] = 1;
  Object call3896 = callmethodflags(call3895, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3889);
// compiled call node returning call3896 (depth = 5)
  int op_slot_right_3888 = gc_frame_newslot(call3896);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3888 = gc_frame_newslot(*var_s);
  params[0] = call3896;
  partcv[0] = 1;
  Object opresult3898 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3898 (depth = 4)
  *var_s = opresult3898;
  if (opresult3898 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 924
  setline(924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3901 == NULL) {
    strlit3901 = alloc_String("""\x0a""");
    gc_root(strlit3901);
  }
// compiled string node returning strlit3901 (depth = 5)
  int op_slot_right_3900 = gc_frame_newslot(strlit3901);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3900 = gc_frame_newslot(*var_s);
  params[0] = strlit3901;
  partcv[0] = 1;
  Object opresult3903 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3903 (depth = 4)
  *var_s = opresult3903;
  if (opresult3903 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 925
  setline(925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3907 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3908 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3907);
// compiled member node returning call3908 (depth = 5)
  int op_slot_right_3906 = gc_frame_newslot(call3908);
// starting to compile identifier node (depth = 5)
  Object bool3910 = alloc_Boolean(0);
// compiled identifier node returning bool3910 (depth = 5)
  int op_slot_left_3906 = gc_frame_newslot(bool3910);
  params[0] = call3908;
  partcv[0] = 1;
  Object opresult3911 = callmethod(bool3910, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3911 (depth = 4)
  Object if3905 = done;
  if (istrue(opresult3911)) {
// Begin line 926
  setline(926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3913 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3915 = alloc_Float64(2);
// compiled num node returning num3915 (depth = 8)
  int op_slot_right_3914 = gc_frame_newslot(num3915);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_3914 = gc_frame_newslot(*var_depth);
  params[0] = num3915;
  partcv[0] = 1;
  Object sum3917 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3917 (depth = 7)
  gc_frame_newslot(sum3917);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3918 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3919 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3918);
// compiled member node returning call3919 (depth = 7)
  params[0] = sum3917;
  partcv[0] = 1;
  Object call3920 = callmethodflags(call3919, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3913);
// compiled call node returning call3920 (depth = 6)
  int op_slot_right_3912 = gc_frame_newslot(call3920);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_3912 = gc_frame_newslot(*var_s);
  params[0] = call3920;
  partcv[0] = 1;
  Object opresult3922 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3922 (depth = 5)
  *var_s = opresult3922;
  if (opresult3922 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if3905 = done;
  } else {
  }
// compiled if node returning if3905 (depth = 3)
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_3924_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// definebindings:
// definebindings:
// Begin line 931
  setline(931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_3925 = gc_frame_newslot(*var_depth);
// starting to compile string node (depth = 5)
  if (strlit3927 == NULL) {
    strlit3927 = alloc_String("    ");
    gc_root(strlit3927);
  }
// compiled string node returning strlit3927 (depth = 5)
  int op_slot_left_3925 = gc_frame_newslot(strlit3927);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object prod3928 = callmethod(strlit3927, "*(1)", 1, partcv, params);
// compiled op node returning prod3928 (depth = 4)
  *var_spc = prod3928;
  if (prod3928 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 932
  setline(932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3929 == NULL) {
    strlit3929 = alloc_String("");
    gc_root(strlit3929);
  }
// compiled string node returning strlit3929 (depth = 4)
  *var_s = strlit3929;
  if (strlit3929 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 933
  setline(933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3931 == NULL) {
    strlit3931 = alloc_String("");
    gc_root(strlit3931);
  }
// compiled string node returning strlit3931 (depth = 5)
  int op_slot_right_3930 = gc_frame_newslot(strlit3931);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3934 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3935 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3934);
// compiled member node returning call3935 (depth = 6)
  int op_slot_right_3933 = gc_frame_newslot(call3935);
// starting to compile string node (depth = 6)
  if (strlit3937 == NULL) {
    strlit3937 = alloc_String("type ");
    gc_root(strlit3937);
  }
// compiled string node returning strlit3937 (depth = 6)
  int op_slot_left_3933 = gc_frame_newslot(strlit3937);
  params[0] = call3935;
  partcv[0] = 1;
  Object opresult3938 = callmethod(strlit3937, "++(1)", 1, partcv, params);
// compiled op node returning opresult3938 (depth = 5)
  int op_slot_left_3930 = gc_frame_newslot(opresult3938);
  params[0] = strlit3931;
  partcv[0] = 1;
  Object opresult3939 = callmethod(opresult3938, "++(1)", 1, partcv, params);
// compiled op node returning opresult3939 (depth = 4)
  *var_s = opresult3939;
  if (opresult3939 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 934
  setline(934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3943 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3944 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3943);
// compiled member node returning call3944 (depth = 5)
  int op_slot_right_3942 = gc_frame_newslot(call3944);
// starting to compile identifier node (depth = 5)
  Object bool3946 = alloc_Boolean(0);
// compiled identifier node returning bool3946 (depth = 5)
  int op_slot_left_3942 = gc_frame_newslot(bool3946);
  params[0] = call3944;
  partcv[0] = 1;
  Object opresult3947 = callmethod(bool3946, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3947 (depth = 4)
  Object if3941 = done;
  if (istrue(opresult3947)) {
// Begin line 935
  setline(935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3948 = gc_frame_new();
// starting to compile num node (depth = 5)
  Object num3949 = alloc_Float64(0);
// compiled num node returning num3949 (depth = 5)
  gc_frame_newslot(num3949);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3950 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3951 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3950);
// compiled member node returning call3951 (depth = 5)
  params[0] = num3949;
  partcv[0] = 1;
  Object call3952 = callmethodflags(call3951, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3948);
// compiled call node returning call3952 (depth = 4)
    gc_frame_newslot(call3952);
    if3941 = call3952;
  } else {
  }
// compiled if node returning if3941 (depth = 3)
// Begin line 937
  setline(937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3954 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3956 = alloc_Float64(2);
// compiled num node returning num3956 (depth = 6)
  int op_slot_right_3955 = gc_frame_newslot(num3956);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_3955 = gc_frame_newslot(*var_depth);
  params[0] = num3956;
  partcv[0] = 1;
  Object sum3958 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3958 (depth = 5)
  gc_frame_newslot(sum3958);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3959 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3960 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3959);
// compiled member node returning call3960 (depth = 5)
  params[0] = sum3958;
  partcv[0] = 1;
  Object call3961 = callmethodflags(call3960, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3954);
// compiled call node returning call3961 (depth = 4)
  int op_slot_right_3953 = gc_frame_newslot(call3961);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3964 == NULL) {
    strlit3964 = alloc_String(" = ");
    gc_root(strlit3964);
  }
// compiled string node returning strlit3964 (depth = 5)
  int op_slot_right_3963 = gc_frame_newslot(strlit3964);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3963 = gc_frame_newslot(*var_s);
  params[0] = strlit3964;
  partcv[0] = 1;
  Object opresult3966 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3966 (depth = 4)
  int op_slot_left_3953 = gc_frame_newslot(opresult3966);
  params[0] = call3961;
  partcv[0] = 1;
  Object opresult3967 = callmethod(opresult3966, "++(1)", 1, partcv, params);
// compiled op node returning opresult3967 (depth = 3)
  gc_frame_end(frame);
  return opresult3967;
}
Object meth_ast_3968_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_typeDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3969 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe3970 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3971 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3972 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3971);
// compiled member node returning call3972 (depth = 5)
  gc_frame_newslot(call3972);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeDecNode (depth = 5)
  params[0] = call3972;
  params[1] = *var_nullNode;
  partcv[0] = 2;
  Object call3973 = callmethodflags(*var_typeDecNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3970);
// compiled call node returning call3973 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call3974 = callmethodflags(call3973, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3969);
// compiled call node returning call3974 (depth = 3)
  gc_frame_end(frame);
  return call3974;
}
Object meth_ast_3975_postCopy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "postCopy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method postCopy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for postCopy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part postCopy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 943
  setline(943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3976 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3977 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call3978 = callmethodflags(*var_other, "parentKind", 1, partcv, params, 0);
  gc_frame_end(callframe3977);
// compiled member node returning call3978 (depth = 4)
  gc_frame_newslot(call3978);
// call case 4: self request
  params[0] = call3978;
  partcv[0] = 1;
  Object call3979 = callmethodflags(self, "parentKind:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3976);
// compiled call node returning call3979 (depth = 3)
// Begin line 944
  setline(944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_3690_new_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_typeDecNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_typeValue = &(stackframe->slots[1]);
  *var_typeValue = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3691 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3691 = alloc_userobj2(28,24, objclass3691);
  gc_frame_newslot(obj3691);
  if (objclass3691 == NULL) {
    glfree(obj3691->class->name);
    obj3691->class->name = "typeDecNode.new(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3691, self, 0);
  addmethodreal(obj3691,"outer", &reader_ast_outer_3692);
  Object oldself3691 = self;
  struct StackFrameObject *oldstackframe3691 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3691);
  gc_frame_newslot((Object)stackframe);
  self = obj3691;
  Object *oldselfslot3691 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3691 = (*(struct UserObject *)self).data[0], lowerouter3691 = thisouter3691;
  if (inheritingObject3691) {
    struct UserObject *inho3691 = (struct UserObject *)inheritingObject3691;
    while (inho3691->super != GraceDefaultObject) inho3691 = (struct UserObject *)inho3691->super;
    inho3691->super = obj3691;
    self = inheritingObject3691;
    *selfslot = self;
    lowerouter3691 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3691;
  }
  if (objclass3691 == NULL) {
  Method *reader3693 = addmethodrealflags(obj3691, "kind",&reader_ast_kind_3693, MFLAG_DEF);
  reader3693->definitionModule = modulename;
  reader3693->definitionLine = 867;
  }
  adddatum2(obj3691, alloc_Undefined(), 1);
  if (objclass3691 == NULL) {
    Method *reader3694 = addmethodrealflags(obj3691, "name", &reader_ast_name_3694, 0);
    Method *writer3694 = addmethodrealflags(obj3691, "name:=(1)", &writer_ast_name_3694, 0);
    reader3694->definitionModule = modulename;
    writer3694->definitionModule = modulename;
    reader3694->definitionLine = 868;
    writer3694->definitionLine = 868;
  }
  obj3691->flags |= OFLAG_MUTABLE;
  adddatum2(obj3691, alloc_Undefined(), 2);
  if (objclass3691 == NULL) {
    Method *reader3695 = addmethodrealflags(obj3691, "value", &reader_ast_value_3695, 0);
    Method *writer3695 = addmethodrealflags(obj3691, "value:=(1)", &writer_ast_value_3695, 0);
    reader3695->definitionModule = modulename;
    writer3695->definitionModule = modulename;
    reader3695->definitionLine = 869;
    writer3695->definitionLine = 869;
  }
  obj3691->flags |= OFLAG_MUTABLE;
  adddatum2(obj3691, alloc_Undefined(), 3);
  if (objclass3691 == NULL) {
    Method *reader3696 = addmethodrealflags(obj3691, "parentKind", &reader_ast_parentKind_3696, 0);
    Method *writer3696 = addmethodrealflags(obj3691, "parentKind:=(1)", &writer_ast_parentKind_3696, 0);
    reader3696->definitionModule = modulename;
    writer3696->definitionModule = modulename;
    reader3696->definitionLine = 870;
    writer3696->definitionLine = 870;
  }
  obj3691->flags |= OFLAG_MUTABLE;
  adddatum2(obj3691, alloc_Undefined(), 4);
  if (objclass3691 == NULL) {
  Method *reader3697 = addmethodrealflags(obj3691, "nameString",&reader_ast_nameString_3697, MFLAG_DEF);
  reader3697->definitionModule = modulename;
  reader3697->definitionLine = 871;
  }
  adddatum2(obj3691, alloc_Undefined(), 5);
  if (objclass3691 == NULL) {
    Method *reader3698 = addmethodrealflags(obj3691, "annotations", &reader_ast_annotations_3698, 0);
    Method *writer3698 = addmethodrealflags(obj3691, "annotations:=(1)", &writer_ast_annotations_3698, 0);
    reader3698->definitionModule = modulename;
    writer3698->definitionModule = modulename;
    reader3698->definitionLine = 872;
    writer3698->definitionLine = 872;
  }
  obj3691->flags |= OFLAG_MUTABLE;
  adddatum2(obj3691, alloc_Undefined(), 6);
  if (objclass3691 == NULL) {
    Method *reader3699 = addmethodrealflags(obj3691, "typeParams", &reader_ast_typeParams_3699, 0);
    Method *writer3699 = addmethodrealflags(obj3691, "typeParams:=(1)", &writer_ast_typeParams_3699, 0);
    reader3699->definitionModule = modulename;
    writer3699->definitionModule = modulename;
    reader3699->definitionLine = 873;
    writer3699->definitionLine = 873;
  }
  obj3691->flags |= OFLAG_MUTABLE;
  adddatum2(obj3691, alloc_Undefined(), 7);
// method "end"
  struct UserObject *uo3700 = (struct UserObject*)obj3691;
  uo3700->data[8] = emptyclosure;
  Method *meth_meth_ast_3700_end = addmethod2pos(obj3691, "end", &meth_ast_3700_end, 8);
  int argcv_meth_ast_3700_end[] = {0};
  meth_meth_ast_3700_end->type = alloc_MethodType(1, argcv_meth_ast_3700_end);
  meth_meth_ast_3700_end->definitionModule = modulename;
  meth_meth_ast_3700_end->definitionLine = 875;
// method "isLegalInTrait"
  struct UserObject *uo3705 = (struct UserObject*)obj3691;
  uo3705->data[9] = emptyclosure;
  Method *meth_meth_ast_3705_isLegalInTrait = addmethod2pos(obj3691, "isLegalInTrait", &meth_ast_3705_isLegalInTrait, 9);
  int argcv_meth_ast_3705_isLegalInTrait[] = {0};
  meth_meth_ast_3705_isLegalInTrait->type = alloc_MethodType(1, argcv_meth_ast_3705_isLegalInTrait);
  meth_meth_ast_3705_isLegalInTrait->definitionModule = modulename;
  meth_meth_ast_3705_isLegalInTrait->definitionLine = 876;
// method "isTypeDec"
  struct UserObject *uo3707 = (struct UserObject*)obj3691;
  uo3707->data[10] = emptyclosure;
  Method *meth_meth_ast_3707_isTypeDec = addmethod2pos(obj3691, "isTypeDec", &meth_ast_3707_isTypeDec, 10);
  int argcv_meth_ast_3707_isTypeDec[] = {0};
  meth_meth_ast_3707_isTypeDec->type = alloc_MethodType(1, argcv_meth_ast_3707_isTypeDec);
  meth_meth_ast_3707_isTypeDec->definitionModule = modulename;
  meth_meth_ast_3707_isTypeDec->definitionLine = 877;
// method "scope:=(_)"
  struct UserObject *uo3709 = (struct UserObject*)obj3691;
  uo3709->data[11] = emptyclosure;
  Method *meth_meth_ast_3709_scope_58__61__40_1_41_ = addmethod2pos(obj3691, "scope:=(1)", &meth_ast_3709_scope_58__61__40_1_41_, 11);
  int argcv_meth_ast_3709_scope_58__61__40_1_41_[] = {1};
  meth_meth_ast_3709_scope_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3709_scope_58__61__40_1_41_);
  meth_meth_ast_3709_scope_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_3709_scope_58__61__40_1_41_->definitionLine = 878;
// method "isExecutable"
  struct UserObject *uo3714 = (struct UserObject*)obj3691;
  uo3714->data[12] = emptyclosure;
  Method *meth_meth_ast_3714_isExecutable = addmethod2pos(obj3691, "isExecutable", &meth_ast_3714_isExecutable, 12);
  int argcv_meth_ast_3714_isExecutable[] = {0};
  meth_meth_ast_3714_isExecutable->type = alloc_MethodType(1, argcv_meth_ast_3714_isExecutable);
  meth_meth_ast_3714_isExecutable->definitionModule = modulename;
  meth_meth_ast_3714_isExecutable->definitionLine = 885;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj3691);
  Object closure3716 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure3716, stackframe);
  addtoclosure(closure3716, var_k);
  struct UserObject *uo3716 = (struct UserObject*)obj3691;
  uo3716->data[13] = (Object)closure3716;
  Method *meth_meth_ast_3716_declarationKindWithAncestors_40_1_41_ = addmethod2pos(obj3691, "declarationKindWithAncestors(1)", &meth_ast_3716_declarationKindWithAncestors_40_1_41_, 13);
  int argcv_meth_ast_3716_declarationKindWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_3716_declarationKindWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3716_declarationKindWithAncestors_40_1_41_);
  meth_meth_ast_3716_declarationKindWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3716_declarationKindWithAncestors_40_1_41_->definitionLine = 886;
// method "isConfidential"
  struct UserObject *uo3719 = (struct UserObject*)obj3691;
  uo3719->data[14] = emptyclosure;
  Method *meth_meth_ast_3719_isConfidential = addmethod2pos(obj3691, "isConfidential", &meth_ast_3719_isConfidential, 14);
  int argcv_meth_ast_3719_isConfidential[] = {0};
  meth_meth_ast_3719_isConfidential->type = alloc_MethodType(1, argcv_meth_ast_3719_isConfidential);
  meth_meth_ast_3719_isConfidential->definitionModule = modulename;
  meth_meth_ast_3719_isConfidential->definitionLine = 887;
// method "isPublic"
  struct UserObject *uo3733 = (struct UserObject*)obj3691;
  uo3733->data[15] = emptyclosure;
  Method *meth_meth_ast_3733_isPublic = addmethod2pos(obj3691, "isPublic", &meth_ast_3733_isPublic, 15);
  int argcv_meth_ast_3733_isPublic[] = {0};
  meth_meth_ast_3733_isPublic->type = alloc_MethodType(1, argcv_meth_ast_3733_isPublic);
  meth_meth_ast_3733_isPublic->definitionModule = modulename;
  meth_meth_ast_3733_isPublic->definitionLine = 891;
// method "isWritable"
  struct UserObject *uo3738 = (struct UserObject*)obj3691;
  uo3738->data[16] = emptyclosure;
  Method *meth_meth_ast_3738_isWritable = addmethod2pos(obj3691, "isWritable", &meth_ast_3738_isWritable, 16);
  int argcv_meth_ast_3738_isWritable[] = {0};
  meth_meth_ast_3738_isWritable->type = alloc_MethodType(1, argcv_meth_ast_3738_isWritable);
  meth_meth_ast_3738_isWritable->definitionModule = modulename;
  meth_meth_ast_3738_isWritable->definitionLine = 892;
// method "isReadable"
  struct UserObject *uo3740 = (struct UserObject*)obj3691;
  uo3740->data[17] = emptyclosure;
  Method *meth_meth_ast_3740_isReadable = addmethod2pos(obj3691, "isReadable", &meth_ast_3740_isReadable, 17);
  int argcv_meth_ast_3740_isReadable[] = {0};
  meth_meth_ast_3740_isReadable->type = alloc_MethodType(1, argcv_meth_ast_3740_isReadable);
  meth_meth_ast_3740_isReadable->definitionModule = modulename;
  meth_meth_ast_3740_isReadable->definitionLine = 893;
// method "accept(_)from(_)"
  struct UserObject *uo3743 = (struct UserObject*)obj3691;
  uo3743->data[18] = emptyclosure;
  Method *meth_meth_ast_3743_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj3691, "accept(1)from(1)", &meth_ast_3743_accept_40_1_41_from_40_1_41_, 18);
  int argcv_meth_ast_3743_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_3743_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_3743_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_3743_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3743_accept_40_1_41_from_40_1_41_->definitionLine = 895;
// method "map(_)ancestors(_)"
  struct UserObject *uo3777 = (struct UserObject*)obj3691;
  uo3777->data[19] = emptyclosure;
  Method *meth_meth_ast_3777_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj3691, "map(1)ancestors(1)", &meth_ast_3777_map_40_1_41_ancestors_40_1_41_, 19);
  int argcv_meth_ast_3777_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_3777_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_3777_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_3777_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3777_map_40_1_41_ancestors_40_1_41_->definitionLine = 906;
// method "pretty(_)"
  struct UserObject *uo3808 = (struct UserObject*)obj3691;
  uo3808->data[20] = emptyclosure;
  Method *meth_meth_ast_3808_pretty_40_1_41_ = addmethod2pos(obj3691, "pretty(1)", &meth_ast_3808_pretty_40_1_41_, 20);
  int argcv_meth_ast_3808_pretty_40_1_41_[] = {1};
  meth_meth_ast_3808_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3808_pretty_40_1_41_);
  meth_meth_ast_3808_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3808_pretty_40_1_41_->definitionLine = 915;
// method "toGrace(_)"
  struct UserObject *uo3924 = (struct UserObject*)obj3691;
  uo3924->data[21] = emptyclosure;
  Method *meth_meth_ast_3924_toGrace_40_1_41_ = addmethod2pos(obj3691, "toGrace(1)", &meth_ast_3924_toGrace_40_1_41_, 21);
  int argcv_meth_ast_3924_toGrace_40_1_41_[] = {1};
  meth_meth_ast_3924_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3924_toGrace_40_1_41_);
meth_meth_ast_3924_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_3924_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_3924_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3924_toGrace_40_1_41_->definitionLine = 930;
// method "shallowCopy"
  block_savedest(obj3691);
  Object closure3968 = createclosure(2, "shallowCopy");
  setclosureframe(closure3968, stackframe);
  addtoclosure(closure3968, var_nullNode);
  addtoclosure(closure3968, var_typeDecNode);
  struct UserObject *uo3968 = (struct UserObject*)obj3691;
  uo3968->data[22] = (Object)closure3968;
  Method *meth_meth_ast_3968_shallowCopy = addmethod2pos(obj3691, "shallowCopy", &meth_ast_3968_shallowCopy, 22);
  int argcv_meth_ast_3968_shallowCopy[] = {0};
  meth_meth_ast_3968_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_3968_shallowCopy);
  meth_meth_ast_3968_shallowCopy->definitionModule = modulename;
  meth_meth_ast_3968_shallowCopy->definitionLine = 939;
// method "postCopy(_)"
  struct UserObject *uo3975 = (struct UserObject*)obj3691;
  uo3975->data[23] = emptyclosure;
  Method *meth_meth_ast_3975_postCopy_40_1_41_ = addmethod2pos(obj3691, "postCopy(1)", &meth_ast_3975_postCopy_40_1_41_, 23);
  int argcv_meth_ast_3975_postCopy_40_1_41_[] = {1};
  meth_meth_ast_3975_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3975_postCopy_40_1_41_);
  meth_meth_ast_3975_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3975_postCopy_40_1_41_->definitionLine = 942;
  sourceObject = obj3691;
// Begin line 866
  setline(866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3980 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3981 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3980);
// compiled call node returning call3981 (depth = 3)
  struct UserObject *obj3691_uo = (struct UserObject *)obj3691;
  obj3691_uo->super = call3981;
  sourceObject = obj3691;
// Begin line 867
  setline(867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3982 == NULL) {
    strlit3982 = alloc_String("typedec");
    gc_root(strlit3982);
  }
// compiled string node returning strlit3982 (depth = 3)
  adddatum2(obj3691, strlit3982, 1);
  sourceObject = obj3691;
// Begin line 868
  setline(868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj3691, *var_name_39_, 2);
  sourceObject = obj3691;
// Begin line 869
  setline(869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeValue (depth = 3)
  adddatum2(obj3691, *var_typeValue, 3);
  sourceObject = obj3691;
// Begin line 870
  setline(870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3983 == NULL) {
    strlit3983 = alloc_String("unset");
    gc_root(strlit3983);
  }
// compiled string node returning strlit3983 (depth = 3)
  adddatum2(obj3691, strlit3983, 4);
  sourceObject = obj3691;
// Begin line 871
  setline(871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3984 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3985 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3986 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3985);
// compiled member node returning call3986 (depth = 4)
  partcv[0] = 0;
  Object call3987 = callmethodflags(call3986, "value", 1, partcv, params, 0);
  gc_frame_end(callframe3984);
// compiled member node returning call3987 (depth = 3)
  adddatum2(obj3691, call3987, 5);
  sourceObject = obj3691;
// Begin line 872
  setline(872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array3988 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3988 (depth = 3)
  adddatum2(obj3691, array3988, 6);
  sourceObject = obj3691;
// Begin line 873
  setline(873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3989 = alloc_Boolean(0);
// compiled identifier node returning bool3989 (depth = 3)
  adddatum2(obj3691, bool3989, 7);
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  objclass3691 = obj3691->class;
  objclass3691->definitionModule = modulename;
  objclass3691->definitionLine = 865;
  (*(struct UserObject *)self).data[0] = lowerouter3691;
  self = oldself3691;
  selfslot = oldselfslot3691;
  stackframe = oldstackframe3691;
  gc_frame_end(frame);
  return obj3691;
}
Object meth_ast_3690_new_40_2_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_typeDecNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_typeValue = &(stackframe->slots[1]);
  *var_typeValue = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3691 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3691 = alloc_userobj2(28,24, objclass3691);
  gc_frame_newslot(obj3691);
  if (objclass3691 == NULL) {
    glfree(obj3691->class->name);
    obj3691->class->name = "typeDecNode.new(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3691, self, 0);
  addmethodreal(obj3691,"outer", &reader_ast_outer_3692);
  Object oldself3691 = self;
  struct StackFrameObject *oldstackframe3691 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3691);
  gc_frame_newslot((Object)stackframe);
  self = obj3691;
  Object *oldselfslot3691 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3691 = (*(struct UserObject *)self).data[0], lowerouter3691 = thisouter3691;
  if (inheritingObject3691) {
    struct UserObject *inho3691 = (struct UserObject *)inheritingObject3691;
    while (inho3691->super != GraceDefaultObject) inho3691 = (struct UserObject *)inho3691->super;
    inho3691->super = obj3691;
    self = inheritingObject3691;
    *selfslot = self;
    lowerouter3691 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3691;
  }
  if (objclass3691 == NULL) {
  Method *reader3693 = addmethodrealflags(obj3691, "kind",&reader_ast_kind_3693, MFLAG_DEF);
  reader3693->definitionModule = modulename;
  reader3693->definitionLine = 867;
  }
  adddatum2(obj3691, alloc_Undefined(), 1);
  if (objclass3691 == NULL) {
    Method *reader3694 = addmethodrealflags(obj3691, "name", &reader_ast_name_3694, 0);
    Method *writer3694 = addmethodrealflags(obj3691, "name:=(1)", &writer_ast_name_3694, 0);
    reader3694->definitionModule = modulename;
    writer3694->definitionModule = modulename;
    reader3694->definitionLine = 868;
    writer3694->definitionLine = 868;
  }
  obj3691->flags |= OFLAG_MUTABLE;
  adddatum2(obj3691, alloc_Undefined(), 2);
  if (objclass3691 == NULL) {
    Method *reader3695 = addmethodrealflags(obj3691, "value", &reader_ast_value_3695, 0);
    Method *writer3695 = addmethodrealflags(obj3691, "value:=(1)", &writer_ast_value_3695, 0);
    reader3695->definitionModule = modulename;
    writer3695->definitionModule = modulename;
    reader3695->definitionLine = 869;
    writer3695->definitionLine = 869;
  }
  obj3691->flags |= OFLAG_MUTABLE;
  adddatum2(obj3691, alloc_Undefined(), 3);
  if (objclass3691 == NULL) {
    Method *reader3696 = addmethodrealflags(obj3691, "parentKind", &reader_ast_parentKind_3696, 0);
    Method *writer3696 = addmethodrealflags(obj3691, "parentKind:=(1)", &writer_ast_parentKind_3696, 0);
    reader3696->definitionModule = modulename;
    writer3696->definitionModule = modulename;
    reader3696->definitionLine = 870;
    writer3696->definitionLine = 870;
  }
  obj3691->flags |= OFLAG_MUTABLE;
  adddatum2(obj3691, alloc_Undefined(), 4);
  if (objclass3691 == NULL) {
  Method *reader3697 = addmethodrealflags(obj3691, "nameString",&reader_ast_nameString_3697, MFLAG_DEF);
  reader3697->definitionModule = modulename;
  reader3697->definitionLine = 871;
  }
  adddatum2(obj3691, alloc_Undefined(), 5);
  if (objclass3691 == NULL) {
    Method *reader3698 = addmethodrealflags(obj3691, "annotations", &reader_ast_annotations_3698, 0);
    Method *writer3698 = addmethodrealflags(obj3691, "annotations:=(1)", &writer_ast_annotations_3698, 0);
    reader3698->definitionModule = modulename;
    writer3698->definitionModule = modulename;
    reader3698->definitionLine = 872;
    writer3698->definitionLine = 872;
  }
  obj3691->flags |= OFLAG_MUTABLE;
  adddatum2(obj3691, alloc_Undefined(), 6);
  if (objclass3691 == NULL) {
    Method *reader3699 = addmethodrealflags(obj3691, "typeParams", &reader_ast_typeParams_3699, 0);
    Method *writer3699 = addmethodrealflags(obj3691, "typeParams:=(1)", &writer_ast_typeParams_3699, 0);
    reader3699->definitionModule = modulename;
    writer3699->definitionModule = modulename;
    reader3699->definitionLine = 873;
    writer3699->definitionLine = 873;
  }
  obj3691->flags |= OFLAG_MUTABLE;
  adddatum2(obj3691, alloc_Undefined(), 7);
// method "end"
  struct UserObject *uo3700 = (struct UserObject*)obj3691;
  uo3700->data[8] = emptyclosure;
  Method *meth_meth_ast_3700_end = addmethod2pos(obj3691, "end", &meth_ast_3700_end, 8);
  int argcv_meth_ast_3700_end[] = {0};
  meth_meth_ast_3700_end->type = alloc_MethodType(1, argcv_meth_ast_3700_end);
  meth_meth_ast_3700_end->definitionModule = modulename;
  meth_meth_ast_3700_end->definitionLine = 875;
// method "isLegalInTrait"
  struct UserObject *uo3705 = (struct UserObject*)obj3691;
  uo3705->data[9] = emptyclosure;
  Method *meth_meth_ast_3705_isLegalInTrait = addmethod2pos(obj3691, "isLegalInTrait", &meth_ast_3705_isLegalInTrait, 9);
  int argcv_meth_ast_3705_isLegalInTrait[] = {0};
  meth_meth_ast_3705_isLegalInTrait->type = alloc_MethodType(1, argcv_meth_ast_3705_isLegalInTrait);
  meth_meth_ast_3705_isLegalInTrait->definitionModule = modulename;
  meth_meth_ast_3705_isLegalInTrait->definitionLine = 876;
// method "isTypeDec"
  struct UserObject *uo3707 = (struct UserObject*)obj3691;
  uo3707->data[10] = emptyclosure;
  Method *meth_meth_ast_3707_isTypeDec = addmethod2pos(obj3691, "isTypeDec", &meth_ast_3707_isTypeDec, 10);
  int argcv_meth_ast_3707_isTypeDec[] = {0};
  meth_meth_ast_3707_isTypeDec->type = alloc_MethodType(1, argcv_meth_ast_3707_isTypeDec);
  meth_meth_ast_3707_isTypeDec->definitionModule = modulename;
  meth_meth_ast_3707_isTypeDec->definitionLine = 877;
// method "scope:=(_)"
  struct UserObject *uo3709 = (struct UserObject*)obj3691;
  uo3709->data[11] = emptyclosure;
  Method *meth_meth_ast_3709_scope_58__61__40_1_41_ = addmethod2pos(obj3691, "scope:=(1)", &meth_ast_3709_scope_58__61__40_1_41_, 11);
  int argcv_meth_ast_3709_scope_58__61__40_1_41_[] = {1};
  meth_meth_ast_3709_scope_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3709_scope_58__61__40_1_41_);
  meth_meth_ast_3709_scope_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_3709_scope_58__61__40_1_41_->definitionLine = 878;
// method "isExecutable"
  struct UserObject *uo3714 = (struct UserObject*)obj3691;
  uo3714->data[12] = emptyclosure;
  Method *meth_meth_ast_3714_isExecutable = addmethod2pos(obj3691, "isExecutable", &meth_ast_3714_isExecutable, 12);
  int argcv_meth_ast_3714_isExecutable[] = {0};
  meth_meth_ast_3714_isExecutable->type = alloc_MethodType(1, argcv_meth_ast_3714_isExecutable);
  meth_meth_ast_3714_isExecutable->definitionModule = modulename;
  meth_meth_ast_3714_isExecutable->definitionLine = 885;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj3691);
  Object closure3716 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure3716, stackframe);
  addtoclosure(closure3716, var_k);
  struct UserObject *uo3716 = (struct UserObject*)obj3691;
  uo3716->data[13] = (Object)closure3716;
  Method *meth_meth_ast_3716_declarationKindWithAncestors_40_1_41_ = addmethod2pos(obj3691, "declarationKindWithAncestors(1)", &meth_ast_3716_declarationKindWithAncestors_40_1_41_, 13);
  int argcv_meth_ast_3716_declarationKindWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_3716_declarationKindWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3716_declarationKindWithAncestors_40_1_41_);
  meth_meth_ast_3716_declarationKindWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3716_declarationKindWithAncestors_40_1_41_->definitionLine = 886;
// method "isConfidential"
  struct UserObject *uo3719 = (struct UserObject*)obj3691;
  uo3719->data[14] = emptyclosure;
  Method *meth_meth_ast_3719_isConfidential = addmethod2pos(obj3691, "isConfidential", &meth_ast_3719_isConfidential, 14);
  int argcv_meth_ast_3719_isConfidential[] = {0};
  meth_meth_ast_3719_isConfidential->type = alloc_MethodType(1, argcv_meth_ast_3719_isConfidential);
  meth_meth_ast_3719_isConfidential->definitionModule = modulename;
  meth_meth_ast_3719_isConfidential->definitionLine = 887;
// method "isPublic"
  struct UserObject *uo3733 = (struct UserObject*)obj3691;
  uo3733->data[15] = emptyclosure;
  Method *meth_meth_ast_3733_isPublic = addmethod2pos(obj3691, "isPublic", &meth_ast_3733_isPublic, 15);
  int argcv_meth_ast_3733_isPublic[] = {0};
  meth_meth_ast_3733_isPublic->type = alloc_MethodType(1, argcv_meth_ast_3733_isPublic);
  meth_meth_ast_3733_isPublic->definitionModule = modulename;
  meth_meth_ast_3733_isPublic->definitionLine = 891;
// method "isWritable"
  struct UserObject *uo3738 = (struct UserObject*)obj3691;
  uo3738->data[16] = emptyclosure;
  Method *meth_meth_ast_3738_isWritable = addmethod2pos(obj3691, "isWritable", &meth_ast_3738_isWritable, 16);
  int argcv_meth_ast_3738_isWritable[] = {0};
  meth_meth_ast_3738_isWritable->type = alloc_MethodType(1, argcv_meth_ast_3738_isWritable);
  meth_meth_ast_3738_isWritable->definitionModule = modulename;
  meth_meth_ast_3738_isWritable->definitionLine = 892;
// method "isReadable"
  struct UserObject *uo3740 = (struct UserObject*)obj3691;
  uo3740->data[17] = emptyclosure;
  Method *meth_meth_ast_3740_isReadable = addmethod2pos(obj3691, "isReadable", &meth_ast_3740_isReadable, 17);
  int argcv_meth_ast_3740_isReadable[] = {0};
  meth_meth_ast_3740_isReadable->type = alloc_MethodType(1, argcv_meth_ast_3740_isReadable);
  meth_meth_ast_3740_isReadable->definitionModule = modulename;
  meth_meth_ast_3740_isReadable->definitionLine = 893;
// method "accept(_)from(_)"
  struct UserObject *uo3743 = (struct UserObject*)obj3691;
  uo3743->data[18] = emptyclosure;
  Method *meth_meth_ast_3743_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj3691, "accept(1)from(1)", &meth_ast_3743_accept_40_1_41_from_40_1_41_, 18);
  int argcv_meth_ast_3743_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_3743_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_3743_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_3743_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3743_accept_40_1_41_from_40_1_41_->definitionLine = 895;
// method "map(_)ancestors(_)"
  struct UserObject *uo3777 = (struct UserObject*)obj3691;
  uo3777->data[19] = emptyclosure;
  Method *meth_meth_ast_3777_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj3691, "map(1)ancestors(1)", &meth_ast_3777_map_40_1_41_ancestors_40_1_41_, 19);
  int argcv_meth_ast_3777_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_3777_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_3777_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_3777_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3777_map_40_1_41_ancestors_40_1_41_->definitionLine = 906;
// method "pretty(_)"
  struct UserObject *uo3808 = (struct UserObject*)obj3691;
  uo3808->data[20] = emptyclosure;
  Method *meth_meth_ast_3808_pretty_40_1_41_ = addmethod2pos(obj3691, "pretty(1)", &meth_ast_3808_pretty_40_1_41_, 20);
  int argcv_meth_ast_3808_pretty_40_1_41_[] = {1};
  meth_meth_ast_3808_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3808_pretty_40_1_41_);
  meth_meth_ast_3808_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3808_pretty_40_1_41_->definitionLine = 915;
// method "toGrace(_)"
  struct UserObject *uo3924 = (struct UserObject*)obj3691;
  uo3924->data[21] = emptyclosure;
  Method *meth_meth_ast_3924_toGrace_40_1_41_ = addmethod2pos(obj3691, "toGrace(1)", &meth_ast_3924_toGrace_40_1_41_, 21);
  int argcv_meth_ast_3924_toGrace_40_1_41_[] = {1};
  meth_meth_ast_3924_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3924_toGrace_40_1_41_);
meth_meth_ast_3924_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_3924_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_3924_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3924_toGrace_40_1_41_->definitionLine = 930;
// method "shallowCopy"
  block_savedest(obj3691);
  Object closure3968 = createclosure(2, "shallowCopy");
  setclosureframe(closure3968, stackframe);
  addtoclosure(closure3968, var_nullNode);
  addtoclosure(closure3968, var_typeDecNode);
  struct UserObject *uo3968 = (struct UserObject*)obj3691;
  uo3968->data[22] = (Object)closure3968;
  Method *meth_meth_ast_3968_shallowCopy = addmethod2pos(obj3691, "shallowCopy", &meth_ast_3968_shallowCopy, 22);
  int argcv_meth_ast_3968_shallowCopy[] = {0};
  meth_meth_ast_3968_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_3968_shallowCopy);
  meth_meth_ast_3968_shallowCopy->definitionModule = modulename;
  meth_meth_ast_3968_shallowCopy->definitionLine = 939;
// method "postCopy(_)"
  struct UserObject *uo3975 = (struct UserObject*)obj3691;
  uo3975->data[23] = emptyclosure;
  Method *meth_meth_ast_3975_postCopy_40_1_41_ = addmethod2pos(obj3691, "postCopy(1)", &meth_ast_3975_postCopy_40_1_41_, 23);
  int argcv_meth_ast_3975_postCopy_40_1_41_[] = {1};
  meth_meth_ast_3975_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_3975_postCopy_40_1_41_);
  meth_meth_ast_3975_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3975_postCopy_40_1_41_->definitionLine = 942;
  sourceObject = obj3691;
// Begin line 866
  setline(866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3980 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3981 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3980);
// compiled call node returning call3981 (depth = 3)
  struct UserObject *obj3691_uo = (struct UserObject *)obj3691;
  obj3691_uo->super = call3981;
  sourceObject = obj3691;
// Begin line 867
  setline(867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3982 == NULL) {
    strlit3982 = alloc_String("typedec");
    gc_root(strlit3982);
  }
// compiled string node returning strlit3982 (depth = 3)
  adddatum2(obj3691, strlit3982, 1);
  sourceObject = obj3691;
// Begin line 868
  setline(868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj3691, *var_name_39_, 2);
  sourceObject = obj3691;
// Begin line 869
  setline(869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeValue (depth = 3)
  adddatum2(obj3691, *var_typeValue, 3);
  sourceObject = obj3691;
// Begin line 870
  setline(870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3983 == NULL) {
    strlit3983 = alloc_String("unset");
    gc_root(strlit3983);
  }
// compiled string node returning strlit3983 (depth = 3)
  adddatum2(obj3691, strlit3983, 4);
  sourceObject = obj3691;
// Begin line 871
  setline(871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3984 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3985 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3986 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3985);
// compiled member node returning call3986 (depth = 4)
  partcv[0] = 0;
  Object call3987 = callmethodflags(call3986, "value", 1, partcv, params, 0);
  gc_frame_end(callframe3984);
// compiled member node returning call3987 (depth = 3)
  adddatum2(obj3691, call3987, 5);
  sourceObject = obj3691;
// Begin line 872
  setline(872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array3988 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3988 (depth = 3)
  adddatum2(obj3691, array3988, 6);
  sourceObject = obj3691;
// Begin line 873
  setline(873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3989 = alloc_Boolean(0);
// compiled identifier node returning bool3989 (depth = 3)
  adddatum2(obj3691, bool3989, 7);
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  sourceObject = obj3691;
  objclass3691 = obj3691->class;
  objclass3691->definitionModule = modulename;
  objclass3691->definitionLine = 865;
  (*(struct UserObject *)self).data[0] = lowerouter3691;
  self = oldself3691;
  selfslot = oldselfslot3691;
  stackframe = oldstackframe3691;
  gc_frame_end(frame);
  return obj3691;
}
Object meth_ast_3991_typeDecNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 34, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeDecNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 864
  setline(864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeDecNode (depth = 3)
  gc_frame_end(frame);
  return *var_typeDecNode;
}
Object meth_ast_3994_new_40_3_41_scope_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new(3)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)scope(_)");
  Object params[3];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_)scope(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_signature = &(stackframe->slots[0]);
  *var_signature = args[curarg];
  curarg++;
  Object *var_body = &(stackframe->slots[1]);
  *var_body = args[curarg];
  curarg++;
  Object *var_dtype = &(stackframe->slots[2]);
  *var_dtype = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *var_s = &(stackframe->slots[3]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_result = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "result");
// Begin line 951
  setline(951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3995 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  gc_frame_newslot(*var_signature);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_body (depth = 5)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 4: self request
  params[0] = *var_signature;
  params[1] = *var_body;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call3996 = callmethodflags(self, "new(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3995);
// compiled call node returning call3996 (depth = 4)
  *var_result = call3996;
  if (call3996 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 952
  setline(952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3997 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call3998 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3997);
// compiled call node returning call3998 (depth = 3)
// Begin line 953
  setline(953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_4013_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 978
  setline(978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4015 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4016 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4017 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4018 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4017);
// compiled member node returning call4018 (depth = 6)
  partcv[0] = 0;
  Object call4019 = callmethodflags(call4018, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe4016);
// compiled member node returning call4019 (depth = 5)
  partcv[0] = 0;
  Object call4020 = callmethodflags(call4019, "not", 1, partcv, params, 0);
  gc_frame_end(callframe4015);
// compiled member node returning call4020 (depth = 4)
  Object if4014 = done;
  if (istrue(call4020)) {
// Begin line 979
  setline(979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4022 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4023 = callmethodflags(self, "usesClassSyntax", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4022);
// compiled member node returning call4023 (depth = 5)
  Object if4021 = done;
  if (istrue(call4023)) {
// starting to compile return node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4024 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4025 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4026 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4027 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4026);
// compiled member node returning call4027 (depth = 8)
  partcv[0] = 0;
  Object call4028 = callmethodflags(call4027, "last", 1, partcv, params, 0);
  gc_frame_end(callframe4025);
// compiled member node returning call4028 (depth = 7)
  partcv[0] = 0;
  Object call4029 = callmethodflags(call4028, "end", 1, partcv, params, 0);
  gc_frame_end(callframe4024);
// compiled member node returning call4029 (depth = 6)
  return call4029;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4021 = undefined;
  } else {
  }
// compiled if node returning if4021 (depth = 4)
// Begin line 980
  setline(980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4030 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4031 == NULL) {
    strlit4031 = alloc_String("}");
    gc_root(strlit4031);
  }
// compiled string node returning strlit4031 (depth = 6)
  gc_frame_newslot(strlit4031);
// starting to compile member node (depth = 6)
  int callframe4032 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4033 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4034 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4035 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4034);
// compiled member node returning call4035 (depth = 8)
  partcv[0] = 0;
  Object call4036 = callmethodflags(call4035, "last", 1, partcv, params, 0);
  gc_frame_end(callframe4033);
// compiled member node returning call4036 (depth = 7)
  partcv[0] = 0;
  Object call4037 = callmethodflags(call4036, "end", 1, partcv, params, 0);
  gc_frame_end(callframe4032);
// compiled member node returning call4037 (depth = 6)
  gc_frame_newslot(call4037);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_ast (depth = 6)
  params[0] = strlit4031;
  params[1] = call4037;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4038 = callmethodflags(module_ast, "positionOfNext(1)after(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4030);
// compiled call node returning call4038 (depth = 5)
  return call4038;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if4014 = undefined;
  } else {
  }
// compiled if node returning if4014 (depth = 3)
// Begin line 982
  setline(982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4041 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4042 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4041);
// compiled member node returning call4042 (depth = 5)
  int op_slot_right_4040 = gc_frame_newslot(call4042);
// starting to compile identifier node (depth = 5)
  Object bool4044 = alloc_Boolean(0);
// compiled identifier node returning bool4044 (depth = 5)
  int op_slot_left_4040 = gc_frame_newslot(bool4044);
  params[0] = call4042;
  partcv[0] = 1;
  Object opresult4045 = callmethod(bool4044, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4045 (depth = 4)
  Object if4039 = done;
  if (istrue(opresult4045)) {
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4046 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4047 == NULL) {
    strlit4047 = alloc_String("}");
    gc_root(strlit4047);
  }
// compiled string node returning strlit4047 (depth = 6)
  gc_frame_newslot(strlit4047);
// starting to compile member node (depth = 6)
  int callframe4048 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4049 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4050 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4049);
// compiled member node returning call4050 (depth = 7)
  partcv[0] = 0;
  Object call4051 = callmethodflags(call4050, "end", 1, partcv, params, 0);
  gc_frame_end(callframe4048);
// compiled member node returning call4051 (depth = 6)
  gc_frame_newslot(call4051);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_ast (depth = 6)
  params[0] = strlit4047;
  params[1] = call4051;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4052 = callmethodflags(module_ast, "positionOfNext(1)after(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4046);
// compiled call node returning call4052 (depth = 5)
  return call4052;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if4039 = undefined;
  } else {
  }
// compiled if node returning if4039 (depth = 3)
// Begin line 985
  setline(985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4053 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4054 == NULL) {
    strlit4054 = alloc_String("}");
    gc_root(strlit4054);
  }
// compiled string node returning strlit4054 (depth = 5)
  gc_frame_newslot(strlit4054);
// starting to compile member node (depth = 5)
  int callframe4055 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4056 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4057 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4058 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4057);
// compiled member node returning call4058 (depth = 7)
  partcv[0] = 0;
  Object call4059 = callmethodflags(call4058, "last", 1, partcv, params, 0);
  gc_frame_end(callframe4056);
// compiled member node returning call4059 (depth = 6)
  partcv[0] = 0;
  Object call4060 = callmethodflags(call4059, "end", 1, partcv, params, 0);
  gc_frame_end(callframe4055);
// compiled member node returning call4060 (depth = 5)
  gc_frame_newslot(call4060);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = strlit4054;
  params[1] = call4060;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4061 = callmethodflags(module_ast, "positionOfNext(1)after(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4053);
// compiled call node returning call4061 (depth = 4)
  return call4061;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_4066__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 6)
  int callframe4067 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4068 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4069 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4070 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4069);
// compiled member node returning call4070 (depth = 8)
  partcv[0] = 0;
  Object call4071 = callmethodflags(call4070, "last", 1, partcv, params, 0);
  gc_frame_end(callframe4068);
// compiled member node returning call4071 (depth = 7)
  partcv[0] = 0;
  Object call4072 = callmethodflags(call4071, "isObject", 1, partcv, params, 0);
  gc_frame_end(callframe4067);
// compiled member node returning call4072 (depth = 6)
  gc_frame_end(frame);
  return call4072;
}
Object meth_ast_4062_ilkName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "ilkName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 989
  setline(989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block4065 = alloc_Block(NULL, NULL, "ast", 989);
  gc_frame_newslot(block4065);
// method "_apply"
  block_savedest(block4065);
  Object closure4066 = createclosure(1, "_apply");
  setclosureframe(closure4066, stackframe);
  addtoclosure(closure4066, selfslot);
  struct UserObject *uo4066 = (struct UserObject*)block4065;
  uo4066->data[0] = (Object)closure4066;
  Method *meth_meth_ast_4066__apply = addmethod2pos(block4065, "_apply", &meth_ast_4066__apply, 0);
  int argcv_meth_ast_4066__apply[] = {0};
  meth_meth_ast_4066__apply->type = alloc_MethodType(1, argcv_meth_ast_4066__apply);
  meth_meth_ast_4066__apply->definitionModule = modulename;
  meth_meth_ast_4066__apply->definitionLine = 3050;
// compiled block node returning block4065 (depth = 5)
  int op_slot_right_4064 = gc_frame_newslot(block4065);
// starting to compile member node (depth = 5)
  int callframe4075 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4076 = callmethodflags(self, "isFresh", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4075);
// compiled member node returning call4076 (depth = 5)
  int op_slot_left_4064 = gc_frame_newslot(call4076);
  params[0] = block4065;
  partcv[0] = 1;
  Object opresult4077 = callmethod(call4076, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4077 (depth = 4)
  Object if4063 = done;
  if (istrue(opresult4077)) {
// Begin line 990
  setline(990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4078 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4079 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4080 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4081 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4080);
// compiled member node returning call4081 (depth = 6)
  partcv[0] = 0;
  Object call4082 = callmethodflags(call4081, "last", 1, partcv, params, 0);
  gc_frame_end(callframe4079);
// compiled member node returning call4082 (depth = 5)
  partcv[0] = 0;
  Object call4083 = callmethodflags(call4082, "name", 1, partcv, params, 0);
  gc_frame_end(callframe4078);
// compiled member node returning call4083 (depth = 4)
    gc_frame_newslot(call4083);
    if4063 = call4083;
  } else {
// Begin line 992
  setline(992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4084 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4085 = callmethodflags(self, "canonicalName", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4084);
// compiled member node returning call4085 (depth = 4)
    gc_frame_newslot(call4085);
    if4063 = call4085;
  }
// compiled if node returning if4063 (depth = 3)
  gc_frame_end(frame);
  return if4063;
}
Object meth_ast_4086_appliedOccurence(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "appliedOccurence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_uninitialized = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 996
  setline(996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4087 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool4088 = alloc_Boolean(0);
// compiled identifier node returning bool4088 (depth = 4)
  gc_frame_newslot(bool4088);
// call case 4: self request
  params[0] = bool4088;
  partcv[0] = 1;
  Object call4089 = callmethodflags(self, "isBindingOccurence:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4087);
// compiled call node returning call4089 (depth = 3)
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4092 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4093 = callmethodflags(self, "cachedIdentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4092);
// compiled member node returning call4093 (depth = 5)
  int op_slot_right_4091 = gc_frame_newslot(call4093);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_uninitialized (depth = 5)
  int op_slot_left_4091 = gc_frame_newslot(*var_uninitialized);
  params[0] = call4093;
  partcv[0] = 1;
  Object opresult4095 = callmethod(*var_uninitialized, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4095 (depth = 4)
  Object if4090 = done;
  if (istrue(opresult4095)) {
// Begin line 998
  setline(998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4096 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool4097 = alloc_Boolean(0);
// compiled identifier node returning bool4097 (depth = 5)
  gc_frame_newslot(bool4097);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4098 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4099 = callmethodflags(self, "cachedIdentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4098);
// compiled member node returning call4099 (depth = 5)
  params[0] = bool4097;
  partcv[0] = 1;
  Object call4100 = callmethodflags(call4099, "isBindingOccurence:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4096);
// compiled call node returning call4100 (depth = 4)
    gc_frame_newslot(call4100);
    if4090 = call4100;
  } else {
  }
// compiled if node returning if4090 (depth = 3)
// Begin line 1000
  setline(1000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_4104__apply_40_2_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_acc = &(stackframe->slots[0]);
  *var_acc = args[curarg];
  curarg++;
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4106 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  partcv[0] = 0;
  Object call4107 = callmethodflags(*var_p, "numParams", 1, partcv, params, 0);
  gc_frame_end(callframe4106);
// compiled member node returning call4107 (depth = 6)
  int op_slot_right_4105 = gc_frame_newslot(call4107);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acc (depth = 6)
  int op_slot_left_4105 = gc_frame_newslot(*var_acc);
  params[0] = call4107;
  partcv[0] = 1;
  Object sum4109 = callmethod(*var_acc, "+(1)", 1, partcv, params);
// compiled op node returning sum4109 (depth = 5)
  gc_frame_end(frame);
  return sum4109;
}
Object meth_ast_4101_numParams(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "numParams");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1003
  setline(1003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4102 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block4103 = alloc_Block(NULL, NULL, "ast", 1003);
  gc_frame_newslot(block4103);
// method "_apply(_,_)"
  block_savedest(block4103);
  Object closure4104 = createclosure(1, "_apply(2)");
  setclosureframe(closure4104, stackframe);
  addtoclosure(closure4104, selfslot);
  struct UserObject *uo4104 = (struct UserObject*)block4103;
  uo4104->data[0] = (Object)closure4104;
  Method *meth_meth_ast_4104__apply_40_2_41_ = addmethod2pos(block4103, "_apply(2)", &meth_ast_4104__apply_40_2_41_, 0);
  int argcv_meth_ast_4104__apply_40_2_41_[] = {2};
  meth_meth_ast_4104__apply_40_2_41_->type = alloc_MethodType(1, argcv_meth_ast_4104__apply_40_2_41_);
  meth_meth_ast_4104__apply_40_2_41_->definitionModule = modulename;
  meth_meth_ast_4104__apply_40_2_41_->definitionLine = 3050;
// compiled block node returning block4103 (depth = 4)
  gc_frame_newslot(block4103);
// starting to compile num node (depth = 4)
  Object num4111 = alloc_Float64(0);
// compiled num node returning num4111 (depth = 4)
  gc_frame_newslot(num4111);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4112 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4113 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4112);
// compiled member node returning call4113 (depth = 4)
  params[0] = block4103;
  params[1] = num4111;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4114 = callmethodflags(call4113, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4102);
// compiled call node returning call4114 (depth = 3)
  gc_frame_end(frame);
  return call4114;
}
Object meth_ast_4121__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_b = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 7)
  int callframe4122 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_b (depth = 8)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call4123 = callmethodflags(*var_b, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4122);
// compiled call node returning call4123 (depth = 7)
  gc_frame_end(frame);
  return call4123;
}
Object meth_ast_4118__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_b = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1007
  setline(1007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4119 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block4120 = alloc_Block(NULL, NULL, "ast", 1007);
  gc_frame_newslot(block4120);
// method "_apply(_)"
  block_savedest(block4120);
  Object closure4121 = createclosure(2, "_apply(1)");
  setclosureframe(closure4121, stackframe);
  addtoclosure(closure4121, var_b);
  addtoclosure(closure4121, selfslot);
  struct UserObject *uo4121 = (struct UserObject*)block4120;
  uo4121->data[0] = (Object)closure4121;
  Method *meth_meth_ast_4121__apply_40_1_41_ = addmethod2pos(block4120, "_apply(1)", &meth_ast_4121__apply_40_1_41_, 0);
  int argcv_meth_ast_4121__apply_40_1_41_[] = {1};
  meth_meth_ast_4121__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4121__apply_40_1_41_);
  meth_meth_ast_4121__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4121__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block4120 (depth = 6)
  gc_frame_newslot(block4120);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4125 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call4126 = callmethodflags(*var_part, "params", 1, partcv, params, 0);
  gc_frame_end(callframe4125);
// compiled member node returning call4126 (depth = 6)
  params[0] = block4120;
  partcv[0] = 1;
  Object call4127 = callmethodflags(call4126, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4119);
// compiled call node returning call4127 (depth = 5)
  gc_frame_end(frame);
  return call4127;
}
Object meth_ast_4115_parametersDo_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parametersDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parametersDo(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parametersDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parametersDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1006
  setline(1006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4116 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block4117 = alloc_Block(NULL, NULL, "ast", 1006);
  gc_frame_newslot(block4117);
// method "_apply(_)"
  block_savedest(block4117);
  Object closure4118 = createclosure(2, "_apply(1)");
  setclosureframe(closure4118, stackframe);
  addtoclosure(closure4118, var_b);
  addtoclosure(closure4118, selfslot);
  struct UserObject *uo4118 = (struct UserObject*)block4117;
  uo4118->data[0] = (Object)closure4118;
  Method *meth_meth_ast_4118__apply_40_1_41_ = addmethod2pos(block4117, "_apply(1)", &meth_ast_4118__apply_40_1_41_, 0);
  int argcv_meth_ast_4118__apply_40_1_41_[] = {1};
  meth_meth_ast_4118__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4118__apply_40_1_41_);
  meth_meth_ast_4118__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4118__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block4117 (depth = 4)
  gc_frame_newslot(block4117);
// call case 6: other requests
// Begin line 1006
  setline(1006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4129 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4130 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4129);
// compiled member node returning call4130 (depth = 4)
  params[0] = block4117;
  partcv[0] = 1;
  Object call4131 = callmethodflags(call4130, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4116);
// compiled call node returning call4131 (depth = 3)
  gc_frame_end(frame);
  return call4131;
}
Object meth_ast_4132_endPos(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "endPos");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_lastPart = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "lastPart");
// Begin line 1011
  setline(1011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4133 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4134 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4135 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4134);
// compiled member node returning call4135 (depth = 5)
  partcv[0] = 0;
  Object call4136 = callmethodflags(call4135, "last", 1, partcv, params, 0);
  gc_frame_end(callframe4133);
// compiled member node returning call4136 (depth = 4)
  *var_lastPart = call4136;
  if (call4136 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1012
  setline(1012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4138 = alloc_Float64(1);
// compiled num node returning num4138 (depth = 4)
  int op_slot_right_4137 = gc_frame_newslot(num4138);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4141 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4142 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastPart (depth = 7)
  partcv[0] = 0;
  Object call4143 = callmethodflags(*var_lastPart, "name", 1, partcv, params, 0);
  gc_frame_end(callframe4142);
// compiled member node returning call4143 (depth = 6)
  partcv[0] = 0;
  Object call4144 = callmethodflags(call4143, "size", 1, partcv, params, 0);
  gc_frame_end(callframe4141);
// compiled member node returning call4144 (depth = 5)
  int op_slot_right_4140 = gc_frame_newslot(call4144);
// starting to compile member node (depth = 5)
  int callframe4146 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastPart (depth = 6)
  partcv[0] = 0;
  Object call4147 = callmethodflags(*var_lastPart, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe4146);
// compiled member node returning call4147 (depth = 5)
  int op_slot_left_4140 = gc_frame_newslot(call4147);
  params[0] = call4144;
  partcv[0] = 1;
  Object sum4148 = callmethod(call4147, "+(1)", 1, partcv, params);
// compiled op node returning sum4148 (depth = 4)
  int op_slot_left_4137 = gc_frame_newslot(sum4148);
  params[0] = num4138;
  partcv[0] = 1;
  Object diff4149 = callmethod(sum4148, "-(1)", 1, partcv, params);
// compiled op node returning diff4149 (depth = 3)
  gc_frame_end(frame);
  return diff4149;
}
Object meth_ast_4153__apply_40_2_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_acc = &(stackframe->slots[0]);
  *var_acc = args[curarg];
  curarg++;
  Object *var_each = &(stackframe->slots[1]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4155 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  partcv[0] = 0;
  Object call4156 = callmethodflags(*var_each, "nameString", 1, partcv, params, 0);
  gc_frame_end(callframe4155);
// compiled member node returning call4156 (depth = 6)
  int op_slot_right_4154 = gc_frame_newslot(call4156);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acc (depth = 6)
  int op_slot_left_4154 = gc_frame_newslot(*var_acc);
  params[0] = call4156;
  partcv[0] = 1;
  Object opresult4158 = callmethod(*var_acc, "++(1)", 1, partcv, params);
// compiled op node returning opresult4158 (depth = 5)
  gc_frame_end(frame);
  return opresult4158;
}
Object meth_ast_4150_nameString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1016
  setline(1016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4151 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block4152 = alloc_Block(NULL, NULL, "ast", 1016);
  gc_frame_newslot(block4152);
// method "_apply(_,_)"
  block_savedest(block4152);
  Object closure4153 = createclosure(1, "_apply(2)");
  setclosureframe(closure4153, stackframe);
  addtoclosure(closure4153, selfslot);
  struct UserObject *uo4153 = (struct UserObject*)block4152;
  uo4153->data[0] = (Object)closure4153;
  Method *meth_meth_ast_4153__apply_40_2_41_ = addmethod2pos(block4152, "_apply(2)", &meth_ast_4153__apply_40_2_41_, 0);
  int argcv_meth_ast_4153__apply_40_2_41_[] = {2};
  meth_meth_ast_4153__apply_40_2_41_->type = alloc_MethodType(1, argcv_meth_ast_4153__apply_40_2_41_);
  meth_meth_ast_4153__apply_40_2_41_->definitionModule = modulename;
  meth_meth_ast_4153__apply_40_2_41_->definitionLine = 3050;
// compiled block node returning block4152 (depth = 4)
  gc_frame_newslot(block4152);
// Begin line 1017
  setline(1017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit4160 == NULL) {
    strlit4160 = alloc_String("");
    gc_root(strlit4160);
  }
// compiled string node returning strlit4160 (depth = 4)
  gc_frame_newslot(strlit4160);
// call case 6: other requests
// Begin line 1016
  setline(1016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4161 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4162 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4161);
// compiled member node returning call4162 (depth = 4)
  params[0] = block4152;
  params[1] = strlit4160;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4163 = callmethodflags(call4162, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4151);
// compiled call node returning call4163 (depth = 3)
  gc_frame_end(frame);
  return call4163;
}
Object meth_ast_4164_asIdentifier(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_uninitialized = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1020
  setline(1020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4167 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4168 = callmethodflags(self, "cachedIdentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4167);
// compiled member node returning call4168 (depth = 5)
  int op_slot_right_4166 = gc_frame_newslot(call4168);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_uninitialized (depth = 5)
  int op_slot_left_4166 = gc_frame_newslot(*var_uninitialized);
  params[0] = call4168;
  partcv[0] = 1;
  Object opresult4170 = callmethod(*var_uninitialized, "==(1)", 1, partcv, params);
// compiled op node returning opresult4170 (depth = 4)
  Object if4165 = done;
  if (istrue(opresult4170)) {
// Begin line 1021
  setline(1021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4171 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe4172 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4173 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4174 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4173);
// compiled member node returning call4174 (depth = 6)
  gc_frame_newslot(call4174);
// starting to compile identifier node (depth = 6)
  Object bool4175 = alloc_Boolean(0);
// compiled identifier node returning bool4175 (depth = 6)
  gc_frame_newslot(bool4175);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_identifierNode (depth = 6)
  params[0] = call4174;
  params[1] = bool4175;
  partcv[0] = 2;
  Object call4176 = callmethodflags(*var_identifierNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4172);
// compiled call node returning call4176 (depth = 5)
  gc_frame_newslot(call4176);
// call case 4: self request
  params[0] = call4176;
  partcv[0] = 1;
  Object call4177 = callmethodflags(self, "cachedIdentifier:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4171);
// compiled call node returning call4177 (depth = 4)
// Begin line 1022
  setline(1022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4178 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4179 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4180 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4181 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4182 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4181);
// compiled member node returning call4182 (depth = 7)
  partcv[0] = 0;
  Object call4183 = callmethodflags(call4182, "first", 1, partcv, params, 0);
  gc_frame_end(callframe4180);
// compiled member node returning call4183 (depth = 6)
  partcv[0] = 0;
  Object call4184 = callmethodflags(call4183, "line", 1, partcv, params, 0);
  gc_frame_end(callframe4179);
// compiled member node returning call4184 (depth = 5)
  gc_frame_newslot(call4184);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4185 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4186 = callmethodflags(self, "cachedIdentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4185);
// compiled member node returning call4186 (depth = 5)
  params[0] = call4184;
  partcv[0] = 1;
  Object call4187 = callmethodflags(call4186, "line:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4178);
// compiled call node returning call4187 (depth = 4)
// Begin line 1023
  setline(1023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4188 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4189 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4190 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4191 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4192 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4191);
// compiled member node returning call4192 (depth = 7)
  partcv[0] = 0;
  Object call4193 = callmethodflags(call4192, "first", 1, partcv, params, 0);
  gc_frame_end(callframe4190);
// compiled member node returning call4193 (depth = 6)
  partcv[0] = 0;
  Object call4194 = callmethodflags(call4193, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe4189);
// compiled member node returning call4194 (depth = 5)
  gc_frame_newslot(call4194);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4195 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4196 = callmethodflags(self, "cachedIdentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4195);
// compiled member node returning call4196 (depth = 5)
  params[0] = call4194;
  partcv[0] = 1;
  Object call4197 = callmethodflags(call4196, "linePos:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4188);
// compiled call node returning call4197 (depth = 4)
// Begin line 1024
  setline(1024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4198 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4199 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4200 = callmethodflags(self, "isBindingOccurence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4199);
// compiled member node returning call4200 (depth = 5)
  gc_frame_newslot(call4200);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4201 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4202 = callmethodflags(self, "cachedIdentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4201);
// compiled member node returning call4202 (depth = 5)
  params[0] = call4200;
  partcv[0] = 1;
  Object call4203 = callmethodflags(call4202, "isBindingOccurrence:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4198);
// compiled call node returning call4203 (depth = 4)
// Begin line 1025
  setline(1025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4204 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4205 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4206 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4207 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4208 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4207);
// compiled member node returning call4208 (depth = 7)
  partcv[0] = 0;
  Object call4209 = callmethodflags(call4208, "last", 1, partcv, params, 0);
  gc_frame_end(callframe4206);
// compiled member node returning call4209 (depth = 6)
  partcv[0] = 0;
  Object call4210 = callmethodflags(call4209, "end", 1, partcv, params, 0);
  gc_frame_end(callframe4205);
// compiled member node returning call4210 (depth = 5)
  gc_frame_newslot(call4210);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4211 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4212 = callmethodflags(self, "cachedIdentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4211);
// compiled member node returning call4212 (depth = 5)
  params[0] = call4210;
  partcv[0] = 1;
  Object call4213 = callmethodflags(call4212, "end:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4204);
// compiled call node returning call4213 (depth = 4)
// Begin line 1026
  setline(1026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4214 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4215 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4216 = callmethodflags(self, "canonicalName", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4215);
// compiled member node returning call4216 (depth = 5)
  gc_frame_newslot(call4216);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4217 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4218 = callmethodflags(self, "cachedIdentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4217);
// compiled member node returning call4218 (depth = 5)
  params[0] = call4216;
  partcv[0] = 1;
  Object call4219 = callmethodflags(call4218, "canonicalName:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4214);
// compiled call node returning call4219 (depth = 4)
    gc_frame_newslot(call4219);
    if4165 = call4219;
  } else {
  }
// compiled if node returning if4165 (depth = 3)
// Begin line 1028
  setline(1028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4220 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4221 = callmethodflags(self, "cachedIdentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4220);
// compiled member node returning call4221 (depth = 3)
  gc_frame_end(frame);
  return call4221;
}
Object meth_ast_4222_value(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "value");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1030
  setline(1030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4223 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4224 = callmethodflags(self, "asIdentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4223);
// compiled member node returning call4224 (depth = 3)
  gc_frame_end(frame);
  return call4224;
}
Object meth_ast_4228__apply_40_2_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_acc = &(stackframe->slots[0]);
  *var_acc = args[curarg];
  curarg++;
  Object *var_each = &(stackframe->slots[1]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4230 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  partcv[0] = 0;
  Object call4231 = callmethodflags(*var_each, "canonicalName", 1, partcv, params, 0);
  gc_frame_end(callframe4230);
// compiled member node returning call4231 (depth = 6)
  int op_slot_right_4229 = gc_frame_newslot(call4231);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acc (depth = 6)
  int op_slot_left_4229 = gc_frame_newslot(*var_acc);
  params[0] = call4231;
  partcv[0] = 1;
  Object opresult4233 = callmethod(*var_acc, "++(1)", 1, partcv, params);
// compiled op node returning opresult4233 (depth = 5)
  gc_frame_end(frame);
  return opresult4233;
}
Object meth_ast_4225_canonicalName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canonicalName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1032
  setline(1032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4226 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block4227 = alloc_Block(NULL, NULL, "ast", 1032);
  gc_frame_newslot(block4227);
// method "_apply(_,_)"
  block_savedest(block4227);
  Object closure4228 = createclosure(1, "_apply(2)");
  setclosureframe(closure4228, stackframe);
  addtoclosure(closure4228, selfslot);
  struct UserObject *uo4228 = (struct UserObject*)block4227;
  uo4228->data[0] = (Object)closure4228;
  Method *meth_meth_ast_4228__apply_40_2_41_ = addmethod2pos(block4227, "_apply(2)", &meth_ast_4228__apply_40_2_41_, 0);
  int argcv_meth_ast_4228__apply_40_2_41_[] = {2};
  meth_meth_ast_4228__apply_40_2_41_->type = alloc_MethodType(1, argcv_meth_ast_4228__apply_40_2_41_);
  meth_meth_ast_4228__apply_40_2_41_->definitionModule = modulename;
  meth_meth_ast_4228__apply_40_2_41_->definitionLine = 3050;
// compiled block node returning block4227 (depth = 4)
  gc_frame_newslot(block4227);
// Begin line 1033
  setline(1033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit4235 == NULL) {
    strlit4235 = alloc_String("");
    gc_root(strlit4235);
  }
// compiled string node returning strlit4235 (depth = 4)
  gc_frame_newslot(strlit4235);
// call case 6: other requests
// Begin line 1032
  setline(1032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4236 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4237 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4236);
// compiled member node returning call4237 (depth = 4)
  params[0] = block4227;
  params[1] = strlit4235;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4238 = callmethodflags(call4237, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4226);
// compiled call node returning call4238 (depth = 3)
  gc_frame_end(frame);
  return call4238;
}
Object meth_ast_4239_hasParams(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasParams");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1035
  setline(1035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4240 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4241 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4242 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4243 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4244 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4245 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4244);
// compiled member node returning call4245 (depth = 7)
  partcv[0] = 0;
  Object call4246 = callmethodflags(call4245, "first", 1, partcv, params, 0);
  gc_frame_end(callframe4243);
// compiled member node returning call4246 (depth = 6)
  partcv[0] = 0;
  Object call4247 = callmethodflags(call4246, "params", 1, partcv, params, 0);
  gc_frame_end(callframe4242);
// compiled member node returning call4247 (depth = 5)
  partcv[0] = 0;
  Object call4248 = callmethodflags(call4247, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe4241);
// compiled member node returning call4248 (depth = 4)
  partcv[0] = 0;
  Object call4249 = callmethodflags(call4248, "not", 1, partcv, params, 0);
  gc_frame_end(callframe4240);
// compiled member node returning call4249 (depth = 3)
  gc_frame_end(frame);
  return call4249;
}
Object meth_ast_4250_numParamLists(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "numParamLists");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_sigSz = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sigSz");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1039
  setline(1039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4251 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4252 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4253 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4252);
// compiled member node returning call4253 (depth = 5)
  partcv[0] = 0;
  Object call4254 = callmethodflags(call4253, "size", 1, partcv, params, 0);
  gc_frame_end(callframe4251);
// compiled member node returning call4254 (depth = 4)
  *var_sigSz = call4254;
  if (call4254 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4257 = alloc_Float64(1);
// compiled num node returning num4257 (depth = 5)
  int op_slot_right_4256 = gc_frame_newslot(num4257);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sigSz (depth = 5)
  int op_slot_left_4256 = gc_frame_newslot(*var_sigSz);
  params[0] = num4257;
  partcv[0] = 1;
  Object opresult4259 = callmethod(*var_sigSz, ">(1)", 1, partcv, params);
// compiled op node returning opresult4259 (depth = 4)
  Object if4255 = done;
  if (istrue(opresult4259)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sigSz (depth = 5)
  return *var_sigSz;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if4255 = undefined;
  } else {
  }
// compiled if node returning if4255 (depth = 3)
// Begin line 1041
  setline(1041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4261 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4262 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4263 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4264 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4265 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4264);
// compiled member node returning call4265 (depth = 7)
  partcv[0] = 0;
  Object call4266 = callmethodflags(call4265, "first", 1, partcv, params, 0);
  gc_frame_end(callframe4263);
// compiled member node returning call4266 (depth = 6)
  partcv[0] = 0;
  Object call4267 = callmethodflags(call4266, "params", 1, partcv, params, 0);
  gc_frame_end(callframe4262);
// compiled member node returning call4267 (depth = 5)
  partcv[0] = 0;
  Object call4268 = callmethodflags(call4267, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe4261);
// compiled member node returning call4268 (depth = 4)
  Object if4260 = done;
  if (istrue(call4268)) {
// starting to compile return node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4269 = alloc_Float64(0);
// compiled num node returning num4269 (depth = 5)
  return num4269;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if4260 = undefined;
  } else {
  }
// compiled if node returning if4260 (depth = 3)
// Begin line 1042
  setline(1042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4270 = alloc_Float64(1);
// compiled num node returning num4270 (depth = 4)
  return num4270;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_4271_hasTypeParams(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasTypeParams");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1044
  setline(1044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4273 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4274 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4275 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4276 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4275);
// compiled member node returning call4276 (depth = 6)
  partcv[0] = 0;
  Object call4277 = callmethodflags(call4276, "first", 1, partcv, params, 0);
  gc_frame_end(callframe4274);
// compiled member node returning call4277 (depth = 5)
  partcv[0] = 0;
  Object call4278 = callmethodflags(call4277, "typeParams", 1, partcv, params, 0);
  gc_frame_end(callframe4273);
// compiled member node returning call4278 (depth = 4)
  int op_slot_right_4272 = gc_frame_newslot(call4278);
// starting to compile identifier node (depth = 4)
  Object bool4280 = alloc_Boolean(0);
// compiled identifier node returning bool4280 (depth = 4)
  int op_slot_left_4272 = gc_frame_newslot(bool4280);
  params[0] = call4278;
  partcv[0] = 1;
  Object opresult4281 = callmethod(bool4280, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4281 (depth = 3)
  gc_frame_end(frame);
  return opresult4281;
}
Object meth_ast_4282_isMethod(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMethod");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1045
  setline(1045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4283 = alloc_Boolean(1);
// compiled identifier node returning bool4283 (depth = 3)
  gc_frame_end(frame);
  return bool4283;
}
Object meth_ast_4284_isExecutable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1046
  setline(1046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4285 = alloc_Boolean(0);
// compiled identifier node returning bool4285 (depth = 3)
  gc_frame_end(frame);
  return bool4285;
}
Object meth_ast_4286_isLegalInTrait(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isLegalInTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4287 = alloc_Boolean(1);
// compiled identifier node returning bool4287 (depth = 3)
  gc_frame_end(frame);
  return bool4287;
}
Object meth_ast_4288_isClass(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isClass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1048
  setline(1048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4290 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4291 = callmethodflags(self, "usesClassSyntax", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4290);
// compiled member node returning call4291 (depth = 4)
  int op_slot_right_4289 = gc_frame_newslot(call4291);
// starting to compile member node (depth = 4)
  int callframe4293 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4294 = callmethodflags(self, "isFresh", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4293);
// compiled member node returning call4294 (depth = 4)
  int op_slot_left_4289 = gc_frame_newslot(call4294);
  params[0] = call4291;
  partcv[0] = 1;
  Object opresult4295 = callmethod(call4294, "||(1)", 1, partcv, params);
// compiled op node returning opresult4295 (depth = 3)
  gc_frame_end(frame);
  return opresult4295;
}
Object meth_ast_4296_isTrait(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1050
  setline(1050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4298 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4299 = callmethodflags(self, "isFresh", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4298);
// compiled member node returning call4299 (depth = 4)
  Object if4297 = done;
  if (istrue(call4299)) {
// Begin line 1051
  setline(1051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4300 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4301 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4302 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4303 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4302);
// compiled member node returning call4303 (depth = 6)
  partcv[0] = 0;
  Object call4304 = callmethodflags(call4303, "last", 1, partcv, params, 0);
  gc_frame_end(callframe4301);
// compiled member node returning call4304 (depth = 5)
  partcv[0] = 0;
  Object call4305 = callmethodflags(call4304, "isTrait", 1, partcv, params, 0);
  gc_frame_end(callframe4300);
// compiled member node returning call4305 (depth = 4)
    gc_frame_newslot(call4305);
    if4297 = call4305;
  } else {
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool4306 = alloc_Boolean(0);
// compiled identifier node returning bool4306 (depth = 4)
    gc_frame_newslot(bool4306);
    if4297 = bool4306;
  }
// compiled if node returning if4297 (depth = 3)
  gc_frame_end(frame);
  return if4297;
}
Object meth_ast_4317__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_p = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1060
  setline(1060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4319 == NULL) {
    strlit4319 = alloc_String("Unknown");
    gc_root(strlit4319);
  }
// compiled string node returning strlit4319 (depth = 11)
  int op_slot_right_4318 = gc_frame_newslot(strlit4319);
// starting to compile member node (depth = 11)
  int callframe4321 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe4322 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_p (depth = 13)
  partcv[0] = 0;
  Object call4323 = callmethodflags(*var_p, "dtype", 1, partcv, params, 0);
  gc_frame_end(callframe4322);
// compiled member node returning call4323 (depth = 12)
  partcv[0] = 0;
  Object call4324 = callmethodflags(call4323, "nameString", 1, partcv, params, 0);
  gc_frame_end(callframe4321);
// compiled member node returning call4324 (depth = 11)
  int op_slot_left_4318 = gc_frame_newslot(call4324);
  params[0] = strlit4319;
  partcv[0] = 1;
  Object opresult4325 = callmethod(call4324, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4325 (depth = 10)
  gc_frame_end(frame);
  return opresult4325;
}
Object meth_ast_4313__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1059
  setline(1059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile block node (depth = 9)
  Object block4316 = alloc_Block(NULL, NULL, "ast", 1059);
  gc_frame_newslot(block4316);
// method "_apply"
  block_savedest(block4316);
  Object closure4317 = createclosure(2, "_apply");
  setclosureframe(closure4317, stackframe);
  addtoclosure(closure4317, var_p);
  addtoclosure(closure4317, selfslot);
  struct UserObject *uo4317 = (struct UserObject*)block4316;
  uo4317->data[0] = (Object)closure4317;
  Method *meth_meth_ast_4317__apply = addmethod2pos(block4316, "_apply", &meth_ast_4317__apply, 0);
  int argcv_meth_ast_4317__apply[] = {0};
  meth_meth_ast_4317__apply->type = alloc_MethodType(1, argcv_meth_ast_4317__apply);
  meth_meth_ast_4317__apply->definitionModule = modulename;
  meth_meth_ast_4317__apply->definitionLine = 3050;
// compiled block node returning block4316 (depth = 9)
  int op_slot_right_4315 = gc_frame_newslot(block4316);
// Begin line 1059
  setline(1059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe4329 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_p (depth = 11)
  partcv[0] = 0;
  Object call4330 = callmethodflags(*var_p, "dtype", 1, partcv, params, 0);
  gc_frame_end(callframe4329);
// compiled member node returning call4330 (depth = 10)
  int op_slot_right_4328 = gc_frame_newslot(call4330);
// starting to compile identifier node (depth = 10)
  Object bool4332 = alloc_Boolean(0);
// compiled identifier node returning bool4332 (depth = 10)
  int op_slot_left_4328 = gc_frame_newslot(bool4332);
  params[0] = call4330;
  partcv[0] = 1;
  Object opresult4333 = callmethod(bool4332, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4333 (depth = 9)
  int op_slot_left_4315 = gc_frame_newslot(opresult4333);
  params[0] = block4316;
  partcv[0] = 1;
  Object opresult4334 = callmethod(opresult4333, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4334 (depth = 8)
  Object if4314 = done;
  if (istrue(opresult4334)) {
// Begin line 1061
  setline(1061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool4335 = alloc_Boolean(1);
// compiled identifier node returning bool4335 (depth = 9)
  block_return(realself, bool4335);
// compiled return node returning undefined (depth = 8)
    gc_frame_newslot(undefined);
    if4314 = undefined;
  } else {
  }
// compiled if node returning if4314 (depth = 7)
  gc_frame_end(frame);
  return if4314;
}
Object meth_ast_4310__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1058
  setline(1058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4311 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block4312 = alloc_Block(NULL, NULL, "ast", 1058);
  gc_frame_newslot(block4312);
// method "_apply(_)"
  block_savedest(block4312);
  Object closure4313 = createclosure(1, "_apply(1)");
  setclosureframe(closure4313, stackframe);
  addtoclosure(closure4313, selfslot);
  struct UserObject *uo4313 = (struct UserObject*)block4312;
  uo4313->data[0] = (Object)closure4313;
  Method *meth_meth_ast_4313__apply_40_1_41_ = addmethod2pos(block4312, "_apply(1)", &meth_ast_4313__apply_40_1_41_, 0);
  int argcv_meth_ast_4313__apply_40_1_41_[] = {1};
  meth_meth_ast_4313__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4313__apply_40_1_41_);
  meth_meth_ast_4313__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4313__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block4312 (depth = 6)
  gc_frame_newslot(block4312);
// call case 6: other requests
// Begin line 1058
  setline(1058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe4337 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call4338 = callmethodflags(*var_part, "params", 1, partcv, params, 0);
  gc_frame_end(callframe4337);
// compiled member node returning call4338 (depth = 6)
  params[0] = block4312;
  partcv[0] = 1;
  Object call4339 = callmethodflags(call4338, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4311);
// compiled call node returning call4339 (depth = 5)
  gc_frame_end(frame);
  return call4339;
}
Object meth_ast_4307_needsArgChecks(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "needsArgChecks");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4308 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block4309 = alloc_Block(NULL, NULL, "ast", 1057);
  gc_frame_newslot(block4309);
// method "_apply(_)"
  block_savedest(block4309);
  Object closure4310 = createclosure(1, "_apply(1)");
  setclosureframe(closure4310, stackframe);
  addtoclosure(closure4310, selfslot);
  struct UserObject *uo4310 = (struct UserObject*)block4309;
  uo4310->data[0] = (Object)closure4310;
  Method *meth_meth_ast_4310__apply_40_1_41_ = addmethod2pos(block4309, "_apply(1)", &meth_ast_4310__apply_40_1_41_, 0);
  int argcv_meth_ast_4310__apply_40_1_41_[] = {1};
  meth_meth_ast_4310__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4310__apply_40_1_41_);
  meth_meth_ast_4310__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4310__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block4309 (depth = 4)
  gc_frame_newslot(block4309);
// call case 6: other requests
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4341 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4342 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4341);
// compiled member node returning call4342 (depth = 4)
  params[0] = block4309;
  partcv[0] = 1;
  Object call4343 = callmethodflags(call4342, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4308);
// compiled call node returning call4343 (depth = 3)
// Begin line 1065
  setline(1065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool4344 = alloc_Boolean(0);
// compiled identifier node returning bool4344 (depth = 4)
  return bool4344;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_4345_scope_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1070
  setline(1070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4346 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call4347 = callmethodflags(self, "symbolTable:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4346);
// compiled call node returning call4347 (depth = 3)
// Begin line 1071
  setline(1071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4348 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call4349 = callmethodflags(*var_st, "node:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4348);
// compiled call node returning call4349 (depth = 3)
  gc_frame_end(frame);
  return call4349;
}
Object meth_ast_4350_declarationKindWithAncestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1073
  setline(1073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4351 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  partcv[0] = 0;
  Object call4352 = callmethodflags(*var_k, "parameter", 1, partcv, params, 0);
  gc_frame_end(callframe4351);
// compiled member node returning call4352 (depth = 3)
  gc_frame_end(frame);
  return call4352;
}
Object meth_ast_4353_isConfidential(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isConfidential");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1075
  setline(1075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4356 = alloc_Float64(0);
// compiled num node returning num4356 (depth = 5)
  int op_slot_right_4355 = gc_frame_newslot(num4356);
// starting to compile member node (depth = 5)
  int callframe4358 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4359 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4360 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4359);
// compiled member node returning call4360 (depth = 6)
  partcv[0] = 0;
  Object call4361 = callmethodflags(call4360, "size", 1, partcv, params, 0);
  gc_frame_end(callframe4358);
// compiled member node returning call4361 (depth = 5)
  int op_slot_left_4355 = gc_frame_newslot(call4361);
  params[0] = num4356;
  partcv[0] = 1;
  Object opresult4362 = callmethod(call4361, "==(1)", 1, partcv, params);
// compiled op node returning opresult4362 (depth = 4)
  Object if4354 = done;
  if (istrue(opresult4362)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4363 = alloc_Boolean(0);
// compiled identifier node returning bool4363 (depth = 5)
  return bool4363;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if4354 = undefined;
  } else {
  }
// compiled if node returning if4354 (depth = 3)
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4364 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit4365 == NULL) {
    strlit4365 = alloc_String("confidential");
    gc_root(strlit4365);
  }
// compiled string node returning strlit4365 (depth = 4)
  gc_frame_newslot(strlit4365);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  params[1] = strlit4365;
  partcv[0] = 2;
  Object call4366 = callmethodflags(module_ast, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4364);
// compiled call node returning call4366 (depth = 3)
  gc_frame_end(frame);
  return call4366;
}
Object meth_ast_4367_isPublic(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1078
  setline(1078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4368 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4369 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4370 = callmethodflags(self, "isConfidential", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4369);
// compiled member node returning call4370 (depth = 4)
  partcv[0] = 0;
  Object call4371 = callmethodflags(call4370, "not", 1, partcv, params, 0);
  gc_frame_end(callframe4368);
// compiled member node returning call4371 (depth = 3)
  gc_frame_end(frame);
  return call4371;
}
Object meth_ast_4372_isWritable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1079
  setline(1079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4373 = alloc_Boolean(0);
// compiled identifier node returning bool4373 (depth = 3)
  gc_frame_end(frame);
  return bool4373;
}
Object meth_ast_4374_isReadable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4375 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4376 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4375);
// compiled member node returning call4376 (depth = 3)
  gc_frame_end(frame);
  return call4376;
}
Object meth_ast_4377_usesAsType_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part usesAsType(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1082
  setline(1082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4379 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4380 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4379);
// compiled member node returning call4380 (depth = 4)
  int op_slot_right_4378 = gc_frame_newslot(call4380);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_4378 = gc_frame_newslot(*var_aNode);
  params[0] = call4380;
  partcv[0] = 1;
  Object opresult4382 = callmethod(*var_aNode, "==(1)", 1, partcv, params);
// compiled op node returning opresult4382 (depth = 3)
  gc_frame_end(frame);
  return opresult4382;
}
Object meth_ast_4386__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 5)
  int callframe4387 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4388 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4389 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4390 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4389);
// compiled member node returning call4390 (depth = 7)
  partcv[0] = 0;
  Object call4391 = callmethodflags(call4390, "last", 1, partcv, params, 0);
  gc_frame_end(callframe4388);
// compiled member node returning call4391 (depth = 6)
  partcv[0] = 0;
  Object call4392 = callmethodflags(call4391, "returnsObject", 1, partcv, params, 0);
  gc_frame_end(callframe4387);
// compiled member node returning call4392 (depth = 5)
  gc_frame_end(frame);
  return call4392;
}
Object meth_ast_4383_returnsObject(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1085
  setline(1085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile block node (depth = 4)
  Object block4385 = alloc_Block(NULL, NULL, "ast", 1085);
  gc_frame_newslot(block4385);
// method "_apply"
  block_savedest(block4385);
  Object closure4386 = createclosure(1, "_apply");
  setclosureframe(closure4386, stackframe);
  addtoclosure(closure4386, selfslot);
  struct UserObject *uo4386 = (struct UserObject*)block4385;
  uo4386->data[0] = (Object)closure4386;
  Method *meth_meth_ast_4386__apply = addmethod2pos(block4385, "_apply", &meth_ast_4386__apply, 0);
  int argcv_meth_ast_4386__apply[] = {0};
  meth_meth_ast_4386__apply->type = alloc_MethodType(1, argcv_meth_ast_4386__apply);
  meth_meth_ast_4386__apply->definitionModule = modulename;
  meth_meth_ast_4386__apply->definitionLine = 3050;
// compiled block node returning block4385 (depth = 4)
  int op_slot_right_4384 = gc_frame_newslot(block4385);
// starting to compile member node (depth = 4)
  int callframe4395 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4396 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4397 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4398 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4397);
// compiled member node returning call4398 (depth = 6)
  partcv[0] = 0;
  Object call4399 = callmethodflags(call4398, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe4396);
// compiled member node returning call4399 (depth = 5)
  partcv[0] = 0;
  Object call4400 = callmethodflags(call4399, "not", 1, partcv, params, 0);
  gc_frame_end(callframe4395);
// compiled member node returning call4400 (depth = 4)
  int op_slot_left_4384 = gc_frame_newslot(call4400);
  params[0] = block4385;
  partcv[0] = 1;
  Object opresult4401 = callmethod(call4400, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4401 (depth = 3)
  gc_frame_end(frame);
  return opresult4401;
}
Object meth_ast_4402_returnedObjectScope(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1089
  setline(1089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4403 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4404 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4405 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4406 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4405);
// compiled member node returning call4406 (depth = 5)
  partcv[0] = 0;
  Object call4407 = callmethodflags(call4406, "last", 1, partcv, params, 0);
  gc_frame_end(callframe4404);
// compiled member node returning call4407 (depth = 4)
  partcv[0] = 0;
  Object call4408 = callmethodflags(call4407, "returnedObjectScope", 1, partcv, params, 0);
  gc_frame_end(callframe4403);
// compiled member node returning call4408 (depth = 3)
  gc_frame_end(frame);
  return call4408;
}
Object meth_ast_4409_resultExpression(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "resultExpression");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_last = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "last");
// definebindings:
// definebindings:
// Begin line 1092
  setline(1092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4411 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4412 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4413 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4412);
// compiled member node returning call4413 (depth = 5)
  partcv[0] = 0;
  Object call4414 = callmethodflags(call4413, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe4411);
// compiled member node returning call4414 (depth = 4)
  Object if4410 = done;
  if (istrue(call4414)) {
// starting to compile call node (depth = 4)
  int callframe4415 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4416 == NULL) {
    strlit4416 = alloc_String("method has no body");
    gc_root(strlit4416);
  }
// compiled string node returning strlit4416 (depth = 5)
  gc_frame_newslot(strlit4416);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4417 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4418 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4417);
// compiled member node returning call4418 (depth = 5)
  params[0] = strlit4416;
  partcv[0] = 1;
  Object call4419 = callmethodflags(call4418, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4415);
// compiled call node returning call4419 (depth = 4)
    gc_frame_newslot(call4419);
    if4410 = call4419;
  } else {
  }
// compiled if node returning if4410 (depth = 3)
// Begin line 1093
  setline(1093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4420 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4421 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4422 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4421);
// compiled member node returning call4422 (depth = 5)
  partcv[0] = 0;
  Object call4423 = callmethodflags(call4422, "last", 1, partcv, params, 0);
  gc_frame_end(callframe4420);
// compiled member node returning call4423 (depth = 4)
  *var_last = call4423;
  if (call4423 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1094
  setline(1094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4425 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_last (depth = 5)
  partcv[0] = 0;
  Object call4426 = callmethodflags(*var_last, "isReturn", 1, partcv, params, 0);
  gc_frame_end(callframe4425);
// compiled member node returning call4426 (depth = 4)
  Object if4424 = done;
  if (istrue(call4426)) {
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4427 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_last (depth = 6)
  partcv[0] = 0;
  Object call4428 = callmethodflags(*var_last, "value", 1, partcv, params, 0);
  gc_frame_end(callframe4427);
// compiled member node returning call4428 (depth = 5)
  *var_last = call4428;
  if (call4428 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4424 = done;
  } else {
  }
// compiled if node returning if4424 (depth = 3)
// Begin line 1095
  setline(1095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_last (depth = 3)
  gc_frame_end(frame);
  return *var_last;
}
Object meth_ast_4460__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1106
  setline(1106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4461 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_visitor (depth = 9)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newChain (depth = 9)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_p (depth = 9)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4462 = callmethodflags(*var_p, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4461);
// compiled call node returning call4462 (depth = 8)
  gc_frame_end(frame);
  return call4462;
}
Object meth_ast_4455__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1105
  setline(1105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4456 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe4457 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call4458 = callmethodflags(*var_part, "params", 1, partcv, params, 0);
  gc_frame_end(callframe4457);
// compiled member node returning call4458 (depth = 7)
  gc_frame_newslot(call4458);
// starting to compile block node (depth = 7)
  Object block4459 = alloc_Block(NULL, NULL, "ast", 1105);
  gc_frame_newslot(block4459);
// method "_apply(_)"
  block_savedest(block4459);
  Object closure4460 = createclosure(3, "_apply(1)");
  setclosureframe(closure4460, stackframe);
  addtoclosure(closure4460, var_visitor);
  addtoclosure(closure4460, var_newChain);
  addtoclosure(closure4460, selfslot);
  struct UserObject *uo4460 = (struct UserObject*)block4459;
  uo4460->data[0] = (Object)closure4460;
  Method *meth_meth_ast_4460__apply_40_1_41_ = addmethod2pos(block4459, "_apply(1)", &meth_ast_4460__apply_40_1_41_, 0);
  int argcv_meth_ast_4460__apply_40_1_41_[] = {1};
  meth_meth_ast_4460__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4460__apply_40_1_41_);
  meth_meth_ast_4460__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4460__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block4459 (depth = 7)
  gc_frame_newslot(block4459);
// call case 5: prelude request
  params[0] = call4458;
  params[1] = block4459;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4464 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4456);
// compiled call node returning call4464 (depth = 6)
  gc_frame_end(frame);
  return call4464;
}
Object meth_ast_4482__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1113
  setline(1113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4483 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4484 = callmethodflags(*var_ann, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4483);
// compiled call node returning call4484 (depth = 6)
  gc_frame_end(frame);
  return call4484;
}
Object meth_ast_4491__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1116
  setline(1116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4492 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4493 = callmethodflags(*var_mx, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4492);
// compiled call node returning call4493 (depth = 6)
  gc_frame_end(frame);
  return call4493;
}
Object meth_ast_4430_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1098
  setline(1098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4432 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4433 = callmethodflags(*var_visitor, "visitMethod(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4432);
// compiled call node returning call4433 (depth = 4)
  Object if4431 = done;
  if (istrue(call4433)) {
// Begin line 1099
  setline(1099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4434 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call4435 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4434);
// compiled call node returning call4435 (depth = 5)
  *var_newChain = call4435;
  if (call4435 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1100
  setline(1100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4436 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4437 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4438 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4437);
// compiled member node returning call4438 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4439 = callmethodflags(call4438, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4436);
// compiled call node returning call4439 (depth = 4)
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4442 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4443 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4442);
// compiled member node returning call4443 (depth = 6)
  int op_slot_right_4441 = gc_frame_newslot(call4443);
// starting to compile identifier node (depth = 6)
  Object bool4445 = alloc_Boolean(0);
// compiled identifier node returning bool4445 (depth = 6)
  int op_slot_left_4441 = gc_frame_newslot(bool4445);
  params[0] = call4443;
  partcv[0] = 1;
  Object opresult4446 = callmethod(bool4445, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4446 (depth = 5)
  Object if4440 = done;
  if (istrue(opresult4446)) {
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4447 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4448 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4449 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4448);
// compiled member node returning call4449 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4450 = callmethodflags(call4449, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4447);
// compiled call node returning call4450 (depth = 5)
    gc_frame_newslot(call4450);
    if4440 = call4450;
  } else {
  }
// compiled if node returning if4440 (depth = 4)
// Begin line 1104
  setline(1104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4451 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4452 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4453 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4452);
// compiled member node returning call4453 (depth = 5)
  gc_frame_newslot(call4453);
// starting to compile block node (depth = 5)
  Object block4454 = alloc_Block(NULL, NULL, "ast", 1104);
  gc_frame_newslot(block4454);
// method "_apply(_)"
  block_savedest(block4454);
  Object closure4455 = createclosure(3, "_apply(1)");
  setclosureframe(closure4455, stackframe);
  addtoclosure(closure4455, var_visitor);
  addtoclosure(closure4455, var_newChain);
  addtoclosure(closure4455, selfslot);
  struct UserObject *uo4455 = (struct UserObject*)block4454;
  uo4455->data[0] = (Object)closure4455;
  Method *meth_meth_ast_4455__apply_40_1_41_ = addmethod2pos(block4454, "_apply(1)", &meth_ast_4455__apply_40_1_41_, 0);
  int argcv_meth_ast_4455__apply_40_1_41_[] = {1};
  meth_meth_ast_4455__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4455__apply_40_1_41_);
  meth_meth_ast_4455__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4455__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block4454 (depth = 5)
  gc_frame_newslot(block4454);
// call case 5: prelude request
  params[0] = call4453;
  params[1] = block4454;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4466 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4451);
// compiled call node returning call4466 (depth = 4)
// Begin line 1109
  setline(1109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4469 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4470 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4469);
// compiled member node returning call4470 (depth = 6)
  int op_slot_right_4468 = gc_frame_newslot(call4470);
// starting to compile identifier node (depth = 6)
  Object bool4472 = alloc_Boolean(0);
// compiled identifier node returning bool4472 (depth = 6)
  int op_slot_left_4468 = gc_frame_newslot(bool4472);
  params[0] = call4470;
  partcv[0] = 1;
  Object opresult4473 = callmethod(bool4472, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4473 (depth = 5)
  Object if4467 = done;
  if (istrue(opresult4473)) {
// Begin line 1110
  setline(1110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4474 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4475 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4476 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4475);
// compiled member node returning call4476 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4477 = callmethodflags(call4476, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4474);
// compiled call node returning call4477 (depth = 5)
    gc_frame_newslot(call4477);
    if4467 = call4477;
  } else {
  }
// compiled if node returning if4467 (depth = 4)
// Begin line 1112
  setline(1112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4478 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4479 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4480 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4479);
// compiled member node returning call4480 (depth = 5)
  gc_frame_newslot(call4480);
// starting to compile block node (depth = 5)
  Object block4481 = alloc_Block(NULL, NULL, "ast", 1112);
  gc_frame_newslot(block4481);
// method "_apply(_)"
  block_savedest(block4481);
  Object closure4482 = createclosure(3, "_apply(1)");
  setclosureframe(closure4482, stackframe);
  addtoclosure(closure4482, var_visitor);
  addtoclosure(closure4482, var_newChain);
  addtoclosure(closure4482, selfslot);
  struct UserObject *uo4482 = (struct UserObject*)block4481;
  uo4482->data[0] = (Object)closure4482;
  Method *meth_meth_ast_4482__apply_40_1_41_ = addmethod2pos(block4481, "_apply(1)", &meth_ast_4482__apply_40_1_41_, 0);
  int argcv_meth_ast_4482__apply_40_1_41_[] = {1};
  meth_meth_ast_4482__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4482__apply_40_1_41_);
  meth_meth_ast_4482__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4482__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block4481 (depth = 5)
  gc_frame_newslot(block4481);
// call case 5: prelude request
  params[0] = call4480;
  params[1] = block4481;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4486 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4478);
// compiled call node returning call4486 (depth = 4)
// Begin line 1115
  setline(1115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4487 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4488 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4489 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4488);
// compiled member node returning call4489 (depth = 5)
  gc_frame_newslot(call4489);
// starting to compile block node (depth = 5)
  Object block4490 = alloc_Block(NULL, NULL, "ast", 1115);
  gc_frame_newslot(block4490);
// method "_apply(_)"
  block_savedest(block4490);
  Object closure4491 = createclosure(3, "_apply(1)");
  setclosureframe(closure4491, stackframe);
  addtoclosure(closure4491, var_visitor);
  addtoclosure(closure4491, var_newChain);
  addtoclosure(closure4491, selfslot);
  struct UserObject *uo4491 = (struct UserObject*)block4490;
  uo4491->data[0] = (Object)closure4491;
  Method *meth_meth_ast_4491__apply_40_1_41_ = addmethod2pos(block4490, "_apply(1)", &meth_ast_4491__apply_40_1_41_, 0);
  int argcv_meth_ast_4491__apply_40_1_41_[] = {1};
  meth_meth_ast_4491__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4491__apply_40_1_41_);
  meth_meth_ast_4491__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4491__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block4490 (depth = 5)
  gc_frame_newslot(block4490);
// call case 5: prelude request
  params[0] = call4489;
  params[1] = block4490;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4495 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4487);
// compiled call node returning call4495 (depth = 4)
    gc_frame_newslot(call4495);
    if4431 = call4495;
  } else {
  }
// compiled if node returning if4431 (depth = 3)
  gc_frame_end(frame);
  return if4431;
}
Object meth_ast_4496_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1121
  setline(1121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4497 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4498 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4497);
// compiled member node returning call4498 (depth = 4)
  *var_n = call4498;
  if (call4498 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1122
  setline(1122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4499 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call4500 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4499);
// compiled call node returning call4500 (depth = 4)
  *var_newChain = call4500;
  if (call4500 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1123
  setline(1123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4501 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4502 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4503 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4504 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4503);
// compiled member node returning call4504 (depth = 5)
  gc_frame_newslot(call4504);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call4504;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4505 = callmethodflags(module_ast, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4502);
// compiled call node returning call4505 (depth = 4)
  gc_frame_newslot(call4505);
// call case 6: other requests
// Begin line 1123
  setline(1123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4505;
  partcv[0] = 1;
  Object call4506 = callmethodflags(*var_n, "body:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4501);
// compiled call node returning call4506 (depth = 3)
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4507 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4508 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4509 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4510 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4509);
// compiled member node returning call4510 (depth = 5)
  gc_frame_newslot(call4510);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call4510;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4511 = callmethodflags(module_ast, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4508);
// compiled call node returning call4511 (depth = 4)
  gc_frame_newslot(call4511);
// call case 6: other requests
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4511;
  partcv[0] = 1;
  Object call4512 = callmethodflags(*var_n, "typeParams:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4507);
// compiled call node returning call4512 (depth = 3)
// Begin line 1125
  setline(1125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4513 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4514 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4515 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4516 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4515);
// compiled member node returning call4516 (depth = 5)
  gc_frame_newslot(call4516);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call4516;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4517 = callmethodflags(module_ast, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4514);
// compiled call node returning call4517 (depth = 4)
  gc_frame_newslot(call4517);
// call case 6: other requests
// Begin line 1125
  setline(1125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4517;
  partcv[0] = 1;
  Object call4518 = callmethodflags(*var_n, "signature:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4513);
// compiled call node returning call4518 (depth = 3)
// Begin line 1126
  setline(1126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4519 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4520 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4521 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4522 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4521);
// compiled member node returning call4522 (depth = 5)
  gc_frame_newslot(call4522);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call4522;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4523 = callmethodflags(module_ast, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4520);
// compiled call node returning call4523 (depth = 4)
  gc_frame_newslot(call4523);
// call case 6: other requests
// Begin line 1126
  setline(1126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4523;
  partcv[0] = 1;
  Object call4524 = callmethodflags(*var_n, "annotations:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4519);
// compiled call node returning call4524 (depth = 3)
// Begin line 1127
  setline(1127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4525 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4526 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4527 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4528 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4527);
// compiled member node returning call4528 (depth = 5)
  gc_frame_newslot(call4528);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call4528;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4529 = callmethodflags(module_ast, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4526);
// compiled call node returning call4529 (depth = 4)
  gc_frame_newslot(call4529);
// call case 6: other requests
// Begin line 1127
  setline(1127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4529;
  partcv[0] = 1;
  Object call4530 = callmethodflags(*var_n, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4525);
// compiled call node returning call4530 (depth = 3)
// Begin line 1128
  setline(1128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4531 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call4532 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4531);
// compiled call node returning call4532 (depth = 3)
  gc_frame_end(frame);
  return call4532;
}
Object meth_ast_4699__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4701 == NULL) {
    strlit4701 = alloc_String("");
    gc_root(strlit4701);
  }
// compiled string node returning strlit4701 (depth = 9)
  int op_slot_right_4700 = gc_frame_newslot(strlit4701);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4704 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num4706 = alloc_Float64(4);
// compiled num node returning num4706 (depth = 12)
  int op_slot_right_4705 = gc_frame_newslot(num4706);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_4705 = gc_frame_newslot(*var_depth);
  params[0] = num4706;
  partcv[0] = 1;
  Object sum4708 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4708 (depth = 11)
  gc_frame_newslot(sum4708);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_p (depth = 11)
  params[0] = sum4708;
  partcv[0] = 1;
  Object call4709 = callmethodflags(*var_p, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4704);
// compiled call node returning call4709 (depth = 10)
  int op_slot_right_4703 = gc_frame_newslot(call4709);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4712 == NULL) {
    strlit4712 = alloc_String("");
    gc_root(strlit4712);
  }
// compiled string node returning strlit4712 (depth = 11)
  int op_slot_right_4711 = gc_frame_newslot(strlit4712);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_4714 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit4717 == NULL) {
    strlit4717 = alloc_String("""\x0a""      ");
    gc_root(strlit4717);
  }
// compiled string node returning strlit4717 (depth = 13)
  int op_slot_right_4716 = gc_frame_newslot(strlit4717);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_s (depth = 14)
  int op_slot_right_4719 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 14)
  if (strlit4721 == NULL) {
    strlit4721 = alloc_String("");
    gc_root(strlit4721);
  }
// compiled string node returning strlit4721 (depth = 14)
  int op_slot_left_4719 = gc_frame_newslot(strlit4721);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4722 = callmethod(strlit4721, "++(1)", 1, partcv, params);
// compiled op node returning opresult4722 (depth = 13)
  int op_slot_left_4716 = gc_frame_newslot(opresult4722);
  params[0] = strlit4717;
  partcv[0] = 1;
  Object opresult4723 = callmethod(opresult4722, "++(1)", 1, partcv, params);
// compiled op node returning opresult4723 (depth = 12)
  int op_slot_left_4714 = gc_frame_newslot(opresult4723);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4724 = callmethod(opresult4723, "++(1)", 1, partcv, params);
// compiled op node returning opresult4724 (depth = 11)
  int op_slot_left_4711 = gc_frame_newslot(opresult4724);
  params[0] = strlit4712;
  partcv[0] = 1;
  Object opresult4725 = callmethod(opresult4724, "++(1)", 1, partcv, params);
// compiled op node returning opresult4725 (depth = 10)
  int op_slot_left_4703 = gc_frame_newslot(opresult4725);
  params[0] = call4709;
  partcv[0] = 1;
  Object opresult4726 = callmethod(opresult4725, "++(1)", 1, partcv, params);
// compiled op node returning opresult4726 (depth = 9)
  int op_slot_left_4700 = gc_frame_newslot(opresult4726);
  params[0] = strlit4701;
  partcv[0] = 1;
  Object opresult4727 = callmethod(opresult4726, "++(1)", 1, partcv, params);
// compiled op node returning opresult4727 (depth = 8)
  *var_s = opresult4727;
  if (opresult4727 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_4653__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1142
  setline(1142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4655 == NULL) {
    strlit4655 = alloc_String("");
    gc_root(strlit4655);
  }
// compiled string node returning strlit4655 (depth = 7)
  int op_slot_right_4654 = gc_frame_newslot(strlit4655);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe4658 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call4659 = callmethodflags(*var_part, "name", 1, partcv, params, 0);
  gc_frame_end(callframe4658);
// compiled member node returning call4659 (depth = 8)
  int op_slot_right_4657 = gc_frame_newslot(call4659);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4662 == NULL) {
    strlit4662 = alloc_String("Part: ");
    gc_root(strlit4662);
  }
// compiled string node returning strlit4662 (depth = 9)
  int op_slot_right_4661 = gc_frame_newslot(strlit4662);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_4664 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4667 == NULL) {
    strlit4667 = alloc_String("""\x0a""  ");
    gc_root(strlit4667);
  }
// compiled string node returning strlit4667 (depth = 11)
  int op_slot_right_4666 = gc_frame_newslot(strlit4667);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_right_4669 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 12)
  if (strlit4671 == NULL) {
    strlit4671 = alloc_String("");
    gc_root(strlit4671);
  }
// compiled string node returning strlit4671 (depth = 12)
  int op_slot_left_4669 = gc_frame_newslot(strlit4671);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4672 = callmethod(strlit4671, "++(1)", 1, partcv, params);
// compiled op node returning opresult4672 (depth = 11)
  int op_slot_left_4666 = gc_frame_newslot(opresult4672);
  params[0] = strlit4667;
  partcv[0] = 1;
  Object opresult4673 = callmethod(opresult4672, "++(1)", 1, partcv, params);
// compiled op node returning opresult4673 (depth = 10)
  int op_slot_left_4664 = gc_frame_newslot(opresult4673);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4674 = callmethod(opresult4673, "++(1)", 1, partcv, params);
// compiled op node returning opresult4674 (depth = 9)
  int op_slot_left_4661 = gc_frame_newslot(opresult4674);
  params[0] = strlit4662;
  partcv[0] = 1;
  Object opresult4675 = callmethod(opresult4674, "++(1)", 1, partcv, params);
// compiled op node returning opresult4675 (depth = 8)
  int op_slot_left_4657 = gc_frame_newslot(opresult4675);
  params[0] = call4659;
  partcv[0] = 1;
  Object opresult4676 = callmethod(opresult4675, "++(1)", 1, partcv, params);
// compiled op node returning opresult4676 (depth = 7)
  int op_slot_left_4654 = gc_frame_newslot(opresult4676);
  params[0] = strlit4655;
  partcv[0] = 1;
  Object opresult4677 = callmethod(opresult4676, "++(1)", 1, partcv, params);
// compiled op node returning opresult4677 (depth = 6)
  *var_s = opresult4677;
  if (opresult4677 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1143
  setline(1143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4680 == NULL) {
    strlit4680 = alloc_String("Parameters:");
    gc_root(strlit4680);
  }
// compiled string node returning strlit4680 (depth = 7)
  int op_slot_right_4679 = gc_frame_newslot(strlit4680);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_4682 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4685 == NULL) {
    strlit4685 = alloc_String("""\x0a""    ");
    gc_root(strlit4685);
  }
// compiled string node returning strlit4685 (depth = 9)
  int op_slot_right_4684 = gc_frame_newslot(strlit4685);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_4687 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit4689 == NULL) {
    strlit4689 = alloc_String("");
    gc_root(strlit4689);
  }
// compiled string node returning strlit4689 (depth = 10)
  int op_slot_left_4687 = gc_frame_newslot(strlit4689);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4690 = callmethod(strlit4689, "++(1)", 1, partcv, params);
// compiled op node returning opresult4690 (depth = 9)
  int op_slot_left_4684 = gc_frame_newslot(opresult4690);
  params[0] = strlit4685;
  partcv[0] = 1;
  Object opresult4691 = callmethod(opresult4690, "++(1)", 1, partcv, params);
// compiled op node returning opresult4691 (depth = 8)
  int op_slot_left_4682 = gc_frame_newslot(opresult4691);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4692 = callmethod(opresult4691, "++(1)", 1, partcv, params);
// compiled op node returning opresult4692 (depth = 7)
  int op_slot_left_4679 = gc_frame_newslot(opresult4692);
  params[0] = strlit4680;
  partcv[0] = 1;
  Object opresult4693 = callmethod(opresult4692, "++(1)", 1, partcv, params);
// compiled op node returning opresult4693 (depth = 6)
  *var_s = opresult4693;
  if (opresult4693 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1144
  setline(1144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4695 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4696 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call4697 = callmethodflags(*var_part, "params", 1, partcv, params, 0);
  gc_frame_end(callframe4696);
// compiled member node returning call4697 (depth = 6)
  gc_frame_newslot(call4697);
// starting to compile block node (depth = 6)
  Object block4698 = alloc_Block(NULL, NULL, "ast", 1144);
  gc_frame_newslot(block4698);
// method "_apply(_)"
  block_savedest(block4698);
  Object closure4699 = createclosure(4, "_apply(1)");
  setclosureframe(closure4699, stackframe);
  addtoclosure(closure4699, var_depth);
  addtoclosure(closure4699, var_spc);
  addtoclosure(closure4699, var_s);
  addtoclosure(closure4699, selfslot);
  struct UserObject *uo4699 = (struct UserObject*)block4698;
  uo4699->data[0] = (Object)closure4699;
  Method *meth_meth_ast_4699__apply_40_1_41_ = addmethod2pos(block4698, "_apply(1)", &meth_ast_4699__apply_40_1_41_, 0);
  int argcv_meth_ast_4699__apply_40_1_41_[] = {1};
  meth_meth_ast_4699__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4699__apply_40_1_41_);
  meth_meth_ast_4699__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4699__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block4698 (depth = 6)
  gc_frame_newslot(block4698);
// call case 5: prelude request
  params[0] = call4697;
  params[1] = block4698;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4730 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4695);
// compiled call node returning call4730 (depth = 5)
  gc_frame_end(frame);
  return call4730;
}
Object meth_ast_4763__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1152
  setline(1152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4765 == NULL) {
    strlit4765 = alloc_String("");
    gc_root(strlit4765);
  }
// compiled string node returning strlit4765 (depth = 8)
  int op_slot_right_4764 = gc_frame_newslot(strlit4765);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4768 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num4769 = alloc_Float64(0);
// compiled num node returning num4769 (depth = 10)
  gc_frame_newslot(num4769);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_g (depth = 10)
  params[0] = num4769;
  partcv[0] = 1;
  Object call4770 = callmethodflags(*var_g, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4768);
// compiled call node returning call4770 (depth = 9)
  int op_slot_right_4767 = gc_frame_newslot(call4770);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4773 == NULL) {
    strlit4773 = alloc_String("  ");
    gc_root(strlit4773);
  }
// compiled string node returning strlit4773 (depth = 10)
  int op_slot_right_4772 = gc_frame_newslot(strlit4773);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_4775 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit4778 == NULL) {
    strlit4778 = alloc_String("""\x0a""");
    gc_root(strlit4778);
  }
// compiled string node returning strlit4778 (depth = 12)
  int op_slot_right_4777 = gc_frame_newslot(strlit4778);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_4780 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit4782 == NULL) {
    strlit4782 = alloc_String("");
    gc_root(strlit4782);
  }
// compiled string node returning strlit4782 (depth = 13)
  int op_slot_left_4780 = gc_frame_newslot(strlit4782);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4783 = callmethod(strlit4782, "++(1)", 1, partcv, params);
// compiled op node returning opresult4783 (depth = 12)
  int op_slot_left_4777 = gc_frame_newslot(opresult4783);
  params[0] = strlit4778;
  partcv[0] = 1;
  Object opresult4784 = callmethod(opresult4783, "++(1)", 1, partcv, params);
// compiled op node returning opresult4784 (depth = 11)
  int op_slot_left_4775 = gc_frame_newslot(opresult4784);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4785 = callmethod(opresult4784, "++(1)", 1, partcv, params);
// compiled op node returning opresult4785 (depth = 10)
  int op_slot_left_4772 = gc_frame_newslot(opresult4785);
  params[0] = strlit4773;
  partcv[0] = 1;
  Object opresult4786 = callmethod(opresult4785, "++(1)", 1, partcv, params);
// compiled op node returning opresult4786 (depth = 9)
  int op_slot_left_4767 = gc_frame_newslot(opresult4786);
  params[0] = call4770;
  partcv[0] = 1;
  Object opresult4787 = callmethod(opresult4786, "++(1)", 1, partcv, params);
// compiled op node returning opresult4787 (depth = 8)
  int op_slot_left_4764 = gc_frame_newslot(opresult4787);
  params[0] = strlit4765;
  partcv[0] = 1;
  Object opresult4788 = callmethod(opresult4787, "++(1)", 1, partcv, params);
// compiled op node returning opresult4788 (depth = 7)
  *var_s = opresult4788;
  if (opresult4788 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_4828__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_an = &(stackframe->slots[0]);
  *var_an = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1159
  setline(1159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4830 == NULL) {
    strlit4830 = alloc_String("");
    gc_root(strlit4830);
  }
// compiled string node returning strlit4830 (depth = 8)
  int op_slot_right_4829 = gc_frame_newslot(strlit4830);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4833 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num4835 = alloc_Float64(2);
// compiled num node returning num4835 (depth = 11)
  int op_slot_right_4834 = gc_frame_newslot(num4835);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_4834 = gc_frame_newslot(*var_depth);
  params[0] = num4835;
  partcv[0] = 1;
  Object sum4837 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4837 (depth = 10)
  gc_frame_newslot(sum4837);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_an (depth = 10)
  params[0] = sum4837;
  partcv[0] = 1;
  Object call4838 = callmethodflags(*var_an, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4833);
// compiled call node returning call4838 (depth = 9)
  int op_slot_right_4832 = gc_frame_newslot(call4838);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4841 == NULL) {
    strlit4841 = alloc_String("  ");
    gc_root(strlit4841);
  }
// compiled string node returning strlit4841 (depth = 10)
  int op_slot_right_4840 = gc_frame_newslot(strlit4841);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_4843 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit4846 == NULL) {
    strlit4846 = alloc_String("""\x0a""");
    gc_root(strlit4846);
  }
// compiled string node returning strlit4846 (depth = 12)
  int op_slot_right_4845 = gc_frame_newslot(strlit4846);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_4848 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit4850 == NULL) {
    strlit4850 = alloc_String("");
    gc_root(strlit4850);
  }
// compiled string node returning strlit4850 (depth = 13)
  int op_slot_left_4848 = gc_frame_newslot(strlit4850);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4851 = callmethod(strlit4850, "++(1)", 1, partcv, params);
// compiled op node returning opresult4851 (depth = 12)
  int op_slot_left_4845 = gc_frame_newslot(opresult4851);
  params[0] = strlit4846;
  partcv[0] = 1;
  Object opresult4852 = callmethod(opresult4851, "++(1)", 1, partcv, params);
// compiled op node returning opresult4852 (depth = 11)
  int op_slot_left_4843 = gc_frame_newslot(opresult4852);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4853 = callmethod(opresult4852, "++(1)", 1, partcv, params);
// compiled op node returning opresult4853 (depth = 10)
  int op_slot_left_4840 = gc_frame_newslot(opresult4853);
  params[0] = strlit4841;
  partcv[0] = 1;
  Object opresult4854 = callmethod(opresult4853, "++(1)", 1, partcv, params);
// compiled op node returning opresult4854 (depth = 9)
  int op_slot_left_4832 = gc_frame_newslot(opresult4854);
  params[0] = call4838;
  partcv[0] = 1;
  Object opresult4855 = callmethod(opresult4854, "++(1)", 1, partcv, params);
// compiled op node returning opresult4855 (depth = 8)
  int op_slot_left_4829 = gc_frame_newslot(opresult4855);
  params[0] = strlit4830;
  partcv[0] = 1;
  Object opresult4856 = callmethod(opresult4855, "++(1)", 1, partcv, params);
// compiled op node returning opresult4856 (depth = 7)
  *var_s = opresult4856;
  if (opresult4856 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_4877__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1165
  setline(1165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4879 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num4881 = alloc_Float64(2);
// compiled num node returning num4881 (depth = 9)
  int op_slot_right_4880 = gc_frame_newslot(num4881);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_4880 = gc_frame_newslot(*var_depth);
  params[0] = num4881;
  partcv[0] = 1;
  Object sum4883 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4883 (depth = 8)
  gc_frame_newslot(sum4883);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum4883;
  partcv[0] = 1;
  Object call4884 = callmethodflags(*var_mx, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4879);
// compiled call node returning call4884 (depth = 7)
  int op_slot_right_4878 = gc_frame_newslot(call4884);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_4886 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4889 == NULL) {
    strlit4889 = alloc_String("""\x0a""  ");
    gc_root(strlit4889);
  }
// compiled string node returning strlit4889 (depth = 9)
  int op_slot_right_4888 = gc_frame_newslot(strlit4889);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_4888 = gc_frame_newslot(*var_s);
  params[0] = strlit4889;
  partcv[0] = 1;
  Object opresult4891 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4891 (depth = 8)
  int op_slot_left_4886 = gc_frame_newslot(opresult4891);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4892 = callmethod(opresult4891, "++(1)", 1, partcv, params);
// compiled op node returning opresult4892 (depth = 7)
  int op_slot_left_4878 = gc_frame_newslot(opresult4892);
  params[0] = call4884;
  partcv[0] = 1;
  Object opresult4893 = callmethod(opresult4892, "++(1)", 1, partcv, params);
// compiled op node returning opresult4893 (depth = 6)
  *var_s = opresult4893;
  if (opresult4893 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_4533_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1131
  setline(1131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4536 = alloc_Float64(1);
// compiled num node returning num4536 (depth = 6)
  int op_slot_right_4535 = gc_frame_newslot(num4536);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_4535 = gc_frame_newslot(*var_depth);
  params[0] = num4536;
  partcv[0] = 1;
  Object sum4538 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4538 (depth = 5)
  int op_slot_right_4534 = gc_frame_newslot(sum4538);
// starting to compile string node (depth = 5)
  if (strlit4540 == NULL) {
    strlit4540 = alloc_String("  ");
    gc_root(strlit4540);
  }
// compiled string node returning strlit4540 (depth = 5)
  int op_slot_left_4534 = gc_frame_newslot(strlit4540);
  params[0] = sum4538;
  partcv[0] = 1;
  Object prod4541 = callmethod(strlit4540, "*(1)", 1, partcv, params);
// compiled op node returning prod4541 (depth = 4)
  *var_spc = prod4541;
  if (prod4541 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1132
  setline(1132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4543 == NULL) {
    strlit4543 = alloc_String("""\x0a""");
    gc_root(strlit4543);
  }
// compiled string node returning strlit4543 (depth = 5)
  int op_slot_right_4542 = gc_frame_newslot(strlit4543);
// starting to compile call node (depth = 5)
  int callframe4545 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call4546 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4545);
// compiled call node returning call4546 (depth = 5)
  int op_slot_left_4542 = gc_frame_newslot(call4546);
  params[0] = strlit4543;
  partcv[0] = 1;
  Object opresult4547 = callmethod(call4546, "++(1)", 1, partcv, params);
// compiled op node returning opresult4547 (depth = 4)
  *var_s = opresult4547;
  if (opresult4547 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1133
  setline(1133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4549 == NULL) {
    strlit4549 = alloc_String("""\x0a""");
    gc_root(strlit4549);
  }
// compiled string node returning strlit4549 (depth = 5)
  int op_slot_right_4548 = gc_frame_newslot(strlit4549);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4552 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num4554 = alloc_Float64(1);
// compiled num node returning num4554 (depth = 8)
  int op_slot_right_4553 = gc_frame_newslot(num4554);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_4553 = gc_frame_newslot(*var_depth);
  params[0] = num4554;
  partcv[0] = 1;
  Object sum4556 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4556 (depth = 7)
  gc_frame_newslot(sum4556);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4557 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4558 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4557);
// compiled member node returning call4558 (depth = 7)
  params[0] = sum4556;
  partcv[0] = 1;
  Object call4559 = callmethodflags(call4558, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4552);
// compiled call node returning call4559 (depth = 6)
  int op_slot_right_4551 = gc_frame_newslot(call4559);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4562 == NULL) {
    strlit4562 = alloc_String("Name: ");
    gc_root(strlit4562);
  }
// compiled string node returning strlit4562 (depth = 7)
  int op_slot_right_4561 = gc_frame_newslot(strlit4562);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_4564 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4564 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4566 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4566 (depth = 7)
  int op_slot_left_4561 = gc_frame_newslot(opresult4566);
  params[0] = strlit4562;
  partcv[0] = 1;
  Object opresult4567 = callmethod(opresult4566, "++(1)", 1, partcv, params);
// compiled op node returning opresult4567 (depth = 6)
  int op_slot_left_4551 = gc_frame_newslot(opresult4567);
  params[0] = call4559;
  partcv[0] = 1;
  Object opresult4568 = callmethod(opresult4567, "++(1)", 1, partcv, params);
// compiled op node returning opresult4568 (depth = 5)
  int op_slot_left_4548 = gc_frame_newslot(opresult4568);
  params[0] = strlit4549;
  partcv[0] = 1;
  Object opresult4569 = callmethod(opresult4568, "++(1)", 1, partcv, params);
// compiled op node returning opresult4569 (depth = 4)
  *var_s = opresult4569;
  if (opresult4569 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1134
  setline(1134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4573 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4574 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4573);
// compiled member node returning call4574 (depth = 5)
  int op_slot_right_4572 = gc_frame_newslot(call4574);
// starting to compile identifier node (depth = 5)
  Object bool4576 = alloc_Boolean(0);
// compiled identifier node returning bool4576 (depth = 5)
  int op_slot_left_4572 = gc_frame_newslot(bool4576);
  params[0] = call4574;
  partcv[0] = 1;
  Object opresult4577 = callmethod(bool4576, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4577 (depth = 4)
  Object if4571 = done;
  if (istrue(opresult4577)) {
// Begin line 1135
  setline(1135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4579 == NULL) {
    strlit4579 = alloc_String("  ");
    gc_root(strlit4579);
  }
// compiled string node returning strlit4579 (depth = 6)
  int op_slot_right_4578 = gc_frame_newslot(strlit4579);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4581 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4584 == NULL) {
    strlit4584 = alloc_String("Returns:""\x0a""");
    gc_root(strlit4584);
  }
// compiled string node returning strlit4584 (depth = 8)
  int op_slot_right_4583 = gc_frame_newslot(strlit4584);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_4586 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_4586 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4588 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4588 (depth = 8)
  int op_slot_left_4583 = gc_frame_newslot(opresult4588);
  params[0] = strlit4584;
  partcv[0] = 1;
  Object opresult4589 = callmethod(opresult4588, "++(1)", 1, partcv, params);
// compiled op node returning opresult4589 (depth = 7)
  int op_slot_left_4581 = gc_frame_newslot(opresult4589);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4590 = callmethod(opresult4589, "++(1)", 1, partcv, params);
// compiled op node returning opresult4590 (depth = 6)
  int op_slot_left_4578 = gc_frame_newslot(opresult4590);
  params[0] = strlit4579;
  partcv[0] = 1;
  Object opresult4591 = callmethod(opresult4590, "++(1)", 1, partcv, params);
// compiled op node returning opresult4591 (depth = 5)
  *var_s = opresult4591;
  if (opresult4591 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1136
  setline(1136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4594 == NULL) {
    strlit4594 = alloc_String("""\x0a""");
    gc_root(strlit4594);
  }
// compiled string node returning strlit4594 (depth = 6)
  int op_slot_right_4593 = gc_frame_newslot(strlit4594);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4597 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num4599 = alloc_Float64(2);
// compiled num node returning num4599 (depth = 9)
  int op_slot_right_4598 = gc_frame_newslot(num4599);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_4598 = gc_frame_newslot(*var_depth);
  params[0] = num4599;
  partcv[0] = 1;
  Object sum4601 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4601 (depth = 8)
  gc_frame_newslot(sum4601);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4602 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4603 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4602);
// compiled member node returning call4603 (depth = 8)
  params[0] = sum4601;
  partcv[0] = 1;
  Object call4604 = callmethodflags(call4603, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4597);
// compiled call node returning call4604 (depth = 7)
  int op_slot_right_4596 = gc_frame_newslot(call4604);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4596 = gc_frame_newslot(*var_s);
  params[0] = call4604;
  partcv[0] = 1;
  Object opresult4606 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4606 (depth = 6)
  int op_slot_left_4593 = gc_frame_newslot(opresult4606);
  params[0] = strlit4594;
  partcv[0] = 1;
  Object opresult4607 = callmethod(opresult4606, "++(1)", 1, partcv, params);
// compiled op node returning opresult4607 (depth = 5)
  *var_s = opresult4607;
  if (opresult4607 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4571 = done;
  } else {
  }
// compiled if node returning if4571 (depth = 3)
// Begin line 1138
  setline(1138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4610 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4611 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4612 = callmethodflags(self, "isBindingOccurence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4611);
// compiled member node returning call4612 (depth = 5)
  partcv[0] = 0;
  Object call4613 = callmethodflags(call4612, "not", 1, partcv, params, 0);
  gc_frame_end(callframe4610);
// compiled member node returning call4613 (depth = 4)
  Object if4609 = done;
  if (istrue(call4613)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4615 == NULL) {
    strlit4615 = alloc_String("Applied""\x0a""");
    gc_root(strlit4615);
  }
// compiled string node returning strlit4615 (depth = 6)
  int op_slot_right_4614 = gc_frame_newslot(strlit4615);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4617 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4617 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4619 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4619 (depth = 6)
  int op_slot_left_4614 = gc_frame_newslot(opresult4619);
  params[0] = strlit4615;
  partcv[0] = 1;
  Object opresult4620 = callmethod(opresult4619, "++(1)", 1, partcv, params);
// compiled op node returning opresult4620 (depth = 5)
  *var_s = opresult4620;
  if (opresult4620 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4609 = done;
  } else {
  }
// compiled if node returning if4609 (depth = 3)
// Begin line 1139
  setline(1139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4623 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4624 = callmethodflags(self, "isFresh", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4623);
// compiled member node returning call4624 (depth = 4)
  Object if4622 = done;
  if (istrue(call4624)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4626 == NULL) {
    strlit4626 = alloc_String("Fresh""\x0a""");
    gc_root(strlit4626);
  }
// compiled string node returning strlit4626 (depth = 6)
  int op_slot_right_4625 = gc_frame_newslot(strlit4626);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4628 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4628 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4630 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4630 (depth = 6)
  int op_slot_left_4625 = gc_frame_newslot(opresult4630);
  params[0] = strlit4626;
  partcv[0] = 1;
  Object opresult4631 = callmethod(opresult4630, "++(1)", 1, partcv, params);
// compiled op node returning opresult4631 (depth = 5)
  *var_s = opresult4631;
  if (opresult4631 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4622 = done;
  } else {
  }
// compiled if node returning if4622 (depth = 3)
// Begin line 1140
  setline(1140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4634 == NULL) {
    strlit4634 = alloc_String("Signature:");
    gc_root(strlit4634);
  }
// compiled string node returning strlit4634 (depth = 5)
  int op_slot_right_4633 = gc_frame_newslot(strlit4634);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_4636 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4639 == NULL) {
    strlit4639 = alloc_String("");
    gc_root(strlit4639);
  }
// compiled string node returning strlit4639 (depth = 7)
  int op_slot_right_4638 = gc_frame_newslot(strlit4639);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_right_4641 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 8)
  if (strlit4643 == NULL) {
    strlit4643 = alloc_String("");
    gc_root(strlit4643);
  }
// compiled string node returning strlit4643 (depth = 8)
  int op_slot_left_4641 = gc_frame_newslot(strlit4643);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4644 = callmethod(strlit4643, "++(1)", 1, partcv, params);
// compiled op node returning opresult4644 (depth = 7)
  int op_slot_left_4638 = gc_frame_newslot(opresult4644);
  params[0] = strlit4639;
  partcv[0] = 1;
  Object opresult4645 = callmethod(opresult4644, "++(1)", 1, partcv, params);
// compiled op node returning opresult4645 (depth = 6)
  int op_slot_left_4636 = gc_frame_newslot(opresult4645);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4646 = callmethod(opresult4645, "++(1)", 1, partcv, params);
// compiled op node returning opresult4646 (depth = 5)
  int op_slot_left_4633 = gc_frame_newslot(opresult4646);
  params[0] = strlit4634;
  partcv[0] = 1;
  Object opresult4647 = callmethod(opresult4646, "++(1)", 1, partcv, params);
// compiled op node returning opresult4647 (depth = 4)
  *var_s = opresult4647;
  if (opresult4647 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1141
  setline(1141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4649 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4650 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4651 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4650);
// compiled member node returning call4651 (depth = 4)
  gc_frame_newslot(call4651);
// starting to compile block node (depth = 4)
  Object block4652 = alloc_Block(NULL, NULL, "ast", 1141);
  gc_frame_newslot(block4652);
// method "_apply(_)"
  block_savedest(block4652);
  Object closure4653 = createclosure(4, "_apply(1)");
  setclosureframe(closure4653, stackframe);
  addtoclosure(closure4653, var_spc);
  addtoclosure(closure4653, var_s);
  addtoclosure(closure4653, var_depth);
  addtoclosure(closure4653, selfslot);
  struct UserObject *uo4653 = (struct UserObject*)block4652;
  uo4653->data[0] = (Object)closure4653;
  Method *meth_meth_ast_4653__apply_40_1_41_ = addmethod2pos(block4652, "_apply(1)", &meth_ast_4653__apply_40_1_41_, 0);
  int argcv_meth_ast_4653__apply_40_1_41_[] = {1};
  meth_meth_ast_4653__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4653__apply_40_1_41_);
  meth_meth_ast_4653__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4653__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block4652 (depth = 4)
  gc_frame_newslot(block4652);
// call case 5: prelude request
  params[0] = call4651;
  params[1] = block4652;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4732 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4649);
// compiled call node returning call4732 (depth = 3)
// Begin line 1148
  setline(1148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4734 == NULL) {
    strlit4734 = alloc_String("""\x0a""");
    gc_root(strlit4734);
  }
// compiled string node returning strlit4734 (depth = 5)
  int op_slot_right_4733 = gc_frame_newslot(strlit4734);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_4733 = gc_frame_newslot(*var_s);
  params[0] = strlit4734;
  partcv[0] = 1;
  Object opresult4736 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4736 (depth = 4)
  *var_s = opresult4736;
  if (opresult4736 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1149
  setline(1149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4740 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4741 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4740);
// compiled member node returning call4741 (depth = 5)
  int op_slot_right_4739 = gc_frame_newslot(call4741);
// starting to compile identifier node (depth = 5)
  Object bool4743 = alloc_Boolean(0);
// compiled identifier node returning bool4743 (depth = 5)
  int op_slot_left_4739 = gc_frame_newslot(bool4743);
  params[0] = call4741;
  partcv[0] = 1;
  Object opresult4744 = callmethod(bool4743, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4744 (depth = 4)
  Object if4738 = done;
  if (istrue(opresult4744)) {
// Begin line 1150
  setline(1150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4746 == NULL) {
    strlit4746 = alloc_String("Generics:");
    gc_root(strlit4746);
  }
// compiled string node returning strlit4746 (depth = 6)
  int op_slot_right_4745 = gc_frame_newslot(strlit4746);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4748 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4751 == NULL) {
    strlit4751 = alloc_String("");
    gc_root(strlit4751);
  }
// compiled string node returning strlit4751 (depth = 8)
  int op_slot_right_4750 = gc_frame_newslot(strlit4751);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_4753 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit4755 == NULL) {
    strlit4755 = alloc_String("");
    gc_root(strlit4755);
  }
// compiled string node returning strlit4755 (depth = 9)
  int op_slot_left_4753 = gc_frame_newslot(strlit4755);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4756 = callmethod(strlit4755, "++(1)", 1, partcv, params);
// compiled op node returning opresult4756 (depth = 8)
  int op_slot_left_4750 = gc_frame_newslot(opresult4756);
  params[0] = strlit4751;
  partcv[0] = 1;
  Object opresult4757 = callmethod(opresult4756, "++(1)", 1, partcv, params);
// compiled op node returning opresult4757 (depth = 7)
  int op_slot_left_4748 = gc_frame_newslot(opresult4757);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4758 = callmethod(opresult4757, "++(1)", 1, partcv, params);
// compiled op node returning opresult4758 (depth = 6)
  int op_slot_left_4745 = gc_frame_newslot(opresult4758);
  params[0] = strlit4746;
  partcv[0] = 1;
  Object opresult4759 = callmethod(opresult4758, "++(1)", 1, partcv, params);
// compiled op node returning opresult4759 (depth = 5)
  *var_s = opresult4759;
  if (opresult4759 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1151
  setline(1151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4761 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block4762 = alloc_Block(NULL, NULL, "ast", 1151);
  gc_frame_newslot(block4762);
// method "_apply(_)"
  block_savedest(block4762);
  Object closure4763 = createclosure(3, "_apply(1)");
  setclosureframe(closure4763, stackframe);
  addtoclosure(closure4763, var_spc);
  addtoclosure(closure4763, var_s);
  addtoclosure(closure4763, selfslot);
  struct UserObject *uo4763 = (struct UserObject*)block4762;
  uo4763->data[0] = (Object)closure4763;
  Method *meth_meth_ast_4763__apply_40_1_41_ = addmethod2pos(block4762, "_apply(1)", &meth_ast_4763__apply_40_1_41_, 0);
  int argcv_meth_ast_4763__apply_40_1_41_[] = {1};
  meth_meth_ast_4763__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4763__apply_40_1_41_);
  meth_meth_ast_4763__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4763__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block4762 (depth = 5)
  gc_frame_newslot(block4762);
// call case 6: other requests
// Begin line 1151
  setline(1151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4791 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4792 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4791);
// compiled member node returning call4792 (depth = 5)
  params[0] = block4762;
  partcv[0] = 1;
  Object call4793 = callmethodflags(call4792, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4761);
// compiled call node returning call4793 (depth = 4)
// Begin line 1154
  setline(1154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4795 == NULL) {
    strlit4795 = alloc_String("""\x0a""");
    gc_root(strlit4795);
  }
// compiled string node returning strlit4795 (depth = 6)
  int op_slot_right_4794 = gc_frame_newslot(strlit4795);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4794 = gc_frame_newslot(*var_s);
  params[0] = strlit4795;
  partcv[0] = 1;
  Object opresult4797 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4797 (depth = 5)
  *var_s = opresult4797;
  if (opresult4797 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4738 = done;
  } else {
  }
// compiled if node returning if4738 (depth = 3)
// Begin line 1156
  setline(1156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4801 = alloc_Float64(0);
// compiled num node returning num4801 (depth = 5)
  int op_slot_right_4800 = gc_frame_newslot(num4801);
// starting to compile member node (depth = 5)
  int callframe4803 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4804 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4805 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4804);
// compiled member node returning call4805 (depth = 6)
  partcv[0] = 0;
  Object call4806 = callmethodflags(call4805, "size", 1, partcv, params, 0);
  gc_frame_end(callframe4803);
// compiled member node returning call4806 (depth = 5)
  int op_slot_left_4800 = gc_frame_newslot(call4806);
  params[0] = num4801;
  partcv[0] = 1;
  Object opresult4807 = callmethod(call4806, ">(1)", 1, partcv, params);
// compiled op node returning opresult4807 (depth = 4)
  Object if4799 = done;
  if (istrue(opresult4807)) {
// Begin line 1157
  setline(1157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4809 == NULL) {
    strlit4809 = alloc_String("Annotations:");
    gc_root(strlit4809);
  }
// compiled string node returning strlit4809 (depth = 6)
  int op_slot_right_4808 = gc_frame_newslot(strlit4809);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4811 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4814 == NULL) {
    strlit4814 = alloc_String("");
    gc_root(strlit4814);
  }
// compiled string node returning strlit4814 (depth = 8)
  int op_slot_right_4813 = gc_frame_newslot(strlit4814);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_4816 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit4818 == NULL) {
    strlit4818 = alloc_String("");
    gc_root(strlit4818);
  }
// compiled string node returning strlit4818 (depth = 9)
  int op_slot_left_4816 = gc_frame_newslot(strlit4818);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4819 = callmethod(strlit4818, "++(1)", 1, partcv, params);
// compiled op node returning opresult4819 (depth = 8)
  int op_slot_left_4813 = gc_frame_newslot(opresult4819);
  params[0] = strlit4814;
  partcv[0] = 1;
  Object opresult4820 = callmethod(opresult4819, "++(1)", 1, partcv, params);
// compiled op node returning opresult4820 (depth = 7)
  int op_slot_left_4811 = gc_frame_newslot(opresult4820);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4821 = callmethod(opresult4820, "++(1)", 1, partcv, params);
// compiled op node returning opresult4821 (depth = 6)
  int op_slot_left_4808 = gc_frame_newslot(opresult4821);
  params[0] = strlit4809;
  partcv[0] = 1;
  Object opresult4822 = callmethod(opresult4821, "++(1)", 1, partcv, params);
// compiled op node returning opresult4822 (depth = 5)
  *var_s = opresult4822;
  if (opresult4822 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1158
  setline(1158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4824 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4825 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4826 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4825);
// compiled member node returning call4826 (depth = 5)
  gc_frame_newslot(call4826);
// starting to compile block node (depth = 5)
  Object block4827 = alloc_Block(NULL, NULL, "ast", 1158);
  gc_frame_newslot(block4827);
// method "_apply(_)"
  block_savedest(block4827);
  Object closure4828 = createclosure(4, "_apply(1)");
  setclosureframe(closure4828, stackframe);
  addtoclosure(closure4828, var_depth);
  addtoclosure(closure4828, var_spc);
  addtoclosure(closure4828, var_s);
  addtoclosure(closure4828, selfslot);
  struct UserObject *uo4828 = (struct UserObject*)block4827;
  uo4828->data[0] = (Object)closure4828;
  Method *meth_meth_ast_4828__apply_40_1_41_ = addmethod2pos(block4827, "_apply(1)", &meth_ast_4828__apply_40_1_41_, 0);
  int argcv_meth_ast_4828__apply_40_1_41_[] = {1};
  meth_meth_ast_4828__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4828__apply_40_1_41_);
  meth_meth_ast_4828__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4828__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block4827 (depth = 5)
  gc_frame_newslot(block4827);
// call case 5: prelude request
  params[0] = call4826;
  params[1] = block4827;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4859 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4824);
// compiled call node returning call4859 (depth = 4)
// Begin line 1161
  setline(1161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4861 == NULL) {
    strlit4861 = alloc_String("""\x0a""");
    gc_root(strlit4861);
  }
// compiled string node returning strlit4861 (depth = 6)
  int op_slot_right_4860 = gc_frame_newslot(strlit4861);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4860 = gc_frame_newslot(*var_s);
  params[0] = strlit4861;
  partcv[0] = 1;
  Object opresult4863 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4863 (depth = 5)
  *var_s = opresult4863;
  if (opresult4863 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4799 = done;
  } else {
  }
// compiled if node returning if4799 (depth = 3)
// Begin line 1163
  setline(1163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4866 == NULL) {
    strlit4866 = alloc_String("Body:");
    gc_root(strlit4866);
  }
// compiled string node returning strlit4866 (depth = 5)
  int op_slot_right_4865 = gc_frame_newslot(strlit4866);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_4868 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4868 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4870 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4870 (depth = 5)
  int op_slot_left_4865 = gc_frame_newslot(opresult4870);
  params[0] = strlit4866;
  partcv[0] = 1;
  Object opresult4871 = callmethod(opresult4870, "++(1)", 1, partcv, params);
// compiled op node returning opresult4871 (depth = 4)
  *var_s = opresult4871;
  if (opresult4871 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1164
  setline(1164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4873 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4874 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4875 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4874);
// compiled member node returning call4875 (depth = 4)
  gc_frame_newslot(call4875);
// starting to compile block node (depth = 4)
  Object block4876 = alloc_Block(NULL, NULL, "ast", 1164);
  gc_frame_newslot(block4876);
// method "_apply(_)"
  block_savedest(block4876);
  Object closure4877 = createclosure(4, "_apply(1)");
  setclosureframe(closure4877, stackframe);
  addtoclosure(closure4877, var_depth);
  addtoclosure(closure4877, var_spc);
  addtoclosure(closure4877, var_s);
  addtoclosure(closure4877, selfslot);
  struct UserObject *uo4877 = (struct UserObject*)block4876;
  uo4877->data[0] = (Object)closure4877;
  Method *meth_meth_ast_4877__apply_40_1_41_ = addmethod2pos(block4876, "_apply(1)", &meth_ast_4877__apply_40_1_41_, 0);
  int argcv_meth_ast_4877__apply_40_1_41_[] = {1};
  meth_meth_ast_4877__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4877__apply_40_1_41_);
  meth_meth_ast_4877__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4877__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block4876 (depth = 4)
  gc_frame_newslot(block4876);
// call case 5: prelude request
  params[0] = call4875;
  params[1] = block4876;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4896 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4873);
// compiled call node returning call4896 (depth = 3)
// Begin line 1167
  setline(1167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4899 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4900 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4899);
// compiled member node returning call4900 (depth = 5)
  int op_slot_right_4898 = gc_frame_newslot(call4900);
// starting to compile identifier node (depth = 5)
  Object bool4902 = alloc_Boolean(0);
// compiled identifier node returning bool4902 (depth = 5)
  int op_slot_left_4898 = gc_frame_newslot(bool4902);
  params[0] = call4900;
  partcv[0] = 1;
  Object opresult4903 = callmethod(bool4902, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4903 (depth = 4)
  Object if4897 = done;
  if (istrue(opresult4903)) {
// Begin line 1168
  setline(1168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4905 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num4907 = alloc_Float64(2);
// compiled num node returning num4907 (depth = 8)
  int op_slot_right_4906 = gc_frame_newslot(num4907);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_4906 = gc_frame_newslot(*var_depth);
  params[0] = num4907;
  partcv[0] = 1;
  Object sum4909 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4909 (depth = 7)
  gc_frame_newslot(sum4909);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4910 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4911 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4910);
// compiled member node returning call4911 (depth = 7)
  params[0] = sum4909;
  partcv[0] = 1;
  Object call4912 = callmethodflags(call4911, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4905);
// compiled call node returning call4912 (depth = 6)
  int op_slot_right_4904 = gc_frame_newslot(call4912);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4904 = gc_frame_newslot(*var_s);
  params[0] = call4912;
  partcv[0] = 1;
  Object opresult4914 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4914 (depth = 5)
  *var_s = opresult4914;
  if (opresult4914 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4897 = done;
  } else {
  }
// compiled if node returning if4897 (depth = 3)
// Begin line 1170
  setline(1170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_4937__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe4939 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4940 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4939);
// compiled member node returning call4940 (depth = 9)
  int op_slot_right_4938 = gc_frame_newslot(call4940);
// starting to compile identifier node (depth = 9)
  Object bool4942 = alloc_Boolean(0);
// compiled identifier node returning bool4942 (depth = 9)
  int op_slot_left_4938 = gc_frame_newslot(bool4942);
  params[0] = call4940;
  partcv[0] = 1;
  Object opresult4943 = callmethod(bool4942, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4943 (depth = 8)
  gc_frame_end(frame);
  return opresult4943;
}
Object meth_ast_4981__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_part = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_pnr = &(stackframe->slots[0]);
  *var_pnr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// definebindings:
// definebindings:
// Begin line 1185
  setline(1185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4982 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_pnr (depth = 10)
  gc_frame_newslot(*var_pnr);
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe4983 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call4984 = callmethodflags(*var_part, "params", 1, partcv, params, 0);
  gc_frame_end(callframe4983);
// compiled member node returning call4984 (depth = 10)
  params[0] = *var_pnr;
  partcv[0] = 1;
  Object call4985 = callmethodflags(call4984, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4982);
// compiled call node returning call4985 (depth = 9)
  *var_p = call4985;
  if (call4985 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 1186
  setline(1186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4987 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num4989 = alloc_Float64(1);
// compiled num node returning num4989 (depth = 12)
  int op_slot_right_4988 = gc_frame_newslot(num4989);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_4988 = gc_frame_newslot(*var_depth);
  params[0] = num4989;
  partcv[0] = 1;
  Object sum4991 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4991 (depth = 11)
  gc_frame_newslot(sum4991);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_p (depth = 11)
  params[0] = sum4991;
  partcv[0] = 1;
  Object call4992 = callmethodflags(*var_p, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4987);
// compiled call node returning call4992 (depth = 10)
  int op_slot_right_4986 = gc_frame_newslot(call4992);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_4986 = gc_frame_newslot(*var_s);
  params[0] = call4992;
  partcv[0] = 1;
  Object opresult4994 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4994 (depth = 9)
  *var_s = opresult4994;
  if (opresult4994 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 1187
  setline(1187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe4998 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe4999 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_part (depth = 12)
  partcv[0] = 0;
  Object call5000 = callmethodflags(*var_part, "params", 1, partcv, params, 0);
  gc_frame_end(callframe4999);
// compiled member node returning call5000 (depth = 11)
  partcv[0] = 0;
  Object call5001 = callmethodflags(call5000, "size", 1, partcv, params, 0);
  gc_frame_end(callframe4998);
// compiled member node returning call5001 (depth = 10)
  int op_slot_right_4997 = gc_frame_newslot(call5001);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_pnr (depth = 10)
  int op_slot_left_4997 = gc_frame_newslot(*var_pnr);
  params[0] = call5001;
  partcv[0] = 1;
  Object opresult5003 = callmethod(*var_pnr, "<(1)", 1, partcv, params);
// compiled op node returning opresult5003 (depth = 9)
  Object if4996 = done;
  if (istrue(opresult5003)) {
// Begin line 1188
  setline(1188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit5005 == NULL) {
    strlit5005 = alloc_String(", ");
    gc_root(strlit5005);
  }
// compiled string node returning strlit5005 (depth = 11)
  int op_slot_right_5004 = gc_frame_newslot(strlit5005);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_5004 = gc_frame_newslot(*var_s);
  params[0] = strlit5005;
  partcv[0] = 1;
  Object opresult5007 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5007 (depth = 10)
  *var_s = opresult5007;
  if (opresult5007 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if4996 = done;
  } else {
  }
// compiled if node returning if4996 (depth = 8)
  gc_frame_end(frame);
  return if4996;
}
Object meth_ast_4927__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_firstPart = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1177
  setline(1177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4929 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call4930 = callmethodflags(*var_part, "name", 1, partcv, params, 0);
  gc_frame_end(callframe4929);
// compiled member node returning call4930 (depth = 7)
  int op_slot_right_4928 = gc_frame_newslot(call4930);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4928 = gc_frame_newslot(*var_s);
  params[0] = call4930;
  partcv[0] = 1;
  Object opresult4932 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4932 (depth = 6)
  *var_s = opresult4932;
  if (opresult4932 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1178
  setline(1178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile block node (depth = 7)
  Object block4936 = alloc_Block(NULL, NULL, "ast", 1178);
  gc_frame_newslot(block4936);
// method "_apply"
  block_savedest(block4936);
  Object closure4937 = createclosure(1, "_apply");
  setclosureframe(closure4937, stackframe);
  addtoclosure(closure4937, selfslot);
  struct UserObject *uo4937 = (struct UserObject*)block4936;
  uo4937->data[0] = (Object)closure4937;
  Method *meth_meth_ast_4937__apply = addmethod2pos(block4936, "_apply", &meth_ast_4937__apply, 0);
  int argcv_meth_ast_4937__apply[] = {0};
  meth_meth_ast_4937__apply->type = alloc_MethodType(1, argcv_meth_ast_4937__apply);
  meth_meth_ast_4937__apply->definitionModule = modulename;
  meth_meth_ast_4937__apply->definitionLine = 3050;
// compiled block node returning block4936 (depth = 7)
  int op_slot_right_4935 = gc_frame_newslot(block4936);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_firstPart (depth = 7)
  int op_slot_left_4935 = gc_frame_newslot(*var_firstPart);
  params[0] = block4936;
  partcv[0] = 1;
  Object opresult4946 = callmethod(*var_firstPart, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4946 (depth = 6)
  Object if4934 = done;
  if (istrue(opresult4946)) {
// Begin line 1179
  setline(1179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4948 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num4950 = alloc_Float64(1);
// compiled num node returning num4950 (depth = 10)
  int op_slot_right_4949 = gc_frame_newslot(num4950);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_4949 = gc_frame_newslot(*var_depth);
  params[0] = num4950;
  partcv[0] = 1;
  Object sum4952 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4952 (depth = 9)
  gc_frame_newslot(sum4952);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe4953 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4954 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4953);
// compiled member node returning call4954 (depth = 9)
  params[0] = sum4952;
  partcv[0] = 1;
  Object call4955 = callmethodflags(call4954, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4948);
// compiled call node returning call4955 (depth = 8)
  int op_slot_right_4947 = gc_frame_newslot(call4955);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4947 = gc_frame_newslot(*var_s);
  params[0] = call4955;
  partcv[0] = 1;
  Object opresult4957 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4957 (depth = 7)
  *var_s = opresult4957;
  if (opresult4957 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if4934 = done;
  } else {
  }
// compiled if node returning if4934 (depth = 5)
// Begin line 1181
  setline(1181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4959 = alloc_Boolean(0);
// compiled identifier node returning bool4959 (depth = 6)
  *var_firstPart = bool4959;
  if (bool4959 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1182
  setline(1182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num4963 = alloc_Float64(0);
// compiled num node returning num4963 (depth = 7)
  int op_slot_right_4962 = gc_frame_newslot(num4963);
// starting to compile member node (depth = 7)
  int callframe4965 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4966 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call4967 = callmethodflags(*var_part, "params", 1, partcv, params, 0);
  gc_frame_end(callframe4966);
// compiled member node returning call4967 (depth = 8)
  partcv[0] = 0;
  Object call4968 = callmethodflags(call4967, "size", 1, partcv, params, 0);
  gc_frame_end(callframe4965);
// compiled member node returning call4968 (depth = 7)
  int op_slot_left_4962 = gc_frame_newslot(call4968);
  params[0] = num4963;
  partcv[0] = 1;
  Object opresult4969 = callmethod(call4968, ">(1)", 1, partcv, params);
// compiled op node returning opresult4969 (depth = 6)
  Object if4961 = done;
  if (istrue(opresult4969)) {
// Begin line 1183
  setline(1183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4971 == NULL) {
    strlit4971 = alloc_String("(");
    gc_root(strlit4971);
  }
// compiled string node returning strlit4971 (depth = 8)
  int op_slot_right_4970 = gc_frame_newslot(strlit4971);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4970 = gc_frame_newslot(*var_s);
  params[0] = strlit4971;
  partcv[0] = 1;
  Object opresult4973 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4973 (depth = 7)
  *var_s = opresult4973;
  if (opresult4973 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1184
  setline(1184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4975 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe4976 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4977 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call4978 = callmethodflags(*var_part, "params", 1, partcv, params, 0);
  gc_frame_end(callframe4977);
// compiled member node returning call4978 (depth = 8)
  partcv[0] = 0;
  Object call4979 = callmethodflags(call4978, "indices", 1, partcv, params, 0);
  gc_frame_end(callframe4976);
// compiled member node returning call4979 (depth = 7)
  gc_frame_newslot(call4979);
// starting to compile block node (depth = 7)
  Object block4980 = alloc_Block(NULL, NULL, "ast", 1184);
  gc_frame_newslot(block4980);
// method "_apply(_)"
  block_savedest(block4980);
  Object closure4981 = createclosure(4, "_apply(1)");
  setclosureframe(closure4981, stackframe);
  addtoclosure(closure4981, var_part);
  addtoclosure(closure4981, var_depth);
  addtoclosure(closure4981, var_s);
  addtoclosure(closure4981, selfslot);
  struct UserObject *uo4981 = (struct UserObject*)block4980;
  uo4981->data[0] = (Object)closure4981;
  Method *meth_meth_ast_4981__apply_40_1_41_ = addmethod2pos(block4980, "_apply(1)", &meth_ast_4981__apply_40_1_41_, 0);
  int argcv_meth_ast_4981__apply_40_1_41_[] = {1};
  meth_meth_ast_4981__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4981__apply_40_1_41_);
  meth_meth_ast_4981__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4981__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block4980 (depth = 7)
  gc_frame_newslot(block4980);
// call case 5: prelude request
  params[0] = call4979;
  params[1] = block4980;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5010 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4975);
// compiled call node returning call5010 (depth = 6)
// Begin line 1191
  setline(1191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5012 == NULL) {
    strlit5012 = alloc_String(")");
    gc_root(strlit5012);
  }
// compiled string node returning strlit5012 (depth = 8)
  int op_slot_right_5011 = gc_frame_newslot(strlit5012);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_5011 = gc_frame_newslot(*var_s);
  params[0] = strlit5012;
  partcv[0] = 1;
  Object opresult5014 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5014 (depth = 7)
  *var_s = opresult5014;
  if (opresult5014 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if4961 = done;
  } else {
  }
// compiled if node returning if4961 (depth = 5)
  gc_frame_end(frame);
  return if4961;
}
Object meth_ast_5059__apply_40_2_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1200
  setline(1200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5061 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num5062 = alloc_Float64(0);
// compiled num node returning num5062 (depth = 10)
  gc_frame_newslot(num5062);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_b (depth = 10)
  params[0] = num5062;
  partcv[0] = 1;
  Object call5063 = callmethodflags(*var_b, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5061);
// compiled call node returning call5063 (depth = 9)
  int op_slot_right_5060 = gc_frame_newslot(call5063);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit5067 == NULL) {
    strlit5067 = alloc_String("");
    gc_root(strlit5067);
  }
// compiled string node returning strlit5067 (depth = 11)
  int op_slot_right_5066 = gc_frame_newslot(strlit5067);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_5066 = gc_frame_newslot(*var_a);
  params[0] = strlit5067;
  partcv[0] = 1;
  Object opresult5069 = callmethod(*var_a, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5069 (depth = 10)
  Object if5065 = done;
struct StackFrameObject *iftmpstackframe5065 = stackframe;
  if (istrue(opresult5069)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5065);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit5071 == NULL) {
    strlit5071 = alloc_String(", ");
    gc_root(strlit5071);
  }
// compiled string node returning strlit5071 (depth = 11)
  int op_slot_right_5070 = gc_frame_newslot(strlit5071);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_5070 = gc_frame_newslot(*var_a);
  params[0] = strlit5071;
  partcv[0] = 1;
  Object opresult5073 = callmethod(*var_a, "++(1)", 1, partcv, params);
// compiled op node returning opresult5073 (depth = 10)
    gc_frame_newslot(opresult5073);
    if5065 = opresult5073;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe5065);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile string node (depth = 10)
  if (strlit5074 == NULL) {
    strlit5074 = alloc_String("");
    gc_root(strlit5074);
  }
// compiled string node returning strlit5074 (depth = 10)
    gc_frame_newslot(strlit5074);
    if5065 = strlit5074;
  }
stackframe = iftmpstackframe5065;
// compiled if node returning if5065 (depth = 9)
  int op_slot_left_5060 = gc_frame_newslot(if5065);
  params[0] = call5063;
  partcv[0] = 1;
  Object opresult5075 = callmethod(if5065, "++(1)", 1, partcv, params);
// compiled op node returning opresult5075 (depth = 8)
  gc_frame_end(frame);
  return opresult5075;
}
Object meth_ast_5112__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1208
  setline(1208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5114 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5116 = alloc_Float64(1);
// compiled num node returning num5116 (depth = 9)
  int op_slot_right_5115 = gc_frame_newslot(num5116);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5115 = gc_frame_newslot(*var_depth);
  params[0] = num5116;
  partcv[0] = 1;
  Object sum5118 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5118 (depth = 8)
  gc_frame_newslot(sum5118);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum5118;
  partcv[0] = 1;
  Object call5119 = callmethodflags(*var_mx, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5114);
// compiled call node returning call5119 (depth = 7)
  int op_slot_right_5113 = gc_frame_newslot(call5119);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5122 == NULL) {
    strlit5122 = alloc_String("    ");
    gc_root(strlit5122);
  }
// compiled string node returning strlit5122 (depth = 8)
  int op_slot_right_5121 = gc_frame_newslot(strlit5122);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_5124 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5127 == NULL) {
    strlit5127 = alloc_String("""\x0a""");
    gc_root(strlit5127);
  }
// compiled string node returning strlit5127 (depth = 10)
  int op_slot_right_5126 = gc_frame_newslot(strlit5127);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_5126 = gc_frame_newslot(*var_s);
  params[0] = strlit5127;
  partcv[0] = 1;
  Object opresult5129 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5129 (depth = 9)
  int op_slot_left_5124 = gc_frame_newslot(opresult5129);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5130 = callmethod(opresult5129, "++(1)", 1, partcv, params);
// compiled op node returning opresult5130 (depth = 8)
  int op_slot_left_5121 = gc_frame_newslot(opresult5130);
  params[0] = strlit5122;
  partcv[0] = 1;
  Object opresult5131 = callmethod(opresult5130, "++(1)", 1, partcv, params);
// compiled op node returning opresult5131 (depth = 7)
  int op_slot_left_5113 = gc_frame_newslot(opresult5131);
  params[0] = call5119;
  partcv[0] = 1;
  Object opresult5132 = callmethod(opresult5131, "++(1)", 1, partcv, params);
// compiled op node returning opresult5132 (depth = 6)
  *var_s = opresult5132;
  if (opresult5132 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_4916_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_firstPart = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "firstPart");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1173
  setline(1173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_4917 = gc_frame_newslot(*var_depth);
// starting to compile string node (depth = 5)
  if (strlit4919 == NULL) {
    strlit4919 = alloc_String("    ");
    gc_root(strlit4919);
  }
// compiled string node returning strlit4919 (depth = 5)
  int op_slot_left_4917 = gc_frame_newslot(strlit4919);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object prod4920 = callmethod(strlit4919, "*(1)", 1, partcv, params);
// compiled op node returning prod4920 (depth = 4)
  *var_spc = prod4920;
  if (prod4920 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1174
  setline(1174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4921 == NULL) {
    strlit4921 = alloc_String("method ");
    gc_root(strlit4921);
  }
// compiled string node returning strlit4921 (depth = 4)
  *var_s = strlit4921;
  if (strlit4921 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1175
  setline(1175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool4922 = alloc_Boolean(1);
// compiled identifier node returning bool4922 (depth = 4)
  *var_firstPart = bool4922;
  if (bool4922 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1176
  setline(1176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4923 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4924 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4925 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4924);
// compiled member node returning call4925 (depth = 4)
  gc_frame_newslot(call4925);
// starting to compile block node (depth = 4)
  Object block4926 = alloc_Block(NULL, NULL, "ast", 1176);
  gc_frame_newslot(block4926);
// method "_apply(_)"
  block_savedest(block4926);
  Object closure4927 = createclosure(4, "_apply(1)");
  setclosureframe(closure4927, stackframe);
  addtoclosure(closure4927, var_s);
  addtoclosure(closure4927, var_firstPart);
  addtoclosure(closure4927, var_depth);
  addtoclosure(closure4927, selfslot);
  struct UserObject *uo4927 = (struct UserObject*)block4926;
  uo4927->data[0] = (Object)closure4927;
  Method *meth_meth_ast_4927__apply_40_1_41_ = addmethod2pos(block4926, "_apply(1)", &meth_ast_4927__apply_40_1_41_, 0);
  int argcv_meth_ast_4927__apply_40_1_41_[] = {1};
  meth_meth_ast_4927__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4927__apply_40_1_41_);
  meth_meth_ast_4927__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4927__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block4926 (depth = 4)
  gc_frame_newslot(block4926);
// call case 5: prelude request
  params[0] = call4925;
  params[1] = block4926;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5017 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4923);
// compiled call node returning call5017 (depth = 3)
// Begin line 1194
  setline(1194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5020 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5021 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5020);
// compiled member node returning call5021 (depth = 5)
  int op_slot_right_5019 = gc_frame_newslot(call5021);
// starting to compile identifier node (depth = 5)
  Object bool5023 = alloc_Boolean(0);
// compiled identifier node returning bool5023 (depth = 5)
  int op_slot_left_5019 = gc_frame_newslot(bool5023);
  params[0] = call5021;
  partcv[0] = 1;
  Object opresult5024 = callmethod(bool5023, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5024 (depth = 4)
  Object if5018 = done;
  if (istrue(opresult5024)) {
// Begin line 1195
  setline(1195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5027 == NULL) {
    strlit5027 = alloc_String("");
    gc_root(strlit5027);
  }
// compiled string node returning strlit5027 (depth = 7)
  int op_slot_right_5026 = gc_frame_newslot(strlit5027);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5030 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num5031 = alloc_Float64(0);
// compiled num node returning num5031 (depth = 9)
  gc_frame_newslot(num5031);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe5032 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5033 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5032);
// compiled member node returning call5033 (depth = 9)
  params[0] = num5031;
  partcv[0] = 1;
  Object call5034 = callmethodflags(call5033, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5030);
// compiled call node returning call5034 (depth = 8)
  int op_slot_right_5029 = gc_frame_newslot(call5034);
// starting to compile string node (depth = 8)
  if (strlit5036 == NULL) {
    strlit5036 = alloc_String(" -> ");
    gc_root(strlit5036);
  }
// compiled string node returning strlit5036 (depth = 8)
  int op_slot_left_5029 = gc_frame_newslot(strlit5036);
  params[0] = call5034;
  partcv[0] = 1;
  Object opresult5037 = callmethod(strlit5036, "++(1)", 1, partcv, params);
// compiled op node returning opresult5037 (depth = 7)
  int op_slot_left_5026 = gc_frame_newslot(opresult5037);
  params[0] = strlit5027;
  partcv[0] = 1;
  Object opresult5038 = callmethod(opresult5037, "++(1)", 1, partcv, params);
// compiled op node returning opresult5038 (depth = 6)
  int op_slot_right_5025 = gc_frame_newslot(opresult5038);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_5025 = gc_frame_newslot(*var_s);
  params[0] = opresult5038;
  partcv[0] = 1;
  Object opresult5040 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5040 (depth = 5)
  *var_s = opresult5040;
  if (opresult5040 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5018 = done;
  } else {
  }
// compiled if node returning if5018 (depth = 3)
// Begin line 1197
  setline(1197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5044 = alloc_Float64(0);
// compiled num node returning num5044 (depth = 5)
  int op_slot_right_5043 = gc_frame_newslot(num5044);
// starting to compile member node (depth = 5)
  int callframe5046 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5047 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5048 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5047);
// compiled member node returning call5048 (depth = 6)
  partcv[0] = 0;
  Object call5049 = callmethodflags(call5048, "size", 1, partcv, params, 0);
  gc_frame_end(callframe5046);
// compiled member node returning call5049 (depth = 5)
  int op_slot_left_5043 = gc_frame_newslot(call5049);
  params[0] = num5044;
  partcv[0] = 1;
  Object opresult5050 = callmethod(call5049, ">(1)", 1, partcv, params);
// compiled op node returning opresult5050 (depth = 4)
  Object if5042 = done;
  if (istrue(opresult5050)) {
// Begin line 1198
  setline(1198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5052 == NULL) {
    strlit5052 = alloc_String(" is ");
    gc_root(strlit5052);
  }
// compiled string node returning strlit5052 (depth = 6)
  int op_slot_right_5051 = gc_frame_newslot(strlit5052);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_5051 = gc_frame_newslot(*var_s);
  params[0] = strlit5052;
  partcv[0] = 1;
  Object opresult5054 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5054 (depth = 5)
  *var_s = opresult5054;
  if (opresult5054 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1199
  setline(1199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5057 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block5058 = alloc_Block(NULL, NULL, "ast", 1199);
  gc_frame_newslot(block5058);
// method "_apply(_,_)"
  block_savedest(block5058);
  Object closure5059 = createclosure(1, "_apply(2)");
  setclosureframe(closure5059, stackframe);
  addtoclosure(closure5059, selfslot);
  struct UserObject *uo5059 = (struct UserObject*)block5058;
  uo5059->data[0] = (Object)closure5059;
  Method *meth_meth_ast_5059__apply_40_2_41_ = addmethod2pos(block5058, "_apply(2)", &meth_ast_5059__apply_40_2_41_, 0);
  int argcv_meth_ast_5059__apply_40_2_41_[] = {2};
  meth_meth_ast_5059__apply_40_2_41_->type = alloc_MethodType(1, argcv_meth_ast_5059__apply_40_2_41_);
  meth_meth_ast_5059__apply_40_2_41_->definitionModule = modulename;
  meth_meth_ast_5059__apply_40_2_41_->definitionLine = 3050;
// compiled block node returning block5058 (depth = 7)
  gc_frame_newslot(block5058);
// Begin line 1201
  setline(1201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit5077 == NULL) {
    strlit5077 = alloc_String("");
    gc_root(strlit5077);
  }
// compiled string node returning strlit5077 (depth = 7)
  gc_frame_newslot(strlit5077);
// call case 6: other requests
// Begin line 1199
  setline(1199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe5078 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5079 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5078);
// compiled member node returning call5079 (depth = 7)
  params[0] = block5058;
  params[1] = strlit5077;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5080 = callmethodflags(call5079, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5057);
// compiled call node returning call5080 (depth = 6)
  int op_slot_right_5056 = gc_frame_newslot(call5080);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_5056 = gc_frame_newslot(*var_s);
  params[0] = call5080;
  partcv[0] = 1;
  Object opresult5082 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5082 (depth = 5)
  *var_s = opresult5082;
  if (opresult5082 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5042 = done;
  } else {
  }
// compiled if node returning if5042 (depth = 3)
// Begin line 1203
  setline(1203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5085 == NULL) {
    strlit5085 = alloc_String(" {");
    gc_root(strlit5085);
  }
// compiled string node returning strlit5085 (depth = 5)
  int op_slot_right_5084 = gc_frame_newslot(strlit5085);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_5084 = gc_frame_newslot(*var_s);
  params[0] = strlit5085;
  partcv[0] = 1;
  Object opresult5087 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5087 (depth = 4)
  *var_s = opresult5087;
  if (opresult5087 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1204
  setline(1204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5091 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5092 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5091);
// compiled member node returning call5092 (depth = 5)
  int op_slot_right_5090 = gc_frame_newslot(call5092);
// starting to compile identifier node (depth = 5)
  Object bool5094 = alloc_Boolean(0);
// compiled identifier node returning bool5094 (depth = 5)
  int op_slot_left_5090 = gc_frame_newslot(bool5094);
  params[0] = call5092;
  partcv[0] = 1;
  Object opresult5095 = callmethod(bool5094, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5095 (depth = 4)
  Object if5089 = done;
  if (istrue(opresult5095)) {
// Begin line 1205
  setline(1205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5097 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num5099 = alloc_Float64(1);
// compiled num node returning num5099 (depth = 8)
  int op_slot_right_5098 = gc_frame_newslot(num5099);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_5098 = gc_frame_newslot(*var_depth);
  params[0] = num5099;
  partcv[0] = 1;
  Object sum5101 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5101 (depth = 7)
  gc_frame_newslot(sum5101);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5102 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5103 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5102);
// compiled member node returning call5103 (depth = 7)
  params[0] = sum5101;
  partcv[0] = 1;
  Object call5104 = callmethodflags(call5103, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5097);
// compiled call node returning call5104 (depth = 6)
  int op_slot_right_5096 = gc_frame_newslot(call5104);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_5096 = gc_frame_newslot(*var_s);
  params[0] = call5104;
  partcv[0] = 1;
  Object opresult5106 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5106 (depth = 5)
  *var_s = opresult5106;
  if (opresult5106 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5089 = done;
  } else {
  }
// compiled if node returning if5089 (depth = 3)
// Begin line 1207
  setline(1207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5108 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5109 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5110 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5109);
// compiled member node returning call5110 (depth = 4)
  gc_frame_newslot(call5110);
// starting to compile block node (depth = 4)
  Object block5111 = alloc_Block(NULL, NULL, "ast", 1207);
  gc_frame_newslot(block5111);
// method "_apply(_)"
  block_savedest(block5111);
  Object closure5112 = createclosure(4, "_apply(1)");
  setclosureframe(closure5112, stackframe);
  addtoclosure(closure5112, var_depth);
  addtoclosure(closure5112, var_spc);
  addtoclosure(closure5112, var_s);
  addtoclosure(closure5112, selfslot);
  struct UserObject *uo5112 = (struct UserObject*)block5111;
  uo5112->data[0] = (Object)closure5112;
  Method *meth_meth_ast_5112__apply_40_1_41_ = addmethod2pos(block5111, "_apply(1)", &meth_ast_5112__apply_40_1_41_, 0);
  int argcv_meth_ast_5112__apply_40_1_41_[] = {1};
  meth_meth_ast_5112__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5112__apply_40_1_41_);
  meth_meth_ast_5112__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5112__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block5111 (depth = 4)
  gc_frame_newslot(block5111);
// call case 5: prelude request
  params[0] = call5110;
  params[1] = block5111;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5135 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5108);
// compiled call node returning call5135 (depth = 3)
// Begin line 1210
  setline(1210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5137 == NULL) {
    strlit5137 = alloc_String("}");
    gc_root(strlit5137);
  }
// compiled string node returning strlit5137 (depth = 5)
  int op_slot_right_5136 = gc_frame_newslot(strlit5137);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_5139 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5142 == NULL) {
    strlit5142 = alloc_String("""\x0a""");
    gc_root(strlit5142);
  }
// compiled string node returning strlit5142 (depth = 7)
  int op_slot_right_5141 = gc_frame_newslot(strlit5142);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5141 = gc_frame_newslot(*var_s);
  params[0] = strlit5142;
  partcv[0] = 1;
  Object opresult5144 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5144 (depth = 6)
  int op_slot_left_5139 = gc_frame_newslot(opresult5144);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5145 = callmethod(opresult5144, "++(1)", 1, partcv, params);
// compiled op node returning opresult5145 (depth = 5)
  int op_slot_left_5136 = gc_frame_newslot(opresult5145);
  params[0] = strlit5137;
  partcv[0] = 1;
  Object opresult5146 = callmethod(opresult5145, "++(1)", 1, partcv, params);
// compiled op node returning opresult5146 (depth = 4)
  *var_s = opresult5146;
  if (opresult5146 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1211
  setline(1211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_5148_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 45, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_methodNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1214
  setline(1214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5149 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe5150 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5151 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5152 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5151);
// compiled member node returning call5152 (depth = 5)
  gc_frame_newslot(call5152);
// starting to compile member node (depth = 5)
  int callframe5153 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5154 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5153);
// compiled member node returning call5154 (depth = 5)
  gc_frame_newslot(call5154);
// starting to compile member node (depth = 5)
  int callframe5155 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5156 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5155);
// compiled member node returning call5156 (depth = 5)
  gc_frame_newslot(call5156);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methodNode (depth = 5)
  params[0] = call5152;
  params[1] = call5154;
  params[2] = call5156;
  partcv[0] = 3;
  Object call5157 = callmethodflags(*var_methodNode, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe5150);
// compiled call node returning call5157 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5158 = callmethodflags(call5157, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5149);
// compiled call node returning call5158 (depth = 3)
  gc_frame_end(frame);
  return call5158;
}
Object meth_ast_5159_postCopy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "postCopy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method postCopy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for postCopy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part postCopy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5160 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5161 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call5162 = callmethodflags(*var_other, "isFresh", 1, partcv, params, 0);
  gc_frame_end(callframe5161);
// compiled member node returning call5162 (depth = 4)
  gc_frame_newslot(call5162);
// call case 4: self request
  params[0] = call5162;
  partcv[0] = 1;
  Object call5163 = callmethodflags(self, "isFresh:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5160);
// compiled call node returning call5163 (depth = 3)
// Begin line 1218
  setline(1218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5164 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5165 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call5166 = callmethodflags(*var_other, "selfclosure", 1, partcv, params, 0);
  gc_frame_end(callframe5165);
// compiled member node returning call5166 (depth = 4)
  gc_frame_newslot(call5166);
// call case 4: self request
  params[0] = call5166;
  partcv[0] = 1;
  Object call5167 = callmethodflags(self, "selfclosure:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5164);
// compiled call node returning call5167 (depth = 3)
// Begin line 1219
  setline(1219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5169 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5170 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call5171 = callmethodflags(*var_other, "isBindingOccurence", 1, partcv, params, 0);
  gc_frame_end(callframe5170);
// compiled member node returning call5171 (depth = 5)
  partcv[0] = 0;
  Object call5172 = callmethodflags(call5171, "not", 1, partcv, params, 0);
  gc_frame_end(callframe5169);
// compiled member node returning call5172 (depth = 4)
  Object if5168 = done;
  if (istrue(call5172)) {
// Begin line 1220
  setline(1220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5173 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5174 = callmethodflags(self, "appliedOccurence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5173);
// compiled member node returning call5174 (depth = 4)
    gc_frame_newslot(call5174);
    if5168 = call5174;
  } else {
  }
// compiled if node returning if5168 (depth = 3)
// Begin line 1222
  setline(1222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_3999_new_40_3_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_uninitialized = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_k = getfromclosure(closure, 2);
  Object *var_methodNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_signature_39_ = &(stackframe->slots[0]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4000 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4000 = alloc_userobj2(56,47, objclass4000);
  gc_frame_newslot(obj4000);
  if (objclass4000 == NULL) {
    glfree(obj4000->class->name);
    obj4000->class->name = "methodNode.new(_,_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4000, self, 0);
  addmethodreal(obj4000,"outer", &reader_ast_outer_4001);
  Object oldself4000 = self;
  struct StackFrameObject *oldstackframe4000 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4000);
  gc_frame_newslot((Object)stackframe);
  self = obj4000;
  Object *oldselfslot4000 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4000 = (*(struct UserObject *)self).data[0], lowerouter4000 = thisouter4000;
  if (inheritingObject4000) {
    struct UserObject *inho4000 = (struct UserObject *)inheritingObject4000;
    while (inho4000->super != GraceDefaultObject) inho4000 = (struct UserObject *)inho4000->super;
    inho4000->super = obj4000;
    self = inheritingObject4000;
    *selfslot = self;
    lowerouter4000 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4000;
  }
  if (objclass4000 == NULL) {
  Method *reader4002 = addmethodrealflags(obj4000, "kind",&reader_ast_kind_4002, MFLAG_DEF);
  reader4002->definitionModule = modulename;
  reader4002->definitionLine = 964;
  }
  adddatum2(obj4000, alloc_Undefined(), 1);
  if (objclass4000 == NULL) {
    Method *reader4003 = addmethodrealflags(obj4000, "signature", &reader_ast_signature_4003, 0);
    Method *writer4003 = addmethodrealflags(obj4000, "signature:=(1)", &writer_ast_signature_4003, 0);
    reader4003->definitionModule = modulename;
    writer4003->definitionModule = modulename;
    reader4003->definitionLine = 965;
    writer4003->definitionLine = 965;
  }
  obj4000->flags |= OFLAG_MUTABLE;
  adddatum2(obj4000, alloc_Undefined(), 2);
  if (objclass4000 == NULL) {
    Method *reader4004 = addmethodrealflags(obj4000, "body", &reader_ast_body_4004, 0);
    Method *writer4004 = addmethodrealflags(obj4000, "body:=(1)", &writer_ast_body_4004, 0);
    reader4004->definitionModule = modulename;
    writer4004->definitionModule = modulename;
    reader4004->definitionLine = 966;
    writer4004->definitionLine = 966;
  }
  obj4000->flags |= OFLAG_MUTABLE;
  adddatum2(obj4000, alloc_Undefined(), 3);
  if (objclass4000 == NULL) {
    Method *reader4005 = addmethodrealflags(obj4000, "dtype", &reader_ast_dtype_4005, 0);
    Method *writer4005 = addmethodrealflags(obj4000, "dtype:=(1)", &writer_ast_dtype_4005, 0);
    reader4005->definitionModule = modulename;
    writer4005->definitionModule = modulename;
    reader4005->definitionLine = 967;
    writer4005->definitionLine = 967;
  }
  obj4000->flags |= OFLAG_MUTABLE;
  adddatum2(obj4000, alloc_Undefined(), 4);
  if (objclass4000 == NULL) {
    Method *reader4006 = addmethodrealflags(obj4000, "typeParams", &reader_ast_typeParams_4006, 0);
    Method *writer4006 = addmethodrealflags(obj4000, "typeParams:=(1)", &writer_ast_typeParams_4006, 0);
    reader4006->definitionModule = modulename;
    writer4006->definitionModule = modulename;
    reader4006->definitionLine = 968;
    writer4006->definitionLine = 968;
  }
  obj4000->flags |= OFLAG_MUTABLE;
  adddatum2(obj4000, alloc_Undefined(), 5);
  if (objclass4000 == NULL) {
    Method *reader4007 = addmethodrealflags(obj4000, "selfclosure", &reader_ast_selfclosure_4007, 0);
    Method *writer4007 = addmethodrealflags(obj4000, "selfclosure:=(1)", &writer_ast_selfclosure_4007, 0);
    reader4007->definitionModule = modulename;
    writer4007->definitionModule = modulename;
    reader4007->definitionLine = 969;
    writer4007->definitionLine = 969;
  }
  obj4000->flags |= OFLAG_MUTABLE;
  adddatum2(obj4000, alloc_Undefined(), 6);
  if (objclass4000 == NULL) {
    Method *reader4008 = addmethodrealflags(obj4000, "annotations", &reader_ast_annotations_4008, 0);
    Method *writer4008 = addmethodrealflags(obj4000, "annotations:=(1)", &writer_ast_annotations_4008, 0);
    reader4008->definitionModule = modulename;
    writer4008->definitionModule = modulename;
    reader4008->definitionLine = 970;
    writer4008->definitionLine = 970;
  }
  obj4000->flags |= OFLAG_MUTABLE;
  adddatum2(obj4000, alloc_Undefined(), 7);
  if (objclass4000 == NULL) {
    Method *reader4009 = addmethodrealflags(obj4000, "isFresh", &reader_ast_isFresh_4009, 0);
    Method *writer4009 = addmethodrealflags(obj4000, "isFresh:=(1)", &writer_ast_isFresh_4009, 0);
    reader4009->definitionModule = modulename;
    writer4009->definitionModule = modulename;
    reader4009->definitionLine = 971;
    writer4009->definitionLine = 971;
  }
  obj4000->flags |= OFLAG_MUTABLE;
  adddatum2(obj4000, alloc_Undefined(), 8);
  if (objclass4000 == NULL) {
    Method *reader4010 = addmethodrealflags(obj4000, "usesClassSyntax", &reader_ast_usesClassSyntax_4010, 0);
    Method *writer4010 = addmethodrealflags(obj4000, "usesClassSyntax:=(1)", &writer_ast_usesClassSyntax_4010, 0);
    reader4010->definitionModule = modulename;
    writer4010->definitionModule = modulename;
    reader4010->definitionLine = 972;
    writer4010->definitionLine = 972;
  }
  obj4000->flags |= OFLAG_MUTABLE;
  adddatum2(obj4000, alloc_Undefined(), 9);
  if (objclass4000 == NULL) {
    Method *reader4011 = addmethodrealflags(obj4000, "cachedIdentifier", &reader_ast_cachedIdentifier_4011, MFLAG_CONFIDENTIAL);
    Method *writer4011 = addmethodrealflags(obj4000, "cachedIdentifier:=(1)", &writer_ast_cachedIdentifier_4011, MFLAG_CONFIDENTIAL);
    reader4011->definitionModule = modulename;
    writer4011->definitionModule = modulename;
    reader4011->definitionLine = 973;
    writer4011->definitionLine = 973;
  }
  obj4000->flags |= OFLAG_MUTABLE;
  adddatum2(obj4000, alloc_Undefined(), 10);
  if (objclass4000 == NULL) {
    Method *reader4012 = addmethodrealflags(obj4000, "isBindingOccurence", &reader_ast_isBindingOccurence_4012, 0);
    Method *writer4012 = addmethodrealflags(obj4000, "isBindingOccurence:=(1)", &writer_ast_isBindingOccurence_4012, MFLAG_CONFIDENTIAL);
    reader4012->definitionModule = modulename;
    writer4012->definitionModule = modulename;
    reader4012->definitionLine = 974;
    writer4012->definitionLine = 974;
  }
  obj4000->flags |= OFLAG_MUTABLE;
  adddatum2(obj4000, alloc_Undefined(), 11);
// method "end"
  struct UserObject *uo4013 = (struct UserObject*)obj4000;
  uo4013->data[12] = emptyclosure;
  Method *meth_meth_ast_4013_end = addmethod2pos(obj4000, "end", &meth_ast_4013_end, 12);
  int argcv_meth_ast_4013_end[] = {0};
  meth_meth_ast_4013_end->type = alloc_MethodType(1, argcv_meth_ast_4013_end);
  meth_meth_ast_4013_end->definitionModule = modulename;
  meth_meth_ast_4013_end->definitionLine = 977;
// method "ilkName"
  struct UserObject *uo4062 = (struct UserObject*)obj4000;
  uo4062->data[13] = emptyclosure;
  Method *meth_meth_ast_4062_ilkName = addmethod2pos(obj4000, "ilkName", &meth_ast_4062_ilkName, 13);
  int argcv_meth_ast_4062_ilkName[] = {0};
  meth_meth_ast_4062_ilkName->type = alloc_MethodType(1, argcv_meth_ast_4062_ilkName);
  meth_meth_ast_4062_ilkName->definitionModule = modulename;
  meth_meth_ast_4062_ilkName->definitionLine = 987;
// method "appliedOccurence"
  block_savedest(obj4000);
  Object closure4086 = createclosure(1, "appliedOccurence");
  setclosureframe(closure4086, stackframe);
  addtoclosure(closure4086, var_uninitialized);
  struct UserObject *uo4086 = (struct UserObject*)obj4000;
  uo4086->data[14] = (Object)closure4086;
  Method *meth_meth_ast_4086_appliedOccurence = addmethod2pos(obj4000, "appliedOccurence", &meth_ast_4086_appliedOccurence, 14);
  int argcv_meth_ast_4086_appliedOccurence[] = {0};
  meth_meth_ast_4086_appliedOccurence->type = alloc_MethodType(1, argcv_meth_ast_4086_appliedOccurence);
  meth_meth_ast_4086_appliedOccurence->definitionModule = modulename;
  meth_meth_ast_4086_appliedOccurence->definitionLine = 995;
// method "numParams"
  struct UserObject *uo4101 = (struct UserObject*)obj4000;
  uo4101->data[15] = emptyclosure;
  Method *meth_meth_ast_4101_numParams = addmethod2pos(obj4000, "numParams", &meth_ast_4101_numParams, 15);
  int argcv_meth_ast_4101_numParams[] = {0};
  meth_meth_ast_4101_numParams->type = alloc_MethodType(1, argcv_meth_ast_4101_numParams);
  meth_meth_ast_4101_numParams->definitionModule = modulename;
  meth_meth_ast_4101_numParams->definitionLine = 1002;
// method "parametersDo(_)"
  struct UserObject *uo4115 = (struct UserObject*)obj4000;
  uo4115->data[16] = emptyclosure;
  Method *meth_meth_ast_4115_parametersDo_40_1_41_ = addmethod2pos(obj4000, "parametersDo(1)", &meth_ast_4115_parametersDo_40_1_41_, 16);
  int argcv_meth_ast_4115_parametersDo_40_1_41_[] = {1};
  meth_meth_ast_4115_parametersDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4115_parametersDo_40_1_41_);
  meth_meth_ast_4115_parametersDo_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4115_parametersDo_40_1_41_->definitionLine = 1005;
// method "endPos"
  struct UserObject *uo4132 = (struct UserObject*)obj4000;
  uo4132->data[17] = emptyclosure;
  Method *meth_meth_ast_4132_endPos = addmethod2pos(obj4000, "endPos", &meth_ast_4132_endPos, 17);
  int argcv_meth_ast_4132_endPos[] = {0};
  meth_meth_ast_4132_endPos->type = alloc_MethodType(1, argcv_meth_ast_4132_endPos);
  meth_meth_ast_4132_endPos->definitionModule = modulename;
  meth_meth_ast_4132_endPos->definitionLine = 1010;
// method "nameString"
  struct UserObject *uo4150 = (struct UserObject*)obj4000;
  uo4150->data[18] = emptyclosure;
  Method *meth_meth_ast_4150_nameString = addmethod2pos(obj4000, "nameString", &meth_ast_4150_nameString, 18);
  int argcv_meth_ast_4150_nameString[] = {0};
  meth_meth_ast_4150_nameString->type = alloc_MethodType(1, argcv_meth_ast_4150_nameString);
  meth_meth_ast_4150_nameString->definitionModule = modulename;
  meth_meth_ast_4150_nameString->definitionLine = 1015;
// method "asIdentifier"
  block_savedest(obj4000);
  Object closure4164 = createclosure(2, "asIdentifier");
  setclosureframe(closure4164, stackframe);
  addtoclosure(closure4164, var_uninitialized);
  addtoclosure(closure4164, var_identifierNode);
  struct UserObject *uo4164 = (struct UserObject*)obj4000;
  uo4164->data[19] = (Object)closure4164;
  Method *meth_meth_ast_4164_asIdentifier = addmethod2pos(obj4000, "asIdentifier", &meth_ast_4164_asIdentifier, 19);
  int argcv_meth_ast_4164_asIdentifier[] = {0};
  meth_meth_ast_4164_asIdentifier->type = alloc_MethodType(1, argcv_meth_ast_4164_asIdentifier);
  meth_meth_ast_4164_asIdentifier->definitionModule = modulename;
  meth_meth_ast_4164_asIdentifier->definitionLine = 1019;
// method "value"
  struct UserObject *uo4222 = (struct UserObject*)obj4000;
  uo4222->data[20] = emptyclosure;
  Method *meth_meth_ast_4222_value = addmethod2pos(obj4000, "value", &meth_ast_4222_value, 20);
  int argcv_meth_ast_4222_value[] = {0};
  meth_meth_ast_4222_value->type = alloc_MethodType(1, argcv_meth_ast_4222_value);
  meth_meth_ast_4222_value->definitionModule = modulename;
  meth_meth_ast_4222_value->definitionLine = 1030;
// method "canonicalName"
  struct UserObject *uo4225 = (struct UserObject*)obj4000;
  uo4225->data[21] = emptyclosure;
  Method *meth_meth_ast_4225_canonicalName = addmethod2pos(obj4000, "canonicalName", &meth_ast_4225_canonicalName, 21);
  int argcv_meth_ast_4225_canonicalName[] = {0};
  meth_meth_ast_4225_canonicalName->type = alloc_MethodType(1, argcv_meth_ast_4225_canonicalName);
  meth_meth_ast_4225_canonicalName->definitionModule = modulename;
  meth_meth_ast_4225_canonicalName->definitionLine = 1031;
// method "hasParams"
  struct UserObject *uo4239 = (struct UserObject*)obj4000;
  uo4239->data[22] = emptyclosure;
  Method *meth_meth_ast_4239_hasParams = addmethod2pos(obj4000, "hasParams", &meth_ast_4239_hasParams, 22);
  int argcv_meth_ast_4239_hasParams[] = {0};
  meth_meth_ast_4239_hasParams->type = alloc_MethodType(1, argcv_meth_ast_4239_hasParams);
  meth_meth_ast_4239_hasParams->definitionModule = modulename;
  meth_meth_ast_4239_hasParams->definitionLine = 1035;
// method "numParamLists"
  struct UserObject *uo4250 = (struct UserObject*)obj4000;
  uo4250->data[23] = emptyclosure;
  Method *meth_meth_ast_4250_numParamLists = addmethod2pos(obj4000, "numParamLists", &meth_ast_4250_numParamLists, 23);
  int argcv_meth_ast_4250_numParamLists[] = {0};
  meth_meth_ast_4250_numParamLists->type = alloc_MethodType(1, argcv_meth_ast_4250_numParamLists);
  meth_meth_ast_4250_numParamLists->definitionModule = modulename;
  meth_meth_ast_4250_numParamLists->definitionLine = 1036;
// method "hasTypeParams"
  struct UserObject *uo4271 = (struct UserObject*)obj4000;
  uo4271->data[24] = emptyclosure;
  Method *meth_meth_ast_4271_hasTypeParams = addmethod2pos(obj4000, "hasTypeParams", &meth_ast_4271_hasTypeParams, 24);
  int argcv_meth_ast_4271_hasTypeParams[] = {0};
  meth_meth_ast_4271_hasTypeParams->type = alloc_MethodType(1, argcv_meth_ast_4271_hasTypeParams);
  meth_meth_ast_4271_hasTypeParams->definitionModule = modulename;
  meth_meth_ast_4271_hasTypeParams->definitionLine = 1044;
// method "isMethod"
  struct UserObject *uo4282 = (struct UserObject*)obj4000;
  uo4282->data[25] = emptyclosure;
  Method *meth_meth_ast_4282_isMethod = addmethod2pos(obj4000, "isMethod", &meth_ast_4282_isMethod, 25);
  int argcv_meth_ast_4282_isMethod[] = {0};
  meth_meth_ast_4282_isMethod->type = alloc_MethodType(1, argcv_meth_ast_4282_isMethod);
  meth_meth_ast_4282_isMethod->definitionModule = modulename;
  meth_meth_ast_4282_isMethod->definitionLine = 1045;
// method "isExecutable"
  struct UserObject *uo4284 = (struct UserObject*)obj4000;
  uo4284->data[26] = emptyclosure;
  Method *meth_meth_ast_4284_isExecutable = addmethod2pos(obj4000, "isExecutable", &meth_ast_4284_isExecutable, 26);
  int argcv_meth_ast_4284_isExecutable[] = {0};
  meth_meth_ast_4284_isExecutable->type = alloc_MethodType(1, argcv_meth_ast_4284_isExecutable);
  meth_meth_ast_4284_isExecutable->definitionModule = modulename;
  meth_meth_ast_4284_isExecutable->definitionLine = 1046;
// method "isLegalInTrait"
  struct UserObject *uo4286 = (struct UserObject*)obj4000;
  uo4286->data[27] = emptyclosure;
  Method *meth_meth_ast_4286_isLegalInTrait = addmethod2pos(obj4000, "isLegalInTrait", &meth_ast_4286_isLegalInTrait, 27);
  int argcv_meth_ast_4286_isLegalInTrait[] = {0};
  meth_meth_ast_4286_isLegalInTrait->type = alloc_MethodType(1, argcv_meth_ast_4286_isLegalInTrait);
  meth_meth_ast_4286_isLegalInTrait->definitionModule = modulename;
  meth_meth_ast_4286_isLegalInTrait->definitionLine = 1047;
// method "isClass"
  struct UserObject *uo4288 = (struct UserObject*)obj4000;
  uo4288->data[28] = emptyclosure;
  Method *meth_meth_ast_4288_isClass = addmethod2pos(obj4000, "isClass", &meth_ast_4288_isClass, 28);
  int argcv_meth_ast_4288_isClass[] = {0};
  meth_meth_ast_4288_isClass->type = alloc_MethodType(1, argcv_meth_ast_4288_isClass);
  meth_meth_ast_4288_isClass->definitionModule = modulename;
  meth_meth_ast_4288_isClass->definitionLine = 1048;
// method "isTrait"
  struct UserObject *uo4296 = (struct UserObject*)obj4000;
  uo4296->data[29] = emptyclosure;
  Method *meth_meth_ast_4296_isTrait = addmethod2pos(obj4000, "isTrait", &meth_ast_4296_isTrait, 29);
  int argcv_meth_ast_4296_isTrait[] = {0};
  meth_meth_ast_4296_isTrait->type = alloc_MethodType(1, argcv_meth_ast_4296_isTrait);
  meth_meth_ast_4296_isTrait->definitionModule = modulename;
  meth_meth_ast_4296_isTrait->definitionLine = 1049;
// method "needsArgChecks"
  struct UserObject *uo4307 = (struct UserObject*)obj4000;
  uo4307->data[30] = emptyclosure;
  Method *meth_meth_ast_4307_needsArgChecks = addmethod2pos(obj4000, "needsArgChecks", &meth_ast_4307_needsArgChecks, 30);
  int argcv_meth_ast_4307_needsArgChecks[] = {0};
  meth_meth_ast_4307_needsArgChecks->type = alloc_MethodType(1, argcv_meth_ast_4307_needsArgChecks);
  meth_meth_ast_4307_needsArgChecks->definitionModule = modulename;
  meth_meth_ast_4307_needsArgChecks->definitionLine = 1056;
// method "scope:=(_)"
  struct UserObject *uo4345 = (struct UserObject*)obj4000;
  uo4345->data[31] = emptyclosure;
  Method *meth_meth_ast_4345_scope_58__61__40_1_41_ = addmethod2pos(obj4000, "scope:=(1)", &meth_ast_4345_scope_58__61__40_1_41_, 31);
  int argcv_meth_ast_4345_scope_58__61__40_1_41_[] = {1};
  meth_meth_ast_4345_scope_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4345_scope_58__61__40_1_41_);
  meth_meth_ast_4345_scope_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_4345_scope_58__61__40_1_41_->definitionLine = 1067;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj4000);
  Object closure4350 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure4350, stackframe);
  addtoclosure(closure4350, var_k);
  struct UserObject *uo4350 = (struct UserObject*)obj4000;
  uo4350->data[32] = (Object)closure4350;
  Method *meth_meth_ast_4350_declarationKindWithAncestors_40_1_41_ = addmethod2pos(obj4000, "declarationKindWithAncestors(1)", &meth_ast_4350_declarationKindWithAncestors_40_1_41_, 32);
  int argcv_meth_ast_4350_declarationKindWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_4350_declarationKindWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4350_declarationKindWithAncestors_40_1_41_);
  meth_meth_ast_4350_declarationKindWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4350_declarationKindWithAncestors_40_1_41_->definitionLine = 1073;
// method "isConfidential"
  struct UserObject *uo4353 = (struct UserObject*)obj4000;
  uo4353->data[33] = emptyclosure;
  Method *meth_meth_ast_4353_isConfidential = addmethod2pos(obj4000, "isConfidential", &meth_ast_4353_isConfidential, 33);
  int argcv_meth_ast_4353_isConfidential[] = {0};
  meth_meth_ast_4353_isConfidential->type = alloc_MethodType(1, argcv_meth_ast_4353_isConfidential);
  meth_meth_ast_4353_isConfidential->definitionModule = modulename;
  meth_meth_ast_4353_isConfidential->definitionLine = 1074;
// method "isPublic"
  struct UserObject *uo4367 = (struct UserObject*)obj4000;
  uo4367->data[34] = emptyclosure;
  Method *meth_meth_ast_4367_isPublic = addmethod2pos(obj4000, "isPublic", &meth_ast_4367_isPublic, 34);
  int argcv_meth_ast_4367_isPublic[] = {0};
  meth_meth_ast_4367_isPublic->type = alloc_MethodType(1, argcv_meth_ast_4367_isPublic);
  meth_meth_ast_4367_isPublic->definitionModule = modulename;
  meth_meth_ast_4367_isPublic->definitionLine = 1078;
// method "isWritable"
  struct UserObject *uo4372 = (struct UserObject*)obj4000;
  uo4372->data[35] = emptyclosure;
  Method *meth_meth_ast_4372_isWritable = addmethod2pos(obj4000, "isWritable", &meth_ast_4372_isWritable, 35);
  int argcv_meth_ast_4372_isWritable[] = {0};
  meth_meth_ast_4372_isWritable->type = alloc_MethodType(1, argcv_meth_ast_4372_isWritable);
  meth_meth_ast_4372_isWritable->definitionModule = modulename;
  meth_meth_ast_4372_isWritable->definitionLine = 1079;
// method "isReadable"
  struct UserObject *uo4374 = (struct UserObject*)obj4000;
  uo4374->data[36] = emptyclosure;
  Method *meth_meth_ast_4374_isReadable = addmethod2pos(obj4000, "isReadable", &meth_ast_4374_isReadable, 36);
  int argcv_meth_ast_4374_isReadable[] = {0};
  meth_meth_ast_4374_isReadable->type = alloc_MethodType(1, argcv_meth_ast_4374_isReadable);
  meth_meth_ast_4374_isReadable->definitionModule = modulename;
  meth_meth_ast_4374_isReadable->definitionLine = 1080;
// method "usesAsType(_)"
  struct UserObject *uo4377 = (struct UserObject*)obj4000;
  uo4377->data[37] = emptyclosure;
  Method *meth_meth_ast_4377_usesAsType_40_1_41_ = addmethod2pos(obj4000, "usesAsType(1)", &meth_ast_4377_usesAsType_40_1_41_, 37);
  int argcv_meth_ast_4377_usesAsType_40_1_41_[] = {1};
  meth_meth_ast_4377_usesAsType_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4377_usesAsType_40_1_41_);
  meth_meth_ast_4377_usesAsType_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4377_usesAsType_40_1_41_->definitionLine = 1081;
// method "returnsObject"
  struct UserObject *uo4383 = (struct UserObject*)obj4000;
  uo4383->data[38] = emptyclosure;
  Method *meth_meth_ast_4383_returnsObject = addmethod2pos(obj4000, "returnsObject", &meth_ast_4383_returnsObject, 38);
  int argcv_meth_ast_4383_returnsObject[] = {0};
  meth_meth_ast_4383_returnsObject->type = alloc_MethodType(1, argcv_meth_ast_4383_returnsObject);
  meth_meth_ast_4383_returnsObject->definitionModule = modulename;
  meth_meth_ast_4383_returnsObject->definitionLine = 1084;
// method "returnedObjectScope"
  struct UserObject *uo4402 = (struct UserObject*)obj4000;
  uo4402->data[39] = emptyclosure;
  Method *meth_meth_ast_4402_returnedObjectScope = addmethod2pos(obj4000, "returnedObjectScope", &meth_ast_4402_returnedObjectScope, 39);
  int argcv_meth_ast_4402_returnedObjectScope[] = {0};
  meth_meth_ast_4402_returnedObjectScope->type = alloc_MethodType(1, argcv_meth_ast_4402_returnedObjectScope);
  meth_meth_ast_4402_returnedObjectScope->definitionModule = modulename;
  meth_meth_ast_4402_returnedObjectScope->definitionLine = 1087;
// method "resultExpression"
  struct UserObject *uo4409 = (struct UserObject*)obj4000;
  uo4409->data[40] = emptyclosure;
  Method *meth_meth_ast_4409_resultExpression = addmethod2pos(obj4000, "resultExpression", &meth_ast_4409_resultExpression, 40);
  int argcv_meth_ast_4409_resultExpression[] = {0};
  meth_meth_ast_4409_resultExpression->type = alloc_MethodType(1, argcv_meth_ast_4409_resultExpression);
  meth_meth_ast_4409_resultExpression->definitionModule = modulename;
  meth_meth_ast_4409_resultExpression->definitionLine = 1091;
// method "accept(_)from(_)"
  struct UserObject *uo4430 = (struct UserObject*)obj4000;
  uo4430->data[41] = emptyclosure;
  Method *meth_meth_ast_4430_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj4000, "accept(1)from(1)", &meth_ast_4430_accept_40_1_41_from_40_1_41_, 41);
  int argcv_meth_ast_4430_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_4430_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_4430_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_4430_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4430_accept_40_1_41_from_40_1_41_->definitionLine = 1097;
// method "map(_)ancestors(_)"
  struct UserObject *uo4496 = (struct UserObject*)obj4000;
  uo4496->data[42] = emptyclosure;
  Method *meth_meth_ast_4496_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj4000, "map(1)ancestors(1)", &meth_ast_4496_map_40_1_41_ancestors_40_1_41_, 42);
  int argcv_meth_ast_4496_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_4496_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_4496_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_4496_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4496_map_40_1_41_ancestors_40_1_41_->definitionLine = 1120;
// method "pretty(_)"
  struct UserObject *uo4533 = (struct UserObject*)obj4000;
  uo4533->data[43] = emptyclosure;
  Method *meth_meth_ast_4533_pretty_40_1_41_ = addmethod2pos(obj4000, "pretty(1)", &meth_ast_4533_pretty_40_1_41_, 43);
  int argcv_meth_ast_4533_pretty_40_1_41_[] = {1};
  meth_meth_ast_4533_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4533_pretty_40_1_41_);
  meth_meth_ast_4533_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4533_pretty_40_1_41_->definitionLine = 1130;
// method "toGrace(_)"
  struct UserObject *uo4916 = (struct UserObject*)obj4000;
  uo4916->data[44] = emptyclosure;
  Method *meth_meth_ast_4916_toGrace_40_1_41_ = addmethod2pos(obj4000, "toGrace(1)", &meth_ast_4916_toGrace_40_1_41_, 44);
  int argcv_meth_ast_4916_toGrace_40_1_41_[] = {1};
  meth_meth_ast_4916_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4916_toGrace_40_1_41_);
meth_meth_ast_4916_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_4916_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_4916_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4916_toGrace_40_1_41_->definitionLine = 1172;
// method "shallowCopy"
  block_savedest(obj4000);
  Object closure5148 = createclosure(1, "shallowCopy");
  setclosureframe(closure5148, stackframe);
  addtoclosure(closure5148, var_methodNode);
  struct UserObject *uo5148 = (struct UserObject*)obj4000;
  uo5148->data[45] = (Object)closure5148;
  Method *meth_meth_ast_5148_shallowCopy = addmethod2pos(obj4000, "shallowCopy", &meth_ast_5148_shallowCopy, 45);
  int argcv_meth_ast_5148_shallowCopy[] = {0};
  meth_meth_ast_5148_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_5148_shallowCopy);
  meth_meth_ast_5148_shallowCopy->definitionModule = modulename;
  meth_meth_ast_5148_shallowCopy->definitionLine = 1213;
// method "postCopy(_)"
  struct UserObject *uo5159 = (struct UserObject*)obj4000;
  uo5159->data[46] = emptyclosure;
  Method *meth_meth_ast_5159_postCopy_40_1_41_ = addmethod2pos(obj4000, "postCopy(1)", &meth_ast_5159_postCopy_40_1_41_, 46);
  int argcv_meth_ast_5159_postCopy_40_1_41_[] = {1};
  meth_meth_ast_5159_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5159_postCopy_40_1_41_);
  meth_meth_ast_5159_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5159_postCopy_40_1_41_->definitionLine = 1216;
  sourceObject = obj4000;
// Begin line 963
  setline(963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5175 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5176 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5175);
// compiled call node returning call5176 (depth = 3)
  struct UserObject *obj4000_uo = (struct UserObject *)obj4000;
  obj4000_uo->super = call5176;
  sourceObject = obj4000;
// Begin line 964
  setline(964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5177 == NULL) {
    strlit5177 = alloc_String("method");
    gc_root(strlit5177);
  }
// compiled string node returning strlit5177 (depth = 3)
  adddatum2(obj4000, strlit5177, 1);
  sourceObject = obj4000;
// Begin line 965
  setline(965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature_39_ (depth = 3)
  adddatum2(obj4000, *var_signature_39_, 2);
  sourceObject = obj4000;
// Begin line 966
  setline(966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_body_39_ (depth = 3)
  adddatum2(obj4000, *var_body_39_, 3);
  sourceObject = obj4000;
// Begin line 967
  setline(967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj4000, *var_dtype_39_, 4);
  sourceObject = obj4000;
// Begin line 968
  setline(968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5178 = alloc_Boolean(0);
// compiled identifier node returning bool5178 (depth = 3)
  adddatum2(obj4000, bool5178, 5);
  sourceObject = obj4000;
// Begin line 969
  setline(969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5179 = alloc_Boolean(0);
// compiled identifier node returning bool5179 (depth = 3)
  adddatum2(obj4000, bool5179, 6);
  sourceObject = obj4000;
// Begin line 970
  setline(970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array5180 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5180 (depth = 3)
  adddatum2(obj4000, array5180, 7);
  sourceObject = obj4000;
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5181 = alloc_Boolean(0);
// compiled identifier node returning bool5181 (depth = 3)
  adddatum2(obj4000, bool5181, 8);
  sourceObject = obj4000;
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5182 = alloc_Boolean(0);
// compiled identifier node returning bool5182 (depth = 3)
  adddatum2(obj4000, bool5182, 9);
  sourceObject = obj4000;
// Begin line 973
  setline(973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_uninitialized (depth = 3)
  adddatum2(obj4000, *var_uninitialized, 10);
  sourceObject = obj4000;
// Begin line 974
  setline(974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5183 = alloc_Boolean(1);
// compiled identifier node returning bool5183 (depth = 3)
  adddatum2(obj4000, bool5183, 11);
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  objclass4000 = obj4000->class;
  objclass4000->definitionModule = modulename;
  objclass4000->definitionLine = 956;
  (*(struct UserObject *)self).data[0] = lowerouter4000;
  self = oldself4000;
  selfslot = oldselfslot4000;
  stackframe = oldstackframe4000;
  gc_frame_end(frame);
  return obj4000;
}
Object meth_ast_3999_new_40_3_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_uninitialized = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_k = getfromclosure(closure, 2);
  Object *var_methodNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_signature_39_ = &(stackframe->slots[0]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4000 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4000 = alloc_userobj2(56,47, objclass4000);
  gc_frame_newslot(obj4000);
  if (objclass4000 == NULL) {
    glfree(obj4000->class->name);
    obj4000->class->name = "methodNode.new(_,_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4000, self, 0);
  addmethodreal(obj4000,"outer", &reader_ast_outer_4001);
  Object oldself4000 = self;
  struct StackFrameObject *oldstackframe4000 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4000);
  gc_frame_newslot((Object)stackframe);
  self = obj4000;
  Object *oldselfslot4000 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4000 = (*(struct UserObject *)self).data[0], lowerouter4000 = thisouter4000;
  if (inheritingObject4000) {
    struct UserObject *inho4000 = (struct UserObject *)inheritingObject4000;
    while (inho4000->super != GraceDefaultObject) inho4000 = (struct UserObject *)inho4000->super;
    inho4000->super = obj4000;
    self = inheritingObject4000;
    *selfslot = self;
    lowerouter4000 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4000;
  }
  if (objclass4000 == NULL) {
  Method *reader4002 = addmethodrealflags(obj4000, "kind",&reader_ast_kind_4002, MFLAG_DEF);
  reader4002->definitionModule = modulename;
  reader4002->definitionLine = 964;
  }
  adddatum2(obj4000, alloc_Undefined(), 1);
  if (objclass4000 == NULL) {
    Method *reader4003 = addmethodrealflags(obj4000, "signature", &reader_ast_signature_4003, 0);
    Method *writer4003 = addmethodrealflags(obj4000, "signature:=(1)", &writer_ast_signature_4003, 0);
    reader4003->definitionModule = modulename;
    writer4003->definitionModule = modulename;
    reader4003->definitionLine = 965;
    writer4003->definitionLine = 965;
  }
  obj4000->flags |= OFLAG_MUTABLE;
  adddatum2(obj4000, alloc_Undefined(), 2);
  if (objclass4000 == NULL) {
    Method *reader4004 = addmethodrealflags(obj4000, "body", &reader_ast_body_4004, 0);
    Method *writer4004 = addmethodrealflags(obj4000, "body:=(1)", &writer_ast_body_4004, 0);
    reader4004->definitionModule = modulename;
    writer4004->definitionModule = modulename;
    reader4004->definitionLine = 966;
    writer4004->definitionLine = 966;
  }
  obj4000->flags |= OFLAG_MUTABLE;
  adddatum2(obj4000, alloc_Undefined(), 3);
  if (objclass4000 == NULL) {
    Method *reader4005 = addmethodrealflags(obj4000, "dtype", &reader_ast_dtype_4005, 0);
    Method *writer4005 = addmethodrealflags(obj4000, "dtype:=(1)", &writer_ast_dtype_4005, 0);
    reader4005->definitionModule = modulename;
    writer4005->definitionModule = modulename;
    reader4005->definitionLine = 967;
    writer4005->definitionLine = 967;
  }
  obj4000->flags |= OFLAG_MUTABLE;
  adddatum2(obj4000, alloc_Undefined(), 4);
  if (objclass4000 == NULL) {
    Method *reader4006 = addmethodrealflags(obj4000, "typeParams", &reader_ast_typeParams_4006, 0);
    Method *writer4006 = addmethodrealflags(obj4000, "typeParams:=(1)", &writer_ast_typeParams_4006, 0);
    reader4006->definitionModule = modulename;
    writer4006->definitionModule = modulename;
    reader4006->definitionLine = 968;
    writer4006->definitionLine = 968;
  }
  obj4000->flags |= OFLAG_MUTABLE;
  adddatum2(obj4000, alloc_Undefined(), 5);
  if (objclass4000 == NULL) {
    Method *reader4007 = addmethodrealflags(obj4000, "selfclosure", &reader_ast_selfclosure_4007, 0);
    Method *writer4007 = addmethodrealflags(obj4000, "selfclosure:=(1)", &writer_ast_selfclosure_4007, 0);
    reader4007->definitionModule = modulename;
    writer4007->definitionModule = modulename;
    reader4007->definitionLine = 969;
    writer4007->definitionLine = 969;
  }
  obj4000->flags |= OFLAG_MUTABLE;
  adddatum2(obj4000, alloc_Undefined(), 6);
  if (objclass4000 == NULL) {
    Method *reader4008 = addmethodrealflags(obj4000, "annotations", &reader_ast_annotations_4008, 0);
    Method *writer4008 = addmethodrealflags(obj4000, "annotations:=(1)", &writer_ast_annotations_4008, 0);
    reader4008->definitionModule = modulename;
    writer4008->definitionModule = modulename;
    reader4008->definitionLine = 970;
    writer4008->definitionLine = 970;
  }
  obj4000->flags |= OFLAG_MUTABLE;
  adddatum2(obj4000, alloc_Undefined(), 7);
  if (objclass4000 == NULL) {
    Method *reader4009 = addmethodrealflags(obj4000, "isFresh", &reader_ast_isFresh_4009, 0);
    Method *writer4009 = addmethodrealflags(obj4000, "isFresh:=(1)", &writer_ast_isFresh_4009, 0);
    reader4009->definitionModule = modulename;
    writer4009->definitionModule = modulename;
    reader4009->definitionLine = 971;
    writer4009->definitionLine = 971;
  }
  obj4000->flags |= OFLAG_MUTABLE;
  adddatum2(obj4000, alloc_Undefined(), 8);
  if (objclass4000 == NULL) {
    Method *reader4010 = addmethodrealflags(obj4000, "usesClassSyntax", &reader_ast_usesClassSyntax_4010, 0);
    Method *writer4010 = addmethodrealflags(obj4000, "usesClassSyntax:=(1)", &writer_ast_usesClassSyntax_4010, 0);
    reader4010->definitionModule = modulename;
    writer4010->definitionModule = modulename;
    reader4010->definitionLine = 972;
    writer4010->definitionLine = 972;
  }
  obj4000->flags |= OFLAG_MUTABLE;
  adddatum2(obj4000, alloc_Undefined(), 9);
  if (objclass4000 == NULL) {
    Method *reader4011 = addmethodrealflags(obj4000, "cachedIdentifier", &reader_ast_cachedIdentifier_4011, MFLAG_CONFIDENTIAL);
    Method *writer4011 = addmethodrealflags(obj4000, "cachedIdentifier:=(1)", &writer_ast_cachedIdentifier_4011, MFLAG_CONFIDENTIAL);
    reader4011->definitionModule = modulename;
    writer4011->definitionModule = modulename;
    reader4011->definitionLine = 973;
    writer4011->definitionLine = 973;
  }
  obj4000->flags |= OFLAG_MUTABLE;
  adddatum2(obj4000, alloc_Undefined(), 10);
  if (objclass4000 == NULL) {
    Method *reader4012 = addmethodrealflags(obj4000, "isBindingOccurence", &reader_ast_isBindingOccurence_4012, 0);
    Method *writer4012 = addmethodrealflags(obj4000, "isBindingOccurence:=(1)", &writer_ast_isBindingOccurence_4012, MFLAG_CONFIDENTIAL);
    reader4012->definitionModule = modulename;
    writer4012->definitionModule = modulename;
    reader4012->definitionLine = 974;
    writer4012->definitionLine = 974;
  }
  obj4000->flags |= OFLAG_MUTABLE;
  adddatum2(obj4000, alloc_Undefined(), 11);
// method "end"
  struct UserObject *uo4013 = (struct UserObject*)obj4000;
  uo4013->data[12] = emptyclosure;
  Method *meth_meth_ast_4013_end = addmethod2pos(obj4000, "end", &meth_ast_4013_end, 12);
  int argcv_meth_ast_4013_end[] = {0};
  meth_meth_ast_4013_end->type = alloc_MethodType(1, argcv_meth_ast_4013_end);
  meth_meth_ast_4013_end->definitionModule = modulename;
  meth_meth_ast_4013_end->definitionLine = 977;
// method "ilkName"
  struct UserObject *uo4062 = (struct UserObject*)obj4000;
  uo4062->data[13] = emptyclosure;
  Method *meth_meth_ast_4062_ilkName = addmethod2pos(obj4000, "ilkName", &meth_ast_4062_ilkName, 13);
  int argcv_meth_ast_4062_ilkName[] = {0};
  meth_meth_ast_4062_ilkName->type = alloc_MethodType(1, argcv_meth_ast_4062_ilkName);
  meth_meth_ast_4062_ilkName->definitionModule = modulename;
  meth_meth_ast_4062_ilkName->definitionLine = 987;
// method "appliedOccurence"
  block_savedest(obj4000);
  Object closure4086 = createclosure(1, "appliedOccurence");
  setclosureframe(closure4086, stackframe);
  addtoclosure(closure4086, var_uninitialized);
  struct UserObject *uo4086 = (struct UserObject*)obj4000;
  uo4086->data[14] = (Object)closure4086;
  Method *meth_meth_ast_4086_appliedOccurence = addmethod2pos(obj4000, "appliedOccurence", &meth_ast_4086_appliedOccurence, 14);
  int argcv_meth_ast_4086_appliedOccurence[] = {0};
  meth_meth_ast_4086_appliedOccurence->type = alloc_MethodType(1, argcv_meth_ast_4086_appliedOccurence);
  meth_meth_ast_4086_appliedOccurence->definitionModule = modulename;
  meth_meth_ast_4086_appliedOccurence->definitionLine = 995;
// method "numParams"
  struct UserObject *uo4101 = (struct UserObject*)obj4000;
  uo4101->data[15] = emptyclosure;
  Method *meth_meth_ast_4101_numParams = addmethod2pos(obj4000, "numParams", &meth_ast_4101_numParams, 15);
  int argcv_meth_ast_4101_numParams[] = {0};
  meth_meth_ast_4101_numParams->type = alloc_MethodType(1, argcv_meth_ast_4101_numParams);
  meth_meth_ast_4101_numParams->definitionModule = modulename;
  meth_meth_ast_4101_numParams->definitionLine = 1002;
// method "parametersDo(_)"
  struct UserObject *uo4115 = (struct UserObject*)obj4000;
  uo4115->data[16] = emptyclosure;
  Method *meth_meth_ast_4115_parametersDo_40_1_41_ = addmethod2pos(obj4000, "parametersDo(1)", &meth_ast_4115_parametersDo_40_1_41_, 16);
  int argcv_meth_ast_4115_parametersDo_40_1_41_[] = {1};
  meth_meth_ast_4115_parametersDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4115_parametersDo_40_1_41_);
  meth_meth_ast_4115_parametersDo_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4115_parametersDo_40_1_41_->definitionLine = 1005;
// method "endPos"
  struct UserObject *uo4132 = (struct UserObject*)obj4000;
  uo4132->data[17] = emptyclosure;
  Method *meth_meth_ast_4132_endPos = addmethod2pos(obj4000, "endPos", &meth_ast_4132_endPos, 17);
  int argcv_meth_ast_4132_endPos[] = {0};
  meth_meth_ast_4132_endPos->type = alloc_MethodType(1, argcv_meth_ast_4132_endPos);
  meth_meth_ast_4132_endPos->definitionModule = modulename;
  meth_meth_ast_4132_endPos->definitionLine = 1010;
// method "nameString"
  struct UserObject *uo4150 = (struct UserObject*)obj4000;
  uo4150->data[18] = emptyclosure;
  Method *meth_meth_ast_4150_nameString = addmethod2pos(obj4000, "nameString", &meth_ast_4150_nameString, 18);
  int argcv_meth_ast_4150_nameString[] = {0};
  meth_meth_ast_4150_nameString->type = alloc_MethodType(1, argcv_meth_ast_4150_nameString);
  meth_meth_ast_4150_nameString->definitionModule = modulename;
  meth_meth_ast_4150_nameString->definitionLine = 1015;
// method "asIdentifier"
  block_savedest(obj4000);
  Object closure4164 = createclosure(2, "asIdentifier");
  setclosureframe(closure4164, stackframe);
  addtoclosure(closure4164, var_uninitialized);
  addtoclosure(closure4164, var_identifierNode);
  struct UserObject *uo4164 = (struct UserObject*)obj4000;
  uo4164->data[19] = (Object)closure4164;
  Method *meth_meth_ast_4164_asIdentifier = addmethod2pos(obj4000, "asIdentifier", &meth_ast_4164_asIdentifier, 19);
  int argcv_meth_ast_4164_asIdentifier[] = {0};
  meth_meth_ast_4164_asIdentifier->type = alloc_MethodType(1, argcv_meth_ast_4164_asIdentifier);
  meth_meth_ast_4164_asIdentifier->definitionModule = modulename;
  meth_meth_ast_4164_asIdentifier->definitionLine = 1019;
// method "value"
  struct UserObject *uo4222 = (struct UserObject*)obj4000;
  uo4222->data[20] = emptyclosure;
  Method *meth_meth_ast_4222_value = addmethod2pos(obj4000, "value", &meth_ast_4222_value, 20);
  int argcv_meth_ast_4222_value[] = {0};
  meth_meth_ast_4222_value->type = alloc_MethodType(1, argcv_meth_ast_4222_value);
  meth_meth_ast_4222_value->definitionModule = modulename;
  meth_meth_ast_4222_value->definitionLine = 1030;
// method "canonicalName"
  struct UserObject *uo4225 = (struct UserObject*)obj4000;
  uo4225->data[21] = emptyclosure;
  Method *meth_meth_ast_4225_canonicalName = addmethod2pos(obj4000, "canonicalName", &meth_ast_4225_canonicalName, 21);
  int argcv_meth_ast_4225_canonicalName[] = {0};
  meth_meth_ast_4225_canonicalName->type = alloc_MethodType(1, argcv_meth_ast_4225_canonicalName);
  meth_meth_ast_4225_canonicalName->definitionModule = modulename;
  meth_meth_ast_4225_canonicalName->definitionLine = 1031;
// method "hasParams"
  struct UserObject *uo4239 = (struct UserObject*)obj4000;
  uo4239->data[22] = emptyclosure;
  Method *meth_meth_ast_4239_hasParams = addmethod2pos(obj4000, "hasParams", &meth_ast_4239_hasParams, 22);
  int argcv_meth_ast_4239_hasParams[] = {0};
  meth_meth_ast_4239_hasParams->type = alloc_MethodType(1, argcv_meth_ast_4239_hasParams);
  meth_meth_ast_4239_hasParams->definitionModule = modulename;
  meth_meth_ast_4239_hasParams->definitionLine = 1035;
// method "numParamLists"
  struct UserObject *uo4250 = (struct UserObject*)obj4000;
  uo4250->data[23] = emptyclosure;
  Method *meth_meth_ast_4250_numParamLists = addmethod2pos(obj4000, "numParamLists", &meth_ast_4250_numParamLists, 23);
  int argcv_meth_ast_4250_numParamLists[] = {0};
  meth_meth_ast_4250_numParamLists->type = alloc_MethodType(1, argcv_meth_ast_4250_numParamLists);
  meth_meth_ast_4250_numParamLists->definitionModule = modulename;
  meth_meth_ast_4250_numParamLists->definitionLine = 1036;
// method "hasTypeParams"
  struct UserObject *uo4271 = (struct UserObject*)obj4000;
  uo4271->data[24] = emptyclosure;
  Method *meth_meth_ast_4271_hasTypeParams = addmethod2pos(obj4000, "hasTypeParams", &meth_ast_4271_hasTypeParams, 24);
  int argcv_meth_ast_4271_hasTypeParams[] = {0};
  meth_meth_ast_4271_hasTypeParams->type = alloc_MethodType(1, argcv_meth_ast_4271_hasTypeParams);
  meth_meth_ast_4271_hasTypeParams->definitionModule = modulename;
  meth_meth_ast_4271_hasTypeParams->definitionLine = 1044;
// method "isMethod"
  struct UserObject *uo4282 = (struct UserObject*)obj4000;
  uo4282->data[25] = emptyclosure;
  Method *meth_meth_ast_4282_isMethod = addmethod2pos(obj4000, "isMethod", &meth_ast_4282_isMethod, 25);
  int argcv_meth_ast_4282_isMethod[] = {0};
  meth_meth_ast_4282_isMethod->type = alloc_MethodType(1, argcv_meth_ast_4282_isMethod);
  meth_meth_ast_4282_isMethod->definitionModule = modulename;
  meth_meth_ast_4282_isMethod->definitionLine = 1045;
// method "isExecutable"
  struct UserObject *uo4284 = (struct UserObject*)obj4000;
  uo4284->data[26] = emptyclosure;
  Method *meth_meth_ast_4284_isExecutable = addmethod2pos(obj4000, "isExecutable", &meth_ast_4284_isExecutable, 26);
  int argcv_meth_ast_4284_isExecutable[] = {0};
  meth_meth_ast_4284_isExecutable->type = alloc_MethodType(1, argcv_meth_ast_4284_isExecutable);
  meth_meth_ast_4284_isExecutable->definitionModule = modulename;
  meth_meth_ast_4284_isExecutable->definitionLine = 1046;
// method "isLegalInTrait"
  struct UserObject *uo4286 = (struct UserObject*)obj4000;
  uo4286->data[27] = emptyclosure;
  Method *meth_meth_ast_4286_isLegalInTrait = addmethod2pos(obj4000, "isLegalInTrait", &meth_ast_4286_isLegalInTrait, 27);
  int argcv_meth_ast_4286_isLegalInTrait[] = {0};
  meth_meth_ast_4286_isLegalInTrait->type = alloc_MethodType(1, argcv_meth_ast_4286_isLegalInTrait);
  meth_meth_ast_4286_isLegalInTrait->definitionModule = modulename;
  meth_meth_ast_4286_isLegalInTrait->definitionLine = 1047;
// method "isClass"
  struct UserObject *uo4288 = (struct UserObject*)obj4000;
  uo4288->data[28] = emptyclosure;
  Method *meth_meth_ast_4288_isClass = addmethod2pos(obj4000, "isClass", &meth_ast_4288_isClass, 28);
  int argcv_meth_ast_4288_isClass[] = {0};
  meth_meth_ast_4288_isClass->type = alloc_MethodType(1, argcv_meth_ast_4288_isClass);
  meth_meth_ast_4288_isClass->definitionModule = modulename;
  meth_meth_ast_4288_isClass->definitionLine = 1048;
// method "isTrait"
  struct UserObject *uo4296 = (struct UserObject*)obj4000;
  uo4296->data[29] = emptyclosure;
  Method *meth_meth_ast_4296_isTrait = addmethod2pos(obj4000, "isTrait", &meth_ast_4296_isTrait, 29);
  int argcv_meth_ast_4296_isTrait[] = {0};
  meth_meth_ast_4296_isTrait->type = alloc_MethodType(1, argcv_meth_ast_4296_isTrait);
  meth_meth_ast_4296_isTrait->definitionModule = modulename;
  meth_meth_ast_4296_isTrait->definitionLine = 1049;
// method "needsArgChecks"
  struct UserObject *uo4307 = (struct UserObject*)obj4000;
  uo4307->data[30] = emptyclosure;
  Method *meth_meth_ast_4307_needsArgChecks = addmethod2pos(obj4000, "needsArgChecks", &meth_ast_4307_needsArgChecks, 30);
  int argcv_meth_ast_4307_needsArgChecks[] = {0};
  meth_meth_ast_4307_needsArgChecks->type = alloc_MethodType(1, argcv_meth_ast_4307_needsArgChecks);
  meth_meth_ast_4307_needsArgChecks->definitionModule = modulename;
  meth_meth_ast_4307_needsArgChecks->definitionLine = 1056;
// method "scope:=(_)"
  struct UserObject *uo4345 = (struct UserObject*)obj4000;
  uo4345->data[31] = emptyclosure;
  Method *meth_meth_ast_4345_scope_58__61__40_1_41_ = addmethod2pos(obj4000, "scope:=(1)", &meth_ast_4345_scope_58__61__40_1_41_, 31);
  int argcv_meth_ast_4345_scope_58__61__40_1_41_[] = {1};
  meth_meth_ast_4345_scope_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4345_scope_58__61__40_1_41_);
  meth_meth_ast_4345_scope_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_4345_scope_58__61__40_1_41_->definitionLine = 1067;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj4000);
  Object closure4350 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure4350, stackframe);
  addtoclosure(closure4350, var_k);
  struct UserObject *uo4350 = (struct UserObject*)obj4000;
  uo4350->data[32] = (Object)closure4350;
  Method *meth_meth_ast_4350_declarationKindWithAncestors_40_1_41_ = addmethod2pos(obj4000, "declarationKindWithAncestors(1)", &meth_ast_4350_declarationKindWithAncestors_40_1_41_, 32);
  int argcv_meth_ast_4350_declarationKindWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_4350_declarationKindWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4350_declarationKindWithAncestors_40_1_41_);
  meth_meth_ast_4350_declarationKindWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4350_declarationKindWithAncestors_40_1_41_->definitionLine = 1073;
// method "isConfidential"
  struct UserObject *uo4353 = (struct UserObject*)obj4000;
  uo4353->data[33] = emptyclosure;
  Method *meth_meth_ast_4353_isConfidential = addmethod2pos(obj4000, "isConfidential", &meth_ast_4353_isConfidential, 33);
  int argcv_meth_ast_4353_isConfidential[] = {0};
  meth_meth_ast_4353_isConfidential->type = alloc_MethodType(1, argcv_meth_ast_4353_isConfidential);
  meth_meth_ast_4353_isConfidential->definitionModule = modulename;
  meth_meth_ast_4353_isConfidential->definitionLine = 1074;
// method "isPublic"
  struct UserObject *uo4367 = (struct UserObject*)obj4000;
  uo4367->data[34] = emptyclosure;
  Method *meth_meth_ast_4367_isPublic = addmethod2pos(obj4000, "isPublic", &meth_ast_4367_isPublic, 34);
  int argcv_meth_ast_4367_isPublic[] = {0};
  meth_meth_ast_4367_isPublic->type = alloc_MethodType(1, argcv_meth_ast_4367_isPublic);
  meth_meth_ast_4367_isPublic->definitionModule = modulename;
  meth_meth_ast_4367_isPublic->definitionLine = 1078;
// method "isWritable"
  struct UserObject *uo4372 = (struct UserObject*)obj4000;
  uo4372->data[35] = emptyclosure;
  Method *meth_meth_ast_4372_isWritable = addmethod2pos(obj4000, "isWritable", &meth_ast_4372_isWritable, 35);
  int argcv_meth_ast_4372_isWritable[] = {0};
  meth_meth_ast_4372_isWritable->type = alloc_MethodType(1, argcv_meth_ast_4372_isWritable);
  meth_meth_ast_4372_isWritable->definitionModule = modulename;
  meth_meth_ast_4372_isWritable->definitionLine = 1079;
// method "isReadable"
  struct UserObject *uo4374 = (struct UserObject*)obj4000;
  uo4374->data[36] = emptyclosure;
  Method *meth_meth_ast_4374_isReadable = addmethod2pos(obj4000, "isReadable", &meth_ast_4374_isReadable, 36);
  int argcv_meth_ast_4374_isReadable[] = {0};
  meth_meth_ast_4374_isReadable->type = alloc_MethodType(1, argcv_meth_ast_4374_isReadable);
  meth_meth_ast_4374_isReadable->definitionModule = modulename;
  meth_meth_ast_4374_isReadable->definitionLine = 1080;
// method "usesAsType(_)"
  struct UserObject *uo4377 = (struct UserObject*)obj4000;
  uo4377->data[37] = emptyclosure;
  Method *meth_meth_ast_4377_usesAsType_40_1_41_ = addmethod2pos(obj4000, "usesAsType(1)", &meth_ast_4377_usesAsType_40_1_41_, 37);
  int argcv_meth_ast_4377_usesAsType_40_1_41_[] = {1};
  meth_meth_ast_4377_usesAsType_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4377_usesAsType_40_1_41_);
  meth_meth_ast_4377_usesAsType_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4377_usesAsType_40_1_41_->definitionLine = 1081;
// method "returnsObject"
  struct UserObject *uo4383 = (struct UserObject*)obj4000;
  uo4383->data[38] = emptyclosure;
  Method *meth_meth_ast_4383_returnsObject = addmethod2pos(obj4000, "returnsObject", &meth_ast_4383_returnsObject, 38);
  int argcv_meth_ast_4383_returnsObject[] = {0};
  meth_meth_ast_4383_returnsObject->type = alloc_MethodType(1, argcv_meth_ast_4383_returnsObject);
  meth_meth_ast_4383_returnsObject->definitionModule = modulename;
  meth_meth_ast_4383_returnsObject->definitionLine = 1084;
// method "returnedObjectScope"
  struct UserObject *uo4402 = (struct UserObject*)obj4000;
  uo4402->data[39] = emptyclosure;
  Method *meth_meth_ast_4402_returnedObjectScope = addmethod2pos(obj4000, "returnedObjectScope", &meth_ast_4402_returnedObjectScope, 39);
  int argcv_meth_ast_4402_returnedObjectScope[] = {0};
  meth_meth_ast_4402_returnedObjectScope->type = alloc_MethodType(1, argcv_meth_ast_4402_returnedObjectScope);
  meth_meth_ast_4402_returnedObjectScope->definitionModule = modulename;
  meth_meth_ast_4402_returnedObjectScope->definitionLine = 1087;
// method "resultExpression"
  struct UserObject *uo4409 = (struct UserObject*)obj4000;
  uo4409->data[40] = emptyclosure;
  Method *meth_meth_ast_4409_resultExpression = addmethod2pos(obj4000, "resultExpression", &meth_ast_4409_resultExpression, 40);
  int argcv_meth_ast_4409_resultExpression[] = {0};
  meth_meth_ast_4409_resultExpression->type = alloc_MethodType(1, argcv_meth_ast_4409_resultExpression);
  meth_meth_ast_4409_resultExpression->definitionModule = modulename;
  meth_meth_ast_4409_resultExpression->definitionLine = 1091;
// method "accept(_)from(_)"
  struct UserObject *uo4430 = (struct UserObject*)obj4000;
  uo4430->data[41] = emptyclosure;
  Method *meth_meth_ast_4430_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj4000, "accept(1)from(1)", &meth_ast_4430_accept_40_1_41_from_40_1_41_, 41);
  int argcv_meth_ast_4430_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_4430_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_4430_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_4430_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4430_accept_40_1_41_from_40_1_41_->definitionLine = 1097;
// method "map(_)ancestors(_)"
  struct UserObject *uo4496 = (struct UserObject*)obj4000;
  uo4496->data[42] = emptyclosure;
  Method *meth_meth_ast_4496_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj4000, "map(1)ancestors(1)", &meth_ast_4496_map_40_1_41_ancestors_40_1_41_, 42);
  int argcv_meth_ast_4496_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_4496_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_4496_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_4496_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4496_map_40_1_41_ancestors_40_1_41_->definitionLine = 1120;
// method "pretty(_)"
  struct UserObject *uo4533 = (struct UserObject*)obj4000;
  uo4533->data[43] = emptyclosure;
  Method *meth_meth_ast_4533_pretty_40_1_41_ = addmethod2pos(obj4000, "pretty(1)", &meth_ast_4533_pretty_40_1_41_, 43);
  int argcv_meth_ast_4533_pretty_40_1_41_[] = {1};
  meth_meth_ast_4533_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4533_pretty_40_1_41_);
  meth_meth_ast_4533_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4533_pretty_40_1_41_->definitionLine = 1130;
// method "toGrace(_)"
  struct UserObject *uo4916 = (struct UserObject*)obj4000;
  uo4916->data[44] = emptyclosure;
  Method *meth_meth_ast_4916_toGrace_40_1_41_ = addmethod2pos(obj4000, "toGrace(1)", &meth_ast_4916_toGrace_40_1_41_, 44);
  int argcv_meth_ast_4916_toGrace_40_1_41_[] = {1};
  meth_meth_ast_4916_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_4916_toGrace_40_1_41_);
meth_meth_ast_4916_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_4916_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_4916_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_4916_toGrace_40_1_41_->definitionLine = 1172;
// method "shallowCopy"
  block_savedest(obj4000);
  Object closure5148 = createclosure(1, "shallowCopy");
  setclosureframe(closure5148, stackframe);
  addtoclosure(closure5148, var_methodNode);
  struct UserObject *uo5148 = (struct UserObject*)obj4000;
  uo5148->data[45] = (Object)closure5148;
  Method *meth_meth_ast_5148_shallowCopy = addmethod2pos(obj4000, "shallowCopy", &meth_ast_5148_shallowCopy, 45);
  int argcv_meth_ast_5148_shallowCopy[] = {0};
  meth_meth_ast_5148_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_5148_shallowCopy);
  meth_meth_ast_5148_shallowCopy->definitionModule = modulename;
  meth_meth_ast_5148_shallowCopy->definitionLine = 1213;
// method "postCopy(_)"
  struct UserObject *uo5159 = (struct UserObject*)obj4000;
  uo5159->data[46] = emptyclosure;
  Method *meth_meth_ast_5159_postCopy_40_1_41_ = addmethod2pos(obj4000, "postCopy(1)", &meth_ast_5159_postCopy_40_1_41_, 46);
  int argcv_meth_ast_5159_postCopy_40_1_41_[] = {1};
  meth_meth_ast_5159_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5159_postCopy_40_1_41_);
  meth_meth_ast_5159_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5159_postCopy_40_1_41_->definitionLine = 1216;
  sourceObject = obj4000;
// Begin line 963
  setline(963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5175 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5176 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5175);
// compiled call node returning call5176 (depth = 3)
  struct UserObject *obj4000_uo = (struct UserObject *)obj4000;
  obj4000_uo->super = call5176;
  sourceObject = obj4000;
// Begin line 964
  setline(964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5177 == NULL) {
    strlit5177 = alloc_String("method");
    gc_root(strlit5177);
  }
// compiled string node returning strlit5177 (depth = 3)
  adddatum2(obj4000, strlit5177, 1);
  sourceObject = obj4000;
// Begin line 965
  setline(965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature_39_ (depth = 3)
  adddatum2(obj4000, *var_signature_39_, 2);
  sourceObject = obj4000;
// Begin line 966
  setline(966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_body_39_ (depth = 3)
  adddatum2(obj4000, *var_body_39_, 3);
  sourceObject = obj4000;
// Begin line 967
  setline(967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj4000, *var_dtype_39_, 4);
  sourceObject = obj4000;
// Begin line 968
  setline(968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5178 = alloc_Boolean(0);
// compiled identifier node returning bool5178 (depth = 3)
  adddatum2(obj4000, bool5178, 5);
  sourceObject = obj4000;
// Begin line 969
  setline(969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5179 = alloc_Boolean(0);
// compiled identifier node returning bool5179 (depth = 3)
  adddatum2(obj4000, bool5179, 6);
  sourceObject = obj4000;
// Begin line 970
  setline(970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array5180 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5180 (depth = 3)
  adddatum2(obj4000, array5180, 7);
  sourceObject = obj4000;
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5181 = alloc_Boolean(0);
// compiled identifier node returning bool5181 (depth = 3)
  adddatum2(obj4000, bool5181, 8);
  sourceObject = obj4000;
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5182 = alloc_Boolean(0);
// compiled identifier node returning bool5182 (depth = 3)
  adddatum2(obj4000, bool5182, 9);
  sourceObject = obj4000;
// Begin line 973
  setline(973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_uninitialized (depth = 3)
  adddatum2(obj4000, *var_uninitialized, 10);
  sourceObject = obj4000;
// Begin line 974
  setline(974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5183 = alloc_Boolean(1);
// compiled identifier node returning bool5183 (depth = 3)
  adddatum2(obj4000, bool5183, 11);
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  sourceObject = obj4000;
  objclass4000 = obj4000->class;
  objclass4000->definitionModule = modulename;
  objclass4000->definitionLine = 956;
  (*(struct UserObject *)self).data[0] = lowerouter4000;
  self = oldself4000;
  selfslot = oldselfslot4000;
  stackframe = oldstackframe4000;
  gc_frame_end(frame);
  return obj4000;
}
Object meth_ast_5185_methodNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 35, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_methodNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 949
  setline(949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methodNode (depth = 3)
  gc_frame_end(frame);
  return *var_methodNode;
}
Object meth_ast_5188_new_40_2_41_scope_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new(2)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)scope(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_)scope(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_receiver = &(stackframe->slots[0]);
  *var_receiver = args[curarg];
  curarg++;
  Object *var_parts = &(stackframe->slots[1]);
  *var_parts = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1228
  setline(1228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5189 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_receiver (depth = 5)
  gc_frame_newslot(*var_receiver);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_parts (depth = 5)
  gc_frame_newslot(*var_parts);
// call case 4: self request
  params[0] = *var_receiver;
  params[1] = *var_parts;
  partcv[0] = 2;
  Object call5190 = callmethodflags(self, "new(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5189);
// compiled call node returning call5190 (depth = 4)
  *var_result = call5190;
  if (call5190 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1229
  setline(1229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5191 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call5192 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5191);
// compiled call node returning call5192 (depth = 3)
// Begin line 1230
  setline(1230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_5206_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_noPosition = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1250
  setline(1250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_noPosition (depth = 5)
  int op_slot_right_5208 = gc_frame_newslot(*var_noPosition);
// starting to compile member node (depth = 5)
  int callframe5210 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5211 = callmethodflags(self, "endPos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5210);
// compiled member node returning call5211 (depth = 5)
  int op_slot_left_5208 = gc_frame_newslot(call5211);
  params[0] = *var_noPosition;
  partcv[0] = 1;
  Object opresult5212 = callmethod(call5211, "==(1)", 1, partcv, params);
// compiled op node returning opresult5212 (depth = 4)
  Object if5207 = done;
  if (istrue(opresult5212)) {
// Begin line 1251
  setline(1251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5214 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5215 = callmethodflags(self, "isRequestOfPrefixOperator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5214);
// compiled member node returning call5215 (depth = 5)
  Object if5213 = done;
  if (istrue(call5215)) {
// Begin line 1252
  setline(1252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5216 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num5217 = alloc_Float64(60);
// compiled num node returning num5217 (depth = 6)
  gc_frame_newslot(num5217);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5219 == NULL) {
    strlit5219 = alloc_String("");
    gc_root(strlit5219);
  }
// compiled string node returning strlit5219 (depth = 7)
  int op_slot_right_5218 = gc_frame_newslot(strlit5219);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe5222 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe5223 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5224 = callmethodflags(self, "receiver", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5223);
// compiled member node returning call5224 (depth = 9)
  partcv[0] = 0;
  Object call5225 = callmethodflags(call5224, "end", 1, partcv, params, 0);
  gc_frame_end(callframe5222);
// compiled member node returning call5225 (depth = 8)
  int op_slot_right_5221 = gc_frame_newslot(call5225);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5228 == NULL) {
    strlit5228 = alloc_String(" with ");
    gc_root(strlit5228);
  }
// compiled string node returning strlit5228 (depth = 9)
  int op_slot_right_5227 = gc_frame_newslot(strlit5228);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5231 = gc_frame_new();
// starting to compile num node (depth = 11)
  Object num5232 = alloc_Float64(1);
// compiled num node returning num5232 (depth = 11)
  gc_frame_newslot(num5232);
// call case 4: self request
  params[0] = num5232;
  partcv[0] = 1;
  Object call5233 = callmethodflags(self, "pretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5231);
// compiled call node returning call5233 (depth = 10)
  int op_slot_right_5230 = gc_frame_newslot(call5233);
// starting to compile string node (depth = 10)
  if (strlit5235 == NULL) {
    strlit5235 = alloc_String("guessing at end of ");
    gc_root(strlit5235);
  }
// compiled string node returning strlit5235 (depth = 10)
  int op_slot_left_5230 = gc_frame_newslot(strlit5235);
  params[0] = call5233;
  partcv[0] = 1;
  Object opresult5236 = callmethod(strlit5235, "++(1)", 1, partcv, params);
// compiled op node returning opresult5236 (depth = 9)
  int op_slot_left_5227 = gc_frame_newslot(opresult5236);
  params[0] = strlit5228;
  partcv[0] = 1;
  Object opresult5237 = callmethod(opresult5236, "++(1)", 1, partcv, params);
// compiled op node returning opresult5237 (depth = 8)
  int op_slot_left_5221 = gc_frame_newslot(opresult5237);
  params[0] = call5225;
  partcv[0] = 1;
  Object opresult5238 = callmethod(opresult5237, "++(1)", 1, partcv, params);
// compiled op node returning opresult5238 (depth = 7)
  int op_slot_left_5218 = gc_frame_newslot(opresult5238);
  params[0] = strlit5219;
  partcv[0] = 1;
  Object opresult5239 = callmethod(opresult5238, "++(1)", 1, partcv, params);
// compiled op node returning opresult5239 (depth = 6)
  gc_frame_newslot(opresult5239);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  params[0] = num5217;
  params[1] = opresult5239;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5240 = callmethodflags(*var_util, "log(1)verbose(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5216);
// compiled call node returning call5240 (depth = 5)
// Begin line 1253
  setline(1253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5241 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5242 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5243 = callmethodflags(self, "receiver", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5242);
// compiled member node returning call5243 (depth = 6)
  partcv[0] = 0;
  Object call5244 = callmethodflags(call5243, "end", 1, partcv, params, 0);
  gc_frame_end(callframe5241);
// compiled member node returning call5244 (depth = 5)
    gc_frame_newslot(call5244);
    if5213 = call5244;
  } else {
// Begin line 1255
  setline(1255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5245 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num5246 = alloc_Float64(60);
// compiled num node returning num5246 (depth = 6)
  gc_frame_newslot(num5246);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5248 == NULL) {
    strlit5248 = alloc_String("");
    gc_root(strlit5248);
  }
// compiled string node returning strlit5248 (depth = 7)
  int op_slot_right_5247 = gc_frame_newslot(strlit5248);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe5251 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe5252 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe5253 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5254 = callmethodflags(self, "parts", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5253);
// compiled member node returning call5254 (depth = 10)
  partcv[0] = 0;
  Object call5255 = callmethodflags(call5254, "last", 1, partcv, params, 0);
  gc_frame_end(callframe5252);
// compiled member node returning call5255 (depth = 9)
  partcv[0] = 0;
  Object call5256 = callmethodflags(call5255, "end", 1, partcv, params, 0);
  gc_frame_end(callframe5251);
// compiled member node returning call5256 (depth = 8)
  int op_slot_right_5250 = gc_frame_newslot(call5256);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5259 == NULL) {
    strlit5259 = alloc_String(" with ");
    gc_root(strlit5259);
  }
// compiled string node returning strlit5259 (depth = 9)
  int op_slot_right_5258 = gc_frame_newslot(strlit5259);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5262 = gc_frame_new();
// starting to compile num node (depth = 11)
  Object num5263 = alloc_Float64(1);
// compiled num node returning num5263 (depth = 11)
  gc_frame_newslot(num5263);
// call case 4: self request
  params[0] = num5263;
  partcv[0] = 1;
  Object call5264 = callmethodflags(self, "pretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5262);
// compiled call node returning call5264 (depth = 10)
  int op_slot_right_5261 = gc_frame_newslot(call5264);
// starting to compile string node (depth = 10)
  if (strlit5266 == NULL) {
    strlit5266 = alloc_String("guessing at end of ");
    gc_root(strlit5266);
  }
// compiled string node returning strlit5266 (depth = 10)
  int op_slot_left_5261 = gc_frame_newslot(strlit5266);
  params[0] = call5264;
  partcv[0] = 1;
  Object opresult5267 = callmethod(strlit5266, "++(1)", 1, partcv, params);
// compiled op node returning opresult5267 (depth = 9)
  int op_slot_left_5258 = gc_frame_newslot(opresult5267);
  params[0] = strlit5259;
  partcv[0] = 1;
  Object opresult5268 = callmethod(opresult5267, "++(1)", 1, partcv, params);
// compiled op node returning opresult5268 (depth = 8)
  int op_slot_left_5250 = gc_frame_newslot(opresult5268);
  params[0] = call5256;
  partcv[0] = 1;
  Object opresult5269 = callmethod(opresult5268, "++(1)", 1, partcv, params);
// compiled op node returning opresult5269 (depth = 7)
  int op_slot_left_5247 = gc_frame_newslot(opresult5269);
  params[0] = strlit5248;
  partcv[0] = 1;
  Object opresult5270 = callmethod(opresult5269, "++(1)", 1, partcv, params);
// compiled op node returning opresult5270 (depth = 6)
  gc_frame_newslot(opresult5270);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  params[0] = num5246;
  params[1] = opresult5270;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5271 = callmethodflags(*var_util, "log(1)verbose(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5245);
// compiled call node returning call5271 (depth = 5)
// Begin line 1256
  setline(1256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5272 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5273 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5274 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5275 = callmethodflags(self, "parts", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5274);
// compiled member node returning call5275 (depth = 7)
  partcv[0] = 0;
  Object call5276 = callmethodflags(call5275, "last", 1, partcv, params, 0);
  gc_frame_end(callframe5273);
// compiled member node returning call5276 (depth = 6)
  partcv[0] = 0;
  Object call5277 = callmethodflags(call5276, "end", 1, partcv, params, 0);
  gc_frame_end(callframe5272);
// compiled member node returning call5277 (depth = 5)
    gc_frame_newslot(call5277);
    if5213 = call5277;
  }
// compiled if node returning if5213 (depth = 4)
    gc_frame_newslot(if5213);
    if5207 = if5213;
  } else {
// Begin line 1259
  setline(1259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5278 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5279 = callmethodflags(self, "endPos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5278);
// compiled member node returning call5279 (depth = 4)
    gc_frame_newslot(call5279);
    if5207 = call5279;
  }
// compiled if node returning if5207 (depth = 3)
  gc_frame_end(frame);
  return if5207;
}
Object meth_ast_5280_end_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "end:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method end:=(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for end:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_newPos = &(stackframe->slots[0]);
  *var_newPos = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part end:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1262
  setline(1262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5281 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_newPos (depth = 4)
  gc_frame_newslot(*var_newPos);
// call case 4: self request
  params[0] = *var_newPos;
  partcv[0] = 1;
  Object call5282 = callmethodflags(self, "endPos:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5281);
// compiled call node returning call5282 (depth = 3)
  gc_frame_end(frame);
  return call5282;
}
Object meth_ast_5283_isRequestOfPrefixOperator(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isRequestOfPrefixOperator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1263
  setline(1263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5284 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5285 == NULL) {
    strlit5285 = alloc_String("prefix");
    gc_root(strlit5285);
  }
// compiled string node returning strlit5285 (depth = 4)
  gc_frame_newslot(strlit5285);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5286 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5287 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5288 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5289 = callmethodflags(self, "parts", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5288);
// compiled member node returning call5289 (depth = 6)
  partcv[0] = 0;
  Object call5290 = callmethodflags(call5289, "first", 1, partcv, params, 0);
  gc_frame_end(callframe5287);
// compiled member node returning call5290 (depth = 5)
  partcv[0] = 0;
  Object call5291 = callmethodflags(call5290, "name", 1, partcv, params, 0);
  gc_frame_end(callframe5286);
// compiled member node returning call5291 (depth = 4)
  params[0] = strlit5285;
  partcv[0] = 1;
  Object call5292 = callmethodflags(call5291, "startsWith(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5284);
// compiled call node returning call5292 (depth = 3)
  gc_frame_end(frame);
  return call5292;
}
Object meth_ast_5293_onSelf(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "onSelf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1266
  setline(1266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5294 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool5295 = alloc_Boolean(1);
// compiled identifier node returning bool5295 (depth = 4)
  gc_frame_newslot(bool5295);
// call case 4: self request
  params[0] = bool5295;
  partcv[0] = 1;
  Object call5296 = callmethodflags(self, "isSelfRequest:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5294);
// compiled call node returning call5296 (depth = 3)
// Begin line 1267
  setline(1267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_5300__apply_40_2_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_acc = &(stackframe->slots[0]);
  *var_acc = args[curarg];
  curarg++;
  Object *var_each = &(stackframe->slots[1]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5302 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  partcv[0] = 0;
  Object call5303 = callmethodflags(*var_each, "nameString", 1, partcv, params, 0);
  gc_frame_end(callframe5302);
// compiled member node returning call5303 (depth = 6)
  int op_slot_right_5301 = gc_frame_newslot(call5303);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acc (depth = 6)
  int op_slot_left_5301 = gc_frame_newslot(*var_acc);
  params[0] = call5303;
  partcv[0] = 1;
  Object opresult5305 = callmethod(*var_acc, "++(1)", 1, partcv, params);
// compiled op node returning opresult5305 (depth = 5)
  gc_frame_end(frame);
  return opresult5305;
}
Object meth_ast_5297_nameString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5298 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5299 = alloc_Block(NULL, NULL, "ast", 1272);
  gc_frame_newslot(block5299);
// method "_apply(_,_)"
  block_savedest(block5299);
  Object closure5300 = createclosure(1, "_apply(2)");
  setclosureframe(closure5300, stackframe);
  addtoclosure(closure5300, selfslot);
  struct UserObject *uo5300 = (struct UserObject*)block5299;
  uo5300->data[0] = (Object)closure5300;
  Method *meth_meth_ast_5300__apply_40_2_41_ = addmethod2pos(block5299, "_apply(2)", &meth_ast_5300__apply_40_2_41_, 0);
  int argcv_meth_ast_5300__apply_40_2_41_[] = {2};
  meth_meth_ast_5300__apply_40_2_41_->type = alloc_MethodType(1, argcv_meth_ast_5300__apply_40_2_41_);
  meth_meth_ast_5300__apply_40_2_41_->definitionModule = modulename;
  meth_meth_ast_5300__apply_40_2_41_->definitionLine = 3050;
// compiled block node returning block5299 (depth = 4)
  gc_frame_newslot(block5299);
// starting to compile string node (depth = 4)
  if (strlit5307 == NULL) {
    strlit5307 = alloc_String("");
    gc_root(strlit5307);
  }
// compiled string node returning strlit5307 (depth = 4)
  gc_frame_newslot(strlit5307);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5308 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5309 = callmethodflags(self, "parts", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5308);
// compiled member node returning call5309 (depth = 4)
  params[0] = block5299;
  params[1] = strlit5307;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5310 = callmethodflags(call5309, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5298);
// compiled call node returning call5310 (depth = 3)
  gc_frame_end(frame);
  return call5310;
}
Object meth_ast_5314__apply_40_2_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_acc = &(stackframe->slots[0]);
  *var_acc = args[curarg];
  curarg++;
  Object *var_each = &(stackframe->slots[1]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5316 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  partcv[0] = 0;
  Object call5317 = callmethodflags(*var_each, "canonicalName", 1, partcv, params, 0);
  gc_frame_end(callframe5316);
// compiled member node returning call5317 (depth = 6)
  int op_slot_right_5315 = gc_frame_newslot(call5317);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acc (depth = 6)
  int op_slot_left_5315 = gc_frame_newslot(*var_acc);
  params[0] = call5317;
  partcv[0] = 1;
  Object opresult5319 = callmethod(*var_acc, "++(1)", 1, partcv, params);
// compiled op node returning opresult5319 (depth = 5)
  gc_frame_end(frame);
  return opresult5319;
}
Object meth_ast_5311_canonicalName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canonicalName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1277
  setline(1277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5312 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5313 = alloc_Block(NULL, NULL, "ast", 1277);
  gc_frame_newslot(block5313);
// method "_apply(_,_)"
  block_savedest(block5313);
  Object closure5314 = createclosure(1, "_apply(2)");
  setclosureframe(closure5314, stackframe);
  addtoclosure(closure5314, selfslot);
  struct UserObject *uo5314 = (struct UserObject*)block5313;
  uo5314->data[0] = (Object)closure5314;
  Method *meth_meth_ast_5314__apply_40_2_41_ = addmethod2pos(block5313, "_apply(2)", &meth_ast_5314__apply_40_2_41_, 0);
  int argcv_meth_ast_5314__apply_40_2_41_[] = {2};
  meth_meth_ast_5314__apply_40_2_41_->type = alloc_MethodType(1, argcv_meth_ast_5314__apply_40_2_41_);
  meth_meth_ast_5314__apply_40_2_41_->definitionModule = modulename;
  meth_meth_ast_5314__apply_40_2_41_->definitionLine = 3050;
// compiled block node returning block5313 (depth = 4)
  gc_frame_newslot(block5313);
// Begin line 1278
  setline(1278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit5321 == NULL) {
    strlit5321 = alloc_String("");
    gc_root(strlit5321);
  }
// compiled string node returning strlit5321 (depth = 4)
  gc_frame_newslot(strlit5321);
// call case 6: other requests
// Begin line 1277
  setline(1277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5322 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5323 = callmethodflags(self, "parts", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5322);
// compiled member node returning call5323 (depth = 4)
  params[0] = block5313;
  params[1] = strlit5321;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5324 = callmethodflags(call5323, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5312);
// compiled call node returning call5324 (depth = 3)
  gc_frame_end(frame);
  return call5324;
}
Object meth_ast_5325_isCall(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1281
  setline(1281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5326 = alloc_Boolean(1);
// compiled identifier node returning bool5326 (depth = 3)
  gc_frame_end(frame);
  return bool5326;
}
Object meth_ast_5327_returnsObject(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1285
  setline(1285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5329 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5330 = callmethodflags(self, "isCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5329);
// compiled member node returning call5330 (depth = 4)
  Object if5328 = done;
  if (istrue(call5330)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool5331 = alloc_Boolean(1);
// compiled identifier node returning bool5331 (depth = 5)
  return bool5331;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if5328 = undefined;
  } else {
  }
// compiled if node returning if5328 (depth = 3)
// Begin line 1286
  setline(1286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5333 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5334 = callmethodflags(self, "isClone", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5333);
// compiled member node returning call5334 (depth = 4)
  Object if5332 = done;
  if (istrue(call5334)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool5335 = alloc_Boolean(1);
// compiled identifier node returning bool5335 (depth = 5)
  return bool5335;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if5332 = undefined;
  } else {
  }
// compiled if node returning if5332 (depth = 3)
// Begin line 1287
  setline(1287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5336 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5337 = callmethodflags(self, "isFresh", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5336);
// compiled member node returning call5337 (depth = 3)
  gc_frame_end(frame);
  return call5337;
}
Object meth_ast_5338_isCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1290
  setline(1290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5341 == NULL) {
    strlit5341 = alloc_String("copy");
    gc_root(strlit5341);
  }
// compiled string node returning strlit5341 (depth = 5)
  int op_slot_right_5340 = gc_frame_newslot(strlit5341);
// starting to compile member node (depth = 5)
  int callframe5343 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5344 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5343);
// compiled member node returning call5344 (depth = 5)
  int op_slot_left_5340 = gc_frame_newslot(call5344);
  params[0] = strlit5341;
  partcv[0] = 1;
  Object opresult5345 = callmethod(call5344, "==(1)", 1, partcv, params);
// compiled op node returning opresult5345 (depth = 4)
  int op_slot_right_5339 = gc_frame_newslot(opresult5345);
// Begin line 1290
  setline(1290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5348 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5349 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5350 = callmethodflags(self, "receiver", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5349);
// compiled member node returning call5350 (depth = 6)
  partcv[0] = 0;
  Object call5351 = callmethodflags(call5350, "isSelf", 1, partcv, params, 0);
  gc_frame_end(callframe5348);
// compiled member node returning call5351 (depth = 5)
  int op_slot_right_5347 = gc_frame_newslot(call5351);
// starting to compile member node (depth = 5)
  int callframe5353 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5354 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5355 = callmethodflags(self, "receiver", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5354);
// compiled member node returning call5355 (depth = 6)
  partcv[0] = 0;
  Object call5356 = callmethodflags(call5355, "isImplicit", 1, partcv, params, 0);
  gc_frame_end(callframe5353);
// compiled member node returning call5356 (depth = 5)
  int op_slot_left_5347 = gc_frame_newslot(call5356);
  params[0] = call5351;
  partcv[0] = 1;
  Object opresult5357 = callmethod(call5356, "||(1)", 1, partcv, params);
// compiled op node returning opresult5357 (depth = 4)
  int op_slot_left_5339 = gc_frame_newslot(opresult5357);
  params[0] = opresult5345;
  partcv[0] = 1;
  Object opresult5358 = callmethod(opresult5357, "&&(1)", 1, partcv, params);
// compiled op node returning opresult5358 (depth = 3)
  gc_frame_end(frame);
  return opresult5358;
}
Object meth_ast_5359_isClone(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isClone");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1294
  setline(1294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// Begin line 1295
  setline(1295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5362 == NULL) {
    strlit5362 = alloc_String("clone(1)");
    gc_root(strlit5362);
  }
// compiled string node returning strlit5362 (depth = 5)
  int op_slot_right_5361 = gc_frame_newslot(strlit5362);
// starting to compile member node (depth = 5)
  int callframe5364 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5365 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5364);
// compiled member node returning call5365 (depth = 5)
  int op_slot_left_5361 = gc_frame_newslot(call5365);
  params[0] = strlit5362;
  partcv[0] = 1;
  Object opresult5366 = callmethod(call5365, "==(1)", 1, partcv, params);
// compiled op node returning opresult5366 (depth = 4)
  int op_slot_right_5360 = gc_frame_newslot(opresult5366);
// Begin line 1294
  setline(1294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5369 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5370 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5371 = callmethodflags(self, "receiver", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5370);
// compiled member node returning call5371 (depth = 6)
  partcv[0] = 0;
  Object call5372 = callmethodflags(call5371, "isPrelude", 1, partcv, params, 0);
  gc_frame_end(callframe5369);
// compiled member node returning call5372 (depth = 5)
  int op_slot_right_5368 = gc_frame_newslot(call5372);
// starting to compile member node (depth = 5)
  int callframe5374 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5375 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5376 = callmethodflags(self, "receiver", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5375);
// compiled member node returning call5376 (depth = 6)
  partcv[0] = 0;
  Object call5377 = callmethodflags(call5376, "isImplicit", 1, partcv, params, 0);
  gc_frame_end(callframe5374);
// compiled member node returning call5377 (depth = 5)
  int op_slot_left_5368 = gc_frame_newslot(call5377);
  params[0] = call5372;
  partcv[0] = 1;
  Object opresult5378 = callmethod(call5377, "||(1)", 1, partcv, params);
// compiled op node returning opresult5378 (depth = 4)
  int op_slot_left_5360 = gc_frame_newslot(opresult5378);
  params[0] = opresult5366;
  partcv[0] = 1;
  Object opresult5379 = callmethod(opresult5378, "&&(1)", 1, partcv, params);
// compiled op node returning opresult5379 (depth = 3)
  gc_frame_end(frame);
  return opresult5379;
}
Object meth_ast_5380_returnedObjectScope(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1299
  setline(1299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5381 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5382 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5381);
// compiled member node returning call5382 (depth = 3)
  gc_frame_end(frame);
  return call5382;
}
Object meth_ast_5394__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 7)
  int callframe5395 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_arg (depth = 8)
  gc_frame_newslot(*var_arg);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_result (depth = 8)
  params[0] = *var_arg;
  partcv[0] = 1;
  Object call5396 = callmethodflags(*var_result, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5395);
// compiled call node returning call5396 (depth = 7)
  gc_frame_end(frame);
  return call5396;
}
Object meth_ast_5389__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1304
  setline(1304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5390 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe5391 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call5392 = callmethodflags(*var_part, "args", 1, partcv, params, 0);
  gc_frame_end(callframe5391);
// compiled member node returning call5392 (depth = 6)
  gc_frame_newslot(call5392);
// starting to compile block node (depth = 6)
  Object block5393 = alloc_Block(NULL, NULL, "ast", 1304);
  gc_frame_newslot(block5393);
// method "_apply(_)"
  block_savedest(block5393);
  Object closure5394 = createclosure(2, "_apply(1)");
  setclosureframe(closure5394, stackframe);
  addtoclosure(closure5394, var_result);
  addtoclosure(closure5394, selfslot);
  struct UserObject *uo5394 = (struct UserObject*)block5393;
  uo5394->data[0] = (Object)closure5394;
  Method *meth_meth_ast_5394__apply_40_1_41_ = addmethod2pos(block5393, "_apply(1)", &meth_ast_5394__apply_40_1_41_, 0);
  int argcv_meth_ast_5394__apply_40_1_41_[] = {1};
  meth_meth_ast_5394__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5394__apply_40_1_41_);
  meth_meth_ast_5394__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5394__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block5393 (depth = 6)
  gc_frame_newslot(block5393);
// call case 5: prelude request
  params[0] = call5392;
  params[1] = block5393;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5398 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5390);
// compiled call node returning call5398 (depth = 5)
  gc_frame_end(frame);
  return call5398;
}
Object meth_ast_5383_arguments(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "arguments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 1302
  setline(1302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array5384 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5384 (depth = 4)
  *var_result = array5384;
  if (array5384 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1303
  setline(1303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5385 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5386 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5387 = callmethodflags(self, "parts", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5386);
// compiled member node returning call5387 (depth = 4)
  gc_frame_newslot(call5387);
// starting to compile block node (depth = 4)
  Object block5388 = alloc_Block(NULL, NULL, "ast", 1303);
  gc_frame_newslot(block5388);
// method "_apply(_)"
  block_savedest(block5388);
  Object closure5389 = createclosure(2, "_apply(1)");
  setclosureframe(closure5389, stackframe);
  addtoclosure(closure5389, var_result);
  addtoclosure(closure5389, selfslot);
  struct UserObject *uo5389 = (struct UserObject*)block5388;
  uo5389->data[0] = (Object)closure5389;
  Method *meth_meth_ast_5389__apply_40_1_41_ = addmethod2pos(block5388, "_apply(1)", &meth_ast_5389__apply_40_1_41_, 0);
  int argcv_meth_ast_5389__apply_40_1_41_[] = {1};
  meth_meth_ast_5389__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5389__apply_40_1_41_);
  meth_meth_ast_5389__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5389__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block5388 (depth = 4)
  gc_frame_newslot(block5388);
// call case 5: prelude request
  params[0] = call5387;
  params[1] = block5388;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5400 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5385);
// compiled call node returning call5400 (depth = 3)
// Begin line 1306
  setline(1306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_5411__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 7)
  int callframe5412 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_arg (depth = 8)
  gc_frame_newslot(*var_arg);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_action (depth = 8)
  params[0] = *var_arg;
  partcv[0] = 1;
  Object call5413 = callmethodflags(*var_action, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5412);
// compiled call node returning call5413 (depth = 7)
  gc_frame_end(frame);
  return call5413;
}
Object meth_ast_5406__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1311
  setline(1311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5407 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe5408 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call5409 = callmethodflags(*var_part, "args", 1, partcv, params, 0);
  gc_frame_end(callframe5408);
// compiled member node returning call5409 (depth = 6)
  gc_frame_newslot(call5409);
// starting to compile block node (depth = 6)
  Object block5410 = alloc_Block(NULL, NULL, "ast", 1311);
  gc_frame_newslot(block5410);
// method "_apply(_)"
  block_savedest(block5410);
  Object closure5411 = createclosure(2, "_apply(1)");
  setclosureframe(closure5411, stackframe);
  addtoclosure(closure5411, var_action);
  addtoclosure(closure5411, selfslot);
  struct UserObject *uo5411 = (struct UserObject*)block5410;
  uo5411->data[0] = (Object)closure5411;
  Method *meth_meth_ast_5411__apply_40_1_41_ = addmethod2pos(block5410, "_apply(1)", &meth_ast_5411__apply_40_1_41_, 0);
  int argcv_meth_ast_5411__apply_40_1_41_[] = {1};
  meth_meth_ast_5411__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5411__apply_40_1_41_);
  meth_meth_ast_5411__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5411__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block5410 (depth = 6)
  gc_frame_newslot(block5410);
// call case 5: prelude request
  params[0] = call5409;
  params[1] = block5410;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5415 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5407);
// compiled call node returning call5415 (depth = 5)
  gc_frame_end(frame);
  return call5415;
}
Object meth_ast_5401_argumentsDo_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "argumentsDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method argumentsDo(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for argumentsDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part argumentsDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1310
  setline(1310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5402 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5403 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5404 = callmethodflags(self, "parts", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5403);
// compiled member node returning call5404 (depth = 4)
  gc_frame_newslot(call5404);
// starting to compile block node (depth = 4)
  Object block5405 = alloc_Block(NULL, NULL, "ast", 1310);
  gc_frame_newslot(block5405);
// method "_apply(_)"
  block_savedest(block5405);
  Object closure5406 = createclosure(2, "_apply(1)");
  setclosureframe(closure5406, stackframe);
  addtoclosure(closure5406, var_action);
  addtoclosure(closure5406, selfslot);
  struct UserObject *uo5406 = (struct UserObject*)block5405;
  uo5406->data[0] = (Object)closure5406;
  Method *meth_meth_ast_5406__apply_40_1_41_ = addmethod2pos(block5405, "_apply(1)", &meth_ast_5406__apply_40_1_41_, 0);
  int argcv_meth_ast_5406__apply_40_1_41_[] = {1};
  meth_meth_ast_5406__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5406__apply_40_1_41_);
  meth_meth_ast_5406__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5406__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block5405 (depth = 4)
  gc_frame_newslot(block5405);
// call case 5: prelude request
  params[0] = call5404;
  params[1] = block5405;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5417 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5402);
// compiled call node returning call5417 (depth = 3)
  gc_frame_end(frame);
  return call5417;
}
Object meth_ast_5421__apply_40_2_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_acc = &(stackframe->slots[0]);
  *var_acc = args[curarg];
  curarg++;
  Object *var_part = &(stackframe->slots[1]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5423 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5424 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call5425 = callmethodflags(*var_part, "args", 1, partcv, params, 0);
  gc_frame_end(callframe5424);
// compiled member node returning call5425 (depth = 7)
  partcv[0] = 0;
  Object call5426 = callmethodflags(call5425, "size", 1, partcv, params, 0);
  gc_frame_end(callframe5423);
// compiled member node returning call5426 (depth = 6)
  int op_slot_right_5422 = gc_frame_newslot(call5426);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acc (depth = 6)
  int op_slot_left_5422 = gc_frame_newslot(*var_acc);
  params[0] = call5426;
  partcv[0] = 1;
  Object sum5428 = callmethod(*var_acc, "+(1)", 1, partcv, params);
// compiled op node returning sum5428 (depth = 5)
  gc_frame_end(frame);
  return sum5428;
}
Object meth_ast_5418_numArgs(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "numArgs");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1316
  setline(1316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5419 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5420 = alloc_Block(NULL, NULL, "ast", 1316);
  gc_frame_newslot(block5420);
// method "_apply(_,_)"
  block_savedest(block5420);
  Object closure5421 = createclosure(1, "_apply(2)");
  setclosureframe(closure5421, stackframe);
  addtoclosure(closure5421, selfslot);
  struct UserObject *uo5421 = (struct UserObject*)block5420;
  uo5421->data[0] = (Object)closure5421;
  Method *meth_meth_ast_5421__apply_40_2_41_ = addmethod2pos(block5420, "_apply(2)", &meth_ast_5421__apply_40_2_41_, 0);
  int argcv_meth_ast_5421__apply_40_2_41_[] = {2};
  meth_meth_ast_5421__apply_40_2_41_->type = alloc_MethodType(1, argcv_meth_ast_5421__apply_40_2_41_);
  meth_meth_ast_5421__apply_40_2_41_->definitionModule = modulename;
  meth_meth_ast_5421__apply_40_2_41_->definitionLine = 3050;
// compiled block node returning block5420 (depth = 4)
  gc_frame_newslot(block5420);
// starting to compile num node (depth = 4)
  Object num5430 = alloc_Float64(0);
// compiled num node returning num5430 (depth = 4)
  gc_frame_newslot(num5430);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5431 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5432 = callmethodflags(self, "parts", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5431);
// compiled member node returning call5432 (depth = 4)
  params[0] = block5420;
  params[1] = num5430;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5433 = callmethodflags(call5432, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5419);
// compiled call node returning call5433 (depth = 3)
  gc_frame_end(frame);
  return call5433;
}
Object meth_ast_5434_numTypeArgs(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "numTypeArgs");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1320
  setline(1320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5437 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5438 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5437);
// compiled member node returning call5438 (depth = 5)
  int op_slot_right_5436 = gc_frame_newslot(call5438);
// starting to compile identifier node (depth = 5)
  Object bool5440 = alloc_Boolean(0);
// compiled identifier node returning bool5440 (depth = 5)
  int op_slot_left_5436 = gc_frame_newslot(bool5440);
  params[0] = call5438;
  partcv[0] = 1;
  Object opresult5441 = callmethod(bool5440, "==(1)", 1, partcv, params);
// compiled op node returning opresult5441 (depth = 4)
  Object if5435 = done;
  if (istrue(opresult5441)) {
// starting to compile num node (depth = 4)
  Object num5442 = alloc_Float64(0);
// compiled num node returning num5442 (depth = 4)
    gc_frame_newslot(num5442);
    if5435 = num5442;
  } else {
// starting to compile member node (depth = 4)
  int callframe5443 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5444 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5445 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5444);
// compiled member node returning call5445 (depth = 5)
  partcv[0] = 0;
  Object call5446 = callmethodflags(call5445, "size", 1, partcv, params, 0);
  gc_frame_end(callframe5443);
// compiled member node returning call5446 (depth = 4)
    gc_frame_newslot(call5446);
    if5435 = call5446;
  }
// compiled if node returning if5435 (depth = 3)
  gc_frame_end(frame);
  return if5435;
}
Object meth_ast_5466__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1329
  setline(1329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5467 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_visitor (depth = 9)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newChain (depth = 9)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_arg (depth = 9)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5468 = callmethodflags(*var_arg, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5467);
// compiled call node returning call5468 (depth = 8)
  gc_frame_end(frame);
  return call5468;
}
Object meth_ast_5461__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1328
  setline(1328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5462 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe5463 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call5464 = callmethodflags(*var_part, "args", 1, partcv, params, 0);
  gc_frame_end(callframe5463);
// compiled member node returning call5464 (depth = 7)
  gc_frame_newslot(call5464);
// starting to compile block node (depth = 7)
  Object block5465 = alloc_Block(NULL, NULL, "ast", 1328);
  gc_frame_newslot(block5465);
// method "_apply(_)"
  block_savedest(block5465);
  Object closure5466 = createclosure(3, "_apply(1)");
  setclosureframe(closure5466, stackframe);
  addtoclosure(closure5466, var_visitor);
  addtoclosure(closure5466, var_newChain);
  addtoclosure(closure5466, selfslot);
  struct UserObject *uo5466 = (struct UserObject*)block5465;
  uo5466->data[0] = (Object)closure5466;
  Method *meth_meth_ast_5466__apply_40_1_41_ = addmethod2pos(block5465, "_apply(1)", &meth_ast_5466__apply_40_1_41_, 0);
  int argcv_meth_ast_5466__apply_40_1_41_[] = {1};
  meth_meth_ast_5466__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5466__apply_40_1_41_);
  meth_meth_ast_5466__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5466__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block5465 (depth = 7)
  gc_frame_newslot(block5465);
// call case 5: prelude request
  params[0] = call5464;
  params[1] = block5465;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5470 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5462);
// compiled call node returning call5470 (depth = 6)
  gc_frame_end(frame);
  return call5470;
}
Object meth_ast_5482__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1334
  setline(1334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5483 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5484 = callmethodflags(*var_each, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5483);
// compiled call node returning call5484 (depth = 7)
  gc_frame_end(frame);
  return call5484;
}
Object meth_ast_5447_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// definebindings:
// definebindings:
// definebindings:
// Begin line 1324
  setline(1324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5449 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5450 = callmethodflags(*var_visitor, "visitCall(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5449);
// compiled call node returning call5450 (depth = 4)
  Object if5448 = done;
  if (istrue(call5450)) {
// Begin line 1325
  setline(1325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5451 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call5452 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5451);
// compiled call node returning call5452 (depth = 5)
  *var_newChain = call5452;
  if (call5452 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1326
  setline(1326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5453 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5454 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5455 = callmethodflags(self, "receiver", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5454);
// compiled member node returning call5455 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5456 = callmethodflags(call5455, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5453);
// compiled call node returning call5456 (depth = 4)
// Begin line 1327
  setline(1327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5457 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5458 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5459 = callmethodflags(self, "parts", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5458);
// compiled member node returning call5459 (depth = 5)
  gc_frame_newslot(call5459);
// starting to compile block node (depth = 5)
  Object block5460 = alloc_Block(NULL, NULL, "ast", 1327);
  gc_frame_newslot(block5460);
// method "_apply(_)"
  block_savedest(block5460);
  Object closure5461 = createclosure(3, "_apply(1)");
  setclosureframe(closure5461, stackframe);
  addtoclosure(closure5461, var_visitor);
  addtoclosure(closure5461, var_newChain);
  addtoclosure(closure5461, selfslot);
  struct UserObject *uo5461 = (struct UserObject*)block5460;
  uo5461->data[0] = (Object)closure5461;
  Method *meth_meth_ast_5461__apply_40_1_41_ = addmethod2pos(block5460, "_apply(1)", &meth_ast_5461__apply_40_1_41_, 0);
  int argcv_meth_ast_5461__apply_40_1_41_[] = {1};
  meth_meth_ast_5461__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5461__apply_40_1_41_);
  meth_meth_ast_5461__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5461__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block5460 (depth = 5)
  gc_frame_newslot(block5460);
// call case 5: prelude request
  params[0] = call5459;
  params[1] = block5460;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5472 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5457);
// compiled call node returning call5472 (depth = 4)
// Begin line 1332
  setline(1332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5475 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5476 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5475);
// compiled member node returning call5476 (depth = 6)
  int op_slot_right_5474 = gc_frame_newslot(call5476);
// starting to compile identifier node (depth = 6)
  Object bool5478 = alloc_Boolean(0);
// compiled identifier node returning bool5478 (depth = 6)
  int op_slot_left_5474 = gc_frame_newslot(bool5478);
  params[0] = call5476;
  partcv[0] = 1;
  Object opresult5479 = callmethod(bool5478, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5479 (depth = 5)
  Object if5473 = done;
  if (istrue(opresult5479)) {
// Begin line 1333
  setline(1333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5480 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block5481 = alloc_Block(NULL, NULL, "ast", 1333);
  gc_frame_newslot(block5481);
// method "_apply(_)"
  block_savedest(block5481);
  Object closure5482 = createclosure(3, "_apply(1)");
  setclosureframe(closure5482, stackframe);
  addtoclosure(closure5482, var_visitor);
  addtoclosure(closure5482, var_newChain);
  addtoclosure(closure5482, selfslot);
  struct UserObject *uo5482 = (struct UserObject*)block5481;
  uo5482->data[0] = (Object)closure5482;
  Method *meth_meth_ast_5482__apply_40_1_41_ = addmethod2pos(block5481, "_apply(1)", &meth_ast_5482__apply_40_1_41_, 0);
  int argcv_meth_ast_5482__apply_40_1_41_[] = {1};
  meth_meth_ast_5482__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5482__apply_40_1_41_);
  meth_meth_ast_5482__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5482__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block5481 (depth = 6)
  gc_frame_newslot(block5481);
// call case 6: other requests
// Begin line 1333
  setline(1333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe5486 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5487 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5486);
// compiled member node returning call5487 (depth = 6)
  params[0] = block5481;
  partcv[0] = 1;
  Object call5488 = callmethodflags(call5487, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5480);
// compiled call node returning call5488 (depth = 5)
    gc_frame_newslot(call5488);
    if5473 = call5488;
  } else {
  }
// compiled if node returning if5473 (depth = 4)
    gc_frame_newslot(if5473);
    if5448 = if5473;
  } else {
  }
// compiled if node returning if5448 (depth = 3)
  gc_frame_end(frame);
  return if5448;
}
Object meth_ast_5489_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1340
  setline(1340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5490 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5491 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5490);
// compiled member node returning call5491 (depth = 4)
  *var_n = call5491;
  if (call5491 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1341
  setline(1341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5492 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5493 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5492);
// compiled call node returning call5493 (depth = 4)
  *var_newChain = call5493;
  if (call5493 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1342
  setline(1342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5494 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe5495 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5496 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5497 = callmethodflags(self, "receiver", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5496);
// compiled member node returning call5497 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5498 = callmethodflags(call5497, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5495);
// compiled call node returning call5498 (depth = 4)
  gc_frame_newslot(call5498);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call5498;
  partcv[0] = 1;
  Object call5499 = callmethodflags(*var_n, "receiver:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5494);
// compiled call node returning call5499 (depth = 3)
// Begin line 1343
  setline(1343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5500 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe5501 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5502 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5503 = callmethodflags(self, "parts", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5502);
// compiled member node returning call5503 (depth = 5)
  gc_frame_newslot(call5503);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call5503;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5504 = callmethodflags(module_ast, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5501);
// compiled call node returning call5504 (depth = 4)
  gc_frame_newslot(call5504);
// call case 6: other requests
// Begin line 1343
  setline(1343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call5504;
  partcv[0] = 1;
  Object call5505 = callmethodflags(*var_n, "parts:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5500);
// compiled call node returning call5505 (depth = 3)
// Begin line 1344
  setline(1344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5506 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe5507 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5508 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5509 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5508);
// compiled member node returning call5509 (depth = 5)
  gc_frame_newslot(call5509);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call5509;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5510 = callmethodflags(module_ast, "maybeListMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5507);
// compiled call node returning call5510 (depth = 4)
  gc_frame_newslot(call5510);
// call case 6: other requests
// Begin line 1344
  setline(1344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call5510;
  partcv[0] = 1;
  Object call5511 = callmethodflags(*var_n, "generics:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5506);
// compiled call node returning call5511 (depth = 3)
// Begin line 1345
  setline(1345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5512 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call5513 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5512);
// compiled call node returning call5513 (depth = 3)
  gc_frame_end(frame);
  return call5513;
}
Object meth_ast_5593__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1356
  setline(1356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5595 == NULL) {
    strlit5595 = alloc_String("""\x0a""");
    gc_root(strlit5595);
  }
// compiled string node returning strlit5595 (depth = 8)
  int op_slot_right_5594 = gc_frame_newslot(strlit5595);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5598 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num5600 = alloc_Float64(2);
// compiled num node returning num5600 (depth = 11)
  int op_slot_right_5599 = gc_frame_newslot(num5600);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_5599 = gc_frame_newslot(*var_depth);
  params[0] = num5600;
  partcv[0] = 1;
  Object sum5602 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5602 (depth = 10)
  gc_frame_newslot(sum5602);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_g (depth = 10)
  params[0] = sum5602;
  partcv[0] = 1;
  Object call5603 = callmethodflags(*var_g, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5598);
// compiled call node returning call5603 (depth = 9)
  int op_slot_right_5597 = gc_frame_newslot(call5603);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5606 == NULL) {
    strlit5606 = alloc_String("    ");
    gc_root(strlit5606);
  }
// compiled string node returning strlit5606 (depth = 10)
  int op_slot_right_5605 = gc_frame_newslot(strlit5606);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_5608 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_5608 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5610 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5610 (depth = 10)
  int op_slot_left_5605 = gc_frame_newslot(opresult5610);
  params[0] = strlit5606;
  partcv[0] = 1;
  Object opresult5611 = callmethod(opresult5610, "++(1)", 1, partcv, params);
// compiled op node returning opresult5611 (depth = 9)
  int op_slot_left_5597 = gc_frame_newslot(opresult5611);
  params[0] = call5603;
  partcv[0] = 1;
  Object opresult5612 = callmethod(opresult5611, "++(1)", 1, partcv, params);
// compiled op node returning opresult5612 (depth = 8)
  int op_slot_left_5594 = gc_frame_newslot(opresult5612);
  params[0] = strlit5595;
  partcv[0] = 1;
  Object opresult5613 = callmethod(opresult5612, "++(1)", 1, partcv, params);
// compiled op node returning opresult5613 (depth = 7)
  *var_s = opresult5613;
  if (opresult5613 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_5629__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1361
  setline(1361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5631 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5633 = alloc_Float64(2);
// compiled num node returning num5633 (depth = 9)
  int op_slot_right_5632 = gc_frame_newslot(num5633);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5632 = gc_frame_newslot(*var_depth);
  params[0] = num5633;
  partcv[0] = 1;
  Object sum5635 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5635 (depth = 8)
  gc_frame_newslot(sum5635);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  params[0] = sum5635;
  partcv[0] = 1;
  Object call5636 = callmethodflags(*var_part, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5631);
// compiled call node returning call5636 (depth = 7)
  int op_slot_right_5630 = gc_frame_newslot(call5636);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_5638 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5641 == NULL) {
    strlit5641 = alloc_String("""\x0a""  ");
    gc_root(strlit5641);
  }
// compiled string node returning strlit5641 (depth = 9)
  int op_slot_right_5640 = gc_frame_newslot(strlit5641);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5640 = gc_frame_newslot(*var_s);
  params[0] = strlit5641;
  partcv[0] = 1;
  Object opresult5643 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5643 (depth = 8)
  int op_slot_left_5638 = gc_frame_newslot(opresult5643);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5644 = callmethod(opresult5643, "++(1)", 1, partcv, params);
// compiled op node returning opresult5644 (depth = 7)
  int op_slot_left_5630 = gc_frame_newslot(opresult5644);
  params[0] = call5636;
  partcv[0] = 1;
  Object opresult5645 = callmethod(opresult5644, "++(1)", 1, partcv, params);
// compiled op node returning opresult5645 (depth = 6)
  *var_s = opresult5645;
  if (opresult5645 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_5514_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// definebindings:
// definebindings:
// Begin line 1348
  setline(1348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num5517 = alloc_Float64(1);
// compiled num node returning num5517 (depth = 6)
  int op_slot_right_5516 = gc_frame_newslot(num5517);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_5516 = gc_frame_newslot(*var_depth);
  params[0] = num5517;
  partcv[0] = 1;
  Object sum5519 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5519 (depth = 5)
  int op_slot_right_5515 = gc_frame_newslot(sum5519);
// starting to compile string node (depth = 5)
  if (strlit5521 == NULL) {
    strlit5521 = alloc_String("  ");
    gc_root(strlit5521);
  }
// compiled string node returning strlit5521 (depth = 5)
  int op_slot_left_5515 = gc_frame_newslot(strlit5521);
  params[0] = sum5519;
  partcv[0] = 1;
  Object prod5522 = callmethod(strlit5521, "*(1)", 1, partcv, params);
// compiled op node returning prod5522 (depth = 4)
  *var_spc = prod5522;
  if (prod5522 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1349
  setline(1349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5523 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call5524 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5523);
// compiled call node returning call5524 (depth = 4)
  *var_s = call5524;
  if (call5524 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1350
  setline(1350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5527 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5528 = callmethodflags(self, "isSelfRequest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5527);
// compiled member node returning call5528 (depth = 6)
  Object if5526 = done;
struct StackFrameObject *iftmpstackframe5526 = stackframe;
  if (istrue(call5528)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5526);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile string node (depth = 6)
  if (strlit5529 == NULL) {
    strlit5529 = alloc_String(" on self""\x0a""");
    gc_root(strlit5529);
  }
// compiled string node returning strlit5529 (depth = 6)
    gc_frame_newslot(strlit5529);
    if5526 = strlit5529;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe5526);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile string node (depth = 6)
  if (strlit5530 == NULL) {
    strlit5530 = alloc_String("""\x0a""");
    gc_root(strlit5530);
  }
// compiled string node returning strlit5530 (depth = 6)
    gc_frame_newslot(strlit5530);
    if5526 = strlit5530;
  }
stackframe = iftmpstackframe5526;
// compiled if node returning if5526 (depth = 5)
  int op_slot_right_5525 = gc_frame_newslot(if5526);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_5525 = gc_frame_newslot(*var_s);
  params[0] = if5526;
  partcv[0] = 1;
  Object opresult5532 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5532 (depth = 4)
  *var_s = opresult5532;
  if (opresult5532 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1351
  setline(1351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5536 == NULL) {
    strlit5536 = alloc_String("""\x0a""");
    gc_root(strlit5536);
  }
// compiled string node returning strlit5536 (depth = 6)
  int op_slot_right_5535 = gc_frame_newslot(strlit5536);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5539 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5541 = alloc_Float64(1);
// compiled num node returning num5541 (depth = 9)
  int op_slot_right_5540 = gc_frame_newslot(num5541);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5540 = gc_frame_newslot(*var_depth);
  params[0] = num5541;
  partcv[0] = 1;
  Object sum5543 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5543 (depth = 8)
  gc_frame_newslot(sum5543);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe5544 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5545 = callmethodflags(self, "receiver", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5544);
// compiled member node returning call5545 (depth = 8)
  params[0] = sum5543;
  partcv[0] = 1;
  Object call5546 = callmethodflags(call5545, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5539);
// compiled call node returning call5546 (depth = 7)
  int op_slot_right_5538 = gc_frame_newslot(call5546);
// starting to compile string node (depth = 7)
  if (strlit5548 == NULL) {
    strlit5548 = alloc_String("Receiver: ");
    gc_root(strlit5548);
  }
// compiled string node returning strlit5548 (depth = 7)
  int op_slot_left_5538 = gc_frame_newslot(strlit5548);
  params[0] = call5546;
  partcv[0] = 1;
  Object opresult5549 = callmethod(strlit5548, "++(1)", 1, partcv, params);
// compiled op node returning opresult5549 (depth = 6)
  int op_slot_left_5535 = gc_frame_newslot(opresult5549);
  params[0] = strlit5536;
  partcv[0] = 1;
  Object opresult5550 = callmethod(opresult5549, "++(1)", 1, partcv, params);
// compiled op node returning opresult5550 (depth = 5)
  int op_slot_right_5534 = gc_frame_newslot(opresult5550);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_5552 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_5552 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5554 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5554 (depth = 5)
  int op_slot_left_5534 = gc_frame_newslot(opresult5554);
  params[0] = opresult5550;
  partcv[0] = 1;
  Object opresult5555 = callmethod(opresult5554, "++(1)", 1, partcv, params);
// compiled op node returning opresult5555 (depth = 4)
  *var_s = opresult5555;
  if (opresult5555 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1352
  setline(1352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5559 == NULL) {
    strlit5559 = alloc_String("""\x0a""");
    gc_root(strlit5559);
  }
// compiled string node returning strlit5559 (depth = 6)
  int op_slot_right_5558 = gc_frame_newslot(strlit5559);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5562 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5563 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5562);
// compiled member node returning call5563 (depth = 7)
  int op_slot_right_5561 = gc_frame_newslot(call5563);
// starting to compile string node (depth = 7)
  if (strlit5565 == NULL) {
    strlit5565 = alloc_String("Method Name: ");
    gc_root(strlit5565);
  }
// compiled string node returning strlit5565 (depth = 7)
  int op_slot_left_5561 = gc_frame_newslot(strlit5565);
  params[0] = call5563;
  partcv[0] = 1;
  Object opresult5566 = callmethod(strlit5565, "++(1)", 1, partcv, params);
// compiled op node returning opresult5566 (depth = 6)
  int op_slot_left_5558 = gc_frame_newslot(opresult5566);
  params[0] = strlit5559;
  partcv[0] = 1;
  Object opresult5567 = callmethod(opresult5566, "++(1)", 1, partcv, params);
// compiled op node returning opresult5567 (depth = 5)
  int op_slot_right_5557 = gc_frame_newslot(opresult5567);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_5569 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_5569 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5571 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5571 (depth = 5)
  int op_slot_left_5557 = gc_frame_newslot(opresult5571);
  params[0] = opresult5567;
  partcv[0] = 1;
  Object opresult5572 = callmethod(opresult5571, "++(1)", 1, partcv, params);
// compiled op node returning opresult5572 (depth = 4)
  *var_s = opresult5572;
  if (opresult5572 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1353
  setline(1353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5576 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5577 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5576);
// compiled member node returning call5577 (depth = 5)
  int op_slot_right_5575 = gc_frame_newslot(call5577);
// starting to compile identifier node (depth = 5)
  Object bool5579 = alloc_Boolean(0);
// compiled identifier node returning bool5579 (depth = 5)
  int op_slot_left_5575 = gc_frame_newslot(bool5579);
  params[0] = call5577;
  partcv[0] = 1;
  Object opresult5580 = callmethod(bool5579, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5580 (depth = 4)
  Object if5574 = done;
  if (istrue(opresult5580)) {
// Begin line 1354
  setline(1354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5582 == NULL) {
    strlit5582 = alloc_String("  Generics:""\x0a""");
    gc_root(strlit5582);
  }
// compiled string node returning strlit5582 (depth = 6)
  int op_slot_right_5581 = gc_frame_newslot(strlit5582);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_5584 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5584 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5586 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5586 (depth = 6)
  int op_slot_left_5581 = gc_frame_newslot(opresult5586);
  params[0] = strlit5582;
  partcv[0] = 1;
  Object opresult5587 = callmethod(opresult5586, "++(1)", 1, partcv, params);
// compiled op node returning opresult5587 (depth = 5)
  *var_s = opresult5587;
  if (opresult5587 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5589 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5590 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5591 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5590);
// compiled member node returning call5591 (depth = 5)
  gc_frame_newslot(call5591);
// starting to compile block node (depth = 5)
  Object block5592 = alloc_Block(NULL, NULL, "ast", 1355);
  gc_frame_newslot(block5592);
// method "_apply(_)"
  block_savedest(block5592);
  Object closure5593 = createclosure(4, "_apply(1)");
  setclosureframe(closure5593, stackframe);
  addtoclosure(closure5593, var_depth);
  addtoclosure(closure5593, var_spc);
  addtoclosure(closure5593, var_s);
  addtoclosure(closure5593, selfslot);
  struct UserObject *uo5593 = (struct UserObject*)block5592;
  uo5593->data[0] = (Object)closure5593;
  Method *meth_meth_ast_5593__apply_40_1_41_ = addmethod2pos(block5592, "_apply(1)", &meth_ast_5593__apply_40_1_41_, 0);
  int argcv_meth_ast_5593__apply_40_1_41_[] = {1};
  meth_meth_ast_5593__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5593__apply_40_1_41_);
  meth_meth_ast_5593__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5593__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block5592 (depth = 5)
  gc_frame_newslot(block5592);
// call case 5: prelude request
  params[0] = call5591;
  params[1] = block5592;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5616 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5589);
// compiled call node returning call5616 (depth = 4)
    gc_frame_newslot(call5616);
    if5574 = call5616;
  } else {
  }
// compiled if node returning if5574 (depth = 3)
// Begin line 1359
  setline(1359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5618 == NULL) {
    strlit5618 = alloc_String("Parts:");
    gc_root(strlit5618);
  }
// compiled string node returning strlit5618 (depth = 5)
  int op_slot_right_5617 = gc_frame_newslot(strlit5618);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_5620 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_5620 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5622 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5622 (depth = 5)
  int op_slot_left_5617 = gc_frame_newslot(opresult5622);
  params[0] = strlit5618;
  partcv[0] = 1;
  Object opresult5623 = callmethod(opresult5622, "++(1)", 1, partcv, params);
// compiled op node returning opresult5623 (depth = 4)
  *var_s = opresult5623;
  if (opresult5623 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1360
  setline(1360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5625 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5626 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5627 = callmethodflags(self, "parts", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5626);
// compiled member node returning call5627 (depth = 4)
  gc_frame_newslot(call5627);
// starting to compile block node (depth = 4)
  Object block5628 = alloc_Block(NULL, NULL, "ast", 1360);
  gc_frame_newslot(block5628);
// method "_apply(_)"
  block_savedest(block5628);
  Object closure5629 = createclosure(4, "_apply(1)");
  setclosureframe(closure5629, stackframe);
  addtoclosure(closure5629, var_depth);
  addtoclosure(closure5629, var_spc);
  addtoclosure(closure5629, var_s);
  addtoclosure(closure5629, selfslot);
  struct UserObject *uo5629 = (struct UserObject*)block5628;
  uo5629->data[0] = (Object)closure5629;
  Method *meth_meth_ast_5629__apply_40_1_41_ = addmethod2pos(block5628, "_apply(1)", &meth_ast_5629__apply_40_1_41_, 0);
  int argcv_meth_ast_5629__apply_40_1_41_[] = {1};
  meth_meth_ast_5629__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5629__apply_40_1_41_);
  meth_meth_ast_5629__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5629__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block5628 (depth = 4)
  gc_frame_newslot(block5628);
// call case 5: prelude request
  params[0] = call5627;
  params[1] = block5628;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5648 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5625);
// compiled call node returning call5648 (depth = 3)
// Begin line 1363
  setline(1363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_5731__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5733 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5735 = alloc_Float64(1);
// compiled num node returning num5735 (depth = 9)
  int op_slot_right_5734 = gc_frame_newslot(num5735);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5734 = gc_frame_newslot(*var_depth);
  params[0] = num5735;
  partcv[0] = 1;
  Object sum5737 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5737 (depth = 8)
  gc_frame_newslot(sum5737);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  params[0] = sum5737;
  partcv[0] = 1;
  Object call5738 = callmethodflags(*var_part, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5733);
// compiled call node returning call5738 (depth = 7)
  int op_slot_right_5732 = gc_frame_newslot(call5738);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5732 = gc_frame_newslot(*var_s);
  params[0] = call5738;
  partcv[0] = 1;
  Object opresult5740 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5740 (depth = 6)
  *var_s = opresult5740;
  if (opresult5740 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_5744__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5746 == NULL) {
    strlit5746 = alloc_String(" ");
    gc_root(strlit5746);
  }
// compiled string node returning strlit5746 (depth = 7)
  int op_slot_right_5745 = gc_frame_newslot(strlit5746);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5745 = gc_frame_newslot(*var_s);
  params[0] = strlit5746;
  partcv[0] = 1;
  Object opresult5748 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5748 (depth = 6)
  *var_s = opresult5748;
  if (opresult5748 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_5649_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_opSymbol = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "opSymbol");
// definebindings:
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1366
  setline(1366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5651 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5652 = callmethodflags(self, "isRequestOfPrefixOperator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5651);
// compiled member node returning call5652 (depth = 4)
  Object if5650 = done;
  if (istrue(call5652)) {
// Begin line 1367
  setline(1367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5653 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num5654 = alloc_Float64(7);
// compiled num node returning num5654 (depth = 6)
  gc_frame_newslot(num5654);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5655 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5656 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe5657 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5658 = callmethodflags(self, "parts", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5657);
// compiled member node returning call5658 (depth = 8)
  partcv[0] = 0;
  Object call5659 = callmethodflags(call5658, "first", 1, partcv, params, 0);
  gc_frame_end(callframe5656);
// compiled member node returning call5659 (depth = 7)
  partcv[0] = 0;
  Object call5660 = callmethodflags(call5659, "name", 1, partcv, params, 0);
  gc_frame_end(callframe5655);
// compiled member node returning call5660 (depth = 6)
  params[0] = num5654;
  partcv[0] = 1;
  Object call5661 = callmethodflags(call5660, "substringFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5653);
// compiled call node returning call5661 (depth = 5)
  *var_opSymbol = call5661;
  if (call5661 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1368
  setline(1368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5663 == NULL) {
    strlit5663 = alloc_String("");
    gc_root(strlit5663);
  }
// compiled string node returning strlit5663 (depth = 6)
  int op_slot_right_5662 = gc_frame_newslot(strlit5663);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5666 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num5667 = alloc_Float64(0);
// compiled num node returning num5667 (depth = 8)
  gc_frame_newslot(num5667);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe5668 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5669 = callmethodflags(self, "receiver", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5668);
// compiled member node returning call5669 (depth = 8)
  params[0] = num5667;
  partcv[0] = 1;
  Object call5670 = callmethodflags(call5669, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5666);
// compiled call node returning call5670 (depth = 7)
  int op_slot_right_5665 = gc_frame_newslot(call5670);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5673 == NULL) {
    strlit5673 = alloc_String(" ");
    gc_root(strlit5673);
  }
// compiled string node returning strlit5673 (depth = 8)
  int op_slot_right_5672 = gc_frame_newslot(strlit5673);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_opSymbol (depth = 9)
  int op_slot_right_5675 = gc_frame_newslot(*var_opSymbol);
// starting to compile string node (depth = 9)
  if (strlit5677 == NULL) {
    strlit5677 = alloc_String("");
    gc_root(strlit5677);
  }
// compiled string node returning strlit5677 (depth = 9)
  int op_slot_left_5675 = gc_frame_newslot(strlit5677);
  params[0] = *var_opSymbol;
  partcv[0] = 1;
  Object opresult5678 = callmethod(strlit5677, "++(1)", 1, partcv, params);
// compiled op node returning opresult5678 (depth = 8)
  int op_slot_left_5672 = gc_frame_newslot(opresult5678);
  params[0] = strlit5673;
  partcv[0] = 1;
  Object opresult5679 = callmethod(opresult5678, "++(1)", 1, partcv, params);
// compiled op node returning opresult5679 (depth = 7)
  int op_slot_left_5665 = gc_frame_newslot(opresult5679);
  params[0] = call5670;
  partcv[0] = 1;
  Object opresult5680 = callmethod(opresult5679, "++(1)", 1, partcv, params);
// compiled op node returning opresult5680 (depth = 6)
  int op_slot_left_5662 = gc_frame_newslot(opresult5680);
  params[0] = strlit5663;
  partcv[0] = 1;
  Object opresult5681 = callmethod(opresult5680, "++(1)", 1, partcv, params);
// compiled op node returning opresult5681 (depth = 5)
  return opresult5681;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if5650 = undefined;
  } else {
  }
// compiled if node returning if5650 (depth = 3)
// Begin line 1370
  setline(1370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5682 == NULL) {
    strlit5682 = alloc_String("");
    gc_root(strlit5682);
  }
// compiled string node returning strlit5682 (depth = 4)
  *var_s = strlit5682;
  if (strlit5682 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1371
  setline(1371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5684 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5685 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5686 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5687 = callmethodflags(self, "receiver", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5686);
// compiled member node returning call5687 (depth = 6)
  partcv[0] = 0;
  Object call5688 = callmethodflags(call5687, "isImplicit", 1, partcv, params, 0);
  gc_frame_end(callframe5685);
// compiled member node returning call5688 (depth = 5)
  partcv[0] = 0;
  Object call5689 = callmethodflags(call5688, "not", 1, partcv, params, 0);
  gc_frame_end(callframe5684);
// compiled member node returning call5689 (depth = 4)
  Object if5683 = done;
  if (istrue(call5689)) {
// Begin line 1372
  setline(1372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5691 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5692 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5693 = callmethodflags(self, "receiver", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5692);
// compiled member node returning call5693 (depth = 6)
  partcv[0] = 0;
  Object call5694 = callmethodflags(call5693, "isSimple", 1, partcv, params, 0);
  gc_frame_end(callframe5691);
// compiled member node returning call5694 (depth = 5)
  Object if5690 = done;
  if (istrue(call5694)) {
// Begin line 1373
  setline(1373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5696 == NULL) {
    strlit5696 = alloc_String(".");
    gc_root(strlit5696);
  }
// compiled string node returning strlit5696 (depth = 7)
  int op_slot_right_5695 = gc_frame_newslot(strlit5696);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5699 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num5701 = alloc_Float64(1);
// compiled num node returning num5701 (depth = 10)
  int op_slot_right_5700 = gc_frame_newslot(num5701);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_5700 = gc_frame_newslot(*var_depth);
  params[0] = num5701;
  partcv[0] = 1;
  Object sum5703 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5703 (depth = 9)
  gc_frame_newslot(sum5703);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe5704 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5705 = callmethodflags(self, "receiver", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5704);
// compiled member node returning call5705 (depth = 9)
  params[0] = sum5703;
  partcv[0] = 1;
  Object call5706 = callmethodflags(call5705, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5699);
// compiled call node returning call5706 (depth = 8)
  int op_slot_right_5698 = gc_frame_newslot(call5706);
// starting to compile string node (depth = 8)
  if (strlit5708 == NULL) {
    strlit5708 = alloc_String("");
    gc_root(strlit5708);
  }
// compiled string node returning strlit5708 (depth = 8)
  int op_slot_left_5698 = gc_frame_newslot(strlit5708);
  params[0] = call5706;
  partcv[0] = 1;
  Object opresult5709 = callmethod(strlit5708, "++(1)", 1, partcv, params);
// compiled op node returning opresult5709 (depth = 7)
  int op_slot_left_5695 = gc_frame_newslot(opresult5709);
  params[0] = strlit5696;
  partcv[0] = 1;
  Object opresult5710 = callmethod(opresult5709, "++(1)", 1, partcv, params);
// compiled op node returning opresult5710 (depth = 6)
  *var_s = opresult5710;
  if (opresult5710 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if5690 = done;
  } else {
// Begin line 1375
  setline(1375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5713 == NULL) {
    strlit5713 = alloc_String(").");
    gc_root(strlit5713);
  }
// compiled string node returning strlit5713 (depth = 7)
  int op_slot_right_5712 = gc_frame_newslot(strlit5713);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5716 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num5718 = alloc_Float64(1);
// compiled num node returning num5718 (depth = 10)
  int op_slot_right_5717 = gc_frame_newslot(num5718);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_5717 = gc_frame_newslot(*var_depth);
  params[0] = num5718;
  partcv[0] = 1;
  Object sum5720 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5720 (depth = 9)
  gc_frame_newslot(sum5720);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe5721 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5722 = callmethodflags(self, "receiver", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5721);
// compiled member node returning call5722 (depth = 9)
  params[0] = sum5720;
  partcv[0] = 1;
  Object call5723 = callmethodflags(call5722, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5716);
// compiled call node returning call5723 (depth = 8)
  int op_slot_right_5715 = gc_frame_newslot(call5723);
// starting to compile string node (depth = 8)
  if (strlit5725 == NULL) {
    strlit5725 = alloc_String("(");
    gc_root(strlit5725);
  }
// compiled string node returning strlit5725 (depth = 8)
  int op_slot_left_5715 = gc_frame_newslot(strlit5725);
  params[0] = call5723;
  partcv[0] = 1;
  Object opresult5726 = callmethod(strlit5725, "++(1)", 1, partcv, params);
// compiled op node returning opresult5726 (depth = 7)
  int op_slot_left_5712 = gc_frame_newslot(opresult5726);
  params[0] = strlit5713;
  partcv[0] = 1;
  Object opresult5727 = callmethod(opresult5726, "++(1)", 1, partcv, params);
// compiled op node returning opresult5727 (depth = 6)
  *var_s = opresult5727;
  if (opresult5727 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if5690 = done;
  }
// compiled if node returning if5690 (depth = 4)
    gc_frame_newslot(if5690);
    if5683 = if5690;
  } else {
  }
// compiled if node returning if5683 (depth = 3)
// Begin line 1378
  setline(1378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5729 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5730 = alloc_Block(NULL, NULL, "ast", 1378);
  gc_frame_newslot(block5730);
// method "_apply(_)"
  block_savedest(block5730);
  Object closure5731 = createclosure(3, "_apply(1)");
  setclosureframe(closure5731, stackframe);
  addtoclosure(closure5731, var_depth);
  addtoclosure(closure5731, var_s);
  addtoclosure(closure5731, selfslot);
  struct UserObject *uo5731 = (struct UserObject*)block5730;
  uo5731->data[0] = (Object)closure5731;
  Method *meth_meth_ast_5731__apply_40_1_41_ = addmethod2pos(block5730, "_apply(1)", &meth_ast_5731__apply_40_1_41_, 0);
  int argcv_meth_ast_5731__apply_40_1_41_[] = {1};
  meth_meth_ast_5731__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5731__apply_40_1_41_);
  meth_meth_ast_5731__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5731__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block5730 (depth = 4)
  gc_frame_newslot(block5730);
// Begin line 1379
  setline(1379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block5743 = alloc_Block(NULL, NULL, "ast", 1379);
  gc_frame_newslot(block5743);
// method "_apply"
  block_savedest(block5743);
  Object closure5744 = createclosure(2, "_apply");
  setclosureframe(closure5744, stackframe);
  addtoclosure(closure5744, var_s);
  addtoclosure(closure5744, selfslot);
  struct UserObject *uo5744 = (struct UserObject*)block5743;
  uo5744->data[0] = (Object)closure5744;
  Method *meth_meth_ast_5744__apply = addmethod2pos(block5743, "_apply", &meth_ast_5744__apply, 0);
  int argcv_meth_ast_5744__apply[] = {0};
  meth_meth_ast_5744__apply->type = alloc_MethodType(1, argcv_meth_ast_5744__apply);
  meth_meth_ast_5744__apply->definitionModule = modulename;
  meth_meth_ast_5744__apply->definitionLine = 3050;
// compiled block node returning block5743 (depth = 4)
  gc_frame_newslot(block5743);
// call case 6: other requests
// Begin line 1378
  setline(1378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5751 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5752 = callmethodflags(self, "parts", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5751);
// compiled member node returning call5752 (depth = 4)
  params[0] = block5730;
  params[1] = block5743;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5753 = callmethodflags(call5752, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5729);
// compiled call node returning call5753 (depth = 3)
// Begin line 1380
  setline(1380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_5754_asIdentifier(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[2];
  Object *var_uninitialized = getfromclosure(closure, 0);
  Object *var_fakeSymbolTable = getfromclosure(closure, 1);
  Object *var_identifierNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1385
  setline(1385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5757 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5758 = callmethodflags(self, "cachedIdentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5757);
// compiled member node returning call5758 (depth = 5)
  int op_slot_right_5756 = gc_frame_newslot(call5758);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_uninitialized (depth = 5)
  int op_slot_left_5756 = gc_frame_newslot(*var_uninitialized);
  params[0] = call5758;
  partcv[0] = 1;
  Object opresult5760 = callmethod(*var_uninitialized, "==(1)", 1, partcv, params);
// compiled op node returning opresult5760 (depth = 4)
  Object if5755 = done;
  if (istrue(opresult5760)) {
// Begin line 1386
  setline(1386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5763 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5764 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5763);
// compiled member node returning call5764 (depth = 6)
  int op_slot_right_5762 = gc_frame_newslot(call5764);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_fakeSymbolTable (depth = 6)
  int op_slot_left_5762 = gc_frame_newslot(*var_fakeSymbolTable);
  params[0] = call5764;
  partcv[0] = 1;
  Object opresult5766 = callmethod(*var_fakeSymbolTable, "==(1)", 1, partcv, params);
// compiled op node returning opresult5766 (depth = 5)
  Object if5761 = done;
  if (istrue(opresult5766)) {
// Begin line 1387
  setline(1387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5767 = gc_frame_new();
// Begin line 1388
  setline(1388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5769 == NULL) {
    strlit5769 = alloc_String(" when scope was fake");
    gc_root(strlit5769);
  }
// compiled string node returning strlit5769 (depth = 7)
  int op_slot_right_5768 = gc_frame_newslot(strlit5769);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5772 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num5773 = alloc_Float64(0);
// compiled num node returning num5773 (depth = 9)
  gc_frame_newslot(num5773);
// call case 4: self request
  params[0] = num5773;
  partcv[0] = 1;
  Object call5774 = callmethodflags(self, "pretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5772);
// compiled call node returning call5774 (depth = 8)
  int op_slot_right_5771 = gc_frame_newslot(call5774);
// starting to compile string node (depth = 8)
  if (strlit5776 == NULL) {
    strlit5776 = alloc_String("asIdentifier requested on ");
    gc_root(strlit5776);
  }
// compiled string node returning strlit5776 (depth = 8)
  int op_slot_left_5771 = gc_frame_newslot(strlit5776);
  params[0] = call5774;
  partcv[0] = 1;
  Object opresult5777 = callmethod(strlit5776, "++(1)", 1, partcv, params);
// compiled op node returning opresult5777 (depth = 7)
  int op_slot_left_5768 = gc_frame_newslot(opresult5777);
  params[0] = strlit5769;
  partcv[0] = 1;
  Object opresult5778 = callmethod(opresult5777, "++(1)", 1, partcv, params);
// compiled op node returning opresult5778 (depth = 6)
  gc_frame_newslot(opresult5778);
// call case 6: other requests
// Begin line 1387
  setline(1387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe5779 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5780 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5779);
// compiled member node returning call5780 (depth = 6)
  params[0] = opresult5778;
  partcv[0] = 1;
  Object call5781 = callmethodflags(call5780, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5767);
// compiled call node returning call5781 (depth = 5)
    gc_frame_newslot(call5781);
    if5761 = call5781;
  } else {
  }
// compiled if node returning if5761 (depth = 4)
// Begin line 1390
  setline(1390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5782 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5783 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe5784 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5785 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5784);
// compiled member node returning call5785 (depth = 6)
  gc_frame_newslot(call5785);
// starting to compile identifier node (depth = 6)
  Object bool5786 = alloc_Boolean(0);
// compiled identifier node returning bool5786 (depth = 6)
  gc_frame_newslot(bool5786);
// starting to compile member node (depth = 6)
  int callframe5787 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5788 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5787);
// compiled member node returning call5788 (depth = 6)
  gc_frame_newslot(call5788);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_identifierNode (depth = 6)
  params[0] = call5785;
  params[1] = bool5786;
  params[2] = call5788;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5789 = callmethodflags(*var_identifierNode, "new(2)scope(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5783);
// compiled call node returning call5789 (depth = 5)
  gc_frame_newslot(call5789);
// call case 4: self request
  params[0] = call5789;
  partcv[0] = 1;
  Object call5790 = callmethodflags(self, "cachedIdentifier:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5782);
// compiled call node returning call5790 (depth = 4)
// Begin line 1391
  setline(1391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5791 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool5792 = alloc_Boolean(1);
// compiled identifier node returning bool5792 (depth = 5)
  gc_frame_newslot(bool5792);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5793 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5794 = callmethodflags(self, "cachedIdentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5793);
// compiled member node returning call5794 (depth = 5)
  params[0] = bool5792;
  partcv[0] = 1;
  Object call5795 = callmethodflags(call5794, "inRequest:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5791);
// compiled call node returning call5795 (depth = 4)
// Begin line 1392
  setline(1392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5796 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5797 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5798 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5799 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5800 = callmethodflags(self, "parts", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5799);
// compiled member node returning call5800 (depth = 7)
  partcv[0] = 0;
  Object call5801 = callmethodflags(call5800, "first", 1, partcv, params, 0);
  gc_frame_end(callframe5798);
// compiled member node returning call5801 (depth = 6)
  partcv[0] = 0;
  Object call5802 = callmethodflags(call5801, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5797);
// compiled member node returning call5802 (depth = 5)
  gc_frame_newslot(call5802);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5803 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5804 = callmethodflags(self, "cachedIdentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5803);
// compiled member node returning call5804 (depth = 5)
  params[0] = call5802;
  partcv[0] = 1;
  Object call5805 = callmethodflags(call5804, "line:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5796);
// compiled call node returning call5805 (depth = 4)
// Begin line 1393
  setline(1393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5806 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5807 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5808 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5809 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5810 = callmethodflags(self, "parts", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5809);
// compiled member node returning call5810 (depth = 7)
  partcv[0] = 0;
  Object call5811 = callmethodflags(call5810, "first", 1, partcv, params, 0);
  gc_frame_end(callframe5808);
// compiled member node returning call5811 (depth = 6)
  partcv[0] = 0;
  Object call5812 = callmethodflags(call5811, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe5807);
// compiled member node returning call5812 (depth = 5)
  gc_frame_newslot(call5812);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5813 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5814 = callmethodflags(self, "cachedIdentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5813);
// compiled member node returning call5814 (depth = 5)
  params[0] = call5812;
  partcv[0] = 1;
  Object call5815 = callmethodflags(call5814, "linePos:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5806);
// compiled call node returning call5815 (depth = 4)
    gc_frame_newslot(call5815);
    if5755 = call5815;
  } else {
  }
// compiled if node returning if5755 (depth = 3)
// Begin line 1395
  setline(1395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5816 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5817 = callmethodflags(self, "cachedIdentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5816);
// compiled member node returning call5817 (depth = 3)
  gc_frame_end(frame);
  return call5817;
}
Object meth_ast_5818_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1397
  setline(1397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5820 == NULL) {
    strlit5820 = alloc_String("");
    gc_root(strlit5820);
  }
// compiled string node returning strlit5820 (depth = 4)
  int op_slot_right_5819 = gc_frame_newslot(strlit5820);
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5823 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num5824 = alloc_Float64(0);
// compiled num node returning num5824 (depth = 6)
  gc_frame_newslot(num5824);
// call case 4: self request
  params[0] = num5824;
  partcv[0] = 1;
  Object call5825 = callmethodflags(self, "toGrace(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5823);
// compiled call node returning call5825 (depth = 5)
  int op_slot_right_5822 = gc_frame_newslot(call5825);
// starting to compile string node (depth = 5)
  if (strlit5827 == NULL) {
    strlit5827 = alloc_String("call ");
    gc_root(strlit5827);
  }
// compiled string node returning strlit5827 (depth = 5)
  int op_slot_left_5822 = gc_frame_newslot(strlit5827);
  params[0] = call5825;
  partcv[0] = 1;
  Object opresult5828 = callmethod(strlit5827, "++(1)", 1, partcv, params);
// compiled op node returning opresult5828 (depth = 4)
  int op_slot_left_5819 = gc_frame_newslot(opresult5828);
  params[0] = strlit5820;
  partcv[0] = 1;
  Object opresult5829 = callmethod(opresult5828, "++(1)", 1, partcv, params);
// compiled op node returning opresult5829 (depth = 3)
  gc_frame_end(frame);
  return opresult5829;
}
Object meth_ast_5830_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_callNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1399
  setline(1399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5831 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe5832 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5833 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5834 = callmethodflags(self, "receiver", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5833);
// compiled member node returning call5834 (depth = 5)
  gc_frame_newslot(call5834);
// starting to compile member node (depth = 5)
  int callframe5835 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5836 = callmethodflags(self, "parts", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5835);
// compiled member node returning call5836 (depth = 5)
  gc_frame_newslot(call5836);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_callNode (depth = 5)
  params[0] = call5834;
  params[1] = call5836;
  partcv[0] = 2;
  Object call5837 = callmethodflags(*var_callNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5832);
// compiled call node returning call5837 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5838 = callmethodflags(call5837, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5831);
// compiled call node returning call5838 (depth = 3)
  gc_frame_end(frame);
  return call5838;
}
Object meth_ast_5839_postCopy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "postCopy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method postCopy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for postCopy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part postCopy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1402
  setline(1402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5840 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5841 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call5842 = callmethodflags(*var_other, "isPattern", 1, partcv, params, 0);
  gc_frame_end(callframe5841);
// compiled member node returning call5842 (depth = 4)
  gc_frame_newslot(call5842);
// call case 4: self request
  params[0] = call5842;
  partcv[0] = 1;
  Object call5843 = callmethodflags(self, "isPattern:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5840);
// compiled call node returning call5843 (depth = 3)
// Begin line 1403
  setline(1403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5844 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5845 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call5846 = callmethodflags(*var_other, "isSelfRequest", 1, partcv, params, 0);
  gc_frame_end(callframe5845);
// compiled member node returning call5846 (depth = 4)
  gc_frame_newslot(call5846);
// call case 4: self request
  params[0] = call5846;
  partcv[0] = 1;
  Object call5847 = callmethodflags(self, "isSelfRequest:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5844);
// compiled call node returning call5847 (depth = 3)
// Begin line 1404
  setline(1404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5848 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5849 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call5850 = callmethodflags(*var_other, "isTailCall", 1, partcv, params, 0);
  gc_frame_end(callframe5849);
// compiled member node returning call5850 (depth = 4)
  gc_frame_newslot(call5850);
// call case 4: self request
  params[0] = call5850;
  partcv[0] = 1;
  Object call5851 = callmethodflags(self, "isTailCall:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5848);
// compiled call node returning call5851 (depth = 3)
// Begin line 1405
  setline(1405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5852 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5853 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call5854 = callmethodflags(*var_other, "isFresh", 1, partcv, params, 0);
  gc_frame_end(callframe5853);
// compiled member node returning call5854 (depth = 4)
  gc_frame_newslot(call5854);
// call case 4: self request
  params[0] = call5854;
  partcv[0] = 1;
  Object call5855 = callmethodflags(self, "isFresh:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5852);
// compiled call node returning call5855 (depth = 3)
// Begin line 1406
  setline(1406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5856 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5857 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call5858 = callmethodflags(*var_other, "endPos", 1, partcv, params, 0);
  gc_frame_end(callframe5857);
// compiled member node returning call5858 (depth = 4)
  gc_frame_newslot(call5858);
// call case 4: self request
  params[0] = call5858;
  partcv[0] = 1;
  Object call5859 = callmethodflags(self, "endPos:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5856);
// compiled call node returning call5859 (depth = 3)
// Begin line 1407
  setline(1407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_5860_statementName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1409
  setline(1409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5861 == NULL) {
    strlit5861 = alloc_String("request");
    gc_root(strlit5861);
  }
// compiled string node returning strlit5861 (depth = 3)
  gc_frame_end(frame);
  return strlit5861;
}
Object meth_ast_5193_new_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_noPosition = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_uninitialized = getfromclosure(closure, 2);
  Object *var_fakeSymbolTable = getfromclosure(closure, 3);
  Object *var_identifierNode = getfromclosure(closure, 4);
  Object *var_callNode = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_receiver_39_ = &(stackframe->slots[0]);
  *var_receiver_39_ = args[curarg];
  curarg++;
  Object *var_parts_39_ = &(stackframe->slots[1]);
  *var_parts_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5194 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5194 = alloc_userobj2(43,35, objclass5194);
  gc_frame_newslot(obj5194);
  if (objclass5194 == NULL) {
    glfree(obj5194->class->name);
    obj5194->class->name = "callNode.new(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj5194, self, 0);
  addmethodreal(obj5194,"outer", &reader_ast_outer_5195);
  Object oldself5194 = self;
  struct StackFrameObject *oldstackframe5194 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5194);
  gc_frame_newslot((Object)stackframe);
  self = obj5194;
  Object *oldselfslot5194 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5194 = (*(struct UserObject *)self).data[0], lowerouter5194 = thisouter5194;
  if (inheritingObject5194) {
    struct UserObject *inho5194 = (struct UserObject *)inheritingObject5194;
    while (inho5194->super != GraceDefaultObject) inho5194 = (struct UserObject *)inho5194->super;
    inho5194->super = obj5194;
    self = inheritingObject5194;
    *selfslot = self;
    lowerouter5194 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5194;
  }
  if (objclass5194 == NULL) {
  Method *reader5196 = addmethodrealflags(obj5194, "kind",&reader_ast_kind_5196, MFLAG_DEF);
  reader5196->definitionModule = modulename;
  reader5196->definitionLine = 1238;
  }
  adddatum2(obj5194, alloc_Undefined(), 1);
  if (objclass5194 == NULL) {
    Method *reader5197 = addmethodrealflags(obj5194, "parts", &reader_ast_parts_5197, 0);
    Method *writer5197 = addmethodrealflags(obj5194, "parts:=(1)", &writer_ast_parts_5197, 0);
    reader5197->definitionModule = modulename;
    writer5197->definitionModule = modulename;
    reader5197->definitionLine = 1239;
    writer5197->definitionLine = 1239;
  }
  obj5194->flags |= OFLAG_MUTABLE;
  adddatum2(obj5194, alloc_Undefined(), 2);
  if (objclass5194 == NULL) {
    Method *reader5198 = addmethodrealflags(obj5194, "generics", &reader_ast_generics_5198, 0);
    Method *writer5198 = addmethodrealflags(obj5194, "generics:=(1)", &writer_ast_generics_5198, 0);
    reader5198->definitionModule = modulename;
    writer5198->definitionModule = modulename;
    reader5198->definitionLine = 1240;
    writer5198->definitionLine = 1240;
  }
  obj5194->flags |= OFLAG_MUTABLE;
  adddatum2(obj5194, alloc_Undefined(), 3);
  if (objclass5194 == NULL) {
    Method *reader5199 = addmethodrealflags(obj5194, "isPattern", &reader_ast_isPattern_5199, 0);
    Method *writer5199 = addmethodrealflags(obj5194, "isPattern:=(1)", &writer_ast_isPattern_5199, 0);
    reader5199->definitionModule = modulename;
    writer5199->definitionModule = modulename;
    reader5199->definitionLine = 1241;
    writer5199->definitionLine = 1241;
  }
  obj5194->flags |= OFLAG_MUTABLE;
  adddatum2(obj5194, alloc_Undefined(), 4);
  if (objclass5194 == NULL) {
    Method *reader5200 = addmethodrealflags(obj5194, "receiver", &reader_ast_receiver_5200, 0);
    Method *writer5200 = addmethodrealflags(obj5194, "receiver:=(1)", &writer_ast_receiver_5200, 0);
    reader5200->definitionModule = modulename;
    writer5200->definitionModule = modulename;
    reader5200->definitionLine = 1242;
    writer5200->definitionLine = 1242;
  }
  obj5194->flags |= OFLAG_MUTABLE;
  adddatum2(obj5194, alloc_Undefined(), 5);
  if (objclass5194 == NULL) {
    Method *reader5201 = addmethodrealflags(obj5194, "isSelfRequest", &reader_ast_isSelfRequest_5201, 0);
    Method *writer5201 = addmethodrealflags(obj5194, "isSelfRequest:=(1)", &writer_ast_isSelfRequest_5201, 0);
    reader5201->definitionModule = modulename;
    writer5201->definitionModule = modulename;
    reader5201->definitionLine = 1243;
    writer5201->definitionLine = 1243;
  }
  obj5194->flags |= OFLAG_MUTABLE;
  adddatum2(obj5194, alloc_Undefined(), 6);
  if (objclass5194 == NULL) {
    Method *reader5202 = addmethodrealflags(obj5194, "isTailCall", &reader_ast_isTailCall_5202, 0);
    Method *writer5202 = addmethodrealflags(obj5194, "isTailCall:=(1)", &writer_ast_isTailCall_5202, 0);
    reader5202->definitionModule = modulename;
    writer5202->definitionModule = modulename;
    reader5202->definitionLine = 1244;
    writer5202->definitionLine = 1244;
  }
  obj5194->flags |= OFLAG_MUTABLE;
  adddatum2(obj5194, alloc_Undefined(), 7);
  if (objclass5194 == NULL) {
    Method *reader5203 = addmethodrealflags(obj5194, "isFresh", &reader_ast_isFresh_5203, 0);
    Method *writer5203 = addmethodrealflags(obj5194, "isFresh:=(1)", &writer_ast_isFresh_5203, 0);
    reader5203->definitionModule = modulename;
    writer5203->definitionModule = modulename;
    reader5203->definitionLine = 1245;
    writer5203->definitionLine = 1245;
  }
  obj5194->flags |= OFLAG_MUTABLE;
  adddatum2(obj5194, alloc_Undefined(), 8);
  if (objclass5194 == NULL) {
    Method *reader5204 = addmethodrealflags(obj5194, "cachedIdentifier", &reader_ast_cachedIdentifier_5204, MFLAG_CONFIDENTIAL);
    Method *writer5204 = addmethodrealflags(obj5194, "cachedIdentifier:=(1)", &writer_ast_cachedIdentifier_5204, MFLAG_CONFIDENTIAL);
    reader5204->definitionModule = modulename;
    writer5204->definitionModule = modulename;
    reader5204->definitionLine = 1246;
    writer5204->definitionLine = 1246;
  }
  obj5194->flags |= OFLAG_MUTABLE;
  adddatum2(obj5194, alloc_Undefined(), 9);
  if (objclass5194 == NULL) {
    Method *reader5205 = addmethodrealflags(obj5194, "endPos", &reader_ast_endPos_5205, 0);
    Method *writer5205 = addmethodrealflags(obj5194, "endPos:=(1)", &writer_ast_endPos_5205, 0);
    reader5205->definitionModule = modulename;
    writer5205->definitionModule = modulename;
    reader5205->definitionLine = 1247;
    writer5205->definitionLine = 1247;
  }
  obj5194->flags |= OFLAG_MUTABLE;
  adddatum2(obj5194, alloc_Undefined(), 10);
// method "end"
  block_savedest(obj5194);
  Object closure5206 = createclosure(2, "end");
  setclosureframe(closure5206, stackframe);
  addtoclosure(closure5206, var_noPosition);
  addtoclosure(closure5206, var_util);
  struct UserObject *uo5206 = (struct UserObject*)obj5194;
  uo5206->data[11] = (Object)closure5206;
  Method *meth_meth_ast_5206_end = addmethod2pos(obj5194, "end", &meth_ast_5206_end, 11);
  int argcv_meth_ast_5206_end[] = {0};
  meth_meth_ast_5206_end->type = alloc_MethodType(1, argcv_meth_ast_5206_end);
  meth_meth_ast_5206_end->definitionModule = modulename;
  meth_meth_ast_5206_end->definitionLine = 1249;
// method "end:=(_)"
  struct UserObject *uo5280 = (struct UserObject*)obj5194;
  uo5280->data[12] = emptyclosure;
  Method *meth_meth_ast_5280_end_58__61__40_1_41_ = addmethod2pos(obj5194, "end:=(1)", &meth_ast_5280_end_58__61__40_1_41_, 12);
  int argcv_meth_ast_5280_end_58__61__40_1_41_[] = {1};
  meth_meth_ast_5280_end_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5280_end_58__61__40_1_41_);
  meth_meth_ast_5280_end_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_5280_end_58__61__40_1_41_->definitionLine = 1262;
// method "isRequestOfPrefixOperator"
  struct UserObject *uo5283 = (struct UserObject*)obj5194;
  uo5283->data[13] = emptyclosure;
  Method *meth_meth_ast_5283_isRequestOfPrefixOperator = addmethod2pos(obj5194, "isRequestOfPrefixOperator", &meth_ast_5283_isRequestOfPrefixOperator, 13);
  int argcv_meth_ast_5283_isRequestOfPrefixOperator[] = {0};
  meth_meth_ast_5283_isRequestOfPrefixOperator->type = alloc_MethodType(1, argcv_meth_ast_5283_isRequestOfPrefixOperator);
  meth_meth_ast_5283_isRequestOfPrefixOperator->definitionModule = modulename;
  meth_meth_ast_5283_isRequestOfPrefixOperator->definitionLine = 1263;
// method "onSelf"
  struct UserObject *uo5293 = (struct UserObject*)obj5194;
  uo5293->data[14] = emptyclosure;
  Method *meth_meth_ast_5293_onSelf = addmethod2pos(obj5194, "onSelf", &meth_ast_5293_onSelf, 14);
  int argcv_meth_ast_5293_onSelf[] = {0};
  meth_meth_ast_5293_onSelf->type = alloc_MethodType(1, argcv_meth_ast_5293_onSelf);
  meth_meth_ast_5293_onSelf->definitionModule = modulename;
  meth_meth_ast_5293_onSelf->definitionLine = 1264;
// method "nameString"
  struct UserObject *uo5297 = (struct UserObject*)obj5194;
  uo5297->data[15] = emptyclosure;
  Method *meth_meth_ast_5297_nameString = addmethod2pos(obj5194, "nameString", &meth_ast_5297_nameString, 15);
  int argcv_meth_ast_5297_nameString[] = {0};
  meth_meth_ast_5297_nameString->type = alloc_MethodType(1, argcv_meth_ast_5297_nameString);
  meth_meth_ast_5297_nameString->definitionModule = modulename;
  meth_meth_ast_5297_nameString->definitionLine = 1270;
// method "canonicalName"
  struct UserObject *uo5311 = (struct UserObject*)obj5194;
  uo5311->data[16] = emptyclosure;
  Method *meth_meth_ast_5311_canonicalName = addmethod2pos(obj5194, "canonicalName", &meth_ast_5311_canonicalName, 16);
  int argcv_meth_ast_5311_canonicalName[] = {0};
  meth_meth_ast_5311_canonicalName->type = alloc_MethodType(1, argcv_meth_ast_5311_canonicalName);
  meth_meth_ast_5311_canonicalName->definitionModule = modulename;
  meth_meth_ast_5311_canonicalName->definitionLine = 1275;
// method "isCall"
  struct UserObject *uo5325 = (struct UserObject*)obj5194;
  uo5325->data[17] = emptyclosure;
  Method *meth_meth_ast_5325_isCall = addmethod2pos(obj5194, "isCall", &meth_ast_5325_isCall, 17);
  int argcv_meth_ast_5325_isCall[] = {0};
  meth_meth_ast_5325_isCall->type = alloc_MethodType(1, argcv_meth_ast_5325_isCall);
  meth_meth_ast_5325_isCall->definitionModule = modulename;
  meth_meth_ast_5325_isCall->definitionLine = 1281;
// method "returnsObject"
  struct UserObject *uo5327 = (struct UserObject*)obj5194;
  uo5327->data[18] = emptyclosure;
  Method *meth_meth_ast_5327_returnsObject = addmethod2pos(obj5194, "returnsObject", &meth_ast_5327_returnsObject, 18);
  int argcv_meth_ast_5327_returnsObject[] = {0};
  meth_meth_ast_5327_returnsObject->type = alloc_MethodType(1, argcv_meth_ast_5327_returnsObject);
  meth_meth_ast_5327_returnsObject->definitionModule = modulename;
  meth_meth_ast_5327_returnsObject->definitionLine = 1282;
// method "isCopy"
  struct UserObject *uo5338 = (struct UserObject*)obj5194;
  uo5338->data[19] = emptyclosure;
  Method *meth_meth_ast_5338_isCopy = addmethod2pos(obj5194, "isCopy", &meth_ast_5338_isCopy, 19);
  int argcv_meth_ast_5338_isCopy[] = {0};
  meth_meth_ast_5338_isCopy->type = alloc_MethodType(1, argcv_meth_ast_5338_isCopy);
  meth_meth_ast_5338_isCopy->definitionModule = modulename;
  meth_meth_ast_5338_isCopy->definitionLine = 1289;
// method "isClone"
  struct UserObject *uo5359 = (struct UserObject*)obj5194;
  uo5359->data[20] = emptyclosure;
  Method *meth_meth_ast_5359_isClone = addmethod2pos(obj5194, "isClone", &meth_ast_5359_isClone, 20);
  int argcv_meth_ast_5359_isClone[] = {0};
  meth_meth_ast_5359_isClone->type = alloc_MethodType(1, argcv_meth_ast_5359_isClone);
  meth_meth_ast_5359_isClone->definitionModule = modulename;
  meth_meth_ast_5359_isClone->definitionLine = 1293;
// method "returnedObjectScope"
  struct UserObject *uo5380 = (struct UserObject*)obj5194;
  uo5380->data[21] = emptyclosure;
  Method *meth_meth_ast_5380_returnedObjectScope = addmethod2pos(obj5194, "returnedObjectScope", &meth_ast_5380_returnedObjectScope, 21);
  int argcv_meth_ast_5380_returnedObjectScope[] = {0};
  meth_meth_ast_5380_returnedObjectScope->type = alloc_MethodType(1, argcv_meth_ast_5380_returnedObjectScope);
  meth_meth_ast_5380_returnedObjectScope->definitionModule = modulename;
  meth_meth_ast_5380_returnedObjectScope->definitionLine = 1297;
// method "arguments"
  struct UserObject *uo5383 = (struct UserObject*)obj5194;
  uo5383->data[22] = emptyclosure;
  Method *meth_meth_ast_5383_arguments = addmethod2pos(obj5194, "arguments", &meth_ast_5383_arguments, 22);
  int argcv_meth_ast_5383_arguments[] = {0};
  meth_meth_ast_5383_arguments->type = alloc_MethodType(1, argcv_meth_ast_5383_arguments);
  meth_meth_ast_5383_arguments->definitionModule = modulename;
  meth_meth_ast_5383_arguments->definitionLine = 1301;
// method "argumentsDo(_)"
  struct UserObject *uo5401 = (struct UserObject*)obj5194;
  uo5401->data[23] = emptyclosure;
  Method *meth_meth_ast_5401_argumentsDo_40_1_41_ = addmethod2pos(obj5194, "argumentsDo(1)", &meth_ast_5401_argumentsDo_40_1_41_, 23);
  int argcv_meth_ast_5401_argumentsDo_40_1_41_[] = {1};
  meth_meth_ast_5401_argumentsDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5401_argumentsDo_40_1_41_);
  meth_meth_ast_5401_argumentsDo_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5401_argumentsDo_40_1_41_->definitionLine = 1309;
// method "numArgs"
  struct UserObject *uo5418 = (struct UserObject*)obj5194;
  uo5418->data[24] = emptyclosure;
  Method *meth_meth_ast_5418_numArgs = addmethod2pos(obj5194, "numArgs", &meth_ast_5418_numArgs, 24);
  int argcv_meth_ast_5418_numArgs[] = {0};
  meth_meth_ast_5418_numArgs->type = alloc_MethodType(1, argcv_meth_ast_5418_numArgs);
  meth_meth_ast_5418_numArgs->definitionModule = modulename;
  meth_meth_ast_5418_numArgs->definitionLine = 1315;
// method "numTypeArgs"
  struct UserObject *uo5434 = (struct UserObject*)obj5194;
  uo5434->data[25] = emptyclosure;
  Method *meth_meth_ast_5434_numTypeArgs = addmethod2pos(obj5194, "numTypeArgs", &meth_ast_5434_numTypeArgs, 25);
  int argcv_meth_ast_5434_numTypeArgs[] = {0};
  meth_meth_ast_5434_numTypeArgs->type = alloc_MethodType(1, argcv_meth_ast_5434_numTypeArgs);
  meth_meth_ast_5434_numTypeArgs->definitionModule = modulename;
  meth_meth_ast_5434_numTypeArgs->definitionLine = 1319;
// method "accept(_)from(_)"
  struct UserObject *uo5447 = (struct UserObject*)obj5194;
  uo5447->data[26] = emptyclosure;
  Method *meth_meth_ast_5447_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj5194, "accept(1)from(1)", &meth_ast_5447_accept_40_1_41_from_40_1_41_, 26);
  int argcv_meth_ast_5447_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_5447_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_5447_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_5447_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5447_accept_40_1_41_from_40_1_41_->definitionLine = 1323;
// method "map(_)ancestors(_)"
  struct UserObject *uo5489 = (struct UserObject*)obj5194;
  uo5489->data[27] = emptyclosure;
  Method *meth_meth_ast_5489_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj5194, "map(1)ancestors(1)", &meth_ast_5489_map_40_1_41_ancestors_40_1_41_, 27);
  int argcv_meth_ast_5489_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_5489_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_5489_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_5489_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5489_map_40_1_41_ancestors_40_1_41_->definitionLine = 1339;
// method "pretty(_)"
  struct UserObject *uo5514 = (struct UserObject*)obj5194;
  uo5514->data[28] = emptyclosure;
  Method *meth_meth_ast_5514_pretty_40_1_41_ = addmethod2pos(obj5194, "pretty(1)", &meth_ast_5514_pretty_40_1_41_, 28);
  int argcv_meth_ast_5514_pretty_40_1_41_[] = {1};
  meth_meth_ast_5514_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5514_pretty_40_1_41_);
  meth_meth_ast_5514_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5514_pretty_40_1_41_->definitionLine = 1347;
// method "toGrace(_)"
  struct UserObject *uo5649 = (struct UserObject*)obj5194;
  uo5649->data[29] = emptyclosure;
  Method *meth_meth_ast_5649_toGrace_40_1_41_ = addmethod2pos(obj5194, "toGrace(1)", &meth_ast_5649_toGrace_40_1_41_, 29);
  int argcv_meth_ast_5649_toGrace_40_1_41_[] = {1};
  meth_meth_ast_5649_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5649_toGrace_40_1_41_);
meth_meth_ast_5649_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_5649_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_5649_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5649_toGrace_40_1_41_->definitionLine = 1365;
// method "asIdentifier"
  block_savedest(obj5194);
  Object closure5754 = createclosure(3, "asIdentifier");
  setclosureframe(closure5754, stackframe);
  addtoclosure(closure5754, var_uninitialized);
  addtoclosure(closure5754, var_fakeSymbolTable);
  addtoclosure(closure5754, var_identifierNode);
  struct UserObject *uo5754 = (struct UserObject*)obj5194;
  uo5754->data[30] = (Object)closure5754;
  Method *meth_meth_ast_5754_asIdentifier = addmethod2pos(obj5194, "asIdentifier", &meth_ast_5754_asIdentifier, 30);
  int argcv_meth_ast_5754_asIdentifier[] = {0};
  meth_meth_ast_5754_asIdentifier->type = alloc_MethodType(1, argcv_meth_ast_5754_asIdentifier);
  meth_meth_ast_5754_asIdentifier->definitionModule = modulename;
  meth_meth_ast_5754_asIdentifier->definitionLine = 1382;
// method "asString"
  struct UserObject *uo5818 = (struct UserObject*)obj5194;
  uo5818->data[31] = emptyclosure;
  Method *meth_meth_ast_5818_asString = addmethod2pos(obj5194, "asString", &meth_ast_5818_asString, 31);
  int argcv_meth_ast_5818_asString[] = {0};
  meth_meth_ast_5818_asString->type = alloc_MethodType(1, argcv_meth_ast_5818_asString);
  meth_meth_ast_5818_asString->definitionModule = modulename;
  meth_meth_ast_5818_asString->definitionLine = 1397;
// method "shallowCopy"
  block_savedest(obj5194);
  Object closure5830 = createclosure(1, "shallowCopy");
  setclosureframe(closure5830, stackframe);
  addtoclosure(closure5830, var_callNode);
  struct UserObject *uo5830 = (struct UserObject*)obj5194;
  uo5830->data[32] = (Object)closure5830;
  Method *meth_meth_ast_5830_shallowCopy = addmethod2pos(obj5194, "shallowCopy", &meth_ast_5830_shallowCopy, 32);
  int argcv_meth_ast_5830_shallowCopy[] = {0};
  meth_meth_ast_5830_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_5830_shallowCopy);
  meth_meth_ast_5830_shallowCopy->definitionModule = modulename;
  meth_meth_ast_5830_shallowCopy->definitionLine = 1398;
// method "postCopy(_)"
  struct UserObject *uo5839 = (struct UserObject*)obj5194;
  uo5839->data[33] = emptyclosure;
  Method *meth_meth_ast_5839_postCopy_40_1_41_ = addmethod2pos(obj5194, "postCopy(1)", &meth_ast_5839_postCopy_40_1_41_, 33);
  int argcv_meth_ast_5839_postCopy_40_1_41_[] = {1};
  meth_meth_ast_5839_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5839_postCopy_40_1_41_);
  meth_meth_ast_5839_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5839_postCopy_40_1_41_->definitionLine = 1401;
// method "statementName"
  struct UserObject *uo5860 = (struct UserObject*)obj5194;
  uo5860->data[34] = emptyclosure;
  Method *meth_meth_ast_5860_statementName = addmethod2pos(obj5194, "statementName", &meth_ast_5860_statementName, 34);
  int argcv_meth_ast_5860_statementName[] = {0};
  meth_meth_ast_5860_statementName->type = alloc_MethodType(1, argcv_meth_ast_5860_statementName);
  meth_meth_ast_5860_statementName->definitionModule = modulename;
  meth_meth_ast_5860_statementName->definitionLine = 1409;
  sourceObject = obj5194;
// Begin line 1237
  setline(1237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5862 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5863 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5862);
// compiled call node returning call5863 (depth = 3)
  struct UserObject *obj5194_uo = (struct UserObject *)obj5194;
  obj5194_uo->super = call5863;
  sourceObject = obj5194;
// Begin line 1238
  setline(1238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5864 == NULL) {
    strlit5864 = alloc_String("call");
    gc_root(strlit5864);
  }
// compiled string node returning strlit5864 (depth = 3)
  adddatum2(obj5194, strlit5864, 1);
  sourceObject = obj5194;
// Begin line 1239
  setline(1239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_parts_39_ (depth = 3)
  adddatum2(obj5194, *var_parts_39_, 2);
  sourceObject = obj5194;
// Begin line 1240
  setline(1240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5865 = alloc_Boolean(0);
// compiled identifier node returning bool5865 (depth = 3)
  adddatum2(obj5194, bool5865, 3);
  sourceObject = obj5194;
// Begin line 1241
  setline(1241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5866 = alloc_Boolean(0);
// compiled identifier node returning bool5866 (depth = 3)
  adddatum2(obj5194, bool5866, 4);
  sourceObject = obj5194;
// Begin line 1242
  setline(1242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_receiver_39_ (depth = 3)
  adddatum2(obj5194, *var_receiver_39_, 5);
  sourceObject = obj5194;
// Begin line 1243
  setline(1243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5867 = alloc_Boolean(0);
// compiled identifier node returning bool5867 (depth = 3)
  adddatum2(obj5194, bool5867, 6);
  sourceObject = obj5194;
// Begin line 1244
  setline(1244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5868 = alloc_Boolean(0);
// compiled identifier node returning bool5868 (depth = 3)
  adddatum2(obj5194, bool5868, 7);
  sourceObject = obj5194;
// Begin line 1245
  setline(1245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5869 = alloc_Boolean(0);
// compiled identifier node returning bool5869 (depth = 3)
  adddatum2(obj5194, bool5869, 8);
  sourceObject = obj5194;
// Begin line 1246
  setline(1246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_uninitialized (depth = 3)
  adddatum2(obj5194, *var_uninitialized, 9);
  sourceObject = obj5194;
// Begin line 1247
  setline(1247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_noPosition (depth = 3)
  adddatum2(obj5194, *var_noPosition, 10);
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  objclass5194 = obj5194->class;
  objclass5194->definitionModule = modulename;
  objclass5194->definitionLine = 1232;
  (*(struct UserObject *)self).data[0] = lowerouter5194;
  self = oldself5194;
  selfslot = oldselfslot5194;
  stackframe = oldstackframe5194;
  gc_frame_end(frame);
  return obj5194;
}
Object meth_ast_5193_new_40_2_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_noPosition = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_uninitialized = getfromclosure(closure, 2);
  Object *var_fakeSymbolTable = getfromclosure(closure, 3);
  Object *var_identifierNode = getfromclosure(closure, 4);
  Object *var_callNode = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_receiver_39_ = &(stackframe->slots[0]);
  *var_receiver_39_ = args[curarg];
  curarg++;
  Object *var_parts_39_ = &(stackframe->slots[1]);
  *var_parts_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5194 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5194 = alloc_userobj2(43,35, objclass5194);
  gc_frame_newslot(obj5194);
  if (objclass5194 == NULL) {
    glfree(obj5194->class->name);
    obj5194->class->name = "callNode.new(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj5194, self, 0);
  addmethodreal(obj5194,"outer", &reader_ast_outer_5195);
  Object oldself5194 = self;
  struct StackFrameObject *oldstackframe5194 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5194);
  gc_frame_newslot((Object)stackframe);
  self = obj5194;
  Object *oldselfslot5194 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5194 = (*(struct UserObject *)self).data[0], lowerouter5194 = thisouter5194;
  if (inheritingObject5194) {
    struct UserObject *inho5194 = (struct UserObject *)inheritingObject5194;
    while (inho5194->super != GraceDefaultObject) inho5194 = (struct UserObject *)inho5194->super;
    inho5194->super = obj5194;
    self = inheritingObject5194;
    *selfslot = self;
    lowerouter5194 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5194;
  }
  if (objclass5194 == NULL) {
  Method *reader5196 = addmethodrealflags(obj5194, "kind",&reader_ast_kind_5196, MFLAG_DEF);
  reader5196->definitionModule = modulename;
  reader5196->definitionLine = 1238;
  }
  adddatum2(obj5194, alloc_Undefined(), 1);
  if (objclass5194 == NULL) {
    Method *reader5197 = addmethodrealflags(obj5194, "parts", &reader_ast_parts_5197, 0);
    Method *writer5197 = addmethodrealflags(obj5194, "parts:=(1)", &writer_ast_parts_5197, 0);
    reader5197->definitionModule = modulename;
    writer5197->definitionModule = modulename;
    reader5197->definitionLine = 1239;
    writer5197->definitionLine = 1239;
  }
  obj5194->flags |= OFLAG_MUTABLE;
  adddatum2(obj5194, alloc_Undefined(), 2);
  if (objclass5194 == NULL) {
    Method *reader5198 = addmethodrealflags(obj5194, "generics", &reader_ast_generics_5198, 0);
    Method *writer5198 = addmethodrealflags(obj5194, "generics:=(1)", &writer_ast_generics_5198, 0);
    reader5198->definitionModule = modulename;
    writer5198->definitionModule = modulename;
    reader5198->definitionLine = 1240;
    writer5198->definitionLine = 1240;
  }
  obj5194->flags |= OFLAG_MUTABLE;
  adddatum2(obj5194, alloc_Undefined(), 3);
  if (objclass5194 == NULL) {
    Method *reader5199 = addmethodrealflags(obj5194, "isPattern", &reader_ast_isPattern_5199, 0);
    Method *writer5199 = addmethodrealflags(obj5194, "isPattern:=(1)", &writer_ast_isPattern_5199, 0);
    reader5199->definitionModule = modulename;
    writer5199->definitionModule = modulename;
    reader5199->definitionLine = 1241;
    writer5199->definitionLine = 1241;
  }
  obj5194->flags |= OFLAG_MUTABLE;
  adddatum2(obj5194, alloc_Undefined(), 4);
  if (objclass5194 == NULL) {
    Method *reader5200 = addmethodrealflags(obj5194, "receiver", &reader_ast_receiver_5200, 0);
    Method *writer5200 = addmethodrealflags(obj5194, "receiver:=(1)", &writer_ast_receiver_5200, 0);
    reader5200->definitionModule = modulename;
    writer5200->definitionModule = modulename;
    reader5200->definitionLine = 1242;
    writer5200->definitionLine = 1242;
  }
  obj5194->flags |= OFLAG_MUTABLE;
  adddatum2(obj5194, alloc_Undefined(), 5);
  if (objclass5194 == NULL) {
    Method *reader5201 = addmethodrealflags(obj5194, "isSelfRequest", &reader_ast_isSelfRequest_5201, 0);
    Method *writer5201 = addmethodrealflags(obj5194, "isSelfRequest:=(1)", &writer_ast_isSelfRequest_5201, 0);
    reader5201->definitionModule = modulename;
    writer5201->definitionModule = modulename;
    reader5201->definitionLine = 1243;
    writer5201->definitionLine = 1243;
  }
  obj5194->flags |= OFLAG_MUTABLE;
  adddatum2(obj5194, alloc_Undefined(), 6);
  if (objclass5194 == NULL) {
    Method *reader5202 = addmethodrealflags(obj5194, "isTailCall", &reader_ast_isTailCall_5202, 0);
    Method *writer5202 = addmethodrealflags(obj5194, "isTailCall:=(1)", &writer_ast_isTailCall_5202, 0);
    reader5202->definitionModule = modulename;
    writer5202->definitionModule = modulename;
    reader5202->definitionLine = 1244;
    writer5202->definitionLine = 1244;
  }
  obj5194->flags |= OFLAG_MUTABLE;
  adddatum2(obj5194, alloc_Undefined(), 7);
  if (objclass5194 == NULL) {
    Method *reader5203 = addmethodrealflags(obj5194, "isFresh", &reader_ast_isFresh_5203, 0);
    Method *writer5203 = addmethodrealflags(obj5194, "isFresh:=(1)", &writer_ast_isFresh_5203, 0);
    reader5203->definitionModule = modulename;
    writer5203->definitionModule = modulename;
    reader5203->definitionLine = 1245;
    writer5203->definitionLine = 1245;
  }
  obj5194->flags |= OFLAG_MUTABLE;
  adddatum2(obj5194, alloc_Undefined(), 8);
  if (objclass5194 == NULL) {
    Method *reader5204 = addmethodrealflags(obj5194, "cachedIdentifier", &reader_ast_cachedIdentifier_5204, MFLAG_CONFIDENTIAL);
    Method *writer5204 = addmethodrealflags(obj5194, "cachedIdentifier:=(1)", &writer_ast_cachedIdentifier_5204, MFLAG_CONFIDENTIAL);
    reader5204->definitionModule = modulename;
    writer5204->definitionModule = modulename;
    reader5204->definitionLine = 1246;
    writer5204->definitionLine = 1246;
  }
  obj5194->flags |= OFLAG_MUTABLE;
  adddatum2(obj5194, alloc_Undefined(), 9);
  if (objclass5194 == NULL) {
    Method *reader5205 = addmethodrealflags(obj5194, "endPos", &reader_ast_endPos_5205, 0);
    Method *writer5205 = addmethodrealflags(obj5194, "endPos:=(1)", &writer_ast_endPos_5205, 0);
    reader5205->definitionModule = modulename;
    writer5205->definitionModule = modulename;
    reader5205->definitionLine = 1247;
    writer5205->definitionLine = 1247;
  }
  obj5194->flags |= OFLAG_MUTABLE;
  adddatum2(obj5194, alloc_Undefined(), 10);
// method "end"
  block_savedest(obj5194);
  Object closure5206 = createclosure(2, "end");
  setclosureframe(closure5206, stackframe);
  addtoclosure(closure5206, var_noPosition);
  addtoclosure(closure5206, var_util);
  struct UserObject *uo5206 = (struct UserObject*)obj5194;
  uo5206->data[11] = (Object)closure5206;
  Method *meth_meth_ast_5206_end = addmethod2pos(obj5194, "end", &meth_ast_5206_end, 11);
  int argcv_meth_ast_5206_end[] = {0};
  meth_meth_ast_5206_end->type = alloc_MethodType(1, argcv_meth_ast_5206_end);
  meth_meth_ast_5206_end->definitionModule = modulename;
  meth_meth_ast_5206_end->definitionLine = 1249;
// method "end:=(_)"
  struct UserObject *uo5280 = (struct UserObject*)obj5194;
  uo5280->data[12] = emptyclosure;
  Method *meth_meth_ast_5280_end_58__61__40_1_41_ = addmethod2pos(obj5194, "end:=(1)", &meth_ast_5280_end_58__61__40_1_41_, 12);
  int argcv_meth_ast_5280_end_58__61__40_1_41_[] = {1};
  meth_meth_ast_5280_end_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5280_end_58__61__40_1_41_);
  meth_meth_ast_5280_end_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_5280_end_58__61__40_1_41_->definitionLine = 1262;
// method "isRequestOfPrefixOperator"
  struct UserObject *uo5283 = (struct UserObject*)obj5194;
  uo5283->data[13] = emptyclosure;
  Method *meth_meth_ast_5283_isRequestOfPrefixOperator = addmethod2pos(obj5194, "isRequestOfPrefixOperator", &meth_ast_5283_isRequestOfPrefixOperator, 13);
  int argcv_meth_ast_5283_isRequestOfPrefixOperator[] = {0};
  meth_meth_ast_5283_isRequestOfPrefixOperator->type = alloc_MethodType(1, argcv_meth_ast_5283_isRequestOfPrefixOperator);
  meth_meth_ast_5283_isRequestOfPrefixOperator->definitionModule = modulename;
  meth_meth_ast_5283_isRequestOfPrefixOperator->definitionLine = 1263;
// method "onSelf"
  struct UserObject *uo5293 = (struct UserObject*)obj5194;
  uo5293->data[14] = emptyclosure;
  Method *meth_meth_ast_5293_onSelf = addmethod2pos(obj5194, "onSelf", &meth_ast_5293_onSelf, 14);
  int argcv_meth_ast_5293_onSelf[] = {0};
  meth_meth_ast_5293_onSelf->type = alloc_MethodType(1, argcv_meth_ast_5293_onSelf);
  meth_meth_ast_5293_onSelf->definitionModule = modulename;
  meth_meth_ast_5293_onSelf->definitionLine = 1264;
// method "nameString"
  struct UserObject *uo5297 = (struct UserObject*)obj5194;
  uo5297->data[15] = emptyclosure;
  Method *meth_meth_ast_5297_nameString = addmethod2pos(obj5194, "nameString", &meth_ast_5297_nameString, 15);
  int argcv_meth_ast_5297_nameString[] = {0};
  meth_meth_ast_5297_nameString->type = alloc_MethodType(1, argcv_meth_ast_5297_nameString);
  meth_meth_ast_5297_nameString->definitionModule = modulename;
  meth_meth_ast_5297_nameString->definitionLine = 1270;
// method "canonicalName"
  struct UserObject *uo5311 = (struct UserObject*)obj5194;
  uo5311->data[16] = emptyclosure;
  Method *meth_meth_ast_5311_canonicalName = addmethod2pos(obj5194, "canonicalName", &meth_ast_5311_canonicalName, 16);
  int argcv_meth_ast_5311_canonicalName[] = {0};
  meth_meth_ast_5311_canonicalName->type = alloc_MethodType(1, argcv_meth_ast_5311_canonicalName);
  meth_meth_ast_5311_canonicalName->definitionModule = modulename;
  meth_meth_ast_5311_canonicalName->definitionLine = 1275;
// method "isCall"
  struct UserObject *uo5325 = (struct UserObject*)obj5194;
  uo5325->data[17] = emptyclosure;
  Method *meth_meth_ast_5325_isCall = addmethod2pos(obj5194, "isCall", &meth_ast_5325_isCall, 17);
  int argcv_meth_ast_5325_isCall[] = {0};
  meth_meth_ast_5325_isCall->type = alloc_MethodType(1, argcv_meth_ast_5325_isCall);
  meth_meth_ast_5325_isCall->definitionModule = modulename;
  meth_meth_ast_5325_isCall->definitionLine = 1281;
// method "returnsObject"
  struct UserObject *uo5327 = (struct UserObject*)obj5194;
  uo5327->data[18] = emptyclosure;
  Method *meth_meth_ast_5327_returnsObject = addmethod2pos(obj5194, "returnsObject", &meth_ast_5327_returnsObject, 18);
  int argcv_meth_ast_5327_returnsObject[] = {0};
  meth_meth_ast_5327_returnsObject->type = alloc_MethodType(1, argcv_meth_ast_5327_returnsObject);
  meth_meth_ast_5327_returnsObject->definitionModule = modulename;
  meth_meth_ast_5327_returnsObject->definitionLine = 1282;
// method "isCopy"
  struct UserObject *uo5338 = (struct UserObject*)obj5194;
  uo5338->data[19] = emptyclosure;
  Method *meth_meth_ast_5338_isCopy = addmethod2pos(obj5194, "isCopy", &meth_ast_5338_isCopy, 19);
  int argcv_meth_ast_5338_isCopy[] = {0};
  meth_meth_ast_5338_isCopy->type = alloc_MethodType(1, argcv_meth_ast_5338_isCopy);
  meth_meth_ast_5338_isCopy->definitionModule = modulename;
  meth_meth_ast_5338_isCopy->definitionLine = 1289;
// method "isClone"
  struct UserObject *uo5359 = (struct UserObject*)obj5194;
  uo5359->data[20] = emptyclosure;
  Method *meth_meth_ast_5359_isClone = addmethod2pos(obj5194, "isClone", &meth_ast_5359_isClone, 20);
  int argcv_meth_ast_5359_isClone[] = {0};
  meth_meth_ast_5359_isClone->type = alloc_MethodType(1, argcv_meth_ast_5359_isClone);
  meth_meth_ast_5359_isClone->definitionModule = modulename;
  meth_meth_ast_5359_isClone->definitionLine = 1293;
// method "returnedObjectScope"
  struct UserObject *uo5380 = (struct UserObject*)obj5194;
  uo5380->data[21] = emptyclosure;
  Method *meth_meth_ast_5380_returnedObjectScope = addmethod2pos(obj5194, "returnedObjectScope", &meth_ast_5380_returnedObjectScope, 21);
  int argcv_meth_ast_5380_returnedObjectScope[] = {0};
  meth_meth_ast_5380_returnedObjectScope->type = alloc_MethodType(1, argcv_meth_ast_5380_returnedObjectScope);
  meth_meth_ast_5380_returnedObjectScope->definitionModule = modulename;
  meth_meth_ast_5380_returnedObjectScope->definitionLine = 1297;
// method "arguments"
  struct UserObject *uo5383 = (struct UserObject*)obj5194;
  uo5383->data[22] = emptyclosure;
  Method *meth_meth_ast_5383_arguments = addmethod2pos(obj5194, "arguments", &meth_ast_5383_arguments, 22);
  int argcv_meth_ast_5383_arguments[] = {0};
  meth_meth_ast_5383_arguments->type = alloc_MethodType(1, argcv_meth_ast_5383_arguments);
  meth_meth_ast_5383_arguments->definitionModule = modulename;
  meth_meth_ast_5383_arguments->definitionLine = 1301;
// method "argumentsDo(_)"
  struct UserObject *uo5401 = (struct UserObject*)obj5194;
  uo5401->data[23] = emptyclosure;
  Method *meth_meth_ast_5401_argumentsDo_40_1_41_ = addmethod2pos(obj5194, "argumentsDo(1)", &meth_ast_5401_argumentsDo_40_1_41_, 23);
  int argcv_meth_ast_5401_argumentsDo_40_1_41_[] = {1};
  meth_meth_ast_5401_argumentsDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5401_argumentsDo_40_1_41_);
  meth_meth_ast_5401_argumentsDo_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5401_argumentsDo_40_1_41_->definitionLine = 1309;
// method "numArgs"
  struct UserObject *uo5418 = (struct UserObject*)obj5194;
  uo5418->data[24] = emptyclosure;
  Method *meth_meth_ast_5418_numArgs = addmethod2pos(obj5194, "numArgs", &meth_ast_5418_numArgs, 24);
  int argcv_meth_ast_5418_numArgs[] = {0};
  meth_meth_ast_5418_numArgs->type = alloc_MethodType(1, argcv_meth_ast_5418_numArgs);
  meth_meth_ast_5418_numArgs->definitionModule = modulename;
  meth_meth_ast_5418_numArgs->definitionLine = 1315;
// method "numTypeArgs"
  struct UserObject *uo5434 = (struct UserObject*)obj5194;
  uo5434->data[25] = emptyclosure;
  Method *meth_meth_ast_5434_numTypeArgs = addmethod2pos(obj5194, "numTypeArgs", &meth_ast_5434_numTypeArgs, 25);
  int argcv_meth_ast_5434_numTypeArgs[] = {0};
  meth_meth_ast_5434_numTypeArgs->type = alloc_MethodType(1, argcv_meth_ast_5434_numTypeArgs);
  meth_meth_ast_5434_numTypeArgs->definitionModule = modulename;
  meth_meth_ast_5434_numTypeArgs->definitionLine = 1319;
// method "accept(_)from(_)"
  struct UserObject *uo5447 = (struct UserObject*)obj5194;
  uo5447->data[26] = emptyclosure;
  Method *meth_meth_ast_5447_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj5194, "accept(1)from(1)", &meth_ast_5447_accept_40_1_41_from_40_1_41_, 26);
  int argcv_meth_ast_5447_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_5447_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_5447_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_5447_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5447_accept_40_1_41_from_40_1_41_->definitionLine = 1323;
// method "map(_)ancestors(_)"
  struct UserObject *uo5489 = (struct UserObject*)obj5194;
  uo5489->data[27] = emptyclosure;
  Method *meth_meth_ast_5489_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj5194, "map(1)ancestors(1)", &meth_ast_5489_map_40_1_41_ancestors_40_1_41_, 27);
  int argcv_meth_ast_5489_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_5489_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_5489_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_5489_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5489_map_40_1_41_ancestors_40_1_41_->definitionLine = 1339;
// method "pretty(_)"
  struct UserObject *uo5514 = (struct UserObject*)obj5194;
  uo5514->data[28] = emptyclosure;
  Method *meth_meth_ast_5514_pretty_40_1_41_ = addmethod2pos(obj5194, "pretty(1)", &meth_ast_5514_pretty_40_1_41_, 28);
  int argcv_meth_ast_5514_pretty_40_1_41_[] = {1};
  meth_meth_ast_5514_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5514_pretty_40_1_41_);
  meth_meth_ast_5514_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5514_pretty_40_1_41_->definitionLine = 1347;
// method "toGrace(_)"
  struct UserObject *uo5649 = (struct UserObject*)obj5194;
  uo5649->data[29] = emptyclosure;
  Method *meth_meth_ast_5649_toGrace_40_1_41_ = addmethod2pos(obj5194, "toGrace(1)", &meth_ast_5649_toGrace_40_1_41_, 29);
  int argcv_meth_ast_5649_toGrace_40_1_41_[] = {1};
  meth_meth_ast_5649_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5649_toGrace_40_1_41_);
meth_meth_ast_5649_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_5649_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_5649_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5649_toGrace_40_1_41_->definitionLine = 1365;
// method "asIdentifier"
  block_savedest(obj5194);
  Object closure5754 = createclosure(3, "asIdentifier");
  setclosureframe(closure5754, stackframe);
  addtoclosure(closure5754, var_uninitialized);
  addtoclosure(closure5754, var_fakeSymbolTable);
  addtoclosure(closure5754, var_identifierNode);
  struct UserObject *uo5754 = (struct UserObject*)obj5194;
  uo5754->data[30] = (Object)closure5754;
  Method *meth_meth_ast_5754_asIdentifier = addmethod2pos(obj5194, "asIdentifier", &meth_ast_5754_asIdentifier, 30);
  int argcv_meth_ast_5754_asIdentifier[] = {0};
  meth_meth_ast_5754_asIdentifier->type = alloc_MethodType(1, argcv_meth_ast_5754_asIdentifier);
  meth_meth_ast_5754_asIdentifier->definitionModule = modulename;
  meth_meth_ast_5754_asIdentifier->definitionLine = 1382;
// method "asString"
  struct UserObject *uo5818 = (struct UserObject*)obj5194;
  uo5818->data[31] = emptyclosure;
  Method *meth_meth_ast_5818_asString = addmethod2pos(obj5194, "asString", &meth_ast_5818_asString, 31);
  int argcv_meth_ast_5818_asString[] = {0};
  meth_meth_ast_5818_asString->type = alloc_MethodType(1, argcv_meth_ast_5818_asString);
  meth_meth_ast_5818_asString->definitionModule = modulename;
  meth_meth_ast_5818_asString->definitionLine = 1397;
// method "shallowCopy"
  block_savedest(obj5194);
  Object closure5830 = createclosure(1, "shallowCopy");
  setclosureframe(closure5830, stackframe);
  addtoclosure(closure5830, var_callNode);
  struct UserObject *uo5830 = (struct UserObject*)obj5194;
  uo5830->data[32] = (Object)closure5830;
  Method *meth_meth_ast_5830_shallowCopy = addmethod2pos(obj5194, "shallowCopy", &meth_ast_5830_shallowCopy, 32);
  int argcv_meth_ast_5830_shallowCopy[] = {0};
  meth_meth_ast_5830_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_5830_shallowCopy);
  meth_meth_ast_5830_shallowCopy->definitionModule = modulename;
  meth_meth_ast_5830_shallowCopy->definitionLine = 1398;
// method "postCopy(_)"
  struct UserObject *uo5839 = (struct UserObject*)obj5194;
  uo5839->data[33] = emptyclosure;
  Method *meth_meth_ast_5839_postCopy_40_1_41_ = addmethod2pos(obj5194, "postCopy(1)", &meth_ast_5839_postCopy_40_1_41_, 33);
  int argcv_meth_ast_5839_postCopy_40_1_41_[] = {1};
  meth_meth_ast_5839_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5839_postCopy_40_1_41_);
  meth_meth_ast_5839_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5839_postCopy_40_1_41_->definitionLine = 1401;
// method "statementName"
  struct UserObject *uo5860 = (struct UserObject*)obj5194;
  uo5860->data[34] = emptyclosure;
  Method *meth_meth_ast_5860_statementName = addmethod2pos(obj5194, "statementName", &meth_ast_5860_statementName, 34);
  int argcv_meth_ast_5860_statementName[] = {0};
  meth_meth_ast_5860_statementName->type = alloc_MethodType(1, argcv_meth_ast_5860_statementName);
  meth_meth_ast_5860_statementName->definitionModule = modulename;
  meth_meth_ast_5860_statementName->definitionLine = 1409;
  sourceObject = obj5194;
// Begin line 1237
  setline(1237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5862 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5863 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5862);
// compiled call node returning call5863 (depth = 3)
  struct UserObject *obj5194_uo = (struct UserObject *)obj5194;
  obj5194_uo->super = call5863;
  sourceObject = obj5194;
// Begin line 1238
  setline(1238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5864 == NULL) {
    strlit5864 = alloc_String("call");
    gc_root(strlit5864);
  }
// compiled string node returning strlit5864 (depth = 3)
  adddatum2(obj5194, strlit5864, 1);
  sourceObject = obj5194;
// Begin line 1239
  setline(1239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_parts_39_ (depth = 3)
  adddatum2(obj5194, *var_parts_39_, 2);
  sourceObject = obj5194;
// Begin line 1240
  setline(1240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5865 = alloc_Boolean(0);
// compiled identifier node returning bool5865 (depth = 3)
  adddatum2(obj5194, bool5865, 3);
  sourceObject = obj5194;
// Begin line 1241
  setline(1241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5866 = alloc_Boolean(0);
// compiled identifier node returning bool5866 (depth = 3)
  adddatum2(obj5194, bool5866, 4);
  sourceObject = obj5194;
// Begin line 1242
  setline(1242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_receiver_39_ (depth = 3)
  adddatum2(obj5194, *var_receiver_39_, 5);
  sourceObject = obj5194;
// Begin line 1243
  setline(1243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5867 = alloc_Boolean(0);
// compiled identifier node returning bool5867 (depth = 3)
  adddatum2(obj5194, bool5867, 6);
  sourceObject = obj5194;
// Begin line 1244
  setline(1244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5868 = alloc_Boolean(0);
// compiled identifier node returning bool5868 (depth = 3)
  adddatum2(obj5194, bool5868, 7);
  sourceObject = obj5194;
// Begin line 1245
  setline(1245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5869 = alloc_Boolean(0);
// compiled identifier node returning bool5869 (depth = 3)
  adddatum2(obj5194, bool5869, 8);
  sourceObject = obj5194;
// Begin line 1246
  setline(1246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_uninitialized (depth = 3)
  adddatum2(obj5194, *var_uninitialized, 9);
  sourceObject = obj5194;
// Begin line 1247
  setline(1247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_noPosition (depth = 3)
  adddatum2(obj5194, *var_noPosition, 10);
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  sourceObject = obj5194;
  objclass5194 = obj5194->class;
  objclass5194->definitionModule = modulename;
  objclass5194->definitionLine = 1232;
  (*(struct UserObject *)self).data[0] = lowerouter5194;
  self = oldself5194;
  selfslot = oldselfslot5194;
  stackframe = oldstackframe5194;
  gc_frame_end(frame);
  return obj5194;
}
Object meth_ast_5871_callNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 36, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_callNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1226
  setline(1226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_callNode (depth = 3)
  gc_frame_end(frame);
  return *var_callNode;
}
Object meth_ast_5874_body_40_1_41_named_40_1_41_scope_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "body(1)named(1)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)scope(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)scope(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for body(_)named(_)scope(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part body(_)");
  Object *var_n = &(stackframe->slots[1]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part named(_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1414
  setline(1414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5875 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  gc_frame_newslot(*var_b);
// call case 4: self request
  params[0] = *var_b;
  partcv[0] = 1;
  Object call5876 = callmethodflags(self, "body(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5875);
// compiled call node returning call5876 (depth = 4)
  *var_result = call5876;
  if (call5876 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1415
  setline(1415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5877 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5878 = callmethodflags(*var_result, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5877);
// compiled call node returning call5878 (depth = 3)
// Begin line 1416
  setline(1416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5879 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call5880 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5879);
// compiled call node returning call5880 (depth = 3)
// Begin line 1417
  setline(1417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_5881_body_40_1_41_named_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "body(1)named(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for body(_)named(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part body(_)");
  Object *var_n = &(stackframe->slots[1]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part named(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 1420
  setline(1420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5882 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  gc_frame_newslot(*var_b);
// call case 4: self request
  params[0] = *var_b;
  partcv[0] = 1;
  Object call5883 = callmethodflags(self, "body(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5882);
// compiled call node returning call5883 (depth = 4)
  *var_result = call5883;
  if (call5883 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1421
  setline(1421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5884 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5885 = callmethodflags(*var_result, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5884);
// compiled call node returning call5885 (depth = 3)
// Begin line 1422
  setline(1422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_5893_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1434
  setline(1434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5894 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5895 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5896 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call5897 = callmethodflags(*var_util, "lines", 1, partcv, params, 0);
  gc_frame_end(callframe5896);
// compiled member node returning call5897 (depth = 5)
  partcv[0] = 0;
  Object call5898 = callmethodflags(call5897, "size", 1, partcv, params, 0);
  gc_frame_end(callframe5895);
// compiled member node returning call5898 (depth = 4)
  gc_frame_newslot(call5898);
// starting to compile member node (depth = 4)
  int callframe5899 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5900 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5901 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call5902 = callmethodflags(*var_util, "lines", 1, partcv, params, 0);
  gc_frame_end(callframe5901);
// compiled member node returning call5902 (depth = 6)
  partcv[0] = 0;
  Object call5903 = callmethodflags(call5902, "last", 1, partcv, params, 0);
  gc_frame_end(callframe5900);
// compiled member node returning call5903 (depth = 5)
  partcv[0] = 0;
  Object call5904 = callmethodflags(call5903, "size", 1, partcv, params, 0);
  gc_frame_end(callframe5899);
// compiled member node returning call5904 (depth = 4)
  gc_frame_newslot(call5904);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = call5898;
  params[1] = call5904;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5905 = callmethodflags(module_ast, "line(1)column(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5894);
// compiled call node returning call5905 (depth = 3)
  gc_frame_end(frame);
  return call5905;
}
Object meth_ast_5906_isModule(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isModule");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1436
  setline(1436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5907 = alloc_Boolean(1);
// compiled identifier node returning bool5907 (depth = 3)
  gc_frame_end(frame);
  return bool5907;
}
Object meth_ast_5908_isTrait(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1437
  setline(1437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5909 = alloc_Boolean(0);
// compiled identifier node returning bool5909 (depth = 3)
  gc_frame_end(frame);
  return bool5909;
}
Object meth_ast_5910_returnsObject(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1438
  setline(1438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5911 = alloc_Boolean(0);
// compiled identifier node returning bool5911 (depth = 3)
  gc_frame_end(frame);
  return bool5911;
}
Object meth_ast_5915__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1441
  setline(1441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5917 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  partcv[0] = 0;
  Object call5918 = callmethodflags(*var_o, "isExternal", 1, partcv, params, 0);
  gc_frame_end(callframe5917);
// compiled member node returning call5918 (depth = 6)
  Object if5916 = done;
  if (istrue(call5918)) {
// starting to compile call node (depth = 6)
  int callframe5919 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_action (depth = 7)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5920 = callmethodflags(*var_action, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5919);
// compiled call node returning call5920 (depth = 6)
    gc_frame_newslot(call5920);
    if5916 = call5920;
  } else {
  }
// compiled if node returning if5916 (depth = 5)
  gc_frame_end(frame);
  return if5916;
}
Object meth_ast_5912_importsDo_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "importsDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method importsDo(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for importsDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part importsDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1440
  setline(1440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5913 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5914 = alloc_Block(NULL, NULL, "ast", 1440);
  gc_frame_newslot(block5914);
// method "_apply(_)"
  block_savedest(block5914);
  Object closure5915 = createclosure(2, "_apply(1)");
  setclosureframe(closure5915, stackframe);
  addtoclosure(closure5915, var_action);
  addtoclosure(closure5915, selfslot);
  struct UserObject *uo5915 = (struct UserObject*)block5914;
  uo5915->data[0] = (Object)closure5915;
  Method *meth_meth_ast_5915__apply_40_1_41_ = addmethod2pos(block5914, "_apply(1)", &meth_ast_5915__apply_40_1_41_, 0);
  int argcv_meth_ast_5915__apply_40_1_41_[] = {1};
  meth_meth_ast_5915__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5915__apply_40_1_41_);
  meth_meth_ast_5915__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5915__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block5914 (depth = 4)
  gc_frame_newslot(block5914);
// call case 6: other requests
// Begin line 1440
  setline(1440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5922 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5923 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5922);
// compiled member node returning call5923 (depth = 4)
  params[0] = block5914;
  partcv[0] = 1;
  Object call5924 = callmethodflags(call5923, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5913);
// compiled call node returning call5924 (depth = 3)
  gc_frame_end(frame);
  return call5924;
}
Object meth_ast_5941__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1449
  setline(1449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5943 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  partcv[0] = 0;
  Object call5944 = callmethodflags(*var_o, "isExternal", 1, partcv, params, 0);
  gc_frame_end(callframe5943);
// compiled member node returning call5944 (depth = 6)
  Object if5942 = done;
  if (istrue(call5944)) {
// starting to compile call node (depth = 6)
  int callframe5945 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_action (depth = 7)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5946 = callmethodflags(*var_action, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5945);
// compiled call node returning call5946 (depth = 6)
    gc_frame_newslot(call5946);
    if5942 = call5946;
  } else {
  }
// compiled if node returning if5942 (depth = 5)
  gc_frame_end(frame);
  return if5942;
}
Object meth_ast_5925_externalsDo_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "externalsDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method externalsDo(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for externalsDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part externalsDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1445
  setline(1445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5928 == NULL) {
    strlit5928 = alloc_String("none");
    gc_root(strlit5928);
  }
// compiled string node returning strlit5928 (depth = 5)
  int op_slot_right_5927 = gc_frame_newslot(strlit5928);
// starting to compile member node (depth = 5)
  int callframe5930 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5931 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5932 = callmethodflags(self, "theDialect", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5931);
// compiled member node returning call5932 (depth = 6)
  partcv[0] = 0;
  Object call5933 = callmethodflags(call5932, "value", 1, partcv, params, 0);
  gc_frame_end(callframe5930);
// compiled member node returning call5933 (depth = 5)
  int op_slot_left_5927 = gc_frame_newslot(call5933);
  params[0] = strlit5928;
  partcv[0] = 1;
  Object opresult5934 = callmethod(call5933, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5934 (depth = 4)
  Object if5926 = done;
  if (istrue(opresult5934)) {
// Begin line 1446
  setline(1446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5935 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5936 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5937 = callmethodflags(self, "theDialect", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5936);
// compiled member node returning call5937 (depth = 5)
  gc_frame_newslot(call5937);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_action (depth = 5)
  params[0] = call5937;
  partcv[0] = 1;
  Object call5938 = callmethodflags(*var_action, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5935);
// compiled call node returning call5938 (depth = 4)
    gc_frame_newslot(call5938);
    if5926 = call5938;
  } else {
  }
// compiled if node returning if5926 (depth = 3)
// Begin line 1448
  setline(1448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5939 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5940 = alloc_Block(NULL, NULL, "ast", 1448);
  gc_frame_newslot(block5940);
// method "_apply(_)"
  block_savedest(block5940);
  Object closure5941 = createclosure(2, "_apply(1)");
  setclosureframe(closure5941, stackframe);
  addtoclosure(closure5941, var_action);
  addtoclosure(closure5941, selfslot);
  struct UserObject *uo5941 = (struct UserObject*)block5940;
  uo5941->data[0] = (Object)closure5941;
  Method *meth_meth_ast_5941__apply_40_1_41_ = addmethod2pos(block5940, "_apply(1)", &meth_ast_5941__apply_40_1_41_, 0);
  int argcv_meth_ast_5941__apply_40_1_41_[] = {1};
  meth_meth_ast_5941__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5941__apply_40_1_41_);
  meth_meth_ast_5941__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5941__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block5940 (depth = 4)
  gc_frame_newslot(block5940);
// call case 6: other requests
// Begin line 1448
  setline(1448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5948 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5949 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5948);
// compiled member node returning call5949 (depth = 4)
  params[0] = block5940;
  partcv[0] = 1;
  Object call5950 = callmethodflags(call5949, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5939);
// compiled call node returning call5950 (depth = 3)
  gc_frame_end(frame);
  return call5950;
}
Object meth_ast_5976__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1460
  setline(1460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5977 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_x (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5978 = callmethodflags(*var_x, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5977);
// compiled call node returning call5978 (depth = 6)
  gc_frame_end(frame);
  return call5978;
}
Object meth_ast_5951_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// definebindings:
// definebindings:
// definebindings:
// Begin line 1453
  setline(1453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5953 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5954 = callmethodflags(*var_visitor, "visitModule(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5953);
// compiled call node returning call5954 (depth = 4)
  Object if5952 = done;
  if (istrue(call5954)) {
// Begin line 1454
  setline(1454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5955 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call5956 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5955);
// compiled call node returning call5956 (depth = 5)
  *var_newChain = call5956;
  if (call5956 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1455
  setline(1455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5957 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5958 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5959 = callmethodflags(self, "theDialect", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5958);
// compiled member node returning call5959 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5960 = callmethodflags(call5959, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5957);
// compiled call node returning call5960 (depth = 4)
// Begin line 1456
  setline(1456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5963 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5964 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5963);
// compiled member node returning call5964 (depth = 6)
  int op_slot_right_5962 = gc_frame_newslot(call5964);
// starting to compile identifier node (depth = 6)
  Object bool5966 = alloc_Boolean(0);
// compiled identifier node returning bool5966 (depth = 6)
  int op_slot_left_5962 = gc_frame_newslot(bool5966);
  params[0] = call5964;
  partcv[0] = 1;
  Object opresult5967 = callmethod(bool5966, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5967 (depth = 5)
  Object if5961 = done;
  if (istrue(opresult5967)) {
// Begin line 1457
  setline(1457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5968 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5969 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5970 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5969);
// compiled member node returning call5970 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5971 = callmethodflags(call5970, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5968);
// compiled call node returning call5971 (depth = 5)
    gc_frame_newslot(call5971);
    if5961 = call5971;
  } else {
  }
// compiled if node returning if5961 (depth = 4)
// Begin line 1459
  setline(1459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5972 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5973 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5974 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5973);
// compiled member node returning call5974 (depth = 5)
  gc_frame_newslot(call5974);
// starting to compile block node (depth = 5)
  Object block5975 = alloc_Block(NULL, NULL, "ast", 1459);
  gc_frame_newslot(block5975);
// method "_apply(_)"
  block_savedest(block5975);
  Object closure5976 = createclosure(3, "_apply(1)");
  setclosureframe(closure5976, stackframe);
  addtoclosure(closure5976, var_visitor);
  addtoclosure(closure5976, var_newChain);
  addtoclosure(closure5976, selfslot);
  struct UserObject *uo5976 = (struct UserObject*)block5975;
  uo5976->data[0] = (Object)closure5976;
  Method *meth_meth_ast_5976__apply_40_1_41_ = addmethod2pos(block5975, "_apply(1)", &meth_ast_5976__apply_40_1_41_, 0);
  int argcv_meth_ast_5976__apply_40_1_41_[] = {1};
  meth_meth_ast_5976__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5976__apply_40_1_41_);
  meth_meth_ast_5976__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5976__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block5975 (depth = 5)
  gc_frame_newslot(block5975);
// call case 5: prelude request
  params[0] = call5974;
  params[1] = block5975;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5980 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5972);
// compiled call node returning call5980 (depth = 4)
    gc_frame_newslot(call5980);
    if5952 = call5980;
  } else {
  }
// compiled if node returning if5952 (depth = 3)
  gc_frame_end(frame);
  return if5952;
}
Object meth_ast_5981_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1465
  setline(1465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5982 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5983 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5982);
// compiled member node returning call5983 (depth = 4)
  *var_n = call5983;
  if (call5983 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1466
  setline(1466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5984 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5985 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5984);
// compiled call node returning call5985 (depth = 4)
  *var_newChain = call5985;
  if (call5985 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1467
  setline(1467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5986 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe5987 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5988 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5989 = callmethodflags(self, "theDialect", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5988);
// compiled member node returning call5989 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5990 = callmethodflags(call5989, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5987);
// compiled call node returning call5990 (depth = 4)
  gc_frame_newslot(call5990);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call5990;
  partcv[0] = 1;
  Object call5991 = callmethodflags(*var_n, "theDialect:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5986);
// compiled call node returning call5991 (depth = 3)
// Begin line 1468
  setline(1468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5992 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe5993 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5994 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5995 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5994);
// compiled member node returning call5995 (depth = 5)
  gc_frame_newslot(call5995);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call5995;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5996 = callmethodflags(module_ast, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5993);
// compiled call node returning call5996 (depth = 4)
  gc_frame_newslot(call5996);
// call case 6: other requests
// Begin line 1468
  setline(1468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call5996;
  partcv[0] = 1;
  Object call5997 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5992);
// compiled call node returning call5997 (depth = 3)
// Begin line 1469
  setline(1469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5998 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe5999 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6000 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6001 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6000);
// compiled member node returning call6001 (depth = 5)
  gc_frame_newslot(call6001);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call6001;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6002 = callmethodflags(module_ast, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5999);
// compiled call node returning call6002 (depth = 4)
  gc_frame_newslot(call6002);
// call case 6: other requests
// Begin line 1469
  setline(1469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6002;
  partcv[0] = 1;
  Object call6003 = callmethodflags(*var_n, "superclass:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5998);
// compiled call node returning call6003 (depth = 3)
// Begin line 1470
  setline(1470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6004 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6005 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6006 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6007 = callmethodflags(self, "usedTraits", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6006);
// compiled member node returning call6007 (depth = 5)
  gc_frame_newslot(call6007);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call6007;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6008 = callmethodflags(module_ast, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6005);
// compiled call node returning call6008 (depth = 4)
  gc_frame_newslot(call6008);
// call case 6: other requests
// Begin line 1470
  setline(1470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6008;
  partcv[0] = 1;
  Object call6009 = callmethodflags(*var_n, "usedTraits:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6004);
// compiled call node returning call6009 (depth = 3)
// Begin line 1471
  setline(1471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6010 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call6011 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6010);
// compiled call node returning call6011 (depth = 3)
  gc_frame_end(frame);
  return call6011;
}
Object meth_ast_6012_basePretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "basePretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method basePretty(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for basePretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part basePretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
// Begin line 1474
  setline(1474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num6015 = alloc_Float64(1);
// compiled num node returning num6015 (depth = 6)
  int op_slot_right_6014 = gc_frame_newslot(num6015);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_6014 = gc_frame_newslot(*var_depth);
  params[0] = num6015;
  partcv[0] = 1;
  Object sum6017 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum6017 (depth = 5)
  int op_slot_right_6013 = gc_frame_newslot(sum6017);
// starting to compile string node (depth = 5)
  if (strlit6019 == NULL) {
    strlit6019 = alloc_String("  ");
    gc_root(strlit6019);
  }
// compiled string node returning strlit6019 (depth = 5)
  int op_slot_left_6013 = gc_frame_newslot(strlit6019);
  params[0] = sum6017;
  partcv[0] = 1;
  Object prod6020 = callmethod(strlit6019, "*(1)", 1, partcv, params);
// compiled op node returning prod6020 (depth = 4)
  *var_spc = prod6020;
  if (prod6020 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1475
  setline(1475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// Begin line 1476
  setline(1476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6023 == NULL) {
    strlit6023 = alloc_String("");
    gc_root(strlit6023);
  }
// compiled string node returning strlit6023 (depth = 5)
  int op_slot_right_6022 = gc_frame_newslot(strlit6023);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6026 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num6027 = alloc_Float64(0);
// compiled num node returning num6027 (depth = 7)
  gc_frame_newslot(num6027);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6028 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6029 = callmethodflags(self, "theDialect", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6028);
// compiled member node returning call6029 (depth = 7)
  params[0] = num6027;
  partcv[0] = 1;
  Object call6030 = callmethodflags(call6029, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6026);
// compiled call node returning call6030 (depth = 6)
  int op_slot_right_6025 = gc_frame_newslot(call6030);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6033 == NULL) {
    strlit6033 = alloc_String("");
    gc_root(strlit6033);
  }
// compiled string node returning strlit6033 (depth = 7)
  int op_slot_right_6032 = gc_frame_newslot(strlit6033);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_6035 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 8)
  if (strlit6037 == NULL) {
    strlit6037 = alloc_String("");
    gc_root(strlit6037);
  }
// compiled string node returning strlit6037 (depth = 8)
  int op_slot_left_6035 = gc_frame_newslot(strlit6037);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6038 = callmethod(strlit6037, "++(1)", 1, partcv, params);
// compiled op node returning opresult6038 (depth = 7)
  int op_slot_left_6032 = gc_frame_newslot(opresult6038);
  params[0] = strlit6033;
  partcv[0] = 1;
  Object opresult6039 = callmethod(opresult6038, "++(1)", 1, partcv, params);
// compiled op node returning opresult6039 (depth = 6)
  int op_slot_left_6025 = gc_frame_newslot(opresult6039);
  params[0] = call6030;
  partcv[0] = 1;
  Object opresult6040 = callmethod(opresult6039, "++(1)", 1, partcv, params);
// compiled op node returning opresult6040 (depth = 5)
  int op_slot_left_6022 = gc_frame_newslot(opresult6040);
  params[0] = strlit6023;
  partcv[0] = 1;
  Object opresult6041 = callmethod(opresult6040, "++(1)", 1, partcv, params);
// compiled op node returning opresult6041 (depth = 4)
  int op_slot_right_6021 = gc_frame_newslot(opresult6041);
// Begin line 1475
  setline(1475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6044 == NULL) {
    strlit6044 = alloc_String("""\x0a""");
    gc_root(strlit6044);
  }
// compiled string node returning strlit6044 (depth = 5)
  int op_slot_right_6043 = gc_frame_newslot(strlit6044);
// starting to compile call node (depth = 5)
  int callframe6046 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6047 = callmethodflags(self, "prettyPrefix(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6046);
// compiled call node returning call6047 (depth = 5)
  int op_slot_left_6043 = gc_frame_newslot(call6047);
  params[0] = strlit6044;
  partcv[0] = 1;
  Object opresult6048 = callmethod(call6047, "++(1)", 1, partcv, params);
// compiled op node returning opresult6048 (depth = 4)
  int op_slot_left_6021 = gc_frame_newslot(opresult6048);
  params[0] = opresult6041;
  partcv[0] = 1;
  Object opresult6049 = callmethod(opresult6048, "++(1)", 1, partcv, params);
// compiled op node returning opresult6049 (depth = 3)
  gc_frame_end(frame);
  return opresult6049;
}
Object meth_ast_6050_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_moduleNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1479
  setline(1479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6051 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe6052 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_moduleNode (depth = 5)
  params[0] = *var_emptySeq;
  partcv[0] = 1;
  Object call6053 = callmethodflags(*var_moduleNode, "body(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6052);
// compiled call node returning call6053 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6054 = callmethodflags(call6053, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6051);
// compiled call node returning call6054 (depth = 3)
  gc_frame_end(frame);
  return call6054;
}
Object meth_ast_6055_postCopy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "postCopy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method postCopy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for postCopy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part postCopy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1482
  setline(1482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6056 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6057 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call6058 = callmethodflags(*var_other, "imports", 1, partcv, params, 0);
  gc_frame_end(callframe6057);
// compiled member node returning call6058 (depth = 4)
  gc_frame_newslot(call6058);
// call case 4: self request
  params[0] = call6058;
  partcv[0] = 1;
  Object call6059 = callmethodflags(self, "imports:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6056);
// compiled call node returning call6059 (depth = 3)
// Begin line 1483
  setline(1483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6060 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6061 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call6062 = callmethodflags(*var_other, "theDialect", 1, partcv, params, 0);
  gc_frame_end(callframe6061);
// compiled member node returning call6062 (depth = 4)
  gc_frame_newslot(call6062);
// call case 4: self request
  params[0] = call6062;
  partcv[0] = 1;
  Object call6063 = callmethodflags(self, "theDialect:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6060);
// compiled call node returning call6063 (depth = 3)
// Begin line 1486
  setline(1486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6064 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6065 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call6066 = callmethodflags(*var_other, "name", 1, partcv, params, 0);
  gc_frame_end(callframe6065);
// compiled member node returning call6066 (depth = 4)
  gc_frame_newslot(call6066);
// call case 4: self request
  params[0] = call6066;
  partcv[0] = 1;
  Object call6067 = callmethodflags(self, "name:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6064);
// compiled call node returning call6067 (depth = 3)
// Begin line 1487
  setline(1487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6068 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6069 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call6070 = callmethodflags(*var_other, "value", 1, partcv, params, 0);
  gc_frame_end(callframe6069);
// compiled member node returning call6070 (depth = 4)
  gc_frame_newslot(call6070);
// call case 4: self request
  params[0] = call6070;
  partcv[0] = 1;
  Object call6071 = callmethodflags(self, "value:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6068);
// compiled call node returning call6071 (depth = 3)
// Begin line 1488
  setline(1488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6072 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6073 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call6074 = callmethodflags(*var_other, "superclass", 1, partcv, params, 0);
  gc_frame_end(callframe6073);
// compiled member node returning call6074 (depth = 4)
  gc_frame_newslot(call6074);
// call case 4: self request
  params[0] = call6074;
  partcv[0] = 1;
  Object call6075 = callmethodflags(self, "superclass:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6072);
// compiled call node returning call6075 (depth = 3)
// Begin line 1489
  setline(1489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6076 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6077 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call6078 = callmethodflags(*var_other, "usedTraits", 1, partcv, params, 0);
  gc_frame_end(callframe6077);
// compiled member node returning call6078 (depth = 4)
  gc_frame_newslot(call6078);
// call case 4: self request
  params[0] = call6078;
  partcv[0] = 1;
  Object call6079 = callmethodflags(self, "usedTraits:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6076);
// compiled call node returning call6079 (depth = 3)
// Begin line 1490
  setline(1490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6080 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6081 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call6082 = callmethodflags(*var_other, "inClass", 1, partcv, params, 0);
  gc_frame_end(callframe6081);
// compiled member node returning call6082 (depth = 4)
  gc_frame_newslot(call6082);
// call case 4: self request
  params[0] = call6082;
  partcv[0] = 1;
  Object call6083 = callmethodflags(self, "inClass:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6080);
// compiled call node returning call6083 (depth = 3)
// Begin line 1491
  setline(1491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6084 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6085 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call6086 = callmethodflags(*var_other, "inTrait", 1, partcv, params, 0);
  gc_frame_end(callframe6085);
// compiled member node returning call6086 (depth = 4)
  gc_frame_newslot(call6086);
// call case 4: self request
  params[0] = call6086;
  partcv[0] = 1;
  Object call6087 = callmethodflags(self, "inTrait:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6084);
// compiled call node returning call6087 (depth = 3)
// Begin line 1492
  setline(1492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6088 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6089 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call6090 = callmethodflags(*var_other, "annotations", 1, partcv, params, 0);
  gc_frame_end(callframe6089);
// compiled member node returning call6090 (depth = 4)
  gc_frame_newslot(call6090);
// call case 4: self request
  params[0] = call6090;
  partcv[0] = 1;
  Object call6091 = callmethodflags(self, "annotations:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6088);
// compiled call node returning call6091 (depth = 3)
// Begin line 1495
  setline(1495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_5886_body_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "body(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)");
  Object params[3];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_moduleNode = getfromclosure(closure, 2);
  Object *var_objectNode = getfromclosure(closure, 3);
  Object *var_dialectNode = getfromclosure(closure, 4);
  Object *var_noPosition = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for body(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part body(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5887 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5887 = alloc_userobj2(19,18, objclass5887);
  gc_frame_newslot(obj5887);
  if (objclass5887 == NULL) {
    glfree(obj5887->class->name);
    obj5887->class->name = "moduleNode.body(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj5887, self, 0);
  addmethodreal(obj5887,"outer", &reader_ast_outer_5888);
  Object oldself5887 = self;
  struct StackFrameObject *oldstackframe5887 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5887);
  gc_frame_newslot((Object)stackframe);
  self = obj5887;
  Object *oldselfslot5887 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5887 = (*(struct UserObject *)self).data[0], lowerouter5887 = thisouter5887;
  if (inheritingObject5887) {
    struct UserObject *inho5887 = (struct UserObject *)inheritingObject5887;
    while (inho5887->super != GraceDefaultObject) inho5887 = (struct UserObject *)inho5887->super;
    inho5887->super = obj5887;
    self = inheritingObject5887;
    *selfslot = self;
    lowerouter5887 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5887;
  }
  if (objclass5887 == NULL) {
  Method *reader5889 = addmethodrealflags(obj5887, "kind",&reader_ast_kind_5889, MFLAG_DEF);
  reader5889->definitionModule = modulename;
  reader5889->definitionLine = 1426;
  }
  adddatum2(obj5887, alloc_Undefined(), 1);
  if (objclass5887 == NULL) {
  Method *reader5890 = addmethodrealflags(obj5887, "sourceLines",&reader_ast_sourceLines_5890, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader5890->definitionModule = modulename;
  reader5890->definitionLine = 1427;
  }
  adddatum2(obj5887, alloc_Undefined(), 2);
  if (objclass5887 == NULL) {
    Method *reader5891 = addmethodrealflags(obj5887, "theDialect", &reader_ast_theDialect_5891, 0);
    Method *writer5891 = addmethodrealflags(obj5887, "theDialect:=(1)", &writer_ast_theDialect_5891, 0);
    reader5891->definitionModule = modulename;
    writer5891->definitionModule = modulename;
    reader5891->definitionLine = 1428;
    writer5891->definitionLine = 1428;
  }
  obj5887->flags |= OFLAG_MUTABLE;
  adddatum2(obj5887, alloc_Undefined(), 3);
  if (objclass5887 == NULL) {
    Method *reader5892 = addmethodrealflags(obj5887, "imports", &reader_ast_imports_5892, 0);
    Method *writer5892 = addmethodrealflags(obj5887, "imports:=(1)", &writer_ast_imports_5892, 0);
    reader5892->definitionModule = modulename;
    writer5892->definitionModule = modulename;
    reader5892->definitionLine = 1431;
    writer5892->definitionLine = 1431;
  }
  obj5887->flags |= OFLAG_MUTABLE;
  adddatum2(obj5887, alloc_Undefined(), 4);
// method "end"
  block_savedest(obj5887);
  Object closure5893 = createclosure(1, "end");
  setclosureframe(closure5893, stackframe);
  addtoclosure(closure5893, var_util);
  struct UserObject *uo5893 = (struct UserObject*)obj5887;
  uo5893->data[5] = (Object)closure5893;
  Method *meth_meth_ast_5893_end = addmethod2pos(obj5887, "end", &meth_ast_5893_end, 5);
  int argcv_meth_ast_5893_end[] = {0};
  meth_meth_ast_5893_end->type = alloc_MethodType(1, argcv_meth_ast_5893_end);
  meth_meth_ast_5893_end->definitionModule = modulename;
  meth_meth_ast_5893_end->definitionLine = 1433;
// method "isModule"
  struct UserObject *uo5906 = (struct UserObject*)obj5887;
  uo5906->data[6] = emptyclosure;
  Method *meth_meth_ast_5906_isModule = addmethod2pos(obj5887, "isModule", &meth_ast_5906_isModule, 6);
  int argcv_meth_ast_5906_isModule[] = {0};
  meth_meth_ast_5906_isModule->type = alloc_MethodType(1, argcv_meth_ast_5906_isModule);
  meth_meth_ast_5906_isModule->definitionModule = modulename;
  meth_meth_ast_5906_isModule->definitionLine = 1436;
// method "isTrait"
  struct UserObject *uo5908 = (struct UserObject*)obj5887;
  uo5908->data[7] = emptyclosure;
  Method *meth_meth_ast_5908_isTrait = addmethod2pos(obj5887, "isTrait", &meth_ast_5908_isTrait, 7);
  int argcv_meth_ast_5908_isTrait[] = {0};
  meth_meth_ast_5908_isTrait->type = alloc_MethodType(1, argcv_meth_ast_5908_isTrait);
  meth_meth_ast_5908_isTrait->definitionModule = modulename;
  meth_meth_ast_5908_isTrait->definitionLine = 1437;
// method "returnsObject"
  struct UserObject *uo5910 = (struct UserObject*)obj5887;
  uo5910->data[8] = emptyclosure;
  Method *meth_meth_ast_5910_returnsObject = addmethod2pos(obj5887, "returnsObject", &meth_ast_5910_returnsObject, 8);
  int argcv_meth_ast_5910_returnsObject[] = {0};
  meth_meth_ast_5910_returnsObject->type = alloc_MethodType(1, argcv_meth_ast_5910_returnsObject);
  meth_meth_ast_5910_returnsObject->definitionModule = modulename;
  meth_meth_ast_5910_returnsObject->definitionLine = 1438;
// method "importsDo(_)"
  struct UserObject *uo5912 = (struct UserObject*)obj5887;
  uo5912->data[9] = emptyclosure;
  Method *meth_meth_ast_5912_importsDo_40_1_41_ = addmethod2pos(obj5887, "importsDo(1)", &meth_ast_5912_importsDo_40_1_41_, 9);
  int argcv_meth_ast_5912_importsDo_40_1_41_[] = {1};
  meth_meth_ast_5912_importsDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5912_importsDo_40_1_41_);
  meth_meth_ast_5912_importsDo_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5912_importsDo_40_1_41_->definitionLine = 1439;
// method "externalsDo(_)"
  struct UserObject *uo5925 = (struct UserObject*)obj5887;
  uo5925->data[10] = emptyclosure;
  Method *meth_meth_ast_5925_externalsDo_40_1_41_ = addmethod2pos(obj5887, "externalsDo(1)", &meth_ast_5925_externalsDo_40_1_41_, 10);
  int argcv_meth_ast_5925_externalsDo_40_1_41_[] = {1};
  meth_meth_ast_5925_externalsDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5925_externalsDo_40_1_41_);
  meth_meth_ast_5925_externalsDo_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5925_externalsDo_40_1_41_->definitionLine = 1444;
// method "accept(_)from(_)"
  struct UserObject *uo5951 = (struct UserObject*)obj5887;
  uo5951->data[11] = emptyclosure;
  Method *meth_meth_ast_5951_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj5887, "accept(1)from(1)", &meth_ast_5951_accept_40_1_41_from_40_1_41_, 11);
  int argcv_meth_ast_5951_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_5951_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_5951_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_5951_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5951_accept_40_1_41_from_40_1_41_->definitionLine = 1452;
// method "map(_)ancestors(_)"
  struct UserObject *uo5981 = (struct UserObject*)obj5887;
  uo5981->data[12] = emptyclosure;
  Method *meth_meth_ast_5981_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj5887, "map(1)ancestors(1)", &meth_ast_5981_map_40_1_41_ancestors_40_1_41_, 12);
  int argcv_meth_ast_5981_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_5981_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_5981_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_5981_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5981_map_40_1_41_ancestors_40_1_41_->definitionLine = 1464;
// method "basePretty(_)"
  struct UserObject *uo6012 = (struct UserObject*)obj5887;
  uo6012->data[13] = emptyclosure;
  Method *meth_meth_ast_6012_basePretty_40_1_41_ = addmethod2pos(obj5887, "basePretty(1)", &meth_ast_6012_basePretty_40_1_41_, 13);
  int argcv_meth_ast_6012_basePretty_40_1_41_[] = {1};
  meth_meth_ast_6012_basePretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6012_basePretty_40_1_41_);
  meth_meth_ast_6012_basePretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6012_basePretty_40_1_41_->definitionLine = 1473;
// method "shallowCopy"
  block_savedest(obj5887);
  Object closure6050 = createclosure(2, "shallowCopy");
  setclosureframe(closure6050, stackframe);
  addtoclosure(closure6050, var_emptySeq);
  addtoclosure(closure6050, var_moduleNode);
  struct UserObject *uo6050 = (struct UserObject*)obj5887;
  uo6050->data[14] = (Object)closure6050;
  Method *meth_meth_ast_6050_shallowCopy = addmethod2pos(obj5887, "shallowCopy", &meth_ast_6050_shallowCopy, 14);
  int argcv_meth_ast_6050_shallowCopy[] = {0};
  meth_meth_ast_6050_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_6050_shallowCopy);
  meth_meth_ast_6050_shallowCopy->definitionModule = modulename;
  meth_meth_ast_6050_shallowCopy->definitionLine = 1478;
// method "postCopy(_)"
  struct UserObject *uo6055 = (struct UserObject*)obj5887;
  uo6055->data[15] = emptyclosure;
  Method *meth_meth_ast_6055_postCopy_40_1_41_ = addmethod2pos(obj5887, "postCopy(1)", &meth_ast_6055_postCopy_40_1_41_, 15);
  int argcv_meth_ast_6055_postCopy_40_1_41_[] = {1};
  meth_meth_ast_6055_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6055_postCopy_40_1_41_);
  meth_meth_ast_6055_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6055_postCopy_40_1_41_->definitionLine = 1481;
  sourceObject = obj5887;
// Begin line 1425
  setline(1425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6092 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
  Object bool6093 = alloc_Boolean(0);
// compiled identifier node returning bool6093 (depth = 4)
  gc_frame_newslot(bool6093);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objectNode (depth = 4)
  params[0] = *var_b;
  params[1] = bool6093;
  params[2] = self;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6094 = callmethodflags(*var_objectNode, "new(2)$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6092);
// compiled call node returning call6094 (depth = 3)
  struct UserObject *obj5887_uo = (struct UserObject *)obj5887;
  obj5887_uo->super = call6094;
  sourceObject = obj5887;
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6095 == NULL) {
    strlit6095 = alloc_String("module");
    gc_root(strlit6095);
  }
// compiled string node returning strlit6095 (depth = 3)
  adddatum2(obj5887, strlit6095, 1);
  sourceObject = obj5887;
// Begin line 1427
  setline(1427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6096 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  partcv[0] = 0;
  Object call6097 = callmethodflags(*var_util, "lines", 1, partcv, params, 0);
  gc_frame_end(callframe6096);
// compiled member node returning call6097 (depth = 3)
  adddatum2(obj5887, call6097, 2);
  sourceObject = obj5887;
// Begin line 1428
  setline(1428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6098 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6099 == NULL) {
    strlit6099 = alloc_String("standardGrace");
    gc_root(strlit6099);
  }
// compiled string node returning strlit6099 (depth = 4)
  gc_frame_newslot(strlit6099);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dialectNode (depth = 4)
  params[0] = strlit6099;
  partcv[0] = 1;
  Object call6100 = callmethodflags(*var_dialectNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6098);
// compiled call node returning call6100 (depth = 3)
  adddatum2(obj5887, call6100, 3);
  sourceObject = obj5887;
// Begin line 1429
  setline(1429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6101 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noPosition (depth = 4)
  gc_frame_newslot(*var_noPosition);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6102 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6103 = callmethodflags(self, "theDialect", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6102);
// compiled member node returning call6103 (depth = 4)
  params[0] = *var_noPosition;
  partcv[0] = 1;
  Object call6104 = callmethodflags(call6103, "setStart(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6101);
// compiled call node returning call6104 (depth = 3)
  sourceObject = obj5887;
// Begin line 1430
  setline(1430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6105 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noPosition (depth = 4)
  gc_frame_newslot(*var_noPosition);
// call case 4: self request
  params[0] = *var_noPosition;
  partcv[0] = 1;
  Object call6106 = callmethodflags(self, "setStart(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6105);
// compiled call node returning call6106 (depth = 3)
  sourceObject = obj5887;
// Begin line 1431
  setline(1431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array6107 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6107 (depth = 3)
  adddatum2(obj5887, array6107, 4);
  sourceObject = obj5887;
  sourceObject = obj5887;
  sourceObject = obj5887;
  sourceObject = obj5887;
  sourceObject = obj5887;
  sourceObject = obj5887;
  sourceObject = obj5887;
  sourceObject = obj5887;
  sourceObject = obj5887;
  sourceObject = obj5887;
  sourceObject = obj5887;
  objclass5887 = obj5887->class;
  objclass5887->definitionModule = modulename;
  objclass5887->definitionLine = 1424;
  (*(struct UserObject *)self).data[0] = lowerouter5887;
  self = oldself5887;
  selfslot = oldselfslot5887;
  stackframe = oldstackframe5887;
  gc_frame_end(frame);
  return obj5887;
}
Object meth_ast_5886_body_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "body(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method body(_)");
  Object params[3];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_moduleNode = getfromclosure(closure, 2);
  Object *var_objectNode = getfromclosure(closure, 3);
  Object *var_dialectNode = getfromclosure(closure, 4);
  Object *var_noPosition = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for body(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part body(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5887 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5887 = alloc_userobj2(19,18, objclass5887);
  gc_frame_newslot(obj5887);
  if (objclass5887 == NULL) {
    glfree(obj5887->class->name);
    obj5887->class->name = "moduleNode.body(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj5887, self, 0);
  addmethodreal(obj5887,"outer", &reader_ast_outer_5888);
  Object oldself5887 = self;
  struct StackFrameObject *oldstackframe5887 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5887);
  gc_frame_newslot((Object)stackframe);
  self = obj5887;
  Object *oldselfslot5887 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5887 = (*(struct UserObject *)self).data[0], lowerouter5887 = thisouter5887;
  if (inheritingObject5887) {
    struct UserObject *inho5887 = (struct UserObject *)inheritingObject5887;
    while (inho5887->super != GraceDefaultObject) inho5887 = (struct UserObject *)inho5887->super;
    inho5887->super = obj5887;
    self = inheritingObject5887;
    *selfslot = self;
    lowerouter5887 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5887;
  }
  if (objclass5887 == NULL) {
  Method *reader5889 = addmethodrealflags(obj5887, "kind",&reader_ast_kind_5889, MFLAG_DEF);
  reader5889->definitionModule = modulename;
  reader5889->definitionLine = 1426;
  }
  adddatum2(obj5887, alloc_Undefined(), 1);
  if (objclass5887 == NULL) {
  Method *reader5890 = addmethodrealflags(obj5887, "sourceLines",&reader_ast_sourceLines_5890, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader5890->definitionModule = modulename;
  reader5890->definitionLine = 1427;
  }
  adddatum2(obj5887, alloc_Undefined(), 2);
  if (objclass5887 == NULL) {
    Method *reader5891 = addmethodrealflags(obj5887, "theDialect", &reader_ast_theDialect_5891, 0);
    Method *writer5891 = addmethodrealflags(obj5887, "theDialect:=(1)", &writer_ast_theDialect_5891, 0);
    reader5891->definitionModule = modulename;
    writer5891->definitionModule = modulename;
    reader5891->definitionLine = 1428;
    writer5891->definitionLine = 1428;
  }
  obj5887->flags |= OFLAG_MUTABLE;
  adddatum2(obj5887, alloc_Undefined(), 3);
  if (objclass5887 == NULL) {
    Method *reader5892 = addmethodrealflags(obj5887, "imports", &reader_ast_imports_5892, 0);
    Method *writer5892 = addmethodrealflags(obj5887, "imports:=(1)", &writer_ast_imports_5892, 0);
    reader5892->definitionModule = modulename;
    writer5892->definitionModule = modulename;
    reader5892->definitionLine = 1431;
    writer5892->definitionLine = 1431;
  }
  obj5887->flags |= OFLAG_MUTABLE;
  adddatum2(obj5887, alloc_Undefined(), 4);
// method "end"
  block_savedest(obj5887);
  Object closure5893 = createclosure(1, "end");
  setclosureframe(closure5893, stackframe);
  addtoclosure(closure5893, var_util);
  struct UserObject *uo5893 = (struct UserObject*)obj5887;
  uo5893->data[5] = (Object)closure5893;
  Method *meth_meth_ast_5893_end = addmethod2pos(obj5887, "end", &meth_ast_5893_end, 5);
  int argcv_meth_ast_5893_end[] = {0};
  meth_meth_ast_5893_end->type = alloc_MethodType(1, argcv_meth_ast_5893_end);
  meth_meth_ast_5893_end->definitionModule = modulename;
  meth_meth_ast_5893_end->definitionLine = 1433;
// method "isModule"
  struct UserObject *uo5906 = (struct UserObject*)obj5887;
  uo5906->data[6] = emptyclosure;
  Method *meth_meth_ast_5906_isModule = addmethod2pos(obj5887, "isModule", &meth_ast_5906_isModule, 6);
  int argcv_meth_ast_5906_isModule[] = {0};
  meth_meth_ast_5906_isModule->type = alloc_MethodType(1, argcv_meth_ast_5906_isModule);
  meth_meth_ast_5906_isModule->definitionModule = modulename;
  meth_meth_ast_5906_isModule->definitionLine = 1436;
// method "isTrait"
  struct UserObject *uo5908 = (struct UserObject*)obj5887;
  uo5908->data[7] = emptyclosure;
  Method *meth_meth_ast_5908_isTrait = addmethod2pos(obj5887, "isTrait", &meth_ast_5908_isTrait, 7);
  int argcv_meth_ast_5908_isTrait[] = {0};
  meth_meth_ast_5908_isTrait->type = alloc_MethodType(1, argcv_meth_ast_5908_isTrait);
  meth_meth_ast_5908_isTrait->definitionModule = modulename;
  meth_meth_ast_5908_isTrait->definitionLine = 1437;
// method "returnsObject"
  struct UserObject *uo5910 = (struct UserObject*)obj5887;
  uo5910->data[8] = emptyclosure;
  Method *meth_meth_ast_5910_returnsObject = addmethod2pos(obj5887, "returnsObject", &meth_ast_5910_returnsObject, 8);
  int argcv_meth_ast_5910_returnsObject[] = {0};
  meth_meth_ast_5910_returnsObject->type = alloc_MethodType(1, argcv_meth_ast_5910_returnsObject);
  meth_meth_ast_5910_returnsObject->definitionModule = modulename;
  meth_meth_ast_5910_returnsObject->definitionLine = 1438;
// method "importsDo(_)"
  struct UserObject *uo5912 = (struct UserObject*)obj5887;
  uo5912->data[9] = emptyclosure;
  Method *meth_meth_ast_5912_importsDo_40_1_41_ = addmethod2pos(obj5887, "importsDo(1)", &meth_ast_5912_importsDo_40_1_41_, 9);
  int argcv_meth_ast_5912_importsDo_40_1_41_[] = {1};
  meth_meth_ast_5912_importsDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5912_importsDo_40_1_41_);
  meth_meth_ast_5912_importsDo_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5912_importsDo_40_1_41_->definitionLine = 1439;
// method "externalsDo(_)"
  struct UserObject *uo5925 = (struct UserObject*)obj5887;
  uo5925->data[10] = emptyclosure;
  Method *meth_meth_ast_5925_externalsDo_40_1_41_ = addmethod2pos(obj5887, "externalsDo(1)", &meth_ast_5925_externalsDo_40_1_41_, 10);
  int argcv_meth_ast_5925_externalsDo_40_1_41_[] = {1};
  meth_meth_ast_5925_externalsDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5925_externalsDo_40_1_41_);
  meth_meth_ast_5925_externalsDo_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5925_externalsDo_40_1_41_->definitionLine = 1444;
// method "accept(_)from(_)"
  struct UserObject *uo5951 = (struct UserObject*)obj5887;
  uo5951->data[11] = emptyclosure;
  Method *meth_meth_ast_5951_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj5887, "accept(1)from(1)", &meth_ast_5951_accept_40_1_41_from_40_1_41_, 11);
  int argcv_meth_ast_5951_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_5951_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_5951_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_5951_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5951_accept_40_1_41_from_40_1_41_->definitionLine = 1452;
// method "map(_)ancestors(_)"
  struct UserObject *uo5981 = (struct UserObject*)obj5887;
  uo5981->data[12] = emptyclosure;
  Method *meth_meth_ast_5981_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj5887, "map(1)ancestors(1)", &meth_ast_5981_map_40_1_41_ancestors_40_1_41_, 12);
  int argcv_meth_ast_5981_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_5981_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_5981_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_5981_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5981_map_40_1_41_ancestors_40_1_41_->definitionLine = 1464;
// method "basePretty(_)"
  struct UserObject *uo6012 = (struct UserObject*)obj5887;
  uo6012->data[13] = emptyclosure;
  Method *meth_meth_ast_6012_basePretty_40_1_41_ = addmethod2pos(obj5887, "basePretty(1)", &meth_ast_6012_basePretty_40_1_41_, 13);
  int argcv_meth_ast_6012_basePretty_40_1_41_[] = {1};
  meth_meth_ast_6012_basePretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6012_basePretty_40_1_41_);
  meth_meth_ast_6012_basePretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6012_basePretty_40_1_41_->definitionLine = 1473;
// method "shallowCopy"
  block_savedest(obj5887);
  Object closure6050 = createclosure(2, "shallowCopy");
  setclosureframe(closure6050, stackframe);
  addtoclosure(closure6050, var_emptySeq);
  addtoclosure(closure6050, var_moduleNode);
  struct UserObject *uo6050 = (struct UserObject*)obj5887;
  uo6050->data[14] = (Object)closure6050;
  Method *meth_meth_ast_6050_shallowCopy = addmethod2pos(obj5887, "shallowCopy", &meth_ast_6050_shallowCopy, 14);
  int argcv_meth_ast_6050_shallowCopy[] = {0};
  meth_meth_ast_6050_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_6050_shallowCopy);
  meth_meth_ast_6050_shallowCopy->definitionModule = modulename;
  meth_meth_ast_6050_shallowCopy->definitionLine = 1478;
// method "postCopy(_)"
  struct UserObject *uo6055 = (struct UserObject*)obj5887;
  uo6055->data[15] = emptyclosure;
  Method *meth_meth_ast_6055_postCopy_40_1_41_ = addmethod2pos(obj5887, "postCopy(1)", &meth_ast_6055_postCopy_40_1_41_, 15);
  int argcv_meth_ast_6055_postCopy_40_1_41_[] = {1};
  meth_meth_ast_6055_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6055_postCopy_40_1_41_);
  meth_meth_ast_6055_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6055_postCopy_40_1_41_->definitionLine = 1481;
  sourceObject = obj5887;
// Begin line 1425
  setline(1425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6092 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
  Object bool6093 = alloc_Boolean(0);
// compiled identifier node returning bool6093 (depth = 4)
  gc_frame_newslot(bool6093);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objectNode (depth = 4)
  params[0] = *var_b;
  params[1] = bool6093;
  params[2] = self;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6094 = callmethodflags(*var_objectNode, "new(2)$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6092);
// compiled call node returning call6094 (depth = 3)
  struct UserObject *obj5887_uo = (struct UserObject *)obj5887;
  obj5887_uo->super = call6094;
  sourceObject = obj5887;
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6095 == NULL) {
    strlit6095 = alloc_String("module");
    gc_root(strlit6095);
  }
// compiled string node returning strlit6095 (depth = 3)
  adddatum2(obj5887, strlit6095, 1);
  sourceObject = obj5887;
// Begin line 1427
  setline(1427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6096 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  partcv[0] = 0;
  Object call6097 = callmethodflags(*var_util, "lines", 1, partcv, params, 0);
  gc_frame_end(callframe6096);
// compiled member node returning call6097 (depth = 3)
  adddatum2(obj5887, call6097, 2);
  sourceObject = obj5887;
// Begin line 1428
  setline(1428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6098 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6099 == NULL) {
    strlit6099 = alloc_String("standardGrace");
    gc_root(strlit6099);
  }
// compiled string node returning strlit6099 (depth = 4)
  gc_frame_newslot(strlit6099);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dialectNode (depth = 4)
  params[0] = strlit6099;
  partcv[0] = 1;
  Object call6100 = callmethodflags(*var_dialectNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6098);
// compiled call node returning call6100 (depth = 3)
  adddatum2(obj5887, call6100, 3);
  sourceObject = obj5887;
// Begin line 1429
  setline(1429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6101 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noPosition (depth = 4)
  gc_frame_newslot(*var_noPosition);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6102 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6103 = callmethodflags(self, "theDialect", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6102);
// compiled member node returning call6103 (depth = 4)
  params[0] = *var_noPosition;
  partcv[0] = 1;
  Object call6104 = callmethodflags(call6103, "setStart(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6101);
// compiled call node returning call6104 (depth = 3)
  sourceObject = obj5887;
// Begin line 1430
  setline(1430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6105 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noPosition (depth = 4)
  gc_frame_newslot(*var_noPosition);
// call case 4: self request
  params[0] = *var_noPosition;
  partcv[0] = 1;
  Object call6106 = callmethodflags(self, "setStart(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6105);
// compiled call node returning call6106 (depth = 3)
  sourceObject = obj5887;
// Begin line 1431
  setline(1431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array6107 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6107 (depth = 3)
  adddatum2(obj5887, array6107, 4);
  sourceObject = obj5887;
  sourceObject = obj5887;
  sourceObject = obj5887;
  sourceObject = obj5887;
  sourceObject = obj5887;
  sourceObject = obj5887;
  sourceObject = obj5887;
  sourceObject = obj5887;
  sourceObject = obj5887;
  sourceObject = obj5887;
  sourceObject = obj5887;
  objclass5887 = obj5887->class;
  objclass5887->definitionModule = modulename;
  objclass5887->definitionLine = 1424;
  (*(struct UserObject *)self).data[0] = lowerouter5887;
  self = oldself5887;
  selfslot = oldselfslot5887;
  stackframe = oldstackframe5887;
  gc_frame_end(frame);
  return obj5887;
}
Object meth_ast_6109_moduleNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 37, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "moduleNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_moduleNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1412
  setline(1412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_moduleNode (depth = 3)
  gc_frame_end(frame);
  return *var_moduleNode;
}
Object meth_ast_6112_body_40_1_41_named_40_1_41_scope_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "body(1)named(1)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)scope(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)scope(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for body(_)named(_)scope(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part body(_)");
  Object *var_n = &(stackframe->slots[1]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part named(_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1501
  setline(1501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6113 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 5)
  Object bool6114 = alloc_Boolean(0);
// compiled identifier node returning bool6114 (depth = 5)
  gc_frame_newslot(bool6114);
// call case 4: self request
  params[0] = *var_b;
  params[1] = bool6114;
  partcv[0] = 2;
  Object call6115 = callmethodflags(self, "new(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6113);
// compiled call node returning call6115 (depth = 4)
  *var_result = call6115;
  if (call6115 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1502
  setline(1502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6116 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6117 = callmethodflags(*var_result, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6116);
// compiled call node returning call6117 (depth = 3)
// Begin line 1503
  setline(1503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6118 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call6119 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6118);
// compiled call node returning call6119 (depth = 3)
// Begin line 1504
  setline(1504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_6120_body_40_1_41_named_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "body(1)named(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)");
  Object params[3];
  int partcv[3];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for body(_)named(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part body(_)");
  Object *var_n = &(stackframe->slots[1]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part named(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1507
  setline(1507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6121 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_fakeSymbolTable (depth = 4)
  gc_frame_newslot(*var_fakeSymbolTable);
// call case 4: self request
  params[0] = *var_b;
  params[1] = *var_n;
  params[2] = *var_fakeSymbolTable;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6122 = callmethodflags(self, "body(1)named(1)scope(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6121);
// compiled call node returning call6122 (depth = 3)
  gc_frame_end(frame);
  return call6122;
}
Object meth_ast_6135_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_noPosition = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_iEnd = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "iEnd");
  Object *var_tEnd = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "tEnd");
// definebindings:
// definebindings:
// Begin line 1522
  setline(1522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6137 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6138 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6139 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6140 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6139);
// compiled member node returning call6140 (depth = 6)
  partcv[0] = 0;
  Object call6141 = callmethodflags(call6140, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe6138);
// compiled member node returning call6141 (depth = 5)
  partcv[0] = 0;
  Object call6142 = callmethodflags(call6141, "not", 1, partcv, params, 0);
  gc_frame_end(callframe6137);
// compiled member node returning call6142 (depth = 4)
  Object if6136 = done;
  if (istrue(call6142)) {
// Begin line 1523
  setline(1523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6143 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6144 == NULL) {
    strlit6144 = alloc_String("}");
    gc_root(strlit6144);
  }
// compiled string node returning strlit6144 (depth = 6)
  gc_frame_newslot(strlit6144);
// starting to compile member node (depth = 6)
  int callframe6145 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6146 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe6147 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6148 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6147);
// compiled member node returning call6148 (depth = 8)
  partcv[0] = 0;
  Object call6149 = callmethodflags(call6148, "last", 1, partcv, params, 0);
  gc_frame_end(callframe6146);
// compiled member node returning call6149 (depth = 7)
  partcv[0] = 0;
  Object call6150 = callmethodflags(call6149, "end", 1, partcv, params, 0);
  gc_frame_end(callframe6145);
// compiled member node returning call6150 (depth = 6)
  gc_frame_newslot(call6150);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_ast (depth = 6)
  params[0] = strlit6144;
  params[1] = call6150;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6151 = callmethodflags(module_ast, "positionOfNext(1)after(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6143);
// compiled call node returning call6151 (depth = 5)
  return call6151;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if6136 = undefined;
  } else {
  }
// compiled if node returning if6136 (depth = 3)
// Begin line 1525
  setline(1525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6154 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6155 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6154);
// compiled member node returning call6155 (depth = 6)
  int op_slot_right_6153 = gc_frame_newslot(call6155);
// starting to compile identifier node (depth = 6)
  Object bool6157 = alloc_Boolean(0);
// compiled identifier node returning bool6157 (depth = 6)
  int op_slot_left_6153 = gc_frame_newslot(bool6157);
  params[0] = call6155;
  partcv[0] = 1;
  Object opresult6158 = callmethod(bool6157, "==(1)", 1, partcv, params);
// compiled op node returning opresult6158 (depth = 5)
  Object if6152 = done;
struct StackFrameObject *iftmpstackframe6152 = stackframe;
  if (istrue(opresult6158)) {
stackframe = alloc_StackFrame(0, iftmpstackframe6152);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_noPosition (depth = 5)
    gc_frame_newslot(*var_noPosition);
    if6152 = *var_noPosition;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe6152);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile member node (depth = 5)
  int callframe6159 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6160 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6161 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6160);
// compiled member node returning call6161 (depth = 6)
  partcv[0] = 0;
  Object call6162 = callmethodflags(call6161, "end", 1, partcv, params, 0);
  gc_frame_end(callframe6159);
// compiled member node returning call6162 (depth = 5)
    gc_frame_newslot(call6162);
    if6152 = call6162;
  }
stackframe = iftmpstackframe6152;
// compiled if node returning if6152 (depth = 4)
  *var_iEnd = if6152;
  if (if6152 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1526
  setline(1526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6164 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6165 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6166 = callmethodflags(self, "usedTraits", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6165);
// compiled member node returning call6166 (depth = 6)
  partcv[0] = 0;
  Object call6167 = callmethodflags(call6166, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe6164);
// compiled member node returning call6167 (depth = 5)
  Object if6163 = done;
struct StackFrameObject *iftmpstackframe6163 = stackframe;
  if (istrue(call6167)) {
stackframe = alloc_StackFrame(0, iftmpstackframe6163);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_noPosition (depth = 5)
    gc_frame_newslot(*var_noPosition);
    if6163 = *var_noPosition;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe6163);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile member node (depth = 5)
  int callframe6168 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6169 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6170 = callmethodflags(self, "usedTraits", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6169);
// compiled member node returning call6170 (depth = 6)
  partcv[0] = 0;
  Object call6171 = callmethodflags(call6170, "end", 1, partcv, params, 0);
  gc_frame_end(callframe6168);
// compiled member node returning call6171 (depth = 5)
    gc_frame_newslot(call6171);
    if6163 = call6171;
  }
stackframe = iftmpstackframe6163;
// compiled if node returning if6163 (depth = 4)
  *var_tEnd = if6163;
  if (if6163 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1527
  setline(1527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tEnd (depth = 5)
  int op_slot_right_6173 = gc_frame_newslot(*var_tEnd);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_iEnd (depth = 5)
  int op_slot_left_6173 = gc_frame_newslot(*var_iEnd);
  params[0] = *var_tEnd;
  partcv[0] = 1;
  Object opresult6175 = callmethod(*var_iEnd, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6175 (depth = 4)
  Object if6172 = done;
  if (istrue(opresult6175)) {
// Begin line 1528
  setline(1528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6176 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6177 == NULL) {
    strlit6177 = alloc_String("}");
    gc_root(strlit6177);
  }
// compiled string node returning strlit6177 (depth = 5)
  gc_frame_newslot(strlit6177);
// starting to compile call node (depth = 5)
  int callframe6178 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_iEnd (depth = 6)
  gc_frame_newslot(*var_iEnd);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tEnd (depth = 6)
  gc_frame_newslot(*var_tEnd);
// call case 5: prelude request
  params[0] = *var_iEnd;
  params[1] = *var_tEnd;
  partcv[0] = 2;
  Object call6179 = callmethodflags(prelude, "max(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6178);
// compiled call node returning call6179 (depth = 5)
  gc_frame_newslot(call6179);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = strlit6177;
  params[1] = call6179;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6180 = callmethodflags(module_ast, "positionOfNext(1)after(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6176);
// compiled call node returning call6180 (depth = 4)
    gc_frame_newslot(call6180);
    if6172 = call6180;
  } else {
// Begin line 1530
  setline(1530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6181 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6182 == NULL) {
    strlit6182 = alloc_String("}");
    gc_root(strlit6182);
  }
// compiled string node returning strlit6182 (depth = 5)
  gc_frame_newslot(strlit6182);
// starting to compile member node (depth = 5)
  int callframe6183 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6184 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6183);
// compiled member node returning call6184 (depth = 5)
  gc_frame_newslot(call6184);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = strlit6182;
  params[1] = call6184;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6185 = callmethodflags(module_ast, "positionOfNext(1)after(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6181);
// compiled call node returning call6185 (depth = 4)
    gc_frame_newslot(call6185);
    if6172 = call6185;
  }
// compiled if node returning if6172 (depth = 3)
  gc_frame_end(frame);
  return if6172;
}
Object meth_ast_6186_description(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "description");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1534
  setline(1534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6188 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6189 = callmethodflags(self, "isTrait", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6188);
// compiled member node returning call6189 (depth = 4)
  Object if6187 = done;
  if (istrue(call6189)) {
// Begin line 1535
  setline(1535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6191 == NULL) {
    strlit6191 = alloc_String(" (trait)");
    gc_root(strlit6191);
  }
// compiled string node returning strlit6191 (depth = 5)
  int op_slot_right_6190 = gc_frame_newslot(strlit6191);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6194 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6195 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6194);
// compiled member node returning call6195 (depth = 6)
  int op_slot_right_6193 = gc_frame_newslot(call6195);
// starting to compile string node (depth = 6)
  if (strlit6197 == NULL) {
    strlit6197 = alloc_String("");
    gc_root(strlit6197);
  }
// compiled string node returning strlit6197 (depth = 6)
  int op_slot_left_6193 = gc_frame_newslot(strlit6197);
  params[0] = call6195;
  partcv[0] = 1;
  Object opresult6198 = callmethod(strlit6197, "++(1)", 1, partcv, params);
// compiled op node returning opresult6198 (depth = 5)
  int op_slot_left_6190 = gc_frame_newslot(opresult6198);
  params[0] = strlit6191;
  partcv[0] = 1;
  Object opresult6199 = callmethod(opresult6198, "++(1)", 1, partcv, params);
// compiled op node returning opresult6199 (depth = 4)
    gc_frame_newslot(opresult6199);
    if6187 = opresult6199;
  } else {
// Begin line 1538
  setline(1538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1536
  setline(1536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe6201 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6202 = callmethodflags(self, "inClass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6201);
// compiled member node returning call6202 (depth = 5)
  Object if6200 = done;
  if (istrue(call6202)) {
// Begin line 1537
  setline(1537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6204 == NULL) {
    strlit6204 = alloc_String(" (class)");
    gc_root(strlit6204);
  }
// compiled string node returning strlit6204 (depth = 6)
  int op_slot_right_6203 = gc_frame_newslot(strlit6204);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6207 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6208 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6207);
// compiled member node returning call6208 (depth = 7)
  int op_slot_right_6206 = gc_frame_newslot(call6208);
// starting to compile string node (depth = 7)
  if (strlit6210 == NULL) {
    strlit6210 = alloc_String("");
    gc_root(strlit6210);
  }
// compiled string node returning strlit6210 (depth = 7)
  int op_slot_left_6206 = gc_frame_newslot(strlit6210);
  params[0] = call6208;
  partcv[0] = 1;
  Object opresult6211 = callmethod(strlit6210, "++(1)", 1, partcv, params);
// compiled op node returning opresult6211 (depth = 6)
  int op_slot_left_6203 = gc_frame_newslot(opresult6211);
  params[0] = strlit6204;
  partcv[0] = 1;
  Object opresult6212 = callmethod(opresult6211, "++(1)", 1, partcv, params);
// compiled op node returning opresult6212 (depth = 5)
    gc_frame_newslot(opresult6212);
    if6200 = opresult6212;
  } else {
// Begin line 1539
  setline(1539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe6213 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6214 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6213);
// compiled member node returning call6214 (depth = 5)
    gc_frame_newslot(call6214);
    if6200 = call6214;
  }
// compiled if node returning if6200 (depth = 4)
    gc_frame_newslot(if6200);
    if6187 = if6200;
  }
// compiled if node returning if6187 (depth = 3)
  gc_frame_end(frame);
  return if6187;
}
Object meth_ast_6215_isFresh(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isFresh");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1542
  setline(1542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6216 = alloc_Boolean(1);
// compiled identifier node returning bool6216 (depth = 3)
  gc_frame_end(frame);
  return bool6216;
}
Object meth_ast_6232__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1550
  setline(1550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6234 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6235 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  partcv[0] = 0;
  Object call6236 = callmethodflags(*var_each, "isLegalInTrait", 1, partcv, params, 0);
  gc_frame_end(callframe6235);
// compiled member node returning call6236 (depth = 7)
  partcv[0] = 0;
  Object call6237 = callmethodflags(call6236, "not", 1, partcv, params, 0);
  gc_frame_end(callframe6234);
// compiled member node returning call6237 (depth = 6)
  Object if6233 = done;
  if (istrue(call6237)) {
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool6238 = alloc_Boolean(0);
// compiled identifier node returning bool6238 (depth = 7)
  block_return(realself, bool6238);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if6233 = undefined;
  } else {
  }
// compiled if node returning if6233 (depth = 5)
  gc_frame_end(frame);
  return if6233;
}
Object meth_ast_6217_isTrait(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1547
  setline(1547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6219 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6220 = callmethodflags(self, "inTrait", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6219);
// compiled member node returning call6220 (depth = 4)
  Object if6218 = done;
  if (istrue(call6220)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool6221 = alloc_Boolean(1);
// compiled identifier node returning bool6221 (depth = 5)
  return bool6221;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if6218 = undefined;
  } else {
  }
// compiled if node returning if6218 (depth = 3)
// Begin line 1548
  setline(1548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6224 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6225 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6224);
// compiled member node returning call6225 (depth = 5)
  int op_slot_right_6223 = gc_frame_newslot(call6225);
// starting to compile identifier node (depth = 5)
  Object bool6227 = alloc_Boolean(0);
// compiled identifier node returning bool6227 (depth = 5)
  int op_slot_left_6223 = gc_frame_newslot(bool6227);
  params[0] = call6225;
  partcv[0] = 1;
  Object opresult6228 = callmethod(bool6227, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6228 (depth = 4)
  Object if6222 = done;
  if (istrue(opresult6228)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool6229 = alloc_Boolean(0);
// compiled identifier node returning bool6229 (depth = 5)
  return bool6229;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if6222 = undefined;
  } else {
  }
// compiled if node returning if6222 (depth = 3)
// Begin line 1549
  setline(1549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6230 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6231 = alloc_Block(NULL, NULL, "ast", 1549);
  gc_frame_newslot(block6231);
// method "_apply(_)"
  block_savedest(block6231);
  Object closure6232 = createclosure(1, "_apply(1)");
  setclosureframe(closure6232, stackframe);
  addtoclosure(closure6232, selfslot);
  struct UserObject *uo6232 = (struct UserObject*)block6231;
  uo6232->data[0] = (Object)closure6232;
  Method *meth_meth_ast_6232__apply_40_1_41_ = addmethod2pos(block6231, "_apply(1)", &meth_ast_6232__apply_40_1_41_, 0);
  int argcv_meth_ast_6232__apply_40_1_41_[] = {1};
  meth_meth_ast_6232__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6232__apply_40_1_41_);
  meth_meth_ast_6232__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6232__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block6231 (depth = 4)
  gc_frame_newslot(block6231);
// call case 6: other requests
// Begin line 1549
  setline(1549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6240 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6241 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6240);
// compiled member node returning call6241 (depth = 4)
  params[0] = block6231;
  partcv[0] = 1;
  Object call6242 = callmethodflags(call6241, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6230);
// compiled call node returning call6242 (depth = 3)
// Begin line 1552
  setline(1552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool6243 = alloc_Boolean(1);
// compiled identifier node returning bool6243 (depth = 4)
  return bool6243;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_6258__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1561
  setline(1561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe6261 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_node (depth = 9)
  partcv[0] = 0;
  Object call6262 = callmethodflags(*var_node, "isMethod", 1, partcv, params, 0);
  gc_frame_end(callframe6261);
// compiled member node returning call6262 (depth = 8)
  int op_slot_right_6260 = gc_frame_newslot(call6262);
// starting to compile member node (depth = 8)
  int callframe6264 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_node (depth = 9)
  partcv[0] = 0;
  Object call6265 = callmethodflags(*var_node, "isFieldDec", 1, partcv, params, 0);
  gc_frame_end(callframe6264);
// compiled member node returning call6265 (depth = 8)
  int op_slot_left_6260 = gc_frame_newslot(call6265);
  params[0] = call6262;
  partcv[0] = 1;
  Object opresult6266 = callmethod(call6265, "||(1)", 1, partcv, params);
// compiled op node returning opresult6266 (depth = 7)
  Object if6259 = done;
  if (istrue(opresult6266)) {
// Begin line 1562
  setline(1562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6267 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe6268 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_node (depth = 9)
  partcv[0] = 0;
  Object call6269 = callmethodflags(*var_node, "nameString", 1, partcv, params, 0);
  gc_frame_end(callframe6268);
// compiled member node returning call6269 (depth = 8)
  gc_frame_newslot(call6269);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe6270 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6271 = callmethodflags(self, "myLocalNames", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6270);
// compiled member node returning call6271 (depth = 8)
  params[0] = call6269;
  partcv[0] = 1;
  Object call6272 = callmethodflags(call6271, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6267);
// compiled call node returning call6272 (depth = 7)
    gc_frame_newslot(call6272);
    if6259 = call6272;
  } else {
  }
// compiled if node returning if6259 (depth = 6)
  gc_frame_end(frame);
  return if6259;
}
Object meth_ast_6244_localNames(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "localNames");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1558
  setline(1558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6247 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6248 = callmethodflags(self, "myLocalNames", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6247);
// compiled member node returning call6248 (depth = 5)
  int op_slot_right_6246 = gc_frame_newslot(call6248);
// starting to compile identifier node (depth = 5)
  Object bool6250 = alloc_Boolean(0);
// compiled identifier node returning bool6250 (depth = 5)
  int op_slot_left_6246 = gc_frame_newslot(bool6250);
  params[0] = call6248;
  partcv[0] = 1;
  Object opresult6251 = callmethod(bool6250, "==(1)", 1, partcv, params);
// compiled op node returning opresult6251 (depth = 4)
  Object if6245 = done;
  if (istrue(opresult6251)) {
// Begin line 1559
  setline(1559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6252 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6253 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call6254 = callmethodflags(prelude, "emptySet", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6253);
// compiled member node returning call6254 (depth = 5)
  gc_frame_newslot(call6254);
// call case 4: self request
  params[0] = call6254;
  partcv[0] = 1;
  Object call6255 = callmethodflags(self, "myLocalNames:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6252);
// compiled call node returning call6255 (depth = 4)
// Begin line 1560
  setline(1560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6256 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6257 = alloc_Block(NULL, NULL, "ast", 1560);
  gc_frame_newslot(block6257);
// method "_apply(_)"
  block_savedest(block6257);
  Object closure6258 = createclosure(1, "_apply(1)");
  setclosureframe(closure6258, stackframe);
  addtoclosure(closure6258, selfslot);
  struct UserObject *uo6258 = (struct UserObject*)block6257;
  uo6258->data[0] = (Object)closure6258;
  Method *meth_meth_ast_6258__apply_40_1_41_ = addmethod2pos(block6257, "_apply(1)", &meth_ast_6258__apply_40_1_41_, 0);
  int argcv_meth_ast_6258__apply_40_1_41_[] = {1};
  meth_meth_ast_6258__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6258__apply_40_1_41_);
  meth_meth_ast_6258__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6258__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block6257 (depth = 5)
  gc_frame_newslot(block6257);
// call case 6: other requests
// Begin line 1560
  setline(1560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe6274 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6275 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6274);
// compiled member node returning call6275 (depth = 5)
  params[0] = block6257;
  partcv[0] = 1;
  Object call6276 = callmethodflags(call6275, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6256);
// compiled call node returning call6276 (depth = 4)
    gc_frame_newslot(call6276);
    if6245 = call6276;
  } else {
  }
// compiled if node returning if6245 (depth = 3)
// Begin line 1566
  setline(1566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6277 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6278 = callmethodflags(self, "myLocalNames", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6277);
// compiled member node returning call6278 (depth = 3)
  gc_frame_end(frame);
  return call6278;
}
Object meth_ast_6293__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 5)
  int callframe6294 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_action (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call6295 = callmethodflags(*var_action, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6294);
// compiled call node returning call6295 (depth = 5)
  gc_frame_end(frame);
  return call6295;
}
Object meth_ast_6279_parentsDo_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parentsDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parentsDo(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parentsDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parentsDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1572
  setline(1572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6282 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6283 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6282);
// compiled member node returning call6283 (depth = 5)
  int op_slot_right_6281 = gc_frame_newslot(call6283);
// starting to compile identifier node (depth = 5)
  Object bool6285 = alloc_Boolean(0);
// compiled identifier node returning bool6285 (depth = 5)
  int op_slot_left_6281 = gc_frame_newslot(bool6285);
  params[0] = call6283;
  partcv[0] = 1;
  Object opresult6286 = callmethod(bool6285, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6286 (depth = 4)
  Object if6280 = done;
  if (istrue(opresult6286)) {
// starting to compile call node (depth = 4)
  int callframe6287 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6288 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6289 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6288);
// compiled member node returning call6289 (depth = 5)
  gc_frame_newslot(call6289);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_action (depth = 5)
  params[0] = call6289;
  partcv[0] = 1;
  Object call6290 = callmethodflags(*var_action, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6287);
// compiled call node returning call6290 (depth = 4)
    gc_frame_newslot(call6290);
    if6280 = call6290;
  } else {
  }
// compiled if node returning if6280 (depth = 3)
// Begin line 1573
  setline(1573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6291 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6292 = alloc_Block(NULL, NULL, "ast", 1573);
  gc_frame_newslot(block6292);
// method "_apply(_)"
  block_savedest(block6292);
  Object closure6293 = createclosure(2, "_apply(1)");
  setclosureframe(closure6293, stackframe);
  addtoclosure(closure6293, var_action);
  addtoclosure(closure6293, selfslot);
  struct UserObject *uo6293 = (struct UserObject*)block6292;
  uo6293->data[0] = (Object)closure6293;
  Method *meth_meth_ast_6293__apply_40_1_41_ = addmethod2pos(block6292, "_apply(1)", &meth_ast_6293__apply_40_1_41_, 0);
  int argcv_meth_ast_6293__apply_40_1_41_[] = {1};
  meth_meth_ast_6293__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6293__apply_40_1_41_);
  meth_meth_ast_6293__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6293__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block6292 (depth = 4)
  gc_frame_newslot(block6292);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6297 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6298 = callmethodflags(self, "usedTraits", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6297);
// compiled member node returning call6298 (depth = 4)
  params[0] = block6292;
  partcv[0] = 1;
  Object call6299 = callmethodflags(call6298, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6291);
// compiled call node returning call6299 (depth = 3)
  gc_frame_end(frame);
  return call6299;
}
Object meth_ast_6303__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1580
  setline(1580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6305 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  partcv[0] = 0;
  Object call6306 = callmethodflags(*var_o, "isMethod", 1, partcv, params, 0);
  gc_frame_end(callframe6305);
// compiled member node returning call6306 (depth = 6)
  Object if6304 = done;
  if (istrue(call6306)) {
// starting to compile call node (depth = 6)
  int callframe6307 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_action (depth = 7)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call6308 = callmethodflags(*var_action, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6307);
// compiled call node returning call6308 (depth = 6)
    gc_frame_newslot(call6308);
    if6304 = call6308;
  } else {
  }
// compiled if node returning if6304 (depth = 5)
  gc_frame_end(frame);
  return if6304;
}
Object meth_ast_6300_methodsDo_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "methodsDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method methodsDo(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for methodsDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part methodsDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1579
  setline(1579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6301 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6302 = alloc_Block(NULL, NULL, "ast", 1579);
  gc_frame_newslot(block6302);
// method "_apply(_)"
  block_savedest(block6302);
  Object closure6303 = createclosure(2, "_apply(1)");
  setclosureframe(closure6303, stackframe);
  addtoclosure(closure6303, var_action);
  addtoclosure(closure6303, selfslot);
  struct UserObject *uo6303 = (struct UserObject*)block6302;
  uo6303->data[0] = (Object)closure6303;
  Method *meth_meth_ast_6303__apply_40_1_41_ = addmethod2pos(block6302, "_apply(1)", &meth_ast_6303__apply_40_1_41_, 0);
  int argcv_meth_ast_6303__apply_40_1_41_[] = {1};
  meth_meth_ast_6303__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6303__apply_40_1_41_);
  meth_meth_ast_6303__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6303__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block6302 (depth = 4)
  gc_frame_newslot(block6302);
// call case 6: other requests
// Begin line 1579
  setline(1579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6310 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6311 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6310);
// compiled member node returning call6311 (depth = 4)
  params[0] = block6302;
  partcv[0] = 1;
  Object call6312 = callmethodflags(call6311, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6301);
// compiled call node returning call6312 (depth = 3)
  gc_frame_end(frame);
  return call6312;
}
Object meth_ast_6316__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1588
  setline(1588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6318 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  partcv[0] = 0;
  Object call6319 = callmethodflags(*var_o, "isExecutable", 1, partcv, params, 0);
  gc_frame_end(callframe6318);
// compiled member node returning call6319 (depth = 6)
  Object if6317 = done;
  if (istrue(call6319)) {
// starting to compile call node (depth = 6)
  int callframe6320 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_action (depth = 7)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call6321 = callmethodflags(*var_action, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6320);
// compiled call node returning call6321 (depth = 6)
    gc_frame_newslot(call6321);
    if6317 = call6321;
  } else {
  }
// compiled if node returning if6317 (depth = 5)
  gc_frame_end(frame);
  return if6317;
}
Object meth_ast_6313_executableComponentsDo_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "executableComponentsDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method executableComponentsDo(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for executableComponentsDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part executableComponentsDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1587
  setline(1587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6314 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6315 = alloc_Block(NULL, NULL, "ast", 1587);
  gc_frame_newslot(block6315);
// method "_apply(_)"
  block_savedest(block6315);
  Object closure6316 = createclosure(2, "_apply(1)");
  setclosureframe(closure6316, stackframe);
  addtoclosure(closure6316, var_action);
  addtoclosure(closure6316, selfslot);
  struct UserObject *uo6316 = (struct UserObject*)block6315;
  uo6316->data[0] = (Object)closure6316;
  Method *meth_meth_ast_6316__apply_40_1_41_ = addmethod2pos(block6315, "_apply(1)", &meth_ast_6316__apply_40_1_41_, 0);
  int argcv_meth_ast_6316__apply_40_1_41_[] = {1};
  meth_meth_ast_6316__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6316__apply_40_1_41_);
  meth_meth_ast_6316__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6316__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block6315 (depth = 4)
  gc_frame_newslot(block6315);
// call case 6: other requests
// Begin line 1587
  setline(1587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6323 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6324 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6323);
// compiled member node returning call6324 (depth = 4)
  params[0] = block6315;
  partcv[0] = 1;
  Object call6325 = callmethodflags(call6324, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6314);
// compiled call node returning call6325 (depth = 3)
  gc_frame_end(frame);
  return call6325;
}
Object meth_ast_6326_scope_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1595
  setline(1595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6327 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call6328 = callmethodflags(self, "symbolTable:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6327);
// compiled call node returning call6328 (depth = 3)
// Begin line 1596
  setline(1596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6329 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6330 = callmethodflags(*var_st, "node:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6329);
// compiled call node returning call6330 (depth = 3)
  gc_frame_end(frame);
  return call6330;
}
Object meth_ast_6331_body(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "body");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1598
  setline(1598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6332 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6333 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6332);
// compiled member node returning call6333 (depth = 3)
  gc_frame_end(frame);
  return call6333;
}
Object meth_ast_6334_returnsObject(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1599
  setline(1599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6335 = alloc_Boolean(1);
// compiled identifier node returning bool6335 (depth = 3)
  gc_frame_end(frame);
  return bool6335;
}
Object meth_ast_6336_returnedObjectScope(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1600
  setline(1600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6337 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6338 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6337);
// compiled member node returning call6338 (depth = 3)
  gc_frame_end(frame);
  return call6338;
}
Object meth_ast_6339_canInherit(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canInherit");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1601
  setline(1601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6340 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6341 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6342 = callmethodflags(self, "inTrait", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6341);
// compiled member node returning call6342 (depth = 4)
  partcv[0] = 0;
  Object call6343 = callmethodflags(call6342, "not", 1, partcv, params, 0);
  gc_frame_end(callframe6340);
// compiled member node returning call6343 (depth = 3)
  gc_frame_end(frame);
  return call6343;
}
Object meth_ast_6344_canUse(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canUse");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1602
  setline(1602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6345 = alloc_Boolean(1);
// compiled identifier node returning bool6345 (depth = 3)
  gc_frame_end(frame);
  return bool6345;
}
Object meth_ast_6346_isObject(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1603
  setline(1603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6347 = alloc_Boolean(1);
// compiled identifier node returning bool6347 (depth = 3)
  gc_frame_end(frame);
  return bool6347;
}
Object meth_ast_6367__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 6)
  int callframe6368 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6369 = callmethodflags(*var_t, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6368);
// compiled call node returning call6369 (depth = 6)
  gc_frame_end(frame);
  return call6369;
}
Object meth_ast_6376__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 6)
  int callframe6377 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_x (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6378 = callmethodflags(*var_x, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6377);
// compiled call node returning call6378 (depth = 6)
  gc_frame_end(frame);
  return call6378;
}
Object meth_ast_6348_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// definebindings:
// definebindings:
// definebindings:
// Begin line 1605
  setline(1605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6350 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6351 = callmethodflags(*var_visitor, "visitObject(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6350);
// compiled call node returning call6351 (depth = 4)
  Object if6349 = done;
  if (istrue(call6351)) {
// Begin line 1606
  setline(1606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6352 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call6353 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6352);
// compiled call node returning call6353 (depth = 5)
  *var_newChain = call6353;
  if (call6353 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1607
  setline(1607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6356 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6357 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6356);
// compiled member node returning call6357 (depth = 6)
  int op_slot_right_6355 = gc_frame_newslot(call6357);
// starting to compile identifier node (depth = 6)
  Object bool6359 = alloc_Boolean(0);
// compiled identifier node returning bool6359 (depth = 6)
  int op_slot_left_6355 = gc_frame_newslot(bool6359);
  params[0] = call6357;
  partcv[0] = 1;
  Object opresult6360 = callmethod(bool6359, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6360 (depth = 5)
  Object if6354 = done;
  if (istrue(opresult6360)) {
// Begin line 1608
  setline(1608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6361 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6362 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6363 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6362);
// compiled member node returning call6363 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6364 = callmethodflags(call6363, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6361);
// compiled call node returning call6364 (depth = 5)
    gc_frame_newslot(call6364);
    if6354 = call6364;
  } else {
  }
// compiled if node returning if6354 (depth = 4)
// Begin line 1610
  setline(1610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6365 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6366 = alloc_Block(NULL, NULL, "ast", 1610);
  gc_frame_newslot(block6366);
// method "_apply(_)"
  block_savedest(block6366);
  Object closure6367 = createclosure(3, "_apply(1)");
  setclosureframe(closure6367, stackframe);
  addtoclosure(closure6367, var_visitor);
  addtoclosure(closure6367, var_newChain);
  addtoclosure(closure6367, selfslot);
  struct UserObject *uo6367 = (struct UserObject*)block6366;
  uo6367->data[0] = (Object)closure6367;
  Method *meth_meth_ast_6367__apply_40_1_41_ = addmethod2pos(block6366, "_apply(1)", &meth_ast_6367__apply_40_1_41_, 0);
  int argcv_meth_ast_6367__apply_40_1_41_[] = {1};
  meth_meth_ast_6367__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6367__apply_40_1_41_);
  meth_meth_ast_6367__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6367__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block6366 (depth = 5)
  gc_frame_newslot(block6366);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6371 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6372 = callmethodflags(self, "usedTraits", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6371);
// compiled member node returning call6372 (depth = 5)
  params[0] = block6366;
  partcv[0] = 1;
  Object call6373 = callmethodflags(call6372, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6365);
// compiled call node returning call6373 (depth = 4)
// Begin line 1611
  setline(1611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6374 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6375 = alloc_Block(NULL, NULL, "ast", 1611);
  gc_frame_newslot(block6375);
// method "_apply(_)"
  block_savedest(block6375);
  Object closure6376 = createclosure(3, "_apply(1)");
  setclosureframe(closure6376, stackframe);
  addtoclosure(closure6376, var_visitor);
  addtoclosure(closure6376, var_newChain);
  addtoclosure(closure6376, selfslot);
  struct UserObject *uo6376 = (struct UserObject*)block6375;
  uo6376->data[0] = (Object)closure6376;
  Method *meth_meth_ast_6376__apply_40_1_41_ = addmethod2pos(block6375, "_apply(1)", &meth_ast_6376__apply_40_1_41_, 0);
  int argcv_meth_ast_6376__apply_40_1_41_[] = {1};
  meth_meth_ast_6376__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6376__apply_40_1_41_);
  meth_meth_ast_6376__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6376__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block6375 (depth = 5)
  gc_frame_newslot(block6375);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6380 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6381 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6380);
// compiled member node returning call6381 (depth = 5)
  params[0] = block6375;
  partcv[0] = 1;
  Object call6382 = callmethodflags(call6381, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6374);
// compiled call node returning call6382 (depth = 4)
    gc_frame_newslot(call6382);
    if6349 = call6382;
  } else {
  }
// compiled if node returning if6349 (depth = 3)
  gc_frame_end(frame);
  return if6349;
}
Object meth_ast_6383_nameString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1615
  setline(1615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6386 == NULL) {
    strlit6386 = alloc_String("object");
    gc_root(strlit6386);
  }
// compiled string node returning strlit6386 (depth = 5)
  int op_slot_right_6385 = gc_frame_newslot(strlit6386);
// starting to compile member node (depth = 5)
  int callframe6388 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6389 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6388);
// compiled member node returning call6389 (depth = 5)
  int op_slot_left_6385 = gc_frame_newslot(call6389);
  params[0] = strlit6386;
  partcv[0] = 1;
  Object opresult6390 = callmethod(call6389, "==(1)", 1, partcv, params);
// compiled op node returning opresult6390 (depth = 4)
  Object if6384 = done;
  if (istrue(opresult6390)) {
// Begin line 1616
  setline(1616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6392 == NULL) {
    strlit6392 = alloc_String("");
    gc_root(strlit6392);
  }
// compiled string node returning strlit6392 (depth = 5)
  int op_slot_right_6391 = gc_frame_newslot(strlit6392);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6395 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6396 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6395);
// compiled member node returning call6396 (depth = 6)
  int op_slot_right_6394 = gc_frame_newslot(call6396);
// starting to compile string node (depth = 6)
  if (strlit6398 == NULL) {
    strlit6398 = alloc_String("object_on_line_");
    gc_root(strlit6398);
  }
// compiled string node returning strlit6398 (depth = 6)
  int op_slot_left_6394 = gc_frame_newslot(strlit6398);
  params[0] = call6396;
  partcv[0] = 1;
  Object opresult6399 = callmethod(strlit6398, "++(1)", 1, partcv, params);
// compiled op node returning opresult6399 (depth = 5)
  int op_slot_left_6391 = gc_frame_newslot(opresult6399);
  params[0] = strlit6392;
  partcv[0] = 1;
  Object opresult6400 = callmethod(opresult6399, "++(1)", 1, partcv, params);
// compiled op node returning opresult6400 (depth = 4)
    gc_frame_newslot(opresult6400);
    if6384 = opresult6400;
  } else {
// Begin line 1618
  setline(1618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6401 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6402 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6401);
// compiled member node returning call6402 (depth = 4)
    gc_frame_newslot(call6402);
    if6384 = call6402;
  }
// compiled if node returning if6384 (depth = 3)
  gc_frame_end(frame);
  return if6384;
}
Object meth_ast_6403_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1622
  setline(1622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6404 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6405 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6404);
// compiled member node returning call6405 (depth = 4)
  *var_n = call6405;
  if (call6405 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1623
  setline(1623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6406 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6407 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6406);
// compiled call node returning call6407 (depth = 4)
  *var_newChain = call6407;
  if (call6407 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1624
  setline(1624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6408 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6409 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6410 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6411 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6410);
// compiled member node returning call6411 (depth = 5)
  gc_frame_newslot(call6411);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call6411;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6412 = callmethodflags(module_ast, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6409);
// compiled call node returning call6412 (depth = 4)
  gc_frame_newslot(call6412);
// call case 6: other requests
// Begin line 1624
  setline(1624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6412;
  partcv[0] = 1;
  Object call6413 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6408);
// compiled call node returning call6413 (depth = 3)
// Begin line 1625
  setline(1625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6414 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6415 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6416 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6417 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6416);
// compiled member node returning call6417 (depth = 5)
  gc_frame_newslot(call6417);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call6417;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6418 = callmethodflags(module_ast, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6415);
// compiled call node returning call6418 (depth = 4)
  gc_frame_newslot(call6418);
// call case 6: other requests
// Begin line 1625
  setline(1625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6418;
  partcv[0] = 1;
  Object call6419 = callmethodflags(*var_n, "superclass:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6414);
// compiled call node returning call6419 (depth = 3)
// Begin line 1626
  setline(1626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6420 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6421 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6422 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6423 = callmethodflags(self, "usedTraits", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6422);
// compiled member node returning call6423 (depth = 5)
  gc_frame_newslot(call6423);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call6423;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6424 = callmethodflags(module_ast, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6421);
// compiled call node returning call6424 (depth = 4)
  gc_frame_newslot(call6424);
// call case 6: other requests
// Begin line 1626
  setline(1626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6424;
  partcv[0] = 1;
  Object call6425 = callmethodflags(*var_n, "usedTraits:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6420);
// compiled call node returning call6425 (depth = 3)
// Begin line 1627
  setline(1627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6426 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call6427 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6426);
// compiled call node returning call6427 (depth = 3)
  gc_frame_end(frame);
  return call6427;
}
Object meth_ast_6515__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1641
  setline(1641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6517 == NULL) {
    strlit6517 = alloc_String("");
    gc_root(strlit6517);
  }
// compiled string node returning strlit6517 (depth = 8)
  int op_slot_right_6516 = gc_frame_newslot(strlit6517);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6520 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num6522 = alloc_Float64(1);
// compiled num node returning num6522 (depth = 11)
  int op_slot_right_6521 = gc_frame_newslot(num6522);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_6521 = gc_frame_newslot(*var_depth);
  params[0] = num6522;
  partcv[0] = 1;
  Object sum6524 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum6524 (depth = 10)
  gc_frame_newslot(sum6524);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  params[0] = sum6524;
  partcv[0] = 1;
  Object call6525 = callmethodflags(*var_t, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6520);
// compiled call node returning call6525 (depth = 9)
  int op_slot_right_6519 = gc_frame_newslot(call6525);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6528 == NULL) {
    strlit6528 = alloc_String("  ");
    gc_root(strlit6528);
  }
// compiled string node returning strlit6528 (depth = 10)
  int op_slot_right_6527 = gc_frame_newslot(strlit6528);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_6530 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit6533 == NULL) {
    strlit6533 = alloc_String("""\x0a""");
    gc_root(strlit6533);
  }
// compiled string node returning strlit6533 (depth = 12)
  int op_slot_right_6532 = gc_frame_newslot(strlit6533);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_6535 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit6537 == NULL) {
    strlit6537 = alloc_String("");
    gc_root(strlit6537);
  }
// compiled string node returning strlit6537 (depth = 13)
  int op_slot_left_6535 = gc_frame_newslot(strlit6537);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult6538 = callmethod(strlit6537, "++(1)", 1, partcv, params);
// compiled op node returning opresult6538 (depth = 12)
  int op_slot_left_6532 = gc_frame_newslot(opresult6538);
  params[0] = strlit6533;
  partcv[0] = 1;
  Object opresult6539 = callmethod(opresult6538, "++(1)", 1, partcv, params);
// compiled op node returning opresult6539 (depth = 11)
  int op_slot_left_6530 = gc_frame_newslot(opresult6539);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6540 = callmethod(opresult6539, "++(1)", 1, partcv, params);
// compiled op node returning opresult6540 (depth = 10)
  int op_slot_left_6527 = gc_frame_newslot(opresult6540);
  params[0] = strlit6528;
  partcv[0] = 1;
  Object opresult6541 = callmethod(opresult6540, "++(1)", 1, partcv, params);
// compiled op node returning opresult6541 (depth = 9)
  int op_slot_left_6519 = gc_frame_newslot(opresult6541);
  params[0] = call6525;
  partcv[0] = 1;
  Object opresult6542 = callmethod(opresult6541, "++(1)", 1, partcv, params);
// compiled op node returning opresult6542 (depth = 8)
  int op_slot_left_6516 = gc_frame_newslot(opresult6542);
  params[0] = strlit6517;
  partcv[0] = 1;
  Object opresult6543 = callmethod(opresult6542, "++(1)", 1, partcv, params);
// compiled op node returning opresult6543 (depth = 7)
  *var_s = opresult6543;
  if (opresult6543 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_6551__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1645
  setline(1645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6553 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6555 = alloc_Float64(1);
// compiled num node returning num6555 (depth = 9)
  int op_slot_right_6554 = gc_frame_newslot(num6555);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_6554 = gc_frame_newslot(*var_depth);
  params[0] = num6555;
  partcv[0] = 1;
  Object sum6557 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum6557 (depth = 8)
  gc_frame_newslot(sum6557);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_x (depth = 8)
  params[0] = sum6557;
  partcv[0] = 1;
  Object call6558 = callmethodflags(*var_x, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6553);
// compiled call node returning call6558 (depth = 7)
  int op_slot_right_6552 = gc_frame_newslot(call6558);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_6560 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6563 == NULL) {
    strlit6563 = alloc_String("""\x0a""");
    gc_root(strlit6563);
  }
// compiled string node returning strlit6563 (depth = 9)
  int op_slot_right_6562 = gc_frame_newslot(strlit6563);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_6562 = gc_frame_newslot(*var_s);
  params[0] = strlit6563;
  partcv[0] = 1;
  Object opresult6565 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6565 (depth = 8)
  int op_slot_left_6560 = gc_frame_newslot(opresult6565);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6566 = callmethod(opresult6565, "++(1)", 1, partcv, params);
// compiled op node returning opresult6566 (depth = 7)
  int op_slot_left_6552 = gc_frame_newslot(opresult6566);
  params[0] = call6558;
  partcv[0] = 1;
  Object opresult6567 = callmethod(opresult6566, "++(1)", 1, partcv, params);
// compiled op node returning opresult6567 (depth = 6)
  *var_s = opresult6567;
  if (opresult6567 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_6428_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth_39_ = &(stackframe->slots[0]);
  *var_depth_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_depth = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "depth");
  Object *var_spc = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "spc");
  Object *var_s = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "s");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1630
  setline(1630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth_39_ (depth = 4)
  *var_depth = *var_depth_39_;
  if (*var_depth_39_ == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1631
  setline(1631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num6431 = alloc_Float64(1);
// compiled num node returning num6431 (depth = 6)
  int op_slot_right_6430 = gc_frame_newslot(num6431);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_6430 = gc_frame_newslot(*var_depth);
  params[0] = num6431;
  partcv[0] = 1;
  Object sum6433 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum6433 (depth = 5)
  int op_slot_right_6429 = gc_frame_newslot(sum6433);
// starting to compile string node (depth = 5)
  if (strlit6435 == NULL) {
    strlit6435 = alloc_String("  ");
    gc_root(strlit6435);
  }
// compiled string node returning strlit6435 (depth = 5)
  int op_slot_left_6429 = gc_frame_newslot(strlit6435);
  params[0] = sum6433;
  partcv[0] = 1;
  Object prod6436 = callmethod(strlit6435, "*(1)", 1, partcv, params);
// compiled op node returning prod6436 (depth = 4)
  *var_spc = prod6436;
  if (prod6436 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1632
  setline(1632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6437 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6438 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6437);
// compiled call node returning call6438 (depth = 4)
  *var_s = call6438;
  if (call6438 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1633
  setline(1633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6440 == NULL) {
    strlit6440 = alloc_String("");
    gc_root(strlit6440);
  }
// compiled string node returning strlit6440 (depth = 5)
  int op_slot_right_6439 = gc_frame_newslot(strlit6440);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6443 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6444 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6443);
// compiled member node returning call6444 (depth = 6)
  int op_slot_right_6442 = gc_frame_newslot(call6444);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6447 == NULL) {
    strlit6447 = alloc_String("Name: ");
    gc_root(strlit6447);
  }
// compiled string node returning strlit6447 (depth = 7)
  int op_slot_right_6446 = gc_frame_newslot(strlit6447);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_6449 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6452 == NULL) {
    strlit6452 = alloc_String("""\x0a""");
    gc_root(strlit6452);
  }
// compiled string node returning strlit6452 (depth = 9)
  int op_slot_right_6451 = gc_frame_newslot(strlit6452);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_6454 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit6456 == NULL) {
    strlit6456 = alloc_String("");
    gc_root(strlit6456);
  }
// compiled string node returning strlit6456 (depth = 10)
  int op_slot_left_6454 = gc_frame_newslot(strlit6456);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult6457 = callmethod(strlit6456, "++(1)", 1, partcv, params);
// compiled op node returning opresult6457 (depth = 9)
  int op_slot_left_6451 = gc_frame_newslot(opresult6457);
  params[0] = strlit6452;
  partcv[0] = 1;
  Object opresult6458 = callmethod(opresult6457, "++(1)", 1, partcv, params);
// compiled op node returning opresult6458 (depth = 8)
  int op_slot_left_6449 = gc_frame_newslot(opresult6458);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6459 = callmethod(opresult6458, "++(1)", 1, partcv, params);
// compiled op node returning opresult6459 (depth = 7)
  int op_slot_left_6446 = gc_frame_newslot(opresult6459);
  params[0] = strlit6447;
  partcv[0] = 1;
  Object opresult6460 = callmethod(opresult6459, "++(1)", 1, partcv, params);
// compiled op node returning opresult6460 (depth = 6)
  int op_slot_left_6442 = gc_frame_newslot(opresult6460);
  params[0] = call6444;
  partcv[0] = 1;
  Object opresult6461 = callmethod(opresult6460, "++(1)", 1, partcv, params);
// compiled op node returning opresult6461 (depth = 5)
  int op_slot_left_6439 = gc_frame_newslot(opresult6461);
  params[0] = strlit6440;
  partcv[0] = 1;
  Object opresult6462 = callmethod(opresult6461, "++(1)", 1, partcv, params);
// compiled op node returning opresult6462 (depth = 4)
  *var_s = opresult6462;
  if (opresult6462 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1634
  setline(1634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6466 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6467 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6466);
// compiled member node returning call6467 (depth = 5)
  int op_slot_right_6465 = gc_frame_newslot(call6467);
// starting to compile identifier node (depth = 5)
  Object bool6469 = alloc_Boolean(0);
// compiled identifier node returning bool6469 (depth = 5)
  int op_slot_left_6465 = gc_frame_newslot(bool6469);
  params[0] = call6467;
  partcv[0] = 1;
  Object opresult6470 = callmethod(bool6469, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6470 (depth = 4)
  Object if6464 = done;
  if (istrue(opresult6470)) {
// Begin line 1635
  setline(1635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1636
  setline(1636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6472 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num6474 = alloc_Float64(1);
// compiled num node returning num6474 (depth = 8)
  int op_slot_right_6473 = gc_frame_newslot(num6474);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_6473 = gc_frame_newslot(*var_depth);
  params[0] = num6474;
  partcv[0] = 1;
  Object sum6476 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum6476 (depth = 7)
  gc_frame_newslot(sum6476);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6477 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6478 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6477);
// compiled member node returning call6478 (depth = 7)
  params[0] = sum6476;
  partcv[0] = 1;
  Object call6479 = callmethodflags(call6478, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6472);
// compiled call node returning call6479 (depth = 6)
  int op_slot_right_6471 = gc_frame_newslot(call6479);
// Begin line 1635
  setline(1635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6482 == NULL) {
    strlit6482 = alloc_String("Superclass: ");
    gc_root(strlit6482);
  }
// compiled string node returning strlit6482 (depth = 7)
  int op_slot_right_6481 = gc_frame_newslot(strlit6482);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_6484 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6487 == NULL) {
    strlit6487 = alloc_String("""\x0a""");
    gc_root(strlit6487);
  }
// compiled string node returning strlit6487 (depth = 9)
  int op_slot_right_6486 = gc_frame_newslot(strlit6487);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_6486 = gc_frame_newslot(*var_s);
  params[0] = strlit6487;
  partcv[0] = 1;
  Object opresult6489 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6489 (depth = 8)
  int op_slot_left_6484 = gc_frame_newslot(opresult6489);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6490 = callmethod(opresult6489, "++(1)", 1, partcv, params);
// compiled op node returning opresult6490 (depth = 7)
  int op_slot_left_6481 = gc_frame_newslot(opresult6490);
  params[0] = strlit6482;
  partcv[0] = 1;
  Object opresult6491 = callmethod(opresult6490, "++(1)", 1, partcv, params);
// compiled op node returning opresult6491 (depth = 6)
  int op_slot_left_6471 = gc_frame_newslot(opresult6491);
  params[0] = call6479;
  partcv[0] = 1;
  Object opresult6492 = callmethod(opresult6491, "++(1)", 1, partcv, params);
// compiled op node returning opresult6492 (depth = 5)
  *var_s = opresult6492;
  if (opresult6492 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6464 = done;
  } else {
  }
// compiled if node returning if6464 (depth = 3)
// Begin line 1638
  setline(1638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6495 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6496 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6497 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6498 = callmethodflags(self, "usedTraits", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6497);
// compiled member node returning call6498 (depth = 6)
  partcv[0] = 0;
  Object call6499 = callmethodflags(call6498, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe6496);
// compiled member node returning call6499 (depth = 5)
  partcv[0] = 0;
  Object call6500 = callmethodflags(call6499, "not", 1, partcv, params, 0);
  gc_frame_end(callframe6495);
// compiled member node returning call6500 (depth = 4)
  Object if6494 = done;
  if (istrue(call6500)) {
// Begin line 1639
  setline(1639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6502 == NULL) {
    strlit6502 = alloc_String("Traits:");
    gc_root(strlit6502);
  }
// compiled string node returning strlit6502 (depth = 6)
  int op_slot_right_6501 = gc_frame_newslot(strlit6502);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_6504 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6507 == NULL) {
    strlit6507 = alloc_String("""\x0a""");
    gc_root(strlit6507);
  }
// compiled string node returning strlit6507 (depth = 8)
  int op_slot_right_6506 = gc_frame_newslot(strlit6507);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6506 = gc_frame_newslot(*var_s);
  params[0] = strlit6507;
  partcv[0] = 1;
  Object opresult6509 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6509 (depth = 7)
  int op_slot_left_6504 = gc_frame_newslot(opresult6509);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6510 = callmethod(opresult6509, "++(1)", 1, partcv, params);
// compiled op node returning opresult6510 (depth = 6)
  int op_slot_left_6501 = gc_frame_newslot(opresult6510);
  params[0] = strlit6502;
  partcv[0] = 1;
  Object opresult6511 = callmethod(opresult6510, "++(1)", 1, partcv, params);
// compiled op node returning opresult6511 (depth = 5)
  *var_s = opresult6511;
  if (opresult6511 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1640
  setline(1640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6513 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6514 = alloc_Block(NULL, NULL, "ast", 1640);
  gc_frame_newslot(block6514);
// method "_apply(_)"
  block_savedest(block6514);
  Object closure6515 = createclosure(4, "_apply(1)");
  setclosureframe(closure6515, stackframe);
  addtoclosure(closure6515, var_depth);
  addtoclosure(closure6515, var_spc);
  addtoclosure(closure6515, var_s);
  addtoclosure(closure6515, selfslot);
  struct UserObject *uo6515 = (struct UserObject*)block6514;
  uo6515->data[0] = (Object)closure6515;
  Method *meth_meth_ast_6515__apply_40_1_41_ = addmethod2pos(block6514, "_apply(1)", &meth_ast_6515__apply_40_1_41_, 0);
  int argcv_meth_ast_6515__apply_40_1_41_[] = {1};
  meth_meth_ast_6515__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6515__apply_40_1_41_);
  meth_meth_ast_6515__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6515__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block6514 (depth = 5)
  gc_frame_newslot(block6514);
// call case 6: other requests
// Begin line 1640
  setline(1640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe6546 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6547 = callmethodflags(self, "usedTraits", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6546);
// compiled member node returning call6547 (depth = 5)
  params[0] = block6514;
  partcv[0] = 1;
  Object call6548 = callmethodflags(call6547, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6513);
// compiled call node returning call6548 (depth = 4)
    gc_frame_newslot(call6548);
    if6494 = call6548;
  } else {
  }
// compiled if node returning if6494 (depth = 3)
// Begin line 1644
  setline(1644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6549 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6550 = alloc_Block(NULL, NULL, "ast", 1644);
  gc_frame_newslot(block6550);
// method "_apply(_)"
  block_savedest(block6550);
  Object closure6551 = createclosure(4, "_apply(1)");
  setclosureframe(closure6551, stackframe);
  addtoclosure(closure6551, var_depth);
  addtoclosure(closure6551, var_spc);
  addtoclosure(closure6551, var_s);
  addtoclosure(closure6551, selfslot);
  struct UserObject *uo6551 = (struct UserObject*)block6550;
  uo6551->data[0] = (Object)closure6551;
  Method *meth_meth_ast_6551__apply_40_1_41_ = addmethod2pos(block6550, "_apply(1)", &meth_ast_6551__apply_40_1_41_, 0);
  int argcv_meth_ast_6551__apply_40_1_41_[] = {1};
  meth_meth_ast_6551__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6551__apply_40_1_41_);
  meth_meth_ast_6551__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6551__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block6550 (depth = 4)
  gc_frame_newslot(block6550);
// call case 6: other requests
// Begin line 1644
  setline(1644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6570 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6571 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6570);
// compiled member node returning call6571 (depth = 4)
  params[0] = block6550;
  partcv[0] = 1;
  Object call6572 = callmethodflags(call6571, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6549);
// compiled call node returning call6572 (depth = 3)
// Begin line 1647
  setline(1647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_6620__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6622 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6624 = alloc_Float64(1);
// compiled num node returning num6624 (depth = 9)
  int op_slot_right_6623 = gc_frame_newslot(num6624);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_6623 = gc_frame_newslot(*var_depth);
  params[0] = num6624;
  partcv[0] = 1;
  Object sum6626 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum6626 (depth = 8)
  gc_frame_newslot(sum6626);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  params[0] = sum6626;
  partcv[0] = 1;
  Object call6627 = callmethodflags(*var_t, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6622);
// compiled call node returning call6627 (depth = 7)
  int op_slot_right_6621 = gc_frame_newslot(call6627);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6630 == NULL) {
    strlit6630 = alloc_String("""\x0a""");
    gc_root(strlit6630);
  }
// compiled string node returning strlit6630 (depth = 8)
  int op_slot_right_6629 = gc_frame_newslot(strlit6630);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6629 = gc_frame_newslot(*var_s);
  params[0] = strlit6630;
  partcv[0] = 1;
  Object opresult6632 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6632 (depth = 7)
  int op_slot_left_6621 = gc_frame_newslot(opresult6632);
  params[0] = call6627;
  partcv[0] = 1;
  Object opresult6633 = callmethod(opresult6632, "++(1)", 1, partcv, params);
// compiled op node returning opresult6633 (depth = 6)
  *var_s = opresult6633;
  if (opresult6633 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_6641__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1659
  setline(1659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6643 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6645 = alloc_Float64(1);
// compiled num node returning num6645 (depth = 9)
  int op_slot_right_6644 = gc_frame_newslot(num6645);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_6644 = gc_frame_newslot(*var_depth);
  params[0] = num6645;
  partcv[0] = 1;
  Object sum6647 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum6647 (depth = 8)
  gc_frame_newslot(sum6647);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_x (depth = 8)
  params[0] = sum6647;
  partcv[0] = 1;
  Object call6648 = callmethodflags(*var_x, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6643);
// compiled call node returning call6648 (depth = 7)
  int op_slot_right_6642 = gc_frame_newslot(call6648);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6651 == NULL) {
    strlit6651 = alloc_String("    ");
    gc_root(strlit6651);
  }
// compiled string node returning strlit6651 (depth = 8)
  int op_slot_right_6650 = gc_frame_newslot(strlit6651);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_6653 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6656 == NULL) {
    strlit6656 = alloc_String("""\x0a""");
    gc_root(strlit6656);
  }
// compiled string node returning strlit6656 (depth = 10)
  int op_slot_right_6655 = gc_frame_newslot(strlit6656);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_6655 = gc_frame_newslot(*var_s);
  params[0] = strlit6656;
  partcv[0] = 1;
  Object opresult6658 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6658 (depth = 9)
  int op_slot_left_6653 = gc_frame_newslot(opresult6658);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6659 = callmethod(opresult6658, "++(1)", 1, partcv, params);
// compiled op node returning opresult6659 (depth = 8)
  int op_slot_left_6650 = gc_frame_newslot(opresult6659);
  params[0] = strlit6651;
  partcv[0] = 1;
  Object opresult6660 = callmethod(opresult6659, "++(1)", 1, partcv, params);
// compiled op node returning opresult6660 (depth = 7)
  int op_slot_left_6642 = gc_frame_newslot(opresult6660);
  params[0] = call6648;
  partcv[0] = 1;
  Object opresult6661 = callmethod(opresult6660, "++(1)", 1, partcv, params);
// compiled op node returning opresult6661 (depth = 6)
  *var_s = opresult6661;
  if (opresult6661 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_6573_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1650
  setline(1650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_6574 = gc_frame_newslot(*var_depth);
// starting to compile string node (depth = 5)
  if (strlit6576 == NULL) {
    strlit6576 = alloc_String("    ");
    gc_root(strlit6576);
  }
// compiled string node returning strlit6576 (depth = 5)
  int op_slot_left_6574 = gc_frame_newslot(strlit6576);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object prod6577 = callmethod(strlit6576, "*(1)", 1, partcv, params);
// compiled op node returning prod6577 (depth = 4)
  *var_spc = prod6577;
  if (prod6577 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1651
  setline(1651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6578 == NULL) {
    strlit6578 = alloc_String("object {");
    gc_root(strlit6578);
  }
// compiled string node returning strlit6578 (depth = 4)
  *var_s = strlit6578;
  if (strlit6578 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1652
  setline(1652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6580 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6581 = callmethodflags(self, "inTrait", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6580);
// compiled member node returning call6581 (depth = 4)
  Object if6579 = done;
  if (istrue(call6581)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6583 == NULL) {
    strlit6583 = alloc_String("   // trait");
    gc_root(strlit6583);
  }
// compiled string node returning strlit6583 (depth = 6)
  int op_slot_right_6582 = gc_frame_newslot(strlit6583);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_6582 = gc_frame_newslot(*var_s);
  params[0] = strlit6583;
  partcv[0] = 1;
  Object opresult6585 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6585 (depth = 5)
  *var_s = opresult6585;
  if (opresult6585 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6579 = done;
  } else {
  }
// compiled if node returning if6579 (depth = 3)
// Begin line 1653
  setline(1653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6588 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6589 = callmethodflags(self, "inClass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6588);
// compiled member node returning call6589 (depth = 4)
  Object if6587 = done;
  if (istrue(call6589)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6591 == NULL) {
    strlit6591 = alloc_String("   // class");
    gc_root(strlit6591);
  }
// compiled string node returning strlit6591 (depth = 6)
  int op_slot_right_6590 = gc_frame_newslot(strlit6591);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_6590 = gc_frame_newslot(*var_s);
  params[0] = strlit6591;
  partcv[0] = 1;
  Object opresult6593 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6593 (depth = 5)
  *var_s = opresult6593;
  if (opresult6593 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6587 = done;
  } else {
  }
// compiled if node returning if6587 (depth = 3)
// Begin line 1654
  setline(1654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6597 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6598 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6597);
// compiled member node returning call6598 (depth = 5)
  int op_slot_right_6596 = gc_frame_newslot(call6598);
// starting to compile identifier node (depth = 5)
  Object bool6600 = alloc_Boolean(0);
// compiled identifier node returning bool6600 (depth = 5)
  int op_slot_left_6596 = gc_frame_newslot(bool6600);
  params[0] = call6598;
  partcv[0] = 1;
  Object opresult6601 = callmethod(bool6600, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6601 (depth = 4)
  Object if6595 = done;
  if (istrue(opresult6601)) {
// Begin line 1655
  setline(1655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6603 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num6605 = alloc_Float64(1);
// compiled num node returning num6605 (depth = 8)
  int op_slot_right_6604 = gc_frame_newslot(num6605);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_6604 = gc_frame_newslot(*var_depth);
  params[0] = num6605;
  partcv[0] = 1;
  Object sum6607 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum6607 (depth = 7)
  gc_frame_newslot(sum6607);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6608 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6609 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6608);
// compiled member node returning call6609 (depth = 7)
  params[0] = sum6607;
  partcv[0] = 1;
  Object call6610 = callmethodflags(call6609, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6603);
// compiled call node returning call6610 (depth = 6)
  int op_slot_right_6602 = gc_frame_newslot(call6610);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6613 == NULL) {
    strlit6613 = alloc_String("""\x0a""");
    gc_root(strlit6613);
  }
// compiled string node returning strlit6613 (depth = 7)
  int op_slot_right_6612 = gc_frame_newslot(strlit6613);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6612 = gc_frame_newslot(*var_s);
  params[0] = strlit6613;
  partcv[0] = 1;
  Object opresult6615 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6615 (depth = 6)
  int op_slot_left_6602 = gc_frame_newslot(opresult6615);
  params[0] = call6610;
  partcv[0] = 1;
  Object opresult6616 = callmethod(opresult6615, "++(1)", 1, partcv, params);
// compiled op node returning opresult6616 (depth = 5)
  *var_s = opresult6616;
  if (opresult6616 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6595 = done;
  } else {
  }
// compiled if node returning if6595 (depth = 3)
// Begin line 1657
  setline(1657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6618 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6619 = alloc_Block(NULL, NULL, "ast", 1657);
  gc_frame_newslot(block6619);
// method "_apply(_)"
  block_savedest(block6619);
  Object closure6620 = createclosure(3, "_apply(1)");
  setclosureframe(closure6620, stackframe);
  addtoclosure(closure6620, var_depth);
  addtoclosure(closure6620, var_s);
  addtoclosure(closure6620, selfslot);
  struct UserObject *uo6620 = (struct UserObject*)block6619;
  uo6620->data[0] = (Object)closure6620;
  Method *meth_meth_ast_6620__apply_40_1_41_ = addmethod2pos(block6619, "_apply(1)", &meth_ast_6620__apply_40_1_41_, 0);
  int argcv_meth_ast_6620__apply_40_1_41_[] = {1};
  meth_meth_ast_6620__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6620__apply_40_1_41_);
  meth_meth_ast_6620__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6620__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block6619 (depth = 4)
  gc_frame_newslot(block6619);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6636 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6637 = callmethodflags(self, "usedTraits", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6636);
// compiled member node returning call6637 (depth = 4)
  params[0] = block6619;
  partcv[0] = 1;
  Object call6638 = callmethodflags(call6637, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6618);
// compiled call node returning call6638 (depth = 3)
// Begin line 1658
  setline(1658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6639 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6640 = alloc_Block(NULL, NULL, "ast", 1658);
  gc_frame_newslot(block6640);
// method "_apply(_)"
  block_savedest(block6640);
  Object closure6641 = createclosure(4, "_apply(1)");
  setclosureframe(closure6641, stackframe);
  addtoclosure(closure6641, var_depth);
  addtoclosure(closure6641, var_spc);
  addtoclosure(closure6641, var_s);
  addtoclosure(closure6641, selfslot);
  struct UserObject *uo6641 = (struct UserObject*)block6640;
  uo6641->data[0] = (Object)closure6641;
  Method *meth_meth_ast_6641__apply_40_1_41_ = addmethod2pos(block6640, "_apply(1)", &meth_ast_6641__apply_40_1_41_, 0);
  int argcv_meth_ast_6641__apply_40_1_41_[] = {1};
  meth_meth_ast_6641__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6641__apply_40_1_41_);
  meth_meth_ast_6641__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6641__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block6640 (depth = 4)
  gc_frame_newslot(block6640);
// call case 6: other requests
// Begin line 1658
  setline(1658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6664 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6665 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6664);
// compiled member node returning call6665 (depth = 4)
  params[0] = block6640;
  partcv[0] = 1;
  Object call6666 = callmethodflags(call6665, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6639);
// compiled call node returning call6666 (depth = 3)
// Begin line 1661
  setline(1661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6668 == NULL) {
    strlit6668 = alloc_String("}");
    gc_root(strlit6668);
  }
// compiled string node returning strlit6668 (depth = 5)
  int op_slot_right_6667 = gc_frame_newslot(strlit6668);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_6670 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6673 == NULL) {
    strlit6673 = alloc_String("""\x0a""");
    gc_root(strlit6673);
  }
// compiled string node returning strlit6673 (depth = 7)
  int op_slot_right_6672 = gc_frame_newslot(strlit6673);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6672 = gc_frame_newslot(*var_s);
  params[0] = strlit6673;
  partcv[0] = 1;
  Object opresult6675 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6675 (depth = 6)
  int op_slot_left_6670 = gc_frame_newslot(opresult6675);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6676 = callmethod(opresult6675, "++(1)", 1, partcv, params);
// compiled op node returning opresult6676 (depth = 5)
  int op_slot_left_6667 = gc_frame_newslot(opresult6676);
  params[0] = strlit6668;
  partcv[0] = 1;
  Object opresult6677 = callmethod(opresult6676, "++(1)", 1, partcv, params);
// compiled op node returning opresult6677 (depth = 4)
  *var_s = opresult6677;
  if (opresult6677 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1662
  setline(1662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_6679_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_objectNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1665
  setline(1665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6680 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe6681 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 5)
  Object bool6682 = alloc_Boolean(0);
// compiled identifier node returning bool6682 (depth = 5)
  gc_frame_newslot(bool6682);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objectNode (depth = 5)
  params[0] = *var_emptySeq;
  params[1] = bool6682;
  partcv[0] = 2;
  Object call6683 = callmethodflags(*var_objectNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6681);
// compiled call node returning call6683 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6684 = callmethodflags(call6683, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6680);
// compiled call node returning call6684 (depth = 3)
  gc_frame_end(frame);
  return call6684;
}
Object meth_ast_6685_postCopy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "postCopy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method postCopy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for postCopy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part postCopy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1668
  setline(1668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6686 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6687 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call6688 = callmethodflags(*var_other, "name", 1, partcv, params, 0);
  gc_frame_end(callframe6687);
// compiled member node returning call6688 (depth = 4)
  gc_frame_newslot(call6688);
// call case 4: self request
  params[0] = call6688;
  partcv[0] = 1;
  Object call6689 = callmethodflags(self, "name:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6686);
// compiled call node returning call6689 (depth = 3)
// Begin line 1669
  setline(1669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6690 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6691 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call6692 = callmethodflags(*var_other, "value", 1, partcv, params, 0);
  gc_frame_end(callframe6691);
// compiled member node returning call6692 (depth = 4)
  gc_frame_newslot(call6692);
// call case 4: self request
  params[0] = call6692;
  partcv[0] = 1;
  Object call6693 = callmethodflags(self, "value:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6690);
// compiled call node returning call6693 (depth = 3)
// Begin line 1670
  setline(1670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6694 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6695 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call6696 = callmethodflags(*var_other, "superclass", 1, partcv, params, 0);
  gc_frame_end(callframe6695);
// compiled member node returning call6696 (depth = 4)
  gc_frame_newslot(call6696);
// call case 4: self request
  params[0] = call6696;
  partcv[0] = 1;
  Object call6697 = callmethodflags(self, "superclass:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6694);
// compiled call node returning call6697 (depth = 3)
// Begin line 1671
  setline(1671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6698 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6699 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call6700 = callmethodflags(*var_other, "usedTraits", 1, partcv, params, 0);
  gc_frame_end(callframe6699);
// compiled member node returning call6700 (depth = 4)
  gc_frame_newslot(call6700);
// call case 4: self request
  params[0] = call6700;
  partcv[0] = 1;
  Object call6701 = callmethodflags(self, "usedTraits:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6698);
// compiled call node returning call6701 (depth = 3)
// Begin line 1672
  setline(1672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6702 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6703 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call6704 = callmethodflags(*var_other, "inClass", 1, partcv, params, 0);
  gc_frame_end(callframe6703);
// compiled member node returning call6704 (depth = 4)
  gc_frame_newslot(call6704);
// call case 4: self request
  params[0] = call6704;
  partcv[0] = 1;
  Object call6705 = callmethodflags(self, "inClass:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6702);
// compiled call node returning call6705 (depth = 3)
// Begin line 1673
  setline(1673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6706 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6707 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call6708 = callmethodflags(*var_other, "inTrait", 1, partcv, params, 0);
  gc_frame_end(callframe6707);
// compiled member node returning call6708 (depth = 4)
  gc_frame_newslot(call6708);
// call case 4: self request
  params[0] = call6708;
  partcv[0] = 1;
  Object call6709 = callmethodflags(self, "inTrait:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6706);
// compiled call node returning call6709 (depth = 3)
// Begin line 1674
  setline(1674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6710 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6711 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call6712 = callmethodflags(*var_other, "annotations", 1, partcv, params, 0);
  gc_frame_end(callframe6711);
// compiled member node returning call6712 (depth = 4)
  gc_frame_newslot(call6712);
// call case 4: self request
  params[0] = call6712;
  partcv[0] = 1;
  Object call6713 = callmethodflags(self, "annotations:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6710);
// compiled call node returning call6713 (depth = 3)
// Begin line 1675
  setline(1675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_6714_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1678
  setline(1678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6716 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6717 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6716);
// compiled member node returning call6717 (depth = 4)
  int op_slot_right_6715 = gc_frame_newslot(call6717);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6720 == NULL) {
    strlit6720 = alloc_String(" ");
    gc_root(strlit6720);
  }
// compiled string node returning strlit6720 (depth = 5)
  int op_slot_right_6719 = gc_frame_newslot(strlit6720);
// starting to compile member node (depth = 5)
  int callframe6722 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6723 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6722);
// compiled member node returning call6723 (depth = 5)
  int op_slot_left_6719 = gc_frame_newslot(call6723);
  params[0] = strlit6720;
  partcv[0] = 1;
  Object opresult6724 = callmethod(call6723, "++(1)", 1, partcv, params);
// compiled op node returning opresult6724 (depth = 4)
  int op_slot_left_6715 = gc_frame_newslot(opresult6724);
  params[0] = call6717;
  partcv[0] = 1;
  Object opresult6725 = callmethod(opresult6724, "++(1)", 1, partcv, params);
// compiled op node returning opresult6725 (depth = 3)
  gc_frame_end(frame);
  return opresult6725;
}
Object meth_ast_6123_new_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_noPosition = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_objectNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[1]);
  *var_superclass_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6124 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6124 = alloc_userobj2(40,33, objclass6124);
  gc_frame_newslot(obj6124);
  if (objclass6124 == NULL) {
    glfree(obj6124->class->name);
    obj6124->class->name = "objectNode.new(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj6124, self, 0);
  addmethodreal(obj6124,"outer", &reader_ast_outer_6125);
  Object oldself6124 = self;
  struct StackFrameObject *oldstackframe6124 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6124);
  gc_frame_newslot((Object)stackframe);
  self = obj6124;
  Object *oldselfslot6124 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6124 = (*(struct UserObject *)self).data[0], lowerouter6124 = thisouter6124;
  if (inheritingObject6124) {
    struct UserObject *inho6124 = (struct UserObject *)inheritingObject6124;
    while (inho6124->super != GraceDefaultObject) inho6124 = (struct UserObject *)inho6124->super;
    inho6124->super = obj6124;
    self = inheritingObject6124;
    *selfslot = self;
    lowerouter6124 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6124;
  }
  if (objclass6124 == NULL) {
  Method *reader6126 = addmethodrealflags(obj6124, "kind",&reader_ast_kind_6126, MFLAG_DEF);
  reader6126->definitionModule = modulename;
  reader6126->definitionLine = 1511;
  }
  adddatum2(obj6124, alloc_Undefined(), 1);
  if (objclass6124 == NULL) {
    Method *reader6127 = addmethodrealflags(obj6124, "value", &reader_ast_value_6127, 0);
    Method *writer6127 = addmethodrealflags(obj6124, "value:=(1)", &writer_ast_value_6127, 0);
    reader6127->definitionModule = modulename;
    writer6127->definitionModule = modulename;
    reader6127->definitionLine = 1512;
    writer6127->definitionLine = 1512;
  }
  obj6124->flags |= OFLAG_MUTABLE;
  adddatum2(obj6124, alloc_Undefined(), 2);
  if (objclass6124 == NULL) {
    Method *reader6128 = addmethodrealflags(obj6124, "superclass", &reader_ast_superclass_6128, 0);
    Method *writer6128 = addmethodrealflags(obj6124, "superclass:=(1)", &writer_ast_superclass_6128, 0);
    reader6128->definitionModule = modulename;
    writer6128->definitionModule = modulename;
    reader6128->definitionLine = 1513;
    writer6128->definitionLine = 1513;
  }
  obj6124->flags |= OFLAG_MUTABLE;
  adddatum2(obj6124, alloc_Undefined(), 3);
  if (objclass6124 == NULL) {
    Method *reader6129 = addmethodrealflags(obj6124, "usedTraits", &reader_ast_usedTraits_6129, 0);
    Method *writer6129 = addmethodrealflags(obj6124, "usedTraits:=(1)", &writer_ast_usedTraits_6129, 0);
    reader6129->definitionModule = modulename;
    writer6129->definitionModule = modulename;
    reader6129->definitionLine = 1514;
    writer6129->definitionLine = 1514;
  }
  obj6124->flags |= OFLAG_MUTABLE;
  adddatum2(obj6124, alloc_Undefined(), 4);
  if (objclass6124 == NULL) {
    Method *reader6130 = addmethodrealflags(obj6124, "name", &reader_ast_name_6130, 0);
    Method *writer6130 = addmethodrealflags(obj6124, "name:=(1)", &writer_ast_name_6130, 0);
    reader6130->definitionModule = modulename;
    writer6130->definitionModule = modulename;
    reader6130->definitionLine = 1515;
    writer6130->definitionLine = 1515;
  }
  obj6124->flags |= OFLAG_MUTABLE;
  adddatum2(obj6124, alloc_Undefined(), 5);
  if (objclass6124 == NULL) {
    Method *reader6131 = addmethodrealflags(obj6124, "inClass", &reader_ast_inClass_6131, 0);
    Method *writer6131 = addmethodrealflags(obj6124, "inClass:=(1)", &writer_ast_inClass_6131, 0);
    reader6131->definitionModule = modulename;
    writer6131->definitionModule = modulename;
    reader6131->definitionLine = 1516;
    writer6131->definitionLine = 1516;
  }
  obj6124->flags |= OFLAG_MUTABLE;
  adddatum2(obj6124, alloc_Undefined(), 6);
  if (objclass6124 == NULL) {
    Method *reader6132 = addmethodrealflags(obj6124, "inTrait", &reader_ast_inTrait_6132, 0);
    Method *writer6132 = addmethodrealflags(obj6124, "inTrait:=(1)", &writer_ast_inTrait_6132, 0);
    reader6132->definitionModule = modulename;
    writer6132->definitionModule = modulename;
    reader6132->definitionLine = 1517;
    writer6132->definitionLine = 1517;
  }
  obj6124->flags |= OFLAG_MUTABLE;
  adddatum2(obj6124, alloc_Undefined(), 7);
  if (objclass6124 == NULL) {
    Method *reader6133 = addmethodrealflags(obj6124, "myLocalNames", &reader_ast_myLocalNames_6133, MFLAG_CONFIDENTIAL);
    Method *writer6133 = addmethodrealflags(obj6124, "myLocalNames:=(1)", &writer_ast_myLocalNames_6133, MFLAG_CONFIDENTIAL);
    reader6133->definitionModule = modulename;
    writer6133->definitionModule = modulename;
    reader6133->definitionLine = 1518;
    writer6133->definitionLine = 1518;
  }
  obj6124->flags |= OFLAG_MUTABLE;
  adddatum2(obj6124, alloc_Undefined(), 8);
  if (objclass6124 == NULL) {
    Method *reader6134 = addmethodrealflags(obj6124, "annotations", &reader_ast_annotations_6134, 0);
    Method *writer6134 = addmethodrealflags(obj6124, "annotations:=(1)", &writer_ast_annotations_6134, 0);
    reader6134->definitionModule = modulename;
    writer6134->definitionModule = modulename;
    reader6134->definitionLine = 1519;
    writer6134->definitionLine = 1519;
  }
  obj6124->flags |= OFLAG_MUTABLE;
  adddatum2(obj6124, alloc_Undefined(), 9);
// method "end"
  block_savedest(obj6124);
  Object closure6135 = createclosure(1, "end");
  setclosureframe(closure6135, stackframe);
  addtoclosure(closure6135, var_noPosition);
  struct UserObject *uo6135 = (struct UserObject*)obj6124;
  uo6135->data[10] = (Object)closure6135;
  Method *meth_meth_ast_6135_end = addmethod2pos(obj6124, "end", &meth_ast_6135_end, 10);
  int argcv_meth_ast_6135_end[] = {0};
  meth_meth_ast_6135_end->type = alloc_MethodType(1, argcv_meth_ast_6135_end);
  meth_meth_ast_6135_end->definitionModule = modulename;
  meth_meth_ast_6135_end->definitionLine = 1521;
// method "description"
  struct UserObject *uo6186 = (struct UserObject*)obj6124;
  uo6186->data[11] = emptyclosure;
  Method *meth_meth_ast_6186_description = addmethod2pos(obj6124, "description", &meth_ast_6186_description, 11);
  int argcv_meth_ast_6186_description[] = {0};
  meth_meth_ast_6186_description->type = alloc_MethodType(1, argcv_meth_ast_6186_description);
  meth_meth_ast_6186_description->definitionModule = modulename;
  meth_meth_ast_6186_description->definitionLine = 1533;
// method "isFresh"
  struct UserObject *uo6215 = (struct UserObject*)obj6124;
  uo6215->data[12] = emptyclosure;
  Method *meth_meth_ast_6215_isFresh = addmethod2pos(obj6124, "isFresh", &meth_ast_6215_isFresh, 12);
  int argcv_meth_ast_6215_isFresh[] = {0};
  meth_meth_ast_6215_isFresh->type = alloc_MethodType(1, argcv_meth_ast_6215_isFresh);
  meth_meth_ast_6215_isFresh->definitionModule = modulename;
  meth_meth_ast_6215_isFresh->definitionLine = 1542;
// method "isTrait"
  struct UserObject *uo6217 = (struct UserObject*)obj6124;
  uo6217->data[13] = emptyclosure;
  Method *meth_meth_ast_6217_isTrait = addmethod2pos(obj6124, "isTrait", &meth_ast_6217_isTrait, 13);
  int argcv_meth_ast_6217_isTrait[] = {0};
  meth_meth_ast_6217_isTrait->type = alloc_MethodType(1, argcv_meth_ast_6217_isTrait);
  meth_meth_ast_6217_isTrait->definitionModule = modulename;
  meth_meth_ast_6217_isTrait->definitionLine = 1543;
// method "localNames"
  struct UserObject *uo6244 = (struct UserObject*)obj6124;
  uo6244->data[14] = emptyclosure;
  Method *meth_meth_ast_6244_localNames = addmethod2pos(obj6124, "localNames", &meth_ast_6244_localNames, 14);
  int argcv_meth_ast_6244_localNames[] = {0};
  meth_meth_ast_6244_localNames->type = alloc_MethodType(1, argcv_meth_ast_6244_localNames);
  meth_meth_ast_6244_localNames->definitionModule = modulename;
  meth_meth_ast_6244_localNames->definitionLine = 1555;
// method "parentsDo(_)"
  struct UserObject *uo6279 = (struct UserObject*)obj6124;
  uo6279->data[15] = emptyclosure;
  Method *meth_meth_ast_6279_parentsDo_40_1_41_ = addmethod2pos(obj6124, "parentsDo(1)", &meth_ast_6279_parentsDo_40_1_41_, 15);
  int argcv_meth_ast_6279_parentsDo_40_1_41_[] = {1};
  meth_meth_ast_6279_parentsDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6279_parentsDo_40_1_41_);
  meth_meth_ast_6279_parentsDo_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6279_parentsDo_40_1_41_->definitionLine = 1569;
// method "methodsDo(_)"
  struct UserObject *uo6300 = (struct UserObject*)obj6124;
  uo6300->data[16] = emptyclosure;
  Method *meth_meth_ast_6300_methodsDo_40_1_41_ = addmethod2pos(obj6124, "methodsDo(1)", &meth_ast_6300_methodsDo_40_1_41_, 16);
  int argcv_meth_ast_6300_methodsDo_40_1_41_[] = {1};
  meth_meth_ast_6300_methodsDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6300_methodsDo_40_1_41_);
  meth_meth_ast_6300_methodsDo_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6300_methodsDo_40_1_41_->definitionLine = 1576;
// method "executableComponentsDo(_)"
  struct UserObject *uo6313 = (struct UserObject*)obj6124;
  uo6313->data[17] = emptyclosure;
  Method *meth_meth_ast_6313_executableComponentsDo_40_1_41_ = addmethod2pos(obj6124, "executableComponentsDo(1)", &meth_ast_6313_executableComponentsDo_40_1_41_, 17);
  int argcv_meth_ast_6313_executableComponentsDo_40_1_41_[] = {1};
  meth_meth_ast_6313_executableComponentsDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6313_executableComponentsDo_40_1_41_);
  meth_meth_ast_6313_executableComponentsDo_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6313_executableComponentsDo_40_1_41_->definitionLine = 1584;
// method "scope:=(_)"
  struct UserObject *uo6326 = (struct UserObject*)obj6124;
  uo6326->data[18] = emptyclosure;
  Method *meth_meth_ast_6326_scope_58__61__40_1_41_ = addmethod2pos(obj6124, "scope:=(1)", &meth_ast_6326_scope_58__61__40_1_41_, 18);
  int argcv_meth_ast_6326_scope_58__61__40_1_41_[] = {1};
  meth_meth_ast_6326_scope_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6326_scope_58__61__40_1_41_);
  meth_meth_ast_6326_scope_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_6326_scope_58__61__40_1_41_->definitionLine = 1592;
// method "body"
  struct UserObject *uo6331 = (struct UserObject*)obj6124;
  uo6331->data[19] = emptyclosure;
  Method *meth_meth_ast_6331_body = addmethod2pos(obj6124, "body", &meth_ast_6331_body, 19);
  int argcv_meth_ast_6331_body[] = {0};
  meth_meth_ast_6331_body->type = alloc_MethodType(1, argcv_meth_ast_6331_body);
  meth_meth_ast_6331_body->definitionModule = modulename;
  meth_meth_ast_6331_body->definitionLine = 1598;
// method "returnsObject"
  struct UserObject *uo6334 = (struct UserObject*)obj6124;
  uo6334->data[20] = emptyclosure;
  Method *meth_meth_ast_6334_returnsObject = addmethod2pos(obj6124, "returnsObject", &meth_ast_6334_returnsObject, 20);
  int argcv_meth_ast_6334_returnsObject[] = {0};
  meth_meth_ast_6334_returnsObject->type = alloc_MethodType(1, argcv_meth_ast_6334_returnsObject);
  meth_meth_ast_6334_returnsObject->definitionModule = modulename;
  meth_meth_ast_6334_returnsObject->definitionLine = 1599;
// method "returnedObjectScope"
  struct UserObject *uo6336 = (struct UserObject*)obj6124;
  uo6336->data[21] = emptyclosure;
  Method *meth_meth_ast_6336_returnedObjectScope = addmethod2pos(obj6124, "returnedObjectScope", &meth_ast_6336_returnedObjectScope, 21);
  int argcv_meth_ast_6336_returnedObjectScope[] = {0};
  meth_meth_ast_6336_returnedObjectScope->type = alloc_MethodType(1, argcv_meth_ast_6336_returnedObjectScope);
  meth_meth_ast_6336_returnedObjectScope->definitionModule = modulename;
  meth_meth_ast_6336_returnedObjectScope->definitionLine = 1600;
// method "canInherit"
  struct UserObject *uo6339 = (struct UserObject*)obj6124;
  uo6339->data[22] = emptyclosure;
  Method *meth_meth_ast_6339_canInherit = addmethod2pos(obj6124, "canInherit", &meth_ast_6339_canInherit, 22);
  int argcv_meth_ast_6339_canInherit[] = {0};
  meth_meth_ast_6339_canInherit->type = alloc_MethodType(1, argcv_meth_ast_6339_canInherit);
  meth_meth_ast_6339_canInherit->definitionModule = modulename;
  meth_meth_ast_6339_canInherit->definitionLine = 1601;
// method "canUse"
  struct UserObject *uo6344 = (struct UserObject*)obj6124;
  uo6344->data[23] = emptyclosure;
  Method *meth_meth_ast_6344_canUse = addmethod2pos(obj6124, "canUse", &meth_ast_6344_canUse, 23);
  int argcv_meth_ast_6344_canUse[] = {0};
  meth_meth_ast_6344_canUse->type = alloc_MethodType(1, argcv_meth_ast_6344_canUse);
  meth_meth_ast_6344_canUse->definitionModule = modulename;
  meth_meth_ast_6344_canUse->definitionLine = 1602;
// method "isObject"
  struct UserObject *uo6346 = (struct UserObject*)obj6124;
  uo6346->data[24] = emptyclosure;
  Method *meth_meth_ast_6346_isObject = addmethod2pos(obj6124, "isObject", &meth_ast_6346_isObject, 24);
  int argcv_meth_ast_6346_isObject[] = {0};
  meth_meth_ast_6346_isObject->type = alloc_MethodType(1, argcv_meth_ast_6346_isObject);
  meth_meth_ast_6346_isObject->definitionModule = modulename;
  meth_meth_ast_6346_isObject->definitionLine = 1603;
// method "accept(_)from(_)"
  struct UserObject *uo6348 = (struct UserObject*)obj6124;
  uo6348->data[25] = emptyclosure;
  Method *meth_meth_ast_6348_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj6124, "accept(1)from(1)", &meth_ast_6348_accept_40_1_41_from_40_1_41_, 25);
  int argcv_meth_ast_6348_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_6348_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_6348_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_6348_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6348_accept_40_1_41_from_40_1_41_->definitionLine = 1604;
// method "nameString"
  struct UserObject *uo6383 = (struct UserObject*)obj6124;
  uo6383->data[26] = emptyclosure;
  Method *meth_meth_ast_6383_nameString = addmethod2pos(obj6124, "nameString", &meth_ast_6383_nameString, 26);
  int argcv_meth_ast_6383_nameString[] = {0};
  meth_meth_ast_6383_nameString->type = alloc_MethodType(1, argcv_meth_ast_6383_nameString);
  meth_meth_ast_6383_nameString->definitionModule = modulename;
  meth_meth_ast_6383_nameString->definitionLine = 1614;
// method "map(_)ancestors(_)"
  struct UserObject *uo6403 = (struct UserObject*)obj6124;
  uo6403->data[27] = emptyclosure;
  Method *meth_meth_ast_6403_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj6124, "map(1)ancestors(1)", &meth_ast_6403_map_40_1_41_ancestors_40_1_41_, 27);
  int argcv_meth_ast_6403_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_6403_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_6403_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_6403_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6403_map_40_1_41_ancestors_40_1_41_->definitionLine = 1621;
// method "pretty(_)"
  struct UserObject *uo6428 = (struct UserObject*)obj6124;
  uo6428->data[28] = emptyclosure;
  Method *meth_meth_ast_6428_pretty_40_1_41_ = addmethod2pos(obj6124, "pretty(1)", &meth_ast_6428_pretty_40_1_41_, 28);
  int argcv_meth_ast_6428_pretty_40_1_41_[] = {1};
  meth_meth_ast_6428_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6428_pretty_40_1_41_);
  meth_meth_ast_6428_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6428_pretty_40_1_41_->definitionLine = 1629;
// method "toGrace(_)"
  struct UserObject *uo6573 = (struct UserObject*)obj6124;
  uo6573->data[29] = emptyclosure;
  Method *meth_meth_ast_6573_toGrace_40_1_41_ = addmethod2pos(obj6124, "toGrace(1)", &meth_ast_6573_toGrace_40_1_41_, 29);
  int argcv_meth_ast_6573_toGrace_40_1_41_[] = {1};
  meth_meth_ast_6573_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6573_toGrace_40_1_41_);
meth_meth_ast_6573_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_6573_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_6573_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6573_toGrace_40_1_41_->definitionLine = 1649;
// method "shallowCopy"
  block_savedest(obj6124);
  Object closure6679 = createclosure(2, "shallowCopy");
  setclosureframe(closure6679, stackframe);
  addtoclosure(closure6679, var_emptySeq);
  addtoclosure(closure6679, var_objectNode);
  struct UserObject *uo6679 = (struct UserObject*)obj6124;
  uo6679->data[30] = (Object)closure6679;
  Method *meth_meth_ast_6679_shallowCopy = addmethod2pos(obj6124, "shallowCopy", &meth_ast_6679_shallowCopy, 30);
  int argcv_meth_ast_6679_shallowCopy[] = {0};
  meth_meth_ast_6679_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_6679_shallowCopy);
  meth_meth_ast_6679_shallowCopy->definitionModule = modulename;
  meth_meth_ast_6679_shallowCopy->definitionLine = 1664;
// method "postCopy(_)"
  struct UserObject *uo6685 = (struct UserObject*)obj6124;
  uo6685->data[31] = emptyclosure;
  Method *meth_meth_ast_6685_postCopy_40_1_41_ = addmethod2pos(obj6124, "postCopy(1)", &meth_ast_6685_postCopy_40_1_41_, 31);
  int argcv_meth_ast_6685_postCopy_40_1_41_[] = {1};
  meth_meth_ast_6685_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6685_postCopy_40_1_41_);
  meth_meth_ast_6685_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6685_postCopy_40_1_41_->definitionLine = 1667;
// method "asString"
  struct UserObject *uo6714 = (struct UserObject*)obj6124;
  uo6714->data[32] = emptyclosure;
  Method *meth_meth_ast_6714_asString = addmethod2pos(obj6124, "asString", &meth_ast_6714_asString, 32);
  int argcv_meth_ast_6714_asString[] = {0};
  meth_meth_ast_6714_asString->type = alloc_MethodType(1, argcv_meth_ast_6714_asString);
  meth_meth_ast_6714_asString->definitionModule = modulename;
  meth_meth_ast_6714_asString->definitionLine = 1677;
  sourceObject = obj6124;
// Begin line 1510
  setline(1510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6726 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6727 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6726);
// compiled call node returning call6727 (depth = 3)
  struct UserObject *obj6124_uo = (struct UserObject *)obj6124;
  obj6124_uo->super = call6727;
  sourceObject = obj6124;
// Begin line 1511
  setline(1511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6728 == NULL) {
    strlit6728 = alloc_String("object");
    gc_root(strlit6728);
  }
// compiled string node returning strlit6728 (depth = 3)
  adddatum2(obj6124, strlit6728, 1);
  sourceObject = obj6124;
// Begin line 1512
  setline(1512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_b (depth = 3)
  adddatum2(obj6124, *var_b, 2);
  sourceObject = obj6124;
// Begin line 1513
  setline(1513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_superclass_39_ (depth = 3)
  adddatum2(obj6124, *var_superclass_39_, 3);
  sourceObject = obj6124;
// Begin line 1514
  setline(1514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array6729 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6729 (depth = 3)
  adddatum2(obj6124, array6729, 4);
  sourceObject = obj6124;
// Begin line 1515
  setline(1515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6730 == NULL) {
    strlit6730 = alloc_String("object");
    gc_root(strlit6730);
  }
// compiled string node returning strlit6730 (depth = 3)
  adddatum2(obj6124, strlit6730, 5);
  sourceObject = obj6124;
// Begin line 1516
  setline(1516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6731 = alloc_Boolean(0);
// compiled identifier node returning bool6731 (depth = 3)
  adddatum2(obj6124, bool6731, 6);
  sourceObject = obj6124;
// Begin line 1517
  setline(1517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6732 = alloc_Boolean(0);
// compiled identifier node returning bool6732 (depth = 3)
  adddatum2(obj6124, bool6732, 7);
  sourceObject = obj6124;
// Begin line 1518
  setline(1518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6733 = alloc_Boolean(0);
// compiled identifier node returning bool6733 (depth = 3)
  adddatum2(obj6124, bool6733, 8);
  sourceObject = obj6124;
// Begin line 1519
  setline(1519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array6734 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6734 (depth = 3)
  adddatum2(obj6124, array6734, 9);
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  objclass6124 = obj6124->class;
  objclass6124->definitionModule = modulename;
  objclass6124->definitionLine = 1509;
  (*(struct UserObject *)self).data[0] = lowerouter6124;
  self = oldself6124;
  selfslot = oldselfslot6124;
  stackframe = oldstackframe6124;
  gc_frame_end(frame);
  return obj6124;
}
Object meth_ast_6123_new_40_2_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_noPosition = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_objectNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[1]);
  *var_superclass_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6124 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6124 = alloc_userobj2(40,33, objclass6124);
  gc_frame_newslot(obj6124);
  if (objclass6124 == NULL) {
    glfree(obj6124->class->name);
    obj6124->class->name = "objectNode.new(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj6124, self, 0);
  addmethodreal(obj6124,"outer", &reader_ast_outer_6125);
  Object oldself6124 = self;
  struct StackFrameObject *oldstackframe6124 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6124);
  gc_frame_newslot((Object)stackframe);
  self = obj6124;
  Object *oldselfslot6124 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6124 = (*(struct UserObject *)self).data[0], lowerouter6124 = thisouter6124;
  if (inheritingObject6124) {
    struct UserObject *inho6124 = (struct UserObject *)inheritingObject6124;
    while (inho6124->super != GraceDefaultObject) inho6124 = (struct UserObject *)inho6124->super;
    inho6124->super = obj6124;
    self = inheritingObject6124;
    *selfslot = self;
    lowerouter6124 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6124;
  }
  if (objclass6124 == NULL) {
  Method *reader6126 = addmethodrealflags(obj6124, "kind",&reader_ast_kind_6126, MFLAG_DEF);
  reader6126->definitionModule = modulename;
  reader6126->definitionLine = 1511;
  }
  adddatum2(obj6124, alloc_Undefined(), 1);
  if (objclass6124 == NULL) {
    Method *reader6127 = addmethodrealflags(obj6124, "value", &reader_ast_value_6127, 0);
    Method *writer6127 = addmethodrealflags(obj6124, "value:=(1)", &writer_ast_value_6127, 0);
    reader6127->definitionModule = modulename;
    writer6127->definitionModule = modulename;
    reader6127->definitionLine = 1512;
    writer6127->definitionLine = 1512;
  }
  obj6124->flags |= OFLAG_MUTABLE;
  adddatum2(obj6124, alloc_Undefined(), 2);
  if (objclass6124 == NULL) {
    Method *reader6128 = addmethodrealflags(obj6124, "superclass", &reader_ast_superclass_6128, 0);
    Method *writer6128 = addmethodrealflags(obj6124, "superclass:=(1)", &writer_ast_superclass_6128, 0);
    reader6128->definitionModule = modulename;
    writer6128->definitionModule = modulename;
    reader6128->definitionLine = 1513;
    writer6128->definitionLine = 1513;
  }
  obj6124->flags |= OFLAG_MUTABLE;
  adddatum2(obj6124, alloc_Undefined(), 3);
  if (objclass6124 == NULL) {
    Method *reader6129 = addmethodrealflags(obj6124, "usedTraits", &reader_ast_usedTraits_6129, 0);
    Method *writer6129 = addmethodrealflags(obj6124, "usedTraits:=(1)", &writer_ast_usedTraits_6129, 0);
    reader6129->definitionModule = modulename;
    writer6129->definitionModule = modulename;
    reader6129->definitionLine = 1514;
    writer6129->definitionLine = 1514;
  }
  obj6124->flags |= OFLAG_MUTABLE;
  adddatum2(obj6124, alloc_Undefined(), 4);
  if (objclass6124 == NULL) {
    Method *reader6130 = addmethodrealflags(obj6124, "name", &reader_ast_name_6130, 0);
    Method *writer6130 = addmethodrealflags(obj6124, "name:=(1)", &writer_ast_name_6130, 0);
    reader6130->definitionModule = modulename;
    writer6130->definitionModule = modulename;
    reader6130->definitionLine = 1515;
    writer6130->definitionLine = 1515;
  }
  obj6124->flags |= OFLAG_MUTABLE;
  adddatum2(obj6124, alloc_Undefined(), 5);
  if (objclass6124 == NULL) {
    Method *reader6131 = addmethodrealflags(obj6124, "inClass", &reader_ast_inClass_6131, 0);
    Method *writer6131 = addmethodrealflags(obj6124, "inClass:=(1)", &writer_ast_inClass_6131, 0);
    reader6131->definitionModule = modulename;
    writer6131->definitionModule = modulename;
    reader6131->definitionLine = 1516;
    writer6131->definitionLine = 1516;
  }
  obj6124->flags |= OFLAG_MUTABLE;
  adddatum2(obj6124, alloc_Undefined(), 6);
  if (objclass6124 == NULL) {
    Method *reader6132 = addmethodrealflags(obj6124, "inTrait", &reader_ast_inTrait_6132, 0);
    Method *writer6132 = addmethodrealflags(obj6124, "inTrait:=(1)", &writer_ast_inTrait_6132, 0);
    reader6132->definitionModule = modulename;
    writer6132->definitionModule = modulename;
    reader6132->definitionLine = 1517;
    writer6132->definitionLine = 1517;
  }
  obj6124->flags |= OFLAG_MUTABLE;
  adddatum2(obj6124, alloc_Undefined(), 7);
  if (objclass6124 == NULL) {
    Method *reader6133 = addmethodrealflags(obj6124, "myLocalNames", &reader_ast_myLocalNames_6133, MFLAG_CONFIDENTIAL);
    Method *writer6133 = addmethodrealflags(obj6124, "myLocalNames:=(1)", &writer_ast_myLocalNames_6133, MFLAG_CONFIDENTIAL);
    reader6133->definitionModule = modulename;
    writer6133->definitionModule = modulename;
    reader6133->definitionLine = 1518;
    writer6133->definitionLine = 1518;
  }
  obj6124->flags |= OFLAG_MUTABLE;
  adddatum2(obj6124, alloc_Undefined(), 8);
  if (objclass6124 == NULL) {
    Method *reader6134 = addmethodrealflags(obj6124, "annotations", &reader_ast_annotations_6134, 0);
    Method *writer6134 = addmethodrealflags(obj6124, "annotations:=(1)", &writer_ast_annotations_6134, 0);
    reader6134->definitionModule = modulename;
    writer6134->definitionModule = modulename;
    reader6134->definitionLine = 1519;
    writer6134->definitionLine = 1519;
  }
  obj6124->flags |= OFLAG_MUTABLE;
  adddatum2(obj6124, alloc_Undefined(), 9);
// method "end"
  block_savedest(obj6124);
  Object closure6135 = createclosure(1, "end");
  setclosureframe(closure6135, stackframe);
  addtoclosure(closure6135, var_noPosition);
  struct UserObject *uo6135 = (struct UserObject*)obj6124;
  uo6135->data[10] = (Object)closure6135;
  Method *meth_meth_ast_6135_end = addmethod2pos(obj6124, "end", &meth_ast_6135_end, 10);
  int argcv_meth_ast_6135_end[] = {0};
  meth_meth_ast_6135_end->type = alloc_MethodType(1, argcv_meth_ast_6135_end);
  meth_meth_ast_6135_end->definitionModule = modulename;
  meth_meth_ast_6135_end->definitionLine = 1521;
// method "description"
  struct UserObject *uo6186 = (struct UserObject*)obj6124;
  uo6186->data[11] = emptyclosure;
  Method *meth_meth_ast_6186_description = addmethod2pos(obj6124, "description", &meth_ast_6186_description, 11);
  int argcv_meth_ast_6186_description[] = {0};
  meth_meth_ast_6186_description->type = alloc_MethodType(1, argcv_meth_ast_6186_description);
  meth_meth_ast_6186_description->definitionModule = modulename;
  meth_meth_ast_6186_description->definitionLine = 1533;
// method "isFresh"
  struct UserObject *uo6215 = (struct UserObject*)obj6124;
  uo6215->data[12] = emptyclosure;
  Method *meth_meth_ast_6215_isFresh = addmethod2pos(obj6124, "isFresh", &meth_ast_6215_isFresh, 12);
  int argcv_meth_ast_6215_isFresh[] = {0};
  meth_meth_ast_6215_isFresh->type = alloc_MethodType(1, argcv_meth_ast_6215_isFresh);
  meth_meth_ast_6215_isFresh->definitionModule = modulename;
  meth_meth_ast_6215_isFresh->definitionLine = 1542;
// method "isTrait"
  struct UserObject *uo6217 = (struct UserObject*)obj6124;
  uo6217->data[13] = emptyclosure;
  Method *meth_meth_ast_6217_isTrait = addmethod2pos(obj6124, "isTrait", &meth_ast_6217_isTrait, 13);
  int argcv_meth_ast_6217_isTrait[] = {0};
  meth_meth_ast_6217_isTrait->type = alloc_MethodType(1, argcv_meth_ast_6217_isTrait);
  meth_meth_ast_6217_isTrait->definitionModule = modulename;
  meth_meth_ast_6217_isTrait->definitionLine = 1543;
// method "localNames"
  struct UserObject *uo6244 = (struct UserObject*)obj6124;
  uo6244->data[14] = emptyclosure;
  Method *meth_meth_ast_6244_localNames = addmethod2pos(obj6124, "localNames", &meth_ast_6244_localNames, 14);
  int argcv_meth_ast_6244_localNames[] = {0};
  meth_meth_ast_6244_localNames->type = alloc_MethodType(1, argcv_meth_ast_6244_localNames);
  meth_meth_ast_6244_localNames->definitionModule = modulename;
  meth_meth_ast_6244_localNames->definitionLine = 1555;
// method "parentsDo(_)"
  struct UserObject *uo6279 = (struct UserObject*)obj6124;
  uo6279->data[15] = emptyclosure;
  Method *meth_meth_ast_6279_parentsDo_40_1_41_ = addmethod2pos(obj6124, "parentsDo(1)", &meth_ast_6279_parentsDo_40_1_41_, 15);
  int argcv_meth_ast_6279_parentsDo_40_1_41_[] = {1};
  meth_meth_ast_6279_parentsDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6279_parentsDo_40_1_41_);
  meth_meth_ast_6279_parentsDo_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6279_parentsDo_40_1_41_->definitionLine = 1569;
// method "methodsDo(_)"
  struct UserObject *uo6300 = (struct UserObject*)obj6124;
  uo6300->data[16] = emptyclosure;
  Method *meth_meth_ast_6300_methodsDo_40_1_41_ = addmethod2pos(obj6124, "methodsDo(1)", &meth_ast_6300_methodsDo_40_1_41_, 16);
  int argcv_meth_ast_6300_methodsDo_40_1_41_[] = {1};
  meth_meth_ast_6300_methodsDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6300_methodsDo_40_1_41_);
  meth_meth_ast_6300_methodsDo_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6300_methodsDo_40_1_41_->definitionLine = 1576;
// method "executableComponentsDo(_)"
  struct UserObject *uo6313 = (struct UserObject*)obj6124;
  uo6313->data[17] = emptyclosure;
  Method *meth_meth_ast_6313_executableComponentsDo_40_1_41_ = addmethod2pos(obj6124, "executableComponentsDo(1)", &meth_ast_6313_executableComponentsDo_40_1_41_, 17);
  int argcv_meth_ast_6313_executableComponentsDo_40_1_41_[] = {1};
  meth_meth_ast_6313_executableComponentsDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6313_executableComponentsDo_40_1_41_);
  meth_meth_ast_6313_executableComponentsDo_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6313_executableComponentsDo_40_1_41_->definitionLine = 1584;
// method "scope:=(_)"
  struct UserObject *uo6326 = (struct UserObject*)obj6124;
  uo6326->data[18] = emptyclosure;
  Method *meth_meth_ast_6326_scope_58__61__40_1_41_ = addmethod2pos(obj6124, "scope:=(1)", &meth_ast_6326_scope_58__61__40_1_41_, 18);
  int argcv_meth_ast_6326_scope_58__61__40_1_41_[] = {1};
  meth_meth_ast_6326_scope_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6326_scope_58__61__40_1_41_);
  meth_meth_ast_6326_scope_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_6326_scope_58__61__40_1_41_->definitionLine = 1592;
// method "body"
  struct UserObject *uo6331 = (struct UserObject*)obj6124;
  uo6331->data[19] = emptyclosure;
  Method *meth_meth_ast_6331_body = addmethod2pos(obj6124, "body", &meth_ast_6331_body, 19);
  int argcv_meth_ast_6331_body[] = {0};
  meth_meth_ast_6331_body->type = alloc_MethodType(1, argcv_meth_ast_6331_body);
  meth_meth_ast_6331_body->definitionModule = modulename;
  meth_meth_ast_6331_body->definitionLine = 1598;
// method "returnsObject"
  struct UserObject *uo6334 = (struct UserObject*)obj6124;
  uo6334->data[20] = emptyclosure;
  Method *meth_meth_ast_6334_returnsObject = addmethod2pos(obj6124, "returnsObject", &meth_ast_6334_returnsObject, 20);
  int argcv_meth_ast_6334_returnsObject[] = {0};
  meth_meth_ast_6334_returnsObject->type = alloc_MethodType(1, argcv_meth_ast_6334_returnsObject);
  meth_meth_ast_6334_returnsObject->definitionModule = modulename;
  meth_meth_ast_6334_returnsObject->definitionLine = 1599;
// method "returnedObjectScope"
  struct UserObject *uo6336 = (struct UserObject*)obj6124;
  uo6336->data[21] = emptyclosure;
  Method *meth_meth_ast_6336_returnedObjectScope = addmethod2pos(obj6124, "returnedObjectScope", &meth_ast_6336_returnedObjectScope, 21);
  int argcv_meth_ast_6336_returnedObjectScope[] = {0};
  meth_meth_ast_6336_returnedObjectScope->type = alloc_MethodType(1, argcv_meth_ast_6336_returnedObjectScope);
  meth_meth_ast_6336_returnedObjectScope->definitionModule = modulename;
  meth_meth_ast_6336_returnedObjectScope->definitionLine = 1600;
// method "canInherit"
  struct UserObject *uo6339 = (struct UserObject*)obj6124;
  uo6339->data[22] = emptyclosure;
  Method *meth_meth_ast_6339_canInherit = addmethod2pos(obj6124, "canInherit", &meth_ast_6339_canInherit, 22);
  int argcv_meth_ast_6339_canInherit[] = {0};
  meth_meth_ast_6339_canInherit->type = alloc_MethodType(1, argcv_meth_ast_6339_canInherit);
  meth_meth_ast_6339_canInherit->definitionModule = modulename;
  meth_meth_ast_6339_canInherit->definitionLine = 1601;
// method "canUse"
  struct UserObject *uo6344 = (struct UserObject*)obj6124;
  uo6344->data[23] = emptyclosure;
  Method *meth_meth_ast_6344_canUse = addmethod2pos(obj6124, "canUse", &meth_ast_6344_canUse, 23);
  int argcv_meth_ast_6344_canUse[] = {0};
  meth_meth_ast_6344_canUse->type = alloc_MethodType(1, argcv_meth_ast_6344_canUse);
  meth_meth_ast_6344_canUse->definitionModule = modulename;
  meth_meth_ast_6344_canUse->definitionLine = 1602;
// method "isObject"
  struct UserObject *uo6346 = (struct UserObject*)obj6124;
  uo6346->data[24] = emptyclosure;
  Method *meth_meth_ast_6346_isObject = addmethod2pos(obj6124, "isObject", &meth_ast_6346_isObject, 24);
  int argcv_meth_ast_6346_isObject[] = {0};
  meth_meth_ast_6346_isObject->type = alloc_MethodType(1, argcv_meth_ast_6346_isObject);
  meth_meth_ast_6346_isObject->definitionModule = modulename;
  meth_meth_ast_6346_isObject->definitionLine = 1603;
// method "accept(_)from(_)"
  struct UserObject *uo6348 = (struct UserObject*)obj6124;
  uo6348->data[25] = emptyclosure;
  Method *meth_meth_ast_6348_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj6124, "accept(1)from(1)", &meth_ast_6348_accept_40_1_41_from_40_1_41_, 25);
  int argcv_meth_ast_6348_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_6348_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_6348_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_6348_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6348_accept_40_1_41_from_40_1_41_->definitionLine = 1604;
// method "nameString"
  struct UserObject *uo6383 = (struct UserObject*)obj6124;
  uo6383->data[26] = emptyclosure;
  Method *meth_meth_ast_6383_nameString = addmethod2pos(obj6124, "nameString", &meth_ast_6383_nameString, 26);
  int argcv_meth_ast_6383_nameString[] = {0};
  meth_meth_ast_6383_nameString->type = alloc_MethodType(1, argcv_meth_ast_6383_nameString);
  meth_meth_ast_6383_nameString->definitionModule = modulename;
  meth_meth_ast_6383_nameString->definitionLine = 1614;
// method "map(_)ancestors(_)"
  struct UserObject *uo6403 = (struct UserObject*)obj6124;
  uo6403->data[27] = emptyclosure;
  Method *meth_meth_ast_6403_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj6124, "map(1)ancestors(1)", &meth_ast_6403_map_40_1_41_ancestors_40_1_41_, 27);
  int argcv_meth_ast_6403_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_6403_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_6403_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_6403_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6403_map_40_1_41_ancestors_40_1_41_->definitionLine = 1621;
// method "pretty(_)"
  struct UserObject *uo6428 = (struct UserObject*)obj6124;
  uo6428->data[28] = emptyclosure;
  Method *meth_meth_ast_6428_pretty_40_1_41_ = addmethod2pos(obj6124, "pretty(1)", &meth_ast_6428_pretty_40_1_41_, 28);
  int argcv_meth_ast_6428_pretty_40_1_41_[] = {1};
  meth_meth_ast_6428_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6428_pretty_40_1_41_);
  meth_meth_ast_6428_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6428_pretty_40_1_41_->definitionLine = 1629;
// method "toGrace(_)"
  struct UserObject *uo6573 = (struct UserObject*)obj6124;
  uo6573->data[29] = emptyclosure;
  Method *meth_meth_ast_6573_toGrace_40_1_41_ = addmethod2pos(obj6124, "toGrace(1)", &meth_ast_6573_toGrace_40_1_41_, 29);
  int argcv_meth_ast_6573_toGrace_40_1_41_[] = {1};
  meth_meth_ast_6573_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6573_toGrace_40_1_41_);
meth_meth_ast_6573_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_6573_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_6573_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6573_toGrace_40_1_41_->definitionLine = 1649;
// method "shallowCopy"
  block_savedest(obj6124);
  Object closure6679 = createclosure(2, "shallowCopy");
  setclosureframe(closure6679, stackframe);
  addtoclosure(closure6679, var_emptySeq);
  addtoclosure(closure6679, var_objectNode);
  struct UserObject *uo6679 = (struct UserObject*)obj6124;
  uo6679->data[30] = (Object)closure6679;
  Method *meth_meth_ast_6679_shallowCopy = addmethod2pos(obj6124, "shallowCopy", &meth_ast_6679_shallowCopy, 30);
  int argcv_meth_ast_6679_shallowCopy[] = {0};
  meth_meth_ast_6679_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_6679_shallowCopy);
  meth_meth_ast_6679_shallowCopy->definitionModule = modulename;
  meth_meth_ast_6679_shallowCopy->definitionLine = 1664;
// method "postCopy(_)"
  struct UserObject *uo6685 = (struct UserObject*)obj6124;
  uo6685->data[31] = emptyclosure;
  Method *meth_meth_ast_6685_postCopy_40_1_41_ = addmethod2pos(obj6124, "postCopy(1)", &meth_ast_6685_postCopy_40_1_41_, 31);
  int argcv_meth_ast_6685_postCopy_40_1_41_[] = {1};
  meth_meth_ast_6685_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6685_postCopy_40_1_41_);
  meth_meth_ast_6685_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6685_postCopy_40_1_41_->definitionLine = 1667;
// method "asString"
  struct UserObject *uo6714 = (struct UserObject*)obj6124;
  uo6714->data[32] = emptyclosure;
  Method *meth_meth_ast_6714_asString = addmethod2pos(obj6124, "asString", &meth_ast_6714_asString, 32);
  int argcv_meth_ast_6714_asString[] = {0};
  meth_meth_ast_6714_asString->type = alloc_MethodType(1, argcv_meth_ast_6714_asString);
  meth_meth_ast_6714_asString->definitionModule = modulename;
  meth_meth_ast_6714_asString->definitionLine = 1677;
  sourceObject = obj6124;
// Begin line 1510
  setline(1510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6726 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6727 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6726);
// compiled call node returning call6727 (depth = 3)
  struct UserObject *obj6124_uo = (struct UserObject *)obj6124;
  obj6124_uo->super = call6727;
  sourceObject = obj6124;
// Begin line 1511
  setline(1511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6728 == NULL) {
    strlit6728 = alloc_String("object");
    gc_root(strlit6728);
  }
// compiled string node returning strlit6728 (depth = 3)
  adddatum2(obj6124, strlit6728, 1);
  sourceObject = obj6124;
// Begin line 1512
  setline(1512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_b (depth = 3)
  adddatum2(obj6124, *var_b, 2);
  sourceObject = obj6124;
// Begin line 1513
  setline(1513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_superclass_39_ (depth = 3)
  adddatum2(obj6124, *var_superclass_39_, 3);
  sourceObject = obj6124;
// Begin line 1514
  setline(1514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array6729 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6729 (depth = 3)
  adddatum2(obj6124, array6729, 4);
  sourceObject = obj6124;
// Begin line 1515
  setline(1515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6730 == NULL) {
    strlit6730 = alloc_String("object");
    gc_root(strlit6730);
  }
// compiled string node returning strlit6730 (depth = 3)
  adddatum2(obj6124, strlit6730, 5);
  sourceObject = obj6124;
// Begin line 1516
  setline(1516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6731 = alloc_Boolean(0);
// compiled identifier node returning bool6731 (depth = 3)
  adddatum2(obj6124, bool6731, 6);
  sourceObject = obj6124;
// Begin line 1517
  setline(1517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6732 = alloc_Boolean(0);
// compiled identifier node returning bool6732 (depth = 3)
  adddatum2(obj6124, bool6732, 7);
  sourceObject = obj6124;
// Begin line 1518
  setline(1518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6733 = alloc_Boolean(0);
// compiled identifier node returning bool6733 (depth = 3)
  adddatum2(obj6124, bool6733, 8);
  sourceObject = obj6124;
// Begin line 1519
  setline(1519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array6734 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6734 (depth = 3)
  adddatum2(obj6124, array6734, 9);
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  sourceObject = obj6124;
  objclass6124 = obj6124->class;
  objclass6124->definitionModule = modulename;
  objclass6124->definitionLine = 1509;
  (*(struct UserObject *)self).data[0] = lowerouter6124;
  self = oldself6124;
  selfslot = oldselfslot6124;
  stackframe = oldstackframe6124;
  gc_frame_end(frame);
  return obj6124;
}
Object meth_ast_6736_objectNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 38, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "objectNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_objectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1499
  setline(1499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_objectNode (depth = 3)
  gc_frame_end(frame);
  return *var_objectNode;
}
Object meth_ast_6744_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1688
  setline(1688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6746 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6747 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6748 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6747);
// compiled member node returning call6748 (depth = 5)
  partcv[0] = 0;
  Object call6749 = callmethodflags(call6748, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe6746);
// compiled member node returning call6749 (depth = 4)
  Object if6745 = done;
  if (istrue(call6749)) {
// Begin line 1689
  setline(1689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6750 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6751 == NULL) {
    strlit6751 = alloc_String("]");
    gc_root(strlit6751);
  }
// compiled string node returning strlit6751 (depth = 5)
  gc_frame_newslot(strlit6751);
// starting to compile member node (depth = 5)
  int callframe6752 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6753 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6752);
// compiled member node returning call6753 (depth = 5)
  gc_frame_newslot(call6753);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = strlit6751;
  params[1] = call6753;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6754 = callmethodflags(module_ast, "positionOfNext(1)after(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6750);
// compiled call node returning call6754 (depth = 4)
    gc_frame_newslot(call6754);
    if6745 = call6754;
  } else {
// Begin line 1691
  setline(1691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6755 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6756 == NULL) {
    strlit6756 = alloc_String("]");
    gc_root(strlit6756);
  }
// compiled string node returning strlit6756 (depth = 5)
  gc_frame_newslot(strlit6756);
// starting to compile member node (depth = 5)
  int callframe6757 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6758 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6759 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6760 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6759);
// compiled member node returning call6760 (depth = 7)
  partcv[0] = 0;
  Object call6761 = callmethodflags(call6760, "last", 1, partcv, params, 0);
  gc_frame_end(callframe6758);
// compiled member node returning call6761 (depth = 6)
  partcv[0] = 0;
  Object call6762 = callmethodflags(call6761, "end", 1, partcv, params, 0);
  gc_frame_end(callframe6757);
// compiled member node returning call6762 (depth = 5)
  gc_frame_newslot(call6762);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = strlit6756;
  params[1] = call6762;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6763 = callmethodflags(module_ast, "positionOfNext(1)after(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6755);
// compiled call node returning call6763 (depth = 4)
    gc_frame_newslot(call6763);
    if6745 = call6763;
  }
// compiled if node returning if6745 (depth = 3)
  gc_frame_end(frame);
  return if6745;
}
Object meth_ast_6774__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ax = &(stackframe->slots[0]);
  *var_ax = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1698
  setline(1698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6775 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ax (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6776 = callmethodflags(*var_ax, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6775);
// compiled call node returning call6776 (depth = 6)
  gc_frame_end(frame);
  return call6776;
}
Object meth_ast_6764_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// definebindings:
// Begin line 1695
  setline(1695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6766 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6767 = callmethodflags(*var_visitor, "visitArray(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6766);
// compiled call node returning call6767 (depth = 4)
  Object if6765 = done;
  if (istrue(call6767)) {
// Begin line 1696
  setline(1696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6768 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call6769 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6768);
// compiled call node returning call6769 (depth = 5)
  *var_newChain = call6769;
  if (call6769 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1697
  setline(1697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6770 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6771 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6772 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6771);
// compiled member node returning call6772 (depth = 5)
  gc_frame_newslot(call6772);
// starting to compile block node (depth = 5)
  Object block6773 = alloc_Block(NULL, NULL, "ast", 1697);
  gc_frame_newslot(block6773);
// method "_apply(_)"
  block_savedest(block6773);
  Object closure6774 = createclosure(3, "_apply(1)");
  setclosureframe(closure6774, stackframe);
  addtoclosure(closure6774, var_visitor);
  addtoclosure(closure6774, var_newChain);
  addtoclosure(closure6774, selfslot);
  struct UserObject *uo6774 = (struct UserObject*)block6773;
  uo6774->data[0] = (Object)closure6774;
  Method *meth_meth_ast_6774__apply_40_1_41_ = addmethod2pos(block6773, "_apply(1)", &meth_ast_6774__apply_40_1_41_, 0);
  int argcv_meth_ast_6774__apply_40_1_41_[] = {1};
  meth_meth_ast_6774__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6774__apply_40_1_41_);
  meth_meth_ast_6774__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6774__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block6773 (depth = 5)
  gc_frame_newslot(block6773);
// call case 5: prelude request
  params[0] = call6772;
  params[1] = block6773;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6778 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6770);
// compiled call node returning call6778 (depth = 4)
    gc_frame_newslot(call6778);
    if6765 = call6778;
  } else {
  }
// compiled if node returning if6765 (depth = 3)
  gc_frame_end(frame);
  return if6765;
}
Object meth_ast_6779_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1703
  setline(1703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6780 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6781 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6780);
// compiled member node returning call6781 (depth = 4)
  *var_n = call6781;
  if (call6781 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1704
  setline(1704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6782 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6783 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6782);
// compiled call node returning call6783 (depth = 4)
  *var_newChain = call6783;
  if (call6783 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1705
  setline(1705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6784 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6785 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6786 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6787 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6786);
// compiled member node returning call6787 (depth = 5)
  gc_frame_newslot(call6787);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call6787;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6788 = callmethodflags(module_ast, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6785);
// compiled call node returning call6788 (depth = 4)
  gc_frame_newslot(call6788);
// call case 6: other requests
// Begin line 1705
  setline(1705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6788;
  partcv[0] = 1;
  Object call6789 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6784);
// compiled call node returning call6789 (depth = 3)
// Begin line 1706
  setline(1706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6790 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call6791 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6790);
// compiled call node returning call6791 (depth = 3)
  gc_frame_end(frame);
  return call6791;
}
Object meth_ast_6807__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ax = &(stackframe->slots[0]);
  *var_ax = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1712
  setline(1712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6809 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6811 = alloc_Float64(1);
// compiled num node returning num6811 (depth = 9)
  int op_slot_right_6810 = gc_frame_newslot(num6811);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_6810 = gc_frame_newslot(*var_depth);
  params[0] = num6811;
  partcv[0] = 1;
  Object sum6813 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum6813 (depth = 8)
  gc_frame_newslot(sum6813);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ax (depth = 8)
  params[0] = sum6813;
  partcv[0] = 1;
  Object call6814 = callmethodflags(*var_ax, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6809);
// compiled call node returning call6814 (depth = 7)
  int op_slot_right_6808 = gc_frame_newslot(call6814);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_6816 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6819 == NULL) {
    strlit6819 = alloc_String("""\x0a""");
    gc_root(strlit6819);
  }
// compiled string node returning strlit6819 (depth = 9)
  int op_slot_right_6818 = gc_frame_newslot(strlit6819);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_6818 = gc_frame_newslot(*var_s);
  params[0] = strlit6819;
  partcv[0] = 1;
  Object opresult6821 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6821 (depth = 8)
  int op_slot_left_6816 = gc_frame_newslot(opresult6821);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6822 = callmethod(opresult6821, "++(1)", 1, partcv, params);
// compiled op node returning opresult6822 (depth = 7)
  int op_slot_left_6808 = gc_frame_newslot(opresult6822);
  params[0] = call6814;
  partcv[0] = 1;
  Object opresult6823 = callmethod(opresult6822, "++(1)", 1, partcv, params);
// compiled op node returning opresult6823 (depth = 6)
  *var_s = opresult6823;
  if (opresult6823 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_6792_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1709
  setline(1709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num6795 = alloc_Float64(1);
// compiled num node returning num6795 (depth = 6)
  int op_slot_right_6794 = gc_frame_newslot(num6795);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_6794 = gc_frame_newslot(*var_depth);
  params[0] = num6795;
  partcv[0] = 1;
  Object sum6797 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum6797 (depth = 5)
  int op_slot_right_6793 = gc_frame_newslot(sum6797);
// starting to compile string node (depth = 5)
  if (strlit6799 == NULL) {
    strlit6799 = alloc_String("  ");
    gc_root(strlit6799);
  }
// compiled string node returning strlit6799 (depth = 5)
  int op_slot_left_6793 = gc_frame_newslot(strlit6799);
  params[0] = sum6797;
  partcv[0] = 1;
  Object prod6800 = callmethod(strlit6799, "*(1)", 1, partcv, params);
// compiled op node returning prod6800 (depth = 4)
  *var_spc = prod6800;
  if (prod6800 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1710
  setline(1710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6801 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6802 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6801);
// compiled call node returning call6802 (depth = 4)
  *var_s = call6802;
  if (call6802 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1711
  setline(1711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6803 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6804 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6805 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6804);
// compiled member node returning call6805 (depth = 4)
  gc_frame_newslot(call6805);
// starting to compile block node (depth = 4)
  Object block6806 = alloc_Block(NULL, NULL, "ast", 1711);
  gc_frame_newslot(block6806);
// method "_apply(_)"
  block_savedest(block6806);
  Object closure6807 = createclosure(4, "_apply(1)");
  setclosureframe(closure6807, stackframe);
  addtoclosure(closure6807, var_depth);
  addtoclosure(closure6807, var_spc);
  addtoclosure(closure6807, var_s);
  addtoclosure(closure6807, selfslot);
  struct UserObject *uo6807 = (struct UserObject*)block6806;
  uo6807->data[0] = (Object)closure6807;
  Method *meth_meth_ast_6807__apply_40_1_41_ = addmethod2pos(block6806, "_apply(1)", &meth_ast_6807__apply_40_1_41_, 0);
  int argcv_meth_ast_6807__apply_40_1_41_[] = {1};
  meth_meth_ast_6807__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6807__apply_40_1_41_);
  meth_meth_ast_6807__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6807__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block6806 (depth = 4)
  gc_frame_newslot(block6806);
// call case 5: prelude request
  params[0] = call6805;
  params[1] = block6806;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6826 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6803);
// compiled call node returning call6826 (depth = 3)
// Begin line 1714
  setline(1714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_6835__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6837 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num6838 = alloc_Float64(0);
// compiled num node returning num6838 (depth = 8)
  gc_frame_newslot(num6838);
// call case 6: other requests
// starting to compile call node (depth = 8)
  int callframe6839 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe6840 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6841 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6840);
// compiled member node returning call6841 (depth = 9)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call6842 = callmethodflags(call6841, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6839);
// compiled call node returning call6842 (depth = 8)
  params[0] = num6838;
  partcv[0] = 1;
  Object call6843 = callmethodflags(call6842, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6837);
// compiled call node returning call6843 (depth = 7)
  int op_slot_right_6836 = gc_frame_newslot(call6843);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6836 = gc_frame_newslot(*var_s);
  params[0] = call6843;
  partcv[0] = 1;
  Object opresult6845 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6845 (depth = 6)
  *var_s = opresult6845;
  if (opresult6845 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6849 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe6850 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6851 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6850);
// compiled member node returning call6851 (depth = 8)
  partcv[0] = 0;
  Object call6852 = callmethodflags(call6851, "size", 1, partcv, params, 0);
  gc_frame_end(callframe6849);
// compiled member node returning call6852 (depth = 7)
  int op_slot_right_6848 = gc_frame_newslot(call6852);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  int op_slot_left_6848 = gc_frame_newslot(*var_i);
  params[0] = call6852;
  partcv[0] = 1;
  Object opresult6854 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult6854 (depth = 6)
  Object if6847 = done;
  if (istrue(opresult6854)) {
// Begin line 1721
  setline(1721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6856 == NULL) {
    strlit6856 = alloc_String(", ");
    gc_root(strlit6856);
  }
// compiled string node returning strlit6856 (depth = 8)
  int op_slot_right_6855 = gc_frame_newslot(strlit6856);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6855 = gc_frame_newslot(*var_s);
  params[0] = strlit6856;
  partcv[0] = 1;
  Object opresult6858 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6858 (depth = 7)
  *var_s = opresult6858;
  if (opresult6858 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if6847 = done;
  } else {
  }
// compiled if node returning if6847 (depth = 5)
  gc_frame_end(frame);
  return if6847;
}
Object meth_ast_6827_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1717
  setline(1717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6828 == NULL) {
    strlit6828 = alloc_String("[");
    gc_root(strlit6828);
  }
// compiled string node returning strlit6828 (depth = 4)
  *var_s = strlit6828;
  if (strlit6828 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1718
  setline(1718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6829 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6830 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6831 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6832 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6831);
// compiled member node returning call6832 (depth = 5)
  partcv[0] = 0;
  Object call6833 = callmethodflags(call6832, "indices", 1, partcv, params, 0);
  gc_frame_end(callframe6830);
// compiled member node returning call6833 (depth = 4)
  gc_frame_newslot(call6833);
// starting to compile block node (depth = 4)
  Object block6834 = alloc_Block(NULL, NULL, "ast", 1718);
  gc_frame_newslot(block6834);
// method "_apply(_)"
  block_savedest(block6834);
  Object closure6835 = createclosure(2, "_apply(1)");
  setclosureframe(closure6835, stackframe);
  addtoclosure(closure6835, var_s);
  addtoclosure(closure6835, selfslot);
  struct UserObject *uo6835 = (struct UserObject*)block6834;
  uo6835->data[0] = (Object)closure6835;
  Method *meth_meth_ast_6835__apply_40_1_41_ = addmethod2pos(block6834, "_apply(1)", &meth_ast_6835__apply_40_1_41_, 0);
  int argcv_meth_ast_6835__apply_40_1_41_[] = {1};
  meth_meth_ast_6835__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6835__apply_40_1_41_);
  meth_meth_ast_6835__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6835__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block6834 (depth = 4)
  gc_frame_newslot(block6834);
// call case 5: prelude request
  params[0] = call6833;
  params[1] = block6834;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6861 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6829);
// compiled call node returning call6861 (depth = 3)
// Begin line 1724
  setline(1724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6863 == NULL) {
    strlit6863 = alloc_String("]");
    gc_root(strlit6863);
  }
// compiled string node returning strlit6863 (depth = 5)
  int op_slot_right_6862 = gc_frame_newslot(strlit6863);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_6862 = gc_frame_newslot(*var_s);
  params[0] = strlit6863;
  partcv[0] = 1;
  Object opresult6865 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6865 (depth = 4)
  *var_s = opresult6865;
  if (opresult6865 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1725
  setline(1725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_6867_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_arrayNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1728
  setline(1728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6868 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe6869 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_arrayNode (depth = 5)
  params[0] = *var_emptySeq;
  partcv[0] = 1;
  Object call6870 = callmethodflags(*var_arrayNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6869);
// compiled call node returning call6870 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6871 = callmethodflags(call6870, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6868);
// compiled call node returning call6871 (depth = 3)
  gc_frame_end(frame);
  return call6871;
}
Object meth_ast_6739_new_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_arrayNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_values = &(stackframe->slots[0]);
  *var_values = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6740 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6740 = alloc_userobj2(9,9, objclass6740);
  gc_frame_newslot(obj6740);
  if (objclass6740 == NULL) {
    glfree(obj6740->class->name);
    obj6740->class->name = "arrayNode.new(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj6740, self, 0);
  addmethodreal(obj6740,"outer", &reader_ast_outer_6741);
  Object oldself6740 = self;
  struct StackFrameObject *oldstackframe6740 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6740);
  gc_frame_newslot((Object)stackframe);
  self = obj6740;
  Object *oldselfslot6740 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6740 = (*(struct UserObject *)self).data[0], lowerouter6740 = thisouter6740;
  if (inheritingObject6740) {
    struct UserObject *inho6740 = (struct UserObject *)inheritingObject6740;
    while (inho6740->super != GraceDefaultObject) inho6740 = (struct UserObject *)inho6740->super;
    inho6740->super = obj6740;
    self = inheritingObject6740;
    *selfslot = self;
    lowerouter6740 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6740;
  }
  if (objclass6740 == NULL) {
  Method *reader6742 = addmethodrealflags(obj6740, "kind",&reader_ast_kind_6742, MFLAG_DEF);
  reader6742->definitionModule = modulename;
  reader6742->definitionLine = 1685;
  }
  adddatum2(obj6740, alloc_Undefined(), 1);
  if (objclass6740 == NULL) {
    Method *reader6743 = addmethodrealflags(obj6740, "value", &reader_ast_value_6743, 0);
    Method *writer6743 = addmethodrealflags(obj6740, "value:=(1)", &writer_ast_value_6743, 0);
    reader6743->definitionModule = modulename;
    writer6743->definitionModule = modulename;
    reader6743->definitionLine = 1686;
    writer6743->definitionLine = 1686;
  }
  obj6740->flags |= OFLAG_MUTABLE;
  adddatum2(obj6740, alloc_Undefined(), 2);
// method "end"
  struct UserObject *uo6744 = (struct UserObject*)obj6740;
  uo6744->data[3] = emptyclosure;
  Method *meth_meth_ast_6744_end = addmethod2pos(obj6740, "end", &meth_ast_6744_end, 3);
  int argcv_meth_ast_6744_end[] = {0};
  meth_meth_ast_6744_end->type = alloc_MethodType(1, argcv_meth_ast_6744_end);
  meth_meth_ast_6744_end->definitionModule = modulename;
  meth_meth_ast_6744_end->definitionLine = 1687;
// method "accept(_)from(_)"
  struct UserObject *uo6764 = (struct UserObject*)obj6740;
  uo6764->data[4] = emptyclosure;
  Method *meth_meth_ast_6764_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj6740, "accept(1)from(1)", &meth_ast_6764_accept_40_1_41_from_40_1_41_, 4);
  int argcv_meth_ast_6764_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_6764_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_6764_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_6764_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6764_accept_40_1_41_from_40_1_41_->definitionLine = 1694;
// method "map(_)ancestors(_)"
  struct UserObject *uo6779 = (struct UserObject*)obj6740;
  uo6779->data[5] = emptyclosure;
  Method *meth_meth_ast_6779_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj6740, "map(1)ancestors(1)", &meth_ast_6779_map_40_1_41_ancestors_40_1_41_, 5);
  int argcv_meth_ast_6779_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_6779_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_6779_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_6779_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6779_map_40_1_41_ancestors_40_1_41_->definitionLine = 1702;
// method "pretty(_)"
  struct UserObject *uo6792 = (struct UserObject*)obj6740;
  uo6792->data[6] = emptyclosure;
  Method *meth_meth_ast_6792_pretty_40_1_41_ = addmethod2pos(obj6740, "pretty(1)", &meth_ast_6792_pretty_40_1_41_, 6);
  int argcv_meth_ast_6792_pretty_40_1_41_[] = {1};
  meth_meth_ast_6792_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6792_pretty_40_1_41_);
  meth_meth_ast_6792_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6792_pretty_40_1_41_->definitionLine = 1708;
// method "toGrace(_)"
  struct UserObject *uo6827 = (struct UserObject*)obj6740;
  uo6827->data[7] = emptyclosure;
  Method *meth_meth_ast_6827_toGrace_40_1_41_ = addmethod2pos(obj6740, "toGrace(1)", &meth_ast_6827_toGrace_40_1_41_, 7);
  int argcv_meth_ast_6827_toGrace_40_1_41_[] = {1};
  meth_meth_ast_6827_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6827_toGrace_40_1_41_);
meth_meth_ast_6827_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_6827_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_6827_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6827_toGrace_40_1_41_->definitionLine = 1716;
// method "shallowCopy"
  block_savedest(obj6740);
  Object closure6867 = createclosure(2, "shallowCopy");
  setclosureframe(closure6867, stackframe);
  addtoclosure(closure6867, var_emptySeq);
  addtoclosure(closure6867, var_arrayNode);
  struct UserObject *uo6867 = (struct UserObject*)obj6740;
  uo6867->data[8] = (Object)closure6867;
  Method *meth_meth_ast_6867_shallowCopy = addmethod2pos(obj6740, "shallowCopy", &meth_ast_6867_shallowCopy, 8);
  int argcv_meth_ast_6867_shallowCopy[] = {0};
  meth_meth_ast_6867_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_6867_shallowCopy);
  meth_meth_ast_6867_shallowCopy->definitionModule = modulename;
  meth_meth_ast_6867_shallowCopy->definitionLine = 1727;
  sourceObject = obj6740;
// Begin line 1684
  setline(1684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6872 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6873 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6872);
// compiled call node returning call6873 (depth = 3)
  struct UserObject *obj6740_uo = (struct UserObject *)obj6740;
  obj6740_uo->super = call6873;
  sourceObject = obj6740;
// Begin line 1685
  setline(1685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6874 == NULL) {
    strlit6874 = alloc_String("array");
    gc_root(strlit6874);
  }
// compiled string node returning strlit6874 (depth = 3)
  adddatum2(obj6740, strlit6874, 1);
  sourceObject = obj6740;
// Begin line 1686
  setline(1686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  adddatum2(obj6740, *var_values, 2);
  sourceObject = obj6740;
  sourceObject = obj6740;
  sourceObject = obj6740;
  sourceObject = obj6740;
  sourceObject = obj6740;
  sourceObject = obj6740;
  objclass6740 = obj6740->class;
  objclass6740->definitionModule = modulename;
  objclass6740->definitionLine = 1683;
  (*(struct UserObject *)self).data[0] = lowerouter6740;
  self = oldself6740;
  selfslot = oldselfslot6740;
  stackframe = oldstackframe6740;
  gc_frame_end(frame);
  return obj6740;
}
Object meth_ast_6739_new_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_arrayNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_values = &(stackframe->slots[0]);
  *var_values = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6740 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6740 = alloc_userobj2(9,9, objclass6740);
  gc_frame_newslot(obj6740);
  if (objclass6740 == NULL) {
    glfree(obj6740->class->name);
    obj6740->class->name = "arrayNode.new(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj6740, self, 0);
  addmethodreal(obj6740,"outer", &reader_ast_outer_6741);
  Object oldself6740 = self;
  struct StackFrameObject *oldstackframe6740 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6740);
  gc_frame_newslot((Object)stackframe);
  self = obj6740;
  Object *oldselfslot6740 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6740 = (*(struct UserObject *)self).data[0], lowerouter6740 = thisouter6740;
  if (inheritingObject6740) {
    struct UserObject *inho6740 = (struct UserObject *)inheritingObject6740;
    while (inho6740->super != GraceDefaultObject) inho6740 = (struct UserObject *)inho6740->super;
    inho6740->super = obj6740;
    self = inheritingObject6740;
    *selfslot = self;
    lowerouter6740 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6740;
  }
  if (objclass6740 == NULL) {
  Method *reader6742 = addmethodrealflags(obj6740, "kind",&reader_ast_kind_6742, MFLAG_DEF);
  reader6742->definitionModule = modulename;
  reader6742->definitionLine = 1685;
  }
  adddatum2(obj6740, alloc_Undefined(), 1);
  if (objclass6740 == NULL) {
    Method *reader6743 = addmethodrealflags(obj6740, "value", &reader_ast_value_6743, 0);
    Method *writer6743 = addmethodrealflags(obj6740, "value:=(1)", &writer_ast_value_6743, 0);
    reader6743->definitionModule = modulename;
    writer6743->definitionModule = modulename;
    reader6743->definitionLine = 1686;
    writer6743->definitionLine = 1686;
  }
  obj6740->flags |= OFLAG_MUTABLE;
  adddatum2(obj6740, alloc_Undefined(), 2);
// method "end"
  struct UserObject *uo6744 = (struct UserObject*)obj6740;
  uo6744->data[3] = emptyclosure;
  Method *meth_meth_ast_6744_end = addmethod2pos(obj6740, "end", &meth_ast_6744_end, 3);
  int argcv_meth_ast_6744_end[] = {0};
  meth_meth_ast_6744_end->type = alloc_MethodType(1, argcv_meth_ast_6744_end);
  meth_meth_ast_6744_end->definitionModule = modulename;
  meth_meth_ast_6744_end->definitionLine = 1687;
// method "accept(_)from(_)"
  struct UserObject *uo6764 = (struct UserObject*)obj6740;
  uo6764->data[4] = emptyclosure;
  Method *meth_meth_ast_6764_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj6740, "accept(1)from(1)", &meth_ast_6764_accept_40_1_41_from_40_1_41_, 4);
  int argcv_meth_ast_6764_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_6764_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_6764_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_6764_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6764_accept_40_1_41_from_40_1_41_->definitionLine = 1694;
// method "map(_)ancestors(_)"
  struct UserObject *uo6779 = (struct UserObject*)obj6740;
  uo6779->data[5] = emptyclosure;
  Method *meth_meth_ast_6779_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj6740, "map(1)ancestors(1)", &meth_ast_6779_map_40_1_41_ancestors_40_1_41_, 5);
  int argcv_meth_ast_6779_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_6779_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_6779_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_6779_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6779_map_40_1_41_ancestors_40_1_41_->definitionLine = 1702;
// method "pretty(_)"
  struct UserObject *uo6792 = (struct UserObject*)obj6740;
  uo6792->data[6] = emptyclosure;
  Method *meth_meth_ast_6792_pretty_40_1_41_ = addmethod2pos(obj6740, "pretty(1)", &meth_ast_6792_pretty_40_1_41_, 6);
  int argcv_meth_ast_6792_pretty_40_1_41_[] = {1};
  meth_meth_ast_6792_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6792_pretty_40_1_41_);
  meth_meth_ast_6792_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6792_pretty_40_1_41_->definitionLine = 1708;
// method "toGrace(_)"
  struct UserObject *uo6827 = (struct UserObject*)obj6740;
  uo6827->data[7] = emptyclosure;
  Method *meth_meth_ast_6827_toGrace_40_1_41_ = addmethod2pos(obj6740, "toGrace(1)", &meth_ast_6827_toGrace_40_1_41_, 7);
  int argcv_meth_ast_6827_toGrace_40_1_41_[] = {1};
  meth_meth_ast_6827_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6827_toGrace_40_1_41_);
meth_meth_ast_6827_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_6827_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_6827_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6827_toGrace_40_1_41_->definitionLine = 1716;
// method "shallowCopy"
  block_savedest(obj6740);
  Object closure6867 = createclosure(2, "shallowCopy");
  setclosureframe(closure6867, stackframe);
  addtoclosure(closure6867, var_emptySeq);
  addtoclosure(closure6867, var_arrayNode);
  struct UserObject *uo6867 = (struct UserObject*)obj6740;
  uo6867->data[8] = (Object)closure6867;
  Method *meth_meth_ast_6867_shallowCopy = addmethod2pos(obj6740, "shallowCopy", &meth_ast_6867_shallowCopy, 8);
  int argcv_meth_ast_6867_shallowCopy[] = {0};
  meth_meth_ast_6867_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_6867_shallowCopy);
  meth_meth_ast_6867_shallowCopy->definitionModule = modulename;
  meth_meth_ast_6867_shallowCopy->definitionLine = 1727;
  sourceObject = obj6740;
// Begin line 1684
  setline(1684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6872 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6873 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6872);
// compiled call node returning call6873 (depth = 3)
  struct UserObject *obj6740_uo = (struct UserObject *)obj6740;
  obj6740_uo->super = call6873;
  sourceObject = obj6740;
// Begin line 1685
  setline(1685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6874 == NULL) {
    strlit6874 = alloc_String("array");
    gc_root(strlit6874);
  }
// compiled string node returning strlit6874 (depth = 3)
  adddatum2(obj6740, strlit6874, 1);
  sourceObject = obj6740;
// Begin line 1686
  setline(1686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  adddatum2(obj6740, *var_values, 2);
  sourceObject = obj6740;
  sourceObject = obj6740;
  sourceObject = obj6740;
  sourceObject = obj6740;
  sourceObject = obj6740;
  sourceObject = obj6740;
  objclass6740 = obj6740->class;
  objclass6740->definitionModule = modulename;
  objclass6740->definitionLine = 1683;
  (*(struct UserObject *)self).data[0] = lowerouter6740;
  self = oldself6740;
  selfslot = oldselfslot6740;
  stackframe = oldstackframe6740;
  gc_frame_end(frame);
  return obj6740;
}
Object meth_ast_6876_arrayNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 39, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "arrayNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_arrayNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1682
  setline(1682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arrayNode (depth = 3)
  gc_frame_end(frame);
  return *var_arrayNode;
}
Object meth_ast_6879_new_40_2_41_scope_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new(2)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)scope(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_)scope(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_request = &(stackframe->slots[0]);
  *var_request = args[curarg];
  curarg++;
  Object *var_receiver = &(stackframe->slots[1]);
  *var_receiver = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1765
  setline(1765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6880 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_request (depth = 5)
  gc_frame_newslot(*var_request);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_receiver (depth = 5)
  gc_frame_newslot(*var_receiver);
// call case 4: self request
  params[0] = *var_request;
  params[1] = *var_receiver;
  partcv[0] = 2;
  Object call6881 = callmethodflags(self, "new(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6880);
// compiled call node returning call6881 (depth = 4)
  *var_result = call6881;
  if (call6881 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1766
  setline(1766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6882 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call6883 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6882);
// compiled call node returning call6883 (depth = 3)
// Begin line 1767
  setline(1767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_6893_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_request = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1779
  setline(1779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6894 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6895 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6896 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6897 = callmethodflags(self, "reqPos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6896);
// compiled member node returning call6897 (depth = 5)
  partcv[0] = 0;
  Object call6898 = callmethodflags(call6897, "line", 1, partcv, params, 0);
  gc_frame_end(callframe6895);
// compiled member node returning call6898 (depth = 4)
  gc_frame_newslot(call6898);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num6900 = alloc_Float64(1);
// compiled num node returning num6900 (depth = 5)
  int op_slot_right_6899 = gc_frame_newslot(num6900);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6903 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_request (depth = 7)
  partcv[0] = 0;
  Object call6904 = callmethodflags(*var_request, "size", 1, partcv, params, 0);
  gc_frame_end(callframe6903);
// compiled member node returning call6904 (depth = 6)
  int op_slot_right_6902 = gc_frame_newslot(call6904);
// starting to compile member node (depth = 6)
  int callframe6906 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6907 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6908 = callmethodflags(self, "reqPos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6907);
// compiled member node returning call6908 (depth = 7)
  partcv[0] = 0;
  Object call6909 = callmethodflags(call6908, "column", 1, partcv, params, 0);
  gc_frame_end(callframe6906);
// compiled member node returning call6909 (depth = 6)
  int op_slot_left_6902 = gc_frame_newslot(call6909);
  params[0] = call6904;
  partcv[0] = 1;
  Object sum6910 = callmethod(call6909, "+(1)", 1, partcv, params);
// compiled op node returning sum6910 (depth = 5)
  int op_slot_left_6899 = gc_frame_newslot(sum6910);
  params[0] = num6900;
  partcv[0] = 1;
  Object diff6911 = callmethod(sum6910, "-(1)", 1, partcv, params);
// compiled op node returning diff6911 (depth = 4)
  gc_frame_newslot(diff6911);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = call6898;
  params[1] = diff6911;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6912 = callmethodflags(module_ast, "line(1)column(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6894);
// compiled call node returning call6912 (depth = 3)
  gc_frame_end(frame);
  return call6912;
}
Object meth_ast_6913_onSelf(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "onSelf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1782
  setline(1782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6914 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool6915 = alloc_Boolean(1);
// compiled identifier node returning bool6915 (depth = 4)
  gc_frame_newslot(bool6915);
// call case 4: self request
  params[0] = bool6915;
  partcv[0] = 1;
  Object call6916 = callmethodflags(self, "isSelfRequest:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6914);
// compiled call node returning call6916 (depth = 3)
// Begin line 1783
  setline(1783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_6917_reqPos(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reqPos");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_request = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1787
  setline(1787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6919 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6920 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6921 = callmethodflags(self, "receiver", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6920);
// compiled member node returning call6921 (depth = 5)
  partcv[0] = 0;
  Object call6922 = callmethodflags(call6921, "isImplicit", 1, partcv, params, 0);
  gc_frame_end(callframe6919);
// compiled member node returning call6922 (depth = 4)
  Object if6918 = done;
  if (istrue(call6922)) {
// Begin line 1788
  setline(1788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6923 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6924 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6923);
// compiled member node returning call6924 (depth = 4)
    gc_frame_newslot(call6924);
    if6918 = call6924;
  } else {
// Begin line 1790
  setline(1790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6925 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_request (depth = 5)
  gc_frame_newslot(*var_request);
// starting to compile member node (depth = 5)
  int callframe6926 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6927 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6928 = callmethodflags(self, "receiver", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6927);
// compiled member node returning call6928 (depth = 6)
  partcv[0] = 0;
  Object call6929 = callmethodflags(call6928, "end", 1, partcv, params, 0);
  gc_frame_end(callframe6926);
// compiled member node returning call6929 (depth = 5)
  gc_frame_newslot(call6929);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = *var_request;
  params[1] = call6929;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6930 = callmethodflags(module_ast, "positionOfNext(1)after(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6925);
// compiled call node returning call6930 (depth = 4)
    gc_frame_newslot(call6930);
    if6918 = call6930;
  }
// compiled if node returning if6918 (depth = 3)
  gc_frame_end(frame);
  return if6918;
}
Object meth_ast_6931_nameString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1793
  setline(1793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6932 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6933 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6932);
// compiled member node returning call6933 (depth = 3)
  gc_frame_end(frame);
  return call6933;
}
Object meth_ast_6934_canonicalName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canonicalName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1794
  setline(1794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6935 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6936 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6935);
// compiled member node returning call6936 (depth = 3)
  gc_frame_end(frame);
  return call6936;
}
Object meth_ast_6937_isMember(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1795
  setline(1795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6938 = alloc_Boolean(1);
// compiled identifier node returning bool6938 (depth = 3)
  gc_frame_end(frame);
  return bool6938;
}
Object meth_ast_6939_isCall(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1796
  setline(1796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6940 = alloc_Boolean(1);
// compiled identifier node returning bool6940 (depth = 3)
  gc_frame_end(frame);
  return bool6940;
}
Object meth_ast_6941_parts(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parts");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_requestPart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1798
  setline(1798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6942 = gc_frame_new();
// starting to compile array node (depth = 4)
  Object array6943 = alloc_BuiltinList();
  gc_pause();
// starting to compile call node (depth = 5)
  int callframe6944 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe6945 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6946 = callmethodflags(self, "reqPos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6945);
// compiled member node returning call6946 (depth = 6)
  gc_frame_newslot(call6946);
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe6947 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe6948 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6949 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6948);
// compiled member node returning call6949 (depth = 7)
  gc_frame_newslot(call6949);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_requestPart (depth = 7)
  params[0] = call6949;
  partcv[0] = 1;
  Object call6950 = callmethodflags(*var_requestPart, "request(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6947);
// compiled call node returning call6950 (depth = 6)
  params[0] = call6946;
  partcv[0] = 1;
  Object call6951 = callmethodflags(call6950, "setStart(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6944);
// compiled call node returning call6951 (depth = 5)
  params[0] = call6951;
  partcv[0] = 1;
  callmethodflags(array6943, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array6943 (depth = 4)
  gc_frame_newslot(array6943);
// call case 5: prelude request
  params[0] = array6943;
  partcv[0] = 1;
  Object call6952 = callmethodflags(prelude, "list(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6942);
// compiled call node returning call6952 (depth = 3)
  gc_frame_end(frame);
  return call6952;
}
Object meth_ast_6953_arguments(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "arguments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1799
  setline(1799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySeq (depth = 3)
  gc_frame_end(frame);
  return *var_emptySeq;
}
Object meth_ast_6954_argumentsDo_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "argumentsDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method argumentsDo(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for argumentsDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part argumentsDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  gc_frame_end(frame);
  return done;
}
Object meth_ast_6955_numArgs(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "numArgs");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1801
  setline(1801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num6956 = alloc_Float64(0);
// compiled num node returning num6956 (depth = 3)
  gc_frame_end(frame);
  return num6956;
}
Object meth_ast_6957_numTypeArgs(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "numTypeArgs");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1803
  setline(1803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6960 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6961 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6960);
// compiled member node returning call6961 (depth = 5)
  int op_slot_right_6959 = gc_frame_newslot(call6961);
// starting to compile identifier node (depth = 5)
  Object bool6963 = alloc_Boolean(0);
// compiled identifier node returning bool6963 (depth = 5)
  int op_slot_left_6959 = gc_frame_newslot(bool6963);
  params[0] = call6961;
  partcv[0] = 1;
  Object opresult6964 = callmethod(bool6963, "==(1)", 1, partcv, params);
// compiled op node returning opresult6964 (depth = 4)
  Object if6958 = done;
  if (istrue(opresult6964)) {
// starting to compile num node (depth = 4)
  Object num6965 = alloc_Float64(0);
// compiled num node returning num6965 (depth = 4)
    gc_frame_newslot(num6965);
    if6958 = num6965;
  } else {
// starting to compile member node (depth = 4)
  int callframe6966 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6967 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6968 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6967);
// compiled member node returning call6968 (depth = 5)
  partcv[0] = 0;
  Object call6969 = callmethodflags(call6968, "size", 1, partcv, params, 0);
  gc_frame_end(callframe6966);
// compiled member node returning call6969 (depth = 4)
    gc_frame_newslot(call6969);
    if6958 = call6969;
  }
// compiled if node returning if6958 (depth = 3)
  gc_frame_end(frame);
  return if6958;
}
Object meth_ast_6985__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 7)
  int callframe6986 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6987 = callmethodflags(*var_each, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6986);
// compiled call node returning call6987 (depth = 7)
  gc_frame_end(frame);
  return call6987;
}
Object meth_ast_6970_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// definebindings:
// definebindings:
// definebindings:
// Begin line 1807
  setline(1807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6972 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6973 = callmethodflags(*var_visitor, "visitMember(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6972);
// compiled call node returning call6973 (depth = 4)
  Object if6971 = done;
  if (istrue(call6973)) {
// Begin line 1808
  setline(1808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6974 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call6975 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6974);
// compiled call node returning call6975 (depth = 5)
  *var_newChain = call6975;
  if (call6975 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1809
  setline(1809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6978 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6979 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6978);
// compiled member node returning call6979 (depth = 6)
  int op_slot_right_6977 = gc_frame_newslot(call6979);
// starting to compile identifier node (depth = 6)
  Object bool6981 = alloc_Boolean(0);
// compiled identifier node returning bool6981 (depth = 6)
  int op_slot_left_6977 = gc_frame_newslot(bool6981);
  params[0] = call6979;
  partcv[0] = 1;
  Object opresult6982 = callmethod(bool6981, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6982 (depth = 5)
  Object if6976 = done;
  if (istrue(opresult6982)) {
// Begin line 1810
  setline(1810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6983 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block6984 = alloc_Block(NULL, NULL, "ast", 1810);
  gc_frame_newslot(block6984);
// method "_apply(_)"
  block_savedest(block6984);
  Object closure6985 = createclosure(3, "_apply(1)");
  setclosureframe(closure6985, stackframe);
  addtoclosure(closure6985, var_visitor);
  addtoclosure(closure6985, var_newChain);
  addtoclosure(closure6985, selfslot);
  struct UserObject *uo6985 = (struct UserObject*)block6984;
  uo6985->data[0] = (Object)closure6985;
  Method *meth_meth_ast_6985__apply_40_1_41_ = addmethod2pos(block6984, "_apply(1)", &meth_ast_6985__apply_40_1_41_, 0);
  int argcv_meth_ast_6985__apply_40_1_41_[] = {1};
  meth_meth_ast_6985__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6985__apply_40_1_41_);
  meth_meth_ast_6985__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6985__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block6984 (depth = 6)
  gc_frame_newslot(block6984);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6989 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6990 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6989);
// compiled member node returning call6990 (depth = 6)
  params[0] = block6984;
  partcv[0] = 1;
  Object call6991 = callmethodflags(call6990, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6983);
// compiled call node returning call6991 (depth = 5)
    gc_frame_newslot(call6991);
    if6976 = call6991;
  } else {
  }
// compiled if node returning if6976 (depth = 4)
// Begin line 1812
  setline(1812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6992 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6993 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6994 = callmethodflags(self, "receiver", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6993);
// compiled member node returning call6994 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6995 = callmethodflags(call6994, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6992);
// compiled call node returning call6995 (depth = 4)
    gc_frame_newslot(call6995);
    if6971 = call6995;
  } else {
  }
// compiled if node returning if6971 (depth = 3)
  gc_frame_end(frame);
  return if6971;
}
Object meth_ast_6996_isSelfOrOuter(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSelfOrOuter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1816
  setline(1816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6997 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6998 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6999 = callmethodflags(self, "receiver", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6998);
// compiled member node returning call6999 (depth = 4)
  partcv[0] = 0;
  Object call7000 = callmethodflags(call6999, "isSelfOrOuter", 1, partcv, params, 0);
  gc_frame_end(callframe6997);
// compiled member node returning call7000 (depth = 3)
  gc_frame_end(frame);
  return call7000;
}
Object meth_ast_7001_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1819
  setline(1819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7002 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7003 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7002);
// compiled member node returning call7003 (depth = 4)
  *var_n = call7003;
  if (call7003 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1820
  setline(1820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7004 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7005 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7004);
// compiled call node returning call7005 (depth = 4)
  *var_newChain = call7005;
  if (call7005 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1821
  setline(1821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7006 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7007 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7008 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7009 = callmethodflags(self, "receiver", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7008);
// compiled member node returning call7009 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7010 = callmethodflags(call7009, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7007);
// compiled call node returning call7010 (depth = 4)
  gc_frame_newslot(call7010);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7010;
  partcv[0] = 1;
  Object call7011 = callmethodflags(*var_n, "receiver:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7006);
// compiled call node returning call7011 (depth = 3)
// Begin line 1822
  setline(1822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7012 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7013 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7014 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7015 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7014);
// compiled member node returning call7015 (depth = 5)
  gc_frame_newslot(call7015);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call7015;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call7016 = callmethodflags(module_ast, "maybeListMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7013);
// compiled call node returning call7016 (depth = 4)
  gc_frame_newslot(call7016);
// call case 6: other requests
// Begin line 1822
  setline(1822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7016;
  partcv[0] = 1;
  Object call7017 = callmethodflags(*var_n, "generics:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7012);
// compiled call node returning call7017 (depth = 3)
// Begin line 1823
  setline(1823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7018 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7019 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7018);
// compiled call node returning call7019 (depth = 3)
  gc_frame_end(frame);
  return call7019;
}
Object meth_ast_7088__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1834
  setline(1834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7090 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num7091 = alloc_Float64(0);
// compiled num node returning num7091 (depth = 9)
  gc_frame_newslot(num7091);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_g (depth = 9)
  params[0] = num7091;
  partcv[0] = 1;
  Object call7092 = callmethodflags(*var_g, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7090);
// compiled call node returning call7092 (depth = 8)
  int op_slot_right_7089 = gc_frame_newslot(call7092);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7095 == NULL) {
    strlit7095 = alloc_String("    ");
    gc_root(strlit7095);
  }
// compiled string node returning strlit7095 (depth = 9)
  int op_slot_right_7094 = gc_frame_newslot(strlit7095);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_7097 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit7100 == NULL) {
    strlit7100 = alloc_String("""\x0a""");
    gc_root(strlit7100);
  }
// compiled string node returning strlit7100 (depth = 11)
  int op_slot_right_7099 = gc_frame_newslot(strlit7100);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_7099 = gc_frame_newslot(*var_s);
  params[0] = strlit7100;
  partcv[0] = 1;
  Object opresult7102 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7102 (depth = 10)
  int op_slot_left_7097 = gc_frame_newslot(opresult7102);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7103 = callmethod(opresult7102, "++(1)", 1, partcv, params);
// compiled op node returning opresult7103 (depth = 9)
  int op_slot_left_7094 = gc_frame_newslot(opresult7103);
  params[0] = strlit7095;
  partcv[0] = 1;
  Object opresult7104 = callmethod(opresult7103, "++(1)", 1, partcv, params);
// compiled op node returning opresult7104 (depth = 8)
  int op_slot_left_7089 = gc_frame_newslot(opresult7104);
  params[0] = call7092;
  partcv[0] = 1;
  Object opresult7105 = callmethod(opresult7104, "++(1)", 1, partcv, params);
// compiled op node returning opresult7105 (depth = 7)
  *var_s = opresult7105;
  if (opresult7105 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_7020_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// definebindings:
// definebindings:
// Begin line 1826
  setline(1826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num7023 = alloc_Float64(1);
// compiled num node returning num7023 (depth = 6)
  int op_slot_right_7022 = gc_frame_newslot(num7023);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_7022 = gc_frame_newslot(*var_depth);
  params[0] = num7023;
  partcv[0] = 1;
  Object sum7025 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7025 (depth = 5)
  int op_slot_right_7021 = gc_frame_newslot(sum7025);
// starting to compile string node (depth = 5)
  if (strlit7027 == NULL) {
    strlit7027 = alloc_String("  ");
    gc_root(strlit7027);
  }
// compiled string node returning strlit7027 (depth = 5)
  int op_slot_left_7021 = gc_frame_newslot(strlit7027);
  params[0] = sum7025;
  partcv[0] = 1;
  Object prod7028 = callmethod(strlit7027, "*(1)", 1, partcv, params);
// compiled op node returning prod7028 (depth = 4)
  *var_spc = prod7028;
  if (prod7028 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1827
  setline(1827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7029 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7030 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7029);
// compiled call node returning call7030 (depth = 4)
  *var_s = call7030;
  if (call7030 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1828
  setline(1828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7033 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7034 = callmethodflags(self, "isSelfRequest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7033);
// compiled member node returning call7034 (depth = 6)
  Object if7032 = done;
struct StackFrameObject *iftmpstackframe7032 = stackframe;
  if (istrue(call7034)) {
stackframe = alloc_StackFrame(0, iftmpstackframe7032);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile string node (depth = 6)
  if (strlit7035 == NULL) {
    strlit7035 = alloc_String(" on self ");
    gc_root(strlit7035);
  }
// compiled string node returning strlit7035 (depth = 6)
    gc_frame_newslot(strlit7035);
    if7032 = strlit7035;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe7032);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile string node (depth = 6)
  if (strlit7036 == NULL) {
    strlit7036 = alloc_String(" ");
    gc_root(strlit7036);
  }
// compiled string node returning strlit7036 (depth = 6)
    gc_frame_newslot(strlit7036);
    if7032 = strlit7036;
  }
stackframe = iftmpstackframe7032;
// compiled if node returning if7032 (depth = 5)
  int op_slot_right_7031 = gc_frame_newslot(if7032);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_7031 = gc_frame_newslot(*var_s);
  params[0] = if7032;
  partcv[0] = 1;
  Object opresult7038 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7038 (depth = 4)
  *var_s = opresult7038;
  if (opresult7038 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1829
  setline(1829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7041 == NULL) {
    strlit7041 = alloc_String("""\xe2""""\x80""""\xba""""\x0a""");
    gc_root(strlit7041);
  }
// compiled string node returning strlit7041 (depth = 5)
  int op_slot_right_7040 = gc_frame_newslot(strlit7041);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7044 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7045 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7044);
// compiled member node returning call7045 (depth = 6)
  int op_slot_right_7043 = gc_frame_newslot(call7045);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7048 == NULL) {
    strlit7048 = alloc_String("""\xe2""""\x80""""\xb9""");
    gc_root(strlit7048);
  }
// compiled string node returning strlit7048 (depth = 7)
  int op_slot_right_7047 = gc_frame_newslot(strlit7048);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7047 = gc_frame_newslot(*var_s);
  params[0] = strlit7048;
  partcv[0] = 1;
  Object opresult7050 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7050 (depth = 6)
  int op_slot_left_7043 = gc_frame_newslot(opresult7050);
  params[0] = call7045;
  partcv[0] = 1;
  Object opresult7051 = callmethod(opresult7050, "++(1)", 1, partcv, params);
// compiled op node returning opresult7051 (depth = 5)
  int op_slot_left_7040 = gc_frame_newslot(opresult7051);
  params[0] = strlit7041;
  partcv[0] = 1;
  Object opresult7052 = callmethod(opresult7051, "++(1)", 1, partcv, params);
// compiled op node returning opresult7052 (depth = 4)
  *var_s = opresult7052;
  if (opresult7052 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1830
  setline(1830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7055 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7056 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7057 = callmethodflags(self, "receiver", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7056);
// compiled member node returning call7057 (depth = 6)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7058 = callmethodflags(call7057, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7055);
// compiled call node returning call7058 (depth = 5)
  int op_slot_right_7054 = gc_frame_newslot(call7058);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_7060 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7060 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7062 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7062 (depth = 5)
  int op_slot_left_7054 = gc_frame_newslot(opresult7062);
  params[0] = call7058;
  partcv[0] = 1;
  Object opresult7063 = callmethod(opresult7062, "++(1)", 1, partcv, params);
// compiled op node returning opresult7063 (depth = 4)
  *var_s = opresult7063;
  if (opresult7063 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1831
  setline(1831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7067 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7068 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7067);
// compiled member node returning call7068 (depth = 5)
  int op_slot_right_7066 = gc_frame_newslot(call7068);
// starting to compile identifier node (depth = 5)
  Object bool7070 = alloc_Boolean(0);
// compiled identifier node returning bool7070 (depth = 5)
  int op_slot_left_7066 = gc_frame_newslot(bool7070);
  params[0] = call7068;
  partcv[0] = 1;
  Object opresult7071 = callmethod(bool7070, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7071 (depth = 4)
  Object if7065 = done;
  if (istrue(opresult7071)) {
// Begin line 1832
  setline(1832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7073 == NULL) {
    strlit7073 = alloc_String("  Generics:");
    gc_root(strlit7073);
  }
// compiled string node returning strlit7073 (depth = 6)
  int op_slot_right_7072 = gc_frame_newslot(strlit7073);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_7075 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7078 == NULL) {
    strlit7078 = alloc_String("""\x0a""");
    gc_root(strlit7078);
  }
// compiled string node returning strlit7078 (depth = 8)
  int op_slot_right_7077 = gc_frame_newslot(strlit7078);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7077 = gc_frame_newslot(*var_s);
  params[0] = strlit7078;
  partcv[0] = 1;
  Object opresult7080 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7080 (depth = 7)
  int op_slot_left_7075 = gc_frame_newslot(opresult7080);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7081 = callmethod(opresult7080, "++(1)", 1, partcv, params);
// compiled op node returning opresult7081 (depth = 6)
  int op_slot_left_7072 = gc_frame_newslot(opresult7081);
  params[0] = strlit7073;
  partcv[0] = 1;
  Object opresult7082 = callmethod(opresult7081, "++(1)", 1, partcv, params);
// compiled op node returning opresult7082 (depth = 5)
  *var_s = opresult7082;
  if (opresult7082 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1833
  setline(1833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7084 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7085 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7086 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7085);
// compiled member node returning call7086 (depth = 5)
  gc_frame_newslot(call7086);
// starting to compile block node (depth = 5)
  Object block7087 = alloc_Block(NULL, NULL, "ast", 1833);
  gc_frame_newslot(block7087);
// method "_apply(_)"
  block_savedest(block7087);
  Object closure7088 = createclosure(3, "_apply(1)");
  setclosureframe(closure7088, stackframe);
  addtoclosure(closure7088, var_spc);
  addtoclosure(closure7088, var_s);
  addtoclosure(closure7088, selfslot);
  struct UserObject *uo7088 = (struct UserObject*)block7087;
  uo7088->data[0] = (Object)closure7088;
  Method *meth_meth_ast_7088__apply_40_1_41_ = addmethod2pos(block7087, "_apply(1)", &meth_ast_7088__apply_40_1_41_, 0);
  int argcv_meth_ast_7088__apply_40_1_41_[] = {1};
  meth_meth_ast_7088__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7088__apply_40_1_41_);
  meth_meth_ast_7088__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7088__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block7087 (depth = 5)
  gc_frame_newslot(block7087);
// call case 5: prelude request
  params[0] = call7086;
  params[1] = block7087;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7108 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7084);
// compiled call node returning call7108 (depth = 4)
    gc_frame_newslot(call7108);
    if7065 = call7108;
  } else {
  }
// compiled if node returning if7065 (depth = 3)
// Begin line 1837
  setline(1837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_7149__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1844
  setline(1844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7151 == NULL) {
    strlit7151 = alloc_String(", ");
    gc_root(strlit7151);
  }
// compiled string node returning strlit7151 (depth = 8)
  int op_slot_right_7150 = gc_frame_newslot(strlit7151);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7154 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num7156 = alloc_Float64(1);
// compiled num node returning num7156 (depth = 11)
  int op_slot_right_7155 = gc_frame_newslot(num7156);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_7155 = gc_frame_newslot(*var_depth);
  params[0] = num7156;
  partcv[0] = 1;
  Object sum7158 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7158 (depth = 10)
  gc_frame_newslot(sum7158);
// call case 6: other requests
// starting to compile call node (depth = 10)
  int callframe7159 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_ix (depth = 11)
  gc_frame_newslot(*var_ix);
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe7160 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7161 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7160);
// compiled member node returning call7161 (depth = 11)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call7162 = callmethodflags(call7161, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7159);
// compiled call node returning call7162 (depth = 10)
  params[0] = sum7158;
  partcv[0] = 1;
  Object call7163 = callmethodflags(call7162, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7154);
// compiled call node returning call7163 (depth = 9)
  int op_slot_right_7153 = gc_frame_newslot(call7163);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_7153 = gc_frame_newslot(*var_s);
  params[0] = call7163;
  partcv[0] = 1;
  Object opresult7165 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7165 (depth = 8)
  int op_slot_left_7150 = gc_frame_newslot(opresult7165);
  params[0] = strlit7151;
  partcv[0] = 1;
  Object opresult7166 = callmethod(opresult7165, "++(1)", 1, partcv, params);
// compiled op node returning opresult7166 (depth = 7)
  *var_s = opresult7166;
  if (opresult7166 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_7109_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// definebindings:
// definebindings:
// Begin line 1840
  setline(1840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7111 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7112 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7111);
// compiled member node returning call7112 (depth = 5)
  int op_slot_right_7110 = gc_frame_newslot(call7112);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7115 == NULL) {
    strlit7115 = alloc_String(".");
    gc_root(strlit7115);
  }
// compiled string node returning strlit7115 (depth = 6)
  int op_slot_right_7114 = gc_frame_newslot(strlit7115);
// starting to compile call node (depth = 6)
  int callframe7117 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7118 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7119 = callmethodflags(self, "receiver", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7118);
// compiled member node returning call7119 (depth = 7)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7120 = callmethodflags(call7119, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7117);
// compiled call node returning call7120 (depth = 6)
  int op_slot_left_7114 = gc_frame_newslot(call7120);
  params[0] = strlit7115;
  partcv[0] = 1;
  Object opresult7121 = callmethod(call7120, "++(1)", 1, partcv, params);
// compiled op node returning opresult7121 (depth = 5)
  int op_slot_left_7110 = gc_frame_newslot(opresult7121);
  params[0] = call7112;
  partcv[0] = 1;
  Object opresult7122 = callmethod(opresult7121, "++(1)", 1, partcv, params);
// compiled op node returning opresult7122 (depth = 4)
  *var_s = opresult7122;
  if (opresult7122 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1841
  setline(1841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7125 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7126 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7125);
// compiled member node returning call7126 (depth = 5)
  int op_slot_right_7124 = gc_frame_newslot(call7126);
// starting to compile identifier node (depth = 5)
  Object bool7128 = alloc_Boolean(0);
// compiled identifier node returning bool7128 (depth = 5)
  int op_slot_left_7124 = gc_frame_newslot(bool7128);
  params[0] = call7126;
  partcv[0] = 1;
  Object opresult7129 = callmethod(bool7128, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7129 (depth = 4)
  Object if7123 = done;
  if (istrue(opresult7129)) {
// Begin line 1842
  setline(1842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7131 == NULL) {
    strlit7131 = alloc_String("""\xe2""""\x9f""""\xa6""");
    gc_root(strlit7131);
  }
// compiled string node returning strlit7131 (depth = 6)
  int op_slot_right_7130 = gc_frame_newslot(strlit7131);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7130 = gc_frame_newslot(*var_s);
  params[0] = strlit7131;
  partcv[0] = 1;
  Object opresult7133 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7133 (depth = 5)
  *var_s = opresult7133;
  if (opresult7133 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1843
  setline(1843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7135 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7138 = alloc_Float64(1);
// compiled num node returning num7138 (depth = 7)
  int op_slot_right_7137 = gc_frame_newslot(num7138);
// starting to compile member node (depth = 7)
  int callframe7140 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe7141 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7142 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7141);
// compiled member node returning call7142 (depth = 8)
  partcv[0] = 0;
  Object call7143 = callmethodflags(call7142, "size", 1, partcv, params, 0);
  gc_frame_end(callframe7140);
// compiled member node returning call7143 (depth = 7)
  int op_slot_left_7137 = gc_frame_newslot(call7143);
  params[0] = num7138;
  partcv[0] = 1;
  Object diff7144 = callmethod(call7143, "-(1)", 1, partcv, params);
// compiled op node returning diff7144 (depth = 6)
  int op_slot_right_7136 = gc_frame_newslot(diff7144);
// starting to compile num node (depth = 6)
  Object num7146 = alloc_Float64(1);
// compiled num node returning num7146 (depth = 6)
  int op_slot_left_7136 = gc_frame_newslot(num7146);
  params[0] = diff7144;
  partcv[0] = 1;
  Object opresult7147 = callmethod(num7146, "..(1)", 1, partcv, params);
// compiled op node returning opresult7147 (depth = 5)
  gc_frame_newslot(opresult7147);
// starting to compile block node (depth = 5)
  Object block7148 = alloc_Block(NULL, NULL, "ast", 1843);
  gc_frame_newslot(block7148);
// method "_apply(_)"
  block_savedest(block7148);
  Object closure7149 = createclosure(3, "_apply(1)");
  setclosureframe(closure7149, stackframe);
  addtoclosure(closure7149, var_depth);
  addtoclosure(closure7149, var_s);
  addtoclosure(closure7149, selfslot);
  struct UserObject *uo7149 = (struct UserObject*)block7148;
  uo7149->data[0] = (Object)closure7149;
  Method *meth_meth_ast_7149__apply_40_1_41_ = addmethod2pos(block7148, "_apply(1)", &meth_ast_7149__apply_40_1_41_, 0);
  int argcv_meth_ast_7149__apply_40_1_41_[] = {1};
  meth_meth_ast_7149__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7149__apply_40_1_41_);
  meth_meth_ast_7149__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7149__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block7148 (depth = 5)
  gc_frame_newslot(block7148);
// call case 5: prelude request
  params[0] = opresult7147;
  params[1] = block7148;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7169 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7135);
// compiled call node returning call7169 (depth = 4)
// Begin line 1846
  setline(1846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7171 == NULL) {
    strlit7171 = alloc_String("""\xe2""""\x9f""""\xa7""");
    gc_root(strlit7171);
  }
// compiled string node returning strlit7171 (depth = 6)
  int op_slot_right_7170 = gc_frame_newslot(strlit7171);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7174 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num7176 = alloc_Float64(1);
// compiled num node returning num7176 (depth = 9)
  int op_slot_right_7175 = gc_frame_newslot(num7176);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_7175 = gc_frame_newslot(*var_depth);
  params[0] = num7176;
  partcv[0] = 1;
  Object sum7178 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7178 (depth = 8)
  gc_frame_newslot(sum7178);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe7179 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe7180 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7181 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7180);
// compiled member node returning call7181 (depth = 9)
  partcv[0] = 0;
  Object call7182 = callmethodflags(call7181, "last", 1, partcv, params, 0);
  gc_frame_end(callframe7179);
// compiled member node returning call7182 (depth = 8)
  params[0] = sum7178;
  partcv[0] = 1;
  Object call7183 = callmethodflags(call7182, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7174);
// compiled call node returning call7183 (depth = 7)
  int op_slot_right_7173 = gc_frame_newslot(call7183);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7173 = gc_frame_newslot(*var_s);
  params[0] = call7183;
  partcv[0] = 1;
  Object opresult7185 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7185 (depth = 6)
  int op_slot_left_7170 = gc_frame_newslot(opresult7185);
  params[0] = strlit7171;
  partcv[0] = 1;
  Object opresult7186 = callmethod(opresult7185, "++(1)", 1, partcv, params);
// compiled op node returning opresult7186 (depth = 5)
  *var_s = opresult7186;
  if (opresult7186 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7123 = done;
  } else {
  }
// compiled if node returning if7123 (depth = 3)
// Begin line 1848
  setline(1848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_7188_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1850
  setline(1850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7189 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num7190 = alloc_Float64(0);
// compiled num node returning num7190 (depth = 4)
  gc_frame_newslot(num7190);
// call case 4: self request
  params[0] = num7190;
  partcv[0] = 1;
  Object call7191 = callmethodflags(self, "toGrace(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7189);
// compiled call node returning call7191 (depth = 3)
  gc_frame_end(frame);
  return call7191;
}
Object meth_ast_7192_asIdentifier(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[2];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_resultNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "resultNode");
// Begin line 1853
  setline(1853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7195 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7196 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7195);
// compiled member node returning call7196 (depth = 5)
  int op_slot_right_7194 = gc_frame_newslot(call7196);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_fakeSymbolTable (depth = 5)
  int op_slot_left_7194 = gc_frame_newslot(*var_fakeSymbolTable);
  params[0] = call7196;
  partcv[0] = 1;
  Object opresult7198 = callmethod(*var_fakeSymbolTable, "==(1)", 1, partcv, params);
// compiled op node returning opresult7198 (depth = 4)
  Object if7193 = done;
  if (istrue(opresult7198)) {
// Begin line 1854
  setline(1854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7199 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7201 == NULL) {
    strlit7201 = alloc_String(" when scope was fake");
    gc_root(strlit7201);
  }
// compiled string node returning strlit7201 (depth = 6)
  int op_slot_right_7200 = gc_frame_newslot(strlit7201);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7204 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num7205 = alloc_Float64(0);
// compiled num node returning num7205 (depth = 8)
  gc_frame_newslot(num7205);
// call case 4: self request
  params[0] = num7205;
  partcv[0] = 1;
  Object call7206 = callmethodflags(self, "pretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7204);
// compiled call node returning call7206 (depth = 7)
  int op_slot_right_7203 = gc_frame_newslot(call7206);
// starting to compile string node (depth = 7)
  if (strlit7208 == NULL) {
    strlit7208 = alloc_String("asIdentifier requested on ");
    gc_root(strlit7208);
  }
// compiled string node returning strlit7208 (depth = 7)
  int op_slot_left_7203 = gc_frame_newslot(strlit7208);
  params[0] = call7206;
  partcv[0] = 1;
  Object opresult7209 = callmethod(strlit7208, "++(1)", 1, partcv, params);
// compiled op node returning opresult7209 (depth = 6)
  int op_slot_left_7200 = gc_frame_newslot(opresult7209);
  params[0] = strlit7201;
  partcv[0] = 1;
  Object opresult7210 = callmethod(opresult7209, "++(1)", 1, partcv, params);
// compiled op node returning opresult7210 (depth = 5)
  gc_frame_newslot(opresult7210);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7211 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call7212 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7211);
// compiled member node returning call7212 (depth = 5)
  params[0] = opresult7210;
  partcv[0] = 1;
  Object call7213 = callmethodflags(call7212, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7199);
// compiled call node returning call7213 (depth = 4)
    gc_frame_newslot(call7213);
    if7193 = call7213;
  } else {
  }
// compiled if node returning if7193 (depth = 3)
// Begin line 1856
  setline(1856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7214 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7215 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7216 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7215);
// compiled member node returning call7216 (depth = 5)
  gc_frame_newslot(call7216);
// starting to compile identifier node (depth = 5)
  Object bool7217 = alloc_Boolean(0);
// compiled identifier node returning bool7217 (depth = 5)
  gc_frame_newslot(bool7217);
// starting to compile member node (depth = 5)
  int callframe7218 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7219 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7218);
// compiled member node returning call7219 (depth = 5)
  gc_frame_newslot(call7219);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_identifierNode (depth = 5)
  params[0] = call7216;
  params[1] = bool7217;
  params[2] = call7219;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call7220 = callmethodflags(*var_identifierNode, "new(2)scope(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7214);
// compiled call node returning call7220 (depth = 4)
  *var_resultNode = call7220;
  if (call7220 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1857
  setline(1857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7221 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool7222 = alloc_Boolean(1);
// compiled identifier node returning bool7222 (depth = 4)
  gc_frame_newslot(bool7222);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = bool7222;
  partcv[0] = 1;
  Object call7223 = callmethodflags(*var_resultNode, "inRequest:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7221);
// compiled call node returning call7223 (depth = 3)
// Begin line 1858
  setline(1858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7224 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7225 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7226 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7225);
// compiled member node returning call7226 (depth = 4)
  gc_frame_newslot(call7226);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = call7226;
  partcv[0] = 1;
  Object call7227 = callmethodflags(*var_resultNode, "line:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7224);
// compiled call node returning call7227 (depth = 3)
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7228 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7229 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7230 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7229);
// compiled member node returning call7230 (depth = 4)
  gc_frame_newslot(call7230);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = call7230;
  partcv[0] = 1;
  Object call7231 = callmethodflags(*var_resultNode, "linePos:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7228);
// compiled call node returning call7231 (depth = 3)
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  return *var_resultNode;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_7232_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_memberNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1863
  setline(1863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7233 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe7234 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7235 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7236 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7235);
// compiled member node returning call7236 (depth = 5)
  gc_frame_newslot(call7236);
// starting to compile member node (depth = 5)
  int callframe7237 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7238 = callmethodflags(self, "receiver", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7237);
// compiled member node returning call7238 (depth = 5)
  gc_frame_newslot(call7238);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_memberNode (depth = 5)
  params[0] = call7236;
  params[1] = call7238;
  partcv[0] = 2;
  Object call7239 = callmethodflags(*var_memberNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7234);
// compiled call node returning call7239 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7240 = callmethodflags(call7239, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7233);
// compiled call node returning call7240 (depth = 3)
  gc_frame_end(frame);
  return call7240;
}
Object meth_ast_7241_statementName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7242 == NULL) {
    strlit7242 = alloc_String("expression");
    gc_root(strlit7242);
  }
// compiled string node returning strlit7242 (depth = 3)
  gc_frame_end(frame);
  return strlit7242;
}
Object meth_ast_7243_postCopy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "postCopy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method postCopy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for postCopy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part postCopy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1867
  setline(1867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7244 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7245 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call7246 = callmethodflags(*var_other, "generics", 1, partcv, params, 0);
  gc_frame_end(callframe7245);
// compiled member node returning call7246 (depth = 4)
  gc_frame_newslot(call7246);
// call case 4: self request
  params[0] = call7246;
  partcv[0] = 1;
  Object call7247 = callmethodflags(self, "generics:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7244);
// compiled call node returning call7247 (depth = 3)
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7248 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7249 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call7250 = callmethodflags(*var_other, "isSelfRequest", 1, partcv, params, 0);
  gc_frame_end(callframe7249);
// compiled member node returning call7250 (depth = 4)
  gc_frame_newslot(call7250);
// call case 4: self request
  params[0] = call7250;
  partcv[0] = 1;
  Object call7251 = callmethodflags(self, "isSelfRequest:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7248);
// compiled call node returning call7251 (depth = 3)
// Begin line 1869
  setline(1869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7252 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7253 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call7254 = callmethodflags(*var_other, "isTailCall", 1, partcv, params, 0);
  gc_frame_end(callframe7253);
// compiled member node returning call7254 (depth = 4)
  gc_frame_newslot(call7254);
// call case 4: self request
  params[0] = call7254;
  partcv[0] = 1;
  Object call7255 = callmethodflags(self, "isTailCall:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7252);
// compiled call node returning call7255 (depth = 3)
// Begin line 1870
  setline(1870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_6884_new_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_requestPart = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_fakeSymbolTable = getfromclosure(closure, 2);
  Object *var_identifierNode = getfromclosure(closure, 3);
  Object *var_memberNode = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_request = &(stackframe->slots[0]);
  *var_request = args[curarg];
  curarg++;
  Object *var_receiver_39_ = &(stackframe->slots[1]);
  *var_receiver_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6885 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6885 = alloc_userobj2(33,29, objclass6885);
  gc_frame_newslot(obj6885);
  if (objclass6885 == NULL) {
    glfree(obj6885->class->name);
    obj6885->class->name = "memberNode.new(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj6885, self, 0);
  addmethodreal(obj6885,"outer", &reader_ast_outer_6886);
  Object oldself6885 = self;
  struct StackFrameObject *oldstackframe6885 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6885);
  gc_frame_newslot((Object)stackframe);
  self = obj6885;
  Object *oldselfslot6885 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6885 = (*(struct UserObject *)self).data[0], lowerouter6885 = thisouter6885;
  if (inheritingObject6885) {
    struct UserObject *inho6885 = (struct UserObject *)inheritingObject6885;
    while (inho6885->super != GraceDefaultObject) inho6885 = (struct UserObject *)inho6885->super;
    inho6885->super = obj6885;
    self = inheritingObject6885;
    *selfslot = self;
    lowerouter6885 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6885;
  }
  if (objclass6885 == NULL) {
  Method *reader6887 = addmethodrealflags(obj6885, "kind",&reader_ast_kind_6887, MFLAG_DEF);
  reader6887->definitionModule = modulename;
  reader6887->definitionLine = 1772;
  }
  adddatum2(obj6885, alloc_Undefined(), 1);
  if (objclass6885 == NULL) {
    Method *reader6888 = addmethodrealflags(obj6885, "value", &reader_ast_value_6888, 0);
    Method *writer6888 = addmethodrealflags(obj6885, "value:=(1)", &writer_ast_value_6888, 0);
    reader6888->definitionModule = modulename;
    writer6888->definitionModule = modulename;
    reader6888->definitionLine = 1773;
    writer6888->definitionLine = 1773;
  }
  obj6885->flags |= OFLAG_MUTABLE;
  adddatum2(obj6885, alloc_Undefined(), 2);
  if (objclass6885 == NULL) {
    Method *reader6889 = addmethodrealflags(obj6885, "receiver", &reader_ast_receiver_6889, 0);
    Method *writer6889 = addmethodrealflags(obj6885, "receiver:=(1)", &writer_ast_receiver_6889, 0);
    reader6889->definitionModule = modulename;
    writer6889->definitionModule = modulename;
    reader6889->definitionLine = 1774;
    writer6889->definitionLine = 1774;
  }
  obj6885->flags |= OFLAG_MUTABLE;
  adddatum2(obj6885, alloc_Undefined(), 3);
  if (objclass6885 == NULL) {
    Method *reader6890 = addmethodrealflags(obj6885, "generics", &reader_ast_generics_6890, 0);
    Method *writer6890 = addmethodrealflags(obj6885, "generics:=(1)", &writer_ast_generics_6890, 0);
    reader6890->definitionModule = modulename;
    writer6890->definitionModule = modulename;
    reader6890->definitionLine = 1775;
    writer6890->definitionLine = 1775;
  }
  obj6885->flags |= OFLAG_MUTABLE;
  adddatum2(obj6885, alloc_Undefined(), 4);
  if (objclass6885 == NULL) {
    Method *reader6891 = addmethodrealflags(obj6885, "isSelfRequest", &reader_ast_isSelfRequest_6891, 0);
    Method *writer6891 = addmethodrealflags(obj6885, "isSelfRequest:=(1)", &writer_ast_isSelfRequest_6891, 0);
    reader6891->definitionModule = modulename;
    writer6891->definitionModule = modulename;
    reader6891->definitionLine = 1776;
    writer6891->definitionLine = 1776;
  }
  obj6885->flags |= OFLAG_MUTABLE;
  adddatum2(obj6885, alloc_Undefined(), 5);
  if (objclass6885 == NULL) {
    Method *reader6892 = addmethodrealflags(obj6885, "isTailCall", &reader_ast_isTailCall_6892, 0);
    Method *writer6892 = addmethodrealflags(obj6885, "isTailCall:=(1)", &writer_ast_isTailCall_6892, 0);
    reader6892->definitionModule = modulename;
    writer6892->definitionModule = modulename;
    reader6892->definitionLine = 1777;
    writer6892->definitionLine = 1777;
  }
  obj6885->flags |= OFLAG_MUTABLE;
  adddatum2(obj6885, alloc_Undefined(), 6);
// method "end"
  block_savedest(obj6885);
  Object closure6893 = createclosure(1, "end");
  setclosureframe(closure6893, stackframe);
  addtoclosure(closure6893, var_request);
  struct UserObject *uo6893 = (struct UserObject*)obj6885;
  uo6893->data[7] = (Object)closure6893;
  Method *meth_meth_ast_6893_end = addmethod2pos(obj6885, "end", &meth_ast_6893_end, 7);
  int argcv_meth_ast_6893_end[] = {0};
  meth_meth_ast_6893_end->type = alloc_MethodType(1, argcv_meth_ast_6893_end);
  meth_meth_ast_6893_end->definitionModule = modulename;
  meth_meth_ast_6893_end->definitionLine = 1778;
// method "onSelf"
  struct UserObject *uo6913 = (struct UserObject*)obj6885;
  uo6913->data[8] = emptyclosure;
  Method *meth_meth_ast_6913_onSelf = addmethod2pos(obj6885, "onSelf", &meth_ast_6913_onSelf, 8);
  int argcv_meth_ast_6913_onSelf[] = {0};
  meth_meth_ast_6913_onSelf->type = alloc_MethodType(1, argcv_meth_ast_6913_onSelf);
  meth_meth_ast_6913_onSelf->definitionModule = modulename;
  meth_meth_ast_6913_onSelf->definitionLine = 1781;
// method "reqPos"
  block_savedest(obj6885);
  Object closure6917 = createclosure(1, "reqPos");
  setclosureframe(closure6917, stackframe);
  addtoclosure(closure6917, var_request);
  struct UserObject *uo6917 = (struct UserObject*)obj6885;
  uo6917->data[9] = (Object)closure6917;
  Method *meth_meth_ast_6917_reqPos = addmethod2pos(obj6885, "reqPos", &meth_ast_6917_reqPos, 9);
  int argcv_meth_ast_6917_reqPos[] = {0};
  meth_meth_ast_6917_reqPos->type = alloc_MethodType(1, argcv_meth_ast_6917_reqPos);
  meth_meth_ast_6917_reqPos->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_6917_reqPos->definitionModule = modulename;
  meth_meth_ast_6917_reqPos->definitionLine = 1785;
// method "nameString"
  struct UserObject *uo6931 = (struct UserObject*)obj6885;
  uo6931->data[10] = emptyclosure;
  Method *meth_meth_ast_6931_nameString = addmethod2pos(obj6885, "nameString", &meth_ast_6931_nameString, 10);
  int argcv_meth_ast_6931_nameString[] = {0};
  meth_meth_ast_6931_nameString->type = alloc_MethodType(1, argcv_meth_ast_6931_nameString);
  meth_meth_ast_6931_nameString->definitionModule = modulename;
  meth_meth_ast_6931_nameString->definitionLine = 1793;
// method "canonicalName"
  struct UserObject *uo6934 = (struct UserObject*)obj6885;
  uo6934->data[11] = emptyclosure;
  Method *meth_meth_ast_6934_canonicalName = addmethod2pos(obj6885, "canonicalName", &meth_ast_6934_canonicalName, 11);
  int argcv_meth_ast_6934_canonicalName[] = {0};
  meth_meth_ast_6934_canonicalName->type = alloc_MethodType(1, argcv_meth_ast_6934_canonicalName);
  meth_meth_ast_6934_canonicalName->definitionModule = modulename;
  meth_meth_ast_6934_canonicalName->definitionLine = 1794;
// method "isMember"
  struct UserObject *uo6937 = (struct UserObject*)obj6885;
  uo6937->data[12] = emptyclosure;
  Method *meth_meth_ast_6937_isMember = addmethod2pos(obj6885, "isMember", &meth_ast_6937_isMember, 12);
  int argcv_meth_ast_6937_isMember[] = {0};
  meth_meth_ast_6937_isMember->type = alloc_MethodType(1, argcv_meth_ast_6937_isMember);
  meth_meth_ast_6937_isMember->definitionModule = modulename;
  meth_meth_ast_6937_isMember->definitionLine = 1795;
// method "isCall"
  struct UserObject *uo6939 = (struct UserObject*)obj6885;
  uo6939->data[13] = emptyclosure;
  Method *meth_meth_ast_6939_isCall = addmethod2pos(obj6885, "isCall", &meth_ast_6939_isCall, 13);
  int argcv_meth_ast_6939_isCall[] = {0};
  meth_meth_ast_6939_isCall->type = alloc_MethodType(1, argcv_meth_ast_6939_isCall);
  meth_meth_ast_6939_isCall->definitionModule = modulename;
  meth_meth_ast_6939_isCall->definitionLine = 1796;
// method "parts"
  block_savedest(obj6885);
  Object closure6941 = createclosure(1, "parts");
  setclosureframe(closure6941, stackframe);
  addtoclosure(closure6941, var_requestPart);
  struct UserObject *uo6941 = (struct UserObject*)obj6885;
  uo6941->data[14] = (Object)closure6941;
  Method *meth_meth_ast_6941_parts = addmethod2pos(obj6885, "parts", &meth_ast_6941_parts, 14);
  int argcv_meth_ast_6941_parts[] = {0};
  meth_meth_ast_6941_parts->type = alloc_MethodType(1, argcv_meth_ast_6941_parts);
  meth_meth_ast_6941_parts->definitionModule = modulename;
  meth_meth_ast_6941_parts->definitionLine = 1798;
// method "arguments"
  block_savedest(obj6885);
  Object closure6953 = createclosure(1, "arguments");
  setclosureframe(closure6953, stackframe);
  addtoclosure(closure6953, var_emptySeq);
  struct UserObject *uo6953 = (struct UserObject*)obj6885;
  uo6953->data[15] = (Object)closure6953;
  Method *meth_meth_ast_6953_arguments = addmethod2pos(obj6885, "arguments", &meth_ast_6953_arguments, 15);
  int argcv_meth_ast_6953_arguments[] = {0};
  meth_meth_ast_6953_arguments->type = alloc_MethodType(1, argcv_meth_ast_6953_arguments);
  meth_meth_ast_6953_arguments->definitionModule = modulename;
  meth_meth_ast_6953_arguments->definitionLine = 1799;
// method "argumentsDo(_)"
  struct UserObject *uo6954 = (struct UserObject*)obj6885;
  uo6954->data[16] = emptyclosure;
  Method *meth_meth_ast_6954_argumentsDo_40_1_41_ = addmethod2pos(obj6885, "argumentsDo(1)", &meth_ast_6954_argumentsDo_40_1_41_, 16);
  int argcv_meth_ast_6954_argumentsDo_40_1_41_[] = {1};
  meth_meth_ast_6954_argumentsDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6954_argumentsDo_40_1_41_);
  meth_meth_ast_6954_argumentsDo_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6954_argumentsDo_40_1_41_->definitionLine = 1800;
// method "numArgs"
  struct UserObject *uo6955 = (struct UserObject*)obj6885;
  uo6955->data[17] = emptyclosure;
  Method *meth_meth_ast_6955_numArgs = addmethod2pos(obj6885, "numArgs", &meth_ast_6955_numArgs, 17);
  int argcv_meth_ast_6955_numArgs[] = {0};
  meth_meth_ast_6955_numArgs->type = alloc_MethodType(1, argcv_meth_ast_6955_numArgs);
  meth_meth_ast_6955_numArgs->definitionModule = modulename;
  meth_meth_ast_6955_numArgs->definitionLine = 1801;
// method "numTypeArgs"
  struct UserObject *uo6957 = (struct UserObject*)obj6885;
  uo6957->data[18] = emptyclosure;
  Method *meth_meth_ast_6957_numTypeArgs = addmethod2pos(obj6885, "numTypeArgs", &meth_ast_6957_numTypeArgs, 18);
  int argcv_meth_ast_6957_numTypeArgs[] = {0};
  meth_meth_ast_6957_numTypeArgs->type = alloc_MethodType(1, argcv_meth_ast_6957_numTypeArgs);
  meth_meth_ast_6957_numTypeArgs->definitionModule = modulename;
  meth_meth_ast_6957_numTypeArgs->definitionLine = 1802;
// method "accept(_)from(_)"
  struct UserObject *uo6970 = (struct UserObject*)obj6885;
  uo6970->data[19] = emptyclosure;
  Method *meth_meth_ast_6970_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj6885, "accept(1)from(1)", &meth_ast_6970_accept_40_1_41_from_40_1_41_, 19);
  int argcv_meth_ast_6970_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_6970_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_6970_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_6970_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6970_accept_40_1_41_from_40_1_41_->definitionLine = 1806;
// method "isSelfOrOuter"
  struct UserObject *uo6996 = (struct UserObject*)obj6885;
  uo6996->data[20] = emptyclosure;
  Method *meth_meth_ast_6996_isSelfOrOuter = addmethod2pos(obj6885, "isSelfOrOuter", &meth_ast_6996_isSelfOrOuter, 20);
  int argcv_meth_ast_6996_isSelfOrOuter[] = {0};
  meth_meth_ast_6996_isSelfOrOuter->type = alloc_MethodType(1, argcv_meth_ast_6996_isSelfOrOuter);
  meth_meth_ast_6996_isSelfOrOuter->definitionModule = modulename;
  meth_meth_ast_6996_isSelfOrOuter->definitionLine = 1815;
// method "map(_)ancestors(_)"
  struct UserObject *uo7001 = (struct UserObject*)obj6885;
  uo7001->data[21] = emptyclosure;
  Method *meth_meth_ast_7001_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj6885, "map(1)ancestors(1)", &meth_ast_7001_map_40_1_41_ancestors_40_1_41_, 21);
  int argcv_meth_ast_7001_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_7001_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_7001_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_7001_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7001_map_40_1_41_ancestors_40_1_41_->definitionLine = 1818;
// method "pretty(_)"
  struct UserObject *uo7020 = (struct UserObject*)obj6885;
  uo7020->data[22] = emptyclosure;
  Method *meth_meth_ast_7020_pretty_40_1_41_ = addmethod2pos(obj6885, "pretty(1)", &meth_ast_7020_pretty_40_1_41_, 22);
  int argcv_meth_ast_7020_pretty_40_1_41_[] = {1};
  meth_meth_ast_7020_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7020_pretty_40_1_41_);
  meth_meth_ast_7020_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7020_pretty_40_1_41_->definitionLine = 1825;
// method "toGrace(_)"
  struct UserObject *uo7109 = (struct UserObject*)obj6885;
  uo7109->data[23] = emptyclosure;
  Method *meth_meth_ast_7109_toGrace_40_1_41_ = addmethod2pos(obj6885, "toGrace(1)", &meth_ast_7109_toGrace_40_1_41_, 23);
  int argcv_meth_ast_7109_toGrace_40_1_41_[] = {1};
  meth_meth_ast_7109_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7109_toGrace_40_1_41_);
meth_meth_ast_7109_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_7109_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_7109_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7109_toGrace_40_1_41_->definitionLine = 1839;
// method "asString"
  struct UserObject *uo7188 = (struct UserObject*)obj6885;
  uo7188->data[24] = emptyclosure;
  Method *meth_meth_ast_7188_asString = addmethod2pos(obj6885, "asString", &meth_ast_7188_asString, 24);
  int argcv_meth_ast_7188_asString[] = {0};
  meth_meth_ast_7188_asString->type = alloc_MethodType(1, argcv_meth_ast_7188_asString);
  meth_meth_ast_7188_asString->definitionModule = modulename;
  meth_meth_ast_7188_asString->definitionLine = 1850;
// method "asIdentifier"
  block_savedest(obj6885);
  Object closure7192 = createclosure(2, "asIdentifier");
  setclosureframe(closure7192, stackframe);
  addtoclosure(closure7192, var_fakeSymbolTable);
  addtoclosure(closure7192, var_identifierNode);
  struct UserObject *uo7192 = (struct UserObject*)obj6885;
  uo7192->data[25] = (Object)closure7192;
  Method *meth_meth_ast_7192_asIdentifier = addmethod2pos(obj6885, "asIdentifier", &meth_ast_7192_asIdentifier, 25);
  int argcv_meth_ast_7192_asIdentifier[] = {0};
  meth_meth_ast_7192_asIdentifier->type = alloc_MethodType(1, argcv_meth_ast_7192_asIdentifier);
  meth_meth_ast_7192_asIdentifier->definitionModule = modulename;
  meth_meth_ast_7192_asIdentifier->definitionLine = 1851;
// method "shallowCopy"
  block_savedest(obj6885);
  Object closure7232 = createclosure(1, "shallowCopy");
  setclosureframe(closure7232, stackframe);
  addtoclosure(closure7232, var_memberNode);
  struct UserObject *uo7232 = (struct UserObject*)obj6885;
  uo7232->data[26] = (Object)closure7232;
  Method *meth_meth_ast_7232_shallowCopy = addmethod2pos(obj6885, "shallowCopy", &meth_ast_7232_shallowCopy, 26);
  int argcv_meth_ast_7232_shallowCopy[] = {0};
  meth_meth_ast_7232_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_7232_shallowCopy);
  meth_meth_ast_7232_shallowCopy->definitionModule = modulename;
  meth_meth_ast_7232_shallowCopy->definitionLine = 1862;
// method "statementName"
  struct UserObject *uo7241 = (struct UserObject*)obj6885;
  uo7241->data[27] = emptyclosure;
  Method *meth_meth_ast_7241_statementName = addmethod2pos(obj6885, "statementName", &meth_ast_7241_statementName, 27);
  int argcv_meth_ast_7241_statementName[] = {0};
  meth_meth_ast_7241_statementName->type = alloc_MethodType(1, argcv_meth_ast_7241_statementName);
  meth_meth_ast_7241_statementName->definitionModule = modulename;
  meth_meth_ast_7241_statementName->definitionLine = 1865;
// method "postCopy(_)"
  struct UserObject *uo7243 = (struct UserObject*)obj6885;
  uo7243->data[28] = emptyclosure;
  Method *meth_meth_ast_7243_postCopy_40_1_41_ = addmethod2pos(obj6885, "postCopy(1)", &meth_ast_7243_postCopy_40_1_41_, 28);
  int argcv_meth_ast_7243_postCopy_40_1_41_[] = {1};
  meth_meth_ast_7243_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7243_postCopy_40_1_41_);
  meth_meth_ast_7243_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7243_postCopy_40_1_41_->definitionLine = 1866;
  sourceObject = obj6885;
// Begin line 1771
  setline(1771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7256 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7257 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7256);
// compiled call node returning call7257 (depth = 3)
  struct UserObject *obj6885_uo = (struct UserObject *)obj6885;
  obj6885_uo->super = call7257;
  sourceObject = obj6885;
// Begin line 1772
  setline(1772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7258 == NULL) {
    strlit7258 = alloc_String("member");
    gc_root(strlit7258);
  }
// compiled string node returning strlit7258 (depth = 3)
  adddatum2(obj6885, strlit7258, 1);
  sourceObject = obj6885;
// Begin line 1773
  setline(1773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_request (depth = 3)
  adddatum2(obj6885, *var_request, 2);
  sourceObject = obj6885;
// Begin line 1774
  setline(1774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_receiver_39_ (depth = 3)
  adddatum2(obj6885, *var_receiver_39_, 3);
  sourceObject = obj6885;
// Begin line 1775
  setline(1775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7259 = alloc_Boolean(0);
// compiled identifier node returning bool7259 (depth = 3)
  adddatum2(obj6885, bool7259, 4);
  sourceObject = obj6885;
// Begin line 1776
  setline(1776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7260 = alloc_Boolean(0);
// compiled identifier node returning bool7260 (depth = 3)
  adddatum2(obj6885, bool7260, 5);
  sourceObject = obj6885;
// Begin line 1777
  setline(1777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7261 = alloc_Boolean(0);
// compiled identifier node returning bool7261 (depth = 3)
  adddatum2(obj6885, bool7261, 6);
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  objclass6885 = obj6885->class;
  objclass6885->definitionModule = modulename;
  objclass6885->definitionLine = 1769;
  (*(struct UserObject *)self).data[0] = lowerouter6885;
  self = oldself6885;
  selfslot = oldselfslot6885;
  stackframe = oldstackframe6885;
  gc_frame_end(frame);
  return obj6885;
}
Object meth_ast_6884_new_40_2_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_requestPart = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_fakeSymbolTable = getfromclosure(closure, 2);
  Object *var_identifierNode = getfromclosure(closure, 3);
  Object *var_memberNode = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_request = &(stackframe->slots[0]);
  *var_request = args[curarg];
  curarg++;
  Object *var_receiver_39_ = &(stackframe->slots[1]);
  *var_receiver_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6885 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6885 = alloc_userobj2(33,29, objclass6885);
  gc_frame_newslot(obj6885);
  if (objclass6885 == NULL) {
    glfree(obj6885->class->name);
    obj6885->class->name = "memberNode.new(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj6885, self, 0);
  addmethodreal(obj6885,"outer", &reader_ast_outer_6886);
  Object oldself6885 = self;
  struct StackFrameObject *oldstackframe6885 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6885);
  gc_frame_newslot((Object)stackframe);
  self = obj6885;
  Object *oldselfslot6885 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6885 = (*(struct UserObject *)self).data[0], lowerouter6885 = thisouter6885;
  if (inheritingObject6885) {
    struct UserObject *inho6885 = (struct UserObject *)inheritingObject6885;
    while (inho6885->super != GraceDefaultObject) inho6885 = (struct UserObject *)inho6885->super;
    inho6885->super = obj6885;
    self = inheritingObject6885;
    *selfslot = self;
    lowerouter6885 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6885;
  }
  if (objclass6885 == NULL) {
  Method *reader6887 = addmethodrealflags(obj6885, "kind",&reader_ast_kind_6887, MFLAG_DEF);
  reader6887->definitionModule = modulename;
  reader6887->definitionLine = 1772;
  }
  adddatum2(obj6885, alloc_Undefined(), 1);
  if (objclass6885 == NULL) {
    Method *reader6888 = addmethodrealflags(obj6885, "value", &reader_ast_value_6888, 0);
    Method *writer6888 = addmethodrealflags(obj6885, "value:=(1)", &writer_ast_value_6888, 0);
    reader6888->definitionModule = modulename;
    writer6888->definitionModule = modulename;
    reader6888->definitionLine = 1773;
    writer6888->definitionLine = 1773;
  }
  obj6885->flags |= OFLAG_MUTABLE;
  adddatum2(obj6885, alloc_Undefined(), 2);
  if (objclass6885 == NULL) {
    Method *reader6889 = addmethodrealflags(obj6885, "receiver", &reader_ast_receiver_6889, 0);
    Method *writer6889 = addmethodrealflags(obj6885, "receiver:=(1)", &writer_ast_receiver_6889, 0);
    reader6889->definitionModule = modulename;
    writer6889->definitionModule = modulename;
    reader6889->definitionLine = 1774;
    writer6889->definitionLine = 1774;
  }
  obj6885->flags |= OFLAG_MUTABLE;
  adddatum2(obj6885, alloc_Undefined(), 3);
  if (objclass6885 == NULL) {
    Method *reader6890 = addmethodrealflags(obj6885, "generics", &reader_ast_generics_6890, 0);
    Method *writer6890 = addmethodrealflags(obj6885, "generics:=(1)", &writer_ast_generics_6890, 0);
    reader6890->definitionModule = modulename;
    writer6890->definitionModule = modulename;
    reader6890->definitionLine = 1775;
    writer6890->definitionLine = 1775;
  }
  obj6885->flags |= OFLAG_MUTABLE;
  adddatum2(obj6885, alloc_Undefined(), 4);
  if (objclass6885 == NULL) {
    Method *reader6891 = addmethodrealflags(obj6885, "isSelfRequest", &reader_ast_isSelfRequest_6891, 0);
    Method *writer6891 = addmethodrealflags(obj6885, "isSelfRequest:=(1)", &writer_ast_isSelfRequest_6891, 0);
    reader6891->definitionModule = modulename;
    writer6891->definitionModule = modulename;
    reader6891->definitionLine = 1776;
    writer6891->definitionLine = 1776;
  }
  obj6885->flags |= OFLAG_MUTABLE;
  adddatum2(obj6885, alloc_Undefined(), 5);
  if (objclass6885 == NULL) {
    Method *reader6892 = addmethodrealflags(obj6885, "isTailCall", &reader_ast_isTailCall_6892, 0);
    Method *writer6892 = addmethodrealflags(obj6885, "isTailCall:=(1)", &writer_ast_isTailCall_6892, 0);
    reader6892->definitionModule = modulename;
    writer6892->definitionModule = modulename;
    reader6892->definitionLine = 1777;
    writer6892->definitionLine = 1777;
  }
  obj6885->flags |= OFLAG_MUTABLE;
  adddatum2(obj6885, alloc_Undefined(), 6);
// method "end"
  block_savedest(obj6885);
  Object closure6893 = createclosure(1, "end");
  setclosureframe(closure6893, stackframe);
  addtoclosure(closure6893, var_request);
  struct UserObject *uo6893 = (struct UserObject*)obj6885;
  uo6893->data[7] = (Object)closure6893;
  Method *meth_meth_ast_6893_end = addmethod2pos(obj6885, "end", &meth_ast_6893_end, 7);
  int argcv_meth_ast_6893_end[] = {0};
  meth_meth_ast_6893_end->type = alloc_MethodType(1, argcv_meth_ast_6893_end);
  meth_meth_ast_6893_end->definitionModule = modulename;
  meth_meth_ast_6893_end->definitionLine = 1778;
// method "onSelf"
  struct UserObject *uo6913 = (struct UserObject*)obj6885;
  uo6913->data[8] = emptyclosure;
  Method *meth_meth_ast_6913_onSelf = addmethod2pos(obj6885, "onSelf", &meth_ast_6913_onSelf, 8);
  int argcv_meth_ast_6913_onSelf[] = {0};
  meth_meth_ast_6913_onSelf->type = alloc_MethodType(1, argcv_meth_ast_6913_onSelf);
  meth_meth_ast_6913_onSelf->definitionModule = modulename;
  meth_meth_ast_6913_onSelf->definitionLine = 1781;
// method "reqPos"
  block_savedest(obj6885);
  Object closure6917 = createclosure(1, "reqPos");
  setclosureframe(closure6917, stackframe);
  addtoclosure(closure6917, var_request);
  struct UserObject *uo6917 = (struct UserObject*)obj6885;
  uo6917->data[9] = (Object)closure6917;
  Method *meth_meth_ast_6917_reqPos = addmethod2pos(obj6885, "reqPos", &meth_ast_6917_reqPos, 9);
  int argcv_meth_ast_6917_reqPos[] = {0};
  meth_meth_ast_6917_reqPos->type = alloc_MethodType(1, argcv_meth_ast_6917_reqPos);
  meth_meth_ast_6917_reqPos->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_6917_reqPos->definitionModule = modulename;
  meth_meth_ast_6917_reqPos->definitionLine = 1785;
// method "nameString"
  struct UserObject *uo6931 = (struct UserObject*)obj6885;
  uo6931->data[10] = emptyclosure;
  Method *meth_meth_ast_6931_nameString = addmethod2pos(obj6885, "nameString", &meth_ast_6931_nameString, 10);
  int argcv_meth_ast_6931_nameString[] = {0};
  meth_meth_ast_6931_nameString->type = alloc_MethodType(1, argcv_meth_ast_6931_nameString);
  meth_meth_ast_6931_nameString->definitionModule = modulename;
  meth_meth_ast_6931_nameString->definitionLine = 1793;
// method "canonicalName"
  struct UserObject *uo6934 = (struct UserObject*)obj6885;
  uo6934->data[11] = emptyclosure;
  Method *meth_meth_ast_6934_canonicalName = addmethod2pos(obj6885, "canonicalName", &meth_ast_6934_canonicalName, 11);
  int argcv_meth_ast_6934_canonicalName[] = {0};
  meth_meth_ast_6934_canonicalName->type = alloc_MethodType(1, argcv_meth_ast_6934_canonicalName);
  meth_meth_ast_6934_canonicalName->definitionModule = modulename;
  meth_meth_ast_6934_canonicalName->definitionLine = 1794;
// method "isMember"
  struct UserObject *uo6937 = (struct UserObject*)obj6885;
  uo6937->data[12] = emptyclosure;
  Method *meth_meth_ast_6937_isMember = addmethod2pos(obj6885, "isMember", &meth_ast_6937_isMember, 12);
  int argcv_meth_ast_6937_isMember[] = {0};
  meth_meth_ast_6937_isMember->type = alloc_MethodType(1, argcv_meth_ast_6937_isMember);
  meth_meth_ast_6937_isMember->definitionModule = modulename;
  meth_meth_ast_6937_isMember->definitionLine = 1795;
// method "isCall"
  struct UserObject *uo6939 = (struct UserObject*)obj6885;
  uo6939->data[13] = emptyclosure;
  Method *meth_meth_ast_6939_isCall = addmethod2pos(obj6885, "isCall", &meth_ast_6939_isCall, 13);
  int argcv_meth_ast_6939_isCall[] = {0};
  meth_meth_ast_6939_isCall->type = alloc_MethodType(1, argcv_meth_ast_6939_isCall);
  meth_meth_ast_6939_isCall->definitionModule = modulename;
  meth_meth_ast_6939_isCall->definitionLine = 1796;
// method "parts"
  block_savedest(obj6885);
  Object closure6941 = createclosure(1, "parts");
  setclosureframe(closure6941, stackframe);
  addtoclosure(closure6941, var_requestPart);
  struct UserObject *uo6941 = (struct UserObject*)obj6885;
  uo6941->data[14] = (Object)closure6941;
  Method *meth_meth_ast_6941_parts = addmethod2pos(obj6885, "parts", &meth_ast_6941_parts, 14);
  int argcv_meth_ast_6941_parts[] = {0};
  meth_meth_ast_6941_parts->type = alloc_MethodType(1, argcv_meth_ast_6941_parts);
  meth_meth_ast_6941_parts->definitionModule = modulename;
  meth_meth_ast_6941_parts->definitionLine = 1798;
// method "arguments"
  block_savedest(obj6885);
  Object closure6953 = createclosure(1, "arguments");
  setclosureframe(closure6953, stackframe);
  addtoclosure(closure6953, var_emptySeq);
  struct UserObject *uo6953 = (struct UserObject*)obj6885;
  uo6953->data[15] = (Object)closure6953;
  Method *meth_meth_ast_6953_arguments = addmethod2pos(obj6885, "arguments", &meth_ast_6953_arguments, 15);
  int argcv_meth_ast_6953_arguments[] = {0};
  meth_meth_ast_6953_arguments->type = alloc_MethodType(1, argcv_meth_ast_6953_arguments);
  meth_meth_ast_6953_arguments->definitionModule = modulename;
  meth_meth_ast_6953_arguments->definitionLine = 1799;
// method "argumentsDo(_)"
  struct UserObject *uo6954 = (struct UserObject*)obj6885;
  uo6954->data[16] = emptyclosure;
  Method *meth_meth_ast_6954_argumentsDo_40_1_41_ = addmethod2pos(obj6885, "argumentsDo(1)", &meth_ast_6954_argumentsDo_40_1_41_, 16);
  int argcv_meth_ast_6954_argumentsDo_40_1_41_[] = {1};
  meth_meth_ast_6954_argumentsDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6954_argumentsDo_40_1_41_);
  meth_meth_ast_6954_argumentsDo_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6954_argumentsDo_40_1_41_->definitionLine = 1800;
// method "numArgs"
  struct UserObject *uo6955 = (struct UserObject*)obj6885;
  uo6955->data[17] = emptyclosure;
  Method *meth_meth_ast_6955_numArgs = addmethod2pos(obj6885, "numArgs", &meth_ast_6955_numArgs, 17);
  int argcv_meth_ast_6955_numArgs[] = {0};
  meth_meth_ast_6955_numArgs->type = alloc_MethodType(1, argcv_meth_ast_6955_numArgs);
  meth_meth_ast_6955_numArgs->definitionModule = modulename;
  meth_meth_ast_6955_numArgs->definitionLine = 1801;
// method "numTypeArgs"
  struct UserObject *uo6957 = (struct UserObject*)obj6885;
  uo6957->data[18] = emptyclosure;
  Method *meth_meth_ast_6957_numTypeArgs = addmethod2pos(obj6885, "numTypeArgs", &meth_ast_6957_numTypeArgs, 18);
  int argcv_meth_ast_6957_numTypeArgs[] = {0};
  meth_meth_ast_6957_numTypeArgs->type = alloc_MethodType(1, argcv_meth_ast_6957_numTypeArgs);
  meth_meth_ast_6957_numTypeArgs->definitionModule = modulename;
  meth_meth_ast_6957_numTypeArgs->definitionLine = 1802;
// method "accept(_)from(_)"
  struct UserObject *uo6970 = (struct UserObject*)obj6885;
  uo6970->data[19] = emptyclosure;
  Method *meth_meth_ast_6970_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj6885, "accept(1)from(1)", &meth_ast_6970_accept_40_1_41_from_40_1_41_, 19);
  int argcv_meth_ast_6970_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_6970_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_6970_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_6970_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6970_accept_40_1_41_from_40_1_41_->definitionLine = 1806;
// method "isSelfOrOuter"
  struct UserObject *uo6996 = (struct UserObject*)obj6885;
  uo6996->data[20] = emptyclosure;
  Method *meth_meth_ast_6996_isSelfOrOuter = addmethod2pos(obj6885, "isSelfOrOuter", &meth_ast_6996_isSelfOrOuter, 20);
  int argcv_meth_ast_6996_isSelfOrOuter[] = {0};
  meth_meth_ast_6996_isSelfOrOuter->type = alloc_MethodType(1, argcv_meth_ast_6996_isSelfOrOuter);
  meth_meth_ast_6996_isSelfOrOuter->definitionModule = modulename;
  meth_meth_ast_6996_isSelfOrOuter->definitionLine = 1815;
// method "map(_)ancestors(_)"
  struct UserObject *uo7001 = (struct UserObject*)obj6885;
  uo7001->data[21] = emptyclosure;
  Method *meth_meth_ast_7001_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj6885, "map(1)ancestors(1)", &meth_ast_7001_map_40_1_41_ancestors_40_1_41_, 21);
  int argcv_meth_ast_7001_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_7001_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_7001_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_7001_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7001_map_40_1_41_ancestors_40_1_41_->definitionLine = 1818;
// method "pretty(_)"
  struct UserObject *uo7020 = (struct UserObject*)obj6885;
  uo7020->data[22] = emptyclosure;
  Method *meth_meth_ast_7020_pretty_40_1_41_ = addmethod2pos(obj6885, "pretty(1)", &meth_ast_7020_pretty_40_1_41_, 22);
  int argcv_meth_ast_7020_pretty_40_1_41_[] = {1};
  meth_meth_ast_7020_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7020_pretty_40_1_41_);
  meth_meth_ast_7020_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7020_pretty_40_1_41_->definitionLine = 1825;
// method "toGrace(_)"
  struct UserObject *uo7109 = (struct UserObject*)obj6885;
  uo7109->data[23] = emptyclosure;
  Method *meth_meth_ast_7109_toGrace_40_1_41_ = addmethod2pos(obj6885, "toGrace(1)", &meth_ast_7109_toGrace_40_1_41_, 23);
  int argcv_meth_ast_7109_toGrace_40_1_41_[] = {1};
  meth_meth_ast_7109_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7109_toGrace_40_1_41_);
meth_meth_ast_7109_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_7109_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_7109_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7109_toGrace_40_1_41_->definitionLine = 1839;
// method "asString"
  struct UserObject *uo7188 = (struct UserObject*)obj6885;
  uo7188->data[24] = emptyclosure;
  Method *meth_meth_ast_7188_asString = addmethod2pos(obj6885, "asString", &meth_ast_7188_asString, 24);
  int argcv_meth_ast_7188_asString[] = {0};
  meth_meth_ast_7188_asString->type = alloc_MethodType(1, argcv_meth_ast_7188_asString);
  meth_meth_ast_7188_asString->definitionModule = modulename;
  meth_meth_ast_7188_asString->definitionLine = 1850;
// method "asIdentifier"
  block_savedest(obj6885);
  Object closure7192 = createclosure(2, "asIdentifier");
  setclosureframe(closure7192, stackframe);
  addtoclosure(closure7192, var_fakeSymbolTable);
  addtoclosure(closure7192, var_identifierNode);
  struct UserObject *uo7192 = (struct UserObject*)obj6885;
  uo7192->data[25] = (Object)closure7192;
  Method *meth_meth_ast_7192_asIdentifier = addmethod2pos(obj6885, "asIdentifier", &meth_ast_7192_asIdentifier, 25);
  int argcv_meth_ast_7192_asIdentifier[] = {0};
  meth_meth_ast_7192_asIdentifier->type = alloc_MethodType(1, argcv_meth_ast_7192_asIdentifier);
  meth_meth_ast_7192_asIdentifier->definitionModule = modulename;
  meth_meth_ast_7192_asIdentifier->definitionLine = 1851;
// method "shallowCopy"
  block_savedest(obj6885);
  Object closure7232 = createclosure(1, "shallowCopy");
  setclosureframe(closure7232, stackframe);
  addtoclosure(closure7232, var_memberNode);
  struct UserObject *uo7232 = (struct UserObject*)obj6885;
  uo7232->data[26] = (Object)closure7232;
  Method *meth_meth_ast_7232_shallowCopy = addmethod2pos(obj6885, "shallowCopy", &meth_ast_7232_shallowCopy, 26);
  int argcv_meth_ast_7232_shallowCopy[] = {0};
  meth_meth_ast_7232_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_7232_shallowCopy);
  meth_meth_ast_7232_shallowCopy->definitionModule = modulename;
  meth_meth_ast_7232_shallowCopy->definitionLine = 1862;
// method "statementName"
  struct UserObject *uo7241 = (struct UserObject*)obj6885;
  uo7241->data[27] = emptyclosure;
  Method *meth_meth_ast_7241_statementName = addmethod2pos(obj6885, "statementName", &meth_ast_7241_statementName, 27);
  int argcv_meth_ast_7241_statementName[] = {0};
  meth_meth_ast_7241_statementName->type = alloc_MethodType(1, argcv_meth_ast_7241_statementName);
  meth_meth_ast_7241_statementName->definitionModule = modulename;
  meth_meth_ast_7241_statementName->definitionLine = 1865;
// method "postCopy(_)"
  struct UserObject *uo7243 = (struct UserObject*)obj6885;
  uo7243->data[28] = emptyclosure;
  Method *meth_meth_ast_7243_postCopy_40_1_41_ = addmethod2pos(obj6885, "postCopy(1)", &meth_ast_7243_postCopy_40_1_41_, 28);
  int argcv_meth_ast_7243_postCopy_40_1_41_[] = {1};
  meth_meth_ast_7243_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7243_postCopy_40_1_41_);
  meth_meth_ast_7243_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7243_postCopy_40_1_41_->definitionLine = 1866;
  sourceObject = obj6885;
// Begin line 1771
  setline(1771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7256 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7257 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7256);
// compiled call node returning call7257 (depth = 3)
  struct UserObject *obj6885_uo = (struct UserObject *)obj6885;
  obj6885_uo->super = call7257;
  sourceObject = obj6885;
// Begin line 1772
  setline(1772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7258 == NULL) {
    strlit7258 = alloc_String("member");
    gc_root(strlit7258);
  }
// compiled string node returning strlit7258 (depth = 3)
  adddatum2(obj6885, strlit7258, 1);
  sourceObject = obj6885;
// Begin line 1773
  setline(1773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_request (depth = 3)
  adddatum2(obj6885, *var_request, 2);
  sourceObject = obj6885;
// Begin line 1774
  setline(1774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_receiver_39_ (depth = 3)
  adddatum2(obj6885, *var_receiver_39_, 3);
  sourceObject = obj6885;
// Begin line 1775
  setline(1775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7259 = alloc_Boolean(0);
// compiled identifier node returning bool7259 (depth = 3)
  adddatum2(obj6885, bool7259, 4);
  sourceObject = obj6885;
// Begin line 1776
  setline(1776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7260 = alloc_Boolean(0);
// compiled identifier node returning bool7260 (depth = 3)
  adddatum2(obj6885, bool7260, 5);
  sourceObject = obj6885;
// Begin line 1777
  setline(1777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7261 = alloc_Boolean(0);
// compiled identifier node returning bool7261 (depth = 3)
  adddatum2(obj6885, bool7261, 6);
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  sourceObject = obj6885;
  objclass6885 = obj6885->class;
  objclass6885->definitionModule = modulename;
  objclass6885->definitionLine = 1769;
  (*(struct UserObject *)self).data[0] = lowerouter6885;
  self = oldself6885;
  selfslot = oldselfslot6885;
  stackframe = oldstackframe6885;
  gc_frame_end(frame);
  return obj6885;
}
Object meth_ast_7263_memberNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 40, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "memberNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_memberNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1762
  setline(1762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_memberNode (depth = 3)
  gc_frame_end(frame);
  return *var_memberNode;
}
Object meth_ast_7272_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1883
  setline(1883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7273 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7274 == NULL) {
    strlit7274 = alloc_String("""\xe2""""\x9f""""\xa7""");
    gc_root(strlit7274);
  }
// compiled string node returning strlit7274 (depth = 4)
  gc_frame_newslot(strlit7274);
// starting to compile member node (depth = 4)
  int callframe7275 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7276 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7277 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7278 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7277);
// compiled member node returning call7278 (depth = 6)
  partcv[0] = 0;
  Object call7279 = callmethodflags(call7278, "last", 1, partcv, params, 0);
  gc_frame_end(callframe7276);
// compiled member node returning call7279 (depth = 5)
  partcv[0] = 0;
  Object call7280 = callmethodflags(call7279, "end", 1, partcv, params, 0);
  gc_frame_end(callframe7275);
// compiled member node returning call7280 (depth = 4)
  gc_frame_newslot(call7280);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = strlit7274;
  params[1] = call7280;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7281 = callmethodflags(module_ast, "positionOfNext(1)after(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7273);
// compiled call node returning call7281 (depth = 3)
  gc_frame_end(frame);
  return call7281;
}
Object meth_ast_7282_nameString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1884
  setline(1884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7283 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7284 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7285 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7284);
// compiled member node returning call7285 (depth = 4)
  partcv[0] = 0;
  Object call7286 = callmethodflags(call7285, "nameString", 1, partcv, params, 0);
  gc_frame_end(callframe7283);
// compiled member node returning call7286 (depth = 3)
  gc_frame_end(frame);
  return call7286;
}
Object meth_ast_7287_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1885
  setline(1885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7288 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num7289 = alloc_Float64(0);
// compiled num node returning num7289 (depth = 4)
  gc_frame_newslot(num7289);
// call case 4: self request
  params[0] = num7289;
  partcv[0] = 1;
  Object call7290 = callmethodflags(self, "toGrace(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7288);
// compiled call node returning call7290 (depth = 3)
  gc_frame_end(frame);
  return call7290;
}
Object meth_ast_7305__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1891
  setline(1891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7306 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7307 = callmethodflags(*var_p, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7306);
// compiled call node returning call7307 (depth = 6)
  gc_frame_end(frame);
  return call7307;
}
Object meth_ast_7291_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// definebindings:
// Begin line 1887
  setline(1887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7293 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7294 = callmethodflags(*var_visitor, "visitGeneric(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7293);
// compiled call node returning call7294 (depth = 4)
  Object if7292 = done;
  if (istrue(call7294)) {
// Begin line 1888
  setline(1888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7295 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call7296 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7295);
// compiled call node returning call7296 (depth = 5)
  *var_newChain = call7296;
  if (call7296 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1889
  setline(1889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7297 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7298 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7299 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7298);
// compiled member node returning call7299 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7300 = callmethodflags(call7299, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7297);
// compiled call node returning call7300 (depth = 4)
// Begin line 1890
  setline(1890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7301 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7302 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7303 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7302);
// compiled member node returning call7303 (depth = 5)
  gc_frame_newslot(call7303);
// starting to compile block node (depth = 5)
  Object block7304 = alloc_Block(NULL, NULL, "ast", 1890);
  gc_frame_newslot(block7304);
// method "_apply(_)"
  block_savedest(block7304);
  Object closure7305 = createclosure(3, "_apply(1)");
  setclosureframe(closure7305, stackframe);
  addtoclosure(closure7305, var_visitor);
  addtoclosure(closure7305, var_newChain);
  addtoclosure(closure7305, selfslot);
  struct UserObject *uo7305 = (struct UserObject*)block7304;
  uo7305->data[0] = (Object)closure7305;
  Method *meth_meth_ast_7305__apply_40_1_41_ = addmethod2pos(block7304, "_apply(1)", &meth_ast_7305__apply_40_1_41_, 0);
  int argcv_meth_ast_7305__apply_40_1_41_[] = {1};
  meth_meth_ast_7305__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7305__apply_40_1_41_);
  meth_meth_ast_7305__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7305__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block7304 (depth = 5)
  gc_frame_newslot(block7304);
// call case 5: prelude request
  params[0] = call7303;
  params[1] = block7304;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7309 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7301);
// compiled call node returning call7309 (depth = 4)
    gc_frame_newslot(call7309);
    if7292 = call7309;
  } else {
  }
// compiled if node returning if7292 (depth = 3)
  gc_frame_end(frame);
  return if7292;
}
Object meth_ast_7310_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1896
  setline(1896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7311 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7312 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7311);
// compiled member node returning call7312 (depth = 4)
  *var_n = call7312;
  if (call7312 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1897
  setline(1897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7313 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7314 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7313);
// compiled call node returning call7314 (depth = 4)
  *var_newChain = call7314;
  if (call7314 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1898
  setline(1898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7315 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7316 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7317 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7318 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7317);
// compiled member node returning call7318 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7319 = callmethodflags(call7318, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7316);
// compiled call node returning call7319 (depth = 4)
  gc_frame_newslot(call7319);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7319;
  partcv[0] = 1;
  Object call7320 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7315);
// compiled call node returning call7320 (depth = 3)
// Begin line 1899
  setline(1899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7321 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7322 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7323 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7324 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7323);
// compiled member node returning call7324 (depth = 5)
  gc_frame_newslot(call7324);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call7324;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call7325 = callmethodflags(module_ast, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7322);
// compiled call node returning call7325 (depth = 4)
  gc_frame_newslot(call7325);
// call case 6: other requests
// Begin line 1899
  setline(1899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7325;
  partcv[0] = 1;
  Object call7326 = callmethodflags(*var_n, "args:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7321);
// compiled call node returning call7326 (depth = 3)
// Begin line 1900
  setline(1900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7327 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7328 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7327);
// compiled call node returning call7328 (depth = 3)
  gc_frame_end(frame);
  return call7328;
}
Object meth_ast_7353__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7355 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num7357 = alloc_Float64(2);
// compiled num node returning num7357 (depth = 9)
  int op_slot_right_7356 = gc_frame_newslot(num7357);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_7356 = gc_frame_newslot(*var_depth);
  params[0] = num7357;
  partcv[0] = 1;
  Object sum7359 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7359 (depth = 8)
  gc_frame_newslot(sum7359);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum7359;
  partcv[0] = 1;
  Object call7360 = callmethodflags(*var_each, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7355);
// compiled call node returning call7360 (depth = 7)
  int op_slot_right_7354 = gc_frame_newslot(call7360);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7354 = gc_frame_newslot(*var_s);
  params[0] = call7360;
  partcv[0] = 1;
  Object opresult7362 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7362 (depth = 6)
  *var_s = opresult7362;
  if (opresult7362 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_7366__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7368 == NULL) {
    strlit7368 = alloc_String(", ");
    gc_root(strlit7368);
  }
// compiled string node returning strlit7368 (depth = 7)
  int op_slot_right_7367 = gc_frame_newslot(strlit7368);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7367 = gc_frame_newslot(*var_s);
  params[0] = strlit7368;
  partcv[0] = 1;
  Object opresult7370 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7370 (depth = 6)
  *var_s = opresult7370;
  if (opresult7370 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_7329_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7331 == NULL) {
    strlit7331 = alloc_String(")""\xe2""""\x9f""""\xa6""");
    gc_root(strlit7331);
  }
// compiled string node returning strlit7331 (depth = 5)
  int op_slot_right_7330 = gc_frame_newslot(strlit7331);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7334 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7335 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7336 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7335);
// compiled member node returning call7336 (depth = 7)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7337 = callmethodflags(call7336, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7334);
// compiled call node returning call7337 (depth = 6)
  int op_slot_right_7333 = gc_frame_newslot(call7337);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7340 == NULL) {
    strlit7340 = alloc_String("(");
    gc_root(strlit7340);
  }
// compiled string node returning strlit7340 (depth = 7)
  int op_slot_right_7339 = gc_frame_newslot(strlit7340);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7343 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7344 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7343);
// compiled call node returning call7344 (depth = 8)
  int op_slot_right_7342 = gc_frame_newslot(call7344);
// starting to compile string node (depth = 8)
  if (strlit7346 == NULL) {
    strlit7346 = alloc_String("");
    gc_root(strlit7346);
  }
// compiled string node returning strlit7346 (depth = 8)
  int op_slot_left_7342 = gc_frame_newslot(strlit7346);
  params[0] = call7344;
  partcv[0] = 1;
  Object opresult7347 = callmethod(strlit7346, "++(1)", 1, partcv, params);
// compiled op node returning opresult7347 (depth = 7)
  int op_slot_left_7339 = gc_frame_newslot(opresult7347);
  params[0] = strlit7340;
  partcv[0] = 1;
  Object opresult7348 = callmethod(opresult7347, "++(1)", 1, partcv, params);
// compiled op node returning opresult7348 (depth = 6)
  int op_slot_left_7333 = gc_frame_newslot(opresult7348);
  params[0] = call7337;
  partcv[0] = 1;
  Object opresult7349 = callmethod(opresult7348, "++(1)", 1, partcv, params);
// compiled op node returning opresult7349 (depth = 5)
  int op_slot_left_7330 = gc_frame_newslot(opresult7349);
  params[0] = strlit7331;
  partcv[0] = 1;
  Object opresult7350 = callmethod(opresult7349, "++(1)", 1, partcv, params);
// compiled op node returning opresult7350 (depth = 4)
  *var_s = opresult7350;
  if (opresult7350 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1904
  setline(1904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7351 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block7352 = alloc_Block(NULL, NULL, "ast", 1904);
  gc_frame_newslot(block7352);
// method "_apply(_)"
  block_savedest(block7352);
  Object closure7353 = createclosure(3, "_apply(1)");
  setclosureframe(closure7353, stackframe);
  addtoclosure(closure7353, var_depth);
  addtoclosure(closure7353, var_s);
  addtoclosure(closure7353, selfslot);
  struct UserObject *uo7353 = (struct UserObject*)block7352;
  uo7353->data[0] = (Object)closure7353;
  Method *meth_meth_ast_7353__apply_40_1_41_ = addmethod2pos(block7352, "_apply(1)", &meth_ast_7353__apply_40_1_41_, 0);
  int argcv_meth_ast_7353__apply_40_1_41_[] = {1};
  meth_meth_ast_7353__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7353__apply_40_1_41_);
  meth_meth_ast_7353__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7353__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block7352 (depth = 4)
  gc_frame_newslot(block7352);
// Begin line 1905
  setline(1905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block7365 = alloc_Block(NULL, NULL, "ast", 1905);
  gc_frame_newslot(block7365);
// method "_apply"
  block_savedest(block7365);
  Object closure7366 = createclosure(2, "_apply");
  setclosureframe(closure7366, stackframe);
  addtoclosure(closure7366, var_s);
  addtoclosure(closure7366, selfslot);
  struct UserObject *uo7366 = (struct UserObject*)block7365;
  uo7366->data[0] = (Object)closure7366;
  Method *meth_meth_ast_7366__apply = addmethod2pos(block7365, "_apply", &meth_ast_7366__apply, 0);
  int argcv_meth_ast_7366__apply[] = {0};
  meth_meth_ast_7366__apply->type = alloc_MethodType(1, argcv_meth_ast_7366__apply);
  meth_meth_ast_7366__apply->definitionModule = modulename;
  meth_meth_ast_7366__apply->definitionLine = 3050;
// compiled block node returning block7365 (depth = 4)
  gc_frame_newslot(block7365);
// call case 6: other requests
// Begin line 1904
  setline(1904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7373 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7374 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7373);
// compiled member node returning call7374 (depth = 4)
  params[0] = block7352;
  params[1] = block7365;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7375 = callmethodflags(call7374, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7351);
// compiled call node returning call7375 (depth = 3)
// Begin line 1906
  setline(1906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7377 == NULL) {
    strlit7377 = alloc_String("""\xe2""""\x9f""""\xa7""");
    gc_root(strlit7377);
  }
// compiled string node returning strlit7377 (depth = 4)
  int op_slot_right_7376 = gc_frame_newslot(strlit7377);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_7376 = gc_frame_newslot(*var_s);
  params[0] = strlit7377;
  partcv[0] = 1;
  Object opresult7379 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7379 (depth = 3)
  gc_frame_end(frame);
  return opresult7379;
}
Object meth_ast_7389__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7391 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num7392 = alloc_Float64(0);
// compiled num node returning num7392 (depth = 8)
  gc_frame_newslot(num7392);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = num7392;
  partcv[0] = 1;
  Object call7393 = callmethodflags(*var_each, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7391);
// compiled call node returning call7393 (depth = 7)
  int op_slot_right_7390 = gc_frame_newslot(call7393);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7390 = gc_frame_newslot(*var_s);
  params[0] = call7393;
  partcv[0] = 1;
  Object opresult7395 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7395 (depth = 6)
  *var_s = opresult7395;
  if (opresult7395 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_7399__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7401 == NULL) {
    strlit7401 = alloc_String(", ");
    gc_root(strlit7401);
  }
// compiled string node returning strlit7401 (depth = 7)
  int op_slot_right_7400 = gc_frame_newslot(strlit7401);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7400 = gc_frame_newslot(*var_s);
  params[0] = strlit7401;
  partcv[0] = 1;
  Object opresult7403 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7403 (depth = 6)
  *var_s = opresult7403;
  if (opresult7403 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_7380_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1909
  setline(1909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7382 == NULL) {
    strlit7382 = alloc_String("""\xe2""""\x9f""""\xa6""");
    gc_root(strlit7382);
  }
// compiled string node returning strlit7382 (depth = 5)
  int op_slot_right_7381 = gc_frame_newslot(strlit7382);
// starting to compile member node (depth = 5)
  int callframe7384 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7385 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7384);
// compiled member node returning call7385 (depth = 5)
  int op_slot_left_7381 = gc_frame_newslot(call7385);
  params[0] = strlit7382;
  partcv[0] = 1;
  Object opresult7386 = callmethod(call7385, "++(1)", 1, partcv, params);
// compiled op node returning opresult7386 (depth = 4)
  *var_s = opresult7386;
  if (opresult7386 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1910
  setline(1910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7387 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block7388 = alloc_Block(NULL, NULL, "ast", 1910);
  gc_frame_newslot(block7388);
// method "_apply(_)"
  block_savedest(block7388);
  Object closure7389 = createclosure(2, "_apply(1)");
  setclosureframe(closure7389, stackframe);
  addtoclosure(closure7389, var_s);
  addtoclosure(closure7389, selfslot);
  struct UserObject *uo7389 = (struct UserObject*)block7388;
  uo7389->data[0] = (Object)closure7389;
  Method *meth_meth_ast_7389__apply_40_1_41_ = addmethod2pos(block7388, "_apply(1)", &meth_ast_7389__apply_40_1_41_, 0);
  int argcv_meth_ast_7389__apply_40_1_41_[] = {1};
  meth_meth_ast_7389__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7389__apply_40_1_41_);
  meth_meth_ast_7389__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7389__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block7388 (depth = 4)
  gc_frame_newslot(block7388);
// Begin line 1911
  setline(1911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block7398 = alloc_Block(NULL, NULL, "ast", 1911);
  gc_frame_newslot(block7398);
// method "_apply"
  block_savedest(block7398);
  Object closure7399 = createclosure(2, "_apply");
  setclosureframe(closure7399, stackframe);
  addtoclosure(closure7399, var_s);
  addtoclosure(closure7399, selfslot);
  struct UserObject *uo7399 = (struct UserObject*)block7398;
  uo7399->data[0] = (Object)closure7399;
  Method *meth_meth_ast_7399__apply = addmethod2pos(block7398, "_apply", &meth_ast_7399__apply, 0);
  int argcv_meth_ast_7399__apply[] = {0};
  meth_meth_ast_7399__apply->type = alloc_MethodType(1, argcv_meth_ast_7399__apply);
  meth_meth_ast_7399__apply->definitionModule = modulename;
  meth_meth_ast_7399__apply->definitionLine = 3050;
// compiled block node returning block7398 (depth = 4)
  gc_frame_newslot(block7398);
// call case 6: other requests
// Begin line 1910
  setline(1910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7406 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7407 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7406);
// compiled member node returning call7407 (depth = 4)
  params[0] = block7388;
  params[1] = block7398;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7408 = callmethodflags(call7407, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7387);
// compiled call node returning call7408 (depth = 3)
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7410 == NULL) {
    strlit7410 = alloc_String("""\xe2""""\x9f""""\xa7""");
    gc_root(strlit7410);
  }
// compiled string node returning strlit7410 (depth = 4)
  int op_slot_right_7409 = gc_frame_newslot(strlit7410);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_7409 = gc_frame_newslot(*var_s);
  params[0] = strlit7410;
  partcv[0] = 1;
  Object opresult7412 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7412 (depth = 3)
  gc_frame_end(frame);
  return opresult7412;
}
Object meth_ast_7413_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1915
  setline(1915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7414 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe7415 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7416 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7417 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7416);
// compiled member node returning call7417 (depth = 5)
  gc_frame_newslot(call7417);
// starting to compile member node (depth = 5)
  int callframe7418 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7419 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7418);
// compiled member node returning call7419 (depth = 5)
  gc_frame_newslot(call7419);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_genericNode (depth = 5)
  params[0] = call7417;
  params[1] = call7419;
  partcv[0] = 2;
  Object call7420 = callmethodflags(*var_genericNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7415);
// compiled call node returning call7420 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7421 = callmethodflags(call7420, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7414);
// compiled call node returning call7421 (depth = 3)
  gc_frame_end(frame);
  return call7421;
}
Object meth_ast_7266_new_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_base = &(stackframe->slots[0]);
  *var_base = args[curarg];
  curarg++;
  Object *var_arguments = &(stackframe->slots[1]);
  *var_arguments = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7267 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7267 = alloc_userobj2(13,12, objclass7267);
  gc_frame_newslot(obj7267);
  if (objclass7267 == NULL) {
    glfree(obj7267->class->name);
    obj7267->class->name = "genericNode.new(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj7267, self, 0);
  addmethodreal(obj7267,"outer", &reader_ast_outer_7268);
  Object oldself7267 = self;
  struct StackFrameObject *oldstackframe7267 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7267);
  gc_frame_newslot((Object)stackframe);
  self = obj7267;
  Object *oldselfslot7267 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7267 = (*(struct UserObject *)self).data[0], lowerouter7267 = thisouter7267;
  if (inheritingObject7267) {
    struct UserObject *inho7267 = (struct UserObject *)inheritingObject7267;
    while (inho7267->super != GraceDefaultObject) inho7267 = (struct UserObject *)inho7267->super;
    inho7267->super = obj7267;
    self = inheritingObject7267;
    *selfslot = self;
    lowerouter7267 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7267;
  }
  if (objclass7267 == NULL) {
  Method *reader7269 = addmethodrealflags(obj7267, "kind",&reader_ast_kind_7269, MFLAG_DEF);
  reader7269->definitionModule = modulename;
  reader7269->definitionLine = 1878;
  }
  adddatum2(obj7267, alloc_Undefined(), 1);
  if (objclass7267 == NULL) {
    Method *reader7270 = addmethodrealflags(obj7267, "value", &reader_ast_value_7270, 0);
    Method *writer7270 = addmethodrealflags(obj7267, "value:=(1)", &writer_ast_value_7270, 0);
    reader7270->definitionModule = modulename;
    writer7270->definitionModule = modulename;
    reader7270->definitionLine = 1879;
    writer7270->definitionLine = 1879;
  }
  obj7267->flags |= OFLAG_MUTABLE;
  adddatum2(obj7267, alloc_Undefined(), 2);
  if (objclass7267 == NULL) {
    Method *reader7271 = addmethodrealflags(obj7267, "args", &reader_ast_args_7271, 0);
    Method *writer7271 = addmethodrealflags(obj7267, "args:=(1)", &writer_ast_args_7271, 0);
    reader7271->definitionModule = modulename;
    writer7271->definitionModule = modulename;
    reader7271->definitionLine = 1882;
    writer7271->definitionLine = 1882;
  }
  obj7267->flags |= OFLAG_MUTABLE;
  adddatum2(obj7267, alloc_Undefined(), 3);
// method "end"
  struct UserObject *uo7272 = (struct UserObject*)obj7267;
  uo7272->data[4] = emptyclosure;
  Method *meth_meth_ast_7272_end = addmethod2pos(obj7267, "end", &meth_ast_7272_end, 4);
  int argcv_meth_ast_7272_end[] = {0};
  meth_meth_ast_7272_end->type = alloc_MethodType(1, argcv_meth_ast_7272_end);
  meth_meth_ast_7272_end->definitionModule = modulename;
  meth_meth_ast_7272_end->definitionLine = 1883;
// method "nameString"
  struct UserObject *uo7282 = (struct UserObject*)obj7267;
  uo7282->data[5] = emptyclosure;
  Method *meth_meth_ast_7282_nameString = addmethod2pos(obj7267, "nameString", &meth_ast_7282_nameString, 5);
  int argcv_meth_ast_7282_nameString[] = {0};
  meth_meth_ast_7282_nameString->type = alloc_MethodType(1, argcv_meth_ast_7282_nameString);
  meth_meth_ast_7282_nameString->definitionModule = modulename;
  meth_meth_ast_7282_nameString->definitionLine = 1884;
// method "asString"
  struct UserObject *uo7287 = (struct UserObject*)obj7267;
  uo7287->data[6] = emptyclosure;
  Method *meth_meth_ast_7287_asString = addmethod2pos(obj7267, "asString", &meth_ast_7287_asString, 6);
  int argcv_meth_ast_7287_asString[] = {0};
  meth_meth_ast_7287_asString->type = alloc_MethodType(1, argcv_meth_ast_7287_asString);
  meth_meth_ast_7287_asString->definitionModule = modulename;
  meth_meth_ast_7287_asString->definitionLine = 1885;
// method "accept(_)from(_)"
  struct UserObject *uo7291 = (struct UserObject*)obj7267;
  uo7291->data[7] = emptyclosure;
  Method *meth_meth_ast_7291_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj7267, "accept(1)from(1)", &meth_ast_7291_accept_40_1_41_from_40_1_41_, 7);
  int argcv_meth_ast_7291_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_7291_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_7291_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_7291_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7291_accept_40_1_41_from_40_1_41_->definitionLine = 1886;
// method "map(_)ancestors(_)"
  struct UserObject *uo7310 = (struct UserObject*)obj7267;
  uo7310->data[8] = emptyclosure;
  Method *meth_meth_ast_7310_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj7267, "map(1)ancestors(1)", &meth_ast_7310_map_40_1_41_ancestors_40_1_41_, 8);
  int argcv_meth_ast_7310_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_7310_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_7310_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_7310_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7310_map_40_1_41_ancestors_40_1_41_->definitionLine = 1895;
// method "pretty(_)"
  struct UserObject *uo7329 = (struct UserObject*)obj7267;
  uo7329->data[9] = emptyclosure;
  Method *meth_meth_ast_7329_pretty_40_1_41_ = addmethod2pos(obj7267, "pretty(1)", &meth_ast_7329_pretty_40_1_41_, 9);
  int argcv_meth_ast_7329_pretty_40_1_41_[] = {1};
  meth_meth_ast_7329_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7329_pretty_40_1_41_);
  meth_meth_ast_7329_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7329_pretty_40_1_41_->definitionLine = 1902;
// method "toGrace(_)"
  struct UserObject *uo7380 = (struct UserObject*)obj7267;
  uo7380->data[10] = emptyclosure;
  Method *meth_meth_ast_7380_toGrace_40_1_41_ = addmethod2pos(obj7267, "toGrace(1)", &meth_ast_7380_toGrace_40_1_41_, 10);
  int argcv_meth_ast_7380_toGrace_40_1_41_[] = {1};
  meth_meth_ast_7380_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7380_toGrace_40_1_41_);
meth_meth_ast_7380_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_7380_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_7380_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7380_toGrace_40_1_41_->definitionLine = 1908;
// method "shallowCopy"
  block_savedest(obj7267);
  Object closure7413 = createclosure(1, "shallowCopy");
  setclosureframe(closure7413, stackframe);
  addtoclosure(closure7413, var_genericNode);
  struct UserObject *uo7413 = (struct UserObject*)obj7267;
  uo7413->data[11] = (Object)closure7413;
  Method *meth_meth_ast_7413_shallowCopy = addmethod2pos(obj7267, "shallowCopy", &meth_ast_7413_shallowCopy, 11);
  int argcv_meth_ast_7413_shallowCopy[] = {0};
  meth_meth_ast_7413_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_7413_shallowCopy);
  meth_meth_ast_7413_shallowCopy->definitionModule = modulename;
  meth_meth_ast_7413_shallowCopy->definitionLine = 1914;
  sourceObject = obj7267;
// Begin line 1877
  setline(1877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7422 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7423 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7422);
// compiled call node returning call7423 (depth = 3)
  struct UserObject *obj7267_uo = (struct UserObject *)obj7267;
  obj7267_uo->super = call7423;
  sourceObject = obj7267;
// Begin line 1878
  setline(1878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7424 == NULL) {
    strlit7424 = alloc_String("generic");
    gc_root(strlit7424);
  }
// compiled string node returning strlit7424 (depth = 3)
  adddatum2(obj7267, strlit7424, 1);
  sourceObject = obj7267;
// Begin line 1879
  setline(1879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_base (depth = 3)
  adddatum2(obj7267, *var_base, 2);
  sourceObject = obj7267;
// Begin line 1882
  setline(1882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arguments (depth = 3)
  adddatum2(obj7267, *var_arguments, 3);
  sourceObject = obj7267;
  sourceObject = obj7267;
  sourceObject = obj7267;
  sourceObject = obj7267;
  sourceObject = obj7267;
  sourceObject = obj7267;
  sourceObject = obj7267;
  sourceObject = obj7267;
  objclass7267 = obj7267->class;
  objclass7267->definitionModule = modulename;
  objclass7267->definitionLine = 1875;
  (*(struct UserObject *)self).data[0] = lowerouter7267;
  self = oldself7267;
  selfslot = oldselfslot7267;
  stackframe = oldstackframe7267;
  gc_frame_end(frame);
  return obj7267;
}
Object meth_ast_7266_new_40_2_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_base = &(stackframe->slots[0]);
  *var_base = args[curarg];
  curarg++;
  Object *var_arguments = &(stackframe->slots[1]);
  *var_arguments = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7267 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7267 = alloc_userobj2(13,12, objclass7267);
  gc_frame_newslot(obj7267);
  if (objclass7267 == NULL) {
    glfree(obj7267->class->name);
    obj7267->class->name = "genericNode.new(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj7267, self, 0);
  addmethodreal(obj7267,"outer", &reader_ast_outer_7268);
  Object oldself7267 = self;
  struct StackFrameObject *oldstackframe7267 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7267);
  gc_frame_newslot((Object)stackframe);
  self = obj7267;
  Object *oldselfslot7267 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7267 = (*(struct UserObject *)self).data[0], lowerouter7267 = thisouter7267;
  if (inheritingObject7267) {
    struct UserObject *inho7267 = (struct UserObject *)inheritingObject7267;
    while (inho7267->super != GraceDefaultObject) inho7267 = (struct UserObject *)inho7267->super;
    inho7267->super = obj7267;
    self = inheritingObject7267;
    *selfslot = self;
    lowerouter7267 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7267;
  }
  if (objclass7267 == NULL) {
  Method *reader7269 = addmethodrealflags(obj7267, "kind",&reader_ast_kind_7269, MFLAG_DEF);
  reader7269->definitionModule = modulename;
  reader7269->definitionLine = 1878;
  }
  adddatum2(obj7267, alloc_Undefined(), 1);
  if (objclass7267 == NULL) {
    Method *reader7270 = addmethodrealflags(obj7267, "value", &reader_ast_value_7270, 0);
    Method *writer7270 = addmethodrealflags(obj7267, "value:=(1)", &writer_ast_value_7270, 0);
    reader7270->definitionModule = modulename;
    writer7270->definitionModule = modulename;
    reader7270->definitionLine = 1879;
    writer7270->definitionLine = 1879;
  }
  obj7267->flags |= OFLAG_MUTABLE;
  adddatum2(obj7267, alloc_Undefined(), 2);
  if (objclass7267 == NULL) {
    Method *reader7271 = addmethodrealflags(obj7267, "args", &reader_ast_args_7271, 0);
    Method *writer7271 = addmethodrealflags(obj7267, "args:=(1)", &writer_ast_args_7271, 0);
    reader7271->definitionModule = modulename;
    writer7271->definitionModule = modulename;
    reader7271->definitionLine = 1882;
    writer7271->definitionLine = 1882;
  }
  obj7267->flags |= OFLAG_MUTABLE;
  adddatum2(obj7267, alloc_Undefined(), 3);
// method "end"
  struct UserObject *uo7272 = (struct UserObject*)obj7267;
  uo7272->data[4] = emptyclosure;
  Method *meth_meth_ast_7272_end = addmethod2pos(obj7267, "end", &meth_ast_7272_end, 4);
  int argcv_meth_ast_7272_end[] = {0};
  meth_meth_ast_7272_end->type = alloc_MethodType(1, argcv_meth_ast_7272_end);
  meth_meth_ast_7272_end->definitionModule = modulename;
  meth_meth_ast_7272_end->definitionLine = 1883;
// method "nameString"
  struct UserObject *uo7282 = (struct UserObject*)obj7267;
  uo7282->data[5] = emptyclosure;
  Method *meth_meth_ast_7282_nameString = addmethod2pos(obj7267, "nameString", &meth_ast_7282_nameString, 5);
  int argcv_meth_ast_7282_nameString[] = {0};
  meth_meth_ast_7282_nameString->type = alloc_MethodType(1, argcv_meth_ast_7282_nameString);
  meth_meth_ast_7282_nameString->definitionModule = modulename;
  meth_meth_ast_7282_nameString->definitionLine = 1884;
// method "asString"
  struct UserObject *uo7287 = (struct UserObject*)obj7267;
  uo7287->data[6] = emptyclosure;
  Method *meth_meth_ast_7287_asString = addmethod2pos(obj7267, "asString", &meth_ast_7287_asString, 6);
  int argcv_meth_ast_7287_asString[] = {0};
  meth_meth_ast_7287_asString->type = alloc_MethodType(1, argcv_meth_ast_7287_asString);
  meth_meth_ast_7287_asString->definitionModule = modulename;
  meth_meth_ast_7287_asString->definitionLine = 1885;
// method "accept(_)from(_)"
  struct UserObject *uo7291 = (struct UserObject*)obj7267;
  uo7291->data[7] = emptyclosure;
  Method *meth_meth_ast_7291_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj7267, "accept(1)from(1)", &meth_ast_7291_accept_40_1_41_from_40_1_41_, 7);
  int argcv_meth_ast_7291_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_7291_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_7291_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_7291_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7291_accept_40_1_41_from_40_1_41_->definitionLine = 1886;
// method "map(_)ancestors(_)"
  struct UserObject *uo7310 = (struct UserObject*)obj7267;
  uo7310->data[8] = emptyclosure;
  Method *meth_meth_ast_7310_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj7267, "map(1)ancestors(1)", &meth_ast_7310_map_40_1_41_ancestors_40_1_41_, 8);
  int argcv_meth_ast_7310_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_7310_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_7310_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_7310_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7310_map_40_1_41_ancestors_40_1_41_->definitionLine = 1895;
// method "pretty(_)"
  struct UserObject *uo7329 = (struct UserObject*)obj7267;
  uo7329->data[9] = emptyclosure;
  Method *meth_meth_ast_7329_pretty_40_1_41_ = addmethod2pos(obj7267, "pretty(1)", &meth_ast_7329_pretty_40_1_41_, 9);
  int argcv_meth_ast_7329_pretty_40_1_41_[] = {1};
  meth_meth_ast_7329_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7329_pretty_40_1_41_);
  meth_meth_ast_7329_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7329_pretty_40_1_41_->definitionLine = 1902;
// method "toGrace(_)"
  struct UserObject *uo7380 = (struct UserObject*)obj7267;
  uo7380->data[10] = emptyclosure;
  Method *meth_meth_ast_7380_toGrace_40_1_41_ = addmethod2pos(obj7267, "toGrace(1)", &meth_ast_7380_toGrace_40_1_41_, 10);
  int argcv_meth_ast_7380_toGrace_40_1_41_[] = {1};
  meth_meth_ast_7380_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7380_toGrace_40_1_41_);
meth_meth_ast_7380_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_7380_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_7380_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7380_toGrace_40_1_41_->definitionLine = 1908;
// method "shallowCopy"
  block_savedest(obj7267);
  Object closure7413 = createclosure(1, "shallowCopy");
  setclosureframe(closure7413, stackframe);
  addtoclosure(closure7413, var_genericNode);
  struct UserObject *uo7413 = (struct UserObject*)obj7267;
  uo7413->data[11] = (Object)closure7413;
  Method *meth_meth_ast_7413_shallowCopy = addmethod2pos(obj7267, "shallowCopy", &meth_ast_7413_shallowCopy, 11);
  int argcv_meth_ast_7413_shallowCopy[] = {0};
  meth_meth_ast_7413_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_7413_shallowCopy);
  meth_meth_ast_7413_shallowCopy->definitionModule = modulename;
  meth_meth_ast_7413_shallowCopy->definitionLine = 1914;
  sourceObject = obj7267;
// Begin line 1877
  setline(1877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7422 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7423 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7422);
// compiled call node returning call7423 (depth = 3)
  struct UserObject *obj7267_uo = (struct UserObject *)obj7267;
  obj7267_uo->super = call7423;
  sourceObject = obj7267;
// Begin line 1878
  setline(1878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7424 == NULL) {
    strlit7424 = alloc_String("generic");
    gc_root(strlit7424);
  }
// compiled string node returning strlit7424 (depth = 3)
  adddatum2(obj7267, strlit7424, 1);
  sourceObject = obj7267;
// Begin line 1879
  setline(1879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_base (depth = 3)
  adddatum2(obj7267, *var_base, 2);
  sourceObject = obj7267;
// Begin line 1882
  setline(1882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arguments (depth = 3)
  adddatum2(obj7267, *var_arguments, 3);
  sourceObject = obj7267;
  sourceObject = obj7267;
  sourceObject = obj7267;
  sourceObject = obj7267;
  sourceObject = obj7267;
  sourceObject = obj7267;
  sourceObject = obj7267;
  sourceObject = obj7267;
  objclass7267 = obj7267->class;
  objclass7267->definitionModule = modulename;
  objclass7267->definitionLine = 1875;
  (*(struct UserObject *)self).data[0] = lowerouter7267;
  self = oldself7267;
  selfslot = oldselfslot7267;
  stackframe = oldstackframe7267;
  gc_frame_end(frame);
  return obj7267;
}
Object meth_ast_7426_genericNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 41, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "genericNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1874
  setline(1874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_genericNode (depth = 3)
  gc_frame_end(frame);
  return *var_genericNode;
}
Object meth_ast_7434_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1925
  setline(1925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7435 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num7436 = alloc_Float64(0);
// compiled num node returning num7436 (depth = 4)
  gc_frame_newslot(num7436);
// call case 4: self request
  params[0] = num7436;
  partcv[0] = 1;
  Object call7437 = callmethodflags(self, "toGrace(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7435);
// compiled call node returning call7437 (depth = 3)
  gc_frame_end(frame);
  return call7437;
}
Object meth_ast_7438_declarationKindWithAncestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1926
  setline(1926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7439 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  partcv[0] = 0;
  Object call7440 = callmethodflags(*var_k, "typeparam", 1, partcv, params, 0);
  gc_frame_end(callframe7439);
// compiled member node returning call7440 (depth = 3)
  gc_frame_end(frame);
  return call7440;
}
Object meth_ast_7441_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1928
  setline(1928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7442 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7443 == NULL) {
    strlit7443 = alloc_String("]]");
    gc_root(strlit7443);
  }
// compiled string node returning strlit7443 (depth = 4)
  gc_frame_newslot(strlit7443);
// starting to compile string node (depth = 4)
  if (strlit7444 == NULL) {
    strlit7444 = alloc_String("""\xe2""""\x9f""""\xa7""");
    gc_root(strlit7444);
  }
// compiled string node returning strlit7444 (depth = 4)
  gc_frame_newslot(strlit7444);
// starting to compile member node (depth = 4)
  int callframe7445 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7446 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7447 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7448 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7447);
// compiled member node returning call7448 (depth = 6)
  partcv[0] = 0;
  Object call7449 = callmethodflags(call7448, "last", 1, partcv, params, 0);
  gc_frame_end(callframe7446);
// compiled member node returning call7449 (depth = 5)
  partcv[0] = 0;
  Object call7450 = callmethodflags(call7449, "end", 1, partcv, params, 0);
  gc_frame_end(callframe7445);
// compiled member node returning call7450 (depth = 4)
  gc_frame_newslot(call7450);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = strlit7443;
  params[1] = strlit7444;
  params[2] = call7450;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7451 = callmethodflags(module_ast, "positionOfNext(1)or(1)after(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7442);
// compiled call node returning call7451 (depth = 3)
  gc_frame_end(frame);
  return call7451;
}
Object meth_ast_7460__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1935
  setline(1935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7461 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7462 = callmethodflags(*var_p, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7461);
// compiled call node returning call7462 (depth = 6)
  gc_frame_end(frame);
  return call7462;
}
Object meth_ast_7452_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// definebindings:
// Begin line 1932
  setline(1932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7454 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7455 = callmethodflags(*var_visitor, "visitTypeParameters(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7454);
// compiled call node returning call7455 (depth = 4)
  Object if7453 = done;
  if (istrue(call7455)) {
// Begin line 1933
  setline(1933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7456 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call7457 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7456);
// compiled call node returning call7457 (depth = 5)
  *var_newChain = call7457;
  if (call7457 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1934
  setline(1934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7458 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block7459 = alloc_Block(NULL, NULL, "ast", 1934);
  gc_frame_newslot(block7459);
// method "_apply(_)"
  block_savedest(block7459);
  Object closure7460 = createclosure(3, "_apply(1)");
  setclosureframe(closure7460, stackframe);
  addtoclosure(closure7460, var_visitor);
  addtoclosure(closure7460, var_newChain);
  addtoclosure(closure7460, selfslot);
  struct UserObject *uo7460 = (struct UserObject*)block7459;
  uo7460->data[0] = (Object)closure7460;
  Method *meth_meth_ast_7460__apply_40_1_41_ = addmethod2pos(block7459, "_apply(1)", &meth_ast_7460__apply_40_1_41_, 0);
  int argcv_meth_ast_7460__apply_40_1_41_[] = {1};
  meth_meth_ast_7460__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7460__apply_40_1_41_);
  meth_meth_ast_7460__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7460__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block7459 (depth = 5)
  gc_frame_newslot(block7459);
// call case 6: other requests
// Begin line 1934
  setline(1934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe7464 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7465 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7464);
// compiled member node returning call7465 (depth = 5)
  params[0] = block7459;
  partcv[0] = 1;
  Object call7466 = callmethodflags(call7465, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7458);
// compiled call node returning call7466 (depth = 4)
    gc_frame_newslot(call7466);
    if7453 = call7466;
  } else {
  }
// compiled if node returning if7453 (depth = 3)
  gc_frame_end(frame);
  return if7453;
}
Object meth_ast_7467_do_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7468 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  gc_frame_newslot(*var_blk);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7469 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7470 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7469);
// compiled member node returning call7470 (depth = 4)
  params[0] = *var_blk;
  partcv[0] = 1;
  Object call7471 = callmethodflags(call7470, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7468);
// compiled call node returning call7471 (depth = 3)
  gc_frame_end(frame);
  return call7471;
}
Object meth_ast_7472_size(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1942
  setline(1942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7473 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7474 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7475 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7474);
// compiled member node returning call7475 (depth = 4)
  partcv[0] = 0;
  Object call7476 = callmethodflags(call7475, "size", 1, partcv, params, 0);
  gc_frame_end(callframe7473);
// compiled member node returning call7476 (depth = 3)
  gc_frame_end(frame);
  return call7476;
}
Object meth_ast_7477_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1944
  setline(1944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7478 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7479 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7478);
// compiled member node returning call7479 (depth = 4)
  *var_n = call7479;
  if (call7479 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1945
  setline(1945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7480 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7481 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7480);
// compiled call node returning call7481 (depth = 4)
  *var_newChain = call7481;
  if (call7481 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1946
  setline(1946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7482 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7483 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7484 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7485 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7484);
// compiled member node returning call7485 (depth = 5)
  gc_frame_newslot(call7485);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call7485;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call7486 = callmethodflags(module_ast, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7483);
// compiled call node returning call7486 (depth = 4)
  gc_frame_newslot(call7486);
// call case 6: other requests
// Begin line 1946
  setline(1946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7486;
  partcv[0] = 1;
  Object call7487 = callmethodflags(*var_n, "params:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7482);
// compiled call node returning call7487 (depth = 3)
// Begin line 1947
  setline(1947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7488 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7489 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7488);
// compiled call node returning call7489 (depth = 3)
  gc_frame_end(frame);
  return call7489;
}
Object meth_ast_7510__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7512 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num7514 = alloc_Float64(2);
// compiled num node returning num7514 (depth = 9)
  int op_slot_right_7513 = gc_frame_newslot(num7514);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_7513 = gc_frame_newslot(*var_depth);
  params[0] = num7514;
  partcv[0] = 1;
  Object sum7516 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7516 (depth = 8)
  gc_frame_newslot(sum7516);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum7516;
  partcv[0] = 1;
  Object call7517 = callmethodflags(*var_each, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7512);
// compiled call node returning call7517 (depth = 7)
  int op_slot_right_7511 = gc_frame_newslot(call7517);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7511 = gc_frame_newslot(*var_s);
  params[0] = call7517;
  partcv[0] = 1;
  Object opresult7519 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7519 (depth = 6)
  *var_s = opresult7519;
  if (opresult7519 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_7523__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7525 == NULL) {
    strlit7525 = alloc_String(", ");
    gc_root(strlit7525);
  }
// compiled string node returning strlit7525 (depth = 7)
  int op_slot_right_7524 = gc_frame_newslot(strlit7525);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7524 = gc_frame_newslot(*var_s);
  params[0] = strlit7525;
  partcv[0] = 1;
  Object opresult7527 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7527 (depth = 6)
  *var_s = opresult7527;
  if (opresult7527 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_7490_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1950
  setline(1950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num7493 = alloc_Float64(1);
// compiled num node returning num7493 (depth = 6)
  int op_slot_right_7492 = gc_frame_newslot(num7493);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_7492 = gc_frame_newslot(*var_depth);
  params[0] = num7493;
  partcv[0] = 1;
  Object sum7495 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7495 (depth = 5)
  int op_slot_right_7491 = gc_frame_newslot(sum7495);
// starting to compile string node (depth = 5)
  if (strlit7497 == NULL) {
    strlit7497 = alloc_String("  ");
    gc_root(strlit7497);
  }
// compiled string node returning strlit7497 (depth = 5)
  int op_slot_left_7491 = gc_frame_newslot(strlit7497);
  params[0] = sum7495;
  partcv[0] = 1;
  Object prod7498 = callmethod(strlit7497, "*(1)", 1, partcv, params);
// compiled op node returning prod7498 (depth = 4)
  *var_spc = prod7498;
  if (prod7498 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1951
  setline(1951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7500 == NULL) {
    strlit7500 = alloc_String("""\xe2""""\x9f""""\xa6""");
    gc_root(strlit7500);
  }
// compiled string node returning strlit7500 (depth = 5)
  int op_slot_right_7499 = gc_frame_newslot(strlit7500);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7503 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7504 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7503);
// compiled call node returning call7504 (depth = 6)
  int op_slot_right_7502 = gc_frame_newslot(call7504);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_left_7502 = gc_frame_newslot(*var_spc);
  params[0] = call7504;
  partcv[0] = 1;
  Object opresult7506 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult7506 (depth = 5)
  int op_slot_left_7499 = gc_frame_newslot(opresult7506);
  params[0] = strlit7500;
  partcv[0] = 1;
  Object opresult7507 = callmethod(opresult7506, "++(1)", 1, partcv, params);
// compiled op node returning opresult7507 (depth = 4)
  *var_s = opresult7507;
  if (opresult7507 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1952
  setline(1952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7508 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block7509 = alloc_Block(NULL, NULL, "ast", 1952);
  gc_frame_newslot(block7509);
// method "_apply(_)"
  block_savedest(block7509);
  Object closure7510 = createclosure(3, "_apply(1)");
  setclosureframe(closure7510, stackframe);
  addtoclosure(closure7510, var_depth);
  addtoclosure(closure7510, var_s);
  addtoclosure(closure7510, selfslot);
  struct UserObject *uo7510 = (struct UserObject*)block7509;
  uo7510->data[0] = (Object)closure7510;
  Method *meth_meth_ast_7510__apply_40_1_41_ = addmethod2pos(block7509, "_apply(1)", &meth_ast_7510__apply_40_1_41_, 0);
  int argcv_meth_ast_7510__apply_40_1_41_[] = {1};
  meth_meth_ast_7510__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7510__apply_40_1_41_);
  meth_meth_ast_7510__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7510__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block7509 (depth = 4)
  gc_frame_newslot(block7509);
// Begin line 1953
  setline(1953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block7522 = alloc_Block(NULL, NULL, "ast", 1953);
  gc_frame_newslot(block7522);
// method "_apply"
  block_savedest(block7522);
  Object closure7523 = createclosure(2, "_apply");
  setclosureframe(closure7523, stackframe);
  addtoclosure(closure7523, var_s);
  addtoclosure(closure7523, selfslot);
  struct UserObject *uo7523 = (struct UserObject*)block7522;
  uo7523->data[0] = (Object)closure7523;
  Method *meth_meth_ast_7523__apply = addmethod2pos(block7522, "_apply", &meth_ast_7523__apply, 0);
  int argcv_meth_ast_7523__apply[] = {0};
  meth_meth_ast_7523__apply->type = alloc_MethodType(1, argcv_meth_ast_7523__apply);
  meth_meth_ast_7523__apply->definitionModule = modulename;
  meth_meth_ast_7523__apply->definitionLine = 3050;
// compiled block node returning block7522 (depth = 4)
  gc_frame_newslot(block7522);
// call case 6: other requests
// Begin line 1952
  setline(1952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7530 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7531 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7530);
// compiled member node returning call7531 (depth = 4)
  params[0] = block7509;
  params[1] = block7522;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7532 = callmethodflags(call7531, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7508);
// compiled call node returning call7532 (depth = 3)
// Begin line 1954
  setline(1954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7534 == NULL) {
    strlit7534 = alloc_String("""\xe2""""\x9f""""\xa7""");
    gc_root(strlit7534);
  }
// compiled string node returning strlit7534 (depth = 4)
  int op_slot_right_7533 = gc_frame_newslot(strlit7534);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_7533 = gc_frame_newslot(*var_s);
  params[0] = strlit7534;
  partcv[0] = 1;
  Object opresult7536 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7536 (depth = 3)
  gc_frame_end(frame);
  return opresult7536;
}
Object meth_ast_7541__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7543 == NULL) {
    strlit7543 = alloc_String("");
    gc_root(strlit7543);
  }
// compiled string node returning strlit7543 (depth = 7)
  int op_slot_right_7542 = gc_frame_newslot(strlit7543);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7546 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7547 = callmethodflags(*var_each, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7546);
// compiled call node returning call7547 (depth = 8)
  int op_slot_right_7545 = gc_frame_newslot(call7547);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7550 == NULL) {
    strlit7550 = alloc_String("");
    gc_root(strlit7550);
  }
// compiled string node returning strlit7550 (depth = 9)
  int op_slot_right_7549 = gc_frame_newslot(strlit7550);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_7552 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit7554 == NULL) {
    strlit7554 = alloc_String("");
    gc_root(strlit7554);
  }
// compiled string node returning strlit7554 (depth = 10)
  int op_slot_left_7552 = gc_frame_newslot(strlit7554);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult7555 = callmethod(strlit7554, "++(1)", 1, partcv, params);
// compiled op node returning opresult7555 (depth = 9)
  int op_slot_left_7549 = gc_frame_newslot(opresult7555);
  params[0] = strlit7550;
  partcv[0] = 1;
  Object opresult7556 = callmethod(opresult7555, "++(1)", 1, partcv, params);
// compiled op node returning opresult7556 (depth = 8)
  int op_slot_left_7545 = gc_frame_newslot(opresult7556);
  params[0] = call7547;
  partcv[0] = 1;
  Object opresult7557 = callmethod(opresult7556, "++(1)", 1, partcv, params);
// compiled op node returning opresult7557 (depth = 7)
  int op_slot_left_7542 = gc_frame_newslot(opresult7557);
  params[0] = strlit7543;
  partcv[0] = 1;
  Object opresult7558 = callmethod(opresult7557, "++(1)", 1, partcv, params);
// compiled op node returning opresult7558 (depth = 6)
  *var_s = opresult7558;
  if (opresult7558 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_7562__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7564 == NULL) {
    strlit7564 = alloc_String(", ");
    gc_root(strlit7564);
  }
// compiled string node returning strlit7564 (depth = 7)
  int op_slot_right_7563 = gc_frame_newslot(strlit7564);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7563 = gc_frame_newslot(*var_s);
  params[0] = strlit7564;
  partcv[0] = 1;
  Object opresult7566 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7566 (depth = 6)
  *var_s = opresult7566;
  if (opresult7566 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_7537_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1957
  setline(1957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7538 == NULL) {
    strlit7538 = alloc_String("""\xe2""""\x9f""""\xa6""");
    gc_root(strlit7538);
  }
// compiled string node returning strlit7538 (depth = 4)
  *var_s = strlit7538;
  if (strlit7538 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1958
  setline(1958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7539 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block7540 = alloc_Block(NULL, NULL, "ast", 1958);
  gc_frame_newslot(block7540);
// method "_apply(_)"
  block_savedest(block7540);
  Object closure7541 = createclosure(3, "_apply(1)");
  setclosureframe(closure7541, stackframe);
  addtoclosure(closure7541, var_depth);
  addtoclosure(closure7541, var_s);
  addtoclosure(closure7541, selfslot);
  struct UserObject *uo7541 = (struct UserObject*)block7540;
  uo7541->data[0] = (Object)closure7541;
  Method *meth_meth_ast_7541__apply_40_1_41_ = addmethod2pos(block7540, "_apply(1)", &meth_ast_7541__apply_40_1_41_, 0);
  int argcv_meth_ast_7541__apply_40_1_41_[] = {1};
  meth_meth_ast_7541__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7541__apply_40_1_41_);
  meth_meth_ast_7541__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7541__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block7540 (depth = 4)
  gc_frame_newslot(block7540);
// Begin line 1959
  setline(1959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block7561 = alloc_Block(NULL, NULL, "ast", 1959);
  gc_frame_newslot(block7561);
// method "_apply"
  block_savedest(block7561);
  Object closure7562 = createclosure(2, "_apply");
  setclosureframe(closure7562, stackframe);
  addtoclosure(closure7562, var_s);
  addtoclosure(closure7562, selfslot);
  struct UserObject *uo7562 = (struct UserObject*)block7561;
  uo7562->data[0] = (Object)closure7562;
  Method *meth_meth_ast_7562__apply = addmethod2pos(block7561, "_apply", &meth_ast_7562__apply, 0);
  int argcv_meth_ast_7562__apply[] = {0};
  meth_meth_ast_7562__apply->type = alloc_MethodType(1, argcv_meth_ast_7562__apply);
  meth_meth_ast_7562__apply->definitionModule = modulename;
  meth_meth_ast_7562__apply->definitionLine = 3050;
// compiled block node returning block7561 (depth = 4)
  gc_frame_newslot(block7561);
// call case 6: other requests
// Begin line 1958
  setline(1958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7569 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7570 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7569);
// compiled member node returning call7570 (depth = 4)
  params[0] = block7540;
  params[1] = block7561;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7571 = callmethodflags(call7570, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7539);
// compiled call node returning call7571 (depth = 3)
// Begin line 1960
  setline(1960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7573 == NULL) {
    strlit7573 = alloc_String("""\xe2""""\x9f""""\xa7""");
    gc_root(strlit7573);
  }
// compiled string node returning strlit7573 (depth = 4)
  int op_slot_right_7572 = gc_frame_newslot(strlit7573);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_7572 = gc_frame_newslot(*var_s);
  params[0] = strlit7573;
  partcv[0] = 1;
  Object opresult7575 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7575 (depth = 3)
  gc_frame_end(frame);
  return opresult7575;
}
Object meth_ast_7576_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_typeParametersNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7577 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe7578 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeParametersNode (depth = 5)
  params[0] = *var_emptySeq;
  partcv[0] = 1;
  Object call7579 = callmethodflags(*var_typeParametersNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7578);
// compiled call node returning call7579 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7580 = callmethodflags(call7579, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7577);
// compiled call node returning call7580 (depth = 3)
  gc_frame_end(frame);
  return call7580;
}
Object meth_ast_7429_new_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_typeParametersNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7430 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7430 = alloc_userobj2(13,13, objclass7430);
  gc_frame_newslot(obj7430);
  if (objclass7430 == NULL) {
    glfree(obj7430->class->name);
    obj7430->class->name = "typeParametersNode.new(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj7430, self, 0);
  addmethodreal(obj7430,"outer", &reader_ast_outer_7431);
  Object oldself7430 = self;
  struct StackFrameObject *oldstackframe7430 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7430);
  gc_frame_newslot((Object)stackframe);
  self = obj7430;
  Object *oldselfslot7430 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7430 = (*(struct UserObject *)self).data[0], lowerouter7430 = thisouter7430;
  if (inheritingObject7430) {
    struct UserObject *inho7430 = (struct UserObject *)inheritingObject7430;
    while (inho7430->super != GraceDefaultObject) inho7430 = (struct UserObject *)inho7430->super;
    inho7430->super = obj7430;
    self = inheritingObject7430;
    *selfslot = self;
    lowerouter7430 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7430;
  }
  if (objclass7430 == NULL) {
  Method *reader7432 = addmethodrealflags(obj7430, "kind",&reader_ast_kind_7432, MFLAG_DEF);
  reader7432->definitionModule = modulename;
  reader7432->definitionLine = 1923;
  }
  adddatum2(obj7430, alloc_Undefined(), 1);
  if (objclass7430 == NULL) {
    Method *reader7433 = addmethodrealflags(obj7430, "params", &reader_ast_params_7433, 0);
    Method *writer7433 = addmethodrealflags(obj7430, "params:=(1)", &writer_ast_params_7433, 0);
    reader7433->definitionModule = modulename;
    writer7433->definitionModule = modulename;
    reader7433->definitionLine = 1924;
    writer7433->definitionLine = 1924;
  }
  obj7430->flags |= OFLAG_MUTABLE;
  adddatum2(obj7430, alloc_Undefined(), 2);
// method "asString"
  struct UserObject *uo7434 = (struct UserObject*)obj7430;
  uo7434->data[3] = emptyclosure;
  Method *meth_meth_ast_7434_asString = addmethod2pos(obj7430, "asString", &meth_ast_7434_asString, 3);
  int argcv_meth_ast_7434_asString[] = {0};
  meth_meth_ast_7434_asString->type = alloc_MethodType(1, argcv_meth_ast_7434_asString);
  meth_meth_ast_7434_asString->definitionModule = modulename;
  meth_meth_ast_7434_asString->definitionLine = 1925;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj7430);
  Object closure7438 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure7438, stackframe);
  addtoclosure(closure7438, var_k);
  struct UserObject *uo7438 = (struct UserObject*)obj7430;
  uo7438->data[4] = (Object)closure7438;
  Method *meth_meth_ast_7438_declarationKindWithAncestors_40_1_41_ = addmethod2pos(obj7430, "declarationKindWithAncestors(1)", &meth_ast_7438_declarationKindWithAncestors_40_1_41_, 4);
  int argcv_meth_ast_7438_declarationKindWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_7438_declarationKindWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7438_declarationKindWithAncestors_40_1_41_);
  meth_meth_ast_7438_declarationKindWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7438_declarationKindWithAncestors_40_1_41_->definitionLine = 1926;
// method "end"
  struct UserObject *uo7441 = (struct UserObject*)obj7430;
  uo7441->data[5] = emptyclosure;
  Method *meth_meth_ast_7441_end = addmethod2pos(obj7430, "end", &meth_ast_7441_end, 5);
  int argcv_meth_ast_7441_end[] = {0};
  meth_meth_ast_7441_end->type = alloc_MethodType(1, argcv_meth_ast_7441_end);
  meth_meth_ast_7441_end->definitionModule = modulename;
  meth_meth_ast_7441_end->definitionLine = 1927;
// method "accept(_)from(_)"
  struct UserObject *uo7452 = (struct UserObject*)obj7430;
  uo7452->data[6] = emptyclosure;
  Method *meth_meth_ast_7452_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj7430, "accept(1)from(1)", &meth_ast_7452_accept_40_1_41_from_40_1_41_, 6);
  int argcv_meth_ast_7452_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_7452_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_7452_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_7452_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7452_accept_40_1_41_from_40_1_41_->definitionLine = 1931;
// method "do(_)"
  struct UserObject *uo7467 = (struct UserObject*)obj7430;
  uo7467->data[7] = emptyclosure;
  Method *meth_meth_ast_7467_do_40_1_41_ = addmethod2pos(obj7430, "do(1)", &meth_ast_7467_do_40_1_41_, 7);
  int argcv_meth_ast_7467_do_40_1_41_[] = {1};
  meth_meth_ast_7467_do_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7467_do_40_1_41_);
  meth_meth_ast_7467_do_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7467_do_40_1_41_->definitionLine = 1939;
// method "size"
  struct UserObject *uo7472 = (struct UserObject*)obj7430;
  uo7472->data[8] = emptyclosure;
  Method *meth_meth_ast_7472_size = addmethod2pos(obj7430, "size", &meth_ast_7472_size, 8);
  int argcv_meth_ast_7472_size[] = {0};
  meth_meth_ast_7472_size->type = alloc_MethodType(1, argcv_meth_ast_7472_size);
  meth_meth_ast_7472_size->definitionModule = modulename;
  meth_meth_ast_7472_size->definitionLine = 1942;
// method "map(_)ancestors(_)"
  struct UserObject *uo7477 = (struct UserObject*)obj7430;
  uo7477->data[9] = emptyclosure;
  Method *meth_meth_ast_7477_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj7430, "map(1)ancestors(1)", &meth_ast_7477_map_40_1_41_ancestors_40_1_41_, 9);
  int argcv_meth_ast_7477_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_7477_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_7477_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_7477_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7477_map_40_1_41_ancestors_40_1_41_->definitionLine = 1943;
// method "pretty(_)"
  struct UserObject *uo7490 = (struct UserObject*)obj7430;
  uo7490->data[10] = emptyclosure;
  Method *meth_meth_ast_7490_pretty_40_1_41_ = addmethod2pos(obj7430, "pretty(1)", &meth_ast_7490_pretty_40_1_41_, 10);
  int argcv_meth_ast_7490_pretty_40_1_41_[] = {1};
  meth_meth_ast_7490_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7490_pretty_40_1_41_);
  meth_meth_ast_7490_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7490_pretty_40_1_41_->definitionLine = 1949;
// method "toGrace(_)"
  struct UserObject *uo7537 = (struct UserObject*)obj7430;
  uo7537->data[11] = emptyclosure;
  Method *meth_meth_ast_7537_toGrace_40_1_41_ = addmethod2pos(obj7430, "toGrace(1)", &meth_ast_7537_toGrace_40_1_41_, 11);
  int argcv_meth_ast_7537_toGrace_40_1_41_[] = {1};
  meth_meth_ast_7537_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7537_toGrace_40_1_41_);
meth_meth_ast_7537_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_7537_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_7537_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7537_toGrace_40_1_41_->definitionLine = 1956;
// method "shallowCopy"
  block_savedest(obj7430);
  Object closure7576 = createclosure(2, "shallowCopy");
  setclosureframe(closure7576, stackframe);
  addtoclosure(closure7576, var_emptySeq);
  addtoclosure(closure7576, var_typeParametersNode);
  struct UserObject *uo7576 = (struct UserObject*)obj7430;
  uo7576->data[12] = (Object)closure7576;
  Method *meth_meth_ast_7576_shallowCopy = addmethod2pos(obj7430, "shallowCopy", &meth_ast_7576_shallowCopy, 12);
  int argcv_meth_ast_7576_shallowCopy[] = {0};
  meth_meth_ast_7576_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_7576_shallowCopy);
  meth_meth_ast_7576_shallowCopy->definitionModule = modulename;
  meth_meth_ast_7576_shallowCopy->definitionLine = 1962;
  sourceObject = obj7430;
// Begin line 1922
  setline(1922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7581 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7582 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7581);
// compiled call node returning call7582 (depth = 3)
  struct UserObject *obj7430_uo = (struct UserObject *)obj7430;
  obj7430_uo->super = call7582;
  sourceObject = obj7430;
// Begin line 1923
  setline(1923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7583 == NULL) {
    strlit7583 = alloc_String("typeparams");
    gc_root(strlit7583);
  }
// compiled string node returning strlit7583 (depth = 3)
  adddatum2(obj7430, strlit7583, 1);
  sourceObject = obj7430;
// Begin line 1924
  setline(1924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_params_39_ (depth = 3)
  adddatum2(obj7430, *var_params_39_, 2);
  sourceObject = obj7430;
  sourceObject = obj7430;
  sourceObject = obj7430;
  sourceObject = obj7430;
  sourceObject = obj7430;
  sourceObject = obj7430;
  sourceObject = obj7430;
  sourceObject = obj7430;
  sourceObject = obj7430;
  sourceObject = obj7430;
  objclass7430 = obj7430->class;
  objclass7430->definitionModule = modulename;
  objclass7430->definitionLine = 1921;
  (*(struct UserObject *)self).data[0] = lowerouter7430;
  self = oldself7430;
  selfslot = oldselfslot7430;
  stackframe = oldstackframe7430;
  gc_frame_end(frame);
  return obj7430;
}
Object meth_ast_7429_new_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_typeParametersNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7430 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7430 = alloc_userobj2(13,13, objclass7430);
  gc_frame_newslot(obj7430);
  if (objclass7430 == NULL) {
    glfree(obj7430->class->name);
    obj7430->class->name = "typeParametersNode.new(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj7430, self, 0);
  addmethodreal(obj7430,"outer", &reader_ast_outer_7431);
  Object oldself7430 = self;
  struct StackFrameObject *oldstackframe7430 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7430);
  gc_frame_newslot((Object)stackframe);
  self = obj7430;
  Object *oldselfslot7430 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7430 = (*(struct UserObject *)self).data[0], lowerouter7430 = thisouter7430;
  if (inheritingObject7430) {
    struct UserObject *inho7430 = (struct UserObject *)inheritingObject7430;
    while (inho7430->super != GraceDefaultObject) inho7430 = (struct UserObject *)inho7430->super;
    inho7430->super = obj7430;
    self = inheritingObject7430;
    *selfslot = self;
    lowerouter7430 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7430;
  }
  if (objclass7430 == NULL) {
  Method *reader7432 = addmethodrealflags(obj7430, "kind",&reader_ast_kind_7432, MFLAG_DEF);
  reader7432->definitionModule = modulename;
  reader7432->definitionLine = 1923;
  }
  adddatum2(obj7430, alloc_Undefined(), 1);
  if (objclass7430 == NULL) {
    Method *reader7433 = addmethodrealflags(obj7430, "params", &reader_ast_params_7433, 0);
    Method *writer7433 = addmethodrealflags(obj7430, "params:=(1)", &writer_ast_params_7433, 0);
    reader7433->definitionModule = modulename;
    writer7433->definitionModule = modulename;
    reader7433->definitionLine = 1924;
    writer7433->definitionLine = 1924;
  }
  obj7430->flags |= OFLAG_MUTABLE;
  adddatum2(obj7430, alloc_Undefined(), 2);
// method "asString"
  struct UserObject *uo7434 = (struct UserObject*)obj7430;
  uo7434->data[3] = emptyclosure;
  Method *meth_meth_ast_7434_asString = addmethod2pos(obj7430, "asString", &meth_ast_7434_asString, 3);
  int argcv_meth_ast_7434_asString[] = {0};
  meth_meth_ast_7434_asString->type = alloc_MethodType(1, argcv_meth_ast_7434_asString);
  meth_meth_ast_7434_asString->definitionModule = modulename;
  meth_meth_ast_7434_asString->definitionLine = 1925;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj7430);
  Object closure7438 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure7438, stackframe);
  addtoclosure(closure7438, var_k);
  struct UserObject *uo7438 = (struct UserObject*)obj7430;
  uo7438->data[4] = (Object)closure7438;
  Method *meth_meth_ast_7438_declarationKindWithAncestors_40_1_41_ = addmethod2pos(obj7430, "declarationKindWithAncestors(1)", &meth_ast_7438_declarationKindWithAncestors_40_1_41_, 4);
  int argcv_meth_ast_7438_declarationKindWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_7438_declarationKindWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7438_declarationKindWithAncestors_40_1_41_);
  meth_meth_ast_7438_declarationKindWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7438_declarationKindWithAncestors_40_1_41_->definitionLine = 1926;
// method "end"
  struct UserObject *uo7441 = (struct UserObject*)obj7430;
  uo7441->data[5] = emptyclosure;
  Method *meth_meth_ast_7441_end = addmethod2pos(obj7430, "end", &meth_ast_7441_end, 5);
  int argcv_meth_ast_7441_end[] = {0};
  meth_meth_ast_7441_end->type = alloc_MethodType(1, argcv_meth_ast_7441_end);
  meth_meth_ast_7441_end->definitionModule = modulename;
  meth_meth_ast_7441_end->definitionLine = 1927;
// method "accept(_)from(_)"
  struct UserObject *uo7452 = (struct UserObject*)obj7430;
  uo7452->data[6] = emptyclosure;
  Method *meth_meth_ast_7452_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj7430, "accept(1)from(1)", &meth_ast_7452_accept_40_1_41_from_40_1_41_, 6);
  int argcv_meth_ast_7452_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_7452_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_7452_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_7452_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7452_accept_40_1_41_from_40_1_41_->definitionLine = 1931;
// method "do(_)"
  struct UserObject *uo7467 = (struct UserObject*)obj7430;
  uo7467->data[7] = emptyclosure;
  Method *meth_meth_ast_7467_do_40_1_41_ = addmethod2pos(obj7430, "do(1)", &meth_ast_7467_do_40_1_41_, 7);
  int argcv_meth_ast_7467_do_40_1_41_[] = {1};
  meth_meth_ast_7467_do_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7467_do_40_1_41_);
  meth_meth_ast_7467_do_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7467_do_40_1_41_->definitionLine = 1939;
// method "size"
  struct UserObject *uo7472 = (struct UserObject*)obj7430;
  uo7472->data[8] = emptyclosure;
  Method *meth_meth_ast_7472_size = addmethod2pos(obj7430, "size", &meth_ast_7472_size, 8);
  int argcv_meth_ast_7472_size[] = {0};
  meth_meth_ast_7472_size->type = alloc_MethodType(1, argcv_meth_ast_7472_size);
  meth_meth_ast_7472_size->definitionModule = modulename;
  meth_meth_ast_7472_size->definitionLine = 1942;
// method "map(_)ancestors(_)"
  struct UserObject *uo7477 = (struct UserObject*)obj7430;
  uo7477->data[9] = emptyclosure;
  Method *meth_meth_ast_7477_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj7430, "map(1)ancestors(1)", &meth_ast_7477_map_40_1_41_ancestors_40_1_41_, 9);
  int argcv_meth_ast_7477_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_7477_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_7477_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_7477_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7477_map_40_1_41_ancestors_40_1_41_->definitionLine = 1943;
// method "pretty(_)"
  struct UserObject *uo7490 = (struct UserObject*)obj7430;
  uo7490->data[10] = emptyclosure;
  Method *meth_meth_ast_7490_pretty_40_1_41_ = addmethod2pos(obj7430, "pretty(1)", &meth_ast_7490_pretty_40_1_41_, 10);
  int argcv_meth_ast_7490_pretty_40_1_41_[] = {1};
  meth_meth_ast_7490_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7490_pretty_40_1_41_);
  meth_meth_ast_7490_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7490_pretty_40_1_41_->definitionLine = 1949;
// method "toGrace(_)"
  struct UserObject *uo7537 = (struct UserObject*)obj7430;
  uo7537->data[11] = emptyclosure;
  Method *meth_meth_ast_7537_toGrace_40_1_41_ = addmethod2pos(obj7430, "toGrace(1)", &meth_ast_7537_toGrace_40_1_41_, 11);
  int argcv_meth_ast_7537_toGrace_40_1_41_[] = {1};
  meth_meth_ast_7537_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7537_toGrace_40_1_41_);
meth_meth_ast_7537_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_7537_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_7537_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7537_toGrace_40_1_41_->definitionLine = 1956;
// method "shallowCopy"
  block_savedest(obj7430);
  Object closure7576 = createclosure(2, "shallowCopy");
  setclosureframe(closure7576, stackframe);
  addtoclosure(closure7576, var_emptySeq);
  addtoclosure(closure7576, var_typeParametersNode);
  struct UserObject *uo7576 = (struct UserObject*)obj7430;
  uo7576->data[12] = (Object)closure7576;
  Method *meth_meth_ast_7576_shallowCopy = addmethod2pos(obj7430, "shallowCopy", &meth_ast_7576_shallowCopy, 12);
  int argcv_meth_ast_7576_shallowCopy[] = {0};
  meth_meth_ast_7576_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_7576_shallowCopy);
  meth_meth_ast_7576_shallowCopy->definitionModule = modulename;
  meth_meth_ast_7576_shallowCopy->definitionLine = 1962;
  sourceObject = obj7430;
// Begin line 1922
  setline(1922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7581 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7582 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7581);
// compiled call node returning call7582 (depth = 3)
  struct UserObject *obj7430_uo = (struct UserObject *)obj7430;
  obj7430_uo->super = call7582;
  sourceObject = obj7430;
// Begin line 1923
  setline(1923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7583 == NULL) {
    strlit7583 = alloc_String("typeparams");
    gc_root(strlit7583);
  }
// compiled string node returning strlit7583 (depth = 3)
  adddatum2(obj7430, strlit7583, 1);
  sourceObject = obj7430;
// Begin line 1924
  setline(1924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_params_39_ (depth = 3)
  adddatum2(obj7430, *var_params_39_, 2);
  sourceObject = obj7430;
  sourceObject = obj7430;
  sourceObject = obj7430;
  sourceObject = obj7430;
  sourceObject = obj7430;
  sourceObject = obj7430;
  sourceObject = obj7430;
  sourceObject = obj7430;
  sourceObject = obj7430;
  sourceObject = obj7430;
  objclass7430 = obj7430->class;
  objclass7430->definitionModule = modulename;
  objclass7430->definitionLine = 1921;
  (*(struct UserObject *)self).data[0] = lowerouter7430;
  self = oldself7430;
  selfslot = oldselfslot7430;
  stackframe = oldstackframe7430;
  gc_frame_end(frame);
  return obj7430;
}
Object meth_ast_7585_typeParametersNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 42, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeParametersNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeParametersNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1920
  setline(1920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeParametersNode (depth = 3)
  gc_frame_end(frame);
  return *var_typeParametersNode;
}
Object meth_ast_7588_new_40_2_41_scope_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new(2)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)scope(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_)scope(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_dtype = &(stackframe->slots[1]);
  *var_dtype = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1970
  setline(1970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7589 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 4: self request
  params[0] = *var_name;
  params[1] = *var_dtype;
  partcv[0] = 2;
  Object call7590 = callmethodflags(self, "new(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7589);
// compiled call node returning call7590 (depth = 4)
  *var_result = call7590;
  if (call7590 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1971
  setline(1971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7591 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call7592 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7591);
// compiled call node returning call7592 (depth = 3)
// Begin line 1972
  setline(1972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_7594_wildcard_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "wildcard(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method wildcard(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for wildcard(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_dtype = &(stackframe->slots[0]);
  *var_dtype = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part wildcard(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_idNode = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "idNode");
// Begin line 1977
  setline(1977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7595 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num7597 = alloc_Float64(1);
// compiled num node returning num7597 (depth = 5)
  int op_slot_right_7596 = gc_frame_newslot(num7597);
// starting to compile member node (depth = 5)
  int callframe7599 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7600 = callmethodflags(self, "wildcardCount", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7599);
// compiled member node returning call7600 (depth = 5)
  int op_slot_left_7596 = gc_frame_newslot(call7600);
  params[0] = num7597;
  partcv[0] = 1;
  Object sum7601 = callmethod(call7600, "+(1)", 1, partcv, params);
// compiled op node returning sum7601 (depth = 4)
  gc_frame_newslot(sum7601);
// call case 4: self request
  params[0] = sum7601;
  partcv[0] = 1;
  Object call7602 = callmethodflags(self, "wildcardCount:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7595);
// compiled call node returning call7602 (depth = 3)
// Begin line 1978
  setline(1978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7603 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7605 == NULL) {
    strlit7605 = alloc_String("");
    gc_root(strlit7605);
  }
// compiled string node returning strlit7605 (depth = 6)
  int op_slot_right_7604 = gc_frame_newslot(strlit7605);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe7608 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7609 = callmethodflags(self, "wildcardCount", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7608);
// compiled member node returning call7609 (depth = 7)
  int op_slot_right_7607 = gc_frame_newslot(call7609);
// starting to compile string node (depth = 7)
  if (strlit7611 == NULL) {
    strlit7611 = alloc_String("__");
    gc_root(strlit7611);
  }
// compiled string node returning strlit7611 (depth = 7)
  int op_slot_left_7607 = gc_frame_newslot(strlit7611);
  params[0] = call7609;
  partcv[0] = 1;
  Object opresult7612 = callmethod(strlit7611, "++(1)", 1, partcv, params);
// compiled op node returning opresult7612 (depth = 6)
  int op_slot_left_7604 = gc_frame_newslot(opresult7612);
  params[0] = strlit7605;
  partcv[0] = 1;
  Object opresult7613 = callmethod(opresult7612, "++(1)", 1, partcv, params);
// compiled op node returning opresult7613 (depth = 5)
  gc_frame_newslot(opresult7613);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 4: self request
  params[0] = opresult7613;
  params[1] = *var_dtype;
  partcv[0] = 2;
  Object call7614 = callmethodflags(self, "new(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7603);
// compiled call node returning call7614 (depth = 4)
  *var_idNode = call7614;
  if (call7614 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1979
  setline(1979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7615 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool7616 = alloc_Boolean(1);
// compiled identifier node returning bool7616 (depth = 4)
  gc_frame_newslot(bool7616);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_idNode (depth = 4)
  params[0] = bool7616;
  partcv[0] = 1;
  Object call7617 = callmethodflags(*var_idNode, "wildcard:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7615);
// compiled call node returning call7617 (depth = 3)
// Begin line 1980
  setline(1980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7618 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7619 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7620 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_idNode (depth = 6)
  partcv[0] = 0;
  Object call7621 = callmethodflags(*var_idNode, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7620);
// compiled member node returning call7621 (depth = 5)
  gc_frame_newslot(call7621);
// starting to compile member node (depth = 5)
  int callframe7622 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_idNode (depth = 6)
  partcv[0] = 0;
  Object call7623 = callmethodflags(*var_idNode, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe7622);
// compiled member node returning call7623 (depth = 5)
  gc_frame_newslot(call7623);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call7621;
  params[1] = call7623;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7624 = callmethodflags(module_ast, "line(1)column(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7619);
// compiled call node returning call7624 (depth = 4)
  gc_frame_newslot(call7624);
// call case 6: other requests
// Begin line 1980
  setline(1980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_idNode (depth = 4)
  params[0] = call7624;
  partcv[0] = 1;
  Object call7625 = callmethodflags(*var_idNode, "end:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7618);
// compiled call node returning call7625 (depth = 3)
// Begin line 1981
  setline(1981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_idNode (depth = 3)
  gc_frame_end(frame);
  return *var_idNode;
}
Object meth_ast_7639_name(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1997
  setline(1997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7640 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7641 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7640);
// compiled member node returning call7641 (depth = 3)
  gc_frame_end(frame);
  return call7641;
}
Object meth_ast_7642_name_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method name:=(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for name:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_nu = &(stackframe->slots[0]);
  *var_nu = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part name:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1999
  setline(1999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7643 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nu (depth = 4)
  gc_frame_newslot(*var_nu);
// call case 4: self request
  params[0] = *var_nu;
  partcv[0] = 1;
  Object call7644 = callmethodflags(self, "value:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7643);
// compiled call node returning call7644 (depth = 3)
// Begin line 2000
  setline(2000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7645 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7646 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7647 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7648 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7647);
// compiled member node returning call7648 (depth = 5)
  gc_frame_newslot(call7648);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num7650 = alloc_Float64(1);
// compiled num node returning num7650 (depth = 6)
  int op_slot_right_7649 = gc_frame_newslot(num7650);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe7653 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nu (depth = 8)
  partcv[0] = 0;
  Object call7654 = callmethodflags(*var_nu, "size", 1, partcv, params, 0);
  gc_frame_end(callframe7653);
// compiled member node returning call7654 (depth = 7)
  int op_slot_right_7652 = gc_frame_newslot(call7654);
// starting to compile member node (depth = 7)
  int callframe7656 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7657 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7656);
// compiled member node returning call7657 (depth = 7)
  int op_slot_left_7652 = gc_frame_newslot(call7657);
  params[0] = call7654;
  partcv[0] = 1;
  Object sum7658 = callmethod(call7657, "+(1)", 1, partcv, params);
// compiled op node returning sum7658 (depth = 6)
  int op_slot_left_7649 = gc_frame_newslot(sum7658);
  params[0] = num7650;
  partcv[0] = 1;
  Object diff7659 = callmethod(sum7658, "-(1)", 1, partcv, params);
// compiled op node returning diff7659 (depth = 5)
  gc_frame_newslot(diff7659);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call7648;
  params[1] = diff7659;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7660 = callmethodflags(module_ast, "line(1)column(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7646);
// compiled call node returning call7660 (depth = 4)
  gc_frame_newslot(call7660);
// call case 4: self request
  params[0] = call7660;
  partcv[0] = 1;
  Object call7661 = callmethodflags(self, "end:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7645);
// compiled call node returning call7661 (depth = 3)
  gc_frame_end(frame);
  return call7661;
}
Object meth_ast_7662_nameString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2002
  setline(2002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7663 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7664 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7663);
// compiled member node returning call7664 (depth = 3)
  gc_frame_end(frame);
  return call7664;
}
Object meth_ast_7666_quoted(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "quoted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2004
  setline(2004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7667 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7668 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7669 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7668);
// compiled member node returning call7669 (depth = 4)
  partcv[0] = 0;
  Object call7670 = callmethodflags(call7669, "quoted", 1, partcv, params, 0);
  gc_frame_end(callframe7667);
// compiled member node returning call7670 (depth = 3)
  gc_frame_end(frame);
  return call7670;
}
Object meth_ast_7671_isIdentifier(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2005
  setline(2005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7672 = alloc_Boolean(1);
// compiled identifier node returning bool7672 (depth = 3)
  gc_frame_end(frame);
  return bool7672;
}
Object meth_ast_7673_isSelf(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSelf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2007
  setline(2007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7675 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7676 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7675);
// compiled member node returning call7676 (depth = 4)
  int op_slot_right_7674 = gc_frame_newslot(call7676);
// starting to compile string node (depth = 4)
  if (strlit7678 == NULL) {
    strlit7678 = alloc_String("self");
    gc_root(strlit7678);
  }
// compiled string node returning strlit7678 (depth = 4)
  int op_slot_left_7674 = gc_frame_newslot(strlit7678);
  params[0] = call7676;
  partcv[0] = 1;
  Object opresult7679 = callmethod(strlit7678, "==(1)", 1, partcv, params);
// compiled op node returning opresult7679 (depth = 3)
  gc_frame_end(frame);
  return opresult7679;
}
Object meth_ast_7680_isSuper(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSuper");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2008
  setline(2008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7682 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7683 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7682);
// compiled member node returning call7683 (depth = 4)
  int op_slot_right_7681 = gc_frame_newslot(call7683);
// starting to compile string node (depth = 4)
  if (strlit7685 == NULL) {
    strlit7685 = alloc_String("super");
    gc_root(strlit7685);
  }
// compiled string node returning strlit7685 (depth = 4)
  int op_slot_left_7681 = gc_frame_newslot(strlit7685);
  params[0] = call7683;
  partcv[0] = 1;
  Object opresult7686 = callmethod(strlit7685, "==(1)", 1, partcv, params);
// compiled op node returning opresult7686 (depth = 3)
  gc_frame_end(frame);
  return opresult7686;
}
Object meth_ast_7687_isPrelude(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPrelude");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2009
  setline(2009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7689 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7690 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7689);
// compiled member node returning call7690 (depth = 4)
  int op_slot_right_7688 = gc_frame_newslot(call7690);
// starting to compile string node (depth = 4)
  if (strlit7692 == NULL) {
    strlit7692 = alloc_String("prelude");
    gc_root(strlit7692);
  }
// compiled string node returning strlit7692 (depth = 4)
  int op_slot_left_7688 = gc_frame_newslot(strlit7692);
  params[0] = call7690;
  partcv[0] = 1;
  Object opresult7693 = callmethod(strlit7692, "==(1)", 1, partcv, params);
// compiled op node returning opresult7693 (depth = 3)
  gc_frame_end(frame);
  return opresult7693;
}
Object meth_ast_7694_isOuter(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isOuter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2010
  setline(2010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7696 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7697 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7696);
// compiled member node returning call7697 (depth = 4)
  int op_slot_right_7695 = gc_frame_newslot(call7697);
// starting to compile string node (depth = 4)
  if (strlit7699 == NULL) {
    strlit7699 = alloc_String("outer");
    gc_root(strlit7699);
  }
// compiled string node returning strlit7699 (depth = 4)
  int op_slot_left_7695 = gc_frame_newslot(strlit7699);
  params[0] = call7697;
  partcv[0] = 1;
  Object opresult7700 = callmethod(strlit7699, "==(1)", 1, partcv, params);
// compiled op node returning opresult7700 (depth = 3)
  gc_frame_end(frame);
  return opresult7700;
}
Object meth_ast_7701_isSelfOrOuter(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSelfOrOuter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2012
  setline(2012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7703 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7704 = callmethodflags(self, "isSelf", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7703);
// compiled member node returning call7704 (depth = 4)
  Object if7702 = done;
  if (istrue(call7704)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool7705 = alloc_Boolean(1);
// compiled identifier node returning bool7705 (depth = 5)
  return bool7705;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if7702 = undefined;
  } else {
  }
// compiled if node returning if7702 (depth = 3)
// Begin line 2013
  setline(2013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7707 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7708 = callmethodflags(self, "isOuter", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7707);
// compiled member node returning call7708 (depth = 4)
  Object if7706 = done;
  if (istrue(call7708)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool7709 = alloc_Boolean(1);
// compiled identifier node returning bool7709 (depth = 5)
  return bool7709;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if7706 = undefined;
  } else {
  }
// compiled if node returning if7706 (depth = 3)
// Begin line 2014
  setline(2014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool7710 = alloc_Boolean(0);
// compiled identifier node returning bool7710 (depth = 4)
  return bool7710;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_7711_isAppliedOccurenceOfIdentifier(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isAppliedOccurenceOfIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 2017
  setline(2017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7713 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7714 = callmethodflags(self, "wildcard", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7713);
// compiled member node returning call7714 (depth = 4)
  Object if7712 = done;
  if (istrue(call7714)) {
// Begin line 2018
  setline(2018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool7715 = alloc_Boolean(0);
// compiled identifier node returning bool7715 (depth = 4)
    gc_frame_newslot(bool7715);
    if7712 = bool7715;
  } else {
// Begin line 2020
  setline(2020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7716 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7717 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7718 = callmethodflags(self, "isBindingOccurrence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7717);
// compiled member node returning call7718 (depth = 5)
  partcv[0] = 0;
  Object call7719 = callmethodflags(call7718, "not", 1, partcv, params, 0);
  gc_frame_end(callframe7716);
// compiled member node returning call7719 (depth = 4)
    gc_frame_newslot(call7719);
    if7712 = call7719;
  }
// compiled if node returning if7712 (depth = 3)
  gc_frame_end(frame);
  return if7712;
}
Object meth_ast_7720_declarationKindWithAncestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2024
  setline(2024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7721 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7722 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  partcv[0] = 0;
  Object call7723 = callmethodflags(*var_as, "parent", 1, partcv, params, 0);
  gc_frame_end(callframe7722);
// compiled member node returning call7723 (depth = 4)
  params[0] = *var_as;
  partcv[0] = 1;
  Object call7724 = callmethodflags(call7723, "declarationKindWithAncestors(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7721);
// compiled call node returning call7724 (depth = 3)
  gc_frame_end(frame);
  return call7724;
}
Object meth_ast_7725_inTypePositionWithAncestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inTypePositionWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method inTypePositionWithAncestors(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for inTypePositionWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part inTypePositionWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7727 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  partcv[0] = 0;
  Object call7728 = callmethodflags(*var_as, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe7727);
// compiled member node returning call7728 (depth = 4)
  Object if7726 = done;
  if (istrue(call7728)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool7729 = alloc_Boolean(0);
// compiled identifier node returning bool7729 (depth = 5)
  return bool7729;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if7726 = undefined;
  } else {
  }
// compiled if node returning if7726 (depth = 3)
// Begin line 2031
  setline(2031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7730 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7731 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  partcv[0] = 0;
  Object call7732 = callmethodflags(*var_as, "parent", 1, partcv, params, 0);
  gc_frame_end(callframe7731);
// compiled member node returning call7732 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7733 = callmethodflags(call7732, "usesAsType(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7730);
// compiled call node returning call7733 (depth = 3)
  gc_frame_end(frame);
  return call7733;
}
Object meth_ast_7734_usesAsType_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part usesAsType(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2034
  setline(2034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7736 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7737 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7736);
// compiled member node returning call7737 (depth = 4)
  int op_slot_right_7735 = gc_frame_newslot(call7737);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_7735 = gc_frame_newslot(*var_aNode);
  params[0] = call7737;
  partcv[0] = 1;
  Object opresult7739 = callmethod(*var_aNode, "==(1)", 1, partcv, params);
// compiled op node returning opresult7739 (depth = 3)
  gc_frame_end(frame);
  return opresult7739;
}
Object meth_ast_7740_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// definebindings:
// definebindings:
// definebindings:
// Begin line 2037
  setline(2037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7742 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7743 = callmethodflags(*var_visitor, "visitIdentifier(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7742);
// compiled call node returning call7743 (depth = 4)
  Object if7741 = done;
  if (istrue(call7743)) {
// Begin line 2038
  setline(2038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7744 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call7745 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7744);
// compiled call node returning call7745 (depth = 5)
  *var_newChain = call7745;
  if (call7745 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2039
  setline(2039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7748 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7749 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7748);
// compiled member node returning call7749 (depth = 6)
  int op_slot_right_7747 = gc_frame_newslot(call7749);
// starting to compile identifier node (depth = 6)
  Object bool7751 = alloc_Boolean(0);
// compiled identifier node returning bool7751 (depth = 6)
  int op_slot_left_7747 = gc_frame_newslot(bool7751);
  params[0] = call7749;
  partcv[0] = 1;
  Object opresult7752 = callmethod(bool7751, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7752 (depth = 5)
  Object if7746 = done;
  if (istrue(opresult7752)) {
// Begin line 2040
  setline(2040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7753 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7754 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7755 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7754);
// compiled member node returning call7755 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7756 = callmethodflags(call7755, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7753);
// compiled call node returning call7756 (depth = 5)
    gc_frame_newslot(call7756);
    if7746 = call7756;
  } else {
  }
// compiled if node returning if7746 (depth = 4)
    gc_frame_newslot(if7746);
    if7741 = if7746;
  } else {
  }
// compiled if node returning if7741 (depth = 3)
  gc_frame_end(frame);
  return if7741;
}
Object meth_ast_7757_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2045
  setline(2045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7758 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7759 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7758);
// compiled member node returning call7759 (depth = 4)
  *var_n = call7759;
  if (call7759 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2046
  setline(2046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7760 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7761 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7760);
// compiled call node returning call7761 (depth = 4)
  *var_newChain = call7761;
  if (call7761 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2047
  setline(2047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7762 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7763 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7764 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7765 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7764);
// compiled member node returning call7765 (depth = 5)
  gc_frame_newslot(call7765);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call7765;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call7766 = callmethodflags(module_ast, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7763);
// compiled call node returning call7766 (depth = 4)
  gc_frame_newslot(call7766);
// call case 6: other requests
// Begin line 2047
  setline(2047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7766;
  partcv[0] = 1;
  Object call7767 = callmethodflags(*var_n, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7762);
// compiled call node returning call7767 (depth = 3)
// Begin line 2048
  setline(2048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7768 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7769 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7768);
// compiled call node returning call7769 (depth = 3)
  gc_frame_end(frame);
  return call7769;
}
Object meth_ast_7874__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2067
  setline(2067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7876 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num7878 = alloc_Float64(2);
// compiled num node returning num7878 (depth = 10)
  int op_slot_right_7877 = gc_frame_newslot(num7878);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_7877 = gc_frame_newslot(*var_depth);
  params[0] = num7878;
  partcv[0] = 1;
  Object sum7880 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7880 (depth = 9)
  gc_frame_newslot(sum7880);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_g (depth = 9)
  params[0] = sum7880;
  partcv[0] = 1;
  Object call7881 = callmethodflags(*var_g, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7876);
// compiled call node returning call7881 (depth = 8)
  int op_slot_right_7875 = gc_frame_newslot(call7881);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7884 == NULL) {
    strlit7884 = alloc_String("  ");
    gc_root(strlit7884);
  }
// compiled string node returning strlit7884 (depth = 9)
  int op_slot_right_7883 = gc_frame_newslot(strlit7884);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_7886 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit7889 == NULL) {
    strlit7889 = alloc_String("""\x0a""");
    gc_root(strlit7889);
  }
// compiled string node returning strlit7889 (depth = 11)
  int op_slot_right_7888 = gc_frame_newslot(strlit7889);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_7888 = gc_frame_newslot(*var_s);
  params[0] = strlit7889;
  partcv[0] = 1;
  Object opresult7891 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7891 (depth = 10)
  int op_slot_left_7886 = gc_frame_newslot(opresult7891);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7892 = callmethod(opresult7891, "++(1)", 1, partcv, params);
// compiled op node returning opresult7892 (depth = 9)
  int op_slot_left_7883 = gc_frame_newslot(opresult7892);
  params[0] = strlit7884;
  partcv[0] = 1;
  Object opresult7893 = callmethod(opresult7892, "++(1)", 1, partcv, params);
// compiled op node returning opresult7893 (depth = 8)
  int op_slot_left_7875 = gc_frame_newslot(opresult7893);
  params[0] = call7881;
  partcv[0] = 1;
  Object opresult7894 = callmethod(opresult7893, "++(1)", 1, partcv, params);
// compiled op node returning opresult7894 (depth = 7)
  *var_s = opresult7894;
  if (opresult7894 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_7770_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2051
  setline(2051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num7773 = alloc_Float64(1);
// compiled num node returning num7773 (depth = 6)
  int op_slot_right_7772 = gc_frame_newslot(num7773);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_7772 = gc_frame_newslot(*var_depth);
  params[0] = num7773;
  partcv[0] = 1;
  Object sum7775 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7775 (depth = 5)
  int op_slot_right_7771 = gc_frame_newslot(sum7775);
// starting to compile string node (depth = 5)
  if (strlit7777 == NULL) {
    strlit7777 = alloc_String("  ");
    gc_root(strlit7777);
  }
// compiled string node returning strlit7777 (depth = 5)
  int op_slot_left_7771 = gc_frame_newslot(strlit7777);
  params[0] = sum7775;
  partcv[0] = 1;
  Object prod7778 = callmethod(strlit7777, "*(1)", 1, partcv, params);
// compiled op node returning prod7778 (depth = 4)
  *var_spc = prod7778;
  if (prod7778 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2052
  setline(2052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7779 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7780 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7779);
// compiled call node returning call7780 (depth = 4)
  *var_s = call7780;
  if (call7780 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2053
  setline(2053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7782 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7783 = callmethodflags(self, "wildcard", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7782);
// compiled member node returning call7783 (depth = 4)
  Object if7781 = done;
  if (istrue(call7783)) {
// Begin line 2054
  setline(2054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7785 == NULL) {
    strlit7785 = alloc_String(" Wildcard");
    gc_root(strlit7785);
  }
// compiled string node returning strlit7785 (depth = 6)
  int op_slot_right_7784 = gc_frame_newslot(strlit7785);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7784 = gc_frame_newslot(*var_s);
  params[0] = strlit7785;
  partcv[0] = 1;
  Object opresult7787 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7787 (depth = 5)
  *var_s = opresult7787;
  if (opresult7787 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7781 = done;
  } else {
// Begin line 2057
  setline(2057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2055
  setline(2055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe7790 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7791 = callmethodflags(self, "isBindingOccurrence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7790);
// compiled member node returning call7791 (depth = 5)
  Object if7789 = done;
  if (istrue(call7791)) {
// Begin line 2056
  setline(2056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7794 == NULL) {
    strlit7794 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit7794);
  }
// compiled string node returning strlit7794 (depth = 8)
  int op_slot_right_7793 = gc_frame_newslot(strlit7794);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe7797 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7798 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7797);
// compiled member node returning call7798 (depth = 9)
  int op_slot_right_7796 = gc_frame_newslot(call7798);
// starting to compile string node (depth = 9)
  if (strlit7800 == NULL) {
    strlit7800 = alloc_String("Binding""\xe2""""\x80""""\xb9""");
    gc_root(strlit7800);
  }
// compiled string node returning strlit7800 (depth = 9)
  int op_slot_left_7796 = gc_frame_newslot(strlit7800);
  params[0] = call7798;
  partcv[0] = 1;
  Object opresult7801 = callmethod(strlit7800, "++(1)", 1, partcv, params);
// compiled op node returning opresult7801 (depth = 8)
  int op_slot_left_7793 = gc_frame_newslot(opresult7801);
  params[0] = strlit7794;
  partcv[0] = 1;
  Object opresult7802 = callmethod(opresult7801, "++(1)", 1, partcv, params);
// compiled op node returning opresult7802 (depth = 7)
  int op_slot_right_7792 = gc_frame_newslot(opresult7802);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7792 = gc_frame_newslot(*var_s);
  params[0] = opresult7802;
  partcv[0] = 1;
  Object opresult7804 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7804 (depth = 6)
  *var_s = opresult7804;
  if (opresult7804 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7789 = done;
  } else {
// Begin line 2058
  setline(2058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7808 == NULL) {
    strlit7808 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit7808);
  }
// compiled string node returning strlit7808 (depth = 8)
  int op_slot_right_7807 = gc_frame_newslot(strlit7808);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe7811 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7812 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7811);
// compiled member node returning call7812 (depth = 9)
  int op_slot_right_7810 = gc_frame_newslot(call7812);
// starting to compile string node (depth = 9)
  if (strlit7814 == NULL) {
    strlit7814 = alloc_String("""\xe2""""\x80""""\xb9""");
    gc_root(strlit7814);
  }
// compiled string node returning strlit7814 (depth = 9)
  int op_slot_left_7810 = gc_frame_newslot(strlit7814);
  params[0] = call7812;
  partcv[0] = 1;
  Object opresult7815 = callmethod(strlit7814, "++(1)", 1, partcv, params);
// compiled op node returning opresult7815 (depth = 8)
  int op_slot_left_7807 = gc_frame_newslot(opresult7815);
  params[0] = strlit7808;
  partcv[0] = 1;
  Object opresult7816 = callmethod(opresult7815, "++(1)", 1, partcv, params);
// compiled op node returning opresult7816 (depth = 7)
  int op_slot_right_7806 = gc_frame_newslot(opresult7816);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7806 = gc_frame_newslot(*var_s);
  params[0] = opresult7816;
  partcv[0] = 1;
  Object opresult7818 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7818 (depth = 6)
  *var_s = opresult7818;
  if (opresult7818 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7789 = done;
  }
// compiled if node returning if7789 (depth = 4)
    gc_frame_newslot(if7789);
    if7781 = if7789;
  }
// compiled if node returning if7781 (depth = 3)
// Begin line 2060
  setline(2060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7822 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7823 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7822);
// compiled member node returning call7823 (depth = 5)
  int op_slot_right_7821 = gc_frame_newslot(call7823);
// starting to compile identifier node (depth = 5)
  Object bool7825 = alloc_Boolean(0);
// compiled identifier node returning bool7825 (depth = 5)
  int op_slot_left_7821 = gc_frame_newslot(bool7825);
  params[0] = call7823;
  partcv[0] = 1;
  Object opresult7826 = callmethod(bool7825, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7826 (depth = 4)
  Object if7820 = done;
  if (istrue(opresult7826)) {
// Begin line 2061
  setline(2061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7828 == NULL) {
    strlit7828 = alloc_String("  Type: ");
    gc_root(strlit7828);
  }
// compiled string node returning strlit7828 (depth = 6)
  int op_slot_right_7827 = gc_frame_newslot(strlit7828);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_7830 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7833 == NULL) {
    strlit7833 = alloc_String("""\x0a""");
    gc_root(strlit7833);
  }
// compiled string node returning strlit7833 (depth = 8)
  int op_slot_right_7832 = gc_frame_newslot(strlit7833);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7832 = gc_frame_newslot(*var_s);
  params[0] = strlit7833;
  partcv[0] = 1;
  Object opresult7835 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7835 (depth = 7)
  int op_slot_left_7830 = gc_frame_newslot(opresult7835);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7836 = callmethod(opresult7835, "++(1)", 1, partcv, params);
// compiled op node returning opresult7836 (depth = 6)
  int op_slot_left_7827 = gc_frame_newslot(opresult7836);
  params[0] = strlit7828;
  partcv[0] = 1;
  Object opresult7837 = callmethod(opresult7836, "++(1)", 1, partcv, params);
// compiled op node returning opresult7837 (depth = 5)
  *var_s = opresult7837;
  if (opresult7837 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2062
  setline(2062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7840 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num7842 = alloc_Float64(2);
// compiled num node returning num7842 (depth = 8)
  int op_slot_right_7841 = gc_frame_newslot(num7842);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_7841 = gc_frame_newslot(*var_depth);
  params[0] = num7842;
  partcv[0] = 1;
  Object sum7844 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7844 (depth = 7)
  gc_frame_newslot(sum7844);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7845 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7846 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7845);
// compiled member node returning call7846 (depth = 7)
  params[0] = sum7844;
  partcv[0] = 1;
  Object call7847 = callmethodflags(call7846, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7840);
// compiled call node returning call7847 (depth = 6)
  int op_slot_right_7839 = gc_frame_newslot(call7847);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7839 = gc_frame_newslot(*var_s);
  params[0] = call7847;
  partcv[0] = 1;
  Object opresult7849 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7849 (depth = 5)
  *var_s = opresult7849;
  if (opresult7849 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7820 = done;
  } else {
  }
// compiled if node returning if7820 (depth = 3)
// Begin line 2064
  setline(2064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7853 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7854 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7853);
// compiled member node returning call7854 (depth = 5)
  int op_slot_right_7852 = gc_frame_newslot(call7854);
// starting to compile identifier node (depth = 5)
  Object bool7856 = alloc_Boolean(0);
// compiled identifier node returning bool7856 (depth = 5)
  int op_slot_left_7852 = gc_frame_newslot(bool7856);
  params[0] = call7854;
  partcv[0] = 1;
  Object opresult7857 = callmethod(bool7856, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7857 (depth = 4)
  Object if7851 = done;
  if (istrue(opresult7857)) {
// Begin line 2065
  setline(2065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7859 == NULL) {
    strlit7859 = alloc_String("Generics:");
    gc_root(strlit7859);
  }
// compiled string node returning strlit7859 (depth = 6)
  int op_slot_right_7858 = gc_frame_newslot(strlit7859);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_7861 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7864 == NULL) {
    strlit7864 = alloc_String("""\x0a""");
    gc_root(strlit7864);
  }
// compiled string node returning strlit7864 (depth = 8)
  int op_slot_right_7863 = gc_frame_newslot(strlit7864);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7863 = gc_frame_newslot(*var_s);
  params[0] = strlit7864;
  partcv[0] = 1;
  Object opresult7866 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7866 (depth = 7)
  int op_slot_left_7861 = gc_frame_newslot(opresult7866);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7867 = callmethod(opresult7866, "++(1)", 1, partcv, params);
// compiled op node returning opresult7867 (depth = 6)
  int op_slot_left_7858 = gc_frame_newslot(opresult7867);
  params[0] = strlit7859;
  partcv[0] = 1;
  Object opresult7868 = callmethod(opresult7867, "++(1)", 1, partcv, params);
// compiled op node returning opresult7868 (depth = 5)
  *var_s = opresult7868;
  if (opresult7868 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2066
  setline(2066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7870 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7871 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7872 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7871);
// compiled member node returning call7872 (depth = 5)
  gc_frame_newslot(call7872);
// starting to compile block node (depth = 5)
  Object block7873 = alloc_Block(NULL, NULL, "ast", 2066);
  gc_frame_newslot(block7873);
// method "_apply(_)"
  block_savedest(block7873);
  Object closure7874 = createclosure(4, "_apply(1)");
  setclosureframe(closure7874, stackframe);
  addtoclosure(closure7874, var_depth);
  addtoclosure(closure7874, var_spc);
  addtoclosure(closure7874, var_s);
  addtoclosure(closure7874, selfslot);
  struct UserObject *uo7874 = (struct UserObject*)block7873;
  uo7874->data[0] = (Object)closure7874;
  Method *meth_meth_ast_7874__apply_40_1_41_ = addmethod2pos(block7873, "_apply(1)", &meth_ast_7874__apply_40_1_41_, 0);
  int argcv_meth_ast_7874__apply_40_1_41_[] = {1};
  meth_meth_ast_7874__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7874__apply_40_1_41_);
  meth_meth_ast_7874__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7874__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block7873 (depth = 5)
  gc_frame_newslot(block7873);
// call case 5: prelude request
  params[0] = call7872;
  params[1] = block7873;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7897 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7870);
// compiled call node returning call7897 (depth = 4)
    gc_frame_newslot(call7897);
    if7851 = call7897;
  } else {
  }
// compiled if node returning if7851 (depth = 3)
// Begin line 2070
  setline(2070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_7956__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2085
  setline(2085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7958 == NULL) {
    strlit7958 = alloc_String(", ");
    gc_root(strlit7958);
  }
// compiled string node returning strlit7958 (depth = 8)
  int op_slot_right_7957 = gc_frame_newslot(strlit7958);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7961 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num7963 = alloc_Float64(1);
// compiled num node returning num7963 (depth = 11)
  int op_slot_right_7962 = gc_frame_newslot(num7963);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_7962 = gc_frame_newslot(*var_depth);
  params[0] = num7963;
  partcv[0] = 1;
  Object sum7965 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7965 (depth = 10)
  gc_frame_newslot(sum7965);
// call case 6: other requests
// starting to compile call node (depth = 10)
  int callframe7966 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_ix (depth = 11)
  gc_frame_newslot(*var_ix);
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe7967 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7968 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7967);
// compiled member node returning call7968 (depth = 11)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call7969 = callmethodflags(call7968, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7966);
// compiled call node returning call7969 (depth = 10)
  params[0] = sum7965;
  partcv[0] = 1;
  Object call7970 = callmethodflags(call7969, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7961);
// compiled call node returning call7970 (depth = 9)
  int op_slot_right_7960 = gc_frame_newslot(call7970);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_7960 = gc_frame_newslot(*var_s);
  params[0] = call7970;
  partcv[0] = 1;
  Object opresult7972 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7972 (depth = 8)
  int op_slot_left_7957 = gc_frame_newslot(opresult7972);
  params[0] = strlit7958;
  partcv[0] = 1;
  Object opresult7973 = callmethod(opresult7972, "++(1)", 1, partcv, params);
// compiled op node returning opresult7973 (depth = 7)
  *var_s = opresult7973;
  if (opresult7973 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_7898_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2073
  setline(2073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_s = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2074
  setline(2074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7900 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7901 = callmethodflags(self, "wildcard", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7900);
// compiled member node returning call7901 (depth = 4)
  Object if7899 = done;
  if (istrue(call7901)) {
// Begin line 2075
  setline(2075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7902 == NULL) {
    strlit7902 = alloc_String("_");
    gc_root(strlit7902);
  }
// compiled string node returning strlit7902 (depth = 5)
  *var_s = strlit7902;
  if (strlit7902 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7899 = done;
  } else {
// Begin line 2077
  setline(2077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7904 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7905 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7904);
// compiled member node returning call7905 (depth = 5)
  *var_s = call7905;
  if (call7905 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7899 = done;
  }
// compiled if node returning if7899 (depth = 3)
// Begin line 2079
  setline(2079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7909 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7910 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7909);
// compiled member node returning call7910 (depth = 5)
  int op_slot_right_7908 = gc_frame_newslot(call7910);
// starting to compile identifier node (depth = 5)
  Object bool7912 = alloc_Boolean(0);
// compiled identifier node returning bool7912 (depth = 5)
  int op_slot_left_7908 = gc_frame_newslot(bool7912);
  params[0] = call7910;
  partcv[0] = 1;
  Object opresult7913 = callmethod(bool7912, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7913 (depth = 4)
  Object if7907 = done;
  if (istrue(opresult7913)) {
// Begin line 2080
  setline(2080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7915 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num7917 = alloc_Float64(1);
// compiled num node returning num7917 (depth = 8)
  int op_slot_right_7916 = gc_frame_newslot(num7917);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_7916 = gc_frame_newslot(*var_depth);
  params[0] = num7917;
  partcv[0] = 1;
  Object sum7919 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7919 (depth = 7)
  gc_frame_newslot(sum7919);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7920 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7921 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7920);
// compiled member node returning call7921 (depth = 7)
  params[0] = sum7919;
  partcv[0] = 1;
  Object call7922 = callmethodflags(call7921, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7915);
// compiled call node returning call7922 (depth = 6)
  int op_slot_right_7914 = gc_frame_newslot(call7922);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7925 == NULL) {
    strlit7925 = alloc_String(":");
    gc_root(strlit7925);
  }
// compiled string node returning strlit7925 (depth = 7)
  int op_slot_right_7924 = gc_frame_newslot(strlit7925);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7924 = gc_frame_newslot(*var_s);
  params[0] = strlit7925;
  partcv[0] = 1;
  Object opresult7927 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7927 (depth = 6)
  int op_slot_left_7914 = gc_frame_newslot(opresult7927);
  params[0] = call7922;
  partcv[0] = 1;
  Object opresult7928 = callmethod(opresult7927, "++(1)", 1, partcv, params);
// compiled op node returning opresult7928 (depth = 5)
  *var_s = opresult7928;
  if (opresult7928 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7907 = done;
  } else {
  }
// compiled if node returning if7907 (depth = 3)
// Begin line 2082
  setline(2082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7932 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7933 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7932);
// compiled member node returning call7933 (depth = 5)
  int op_slot_right_7931 = gc_frame_newslot(call7933);
// starting to compile identifier node (depth = 5)
  Object bool7935 = alloc_Boolean(0);
// compiled identifier node returning bool7935 (depth = 5)
  int op_slot_left_7931 = gc_frame_newslot(bool7935);
  params[0] = call7933;
  partcv[0] = 1;
  Object opresult7936 = callmethod(bool7935, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7936 (depth = 4)
  Object if7930 = done;
  if (istrue(opresult7936)) {
// Begin line 2083
  setline(2083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7938 == NULL) {
    strlit7938 = alloc_String("""\xe2""""\x9f""""\xa6""");
    gc_root(strlit7938);
  }
// compiled string node returning strlit7938 (depth = 6)
  int op_slot_right_7937 = gc_frame_newslot(strlit7938);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7937 = gc_frame_newslot(*var_s);
  params[0] = strlit7938;
  partcv[0] = 1;
  Object opresult7940 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7940 (depth = 5)
  *var_s = opresult7940;
  if (opresult7940 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2084
  setline(2084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7942 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7945 = alloc_Float64(1);
// compiled num node returning num7945 (depth = 7)
  int op_slot_right_7944 = gc_frame_newslot(num7945);
// starting to compile member node (depth = 7)
  int callframe7947 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe7948 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7949 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7948);
// compiled member node returning call7949 (depth = 8)
  partcv[0] = 0;
  Object call7950 = callmethodflags(call7949, "size", 1, partcv, params, 0);
  gc_frame_end(callframe7947);
// compiled member node returning call7950 (depth = 7)
  int op_slot_left_7944 = gc_frame_newslot(call7950);
  params[0] = num7945;
  partcv[0] = 1;
  Object diff7951 = callmethod(call7950, "-(1)", 1, partcv, params);
// compiled op node returning diff7951 (depth = 6)
  int op_slot_right_7943 = gc_frame_newslot(diff7951);
// starting to compile num node (depth = 6)
  Object num7953 = alloc_Float64(1);
// compiled num node returning num7953 (depth = 6)
  int op_slot_left_7943 = gc_frame_newslot(num7953);
  params[0] = diff7951;
  partcv[0] = 1;
  Object opresult7954 = callmethod(num7953, "..(1)", 1, partcv, params);
// compiled op node returning opresult7954 (depth = 5)
  gc_frame_newslot(opresult7954);
// starting to compile block node (depth = 5)
  Object block7955 = alloc_Block(NULL, NULL, "ast", 2084);
  gc_frame_newslot(block7955);
// method "_apply(_)"
  block_savedest(block7955);
  Object closure7956 = createclosure(3, "_apply(1)");
  setclosureframe(closure7956, stackframe);
  addtoclosure(closure7956, var_depth);
  addtoclosure(closure7956, var_s);
  addtoclosure(closure7956, selfslot);
  struct UserObject *uo7956 = (struct UserObject*)block7955;
  uo7956->data[0] = (Object)closure7956;
  Method *meth_meth_ast_7956__apply_40_1_41_ = addmethod2pos(block7955, "_apply(1)", &meth_ast_7956__apply_40_1_41_, 0);
  int argcv_meth_ast_7956__apply_40_1_41_[] = {1};
  meth_meth_ast_7956__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7956__apply_40_1_41_);
  meth_meth_ast_7956__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7956__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block7955 (depth = 5)
  gc_frame_newslot(block7955);
// call case 5: prelude request
  params[0] = opresult7954;
  params[1] = block7955;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7976 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7942);
// compiled call node returning call7976 (depth = 4)
// Begin line 2087
  setline(2087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7978 == NULL) {
    strlit7978 = alloc_String("""\xe2""""\x9f""""\xa7""");
    gc_root(strlit7978);
  }
// compiled string node returning strlit7978 (depth = 6)
  int op_slot_right_7977 = gc_frame_newslot(strlit7978);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7981 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num7983 = alloc_Float64(1);
// compiled num node returning num7983 (depth = 9)
  int op_slot_right_7982 = gc_frame_newslot(num7983);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_7982 = gc_frame_newslot(*var_depth);
  params[0] = num7983;
  partcv[0] = 1;
  Object sum7985 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7985 (depth = 8)
  gc_frame_newslot(sum7985);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe7986 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe7987 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7988 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7987);
// compiled member node returning call7988 (depth = 9)
  partcv[0] = 0;
  Object call7989 = callmethodflags(call7988, "last", 1, partcv, params, 0);
  gc_frame_end(callframe7986);
// compiled member node returning call7989 (depth = 8)
  params[0] = sum7985;
  partcv[0] = 1;
  Object call7990 = callmethodflags(call7989, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7981);
// compiled call node returning call7990 (depth = 7)
  int op_slot_right_7980 = gc_frame_newslot(call7990);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7980 = gc_frame_newslot(*var_s);
  params[0] = call7990;
  partcv[0] = 1;
  Object opresult7992 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7992 (depth = 6)
  int op_slot_left_7977 = gc_frame_newslot(opresult7992);
  params[0] = strlit7978;
  partcv[0] = 1;
  Object opresult7993 = callmethod(opresult7992, "++(1)", 1, partcv, params);
// compiled op node returning opresult7993 (depth = 5)
  *var_s = opresult7993;
  if (opresult7993 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7930 = done;
  } else {
  }
// compiled if node returning if7930 (depth = 3)
// Begin line 2089
  setline(2089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_7995_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 2093
  setline(2093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7997 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7998 = callmethodflags(self, "isBindingOccurrence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7997);
// compiled member node returning call7998 (depth = 4)
  Object if7996 = done;
  if (istrue(call7998)) {
// Begin line 2094
  setline(2094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8000 == NULL) {
    strlit8000 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit8000);
  }
// compiled string node returning strlit8000 (depth = 5)
  int op_slot_right_7999 = gc_frame_newslot(strlit8000);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8003 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8004 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8003);
// compiled member node returning call8004 (depth = 6)
  int op_slot_right_8002 = gc_frame_newslot(call8004);
// starting to compile string node (depth = 6)
  if (strlit8006 == NULL) {
    strlit8006 = alloc_String("identifierBinding""\xe2""""\x80""""\xb9""");
    gc_root(strlit8006);
  }
// compiled string node returning strlit8006 (depth = 6)
  int op_slot_left_8002 = gc_frame_newslot(strlit8006);
  params[0] = call8004;
  partcv[0] = 1;
  Object opresult8007 = callmethod(strlit8006, "++(1)", 1, partcv, params);
// compiled op node returning opresult8007 (depth = 5)
  int op_slot_left_7999 = gc_frame_newslot(opresult8007);
  params[0] = strlit8000;
  partcv[0] = 1;
  Object opresult8008 = callmethod(opresult8007, "++(1)", 1, partcv, params);
// compiled op node returning opresult8008 (depth = 4)
    gc_frame_newslot(opresult8008);
    if7996 = opresult8008;
  } else {
// Begin line 2096
  setline(2096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8010 == NULL) {
    strlit8010 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit8010);
  }
// compiled string node returning strlit8010 (depth = 5)
  int op_slot_right_8009 = gc_frame_newslot(strlit8010);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8013 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8014 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8013);
// compiled member node returning call8014 (depth = 6)
  int op_slot_right_8012 = gc_frame_newslot(call8014);
// starting to compile string node (depth = 6)
  if (strlit8016 == NULL) {
    strlit8016 = alloc_String("identifier""\xe2""""\x80""""\xb9""");
    gc_root(strlit8016);
  }
// compiled string node returning strlit8016 (depth = 6)
  int op_slot_left_8012 = gc_frame_newslot(strlit8016);
  params[0] = call8014;
  partcv[0] = 1;
  Object opresult8017 = callmethod(strlit8016, "++(1)", 1, partcv, params);
// compiled op node returning opresult8017 (depth = 5)
  int op_slot_left_8009 = gc_frame_newslot(opresult8017);
  params[0] = strlit8010;
  partcv[0] = 1;
  Object opresult8018 = callmethod(opresult8017, "++(1)", 1, partcv, params);
// compiled op node returning opresult8018 (depth = 4)
    gc_frame_newslot(opresult8018);
    if7996 = opresult8018;
  }
// compiled if node returning if7996 (depth = 3)
  gc_frame_end(frame);
  return if7996;
}
Object meth_ast_8019_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2100
  setline(2100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8020 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe8021 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8022 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8023 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8022);
// compiled member node returning call8023 (depth = 5)
  gc_frame_newslot(call8023);
// starting to compile member node (depth = 5)
  int callframe8024 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8025 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8024);
// compiled member node returning call8025 (depth = 5)
  gc_frame_newslot(call8025);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_identifierNode (depth = 5)
  params[0] = call8023;
  params[1] = call8025;
  partcv[0] = 2;
  Object call8026 = callmethodflags(*var_identifierNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8021);
// compiled call node returning call8026 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call8027 = callmethodflags(call8026, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8020);
// compiled call node returning call8027 (depth = 3)
  gc_frame_end(frame);
  return call8027;
}
Object meth_ast_8028_postCopy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "postCopy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method postCopy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for postCopy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part postCopy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2103
  setline(2103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8029 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8030 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call8031 = callmethodflags(*var_other, "wildcard", 1, partcv, params, 0);
  gc_frame_end(callframe8030);
// compiled member node returning call8031 (depth = 4)
  gc_frame_newslot(call8031);
// call case 4: self request
  params[0] = call8031;
  partcv[0] = 1;
  Object call8032 = callmethodflags(self, "wildcard:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8029);
// compiled call node returning call8032 (depth = 3)
// Begin line 2104
  setline(2104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8033 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8034 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call8035 = callmethodflags(*var_other, "isBindingOccurrence", 1, partcv, params, 0);
  gc_frame_end(callframe8034);
// compiled member node returning call8035 (depth = 4)
  gc_frame_newslot(call8035);
// call case 4: self request
  params[0] = call8035;
  partcv[0] = 1;
  Object call8036 = callmethodflags(self, "isBindingOccurrence:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8033);
// compiled call node returning call8036 (depth = 3)
// Begin line 2105
  setline(2105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8037 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8038 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call8039 = callmethodflags(*var_other, "isDeclaredByParent", 1, partcv, params, 0);
  gc_frame_end(callframe8038);
// compiled member node returning call8039 (depth = 4)
  gc_frame_newslot(call8039);
// call case 4: self request
  params[0] = call8039;
  partcv[0] = 1;
  Object call8040 = callmethodflags(self, "isDeclaredByParent:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8037);
// compiled call node returning call8040 (depth = 3)
// Begin line 2106
  setline(2106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8041 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8042 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call8043 = callmethodflags(*var_other, "isAssigned", 1, partcv, params, 0);
  gc_frame_end(callframe8042);
// compiled member node returning call8043 (depth = 4)
  gc_frame_newslot(call8043);
// call case 4: self request
  params[0] = call8043;
  partcv[0] = 1;
  Object call8044 = callmethodflags(self, "isAssigned:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8041);
// compiled call node returning call8044 (depth = 3)
// Begin line 2107
  setline(2107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8045 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8046 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call8047 = callmethodflags(*var_other, "inRequest", 1, partcv, params, 0);
  gc_frame_end(callframe8046);
// compiled member node returning call8047 (depth = 4)
  gc_frame_newslot(call8047);
// call case 4: self request
  params[0] = call8047;
  partcv[0] = 1;
  Object call8048 = callmethodflags(self, "inRequest:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8045);
// compiled call node returning call8048 (depth = 3)
// Begin line 2108
  setline(2108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8049 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8050 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call8051 = callmethodflags(*var_other, "end", 1, partcv, params, 0);
  gc_frame_end(callframe8050);
// compiled member node returning call8051 (depth = 4)
  gc_frame_newslot(call8051);
// call case 4: self request
  params[0] = call8051;
  partcv[0] = 1;
  Object call8052 = callmethodflags(self, "end:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8049);
// compiled call node returning call8052 (depth = 3)
// Begin line 2109
  setline(2109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8053 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8054 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call8055 = callmethodflags(*var_other, "canonicalName", 1, partcv, params, 0);
  gc_frame_end(callframe8054);
// compiled member node returning call8055 (depth = 4)
  gc_frame_newslot(call8055);
// call case 4: self request
  params[0] = call8055;
  partcv[0] = 1;
  Object call8056 = callmethodflags(self, "canonicalName:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8053);
// compiled call node returning call8056 (depth = 3)
// Begin line 2110
  setline(2110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_8057_statementName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2112
  setline(2112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8058 == NULL) {
    strlit8058 = alloc_String("expression");
    gc_root(strlit8058);
  }
// compiled string node returning strlit8058 (depth = 3)
  gc_frame_end(frame);
  return strlit8058;
}
Object meth_ast_7626_new_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[1]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7627 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7627 = alloc_userobj2(43,34, objclass7627);
  gc_frame_newslot(obj7627);
  if (objclass7627 == NULL) {
    glfree(obj7627->class->name);
    obj7627->class->name = "identifierNode.new(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj7627, self, 0);
  addmethodreal(obj7627,"outer", &reader_ast_outer_7628);
  Object oldself7627 = self;
  struct StackFrameObject *oldstackframe7627 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7627);
  gc_frame_newslot((Object)stackframe);
  self = obj7627;
  Object *oldselfslot7627 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7627 = (*(struct UserObject *)self).data[0], lowerouter7627 = thisouter7627;
  if (inheritingObject7627) {
    struct UserObject *inho7627 = (struct UserObject *)inheritingObject7627;
    while (inho7627->super != GraceDefaultObject) inho7627 = (struct UserObject *)inho7627->super;
    inho7627->super = obj7627;
    self = inheritingObject7627;
    *selfslot = self;
    lowerouter7627 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7627;
  }
  if (objclass7627 == NULL) {
  Method *reader7629 = addmethodrealflags(obj7627, "kind",&reader_ast_kind_7629, MFLAG_DEF);
  reader7629->definitionModule = modulename;
  reader7629->definitionLine = 1986;
  }
  adddatum2(obj7627, alloc_Undefined(), 1);
  if (objclass7627 == NULL) {
    Method *reader7630 = addmethodrealflags(obj7627, "value", &reader_ast_value_7630, 0);
    Method *writer7630 = addmethodrealflags(obj7627, "value:=(1)", &writer_ast_value_7630, 0);
    reader7630->definitionModule = modulename;
    writer7630->definitionModule = modulename;
    reader7630->definitionLine = 1987;
    writer7630->definitionLine = 1987;
  }
  obj7627->flags |= OFLAG_MUTABLE;
  adddatum2(obj7627, alloc_Undefined(), 2);
  if (objclass7627 == NULL) {
    Method *reader7631 = addmethodrealflags(obj7627, "wildcard", &reader_ast_wildcard_7631, 0);
    Method *writer7631 = addmethodrealflags(obj7627, "wildcard:=(1)", &writer_ast_wildcard_7631, 0);
    reader7631->definitionModule = modulename;
    writer7631->definitionModule = modulename;
    reader7631->definitionLine = 1988;
    writer7631->definitionLine = 1988;
  }
  obj7627->flags |= OFLAG_MUTABLE;
  adddatum2(obj7627, alloc_Undefined(), 3);
  if (objclass7627 == NULL) {
    Method *reader7632 = addmethodrealflags(obj7627, "dtype", &reader_ast_dtype_7632, 0);
    Method *writer7632 = addmethodrealflags(obj7627, "dtype:=(1)", &writer_ast_dtype_7632, 0);
    reader7632->definitionModule = modulename;
    writer7632->definitionModule = modulename;
    reader7632->definitionLine = 1989;
    writer7632->definitionLine = 1989;
  }
  obj7627->flags |= OFLAG_MUTABLE;
  adddatum2(obj7627, alloc_Undefined(), 4);
  if (objclass7627 == NULL) {
    Method *reader7633 = addmethodrealflags(obj7627, "isBindingOccurrence", &reader_ast_isBindingOccurrence_7633, 0);
    Method *writer7633 = addmethodrealflags(obj7627, "isBindingOccurrence:=(1)", &writer_ast_isBindingOccurrence_7633, 0);
    reader7633->definitionModule = modulename;
    writer7633->definitionModule = modulename;
    reader7633->definitionLine = 1990;
    writer7633->definitionLine = 1990;
  }
  obj7627->flags |= OFLAG_MUTABLE;
  adddatum2(obj7627, alloc_Undefined(), 5);
  if (objclass7627 == NULL) {
    Method *reader7634 = addmethodrealflags(obj7627, "isAssigned", &reader_ast_isAssigned_7634, 0);
    Method *writer7634 = addmethodrealflags(obj7627, "isAssigned:=(1)", &writer_ast_isAssigned_7634, 0);
    reader7634->definitionModule = modulename;
    writer7634->definitionModule = modulename;
    reader7634->definitionLine = 1991;
    writer7634->definitionLine = 1991;
  }
  obj7627->flags |= OFLAG_MUTABLE;
  adddatum2(obj7627, alloc_Undefined(), 6);
  if (objclass7627 == NULL) {
    Method *reader7635 = addmethodrealflags(obj7627, "inRequest", &reader_ast_inRequest_7635, 0);
    Method *writer7635 = addmethodrealflags(obj7627, "inRequest:=(1)", &writer_ast_inRequest_7635, 0);
    reader7635->definitionModule = modulename;
    writer7635->definitionModule = modulename;
    reader7635->definitionLine = 1992;
    writer7635->definitionLine = 1992;
  }
  obj7627->flags |= OFLAG_MUTABLE;
  adddatum2(obj7627, alloc_Undefined(), 7);
  if (objclass7627 == NULL) {
    Method *reader7636 = addmethodrealflags(obj7627, "generics", &reader_ast_generics_7636, 0);
    Method *writer7636 = addmethodrealflags(obj7627, "generics:=(1)", &writer_ast_generics_7636, 0);
    reader7636->definitionModule = modulename;
    writer7636->definitionModule = modulename;
    reader7636->definitionLine = 1993;
    writer7636->definitionLine = 1993;
  }
  obj7627->flags |= OFLAG_MUTABLE;
  adddatum2(obj7627, alloc_Undefined(), 8);
  if (objclass7627 == NULL) {
    Method *reader7637 = addmethodrealflags(obj7627, "isDeclaredByParent", &reader_ast_isDeclaredByParent_7637, 0);
    Method *writer7637 = addmethodrealflags(obj7627, "isDeclaredByParent:=(1)", &writer_ast_isDeclaredByParent_7637, 0);
    reader7637->definitionModule = modulename;
    writer7637->definitionModule = modulename;
    reader7637->definitionLine = 1994;
    writer7637->definitionLine = 1994;
  }
  obj7627->flags |= OFLAG_MUTABLE;
  adddatum2(obj7627, alloc_Undefined(), 9);
  if (objclass7627 == NULL) {
    Method *reader7638 = addmethodrealflags(obj7627, "end", &reader_ast_end_7638, 0);
    Method *writer7638 = addmethodrealflags(obj7627, "end:=(1)", &writer_ast_end_7638, 0);
    reader7638->definitionModule = modulename;
    writer7638->definitionModule = modulename;
    reader7638->definitionLine = 1995;
    writer7638->definitionLine = 1995;
  }
  obj7627->flags |= OFLAG_MUTABLE;
  adddatum2(obj7627, alloc_Undefined(), 10);
// method "name"
  struct UserObject *uo7639 = (struct UserObject*)obj7627;
  uo7639->data[11] = emptyclosure;
  Method *meth_meth_ast_7639_name = addmethod2pos(obj7627, "name", &meth_ast_7639_name, 11);
  int argcv_meth_ast_7639_name[] = {0};
  meth_meth_ast_7639_name->type = alloc_MethodType(1, argcv_meth_ast_7639_name);
  meth_meth_ast_7639_name->definitionModule = modulename;
  meth_meth_ast_7639_name->definitionLine = 1997;
// method "name:=(_)"
  struct UserObject *uo7642 = (struct UserObject*)obj7627;
  uo7642->data[12] = emptyclosure;
  Method *meth_meth_ast_7642_name_58__61__40_1_41_ = addmethod2pos(obj7627, "name:=(1)", &meth_ast_7642_name_58__61__40_1_41_, 12);
  int argcv_meth_ast_7642_name_58__61__40_1_41_[] = {1};
  meth_meth_ast_7642_name_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7642_name_58__61__40_1_41_);
  meth_meth_ast_7642_name_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_7642_name_58__61__40_1_41_->definitionLine = 1998;
// method "nameString"
  struct UserObject *uo7662 = (struct UserObject*)obj7627;
  uo7662->data[13] = emptyclosure;
  Method *meth_meth_ast_7662_nameString = addmethod2pos(obj7627, "nameString", &meth_ast_7662_nameString, 13);
  int argcv_meth_ast_7662_nameString[] = {0};
  meth_meth_ast_7662_nameString->type = alloc_MethodType(1, argcv_meth_ast_7662_nameString);
  meth_meth_ast_7662_nameString->definitionModule = modulename;
  meth_meth_ast_7662_nameString->definitionLine = 2002;
  if (objclass7627 == NULL) {
    Method *reader7665 = addmethodrealflags(obj7627, "canonicalName", &reader_ast_canonicalName_7665, 0);
    Method *writer7665 = addmethodrealflags(obj7627, "canonicalName:=(1)", &writer_ast_canonicalName_7665, 0);
    reader7665->definitionModule = modulename;
    writer7665->definitionModule = modulename;
    reader7665->definitionLine = 2003;
    writer7665->definitionLine = 2003;
  }
  obj7627->flags |= OFLAG_MUTABLE;
  adddatum2(obj7627, alloc_Undefined(), 14);
// method "quoted"
  struct UserObject *uo7666 = (struct UserObject*)obj7627;
  uo7666->data[15] = emptyclosure;
  Method *meth_meth_ast_7666_quoted = addmethod2pos(obj7627, "quoted", &meth_ast_7666_quoted, 15);
  int argcv_meth_ast_7666_quoted[] = {0};
  meth_meth_ast_7666_quoted->type = alloc_MethodType(1, argcv_meth_ast_7666_quoted);
  meth_meth_ast_7666_quoted->definitionModule = modulename;
  meth_meth_ast_7666_quoted->definitionLine = 2004;
// method "isIdentifier"
  struct UserObject *uo7671 = (struct UserObject*)obj7627;
  uo7671->data[16] = emptyclosure;
  Method *meth_meth_ast_7671_isIdentifier = addmethod2pos(obj7627, "isIdentifier", &meth_ast_7671_isIdentifier, 16);
  int argcv_meth_ast_7671_isIdentifier[] = {0};
  meth_meth_ast_7671_isIdentifier->type = alloc_MethodType(1, argcv_meth_ast_7671_isIdentifier);
  meth_meth_ast_7671_isIdentifier->definitionModule = modulename;
  meth_meth_ast_7671_isIdentifier->definitionLine = 2005;
// method "isSelf"
  struct UserObject *uo7673 = (struct UserObject*)obj7627;
  uo7673->data[17] = emptyclosure;
  Method *meth_meth_ast_7673_isSelf = addmethod2pos(obj7627, "isSelf", &meth_ast_7673_isSelf, 17);
  int argcv_meth_ast_7673_isSelf[] = {0};
  meth_meth_ast_7673_isSelf->type = alloc_MethodType(1, argcv_meth_ast_7673_isSelf);
  meth_meth_ast_7673_isSelf->definitionModule = modulename;
  meth_meth_ast_7673_isSelf->definitionLine = 2007;
// method "isSuper"
  struct UserObject *uo7680 = (struct UserObject*)obj7627;
  uo7680->data[18] = emptyclosure;
  Method *meth_meth_ast_7680_isSuper = addmethod2pos(obj7627, "isSuper", &meth_ast_7680_isSuper, 18);
  int argcv_meth_ast_7680_isSuper[] = {0};
  meth_meth_ast_7680_isSuper->type = alloc_MethodType(1, argcv_meth_ast_7680_isSuper);
  meth_meth_ast_7680_isSuper->definitionModule = modulename;
  meth_meth_ast_7680_isSuper->definitionLine = 2008;
// method "isPrelude"
  struct UserObject *uo7687 = (struct UserObject*)obj7627;
  uo7687->data[19] = emptyclosure;
  Method *meth_meth_ast_7687_isPrelude = addmethod2pos(obj7627, "isPrelude", &meth_ast_7687_isPrelude, 19);
  int argcv_meth_ast_7687_isPrelude[] = {0};
  meth_meth_ast_7687_isPrelude->type = alloc_MethodType(1, argcv_meth_ast_7687_isPrelude);
  meth_meth_ast_7687_isPrelude->definitionModule = modulename;
  meth_meth_ast_7687_isPrelude->definitionLine = 2009;
// method "isOuter"
  struct UserObject *uo7694 = (struct UserObject*)obj7627;
  uo7694->data[20] = emptyclosure;
  Method *meth_meth_ast_7694_isOuter = addmethod2pos(obj7627, "isOuter", &meth_ast_7694_isOuter, 20);
  int argcv_meth_ast_7694_isOuter[] = {0};
  meth_meth_ast_7694_isOuter->type = alloc_MethodType(1, argcv_meth_ast_7694_isOuter);
  meth_meth_ast_7694_isOuter->definitionModule = modulename;
  meth_meth_ast_7694_isOuter->definitionLine = 2010;
// method "isSelfOrOuter"
  struct UserObject *uo7701 = (struct UserObject*)obj7627;
  uo7701->data[21] = emptyclosure;
  Method *meth_meth_ast_7701_isSelfOrOuter = addmethod2pos(obj7627, "isSelfOrOuter", &meth_ast_7701_isSelfOrOuter, 21);
  int argcv_meth_ast_7701_isSelfOrOuter[] = {0};
  meth_meth_ast_7701_isSelfOrOuter->type = alloc_MethodType(1, argcv_meth_ast_7701_isSelfOrOuter);
  meth_meth_ast_7701_isSelfOrOuter->definitionModule = modulename;
  meth_meth_ast_7701_isSelfOrOuter->definitionLine = 2011;
// method "isAppliedOccurenceOfIdentifier"
  struct UserObject *uo7711 = (struct UserObject*)obj7627;
  uo7711->data[22] = emptyclosure;
  Method *meth_meth_ast_7711_isAppliedOccurenceOfIdentifier = addmethod2pos(obj7627, "isAppliedOccurenceOfIdentifier", &meth_ast_7711_isAppliedOccurenceOfIdentifier, 22);
  int argcv_meth_ast_7711_isAppliedOccurenceOfIdentifier[] = {0};
  meth_meth_ast_7711_isAppliedOccurenceOfIdentifier->type = alloc_MethodType(1, argcv_meth_ast_7711_isAppliedOccurenceOfIdentifier);
  meth_meth_ast_7711_isAppliedOccurenceOfIdentifier->definitionModule = modulename;
  meth_meth_ast_7711_isAppliedOccurenceOfIdentifier->definitionLine = 2016;
// method "declarationKindWithAncestors(_)"
  struct UserObject *uo7720 = (struct UserObject*)obj7627;
  uo7720->data[23] = emptyclosure;
  Method *meth_meth_ast_7720_declarationKindWithAncestors_40_1_41_ = addmethod2pos(obj7627, "declarationKindWithAncestors(1)", &meth_ast_7720_declarationKindWithAncestors_40_1_41_, 23);
  int argcv_meth_ast_7720_declarationKindWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_7720_declarationKindWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7720_declarationKindWithAncestors_40_1_41_);
  meth_meth_ast_7720_declarationKindWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7720_declarationKindWithAncestors_40_1_41_->definitionLine = 2023;
// method "inTypePositionWithAncestors(_)"
  struct UserObject *uo7725 = (struct UserObject*)obj7627;
  uo7725->data[24] = emptyclosure;
  Method *meth_meth_ast_7725_inTypePositionWithAncestors_40_1_41_ = addmethod2pos(obj7627, "inTypePositionWithAncestors(1)", &meth_ast_7725_inTypePositionWithAncestors_40_1_41_, 24);
  int argcv_meth_ast_7725_inTypePositionWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_7725_inTypePositionWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7725_inTypePositionWithAncestors_40_1_41_);
  meth_meth_ast_7725_inTypePositionWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7725_inTypePositionWithAncestors_40_1_41_->definitionLine = 2026;
// method "usesAsType(_)"
  struct UserObject *uo7734 = (struct UserObject*)obj7627;
  uo7734->data[25] = emptyclosure;
  Method *meth_meth_ast_7734_usesAsType_40_1_41_ = addmethod2pos(obj7627, "usesAsType(1)", &meth_ast_7734_usesAsType_40_1_41_, 25);
  int argcv_meth_ast_7734_usesAsType_40_1_41_[] = {1};
  meth_meth_ast_7734_usesAsType_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7734_usesAsType_40_1_41_);
  meth_meth_ast_7734_usesAsType_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7734_usesAsType_40_1_41_->definitionLine = 2033;
// method "accept(_)from(_)"
  struct UserObject *uo7740 = (struct UserObject*)obj7627;
  uo7740->data[26] = emptyclosure;
  Method *meth_meth_ast_7740_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj7627, "accept(1)from(1)", &meth_ast_7740_accept_40_1_41_from_40_1_41_, 26);
  int argcv_meth_ast_7740_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_7740_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_7740_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_7740_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7740_accept_40_1_41_from_40_1_41_->definitionLine = 2036;
// method "map(_)ancestors(_)"
  struct UserObject *uo7757 = (struct UserObject*)obj7627;
  uo7757->data[27] = emptyclosure;
  Method *meth_meth_ast_7757_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj7627, "map(1)ancestors(1)", &meth_ast_7757_map_40_1_41_ancestors_40_1_41_, 27);
  int argcv_meth_ast_7757_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_7757_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_7757_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_7757_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7757_map_40_1_41_ancestors_40_1_41_->definitionLine = 2044;
// method "pretty(_)"
  struct UserObject *uo7770 = (struct UserObject*)obj7627;
  uo7770->data[28] = emptyclosure;
  Method *meth_meth_ast_7770_pretty_40_1_41_ = addmethod2pos(obj7627, "pretty(1)", &meth_ast_7770_pretty_40_1_41_, 28);
  int argcv_meth_ast_7770_pretty_40_1_41_[] = {1};
  meth_meth_ast_7770_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7770_pretty_40_1_41_);
  meth_meth_ast_7770_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7770_pretty_40_1_41_->definitionLine = 2050;
// method "toGrace(_)"
  struct UserObject *uo7898 = (struct UserObject*)obj7627;
  uo7898->data[29] = emptyclosure;
  Method *meth_meth_ast_7898_toGrace_40_1_41_ = addmethod2pos(obj7627, "toGrace(1)", &meth_ast_7898_toGrace_40_1_41_, 29);
  int argcv_meth_ast_7898_toGrace_40_1_41_[] = {1};
  meth_meth_ast_7898_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7898_toGrace_40_1_41_);
meth_meth_ast_7898_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_7898_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_7898_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7898_toGrace_40_1_41_->definitionLine = 2072;
// method "asString"
  struct UserObject *uo7995 = (struct UserObject*)obj7627;
  uo7995->data[30] = emptyclosure;
  Method *meth_meth_ast_7995_asString = addmethod2pos(obj7627, "asString", &meth_ast_7995_asString, 30);
  int argcv_meth_ast_7995_asString[] = {0};
  meth_meth_ast_7995_asString->type = alloc_MethodType(1, argcv_meth_ast_7995_asString);
  meth_meth_ast_7995_asString->definitionModule = modulename;
  meth_meth_ast_7995_asString->definitionLine = 2092;
// method "shallowCopy"
  block_savedest(obj7627);
  Object closure8019 = createclosure(1, "shallowCopy");
  setclosureframe(closure8019, stackframe);
  addtoclosure(closure8019, var_identifierNode);
  struct UserObject *uo8019 = (struct UserObject*)obj7627;
  uo8019->data[31] = (Object)closure8019;
  Method *meth_meth_ast_8019_shallowCopy = addmethod2pos(obj7627, "shallowCopy", &meth_ast_8019_shallowCopy, 31);
  int argcv_meth_ast_8019_shallowCopy[] = {0};
  meth_meth_ast_8019_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_8019_shallowCopy);
  meth_meth_ast_8019_shallowCopy->definitionModule = modulename;
  meth_meth_ast_8019_shallowCopy->definitionLine = 2099;
// method "postCopy(_)"
  struct UserObject *uo8028 = (struct UserObject*)obj7627;
  uo8028->data[32] = emptyclosure;
  Method *meth_meth_ast_8028_postCopy_40_1_41_ = addmethod2pos(obj7627, "postCopy(1)", &meth_ast_8028_postCopy_40_1_41_, 32);
  int argcv_meth_ast_8028_postCopy_40_1_41_[] = {1};
  meth_meth_ast_8028_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8028_postCopy_40_1_41_);
  meth_meth_ast_8028_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8028_postCopy_40_1_41_->definitionLine = 2102;
// method "statementName"
  struct UserObject *uo8057 = (struct UserObject*)obj7627;
  uo8057->data[33] = emptyclosure;
  Method *meth_meth_ast_8057_statementName = addmethod2pos(obj7627, "statementName", &meth_ast_8057_statementName, 33);
  int argcv_meth_ast_8057_statementName[] = {0};
  meth_meth_ast_8057_statementName->type = alloc_MethodType(1, argcv_meth_ast_8057_statementName);
  meth_meth_ast_8057_statementName->definitionModule = modulename;
  meth_meth_ast_8057_statementName->definitionLine = 2112;
  sourceObject = obj7627;
// Begin line 1985
  setline(1985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8059 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8060 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8059);
// compiled call node returning call8060 (depth = 3)
  struct UserObject *obj7627_uo = (struct UserObject *)obj7627;
  obj7627_uo->super = call8060;
  sourceObject = obj7627;
// Begin line 1986
  setline(1986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8061 == NULL) {
    strlit8061 = alloc_String("identifier");
    gc_root(strlit8061);
  }
// compiled string node returning strlit8061 (depth = 3)
  adddatum2(obj7627, strlit8061, 1);
  sourceObject = obj7627;
// Begin line 1987
  setline(1987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj7627, *var_name_39_, 2);
  sourceObject = obj7627;
// Begin line 1988
  setline(1988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8062 = alloc_Boolean(0);
// compiled identifier node returning bool8062 (depth = 3)
  adddatum2(obj7627, bool8062, 3);
  sourceObject = obj7627;
// Begin line 1989
  setline(1989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj7627, *var_dtype_39_, 4);
  sourceObject = obj7627;
// Begin line 1990
  setline(1990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8063 = alloc_Boolean(0);
// compiled identifier node returning bool8063 (depth = 3)
  adddatum2(obj7627, bool8063, 5);
  sourceObject = obj7627;
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8064 = alloc_Boolean(0);
// compiled identifier node returning bool8064 (depth = 3)
  adddatum2(obj7627, bool8064, 6);
  sourceObject = obj7627;
// Begin line 1992
  setline(1992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8065 = alloc_Boolean(0);
// compiled identifier node returning bool8065 (depth = 3)
  adddatum2(obj7627, bool8065, 7);
  sourceObject = obj7627;
// Begin line 1993
  setline(1993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8066 = alloc_Boolean(0);
// compiled identifier node returning bool8066 (depth = 3)
  adddatum2(obj7627, bool8066, 8);
  sourceObject = obj7627;
// Begin line 1994
  setline(1994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8067 = alloc_Boolean(0);
// compiled identifier node returning bool8067 (depth = 3)
  adddatum2(obj7627, bool8067, 9);
  sourceObject = obj7627;
// Begin line 1995
  setline(1995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8068 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8069 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8070 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8069);
// compiled member node returning call8070 (depth = 4)
  gc_frame_newslot(call8070);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8072 = alloc_Float64(1);
// compiled num node returning num8072 (depth = 5)
  int op_slot_right_8071 = gc_frame_newslot(num8072);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8075 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8076 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8077 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8076);
// compiled member node returning call8077 (depth = 7)
  partcv[0] = 0;
  Object call8078 = callmethodflags(call8077, "size", 1, partcv, params, 0);
  gc_frame_end(callframe8075);
// compiled member node returning call8078 (depth = 6)
  int op_slot_right_8074 = gc_frame_newslot(call8078);
// starting to compile member node (depth = 6)
  int callframe8080 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8081 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8080);
// compiled member node returning call8081 (depth = 6)
  int op_slot_left_8074 = gc_frame_newslot(call8081);
  params[0] = call8078;
  partcv[0] = 1;
  Object sum8082 = callmethod(call8081, "+(1)", 1, partcv, params);
// compiled op node returning sum8082 (depth = 5)
  int op_slot_left_8071 = gc_frame_newslot(sum8082);
  params[0] = num8072;
  partcv[0] = 1;
  Object diff8083 = callmethod(sum8082, "-(1)", 1, partcv, params);
// compiled op node returning diff8083 (depth = 4)
  gc_frame_newslot(diff8083);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = call8070;
  params[1] = diff8083;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8084 = callmethodflags(module_ast, "line(1)column(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8068);
// compiled call node returning call8084 (depth = 3)
  adddatum2(obj7627, call8084, 10);
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
// Begin line 2003
  setline(2003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8085 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8086 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8085);
// compiled member node returning call8086 (depth = 3)
  adddatum2(obj7627, call8086, 14);
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  objclass7627 = obj7627->class;
  objclass7627->definitionModule = modulename;
  objclass7627->definitionLine = 1984;
  (*(struct UserObject *)self).data[0] = lowerouter7627;
  self = oldself7627;
  selfslot = oldselfslot7627;
  stackframe = oldstackframe7627;
  gc_frame_end(frame);
  return obj7627;
}
Object meth_ast_7626_new_40_2_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[1]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7627 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7627 = alloc_userobj2(43,34, objclass7627);
  gc_frame_newslot(obj7627);
  if (objclass7627 == NULL) {
    glfree(obj7627->class->name);
    obj7627->class->name = "identifierNode.new(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj7627, self, 0);
  addmethodreal(obj7627,"outer", &reader_ast_outer_7628);
  Object oldself7627 = self;
  struct StackFrameObject *oldstackframe7627 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7627);
  gc_frame_newslot((Object)stackframe);
  self = obj7627;
  Object *oldselfslot7627 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7627 = (*(struct UserObject *)self).data[0], lowerouter7627 = thisouter7627;
  if (inheritingObject7627) {
    struct UserObject *inho7627 = (struct UserObject *)inheritingObject7627;
    while (inho7627->super != GraceDefaultObject) inho7627 = (struct UserObject *)inho7627->super;
    inho7627->super = obj7627;
    self = inheritingObject7627;
    *selfslot = self;
    lowerouter7627 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7627;
  }
  if (objclass7627 == NULL) {
  Method *reader7629 = addmethodrealflags(obj7627, "kind",&reader_ast_kind_7629, MFLAG_DEF);
  reader7629->definitionModule = modulename;
  reader7629->definitionLine = 1986;
  }
  adddatum2(obj7627, alloc_Undefined(), 1);
  if (objclass7627 == NULL) {
    Method *reader7630 = addmethodrealflags(obj7627, "value", &reader_ast_value_7630, 0);
    Method *writer7630 = addmethodrealflags(obj7627, "value:=(1)", &writer_ast_value_7630, 0);
    reader7630->definitionModule = modulename;
    writer7630->definitionModule = modulename;
    reader7630->definitionLine = 1987;
    writer7630->definitionLine = 1987;
  }
  obj7627->flags |= OFLAG_MUTABLE;
  adddatum2(obj7627, alloc_Undefined(), 2);
  if (objclass7627 == NULL) {
    Method *reader7631 = addmethodrealflags(obj7627, "wildcard", &reader_ast_wildcard_7631, 0);
    Method *writer7631 = addmethodrealflags(obj7627, "wildcard:=(1)", &writer_ast_wildcard_7631, 0);
    reader7631->definitionModule = modulename;
    writer7631->definitionModule = modulename;
    reader7631->definitionLine = 1988;
    writer7631->definitionLine = 1988;
  }
  obj7627->flags |= OFLAG_MUTABLE;
  adddatum2(obj7627, alloc_Undefined(), 3);
  if (objclass7627 == NULL) {
    Method *reader7632 = addmethodrealflags(obj7627, "dtype", &reader_ast_dtype_7632, 0);
    Method *writer7632 = addmethodrealflags(obj7627, "dtype:=(1)", &writer_ast_dtype_7632, 0);
    reader7632->definitionModule = modulename;
    writer7632->definitionModule = modulename;
    reader7632->definitionLine = 1989;
    writer7632->definitionLine = 1989;
  }
  obj7627->flags |= OFLAG_MUTABLE;
  adddatum2(obj7627, alloc_Undefined(), 4);
  if (objclass7627 == NULL) {
    Method *reader7633 = addmethodrealflags(obj7627, "isBindingOccurrence", &reader_ast_isBindingOccurrence_7633, 0);
    Method *writer7633 = addmethodrealflags(obj7627, "isBindingOccurrence:=(1)", &writer_ast_isBindingOccurrence_7633, 0);
    reader7633->definitionModule = modulename;
    writer7633->definitionModule = modulename;
    reader7633->definitionLine = 1990;
    writer7633->definitionLine = 1990;
  }
  obj7627->flags |= OFLAG_MUTABLE;
  adddatum2(obj7627, alloc_Undefined(), 5);
  if (objclass7627 == NULL) {
    Method *reader7634 = addmethodrealflags(obj7627, "isAssigned", &reader_ast_isAssigned_7634, 0);
    Method *writer7634 = addmethodrealflags(obj7627, "isAssigned:=(1)", &writer_ast_isAssigned_7634, 0);
    reader7634->definitionModule = modulename;
    writer7634->definitionModule = modulename;
    reader7634->definitionLine = 1991;
    writer7634->definitionLine = 1991;
  }
  obj7627->flags |= OFLAG_MUTABLE;
  adddatum2(obj7627, alloc_Undefined(), 6);
  if (objclass7627 == NULL) {
    Method *reader7635 = addmethodrealflags(obj7627, "inRequest", &reader_ast_inRequest_7635, 0);
    Method *writer7635 = addmethodrealflags(obj7627, "inRequest:=(1)", &writer_ast_inRequest_7635, 0);
    reader7635->definitionModule = modulename;
    writer7635->definitionModule = modulename;
    reader7635->definitionLine = 1992;
    writer7635->definitionLine = 1992;
  }
  obj7627->flags |= OFLAG_MUTABLE;
  adddatum2(obj7627, alloc_Undefined(), 7);
  if (objclass7627 == NULL) {
    Method *reader7636 = addmethodrealflags(obj7627, "generics", &reader_ast_generics_7636, 0);
    Method *writer7636 = addmethodrealflags(obj7627, "generics:=(1)", &writer_ast_generics_7636, 0);
    reader7636->definitionModule = modulename;
    writer7636->definitionModule = modulename;
    reader7636->definitionLine = 1993;
    writer7636->definitionLine = 1993;
  }
  obj7627->flags |= OFLAG_MUTABLE;
  adddatum2(obj7627, alloc_Undefined(), 8);
  if (objclass7627 == NULL) {
    Method *reader7637 = addmethodrealflags(obj7627, "isDeclaredByParent", &reader_ast_isDeclaredByParent_7637, 0);
    Method *writer7637 = addmethodrealflags(obj7627, "isDeclaredByParent:=(1)", &writer_ast_isDeclaredByParent_7637, 0);
    reader7637->definitionModule = modulename;
    writer7637->definitionModule = modulename;
    reader7637->definitionLine = 1994;
    writer7637->definitionLine = 1994;
  }
  obj7627->flags |= OFLAG_MUTABLE;
  adddatum2(obj7627, alloc_Undefined(), 9);
  if (objclass7627 == NULL) {
    Method *reader7638 = addmethodrealflags(obj7627, "end", &reader_ast_end_7638, 0);
    Method *writer7638 = addmethodrealflags(obj7627, "end:=(1)", &writer_ast_end_7638, 0);
    reader7638->definitionModule = modulename;
    writer7638->definitionModule = modulename;
    reader7638->definitionLine = 1995;
    writer7638->definitionLine = 1995;
  }
  obj7627->flags |= OFLAG_MUTABLE;
  adddatum2(obj7627, alloc_Undefined(), 10);
// method "name"
  struct UserObject *uo7639 = (struct UserObject*)obj7627;
  uo7639->data[11] = emptyclosure;
  Method *meth_meth_ast_7639_name = addmethod2pos(obj7627, "name", &meth_ast_7639_name, 11);
  int argcv_meth_ast_7639_name[] = {0};
  meth_meth_ast_7639_name->type = alloc_MethodType(1, argcv_meth_ast_7639_name);
  meth_meth_ast_7639_name->definitionModule = modulename;
  meth_meth_ast_7639_name->definitionLine = 1997;
// method "name:=(_)"
  struct UserObject *uo7642 = (struct UserObject*)obj7627;
  uo7642->data[12] = emptyclosure;
  Method *meth_meth_ast_7642_name_58__61__40_1_41_ = addmethod2pos(obj7627, "name:=(1)", &meth_ast_7642_name_58__61__40_1_41_, 12);
  int argcv_meth_ast_7642_name_58__61__40_1_41_[] = {1};
  meth_meth_ast_7642_name_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7642_name_58__61__40_1_41_);
  meth_meth_ast_7642_name_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_7642_name_58__61__40_1_41_->definitionLine = 1998;
// method "nameString"
  struct UserObject *uo7662 = (struct UserObject*)obj7627;
  uo7662->data[13] = emptyclosure;
  Method *meth_meth_ast_7662_nameString = addmethod2pos(obj7627, "nameString", &meth_ast_7662_nameString, 13);
  int argcv_meth_ast_7662_nameString[] = {0};
  meth_meth_ast_7662_nameString->type = alloc_MethodType(1, argcv_meth_ast_7662_nameString);
  meth_meth_ast_7662_nameString->definitionModule = modulename;
  meth_meth_ast_7662_nameString->definitionLine = 2002;
  if (objclass7627 == NULL) {
    Method *reader7665 = addmethodrealflags(obj7627, "canonicalName", &reader_ast_canonicalName_7665, 0);
    Method *writer7665 = addmethodrealflags(obj7627, "canonicalName:=(1)", &writer_ast_canonicalName_7665, 0);
    reader7665->definitionModule = modulename;
    writer7665->definitionModule = modulename;
    reader7665->definitionLine = 2003;
    writer7665->definitionLine = 2003;
  }
  obj7627->flags |= OFLAG_MUTABLE;
  adddatum2(obj7627, alloc_Undefined(), 14);
// method "quoted"
  struct UserObject *uo7666 = (struct UserObject*)obj7627;
  uo7666->data[15] = emptyclosure;
  Method *meth_meth_ast_7666_quoted = addmethod2pos(obj7627, "quoted", &meth_ast_7666_quoted, 15);
  int argcv_meth_ast_7666_quoted[] = {0};
  meth_meth_ast_7666_quoted->type = alloc_MethodType(1, argcv_meth_ast_7666_quoted);
  meth_meth_ast_7666_quoted->definitionModule = modulename;
  meth_meth_ast_7666_quoted->definitionLine = 2004;
// method "isIdentifier"
  struct UserObject *uo7671 = (struct UserObject*)obj7627;
  uo7671->data[16] = emptyclosure;
  Method *meth_meth_ast_7671_isIdentifier = addmethod2pos(obj7627, "isIdentifier", &meth_ast_7671_isIdentifier, 16);
  int argcv_meth_ast_7671_isIdentifier[] = {0};
  meth_meth_ast_7671_isIdentifier->type = alloc_MethodType(1, argcv_meth_ast_7671_isIdentifier);
  meth_meth_ast_7671_isIdentifier->definitionModule = modulename;
  meth_meth_ast_7671_isIdentifier->definitionLine = 2005;
// method "isSelf"
  struct UserObject *uo7673 = (struct UserObject*)obj7627;
  uo7673->data[17] = emptyclosure;
  Method *meth_meth_ast_7673_isSelf = addmethod2pos(obj7627, "isSelf", &meth_ast_7673_isSelf, 17);
  int argcv_meth_ast_7673_isSelf[] = {0};
  meth_meth_ast_7673_isSelf->type = alloc_MethodType(1, argcv_meth_ast_7673_isSelf);
  meth_meth_ast_7673_isSelf->definitionModule = modulename;
  meth_meth_ast_7673_isSelf->definitionLine = 2007;
// method "isSuper"
  struct UserObject *uo7680 = (struct UserObject*)obj7627;
  uo7680->data[18] = emptyclosure;
  Method *meth_meth_ast_7680_isSuper = addmethod2pos(obj7627, "isSuper", &meth_ast_7680_isSuper, 18);
  int argcv_meth_ast_7680_isSuper[] = {0};
  meth_meth_ast_7680_isSuper->type = alloc_MethodType(1, argcv_meth_ast_7680_isSuper);
  meth_meth_ast_7680_isSuper->definitionModule = modulename;
  meth_meth_ast_7680_isSuper->definitionLine = 2008;
// method "isPrelude"
  struct UserObject *uo7687 = (struct UserObject*)obj7627;
  uo7687->data[19] = emptyclosure;
  Method *meth_meth_ast_7687_isPrelude = addmethod2pos(obj7627, "isPrelude", &meth_ast_7687_isPrelude, 19);
  int argcv_meth_ast_7687_isPrelude[] = {0};
  meth_meth_ast_7687_isPrelude->type = alloc_MethodType(1, argcv_meth_ast_7687_isPrelude);
  meth_meth_ast_7687_isPrelude->definitionModule = modulename;
  meth_meth_ast_7687_isPrelude->definitionLine = 2009;
// method "isOuter"
  struct UserObject *uo7694 = (struct UserObject*)obj7627;
  uo7694->data[20] = emptyclosure;
  Method *meth_meth_ast_7694_isOuter = addmethod2pos(obj7627, "isOuter", &meth_ast_7694_isOuter, 20);
  int argcv_meth_ast_7694_isOuter[] = {0};
  meth_meth_ast_7694_isOuter->type = alloc_MethodType(1, argcv_meth_ast_7694_isOuter);
  meth_meth_ast_7694_isOuter->definitionModule = modulename;
  meth_meth_ast_7694_isOuter->definitionLine = 2010;
// method "isSelfOrOuter"
  struct UserObject *uo7701 = (struct UserObject*)obj7627;
  uo7701->data[21] = emptyclosure;
  Method *meth_meth_ast_7701_isSelfOrOuter = addmethod2pos(obj7627, "isSelfOrOuter", &meth_ast_7701_isSelfOrOuter, 21);
  int argcv_meth_ast_7701_isSelfOrOuter[] = {0};
  meth_meth_ast_7701_isSelfOrOuter->type = alloc_MethodType(1, argcv_meth_ast_7701_isSelfOrOuter);
  meth_meth_ast_7701_isSelfOrOuter->definitionModule = modulename;
  meth_meth_ast_7701_isSelfOrOuter->definitionLine = 2011;
// method "isAppliedOccurenceOfIdentifier"
  struct UserObject *uo7711 = (struct UserObject*)obj7627;
  uo7711->data[22] = emptyclosure;
  Method *meth_meth_ast_7711_isAppliedOccurenceOfIdentifier = addmethod2pos(obj7627, "isAppliedOccurenceOfIdentifier", &meth_ast_7711_isAppliedOccurenceOfIdentifier, 22);
  int argcv_meth_ast_7711_isAppliedOccurenceOfIdentifier[] = {0};
  meth_meth_ast_7711_isAppliedOccurenceOfIdentifier->type = alloc_MethodType(1, argcv_meth_ast_7711_isAppliedOccurenceOfIdentifier);
  meth_meth_ast_7711_isAppliedOccurenceOfIdentifier->definitionModule = modulename;
  meth_meth_ast_7711_isAppliedOccurenceOfIdentifier->definitionLine = 2016;
// method "declarationKindWithAncestors(_)"
  struct UserObject *uo7720 = (struct UserObject*)obj7627;
  uo7720->data[23] = emptyclosure;
  Method *meth_meth_ast_7720_declarationKindWithAncestors_40_1_41_ = addmethod2pos(obj7627, "declarationKindWithAncestors(1)", &meth_ast_7720_declarationKindWithAncestors_40_1_41_, 23);
  int argcv_meth_ast_7720_declarationKindWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_7720_declarationKindWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7720_declarationKindWithAncestors_40_1_41_);
  meth_meth_ast_7720_declarationKindWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7720_declarationKindWithAncestors_40_1_41_->definitionLine = 2023;
// method "inTypePositionWithAncestors(_)"
  struct UserObject *uo7725 = (struct UserObject*)obj7627;
  uo7725->data[24] = emptyclosure;
  Method *meth_meth_ast_7725_inTypePositionWithAncestors_40_1_41_ = addmethod2pos(obj7627, "inTypePositionWithAncestors(1)", &meth_ast_7725_inTypePositionWithAncestors_40_1_41_, 24);
  int argcv_meth_ast_7725_inTypePositionWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_7725_inTypePositionWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7725_inTypePositionWithAncestors_40_1_41_);
  meth_meth_ast_7725_inTypePositionWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7725_inTypePositionWithAncestors_40_1_41_->definitionLine = 2026;
// method "usesAsType(_)"
  struct UserObject *uo7734 = (struct UserObject*)obj7627;
  uo7734->data[25] = emptyclosure;
  Method *meth_meth_ast_7734_usesAsType_40_1_41_ = addmethod2pos(obj7627, "usesAsType(1)", &meth_ast_7734_usesAsType_40_1_41_, 25);
  int argcv_meth_ast_7734_usesAsType_40_1_41_[] = {1};
  meth_meth_ast_7734_usesAsType_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7734_usesAsType_40_1_41_);
  meth_meth_ast_7734_usesAsType_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7734_usesAsType_40_1_41_->definitionLine = 2033;
// method "accept(_)from(_)"
  struct UserObject *uo7740 = (struct UserObject*)obj7627;
  uo7740->data[26] = emptyclosure;
  Method *meth_meth_ast_7740_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj7627, "accept(1)from(1)", &meth_ast_7740_accept_40_1_41_from_40_1_41_, 26);
  int argcv_meth_ast_7740_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_7740_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_7740_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_7740_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7740_accept_40_1_41_from_40_1_41_->definitionLine = 2036;
// method "map(_)ancestors(_)"
  struct UserObject *uo7757 = (struct UserObject*)obj7627;
  uo7757->data[27] = emptyclosure;
  Method *meth_meth_ast_7757_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj7627, "map(1)ancestors(1)", &meth_ast_7757_map_40_1_41_ancestors_40_1_41_, 27);
  int argcv_meth_ast_7757_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_7757_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_7757_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_7757_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7757_map_40_1_41_ancestors_40_1_41_->definitionLine = 2044;
// method "pretty(_)"
  struct UserObject *uo7770 = (struct UserObject*)obj7627;
  uo7770->data[28] = emptyclosure;
  Method *meth_meth_ast_7770_pretty_40_1_41_ = addmethod2pos(obj7627, "pretty(1)", &meth_ast_7770_pretty_40_1_41_, 28);
  int argcv_meth_ast_7770_pretty_40_1_41_[] = {1};
  meth_meth_ast_7770_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7770_pretty_40_1_41_);
  meth_meth_ast_7770_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7770_pretty_40_1_41_->definitionLine = 2050;
// method "toGrace(_)"
  struct UserObject *uo7898 = (struct UserObject*)obj7627;
  uo7898->data[29] = emptyclosure;
  Method *meth_meth_ast_7898_toGrace_40_1_41_ = addmethod2pos(obj7627, "toGrace(1)", &meth_ast_7898_toGrace_40_1_41_, 29);
  int argcv_meth_ast_7898_toGrace_40_1_41_[] = {1};
  meth_meth_ast_7898_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7898_toGrace_40_1_41_);
meth_meth_ast_7898_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_7898_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_7898_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7898_toGrace_40_1_41_->definitionLine = 2072;
// method "asString"
  struct UserObject *uo7995 = (struct UserObject*)obj7627;
  uo7995->data[30] = emptyclosure;
  Method *meth_meth_ast_7995_asString = addmethod2pos(obj7627, "asString", &meth_ast_7995_asString, 30);
  int argcv_meth_ast_7995_asString[] = {0};
  meth_meth_ast_7995_asString->type = alloc_MethodType(1, argcv_meth_ast_7995_asString);
  meth_meth_ast_7995_asString->definitionModule = modulename;
  meth_meth_ast_7995_asString->definitionLine = 2092;
// method "shallowCopy"
  block_savedest(obj7627);
  Object closure8019 = createclosure(1, "shallowCopy");
  setclosureframe(closure8019, stackframe);
  addtoclosure(closure8019, var_identifierNode);
  struct UserObject *uo8019 = (struct UserObject*)obj7627;
  uo8019->data[31] = (Object)closure8019;
  Method *meth_meth_ast_8019_shallowCopy = addmethod2pos(obj7627, "shallowCopy", &meth_ast_8019_shallowCopy, 31);
  int argcv_meth_ast_8019_shallowCopy[] = {0};
  meth_meth_ast_8019_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_8019_shallowCopy);
  meth_meth_ast_8019_shallowCopy->definitionModule = modulename;
  meth_meth_ast_8019_shallowCopy->definitionLine = 2099;
// method "postCopy(_)"
  struct UserObject *uo8028 = (struct UserObject*)obj7627;
  uo8028->data[32] = emptyclosure;
  Method *meth_meth_ast_8028_postCopy_40_1_41_ = addmethod2pos(obj7627, "postCopy(1)", &meth_ast_8028_postCopy_40_1_41_, 32);
  int argcv_meth_ast_8028_postCopy_40_1_41_[] = {1};
  meth_meth_ast_8028_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8028_postCopy_40_1_41_);
  meth_meth_ast_8028_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8028_postCopy_40_1_41_->definitionLine = 2102;
// method "statementName"
  struct UserObject *uo8057 = (struct UserObject*)obj7627;
  uo8057->data[33] = emptyclosure;
  Method *meth_meth_ast_8057_statementName = addmethod2pos(obj7627, "statementName", &meth_ast_8057_statementName, 33);
  int argcv_meth_ast_8057_statementName[] = {0};
  meth_meth_ast_8057_statementName->type = alloc_MethodType(1, argcv_meth_ast_8057_statementName);
  meth_meth_ast_8057_statementName->definitionModule = modulename;
  meth_meth_ast_8057_statementName->definitionLine = 2112;
  sourceObject = obj7627;
// Begin line 1985
  setline(1985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8059 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8060 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8059);
// compiled call node returning call8060 (depth = 3)
  struct UserObject *obj7627_uo = (struct UserObject *)obj7627;
  obj7627_uo->super = call8060;
  sourceObject = obj7627;
// Begin line 1986
  setline(1986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8061 == NULL) {
    strlit8061 = alloc_String("identifier");
    gc_root(strlit8061);
  }
// compiled string node returning strlit8061 (depth = 3)
  adddatum2(obj7627, strlit8061, 1);
  sourceObject = obj7627;
// Begin line 1987
  setline(1987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj7627, *var_name_39_, 2);
  sourceObject = obj7627;
// Begin line 1988
  setline(1988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8062 = alloc_Boolean(0);
// compiled identifier node returning bool8062 (depth = 3)
  adddatum2(obj7627, bool8062, 3);
  sourceObject = obj7627;
// Begin line 1989
  setline(1989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj7627, *var_dtype_39_, 4);
  sourceObject = obj7627;
// Begin line 1990
  setline(1990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8063 = alloc_Boolean(0);
// compiled identifier node returning bool8063 (depth = 3)
  adddatum2(obj7627, bool8063, 5);
  sourceObject = obj7627;
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8064 = alloc_Boolean(0);
// compiled identifier node returning bool8064 (depth = 3)
  adddatum2(obj7627, bool8064, 6);
  sourceObject = obj7627;
// Begin line 1992
  setline(1992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8065 = alloc_Boolean(0);
// compiled identifier node returning bool8065 (depth = 3)
  adddatum2(obj7627, bool8065, 7);
  sourceObject = obj7627;
// Begin line 1993
  setline(1993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8066 = alloc_Boolean(0);
// compiled identifier node returning bool8066 (depth = 3)
  adddatum2(obj7627, bool8066, 8);
  sourceObject = obj7627;
// Begin line 1994
  setline(1994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8067 = alloc_Boolean(0);
// compiled identifier node returning bool8067 (depth = 3)
  adddatum2(obj7627, bool8067, 9);
  sourceObject = obj7627;
// Begin line 1995
  setline(1995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8068 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8069 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8070 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8069);
// compiled member node returning call8070 (depth = 4)
  gc_frame_newslot(call8070);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8072 = alloc_Float64(1);
// compiled num node returning num8072 (depth = 5)
  int op_slot_right_8071 = gc_frame_newslot(num8072);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8075 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8076 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8077 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8076);
// compiled member node returning call8077 (depth = 7)
  partcv[0] = 0;
  Object call8078 = callmethodflags(call8077, "size", 1, partcv, params, 0);
  gc_frame_end(callframe8075);
// compiled member node returning call8078 (depth = 6)
  int op_slot_right_8074 = gc_frame_newslot(call8078);
// starting to compile member node (depth = 6)
  int callframe8080 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8081 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8080);
// compiled member node returning call8081 (depth = 6)
  int op_slot_left_8074 = gc_frame_newslot(call8081);
  params[0] = call8078;
  partcv[0] = 1;
  Object sum8082 = callmethod(call8081, "+(1)", 1, partcv, params);
// compiled op node returning sum8082 (depth = 5)
  int op_slot_left_8071 = gc_frame_newslot(sum8082);
  params[0] = num8072;
  partcv[0] = 1;
  Object diff8083 = callmethod(sum8082, "-(1)", 1, partcv, params);
// compiled op node returning diff8083 (depth = 4)
  gc_frame_newslot(diff8083);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = call8070;
  params[1] = diff8083;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8084 = callmethodflags(module_ast, "line(1)column(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8068);
// compiled call node returning call8084 (depth = 3)
  adddatum2(obj7627, call8084, 10);
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
// Begin line 2003
  setline(2003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8085 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8086 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8085);
// compiled member node returning call8086 (depth = 3)
  adddatum2(obj7627, call8086, 14);
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  sourceObject = obj7627;
  objclass7627 = obj7627->class;
  objclass7627->definitionModule = modulename;
  objclass7627->definitionLine = 1984;
  (*(struct UserObject *)self).data[0] = lowerouter7627;
  self = oldself7627;
  selfslot = oldselfslot7627;
  stackframe = oldstackframe7627;
  gc_frame_end(frame);
  return obj7627;
}
Object meth_ast_8089_identifierNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 43, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "identifierNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1967
  setline(1967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_identifierNode (depth = 3)
  gc_frame_end(frame);
  return *var_identifierNode;
}
Object meth_ast_8094_typeType(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 44, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2116
  setline(2116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeType (depth = 3)
  gc_frame_end(frame);
  return *var_typeType;
}
Object meth_ast_8098_unknownType(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 45, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "unknownType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2117
  setline(2117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_unknownType (depth = 3)
  gc_frame_end(frame);
  return *var_unknownType;
}
Object meth_ast_8101_new_40_1_41_scope_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new(1)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)scope(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new(_)scope(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 2121
  setline(2121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8102 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  gc_frame_newslot(*var_v);
// call case 4: self request
  params[0] = *var_v;
  partcv[0] = 1;
  Object call8103 = callmethodflags(self, "new(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8102);
// compiled call node returning call8103 (depth = 4)
  *var_result = call8103;
  if (call8103 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2122
  setline(2122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8104 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call8105 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8104);
// compiled call node returning call8105 (depth = 3)
// Begin line 2123
  setline(2123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_8112_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2134
  setline(2134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8113 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8114 = callmethodflags(*var_visitor, "visitString(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8113);
// compiled call node returning call8114 (depth = 3)
  gc_frame_end(frame);
  return call8114;
}
Object meth_ast_8115_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2137
  setline(2137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8116 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8117 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8116);
// compiled member node returning call8117 (depth = 4)
  *var_n = call8117;
  if (call8117 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2138
  setline(2138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8118 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8119 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8118);
// compiled call node returning call8119 (depth = 4)
  *var_newChain = call8119;
  if (call8119 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2139
  setline(2139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8120 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call8121 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8120);
// compiled call node returning call8121 (depth = 3)
  gc_frame_end(frame);
  return call8121;
}
Object meth_ast_8122_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2142
  setline(2142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8124 == NULL) {
    strlit8124 = alloc_String(")");
    gc_root(strlit8124);
  }
// compiled string node returning strlit8124 (depth = 4)
  int op_slot_right_8123 = gc_frame_newslot(strlit8124);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8127 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8128 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8127);
// compiled member node returning call8128 (depth = 5)
  int op_slot_right_8126 = gc_frame_newslot(call8128);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8131 == NULL) {
    strlit8131 = alloc_String("(");
    gc_root(strlit8131);
  }
// compiled string node returning strlit8131 (depth = 6)
  int op_slot_right_8130 = gc_frame_newslot(strlit8131);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8134 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8135 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8134);
// compiled call node returning call8135 (depth = 7)
  int op_slot_right_8133 = gc_frame_newslot(call8135);
// starting to compile string node (depth = 7)
  if (strlit8137 == NULL) {
    strlit8137 = alloc_String("");
    gc_root(strlit8137);
  }
// compiled string node returning strlit8137 (depth = 7)
  int op_slot_left_8133 = gc_frame_newslot(strlit8137);
  params[0] = call8135;
  partcv[0] = 1;
  Object opresult8138 = callmethod(strlit8137, "++(1)", 1, partcv, params);
// compiled op node returning opresult8138 (depth = 6)
  int op_slot_left_8130 = gc_frame_newslot(opresult8138);
  params[0] = strlit8131;
  partcv[0] = 1;
  Object opresult8139 = callmethod(opresult8138, "++(1)", 1, partcv, params);
// compiled op node returning opresult8139 (depth = 5)
  int op_slot_left_8126 = gc_frame_newslot(opresult8139);
  params[0] = call8128;
  partcv[0] = 1;
  Object opresult8140 = callmethod(opresult8139, "++(1)", 1, partcv, params);
// compiled op node returning opresult8140 (depth = 4)
  int op_slot_left_8123 = gc_frame_newslot(opresult8140);
  params[0] = strlit8124;
  partcv[0] = 1;
  Object opresult8141 = callmethod(opresult8140, "++(1)", 1, partcv, params);
// compiled op node returning opresult8141 (depth = 3)
  gc_frame_end(frame);
  return opresult8141;
}
Object meth_ast_8142_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_q = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "q");
// Begin line 2145
  setline(2145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8143 == NULL) {
    strlit8143 = alloc_String("""\x22""");
    gc_root(strlit8143);
  }
// compiled string node returning strlit8143 (depth = 4)
  *var_q = strlit8143;
  if (strlit8143 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2146
  setline(2146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_q (depth = 4)
  int op_slot_right_8144 = gc_frame_newslot(*var_q);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8147 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8148 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8149 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8148);
// compiled member node returning call8149 (depth = 6)
  partcv[0] = 0;
  Object call8150 = callmethodflags(call8149, "quoted", 1, partcv, params, 0);
  gc_frame_end(callframe8147);
// compiled member node returning call8150 (depth = 5)
  int op_slot_right_8146 = gc_frame_newslot(call8150);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_q (depth = 5)
  int op_slot_left_8146 = gc_frame_newslot(*var_q);
  params[0] = call8150;
  partcv[0] = 1;
  Object opresult8152 = callmethod(*var_q, "++(1)", 1, partcv, params);
// compiled op node returning opresult8152 (depth = 4)
  int op_slot_left_8144 = gc_frame_newslot(opresult8152);
  params[0] = *var_q;
  partcv[0] = 1;
  Object opresult8153 = callmethod(opresult8152, "++(1)", 1, partcv, params);
// compiled op node returning opresult8153 (depth = 3)
  gc_frame_end(frame);
  return opresult8153;
}
Object meth_ast_8154_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2148
  setline(2148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8156 == NULL) {
    strlit8156 = alloc_String("");
    gc_root(strlit8156);
  }
// compiled string node returning strlit8156 (depth = 4)
  int op_slot_right_8155 = gc_frame_newslot(strlit8156);
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8159 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num8160 = alloc_Float64(0);
// compiled num node returning num8160 (depth = 6)
  gc_frame_newslot(num8160);
// call case 4: self request
  params[0] = num8160;
  partcv[0] = 1;
  Object call8161 = callmethodflags(self, "toGrace(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8159);
// compiled call node returning call8161 (depth = 5)
  int op_slot_right_8158 = gc_frame_newslot(call8161);
// starting to compile string node (depth = 5)
  if (strlit8163 == NULL) {
    strlit8163 = alloc_String("string ");
    gc_root(strlit8163);
  }
// compiled string node returning strlit8163 (depth = 5)
  int op_slot_left_8158 = gc_frame_newslot(strlit8163);
  params[0] = call8161;
  partcv[0] = 1;
  Object opresult8164 = callmethod(strlit8163, "++(1)", 1, partcv, params);
// compiled op node returning opresult8164 (depth = 4)
  int op_slot_left_8155 = gc_frame_newslot(opresult8164);
  params[0] = strlit8156;
  partcv[0] = 1;
  Object opresult8165 = callmethod(opresult8164, "++(1)", 1, partcv, params);
// compiled op node returning opresult8165 (depth = 3)
  gc_frame_end(frame);
  return opresult8165;
}
Object meth_ast_8166_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2150
  setline(2150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8167 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe8168 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8169 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8170 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8169);
// compiled member node returning call8170 (depth = 5)
  gc_frame_newslot(call8170);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_stringNode (depth = 5)
  params[0] = call8170;
  partcv[0] = 1;
  Object call8171 = callmethodflags(*var_stringNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8168);
// compiled call node returning call8171 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call8172 = callmethodflags(call8171, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8167);
// compiled call node returning call8172 (depth = 3)
  gc_frame_end(frame);
  return call8172;
}
Object meth_ast_8173_postCopy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "postCopy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method postCopy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for postCopy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part postCopy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2153
  setline(2153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8174 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8175 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call8176 = callmethodflags(*var_other, "end", 1, partcv, params, 0);
  gc_frame_end(callframe8175);
// compiled member node returning call8176 (depth = 4)
  gc_frame_newslot(call8176);
// call case 4: self request
  params[0] = call8176;
  partcv[0] = 1;
  Object call8177 = callmethodflags(self, "end:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8174);
// compiled call node returning call8177 (depth = 3)
// Begin line 2154
  setline(2154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_8178_statementName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2156
  setline(2156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8179 == NULL) {
    strlit8179 = alloc_String("expression");
    gc_root(strlit8179);
  }
// compiled string node returning strlit8179 (depth = 3)
  gc_frame_end(frame);
  return strlit8179;
}
Object meth_ast_8180_isDelimited(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isDelimited");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2157
  setline(2157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8181 = alloc_Boolean(1);
// compiled identifier node returning bool8181 (depth = 3)
  gc_frame_end(frame);
  return bool8181;
}
Object meth_ast_8182_isConstant(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isConstant");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2158
  setline(2158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8183 = alloc_Boolean(1);
// compiled identifier node returning bool8183 (depth = 3)
  gc_frame_end(frame);
  return bool8183;
}
Object meth_ast_8106_new_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)");
  Object params[2];
  int partcv[2];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8107 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8107 = alloc_userobj2(15,14, objclass8107);
  gc_frame_newslot(obj8107);
  if (objclass8107 == NULL) {
    glfree(obj8107->class->name);
    obj8107->class->name = "stringNode.new(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj8107, self, 0);
  addmethodreal(obj8107,"outer", &reader_ast_outer_8108);
  Object oldself8107 = self;
  struct StackFrameObject *oldstackframe8107 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8107);
  gc_frame_newslot((Object)stackframe);
  self = obj8107;
  Object *oldselfslot8107 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8107 = (*(struct UserObject *)self).data[0], lowerouter8107 = thisouter8107;
  if (inheritingObject8107) {
    struct UserObject *inho8107 = (struct UserObject *)inheritingObject8107;
    while (inho8107->super != GraceDefaultObject) inho8107 = (struct UserObject *)inho8107->super;
    inho8107->super = obj8107;
    self = inheritingObject8107;
    *selfslot = self;
    lowerouter8107 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8107;
  }
  if (objclass8107 == NULL) {
  Method *reader8109 = addmethodrealflags(obj8107, "kind",&reader_ast_kind_8109, MFLAG_DEF);
  reader8109->definitionModule = modulename;
  reader8109->definitionLine = 2128;
  }
  adddatum2(obj8107, alloc_Undefined(), 1);
  if (objclass8107 == NULL) {
    Method *reader8110 = addmethodrealflags(obj8107, "value", &reader_ast_value_8110, 0);
    Method *writer8110 = addmethodrealflags(obj8107, "value:=(1)", &writer_ast_value_8110, 0);
    reader8110->definitionModule = modulename;
    writer8110->definitionModule = modulename;
    reader8110->definitionLine = 2129;
    writer8110->definitionLine = 2129;
  }
  obj8107->flags |= OFLAG_MUTABLE;
  adddatum2(obj8107, alloc_Undefined(), 2);
  if (objclass8107 == NULL) {
    Method *reader8111 = addmethodrealflags(obj8107, "end", &reader_ast_end_8111, 0);
    Method *writer8111 = addmethodrealflags(obj8107, "end:=(1)", &writer_ast_end_8111, 0);
    reader8111->definitionModule = modulename;
    writer8111->definitionModule = modulename;
    reader8111->definitionLine = 2130;
    writer8111->definitionLine = 2130;
  }
  obj8107->flags |= OFLAG_MUTABLE;
  adddatum2(obj8107, alloc_Undefined(), 3);
// method "accept(_)from(_)"
  struct UserObject *uo8112 = (struct UserObject*)obj8107;
  uo8112->data[4] = emptyclosure;
  Method *meth_meth_ast_8112_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj8107, "accept(1)from(1)", &meth_ast_8112_accept_40_1_41_from_40_1_41_, 4);
  int argcv_meth_ast_8112_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_8112_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_8112_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_8112_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8112_accept_40_1_41_from_40_1_41_->definitionLine = 2133;
// method "map(_)ancestors(_)"
  struct UserObject *uo8115 = (struct UserObject*)obj8107;
  uo8115->data[5] = emptyclosure;
  Method *meth_meth_ast_8115_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj8107, "map(1)ancestors(1)", &meth_ast_8115_map_40_1_41_ancestors_40_1_41_, 5);
  int argcv_meth_ast_8115_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_8115_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_8115_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_8115_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8115_map_40_1_41_ancestors_40_1_41_->definitionLine = 2136;
// method "pretty(_)"
  struct UserObject *uo8122 = (struct UserObject*)obj8107;
  uo8122->data[6] = emptyclosure;
  Method *meth_meth_ast_8122_pretty_40_1_41_ = addmethod2pos(obj8107, "pretty(1)", &meth_ast_8122_pretty_40_1_41_, 6);
  int argcv_meth_ast_8122_pretty_40_1_41_[] = {1};
  meth_meth_ast_8122_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8122_pretty_40_1_41_);
  meth_meth_ast_8122_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8122_pretty_40_1_41_->definitionLine = 2141;
// method "toGrace(_)"
  struct UserObject *uo8142 = (struct UserObject*)obj8107;
  uo8142->data[7] = emptyclosure;
  Method *meth_meth_ast_8142_toGrace_40_1_41_ = addmethod2pos(obj8107, "toGrace(1)", &meth_ast_8142_toGrace_40_1_41_, 7);
  int argcv_meth_ast_8142_toGrace_40_1_41_[] = {1};
  meth_meth_ast_8142_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8142_toGrace_40_1_41_);
meth_meth_ast_8142_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_8142_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_8142_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8142_toGrace_40_1_41_->definitionLine = 2144;
// method "asString"
  struct UserObject *uo8154 = (struct UserObject*)obj8107;
  uo8154->data[8] = emptyclosure;
  Method *meth_meth_ast_8154_asString = addmethod2pos(obj8107, "asString", &meth_ast_8154_asString, 8);
  int argcv_meth_ast_8154_asString[] = {0};
  meth_meth_ast_8154_asString->type = alloc_MethodType(1, argcv_meth_ast_8154_asString);
  meth_meth_ast_8154_asString->definitionModule = modulename;
  meth_meth_ast_8154_asString->definitionLine = 2148;
// method "shallowCopy"
  block_savedest(obj8107);
  Object closure8166 = createclosure(1, "shallowCopy");
  setclosureframe(closure8166, stackframe);
  addtoclosure(closure8166, var_stringNode);
  struct UserObject *uo8166 = (struct UserObject*)obj8107;
  uo8166->data[9] = (Object)closure8166;
  Method *meth_meth_ast_8166_shallowCopy = addmethod2pos(obj8107, "shallowCopy", &meth_ast_8166_shallowCopy, 9);
  int argcv_meth_ast_8166_shallowCopy[] = {0};
  meth_meth_ast_8166_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_8166_shallowCopy);
  meth_meth_ast_8166_shallowCopy->definitionModule = modulename;
  meth_meth_ast_8166_shallowCopy->definitionLine = 2149;
// method "postCopy(_)"
  struct UserObject *uo8173 = (struct UserObject*)obj8107;
  uo8173->data[10] = emptyclosure;
  Method *meth_meth_ast_8173_postCopy_40_1_41_ = addmethod2pos(obj8107, "postCopy(1)", &meth_ast_8173_postCopy_40_1_41_, 10);
  int argcv_meth_ast_8173_postCopy_40_1_41_[] = {1};
  meth_meth_ast_8173_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8173_postCopy_40_1_41_);
  meth_meth_ast_8173_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8173_postCopy_40_1_41_->definitionLine = 2152;
// method "statementName"
  struct UserObject *uo8178 = (struct UserObject*)obj8107;
  uo8178->data[11] = emptyclosure;
  Method *meth_meth_ast_8178_statementName = addmethod2pos(obj8107, "statementName", &meth_ast_8178_statementName, 11);
  int argcv_meth_ast_8178_statementName[] = {0};
  meth_meth_ast_8178_statementName->type = alloc_MethodType(1, argcv_meth_ast_8178_statementName);
  meth_meth_ast_8178_statementName->definitionModule = modulename;
  meth_meth_ast_8178_statementName->definitionLine = 2156;
// method "isDelimited"
  struct UserObject *uo8180 = (struct UserObject*)obj8107;
  uo8180->data[12] = emptyclosure;
  Method *meth_meth_ast_8180_isDelimited = addmethod2pos(obj8107, "isDelimited", &meth_ast_8180_isDelimited, 12);
  int argcv_meth_ast_8180_isDelimited[] = {0};
  meth_meth_ast_8180_isDelimited->type = alloc_MethodType(1, argcv_meth_ast_8180_isDelimited);
  meth_meth_ast_8180_isDelimited->definitionModule = modulename;
  meth_meth_ast_8180_isDelimited->definitionLine = 2157;
// method "isConstant"
  struct UserObject *uo8182 = (struct UserObject*)obj8107;
  uo8182->data[13] = emptyclosure;
  Method *meth_meth_ast_8182_isConstant = addmethod2pos(obj8107, "isConstant", &meth_ast_8182_isConstant, 13);
  int argcv_meth_ast_8182_isConstant[] = {0};
  meth_meth_ast_8182_isConstant->type = alloc_MethodType(1, argcv_meth_ast_8182_isConstant);
  meth_meth_ast_8182_isConstant->definitionModule = modulename;
  meth_meth_ast_8182_isConstant->definitionLine = 2158;
  sourceObject = obj8107;
// Begin line 2127
  setline(2127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8184 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8185 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8184);
// compiled call node returning call8185 (depth = 3)
  struct UserObject *obj8107_uo = (struct UserObject *)obj8107;
  obj8107_uo->super = call8185;
  sourceObject = obj8107;
// Begin line 2128
  setline(2128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8186 == NULL) {
    strlit8186 = alloc_String("string");
    gc_root(strlit8186);
  }
// compiled string node returning strlit8186 (depth = 3)
  adddatum2(obj8107, strlit8186, 1);
  sourceObject = obj8107;
// Begin line 2129
  setline(2129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  adddatum2(obj8107, *var_v, 2);
  sourceObject = obj8107;
// Begin line 2130
  setline(2130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8187 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8188 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8189 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8188);
// compiled member node returning call8189 (depth = 4)
  gc_frame_newslot(call8189);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8191 = alloc_Float64(1);
// compiled num node returning num8191 (depth = 5)
  int op_slot_right_8190 = gc_frame_newslot(num8191);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8194 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  partcv[0] = 0;
  Object call8195 = callmethodflags(*var_v, "size", 1, partcv, params, 0);
  gc_frame_end(callframe8194);
// compiled member node returning call8195 (depth = 6)
  int op_slot_right_8193 = gc_frame_newslot(call8195);
// starting to compile member node (depth = 6)
  int callframe8197 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8198 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8197);
// compiled member node returning call8198 (depth = 6)
  int op_slot_left_8193 = gc_frame_newslot(call8198);
  params[0] = call8195;
  partcv[0] = 1;
  Object sum8199 = callmethod(call8198, "+(1)", 1, partcv, params);
// compiled op node returning sum8199 (depth = 5)
  int op_slot_left_8190 = gc_frame_newslot(sum8199);
  params[0] = num8191;
  partcv[0] = 1;
  Object sum8200 = callmethod(sum8199, "+(1)", 1, partcv, params);
// compiled op node returning sum8200 (depth = 4)
  gc_frame_newslot(sum8200);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = call8189;
  params[1] = sum8200;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8201 = callmethodflags(module_ast, "line(1)column(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8187);
// compiled call node returning call8201 (depth = 3)
  adddatum2(obj8107, call8201, 3);
  sourceObject = obj8107;
  sourceObject = obj8107;
  sourceObject = obj8107;
  sourceObject = obj8107;
  sourceObject = obj8107;
  sourceObject = obj8107;
  sourceObject = obj8107;
  sourceObject = obj8107;
  sourceObject = obj8107;
  sourceObject = obj8107;
  objclass8107 = obj8107->class;
  objclass8107->definitionModule = modulename;
  objclass8107->definitionLine = 2126;
  (*(struct UserObject *)self).data[0] = lowerouter8107;
  self = oldself8107;
  selfslot = oldselfslot8107;
  stackframe = oldstackframe8107;
  gc_frame_end(frame);
  return obj8107;
}
Object meth_ast_8106_new_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method new(_)");
  Object params[2];
  int partcv[2];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8107 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8107 = alloc_userobj2(15,14, objclass8107);
  gc_frame_newslot(obj8107);
  if (objclass8107 == NULL) {
    glfree(obj8107->class->name);
    obj8107->class->name = "stringNode.new(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj8107, self, 0);
  addmethodreal(obj8107,"outer", &reader_ast_outer_8108);
  Object oldself8107 = self;
  struct StackFrameObject *oldstackframe8107 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8107);
  gc_frame_newslot((Object)stackframe);
  self = obj8107;
  Object *oldselfslot8107 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8107 = (*(struct UserObject *)self).data[0], lowerouter8107 = thisouter8107;
  if (inheritingObject8107) {
    struct UserObject *inho8107 = (struct UserObject *)inheritingObject8107;
    while (inho8107->super != GraceDefaultObject) inho8107 = (struct UserObject *)inho8107->super;
    inho8107->super = obj8107;
    self = inheritingObject8107;
    *selfslot = self;
    lowerouter8107 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8107;
  }
  if (objclass8107 == NULL) {
  Method *reader8109 = addmethodrealflags(obj8107, "kind",&reader_ast_kind_8109, MFLAG_DEF);
  reader8109->definitionModule = modulename;
  reader8109->definitionLine = 2128;
  }
  adddatum2(obj8107, alloc_Undefined(), 1);
  if (objclass8107 == NULL) {
    Method *reader8110 = addmethodrealflags(obj8107, "value", &reader_ast_value_8110, 0);
    Method *writer8110 = addmethodrealflags(obj8107, "value:=(1)", &writer_ast_value_8110, 0);
    reader8110->definitionModule = modulename;
    writer8110->definitionModule = modulename;
    reader8110->definitionLine = 2129;
    writer8110->definitionLine = 2129;
  }
  obj8107->flags |= OFLAG_MUTABLE;
  adddatum2(obj8107, alloc_Undefined(), 2);
  if (objclass8107 == NULL) {
    Method *reader8111 = addmethodrealflags(obj8107, "end", &reader_ast_end_8111, 0);
    Method *writer8111 = addmethodrealflags(obj8107, "end:=(1)", &writer_ast_end_8111, 0);
    reader8111->definitionModule = modulename;
    writer8111->definitionModule = modulename;
    reader8111->definitionLine = 2130;
    writer8111->definitionLine = 2130;
  }
  obj8107->flags |= OFLAG_MUTABLE;
  adddatum2(obj8107, alloc_Undefined(), 3);
// method "accept(_)from(_)"
  struct UserObject *uo8112 = (struct UserObject*)obj8107;
  uo8112->data[4] = emptyclosure;
  Method *meth_meth_ast_8112_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj8107, "accept(1)from(1)", &meth_ast_8112_accept_40_1_41_from_40_1_41_, 4);
  int argcv_meth_ast_8112_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_8112_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_8112_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_8112_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8112_accept_40_1_41_from_40_1_41_->definitionLine = 2133;
// method "map(_)ancestors(_)"
  struct UserObject *uo8115 = (struct UserObject*)obj8107;
  uo8115->data[5] = emptyclosure;
  Method *meth_meth_ast_8115_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj8107, "map(1)ancestors(1)", &meth_ast_8115_map_40_1_41_ancestors_40_1_41_, 5);
  int argcv_meth_ast_8115_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_8115_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_8115_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_8115_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8115_map_40_1_41_ancestors_40_1_41_->definitionLine = 2136;
// method "pretty(_)"
  struct UserObject *uo8122 = (struct UserObject*)obj8107;
  uo8122->data[6] = emptyclosure;
  Method *meth_meth_ast_8122_pretty_40_1_41_ = addmethod2pos(obj8107, "pretty(1)", &meth_ast_8122_pretty_40_1_41_, 6);
  int argcv_meth_ast_8122_pretty_40_1_41_[] = {1};
  meth_meth_ast_8122_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8122_pretty_40_1_41_);
  meth_meth_ast_8122_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8122_pretty_40_1_41_->definitionLine = 2141;
// method "toGrace(_)"
  struct UserObject *uo8142 = (struct UserObject*)obj8107;
  uo8142->data[7] = emptyclosure;
  Method *meth_meth_ast_8142_toGrace_40_1_41_ = addmethod2pos(obj8107, "toGrace(1)", &meth_ast_8142_toGrace_40_1_41_, 7);
  int argcv_meth_ast_8142_toGrace_40_1_41_[] = {1};
  meth_meth_ast_8142_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8142_toGrace_40_1_41_);
meth_meth_ast_8142_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_8142_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_8142_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8142_toGrace_40_1_41_->definitionLine = 2144;
// method "asString"
  struct UserObject *uo8154 = (struct UserObject*)obj8107;
  uo8154->data[8] = emptyclosure;
  Method *meth_meth_ast_8154_asString = addmethod2pos(obj8107, "asString", &meth_ast_8154_asString, 8);
  int argcv_meth_ast_8154_asString[] = {0};
  meth_meth_ast_8154_asString->type = alloc_MethodType(1, argcv_meth_ast_8154_asString);
  meth_meth_ast_8154_asString->definitionModule = modulename;
  meth_meth_ast_8154_asString->definitionLine = 2148;
// method "shallowCopy"
  block_savedest(obj8107);
  Object closure8166 = createclosure(1, "shallowCopy");
  setclosureframe(closure8166, stackframe);
  addtoclosure(closure8166, var_stringNode);
  struct UserObject *uo8166 = (struct UserObject*)obj8107;
  uo8166->data[9] = (Object)closure8166;
  Method *meth_meth_ast_8166_shallowCopy = addmethod2pos(obj8107, "shallowCopy", &meth_ast_8166_shallowCopy, 9);
  int argcv_meth_ast_8166_shallowCopy[] = {0};
  meth_meth_ast_8166_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_8166_shallowCopy);
  meth_meth_ast_8166_shallowCopy->definitionModule = modulename;
  meth_meth_ast_8166_shallowCopy->definitionLine = 2149;
// method "postCopy(_)"
  struct UserObject *uo8173 = (struct UserObject*)obj8107;
  uo8173->data[10] = emptyclosure;
  Method *meth_meth_ast_8173_postCopy_40_1_41_ = addmethod2pos(obj8107, "postCopy(1)", &meth_ast_8173_postCopy_40_1_41_, 10);
  int argcv_meth_ast_8173_postCopy_40_1_41_[] = {1};
  meth_meth_ast_8173_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8173_postCopy_40_1_41_);
  meth_meth_ast_8173_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8173_postCopy_40_1_41_->definitionLine = 2152;
// method "statementName"
  struct UserObject *uo8178 = (struct UserObject*)obj8107;
  uo8178->data[11] = emptyclosure;
  Method *meth_meth_ast_8178_statementName = addmethod2pos(obj8107, "statementName", &meth_ast_8178_statementName, 11);
  int argcv_meth_ast_8178_statementName[] = {0};
  meth_meth_ast_8178_statementName->type = alloc_MethodType(1, argcv_meth_ast_8178_statementName);
  meth_meth_ast_8178_statementName->definitionModule = modulename;
  meth_meth_ast_8178_statementName->definitionLine = 2156;
// method "isDelimited"
  struct UserObject *uo8180 = (struct UserObject*)obj8107;
  uo8180->data[12] = emptyclosure;
  Method *meth_meth_ast_8180_isDelimited = addmethod2pos(obj8107, "isDelimited", &meth_ast_8180_isDelimited, 12);
  int argcv_meth_ast_8180_isDelimited[] = {0};
  meth_meth_ast_8180_isDelimited->type = alloc_MethodType(1, argcv_meth_ast_8180_isDelimited);
  meth_meth_ast_8180_isDelimited->definitionModule = modulename;
  meth_meth_ast_8180_isDelimited->definitionLine = 2157;
// method "isConstant"
  struct UserObject *uo8182 = (struct UserObject*)obj8107;
  uo8182->data[13] = emptyclosure;
  Method *meth_meth_ast_8182_isConstant = addmethod2pos(obj8107, "isConstant", &meth_ast_8182_isConstant, 13);
  int argcv_meth_ast_8182_isConstant[] = {0};
  meth_meth_ast_8182_isConstant->type = alloc_MethodType(1, argcv_meth_ast_8182_isConstant);
  meth_meth_ast_8182_isConstant->definitionModule = modulename;
  meth_meth_ast_8182_isConstant->definitionLine = 2158;
  sourceObject = obj8107;
// Begin line 2127
  setline(2127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8184 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8185 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8184);
// compiled call node returning call8185 (depth = 3)
  struct UserObject *obj8107_uo = (struct UserObject *)obj8107;
  obj8107_uo->super = call8185;
  sourceObject = obj8107;
// Begin line 2128
  setline(2128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8186 == NULL) {
    strlit8186 = alloc_String("string");
    gc_root(strlit8186);
  }
// compiled string node returning strlit8186 (depth = 3)
  adddatum2(obj8107, strlit8186, 1);
  sourceObject = obj8107;
// Begin line 2129
  setline(2129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  adddatum2(obj8107, *var_v, 2);
  sourceObject = obj8107;
// Begin line 2130
  setline(2130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8187 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8188 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8189 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8188);
// compiled member node returning call8189 (depth = 4)
  gc_frame_newslot(call8189);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8191 = alloc_Float64(1);
// compiled num node returning num8191 (depth = 5)
  int op_slot_right_8190 = gc_frame_newslot(num8191);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8194 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  partcv[0] = 0;
  Object call8195 = callmethodflags(*var_v, "size", 1, partcv, params, 0);
  gc_frame_end(callframe8194);
// compiled member node returning call8195 (depth = 6)
  int op_slot_right_8193 = gc_frame_newslot(call8195);
// starting to compile member node (depth = 6)
  int callframe8197 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8198 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8197);
// compiled member node returning call8198 (depth = 6)
  int op_slot_left_8193 = gc_frame_newslot(call8198);
  params[0] = call8195;
  partcv[0] = 1;
  Object sum8199 = callmethod(call8198, "+(1)", 1, partcv, params);
// compiled op node returning sum8199 (depth = 5)
  int op_slot_left_8190 = gc_frame_newslot(sum8199);
  params[0] = num8191;
  partcv[0] = 1;
  Object sum8200 = callmethod(sum8199, "+(1)", 1, partcv, params);
// compiled op node returning sum8200 (depth = 4)
  gc_frame_newslot(sum8200);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = call8189;
  params[1] = sum8200;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8201 = callmethodflags(module_ast, "line(1)column(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8187);
// compiled call node returning call8201 (depth = 3)
  adddatum2(obj8107, call8201, 3);
  sourceObject = obj8107;
  sourceObject = obj8107;
  sourceObject = obj8107;
  sourceObject = obj8107;
  sourceObject = obj8107;
  sourceObject = obj8107;
  sourceObject = obj8107;
  sourceObject = obj8107;
  sourceObject = obj8107;
  sourceObject = obj8107;
  objclass8107 = obj8107->class;
  objclass8107->definitionModule = modulename;
  objclass8107->definitionLine = 2126;
  (*(struct UserObject *)self).data[0] = lowerouter8107;
  self = oldself8107;
  selfslot = oldselfslot8107;
  stackframe = oldstackframe8107;
  gc_frame_end(frame);
  return obj8107;
}
Object meth_ast_8203_stringNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 46, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "stringNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2119
  setline(2119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_stringNode (depth = 3)
  gc_frame_end(frame);
  return *var_stringNode;
}
Object meth_ast_8211_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2167
  setline(2167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8212 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8213 = callmethodflags(*var_visitor, "visitNum(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8212);
// compiled call node returning call8213 (depth = 3)
  gc_frame_end(frame);
  return call8213;
}
Object meth_ast_8214_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2170
  setline(2170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8215 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8216 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8215);
// compiled member node returning call8216 (depth = 4)
  *var_n = call8216;
  if (call8216 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2171
  setline(2171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8217 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8218 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8217);
// compiled call node returning call8218 (depth = 4)
  *var_newChain = call8218;
  if (call8218 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2172
  setline(2172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8219 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call8220 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8219);
// compiled call node returning call8220 (depth = 3)
  gc_frame_end(frame);
  return call8220;
}
Object meth_ast_8221_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2175
  setline(2175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8223 == NULL) {
    strlit8223 = alloc_String(")");
    gc_root(strlit8223);
  }
// compiled string node returning strlit8223 (depth = 4)
  int op_slot_right_8222 = gc_frame_newslot(strlit8223);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8226 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8227 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8226);
// compiled member node returning call8227 (depth = 5)
  int op_slot_right_8225 = gc_frame_newslot(call8227);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8230 == NULL) {
    strlit8230 = alloc_String("(");
    gc_root(strlit8230);
  }
// compiled string node returning strlit8230 (depth = 6)
  int op_slot_right_8229 = gc_frame_newslot(strlit8230);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8233 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8234 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8233);
// compiled call node returning call8234 (depth = 7)
  int op_slot_right_8232 = gc_frame_newslot(call8234);
// starting to compile string node (depth = 7)
  if (strlit8236 == NULL) {
    strlit8236 = alloc_String("");
    gc_root(strlit8236);
  }
// compiled string node returning strlit8236 (depth = 7)
  int op_slot_left_8232 = gc_frame_newslot(strlit8236);
  params[0] = call8234;
  partcv[0] = 1;
  Object opresult8237 = callmethod(strlit8236, "++(1)", 1, partcv, params);
// compiled op node returning opresult8237 (depth = 6)
  int op_slot_left_8229 = gc_frame_newslot(opresult8237);
  params[0] = strlit8230;
  partcv[0] = 1;
  Object opresult8238 = callmethod(opresult8237, "++(1)", 1, partcv, params);
// compiled op node returning opresult8238 (depth = 5)
  int op_slot_left_8225 = gc_frame_newslot(opresult8238);
  params[0] = call8227;
  partcv[0] = 1;
  Object opresult8239 = callmethod(opresult8238, "++(1)", 1, partcv, params);
// compiled op node returning opresult8239 (depth = 4)
  int op_slot_left_8222 = gc_frame_newslot(opresult8239);
  params[0] = strlit8223;
  partcv[0] = 1;
  Object opresult8240 = callmethod(opresult8239, "++(1)", 1, partcv, params);
// compiled op node returning opresult8240 (depth = 3)
  gc_frame_end(frame);
  return opresult8240;
}
Object meth_ast_8241_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2178
  setline(2178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8242 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8243 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8244 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8243);
// compiled member node returning call8244 (depth = 4)
  partcv[0] = 0;
  Object call8245 = callmethodflags(call8244, "asString", 1, partcv, params, 0);
  gc_frame_end(callframe8242);
// compiled member node returning call8245 (depth = 3)
  gc_frame_end(frame);
  return call8245;
}
Object meth_ast_8246_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2180
  setline(2180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8248 == NULL) {
    strlit8248 = alloc_String("");
    gc_root(strlit8248);
  }
// compiled string node returning strlit8248 (depth = 4)
  int op_slot_right_8247 = gc_frame_newslot(strlit8248);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8251 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8252 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8251);
// compiled member node returning call8252 (depth = 5)
  int op_slot_right_8250 = gc_frame_newslot(call8252);
// starting to compile string node (depth = 5)
  if (strlit8254 == NULL) {
    strlit8254 = alloc_String("num ");
    gc_root(strlit8254);
  }
// compiled string node returning strlit8254 (depth = 5)
  int op_slot_left_8250 = gc_frame_newslot(strlit8254);
  params[0] = call8252;
  partcv[0] = 1;
  Object opresult8255 = callmethod(strlit8254, "++(1)", 1, partcv, params);
// compiled op node returning opresult8255 (depth = 4)
  int op_slot_left_8247 = gc_frame_newslot(opresult8255);
  params[0] = strlit8248;
  partcv[0] = 1;
  Object opresult8256 = callmethod(opresult8255, "++(1)", 1, partcv, params);
// compiled op node returning opresult8256 (depth = 3)
  gc_frame_end(frame);
  return opresult8256;
}
Object meth_ast_8257_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2182
  setline(2182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8258 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe8259 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8260 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8261 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8260);
// compiled member node returning call8261 (depth = 5)
  gc_frame_newslot(call8261);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_numNode (depth = 5)
  params[0] = call8261;
  partcv[0] = 1;
  Object call8262 = callmethodflags(*var_numNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8259);
// compiled call node returning call8262 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call8263 = callmethodflags(call8262, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8258);
// compiled call node returning call8263 (depth = 3)
  gc_frame_end(frame);
  return call8263;
}
Object meth_ast_8264_statementName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2184
  setline(2184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8265 == NULL) {
    strlit8265 = alloc_String("expression");
    gc_root(strlit8265);
  }
// compiled string node returning strlit8265 (depth = 3)
  gc_frame_end(frame);
  return strlit8265;
}
Object meth_ast_8266_isDelimited(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isDelimited");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2185
  setline(2185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8267 = alloc_Boolean(1);
// compiled identifier node returning bool8267 (depth = 3)
  gc_frame_end(frame);
  return bool8267;
}
Object meth_ast_8268_isConstant(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isConstant");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2186
  setline(2186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8269 = alloc_Boolean(1);
// compiled identifier node returning bool8269 (depth = 3)
  gc_frame_end(frame);
  return bool8269;
}
Object meth_ast_8206_new_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val = &(stackframe->slots[0]);
  *var_val = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8207 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8207 = alloc_userobj2(12,12, objclass8207);
  gc_frame_newslot(obj8207);
  if (objclass8207 == NULL) {
    glfree(obj8207->class->name);
    obj8207->class->name = "numNode.new(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj8207, self, 0);
  addmethodreal(obj8207,"outer", &reader_ast_outer_8208);
  Object oldself8207 = self;
  struct StackFrameObject *oldstackframe8207 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8207);
  gc_frame_newslot((Object)stackframe);
  self = obj8207;
  Object *oldselfslot8207 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8207 = (*(struct UserObject *)self).data[0], lowerouter8207 = thisouter8207;
  if (inheritingObject8207) {
    struct UserObject *inho8207 = (struct UserObject *)inheritingObject8207;
    while (inho8207->super != GraceDefaultObject) inho8207 = (struct UserObject *)inho8207->super;
    inho8207->super = obj8207;
    self = inheritingObject8207;
    *selfslot = self;
    lowerouter8207 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8207;
  }
  if (objclass8207 == NULL) {
  Method *reader8209 = addmethodrealflags(obj8207, "kind",&reader_ast_kind_8209, MFLAG_DEF);
  reader8209->definitionModule = modulename;
  reader8209->definitionLine = 2164;
  }
  adddatum2(obj8207, alloc_Undefined(), 1);
  if (objclass8207 == NULL) {
    Method *reader8210 = addmethodrealflags(obj8207, "value", &reader_ast_value_8210, 0);
    Method *writer8210 = addmethodrealflags(obj8207, "value:=(1)", &writer_ast_value_8210, 0);
    reader8210->definitionModule = modulename;
    writer8210->definitionModule = modulename;
    reader8210->definitionLine = 2165;
    writer8210->definitionLine = 2165;
  }
  obj8207->flags |= OFLAG_MUTABLE;
  adddatum2(obj8207, alloc_Undefined(), 2);
// method "accept(_)from(_)"
  struct UserObject *uo8211 = (struct UserObject*)obj8207;
  uo8211->data[3] = emptyclosure;
  Method *meth_meth_ast_8211_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj8207, "accept(1)from(1)", &meth_ast_8211_accept_40_1_41_from_40_1_41_, 3);
  int argcv_meth_ast_8211_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_8211_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_8211_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_8211_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8211_accept_40_1_41_from_40_1_41_->definitionLine = 2166;
// method "map(_)ancestors(_)"
  struct UserObject *uo8214 = (struct UserObject*)obj8207;
  uo8214->data[4] = emptyclosure;
  Method *meth_meth_ast_8214_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj8207, "map(1)ancestors(1)", &meth_ast_8214_map_40_1_41_ancestors_40_1_41_, 4);
  int argcv_meth_ast_8214_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_8214_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_8214_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_8214_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8214_map_40_1_41_ancestors_40_1_41_->definitionLine = 2169;
// method "pretty(_)"
  struct UserObject *uo8221 = (struct UserObject*)obj8207;
  uo8221->data[5] = emptyclosure;
  Method *meth_meth_ast_8221_pretty_40_1_41_ = addmethod2pos(obj8207, "pretty(1)", &meth_ast_8221_pretty_40_1_41_, 5);
  int argcv_meth_ast_8221_pretty_40_1_41_[] = {1};
  meth_meth_ast_8221_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8221_pretty_40_1_41_);
  meth_meth_ast_8221_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8221_pretty_40_1_41_->definitionLine = 2174;
// method "toGrace(_)"
  struct UserObject *uo8241 = (struct UserObject*)obj8207;
  uo8241->data[6] = emptyclosure;
  Method *meth_meth_ast_8241_toGrace_40_1_41_ = addmethod2pos(obj8207, "toGrace(1)", &meth_ast_8241_toGrace_40_1_41_, 6);
  int argcv_meth_ast_8241_toGrace_40_1_41_[] = {1};
  meth_meth_ast_8241_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8241_toGrace_40_1_41_);
meth_meth_ast_8241_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_8241_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_8241_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8241_toGrace_40_1_41_->definitionLine = 2177;
// method "asString"
  struct UserObject *uo8246 = (struct UserObject*)obj8207;
  uo8246->data[7] = emptyclosure;
  Method *meth_meth_ast_8246_asString = addmethod2pos(obj8207, "asString", &meth_ast_8246_asString, 7);
  int argcv_meth_ast_8246_asString[] = {0};
  meth_meth_ast_8246_asString->type = alloc_MethodType(1, argcv_meth_ast_8246_asString);
  meth_meth_ast_8246_asString->definitionModule = modulename;
  meth_meth_ast_8246_asString->definitionLine = 2180;
// method "shallowCopy"
  block_savedest(obj8207);
  Object closure8257 = createclosure(1, "shallowCopy");
  setclosureframe(closure8257, stackframe);
  addtoclosure(closure8257, var_numNode);
  struct UserObject *uo8257 = (struct UserObject*)obj8207;
  uo8257->data[8] = (Object)closure8257;
  Method *meth_meth_ast_8257_shallowCopy = addmethod2pos(obj8207, "shallowCopy", &meth_ast_8257_shallowCopy, 8);
  int argcv_meth_ast_8257_shallowCopy[] = {0};
  meth_meth_ast_8257_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_8257_shallowCopy);
  meth_meth_ast_8257_shallowCopy->definitionModule = modulename;
  meth_meth_ast_8257_shallowCopy->definitionLine = 2181;
// method "statementName"
  struct UserObject *uo8264 = (struct UserObject*)obj8207;
  uo8264->data[9] = emptyclosure;
  Method *meth_meth_ast_8264_statementName = addmethod2pos(obj8207, "statementName", &meth_ast_8264_statementName, 9);
  int argcv_meth_ast_8264_statementName[] = {0};
  meth_meth_ast_8264_statementName->type = alloc_MethodType(1, argcv_meth_ast_8264_statementName);
  meth_meth_ast_8264_statementName->definitionModule = modulename;
  meth_meth_ast_8264_statementName->definitionLine = 2184;
// method "isDelimited"
  struct UserObject *uo8266 = (struct UserObject*)obj8207;
  uo8266->data[10] = emptyclosure;
  Method *meth_meth_ast_8266_isDelimited = addmethod2pos(obj8207, "isDelimited", &meth_ast_8266_isDelimited, 10);
  int argcv_meth_ast_8266_isDelimited[] = {0};
  meth_meth_ast_8266_isDelimited->type = alloc_MethodType(1, argcv_meth_ast_8266_isDelimited);
  meth_meth_ast_8266_isDelimited->definitionModule = modulename;
  meth_meth_ast_8266_isDelimited->definitionLine = 2185;
// method "isConstant"
  struct UserObject *uo8268 = (struct UserObject*)obj8207;
  uo8268->data[11] = emptyclosure;
  Method *meth_meth_ast_8268_isConstant = addmethod2pos(obj8207, "isConstant", &meth_ast_8268_isConstant, 11);
  int argcv_meth_ast_8268_isConstant[] = {0};
  meth_meth_ast_8268_isConstant->type = alloc_MethodType(1, argcv_meth_ast_8268_isConstant);
  meth_meth_ast_8268_isConstant->definitionModule = modulename;
  meth_meth_ast_8268_isConstant->definitionLine = 2186;
  sourceObject = obj8207;
// Begin line 2163
  setline(2163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8270 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8271 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8270);
// compiled call node returning call8271 (depth = 3)
  struct UserObject *obj8207_uo = (struct UserObject *)obj8207;
  obj8207_uo->super = call8271;
  sourceObject = obj8207;
// Begin line 2164
  setline(2164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8272 == NULL) {
    strlit8272 = alloc_String("num");
    gc_root(strlit8272);
  }
// compiled string node returning strlit8272 (depth = 3)
  adddatum2(obj8207, strlit8272, 1);
  sourceObject = obj8207;
// Begin line 2165
  setline(2165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val (depth = 3)
  adddatum2(obj8207, *var_val, 2);
  sourceObject = obj8207;
  sourceObject = obj8207;
  sourceObject = obj8207;
  sourceObject = obj8207;
  sourceObject = obj8207;
  sourceObject = obj8207;
  sourceObject = obj8207;
  sourceObject = obj8207;
  sourceObject = obj8207;
  objclass8207 = obj8207->class;
  objclass8207->definitionModule = modulename;
  objclass8207->definitionLine = 2162;
  (*(struct UserObject *)self).data[0] = lowerouter8207;
  self = oldself8207;
  selfslot = oldselfslot8207;
  stackframe = oldstackframe8207;
  gc_frame_end(frame);
  return obj8207;
}
Object meth_ast_8206_new_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val = &(stackframe->slots[0]);
  *var_val = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8207 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8207 = alloc_userobj2(12,12, objclass8207);
  gc_frame_newslot(obj8207);
  if (objclass8207 == NULL) {
    glfree(obj8207->class->name);
    obj8207->class->name = "numNode.new(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj8207, self, 0);
  addmethodreal(obj8207,"outer", &reader_ast_outer_8208);
  Object oldself8207 = self;
  struct StackFrameObject *oldstackframe8207 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8207);
  gc_frame_newslot((Object)stackframe);
  self = obj8207;
  Object *oldselfslot8207 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8207 = (*(struct UserObject *)self).data[0], lowerouter8207 = thisouter8207;
  if (inheritingObject8207) {
    struct UserObject *inho8207 = (struct UserObject *)inheritingObject8207;
    while (inho8207->super != GraceDefaultObject) inho8207 = (struct UserObject *)inho8207->super;
    inho8207->super = obj8207;
    self = inheritingObject8207;
    *selfslot = self;
    lowerouter8207 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8207;
  }
  if (objclass8207 == NULL) {
  Method *reader8209 = addmethodrealflags(obj8207, "kind",&reader_ast_kind_8209, MFLAG_DEF);
  reader8209->definitionModule = modulename;
  reader8209->definitionLine = 2164;
  }
  adddatum2(obj8207, alloc_Undefined(), 1);
  if (objclass8207 == NULL) {
    Method *reader8210 = addmethodrealflags(obj8207, "value", &reader_ast_value_8210, 0);
    Method *writer8210 = addmethodrealflags(obj8207, "value:=(1)", &writer_ast_value_8210, 0);
    reader8210->definitionModule = modulename;
    writer8210->definitionModule = modulename;
    reader8210->definitionLine = 2165;
    writer8210->definitionLine = 2165;
  }
  obj8207->flags |= OFLAG_MUTABLE;
  adddatum2(obj8207, alloc_Undefined(), 2);
// method "accept(_)from(_)"
  struct UserObject *uo8211 = (struct UserObject*)obj8207;
  uo8211->data[3] = emptyclosure;
  Method *meth_meth_ast_8211_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj8207, "accept(1)from(1)", &meth_ast_8211_accept_40_1_41_from_40_1_41_, 3);
  int argcv_meth_ast_8211_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_8211_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_8211_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_8211_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8211_accept_40_1_41_from_40_1_41_->definitionLine = 2166;
// method "map(_)ancestors(_)"
  struct UserObject *uo8214 = (struct UserObject*)obj8207;
  uo8214->data[4] = emptyclosure;
  Method *meth_meth_ast_8214_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj8207, "map(1)ancestors(1)", &meth_ast_8214_map_40_1_41_ancestors_40_1_41_, 4);
  int argcv_meth_ast_8214_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_8214_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_8214_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_8214_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8214_map_40_1_41_ancestors_40_1_41_->definitionLine = 2169;
// method "pretty(_)"
  struct UserObject *uo8221 = (struct UserObject*)obj8207;
  uo8221->data[5] = emptyclosure;
  Method *meth_meth_ast_8221_pretty_40_1_41_ = addmethod2pos(obj8207, "pretty(1)", &meth_ast_8221_pretty_40_1_41_, 5);
  int argcv_meth_ast_8221_pretty_40_1_41_[] = {1};
  meth_meth_ast_8221_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8221_pretty_40_1_41_);
  meth_meth_ast_8221_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8221_pretty_40_1_41_->definitionLine = 2174;
// method "toGrace(_)"
  struct UserObject *uo8241 = (struct UserObject*)obj8207;
  uo8241->data[6] = emptyclosure;
  Method *meth_meth_ast_8241_toGrace_40_1_41_ = addmethod2pos(obj8207, "toGrace(1)", &meth_ast_8241_toGrace_40_1_41_, 6);
  int argcv_meth_ast_8241_toGrace_40_1_41_[] = {1};
  meth_meth_ast_8241_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8241_toGrace_40_1_41_);
meth_meth_ast_8241_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_8241_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_8241_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8241_toGrace_40_1_41_->definitionLine = 2177;
// method "asString"
  struct UserObject *uo8246 = (struct UserObject*)obj8207;
  uo8246->data[7] = emptyclosure;
  Method *meth_meth_ast_8246_asString = addmethod2pos(obj8207, "asString", &meth_ast_8246_asString, 7);
  int argcv_meth_ast_8246_asString[] = {0};
  meth_meth_ast_8246_asString->type = alloc_MethodType(1, argcv_meth_ast_8246_asString);
  meth_meth_ast_8246_asString->definitionModule = modulename;
  meth_meth_ast_8246_asString->definitionLine = 2180;
// method "shallowCopy"
  block_savedest(obj8207);
  Object closure8257 = createclosure(1, "shallowCopy");
  setclosureframe(closure8257, stackframe);
  addtoclosure(closure8257, var_numNode);
  struct UserObject *uo8257 = (struct UserObject*)obj8207;
  uo8257->data[8] = (Object)closure8257;
  Method *meth_meth_ast_8257_shallowCopy = addmethod2pos(obj8207, "shallowCopy", &meth_ast_8257_shallowCopy, 8);
  int argcv_meth_ast_8257_shallowCopy[] = {0};
  meth_meth_ast_8257_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_8257_shallowCopy);
  meth_meth_ast_8257_shallowCopy->definitionModule = modulename;
  meth_meth_ast_8257_shallowCopy->definitionLine = 2181;
// method "statementName"
  struct UserObject *uo8264 = (struct UserObject*)obj8207;
  uo8264->data[9] = emptyclosure;
  Method *meth_meth_ast_8264_statementName = addmethod2pos(obj8207, "statementName", &meth_ast_8264_statementName, 9);
  int argcv_meth_ast_8264_statementName[] = {0};
  meth_meth_ast_8264_statementName->type = alloc_MethodType(1, argcv_meth_ast_8264_statementName);
  meth_meth_ast_8264_statementName->definitionModule = modulename;
  meth_meth_ast_8264_statementName->definitionLine = 2184;
// method "isDelimited"
  struct UserObject *uo8266 = (struct UserObject*)obj8207;
  uo8266->data[10] = emptyclosure;
  Method *meth_meth_ast_8266_isDelimited = addmethod2pos(obj8207, "isDelimited", &meth_ast_8266_isDelimited, 10);
  int argcv_meth_ast_8266_isDelimited[] = {0};
  meth_meth_ast_8266_isDelimited->type = alloc_MethodType(1, argcv_meth_ast_8266_isDelimited);
  meth_meth_ast_8266_isDelimited->definitionModule = modulename;
  meth_meth_ast_8266_isDelimited->definitionLine = 2185;
// method "isConstant"
  struct UserObject *uo8268 = (struct UserObject*)obj8207;
  uo8268->data[11] = emptyclosure;
  Method *meth_meth_ast_8268_isConstant = addmethod2pos(obj8207, "isConstant", &meth_ast_8268_isConstant, 11);
  int argcv_meth_ast_8268_isConstant[] = {0};
  meth_meth_ast_8268_isConstant->type = alloc_MethodType(1, argcv_meth_ast_8268_isConstant);
  meth_meth_ast_8268_isConstant->definitionModule = modulename;
  meth_meth_ast_8268_isConstant->definitionLine = 2186;
  sourceObject = obj8207;
// Begin line 2163
  setline(2163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8270 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8271 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8270);
// compiled call node returning call8271 (depth = 3)
  struct UserObject *obj8207_uo = (struct UserObject *)obj8207;
  obj8207_uo->super = call8271;
  sourceObject = obj8207;
// Begin line 2164
  setline(2164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8272 == NULL) {
    strlit8272 = alloc_String("num");
    gc_root(strlit8272);
  }
// compiled string node returning strlit8272 (depth = 3)
  adddatum2(obj8207, strlit8272, 1);
  sourceObject = obj8207;
// Begin line 2165
  setline(2165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val (depth = 3)
  adddatum2(obj8207, *var_val, 2);
  sourceObject = obj8207;
  sourceObject = obj8207;
  sourceObject = obj8207;
  sourceObject = obj8207;
  sourceObject = obj8207;
  sourceObject = obj8207;
  sourceObject = obj8207;
  sourceObject = obj8207;
  sourceObject = obj8207;
  objclass8207 = obj8207->class;
  objclass8207->definitionModule = modulename;
  objclass8207->definitionLine = 2162;
  (*(struct UserObject *)self).data[0] = lowerouter8207;
  self = oldself8207;
  selfslot = oldselfslot8207;
  stackframe = oldstackframe8207;
  gc_frame_end(frame);
  return obj8207;
}
Object meth_ast_8274_numNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 47, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "numNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2161
  setline(2161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_numNode (depth = 3)
  gc_frame_end(frame);
  return *var_numNode;
}
Object meth_ast_8286_start(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "start");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2199
  setline(2199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8287 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8288 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8289 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8288);
// compiled member node returning call8289 (depth = 4)
  partcv[0] = 0;
  Object call8290 = callmethodflags(call8289, "start", 1, partcv, params, 0);
  gc_frame_end(callframe8287);
// compiled member node returning call8290 (depth = 3)
  gc_frame_end(frame);
  return call8290;
}
Object meth_ast_8291_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2200
  setline(2200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8292 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8293 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8294 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8293);
// compiled member node returning call8294 (depth = 4)
  partcv[0] = 0;
  Object call8295 = callmethodflags(call8294, "end", 1, partcv, params, 0);
  gc_frame_end(callframe8292);
// compiled member node returning call8295 (depth = 3)
  gc_frame_end(frame);
  return call8295;
}
Object meth_ast_8296_onSelf(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "onSelf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2202
  setline(2202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8297 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool8298 = alloc_Boolean(1);
// compiled identifier node returning bool8298 (depth = 4)
  gc_frame_newslot(bool8298);
// call case 4: self request
  params[0] = bool8298;
  partcv[0] = 1;
  Object call8299 = callmethodflags(self, "isSelfRequest:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8297);
// compiled call node returning call8299 (depth = 3)
// Begin line 2203
  setline(2203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_8300_opPos(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "opPos");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2207
  setline(2207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8301 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8302 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8303 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8302);
// compiled member node returning call8303 (depth = 4)
  gc_frame_newslot(call8303);
// starting to compile member node (depth = 4)
  int callframe8304 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8305 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8306 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8305);
// compiled member node returning call8306 (depth = 5)
  partcv[0] = 0;
  Object call8307 = callmethodflags(call8306, "end", 1, partcv, params, 0);
  gc_frame_end(callframe8304);
// compiled member node returning call8307 (depth = 4)
  gc_frame_newslot(call8307);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = call8303;
  params[1] = call8307;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8308 = callmethodflags(module_ast, "positionOfNext(1)after(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8301);
// compiled call node returning call8308 (depth = 3)
  gc_frame_end(frame);
  return call8308;
}
Object meth_ast_8309_isSimple(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2209
  setline(2209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8310 = alloc_Boolean(0);
// compiled identifier node returning bool8310 (depth = 3)
  gc_frame_end(frame);
  return bool8310;
}
Object meth_ast_8311_nameString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2210
  setline(2210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8313 == NULL) {
    strlit8313 = alloc_String("(1)");
    gc_root(strlit8313);
  }
// compiled string node returning strlit8313 (depth = 4)
  int op_slot_right_8312 = gc_frame_newslot(strlit8313);
// starting to compile member node (depth = 4)
  int callframe8315 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8316 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8315);
// compiled member node returning call8316 (depth = 4)
  int op_slot_left_8312 = gc_frame_newslot(call8316);
  params[0] = strlit8313;
  partcv[0] = 1;
  Object opresult8317 = callmethod(call8316, "++(1)", 1, partcv, params);
// compiled op node returning opresult8317 (depth = 3)
  gc_frame_end(frame);
  return opresult8317;
}
Object meth_ast_8318_canonicalName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canonicalName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2211
  setline(2211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8320 == NULL) {
    strlit8320 = alloc_String("(_)");
    gc_root(strlit8320);
  }
// compiled string node returning strlit8320 (depth = 4)
  int op_slot_right_8319 = gc_frame_newslot(strlit8320);
// starting to compile member node (depth = 4)
  int callframe8322 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8323 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8322);
// compiled member node returning call8323 (depth = 4)
  int op_slot_left_8319 = gc_frame_newslot(call8323);
  params[0] = strlit8320;
  partcv[0] = 1;
  Object opresult8324 = callmethod(call8323, "++(1)", 1, partcv, params);
// compiled op node returning opresult8324 (depth = 3)
  gc_frame_end(frame);
  return opresult8324;
}
Object meth_ast_8325_receiver(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "receiver");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2212
  setline(2212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8326 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8327 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8326);
// compiled member node returning call8327 (depth = 3)
  gc_frame_end(frame);
  return call8327;
}
Object meth_ast_8328_isCall(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2213
  setline(2213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8329 = alloc_Boolean(1);
// compiled identifier node returning bool8329 (depth = 3)
  gc_frame_end(frame);
  return bool8329;
}
Object meth_ast_8330_parts(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parts");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_requestPart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2215
  setline(2215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8331 = gc_frame_new();
// starting to compile array node (depth = 4)
  Object array8332 = alloc_BuiltinList();
  gc_pause();
// starting to compile call node (depth = 5)
  int callframe8333 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe8334 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8335 = callmethodflags(self, "opPos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8334);
// compiled member node returning call8335 (depth = 6)
  gc_frame_newslot(call8335);
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe8336 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe8337 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8338 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8337);
// compiled member node returning call8338 (depth = 7)
  gc_frame_newslot(call8338);
// starting to compile array node (depth = 7)
  Object array8339 = alloc_BuiltinList();
  gc_pause();
// starting to compile member node (depth = 8)
  int callframe8340 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8341 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8340);
// compiled member node returning call8341 (depth = 8)
  params[0] = call8341;
  partcv[0] = 1;
  callmethodflags(array8339, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array8339 (depth = 7)
  gc_frame_newslot(array8339);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_requestPart (depth = 7)
  params[0] = call8338;
  params[1] = array8339;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8342 = callmethodflags(*var_requestPart, "request(1)withArgs(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8336);
// compiled call node returning call8342 (depth = 6)
  params[0] = call8335;
  partcv[0] = 1;
  Object call8343 = callmethodflags(call8342, "setStart(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8333);
// compiled call node returning call8343 (depth = 5)
  params[0] = call8343;
  partcv[0] = 1;
  callmethodflags(array8332, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array8332 (depth = 4)
  gc_frame_newslot(array8332);
// call case 5: prelude request
  params[0] = array8332;
  partcv[0] = 1;
  Object call8344 = callmethodflags(prelude, "list(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8331);
// compiled call node returning call8344 (depth = 3)
  gc_frame_end(frame);
  return call8344;
}
Object meth_ast_8345_arguments(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "arguments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2216
  setline(2216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array8346 = alloc_BuiltinList();
  gc_pause();
// starting to compile member node (depth = 4)
  int callframe8347 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8348 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8347);
// compiled member node returning call8348 (depth = 4)
  params[0] = call8348;
  partcv[0] = 1;
  callmethodflags(array8346, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array8346 (depth = 3)
  gc_frame_end(frame);
  return array8346;
}
Object meth_ast_8349_argumentsDo_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "argumentsDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method argumentsDo(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for argumentsDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part argumentsDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2217
  setline(2217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8350 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8351 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8352 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8351);
// compiled member node returning call8352 (depth = 4)
  gc_frame_newslot(call8352);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_action (depth = 4)
  params[0] = call8352;
  partcv[0] = 1;
  Object call8353 = callmethodflags(*var_action, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8350);
// compiled call node returning call8353 (depth = 3)
  gc_frame_end(frame);
  return call8353;
}
Object meth_ast_8354_numArgs(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "numArgs");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2218
  setline(2218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num8355 = alloc_Float64(1);
// compiled num node returning num8355 (depth = 3)
  gc_frame_end(frame);
  return num8355;
}
Object meth_ast_8356_numTypeArgs(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "numTypeArgs");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2219
  setline(2219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num8357 = alloc_Float64(0);
// compiled num node returning num8357 (depth = 3)
  gc_frame_end(frame);
  return num8357;
}
Object meth_ast_8358_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// definebindings:
// Begin line 2222
  setline(2222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8360 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8361 = callmethodflags(*var_visitor, "visitOp(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8360);
// compiled call node returning call8361 (depth = 4)
  Object if8359 = done;
  if (istrue(call8361)) {
// Begin line 2223
  setline(2223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8362 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call8363 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8362);
// compiled call node returning call8363 (depth = 5)
  *var_newChain = call8363;
  if (call8363 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2224
  setline(2224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8364 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8365 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8366 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8365);
// compiled member node returning call8366 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8367 = callmethodflags(call8366, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8364);
// compiled call node returning call8367 (depth = 4)
// Begin line 2225
  setline(2225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8368 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8369 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8370 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8369);
// compiled member node returning call8370 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8371 = callmethodflags(call8370, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8368);
// compiled call node returning call8371 (depth = 4)
    gc_frame_newslot(call8371);
    if8359 = call8371;
  } else {
  }
// compiled if node returning if8359 (depth = 3)
  gc_frame_end(frame);
  return if8359;
}
Object meth_ast_8372_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2229
  setline(2229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8373 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8374 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8373);
// compiled member node returning call8374 (depth = 4)
  *var_n = call8374;
  if (call8374 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2230
  setline(2230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8375 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8376 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8375);
// compiled call node returning call8376 (depth = 4)
  *var_newChain = call8376;
  if (call8376 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2231
  setline(2231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8377 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8378 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8379 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8380 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8379);
// compiled member node returning call8380 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8381 = callmethodflags(call8380, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8378);
// compiled call node returning call8381 (depth = 4)
  gc_frame_newslot(call8381);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8381;
  partcv[0] = 1;
  Object call8382 = callmethodflags(*var_n, "left:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8377);
// compiled call node returning call8382 (depth = 3)
// Begin line 2232
  setline(2232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8383 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8384 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8385 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8386 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8385);
// compiled member node returning call8386 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8387 = callmethodflags(call8386, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8384);
// compiled call node returning call8387 (depth = 4)
  gc_frame_newslot(call8387);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8387;
  partcv[0] = 1;
  Object call8388 = callmethodflags(*var_n, "right:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8383);
// compiled call node returning call8388 (depth = 3)
// Begin line 2233
  setline(2233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8389 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call8390 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8389);
// compiled call node returning call8390 (depth = 3)
  gc_frame_end(frame);
  return call8390;
}
Object meth_ast_8391_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2236
  setline(2236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8394 = alloc_Float64(1);
// compiled num node returning num8394 (depth = 6)
  int op_slot_right_8393 = gc_frame_newslot(num8394);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_8393 = gc_frame_newslot(*var_depth);
  params[0] = num8394;
  partcv[0] = 1;
  Object sum8396 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8396 (depth = 5)
  int op_slot_right_8392 = gc_frame_newslot(sum8396);
// starting to compile string node (depth = 5)
  if (strlit8398 == NULL) {
    strlit8398 = alloc_String("  ");
    gc_root(strlit8398);
  }
// compiled string node returning strlit8398 (depth = 5)
  int op_slot_left_8392 = gc_frame_newslot(strlit8398);
  params[0] = sum8396;
  partcv[0] = 1;
  Object prod8399 = callmethod(strlit8398, "*(1)", 1, partcv, params);
// compiled op node returning prod8399 (depth = 4)
  *var_spc = prod8399;
  if (prod8399 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2237
  setline(2237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8401 == NULL) {
    strlit8401 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit8401);
  }
// compiled string node returning strlit8401 (depth = 5)
  int op_slot_right_8400 = gc_frame_newslot(strlit8401);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8404 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8405 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8404);
// compiled member node returning call8405 (depth = 6)
  int op_slot_right_8403 = gc_frame_newslot(call8405);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8408 == NULL) {
    strlit8408 = alloc_String("""\xe2""""\x80""""\xb9""");
    gc_root(strlit8408);
  }
// compiled string node returning strlit8408 (depth = 7)
  int op_slot_right_8407 = gc_frame_newslot(strlit8408);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8411 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8412 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8411);
// compiled call node returning call8412 (depth = 8)
  int op_slot_right_8410 = gc_frame_newslot(call8412);
// starting to compile string node (depth = 8)
  if (strlit8414 == NULL) {
    strlit8414 = alloc_String("");
    gc_root(strlit8414);
  }
// compiled string node returning strlit8414 (depth = 8)
  int op_slot_left_8410 = gc_frame_newslot(strlit8414);
  params[0] = call8412;
  partcv[0] = 1;
  Object opresult8415 = callmethod(strlit8414, "++(1)", 1, partcv, params);
// compiled op node returning opresult8415 (depth = 7)
  int op_slot_left_8407 = gc_frame_newslot(opresult8415);
  params[0] = strlit8408;
  partcv[0] = 1;
  Object opresult8416 = callmethod(opresult8415, "++(1)", 1, partcv, params);
// compiled op node returning opresult8416 (depth = 6)
  int op_slot_left_8403 = gc_frame_newslot(opresult8416);
  params[0] = call8405;
  partcv[0] = 1;
  Object opresult8417 = callmethod(opresult8416, "++(1)", 1, partcv, params);
// compiled op node returning opresult8417 (depth = 5)
  int op_slot_left_8400 = gc_frame_newslot(opresult8417);
  params[0] = strlit8401;
  partcv[0] = 1;
  Object opresult8418 = callmethod(opresult8417, "++(1)", 1, partcv, params);
// compiled op node returning opresult8418 (depth = 4)
  *var_s = opresult8418;
  if (opresult8418 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2238
  setline(2238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8420 == NULL) {
    strlit8420 = alloc_String("""\x0a""");
    gc_root(strlit8420);
  }
// compiled string node returning strlit8420 (depth = 5)
  int op_slot_right_8419 = gc_frame_newslot(strlit8420);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_8419 = gc_frame_newslot(*var_s);
  params[0] = strlit8420;
  partcv[0] = 1;
  Object opresult8422 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8422 (depth = 4)
  *var_s = opresult8422;
  if (opresult8422 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2239
  setline(2239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8425 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8427 = alloc_Float64(1);
// compiled num node returning num8427 (depth = 7)
  int op_slot_right_8426 = gc_frame_newslot(num8427);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_8426 = gc_frame_newslot(*var_depth);
  params[0] = num8427;
  partcv[0] = 1;
  Object sum8429 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8429 (depth = 6)
  gc_frame_newslot(sum8429);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8430 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8431 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8430);
// compiled member node returning call8431 (depth = 6)
  params[0] = sum8429;
  partcv[0] = 1;
  Object call8432 = callmethodflags(call8431, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8425);
// compiled call node returning call8432 (depth = 5)
  int op_slot_right_8424 = gc_frame_newslot(call8432);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_8434 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8434 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8436 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8436 (depth = 5)
  int op_slot_left_8424 = gc_frame_newslot(opresult8436);
  params[0] = call8432;
  partcv[0] = 1;
  Object opresult8437 = callmethod(opresult8436, "++(1)", 1, partcv, params);
// compiled op node returning opresult8437 (depth = 4)
  *var_s = opresult8437;
  if (opresult8437 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2240
  setline(2240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8440 == NULL) {
    strlit8440 = alloc_String("""\x0a""");
    gc_root(strlit8440);
  }
// compiled string node returning strlit8440 (depth = 5)
  int op_slot_right_8439 = gc_frame_newslot(strlit8440);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_8439 = gc_frame_newslot(*var_s);
  params[0] = strlit8440;
  partcv[0] = 1;
  Object opresult8442 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8442 (depth = 4)
  *var_s = opresult8442;
  if (opresult8442 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2241
  setline(2241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8445 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8447 = alloc_Float64(1);
// compiled num node returning num8447 (depth = 7)
  int op_slot_right_8446 = gc_frame_newslot(num8447);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_8446 = gc_frame_newslot(*var_depth);
  params[0] = num8447;
  partcv[0] = 1;
  Object sum8449 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8449 (depth = 6)
  gc_frame_newslot(sum8449);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8450 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8451 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8450);
// compiled member node returning call8451 (depth = 6)
  params[0] = sum8449;
  partcv[0] = 1;
  Object call8452 = callmethodflags(call8451, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8445);
// compiled call node returning call8452 (depth = 5)
  int op_slot_right_8444 = gc_frame_newslot(call8452);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_8454 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8454 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8456 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8456 (depth = 5)
  int op_slot_left_8444 = gc_frame_newslot(opresult8456);
  params[0] = call8452;
  partcv[0] = 1;
  Object opresult8457 = callmethod(opresult8456, "++(1)", 1, partcv, params);
// compiled op node returning opresult8457 (depth = 4)
  *var_s = opresult8457;
  if (opresult8457 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2242
  setline(2242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_8464__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe8466 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8467 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8466);
// compiled member node returning call8467 (depth = 7)
  int op_slot_right_8465 = gc_frame_newslot(call8467);
// starting to compile member node (depth = 7)
  int callframe8469 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe8470 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8471 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8470);
// compiled member node returning call8471 (depth = 8)
  partcv[0] = 0;
  Object call8472 = callmethodflags(call8471, "value", 1, partcv, params, 0);
  gc_frame_end(callframe8469);
// compiled member node returning call8472 (depth = 7)
  int op_slot_left_8465 = gc_frame_newslot(call8472);
  params[0] = call8467;
  partcv[0] = 1;
  Object opresult8473 = callmethod(call8472, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8473 (depth = 6)
  gc_frame_end(frame);
  return opresult8473;
}
Object meth_ast_8535__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe8537 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8538 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8537);
// compiled member node returning call8538 (depth = 7)
  int op_slot_right_8536 = gc_frame_newslot(call8538);
// starting to compile member node (depth = 7)
  int callframe8540 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe8541 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8542 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8541);
// compiled member node returning call8542 (depth = 8)
  partcv[0] = 0;
  Object call8543 = callmethodflags(call8542, "value", 1, partcv, params, 0);
  gc_frame_end(callframe8540);
// compiled member node returning call8543 (depth = 7)
  int op_slot_left_8536 = gc_frame_newslot(call8543);
  params[0] = call8538;
  partcv[0] = 1;
  Object opresult8544 = callmethod(call8543, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8544 (depth = 6)
  gc_frame_end(frame);
  return opresult8544;
}
Object meth_ast_8459_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2245
  setline(2245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8460 == NULL) {
    strlit8460 = alloc_String("");
    gc_root(strlit8460);
  }
// compiled string node returning strlit8460 (depth = 4)
  *var_s = strlit8460;
  if (strlit8460 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2246
  setline(2246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block8463 = alloc_Block(NULL, NULL, "ast", 2246);
  gc_frame_newslot(block8463);
// method "_apply"
  block_savedest(block8463);
  Object closure8464 = createclosure(1, "_apply");
  setclosureframe(closure8464, stackframe);
  addtoclosure(closure8464, selfslot);
  struct UserObject *uo8464 = (struct UserObject*)block8463;
  uo8464->data[0] = (Object)closure8464;
  Method *meth_meth_ast_8464__apply = addmethod2pos(block8463, "_apply", &meth_ast_8464__apply, 0);
  int argcv_meth_ast_8464__apply[] = {0};
  meth_meth_ast_8464__apply->type = alloc_MethodType(1, argcv_meth_ast_8464__apply);
  meth_meth_ast_8464__apply->definitionModule = modulename;
  meth_meth_ast_8464__apply->definitionLine = 3050;
// compiled block node returning block8463 (depth = 5)
  int op_slot_right_8462 = gc_frame_newslot(block8463);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8477 == NULL) {
    strlit8477 = alloc_String("op");
    gc_root(strlit8477);
  }
// compiled string node returning strlit8477 (depth = 6)
  int op_slot_right_8476 = gc_frame_newslot(strlit8477);
// starting to compile member node (depth = 6)
  int callframe8479 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8480 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8481 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8480);
// compiled member node returning call8481 (depth = 7)
  partcv[0] = 0;
  Object call8482 = callmethodflags(call8481, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe8479);
// compiled member node returning call8482 (depth = 6)
  int op_slot_left_8476 = gc_frame_newslot(call8482);
  params[0] = strlit8477;
  partcv[0] = 1;
  Object opresult8483 = callmethod(call8482, "==(1)", 1, partcv, params);
// compiled op node returning opresult8483 (depth = 5)
  int op_slot_left_8462 = gc_frame_newslot(opresult8483);
  params[0] = block8463;
  partcv[0] = 1;
  Object opresult8484 = callmethod(opresult8483, "&&(1)", 1, partcv, params);
// compiled op node returning opresult8484 (depth = 4)
  Object if8461 = done;
  if (istrue(opresult8484)) {
// Begin line 2247
  setline(2247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8486 == NULL) {
    strlit8486 = alloc_String(")");
    gc_root(strlit8486);
  }
// compiled string node returning strlit8486 (depth = 6)
  int op_slot_right_8485 = gc_frame_newslot(strlit8486);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8489 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num8490 = alloc_Float64(0);
// compiled num node returning num8490 (depth = 8)
  gc_frame_newslot(num8490);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe8491 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8492 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8491);
// compiled member node returning call8492 (depth = 8)
  params[0] = num8490;
  partcv[0] = 1;
  Object call8493 = callmethodflags(call8492, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8489);
// compiled call node returning call8493 (depth = 7)
  int op_slot_right_8488 = gc_frame_newslot(call8493);
// starting to compile string node (depth = 7)
  if (strlit8495 == NULL) {
    strlit8495 = alloc_String("(");
    gc_root(strlit8495);
  }
// compiled string node returning strlit8495 (depth = 7)
  int op_slot_left_8488 = gc_frame_newslot(strlit8495);
  params[0] = call8493;
  partcv[0] = 1;
  Object opresult8496 = callmethod(strlit8495, "++(1)", 1, partcv, params);
// compiled op node returning opresult8496 (depth = 6)
  int op_slot_left_8485 = gc_frame_newslot(opresult8496);
  params[0] = strlit8486;
  partcv[0] = 1;
  Object opresult8497 = callmethod(opresult8496, "++(1)", 1, partcv, params);
// compiled op node returning opresult8497 (depth = 5)
  *var_s = opresult8497;
  if (opresult8497 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8461 = done;
  } else {
// Begin line 2249
  setline(2249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8499 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num8500 = alloc_Float64(0);
// compiled num node returning num8500 (depth = 6)
  gc_frame_newslot(num8500);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8501 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8502 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8501);
// compiled member node returning call8502 (depth = 6)
  params[0] = num8500;
  partcv[0] = 1;
  Object call8503 = callmethodflags(call8502, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8499);
// compiled call node returning call8503 (depth = 5)
  *var_s = call8503;
  if (call8503 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8461 = done;
  }
// compiled if node returning if8461 (depth = 3)
// Begin line 2251
  setline(2251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8507 == NULL) {
    strlit8507 = alloc_String("..");
    gc_root(strlit8507);
  }
// compiled string node returning strlit8507 (depth = 5)
  int op_slot_right_8506 = gc_frame_newslot(strlit8507);
// starting to compile member node (depth = 5)
  int callframe8509 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8510 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8509);
// compiled member node returning call8510 (depth = 5)
  int op_slot_left_8506 = gc_frame_newslot(call8510);
  params[0] = strlit8507;
  partcv[0] = 1;
  Object opresult8511 = callmethod(call8510, "==(1)", 1, partcv, params);
// compiled op node returning opresult8511 (depth = 4)
  Object if8505 = done;
  if (istrue(opresult8511)) {
// Begin line 2252
  setline(2252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8513 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8514 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8513);
// compiled member node returning call8514 (depth = 6)
  int op_slot_right_8512 = gc_frame_newslot(call8514);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8512 = gc_frame_newslot(*var_s);
  params[0] = call8514;
  partcv[0] = 1;
  Object opresult8516 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8516 (depth = 5)
  *var_s = opresult8516;
  if (opresult8516 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8505 = done;
  } else {
// Begin line 2254
  setline(2254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8519 == NULL) {
    strlit8519 = alloc_String(" ");
    gc_root(strlit8519);
  }
// compiled string node returning strlit8519 (depth = 6)
  int op_slot_right_8518 = gc_frame_newslot(strlit8519);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe8522 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8523 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8522);
// compiled member node returning call8523 (depth = 7)
  int op_slot_right_8521 = gc_frame_newslot(call8523);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8526 == NULL) {
    strlit8526 = alloc_String(" ");
    gc_root(strlit8526);
  }
// compiled string node returning strlit8526 (depth = 8)
  int op_slot_right_8525 = gc_frame_newslot(strlit8526);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_8525 = gc_frame_newslot(*var_s);
  params[0] = strlit8526;
  partcv[0] = 1;
  Object opresult8528 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8528 (depth = 7)
  int op_slot_left_8521 = gc_frame_newslot(opresult8528);
  params[0] = call8523;
  partcv[0] = 1;
  Object opresult8529 = callmethod(opresult8528, "++(1)", 1, partcv, params);
// compiled op node returning opresult8529 (depth = 6)
  int op_slot_left_8518 = gc_frame_newslot(opresult8529);
  params[0] = strlit8519;
  partcv[0] = 1;
  Object opresult8530 = callmethod(opresult8529, "++(1)", 1, partcv, params);
// compiled op node returning opresult8530 (depth = 5)
  *var_s = opresult8530;
  if (opresult8530 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8505 = done;
  }
// compiled if node returning if8505 (depth = 3)
// Begin line 2256
  setline(2256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block8534 = alloc_Block(NULL, NULL, "ast", 2256);
  gc_frame_newslot(block8534);
// method "_apply"
  block_savedest(block8534);
  Object closure8535 = createclosure(1, "_apply");
  setclosureframe(closure8535, stackframe);
  addtoclosure(closure8535, selfslot);
  struct UserObject *uo8535 = (struct UserObject*)block8534;
  uo8535->data[0] = (Object)closure8535;
  Method *meth_meth_ast_8535__apply = addmethod2pos(block8534, "_apply", &meth_ast_8535__apply, 0);
  int argcv_meth_ast_8535__apply[] = {0};
  meth_meth_ast_8535__apply->type = alloc_MethodType(1, argcv_meth_ast_8535__apply);
  meth_meth_ast_8535__apply->definitionModule = modulename;
  meth_meth_ast_8535__apply->definitionLine = 3050;
// compiled block node returning block8534 (depth = 5)
  int op_slot_right_8533 = gc_frame_newslot(block8534);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8548 == NULL) {
    strlit8548 = alloc_String("op");
    gc_root(strlit8548);
  }
// compiled string node returning strlit8548 (depth = 6)
  int op_slot_right_8547 = gc_frame_newslot(strlit8548);
// starting to compile member node (depth = 6)
  int callframe8550 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8551 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8552 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8551);
// compiled member node returning call8552 (depth = 7)
  partcv[0] = 0;
  Object call8553 = callmethodflags(call8552, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe8550);
// compiled member node returning call8553 (depth = 6)
  int op_slot_left_8547 = gc_frame_newslot(call8553);
  params[0] = strlit8548;
  partcv[0] = 1;
  Object opresult8554 = callmethod(call8553, "==(1)", 1, partcv, params);
// compiled op node returning opresult8554 (depth = 5)
  int op_slot_left_8533 = gc_frame_newslot(opresult8554);
  params[0] = block8534;
  partcv[0] = 1;
  Object opresult8555 = callmethod(opresult8554, "&&(1)", 1, partcv, params);
// compiled op node returning opresult8555 (depth = 4)
  Object if8532 = done;
  if (istrue(opresult8555)) {
// Begin line 2257
  setline(2257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8557 == NULL) {
    strlit8557 = alloc_String(")");
    gc_root(strlit8557);
  }
// compiled string node returning strlit8557 (depth = 6)
  int op_slot_right_8556 = gc_frame_newslot(strlit8557);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8560 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num8561 = alloc_Float64(0);
// compiled num node returning num8561 (depth = 8)
  gc_frame_newslot(num8561);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe8562 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8563 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8562);
// compiled member node returning call8563 (depth = 8)
  params[0] = num8561;
  partcv[0] = 1;
  Object call8564 = callmethodflags(call8563, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8560);
// compiled call node returning call8564 (depth = 7)
  int op_slot_right_8559 = gc_frame_newslot(call8564);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8567 == NULL) {
    strlit8567 = alloc_String("(");
    gc_root(strlit8567);
  }
// compiled string node returning strlit8567 (depth = 8)
  int op_slot_right_8566 = gc_frame_newslot(strlit8567);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_8566 = gc_frame_newslot(*var_s);
  params[0] = strlit8567;
  partcv[0] = 1;
  Object opresult8569 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8569 (depth = 7)
  int op_slot_left_8559 = gc_frame_newslot(opresult8569);
  params[0] = call8564;
  partcv[0] = 1;
  Object opresult8570 = callmethod(opresult8569, "++(1)", 1, partcv, params);
// compiled op node returning opresult8570 (depth = 6)
  int op_slot_left_8556 = gc_frame_newslot(opresult8570);
  params[0] = strlit8557;
  partcv[0] = 1;
  Object opresult8571 = callmethod(opresult8570, "++(1)", 1, partcv, params);
// compiled op node returning opresult8571 (depth = 5)
  *var_s = opresult8571;
  if (opresult8571 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8532 = done;
  } else {
// Begin line 2259
  setline(2259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8574 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num8575 = alloc_Float64(0);
// compiled num node returning num8575 (depth = 7)
  gc_frame_newslot(num8575);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8576 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8577 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8576);
// compiled member node returning call8577 (depth = 7)
  params[0] = num8575;
  partcv[0] = 1;
  Object call8578 = callmethodflags(call8577, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8574);
// compiled call node returning call8578 (depth = 6)
  int op_slot_right_8573 = gc_frame_newslot(call8578);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8573 = gc_frame_newslot(*var_s);
  params[0] = call8578;
  partcv[0] = 1;
  Object opresult8580 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8580 (depth = 5)
  *var_s = opresult8580;
  if (opresult8580 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8532 = done;
  }
// compiled if node returning if8532 (depth = 3)
// Begin line 2261
  setline(2261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_8582_asIdentifier(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_resultNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "resultNode");
// Begin line 2265
  setline(2265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8583 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8584 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8585 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8584);
// compiled member node returning call8585 (depth = 5)
  gc_frame_newslot(call8585);
// starting to compile identifier node (depth = 5)
  Object bool8586 = alloc_Boolean(0);
// compiled identifier node returning bool8586 (depth = 5)
  gc_frame_newslot(bool8586);
// starting to compile member node (depth = 5)
  int callframe8587 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8588 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8587);
// compiled member node returning call8588 (depth = 5)
  gc_frame_newslot(call8588);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_identifierNode (depth = 5)
  params[0] = call8585;
  params[1] = bool8586;
  params[2] = call8588;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8589 = callmethodflags(*var_identifierNode, "new(2)scope(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8583);
// compiled call node returning call8589 (depth = 4)
  *var_resultNode = call8589;
  if (call8589 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2266
  setline(2266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8590 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool8591 = alloc_Boolean(1);
// compiled identifier node returning bool8591 (depth = 4)
  gc_frame_newslot(bool8591);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = bool8591;
  partcv[0] = 1;
  Object call8592 = callmethodflags(*var_resultNode, "inRequest:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8590);
// compiled call node returning call8592 (depth = 3)
// Begin line 2267
  setline(2267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8593 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8594 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8595 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8594);
// compiled member node returning call8595 (depth = 4)
  gc_frame_newslot(call8595);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = call8595;
  partcv[0] = 1;
  Object call8596 = callmethodflags(*var_resultNode, "line:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8593);
// compiled call node returning call8596 (depth = 3)
// Begin line 2268
  setline(2268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8597 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8598 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8599 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8598);
// compiled member node returning call8599 (depth = 4)
  gc_frame_newslot(call8599);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = call8599;
  partcv[0] = 1;
  Object call8600 = callmethodflags(*var_resultNode, "linePos:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8597);
// compiled call node returning call8600 (depth = 3)
// Begin line 2269
  setline(2269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  return *var_resultNode;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_8601_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_opNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2272
  setline(2272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8602 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe8603 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8604 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8605 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8604);
// compiled member node returning call8605 (depth = 5)
  gc_frame_newslot(call8605);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_opNode (depth = 5)
  params[0] = call8605;
  params[1] = *var_nullNode;
  params[2] = *var_nullNode;
  partcv[0] = 3;
  Object call8606 = callmethodflags(*var_opNode, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe8603);
// compiled call node returning call8606 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call8607 = callmethodflags(call8606, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8602);
// compiled call node returning call8607 (depth = 3)
  gc_frame_end(frame);
  return call8607;
}
Object meth_ast_8608_postCopy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "postCopy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method postCopy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for postCopy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part postCopy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2275
  setline(2275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8609 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8610 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call8611 = callmethodflags(*var_other, "isTailCall", 1, partcv, params, 0);
  gc_frame_end(callframe8610);
// compiled member node returning call8611 (depth = 4)
  gc_frame_newslot(call8611);
// call case 4: self request
  params[0] = call8611;
  partcv[0] = 1;
  Object call8612 = callmethodflags(self, "isTailCall:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8609);
// compiled call node returning call8612 (depth = 3)
// Begin line 2276
  setline(2276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8613 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8614 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call8615 = callmethodflags(*var_other, "isSelfRequest", 1, partcv, params, 0);
  gc_frame_end(callframe8614);
// compiled member node returning call8615 (depth = 4)
  gc_frame_newslot(call8615);
// call case 4: self request
  params[0] = call8615;
  partcv[0] = 1;
  Object call8616 = callmethodflags(self, "isSelfRequest:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8613);
// compiled call node returning call8616 (depth = 3)
// Begin line 2277
  setline(2277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_8277_new_40_3_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_requestPart = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_nullNode = getfromclosure(closure, 2);
  Object *var_opNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_op = &(stackframe->slots[0]);
  *var_op = args[curarg];
  curarg++;
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[2]);
  *var_r = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8278 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8278 = alloc_userobj2(31,28, objclass8278);
  gc_frame_newslot(obj8278);
  if (objclass8278 == NULL) {
    glfree(obj8278->class->name);
    obj8278->class->name = "opNode.new(_,_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj8278, self, 0);
  addmethodreal(obj8278,"outer", &reader_ast_outer_8279);
  Object oldself8278 = self;
  struct StackFrameObject *oldstackframe8278 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8278);
  gc_frame_newslot((Object)stackframe);
  self = obj8278;
  Object *oldselfslot8278 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8278 = (*(struct UserObject *)self).data[0], lowerouter8278 = thisouter8278;
  if (inheritingObject8278) {
    struct UserObject *inho8278 = (struct UserObject *)inheritingObject8278;
    while (inho8278->super != GraceDefaultObject) inho8278 = (struct UserObject *)inho8278->super;
    inho8278->super = obj8278;
    self = inheritingObject8278;
    *selfslot = self;
    lowerouter8278 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8278;
  }
  if (objclass8278 == NULL) {
  Method *reader8280 = addmethodrealflags(obj8278, "kind",&reader_ast_kind_8280, MFLAG_DEF);
  reader8280->definitionModule = modulename;
  reader8280->definitionLine = 2192;
  }
  adddatum2(obj8278, alloc_Undefined(), 1);
  if (objclass8278 == NULL) {
  Method *reader8281 = addmethodrealflags(obj8278, "value",&reader_ast_value_8281, MFLAG_DEF);
  reader8281->definitionModule = modulename;
  reader8281->definitionLine = 2193;
  }
  adddatum2(obj8278, alloc_Undefined(), 2);
  if (objclass8278 == NULL) {
    Method *reader8282 = addmethodrealflags(obj8278, "left", &reader_ast_left_8282, 0);
    Method *writer8282 = addmethodrealflags(obj8278, "left:=(1)", &writer_ast_left_8282, 0);
    reader8282->definitionModule = modulename;
    writer8282->definitionModule = modulename;
    reader8282->definitionLine = 2194;
    writer8282->definitionLine = 2194;
  }
  obj8278->flags |= OFLAG_MUTABLE;
  adddatum2(obj8278, alloc_Undefined(), 3);
  if (objclass8278 == NULL) {
    Method *reader8283 = addmethodrealflags(obj8278, "right", &reader_ast_right_8283, 0);
    Method *writer8283 = addmethodrealflags(obj8278, "right:=(1)", &writer_ast_right_8283, 0);
    reader8283->definitionModule = modulename;
    writer8283->definitionModule = modulename;
    reader8283->definitionLine = 2195;
    writer8283->definitionLine = 2195;
  }
  obj8278->flags |= OFLAG_MUTABLE;
  adddatum2(obj8278, alloc_Undefined(), 4);
  if (objclass8278 == NULL) {
    Method *reader8284 = addmethodrealflags(obj8278, "isTailCall", &reader_ast_isTailCall_8284, 0);
    Method *writer8284 = addmethodrealflags(obj8278, "isTailCall:=(1)", &writer_ast_isTailCall_8284, 0);
    reader8284->definitionModule = modulename;
    writer8284->definitionModule = modulename;
    reader8284->definitionLine = 2196;
    writer8284->definitionLine = 2196;
  }
  obj8278->flags |= OFLAG_MUTABLE;
  adddatum2(obj8278, alloc_Undefined(), 5);
  if (objclass8278 == NULL) {
    Method *reader8285 = addmethodrealflags(obj8278, "isSelfRequest", &reader_ast_isSelfRequest_8285, 0);
    Method *writer8285 = addmethodrealflags(obj8278, "isSelfRequest:=(1)", &writer_ast_isSelfRequest_8285, 0);
    reader8285->definitionModule = modulename;
    writer8285->definitionModule = modulename;
    reader8285->definitionLine = 2197;
    writer8285->definitionLine = 2197;
  }
  obj8278->flags |= OFLAG_MUTABLE;
  adddatum2(obj8278, alloc_Undefined(), 6);
// method "start"
  struct UserObject *uo8286 = (struct UserObject*)obj8278;
  uo8286->data[7] = emptyclosure;
  Method *meth_meth_ast_8286_start = addmethod2pos(obj8278, "start", &meth_ast_8286_start, 7);
  int argcv_meth_ast_8286_start[] = {0};
  meth_meth_ast_8286_start->type = alloc_MethodType(1, argcv_meth_ast_8286_start);
  meth_meth_ast_8286_start->definitionModule = modulename;
  meth_meth_ast_8286_start->definitionLine = 2199;
// method "end"
  struct UserObject *uo8291 = (struct UserObject*)obj8278;
  uo8291->data[8] = emptyclosure;
  Method *meth_meth_ast_8291_end = addmethod2pos(obj8278, "end", &meth_ast_8291_end, 8);
  int argcv_meth_ast_8291_end[] = {0};
  meth_meth_ast_8291_end->type = alloc_MethodType(1, argcv_meth_ast_8291_end);
  meth_meth_ast_8291_end->definitionModule = modulename;
  meth_meth_ast_8291_end->definitionLine = 2200;
// method "onSelf"
  struct UserObject *uo8296 = (struct UserObject*)obj8278;
  uo8296->data[9] = emptyclosure;
  Method *meth_meth_ast_8296_onSelf = addmethod2pos(obj8278, "onSelf", &meth_ast_8296_onSelf, 9);
  int argcv_meth_ast_8296_onSelf[] = {0};
  meth_meth_ast_8296_onSelf->type = alloc_MethodType(1, argcv_meth_ast_8296_onSelf);
  meth_meth_ast_8296_onSelf->definitionModule = modulename;
  meth_meth_ast_8296_onSelf->definitionLine = 2201;
// method "opPos"
  struct UserObject *uo8300 = (struct UserObject*)obj8278;
  uo8300->data[10] = emptyclosure;
  Method *meth_meth_ast_8300_opPos = addmethod2pos(obj8278, "opPos", &meth_ast_8300_opPos, 10);
  int argcv_meth_ast_8300_opPos[] = {0};
  meth_meth_ast_8300_opPos->type = alloc_MethodType(1, argcv_meth_ast_8300_opPos);
  meth_meth_ast_8300_opPos->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_8300_opPos->definitionModule = modulename;
  meth_meth_ast_8300_opPos->definitionLine = 2205;
// method "isSimple"
  struct UserObject *uo8309 = (struct UserObject*)obj8278;
  uo8309->data[11] = emptyclosure;
  Method *meth_meth_ast_8309_isSimple = addmethod2pos(obj8278, "isSimple", &meth_ast_8309_isSimple, 11);
  int argcv_meth_ast_8309_isSimple[] = {0};
  meth_meth_ast_8309_isSimple->type = alloc_MethodType(1, argcv_meth_ast_8309_isSimple);
  meth_meth_ast_8309_isSimple->definitionModule = modulename;
  meth_meth_ast_8309_isSimple->definitionLine = 2209;
// method "nameString"
  struct UserObject *uo8311 = (struct UserObject*)obj8278;
  uo8311->data[12] = emptyclosure;
  Method *meth_meth_ast_8311_nameString = addmethod2pos(obj8278, "nameString", &meth_ast_8311_nameString, 12);
  int argcv_meth_ast_8311_nameString[] = {0};
  meth_meth_ast_8311_nameString->type = alloc_MethodType(1, argcv_meth_ast_8311_nameString);
  meth_meth_ast_8311_nameString->definitionModule = modulename;
  meth_meth_ast_8311_nameString->definitionLine = 2210;
// method "canonicalName"
  struct UserObject *uo8318 = (struct UserObject*)obj8278;
  uo8318->data[13] = emptyclosure;
  Method *meth_meth_ast_8318_canonicalName = addmethod2pos(obj8278, "canonicalName", &meth_ast_8318_canonicalName, 13);
  int argcv_meth_ast_8318_canonicalName[] = {0};
  meth_meth_ast_8318_canonicalName->type = alloc_MethodType(1, argcv_meth_ast_8318_canonicalName);
  meth_meth_ast_8318_canonicalName->definitionModule = modulename;
  meth_meth_ast_8318_canonicalName->definitionLine = 2211;
// method "receiver"
  struct UserObject *uo8325 = (struct UserObject*)obj8278;
  uo8325->data[14] = emptyclosure;
  Method *meth_meth_ast_8325_receiver = addmethod2pos(obj8278, "receiver", &meth_ast_8325_receiver, 14);
  int argcv_meth_ast_8325_receiver[] = {0};
  meth_meth_ast_8325_receiver->type = alloc_MethodType(1, argcv_meth_ast_8325_receiver);
  meth_meth_ast_8325_receiver->definitionModule = modulename;
  meth_meth_ast_8325_receiver->definitionLine = 2212;
// method "isCall"
  struct UserObject *uo8328 = (struct UserObject*)obj8278;
  uo8328->data[15] = emptyclosure;
  Method *meth_meth_ast_8328_isCall = addmethod2pos(obj8278, "isCall", &meth_ast_8328_isCall, 15);
  int argcv_meth_ast_8328_isCall[] = {0};
  meth_meth_ast_8328_isCall->type = alloc_MethodType(1, argcv_meth_ast_8328_isCall);
  meth_meth_ast_8328_isCall->definitionModule = modulename;
  meth_meth_ast_8328_isCall->definitionLine = 2213;
// method "parts"
  block_savedest(obj8278);
  Object closure8330 = createclosure(1, "parts");
  setclosureframe(closure8330, stackframe);
  addtoclosure(closure8330, var_requestPart);
  struct UserObject *uo8330 = (struct UserObject*)obj8278;
  uo8330->data[16] = (Object)closure8330;
  Method *meth_meth_ast_8330_parts = addmethod2pos(obj8278, "parts", &meth_ast_8330_parts, 16);
  int argcv_meth_ast_8330_parts[] = {0};
  meth_meth_ast_8330_parts->type = alloc_MethodType(1, argcv_meth_ast_8330_parts);
  meth_meth_ast_8330_parts->definitionModule = modulename;
  meth_meth_ast_8330_parts->definitionLine = 2215;
// method "arguments"
  struct UserObject *uo8345 = (struct UserObject*)obj8278;
  uo8345->data[17] = emptyclosure;
  Method *meth_meth_ast_8345_arguments = addmethod2pos(obj8278, "arguments", &meth_ast_8345_arguments, 17);
  int argcv_meth_ast_8345_arguments[] = {0};
  meth_meth_ast_8345_arguments->type = alloc_MethodType(1, argcv_meth_ast_8345_arguments);
  meth_meth_ast_8345_arguments->definitionModule = modulename;
  meth_meth_ast_8345_arguments->definitionLine = 2216;
// method "argumentsDo(_)"
  struct UserObject *uo8349 = (struct UserObject*)obj8278;
  uo8349->data[18] = emptyclosure;
  Method *meth_meth_ast_8349_argumentsDo_40_1_41_ = addmethod2pos(obj8278, "argumentsDo(1)", &meth_ast_8349_argumentsDo_40_1_41_, 18);
  int argcv_meth_ast_8349_argumentsDo_40_1_41_[] = {1};
  meth_meth_ast_8349_argumentsDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8349_argumentsDo_40_1_41_);
  meth_meth_ast_8349_argumentsDo_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8349_argumentsDo_40_1_41_->definitionLine = 2217;
// method "numArgs"
  struct UserObject *uo8354 = (struct UserObject*)obj8278;
  uo8354->data[19] = emptyclosure;
  Method *meth_meth_ast_8354_numArgs = addmethod2pos(obj8278, "numArgs", &meth_ast_8354_numArgs, 19);
  int argcv_meth_ast_8354_numArgs[] = {0};
  meth_meth_ast_8354_numArgs->type = alloc_MethodType(1, argcv_meth_ast_8354_numArgs);
  meth_meth_ast_8354_numArgs->definitionModule = modulename;
  meth_meth_ast_8354_numArgs->definitionLine = 2218;
// method "numTypeArgs"
  struct UserObject *uo8356 = (struct UserObject*)obj8278;
  uo8356->data[20] = emptyclosure;
  Method *meth_meth_ast_8356_numTypeArgs = addmethod2pos(obj8278, "numTypeArgs", &meth_ast_8356_numTypeArgs, 20);
  int argcv_meth_ast_8356_numTypeArgs[] = {0};
  meth_meth_ast_8356_numTypeArgs->type = alloc_MethodType(1, argcv_meth_ast_8356_numTypeArgs);
  meth_meth_ast_8356_numTypeArgs->definitionModule = modulename;
  meth_meth_ast_8356_numTypeArgs->definitionLine = 2219;
// method "accept(_)from(_)"
  struct UserObject *uo8358 = (struct UserObject*)obj8278;
  uo8358->data[21] = emptyclosure;
  Method *meth_meth_ast_8358_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj8278, "accept(1)from(1)", &meth_ast_8358_accept_40_1_41_from_40_1_41_, 21);
  int argcv_meth_ast_8358_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_8358_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_8358_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_8358_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8358_accept_40_1_41_from_40_1_41_->definitionLine = 2221;
// method "map(_)ancestors(_)"
  struct UserObject *uo8372 = (struct UserObject*)obj8278;
  uo8372->data[22] = emptyclosure;
  Method *meth_meth_ast_8372_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj8278, "map(1)ancestors(1)", &meth_ast_8372_map_40_1_41_ancestors_40_1_41_, 22);
  int argcv_meth_ast_8372_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_8372_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_8372_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_8372_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8372_map_40_1_41_ancestors_40_1_41_->definitionLine = 2228;
// method "pretty(_)"
  struct UserObject *uo8391 = (struct UserObject*)obj8278;
  uo8391->data[23] = emptyclosure;
  Method *meth_meth_ast_8391_pretty_40_1_41_ = addmethod2pos(obj8278, "pretty(1)", &meth_ast_8391_pretty_40_1_41_, 23);
  int argcv_meth_ast_8391_pretty_40_1_41_[] = {1};
  meth_meth_ast_8391_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8391_pretty_40_1_41_);
  meth_meth_ast_8391_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8391_pretty_40_1_41_->definitionLine = 2235;
// method "toGrace(_)"
  struct UserObject *uo8459 = (struct UserObject*)obj8278;
  uo8459->data[24] = emptyclosure;
  Method *meth_meth_ast_8459_toGrace_40_1_41_ = addmethod2pos(obj8278, "toGrace(1)", &meth_ast_8459_toGrace_40_1_41_, 24);
  int argcv_meth_ast_8459_toGrace_40_1_41_[] = {1};
  meth_meth_ast_8459_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8459_toGrace_40_1_41_);
meth_meth_ast_8459_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_8459_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_8459_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8459_toGrace_40_1_41_->definitionLine = 2244;
// method "asIdentifier"
  block_savedest(obj8278);
  Object closure8582 = createclosure(1, "asIdentifier");
  setclosureframe(closure8582, stackframe);
  addtoclosure(closure8582, var_identifierNode);
  struct UserObject *uo8582 = (struct UserObject*)obj8278;
  uo8582->data[25] = (Object)closure8582;
  Method *meth_meth_ast_8582_asIdentifier = addmethod2pos(obj8278, "asIdentifier", &meth_ast_8582_asIdentifier, 25);
  int argcv_meth_ast_8582_asIdentifier[] = {0};
  meth_meth_ast_8582_asIdentifier->type = alloc_MethodType(1, argcv_meth_ast_8582_asIdentifier);
  meth_meth_ast_8582_asIdentifier->definitionModule = modulename;
  meth_meth_ast_8582_asIdentifier->definitionLine = 2263;
// method "shallowCopy"
  block_savedest(obj8278);
  Object closure8601 = createclosure(2, "shallowCopy");
  setclosureframe(closure8601, stackframe);
  addtoclosure(closure8601, var_nullNode);
  addtoclosure(closure8601, var_opNode);
  struct UserObject *uo8601 = (struct UserObject*)obj8278;
  uo8601->data[26] = (Object)closure8601;
  Method *meth_meth_ast_8601_shallowCopy = addmethod2pos(obj8278, "shallowCopy", &meth_ast_8601_shallowCopy, 26);
  int argcv_meth_ast_8601_shallowCopy[] = {0};
  meth_meth_ast_8601_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_8601_shallowCopy);
  meth_meth_ast_8601_shallowCopy->definitionModule = modulename;
  meth_meth_ast_8601_shallowCopy->definitionLine = 2271;
// method "postCopy(_)"
  struct UserObject *uo8608 = (struct UserObject*)obj8278;
  uo8608->data[27] = emptyclosure;
  Method *meth_meth_ast_8608_postCopy_40_1_41_ = addmethod2pos(obj8278, "postCopy(1)", &meth_ast_8608_postCopy_40_1_41_, 27);
  int argcv_meth_ast_8608_postCopy_40_1_41_[] = {1};
  meth_meth_ast_8608_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8608_postCopy_40_1_41_);
  meth_meth_ast_8608_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8608_postCopy_40_1_41_->definitionLine = 2274;
  sourceObject = obj8278;
// Begin line 2191
  setline(2191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8617 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8618 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8617);
// compiled call node returning call8618 (depth = 3)
  struct UserObject *obj8278_uo = (struct UserObject *)obj8278;
  obj8278_uo->super = call8618;
  sourceObject = obj8278;
// Begin line 2192
  setline(2192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8619 == NULL) {
    strlit8619 = alloc_String("op");
    gc_root(strlit8619);
  }
// compiled string node returning strlit8619 (depth = 3)
  adddatum2(obj8278, strlit8619, 1);
  sourceObject = obj8278;
// Begin line 2193
  setline(2193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_op (depth = 3)
  adddatum2(obj8278, *var_op, 2);
  sourceObject = obj8278;
// Begin line 2194
  setline(2194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  adddatum2(obj8278, *var_l, 3);
  sourceObject = obj8278;
// Begin line 2195
  setline(2195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_r (depth = 3)
  adddatum2(obj8278, *var_r, 4);
  sourceObject = obj8278;
// Begin line 2196
  setline(2196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8620 = alloc_Boolean(0);
// compiled identifier node returning bool8620 (depth = 3)
  adddatum2(obj8278, bool8620, 5);
  sourceObject = obj8278;
// Begin line 2197
  setline(2197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8621 = alloc_Boolean(0);
// compiled identifier node returning bool8621 (depth = 3)
  adddatum2(obj8278, bool8621, 6);
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  objclass8278 = obj8278->class;
  objclass8278->definitionModule = modulename;
  objclass8278->definitionLine = 2190;
  (*(struct UserObject *)self).data[0] = lowerouter8278;
  self = oldself8278;
  selfslot = oldselfslot8278;
  stackframe = oldstackframe8278;
  gc_frame_end(frame);
  return obj8278;
}
Object meth_ast_8277_new_40_3_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_requestPart = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_nullNode = getfromclosure(closure, 2);
  Object *var_opNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_op = &(stackframe->slots[0]);
  *var_op = args[curarg];
  curarg++;
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[2]);
  *var_r = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8278 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8278 = alloc_userobj2(31,28, objclass8278);
  gc_frame_newslot(obj8278);
  if (objclass8278 == NULL) {
    glfree(obj8278->class->name);
    obj8278->class->name = "opNode.new(_,_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj8278, self, 0);
  addmethodreal(obj8278,"outer", &reader_ast_outer_8279);
  Object oldself8278 = self;
  struct StackFrameObject *oldstackframe8278 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8278);
  gc_frame_newslot((Object)stackframe);
  self = obj8278;
  Object *oldselfslot8278 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8278 = (*(struct UserObject *)self).data[0], lowerouter8278 = thisouter8278;
  if (inheritingObject8278) {
    struct UserObject *inho8278 = (struct UserObject *)inheritingObject8278;
    while (inho8278->super != GraceDefaultObject) inho8278 = (struct UserObject *)inho8278->super;
    inho8278->super = obj8278;
    self = inheritingObject8278;
    *selfslot = self;
    lowerouter8278 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8278;
  }
  if (objclass8278 == NULL) {
  Method *reader8280 = addmethodrealflags(obj8278, "kind",&reader_ast_kind_8280, MFLAG_DEF);
  reader8280->definitionModule = modulename;
  reader8280->definitionLine = 2192;
  }
  adddatum2(obj8278, alloc_Undefined(), 1);
  if (objclass8278 == NULL) {
  Method *reader8281 = addmethodrealflags(obj8278, "value",&reader_ast_value_8281, MFLAG_DEF);
  reader8281->definitionModule = modulename;
  reader8281->definitionLine = 2193;
  }
  adddatum2(obj8278, alloc_Undefined(), 2);
  if (objclass8278 == NULL) {
    Method *reader8282 = addmethodrealflags(obj8278, "left", &reader_ast_left_8282, 0);
    Method *writer8282 = addmethodrealflags(obj8278, "left:=(1)", &writer_ast_left_8282, 0);
    reader8282->definitionModule = modulename;
    writer8282->definitionModule = modulename;
    reader8282->definitionLine = 2194;
    writer8282->definitionLine = 2194;
  }
  obj8278->flags |= OFLAG_MUTABLE;
  adddatum2(obj8278, alloc_Undefined(), 3);
  if (objclass8278 == NULL) {
    Method *reader8283 = addmethodrealflags(obj8278, "right", &reader_ast_right_8283, 0);
    Method *writer8283 = addmethodrealflags(obj8278, "right:=(1)", &writer_ast_right_8283, 0);
    reader8283->definitionModule = modulename;
    writer8283->definitionModule = modulename;
    reader8283->definitionLine = 2195;
    writer8283->definitionLine = 2195;
  }
  obj8278->flags |= OFLAG_MUTABLE;
  adddatum2(obj8278, alloc_Undefined(), 4);
  if (objclass8278 == NULL) {
    Method *reader8284 = addmethodrealflags(obj8278, "isTailCall", &reader_ast_isTailCall_8284, 0);
    Method *writer8284 = addmethodrealflags(obj8278, "isTailCall:=(1)", &writer_ast_isTailCall_8284, 0);
    reader8284->definitionModule = modulename;
    writer8284->definitionModule = modulename;
    reader8284->definitionLine = 2196;
    writer8284->definitionLine = 2196;
  }
  obj8278->flags |= OFLAG_MUTABLE;
  adddatum2(obj8278, alloc_Undefined(), 5);
  if (objclass8278 == NULL) {
    Method *reader8285 = addmethodrealflags(obj8278, "isSelfRequest", &reader_ast_isSelfRequest_8285, 0);
    Method *writer8285 = addmethodrealflags(obj8278, "isSelfRequest:=(1)", &writer_ast_isSelfRequest_8285, 0);
    reader8285->definitionModule = modulename;
    writer8285->definitionModule = modulename;
    reader8285->definitionLine = 2197;
    writer8285->definitionLine = 2197;
  }
  obj8278->flags |= OFLAG_MUTABLE;
  adddatum2(obj8278, alloc_Undefined(), 6);
// method "start"
  struct UserObject *uo8286 = (struct UserObject*)obj8278;
  uo8286->data[7] = emptyclosure;
  Method *meth_meth_ast_8286_start = addmethod2pos(obj8278, "start", &meth_ast_8286_start, 7);
  int argcv_meth_ast_8286_start[] = {0};
  meth_meth_ast_8286_start->type = alloc_MethodType(1, argcv_meth_ast_8286_start);
  meth_meth_ast_8286_start->definitionModule = modulename;
  meth_meth_ast_8286_start->definitionLine = 2199;
// method "end"
  struct UserObject *uo8291 = (struct UserObject*)obj8278;
  uo8291->data[8] = emptyclosure;
  Method *meth_meth_ast_8291_end = addmethod2pos(obj8278, "end", &meth_ast_8291_end, 8);
  int argcv_meth_ast_8291_end[] = {0};
  meth_meth_ast_8291_end->type = alloc_MethodType(1, argcv_meth_ast_8291_end);
  meth_meth_ast_8291_end->definitionModule = modulename;
  meth_meth_ast_8291_end->definitionLine = 2200;
// method "onSelf"
  struct UserObject *uo8296 = (struct UserObject*)obj8278;
  uo8296->data[9] = emptyclosure;
  Method *meth_meth_ast_8296_onSelf = addmethod2pos(obj8278, "onSelf", &meth_ast_8296_onSelf, 9);
  int argcv_meth_ast_8296_onSelf[] = {0};
  meth_meth_ast_8296_onSelf->type = alloc_MethodType(1, argcv_meth_ast_8296_onSelf);
  meth_meth_ast_8296_onSelf->definitionModule = modulename;
  meth_meth_ast_8296_onSelf->definitionLine = 2201;
// method "opPos"
  struct UserObject *uo8300 = (struct UserObject*)obj8278;
  uo8300->data[10] = emptyclosure;
  Method *meth_meth_ast_8300_opPos = addmethod2pos(obj8278, "opPos", &meth_ast_8300_opPos, 10);
  int argcv_meth_ast_8300_opPos[] = {0};
  meth_meth_ast_8300_opPos->type = alloc_MethodType(1, argcv_meth_ast_8300_opPos);
  meth_meth_ast_8300_opPos->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_8300_opPos->definitionModule = modulename;
  meth_meth_ast_8300_opPos->definitionLine = 2205;
// method "isSimple"
  struct UserObject *uo8309 = (struct UserObject*)obj8278;
  uo8309->data[11] = emptyclosure;
  Method *meth_meth_ast_8309_isSimple = addmethod2pos(obj8278, "isSimple", &meth_ast_8309_isSimple, 11);
  int argcv_meth_ast_8309_isSimple[] = {0};
  meth_meth_ast_8309_isSimple->type = alloc_MethodType(1, argcv_meth_ast_8309_isSimple);
  meth_meth_ast_8309_isSimple->definitionModule = modulename;
  meth_meth_ast_8309_isSimple->definitionLine = 2209;
// method "nameString"
  struct UserObject *uo8311 = (struct UserObject*)obj8278;
  uo8311->data[12] = emptyclosure;
  Method *meth_meth_ast_8311_nameString = addmethod2pos(obj8278, "nameString", &meth_ast_8311_nameString, 12);
  int argcv_meth_ast_8311_nameString[] = {0};
  meth_meth_ast_8311_nameString->type = alloc_MethodType(1, argcv_meth_ast_8311_nameString);
  meth_meth_ast_8311_nameString->definitionModule = modulename;
  meth_meth_ast_8311_nameString->definitionLine = 2210;
// method "canonicalName"
  struct UserObject *uo8318 = (struct UserObject*)obj8278;
  uo8318->data[13] = emptyclosure;
  Method *meth_meth_ast_8318_canonicalName = addmethod2pos(obj8278, "canonicalName", &meth_ast_8318_canonicalName, 13);
  int argcv_meth_ast_8318_canonicalName[] = {0};
  meth_meth_ast_8318_canonicalName->type = alloc_MethodType(1, argcv_meth_ast_8318_canonicalName);
  meth_meth_ast_8318_canonicalName->definitionModule = modulename;
  meth_meth_ast_8318_canonicalName->definitionLine = 2211;
// method "receiver"
  struct UserObject *uo8325 = (struct UserObject*)obj8278;
  uo8325->data[14] = emptyclosure;
  Method *meth_meth_ast_8325_receiver = addmethod2pos(obj8278, "receiver", &meth_ast_8325_receiver, 14);
  int argcv_meth_ast_8325_receiver[] = {0};
  meth_meth_ast_8325_receiver->type = alloc_MethodType(1, argcv_meth_ast_8325_receiver);
  meth_meth_ast_8325_receiver->definitionModule = modulename;
  meth_meth_ast_8325_receiver->definitionLine = 2212;
// method "isCall"
  struct UserObject *uo8328 = (struct UserObject*)obj8278;
  uo8328->data[15] = emptyclosure;
  Method *meth_meth_ast_8328_isCall = addmethod2pos(obj8278, "isCall", &meth_ast_8328_isCall, 15);
  int argcv_meth_ast_8328_isCall[] = {0};
  meth_meth_ast_8328_isCall->type = alloc_MethodType(1, argcv_meth_ast_8328_isCall);
  meth_meth_ast_8328_isCall->definitionModule = modulename;
  meth_meth_ast_8328_isCall->definitionLine = 2213;
// method "parts"
  block_savedest(obj8278);
  Object closure8330 = createclosure(1, "parts");
  setclosureframe(closure8330, stackframe);
  addtoclosure(closure8330, var_requestPart);
  struct UserObject *uo8330 = (struct UserObject*)obj8278;
  uo8330->data[16] = (Object)closure8330;
  Method *meth_meth_ast_8330_parts = addmethod2pos(obj8278, "parts", &meth_ast_8330_parts, 16);
  int argcv_meth_ast_8330_parts[] = {0};
  meth_meth_ast_8330_parts->type = alloc_MethodType(1, argcv_meth_ast_8330_parts);
  meth_meth_ast_8330_parts->definitionModule = modulename;
  meth_meth_ast_8330_parts->definitionLine = 2215;
// method "arguments"
  struct UserObject *uo8345 = (struct UserObject*)obj8278;
  uo8345->data[17] = emptyclosure;
  Method *meth_meth_ast_8345_arguments = addmethod2pos(obj8278, "arguments", &meth_ast_8345_arguments, 17);
  int argcv_meth_ast_8345_arguments[] = {0};
  meth_meth_ast_8345_arguments->type = alloc_MethodType(1, argcv_meth_ast_8345_arguments);
  meth_meth_ast_8345_arguments->definitionModule = modulename;
  meth_meth_ast_8345_arguments->definitionLine = 2216;
// method "argumentsDo(_)"
  struct UserObject *uo8349 = (struct UserObject*)obj8278;
  uo8349->data[18] = emptyclosure;
  Method *meth_meth_ast_8349_argumentsDo_40_1_41_ = addmethod2pos(obj8278, "argumentsDo(1)", &meth_ast_8349_argumentsDo_40_1_41_, 18);
  int argcv_meth_ast_8349_argumentsDo_40_1_41_[] = {1};
  meth_meth_ast_8349_argumentsDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8349_argumentsDo_40_1_41_);
  meth_meth_ast_8349_argumentsDo_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8349_argumentsDo_40_1_41_->definitionLine = 2217;
// method "numArgs"
  struct UserObject *uo8354 = (struct UserObject*)obj8278;
  uo8354->data[19] = emptyclosure;
  Method *meth_meth_ast_8354_numArgs = addmethod2pos(obj8278, "numArgs", &meth_ast_8354_numArgs, 19);
  int argcv_meth_ast_8354_numArgs[] = {0};
  meth_meth_ast_8354_numArgs->type = alloc_MethodType(1, argcv_meth_ast_8354_numArgs);
  meth_meth_ast_8354_numArgs->definitionModule = modulename;
  meth_meth_ast_8354_numArgs->definitionLine = 2218;
// method "numTypeArgs"
  struct UserObject *uo8356 = (struct UserObject*)obj8278;
  uo8356->data[20] = emptyclosure;
  Method *meth_meth_ast_8356_numTypeArgs = addmethod2pos(obj8278, "numTypeArgs", &meth_ast_8356_numTypeArgs, 20);
  int argcv_meth_ast_8356_numTypeArgs[] = {0};
  meth_meth_ast_8356_numTypeArgs->type = alloc_MethodType(1, argcv_meth_ast_8356_numTypeArgs);
  meth_meth_ast_8356_numTypeArgs->definitionModule = modulename;
  meth_meth_ast_8356_numTypeArgs->definitionLine = 2219;
// method "accept(_)from(_)"
  struct UserObject *uo8358 = (struct UserObject*)obj8278;
  uo8358->data[21] = emptyclosure;
  Method *meth_meth_ast_8358_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj8278, "accept(1)from(1)", &meth_ast_8358_accept_40_1_41_from_40_1_41_, 21);
  int argcv_meth_ast_8358_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_8358_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_8358_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_8358_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8358_accept_40_1_41_from_40_1_41_->definitionLine = 2221;
// method "map(_)ancestors(_)"
  struct UserObject *uo8372 = (struct UserObject*)obj8278;
  uo8372->data[22] = emptyclosure;
  Method *meth_meth_ast_8372_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj8278, "map(1)ancestors(1)", &meth_ast_8372_map_40_1_41_ancestors_40_1_41_, 22);
  int argcv_meth_ast_8372_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_8372_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_8372_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_8372_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8372_map_40_1_41_ancestors_40_1_41_->definitionLine = 2228;
// method "pretty(_)"
  struct UserObject *uo8391 = (struct UserObject*)obj8278;
  uo8391->data[23] = emptyclosure;
  Method *meth_meth_ast_8391_pretty_40_1_41_ = addmethod2pos(obj8278, "pretty(1)", &meth_ast_8391_pretty_40_1_41_, 23);
  int argcv_meth_ast_8391_pretty_40_1_41_[] = {1};
  meth_meth_ast_8391_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8391_pretty_40_1_41_);
  meth_meth_ast_8391_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8391_pretty_40_1_41_->definitionLine = 2235;
// method "toGrace(_)"
  struct UserObject *uo8459 = (struct UserObject*)obj8278;
  uo8459->data[24] = emptyclosure;
  Method *meth_meth_ast_8459_toGrace_40_1_41_ = addmethod2pos(obj8278, "toGrace(1)", &meth_ast_8459_toGrace_40_1_41_, 24);
  int argcv_meth_ast_8459_toGrace_40_1_41_[] = {1};
  meth_meth_ast_8459_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8459_toGrace_40_1_41_);
meth_meth_ast_8459_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_8459_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_8459_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8459_toGrace_40_1_41_->definitionLine = 2244;
// method "asIdentifier"
  block_savedest(obj8278);
  Object closure8582 = createclosure(1, "asIdentifier");
  setclosureframe(closure8582, stackframe);
  addtoclosure(closure8582, var_identifierNode);
  struct UserObject *uo8582 = (struct UserObject*)obj8278;
  uo8582->data[25] = (Object)closure8582;
  Method *meth_meth_ast_8582_asIdentifier = addmethod2pos(obj8278, "asIdentifier", &meth_ast_8582_asIdentifier, 25);
  int argcv_meth_ast_8582_asIdentifier[] = {0};
  meth_meth_ast_8582_asIdentifier->type = alloc_MethodType(1, argcv_meth_ast_8582_asIdentifier);
  meth_meth_ast_8582_asIdentifier->definitionModule = modulename;
  meth_meth_ast_8582_asIdentifier->definitionLine = 2263;
// method "shallowCopy"
  block_savedest(obj8278);
  Object closure8601 = createclosure(2, "shallowCopy");
  setclosureframe(closure8601, stackframe);
  addtoclosure(closure8601, var_nullNode);
  addtoclosure(closure8601, var_opNode);
  struct UserObject *uo8601 = (struct UserObject*)obj8278;
  uo8601->data[26] = (Object)closure8601;
  Method *meth_meth_ast_8601_shallowCopy = addmethod2pos(obj8278, "shallowCopy", &meth_ast_8601_shallowCopy, 26);
  int argcv_meth_ast_8601_shallowCopy[] = {0};
  meth_meth_ast_8601_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_8601_shallowCopy);
  meth_meth_ast_8601_shallowCopy->definitionModule = modulename;
  meth_meth_ast_8601_shallowCopy->definitionLine = 2271;
// method "postCopy(_)"
  struct UserObject *uo8608 = (struct UserObject*)obj8278;
  uo8608->data[27] = emptyclosure;
  Method *meth_meth_ast_8608_postCopy_40_1_41_ = addmethod2pos(obj8278, "postCopy(1)", &meth_ast_8608_postCopy_40_1_41_, 27);
  int argcv_meth_ast_8608_postCopy_40_1_41_[] = {1};
  meth_meth_ast_8608_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8608_postCopy_40_1_41_);
  meth_meth_ast_8608_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8608_postCopy_40_1_41_->definitionLine = 2274;
  sourceObject = obj8278;
// Begin line 2191
  setline(2191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8617 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8618 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8617);
// compiled call node returning call8618 (depth = 3)
  struct UserObject *obj8278_uo = (struct UserObject *)obj8278;
  obj8278_uo->super = call8618;
  sourceObject = obj8278;
// Begin line 2192
  setline(2192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8619 == NULL) {
    strlit8619 = alloc_String("op");
    gc_root(strlit8619);
  }
// compiled string node returning strlit8619 (depth = 3)
  adddatum2(obj8278, strlit8619, 1);
  sourceObject = obj8278;
// Begin line 2193
  setline(2193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_op (depth = 3)
  adddatum2(obj8278, *var_op, 2);
  sourceObject = obj8278;
// Begin line 2194
  setline(2194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  adddatum2(obj8278, *var_l, 3);
  sourceObject = obj8278;
// Begin line 2195
  setline(2195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_r (depth = 3)
  adddatum2(obj8278, *var_r, 4);
  sourceObject = obj8278;
// Begin line 2196
  setline(2196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8620 = alloc_Boolean(0);
// compiled identifier node returning bool8620 (depth = 3)
  adddatum2(obj8278, bool8620, 5);
  sourceObject = obj8278;
// Begin line 2197
  setline(2197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8621 = alloc_Boolean(0);
// compiled identifier node returning bool8621 (depth = 3)
  adddatum2(obj8278, bool8621, 6);
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  sourceObject = obj8278;
  objclass8278 = obj8278->class;
  objclass8278->definitionModule = modulename;
  objclass8278->definitionLine = 2190;
  (*(struct UserObject *)self).data[0] = lowerouter8278;
  self = oldself8278;
  selfslot = oldselfslot8278;
  stackframe = oldstackframe8278;
  gc_frame_end(frame);
  return obj8278;
}
Object meth_ast_8623_opNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 48, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "opNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_opNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2189
  setline(2189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_opNode (depth = 3)
  gc_frame_end(frame);
  return *var_opNode;
}
Object meth_ast_8632_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2289
  setline(2289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8633 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8634 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8635 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8634);
// compiled member node returning call8635 (depth = 4)
  partcv[0] = 0;
  Object call8636 = callmethodflags(call8635, "end", 1, partcv, params, 0);
  gc_frame_end(callframe8633);
// compiled member node returning call8636 (depth = 3)
  gc_frame_end(frame);
  return call8636;
}
Object meth_ast_8637_nameString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2290
  setline(2290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8639 == NULL) {
    strlit8639 = alloc_String(":=(1)");
    gc_root(strlit8639);
  }
// compiled string node returning strlit8639 (depth = 4)
  int op_slot_right_8638 = gc_frame_newslot(strlit8639);
// starting to compile member node (depth = 4)
  int callframe8641 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8642 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8641);
// compiled member node returning call8642 (depth = 4)
  int op_slot_left_8638 = gc_frame_newslot(call8642);
  params[0] = strlit8639;
  partcv[0] = 1;
  Object opresult8643 = callmethod(call8642, "++(1)", 1, partcv, params);
// compiled op node returning opresult8643 (depth = 3)
  gc_frame_end(frame);
  return opresult8643;
}
Object meth_ast_8644_canonicalName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canonicalName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2291
  setline(2291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8646 == NULL) {
    strlit8646 = alloc_String(":=(_)");
    gc_root(strlit8646);
  }
// compiled string node returning strlit8646 (depth = 4)
  int op_slot_right_8645 = gc_frame_newslot(strlit8646);
// starting to compile member node (depth = 4)
  int callframe8648 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8649 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8648);
// compiled member node returning call8649 (depth = 4)
  int op_slot_left_8645 = gc_frame_newslot(call8649);
  params[0] = strlit8646;
  partcv[0] = 1;
  Object opresult8650 = callmethod(call8649, "++(1)", 1, partcv, params);
// compiled op node returning opresult8650 (depth = 3)
  gc_frame_end(frame);
  return opresult8650;
}
Object meth_ast_8651_isBind(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isBind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2292
  setline(2292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8652 = alloc_Boolean(1);
// compiled identifier node returning bool8652 (depth = 3)
  gc_frame_end(frame);
  return bool8652;
}
Object meth_ast_8653_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2293
  setline(2293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8655 == NULL) {
    strlit8655 = alloc_String("");
    gc_root(strlit8655);
  }
// compiled string node returning strlit8655 (depth = 4)
  int op_slot_right_8654 = gc_frame_newslot(strlit8655);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8658 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8659 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8658);
// compiled member node returning call8659 (depth = 5)
  int op_slot_right_8657 = gc_frame_newslot(call8659);
// starting to compile string node (depth = 5)
  if (strlit8661 == NULL) {
    strlit8661 = alloc_String("bind ");
    gc_root(strlit8661);
  }
// compiled string node returning strlit8661 (depth = 5)
  int op_slot_left_8657 = gc_frame_newslot(strlit8661);
  params[0] = call8659;
  partcv[0] = 1;
  Object opresult8662 = callmethod(strlit8661, "++(1)", 1, partcv, params);
// compiled op node returning opresult8662 (depth = 4)
  int op_slot_left_8654 = gc_frame_newslot(opresult8662);
  params[0] = strlit8655;
  partcv[0] = 1;
  Object opresult8663 = callmethod(opresult8662, "++(1)", 1, partcv, params);
// compiled op node returning opresult8663 (depth = 3)
  gc_frame_end(frame);
  return opresult8663;
}
Object meth_ast_8664_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// definebindings:
// Begin line 2295
  setline(2295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8666 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8667 = callmethodflags(*var_visitor, "visitBind(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8666);
// compiled call node returning call8667 (depth = 4)
  Object if8665 = done;
  if (istrue(call8667)) {
// Begin line 2296
  setline(2296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8668 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call8669 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8668);
// compiled call node returning call8669 (depth = 5)
  *var_newChain = call8669;
  if (call8669 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2297
  setline(2297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8670 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8671 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8672 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8671);
// compiled member node returning call8672 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8673 = callmethodflags(call8672, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8670);
// compiled call node returning call8673 (depth = 4)
// Begin line 2298
  setline(2298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8674 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8675 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8676 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8675);
// compiled member node returning call8676 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8677 = callmethodflags(call8676, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8674);
// compiled call node returning call8677 (depth = 4)
    gc_frame_newslot(call8677);
    if8665 = call8677;
  } else {
  }
// compiled if node returning if8665 (depth = 3)
  gc_frame_end(frame);
  return if8665;
}
Object meth_ast_8678_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2302
  setline(2302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8679 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8680 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8679);
// compiled member node returning call8680 (depth = 4)
  *var_n = call8680;
  if (call8680 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2303
  setline(2303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8681 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8682 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8681);
// compiled call node returning call8682 (depth = 4)
  *var_newChain = call8682;
  if (call8682 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2304
  setline(2304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8683 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8684 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8685 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8686 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8685);
// compiled member node returning call8686 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8687 = callmethodflags(call8686, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8684);
// compiled call node returning call8687 (depth = 4)
  gc_frame_newslot(call8687);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8687;
  partcv[0] = 1;
  Object call8688 = callmethodflags(*var_n, "dest:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8683);
// compiled call node returning call8688 (depth = 3)
// Begin line 2305
  setline(2305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8689 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8690 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8691 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8692 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8691);
// compiled member node returning call8692 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8693 = callmethodflags(call8692, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8690);
// compiled call node returning call8693 (depth = 4)
  gc_frame_newslot(call8693);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8693;
  partcv[0] = 1;
  Object call8694 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8689);
// compiled call node returning call8694 (depth = 3)
// Begin line 2306
  setline(2306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8695 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call8696 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8695);
// compiled call node returning call8696 (depth = 3)
  gc_frame_end(frame);
  return call8696;
}
Object meth_ast_8697_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2309
  setline(2309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8700 = alloc_Float64(1);
// compiled num node returning num8700 (depth = 6)
  int op_slot_right_8699 = gc_frame_newslot(num8700);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_8699 = gc_frame_newslot(*var_depth);
  params[0] = num8700;
  partcv[0] = 1;
  Object sum8702 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8702 (depth = 5)
  int op_slot_right_8698 = gc_frame_newslot(sum8702);
// starting to compile string node (depth = 5)
  if (strlit8704 == NULL) {
    strlit8704 = alloc_String("  ");
    gc_root(strlit8704);
  }
// compiled string node returning strlit8704 (depth = 5)
  int op_slot_left_8698 = gc_frame_newslot(strlit8704);
  params[0] = sum8702;
  partcv[0] = 1;
  Object prod8705 = callmethod(strlit8704, "*(1)", 1, partcv, params);
// compiled op node returning prod8705 (depth = 4)
  *var_spc = prod8705;
  if (prod8705 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2310
  setline(2310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8707 == NULL) {
    strlit8707 = alloc_String("""\x0a""");
    gc_root(strlit8707);
  }
// compiled string node returning strlit8707 (depth = 5)
  int op_slot_right_8706 = gc_frame_newslot(strlit8707);
// starting to compile call node (depth = 5)
  int callframe8709 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8710 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8709);
// compiled call node returning call8710 (depth = 5)
  int op_slot_left_8706 = gc_frame_newslot(call8710);
  params[0] = strlit8707;
  partcv[0] = 1;
  Object opresult8711 = callmethod(call8710, "++(1)", 1, partcv, params);
// compiled op node returning opresult8711 (depth = 4)
  *var_s = opresult8711;
  if (opresult8711 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2311
  setline(2311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8713 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8715 = alloc_Float64(1);
// compiled num node returning num8715 (depth = 7)
  int op_slot_right_8714 = gc_frame_newslot(num8715);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_8714 = gc_frame_newslot(*var_depth);
  params[0] = num8715;
  partcv[0] = 1;
  Object sum8717 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8717 (depth = 6)
  gc_frame_newslot(sum8717);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8718 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8719 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8718);
// compiled member node returning call8719 (depth = 6)
  params[0] = sum8717;
  partcv[0] = 1;
  Object call8720 = callmethodflags(call8719, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8713);
// compiled call node returning call8720 (depth = 5)
  int op_slot_right_8712 = gc_frame_newslot(call8720);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_8722 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8722 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8724 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8724 (depth = 5)
  int op_slot_left_8712 = gc_frame_newslot(opresult8724);
  params[0] = call8720;
  partcv[0] = 1;
  Object opresult8725 = callmethod(opresult8724, "++(1)", 1, partcv, params);
// compiled op node returning opresult8725 (depth = 4)
  *var_s = opresult8725;
  if (opresult8725 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2312
  setline(2312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8728 == NULL) {
    strlit8728 = alloc_String("""\x0a""");
    gc_root(strlit8728);
  }
// compiled string node returning strlit8728 (depth = 5)
  int op_slot_right_8727 = gc_frame_newslot(strlit8728);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_8727 = gc_frame_newslot(*var_s);
  params[0] = strlit8728;
  partcv[0] = 1;
  Object opresult8730 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8730 (depth = 4)
  *var_s = opresult8730;
  if (opresult8730 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2313
  setline(2313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8733 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8735 = alloc_Float64(1);
// compiled num node returning num8735 (depth = 7)
  int op_slot_right_8734 = gc_frame_newslot(num8735);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_8734 = gc_frame_newslot(*var_depth);
  params[0] = num8735;
  partcv[0] = 1;
  Object sum8737 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8737 (depth = 6)
  gc_frame_newslot(sum8737);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8738 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8739 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8738);
// compiled member node returning call8739 (depth = 6)
  params[0] = sum8737;
  partcv[0] = 1;
  Object call8740 = callmethodflags(call8739, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8733);
// compiled call node returning call8740 (depth = 5)
  int op_slot_right_8732 = gc_frame_newslot(call8740);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_8742 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8742 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8744 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8744 (depth = 5)
  int op_slot_left_8732 = gc_frame_newslot(opresult8744);
  params[0] = call8740;
  partcv[0] = 1;
  Object opresult8745 = callmethod(opresult8744, "++(1)", 1, partcv, params);
// compiled op node returning opresult8745 (depth = 4)
  *var_s = opresult8745;
  if (opresult8745 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2314
  setline(2314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_8747_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2317
  setline(2317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_8748 = gc_frame_newslot(*var_depth);
// starting to compile string node (depth = 5)
  if (strlit8750 == NULL) {
    strlit8750 = alloc_String("    ");
    gc_root(strlit8750);
  }
// compiled string node returning strlit8750 (depth = 5)
  int op_slot_left_8748 = gc_frame_newslot(strlit8750);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object prod8751 = callmethod(strlit8750, "*(1)", 1, partcv, params);
// compiled op node returning prod8751 (depth = 4)
  *var_spc = prod8751;
  if (prod8751 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2318
  setline(2318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8752 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8754 = alloc_Float64(1);
// compiled num node returning num8754 (depth = 6)
  int op_slot_right_8753 = gc_frame_newslot(num8754);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_8753 = gc_frame_newslot(*var_depth);
  params[0] = num8754;
  partcv[0] = 1;
  Object sum8756 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8756 (depth = 5)
  gc_frame_newslot(sum8756);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8757 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8758 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8757);
// compiled member node returning call8758 (depth = 5)
  params[0] = sum8756;
  partcv[0] = 1;
  Object call8759 = callmethodflags(call8758, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8752);
// compiled call node returning call8759 (depth = 4)
  *var_s = call8759;
  if (call8759 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2319
  setline(2319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8761 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8763 = alloc_Float64(1);
// compiled num node returning num8763 (depth = 7)
  int op_slot_right_8762 = gc_frame_newslot(num8763);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_8762 = gc_frame_newslot(*var_depth);
  params[0] = num8763;
  partcv[0] = 1;
  Object sum8765 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8765 (depth = 6)
  gc_frame_newslot(sum8765);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8766 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8767 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8766);
// compiled member node returning call8767 (depth = 6)
  params[0] = sum8765;
  partcv[0] = 1;
  Object call8768 = callmethodflags(call8767, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8761);
// compiled call node returning call8768 (depth = 5)
  int op_slot_right_8760 = gc_frame_newslot(call8768);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8771 == NULL) {
    strlit8771 = alloc_String(" := ");
    gc_root(strlit8771);
  }
// compiled string node returning strlit8771 (depth = 6)
  int op_slot_right_8770 = gc_frame_newslot(strlit8771);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8770 = gc_frame_newslot(*var_s);
  params[0] = strlit8771;
  partcv[0] = 1;
  Object opresult8773 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8773 (depth = 5)
  int op_slot_left_8760 = gc_frame_newslot(opresult8773);
  params[0] = call8768;
  partcv[0] = 1;
  Object opresult8774 = callmethod(opresult8773, "++(1)", 1, partcv, params);
// compiled op node returning opresult8774 (depth = 4)
  *var_s = opresult8774;
  if (opresult8774 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2320
  setline(2320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_8776_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2323
  setline(2323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8777 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe8778 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8779 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8780 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8779);
// compiled member node returning call8780 (depth = 5)
  gc_frame_newslot(call8780);
// starting to compile member node (depth = 5)
  int callframe8781 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8782 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8781);
// compiled member node returning call8782 (depth = 5)
  gc_frame_newslot(call8782);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_bindNode (depth = 5)
  params[0] = call8780;
  params[1] = call8782;
  partcv[0] = 2;
  Object call8783 = callmethodflags(*var_bindNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8778);
// compiled call node returning call8783 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call8784 = callmethodflags(call8783, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8777);
// compiled call node returning call8784 (depth = 3)
  gc_frame_end(frame);
  return call8784;
}
Object meth_ast_8785_statementName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2325
  setline(2325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8786 == NULL) {
    strlit8786 = alloc_String("assignment or assigment request");
    gc_root(strlit8786);
  }
// compiled string node returning strlit8786 (depth = 3)
  gc_frame_end(frame);
  return strlit8786;
}
Object meth_ast_8626_new_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_dest_39_ = &(stackframe->slots[0]);
  *var_dest_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8627 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8627 = alloc_userobj2(16,15, objclass8627);
  gc_frame_newslot(obj8627);
  if (objclass8627 == NULL) {
    glfree(obj8627->class->name);
    obj8627->class->name = "bindNode.new(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj8627, self, 0);
  addmethodreal(obj8627,"outer", &reader_ast_outer_8628);
  Object oldself8627 = self;
  struct StackFrameObject *oldstackframe8627 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8627);
  gc_frame_newslot((Object)stackframe);
  self = obj8627;
  Object *oldselfslot8627 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8627 = (*(struct UserObject *)self).data[0], lowerouter8627 = thisouter8627;
  if (inheritingObject8627) {
    struct UserObject *inho8627 = (struct UserObject *)inheritingObject8627;
    while (inho8627->super != GraceDefaultObject) inho8627 = (struct UserObject *)inho8627->super;
    inho8627->super = obj8627;
    self = inheritingObject8627;
    *selfslot = self;
    lowerouter8627 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8627;
  }
  if (objclass8627 == NULL) {
  Method *reader8629 = addmethodrealflags(obj8627, "kind",&reader_ast_kind_8629, MFLAG_DEF);
  reader8629->definitionModule = modulename;
  reader8629->definitionLine = 2285;
  }
  adddatum2(obj8627, alloc_Undefined(), 1);
  if (objclass8627 == NULL) {
    Method *reader8630 = addmethodrealflags(obj8627, "dest", &reader_ast_dest_8630, 0);
    Method *writer8630 = addmethodrealflags(obj8627, "dest:=(1)", &writer_ast_dest_8630, 0);
    reader8630->definitionModule = modulename;
    writer8630->definitionModule = modulename;
    reader8630->definitionLine = 2286;
    writer8630->definitionLine = 2286;
  }
  obj8627->flags |= OFLAG_MUTABLE;
  adddatum2(obj8627, alloc_Undefined(), 2);
  if (objclass8627 == NULL) {
    Method *reader8631 = addmethodrealflags(obj8627, "value", &reader_ast_value_8631, 0);
    Method *writer8631 = addmethodrealflags(obj8627, "value:=(1)", &writer_ast_value_8631, 0);
    reader8631->definitionModule = modulename;
    writer8631->definitionModule = modulename;
    reader8631->definitionLine = 2287;
    writer8631->definitionLine = 2287;
  }
  obj8627->flags |= OFLAG_MUTABLE;
  adddatum2(obj8627, alloc_Undefined(), 3);
// method "end"
  struct UserObject *uo8632 = (struct UserObject*)obj8627;
  uo8632->data[4] = emptyclosure;
  Method *meth_meth_ast_8632_end = addmethod2pos(obj8627, "end", &meth_ast_8632_end, 4);
  int argcv_meth_ast_8632_end[] = {0};
  meth_meth_ast_8632_end->type = alloc_MethodType(1, argcv_meth_ast_8632_end);
  meth_meth_ast_8632_end->definitionModule = modulename;
  meth_meth_ast_8632_end->definitionLine = 2289;
// method "nameString"
  struct UserObject *uo8637 = (struct UserObject*)obj8627;
  uo8637->data[5] = emptyclosure;
  Method *meth_meth_ast_8637_nameString = addmethod2pos(obj8627, "nameString", &meth_ast_8637_nameString, 5);
  int argcv_meth_ast_8637_nameString[] = {0};
  meth_meth_ast_8637_nameString->type = alloc_MethodType(1, argcv_meth_ast_8637_nameString);
  meth_meth_ast_8637_nameString->definitionModule = modulename;
  meth_meth_ast_8637_nameString->definitionLine = 2290;
// method "canonicalName"
  struct UserObject *uo8644 = (struct UserObject*)obj8627;
  uo8644->data[6] = emptyclosure;
  Method *meth_meth_ast_8644_canonicalName = addmethod2pos(obj8627, "canonicalName", &meth_ast_8644_canonicalName, 6);
  int argcv_meth_ast_8644_canonicalName[] = {0};
  meth_meth_ast_8644_canonicalName->type = alloc_MethodType(1, argcv_meth_ast_8644_canonicalName);
  meth_meth_ast_8644_canonicalName->definitionModule = modulename;
  meth_meth_ast_8644_canonicalName->definitionLine = 2291;
// method "isBind"
  struct UserObject *uo8651 = (struct UserObject*)obj8627;
  uo8651->data[7] = emptyclosure;
  Method *meth_meth_ast_8651_isBind = addmethod2pos(obj8627, "isBind", &meth_ast_8651_isBind, 7);
  int argcv_meth_ast_8651_isBind[] = {0};
  meth_meth_ast_8651_isBind->type = alloc_MethodType(1, argcv_meth_ast_8651_isBind);
  meth_meth_ast_8651_isBind->definitionModule = modulename;
  meth_meth_ast_8651_isBind->definitionLine = 2292;
// method "asString"
  struct UserObject *uo8653 = (struct UserObject*)obj8627;
  uo8653->data[8] = emptyclosure;
  Method *meth_meth_ast_8653_asString = addmethod2pos(obj8627, "asString", &meth_ast_8653_asString, 8);
  int argcv_meth_ast_8653_asString[] = {0};
  meth_meth_ast_8653_asString->type = alloc_MethodType(1, argcv_meth_ast_8653_asString);
  meth_meth_ast_8653_asString->definitionModule = modulename;
  meth_meth_ast_8653_asString->definitionLine = 2293;
// method "accept(_)from(_)"
  struct UserObject *uo8664 = (struct UserObject*)obj8627;
  uo8664->data[9] = emptyclosure;
  Method *meth_meth_ast_8664_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj8627, "accept(1)from(1)", &meth_ast_8664_accept_40_1_41_from_40_1_41_, 9);
  int argcv_meth_ast_8664_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_8664_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_8664_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_8664_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8664_accept_40_1_41_from_40_1_41_->definitionLine = 2294;
// method "map(_)ancestors(_)"
  struct UserObject *uo8678 = (struct UserObject*)obj8627;
  uo8678->data[10] = emptyclosure;
  Method *meth_meth_ast_8678_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj8627, "map(1)ancestors(1)", &meth_ast_8678_map_40_1_41_ancestors_40_1_41_, 10);
  int argcv_meth_ast_8678_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_8678_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_8678_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_8678_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8678_map_40_1_41_ancestors_40_1_41_->definitionLine = 2301;
// method "pretty(_)"
  struct UserObject *uo8697 = (struct UserObject*)obj8627;
  uo8697->data[11] = emptyclosure;
  Method *meth_meth_ast_8697_pretty_40_1_41_ = addmethod2pos(obj8627, "pretty(1)", &meth_ast_8697_pretty_40_1_41_, 11);
  int argcv_meth_ast_8697_pretty_40_1_41_[] = {1};
  meth_meth_ast_8697_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8697_pretty_40_1_41_);
  meth_meth_ast_8697_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8697_pretty_40_1_41_->definitionLine = 2308;
// method "toGrace(_)"
  struct UserObject *uo8747 = (struct UserObject*)obj8627;
  uo8747->data[12] = emptyclosure;
  Method *meth_meth_ast_8747_toGrace_40_1_41_ = addmethod2pos(obj8627, "toGrace(1)", &meth_ast_8747_toGrace_40_1_41_, 12);
  int argcv_meth_ast_8747_toGrace_40_1_41_[] = {1};
  meth_meth_ast_8747_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8747_toGrace_40_1_41_);
meth_meth_ast_8747_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_8747_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_8747_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8747_toGrace_40_1_41_->definitionLine = 2316;
// method "shallowCopy"
  block_savedest(obj8627);
  Object closure8776 = createclosure(1, "shallowCopy");
  setclosureframe(closure8776, stackframe);
  addtoclosure(closure8776, var_bindNode);
  struct UserObject *uo8776 = (struct UserObject*)obj8627;
  uo8776->data[13] = (Object)closure8776;
  Method *meth_meth_ast_8776_shallowCopy = addmethod2pos(obj8627, "shallowCopy", &meth_ast_8776_shallowCopy, 13);
  int argcv_meth_ast_8776_shallowCopy[] = {0};
  meth_meth_ast_8776_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_8776_shallowCopy);
  meth_meth_ast_8776_shallowCopy->definitionModule = modulename;
  meth_meth_ast_8776_shallowCopy->definitionLine = 2322;
// method "statementName"
  struct UserObject *uo8785 = (struct UserObject*)obj8627;
  uo8785->data[14] = emptyclosure;
  Method *meth_meth_ast_8785_statementName = addmethod2pos(obj8627, "statementName", &meth_ast_8785_statementName, 14);
  int argcv_meth_ast_8785_statementName[] = {0};
  meth_meth_ast_8785_statementName->type = alloc_MethodType(1, argcv_meth_ast_8785_statementName);
  meth_meth_ast_8785_statementName->definitionModule = modulename;
  meth_meth_ast_8785_statementName->definitionLine = 2325;
  sourceObject = obj8627;
// Begin line 2284
  setline(2284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8787 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8788 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8787);
// compiled call node returning call8788 (depth = 3)
  struct UserObject *obj8627_uo = (struct UserObject *)obj8627;
  obj8627_uo->super = call8788;
  sourceObject = obj8627;
// Begin line 2285
  setline(2285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8789 == NULL) {
    strlit8789 = alloc_String("bind");
    gc_root(strlit8789);
  }
// compiled string node returning strlit8789 (depth = 3)
  adddatum2(obj8627, strlit8789, 1);
  sourceObject = obj8627;
// Begin line 2286
  setline(2286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dest_39_ (depth = 3)
  adddatum2(obj8627, *var_dest_39_, 2);
  sourceObject = obj8627;
// Begin line 2287
  setline(2287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj8627, *var_val_39_, 3);
  sourceObject = obj8627;
  sourceObject = obj8627;
  sourceObject = obj8627;
  sourceObject = obj8627;
  sourceObject = obj8627;
  sourceObject = obj8627;
  sourceObject = obj8627;
  sourceObject = obj8627;
  sourceObject = obj8627;
  sourceObject = obj8627;
  sourceObject = obj8627;
  objclass8627 = obj8627->class;
  objclass8627->definitionModule = modulename;
  objclass8627->definitionLine = 2282;
  (*(struct UserObject *)self).data[0] = lowerouter8627;
  self = oldself8627;
  selfslot = oldselfslot8627;
  stackframe = oldstackframe8627;
  gc_frame_end(frame);
  return obj8627;
}
Object meth_ast_8626_new_40_2_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_dest_39_ = &(stackframe->slots[0]);
  *var_dest_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8627 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8627 = alloc_userobj2(16,15, objclass8627);
  gc_frame_newslot(obj8627);
  if (objclass8627 == NULL) {
    glfree(obj8627->class->name);
    obj8627->class->name = "bindNode.new(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj8627, self, 0);
  addmethodreal(obj8627,"outer", &reader_ast_outer_8628);
  Object oldself8627 = self;
  struct StackFrameObject *oldstackframe8627 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8627);
  gc_frame_newslot((Object)stackframe);
  self = obj8627;
  Object *oldselfslot8627 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8627 = (*(struct UserObject *)self).data[0], lowerouter8627 = thisouter8627;
  if (inheritingObject8627) {
    struct UserObject *inho8627 = (struct UserObject *)inheritingObject8627;
    while (inho8627->super != GraceDefaultObject) inho8627 = (struct UserObject *)inho8627->super;
    inho8627->super = obj8627;
    self = inheritingObject8627;
    *selfslot = self;
    lowerouter8627 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8627;
  }
  if (objclass8627 == NULL) {
  Method *reader8629 = addmethodrealflags(obj8627, "kind",&reader_ast_kind_8629, MFLAG_DEF);
  reader8629->definitionModule = modulename;
  reader8629->definitionLine = 2285;
  }
  adddatum2(obj8627, alloc_Undefined(), 1);
  if (objclass8627 == NULL) {
    Method *reader8630 = addmethodrealflags(obj8627, "dest", &reader_ast_dest_8630, 0);
    Method *writer8630 = addmethodrealflags(obj8627, "dest:=(1)", &writer_ast_dest_8630, 0);
    reader8630->definitionModule = modulename;
    writer8630->definitionModule = modulename;
    reader8630->definitionLine = 2286;
    writer8630->definitionLine = 2286;
  }
  obj8627->flags |= OFLAG_MUTABLE;
  adddatum2(obj8627, alloc_Undefined(), 2);
  if (objclass8627 == NULL) {
    Method *reader8631 = addmethodrealflags(obj8627, "value", &reader_ast_value_8631, 0);
    Method *writer8631 = addmethodrealflags(obj8627, "value:=(1)", &writer_ast_value_8631, 0);
    reader8631->definitionModule = modulename;
    writer8631->definitionModule = modulename;
    reader8631->definitionLine = 2287;
    writer8631->definitionLine = 2287;
  }
  obj8627->flags |= OFLAG_MUTABLE;
  adddatum2(obj8627, alloc_Undefined(), 3);
// method "end"
  struct UserObject *uo8632 = (struct UserObject*)obj8627;
  uo8632->data[4] = emptyclosure;
  Method *meth_meth_ast_8632_end = addmethod2pos(obj8627, "end", &meth_ast_8632_end, 4);
  int argcv_meth_ast_8632_end[] = {0};
  meth_meth_ast_8632_end->type = alloc_MethodType(1, argcv_meth_ast_8632_end);
  meth_meth_ast_8632_end->definitionModule = modulename;
  meth_meth_ast_8632_end->definitionLine = 2289;
// method "nameString"
  struct UserObject *uo8637 = (struct UserObject*)obj8627;
  uo8637->data[5] = emptyclosure;
  Method *meth_meth_ast_8637_nameString = addmethod2pos(obj8627, "nameString", &meth_ast_8637_nameString, 5);
  int argcv_meth_ast_8637_nameString[] = {0};
  meth_meth_ast_8637_nameString->type = alloc_MethodType(1, argcv_meth_ast_8637_nameString);
  meth_meth_ast_8637_nameString->definitionModule = modulename;
  meth_meth_ast_8637_nameString->definitionLine = 2290;
// method "canonicalName"
  struct UserObject *uo8644 = (struct UserObject*)obj8627;
  uo8644->data[6] = emptyclosure;
  Method *meth_meth_ast_8644_canonicalName = addmethod2pos(obj8627, "canonicalName", &meth_ast_8644_canonicalName, 6);
  int argcv_meth_ast_8644_canonicalName[] = {0};
  meth_meth_ast_8644_canonicalName->type = alloc_MethodType(1, argcv_meth_ast_8644_canonicalName);
  meth_meth_ast_8644_canonicalName->definitionModule = modulename;
  meth_meth_ast_8644_canonicalName->definitionLine = 2291;
// method "isBind"
  struct UserObject *uo8651 = (struct UserObject*)obj8627;
  uo8651->data[7] = emptyclosure;
  Method *meth_meth_ast_8651_isBind = addmethod2pos(obj8627, "isBind", &meth_ast_8651_isBind, 7);
  int argcv_meth_ast_8651_isBind[] = {0};
  meth_meth_ast_8651_isBind->type = alloc_MethodType(1, argcv_meth_ast_8651_isBind);
  meth_meth_ast_8651_isBind->definitionModule = modulename;
  meth_meth_ast_8651_isBind->definitionLine = 2292;
// method "asString"
  struct UserObject *uo8653 = (struct UserObject*)obj8627;
  uo8653->data[8] = emptyclosure;
  Method *meth_meth_ast_8653_asString = addmethod2pos(obj8627, "asString", &meth_ast_8653_asString, 8);
  int argcv_meth_ast_8653_asString[] = {0};
  meth_meth_ast_8653_asString->type = alloc_MethodType(1, argcv_meth_ast_8653_asString);
  meth_meth_ast_8653_asString->definitionModule = modulename;
  meth_meth_ast_8653_asString->definitionLine = 2293;
// method "accept(_)from(_)"
  struct UserObject *uo8664 = (struct UserObject*)obj8627;
  uo8664->data[9] = emptyclosure;
  Method *meth_meth_ast_8664_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj8627, "accept(1)from(1)", &meth_ast_8664_accept_40_1_41_from_40_1_41_, 9);
  int argcv_meth_ast_8664_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_8664_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_8664_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_8664_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8664_accept_40_1_41_from_40_1_41_->definitionLine = 2294;
// method "map(_)ancestors(_)"
  struct UserObject *uo8678 = (struct UserObject*)obj8627;
  uo8678->data[10] = emptyclosure;
  Method *meth_meth_ast_8678_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj8627, "map(1)ancestors(1)", &meth_ast_8678_map_40_1_41_ancestors_40_1_41_, 10);
  int argcv_meth_ast_8678_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_8678_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_8678_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_8678_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8678_map_40_1_41_ancestors_40_1_41_->definitionLine = 2301;
// method "pretty(_)"
  struct UserObject *uo8697 = (struct UserObject*)obj8627;
  uo8697->data[11] = emptyclosure;
  Method *meth_meth_ast_8697_pretty_40_1_41_ = addmethod2pos(obj8627, "pretty(1)", &meth_ast_8697_pretty_40_1_41_, 11);
  int argcv_meth_ast_8697_pretty_40_1_41_[] = {1};
  meth_meth_ast_8697_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8697_pretty_40_1_41_);
  meth_meth_ast_8697_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8697_pretty_40_1_41_->definitionLine = 2308;
// method "toGrace(_)"
  struct UserObject *uo8747 = (struct UserObject*)obj8627;
  uo8747->data[12] = emptyclosure;
  Method *meth_meth_ast_8747_toGrace_40_1_41_ = addmethod2pos(obj8627, "toGrace(1)", &meth_ast_8747_toGrace_40_1_41_, 12);
  int argcv_meth_ast_8747_toGrace_40_1_41_[] = {1};
  meth_meth_ast_8747_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8747_toGrace_40_1_41_);
meth_meth_ast_8747_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_8747_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_8747_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8747_toGrace_40_1_41_->definitionLine = 2316;
// method "shallowCopy"
  block_savedest(obj8627);
  Object closure8776 = createclosure(1, "shallowCopy");
  setclosureframe(closure8776, stackframe);
  addtoclosure(closure8776, var_bindNode);
  struct UserObject *uo8776 = (struct UserObject*)obj8627;
  uo8776->data[13] = (Object)closure8776;
  Method *meth_meth_ast_8776_shallowCopy = addmethod2pos(obj8627, "shallowCopy", &meth_ast_8776_shallowCopy, 13);
  int argcv_meth_ast_8776_shallowCopy[] = {0};
  meth_meth_ast_8776_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_8776_shallowCopy);
  meth_meth_ast_8776_shallowCopy->definitionModule = modulename;
  meth_meth_ast_8776_shallowCopy->definitionLine = 2322;
// method "statementName"
  struct UserObject *uo8785 = (struct UserObject*)obj8627;
  uo8785->data[14] = emptyclosure;
  Method *meth_meth_ast_8785_statementName = addmethod2pos(obj8627, "statementName", &meth_ast_8785_statementName, 14);
  int argcv_meth_ast_8785_statementName[] = {0};
  meth_meth_ast_8785_statementName->type = alloc_MethodType(1, argcv_meth_ast_8785_statementName);
  meth_meth_ast_8785_statementName->definitionModule = modulename;
  meth_meth_ast_8785_statementName->definitionLine = 2325;
  sourceObject = obj8627;
// Begin line 2284
  setline(2284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8787 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8788 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8787);
// compiled call node returning call8788 (depth = 3)
  struct UserObject *obj8627_uo = (struct UserObject *)obj8627;
  obj8627_uo->super = call8788;
  sourceObject = obj8627;
// Begin line 2285
  setline(2285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8789 == NULL) {
    strlit8789 = alloc_String("bind");
    gc_root(strlit8789);
  }
// compiled string node returning strlit8789 (depth = 3)
  adddatum2(obj8627, strlit8789, 1);
  sourceObject = obj8627;
// Begin line 2286
  setline(2286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dest_39_ (depth = 3)
  adddatum2(obj8627, *var_dest_39_, 2);
  sourceObject = obj8627;
// Begin line 2287
  setline(2287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj8627, *var_val_39_, 3);
  sourceObject = obj8627;
  sourceObject = obj8627;
  sourceObject = obj8627;
  sourceObject = obj8627;
  sourceObject = obj8627;
  sourceObject = obj8627;
  sourceObject = obj8627;
  sourceObject = obj8627;
  sourceObject = obj8627;
  sourceObject = obj8627;
  sourceObject = obj8627;
  objclass8627 = obj8627->class;
  objclass8627->definitionModule = modulename;
  objclass8627->definitionLine = 2282;
  (*(struct UserObject *)self).data[0] = lowerouter8627;
  self = oldself8627;
  selfslot = oldselfslot8627;
  stackframe = oldstackframe8627;
  gc_frame_end(frame);
  return obj8627;
}
Object meth_ast_8791_bindNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 49, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2281
  setline(2281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_bindNode (depth = 3)
  gc_frame_end(frame);
  return *var_bindNode;
}
Object meth_ast_8794_new_40_3_41_scope_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new(3)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)scope(_)");
  Object params[3];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_)scope(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val = &(stackframe->slots[1]);
  *var_val = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *var_s = &(stackframe->slots[3]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_result = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "result");
// Begin line 2330
  setline(2330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8795 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name_39_ (depth = 5)
  gc_frame_newslot(*var_name_39_);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype_39_ (depth = 5)
  gc_frame_newslot(*var_dtype_39_);
// call case 4: self request
  params[0] = *var_name_39_;
  params[1] = *var_val;
  params[2] = *var_dtype_39_;
  partcv[0] = 3;
  Object call8796 = callmethodflags(self, "new(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8795);
// compiled call node returning call8796 (depth = 4)
  *var_result = call8796;
  if (call8796 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2331
  setline(2331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8797 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call8798 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8797);
// compiled call node returning call8798 (depth = 3)
// Begin line 2332
  setline(2332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_8810_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2346
  setline(2346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8811 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8812 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8813 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8812);
// compiled member node returning call8813 (depth = 4)
  partcv[0] = 0;
  Object call8814 = callmethodflags(call8813, "end", 1, partcv, params, 0);
  gc_frame_end(callframe8811);
// compiled member node returning call8814 (depth = 3)
  gc_frame_end(frame);
  return call8814;
}
Object meth_ast_8815_isPublic(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2349
  setline(2349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8818 = alloc_Float64(0);
// compiled num node returning num8818 (depth = 5)
  int op_slot_right_8817 = gc_frame_newslot(num8818);
// starting to compile member node (depth = 5)
  int callframe8820 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8821 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8822 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8821);
// compiled member node returning call8822 (depth = 6)
  partcv[0] = 0;
  Object call8823 = callmethodflags(call8822, "size", 1, partcv, params, 0);
  gc_frame_end(callframe8820);
// compiled member node returning call8823 (depth = 5)
  int op_slot_left_8817 = gc_frame_newslot(call8823);
  params[0] = num8818;
  partcv[0] = 1;
  Object opresult8824 = callmethod(call8823, "==(1)", 1, partcv, params);
// compiled op node returning opresult8824 (depth = 4)
  Object if8816 = done;
  if (istrue(opresult8824)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8825 = alloc_Boolean(0);
// compiled identifier node returning bool8825 (depth = 5)
  return bool8825;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8816 = undefined;
  } else {
  }
// compiled if node returning if8816 (depth = 3)
// Begin line 2350
  setline(2350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8827 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8828 == NULL) {
    strlit8828 = alloc_String("public");
    gc_root(strlit8828);
  }
// compiled string node returning strlit8828 (depth = 5)
  gc_frame_newslot(strlit8828);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = self;
  params[1] = strlit8828;
  partcv[0] = 2;
  Object call8829 = callmethodflags(module_ast, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8827);
// compiled call node returning call8829 (depth = 4)
  Object if8826 = done;
  if (istrue(call8829)) {
// Begin line 2350
  setline(2350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8830 = alloc_Boolean(1);
// compiled identifier node returning bool8830 (depth = 5)
  return bool8830;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8826 = undefined;
  } else {
  }
// compiled if node returning if8826 (depth = 3)
// Begin line 2351
  setline(2351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8831 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit8832 == NULL) {
    strlit8832 = alloc_String("readable");
    gc_root(strlit8832);
  }
// compiled string node returning strlit8832 (depth = 4)
  gc_frame_newslot(strlit8832);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  params[1] = strlit8832;
  partcv[0] = 2;
  Object call8833 = callmethodflags(module_ast, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8831);
// compiled call node returning call8833 (depth = 3)
  gc_frame_end(frame);
  return call8833;
}
Object meth_ast_8834_isFieldDec(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isFieldDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2353
  setline(2353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8835 = alloc_Boolean(1);
// compiled identifier node returning bool8835 (depth = 3)
  gc_frame_end(frame);
  return bool8835;
}
Object meth_ast_8836_isWritable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2354
  setline(2354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8837 = alloc_Boolean(0);
// compiled identifier node returning bool8837 (depth = 3)
  gc_frame_end(frame);
  return bool8837;
}
Object meth_ast_8838_isReadable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2355
  setline(2355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8839 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8840 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8839);
// compiled member node returning call8840 (depth = 3)
  gc_frame_end(frame);
  return call8840;
}
Object meth_ast_8841_returnsObject(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2358
  setline(2358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8842 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8843 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8844 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8843);
// compiled member node returning call8844 (depth = 4)
  partcv[0] = 0;
  Object call8845 = callmethodflags(call8844, "returnsObject", 1, partcv, params, 0);
  gc_frame_end(callframe8842);
// compiled member node returning call8845 (depth = 3)
  gc_frame_end(frame);
  return call8845;
}
Object meth_ast_8846_returnedObjectScope(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2362
  setline(2362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8847 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8848 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8849 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8848);
// compiled member node returning call8849 (depth = 4)
  partcv[0] = 0;
  Object call8850 = callmethodflags(call8849, "returnedObjectScope", 1, partcv, params, 0);
  gc_frame_end(callframe8847);
// compiled member node returning call8850 (depth = 3)
  gc_frame_end(frame);
  return call8850;
}
Object meth_ast_8851_usesAsType_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part usesAsType(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2365
  setline(2365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8853 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8854 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8853);
// compiled member node returning call8854 (depth = 4)
  int op_slot_right_8852 = gc_frame_newslot(call8854);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_8852 = gc_frame_newslot(*var_aNode);
  params[0] = call8854;
  partcv[0] = 1;
  Object opresult8856 = callmethod(*var_aNode, "==(1)", 1, partcv, params);
// compiled op node returning opresult8856 (depth = 3)
  gc_frame_end(frame);
  return opresult8856;
}
Object meth_ast_8857_declarationKindWithAncestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2367
  setline(2367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8858 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  partcv[0] = 0;
  Object call8859 = callmethodflags(*var_k, "defdec", 1, partcv, params, 0);
  gc_frame_end(callframe8858);
// compiled member node returning call8859 (depth = 3)
  gc_frame_end(frame);
  return call8859;
}
Object meth_ast_8885__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2377
  setline(2377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8886 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8887 = callmethodflags(*var_ann, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8886);
// compiled call node returning call8887 (depth = 6)
  gc_frame_end(frame);
  return call8887;
}
Object meth_ast_8860_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// definebindings:
// definebindings:
// definebindings:
// Begin line 2370
  setline(2370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8862 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8863 = callmethodflags(*var_visitor, "visitDefDec(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8862);
// compiled call node returning call8863 (depth = 4)
  Object if8861 = done;
  if (istrue(call8863)) {
// Begin line 2371
  setline(2371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8864 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call8865 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8864);
// compiled call node returning call8865 (depth = 5)
  *var_newChain = call8865;
  if (call8865 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2372
  setline(2372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8866 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8867 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8868 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8867);
// compiled member node returning call8868 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8869 = callmethodflags(call8868, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8866);
// compiled call node returning call8869 (depth = 4)
// Begin line 2373
  setline(2373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8872 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8873 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8872);
// compiled member node returning call8873 (depth = 6)
  int op_slot_right_8871 = gc_frame_newslot(call8873);
// starting to compile identifier node (depth = 6)
  Object bool8875 = alloc_Boolean(0);
// compiled identifier node returning bool8875 (depth = 6)
  int op_slot_left_8871 = gc_frame_newslot(bool8875);
  params[0] = call8873;
  partcv[0] = 1;
  Object opresult8876 = callmethod(bool8875, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8876 (depth = 5)
  Object if8870 = done;
  if (istrue(opresult8876)) {
// Begin line 2374
  setline(2374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8877 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8878 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8879 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8878);
// compiled member node returning call8879 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8880 = callmethodflags(call8879, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8877);
// compiled call node returning call8880 (depth = 5)
    gc_frame_newslot(call8880);
    if8870 = call8880;
  } else {
  }
// compiled if node returning if8870 (depth = 4)
// Begin line 2376
  setline(2376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8881 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8882 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8883 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8882);
// compiled member node returning call8883 (depth = 5)
  gc_frame_newslot(call8883);
// starting to compile block node (depth = 5)
  Object block8884 = alloc_Block(NULL, NULL, "ast", 2376);
  gc_frame_newslot(block8884);
// method "_apply(_)"
  block_savedest(block8884);
  Object closure8885 = createclosure(3, "_apply(1)");
  setclosureframe(closure8885, stackframe);
  addtoclosure(closure8885, var_visitor);
  addtoclosure(closure8885, var_newChain);
  addtoclosure(closure8885, selfslot);
  struct UserObject *uo8885 = (struct UserObject*)block8884;
  uo8885->data[0] = (Object)closure8885;
  Method *meth_meth_ast_8885__apply_40_1_41_ = addmethod2pos(block8884, "_apply(1)", &meth_ast_8885__apply_40_1_41_, 0);
  int argcv_meth_ast_8885__apply_40_1_41_[] = {1};
  meth_meth_ast_8885__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8885__apply_40_1_41_);
  meth_meth_ast_8885__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8885__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block8884 (depth = 5)
  gc_frame_newslot(block8884);
// call case 5: prelude request
  params[0] = call8883;
  params[1] = block8884;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8889 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8881);
// compiled call node returning call8889 (depth = 4)
// Begin line 2379
  setline(2379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8890 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8891 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8892 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8891);
// compiled member node returning call8892 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8893 = callmethodflags(call8892, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8890);
// compiled call node returning call8893 (depth = 4)
    gc_frame_newslot(call8893);
    if8861 = call8893;
  } else {
  }
// compiled if node returning if8861 (depth = 3)
  gc_frame_end(frame);
  return if8861;
}
Object meth_ast_8894_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2383
  setline(2383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8895 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8896 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8895);
// compiled member node returning call8896 (depth = 4)
  *var_n = call8896;
  if (call8896 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2384
  setline(2384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8897 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8898 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8897);
// compiled call node returning call8898 (depth = 4)
  *var_newChain = call8898;
  if (call8898 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2385
  setline(2385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8899 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8900 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8901 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8902 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8901);
// compiled member node returning call8902 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8903 = callmethodflags(call8902, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8900);
// compiled call node returning call8903 (depth = 4)
  gc_frame_newslot(call8903);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8903;
  partcv[0] = 1;
  Object call8904 = callmethodflags(*var_n, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8899);
// compiled call node returning call8904 (depth = 3)
// Begin line 2386
  setline(2386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8905 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8906 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8907 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8908 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8907);
// compiled member node returning call8908 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8909 = callmethodflags(call8908, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8906);
// compiled call node returning call8909 (depth = 4)
  gc_frame_newslot(call8909);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8909;
  partcv[0] = 1;
  Object call8910 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8905);
// compiled call node returning call8910 (depth = 3)
// Begin line 2387
  setline(2387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8911 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8912 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8913 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8914 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8913);
// compiled member node returning call8914 (depth = 5)
  gc_frame_newslot(call8914);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call8914;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8915 = callmethodflags(module_ast, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8912);
// compiled call node returning call8915 (depth = 4)
  gc_frame_newslot(call8915);
// call case 6: other requests
// Begin line 2387
  setline(2387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8915;
  partcv[0] = 1;
  Object call8916 = callmethodflags(*var_n, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8911);
// compiled call node returning call8916 (depth = 3)
// Begin line 2388
  setline(2388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8917 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8918 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8919 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8920 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8919);
// compiled member node returning call8920 (depth = 5)
  gc_frame_newslot(call8920);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call8920;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8921 = callmethodflags(module_ast, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8918);
// compiled call node returning call8921 (depth = 4)
  gc_frame_newslot(call8921);
// call case 6: other requests
// Begin line 2388
  setline(2388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8921;
  partcv[0] = 1;
  Object call8922 = callmethodflags(*var_n, "annotations:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8917);
// compiled call node returning call8922 (depth = 3)
// Begin line 2389
  setline(2389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8923 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call8924 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8923);
// compiled call node returning call8924 (depth = 3)
  gc_frame_end(frame);
  return call8924;
}
Object meth_ast_9032__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2404
  setline(2404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9034 == NULL) {
    strlit9034 = alloc_String("");
    gc_root(strlit9034);
  }
// compiled string node returning strlit9034 (depth = 8)
  int op_slot_right_9033 = gc_frame_newslot(strlit9034);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9037 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num9039 = alloc_Float64(2);
// compiled num node returning num9039 (depth = 11)
  int op_slot_right_9038 = gc_frame_newslot(num9039);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_9038 = gc_frame_newslot(*var_depth);
  params[0] = num9039;
  partcv[0] = 1;
  Object sum9041 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum9041 (depth = 10)
  gc_frame_newslot(sum9041);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ann (depth = 10)
  params[0] = sum9041;
  partcv[0] = 1;
  Object call9042 = callmethodflags(*var_ann, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9037);
// compiled call node returning call9042 (depth = 9)
  int op_slot_right_9036 = gc_frame_newslot(call9042);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit9045 == NULL) {
    strlit9045 = alloc_String(" ");
    gc_root(strlit9045);
  }
// compiled string node returning strlit9045 (depth = 10)
  int op_slot_right_9044 = gc_frame_newslot(strlit9045);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_9047 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit9049 == NULL) {
    strlit9049 = alloc_String("");
    gc_root(strlit9049);
  }
// compiled string node returning strlit9049 (depth = 11)
  int op_slot_left_9047 = gc_frame_newslot(strlit9049);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9050 = callmethod(strlit9049, "++(1)", 1, partcv, params);
// compiled op node returning opresult9050 (depth = 10)
  int op_slot_left_9044 = gc_frame_newslot(opresult9050);
  params[0] = strlit9045;
  partcv[0] = 1;
  Object opresult9051 = callmethod(opresult9050, "++(1)", 1, partcv, params);
// compiled op node returning opresult9051 (depth = 9)
  int op_slot_left_9036 = gc_frame_newslot(opresult9051);
  params[0] = call9042;
  partcv[0] = 1;
  Object opresult9052 = callmethod(opresult9051, "++(1)", 1, partcv, params);
// compiled op node returning opresult9052 (depth = 8)
  int op_slot_left_9033 = gc_frame_newslot(opresult9052);
  params[0] = strlit9034;
  partcv[0] = 1;
  Object opresult9053 = callmethod(opresult9052, "++(1)", 1, partcv, params);
// compiled op node returning opresult9053 (depth = 7)
  *var_s = opresult9053;
  if (opresult9053 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_8925_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2392
  setline(2392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8928 = alloc_Float64(1);
// compiled num node returning num8928 (depth = 6)
  int op_slot_right_8927 = gc_frame_newslot(num8928);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_8927 = gc_frame_newslot(*var_depth);
  params[0] = num8928;
  partcv[0] = 1;
  Object sum8930 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8930 (depth = 5)
  int op_slot_right_8926 = gc_frame_newslot(sum8930);
// starting to compile string node (depth = 5)
  if (strlit8932 == NULL) {
    strlit8932 = alloc_String("  ");
    gc_root(strlit8932);
  }
// compiled string node returning strlit8932 (depth = 5)
  int op_slot_left_8926 = gc_frame_newslot(strlit8932);
  params[0] = sum8930;
  partcv[0] = 1;
  Object prod8933 = callmethod(strlit8932, "*(1)", 1, partcv, params);
// compiled op node returning prod8933 (depth = 4)
  *var_spc = prod8933;
  if (prod8933 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2393
  setline(2393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8935 == NULL) {
    strlit8935 = alloc_String("""\x0a""");
    gc_root(strlit8935);
  }
// compiled string node returning strlit8935 (depth = 5)
  int op_slot_right_8934 = gc_frame_newslot(strlit8935);
// starting to compile call node (depth = 5)
  int callframe8937 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8938 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8937);
// compiled call node returning call8938 (depth = 5)
  int op_slot_left_8934 = gc_frame_newslot(call8938);
  params[0] = strlit8935;
  partcv[0] = 1;
  Object opresult8939 = callmethod(call8938, "++(1)", 1, partcv, params);
// compiled op node returning opresult8939 (depth = 4)
  *var_s = opresult8939;
  if (opresult8939 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2394
  setline(2394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8941 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8942 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8943 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8942);
// compiled member node returning call8943 (depth = 6)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8944 = callmethodflags(call8943, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8941);
// compiled call node returning call8944 (depth = 5)
  int op_slot_right_8940 = gc_frame_newslot(call8944);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_8946 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8946 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8948 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8948 (depth = 5)
  int op_slot_left_8940 = gc_frame_newslot(opresult8948);
  params[0] = call8944;
  partcv[0] = 1;
  Object opresult8949 = callmethod(opresult8948, "++(1)", 1, partcv, params);
// compiled op node returning opresult8949 (depth = 4)
  *var_s = opresult8949;
  if (opresult8949 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2395
  setline(2395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8953 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8954 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8953);
// compiled member node returning call8954 (depth = 5)
  int op_slot_right_8952 = gc_frame_newslot(call8954);
// starting to compile identifier node (depth = 5)
  Object bool8956 = alloc_Boolean(0);
// compiled identifier node returning bool8956 (depth = 5)
  int op_slot_left_8952 = gc_frame_newslot(bool8956);
  params[0] = call8954;
  partcv[0] = 1;
  Object opresult8957 = callmethod(bool8956, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8957 (depth = 4)
  Object if8951 = done;
  if (istrue(opresult8957)) {
// Begin line 2396
  setline(2396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8959 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8961 = alloc_Float64(2);
// compiled num node returning num8961 (depth = 8)
  int op_slot_right_8960 = gc_frame_newslot(num8961);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8960 = gc_frame_newslot(*var_depth);
  params[0] = num8961;
  partcv[0] = 1;
  Object sum8963 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8963 (depth = 7)
  gc_frame_newslot(sum8963);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8964 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8965 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8964);
// compiled member node returning call8965 (depth = 7)
  params[0] = sum8963;
  partcv[0] = 1;
  Object call8966 = callmethodflags(call8965, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8959);
// compiled call node returning call8966 (depth = 6)
  int op_slot_right_8958 = gc_frame_newslot(call8966);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8969 == NULL) {
    strlit8969 = alloc_String("Type: ");
    gc_root(strlit8969);
  }
// compiled string node returning strlit8969 (depth = 7)
  int op_slot_right_8968 = gc_frame_newslot(strlit8969);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_8971 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8974 == NULL) {
    strlit8974 = alloc_String("""\x0a""");
    gc_root(strlit8974);
  }
// compiled string node returning strlit8974 (depth = 9)
  int op_slot_right_8973 = gc_frame_newslot(strlit8974);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_8973 = gc_frame_newslot(*var_s);
  params[0] = strlit8974;
  partcv[0] = 1;
  Object opresult8976 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8976 (depth = 8)
  int op_slot_left_8971 = gc_frame_newslot(opresult8976);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8977 = callmethod(opresult8976, "++(1)", 1, partcv, params);
// compiled op node returning opresult8977 (depth = 7)
  int op_slot_left_8968 = gc_frame_newslot(opresult8977);
  params[0] = strlit8969;
  partcv[0] = 1;
  Object opresult8978 = callmethod(opresult8977, "++(1)", 1, partcv, params);
// compiled op node returning opresult8978 (depth = 6)
  int op_slot_left_8958 = gc_frame_newslot(opresult8978);
  params[0] = call8966;
  partcv[0] = 1;
  Object opresult8979 = callmethod(opresult8978, "++(1)", 1, partcv, params);
// compiled op node returning opresult8979 (depth = 5)
  *var_s = opresult8979;
  if (opresult8979 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8951 = done;
  } else {
  }
// compiled if node returning if8951 (depth = 3)
// Begin line 2398
  setline(2398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8983 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8984 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8983);
// compiled member node returning call8984 (depth = 5)
  int op_slot_right_8982 = gc_frame_newslot(call8984);
// starting to compile identifier node (depth = 5)
  Object bool8986 = alloc_Boolean(0);
// compiled identifier node returning bool8986 (depth = 5)
  int op_slot_left_8982 = gc_frame_newslot(bool8986);
  params[0] = call8984;
  partcv[0] = 1;
  Object opresult8987 = callmethod(bool8986, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8987 (depth = 4)
  Object if8981 = done;
  if (istrue(opresult8987)) {
// Begin line 2399
  setline(2399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8989 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8991 = alloc_Float64(2);
// compiled num node returning num8991 (depth = 8)
  int op_slot_right_8990 = gc_frame_newslot(num8991);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8990 = gc_frame_newslot(*var_depth);
  params[0] = num8991;
  partcv[0] = 1;
  Object sum8993 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8993 (depth = 7)
  gc_frame_newslot(sum8993);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8994 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8995 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8994);
// compiled member node returning call8995 (depth = 7)
  params[0] = sum8993;
  partcv[0] = 1;
  Object call8996 = callmethodflags(call8995, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8989);
// compiled call node returning call8996 (depth = 6)
  int op_slot_right_8988 = gc_frame_newslot(call8996);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8999 == NULL) {
    strlit8999 = alloc_String("Value: ");
    gc_root(strlit8999);
  }
// compiled string node returning strlit8999 (depth = 7)
  int op_slot_right_8998 = gc_frame_newslot(strlit8999);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_9001 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9004 == NULL) {
    strlit9004 = alloc_String("""\x0a""");
    gc_root(strlit9004);
  }
// compiled string node returning strlit9004 (depth = 9)
  int op_slot_right_9003 = gc_frame_newslot(strlit9004);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_9003 = gc_frame_newslot(*var_s);
  params[0] = strlit9004;
  partcv[0] = 1;
  Object opresult9006 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9006 (depth = 8)
  int op_slot_left_9001 = gc_frame_newslot(opresult9006);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9007 = callmethod(opresult9006, "++(1)", 1, partcv, params);
// compiled op node returning opresult9007 (depth = 7)
  int op_slot_left_8998 = gc_frame_newslot(opresult9007);
  params[0] = strlit8999;
  partcv[0] = 1;
  Object opresult9008 = callmethod(opresult9007, "++(1)", 1, partcv, params);
// compiled op node returning opresult9008 (depth = 6)
  int op_slot_left_8988 = gc_frame_newslot(opresult9008);
  params[0] = call8996;
  partcv[0] = 1;
  Object opresult9009 = callmethod(opresult9008, "++(1)", 1, partcv, params);
// compiled op node returning opresult9009 (depth = 5)
  *var_s = opresult9009;
  if (opresult9009 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8981 = done;
  } else {
  }
// compiled if node returning if8981 (depth = 3)
// Begin line 2401
  setline(2401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9012 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9013 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9014 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9015 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9014);
// compiled member node returning call9015 (depth = 6)
  partcv[0] = 0;
  Object call9016 = callmethodflags(call9015, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe9013);
// compiled member node returning call9016 (depth = 5)
  partcv[0] = 0;
  Object call9017 = callmethodflags(call9016, "not", 1, partcv, params, 0);
  gc_frame_end(callframe9012);
// compiled member node returning call9017 (depth = 4)
  Object if9011 = done;
  if (istrue(call9017)) {
// Begin line 2402
  setline(2402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9020 == NULL) {
    strlit9020 = alloc_String("Annotations:");
    gc_root(strlit9020);
  }
// compiled string node returning strlit9020 (depth = 7)
  int op_slot_right_9019 = gc_frame_newslot(strlit9020);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_9022 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 8)
  if (strlit9024 == NULL) {
    strlit9024 = alloc_String("""\x0a""");
    gc_root(strlit9024);
  }
// compiled string node returning strlit9024 (depth = 8)
  int op_slot_left_9022 = gc_frame_newslot(strlit9024);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9025 = callmethod(strlit9024, "++(1)", 1, partcv, params);
// compiled op node returning opresult9025 (depth = 7)
  int op_slot_left_9019 = gc_frame_newslot(opresult9025);
  params[0] = strlit9020;
  partcv[0] = 1;
  Object opresult9026 = callmethod(opresult9025, "++(1)", 1, partcv, params);
// compiled op node returning opresult9026 (depth = 6)
  int op_slot_right_9018 = gc_frame_newslot(opresult9026);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9018 = gc_frame_newslot(*var_s);
  params[0] = opresult9026;
  partcv[0] = 1;
  Object opresult9028 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9028 (depth = 5)
  *var_s = opresult9028;
  if (opresult9028 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2403
  setline(2403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9030 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block9031 = alloc_Block(NULL, NULL, "ast", 2403);
  gc_frame_newslot(block9031);
// method "_apply(_)"
  block_savedest(block9031);
  Object closure9032 = createclosure(3, "_apply(1)");
  setclosureframe(closure9032, stackframe);
  addtoclosure(closure9032, var_depth);
  addtoclosure(closure9032, var_s);
  addtoclosure(closure9032, selfslot);
  struct UserObject *uo9032 = (struct UserObject*)block9031;
  uo9032->data[0] = (Object)closure9032;
  Method *meth_meth_ast_9032__apply_40_1_41_ = addmethod2pos(block9031, "_apply(1)", &meth_ast_9032__apply_40_1_41_, 0);
  int argcv_meth_ast_9032__apply_40_1_41_[] = {1};
  meth_meth_ast_9032__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9032__apply_40_1_41_);
  meth_meth_ast_9032__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9032__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block9031 (depth = 5)
  gc_frame_newslot(block9031);
// call case 6: other requests
// Begin line 2403
  setline(2403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe9056 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9057 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9056);
// compiled member node returning call9057 (depth = 5)
  params[0] = block9031;
  partcv[0] = 1;
  Object call9058 = callmethodflags(call9057, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9030);
// compiled call node returning call9058 (depth = 4)
    gc_frame_newslot(call9058);
    if9011 = call9058;
  } else {
  }
// compiled if node returning if9011 (depth = 3)
// Begin line 2407
  setline(2407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9061 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9062 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9061);
// compiled member node returning call9062 (depth = 5)
  int op_slot_right_9060 = gc_frame_newslot(call9062);
// starting to compile identifier node (depth = 5)
  Object bool9064 = alloc_Boolean(0);
// compiled identifier node returning bool9064 (depth = 5)
  int op_slot_left_9060 = gc_frame_newslot(bool9064);
  params[0] = call9062;
  partcv[0] = 1;
  Object opresult9065 = callmethod(bool9064, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9065 (depth = 4)
  Object if9059 = done;
  if (istrue(opresult9065)) {
// Begin line 2408
  setline(2408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9067 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num9069 = alloc_Float64(2);
// compiled num node returning num9069 (depth = 8)
  int op_slot_right_9068 = gc_frame_newslot(num9069);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_9068 = gc_frame_newslot(*var_depth);
  params[0] = num9069;
  partcv[0] = 1;
  Object sum9071 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum9071 (depth = 7)
  gc_frame_newslot(sum9071);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9072 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9073 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9072);
// compiled member node returning call9073 (depth = 7)
  params[0] = sum9071;
  partcv[0] = 1;
  Object call9074 = callmethodflags(call9073, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9067);
// compiled call node returning call9074 (depth = 6)
  int op_slot_right_9066 = gc_frame_newslot(call9074);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9066 = gc_frame_newslot(*var_s);
  params[0] = call9074;
  partcv[0] = 1;
  Object opresult9076 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9076 (depth = 5)
  *var_s = opresult9076;
  if (opresult9076 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9059 = done;
  } else {
  }
// compiled if node returning if9059 (depth = 3)
// Begin line 2410
  setline(2410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_9099__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2416
  setline(2416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9101 == NULL) {
    strlit9101 = alloc_String("Unknown");
    gc_root(strlit9101);
  }
// compiled string node returning strlit9101 (depth = 7)
  int op_slot_right_9100 = gc_frame_newslot(strlit9101);
// starting to compile member node (depth = 7)
  int callframe9103 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe9104 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9105 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9104);
// compiled member node returning call9105 (depth = 8)
  partcv[0] = 0;
  Object call9106 = callmethodflags(call9105, "value", 1, partcv, params, 0);
  gc_frame_end(callframe9103);
// compiled member node returning call9106 (depth = 7)
  int op_slot_left_9100 = gc_frame_newslot(call9106);
  params[0] = strlit9101;
  partcv[0] = 1;
  Object opresult9107 = callmethod(call9106, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9107 (depth = 6)
  gc_frame_end(frame);
  return opresult9107;
}
Object meth_ast_9147__apply_40_2_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2422
  setline(2422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9149 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num9150 = alloc_Float64(0);
// compiled num node returning num9150 (depth = 10)
  gc_frame_newslot(num9150);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_b (depth = 10)
  params[0] = num9150;
  partcv[0] = 1;
  Object call9151 = callmethodflags(*var_b, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9149);
// compiled call node returning call9151 (depth = 9)
  int op_slot_right_9148 = gc_frame_newslot(call9151);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit9155 == NULL) {
    strlit9155 = alloc_String("");
    gc_root(strlit9155);
  }
// compiled string node returning strlit9155 (depth = 11)
  int op_slot_right_9154 = gc_frame_newslot(strlit9155);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_9154 = gc_frame_newslot(*var_a);
  params[0] = strlit9155;
  partcv[0] = 1;
  Object opresult9157 = callmethod(*var_a, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9157 (depth = 10)
  Object if9153 = done;
struct StackFrameObject *iftmpstackframe9153 = stackframe;
  if (istrue(opresult9157)) {
stackframe = alloc_StackFrame(0, iftmpstackframe9153);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit9159 == NULL) {
    strlit9159 = alloc_String(", ");
    gc_root(strlit9159);
  }
// compiled string node returning strlit9159 (depth = 11)
  int op_slot_right_9158 = gc_frame_newslot(strlit9159);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_9158 = gc_frame_newslot(*var_a);
  params[0] = strlit9159;
  partcv[0] = 1;
  Object opresult9161 = callmethod(*var_a, "++(1)", 1, partcv, params);
// compiled op node returning opresult9161 (depth = 10)
    gc_frame_newslot(opresult9161);
    if9153 = opresult9161;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe9153);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile string node (depth = 10)
  if (strlit9162 == NULL) {
    strlit9162 = alloc_String("");
    gc_root(strlit9162);
  }
// compiled string node returning strlit9162 (depth = 10)
    gc_frame_newslot(strlit9162);
    if9153 = strlit9162;
  }
stackframe = iftmpstackframe9153;
// compiled if node returning if9153 (depth = 9)
  int op_slot_left_9148 = gc_frame_newslot(if9153);
  params[0] = call9151;
  partcv[0] = 1;
  Object opresult9163 = callmethod(if9153, "++(1)", 1, partcv, params);
// compiled op node returning opresult9163 (depth = 8)
  gc_frame_end(frame);
  return opresult9163;
}
Object meth_ast_9078_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2413
  setline(2413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_9079 = gc_frame_newslot(*var_depth);
// starting to compile string node (depth = 5)
  if (strlit9081 == NULL) {
    strlit9081 = alloc_String("    ");
    gc_root(strlit9081);
  }
// compiled string node returning strlit9081 (depth = 5)
  int op_slot_left_9079 = gc_frame_newslot(strlit9081);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object prod9082 = callmethod(strlit9081, "*(1)", 1, partcv, params);
// compiled op node returning prod9082 (depth = 4)
  *var_spc = prod9082;
  if (prod9082 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2414
  setline(2414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9084 == NULL) {
    strlit9084 = alloc_String("");
    gc_root(strlit9084);
  }
// compiled string node returning strlit9084 (depth = 5)
  int op_slot_right_9083 = gc_frame_newslot(strlit9084);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9087 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num9088 = alloc_Float64(0);
// compiled num node returning num9088 (depth = 7)
  gc_frame_newslot(num9088);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9089 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9090 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9089);
// compiled member node returning call9090 (depth = 7)
  params[0] = num9088;
  partcv[0] = 1;
  Object call9091 = callmethodflags(call9090, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9087);
// compiled call node returning call9091 (depth = 6)
  int op_slot_right_9086 = gc_frame_newslot(call9091);
// starting to compile string node (depth = 6)
  if (strlit9093 == NULL) {
    strlit9093 = alloc_String("def ");
    gc_root(strlit9093);
  }
// compiled string node returning strlit9093 (depth = 6)
  int op_slot_left_9086 = gc_frame_newslot(strlit9093);
  params[0] = call9091;
  partcv[0] = 1;
  Object opresult9094 = callmethod(strlit9093, "++(1)", 1, partcv, params);
// compiled op node returning opresult9094 (depth = 5)
  int op_slot_left_9083 = gc_frame_newslot(opresult9094);
  params[0] = strlit9084;
  partcv[0] = 1;
  Object opresult9095 = callmethod(opresult9094, "++(1)", 1, partcv, params);
// compiled op node returning opresult9095 (depth = 4)
  *var_s = opresult9095;
  if (opresult9095 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2415
  setline(2415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block9098 = alloc_Block(NULL, NULL, "ast", 2415);
  gc_frame_newslot(block9098);
// method "_apply"
  block_savedest(block9098);
  Object closure9099 = createclosure(1, "_apply");
  setclosureframe(closure9099, stackframe);
  addtoclosure(closure9099, selfslot);
  struct UserObject *uo9099 = (struct UserObject*)block9098;
  uo9099->data[0] = (Object)closure9099;
  Method *meth_meth_ast_9099__apply = addmethod2pos(block9098, "_apply", &meth_ast_9099__apply, 0);
  int argcv_meth_ast_9099__apply[] = {0};
  meth_meth_ast_9099__apply->type = alloc_MethodType(1, argcv_meth_ast_9099__apply);
  meth_meth_ast_9099__apply->definitionModule = modulename;
  meth_meth_ast_9099__apply->definitionLine = 3050;
// compiled block node returning block9098 (depth = 5)
  int op_slot_right_9097 = gc_frame_newslot(block9098);
// Begin line 2415
  setline(2415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9111 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9112 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9111);
// compiled member node returning call9112 (depth = 6)
  int op_slot_right_9110 = gc_frame_newslot(call9112);
// starting to compile identifier node (depth = 6)
  Object bool9114 = alloc_Boolean(0);
// compiled identifier node returning bool9114 (depth = 6)
  int op_slot_left_9110 = gc_frame_newslot(bool9114);
  params[0] = call9112;
  partcv[0] = 1;
  Object opresult9115 = callmethod(bool9114, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9115 (depth = 5)
  int op_slot_left_9097 = gc_frame_newslot(opresult9115);
  params[0] = block9098;
  partcv[0] = 1;
  Object opresult9116 = callmethod(opresult9115, "&&(1)", 1, partcv, params);
// compiled op node returning opresult9116 (depth = 4)
  Object if9096 = done;
  if (istrue(opresult9116)) {
// Begin line 2417
  setline(2417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9118 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num9119 = alloc_Float64(0);
// compiled num node returning num9119 (depth = 7)
  gc_frame_newslot(num9119);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9120 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9121 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9120);
// compiled member node returning call9121 (depth = 7)
  params[0] = num9119;
  partcv[0] = 1;
  Object call9122 = callmethodflags(call9121, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9118);
// compiled call node returning call9122 (depth = 6)
  int op_slot_right_9117 = gc_frame_newslot(call9122);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9125 == NULL) {
    strlit9125 = alloc_String(" : ");
    gc_root(strlit9125);
  }
// compiled string node returning strlit9125 (depth = 7)
  int op_slot_right_9124 = gc_frame_newslot(strlit9125);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_9124 = gc_frame_newslot(*var_s);
  params[0] = strlit9125;
  partcv[0] = 1;
  Object opresult9127 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9127 (depth = 6)
  int op_slot_left_9117 = gc_frame_newslot(opresult9127);
  params[0] = call9122;
  partcv[0] = 1;
  Object opresult9128 = callmethod(opresult9127, "++(1)", 1, partcv, params);
// compiled op node returning opresult9128 (depth = 5)
  *var_s = opresult9128;
  if (opresult9128 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9096 = done;
  } else {
  }
// compiled if node returning if9096 (depth = 3)
// Begin line 2419
  setline(2419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num9132 = alloc_Float64(0);
// compiled num node returning num9132 (depth = 5)
  int op_slot_right_9131 = gc_frame_newslot(num9132);
// starting to compile member node (depth = 5)
  int callframe9134 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9135 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9136 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9135);
// compiled member node returning call9136 (depth = 6)
  partcv[0] = 0;
  Object call9137 = callmethodflags(call9136, "size", 1, partcv, params, 0);
  gc_frame_end(callframe9134);
// compiled member node returning call9137 (depth = 5)
  int op_slot_left_9131 = gc_frame_newslot(call9137);
  params[0] = num9132;
  partcv[0] = 1;
  Object opresult9138 = callmethod(call9137, ">(1)", 1, partcv, params);
// compiled op node returning opresult9138 (depth = 4)
  Object if9130 = done;
  if (istrue(opresult9138)) {
// Begin line 2420
  setline(2420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9140 == NULL) {
    strlit9140 = alloc_String(" is ");
    gc_root(strlit9140);
  }
// compiled string node returning strlit9140 (depth = 6)
  int op_slot_right_9139 = gc_frame_newslot(strlit9140);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9139 = gc_frame_newslot(*var_s);
  params[0] = strlit9140;
  partcv[0] = 1;
  Object opresult9142 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9142 (depth = 5)
  *var_s = opresult9142;
  if (opresult9142 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2421
  setline(2421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9145 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block9146 = alloc_Block(NULL, NULL, "ast", 2421);
  gc_frame_newslot(block9146);
// method "_apply(_,_)"
  block_savedest(block9146);
  Object closure9147 = createclosure(1, "_apply(2)");
  setclosureframe(closure9147, stackframe);
  addtoclosure(closure9147, selfslot);
  struct UserObject *uo9147 = (struct UserObject*)block9146;
  uo9147->data[0] = (Object)closure9147;
  Method *meth_meth_ast_9147__apply_40_2_41_ = addmethod2pos(block9146, "_apply(2)", &meth_ast_9147__apply_40_2_41_, 0);
  int argcv_meth_ast_9147__apply_40_2_41_[] = {2};
  meth_meth_ast_9147__apply_40_2_41_->type = alloc_MethodType(1, argcv_meth_ast_9147__apply_40_2_41_);
  meth_meth_ast_9147__apply_40_2_41_->definitionModule = modulename;
  meth_meth_ast_9147__apply_40_2_41_->definitionLine = 3050;
// compiled block node returning block9146 (depth = 7)
  gc_frame_newslot(block9146);
// Begin line 2423
  setline(2423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit9165 == NULL) {
    strlit9165 = alloc_String("");
    gc_root(strlit9165);
  }
// compiled string node returning strlit9165 (depth = 7)
  gc_frame_newslot(strlit9165);
// call case 6: other requests
// Begin line 2421
  setline(2421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe9166 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9167 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9166);
// compiled member node returning call9167 (depth = 7)
  params[0] = block9146;
  params[1] = strlit9165;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9168 = callmethodflags(call9167, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9145);
// compiled call node returning call9168 (depth = 6)
  int op_slot_right_9144 = gc_frame_newslot(call9168);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9144 = gc_frame_newslot(*var_s);
  params[0] = call9168;
  partcv[0] = 1;
  Object opresult9170 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9170 (depth = 5)
  *var_s = opresult9170;
  if (opresult9170 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9130 = done;
  } else {
  }
// compiled if node returning if9130 (depth = 3)
// Begin line 2425
  setline(2425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9174 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9175 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9174);
// compiled member node returning call9175 (depth = 5)
  int op_slot_right_9173 = gc_frame_newslot(call9175);
// starting to compile identifier node (depth = 5)
  Object bool9177 = alloc_Boolean(0);
// compiled identifier node returning bool9177 (depth = 5)
  int op_slot_left_9173 = gc_frame_newslot(bool9177);
  params[0] = call9175;
  partcv[0] = 1;
  Object opresult9178 = callmethod(bool9177, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9178 (depth = 4)
  Object if9172 = done;
  if (istrue(opresult9178)) {
// Begin line 2426
  setline(2426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9180 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9181 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9182 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9181);
// compiled member node returning call9182 (depth = 7)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9183 = callmethodflags(call9182, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9180);
// compiled call node returning call9183 (depth = 6)
  int op_slot_right_9179 = gc_frame_newslot(call9183);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9186 == NULL) {
    strlit9186 = alloc_String(" = ");
    gc_root(strlit9186);
  }
// compiled string node returning strlit9186 (depth = 7)
  int op_slot_right_9185 = gc_frame_newslot(strlit9186);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_9185 = gc_frame_newslot(*var_s);
  params[0] = strlit9186;
  partcv[0] = 1;
  Object opresult9188 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9188 (depth = 6)
  int op_slot_left_9179 = gc_frame_newslot(opresult9188);
  params[0] = call9183;
  partcv[0] = 1;
  Object opresult9189 = callmethod(opresult9188, "++(1)", 1, partcv, params);
// compiled op node returning opresult9189 (depth = 5)
  *var_s = opresult9189;
  if (opresult9189 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9172 = done;
  } else {
  }
// compiled if node returning if9172 (depth = 3)
// Begin line 2428
  setline(2428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_9191_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_defDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2431
  setline(2431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9192 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe9193 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9194 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9195 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9194);
// compiled member node returning call9195 (depth = 5)
  gc_frame_newslot(call9195);
// starting to compile member node (depth = 5)
  int callframe9196 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9197 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9196);
// compiled member node returning call9197 (depth = 5)
  gc_frame_newslot(call9197);
// starting to compile member node (depth = 5)
  int callframe9198 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9199 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9198);
// compiled member node returning call9199 (depth = 5)
  gc_frame_newslot(call9199);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_defDecNode (depth = 5)
  params[0] = call9195;
  params[1] = call9197;
  params[2] = call9199;
  partcv[0] = 3;
  Object call9200 = callmethodflags(*var_defDecNode, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe9193);
// compiled call node returning call9200 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call9201 = callmethodflags(call9200, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9192);
// compiled call node returning call9201 (depth = 3)
  gc_frame_end(frame);
  return call9201;
}
Object meth_ast_9202_postCopy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "postCopy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method postCopy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for postCopy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part postCopy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2434
  setline(2434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9203 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe9204 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call9205 = callmethodflags(*var_other, "startToken", 1, partcv, params, 0);
  gc_frame_end(callframe9204);
// compiled member node returning call9205 (depth = 4)
  gc_frame_newslot(call9205);
// call case 4: self request
  params[0] = call9205;
  partcv[0] = 1;
  Object call9206 = callmethodflags(self, "startToken:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9203);
// compiled call node returning call9206 (depth = 3)
// Begin line 2435
  setline(2435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9207 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe9208 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call9209 = callmethodflags(*var_other, "parentKind", 1, partcv, params, 0);
  gc_frame_end(callframe9208);
// compiled member node returning call9209 (depth = 4)
  gc_frame_newslot(call9209);
// call case 4: self request
  params[0] = call9209;
  partcv[0] = 1;
  Object call9210 = callmethodflags(self, "parentKind:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9207);
// compiled call node returning call9210 (depth = 3)
// Begin line 2436
  setline(2436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_9211_statementName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2438
  setline(2438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9212 == NULL) {
    strlit9212 = alloc_String("definition");
    gc_root(strlit9212);
  }
// compiled string node returning strlit9212 (depth = 3)
  gc_frame_end(frame);
  return strlit9212;
}
Object meth_ast_8799_new_40_3_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_defDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val = &(stackframe->slots[1]);
  *var_val = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8800 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8800 = alloc_userobj2(30,25, objclass8800);
  gc_frame_newslot(obj8800);
  if (objclass8800 == NULL) {
    glfree(obj8800->class->name);
    obj8800->class->name = "defDecNode.new(_,_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj8800, self, 0);
  addmethodreal(obj8800,"outer", &reader_ast_outer_8801);
  Object oldself8800 = self;
  struct StackFrameObject *oldstackframe8800 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8800);
  gc_frame_newslot((Object)stackframe);
  self = obj8800;
  Object *oldselfslot8800 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8800 = (*(struct UserObject *)self).data[0], lowerouter8800 = thisouter8800;
  if (inheritingObject8800) {
    struct UserObject *inho8800 = (struct UserObject *)inheritingObject8800;
    while (inho8800->super != GraceDefaultObject) inho8800 = (struct UserObject *)inho8800->super;
    inho8800->super = obj8800;
    self = inheritingObject8800;
    *selfslot = self;
    lowerouter8800 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8800;
  }
  if (objclass8800 == NULL) {
  Method *reader8802 = addmethodrealflags(obj8800, "kind",&reader_ast_kind_8802, MFLAG_DEF);
  reader8802->definitionModule = modulename;
  reader8802->definitionLine = 2337;
  }
  adddatum2(obj8800, alloc_Undefined(), 1);
  if (objclass8800 == NULL) {
    Method *reader8803 = addmethodrealflags(obj8800, "name", &reader_ast_name_8803, 0);
    Method *writer8803 = addmethodrealflags(obj8800, "name:=(1)", &writer_ast_name_8803, 0);
    reader8803->definitionModule = modulename;
    writer8803->definitionModule = modulename;
    reader8803->definitionLine = 2338;
    writer8803->definitionLine = 2338;
  }
  obj8800->flags |= OFLAG_MUTABLE;
  adddatum2(obj8800, alloc_Undefined(), 2);
  if (objclass8800 == NULL) {
    Method *reader8804 = addmethodrealflags(obj8800, "value", &reader_ast_value_8804, 0);
    Method *writer8804 = addmethodrealflags(obj8800, "value:=(1)", &writer_ast_value_8804, 0);
    reader8804->definitionModule = modulename;
    writer8804->definitionModule = modulename;
    reader8804->definitionLine = 2339;
    writer8804->definitionLine = 2339;
  }
  obj8800->flags |= OFLAG_MUTABLE;
  adddatum2(obj8800, alloc_Undefined(), 3);
  if (objclass8800 == NULL) {
    Method *reader8805 = addmethodrealflags(obj8800, "dtype", &reader_ast_dtype_8805, 0);
    Method *writer8805 = addmethodrealflags(obj8800, "dtype:=(1)", &writer_ast_dtype_8805, 0);
    reader8805->definitionModule = modulename;
    writer8805->definitionModule = modulename;
    reader8805->definitionLine = 2340;
    writer8805->definitionLine = 2340;
  }
  obj8800->flags |= OFLAG_MUTABLE;
  adddatum2(obj8800, alloc_Undefined(), 4);
  if (objclass8800 == NULL) {
    Method *reader8806 = addmethodrealflags(obj8800, "parentKind", &reader_ast_parentKind_8806, 0);
    Method *writer8806 = addmethodrealflags(obj8800, "parentKind:=(1)", &writer_ast_parentKind_8806, 0);
    reader8806->definitionModule = modulename;
    writer8806->definitionModule = modulename;
    reader8806->definitionLine = 2341;
    writer8806->definitionLine = 2341;
  }
  obj8800->flags |= OFLAG_MUTABLE;
  adddatum2(obj8800, alloc_Undefined(), 5);
  if (objclass8800 == NULL) {
  Method *reader8807 = addmethodrealflags(obj8800, "nameString",&reader_ast_nameString_8807, MFLAG_DEF);
  reader8807->definitionModule = modulename;
  reader8807->definitionLine = 2342;
  }
  adddatum2(obj8800, alloc_Undefined(), 6);
  if (objclass8800 == NULL) {
    Method *reader8808 = addmethodrealflags(obj8800, "annotations", &reader_ast_annotations_8808, 0);
    Method *writer8808 = addmethodrealflags(obj8800, "annotations:=(1)", &writer_ast_annotations_8808, 0);
    reader8808->definitionModule = modulename;
    writer8808->definitionModule = modulename;
    reader8808->definitionLine = 2343;
    writer8808->definitionLine = 2343;
  }
  obj8800->flags |= OFLAG_MUTABLE;
  adddatum2(obj8800, alloc_Undefined(), 7);
  if (objclass8800 == NULL) {
    Method *reader8809 = addmethodrealflags(obj8800, "startToken", &reader_ast_startToken_8809, 0);
    Method *writer8809 = addmethodrealflags(obj8800, "startToken:=(1)", &writer_ast_startToken_8809, 0);
    reader8809->definitionModule = modulename;
    writer8809->definitionModule = modulename;
    reader8809->definitionLine = 2344;
    writer8809->definitionLine = 2344;
  }
  obj8800->flags |= OFLAG_MUTABLE;
  adddatum2(obj8800, alloc_Undefined(), 8);
// method "end"
  struct UserObject *uo8810 = (struct UserObject*)obj8800;
  uo8810->data[9] = emptyclosure;
  Method *meth_meth_ast_8810_end = addmethod2pos(obj8800, "end", &meth_ast_8810_end, 9);
  int argcv_meth_ast_8810_end[] = {0};
  meth_meth_ast_8810_end->type = alloc_MethodType(1, argcv_meth_ast_8810_end);
  meth_meth_ast_8810_end->definitionModule = modulename;
  meth_meth_ast_8810_end->definitionLine = 2346;
// method "isPublic"
  struct UserObject *uo8815 = (struct UserObject*)obj8800;
  uo8815->data[10] = emptyclosure;
  Method *meth_meth_ast_8815_isPublic = addmethod2pos(obj8800, "isPublic", &meth_ast_8815_isPublic, 10);
  int argcv_meth_ast_8815_isPublic[] = {0};
  meth_meth_ast_8815_isPublic->type = alloc_MethodType(1, argcv_meth_ast_8815_isPublic);
  meth_meth_ast_8815_isPublic->definitionModule = modulename;
  meth_meth_ast_8815_isPublic->definitionLine = 2347;
// method "isFieldDec"
  struct UserObject *uo8834 = (struct UserObject*)obj8800;
  uo8834->data[11] = emptyclosure;
  Method *meth_meth_ast_8834_isFieldDec = addmethod2pos(obj8800, "isFieldDec", &meth_ast_8834_isFieldDec, 11);
  int argcv_meth_ast_8834_isFieldDec[] = {0};
  meth_meth_ast_8834_isFieldDec->type = alloc_MethodType(1, argcv_meth_ast_8834_isFieldDec);
  meth_meth_ast_8834_isFieldDec->definitionModule = modulename;
  meth_meth_ast_8834_isFieldDec->definitionLine = 2353;
// method "isWritable"
  struct UserObject *uo8836 = (struct UserObject*)obj8800;
  uo8836->data[12] = emptyclosure;
  Method *meth_meth_ast_8836_isWritable = addmethod2pos(obj8800, "isWritable", &meth_ast_8836_isWritable, 12);
  int argcv_meth_ast_8836_isWritable[] = {0};
  meth_meth_ast_8836_isWritable->type = alloc_MethodType(1, argcv_meth_ast_8836_isWritable);
  meth_meth_ast_8836_isWritable->definitionModule = modulename;
  meth_meth_ast_8836_isWritable->definitionLine = 2354;
// method "isReadable"
  struct UserObject *uo8838 = (struct UserObject*)obj8800;
  uo8838->data[13] = emptyclosure;
  Method *meth_meth_ast_8838_isReadable = addmethod2pos(obj8800, "isReadable", &meth_ast_8838_isReadable, 13);
  int argcv_meth_ast_8838_isReadable[] = {0};
  meth_meth_ast_8838_isReadable->type = alloc_MethodType(1, argcv_meth_ast_8838_isReadable);
  meth_meth_ast_8838_isReadable->definitionModule = modulename;
  meth_meth_ast_8838_isReadable->definitionLine = 2355;
// method "returnsObject"
  struct UserObject *uo8841 = (struct UserObject*)obj8800;
  uo8841->data[14] = emptyclosure;
  Method *meth_meth_ast_8841_returnsObject = addmethod2pos(obj8800, "returnsObject", &meth_ast_8841_returnsObject, 14);
  int argcv_meth_ast_8841_returnsObject[] = {0};
  meth_meth_ast_8841_returnsObject->type = alloc_MethodType(1, argcv_meth_ast_8841_returnsObject);
  meth_meth_ast_8841_returnsObject->definitionModule = modulename;
  meth_meth_ast_8841_returnsObject->definitionLine = 2357;
// method "returnedObjectScope"
  struct UserObject *uo8846 = (struct UserObject*)obj8800;
  uo8846->data[15] = emptyclosure;
  Method *meth_meth_ast_8846_returnedObjectScope = addmethod2pos(obj8800, "returnedObjectScope", &meth_ast_8846_returnedObjectScope, 15);
  int argcv_meth_ast_8846_returnedObjectScope[] = {0};
  meth_meth_ast_8846_returnedObjectScope->type = alloc_MethodType(1, argcv_meth_ast_8846_returnedObjectScope);
  meth_meth_ast_8846_returnedObjectScope->definitionModule = modulename;
  meth_meth_ast_8846_returnedObjectScope->definitionLine = 2360;
// method "usesAsType(_)"
  struct UserObject *uo8851 = (struct UserObject*)obj8800;
  uo8851->data[16] = emptyclosure;
  Method *meth_meth_ast_8851_usesAsType_40_1_41_ = addmethod2pos(obj8800, "usesAsType(1)", &meth_ast_8851_usesAsType_40_1_41_, 16);
  int argcv_meth_ast_8851_usesAsType_40_1_41_[] = {1};
  meth_meth_ast_8851_usesAsType_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8851_usesAsType_40_1_41_);
  meth_meth_ast_8851_usesAsType_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8851_usesAsType_40_1_41_->definitionLine = 2364;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj8800);
  Object closure8857 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure8857, stackframe);
  addtoclosure(closure8857, var_k);
  struct UserObject *uo8857 = (struct UserObject*)obj8800;
  uo8857->data[17] = (Object)closure8857;
  Method *meth_meth_ast_8857_declarationKindWithAncestors_40_1_41_ = addmethod2pos(obj8800, "declarationKindWithAncestors(1)", &meth_ast_8857_declarationKindWithAncestors_40_1_41_, 17);
  int argcv_meth_ast_8857_declarationKindWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_8857_declarationKindWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8857_declarationKindWithAncestors_40_1_41_);
  meth_meth_ast_8857_declarationKindWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8857_declarationKindWithAncestors_40_1_41_->definitionLine = 2367;
// method "accept(_)from(_)"
  struct UserObject *uo8860 = (struct UserObject*)obj8800;
  uo8860->data[18] = emptyclosure;
  Method *meth_meth_ast_8860_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj8800, "accept(1)from(1)", &meth_ast_8860_accept_40_1_41_from_40_1_41_, 18);
  int argcv_meth_ast_8860_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_8860_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_8860_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_8860_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8860_accept_40_1_41_from_40_1_41_->definitionLine = 2369;
// method "map(_)ancestors(_)"
  struct UserObject *uo8894 = (struct UserObject*)obj8800;
  uo8894->data[19] = emptyclosure;
  Method *meth_meth_ast_8894_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj8800, "map(1)ancestors(1)", &meth_ast_8894_map_40_1_41_ancestors_40_1_41_, 19);
  int argcv_meth_ast_8894_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_8894_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_8894_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_8894_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8894_map_40_1_41_ancestors_40_1_41_->definitionLine = 2382;
// method "pretty(_)"
  struct UserObject *uo8925 = (struct UserObject*)obj8800;
  uo8925->data[20] = emptyclosure;
  Method *meth_meth_ast_8925_pretty_40_1_41_ = addmethod2pos(obj8800, "pretty(1)", &meth_ast_8925_pretty_40_1_41_, 20);
  int argcv_meth_ast_8925_pretty_40_1_41_[] = {1};
  meth_meth_ast_8925_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8925_pretty_40_1_41_);
  meth_meth_ast_8925_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8925_pretty_40_1_41_->definitionLine = 2391;
// method "toGrace(_)"
  struct UserObject *uo9078 = (struct UserObject*)obj8800;
  uo9078->data[21] = emptyclosure;
  Method *meth_meth_ast_9078_toGrace_40_1_41_ = addmethod2pos(obj8800, "toGrace(1)", &meth_ast_9078_toGrace_40_1_41_, 21);
  int argcv_meth_ast_9078_toGrace_40_1_41_[] = {1};
  meth_meth_ast_9078_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9078_toGrace_40_1_41_);
meth_meth_ast_9078_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_9078_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_9078_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9078_toGrace_40_1_41_->definitionLine = 2412;
// method "shallowCopy"
  block_savedest(obj8800);
  Object closure9191 = createclosure(1, "shallowCopy");
  setclosureframe(closure9191, stackframe);
  addtoclosure(closure9191, var_defDecNode);
  struct UserObject *uo9191 = (struct UserObject*)obj8800;
  uo9191->data[22] = (Object)closure9191;
  Method *meth_meth_ast_9191_shallowCopy = addmethod2pos(obj8800, "shallowCopy", &meth_ast_9191_shallowCopy, 22);
  int argcv_meth_ast_9191_shallowCopy[] = {0};
  meth_meth_ast_9191_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_9191_shallowCopy);
  meth_meth_ast_9191_shallowCopy->definitionModule = modulename;
  meth_meth_ast_9191_shallowCopy->definitionLine = 2430;
// method "postCopy(_)"
  struct UserObject *uo9202 = (struct UserObject*)obj8800;
  uo9202->data[23] = emptyclosure;
  Method *meth_meth_ast_9202_postCopy_40_1_41_ = addmethod2pos(obj8800, "postCopy(1)", &meth_ast_9202_postCopy_40_1_41_, 23);
  int argcv_meth_ast_9202_postCopy_40_1_41_[] = {1};
  meth_meth_ast_9202_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9202_postCopy_40_1_41_);
  meth_meth_ast_9202_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9202_postCopy_40_1_41_->definitionLine = 2433;
// method "statementName"
  struct UserObject *uo9211 = (struct UserObject*)obj8800;
  uo9211->data[24] = emptyclosure;
  Method *meth_meth_ast_9211_statementName = addmethod2pos(obj8800, "statementName", &meth_ast_9211_statementName, 24);
  int argcv_meth_ast_9211_statementName[] = {0};
  meth_meth_ast_9211_statementName->type = alloc_MethodType(1, argcv_meth_ast_9211_statementName);
  meth_meth_ast_9211_statementName->definitionModule = modulename;
  meth_meth_ast_9211_statementName->definitionLine = 2438;
  sourceObject = obj8800;
// Begin line 2336
  setline(2336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9213 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9214 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9213);
// compiled call node returning call9214 (depth = 3)
  struct UserObject *obj8800_uo = (struct UserObject *)obj8800;
  obj8800_uo->super = call9214;
  sourceObject = obj8800;
// Begin line 2337
  setline(2337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9215 == NULL) {
    strlit9215 = alloc_String("defdec");
    gc_root(strlit9215);
  }
// compiled string node returning strlit9215 (depth = 3)
  adddatum2(obj8800, strlit9215, 1);
  sourceObject = obj8800;
// Begin line 2338
  setline(2338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj8800, *var_name_39_, 2);
  sourceObject = obj8800;
// Begin line 2339
  setline(2339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val (depth = 3)
  adddatum2(obj8800, *var_val, 3);
  sourceObject = obj8800;
// Begin line 2340
  setline(2340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj8800, *var_dtype_39_, 4);
  sourceObject = obj8800;
// Begin line 2341
  setline(2341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9216 == NULL) {
    strlit9216 = alloc_String("unset");
    gc_root(strlit9216);
  }
// compiled string node returning strlit9216 (depth = 3)
  adddatum2(obj8800, strlit9216, 5);
  sourceObject = obj8800;
// Begin line 2342
  setline(2342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9217 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9218 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9219 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9218);
// compiled member node returning call9219 (depth = 4)
  partcv[0] = 0;
  Object call9220 = callmethodflags(call9219, "nameString", 1, partcv, params, 0);
  gc_frame_end(callframe9217);
// compiled member node returning call9220 (depth = 3)
  adddatum2(obj8800, call9220, 6);
  sourceObject = obj8800;
// Begin line 2343
  setline(2343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array9221 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9221 (depth = 3)
  adddatum2(obj8800, array9221, 7);
  sourceObject = obj8800;
// Begin line 2344
  setline(2344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9222 = alloc_Boolean(0);
// compiled identifier node returning bool9222 (depth = 3)
  adddatum2(obj8800, bool9222, 8);
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  objclass8800 = obj8800->class;
  objclass8800->definitionModule = modulename;
  objclass8800->definitionLine = 2335;
  (*(struct UserObject *)self).data[0] = lowerouter8800;
  self = oldself8800;
  selfslot = oldselfslot8800;
  stackframe = oldstackframe8800;
  gc_frame_end(frame);
  return obj8800;
}
Object meth_ast_8799_new_40_3_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_defDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val = &(stackframe->slots[1]);
  *var_val = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8800 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8800 = alloc_userobj2(30,25, objclass8800);
  gc_frame_newslot(obj8800);
  if (objclass8800 == NULL) {
    glfree(obj8800->class->name);
    obj8800->class->name = "defDecNode.new(_,_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj8800, self, 0);
  addmethodreal(obj8800,"outer", &reader_ast_outer_8801);
  Object oldself8800 = self;
  struct StackFrameObject *oldstackframe8800 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8800);
  gc_frame_newslot((Object)stackframe);
  self = obj8800;
  Object *oldselfslot8800 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8800 = (*(struct UserObject *)self).data[0], lowerouter8800 = thisouter8800;
  if (inheritingObject8800) {
    struct UserObject *inho8800 = (struct UserObject *)inheritingObject8800;
    while (inho8800->super != GraceDefaultObject) inho8800 = (struct UserObject *)inho8800->super;
    inho8800->super = obj8800;
    self = inheritingObject8800;
    *selfslot = self;
    lowerouter8800 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8800;
  }
  if (objclass8800 == NULL) {
  Method *reader8802 = addmethodrealflags(obj8800, "kind",&reader_ast_kind_8802, MFLAG_DEF);
  reader8802->definitionModule = modulename;
  reader8802->definitionLine = 2337;
  }
  adddatum2(obj8800, alloc_Undefined(), 1);
  if (objclass8800 == NULL) {
    Method *reader8803 = addmethodrealflags(obj8800, "name", &reader_ast_name_8803, 0);
    Method *writer8803 = addmethodrealflags(obj8800, "name:=(1)", &writer_ast_name_8803, 0);
    reader8803->definitionModule = modulename;
    writer8803->definitionModule = modulename;
    reader8803->definitionLine = 2338;
    writer8803->definitionLine = 2338;
  }
  obj8800->flags |= OFLAG_MUTABLE;
  adddatum2(obj8800, alloc_Undefined(), 2);
  if (objclass8800 == NULL) {
    Method *reader8804 = addmethodrealflags(obj8800, "value", &reader_ast_value_8804, 0);
    Method *writer8804 = addmethodrealflags(obj8800, "value:=(1)", &writer_ast_value_8804, 0);
    reader8804->definitionModule = modulename;
    writer8804->definitionModule = modulename;
    reader8804->definitionLine = 2339;
    writer8804->definitionLine = 2339;
  }
  obj8800->flags |= OFLAG_MUTABLE;
  adddatum2(obj8800, alloc_Undefined(), 3);
  if (objclass8800 == NULL) {
    Method *reader8805 = addmethodrealflags(obj8800, "dtype", &reader_ast_dtype_8805, 0);
    Method *writer8805 = addmethodrealflags(obj8800, "dtype:=(1)", &writer_ast_dtype_8805, 0);
    reader8805->definitionModule = modulename;
    writer8805->definitionModule = modulename;
    reader8805->definitionLine = 2340;
    writer8805->definitionLine = 2340;
  }
  obj8800->flags |= OFLAG_MUTABLE;
  adddatum2(obj8800, alloc_Undefined(), 4);
  if (objclass8800 == NULL) {
    Method *reader8806 = addmethodrealflags(obj8800, "parentKind", &reader_ast_parentKind_8806, 0);
    Method *writer8806 = addmethodrealflags(obj8800, "parentKind:=(1)", &writer_ast_parentKind_8806, 0);
    reader8806->definitionModule = modulename;
    writer8806->definitionModule = modulename;
    reader8806->definitionLine = 2341;
    writer8806->definitionLine = 2341;
  }
  obj8800->flags |= OFLAG_MUTABLE;
  adddatum2(obj8800, alloc_Undefined(), 5);
  if (objclass8800 == NULL) {
  Method *reader8807 = addmethodrealflags(obj8800, "nameString",&reader_ast_nameString_8807, MFLAG_DEF);
  reader8807->definitionModule = modulename;
  reader8807->definitionLine = 2342;
  }
  adddatum2(obj8800, alloc_Undefined(), 6);
  if (objclass8800 == NULL) {
    Method *reader8808 = addmethodrealflags(obj8800, "annotations", &reader_ast_annotations_8808, 0);
    Method *writer8808 = addmethodrealflags(obj8800, "annotations:=(1)", &writer_ast_annotations_8808, 0);
    reader8808->definitionModule = modulename;
    writer8808->definitionModule = modulename;
    reader8808->definitionLine = 2343;
    writer8808->definitionLine = 2343;
  }
  obj8800->flags |= OFLAG_MUTABLE;
  adddatum2(obj8800, alloc_Undefined(), 7);
  if (objclass8800 == NULL) {
    Method *reader8809 = addmethodrealflags(obj8800, "startToken", &reader_ast_startToken_8809, 0);
    Method *writer8809 = addmethodrealflags(obj8800, "startToken:=(1)", &writer_ast_startToken_8809, 0);
    reader8809->definitionModule = modulename;
    writer8809->definitionModule = modulename;
    reader8809->definitionLine = 2344;
    writer8809->definitionLine = 2344;
  }
  obj8800->flags |= OFLAG_MUTABLE;
  adddatum2(obj8800, alloc_Undefined(), 8);
// method "end"
  struct UserObject *uo8810 = (struct UserObject*)obj8800;
  uo8810->data[9] = emptyclosure;
  Method *meth_meth_ast_8810_end = addmethod2pos(obj8800, "end", &meth_ast_8810_end, 9);
  int argcv_meth_ast_8810_end[] = {0};
  meth_meth_ast_8810_end->type = alloc_MethodType(1, argcv_meth_ast_8810_end);
  meth_meth_ast_8810_end->definitionModule = modulename;
  meth_meth_ast_8810_end->definitionLine = 2346;
// method "isPublic"
  struct UserObject *uo8815 = (struct UserObject*)obj8800;
  uo8815->data[10] = emptyclosure;
  Method *meth_meth_ast_8815_isPublic = addmethod2pos(obj8800, "isPublic", &meth_ast_8815_isPublic, 10);
  int argcv_meth_ast_8815_isPublic[] = {0};
  meth_meth_ast_8815_isPublic->type = alloc_MethodType(1, argcv_meth_ast_8815_isPublic);
  meth_meth_ast_8815_isPublic->definitionModule = modulename;
  meth_meth_ast_8815_isPublic->definitionLine = 2347;
// method "isFieldDec"
  struct UserObject *uo8834 = (struct UserObject*)obj8800;
  uo8834->data[11] = emptyclosure;
  Method *meth_meth_ast_8834_isFieldDec = addmethod2pos(obj8800, "isFieldDec", &meth_ast_8834_isFieldDec, 11);
  int argcv_meth_ast_8834_isFieldDec[] = {0};
  meth_meth_ast_8834_isFieldDec->type = alloc_MethodType(1, argcv_meth_ast_8834_isFieldDec);
  meth_meth_ast_8834_isFieldDec->definitionModule = modulename;
  meth_meth_ast_8834_isFieldDec->definitionLine = 2353;
// method "isWritable"
  struct UserObject *uo8836 = (struct UserObject*)obj8800;
  uo8836->data[12] = emptyclosure;
  Method *meth_meth_ast_8836_isWritable = addmethod2pos(obj8800, "isWritable", &meth_ast_8836_isWritable, 12);
  int argcv_meth_ast_8836_isWritable[] = {0};
  meth_meth_ast_8836_isWritable->type = alloc_MethodType(1, argcv_meth_ast_8836_isWritable);
  meth_meth_ast_8836_isWritable->definitionModule = modulename;
  meth_meth_ast_8836_isWritable->definitionLine = 2354;
// method "isReadable"
  struct UserObject *uo8838 = (struct UserObject*)obj8800;
  uo8838->data[13] = emptyclosure;
  Method *meth_meth_ast_8838_isReadable = addmethod2pos(obj8800, "isReadable", &meth_ast_8838_isReadable, 13);
  int argcv_meth_ast_8838_isReadable[] = {0};
  meth_meth_ast_8838_isReadable->type = alloc_MethodType(1, argcv_meth_ast_8838_isReadable);
  meth_meth_ast_8838_isReadable->definitionModule = modulename;
  meth_meth_ast_8838_isReadable->definitionLine = 2355;
// method "returnsObject"
  struct UserObject *uo8841 = (struct UserObject*)obj8800;
  uo8841->data[14] = emptyclosure;
  Method *meth_meth_ast_8841_returnsObject = addmethod2pos(obj8800, "returnsObject", &meth_ast_8841_returnsObject, 14);
  int argcv_meth_ast_8841_returnsObject[] = {0};
  meth_meth_ast_8841_returnsObject->type = alloc_MethodType(1, argcv_meth_ast_8841_returnsObject);
  meth_meth_ast_8841_returnsObject->definitionModule = modulename;
  meth_meth_ast_8841_returnsObject->definitionLine = 2357;
// method "returnedObjectScope"
  struct UserObject *uo8846 = (struct UserObject*)obj8800;
  uo8846->data[15] = emptyclosure;
  Method *meth_meth_ast_8846_returnedObjectScope = addmethod2pos(obj8800, "returnedObjectScope", &meth_ast_8846_returnedObjectScope, 15);
  int argcv_meth_ast_8846_returnedObjectScope[] = {0};
  meth_meth_ast_8846_returnedObjectScope->type = alloc_MethodType(1, argcv_meth_ast_8846_returnedObjectScope);
  meth_meth_ast_8846_returnedObjectScope->definitionModule = modulename;
  meth_meth_ast_8846_returnedObjectScope->definitionLine = 2360;
// method "usesAsType(_)"
  struct UserObject *uo8851 = (struct UserObject*)obj8800;
  uo8851->data[16] = emptyclosure;
  Method *meth_meth_ast_8851_usesAsType_40_1_41_ = addmethod2pos(obj8800, "usesAsType(1)", &meth_ast_8851_usesAsType_40_1_41_, 16);
  int argcv_meth_ast_8851_usesAsType_40_1_41_[] = {1};
  meth_meth_ast_8851_usesAsType_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8851_usesAsType_40_1_41_);
  meth_meth_ast_8851_usesAsType_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8851_usesAsType_40_1_41_->definitionLine = 2364;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj8800);
  Object closure8857 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure8857, stackframe);
  addtoclosure(closure8857, var_k);
  struct UserObject *uo8857 = (struct UserObject*)obj8800;
  uo8857->data[17] = (Object)closure8857;
  Method *meth_meth_ast_8857_declarationKindWithAncestors_40_1_41_ = addmethod2pos(obj8800, "declarationKindWithAncestors(1)", &meth_ast_8857_declarationKindWithAncestors_40_1_41_, 17);
  int argcv_meth_ast_8857_declarationKindWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_8857_declarationKindWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8857_declarationKindWithAncestors_40_1_41_);
  meth_meth_ast_8857_declarationKindWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8857_declarationKindWithAncestors_40_1_41_->definitionLine = 2367;
// method "accept(_)from(_)"
  struct UserObject *uo8860 = (struct UserObject*)obj8800;
  uo8860->data[18] = emptyclosure;
  Method *meth_meth_ast_8860_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj8800, "accept(1)from(1)", &meth_ast_8860_accept_40_1_41_from_40_1_41_, 18);
  int argcv_meth_ast_8860_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_8860_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_8860_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_8860_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8860_accept_40_1_41_from_40_1_41_->definitionLine = 2369;
// method "map(_)ancestors(_)"
  struct UserObject *uo8894 = (struct UserObject*)obj8800;
  uo8894->data[19] = emptyclosure;
  Method *meth_meth_ast_8894_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj8800, "map(1)ancestors(1)", &meth_ast_8894_map_40_1_41_ancestors_40_1_41_, 19);
  int argcv_meth_ast_8894_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_8894_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_8894_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_8894_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8894_map_40_1_41_ancestors_40_1_41_->definitionLine = 2382;
// method "pretty(_)"
  struct UserObject *uo8925 = (struct UserObject*)obj8800;
  uo8925->data[20] = emptyclosure;
  Method *meth_meth_ast_8925_pretty_40_1_41_ = addmethod2pos(obj8800, "pretty(1)", &meth_ast_8925_pretty_40_1_41_, 20);
  int argcv_meth_ast_8925_pretty_40_1_41_[] = {1};
  meth_meth_ast_8925_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8925_pretty_40_1_41_);
  meth_meth_ast_8925_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8925_pretty_40_1_41_->definitionLine = 2391;
// method "toGrace(_)"
  struct UserObject *uo9078 = (struct UserObject*)obj8800;
  uo9078->data[21] = emptyclosure;
  Method *meth_meth_ast_9078_toGrace_40_1_41_ = addmethod2pos(obj8800, "toGrace(1)", &meth_ast_9078_toGrace_40_1_41_, 21);
  int argcv_meth_ast_9078_toGrace_40_1_41_[] = {1};
  meth_meth_ast_9078_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9078_toGrace_40_1_41_);
meth_meth_ast_9078_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_9078_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_9078_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9078_toGrace_40_1_41_->definitionLine = 2412;
// method "shallowCopy"
  block_savedest(obj8800);
  Object closure9191 = createclosure(1, "shallowCopy");
  setclosureframe(closure9191, stackframe);
  addtoclosure(closure9191, var_defDecNode);
  struct UserObject *uo9191 = (struct UserObject*)obj8800;
  uo9191->data[22] = (Object)closure9191;
  Method *meth_meth_ast_9191_shallowCopy = addmethod2pos(obj8800, "shallowCopy", &meth_ast_9191_shallowCopy, 22);
  int argcv_meth_ast_9191_shallowCopy[] = {0};
  meth_meth_ast_9191_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_9191_shallowCopy);
  meth_meth_ast_9191_shallowCopy->definitionModule = modulename;
  meth_meth_ast_9191_shallowCopy->definitionLine = 2430;
// method "postCopy(_)"
  struct UserObject *uo9202 = (struct UserObject*)obj8800;
  uo9202->data[23] = emptyclosure;
  Method *meth_meth_ast_9202_postCopy_40_1_41_ = addmethod2pos(obj8800, "postCopy(1)", &meth_ast_9202_postCopy_40_1_41_, 23);
  int argcv_meth_ast_9202_postCopy_40_1_41_[] = {1};
  meth_meth_ast_9202_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9202_postCopy_40_1_41_);
  meth_meth_ast_9202_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9202_postCopy_40_1_41_->definitionLine = 2433;
// method "statementName"
  struct UserObject *uo9211 = (struct UserObject*)obj8800;
  uo9211->data[24] = emptyclosure;
  Method *meth_meth_ast_9211_statementName = addmethod2pos(obj8800, "statementName", &meth_ast_9211_statementName, 24);
  int argcv_meth_ast_9211_statementName[] = {0};
  meth_meth_ast_9211_statementName->type = alloc_MethodType(1, argcv_meth_ast_9211_statementName);
  meth_meth_ast_9211_statementName->definitionModule = modulename;
  meth_meth_ast_9211_statementName->definitionLine = 2438;
  sourceObject = obj8800;
// Begin line 2336
  setline(2336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9213 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9214 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9213);
// compiled call node returning call9214 (depth = 3)
  struct UserObject *obj8800_uo = (struct UserObject *)obj8800;
  obj8800_uo->super = call9214;
  sourceObject = obj8800;
// Begin line 2337
  setline(2337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9215 == NULL) {
    strlit9215 = alloc_String("defdec");
    gc_root(strlit9215);
  }
// compiled string node returning strlit9215 (depth = 3)
  adddatum2(obj8800, strlit9215, 1);
  sourceObject = obj8800;
// Begin line 2338
  setline(2338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj8800, *var_name_39_, 2);
  sourceObject = obj8800;
// Begin line 2339
  setline(2339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val (depth = 3)
  adddatum2(obj8800, *var_val, 3);
  sourceObject = obj8800;
// Begin line 2340
  setline(2340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj8800, *var_dtype_39_, 4);
  sourceObject = obj8800;
// Begin line 2341
  setline(2341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9216 == NULL) {
    strlit9216 = alloc_String("unset");
    gc_root(strlit9216);
  }
// compiled string node returning strlit9216 (depth = 3)
  adddatum2(obj8800, strlit9216, 5);
  sourceObject = obj8800;
// Begin line 2342
  setline(2342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9217 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9218 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9219 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9218);
// compiled member node returning call9219 (depth = 4)
  partcv[0] = 0;
  Object call9220 = callmethodflags(call9219, "nameString", 1, partcv, params, 0);
  gc_frame_end(callframe9217);
// compiled member node returning call9220 (depth = 3)
  adddatum2(obj8800, call9220, 6);
  sourceObject = obj8800;
// Begin line 2343
  setline(2343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array9221 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9221 (depth = 3)
  adddatum2(obj8800, array9221, 7);
  sourceObject = obj8800;
// Begin line 2344
  setline(2344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9222 = alloc_Boolean(0);
// compiled identifier node returning bool9222 (depth = 3)
  adddatum2(obj8800, bool9222, 8);
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  sourceObject = obj8800;
  objclass8800 = obj8800->class;
  objclass8800->definitionModule = modulename;
  objclass8800->definitionLine = 2335;
  (*(struct UserObject *)self).data[0] = lowerouter8800;
  self = oldself8800;
  selfslot = oldselfslot8800;
  stackframe = oldstackframe8800;
  gc_frame_end(frame);
  return obj8800;
}
Object meth_ast_9224_defDecNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 50, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defDecNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_defDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2328
  setline(2328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_defDecNode (depth = 3)
  gc_frame_end(frame);
  return *var_defDecNode;
}
Object meth_ast_9237_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2453
  setline(2453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9240 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9241 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9240);
// compiled member node returning call9241 (depth = 5)
  int op_slot_right_9239 = gc_frame_newslot(call9241);
// starting to compile identifier node (depth = 5)
  Object bool9243 = alloc_Boolean(0);
// compiled identifier node returning bool9243 (depth = 5)
  int op_slot_left_9239 = gc_frame_newslot(bool9243);
  params[0] = call9241;
  partcv[0] = 1;
  Object opresult9244 = callmethod(bool9243, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9244 (depth = 4)
  Object if9238 = done;
  if (istrue(opresult9244)) {
// starting to compile return node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9245 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9246 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9247 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9246);
// compiled member node returning call9247 (depth = 6)
  partcv[0] = 0;
  Object call9248 = callmethodflags(call9247, "end", 1, partcv, params, 0);
  gc_frame_end(callframe9245);
// compiled member node returning call9248 (depth = 5)
  return call9248;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if9238 = undefined;
  } else {
  }
// compiled if node returning if9238 (depth = 3)
// Begin line 2454
  setline(2454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9250 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9251 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9252 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9253 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9252);
// compiled member node returning call9253 (depth = 6)
  partcv[0] = 0;
  Object call9254 = callmethodflags(call9253, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe9251);
// compiled member node returning call9254 (depth = 5)
  partcv[0] = 0;
  Object call9255 = callmethodflags(call9254, "not", 1, partcv, params, 0);
  gc_frame_end(callframe9250);
// compiled member node returning call9255 (depth = 4)
  Object if9249 = done;
  if (istrue(call9255)) {
// starting to compile return node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9256 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9257 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9258 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9259 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9258);
// compiled member node returning call9259 (depth = 7)
  partcv[0] = 0;
  Object call9260 = callmethodflags(call9259, "last", 1, partcv, params, 0);
  gc_frame_end(callframe9257);
// compiled member node returning call9260 (depth = 6)
  partcv[0] = 0;
  Object call9261 = callmethodflags(call9260, "end", 1, partcv, params, 0);
  gc_frame_end(callframe9256);
// compiled member node returning call9261 (depth = 5)
  return call9261;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if9249 = undefined;
  } else {
  }
// compiled if node returning if9249 (depth = 3)
// Begin line 2455
  setline(2455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9264 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9265 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9264);
// compiled member node returning call9265 (depth = 5)
  int op_slot_right_9263 = gc_frame_newslot(call9265);
// starting to compile identifier node (depth = 5)
  Object bool9267 = alloc_Boolean(0);
// compiled identifier node returning bool9267 (depth = 5)
  int op_slot_left_9263 = gc_frame_newslot(bool9267);
  params[0] = call9265;
  partcv[0] = 1;
  Object opresult9268 = callmethod(bool9267, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9268 (depth = 4)
  Object if9262 = done;
  if (istrue(opresult9268)) {
// starting to compile return node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9269 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9270 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9271 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9270);
// compiled member node returning call9271 (depth = 6)
  partcv[0] = 0;
  Object call9272 = callmethodflags(call9271, "end", 1, partcv, params, 0);
  gc_frame_end(callframe9269);
// compiled member node returning call9272 (depth = 5)
  return call9272;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if9262 = undefined;
  } else {
  }
// compiled if node returning if9262 (depth = 3)
// Begin line 2456
  setline(2456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9273 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9274 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9275 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9274);
// compiled member node returning call9275 (depth = 5)
  partcv[0] = 0;
  Object call9276 = callmethodflags(call9275, "end", 1, partcv, params, 0);
  gc_frame_end(callframe9273);
// compiled member node returning call9276 (depth = 4)
  return call9276;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_9277_isPublic(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2460
  setline(2460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num9280 = alloc_Float64(0);
// compiled num node returning num9280 (depth = 5)
  int op_slot_right_9279 = gc_frame_newslot(num9280);
// starting to compile member node (depth = 5)
  int callframe9282 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9283 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9284 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9283);
// compiled member node returning call9284 (depth = 6)
  partcv[0] = 0;
  Object call9285 = callmethodflags(call9284, "size", 1, partcv, params, 0);
  gc_frame_end(callframe9282);
// compiled member node returning call9285 (depth = 5)
  int op_slot_left_9279 = gc_frame_newslot(call9285);
  params[0] = num9280;
  partcv[0] = 1;
  Object opresult9286 = callmethod(call9285, "==(1)", 1, partcv, params);
// compiled op node returning opresult9286 (depth = 4)
  Object if9278 = done;
  if (istrue(opresult9286)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool9287 = alloc_Boolean(0);
// compiled identifier node returning bool9287 (depth = 5)
  return bool9287;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if9278 = undefined;
  } else {
  }
// compiled if node returning if9278 (depth = 3)
// Begin line 2461
  setline(2461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9289 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit9290 == NULL) {
    strlit9290 = alloc_String("public");
    gc_root(strlit9290);
  }
// compiled string node returning strlit9290 (depth = 5)
  gc_frame_newslot(strlit9290);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = self;
  params[1] = strlit9290;
  partcv[0] = 2;
  Object call9291 = callmethodflags(module_ast, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9289);
// compiled call node returning call9291 (depth = 4)
  Object if9288 = done;
  if (istrue(call9291)) {
// Begin line 2461
  setline(2461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool9292 = alloc_Boolean(1);
// compiled identifier node returning bool9292 (depth = 5)
  return bool9292;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if9288 = undefined;
  } else {
  }
// compiled if node returning if9288 (depth = 3)
// Begin line 2462
  setline(2462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9293 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit9294 == NULL) {
    strlit9294 = alloc_String("readable");
    gc_root(strlit9294);
  }
// compiled string node returning strlit9294 (depth = 4)
  gc_frame_newslot(strlit9294);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  params[1] = strlit9294;
  partcv[0] = 2;
  Object call9295 = callmethodflags(module_ast, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9293);
// compiled call node returning call9295 (depth = 3)
  gc_frame_end(frame);
  return call9295;
}
Object meth_ast_9296_isWritable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2465
  setline(2465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num9299 = alloc_Float64(0);
// compiled num node returning num9299 (depth = 5)
  int op_slot_right_9298 = gc_frame_newslot(num9299);
// starting to compile member node (depth = 5)
  int callframe9301 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9302 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9303 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9302);
// compiled member node returning call9303 (depth = 6)
  partcv[0] = 0;
  Object call9304 = callmethodflags(call9303, "size", 1, partcv, params, 0);
  gc_frame_end(callframe9301);
// compiled member node returning call9304 (depth = 5)
  int op_slot_left_9298 = gc_frame_newslot(call9304);
  params[0] = num9299;
  partcv[0] = 1;
  Object opresult9305 = callmethod(call9304, "==(1)", 1, partcv, params);
// compiled op node returning opresult9305 (depth = 4)
  Object if9297 = done;
  if (istrue(opresult9305)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool9306 = alloc_Boolean(0);
// compiled identifier node returning bool9306 (depth = 5)
  return bool9306;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if9297 = undefined;
  } else {
  }
// compiled if node returning if9297 (depth = 3)
// Begin line 2466
  setline(2466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9308 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit9309 == NULL) {
    strlit9309 = alloc_String("public");
    gc_root(strlit9309);
  }
// compiled string node returning strlit9309 (depth = 5)
  gc_frame_newslot(strlit9309);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = self;
  params[1] = strlit9309;
  partcv[0] = 2;
  Object call9310 = callmethodflags(module_ast, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9308);
// compiled call node returning call9310 (depth = 4)
  Object if9307 = done;
  if (istrue(call9310)) {
// Begin line 2466
  setline(2466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool9311 = alloc_Boolean(1);
// compiled identifier node returning bool9311 (depth = 5)
  return bool9311;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if9307 = undefined;
  } else {
  }
// compiled if node returning if9307 (depth = 3)
// Begin line 2467
  setline(2467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9313 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit9314 == NULL) {
    strlit9314 = alloc_String("writable");
    gc_root(strlit9314);
  }
// compiled string node returning strlit9314 (depth = 5)
  gc_frame_newslot(strlit9314);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = self;
  params[1] = strlit9314;
  partcv[0] = 2;
  Object call9315 = callmethodflags(module_ast, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9313);
// compiled call node returning call9315 (depth = 4)
  Object if9312 = done;
  if (istrue(call9315)) {
// Begin line 2467
  setline(2467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool9316 = alloc_Boolean(1);
// compiled identifier node returning bool9316 (depth = 5)
  return bool9316;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if9312 = undefined;
  } else {
  }
// compiled if node returning if9312 (depth = 3)
// Begin line 2468
  setline(2468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9317 = alloc_Boolean(0);
// compiled identifier node returning bool9317 (depth = 3)
  gc_frame_end(frame);
  return bool9317;
}
Object meth_ast_9318_isReadable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2471
  setline(2471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num9321 = alloc_Float64(0);
// compiled num node returning num9321 (depth = 5)
  int op_slot_right_9320 = gc_frame_newslot(num9321);
// starting to compile member node (depth = 5)
  int callframe9323 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9324 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9325 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9324);
// compiled member node returning call9325 (depth = 6)
  partcv[0] = 0;
  Object call9326 = callmethodflags(call9325, "size", 1, partcv, params, 0);
  gc_frame_end(callframe9323);
// compiled member node returning call9326 (depth = 5)
  int op_slot_left_9320 = gc_frame_newslot(call9326);
  params[0] = num9321;
  partcv[0] = 1;
  Object opresult9327 = callmethod(call9326, "==(1)", 1, partcv, params);
// compiled op node returning opresult9327 (depth = 4)
  Object if9319 = done;
  if (istrue(opresult9327)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool9328 = alloc_Boolean(0);
// compiled identifier node returning bool9328 (depth = 5)
  return bool9328;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if9319 = undefined;
  } else {
  }
// compiled if node returning if9319 (depth = 3)
// Begin line 2472
  setline(2472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9330 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit9331 == NULL) {
    strlit9331 = alloc_String("public");
    gc_root(strlit9331);
  }
// compiled string node returning strlit9331 (depth = 5)
  gc_frame_newslot(strlit9331);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = self;
  params[1] = strlit9331;
  partcv[0] = 2;
  Object call9332 = callmethodflags(module_ast, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9330);
// compiled call node returning call9332 (depth = 4)
  Object if9329 = done;
  if (istrue(call9332)) {
// Begin line 2472
  setline(2472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool9333 = alloc_Boolean(1);
// compiled identifier node returning bool9333 (depth = 5)
  return bool9333;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if9329 = undefined;
  } else {
  }
// compiled if node returning if9329 (depth = 3)
// Begin line 2473
  setline(2473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9335 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit9336 == NULL) {
    strlit9336 = alloc_String("readable");
    gc_root(strlit9336);
  }
// compiled string node returning strlit9336 (depth = 5)
  gc_frame_newslot(strlit9336);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = self;
  params[1] = strlit9336;
  partcv[0] = 2;
  Object call9337 = callmethodflags(module_ast, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9335);
// compiled call node returning call9337 (depth = 4)
  Object if9334 = done;
  if (istrue(call9337)) {
// Begin line 2473
  setline(2473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool9338 = alloc_Boolean(1);
// compiled identifier node returning bool9338 (depth = 5)
  return bool9338;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if9334 = undefined;
  } else {
  }
// compiled if node returning if9334 (depth = 3)
// Begin line 2474
  setline(2474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9339 = alloc_Boolean(0);
// compiled identifier node returning bool9339 (depth = 3)
  gc_frame_end(frame);
  return bool9339;
}
Object meth_ast_9340_isFieldDec(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isFieldDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2476
  setline(2476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9341 = alloc_Boolean(1);
// compiled identifier node returning bool9341 (depth = 3)
  gc_frame_end(frame);
  return bool9341;
}
Object meth_ast_9342_usesAsType_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part usesAsType(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2479
  setline(2479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9344 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9345 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9344);
// compiled member node returning call9345 (depth = 4)
  int op_slot_right_9343 = gc_frame_newslot(call9345);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_9343 = gc_frame_newslot(*var_aNode);
  params[0] = call9345;
  partcv[0] = 1;
  Object opresult9347 = callmethod(*var_aNode, "==(1)", 1, partcv, params);
// compiled op node returning opresult9347 (depth = 3)
  gc_frame_end(frame);
  return opresult9347;
}
Object meth_ast_9348_declarationKindWithAncestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2482
  setline(2482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9349 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  partcv[0] = 0;
  Object call9350 = callmethodflags(*var_k, "vardec", 1, partcv, params, 0);
  gc_frame_end(callframe9349);
// compiled member node returning call9350 (depth = 3)
  gc_frame_end(frame);
  return call9350;
}
Object meth_ast_9376__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2492
  setline(2492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9377 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9378 = callmethodflags(*var_ann, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9377);
// compiled call node returning call9378 (depth = 6)
  gc_frame_end(frame);
  return call9378;
}
Object meth_ast_9351_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2485
  setline(2485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9353 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9354 = callmethodflags(*var_visitor, "visitVarDec(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9353);
// compiled call node returning call9354 (depth = 4)
  Object if9352 = done;
  if (istrue(call9354)) {
// Begin line 2486
  setline(2486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9355 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call9356 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9355);
// compiled call node returning call9356 (depth = 5)
  *var_newChain = call9356;
  if (call9356 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2487
  setline(2487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9357 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9358 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9359 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9358);
// compiled member node returning call9359 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9360 = callmethodflags(call9359, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9357);
// compiled call node returning call9360 (depth = 4)
// Begin line 2488
  setline(2488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9363 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9364 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9363);
// compiled member node returning call9364 (depth = 6)
  int op_slot_right_9362 = gc_frame_newslot(call9364);
// starting to compile identifier node (depth = 6)
  Object bool9366 = alloc_Boolean(0);
// compiled identifier node returning bool9366 (depth = 6)
  int op_slot_left_9362 = gc_frame_newslot(bool9366);
  params[0] = call9364;
  partcv[0] = 1;
  Object opresult9367 = callmethod(bool9366, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9367 (depth = 5)
  Object if9361 = done;
  if (istrue(opresult9367)) {
// Begin line 2489
  setline(2489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9368 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9369 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9370 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9369);
// compiled member node returning call9370 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9371 = callmethodflags(call9370, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9368);
// compiled call node returning call9371 (depth = 5)
    gc_frame_newslot(call9371);
    if9361 = call9371;
  } else {
  }
// compiled if node returning if9361 (depth = 4)
// Begin line 2491
  setline(2491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9372 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9373 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9374 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9373);
// compiled member node returning call9374 (depth = 5)
  gc_frame_newslot(call9374);
// starting to compile block node (depth = 5)
  Object block9375 = alloc_Block(NULL, NULL, "ast", 2491);
  gc_frame_newslot(block9375);
// method "_apply(_)"
  block_savedest(block9375);
  Object closure9376 = createclosure(3, "_apply(1)");
  setclosureframe(closure9376, stackframe);
  addtoclosure(closure9376, var_visitor);
  addtoclosure(closure9376, var_newChain);
  addtoclosure(closure9376, selfslot);
  struct UserObject *uo9376 = (struct UserObject*)block9375;
  uo9376->data[0] = (Object)closure9376;
  Method *meth_meth_ast_9376__apply_40_1_41_ = addmethod2pos(block9375, "_apply(1)", &meth_ast_9376__apply_40_1_41_, 0);
  int argcv_meth_ast_9376__apply_40_1_41_[] = {1};
  meth_meth_ast_9376__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9376__apply_40_1_41_);
  meth_meth_ast_9376__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9376__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block9375 (depth = 5)
  gc_frame_newslot(block9375);
// call case 5: prelude request
  params[0] = call9374;
  params[1] = block9375;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9380 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9372);
// compiled call node returning call9380 (depth = 4)
// Begin line 2494
  setline(2494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9383 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9384 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9383);
// compiled member node returning call9384 (depth = 6)
  int op_slot_right_9382 = gc_frame_newslot(call9384);
// starting to compile identifier node (depth = 6)
  Object bool9386 = alloc_Boolean(0);
// compiled identifier node returning bool9386 (depth = 6)
  int op_slot_left_9382 = gc_frame_newslot(bool9386);
  params[0] = call9384;
  partcv[0] = 1;
  Object opresult9387 = callmethod(bool9386, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9387 (depth = 5)
  Object if9381 = done;
  if (istrue(opresult9387)) {
// Begin line 2495
  setline(2495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9388 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9389 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9390 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9389);
// compiled member node returning call9390 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9391 = callmethodflags(call9390, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9388);
// compiled call node returning call9391 (depth = 5)
    gc_frame_newslot(call9391);
    if9381 = call9391;
  } else {
  }
// compiled if node returning if9381 (depth = 4)
    gc_frame_newslot(if9381);
    if9352 = if9381;
  } else {
  }
// compiled if node returning if9352 (depth = 3)
  gc_frame_end(frame);
  return if9352;
}
Object meth_ast_9392_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2500
  setline(2500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9393 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9394 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9393);
// compiled member node returning call9394 (depth = 4)
  *var_n = call9394;
  if (call9394 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2501
  setline(2501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9395 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9396 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9395);
// compiled call node returning call9396 (depth = 4)
  *var_newChain = call9396;
  if (call9396 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2502
  setline(2502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9397 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9398 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9399 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9400 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9399);
// compiled member node returning call9400 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9401 = callmethodflags(call9400, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9398);
// compiled call node returning call9401 (depth = 4)
  gc_frame_newslot(call9401);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call9401;
  partcv[0] = 1;
  Object call9402 = callmethodflags(*var_n, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9397);
// compiled call node returning call9402 (depth = 3)
// Begin line 2503
  setline(2503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9403 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9404 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9405 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9406 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9405);
// compiled member node returning call9406 (depth = 5)
  gc_frame_newslot(call9406);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call9406;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9407 = callmethodflags(module_ast, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9404);
// compiled call node returning call9407 (depth = 4)
  gc_frame_newslot(call9407);
// call case 6: other requests
// Begin line 2503
  setline(2503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call9407;
  partcv[0] = 1;
  Object call9408 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9403);
// compiled call node returning call9408 (depth = 3)
// Begin line 2504
  setline(2504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9409 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9410 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9411 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9412 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9411);
// compiled member node returning call9412 (depth = 5)
  gc_frame_newslot(call9412);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call9412;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9413 = callmethodflags(module_ast, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9410);
// compiled call node returning call9413 (depth = 4)
  gc_frame_newslot(call9413);
// call case 6: other requests
// Begin line 2504
  setline(2504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call9413;
  partcv[0] = 1;
  Object call9414 = callmethodflags(*var_n, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9409);
// compiled call node returning call9414 (depth = 3)
// Begin line 2505
  setline(2505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9415 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9416 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9417 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9418 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9417);
// compiled member node returning call9418 (depth = 5)
  gc_frame_newslot(call9418);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call9418;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9419 = callmethodflags(module_ast, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9416);
// compiled call node returning call9419 (depth = 4)
  gc_frame_newslot(call9419);
// call case 6: other requests
// Begin line 2505
  setline(2505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call9419;
  partcv[0] = 1;
  Object call9420 = callmethodflags(*var_n, "annotations:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9415);
// compiled call node returning call9420 (depth = 3)
// Begin line 2506
  setline(2506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9421 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9422 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9421);
// compiled call node returning call9422 (depth = 3)
  gc_frame_end(frame);
  return call9422;
}
Object meth_ast_9423_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2509
  setline(2509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9426 = alloc_Float64(1);
// compiled num node returning num9426 (depth = 6)
  int op_slot_right_9425 = gc_frame_newslot(num9426);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_9425 = gc_frame_newslot(*var_depth);
  params[0] = num9426;
  partcv[0] = 1;
  Object sum9428 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum9428 (depth = 5)
  int op_slot_right_9424 = gc_frame_newslot(sum9428);
// starting to compile string node (depth = 5)
  if (strlit9430 == NULL) {
    strlit9430 = alloc_String("  ");
    gc_root(strlit9430);
  }
// compiled string node returning strlit9430 (depth = 5)
  int op_slot_left_9424 = gc_frame_newslot(strlit9430);
  params[0] = sum9428;
  partcv[0] = 1;
  Object prod9431 = callmethod(strlit9430, "*(1)", 1, partcv, params);
// compiled op node returning prod9431 (depth = 4)
  *var_spc = prod9431;
  if (prod9431 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2510
  setline(2510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9433 == NULL) {
    strlit9433 = alloc_String("""\x0a""");
    gc_root(strlit9433);
  }
// compiled string node returning strlit9433 (depth = 5)
  int op_slot_right_9432 = gc_frame_newslot(strlit9433);
// starting to compile call node (depth = 5)
  int callframe9435 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9436 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9435);
// compiled call node returning call9436 (depth = 5)
  int op_slot_left_9432 = gc_frame_newslot(call9436);
  params[0] = strlit9433;
  partcv[0] = 1;
  Object opresult9437 = callmethod(call9436, "++(1)", 1, partcv, params);
// compiled op node returning opresult9437 (depth = 4)
  *var_s = opresult9437;
  if (opresult9437 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2511
  setline(2511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9439 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9441 = alloc_Float64(1);
// compiled num node returning num9441 (depth = 7)
  int op_slot_right_9440 = gc_frame_newslot(num9441);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_9440 = gc_frame_newslot(*var_depth);
  params[0] = num9441;
  partcv[0] = 1;
  Object sum9443 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum9443 (depth = 6)
  gc_frame_newslot(sum9443);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9444 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9445 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9444);
// compiled member node returning call9445 (depth = 6)
  params[0] = sum9443;
  partcv[0] = 1;
  Object call9446 = callmethodflags(call9445, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9439);
// compiled call node returning call9446 (depth = 5)
  int op_slot_right_9438 = gc_frame_newslot(call9446);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_9448 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9448 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9450 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9450 (depth = 5)
  int op_slot_left_9438 = gc_frame_newslot(opresult9450);
  params[0] = call9446;
  partcv[0] = 1;
  Object opresult9451 = callmethod(opresult9450, "++(1)", 1, partcv, params);
// compiled op node returning opresult9451 (depth = 4)
  *var_s = opresult9451;
  if (opresult9451 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2512
  setline(2512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9455 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9456 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9455);
// compiled member node returning call9456 (depth = 5)
  int op_slot_right_9454 = gc_frame_newslot(call9456);
// starting to compile identifier node (depth = 5)
  Object bool9458 = alloc_Boolean(0);
// compiled identifier node returning bool9458 (depth = 5)
  int op_slot_left_9454 = gc_frame_newslot(bool9458);
  params[0] = call9456;
  partcv[0] = 1;
  Object opresult9459 = callmethod(bool9458, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9459 (depth = 4)
  Object if9453 = done;
  if (istrue(opresult9459)) {
// Begin line 2513
  setline(2513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9461 == NULL) {
    strlit9461 = alloc_String("Type: ");
    gc_root(strlit9461);
  }
// compiled string node returning strlit9461 (depth = 6)
  int op_slot_right_9460 = gc_frame_newslot(strlit9461);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_9463 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9466 == NULL) {
    strlit9466 = alloc_String("""\x0a""");
    gc_root(strlit9466);
  }
// compiled string node returning strlit9466 (depth = 8)
  int op_slot_right_9465 = gc_frame_newslot(strlit9466);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_9465 = gc_frame_newslot(*var_s);
  params[0] = strlit9466;
  partcv[0] = 1;
  Object opresult9468 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9468 (depth = 7)
  int op_slot_left_9463 = gc_frame_newslot(opresult9468);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9469 = callmethod(opresult9468, "++(1)", 1, partcv, params);
// compiled op node returning opresult9469 (depth = 6)
  int op_slot_left_9460 = gc_frame_newslot(opresult9469);
  params[0] = strlit9461;
  partcv[0] = 1;
  Object opresult9470 = callmethod(opresult9469, "++(1)", 1, partcv, params);
// compiled op node returning opresult9470 (depth = 5)
  *var_s = opresult9470;
  if (opresult9470 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2514
  setline(2514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9473 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num9475 = alloc_Float64(2);
// compiled num node returning num9475 (depth = 8)
  int op_slot_right_9474 = gc_frame_newslot(num9475);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_9474 = gc_frame_newslot(*var_depth);
  params[0] = num9475;
  partcv[0] = 1;
  Object sum9477 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum9477 (depth = 7)
  gc_frame_newslot(sum9477);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9478 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9479 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9478);
// compiled member node returning call9479 (depth = 7)
  params[0] = sum9477;
  partcv[0] = 1;
  Object call9480 = callmethodflags(call9479, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9473);
// compiled call node returning call9480 (depth = 6)
  int op_slot_right_9472 = gc_frame_newslot(call9480);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9472 = gc_frame_newslot(*var_s);
  params[0] = call9480;
  partcv[0] = 1;
  Object opresult9482 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9482 (depth = 5)
  *var_s = opresult9482;
  if (opresult9482 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9453 = done;
  } else {
  }
// compiled if node returning if9453 (depth = 3)
// Begin line 2516
  setline(2516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9486 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9487 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9486);
// compiled member node returning call9487 (depth = 5)
  int op_slot_right_9485 = gc_frame_newslot(call9487);
// starting to compile identifier node (depth = 5)
  Object bool9489 = alloc_Boolean(0);
// compiled identifier node returning bool9489 (depth = 5)
  int op_slot_left_9485 = gc_frame_newslot(bool9489);
  params[0] = call9487;
  partcv[0] = 1;
  Object opresult9490 = callmethod(bool9489, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9490 (depth = 4)
  Object if9484 = done;
  if (istrue(opresult9490)) {
// Begin line 2517
  setline(2517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9492 == NULL) {
    strlit9492 = alloc_String("Value: ");
    gc_root(strlit9492);
  }
// compiled string node returning strlit9492 (depth = 6)
  int op_slot_right_9491 = gc_frame_newslot(strlit9492);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_9494 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9497 == NULL) {
    strlit9497 = alloc_String("""\x0a""");
    gc_root(strlit9497);
  }
// compiled string node returning strlit9497 (depth = 8)
  int op_slot_right_9496 = gc_frame_newslot(strlit9497);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_9496 = gc_frame_newslot(*var_s);
  params[0] = strlit9497;
  partcv[0] = 1;
  Object opresult9499 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9499 (depth = 7)
  int op_slot_left_9494 = gc_frame_newslot(opresult9499);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9500 = callmethod(opresult9499, "++(1)", 1, partcv, params);
// compiled op node returning opresult9500 (depth = 6)
  int op_slot_left_9491 = gc_frame_newslot(opresult9500);
  params[0] = strlit9492;
  partcv[0] = 1;
  Object opresult9501 = callmethod(opresult9500, "++(1)", 1, partcv, params);
// compiled op node returning opresult9501 (depth = 5)
  *var_s = opresult9501;
  if (opresult9501 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2518
  setline(2518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9504 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num9506 = alloc_Float64(2);
// compiled num node returning num9506 (depth = 8)
  int op_slot_right_9505 = gc_frame_newslot(num9506);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_9505 = gc_frame_newslot(*var_depth);
  params[0] = num9506;
  partcv[0] = 1;
  Object sum9508 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum9508 (depth = 7)
  gc_frame_newslot(sum9508);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9509 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9510 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9509);
// compiled member node returning call9510 (depth = 7)
  params[0] = sum9508;
  partcv[0] = 1;
  Object call9511 = callmethodflags(call9510, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9504);
// compiled call node returning call9511 (depth = 6)
  int op_slot_right_9503 = gc_frame_newslot(call9511);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9503 = gc_frame_newslot(*var_s);
  params[0] = call9511;
  partcv[0] = 1;
  Object opresult9513 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9513 (depth = 5)
  *var_s = opresult9513;
  if (opresult9513 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9484 = done;
  } else {
  }
// compiled if node returning if9484 (depth = 3)
// Begin line 2520
  setline(2520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9517 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9518 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9517);
// compiled member node returning call9518 (depth = 5)
  int op_slot_right_9516 = gc_frame_newslot(call9518);
// starting to compile identifier node (depth = 5)
  Object bool9520 = alloc_Boolean(0);
// compiled identifier node returning bool9520 (depth = 5)
  int op_slot_left_9516 = gc_frame_newslot(bool9520);
  params[0] = call9518;
  partcv[0] = 1;
  Object opresult9521 = callmethod(bool9520, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9521 (depth = 4)
  Object if9515 = done;
  if (istrue(opresult9521)) {
// Begin line 2521
  setline(2521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9523 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num9525 = alloc_Float64(2);
// compiled num node returning num9525 (depth = 8)
  int op_slot_right_9524 = gc_frame_newslot(num9525);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_9524 = gc_frame_newslot(*var_depth);
  params[0] = num9525;
  partcv[0] = 1;
  Object sum9527 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum9527 (depth = 7)
  gc_frame_newslot(sum9527);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9528 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9529 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9528);
// compiled member node returning call9529 (depth = 7)
  params[0] = sum9527;
  partcv[0] = 1;
  Object call9530 = callmethodflags(call9529, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9523);
// compiled call node returning call9530 (depth = 6)
  int op_slot_right_9522 = gc_frame_newslot(call9530);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9522 = gc_frame_newslot(*var_s);
  params[0] = call9530;
  partcv[0] = 1;
  Object opresult9532 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9532 (depth = 5)
  *var_s = opresult9532;
  if (opresult9532 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9515 = done;
  } else {
  }
// compiled if node returning if9515 (depth = 3)
// Begin line 2523
  setline(2523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_9555__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2529
  setline(2529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9557 == NULL) {
    strlit9557 = alloc_String("Unknown");
    gc_root(strlit9557);
  }
// compiled string node returning strlit9557 (depth = 7)
  int op_slot_right_9556 = gc_frame_newslot(strlit9557);
// starting to compile member node (depth = 7)
  int callframe9559 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe9560 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9561 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9560);
// compiled member node returning call9561 (depth = 8)
  partcv[0] = 0;
  Object call9562 = callmethodflags(call9561, "value", 1, partcv, params, 0);
  gc_frame_end(callframe9559);
// compiled member node returning call9562 (depth = 7)
  int op_slot_left_9556 = gc_frame_newslot(call9562);
  params[0] = strlit9557;
  partcv[0] = 1;
  Object opresult9563 = callmethod(call9562, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9563 (depth = 6)
  gc_frame_end(frame);
  return opresult9563;
}
Object meth_ast_9603__apply_40_2_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2535
  setline(2535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9605 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num9606 = alloc_Float64(0);
// compiled num node returning num9606 (depth = 10)
  gc_frame_newslot(num9606);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_b (depth = 10)
  params[0] = num9606;
  partcv[0] = 1;
  Object call9607 = callmethodflags(*var_b, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9605);
// compiled call node returning call9607 (depth = 9)
  int op_slot_right_9604 = gc_frame_newslot(call9607);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit9611 == NULL) {
    strlit9611 = alloc_String("");
    gc_root(strlit9611);
  }
// compiled string node returning strlit9611 (depth = 11)
  int op_slot_right_9610 = gc_frame_newslot(strlit9611);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_9610 = gc_frame_newslot(*var_a);
  params[0] = strlit9611;
  partcv[0] = 1;
  Object opresult9613 = callmethod(*var_a, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9613 (depth = 10)
  Object if9609 = done;
struct StackFrameObject *iftmpstackframe9609 = stackframe;
  if (istrue(opresult9613)) {
stackframe = alloc_StackFrame(0, iftmpstackframe9609);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit9615 == NULL) {
    strlit9615 = alloc_String(", ");
    gc_root(strlit9615);
  }
// compiled string node returning strlit9615 (depth = 11)
  int op_slot_right_9614 = gc_frame_newslot(strlit9615);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_9614 = gc_frame_newslot(*var_a);
  params[0] = strlit9615;
  partcv[0] = 1;
  Object opresult9617 = callmethod(*var_a, "++(1)", 1, partcv, params);
// compiled op node returning opresult9617 (depth = 10)
    gc_frame_newslot(opresult9617);
    if9609 = opresult9617;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe9609);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile string node (depth = 10)
  if (strlit9618 == NULL) {
    strlit9618 = alloc_String("");
    gc_root(strlit9618);
  }
// compiled string node returning strlit9618 (depth = 10)
    gc_frame_newslot(strlit9618);
    if9609 = strlit9618;
  }
stackframe = iftmpstackframe9609;
// compiled if node returning if9609 (depth = 9)
  int op_slot_left_9604 = gc_frame_newslot(if9609);
  params[0] = call9607;
  partcv[0] = 1;
  Object opresult9619 = callmethod(if9609, "++(1)", 1, partcv, params);
// compiled op node returning opresult9619 (depth = 8)
  gc_frame_end(frame);
  return opresult9619;
}
Object meth_ast_9534_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2526
  setline(2526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_9535 = gc_frame_newslot(*var_depth);
// starting to compile string node (depth = 5)
  if (strlit9537 == NULL) {
    strlit9537 = alloc_String("    ");
    gc_root(strlit9537);
  }
// compiled string node returning strlit9537 (depth = 5)
  int op_slot_left_9535 = gc_frame_newslot(strlit9537);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object prod9538 = callmethod(strlit9537, "*(1)", 1, partcv, params);
// compiled op node returning prod9538 (depth = 4)
  *var_spc = prod9538;
  if (prod9538 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2527
  setline(2527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9540 == NULL) {
    strlit9540 = alloc_String("");
    gc_root(strlit9540);
  }
// compiled string node returning strlit9540 (depth = 5)
  int op_slot_right_9539 = gc_frame_newslot(strlit9540);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9543 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num9544 = alloc_Float64(0);
// compiled num node returning num9544 (depth = 7)
  gc_frame_newslot(num9544);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9545 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9546 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9545);
// compiled member node returning call9546 (depth = 7)
  params[0] = num9544;
  partcv[0] = 1;
  Object call9547 = callmethodflags(call9546, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9543);
// compiled call node returning call9547 (depth = 6)
  int op_slot_right_9542 = gc_frame_newslot(call9547);
// starting to compile string node (depth = 6)
  if (strlit9549 == NULL) {
    strlit9549 = alloc_String("var ");
    gc_root(strlit9549);
  }
// compiled string node returning strlit9549 (depth = 6)
  int op_slot_left_9542 = gc_frame_newslot(strlit9549);
  params[0] = call9547;
  partcv[0] = 1;
  Object opresult9550 = callmethod(strlit9549, "++(1)", 1, partcv, params);
// compiled op node returning opresult9550 (depth = 5)
  int op_slot_left_9539 = gc_frame_newslot(opresult9550);
  params[0] = strlit9540;
  partcv[0] = 1;
  Object opresult9551 = callmethod(opresult9550, "++(1)", 1, partcv, params);
// compiled op node returning opresult9551 (depth = 4)
  *var_s = opresult9551;
  if (opresult9551 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2528
  setline(2528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block9554 = alloc_Block(NULL, NULL, "ast", 2528);
  gc_frame_newslot(block9554);
// method "_apply"
  block_savedest(block9554);
  Object closure9555 = createclosure(1, "_apply");
  setclosureframe(closure9555, stackframe);
  addtoclosure(closure9555, selfslot);
  struct UserObject *uo9555 = (struct UserObject*)block9554;
  uo9555->data[0] = (Object)closure9555;
  Method *meth_meth_ast_9555__apply = addmethod2pos(block9554, "_apply", &meth_ast_9555__apply, 0);
  int argcv_meth_ast_9555__apply[] = {0};
  meth_meth_ast_9555__apply->type = alloc_MethodType(1, argcv_meth_ast_9555__apply);
  meth_meth_ast_9555__apply->definitionModule = modulename;
  meth_meth_ast_9555__apply->definitionLine = 3050;
// compiled block node returning block9554 (depth = 5)
  int op_slot_right_9553 = gc_frame_newslot(block9554);
// Begin line 2528
  setline(2528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9567 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9568 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9567);
// compiled member node returning call9568 (depth = 6)
  int op_slot_right_9566 = gc_frame_newslot(call9568);
// starting to compile identifier node (depth = 6)
  Object bool9570 = alloc_Boolean(0);
// compiled identifier node returning bool9570 (depth = 6)
  int op_slot_left_9566 = gc_frame_newslot(bool9570);
  params[0] = call9568;
  partcv[0] = 1;
  Object opresult9571 = callmethod(bool9570, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9571 (depth = 5)
  int op_slot_left_9553 = gc_frame_newslot(opresult9571);
  params[0] = block9554;
  partcv[0] = 1;
  Object opresult9572 = callmethod(opresult9571, "&&(1)", 1, partcv, params);
// compiled op node returning opresult9572 (depth = 4)
  Object if9552 = done;
  if (istrue(opresult9572)) {
// Begin line 2530
  setline(2530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9574 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num9575 = alloc_Float64(0);
// compiled num node returning num9575 (depth = 7)
  gc_frame_newslot(num9575);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9576 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9577 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9576);
// compiled member node returning call9577 (depth = 7)
  params[0] = num9575;
  partcv[0] = 1;
  Object call9578 = callmethodflags(call9577, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9574);
// compiled call node returning call9578 (depth = 6)
  int op_slot_right_9573 = gc_frame_newslot(call9578);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9581 == NULL) {
    strlit9581 = alloc_String(" : ");
    gc_root(strlit9581);
  }
// compiled string node returning strlit9581 (depth = 7)
  int op_slot_right_9580 = gc_frame_newslot(strlit9581);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_9580 = gc_frame_newslot(*var_s);
  params[0] = strlit9581;
  partcv[0] = 1;
  Object opresult9583 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9583 (depth = 6)
  int op_slot_left_9573 = gc_frame_newslot(opresult9583);
  params[0] = call9578;
  partcv[0] = 1;
  Object opresult9584 = callmethod(opresult9583, "++(1)", 1, partcv, params);
// compiled op node returning opresult9584 (depth = 5)
  *var_s = opresult9584;
  if (opresult9584 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9552 = done;
  } else {
  }
// compiled if node returning if9552 (depth = 3)
// Begin line 2532
  setline(2532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num9588 = alloc_Float64(0);
// compiled num node returning num9588 (depth = 5)
  int op_slot_right_9587 = gc_frame_newslot(num9588);
// starting to compile member node (depth = 5)
  int callframe9590 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9591 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9592 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9591);
// compiled member node returning call9592 (depth = 6)
  partcv[0] = 0;
  Object call9593 = callmethodflags(call9592, "size", 1, partcv, params, 0);
  gc_frame_end(callframe9590);
// compiled member node returning call9593 (depth = 5)
  int op_slot_left_9587 = gc_frame_newslot(call9593);
  params[0] = num9588;
  partcv[0] = 1;
  Object opresult9594 = callmethod(call9593, ">(1)", 1, partcv, params);
// compiled op node returning opresult9594 (depth = 4)
  Object if9586 = done;
  if (istrue(opresult9594)) {
// Begin line 2533
  setline(2533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9596 == NULL) {
    strlit9596 = alloc_String(" is ");
    gc_root(strlit9596);
  }
// compiled string node returning strlit9596 (depth = 6)
  int op_slot_right_9595 = gc_frame_newslot(strlit9596);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9595 = gc_frame_newslot(*var_s);
  params[0] = strlit9596;
  partcv[0] = 1;
  Object opresult9598 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9598 (depth = 5)
  *var_s = opresult9598;
  if (opresult9598 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2534
  setline(2534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9601 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block9602 = alloc_Block(NULL, NULL, "ast", 2534);
  gc_frame_newslot(block9602);
// method "_apply(_,_)"
  block_savedest(block9602);
  Object closure9603 = createclosure(1, "_apply(2)");
  setclosureframe(closure9603, stackframe);
  addtoclosure(closure9603, selfslot);
  struct UserObject *uo9603 = (struct UserObject*)block9602;
  uo9603->data[0] = (Object)closure9603;
  Method *meth_meth_ast_9603__apply_40_2_41_ = addmethod2pos(block9602, "_apply(2)", &meth_ast_9603__apply_40_2_41_, 0);
  int argcv_meth_ast_9603__apply_40_2_41_[] = {2};
  meth_meth_ast_9603__apply_40_2_41_->type = alloc_MethodType(1, argcv_meth_ast_9603__apply_40_2_41_);
  meth_meth_ast_9603__apply_40_2_41_->definitionModule = modulename;
  meth_meth_ast_9603__apply_40_2_41_->definitionLine = 3050;
// compiled block node returning block9602 (depth = 7)
  gc_frame_newslot(block9602);
// Begin line 2536
  setline(2536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit9621 == NULL) {
    strlit9621 = alloc_String("");
    gc_root(strlit9621);
  }
// compiled string node returning strlit9621 (depth = 7)
  gc_frame_newslot(strlit9621);
// call case 6: other requests
// Begin line 2534
  setline(2534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe9622 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9623 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9622);
// compiled member node returning call9623 (depth = 7)
  params[0] = block9602;
  params[1] = strlit9621;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9624 = callmethodflags(call9623, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9601);
// compiled call node returning call9624 (depth = 6)
  int op_slot_right_9600 = gc_frame_newslot(call9624);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9600 = gc_frame_newslot(*var_s);
  params[0] = call9624;
  partcv[0] = 1;
  Object opresult9626 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9626 (depth = 5)
  *var_s = opresult9626;
  if (opresult9626 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9586 = done;
  } else {
  }
// compiled if node returning if9586 (depth = 3)
// Begin line 2538
  setline(2538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9630 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9631 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9630);
// compiled member node returning call9631 (depth = 5)
  int op_slot_right_9629 = gc_frame_newslot(call9631);
// starting to compile identifier node (depth = 5)
  Object bool9633 = alloc_Boolean(0);
// compiled identifier node returning bool9633 (depth = 5)
  int op_slot_left_9629 = gc_frame_newslot(bool9633);
  params[0] = call9631;
  partcv[0] = 1;
  Object opresult9634 = callmethod(bool9633, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9634 (depth = 4)
  Object if9628 = done;
  if (istrue(opresult9634)) {
// Begin line 2539
  setline(2539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9636 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9637 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9638 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9637);
// compiled member node returning call9638 (depth = 7)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9639 = callmethodflags(call9638, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9636);
// compiled call node returning call9639 (depth = 6)
  int op_slot_right_9635 = gc_frame_newslot(call9639);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9642 == NULL) {
    strlit9642 = alloc_String(" := ");
    gc_root(strlit9642);
  }
// compiled string node returning strlit9642 (depth = 7)
  int op_slot_right_9641 = gc_frame_newslot(strlit9642);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_9641 = gc_frame_newslot(*var_s);
  params[0] = strlit9642;
  partcv[0] = 1;
  Object opresult9644 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9644 (depth = 6)
  int op_slot_left_9635 = gc_frame_newslot(opresult9644);
  params[0] = call9639;
  partcv[0] = 1;
  Object opresult9645 = callmethod(opresult9644, "++(1)", 1, partcv, params);
// compiled op node returning opresult9645 (depth = 5)
  *var_s = opresult9645;
  if (opresult9645 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9628 = done;
  } else {
  }
// compiled if node returning if9628 (depth = 3)
// Begin line 2541
  setline(2541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_9647_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_varDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2544
  setline(2544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9648 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe9649 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9650 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9651 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9650);
// compiled member node returning call9651 (depth = 5)
  gc_frame_newslot(call9651);
// starting to compile member node (depth = 5)
  int callframe9652 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9653 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9652);
// compiled member node returning call9653 (depth = 5)
  gc_frame_newslot(call9653);
// starting to compile member node (depth = 5)
  int callframe9654 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9655 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9654);
// compiled member node returning call9655 (depth = 5)
  gc_frame_newslot(call9655);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_varDecNode (depth = 5)
  params[0] = call9651;
  params[1] = call9653;
  params[2] = call9655;
  partcv[0] = 3;
  Object call9656 = callmethodflags(*var_varDecNode, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe9649);
// compiled call node returning call9656 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call9657 = callmethodflags(call9656, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9648);
// compiled call node returning call9657 (depth = 3)
  gc_frame_end(frame);
  return call9657;
}
Object meth_ast_9658_postCopy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "postCopy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method postCopy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for postCopy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part postCopy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2547
  setline(2547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9659 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe9660 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call9661 = callmethodflags(*var_other, "parentKind", 1, partcv, params, 0);
  gc_frame_end(callframe9660);
// compiled member node returning call9661 (depth = 4)
  gc_frame_newslot(call9661);
// call case 4: self request
  params[0] = call9661;
  partcv[0] = 1;
  Object call9662 = callmethodflags(self, "parentKind:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9659);
// compiled call node returning call9662 (depth = 3)
// Begin line 2548
  setline(2548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_9663_statementName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2550
  setline(2550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9664 == NULL) {
    strlit9664 = alloc_String("variable declaration");
    gc_root(strlit9664);
  }
// compiled string node returning strlit9664 (depth = 3)
  gc_frame_end(frame);
  return strlit9664;
}
Object meth_ast_9227_new_40_3_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_varDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9228 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9228 = alloc_userobj2(26,22, objclass9228);
  gc_frame_newslot(obj9228);
  if (objclass9228 == NULL) {
    glfree(obj9228->class->name);
    obj9228->class->name = "varDecNode.new(_,_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj9228, self, 0);
  addmethodreal(obj9228,"outer", &reader_ast_outer_9229);
  Object oldself9228 = self;
  struct StackFrameObject *oldstackframe9228 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9228);
  gc_frame_newslot((Object)stackframe);
  self = obj9228;
  Object *oldselfslot9228 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9228 = (*(struct UserObject *)self).data[0], lowerouter9228 = thisouter9228;
  if (inheritingObject9228) {
    struct UserObject *inho9228 = (struct UserObject *)inheritingObject9228;
    while (inho9228->super != GraceDefaultObject) inho9228 = (struct UserObject *)inho9228->super;
    inho9228->super = obj9228;
    self = inheritingObject9228;
    *selfslot = self;
    lowerouter9228 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9228;
  }
  if (objclass9228 == NULL) {
  Method *reader9230 = addmethodrealflags(obj9228, "kind",&reader_ast_kind_9230, MFLAG_DEF);
  reader9230->definitionModule = modulename;
  reader9230->definitionLine = 2444;
  }
  adddatum2(obj9228, alloc_Undefined(), 1);
  if (objclass9228 == NULL) {
    Method *reader9231 = addmethodrealflags(obj9228, "name", &reader_ast_name_9231, 0);
    Method *writer9231 = addmethodrealflags(obj9228, "name:=(1)", &writer_ast_name_9231, 0);
    reader9231->definitionModule = modulename;
    writer9231->definitionModule = modulename;
    reader9231->definitionLine = 2445;
    writer9231->definitionLine = 2445;
  }
  obj9228->flags |= OFLAG_MUTABLE;
  adddatum2(obj9228, alloc_Undefined(), 2);
  if (objclass9228 == NULL) {
    Method *reader9232 = addmethodrealflags(obj9228, "value", &reader_ast_value_9232, 0);
    Method *writer9232 = addmethodrealflags(obj9228, "value:=(1)", &writer_ast_value_9232, 0);
    reader9232->definitionModule = modulename;
    writer9232->definitionModule = modulename;
    reader9232->definitionLine = 2446;
    writer9232->definitionLine = 2446;
  }
  obj9228->flags |= OFLAG_MUTABLE;
  adddatum2(obj9228, alloc_Undefined(), 3);
  if (objclass9228 == NULL) {
    Method *reader9233 = addmethodrealflags(obj9228, "dtype", &reader_ast_dtype_9233, 0);
    Method *writer9233 = addmethodrealflags(obj9228, "dtype:=(1)", &writer_ast_dtype_9233, 0);
    reader9233->definitionModule = modulename;
    writer9233->definitionModule = modulename;
    reader9233->definitionLine = 2447;
    writer9233->definitionLine = 2447;
  }
  obj9228->flags |= OFLAG_MUTABLE;
  adddatum2(obj9228, alloc_Undefined(), 4);
  if (objclass9228 == NULL) {
    Method *reader9234 = addmethodrealflags(obj9228, "parentKind", &reader_ast_parentKind_9234, 0);
    Method *writer9234 = addmethodrealflags(obj9228, "parentKind:=(1)", &writer_ast_parentKind_9234, 0);
    reader9234->definitionModule = modulename;
    writer9234->definitionModule = modulename;
    reader9234->definitionLine = 2448;
    writer9234->definitionLine = 2448;
  }
  obj9228->flags |= OFLAG_MUTABLE;
  adddatum2(obj9228, alloc_Undefined(), 5);
  if (objclass9228 == NULL) {
  Method *reader9235 = addmethodrealflags(obj9228, "nameString",&reader_ast_nameString_9235, MFLAG_DEF);
  reader9235->definitionModule = modulename;
  reader9235->definitionLine = 2449;
  }
  adddatum2(obj9228, alloc_Undefined(), 6);
  if (objclass9228 == NULL) {
    Method *reader9236 = addmethodrealflags(obj9228, "annotations", &reader_ast_annotations_9236, 0);
    Method *writer9236 = addmethodrealflags(obj9228, "annotations:=(1)", &writer_ast_annotations_9236, 0);
    reader9236->definitionModule = modulename;
    writer9236->definitionModule = modulename;
    reader9236->definitionLine = 2450;
    writer9236->definitionLine = 2450;
  }
  obj9228->flags |= OFLAG_MUTABLE;
  adddatum2(obj9228, alloc_Undefined(), 7);
// method "end"
  struct UserObject *uo9237 = (struct UserObject*)obj9228;
  uo9237->data[8] = emptyclosure;
  Method *meth_meth_ast_9237_end = addmethod2pos(obj9228, "end", &meth_ast_9237_end, 8);
  int argcv_meth_ast_9237_end[] = {0};
  meth_meth_ast_9237_end->type = alloc_MethodType(1, argcv_meth_ast_9237_end);
  meth_meth_ast_9237_end->definitionModule = modulename;
  meth_meth_ast_9237_end->definitionLine = 2452;
// method "isPublic"
  struct UserObject *uo9277 = (struct UserObject*)obj9228;
  uo9277->data[9] = emptyclosure;
  Method *meth_meth_ast_9277_isPublic = addmethod2pos(obj9228, "isPublic", &meth_ast_9277_isPublic, 9);
  int argcv_meth_ast_9277_isPublic[] = {0};
  meth_meth_ast_9277_isPublic->type = alloc_MethodType(1, argcv_meth_ast_9277_isPublic);
  meth_meth_ast_9277_isPublic->definitionModule = modulename;
  meth_meth_ast_9277_isPublic->definitionLine = 2458;
// method "isWritable"
  struct UserObject *uo9296 = (struct UserObject*)obj9228;
  uo9296->data[10] = emptyclosure;
  Method *meth_meth_ast_9296_isWritable = addmethod2pos(obj9228, "isWritable", &meth_ast_9296_isWritable, 10);
  int argcv_meth_ast_9296_isWritable[] = {0};
  meth_meth_ast_9296_isWritable->type = alloc_MethodType(1, argcv_meth_ast_9296_isWritable);
  meth_meth_ast_9296_isWritable->definitionModule = modulename;
  meth_meth_ast_9296_isWritable->definitionLine = 2464;
// method "isReadable"
  struct UserObject *uo9318 = (struct UserObject*)obj9228;
  uo9318->data[11] = emptyclosure;
  Method *meth_meth_ast_9318_isReadable = addmethod2pos(obj9228, "isReadable", &meth_ast_9318_isReadable, 11);
  int argcv_meth_ast_9318_isReadable[] = {0};
  meth_meth_ast_9318_isReadable->type = alloc_MethodType(1, argcv_meth_ast_9318_isReadable);
  meth_meth_ast_9318_isReadable->definitionModule = modulename;
  meth_meth_ast_9318_isReadable->definitionLine = 2470;
// method "isFieldDec"
  struct UserObject *uo9340 = (struct UserObject*)obj9228;
  uo9340->data[12] = emptyclosure;
  Method *meth_meth_ast_9340_isFieldDec = addmethod2pos(obj9228, "isFieldDec", &meth_ast_9340_isFieldDec, 12);
  int argcv_meth_ast_9340_isFieldDec[] = {0};
  meth_meth_ast_9340_isFieldDec->type = alloc_MethodType(1, argcv_meth_ast_9340_isFieldDec);
  meth_meth_ast_9340_isFieldDec->definitionModule = modulename;
  meth_meth_ast_9340_isFieldDec->definitionLine = 2476;
// method "usesAsType(_)"
  struct UserObject *uo9342 = (struct UserObject*)obj9228;
  uo9342->data[13] = emptyclosure;
  Method *meth_meth_ast_9342_usesAsType_40_1_41_ = addmethod2pos(obj9228, "usesAsType(1)", &meth_ast_9342_usesAsType_40_1_41_, 13);
  int argcv_meth_ast_9342_usesAsType_40_1_41_[] = {1};
  meth_meth_ast_9342_usesAsType_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9342_usesAsType_40_1_41_);
  meth_meth_ast_9342_usesAsType_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9342_usesAsType_40_1_41_->definitionLine = 2478;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj9228);
  Object closure9348 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure9348, stackframe);
  addtoclosure(closure9348, var_k);
  struct UserObject *uo9348 = (struct UserObject*)obj9228;
  uo9348->data[14] = (Object)closure9348;
  Method *meth_meth_ast_9348_declarationKindWithAncestors_40_1_41_ = addmethod2pos(obj9228, "declarationKindWithAncestors(1)", &meth_ast_9348_declarationKindWithAncestors_40_1_41_, 14);
  int argcv_meth_ast_9348_declarationKindWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_9348_declarationKindWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9348_declarationKindWithAncestors_40_1_41_);
  meth_meth_ast_9348_declarationKindWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9348_declarationKindWithAncestors_40_1_41_->definitionLine = 2482;
// method "accept(_)from(_)"
  struct UserObject *uo9351 = (struct UserObject*)obj9228;
  uo9351->data[15] = emptyclosure;
  Method *meth_meth_ast_9351_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj9228, "accept(1)from(1)", &meth_ast_9351_accept_40_1_41_from_40_1_41_, 15);
  int argcv_meth_ast_9351_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_9351_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_9351_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_9351_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9351_accept_40_1_41_from_40_1_41_->definitionLine = 2484;
// method "map(_)ancestors(_)"
  struct UserObject *uo9392 = (struct UserObject*)obj9228;
  uo9392->data[16] = emptyclosure;
  Method *meth_meth_ast_9392_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj9228, "map(1)ancestors(1)", &meth_ast_9392_map_40_1_41_ancestors_40_1_41_, 16);
  int argcv_meth_ast_9392_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_9392_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_9392_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_9392_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9392_map_40_1_41_ancestors_40_1_41_->definitionLine = 2499;
// method "pretty(_)"
  struct UserObject *uo9423 = (struct UserObject*)obj9228;
  uo9423->data[17] = emptyclosure;
  Method *meth_meth_ast_9423_pretty_40_1_41_ = addmethod2pos(obj9228, "pretty(1)", &meth_ast_9423_pretty_40_1_41_, 17);
  int argcv_meth_ast_9423_pretty_40_1_41_[] = {1};
  meth_meth_ast_9423_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9423_pretty_40_1_41_);
  meth_meth_ast_9423_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9423_pretty_40_1_41_->definitionLine = 2508;
// method "toGrace(_)"
  struct UserObject *uo9534 = (struct UserObject*)obj9228;
  uo9534->data[18] = emptyclosure;
  Method *meth_meth_ast_9534_toGrace_40_1_41_ = addmethod2pos(obj9228, "toGrace(1)", &meth_ast_9534_toGrace_40_1_41_, 18);
  int argcv_meth_ast_9534_toGrace_40_1_41_[] = {1};
  meth_meth_ast_9534_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9534_toGrace_40_1_41_);
meth_meth_ast_9534_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_9534_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_9534_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9534_toGrace_40_1_41_->definitionLine = 2525;
// method "shallowCopy"
  block_savedest(obj9228);
  Object closure9647 = createclosure(1, "shallowCopy");
  setclosureframe(closure9647, stackframe);
  addtoclosure(closure9647, var_varDecNode);
  struct UserObject *uo9647 = (struct UserObject*)obj9228;
  uo9647->data[19] = (Object)closure9647;
  Method *meth_meth_ast_9647_shallowCopy = addmethod2pos(obj9228, "shallowCopy", &meth_ast_9647_shallowCopy, 19);
  int argcv_meth_ast_9647_shallowCopy[] = {0};
  meth_meth_ast_9647_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_9647_shallowCopy);
  meth_meth_ast_9647_shallowCopy->definitionModule = modulename;
  meth_meth_ast_9647_shallowCopy->definitionLine = 2543;
// method "postCopy(_)"
  struct UserObject *uo9658 = (struct UserObject*)obj9228;
  uo9658->data[20] = emptyclosure;
  Method *meth_meth_ast_9658_postCopy_40_1_41_ = addmethod2pos(obj9228, "postCopy(1)", &meth_ast_9658_postCopy_40_1_41_, 20);
  int argcv_meth_ast_9658_postCopy_40_1_41_[] = {1};
  meth_meth_ast_9658_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9658_postCopy_40_1_41_);
  meth_meth_ast_9658_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9658_postCopy_40_1_41_->definitionLine = 2546;
// method "statementName"
  struct UserObject *uo9663 = (struct UserObject*)obj9228;
  uo9663->data[21] = emptyclosure;
  Method *meth_meth_ast_9663_statementName = addmethod2pos(obj9228, "statementName", &meth_ast_9663_statementName, 21);
  int argcv_meth_ast_9663_statementName[] = {0};
  meth_meth_ast_9663_statementName->type = alloc_MethodType(1, argcv_meth_ast_9663_statementName);
  meth_meth_ast_9663_statementName->definitionModule = modulename;
  meth_meth_ast_9663_statementName->definitionLine = 2550;
  sourceObject = obj9228;
// Begin line 2443
  setline(2443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9665 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9666 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9665);
// compiled call node returning call9666 (depth = 3)
  struct UserObject *obj9228_uo = (struct UserObject *)obj9228;
  obj9228_uo->super = call9666;
  sourceObject = obj9228;
// Begin line 2444
  setline(2444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9667 == NULL) {
    strlit9667 = alloc_String("vardec");
    gc_root(strlit9667);
  }
// compiled string node returning strlit9667 (depth = 3)
  adddatum2(obj9228, strlit9667, 1);
  sourceObject = obj9228;
// Begin line 2445
  setline(2445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj9228, *var_name_39_, 2);
  sourceObject = obj9228;
// Begin line 2446
  setline(2446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj9228, *var_val_39_, 3);
  sourceObject = obj9228;
// Begin line 2447
  setline(2447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj9228, *var_dtype_39_, 4);
  sourceObject = obj9228;
// Begin line 2448
  setline(2448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9668 == NULL) {
    strlit9668 = alloc_String("unset");
    gc_root(strlit9668);
  }
// compiled string node returning strlit9668 (depth = 3)
  adddatum2(obj9228, strlit9668, 5);
  sourceObject = obj9228;
// Begin line 2449
  setline(2449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9669 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9670 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9671 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9670);
// compiled member node returning call9671 (depth = 4)
  partcv[0] = 0;
  Object call9672 = callmethodflags(call9671, "value", 1, partcv, params, 0);
  gc_frame_end(callframe9669);
// compiled member node returning call9672 (depth = 3)
  adddatum2(obj9228, call9672, 6);
  sourceObject = obj9228;
// Begin line 2450
  setline(2450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array9673 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9673 (depth = 3)
  adddatum2(obj9228, array9673, 7);
  sourceObject = obj9228;
  sourceObject = obj9228;
  sourceObject = obj9228;
  sourceObject = obj9228;
  sourceObject = obj9228;
  sourceObject = obj9228;
  sourceObject = obj9228;
  sourceObject = obj9228;
  sourceObject = obj9228;
  sourceObject = obj9228;
  sourceObject = obj9228;
  sourceObject = obj9228;
  sourceObject = obj9228;
  sourceObject = obj9228;
  objclass9228 = obj9228->class;
  objclass9228->definitionModule = modulename;
  objclass9228->definitionLine = 2442;
  (*(struct UserObject *)self).data[0] = lowerouter9228;
  self = oldself9228;
  selfslot = oldselfslot9228;
  stackframe = oldstackframe9228;
  gc_frame_end(frame);
  return obj9228;
}
Object meth_ast_9227_new_40_3_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_varDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9228 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9228 = alloc_userobj2(26,22, objclass9228);
  gc_frame_newslot(obj9228);
  if (objclass9228 == NULL) {
    glfree(obj9228->class->name);
    obj9228->class->name = "varDecNode.new(_,_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj9228, self, 0);
  addmethodreal(obj9228,"outer", &reader_ast_outer_9229);
  Object oldself9228 = self;
  struct StackFrameObject *oldstackframe9228 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9228);
  gc_frame_newslot((Object)stackframe);
  self = obj9228;
  Object *oldselfslot9228 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9228 = (*(struct UserObject *)self).data[0], lowerouter9228 = thisouter9228;
  if (inheritingObject9228) {
    struct UserObject *inho9228 = (struct UserObject *)inheritingObject9228;
    while (inho9228->super != GraceDefaultObject) inho9228 = (struct UserObject *)inho9228->super;
    inho9228->super = obj9228;
    self = inheritingObject9228;
    *selfslot = self;
    lowerouter9228 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9228;
  }
  if (objclass9228 == NULL) {
  Method *reader9230 = addmethodrealflags(obj9228, "kind",&reader_ast_kind_9230, MFLAG_DEF);
  reader9230->definitionModule = modulename;
  reader9230->definitionLine = 2444;
  }
  adddatum2(obj9228, alloc_Undefined(), 1);
  if (objclass9228 == NULL) {
    Method *reader9231 = addmethodrealflags(obj9228, "name", &reader_ast_name_9231, 0);
    Method *writer9231 = addmethodrealflags(obj9228, "name:=(1)", &writer_ast_name_9231, 0);
    reader9231->definitionModule = modulename;
    writer9231->definitionModule = modulename;
    reader9231->definitionLine = 2445;
    writer9231->definitionLine = 2445;
  }
  obj9228->flags |= OFLAG_MUTABLE;
  adddatum2(obj9228, alloc_Undefined(), 2);
  if (objclass9228 == NULL) {
    Method *reader9232 = addmethodrealflags(obj9228, "value", &reader_ast_value_9232, 0);
    Method *writer9232 = addmethodrealflags(obj9228, "value:=(1)", &writer_ast_value_9232, 0);
    reader9232->definitionModule = modulename;
    writer9232->definitionModule = modulename;
    reader9232->definitionLine = 2446;
    writer9232->definitionLine = 2446;
  }
  obj9228->flags |= OFLAG_MUTABLE;
  adddatum2(obj9228, alloc_Undefined(), 3);
  if (objclass9228 == NULL) {
    Method *reader9233 = addmethodrealflags(obj9228, "dtype", &reader_ast_dtype_9233, 0);
    Method *writer9233 = addmethodrealflags(obj9228, "dtype:=(1)", &writer_ast_dtype_9233, 0);
    reader9233->definitionModule = modulename;
    writer9233->definitionModule = modulename;
    reader9233->definitionLine = 2447;
    writer9233->definitionLine = 2447;
  }
  obj9228->flags |= OFLAG_MUTABLE;
  adddatum2(obj9228, alloc_Undefined(), 4);
  if (objclass9228 == NULL) {
    Method *reader9234 = addmethodrealflags(obj9228, "parentKind", &reader_ast_parentKind_9234, 0);
    Method *writer9234 = addmethodrealflags(obj9228, "parentKind:=(1)", &writer_ast_parentKind_9234, 0);
    reader9234->definitionModule = modulename;
    writer9234->definitionModule = modulename;
    reader9234->definitionLine = 2448;
    writer9234->definitionLine = 2448;
  }
  obj9228->flags |= OFLAG_MUTABLE;
  adddatum2(obj9228, alloc_Undefined(), 5);
  if (objclass9228 == NULL) {
  Method *reader9235 = addmethodrealflags(obj9228, "nameString",&reader_ast_nameString_9235, MFLAG_DEF);
  reader9235->definitionModule = modulename;
  reader9235->definitionLine = 2449;
  }
  adddatum2(obj9228, alloc_Undefined(), 6);
  if (objclass9228 == NULL) {
    Method *reader9236 = addmethodrealflags(obj9228, "annotations", &reader_ast_annotations_9236, 0);
    Method *writer9236 = addmethodrealflags(obj9228, "annotations:=(1)", &writer_ast_annotations_9236, 0);
    reader9236->definitionModule = modulename;
    writer9236->definitionModule = modulename;
    reader9236->definitionLine = 2450;
    writer9236->definitionLine = 2450;
  }
  obj9228->flags |= OFLAG_MUTABLE;
  adddatum2(obj9228, alloc_Undefined(), 7);
// method "end"
  struct UserObject *uo9237 = (struct UserObject*)obj9228;
  uo9237->data[8] = emptyclosure;
  Method *meth_meth_ast_9237_end = addmethod2pos(obj9228, "end", &meth_ast_9237_end, 8);
  int argcv_meth_ast_9237_end[] = {0};
  meth_meth_ast_9237_end->type = alloc_MethodType(1, argcv_meth_ast_9237_end);
  meth_meth_ast_9237_end->definitionModule = modulename;
  meth_meth_ast_9237_end->definitionLine = 2452;
// method "isPublic"
  struct UserObject *uo9277 = (struct UserObject*)obj9228;
  uo9277->data[9] = emptyclosure;
  Method *meth_meth_ast_9277_isPublic = addmethod2pos(obj9228, "isPublic", &meth_ast_9277_isPublic, 9);
  int argcv_meth_ast_9277_isPublic[] = {0};
  meth_meth_ast_9277_isPublic->type = alloc_MethodType(1, argcv_meth_ast_9277_isPublic);
  meth_meth_ast_9277_isPublic->definitionModule = modulename;
  meth_meth_ast_9277_isPublic->definitionLine = 2458;
// method "isWritable"
  struct UserObject *uo9296 = (struct UserObject*)obj9228;
  uo9296->data[10] = emptyclosure;
  Method *meth_meth_ast_9296_isWritable = addmethod2pos(obj9228, "isWritable", &meth_ast_9296_isWritable, 10);
  int argcv_meth_ast_9296_isWritable[] = {0};
  meth_meth_ast_9296_isWritable->type = alloc_MethodType(1, argcv_meth_ast_9296_isWritable);
  meth_meth_ast_9296_isWritable->definitionModule = modulename;
  meth_meth_ast_9296_isWritable->definitionLine = 2464;
// method "isReadable"
  struct UserObject *uo9318 = (struct UserObject*)obj9228;
  uo9318->data[11] = emptyclosure;
  Method *meth_meth_ast_9318_isReadable = addmethod2pos(obj9228, "isReadable", &meth_ast_9318_isReadable, 11);
  int argcv_meth_ast_9318_isReadable[] = {0};
  meth_meth_ast_9318_isReadable->type = alloc_MethodType(1, argcv_meth_ast_9318_isReadable);
  meth_meth_ast_9318_isReadable->definitionModule = modulename;
  meth_meth_ast_9318_isReadable->definitionLine = 2470;
// method "isFieldDec"
  struct UserObject *uo9340 = (struct UserObject*)obj9228;
  uo9340->data[12] = emptyclosure;
  Method *meth_meth_ast_9340_isFieldDec = addmethod2pos(obj9228, "isFieldDec", &meth_ast_9340_isFieldDec, 12);
  int argcv_meth_ast_9340_isFieldDec[] = {0};
  meth_meth_ast_9340_isFieldDec->type = alloc_MethodType(1, argcv_meth_ast_9340_isFieldDec);
  meth_meth_ast_9340_isFieldDec->definitionModule = modulename;
  meth_meth_ast_9340_isFieldDec->definitionLine = 2476;
// method "usesAsType(_)"
  struct UserObject *uo9342 = (struct UserObject*)obj9228;
  uo9342->data[13] = emptyclosure;
  Method *meth_meth_ast_9342_usesAsType_40_1_41_ = addmethod2pos(obj9228, "usesAsType(1)", &meth_ast_9342_usesAsType_40_1_41_, 13);
  int argcv_meth_ast_9342_usesAsType_40_1_41_[] = {1};
  meth_meth_ast_9342_usesAsType_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9342_usesAsType_40_1_41_);
  meth_meth_ast_9342_usesAsType_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9342_usesAsType_40_1_41_->definitionLine = 2478;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj9228);
  Object closure9348 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure9348, stackframe);
  addtoclosure(closure9348, var_k);
  struct UserObject *uo9348 = (struct UserObject*)obj9228;
  uo9348->data[14] = (Object)closure9348;
  Method *meth_meth_ast_9348_declarationKindWithAncestors_40_1_41_ = addmethod2pos(obj9228, "declarationKindWithAncestors(1)", &meth_ast_9348_declarationKindWithAncestors_40_1_41_, 14);
  int argcv_meth_ast_9348_declarationKindWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_9348_declarationKindWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9348_declarationKindWithAncestors_40_1_41_);
  meth_meth_ast_9348_declarationKindWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9348_declarationKindWithAncestors_40_1_41_->definitionLine = 2482;
// method "accept(_)from(_)"
  struct UserObject *uo9351 = (struct UserObject*)obj9228;
  uo9351->data[15] = emptyclosure;
  Method *meth_meth_ast_9351_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj9228, "accept(1)from(1)", &meth_ast_9351_accept_40_1_41_from_40_1_41_, 15);
  int argcv_meth_ast_9351_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_9351_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_9351_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_9351_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9351_accept_40_1_41_from_40_1_41_->definitionLine = 2484;
// method "map(_)ancestors(_)"
  struct UserObject *uo9392 = (struct UserObject*)obj9228;
  uo9392->data[16] = emptyclosure;
  Method *meth_meth_ast_9392_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj9228, "map(1)ancestors(1)", &meth_ast_9392_map_40_1_41_ancestors_40_1_41_, 16);
  int argcv_meth_ast_9392_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_9392_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_9392_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_9392_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9392_map_40_1_41_ancestors_40_1_41_->definitionLine = 2499;
// method "pretty(_)"
  struct UserObject *uo9423 = (struct UserObject*)obj9228;
  uo9423->data[17] = emptyclosure;
  Method *meth_meth_ast_9423_pretty_40_1_41_ = addmethod2pos(obj9228, "pretty(1)", &meth_ast_9423_pretty_40_1_41_, 17);
  int argcv_meth_ast_9423_pretty_40_1_41_[] = {1};
  meth_meth_ast_9423_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9423_pretty_40_1_41_);
  meth_meth_ast_9423_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9423_pretty_40_1_41_->definitionLine = 2508;
// method "toGrace(_)"
  struct UserObject *uo9534 = (struct UserObject*)obj9228;
  uo9534->data[18] = emptyclosure;
  Method *meth_meth_ast_9534_toGrace_40_1_41_ = addmethod2pos(obj9228, "toGrace(1)", &meth_ast_9534_toGrace_40_1_41_, 18);
  int argcv_meth_ast_9534_toGrace_40_1_41_[] = {1};
  meth_meth_ast_9534_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9534_toGrace_40_1_41_);
meth_meth_ast_9534_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_9534_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_9534_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9534_toGrace_40_1_41_->definitionLine = 2525;
// method "shallowCopy"
  block_savedest(obj9228);
  Object closure9647 = createclosure(1, "shallowCopy");
  setclosureframe(closure9647, stackframe);
  addtoclosure(closure9647, var_varDecNode);
  struct UserObject *uo9647 = (struct UserObject*)obj9228;
  uo9647->data[19] = (Object)closure9647;
  Method *meth_meth_ast_9647_shallowCopy = addmethod2pos(obj9228, "shallowCopy", &meth_ast_9647_shallowCopy, 19);
  int argcv_meth_ast_9647_shallowCopy[] = {0};
  meth_meth_ast_9647_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_9647_shallowCopy);
  meth_meth_ast_9647_shallowCopy->definitionModule = modulename;
  meth_meth_ast_9647_shallowCopy->definitionLine = 2543;
// method "postCopy(_)"
  struct UserObject *uo9658 = (struct UserObject*)obj9228;
  uo9658->data[20] = emptyclosure;
  Method *meth_meth_ast_9658_postCopy_40_1_41_ = addmethod2pos(obj9228, "postCopy(1)", &meth_ast_9658_postCopy_40_1_41_, 20);
  int argcv_meth_ast_9658_postCopy_40_1_41_[] = {1};
  meth_meth_ast_9658_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9658_postCopy_40_1_41_);
  meth_meth_ast_9658_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9658_postCopy_40_1_41_->definitionLine = 2546;
// method "statementName"
  struct UserObject *uo9663 = (struct UserObject*)obj9228;
  uo9663->data[21] = emptyclosure;
  Method *meth_meth_ast_9663_statementName = addmethod2pos(obj9228, "statementName", &meth_ast_9663_statementName, 21);
  int argcv_meth_ast_9663_statementName[] = {0};
  meth_meth_ast_9663_statementName->type = alloc_MethodType(1, argcv_meth_ast_9663_statementName);
  meth_meth_ast_9663_statementName->definitionModule = modulename;
  meth_meth_ast_9663_statementName->definitionLine = 2550;
  sourceObject = obj9228;
// Begin line 2443
  setline(2443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9665 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9666 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9665);
// compiled call node returning call9666 (depth = 3)
  struct UserObject *obj9228_uo = (struct UserObject *)obj9228;
  obj9228_uo->super = call9666;
  sourceObject = obj9228;
// Begin line 2444
  setline(2444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9667 == NULL) {
    strlit9667 = alloc_String("vardec");
    gc_root(strlit9667);
  }
// compiled string node returning strlit9667 (depth = 3)
  adddatum2(obj9228, strlit9667, 1);
  sourceObject = obj9228;
// Begin line 2445
  setline(2445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj9228, *var_name_39_, 2);
  sourceObject = obj9228;
// Begin line 2446
  setline(2446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj9228, *var_val_39_, 3);
  sourceObject = obj9228;
// Begin line 2447
  setline(2447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj9228, *var_dtype_39_, 4);
  sourceObject = obj9228;
// Begin line 2448
  setline(2448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9668 == NULL) {
    strlit9668 = alloc_String("unset");
    gc_root(strlit9668);
  }
// compiled string node returning strlit9668 (depth = 3)
  adddatum2(obj9228, strlit9668, 5);
  sourceObject = obj9228;
// Begin line 2449
  setline(2449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9669 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9670 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9671 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9670);
// compiled member node returning call9671 (depth = 4)
  partcv[0] = 0;
  Object call9672 = callmethodflags(call9671, "value", 1, partcv, params, 0);
  gc_frame_end(callframe9669);
// compiled member node returning call9672 (depth = 3)
  adddatum2(obj9228, call9672, 6);
  sourceObject = obj9228;
// Begin line 2450
  setline(2450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array9673 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9673 (depth = 3)
  adddatum2(obj9228, array9673, 7);
  sourceObject = obj9228;
  sourceObject = obj9228;
  sourceObject = obj9228;
  sourceObject = obj9228;
  sourceObject = obj9228;
  sourceObject = obj9228;
  sourceObject = obj9228;
  sourceObject = obj9228;
  sourceObject = obj9228;
  sourceObject = obj9228;
  sourceObject = obj9228;
  sourceObject = obj9228;
  sourceObject = obj9228;
  sourceObject = obj9228;
  objclass9228 = obj9228->class;
  objclass9228->definitionModule = modulename;
  objclass9228->definitionLine = 2442;
  (*(struct UserObject *)self).data[0] = lowerouter9228;
  self = oldself9228;
  selfslot = oldselfslot9228;
  stackframe = oldstackframe9228;
  gc_frame_end(frame);
  return obj9228;
}
Object meth_ast_9675_varDecNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 51, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "varDecNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_varDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2441
  setline(2441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_varDecNode (depth = 3)
  gc_frame_end(frame);
  return *var_varDecNode;
}
Object meth_ast_9686_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2562
  setline(2562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9687 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9688 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9689 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9688);
// compiled member node returning call9689 (depth = 4)
  partcv[0] = 0;
  Object call9690 = callmethodflags(call9689, "end", 1, partcv, params, 0);
  gc_frame_end(callframe9687);
// compiled member node returning call9690 (depth = 3)
  gc_frame_end(frame);
  return call9690;
}
Object meth_ast_9691_isImport(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isImport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2563
  setline(2563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9692 = alloc_Boolean(1);
// compiled identifier node returning bool9692 (depth = 3)
  gc_frame_end(frame);
  return bool9692;
}
Object meth_ast_9693_isExternal(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExternal");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2564
  setline(2564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9694 = alloc_Boolean(1);
// compiled identifier node returning bool9694 (depth = 3)
  gc_frame_end(frame);
  return bool9694;
}
Object meth_ast_9695_isExecutable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2565
  setline(2565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9696 = alloc_Boolean(0);
// compiled identifier node returning bool9696 (depth = 3)
  gc_frame_end(frame);
  return bool9696;
}
Object meth_ast_9697_name(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2566
  setline(2566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9698 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9699 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9698);
// compiled member node returning call9699 (depth = 3)
  gc_frame_end(frame);
  return call9699;
}
Object meth_ast_9700_nameString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2567
  setline(2567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9701 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9702 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9703 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9702);
// compiled member node returning call9703 (depth = 4)
  partcv[0] = 0;
  Object call9704 = callmethodflags(call9703, "nameString", 1, partcv, params, 0);
  gc_frame_end(callframe9701);
// compiled member node returning call9704 (depth = 3)
  gc_frame_end(frame);
  return call9704;
}
Object meth_ast_9705_isPublic(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2570
  setline(2570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num9708 = alloc_Float64(0);
// compiled num node returning num9708 (depth = 5)
  int op_slot_right_9707 = gc_frame_newslot(num9708);
// starting to compile member node (depth = 5)
  int callframe9710 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9711 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9712 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9711);
// compiled member node returning call9712 (depth = 6)
  partcv[0] = 0;
  Object call9713 = callmethodflags(call9712, "size", 1, partcv, params, 0);
  gc_frame_end(callframe9710);
// compiled member node returning call9713 (depth = 5)
  int op_slot_left_9707 = gc_frame_newslot(call9713);
  params[0] = num9708;
  partcv[0] = 1;
  Object opresult9714 = callmethod(call9713, "==(1)", 1, partcv, params);
// compiled op node returning opresult9714 (depth = 4)
  Object if9706 = done;
  if (istrue(opresult9714)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool9715 = alloc_Boolean(0);
// compiled identifier node returning bool9715 (depth = 5)
  return bool9715;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if9706 = undefined;
  } else {
  }
// compiled if node returning if9706 (depth = 3)
// Begin line 2571
  setline(2571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9717 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit9718 == NULL) {
    strlit9718 = alloc_String("public");
    gc_root(strlit9718);
  }
// compiled string node returning strlit9718 (depth = 5)
  gc_frame_newslot(strlit9718);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = self;
  params[1] = strlit9718;
  partcv[0] = 2;
  Object call9719 = callmethodflags(module_ast, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9717);
// compiled call node returning call9719 (depth = 4)
  Object if9716 = done;
  if (istrue(call9719)) {
// Begin line 2571
  setline(2571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool9720 = alloc_Boolean(1);
// compiled identifier node returning bool9720 (depth = 5)
  return bool9720;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if9716 = undefined;
  } else {
  }
// compiled if node returning if9716 (depth = 3)
// Begin line 2572
  setline(2572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9721 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit9722 == NULL) {
    strlit9722 = alloc_String("readable");
    gc_root(strlit9722);
  }
// compiled string node returning strlit9722 (depth = 4)
  gc_frame_newslot(strlit9722);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  params[1] = strlit9722;
  partcv[0] = 2;
  Object call9723 = callmethodflags(module_ast, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9721);
// compiled call node returning call9723 (depth = 3)
  gc_frame_end(frame);
  return call9723;
}
Object meth_ast_9730__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_bnm = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 2577
  setline(2577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9733 == NULL) {
    strlit9733 = alloc_String("/");
    gc_root(strlit9733);
  }
// compiled string node returning strlit9733 (depth = 7)
  int op_slot_right_9732 = gc_frame_newslot(strlit9733);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_left_9732 = gc_frame_newslot(*var_c);
  params[0] = strlit9733;
  partcv[0] = 1;
  Object opresult9735 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult9735 (depth = 6)
  Object if9731 = done;
  if (istrue(opresult9735)) {
// Begin line 2578
  setline(2578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9736 == NULL) {
    strlit9736 = alloc_String("");
    gc_root(strlit9736);
  }
// compiled string node returning strlit9736 (depth = 7)
  *var_bnm = strlit9736;
  if (strlit9736 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if9731 = done;
  } else {
// Begin line 2580
  setline(2580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_right_9738 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_bnm (depth = 8)
  int op_slot_left_9738 = gc_frame_newslot(*var_bnm);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult9740 = callmethod(*var_bnm, "++(1)", 1, partcv, params);
// compiled op node returning opresult9740 (depth = 7)
  *var_bnm = opresult9740;
  if (opresult9740 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if9731 = done;
  }
// compiled if node returning if9731 (depth = 5)
  gc_frame_end(frame);
  return if9731;
}
Object meth_ast_9724_moduleName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "moduleName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_bnm = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "bnm");
// Begin line 2575
  setline(2575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9725 == NULL) {
    strlit9725 = alloc_String("");
    gc_root(strlit9725);
  }
// compiled string node returning strlit9725 (depth = 4)
  *var_bnm = strlit9725;
  if (strlit9725 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2576
  setline(2576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9726 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe9727 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9728 = callmethodflags(self, "path", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9727);
// compiled member node returning call9728 (depth = 4)
  gc_frame_newslot(call9728);
// starting to compile block node (depth = 4)
  Object block9729 = alloc_Block(NULL, NULL, "ast", 2576);
  gc_frame_newslot(block9729);
// method "_apply(_)"
  block_savedest(block9729);
  Object closure9730 = createclosure(2, "_apply(1)");
  setclosureframe(closure9730, stackframe);
  addtoclosure(closure9730, var_bnm);
  addtoclosure(closure9730, selfslot);
  struct UserObject *uo9730 = (struct UserObject*)block9729;
  uo9730->data[0] = (Object)closure9730;
  Method *meth_meth_ast_9730__apply_40_1_41_ = addmethod2pos(block9729, "_apply(1)", &meth_ast_9730__apply_40_1_41_, 0);
  int argcv_meth_ast_9730__apply_40_1_41_[] = {1};
  meth_meth_ast_9730__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9730__apply_40_1_41_);
  meth_meth_ast_9730__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9730__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block9729 (depth = 4)
  gc_frame_newslot(block9729);
// call case 5: prelude request
  params[0] = call9728;
  params[1] = block9729;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9743 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9726);
// compiled call node returning call9743 (depth = 3)
// Begin line 2583
  setline(2583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_bnm (depth = 3)
  gc_frame_end(frame);
  return *var_bnm;
}
Object meth_ast_9744_isWritable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2585
  setline(2585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9745 = alloc_Boolean(0);
// compiled identifier node returning bool9745 (depth = 3)
  gc_frame_end(frame);
  return bool9745;
}
Object meth_ast_9746_isReadable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2586
  setline(2586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9747 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9748 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9747);
// compiled member node returning call9748 (depth = 3)
  gc_frame_end(frame);
  return call9748;
}
Object meth_ast_9749_declarationKindWithAncestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2587
  setline(2587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9750 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  partcv[0] = 0;
  Object call9751 = callmethodflags(*var_k, "defdec", 1, partcv, params, 0);
  gc_frame_end(callframe9750);
// compiled member node returning call9751 (depth = 3)
  gc_frame_end(frame);
  return call9751;
}
Object meth_ast_9752_usesAsType_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part usesAsType(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2589
  setline(2589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9754 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9755 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9754);
// compiled member node returning call9755 (depth = 4)
  int op_slot_right_9753 = gc_frame_newslot(call9755);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_9753 = gc_frame_newslot(*var_aNode);
  params[0] = call9755;
  partcv[0] = 1;
  Object opresult9757 = callmethod(*var_aNode, "==(1)", 1, partcv, params);
// compiled op node returning opresult9757 (depth = 3)
  gc_frame_end(frame);
  return opresult9757;
}
Object meth_ast_9768__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2595
  setline(2595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9769 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9770 = callmethodflags(*var_ann, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9769);
// compiled call node returning call9770 (depth = 6)
  gc_frame_end(frame);
  return call9770;
}
Object meth_ast_9758_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// definebindings:
// definebindings:
// definebindings:
// Begin line 2592
  setline(2592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9760 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9761 = callmethodflags(*var_visitor, "visitImport(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9760);
// compiled call node returning call9761 (depth = 4)
  Object if9759 = done;
  if (istrue(call9761)) {
// Begin line 2593
  setline(2593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9762 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call9763 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9762);
// compiled call node returning call9763 (depth = 5)
  *var_newChain = call9763;
  if (call9763 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2594
  setline(2594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9764 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9765 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9766 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9765);
// compiled member node returning call9766 (depth = 5)
  gc_frame_newslot(call9766);
// starting to compile block node (depth = 5)
  Object block9767 = alloc_Block(NULL, NULL, "ast", 2594);
  gc_frame_newslot(block9767);
// method "_apply(_)"
  block_savedest(block9767);
  Object closure9768 = createclosure(3, "_apply(1)");
  setclosureframe(closure9768, stackframe);
  addtoclosure(closure9768, var_visitor);
  addtoclosure(closure9768, var_newChain);
  addtoclosure(closure9768, selfslot);
  struct UserObject *uo9768 = (struct UserObject*)block9767;
  uo9768->data[0] = (Object)closure9768;
  Method *meth_meth_ast_9768__apply_40_1_41_ = addmethod2pos(block9767, "_apply(1)", &meth_ast_9768__apply_40_1_41_, 0);
  int argcv_meth_ast_9768__apply_40_1_41_[] = {1};
  meth_meth_ast_9768__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9768__apply_40_1_41_);
  meth_meth_ast_9768__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9768__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block9767 (depth = 5)
  gc_frame_newslot(block9767);
// call case 5: prelude request
  params[0] = call9766;
  params[1] = block9767;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9772 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9764);
// compiled call node returning call9772 (depth = 4)
// Begin line 2597
  setline(2597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9773 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9774 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9775 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9774);
// compiled member node returning call9775 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9776 = callmethodflags(call9775, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9773);
// compiled call node returning call9776 (depth = 4)
// Begin line 2598
  setline(2598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9779 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9780 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9779);
// compiled member node returning call9780 (depth = 6)
  int op_slot_right_9778 = gc_frame_newslot(call9780);
// starting to compile identifier node (depth = 6)
  Object bool9782 = alloc_Boolean(0);
// compiled identifier node returning bool9782 (depth = 6)
  int op_slot_left_9778 = gc_frame_newslot(bool9782);
  params[0] = call9780;
  partcv[0] = 1;
  Object opresult9783 = callmethod(bool9782, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9783 (depth = 5)
  Object if9777 = done;
  if (istrue(opresult9783)) {
// Begin line 2599
  setline(2599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9784 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9785 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9786 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9785);
// compiled member node returning call9786 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9787 = callmethodflags(call9786, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9784);
// compiled call node returning call9787 (depth = 5)
    gc_frame_newslot(call9787);
    if9777 = call9787;
  } else {
  }
// compiled if node returning if9777 (depth = 4)
    gc_frame_newslot(if9777);
    if9759 = if9777;
  } else {
  }
// compiled if node returning if9759 (depth = 3)
  gc_frame_end(frame);
  return if9759;
}
Object meth_ast_9788_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2604
  setline(2604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9789 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9790 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9789);
// compiled member node returning call9790 (depth = 4)
  *var_n = call9790;
  if (call9790 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2605
  setline(2605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9791 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9792 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9791);
// compiled call node returning call9792 (depth = 4)
  *var_newChain = call9792;
  if (call9792 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2606
  setline(2606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9793 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9794 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9795 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9796 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9795);
// compiled member node returning call9796 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9797 = callmethodflags(call9796, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9794);
// compiled call node returning call9797 (depth = 4)
  gc_frame_newslot(call9797);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call9797;
  partcv[0] = 1;
  Object call9798 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9793);
// compiled call node returning call9798 (depth = 3)
// Begin line 2607
  setline(2607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9799 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9800 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9801 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9802 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9801);
// compiled member node returning call9802 (depth = 5)
  gc_frame_newslot(call9802);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call9802;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9803 = callmethodflags(module_ast, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9800);
// compiled call node returning call9803 (depth = 4)
  gc_frame_newslot(call9803);
// call case 6: other requests
// Begin line 2607
  setline(2607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call9803;
  partcv[0] = 1;
  Object call9804 = callmethodflags(*var_n, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9799);
// compiled call node returning call9804 (depth = 3)
// Begin line 2608
  setline(2608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9805 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9806 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9807 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9808 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9807);
// compiled member node returning call9808 (depth = 5)
  gc_frame_newslot(call9808);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call9808;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9809 = callmethodflags(module_ast, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9806);
// compiled call node returning call9809 (depth = 4)
  gc_frame_newslot(call9809);
// call case 6: other requests
// Begin line 2608
  setline(2608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call9809;
  partcv[0] = 1;
  Object call9810 = callmethodflags(*var_n, "annotations:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9805);
// compiled call node returning call9810 (depth = 3)
// Begin line 2609
  setline(2609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9811 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9812 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9811);
// compiled call node returning call9812 (depth = 3)
  gc_frame_end(frame);
  return call9812;
}
Object meth_ast_9813_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// definebindings:
// definebindings:
// Begin line 2612
  setline(2612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9816 = alloc_Float64(1);
// compiled num node returning num9816 (depth = 6)
  int op_slot_right_9815 = gc_frame_newslot(num9816);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_9815 = gc_frame_newslot(*var_depth);
  params[0] = num9816;
  partcv[0] = 1;
  Object sum9818 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum9818 (depth = 5)
  int op_slot_right_9814 = gc_frame_newslot(sum9818);
// starting to compile string node (depth = 5)
  if (strlit9820 == NULL) {
    strlit9820 = alloc_String("  ");
    gc_root(strlit9820);
  }
// compiled string node returning strlit9820 (depth = 5)
  int op_slot_left_9814 = gc_frame_newslot(strlit9820);
  params[0] = sum9818;
  partcv[0] = 1;
  Object prod9821 = callmethod(strlit9820, "*(1)", 1, partcv, params);
// compiled op node returning prod9821 (depth = 4)
  *var_spc = prod9821;
  if (prod9821 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2613
  setline(2613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9823 == NULL) {
    strlit9823 = alloc_String("""\x0a""");
    gc_root(strlit9823);
  }
// compiled string node returning strlit9823 (depth = 5)
  int op_slot_right_9822 = gc_frame_newslot(strlit9823);
// starting to compile call node (depth = 5)
  int callframe9825 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9826 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9825);
// compiled call node returning call9826 (depth = 5)
  int op_slot_left_9822 = gc_frame_newslot(call9826);
  params[0] = strlit9823;
  partcv[0] = 1;
  Object opresult9827 = callmethod(call9826, "++(1)", 1, partcv, params);
// compiled op node returning opresult9827 (depth = 4)
  *var_s = opresult9827;
  if (opresult9827 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2614
  setline(2614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9830 == NULL) {
    strlit9830 = alloc_String("""\x0a""");
    gc_root(strlit9830);
  }
// compiled string node returning strlit9830 (depth = 6)
  int op_slot_right_9829 = gc_frame_newslot(strlit9830);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9833 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9834 = callmethodflags(self, "path", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9833);
// compiled member node returning call9834 (depth = 7)
  int op_slot_right_9832 = gc_frame_newslot(call9834);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9837 == NULL) {
    strlit9837 = alloc_String("Path: ");
    gc_root(strlit9837);
  }
// compiled string node returning strlit9837 (depth = 8)
  int op_slot_right_9836 = gc_frame_newslot(strlit9837);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_9839 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 9)
  if (strlit9841 == NULL) {
    strlit9841 = alloc_String("");
    gc_root(strlit9841);
  }
// compiled string node returning strlit9841 (depth = 9)
  int op_slot_left_9839 = gc_frame_newslot(strlit9841);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9842 = callmethod(strlit9841, "++(1)", 1, partcv, params);
// compiled op node returning opresult9842 (depth = 8)
  int op_slot_left_9836 = gc_frame_newslot(opresult9842);
  params[0] = strlit9837;
  partcv[0] = 1;
  Object opresult9843 = callmethod(opresult9842, "++(1)", 1, partcv, params);
// compiled op node returning opresult9843 (depth = 7)
  int op_slot_left_9832 = gc_frame_newslot(opresult9843);
  params[0] = call9834;
  partcv[0] = 1;
  Object opresult9844 = callmethod(opresult9843, "++(1)", 1, partcv, params);
// compiled op node returning opresult9844 (depth = 6)
  int op_slot_left_9829 = gc_frame_newslot(opresult9844);
  params[0] = strlit9830;
  partcv[0] = 1;
  Object opresult9845 = callmethod(opresult9844, "++(1)", 1, partcv, params);
// compiled op node returning opresult9845 (depth = 5)
  int op_slot_right_9828 = gc_frame_newslot(opresult9845);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_9828 = gc_frame_newslot(*var_s);
  params[0] = opresult9845;
  partcv[0] = 1;
  Object opresult9847 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9847 (depth = 4)
  *var_s = opresult9847;
  if (opresult9847 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2615
  setline(2615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9851 == NULL) {
    strlit9851 = alloc_String("""\x0a""");
    gc_root(strlit9851);
  }
// compiled string node returning strlit9851 (depth = 6)
  int op_slot_right_9850 = gc_frame_newslot(strlit9851);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9854 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9855 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9854);
// compiled member node returning call9855 (depth = 7)
  int op_slot_right_9853 = gc_frame_newslot(call9855);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9858 == NULL) {
    strlit9858 = alloc_String("Identifier: ");
    gc_root(strlit9858);
  }
// compiled string node returning strlit9858 (depth = 8)
  int op_slot_right_9857 = gc_frame_newslot(strlit9858);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_9860 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 9)
  if (strlit9862 == NULL) {
    strlit9862 = alloc_String("");
    gc_root(strlit9862);
  }
// compiled string node returning strlit9862 (depth = 9)
  int op_slot_left_9860 = gc_frame_newslot(strlit9862);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9863 = callmethod(strlit9862, "++(1)", 1, partcv, params);
// compiled op node returning opresult9863 (depth = 8)
  int op_slot_left_9857 = gc_frame_newslot(opresult9863);
  params[0] = strlit9858;
  partcv[0] = 1;
  Object opresult9864 = callmethod(opresult9863, "++(1)", 1, partcv, params);
// compiled op node returning opresult9864 (depth = 7)
  int op_slot_left_9853 = gc_frame_newslot(opresult9864);
  params[0] = call9855;
  partcv[0] = 1;
  Object opresult9865 = callmethod(opresult9864, "++(1)", 1, partcv, params);
// compiled op node returning opresult9865 (depth = 6)
  int op_slot_left_9850 = gc_frame_newslot(opresult9865);
  params[0] = strlit9851;
  partcv[0] = 1;
  Object opresult9866 = callmethod(opresult9865, "++(1)", 1, partcv, params);
// compiled op node returning opresult9866 (depth = 5)
  int op_slot_right_9849 = gc_frame_newslot(opresult9866);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_9849 = gc_frame_newslot(*var_s);
  params[0] = opresult9866;
  partcv[0] = 1;
  Object opresult9868 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9868 (depth = 4)
  *var_s = opresult9868;
  if (opresult9868 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2616
  setline(2616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num9872 = alloc_Float64(0);
// compiled num node returning num9872 (depth = 5)
  int op_slot_right_9871 = gc_frame_newslot(num9872);
// starting to compile member node (depth = 5)
  int callframe9874 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9875 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9876 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9875);
// compiled member node returning call9876 (depth = 6)
  partcv[0] = 0;
  Object call9877 = callmethodflags(call9876, "size", 1, partcv, params, 0);
  gc_frame_end(callframe9874);
// compiled member node returning call9877 (depth = 5)
  int op_slot_left_9871 = gc_frame_newslot(call9877);
  params[0] = num9872;
  partcv[0] = 1;
  Object opresult9878 = callmethod(call9877, ">(1)", 1, partcv, params);
// compiled op node returning opresult9878 (depth = 4)
  Object if9870 = done;
  if (istrue(opresult9878)) {
// Begin line 2617
  setline(2617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9881 == NULL) {
    strlit9881 = alloc_String("""\x0a""");
    gc_root(strlit9881);
  }
// compiled string node returning strlit9881 (depth = 7)
  int op_slot_right_9880 = gc_frame_newslot(strlit9881);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe9884 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9885 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9884);
// compiled member node returning call9885 (depth = 8)
  int op_slot_right_9883 = gc_frame_newslot(call9885);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9888 == NULL) {
    strlit9888 = alloc_String("Anotations: ");
    gc_root(strlit9888);
  }
// compiled string node returning strlit9888 (depth = 9)
  int op_slot_right_9887 = gc_frame_newslot(strlit9888);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_9890 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 10)
  if (strlit9892 == NULL) {
    strlit9892 = alloc_String("");
    gc_root(strlit9892);
  }
// compiled string node returning strlit9892 (depth = 10)
  int op_slot_left_9890 = gc_frame_newslot(strlit9892);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9893 = callmethod(strlit9892, "++(1)", 1, partcv, params);
// compiled op node returning opresult9893 (depth = 9)
  int op_slot_left_9887 = gc_frame_newslot(opresult9893);
  params[0] = strlit9888;
  partcv[0] = 1;
  Object opresult9894 = callmethod(opresult9893, "++(1)", 1, partcv, params);
// compiled op node returning opresult9894 (depth = 8)
  int op_slot_left_9883 = gc_frame_newslot(opresult9894);
  params[0] = call9885;
  partcv[0] = 1;
  Object opresult9895 = callmethod(opresult9894, "++(1)", 1, partcv, params);
// compiled op node returning opresult9895 (depth = 7)
  int op_slot_left_9880 = gc_frame_newslot(opresult9895);
  params[0] = strlit9881;
  partcv[0] = 1;
  Object opresult9896 = callmethod(opresult9895, "++(1)", 1, partcv, params);
// compiled op node returning opresult9896 (depth = 6)
  int op_slot_right_9879 = gc_frame_newslot(opresult9896);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9879 = gc_frame_newslot(*var_s);
  params[0] = opresult9896;
  partcv[0] = 1;
  Object opresult9898 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9898 (depth = 5)
  *var_s = opresult9898;
  if (opresult9898 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9870 = done;
  } else {
  }
// compiled if node returning if9870 (depth = 3)
// Begin line 2619
  setline(2619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_9900_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2622
  setline(2622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9902 == NULL) {
    strlit9902 = alloc_String("");
    gc_root(strlit9902);
  }
// compiled string node returning strlit9902 (depth = 4)
  int op_slot_right_9901 = gc_frame_newslot(strlit9902);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9905 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9906 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9905);
// compiled member node returning call9906 (depth = 5)
  int op_slot_right_9904 = gc_frame_newslot(call9906);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9909 == NULL) {
    strlit9909 = alloc_String("""\x22"" as ");
    gc_root(strlit9909);
  }
// compiled string node returning strlit9909 (depth = 6)
  int op_slot_right_9908 = gc_frame_newslot(strlit9909);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9912 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9913 = callmethodflags(self, "path", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9912);
// compiled member node returning call9913 (depth = 7)
  int op_slot_right_9911 = gc_frame_newslot(call9913);
// starting to compile string node (depth = 7)
  if (strlit9915 == NULL) {
    strlit9915 = alloc_String("import ""\x22""");
    gc_root(strlit9915);
  }
// compiled string node returning strlit9915 (depth = 7)
  int op_slot_left_9911 = gc_frame_newslot(strlit9915);
  params[0] = call9913;
  partcv[0] = 1;
  Object opresult9916 = callmethod(strlit9915, "++(1)", 1, partcv, params);
// compiled op node returning opresult9916 (depth = 6)
  int op_slot_left_9908 = gc_frame_newslot(opresult9916);
  params[0] = strlit9909;
  partcv[0] = 1;
  Object opresult9917 = callmethod(opresult9916, "++(1)", 1, partcv, params);
// compiled op node returning opresult9917 (depth = 5)
  int op_slot_left_9904 = gc_frame_newslot(opresult9917);
  params[0] = call9906;
  partcv[0] = 1;
  Object opresult9918 = callmethod(opresult9917, "++(1)", 1, partcv, params);
// compiled op node returning opresult9918 (depth = 4)
  int op_slot_left_9901 = gc_frame_newslot(opresult9918);
  params[0] = strlit9902;
  partcv[0] = 1;
  Object opresult9919 = callmethod(opresult9918, "++(1)", 1, partcv, params);
// compiled op node returning opresult9919 (depth = 3)
  gc_frame_end(frame);
  return opresult9919;
}
Object meth_ast_9920_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_importNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2625
  setline(2625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9921 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe9922 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9923 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9924 = callmethodflags(self, "path", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9923);
// compiled member node returning call9924 (depth = 5)
  gc_frame_newslot(call9924);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
  Object bool9925 = alloc_Boolean(0);
// compiled identifier node returning bool9925 (depth = 5)
  gc_frame_newslot(bool9925);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_importNode (depth = 5)
  params[0] = call9924;
  params[1] = *var_nullNode;
  params[2] = bool9925;
  partcv[0] = 3;
  Object call9926 = callmethodflags(*var_importNode, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe9922);
// compiled call node returning call9926 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call9927 = callmethodflags(call9926, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9921);
// compiled call node returning call9927 (depth = 3)
  gc_frame_end(frame);
  return call9927;
}
Object meth_ast_9678_new_40_3_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_importNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  Object *var_name_39_ = &(stackframe->slots[1]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9679 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9679 = alloc_userobj2(26,23, objclass9679);
  gc_frame_newslot(obj9679);
  if (objclass9679 == NULL) {
    glfree(obj9679->class->name);
    obj9679->class->name = "importNode.new(_,_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj9679, self, 0);
  addmethodreal(obj9679,"outer", &reader_ast_outer_9680);
  Object oldself9679 = self;
  struct StackFrameObject *oldstackframe9679 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9679);
  gc_frame_newslot((Object)stackframe);
  self = obj9679;
  Object *oldselfslot9679 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9679 = (*(struct UserObject *)self).data[0], lowerouter9679 = thisouter9679;
  if (inheritingObject9679) {
    struct UserObject *inho9679 = (struct UserObject *)inheritingObject9679;
    while (inho9679->super != GraceDefaultObject) inho9679 = (struct UserObject *)inho9679->super;
    inho9679->super = obj9679;
    self = inheritingObject9679;
    *selfslot = self;
    lowerouter9679 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9679;
  }
  if (objclass9679 == NULL) {
  Method *reader9681 = addmethodrealflags(obj9679, "kind",&reader_ast_kind_9681, MFLAG_DEF);
  reader9681->definitionModule = modulename;
  reader9681->definitionLine = 2557;
  }
  adddatum2(obj9679, alloc_Undefined(), 1);
  if (objclass9679 == NULL) {
    Method *reader9682 = addmethodrealflags(obj9679, "value", &reader_ast_value_9682, 0);
    Method *writer9682 = addmethodrealflags(obj9679, "value:=(1)", &writer_ast_value_9682, 0);
    reader9682->definitionModule = modulename;
    writer9682->definitionModule = modulename;
    reader9682->definitionLine = 2558;
    writer9682->definitionLine = 2558;
  }
  obj9679->flags |= OFLAG_MUTABLE;
  adddatum2(obj9679, alloc_Undefined(), 2);
  if (objclass9679 == NULL) {
    Method *reader9683 = addmethodrealflags(obj9679, "path", &reader_ast_path_9683, 0);
    Method *writer9683 = addmethodrealflags(obj9679, "path:=(1)", &writer_ast_path_9683, 0);
    reader9683->definitionModule = modulename;
    writer9683->definitionModule = modulename;
    reader9683->definitionLine = 2559;
    writer9683->definitionLine = 2559;
  }
  obj9679->flags |= OFLAG_MUTABLE;
  adddatum2(obj9679, alloc_Undefined(), 3);
  if (objclass9679 == NULL) {
    Method *reader9684 = addmethodrealflags(obj9679, "annotations", &reader_ast_annotations_9684, 0);
    Method *writer9684 = addmethodrealflags(obj9679, "annotations:=(1)", &writer_ast_annotations_9684, 0);
    reader9684->definitionModule = modulename;
    writer9684->definitionModule = modulename;
    reader9684->definitionLine = 2560;
    writer9684->definitionLine = 2560;
  }
  obj9679->flags |= OFLAG_MUTABLE;
  adddatum2(obj9679, alloc_Undefined(), 4);
  if (objclass9679 == NULL) {
    Method *reader9685 = addmethodrealflags(obj9679, "dtype", &reader_ast_dtype_9685, 0);
    Method *writer9685 = addmethodrealflags(obj9679, "dtype:=(1)", &writer_ast_dtype_9685, 0);
    reader9685->definitionModule = modulename;
    writer9685->definitionModule = modulename;
    reader9685->definitionLine = 2561;
    writer9685->definitionLine = 2561;
  }
  obj9679->flags |= OFLAG_MUTABLE;
  adddatum2(obj9679, alloc_Undefined(), 5);
// method "end"
  struct UserObject *uo9686 = (struct UserObject*)obj9679;
  uo9686->data[6] = emptyclosure;
  Method *meth_meth_ast_9686_end = addmethod2pos(obj9679, "end", &meth_ast_9686_end, 6);
  int argcv_meth_ast_9686_end[] = {0};
  meth_meth_ast_9686_end->type = alloc_MethodType(1, argcv_meth_ast_9686_end);
  meth_meth_ast_9686_end->definitionModule = modulename;
  meth_meth_ast_9686_end->definitionLine = 2562;
// method "isImport"
  struct UserObject *uo9691 = (struct UserObject*)obj9679;
  uo9691->data[7] = emptyclosure;
  Method *meth_meth_ast_9691_isImport = addmethod2pos(obj9679, "isImport", &meth_ast_9691_isImport, 7);
  int argcv_meth_ast_9691_isImport[] = {0};
  meth_meth_ast_9691_isImport->type = alloc_MethodType(1, argcv_meth_ast_9691_isImport);
  meth_meth_ast_9691_isImport->definitionModule = modulename;
  meth_meth_ast_9691_isImport->definitionLine = 2563;
// method "isExternal"
  struct UserObject *uo9693 = (struct UserObject*)obj9679;
  uo9693->data[8] = emptyclosure;
  Method *meth_meth_ast_9693_isExternal = addmethod2pos(obj9679, "isExternal", &meth_ast_9693_isExternal, 8);
  int argcv_meth_ast_9693_isExternal[] = {0};
  meth_meth_ast_9693_isExternal->type = alloc_MethodType(1, argcv_meth_ast_9693_isExternal);
  meth_meth_ast_9693_isExternal->definitionModule = modulename;
  meth_meth_ast_9693_isExternal->definitionLine = 2564;
// method "isExecutable"
  struct UserObject *uo9695 = (struct UserObject*)obj9679;
  uo9695->data[9] = emptyclosure;
  Method *meth_meth_ast_9695_isExecutable = addmethod2pos(obj9679, "isExecutable", &meth_ast_9695_isExecutable, 9);
  int argcv_meth_ast_9695_isExecutable[] = {0};
  meth_meth_ast_9695_isExecutable->type = alloc_MethodType(1, argcv_meth_ast_9695_isExecutable);
  meth_meth_ast_9695_isExecutable->definitionModule = modulename;
  meth_meth_ast_9695_isExecutable->definitionLine = 2565;
// method "name"
  struct UserObject *uo9697 = (struct UserObject*)obj9679;
  uo9697->data[10] = emptyclosure;
  Method *meth_meth_ast_9697_name = addmethod2pos(obj9679, "name", &meth_ast_9697_name, 10);
  int argcv_meth_ast_9697_name[] = {0};
  meth_meth_ast_9697_name->type = alloc_MethodType(1, argcv_meth_ast_9697_name);
  meth_meth_ast_9697_name->definitionModule = modulename;
  meth_meth_ast_9697_name->definitionLine = 2566;
// method "nameString"
  struct UserObject *uo9700 = (struct UserObject*)obj9679;
  uo9700->data[11] = emptyclosure;
  Method *meth_meth_ast_9700_nameString = addmethod2pos(obj9679, "nameString", &meth_ast_9700_nameString, 11);
  int argcv_meth_ast_9700_nameString[] = {0};
  meth_meth_ast_9700_nameString->type = alloc_MethodType(1, argcv_meth_ast_9700_nameString);
  meth_meth_ast_9700_nameString->definitionModule = modulename;
  meth_meth_ast_9700_nameString->definitionLine = 2567;
// method "isPublic"
  struct UserObject *uo9705 = (struct UserObject*)obj9679;
  uo9705->data[12] = emptyclosure;
  Method *meth_meth_ast_9705_isPublic = addmethod2pos(obj9679, "isPublic", &meth_ast_9705_isPublic, 12);
  int argcv_meth_ast_9705_isPublic[] = {0};
  meth_meth_ast_9705_isPublic->type = alloc_MethodType(1, argcv_meth_ast_9705_isPublic);
  meth_meth_ast_9705_isPublic->definitionModule = modulename;
  meth_meth_ast_9705_isPublic->definitionLine = 2568;
// method "moduleName"
  struct UserObject *uo9724 = (struct UserObject*)obj9679;
  uo9724->data[13] = emptyclosure;
  Method *meth_meth_ast_9724_moduleName = addmethod2pos(obj9679, "moduleName", &meth_ast_9724_moduleName, 13);
  int argcv_meth_ast_9724_moduleName[] = {0};
  meth_meth_ast_9724_moduleName->type = alloc_MethodType(1, argcv_meth_ast_9724_moduleName);
  meth_meth_ast_9724_moduleName->definitionModule = modulename;
  meth_meth_ast_9724_moduleName->definitionLine = 2574;
// method "isWritable"
  struct UserObject *uo9744 = (struct UserObject*)obj9679;
  uo9744->data[14] = emptyclosure;
  Method *meth_meth_ast_9744_isWritable = addmethod2pos(obj9679, "isWritable", &meth_ast_9744_isWritable, 14);
  int argcv_meth_ast_9744_isWritable[] = {0};
  meth_meth_ast_9744_isWritable->type = alloc_MethodType(1, argcv_meth_ast_9744_isWritable);
  meth_meth_ast_9744_isWritable->definitionModule = modulename;
  meth_meth_ast_9744_isWritable->definitionLine = 2585;
// method "isReadable"
  struct UserObject *uo9746 = (struct UserObject*)obj9679;
  uo9746->data[15] = emptyclosure;
  Method *meth_meth_ast_9746_isReadable = addmethod2pos(obj9679, "isReadable", &meth_ast_9746_isReadable, 15);
  int argcv_meth_ast_9746_isReadable[] = {0};
  meth_meth_ast_9746_isReadable->type = alloc_MethodType(1, argcv_meth_ast_9746_isReadable);
  meth_meth_ast_9746_isReadable->definitionModule = modulename;
  meth_meth_ast_9746_isReadable->definitionLine = 2586;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj9679);
  Object closure9749 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure9749, stackframe);
  addtoclosure(closure9749, var_k);
  struct UserObject *uo9749 = (struct UserObject*)obj9679;
  uo9749->data[16] = (Object)closure9749;
  Method *meth_meth_ast_9749_declarationKindWithAncestors_40_1_41_ = addmethod2pos(obj9679, "declarationKindWithAncestors(1)", &meth_ast_9749_declarationKindWithAncestors_40_1_41_, 16);
  int argcv_meth_ast_9749_declarationKindWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_9749_declarationKindWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9749_declarationKindWithAncestors_40_1_41_);
  meth_meth_ast_9749_declarationKindWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9749_declarationKindWithAncestors_40_1_41_->definitionLine = 2587;
// method "usesAsType(_)"
  struct UserObject *uo9752 = (struct UserObject*)obj9679;
  uo9752->data[17] = emptyclosure;
  Method *meth_meth_ast_9752_usesAsType_40_1_41_ = addmethod2pos(obj9679, "usesAsType(1)", &meth_ast_9752_usesAsType_40_1_41_, 17);
  int argcv_meth_ast_9752_usesAsType_40_1_41_[] = {1};
  meth_meth_ast_9752_usesAsType_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9752_usesAsType_40_1_41_);
  meth_meth_ast_9752_usesAsType_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9752_usesAsType_40_1_41_->definitionLine = 2588;
// method "accept(_)from(_)"
  struct UserObject *uo9758 = (struct UserObject*)obj9679;
  uo9758->data[18] = emptyclosure;
  Method *meth_meth_ast_9758_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj9679, "accept(1)from(1)", &meth_ast_9758_accept_40_1_41_from_40_1_41_, 18);
  int argcv_meth_ast_9758_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_9758_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_9758_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_9758_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9758_accept_40_1_41_from_40_1_41_->definitionLine = 2591;
// method "map(_)ancestors(_)"
  struct UserObject *uo9788 = (struct UserObject*)obj9679;
  uo9788->data[19] = emptyclosure;
  Method *meth_meth_ast_9788_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj9679, "map(1)ancestors(1)", &meth_ast_9788_map_40_1_41_ancestors_40_1_41_, 19);
  int argcv_meth_ast_9788_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_9788_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_9788_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_9788_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9788_map_40_1_41_ancestors_40_1_41_->definitionLine = 2603;
// method "pretty(_)"
  struct UserObject *uo9813 = (struct UserObject*)obj9679;
  uo9813->data[20] = emptyclosure;
  Method *meth_meth_ast_9813_pretty_40_1_41_ = addmethod2pos(obj9679, "pretty(1)", &meth_ast_9813_pretty_40_1_41_, 20);
  int argcv_meth_ast_9813_pretty_40_1_41_[] = {1};
  meth_meth_ast_9813_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9813_pretty_40_1_41_);
  meth_meth_ast_9813_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9813_pretty_40_1_41_->definitionLine = 2611;
// method "toGrace(_)"
  struct UserObject *uo9900 = (struct UserObject*)obj9679;
  uo9900->data[21] = emptyclosure;
  Method *meth_meth_ast_9900_toGrace_40_1_41_ = addmethod2pos(obj9679, "toGrace(1)", &meth_ast_9900_toGrace_40_1_41_, 21);
  int argcv_meth_ast_9900_toGrace_40_1_41_[] = {1};
  meth_meth_ast_9900_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9900_toGrace_40_1_41_);
meth_meth_ast_9900_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_9900_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_9900_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9900_toGrace_40_1_41_->definitionLine = 2621;
// method "shallowCopy"
  block_savedest(obj9679);
  Object closure9920 = createclosure(2, "shallowCopy");
  setclosureframe(closure9920, stackframe);
  addtoclosure(closure9920, var_nullNode);
  addtoclosure(closure9920, var_importNode);
  struct UserObject *uo9920 = (struct UserObject*)obj9679;
  uo9920->data[22] = (Object)closure9920;
  Method *meth_meth_ast_9920_shallowCopy = addmethod2pos(obj9679, "shallowCopy", &meth_ast_9920_shallowCopy, 22);
  int argcv_meth_ast_9920_shallowCopy[] = {0};
  meth_meth_ast_9920_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_9920_shallowCopy);
  meth_meth_ast_9920_shallowCopy->definitionModule = modulename;
  meth_meth_ast_9920_shallowCopy->definitionLine = 2624;
  sourceObject = obj9679;
// Begin line 2556
  setline(2556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9928 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9929 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9928);
// compiled call node returning call9929 (depth = 3)
  struct UserObject *obj9679_uo = (struct UserObject *)obj9679;
  obj9679_uo->super = call9929;
  sourceObject = obj9679;
// Begin line 2557
  setline(2557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9930 == NULL) {
    strlit9930 = alloc_String("import");
    gc_root(strlit9930);
  }
// compiled string node returning strlit9930 (depth = 3)
  adddatum2(obj9679, strlit9930, 1);
  sourceObject = obj9679;
// Begin line 2558
  setline(2558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj9679, *var_name_39_, 2);
  sourceObject = obj9679;
// Begin line 2559
  setline(2559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_path_39_ (depth = 3)
  adddatum2(obj9679, *var_path_39_, 3);
  sourceObject = obj9679;
// Begin line 2560
  setline(2560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array9931 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9931 (depth = 3)
  adddatum2(obj9679, array9931, 4);
  sourceObject = obj9679;
// Begin line 2561
  setline(2561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj9679, *var_dtype_39_, 5);
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  objclass9679 = obj9679->class;
  objclass9679->definitionModule = modulename;
  objclass9679->definitionLine = 2555;
  (*(struct UserObject *)self).data[0] = lowerouter9679;
  self = oldself9679;
  selfslot = oldselfslot9679;
  stackframe = oldstackframe9679;
  gc_frame_end(frame);
  return obj9679;
}
Object meth_ast_9678_new_40_3_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_importNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  Object *var_name_39_ = &(stackframe->slots[1]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9679 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9679 = alloc_userobj2(26,23, objclass9679);
  gc_frame_newslot(obj9679);
  if (objclass9679 == NULL) {
    glfree(obj9679->class->name);
    obj9679->class->name = "importNode.new(_,_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj9679, self, 0);
  addmethodreal(obj9679,"outer", &reader_ast_outer_9680);
  Object oldself9679 = self;
  struct StackFrameObject *oldstackframe9679 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9679);
  gc_frame_newslot((Object)stackframe);
  self = obj9679;
  Object *oldselfslot9679 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9679 = (*(struct UserObject *)self).data[0], lowerouter9679 = thisouter9679;
  if (inheritingObject9679) {
    struct UserObject *inho9679 = (struct UserObject *)inheritingObject9679;
    while (inho9679->super != GraceDefaultObject) inho9679 = (struct UserObject *)inho9679->super;
    inho9679->super = obj9679;
    self = inheritingObject9679;
    *selfslot = self;
    lowerouter9679 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9679;
  }
  if (objclass9679 == NULL) {
  Method *reader9681 = addmethodrealflags(obj9679, "kind",&reader_ast_kind_9681, MFLAG_DEF);
  reader9681->definitionModule = modulename;
  reader9681->definitionLine = 2557;
  }
  adddatum2(obj9679, alloc_Undefined(), 1);
  if (objclass9679 == NULL) {
    Method *reader9682 = addmethodrealflags(obj9679, "value", &reader_ast_value_9682, 0);
    Method *writer9682 = addmethodrealflags(obj9679, "value:=(1)", &writer_ast_value_9682, 0);
    reader9682->definitionModule = modulename;
    writer9682->definitionModule = modulename;
    reader9682->definitionLine = 2558;
    writer9682->definitionLine = 2558;
  }
  obj9679->flags |= OFLAG_MUTABLE;
  adddatum2(obj9679, alloc_Undefined(), 2);
  if (objclass9679 == NULL) {
    Method *reader9683 = addmethodrealflags(obj9679, "path", &reader_ast_path_9683, 0);
    Method *writer9683 = addmethodrealflags(obj9679, "path:=(1)", &writer_ast_path_9683, 0);
    reader9683->definitionModule = modulename;
    writer9683->definitionModule = modulename;
    reader9683->definitionLine = 2559;
    writer9683->definitionLine = 2559;
  }
  obj9679->flags |= OFLAG_MUTABLE;
  adddatum2(obj9679, alloc_Undefined(), 3);
  if (objclass9679 == NULL) {
    Method *reader9684 = addmethodrealflags(obj9679, "annotations", &reader_ast_annotations_9684, 0);
    Method *writer9684 = addmethodrealflags(obj9679, "annotations:=(1)", &writer_ast_annotations_9684, 0);
    reader9684->definitionModule = modulename;
    writer9684->definitionModule = modulename;
    reader9684->definitionLine = 2560;
    writer9684->definitionLine = 2560;
  }
  obj9679->flags |= OFLAG_MUTABLE;
  adddatum2(obj9679, alloc_Undefined(), 4);
  if (objclass9679 == NULL) {
    Method *reader9685 = addmethodrealflags(obj9679, "dtype", &reader_ast_dtype_9685, 0);
    Method *writer9685 = addmethodrealflags(obj9679, "dtype:=(1)", &writer_ast_dtype_9685, 0);
    reader9685->definitionModule = modulename;
    writer9685->definitionModule = modulename;
    reader9685->definitionLine = 2561;
    writer9685->definitionLine = 2561;
  }
  obj9679->flags |= OFLAG_MUTABLE;
  adddatum2(obj9679, alloc_Undefined(), 5);
// method "end"
  struct UserObject *uo9686 = (struct UserObject*)obj9679;
  uo9686->data[6] = emptyclosure;
  Method *meth_meth_ast_9686_end = addmethod2pos(obj9679, "end", &meth_ast_9686_end, 6);
  int argcv_meth_ast_9686_end[] = {0};
  meth_meth_ast_9686_end->type = alloc_MethodType(1, argcv_meth_ast_9686_end);
  meth_meth_ast_9686_end->definitionModule = modulename;
  meth_meth_ast_9686_end->definitionLine = 2562;
// method "isImport"
  struct UserObject *uo9691 = (struct UserObject*)obj9679;
  uo9691->data[7] = emptyclosure;
  Method *meth_meth_ast_9691_isImport = addmethod2pos(obj9679, "isImport", &meth_ast_9691_isImport, 7);
  int argcv_meth_ast_9691_isImport[] = {0};
  meth_meth_ast_9691_isImport->type = alloc_MethodType(1, argcv_meth_ast_9691_isImport);
  meth_meth_ast_9691_isImport->definitionModule = modulename;
  meth_meth_ast_9691_isImport->definitionLine = 2563;
// method "isExternal"
  struct UserObject *uo9693 = (struct UserObject*)obj9679;
  uo9693->data[8] = emptyclosure;
  Method *meth_meth_ast_9693_isExternal = addmethod2pos(obj9679, "isExternal", &meth_ast_9693_isExternal, 8);
  int argcv_meth_ast_9693_isExternal[] = {0};
  meth_meth_ast_9693_isExternal->type = alloc_MethodType(1, argcv_meth_ast_9693_isExternal);
  meth_meth_ast_9693_isExternal->definitionModule = modulename;
  meth_meth_ast_9693_isExternal->definitionLine = 2564;
// method "isExecutable"
  struct UserObject *uo9695 = (struct UserObject*)obj9679;
  uo9695->data[9] = emptyclosure;
  Method *meth_meth_ast_9695_isExecutable = addmethod2pos(obj9679, "isExecutable", &meth_ast_9695_isExecutable, 9);
  int argcv_meth_ast_9695_isExecutable[] = {0};
  meth_meth_ast_9695_isExecutable->type = alloc_MethodType(1, argcv_meth_ast_9695_isExecutable);
  meth_meth_ast_9695_isExecutable->definitionModule = modulename;
  meth_meth_ast_9695_isExecutable->definitionLine = 2565;
// method "name"
  struct UserObject *uo9697 = (struct UserObject*)obj9679;
  uo9697->data[10] = emptyclosure;
  Method *meth_meth_ast_9697_name = addmethod2pos(obj9679, "name", &meth_ast_9697_name, 10);
  int argcv_meth_ast_9697_name[] = {0};
  meth_meth_ast_9697_name->type = alloc_MethodType(1, argcv_meth_ast_9697_name);
  meth_meth_ast_9697_name->definitionModule = modulename;
  meth_meth_ast_9697_name->definitionLine = 2566;
// method "nameString"
  struct UserObject *uo9700 = (struct UserObject*)obj9679;
  uo9700->data[11] = emptyclosure;
  Method *meth_meth_ast_9700_nameString = addmethod2pos(obj9679, "nameString", &meth_ast_9700_nameString, 11);
  int argcv_meth_ast_9700_nameString[] = {0};
  meth_meth_ast_9700_nameString->type = alloc_MethodType(1, argcv_meth_ast_9700_nameString);
  meth_meth_ast_9700_nameString->definitionModule = modulename;
  meth_meth_ast_9700_nameString->definitionLine = 2567;
// method "isPublic"
  struct UserObject *uo9705 = (struct UserObject*)obj9679;
  uo9705->data[12] = emptyclosure;
  Method *meth_meth_ast_9705_isPublic = addmethod2pos(obj9679, "isPublic", &meth_ast_9705_isPublic, 12);
  int argcv_meth_ast_9705_isPublic[] = {0};
  meth_meth_ast_9705_isPublic->type = alloc_MethodType(1, argcv_meth_ast_9705_isPublic);
  meth_meth_ast_9705_isPublic->definitionModule = modulename;
  meth_meth_ast_9705_isPublic->definitionLine = 2568;
// method "moduleName"
  struct UserObject *uo9724 = (struct UserObject*)obj9679;
  uo9724->data[13] = emptyclosure;
  Method *meth_meth_ast_9724_moduleName = addmethod2pos(obj9679, "moduleName", &meth_ast_9724_moduleName, 13);
  int argcv_meth_ast_9724_moduleName[] = {0};
  meth_meth_ast_9724_moduleName->type = alloc_MethodType(1, argcv_meth_ast_9724_moduleName);
  meth_meth_ast_9724_moduleName->definitionModule = modulename;
  meth_meth_ast_9724_moduleName->definitionLine = 2574;
// method "isWritable"
  struct UserObject *uo9744 = (struct UserObject*)obj9679;
  uo9744->data[14] = emptyclosure;
  Method *meth_meth_ast_9744_isWritable = addmethod2pos(obj9679, "isWritable", &meth_ast_9744_isWritable, 14);
  int argcv_meth_ast_9744_isWritable[] = {0};
  meth_meth_ast_9744_isWritable->type = alloc_MethodType(1, argcv_meth_ast_9744_isWritable);
  meth_meth_ast_9744_isWritable->definitionModule = modulename;
  meth_meth_ast_9744_isWritable->definitionLine = 2585;
// method "isReadable"
  struct UserObject *uo9746 = (struct UserObject*)obj9679;
  uo9746->data[15] = emptyclosure;
  Method *meth_meth_ast_9746_isReadable = addmethod2pos(obj9679, "isReadable", &meth_ast_9746_isReadable, 15);
  int argcv_meth_ast_9746_isReadable[] = {0};
  meth_meth_ast_9746_isReadable->type = alloc_MethodType(1, argcv_meth_ast_9746_isReadable);
  meth_meth_ast_9746_isReadable->definitionModule = modulename;
  meth_meth_ast_9746_isReadable->definitionLine = 2586;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj9679);
  Object closure9749 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure9749, stackframe);
  addtoclosure(closure9749, var_k);
  struct UserObject *uo9749 = (struct UserObject*)obj9679;
  uo9749->data[16] = (Object)closure9749;
  Method *meth_meth_ast_9749_declarationKindWithAncestors_40_1_41_ = addmethod2pos(obj9679, "declarationKindWithAncestors(1)", &meth_ast_9749_declarationKindWithAncestors_40_1_41_, 16);
  int argcv_meth_ast_9749_declarationKindWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_9749_declarationKindWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9749_declarationKindWithAncestors_40_1_41_);
  meth_meth_ast_9749_declarationKindWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9749_declarationKindWithAncestors_40_1_41_->definitionLine = 2587;
// method "usesAsType(_)"
  struct UserObject *uo9752 = (struct UserObject*)obj9679;
  uo9752->data[17] = emptyclosure;
  Method *meth_meth_ast_9752_usesAsType_40_1_41_ = addmethod2pos(obj9679, "usesAsType(1)", &meth_ast_9752_usesAsType_40_1_41_, 17);
  int argcv_meth_ast_9752_usesAsType_40_1_41_[] = {1};
  meth_meth_ast_9752_usesAsType_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9752_usesAsType_40_1_41_);
  meth_meth_ast_9752_usesAsType_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9752_usesAsType_40_1_41_->definitionLine = 2588;
// method "accept(_)from(_)"
  struct UserObject *uo9758 = (struct UserObject*)obj9679;
  uo9758->data[18] = emptyclosure;
  Method *meth_meth_ast_9758_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj9679, "accept(1)from(1)", &meth_ast_9758_accept_40_1_41_from_40_1_41_, 18);
  int argcv_meth_ast_9758_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_9758_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_9758_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_9758_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9758_accept_40_1_41_from_40_1_41_->definitionLine = 2591;
// method "map(_)ancestors(_)"
  struct UserObject *uo9788 = (struct UserObject*)obj9679;
  uo9788->data[19] = emptyclosure;
  Method *meth_meth_ast_9788_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj9679, "map(1)ancestors(1)", &meth_ast_9788_map_40_1_41_ancestors_40_1_41_, 19);
  int argcv_meth_ast_9788_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_9788_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_9788_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_9788_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9788_map_40_1_41_ancestors_40_1_41_->definitionLine = 2603;
// method "pretty(_)"
  struct UserObject *uo9813 = (struct UserObject*)obj9679;
  uo9813->data[20] = emptyclosure;
  Method *meth_meth_ast_9813_pretty_40_1_41_ = addmethod2pos(obj9679, "pretty(1)", &meth_ast_9813_pretty_40_1_41_, 20);
  int argcv_meth_ast_9813_pretty_40_1_41_[] = {1};
  meth_meth_ast_9813_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9813_pretty_40_1_41_);
  meth_meth_ast_9813_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9813_pretty_40_1_41_->definitionLine = 2611;
// method "toGrace(_)"
  struct UserObject *uo9900 = (struct UserObject*)obj9679;
  uo9900->data[21] = emptyclosure;
  Method *meth_meth_ast_9900_toGrace_40_1_41_ = addmethod2pos(obj9679, "toGrace(1)", &meth_ast_9900_toGrace_40_1_41_, 21);
  int argcv_meth_ast_9900_toGrace_40_1_41_[] = {1};
  meth_meth_ast_9900_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9900_toGrace_40_1_41_);
meth_meth_ast_9900_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_9900_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_9900_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9900_toGrace_40_1_41_->definitionLine = 2621;
// method "shallowCopy"
  block_savedest(obj9679);
  Object closure9920 = createclosure(2, "shallowCopy");
  setclosureframe(closure9920, stackframe);
  addtoclosure(closure9920, var_nullNode);
  addtoclosure(closure9920, var_importNode);
  struct UserObject *uo9920 = (struct UserObject*)obj9679;
  uo9920->data[22] = (Object)closure9920;
  Method *meth_meth_ast_9920_shallowCopy = addmethod2pos(obj9679, "shallowCopy", &meth_ast_9920_shallowCopy, 22);
  int argcv_meth_ast_9920_shallowCopy[] = {0};
  meth_meth_ast_9920_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_9920_shallowCopy);
  meth_meth_ast_9920_shallowCopy->definitionModule = modulename;
  meth_meth_ast_9920_shallowCopy->definitionLine = 2624;
  sourceObject = obj9679;
// Begin line 2556
  setline(2556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9928 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9929 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9928);
// compiled call node returning call9929 (depth = 3)
  struct UserObject *obj9679_uo = (struct UserObject *)obj9679;
  obj9679_uo->super = call9929;
  sourceObject = obj9679;
// Begin line 2557
  setline(2557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9930 == NULL) {
    strlit9930 = alloc_String("import");
    gc_root(strlit9930);
  }
// compiled string node returning strlit9930 (depth = 3)
  adddatum2(obj9679, strlit9930, 1);
  sourceObject = obj9679;
// Begin line 2558
  setline(2558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj9679, *var_name_39_, 2);
  sourceObject = obj9679;
// Begin line 2559
  setline(2559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_path_39_ (depth = 3)
  adddatum2(obj9679, *var_path_39_, 3);
  sourceObject = obj9679;
// Begin line 2560
  setline(2560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array9931 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9931 (depth = 3)
  adddatum2(obj9679, array9931, 4);
  sourceObject = obj9679;
// Begin line 2561
  setline(2561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj9679, *var_dtype_39_, 5);
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  sourceObject = obj9679;
  objclass9679 = obj9679->class;
  objclass9679->definitionModule = modulename;
  objclass9679->definitionLine = 2555;
  (*(struct UserObject *)self).data[0] = lowerouter9679;
  self = oldself9679;
  selfslot = oldselfslot9679;
  stackframe = oldstackframe9679;
  gc_frame_end(frame);
  return obj9679;
}
Object meth_ast_9933_importNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 52, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "importNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_importNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2554
  setline(2554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_importNode (depth = 3)
  gc_frame_end(frame);
  return *var_importNode;
}
Object meth_ast_9936_fromToken_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "fromToken(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method fromToken(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for fromToken(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_stringTok = &(stackframe->slots[0]);
  *var_stringTok = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part fromToken(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_result = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "result");
// Begin line 2631
  setline(2631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9937 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9938 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_stringTok (depth = 6)
  partcv[0] = 0;
  Object call9939 = callmethodflags(*var_stringTok, "value", 1, partcv, params, 0);
  gc_frame_end(callframe9938);
// compiled member node returning call9939 (depth = 5)
  gc_frame_newslot(call9939);
// call case 4: self request
  params[0] = call9939;
  partcv[0] = 1;
  Object call9940 = callmethodflags(self, "new(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9937);
// compiled call node returning call9940 (depth = 4)
  *var_result = call9940;
  if (call9940 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2632
  setline(2632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9941 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9942 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9943 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_stringTok (depth = 6)
  partcv[0] = 0;
  Object call9944 = callmethodflags(*var_stringTok, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9943);
// compiled member node returning call9944 (depth = 5)
  gc_frame_newslot(call9944);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9946 = alloc_Float64(1);
// compiled num node returning num9946 (depth = 6)
  int op_slot_right_9945 = gc_frame_newslot(num9946);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9949 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_stringTok (depth = 8)
  partcv[0] = 0;
  Object call9950 = callmethodflags(*var_stringTok, "size", 1, partcv, params, 0);
  gc_frame_end(callframe9949);
// compiled member node returning call9950 (depth = 7)
  int op_slot_right_9948 = gc_frame_newslot(call9950);
// starting to compile member node (depth = 7)
  int callframe9952 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_stringTok (depth = 8)
  partcv[0] = 0;
  Object call9953 = callmethodflags(*var_stringTok, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe9952);
// compiled member node returning call9953 (depth = 7)
  int op_slot_left_9948 = gc_frame_newslot(call9953);
  params[0] = call9950;
  partcv[0] = 1;
  Object sum9954 = callmethod(call9953, "+(1)", 1, partcv, params);
// compiled op node returning sum9954 (depth = 6)
  int op_slot_left_9945 = gc_frame_newslot(sum9954);
  params[0] = num9946;
  partcv[0] = 1;
  Object diff9955 = callmethod(sum9954, "-(1)", 1, partcv, params);
// compiled op node returning diff9955 (depth = 5)
  gc_frame_newslot(diff9955);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call9944;
  params[1] = diff9955;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9956 = callmethodflags(module_ast, "line(1)column(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9942);
// compiled call node returning call9956 (depth = 4)
  gc_frame_newslot(call9956);
// call case 6: other requests
// Begin line 2632
  setline(2632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = call9956;
  partcv[0] = 1;
  Object call9957 = callmethodflags(*var_result, "end:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9941);
// compiled call node returning call9957 (depth = 3)
// Begin line 2633
  setline(2633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_9964_isDialect(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isDialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2641
  setline(2641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9965 = alloc_Boolean(1);
// compiled identifier node returning bool9965 (depth = 3)
  gc_frame_end(frame);
  return bool9965;
}
Object meth_ast_9966_isExternal(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExternal");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2642
  setline(2642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9967 = alloc_Boolean(1);
// compiled identifier node returning bool9967 (depth = 3)
  gc_frame_end(frame);
  return bool9967;
}
Object meth_ast_9968_isExecutable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2643
  setline(2643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9969 = alloc_Boolean(0);
// compiled identifier node returning bool9969 (depth = 3)
  gc_frame_end(frame);
  return bool9969;
}
Object meth_ast_9976__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_bnm = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 2647
  setline(2647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9979 == NULL) {
    strlit9979 = alloc_String("/");
    gc_root(strlit9979);
  }
// compiled string node returning strlit9979 (depth = 7)
  int op_slot_right_9978 = gc_frame_newslot(strlit9979);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_left_9978 = gc_frame_newslot(*var_c);
  params[0] = strlit9979;
  partcv[0] = 1;
  Object opresult9981 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult9981 (depth = 6)
  Object if9977 = done;
  if (istrue(opresult9981)) {
// Begin line 2648
  setline(2648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9982 == NULL) {
    strlit9982 = alloc_String("");
    gc_root(strlit9982);
  }
// compiled string node returning strlit9982 (depth = 7)
  *var_bnm = strlit9982;
  if (strlit9982 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if9977 = done;
  } else {
// Begin line 2650
  setline(2650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_right_9984 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_bnm (depth = 8)
  int op_slot_left_9984 = gc_frame_newslot(*var_bnm);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult9986 = callmethod(*var_bnm, "++(1)", 1, partcv, params);
// compiled op node returning opresult9986 (depth = 7)
  *var_bnm = opresult9986;
  if (opresult9986 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if9977 = done;
  }
// compiled if node returning if9977 (depth = 5)
  gc_frame_end(frame);
  return if9977;
}
Object meth_ast_9970_moduleName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "moduleName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_bnm = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "bnm");
// Begin line 2645
  setline(2645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9971 == NULL) {
    strlit9971 = alloc_String("");
    gc_root(strlit9971);
  }
// compiled string node returning strlit9971 (depth = 4)
  *var_bnm = strlit9971;
  if (strlit9971 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2646
  setline(2646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9972 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe9973 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9974 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9973);
// compiled member node returning call9974 (depth = 4)
  gc_frame_newslot(call9974);
// starting to compile block node (depth = 4)
  Object block9975 = alloc_Block(NULL, NULL, "ast", 2646);
  gc_frame_newslot(block9975);
// method "_apply(_)"
  block_savedest(block9975);
  Object closure9976 = createclosure(2, "_apply(1)");
  setclosureframe(closure9976, stackframe);
  addtoclosure(closure9976, var_bnm);
  addtoclosure(closure9976, selfslot);
  struct UserObject *uo9976 = (struct UserObject*)block9975;
  uo9976->data[0] = (Object)closure9976;
  Method *meth_meth_ast_9976__apply_40_1_41_ = addmethod2pos(block9975, "_apply(1)", &meth_ast_9976__apply_40_1_41_, 0);
  int argcv_meth_ast_9976__apply_40_1_41_[] = {1};
  meth_meth_ast_9976__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9976__apply_40_1_41_);
  meth_meth_ast_9976__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9976__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block9975 (depth = 4)
  gc_frame_newslot(block9975);
// call case 5: prelude request
  params[0] = call9974;
  params[1] = block9975;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9989 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9972);
// compiled call node returning call9989 (depth = 3)
// Begin line 2653
  setline(2653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_bnm (depth = 3)
  gc_frame_end(frame);
  return *var_bnm;
}
Object meth_ast_9990_path(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "path");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2656
  setline(2656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9991 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9992 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9991);
// compiled member node returning call9992 (depth = 3)
  gc_frame_end(frame);
  return call9992;
}
Object meth_ast_9993_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2659
  setline(2659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9994 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9995 = callmethodflags(*var_visitor, "visitDialect(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9994);
// compiled call node returning call9995 (depth = 3)
  gc_frame_end(frame);
  return call9995;
}
Object meth_ast_9996_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2662
  setline(2662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9997 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9998 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9997);
// compiled member node returning call9998 (depth = 4)
  *var_n = call9998;
  if (call9998 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2663
  setline(2663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9999 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call10000 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9999);
// compiled call node returning call10000 (depth = 4)
  *var_newChain = call10000;
  if (call10000 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2664
  setline(2664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10001 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call10002 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe10001);
// compiled call node returning call10002 (depth = 3)
  gc_frame_end(frame);
  return call10002;
}
Object meth_ast_10003_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2667
  setline(2667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num10006 = alloc_Float64(1);
// compiled num node returning num10006 (depth = 6)
  int op_slot_right_10005 = gc_frame_newslot(num10006);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_10005 = gc_frame_newslot(*var_depth);
  params[0] = num10006;
  partcv[0] = 1;
  Object sum10008 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum10008 (depth = 5)
  int op_slot_right_10004 = gc_frame_newslot(sum10008);
// starting to compile string node (depth = 5)
  if (strlit10010 == NULL) {
    strlit10010 = alloc_String("  ");
    gc_root(strlit10010);
  }
// compiled string node returning strlit10010 (depth = 5)
  int op_slot_left_10004 = gc_frame_newslot(strlit10010);
  params[0] = sum10008;
  partcv[0] = 1;
  Object prod10011 = callmethod(strlit10010, "*(1)", 1, partcv, params);
// compiled op node returning prod10011 (depth = 4)
  *var_spc = prod10011;
  if (prod10011 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2668
  setline(2668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10013 == NULL) {
    strlit10013 = alloc_String("""\x0a""");
    gc_root(strlit10013);
  }
// compiled string node returning strlit10013 (depth = 5)
  int op_slot_right_10012 = gc_frame_newslot(strlit10013);
// starting to compile call node (depth = 5)
  int callframe10015 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call10016 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10015);
// compiled call node returning call10016 (depth = 5)
  int op_slot_left_10012 = gc_frame_newslot(call10016);
  params[0] = strlit10013;
  partcv[0] = 1;
  Object opresult10017 = callmethod(call10016, "++(1)", 1, partcv, params);
// compiled op node returning opresult10017 (depth = 4)
  *var_s = opresult10017;
  if (opresult10017 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2669
  setline(2669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10020 == NULL) {
    strlit10020 = alloc_String("""\x0a""");
    gc_root(strlit10020);
  }
// compiled string node returning strlit10020 (depth = 6)
  int op_slot_right_10019 = gc_frame_newslot(strlit10020);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe10023 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10024 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10023);
// compiled member node returning call10024 (depth = 7)
  int op_slot_right_10022 = gc_frame_newslot(call10024);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10027 == NULL) {
    strlit10027 = alloc_String("Path: ");
    gc_root(strlit10027);
  }
// compiled string node returning strlit10027 (depth = 8)
  int op_slot_right_10026 = gc_frame_newslot(strlit10027);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_10029 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 9)
  if (strlit10031 == NULL) {
    strlit10031 = alloc_String("");
    gc_root(strlit10031);
  }
// compiled string node returning strlit10031 (depth = 9)
  int op_slot_left_10029 = gc_frame_newslot(strlit10031);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult10032 = callmethod(strlit10031, "++(1)", 1, partcv, params);
// compiled op node returning opresult10032 (depth = 8)
  int op_slot_left_10026 = gc_frame_newslot(opresult10032);
  params[0] = strlit10027;
  partcv[0] = 1;
  Object opresult10033 = callmethod(opresult10032, "++(1)", 1, partcv, params);
// compiled op node returning opresult10033 (depth = 7)
  int op_slot_left_10022 = gc_frame_newslot(opresult10033);
  params[0] = call10024;
  partcv[0] = 1;
  Object opresult10034 = callmethod(opresult10033, "++(1)", 1, partcv, params);
// compiled op node returning opresult10034 (depth = 6)
  int op_slot_left_10019 = gc_frame_newslot(opresult10034);
  params[0] = strlit10020;
  partcv[0] = 1;
  Object opresult10035 = callmethod(opresult10034, "++(1)", 1, partcv, params);
// compiled op node returning opresult10035 (depth = 5)
  int op_slot_right_10018 = gc_frame_newslot(opresult10035);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_10018 = gc_frame_newslot(*var_s);
  params[0] = opresult10035;
  partcv[0] = 1;
  Object opresult10037 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10037 (depth = 4)
  *var_s = opresult10037;
  if (opresult10037 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2670
  setline(2670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_10039_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2673
  setline(2673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10041 == NULL) {
    strlit10041 = alloc_String("""\x22""");
    gc_root(strlit10041);
  }
// compiled string node returning strlit10041 (depth = 4)
  int op_slot_right_10040 = gc_frame_newslot(strlit10041);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10044 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10045 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10044);
// compiled member node returning call10045 (depth = 5)
  int op_slot_right_10043 = gc_frame_newslot(call10045);
// starting to compile string node (depth = 5)
  if (strlit10047 == NULL) {
    strlit10047 = alloc_String("dialect ""\x22""");
    gc_root(strlit10047);
  }
// compiled string node returning strlit10047 (depth = 5)
  int op_slot_left_10043 = gc_frame_newslot(strlit10047);
  params[0] = call10045;
  partcv[0] = 1;
  Object opresult10048 = callmethod(strlit10047, "++(1)", 1, partcv, params);
// compiled op node returning opresult10048 (depth = 4)
  int op_slot_left_10040 = gc_frame_newslot(opresult10048);
  params[0] = strlit10041;
  partcv[0] = 1;
  Object opresult10049 = callmethod(opresult10048, "++(1)", 1, partcv, params);
// compiled op node returning opresult10049 (depth = 3)
  gc_frame_end(frame);
  return opresult10049;
}
Object meth_ast_10050_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_dialectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2676
  setline(2676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10051 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe10052 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe10053 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10054 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10053);
// compiled member node returning call10054 (depth = 5)
  gc_frame_newslot(call10054);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dialectNode (depth = 5)
  params[0] = call10054;
  partcv[0] = 1;
  Object call10055 = callmethodflags(*var_dialectNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10052);
// compiled call node returning call10055 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call10056 = callmethodflags(call10055, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10051);
// compiled call node returning call10056 (depth = 3)
  gc_frame_end(frame);
  return call10056;
}
Object meth_ast_10057_postCopy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "postCopy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method postCopy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for postCopy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part postCopy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2679
  setline(2679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10058 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10059 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call10060 = callmethodflags(*var_other, "end", 1, partcv, params, 0);
  gc_frame_end(callframe10059);
// compiled member node returning call10060 (depth = 4)
  gc_frame_newslot(call10060);
// call case 4: self request
  params[0] = call10060;
  partcv[0] = 1;
  Object call10061 = callmethodflags(self, "end:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10058);
// compiled call node returning call10061 (depth = 3)
// Begin line 2680
  setline(2680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_9958_new_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_dialectNode = getfromclosure(closure, 0);
  Object *var_noPosition = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_pathString = &(stackframe->slots[0]);
  *var_pathString = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9959 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9959 = alloc_userobj2(16,15, objclass9959);
  gc_frame_newslot(obj9959);
  if (objclass9959 == NULL) {
    glfree(obj9959->class->name);
    obj9959->class->name = "dialectNode.new(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj9959, self, 0);
  addmethodreal(obj9959,"outer", &reader_ast_outer_9960);
  Object oldself9959 = self;
  struct StackFrameObject *oldstackframe9959 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9959);
  gc_frame_newslot((Object)stackframe);
  self = obj9959;
  Object *oldselfslot9959 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9959 = (*(struct UserObject *)self).data[0], lowerouter9959 = thisouter9959;
  if (inheritingObject9959) {
    struct UserObject *inho9959 = (struct UserObject *)inheritingObject9959;
    while (inho9959->super != GraceDefaultObject) inho9959 = (struct UserObject *)inho9959->super;
    inho9959->super = obj9959;
    self = inheritingObject9959;
    *selfslot = self;
    lowerouter9959 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9959;
  }
  if (objclass9959 == NULL) {
  Method *reader9961 = addmethodrealflags(obj9959, "kind",&reader_ast_kind_9961, MFLAG_DEF);
  reader9961->definitionModule = modulename;
  reader9961->definitionLine = 2637;
  }
  adddatum2(obj9959, alloc_Undefined(), 1);
  if (objclass9959 == NULL) {
    Method *reader9962 = addmethodrealflags(obj9959, "value", &reader_ast_value_9962, 0);
    Method *writer9962 = addmethodrealflags(obj9959, "value:=(1)", &writer_ast_value_9962, 0);
    reader9962->definitionModule = modulename;
    writer9962->definitionModule = modulename;
    reader9962->definitionLine = 2638;
    writer9962->definitionLine = 2638;
  }
  obj9959->flags |= OFLAG_MUTABLE;
  adddatum2(obj9959, alloc_Undefined(), 2);
  if (objclass9959 == NULL) {
    Method *reader9963 = addmethodrealflags(obj9959, "end", &reader_ast_end_9963, 0);
    Method *writer9963 = addmethodrealflags(obj9959, "end:=(1)", &writer_ast_end_9963, 0);
    reader9963->definitionModule = modulename;
    writer9963->definitionModule = modulename;
    reader9963->definitionLine = 2639;
    writer9963->definitionLine = 2639;
  }
  obj9959->flags |= OFLAG_MUTABLE;
  adddatum2(obj9959, alloc_Undefined(), 3);
// method "isDialect"
  struct UserObject *uo9964 = (struct UserObject*)obj9959;
  uo9964->data[4] = emptyclosure;
  Method *meth_meth_ast_9964_isDialect = addmethod2pos(obj9959, "isDialect", &meth_ast_9964_isDialect, 4);
  int argcv_meth_ast_9964_isDialect[] = {0};
  meth_meth_ast_9964_isDialect->type = alloc_MethodType(1, argcv_meth_ast_9964_isDialect);
  meth_meth_ast_9964_isDialect->definitionModule = modulename;
  meth_meth_ast_9964_isDialect->definitionLine = 2641;
// method "isExternal"
  struct UserObject *uo9966 = (struct UserObject*)obj9959;
  uo9966->data[5] = emptyclosure;
  Method *meth_meth_ast_9966_isExternal = addmethod2pos(obj9959, "isExternal", &meth_ast_9966_isExternal, 5);
  int argcv_meth_ast_9966_isExternal[] = {0};
  meth_meth_ast_9966_isExternal->type = alloc_MethodType(1, argcv_meth_ast_9966_isExternal);
  meth_meth_ast_9966_isExternal->definitionModule = modulename;
  meth_meth_ast_9966_isExternal->definitionLine = 2642;
// method "isExecutable"
  struct UserObject *uo9968 = (struct UserObject*)obj9959;
  uo9968->data[6] = emptyclosure;
  Method *meth_meth_ast_9968_isExecutable = addmethod2pos(obj9959, "isExecutable", &meth_ast_9968_isExecutable, 6);
  int argcv_meth_ast_9968_isExecutable[] = {0};
  meth_meth_ast_9968_isExecutable->type = alloc_MethodType(1, argcv_meth_ast_9968_isExecutable);
  meth_meth_ast_9968_isExecutable->definitionModule = modulename;
  meth_meth_ast_9968_isExecutable->definitionLine = 2643;
// method "moduleName"
  struct UserObject *uo9970 = (struct UserObject*)obj9959;
  uo9970->data[7] = emptyclosure;
  Method *meth_meth_ast_9970_moduleName = addmethod2pos(obj9959, "moduleName", &meth_ast_9970_moduleName, 7);
  int argcv_meth_ast_9970_moduleName[] = {0};
  meth_meth_ast_9970_moduleName->type = alloc_MethodType(1, argcv_meth_ast_9970_moduleName);
  meth_meth_ast_9970_moduleName->definitionModule = modulename;
  meth_meth_ast_9970_moduleName->definitionLine = 2644;
// method "path"
  struct UserObject *uo9990 = (struct UserObject*)obj9959;
  uo9990->data[8] = emptyclosure;
  Method *meth_meth_ast_9990_path = addmethod2pos(obj9959, "path", &meth_ast_9990_path, 8);
  int argcv_meth_ast_9990_path[] = {0};
  meth_meth_ast_9990_path->type = alloc_MethodType(1, argcv_meth_ast_9990_path);
  meth_meth_ast_9990_path->definitionModule = modulename;
  meth_meth_ast_9990_path->definitionLine = 2655;
// method "accept(_)from(_)"
  struct UserObject *uo9993 = (struct UserObject*)obj9959;
  uo9993->data[9] = emptyclosure;
  Method *meth_meth_ast_9993_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj9959, "accept(1)from(1)", &meth_ast_9993_accept_40_1_41_from_40_1_41_, 9);
  int argcv_meth_ast_9993_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_9993_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_9993_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_9993_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9993_accept_40_1_41_from_40_1_41_->definitionLine = 2658;
// method "map(_)ancestors(_)"
  struct UserObject *uo9996 = (struct UserObject*)obj9959;
  uo9996->data[10] = emptyclosure;
  Method *meth_meth_ast_9996_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj9959, "map(1)ancestors(1)", &meth_ast_9996_map_40_1_41_ancestors_40_1_41_, 10);
  int argcv_meth_ast_9996_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_9996_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_9996_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_9996_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9996_map_40_1_41_ancestors_40_1_41_->definitionLine = 2661;
// method "pretty(_)"
  struct UserObject *uo10003 = (struct UserObject*)obj9959;
  uo10003->data[11] = emptyclosure;
  Method *meth_meth_ast_10003_pretty_40_1_41_ = addmethod2pos(obj9959, "pretty(1)", &meth_ast_10003_pretty_40_1_41_, 11);
  int argcv_meth_ast_10003_pretty_40_1_41_[] = {1};
  meth_meth_ast_10003_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10003_pretty_40_1_41_);
  meth_meth_ast_10003_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10003_pretty_40_1_41_->definitionLine = 2666;
// method "toGrace(_)"
  struct UserObject *uo10039 = (struct UserObject*)obj9959;
  uo10039->data[12] = emptyclosure;
  Method *meth_meth_ast_10039_toGrace_40_1_41_ = addmethod2pos(obj9959, "toGrace(1)", &meth_ast_10039_toGrace_40_1_41_, 12);
  int argcv_meth_ast_10039_toGrace_40_1_41_[] = {1};
  meth_meth_ast_10039_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10039_toGrace_40_1_41_);
meth_meth_ast_10039_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_10039_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_10039_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10039_toGrace_40_1_41_->definitionLine = 2672;
// method "shallowCopy"
  block_savedest(obj9959);
  Object closure10050 = createclosure(1, "shallowCopy");
  setclosureframe(closure10050, stackframe);
  addtoclosure(closure10050, var_dialectNode);
  struct UserObject *uo10050 = (struct UserObject*)obj9959;
  uo10050->data[13] = (Object)closure10050;
  Method *meth_meth_ast_10050_shallowCopy = addmethod2pos(obj9959, "shallowCopy", &meth_ast_10050_shallowCopy, 13);
  int argcv_meth_ast_10050_shallowCopy[] = {0};
  meth_meth_ast_10050_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_10050_shallowCopy);
  meth_meth_ast_10050_shallowCopy->definitionModule = modulename;
  meth_meth_ast_10050_shallowCopy->definitionLine = 2675;
// method "postCopy(_)"
  struct UserObject *uo10057 = (struct UserObject*)obj9959;
  uo10057->data[14] = emptyclosure;
  Method *meth_meth_ast_10057_postCopy_40_1_41_ = addmethod2pos(obj9959, "postCopy(1)", &meth_ast_10057_postCopy_40_1_41_, 14);
  int argcv_meth_ast_10057_postCopy_40_1_41_[] = {1};
  meth_meth_ast_10057_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10057_postCopy_40_1_41_);
  meth_meth_ast_10057_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10057_postCopy_40_1_41_->definitionLine = 2678;
  sourceObject = obj9959;
// Begin line 2636
  setline(2636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10062 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10063 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10062);
// compiled call node returning call10063 (depth = 3)
  struct UserObject *obj9959_uo = (struct UserObject *)obj9959;
  obj9959_uo->super = call10063;
  sourceObject = obj9959;
// Begin line 2637
  setline(2637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10064 == NULL) {
    strlit10064 = alloc_String("dialect");
    gc_root(strlit10064);
  }
// compiled string node returning strlit10064 (depth = 3)
  adddatum2(obj9959, strlit10064, 1);
  sourceObject = obj9959;
// Begin line 2638
  setline(2638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_pathString (depth = 3)
  adddatum2(obj9959, *var_pathString, 2);
  sourceObject = obj9959;
// Begin line 2639
  setline(2639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_noPosition (depth = 3)
  adddatum2(obj9959, *var_noPosition, 3);
  sourceObject = obj9959;
  sourceObject = obj9959;
  sourceObject = obj9959;
  sourceObject = obj9959;
  sourceObject = obj9959;
  sourceObject = obj9959;
  sourceObject = obj9959;
  sourceObject = obj9959;
  sourceObject = obj9959;
  sourceObject = obj9959;
  sourceObject = obj9959;
  objclass9959 = obj9959->class;
  objclass9959->definitionModule = modulename;
  objclass9959->definitionLine = 2635;
  (*(struct UserObject *)self).data[0] = lowerouter9959;
  self = oldself9959;
  selfslot = oldselfslot9959;
  stackframe = oldstackframe9959;
  gc_frame_end(frame);
  return obj9959;
}
Object meth_ast_9958_new_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_dialectNode = getfromclosure(closure, 0);
  Object *var_noPosition = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_pathString = &(stackframe->slots[0]);
  *var_pathString = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9959 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9959 = alloc_userobj2(16,15, objclass9959);
  gc_frame_newslot(obj9959);
  if (objclass9959 == NULL) {
    glfree(obj9959->class->name);
    obj9959->class->name = "dialectNode.new(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj9959, self, 0);
  addmethodreal(obj9959,"outer", &reader_ast_outer_9960);
  Object oldself9959 = self;
  struct StackFrameObject *oldstackframe9959 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9959);
  gc_frame_newslot((Object)stackframe);
  self = obj9959;
  Object *oldselfslot9959 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9959 = (*(struct UserObject *)self).data[0], lowerouter9959 = thisouter9959;
  if (inheritingObject9959) {
    struct UserObject *inho9959 = (struct UserObject *)inheritingObject9959;
    while (inho9959->super != GraceDefaultObject) inho9959 = (struct UserObject *)inho9959->super;
    inho9959->super = obj9959;
    self = inheritingObject9959;
    *selfslot = self;
    lowerouter9959 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9959;
  }
  if (objclass9959 == NULL) {
  Method *reader9961 = addmethodrealflags(obj9959, "kind",&reader_ast_kind_9961, MFLAG_DEF);
  reader9961->definitionModule = modulename;
  reader9961->definitionLine = 2637;
  }
  adddatum2(obj9959, alloc_Undefined(), 1);
  if (objclass9959 == NULL) {
    Method *reader9962 = addmethodrealflags(obj9959, "value", &reader_ast_value_9962, 0);
    Method *writer9962 = addmethodrealflags(obj9959, "value:=(1)", &writer_ast_value_9962, 0);
    reader9962->definitionModule = modulename;
    writer9962->definitionModule = modulename;
    reader9962->definitionLine = 2638;
    writer9962->definitionLine = 2638;
  }
  obj9959->flags |= OFLAG_MUTABLE;
  adddatum2(obj9959, alloc_Undefined(), 2);
  if (objclass9959 == NULL) {
    Method *reader9963 = addmethodrealflags(obj9959, "end", &reader_ast_end_9963, 0);
    Method *writer9963 = addmethodrealflags(obj9959, "end:=(1)", &writer_ast_end_9963, 0);
    reader9963->definitionModule = modulename;
    writer9963->definitionModule = modulename;
    reader9963->definitionLine = 2639;
    writer9963->definitionLine = 2639;
  }
  obj9959->flags |= OFLAG_MUTABLE;
  adddatum2(obj9959, alloc_Undefined(), 3);
// method "isDialect"
  struct UserObject *uo9964 = (struct UserObject*)obj9959;
  uo9964->data[4] = emptyclosure;
  Method *meth_meth_ast_9964_isDialect = addmethod2pos(obj9959, "isDialect", &meth_ast_9964_isDialect, 4);
  int argcv_meth_ast_9964_isDialect[] = {0};
  meth_meth_ast_9964_isDialect->type = alloc_MethodType(1, argcv_meth_ast_9964_isDialect);
  meth_meth_ast_9964_isDialect->definitionModule = modulename;
  meth_meth_ast_9964_isDialect->definitionLine = 2641;
// method "isExternal"
  struct UserObject *uo9966 = (struct UserObject*)obj9959;
  uo9966->data[5] = emptyclosure;
  Method *meth_meth_ast_9966_isExternal = addmethod2pos(obj9959, "isExternal", &meth_ast_9966_isExternal, 5);
  int argcv_meth_ast_9966_isExternal[] = {0};
  meth_meth_ast_9966_isExternal->type = alloc_MethodType(1, argcv_meth_ast_9966_isExternal);
  meth_meth_ast_9966_isExternal->definitionModule = modulename;
  meth_meth_ast_9966_isExternal->definitionLine = 2642;
// method "isExecutable"
  struct UserObject *uo9968 = (struct UserObject*)obj9959;
  uo9968->data[6] = emptyclosure;
  Method *meth_meth_ast_9968_isExecutable = addmethod2pos(obj9959, "isExecutable", &meth_ast_9968_isExecutable, 6);
  int argcv_meth_ast_9968_isExecutable[] = {0};
  meth_meth_ast_9968_isExecutable->type = alloc_MethodType(1, argcv_meth_ast_9968_isExecutable);
  meth_meth_ast_9968_isExecutable->definitionModule = modulename;
  meth_meth_ast_9968_isExecutable->definitionLine = 2643;
// method "moduleName"
  struct UserObject *uo9970 = (struct UserObject*)obj9959;
  uo9970->data[7] = emptyclosure;
  Method *meth_meth_ast_9970_moduleName = addmethod2pos(obj9959, "moduleName", &meth_ast_9970_moduleName, 7);
  int argcv_meth_ast_9970_moduleName[] = {0};
  meth_meth_ast_9970_moduleName->type = alloc_MethodType(1, argcv_meth_ast_9970_moduleName);
  meth_meth_ast_9970_moduleName->definitionModule = modulename;
  meth_meth_ast_9970_moduleName->definitionLine = 2644;
// method "path"
  struct UserObject *uo9990 = (struct UserObject*)obj9959;
  uo9990->data[8] = emptyclosure;
  Method *meth_meth_ast_9990_path = addmethod2pos(obj9959, "path", &meth_ast_9990_path, 8);
  int argcv_meth_ast_9990_path[] = {0};
  meth_meth_ast_9990_path->type = alloc_MethodType(1, argcv_meth_ast_9990_path);
  meth_meth_ast_9990_path->definitionModule = modulename;
  meth_meth_ast_9990_path->definitionLine = 2655;
// method "accept(_)from(_)"
  struct UserObject *uo9993 = (struct UserObject*)obj9959;
  uo9993->data[9] = emptyclosure;
  Method *meth_meth_ast_9993_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj9959, "accept(1)from(1)", &meth_ast_9993_accept_40_1_41_from_40_1_41_, 9);
  int argcv_meth_ast_9993_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_9993_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_9993_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_9993_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9993_accept_40_1_41_from_40_1_41_->definitionLine = 2658;
// method "map(_)ancestors(_)"
  struct UserObject *uo9996 = (struct UserObject*)obj9959;
  uo9996->data[10] = emptyclosure;
  Method *meth_meth_ast_9996_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj9959, "map(1)ancestors(1)", &meth_ast_9996_map_40_1_41_ancestors_40_1_41_, 10);
  int argcv_meth_ast_9996_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_9996_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_9996_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_9996_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9996_map_40_1_41_ancestors_40_1_41_->definitionLine = 2661;
// method "pretty(_)"
  struct UserObject *uo10003 = (struct UserObject*)obj9959;
  uo10003->data[11] = emptyclosure;
  Method *meth_meth_ast_10003_pretty_40_1_41_ = addmethod2pos(obj9959, "pretty(1)", &meth_ast_10003_pretty_40_1_41_, 11);
  int argcv_meth_ast_10003_pretty_40_1_41_[] = {1};
  meth_meth_ast_10003_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10003_pretty_40_1_41_);
  meth_meth_ast_10003_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10003_pretty_40_1_41_->definitionLine = 2666;
// method "toGrace(_)"
  struct UserObject *uo10039 = (struct UserObject*)obj9959;
  uo10039->data[12] = emptyclosure;
  Method *meth_meth_ast_10039_toGrace_40_1_41_ = addmethod2pos(obj9959, "toGrace(1)", &meth_ast_10039_toGrace_40_1_41_, 12);
  int argcv_meth_ast_10039_toGrace_40_1_41_[] = {1};
  meth_meth_ast_10039_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10039_toGrace_40_1_41_);
meth_meth_ast_10039_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_10039_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_10039_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10039_toGrace_40_1_41_->definitionLine = 2672;
// method "shallowCopy"
  block_savedest(obj9959);
  Object closure10050 = createclosure(1, "shallowCopy");
  setclosureframe(closure10050, stackframe);
  addtoclosure(closure10050, var_dialectNode);
  struct UserObject *uo10050 = (struct UserObject*)obj9959;
  uo10050->data[13] = (Object)closure10050;
  Method *meth_meth_ast_10050_shallowCopy = addmethod2pos(obj9959, "shallowCopy", &meth_ast_10050_shallowCopy, 13);
  int argcv_meth_ast_10050_shallowCopy[] = {0};
  meth_meth_ast_10050_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_10050_shallowCopy);
  meth_meth_ast_10050_shallowCopy->definitionModule = modulename;
  meth_meth_ast_10050_shallowCopy->definitionLine = 2675;
// method "postCopy(_)"
  struct UserObject *uo10057 = (struct UserObject*)obj9959;
  uo10057->data[14] = emptyclosure;
  Method *meth_meth_ast_10057_postCopy_40_1_41_ = addmethod2pos(obj9959, "postCopy(1)", &meth_ast_10057_postCopy_40_1_41_, 14);
  int argcv_meth_ast_10057_postCopy_40_1_41_[] = {1};
  meth_meth_ast_10057_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10057_postCopy_40_1_41_);
  meth_meth_ast_10057_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10057_postCopy_40_1_41_->definitionLine = 2678;
  sourceObject = obj9959;
// Begin line 2636
  setline(2636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10062 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10063 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10062);
// compiled call node returning call10063 (depth = 3)
  struct UserObject *obj9959_uo = (struct UserObject *)obj9959;
  obj9959_uo->super = call10063;
  sourceObject = obj9959;
// Begin line 2637
  setline(2637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10064 == NULL) {
    strlit10064 = alloc_String("dialect");
    gc_root(strlit10064);
  }
// compiled string node returning strlit10064 (depth = 3)
  adddatum2(obj9959, strlit10064, 1);
  sourceObject = obj9959;
// Begin line 2638
  setline(2638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_pathString (depth = 3)
  adddatum2(obj9959, *var_pathString, 2);
  sourceObject = obj9959;
// Begin line 2639
  setline(2639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_noPosition (depth = 3)
  adddatum2(obj9959, *var_noPosition, 3);
  sourceObject = obj9959;
  sourceObject = obj9959;
  sourceObject = obj9959;
  sourceObject = obj9959;
  sourceObject = obj9959;
  sourceObject = obj9959;
  sourceObject = obj9959;
  sourceObject = obj9959;
  sourceObject = obj9959;
  sourceObject = obj9959;
  sourceObject = obj9959;
  objclass9959 = obj9959->class;
  objclass9959->definitionModule = modulename;
  objclass9959->definitionLine = 2635;
  (*(struct UserObject *)self).data[0] = lowerouter9959;
  self = oldself9959;
  selfslot = oldselfslot9959;
  stackframe = oldstackframe9959;
  gc_frame_end(frame);
  return obj9959;
}
Object meth_ast_10066_dialectNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 53, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dialectNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_dialectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2629
  setline(2629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dialectNode (depth = 3)
  gc_frame_end(frame);
  return *var_dialectNode;
}
Object meth_ast_10075_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_noPosition = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 2692
  setline(2692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10078 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10079 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10080 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10079);
// compiled member node returning call10080 (depth = 6)
  partcv[0] = 0;
  Object call10081 = callmethodflags(call10080, "end", 1, partcv, params, 0);
  gc_frame_end(callframe10078);
// compiled member node returning call10081 (depth = 5)
  int op_slot_right_10077 = gc_frame_newslot(call10081);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_noPosition (depth = 5)
  int op_slot_left_10077 = gc_frame_newslot(*var_noPosition);
  params[0] = call10081;
  partcv[0] = 1;
  Object opresult10083 = callmethod(*var_noPosition, "≠(1)", 1, partcv, params);
// compiled op node returning opresult10083 (depth = 4)
  Object if10076 = done;
  if (istrue(opresult10083)) {
// Begin line 2693
  setline(2693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe10084 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10085 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10086 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10085);
// compiled member node returning call10086 (depth = 5)
  partcv[0] = 0;
  Object call10087 = callmethodflags(call10086, "end", 1, partcv, params, 0);
  gc_frame_end(callframe10084);
// compiled member node returning call10087 (depth = 4)
    gc_frame_newslot(call10087);
    if10076 = call10087;
  } else {
// Begin line 2695
  setline(2695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10088 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe10089 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10090 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10089);
// compiled member node returning call10090 (depth = 5)
  gc_frame_newslot(call10090);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num10092 = alloc_Float64(5);
// compiled num node returning num10092 (depth = 6)
  int op_slot_right_10091 = gc_frame_newslot(num10092);
// starting to compile member node (depth = 6)
  int callframe10094 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10095 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10094);
// compiled member node returning call10095 (depth = 6)
  int op_slot_left_10091 = gc_frame_newslot(call10095);
  params[0] = num10092;
  partcv[0] = 1;
  Object sum10096 = callmethod(call10095, "+(1)", 1, partcv, params);
// compiled op node returning sum10096 (depth = 5)
  gc_frame_newslot(sum10096);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call10090;
  params[1] = sum10096;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10097 = callmethodflags(module_ast, "line(1)column(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10088);
// compiled call node returning call10097 (depth = 4)
    gc_frame_newslot(call10097);
    if10076 = call10097;
  }
// compiled if node returning if10076 (depth = 3)
  gc_frame_end(frame);
  return if10076;
}
Object meth_ast_10098_isReturn(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReturn");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2698
  setline(2698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10099 = alloc_Boolean(1);
// compiled identifier node returning bool10099 (depth = 3)
  gc_frame_end(frame);
  return bool10099;
}
Object meth_ast_10100_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// definebindings:
// Begin line 2700
  setline(2700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10102 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10103 = callmethodflags(*var_visitor, "visitReturn(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10102);
// compiled call node returning call10103 (depth = 4)
  Object if10101 = done;
  if (istrue(call10103)) {
// Begin line 2701
  setline(2701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10104 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call10105 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10104);
// compiled call node returning call10105 (depth = 5)
  *var_newChain = call10105;
  if (call10105 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2702
  setline(2702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10106 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10107 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10108 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10107);
// compiled member node returning call10108 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10109 = callmethodflags(call10108, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10106);
// compiled call node returning call10109 (depth = 4)
    gc_frame_newslot(call10109);
    if10101 = call10109;
  } else {
  }
// compiled if node returning if10101 (depth = 3)
  gc_frame_end(frame);
  return if10101;
}
Object meth_ast_10110_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2706
  setline(2706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10111 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10112 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10111);
// compiled member node returning call10112 (depth = 4)
  *var_n = call10112;
  if (call10112 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2707
  setline(2707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10113 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call10114 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10113);
// compiled call node returning call10114 (depth = 4)
  *var_newChain = call10114;
  if (call10114 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2708
  setline(2708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10115 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe10116 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10117 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10118 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10117);
// compiled member node returning call10118 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10119 = callmethodflags(call10118, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10116);
// compiled call node returning call10119 (depth = 4)
  gc_frame_newslot(call10119);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call10119;
  partcv[0] = 1;
  Object call10120 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10115);
// compiled call node returning call10120 (depth = 3)
// Begin line 2709
  setline(2709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10121 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe10122 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe10123 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10124 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10123);
// compiled member node returning call10124 (depth = 5)
  gc_frame_newslot(call10124);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call10124;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call10125 = callmethodflags(module_ast, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10122);
// compiled call node returning call10125 (depth = 4)
  gc_frame_newslot(call10125);
// call case 6: other requests
// Begin line 2709
  setline(2709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call10125;
  partcv[0] = 1;
  Object call10126 = callmethodflags(*var_n, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10121);
// compiled call node returning call10126 (depth = 3)
// Begin line 2710
  setline(2710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10127 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call10128 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe10127);
// compiled call node returning call10128 (depth = 3)
  gc_frame_end(frame);
  return call10128;
}
Object meth_ast_10129_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// definebindings:
// definebindings:
// Begin line 2713
  setline(2713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num10132 = alloc_Float64(1);
// compiled num node returning num10132 (depth = 6)
  int op_slot_right_10131 = gc_frame_newslot(num10132);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_10131 = gc_frame_newslot(*var_depth);
  params[0] = num10132;
  partcv[0] = 1;
  Object sum10134 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum10134 (depth = 5)
  int op_slot_right_10130 = gc_frame_newslot(sum10134);
// starting to compile string node (depth = 5)
  if (strlit10136 == NULL) {
    strlit10136 = alloc_String("  ");
    gc_root(strlit10136);
  }
// compiled string node returning strlit10136 (depth = 5)
  int op_slot_left_10130 = gc_frame_newslot(strlit10136);
  params[0] = sum10134;
  partcv[0] = 1;
  Object prod10137 = callmethod(strlit10136, "*(1)", 1, partcv, params);
// compiled op node returning prod10137 (depth = 4)
  *var_spc = prod10137;
  if (prod10137 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2714
  setline(2714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10139 == NULL) {
    strlit10139 = alloc_String("""\x0a""");
    gc_root(strlit10139);
  }
// compiled string node returning strlit10139 (depth = 5)
  int op_slot_right_10138 = gc_frame_newslot(strlit10139);
// starting to compile call node (depth = 5)
  int callframe10141 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call10142 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10141);
// compiled call node returning call10142 (depth = 5)
  int op_slot_left_10138 = gc_frame_newslot(call10142);
  params[0] = strlit10139;
  partcv[0] = 1;
  Object opresult10143 = callmethod(call10142, "++(1)", 1, partcv, params);
// compiled op node returning opresult10143 (depth = 4)
  *var_s = opresult10143;
  if (opresult10143 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2715
  setline(2715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10145 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num10147 = alloc_Float64(1);
// compiled num node returning num10147 (depth = 7)
  int op_slot_right_10146 = gc_frame_newslot(num10147);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_10146 = gc_frame_newslot(*var_depth);
  params[0] = num10147;
  partcv[0] = 1;
  Object sum10149 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum10149 (depth = 6)
  gc_frame_newslot(sum10149);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10150 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10151 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10150);
// compiled member node returning call10151 (depth = 6)
  params[0] = sum10149;
  partcv[0] = 1;
  Object call10152 = callmethodflags(call10151, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10145);
// compiled call node returning call10152 (depth = 5)
  int op_slot_right_10144 = gc_frame_newslot(call10152);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_10154 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_10154 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult10156 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10156 (depth = 5)
  int op_slot_left_10144 = gc_frame_newslot(opresult10156);
  params[0] = call10152;
  partcv[0] = 1;
  Object opresult10157 = callmethod(opresult10156, "++(1)", 1, partcv, params);
// compiled op node returning opresult10157 (depth = 4)
  *var_s = opresult10157;
  if (opresult10157 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2716
  setline(2716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10161 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10162 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10161);
// compiled member node returning call10162 (depth = 5)
  int op_slot_right_10160 = gc_frame_newslot(call10162);
// starting to compile identifier node (depth = 5)
  Object bool10164 = alloc_Boolean(0);
// compiled identifier node returning bool10164 (depth = 5)
  int op_slot_left_10160 = gc_frame_newslot(bool10164);
  params[0] = call10162;
  partcv[0] = 1;
  Object opresult10165 = callmethod(bool10164, "≠(1)", 1, partcv, params);
// compiled op node returning opresult10165 (depth = 4)
  Object if10159 = done;
  if (istrue(opresult10165)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10167 == NULL) {
    strlit10167 = alloc_String(")");
    gc_root(strlit10167);
  }
// compiled string node returning strlit10167 (depth = 6)
  int op_slot_right_10166 = gc_frame_newslot(strlit10167);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10170 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num10171 = alloc_Float64(0);
// compiled num node returning num10171 (depth = 8)
  gc_frame_newslot(num10171);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe10172 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10173 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10172);
// compiled member node returning call10173 (depth = 8)
  params[0] = num10171;
  partcv[0] = 1;
  Object call10174 = callmethodflags(call10173, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10170);
// compiled call node returning call10174 (depth = 7)
  int op_slot_right_10169 = gc_frame_newslot(call10174);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10177 == NULL) {
    strlit10177 = alloc_String(" (type ");
    gc_root(strlit10177);
  }
// compiled string node returning strlit10177 (depth = 8)
  int op_slot_right_10176 = gc_frame_newslot(strlit10177);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_10179 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit10181 == NULL) {
    strlit10181 = alloc_String("");
    gc_root(strlit10181);
  }
// compiled string node returning strlit10181 (depth = 9)
  int op_slot_left_10179 = gc_frame_newslot(strlit10181);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10182 = callmethod(strlit10181, "++(1)", 1, partcv, params);
// compiled op node returning opresult10182 (depth = 8)
  int op_slot_left_10176 = gc_frame_newslot(opresult10182);
  params[0] = strlit10177;
  partcv[0] = 1;
  Object opresult10183 = callmethod(opresult10182, "++(1)", 1, partcv, params);
// compiled op node returning opresult10183 (depth = 7)
  int op_slot_left_10169 = gc_frame_newslot(opresult10183);
  params[0] = call10174;
  partcv[0] = 1;
  Object opresult10184 = callmethod(opresult10183, "++(1)", 1, partcv, params);
// compiled op node returning opresult10184 (depth = 6)
  int op_slot_left_10166 = gc_frame_newslot(opresult10184);
  params[0] = strlit10167;
  partcv[0] = 1;
  Object opresult10185 = callmethod(opresult10184, "++(1)", 1, partcv, params);
// compiled op node returning opresult10185 (depth = 5)
  *var_s = opresult10185;
  if (opresult10185 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10159 = done;
  } else {
  }
// compiled if node returning if10159 (depth = 3)
// Begin line 2717
  setline(2717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_10187_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2720
  setline(2720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10189 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10190 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10191 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10190);
// compiled member node returning call10191 (depth = 5)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call10192 = callmethodflags(call10191, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10189);
// compiled call node returning call10192 (depth = 4)
  int op_slot_right_10188 = gc_frame_newslot(call10192);
// starting to compile string node (depth = 4)
  if (strlit10194 == NULL) {
    strlit10194 = alloc_String("return ");
    gc_root(strlit10194);
  }
// compiled string node returning strlit10194 (depth = 4)
  int op_slot_left_10188 = gc_frame_newslot(strlit10194);
  params[0] = call10192;
  partcv[0] = 1;
  Object opresult10195 = callmethod(strlit10194, "++(1)", 1, partcv, params);
// compiled op node returning opresult10195 (depth = 3)
  gc_frame_end(frame);
  return opresult10195;
}
Object meth_ast_10196_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_returnNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2723
  setline(2723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10197 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe10198 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe10199 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10200 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10199);
// compiled member node returning call10200 (depth = 5)
  gc_frame_newslot(call10200);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_returnNode (depth = 5)
  params[0] = call10200;
  partcv[0] = 1;
  Object call10201 = callmethodflags(*var_returnNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10198);
// compiled call node returning call10201 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call10202 = callmethodflags(call10201, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10197);
// compiled call node returning call10202 (depth = 3)
  gc_frame_end(frame);
  return call10202;
}
Object meth_ast_10203_postCopy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "postCopy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method postCopy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for postCopy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part postCopy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2726
  setline(2726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10204 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10205 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call10206 = callmethodflags(*var_other, "dtype", 1, partcv, params, 0);
  gc_frame_end(callframe10205);
// compiled member node returning call10206 (depth = 4)
  gc_frame_newslot(call10206);
// call case 4: self request
  params[0] = call10206;
  partcv[0] = 1;
  Object call10207 = callmethodflags(self, "dtype:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10204);
// compiled call node returning call10207 (depth = 3)
// Begin line 2727
  setline(2727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_10208_returnsObject(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2729
  setline(2729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe10209 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe10210 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10211 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10210);
// compiled member node returning call10211 (depth = 4)
  partcv[0] = 0;
  Object call10212 = callmethodflags(call10211, "returnsObject", 1, partcv, params, 0);
  gc_frame_end(callframe10209);
// compiled member node returning call10212 (depth = 3)
  gc_frame_end(frame);
  return call10212;
}
Object meth_ast_10213_returnedObjectScope(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2732
  setline(2732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe10214 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe10215 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10216 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10215);
// compiled member node returning call10216 (depth = 4)
  partcv[0] = 0;
  Object call10217 = callmethodflags(call10216, "returnedObjectScope", 1, partcv, params, 0);
  gc_frame_end(callframe10214);
// compiled member node returning call10217 (depth = 3)
  gc_frame_end(frame);
  return call10217;
}
Object meth_ast_10218_resultExpression(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "resultExpression");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2734
  setline(2734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe10219 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10220 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10219);
// compiled member node returning call10220 (depth = 3)
  gc_frame_end(frame);
  return call10220;
}
Object meth_ast_10069_new_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_noPosition = getfromclosure(closure, 0);
  Object *var_returnNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10070 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10070 = alloc_userobj2(16,15, objclass10070);
  gc_frame_newslot(obj10070);
  if (objclass10070 == NULL) {
    glfree(obj10070->class->name);
    obj10070->class->name = "returnNode.new(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj10070, self, 0);
  addmethodreal(obj10070,"outer", &reader_ast_outer_10071);
  Object oldself10070 = self;
  struct StackFrameObject *oldstackframe10070 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10070);
  gc_frame_newslot((Object)stackframe);
  self = obj10070;
  Object *oldselfslot10070 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10070 = (*(struct UserObject *)self).data[0], lowerouter10070 = thisouter10070;
  if (inheritingObject10070) {
    struct UserObject *inho10070 = (struct UserObject *)inheritingObject10070;
    while (inho10070->super != GraceDefaultObject) inho10070 = (struct UserObject *)inho10070->super;
    inho10070->super = obj10070;
    self = inheritingObject10070;
    *selfslot = self;
    lowerouter10070 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10070;
  }
  if (objclass10070 == NULL) {
  Method *reader10072 = addmethodrealflags(obj10070, "kind",&reader_ast_kind_10072, MFLAG_DEF);
  reader10072->definitionModule = modulename;
  reader10072->definitionLine = 2687;
  }
  adddatum2(obj10070, alloc_Undefined(), 1);
  if (objclass10070 == NULL) {
    Method *reader10073 = addmethodrealflags(obj10070, "value", &reader_ast_value_10073, 0);
    Method *writer10073 = addmethodrealflags(obj10070, "value:=(1)", &writer_ast_value_10073, 0);
    reader10073->definitionModule = modulename;
    writer10073->definitionModule = modulename;
    reader10073->definitionLine = 2688;
    writer10073->definitionLine = 2688;
  }
  obj10070->flags |= OFLAG_MUTABLE;
  adddatum2(obj10070, alloc_Undefined(), 2);
  if (objclass10070 == NULL) {
    Method *reader10074 = addmethodrealflags(obj10070, "dtype", &reader_ast_dtype_10074, 0);
    Method *writer10074 = addmethodrealflags(obj10070, "dtype:=(1)", &writer_ast_dtype_10074, 0);
    reader10074->definitionModule = modulename;
    writer10074->definitionModule = modulename;
    reader10074->definitionLine = 2689;
    writer10074->definitionLine = 2689;
  }
  obj10070->flags |= OFLAG_MUTABLE;
  adddatum2(obj10070, alloc_Undefined(), 3);
// method "end"
  block_savedest(obj10070);
  Object closure10075 = createclosure(1, "end");
  setclosureframe(closure10075, stackframe);
  addtoclosure(closure10075, var_noPosition);
  struct UserObject *uo10075 = (struct UserObject*)obj10070;
  uo10075->data[4] = (Object)closure10075;
  Method *meth_meth_ast_10075_end = addmethod2pos(obj10070, "end", &meth_ast_10075_end, 4);
  int argcv_meth_ast_10075_end[] = {0};
  meth_meth_ast_10075_end->type = alloc_MethodType(1, argcv_meth_ast_10075_end);
  meth_meth_ast_10075_end->definitionModule = modulename;
  meth_meth_ast_10075_end->definitionLine = 2691;
// method "isReturn"
  struct UserObject *uo10098 = (struct UserObject*)obj10070;
  uo10098->data[5] = emptyclosure;
  Method *meth_meth_ast_10098_isReturn = addmethod2pos(obj10070, "isReturn", &meth_ast_10098_isReturn, 5);
  int argcv_meth_ast_10098_isReturn[] = {0};
  meth_meth_ast_10098_isReturn->type = alloc_MethodType(1, argcv_meth_ast_10098_isReturn);
  meth_meth_ast_10098_isReturn->definitionModule = modulename;
  meth_meth_ast_10098_isReturn->definitionLine = 2698;
// method "accept(_)from(_)"
  struct UserObject *uo10100 = (struct UserObject*)obj10070;
  uo10100->data[6] = emptyclosure;
  Method *meth_meth_ast_10100_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj10070, "accept(1)from(1)", &meth_ast_10100_accept_40_1_41_from_40_1_41_, 6);
  int argcv_meth_ast_10100_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_10100_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_10100_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_10100_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10100_accept_40_1_41_from_40_1_41_->definitionLine = 2699;
// method "map(_)ancestors(_)"
  struct UserObject *uo10110 = (struct UserObject*)obj10070;
  uo10110->data[7] = emptyclosure;
  Method *meth_meth_ast_10110_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj10070, "map(1)ancestors(1)", &meth_ast_10110_map_40_1_41_ancestors_40_1_41_, 7);
  int argcv_meth_ast_10110_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_10110_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_10110_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_10110_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10110_map_40_1_41_ancestors_40_1_41_->definitionLine = 2705;
// method "pretty(_)"
  struct UserObject *uo10129 = (struct UserObject*)obj10070;
  uo10129->data[8] = emptyclosure;
  Method *meth_meth_ast_10129_pretty_40_1_41_ = addmethod2pos(obj10070, "pretty(1)", &meth_ast_10129_pretty_40_1_41_, 8);
  int argcv_meth_ast_10129_pretty_40_1_41_[] = {1};
  meth_meth_ast_10129_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10129_pretty_40_1_41_);
  meth_meth_ast_10129_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10129_pretty_40_1_41_->definitionLine = 2712;
// method "toGrace(_)"
  struct UserObject *uo10187 = (struct UserObject*)obj10070;
  uo10187->data[9] = emptyclosure;
  Method *meth_meth_ast_10187_toGrace_40_1_41_ = addmethod2pos(obj10070, "toGrace(1)", &meth_ast_10187_toGrace_40_1_41_, 9);
  int argcv_meth_ast_10187_toGrace_40_1_41_[] = {1};
  meth_meth_ast_10187_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10187_toGrace_40_1_41_);
meth_meth_ast_10187_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_10187_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_10187_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10187_toGrace_40_1_41_->definitionLine = 2719;
// method "shallowCopy"
  block_savedest(obj10070);
  Object closure10196 = createclosure(1, "shallowCopy");
  setclosureframe(closure10196, stackframe);
  addtoclosure(closure10196, var_returnNode);
  struct UserObject *uo10196 = (struct UserObject*)obj10070;
  uo10196->data[10] = (Object)closure10196;
  Method *meth_meth_ast_10196_shallowCopy = addmethod2pos(obj10070, "shallowCopy", &meth_ast_10196_shallowCopy, 10);
  int argcv_meth_ast_10196_shallowCopy[] = {0};
  meth_meth_ast_10196_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_10196_shallowCopy);
  meth_meth_ast_10196_shallowCopy->definitionModule = modulename;
  meth_meth_ast_10196_shallowCopy->definitionLine = 2722;
// method "postCopy(_)"
  struct UserObject *uo10203 = (struct UserObject*)obj10070;
  uo10203->data[11] = emptyclosure;
  Method *meth_meth_ast_10203_postCopy_40_1_41_ = addmethod2pos(obj10070, "postCopy(1)", &meth_ast_10203_postCopy_40_1_41_, 11);
  int argcv_meth_ast_10203_postCopy_40_1_41_[] = {1};
  meth_meth_ast_10203_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10203_postCopy_40_1_41_);
  meth_meth_ast_10203_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10203_postCopy_40_1_41_->definitionLine = 2725;
// method "returnsObject"
  struct UserObject *uo10208 = (struct UserObject*)obj10070;
  uo10208->data[12] = emptyclosure;
  Method *meth_meth_ast_10208_returnsObject = addmethod2pos(obj10070, "returnsObject", &meth_ast_10208_returnsObject, 12);
  int argcv_meth_ast_10208_returnsObject[] = {0};
  meth_meth_ast_10208_returnsObject->type = alloc_MethodType(1, argcv_meth_ast_10208_returnsObject);
  meth_meth_ast_10208_returnsObject->definitionModule = modulename;
  meth_meth_ast_10208_returnsObject->definitionLine = 2729;
// method "returnedObjectScope"
  struct UserObject *uo10213 = (struct UserObject*)obj10070;
  uo10213->data[13] = emptyclosure;
  Method *meth_meth_ast_10213_returnedObjectScope = addmethod2pos(obj10070, "returnedObjectScope", &meth_ast_10213_returnedObjectScope, 13);
  int argcv_meth_ast_10213_returnedObjectScope[] = {0};
  meth_meth_ast_10213_returnedObjectScope->type = alloc_MethodType(1, argcv_meth_ast_10213_returnedObjectScope);
  meth_meth_ast_10213_returnedObjectScope->definitionModule = modulename;
  meth_meth_ast_10213_returnedObjectScope->definitionLine = 2730;
// method "resultExpression"
  struct UserObject *uo10218 = (struct UserObject*)obj10070;
  uo10218->data[14] = emptyclosure;
  Method *meth_meth_ast_10218_resultExpression = addmethod2pos(obj10070, "resultExpression", &meth_ast_10218_resultExpression, 14);
  int argcv_meth_ast_10218_resultExpression[] = {0};
  meth_meth_ast_10218_resultExpression->type = alloc_MethodType(1, argcv_meth_ast_10218_resultExpression);
  meth_meth_ast_10218_resultExpression->definitionModule = modulename;
  meth_meth_ast_10218_resultExpression->definitionLine = 2734;
  sourceObject = obj10070;
// Begin line 2686
  setline(2686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10221 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10222 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10221);
// compiled call node returning call10222 (depth = 3)
  struct UserObject *obj10070_uo = (struct UserObject *)obj10070;
  obj10070_uo->super = call10222;
  sourceObject = obj10070;
// Begin line 2687
  setline(2687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10223 == NULL) {
    strlit10223 = alloc_String("return");
    gc_root(strlit10223);
  }
// compiled string node returning strlit10223 (depth = 3)
  adddatum2(obj10070, strlit10223, 1);
  sourceObject = obj10070;
// Begin line 2688
  setline(2688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_expr (depth = 3)
  adddatum2(obj10070, *var_expr, 2);
  sourceObject = obj10070;
// Begin line 2689
  setline(2689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10224 = alloc_Boolean(0);
// compiled identifier node returning bool10224 (depth = 3)
  adddatum2(obj10070, bool10224, 3);
  sourceObject = obj10070;
  sourceObject = obj10070;
  sourceObject = obj10070;
  sourceObject = obj10070;
  sourceObject = obj10070;
  sourceObject = obj10070;
  sourceObject = obj10070;
  sourceObject = obj10070;
  sourceObject = obj10070;
  sourceObject = obj10070;
  sourceObject = obj10070;
  objclass10070 = obj10070->class;
  objclass10070->definitionModule = modulename;
  objclass10070->definitionLine = 2685;
  (*(struct UserObject *)self).data[0] = lowerouter10070;
  self = oldself10070;
  selfslot = oldselfslot10070;
  stackframe = oldstackframe10070;
  gc_frame_end(frame);
  return obj10070;
}
Object meth_ast_10069_new_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_noPosition = getfromclosure(closure, 0);
  Object *var_returnNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10070 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10070 = alloc_userobj2(16,15, objclass10070);
  gc_frame_newslot(obj10070);
  if (objclass10070 == NULL) {
    glfree(obj10070->class->name);
    obj10070->class->name = "returnNode.new(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj10070, self, 0);
  addmethodreal(obj10070,"outer", &reader_ast_outer_10071);
  Object oldself10070 = self;
  struct StackFrameObject *oldstackframe10070 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10070);
  gc_frame_newslot((Object)stackframe);
  self = obj10070;
  Object *oldselfslot10070 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10070 = (*(struct UserObject *)self).data[0], lowerouter10070 = thisouter10070;
  if (inheritingObject10070) {
    struct UserObject *inho10070 = (struct UserObject *)inheritingObject10070;
    while (inho10070->super != GraceDefaultObject) inho10070 = (struct UserObject *)inho10070->super;
    inho10070->super = obj10070;
    self = inheritingObject10070;
    *selfslot = self;
    lowerouter10070 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10070;
  }
  if (objclass10070 == NULL) {
  Method *reader10072 = addmethodrealflags(obj10070, "kind",&reader_ast_kind_10072, MFLAG_DEF);
  reader10072->definitionModule = modulename;
  reader10072->definitionLine = 2687;
  }
  adddatum2(obj10070, alloc_Undefined(), 1);
  if (objclass10070 == NULL) {
    Method *reader10073 = addmethodrealflags(obj10070, "value", &reader_ast_value_10073, 0);
    Method *writer10073 = addmethodrealflags(obj10070, "value:=(1)", &writer_ast_value_10073, 0);
    reader10073->definitionModule = modulename;
    writer10073->definitionModule = modulename;
    reader10073->definitionLine = 2688;
    writer10073->definitionLine = 2688;
  }
  obj10070->flags |= OFLAG_MUTABLE;
  adddatum2(obj10070, alloc_Undefined(), 2);
  if (objclass10070 == NULL) {
    Method *reader10074 = addmethodrealflags(obj10070, "dtype", &reader_ast_dtype_10074, 0);
    Method *writer10074 = addmethodrealflags(obj10070, "dtype:=(1)", &writer_ast_dtype_10074, 0);
    reader10074->definitionModule = modulename;
    writer10074->definitionModule = modulename;
    reader10074->definitionLine = 2689;
    writer10074->definitionLine = 2689;
  }
  obj10070->flags |= OFLAG_MUTABLE;
  adddatum2(obj10070, alloc_Undefined(), 3);
// method "end"
  block_savedest(obj10070);
  Object closure10075 = createclosure(1, "end");
  setclosureframe(closure10075, stackframe);
  addtoclosure(closure10075, var_noPosition);
  struct UserObject *uo10075 = (struct UserObject*)obj10070;
  uo10075->data[4] = (Object)closure10075;
  Method *meth_meth_ast_10075_end = addmethod2pos(obj10070, "end", &meth_ast_10075_end, 4);
  int argcv_meth_ast_10075_end[] = {0};
  meth_meth_ast_10075_end->type = alloc_MethodType(1, argcv_meth_ast_10075_end);
  meth_meth_ast_10075_end->definitionModule = modulename;
  meth_meth_ast_10075_end->definitionLine = 2691;
// method "isReturn"
  struct UserObject *uo10098 = (struct UserObject*)obj10070;
  uo10098->data[5] = emptyclosure;
  Method *meth_meth_ast_10098_isReturn = addmethod2pos(obj10070, "isReturn", &meth_ast_10098_isReturn, 5);
  int argcv_meth_ast_10098_isReturn[] = {0};
  meth_meth_ast_10098_isReturn->type = alloc_MethodType(1, argcv_meth_ast_10098_isReturn);
  meth_meth_ast_10098_isReturn->definitionModule = modulename;
  meth_meth_ast_10098_isReturn->definitionLine = 2698;
// method "accept(_)from(_)"
  struct UserObject *uo10100 = (struct UserObject*)obj10070;
  uo10100->data[6] = emptyclosure;
  Method *meth_meth_ast_10100_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj10070, "accept(1)from(1)", &meth_ast_10100_accept_40_1_41_from_40_1_41_, 6);
  int argcv_meth_ast_10100_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_10100_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_10100_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_10100_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10100_accept_40_1_41_from_40_1_41_->definitionLine = 2699;
// method "map(_)ancestors(_)"
  struct UserObject *uo10110 = (struct UserObject*)obj10070;
  uo10110->data[7] = emptyclosure;
  Method *meth_meth_ast_10110_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj10070, "map(1)ancestors(1)", &meth_ast_10110_map_40_1_41_ancestors_40_1_41_, 7);
  int argcv_meth_ast_10110_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_10110_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_10110_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_10110_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10110_map_40_1_41_ancestors_40_1_41_->definitionLine = 2705;
// method "pretty(_)"
  struct UserObject *uo10129 = (struct UserObject*)obj10070;
  uo10129->data[8] = emptyclosure;
  Method *meth_meth_ast_10129_pretty_40_1_41_ = addmethod2pos(obj10070, "pretty(1)", &meth_ast_10129_pretty_40_1_41_, 8);
  int argcv_meth_ast_10129_pretty_40_1_41_[] = {1};
  meth_meth_ast_10129_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10129_pretty_40_1_41_);
  meth_meth_ast_10129_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10129_pretty_40_1_41_->definitionLine = 2712;
// method "toGrace(_)"
  struct UserObject *uo10187 = (struct UserObject*)obj10070;
  uo10187->data[9] = emptyclosure;
  Method *meth_meth_ast_10187_toGrace_40_1_41_ = addmethod2pos(obj10070, "toGrace(1)", &meth_ast_10187_toGrace_40_1_41_, 9);
  int argcv_meth_ast_10187_toGrace_40_1_41_[] = {1};
  meth_meth_ast_10187_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10187_toGrace_40_1_41_);
meth_meth_ast_10187_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_10187_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_10187_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10187_toGrace_40_1_41_->definitionLine = 2719;
// method "shallowCopy"
  block_savedest(obj10070);
  Object closure10196 = createclosure(1, "shallowCopy");
  setclosureframe(closure10196, stackframe);
  addtoclosure(closure10196, var_returnNode);
  struct UserObject *uo10196 = (struct UserObject*)obj10070;
  uo10196->data[10] = (Object)closure10196;
  Method *meth_meth_ast_10196_shallowCopy = addmethod2pos(obj10070, "shallowCopy", &meth_ast_10196_shallowCopy, 10);
  int argcv_meth_ast_10196_shallowCopy[] = {0};
  meth_meth_ast_10196_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_10196_shallowCopy);
  meth_meth_ast_10196_shallowCopy->definitionModule = modulename;
  meth_meth_ast_10196_shallowCopy->definitionLine = 2722;
// method "postCopy(_)"
  struct UserObject *uo10203 = (struct UserObject*)obj10070;
  uo10203->data[11] = emptyclosure;
  Method *meth_meth_ast_10203_postCopy_40_1_41_ = addmethod2pos(obj10070, "postCopy(1)", &meth_ast_10203_postCopy_40_1_41_, 11);
  int argcv_meth_ast_10203_postCopy_40_1_41_[] = {1};
  meth_meth_ast_10203_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10203_postCopy_40_1_41_);
  meth_meth_ast_10203_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10203_postCopy_40_1_41_->definitionLine = 2725;
// method "returnsObject"
  struct UserObject *uo10208 = (struct UserObject*)obj10070;
  uo10208->data[12] = emptyclosure;
  Method *meth_meth_ast_10208_returnsObject = addmethod2pos(obj10070, "returnsObject", &meth_ast_10208_returnsObject, 12);
  int argcv_meth_ast_10208_returnsObject[] = {0};
  meth_meth_ast_10208_returnsObject->type = alloc_MethodType(1, argcv_meth_ast_10208_returnsObject);
  meth_meth_ast_10208_returnsObject->definitionModule = modulename;
  meth_meth_ast_10208_returnsObject->definitionLine = 2729;
// method "returnedObjectScope"
  struct UserObject *uo10213 = (struct UserObject*)obj10070;
  uo10213->data[13] = emptyclosure;
  Method *meth_meth_ast_10213_returnedObjectScope = addmethod2pos(obj10070, "returnedObjectScope", &meth_ast_10213_returnedObjectScope, 13);
  int argcv_meth_ast_10213_returnedObjectScope[] = {0};
  meth_meth_ast_10213_returnedObjectScope->type = alloc_MethodType(1, argcv_meth_ast_10213_returnedObjectScope);
  meth_meth_ast_10213_returnedObjectScope->definitionModule = modulename;
  meth_meth_ast_10213_returnedObjectScope->definitionLine = 2730;
// method "resultExpression"
  struct UserObject *uo10218 = (struct UserObject*)obj10070;
  uo10218->data[14] = emptyclosure;
  Method *meth_meth_ast_10218_resultExpression = addmethod2pos(obj10070, "resultExpression", &meth_ast_10218_resultExpression, 14);
  int argcv_meth_ast_10218_resultExpression[] = {0};
  meth_meth_ast_10218_resultExpression->type = alloc_MethodType(1, argcv_meth_ast_10218_resultExpression);
  meth_meth_ast_10218_resultExpression->definitionModule = modulename;
  meth_meth_ast_10218_resultExpression->definitionLine = 2734;
  sourceObject = obj10070;
// Begin line 2686
  setline(2686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10221 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10222 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10221);
// compiled call node returning call10222 (depth = 3)
  struct UserObject *obj10070_uo = (struct UserObject *)obj10070;
  obj10070_uo->super = call10222;
  sourceObject = obj10070;
// Begin line 2687
  setline(2687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10223 == NULL) {
    strlit10223 = alloc_String("return");
    gc_root(strlit10223);
  }
// compiled string node returning strlit10223 (depth = 3)
  adddatum2(obj10070, strlit10223, 1);
  sourceObject = obj10070;
// Begin line 2688
  setline(2688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_expr (depth = 3)
  adddatum2(obj10070, *var_expr, 2);
  sourceObject = obj10070;
// Begin line 2689
  setline(2689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10224 = alloc_Boolean(0);
// compiled identifier node returning bool10224 (depth = 3)
  adddatum2(obj10070, bool10224, 3);
  sourceObject = obj10070;
  sourceObject = obj10070;
  sourceObject = obj10070;
  sourceObject = obj10070;
  sourceObject = obj10070;
  sourceObject = obj10070;
  sourceObject = obj10070;
  sourceObject = obj10070;
  sourceObject = obj10070;
  sourceObject = obj10070;
  sourceObject = obj10070;
  objclass10070 = obj10070->class;
  objclass10070->definitionModule = modulename;
  objclass10070->definitionLine = 2685;
  (*(struct UserObject *)self).data[0] = lowerouter10070;
  self = oldself10070;
  selfslot = oldselfslot10070;
  stackframe = oldstackframe10070;
  gc_frame_end(frame);
  return obj10070;
}
Object meth_ast_10226_returnNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 54, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "returnNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_returnNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2684
  setline(2684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_returnNode (depth = 3)
  gc_frame_end(frame);
  return *var_returnNode;
}
Object meth_ast_10229_new_40_1_41_scope_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new(1)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)scope(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new(_)scope(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 2739
  setline(2739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10230 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_expr (depth = 5)
  gc_frame_newslot(*var_expr);
// call case 4: self request
  params[0] = *var_expr;
  partcv[0] = 1;
  Object call10231 = callmethodflags(self, "new(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10230);
// compiled call node returning call10231 (depth = 4)
  *var_result = call10231;
  if (call10231 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2740
  setline(2740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10232 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call10233 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10232);
// compiled call node returning call10233 (depth = 3)
// Begin line 2741
  setline(2741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_10243_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2752
  setline(2752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe10244 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe10245 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10246 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10245);
// compiled member node returning call10246 (depth = 4)
  partcv[0] = 0;
  Object call10247 = callmethodflags(call10246, "end", 1, partcv, params, 0);
  gc_frame_end(callframe10244);
// compiled member node returning call10247 (depth = 3)
  gc_frame_end(frame);
  return call10247;
}
Object meth_ast_10248_isLegalInTrait(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isLegalInTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2753
  setline(2753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe10249 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10250 = callmethodflags(self, "isUse", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10249);
// compiled member node returning call10250 (depth = 3)
  gc_frame_end(frame);
  return call10250;
}
Object meth_ast_10251_isInherits(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isInherits");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2754
  setline(2754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10252 = alloc_Boolean(1);
// compiled identifier node returning bool10252 (depth = 3)
  gc_frame_end(frame);
  return bool10252;
}
Object meth_ast_10253_inheritFromMember(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inheritFromMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2755
  setline(2755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe10254 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe10255 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10256 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10255);
// compiled member node returning call10256 (depth = 4)
  partcv[0] = 0;
  Object call10257 = callmethodflags(call10256, "isMember", 1, partcv, params, 0);
  gc_frame_end(callframe10254);
// compiled member node returning call10257 (depth = 3)
  gc_frame_end(frame);
  return call10257;
}
Object meth_ast_10258_inheritFromCall(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inheritFromCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2756
  setline(2756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe10259 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe10260 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10261 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10260);
// compiled member node returning call10261 (depth = 4)
  partcv[0] = 0;
  Object call10262 = callmethodflags(call10261, "isCall", 1, partcv, params, 0);
  gc_frame_end(callframe10259);
// compiled member node returning call10262 (depth = 3)
  gc_frame_end(frame);
  return call10262;
}
Object meth_ast_10263_isExecutable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2757
  setline(2757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10264 = alloc_Boolean(0);
// compiled identifier node returning bool10264 (depth = 3)
  gc_frame_end(frame);
  return bool10264;
}
Object meth_ast_10277__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2763
  setline(2763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10278 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe10279 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call10280 = callmethodflags(*var_a, "newName", 1, partcv, params, 0);
  gc_frame_end(callframe10279);
// compiled member node returning call10280 (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10281 = callmethodflags(call10280, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10278);
// compiled call node returning call10281 (depth = 6)
// Begin line 2764
  setline(2764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10282 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe10283 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call10284 = callmethodflags(*var_a, "oldName", 1, partcv, params, 0);
  gc_frame_end(callframe10283);
// compiled member node returning call10284 (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10285 = callmethodflags(call10284, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10282);
// compiled call node returning call10285 (depth = 6)
  gc_frame_end(frame);
  return call10285;
}
Object meth_ast_10292__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_e = &(stackframe->slots[0]);
  *var_e = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 6)
  int callframe10293 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_e (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10294 = callmethodflags(*var_e, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10293);
// compiled call node returning call10294 (depth = 6)
  gc_frame_end(frame);
  return call10294;
}
Object meth_ast_10265_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// definebindings:
// Begin line 2759
  setline(2759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10267 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10268 = callmethodflags(*var_visitor, "visitInherits(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10267);
// compiled call node returning call10268 (depth = 4)
  Object if10266 = done;
  if (istrue(call10268)) {
// Begin line 2760
  setline(2760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10269 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call10270 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10269);
// compiled call node returning call10270 (depth = 5)
  *var_newChain = call10270;
  if (call10270 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2761
  setline(2761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10271 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10272 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10273 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10272);
// compiled member node returning call10273 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10274 = callmethodflags(call10273, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10271);
// compiled call node returning call10274 (depth = 4)
// Begin line 2762
  setline(2762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10275 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block10276 = alloc_Block(NULL, NULL, "ast", 2762);
  gc_frame_newslot(block10276);
// method "_apply(_)"
  block_savedest(block10276);
  Object closure10277 = createclosure(3, "_apply(1)");
  setclosureframe(closure10277, stackframe);
  addtoclosure(closure10277, var_visitor);
  addtoclosure(closure10277, var_newChain);
  addtoclosure(closure10277, selfslot);
  struct UserObject *uo10277 = (struct UserObject*)block10276;
  uo10277->data[0] = (Object)closure10277;
  Method *meth_meth_ast_10277__apply_40_1_41_ = addmethod2pos(block10276, "_apply(1)", &meth_ast_10277__apply_40_1_41_, 0);
  int argcv_meth_ast_10277__apply_40_1_41_[] = {1};
  meth_meth_ast_10277__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10277__apply_40_1_41_);
  meth_meth_ast_10277__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10277__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block10276 (depth = 5)
  gc_frame_newslot(block10276);
// call case 6: other requests
// Begin line 2762
  setline(2762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe10287 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10288 = callmethodflags(self, "aliases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10287);
// compiled member node returning call10288 (depth = 5)
  params[0] = block10276;
  partcv[0] = 1;
  Object call10289 = callmethodflags(call10288, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10275);
// compiled call node returning call10289 (depth = 4)
// Begin line 2766
  setline(2766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10290 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block10291 = alloc_Block(NULL, NULL, "ast", 2766);
  gc_frame_newslot(block10291);
// method "_apply(_)"
  block_savedest(block10291);
  Object closure10292 = createclosure(3, "_apply(1)");
  setclosureframe(closure10292, stackframe);
  addtoclosure(closure10292, var_visitor);
  addtoclosure(closure10292, var_newChain);
  addtoclosure(closure10292, selfslot);
  struct UserObject *uo10292 = (struct UserObject*)block10291;
  uo10292->data[0] = (Object)closure10292;
  Method *meth_meth_ast_10292__apply_40_1_41_ = addmethod2pos(block10291, "_apply(1)", &meth_ast_10292__apply_40_1_41_, 0);
  int argcv_meth_ast_10292__apply_40_1_41_[] = {1};
  meth_meth_ast_10292__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10292__apply_40_1_41_);
  meth_meth_ast_10292__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10292__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block10291 (depth = 5)
  gc_frame_newslot(block10291);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10296 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10297 = callmethodflags(self, "exclusions", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10296);
// compiled member node returning call10297 (depth = 5)
  params[0] = block10291;
  partcv[0] = 1;
  Object call10298 = callmethodflags(call10297, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10290);
// compiled call node returning call10298 (depth = 4)
    gc_frame_newslot(call10298);
    if10266 = call10298;
  } else {
  }
// compiled if node returning if10266 (depth = 3)
  gc_frame_end(frame);
  return if10266;
}
Object meth_ast_10299_declarationKindWithAncestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2773
  setline(2773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe10300 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  partcv[0] = 0;
  Object call10301 = callmethodflags(*var_k, "methdec", 1, partcv, params, 0);
  gc_frame_end(callframe10300);
// compiled member node returning call10301 (depth = 3)
  gc_frame_end(frame);
  return call10301;
}
Object meth_ast_10302_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2776
  setline(2776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10303 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10304 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10303);
// compiled member node returning call10304 (depth = 4)
  *var_n = call10304;
  if (call10304 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2777
  setline(2777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10305 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call10306 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10305);
// compiled call node returning call10306 (depth = 4)
  *var_newChain = call10306;
  if (call10306 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2778
  setline(2778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10307 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe10308 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10309 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10310 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10309);
// compiled member node returning call10310 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10311 = callmethodflags(call10310, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10308);
// compiled call node returning call10311 (depth = 4)
  gc_frame_newslot(call10311);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call10311;
  partcv[0] = 1;
  Object call10312 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10307);
// compiled call node returning call10312 (depth = 3)
// Begin line 2779
  setline(2779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10313 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call10314 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe10313);
// compiled call node returning call10314 (depth = 3)
  gc_frame_end(frame);
  return call10314;
}
Object meth_ast_10359__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2787
  setline(2787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10361 == NULL) {
    strlit10361 = alloc_String("");
    gc_root(strlit10361);
  }
// compiled string node returning strlit10361 (depth = 7)
  int op_slot_right_10360 = gc_frame_newslot(strlit10361);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10364 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call10365 = callmethodflags(*var_a, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10364);
// compiled call node returning call10365 (depth = 8)
  int op_slot_right_10363 = gc_frame_newslot(call10365);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10368 == NULL) {
    strlit10368 = alloc_String("""\x0a""");
    gc_root(strlit10368);
  }
// compiled string node returning strlit10368 (depth = 9)
  int op_slot_right_10367 = gc_frame_newslot(strlit10368);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_10370 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit10372 == NULL) {
    strlit10372 = alloc_String("");
    gc_root(strlit10372);
  }
// compiled string node returning strlit10372 (depth = 10)
  int op_slot_left_10370 = gc_frame_newslot(strlit10372);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10373 = callmethod(strlit10372, "++(1)", 1, partcv, params);
// compiled op node returning opresult10373 (depth = 9)
  int op_slot_left_10367 = gc_frame_newslot(opresult10373);
  params[0] = strlit10368;
  partcv[0] = 1;
  Object opresult10374 = callmethod(opresult10373, "++(1)", 1, partcv, params);
// compiled op node returning opresult10374 (depth = 8)
  int op_slot_left_10363 = gc_frame_newslot(opresult10374);
  params[0] = call10365;
  partcv[0] = 1;
  Object opresult10375 = callmethod(opresult10374, "++(1)", 1, partcv, params);
// compiled op node returning opresult10375 (depth = 7)
  int op_slot_left_10360 = gc_frame_newslot(opresult10375);
  params[0] = strlit10361;
  partcv[0] = 1;
  Object opresult10376 = callmethod(opresult10375, "++(1)", 1, partcv, params);
// compiled op node returning opresult10376 (depth = 6)
  *var_s = opresult10376;
  if (opresult10376 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_10407__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_e = &(stackframe->slots[0]);
  *var_e = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2791
  setline(2791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10409 == NULL) {
    strlit10409 = alloc_String(" ");
    gc_root(strlit10409);
  }
// compiled string node returning strlit10409 (depth = 7)
  int op_slot_right_10408 = gc_frame_newslot(strlit10409);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_e (depth = 8)
  int op_slot_right_10411 = gc_frame_newslot(*var_e);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10414 == NULL) {
    strlit10414 = alloc_String(" exclude ");
    gc_root(strlit10414);
  }
// compiled string node returning strlit10414 (depth = 9)
  int op_slot_right_10413 = gc_frame_newslot(strlit10414);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_10416 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit10418 == NULL) {
    strlit10418 = alloc_String("");
    gc_root(strlit10418);
  }
// compiled string node returning strlit10418 (depth = 10)
  int op_slot_left_10416 = gc_frame_newslot(strlit10418);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10419 = callmethod(strlit10418, "++(1)", 1, partcv, params);
// compiled op node returning opresult10419 (depth = 9)
  int op_slot_left_10413 = gc_frame_newslot(opresult10419);
  params[0] = strlit10414;
  partcv[0] = 1;
  Object opresult10420 = callmethod(opresult10419, "++(1)", 1, partcv, params);
// compiled op node returning opresult10420 (depth = 8)
  int op_slot_left_10411 = gc_frame_newslot(opresult10420);
  params[0] = *var_e;
  partcv[0] = 1;
  Object opresult10421 = callmethod(opresult10420, "++(1)", 1, partcv, params);
// compiled op node returning opresult10421 (depth = 7)
  int op_slot_left_10408 = gc_frame_newslot(opresult10421);
  params[0] = strlit10409;
  partcv[0] = 1;
  Object opresult10422 = callmethod(opresult10421, "++(1)", 1, partcv, params);
// compiled op node returning opresult10422 (depth = 6)
  *var_s = opresult10422;
  if (opresult10422 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_10315_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2782
  setline(2782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num10318 = alloc_Float64(1);
// compiled num node returning num10318 (depth = 6)
  int op_slot_right_10317 = gc_frame_newslot(num10318);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_10317 = gc_frame_newslot(*var_depth);
  params[0] = num10318;
  partcv[0] = 1;
  Object sum10320 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum10320 (depth = 5)
  int op_slot_right_10316 = gc_frame_newslot(sum10320);
// starting to compile string node (depth = 5)
  if (strlit10322 == NULL) {
    strlit10322 = alloc_String("  ");
    gc_root(strlit10322);
  }
// compiled string node returning strlit10322 (depth = 5)
  int op_slot_left_10316 = gc_frame_newslot(strlit10322);
  params[0] = sum10320;
  partcv[0] = 1;
  Object prod10323 = callmethod(strlit10322, "*(1)", 1, partcv, params);
// compiled op node returning prod10323 (depth = 4)
  *var_spc = prod10323;
  if (prod10323 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2783
  setline(2783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10324 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call10325 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10324);
// compiled call node returning call10325 (depth = 4)
  *var_s = call10325;
  if (call10325 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2784
  setline(2784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10327 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10328 = callmethodflags(self, "isUse", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10327);
// compiled member node returning call10328 (depth = 4)
  Object if10326 = done;
  if (istrue(call10328)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10330 == NULL) {
    strlit10330 = alloc_String(" (use)");
    gc_root(strlit10330);
  }
// compiled string node returning strlit10330 (depth = 6)
  int op_slot_right_10329 = gc_frame_newslot(strlit10330);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_10332 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 7)
  if (strlit10334 == NULL) {
    strlit10334 = alloc_String("");
    gc_root(strlit10334);
  }
// compiled string node returning strlit10334 (depth = 7)
  int op_slot_left_10332 = gc_frame_newslot(strlit10334);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10335 = callmethod(strlit10334, "++(1)", 1, partcv, params);
// compiled op node returning opresult10335 (depth = 6)
  int op_slot_left_10329 = gc_frame_newslot(opresult10335);
  params[0] = strlit10330;
  partcv[0] = 1;
  Object opresult10336 = callmethod(opresult10335, "++(1)", 1, partcv, params);
// compiled op node returning opresult10336 (depth = 5)
  *var_s = opresult10336;
  if (opresult10336 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10326 = done;
  } else {
  }
// compiled if node returning if10326 (depth = 3)
// Begin line 2785
  setline(2785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10339 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num10341 = alloc_Float64(1);
// compiled num node returning num10341 (depth = 7)
  int op_slot_right_10340 = gc_frame_newslot(num10341);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_10340 = gc_frame_newslot(*var_depth);
  params[0] = num10341;
  partcv[0] = 1;
  Object sum10343 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum10343 (depth = 6)
  gc_frame_newslot(sum10343);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10344 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10345 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10344);
// compiled member node returning call10345 (depth = 6)
  params[0] = sum10343;
  partcv[0] = 1;
  Object call10346 = callmethodflags(call10345, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10339);
// compiled call node returning call10346 (depth = 5)
  int op_slot_right_10338 = gc_frame_newslot(call10346);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_10348 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10351 == NULL) {
    strlit10351 = alloc_String("""\x0a""");
    gc_root(strlit10351);
  }
// compiled string node returning strlit10351 (depth = 7)
  int op_slot_right_10350 = gc_frame_newslot(strlit10351);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_10350 = gc_frame_newslot(*var_s);
  params[0] = strlit10351;
  partcv[0] = 1;
  Object opresult10353 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10353 (depth = 6)
  int op_slot_left_10348 = gc_frame_newslot(opresult10353);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult10354 = callmethod(opresult10353, "++(1)", 1, partcv, params);
// compiled op node returning opresult10354 (depth = 5)
  int op_slot_left_10338 = gc_frame_newslot(opresult10354);
  params[0] = call10346;
  partcv[0] = 1;
  Object opresult10355 = callmethod(opresult10354, "++(1)", 1, partcv, params);
// compiled op node returning opresult10355 (depth = 4)
  *var_s = opresult10355;
  if (opresult10355 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2786
  setline(2786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10357 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block10358 = alloc_Block(NULL, NULL, "ast", 2786);
  gc_frame_newslot(block10358);
// method "_apply(_)"
  block_savedest(block10358);
  Object closure10359 = createclosure(3, "_apply(1)");
  setclosureframe(closure10359, stackframe);
  addtoclosure(closure10359, var_depth);
  addtoclosure(closure10359, var_s);
  addtoclosure(closure10359, selfslot);
  struct UserObject *uo10359 = (struct UserObject*)block10358;
  uo10359->data[0] = (Object)closure10359;
  Method *meth_meth_ast_10359__apply_40_1_41_ = addmethod2pos(block10358, "_apply(1)", &meth_ast_10359__apply_40_1_41_, 0);
  int argcv_meth_ast_10359__apply_40_1_41_[] = {1};
  meth_meth_ast_10359__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10359__apply_40_1_41_);
  meth_meth_ast_10359__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10359__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block10358 (depth = 4)
  gc_frame_newslot(block10358);
// call case 6: other requests
// Begin line 2786
  setline(2786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe10379 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10380 = callmethodflags(self, "aliases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10379);
// compiled member node returning call10380 (depth = 4)
  params[0] = block10358;
  partcv[0] = 1;
  Object call10381 = callmethodflags(call10380, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10357);
// compiled call node returning call10381 (depth = 3)
// Begin line 2789
  setline(2789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10383 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10384 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10385 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10386 = callmethodflags(self, "exclusions", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10385);
// compiled member node returning call10386 (depth = 6)
  partcv[0] = 0;
  Object call10387 = callmethodflags(call10386, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe10384);
// compiled member node returning call10387 (depth = 5)
  partcv[0] = 0;
  Object call10388 = callmethodflags(call10387, "not", 1, partcv, params, 0);
  gc_frame_end(callframe10383);
// compiled member node returning call10388 (depth = 4)
  Object if10382 = done;
  if (istrue(call10388)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10390 == NULL) {
    strlit10390 = alloc_String("");
    gc_root(strlit10390);
  }
// compiled string node returning strlit10390 (depth = 6)
  int op_slot_right_10389 = gc_frame_newslot(strlit10390);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_10392 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10395 == NULL) {
    strlit10395 = alloc_String("""\x0a""");
    gc_root(strlit10395);
  }
// compiled string node returning strlit10395 (depth = 8)
  int op_slot_right_10394 = gc_frame_newslot(strlit10395);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_10397 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit10399 == NULL) {
    strlit10399 = alloc_String("");
    gc_root(strlit10399);
  }
// compiled string node returning strlit10399 (depth = 9)
  int op_slot_left_10397 = gc_frame_newslot(strlit10399);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10400 = callmethod(strlit10399, "++(1)", 1, partcv, params);
// compiled op node returning opresult10400 (depth = 8)
  int op_slot_left_10394 = gc_frame_newslot(opresult10400);
  params[0] = strlit10395;
  partcv[0] = 1;
  Object opresult10401 = callmethod(opresult10400, "++(1)", 1, partcv, params);
// compiled op node returning opresult10401 (depth = 7)
  int op_slot_left_10392 = gc_frame_newslot(opresult10401);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult10402 = callmethod(opresult10401, "++(1)", 1, partcv, params);
// compiled op node returning opresult10402 (depth = 6)
  int op_slot_left_10389 = gc_frame_newslot(opresult10402);
  params[0] = strlit10390;
  partcv[0] = 1;
  Object opresult10403 = callmethod(opresult10402, "++(1)", 1, partcv, params);
// compiled op node returning opresult10403 (depth = 5)
  *var_s = opresult10403;
  if (opresult10403 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10382 = done;
  } else {
  }
// compiled if node returning if10382 (depth = 3)
// Begin line 2790
  setline(2790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10405 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block10406 = alloc_Block(NULL, NULL, "ast", 2790);
  gc_frame_newslot(block10406);
// method "_apply(_)"
  block_savedest(block10406);
  Object closure10407 = createclosure(2, "_apply(1)");
  setclosureframe(closure10407, stackframe);
  addtoclosure(closure10407, var_s);
  addtoclosure(closure10407, selfslot);
  struct UserObject *uo10407 = (struct UserObject*)block10406;
  uo10407->data[0] = (Object)closure10407;
  Method *meth_meth_ast_10407__apply_40_1_41_ = addmethod2pos(block10406, "_apply(1)", &meth_ast_10407__apply_40_1_41_, 0);
  int argcv_meth_ast_10407__apply_40_1_41_[] = {1};
  meth_meth_ast_10407__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10407__apply_40_1_41_);
  meth_meth_ast_10407__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10407__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block10406 (depth = 4)
  gc_frame_newslot(block10406);
// call case 6: other requests
// Begin line 2790
  setline(2790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe10425 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10426 = callmethodflags(self, "exclusions", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10425);
// compiled member node returning call10426 (depth = 4)
  params[0] = block10406;
  partcv[0] = 1;
  Object call10427 = callmethodflags(call10426, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10405);
// compiled call node returning call10427 (depth = 3)
// Begin line 2793
  setline(2793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10429 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10430 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10431 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10432 = callmethodflags(self, "providedNames", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10431);
// compiled member node returning call10432 (depth = 6)
  partcv[0] = 0;
  Object call10433 = callmethodflags(call10432, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe10430);
// compiled member node returning call10433 (depth = 5)
  partcv[0] = 0;
  Object call10434 = callmethodflags(call10433, "not", 1, partcv, params, 0);
  gc_frame_end(callframe10429);
// compiled member node returning call10434 (depth = 4)
  Object if10428 = done;
  if (istrue(call10434)) {
// Begin line 2794
  setline(2794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10437 == NULL) {
    strlit10437 = alloc_String("");
    gc_root(strlit10437);
  }
// compiled string node returning strlit10437 (depth = 7)
  int op_slot_right_10436 = gc_frame_newslot(strlit10437);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe10440 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 9)
  int callframe10441 = gc_frame_new();
// starting to compile member node (depth = 10)
  int callframe10442 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10443 = callmethodflags(self, "providedNames", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10442);
// compiled member node returning call10443 (depth = 10)
  gc_frame_newslot(call10443);
// call case 5: prelude request
  params[0] = call10443;
  partcv[0] = 1;
  Object call10444 = callmethodflags(prelude, "list(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10441);
// compiled call node returning call10444 (depth = 9)
  partcv[0] = 0;
  Object call10445 = callmethodflags(call10444, "sort", 1, partcv, params, 0);
  gc_frame_end(callframe10440);
// compiled member node returning call10445 (depth = 8)
  int op_slot_right_10439 = gc_frame_newslot(call10445);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10448 == NULL) {
    strlit10448 = alloc_String("Provided names: ");
    gc_root(strlit10448);
  }
// compiled string node returning strlit10448 (depth = 9)
  int op_slot_right_10447 = gc_frame_newslot(strlit10448);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_10450 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 10)
  if (strlit10452 == NULL) {
    strlit10452 = alloc_String("""\x0a""");
    gc_root(strlit10452);
  }
// compiled string node returning strlit10452 (depth = 10)
  int op_slot_left_10450 = gc_frame_newslot(strlit10452);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult10453 = callmethod(strlit10452, "++(1)", 1, partcv, params);
// compiled op node returning opresult10453 (depth = 9)
  int op_slot_left_10447 = gc_frame_newslot(opresult10453);
  params[0] = strlit10448;
  partcv[0] = 1;
  Object opresult10454 = callmethod(opresult10453, "++(1)", 1, partcv, params);
// compiled op node returning opresult10454 (depth = 8)
  int op_slot_left_10439 = gc_frame_newslot(opresult10454);
  params[0] = call10445;
  partcv[0] = 1;
  Object opresult10455 = callmethod(opresult10454, "++(1)", 1, partcv, params);
// compiled op node returning opresult10455 (depth = 7)
  int op_slot_left_10436 = gc_frame_newslot(opresult10455);
  params[0] = strlit10437;
  partcv[0] = 1;
  Object opresult10456 = callmethod(opresult10455, "++(1)", 1, partcv, params);
// compiled op node returning opresult10456 (depth = 6)
  int op_slot_right_10435 = gc_frame_newslot(opresult10456);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_10435 = gc_frame_newslot(*var_s);
  params[0] = opresult10456;
  partcv[0] = 1;
  Object opresult10458 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10458 (depth = 5)
  *var_s = opresult10458;
  if (opresult10458 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10428 = done;
  } else {
  }
// compiled if node returning if10428 (depth = 3)
// Begin line 2796
  setline(2796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_10464__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2801
  setline(2801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10466 == NULL) {
    strlit10466 = alloc_String("    ");
    gc_root(strlit10466);
  }
// compiled string node returning strlit10466 (depth = 7)
  int op_slot_right_10465 = gc_frame_newslot(strlit10466);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_10465 = gc_frame_newslot(*var_s);
  params[0] = strlit10466;
  partcv[0] = 1;
  Object opresult10468 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10468 (depth = 6)
  *var_s = opresult10468;
  if (opresult10468 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_10492__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2806
  setline(2806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10494 == NULL) {
    strlit10494 = alloc_String(" ");
    gc_root(strlit10494);
  }
// compiled string node returning strlit10494 (depth = 7)
  int op_slot_right_10493 = gc_frame_newslot(strlit10494);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  int op_slot_right_10496 = gc_frame_newslot(*var_a);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10499 == NULL) {
    strlit10499 = alloc_String(" ");
    gc_root(strlit10499);
  }
// compiled string node returning strlit10499 (depth = 9)
  int op_slot_right_10498 = gc_frame_newslot(strlit10499);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_10501 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit10503 == NULL) {
    strlit10503 = alloc_String("");
    gc_root(strlit10503);
  }
// compiled string node returning strlit10503 (depth = 10)
  int op_slot_left_10501 = gc_frame_newslot(strlit10503);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10504 = callmethod(strlit10503, "++(1)", 1, partcv, params);
// compiled op node returning opresult10504 (depth = 9)
  int op_slot_left_10498 = gc_frame_newslot(opresult10504);
  params[0] = strlit10499;
  partcv[0] = 1;
  Object opresult10505 = callmethod(opresult10504, "++(1)", 1, partcv, params);
// compiled op node returning opresult10505 (depth = 8)
  int op_slot_left_10496 = gc_frame_newslot(opresult10505);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult10506 = callmethod(opresult10505, "++(1)", 1, partcv, params);
// compiled op node returning opresult10506 (depth = 7)
  int op_slot_left_10493 = gc_frame_newslot(opresult10506);
  params[0] = strlit10494;
  partcv[0] = 1;
  Object opresult10507 = callmethod(opresult10506, "++(1)", 1, partcv, params);
// compiled op node returning opresult10507 (depth = 6)
  *var_s = opresult10507;
  if (opresult10507 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_10515__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_e = &(stackframe->slots[0]);
  *var_e = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2809
  setline(2809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10517 == NULL) {
    strlit10517 = alloc_String(" ");
    gc_root(strlit10517);
  }
// compiled string node returning strlit10517 (depth = 7)
  int op_slot_right_10516 = gc_frame_newslot(strlit10517);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe10520 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_e (depth = 9)
  partcv[0] = 0;
  Object call10521 = callmethodflags(*var_e, "nameString", 1, partcv, params, 0);
  gc_frame_end(callframe10520);
// compiled member node returning call10521 (depth = 8)
  int op_slot_right_10519 = gc_frame_newslot(call10521);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10524 == NULL) {
    strlit10524 = alloc_String(" exclude ");
    gc_root(strlit10524);
  }
// compiled string node returning strlit10524 (depth = 9)
  int op_slot_right_10523 = gc_frame_newslot(strlit10524);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_10526 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit10528 == NULL) {
    strlit10528 = alloc_String("");
    gc_root(strlit10528);
  }
// compiled string node returning strlit10528 (depth = 10)
  int op_slot_left_10526 = gc_frame_newslot(strlit10528);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10529 = callmethod(strlit10528, "++(1)", 1, partcv, params);
// compiled op node returning opresult10529 (depth = 9)
  int op_slot_left_10523 = gc_frame_newslot(opresult10529);
  params[0] = strlit10524;
  partcv[0] = 1;
  Object opresult10530 = callmethod(opresult10529, "++(1)", 1, partcv, params);
// compiled op node returning opresult10530 (depth = 8)
  int op_slot_left_10519 = gc_frame_newslot(opresult10530);
  params[0] = call10521;
  partcv[0] = 1;
  Object opresult10531 = callmethod(opresult10530, "++(1)", 1, partcv, params);
// compiled op node returning opresult10531 (depth = 7)
  int op_slot_left_10516 = gc_frame_newslot(opresult10531);
  params[0] = strlit10517;
  partcv[0] = 1;
  Object opresult10532 = callmethod(opresult10531, "++(1)", 1, partcv, params);
// compiled op node returning opresult10532 (depth = 6)
  *var_s = opresult10532;
  if (opresult10532 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_10460_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 2799
  setline(2799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10461 == NULL) {
    strlit10461 = alloc_String("");
    gc_root(strlit10461);
  }
// compiled string node returning strlit10461 (depth = 4)
  *var_s = strlit10461;
  if (strlit10461 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2800
  setline(2800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10462 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth (depth = 4)
  gc_frame_newslot(*var_depth);
// starting to compile block node (depth = 4)
  Object block10463 = alloc_Block(NULL, NULL, "ast", 2800);
  gc_frame_newslot(block10463);
// method "_apply"
  block_savedest(block10463);
  Object closure10464 = createclosure(2, "_apply");
  setclosureframe(closure10464, stackframe);
  addtoclosure(closure10464, var_s);
  addtoclosure(closure10464, selfslot);
  struct UserObject *uo10464 = (struct UserObject*)block10463;
  uo10464->data[0] = (Object)closure10464;
  Method *meth_meth_ast_10464__apply = addmethod2pos(block10463, "_apply", &meth_ast_10464__apply, 0);
  int argcv_meth_ast_10464__apply[] = {0};
  meth_meth_ast_10464__apply->type = alloc_MethodType(1, argcv_meth_ast_10464__apply);
  meth_meth_ast_10464__apply->definitionModule = modulename;
  meth_meth_ast_10464__apply->definitionLine = 3050;
// compiled block node returning block10463 (depth = 4)
  gc_frame_newslot(block10463);
// call case 5: prelude request
  params[0] = *var_depth;
  params[1] = block10463;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10471 = callmethodflags(prelude, "repeat(1)times(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10462);
// compiled call node returning call10471 (depth = 3)
// Begin line 2803
  setline(2803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe10474 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10475 = callmethodflags(self, "isUse", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10474);
// compiled member node returning call10475 (depth = 6)
  Object if10473 = done;
struct StackFrameObject *iftmpstackframe10473 = stackframe;
  if (istrue(call10475)) {
stackframe = alloc_StackFrame(0, iftmpstackframe10473);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile string node (depth = 6)
  if (strlit10476 == NULL) {
    strlit10476 = alloc_String("use ");
    gc_root(strlit10476);
  }
// compiled string node returning strlit10476 (depth = 6)
    gc_frame_newslot(strlit10476);
    if10473 = strlit10476;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe10473);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile string node (depth = 6)
  if (strlit10477 == NULL) {
    strlit10477 = alloc_String("inherit ");
    gc_root(strlit10477);
  }
// compiled string node returning strlit10477 (depth = 6)
    gc_frame_newslot(strlit10477);
    if10473 = strlit10477;
  }
stackframe = iftmpstackframe10473;
// compiled if node returning if10473 (depth = 5)
  int op_slot_right_10472 = gc_frame_newslot(if10473);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_10472 = gc_frame_newslot(*var_s);
  params[0] = if10473;
  partcv[0] = 1;
  Object opresult10479 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10479 (depth = 4)
  *var_s = opresult10479;
  if (opresult10479 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2804
  setline(2804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10482 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num10483 = alloc_Float64(0);
// compiled num node returning num10483 (depth = 6)
  gc_frame_newslot(num10483);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10484 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10485 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10484);
// compiled member node returning call10485 (depth = 6)
  params[0] = num10483;
  partcv[0] = 1;
  Object call10486 = callmethodflags(call10485, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10482);
// compiled call node returning call10486 (depth = 5)
  int op_slot_right_10481 = gc_frame_newslot(call10486);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_10481 = gc_frame_newslot(*var_s);
  params[0] = call10486;
  partcv[0] = 1;
  Object opresult10488 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10488 (depth = 4)
  *var_s = opresult10488;
  if (opresult10488 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2805
  setline(2805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10490 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block10491 = alloc_Block(NULL, NULL, "ast", 2805);
  gc_frame_newslot(block10491);
// method "_apply(_)"
  block_savedest(block10491);
  Object closure10492 = createclosure(2, "_apply(1)");
  setclosureframe(closure10492, stackframe);
  addtoclosure(closure10492, var_s);
  addtoclosure(closure10492, selfslot);
  struct UserObject *uo10492 = (struct UserObject*)block10491;
  uo10492->data[0] = (Object)closure10492;
  Method *meth_meth_ast_10492__apply_40_1_41_ = addmethod2pos(block10491, "_apply(1)", &meth_ast_10492__apply_40_1_41_, 0);
  int argcv_meth_ast_10492__apply_40_1_41_[] = {1};
  meth_meth_ast_10492__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10492__apply_40_1_41_);
  meth_meth_ast_10492__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10492__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block10491 (depth = 4)
  gc_frame_newslot(block10491);
// call case 6: other requests
// Begin line 2805
  setline(2805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe10510 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10511 = callmethodflags(self, "aliases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10510);
// compiled member node returning call10511 (depth = 4)
  params[0] = block10491;
  partcv[0] = 1;
  Object call10512 = callmethodflags(call10511, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10490);
// compiled call node returning call10512 (depth = 3)
// Begin line 2808
  setline(2808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10513 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block10514 = alloc_Block(NULL, NULL, "ast", 2808);
  gc_frame_newslot(block10514);
// method "_apply(_)"
  block_savedest(block10514);
  Object closure10515 = createclosure(2, "_apply(1)");
  setclosureframe(closure10515, stackframe);
  addtoclosure(closure10515, var_s);
  addtoclosure(closure10515, selfslot);
  struct UserObject *uo10515 = (struct UserObject*)block10514;
  uo10515->data[0] = (Object)closure10515;
  Method *meth_meth_ast_10515__apply_40_1_41_ = addmethod2pos(block10514, "_apply(1)", &meth_ast_10515__apply_40_1_41_, 0);
  int argcv_meth_ast_10515__apply_40_1_41_[] = {1};
  meth_meth_ast_10515__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10515__apply_40_1_41_);
  meth_meth_ast_10515__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10515__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block10514 (depth = 4)
  gc_frame_newslot(block10514);
// call case 6: other requests
// Begin line 2808
  setline(2808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe10535 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10536 = callmethodflags(self, "exclusions", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10535);
// compiled member node returning call10536 (depth = 4)
  params[0] = block10514;
  partcv[0] = 1;
  Object call10537 = callmethodflags(call10536, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10513);
// compiled call node returning call10537 (depth = 3)
// Begin line 2811
  setline(2811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_10538_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2814
  setline(2814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10540 = gc_frame_new();
// starting to compile num node (depth = 5)
  Object num10541 = alloc_Float64(0);
// compiled num node returning num10541 (depth = 5)
  gc_frame_newslot(num10541);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10542 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10543 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10542);
// compiled member node returning call10543 (depth = 5)
  params[0] = num10541;
  partcv[0] = 1;
  Object call10544 = callmethodflags(call10543, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10540);
// compiled call node returning call10544 (depth = 4)
  int op_slot_right_10539 = gc_frame_newslot(call10544);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10547 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10548 = callmethodflags(self, "isUse", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10547);
// compiled member node returning call10548 (depth = 5)
  Object if10546 = done;
struct StackFrameObject *iftmpstackframe10546 = stackframe;
  if (istrue(call10548)) {
stackframe = alloc_StackFrame(0, iftmpstackframe10546);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile string node (depth = 5)
  if (strlit10549 == NULL) {
    strlit10549 = alloc_String("use ");
    gc_root(strlit10549);
  }
// compiled string node returning strlit10549 (depth = 5)
    gc_frame_newslot(strlit10549);
    if10546 = strlit10549;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe10546);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile string node (depth = 5)
  if (strlit10550 == NULL) {
    strlit10550 = alloc_String("inherit ");
    gc_root(strlit10550);
  }
// compiled string node returning strlit10550 (depth = 5)
    gc_frame_newslot(strlit10550);
    if10546 = strlit10550;
  }
stackframe = iftmpstackframe10546;
// compiled if node returning if10546 (depth = 4)
  int op_slot_left_10539 = gc_frame_newslot(if10546);
  params[0] = call10544;
  partcv[0] = 1;
  Object opresult10551 = callmethod(if10546, "++(1)", 1, partcv, params);
// compiled op node returning opresult10551 (depth = 3)
  gc_frame_end(frame);
  return opresult10551;
}
Object meth_ast_10552_nameString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2816
  setline(2816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10553 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num10554 = alloc_Float64(0);
// compiled num node returning num10554 (depth = 4)
  gc_frame_newslot(num10554);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe10555 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10556 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10555);
// compiled member node returning call10556 (depth = 4)
  params[0] = num10554;
  partcv[0] = 1;
  Object call10557 = callmethodflags(call10556, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10553);
// compiled call node returning call10557 (depth = 3)
  gc_frame_end(frame);
  return call10557;
}
Object meth_ast_10558_addAlias_40_1_41_for_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAlias(1)for(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAlias(_)for(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAlias(_)for(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for addAlias(_)for(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_newName = &(stackframe->slots[0]);
  *var_newName = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addAlias(_)");
  Object *var_oldName = &(stackframe->slots[1]);
  *var_oldName = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part for(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2818
  setline(2818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10559 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe10560 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newName (depth = 5)
  gc_frame_newslot(*var_newName);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_oldName (depth = 5)
  gc_frame_newslot(*var_oldName);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = *var_newName;
  params[1] = *var_oldName;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10561 = callmethodflags(module_ast, "aliasNew(1)old(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10560);
// compiled call node returning call10561 (depth = 4)
  gc_frame_newslot(call10561);
// call case 6: other requests
// Begin line 2818
  setline(2818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe10562 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10563 = callmethodflags(self, "aliases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10562);
// compiled member node returning call10563 (depth = 4)
  params[0] = call10561;
  partcv[0] = 1;
  Object call10564 = callmethodflags(call10563, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10559);
// compiled call node returning call10564 (depth = 3)
  gc_frame_end(frame);
  return call10564;
}
Object meth_ast_10565_addExclusion_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addExclusion(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addExclusion(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addExclusion(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ident = &(stackframe->slots[0]);
  *var_ident = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addExclusion(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2821
  setline(2821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10566 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ident (depth = 4)
  gc_frame_newslot(*var_ident);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe10567 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10568 = callmethodflags(self, "exclusions", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10567);
// compiled member node returning call10568 (depth = 4)
  params[0] = *var_ident;
  partcv[0] = 1;
  Object call10569 = callmethodflags(call10568, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10566);
// compiled call node returning call10569 (depth = 3)
  gc_frame_end(frame);
  return call10569;
}
Object meth_ast_10570_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_inheritNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2824
  setline(2824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10571 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe10572 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_inheritNode (depth = 5)
  params[0] = *var_nullNode;
  partcv[0] = 1;
  Object call10573 = callmethodflags(*var_inheritNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10572);
// compiled call node returning call10573 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call10574 = callmethodflags(call10573, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10571);
// compiled call node returning call10574 (depth = 3)
  gc_frame_end(frame);
  return call10574;
}
Object meth_ast_10575_postCopy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "postCopy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method postCopy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for postCopy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part postCopy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2827
  setline(2827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10576 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10577 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call10578 = callmethodflags(*var_other, "providedNames", 1, partcv, params, 0);
  gc_frame_end(callframe10577);
// compiled member node returning call10578 (depth = 4)
  gc_frame_newslot(call10578);
// call case 4: self request
  params[0] = call10578;
  partcv[0] = 1;
  Object call10579 = callmethodflags(self, "providedNames:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10576);
// compiled call node returning call10579 (depth = 3)
// Begin line 2828
  setline(2828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10580 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10581 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call10582 = callmethodflags(*var_other, "aliases", 1, partcv, params, 0);
  gc_frame_end(callframe10581);
// compiled member node returning call10582 (depth = 4)
  gc_frame_newslot(call10582);
// call case 4: self request
  params[0] = call10582;
  partcv[0] = 1;
  Object call10583 = callmethodflags(self, "aliases:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10580);
// compiled call node returning call10583 (depth = 3)
// Begin line 2829
  setline(2829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10584 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10585 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call10586 = callmethodflags(*var_other, "exclusions", 1, partcv, params, 0);
  gc_frame_end(callframe10585);
// compiled member node returning call10586 (depth = 4)
  gc_frame_newslot(call10586);
// call case 4: self request
  params[0] = call10586;
  partcv[0] = 1;
  Object call10587 = callmethodflags(self, "exclusions:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10584);
// compiled call node returning call10587 (depth = 3)
// Begin line 2830
  setline(2830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10588 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10589 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call10590 = callmethodflags(*var_other, "isUse", 1, partcv, params, 0);
  gc_frame_end(callframe10589);
// compiled member node returning call10590 (depth = 4)
  gc_frame_newslot(call10590);
// call case 4: self request
  params[0] = call10590;
  partcv[0] = 1;
  Object call10591 = callmethodflags(self, "isUse:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10588);
// compiled call node returning call10591 (depth = 3)
// Begin line 2831
  setline(2831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_10592_statementName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 2834
  setline(2834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10594 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10595 = callmethodflags(self, "isUse", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10594);
// compiled member node returning call10595 (depth = 4)
  Object if10593 = done;
  if (istrue(call10595)) {
// starting to compile string node (depth = 4)
  if (strlit10596 == NULL) {
    strlit10596 = alloc_String("use");
    gc_root(strlit10596);
  }
// compiled string node returning strlit10596 (depth = 4)
    gc_frame_newslot(strlit10596);
    if10593 = strlit10596;
  } else {
// starting to compile string node (depth = 4)
  if (strlit10597 == NULL) {
    strlit10597 = alloc_String("inherit");
    gc_root(strlit10597);
  }
// compiled string node returning strlit10597 (depth = 4)
    gc_frame_newslot(strlit10597);
    if10593 = strlit10597;
  }
// compiled if node returning if10593 (depth = 3)
  gc_frame_end(frame);
  return if10593;
}
Object meth_ast_10234_new_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_inheritNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10235 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10235 = alloc_userobj2(29,25, objclass10235);
  gc_frame_newslot(obj10235);
  if (objclass10235 == NULL) {
    glfree(obj10235->class->name);
    obj10235->class->name = "inheritNode.new(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj10235, self, 0);
  addmethodreal(obj10235,"outer", &reader_ast_outer_10236);
  Object oldself10235 = self;
  struct StackFrameObject *oldstackframe10235 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10235);
  gc_frame_newslot((Object)stackframe);
  self = obj10235;
  Object *oldselfslot10235 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10235 = (*(struct UserObject *)self).data[0], lowerouter10235 = thisouter10235;
  if (inheritingObject10235) {
    struct UserObject *inho10235 = (struct UserObject *)inheritingObject10235;
    while (inho10235->super != GraceDefaultObject) inho10235 = (struct UserObject *)inho10235->super;
    inho10235->super = obj10235;
    self = inheritingObject10235;
    *selfslot = self;
    lowerouter10235 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10235;
  }
  if (objclass10235 == NULL) {
  Method *reader10237 = addmethodrealflags(obj10235, "kind",&reader_ast_kind_10237, MFLAG_DEF);
  reader10237->definitionModule = modulename;
  reader10237->definitionLine = 2745;
  }
  adddatum2(obj10235, alloc_Undefined(), 1);
  if (objclass10235 == NULL) {
    Method *reader10238 = addmethodrealflags(obj10235, "value", &reader_ast_value_10238, 0);
    Method *writer10238 = addmethodrealflags(obj10235, "value:=(1)", &writer_ast_value_10238, 0);
    reader10238->definitionModule = modulename;
    writer10238->definitionModule = modulename;
    reader10238->definitionLine = 2746;
    writer10238->definitionLine = 2746;
  }
  obj10235->flags |= OFLAG_MUTABLE;
  adddatum2(obj10235, alloc_Undefined(), 2);
  if (objclass10235 == NULL) {
    Method *reader10239 = addmethodrealflags(obj10235, "providedNames", &reader_ast_providedNames_10239, 0);
    Method *writer10239 = addmethodrealflags(obj10235, "providedNames:=(1)", &writer_ast_providedNames_10239, 0);
    reader10239->definitionModule = modulename;
    writer10239->definitionModule = modulename;
    reader10239->definitionLine = 2747;
    writer10239->definitionLine = 2747;
  }
  obj10235->flags |= OFLAG_MUTABLE;
  adddatum2(obj10235, alloc_Undefined(), 3);
  if (objclass10235 == NULL) {
    Method *reader10240 = addmethodrealflags(obj10235, "aliases", &reader_ast_aliases_10240, 0);
    Method *writer10240 = addmethodrealflags(obj10235, "aliases:=(1)", &writer_ast_aliases_10240, 0);
    reader10240->definitionModule = modulename;
    writer10240->definitionModule = modulename;
    reader10240->definitionLine = 2748;
    writer10240->definitionLine = 2748;
  }
  obj10235->flags |= OFLAG_MUTABLE;
  adddatum2(obj10235, alloc_Undefined(), 4);
  if (objclass10235 == NULL) {
    Method *reader10241 = addmethodrealflags(obj10235, "exclusions", &reader_ast_exclusions_10241, 0);
    Method *writer10241 = addmethodrealflags(obj10235, "exclusions:=(1)", &writer_ast_exclusions_10241, 0);
    reader10241->definitionModule = modulename;
    writer10241->definitionModule = modulename;
    reader10241->definitionLine = 2749;
    writer10241->definitionLine = 2749;
  }
  obj10235->flags |= OFLAG_MUTABLE;
  adddatum2(obj10235, alloc_Undefined(), 5);
  if (objclass10235 == NULL) {
    Method *reader10242 = addmethodrealflags(obj10235, "isUse", &reader_ast_isUse_10242, 0);
    Method *writer10242 = addmethodrealflags(obj10235, "isUse:=(1)", &writer_ast_isUse_10242, 0);
    reader10242->definitionModule = modulename;
    writer10242->definitionModule = modulename;
    reader10242->definitionLine = 2750;
    writer10242->definitionLine = 2750;
  }
  obj10235->flags |= OFLAG_MUTABLE;
  adddatum2(obj10235, alloc_Undefined(), 6);
// method "end"
  struct UserObject *uo10243 = (struct UserObject*)obj10235;
  uo10243->data[7] = emptyclosure;
  Method *meth_meth_ast_10243_end = addmethod2pos(obj10235, "end", &meth_ast_10243_end, 7);
  int argcv_meth_ast_10243_end[] = {0};
  meth_meth_ast_10243_end->type = alloc_MethodType(1, argcv_meth_ast_10243_end);
  meth_meth_ast_10243_end->definitionModule = modulename;
  meth_meth_ast_10243_end->definitionLine = 2752;
// method "isLegalInTrait"
  struct UserObject *uo10248 = (struct UserObject*)obj10235;
  uo10248->data[8] = emptyclosure;
  Method *meth_meth_ast_10248_isLegalInTrait = addmethod2pos(obj10235, "isLegalInTrait", &meth_ast_10248_isLegalInTrait, 8);
  int argcv_meth_ast_10248_isLegalInTrait[] = {0};
  meth_meth_ast_10248_isLegalInTrait->type = alloc_MethodType(1, argcv_meth_ast_10248_isLegalInTrait);
  meth_meth_ast_10248_isLegalInTrait->definitionModule = modulename;
  meth_meth_ast_10248_isLegalInTrait->definitionLine = 2753;
// method "isInherits"
  struct UserObject *uo10251 = (struct UserObject*)obj10235;
  uo10251->data[9] = emptyclosure;
  Method *meth_meth_ast_10251_isInherits = addmethod2pos(obj10235, "isInherits", &meth_ast_10251_isInherits, 9);
  int argcv_meth_ast_10251_isInherits[] = {0};
  meth_meth_ast_10251_isInherits->type = alloc_MethodType(1, argcv_meth_ast_10251_isInherits);
  meth_meth_ast_10251_isInherits->definitionModule = modulename;
  meth_meth_ast_10251_isInherits->definitionLine = 2754;
// method "inheritFromMember"
  struct UserObject *uo10253 = (struct UserObject*)obj10235;
  uo10253->data[10] = emptyclosure;
  Method *meth_meth_ast_10253_inheritFromMember = addmethod2pos(obj10235, "inheritFromMember", &meth_ast_10253_inheritFromMember, 10);
  int argcv_meth_ast_10253_inheritFromMember[] = {0};
  meth_meth_ast_10253_inheritFromMember->type = alloc_MethodType(1, argcv_meth_ast_10253_inheritFromMember);
  meth_meth_ast_10253_inheritFromMember->definitionModule = modulename;
  meth_meth_ast_10253_inheritFromMember->definitionLine = 2755;
// method "inheritFromCall"
  struct UserObject *uo10258 = (struct UserObject*)obj10235;
  uo10258->data[11] = emptyclosure;
  Method *meth_meth_ast_10258_inheritFromCall = addmethod2pos(obj10235, "inheritFromCall", &meth_ast_10258_inheritFromCall, 11);
  int argcv_meth_ast_10258_inheritFromCall[] = {0};
  meth_meth_ast_10258_inheritFromCall->type = alloc_MethodType(1, argcv_meth_ast_10258_inheritFromCall);
  meth_meth_ast_10258_inheritFromCall->definitionModule = modulename;
  meth_meth_ast_10258_inheritFromCall->definitionLine = 2756;
// method "isExecutable"
  struct UserObject *uo10263 = (struct UserObject*)obj10235;
  uo10263->data[12] = emptyclosure;
  Method *meth_meth_ast_10263_isExecutable = addmethod2pos(obj10235, "isExecutable", &meth_ast_10263_isExecutable, 12);
  int argcv_meth_ast_10263_isExecutable[] = {0};
  meth_meth_ast_10263_isExecutable->type = alloc_MethodType(1, argcv_meth_ast_10263_isExecutable);
  meth_meth_ast_10263_isExecutable->definitionModule = modulename;
  meth_meth_ast_10263_isExecutable->definitionLine = 2757;
// method "accept(_)from(_)"
  struct UserObject *uo10265 = (struct UserObject*)obj10235;
  uo10265->data[13] = emptyclosure;
  Method *meth_meth_ast_10265_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj10235, "accept(1)from(1)", &meth_ast_10265_accept_40_1_41_from_40_1_41_, 13);
  int argcv_meth_ast_10265_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_10265_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_10265_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_10265_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10265_accept_40_1_41_from_40_1_41_->definitionLine = 2758;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj10235);
  Object closure10299 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure10299, stackframe);
  addtoclosure(closure10299, var_k);
  struct UserObject *uo10299 = (struct UserObject*)obj10235;
  uo10299->data[14] = (Object)closure10299;
  Method *meth_meth_ast_10299_declarationKindWithAncestors_40_1_41_ = addmethod2pos(obj10235, "declarationKindWithAncestors(1)", &meth_ast_10299_declarationKindWithAncestors_40_1_41_, 14);
  int argcv_meth_ast_10299_declarationKindWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_10299_declarationKindWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10299_declarationKindWithAncestors_40_1_41_);
  meth_meth_ast_10299_declarationKindWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10299_declarationKindWithAncestors_40_1_41_->definitionLine = 2769;
// method "map(_)ancestors(_)"
  struct UserObject *uo10302 = (struct UserObject*)obj10235;
  uo10302->data[15] = emptyclosure;
  Method *meth_meth_ast_10302_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj10235, "map(1)ancestors(1)", &meth_ast_10302_map_40_1_41_ancestors_40_1_41_, 15);
  int argcv_meth_ast_10302_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_10302_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_10302_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_10302_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10302_map_40_1_41_ancestors_40_1_41_->definitionLine = 2775;
// method "pretty(_)"
  struct UserObject *uo10315 = (struct UserObject*)obj10235;
  uo10315->data[16] = emptyclosure;
  Method *meth_meth_ast_10315_pretty_40_1_41_ = addmethod2pos(obj10235, "pretty(1)", &meth_ast_10315_pretty_40_1_41_, 16);
  int argcv_meth_ast_10315_pretty_40_1_41_[] = {1};
  meth_meth_ast_10315_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10315_pretty_40_1_41_);
  meth_meth_ast_10315_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10315_pretty_40_1_41_->definitionLine = 2781;
// method "toGrace(_)"
  struct UserObject *uo10460 = (struct UserObject*)obj10235;
  uo10460->data[17] = emptyclosure;
  Method *meth_meth_ast_10460_toGrace_40_1_41_ = addmethod2pos(obj10235, "toGrace(1)", &meth_ast_10460_toGrace_40_1_41_, 17);
  int argcv_meth_ast_10460_toGrace_40_1_41_[] = {1};
  meth_meth_ast_10460_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10460_toGrace_40_1_41_);
meth_meth_ast_10460_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_10460_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_10460_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10460_toGrace_40_1_41_->definitionLine = 2798;
// method "asString"
  struct UserObject *uo10538 = (struct UserObject*)obj10235;
  uo10538->data[18] = emptyclosure;
  Method *meth_meth_ast_10538_asString = addmethod2pos(obj10235, "asString", &meth_ast_10538_asString, 18);
  int argcv_meth_ast_10538_asString[] = {0};
  meth_meth_ast_10538_asString->type = alloc_MethodType(1, argcv_meth_ast_10538_asString);
  meth_meth_ast_10538_asString->definitionModule = modulename;
  meth_meth_ast_10538_asString->definitionLine = 2813;
// method "nameString"
  struct UserObject *uo10552 = (struct UserObject*)obj10235;
  uo10552->data[19] = emptyclosure;
  Method *meth_meth_ast_10552_nameString = addmethod2pos(obj10235, "nameString", &meth_ast_10552_nameString, 19);
  int argcv_meth_ast_10552_nameString[] = {0};
  meth_meth_ast_10552_nameString->type = alloc_MethodType(1, argcv_meth_ast_10552_nameString);
  meth_meth_ast_10552_nameString->definitionModule = modulename;
  meth_meth_ast_10552_nameString->definitionLine = 2816;
// method "addAlias(_)for(_)"
  struct UserObject *uo10558 = (struct UserObject*)obj10235;
  uo10558->data[20] = emptyclosure;
  Method *meth_meth_ast_10558_addAlias_40_1_41_for_40_1_41_ = addmethod2pos(obj10235, "addAlias(1)for(1)", &meth_ast_10558_addAlias_40_1_41_for_40_1_41_, 20);
  int argcv_meth_ast_10558_addAlias_40_1_41_for_40_1_41_[] = {1, 1};
  meth_meth_ast_10558_addAlias_40_1_41_for_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_10558_addAlias_40_1_41_for_40_1_41_);
  meth_meth_ast_10558_addAlias_40_1_41_for_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10558_addAlias_40_1_41_for_40_1_41_->definitionLine = 2817;
// method "addExclusion(_)"
  struct UserObject *uo10565 = (struct UserObject*)obj10235;
  uo10565->data[21] = emptyclosure;
  Method *meth_meth_ast_10565_addExclusion_40_1_41_ = addmethod2pos(obj10235, "addExclusion(1)", &meth_ast_10565_addExclusion_40_1_41_, 21);
  int argcv_meth_ast_10565_addExclusion_40_1_41_[] = {1};
  meth_meth_ast_10565_addExclusion_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10565_addExclusion_40_1_41_);
  meth_meth_ast_10565_addExclusion_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10565_addExclusion_40_1_41_->definitionLine = 2820;
// method "shallowCopy"
  block_savedest(obj10235);
  Object closure10570 = createclosure(2, "shallowCopy");
  setclosureframe(closure10570, stackframe);
  addtoclosure(closure10570, var_nullNode);
  addtoclosure(closure10570, var_inheritNode);
  struct UserObject *uo10570 = (struct UserObject*)obj10235;
  uo10570->data[22] = (Object)closure10570;
  Method *meth_meth_ast_10570_shallowCopy = addmethod2pos(obj10235, "shallowCopy", &meth_ast_10570_shallowCopy, 22);
  int argcv_meth_ast_10570_shallowCopy[] = {0};
  meth_meth_ast_10570_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_10570_shallowCopy);
  meth_meth_ast_10570_shallowCopy->definitionModule = modulename;
  meth_meth_ast_10570_shallowCopy->definitionLine = 2823;
// method "postCopy(_)"
  struct UserObject *uo10575 = (struct UserObject*)obj10235;
  uo10575->data[23] = emptyclosure;
  Method *meth_meth_ast_10575_postCopy_40_1_41_ = addmethod2pos(obj10235, "postCopy(1)", &meth_ast_10575_postCopy_40_1_41_, 23);
  int argcv_meth_ast_10575_postCopy_40_1_41_[] = {1};
  meth_meth_ast_10575_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10575_postCopy_40_1_41_);
  meth_meth_ast_10575_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10575_postCopy_40_1_41_->definitionLine = 2826;
// method "statementName"
  struct UserObject *uo10592 = (struct UserObject*)obj10235;
  uo10592->data[24] = emptyclosure;
  Method *meth_meth_ast_10592_statementName = addmethod2pos(obj10235, "statementName", &meth_ast_10592_statementName, 24);
  int argcv_meth_ast_10592_statementName[] = {0};
  meth_meth_ast_10592_statementName->type = alloc_MethodType(1, argcv_meth_ast_10592_statementName);
  meth_meth_ast_10592_statementName->definitionModule = modulename;
  meth_meth_ast_10592_statementName->definitionLine = 2833;
  sourceObject = obj10235;
// Begin line 2744
  setline(2744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10598 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10599 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10598);
// compiled call node returning call10599 (depth = 3)
  struct UserObject *obj10235_uo = (struct UserObject *)obj10235;
  obj10235_uo->super = call10599;
  sourceObject = obj10235;
// Begin line 2745
  setline(2745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10600 == NULL) {
    strlit10600 = alloc_String("inherit");
    gc_root(strlit10600);
  }
// compiled string node returning strlit10600 (depth = 3)
  adddatum2(obj10235, strlit10600, 1);
  sourceObject = obj10235;
// Begin line 2746
  setline(2746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_expr (depth = 3)
  adddatum2(obj10235, *var_expr, 2);
  sourceObject = obj10235;
// Begin line 2747
  setline(2747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe10601 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call10602 = callmethodflags(prelude, "emptySet", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10601);
// compiled member node returning call10602 (depth = 3)
  adddatum2(obj10235, call10602, 3);
  sourceObject = obj10235;
// Begin line 2748
  setline(2748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array10603 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10603 (depth = 3)
  adddatum2(obj10235, array10603, 4);
  sourceObject = obj10235;
// Begin line 2749
  setline(2749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array10604 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10604 (depth = 3)
  adddatum2(obj10235, array10604, 5);
  sourceObject = obj10235;
// Begin line 2750
  setline(2750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10605 = alloc_Boolean(0);
// compiled identifier node returning bool10605 (depth = 3)
  adddatum2(obj10235, bool10605, 6);
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  objclass10235 = obj10235->class;
  objclass10235->definitionModule = modulename;
  objclass10235->definitionLine = 2743;
  (*(struct UserObject *)self).data[0] = lowerouter10235;
  self = oldself10235;
  selfslot = oldselfslot10235;
  stackframe = oldstackframe10235;
  gc_frame_end(frame);
  return obj10235;
}
Object meth_ast_10234_new_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_inheritNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10235 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10235 = alloc_userobj2(29,25, objclass10235);
  gc_frame_newslot(obj10235);
  if (objclass10235 == NULL) {
    glfree(obj10235->class->name);
    obj10235->class->name = "inheritNode.new(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj10235, self, 0);
  addmethodreal(obj10235,"outer", &reader_ast_outer_10236);
  Object oldself10235 = self;
  struct StackFrameObject *oldstackframe10235 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10235);
  gc_frame_newslot((Object)stackframe);
  self = obj10235;
  Object *oldselfslot10235 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10235 = (*(struct UserObject *)self).data[0], lowerouter10235 = thisouter10235;
  if (inheritingObject10235) {
    struct UserObject *inho10235 = (struct UserObject *)inheritingObject10235;
    while (inho10235->super != GraceDefaultObject) inho10235 = (struct UserObject *)inho10235->super;
    inho10235->super = obj10235;
    self = inheritingObject10235;
    *selfslot = self;
    lowerouter10235 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10235;
  }
  if (objclass10235 == NULL) {
  Method *reader10237 = addmethodrealflags(obj10235, "kind",&reader_ast_kind_10237, MFLAG_DEF);
  reader10237->definitionModule = modulename;
  reader10237->definitionLine = 2745;
  }
  adddatum2(obj10235, alloc_Undefined(), 1);
  if (objclass10235 == NULL) {
    Method *reader10238 = addmethodrealflags(obj10235, "value", &reader_ast_value_10238, 0);
    Method *writer10238 = addmethodrealflags(obj10235, "value:=(1)", &writer_ast_value_10238, 0);
    reader10238->definitionModule = modulename;
    writer10238->definitionModule = modulename;
    reader10238->definitionLine = 2746;
    writer10238->definitionLine = 2746;
  }
  obj10235->flags |= OFLAG_MUTABLE;
  adddatum2(obj10235, alloc_Undefined(), 2);
  if (objclass10235 == NULL) {
    Method *reader10239 = addmethodrealflags(obj10235, "providedNames", &reader_ast_providedNames_10239, 0);
    Method *writer10239 = addmethodrealflags(obj10235, "providedNames:=(1)", &writer_ast_providedNames_10239, 0);
    reader10239->definitionModule = modulename;
    writer10239->definitionModule = modulename;
    reader10239->definitionLine = 2747;
    writer10239->definitionLine = 2747;
  }
  obj10235->flags |= OFLAG_MUTABLE;
  adddatum2(obj10235, alloc_Undefined(), 3);
  if (objclass10235 == NULL) {
    Method *reader10240 = addmethodrealflags(obj10235, "aliases", &reader_ast_aliases_10240, 0);
    Method *writer10240 = addmethodrealflags(obj10235, "aliases:=(1)", &writer_ast_aliases_10240, 0);
    reader10240->definitionModule = modulename;
    writer10240->definitionModule = modulename;
    reader10240->definitionLine = 2748;
    writer10240->definitionLine = 2748;
  }
  obj10235->flags |= OFLAG_MUTABLE;
  adddatum2(obj10235, alloc_Undefined(), 4);
  if (objclass10235 == NULL) {
    Method *reader10241 = addmethodrealflags(obj10235, "exclusions", &reader_ast_exclusions_10241, 0);
    Method *writer10241 = addmethodrealflags(obj10235, "exclusions:=(1)", &writer_ast_exclusions_10241, 0);
    reader10241->definitionModule = modulename;
    writer10241->definitionModule = modulename;
    reader10241->definitionLine = 2749;
    writer10241->definitionLine = 2749;
  }
  obj10235->flags |= OFLAG_MUTABLE;
  adddatum2(obj10235, alloc_Undefined(), 5);
  if (objclass10235 == NULL) {
    Method *reader10242 = addmethodrealflags(obj10235, "isUse", &reader_ast_isUse_10242, 0);
    Method *writer10242 = addmethodrealflags(obj10235, "isUse:=(1)", &writer_ast_isUse_10242, 0);
    reader10242->definitionModule = modulename;
    writer10242->definitionModule = modulename;
    reader10242->definitionLine = 2750;
    writer10242->definitionLine = 2750;
  }
  obj10235->flags |= OFLAG_MUTABLE;
  adddatum2(obj10235, alloc_Undefined(), 6);
// method "end"
  struct UserObject *uo10243 = (struct UserObject*)obj10235;
  uo10243->data[7] = emptyclosure;
  Method *meth_meth_ast_10243_end = addmethod2pos(obj10235, "end", &meth_ast_10243_end, 7);
  int argcv_meth_ast_10243_end[] = {0};
  meth_meth_ast_10243_end->type = alloc_MethodType(1, argcv_meth_ast_10243_end);
  meth_meth_ast_10243_end->definitionModule = modulename;
  meth_meth_ast_10243_end->definitionLine = 2752;
// method "isLegalInTrait"
  struct UserObject *uo10248 = (struct UserObject*)obj10235;
  uo10248->data[8] = emptyclosure;
  Method *meth_meth_ast_10248_isLegalInTrait = addmethod2pos(obj10235, "isLegalInTrait", &meth_ast_10248_isLegalInTrait, 8);
  int argcv_meth_ast_10248_isLegalInTrait[] = {0};
  meth_meth_ast_10248_isLegalInTrait->type = alloc_MethodType(1, argcv_meth_ast_10248_isLegalInTrait);
  meth_meth_ast_10248_isLegalInTrait->definitionModule = modulename;
  meth_meth_ast_10248_isLegalInTrait->definitionLine = 2753;
// method "isInherits"
  struct UserObject *uo10251 = (struct UserObject*)obj10235;
  uo10251->data[9] = emptyclosure;
  Method *meth_meth_ast_10251_isInherits = addmethod2pos(obj10235, "isInherits", &meth_ast_10251_isInherits, 9);
  int argcv_meth_ast_10251_isInherits[] = {0};
  meth_meth_ast_10251_isInherits->type = alloc_MethodType(1, argcv_meth_ast_10251_isInherits);
  meth_meth_ast_10251_isInherits->definitionModule = modulename;
  meth_meth_ast_10251_isInherits->definitionLine = 2754;
// method "inheritFromMember"
  struct UserObject *uo10253 = (struct UserObject*)obj10235;
  uo10253->data[10] = emptyclosure;
  Method *meth_meth_ast_10253_inheritFromMember = addmethod2pos(obj10235, "inheritFromMember", &meth_ast_10253_inheritFromMember, 10);
  int argcv_meth_ast_10253_inheritFromMember[] = {0};
  meth_meth_ast_10253_inheritFromMember->type = alloc_MethodType(1, argcv_meth_ast_10253_inheritFromMember);
  meth_meth_ast_10253_inheritFromMember->definitionModule = modulename;
  meth_meth_ast_10253_inheritFromMember->definitionLine = 2755;
// method "inheritFromCall"
  struct UserObject *uo10258 = (struct UserObject*)obj10235;
  uo10258->data[11] = emptyclosure;
  Method *meth_meth_ast_10258_inheritFromCall = addmethod2pos(obj10235, "inheritFromCall", &meth_ast_10258_inheritFromCall, 11);
  int argcv_meth_ast_10258_inheritFromCall[] = {0};
  meth_meth_ast_10258_inheritFromCall->type = alloc_MethodType(1, argcv_meth_ast_10258_inheritFromCall);
  meth_meth_ast_10258_inheritFromCall->definitionModule = modulename;
  meth_meth_ast_10258_inheritFromCall->definitionLine = 2756;
// method "isExecutable"
  struct UserObject *uo10263 = (struct UserObject*)obj10235;
  uo10263->data[12] = emptyclosure;
  Method *meth_meth_ast_10263_isExecutable = addmethod2pos(obj10235, "isExecutable", &meth_ast_10263_isExecutable, 12);
  int argcv_meth_ast_10263_isExecutable[] = {0};
  meth_meth_ast_10263_isExecutable->type = alloc_MethodType(1, argcv_meth_ast_10263_isExecutable);
  meth_meth_ast_10263_isExecutable->definitionModule = modulename;
  meth_meth_ast_10263_isExecutable->definitionLine = 2757;
// method "accept(_)from(_)"
  struct UserObject *uo10265 = (struct UserObject*)obj10235;
  uo10265->data[13] = emptyclosure;
  Method *meth_meth_ast_10265_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj10235, "accept(1)from(1)", &meth_ast_10265_accept_40_1_41_from_40_1_41_, 13);
  int argcv_meth_ast_10265_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_10265_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_10265_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_10265_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10265_accept_40_1_41_from_40_1_41_->definitionLine = 2758;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj10235);
  Object closure10299 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure10299, stackframe);
  addtoclosure(closure10299, var_k);
  struct UserObject *uo10299 = (struct UserObject*)obj10235;
  uo10299->data[14] = (Object)closure10299;
  Method *meth_meth_ast_10299_declarationKindWithAncestors_40_1_41_ = addmethod2pos(obj10235, "declarationKindWithAncestors(1)", &meth_ast_10299_declarationKindWithAncestors_40_1_41_, 14);
  int argcv_meth_ast_10299_declarationKindWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_10299_declarationKindWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10299_declarationKindWithAncestors_40_1_41_);
  meth_meth_ast_10299_declarationKindWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10299_declarationKindWithAncestors_40_1_41_->definitionLine = 2769;
// method "map(_)ancestors(_)"
  struct UserObject *uo10302 = (struct UserObject*)obj10235;
  uo10302->data[15] = emptyclosure;
  Method *meth_meth_ast_10302_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj10235, "map(1)ancestors(1)", &meth_ast_10302_map_40_1_41_ancestors_40_1_41_, 15);
  int argcv_meth_ast_10302_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_10302_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_10302_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_10302_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10302_map_40_1_41_ancestors_40_1_41_->definitionLine = 2775;
// method "pretty(_)"
  struct UserObject *uo10315 = (struct UserObject*)obj10235;
  uo10315->data[16] = emptyclosure;
  Method *meth_meth_ast_10315_pretty_40_1_41_ = addmethod2pos(obj10235, "pretty(1)", &meth_ast_10315_pretty_40_1_41_, 16);
  int argcv_meth_ast_10315_pretty_40_1_41_[] = {1};
  meth_meth_ast_10315_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10315_pretty_40_1_41_);
  meth_meth_ast_10315_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10315_pretty_40_1_41_->definitionLine = 2781;
// method "toGrace(_)"
  struct UserObject *uo10460 = (struct UserObject*)obj10235;
  uo10460->data[17] = emptyclosure;
  Method *meth_meth_ast_10460_toGrace_40_1_41_ = addmethod2pos(obj10235, "toGrace(1)", &meth_ast_10460_toGrace_40_1_41_, 17);
  int argcv_meth_ast_10460_toGrace_40_1_41_[] = {1};
  meth_meth_ast_10460_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10460_toGrace_40_1_41_);
meth_meth_ast_10460_toGrace_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_10460_toGrace_40_1_41_->type->names[0] = "depth";
  meth_meth_ast_10460_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10460_toGrace_40_1_41_->definitionLine = 2798;
// method "asString"
  struct UserObject *uo10538 = (struct UserObject*)obj10235;
  uo10538->data[18] = emptyclosure;
  Method *meth_meth_ast_10538_asString = addmethod2pos(obj10235, "asString", &meth_ast_10538_asString, 18);
  int argcv_meth_ast_10538_asString[] = {0};
  meth_meth_ast_10538_asString->type = alloc_MethodType(1, argcv_meth_ast_10538_asString);
  meth_meth_ast_10538_asString->definitionModule = modulename;
  meth_meth_ast_10538_asString->definitionLine = 2813;
// method "nameString"
  struct UserObject *uo10552 = (struct UserObject*)obj10235;
  uo10552->data[19] = emptyclosure;
  Method *meth_meth_ast_10552_nameString = addmethod2pos(obj10235, "nameString", &meth_ast_10552_nameString, 19);
  int argcv_meth_ast_10552_nameString[] = {0};
  meth_meth_ast_10552_nameString->type = alloc_MethodType(1, argcv_meth_ast_10552_nameString);
  meth_meth_ast_10552_nameString->definitionModule = modulename;
  meth_meth_ast_10552_nameString->definitionLine = 2816;
// method "addAlias(_)for(_)"
  struct UserObject *uo10558 = (struct UserObject*)obj10235;
  uo10558->data[20] = emptyclosure;
  Method *meth_meth_ast_10558_addAlias_40_1_41_for_40_1_41_ = addmethod2pos(obj10235, "addAlias(1)for(1)", &meth_ast_10558_addAlias_40_1_41_for_40_1_41_, 20);
  int argcv_meth_ast_10558_addAlias_40_1_41_for_40_1_41_[] = {1, 1};
  meth_meth_ast_10558_addAlias_40_1_41_for_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_10558_addAlias_40_1_41_for_40_1_41_);
  meth_meth_ast_10558_addAlias_40_1_41_for_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10558_addAlias_40_1_41_for_40_1_41_->definitionLine = 2817;
// method "addExclusion(_)"
  struct UserObject *uo10565 = (struct UserObject*)obj10235;
  uo10565->data[21] = emptyclosure;
  Method *meth_meth_ast_10565_addExclusion_40_1_41_ = addmethod2pos(obj10235, "addExclusion(1)", &meth_ast_10565_addExclusion_40_1_41_, 21);
  int argcv_meth_ast_10565_addExclusion_40_1_41_[] = {1};
  meth_meth_ast_10565_addExclusion_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10565_addExclusion_40_1_41_);
  meth_meth_ast_10565_addExclusion_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10565_addExclusion_40_1_41_->definitionLine = 2820;
// method "shallowCopy"
  block_savedest(obj10235);
  Object closure10570 = createclosure(2, "shallowCopy");
  setclosureframe(closure10570, stackframe);
  addtoclosure(closure10570, var_nullNode);
  addtoclosure(closure10570, var_inheritNode);
  struct UserObject *uo10570 = (struct UserObject*)obj10235;
  uo10570->data[22] = (Object)closure10570;
  Method *meth_meth_ast_10570_shallowCopy = addmethod2pos(obj10235, "shallowCopy", &meth_ast_10570_shallowCopy, 22);
  int argcv_meth_ast_10570_shallowCopy[] = {0};
  meth_meth_ast_10570_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_10570_shallowCopy);
  meth_meth_ast_10570_shallowCopy->definitionModule = modulename;
  meth_meth_ast_10570_shallowCopy->definitionLine = 2823;
// method "postCopy(_)"
  struct UserObject *uo10575 = (struct UserObject*)obj10235;
  uo10575->data[23] = emptyclosure;
  Method *meth_meth_ast_10575_postCopy_40_1_41_ = addmethod2pos(obj10235, "postCopy(1)", &meth_ast_10575_postCopy_40_1_41_, 23);
  int argcv_meth_ast_10575_postCopy_40_1_41_[] = {1};
  meth_meth_ast_10575_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10575_postCopy_40_1_41_);
  meth_meth_ast_10575_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10575_postCopy_40_1_41_->definitionLine = 2826;
// method "statementName"
  struct UserObject *uo10592 = (struct UserObject*)obj10235;
  uo10592->data[24] = emptyclosure;
  Method *meth_meth_ast_10592_statementName = addmethod2pos(obj10235, "statementName", &meth_ast_10592_statementName, 24);
  int argcv_meth_ast_10592_statementName[] = {0};
  meth_meth_ast_10592_statementName->type = alloc_MethodType(1, argcv_meth_ast_10592_statementName);
  meth_meth_ast_10592_statementName->definitionModule = modulename;
  meth_meth_ast_10592_statementName->definitionLine = 2833;
  sourceObject = obj10235;
// Begin line 2744
  setline(2744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10598 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10599 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10598);
// compiled call node returning call10599 (depth = 3)
  struct UserObject *obj10235_uo = (struct UserObject *)obj10235;
  obj10235_uo->super = call10599;
  sourceObject = obj10235;
// Begin line 2745
  setline(2745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10600 == NULL) {
    strlit10600 = alloc_String("inherit");
    gc_root(strlit10600);
  }
// compiled string node returning strlit10600 (depth = 3)
  adddatum2(obj10235, strlit10600, 1);
  sourceObject = obj10235;
// Begin line 2746
  setline(2746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_expr (depth = 3)
  adddatum2(obj10235, *var_expr, 2);
  sourceObject = obj10235;
// Begin line 2747
  setline(2747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe10601 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call10602 = callmethodflags(prelude, "emptySet", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10601);
// compiled member node returning call10602 (depth = 3)
  adddatum2(obj10235, call10602, 3);
  sourceObject = obj10235;
// Begin line 2748
  setline(2748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array10603 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10603 (depth = 3)
  adddatum2(obj10235, array10603, 4);
  sourceObject = obj10235;
// Begin line 2749
  setline(2749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array10604 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10604 (depth = 3)
  adddatum2(obj10235, array10604, 5);
  sourceObject = obj10235;
// Begin line 2750
  setline(2750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10605 = alloc_Boolean(0);
// compiled identifier node returning bool10605 (depth = 3)
  adddatum2(obj10235, bool10605, 6);
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  sourceObject = obj10235;
  objclass10235 = obj10235->class;
  objclass10235->definitionModule = modulename;
  objclass10235->definitionLine = 2743;
  (*(struct UserObject *)self).data[0] = lowerouter10235;
  self = oldself10235;
  selfslot = oldselfslot10235;
  stackframe = oldstackframe10235;
  gc_frame_end(frame);
  return obj10235;
}
Object meth_ast_10607_inheritNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 55, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "inheritNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_inheritNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2737
  setline(2737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_inheritNode (depth = 3)
  gc_frame_end(frame);
  return *var_inheritNode;
}
Object meth_ast_10610_AliasPair(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 56, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "AliasPair");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_AliasPair = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2838
  setline(2838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_AliasPair (depth = 3)
  gc_frame_end(frame);
  return *var_AliasPair;
}
Object meth_ast_10613_new(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2861
  setline(2861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10614 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10615 == NULL) {
    strlit10615 = alloc_String("");
    gc_root(strlit10615);
  }
// compiled string node returning strlit10615 (depth = 4)
  gc_frame_newslot(strlit10615);
// starting to compile array node (depth = 4)
  Object array10616 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10616 (depth = 4)
  gc_frame_newslot(array10616);
// call case 4: self request
  params[0] = strlit10615;
  params[1] = array10616;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10617 = callmethodflags(self, "partName(1)params(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10614);
// compiled call node returning call10617 (depth = 3)
  gc_frame_end(frame);
  return call10617;
}
Object meth_ast_10618_partName_40_1_41_scope_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "partName(1)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName(_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName(_)scope(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for partName(_)scope(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part partName(_)");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 2864
  setline(2864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10619 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile array node (depth = 5)
  Object array10620 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10620 (depth = 5)
  gc_frame_newslot(array10620);
// call case 4: self request
  params[0] = *var_n;
  params[1] = array10620;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10621 = callmethodflags(self, "partName(1)params(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10619);
// compiled call node returning call10621 (depth = 4)
  *var_result = call10621;
  if (call10621 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2865
  setline(2865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10622 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call10623 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10622);
// compiled call node returning call10623 (depth = 3)
// Begin line 2866
  setline(2866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_10624_partName_40_1_41_params_40_1_41_scope_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "partName(1)params(1)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName(_)params(_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName(_)params(_)scope(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName(_)params(_)scope(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for partName(_)params(_)scope(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part partName(_)");
  Object *var_ps = &(stackframe->slots[1]);
  *var_ps = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part params(_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 2869
  setline(2869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10625 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ps (depth = 5)
  gc_frame_newslot(*var_ps);
// call case 4: self request
  params[0] = *var_n;
  params[1] = *var_ps;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10626 = callmethodflags(self, "partName(1)params(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10625);
// compiled call node returning call10626 (depth = 4)
  *var_result = call10626;
  if (call10626 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2870
  setline(2870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10627 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call10628 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10627);
// compiled call node returning call10628 (depth = 3)
// Begin line 2871
  setline(2871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_10629_partName_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "partName(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for partName(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part partName(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2874
  setline(2874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10630 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile array node (depth = 4)
  Object array10631 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10631 (depth = 4)
  gc_frame_newslot(array10631);
// call case 4: self request
  params[0] = *var_n;
  params[1] = array10631;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10632 = callmethodflags(self, "partName(1)params(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10630);
// compiled call node returning call10632 (depth = 3)
  gc_frame_end(frame);
  return call10632;
}
Object meth_ast_10641_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2885
  setline(2885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10643 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10644 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10645 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10646 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10645);
// compiled member node returning call10646 (depth = 6)
  partcv[0] = 0;
  Object call10647 = callmethodflags(call10646, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe10644);
// compiled member node returning call10647 (depth = 5)
  partcv[0] = 0;
  Object call10648 = callmethodflags(call10647, "not", 1, partcv, params, 0);
  gc_frame_end(callframe10643);
// compiled member node returning call10648 (depth = 4)
  Object if10642 = done;
  if (istrue(call10648)) {
// Begin line 2886
  setline(2886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10649 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10650 == NULL) {
    strlit10650 = alloc_String(")");
    gc_root(strlit10650);
  }
// compiled string node returning strlit10650 (depth = 6)
  gc_frame_newslot(strlit10650);
// starting to compile member node (depth = 6)
  int callframe10651 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe10652 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe10653 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10654 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10653);
// compiled member node returning call10654 (depth = 8)
  partcv[0] = 0;
  Object call10655 = callmethodflags(call10654, "last", 1, partcv, params, 0);
  gc_frame_end(callframe10652);
// compiled member node returning call10655 (depth = 7)
  partcv[0] = 0;
  Object call10656 = callmethodflags(call10655, "end", 1, partcv, params, 0);
  gc_frame_end(callframe10651);
// compiled member node returning call10656 (depth = 6)
  gc_frame_newslot(call10656);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_ast (depth = 6)
  params[0] = strlit10650;
  params[1] = call10656;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10657 = callmethodflags(module_ast, "positionOfNext(1)after(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10649);
// compiled call node returning call10657 (depth = 5)
  return call10657;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if10642 = undefined;
  } else {
  }
// compiled if node returning if10642 (depth = 3)
// Begin line 2888
  setline(2888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10660 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10661 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10660);
// compiled member node returning call10661 (depth = 5)
  int op_slot_right_10659 = gc_frame_newslot(call10661);
// starting to compile identifier node (depth = 5)
  Object bool10663 = alloc_Boolean(0);
// compiled identifier node returning bool10663 (depth = 5)
  int op_slot_left_10659 = gc_frame_newslot(bool10663);
  params[0] = call10661;
  partcv[0] = 1;
  Object opresult10664 = callmethod(bool10663, "≠(1)", 1, partcv, params);
// compiled op node returning opresult10664 (depth = 4)
  Object if10658 = done;
  if (istrue(opresult10664)) {
// Begin line 2889
  setline(2889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10665 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10666 == NULL) {
    strlit10666 = alloc_String("""\xe2""""\x9f""""\xa7""");
    gc_root(strlit10666);
  }
// compiled string node returning strlit10666 (depth = 6)
  gc_frame_newslot(strlit10666);
// starting to compile member node (depth = 6)
  int callframe10667 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe10668 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe10669 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10670 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10669);
// compiled member node returning call10670 (depth = 8)
  partcv[0] = 0;
  Object call10671 = callmethodflags(call10670, "last", 1, partcv, params, 0);
  gc_frame_end(callframe10668);
// compiled member node returning call10671 (depth = 7)
  partcv[0] = 0;
  Object call10672 = callmethodflags(call10671, "end", 1, partcv, params, 0);
  gc_frame_end(callframe10667);
// compiled member node returning call10672 (depth = 6)
  gc_frame_newslot(call10672);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_ast (depth = 6)
  params[0] = strlit10666;
  params[1] = call10672;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10673 = callmethodflags(module_ast, "positionOfNext(1)after(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10665);
// compiled call node returning call10673 (depth = 5)
  return call10673;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if10658 = undefined;
  } else {
  }
// compiled if node returning if10658 (depth = 3)
// Begin line 2891
  setline(2891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10674 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe10675 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10676 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10675);
// compiled member node returning call10676 (depth = 5)
  gc_frame_newslot(call10676);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num10678 = alloc_Float64(1);
// compiled num node returning num10678 (depth = 6)
  int op_slot_right_10677 = gc_frame_newslot(num10678);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe10681 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe10682 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10683 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10682);
// compiled member node returning call10683 (depth = 8)
  partcv[0] = 0;
  Object call10684 = callmethodflags(call10683, "size", 1, partcv, params, 0);
  gc_frame_end(callframe10681);
// compiled member node returning call10684 (depth = 7)
  int op_slot_right_10680 = gc_frame_newslot(call10684);
// starting to compile member node (depth = 7)
  int callframe10686 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10687 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10686);
// compiled member node returning call10687 (depth = 7)
  int op_slot_left_10680 = gc_frame_newslot(call10687);
  params[0] = call10684;
  partcv[0] = 1;
  Object sum10688 = callmethod(call10687, "+(1)", 1, partcv, params);
// compiled op node returning sum10688 (depth = 6)
  int op_slot_left_10677 = gc_frame_newslot(sum10688);
  params[0] = num10678;
  partcv[0] = 1;
  Object diff10689 = callmethod(sum10688, "-(1)", 1, partcv, params);
// compiled op node returning diff10689 (depth = 5)
  gc_frame_newslot(diff10689);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call10676;
  params[1] = diff10689;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10690 = callmethodflags(module_ast, "line(1)column(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10674);
// compiled call node returning call10690 (depth = 4)
  return call10690;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_10691_numParams(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "numParams");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2893
  setline(2893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe10692 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe10693 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10694 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10693);
// compiled member node returning call10694 (depth = 4)
  partcv[0] = 0;
  Object call10695 = callmethodflags(call10694, "size", 1, partcv, params, 0);
  gc_frame_end(callframe10692);
// compiled member node returning call10695 (depth = 3)
  gc_frame_end(frame);
  return call10695;
}
Object meth_ast_10696_nameString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 2895
  setline(2895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10698 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10699 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10700 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10699);
// compiled member node returning call10700 (depth = 5)
  partcv[0] = 0;
  Object call10701 = callmethodflags(call10700, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe10698);
// compiled member node returning call10701 (depth = 4)
  Object if10697 = done;
  if (istrue(call10701)) {
// starting to compile return node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10702 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10703 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10702);
// compiled member node returning call10703 (depth = 5)
  return call10703;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if10697 = undefined;
  } else {
  }
// compiled if node returning if10697 (depth = 3)
// Begin line 2896
  setline(2896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10705 == NULL) {
    strlit10705 = alloc_String(")");
    gc_root(strlit10705);
  }
// compiled string node returning strlit10705 (depth = 4)
  int op_slot_right_10704 = gc_frame_newslot(strlit10705);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10708 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10709 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10710 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10709);
// compiled member node returning call10710 (depth = 6)
  partcv[0] = 0;
  Object call10711 = callmethodflags(call10710, "size", 1, partcv, params, 0);
  gc_frame_end(callframe10708);
// compiled member node returning call10711 (depth = 5)
  int op_slot_right_10707 = gc_frame_newslot(call10711);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10714 == NULL) {
    strlit10714 = alloc_String("(");
    gc_root(strlit10714);
  }
// compiled string node returning strlit10714 (depth = 6)
  int op_slot_right_10713 = gc_frame_newslot(strlit10714);
// starting to compile member node (depth = 6)
  int callframe10716 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10717 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10716);
// compiled member node returning call10717 (depth = 6)
  int op_slot_left_10713 = gc_frame_newslot(call10717);
  params[0] = strlit10714;
  partcv[0] = 1;
  Object opresult10718 = callmethod(call10717, "++(1)", 1, partcv, params);
// compiled op node returning opresult10718 (depth = 5)
  int op_slot_left_10707 = gc_frame_newslot(opresult10718);
  params[0] = call10711;
  partcv[0] = 1;
  Object opresult10719 = callmethod(opresult10718, "++(1)", 1, partcv, params);
// compiled op node returning opresult10719 (depth = 4)
  int op_slot_left_10704 = gc_frame_newslot(opresult10719);
  params[0] = strlit10705;
  partcv[0] = 1;
  Object opresult10720 = callmethod(opresult10719, "++(1)", 1, partcv, params);
// compiled op node returning opresult10720 (depth = 3)
  gc_frame_end(frame);
  return opresult10720;
}
Object meth_ast_10732__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_underScores = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___2 = &(stackframe->slots[0]);
  *var___2 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10734 == NULL) {
    strlit10734 = alloc_String("_");
    gc_root(strlit10734);
  }
// compiled string node returning strlit10734 (depth = 7)
  int op_slot_right_10733 = gc_frame_newslot(strlit10734);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_underScores (depth = 7)
  int op_slot_left_10733 = gc_frame_newslot(*var_underScores);
  params[0] = strlit10734;
  partcv[0] = 1;
  Object opresult10736 = callmethod(*var_underScores, "++(1)", 1, partcv, params);
// compiled op node returning opresult10736 (depth = 6)
  *var_underScores = opresult10736;
  if (opresult10736 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_10740__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_underScores = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10742 == NULL) {
    strlit10742 = alloc_String(",");
    gc_root(strlit10742);
  }
// compiled string node returning strlit10742 (depth = 7)
  int op_slot_right_10741 = gc_frame_newslot(strlit10742);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_underScores (depth = 7)
  int op_slot_left_10741 = gc_frame_newslot(*var_underScores);
  params[0] = strlit10742;
  partcv[0] = 1;
  Object opresult10744 = callmethod(*var_underScores, "++(1)", 1, partcv, params);
// compiled op node returning opresult10744 (depth = 6)
  *var_underScores = opresult10744;
  if (opresult10744 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_10721_canonicalName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canonicalName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_underScores = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "underScores");
// Begin line 2899
  setline(2899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10723 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10724 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10725 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10724);
// compiled member node returning call10725 (depth = 5)
  partcv[0] = 0;
  Object call10726 = callmethodflags(call10725, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe10723);
// compiled member node returning call10726 (depth = 4)
  Object if10722 = done;
  if (istrue(call10726)) {
// starting to compile return node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10727 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10728 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10727);
// compiled member node returning call10728 (depth = 5)
  return call10728;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if10722 = undefined;
  } else {
  }
// compiled if node returning if10722 (depth = 3)
// Begin line 2900
  setline(2900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10729 == NULL) {
    strlit10729 = alloc_String("");
    gc_root(strlit10729);
  }
// compiled string node returning strlit10729 (depth = 4)
  *var_underScores = strlit10729;
  if (strlit10729 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2901
  setline(2901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10730 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block10731 = alloc_Block(NULL, NULL, "ast", 2901);
  gc_frame_newslot(block10731);
// method "_apply(_)"
  block_savedest(block10731);
  Object closure10732 = createclosure(2, "_apply(1)");
  setclosureframe(closure10732, stackframe);
  addtoclosure(closure10732, var_underScores);
  addtoclosure(closure10732, selfslot);
  struct UserObject *uo10732 = (struct UserObject*)block10731;
  uo10732->data[0] = (Object)closure10732;
  Method *meth_meth_ast_10732__apply_40_1_41_ = addmethod2pos(block10731, "_apply(1)", &meth_ast_10732__apply_40_1_41_, 0);
  int argcv_meth_ast_10732__apply_40_1_41_[] = {1};
  meth_meth_ast_10732__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10732__apply_40_1_41_);
  meth_meth_ast_10732__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10732__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block10731 (depth = 4)
  gc_frame_newslot(block10731);
// Begin line 2902
  setline(2902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block10739 = alloc_Block(NULL, NULL, "ast", 2902);
  gc_frame_newslot(block10739);
// method "_apply"
  block_savedest(block10739);
  Object closure10740 = createclosure(2, "_apply");
  setclosureframe(closure10740, stackframe);
  addtoclosure(closure10740, var_underScores);
  addtoclosure(closure10740, selfslot);
  struct UserObject *uo10740 = (struct UserObject*)block10739;
  uo10740->data[0] = (Object)closure10740;
  Method *meth_meth_ast_10740__apply = addmethod2pos(block10739, "_apply", &meth_ast_10740__apply, 0);
  int argcv_meth_ast_10740__apply[] = {0};
  meth_meth_ast_10740__apply->type = alloc_MethodType(1, argcv_meth_ast_10740__apply);
  meth_meth_ast_10740__apply->definitionModule = modulename;
  meth_meth_ast_10740__apply->definitionLine = 3050;
// compiled block node returning block10739 (depth = 4)
  gc_frame_newslot(block10739);
// call case 6: other requests
// Begin line 2901
  setline(2901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe10747 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10748 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10747);
// compiled member node returning call10748 (depth = 4)
  params[0] = block10731;
  params[1] = block10739;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10749 = callmethodflags(call10748, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10730);
// compiled call node returning call10749 (depth = 3)
// Begin line 2903
  setline(2903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10751 == NULL) {
    strlit10751 = alloc_String(")");
    gc_root(strlit10751);
  }
// compiled string node returning strlit10751 (depth = 4)
  int op_slot_right_10750 = gc_frame_newslot(strlit10751);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_underScores (depth = 5)
  int op_slot_right_10753 = gc_frame_newslot(*var_underScores);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10756 == NULL) {
    strlit10756 = alloc_String("(");
    gc_root(strlit10756);
  }
// compiled string node returning strlit10756 (depth = 6)
  int op_slot_right_10755 = gc_frame_newslot(strlit10756);
// starting to compile member node (depth = 6)
  int callframe10758 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10759 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10758);
// compiled member node returning call10759 (depth = 6)
  int op_slot_left_10755 = gc_frame_newslot(call10759);
  params[0] = strlit10756;
  partcv[0] = 1;
  Object opresult10760 = callmethod(call10759, "++(1)", 1, partcv, params);
// compiled op node returning opresult10760 (depth = 5)
  int op_slot_left_10753 = gc_frame_newslot(opresult10760);
  params[0] = *var_underScores;
  partcv[0] = 1;
  Object opresult10761 = callmethod(opresult10760, "++(1)", 1, partcv, params);
// compiled op node returning opresult10761 (depth = 4)
  int op_slot_left_10750 = gc_frame_newslot(opresult10761);
  params[0] = strlit10751;
  partcv[0] = 1;
  Object opresult10762 = callmethod(opresult10761, "++(1)", 1, partcv, params);
// compiled op node returning opresult10762 (depth = 3)
  gc_frame_end(frame);
  return opresult10762;
}
Object meth_ast_10771__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 6)
  int callframe10772 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10773 = callmethodflags(*var_p, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10772);
// compiled call node returning call10773 (depth = 6)
  gc_frame_end(frame);
  return call10773;
}
Object meth_ast_10763_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// definebindings:
// definebindings:
// definebindings:
// Begin line 2907
  setline(2907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10765 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10766 = callmethodflags(*var_visitor, "visitSignaturePart(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10765);
// compiled call node returning call10766 (depth = 4)
  Object if10764 = done;
  if (istrue(call10766)) {
// Begin line 2908
  setline(2908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10767 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call10768 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10767);
// compiled call node returning call10768 (depth = 5)
  *var_newChain = call10768;
  if (call10768 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2909
  setline(2909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10769 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block10770 = alloc_Block(NULL, NULL, "ast", 2909);
  gc_frame_newslot(block10770);
// method "_apply(_)"
  block_savedest(block10770);
  Object closure10771 = createclosure(3, "_apply(1)");
  setclosureframe(closure10771, stackframe);
  addtoclosure(closure10771, var_visitor);
  addtoclosure(closure10771, var_newChain);
  addtoclosure(closure10771, selfslot);
  struct UserObject *uo10771 = (struct UserObject*)block10770;
  uo10771->data[0] = (Object)closure10771;
  Method *meth_meth_ast_10771__apply_40_1_41_ = addmethod2pos(block10770, "_apply(1)", &meth_ast_10771__apply_40_1_41_, 0);
  int argcv_meth_ast_10771__apply_40_1_41_[] = {1};
  meth_meth_ast_10771__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10771__apply_40_1_41_);
  meth_meth_ast_10771__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10771__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block10770 (depth = 5)
  gc_frame_newslot(block10770);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10775 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10776 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10775);
// compiled member node returning call10776 (depth = 5)
  params[0] = block10770;
  partcv[0] = 1;
  Object call10777 = callmethodflags(call10776, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10769);
// compiled call node returning call10777 (depth = 4)
// Begin line 2910
  setline(2910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe10780 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10781 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10780);
// compiled member node returning call10781 (depth = 6)
  int op_slot_right_10779 = gc_frame_newslot(call10781);
// starting to compile identifier node (depth = 6)
  Object bool10783 = alloc_Boolean(0);
// compiled identifier node returning bool10783 (depth = 6)
  int op_slot_left_10779 = gc_frame_newslot(bool10783);
  params[0] = call10781;
  partcv[0] = 1;
  Object opresult10784 = callmethod(bool10783, "≠(1)", 1, partcv, params);
// compiled op node returning opresult10784 (depth = 5)
  Object if10778 = done;
  if (istrue(opresult10784)) {
// Begin line 2911
  setline(2911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10785 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10786 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10787 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10786);
// compiled member node returning call10787 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10788 = callmethodflags(call10787, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10785);
// compiled call node returning call10788 (depth = 5)
    gc_frame_newslot(call10788);
    if10778 = call10788;
  } else {
  }
// compiled if node returning if10778 (depth = 4)
    gc_frame_newslot(if10778);
    if10764 = if10778;
  } else {
  }
// compiled if node returning if10764 (depth = 3)
  gc_frame_end(frame);
  return if10764;
}
Object meth_ast_10789_declarationKindWithAncestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2915
  setline(2915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe10790 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  partcv[0] = 0;
  Object call10791 = callmethodflags(*var_k, "parameter", 1, partcv, params, 0);
  gc_frame_end(callframe10790);
// compiled member node returning call10791 (depth = 3)
  gc_frame_end(frame);
  return call10791;
}
Object meth_ast_10792_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_nd = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nd");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2917
  setline(2917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10793 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10794 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10793);
// compiled member node returning call10794 (depth = 4)
  *var_nd = call10794;
  if (call10794 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2918
  setline(2918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10795 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nd (depth = 5)
  gc_frame_newslot(*var_nd);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_nd;
  partcv[0] = 1;
  Object call10796 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10795);
// compiled call node returning call10796 (depth = 4)
  *var_newChain = call10796;
  if (call10796 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2919
  setline(2919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10797 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe10798 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe10799 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10800 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10799);
// compiled member node returning call10800 (depth = 5)
  gc_frame_newslot(call10800);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call10800;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call10801 = callmethodflags(module_ast, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10798);
// compiled call node returning call10801 (depth = 4)
  gc_frame_newslot(call10801);
// call case 6: other requests
// Begin line 2919
  setline(2919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nd (depth = 4)
  params[0] = call10801;
  partcv[0] = 1;
  Object call10802 = callmethodflags(*var_nd, "params:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10797);
// compiled call node returning call10802 (depth = 3)
// Begin line 2920
  setline(2920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10803 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe10804 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe10805 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10806 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10805);
// compiled member node returning call10806 (depth = 5)
  gc_frame_newslot(call10806);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call10806;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call10807 = callmethodflags(module_ast, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10804);
// compiled call node returning call10807 (depth = 4)
  gc_frame_newslot(call10807);
// call case 6: other requests
// Begin line 2920
  setline(2920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nd (depth = 4)
  params[0] = call10807;
  partcv[0] = 1;
  Object call10808 = callmethodflags(*var_nd, "typeParams:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10803);
// compiled call node returning call10808 (depth = 3)
// Begin line 2921
  setline(2921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10809 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nd (depth = 4)
  gc_frame_newslot(*var_nd);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_nd;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call10810 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe10809);
// compiled call node returning call10810 (depth = 3)
  gc_frame_end(frame);
  return call10810;
}
Object meth_ast_10866__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2928
  setline(2928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10868 == NULL) {
    strlit10868 = alloc_String("");
    gc_root(strlit10868);
  }
// compiled string node returning strlit10868 (depth = 7)
  int op_slot_right_10867 = gc_frame_newslot(strlit10868);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10871 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num10873 = alloc_Float64(2);
// compiled num node returning num10873 (depth = 10)
  int op_slot_right_10872 = gc_frame_newslot(num10873);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_10872 = gc_frame_newslot(*var_depth);
  params[0] = num10873;
  partcv[0] = 1;
  Object sum10875 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum10875 (depth = 9)
  gc_frame_newslot(sum10875);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_p (depth = 9)
  params[0] = sum10875;
  partcv[0] = 1;
  Object call10876 = callmethodflags(*var_p, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10871);
// compiled call node returning call10876 (depth = 8)
  int op_slot_right_10870 = gc_frame_newslot(call10876);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10879 == NULL) {
    strlit10879 = alloc_String("");
    gc_root(strlit10879);
  }
// compiled string node returning strlit10879 (depth = 9)
  int op_slot_right_10878 = gc_frame_newslot(strlit10879);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_10881 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit10884 == NULL) {
    strlit10884 = alloc_String("""\x0a""  ");
    gc_root(strlit10884);
  }
// compiled string node returning strlit10884 (depth = 11)
  int op_slot_right_10883 = gc_frame_newslot(strlit10884);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_right_10886 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 12)
  if (strlit10888 == NULL) {
    strlit10888 = alloc_String("");
    gc_root(strlit10888);
  }
// compiled string node returning strlit10888 (depth = 12)
  int op_slot_left_10886 = gc_frame_newslot(strlit10888);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10889 = callmethod(strlit10888, "++(1)", 1, partcv, params);
// compiled op node returning opresult10889 (depth = 11)
  int op_slot_left_10883 = gc_frame_newslot(opresult10889);
  params[0] = strlit10884;
  partcv[0] = 1;
  Object opresult10890 = callmethod(opresult10889, "++(1)", 1, partcv, params);
// compiled op node returning opresult10890 (depth = 10)
  int op_slot_left_10881 = gc_frame_newslot(opresult10890);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult10891 = callmethod(opresult10890, "++(1)", 1, partcv, params);
// compiled op node returning opresult10891 (depth = 9)
  int op_slot_left_10878 = gc_frame_newslot(opresult10891);
  params[0] = strlit10879;
  partcv[0] = 1;
  Object opresult10892 = callmethod(opresult10891, "++(1)", 1, partcv, params);
// compiled op node returning opresult10892 (depth = 8)
  int op_slot_left_10870 = gc_frame_newslot(opresult10892);
  params[0] = call10876;
  partcv[0] = 1;
  Object opresult10893 = callmethod(opresult10892, "++(1)", 1, partcv, params);
// compiled op node returning opresult10893 (depth = 7)
  int op_slot_left_10867 = gc_frame_newslot(opresult10893);
  params[0] = strlit10868;
  partcv[0] = 1;
  Object opresult10894 = callmethod(opresult10893, "++(1)", 1, partcv, params);
// compiled op node returning opresult10894 (depth = 6)
  *var_s = opresult10894;
  if (opresult10894 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_10811_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// definebindings:
// definebindings:
// Begin line 2924
  setline(2924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num10814 = alloc_Float64(1);
// compiled num node returning num10814 (depth = 6)
  int op_slot_right_10813 = gc_frame_newslot(num10814);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_10813 = gc_frame_newslot(*var_depth);
  params[0] = num10814;
  partcv[0] = 1;
  Object sum10816 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum10816 (depth = 5)
  int op_slot_right_10812 = gc_frame_newslot(sum10816);
// starting to compile string node (depth = 5)
  if (strlit10818 == NULL) {
    strlit10818 = alloc_String("  ");
    gc_root(strlit10818);
  }
// compiled string node returning strlit10818 (depth = 5)
  int op_slot_left_10812 = gc_frame_newslot(strlit10818);
  params[0] = sum10816;
  partcv[0] = 1;
  Object prod10819 = callmethod(strlit10818, "*(1)", 1, partcv, params);
// compiled op node returning prod10819 (depth = 4)
  *var_spc = prod10819;
  if (prod10819 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2925
  setline(2925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10821 == NULL) {
    strlit10821 = alloc_String("");
    gc_root(strlit10821);
  }
// compiled string node returning strlit10821 (depth = 5)
  int op_slot_right_10820 = gc_frame_newslot(strlit10821);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe10824 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10825 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10824);
// compiled member node returning call10825 (depth = 6)
  int op_slot_right_10823 = gc_frame_newslot(call10825);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10828 == NULL) {
    strlit10828 = alloc_String(": ");
    gc_root(strlit10828);
  }
// compiled string node returning strlit10828 (depth = 7)
  int op_slot_right_10827 = gc_frame_newslot(strlit10828);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10831 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call10832 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10831);
// compiled call node returning call10832 (depth = 8)
  int op_slot_right_10830 = gc_frame_newslot(call10832);
// starting to compile string node (depth = 8)
  if (strlit10834 == NULL) {
    strlit10834 = alloc_String("");
    gc_root(strlit10834);
  }
// compiled string node returning strlit10834 (depth = 8)
  int op_slot_left_10830 = gc_frame_newslot(strlit10834);
  params[0] = call10832;
  partcv[0] = 1;
  Object opresult10835 = callmethod(strlit10834, "++(1)", 1, partcv, params);
// compiled op node returning opresult10835 (depth = 7)
  int op_slot_left_10827 = gc_frame_newslot(opresult10835);
  params[0] = strlit10828;
  partcv[0] = 1;
  Object opresult10836 = callmethod(opresult10835, "++(1)", 1, partcv, params);
// compiled op node returning opresult10836 (depth = 6)
  int op_slot_left_10823 = gc_frame_newslot(opresult10836);
  params[0] = call10825;
  partcv[0] = 1;
  Object opresult10837 = callmethod(opresult10836, "++(1)", 1, partcv, params);
// compiled op node returning opresult10837 (depth = 5)
  int op_slot_left_10820 = gc_frame_newslot(opresult10837);
  params[0] = strlit10821;
  partcv[0] = 1;
  Object opresult10838 = callmethod(opresult10837, "++(1)", 1, partcv, params);
// compiled op node returning opresult10838 (depth = 4)
  *var_s = opresult10838;
  if (opresult10838 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2926
  setline(2926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10840 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10841 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10842 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10843 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10842);
// compiled member node returning call10843 (depth = 6)
  partcv[0] = 0;
  Object call10844 = callmethodflags(call10843, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe10841);
// compiled member node returning call10844 (depth = 5)
  partcv[0] = 0;
  Object call10845 = callmethodflags(call10844, "not", 1, partcv, params, 0);
  gc_frame_end(callframe10840);
// compiled member node returning call10845 (depth = 4)
  Object if10839 = done;
  if (istrue(call10845)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10847 == NULL) {
    strlit10847 = alloc_String("Parameters:");
    gc_root(strlit10847);
  }
// compiled string node returning strlit10847 (depth = 6)
  int op_slot_right_10846 = gc_frame_newslot(strlit10847);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_10849 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10852 == NULL) {
    strlit10852 = alloc_String("""\x0a""");
    gc_root(strlit10852);
  }
// compiled string node returning strlit10852 (depth = 8)
  int op_slot_right_10851 = gc_frame_newslot(strlit10852);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_10854 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit10856 == NULL) {
    strlit10856 = alloc_String("");
    gc_root(strlit10856);
  }
// compiled string node returning strlit10856 (depth = 9)
  int op_slot_left_10854 = gc_frame_newslot(strlit10856);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10857 = callmethod(strlit10856, "++(1)", 1, partcv, params);
// compiled op node returning opresult10857 (depth = 8)
  int op_slot_left_10851 = gc_frame_newslot(opresult10857);
  params[0] = strlit10852;
  partcv[0] = 1;
  Object opresult10858 = callmethod(opresult10857, "++(1)", 1, partcv, params);
// compiled op node returning opresult10858 (depth = 7)
  int op_slot_left_10849 = gc_frame_newslot(opresult10858);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult10859 = callmethod(opresult10858, "++(1)", 1, partcv, params);
// compiled op node returning opresult10859 (depth = 6)
  int op_slot_left_10846 = gc_frame_newslot(opresult10859);
  params[0] = strlit10847;
  partcv[0] = 1;
  Object opresult10860 = callmethod(opresult10859, "++(1)", 1, partcv, params);
// compiled op node returning opresult10860 (depth = 5)
  *var_s = opresult10860;
  if (opresult10860 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10839 = done;
  } else {
  }
// compiled if node returning if10839 (depth = 3)
// Begin line 2927
  setline(2927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10862 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10863 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10864 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10863);
// compiled member node returning call10864 (depth = 4)
  gc_frame_newslot(call10864);
// starting to compile block node (depth = 4)
  Object block10865 = alloc_Block(NULL, NULL, "ast", 2927);
  gc_frame_newslot(block10865);
// method "_apply(_)"
  block_savedest(block10865);
  Object closure10866 = createclosure(4, "_apply(1)");
  setclosureframe(closure10866, stackframe);
  addtoclosure(closure10866, var_depth);
  addtoclosure(closure10866, var_spc);
  addtoclosure(closure10866, var_s);
  addtoclosure(closure10866, selfslot);
  struct UserObject *uo10866 = (struct UserObject*)block10865;
  uo10866->data[0] = (Object)closure10866;
  Method *meth_meth_ast_10866__apply_40_1_41_ = addmethod2pos(block10865, "_apply(1)", &meth_ast_10866__apply_40_1_41_, 0);
  int argcv_meth_ast_10866__apply_40_1_41_[] = {1};
  meth_meth_ast_10866__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10866__apply_40_1_41_);
  meth_meth_ast_10866__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10866__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block10865 (depth = 4)
  gc_frame_newslot(block10865);
// call case 5: prelude request
  params[0] = call10864;
  params[1] = block10865;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10897 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10862);
// compiled call node returning call10897 (depth = 3)
// Begin line 2930
  setline(2930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_10915__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10916 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num10918 = alloc_Float64(1);
// compiled num node returning num10918 (depth = 9)
  int op_slot_right_10917 = gc_frame_newslot(num10918);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_10917 = gc_frame_newslot(*var_depth);
  params[0] = num10918;
  partcv[0] = 1;
  Object sum10920 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum10920 (depth = 8)
  gc_frame_newslot(sum10920);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum10920;
  partcv[0] = 1;
  Object call10921 = callmethodflags(*var_each, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10916);
// compiled call node returning call10921 (depth = 7)
  *var_s = call10921;
  if (call10921 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_10925__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10927 == NULL) {
    strlit10927 = alloc_String(", ");
    gc_root(strlit10927);
  }
// compiled string node returning strlit10927 (depth = 8)
  int op_slot_right_10926 = gc_frame_newslot(strlit10927);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_10926 = gc_frame_newslot(*var_s);
  params[0] = strlit10927;
  partcv[0] = 1;
  Object opresult10929 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10929 (depth = 7)
  *var_s = opresult10929;
  if (opresult10929 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_10898_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// definebindings:
// definebindings:
// Begin line 2933
  setline(2933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10899 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10900 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10899);
// compiled member node returning call10900 (depth = 4)
  *var_s = call10900;
  if (call10900 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2934
  setline(2934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10902 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10903 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10904 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10905 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10904);
// compiled member node returning call10905 (depth = 6)
  partcv[0] = 0;
  Object call10906 = callmethodflags(call10905, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe10903);
// compiled member node returning call10906 (depth = 5)
  partcv[0] = 0;
  Object call10907 = callmethodflags(call10906, "not", 1, partcv, params, 0);
  gc_frame_end(callframe10902);
// compiled member node returning call10907 (depth = 4)
  Object if10901 = done;
  if (istrue(call10907)) {
// Begin line 2935
  setline(2935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10909 == NULL) {
    strlit10909 = alloc_String("(");
    gc_root(strlit10909);
  }
// compiled string node returning strlit10909 (depth = 6)
  int op_slot_right_10908 = gc_frame_newslot(strlit10909);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_10908 = gc_frame_newslot(*var_s);
  params[0] = strlit10909;
  partcv[0] = 1;
  Object opresult10911 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10911 (depth = 5)
  *var_s = opresult10911;
  if (opresult10911 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2936
  setline(2936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10913 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block10914 = alloc_Block(NULL, NULL, "ast", 2936);
  gc_frame_newslot(block10914);
// method "_apply(_)"
  block_savedest(block10914);
  Object closure10915 = createclosure(3, "_apply(1)");
  setclosureframe(closure10915, stackframe);
  addtoclosure(closure10915, var_depth);
  addtoclosure(closure10915, var_s);
  addtoclosure(closure10915, selfslot);
  struct UserObject *uo10915 = (struct UserObject*)block10914;
  uo10915->data[0] = (Object)closure10915;
  Method *meth_meth_ast_10915__apply_40_1_41_ = addmethod2pos(block10914, "_apply(1)", &meth_ast_10915__apply_40_1_41_, 0);
  int argcv_meth_ast_10915__apply_40_1_41_[] = {1};
  meth_meth_ast_10915__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10915__apply_40_1_41_);
  meth_meth_ast_10915__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10915__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block10914 (depth = 5)
  gc_frame_newslot(block10914);
// Begin line 2937
  setline(2937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block10924 = alloc_Block(NULL, NULL, "ast", 2937);
  gc_frame_newslot(block10924);
// method "_apply"
  block_savedest(block10924);
  Object closure10925 = createclosure(2, "_apply");
  setclosureframe(closure10925, stackframe);
  addtoclosure(closure10925, var_s);
  addtoclosure(closure10925, selfslot);
  struct UserObject *uo10925 = (struct UserObject*)block10924;
  uo10925->data[0] = (Object)closure10925;
  Method *meth_meth_ast_10925__apply = addmethod2pos(block10924, "_apply", &meth_ast_10925__apply, 0);
  int argcv_meth_ast_10925__apply[] = {0};
  meth_meth_ast_10925__apply->type = alloc_MethodType(1, argcv_meth_ast_10925__apply);
  meth_meth_ast_10925__apply->definitionModule = modulename;
  meth_meth_ast_10925__apply->definitionLine = 3050;
// compiled block node returning block10924 (depth = 5)
  gc_frame_newslot(block10924);
// call case 6: other requests
// Begin line 2936
  setline(2936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe10932 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10933 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10932);
// compiled member node returning call10933 (depth = 5)
  params[0] = block10914;
  params[1] = block10924;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10934 = callmethodflags(call10933, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10913);
// compiled call node returning call10934 (depth = 4)
// Begin line 2938
  setline(2938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10936 == NULL) {
    strlit10936 = alloc_String(")");
    gc_root(strlit10936);
  }
// compiled string node returning strlit10936 (depth = 6)
  int op_slot_right_10935 = gc_frame_newslot(strlit10936);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_10935 = gc_frame_newslot(*var_s);
  params[0] = strlit10936;
  partcv[0] = 1;
  Object opresult10938 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10938 (depth = 5)
  *var_s = opresult10938;
  if (opresult10938 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10901 = done;
  } else {
  }
// compiled if node returning if10901 (depth = 3)
// Begin line 2940
  setline(2940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_10940_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_signaturePart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2943
  setline(2943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10941 = gc_frame_new();
// Begin line 2944
  setline(2944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 2943
  setline(2943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10942 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe10943 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10944 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10943);
// compiled member node returning call10944 (depth = 5)
  gc_frame_newslot(call10944);
// starting to compile member node (depth = 5)
  int callframe10945 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10946 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10945);
// compiled member node returning call10946 (depth = 5)
  gc_frame_newslot(call10946);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signaturePart (depth = 5)
  params[0] = call10944;
  params[1] = call10946;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10947 = callmethodflags(*var_signaturePart, "partName(1)params(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10942);
// compiled call node returning call10947 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call10948 = callmethodflags(call10947, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10941);
// compiled call node returning call10948 (depth = 3)
  gc_frame_end(frame);
  return call10948;
}
Object meth_ast_10949_postCopy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "postCopy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method postCopy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for postCopy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part postCopy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2947
  setline(2947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10950 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10951 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call10952 = callmethodflags(*var_other, "typeParams", 1, partcv, params, 0);
  gc_frame_end(callframe10951);
// compiled member node returning call10952 (depth = 4)
  gc_frame_newslot(call10952);
// call case 4: self request
  params[0] = call10952;
  partcv[0] = 1;
  Object call10953 = callmethodflags(self, "typeParams:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10950);
// compiled call node returning call10953 (depth = 3)
// Begin line 2948
  setline(2948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10954 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10955 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call10956 = callmethodflags(*var_other, "lineLength", 1, partcv, params, 0);
  gc_frame_end(callframe10955);
// compiled member node returning call10956 (depth = 4)
  gc_frame_newslot(call10956);
// call case 4: self request
  params[0] = call10956;
  partcv[0] = 1;
  Object call10957 = callmethodflags(self, "lineLength:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10954);
// compiled call node returning call10957 (depth = 3)
// Begin line 2949
  setline(2949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_10958_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2952
  setline(2952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10960 == NULL) {
    strlit10960 = alloc_String("");
    gc_root(strlit10960);
  }
// compiled string node returning strlit10960 (depth = 4)
  int op_slot_right_10959 = gc_frame_newslot(strlit10960);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10963 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10964 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10963);
// compiled member node returning call10964 (depth = 5)
  int op_slot_right_10962 = gc_frame_newslot(call10964);
// starting to compile string node (depth = 5)
  if (strlit10966 == NULL) {
    strlit10966 = alloc_String("part: ");
    gc_root(strlit10966);
  }
// compiled string node returning strlit10966 (depth = 5)
  int op_slot_left_10962 = gc_frame_newslot(strlit10966);
  params[0] = call10964;
  partcv[0] = 1;
  Object opresult10967 = callmethod(strlit10966, "++(1)", 1, partcv, params);
// compiled op node returning opresult10967 (depth = 4)
  int op_slot_left_10959 = gc_frame_newslot(opresult10967);
  params[0] = strlit10960;
  partcv[0] = 1;
  Object opresult10968 = callmethod(opresult10967, "++(1)", 1, partcv, params);
// compiled op node returning opresult10968 (depth = 3)
  gc_frame_end(frame);
  return opresult10968;
}
Object meth_ast_10633_partName_40_1_41_params_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "partName(1)params(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName(_)params(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName(_)params(_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_signaturePart = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for partName(_)params(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part partName(_)");
  Object *var_ps = &(stackframe->slots[1]);
  *var_ps = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part params(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10634 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10634 = alloc_userobj2(21,18, objclass10634);
  gc_frame_newslot(obj10634);
  if (objclass10634 == NULL) {
    glfree(obj10634->class->name);
    obj10634->class->name = "signaturePart.partName(_)params(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj10634, self, 0);
  addmethodreal(obj10634,"outer", &reader_ast_outer_10635);
  Object oldself10634 = self;
  struct StackFrameObject *oldstackframe10634 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10634);
  gc_frame_newslot((Object)stackframe);
  self = obj10634;
  Object *oldselfslot10634 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10634 = (*(struct UserObject *)self).data[0], lowerouter10634 = thisouter10634;
  if (inheritingObject10634) {
    struct UserObject *inho10634 = (struct UserObject *)inheritingObject10634;
    while (inho10634->super != GraceDefaultObject) inho10634 = (struct UserObject *)inho10634->super;
    inho10634->super = obj10634;
    self = inheritingObject10634;
    *selfslot = self;
    lowerouter10634 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10634;
  }
  if (objclass10634 == NULL) {
  Method *reader10636 = addmethodrealflags(obj10634, "kind",&reader_ast_kind_10636, MFLAG_DEF);
  reader10636->definitionModule = modulename;
  reader10636->definitionLine = 2878;
  }
  adddatum2(obj10634, alloc_Undefined(), 1);
  if (objclass10634 == NULL) {
    Method *reader10637 = addmethodrealflags(obj10634, "name", &reader_ast_name_10637, 0);
    Method *writer10637 = addmethodrealflags(obj10634, "name:=(1)", &writer_ast_name_10637, 0);
    reader10637->definitionModule = modulename;
    writer10637->definitionModule = modulename;
    reader10637->definitionLine = 2879;
    writer10637->definitionLine = 2879;
  }
  obj10634->flags |= OFLAG_MUTABLE;
  adddatum2(obj10634, alloc_Undefined(), 2);
  if (objclass10634 == NULL) {
    Method *reader10638 = addmethodrealflags(obj10634, "params", &reader_ast_params_10638, 0);
    Method *writer10638 = addmethodrealflags(obj10634, "params:=(1)", &writer_ast_params_10638, 0);
    reader10638->definitionModule = modulename;
    writer10638->definitionModule = modulename;
    reader10638->definitionLine = 2880;
    writer10638->definitionLine = 2880;
  }
  obj10634->flags |= OFLAG_MUTABLE;
  adddatum2(obj10634, alloc_Undefined(), 3);
  if (objclass10634 == NULL) {
    Method *reader10639 = addmethodrealflags(obj10634, "typeParams", &reader_ast_typeParams_10639, 0);
    Method *writer10639 = addmethodrealflags(obj10634, "typeParams:=(1)", &writer_ast_typeParams_10639, 0);
    reader10639->definitionModule = modulename;
    writer10639->definitionModule = modulename;
    reader10639->definitionLine = 2881;
    writer10639->definitionLine = 2881;
  }
  obj10634->flags |= OFLAG_MUTABLE;
  adddatum2(obj10634, alloc_Undefined(), 4);
  if (objclass10634 == NULL) {
    Method *reader10640 = addmethodrealflags(obj10634, "lineLength", &reader_ast_lineLength_10640, 0);
    Method *writer10640 = addmethodrealflags(obj10634, "lineLength:=(1)", &writer_ast_lineLength_10640, 0);
    reader10640->definitionModule = modulename;
    writer10640->definitionModule = modulename;
    reader10640->definitionLine = 2882;
    writer10640->definitionLine = 2882;
  }
  obj10634->flags |= OFLAG_MUTABLE;
  adddatum2(obj10634, alloc_Undefined(), 5);
// method "end"
  struct UserObject *uo10641 = (struct UserObject*)obj10634;
  uo10641->data[6] = emptyclosure;
  Method *meth_meth_ast_10641_end = addmethod2pos(obj10634, "end", &meth_ast_10641_end, 6);
  int argcv_meth_ast_10641_end[] = {0};
  meth_meth_ast_10641_end->type = alloc_MethodType(1, argcv_meth_ast_10641_end);
  meth_meth_ast_10641_end->definitionModule = modulename;
  meth_meth_ast_10641_end->definitionLine = 2884;
// method "numParams"
  struct UserObject *uo10691 = (struct UserObject*)obj10634;
  uo10691->data[7] = emptyclosure;
  Method *meth_meth_ast_10691_numParams = addmethod2pos(obj10634, "numParams", &meth_ast_10691_numParams, 7);
  int argcv_meth_ast_10691_numParams[] = {0};
  meth_meth_ast_10691_numParams->type = alloc_MethodType(1, argcv_meth_ast_10691_numParams);
  meth_meth_ast_10691_numParams->definitionModule = modulename;
  meth_meth_ast_10691_numParams->definitionLine = 2893;
// method "nameString"
  struct UserObject *uo10696 = (struct UserObject*)obj10634;
  uo10696->data[8] = emptyclosure;
  Method *meth_meth_ast_10696_nameString = addmethod2pos(obj10634, "nameString", &meth_ast_10696_nameString, 8);
  int argcv_meth_ast_10696_nameString[] = {0};
  meth_meth_ast_10696_nameString->type = alloc_MethodType(1, argcv_meth_ast_10696_nameString);
  meth_meth_ast_10696_nameString->definitionModule = modulename;
  meth_meth_ast_10696_nameString->definitionLine = 2894;
// method "canonicalName"
  struct UserObject *uo10721 = (struct UserObject*)obj10634;
  uo10721->data[9] = emptyclosure;
  Method *meth_meth_ast_10721_canonicalName = addmethod2pos(obj10634, "canonicalName", &meth_ast_10721_canonicalName, 9);
  int argcv_meth_ast_10721_canonicalName[] = {0};
  meth_meth_ast_10721_canonicalName->type = alloc_MethodType(1, argcv_meth_ast_10721_canonicalName);
  meth_meth_ast_10721_canonicalName->definitionModule = modulename;
  meth_meth_ast_10721_canonicalName->definitionLine = 2898;
// method "accept(_)from(_)"
  struct UserObject *uo10763 = (struct UserObject*)obj10634;
  uo10763->data[10] = emptyclosure;
  Method *meth_meth_ast_10763_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj10634, "accept(1)from(1)", &meth_ast_10763_accept_40_1_41_from_40_1_41_, 10);
  int argcv_meth_ast_10763_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_10763_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_10763_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_10763_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10763_accept_40_1_41_from_40_1_41_->definitionLine = 2906;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj10634);
  Object closure10789 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure10789, stackframe);
  addtoclosure(closure10789, var_k);
  struct UserObject *uo10789 = (struct UserObject*)obj10634;
  uo10789->data[11] = (Object)closure10789;
  Method *meth_meth_ast_10789_declarationKindWithAncestors_40_1_41_ = addmethod2pos(obj10634, "declarationKindWithAncestors(1)", &meth_ast_10789_declarationKindWithAncestors_40_1_41_, 11);
  int argcv_meth_ast_10789_declarationKindWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_10789_declarationKindWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10789_declarationKindWithAncestors_40_1_41_);
  meth_meth_ast_10789_declarationKindWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10789_declarationKindWithAncestors_40_1_41_->definitionLine = 2915;
// method "map(_)ancestors(_)"
  struct UserObject *uo10792 = (struct UserObject*)obj10634;
  uo10792->data[12] = emptyclosure;
  Method *meth_meth_ast_10792_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj10634, "map(1)ancestors(1)", &meth_ast_10792_map_40_1_41_ancestors_40_1_41_, 12);
  int argcv_meth_ast_10792_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_10792_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_10792_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_10792_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10792_map_40_1_41_ancestors_40_1_41_->definitionLine = 2916;
// method "pretty(_)"
  struct UserObject *uo10811 = (struct UserObject*)obj10634;
  uo10811->data[13] = emptyclosure;
  Method *meth_meth_ast_10811_pretty_40_1_41_ = addmethod2pos(obj10634, "pretty(1)", &meth_ast_10811_pretty_40_1_41_, 13);
  int argcv_meth_ast_10811_pretty_40_1_41_[] = {1};
  meth_meth_ast_10811_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10811_pretty_40_1_41_);
  meth_meth_ast_10811_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10811_pretty_40_1_41_->definitionLine = 2923;
// method "toGrace(_)"
  struct UserObject *uo10898 = (struct UserObject*)obj10634;
  uo10898->data[14] = emptyclosure;
  Method *meth_meth_ast_10898_toGrace_40_1_41_ = addmethod2pos(obj10634, "toGrace(1)", &meth_ast_10898_toGrace_40_1_41_, 14);
  int argcv_meth_ast_10898_toGrace_40_1_41_[] = {1};
  meth_meth_ast_10898_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10898_toGrace_40_1_41_);
  meth_meth_ast_10898_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10898_toGrace_40_1_41_->definitionLine = 2932;
// method "shallowCopy"
  block_savedest(obj10634);
  Object closure10940 = createclosure(1, "shallowCopy");
  setclosureframe(closure10940, stackframe);
  addtoclosure(closure10940, var_signaturePart);
  struct UserObject *uo10940 = (struct UserObject*)obj10634;
  uo10940->data[15] = (Object)closure10940;
  Method *meth_meth_ast_10940_shallowCopy = addmethod2pos(obj10634, "shallowCopy", &meth_ast_10940_shallowCopy, 15);
  int argcv_meth_ast_10940_shallowCopy[] = {0};
  meth_meth_ast_10940_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_10940_shallowCopy);
  meth_meth_ast_10940_shallowCopy->definitionModule = modulename;
  meth_meth_ast_10940_shallowCopy->definitionLine = 2942;
// method "postCopy(_)"
  struct UserObject *uo10949 = (struct UserObject*)obj10634;
  uo10949->data[16] = emptyclosure;
  Method *meth_meth_ast_10949_postCopy_40_1_41_ = addmethod2pos(obj10634, "postCopy(1)", &meth_ast_10949_postCopy_40_1_41_, 16);
  int argcv_meth_ast_10949_postCopy_40_1_41_[] = {1};
  meth_meth_ast_10949_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10949_postCopy_40_1_41_);
  meth_meth_ast_10949_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10949_postCopy_40_1_41_->definitionLine = 2946;
// method "asString"
  struct UserObject *uo10958 = (struct UserObject*)obj10634;
  uo10958->data[17] = emptyclosure;
  Method *meth_meth_ast_10958_asString = addmethod2pos(obj10634, "asString", &meth_ast_10958_asString, 17);
  int argcv_meth_ast_10958_asString[] = {0};
  meth_meth_ast_10958_asString->type = alloc_MethodType(1, argcv_meth_ast_10958_asString);
  meth_meth_ast_10958_asString->definitionModule = modulename;
  meth_meth_ast_10958_asString->definitionLine = 2951;
  sourceObject = obj10634;
// Begin line 2877
  setline(2877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10969 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10970 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10969);
// compiled call node returning call10970 (depth = 3)
  struct UserObject *obj10634_uo = (struct UserObject *)obj10634;
  obj10634_uo->super = call10970;
  sourceObject = obj10634;
// Begin line 2878
  setline(2878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10971 == NULL) {
    strlit10971 = alloc_String("signaturepart");
    gc_root(strlit10971);
  }
// compiled string node returning strlit10971 (depth = 3)
  adddatum2(obj10634, strlit10971, 1);
  sourceObject = obj10634;
// Begin line 2879
  setline(2879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  adddatum2(obj10634, *var_n, 2);
  sourceObject = obj10634;
// Begin line 2880
  setline(2880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ps (depth = 3)
  adddatum2(obj10634, *var_ps, 3);
  sourceObject = obj10634;
// Begin line 2881
  setline(2881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10972 = alloc_Boolean(0);
// compiled identifier node returning bool10972 (depth = 3)
  adddatum2(obj10634, bool10972, 4);
  sourceObject = obj10634;
// Begin line 2882
  setline(2882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num10973 = alloc_Float64(0);
// compiled num node returning num10973 (depth = 3)
  adddatum2(obj10634, num10973, 5);
  sourceObject = obj10634;
  sourceObject = obj10634;
  sourceObject = obj10634;
  sourceObject = obj10634;
  sourceObject = obj10634;
  sourceObject = obj10634;
  sourceObject = obj10634;
  sourceObject = obj10634;
  sourceObject = obj10634;
  sourceObject = obj10634;
  sourceObject = obj10634;
  sourceObject = obj10634;
  objclass10634 = obj10634->class;
  objclass10634->definitionModule = modulename;
  objclass10634->definitionLine = 2876;
  (*(struct UserObject *)self).data[0] = lowerouter10634;
  self = oldself10634;
  selfslot = oldselfslot10634;
  stackframe = oldstackframe10634;
  gc_frame_end(frame);
  return obj10634;
}
Object meth_ast_10633_partName_40_1_41_params_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "partName(1)params(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method partName(_)params(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method partName(_)params(_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_signaturePart = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for partName(_)params(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part partName(_)");
  Object *var_ps = &(stackframe->slots[1]);
  *var_ps = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part params(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10634 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10634 = alloc_userobj2(21,18, objclass10634);
  gc_frame_newslot(obj10634);
  if (objclass10634 == NULL) {
    glfree(obj10634->class->name);
    obj10634->class->name = "signaturePart.partName(_)params(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj10634, self, 0);
  addmethodreal(obj10634,"outer", &reader_ast_outer_10635);
  Object oldself10634 = self;
  struct StackFrameObject *oldstackframe10634 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10634);
  gc_frame_newslot((Object)stackframe);
  self = obj10634;
  Object *oldselfslot10634 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10634 = (*(struct UserObject *)self).data[0], lowerouter10634 = thisouter10634;
  if (inheritingObject10634) {
    struct UserObject *inho10634 = (struct UserObject *)inheritingObject10634;
    while (inho10634->super != GraceDefaultObject) inho10634 = (struct UserObject *)inho10634->super;
    inho10634->super = obj10634;
    self = inheritingObject10634;
    *selfslot = self;
    lowerouter10634 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10634;
  }
  if (objclass10634 == NULL) {
  Method *reader10636 = addmethodrealflags(obj10634, "kind",&reader_ast_kind_10636, MFLAG_DEF);
  reader10636->definitionModule = modulename;
  reader10636->definitionLine = 2878;
  }
  adddatum2(obj10634, alloc_Undefined(), 1);
  if (objclass10634 == NULL) {
    Method *reader10637 = addmethodrealflags(obj10634, "name", &reader_ast_name_10637, 0);
    Method *writer10637 = addmethodrealflags(obj10634, "name:=(1)", &writer_ast_name_10637, 0);
    reader10637->definitionModule = modulename;
    writer10637->definitionModule = modulename;
    reader10637->definitionLine = 2879;
    writer10637->definitionLine = 2879;
  }
  obj10634->flags |= OFLAG_MUTABLE;
  adddatum2(obj10634, alloc_Undefined(), 2);
  if (objclass10634 == NULL) {
    Method *reader10638 = addmethodrealflags(obj10634, "params", &reader_ast_params_10638, 0);
    Method *writer10638 = addmethodrealflags(obj10634, "params:=(1)", &writer_ast_params_10638, 0);
    reader10638->definitionModule = modulename;
    writer10638->definitionModule = modulename;
    reader10638->definitionLine = 2880;
    writer10638->definitionLine = 2880;
  }
  obj10634->flags |= OFLAG_MUTABLE;
  adddatum2(obj10634, alloc_Undefined(), 3);
  if (objclass10634 == NULL) {
    Method *reader10639 = addmethodrealflags(obj10634, "typeParams", &reader_ast_typeParams_10639, 0);
    Method *writer10639 = addmethodrealflags(obj10634, "typeParams:=(1)", &writer_ast_typeParams_10639, 0);
    reader10639->definitionModule = modulename;
    writer10639->definitionModule = modulename;
    reader10639->definitionLine = 2881;
    writer10639->definitionLine = 2881;
  }
  obj10634->flags |= OFLAG_MUTABLE;
  adddatum2(obj10634, alloc_Undefined(), 4);
  if (objclass10634 == NULL) {
    Method *reader10640 = addmethodrealflags(obj10634, "lineLength", &reader_ast_lineLength_10640, 0);
    Method *writer10640 = addmethodrealflags(obj10634, "lineLength:=(1)", &writer_ast_lineLength_10640, 0);
    reader10640->definitionModule = modulename;
    writer10640->definitionModule = modulename;
    reader10640->definitionLine = 2882;
    writer10640->definitionLine = 2882;
  }
  obj10634->flags |= OFLAG_MUTABLE;
  adddatum2(obj10634, alloc_Undefined(), 5);
// method "end"
  struct UserObject *uo10641 = (struct UserObject*)obj10634;
  uo10641->data[6] = emptyclosure;
  Method *meth_meth_ast_10641_end = addmethod2pos(obj10634, "end", &meth_ast_10641_end, 6);
  int argcv_meth_ast_10641_end[] = {0};
  meth_meth_ast_10641_end->type = alloc_MethodType(1, argcv_meth_ast_10641_end);
  meth_meth_ast_10641_end->definitionModule = modulename;
  meth_meth_ast_10641_end->definitionLine = 2884;
// method "numParams"
  struct UserObject *uo10691 = (struct UserObject*)obj10634;
  uo10691->data[7] = emptyclosure;
  Method *meth_meth_ast_10691_numParams = addmethod2pos(obj10634, "numParams", &meth_ast_10691_numParams, 7);
  int argcv_meth_ast_10691_numParams[] = {0};
  meth_meth_ast_10691_numParams->type = alloc_MethodType(1, argcv_meth_ast_10691_numParams);
  meth_meth_ast_10691_numParams->definitionModule = modulename;
  meth_meth_ast_10691_numParams->definitionLine = 2893;
// method "nameString"
  struct UserObject *uo10696 = (struct UserObject*)obj10634;
  uo10696->data[8] = emptyclosure;
  Method *meth_meth_ast_10696_nameString = addmethod2pos(obj10634, "nameString", &meth_ast_10696_nameString, 8);
  int argcv_meth_ast_10696_nameString[] = {0};
  meth_meth_ast_10696_nameString->type = alloc_MethodType(1, argcv_meth_ast_10696_nameString);
  meth_meth_ast_10696_nameString->definitionModule = modulename;
  meth_meth_ast_10696_nameString->definitionLine = 2894;
// method "canonicalName"
  struct UserObject *uo10721 = (struct UserObject*)obj10634;
  uo10721->data[9] = emptyclosure;
  Method *meth_meth_ast_10721_canonicalName = addmethod2pos(obj10634, "canonicalName", &meth_ast_10721_canonicalName, 9);
  int argcv_meth_ast_10721_canonicalName[] = {0};
  meth_meth_ast_10721_canonicalName->type = alloc_MethodType(1, argcv_meth_ast_10721_canonicalName);
  meth_meth_ast_10721_canonicalName->definitionModule = modulename;
  meth_meth_ast_10721_canonicalName->definitionLine = 2898;
// method "accept(_)from(_)"
  struct UserObject *uo10763 = (struct UserObject*)obj10634;
  uo10763->data[10] = emptyclosure;
  Method *meth_meth_ast_10763_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj10634, "accept(1)from(1)", &meth_ast_10763_accept_40_1_41_from_40_1_41_, 10);
  int argcv_meth_ast_10763_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_10763_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_10763_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_10763_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10763_accept_40_1_41_from_40_1_41_->definitionLine = 2906;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj10634);
  Object closure10789 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure10789, stackframe);
  addtoclosure(closure10789, var_k);
  struct UserObject *uo10789 = (struct UserObject*)obj10634;
  uo10789->data[11] = (Object)closure10789;
  Method *meth_meth_ast_10789_declarationKindWithAncestors_40_1_41_ = addmethod2pos(obj10634, "declarationKindWithAncestors(1)", &meth_ast_10789_declarationKindWithAncestors_40_1_41_, 11);
  int argcv_meth_ast_10789_declarationKindWithAncestors_40_1_41_[] = {1};
  meth_meth_ast_10789_declarationKindWithAncestors_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10789_declarationKindWithAncestors_40_1_41_);
  meth_meth_ast_10789_declarationKindWithAncestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10789_declarationKindWithAncestors_40_1_41_->definitionLine = 2915;
// method "map(_)ancestors(_)"
  struct UserObject *uo10792 = (struct UserObject*)obj10634;
  uo10792->data[12] = emptyclosure;
  Method *meth_meth_ast_10792_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj10634, "map(1)ancestors(1)", &meth_ast_10792_map_40_1_41_ancestors_40_1_41_, 12);
  int argcv_meth_ast_10792_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_10792_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_10792_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_10792_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10792_map_40_1_41_ancestors_40_1_41_->definitionLine = 2916;
// method "pretty(_)"
  struct UserObject *uo10811 = (struct UserObject*)obj10634;
  uo10811->data[13] = emptyclosure;
  Method *meth_meth_ast_10811_pretty_40_1_41_ = addmethod2pos(obj10634, "pretty(1)", &meth_ast_10811_pretty_40_1_41_, 13);
  int argcv_meth_ast_10811_pretty_40_1_41_[] = {1};
  meth_meth_ast_10811_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10811_pretty_40_1_41_);
  meth_meth_ast_10811_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10811_pretty_40_1_41_->definitionLine = 2923;
// method "toGrace(_)"
  struct UserObject *uo10898 = (struct UserObject*)obj10634;
  uo10898->data[14] = emptyclosure;
  Method *meth_meth_ast_10898_toGrace_40_1_41_ = addmethod2pos(obj10634, "toGrace(1)", &meth_ast_10898_toGrace_40_1_41_, 14);
  int argcv_meth_ast_10898_toGrace_40_1_41_[] = {1};
  meth_meth_ast_10898_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10898_toGrace_40_1_41_);
  meth_meth_ast_10898_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10898_toGrace_40_1_41_->definitionLine = 2932;
// method "shallowCopy"
  block_savedest(obj10634);
  Object closure10940 = createclosure(1, "shallowCopy");
  setclosureframe(closure10940, stackframe);
  addtoclosure(closure10940, var_signaturePart);
  struct UserObject *uo10940 = (struct UserObject*)obj10634;
  uo10940->data[15] = (Object)closure10940;
  Method *meth_meth_ast_10940_shallowCopy = addmethod2pos(obj10634, "shallowCopy", &meth_ast_10940_shallowCopy, 15);
  int argcv_meth_ast_10940_shallowCopy[] = {0};
  meth_meth_ast_10940_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_10940_shallowCopy);
  meth_meth_ast_10940_shallowCopy->definitionModule = modulename;
  meth_meth_ast_10940_shallowCopy->definitionLine = 2942;
// method "postCopy(_)"
  struct UserObject *uo10949 = (struct UserObject*)obj10634;
  uo10949->data[16] = emptyclosure;
  Method *meth_meth_ast_10949_postCopy_40_1_41_ = addmethod2pos(obj10634, "postCopy(1)", &meth_ast_10949_postCopy_40_1_41_, 16);
  int argcv_meth_ast_10949_postCopy_40_1_41_[] = {1};
  meth_meth_ast_10949_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10949_postCopy_40_1_41_);
  meth_meth_ast_10949_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10949_postCopy_40_1_41_->definitionLine = 2946;
// method "asString"
  struct UserObject *uo10958 = (struct UserObject*)obj10634;
  uo10958->data[17] = emptyclosure;
  Method *meth_meth_ast_10958_asString = addmethod2pos(obj10634, "asString", &meth_ast_10958_asString, 17);
  int argcv_meth_ast_10958_asString[] = {0};
  meth_meth_ast_10958_asString->type = alloc_MethodType(1, argcv_meth_ast_10958_asString);
  meth_meth_ast_10958_asString->definitionModule = modulename;
  meth_meth_ast_10958_asString->definitionLine = 2951;
  sourceObject = obj10634;
// Begin line 2877
  setline(2877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10969 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10970 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10969);
// compiled call node returning call10970 (depth = 3)
  struct UserObject *obj10634_uo = (struct UserObject *)obj10634;
  obj10634_uo->super = call10970;
  sourceObject = obj10634;
// Begin line 2878
  setline(2878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10971 == NULL) {
    strlit10971 = alloc_String("signaturepart");
    gc_root(strlit10971);
  }
// compiled string node returning strlit10971 (depth = 3)
  adddatum2(obj10634, strlit10971, 1);
  sourceObject = obj10634;
// Begin line 2879
  setline(2879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  adddatum2(obj10634, *var_n, 2);
  sourceObject = obj10634;
// Begin line 2880
  setline(2880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ps (depth = 3)
  adddatum2(obj10634, *var_ps, 3);
  sourceObject = obj10634;
// Begin line 2881
  setline(2881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10972 = alloc_Boolean(0);
// compiled identifier node returning bool10972 (depth = 3)
  adddatum2(obj10634, bool10972, 4);
  sourceObject = obj10634;
// Begin line 2882
  setline(2882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num10973 = alloc_Float64(0);
// compiled num node returning num10973 (depth = 3)
  adddatum2(obj10634, num10973, 5);
  sourceObject = obj10634;
  sourceObject = obj10634;
  sourceObject = obj10634;
  sourceObject = obj10634;
  sourceObject = obj10634;
  sourceObject = obj10634;
  sourceObject = obj10634;
  sourceObject = obj10634;
  sourceObject = obj10634;
  sourceObject = obj10634;
  sourceObject = obj10634;
  sourceObject = obj10634;
  objclass10634 = obj10634->class;
  objclass10634->definitionModule = modulename;
  objclass10634->definitionLine = 2876;
  (*(struct UserObject *)self).data[0] = lowerouter10634;
  self = oldself10634;
  selfslot = oldselfslot10634;
  stackframe = oldstackframe10634;
  gc_frame_end(frame);
  return obj10634;
}
Object meth_ast_10975_signaturePart(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 57, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "signaturePart");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_signaturePart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2859
  setline(2859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signaturePart (depth = 3)
  gc_frame_end(frame);
  return *var_signaturePart;
}
Object meth_ast_10978_new(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2958
  setline(2958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10979 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10980 == NULL) {
    strlit10980 = alloc_String("");
    gc_root(strlit10980);
  }
// compiled string node returning strlit10980 (depth = 4)
  gc_frame_newslot(strlit10980);
// starting to compile array node (depth = 4)
  Object array10981 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10981 (depth = 4)
  gc_frame_newslot(array10981);
// call case 4: self request
  params[0] = strlit10980;
  params[1] = array10981;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10982 = callmethodflags(self, "request(1)withArgs(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10979);
// compiled call node returning call10982 (depth = 3)
  gc_frame_end(frame);
  return call10982;
}
Object meth_ast_10983_request_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "request(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for request(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part request(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2959
  setline(2959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10984 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name (depth = 4)
  gc_frame_newslot(*var_name);
// starting to compile array node (depth = 4)
  Object array10985 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10985 (depth = 4)
  gc_frame_newslot(array10985);
// call case 4: self request
  params[0] = *var_name;
  params[1] = array10985;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10986 = callmethodflags(self, "request(1)withArgs(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10984);
// compiled call node returning call10986 (depth = 3)
  gc_frame_end(frame);
  return call10986;
}
Object meth_ast_10987_request_40_1_41_withArgs_40_1_41_scope_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "request(1)withArgs(1)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request(_)withArgs(_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request(_)withArgs(_)scope(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request(_)withArgs(_)scope(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for request(_)withArgs(_)scope(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part request(_)");
  Object *var_argList = &(stackframe->slots[1]);
  *var_argList = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withArgs(_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 2961
  setline(2961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10988 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_argList (depth = 5)
  gc_frame_newslot(*var_argList);
// call case 4: self request
  params[0] = *var_name;
  params[1] = *var_argList;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10989 = callmethodflags(self, "request(1)withArgs(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10988);
// compiled call node returning call10989 (depth = 4)
  *var_result = call10989;
  if (call10989 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2962
  setline(2962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10990 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call10991 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10990);
// compiled call node returning call10991 (depth = 3)
// Begin line 2963
  setline(2963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_11000_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2974
  setline(2974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe11002 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe11003 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe11004 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11005 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11004);
// compiled member node returning call11005 (depth = 6)
  partcv[0] = 0;
  Object call11006 = callmethodflags(call11005, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe11003);
// compiled member node returning call11006 (depth = 5)
  partcv[0] = 0;
  Object call11007 = callmethodflags(call11006, "not", 1, partcv, params, 0);
  gc_frame_end(callframe11002);
// compiled member node returning call11007 (depth = 4)
  Object if11001 = done;
  if (istrue(call11007)) {
// Begin line 2975
  setline(2975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe11008 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe11009 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe11010 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11011 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11010);
// compiled member node returning call11011 (depth = 7)
  partcv[0] = 0;
  Object call11012 = callmethodflags(call11011, "last", 1, partcv, params, 0);
  gc_frame_end(callframe11009);
// compiled member node returning call11012 (depth = 6)
  partcv[0] = 0;
  Object call11013 = callmethodflags(call11012, "end", 1, partcv, params, 0);
  gc_frame_end(callframe11008);
// compiled member node returning call11013 (depth = 5)
  return call11013;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if11001 = undefined;
  } else {
  }
// compiled if node returning if11001 (depth = 3)
// Begin line 2977
  setline(2977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe11015 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe11016 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe11017 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11018 = callmethodflags(self, "typeArgs", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11017);
// compiled member node returning call11018 (depth = 6)
  partcv[0] = 0;
  Object call11019 = callmethodflags(call11018, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe11016);
// compiled member node returning call11019 (depth = 5)
  partcv[0] = 0;
  Object call11020 = callmethodflags(call11019, "not", 1, partcv, params, 0);
  gc_frame_end(callframe11015);
// compiled member node returning call11020 (depth = 4)
  Object if11014 = done;
  if (istrue(call11020)) {
// Begin line 2978
  setline(2978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11021 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit11022 == NULL) {
    strlit11022 = alloc_String("""\xe2""""\x9f""""\xa7""");
    gc_root(strlit11022);
  }
// compiled string node returning strlit11022 (depth = 6)
  gc_frame_newslot(strlit11022);
// starting to compile member node (depth = 6)
  int callframe11023 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe11024 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe11025 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11026 = callmethodflags(self, "typeArgs", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11025);
// compiled member node returning call11026 (depth = 8)
  partcv[0] = 0;
  Object call11027 = callmethodflags(call11026, "last", 1, partcv, params, 0);
  gc_frame_end(callframe11024);
// compiled member node returning call11027 (depth = 7)
  partcv[0] = 0;
  Object call11028 = callmethodflags(call11027, "end", 1, partcv, params, 0);
  gc_frame_end(callframe11023);
// compiled member node returning call11028 (depth = 6)
  gc_frame_newslot(call11028);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_ast (depth = 6)
  params[0] = strlit11022;
  params[1] = call11028;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11029 = callmethodflags(module_ast, "positionOfNext(1)after(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11021);
// compiled call node returning call11029 (depth = 5)
  return call11029;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if11014 = undefined;
  } else {
  }
// compiled if node returning if11014 (depth = 3)
// Begin line 2980
  setline(2980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11030 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe11031 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11032 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11031);
// compiled member node returning call11032 (depth = 5)
  gc_frame_newslot(call11032);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num11034 = alloc_Float64(1);
// compiled num node returning num11034 (depth = 6)
  int op_slot_right_11033 = gc_frame_newslot(num11034);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe11037 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe11038 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11039 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11038);
// compiled member node returning call11039 (depth = 8)
  partcv[0] = 0;
  Object call11040 = callmethodflags(call11039, "size", 1, partcv, params, 0);
  gc_frame_end(callframe11037);
// compiled member node returning call11040 (depth = 7)
  int op_slot_right_11036 = gc_frame_newslot(call11040);
// starting to compile member node (depth = 7)
  int callframe11042 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11043 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11042);
// compiled member node returning call11043 (depth = 7)
  int op_slot_left_11036 = gc_frame_newslot(call11043);
  params[0] = call11040;
  partcv[0] = 1;
  Object sum11044 = callmethod(call11043, "+(1)", 1, partcv, params);
// compiled op node returning sum11044 (depth = 6)
  int op_slot_left_11033 = gc_frame_newslot(sum11044);
  params[0] = num11034;
  partcv[0] = 1;
  Object diff11045 = callmethod(sum11044, "-(1)", 1, partcv, params);
// compiled op node returning diff11045 (depth = 5)
  gc_frame_newslot(diff11045);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call11032;
  params[1] = diff11045;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11046 = callmethodflags(module_ast, "line(1)column(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11030);
// compiled call node returning call11046 (depth = 4)
  return call11046;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_11047_nameString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 2983
  setline(2983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num11050 = alloc_Float64(0);
// compiled num node returning num11050 (depth = 5)
  int op_slot_right_11049 = gc_frame_newslot(num11050);
// starting to compile member node (depth = 5)
  int callframe11052 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe11053 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11054 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11053);
// compiled member node returning call11054 (depth = 6)
  partcv[0] = 0;
  Object call11055 = callmethodflags(call11054, "size", 1, partcv, params, 0);
  gc_frame_end(callframe11052);
// compiled member node returning call11055 (depth = 5)
  int op_slot_left_11049 = gc_frame_newslot(call11055);
  params[0] = num11050;
  partcv[0] = 1;
  Object opresult11056 = callmethod(call11055, "==(1)", 1, partcv, params);
// compiled op node returning opresult11056 (depth = 4)
  Object if11048 = done;
  if (istrue(opresult11056)) {
// starting to compile return node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe11057 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11058 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11057);
// compiled member node returning call11058 (depth = 5)
  return call11058;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if11048 = undefined;
  } else {
  }
// compiled if node returning if11048 (depth = 3)
// Begin line 2984
  setline(2984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit11060 == NULL) {
    strlit11060 = alloc_String(")");
    gc_root(strlit11060);
  }
// compiled string node returning strlit11060 (depth = 4)
  int op_slot_right_11059 = gc_frame_newslot(strlit11060);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe11063 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe11064 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11065 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11064);
// compiled member node returning call11065 (depth = 6)
  partcv[0] = 0;
  Object call11066 = callmethodflags(call11065, "size", 1, partcv, params, 0);
  gc_frame_end(callframe11063);
// compiled member node returning call11066 (depth = 5)
  int op_slot_right_11062 = gc_frame_newslot(call11066);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit11069 == NULL) {
    strlit11069 = alloc_String("(");
    gc_root(strlit11069);
  }
// compiled string node returning strlit11069 (depth = 6)
  int op_slot_right_11068 = gc_frame_newslot(strlit11069);
// starting to compile member node (depth = 6)
  int callframe11071 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11072 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11071);
// compiled member node returning call11072 (depth = 6)
  int op_slot_left_11068 = gc_frame_newslot(call11072);
  params[0] = strlit11069;
  partcv[0] = 1;
  Object opresult11073 = callmethod(call11072, "++(1)", 1, partcv, params);
// compiled op node returning opresult11073 (depth = 5)
  int op_slot_left_11062 = gc_frame_newslot(opresult11073);
  params[0] = call11066;
  partcv[0] = 1;
  Object opresult11074 = callmethod(opresult11073, "++(1)", 1, partcv, params);
// compiled op node returning opresult11074 (depth = 4)
  int op_slot_left_11059 = gc_frame_newslot(opresult11074);
  params[0] = strlit11060;
  partcv[0] = 1;
  Object opresult11075 = callmethod(opresult11074, "++(1)", 1, partcv, params);
// compiled op node returning opresult11075 (depth = 3)
  gc_frame_end(frame);
  return opresult11075;
}
Object meth_ast_11091__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_underScores = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___3 = &(stackframe->slots[0]);
  *var___3 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit11093 == NULL) {
    strlit11093 = alloc_String("_");
    gc_root(strlit11093);
  }
// compiled string node returning strlit11093 (depth = 7)
  int op_slot_right_11092 = gc_frame_newslot(strlit11093);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_underScores (depth = 7)
  int op_slot_left_11092 = gc_frame_newslot(*var_underScores);
  params[0] = strlit11093;
  partcv[0] = 1;
  Object opresult11095 = callmethod(*var_underScores, "++(1)", 1, partcv, params);
// compiled op node returning opresult11095 (depth = 6)
  *var_underScores = opresult11095;
  if (opresult11095 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_11099__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_underScores = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit11101 == NULL) {
    strlit11101 = alloc_String(",");
    gc_root(strlit11101);
  }
// compiled string node returning strlit11101 (depth = 7)
  int op_slot_right_11100 = gc_frame_newslot(strlit11101);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_underScores (depth = 7)
  int op_slot_left_11100 = gc_frame_newslot(*var_underScores);
  params[0] = strlit11101;
  partcv[0] = 1;
  Object opresult11103 = callmethod(*var_underScores, "++(1)", 1, partcv, params);
// compiled op node returning opresult11103 (depth = 6)
  *var_underScores = opresult11103;
  if (opresult11103 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_11076_canonicalName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canonicalName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_underScores = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "underScores");
// Begin line 2988
  setline(2988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num11079 = alloc_Float64(0);
// compiled num node returning num11079 (depth = 5)
  int op_slot_right_11078 = gc_frame_newslot(num11079);
// starting to compile member node (depth = 5)
  int callframe11081 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe11082 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11083 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11082);
// compiled member node returning call11083 (depth = 6)
  partcv[0] = 0;
  Object call11084 = callmethodflags(call11083, "size", 1, partcv, params, 0);
  gc_frame_end(callframe11081);
// compiled member node returning call11084 (depth = 5)
  int op_slot_left_11078 = gc_frame_newslot(call11084);
  params[0] = num11079;
  partcv[0] = 1;
  Object opresult11085 = callmethod(call11084, "==(1)", 1, partcv, params);
// compiled op node returning opresult11085 (depth = 4)
  Object if11077 = done;
  if (istrue(opresult11085)) {
// starting to compile return node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe11086 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11087 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11086);
// compiled member node returning call11087 (depth = 5)
  return call11087;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if11077 = undefined;
  } else {
  }
// compiled if node returning if11077 (depth = 3)
// Begin line 2989
  setline(2989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit11088 == NULL) {
    strlit11088 = alloc_String("");
    gc_root(strlit11088);
  }
// compiled string node returning strlit11088 (depth = 4)
  *var_underScores = strlit11088;
  if (strlit11088 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2990
  setline(2990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11089 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block11090 = alloc_Block(NULL, NULL, "ast", 2990);
  gc_frame_newslot(block11090);
// method "_apply(_)"
  block_savedest(block11090);
  Object closure11091 = createclosure(2, "_apply(1)");
  setclosureframe(closure11091, stackframe);
  addtoclosure(closure11091, var_underScores);
  addtoclosure(closure11091, selfslot);
  struct UserObject *uo11091 = (struct UserObject*)block11090;
  uo11091->data[0] = (Object)closure11091;
  Method *meth_meth_ast_11091__apply_40_1_41_ = addmethod2pos(block11090, "_apply(1)", &meth_ast_11091__apply_40_1_41_, 0);
  int argcv_meth_ast_11091__apply_40_1_41_[] = {1};
  meth_meth_ast_11091__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_11091__apply_40_1_41_);
  meth_meth_ast_11091__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11091__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block11090 (depth = 4)
  gc_frame_newslot(block11090);
// Begin line 2991
  setline(2991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block11098 = alloc_Block(NULL, NULL, "ast", 2991);
  gc_frame_newslot(block11098);
// method "_apply"
  block_savedest(block11098);
  Object closure11099 = createclosure(2, "_apply");
  setclosureframe(closure11099, stackframe);
  addtoclosure(closure11099, var_underScores);
  addtoclosure(closure11099, selfslot);
  struct UserObject *uo11099 = (struct UserObject*)block11098;
  uo11099->data[0] = (Object)closure11099;
  Method *meth_meth_ast_11099__apply = addmethod2pos(block11098, "_apply", &meth_ast_11099__apply, 0);
  int argcv_meth_ast_11099__apply[] = {0};
  meth_meth_ast_11099__apply->type = alloc_MethodType(1, argcv_meth_ast_11099__apply);
  meth_meth_ast_11099__apply->definitionModule = modulename;
  meth_meth_ast_11099__apply->definitionLine = 3050;
// compiled block node returning block11098 (depth = 4)
  gc_frame_newslot(block11098);
// call case 6: other requests
// Begin line 2990
  setline(2990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe11106 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11107 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11106);
// compiled member node returning call11107 (depth = 4)
  params[0] = block11090;
  params[1] = block11098;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11108 = callmethodflags(call11107, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe11089);
// compiled call node returning call11108 (depth = 3)
// Begin line 2992
  setline(2992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit11110 == NULL) {
    strlit11110 = alloc_String(")");
    gc_root(strlit11110);
  }
// compiled string node returning strlit11110 (depth = 4)
  int op_slot_right_11109 = gc_frame_newslot(strlit11110);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_underScores (depth = 5)
  int op_slot_right_11112 = gc_frame_newslot(*var_underScores);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit11115 == NULL) {
    strlit11115 = alloc_String("(");
    gc_root(strlit11115);
  }
// compiled string node returning strlit11115 (depth = 6)
  int op_slot_right_11114 = gc_frame_newslot(strlit11115);
// starting to compile member node (depth = 6)
  int callframe11117 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11118 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11117);
// compiled member node returning call11118 (depth = 6)
  int op_slot_left_11114 = gc_frame_newslot(call11118);
  params[0] = strlit11115;
  partcv[0] = 1;
  Object opresult11119 = callmethod(call11118, "++(1)", 1, partcv, params);
// compiled op node returning opresult11119 (depth = 5)
  int op_slot_left_11112 = gc_frame_newslot(opresult11119);
  params[0] = *var_underScores;
  partcv[0] = 1;
  Object opresult11120 = callmethod(opresult11119, "++(1)", 1, partcv, params);
// compiled op node returning opresult11120 (depth = 4)
  int op_slot_left_11109 = gc_frame_newslot(opresult11120);
  params[0] = strlit11110;
  partcv[0] = 1;
  Object opresult11121 = callmethod(opresult11120, "++(1)", 1, partcv, params);
// compiled op node returning opresult11121 (depth = 3)
  gc_frame_end(frame);
  return opresult11121;
}
Object meth_ast_11122_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2996
  setline(2996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe11123 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11124 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11123);
// compiled member node returning call11124 (depth = 4)
  *var_n = call11124;
  if (call11124 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2997
  setline(2997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11125 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call11126 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe11125);
// compiled call node returning call11126 (depth = 4)
  *var_newChain = call11126;
  if (call11126 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2998
  setline(2998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11127 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe11128 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe11129 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11130 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11129);
// compiled member node returning call11130 (depth = 5)
  gc_frame_newslot(call11130);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call11130;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call11131 = callmethodflags(module_ast, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11128);
// compiled call node returning call11131 (depth = 4)
  gc_frame_newslot(call11131);
// call case 6: other requests
// Begin line 2998
  setline(2998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call11131;
  partcv[0] = 1;
  Object call11132 = callmethodflags(*var_n, "args:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe11127);
// compiled call node returning call11132 (depth = 3)
// Begin line 2999
  setline(2999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11133 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call11134 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe11133);
// compiled call node returning call11134 (depth = 3)
  gc_frame_end(frame);
  return call11134;
}
Object meth_ast_11183__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3006
  setline(3006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit11185 == NULL) {
    strlit11185 = alloc_String("");
    gc_root(strlit11185);
  }
// compiled string node returning strlit11185 (depth = 7)
  int op_slot_right_11184 = gc_frame_newslot(strlit11185);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11188 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num11190 = alloc_Float64(3);
// compiled num node returning num11190 (depth = 10)
  int op_slot_right_11189 = gc_frame_newslot(num11190);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_11189 = gc_frame_newslot(*var_depth);
  params[0] = num11190;
  partcv[0] = 1;
  Object sum11192 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum11192 (depth = 9)
  gc_frame_newslot(sum11192);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  params[0] = sum11192;
  partcv[0] = 1;
  Object call11193 = callmethodflags(*var_a, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe11188);
// compiled call node returning call11193 (depth = 8)
  int op_slot_right_11187 = gc_frame_newslot(call11193);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit11196 == NULL) {
    strlit11196 = alloc_String("");
    gc_root(strlit11196);
  }
// compiled string node returning strlit11196 (depth = 9)
  int op_slot_right_11195 = gc_frame_newslot(strlit11196);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_11198 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit11201 == NULL) {
    strlit11201 = alloc_String("""\x0a""  ");
    gc_root(strlit11201);
  }
// compiled string node returning strlit11201 (depth = 11)
  int op_slot_right_11200 = gc_frame_newslot(strlit11201);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_right_11203 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 12)
  if (strlit11205 == NULL) {
    strlit11205 = alloc_String("");
    gc_root(strlit11205);
  }
// compiled string node returning strlit11205 (depth = 12)
  int op_slot_left_11203 = gc_frame_newslot(strlit11205);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult11206 = callmethod(strlit11205, "++(1)", 1, partcv, params);
// compiled op node returning opresult11206 (depth = 11)
  int op_slot_left_11200 = gc_frame_newslot(opresult11206);
  params[0] = strlit11201;
  partcv[0] = 1;
  Object opresult11207 = callmethod(opresult11206, "++(1)", 1, partcv, params);
// compiled op node returning opresult11207 (depth = 10)
  int op_slot_left_11198 = gc_frame_newslot(opresult11207);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult11208 = callmethod(opresult11207, "++(1)", 1, partcv, params);
// compiled op node returning opresult11208 (depth = 9)
  int op_slot_left_11195 = gc_frame_newslot(opresult11208);
  params[0] = strlit11196;
  partcv[0] = 1;
  Object opresult11209 = callmethod(opresult11208, "++(1)", 1, partcv, params);
// compiled op node returning opresult11209 (depth = 8)
  int op_slot_left_11187 = gc_frame_newslot(opresult11209);
  params[0] = call11193;
  partcv[0] = 1;
  Object opresult11210 = callmethod(opresult11209, "++(1)", 1, partcv, params);
// compiled op node returning opresult11210 (depth = 7)
  int op_slot_left_11184 = gc_frame_newslot(opresult11210);
  params[0] = strlit11185;
  partcv[0] = 1;
  Object opresult11211 = callmethod(opresult11210, "++(1)", 1, partcv, params);
// compiled op node returning opresult11211 (depth = 6)
  *var_s = opresult11211;
  if (opresult11211 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_11135_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 3002
  setline(3002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num11138 = alloc_Float64(1);
// compiled num node returning num11138 (depth = 6)
  int op_slot_right_11137 = gc_frame_newslot(num11138);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_11137 = gc_frame_newslot(*var_depth);
  params[0] = num11138;
  partcv[0] = 1;
  Object sum11140 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum11140 (depth = 5)
  int op_slot_right_11136 = gc_frame_newslot(sum11140);
// starting to compile string node (depth = 5)
  if (strlit11142 == NULL) {
    strlit11142 = alloc_String("  ");
    gc_root(strlit11142);
  }
// compiled string node returning strlit11142 (depth = 5)
  int op_slot_left_11136 = gc_frame_newslot(strlit11142);
  params[0] = sum11140;
  partcv[0] = 1;
  Object prod11143 = callmethod(strlit11142, "*(1)", 1, partcv, params);
// compiled op node returning prod11143 (depth = 4)
  *var_spc = prod11143;
  if (prod11143 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 3003
  setline(3003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit11145 == NULL) {
    strlit11145 = alloc_String("");
    gc_root(strlit11145);
  }
// compiled string node returning strlit11145 (depth = 5)
  int op_slot_right_11144 = gc_frame_newslot(strlit11145);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe11148 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11149 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11148);
// compiled member node returning call11149 (depth = 6)
  int op_slot_right_11147 = gc_frame_newslot(call11149);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit11152 == NULL) {
    strlit11152 = alloc_String(": ");
    gc_root(strlit11152);
  }
// compiled string node returning strlit11152 (depth = 7)
  int op_slot_right_11151 = gc_frame_newslot(strlit11152);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11155 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 4: self request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call11156 = callmethodflags(self, "basePretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11155);
// compiled call node returning call11156 (depth = 8)
  int op_slot_right_11154 = gc_frame_newslot(call11156);
// starting to compile string node (depth = 8)
  if (strlit11158 == NULL) {
    strlit11158 = alloc_String("");
    gc_root(strlit11158);
  }
// compiled string node returning strlit11158 (depth = 8)
  int op_slot_left_11154 = gc_frame_newslot(strlit11158);
  params[0] = call11156;
  partcv[0] = 1;
  Object opresult11159 = callmethod(strlit11158, "++(1)", 1, partcv, params);
// compiled op node returning opresult11159 (depth = 7)
  int op_slot_left_11151 = gc_frame_newslot(opresult11159);
  params[0] = strlit11152;
  partcv[0] = 1;
  Object opresult11160 = callmethod(opresult11159, "++(1)", 1, partcv, params);
// compiled op node returning opresult11160 (depth = 6)
  int op_slot_left_11147 = gc_frame_newslot(opresult11160);
  params[0] = call11149;
  partcv[0] = 1;
  Object opresult11161 = callmethod(opresult11160, "++(1)", 1, partcv, params);
// compiled op node returning opresult11161 (depth = 5)
  int op_slot_left_11144 = gc_frame_newslot(opresult11161);
  params[0] = strlit11145;
  partcv[0] = 1;
  Object opresult11162 = callmethod(opresult11161, "++(1)", 1, partcv, params);
// compiled op node returning opresult11162 (depth = 4)
  *var_s = opresult11162;
  if (opresult11162 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 3004
  setline(3004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit11164 == NULL) {
    strlit11164 = alloc_String("Args:");
    gc_root(strlit11164);
  }
// compiled string node returning strlit11164 (depth = 5)
  int op_slot_right_11163 = gc_frame_newslot(strlit11164);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_11166 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit11169 == NULL) {
    strlit11169 = alloc_String("""\x0a""");
    gc_root(strlit11169);
  }
// compiled string node returning strlit11169 (depth = 7)
  int op_slot_right_11168 = gc_frame_newslot(strlit11169);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_right_11171 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 8)
  if (strlit11173 == NULL) {
    strlit11173 = alloc_String("");
    gc_root(strlit11173);
  }
// compiled string node returning strlit11173 (depth = 8)
  int op_slot_left_11171 = gc_frame_newslot(strlit11173);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult11174 = callmethod(strlit11173, "++(1)", 1, partcv, params);
// compiled op node returning opresult11174 (depth = 7)
  int op_slot_left_11168 = gc_frame_newslot(opresult11174);
  params[0] = strlit11169;
  partcv[0] = 1;
  Object opresult11175 = callmethod(opresult11174, "++(1)", 1, partcv, params);
// compiled op node returning opresult11175 (depth = 6)
  int op_slot_left_11166 = gc_frame_newslot(opresult11175);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult11176 = callmethod(opresult11175, "++(1)", 1, partcv, params);
// compiled op node returning opresult11176 (depth = 5)
  int op_slot_left_11163 = gc_frame_newslot(opresult11176);
  params[0] = strlit11164;
  partcv[0] = 1;
  Object opresult11177 = callmethod(opresult11176, "++(1)", 1, partcv, params);
// compiled op node returning opresult11177 (depth = 4)
  *var_s = opresult11177;
  if (opresult11177 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 3005
  setline(3005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11179 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe11180 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11181 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11180);
// compiled member node returning call11181 (depth = 4)
  gc_frame_newslot(call11181);
// starting to compile block node (depth = 4)
  Object block11182 = alloc_Block(NULL, NULL, "ast", 3005);
  gc_frame_newslot(block11182);
// method "_apply(_)"
  block_savedest(block11182);
  Object closure11183 = createclosure(4, "_apply(1)");
  setclosureframe(closure11183, stackframe);
  addtoclosure(closure11183, var_depth);
  addtoclosure(closure11183, var_spc);
  addtoclosure(closure11183, var_s);
  addtoclosure(closure11183, selfslot);
  struct UserObject *uo11183 = (struct UserObject*)block11182;
  uo11183->data[0] = (Object)closure11183;
  Method *meth_meth_ast_11183__apply_40_1_41_ = addmethod2pos(block11182, "_apply(1)", &meth_ast_11183__apply_40_1_41_, 0);
  int argcv_meth_ast_11183__apply_40_1_41_[] = {1};
  meth_meth_ast_11183__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_11183__apply_40_1_41_);
  meth_meth_ast_11183__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11183__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block11182 (depth = 4)
  gc_frame_newslot(block11182);
// call case 5: prelude request
  params[0] = call11181;
  params[1] = block11182;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11214 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11179);
// compiled call node returning call11214 (depth = 3)
// Begin line 3008
  setline(3008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_11234__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_tArg = &(stackframe->slots[0]);
  *var_tArg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3015
  setline(3015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11236 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num11238 = alloc_Float64(1);
// compiled num node returning num11238 (depth = 10)
  int op_slot_right_11237 = gc_frame_newslot(num11238);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_11237 = gc_frame_newslot(*var_depth);
  params[0] = num11238;
  partcv[0] = 1;
  Object sum11240 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum11240 (depth = 9)
  gc_frame_newslot(sum11240);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tArg (depth = 9)
  params[0] = sum11240;
  partcv[0] = 1;
  Object call11241 = callmethodflags(*var_tArg, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe11236);
// compiled call node returning call11241 (depth = 8)
  int op_slot_right_11235 = gc_frame_newslot(call11241);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_11235 = gc_frame_newslot(*var_s);
  params[0] = call11241;
  partcv[0] = 1;
  Object opresult11243 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult11243 (depth = 7)
  *var_s = opresult11243;
  if (opresult11243 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_11247__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit11249 == NULL) {
    strlit11249 = alloc_String(", ");
    gc_root(strlit11249);
  }
// compiled string node returning strlit11249 (depth = 8)
  int op_slot_right_11248 = gc_frame_newslot(strlit11249);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_11248 = gc_frame_newslot(*var_s);
  params[0] = strlit11249;
  partcv[0] = 1;
  Object opresult11251 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult11251 (depth = 7)
  *var_s = opresult11251;
  if (opresult11251 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_11299__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3023
  setline(3023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11301 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_arg (depth = 9)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call11302 = callmethodflags(*var_arg, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe11301);
// compiled call node returning call11302 (depth = 8)
  int op_slot_right_11300 = gc_frame_newslot(call11302);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_11300 = gc_frame_newslot(*var_s);
  params[0] = call11302;
  partcv[0] = 1;
  Object opresult11304 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult11304 (depth = 7)
  *var_s = opresult11304;
  if (opresult11304 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_11308__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3025
  setline(3025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit11310 == NULL) {
    strlit11310 = alloc_String(", ");
    gc_root(strlit11310);
  }
// compiled string node returning strlit11310 (depth = 8)
  int op_slot_right_11309 = gc_frame_newslot(strlit11310);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_11309 = gc_frame_newslot(*var_s);
  params[0] = strlit11310;
  partcv[0] = 1;
  Object opresult11312 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult11312 (depth = 7)
  *var_s = opresult11312;
  if (opresult11312 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_11215_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// definebindings:
// definebindings:
// definebindings:
  Object *var_needsParens = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "needsParens");
// definebindings:
// definebindings:
// definebindings:
// Begin line 3011
  setline(3011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe11216 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11217 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11216);
// compiled member node returning call11217 (depth = 4)
  *var_s = call11217;
  if (call11217 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 3012
  setline(3012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num11220 = alloc_Float64(0);
// compiled num node returning num11220 (depth = 5)
  int op_slot_right_11219 = gc_frame_newslot(num11220);
// starting to compile member node (depth = 5)
  int callframe11222 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe11223 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11224 = callmethodflags(self, "typeArgs", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11223);
// compiled member node returning call11224 (depth = 6)
  partcv[0] = 0;
  Object call11225 = callmethodflags(call11224, "size", 1, partcv, params, 0);
  gc_frame_end(callframe11222);
// compiled member node returning call11225 (depth = 5)
  int op_slot_left_11219 = gc_frame_newslot(call11225);
  params[0] = num11220;
  partcv[0] = 1;
  Object opresult11226 = callmethod(call11225, ">(1)", 1, partcv, params);
// compiled op node returning opresult11226 (depth = 4)
  Object if11218 = done;
  if (istrue(opresult11226)) {
// Begin line 3013
  setline(3013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit11228 == NULL) {
    strlit11228 = alloc_String("""\xe2""""\x9f""""\xa6""");
    gc_root(strlit11228);
  }
// compiled string node returning strlit11228 (depth = 6)
  int op_slot_right_11227 = gc_frame_newslot(strlit11228);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_11227 = gc_frame_newslot(*var_s);
  params[0] = strlit11228;
  partcv[0] = 1;
  Object opresult11230 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult11230 (depth = 5)
  *var_s = opresult11230;
  if (opresult11230 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 3014
  setline(3014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11232 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block11233 = alloc_Block(NULL, NULL, "ast", 3014);
  gc_frame_newslot(block11233);
// method "_apply(_)"
  block_savedest(block11233);
  Object closure11234 = createclosure(3, "_apply(1)");
  setclosureframe(closure11234, stackframe);
  addtoclosure(closure11234, var_depth);
  addtoclosure(closure11234, var_s);
  addtoclosure(closure11234, selfslot);
  struct UserObject *uo11234 = (struct UserObject*)block11233;
  uo11234->data[0] = (Object)closure11234;
  Method *meth_meth_ast_11234__apply_40_1_41_ = addmethod2pos(block11233, "_apply(1)", &meth_ast_11234__apply_40_1_41_, 0);
  int argcv_meth_ast_11234__apply_40_1_41_[] = {1};
  meth_meth_ast_11234__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_11234__apply_40_1_41_);
  meth_meth_ast_11234__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11234__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block11233 (depth = 5)
  gc_frame_newslot(block11233);
// Begin line 3016
  setline(3016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block11246 = alloc_Block(NULL, NULL, "ast", 3016);
  gc_frame_newslot(block11246);
// method "_apply"
  block_savedest(block11246);
  Object closure11247 = createclosure(2, "_apply");
  setclosureframe(closure11247, stackframe);
  addtoclosure(closure11247, var_s);
  addtoclosure(closure11247, selfslot);
  struct UserObject *uo11247 = (struct UserObject*)block11246;
  uo11247->data[0] = (Object)closure11247;
  Method *meth_meth_ast_11247__apply = addmethod2pos(block11246, "_apply", &meth_ast_11247__apply, 0);
  int argcv_meth_ast_11247__apply[] = {0};
  meth_meth_ast_11247__apply->type = alloc_MethodType(1, argcv_meth_ast_11247__apply);
  meth_meth_ast_11247__apply->definitionModule = modulename;
  meth_meth_ast_11247__apply->definitionLine = 3050;
// compiled block node returning block11246 (depth = 5)
  gc_frame_newslot(block11246);
// call case 6: other requests
// Begin line 3014
  setline(3014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe11254 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11255 = callmethodflags(self, "typeArgs", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11254);
// compiled member node returning call11255 (depth = 5)
  params[0] = block11233;
  params[1] = block11246;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11256 = callmethodflags(call11255, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe11232);
// compiled call node returning call11256 (depth = 4)
// Begin line 3017
  setline(3017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit11258 == NULL) {
    strlit11258 = alloc_String("""\xe2""""\x9f""""\xa7""");
    gc_root(strlit11258);
  }
// compiled string node returning strlit11258 (depth = 6)
  int op_slot_right_11257 = gc_frame_newslot(strlit11258);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_11257 = gc_frame_newslot(*var_s);
  params[0] = strlit11258;
  partcv[0] = 1;
  Object opresult11260 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult11260 (depth = 5)
  *var_s = opresult11260;
  if (opresult11260 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if11218 = done;
  } else {
  }
// compiled if node returning if11218 (depth = 3)
// Begin line 3019
  setline(3019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num11264 = alloc_Float64(0);
// compiled num node returning num11264 (depth = 5)
  int op_slot_right_11263 = gc_frame_newslot(num11264);
// starting to compile member node (depth = 5)
  int callframe11266 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe11267 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11268 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11267);
// compiled member node returning call11268 (depth = 6)
  partcv[0] = 0;
  Object call11269 = callmethodflags(call11268, "size", 1, partcv, params, 0);
  gc_frame_end(callframe11266);
// compiled member node returning call11269 (depth = 5)
  int op_slot_left_11263 = gc_frame_newslot(call11269);
  params[0] = num11264;
  partcv[0] = 1;
  Object opresult11270 = callmethod(call11269, ">(1)", 1, partcv, params);
// compiled op node returning opresult11270 (depth = 4)
  Object if11262 = done;
  if (istrue(opresult11270)) {
// Begin line 3020
  setline(3020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe11272 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe11273 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe11274 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe11275 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11276 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11275);
// compiled member node returning call11276 (depth = 9)
  partcv[0] = 0;
  Object call11277 = callmethodflags(call11276, "first", 1, partcv, params, 0);
  gc_frame_end(callframe11274);
// compiled member node returning call11277 (depth = 8)
  partcv[0] = 0;
  Object call11278 = callmethodflags(call11277, "isDelimited", 1, partcv, params, 0);
  gc_frame_end(callframe11273);
// compiled member node returning call11278 (depth = 7)
  partcv[0] = 0;
  Object call11279 = callmethodflags(call11278, "not", 1, partcv, params, 0);
  gc_frame_end(callframe11272);
// compiled member node returning call11279 (depth = 6)
  int op_slot_right_11271 = gc_frame_newslot(call11279);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num11282 = alloc_Float64(1);
// compiled num node returning num11282 (depth = 7)
  int op_slot_right_11281 = gc_frame_newslot(num11282);
// starting to compile member node (depth = 7)
  int callframe11284 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe11285 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11286 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11285);
// compiled member node returning call11286 (depth = 8)
  partcv[0] = 0;
  Object call11287 = callmethodflags(call11286, "size", 1, partcv, params, 0);
  gc_frame_end(callframe11284);
// compiled member node returning call11287 (depth = 7)
  int op_slot_left_11281 = gc_frame_newslot(call11287);
  params[0] = num11282;
  partcv[0] = 1;
  Object opresult11288 = callmethod(call11287, ">(1)", 1, partcv, params);
// compiled op node returning opresult11288 (depth = 6)
  int op_slot_left_11271 = gc_frame_newslot(opresult11288);
  params[0] = call11279;
  partcv[0] = 1;
  Object opresult11289 = callmethod(opresult11288, "||(1)", 1, partcv, params);
// compiled op node returning opresult11289 (depth = 5)
  *var_needsParens = opresult11289;
  if (opresult11289 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3021
  setline(3021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile if node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_needsParens (depth = 7)
  Object if11291 = done;
struct StackFrameObject *iftmpstackframe11291 = stackframe;
  if (istrue(*var_needsParens)) {
stackframe = alloc_StackFrame(0, iftmpstackframe11291);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile string node (depth = 7)
  if (strlit11292 == NULL) {
    strlit11292 = alloc_String("(");
    gc_root(strlit11292);
  }
// compiled string node returning strlit11292 (depth = 7)
    gc_frame_newslot(strlit11292);
    if11291 = strlit11292;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe11291);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile string node (depth = 7)
  if (strlit11293 == NULL) {
    strlit11293 = alloc_String(" ");
    gc_root(strlit11293);
  }
// compiled string node returning strlit11293 (depth = 7)
    gc_frame_newslot(strlit11293);
    if11291 = strlit11293;
  }
stackframe = iftmpstackframe11291;
// compiled if node returning if11291 (depth = 6)
  int op_slot_right_11290 = gc_frame_newslot(if11291);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_11290 = gc_frame_newslot(*var_s);
  params[0] = if11291;
  partcv[0] = 1;
  Object opresult11295 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult11295 (depth = 5)
  *var_s = opresult11295;
  if (opresult11295 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 3022
  setline(3022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11297 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block11298 = alloc_Block(NULL, NULL, "ast", 3022);
  gc_frame_newslot(block11298);
// method "_apply(_)"
  block_savedest(block11298);
  Object closure11299 = createclosure(3, "_apply(1)");
  setclosureframe(closure11299, stackframe);
  addtoclosure(closure11299, var_depth);
  addtoclosure(closure11299, var_s);
  addtoclosure(closure11299, selfslot);
  struct UserObject *uo11299 = (struct UserObject*)block11298;
  uo11299->data[0] = (Object)closure11299;
  Method *meth_meth_ast_11299__apply_40_1_41_ = addmethod2pos(block11298, "_apply(1)", &meth_ast_11299__apply_40_1_41_, 0);
  int argcv_meth_ast_11299__apply_40_1_41_[] = {1};
  meth_meth_ast_11299__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_11299__apply_40_1_41_);
  meth_meth_ast_11299__apply_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11299__apply_40_1_41_->definitionLine = 3050;
// compiled block node returning block11298 (depth = 5)
  gc_frame_newslot(block11298);
// Begin line 3024
  setline(3024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block11307 = alloc_Block(NULL, NULL, "ast", 3024);
  gc_frame_newslot(block11307);
// method "_apply"
  block_savedest(block11307);
  Object closure11308 = createclosure(2, "_apply");
  setclosureframe(closure11308, stackframe);
  addtoclosure(closure11308, var_s);
  addtoclosure(closure11308, selfslot);
  struct UserObject *uo11308 = (struct UserObject*)block11307;
  uo11308->data[0] = (Object)closure11308;
  Method *meth_meth_ast_11308__apply = addmethod2pos(block11307, "_apply", &meth_ast_11308__apply, 0);
  int argcv_meth_ast_11308__apply[] = {0};
  meth_meth_ast_11308__apply->type = alloc_MethodType(1, argcv_meth_ast_11308__apply);
  meth_meth_ast_11308__apply->definitionModule = modulename;
  meth_meth_ast_11308__apply->definitionLine = 3050;
// compiled block node returning block11307 (depth = 5)
  gc_frame_newslot(block11307);
// call case 6: other requests
// Begin line 3022
  setline(3022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe11315 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11316 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11315);
// compiled member node returning call11316 (depth = 5)
  params[0] = block11298;
  params[1] = block11307;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11317 = callmethodflags(call11316, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe11297);
// compiled call node returning call11317 (depth = 4)
// Begin line 3027
  setline(3027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_needsParens (depth = 5)
  Object if11318 = done;
  if (istrue(*var_needsParens)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit11320 == NULL) {
    strlit11320 = alloc_String(")");
    gc_root(strlit11320);
  }
// compiled string node returning strlit11320 (depth = 7)
  int op_slot_right_11319 = gc_frame_newslot(strlit11320);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_11319 = gc_frame_newslot(*var_s);
  params[0] = strlit11320;
  partcv[0] = 1;
  Object opresult11322 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult11322 (depth = 6)
  *var_s = opresult11322;
  if (opresult11322 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if11318 = done;
  } else {
  }
// compiled if node returning if11318 (depth = 4)
    gc_frame_newslot(if11318);
    if11262 = if11318;
  } else {
  }
// compiled if node returning if11262 (depth = 3)
// Begin line 3029
  setline(3029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_11324_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_requestPart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3033
  setline(3033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11325 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe11326 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe11327 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11328 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11327);
// compiled member node returning call11328 (depth = 5)
  gc_frame_newslot(call11328);
// starting to compile member node (depth = 5)
  int callframe11329 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11330 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11329);
// compiled member node returning call11330 (depth = 5)
  gc_frame_newslot(call11330);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_requestPart (depth = 5)
  params[0] = call11328;
  params[1] = call11330;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11331 = callmethodflags(*var_requestPart, "request(1)withArgs(1)", 2, partcv, params, 0);
  gc_frame_end(callframe11326);
// compiled call node returning call11331 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call11332 = callmethodflags(call11331, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe11325);
// compiled call node returning call11332 (depth = 3)
  gc_frame_end(frame);
  return call11332;
}
Object meth_ast_11333_postCopy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "postCopy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method postCopy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for postCopy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part postCopy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3036
  setline(3036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11334 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe11335 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call11336 = callmethodflags(*var_other, "lineLength", 1, partcv, params, 0);
  gc_frame_end(callframe11335);
// compiled member node returning call11336 (depth = 4)
  gc_frame_newslot(call11336);
// call case 4: self request
  params[0] = call11336;
  partcv[0] = 1;
  Object call11337 = callmethodflags(self, "lineLength:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11334);
// compiled call node returning call11337 (depth = 3)
// Begin line 3037
  setline(3037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_11338_statementName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3039
  setline(3039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit11339 == NULL) {
    strlit11339 = alloc_String("request");
    gc_root(strlit11339);
  }
// compiled string node returning strlit11339 (depth = 3)
  gc_frame_end(frame);
  return strlit11339;
}
Object meth_ast_10992_request_40_1_41_withArgs_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "request(1)withArgs(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request(_)withArgs(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request(_)withArgs(_)");
  Object params[1];
  int partcv[2];
  Object *var_requestPart = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for request(_)withArgs(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_rPart = &(stackframe->slots[0]);
  *var_rPart = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part request(_)");
  Object *var_xs = &(stackframe->slots[1]);
  *var_xs = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withArgs(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10993 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10993 = alloc_userobj2(18,15, objclass10993);
  gc_frame_newslot(obj10993);
  if (objclass10993 == NULL) {
    glfree(obj10993->class->name);
    obj10993->class->name = "requestPart.request(_)withArgs(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj10993, self, 0);
  addmethodreal(obj10993,"outer", &reader_ast_outer_10994);
  Object oldself10993 = self;
  struct StackFrameObject *oldstackframe10993 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10993);
  gc_frame_newslot((Object)stackframe);
  self = obj10993;
  Object *oldselfslot10993 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10993 = (*(struct UserObject *)self).data[0], lowerouter10993 = thisouter10993;
  if (inheritingObject10993) {
    struct UserObject *inho10993 = (struct UserObject *)inheritingObject10993;
    while (inho10993->super != GraceDefaultObject) inho10993 = (struct UserObject *)inho10993->super;
    inho10993->super = obj10993;
    self = inheritingObject10993;
    *selfslot = self;
    lowerouter10993 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10993;
  }
  if (objclass10993 == NULL) {
  Method *reader10995 = addmethodrealflags(obj10993, "kind",&reader_ast_kind_10995, MFLAG_DEF);
  reader10995->definitionModule = modulename;
  reader10995->definitionLine = 2967;
  }
  adddatum2(obj10993, alloc_Undefined(), 1);
  if (objclass10993 == NULL) {
    Method *reader10996 = addmethodrealflags(obj10993, "name", &reader_ast_name_10996, 0);
    Method *writer10996 = addmethodrealflags(obj10993, "name:=(1)", &writer_ast_name_10996, 0);
    reader10996->definitionModule = modulename;
    writer10996->definitionModule = modulename;
    reader10996->definitionLine = 2968;
    writer10996->definitionLine = 2968;
  }
  obj10993->flags |= OFLAG_MUTABLE;
  adddatum2(obj10993, alloc_Undefined(), 2);
  if (objclass10993 == NULL) {
    Method *reader10997 = addmethodrealflags(obj10993, "args", &reader_ast_args_10997, 0);
    Method *writer10997 = addmethodrealflags(obj10993, "args:=(1)", &writer_ast_args_10997, 0);
    reader10997->definitionModule = modulename;
    writer10997->definitionModule = modulename;
    reader10997->definitionLine = 2969;
    writer10997->definitionLine = 2969;
  }
  obj10993->flags |= OFLAG_MUTABLE;
  adddatum2(obj10993, alloc_Undefined(), 3);
  if (objclass10993 == NULL) {
    Method *reader10998 = addmethodrealflags(obj10993, "typeArgs", &reader_ast_typeArgs_10998, MFLAG_CONFIDENTIAL);
    Method *writer10998 = addmethodrealflags(obj10993, "typeArgs:=(1)", &writer_ast_typeArgs_10998, MFLAG_CONFIDENTIAL);
    reader10998->definitionModule = modulename;
    writer10998->definitionModule = modulename;
    reader10998->definitionLine = 2970;
    writer10998->definitionLine = 2970;
  }
  obj10993->flags |= OFLAG_MUTABLE;
  adddatum2(obj10993, alloc_Undefined(), 4);
  if (objclass10993 == NULL) {
    Method *reader10999 = addmethodrealflags(obj10993, "lineLength", &reader_ast_lineLength_10999, 0);
    Method *writer10999 = addmethodrealflags(obj10993, "lineLength:=(1)", &writer_ast_lineLength_10999, 0);
    reader10999->definitionModule = modulename;
    writer10999->definitionModule = modulename;
    reader10999->definitionLine = 2971;
    writer10999->definitionLine = 2971;
  }
  obj10993->flags |= OFLAG_MUTABLE;
  adddatum2(obj10993, alloc_Undefined(), 5);
// method "end"
  struct UserObject *uo11000 = (struct UserObject*)obj10993;
  uo11000->data[6] = emptyclosure;
  Method *meth_meth_ast_11000_end = addmethod2pos(obj10993, "end", &meth_ast_11000_end, 6);
  int argcv_meth_ast_11000_end[] = {0};
  meth_meth_ast_11000_end->type = alloc_MethodType(1, argcv_meth_ast_11000_end);
  meth_meth_ast_11000_end->definitionModule = modulename;
  meth_meth_ast_11000_end->definitionLine = 2973;
// method "nameString"
  struct UserObject *uo11047 = (struct UserObject*)obj10993;
  uo11047->data[7] = emptyclosure;
  Method *meth_meth_ast_11047_nameString = addmethod2pos(obj10993, "nameString", &meth_ast_11047_nameString, 7);
  int argcv_meth_ast_11047_nameString[] = {0};
  meth_meth_ast_11047_nameString->type = alloc_MethodType(1, argcv_meth_ast_11047_nameString);
  meth_meth_ast_11047_nameString->definitionModule = modulename;
  meth_meth_ast_11047_nameString->definitionLine = 2982;
// method "canonicalName"
  struct UserObject *uo11076 = (struct UserObject*)obj10993;
  uo11076->data[8] = emptyclosure;
  Method *meth_meth_ast_11076_canonicalName = addmethod2pos(obj10993, "canonicalName", &meth_ast_11076_canonicalName, 8);
  int argcv_meth_ast_11076_canonicalName[] = {0};
  meth_meth_ast_11076_canonicalName->type = alloc_MethodType(1, argcv_meth_ast_11076_canonicalName);
  meth_meth_ast_11076_canonicalName->definitionModule = modulename;
  meth_meth_ast_11076_canonicalName->definitionLine = 2987;
// method "map(_)ancestors(_)"
  struct UserObject *uo11122 = (struct UserObject*)obj10993;
  uo11122->data[9] = emptyclosure;
  Method *meth_meth_ast_11122_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj10993, "map(1)ancestors(1)", &meth_ast_11122_map_40_1_41_ancestors_40_1_41_, 9);
  int argcv_meth_ast_11122_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_11122_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_11122_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_11122_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11122_map_40_1_41_ancestors_40_1_41_->definitionLine = 2995;
// method "pretty(_)"
  struct UserObject *uo11135 = (struct UserObject*)obj10993;
  uo11135->data[10] = emptyclosure;
  Method *meth_meth_ast_11135_pretty_40_1_41_ = addmethod2pos(obj10993, "pretty(1)", &meth_ast_11135_pretty_40_1_41_, 10);
  int argcv_meth_ast_11135_pretty_40_1_41_[] = {1};
  meth_meth_ast_11135_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_11135_pretty_40_1_41_);
  meth_meth_ast_11135_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11135_pretty_40_1_41_->definitionLine = 3001;
// method "toGrace(_)"
  struct UserObject *uo11215 = (struct UserObject*)obj10993;
  uo11215->data[11] = emptyclosure;
  Method *meth_meth_ast_11215_toGrace_40_1_41_ = addmethod2pos(obj10993, "toGrace(1)", &meth_ast_11215_toGrace_40_1_41_, 11);
  int argcv_meth_ast_11215_toGrace_40_1_41_[] = {1};
  meth_meth_ast_11215_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_11215_toGrace_40_1_41_);
  meth_meth_ast_11215_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11215_toGrace_40_1_41_->definitionLine = 3010;
// method "shallowCopy"
  block_savedest(obj10993);
  Object closure11324 = createclosure(1, "shallowCopy");
  setclosureframe(closure11324, stackframe);
  addtoclosure(closure11324, var_requestPart);
  struct UserObject *uo11324 = (struct UserObject*)obj10993;
  uo11324->data[12] = (Object)closure11324;
  Method *meth_meth_ast_11324_shallowCopy = addmethod2pos(obj10993, "shallowCopy", &meth_ast_11324_shallowCopy, 12);
  int argcv_meth_ast_11324_shallowCopy[] = {0};
  meth_meth_ast_11324_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_11324_shallowCopy);
  meth_meth_ast_11324_shallowCopy->definitionModule = modulename;
  meth_meth_ast_11324_shallowCopy->definitionLine = 3032;
// method "postCopy(_)"
  struct UserObject *uo11333 = (struct UserObject*)obj10993;
  uo11333->data[13] = emptyclosure;
  Method *meth_meth_ast_11333_postCopy_40_1_41_ = addmethod2pos(obj10993, "postCopy(1)", &meth_ast_11333_postCopy_40_1_41_, 13);
  int argcv_meth_ast_11333_postCopy_40_1_41_[] = {1};
  meth_meth_ast_11333_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_11333_postCopy_40_1_41_);
  meth_meth_ast_11333_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11333_postCopy_40_1_41_->definitionLine = 3035;
// method "statementName"
  struct UserObject *uo11338 = (struct UserObject*)obj10993;
  uo11338->data[14] = emptyclosure;
  Method *meth_meth_ast_11338_statementName = addmethod2pos(obj10993, "statementName", &meth_ast_11338_statementName, 14);
  int argcv_meth_ast_11338_statementName[] = {0};
  meth_meth_ast_11338_statementName->type = alloc_MethodType(1, argcv_meth_ast_11338_statementName);
  meth_meth_ast_11338_statementName->definitionModule = modulename;
  meth_meth_ast_11338_statementName->definitionLine = 3039;
  sourceObject = obj10993;
// Begin line 2966
  setline(2966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11340 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call11341 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11340);
// compiled call node returning call11341 (depth = 3)
  struct UserObject *obj10993_uo = (struct UserObject *)obj10993;
  obj10993_uo->super = call11341;
  sourceObject = obj10993;
// Begin line 2967
  setline(2967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit11342 == NULL) {
    strlit11342 = alloc_String("callwithpart");
    gc_root(strlit11342);
  }
// compiled string node returning strlit11342 (depth = 3)
  adddatum2(obj10993, strlit11342, 1);
  sourceObject = obj10993;
// Begin line 2968
  setline(2968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_rPart (depth = 3)
  adddatum2(obj10993, *var_rPart, 2);
  sourceObject = obj10993;
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_xs (depth = 3)
  adddatum2(obj10993, *var_xs, 3);
  sourceObject = obj10993;
// Begin line 2970
  setline(2970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySeq (depth = 3)
  adddatum2(obj10993, *var_emptySeq, 4);
  sourceObject = obj10993;
// Begin line 2971
  setline(2971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num11343 = alloc_Float64(0);
// compiled num node returning num11343 (depth = 3)
  adddatum2(obj10993, num11343, 5);
  sourceObject = obj10993;
  sourceObject = obj10993;
  sourceObject = obj10993;
  sourceObject = obj10993;
  sourceObject = obj10993;
  sourceObject = obj10993;
  sourceObject = obj10993;
  sourceObject = obj10993;
  sourceObject = obj10993;
  objclass10993 = obj10993->class;
  objclass10993->definitionModule = modulename;
  objclass10993->definitionLine = 2965;
  (*(struct UserObject *)self).data[0] = lowerouter10993;
  self = oldself10993;
  selfslot = oldselfslot10993;
  stackframe = oldstackframe10993;
  gc_frame_end(frame);
  return obj10993;
}
Object meth_ast_10992_request_40_1_41_withArgs_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "request(1)withArgs(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method request(_)withArgs(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method request(_)withArgs(_)");
  Object params[1];
  int partcv[2];
  Object *var_requestPart = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for request(_)withArgs(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_rPart = &(stackframe->slots[0]);
  *var_rPart = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part request(_)");
  Object *var_xs = &(stackframe->slots[1]);
  *var_xs = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withArgs(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10993 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10993 = alloc_userobj2(18,15, objclass10993);
  gc_frame_newslot(obj10993);
  if (objclass10993 == NULL) {
    glfree(obj10993->class->name);
    obj10993->class->name = "requestPart.request(_)withArgs(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj10993, self, 0);
  addmethodreal(obj10993,"outer", &reader_ast_outer_10994);
  Object oldself10993 = self;
  struct StackFrameObject *oldstackframe10993 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10993);
  gc_frame_newslot((Object)stackframe);
  self = obj10993;
  Object *oldselfslot10993 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10993 = (*(struct UserObject *)self).data[0], lowerouter10993 = thisouter10993;
  if (inheritingObject10993) {
    struct UserObject *inho10993 = (struct UserObject *)inheritingObject10993;
    while (inho10993->super != GraceDefaultObject) inho10993 = (struct UserObject *)inho10993->super;
    inho10993->super = obj10993;
    self = inheritingObject10993;
    *selfslot = self;
    lowerouter10993 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10993;
  }
  if (objclass10993 == NULL) {
  Method *reader10995 = addmethodrealflags(obj10993, "kind",&reader_ast_kind_10995, MFLAG_DEF);
  reader10995->definitionModule = modulename;
  reader10995->definitionLine = 2967;
  }
  adddatum2(obj10993, alloc_Undefined(), 1);
  if (objclass10993 == NULL) {
    Method *reader10996 = addmethodrealflags(obj10993, "name", &reader_ast_name_10996, 0);
    Method *writer10996 = addmethodrealflags(obj10993, "name:=(1)", &writer_ast_name_10996, 0);
    reader10996->definitionModule = modulename;
    writer10996->definitionModule = modulename;
    reader10996->definitionLine = 2968;
    writer10996->definitionLine = 2968;
  }
  obj10993->flags |= OFLAG_MUTABLE;
  adddatum2(obj10993, alloc_Undefined(), 2);
  if (objclass10993 == NULL) {
    Method *reader10997 = addmethodrealflags(obj10993, "args", &reader_ast_args_10997, 0);
    Method *writer10997 = addmethodrealflags(obj10993, "args:=(1)", &writer_ast_args_10997, 0);
    reader10997->definitionModule = modulename;
    writer10997->definitionModule = modulename;
    reader10997->definitionLine = 2969;
    writer10997->definitionLine = 2969;
  }
  obj10993->flags |= OFLAG_MUTABLE;
  adddatum2(obj10993, alloc_Undefined(), 3);
  if (objclass10993 == NULL) {
    Method *reader10998 = addmethodrealflags(obj10993, "typeArgs", &reader_ast_typeArgs_10998, MFLAG_CONFIDENTIAL);
    Method *writer10998 = addmethodrealflags(obj10993, "typeArgs:=(1)", &writer_ast_typeArgs_10998, MFLAG_CONFIDENTIAL);
    reader10998->definitionModule = modulename;
    writer10998->definitionModule = modulename;
    reader10998->definitionLine = 2970;
    writer10998->definitionLine = 2970;
  }
  obj10993->flags |= OFLAG_MUTABLE;
  adddatum2(obj10993, alloc_Undefined(), 4);
  if (objclass10993 == NULL) {
    Method *reader10999 = addmethodrealflags(obj10993, "lineLength", &reader_ast_lineLength_10999, 0);
    Method *writer10999 = addmethodrealflags(obj10993, "lineLength:=(1)", &writer_ast_lineLength_10999, 0);
    reader10999->definitionModule = modulename;
    writer10999->definitionModule = modulename;
    reader10999->definitionLine = 2971;
    writer10999->definitionLine = 2971;
  }
  obj10993->flags |= OFLAG_MUTABLE;
  adddatum2(obj10993, alloc_Undefined(), 5);
// method "end"
  struct UserObject *uo11000 = (struct UserObject*)obj10993;
  uo11000->data[6] = emptyclosure;
  Method *meth_meth_ast_11000_end = addmethod2pos(obj10993, "end", &meth_ast_11000_end, 6);
  int argcv_meth_ast_11000_end[] = {0};
  meth_meth_ast_11000_end->type = alloc_MethodType(1, argcv_meth_ast_11000_end);
  meth_meth_ast_11000_end->definitionModule = modulename;
  meth_meth_ast_11000_end->definitionLine = 2973;
// method "nameString"
  struct UserObject *uo11047 = (struct UserObject*)obj10993;
  uo11047->data[7] = emptyclosure;
  Method *meth_meth_ast_11047_nameString = addmethod2pos(obj10993, "nameString", &meth_ast_11047_nameString, 7);
  int argcv_meth_ast_11047_nameString[] = {0};
  meth_meth_ast_11047_nameString->type = alloc_MethodType(1, argcv_meth_ast_11047_nameString);
  meth_meth_ast_11047_nameString->definitionModule = modulename;
  meth_meth_ast_11047_nameString->definitionLine = 2982;
// method "canonicalName"
  struct UserObject *uo11076 = (struct UserObject*)obj10993;
  uo11076->data[8] = emptyclosure;
  Method *meth_meth_ast_11076_canonicalName = addmethod2pos(obj10993, "canonicalName", &meth_ast_11076_canonicalName, 8);
  int argcv_meth_ast_11076_canonicalName[] = {0};
  meth_meth_ast_11076_canonicalName->type = alloc_MethodType(1, argcv_meth_ast_11076_canonicalName);
  meth_meth_ast_11076_canonicalName->definitionModule = modulename;
  meth_meth_ast_11076_canonicalName->definitionLine = 2987;
// method "map(_)ancestors(_)"
  struct UserObject *uo11122 = (struct UserObject*)obj10993;
  uo11122->data[9] = emptyclosure;
  Method *meth_meth_ast_11122_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj10993, "map(1)ancestors(1)", &meth_ast_11122_map_40_1_41_ancestors_40_1_41_, 9);
  int argcv_meth_ast_11122_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_11122_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_11122_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_11122_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11122_map_40_1_41_ancestors_40_1_41_->definitionLine = 2995;
// method "pretty(_)"
  struct UserObject *uo11135 = (struct UserObject*)obj10993;
  uo11135->data[10] = emptyclosure;
  Method *meth_meth_ast_11135_pretty_40_1_41_ = addmethod2pos(obj10993, "pretty(1)", &meth_ast_11135_pretty_40_1_41_, 10);
  int argcv_meth_ast_11135_pretty_40_1_41_[] = {1};
  meth_meth_ast_11135_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_11135_pretty_40_1_41_);
  meth_meth_ast_11135_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11135_pretty_40_1_41_->definitionLine = 3001;
// method "toGrace(_)"
  struct UserObject *uo11215 = (struct UserObject*)obj10993;
  uo11215->data[11] = emptyclosure;
  Method *meth_meth_ast_11215_toGrace_40_1_41_ = addmethod2pos(obj10993, "toGrace(1)", &meth_ast_11215_toGrace_40_1_41_, 11);
  int argcv_meth_ast_11215_toGrace_40_1_41_[] = {1};
  meth_meth_ast_11215_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_11215_toGrace_40_1_41_);
  meth_meth_ast_11215_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11215_toGrace_40_1_41_->definitionLine = 3010;
// method "shallowCopy"
  block_savedest(obj10993);
  Object closure11324 = createclosure(1, "shallowCopy");
  setclosureframe(closure11324, stackframe);
  addtoclosure(closure11324, var_requestPart);
  struct UserObject *uo11324 = (struct UserObject*)obj10993;
  uo11324->data[12] = (Object)closure11324;
  Method *meth_meth_ast_11324_shallowCopy = addmethod2pos(obj10993, "shallowCopy", &meth_ast_11324_shallowCopy, 12);
  int argcv_meth_ast_11324_shallowCopy[] = {0};
  meth_meth_ast_11324_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_11324_shallowCopy);
  meth_meth_ast_11324_shallowCopy->definitionModule = modulename;
  meth_meth_ast_11324_shallowCopy->definitionLine = 3032;
// method "postCopy(_)"
  struct UserObject *uo11333 = (struct UserObject*)obj10993;
  uo11333->data[13] = emptyclosure;
  Method *meth_meth_ast_11333_postCopy_40_1_41_ = addmethod2pos(obj10993, "postCopy(1)", &meth_ast_11333_postCopy_40_1_41_, 13);
  int argcv_meth_ast_11333_postCopy_40_1_41_[] = {1};
  meth_meth_ast_11333_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_11333_postCopy_40_1_41_);
  meth_meth_ast_11333_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11333_postCopy_40_1_41_->definitionLine = 3035;
// method "statementName"
  struct UserObject *uo11338 = (struct UserObject*)obj10993;
  uo11338->data[14] = emptyclosure;
  Method *meth_meth_ast_11338_statementName = addmethod2pos(obj10993, "statementName", &meth_ast_11338_statementName, 14);
  int argcv_meth_ast_11338_statementName[] = {0};
  meth_meth_ast_11338_statementName->type = alloc_MethodType(1, argcv_meth_ast_11338_statementName);
  meth_meth_ast_11338_statementName->definitionModule = modulename;
  meth_meth_ast_11338_statementName->definitionLine = 3039;
  sourceObject = obj10993;
// Begin line 2966
  setline(2966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11340 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call11341 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11340);
// compiled call node returning call11341 (depth = 3)
  struct UserObject *obj10993_uo = (struct UserObject *)obj10993;
  obj10993_uo->super = call11341;
  sourceObject = obj10993;
// Begin line 2967
  setline(2967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit11342 == NULL) {
    strlit11342 = alloc_String("callwithpart");
    gc_root(strlit11342);
  }
// compiled string node returning strlit11342 (depth = 3)
  adddatum2(obj10993, strlit11342, 1);
  sourceObject = obj10993;
// Begin line 2968
  setline(2968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_rPart (depth = 3)
  adddatum2(obj10993, *var_rPart, 2);
  sourceObject = obj10993;
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_xs (depth = 3)
  adddatum2(obj10993, *var_xs, 3);
  sourceObject = obj10993;
// Begin line 2970
  setline(2970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySeq (depth = 3)
  adddatum2(obj10993, *var_emptySeq, 4);
  sourceObject = obj10993;
// Begin line 2971
  setline(2971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num11343 = alloc_Float64(0);
// compiled num node returning num11343 (depth = 3)
  adddatum2(obj10993, num11343, 5);
  sourceObject = obj10993;
  sourceObject = obj10993;
  sourceObject = obj10993;
  sourceObject = obj10993;
  sourceObject = obj10993;
  sourceObject = obj10993;
  sourceObject = obj10993;
  sourceObject = obj10993;
  sourceObject = obj10993;
  objclass10993 = obj10993->class;
  objclass10993->definitionModule = modulename;
  objclass10993->definitionLine = 2965;
  (*(struct UserObject *)self).data[0] = lowerouter10993;
  self = oldself10993;
  selfslot = oldselfslot10993;
  stackframe = oldstackframe10993;
  gc_frame_end(frame);
  return obj10993;
}
Object meth_ast_11345_requestPart(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 58, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "requestPart");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_requestPart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2957
  setline(2957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_requestPart (depth = 3)
  gc_frame_end(frame);
  return *var_requestPart;
}
Object meth_ast_11356_end(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "end");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3052
  setline(3052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11357 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe11358 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11359 = callmethodflags(self, "endLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11358);
// compiled member node returning call11359 (depth = 4)
  gc_frame_newslot(call11359);
// starting to compile member node (depth = 4)
  int callframe11360 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe11361 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe11362 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11363 = callmethodflags(self, "endLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11362);
// compiled member node returning call11363 (depth = 6)
  gc_frame_newslot(call11363);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe11364 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call11365 = callmethodflags(*var_util, "lines", 1, partcv, params, 0);
  gc_frame_end(callframe11364);
// compiled member node returning call11365 (depth = 6)
  params[0] = call11363;
  partcv[0] = 1;
  Object call11366 = callmethodflags(call11365, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe11361);
// compiled call node returning call11366 (depth = 5)
  partcv[0] = 0;
  Object call11367 = callmethodflags(call11366, "size", 1, partcv, params, 0);
  gc_frame_end(callframe11360);
// compiled member node returning call11367 (depth = 4)
  gc_frame_newslot(call11367);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = call11359;
  params[1] = call11367;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11368 = callmethodflags(module_ast, "line(1)column(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11357);
// compiled call node returning call11368 (depth = 3)
  gc_frame_end(frame);
  return call11368;
}
Object meth_ast_11369_isComment(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isComment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3053
  setline(3053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool11370 = alloc_Boolean(1);
// compiled identifier node returning bool11370 (depth = 3)
  gc_frame_end(frame);
  return bool11370;
}
Object meth_ast_11371_isLegalInTrait(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isLegalInTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3054
  setline(3054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool11372 = alloc_Boolean(1);
// compiled identifier node returning bool11372 (depth = 3)
  gc_frame_end(frame);
  return bool11372;
}
Object meth_ast_11373_isExecutable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3055
  setline(3055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool11374 = alloc_Boolean(0);
// compiled identifier node returning bool11374 (depth = 3)
  gc_frame_end(frame);
  return bool11374;
}
Object meth_ast_11375_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3056
  setline(3056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit11377 == NULL) {
    strlit11377 = alloc_String("");
    gc_root(strlit11377);
  }
// compiled string node returning strlit11377 (depth = 4)
  int op_slot_right_11376 = gc_frame_newslot(strlit11377);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe11380 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11381 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11380);
// compiled member node returning call11381 (depth = 5)
  int op_slot_right_11379 = gc_frame_newslot(call11381);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit11384 == NULL) {
    strlit11384 = alloc_String("): ");
    gc_root(strlit11384);
  }
// compiled string node returning strlit11384 (depth = 6)
  int op_slot_right_11383 = gc_frame_newslot(strlit11384);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe11387 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11388 = callmethodflags(self, "endLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11387);
// compiled member node returning call11388 (depth = 7)
  int op_slot_right_11386 = gc_frame_newslot(call11388);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit11391 == NULL) {
    strlit11391 = alloc_String("""\xe2""""\x80""""\x93""");
    gc_root(strlit11391);
  }
// compiled string node returning strlit11391 (depth = 8)
  int op_slot_right_11390 = gc_frame_newslot(strlit11391);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe11394 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11395 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11394);
// compiled member node returning call11395 (depth = 9)
  int op_slot_right_11393 = gc_frame_newslot(call11395);
// starting to compile string node (depth = 9)
  if (strlit11397 == NULL) {
    strlit11397 = alloc_String("comment (");
    gc_root(strlit11397);
  }
// compiled string node returning strlit11397 (depth = 9)
  int op_slot_left_11393 = gc_frame_newslot(strlit11397);
  params[0] = call11395;
  partcv[0] = 1;
  Object opresult11398 = callmethod(strlit11397, "++(1)", 1, partcv, params);
// compiled op node returning opresult11398 (depth = 8)
  int op_slot_left_11390 = gc_frame_newslot(opresult11398);
  params[0] = strlit11391;
  partcv[0] = 1;
  Object opresult11399 = callmethod(opresult11398, "++(1)", 1, partcv, params);
// compiled op node returning opresult11399 (depth = 7)
  int op_slot_left_11386 = gc_frame_newslot(opresult11399);
  params[0] = call11388;
  partcv[0] = 1;
  Object opresult11400 = callmethod(opresult11399, "++(1)", 1, partcv, params);
// compiled op node returning opresult11400 (depth = 6)
  int op_slot_left_11383 = gc_frame_newslot(opresult11400);
  params[0] = strlit11384;
  partcv[0] = 1;
  Object opresult11401 = callmethod(opresult11400, "++(1)", 1, partcv, params);
// compiled op node returning opresult11401 (depth = 5)
  int op_slot_left_11379 = gc_frame_newslot(opresult11401);
  params[0] = call11381;
  partcv[0] = 1;
  Object opresult11402 = callmethod(opresult11401, "++(1)", 1, partcv, params);
// compiled op node returning opresult11402 (depth = 4)
  int op_slot_left_11376 = gc_frame_newslot(opresult11402);
  params[0] = strlit11377;
  partcv[0] = 1;
  Object opresult11403 = callmethod(opresult11402, "++(1)", 1, partcv, params);
// compiled op node returning opresult11403 (depth = 3)
  gc_frame_end(frame);
  return opresult11403;
}
Object meth_ast_11404_extendCommentUsing_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "extendCommentUsing(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method extendCommentUsing(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for extendCommentUsing(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cmtNode = &(stackframe->slots[0]);
  *var_cmtNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part extendCommentUsing(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3058
  setline(3058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11405 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe11407 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cmtNode (depth = 6)
  partcv[0] = 0;
  Object call11408 = callmethodflags(*var_cmtNode, "value", 1, partcv, params, 0);
  gc_frame_end(callframe11407);
// compiled member node returning call11408 (depth = 5)
  int op_slot_right_11406 = gc_frame_newslot(call11408);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit11411 == NULL) {
    strlit11411 = alloc_String(" ");
    gc_root(strlit11411);
  }
// compiled string node returning strlit11411 (depth = 6)
  int op_slot_right_11410 = gc_frame_newslot(strlit11411);
// starting to compile member node (depth = 6)
  int callframe11413 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11414 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11413);
// compiled member node returning call11414 (depth = 6)
  int op_slot_left_11410 = gc_frame_newslot(call11414);
  params[0] = strlit11411;
  partcv[0] = 1;
  Object opresult11415 = callmethod(call11414, "++(1)", 1, partcv, params);
// compiled op node returning opresult11415 (depth = 5)
  int op_slot_left_11406 = gc_frame_newslot(opresult11415);
  params[0] = call11408;
  partcv[0] = 1;
  Object opresult11416 = callmethod(opresult11415, "++(1)", 1, partcv, params);
// compiled op node returning opresult11416 (depth = 4)
  gc_frame_newslot(opresult11416);
// call case 4: self request
  params[0] = opresult11416;
  partcv[0] = 1;
  Object call11417 = callmethodflags(self, "value:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11405);
// compiled call node returning call11417 (depth = 3)
// Begin line 3059
  setline(3059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11418 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe11419 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cmtNode (depth = 5)
  partcv[0] = 0;
  Object call11420 = callmethodflags(*var_cmtNode, "endLine", 1, partcv, params, 0);
  gc_frame_end(callframe11419);
// compiled member node returning call11420 (depth = 4)
  gc_frame_newslot(call11420);
// call case 4: self request
  params[0] = call11420;
  partcv[0] = 1;
  Object call11421 = callmethodflags(self, "endLine:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11418);
// compiled call node returning call11421 (depth = 3)
  gc_frame_end(frame);
  return call11421;
}
Object meth_ast_11422_map_40_1_41_ancestors_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 3062
  setline(3062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe11423 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11424 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11423);
// compiled member node returning call11424 (depth = 4)
  *var_n = call11424;
  if (call11424 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 3063
  setline(3063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11425 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call11426 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe11425);
// compiled call node returning call11426 (depth = 4)
  *var_newChain = call11426;
  if (call11426 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 3064
  setline(3064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11427 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call11428 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe11427);
// compiled call node returning call11428 (depth = 3)
  gc_frame_end(frame);
  return call11428;
}
Object meth_ast_11429_accept_40_1_41_from_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3067
  setline(3067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11430 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11431 = callmethodflags(*var_visitor, "visitComment(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe11430);
// compiled call node returning call11431 (depth = 3)
  gc_frame_end(frame);
  return call11431;
}
Object meth_ast_11440__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3072
  setline(3072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit11442 == NULL) {
    strlit11442 = alloc_String("  ");
    gc_root(strlit11442);
  }
// compiled string node returning strlit11442 (depth = 7)
  int op_slot_right_11441 = gc_frame_newslot(strlit11442);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_11441 = gc_frame_newslot(*var_s);
  params[0] = strlit11442;
  partcv[0] = 1;
  Object opresult11444 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult11444 (depth = 6)
  *var_s = opresult11444;
  if (opresult11444 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_11432_pretty_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
  Object *var_pb = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "pb");
// Begin line 3070
  setline(3070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit11433 == NULL) {
    strlit11433 = alloc_String("""\x0a""");
    gc_root(strlit11433);
  }
// compiled string node returning strlit11433 (depth = 4)
  *var_s = strlit11433;
  if (strlit11433 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 3071
  setline(3071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11434 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num11436 = alloc_Float64(1);
// compiled num node returning num11436 (depth = 5)
  int op_slot_right_11435 = gc_frame_newslot(num11436);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_left_11435 = gc_frame_newslot(*var_depth);
  params[0] = num11436;
  partcv[0] = 1;
  Object diff11438 = callmethod(*var_depth, "-(1)", 1, partcv, params);
// compiled op node returning diff11438 (depth = 4)
  gc_frame_newslot(diff11438);
// starting to compile block node (depth = 4)
  Object block11439 = alloc_Block(NULL, NULL, "ast", 3071);
  gc_frame_newslot(block11439);
// method "_apply"
  block_savedest(block11439);
  Object closure11440 = createclosure(2, "_apply");
  setclosureframe(closure11440, stackframe);
  addtoclosure(closure11440, var_s);
  addtoclosure(closure11440, selfslot);
  struct UserObject *uo11440 = (struct UserObject*)block11439;
  uo11440->data[0] = (Object)closure11440;
  Method *meth_meth_ast_11440__apply = addmethod2pos(block11439, "_apply", &meth_ast_11440__apply, 0);
  int argcv_meth_ast_11440__apply[] = {0};
  meth_meth_ast_11440__apply->type = alloc_MethodType(1, argcv_meth_ast_11440__apply);
  meth_meth_ast_11440__apply->definitionModule = modulename;
  meth_meth_ast_11440__apply->definitionLine = 3050;
// compiled block node returning block11439 (depth = 4)
  gc_frame_newslot(block11439);
// call case 5: prelude request
  params[0] = diff11438;
  params[1] = block11439;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11447 = callmethodflags(prelude, "repeat(1)times(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11434);
// compiled call node returning call11447 (depth = 3)
// Begin line 3074
  setline(3074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe11449 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11450 = callmethodflags(self, "isPreceededByBlankLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11449);
// compiled member node returning call11450 (depth = 5)
  Object if11448 = done;
struct StackFrameObject *iftmpstackframe11448 = stackframe;
  if (istrue(call11450)) {
stackframe = alloc_StackFrame(0, iftmpstackframe11448);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile string node (depth = 5)
  if (strlit11451 == NULL) {
    strlit11451 = alloc_String(" > blank");
    gc_root(strlit11451);
  }
// compiled string node returning strlit11451 (depth = 5)
    gc_frame_newslot(strlit11451);
    if11448 = strlit11451;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe11448);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile string node (depth = 5)
  if (strlit11452 == NULL) {
    strlit11452 = alloc_String("");
    gc_root(strlit11452);
  }
// compiled string node returning strlit11452 (depth = 5)
    gc_frame_newslot(strlit11452);
    if11448 = strlit11452;
  }
stackframe = iftmpstackframe11448;
// compiled if node returning if11448 (depth = 4)
  *var_pb = if11448;
  if (if11448 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 3075
  setline(3075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit11454 == NULL) {
    strlit11454 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit11454);
  }
// compiled string node returning strlit11454 (depth = 4)
  int op_slot_right_11453 = gc_frame_newslot(strlit11454);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe11457 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11458 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11457);
// compiled member node returning call11458 (depth = 5)
  int op_slot_right_11456 = gc_frame_newslot(call11458);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit11461 == NULL) {
    strlit11461 = alloc_String("): ""\xe2""""\x80""""\xb9""");
    gc_root(strlit11461);
  }
// compiled string node returning strlit11461 (depth = 6)
  int op_slot_right_11460 = gc_frame_newslot(strlit11461);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe11464 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11465 = callmethodflags(self, "endLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11464);
// compiled member node returning call11465 (depth = 7)
  int op_slot_right_11463 = gc_frame_newslot(call11465);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit11468 == NULL) {
    strlit11468 = alloc_String("""\xe2""""\x80""""\x93""");
    gc_root(strlit11468);
  }
// compiled string node returning strlit11468 (depth = 8)
  int op_slot_right_11467 = gc_frame_newslot(strlit11468);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe11471 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11472 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11471);
// compiled member node returning call11472 (depth = 9)
  int op_slot_right_11470 = gc_frame_newslot(call11472);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit11475 == NULL) {
    strlit11475 = alloc_String("(");
    gc_root(strlit11475);
  }
// compiled string node returning strlit11475 (depth = 10)
  int op_slot_right_11474 = gc_frame_newslot(strlit11475);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_pb (depth = 11)
  int op_slot_right_11477 = gc_frame_newslot(*var_pb);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit11480 == NULL) {
    strlit11480 = alloc_String("Comment");
    gc_root(strlit11480);
  }
// compiled string node returning strlit11480 (depth = 12)
  int op_slot_right_11479 = gc_frame_newslot(strlit11480);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_11482 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit11484 == NULL) {
    strlit11484 = alloc_String("");
    gc_root(strlit11484);
  }
// compiled string node returning strlit11484 (depth = 13)
  int op_slot_left_11482 = gc_frame_newslot(strlit11484);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult11485 = callmethod(strlit11484, "++(1)", 1, partcv, params);
// compiled op node returning opresult11485 (depth = 12)
  int op_slot_left_11479 = gc_frame_newslot(opresult11485);
  params[0] = strlit11480;
  partcv[0] = 1;
  Object opresult11486 = callmethod(opresult11485, "++(1)", 1, partcv, params);
// compiled op node returning opresult11486 (depth = 11)
  int op_slot_left_11477 = gc_frame_newslot(opresult11486);
  params[0] = *var_pb;
  partcv[0] = 1;
  Object opresult11487 = callmethod(opresult11486, "++(1)", 1, partcv, params);
// compiled op node returning opresult11487 (depth = 10)
  int op_slot_left_11474 = gc_frame_newslot(opresult11487);
  params[0] = strlit11475;
  partcv[0] = 1;
  Object opresult11488 = callmethod(opresult11487, "++(1)", 1, partcv, params);
// compiled op node returning opresult11488 (depth = 9)
  int op_slot_left_11470 = gc_frame_newslot(opresult11488);
  params[0] = call11472;
  partcv[0] = 1;
  Object opresult11489 = callmethod(opresult11488, "++(1)", 1, partcv, params);
// compiled op node returning opresult11489 (depth = 8)
  int op_slot_left_11467 = gc_frame_newslot(opresult11489);
  params[0] = strlit11468;
  partcv[0] = 1;
  Object opresult11490 = callmethod(opresult11489, "++(1)", 1, partcv, params);
// compiled op node returning opresult11490 (depth = 7)
  int op_slot_left_11463 = gc_frame_newslot(opresult11490);
  params[0] = call11465;
  partcv[0] = 1;
  Object opresult11491 = callmethod(opresult11490, "++(1)", 1, partcv, params);
// compiled op node returning opresult11491 (depth = 6)
  int op_slot_left_11460 = gc_frame_newslot(opresult11491);
  params[0] = strlit11461;
  partcv[0] = 1;
  Object opresult11492 = callmethod(opresult11491, "++(1)", 1, partcv, params);
// compiled op node returning opresult11492 (depth = 5)
  int op_slot_left_11456 = gc_frame_newslot(opresult11492);
  params[0] = call11458;
  partcv[0] = 1;
  Object opresult11493 = callmethod(opresult11492, "++(1)", 1, partcv, params);
// compiled op node returning opresult11493 (depth = 4)
  int op_slot_left_11453 = gc_frame_newslot(opresult11493);
  params[0] = strlit11454;
  partcv[0] = 1;
  Object opresult11494 = callmethod(opresult11493, "++(1)", 1, partcv, params);
// compiled op node returning opresult11494 (depth = 3)
  gc_frame_end(frame);
  return opresult11494;
}
Object meth_ast_11495_toGrace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[3];
  int partcv[3];
  Object *var_lineLength = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
// Begin line 3080
  setline(3080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe11497 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11498 = callmethodflags(self, "isPartialLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11497);
// compiled member node returning call11498 (depth = 4)
  Object if11496 = done;
  if (istrue(call11498)) {
// Begin line 3081
  setline(3081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit11500 == NULL) {
    strlit11500 = alloc_String("");
    gc_root(strlit11500);
  }
// compiled string node returning strlit11500 (depth = 5)
  int op_slot_right_11499 = gc_frame_newslot(strlit11500);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe11503 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11504 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11503);
// compiled member node returning call11504 (depth = 6)
  int op_slot_right_11502 = gc_frame_newslot(call11504);
// starting to compile string node (depth = 6)
  if (strlit11506 == NULL) {
    strlit11506 = alloc_String("// (partial) ");
    gc_root(strlit11506);
  }
// compiled string node returning strlit11506 (depth = 6)
  int op_slot_left_11502 = gc_frame_newslot(strlit11506);
  params[0] = call11504;
  partcv[0] = 1;
  Object opresult11507 = callmethod(strlit11506, "++(1)", 1, partcv, params);
// compiled op node returning opresult11507 (depth = 5)
  int op_slot_left_11499 = gc_frame_newslot(opresult11507);
  params[0] = strlit11500;
  partcv[0] = 1;
  Object opresult11508 = callmethod(opresult11507, "++(1)", 1, partcv, params);
// compiled op node returning opresult11508 (depth = 4)
    gc_frame_newslot(opresult11508);
    if11496 = opresult11508;
  } else {
// Begin line 3083
  setline(3083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_11509 = gc_frame_newslot(*var_depth);
// starting to compile string node (depth = 6)
  if (strlit11511 == NULL) {
    strlit11511 = alloc_String("    ");
    gc_root(strlit11511);
  }
// compiled string node returning strlit11511 (depth = 6)
  int op_slot_left_11509 = gc_frame_newslot(strlit11511);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object prod11512 = callmethod(strlit11511, "*(1)", 1, partcv, params);
// compiled op node returning prod11512 (depth = 5)
  *var_spc = prod11512;
  if (prod11512 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3084
  setline(3084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11513 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe11514 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11515 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11514);
// compiled member node returning call11515 (depth = 5)
  gc_frame_newslot(call11515);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineLength (depth = 5)
  gc_frame_newslot(*var_lineLength);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit11517 == NULL) {
    strlit11517 = alloc_String("// ");
    gc_root(strlit11517);
  }
// compiled string node returning strlit11517 (depth = 6)
  int op_slot_right_11516 = gc_frame_newslot(strlit11517);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_left_11516 = gc_frame_newslot(*var_spc);
  params[0] = strlit11517;
  partcv[0] = 1;
  Object opresult11519 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult11519 (depth = 5)
  gc_frame_newslot(opresult11519);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_ast (depth = 5)
  params[0] = call11515;
  params[1] = *var_lineLength;
  params[2] = opresult11519;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call11520 = callmethodflags(module_ast, "wrap(1)to(1)prefix(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11513);
// compiled call node returning call11520 (depth = 4)
    gc_frame_newslot(call11520);
    if11496 = call11520;
  }
// compiled if node returning if11496 (depth = 3)
  gc_frame_end(frame);
  return if11496;
}
Object meth_ast_11521_shallowCopy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_commentNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3088
  setline(3088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11522 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe11523 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_commentNode (depth = 5)
  params[0] = *var_nullNode;
  partcv[0] = 1;
  Object call11524 = callmethodflags(*var_commentNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe11523);
// compiled call node returning call11524 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call11525 = callmethodflags(call11524, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe11522);
// compiled call node returning call11525 (depth = 3)
  gc_frame_end(frame);
  return call11525;
}
Object meth_ast_11526_postCopy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "postCopy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method postCopy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for postCopy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part postCopy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3091
  setline(3091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11527 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe11528 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call11529 = callmethodflags(*var_other, "value", 1, partcv, params, 0);
  gc_frame_end(callframe11528);
// compiled member node returning call11529 (depth = 4)
  gc_frame_newslot(call11529);
// call case 4: self request
  params[0] = call11529;
  partcv[0] = 1;
  Object call11530 = callmethodflags(self, "value:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11527);
// compiled call node returning call11530 (depth = 3)
// Begin line 3092
  setline(3092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11531 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe11532 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call11533 = callmethodflags(*var_other, "isPartialLine", 1, partcv, params, 0);
  gc_frame_end(callframe11532);
// compiled member node returning call11533 (depth = 4)
  gc_frame_newslot(call11533);
// call case 4: self request
  params[0] = call11533;
  partcv[0] = 1;
  Object call11534 = callmethodflags(self, "isPartialLine:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11531);
// compiled call node returning call11534 (depth = 3)
// Begin line 3093
  setline(3093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11535 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe11536 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call11537 = callmethodflags(*var_other, "isPreceededByBlankLine", 1, partcv, params, 0);
  gc_frame_end(callframe11536);
// compiled member node returning call11537 (depth = 4)
  gc_frame_newslot(call11537);
// call case 4: self request
  params[0] = call11537;
  partcv[0] = 1;
  Object call11538 = callmethodflags(self, "isPreceededByBlankLine:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11535);
// compiled call node returning call11538 (depth = 3)
// Begin line 3094
  setline(3094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11539 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe11540 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call11541 = callmethodflags(*var_other, "endLine", 1, partcv, params, 0);
  gc_frame_end(callframe11540);
// compiled member node returning call11541 (depth = 4)
  gc_frame_newslot(call11541);
// call case 4: self request
  params[0] = call11541;
  partcv[0] = 1;
  Object call11542 = callmethodflags(self, "endLine:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11539);
// compiled call node returning call11542 (depth = 3)
// Begin line 3095
  setline(3095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_11348_new_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_lineLength = getfromclosure(closure, 1);
  Object *var_nullNode = getfromclosure(closure, 2);
  Object *var_commentNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val_39_ = &(stackframe->slots[0]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject11349 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj11349 = alloc_userobj2(21,18, objclass11349);
  gc_frame_newslot(obj11349);
  if (objclass11349 == NULL) {
    glfree(obj11349->class->name);
    obj11349->class->name = "commentNode.new(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj11349, self, 0);
  addmethodreal(obj11349,"outer", &reader_ast_outer_11350);
  Object oldself11349 = self;
  struct StackFrameObject *oldstackframe11349 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe11349);
  gc_frame_newslot((Object)stackframe);
  self = obj11349;
  Object *oldselfslot11349 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter11349 = (*(struct UserObject *)self).data[0], lowerouter11349 = thisouter11349;
  if (inheritingObject11349) {
    struct UserObject *inho11349 = (struct UserObject *)inheritingObject11349;
    while (inho11349->super != GraceDefaultObject) inho11349 = (struct UserObject *)inho11349->super;
    inho11349->super = obj11349;
    self = inheritingObject11349;
    *selfslot = self;
    lowerouter11349 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter11349;
  }
  if (objclass11349 == NULL) {
  Method *reader11351 = addmethodrealflags(obj11349, "kind",&reader_ast_kind_11351, MFLAG_DEF);
  reader11351->definitionModule = modulename;
  reader11351->definitionLine = 3046;
  }
  adddatum2(obj11349, alloc_Undefined(), 1);
  if (objclass11349 == NULL) {
    Method *reader11352 = addmethodrealflags(obj11349, "value", &reader_ast_value_11352, 0);
    Method *writer11352 = addmethodrealflags(obj11349, "value:=(1)", &writer_ast_value_11352, 0);
    reader11352->definitionModule = modulename;
    writer11352->definitionModule = modulename;
    reader11352->definitionLine = 3047;
    writer11352->definitionLine = 3047;
  }
  obj11349->flags |= OFLAG_MUTABLE;
  adddatum2(obj11349, alloc_Undefined(), 2);
  if (objclass11349 == NULL) {
    Method *reader11353 = addmethodrealflags(obj11349, "isPartialLine", &reader_ast_isPartialLine_11353, 0);
    Method *writer11353 = addmethodrealflags(obj11349, "isPartialLine:=(1)", &writer_ast_isPartialLine_11353, 0);
    reader11353->definitionModule = modulename;
    writer11353->definitionModule = modulename;
    reader11353->definitionLine = 3048;
    writer11353->definitionLine = 3048;
  }
  obj11349->flags |= OFLAG_MUTABLE;
  adddatum2(obj11349, alloc_Undefined(), 3);
  if (objclass11349 == NULL) {
    Method *reader11354 = addmethodrealflags(obj11349, "isPreceededByBlankLine", &reader_ast_isPreceededByBlankLine_11354, 0);
    Method *writer11354 = addmethodrealflags(obj11349, "isPreceededByBlankLine:=(1)", &writer_ast_isPreceededByBlankLine_11354, 0);
    reader11354->definitionModule = modulename;
    writer11354->definitionModule = modulename;
    reader11354->definitionLine = 3049;
    writer11354->definitionLine = 3049;
  }
  obj11349->flags |= OFLAG_MUTABLE;
  adddatum2(obj11349, alloc_Undefined(), 4);
  if (objclass11349 == NULL) {
    Method *reader11355 = addmethodrealflags(obj11349, "endLine", &reader_ast_endLine_11355, 0);
    Method *writer11355 = addmethodrealflags(obj11349, "endLine:=(1)", &writer_ast_endLine_11355, 0);
    reader11355->definitionModule = modulename;
    writer11355->definitionModule = modulename;
    reader11355->definitionLine = 3050;
    writer11355->definitionLine = 3050;
  }
  obj11349->flags |= OFLAG_MUTABLE;
  adddatum2(obj11349, alloc_Undefined(), 5);
// method "end"
  block_savedest(obj11349);
  Object closure11356 = createclosure(1, "end");
  setclosureframe(closure11356, stackframe);
  addtoclosure(closure11356, var_util);
  struct UserObject *uo11356 = (struct UserObject*)obj11349;
  uo11356->data[6] = (Object)closure11356;
  Method *meth_meth_ast_11356_end = addmethod2pos(obj11349, "end", &meth_ast_11356_end, 6);
  int argcv_meth_ast_11356_end[] = {0};
  meth_meth_ast_11356_end->type = alloc_MethodType(1, argcv_meth_ast_11356_end);
  meth_meth_ast_11356_end->definitionModule = modulename;
  meth_meth_ast_11356_end->definitionLine = 3052;
// method "isComment"
  struct UserObject *uo11369 = (struct UserObject*)obj11349;
  uo11369->data[7] = emptyclosure;
  Method *meth_meth_ast_11369_isComment = addmethod2pos(obj11349, "isComment", &meth_ast_11369_isComment, 7);
  int argcv_meth_ast_11369_isComment[] = {0};
  meth_meth_ast_11369_isComment->type = alloc_MethodType(1, argcv_meth_ast_11369_isComment);
  meth_meth_ast_11369_isComment->definitionModule = modulename;
  meth_meth_ast_11369_isComment->definitionLine = 3053;
// method "isLegalInTrait"
  struct UserObject *uo11371 = (struct UserObject*)obj11349;
  uo11371->data[8] = emptyclosure;
  Method *meth_meth_ast_11371_isLegalInTrait = addmethod2pos(obj11349, "isLegalInTrait", &meth_ast_11371_isLegalInTrait, 8);
  int argcv_meth_ast_11371_isLegalInTrait[] = {0};
  meth_meth_ast_11371_isLegalInTrait->type = alloc_MethodType(1, argcv_meth_ast_11371_isLegalInTrait);
  meth_meth_ast_11371_isLegalInTrait->definitionModule = modulename;
  meth_meth_ast_11371_isLegalInTrait->definitionLine = 3054;
// method "isExecutable"
  struct UserObject *uo11373 = (struct UserObject*)obj11349;
  uo11373->data[9] = emptyclosure;
  Method *meth_meth_ast_11373_isExecutable = addmethod2pos(obj11349, "isExecutable", &meth_ast_11373_isExecutable, 9);
  int argcv_meth_ast_11373_isExecutable[] = {0};
  meth_meth_ast_11373_isExecutable->type = alloc_MethodType(1, argcv_meth_ast_11373_isExecutable);
  meth_meth_ast_11373_isExecutable->definitionModule = modulename;
  meth_meth_ast_11373_isExecutable->definitionLine = 3055;
// method "asString"
  struct UserObject *uo11375 = (struct UserObject*)obj11349;
  uo11375->data[10] = emptyclosure;
  Method *meth_meth_ast_11375_asString = addmethod2pos(obj11349, "asString", &meth_ast_11375_asString, 10);
  int argcv_meth_ast_11375_asString[] = {0};
  meth_meth_ast_11375_asString->type = alloc_MethodType(1, argcv_meth_ast_11375_asString);
  meth_meth_ast_11375_asString->definitionModule = modulename;
  meth_meth_ast_11375_asString->definitionLine = 3056;
// method "extendCommentUsing(_)"
  struct UserObject *uo11404 = (struct UserObject*)obj11349;
  uo11404->data[11] = emptyclosure;
  Method *meth_meth_ast_11404_extendCommentUsing_40_1_41_ = addmethod2pos(obj11349, "extendCommentUsing(1)", &meth_ast_11404_extendCommentUsing_40_1_41_, 11);
  int argcv_meth_ast_11404_extendCommentUsing_40_1_41_[] = {1};
  meth_meth_ast_11404_extendCommentUsing_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_11404_extendCommentUsing_40_1_41_);
  meth_meth_ast_11404_extendCommentUsing_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11404_extendCommentUsing_40_1_41_->definitionLine = 3057;
// method "map(_)ancestors(_)"
  struct UserObject *uo11422 = (struct UserObject*)obj11349;
  uo11422->data[12] = emptyclosure;
  Method *meth_meth_ast_11422_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj11349, "map(1)ancestors(1)", &meth_ast_11422_map_40_1_41_ancestors_40_1_41_, 12);
  int argcv_meth_ast_11422_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_11422_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_11422_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_11422_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11422_map_40_1_41_ancestors_40_1_41_->definitionLine = 3061;
// method "accept(_)from(_)"
  struct UserObject *uo11429 = (struct UserObject*)obj11349;
  uo11429->data[13] = emptyclosure;
  Method *meth_meth_ast_11429_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj11349, "accept(1)from(1)", &meth_ast_11429_accept_40_1_41_from_40_1_41_, 13);
  int argcv_meth_ast_11429_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_11429_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_11429_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_11429_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11429_accept_40_1_41_from_40_1_41_->definitionLine = 3066;
// method "pretty(_)"
  struct UserObject *uo11432 = (struct UserObject*)obj11349;
  uo11432->data[14] = emptyclosure;
  Method *meth_meth_ast_11432_pretty_40_1_41_ = addmethod2pos(obj11349, "pretty(1)", &meth_ast_11432_pretty_40_1_41_, 14);
  int argcv_meth_ast_11432_pretty_40_1_41_[] = {1};
  meth_meth_ast_11432_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_11432_pretty_40_1_41_);
  meth_meth_ast_11432_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11432_pretty_40_1_41_->definitionLine = 3069;
// method "toGrace(_)"
  block_savedest(obj11349);
  Object closure11495 = createclosure(1, "toGrace(1)");
  setclosureframe(closure11495, stackframe);
  addtoclosure(closure11495, var_lineLength);
  struct UserObject *uo11495 = (struct UserObject*)obj11349;
  uo11495->data[15] = (Object)closure11495;
  Method *meth_meth_ast_11495_toGrace_40_1_41_ = addmethod2pos(obj11349, "toGrace(1)", &meth_ast_11495_toGrace_40_1_41_, 15);
  int argcv_meth_ast_11495_toGrace_40_1_41_[] = {1};
  meth_meth_ast_11495_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_11495_toGrace_40_1_41_);
  meth_meth_ast_11495_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11495_toGrace_40_1_41_->definitionLine = 3077;
// method "shallowCopy"
  block_savedest(obj11349);
  Object closure11521 = createclosure(2, "shallowCopy");
  setclosureframe(closure11521, stackframe);
  addtoclosure(closure11521, var_nullNode);
  addtoclosure(closure11521, var_commentNode);
  struct UserObject *uo11521 = (struct UserObject*)obj11349;
  uo11521->data[16] = (Object)closure11521;
  Method *meth_meth_ast_11521_shallowCopy = addmethod2pos(obj11349, "shallowCopy", &meth_ast_11521_shallowCopy, 16);
  int argcv_meth_ast_11521_shallowCopy[] = {0};
  meth_meth_ast_11521_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_11521_shallowCopy);
  meth_meth_ast_11521_shallowCopy->definitionModule = modulename;
  meth_meth_ast_11521_shallowCopy->definitionLine = 3087;
// method "postCopy(_)"
  struct UserObject *uo11526 = (struct UserObject*)obj11349;
  uo11526->data[17] = emptyclosure;
  Method *meth_meth_ast_11526_postCopy_40_1_41_ = addmethod2pos(obj11349, "postCopy(1)", &meth_ast_11526_postCopy_40_1_41_, 17);
  int argcv_meth_ast_11526_postCopy_40_1_41_[] = {1};
  meth_meth_ast_11526_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_11526_postCopy_40_1_41_);
  meth_meth_ast_11526_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11526_postCopy_40_1_41_->definitionLine = 3090;
  sourceObject = obj11349;
// Begin line 3045
  setline(3045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11543 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call11544 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11543);
// compiled call node returning call11544 (depth = 3)
  struct UserObject *obj11349_uo = (struct UserObject *)obj11349;
  obj11349_uo->super = call11544;
  sourceObject = obj11349;
// Begin line 3046
  setline(3046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit11545 == NULL) {
    strlit11545 = alloc_String("comment");
    gc_root(strlit11545);
  }
// compiled string node returning strlit11545 (depth = 3)
  adddatum2(obj11349, strlit11545, 1);
  sourceObject = obj11349;
// Begin line 3047
  setline(3047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj11349, *var_val_39_, 2);
  sourceObject = obj11349;
// Begin line 3048
  setline(3048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool11546 = alloc_Boolean(0);
// compiled identifier node returning bool11546 (depth = 3)
  adddatum2(obj11349, bool11546, 3);
  sourceObject = obj11349;
// Begin line 3049
  setline(3049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool11547 = alloc_Boolean(0);
// compiled identifier node returning bool11547 (depth = 3)
  adddatum2(obj11349, bool11547, 4);
  sourceObject = obj11349;
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe11548 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  partcv[0] = 0;
  Object call11549 = callmethodflags(*var_util, "linenum", 1, partcv, params, 0);
  gc_frame_end(callframe11548);
// compiled member node returning call11549 (depth = 3)
  adddatum2(obj11349, call11549, 5);
  sourceObject = obj11349;
  sourceObject = obj11349;
  sourceObject = obj11349;
  sourceObject = obj11349;
  sourceObject = obj11349;
  sourceObject = obj11349;
  sourceObject = obj11349;
  sourceObject = obj11349;
  sourceObject = obj11349;
  sourceObject = obj11349;
  sourceObject = obj11349;
  sourceObject = obj11349;
  objclass11349 = obj11349->class;
  objclass11349->definitionModule = modulename;
  objclass11349->definitionLine = 3044;
  (*(struct UserObject *)self).data[0] = lowerouter11349;
  self = oldself11349;
  selfslot = oldselfslot11349;
  stackframe = oldstackframe11349;
  gc_frame_end(frame);
  return obj11349;
}
Object meth_ast_11348_new_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_lineLength = getfromclosure(closure, 1);
  Object *var_nullNode = getfromclosure(closure, 2);
  Object *var_commentNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val_39_ = &(stackframe->slots[0]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject11349 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj11349 = alloc_userobj2(21,18, objclass11349);
  gc_frame_newslot(obj11349);
  if (objclass11349 == NULL) {
    glfree(obj11349->class->name);
    obj11349->class->name = "commentNode.new(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj11349, self, 0);
  addmethodreal(obj11349,"outer", &reader_ast_outer_11350);
  Object oldself11349 = self;
  struct StackFrameObject *oldstackframe11349 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe11349);
  gc_frame_newslot((Object)stackframe);
  self = obj11349;
  Object *oldselfslot11349 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter11349 = (*(struct UserObject *)self).data[0], lowerouter11349 = thisouter11349;
  if (inheritingObject11349) {
    struct UserObject *inho11349 = (struct UserObject *)inheritingObject11349;
    while (inho11349->super != GraceDefaultObject) inho11349 = (struct UserObject *)inho11349->super;
    inho11349->super = obj11349;
    self = inheritingObject11349;
    *selfslot = self;
    lowerouter11349 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter11349;
  }
  if (objclass11349 == NULL) {
  Method *reader11351 = addmethodrealflags(obj11349, "kind",&reader_ast_kind_11351, MFLAG_DEF);
  reader11351->definitionModule = modulename;
  reader11351->definitionLine = 3046;
  }
  adddatum2(obj11349, alloc_Undefined(), 1);
  if (objclass11349 == NULL) {
    Method *reader11352 = addmethodrealflags(obj11349, "value", &reader_ast_value_11352, 0);
    Method *writer11352 = addmethodrealflags(obj11349, "value:=(1)", &writer_ast_value_11352, 0);
    reader11352->definitionModule = modulename;
    writer11352->definitionModule = modulename;
    reader11352->definitionLine = 3047;
    writer11352->definitionLine = 3047;
  }
  obj11349->flags |= OFLAG_MUTABLE;
  adddatum2(obj11349, alloc_Undefined(), 2);
  if (objclass11349 == NULL) {
    Method *reader11353 = addmethodrealflags(obj11349, "isPartialLine", &reader_ast_isPartialLine_11353, 0);
    Method *writer11353 = addmethodrealflags(obj11349, "isPartialLine:=(1)", &writer_ast_isPartialLine_11353, 0);
    reader11353->definitionModule = modulename;
    writer11353->definitionModule = modulename;
    reader11353->definitionLine = 3048;
    writer11353->definitionLine = 3048;
  }
  obj11349->flags |= OFLAG_MUTABLE;
  adddatum2(obj11349, alloc_Undefined(), 3);
  if (objclass11349 == NULL) {
    Method *reader11354 = addmethodrealflags(obj11349, "isPreceededByBlankLine", &reader_ast_isPreceededByBlankLine_11354, 0);
    Method *writer11354 = addmethodrealflags(obj11349, "isPreceededByBlankLine:=(1)", &writer_ast_isPreceededByBlankLine_11354, 0);
    reader11354->definitionModule = modulename;
    writer11354->definitionModule = modulename;
    reader11354->definitionLine = 3049;
    writer11354->definitionLine = 3049;
  }
  obj11349->flags |= OFLAG_MUTABLE;
  adddatum2(obj11349, alloc_Undefined(), 4);
  if (objclass11349 == NULL) {
    Method *reader11355 = addmethodrealflags(obj11349, "endLine", &reader_ast_endLine_11355, 0);
    Method *writer11355 = addmethodrealflags(obj11349, "endLine:=(1)", &writer_ast_endLine_11355, 0);
    reader11355->definitionModule = modulename;
    writer11355->definitionModule = modulename;
    reader11355->definitionLine = 3050;
    writer11355->definitionLine = 3050;
  }
  obj11349->flags |= OFLAG_MUTABLE;
  adddatum2(obj11349, alloc_Undefined(), 5);
// method "end"
  block_savedest(obj11349);
  Object closure11356 = createclosure(1, "end");
  setclosureframe(closure11356, stackframe);
  addtoclosure(closure11356, var_util);
  struct UserObject *uo11356 = (struct UserObject*)obj11349;
  uo11356->data[6] = (Object)closure11356;
  Method *meth_meth_ast_11356_end = addmethod2pos(obj11349, "end", &meth_ast_11356_end, 6);
  int argcv_meth_ast_11356_end[] = {0};
  meth_meth_ast_11356_end->type = alloc_MethodType(1, argcv_meth_ast_11356_end);
  meth_meth_ast_11356_end->definitionModule = modulename;
  meth_meth_ast_11356_end->definitionLine = 3052;
// method "isComment"
  struct UserObject *uo11369 = (struct UserObject*)obj11349;
  uo11369->data[7] = emptyclosure;
  Method *meth_meth_ast_11369_isComment = addmethod2pos(obj11349, "isComment", &meth_ast_11369_isComment, 7);
  int argcv_meth_ast_11369_isComment[] = {0};
  meth_meth_ast_11369_isComment->type = alloc_MethodType(1, argcv_meth_ast_11369_isComment);
  meth_meth_ast_11369_isComment->definitionModule = modulename;
  meth_meth_ast_11369_isComment->definitionLine = 3053;
// method "isLegalInTrait"
  struct UserObject *uo11371 = (struct UserObject*)obj11349;
  uo11371->data[8] = emptyclosure;
  Method *meth_meth_ast_11371_isLegalInTrait = addmethod2pos(obj11349, "isLegalInTrait", &meth_ast_11371_isLegalInTrait, 8);
  int argcv_meth_ast_11371_isLegalInTrait[] = {0};
  meth_meth_ast_11371_isLegalInTrait->type = alloc_MethodType(1, argcv_meth_ast_11371_isLegalInTrait);
  meth_meth_ast_11371_isLegalInTrait->definitionModule = modulename;
  meth_meth_ast_11371_isLegalInTrait->definitionLine = 3054;
// method "isExecutable"
  struct UserObject *uo11373 = (struct UserObject*)obj11349;
  uo11373->data[9] = emptyclosure;
  Method *meth_meth_ast_11373_isExecutable = addmethod2pos(obj11349, "isExecutable", &meth_ast_11373_isExecutable, 9);
  int argcv_meth_ast_11373_isExecutable[] = {0};
  meth_meth_ast_11373_isExecutable->type = alloc_MethodType(1, argcv_meth_ast_11373_isExecutable);
  meth_meth_ast_11373_isExecutable->definitionModule = modulename;
  meth_meth_ast_11373_isExecutable->definitionLine = 3055;
// method "asString"
  struct UserObject *uo11375 = (struct UserObject*)obj11349;
  uo11375->data[10] = emptyclosure;
  Method *meth_meth_ast_11375_asString = addmethod2pos(obj11349, "asString", &meth_ast_11375_asString, 10);
  int argcv_meth_ast_11375_asString[] = {0};
  meth_meth_ast_11375_asString->type = alloc_MethodType(1, argcv_meth_ast_11375_asString);
  meth_meth_ast_11375_asString->definitionModule = modulename;
  meth_meth_ast_11375_asString->definitionLine = 3056;
// method "extendCommentUsing(_)"
  struct UserObject *uo11404 = (struct UserObject*)obj11349;
  uo11404->data[11] = emptyclosure;
  Method *meth_meth_ast_11404_extendCommentUsing_40_1_41_ = addmethod2pos(obj11349, "extendCommentUsing(1)", &meth_ast_11404_extendCommentUsing_40_1_41_, 11);
  int argcv_meth_ast_11404_extendCommentUsing_40_1_41_[] = {1};
  meth_meth_ast_11404_extendCommentUsing_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_11404_extendCommentUsing_40_1_41_);
  meth_meth_ast_11404_extendCommentUsing_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11404_extendCommentUsing_40_1_41_->definitionLine = 3057;
// method "map(_)ancestors(_)"
  struct UserObject *uo11422 = (struct UserObject*)obj11349;
  uo11422->data[12] = emptyclosure;
  Method *meth_meth_ast_11422_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj11349, "map(1)ancestors(1)", &meth_ast_11422_map_40_1_41_ancestors_40_1_41_, 12);
  int argcv_meth_ast_11422_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_11422_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_11422_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_11422_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11422_map_40_1_41_ancestors_40_1_41_->definitionLine = 3061;
// method "accept(_)from(_)"
  struct UserObject *uo11429 = (struct UserObject*)obj11349;
  uo11429->data[13] = emptyclosure;
  Method *meth_meth_ast_11429_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj11349, "accept(1)from(1)", &meth_ast_11429_accept_40_1_41_from_40_1_41_, 13);
  int argcv_meth_ast_11429_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_11429_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_11429_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_11429_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11429_accept_40_1_41_from_40_1_41_->definitionLine = 3066;
// method "pretty(_)"
  struct UserObject *uo11432 = (struct UserObject*)obj11349;
  uo11432->data[14] = emptyclosure;
  Method *meth_meth_ast_11432_pretty_40_1_41_ = addmethod2pos(obj11349, "pretty(1)", &meth_ast_11432_pretty_40_1_41_, 14);
  int argcv_meth_ast_11432_pretty_40_1_41_[] = {1};
  meth_meth_ast_11432_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_11432_pretty_40_1_41_);
  meth_meth_ast_11432_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11432_pretty_40_1_41_->definitionLine = 3069;
// method "toGrace(_)"
  block_savedest(obj11349);
  Object closure11495 = createclosure(1, "toGrace(1)");
  setclosureframe(closure11495, stackframe);
  addtoclosure(closure11495, var_lineLength);
  struct UserObject *uo11495 = (struct UserObject*)obj11349;
  uo11495->data[15] = (Object)closure11495;
  Method *meth_meth_ast_11495_toGrace_40_1_41_ = addmethod2pos(obj11349, "toGrace(1)", &meth_ast_11495_toGrace_40_1_41_, 15);
  int argcv_meth_ast_11495_toGrace_40_1_41_[] = {1};
  meth_meth_ast_11495_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_11495_toGrace_40_1_41_);
  meth_meth_ast_11495_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11495_toGrace_40_1_41_->definitionLine = 3077;
// method "shallowCopy"
  block_savedest(obj11349);
  Object closure11521 = createclosure(2, "shallowCopy");
  setclosureframe(closure11521, stackframe);
  addtoclosure(closure11521, var_nullNode);
  addtoclosure(closure11521, var_commentNode);
  struct UserObject *uo11521 = (struct UserObject*)obj11349;
  uo11521->data[16] = (Object)closure11521;
  Method *meth_meth_ast_11521_shallowCopy = addmethod2pos(obj11349, "shallowCopy", &meth_ast_11521_shallowCopy, 16);
  int argcv_meth_ast_11521_shallowCopy[] = {0};
  meth_meth_ast_11521_shallowCopy->type = alloc_MethodType(1, argcv_meth_ast_11521_shallowCopy);
  meth_meth_ast_11521_shallowCopy->definitionModule = modulename;
  meth_meth_ast_11521_shallowCopy->definitionLine = 3087;
// method "postCopy(_)"
  struct UserObject *uo11526 = (struct UserObject*)obj11349;
  uo11526->data[17] = emptyclosure;
  Method *meth_meth_ast_11526_postCopy_40_1_41_ = addmethod2pos(obj11349, "postCopy(1)", &meth_ast_11526_postCopy_40_1_41_, 17);
  int argcv_meth_ast_11526_postCopy_40_1_41_[] = {1};
  meth_meth_ast_11526_postCopy_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_11526_postCopy_40_1_41_);
  meth_meth_ast_11526_postCopy_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11526_postCopy_40_1_41_->definitionLine = 3090;
  sourceObject = obj11349;
// Begin line 3045
  setline(3045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11543 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call11544 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11543);
// compiled call node returning call11544 (depth = 3)
  struct UserObject *obj11349_uo = (struct UserObject *)obj11349;
  obj11349_uo->super = call11544;
  sourceObject = obj11349;
// Begin line 3046
  setline(3046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit11545 == NULL) {
    strlit11545 = alloc_String("comment");
    gc_root(strlit11545);
  }
// compiled string node returning strlit11545 (depth = 3)
  adddatum2(obj11349, strlit11545, 1);
  sourceObject = obj11349;
// Begin line 3047
  setline(3047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj11349, *var_val_39_, 2);
  sourceObject = obj11349;
// Begin line 3048
  setline(3048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool11546 = alloc_Boolean(0);
// compiled identifier node returning bool11546 (depth = 3)
  adddatum2(obj11349, bool11546, 3);
  sourceObject = obj11349;
// Begin line 3049
  setline(3049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool11547 = alloc_Boolean(0);
// compiled identifier node returning bool11547 (depth = 3)
  adddatum2(obj11349, bool11547, 4);
  sourceObject = obj11349;
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe11548 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  partcv[0] = 0;
  Object call11549 = callmethodflags(*var_util, "linenum", 1, partcv, params, 0);
  gc_frame_end(callframe11548);
// compiled member node returning call11549 (depth = 3)
  adddatum2(obj11349, call11549, 5);
  sourceObject = obj11349;
  sourceObject = obj11349;
  sourceObject = obj11349;
  sourceObject = obj11349;
  sourceObject = obj11349;
  sourceObject = obj11349;
  sourceObject = obj11349;
  sourceObject = obj11349;
  sourceObject = obj11349;
  sourceObject = obj11349;
  sourceObject = obj11349;
  sourceObject = obj11349;
  objclass11349 = obj11349->class;
  objclass11349->definitionModule = modulename;
  objclass11349->definitionLine = 3044;
  (*(struct UserObject *)self).data[0] = lowerouter11349;
  self = oldself11349;
  selfslot = oldselfslot11349;
  stackframe = oldstackframe11349;
  gc_frame_end(frame);
  return obj11349;
}
Object meth_ast_11551_commentNode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 59, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "commentNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_commentNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3043
  setline(3043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_commentNode (depth = 3)
  gc_frame_end(frame);
  return *var_commentNode;
}
Object meth_ast_11554_AstVisitor(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 60, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "AstVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_AstVisitor = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3134
  setline(3134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_AstVisitor (depth = 3)
  gc_frame_end(frame);
  return *var_AstVisitor;
}
Object meth_ast_11557_visitCall_40_1_41_up_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitCall(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitCall(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3277
  setline(3277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11558 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool11559 = alloc_Boolean(1);
// compiled identifier node returning bool11559 (depth = 4)
  gc_frame_newslot(bool11559);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  params[0] = bool11559;
  partcv[0] = 1;
  Object call11560 = callmethodflags(*var_c, "isPattern:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe11558);
// compiled call node returning call11560 (depth = 3)
// Begin line 3278
  setline(3278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool11561 = alloc_Boolean(1);
// compiled identifier node returning bool11561 (depth = 3)
  gc_frame_end(frame);
  return bool11561;
}
Object meth_ast_11564_patternMarkVisitor(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 61, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "patternMarkVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_patternMarkVisitor = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3274
  setline(3274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_patternMarkVisitor (depth = 3)
  gc_frame_end(frame);
  return *var_patternMarkVisitor;
}
Object module_ast_init() {
  if (module_ast) return module_ast;
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(72, 72);
  module_ast = self;
  self->class->definitionModule = "ast";
  gc_root(self);
  prelude = module_standardGrace_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule("ast");
  setsource(originalSourceLines);
  setclassname(self, "Module<ast>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(72, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
// end of preamble
  Object params[2];
  int partcv[2];
// definebindings:
  Object *var_util = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "util");
  Object *var_k = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "k");
  Object *var_Position = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "Position");
  Object *var_Range = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "Range");
  Object *var_noPosition = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "noPosition");
  Object *var_emptyRange = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "emptyRange");
  Object *var_lineLength = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "lineLength");
  Object *var_uninitialized = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "uninitialized");
  Object *var_ancestorChain = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "ancestorChain");
  Object *var_emptySeq = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "emptySeq");
  Object *var_AstNode = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "AstNode");
  Object *var_SymbolTable = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "SymbolTable");
  Object *var_implicit = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "implicit");
  Object *var_nullNode = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "nullNode");
  Object *var_fakeSymbolTable = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "fakeSymbolTable");
  Object *var_ifNode = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "ifNode");
  Object *var_blockNode = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "blockNode");
  Object *var_tryCatchNode = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "tryCatchNode");
  Object *var_matchCaseNode = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "matchCaseNode");
  Object *var_methodTypeNode = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "methodTypeNode");
  Object *var_typeLiteralNode = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "typeLiteralNode");
  Object *var_typeDecNode = &(stackframe->slots[22]);
  setframeelementname(stackframe, 22, "typeDecNode");
  Object *var_methodNode = &(stackframe->slots[23]);
  setframeelementname(stackframe, 23, "methodNode");
  Object *var_callNode = &(stackframe->slots[24]);
  setframeelementname(stackframe, 24, "callNode");
  Object *var_moduleNode = &(stackframe->slots[25]);
  setframeelementname(stackframe, 25, "moduleNode");
  Object *var_objectNode = &(stackframe->slots[26]);
  setframeelementname(stackframe, 26, "objectNode");
  Object *var_arrayNode = &(stackframe->slots[27]);
  setframeelementname(stackframe, 27, "arrayNode");
  Object *var_memberNode = &(stackframe->slots[28]);
  setframeelementname(stackframe, 28, "memberNode");
  Object *var_genericNode = &(stackframe->slots[29]);
  setframeelementname(stackframe, 29, "genericNode");
  Object *var_typeParametersNode = &(stackframe->slots[30]);
  setframeelementname(stackframe, 30, "typeParametersNode");
  Object *var_identifierNode = &(stackframe->slots[31]);
  setframeelementname(stackframe, 31, "identifierNode");
  Object *var_typeType = &(stackframe->slots[32]);
  setframeelementname(stackframe, 32, "typeType");
  Object *var_unknownType = &(stackframe->slots[33]);
  setframeelementname(stackframe, 33, "unknownType");
  Object *var_stringNode = &(stackframe->slots[34]);
  setframeelementname(stackframe, 34, "stringNode");
  Object *var_numNode = &(stackframe->slots[35]);
  setframeelementname(stackframe, 35, "numNode");
  Object *var_opNode = &(stackframe->slots[36]);
  setframeelementname(stackframe, 36, "opNode");
  Object *var_bindNode = &(stackframe->slots[37]);
  setframeelementname(stackframe, 37, "bindNode");
  Object *var_defDecNode = &(stackframe->slots[38]);
  setframeelementname(stackframe, 38, "defDecNode");
  Object *var_varDecNode = &(stackframe->slots[39]);
  setframeelementname(stackframe, 39, "varDecNode");
  Object *var_importNode = &(stackframe->slots[40]);
  setframeelementname(stackframe, 40, "importNode");
  Object *var_dialectNode = &(stackframe->slots[41]);
  setframeelementname(stackframe, 41, "dialectNode");
  Object *var_returnNode = &(stackframe->slots[42]);
  setframeelementname(stackframe, 42, "returnNode");
  Object *var_inheritNode = &(stackframe->slots[43]);
  setframeelementname(stackframe, 43, "inheritNode");
  Object *var_AliasPair = &(stackframe->slots[44]);
  setframeelementname(stackframe, 44, "AliasPair");
  Object *var_signaturePart = &(stackframe->slots[45]);
  setframeelementname(stackframe, 45, "signaturePart");
  Object *var_requestPart = &(stackframe->slots[46]);
  setframeelementname(stackframe, 46, "requestPart");
  Object *var_commentNode = &(stackframe->slots[47]);
  setframeelementname(stackframe, 47, "commentNode");
  Object *var_AstVisitor = &(stackframe->slots[48]);
  setframeelementname(stackframe, 48, "AstVisitor");
  Object *var_patternMarkVisitor = &(stackframe->slots[49]);
  setframeelementname(stackframe, 49, "patternMarkVisitor");
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "line(_)column(_)"
  struct UserObject *uo1 = (struct UserObject*)self;
  uo1->data[1] = emptyclosure;
  Method *meth_meth_ast_1_line_40_1_41_column_40_1_41_ = addmethod2pos(self, "line(1)column(1)", &meth_ast_1_line_40_1_41_column_40_1_41_, 1);
  int argcv_meth_ast_1_line_40_1_41_column_40_1_41_[] = {1, 1};
  meth_meth_ast_1_line_40_1_41_column_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1_line_40_1_41_column_40_1_41_);
meth_meth_ast_1_line_40_1_41_column_40_1_41_->type->types[0] = type_Number;
meth_meth_ast_1_line_40_1_41_column_40_1_41_->type->names[0] = "l";
meth_meth_ast_1_line_40_1_41_column_40_1_41_->type->types[1] = type_Number;
meth_meth_ast_1_line_40_1_41_column_40_1_41_->type->names[1] = "c";
  meth_meth_ast_1_line_40_1_41_column_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1_line_40_1_41_column_40_1_41_->definitionLine = 30;
  Method *meth_meth_ast_1_line_40_1_41_column_40_1_41__object = addmethod2pos(self, "line(1)column(1)$object(1)", &meth_ast_1_line_40_1_41_column_40_1_41__object, 1);
  int argcv_meth_ast_1_line_40_1_41_column_40_1_41__object[] = {1, 1};
  meth_meth_ast_1_line_40_1_41_column_40_1_41__object->type = alloc_MethodType(2, argcv_meth_ast_1_line_40_1_41_column_40_1_41__object);
meth_meth_ast_1_line_40_1_41_column_40_1_41__object->type->types[0] = type_Number;
meth_meth_ast_1_line_40_1_41_column_40_1_41__object->type->names[0] = "l";
meth_meth_ast_1_line_40_1_41_column_40_1_41__object->type->types[1] = type_Number;
meth_meth_ast_1_line_40_1_41_column_40_1_41__object->type->names[1] = "c";
  meth_meth_ast_1_line_40_1_41_column_40_1_41__object->definitionModule = modulename;
  meth_meth_ast_1_line_40_1_41_column_40_1_41__object->definitionLine = 30;
// compiled method node returning  (depth = 1)
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "start(_)end(_)"
  block_savedest(self);
  Object closure109 = createclosure(1, "start(1)end(1)");
  setclosureframe(closure109, stackframe);
  addtoclosure(closure109, var_noPosition);
  struct UserObject *uo109 = (struct UserObject*)self;
  uo109->data[2] = (Object)closure109;
  Method *meth_meth_ast_109_start_40_1_41_end_40_1_41_ = addmethod2pos(self, "start(1)end(1)", &meth_ast_109_start_40_1_41_end_40_1_41_, 2);
  int argcv_meth_ast_109_start_40_1_41_end_40_1_41_[] = {1, 1};
  meth_meth_ast_109_start_40_1_41_end_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_109_start_40_1_41_end_40_1_41_);
  meth_meth_ast_109_start_40_1_41_end_40_1_41_->definitionModule = modulename;
  meth_meth_ast_109_start_40_1_41_end_40_1_41_->definitionLine = 54;
  block_savedest(self);
  Object closure197 = createclosure(1, "start(1)end(1)$object(1)");
  setclosureframe(closure197, stackframe);
  addtoclosure(closure197, var_noPosition);
  Method *meth_meth_ast_109_start_40_1_41_end_40_1_41__object = addmethod2pos(self, "start(1)end(1)$object(1)", &meth_ast_109_start_40_1_41_end_40_1_41__object, 2);
  meth_meth_ast_109_start_40_1_41_end_40_1_41__object->definitionModule = modulename;
  meth_meth_ast_109_start_40_1_41_end_40_1_41__object->definitionLine = 54;
// compiled method node returning  (depth = 1)
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "positionOfNext(_)after(_)"
  block_savedest(self);
  Object closure198 = createclosure(2, "positionOfNext(1)after(1)");
  setclosureframe(closure198, stackframe);
  addtoclosure(closure198, var_util);
  addtoclosure(closure198, var_noPosition);
  struct UserObject *uo198 = (struct UserObject*)self;
  uo198->data[3] = (Object)closure198;
  Method *meth_meth_ast_198_positionOfNext_40_1_41_after_40_1_41_ = addmethod2pos(self, "positionOfNext(1)after(1)", &meth_ast_198_positionOfNext_40_1_41_after_40_1_41_, 3);
  int argcv_meth_ast_198_positionOfNext_40_1_41_after_40_1_41_[] = {1, 1};
  meth_meth_ast_198_positionOfNext_40_1_41_after_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_198_positionOfNext_40_1_41_after_40_1_41_);
meth_meth_ast_198_positionOfNext_40_1_41_after_40_1_41_->type->types[0] = type_String;
meth_meth_ast_198_positionOfNext_40_1_41_after_40_1_41_->type->names[0] = "needle";
  meth_meth_ast_198_positionOfNext_40_1_41_after_40_1_41_->definitionModule = modulename;
  meth_meth_ast_198_positionOfNext_40_1_41_after_40_1_41_->definitionLine = 73;
// compiled method node returning  (depth = 1)
// Begin line 86
  setline(86);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "positionOfNext(_)or(_)after(_)"
  block_savedest(self);
  Object closure248 = createclosure(2, "positionOfNext(1)or(1)after(1)");
  setclosureframe(closure248, stackframe);
  addtoclosure(closure248, var_util);
  addtoclosure(closure248, var_noPosition);
  struct UserObject *uo248 = (struct UserObject*)self;
  uo248->data[4] = (Object)closure248;
  Method *meth_meth_ast_248_positionOfNext_40_1_41_or_40_1_41_after_40_1_41_ = addmethod2pos(self, "positionOfNext(1)or(1)after(1)", &meth_ast_248_positionOfNext_40_1_41_or_40_1_41_after_40_1_41_, 4);
  int argcv_meth_ast_248_positionOfNext_40_1_41_or_40_1_41_after_40_1_41_[] = {1, 1, 1};
  meth_meth_ast_248_positionOfNext_40_1_41_or_40_1_41_after_40_1_41_->type = alloc_MethodType(3, argcv_meth_ast_248_positionOfNext_40_1_41_or_40_1_41_after_40_1_41_);
meth_meth_ast_248_positionOfNext_40_1_41_or_40_1_41_after_40_1_41_->type->types[0] = type_String;
meth_meth_ast_248_positionOfNext_40_1_41_or_40_1_41_after_40_1_41_->type->names[0] = "needle1";
meth_meth_ast_248_positionOfNext_40_1_41_or_40_1_41_after_40_1_41_->type->types[1] = type_String;
meth_meth_ast_248_positionOfNext_40_1_41_or_40_1_41_after_40_1_41_->type->names[1] = "needle2";
  meth_meth_ast_248_positionOfNext_40_1_41_or_40_1_41_after_40_1_41_->definitionModule = modulename;
  meth_meth_ast_248_positionOfNext_40_1_41_or_40_1_41_after_40_1_41_->definitionLine = 86;
// compiled method node returning  (depth = 1)
// Begin line 108
  setline(108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "listMap(_,_)ancestors(_)"
  struct UserObject *uo324 = (struct UserObject*)self;
  uo324->data[5] = emptyclosure;
  Method *meth_meth_ast_324_listMap_40_2_41_ancestors_40_1_41_ = addmethod2pos(self, "listMap(2)ancestors(1)", &meth_ast_324_listMap_40_2_41_ancestors_40_1_41_, 5);
  int argcv_meth_ast_324_listMap_40_2_41_ancestors_40_1_41_[] = {2, 1};
  meth_meth_ast_324_listMap_40_2_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_324_listMap_40_2_41_ancestors_40_1_41_);
  meth_meth_ast_324_listMap_40_2_41_ancestors_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_324_listMap_40_2_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_324_listMap_40_2_41_ancestors_40_1_41_->definitionLine = 108;
// compiled method node returning  (depth = 1)
// Begin line 113
  setline(113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "maybeMap(_,_)ancestors(_)"
  struct UserObject *uo335 = (struct UserObject*)self;
  uo335->data[6] = emptyclosure;
  Method *meth_meth_ast_335_maybeMap_40_2_41_ancestors_40_1_41_ = addmethod2pos(self, "maybeMap(2)ancestors(1)", &meth_ast_335_maybeMap_40_2_41_ancestors_40_1_41_, 6);
  int argcv_meth_ast_335_maybeMap_40_2_41_ancestors_40_1_41_[] = {2, 1};
  meth_meth_ast_335_maybeMap_40_2_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_335_maybeMap_40_2_41_ancestors_40_1_41_);
  meth_meth_ast_335_maybeMap_40_2_41_ancestors_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_335_maybeMap_40_2_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_335_maybeMap_40_2_41_ancestors_40_1_41_->definitionLine = 113;
// compiled method node returning  (depth = 1)
// Begin line 120
  setline(120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "maybeListMap(_,_)ancestors(_)"
  struct UserObject *uo343 = (struct UserObject*)self;
  uo343->data[7] = emptyclosure;
  Method *meth_meth_ast_343_maybeListMap_40_2_41_ancestors_40_1_41_ = addmethod2pos(self, "maybeListMap(2)ancestors(1)", &meth_ast_343_maybeListMap_40_2_41_ancestors_40_1_41_, 7);
  int argcv_meth_ast_343_maybeListMap_40_2_41_ancestors_40_1_41_[] = {2, 1};
  meth_meth_ast_343_maybeListMap_40_2_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_343_maybeListMap_40_2_41_ancestors_40_1_41_);
  meth_meth_ast_343_maybeListMap_40_2_41_ancestors_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_343_maybeListMap_40_2_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_343_maybeListMap_40_2_41_ancestors_40_1_41_->definitionLine = 120;
// compiled method node returning  (depth = 1)
// Begin line 192
  setline(192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "baseNode"
  block_savedest(self);
  Object closure351 = createclosure(4, "baseNode");
  setclosureframe(closure351, stackframe);
  addtoclosure(closure351, var_unknownType);
  addtoclosure(closure351, var_ancestorChain);
  addtoclosure(closure351, var_util);
  addtoclosure(closure351, var_fakeSymbolTable);
  struct UserObject *uo351 = (struct UserObject*)self;
  uo351->data[8] = (Object)closure351;
  Method *meth_meth_ast_351_baseNode = addmethod2pos(self, "baseNode", &meth_ast_351_baseNode, 8);
  int argcv_meth_ast_351_baseNode[] = {0};
  meth_meth_ast_351_baseNode->type = alloc_MethodType(1, argcv_meth_ast_351_baseNode);
  meth_meth_ast_351_baseNode->definitionModule = modulename;
  meth_meth_ast_351_baseNode->definitionLine = 192;
  block_savedest(self);
  Object closure783 = createclosure(4, "baseNode$object(1)");
  setclosureframe(closure783, stackframe);
  addtoclosure(closure783, var_unknownType);
  addtoclosure(closure783, var_ancestorChain);
  addtoclosure(closure783, var_util);
  addtoclosure(closure783, var_fakeSymbolTable);
  Method *meth_meth_ast_351_baseNode_object = addmethod2pos(self, "baseNode$object(1)", &meth_ast_351_baseNode_object, 8);
  meth_meth_ast_351_baseNode_object->definitionModule = modulename;
  meth_meth_ast_351_baseNode_object->definitionLine = 192;
// compiled method node returning  (depth = 1)
// Begin line 1732
  setline(1732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "outerNode(_)"
  block_savedest(self);
  Object closure784 = createclosure(1, "outerNode(1)");
  setclosureframe(closure784, stackframe);
  addtoclosure(closure784, var_noPosition);
  struct UserObject *uo784 = (struct UserObject*)self;
  uo784->data[9] = (Object)closure784;
  Method *meth_meth_ast_784_outerNode_40_1_41_ = addmethod2pos(self, "outerNode(1)", &meth_ast_784_outerNode_40_1_41_, 9);
  int argcv_meth_ast_784_outerNode_40_1_41_[] = {1};
  meth_meth_ast_784_outerNode_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_784_outerNode_40_1_41_);
  meth_meth_ast_784_outerNode_40_1_41_->definitionModule = modulename;
  meth_meth_ast_784_outerNode_40_1_41_->definitionLine = 1732;
  block_savedest(self);
  Object closure874 = createclosure(1, "outerNode(1)$object(1)");
  setclosureframe(closure874, stackframe);
  addtoclosure(closure874, var_noPosition);
  Method *meth_meth_ast_784_outerNode_40_1_41__object = addmethod2pos(self, "outerNode(1)$object(1)", &meth_ast_784_outerNode_40_1_41__object, 9);
  meth_meth_ast_784_outerNode_40_1_41__object->definitionModule = modulename;
  meth_meth_ast_784_outerNode_40_1_41__object->definitionLine = 1732;
// compiled method node returning  (depth = 1)
// Begin line 2843
  setline(2843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "aliasNew(_)old(_)"
  block_savedest(self);
  Object closure875 = createclosure(1, "aliasNew(1)old(1)");
  setclosureframe(closure875, stackframe);
  addtoclosure(closure875, var_AliasPair);
  struct UserObject *uo875 = (struct UserObject*)self;
  uo875->data[10] = (Object)closure875;
  Method *meth_meth_ast_875_aliasNew_40_1_41_old_40_1_41_ = addmethod2pos(self, "aliasNew(1)old(1)", &meth_ast_875_aliasNew_40_1_41_old_40_1_41_, 10);
  int argcv_meth_ast_875_aliasNew_40_1_41_old_40_1_41_[] = {1, 1};
  meth_meth_ast_875_aliasNew_40_1_41_old_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_875_aliasNew_40_1_41_old_40_1_41_);
  meth_meth_ast_875_aliasNew_40_1_41_old_40_1_41_->definitionModule = modulename;
  meth_meth_ast_875_aliasNew_40_1_41_old_40_1_41_->definitionLine = 2843;
  block_savedest(self);
  Object closure980 = createclosure(1, "aliasNew(1)old(1)$object(1)");
  setclosureframe(closure980, stackframe);
  addtoclosure(closure980, var_AliasPair);
  Method *meth_meth_ast_875_aliasNew_40_1_41_old_40_1_41__object = addmethod2pos(self, "aliasNew(1)old(1)$object(1)", &meth_ast_875_aliasNew_40_1_41_old_40_1_41__object, 10);
  meth_meth_ast_875_aliasNew_40_1_41_old_40_1_41__object->definitionModule = modulename;
  meth_meth_ast_875_aliasNew_40_1_41_old_40_1_41__object->definitionLine = 2843;
// compiled method node returning  (depth = 1)
// Begin line 3100
  setline(3100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "wrap(_)to(_)prefix(_)"
  struct UserObject *uo981 = (struct UserObject*)self;
  uo981->data[11] = emptyclosure;
  Method *meth_meth_ast_981_wrap_40_1_41_to_40_1_41_prefix_40_1_41_ = addmethod2pos(self, "wrap(1)to(1)prefix(1)", &meth_ast_981_wrap_40_1_41_to_40_1_41_prefix_40_1_41_, 11);
  int argcv_meth_ast_981_wrap_40_1_41_to_40_1_41_prefix_40_1_41_[] = {1, 1, 1};
  meth_meth_ast_981_wrap_40_1_41_to_40_1_41_prefix_40_1_41_->type = alloc_MethodType(3, argcv_meth_ast_981_wrap_40_1_41_to_40_1_41_prefix_40_1_41_);
meth_meth_ast_981_wrap_40_1_41_to_40_1_41_prefix_40_1_41_->type->types[1] = type_Number;
meth_meth_ast_981_wrap_40_1_41_to_40_1_41_prefix_40_1_41_->type->names[1] = "l";
  meth_meth_ast_981_wrap_40_1_41_to_40_1_41_prefix_40_1_41_->definitionModule = modulename;
  meth_meth_ast_981_wrap_40_1_41_to_40_1_41_prefix_40_1_41_->definitionLine = 3100;
// compiled method node returning  (depth = 1)
// Begin line 3167
  setline(3167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "baseVisitor"
  struct UserObject *uo1151 = (struct UserObject*)self;
  uo1151->data[12] = emptyclosure;
  Method *meth_meth_ast_1151_baseVisitor = addmethod2pos(self, "baseVisitor", &meth_ast_1151_baseVisitor, 12);
  int argcv_meth_ast_1151_baseVisitor[] = {0};
  meth_meth_ast_1151_baseVisitor->type = alloc_MethodType(1, argcv_meth_ast_1151_baseVisitor);
  meth_meth_ast_1151_baseVisitor->definitionModule = modulename;
  meth_meth_ast_1151_baseVisitor->definitionLine = 3167;
  Method *meth_meth_ast_1151_baseVisitor_object = addmethod2pos(self, "baseVisitor$object(1)", &meth_ast_1151_baseVisitor_object, 12);
  int argcv_meth_ast_1151_baseVisitor_object[] = {0};
  meth_meth_ast_1151_baseVisitor_object->type = alloc_MethodType(1, argcv_meth_ast_1151_baseVisitor_object);
  meth_meth_ast_1151_baseVisitor_object->definitionModule = modulename;
  meth_meth_ast_1151_baseVisitor_object->definitionLine = 3167;
// compiled method node returning  (depth = 1)
// Begin line 3233
  setline(3233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pluggableVisitor(_)"
  struct UserObject *uo1307 = (struct UserObject*)self;
  uo1307->data[13] = emptyclosure;
  Method *meth_meth_ast_1307_pluggableVisitor_40_1_41_ = addmethod2pos(self, "pluggableVisitor(1)", &meth_ast_1307_pluggableVisitor_40_1_41_, 13);
  int argcv_meth_ast_1307_pluggableVisitor_40_1_41_[] = {1};
  meth_meth_ast_1307_pluggableVisitor_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1307_pluggableVisitor_40_1_41_);
  meth_meth_ast_1307_pluggableVisitor_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1307_pluggableVisitor_40_1_41_->definitionLine = 3233;
  Method *meth_meth_ast_1307_pluggableVisitor_40_1_41__object = addmethod2pos(self, "pluggableVisitor(1)$object(1)", &meth_ast_1307_pluggableVisitor_40_1_41__object, 13);
  int argcv_meth_ast_1307_pluggableVisitor_40_1_41__object[] = {1};
  meth_meth_ast_1307_pluggableVisitor_40_1_41__object->type = alloc_MethodType(1, argcv_meth_ast_1307_pluggableVisitor_40_1_41__object);
  meth_meth_ast_1307_pluggableVisitor_40_1_41__object->definitionModule = modulename;
  meth_meth_ast_1307_pluggableVisitor_40_1_41__object->definitionLine = 3233;
// compiled method node returning  (depth = 1)
// Begin line 3282
  setline(3282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "findAnnotation(_,_)"
  block_savedest(self);
  Object closure1400 = createclosure(1, "findAnnotation(2)");
  setclosureframe(closure1400, stackframe);
  addtoclosure(closure1400, var__prelude);
  struct UserObject *uo1400 = (struct UserObject*)self;
  uo1400->data[14] = (Object)closure1400;
  Method *meth_meth_ast_1400_findAnnotation_40_2_41_ = addmethod2pos(self, "findAnnotation(2)", &meth_ast_1400_findAnnotation_40_2_41_, 14);
  int argcv_meth_ast_1400_findAnnotation_40_2_41_[] = {2};
  meth_meth_ast_1400_findAnnotation_40_2_41_->type = alloc_MethodType(1, argcv_meth_ast_1400_findAnnotation_40_2_41_);
  meth_meth_ast_1400_findAnnotation_40_2_41_->definitionModule = modulename;
  meth_meth_ast_1400_findAnnotation_40_2_41_->definitionLine = 3282;
// compiled method node returning  (depth = 1)
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of util as util
  if (module_util == NULL)
    module_util = LOAD_MODULE(util);
  *var_util = module_util;
// compiled import node returning done (depth = 1)
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of identifierKinds as k
  if (module_identifierKinds == NULL)
    module_identifierKinds = LOAD_MODULE(identifierKinds);
  *var_k = module_identifierKinds;
// compiled import node returning done (depth = 1)
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Position
// starting to compile typeliteral node (depth = 2)
//   Type literal 
  Object type1433 = alloc_Type("Position", 7);
  add_Method((ClassData)type1433, "line", NULL);
  add_Method((ClassData)type1433, "column", NULL);
  add_Method((ClassData)type1433, ">", NULL);
  add_Method((ClassData)type1433, """\xe2""""\x89""""\xa5""", NULL);
  add_Method((ClassData)type1433, "==", NULL);
  add_Method((ClassData)type1433, "<", NULL);
  add_Method((ClassData)type1433, """\xe2""""\x89""""\xa4""", NULL);
// compiled typeliteral node returning type1433 (depth = 2)
  *var_Position = type1433;
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Position"
  block_savedest(self);
  Object closure1434 = createclosure(1, "Position");
  setclosureframe(closure1434, stackframe);
  addtoclosure(closure1434, var_Position);
  struct UserObject *uo1434 = (struct UserObject*)self;
  uo1434->data[15] = (Object)closure1434;
  Method *meth_meth_ast_1434_Position = addmethod2pos(self, "Position", &meth_ast_1434_Position, 15);
  int argcv_meth_ast_1434_Position[] = {0};
  meth_meth_ast_1434_Position->type = alloc_MethodType(1, argcv_meth_ast_1434_Position);
  meth_meth_ast_1434_Position->definitionModule = modulename;
  meth_meth_ast_1434_Position->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Range
// starting to compile typeliteral node (depth = 2)
//   Type literal 
  Object type1436 = alloc_Type("Range", 2);
  add_Method((ClassData)type1436, "start", NULL);
  add_Method((ClassData)type1436, "end", NULL);
// compiled typeliteral node returning type1436 (depth = 2)
  *var_Range = type1436;
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Range"
  block_savedest(self);
  Object closure1437 = createclosure(1, "Range");
  setclosureframe(closure1437, stackframe);
  addtoclosure(closure1437, var_Range);
  struct UserObject *uo1437 = (struct UserObject*)self;
  uo1437->data[16] = (Object)closure1437;
  Method *meth_meth_ast_1437_Range = addmethod2pos(self, "Range", &meth_ast_1437_Range, 16);
  int argcv_meth_ast_1437_Range[] = {0};
  meth_meth_ast_1437_Range->type = alloc_MethodType(1, argcv_meth_ast_1437_Range);
  meth_meth_ast_1437_Range->definitionModule = modulename;
  meth_meth_ast_1437_Range->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 70
  setline(70);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe1438 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num1439 = alloc_Float64(0);
// compiled num node returning num1439 (depth = 3)
  gc_frame_newslot(num1439);
// starting to compile num node (depth = 3)
  Object num1440 = alloc_Float64(0);
// compiled num node returning num1440 (depth = 3)
  gc_frame_newslot(num1440);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_ast (depth = 3)
  params[0] = num1439;
  params[1] = num1440;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1441 = callmethodflags(module_ast, "line(1)column(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1438);
// compiled call node returning call1441 (depth = 2)
  *var_noPosition = call1441;
  if (call1441 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "noPosition"
  block_savedest(self);
  Object closure1442 = createclosure(1, "noPosition");
  setclosureframe(closure1442, stackframe);
  addtoclosure(closure1442, var_noPosition);
  struct UserObject *uo1442 = (struct UserObject*)self;
  uo1442->data[17] = (Object)closure1442;
  Method *meth_meth_ast_1442_noPosition = addmethod2pos(self, "noPosition", &meth_ast_1442_noPosition, 17);
  int argcv_meth_ast_1442_noPosition[] = {0};
  meth_meth_ast_1442_noPosition->type = alloc_MethodType(1, argcv_meth_ast_1442_noPosition);
  meth_meth_ast_1442_noPosition->definitionModule = modulename;
  meth_meth_ast_1442_noPosition->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 71
  setline(71);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe1443 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_noPosition (depth = 3)
  gc_frame_newslot(*var_noPosition);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_noPosition (depth = 3)
  gc_frame_newslot(*var_noPosition);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_ast (depth = 3)
  params[0] = *var_noPosition;
  params[1] = *var_noPosition;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1444 = callmethodflags(module_ast, "start(1)end(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1443);
// compiled call node returning call1444 (depth = 2)
  *var_emptyRange = call1444;
  if (call1444 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "emptyRange"
  block_savedest(self);
  Object closure1445 = createclosure(1, "emptyRange");
  setclosureframe(closure1445, stackframe);
  addtoclosure(closure1445, var_emptyRange);
  struct UserObject *uo1445 = (struct UserObject*)self;
  uo1445->data[18] = (Object)closure1445;
  Method *meth_meth_ast_1445_emptyRange = addmethod2pos(self, "emptyRange", &meth_ast_1445_emptyRange, 18);
  int argcv_meth_ast_1445_emptyRange[] = {0};
  meth_meth_ast_1445_emptyRange->type = alloc_MethodType(1, argcv_meth_ast_1445_emptyRange);
  meth_meth_ast_1445_emptyRange->definitionModule = modulename;
  meth_meth_ast_1445_emptyRange->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 106
  setline(106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num1446 = alloc_Float64(80);
// compiled num node returning num1446 (depth = 2)
  *var_lineLength = num1446;
  if (num1446 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lineLength"
  block_savedest(self);
  Object closure1447 = createclosure(1, "lineLength");
  setclosureframe(closure1447, stackframe);
  addtoclosure(closure1447, var_lineLength);
  struct UserObject *uo1447 = (struct UserObject*)self;
  uo1447->data[19] = (Object)closure1447;
  Method *meth_meth_ast_1447_lineLength = addmethod2pos(self, "lineLength", &meth_ast_1447_lineLength, 19);
  int argcv_meth_ast_1447_lineLength[] = {0};
  meth_meth_ast_1447_lineLength->type = alloc_MethodType(1, argcv_meth_ast_1447_lineLength);
  meth_meth_ast_1447_lineLength->definitionModule = modulename;
  meth_meth_ast_1447_lineLength->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 107
  setline(107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe1448 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit1449 == NULL) {
    strlit1449 = alloc_String("uninitialized");
    gc_root(strlit1449);
  }
// compiled string node returning strlit1449 (depth = 3)
  gc_frame_newslot(strlit1449);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe1450 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1451 = callmethodflags(prelude, "Singleton", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1450);
// compiled member node returning call1451 (depth = 3)
  params[0] = strlit1449;
  partcv[0] = 1;
  Object call1452 = callmethodflags(call1451, "named(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1448);
// compiled call node returning call1452 (depth = 2)
  *var_uninitialized = call1452;
  if (call1452 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "uninitialized"
  block_savedest(self);
  Object closure1453 = createclosure(1, "uninitialized");
  setclosureframe(closure1453, stackframe);
  addtoclosure(closure1453, var_uninitialized);
  struct UserObject *uo1453 = (struct UserObject*)self;
  uo1453->data[20] = (Object)closure1453;
  Method *meth_meth_ast_1453_uninitialized = addmethod2pos(self, "uninitialized", &meth_ast_1453_uninitialized, 20);
  int argcv_meth_ast_1453_uninitialized[] = {0};
  meth_meth_ast_1453_uninitialized->type = alloc_MethodType(1, argcv_meth_ast_1453_uninitialized);
  meth_meth_ast_1453_uninitialized->definitionModule = modulename;
  meth_meth_ast_1453_uninitialized->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 128
  setline(128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1454 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1454 = alloc_userobj2(5,6, objclass1454);
  gc_frame_newslot(obj1454);
  if (objclass1454 == NULL) {
    glfree(obj1454->class->name);
    obj1454->class->name = "ancestorChain";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj1454, self, 0);
  addmethodreal(obj1454,"outer", &reader_ast_outer_1455);
  Object oldself1454 = self;
  struct StackFrameObject *oldstackframe1454 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1454);
  gc_frame_newslot((Object)stackframe);
  self = obj1454;
  Object *oldselfslot1454 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1454 = (*(struct UserObject *)self).data[0], lowerouter1454 = thisouter1454;
  if (inheritingObject1454) {
    struct UserObject *inho1454 = (struct UserObject *)inheritingObject1454;
    while (inho1454->super != GraceDefaultObject) inho1454 = (struct UserObject *)inho1454->super;
    inho1454->super = obj1454;
    self = inheritingObject1454;
    *selfslot = self;
    lowerouter1454 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1454;
  }
// method "empty"
  struct UserObject *uo1456 = (struct UserObject*)obj1454;
  uo1456->data[1] = emptyclosure;
  Method *meth_meth_ast_1456_empty = addmethod2pos(obj1454, "empty", &meth_ast_1456_empty, 1);
  int argcv_meth_ast_1456_empty[] = {0};
  meth_meth_ast_1456_empty->type = alloc_MethodType(1, argcv_meth_ast_1456_empty);
  meth_meth_ast_1456_empty->definitionModule = modulename;
  meth_meth_ast_1456_empty->definitionLine = 129;
  Method *meth_meth_ast_1456_empty_object = addmethod2pos(obj1454, "empty$object(1)", &meth_ast_1456_empty_object, 1);
  int argcv_meth_ast_1456_empty_object[] = {0};
  meth_meth_ast_1456_empty_object->type = alloc_MethodType(1, argcv_meth_ast_1456_empty_object);
  meth_meth_ast_1456_empty_object->definitionModule = modulename;
  meth_meth_ast_1456_empty_object->definitionLine = 129;
// method "with(_)"
  struct UserObject *uo1469 = (struct UserObject*)obj1454;
  uo1469->data[2] = emptyclosure;
  Method *meth_meth_ast_1469_with_40_1_41_ = addmethod2pos(obj1454, "with(1)", &meth_ast_1469_with_40_1_41_, 2);
  int argcv_meth_ast_1469_with_40_1_41_[] = {1};
  meth_meth_ast_1469_with_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1469_with_40_1_41_);
  meth_meth_ast_1469_with_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1469_with_40_1_41_->definitionLine = 134;
// method "cons(_)onto(_)"
  struct UserObject *uo1474 = (struct UserObject*)obj1454;
  uo1474->data[3] = emptyclosure;
  Method *meth_meth_ast_1474_cons_40_1_41_onto_40_1_41_ = addmethod2pos(obj1454, "cons(1)onto(1)", &meth_ast_1474_cons_40_1_41_onto_40_1_41_, 3);
  int argcv_meth_ast_1474_cons_40_1_41_onto_40_1_41_[] = {1, 1};
  meth_meth_ast_1474_cons_40_1_41_onto_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1474_cons_40_1_41_onto_40_1_41_);
  meth_meth_ast_1474_cons_40_1_41_onto_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_1474_cons_40_1_41_onto_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1474_cons_40_1_41_onto_40_1_41_->definitionLine = 135;
  Method *meth_meth_ast_1474_cons_40_1_41_onto_40_1_41__object = addmethod2pos(obj1454, "cons(1)onto(1)$object(1)", &meth_ast_1474_cons_40_1_41_onto_40_1_41__object, 3);
  int argcv_meth_ast_1474_cons_40_1_41_onto_40_1_41__object[] = {1, 1};
  meth_meth_ast_1474_cons_40_1_41_onto_40_1_41__object->type = alloc_MethodType(2, argcv_meth_ast_1474_cons_40_1_41_onto_40_1_41__object);
  meth_meth_ast_1474_cons_40_1_41_onto_40_1_41__object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_1474_cons_40_1_41_onto_40_1_41__object->definitionModule = modulename;
  meth_meth_ast_1474_cons_40_1_41_onto_40_1_41__object->definitionLine = 135;
  sourceObject = obj1454;
  sourceObject = obj1454;
  sourceObject = obj1454;
  objclass1454 = obj1454->class;
  objclass1454->definitionModule = modulename;
  objclass1454->definitionLine = 128;
  (*(struct UserObject *)self).data[0] = lowerouter1454;
  self = oldself1454;
  selfslot = oldselfslot1454;
  stackframe = oldstackframe1454;
// compiled object node returning obj1454 (depth = 2)
  *var_ancestorChain = obj1454;
  if (obj1454 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "ancestorChain"
  block_savedest(self);
  Object closure1548 = createclosure(1, "ancestorChain");
  setclosureframe(closure1548, stackframe);
  addtoclosure(closure1548, var_ancestorChain);
  struct UserObject *uo1548 = (struct UserObject*)self;
  uo1548->data[21] = (Object)closure1548;
  Method *meth_meth_ast_1548_ancestorChain = addmethod2pos(self, "ancestorChain", &meth_ast_1548_ancestorChain, 21);
  int argcv_meth_ast_1548_ancestorChain[] = {0};
  meth_meth_ast_1548_ancestorChain->type = alloc_MethodType(1, argcv_meth_ast_1548_ancestorChain);
  meth_meth_ast_1548_ancestorChain->definitionModule = modulename;
  meth_meth_ast_1548_ancestorChain->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 162
  setline(162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile member node (depth = 2)
  int callframe1549 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1550 = callmethodflags(prelude, "emptySequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1549);
// compiled member node returning call1550 (depth = 2)
  *var_emptySeq = call1550;
  if (call1550 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "emptySeq"
  block_savedest(self);
  Object closure1551 = createclosure(1, "emptySeq");
  setclosureframe(closure1551, stackframe);
  addtoclosure(closure1551, var_emptySeq);
  struct UserObject *uo1551 = (struct UserObject*)self;
  uo1551->data[22] = (Object)closure1551;
  Method *meth_meth_ast_1551_emptySeq = addmethod2pos(self, "emptySeq", &meth_ast_1551_emptySeq, 22);
  int argcv_meth_ast_1551_emptySeq[] = {0};
  meth_meth_ast_1551_emptySeq->type = alloc_MethodType(1, argcv_meth_ast_1551_emptySeq);
  meth_meth_ast_1551_emptySeq->definitionModule = modulename;
  meth_meth_ast_1551_emptySeq->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 164
  setline(164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl AstNode
// starting to compile typeliteral node (depth = 2)
//   Type literal 
  Object type1553 = alloc_Type("AstNode", 13);
  add_Method((ClassData)type1553, "kind", NULL);
  add_Method((ClassData)type1553, "register", NULL);
  add_Method((ClassData)type1553, "line", NULL);
  add_Method((ClassData)type1553, "line:=(1)", NULL);
  add_Method((ClassData)type1553, "column", NULL);
  add_Method((ClassData)type1553, "linePos", NULL);
  add_Method((ClassData)type1553, "linePos:=(1)", NULL);
  add_Method((ClassData)type1553, "scope", NULL);
  add_Method((ClassData)type1553, "pretty(1)", NULL);
  add_Method((ClassData)type1553, "comments", NULL);
  add_Method((ClassData)type1553, "range", NULL);
  add_Method((ClassData)type1553, "start", NULL);
  add_Method((ClassData)type1553, "end", NULL);
// compiled typeliteral node returning type1553 (depth = 2)
  *var_AstNode = type1553;
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "AstNode"
  block_savedest(self);
  Object closure1554 = createclosure(1, "AstNode");
  setclosureframe(closure1554, stackframe);
  addtoclosure(closure1554, var_AstNode);
  struct UserObject *uo1554 = (struct UserObject*)self;
  uo1554->data[23] = (Object)closure1554;
  Method *meth_meth_ast_1554_AstNode = addmethod2pos(self, "AstNode", &meth_ast_1554_AstNode, 23);
  int argcv_meth_ast_1554_AstNode[] = {0};
  meth_meth_ast_1554_AstNode->type = alloc_MethodType(1, argcv_meth_ast_1554_AstNode);
  meth_meth_ast_1554_AstNode->definitionModule = modulename;
  meth_meth_ast_1554_AstNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 190
  setline(190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl SymbolTable
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_Unknown (depth = 2)
  *var_SymbolTable = *var_Unknown;
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "SymbolTable"
  block_savedest(self);
  Object closure1556 = createclosure(1, "SymbolTable");
  setclosureframe(closure1556, stackframe);
  addtoclosure(closure1556, var_SymbolTable);
  struct UserObject *uo1556 = (struct UserObject*)self;
  uo1556->data[24] = (Object)closure1556;
  Method *meth_meth_ast_1556_SymbolTable = addmethod2pos(self, "SymbolTable", &meth_ast_1556_SymbolTable, 24);
  int argcv_meth_ast_1556_SymbolTable[] = {0};
  meth_meth_ast_1556_SymbolTable->type = alloc_MethodType(1, argcv_meth_ast_1556_SymbolTable);
  meth_meth_ast_1556_SymbolTable->definitionModule = modulename;
  meth_meth_ast_1556_SymbolTable->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1557 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1557 = alloc_userobj2(12,13, objclass1557);
  gc_frame_newslot(obj1557);
  if (objclass1557 == NULL) {
    glfree(obj1557->class->name);
    obj1557->class->name = "implicit";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj1557, self, 0);
  addmethodreal(obj1557,"outer", &reader_ast_outer_1558);
  Object oldself1557 = self;
  struct StackFrameObject *oldstackframe1557 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1557);
  gc_frame_newslot((Object)stackframe);
  self = obj1557;
  Object *oldselfslot1557 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1557 = (*(struct UserObject *)self).data[0], lowerouter1557 = thisouter1557;
  if (inheritingObject1557) {
    struct UserObject *inho1557 = (struct UserObject *)inheritingObject1557;
    while (inho1557->super != GraceDefaultObject) inho1557 = (struct UserObject *)inho1557->super;
    inho1557->super = obj1557;
    self = inheritingObject1557;
    *selfslot = self;
    lowerouter1557 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1557;
  }
  if (objclass1557 == NULL) {
  Method *reader1559 = addmethodrealflags(obj1557, "kind",&reader_ast_kind_1559, MFLAG_DEF);
  reader1559->definitionModule = modulename;
  reader1559->definitionLine = 335;
  }
  adddatum2(obj1557, alloc_Undefined(), 1);
  if (objclass1557 == NULL) {
  Method *reader1560 = addmethodrealflags(obj1557, "nameString",&reader_ast_nameString_1560, MFLAG_DEF);
  reader1560->definitionModule = modulename;
  reader1560->definitionLine = 336;
  }
  adddatum2(obj1557, alloc_Undefined(), 2);
// method "range"
  block_savedest(obj1557);
  Object closure1561 = createclosure(1, "range");
  setclosureframe(closure1561, stackframe);
  addtoclosure(closure1561, var_emptyRange);
  struct UserObject *uo1561 = (struct UserObject*)obj1557;
  uo1561->data[3] = (Object)closure1561;
  Method *meth_meth_ast_1561_range = addmethod2pos(obj1557, "range", &meth_ast_1561_range, 3);
  int argcv_meth_ast_1561_range[] = {0};
  meth_meth_ast_1561_range->type = alloc_MethodType(1, argcv_meth_ast_1561_range);
  meth_meth_ast_1561_range->definitionModule = modulename;
  meth_meth_ast_1561_range->definitionLine = 337;
// method "isImplicit"
  struct UserObject *uo1562 = (struct UserObject*)obj1557;
  uo1562->data[4] = emptyclosure;
  Method *meth_meth_ast_1562_isImplicit = addmethod2pos(obj1557, "isImplicit", &meth_ast_1562_isImplicit, 4);
  int argcv_meth_ast_1562_isImplicit[] = {0};
  meth_meth_ast_1562_isImplicit->type = alloc_MethodType(1, argcv_meth_ast_1562_isImplicit);
  meth_meth_ast_1562_isImplicit->definitionModule = modulename;
  meth_meth_ast_1562_isImplicit->definitionLine = 338;
// method "toGrace(_)"
  struct UserObject *uo1564 = (struct UserObject*)obj1557;
  uo1564->data[5] = emptyclosure;
  Method *meth_meth_ast_1564_toGrace_40_1_41_ = addmethod2pos(obj1557, "toGrace(1)", &meth_ast_1564_toGrace_40_1_41_, 5);
  int argcv_meth_ast_1564_toGrace_40_1_41_[] = {1};
  meth_meth_ast_1564_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1564_toGrace_40_1_41_);
  meth_meth_ast_1564_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1564_toGrace_40_1_41_->definitionLine = 339;
// method "asString"
  struct UserObject *uo1566 = (struct UserObject*)obj1557;
  uo1566->data[6] = emptyclosure;
  Method *meth_meth_ast_1566_asString = addmethod2pos(obj1557, "asString", &meth_ast_1566_asString, 6);
  int argcv_meth_ast_1566_asString[] = {0};
  meth_meth_ast_1566_asString->type = alloc_MethodType(1, argcv_meth_ast_1566_asString);
  meth_meth_ast_1566_asString->definitionModule = modulename;
  meth_meth_ast_1566_asString->definitionLine = 340;
// method "==(_)"
  struct UserObject *uo1568 = (struct UserObject*)obj1557;
  uo1568->data[7] = emptyclosure;
  Method *meth_meth_ast_1568__61__61__40_1_41_ = addmethod2pos(obj1557, "==(1)", &meth_ast_1568__61__61__40_1_41_, 7);
  int argcv_meth_ast_1568__61__61__40_1_41_[] = {1};
  meth_meth_ast_1568__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1568__61__61__40_1_41_);
  meth_meth_ast_1568__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_1568__61__61__40_1_41_->definitionLine = 341;
// method "map(_)ancestors(_)"
  struct UserObject *uo1571 = (struct UserObject*)obj1557;
  uo1571->data[8] = emptyclosure;
  Method *meth_meth_ast_1571_map_40_1_41_ancestors_40_1_41_ = addmethod2pos(obj1557, "map(1)ancestors(1)", &meth_ast_1571_map_40_1_41_ancestors_40_1_41_, 8);
  int argcv_meth_ast_1571_map_40_1_41_ancestors_40_1_41_[] = {1, 1};
  meth_meth_ast_1571_map_40_1_41_ancestors_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1571_map_40_1_41_ancestors_40_1_41_);
  meth_meth_ast_1571_map_40_1_41_ancestors_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1571_map_40_1_41_ancestors_40_1_41_->definitionLine = 342;
// method "accept(_)from(_)"
  struct UserObject *uo1572 = (struct UserObject*)obj1557;
  uo1572->data[9] = emptyclosure;
  Method *meth_meth_ast_1572_accept_40_1_41_from_40_1_41_ = addmethod2pos(obj1557, "accept(1)from(1)", &meth_ast_1572_accept_40_1_41_from_40_1_41_, 9);
  int argcv_meth_ast_1572_accept_40_1_41_from_40_1_41_[] = {1, 1};
  meth_meth_ast_1572_accept_40_1_41_from_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1572_accept_40_1_41_from_40_1_41_);
  meth_meth_ast_1572_accept_40_1_41_from_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1572_accept_40_1_41_from_40_1_41_->definitionLine = 343;
// method "pretty(_)"
  struct UserObject *uo1575 = (struct UserObject*)obj1557;
  uo1575->data[10] = emptyclosure;
  Method *meth_meth_ast_1575_pretty_40_1_41_ = addmethod2pos(obj1557, "pretty(1)", &meth_ast_1575_pretty_40_1_41_, 10);
  int argcv_meth_ast_1575_pretty_40_1_41_[] = {1};
  meth_meth_ast_1575_pretty_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1575_pretty_40_1_41_);
  meth_meth_ast_1575_pretty_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1575_pretty_40_1_41_->definitionLine = 346;
  sourceObject = obj1557;
// Begin line 332
  setline(332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1577 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1578 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1577);
// compiled call node returning call1578 (depth = 3)
  struct UserObject *obj1557_uo = (struct UserObject *)obj1557;
  obj1557_uo->super = call1578;
  sourceObject = obj1557;
// Begin line 333
  setline(333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1579 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num1580 = alloc_Float64(0);
// compiled num node returning num1580 (depth = 4)
  gc_frame_newslot(num1580);
// call case 4: self request
  params[0] = num1580;
  partcv[0] = 1;
  Object call1581 = callmethodflags(self, "line:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1579);
// compiled call node returning call1581 (depth = 3)
  sourceObject = obj1557;
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1582 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num1583 = alloc_Float64(0);
// compiled num node returning num1583 (depth = 4)
  gc_frame_newslot(num1583);
// call case 4: self request
  params[0] = num1583;
  partcv[0] = 1;
  Object call1584 = callmethodflags(self, "linePos:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1582);
// compiled call node returning call1584 (depth = 3)
  sourceObject = obj1557;
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1585 == NULL) {
    strlit1585 = alloc_String("implicit");
    gc_root(strlit1585);
  }
// compiled string node returning strlit1585 (depth = 3)
  adddatum2(obj1557, strlit1585, 1);
  sourceObject = obj1557;
// Begin line 336
  setline(336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1586 == NULL) {
    strlit1586 = alloc_String("implicit");
    gc_root(strlit1586);
  }
// compiled string node returning strlit1586 (depth = 3)
  adddatum2(obj1557, strlit1586, 2);
  sourceObject = obj1557;
  sourceObject = obj1557;
  sourceObject = obj1557;
  sourceObject = obj1557;
  sourceObject = obj1557;
  sourceObject = obj1557;
  sourceObject = obj1557;
  sourceObject = obj1557;
  objclass1557 = obj1557->class;
  objclass1557->definitionModule = modulename;
  objclass1557->definitionLine = 331;
  (*(struct UserObject *)self).data[0] = lowerouter1557;
  self = oldself1557;
  selfslot = oldselfslot1557;
  stackframe = oldstackframe1557;
// compiled object node returning obj1557 (depth = 2)
  *var_implicit = obj1557;
  if (obj1557 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "implicit"
  block_savedest(self);
  Object closure1587 = createclosure(1, "implicit");
  setclosureframe(closure1587, stackframe);
  addtoclosure(closure1587, var_implicit);
  struct UserObject *uo1587 = (struct UserObject*)self;
  uo1587->data[25] = (Object)closure1587;
  Method *meth_meth_ast_1587_implicit = addmethod2pos(self, "implicit", &meth_ast_1587_implicit, 25);
  int argcv_meth_ast_1587_implicit[] = {0};
  meth_meth_ast_1587_implicit->type = alloc_MethodType(1, argcv_meth_ast_1587_implicit);
  meth_meth_ast_1587_implicit->definitionModule = modulename;
  meth_meth_ast_1587_implicit->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1588 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1588 = alloc_userobj2(5,6, objclass1588);
  gc_frame_newslot(obj1588);
  if (objclass1588 == NULL) {
    glfree(obj1588->class->name);
    obj1588->class->name = "nullNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj1588, self, 0);
  addmethodreal(obj1588,"outer", &reader_ast_outer_1589);
  Object oldself1588 = self;
  struct StackFrameObject *oldstackframe1588 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1588);
  gc_frame_newslot((Object)stackframe);
  self = obj1588;
  Object *oldselfslot1588 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1588 = (*(struct UserObject *)self).data[0], lowerouter1588 = thisouter1588;
  if (inheritingObject1588) {
    struct UserObject *inho1588 = (struct UserObject *)inheritingObject1588;
    while (inho1588->super != GraceDefaultObject) inho1588 = (struct UserObject *)inho1588->super;
    inho1588->super = obj1588;
    self = inheritingObject1588;
    *selfslot = self;
    lowerouter1588 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1588;
  }
  if (objclass1588 == NULL) {
  Method *reader1590 = addmethodrealflags(obj1588, "kind",&reader_ast_kind_1590, MFLAG_DEF);
  reader1590->definitionModule = modulename;
  reader1590->definitionLine = 351;
  }
  adddatum2(obj1588, alloc_Undefined(), 1);
// method "toGrace(_)"
  struct UserObject *uo1591 = (struct UserObject*)obj1588;
  uo1591->data[2] = emptyclosure;
  Method *meth_meth_ast_1591_toGrace_40_1_41_ = addmethod2pos(obj1588, "toGrace(1)", &meth_ast_1591_toGrace_40_1_41_, 2);
  int argcv_meth_ast_1591_toGrace_40_1_41_[] = {1};
  meth_meth_ast_1591_toGrace_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1591_toGrace_40_1_41_);
  meth_meth_ast_1591_toGrace_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1591_toGrace_40_1_41_->definitionLine = 352;
// method "range"
  block_savedest(obj1588);
  Object closure1593 = createclosure(1, "range");
  setclosureframe(closure1593, stackframe);
  addtoclosure(closure1593, var_emptyRange);
  struct UserObject *uo1593 = (struct UserObject*)obj1588;
  uo1593->data[3] = (Object)closure1593;
  Method *meth_meth_ast_1593_range = addmethod2pos(obj1588, "range", &meth_ast_1593_range, 3);
  int argcv_meth_ast_1593_range[] = {0};
  meth_meth_ast_1593_range->type = alloc_MethodType(1, argcv_meth_ast_1593_range);
  meth_meth_ast_1593_range->definitionModule = modulename;
  meth_meth_ast_1593_range->definitionLine = 355;
// method "asString"
  struct UserObject *uo1594 = (struct UserObject*)obj1588;
  uo1594->data[4] = emptyclosure;
  Method *meth_meth_ast_1594_asString = addmethod2pos(obj1588, "asString", &meth_ast_1594_asString, 4);
  int argcv_meth_ast_1594_asString[] = {0};
  meth_meth_ast_1594_asString->type = alloc_MethodType(1, argcv_meth_ast_1594_asString);
  meth_meth_ast_1594_asString->definitionModule = modulename;
  meth_meth_ast_1594_asString->definitionLine = 356;
// method "==(_)"
  struct UserObject *uo1596 = (struct UserObject*)obj1588;
  uo1596->data[5] = emptyclosure;
  Method *meth_meth_ast_1596__61__61__40_1_41_ = addmethod2pos(obj1588, "==(1)", &meth_ast_1596__61__61__40_1_41_, 5);
  int argcv_meth_ast_1596__61__61__40_1_41_[] = {1};
  meth_meth_ast_1596__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1596__61__61__40_1_41_);
  meth_meth_ast_1596__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_1596__61__61__40_1_41_->definitionLine = 357;
  sourceObject = obj1588;
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1599 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1600 = callmethodflags(module_ast, "baseNode$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1599);
// compiled call node returning call1600 (depth = 3)
  struct UserObject *obj1588_uo = (struct UserObject *)obj1588;
  obj1588_uo->super = call1600;
  sourceObject = obj1588;
// Begin line 351
  setline(351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1601 == NULL) {
    strlit1601 = alloc_String("null");
    gc_root(strlit1601);
  }
// compiled string node returning strlit1601 (depth = 3)
  adddatum2(obj1588, strlit1601, 1);
  sourceObject = obj1588;
  sourceObject = obj1588;
  sourceObject = obj1588;
  sourceObject = obj1588;
  objclass1588 = obj1588->class;
  objclass1588->definitionModule = modulename;
  objclass1588->definitionLine = 349;
  (*(struct UserObject *)self).data[0] = lowerouter1588;
  self = oldself1588;
  selfslot = oldselfslot1588;
  stackframe = oldstackframe1588;
// compiled object node returning obj1588 (depth = 2)
  *var_nullNode = obj1588;
  if (obj1588 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "nullNode"
  block_savedest(self);
  Object closure1602 = createclosure(1, "nullNode");
  setclosureframe(closure1602, stackframe);
  addtoclosure(closure1602, var_nullNode);
  struct UserObject *uo1602 = (struct UserObject*)self;
  uo1602->data[26] = (Object)closure1602;
  Method *meth_meth_ast_1602_nullNode = addmethod2pos(self, "nullNode", &meth_ast_1602_nullNode, 26);
  int argcv_meth_ast_1602_nullNode[] = {0};
  meth_meth_ast_1602_nullNode->type = alloc_MethodType(1, argcv_meth_ast_1602_nullNode);
  meth_meth_ast_1602_nullNode->definitionModule = modulename;
  meth_meth_ast_1602_nullNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1603 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1603 = alloc_userobj2(8,8, objclass1603);
  gc_frame_newslot(obj1603);
  if (objclass1603 == NULL) {
    glfree(obj1603->class->name);
    obj1603->class->name = "fakeSymbolTable";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj1603, self, 0);
  addmethodreal(obj1603,"outer", &reader_ast_outer_1604);
  Object oldself1603 = self;
  struct StackFrameObject *oldstackframe1603 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1603);
  gc_frame_newslot((Object)stackframe);
  self = obj1603;
  Object *oldselfslot1603 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1603 = (*(struct UserObject *)self).data[0], lowerouter1603 = thisouter1603;
  if (inheritingObject1603) {
    struct UserObject *inho1603 = (struct UserObject *)inheritingObject1603;
    while (inho1603->super != GraceDefaultObject) inho1603 = (struct UserObject *)inho1603->super;
    inho1603->super = obj1603;
    self = inheritingObject1603;
    *selfslot = self;
    lowerouter1603 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1603;
  }
  if (objclass1603 == NULL) {
    Method *reader1605 = addmethodrealflags(obj1603, "node", &reader_ast_node_1605, 0);
    Method *writer1605 = addmethodrealflags(obj1603, "node:=(1)", &writer_ast_node_1605, 0);
    reader1605->definitionModule = modulename;
    writer1605->definitionModule = modulename;
    reader1605->definitionLine = 361;
    writer1605->definitionLine = 361;
  }
  obj1603->flags |= OFLAG_MUTABLE;
  adddatum2(obj1603, alloc_Undefined(), 1);
// method "asString"
  struct UserObject *uo1606 = (struct UserObject*)obj1603;
  uo1606->data[2] = emptyclosure;
  Method *meth_meth_ast_1606_asString = addmethod2pos(obj1603, "asString", &meth_ast_1606_asString, 2);
  int argcv_meth_ast_1606_asString[] = {0};
  meth_meth_ast_1606_asString->type = alloc_MethodType(1, argcv_meth_ast_1606_asString);
  meth_meth_ast_1606_asString->definitionModule = modulename;
  meth_meth_ast_1606_asString->definitionLine = 362;
// method "addNode(_)as(_)"
  struct UserObject *uo1608 = (struct UserObject*)obj1603;
  uo1608->data[3] = emptyclosure;
  Method *meth_meth_ast_1608_addNode_40_1_41_as_40_1_41_ = addmethod2pos(obj1603, "addNode(1)as(1)", &meth_ast_1608_addNode_40_1_41_as_40_1_41_, 3);
  int argcv_meth_ast_1608_addNode_40_1_41_as_40_1_41_[] = {1, 1};
  meth_meth_ast_1608_addNode_40_1_41_as_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1608_addNode_40_1_41_as_40_1_41_);
  meth_meth_ast_1608_addNode_40_1_41_as_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1608_addNode_40_1_41_as_40_1_41_->definitionLine = 363;
// method "thatDefines(_)ifNone(_)"
  struct UserObject *uo1637 = (struct UserObject*)obj1603;
  uo1637->data[4] = emptyclosure;
  Method *meth_meth_ast_1637_thatDefines_40_1_41_ifNone_40_1_41_ = addmethod2pos(obj1603, "thatDefines(1)ifNone(1)", &meth_ast_1637_thatDefines_40_1_41_ifNone_40_1_41_, 4);
  int argcv_meth_ast_1637_thatDefines_40_1_41_ifNone_40_1_41_[] = {1, 1};
  meth_meth_ast_1637_thatDefines_40_1_41_ifNone_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_1637_thatDefines_40_1_41_ifNone_40_1_41_);
  meth_meth_ast_1637_thatDefines_40_1_41_ifNone_40_1_41_->definitionModule = modulename;
  meth_meth_ast_1637_thatDefines_40_1_41_ifNone_40_1_41_->definitionLine = 366;
// method "enclosingObjectScope"
  struct UserObject *uo1650 = (struct UserObject*)obj1603;
  uo1650->data[5] = emptyclosure;
  Method *meth_meth_ast_1650_enclosingObjectScope = addmethod2pos(obj1603, "enclosingObjectScope", &meth_ast_1650_enclosingObjectScope, 5);
  int argcv_meth_ast_1650_enclosingObjectScope[] = {0};
  meth_meth_ast_1650_enclosingObjectScope->type = alloc_MethodType(1, argcv_meth_ast_1650_enclosingObjectScope);
  meth_meth_ast_1650_enclosingObjectScope->definitionModule = modulename;
  meth_meth_ast_1650_enclosingObjectScope->definitionLine = 369;
// method "variety"
  struct UserObject *uo1665 = (struct UserObject*)obj1603;
  uo1665->data[6] = emptyclosure;
  Method *meth_meth_ast_1665_variety = addmethod2pos(obj1603, "variety", &meth_ast_1665_variety, 6);
  int argcv_meth_ast_1665_variety[] = {0};
  meth_meth_ast_1665_variety->type = alloc_MethodType(1, argcv_meth_ast_1665_variety);
  meth_meth_ast_1665_variety->definitionModule = modulename;
  meth_meth_ast_1665_variety->definitionLine = 372;
// method "==(_)"
  struct UserObject *uo1667 = (struct UserObject*)obj1603;
  uo1667->data[7] = emptyclosure;
  Method *meth_meth_ast_1667__61__61__40_1_41_ = addmethod2pos(obj1603, "==(1)", &meth_ast_1667__61__61__40_1_41_, 7);
  int argcv_meth_ast_1667__61__61__40_1_41_[] = {1};
  meth_meth_ast_1667__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_1667__61__61__40_1_41_);
  meth_meth_ast_1667__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_ast_1667__61__61__40_1_41_->definitionLine = 373;
  sourceObject = obj1603;
// Begin line 361
  setline(361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_nullNode (depth = 3)
  adddatum2(obj1603, *var_nullNode, 1);
  sourceObject = obj1603;
  sourceObject = obj1603;
  sourceObject = obj1603;
  sourceObject = obj1603;
  sourceObject = obj1603;
  sourceObject = obj1603;
  objclass1603 = obj1603->class;
  objclass1603->definitionModule = modulename;
  objclass1603->definitionLine = 360;
  (*(struct UserObject *)self).data[0] = lowerouter1603;
  self = oldself1603;
  selfslot = oldselfslot1603;
  stackframe = oldstackframe1603;
// compiled object node returning obj1603 (depth = 2)
  *var_fakeSymbolTable = obj1603;
  if (obj1603 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "fakeSymbolTable"
  block_savedest(self);
  Object closure1670 = createclosure(1, "fakeSymbolTable");
  setclosureframe(closure1670, stackframe);
  addtoclosure(closure1670, var_fakeSymbolTable);
  struct UserObject *uo1670 = (struct UserObject*)self;
  uo1670->data[27] = (Object)closure1670;
  Method *meth_meth_ast_1670_fakeSymbolTable = addmethod2pos(self, "fakeSymbolTable", &meth_ast_1670_fakeSymbolTable, 27);
  int argcv_meth_ast_1670_fakeSymbolTable[] = {0};
  meth_meth_ast_1670_fakeSymbolTable->type = alloc_MethodType(1, argcv_meth_ast_1670_fakeSymbolTable);
  meth_meth_ast_1670_fakeSymbolTable->definitionModule = modulename;
  meth_meth_ast_1670_fakeSymbolTable->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1671 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1671 = alloc_userobj2(2,4, objclass1671);
  gc_frame_newslot(obj1671);
  if (objclass1671 == NULL) {
    glfree(obj1671->class->name);
    obj1671->class->name = "ifNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj1671, self, 0);
  addmethodreal(obj1671,"outer", &reader_ast_outer_1672);
  Object oldself1671 = self;
  struct StackFrameObject *oldstackframe1671 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1671);
  gc_frame_newslot((Object)stackframe);
  self = obj1671;
  Object *oldselfslot1671 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1671 = (*(struct UserObject *)self).data[0], lowerouter1671 = thisouter1671;
  if (inheritingObject1671) {
    struct UserObject *inho1671 = (struct UserObject *)inheritingObject1671;
    while (inho1671->super != GraceDefaultObject) inho1671 = (struct UserObject *)inho1671->super;
    inho1671->super = obj1671;
    self = inheritingObject1671;
    *selfslot = self;
    lowerouter1671 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1671;
  }
// method "new(_,_,_)"
  block_savedest(obj1671);
  Object closure1673 = createclosure(3, "new(3)");
  setclosureframe(closure1673, stackframe);
  addtoclosure(closure1673, var_util);
  addtoclosure(closure1673, var_nullNode);
  addtoclosure(closure1673, var_ifNode);
  struct UserObject *uo1673 = (struct UserObject*)obj1671;
  uo1673->data[1] = (Object)closure1673;
  Method *meth_meth_ast_1673_new_40_3_41_ = addmethod2pos(obj1671, "new(3)", &meth_ast_1673_new_40_3_41_, 1);
  int argcv_meth_ast_1673_new_40_3_41_[] = {3};
  meth_meth_ast_1673_new_40_3_41_->type = alloc_MethodType(1, argcv_meth_ast_1673_new_40_3_41_);
  meth_meth_ast_1673_new_40_3_41_->definitionModule = modulename;
  meth_meth_ast_1673_new_40_3_41_->definitionLine = 377;
  block_savedest(obj1671);
  Object closure2013 = createclosure(3, "new(3)$object(1)");
  setclosureframe(closure2013, stackframe);
  addtoclosure(closure2013, var_util);
  addtoclosure(closure2013, var_nullNode);
  addtoclosure(closure2013, var_ifNode);
  Method *meth_meth_ast_1673_new_40_3_41__object = addmethod2pos(obj1671, "new(3)$object(1)", &meth_ast_1673_new_40_3_41__object, 1);
  meth_meth_ast_1673_new_40_3_41__object->definitionModule = modulename;
  meth_meth_ast_1673_new_40_3_41__object->definitionLine = 377;
  sourceObject = obj1671;
  objclass1671 = obj1671->class;
  objclass1671->definitionModule = modulename;
  objclass1671->definitionLine = 376;
  (*(struct UserObject *)self).data[0] = lowerouter1671;
  self = oldself1671;
  selfslot = oldselfslot1671;
  stackframe = oldstackframe1671;
// compiled object node returning obj1671 (depth = 2)
  *var_ifNode = obj1671;
  if (obj1671 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "ifNode"
  block_savedest(self);
  Object closure2014 = createclosure(1, "ifNode");
  setclosureframe(closure2014, stackframe);
  addtoclosure(closure2014, var_ifNode);
  struct UserObject *uo2014 = (struct UserObject*)self;
  uo2014->data[28] = (Object)closure2014;
  Method *meth_meth_ast_2014_ifNode = addmethod2pos(self, "ifNode", &meth_ast_2014_ifNode, 28);
  int argcv_meth_ast_2014_ifNode[] = {0};
  meth_meth_ast_2014_ifNode->type = alloc_MethodType(1, argcv_meth_ast_2014_ifNode);
  meth_meth_ast_2014_ifNode->definitionModule = modulename;
  meth_meth_ast_2014_ifNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 447
  setline(447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject2015 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2015 = alloc_userobj2(2,4, objclass2015);
  gc_frame_newslot(obj2015);
  if (objclass2015 == NULL) {
    glfree(obj2015->class->name);
    obj2015->class->name = "blockNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2015, self, 0);
  addmethodreal(obj2015,"outer", &reader_ast_outer_2016);
  Object oldself2015 = self;
  struct StackFrameObject *oldstackframe2015 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2015);
  gc_frame_newslot((Object)stackframe);
  self = obj2015;
  Object *oldselfslot2015 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2015 = (*(struct UserObject *)self).data[0], lowerouter2015 = thisouter2015;
  if (inheritingObject2015) {
    struct UserObject *inho2015 = (struct UserObject *)inheritingObject2015;
    while (inho2015->super != GraceDefaultObject) inho2015 = (struct UserObject *)inho2015->super;
    inho2015->super = obj2015;
    self = inheritingObject2015;
    *selfslot = self;
    lowerouter2015 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2015;
  }
// method "new(_,_)"
  block_savedest(obj2015);
  Object closure2017 = createclosure(4, "new(2)");
  setclosureframe(closure2017, stackframe);
  addtoclosure(closure2017, var_k);
  addtoclosure(closure2017, var_blockNode);
  addtoclosure(closure2017, var_patternMarkVisitor);
  addtoclosure(closure2017, var_ancestorChain);
  struct UserObject *uo2017 = (struct UserObject*)obj2015;
  uo2017->data[1] = (Object)closure2017;
  Method *meth_meth_ast_2017_new_40_2_41_ = addmethod2pos(obj2015, "new(2)", &meth_ast_2017_new_40_2_41_, 1);
  int argcv_meth_ast_2017_new_40_2_41_[] = {2};
  meth_meth_ast_2017_new_40_2_41_->type = alloc_MethodType(1, argcv_meth_ast_2017_new_40_2_41_);
  meth_meth_ast_2017_new_40_2_41_->definitionModule = modulename;
  meth_meth_ast_2017_new_40_2_41_->definitionLine = 448;
  block_savedest(obj2015);
  Object closure2478 = createclosure(4, "new(2)$object(1)");
  setclosureframe(closure2478, stackframe);
  addtoclosure(closure2478, var_k);
  addtoclosure(closure2478, var_blockNode);
  addtoclosure(closure2478, var_patternMarkVisitor);
  addtoclosure(closure2478, var_ancestorChain);
  Method *meth_meth_ast_2017_new_40_2_41__object = addmethod2pos(obj2015, "new(2)$object(1)", &meth_ast_2017_new_40_2_41__object, 1);
  meth_meth_ast_2017_new_40_2_41__object->definitionModule = modulename;
  meth_meth_ast_2017_new_40_2_41__object->definitionLine = 448;
  sourceObject = obj2015;
  objclass2015 = obj2015->class;
  objclass2015->definitionModule = modulename;
  objclass2015->definitionLine = 447;
  (*(struct UserObject *)self).data[0] = lowerouter2015;
  self = oldself2015;
  selfslot = oldselfslot2015;
  stackframe = oldstackframe2015;
// compiled object node returning obj2015 (depth = 2)
  *var_blockNode = obj2015;
  if (obj2015 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "blockNode"
  block_savedest(self);
  Object closure2479 = createclosure(1, "blockNode");
  setclosureframe(closure2479, stackframe);
  addtoclosure(closure2479, var_blockNode);
  struct UserObject *uo2479 = (struct UserObject*)self;
  uo2479->data[29] = (Object)closure2479;
  Method *meth_meth_ast_2479_blockNode = addmethod2pos(self, "blockNode", &meth_ast_2479_blockNode, 29);
  int argcv_meth_ast_2479_blockNode[] = {0};
  meth_meth_ast_2479_blockNode->type = alloc_MethodType(1, argcv_meth_ast_2479_blockNode);
  meth_meth_ast_2479_blockNode->definitionModule = modulename;
  meth_meth_ast_2479_blockNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject2480 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2480 = alloc_userobj2(2,4, objclass2480);
  gc_frame_newslot(obj2480);
  if (objclass2480 == NULL) {
    glfree(obj2480->class->name);
    obj2480->class->name = "tryCatchNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2480, self, 0);
  addmethodreal(obj2480,"outer", &reader_ast_outer_2481);
  Object oldself2480 = self;
  struct StackFrameObject *oldstackframe2480 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2480);
  gc_frame_newslot((Object)stackframe);
  self = obj2480;
  Object *oldselfslot2480 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2480 = (*(struct UserObject *)self).data[0], lowerouter2480 = thisouter2480;
  if (inheritingObject2480) {
    struct UserObject *inho2480 = (struct UserObject *)inheritingObject2480;
    while (inho2480->super != GraceDefaultObject) inho2480 = (struct UserObject *)inho2480->super;
    inho2480->super = obj2480;
    self = inheritingObject2480;
    *selfslot = self;
    lowerouter2480 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2480;
  }
// method "new(_,_,_)"
  block_savedest(obj2480);
  Object closure2482 = createclosure(3, "new(3)");
  setclosureframe(closure2482, stackframe);
  addtoclosure(closure2482, var_nullNode);
  addtoclosure(closure2482, var_emptySeq);
  addtoclosure(closure2482, var_tryCatchNode);
  struct UserObject *uo2482 = (struct UserObject*)obj2480;
  uo2482->data[1] = (Object)closure2482;
  Method *meth_meth_ast_2482_new_40_3_41_ = addmethod2pos(obj2480, "new(3)", &meth_ast_2482_new_40_3_41_, 1);
  int argcv_meth_ast_2482_new_40_3_41_[] = {3};
  meth_meth_ast_2482_new_40_3_41_->type = alloc_MethodType(1, argcv_meth_ast_2482_new_40_3_41_);
  meth_meth_ast_2482_new_40_3_41_->definitionModule = modulename;
  meth_meth_ast_2482_new_40_3_41_->definitionLine = 568;
  block_savedest(obj2480);
  Object closure2785 = createclosure(3, "new(3)$object(1)");
  setclosureframe(closure2785, stackframe);
  addtoclosure(closure2785, var_nullNode);
  addtoclosure(closure2785, var_emptySeq);
  addtoclosure(closure2785, var_tryCatchNode);
  Method *meth_meth_ast_2482_new_40_3_41__object = addmethod2pos(obj2480, "new(3)$object(1)", &meth_ast_2482_new_40_3_41__object, 1);
  meth_meth_ast_2482_new_40_3_41__object->definitionModule = modulename;
  meth_meth_ast_2482_new_40_3_41__object->definitionLine = 568;
  sourceObject = obj2480;
  objclass2480 = obj2480->class;
  objclass2480->definitionModule = modulename;
  objclass2480->definitionLine = 567;
  (*(struct UserObject *)self).data[0] = lowerouter2480;
  self = oldself2480;
  selfslot = oldselfslot2480;
  stackframe = oldstackframe2480;
// compiled object node returning obj2480 (depth = 2)
  *var_tryCatchNode = obj2480;
  if (obj2480 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "tryCatchNode"
  block_savedest(self);
  Object closure2786 = createclosure(1, "tryCatchNode");
  setclosureframe(closure2786, stackframe);
  addtoclosure(closure2786, var_tryCatchNode);
  struct UserObject *uo2786 = (struct UserObject*)self;
  uo2786->data[30] = (Object)closure2786;
  Method *meth_meth_ast_2786_tryCatchNode = addmethod2pos(self, "tryCatchNode", &meth_ast_2786_tryCatchNode, 30);
  int argcv_meth_ast_2786_tryCatchNode[] = {0};
  meth_meth_ast_2786_tryCatchNode->type = alloc_MethodType(1, argcv_meth_ast_2786_tryCatchNode);
  meth_meth_ast_2786_tryCatchNode->definitionModule = modulename;
  meth_meth_ast_2786_tryCatchNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 628
  setline(628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject2787 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2787 = alloc_userobj2(2,4, objclass2787);
  gc_frame_newslot(obj2787);
  if (objclass2787 == NULL) {
    glfree(obj2787->class->name);
    obj2787->class->name = "matchCaseNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2787, self, 0);
  addmethodreal(obj2787,"outer", &reader_ast_outer_2788);
  Object oldself2787 = self;
  struct StackFrameObject *oldstackframe2787 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2787);
  gc_frame_newslot((Object)stackframe);
  self = obj2787;
  Object *oldselfslot2787 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2787 = (*(struct UserObject *)self).data[0], lowerouter2787 = thisouter2787;
  if (inheritingObject2787) {
    struct UserObject *inho2787 = (struct UserObject *)inheritingObject2787;
    while (inho2787->super != GraceDefaultObject) inho2787 = (struct UserObject *)inho2787->super;
    inho2787->super = obj2787;
    self = inheritingObject2787;
    *selfslot = self;
    lowerouter2787 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2787;
  }
// method "new(_,_)"
  block_savedest(obj2787);
  Object closure2789 = createclosure(3, "new(2)");
  setclosureframe(closure2789, stackframe);
  addtoclosure(closure2789, var_nullNode);
  addtoclosure(closure2789, var_emptySeq);
  addtoclosure(closure2789, var_matchCaseNode);
  struct UserObject *uo2789 = (struct UserObject*)obj2787;
  uo2789->data[1] = (Object)closure2789;
  Method *meth_meth_ast_2789_new_40_2_41_ = addmethod2pos(obj2787, "new(2)", &meth_ast_2789_new_40_2_41_, 1);
  int argcv_meth_ast_2789_new_40_2_41_[] = {2};
  meth_meth_ast_2789_new_40_2_41_->type = alloc_MethodType(1, argcv_meth_ast_2789_new_40_2_41_);
  meth_meth_ast_2789_new_40_2_41_->definitionModule = modulename;
  meth_meth_ast_2789_new_40_2_41_->definitionLine = 629;
  block_savedest(obj2787);
  Object closure2983 = createclosure(3, "new(2)$object(1)");
  setclosureframe(closure2983, stackframe);
  addtoclosure(closure2983, var_nullNode);
  addtoclosure(closure2983, var_emptySeq);
  addtoclosure(closure2983, var_matchCaseNode);
  Method *meth_meth_ast_2789_new_40_2_41__object = addmethod2pos(obj2787, "new(2)$object(1)", &meth_ast_2789_new_40_2_41__object, 1);
  meth_meth_ast_2789_new_40_2_41__object->definitionModule = modulename;
  meth_meth_ast_2789_new_40_2_41__object->definitionLine = 629;
  sourceObject = obj2787;
  objclass2787 = obj2787->class;
  objclass2787->definitionModule = modulename;
  objclass2787->definitionLine = 628;
  (*(struct UserObject *)self).data[0] = lowerouter2787;
  self = oldself2787;
  selfslot = oldselfslot2787;
  stackframe = oldstackframe2787;
// compiled object node returning obj2787 (depth = 2)
  *var_matchCaseNode = obj2787;
  if (obj2787 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "matchCaseNode"
  block_savedest(self);
  Object closure2984 = createclosure(1, "matchCaseNode");
  setclosureframe(closure2984, stackframe);
  addtoclosure(closure2984, var_matchCaseNode);
  struct UserObject *uo2984 = (struct UserObject*)self;
  uo2984->data[31] = (Object)closure2984;
  Method *meth_meth_ast_2984_matchCaseNode = addmethod2pos(self, "matchCaseNode", &meth_ast_2984_matchCaseNode, 31);
  int argcv_meth_ast_2984_matchCaseNode[] = {0};
  meth_meth_ast_2984_matchCaseNode->type = alloc_MethodType(1, argcv_meth_ast_2984_matchCaseNode);
  meth_meth_ast_2984_matchCaseNode->definitionModule = modulename;
  meth_meth_ast_2984_matchCaseNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 678
  setline(678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject2985 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2985 = alloc_userobj2(2,4, objclass2985);
  gc_frame_newslot(obj2985);
  if (objclass2985 == NULL) {
    glfree(obj2985->class->name);
    obj2985->class->name = "methodTypeNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2985, self, 0);
  addmethodreal(obj2985,"outer", &reader_ast_outer_2986);
  Object oldself2985 = self;
  struct StackFrameObject *oldstackframe2985 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2985);
  gc_frame_newslot((Object)stackframe);
  self = obj2985;
  Object *oldselfslot2985 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2985 = (*(struct UserObject *)self).data[0], lowerouter2985 = thisouter2985;
  if (inheritingObject2985) {
    struct UserObject *inho2985 = (struct UserObject *)inheritingObject2985;
    while (inho2985->super != GraceDefaultObject) inho2985 = (struct UserObject *)inho2985->super;
    inho2985->super = obj2985;
    self = inheritingObject2985;
    *selfslot = self;
    lowerouter2985 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2985;
  }
// method "new(_,_)"
  block_savedest(obj2985);
  Object closure2987 = createclosure(4, "new(2)");
  setclosureframe(closure2987, stackframe);
  addtoclosure(closure2987, var_uninitialized);
  addtoclosure(closure2987, var_identifierNode);
  addtoclosure(closure2987, var_k);
  addtoclosure(closure2987, var_methodTypeNode);
  struct UserObject *uo2987 = (struct UserObject*)obj2985;
  uo2987->data[1] = (Object)closure2987;
  Method *meth_meth_ast_2987_new_40_2_41_ = addmethod2pos(obj2985, "new(2)", &meth_ast_2987_new_40_2_41_, 1);
  int argcv_meth_ast_2987_new_40_2_41_[] = {2};
  meth_meth_ast_2987_new_40_2_41_->type = alloc_MethodType(1, argcv_meth_ast_2987_new_40_2_41_);
  meth_meth_ast_2987_new_40_2_41_->definitionModule = modulename;
  meth_meth_ast_2987_new_40_2_41_->definitionLine = 679;
  block_savedest(obj2985);
  Object closure3385 = createclosure(4, "new(2)$object(1)");
  setclosureframe(closure3385, stackframe);
  addtoclosure(closure3385, var_uninitialized);
  addtoclosure(closure3385, var_identifierNode);
  addtoclosure(closure3385, var_k);
  addtoclosure(closure3385, var_methodTypeNode);
  Method *meth_meth_ast_2987_new_40_2_41__object = addmethod2pos(obj2985, "new(2)$object(1)", &meth_ast_2987_new_40_2_41__object, 1);
  meth_meth_ast_2987_new_40_2_41__object->definitionModule = modulename;
  meth_meth_ast_2987_new_40_2_41__object->definitionLine = 679;
  sourceObject = obj2985;
  objclass2985 = obj2985->class;
  objclass2985->definitionModule = modulename;
  objclass2985->definitionLine = 678;
  (*(struct UserObject *)self).data[0] = lowerouter2985;
  self = oldself2985;
  selfslot = oldselfslot2985;
  stackframe = oldstackframe2985;
// compiled object node returning obj2985 (depth = 2)
  *var_methodTypeNode = obj2985;
  if (obj2985 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "methodTypeNode"
  block_savedest(self);
  Object closure3386 = createclosure(1, "methodTypeNode");
  setclosureframe(closure3386, stackframe);
  addtoclosure(closure3386, var_methodTypeNode);
  struct UserObject *uo3386 = (struct UserObject*)self;
  uo3386->data[32] = (Object)closure3386;
  Method *meth_meth_ast_3386_methodTypeNode = addmethod2pos(self, "methodTypeNode", &meth_ast_3386_methodTypeNode, 32);
  int argcv_meth_ast_3386_methodTypeNode[] = {0};
  meth_meth_ast_3386_methodTypeNode->type = alloc_MethodType(1, argcv_meth_ast_3386_methodTypeNode);
  meth_meth_ast_3386_methodTypeNode->definitionModule = modulename;
  meth_meth_ast_3386_methodTypeNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 781
  setline(781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject3387 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3387 = alloc_userobj2(2,4, objclass3387);
  gc_frame_newslot(obj3387);
  if (objclass3387 == NULL) {
    glfree(obj3387->class->name);
    obj3387->class->name = "typeLiteralNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3387, self, 0);
  addmethodreal(obj3387,"outer", &reader_ast_outer_3388);
  Object oldself3387 = self;
  struct StackFrameObject *oldstackframe3387 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3387);
  gc_frame_newslot((Object)stackframe);
  self = obj3387;
  Object *oldselfslot3387 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3387 = (*(struct UserObject *)self).data[0], lowerouter3387 = thisouter3387;
  if (inheritingObject3387) {
    struct UserObject *inho3387 = (struct UserObject *)inheritingObject3387;
    while (inho3387->super != GraceDefaultObject) inho3387 = (struct UserObject *)inho3387->super;
    inho3387->super = obj3387;
    self = inheritingObject3387;
    *selfslot = self;
    lowerouter3387 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3387;
  }
// method "new(_,_)"
  block_savedest(obj3387);
  Object closure3389 = createclosure(4, "new(2)");
  setclosureframe(closure3389, stackframe);
  addtoclosure(closure3389, var_k);
  addtoclosure(closure3389, var_noPosition);
  addtoclosure(closure3389, var_emptySeq);
  addtoclosure(closure3389, var_typeLiteralNode);
  struct UserObject *uo3389 = (struct UserObject*)obj3387;
  uo3389->data[1] = (Object)closure3389;
  Method *meth_meth_ast_3389_new_40_2_41_ = addmethod2pos(obj3387, "new(2)", &meth_ast_3389_new_40_2_41_, 1);
  int argcv_meth_ast_3389_new_40_2_41_[] = {2};
  meth_meth_ast_3389_new_40_2_41_->type = alloc_MethodType(1, argcv_meth_ast_3389_new_40_2_41_);
  meth_meth_ast_3389_new_40_2_41_->definitionModule = modulename;
  meth_meth_ast_3389_new_40_2_41_->definitionLine = 782;
  block_savedest(obj3387);
  Object closure3686 = createclosure(4, "new(2)$object(1)");
  setclosureframe(closure3686, stackframe);
  addtoclosure(closure3686, var_k);
  addtoclosure(closure3686, var_noPosition);
  addtoclosure(closure3686, var_emptySeq);
  addtoclosure(closure3686, var_typeLiteralNode);
  Method *meth_meth_ast_3389_new_40_2_41__object = addmethod2pos(obj3387, "new(2)$object(1)", &meth_ast_3389_new_40_2_41__object, 1);
  meth_meth_ast_3389_new_40_2_41__object->definitionModule = modulename;
  meth_meth_ast_3389_new_40_2_41__object->definitionLine = 782;
  sourceObject = obj3387;
  objclass3387 = obj3387->class;
  objclass3387->definitionModule = modulename;
  objclass3387->definitionLine = 781;
  (*(struct UserObject *)self).data[0] = lowerouter3387;
  self = oldself3387;
  selfslot = oldselfslot3387;
  stackframe = oldstackframe3387;
// compiled object node returning obj3387 (depth = 2)
  *var_typeLiteralNode = obj3387;
  if (obj3387 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "typeLiteralNode"
  block_savedest(self);
  Object closure3687 = createclosure(1, "typeLiteralNode");
  setclosureframe(closure3687, stackframe);
  addtoclosure(closure3687, var_typeLiteralNode);
  struct UserObject *uo3687 = (struct UserObject*)self;
  uo3687->data[33] = (Object)closure3687;
  Method *meth_meth_ast_3687_typeLiteralNode = addmethod2pos(self, "typeLiteralNode", &meth_ast_3687_typeLiteralNode, 33);
  int argcv_meth_ast_3687_typeLiteralNode[] = {0};
  meth_meth_ast_3687_typeLiteralNode->type = alloc_MethodType(1, argcv_meth_ast_3687_typeLiteralNode);
  meth_meth_ast_3687_typeLiteralNode->definitionModule = modulename;
  meth_meth_ast_3687_typeLiteralNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 864
  setline(864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject3688 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3688 = alloc_userobj2(2,4, objclass3688);
  gc_frame_newslot(obj3688);
  if (objclass3688 == NULL) {
    glfree(obj3688->class->name);
    obj3688->class->name = "typeDecNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3688, self, 0);
  addmethodreal(obj3688,"outer", &reader_ast_outer_3689);
  Object oldself3688 = self;
  struct StackFrameObject *oldstackframe3688 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3688);
  gc_frame_newslot((Object)stackframe);
  self = obj3688;
  Object *oldselfslot3688 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3688 = (*(struct UserObject *)self).data[0], lowerouter3688 = thisouter3688;
  if (inheritingObject3688) {
    struct UserObject *inho3688 = (struct UserObject *)inheritingObject3688;
    while (inho3688->super != GraceDefaultObject) inho3688 = (struct UserObject *)inho3688->super;
    inho3688->super = obj3688;
    self = inheritingObject3688;
    *selfslot = self;
    lowerouter3688 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3688;
  }
// method "new(_,_)"
  block_savedest(obj3688);
  Object closure3690 = createclosure(3, "new(2)");
  setclosureframe(closure3690, stackframe);
  addtoclosure(closure3690, var_k);
  addtoclosure(closure3690, var_nullNode);
  addtoclosure(closure3690, var_typeDecNode);
  struct UserObject *uo3690 = (struct UserObject*)obj3688;
  uo3690->data[1] = (Object)closure3690;
  Method *meth_meth_ast_3690_new_40_2_41_ = addmethod2pos(obj3688, "new(2)", &meth_ast_3690_new_40_2_41_, 1);
  int argcv_meth_ast_3690_new_40_2_41_[] = {2};
  meth_meth_ast_3690_new_40_2_41_->type = alloc_MethodType(1, argcv_meth_ast_3690_new_40_2_41_);
  meth_meth_ast_3690_new_40_2_41_->definitionModule = modulename;
  meth_meth_ast_3690_new_40_2_41_->definitionLine = 865;
  block_savedest(obj3688);
  Object closure3990 = createclosure(3, "new(2)$object(1)");
  setclosureframe(closure3990, stackframe);
  addtoclosure(closure3990, var_k);
  addtoclosure(closure3990, var_nullNode);
  addtoclosure(closure3990, var_typeDecNode);
  Method *meth_meth_ast_3690_new_40_2_41__object = addmethod2pos(obj3688, "new(2)$object(1)", &meth_ast_3690_new_40_2_41__object, 1);
  meth_meth_ast_3690_new_40_2_41__object->definitionModule = modulename;
  meth_meth_ast_3690_new_40_2_41__object->definitionLine = 865;
  sourceObject = obj3688;
  objclass3688 = obj3688->class;
  objclass3688->definitionModule = modulename;
  objclass3688->definitionLine = 864;
  (*(struct UserObject *)self).data[0] = lowerouter3688;
  self = oldself3688;
  selfslot = oldselfslot3688;
  stackframe = oldstackframe3688;
// compiled object node returning obj3688 (depth = 2)
  *var_typeDecNode = obj3688;
  if (obj3688 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "typeDecNode"
  block_savedest(self);
  Object closure3991 = createclosure(1, "typeDecNode");
  setclosureframe(closure3991, stackframe);
  addtoclosure(closure3991, var_typeDecNode);
  struct UserObject *uo3991 = (struct UserObject*)self;
  uo3991->data[34] = (Object)closure3991;
  Method *meth_meth_ast_3991_typeDecNode = addmethod2pos(self, "typeDecNode", &meth_ast_3991_typeDecNode, 34);
  int argcv_meth_ast_3991_typeDecNode[] = {0};
  meth_meth_ast_3991_typeDecNode->type = alloc_MethodType(1, argcv_meth_ast_3991_typeDecNode);
  meth_meth_ast_3991_typeDecNode->definitionModule = modulename;
  meth_meth_ast_3991_typeDecNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 949
  setline(949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject3992 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3992 = alloc_userobj2(3,4, objclass3992);
  gc_frame_newslot(obj3992);
  if (objclass3992 == NULL) {
    glfree(obj3992->class->name);
    obj3992->class->name = "methodNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3992, self, 0);
  addmethodreal(obj3992,"outer", &reader_ast_outer_3993);
  Object oldself3992 = self;
  struct StackFrameObject *oldstackframe3992 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3992);
  gc_frame_newslot((Object)stackframe);
  self = obj3992;
  Object *oldselfslot3992 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3992 = (*(struct UserObject *)self).data[0], lowerouter3992 = thisouter3992;
  if (inheritingObject3992) {
    struct UserObject *inho3992 = (struct UserObject *)inheritingObject3992;
    while (inho3992->super != GraceDefaultObject) inho3992 = (struct UserObject *)inho3992->super;
    inho3992->super = obj3992;
    self = inheritingObject3992;
    *selfslot = self;
    lowerouter3992 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3992;
  }
// method "new(_,_,_)scope(_)"
  struct UserObject *uo3994 = (struct UserObject*)obj3992;
  uo3994->data[1] = emptyclosure;
  Method *meth_meth_ast_3994_new_40_3_41_scope_40_1_41_ = addmethod2pos(obj3992, "new(3)scope(1)", &meth_ast_3994_new_40_3_41_scope_40_1_41_, 1);
  int argcv_meth_ast_3994_new_40_3_41_scope_40_1_41_[] = {3, 1};
  meth_meth_ast_3994_new_40_3_41_scope_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_3994_new_40_3_41_scope_40_1_41_);
  meth_meth_ast_3994_new_40_3_41_scope_40_1_41_->definitionModule = modulename;
  meth_meth_ast_3994_new_40_3_41_scope_40_1_41_->definitionLine = 950;
// method "new(_,_,_)"
  block_savedest(obj3992);
  Object closure3999 = createclosure(4, "new(3)");
  setclosureframe(closure3999, stackframe);
  addtoclosure(closure3999, var_uninitialized);
  addtoclosure(closure3999, var_identifierNode);
  addtoclosure(closure3999, var_k);
  addtoclosure(closure3999, var_methodNode);
  struct UserObject *uo3999 = (struct UserObject*)obj3992;
  uo3999->data[2] = (Object)closure3999;
  Method *meth_meth_ast_3999_new_40_3_41_ = addmethod2pos(obj3992, "new(3)", &meth_ast_3999_new_40_3_41_, 2);
  int argcv_meth_ast_3999_new_40_3_41_[] = {3};
  meth_meth_ast_3999_new_40_3_41_->type = alloc_MethodType(1, argcv_meth_ast_3999_new_40_3_41_);
  meth_meth_ast_3999_new_40_3_41_->definitionModule = modulename;
  meth_meth_ast_3999_new_40_3_41_->definitionLine = 956;
  block_savedest(obj3992);
  Object closure5184 = createclosure(4, "new(3)$object(1)");
  setclosureframe(closure5184, stackframe);
  addtoclosure(closure5184, var_uninitialized);
  addtoclosure(closure5184, var_identifierNode);
  addtoclosure(closure5184, var_k);
  addtoclosure(closure5184, var_methodNode);
  Method *meth_meth_ast_3999_new_40_3_41__object = addmethod2pos(obj3992, "new(3)$object(1)", &meth_ast_3999_new_40_3_41__object, 2);
  meth_meth_ast_3999_new_40_3_41__object->definitionModule = modulename;
  meth_meth_ast_3999_new_40_3_41__object->definitionLine = 956;
  sourceObject = obj3992;
  sourceObject = obj3992;
  objclass3992 = obj3992->class;
  objclass3992->definitionModule = modulename;
  objclass3992->definitionLine = 949;
  (*(struct UserObject *)self).data[0] = lowerouter3992;
  self = oldself3992;
  selfslot = oldselfslot3992;
  stackframe = oldstackframe3992;
// compiled object node returning obj3992 (depth = 2)
  *var_methodNode = obj3992;
  if (obj3992 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "methodNode"
  block_savedest(self);
  Object closure5185 = createclosure(1, "methodNode");
  setclosureframe(closure5185, stackframe);
  addtoclosure(closure5185, var_methodNode);
  struct UserObject *uo5185 = (struct UserObject*)self;
  uo5185->data[35] = (Object)closure5185;
  Method *meth_meth_ast_5185_methodNode = addmethod2pos(self, "methodNode", &meth_ast_5185_methodNode, 35);
  int argcv_meth_ast_5185_methodNode[] = {0};
  meth_meth_ast_5185_methodNode->type = alloc_MethodType(1, argcv_meth_ast_5185_methodNode);
  meth_meth_ast_5185_methodNode->definitionModule = modulename;
  meth_meth_ast_5185_methodNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1226
  setline(1226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5186 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5186 = alloc_userobj2(3,4, objclass5186);
  gc_frame_newslot(obj5186);
  if (objclass5186 == NULL) {
    glfree(obj5186->class->name);
    obj5186->class->name = "callNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj5186, self, 0);
  addmethodreal(obj5186,"outer", &reader_ast_outer_5187);
  Object oldself5186 = self;
  struct StackFrameObject *oldstackframe5186 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5186);
  gc_frame_newslot((Object)stackframe);
  self = obj5186;
  Object *oldselfslot5186 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5186 = (*(struct UserObject *)self).data[0], lowerouter5186 = thisouter5186;
  if (inheritingObject5186) {
    struct UserObject *inho5186 = (struct UserObject *)inheritingObject5186;
    while (inho5186->super != GraceDefaultObject) inho5186 = (struct UserObject *)inho5186->super;
    inho5186->super = obj5186;
    self = inheritingObject5186;
    *selfslot = self;
    lowerouter5186 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5186;
  }
// method "new(_,_)scope(_)"
  struct UserObject *uo5188 = (struct UserObject*)obj5186;
  uo5188->data[1] = emptyclosure;
  Method *meth_meth_ast_5188_new_40_2_41_scope_40_1_41_ = addmethod2pos(obj5186, "new(2)scope(1)", &meth_ast_5188_new_40_2_41_scope_40_1_41_, 1);
  int argcv_meth_ast_5188_new_40_2_41_scope_40_1_41_[] = {2, 1};
  meth_meth_ast_5188_new_40_2_41_scope_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_5188_new_40_2_41_scope_40_1_41_);
  meth_meth_ast_5188_new_40_2_41_scope_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5188_new_40_2_41_scope_40_1_41_->definitionLine = 1227;
// method "new(_,_)"
  block_savedest(obj5186);
  Object closure5193 = createclosure(6, "new(2)");
  setclosureframe(closure5193, stackframe);
  addtoclosure(closure5193, var_noPosition);
  addtoclosure(closure5193, var_util);
  addtoclosure(closure5193, var_uninitialized);
  addtoclosure(closure5193, var_fakeSymbolTable);
  addtoclosure(closure5193, var_identifierNode);
  addtoclosure(closure5193, var_callNode);
  struct UserObject *uo5193 = (struct UserObject*)obj5186;
  uo5193->data[2] = (Object)closure5193;
  Method *meth_meth_ast_5193_new_40_2_41_ = addmethod2pos(obj5186, "new(2)", &meth_ast_5193_new_40_2_41_, 2);
  int argcv_meth_ast_5193_new_40_2_41_[] = {2};
  meth_meth_ast_5193_new_40_2_41_->type = alloc_MethodType(1, argcv_meth_ast_5193_new_40_2_41_);
  meth_meth_ast_5193_new_40_2_41_->definitionModule = modulename;
  meth_meth_ast_5193_new_40_2_41_->definitionLine = 1232;
  block_savedest(obj5186);
  Object closure5870 = createclosure(6, "new(2)$object(1)");
  setclosureframe(closure5870, stackframe);
  addtoclosure(closure5870, var_noPosition);
  addtoclosure(closure5870, var_util);
  addtoclosure(closure5870, var_uninitialized);
  addtoclosure(closure5870, var_fakeSymbolTable);
  addtoclosure(closure5870, var_identifierNode);
  addtoclosure(closure5870, var_callNode);
  Method *meth_meth_ast_5193_new_40_2_41__object = addmethod2pos(obj5186, "new(2)$object(1)", &meth_ast_5193_new_40_2_41__object, 2);
  meth_meth_ast_5193_new_40_2_41__object->definitionModule = modulename;
  meth_meth_ast_5193_new_40_2_41__object->definitionLine = 1232;
  sourceObject = obj5186;
  sourceObject = obj5186;
  objclass5186 = obj5186->class;
  objclass5186->definitionModule = modulename;
  objclass5186->definitionLine = 1226;
  (*(struct UserObject *)self).data[0] = lowerouter5186;
  self = oldself5186;
  selfslot = oldselfslot5186;
  stackframe = oldstackframe5186;
// compiled object node returning obj5186 (depth = 2)
  *var_callNode = obj5186;
  if (obj5186 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "callNode"
  block_savedest(self);
  Object closure5871 = createclosure(1, "callNode");
  setclosureframe(closure5871, stackframe);
  addtoclosure(closure5871, var_callNode);
  struct UserObject *uo5871 = (struct UserObject*)self;
  uo5871->data[36] = (Object)closure5871;
  Method *meth_meth_ast_5871_callNode = addmethod2pos(self, "callNode", &meth_ast_5871_callNode, 36);
  int argcv_meth_ast_5871_callNode[] = {0};
  meth_meth_ast_5871_callNode->type = alloc_MethodType(1, argcv_meth_ast_5871_callNode);
  meth_meth_ast_5871_callNode->definitionModule = modulename;
  meth_meth_ast_5871_callNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1412
  setline(1412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5872 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5872 = alloc_userobj2(4,5, objclass5872);
  gc_frame_newslot(obj5872);
  if (objclass5872 == NULL) {
    glfree(obj5872->class->name);
    obj5872->class->name = "moduleNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj5872, self, 0);
  addmethodreal(obj5872,"outer", &reader_ast_outer_5873);
  Object oldself5872 = self;
  struct StackFrameObject *oldstackframe5872 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5872);
  gc_frame_newslot((Object)stackframe);
  self = obj5872;
  Object *oldselfslot5872 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5872 = (*(struct UserObject *)self).data[0], lowerouter5872 = thisouter5872;
  if (inheritingObject5872) {
    struct UserObject *inho5872 = (struct UserObject *)inheritingObject5872;
    while (inho5872->super != GraceDefaultObject) inho5872 = (struct UserObject *)inho5872->super;
    inho5872->super = obj5872;
    self = inheritingObject5872;
    *selfslot = self;
    lowerouter5872 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5872;
  }
// method "body(_)named(_)scope(_)"
  struct UserObject *uo5874 = (struct UserObject*)obj5872;
  uo5874->data[1] = emptyclosure;
  Method *meth_meth_ast_5874_body_40_1_41_named_40_1_41_scope_40_1_41_ = addmethod2pos(obj5872, "body(1)named(1)scope(1)", &meth_ast_5874_body_40_1_41_named_40_1_41_scope_40_1_41_, 1);
  int argcv_meth_ast_5874_body_40_1_41_named_40_1_41_scope_40_1_41_[] = {1, 1, 1};
  meth_meth_ast_5874_body_40_1_41_named_40_1_41_scope_40_1_41_->type = alloc_MethodType(3, argcv_meth_ast_5874_body_40_1_41_named_40_1_41_scope_40_1_41_);
  meth_meth_ast_5874_body_40_1_41_named_40_1_41_scope_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5874_body_40_1_41_named_40_1_41_scope_40_1_41_->definitionLine = 1413;
// method "body(_)named(_)"
  struct UserObject *uo5881 = (struct UserObject*)obj5872;
  uo5881->data[2] = emptyclosure;
  Method *meth_meth_ast_5881_body_40_1_41_named_40_1_41_ = addmethod2pos(obj5872, "body(1)named(1)", &meth_ast_5881_body_40_1_41_named_40_1_41_, 2);
  int argcv_meth_ast_5881_body_40_1_41_named_40_1_41_[] = {1, 1};
  meth_meth_ast_5881_body_40_1_41_named_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_5881_body_40_1_41_named_40_1_41_);
  meth_meth_ast_5881_body_40_1_41_named_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5881_body_40_1_41_named_40_1_41_->definitionLine = 1419;
// method "body(_)"
  block_savedest(obj5872);
  Object closure5886 = createclosure(6, "body(1)");
  setclosureframe(closure5886, stackframe);
  addtoclosure(closure5886, var_util);
  addtoclosure(closure5886, var_emptySeq);
  addtoclosure(closure5886, var_moduleNode);
  addtoclosure(closure5886, var_objectNode);
  addtoclosure(closure5886, var_dialectNode);
  addtoclosure(closure5886, var_noPosition);
  struct UserObject *uo5886 = (struct UserObject*)obj5872;
  uo5886->data[3] = (Object)closure5886;
  Method *meth_meth_ast_5886_body_40_1_41_ = addmethod2pos(obj5872, "body(1)", &meth_ast_5886_body_40_1_41_, 3);
  int argcv_meth_ast_5886_body_40_1_41_[] = {1};
  meth_meth_ast_5886_body_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_5886_body_40_1_41_);
  meth_meth_ast_5886_body_40_1_41_->definitionModule = modulename;
  meth_meth_ast_5886_body_40_1_41_->definitionLine = 1424;
  block_savedest(obj5872);
  Object closure6108 = createclosure(6, "body(1)$object(1)");
  setclosureframe(closure6108, stackframe);
  addtoclosure(closure6108, var_util);
  addtoclosure(closure6108, var_emptySeq);
  addtoclosure(closure6108, var_moduleNode);
  addtoclosure(closure6108, var_objectNode);
  addtoclosure(closure6108, var_dialectNode);
  addtoclosure(closure6108, var_noPosition);
  Method *meth_meth_ast_5886_body_40_1_41__object = addmethod2pos(obj5872, "body(1)$object(1)", &meth_ast_5886_body_40_1_41__object, 3);
  meth_meth_ast_5886_body_40_1_41__object->definitionModule = modulename;
  meth_meth_ast_5886_body_40_1_41__object->definitionLine = 1424;
  sourceObject = obj5872;
  sourceObject = obj5872;
  sourceObject = obj5872;
  objclass5872 = obj5872->class;
  objclass5872->definitionModule = modulename;
  objclass5872->definitionLine = 1412;
  (*(struct UserObject *)self).data[0] = lowerouter5872;
  self = oldself5872;
  selfslot = oldselfslot5872;
  stackframe = oldstackframe5872;
// compiled object node returning obj5872 (depth = 2)
  *var_moduleNode = obj5872;
  if (obj5872 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "moduleNode"
  block_savedest(self);
  Object closure6109 = createclosure(1, "moduleNode");
  setclosureframe(closure6109, stackframe);
  addtoclosure(closure6109, var_moduleNode);
  struct UserObject *uo6109 = (struct UserObject*)self;
  uo6109->data[37] = (Object)closure6109;
  Method *meth_meth_ast_6109_moduleNode = addmethod2pos(self, "moduleNode", &meth_ast_6109_moduleNode, 37);
  int argcv_meth_ast_6109_moduleNode[] = {0};
  meth_meth_ast_6109_moduleNode->type = alloc_MethodType(1, argcv_meth_ast_6109_moduleNode);
  meth_meth_ast_6109_moduleNode->definitionModule = modulename;
  meth_meth_ast_6109_moduleNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1499
  setline(1499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6110 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6110 = alloc_userobj2(4,5, objclass6110);
  gc_frame_newslot(obj6110);
  if (objclass6110 == NULL) {
    glfree(obj6110->class->name);
    obj6110->class->name = "objectNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj6110, self, 0);
  addmethodreal(obj6110,"outer", &reader_ast_outer_6111);
  Object oldself6110 = self;
  struct StackFrameObject *oldstackframe6110 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6110);
  gc_frame_newslot((Object)stackframe);
  self = obj6110;
  Object *oldselfslot6110 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6110 = (*(struct UserObject *)self).data[0], lowerouter6110 = thisouter6110;
  if (inheritingObject6110) {
    struct UserObject *inho6110 = (struct UserObject *)inheritingObject6110;
    while (inho6110->super != GraceDefaultObject) inho6110 = (struct UserObject *)inho6110->super;
    inho6110->super = obj6110;
    self = inheritingObject6110;
    *selfslot = self;
    lowerouter6110 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6110;
  }
// method "body(_)named(_)scope(_)"
  struct UserObject *uo6112 = (struct UserObject*)obj6110;
  uo6112->data[1] = emptyclosure;
  Method *meth_meth_ast_6112_body_40_1_41_named_40_1_41_scope_40_1_41_ = addmethod2pos(obj6110, "body(1)named(1)scope(1)", &meth_ast_6112_body_40_1_41_named_40_1_41_scope_40_1_41_, 1);
  int argcv_meth_ast_6112_body_40_1_41_named_40_1_41_scope_40_1_41_[] = {1, 1, 1};
  meth_meth_ast_6112_body_40_1_41_named_40_1_41_scope_40_1_41_->type = alloc_MethodType(3, argcv_meth_ast_6112_body_40_1_41_named_40_1_41_scope_40_1_41_);
  meth_meth_ast_6112_body_40_1_41_named_40_1_41_scope_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6112_body_40_1_41_named_40_1_41_scope_40_1_41_->definitionLine = 1500;
// method "body(_)named(_)"
  block_savedest(obj6110);
  Object closure6120 = createclosure(1, "body(1)named(1)");
  setclosureframe(closure6120, stackframe);
  addtoclosure(closure6120, var_fakeSymbolTable);
  struct UserObject *uo6120 = (struct UserObject*)obj6110;
  uo6120->data[2] = (Object)closure6120;
  Method *meth_meth_ast_6120_body_40_1_41_named_40_1_41_ = addmethod2pos(obj6110, "body(1)named(1)", &meth_ast_6120_body_40_1_41_named_40_1_41_, 2);
  int argcv_meth_ast_6120_body_40_1_41_named_40_1_41_[] = {1, 1};
  meth_meth_ast_6120_body_40_1_41_named_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_6120_body_40_1_41_named_40_1_41_);
  meth_meth_ast_6120_body_40_1_41_named_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6120_body_40_1_41_named_40_1_41_->definitionLine = 1506;
// method "new(_,_)"
  block_savedest(obj6110);
  Object closure6123 = createclosure(3, "new(2)");
  setclosureframe(closure6123, stackframe);
  addtoclosure(closure6123, var_noPosition);
  addtoclosure(closure6123, var_emptySeq);
  addtoclosure(closure6123, var_objectNode);
  struct UserObject *uo6123 = (struct UserObject*)obj6110;
  uo6123->data[3] = (Object)closure6123;
  Method *meth_meth_ast_6123_new_40_2_41_ = addmethod2pos(obj6110, "new(2)", &meth_ast_6123_new_40_2_41_, 3);
  int argcv_meth_ast_6123_new_40_2_41_[] = {2};
  meth_meth_ast_6123_new_40_2_41_->type = alloc_MethodType(1, argcv_meth_ast_6123_new_40_2_41_);
  meth_meth_ast_6123_new_40_2_41_->definitionModule = modulename;
  meth_meth_ast_6123_new_40_2_41_->definitionLine = 1509;
  block_savedest(obj6110);
  Object closure6735 = createclosure(3, "new(2)$object(1)");
  setclosureframe(closure6735, stackframe);
  addtoclosure(closure6735, var_noPosition);
  addtoclosure(closure6735, var_emptySeq);
  addtoclosure(closure6735, var_objectNode);
  Method *meth_meth_ast_6123_new_40_2_41__object = addmethod2pos(obj6110, "new(2)$object(1)", &meth_ast_6123_new_40_2_41__object, 3);
  meth_meth_ast_6123_new_40_2_41__object->definitionModule = modulename;
  meth_meth_ast_6123_new_40_2_41__object->definitionLine = 1509;
  sourceObject = obj6110;
  sourceObject = obj6110;
  sourceObject = obj6110;
  objclass6110 = obj6110->class;
  objclass6110->definitionModule = modulename;
  objclass6110->definitionLine = 1499;
  (*(struct UserObject *)self).data[0] = lowerouter6110;
  self = oldself6110;
  selfslot = oldselfslot6110;
  stackframe = oldstackframe6110;
// compiled object node returning obj6110 (depth = 2)
  *var_objectNode = obj6110;
  if (obj6110 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "objectNode"
  block_savedest(self);
  Object closure6736 = createclosure(1, "objectNode");
  setclosureframe(closure6736, stackframe);
  addtoclosure(closure6736, var_objectNode);
  struct UserObject *uo6736 = (struct UserObject*)self;
  uo6736->data[38] = (Object)closure6736;
  Method *meth_meth_ast_6736_objectNode = addmethod2pos(self, "objectNode", &meth_ast_6736_objectNode, 38);
  int argcv_meth_ast_6736_objectNode[] = {0};
  meth_meth_ast_6736_objectNode->type = alloc_MethodType(1, argcv_meth_ast_6736_objectNode);
  meth_meth_ast_6736_objectNode->definitionModule = modulename;
  meth_meth_ast_6736_objectNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1682
  setline(1682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6737 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6737 = alloc_userobj2(2,4, objclass6737);
  gc_frame_newslot(obj6737);
  if (objclass6737 == NULL) {
    glfree(obj6737->class->name);
    obj6737->class->name = "arrayNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj6737, self, 0);
  addmethodreal(obj6737,"outer", &reader_ast_outer_6738);
  Object oldself6737 = self;
  struct StackFrameObject *oldstackframe6737 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6737);
  gc_frame_newslot((Object)stackframe);
  self = obj6737;
  Object *oldselfslot6737 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6737 = (*(struct UserObject *)self).data[0], lowerouter6737 = thisouter6737;
  if (inheritingObject6737) {
    struct UserObject *inho6737 = (struct UserObject *)inheritingObject6737;
    while (inho6737->super != GraceDefaultObject) inho6737 = (struct UserObject *)inho6737->super;
    inho6737->super = obj6737;
    self = inheritingObject6737;
    *selfslot = self;
    lowerouter6737 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6737;
  }
// method "new(_)"
  block_savedest(obj6737);
  Object closure6739 = createclosure(2, "new(1)");
  setclosureframe(closure6739, stackframe);
  addtoclosure(closure6739, var_emptySeq);
  addtoclosure(closure6739, var_arrayNode);
  struct UserObject *uo6739 = (struct UserObject*)obj6737;
  uo6739->data[1] = (Object)closure6739;
  Method *meth_meth_ast_6739_new_40_1_41_ = addmethod2pos(obj6737, "new(1)", &meth_ast_6739_new_40_1_41_, 1);
  int argcv_meth_ast_6739_new_40_1_41_[] = {1};
  meth_meth_ast_6739_new_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_6739_new_40_1_41_);
  meth_meth_ast_6739_new_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6739_new_40_1_41_->definitionLine = 1683;
  block_savedest(obj6737);
  Object closure6875 = createclosure(2, "new(1)$object(1)");
  setclosureframe(closure6875, stackframe);
  addtoclosure(closure6875, var_emptySeq);
  addtoclosure(closure6875, var_arrayNode);
  Method *meth_meth_ast_6739_new_40_1_41__object = addmethod2pos(obj6737, "new(1)$object(1)", &meth_ast_6739_new_40_1_41__object, 1);
  meth_meth_ast_6739_new_40_1_41__object->definitionModule = modulename;
  meth_meth_ast_6739_new_40_1_41__object->definitionLine = 1683;
  sourceObject = obj6737;
  objclass6737 = obj6737->class;
  objclass6737->definitionModule = modulename;
  objclass6737->definitionLine = 1682;
  (*(struct UserObject *)self).data[0] = lowerouter6737;
  self = oldself6737;
  selfslot = oldselfslot6737;
  stackframe = oldstackframe6737;
// compiled object node returning obj6737 (depth = 2)
  *var_arrayNode = obj6737;
  if (obj6737 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "arrayNode"
  block_savedest(self);
  Object closure6876 = createclosure(1, "arrayNode");
  setclosureframe(closure6876, stackframe);
  addtoclosure(closure6876, var_arrayNode);
  struct UserObject *uo6876 = (struct UserObject*)self;
  uo6876->data[39] = (Object)closure6876;
  Method *meth_meth_ast_6876_arrayNode = addmethod2pos(self, "arrayNode", &meth_ast_6876_arrayNode, 39);
  int argcv_meth_ast_6876_arrayNode[] = {0};
  meth_meth_ast_6876_arrayNode->type = alloc_MethodType(1, argcv_meth_ast_6876_arrayNode);
  meth_meth_ast_6876_arrayNode->definitionModule = modulename;
  meth_meth_ast_6876_arrayNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1762
  setline(1762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6877 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6877 = alloc_userobj2(3,4, objclass6877);
  gc_frame_newslot(obj6877);
  if (objclass6877 == NULL) {
    glfree(obj6877->class->name);
    obj6877->class->name = "memberNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj6877, self, 0);
  addmethodreal(obj6877,"outer", &reader_ast_outer_6878);
  Object oldself6877 = self;
  struct StackFrameObject *oldstackframe6877 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6877);
  gc_frame_newslot((Object)stackframe);
  self = obj6877;
  Object *oldselfslot6877 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6877 = (*(struct UserObject *)self).data[0], lowerouter6877 = thisouter6877;
  if (inheritingObject6877) {
    struct UserObject *inho6877 = (struct UserObject *)inheritingObject6877;
    while (inho6877->super != GraceDefaultObject) inho6877 = (struct UserObject *)inho6877->super;
    inho6877->super = obj6877;
    self = inheritingObject6877;
    *selfslot = self;
    lowerouter6877 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6877;
  }
// method "new(_,_)scope(_)"
  struct UserObject *uo6879 = (struct UserObject*)obj6877;
  uo6879->data[1] = emptyclosure;
  Method *meth_meth_ast_6879_new_40_2_41_scope_40_1_41_ = addmethod2pos(obj6877, "new(2)scope(1)", &meth_ast_6879_new_40_2_41_scope_40_1_41_, 1);
  int argcv_meth_ast_6879_new_40_2_41_scope_40_1_41_[] = {2, 1};
  meth_meth_ast_6879_new_40_2_41_scope_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_6879_new_40_2_41_scope_40_1_41_);
  meth_meth_ast_6879_new_40_2_41_scope_40_1_41_->definitionModule = modulename;
  meth_meth_ast_6879_new_40_2_41_scope_40_1_41_->definitionLine = 1763;
// method "new(_,_)"
  block_savedest(obj6877);
  Object closure6884 = createclosure(5, "new(2)");
  setclosureframe(closure6884, stackframe);
  addtoclosure(closure6884, var_requestPart);
  addtoclosure(closure6884, var_emptySeq);
  addtoclosure(closure6884, var_fakeSymbolTable);
  addtoclosure(closure6884, var_identifierNode);
  addtoclosure(closure6884, var_memberNode);
  struct UserObject *uo6884 = (struct UserObject*)obj6877;
  uo6884->data[2] = (Object)closure6884;
  Method *meth_meth_ast_6884_new_40_2_41_ = addmethod2pos(obj6877, "new(2)", &meth_ast_6884_new_40_2_41_, 2);
  int argcv_meth_ast_6884_new_40_2_41_[] = {2};
  meth_meth_ast_6884_new_40_2_41_->type = alloc_MethodType(1, argcv_meth_ast_6884_new_40_2_41_);
  meth_meth_ast_6884_new_40_2_41_->definitionModule = modulename;
  meth_meth_ast_6884_new_40_2_41_->definitionLine = 1769;
  block_savedest(obj6877);
  Object closure7262 = createclosure(5, "new(2)$object(1)");
  setclosureframe(closure7262, stackframe);
  addtoclosure(closure7262, var_requestPart);
  addtoclosure(closure7262, var_emptySeq);
  addtoclosure(closure7262, var_fakeSymbolTable);
  addtoclosure(closure7262, var_identifierNode);
  addtoclosure(closure7262, var_memberNode);
  Method *meth_meth_ast_6884_new_40_2_41__object = addmethod2pos(obj6877, "new(2)$object(1)", &meth_ast_6884_new_40_2_41__object, 2);
  meth_meth_ast_6884_new_40_2_41__object->definitionModule = modulename;
  meth_meth_ast_6884_new_40_2_41__object->definitionLine = 1769;
  sourceObject = obj6877;
  sourceObject = obj6877;
  objclass6877 = obj6877->class;
  objclass6877->definitionModule = modulename;
  objclass6877->definitionLine = 1762;
  (*(struct UserObject *)self).data[0] = lowerouter6877;
  self = oldself6877;
  selfslot = oldselfslot6877;
  stackframe = oldstackframe6877;
// compiled object node returning obj6877 (depth = 2)
  *var_memberNode = obj6877;
  if (obj6877 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "memberNode"
  block_savedest(self);
  Object closure7263 = createclosure(1, "memberNode");
  setclosureframe(closure7263, stackframe);
  addtoclosure(closure7263, var_memberNode);
  struct UserObject *uo7263 = (struct UserObject*)self;
  uo7263->data[40] = (Object)closure7263;
  Method *meth_meth_ast_7263_memberNode = addmethod2pos(self, "memberNode", &meth_ast_7263_memberNode, 40);
  int argcv_meth_ast_7263_memberNode[] = {0};
  meth_meth_ast_7263_memberNode->type = alloc_MethodType(1, argcv_meth_ast_7263_memberNode);
  meth_meth_ast_7263_memberNode->definitionModule = modulename;
  meth_meth_ast_7263_memberNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1874
  setline(1874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7264 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7264 = alloc_userobj2(2,4, objclass7264);
  gc_frame_newslot(obj7264);
  if (objclass7264 == NULL) {
    glfree(obj7264->class->name);
    obj7264->class->name = "genericNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj7264, self, 0);
  addmethodreal(obj7264,"outer", &reader_ast_outer_7265);
  Object oldself7264 = self;
  struct StackFrameObject *oldstackframe7264 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7264);
  gc_frame_newslot((Object)stackframe);
  self = obj7264;
  Object *oldselfslot7264 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7264 = (*(struct UserObject *)self).data[0], lowerouter7264 = thisouter7264;
  if (inheritingObject7264) {
    struct UserObject *inho7264 = (struct UserObject *)inheritingObject7264;
    while (inho7264->super != GraceDefaultObject) inho7264 = (struct UserObject *)inho7264->super;
    inho7264->super = obj7264;
    self = inheritingObject7264;
    *selfslot = self;
    lowerouter7264 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7264;
  }
// method "new(_,_)"
  block_savedest(obj7264);
  Object closure7266 = createclosure(1, "new(2)");
  setclosureframe(closure7266, stackframe);
  addtoclosure(closure7266, var_genericNode);
  struct UserObject *uo7266 = (struct UserObject*)obj7264;
  uo7266->data[1] = (Object)closure7266;
  Method *meth_meth_ast_7266_new_40_2_41_ = addmethod2pos(obj7264, "new(2)", &meth_ast_7266_new_40_2_41_, 1);
  int argcv_meth_ast_7266_new_40_2_41_[] = {2};
  meth_meth_ast_7266_new_40_2_41_->type = alloc_MethodType(1, argcv_meth_ast_7266_new_40_2_41_);
  meth_meth_ast_7266_new_40_2_41_->definitionModule = modulename;
  meth_meth_ast_7266_new_40_2_41_->definitionLine = 1875;
  block_savedest(obj7264);
  Object closure7425 = createclosure(1, "new(2)$object(1)");
  setclosureframe(closure7425, stackframe);
  addtoclosure(closure7425, var_genericNode);
  Method *meth_meth_ast_7266_new_40_2_41__object = addmethod2pos(obj7264, "new(2)$object(1)", &meth_ast_7266_new_40_2_41__object, 1);
  meth_meth_ast_7266_new_40_2_41__object->definitionModule = modulename;
  meth_meth_ast_7266_new_40_2_41__object->definitionLine = 1875;
  sourceObject = obj7264;
  objclass7264 = obj7264->class;
  objclass7264->definitionModule = modulename;
  objclass7264->definitionLine = 1874;
  (*(struct UserObject *)self).data[0] = lowerouter7264;
  self = oldself7264;
  selfslot = oldselfslot7264;
  stackframe = oldstackframe7264;
// compiled object node returning obj7264 (depth = 2)
  *var_genericNode = obj7264;
  if (obj7264 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "genericNode"
  block_savedest(self);
  Object closure7426 = createclosure(1, "genericNode");
  setclosureframe(closure7426, stackframe);
  addtoclosure(closure7426, var_genericNode);
  struct UserObject *uo7426 = (struct UserObject*)self;
  uo7426->data[41] = (Object)closure7426;
  Method *meth_meth_ast_7426_genericNode = addmethod2pos(self, "genericNode", &meth_ast_7426_genericNode, 41);
  int argcv_meth_ast_7426_genericNode[] = {0};
  meth_meth_ast_7426_genericNode->type = alloc_MethodType(1, argcv_meth_ast_7426_genericNode);
  meth_meth_ast_7426_genericNode->definitionModule = modulename;
  meth_meth_ast_7426_genericNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1920
  setline(1920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7427 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7427 = alloc_userobj2(2,4, objclass7427);
  gc_frame_newslot(obj7427);
  if (objclass7427 == NULL) {
    glfree(obj7427->class->name);
    obj7427->class->name = "typeParametersNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj7427, self, 0);
  addmethodreal(obj7427,"outer", &reader_ast_outer_7428);
  Object oldself7427 = self;
  struct StackFrameObject *oldstackframe7427 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7427);
  gc_frame_newslot((Object)stackframe);
  self = obj7427;
  Object *oldselfslot7427 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7427 = (*(struct UserObject *)self).data[0], lowerouter7427 = thisouter7427;
  if (inheritingObject7427) {
    struct UserObject *inho7427 = (struct UserObject *)inheritingObject7427;
    while (inho7427->super != GraceDefaultObject) inho7427 = (struct UserObject *)inho7427->super;
    inho7427->super = obj7427;
    self = inheritingObject7427;
    *selfslot = self;
    lowerouter7427 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7427;
  }
// method "new(_)"
  block_savedest(obj7427);
  Object closure7429 = createclosure(3, "new(1)");
  setclosureframe(closure7429, stackframe);
  addtoclosure(closure7429, var_k);
  addtoclosure(closure7429, var_emptySeq);
  addtoclosure(closure7429, var_typeParametersNode);
  struct UserObject *uo7429 = (struct UserObject*)obj7427;
  uo7429->data[1] = (Object)closure7429;
  Method *meth_meth_ast_7429_new_40_1_41_ = addmethod2pos(obj7427, "new(1)", &meth_ast_7429_new_40_1_41_, 1);
  int argcv_meth_ast_7429_new_40_1_41_[] = {1};
  meth_meth_ast_7429_new_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7429_new_40_1_41_);
  meth_meth_ast_7429_new_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7429_new_40_1_41_->definitionLine = 1921;
  block_savedest(obj7427);
  Object closure7584 = createclosure(3, "new(1)$object(1)");
  setclosureframe(closure7584, stackframe);
  addtoclosure(closure7584, var_k);
  addtoclosure(closure7584, var_emptySeq);
  addtoclosure(closure7584, var_typeParametersNode);
  Method *meth_meth_ast_7429_new_40_1_41__object = addmethod2pos(obj7427, "new(1)$object(1)", &meth_ast_7429_new_40_1_41__object, 1);
  meth_meth_ast_7429_new_40_1_41__object->definitionModule = modulename;
  meth_meth_ast_7429_new_40_1_41__object->definitionLine = 1921;
  sourceObject = obj7427;
  objclass7427 = obj7427->class;
  objclass7427->definitionModule = modulename;
  objclass7427->definitionLine = 1920;
  (*(struct UserObject *)self).data[0] = lowerouter7427;
  self = oldself7427;
  selfslot = oldselfslot7427;
  stackframe = oldstackframe7427;
// compiled object node returning obj7427 (depth = 2)
  *var_typeParametersNode = obj7427;
  if (obj7427 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "typeParametersNode"
  block_savedest(self);
  Object closure7585 = createclosure(1, "typeParametersNode");
  setclosureframe(closure7585, stackframe);
  addtoclosure(closure7585, var_typeParametersNode);
  struct UserObject *uo7585 = (struct UserObject*)self;
  uo7585->data[42] = (Object)closure7585;
  Method *meth_meth_ast_7585_typeParametersNode = addmethod2pos(self, "typeParametersNode", &meth_ast_7585_typeParametersNode, 42);
  int argcv_meth_ast_7585_typeParametersNode[] = {0};
  meth_meth_ast_7585_typeParametersNode->type = alloc_MethodType(1, argcv_meth_ast_7585_typeParametersNode);
  meth_meth_ast_7585_typeParametersNode->definitionModule = modulename;
  meth_meth_ast_7585_typeParametersNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1967
  setline(1967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7586 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7586 = alloc_userobj2(6,6, objclass7586);
  gc_frame_newslot(obj7586);
  if (objclass7586 == NULL) {
    glfree(obj7586->class->name);
    obj7586->class->name = "identifierNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj7586, self, 0);
  addmethodreal(obj7586,"outer", &reader_ast_outer_7587);
  Object oldself7586 = self;
  struct StackFrameObject *oldstackframe7586 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7586);
  gc_frame_newslot((Object)stackframe);
  self = obj7586;
  Object *oldselfslot7586 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7586 = (*(struct UserObject *)self).data[0], lowerouter7586 = thisouter7586;
  if (inheritingObject7586) {
    struct UserObject *inho7586 = (struct UserObject *)inheritingObject7586;
    while (inho7586->super != GraceDefaultObject) inho7586 = (struct UserObject *)inho7586->super;
    inho7586->super = obj7586;
    self = inheritingObject7586;
    *selfslot = self;
    lowerouter7586 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7586;
  }
// method "new(_,_)scope(_)"
  struct UserObject *uo7588 = (struct UserObject*)obj7586;
  uo7588->data[1] = emptyclosure;
  Method *meth_meth_ast_7588_new_40_2_41_scope_40_1_41_ = addmethod2pos(obj7586, "new(2)scope(1)", &meth_ast_7588_new_40_2_41_scope_40_1_41_, 1);
  int argcv_meth_ast_7588_new_40_2_41_scope_40_1_41_[] = {2, 1};
  meth_meth_ast_7588_new_40_2_41_scope_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_7588_new_40_2_41_scope_40_1_41_);
  meth_meth_ast_7588_new_40_2_41_scope_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7588_new_40_2_41_scope_40_1_41_->definitionLine = 1969;
  if (objclass7586 == NULL) {
    Method *reader7593 = addmethodrealflags(obj7586, "wildcardCount", &reader_ast_wildcardCount_7593, MFLAG_CONFIDENTIAL);
    Method *writer7593 = addmethodrealflags(obj7586, "wildcardCount:=(1)", &writer_ast_wildcardCount_7593, MFLAG_CONFIDENTIAL);
    reader7593->definitionModule = modulename;
    writer7593->definitionModule = modulename;
    reader7593->definitionLine = 1975;
    writer7593->definitionLine = 1975;
  }
  obj7586->flags |= OFLAG_MUTABLE;
  adddatum2(obj7586, alloc_Undefined(), 2);
// method "wildcard(_)"
  struct UserObject *uo7594 = (struct UserObject*)obj7586;
  uo7594->data[3] = emptyclosure;
  Method *meth_meth_ast_7594_wildcard_40_1_41_ = addmethod2pos(obj7586, "wildcard(1)", &meth_ast_7594_wildcard_40_1_41_, 3);
  int argcv_meth_ast_7594_wildcard_40_1_41_[] = {1};
  meth_meth_ast_7594_wildcard_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_7594_wildcard_40_1_41_);
  meth_meth_ast_7594_wildcard_40_1_41_->definitionModule = modulename;
  meth_meth_ast_7594_wildcard_40_1_41_->definitionLine = 1976;
// method "new(_,_)"
  block_savedest(obj7586);
  Object closure7626 = createclosure(1, "new(2)");
  setclosureframe(closure7626, stackframe);
  addtoclosure(closure7626, var_identifierNode);
  struct UserObject *uo7626 = (struct UserObject*)obj7586;
  uo7626->data[4] = (Object)closure7626;
  Method *meth_meth_ast_7626_new_40_2_41_ = addmethod2pos(obj7586, "new(2)", &meth_ast_7626_new_40_2_41_, 4);
  int argcv_meth_ast_7626_new_40_2_41_[] = {2};
  meth_meth_ast_7626_new_40_2_41_->type = alloc_MethodType(1, argcv_meth_ast_7626_new_40_2_41_);
  meth_meth_ast_7626_new_40_2_41_->definitionModule = modulename;
  meth_meth_ast_7626_new_40_2_41_->definitionLine = 1984;
  block_savedest(obj7586);
  Object closure8087 = createclosure(1, "new(2)$object(1)");
  setclosureframe(closure8087, stackframe);
  addtoclosure(closure8087, var_identifierNode);
  Method *meth_meth_ast_7626_new_40_2_41__object = addmethod2pos(obj7586, "new(2)$object(1)", &meth_ast_7626_new_40_2_41__object, 4);
  meth_meth_ast_7626_new_40_2_41__object->definitionModule = modulename;
  meth_meth_ast_7626_new_40_2_41__object->definitionLine = 1984;
  sourceObject = obj7586;
  sourceObject = obj7586;
// Begin line 1975
  setline(1975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num8088 = alloc_Float64(0);
// compiled num node returning num8088 (depth = 3)
  adddatum2(obj7586, num8088, 2);
  sourceObject = obj7586;
  sourceObject = obj7586;
  objclass7586 = obj7586->class;
  objclass7586->definitionModule = modulename;
  objclass7586->definitionLine = 1967;
  (*(struct UserObject *)self).data[0] = lowerouter7586;
  self = oldself7586;
  selfslot = oldselfslot7586;
  stackframe = oldstackframe7586;
// compiled object node returning obj7586 (depth = 2)
  *var_identifierNode = obj7586;
  if (obj7586 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "identifierNode"
  block_savedest(self);
  Object closure8089 = createclosure(1, "identifierNode");
  setclosureframe(closure8089, stackframe);
  addtoclosure(closure8089, var_identifierNode);
  struct UserObject *uo8089 = (struct UserObject*)self;
  uo8089->data[43] = (Object)closure8089;
  Method *meth_meth_ast_8089_identifierNode = addmethod2pos(self, "identifierNode", &meth_ast_8089_identifierNode, 43);
  int argcv_meth_ast_8089_identifierNode[] = {0};
  meth_meth_ast_8089_identifierNode->type = alloc_MethodType(1, argcv_meth_ast_8089_identifierNode);
  meth_meth_ast_8089_identifierNode->definitionModule = modulename;
  meth_meth_ast_8089_identifierNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2116
  setline(2116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe8090 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit8091 == NULL) {
    strlit8091 = alloc_String("Type");
    gc_root(strlit8091);
  }
// compiled string node returning strlit8091 (depth = 3)
  gc_frame_newslot(strlit8091);
// starting to compile identifier node (depth = 3)
  Object bool8092 = alloc_Boolean(0);
// compiled identifier node returning bool8092 (depth = 3)
  gc_frame_newslot(bool8092);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_identifierNode (depth = 3)
  params[0] = strlit8091;
  params[1] = bool8092;
  partcv[0] = 2;
  Object call8093 = callmethodflags(*var_identifierNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8090);
// compiled call node returning call8093 (depth = 2)
  *var_typeType = call8093;
  if (call8093 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "typeType"
  block_savedest(self);
  Object closure8094 = createclosure(1, "typeType");
  setclosureframe(closure8094, stackframe);
  addtoclosure(closure8094, var_typeType);
  struct UserObject *uo8094 = (struct UserObject*)self;
  uo8094->data[44] = (Object)closure8094;
  Method *meth_meth_ast_8094_typeType = addmethod2pos(self, "typeType", &meth_ast_8094_typeType, 44);
  int argcv_meth_ast_8094_typeType[] = {0};
  meth_meth_ast_8094_typeType->type = alloc_MethodType(1, argcv_meth_ast_8094_typeType);
  meth_meth_ast_8094_typeType->definitionModule = modulename;
  meth_meth_ast_8094_typeType->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2117
  setline(2117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe8095 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit8096 == NULL) {
    strlit8096 = alloc_String("Unknown");
    gc_root(strlit8096);
  }
// compiled string node returning strlit8096 (depth = 3)
  gc_frame_newslot(strlit8096);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeType (depth = 3)
  gc_frame_newslot(*var_typeType);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_identifierNode (depth = 3)
  params[0] = strlit8096;
  params[1] = *var_typeType;
  partcv[0] = 2;
  Object call8097 = callmethodflags(*var_identifierNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8095);
// compiled call node returning call8097 (depth = 2)
  *var_unknownType = call8097;
  if (call8097 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "unknownType"
  block_savedest(self);
  Object closure8098 = createclosure(1, "unknownType");
  setclosureframe(closure8098, stackframe);
  addtoclosure(closure8098, var_unknownType);
  struct UserObject *uo8098 = (struct UserObject*)self;
  uo8098->data[45] = (Object)closure8098;
  Method *meth_meth_ast_8098_unknownType = addmethod2pos(self, "unknownType", &meth_ast_8098_unknownType, 45);
  int argcv_meth_ast_8098_unknownType[] = {0};
  meth_meth_ast_8098_unknownType->type = alloc_MethodType(1, argcv_meth_ast_8098_unknownType);
  meth_meth_ast_8098_unknownType->definitionModule = modulename;
  meth_meth_ast_8098_unknownType->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2119
  setline(2119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject8099 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8099 = alloc_userobj2(3,4, objclass8099);
  gc_frame_newslot(obj8099);
  if (objclass8099 == NULL) {
    glfree(obj8099->class->name);
    obj8099->class->name = "stringNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj8099, self, 0);
  addmethodreal(obj8099,"outer", &reader_ast_outer_8100);
  Object oldself8099 = self;
  struct StackFrameObject *oldstackframe8099 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8099);
  gc_frame_newslot((Object)stackframe);
  self = obj8099;
  Object *oldselfslot8099 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8099 = (*(struct UserObject *)self).data[0], lowerouter8099 = thisouter8099;
  if (inheritingObject8099) {
    struct UserObject *inho8099 = (struct UserObject *)inheritingObject8099;
    while (inho8099->super != GraceDefaultObject) inho8099 = (struct UserObject *)inho8099->super;
    inho8099->super = obj8099;
    self = inheritingObject8099;
    *selfslot = self;
    lowerouter8099 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8099;
  }
// method "new(_)scope(_)"
  struct UserObject *uo8101 = (struct UserObject*)obj8099;
  uo8101->data[1] = emptyclosure;
  Method *meth_meth_ast_8101_new_40_1_41_scope_40_1_41_ = addmethod2pos(obj8099, "new(1)scope(1)", &meth_ast_8101_new_40_1_41_scope_40_1_41_, 1);
  int argcv_meth_ast_8101_new_40_1_41_scope_40_1_41_[] = {1, 1};
  meth_meth_ast_8101_new_40_1_41_scope_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_8101_new_40_1_41_scope_40_1_41_);
  meth_meth_ast_8101_new_40_1_41_scope_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8101_new_40_1_41_scope_40_1_41_->definitionLine = 2120;
// method "new(_)"
  block_savedest(obj8099);
  Object closure8106 = createclosure(1, "new(1)");
  setclosureframe(closure8106, stackframe);
  addtoclosure(closure8106, var_stringNode);
  struct UserObject *uo8106 = (struct UserObject*)obj8099;
  uo8106->data[2] = (Object)closure8106;
  Method *meth_meth_ast_8106_new_40_1_41_ = addmethod2pos(obj8099, "new(1)", &meth_ast_8106_new_40_1_41_, 2);
  int argcv_meth_ast_8106_new_40_1_41_[] = {1};
  meth_meth_ast_8106_new_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8106_new_40_1_41_);
  meth_meth_ast_8106_new_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8106_new_40_1_41_->definitionLine = 2126;
  block_savedest(obj8099);
  Object closure8202 = createclosure(1, "new(1)$object(1)");
  setclosureframe(closure8202, stackframe);
  addtoclosure(closure8202, var_stringNode);
  Method *meth_meth_ast_8106_new_40_1_41__object = addmethod2pos(obj8099, "new(1)$object(1)", &meth_ast_8106_new_40_1_41__object, 2);
  meth_meth_ast_8106_new_40_1_41__object->definitionModule = modulename;
  meth_meth_ast_8106_new_40_1_41__object->definitionLine = 2126;
  sourceObject = obj8099;
  sourceObject = obj8099;
  objclass8099 = obj8099->class;
  objclass8099->definitionModule = modulename;
  objclass8099->definitionLine = 2119;
  (*(struct UserObject *)self).data[0] = lowerouter8099;
  self = oldself8099;
  selfslot = oldselfslot8099;
  stackframe = oldstackframe8099;
// compiled object node returning obj8099 (depth = 2)
  *var_stringNode = obj8099;
  if (obj8099 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "stringNode"
  block_savedest(self);
  Object closure8203 = createclosure(1, "stringNode");
  setclosureframe(closure8203, stackframe);
  addtoclosure(closure8203, var_stringNode);
  struct UserObject *uo8203 = (struct UserObject*)self;
  uo8203->data[46] = (Object)closure8203;
  Method *meth_meth_ast_8203_stringNode = addmethod2pos(self, "stringNode", &meth_ast_8203_stringNode, 46);
  int argcv_meth_ast_8203_stringNode[] = {0};
  meth_meth_ast_8203_stringNode->type = alloc_MethodType(1, argcv_meth_ast_8203_stringNode);
  meth_meth_ast_8203_stringNode->definitionModule = modulename;
  meth_meth_ast_8203_stringNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2161
  setline(2161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject8204 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8204 = alloc_userobj2(2,4, objclass8204);
  gc_frame_newslot(obj8204);
  if (objclass8204 == NULL) {
    glfree(obj8204->class->name);
    obj8204->class->name = "numNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj8204, self, 0);
  addmethodreal(obj8204,"outer", &reader_ast_outer_8205);
  Object oldself8204 = self;
  struct StackFrameObject *oldstackframe8204 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8204);
  gc_frame_newslot((Object)stackframe);
  self = obj8204;
  Object *oldselfslot8204 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8204 = (*(struct UserObject *)self).data[0], lowerouter8204 = thisouter8204;
  if (inheritingObject8204) {
    struct UserObject *inho8204 = (struct UserObject *)inheritingObject8204;
    while (inho8204->super != GraceDefaultObject) inho8204 = (struct UserObject *)inho8204->super;
    inho8204->super = obj8204;
    self = inheritingObject8204;
    *selfslot = self;
    lowerouter8204 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8204;
  }
// method "new(_)"
  block_savedest(obj8204);
  Object closure8206 = createclosure(1, "new(1)");
  setclosureframe(closure8206, stackframe);
  addtoclosure(closure8206, var_numNode);
  struct UserObject *uo8206 = (struct UserObject*)obj8204;
  uo8206->data[1] = (Object)closure8206;
  Method *meth_meth_ast_8206_new_40_1_41_ = addmethod2pos(obj8204, "new(1)", &meth_ast_8206_new_40_1_41_, 1);
  int argcv_meth_ast_8206_new_40_1_41_[] = {1};
  meth_meth_ast_8206_new_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_8206_new_40_1_41_);
  meth_meth_ast_8206_new_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8206_new_40_1_41_->definitionLine = 2162;
  block_savedest(obj8204);
  Object closure8273 = createclosure(1, "new(1)$object(1)");
  setclosureframe(closure8273, stackframe);
  addtoclosure(closure8273, var_numNode);
  Method *meth_meth_ast_8206_new_40_1_41__object = addmethod2pos(obj8204, "new(1)$object(1)", &meth_ast_8206_new_40_1_41__object, 1);
  meth_meth_ast_8206_new_40_1_41__object->definitionModule = modulename;
  meth_meth_ast_8206_new_40_1_41__object->definitionLine = 2162;
  sourceObject = obj8204;
  objclass8204 = obj8204->class;
  objclass8204->definitionModule = modulename;
  objclass8204->definitionLine = 2161;
  (*(struct UserObject *)self).data[0] = lowerouter8204;
  self = oldself8204;
  selfslot = oldselfslot8204;
  stackframe = oldstackframe8204;
// compiled object node returning obj8204 (depth = 2)
  *var_numNode = obj8204;
  if (obj8204 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "numNode"
  block_savedest(self);
  Object closure8274 = createclosure(1, "numNode");
  setclosureframe(closure8274, stackframe);
  addtoclosure(closure8274, var_numNode);
  struct UserObject *uo8274 = (struct UserObject*)self;
  uo8274->data[47] = (Object)closure8274;
  Method *meth_meth_ast_8274_numNode = addmethod2pos(self, "numNode", &meth_ast_8274_numNode, 47);
  int argcv_meth_ast_8274_numNode[] = {0};
  meth_meth_ast_8274_numNode->type = alloc_MethodType(1, argcv_meth_ast_8274_numNode);
  meth_meth_ast_8274_numNode->definitionModule = modulename;
  meth_meth_ast_8274_numNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2189
  setline(2189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject8275 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8275 = alloc_userobj2(2,4, objclass8275);
  gc_frame_newslot(obj8275);
  if (objclass8275 == NULL) {
    glfree(obj8275->class->name);
    obj8275->class->name = "opNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj8275, self, 0);
  addmethodreal(obj8275,"outer", &reader_ast_outer_8276);
  Object oldself8275 = self;
  struct StackFrameObject *oldstackframe8275 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8275);
  gc_frame_newslot((Object)stackframe);
  self = obj8275;
  Object *oldselfslot8275 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8275 = (*(struct UserObject *)self).data[0], lowerouter8275 = thisouter8275;
  if (inheritingObject8275) {
    struct UserObject *inho8275 = (struct UserObject *)inheritingObject8275;
    while (inho8275->super != GraceDefaultObject) inho8275 = (struct UserObject *)inho8275->super;
    inho8275->super = obj8275;
    self = inheritingObject8275;
    *selfslot = self;
    lowerouter8275 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8275;
  }
// method "new(_,_,_)"
  block_savedest(obj8275);
  Object closure8277 = createclosure(4, "new(3)");
  setclosureframe(closure8277, stackframe);
  addtoclosure(closure8277, var_requestPart);
  addtoclosure(closure8277, var_identifierNode);
  addtoclosure(closure8277, var_nullNode);
  addtoclosure(closure8277, var_opNode);
  struct UserObject *uo8277 = (struct UserObject*)obj8275;
  uo8277->data[1] = (Object)closure8277;
  Method *meth_meth_ast_8277_new_40_3_41_ = addmethod2pos(obj8275, "new(3)", &meth_ast_8277_new_40_3_41_, 1);
  int argcv_meth_ast_8277_new_40_3_41_[] = {3};
  meth_meth_ast_8277_new_40_3_41_->type = alloc_MethodType(1, argcv_meth_ast_8277_new_40_3_41_);
  meth_meth_ast_8277_new_40_3_41_->definitionModule = modulename;
  meth_meth_ast_8277_new_40_3_41_->definitionLine = 2190;
  block_savedest(obj8275);
  Object closure8622 = createclosure(4, "new(3)$object(1)");
  setclosureframe(closure8622, stackframe);
  addtoclosure(closure8622, var_requestPart);
  addtoclosure(closure8622, var_identifierNode);
  addtoclosure(closure8622, var_nullNode);
  addtoclosure(closure8622, var_opNode);
  Method *meth_meth_ast_8277_new_40_3_41__object = addmethod2pos(obj8275, "new(3)$object(1)", &meth_ast_8277_new_40_3_41__object, 1);
  meth_meth_ast_8277_new_40_3_41__object->definitionModule = modulename;
  meth_meth_ast_8277_new_40_3_41__object->definitionLine = 2190;
  sourceObject = obj8275;
  objclass8275 = obj8275->class;
  objclass8275->definitionModule = modulename;
  objclass8275->definitionLine = 2189;
  (*(struct UserObject *)self).data[0] = lowerouter8275;
  self = oldself8275;
  selfslot = oldselfslot8275;
  stackframe = oldstackframe8275;
// compiled object node returning obj8275 (depth = 2)
  *var_opNode = obj8275;
  if (obj8275 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "opNode"
  block_savedest(self);
  Object closure8623 = createclosure(1, "opNode");
  setclosureframe(closure8623, stackframe);
  addtoclosure(closure8623, var_opNode);
  struct UserObject *uo8623 = (struct UserObject*)self;
  uo8623->data[48] = (Object)closure8623;
  Method *meth_meth_ast_8623_opNode = addmethod2pos(self, "opNode", &meth_ast_8623_opNode, 48);
  int argcv_meth_ast_8623_opNode[] = {0};
  meth_meth_ast_8623_opNode->type = alloc_MethodType(1, argcv_meth_ast_8623_opNode);
  meth_meth_ast_8623_opNode->definitionModule = modulename;
  meth_meth_ast_8623_opNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2281
  setline(2281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject8624 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8624 = alloc_userobj2(2,4, objclass8624);
  gc_frame_newslot(obj8624);
  if (objclass8624 == NULL) {
    glfree(obj8624->class->name);
    obj8624->class->name = "bindNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj8624, self, 0);
  addmethodreal(obj8624,"outer", &reader_ast_outer_8625);
  Object oldself8624 = self;
  struct StackFrameObject *oldstackframe8624 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8624);
  gc_frame_newslot((Object)stackframe);
  self = obj8624;
  Object *oldselfslot8624 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8624 = (*(struct UserObject *)self).data[0], lowerouter8624 = thisouter8624;
  if (inheritingObject8624) {
    struct UserObject *inho8624 = (struct UserObject *)inheritingObject8624;
    while (inho8624->super != GraceDefaultObject) inho8624 = (struct UserObject *)inho8624->super;
    inho8624->super = obj8624;
    self = inheritingObject8624;
    *selfslot = self;
    lowerouter8624 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8624;
  }
// method "new(_,_)"
  block_savedest(obj8624);
  Object closure8626 = createclosure(1, "new(2)");
  setclosureframe(closure8626, stackframe);
  addtoclosure(closure8626, var_bindNode);
  struct UserObject *uo8626 = (struct UserObject*)obj8624;
  uo8626->data[1] = (Object)closure8626;
  Method *meth_meth_ast_8626_new_40_2_41_ = addmethod2pos(obj8624, "new(2)", &meth_ast_8626_new_40_2_41_, 1);
  int argcv_meth_ast_8626_new_40_2_41_[] = {2};
  meth_meth_ast_8626_new_40_2_41_->type = alloc_MethodType(1, argcv_meth_ast_8626_new_40_2_41_);
  meth_meth_ast_8626_new_40_2_41_->definitionModule = modulename;
  meth_meth_ast_8626_new_40_2_41_->definitionLine = 2282;
  block_savedest(obj8624);
  Object closure8790 = createclosure(1, "new(2)$object(1)");
  setclosureframe(closure8790, stackframe);
  addtoclosure(closure8790, var_bindNode);
  Method *meth_meth_ast_8626_new_40_2_41__object = addmethod2pos(obj8624, "new(2)$object(1)", &meth_ast_8626_new_40_2_41__object, 1);
  meth_meth_ast_8626_new_40_2_41__object->definitionModule = modulename;
  meth_meth_ast_8626_new_40_2_41__object->definitionLine = 2282;
  sourceObject = obj8624;
  objclass8624 = obj8624->class;
  objclass8624->definitionModule = modulename;
  objclass8624->definitionLine = 2281;
  (*(struct UserObject *)self).data[0] = lowerouter8624;
  self = oldself8624;
  selfslot = oldselfslot8624;
  stackframe = oldstackframe8624;
// compiled object node returning obj8624 (depth = 2)
  *var_bindNode = obj8624;
  if (obj8624 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "bindNode"
  block_savedest(self);
  Object closure8791 = createclosure(1, "bindNode");
  setclosureframe(closure8791, stackframe);
  addtoclosure(closure8791, var_bindNode);
  struct UserObject *uo8791 = (struct UserObject*)self;
  uo8791->data[49] = (Object)closure8791;
  Method *meth_meth_ast_8791_bindNode = addmethod2pos(self, "bindNode", &meth_ast_8791_bindNode, 49);
  int argcv_meth_ast_8791_bindNode[] = {0};
  meth_meth_ast_8791_bindNode->type = alloc_MethodType(1, argcv_meth_ast_8791_bindNode);
  meth_meth_ast_8791_bindNode->definitionModule = modulename;
  meth_meth_ast_8791_bindNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2328
  setline(2328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject8792 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8792 = alloc_userobj2(3,4, objclass8792);
  gc_frame_newslot(obj8792);
  if (objclass8792 == NULL) {
    glfree(obj8792->class->name);
    obj8792->class->name = "defDecNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj8792, self, 0);
  addmethodreal(obj8792,"outer", &reader_ast_outer_8793);
  Object oldself8792 = self;
  struct StackFrameObject *oldstackframe8792 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8792);
  gc_frame_newslot((Object)stackframe);
  self = obj8792;
  Object *oldselfslot8792 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8792 = (*(struct UserObject *)self).data[0], lowerouter8792 = thisouter8792;
  if (inheritingObject8792) {
    struct UserObject *inho8792 = (struct UserObject *)inheritingObject8792;
    while (inho8792->super != GraceDefaultObject) inho8792 = (struct UserObject *)inho8792->super;
    inho8792->super = obj8792;
    self = inheritingObject8792;
    *selfslot = self;
    lowerouter8792 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8792;
  }
// method "new(_,_,_)scope(_)"
  struct UserObject *uo8794 = (struct UserObject*)obj8792;
  uo8794->data[1] = emptyclosure;
  Method *meth_meth_ast_8794_new_40_3_41_scope_40_1_41_ = addmethod2pos(obj8792, "new(3)scope(1)", &meth_ast_8794_new_40_3_41_scope_40_1_41_, 1);
  int argcv_meth_ast_8794_new_40_3_41_scope_40_1_41_[] = {3, 1};
  meth_meth_ast_8794_new_40_3_41_scope_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_8794_new_40_3_41_scope_40_1_41_);
  meth_meth_ast_8794_new_40_3_41_scope_40_1_41_->definitionModule = modulename;
  meth_meth_ast_8794_new_40_3_41_scope_40_1_41_->definitionLine = 2329;
// method "new(_,_,_)"
  block_savedest(obj8792);
  Object closure8799 = createclosure(2, "new(3)");
  setclosureframe(closure8799, stackframe);
  addtoclosure(closure8799, var_k);
  addtoclosure(closure8799, var_defDecNode);
  struct UserObject *uo8799 = (struct UserObject*)obj8792;
  uo8799->data[2] = (Object)closure8799;
  Method *meth_meth_ast_8799_new_40_3_41_ = addmethod2pos(obj8792, "new(3)", &meth_ast_8799_new_40_3_41_, 2);
  int argcv_meth_ast_8799_new_40_3_41_[] = {3};
  meth_meth_ast_8799_new_40_3_41_->type = alloc_MethodType(1, argcv_meth_ast_8799_new_40_3_41_);
  meth_meth_ast_8799_new_40_3_41_->definitionModule = modulename;
  meth_meth_ast_8799_new_40_3_41_->definitionLine = 2335;
  block_savedest(obj8792);
  Object closure9223 = createclosure(2, "new(3)$object(1)");
  setclosureframe(closure9223, stackframe);
  addtoclosure(closure9223, var_k);
  addtoclosure(closure9223, var_defDecNode);
  Method *meth_meth_ast_8799_new_40_3_41__object = addmethod2pos(obj8792, "new(3)$object(1)", &meth_ast_8799_new_40_3_41__object, 2);
  meth_meth_ast_8799_new_40_3_41__object->definitionModule = modulename;
  meth_meth_ast_8799_new_40_3_41__object->definitionLine = 2335;
  sourceObject = obj8792;
  sourceObject = obj8792;
  objclass8792 = obj8792->class;
  objclass8792->definitionModule = modulename;
  objclass8792->definitionLine = 2328;
  (*(struct UserObject *)self).data[0] = lowerouter8792;
  self = oldself8792;
  selfslot = oldselfslot8792;
  stackframe = oldstackframe8792;
// compiled object node returning obj8792 (depth = 2)
  *var_defDecNode = obj8792;
  if (obj8792 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "defDecNode"
  block_savedest(self);
  Object closure9224 = createclosure(1, "defDecNode");
  setclosureframe(closure9224, stackframe);
  addtoclosure(closure9224, var_defDecNode);
  struct UserObject *uo9224 = (struct UserObject*)self;
  uo9224->data[50] = (Object)closure9224;
  Method *meth_meth_ast_9224_defDecNode = addmethod2pos(self, "defDecNode", &meth_ast_9224_defDecNode, 50);
  int argcv_meth_ast_9224_defDecNode[] = {0};
  meth_meth_ast_9224_defDecNode->type = alloc_MethodType(1, argcv_meth_ast_9224_defDecNode);
  meth_meth_ast_9224_defDecNode->definitionModule = modulename;
  meth_meth_ast_9224_defDecNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2441
  setline(2441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9225 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9225 = alloc_userobj2(2,4, objclass9225);
  gc_frame_newslot(obj9225);
  if (objclass9225 == NULL) {
    glfree(obj9225->class->name);
    obj9225->class->name = "varDecNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj9225, self, 0);
  addmethodreal(obj9225,"outer", &reader_ast_outer_9226);
  Object oldself9225 = self;
  struct StackFrameObject *oldstackframe9225 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9225);
  gc_frame_newslot((Object)stackframe);
  self = obj9225;
  Object *oldselfslot9225 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9225 = (*(struct UserObject *)self).data[0], lowerouter9225 = thisouter9225;
  if (inheritingObject9225) {
    struct UserObject *inho9225 = (struct UserObject *)inheritingObject9225;
    while (inho9225->super != GraceDefaultObject) inho9225 = (struct UserObject *)inho9225->super;
    inho9225->super = obj9225;
    self = inheritingObject9225;
    *selfslot = self;
    lowerouter9225 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9225;
  }
// method "new(_,_,_)"
  block_savedest(obj9225);
  Object closure9227 = createclosure(2, "new(3)");
  setclosureframe(closure9227, stackframe);
  addtoclosure(closure9227, var_k);
  addtoclosure(closure9227, var_varDecNode);
  struct UserObject *uo9227 = (struct UserObject*)obj9225;
  uo9227->data[1] = (Object)closure9227;
  Method *meth_meth_ast_9227_new_40_3_41_ = addmethod2pos(obj9225, "new(3)", &meth_ast_9227_new_40_3_41_, 1);
  int argcv_meth_ast_9227_new_40_3_41_[] = {3};
  meth_meth_ast_9227_new_40_3_41_->type = alloc_MethodType(1, argcv_meth_ast_9227_new_40_3_41_);
  meth_meth_ast_9227_new_40_3_41_->definitionModule = modulename;
  meth_meth_ast_9227_new_40_3_41_->definitionLine = 2442;
  block_savedest(obj9225);
  Object closure9674 = createclosure(2, "new(3)$object(1)");
  setclosureframe(closure9674, stackframe);
  addtoclosure(closure9674, var_k);
  addtoclosure(closure9674, var_varDecNode);
  Method *meth_meth_ast_9227_new_40_3_41__object = addmethod2pos(obj9225, "new(3)$object(1)", &meth_ast_9227_new_40_3_41__object, 1);
  meth_meth_ast_9227_new_40_3_41__object->definitionModule = modulename;
  meth_meth_ast_9227_new_40_3_41__object->definitionLine = 2442;
  sourceObject = obj9225;
  objclass9225 = obj9225->class;
  objclass9225->definitionModule = modulename;
  objclass9225->definitionLine = 2441;
  (*(struct UserObject *)self).data[0] = lowerouter9225;
  self = oldself9225;
  selfslot = oldselfslot9225;
  stackframe = oldstackframe9225;
// compiled object node returning obj9225 (depth = 2)
  *var_varDecNode = obj9225;
  if (obj9225 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "varDecNode"
  block_savedest(self);
  Object closure9675 = createclosure(1, "varDecNode");
  setclosureframe(closure9675, stackframe);
  addtoclosure(closure9675, var_varDecNode);
  struct UserObject *uo9675 = (struct UserObject*)self;
  uo9675->data[51] = (Object)closure9675;
  Method *meth_meth_ast_9675_varDecNode = addmethod2pos(self, "varDecNode", &meth_ast_9675_varDecNode, 51);
  int argcv_meth_ast_9675_varDecNode[] = {0};
  meth_meth_ast_9675_varDecNode->type = alloc_MethodType(1, argcv_meth_ast_9675_varDecNode);
  meth_meth_ast_9675_varDecNode->definitionModule = modulename;
  meth_meth_ast_9675_varDecNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2554
  setline(2554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9676 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9676 = alloc_userobj2(2,4, objclass9676);
  gc_frame_newslot(obj9676);
  if (objclass9676 == NULL) {
    glfree(obj9676->class->name);
    obj9676->class->name = "importNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj9676, self, 0);
  addmethodreal(obj9676,"outer", &reader_ast_outer_9677);
  Object oldself9676 = self;
  struct StackFrameObject *oldstackframe9676 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9676);
  gc_frame_newslot((Object)stackframe);
  self = obj9676;
  Object *oldselfslot9676 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9676 = (*(struct UserObject *)self).data[0], lowerouter9676 = thisouter9676;
  if (inheritingObject9676) {
    struct UserObject *inho9676 = (struct UserObject *)inheritingObject9676;
    while (inho9676->super != GraceDefaultObject) inho9676 = (struct UserObject *)inho9676->super;
    inho9676->super = obj9676;
    self = inheritingObject9676;
    *selfslot = self;
    lowerouter9676 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9676;
  }
// method "new(_,_,_)"
  block_savedest(obj9676);
  Object closure9678 = createclosure(3, "new(3)");
  setclosureframe(closure9678, stackframe);
  addtoclosure(closure9678, var_k);
  addtoclosure(closure9678, var_nullNode);
  addtoclosure(closure9678, var_importNode);
  struct UserObject *uo9678 = (struct UserObject*)obj9676;
  uo9678->data[1] = (Object)closure9678;
  Method *meth_meth_ast_9678_new_40_3_41_ = addmethod2pos(obj9676, "new(3)", &meth_ast_9678_new_40_3_41_, 1);
  int argcv_meth_ast_9678_new_40_3_41_[] = {3};
  meth_meth_ast_9678_new_40_3_41_->type = alloc_MethodType(1, argcv_meth_ast_9678_new_40_3_41_);
  meth_meth_ast_9678_new_40_3_41_->definitionModule = modulename;
  meth_meth_ast_9678_new_40_3_41_->definitionLine = 2555;
  block_savedest(obj9676);
  Object closure9932 = createclosure(3, "new(3)$object(1)");
  setclosureframe(closure9932, stackframe);
  addtoclosure(closure9932, var_k);
  addtoclosure(closure9932, var_nullNode);
  addtoclosure(closure9932, var_importNode);
  Method *meth_meth_ast_9678_new_40_3_41__object = addmethod2pos(obj9676, "new(3)$object(1)", &meth_ast_9678_new_40_3_41__object, 1);
  meth_meth_ast_9678_new_40_3_41__object->definitionModule = modulename;
  meth_meth_ast_9678_new_40_3_41__object->definitionLine = 2555;
  sourceObject = obj9676;
  objclass9676 = obj9676->class;
  objclass9676->definitionModule = modulename;
  objclass9676->definitionLine = 2554;
  (*(struct UserObject *)self).data[0] = lowerouter9676;
  self = oldself9676;
  selfslot = oldselfslot9676;
  stackframe = oldstackframe9676;
// compiled object node returning obj9676 (depth = 2)
  *var_importNode = obj9676;
  if (obj9676 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "importNode"
  block_savedest(self);
  Object closure9933 = createclosure(1, "importNode");
  setclosureframe(closure9933, stackframe);
  addtoclosure(closure9933, var_importNode);
  struct UserObject *uo9933 = (struct UserObject*)self;
  uo9933->data[52] = (Object)closure9933;
  Method *meth_meth_ast_9933_importNode = addmethod2pos(self, "importNode", &meth_ast_9933_importNode, 52);
  int argcv_meth_ast_9933_importNode[] = {0};
  meth_meth_ast_9933_importNode->type = alloc_MethodType(1, argcv_meth_ast_9933_importNode);
  meth_meth_ast_9933_importNode->definitionModule = modulename;
  meth_meth_ast_9933_importNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2629
  setline(2629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9934 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9934 = alloc_userobj2(3,4, objclass9934);
  gc_frame_newslot(obj9934);
  if (objclass9934 == NULL) {
    glfree(obj9934->class->name);
    obj9934->class->name = "dialectNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj9934, self, 0);
  addmethodreal(obj9934,"outer", &reader_ast_outer_9935);
  Object oldself9934 = self;
  struct StackFrameObject *oldstackframe9934 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9934);
  gc_frame_newslot((Object)stackframe);
  self = obj9934;
  Object *oldselfslot9934 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9934 = (*(struct UserObject *)self).data[0], lowerouter9934 = thisouter9934;
  if (inheritingObject9934) {
    struct UserObject *inho9934 = (struct UserObject *)inheritingObject9934;
    while (inho9934->super != GraceDefaultObject) inho9934 = (struct UserObject *)inho9934->super;
    inho9934->super = obj9934;
    self = inheritingObject9934;
    *selfslot = self;
    lowerouter9934 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9934;
  }
// method "fromToken(_)"
  struct UserObject *uo9936 = (struct UserObject*)obj9934;
  uo9936->data[1] = emptyclosure;
  Method *meth_meth_ast_9936_fromToken_40_1_41_ = addmethod2pos(obj9934, "fromToken(1)", &meth_ast_9936_fromToken_40_1_41_, 1);
  int argcv_meth_ast_9936_fromToken_40_1_41_[] = {1};
  meth_meth_ast_9936_fromToken_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9936_fromToken_40_1_41_);
  meth_meth_ast_9936_fromToken_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9936_fromToken_40_1_41_->definitionLine = 2630;
// method "new(_)"
  block_savedest(obj9934);
  Object closure9958 = createclosure(2, "new(1)");
  setclosureframe(closure9958, stackframe);
  addtoclosure(closure9958, var_dialectNode);
  addtoclosure(closure9958, var_noPosition);
  struct UserObject *uo9958 = (struct UserObject*)obj9934;
  uo9958->data[2] = (Object)closure9958;
  Method *meth_meth_ast_9958_new_40_1_41_ = addmethod2pos(obj9934, "new(1)", &meth_ast_9958_new_40_1_41_, 2);
  int argcv_meth_ast_9958_new_40_1_41_[] = {1};
  meth_meth_ast_9958_new_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_9958_new_40_1_41_);
  meth_meth_ast_9958_new_40_1_41_->definitionModule = modulename;
  meth_meth_ast_9958_new_40_1_41_->definitionLine = 2635;
  block_savedest(obj9934);
  Object closure10065 = createclosure(2, "new(1)$object(1)");
  setclosureframe(closure10065, stackframe);
  addtoclosure(closure10065, var_dialectNode);
  addtoclosure(closure10065, var_noPosition);
  Method *meth_meth_ast_9958_new_40_1_41__object = addmethod2pos(obj9934, "new(1)$object(1)", &meth_ast_9958_new_40_1_41__object, 2);
  meth_meth_ast_9958_new_40_1_41__object->definitionModule = modulename;
  meth_meth_ast_9958_new_40_1_41__object->definitionLine = 2635;
  sourceObject = obj9934;
  sourceObject = obj9934;
  objclass9934 = obj9934->class;
  objclass9934->definitionModule = modulename;
  objclass9934->definitionLine = 2629;
  (*(struct UserObject *)self).data[0] = lowerouter9934;
  self = oldself9934;
  selfslot = oldselfslot9934;
  stackframe = oldstackframe9934;
// compiled object node returning obj9934 (depth = 2)
  *var_dialectNode = obj9934;
  if (obj9934 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "dialectNode"
  block_savedest(self);
  Object closure10066 = createclosure(1, "dialectNode");
  setclosureframe(closure10066, stackframe);
  addtoclosure(closure10066, var_dialectNode);
  struct UserObject *uo10066 = (struct UserObject*)self;
  uo10066->data[53] = (Object)closure10066;
  Method *meth_meth_ast_10066_dialectNode = addmethod2pos(self, "dialectNode", &meth_ast_10066_dialectNode, 53);
  int argcv_meth_ast_10066_dialectNode[] = {0};
  meth_meth_ast_10066_dialectNode->type = alloc_MethodType(1, argcv_meth_ast_10066_dialectNode);
  meth_meth_ast_10066_dialectNode->definitionModule = modulename;
  meth_meth_ast_10066_dialectNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2684
  setline(2684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject10067 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10067 = alloc_userobj2(2,4, objclass10067);
  gc_frame_newslot(obj10067);
  if (objclass10067 == NULL) {
    glfree(obj10067->class->name);
    obj10067->class->name = "returnNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj10067, self, 0);
  addmethodreal(obj10067,"outer", &reader_ast_outer_10068);
  Object oldself10067 = self;
  struct StackFrameObject *oldstackframe10067 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10067);
  gc_frame_newslot((Object)stackframe);
  self = obj10067;
  Object *oldselfslot10067 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10067 = (*(struct UserObject *)self).data[0], lowerouter10067 = thisouter10067;
  if (inheritingObject10067) {
    struct UserObject *inho10067 = (struct UserObject *)inheritingObject10067;
    while (inho10067->super != GraceDefaultObject) inho10067 = (struct UserObject *)inho10067->super;
    inho10067->super = obj10067;
    self = inheritingObject10067;
    *selfslot = self;
    lowerouter10067 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10067;
  }
// method "new(_)"
  block_savedest(obj10067);
  Object closure10069 = createclosure(2, "new(1)");
  setclosureframe(closure10069, stackframe);
  addtoclosure(closure10069, var_noPosition);
  addtoclosure(closure10069, var_returnNode);
  struct UserObject *uo10069 = (struct UserObject*)obj10067;
  uo10069->data[1] = (Object)closure10069;
  Method *meth_meth_ast_10069_new_40_1_41_ = addmethod2pos(obj10067, "new(1)", &meth_ast_10069_new_40_1_41_, 1);
  int argcv_meth_ast_10069_new_40_1_41_[] = {1};
  meth_meth_ast_10069_new_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10069_new_40_1_41_);
  meth_meth_ast_10069_new_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10069_new_40_1_41_->definitionLine = 2685;
  block_savedest(obj10067);
  Object closure10225 = createclosure(2, "new(1)$object(1)");
  setclosureframe(closure10225, stackframe);
  addtoclosure(closure10225, var_noPosition);
  addtoclosure(closure10225, var_returnNode);
  Method *meth_meth_ast_10069_new_40_1_41__object = addmethod2pos(obj10067, "new(1)$object(1)", &meth_ast_10069_new_40_1_41__object, 1);
  meth_meth_ast_10069_new_40_1_41__object->definitionModule = modulename;
  meth_meth_ast_10069_new_40_1_41__object->definitionLine = 2685;
  sourceObject = obj10067;
  objclass10067 = obj10067->class;
  objclass10067->definitionModule = modulename;
  objclass10067->definitionLine = 2684;
  (*(struct UserObject *)self).data[0] = lowerouter10067;
  self = oldself10067;
  selfslot = oldselfslot10067;
  stackframe = oldstackframe10067;
// compiled object node returning obj10067 (depth = 2)
  *var_returnNode = obj10067;
  if (obj10067 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "returnNode"
  block_savedest(self);
  Object closure10226 = createclosure(1, "returnNode");
  setclosureframe(closure10226, stackframe);
  addtoclosure(closure10226, var_returnNode);
  struct UserObject *uo10226 = (struct UserObject*)self;
  uo10226->data[54] = (Object)closure10226;
  Method *meth_meth_ast_10226_returnNode = addmethod2pos(self, "returnNode", &meth_ast_10226_returnNode, 54);
  int argcv_meth_ast_10226_returnNode[] = {0};
  meth_meth_ast_10226_returnNode->type = alloc_MethodType(1, argcv_meth_ast_10226_returnNode);
  meth_meth_ast_10226_returnNode->definitionModule = modulename;
  meth_meth_ast_10226_returnNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2737
  setline(2737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject10227 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10227 = alloc_userobj2(3,4, objclass10227);
  gc_frame_newslot(obj10227);
  if (objclass10227 == NULL) {
    glfree(obj10227->class->name);
    obj10227->class->name = "inheritNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj10227, self, 0);
  addmethodreal(obj10227,"outer", &reader_ast_outer_10228);
  Object oldself10227 = self;
  struct StackFrameObject *oldstackframe10227 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10227);
  gc_frame_newslot((Object)stackframe);
  self = obj10227;
  Object *oldselfslot10227 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10227 = (*(struct UserObject *)self).data[0], lowerouter10227 = thisouter10227;
  if (inheritingObject10227) {
    struct UserObject *inho10227 = (struct UserObject *)inheritingObject10227;
    while (inho10227->super != GraceDefaultObject) inho10227 = (struct UserObject *)inho10227->super;
    inho10227->super = obj10227;
    self = inheritingObject10227;
    *selfslot = self;
    lowerouter10227 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10227;
  }
// method "new(_)scope(_)"
  struct UserObject *uo10229 = (struct UserObject*)obj10227;
  uo10229->data[1] = emptyclosure;
  Method *meth_meth_ast_10229_new_40_1_41_scope_40_1_41_ = addmethod2pos(obj10227, "new(1)scope(1)", &meth_ast_10229_new_40_1_41_scope_40_1_41_, 1);
  int argcv_meth_ast_10229_new_40_1_41_scope_40_1_41_[] = {1, 1};
  meth_meth_ast_10229_new_40_1_41_scope_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_10229_new_40_1_41_scope_40_1_41_);
  meth_meth_ast_10229_new_40_1_41_scope_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10229_new_40_1_41_scope_40_1_41_->definitionLine = 2738;
// method "new(_)"
  block_savedest(obj10227);
  Object closure10234 = createclosure(3, "new(1)");
  setclosureframe(closure10234, stackframe);
  addtoclosure(closure10234, var_k);
  addtoclosure(closure10234, var_nullNode);
  addtoclosure(closure10234, var_inheritNode);
  struct UserObject *uo10234 = (struct UserObject*)obj10227;
  uo10234->data[2] = (Object)closure10234;
  Method *meth_meth_ast_10234_new_40_1_41_ = addmethod2pos(obj10227, "new(1)", &meth_ast_10234_new_40_1_41_, 2);
  int argcv_meth_ast_10234_new_40_1_41_[] = {1};
  meth_meth_ast_10234_new_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10234_new_40_1_41_);
  meth_meth_ast_10234_new_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10234_new_40_1_41_->definitionLine = 2743;
  block_savedest(obj10227);
  Object closure10606 = createclosure(3, "new(1)$object(1)");
  setclosureframe(closure10606, stackframe);
  addtoclosure(closure10606, var_k);
  addtoclosure(closure10606, var_nullNode);
  addtoclosure(closure10606, var_inheritNode);
  Method *meth_meth_ast_10234_new_40_1_41__object = addmethod2pos(obj10227, "new(1)$object(1)", &meth_ast_10234_new_40_1_41__object, 2);
  meth_meth_ast_10234_new_40_1_41__object->definitionModule = modulename;
  meth_meth_ast_10234_new_40_1_41__object->definitionLine = 2743;
  sourceObject = obj10227;
  sourceObject = obj10227;
  objclass10227 = obj10227->class;
  objclass10227->definitionModule = modulename;
  objclass10227->definitionLine = 2737;
  (*(struct UserObject *)self).data[0] = lowerouter10227;
  self = oldself10227;
  selfslot = oldselfslot10227;
  stackframe = oldstackframe10227;
// compiled object node returning obj10227 (depth = 2)
  *var_inheritNode = obj10227;
  if (obj10227 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "inheritNode"
  block_savedest(self);
  Object closure10607 = createclosure(1, "inheritNode");
  setclosureframe(closure10607, stackframe);
  addtoclosure(closure10607, var_inheritNode);
  struct UserObject *uo10607 = (struct UserObject*)self;
  uo10607->data[55] = (Object)closure10607;
  Method *meth_meth_ast_10607_inheritNode = addmethod2pos(self, "inheritNode", &meth_ast_10607_inheritNode, 55);
  int argcv_meth_ast_10607_inheritNode[] = {0};
  meth_meth_ast_10607_inheritNode->type = alloc_MethodType(1, argcv_meth_ast_10607_inheritNode);
  meth_meth_ast_10607_inheritNode->definitionModule = modulename;
  meth_meth_ast_10607_inheritNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2838
  setline(2838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl AliasPair
// starting to compile typeliteral node (depth = 2)
//   Type literal 
  Object type10609 = alloc_Type("AliasPair", 2);
  add_Method((ClassData)type10609, "newName", NULL);
  add_Method((ClassData)type10609, "oldName", NULL);
// compiled typeliteral node returning type10609 (depth = 2)
  *var_AliasPair = type10609;
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "AliasPair"
  block_savedest(self);
  Object closure10610 = createclosure(1, "AliasPair");
  setclosureframe(closure10610, stackframe);
  addtoclosure(closure10610, var_AliasPair);
  struct UserObject *uo10610 = (struct UserObject*)self;
  uo10610->data[56] = (Object)closure10610;
  Method *meth_meth_ast_10610_AliasPair = addmethod2pos(self, "AliasPair", &meth_ast_10610_AliasPair, 56);
  int argcv_meth_ast_10610_AliasPair[] = {0};
  meth_meth_ast_10610_AliasPair->type = alloc_MethodType(1, argcv_meth_ast_10610_AliasPair);
  meth_meth_ast_10610_AliasPair->definitionModule = modulename;
  meth_meth_ast_10610_AliasPair->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 2859
  setline(2859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject10611 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10611 = alloc_userobj2(6,7, objclass10611);
  gc_frame_newslot(obj10611);
  if (objclass10611 == NULL) {
    glfree(obj10611->class->name);
    obj10611->class->name = "signaturePart";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj10611, self, 0);
  addmethodreal(obj10611,"outer", &reader_ast_outer_10612);
  Object oldself10611 = self;
  struct StackFrameObject *oldstackframe10611 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10611);
  gc_frame_newslot((Object)stackframe);
  self = obj10611;
  Object *oldselfslot10611 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10611 = (*(struct UserObject *)self).data[0], lowerouter10611 = thisouter10611;
  if (inheritingObject10611) {
    struct UserObject *inho10611 = (struct UserObject *)inheritingObject10611;
    while (inho10611->super != GraceDefaultObject) inho10611 = (struct UserObject *)inho10611->super;
    inho10611->super = obj10611;
    self = inheritingObject10611;
    *selfslot = self;
    lowerouter10611 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10611;
  }
// method "new"
  struct UserObject *uo10613 = (struct UserObject*)obj10611;
  uo10613->data[1] = emptyclosure;
  Method *meth_meth_ast_10613_new = addmethod2pos(obj10611, "new", &meth_ast_10613_new, 1);
  int argcv_meth_ast_10613_new[] = {0};
  meth_meth_ast_10613_new->type = alloc_MethodType(1, argcv_meth_ast_10613_new);
  meth_meth_ast_10613_new->definitionModule = modulename;
  meth_meth_ast_10613_new->definitionLine = 2860;
// method "partName(_)scope(_)"
  struct UserObject *uo10618 = (struct UserObject*)obj10611;
  uo10618->data[2] = emptyclosure;
  Method *meth_meth_ast_10618_partName_40_1_41_scope_40_1_41_ = addmethod2pos(obj10611, "partName(1)scope(1)", &meth_ast_10618_partName_40_1_41_scope_40_1_41_, 2);
  int argcv_meth_ast_10618_partName_40_1_41_scope_40_1_41_[] = {1, 1};
  meth_meth_ast_10618_partName_40_1_41_scope_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_10618_partName_40_1_41_scope_40_1_41_);
  meth_meth_ast_10618_partName_40_1_41_scope_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10618_partName_40_1_41_scope_40_1_41_->definitionLine = 2863;
// method "partName(_)params(_)scope(_)"
  struct UserObject *uo10624 = (struct UserObject*)obj10611;
  uo10624->data[3] = emptyclosure;
  Method *meth_meth_ast_10624_partName_40_1_41_params_40_1_41_scope_40_1_41_ = addmethod2pos(obj10611, "partName(1)params(1)scope(1)", &meth_ast_10624_partName_40_1_41_params_40_1_41_scope_40_1_41_, 3);
  int argcv_meth_ast_10624_partName_40_1_41_params_40_1_41_scope_40_1_41_[] = {1, 1, 1};
  meth_meth_ast_10624_partName_40_1_41_params_40_1_41_scope_40_1_41_->type = alloc_MethodType(3, argcv_meth_ast_10624_partName_40_1_41_params_40_1_41_scope_40_1_41_);
  meth_meth_ast_10624_partName_40_1_41_params_40_1_41_scope_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10624_partName_40_1_41_params_40_1_41_scope_40_1_41_->definitionLine = 2868;
// method "partName(_)"
  struct UserObject *uo10629 = (struct UserObject*)obj10611;
  uo10629->data[4] = emptyclosure;
  Method *meth_meth_ast_10629_partName_40_1_41_ = addmethod2pos(obj10611, "partName(1)", &meth_ast_10629_partName_40_1_41_, 4);
  int argcv_meth_ast_10629_partName_40_1_41_[] = {1};
  meth_meth_ast_10629_partName_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10629_partName_40_1_41_);
  meth_meth_ast_10629_partName_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10629_partName_40_1_41_->definitionLine = 2873;
// method "partName(_)params(_)"
  block_savedest(obj10611);
  Object closure10633 = createclosure(2, "partName(1)params(1)");
  setclosureframe(closure10633, stackframe);
  addtoclosure(closure10633, var_k);
  addtoclosure(closure10633, var_signaturePart);
  struct UserObject *uo10633 = (struct UserObject*)obj10611;
  uo10633->data[5] = (Object)closure10633;
  Method *meth_meth_ast_10633_partName_40_1_41_params_40_1_41_ = addmethod2pos(obj10611, "partName(1)params(1)", &meth_ast_10633_partName_40_1_41_params_40_1_41_, 5);
  int argcv_meth_ast_10633_partName_40_1_41_params_40_1_41_[] = {1, 1};
  meth_meth_ast_10633_partName_40_1_41_params_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_10633_partName_40_1_41_params_40_1_41_);
  meth_meth_ast_10633_partName_40_1_41_params_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10633_partName_40_1_41_params_40_1_41_->definitionLine = 2876;
  block_savedest(obj10611);
  Object closure10974 = createclosure(2, "partName(1)params(1)$object(1)");
  setclosureframe(closure10974, stackframe);
  addtoclosure(closure10974, var_k);
  addtoclosure(closure10974, var_signaturePart);
  Method *meth_meth_ast_10633_partName_40_1_41_params_40_1_41__object = addmethod2pos(obj10611, "partName(1)params(1)$object(1)", &meth_ast_10633_partName_40_1_41_params_40_1_41__object, 5);
  meth_meth_ast_10633_partName_40_1_41_params_40_1_41__object->definitionModule = modulename;
  meth_meth_ast_10633_partName_40_1_41_params_40_1_41__object->definitionLine = 2876;
  sourceObject = obj10611;
  sourceObject = obj10611;
  sourceObject = obj10611;
  sourceObject = obj10611;
  sourceObject = obj10611;
  objclass10611 = obj10611->class;
  objclass10611->definitionModule = modulename;
  objclass10611->definitionLine = 2859;
  (*(struct UserObject *)self).data[0] = lowerouter10611;
  self = oldself10611;
  selfslot = oldselfslot10611;
  stackframe = oldstackframe10611;
// compiled object node returning obj10611 (depth = 2)
  *var_signaturePart = obj10611;
  if (obj10611 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "signaturePart"
  block_savedest(self);
  Object closure10975 = createclosure(1, "signaturePart");
  setclosureframe(closure10975, stackframe);
  addtoclosure(closure10975, var_signaturePart);
  struct UserObject *uo10975 = (struct UserObject*)self;
  uo10975->data[57] = (Object)closure10975;
  Method *meth_meth_ast_10975_signaturePart = addmethod2pos(self, "signaturePart", &meth_ast_10975_signaturePart, 57);
  int argcv_meth_ast_10975_signaturePart[] = {0};
  meth_meth_ast_10975_signaturePart->type = alloc_MethodType(1, argcv_meth_ast_10975_signaturePart);
  meth_meth_ast_10975_signaturePart->definitionModule = modulename;
  meth_meth_ast_10975_signaturePart->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2957
  setline(2957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject10976 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10976 = alloc_userobj2(5,6, objclass10976);
  gc_frame_newslot(obj10976);
  if (objclass10976 == NULL) {
    glfree(obj10976->class->name);
    obj10976->class->name = "requestPart";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj10976, self, 0);
  addmethodreal(obj10976,"outer", &reader_ast_outer_10977);
  Object oldself10976 = self;
  struct StackFrameObject *oldstackframe10976 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10976);
  gc_frame_newslot((Object)stackframe);
  self = obj10976;
  Object *oldselfslot10976 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10976 = (*(struct UserObject *)self).data[0], lowerouter10976 = thisouter10976;
  if (inheritingObject10976) {
    struct UserObject *inho10976 = (struct UserObject *)inheritingObject10976;
    while (inho10976->super != GraceDefaultObject) inho10976 = (struct UserObject *)inho10976->super;
    inho10976->super = obj10976;
    self = inheritingObject10976;
    *selfslot = self;
    lowerouter10976 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10976;
  }
// method "new"
  struct UserObject *uo10978 = (struct UserObject*)obj10976;
  uo10978->data[1] = emptyclosure;
  Method *meth_meth_ast_10978_new = addmethod2pos(obj10976, "new", &meth_ast_10978_new, 1);
  int argcv_meth_ast_10978_new[] = {0};
  meth_meth_ast_10978_new->type = alloc_MethodType(1, argcv_meth_ast_10978_new);
  meth_meth_ast_10978_new->definitionModule = modulename;
  meth_meth_ast_10978_new->definitionLine = 2958;
// method "request(_)"
  struct UserObject *uo10983 = (struct UserObject*)obj10976;
  uo10983->data[2] = emptyclosure;
  Method *meth_meth_ast_10983_request_40_1_41_ = addmethod2pos(obj10976, "request(1)", &meth_ast_10983_request_40_1_41_, 2);
  int argcv_meth_ast_10983_request_40_1_41_[] = {1};
  meth_meth_ast_10983_request_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_10983_request_40_1_41_);
  meth_meth_ast_10983_request_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10983_request_40_1_41_->definitionLine = 2959;
// method "request(_)withArgs(_)scope(_)"
  struct UserObject *uo10987 = (struct UserObject*)obj10976;
  uo10987->data[3] = emptyclosure;
  Method *meth_meth_ast_10987_request_40_1_41_withArgs_40_1_41_scope_40_1_41_ = addmethod2pos(obj10976, "request(1)withArgs(1)scope(1)", &meth_ast_10987_request_40_1_41_withArgs_40_1_41_scope_40_1_41_, 3);
  int argcv_meth_ast_10987_request_40_1_41_withArgs_40_1_41_scope_40_1_41_[] = {1, 1, 1};
  meth_meth_ast_10987_request_40_1_41_withArgs_40_1_41_scope_40_1_41_->type = alloc_MethodType(3, argcv_meth_ast_10987_request_40_1_41_withArgs_40_1_41_scope_40_1_41_);
  meth_meth_ast_10987_request_40_1_41_withArgs_40_1_41_scope_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10987_request_40_1_41_withArgs_40_1_41_scope_40_1_41_->definitionLine = 2960;
// method "request(_)withArgs(_)"
  block_savedest(obj10976);
  Object closure10992 = createclosure(2, "request(1)withArgs(1)");
  setclosureframe(closure10992, stackframe);
  addtoclosure(closure10992, var_requestPart);
  addtoclosure(closure10992, var_emptySeq);
  struct UserObject *uo10992 = (struct UserObject*)obj10976;
  uo10992->data[4] = (Object)closure10992;
  Method *meth_meth_ast_10992_request_40_1_41_withArgs_40_1_41_ = addmethod2pos(obj10976, "request(1)withArgs(1)", &meth_ast_10992_request_40_1_41_withArgs_40_1_41_, 4);
  int argcv_meth_ast_10992_request_40_1_41_withArgs_40_1_41_[] = {1, 1};
  meth_meth_ast_10992_request_40_1_41_withArgs_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_10992_request_40_1_41_withArgs_40_1_41_);
  meth_meth_ast_10992_request_40_1_41_withArgs_40_1_41_->definitionModule = modulename;
  meth_meth_ast_10992_request_40_1_41_withArgs_40_1_41_->definitionLine = 2965;
  block_savedest(obj10976);
  Object closure11344 = createclosure(2, "request(1)withArgs(1)$object(1)");
  setclosureframe(closure11344, stackframe);
  addtoclosure(closure11344, var_requestPart);
  addtoclosure(closure11344, var_emptySeq);
  Method *meth_meth_ast_10992_request_40_1_41_withArgs_40_1_41__object = addmethod2pos(obj10976, "request(1)withArgs(1)$object(1)", &meth_ast_10992_request_40_1_41_withArgs_40_1_41__object, 4);
  meth_meth_ast_10992_request_40_1_41_withArgs_40_1_41__object->definitionModule = modulename;
  meth_meth_ast_10992_request_40_1_41_withArgs_40_1_41__object->definitionLine = 2965;
  sourceObject = obj10976;
  sourceObject = obj10976;
  sourceObject = obj10976;
  sourceObject = obj10976;
  objclass10976 = obj10976->class;
  objclass10976->definitionModule = modulename;
  objclass10976->definitionLine = 2957;
  (*(struct UserObject *)self).data[0] = lowerouter10976;
  self = oldself10976;
  selfslot = oldselfslot10976;
  stackframe = oldstackframe10976;
// compiled object node returning obj10976 (depth = 2)
  *var_requestPart = obj10976;
  if (obj10976 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "requestPart"
  block_savedest(self);
  Object closure11345 = createclosure(1, "requestPart");
  setclosureframe(closure11345, stackframe);
  addtoclosure(closure11345, var_requestPart);
  struct UserObject *uo11345 = (struct UserObject*)self;
  uo11345->data[58] = (Object)closure11345;
  Method *meth_meth_ast_11345_requestPart = addmethod2pos(self, "requestPart", &meth_ast_11345_requestPart, 58);
  int argcv_meth_ast_11345_requestPart[] = {0};
  meth_meth_ast_11345_requestPart->type = alloc_MethodType(1, argcv_meth_ast_11345_requestPart);
  meth_meth_ast_11345_requestPart->definitionModule = modulename;
  meth_meth_ast_11345_requestPart->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 3043
  setline(3043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject11346 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj11346 = alloc_userobj2(2,4, objclass11346);
  gc_frame_newslot(obj11346);
  if (objclass11346 == NULL) {
    glfree(obj11346->class->name);
    obj11346->class->name = "commentNode";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj11346, self, 0);
  addmethodreal(obj11346,"outer", &reader_ast_outer_11347);
  Object oldself11346 = self;
  struct StackFrameObject *oldstackframe11346 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe11346);
  gc_frame_newslot((Object)stackframe);
  self = obj11346;
  Object *oldselfslot11346 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter11346 = (*(struct UserObject *)self).data[0], lowerouter11346 = thisouter11346;
  if (inheritingObject11346) {
    struct UserObject *inho11346 = (struct UserObject *)inheritingObject11346;
    while (inho11346->super != GraceDefaultObject) inho11346 = (struct UserObject *)inho11346->super;
    inho11346->super = obj11346;
    self = inheritingObject11346;
    *selfslot = self;
    lowerouter11346 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter11346;
  }
// method "new(_)"
  block_savedest(obj11346);
  Object closure11348 = createclosure(4, "new(1)");
  setclosureframe(closure11348, stackframe);
  addtoclosure(closure11348, var_util);
  addtoclosure(closure11348, var_lineLength);
  addtoclosure(closure11348, var_nullNode);
  addtoclosure(closure11348, var_commentNode);
  struct UserObject *uo11348 = (struct UserObject*)obj11346;
  uo11348->data[1] = (Object)closure11348;
  Method *meth_meth_ast_11348_new_40_1_41_ = addmethod2pos(obj11346, "new(1)", &meth_ast_11348_new_40_1_41_, 1);
  int argcv_meth_ast_11348_new_40_1_41_[] = {1};
  meth_meth_ast_11348_new_40_1_41_->type = alloc_MethodType(1, argcv_meth_ast_11348_new_40_1_41_);
  meth_meth_ast_11348_new_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11348_new_40_1_41_->definitionLine = 3044;
  block_savedest(obj11346);
  Object closure11550 = createclosure(4, "new(1)$object(1)");
  setclosureframe(closure11550, stackframe);
  addtoclosure(closure11550, var_util);
  addtoclosure(closure11550, var_lineLength);
  addtoclosure(closure11550, var_nullNode);
  addtoclosure(closure11550, var_commentNode);
  Method *meth_meth_ast_11348_new_40_1_41__object = addmethod2pos(obj11346, "new(1)$object(1)", &meth_ast_11348_new_40_1_41__object, 1);
  meth_meth_ast_11348_new_40_1_41__object->definitionModule = modulename;
  meth_meth_ast_11348_new_40_1_41__object->definitionLine = 3044;
  sourceObject = obj11346;
  objclass11346 = obj11346->class;
  objclass11346->definitionModule = modulename;
  objclass11346->definitionLine = 3043;
  (*(struct UserObject *)self).data[0] = lowerouter11346;
  self = oldself11346;
  selfslot = oldselfslot11346;
  stackframe = oldstackframe11346;
// compiled object node returning obj11346 (depth = 2)
  *var_commentNode = obj11346;
  if (obj11346 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// starting to compile method node (depth = 2)
// method "commentNode"
  block_savedest(self);
  Object closure11551 = createclosure(1, "commentNode");
  setclosureframe(closure11551, stackframe);
  addtoclosure(closure11551, var_commentNode);
  struct UserObject *uo11551 = (struct UserObject*)self;
  uo11551->data[59] = (Object)closure11551;
  Method *meth_meth_ast_11551_commentNode = addmethod2pos(self, "commentNode", &meth_ast_11551_commentNode, 59);
  int argcv_meth_ast_11551_commentNode[] = {0};
  meth_meth_ast_11551_commentNode->type = alloc_MethodType(1, argcv_meth_ast_11551_commentNode);
  meth_meth_ast_11551_commentNode->definitionModule = modulename;
  meth_meth_ast_11551_commentNode->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 3134
  setline(3134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl AstVisitor
// starting to compile typeliteral node (depth = 2)
//   Type literal 
  Object type11553 = alloc_Type("AstVisitor", 30);
  add_Method((ClassData)type11553, "visitIf(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitBlock(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitMatchCase(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitTryCatch(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitMethodType(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitSignaturePart(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitTypeLiteral(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitTypeParameters(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitTypeDec(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitMethod(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitCall(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitObject(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitModule(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitArray(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitMember(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitGeneric(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitIdentifier(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitString(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitNum(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitOp(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitBind(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitDefDec(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitVarDec(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitImport(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitReturn(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitInherits(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitDialect(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitComment(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitImplicit(1)up(1)", NULL);
  add_Method((ClassData)type11553, "visitOuter(1)up(1)", NULL);
// compiled typeliteral node returning type11553 (depth = 2)
  *var_AstVisitor = type11553;
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "AstVisitor"
  block_savedest(self);
  Object closure11554 = createclosure(1, "AstVisitor");
  setclosureframe(closure11554, stackframe);
  addtoclosure(closure11554, var_AstVisitor);
  struct UserObject *uo11554 = (struct UserObject*)self;
  uo11554->data[60] = (Object)closure11554;
  Method *meth_meth_ast_11554_AstVisitor = addmethod2pos(self, "AstVisitor", &meth_ast_11554_AstVisitor, 60);
  int argcv_meth_ast_11554_AstVisitor[] = {0};
  meth_meth_ast_11554_AstVisitor->type = alloc_MethodType(1, argcv_meth_ast_11554_AstVisitor);
  meth_meth_ast_11554_AstVisitor->definitionModule = modulename;
  meth_meth_ast_11554_AstVisitor->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 3274
  setline(3274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject11555 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj11555 = alloc_userobj2(1,2, objclass11555);
  gc_frame_newslot(obj11555);
  if (objclass11555 == NULL) {
    glfree(obj11555->class->name);
    obj11555->class->name = "patternMarkVisitor";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj11555, self, 0);
  addmethodreal(obj11555,"outer", &reader_ast_outer_11556);
  Object oldself11555 = self;
  struct StackFrameObject *oldstackframe11555 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe11555);
  gc_frame_newslot((Object)stackframe);
  self = obj11555;
  Object *oldselfslot11555 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter11555 = (*(struct UserObject *)self).data[0], lowerouter11555 = thisouter11555;
  if (inheritingObject11555) {
    struct UserObject *inho11555 = (struct UserObject *)inheritingObject11555;
    while (inho11555->super != GraceDefaultObject) inho11555 = (struct UserObject *)inho11555->super;
    inho11555->super = obj11555;
    self = inheritingObject11555;
    *selfslot = self;
    lowerouter11555 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter11555;
  }
// method "visitCall(_)up(_)"
  struct UserObject *uo11557 = (struct UserObject*)obj11555;
  uo11557->data[1] = emptyclosure;
  Method *meth_meth_ast_11557_visitCall_40_1_41_up_40_1_41_ = addmethod2pos(obj11555, "visitCall(1)up(1)", &meth_ast_11557_visitCall_40_1_41_up_40_1_41_, 1);
  int argcv_meth_ast_11557_visitCall_40_1_41_up_40_1_41_[] = {1, 1};
  meth_meth_ast_11557_visitCall_40_1_41_up_40_1_41_->type = alloc_MethodType(2, argcv_meth_ast_11557_visitCall_40_1_41_up_40_1_41_);
  meth_meth_ast_11557_visitCall_40_1_41_up_40_1_41_->definitionModule = modulename;
  meth_meth_ast_11557_visitCall_40_1_41_up_40_1_41_->definitionLine = 3276;
  sourceObject = obj11555;
// Begin line 3275
  setline(3275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11562 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_ast (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call11563 = callmethodflags(module_ast, "baseVisitor$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11562);
// compiled call node returning call11563 (depth = 3)
  struct UserObject *obj11555_uo = (struct UserObject *)obj11555;
  obj11555_uo->super = call11563;
  sourceObject = obj11555;
  objclass11555 = obj11555->class;
  objclass11555->definitionModule = modulename;
  objclass11555->definitionLine = 3274;
  (*(struct UserObject *)self).data[0] = lowerouter11555;
  self = oldself11555;
  selfslot = oldselfslot11555;
  stackframe = oldstackframe11555;
// compiled object node returning obj11555 (depth = 2)
  *var_patternMarkVisitor = obj11555;
  if (obj11555 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "patternMarkVisitor"
  block_savedest(self);
  Object closure11564 = createclosure(1, "patternMarkVisitor");
  setclosureframe(closure11564, stackframe);
  addtoclosure(closure11564, var_patternMarkVisitor);
  struct UserObject *uo11564 = (struct UserObject*)self;
  uo11564->data[61] = (Object)closure11564;
  Method *meth_meth_ast_11564_patternMarkVisitor = addmethod2pos(self, "patternMarkVisitor", &meth_ast_11564_patternMarkVisitor, 61);
  int argcv_meth_ast_11564_patternMarkVisitor[] = {0};
  meth_meth_ast_11564_patternMarkVisitor->type = alloc_MethodType(1, argcv_meth_ast_11564_patternMarkVisitor);
  meth_meth_ast_11564_patternMarkVisitor->definitionModule = modulename;
  meth_meth_ast_11564_patternMarkVisitor->definitionLine = 3050;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
  gc_frame_end(frame);
  return self;
}
