#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "1e6315be77eff662cf99876c2ac8964a81f2abc7";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "lexer";
Object module_standardGrace_init();
extern Object module_standardGrace;
Object module_lexer = NULL;
static char *originalSourceLines[] = {
  "#pragma ExtendedLineups",
  "import \"util\" as util",
  "import \"unicode\" as unicode",
  "import \"errormessages\" as errormessages",
  "import \"stringMap\" as map",
  "",
  "def keywords = map.new",
  "keywords.put(\"alias\", true)",
  "keywords.put(\"class\", true)",
  "keywords.put(\"def\", true)",
  "keywords.put(\"dialect\", true)",
  "keywords.put(\"exclude\", true)",
  "keywords.put(\"factory\", true)",
  "keywords.put(\"import\", true)",
  "keywords.put(\"inherit\", true)",
  "keywords.put(\"interface\", true)",
  "keywords.put(\"is\", true)",
  "keywords.put(\"method\", true)",
  "keywords.put(\"object\", true)",
  "keywords.put(\"return\", true)",
  "keywords.put(\"super\", true)",
  "keywords.put(\"trait\", true)",
  "keywords.put(\"type\", true)",
  "keywords.put(\"use\", true)",
  "keywords.put(\"var\", true)",
  "",
  "def operatorChars = \"-&|:$#\\\\%^@?*/+!~\"",
  "method isOperatorChar(c, ordval) {",
  "    if (operatorChars.contains(c)) then { return true }",
  "    if (unicode.isSymbolMathematical(ordval)) then { return true }",
  "    if (unicode.inCategory(c, \"So\")) then { return true }",
  "    return false",
  "}",
  "",
  "def spaceChars = \" \\u00A0\"    // ASCII space + non-breaking space",
  "def tab = \"\\t\"",
  "method isBadSeparator(ch) {",
  "    if (spaceChars.contains(ch)) then { return false }",
  "    if (tab == ch) then { return true }",
  "    return unicode.inCategory(ch, \"Z\")",
  "}",
  "",
  "def nl_cr = \"\\n\\r\"      // nl and cr",
  "method isBadControl(ch) {",
  "    if (nl_cr.contains(ch)) then { return false }",
  "    return unicode.inCategory(ch, \"C\")",
  "}",
  "",
  "def selfModes = \"(),\\{}[];⟦⟧\"",
  "method isSelfMode(ch) { selfModes.contains(ch) }",
  "",
  "def brackets = \"()\\{}[]⟦⟧\"",
  "method isBracket(ch) { brackets.contains(ch) }",
  "",
  "def alphaNums = \"_'0123456789abcdefghijklmnopqrstuvwzyzABCDEFGHIJKLMNOPQRSTUVWXYZ\"",
  "method isIdentifierChar(ch) {",
  "    if (alphaNums.contains(ch)) then { return true }",
  "    if (unicode.inCategory(ch, \"L\")) then { return true }",
  "    if (unicode.inCategory(ch, \"N\")) then { return true }",
  "    return false",
  "}",
  "def digits = \"0123456789\"",
  "method isDigit(ch) { digits.contains(ch) }",
  "",
  "def asciiLetters = \"abcdefghijklmnopqrstuvwzyzABCDEFGHIJKLMNOPQRSTUVWXYZ\"",
  "method isLetter(ch) {",
  "    if (asciiLetters.contains(ch)) then { return true }",
  "    if (unicode.inCategory(ch, \"L\")) then { return true }",
  "    return false",
  "}",
  "",
  "method padl(s, l, w) {",
  "    if (s.size >= l) then {",
  "        return s",
  "    }",
  "    var s' := s",
  "    while {s'.size < l} do {",
  "        s' := w ++ s'",
  "    }",
  "    return s'",
  "}",
  "",
  "class new {",
  "    var tokens",
  "    var lineNumber := 1",
  "    var linePosition := 0",
  "    var startPosition := 1",
  "    var indentLevel := 0",
  "    var startLine := 1",
  "    var stringStart",
  "    var unichars := 0",
  "    class token {",
  "        def line is public = lineNumber",
  "        def indent is public = indentLevel",
  "        def linePos is public = startPosition",
  "",
  "        var next is public := false",
  "        var prev is public := false",
  "",
  "        method ==(other) {",
  "            if (false == other) then {",
  "                false",
  "            } else {",
  "                (other.line == line) && (other.linePos == linePos)",
  "            }",
  "        }",
  "        method asString { \"({line}:{linePos}){self.kind} {self.value}\" }",
  "        method value { abstract }",
  "        method size { abstract }",
  "        method kind { abstract }",
  "        method endPos { linePos + size - 1 }",
  "    }",
  "",
  "",
  "    class identifierToken(s) {",
  "        inherit token",
  "        def kind is public = \"identifier\"",
  "        def value is public = s",
  "        def size is public = s.size",
  "    }",
  "    class stringToken(s) {",
  "        inherit token",
  "        def kind is public = \"string\"",
  "        def value is public = s",
  "        def size is public = linePosition - startPosition + 1",
  "    }",
  "    class multiLineStringToken(s) {",
  "        inherit token",
  "        def kind is public = \"string\"",
  "        def value is public = s",
  "        def size is public = s.size + 2",
  "        def line' = startLine",
  "        def linePos' = stringStart",
  "        method line is override { line' }",
  "        method linePos is override { linePos' }",
  "        method endLine { lineNumber }",
  "        method endPos is override { linePosition }",
  "    }",
  "    class commentToken(s) {",
  "        inherit token",
  "        def kind is public = \"comment\"",
  "        def value is public = s",
  "        def size is public = s.size + 2",
  "    }",
  "    class lBraceToken {",
  "        inherit token",
  "        def kind is public = \"lbrace\"",
  "        def value is public = \"\\{\"",
  "        def size is public = 1",
  "    }",
  "    class rBraceToken {",
  "        inherit token",
  "        def kind is public = \"rbrace\"",
  "        def value is public = \"}\"",
  "        def size is public = 1",
  "    }",
  "    class lParenToken {",
  "        inherit token",
  "        def kind is public = \"lparen\"",
  "        def value is public = \"(\"",
  "        def size is public = 1",
  "    }",
  "    class rParenToken {",
  "        inherit token",
  "        def kind is public = \"rparen\"",
  "        def value is public = \")\"",
  "        def size is public = 1",
  "    }",
  "    class lSquareToken {",
  "        inherit token",
  "        def kind is public = \"lsquare\"",
  "        def value is public = \"[\"",
  "        def size is public = 1",
  "    }",
  "    class rSquareToken {",
  "        inherit token",
  "        def kind is public = \"rsquare\"",
  "        def value is public = \"]\"",
  "        def size is public = 1",
  "    }",
  "    class commaToken {",
  "        inherit token",
  "        def kind is public = \"comma\"",
  "        def value is public = \",\"",
  "        def size is public = 1",
  "    }",
  "    class colonToken {",
  "        inherit token",
  "        def kind is public = \"colon\"",
  "        def value is public = \":\"",
  "        def size is public = 1",
  "    }",
  "    class dotToken {",
  "        inherit token",
  "        def kind is public = \"dot\"",
  "        def value is public = \".\"",
  "        def size is public = 1",
  "    }",
  "    class numToken(v, b) {",
  "        inherit token",
  "        def kind is public = \"num\"",
  "        def value is public = v",
  "        def base is public = b",
  "        def size is public = linePosition - startPosition + 1",
  "    }",
  "    class keywordToken(v) {",
  "        inherit token",
  "        def kind is public = \"keyword\"",
  "        def value is public = v",
  "        def size is public = v.size",
  "    }",
  "    class opToken(v) {",
  "        inherit token",
  "        def kind is public = \"op\"",
  "        def value is public = v",
  "        def size is public = v.size",
  "    }",
  "    class arrowToken {",
  "        inherit token",
  "        def kind is public = \"arrow\"",
  "        def value is public = \"→\"",
  "        def size is public = 1",
  "    }",
  "    class bindToken {",
  "        inherit token",
  "        def kind is public = \"bind\"",
  "        def value is public = \":=\"",
  "        def size is public = 2",
  "    }",
  "    class semicolonToken {",
  "        inherit token",
  "        def kind is public = \"semicolon\"",
  "        def value is public = \";\"",
  "        def size is public = 1",
  "    }",
  "    class lGenericToken {",
  "        inherit token",
  "        def kind is public = \"lgeneric\"",
  "        def value is public = \"⟦\"",
  "        def size is public = 1",
  "    }",
  "    class rGenericToken {",
  "        inherit token",
  "        def kind is public = \"rgeneric\"",
  "        def value is public = \"⟧\"",
  "        def size is public = 1",
  "    }",
  "    class eofToken {",
  "        inherit token",
  "        def kind is public = \"eof\"",
  "        def value is public = \"\"",
  "        def size is public = 0",
  "    }",
  "",
  "    var state",
  "    var accum := \"\"",
  "",
  "    var inStr := false",
  "    var escaped := false",
  "    var codepoint := 0",
  "    var interpdepth := 0",
  "    var interpString := false",
  "",
  "    method advanceTo(s) { state := s }",
  "    method emit(t) {",
  "        tokens.push(t)",
  "        accum := \"\"",
  "    }",
  "    method store(c) { accum := accum ++ c }",
  "",
  "    def startState = object {",
  "        method consume(c){",
  "            if (c == \"#\") then {",
  "                advanceTo(pragmaPrefixState)",
  "            } else {",
  "                advanceTo(defaultState)",
  "                state.consume(c)",
  "            }",
  "        }",
  "    }",
  "    state := startState",
  "",
  "    def pragmaPrefixState = object {",
  "        method consume(c){",
  "            checkSeparator(c)",
  "            if (c == \"\\n\") then {",
  "                errormessages.syntaxError \"Incomplete pragma definition \"",
  "                    atRange(lineNumber, startPosition, linePosition)",
  "            } elseif {isSpaceChar(c)} then {",
  "                if (accum == \"pragma\") then {",
  "                    accum := \"\"",
  "                    advanceTo(pragmaBodyState)",
  "                } else {",
  "                    errormessages.syntaxError \"Pragmas must start with #pragma \"",
  "                        atRange(lineNumber, startPosition, linePosition)",
  "                }",
  "            } else {",
  "                store(c)",
  "            }",
  "        }",
  "    }",
  "",
  "    def pragmaBodyState = object {",
  "        method consume(c){",
  "            checkSeparator(c)",
  "            if ((c == \"\\n\") || isSpaceChar(c)) then {",
  "                //a complete pragma has been found",
  "                util.processExtension(accum)",
  "                accum := \"\"",
  "                advanceTo(pragmaTrailingWhitespaceState)",
  "                state.consume(c)",
  "            } else {",
  "                store(c)",
  "            }",
  "        }",
  "    }",
  "",
  "    def pragmaTrailingWhitespaceState = object {",
  "        method consume(c) {",
  "            checkSeparator(c)",
  "            if (c == \"\\n\") then {",
  "                advanceTo(startState)",
  "            } elseif {!isSpaceChar(c)} then {",
  "                errormessages.syntaxError \"Pragmas must be a single word \"",
  "                    atRange(lineNumber, startPosition, linePosition)",
  "            }",
  "        }",
  "    }",
  "",
  "    def defaultState = object {",
  "        method consume(c) {",
  "            def ordval = c.ord",
  "            checkSeparator(c)",
  "            startPosition := linePosition",
  "            startLine := lineNumber",
  "            if (spaceChars.contains(c)) then {",
  "                //do nothing",
  "            } elseif {c == \"\\\"\"} then {",
  "                inStr := true",
  "                stringStart := linePosition",
  "                advanceTo(quotedStringState)",
  "            } elseif {c == \"‹\"} then {",
  "                inStr := true",
  "                stringStart := linePosition",
  "                advanceTo(extendedStringState)",
  "            } elseif {isDigit(c)} then {",
  "                if ((tokens.size > 0) && {tokens.last.kind == \"num\"}) then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.deleteRange(tokens.last.linePos+tokens.last.size, linePosition - 1)onLine(lineNumber)",
  "                    errormessages.syntaxError(\"Consecutive numbers are not allowed.\")",
  "                        atRange(lineNumber, tokens.last.linePos, linePosition)withSuggestion(suggestion)",
  "                }",
  "                startPosition := linePosition",
  "                advanceTo(numberStartState)",
  "                state.consume(c)",
  "            } elseif {isIdentifierChar(c)} then {",
  "                advanceTo(identifierState)",
  "                state.consume(c)",
  "            } elseif {c == \"/\"} then {",
  "                advanceTo(slashState)",
  "                state.consume(c)",
  "            } elseif {c == \".\"} then {",
  "                advanceTo(dotState)",
  "                state.consume(c)",
  "            } elseif {(c == \"<\") || isOperatorChar(c, ordval)} then {",
  "                advanceTo(operatorState)",
  "                state.consume(c)",
  "            } elseif {c == \",\"} then {",
  "                emit(commaToken)",
  "            } elseif {c == \"\\{\"} then {",
  "                emit(lBraceToken)",
  "            } elseif {c == \"}\"} then {",
  "                advanceTo(rBraceState)",
  "                state.consume(c)",
  "            } elseif {c == \"(\"} then {",
  "                emit(lParenToken)",
  "            } elseif {c == \")\"} then {",
  "                if ((tokens.size > 0) && {tokens.last.kind == \"lparen\"}) then {",
  "                    errormessages.syntaxError(\"empty parenthesis are not allowed. \" ++",
  "                        \"Remove them, or put something between them.\")",
  "                        atRange(lineNumber, tokens.last.linePos, linePosition)",
  "                }",
  "                emit(rParenToken)",
  "            } elseif {c == \"[\"} then {",
  "                emit(lSquareToken)",
  "            } elseif {c == \"]\"} then {",
  "                emit(rSquareToken)",
  "            } elseif {c == \"⟦\"} then {",
  "                emit(lGenericToken)",
  "            } elseif {c == \"⟧\"} then {",
  "                emit(rGenericToken)",
  "            } elseif {c == \";\"} then {",
  "                emit(semicolonToken)",
  "            } elseif {c == \"\\n\"} then {",
  "                indentLevel := 0",
  "                advanceTo(indentationState)",
  "            } else {",
  "                if((unicode.isSeparator(ordval).not) &&",
  "                        (unicode.isControl(ordval).not) &&",
  "                        (ordval != 10) &&",
  "                        (ordval != 13) &&",
  "                        (ordval != 32)) then {",
  "                    errormessages.syntaxError(\"{unicode.name(c)} (U+{padl(ordval.inBase 16, 4, \"0\")}) \"",
  "                        ++ \"is not a valid character; use spaces instead.\")atRange(",
  "                        lineNumber, linePosition, linePosition)",
  "                }",
  "            }",
  "        }",
  "    }",
  "",
  "    def rBraceState = object {",
  "        method consume (c){",
  "            if (interpdepth > 0) then {",
  "                if (tokens.last.kind == \"lparen\") then {",
  "                    def suggestion1 = errormessages.suggestion.new",
  "                    suggestion1.deleteRange(tokens.last.linePos, linePosition)",
  "                                    onLine(lineNumber)",
  "                    def suggestion2 = errormessages.suggestion.new",
  "                    suggestion2.insert \"«expression»\"",
  "                                    atPosition (tokens.last.linePos+1)",
  "                                    onLine(lineNumber)",
  "                    errormessages.syntaxError \"a string interpolation cannot be empty.\"",
  "                          atRange (lineNumber, tokens.last.linePos, linePosition)",
  "                          withSuggestions [suggestion1, suggestion2]",
  "                }",
  "                emit (rParenToken)",
  "                emit (opToken(\"++\"))",
  "                interpdepth := interpdepth - 1",
  "                inStr := true",
  "                advanceTo(quotedStringState)",
  "            } else {",
  "                emit (rBraceToken)",
  "                advanceTo (defaultState)",
  "            }",
  "        }",
  "    }",
  "",
  "    def slashState = object {",
  "        method consume (c) {",
  "            checkSeparator(c)",
  "            if (c == \"/\") then {",
  "                store(c)",
  "                if (accum == \"//\") then {",
  "                    advanceTo(commentSpaceState)",
  "                }",
  "            } elseif {accum == \"/\"} then {",
  "                advanceTo(operatorState)",
  "                state.consume(c)",
  "            } else {",
  "                advanceTo(defaultState)",
  "                state.consume(c)",
  "            }",
  "        }",
  "    }",
  "",
  "    def dotState = object {",
  "        method consume (c) {",
  "            checkSeparator(c)",
  "            if (c == \".\") then {",
  "                store(c)",
  "                if (accum == \"...\") then {",
  "                    advanceTo(identifierState)",
  "                }",
  "            } elseif {accum == \"..\"} then {",
  "                advanceTo(operatorState)",
  "                state.consume(c)",
  "            } elseif {isDigit(c)} then {",
  "                accum := \"0.\"",
  "                //should an error be thrown instead?",
  "                advanceTo(numberFractionState)",
  "                state.consume(c)",
  "            } else {",
  "                emit(dotToken)",
  "                advanceTo(defaultState)",
  "                state.consume(c)",
  "            }",
  "        }",
  "    }",
  "",
  "    def identifierState = object {",
  "        method consume (c) {",
  "            checkSeparator(c)",
  "            if (!isIdentifierChar(c)) then {",
  "                if (keywords.contains(accum)) then {",
  "                    if (accum == \"super\") then {",
  "                        errormessages.syntaxError(",
  "                            \"`super` is no longer part of Grace.\\n\" ++",
  "                              \"Consider using an `alias` clause on the inherit statement.\")",
  "                              atRange(lineNumber, startPosition, linePosition-1)",
  "                    } elseif {accum == \"inherits\"} then {",
  "                        errormessages.syntaxError(",
  "                            \"The reserved word `inherits` has been replaced by `inherit`.\")",
  "                              atRange(lineNumber, startPosition, linePosition-1)",
  "                    }",
  "                    emit(keywordToken(accum))",
  "                } else {",
  "                    emit(identifierToken(accum))",
  "                }",
  "                advanceTo(defaultState)",
  "                state.consume(c)",
  "            } else {",
  "                store(c)",
  "            }",
  "        }",
  "    }",
  "    def quotedStringState = object {",
  "        method consume (c) {",
  "",
  "            checkSeparatorString (c)",
  "            if (c == \"\\\"\") then {",
  "                emit(stringToken(accum))",
  "                if (interpString && (interpdepth == 0)) then {",
  "                    emit(rParenToken)",
  "                    interpString := false",
  "                }",
  "                advanceTo(defaultState)",
  "                inStr := false",
  "            } elseif {c == \"\\n\"} then {",
  "                newLineError",
  "            } elseif {c == \"\\{\"} then {",
  "                def strToken = stringToken(accum)",
  "                startPosition := linePosition",
  "                if (!interpString) then {",
  "                    emit(lParenToken)",
  "                    interpString := true",
  "                }",
  "                emit(strToken)",
  "                emit(opToken(\"++\"))",
  "                emit(lParenToken)",
  "                advanceTo(defaultState)",
  "                inStr := false",
  "                interpdepth := interpdepth + 1",
  "            } elseif {c == \"\\\\\"} then {",
  "                advanceTo(quotedStringEscapedState)",
  "            } else {",
  "                store(c)",
  "            }",
  "        }",
  "    }",
  "    def unicodeState = object {",
  "        method consume(c){",
  "            unichars := unichars - 1",
  "            codepoint := codepoint * 16",
  "            codepoint := codepoint + hexdecchar(c)",
  "            //print \"adding unicode char {c}\"",
  "            if (unichars == 0) then {",
  "                // At the end of the sequence construct",
  "                // the character in the unicode library.",
  "                store(unicode.create(codepoint))",
  "                advanceTo(quotedStringState)",
  "            }",
  "        }",
  "    }",
  "    def quotedStringEscapedState = object {",
  "        method consume (c) {",
  "            checkSeparatorString (c)",
  "            advanceTo(quotedStringState)",
  "            if (c == \"\\n\") then {",
  "               newLineError",
  "            } elseif { c == \"n\" } then {",
  "                // Newline escape",
  "                accum := accum ++ \"\\u000a\"",
  "            } elseif { c == \"u\" } then {",
  "                // Beginning of a four-digit Unicode escape",
  "                // (for a BMP codepoint).",
  "                unichars := 4",
  "                codepoint := 0",
  "                advanceTo(unicodeState)",
  "            } elseif { c == \"U\" } then {",
  "                // Beginning of a six-digit Unicode escape",
  "                // (for a general codepoint).",
  "                unichars := 6",
  "                codepoint := 0",
  "                advanceTo(unicodeState)",
  "            } elseif { c == \"t\" } then {",
  "                // Tab escape",
  "                accum := accum ++ \"\\u0009\"",
  "            } elseif { c == \"r\" } then {",
  "                // Carriage return escape",
  "                accum := accum ++ \"\\u000d\"",
  "            } elseif { c == \"b\" } then {",
  "                // Backspace escape",
  "                accum := accum ++ \"\\u0008\"",
  "            } elseif { c == \"l\" } then {",
  "                // LINE SEPARATOR escape",
  "                accum := accum ++ \"\\u2028\"",
  "            } elseif { c == \"f\" } then {",
  "                // Form feed/page down escape",
  "                accum := accum ++ \"\\u000c\"",
  "            } elseif { c == \"e\" } then {",
  "                // Escape escape",
  "                accum := accum ++ \"\\u001b\"",
  "            } elseif { c == \"_\" } then {",
  "                // non-breaking space",
  "                accum := accum ++ \"\\u00a0\"",
  "            } else {",
  "                // For any other character preceded by \\,",
  "                // insert it literally.",
  "                store(c)",
  "            }",
  "        }",
  "    }",
  "",
  "    def extendedStringState = object {",
  "        method consume (c) {",
  "",
  "            if (c == \"›\") then {",
  "                emit(multiLineStringToken(accum))",
  "                inStr := false",
  "                advanceTo(defaultState)",
  "            } else {",
  "                store(c)",
  "            }",
  "        }",
  "    }",
  "",
  "    var tokenBase is writable",
  "    var mantissa is writable",
  "    def numberStartState = object {",
  "        method consume (c) {",
  "            checkSeparator (c)",
  "            if (isDigit(c)) then {",
  "                store(c)",
  "            } elseif { c == \"x\" } then {",
  "                tokenBase := accum.asNumber",
  "                if (tokenBase == 0) then {",
  "                    tokenBase := 16",
  "                }",
  "                accum := \"\"",
  "                advanceTo(numberBaseState)",
  "            } elseif {(c == \"e\") || (c == \"E\")} then {",
  "                mantissa := accum.asNumber",
  "                accum := \"\"",
  "                advanceTo(numberExponentSignState)",
  "            } elseif { isLetter(c) } then {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\".\")atPosition(linePosition)onLine(lineNumber)",
  "                errormessages.syntaxError(\"'{c}' is not a valid digit in base 10. Valid digits are 0..9.\")atRange(",
  "                    lineNumber, startPosition, linePosition)withSuggestion(suggestion)",
  "            } elseif { c == \".\" } then {",
  "                advanceTo(numberDotState)",
  "            } else {",
  "                emit(numToken(accum, 10))",
  "                advanceTo(defaultState)",
  "                state.consume(c)",
  "            }",
  "        }",
  "    }",
  "    def numberBaseState = object {",
  "        method consume (c) {",
  "            checkSeparator(c)",
  "            if (isDigit(c) || isLetter(c)) then {",
  "                store(c)",
  "            } elseif {(c == \".\") && (tokenBase == 10)} then {",
  "                advanceTo(numberDotState)",
  "            } else {",
  "                emit(numToken(fromBase(accum, tokenBase).asString, tokenBase))",
  "                advanceTo(defaultState)",
  "                state.consume(c)",
  "            }",
  "        }",
  "    }",
  "",
  "",
  "    def numberDotState = object {",
  "        method consume (c) {",
  "            if (isDigit(c)) then {",
  "                store(\".\")",
  "                advanceTo(numberFractionState)",
  "                state.consume(c)",
  "            } elseif { spaceChars.contains(c) } then {",
  "                //alternatively, throw an error here",
  "                emit(numToken(accum, 10))",
  "                advanceTo(defaultState)",
  "                state.consume(c)",
  "            } else {",
  "                emit(numToken(accum, 10))",
  "                accum := \".\"",
  "                advanceTo(dotState)",
  "                state.consume(c)",
  "            }",
  "        }",
  "    }",
  "    def numberFractionState = object {",
  "        method consume (c) {",
  "            checkSeparator(c)",
  "            if (isDigit(c)) then {",
  "                store(c)",
  "            } elseif {(c == \"e\") || (c == \"E\")} then {",
  "                mantissa := accum.asNumber",
  "                accum := \"\"",
  "                advanceTo(numberExponentSignState)",
  "            } elseif {isLetter(c)} then {",
  "                errormessages.syntaxError(\"the fractional part of a number must be in base 10.\")atRange(",
  "                    lineNumber, startPosition, linePosition)",
  "            } else {",
  "                emit(numToken(accum, 10))",
  "                advanceTo(defaultState)",
  "                state.consume(c)",
  "            }",
  "        }",
  "    }",
  "    def numberExponentSignState = object {",
  "        method consume (c) {",
  "            checkSeparator(c)",
  "            if (isDigit(c) || (c == \"-\")) then {",
  "                store(c)",
  "                advanceTo(numberExponentState)",
  "            } elseif {isLetter(c)} then {",
  "                errormessages.syntaxError(\"{c} is not an allowed base-10 exponent character\")atRange(",
  "                    lineNumber, startPosition, linePosition)",
  "            } else {",
  "                errormessages.syntaxError(\"exponents must have at least one digit\")atRange(",
  "                    lineNumber, startPosition, linePosition)",
  "            }",
  "        }",
  "    }",
  "    def numberExponentState = object {",
  "        method consume (c) {",
  "            checkSeparator(c)",
  "            if (isDigit(c)) then {",
  "                store(c)",
  "            } elseif {isLetter(c)} then {",
  "                errormessages.syntaxError(\"{c} is not an allowed base-10 exponent character\")atRange(",
  "                    lineNumber, startPosition, linePosition)",
  "            } else {",
  "                if (accum == \"-\") then {",
  "                    errormessages.syntaxError(\"exponents must have at least one digit\")atRange(",
  "                        lineNumber, startPosition, linePosition)",
  "                }",
  "                def exponent = accum.asNumber",
  "                var absExp := exponent",
  "                if (exponent < 0) then {",
  "                    absExp := -exponent",
  "                }",
  "                var absMultiplier := 1",
  "                repeat (absExp) times {",
  "                    absMultiplier := absMultiplier * 10",
  "                }",
  "                if (exponent >= 0) then {",
  "                    emit (numToken((mantissa * absMultiplier).asString, 10))",
  "                } else {",
  "                    emit (numToken((mantissa / absMultiplier).asString, 10))",
  "                }",
  "                advanceTo(defaultState)",
  "                state.consume(c)",
  "            }",
  "        }",
  "    }",
  "",
  "    def operatorState = object {",
  "        method consume (c) {",
  "            checkSeparator (c)",
  "            if (isOperatorChar(c, c.ord)) then {",
  "                store(c)",
  "            } else {",
  "                if (accum == \"→\") then {",
  "                    emit(arrowToken)",
  "                } elseif { accum == \":=\" } then {",
  "                    emit(bindToken)",
  "                } elseif { accum == \":\" } then {",
  "                    emit(colonToken)",
  "                } else {",
  "                    emit(opToken(accum))",
  "                }",
  "                advanceTo(defaultState)",
  "                state.consume(c)",
  "            }",
  "        }",
  "    }",
  "",
  "    def indentationState = object {",
  "        method consume (c) {",
  "            if (spaceChars.contains(c)) then {",
  "                indentLevel := linePosition",
  "            } else {",
  "                advanceTo(defaultState)",
  "                state.consume(c)",
  "            }",
  "        }",
  "    }",
  "    def commentSpaceState = object {",
  "        method consume (c) {",
  "            if (!spaceChars.contains(c)) then {",
  "                accum := \"\"",
  "                advanceTo(commentState)",
  "                state.consume(c)",
  "            }",
  "        }",
  "    }",
  "    def commentState = object {",
  "        method consume (c) {",
  "            if (c == \"\\n\") then {",
  "                emit (commentToken(accum))",
  "                indentLevel := 0",
  "                advanceTo(indentationState)",
  "            } else {",
  "                store(c)",
  "            }",
  "        }",
  "    }",
  "",
  "    method newLineError {",
  "        if (interpdepth > 0) then {",
  "            // Find closest {.",
  "            var line := lineNumber",
  "            var i := util.lines.at(line).size",
  "            while { util.lines.at(line).at(i) != \"\\{\" } do {",
  "                i := i - 1",
  "                if(i == 0) then {",
  "                    lineNumber := line - 1",
  "                    i := util.lines.at(line).size",
  "                }",
  "            }",
  "            def suggestions = []",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\"\\\\\")atPosition(i)onLine(line)",
  "            suggestions.push(suggestion)",
  "            if((line == lineNumber) && (i == (linePosition - 2))) then {",
  "                errormessages.syntaxError(\"for a '\\{' character in a string use '\\\\\\{'.\")atPosition(",
  "                    line, i)withSuggestions(suggestions)",
  "            } else {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\"}\")atPosition(linePosition - accum.size - 1)onLine(lineNumber)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a string interpolation must end with a '}'. For a '\\{' character in a string use '\\\\\\{'.\")atPosition(",
  "                    lineNumber, linePosition - accum.size - 1)withSuggestions(suggestions)",
  "            }",
  "        } else {",
  "            def errorLine = util.lines.at(lineNumber)",
  "            def nextLine = if (util.lines.size >= (lineNumber + 1)) then {",
  "                    util.lines.at(lineNumber + 1)",
  "                } else {",
  "                    \"\"",
  "                }",
  "            // Count the number of literal quotes in the next line.",
  "            var i := 1",
  "            var count := 0",
  "            while { i <= nextLine.size } do {",
  "                if (nextLine.at(i) == \"\\\"\") then {",
  "                    count := count + 1",
  "                } elseif {",
  "                    nextLine.at(i) == \"\\\\\"",
  "                } then {",
  "                    i := i + 1",
  "                }",
  "                i := i + 1",
  "            }",
  "            if ((count % 2) == 1) then {",
  "                def suggestions = []",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.addLine(lineNumber, errorLine ++ nextLine)",
  "                suggestion.addLine(lineNumber + 1, \"\")",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.addLine(lineNumber, errorLine ++ \"\\\"\")",
  "                suggestion.addLine(lineNumber + 1, \"    ++ \\\"\" ++ nextLine)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.addLine(lineNumber, errorLine ++ \"\\\\n\" ++ nextLine)",
  "                suggestion.addLine(lineNumber + 1, \"\")",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a string must be terminated by a \\\" before the end of the line. To insert a newline in a string, use '\\\\n'. To split a string over multiple lines, use '++' to join strings together.\")",
  "                    atRange(lineNumber, linePosition, linePosition)",
  "                    withSuggestions(suggestions)",
  "            } else {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.addLine(lineNumber, errorLine ++ \"\\\"\")",
  "                errormessages.syntaxError(\"a string must be terminated \" ++",
  "                    \"by a \\\" before the end of the line.\")",
  "                    atPosition(lineNumber, linePosition)",
  "                    withSuggestion(suggestion)",
  "            }",
  "        }",
  "    }",
  "",
  "    method isSpaceChar(c){",
  "        spaceChars.contains(c)",
  "    }",
  "    method checkSeparatorString (c) {",
  "        def ordval = c.ord",
  "        if (isBadSeparator(c)) then {",
  "            // Character is whitespace, but not an ASCII space or",
  "            // Unicode NO-BREAK SPACE.  For example, a tab",
  "",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.replaceChar(linePosition)with(\" \")onLine(lineNumber)",
  "            if (ordval == 9) then {",
  "                suggestion.replaceRange(linePosition, linePosition)",
  "                    with(\"\\\\t\")",
  "                    onLine(lineNumber)",
  "                errormessages.syntaxError(\"tabs cannot be \"",
  "                    ++ \"written in the source code; \"",
  "                    ++ \"use the string escape \\\\t instead\")",
  "                    atRange(lineNumber, linePosition, linePosition)",
  "                    withSuggestion(suggestion)",
  "                errormessages.syntaxError(\"tabs are not allowed; use spaces instead.\")atRange(lineNumber,",
  "                    linePosition, linePosition)withSuggestion(suggestion)",
  "            } else {",
  "                suggestion.replaceRange(linePosition, linePosition)",
  "                    with(\"\\\\u{padl(ordval.inBase 16, 4, \"0\")}\")",
  "                    onLine(lineNumber)",
  "                errormessages.syntaxError(\"{unicode.name(c)} (U+{padl(ordval.inBase 16, 4, \"0\")}) \"",
  "                    ++ \"is not a valid whitespace character\"",
  "                    ++ \" and cannot be \"",
  "                    ++ \"written in the source code; \"",
  "                    ++ \"use the Unicode escape \\\\u\"",
  "                    ++ padl(ordval.inBase 16, 4, \"0\")",
  "                    ++ \" instead\")",
  "                    atRange(lineNumber, linePosition, linePosition)",
  "                    withSuggestion(suggestion)",
  "                errormessages.syntaxError(\"{unicode.name(c)} (U+{padl(ordval.inBase 16, 4, \"0\")}) \"",
  "                    ++ \"is not a valid whitespace character; use spaces instead.\")atRange(lineNumber,",
  "                    linePosition, linePosition)withSuggestion(suggestion)",
  "            }",
  "        } elseif {isBadControl(c)} then {",
  "            // Character is a control character other than",
  "            // carriage return or line feed.",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.replaceRange(linePosition, linePosition)",
  "                with(\"\\\\u{padl(ordval.inBase 16, 4, \"0\")}\")",
  "                onLine(lineNumber)",
  "            errormessages.syntaxError(\"{unicode.name(c)} (U+{padl(ordval.inBase 16, 4, \"0\")}) \"",
  "                ++ \"is a control character and cannot be \"",
  "                ++ \"written in the source code; \"",
  "                ++ \"use the Unicode escape \\\\u\"",
  "                ++ padl(ordval.inBase 16, 4, \"0\")",
  "                ++ \" instead\")",
  "                atRange(lineNumber, linePosition, linePosition)",
  "                withSuggestion(suggestion)",
  "            suggestion.deleteChar(linePosition)onLine(lineNumber)",
  "            errormessages.syntaxError(\"{unicode.name(c)} (U+{padl(ordval.inBase 16, 4, \"0\")}) \"",
  "                ++ \"is a control character and cannot be written in the source code; consider using spaces instead.\")atRange(lineNumber,",
  "                linePosition, linePosition)withSuggestion(suggestion)",
  "        }",
  "    }",
  "",
  "    method checkSeparator (c){",
  "        def ordval = c.ord",
  "        if (isBadSeparator(c)) then {",
  "            // Character is whitespace, but not an ASCII space or",
  "            // Unicode NO-BREAK SPACE.  For example, a tab",
  "",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.replaceChar(linePosition)with(\" \")onLine(lineNumber)",
  "            if (ordval == 9) then {",
  "                errormessages.syntaxError(\"tabs are not allowed; use spaces instead.\")atRange(lineNumber,",
  "                    linePosition, linePosition)withSuggestion(suggestion)",
  "            } else {",
  "                errormessages.syntaxError(\"{unicode.name(c)} (U+{padl(ordval.inBase 16, 4, \"0\")}) \"",
  "                    ++ \"is not a valid whitespace character; use spaces instead.\")atRange(lineNumber,",
  "                    linePosition, linePosition)withSuggestion(suggestion)",
  "            }",
  "        } elseif {isBadControl(c)} then {",
  "            // Character is a control character other than",
  "            // carriage return or line feed.",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.deleteChar(linePosition)onLine(lineNumber)",
  "            errormessages.syntaxError(\"{unicode.name(c)} (U+{padl(ordval.inBase 16, 4, \"0\")}) \"",
  "                ++ \"is a control character and cannot be written in the source code; consider using spaces instead.\")atRange(lineNumber,",
  "                linePosition, linePosition)withSuggestion(suggestion)",
  "        }",
  "    }",
  "",
  "    method fromBase(str, base) {",
  "        var val := 0",
  "        var i := 0",
  "        for (str) do {c->",
  "            def n = c.ord",
  "            val := val * base",
  "            var inc := 0",
  "            if ((n >= 48) && (n <= 57)) then {          // 48 = '0', 57 = '9'",
  "                inc := n - 48 // '0'",
  "            } elseif {(n >= 65) && (n <= 90)} then {    // 65 = 'A', 90 = 'Z'",
  "                inc := n - 55 // 'A' - 10",
  "            } else {",
  "                inc := n - 87 // 'a' - 10",
  "            }",
  "            if (inc >= base) then {",
  "                if((str.first == \"0\") && (inc < 16)) then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\"x\")atPosition(linePosition - str.size + 1)onLine(lineNumber)",
  "                    errormessages.syntaxError(\"a number in base 16 must start with '0x'.\")atPosition(",
  "                        lineNumber, linePosition - str.size + 1)withSuggestion(suggestion)",
  "                } else {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    if(str.size == 1) then {",
  "                        suggestion.deleteRange(linePosition - str.size - 1, linePosition - 1)onLine(lineNumber)",
  "                    } else {",
  "                        suggestion.deleteChar(linePosition - str.size + i)onLine(lineNumber)",
  "                    }",
  "                    def validDigits = if(base <= 10) then {",
  "                        \"'0' to '{base - 1}'\"",
  "                    } else {",
  "                        \"'0' to '9', 'a' to '{unicode.create(87 + base)}'\"",
  "                    }",
  "                    errormessages.syntaxError(\"'{c}' is not a valid digit in base {base}. Valid digits are {validDigits}.\")atRange(",
  "                        lineNumber, linePosition - str.size + i, linePosition - str.size + i)withSuggestion(suggestion)",
  "                }",
  "            }",
  "            val := val + inc",
  "            i := i + 1",
  "        }",
  "        val",
  "    }",
  "",
  "    method hexdecchar(c) {",
  "    // Return the numeric value of the single hexadecimal digit c.",
  "        def AOrd = \"A\".ord",
  "        def aOrd = \"a\".ord",
  "        def zeroOrd = \"0\".ord",
  "        def cOrd = c.ord",
  "        if ( (cOrd >= AOrd) && (cOrd <= \"F\".ord) ) then {",
  "            cOrd - AOrd + 10",
  "        } elseif { (cOrd >= aOrd) && (cOrd <= \"f\".ord) } then {",
  "            cOrd - aOrd + 10",
  "        } elseif { (cOrd >= zeroOrd) && (cOrd <= \"9\".ord) } then {",
  "            cOrd - zeroOrd",
  "        } else {",
  "            errormessages.syntaxError(\"the character '{c}' must be a hexadecimal digit\")",
  "                atRange(lineNumber, linePosition, linePosition)",
  "        }",
  "    }",
  "    // Read the program text from util.infile and return a list of",
  "    // tokens.",
  "    method lexfile(file) {",
  "        def lines = util.lines.makeEmpty",
  "        def cLines = util.cLines.makeEmpty",
  "            // making them empty is necessary for the browser,",
  "            // where these variables persist from one compilation",
  "            // to the next",
  "        var line := \"\"",
  "        var cLine := \"\"",
  "        var wasCR := false",
  "        for(file.read) do { c ->",
  "            if (c == \"\\r\") then {",
  "                lines.push(line)",
  "                cLines.push(cLine)",
  "                line := \"\"",
  "                cLine := \"\"",
  "                wasCR := true",
  "            } elseif {c  == \"\\n\"} then {",
  "                if (wasCR) then {",
  "                    // the spec says \"LINE FEED that immediately",
  "                    // follows a CARRIAGE RETURN is ignored\"",
  "                } else {",
  "                    lines.push(line)",
  "                    cLines.push(cLine)",
  "                    line := \"\"",
  "                    cLine := \"\"",
  "                }",
  "                wasCR := false",
  "            } elseif {c == \"\\l\"} then {",
  "                lines.push(line)",
  "                cLines.push(cLine)",
  "                line := \"\"",
  "                cLine := \"\"",
  "                wasCR := false",
  "            } elseif {c == \"\\\\\"} then {",
  "                line := line ++ c",
  "                cLine := cLine ++ \"\\\\\\\\\"",
  "                wasCR := false",
  "            } elseif {c == \"\\\"\"} then {",
  "                line := line ++ c",
  "                cLine := cLine ++ \"\\\\\\\"\"",
  "                wasCR := false",
  "            } else {",
  "                line := line ++ c",
  "                cLine := cLine ++ c",
  "                wasCR := false",
  "            }",
  "        }",
  "        if (line != \"\") then {",
  "            // this deals with an un-terminated final line",
  "            lines.push(line)",
  "            cLines.push(cLine)",
  "        }",
  "        lexinput(lines)",
  "    }",
  "",
  "    method lexinput(inputLines) {",
  "        // tokens is a doubly-linked list of tokens.",
  "        tokens := object {",
  "            var first is readable := false",
  "            var last is readable := false",
  "            var size is readable := 0",
  "",
  "            method savePosition {",
  "                return [first, last, size]",
  "            }",
  "",
  "            method restorePosition(saved) {",
  "                first := saved.first",
  "                last := saved.second",
  "                size := saved.third",
  "            }",
  "",
  "            method push(t) {",
  "                if(first == false) then {",
  "                    first := t",
  "                    last := t",
  "                } else {",
  "                    last.next := t",
  "                    t.prev := last",
  "                    if ((t.indent - last.indent).abs == 1) then {",
  "                        def m1 = \"the indentation for this line can't differ \"",
  "                        def m2 = \"from that of the previous line by 1.\\n  To start a block, or \"",
  "                        def m3 = \"continue a statement on the next line line, indent by 2 or more. \"",
  "                        def m4 = \"To end a block, or end the continuation, decrease the indent \"",
  "                        def m5 = \"to the prior level. \"",
  "                        def m6 = \"Otherwise, use the same indentation as the previous line.\"",
  "                        def msg = m1 ++ m2 ++ m3 ++ m4 ++ m5 ++ m6",
  "                        errormessages.syntaxError(msg) atRange(t.line, 1, t.indent)",
  "                    }",
  "                    last := t",
  "                }",
  "                size := size + 1",
  "            }",
  "",
  "            method pop {",
  "                if(last != false) then {",
  "                    def popped = last",
  "                    last := last.prev",
  "                    if(last == false) then {",
  "                        first := false",
  "                    }",
  "                    size := size - 1",
  "                    popped",
  "                }",
  "            }",
  "",
  "            method poll {",
  "                if(first != false) then {",
  "                    def polled = first",
  "                    first := first.next",
  "                    if(first == false) then {",
  "                        last := false",
  "                    }",
  "                    size := size - 1",
  "                    polled",
  "                }",
  "            }",
  "",
  "            class iterator {",
  "                var n := first",
  "                method hasNext {",
  "                    n != false",
  "                }",
  "                method next {",
  "                    def ret = n",
  "                    n := n.next",
  "                    ret",
  "                }",
  "            }",
  "",
  "            method do(action) {",
  "                var n := first",
  "                while { n != false } do {",
  "                    action.apply(n)",
  "                    n := n.next",
  "                }",
  "            }",
  "        }",
  "",
  "",
  "        linePosition := 0",
  "        util.log_verbose \"lexing.\"",
  "        state := startState",
  "        for (inputLines) do { eachLine ->",
  "            def charS = eachLine.iterator",
  "            while {charS.hasNext} do {",
  "                def ch = charS.next",
  "                linePosition := linePosition + 1",
  "                if (inStr.not && { \"><![]-\".contains(ch) } && charS.hasNext) then {",
  "                    // map to unicode equavalents",
  "                    def nextCh = charS.next",
  "                    linePosition := linePosition + 1",
  "                    def bigraph = ch ++ nextCh",
  "                    if (bigraph == \">=\") then { state.consume \"≥\"",
  "                    } elseif { bigraph == \"<=\" } then { state.consume \"≤\"",
  "                    } elseif { bigraph == \"!=\" } then { state.consume \"≠\"",
  "                    } elseif { bigraph == \"[[\" } then { state.consume \"⟦\"",
  "                    } elseif { bigraph == \"]]\" } then { state.consume \"⟧\"",
  "                    } elseif { bigraph == \"->\" } then { state.consume \"→\"",
  "                    } else {",
  "                        linePosition := linePosition - 1",
  "                        state.consume(ch)",
  "                        linePosition := linePosition + 1",
  "                        state.consume(nextCh)",
  "                    }",
  "                } else {",
  "                    state.consume(ch)",
  "                }",
  "            }",
  "            state.consume(\"\\n\")",
  "            linePosition := 0",
  "            lineNumber := lineNumber + 1",
  "        }",
  "        linePosition := linePosition + 1",
  "        if (inStr) then {",
  "            errormessages.syntaxError(\"a multi-line string must end with a '›'.\\n\" ++",
  "                \"String opened on line {startLine} and unclosed at end of input.\")",
  "                atRange(startLine, stringStart, util.lines.at(startLine).size)",
  "        }",
  "        tokens.push(eofToken)",
  "        tokens",
  "    }",
  "}",
  NULL
};
Object reader_lexer_outer_99(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_tokens_100(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_lexer_tokens_100(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_lexer_lineNumber_101(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_lexer_lineNumber_101(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_lexer_linePosition_102(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_lexer_linePosition_102(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_lexer_startPosition_103(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_lexer_startPosition_103(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_lexer_indentLevel_104(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_lexer_indentLevel_104(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_lexer_startLine_105(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_lexer_startLine_105(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_lexer_stringStart_106(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_lexer_stringStart_106(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_lexer_unichars_107(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_lexer_unichars_107(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_lexer_outer_110(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_line_111(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_indent_112(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_linePos_113(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_next_114(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_lexer_next_114(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_lexer_prev_115(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_lexer_prev_115(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_lexer_outer_216(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_217(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_218(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_219(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_230(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_231(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_232(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_233(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_257(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_258(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_259(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_260(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_line_39__261(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_lexer_linePos_39__262(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_lexer_outer_301(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_302(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_303(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_304(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_319(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_320(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_321(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_322(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_333(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_334(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_335(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_336(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_347(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_348(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_349(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_350(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_361(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_362(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_363(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_364(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_375(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_376(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_377(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_378(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_389(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_390(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_391(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_392(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_403(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_404(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_405(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_406(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_417(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_418(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_419(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_420(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_431(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_432(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_433(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_434(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_445(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_446(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_447(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_base_448(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_size_449(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_lexer_outer_473(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_474(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_475(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_476(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_487(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_488(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_489(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_490(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_501(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_502(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_503(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_504(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_515(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_516(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_517(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_518(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_529(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_530(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_531(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_532(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_543(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_544(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_545(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_546(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_557(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_558(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_559(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_560(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_571(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_572(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_573(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_574(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_state_583(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[32];
}
Object writer_lexer_state_583(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[32] = args[0];
  return done;
}
Object reader_lexer_accum_584(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[33];
}
Object writer_lexer_accum_584(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[33] = args[0];
  return done;
}
Object reader_lexer_inStr_585(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[34];
}
Object writer_lexer_inStr_585(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[34] = args[0];
  return done;
}
Object reader_lexer_escaped_586(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[35];
}
Object writer_lexer_escaped_586(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[35] = args[0];
  return done;
}
Object reader_lexer_codepoint_587(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[36];
}
Object writer_lexer_codepoint_587(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[36] = args[0];
  return done;
}
Object reader_lexer_interpdepth_588(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[37];
}
Object writer_lexer_interpdepth_588(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[37] = args[0];
  return done;
}
Object reader_lexer_interpString_589(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[38];
}
Object writer_lexer_interpString_589(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[38] = args[0];
  return done;
}
Object reader_lexer_startState_609(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[42];
}
Object reader_lexer_pragmaPrefixState_610(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[43];
}
Object reader_lexer_pragmaBodyState_611(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[44];
}
Object reader_lexer_pragmaTrailingWhitespaceState_612(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[45];
}
Object reader_lexer_defaultState_613(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[46];
}
Object reader_lexer_rBraceState_614(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[47];
}
Object reader_lexer_slashState_615(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[48];
}
Object reader_lexer_dotState_616(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[49];
}
Object reader_lexer_identifierState_617(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[50];
}
Object reader_lexer_quotedStringState_618(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[51];
}
Object reader_lexer_unicodeState_619(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[52];
}
Object reader_lexer_quotedStringEscapedState_620(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[53];
}
Object reader_lexer_extendedStringState_621(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[54];
}
Object reader_lexer_tokenBase_622(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[55];
}
Object writer_lexer_tokenBase_622(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[55] = args[0];
  return done;
}
Object reader_lexer_mantissa_623(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[56];
}
Object writer_lexer_mantissa_623(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[56] = args[0];
  return done;
}
Object reader_lexer_numberStartState_624(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[57];
}
Object reader_lexer_numberBaseState_625(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[58];
}
Object reader_lexer_numberDotState_626(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[59];
}
Object reader_lexer_numberFractionState_627(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[60];
}
Object reader_lexer_numberExponentSignState_628(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[61];
}
Object reader_lexer_numberExponentState_629(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[62];
}
Object reader_lexer_operatorState_630(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[63];
}
Object reader_lexer_indentationState_631(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[64];
}
Object reader_lexer_commentSpaceState_632(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[65];
}
Object reader_lexer_commentState_633(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[66];
}
Object reader_lexer_outer_1830(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_first_1831(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_lexer_first_1831(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_lexer_last_1832(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_lexer_last_1832(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_lexer_size_1833(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_lexer_size_1833(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_lexer_outer_1999(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_n_2000(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_lexer_n_2000(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_lexer_outer_2279(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_2313(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_2386(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_2434(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_2476(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_3026(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_3174(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_3244(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_3344(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_3465(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_3644(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_3713(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_3923(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_3960(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_4131(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_4214(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_4301(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_4395(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_4464(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_4607(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_4700(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_4728(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_4755(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
static Object strlit12;
static Object strlit27;
static Object strlit35;
static Object strlit50;
static Object strlit55;
static Object strlit69;
static ClassData objclass98;
static ClassData objclass109;
static Object strlit142;
static Object strlit149;
static Object strlit156;
static Object strlit163;
static Object strlit169;
static ClassData objclass215;
static Object strlit224;
static ClassData objclass229;
static Object strlit238;
static ClassData objclass256;
static Object strlit283;
static ClassData objclass300;
static Object strlit309;
static ClassData objclass318;
static Object strlit327;
static Object strlit328;
static ClassData objclass332;
static Object strlit341;
static Object strlit342;
static ClassData objclass346;
static Object strlit355;
static Object strlit356;
static ClassData objclass360;
static Object strlit369;
static Object strlit370;
static ClassData objclass374;
static Object strlit383;
static Object strlit384;
static ClassData objclass388;
static Object strlit397;
static Object strlit398;
static ClassData objclass402;
static Object strlit411;
static Object strlit412;
static ClassData objclass416;
static Object strlit425;
static Object strlit426;
static ClassData objclass430;
static Object strlit439;
static Object strlit440;
static ClassData objclass444;
static Object strlit454;
static ClassData objclass472;
static Object strlit481;
static ClassData objclass486;
static Object strlit495;
static ClassData objclass500;
static Object strlit509;
static Object strlit510;
static ClassData objclass514;
static Object strlit523;
static Object strlit524;
static ClassData objclass528;
static Object strlit537;
static Object strlit538;
static ClassData objclass542;
static Object strlit551;
static Object strlit552;
static ClassData objclass556;
static Object strlit565;
static Object strlit566;
static ClassData objclass570;
static Object strlit579;
static Object strlit580;
static Object strlit599;
static Object strlit654;
static Object strlit697;
static Object strlit720;
static Object strlit728;
static Object strlit748;
static Object strlit795;
static Object strlit811;
static Object strlit823;
static Object strlit868;
static Object strlit881;
static Object strlit894;
static Object strlit910;
static Object strlit922;
static Object strlit927;
static Object strlit943;
static Object strlit949;
static Object strlit951;
static Object strlit974;
static Object strlit988;
static Object strlit994;
static Object strlit997;
static Object strlit999;
static Object strlit1010;
static Object strlit1024;
static Object strlit1032;
static Object strlit1035;
static Object strlit1043;
static Object strlit1051;
static Object strlit1055;
static Object strlit1058;
static Object strlit1061;
static Object strlit1064;
static Object strlit1067;
static Object strlit1075;
static Object strlit1079;
static Object strlit1085;
static Object strlit1105;
static Object strlit1108;
static Object strlit1116;
static Object strlit1120;
static Object strlit1126;
static Object strlit1152;
static Object strlit1160;
static Object strlit1163;
static Object strlit1171;
static Object strlit1179;
static Object strlit1183;
static Object strlit1186;
static Object strlit1189;
static Object strlit1192;
static Object strlit1200;
static Object strlit1204;
static Object strlit1210;
static Object strlit1235;
static Object strlit1238;
static Object strlit1246;
static Object strlit1250;
static Object strlit1256;
static Object strlit1282;
static Object strlit1292;
static Object strlit1302;
static Object strlit1305;
static Object strlit1313;
static Object strlit1317;
static Object strlit1323;
static Object strlit1351;
static Object strlit1354;
static Object strlit1362;
static Object strlit1366;
static Object strlit1372;
static Object strlit1449;
static Object strlit1460;
static Object strlit1476;
static Object strlit1543;
static Object strlit1551;
static Object strlit1555;
static Object strlit1565;
static Object strlit1570;
static Object strlit1575;
static Object strlit1580;
static Object strlit1584;
static Object strlit1627;
static Object strlit1630;
static Object strlit1633;
static Object strlit1641;
static Object strlit1661;
static Object strlit1681;
static Object strlit1695;
static Object strlit1699;
static Object strlit1718;
static Object strlit1719;
static Object strlit1728;
static Object strlit1735;
static Object strlit1737;
static Object strlit1743;
static Object strlit1751;
static Object strlit1753;
static Object strlit1759;
static Object strlit1766;
static Object strlit1768;
static Object strlit1774;
static Object strlit1782;
static Object strlit1790;
static Object strlit1798;
static Object strlit1818;
static ClassData objclass1829;
static Object strlit1891;
static Object strlit1892;
static Object strlit1893;
static Object strlit1894;
static Object strlit1895;
static Object strlit1896;
static ClassData objclass1998;
static Object strlit2050;
static Object strlit2088;
static Object strlit2113;
static Object strlit2117;
static Object strlit2123;
static Object strlit2127;
static Object strlit2133;
static Object strlit2137;
static Object strlit2143;
static Object strlit2147;
static Object strlit2153;
static Object strlit2157;
static Object strlit2163;
static Object strlit2167;
static Object strlit2202;
static Object strlit2233;
static Object strlit2239;
static Object strlit2243;
static Object strlit2272;
static ClassData objclass2278;
static Object strlit2283;
static ClassData objclass2312;
static Object strlit2321;
static Object strlit2325;
static Object strlit2346;
static Object strlit2354;
static Object strlit2367;
static ClassData objclass2385;
static Object strlit2400;
static Object strlit2411;
static ClassData objclass2433;
static Object strlit2442;
static Object strlit2461;
static ClassData objclass2475;
static Object strlit2505;
static Object strlit2531;
static Object strlit2563;
static Object strlit2625;
static Object strlit2684;
static Object strlit2703;
static Object strlit2726;
static Object strlit2746;
static Object strlit2759;
static Object strlit2772;
static Object strlit2791;
static Object strlit2804;
static Object strlit2812;
static Object strlit2838;
static Object strlit2840;
static Object strlit2869;
static Object strlit2882;
static Object strlit2895;
static Object strlit2908;
static Object strlit2921;
static Object strlit2934;
static Object strlit2985;
static Object strlit2988;
static Object strlit2996;
static Object strlit3000;
static Object strlit3006;
static ClassData objclass3025;
static Object strlit3039;
static Object strlit3077;
static Object strlit3096;
static Object strlit3125;
static ClassData objclass3173;
static Object strlit3182;
static Object strlit3191;
static Object strlit3208;
static ClassData objclass3243;
static Object strlit3252;
static Object strlit3261;
static Object strlit3278;
static Object strlit3303;
static ClassData objclass3343;
static Object strlit3364;
static Object strlit3373;
static Object strlit3375;
static Object strlit3396;
static Object strlit3404;
static ClassData objclass3464;
static Object strlit3473;
static Object strlit3532;
static Object strlit3541;
static Object strlit3586;
static Object strlit3628;
static ClassData objclass3643;
static ClassData objclass3712;
static Object strlit3729;
static Object strlit3738;
static Object strlit3743;
static Object strlit3755;
static Object strlit3778;
static Object strlit3801;
static Object strlit3806;
static Object strlit3818;
static Object strlit3823;
static Object strlit3835;
static Object strlit3840;
static Object strlit3852;
static Object strlit3857;
static Object strlit3869;
static Object strlit3874;
static Object strlit3886;
static Object strlit3891;
static Object strlit3903;
static Object strlit3908;
static ClassData objclass3922;
static Object strlit3927;
static ClassData objclass3959;
static Object strlit3975;
static Object strlit4003;
static Object strlit4018;
static Object strlit4023;
static Object strlit4038;
static Object strlit4058;
static Object strlit4070;
static Object strlit4074;
static Object strlit4092;
static ClassData objclass4130;
static Object strlit4161;
static ClassData objclass4213;
static Object strlit4220;
static Object strlit4282;
static ClassData objclass4300;
static Object strlit4317;
static Object strlit4322;
static Object strlit4337;
static Object strlit4353;
static ClassData objclass4394;
static Object strlit4404;
static Object strlit4428;
static Object strlit4432;
static Object strlit4449;
static ClassData objclass4463;
static Object strlit4482;
static Object strlit4486;
static Object strlit4504;
static Object strlit4512;
static ClassData objclass4606;
static Object strlit4624;
static Object strlit4641;
static Object strlit4658;
static ClassData objclass4699;
static ClassData objclass4727;
static Object strlit4736;
static ClassData objclass4754;
static Object strlit4759;
Object module_util;
Object module_util_init();
Object module_unicode;
Object module_unicode_init();
Object module_errormessages;
Object module_errormessages_init();
Object module_stringMap;
Object module_stringMap_init();
static Object strlit4796;
static Object strlit4800;
static Object strlit4804;
static Object strlit4808;
static Object strlit4812;
static Object strlit4816;
static Object strlit4820;
static Object strlit4824;
static Object strlit4828;
static Object strlit4832;
static Object strlit4836;
static Object strlit4840;
static Object strlit4844;
static Object strlit4848;
static Object strlit4852;
static Object strlit4856;
static Object strlit4860;
static Object strlit4864;
static Object strlit4867;
static Object strlit4869;
static Object strlit4871;
static Object strlit4873;
static Object strlit4875;
static Object strlit4877;
static Object strlit4879;
static Object strlit4881;
static Object strlit4883;
Object meth_lexer_1_isOperatorChar_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "isOperatorChar(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method isOperatorChar(_,_)");
  Object params[2];
  int partcv[1];
  Object *var_operatorChars = getfromclosure(closure, 0);
  Object *var_unicode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isOperatorChar(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *var_ordval = &(stackframe->slots[1]);
  *var_ordval = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part isOperatorChar(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 29
  setline(29);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_operatorChars (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4 = callmethodflags(*var_operatorChars, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3);
// compiled call node returning call4 (depth = 3)
  Object if2 = done;
  if (istrue(call4)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool5 = alloc_Boolean(1);
// compiled identifier node returning bool5 (depth = 4)
  return bool5;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if2 = undefined;
  } else {
  }
// compiled if node returning if2 (depth = 2)
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ordval (depth = 4)
  gc_frame_newslot(*var_ordval);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unicode (depth = 4)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call8 = callmethodflags(*var_unicode, "isSymbolMathematical(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7);
// compiled call node returning call8 (depth = 3)
  Object if6 = done;
  if (istrue(call8)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool9 = alloc_Boolean(1);
// compiled identifier node returning bool9 (depth = 4)
  return bool9;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if6 = undefined;
  } else {
  }
// compiled if node returning if6 (depth = 2)
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// starting to compile string node (depth = 4)
  if (strlit12 == NULL) {
    strlit12 = alloc_String("So");
    gc_root(strlit12);
  }
// compiled string node returning strlit12 (depth = 4)
  gc_frame_newslot(strlit12);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unicode (depth = 4)
  params[0] = *var_c;
  params[1] = strlit12;
  partcv[0] = 2;
  Object call13 = callmethodflags(*var_unicode, "inCategory(2)", 1, partcv, params, 0);
  gc_frame_end(callframe11);
// compiled call node returning call13 (depth = 3)
  Object if10 = done;
  if (istrue(call13)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool14 = alloc_Boolean(1);
// compiled identifier node returning bool14 (depth = 4)
  return bool14;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if10 = undefined;
  } else {
  }
// compiled if node returning if10 (depth = 2)
// Begin line 32
  setline(32);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool15 = alloc_Boolean(0);
// compiled identifier node returning bool15 (depth = 3)
  return bool15;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_lexer_16_isBadSeparator_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "isBadSeparator(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method isBadSeparator(_)");
  Object params[2];
  int partcv[1];
  Object *var_spaceChars = getfromclosure(closure, 0);
  Object *var_tab = getfromclosure(closure, 1);
  Object *var_unicode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isBadSeparator(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ch = &(stackframe->slots[0]);
  *var_ch = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part isBadSeparator(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 38
  setline(38);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe18 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ch (depth = 4)
  gc_frame_newslot(*var_ch);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_spaceChars (depth = 4)
  params[0] = *var_ch;
  partcv[0] = 1;
  Object call19 = callmethodflags(*var_spaceChars, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe18);
// compiled call node returning call19 (depth = 3)
  Object if17 = done;
  if (istrue(call19)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool20 = alloc_Boolean(0);
// compiled identifier node returning bool20 (depth = 4)
  return bool20;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if17 = undefined;
  } else {
  }
// compiled if node returning if17 (depth = 2)
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ch (depth = 4)
  int op_slot_right_22 = gc_frame_newslot(*var_ch);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tab (depth = 4)
  int op_slot_left_22 = gc_frame_newslot(*var_tab);
  params[0] = *var_ch;
  partcv[0] = 1;
  Object opresult24 = callmethod(*var_tab, "==(1)", 1, partcv, params);
// compiled op node returning opresult24 (depth = 3)
  Object if21 = done;
  if (istrue(opresult24)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool25 = alloc_Boolean(1);
// compiled identifier node returning bool25 (depth = 4)
  return bool25;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if21 = undefined;
  } else {
  }
// compiled if node returning if21 (depth = 2)
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe26 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ch (depth = 4)
  gc_frame_newslot(*var_ch);
// starting to compile string node (depth = 4)
  if (strlit27 == NULL) {
    strlit27 = alloc_String("Z");
    gc_root(strlit27);
  }
// compiled string node returning strlit27 (depth = 4)
  gc_frame_newslot(strlit27);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unicode (depth = 4)
  params[0] = *var_ch;
  params[1] = strlit27;
  partcv[0] = 2;
  Object call28 = callmethodflags(*var_unicode, "inCategory(2)", 1, partcv, params, 0);
  gc_frame_end(callframe26);
// compiled call node returning call28 (depth = 3)
  return call28;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_lexer_29_isBadControl_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "isBadControl(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method isBadControl(_)");
  Object params[2];
  int partcv[1];
  Object *var_nl_cr = getfromclosure(closure, 0);
  Object *var_unicode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isBadControl(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ch = &(stackframe->slots[0]);
  *var_ch = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part isBadControl(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 45
  setline(45);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe31 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ch (depth = 4)
  gc_frame_newslot(*var_ch);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nl_cr (depth = 4)
  params[0] = *var_ch;
  partcv[0] = 1;
  Object call32 = callmethodflags(*var_nl_cr, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe31);
// compiled call node returning call32 (depth = 3)
  Object if30 = done;
  if (istrue(call32)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool33 = alloc_Boolean(0);
// compiled identifier node returning bool33 (depth = 4)
  return bool33;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if30 = undefined;
  } else {
  }
// compiled if node returning if30 (depth = 2)
// Begin line 46
  setline(46);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe34 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ch (depth = 4)
  gc_frame_newslot(*var_ch);
// starting to compile string node (depth = 4)
  if (strlit35 == NULL) {
    strlit35 = alloc_String("C");
    gc_root(strlit35);
  }
// compiled string node returning strlit35 (depth = 4)
  gc_frame_newslot(strlit35);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unicode (depth = 4)
  params[0] = *var_ch;
  params[1] = strlit35;
  partcv[0] = 2;
  Object call36 = callmethodflags(*var_unicode, "inCategory(2)", 1, partcv, params, 0);
  gc_frame_end(callframe34);
// compiled call node returning call36 (depth = 3)
  return call36;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_lexer_37_isSelfMode_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "isSelfMode(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method isSelfMode(_)");
  Object params[1];
  int partcv[1];
  Object *var_selfModes = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isSelfMode(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ch = &(stackframe->slots[0]);
  *var_ch = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part isSelfMode(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 2)
  int callframe38 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ch (depth = 3)
  gc_frame_newslot(*var_ch);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_selfModes (depth = 3)
  params[0] = *var_ch;
  partcv[0] = 1;
  Object call39 = callmethodflags(*var_selfModes, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe38);
// compiled call node returning call39 (depth = 2)
  gc_frame_end(frame);
  return call39;
}
Object meth_lexer_40_isBracket_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "isBracket(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method isBracket(_)");
  Object params[1];
  int partcv[1];
  Object *var_brackets = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isBracket(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ch = &(stackframe->slots[0]);
  *var_ch = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part isBracket(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 2)
  int callframe41 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ch (depth = 3)
  gc_frame_newslot(*var_ch);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_brackets (depth = 3)
  params[0] = *var_ch;
  partcv[0] = 1;
  Object call42 = callmethodflags(*var_brackets, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe41);
// compiled call node returning call42 (depth = 2)
  gc_frame_end(frame);
  return call42;
}
Object meth_lexer_43_isIdentifierChar_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "isIdentifierChar(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method isIdentifierChar(_)");
  Object params[2];
  int partcv[1];
  Object *var_alphaNums = getfromclosure(closure, 0);
  Object *var_unicode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isIdentifierChar(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ch = &(stackframe->slots[0]);
  *var_ch = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part isIdentifierChar(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe45 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ch (depth = 4)
  gc_frame_newslot(*var_ch);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_alphaNums (depth = 4)
  params[0] = *var_ch;
  partcv[0] = 1;
  Object call46 = callmethodflags(*var_alphaNums, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe45);
// compiled call node returning call46 (depth = 3)
  Object if44 = done;
  if (istrue(call46)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool47 = alloc_Boolean(1);
// compiled identifier node returning bool47 (depth = 4)
  return bool47;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if44 = undefined;
  } else {
  }
// compiled if node returning if44 (depth = 2)
// Begin line 58
  setline(58);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe49 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ch (depth = 4)
  gc_frame_newslot(*var_ch);
// starting to compile string node (depth = 4)
  if (strlit50 == NULL) {
    strlit50 = alloc_String("L");
    gc_root(strlit50);
  }
// compiled string node returning strlit50 (depth = 4)
  gc_frame_newslot(strlit50);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unicode (depth = 4)
  params[0] = *var_ch;
  params[1] = strlit50;
  partcv[0] = 2;
  Object call51 = callmethodflags(*var_unicode, "inCategory(2)", 1, partcv, params, 0);
  gc_frame_end(callframe49);
// compiled call node returning call51 (depth = 3)
  Object if48 = done;
  if (istrue(call51)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool52 = alloc_Boolean(1);
// compiled identifier node returning bool52 (depth = 4)
  return bool52;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if48 = undefined;
  } else {
  }
// compiled if node returning if48 (depth = 2)
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe54 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ch (depth = 4)
  gc_frame_newslot(*var_ch);
// starting to compile string node (depth = 4)
  if (strlit55 == NULL) {
    strlit55 = alloc_String("N");
    gc_root(strlit55);
  }
// compiled string node returning strlit55 (depth = 4)
  gc_frame_newslot(strlit55);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unicode (depth = 4)
  params[0] = *var_ch;
  params[1] = strlit55;
  partcv[0] = 2;
  Object call56 = callmethodflags(*var_unicode, "inCategory(2)", 1, partcv, params, 0);
  gc_frame_end(callframe54);
// compiled call node returning call56 (depth = 3)
  Object if53 = done;
  if (istrue(call56)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool57 = alloc_Boolean(1);
// compiled identifier node returning bool57 (depth = 4)
  return bool57;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if53 = undefined;
  } else {
  }
// compiled if node returning if53 (depth = 2)
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool58 = alloc_Boolean(0);
// compiled identifier node returning bool58 (depth = 3)
  return bool58;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_lexer_59_isDigit_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "isDigit(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method isDigit(_)");
  Object params[1];
  int partcv[1];
  Object *var_digits = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isDigit(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ch = &(stackframe->slots[0]);
  *var_ch = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part isDigit(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 2)
  int callframe60 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ch (depth = 3)
  gc_frame_newslot(*var_ch);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_digits (depth = 3)
  params[0] = *var_ch;
  partcv[0] = 1;
  Object call61 = callmethodflags(*var_digits, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe60);
// compiled call node returning call61 (depth = 2)
  gc_frame_end(frame);
  return call61;
}
Object meth_lexer_62_isLetter_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "isLetter(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method isLetter(_)");
  Object params[2];
  int partcv[1];
  Object *var_asciiLetters = getfromclosure(closure, 0);
  Object *var_unicode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isLetter(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ch = &(stackframe->slots[0]);
  *var_ch = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part isLetter(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe64 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ch (depth = 4)
  gc_frame_newslot(*var_ch);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_asciiLetters (depth = 4)
  params[0] = *var_ch;
  partcv[0] = 1;
  Object call65 = callmethodflags(*var_asciiLetters, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe64);
// compiled call node returning call65 (depth = 3)
  Object if63 = done;
  if (istrue(call65)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool66 = alloc_Boolean(1);
// compiled identifier node returning bool66 (depth = 4)
  return bool66;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if63 = undefined;
  } else {
  }
// compiled if node returning if63 (depth = 2)
// Begin line 68
  setline(68);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe68 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ch (depth = 4)
  gc_frame_newslot(*var_ch);
// starting to compile string node (depth = 4)
  if (strlit69 == NULL) {
    strlit69 = alloc_String("L");
    gc_root(strlit69);
  }
// compiled string node returning strlit69 (depth = 4)
  gc_frame_newslot(strlit69);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unicode (depth = 4)
  params[0] = *var_ch;
  params[1] = strlit69;
  partcv[0] = 2;
  Object call70 = callmethodflags(*var_unicode, "inCategory(2)", 1, partcv, params, 0);
  gc_frame_end(callframe68);
// compiled call node returning call70 (depth = 3)
  Object if67 = done;
  if (istrue(call70)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool71 = alloc_Boolean(1);
// compiled identifier node returning bool71 (depth = 4)
  return bool71;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if67 = undefined;
  } else {
  }
// compiled if node returning if67 (depth = 2)
// Begin line 69
  setline(69);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool72 = alloc_Boolean(0);
// compiled identifier node returning bool72 (depth = 3)
  return bool72;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_lexer_82__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_l = getfromclosure(closure, 0);
  Object *var_s_39_ = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_l (depth = 5)
  int op_slot_right_83 = gc_frame_newslot(*var_l);
// starting to compile member node (depth = 5)
  int callframe85 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s_39_ (depth = 6)
  partcv[0] = 0;
  Object call86 = callmethodflags(*var_s_39_, "size", 1, partcv, params, 0);
  gc_frame_end(callframe85);
// compiled member node returning call86 (depth = 5)
  int op_slot_left_83 = gc_frame_newslot(call86);
  params[0] = *var_l;
  partcv[0] = 1;
  Object opresult87 = callmethod(call86, "<(1)", 1, partcv, params);
// compiled op node returning opresult87 (depth = 4)
  gc_frame_end(frame);
  return opresult87;
}
Object meth_lexer_90__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s_39_ = getfromclosure(closure, 0);
  Object *var_w = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s_39_ (depth = 6)
  int op_slot_right_91 = gc_frame_newslot(*var_s_39_);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_w (depth = 6)
  int op_slot_left_91 = gc_frame_newslot(*var_w);
  params[0] = *var_s_39_;
  partcv[0] = 1;
  Object opresult93 = callmethod(*var_w, "++(1)", 1, partcv, params);
// compiled op node returning opresult93 (depth = 5)
  *var_s_39_ = opresult93;
  if (opresult93 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer_73_padl_40_3_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "padl(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method padl(_,_,_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for padl(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  Object *var_w = &(stackframe->slots[2]);
  *var_w = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part padl(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_s_39_ = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "s'");
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_l (depth = 4)
  int op_slot_right_75 = gc_frame_newslot(*var_l);
// starting to compile member node (depth = 4)
  int callframe77 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  partcv[0] = 0;
  Object call78 = callmethodflags(*var_s, "size", 1, partcv, params, 0);
  gc_frame_end(callframe77);
// compiled member node returning call78 (depth = 4)
  int op_slot_left_75 = gc_frame_newslot(call78);
  params[0] = *var_l;
  partcv[0] = 1;
  Object opresult79 = callmethod(call78, "≥(1)", 1, partcv, params);
// compiled op node returning opresult79 (depth = 3)
  Object if74 = done;
  if (istrue(opresult79)) {
// Begin line 74
  setline(74);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  return *var_s;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if74 = undefined;
  } else {
  }
// compiled if node returning if74 (depth = 2)
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  *var_s_39_ = *var_s;
  if (*var_s == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 77
  setline(77);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe80 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block81 = alloc_Block(NULL, NULL, "lexer", 77);
  gc_frame_newslot(block81);
// method "_apply"
  block_savedest(block81);
  Object closure82 = createclosure(3, "_apply");
  setclosureframe(closure82, stackframe);
  addtoclosure(closure82, var_l);
  addtoclosure(closure82, var_s_39_);
  addtoclosure(closure82, selfslot);
  struct UserObject *uo82 = (struct UserObject*)block81;
  uo82->data[0] = (Object)closure82;
  Method *meth_meth_lexer_82__apply = addmethod2pos(block81, "_apply", &meth_lexer_82__apply, 0);
  int argcv_meth_lexer_82__apply[] = {0};
  meth_meth_lexer_82__apply->type = alloc_MethodType(1, argcv_meth_lexer_82__apply);
  meth_meth_lexer_82__apply->definitionModule = modulename;
  meth_meth_lexer_82__apply->definitionLine = 1145;
// compiled block node returning block81 (depth = 3)
  gc_frame_newslot(block81);
// starting to compile block node (depth = 3)
  Object block89 = alloc_Block(NULL, NULL, "lexer", 77);
  gc_frame_newslot(block89);
// method "_apply"
  block_savedest(block89);
  Object closure90 = createclosure(3, "_apply");
  setclosureframe(closure90, stackframe);
  addtoclosure(closure90, var_s_39_);
  addtoclosure(closure90, var_w);
  addtoclosure(closure90, selfslot);
  struct UserObject *uo90 = (struct UserObject*)block89;
  uo90->data[0] = (Object)closure90;
  Method *meth_meth_lexer_90__apply = addmethod2pos(block89, "_apply", &meth_lexer_90__apply, 0);
  int argcv_meth_lexer_90__apply[] = {0};
  meth_meth_lexer_90__apply->type = alloc_MethodType(1, argcv_meth_lexer_90__apply);
  meth_meth_lexer_90__apply->definitionModule = modulename;
  meth_meth_lexer_90__apply->definitionLine = 1145;
// compiled block node returning block89 (depth = 3)
  gc_frame_newslot(block89);
// call case 5: prelude request
  params[0] = block81;
  params[1] = block89;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call96 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe80);
// compiled call node returning call96 (depth = 2)
// Begin line 80
  setline(80);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s_39_ (depth = 3)
  return *var_s_39_;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_lexer_116__61__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  int op_slot_right_118 = gc_frame_newslot(*var_other);
// starting to compile identifier node (depth = 4)
  Object bool120 = alloc_Boolean(0);
// compiled identifier node returning bool120 (depth = 4)
  int op_slot_left_118 = gc_frame_newslot(bool120);
  params[0] = *var_other;
  partcv[0] = 1;
  Object opresult121 = callmethod(bool120, "==(1)", 1, partcv, params);
// compiled op node returning opresult121 (depth = 3)
  Object if117 = done;
  if (istrue(opresult121)) {
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool122 = alloc_Boolean(0);
// compiled identifier node returning bool122 (depth = 3)
    gc_frame_newslot(bool122);
    if117 = bool122;
  } else {
// Begin line 104
  setline(104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe125 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call126 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe125);
// compiled member node returning call126 (depth = 5)
  int op_slot_right_124 = gc_frame_newslot(call126);
// starting to compile member node (depth = 5)
  int callframe128 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call129 = callmethodflags(*var_other, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe128);
// compiled member node returning call129 (depth = 5)
  int op_slot_left_124 = gc_frame_newslot(call129);
  params[0] = call126;
  partcv[0] = 1;
  Object opresult130 = callmethod(call129, "==(1)", 1, partcv, params);
// compiled op node returning opresult130 (depth = 4)
  int op_slot_right_123 = gc_frame_newslot(opresult130);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe133 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call134 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe133);
// compiled member node returning call134 (depth = 5)
  int op_slot_right_132 = gc_frame_newslot(call134);
// starting to compile member node (depth = 5)
  int callframe136 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call137 = callmethodflags(*var_other, "line", 1, partcv, params, 0);
  gc_frame_end(callframe136);
// compiled member node returning call137 (depth = 5)
  int op_slot_left_132 = gc_frame_newslot(call137);
  params[0] = call134;
  partcv[0] = 1;
  Object opresult138 = callmethod(call137, "==(1)", 1, partcv, params);
// compiled op node returning opresult138 (depth = 4)
  int op_slot_left_123 = gc_frame_newslot(opresult138);
  params[0] = opresult130;
  partcv[0] = 1;
  Object opresult139 = callmethod(opresult138, "&&(1)", 1, partcv, params);
// compiled op node returning opresult139 (depth = 3)
    gc_frame_newslot(opresult139);
    if117 = opresult139;
  }
// compiled if node returning if117 (depth = 2)
  gc_frame_end(frame);
  return if117;
}
Object meth_lexer_140_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 107
  setline(107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit142 == NULL) {
    strlit142 = alloc_String("");
    gc_root(strlit142);
  }
// compiled string node returning strlit142 (depth = 3)
  int op_slot_right_141 = gc_frame_newslot(strlit142);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe145 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call146 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe145);
// compiled member node returning call146 (depth = 4)
  int op_slot_right_144 = gc_frame_newslot(call146);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit149 == NULL) {
    strlit149 = alloc_String(" ");
    gc_root(strlit149);
  }
// compiled string node returning strlit149 (depth = 5)
  int op_slot_right_148 = gc_frame_newslot(strlit149);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe152 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call153 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe152);
// compiled member node returning call153 (depth = 6)
  int op_slot_right_151 = gc_frame_newslot(call153);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit156 == NULL) {
    strlit156 = alloc_String(")");
    gc_root(strlit156);
  }
// compiled string node returning strlit156 (depth = 7)
  int op_slot_right_155 = gc_frame_newslot(strlit156);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe159 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call160 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe159);
// compiled member node returning call160 (depth = 8)
  int op_slot_right_158 = gc_frame_newslot(call160);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit163 == NULL) {
    strlit163 = alloc_String(":");
    gc_root(strlit163);
  }
// compiled string node returning strlit163 (depth = 9)
  int op_slot_right_162 = gc_frame_newslot(strlit163);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe166 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call167 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe166);
// compiled member node returning call167 (depth = 10)
  int op_slot_right_165 = gc_frame_newslot(call167);
// starting to compile string node (depth = 10)
  if (strlit169 == NULL) {
    strlit169 = alloc_String("(");
    gc_root(strlit169);
  }
// compiled string node returning strlit169 (depth = 10)
  int op_slot_left_165 = gc_frame_newslot(strlit169);
  params[0] = call167;
  partcv[0] = 1;
  Object opresult170 = callmethod(strlit169, "++(1)", 1, partcv, params);
// compiled op node returning opresult170 (depth = 9)
  int op_slot_left_162 = gc_frame_newslot(opresult170);
  params[0] = strlit163;
  partcv[0] = 1;
  Object opresult171 = callmethod(opresult170, "++(1)", 1, partcv, params);
// compiled op node returning opresult171 (depth = 8)
  int op_slot_left_158 = gc_frame_newslot(opresult171);
  params[0] = call160;
  partcv[0] = 1;
  Object opresult172 = callmethod(opresult171, "++(1)", 1, partcv, params);
// compiled op node returning opresult172 (depth = 7)
  int op_slot_left_155 = gc_frame_newslot(opresult172);
  params[0] = strlit156;
  partcv[0] = 1;
  Object opresult173 = callmethod(opresult172, "++(1)", 1, partcv, params);
// compiled op node returning opresult173 (depth = 6)
  int op_slot_left_151 = gc_frame_newslot(opresult173);
  params[0] = call153;
  partcv[0] = 1;
  Object opresult174 = callmethod(opresult173, "++(1)", 1, partcv, params);
// compiled op node returning opresult174 (depth = 5)
  int op_slot_left_148 = gc_frame_newslot(opresult174);
  params[0] = strlit149;
  partcv[0] = 1;
  Object opresult175 = callmethod(opresult174, "++(1)", 1, partcv, params);
// compiled op node returning opresult175 (depth = 4)
  int op_slot_left_144 = gc_frame_newslot(opresult175);
  params[0] = call146;
  partcv[0] = 1;
  Object opresult176 = callmethod(opresult175, "++(1)", 1, partcv, params);
// compiled op node returning opresult176 (depth = 3)
  int op_slot_left_141 = gc_frame_newslot(opresult176);
  params[0] = strlit142;
  partcv[0] = 1;
  Object opresult177 = callmethod(opresult176, "++(1)", 1, partcv, params);
// compiled op node returning opresult177 (depth = 2)
  gc_frame_end(frame);
  return opresult177;
}
Object meth_lexer_178_value(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "value");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 108
  setline(108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe179 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call180 = callmethodflags(prelude, "abstract", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe179);
// compiled member node returning call180 (depth = 2)
  gc_frame_end(frame);
  return call180;
}
Object meth_lexer_181_size(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 109
  setline(109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe182 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call183 = callmethodflags(prelude, "abstract", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe182);
// compiled member node returning call183 (depth = 2)
  gc_frame_end(frame);
  return call183;
}
Object meth_lexer_184_kind(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "kind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe185 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call186 = callmethodflags(prelude, "abstract", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe185);
// compiled member node returning call186 (depth = 2)
  gc_frame_end(frame);
  return call186;
}
Object meth_lexer_187_endPos(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "endPos");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile num node (depth = 3)
  Object num189 = alloc_Float64(1);
// compiled num node returning num189 (depth = 3)
  int op_slot_right_188 = gc_frame_newslot(num189);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe192 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call193 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe192);
// compiled member node returning call193 (depth = 4)
  int op_slot_right_191 = gc_frame_newslot(call193);
// starting to compile member node (depth = 4)
  int callframe195 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call196 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe195);
// compiled member node returning call196 (depth = 4)
  int op_slot_left_191 = gc_frame_newslot(call196);
  params[0] = call193;
  partcv[0] = 1;
  Object sum197 = callmethod(call196, "+(1)", 1, partcv, params);
// compiled op node returning sum197 (depth = 3)
  int op_slot_left_188 = gc_frame_newslot(sum197);
  params[0] = num189;
  partcv[0] = 1;
  Object diff198 = callmethod(sum197, "-(1)", 1, partcv, params);
// compiled op node returning diff198 (depth = 2)
  gc_frame_end(frame);
  return diff198;
}
Object meth_lexer_108_token(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "token");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject109 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj109 = alloc_userobj2(13,12, objclass109);
  gc_frame_newslot(obj109);
  if (objclass109 == NULL) {
    glfree(obj109->class->name);
    obj109->class->name = "new.token";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj109, self, 0);
  addmethodreal(obj109,"outer", &reader_lexer_outer_110);
  Object oldself109 = self;
  struct StackFrameObject *oldstackframe109 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe109);
  gc_frame_newslot((Object)stackframe);
  self = obj109;
  Object *oldselfslot109 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter109 = (*(struct UserObject *)self).data[0], lowerouter109 = thisouter109;
  if (inheritingObject109) {
    struct UserObject *inho109 = (struct UserObject *)inheritingObject109;
    while (inho109->super != GraceDefaultObject) inho109 = (struct UserObject *)inho109->super;
    inho109->super = obj109;
    self = inheritingObject109;
    *selfslot = self;
    lowerouter109 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter109;
  }
  if (objclass109 == NULL) {
  Method *reader111 = addmethodrealflags(obj109, "line",&reader_lexer_line_111, MFLAG_DEF);
  reader111->definitionModule = modulename;
  reader111->definitionLine = 93;
  }
  adddatum2(obj109, alloc_Undefined(), 1);
  if (objclass109 == NULL) {
  Method *reader112 = addmethodrealflags(obj109, "indent",&reader_lexer_indent_112, MFLAG_DEF);
  reader112->definitionModule = modulename;
  reader112->definitionLine = 94;
  }
  adddatum2(obj109, alloc_Undefined(), 2);
  if (objclass109 == NULL) {
  Method *reader113 = addmethodrealflags(obj109, "linePos",&reader_lexer_linePos_113, MFLAG_DEF);
  reader113->definitionModule = modulename;
  reader113->definitionLine = 95;
  }
  adddatum2(obj109, alloc_Undefined(), 3);
  if (objclass109 == NULL) {
    Method *reader114 = addmethodrealflags(obj109, "next", &reader_lexer_next_114, 0);
    Method *writer114 = addmethodrealflags(obj109, "next:=(1)", &writer_lexer_next_114, 0);
    reader114->definitionModule = modulename;
    writer114->definitionModule = modulename;
    reader114->definitionLine = 97;
    writer114->definitionLine = 97;
  }
  obj109->flags |= OFLAG_MUTABLE;
  adddatum2(obj109, alloc_Undefined(), 4);
  if (objclass109 == NULL) {
    Method *reader115 = addmethodrealflags(obj109, "prev", &reader_lexer_prev_115, 0);
    Method *writer115 = addmethodrealflags(obj109, "prev:=(1)", &writer_lexer_prev_115, 0);
    reader115->definitionModule = modulename;
    writer115->definitionModule = modulename;
    reader115->definitionLine = 98;
    writer115->definitionLine = 98;
  }
  obj109->flags |= OFLAG_MUTABLE;
  adddatum2(obj109, alloc_Undefined(), 5);
// method "==(_)"
  struct UserObject *uo116 = (struct UserObject*)obj109;
  uo116->data[6] = emptyclosure;
  Method *meth_meth_lexer_116__61__61__40_1_41_ = addmethod2pos(obj109, "==(1)", &meth_lexer_116__61__61__40_1_41_, 6);
  int argcv_meth_lexer_116__61__61__40_1_41_[] = {1};
  meth_meth_lexer_116__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_116__61__61__40_1_41_);
  meth_meth_lexer_116__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_lexer_116__61__61__40_1_41_->definitionLine = 100;
// method "asString"
  struct UserObject *uo140 = (struct UserObject*)obj109;
  uo140->data[7] = emptyclosure;
  Method *meth_meth_lexer_140_asString = addmethod2pos(obj109, "asString", &meth_lexer_140_asString, 7);
  int argcv_meth_lexer_140_asString[] = {0};
  meth_meth_lexer_140_asString->type = alloc_MethodType(1, argcv_meth_lexer_140_asString);
  meth_meth_lexer_140_asString->definitionModule = modulename;
  meth_meth_lexer_140_asString->definitionLine = 107;
// method "value"
  struct UserObject *uo178 = (struct UserObject*)obj109;
  uo178->data[8] = emptyclosure;
  Method *meth_meth_lexer_178_value = addmethod2pos(obj109, "value", &meth_lexer_178_value, 8);
  int argcv_meth_lexer_178_value[] = {0};
  meth_meth_lexer_178_value->type = alloc_MethodType(1, argcv_meth_lexer_178_value);
  meth_meth_lexer_178_value->definitionModule = modulename;
  meth_meth_lexer_178_value->definitionLine = 108;
// method "size"
  struct UserObject *uo181 = (struct UserObject*)obj109;
  uo181->data[9] = emptyclosure;
  Method *meth_meth_lexer_181_size = addmethod2pos(obj109, "size", &meth_lexer_181_size, 9);
  int argcv_meth_lexer_181_size[] = {0};
  meth_meth_lexer_181_size->type = alloc_MethodType(1, argcv_meth_lexer_181_size);
  meth_meth_lexer_181_size->definitionModule = modulename;
  meth_meth_lexer_181_size->definitionLine = 109;
// method "kind"
  struct UserObject *uo184 = (struct UserObject*)obj109;
  uo184->data[10] = emptyclosure;
  Method *meth_meth_lexer_184_kind = addmethod2pos(obj109, "kind", &meth_lexer_184_kind, 10);
  int argcv_meth_lexer_184_kind[] = {0};
  meth_meth_lexer_184_kind->type = alloc_MethodType(1, argcv_meth_lexer_184_kind);
  meth_meth_lexer_184_kind->definitionModule = modulename;
  meth_meth_lexer_184_kind->definitionLine = 110;
// method "endPos"
  struct UserObject *uo187 = (struct UserObject*)obj109;
  uo187->data[11] = emptyclosure;
  Method *meth_meth_lexer_187_endPos = addmethod2pos(obj109, "endPos", &meth_lexer_187_endPos, 11);
  int argcv_meth_lexer_187_endPos[] = {0};
  meth_meth_lexer_187_endPos->type = alloc_MethodType(1, argcv_meth_lexer_187_endPos);
  meth_meth_lexer_187_endPos->definitionModule = modulename;
  meth_meth_lexer_187_endPos->definitionLine = 111;
  sourceObject = obj109;
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe199 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe200 = gc_frame_new();
// call case 3: self.outer request
  Object call201 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe200);
// compiled member node returning call201 (depth = 3)
  partcv[0] = 0;
  Object call202 = callmethodflags(call201, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe199);
// compiled member node returning call202 (depth = 2)
  adddatum2(obj109, call202, 1);
  sourceObject = obj109;
// Begin line 94
  setline(94);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe203 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe204 = gc_frame_new();
// call case 3: self.outer request
  Object call205 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe204);
// compiled member node returning call205 (depth = 3)
  partcv[0] = 0;
  Object call206 = callmethodflags(call205, "indentLevel", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe203);
// compiled member node returning call206 (depth = 2)
  adddatum2(obj109, call206, 2);
  sourceObject = obj109;
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe207 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe208 = gc_frame_new();
// call case 3: self.outer request
  Object call209 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe208);
// compiled member node returning call209 (depth = 3)
  partcv[0] = 0;
  Object call210 = callmethodflags(call209, "startPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe207);
// compiled member node returning call210 (depth = 2)
  adddatum2(obj109, call210, 3);
  sourceObject = obj109;
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool211 = alloc_Boolean(0);
// compiled identifier node returning bool211 (depth = 2)
  adddatum2(obj109, bool211, 4);
  sourceObject = obj109;
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool212 = alloc_Boolean(0);
// compiled identifier node returning bool212 (depth = 2)
  adddatum2(obj109, bool212, 5);
  sourceObject = obj109;
  sourceObject = obj109;
  sourceObject = obj109;
  sourceObject = obj109;
  sourceObject = obj109;
  sourceObject = obj109;
  objclass109 = obj109->class;
  objclass109->definitionModule = modulename;
  objclass109->definitionLine = 92;
  (*(struct UserObject *)self).data[0] = lowerouter109;
  self = oldself109;
  selfslot = oldselfslot109;
  stackframe = oldstackframe109;
  gc_frame_end(frame);
  return obj109;
}
Object meth_lexer_108_token_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "token$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject109 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj109 = alloc_userobj2(13,12, objclass109);
  gc_frame_newslot(obj109);
  if (objclass109 == NULL) {
    glfree(obj109->class->name);
    obj109->class->name = "new.token";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj109, self, 0);
  addmethodreal(obj109,"outer", &reader_lexer_outer_110);
  Object oldself109 = self;
  struct StackFrameObject *oldstackframe109 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe109);
  gc_frame_newslot((Object)stackframe);
  self = obj109;
  Object *oldselfslot109 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter109 = (*(struct UserObject *)self).data[0], lowerouter109 = thisouter109;
  if (inheritingObject109) {
    struct UserObject *inho109 = (struct UserObject *)inheritingObject109;
    while (inho109->super != GraceDefaultObject) inho109 = (struct UserObject *)inho109->super;
    inho109->super = obj109;
    self = inheritingObject109;
    *selfslot = self;
    lowerouter109 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter109;
  }
  if (objclass109 == NULL) {
  Method *reader111 = addmethodrealflags(obj109, "line",&reader_lexer_line_111, MFLAG_DEF);
  reader111->definitionModule = modulename;
  reader111->definitionLine = 93;
  }
  adddatum2(obj109, alloc_Undefined(), 1);
  if (objclass109 == NULL) {
  Method *reader112 = addmethodrealflags(obj109, "indent",&reader_lexer_indent_112, MFLAG_DEF);
  reader112->definitionModule = modulename;
  reader112->definitionLine = 94;
  }
  adddatum2(obj109, alloc_Undefined(), 2);
  if (objclass109 == NULL) {
  Method *reader113 = addmethodrealflags(obj109, "linePos",&reader_lexer_linePos_113, MFLAG_DEF);
  reader113->definitionModule = modulename;
  reader113->definitionLine = 95;
  }
  adddatum2(obj109, alloc_Undefined(), 3);
  if (objclass109 == NULL) {
    Method *reader114 = addmethodrealflags(obj109, "next", &reader_lexer_next_114, 0);
    Method *writer114 = addmethodrealflags(obj109, "next:=(1)", &writer_lexer_next_114, 0);
    reader114->definitionModule = modulename;
    writer114->definitionModule = modulename;
    reader114->definitionLine = 97;
    writer114->definitionLine = 97;
  }
  obj109->flags |= OFLAG_MUTABLE;
  adddatum2(obj109, alloc_Undefined(), 4);
  if (objclass109 == NULL) {
    Method *reader115 = addmethodrealflags(obj109, "prev", &reader_lexer_prev_115, 0);
    Method *writer115 = addmethodrealflags(obj109, "prev:=(1)", &writer_lexer_prev_115, 0);
    reader115->definitionModule = modulename;
    writer115->definitionModule = modulename;
    reader115->definitionLine = 98;
    writer115->definitionLine = 98;
  }
  obj109->flags |= OFLAG_MUTABLE;
  adddatum2(obj109, alloc_Undefined(), 5);
// method "==(_)"
  struct UserObject *uo116 = (struct UserObject*)obj109;
  uo116->data[6] = emptyclosure;
  Method *meth_meth_lexer_116__61__61__40_1_41_ = addmethod2pos(obj109, "==(1)", &meth_lexer_116__61__61__40_1_41_, 6);
  int argcv_meth_lexer_116__61__61__40_1_41_[] = {1};
  meth_meth_lexer_116__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_116__61__61__40_1_41_);
  meth_meth_lexer_116__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_lexer_116__61__61__40_1_41_->definitionLine = 100;
// method "asString"
  struct UserObject *uo140 = (struct UserObject*)obj109;
  uo140->data[7] = emptyclosure;
  Method *meth_meth_lexer_140_asString = addmethod2pos(obj109, "asString", &meth_lexer_140_asString, 7);
  int argcv_meth_lexer_140_asString[] = {0};
  meth_meth_lexer_140_asString->type = alloc_MethodType(1, argcv_meth_lexer_140_asString);
  meth_meth_lexer_140_asString->definitionModule = modulename;
  meth_meth_lexer_140_asString->definitionLine = 107;
// method "value"
  struct UserObject *uo178 = (struct UserObject*)obj109;
  uo178->data[8] = emptyclosure;
  Method *meth_meth_lexer_178_value = addmethod2pos(obj109, "value", &meth_lexer_178_value, 8);
  int argcv_meth_lexer_178_value[] = {0};
  meth_meth_lexer_178_value->type = alloc_MethodType(1, argcv_meth_lexer_178_value);
  meth_meth_lexer_178_value->definitionModule = modulename;
  meth_meth_lexer_178_value->definitionLine = 108;
// method "size"
  struct UserObject *uo181 = (struct UserObject*)obj109;
  uo181->data[9] = emptyclosure;
  Method *meth_meth_lexer_181_size = addmethod2pos(obj109, "size", &meth_lexer_181_size, 9);
  int argcv_meth_lexer_181_size[] = {0};
  meth_meth_lexer_181_size->type = alloc_MethodType(1, argcv_meth_lexer_181_size);
  meth_meth_lexer_181_size->definitionModule = modulename;
  meth_meth_lexer_181_size->definitionLine = 109;
// method "kind"
  struct UserObject *uo184 = (struct UserObject*)obj109;
  uo184->data[10] = emptyclosure;
  Method *meth_meth_lexer_184_kind = addmethod2pos(obj109, "kind", &meth_lexer_184_kind, 10);
  int argcv_meth_lexer_184_kind[] = {0};
  meth_meth_lexer_184_kind->type = alloc_MethodType(1, argcv_meth_lexer_184_kind);
  meth_meth_lexer_184_kind->definitionModule = modulename;
  meth_meth_lexer_184_kind->definitionLine = 110;
// method "endPos"
  struct UserObject *uo187 = (struct UserObject*)obj109;
  uo187->data[11] = emptyclosure;
  Method *meth_meth_lexer_187_endPos = addmethod2pos(obj109, "endPos", &meth_lexer_187_endPos, 11);
  int argcv_meth_lexer_187_endPos[] = {0};
  meth_meth_lexer_187_endPos->type = alloc_MethodType(1, argcv_meth_lexer_187_endPos);
  meth_meth_lexer_187_endPos->definitionModule = modulename;
  meth_meth_lexer_187_endPos->definitionLine = 111;
  sourceObject = obj109;
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe199 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe200 = gc_frame_new();
// call case 3: self.outer request
  Object call201 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe200);
// compiled member node returning call201 (depth = 3)
  partcv[0] = 0;
  Object call202 = callmethodflags(call201, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe199);
// compiled member node returning call202 (depth = 2)
  adddatum2(obj109, call202, 1);
  sourceObject = obj109;
// Begin line 94
  setline(94);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe203 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe204 = gc_frame_new();
// call case 3: self.outer request
  Object call205 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe204);
// compiled member node returning call205 (depth = 3)
  partcv[0] = 0;
  Object call206 = callmethodflags(call205, "indentLevel", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe203);
// compiled member node returning call206 (depth = 2)
  adddatum2(obj109, call206, 2);
  sourceObject = obj109;
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe207 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe208 = gc_frame_new();
// call case 3: self.outer request
  Object call209 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe208);
// compiled member node returning call209 (depth = 3)
  partcv[0] = 0;
  Object call210 = callmethodflags(call209, "startPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe207);
// compiled member node returning call210 (depth = 2)
  adddatum2(obj109, call210, 3);
  sourceObject = obj109;
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool211 = alloc_Boolean(0);
// compiled identifier node returning bool211 (depth = 2)
  adddatum2(obj109, bool211, 4);
  sourceObject = obj109;
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool212 = alloc_Boolean(0);
// compiled identifier node returning bool212 (depth = 2)
  adddatum2(obj109, bool212, 5);
  sourceObject = obj109;
  sourceObject = obj109;
  sourceObject = obj109;
  sourceObject = obj109;
  sourceObject = obj109;
  sourceObject = obj109;
  objclass109 = obj109->class;
  objclass109->definitionModule = modulename;
  objclass109->definitionLine = 92;
  (*(struct UserObject *)self).data[0] = lowerouter109;
  self = oldself109;
  selfslot = oldselfslot109;
  stackframe = oldstackframe109;
  gc_frame_end(frame);
  return obj109;
}
Object meth_lexer_214_identifierToken_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "identifierToken(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method identifierToken(_)");
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for identifierToken(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part identifierToken(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject215 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj215 = alloc_userobj2(3,4, objclass215);
  gc_frame_newslot(obj215);
  if (objclass215 == NULL) {
    glfree(obj215->class->name);
    obj215->class->name = "new.identifierToken(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj215, self, 0);
  addmethodreal(obj215,"outer", &reader_lexer_outer_216);
  Object oldself215 = self;
  struct StackFrameObject *oldstackframe215 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe215);
  gc_frame_newslot((Object)stackframe);
  self = obj215;
  Object *oldselfslot215 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter215 = (*(struct UserObject *)self).data[0], lowerouter215 = thisouter215;
  if (inheritingObject215) {
    struct UserObject *inho215 = (struct UserObject *)inheritingObject215;
    while (inho215->super != GraceDefaultObject) inho215 = (struct UserObject *)inho215->super;
    inho215->super = obj215;
    self = inheritingObject215;
    *selfslot = self;
    lowerouter215 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter215;
  }
  if (objclass215 == NULL) {
  Method *reader217 = addmethodrealflags(obj215, "kind",&reader_lexer_kind_217, MFLAG_DEF);
  reader217->definitionModule = modulename;
  reader217->definitionLine = 117;
  }
  adddatum2(obj215, alloc_Undefined(), 1);
  if (objclass215 == NULL) {
  Method *reader218 = addmethodrealflags(obj215, "value",&reader_lexer_value_218, MFLAG_DEF);
  reader218->definitionModule = modulename;
  reader218->definitionLine = 118;
  }
  adddatum2(obj215, alloc_Undefined(), 2);
  if (objclass215 == NULL) {
  Method *reader219 = addmethodrealflags(obj215, "size",&reader_lexer_size_219, MFLAG_DEF);
  reader219->definitionModule = modulename;
  reader219->definitionLine = 119;
  }
  adddatum2(obj215, alloc_Undefined(), 3);
  sourceObject = obj215;
// Begin line 116
  setline(116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe220 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe221 = gc_frame_new();
// call case 3: self.outer request
  Object call222 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe221);
// compiled member node returning call222 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call223 = callmethodflags(call222, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe220);
// compiled call node returning call223 (depth = 2)
  struct UserObject *obj215_uo = (struct UserObject *)obj215;
  obj215_uo->super = call223;
  sourceObject = obj215;
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit224 == NULL) {
    strlit224 = alloc_String("identifier");
    gc_root(strlit224);
  }
// compiled string node returning strlit224 (depth = 2)
  adddatum2(obj215, strlit224, 1);
  sourceObject = obj215;
// Begin line 118
  setline(118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_s (depth = 2)
  adddatum2(obj215, *var_s, 2);
  sourceObject = obj215;
// Begin line 119
  setline(119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe225 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  partcv[0] = 0;
  Object call226 = callmethodflags(*var_s, "size", 1, partcv, params, 0);
  gc_frame_end(callframe225);
// compiled member node returning call226 (depth = 2)
  adddatum2(obj215, call226, 3);
  objclass215 = obj215->class;
  objclass215->definitionModule = modulename;
  objclass215->definitionLine = 115;
  (*(struct UserObject *)self).data[0] = lowerouter215;
  self = oldself215;
  selfslot = oldselfslot215;
  stackframe = oldstackframe215;
  gc_frame_end(frame);
  return obj215;
}
Object meth_lexer_214_identifierToken_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "identifierToken(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method identifierToken(_)");
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for identifierToken(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part identifierToken(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject215 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj215 = alloc_userobj2(3,4, objclass215);
  gc_frame_newslot(obj215);
  if (objclass215 == NULL) {
    glfree(obj215->class->name);
    obj215->class->name = "new.identifierToken(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj215, self, 0);
  addmethodreal(obj215,"outer", &reader_lexer_outer_216);
  Object oldself215 = self;
  struct StackFrameObject *oldstackframe215 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe215);
  gc_frame_newslot((Object)stackframe);
  self = obj215;
  Object *oldselfslot215 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter215 = (*(struct UserObject *)self).data[0], lowerouter215 = thisouter215;
  if (inheritingObject215) {
    struct UserObject *inho215 = (struct UserObject *)inheritingObject215;
    while (inho215->super != GraceDefaultObject) inho215 = (struct UserObject *)inho215->super;
    inho215->super = obj215;
    self = inheritingObject215;
    *selfslot = self;
    lowerouter215 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter215;
  }
  if (objclass215 == NULL) {
  Method *reader217 = addmethodrealflags(obj215, "kind",&reader_lexer_kind_217, MFLAG_DEF);
  reader217->definitionModule = modulename;
  reader217->definitionLine = 117;
  }
  adddatum2(obj215, alloc_Undefined(), 1);
  if (objclass215 == NULL) {
  Method *reader218 = addmethodrealflags(obj215, "value",&reader_lexer_value_218, MFLAG_DEF);
  reader218->definitionModule = modulename;
  reader218->definitionLine = 118;
  }
  adddatum2(obj215, alloc_Undefined(), 2);
  if (objclass215 == NULL) {
  Method *reader219 = addmethodrealflags(obj215, "size",&reader_lexer_size_219, MFLAG_DEF);
  reader219->definitionModule = modulename;
  reader219->definitionLine = 119;
  }
  adddatum2(obj215, alloc_Undefined(), 3);
  sourceObject = obj215;
// Begin line 116
  setline(116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe220 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe221 = gc_frame_new();
// call case 3: self.outer request
  Object call222 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe221);
// compiled member node returning call222 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call223 = callmethodflags(call222, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe220);
// compiled call node returning call223 (depth = 2)
  struct UserObject *obj215_uo = (struct UserObject *)obj215;
  obj215_uo->super = call223;
  sourceObject = obj215;
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit224 == NULL) {
    strlit224 = alloc_String("identifier");
    gc_root(strlit224);
  }
// compiled string node returning strlit224 (depth = 2)
  adddatum2(obj215, strlit224, 1);
  sourceObject = obj215;
// Begin line 118
  setline(118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_s (depth = 2)
  adddatum2(obj215, *var_s, 2);
  sourceObject = obj215;
// Begin line 119
  setline(119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe225 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  partcv[0] = 0;
  Object call226 = callmethodflags(*var_s, "size", 1, partcv, params, 0);
  gc_frame_end(callframe225);
// compiled member node returning call226 (depth = 2)
  adddatum2(obj215, call226, 3);
  objclass215 = obj215->class;
  objclass215->definitionModule = modulename;
  objclass215->definitionLine = 115;
  (*(struct UserObject *)self).data[0] = lowerouter215;
  self = oldself215;
  selfslot = oldselfslot215;
  stackframe = oldstackframe215;
  gc_frame_end(frame);
  return obj215;
}
Object meth_lexer_228_stringToken_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "stringToken(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method stringToken(_)");
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for stringToken(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part stringToken(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject229 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj229 = alloc_userobj2(3,4, objclass229);
  gc_frame_newslot(obj229);
  if (objclass229 == NULL) {
    glfree(obj229->class->name);
    obj229->class->name = "new.stringToken(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj229, self, 0);
  addmethodreal(obj229,"outer", &reader_lexer_outer_230);
  Object oldself229 = self;
  struct StackFrameObject *oldstackframe229 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe229);
  gc_frame_newslot((Object)stackframe);
  self = obj229;
  Object *oldselfslot229 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter229 = (*(struct UserObject *)self).data[0], lowerouter229 = thisouter229;
  if (inheritingObject229) {
    struct UserObject *inho229 = (struct UserObject *)inheritingObject229;
    while (inho229->super != GraceDefaultObject) inho229 = (struct UserObject *)inho229->super;
    inho229->super = obj229;
    self = inheritingObject229;
    *selfslot = self;
    lowerouter229 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter229;
  }
  if (objclass229 == NULL) {
  Method *reader231 = addmethodrealflags(obj229, "kind",&reader_lexer_kind_231, MFLAG_DEF);
  reader231->definitionModule = modulename;
  reader231->definitionLine = 123;
  }
  adddatum2(obj229, alloc_Undefined(), 1);
  if (objclass229 == NULL) {
  Method *reader232 = addmethodrealflags(obj229, "value",&reader_lexer_value_232, MFLAG_DEF);
  reader232->definitionModule = modulename;
  reader232->definitionLine = 124;
  }
  adddatum2(obj229, alloc_Undefined(), 2);
  if (objclass229 == NULL) {
  Method *reader233 = addmethodrealflags(obj229, "size",&reader_lexer_size_233, MFLAG_DEF);
  reader233->definitionModule = modulename;
  reader233->definitionLine = 125;
  }
  adddatum2(obj229, alloc_Undefined(), 3);
  sourceObject = obj229;
// Begin line 122
  setline(122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe234 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe235 = gc_frame_new();
// call case 3: self.outer request
  Object call236 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe235);
// compiled member node returning call236 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call237 = callmethodflags(call236, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe234);
// compiled call node returning call237 (depth = 2)
  struct UserObject *obj229_uo = (struct UserObject *)obj229;
  obj229_uo->super = call237;
  sourceObject = obj229;
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit238 == NULL) {
    strlit238 = alloc_String("string");
    gc_root(strlit238);
  }
// compiled string node returning strlit238 (depth = 2)
  adddatum2(obj229, strlit238, 1);
  sourceObject = obj229;
// Begin line 124
  setline(124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_s (depth = 2)
  adddatum2(obj229, *var_s, 2);
  sourceObject = obj229;
// Begin line 125
  setline(125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile num node (depth = 3)
  Object num240 = alloc_Float64(1);
// compiled num node returning num240 (depth = 3)
  int op_slot_right_239 = gc_frame_newslot(num240);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe243 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe244 = gc_frame_new();
// call case 3: self.outer request
  Object call245 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe244);
// compiled member node returning call245 (depth = 5)
  partcv[0] = 0;
  Object call246 = callmethodflags(call245, "startPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe243);
// compiled member node returning call246 (depth = 4)
  int op_slot_right_242 = gc_frame_newslot(call246);
// starting to compile member node (depth = 4)
  int callframe248 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe249 = gc_frame_new();
// call case 3: self.outer request
  Object call250 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe249);
// compiled member node returning call250 (depth = 5)
  partcv[0] = 0;
  Object call251 = callmethodflags(call250, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe248);
// compiled member node returning call251 (depth = 4)
  int op_slot_left_242 = gc_frame_newslot(call251);
  params[0] = call246;
  partcv[0] = 1;
  Object diff252 = callmethod(call251, "-(1)", 1, partcv, params);
// compiled op node returning diff252 (depth = 3)
  int op_slot_left_239 = gc_frame_newslot(diff252);
  params[0] = num240;
  partcv[0] = 1;
  Object sum253 = callmethod(diff252, "+(1)", 1, partcv, params);
// compiled op node returning sum253 (depth = 2)
  adddatum2(obj229, sum253, 3);
  objclass229 = obj229->class;
  objclass229->definitionModule = modulename;
  objclass229->definitionLine = 121;
  (*(struct UserObject *)self).data[0] = lowerouter229;
  self = oldself229;
  selfslot = oldselfslot229;
  stackframe = oldstackframe229;
  gc_frame_end(frame);
  return obj229;
}
Object meth_lexer_228_stringToken_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "stringToken(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method stringToken(_)");
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for stringToken(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part stringToken(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject229 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj229 = alloc_userobj2(3,4, objclass229);
  gc_frame_newslot(obj229);
  if (objclass229 == NULL) {
    glfree(obj229->class->name);
    obj229->class->name = "new.stringToken(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj229, self, 0);
  addmethodreal(obj229,"outer", &reader_lexer_outer_230);
  Object oldself229 = self;
  struct StackFrameObject *oldstackframe229 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe229);
  gc_frame_newslot((Object)stackframe);
  self = obj229;
  Object *oldselfslot229 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter229 = (*(struct UserObject *)self).data[0], lowerouter229 = thisouter229;
  if (inheritingObject229) {
    struct UserObject *inho229 = (struct UserObject *)inheritingObject229;
    while (inho229->super != GraceDefaultObject) inho229 = (struct UserObject *)inho229->super;
    inho229->super = obj229;
    self = inheritingObject229;
    *selfslot = self;
    lowerouter229 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter229;
  }
  if (objclass229 == NULL) {
  Method *reader231 = addmethodrealflags(obj229, "kind",&reader_lexer_kind_231, MFLAG_DEF);
  reader231->definitionModule = modulename;
  reader231->definitionLine = 123;
  }
  adddatum2(obj229, alloc_Undefined(), 1);
  if (objclass229 == NULL) {
  Method *reader232 = addmethodrealflags(obj229, "value",&reader_lexer_value_232, MFLAG_DEF);
  reader232->definitionModule = modulename;
  reader232->definitionLine = 124;
  }
  adddatum2(obj229, alloc_Undefined(), 2);
  if (objclass229 == NULL) {
  Method *reader233 = addmethodrealflags(obj229, "size",&reader_lexer_size_233, MFLAG_DEF);
  reader233->definitionModule = modulename;
  reader233->definitionLine = 125;
  }
  adddatum2(obj229, alloc_Undefined(), 3);
  sourceObject = obj229;
// Begin line 122
  setline(122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe234 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe235 = gc_frame_new();
// call case 3: self.outer request
  Object call236 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe235);
// compiled member node returning call236 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call237 = callmethodflags(call236, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe234);
// compiled call node returning call237 (depth = 2)
  struct UserObject *obj229_uo = (struct UserObject *)obj229;
  obj229_uo->super = call237;
  sourceObject = obj229;
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit238 == NULL) {
    strlit238 = alloc_String("string");
    gc_root(strlit238);
  }
// compiled string node returning strlit238 (depth = 2)
  adddatum2(obj229, strlit238, 1);
  sourceObject = obj229;
// Begin line 124
  setline(124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_s (depth = 2)
  adddatum2(obj229, *var_s, 2);
  sourceObject = obj229;
// Begin line 125
  setline(125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile num node (depth = 3)
  Object num240 = alloc_Float64(1);
// compiled num node returning num240 (depth = 3)
  int op_slot_right_239 = gc_frame_newslot(num240);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe243 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe244 = gc_frame_new();
// call case 3: self.outer request
  Object call245 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe244);
// compiled member node returning call245 (depth = 5)
  partcv[0] = 0;
  Object call246 = callmethodflags(call245, "startPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe243);
// compiled member node returning call246 (depth = 4)
  int op_slot_right_242 = gc_frame_newslot(call246);
// starting to compile member node (depth = 4)
  int callframe248 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe249 = gc_frame_new();
// call case 3: self.outer request
  Object call250 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe249);
// compiled member node returning call250 (depth = 5)
  partcv[0] = 0;
  Object call251 = callmethodflags(call250, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe248);
// compiled member node returning call251 (depth = 4)
  int op_slot_left_242 = gc_frame_newslot(call251);
  params[0] = call246;
  partcv[0] = 1;
  Object diff252 = callmethod(call251, "-(1)", 1, partcv, params);
// compiled op node returning diff252 (depth = 3)
  int op_slot_left_239 = gc_frame_newslot(diff252);
  params[0] = num240;
  partcv[0] = 1;
  Object sum253 = callmethod(diff252, "+(1)", 1, partcv, params);
// compiled op node returning sum253 (depth = 2)
  adddatum2(obj229, sum253, 3);
  objclass229 = obj229->class;
  objclass229->definitionModule = modulename;
  objclass229->definitionLine = 121;
  (*(struct UserObject *)self).data[0] = lowerouter229;
  self = oldself229;
  selfslot = oldselfslot229;
  stackframe = oldstackframe229;
  gc_frame_end(frame);
  return obj229;
}
Object meth_lexer_263_line(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "line");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 134
  setline(134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe264 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call265 = callmethodflags(self, "line'", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe264);
// compiled member node returning call265 (depth = 2)
  gc_frame_end(frame);
  return call265;
}
Object meth_lexer_266_linePos(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "linePos");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe267 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call268 = callmethodflags(self, "linePos'", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe267);
// compiled member node returning call268 (depth = 2)
  gc_frame_end(frame);
  return call268;
}
Object meth_lexer_269_endLine(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "endLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe270 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe271 = gc_frame_new();
// call case 3: self.outer request
  Object call272 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe271);
// compiled member node returning call272 (depth = 3)
  partcv[0] = 0;
  Object call273 = callmethodflags(call272, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe270);
// compiled member node returning call273 (depth = 2)
  gc_frame_end(frame);
  return call273;
}
Object meth_lexer_274_endPos(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "endPos");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 137
  setline(137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe275 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe276 = gc_frame_new();
// call case 3: self.outer request
  Object call277 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe276);
// compiled member node returning call277 (depth = 3)
  partcv[0] = 0;
  Object call278 = callmethodflags(call277, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe275);
// compiled member node returning call278 (depth = 2)
  gc_frame_end(frame);
  return call278;
}
Object meth_lexer_255_multiLineStringToken_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "multiLineStringToken(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method multiLineStringToken(_)");
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for multiLineStringToken(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part multiLineStringToken(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject256 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj256 = alloc_userobj2(9,10, objclass256);
  gc_frame_newslot(obj256);
  if (objclass256 == NULL) {
    glfree(obj256->class->name);
    obj256->class->name = "new.multiLineStringToken(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj256, self, 0);
  addmethodreal(obj256,"outer", &reader_lexer_outer_257);
  Object oldself256 = self;
  struct StackFrameObject *oldstackframe256 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe256);
  gc_frame_newslot((Object)stackframe);
  self = obj256;
  Object *oldselfslot256 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter256 = (*(struct UserObject *)self).data[0], lowerouter256 = thisouter256;
  if (inheritingObject256) {
    struct UserObject *inho256 = (struct UserObject *)inheritingObject256;
    while (inho256->super != GraceDefaultObject) inho256 = (struct UserObject *)inho256->super;
    inho256->super = obj256;
    self = inheritingObject256;
    *selfslot = self;
    lowerouter256 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter256;
  }
  if (objclass256 == NULL) {
  Method *reader258 = addmethodrealflags(obj256, "kind",&reader_lexer_kind_258, MFLAG_DEF);
  reader258->definitionModule = modulename;
  reader258->definitionLine = 129;
  }
  adddatum2(obj256, alloc_Undefined(), 1);
  if (objclass256 == NULL) {
  Method *reader259 = addmethodrealflags(obj256, "value",&reader_lexer_value_259, MFLAG_DEF);
  reader259->definitionModule = modulename;
  reader259->definitionLine = 130;
  }
  adddatum2(obj256, alloc_Undefined(), 2);
  if (objclass256 == NULL) {
  Method *reader260 = addmethodrealflags(obj256, "size",&reader_lexer_size_260, MFLAG_DEF);
  reader260->definitionModule = modulename;
  reader260->definitionLine = 131;
  }
  adddatum2(obj256, alloc_Undefined(), 3);
  if (objclass256 == NULL) {
  Method *reader261 = addmethodrealflags(obj256, "line'",&reader_lexer_line_39__261, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader261->definitionModule = modulename;
  reader261->definitionLine = 132;
  }
  adddatum2(obj256, alloc_Undefined(), 4);
  if (objclass256 == NULL) {
  Method *reader262 = addmethodrealflags(obj256, "linePos'",&reader_lexer_linePos_39__262, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader262->definitionModule = modulename;
  reader262->definitionLine = 133;
  }
  adddatum2(obj256, alloc_Undefined(), 5);
// method "line"
  struct UserObject *uo263 = (struct UserObject*)obj256;
  uo263->data[6] = emptyclosure;
  Method *meth_meth_lexer_263_line = addmethod2pos(obj256, "line", &meth_lexer_263_line, 6);
  int argcv_meth_lexer_263_line[] = {0};
  meth_meth_lexer_263_line->type = alloc_MethodType(1, argcv_meth_lexer_263_line);
  meth_meth_lexer_263_line->definitionModule = modulename;
  meth_meth_lexer_263_line->definitionLine = 134;
// method "linePos"
  struct UserObject *uo266 = (struct UserObject*)obj256;
  uo266->data[7] = emptyclosure;
  Method *meth_meth_lexer_266_linePos = addmethod2pos(obj256, "linePos", &meth_lexer_266_linePos, 7);
  int argcv_meth_lexer_266_linePos[] = {0};
  meth_meth_lexer_266_linePos->type = alloc_MethodType(1, argcv_meth_lexer_266_linePos);
  meth_meth_lexer_266_linePos->definitionModule = modulename;
  meth_meth_lexer_266_linePos->definitionLine = 135;
// method "endLine"
  struct UserObject *uo269 = (struct UserObject*)obj256;
  uo269->data[8] = emptyclosure;
  Method *meth_meth_lexer_269_endLine = addmethod2pos(obj256, "endLine", &meth_lexer_269_endLine, 8);
  int argcv_meth_lexer_269_endLine[] = {0};
  meth_meth_lexer_269_endLine->type = alloc_MethodType(1, argcv_meth_lexer_269_endLine);
  meth_meth_lexer_269_endLine->definitionModule = modulename;
  meth_meth_lexer_269_endLine->definitionLine = 136;
// method "endPos"
  struct UserObject *uo274 = (struct UserObject*)obj256;
  uo274->data[9] = emptyclosure;
  Method *meth_meth_lexer_274_endPos = addmethod2pos(obj256, "endPos", &meth_lexer_274_endPos, 9);
  int argcv_meth_lexer_274_endPos[] = {0};
  meth_meth_lexer_274_endPos->type = alloc_MethodType(1, argcv_meth_lexer_274_endPos);
  meth_meth_lexer_274_endPos->definitionModule = modulename;
  meth_meth_lexer_274_endPos->definitionLine = 137;
  sourceObject = obj256;
// Begin line 128
  setline(128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe279 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe280 = gc_frame_new();
// call case 3: self.outer request
  Object call281 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe280);
// compiled member node returning call281 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call282 = callmethodflags(call281, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe279);
// compiled call node returning call282 (depth = 2)
  struct UserObject *obj256_uo = (struct UserObject *)obj256;
  obj256_uo->super = call282;
  sourceObject = obj256;
// Begin line 129
  setline(129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit283 == NULL) {
    strlit283 = alloc_String("string");
    gc_root(strlit283);
  }
// compiled string node returning strlit283 (depth = 2)
  adddatum2(obj256, strlit283, 1);
  sourceObject = obj256;
// Begin line 130
  setline(130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_s (depth = 2)
  adddatum2(obj256, *var_s, 2);
  sourceObject = obj256;
// Begin line 131
  setline(131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile num node (depth = 3)
  Object num285 = alloc_Float64(2);
// compiled num node returning num285 (depth = 3)
  int op_slot_right_284 = gc_frame_newslot(num285);
// starting to compile member node (depth = 3)
  int callframe287 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  partcv[0] = 0;
  Object call288 = callmethodflags(*var_s, "size", 1, partcv, params, 0);
  gc_frame_end(callframe287);
// compiled member node returning call288 (depth = 3)
  int op_slot_left_284 = gc_frame_newslot(call288);
  params[0] = num285;
  partcv[0] = 1;
  Object sum289 = callmethod(call288, "+(1)", 1, partcv, params);
// compiled op node returning sum289 (depth = 2)
  adddatum2(obj256, sum289, 3);
  sourceObject = obj256;
// Begin line 132
  setline(132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe290 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe291 = gc_frame_new();
// call case 3: self.outer request
  Object call292 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe291);
// compiled member node returning call292 (depth = 3)
  partcv[0] = 0;
  Object call293 = callmethodflags(call292, "startLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe290);
// compiled member node returning call293 (depth = 2)
  adddatum2(obj256, call293, 4);
  sourceObject = obj256;
// Begin line 133
  setline(133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe294 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe295 = gc_frame_new();
// call case 3: self.outer request
  Object call296 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe295);
// compiled member node returning call296 (depth = 3)
  partcv[0] = 0;
  Object call297 = callmethodflags(call296, "stringStart", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe294);
// compiled member node returning call297 (depth = 2)
  adddatum2(obj256, call297, 5);
  sourceObject = obj256;
  sourceObject = obj256;
  sourceObject = obj256;
  sourceObject = obj256;
  objclass256 = obj256->class;
  objclass256->definitionModule = modulename;
  objclass256->definitionLine = 127;
  (*(struct UserObject *)self).data[0] = lowerouter256;
  self = oldself256;
  selfslot = oldselfslot256;
  stackframe = oldstackframe256;
  gc_frame_end(frame);
  return obj256;
}
Object meth_lexer_255_multiLineStringToken_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "multiLineStringToken(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method multiLineStringToken(_)");
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for multiLineStringToken(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part multiLineStringToken(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject256 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj256 = alloc_userobj2(9,10, objclass256);
  gc_frame_newslot(obj256);
  if (objclass256 == NULL) {
    glfree(obj256->class->name);
    obj256->class->name = "new.multiLineStringToken(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj256, self, 0);
  addmethodreal(obj256,"outer", &reader_lexer_outer_257);
  Object oldself256 = self;
  struct StackFrameObject *oldstackframe256 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe256);
  gc_frame_newslot((Object)stackframe);
  self = obj256;
  Object *oldselfslot256 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter256 = (*(struct UserObject *)self).data[0], lowerouter256 = thisouter256;
  if (inheritingObject256) {
    struct UserObject *inho256 = (struct UserObject *)inheritingObject256;
    while (inho256->super != GraceDefaultObject) inho256 = (struct UserObject *)inho256->super;
    inho256->super = obj256;
    self = inheritingObject256;
    *selfslot = self;
    lowerouter256 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter256;
  }
  if (objclass256 == NULL) {
  Method *reader258 = addmethodrealflags(obj256, "kind",&reader_lexer_kind_258, MFLAG_DEF);
  reader258->definitionModule = modulename;
  reader258->definitionLine = 129;
  }
  adddatum2(obj256, alloc_Undefined(), 1);
  if (objclass256 == NULL) {
  Method *reader259 = addmethodrealflags(obj256, "value",&reader_lexer_value_259, MFLAG_DEF);
  reader259->definitionModule = modulename;
  reader259->definitionLine = 130;
  }
  adddatum2(obj256, alloc_Undefined(), 2);
  if (objclass256 == NULL) {
  Method *reader260 = addmethodrealflags(obj256, "size",&reader_lexer_size_260, MFLAG_DEF);
  reader260->definitionModule = modulename;
  reader260->definitionLine = 131;
  }
  adddatum2(obj256, alloc_Undefined(), 3);
  if (objclass256 == NULL) {
  Method *reader261 = addmethodrealflags(obj256, "line'",&reader_lexer_line_39__261, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader261->definitionModule = modulename;
  reader261->definitionLine = 132;
  }
  adddatum2(obj256, alloc_Undefined(), 4);
  if (objclass256 == NULL) {
  Method *reader262 = addmethodrealflags(obj256, "linePos'",&reader_lexer_linePos_39__262, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader262->definitionModule = modulename;
  reader262->definitionLine = 133;
  }
  adddatum2(obj256, alloc_Undefined(), 5);
// method "line"
  struct UserObject *uo263 = (struct UserObject*)obj256;
  uo263->data[6] = emptyclosure;
  Method *meth_meth_lexer_263_line = addmethod2pos(obj256, "line", &meth_lexer_263_line, 6);
  int argcv_meth_lexer_263_line[] = {0};
  meth_meth_lexer_263_line->type = alloc_MethodType(1, argcv_meth_lexer_263_line);
  meth_meth_lexer_263_line->definitionModule = modulename;
  meth_meth_lexer_263_line->definitionLine = 134;
// method "linePos"
  struct UserObject *uo266 = (struct UserObject*)obj256;
  uo266->data[7] = emptyclosure;
  Method *meth_meth_lexer_266_linePos = addmethod2pos(obj256, "linePos", &meth_lexer_266_linePos, 7);
  int argcv_meth_lexer_266_linePos[] = {0};
  meth_meth_lexer_266_linePos->type = alloc_MethodType(1, argcv_meth_lexer_266_linePos);
  meth_meth_lexer_266_linePos->definitionModule = modulename;
  meth_meth_lexer_266_linePos->definitionLine = 135;
// method "endLine"
  struct UserObject *uo269 = (struct UserObject*)obj256;
  uo269->data[8] = emptyclosure;
  Method *meth_meth_lexer_269_endLine = addmethod2pos(obj256, "endLine", &meth_lexer_269_endLine, 8);
  int argcv_meth_lexer_269_endLine[] = {0};
  meth_meth_lexer_269_endLine->type = alloc_MethodType(1, argcv_meth_lexer_269_endLine);
  meth_meth_lexer_269_endLine->definitionModule = modulename;
  meth_meth_lexer_269_endLine->definitionLine = 136;
// method "endPos"
  struct UserObject *uo274 = (struct UserObject*)obj256;
  uo274->data[9] = emptyclosure;
  Method *meth_meth_lexer_274_endPos = addmethod2pos(obj256, "endPos", &meth_lexer_274_endPos, 9);
  int argcv_meth_lexer_274_endPos[] = {0};
  meth_meth_lexer_274_endPos->type = alloc_MethodType(1, argcv_meth_lexer_274_endPos);
  meth_meth_lexer_274_endPos->definitionModule = modulename;
  meth_meth_lexer_274_endPos->definitionLine = 137;
  sourceObject = obj256;
// Begin line 128
  setline(128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe279 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe280 = gc_frame_new();
// call case 3: self.outer request
  Object call281 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe280);
// compiled member node returning call281 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call282 = callmethodflags(call281, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe279);
// compiled call node returning call282 (depth = 2)
  struct UserObject *obj256_uo = (struct UserObject *)obj256;
  obj256_uo->super = call282;
  sourceObject = obj256;
// Begin line 129
  setline(129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit283 == NULL) {
    strlit283 = alloc_String("string");
    gc_root(strlit283);
  }
// compiled string node returning strlit283 (depth = 2)
  adddatum2(obj256, strlit283, 1);
  sourceObject = obj256;
// Begin line 130
  setline(130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_s (depth = 2)
  adddatum2(obj256, *var_s, 2);
  sourceObject = obj256;
// Begin line 131
  setline(131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile num node (depth = 3)
  Object num285 = alloc_Float64(2);
// compiled num node returning num285 (depth = 3)
  int op_slot_right_284 = gc_frame_newslot(num285);
// starting to compile member node (depth = 3)
  int callframe287 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  partcv[0] = 0;
  Object call288 = callmethodflags(*var_s, "size", 1, partcv, params, 0);
  gc_frame_end(callframe287);
// compiled member node returning call288 (depth = 3)
  int op_slot_left_284 = gc_frame_newslot(call288);
  params[0] = num285;
  partcv[0] = 1;
  Object sum289 = callmethod(call288, "+(1)", 1, partcv, params);
// compiled op node returning sum289 (depth = 2)
  adddatum2(obj256, sum289, 3);
  sourceObject = obj256;
// Begin line 132
  setline(132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe290 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe291 = gc_frame_new();
// call case 3: self.outer request
  Object call292 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe291);
// compiled member node returning call292 (depth = 3)
  partcv[0] = 0;
  Object call293 = callmethodflags(call292, "startLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe290);
// compiled member node returning call293 (depth = 2)
  adddatum2(obj256, call293, 4);
  sourceObject = obj256;
// Begin line 133
  setline(133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe294 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe295 = gc_frame_new();
// call case 3: self.outer request
  Object call296 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe295);
// compiled member node returning call296 (depth = 3)
  partcv[0] = 0;
  Object call297 = callmethodflags(call296, "stringStart", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe294);
// compiled member node returning call297 (depth = 2)
  adddatum2(obj256, call297, 5);
  sourceObject = obj256;
  sourceObject = obj256;
  sourceObject = obj256;
  sourceObject = obj256;
  objclass256 = obj256->class;
  objclass256->definitionModule = modulename;
  objclass256->definitionLine = 127;
  (*(struct UserObject *)self).data[0] = lowerouter256;
  self = oldself256;
  selfslot = oldselfslot256;
  stackframe = oldstackframe256;
  gc_frame_end(frame);
  return obj256;
}
Object meth_lexer_299_commentToken_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "commentToken(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method commentToken(_)");
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for commentToken(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part commentToken(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject300 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj300 = alloc_userobj2(3,4, objclass300);
  gc_frame_newslot(obj300);
  if (objclass300 == NULL) {
    glfree(obj300->class->name);
    obj300->class->name = "new.commentToken(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj300, self, 0);
  addmethodreal(obj300,"outer", &reader_lexer_outer_301);
  Object oldself300 = self;
  struct StackFrameObject *oldstackframe300 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe300);
  gc_frame_newslot((Object)stackframe);
  self = obj300;
  Object *oldselfslot300 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter300 = (*(struct UserObject *)self).data[0], lowerouter300 = thisouter300;
  if (inheritingObject300) {
    struct UserObject *inho300 = (struct UserObject *)inheritingObject300;
    while (inho300->super != GraceDefaultObject) inho300 = (struct UserObject *)inho300->super;
    inho300->super = obj300;
    self = inheritingObject300;
    *selfslot = self;
    lowerouter300 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter300;
  }
  if (objclass300 == NULL) {
  Method *reader302 = addmethodrealflags(obj300, "kind",&reader_lexer_kind_302, MFLAG_DEF);
  reader302->definitionModule = modulename;
  reader302->definitionLine = 141;
  }
  adddatum2(obj300, alloc_Undefined(), 1);
  if (objclass300 == NULL) {
  Method *reader303 = addmethodrealflags(obj300, "value",&reader_lexer_value_303, MFLAG_DEF);
  reader303->definitionModule = modulename;
  reader303->definitionLine = 142;
  }
  adddatum2(obj300, alloc_Undefined(), 2);
  if (objclass300 == NULL) {
  Method *reader304 = addmethodrealflags(obj300, "size",&reader_lexer_size_304, MFLAG_DEF);
  reader304->definitionModule = modulename;
  reader304->definitionLine = 143;
  }
  adddatum2(obj300, alloc_Undefined(), 3);
  sourceObject = obj300;
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe305 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe306 = gc_frame_new();
// call case 3: self.outer request
  Object call307 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe306);
// compiled member node returning call307 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call308 = callmethodflags(call307, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe305);
// compiled call node returning call308 (depth = 2)
  struct UserObject *obj300_uo = (struct UserObject *)obj300;
  obj300_uo->super = call308;
  sourceObject = obj300;
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit309 == NULL) {
    strlit309 = alloc_String("comment");
    gc_root(strlit309);
  }
// compiled string node returning strlit309 (depth = 2)
  adddatum2(obj300, strlit309, 1);
  sourceObject = obj300;
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_s (depth = 2)
  adddatum2(obj300, *var_s, 2);
  sourceObject = obj300;
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile num node (depth = 3)
  Object num311 = alloc_Float64(2);
// compiled num node returning num311 (depth = 3)
  int op_slot_right_310 = gc_frame_newslot(num311);
// starting to compile member node (depth = 3)
  int callframe313 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  partcv[0] = 0;
  Object call314 = callmethodflags(*var_s, "size", 1, partcv, params, 0);
  gc_frame_end(callframe313);
// compiled member node returning call314 (depth = 3)
  int op_slot_left_310 = gc_frame_newslot(call314);
  params[0] = num311;
  partcv[0] = 1;
  Object sum315 = callmethod(call314, "+(1)", 1, partcv, params);
// compiled op node returning sum315 (depth = 2)
  adddatum2(obj300, sum315, 3);
  objclass300 = obj300->class;
  objclass300->definitionModule = modulename;
  objclass300->definitionLine = 139;
  (*(struct UserObject *)self).data[0] = lowerouter300;
  self = oldself300;
  selfslot = oldselfslot300;
  stackframe = oldstackframe300;
  gc_frame_end(frame);
  return obj300;
}
Object meth_lexer_299_commentToken_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "commentToken(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method commentToken(_)");
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for commentToken(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part commentToken(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject300 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj300 = alloc_userobj2(3,4, objclass300);
  gc_frame_newslot(obj300);
  if (objclass300 == NULL) {
    glfree(obj300->class->name);
    obj300->class->name = "new.commentToken(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj300, self, 0);
  addmethodreal(obj300,"outer", &reader_lexer_outer_301);
  Object oldself300 = self;
  struct StackFrameObject *oldstackframe300 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe300);
  gc_frame_newslot((Object)stackframe);
  self = obj300;
  Object *oldselfslot300 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter300 = (*(struct UserObject *)self).data[0], lowerouter300 = thisouter300;
  if (inheritingObject300) {
    struct UserObject *inho300 = (struct UserObject *)inheritingObject300;
    while (inho300->super != GraceDefaultObject) inho300 = (struct UserObject *)inho300->super;
    inho300->super = obj300;
    self = inheritingObject300;
    *selfslot = self;
    lowerouter300 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter300;
  }
  if (objclass300 == NULL) {
  Method *reader302 = addmethodrealflags(obj300, "kind",&reader_lexer_kind_302, MFLAG_DEF);
  reader302->definitionModule = modulename;
  reader302->definitionLine = 141;
  }
  adddatum2(obj300, alloc_Undefined(), 1);
  if (objclass300 == NULL) {
  Method *reader303 = addmethodrealflags(obj300, "value",&reader_lexer_value_303, MFLAG_DEF);
  reader303->definitionModule = modulename;
  reader303->definitionLine = 142;
  }
  adddatum2(obj300, alloc_Undefined(), 2);
  if (objclass300 == NULL) {
  Method *reader304 = addmethodrealflags(obj300, "size",&reader_lexer_size_304, MFLAG_DEF);
  reader304->definitionModule = modulename;
  reader304->definitionLine = 143;
  }
  adddatum2(obj300, alloc_Undefined(), 3);
  sourceObject = obj300;
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe305 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe306 = gc_frame_new();
// call case 3: self.outer request
  Object call307 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe306);
// compiled member node returning call307 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call308 = callmethodflags(call307, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe305);
// compiled call node returning call308 (depth = 2)
  struct UserObject *obj300_uo = (struct UserObject *)obj300;
  obj300_uo->super = call308;
  sourceObject = obj300;
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit309 == NULL) {
    strlit309 = alloc_String("comment");
    gc_root(strlit309);
  }
// compiled string node returning strlit309 (depth = 2)
  adddatum2(obj300, strlit309, 1);
  sourceObject = obj300;
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_s (depth = 2)
  adddatum2(obj300, *var_s, 2);
  sourceObject = obj300;
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile num node (depth = 3)
  Object num311 = alloc_Float64(2);
// compiled num node returning num311 (depth = 3)
  int op_slot_right_310 = gc_frame_newslot(num311);
// starting to compile member node (depth = 3)
  int callframe313 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  partcv[0] = 0;
  Object call314 = callmethodflags(*var_s, "size", 1, partcv, params, 0);
  gc_frame_end(callframe313);
// compiled member node returning call314 (depth = 3)
  int op_slot_left_310 = gc_frame_newslot(call314);
  params[0] = num311;
  partcv[0] = 1;
  Object sum315 = callmethod(call314, "+(1)", 1, partcv, params);
// compiled op node returning sum315 (depth = 2)
  adddatum2(obj300, sum315, 3);
  objclass300 = obj300->class;
  objclass300->definitionModule = modulename;
  objclass300->definitionLine = 139;
  (*(struct UserObject *)self).data[0] = lowerouter300;
  self = oldself300;
  selfslot = oldselfslot300;
  stackframe = oldstackframe300;
  gc_frame_end(frame);
  return obj300;
}
Object meth_lexer_317_lBraceToken(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "lBraceToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject318 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj318 = alloc_userobj2(3,4, objclass318);
  gc_frame_newslot(obj318);
  if (objclass318 == NULL) {
    glfree(obj318->class->name);
    obj318->class->name = "new.lBraceToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj318, self, 0);
  addmethodreal(obj318,"outer", &reader_lexer_outer_319);
  Object oldself318 = self;
  struct StackFrameObject *oldstackframe318 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe318);
  gc_frame_newslot((Object)stackframe);
  self = obj318;
  Object *oldselfslot318 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter318 = (*(struct UserObject *)self).data[0], lowerouter318 = thisouter318;
  if (inheritingObject318) {
    struct UserObject *inho318 = (struct UserObject *)inheritingObject318;
    while (inho318->super != GraceDefaultObject) inho318 = (struct UserObject *)inho318->super;
    inho318->super = obj318;
    self = inheritingObject318;
    *selfslot = self;
    lowerouter318 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter318;
  }
  if (objclass318 == NULL) {
  Method *reader320 = addmethodrealflags(obj318, "kind",&reader_lexer_kind_320, MFLAG_DEF);
  reader320->definitionModule = modulename;
  reader320->definitionLine = 147;
  }
  adddatum2(obj318, alloc_Undefined(), 1);
  if (objclass318 == NULL) {
  Method *reader321 = addmethodrealflags(obj318, "value",&reader_lexer_value_321, MFLAG_DEF);
  reader321->definitionModule = modulename;
  reader321->definitionLine = 148;
  }
  adddatum2(obj318, alloc_Undefined(), 2);
  if (objclass318 == NULL) {
  Method *reader322 = addmethodrealflags(obj318, "size",&reader_lexer_size_322, MFLAG_DEF);
  reader322->definitionModule = modulename;
  reader322->definitionLine = 149;
  }
  adddatum2(obj318, alloc_Undefined(), 3);
  sourceObject = obj318;
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe323 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe324 = gc_frame_new();
// call case 3: self.outer request
  Object call325 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe324);
// compiled member node returning call325 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call326 = callmethodflags(call325, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe323);
// compiled call node returning call326 (depth = 2)
  struct UserObject *obj318_uo = (struct UserObject *)obj318;
  obj318_uo->super = call326;
  sourceObject = obj318;
// Begin line 147
  setline(147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit327 == NULL) {
    strlit327 = alloc_String("lbrace");
    gc_root(strlit327);
  }
// compiled string node returning strlit327 (depth = 2)
  adddatum2(obj318, strlit327, 1);
  sourceObject = obj318;
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit328 == NULL) {
    strlit328 = alloc_String("{");
    gc_root(strlit328);
  }
// compiled string node returning strlit328 (depth = 2)
  adddatum2(obj318, strlit328, 2);
  sourceObject = obj318;
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num329 = alloc_Float64(1);
// compiled num node returning num329 (depth = 2)
  adddatum2(obj318, num329, 3);
  objclass318 = obj318->class;
  objclass318->definitionModule = modulename;
  objclass318->definitionLine = 145;
  (*(struct UserObject *)self).data[0] = lowerouter318;
  self = oldself318;
  selfslot = oldselfslot318;
  stackframe = oldstackframe318;
  gc_frame_end(frame);
  return obj318;
}
Object meth_lexer_317_lBraceToken_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "lBraceToken$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject318 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj318 = alloc_userobj2(3,4, objclass318);
  gc_frame_newslot(obj318);
  if (objclass318 == NULL) {
    glfree(obj318->class->name);
    obj318->class->name = "new.lBraceToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj318, self, 0);
  addmethodreal(obj318,"outer", &reader_lexer_outer_319);
  Object oldself318 = self;
  struct StackFrameObject *oldstackframe318 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe318);
  gc_frame_newslot((Object)stackframe);
  self = obj318;
  Object *oldselfslot318 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter318 = (*(struct UserObject *)self).data[0], lowerouter318 = thisouter318;
  if (inheritingObject318) {
    struct UserObject *inho318 = (struct UserObject *)inheritingObject318;
    while (inho318->super != GraceDefaultObject) inho318 = (struct UserObject *)inho318->super;
    inho318->super = obj318;
    self = inheritingObject318;
    *selfslot = self;
    lowerouter318 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter318;
  }
  if (objclass318 == NULL) {
  Method *reader320 = addmethodrealflags(obj318, "kind",&reader_lexer_kind_320, MFLAG_DEF);
  reader320->definitionModule = modulename;
  reader320->definitionLine = 147;
  }
  adddatum2(obj318, alloc_Undefined(), 1);
  if (objclass318 == NULL) {
  Method *reader321 = addmethodrealflags(obj318, "value",&reader_lexer_value_321, MFLAG_DEF);
  reader321->definitionModule = modulename;
  reader321->definitionLine = 148;
  }
  adddatum2(obj318, alloc_Undefined(), 2);
  if (objclass318 == NULL) {
  Method *reader322 = addmethodrealflags(obj318, "size",&reader_lexer_size_322, MFLAG_DEF);
  reader322->definitionModule = modulename;
  reader322->definitionLine = 149;
  }
  adddatum2(obj318, alloc_Undefined(), 3);
  sourceObject = obj318;
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe323 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe324 = gc_frame_new();
// call case 3: self.outer request
  Object call325 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe324);
// compiled member node returning call325 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call326 = callmethodflags(call325, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe323);
// compiled call node returning call326 (depth = 2)
  struct UserObject *obj318_uo = (struct UserObject *)obj318;
  obj318_uo->super = call326;
  sourceObject = obj318;
// Begin line 147
  setline(147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit327 == NULL) {
    strlit327 = alloc_String("lbrace");
    gc_root(strlit327);
  }
// compiled string node returning strlit327 (depth = 2)
  adddatum2(obj318, strlit327, 1);
  sourceObject = obj318;
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit328 == NULL) {
    strlit328 = alloc_String("{");
    gc_root(strlit328);
  }
// compiled string node returning strlit328 (depth = 2)
  adddatum2(obj318, strlit328, 2);
  sourceObject = obj318;
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num329 = alloc_Float64(1);
// compiled num node returning num329 (depth = 2)
  adddatum2(obj318, num329, 3);
  objclass318 = obj318->class;
  objclass318->definitionModule = modulename;
  objclass318->definitionLine = 145;
  (*(struct UserObject *)self).data[0] = lowerouter318;
  self = oldself318;
  selfslot = oldselfslot318;
  stackframe = oldstackframe318;
  gc_frame_end(frame);
  return obj318;
}
Object meth_lexer_331_rBraceToken(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "rBraceToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject332 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj332 = alloc_userobj2(3,4, objclass332);
  gc_frame_newslot(obj332);
  if (objclass332 == NULL) {
    glfree(obj332->class->name);
    obj332->class->name = "new.rBraceToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj332, self, 0);
  addmethodreal(obj332,"outer", &reader_lexer_outer_333);
  Object oldself332 = self;
  struct StackFrameObject *oldstackframe332 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe332);
  gc_frame_newslot((Object)stackframe);
  self = obj332;
  Object *oldselfslot332 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter332 = (*(struct UserObject *)self).data[0], lowerouter332 = thisouter332;
  if (inheritingObject332) {
    struct UserObject *inho332 = (struct UserObject *)inheritingObject332;
    while (inho332->super != GraceDefaultObject) inho332 = (struct UserObject *)inho332->super;
    inho332->super = obj332;
    self = inheritingObject332;
    *selfslot = self;
    lowerouter332 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter332;
  }
  if (objclass332 == NULL) {
  Method *reader334 = addmethodrealflags(obj332, "kind",&reader_lexer_kind_334, MFLAG_DEF);
  reader334->definitionModule = modulename;
  reader334->definitionLine = 153;
  }
  adddatum2(obj332, alloc_Undefined(), 1);
  if (objclass332 == NULL) {
  Method *reader335 = addmethodrealflags(obj332, "value",&reader_lexer_value_335, MFLAG_DEF);
  reader335->definitionModule = modulename;
  reader335->definitionLine = 154;
  }
  adddatum2(obj332, alloc_Undefined(), 2);
  if (objclass332 == NULL) {
  Method *reader336 = addmethodrealflags(obj332, "size",&reader_lexer_size_336, MFLAG_DEF);
  reader336->definitionModule = modulename;
  reader336->definitionLine = 155;
  }
  adddatum2(obj332, alloc_Undefined(), 3);
  sourceObject = obj332;
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe337 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe338 = gc_frame_new();
// call case 3: self.outer request
  Object call339 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe338);
// compiled member node returning call339 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call340 = callmethodflags(call339, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe337);
// compiled call node returning call340 (depth = 2)
  struct UserObject *obj332_uo = (struct UserObject *)obj332;
  obj332_uo->super = call340;
  sourceObject = obj332;
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit341 == NULL) {
    strlit341 = alloc_String("rbrace");
    gc_root(strlit341);
  }
// compiled string node returning strlit341 (depth = 2)
  adddatum2(obj332, strlit341, 1);
  sourceObject = obj332;
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit342 == NULL) {
    strlit342 = alloc_String("}");
    gc_root(strlit342);
  }
// compiled string node returning strlit342 (depth = 2)
  adddatum2(obj332, strlit342, 2);
  sourceObject = obj332;
// Begin line 155
  setline(155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num343 = alloc_Float64(1);
// compiled num node returning num343 (depth = 2)
  adddatum2(obj332, num343, 3);
  objclass332 = obj332->class;
  objclass332->definitionModule = modulename;
  objclass332->definitionLine = 151;
  (*(struct UserObject *)self).data[0] = lowerouter332;
  self = oldself332;
  selfslot = oldselfslot332;
  stackframe = oldstackframe332;
  gc_frame_end(frame);
  return obj332;
}
Object meth_lexer_331_rBraceToken_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "rBraceToken$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject332 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj332 = alloc_userobj2(3,4, objclass332);
  gc_frame_newslot(obj332);
  if (objclass332 == NULL) {
    glfree(obj332->class->name);
    obj332->class->name = "new.rBraceToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj332, self, 0);
  addmethodreal(obj332,"outer", &reader_lexer_outer_333);
  Object oldself332 = self;
  struct StackFrameObject *oldstackframe332 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe332);
  gc_frame_newslot((Object)stackframe);
  self = obj332;
  Object *oldselfslot332 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter332 = (*(struct UserObject *)self).data[0], lowerouter332 = thisouter332;
  if (inheritingObject332) {
    struct UserObject *inho332 = (struct UserObject *)inheritingObject332;
    while (inho332->super != GraceDefaultObject) inho332 = (struct UserObject *)inho332->super;
    inho332->super = obj332;
    self = inheritingObject332;
    *selfslot = self;
    lowerouter332 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter332;
  }
  if (objclass332 == NULL) {
  Method *reader334 = addmethodrealflags(obj332, "kind",&reader_lexer_kind_334, MFLAG_DEF);
  reader334->definitionModule = modulename;
  reader334->definitionLine = 153;
  }
  adddatum2(obj332, alloc_Undefined(), 1);
  if (objclass332 == NULL) {
  Method *reader335 = addmethodrealflags(obj332, "value",&reader_lexer_value_335, MFLAG_DEF);
  reader335->definitionModule = modulename;
  reader335->definitionLine = 154;
  }
  adddatum2(obj332, alloc_Undefined(), 2);
  if (objclass332 == NULL) {
  Method *reader336 = addmethodrealflags(obj332, "size",&reader_lexer_size_336, MFLAG_DEF);
  reader336->definitionModule = modulename;
  reader336->definitionLine = 155;
  }
  adddatum2(obj332, alloc_Undefined(), 3);
  sourceObject = obj332;
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe337 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe338 = gc_frame_new();
// call case 3: self.outer request
  Object call339 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe338);
// compiled member node returning call339 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call340 = callmethodflags(call339, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe337);
// compiled call node returning call340 (depth = 2)
  struct UserObject *obj332_uo = (struct UserObject *)obj332;
  obj332_uo->super = call340;
  sourceObject = obj332;
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit341 == NULL) {
    strlit341 = alloc_String("rbrace");
    gc_root(strlit341);
  }
// compiled string node returning strlit341 (depth = 2)
  adddatum2(obj332, strlit341, 1);
  sourceObject = obj332;
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit342 == NULL) {
    strlit342 = alloc_String("}");
    gc_root(strlit342);
  }
// compiled string node returning strlit342 (depth = 2)
  adddatum2(obj332, strlit342, 2);
  sourceObject = obj332;
// Begin line 155
  setline(155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num343 = alloc_Float64(1);
// compiled num node returning num343 (depth = 2)
  adddatum2(obj332, num343, 3);
  objclass332 = obj332->class;
  objclass332->definitionModule = modulename;
  objclass332->definitionLine = 151;
  (*(struct UserObject *)self).data[0] = lowerouter332;
  self = oldself332;
  selfslot = oldselfslot332;
  stackframe = oldstackframe332;
  gc_frame_end(frame);
  return obj332;
}
Object meth_lexer_345_lParenToken(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "lParenToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject346 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj346 = alloc_userobj2(3,4, objclass346);
  gc_frame_newslot(obj346);
  if (objclass346 == NULL) {
    glfree(obj346->class->name);
    obj346->class->name = "new.lParenToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj346, self, 0);
  addmethodreal(obj346,"outer", &reader_lexer_outer_347);
  Object oldself346 = self;
  struct StackFrameObject *oldstackframe346 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe346);
  gc_frame_newslot((Object)stackframe);
  self = obj346;
  Object *oldselfslot346 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter346 = (*(struct UserObject *)self).data[0], lowerouter346 = thisouter346;
  if (inheritingObject346) {
    struct UserObject *inho346 = (struct UserObject *)inheritingObject346;
    while (inho346->super != GraceDefaultObject) inho346 = (struct UserObject *)inho346->super;
    inho346->super = obj346;
    self = inheritingObject346;
    *selfslot = self;
    lowerouter346 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter346;
  }
  if (objclass346 == NULL) {
  Method *reader348 = addmethodrealflags(obj346, "kind",&reader_lexer_kind_348, MFLAG_DEF);
  reader348->definitionModule = modulename;
  reader348->definitionLine = 159;
  }
  adddatum2(obj346, alloc_Undefined(), 1);
  if (objclass346 == NULL) {
  Method *reader349 = addmethodrealflags(obj346, "value",&reader_lexer_value_349, MFLAG_DEF);
  reader349->definitionModule = modulename;
  reader349->definitionLine = 160;
  }
  adddatum2(obj346, alloc_Undefined(), 2);
  if (objclass346 == NULL) {
  Method *reader350 = addmethodrealflags(obj346, "size",&reader_lexer_size_350, MFLAG_DEF);
  reader350->definitionModule = modulename;
  reader350->definitionLine = 161;
  }
  adddatum2(obj346, alloc_Undefined(), 3);
  sourceObject = obj346;
// Begin line 158
  setline(158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe351 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe352 = gc_frame_new();
// call case 3: self.outer request
  Object call353 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe352);
// compiled member node returning call353 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call354 = callmethodflags(call353, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe351);
// compiled call node returning call354 (depth = 2)
  struct UserObject *obj346_uo = (struct UserObject *)obj346;
  obj346_uo->super = call354;
  sourceObject = obj346;
// Begin line 159
  setline(159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit355 == NULL) {
    strlit355 = alloc_String("lparen");
    gc_root(strlit355);
  }
// compiled string node returning strlit355 (depth = 2)
  adddatum2(obj346, strlit355, 1);
  sourceObject = obj346;
// Begin line 160
  setline(160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit356 == NULL) {
    strlit356 = alloc_String("(");
    gc_root(strlit356);
  }
// compiled string node returning strlit356 (depth = 2)
  adddatum2(obj346, strlit356, 2);
  sourceObject = obj346;
// Begin line 161
  setline(161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num357 = alloc_Float64(1);
// compiled num node returning num357 (depth = 2)
  adddatum2(obj346, num357, 3);
  objclass346 = obj346->class;
  objclass346->definitionModule = modulename;
  objclass346->definitionLine = 157;
  (*(struct UserObject *)self).data[0] = lowerouter346;
  self = oldself346;
  selfslot = oldselfslot346;
  stackframe = oldstackframe346;
  gc_frame_end(frame);
  return obj346;
}
Object meth_lexer_345_lParenToken_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "lParenToken$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject346 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj346 = alloc_userobj2(3,4, objclass346);
  gc_frame_newslot(obj346);
  if (objclass346 == NULL) {
    glfree(obj346->class->name);
    obj346->class->name = "new.lParenToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj346, self, 0);
  addmethodreal(obj346,"outer", &reader_lexer_outer_347);
  Object oldself346 = self;
  struct StackFrameObject *oldstackframe346 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe346);
  gc_frame_newslot((Object)stackframe);
  self = obj346;
  Object *oldselfslot346 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter346 = (*(struct UserObject *)self).data[0], lowerouter346 = thisouter346;
  if (inheritingObject346) {
    struct UserObject *inho346 = (struct UserObject *)inheritingObject346;
    while (inho346->super != GraceDefaultObject) inho346 = (struct UserObject *)inho346->super;
    inho346->super = obj346;
    self = inheritingObject346;
    *selfslot = self;
    lowerouter346 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter346;
  }
  if (objclass346 == NULL) {
  Method *reader348 = addmethodrealflags(obj346, "kind",&reader_lexer_kind_348, MFLAG_DEF);
  reader348->definitionModule = modulename;
  reader348->definitionLine = 159;
  }
  adddatum2(obj346, alloc_Undefined(), 1);
  if (objclass346 == NULL) {
  Method *reader349 = addmethodrealflags(obj346, "value",&reader_lexer_value_349, MFLAG_DEF);
  reader349->definitionModule = modulename;
  reader349->definitionLine = 160;
  }
  adddatum2(obj346, alloc_Undefined(), 2);
  if (objclass346 == NULL) {
  Method *reader350 = addmethodrealflags(obj346, "size",&reader_lexer_size_350, MFLAG_DEF);
  reader350->definitionModule = modulename;
  reader350->definitionLine = 161;
  }
  adddatum2(obj346, alloc_Undefined(), 3);
  sourceObject = obj346;
// Begin line 158
  setline(158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe351 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe352 = gc_frame_new();
// call case 3: self.outer request
  Object call353 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe352);
// compiled member node returning call353 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call354 = callmethodflags(call353, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe351);
// compiled call node returning call354 (depth = 2)
  struct UserObject *obj346_uo = (struct UserObject *)obj346;
  obj346_uo->super = call354;
  sourceObject = obj346;
// Begin line 159
  setline(159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit355 == NULL) {
    strlit355 = alloc_String("lparen");
    gc_root(strlit355);
  }
// compiled string node returning strlit355 (depth = 2)
  adddatum2(obj346, strlit355, 1);
  sourceObject = obj346;
// Begin line 160
  setline(160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit356 == NULL) {
    strlit356 = alloc_String("(");
    gc_root(strlit356);
  }
// compiled string node returning strlit356 (depth = 2)
  adddatum2(obj346, strlit356, 2);
  sourceObject = obj346;
// Begin line 161
  setline(161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num357 = alloc_Float64(1);
// compiled num node returning num357 (depth = 2)
  adddatum2(obj346, num357, 3);
  objclass346 = obj346->class;
  objclass346->definitionModule = modulename;
  objclass346->definitionLine = 157;
  (*(struct UserObject *)self).data[0] = lowerouter346;
  self = oldself346;
  selfslot = oldselfslot346;
  stackframe = oldstackframe346;
  gc_frame_end(frame);
  return obj346;
}
Object meth_lexer_359_rParenToken(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "rParenToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject360 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj360 = alloc_userobj2(3,4, objclass360);
  gc_frame_newslot(obj360);
  if (objclass360 == NULL) {
    glfree(obj360->class->name);
    obj360->class->name = "new.rParenToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj360, self, 0);
  addmethodreal(obj360,"outer", &reader_lexer_outer_361);
  Object oldself360 = self;
  struct StackFrameObject *oldstackframe360 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe360);
  gc_frame_newslot((Object)stackframe);
  self = obj360;
  Object *oldselfslot360 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter360 = (*(struct UserObject *)self).data[0], lowerouter360 = thisouter360;
  if (inheritingObject360) {
    struct UserObject *inho360 = (struct UserObject *)inheritingObject360;
    while (inho360->super != GraceDefaultObject) inho360 = (struct UserObject *)inho360->super;
    inho360->super = obj360;
    self = inheritingObject360;
    *selfslot = self;
    lowerouter360 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter360;
  }
  if (objclass360 == NULL) {
  Method *reader362 = addmethodrealflags(obj360, "kind",&reader_lexer_kind_362, MFLAG_DEF);
  reader362->definitionModule = modulename;
  reader362->definitionLine = 165;
  }
  adddatum2(obj360, alloc_Undefined(), 1);
  if (objclass360 == NULL) {
  Method *reader363 = addmethodrealflags(obj360, "value",&reader_lexer_value_363, MFLAG_DEF);
  reader363->definitionModule = modulename;
  reader363->definitionLine = 166;
  }
  adddatum2(obj360, alloc_Undefined(), 2);
  if (objclass360 == NULL) {
  Method *reader364 = addmethodrealflags(obj360, "size",&reader_lexer_size_364, MFLAG_DEF);
  reader364->definitionModule = modulename;
  reader364->definitionLine = 167;
  }
  adddatum2(obj360, alloc_Undefined(), 3);
  sourceObject = obj360;
// Begin line 164
  setline(164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe365 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe366 = gc_frame_new();
// call case 3: self.outer request
  Object call367 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe366);
// compiled member node returning call367 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call368 = callmethodflags(call367, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe365);
// compiled call node returning call368 (depth = 2)
  struct UserObject *obj360_uo = (struct UserObject *)obj360;
  obj360_uo->super = call368;
  sourceObject = obj360;
// Begin line 165
  setline(165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit369 == NULL) {
    strlit369 = alloc_String("rparen");
    gc_root(strlit369);
  }
// compiled string node returning strlit369 (depth = 2)
  adddatum2(obj360, strlit369, 1);
  sourceObject = obj360;
// Begin line 166
  setline(166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit370 == NULL) {
    strlit370 = alloc_String(")");
    gc_root(strlit370);
  }
// compiled string node returning strlit370 (depth = 2)
  adddatum2(obj360, strlit370, 2);
  sourceObject = obj360;
// Begin line 167
  setline(167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num371 = alloc_Float64(1);
// compiled num node returning num371 (depth = 2)
  adddatum2(obj360, num371, 3);
  objclass360 = obj360->class;
  objclass360->definitionModule = modulename;
  objclass360->definitionLine = 163;
  (*(struct UserObject *)self).data[0] = lowerouter360;
  self = oldself360;
  selfslot = oldselfslot360;
  stackframe = oldstackframe360;
  gc_frame_end(frame);
  return obj360;
}
Object meth_lexer_359_rParenToken_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "rParenToken$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject360 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj360 = alloc_userobj2(3,4, objclass360);
  gc_frame_newslot(obj360);
  if (objclass360 == NULL) {
    glfree(obj360->class->name);
    obj360->class->name = "new.rParenToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj360, self, 0);
  addmethodreal(obj360,"outer", &reader_lexer_outer_361);
  Object oldself360 = self;
  struct StackFrameObject *oldstackframe360 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe360);
  gc_frame_newslot((Object)stackframe);
  self = obj360;
  Object *oldselfslot360 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter360 = (*(struct UserObject *)self).data[0], lowerouter360 = thisouter360;
  if (inheritingObject360) {
    struct UserObject *inho360 = (struct UserObject *)inheritingObject360;
    while (inho360->super != GraceDefaultObject) inho360 = (struct UserObject *)inho360->super;
    inho360->super = obj360;
    self = inheritingObject360;
    *selfslot = self;
    lowerouter360 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter360;
  }
  if (objclass360 == NULL) {
  Method *reader362 = addmethodrealflags(obj360, "kind",&reader_lexer_kind_362, MFLAG_DEF);
  reader362->definitionModule = modulename;
  reader362->definitionLine = 165;
  }
  adddatum2(obj360, alloc_Undefined(), 1);
  if (objclass360 == NULL) {
  Method *reader363 = addmethodrealflags(obj360, "value",&reader_lexer_value_363, MFLAG_DEF);
  reader363->definitionModule = modulename;
  reader363->definitionLine = 166;
  }
  adddatum2(obj360, alloc_Undefined(), 2);
  if (objclass360 == NULL) {
  Method *reader364 = addmethodrealflags(obj360, "size",&reader_lexer_size_364, MFLAG_DEF);
  reader364->definitionModule = modulename;
  reader364->definitionLine = 167;
  }
  adddatum2(obj360, alloc_Undefined(), 3);
  sourceObject = obj360;
// Begin line 164
  setline(164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe365 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe366 = gc_frame_new();
// call case 3: self.outer request
  Object call367 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe366);
// compiled member node returning call367 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call368 = callmethodflags(call367, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe365);
// compiled call node returning call368 (depth = 2)
  struct UserObject *obj360_uo = (struct UserObject *)obj360;
  obj360_uo->super = call368;
  sourceObject = obj360;
// Begin line 165
  setline(165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit369 == NULL) {
    strlit369 = alloc_String("rparen");
    gc_root(strlit369);
  }
// compiled string node returning strlit369 (depth = 2)
  adddatum2(obj360, strlit369, 1);
  sourceObject = obj360;
// Begin line 166
  setline(166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit370 == NULL) {
    strlit370 = alloc_String(")");
    gc_root(strlit370);
  }
// compiled string node returning strlit370 (depth = 2)
  adddatum2(obj360, strlit370, 2);
  sourceObject = obj360;
// Begin line 167
  setline(167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num371 = alloc_Float64(1);
// compiled num node returning num371 (depth = 2)
  adddatum2(obj360, num371, 3);
  objclass360 = obj360->class;
  objclass360->definitionModule = modulename;
  objclass360->definitionLine = 163;
  (*(struct UserObject *)self).data[0] = lowerouter360;
  self = oldself360;
  selfslot = oldselfslot360;
  stackframe = oldstackframe360;
  gc_frame_end(frame);
  return obj360;
}
Object meth_lexer_373_lSquareToken(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "lSquareToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject374 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj374 = alloc_userobj2(3,4, objclass374);
  gc_frame_newslot(obj374);
  if (objclass374 == NULL) {
    glfree(obj374->class->name);
    obj374->class->name = "new.lSquareToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj374, self, 0);
  addmethodreal(obj374,"outer", &reader_lexer_outer_375);
  Object oldself374 = self;
  struct StackFrameObject *oldstackframe374 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe374);
  gc_frame_newslot((Object)stackframe);
  self = obj374;
  Object *oldselfslot374 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter374 = (*(struct UserObject *)self).data[0], lowerouter374 = thisouter374;
  if (inheritingObject374) {
    struct UserObject *inho374 = (struct UserObject *)inheritingObject374;
    while (inho374->super != GraceDefaultObject) inho374 = (struct UserObject *)inho374->super;
    inho374->super = obj374;
    self = inheritingObject374;
    *selfslot = self;
    lowerouter374 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter374;
  }
  if (objclass374 == NULL) {
  Method *reader376 = addmethodrealflags(obj374, "kind",&reader_lexer_kind_376, MFLAG_DEF);
  reader376->definitionModule = modulename;
  reader376->definitionLine = 171;
  }
  adddatum2(obj374, alloc_Undefined(), 1);
  if (objclass374 == NULL) {
  Method *reader377 = addmethodrealflags(obj374, "value",&reader_lexer_value_377, MFLAG_DEF);
  reader377->definitionModule = modulename;
  reader377->definitionLine = 172;
  }
  adddatum2(obj374, alloc_Undefined(), 2);
  if (objclass374 == NULL) {
  Method *reader378 = addmethodrealflags(obj374, "size",&reader_lexer_size_378, MFLAG_DEF);
  reader378->definitionModule = modulename;
  reader378->definitionLine = 173;
  }
  adddatum2(obj374, alloc_Undefined(), 3);
  sourceObject = obj374;
// Begin line 170
  setline(170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe379 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe380 = gc_frame_new();
// call case 3: self.outer request
  Object call381 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe380);
// compiled member node returning call381 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call382 = callmethodflags(call381, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe379);
// compiled call node returning call382 (depth = 2)
  struct UserObject *obj374_uo = (struct UserObject *)obj374;
  obj374_uo->super = call382;
  sourceObject = obj374;
// Begin line 171
  setline(171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit383 == NULL) {
    strlit383 = alloc_String("lsquare");
    gc_root(strlit383);
  }
// compiled string node returning strlit383 (depth = 2)
  adddatum2(obj374, strlit383, 1);
  sourceObject = obj374;
// Begin line 172
  setline(172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit384 == NULL) {
    strlit384 = alloc_String("[");
    gc_root(strlit384);
  }
// compiled string node returning strlit384 (depth = 2)
  adddatum2(obj374, strlit384, 2);
  sourceObject = obj374;
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num385 = alloc_Float64(1);
// compiled num node returning num385 (depth = 2)
  adddatum2(obj374, num385, 3);
  objclass374 = obj374->class;
  objclass374->definitionModule = modulename;
  objclass374->definitionLine = 169;
  (*(struct UserObject *)self).data[0] = lowerouter374;
  self = oldself374;
  selfslot = oldselfslot374;
  stackframe = oldstackframe374;
  gc_frame_end(frame);
  return obj374;
}
Object meth_lexer_373_lSquareToken_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "lSquareToken$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject374 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj374 = alloc_userobj2(3,4, objclass374);
  gc_frame_newslot(obj374);
  if (objclass374 == NULL) {
    glfree(obj374->class->name);
    obj374->class->name = "new.lSquareToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj374, self, 0);
  addmethodreal(obj374,"outer", &reader_lexer_outer_375);
  Object oldself374 = self;
  struct StackFrameObject *oldstackframe374 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe374);
  gc_frame_newslot((Object)stackframe);
  self = obj374;
  Object *oldselfslot374 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter374 = (*(struct UserObject *)self).data[0], lowerouter374 = thisouter374;
  if (inheritingObject374) {
    struct UserObject *inho374 = (struct UserObject *)inheritingObject374;
    while (inho374->super != GraceDefaultObject) inho374 = (struct UserObject *)inho374->super;
    inho374->super = obj374;
    self = inheritingObject374;
    *selfslot = self;
    lowerouter374 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter374;
  }
  if (objclass374 == NULL) {
  Method *reader376 = addmethodrealflags(obj374, "kind",&reader_lexer_kind_376, MFLAG_DEF);
  reader376->definitionModule = modulename;
  reader376->definitionLine = 171;
  }
  adddatum2(obj374, alloc_Undefined(), 1);
  if (objclass374 == NULL) {
  Method *reader377 = addmethodrealflags(obj374, "value",&reader_lexer_value_377, MFLAG_DEF);
  reader377->definitionModule = modulename;
  reader377->definitionLine = 172;
  }
  adddatum2(obj374, alloc_Undefined(), 2);
  if (objclass374 == NULL) {
  Method *reader378 = addmethodrealflags(obj374, "size",&reader_lexer_size_378, MFLAG_DEF);
  reader378->definitionModule = modulename;
  reader378->definitionLine = 173;
  }
  adddatum2(obj374, alloc_Undefined(), 3);
  sourceObject = obj374;
// Begin line 170
  setline(170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe379 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe380 = gc_frame_new();
// call case 3: self.outer request
  Object call381 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe380);
// compiled member node returning call381 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call382 = callmethodflags(call381, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe379);
// compiled call node returning call382 (depth = 2)
  struct UserObject *obj374_uo = (struct UserObject *)obj374;
  obj374_uo->super = call382;
  sourceObject = obj374;
// Begin line 171
  setline(171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit383 == NULL) {
    strlit383 = alloc_String("lsquare");
    gc_root(strlit383);
  }
// compiled string node returning strlit383 (depth = 2)
  adddatum2(obj374, strlit383, 1);
  sourceObject = obj374;
// Begin line 172
  setline(172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit384 == NULL) {
    strlit384 = alloc_String("[");
    gc_root(strlit384);
  }
// compiled string node returning strlit384 (depth = 2)
  adddatum2(obj374, strlit384, 2);
  sourceObject = obj374;
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num385 = alloc_Float64(1);
// compiled num node returning num385 (depth = 2)
  adddatum2(obj374, num385, 3);
  objclass374 = obj374->class;
  objclass374->definitionModule = modulename;
  objclass374->definitionLine = 169;
  (*(struct UserObject *)self).data[0] = lowerouter374;
  self = oldself374;
  selfslot = oldselfslot374;
  stackframe = oldstackframe374;
  gc_frame_end(frame);
  return obj374;
}
Object meth_lexer_387_rSquareToken(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "rSquareToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject388 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj388 = alloc_userobj2(3,4, objclass388);
  gc_frame_newslot(obj388);
  if (objclass388 == NULL) {
    glfree(obj388->class->name);
    obj388->class->name = "new.rSquareToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj388, self, 0);
  addmethodreal(obj388,"outer", &reader_lexer_outer_389);
  Object oldself388 = self;
  struct StackFrameObject *oldstackframe388 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe388);
  gc_frame_newslot((Object)stackframe);
  self = obj388;
  Object *oldselfslot388 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter388 = (*(struct UserObject *)self).data[0], lowerouter388 = thisouter388;
  if (inheritingObject388) {
    struct UserObject *inho388 = (struct UserObject *)inheritingObject388;
    while (inho388->super != GraceDefaultObject) inho388 = (struct UserObject *)inho388->super;
    inho388->super = obj388;
    self = inheritingObject388;
    *selfslot = self;
    lowerouter388 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter388;
  }
  if (objclass388 == NULL) {
  Method *reader390 = addmethodrealflags(obj388, "kind",&reader_lexer_kind_390, MFLAG_DEF);
  reader390->definitionModule = modulename;
  reader390->definitionLine = 177;
  }
  adddatum2(obj388, alloc_Undefined(), 1);
  if (objclass388 == NULL) {
  Method *reader391 = addmethodrealflags(obj388, "value",&reader_lexer_value_391, MFLAG_DEF);
  reader391->definitionModule = modulename;
  reader391->definitionLine = 178;
  }
  adddatum2(obj388, alloc_Undefined(), 2);
  if (objclass388 == NULL) {
  Method *reader392 = addmethodrealflags(obj388, "size",&reader_lexer_size_392, MFLAG_DEF);
  reader392->definitionModule = modulename;
  reader392->definitionLine = 179;
  }
  adddatum2(obj388, alloc_Undefined(), 3);
  sourceObject = obj388;
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe393 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe394 = gc_frame_new();
// call case 3: self.outer request
  Object call395 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe394);
// compiled member node returning call395 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call396 = callmethodflags(call395, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe393);
// compiled call node returning call396 (depth = 2)
  struct UserObject *obj388_uo = (struct UserObject *)obj388;
  obj388_uo->super = call396;
  sourceObject = obj388;
// Begin line 177
  setline(177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit397 == NULL) {
    strlit397 = alloc_String("rsquare");
    gc_root(strlit397);
  }
// compiled string node returning strlit397 (depth = 2)
  adddatum2(obj388, strlit397, 1);
  sourceObject = obj388;
// Begin line 178
  setline(178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit398 == NULL) {
    strlit398 = alloc_String("]");
    gc_root(strlit398);
  }
// compiled string node returning strlit398 (depth = 2)
  adddatum2(obj388, strlit398, 2);
  sourceObject = obj388;
// Begin line 179
  setline(179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num399 = alloc_Float64(1);
// compiled num node returning num399 (depth = 2)
  adddatum2(obj388, num399, 3);
  objclass388 = obj388->class;
  objclass388->definitionModule = modulename;
  objclass388->definitionLine = 175;
  (*(struct UserObject *)self).data[0] = lowerouter388;
  self = oldself388;
  selfslot = oldselfslot388;
  stackframe = oldstackframe388;
  gc_frame_end(frame);
  return obj388;
}
Object meth_lexer_387_rSquareToken_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "rSquareToken$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject388 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj388 = alloc_userobj2(3,4, objclass388);
  gc_frame_newslot(obj388);
  if (objclass388 == NULL) {
    glfree(obj388->class->name);
    obj388->class->name = "new.rSquareToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj388, self, 0);
  addmethodreal(obj388,"outer", &reader_lexer_outer_389);
  Object oldself388 = self;
  struct StackFrameObject *oldstackframe388 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe388);
  gc_frame_newslot((Object)stackframe);
  self = obj388;
  Object *oldselfslot388 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter388 = (*(struct UserObject *)self).data[0], lowerouter388 = thisouter388;
  if (inheritingObject388) {
    struct UserObject *inho388 = (struct UserObject *)inheritingObject388;
    while (inho388->super != GraceDefaultObject) inho388 = (struct UserObject *)inho388->super;
    inho388->super = obj388;
    self = inheritingObject388;
    *selfslot = self;
    lowerouter388 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter388;
  }
  if (objclass388 == NULL) {
  Method *reader390 = addmethodrealflags(obj388, "kind",&reader_lexer_kind_390, MFLAG_DEF);
  reader390->definitionModule = modulename;
  reader390->definitionLine = 177;
  }
  adddatum2(obj388, alloc_Undefined(), 1);
  if (objclass388 == NULL) {
  Method *reader391 = addmethodrealflags(obj388, "value",&reader_lexer_value_391, MFLAG_DEF);
  reader391->definitionModule = modulename;
  reader391->definitionLine = 178;
  }
  adddatum2(obj388, alloc_Undefined(), 2);
  if (objclass388 == NULL) {
  Method *reader392 = addmethodrealflags(obj388, "size",&reader_lexer_size_392, MFLAG_DEF);
  reader392->definitionModule = modulename;
  reader392->definitionLine = 179;
  }
  adddatum2(obj388, alloc_Undefined(), 3);
  sourceObject = obj388;
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe393 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe394 = gc_frame_new();
// call case 3: self.outer request
  Object call395 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe394);
// compiled member node returning call395 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call396 = callmethodflags(call395, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe393);
// compiled call node returning call396 (depth = 2)
  struct UserObject *obj388_uo = (struct UserObject *)obj388;
  obj388_uo->super = call396;
  sourceObject = obj388;
// Begin line 177
  setline(177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit397 == NULL) {
    strlit397 = alloc_String("rsquare");
    gc_root(strlit397);
  }
// compiled string node returning strlit397 (depth = 2)
  adddatum2(obj388, strlit397, 1);
  sourceObject = obj388;
// Begin line 178
  setline(178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit398 == NULL) {
    strlit398 = alloc_String("]");
    gc_root(strlit398);
  }
// compiled string node returning strlit398 (depth = 2)
  adddatum2(obj388, strlit398, 2);
  sourceObject = obj388;
// Begin line 179
  setline(179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num399 = alloc_Float64(1);
// compiled num node returning num399 (depth = 2)
  adddatum2(obj388, num399, 3);
  objclass388 = obj388->class;
  objclass388->definitionModule = modulename;
  objclass388->definitionLine = 175;
  (*(struct UserObject *)self).data[0] = lowerouter388;
  self = oldself388;
  selfslot = oldselfslot388;
  stackframe = oldstackframe388;
  gc_frame_end(frame);
  return obj388;
}
Object meth_lexer_401_commaToken(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "commaToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject402 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj402 = alloc_userobj2(3,4, objclass402);
  gc_frame_newslot(obj402);
  if (objclass402 == NULL) {
    glfree(obj402->class->name);
    obj402->class->name = "new.commaToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj402, self, 0);
  addmethodreal(obj402,"outer", &reader_lexer_outer_403);
  Object oldself402 = self;
  struct StackFrameObject *oldstackframe402 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe402);
  gc_frame_newslot((Object)stackframe);
  self = obj402;
  Object *oldselfslot402 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter402 = (*(struct UserObject *)self).data[0], lowerouter402 = thisouter402;
  if (inheritingObject402) {
    struct UserObject *inho402 = (struct UserObject *)inheritingObject402;
    while (inho402->super != GraceDefaultObject) inho402 = (struct UserObject *)inho402->super;
    inho402->super = obj402;
    self = inheritingObject402;
    *selfslot = self;
    lowerouter402 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter402;
  }
  if (objclass402 == NULL) {
  Method *reader404 = addmethodrealflags(obj402, "kind",&reader_lexer_kind_404, MFLAG_DEF);
  reader404->definitionModule = modulename;
  reader404->definitionLine = 183;
  }
  adddatum2(obj402, alloc_Undefined(), 1);
  if (objclass402 == NULL) {
  Method *reader405 = addmethodrealflags(obj402, "value",&reader_lexer_value_405, MFLAG_DEF);
  reader405->definitionModule = modulename;
  reader405->definitionLine = 184;
  }
  adddatum2(obj402, alloc_Undefined(), 2);
  if (objclass402 == NULL) {
  Method *reader406 = addmethodrealflags(obj402, "size",&reader_lexer_size_406, MFLAG_DEF);
  reader406->definitionModule = modulename;
  reader406->definitionLine = 185;
  }
  adddatum2(obj402, alloc_Undefined(), 3);
  sourceObject = obj402;
// Begin line 182
  setline(182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe407 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe408 = gc_frame_new();
// call case 3: self.outer request
  Object call409 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe408);
// compiled member node returning call409 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call410 = callmethodflags(call409, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe407);
// compiled call node returning call410 (depth = 2)
  struct UserObject *obj402_uo = (struct UserObject *)obj402;
  obj402_uo->super = call410;
  sourceObject = obj402;
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit411 == NULL) {
    strlit411 = alloc_String("comma");
    gc_root(strlit411);
  }
// compiled string node returning strlit411 (depth = 2)
  adddatum2(obj402, strlit411, 1);
  sourceObject = obj402;
// Begin line 184
  setline(184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit412 == NULL) {
    strlit412 = alloc_String(",");
    gc_root(strlit412);
  }
// compiled string node returning strlit412 (depth = 2)
  adddatum2(obj402, strlit412, 2);
  sourceObject = obj402;
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num413 = alloc_Float64(1);
// compiled num node returning num413 (depth = 2)
  adddatum2(obj402, num413, 3);
  objclass402 = obj402->class;
  objclass402->definitionModule = modulename;
  objclass402->definitionLine = 181;
  (*(struct UserObject *)self).data[0] = lowerouter402;
  self = oldself402;
  selfslot = oldselfslot402;
  stackframe = oldstackframe402;
  gc_frame_end(frame);
  return obj402;
}
Object meth_lexer_401_commaToken_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "commaToken$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject402 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj402 = alloc_userobj2(3,4, objclass402);
  gc_frame_newslot(obj402);
  if (objclass402 == NULL) {
    glfree(obj402->class->name);
    obj402->class->name = "new.commaToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj402, self, 0);
  addmethodreal(obj402,"outer", &reader_lexer_outer_403);
  Object oldself402 = self;
  struct StackFrameObject *oldstackframe402 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe402);
  gc_frame_newslot((Object)stackframe);
  self = obj402;
  Object *oldselfslot402 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter402 = (*(struct UserObject *)self).data[0], lowerouter402 = thisouter402;
  if (inheritingObject402) {
    struct UserObject *inho402 = (struct UserObject *)inheritingObject402;
    while (inho402->super != GraceDefaultObject) inho402 = (struct UserObject *)inho402->super;
    inho402->super = obj402;
    self = inheritingObject402;
    *selfslot = self;
    lowerouter402 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter402;
  }
  if (objclass402 == NULL) {
  Method *reader404 = addmethodrealflags(obj402, "kind",&reader_lexer_kind_404, MFLAG_DEF);
  reader404->definitionModule = modulename;
  reader404->definitionLine = 183;
  }
  adddatum2(obj402, alloc_Undefined(), 1);
  if (objclass402 == NULL) {
  Method *reader405 = addmethodrealflags(obj402, "value",&reader_lexer_value_405, MFLAG_DEF);
  reader405->definitionModule = modulename;
  reader405->definitionLine = 184;
  }
  adddatum2(obj402, alloc_Undefined(), 2);
  if (objclass402 == NULL) {
  Method *reader406 = addmethodrealflags(obj402, "size",&reader_lexer_size_406, MFLAG_DEF);
  reader406->definitionModule = modulename;
  reader406->definitionLine = 185;
  }
  adddatum2(obj402, alloc_Undefined(), 3);
  sourceObject = obj402;
// Begin line 182
  setline(182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe407 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe408 = gc_frame_new();
// call case 3: self.outer request
  Object call409 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe408);
// compiled member node returning call409 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call410 = callmethodflags(call409, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe407);
// compiled call node returning call410 (depth = 2)
  struct UserObject *obj402_uo = (struct UserObject *)obj402;
  obj402_uo->super = call410;
  sourceObject = obj402;
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit411 == NULL) {
    strlit411 = alloc_String("comma");
    gc_root(strlit411);
  }
// compiled string node returning strlit411 (depth = 2)
  adddatum2(obj402, strlit411, 1);
  sourceObject = obj402;
// Begin line 184
  setline(184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit412 == NULL) {
    strlit412 = alloc_String(",");
    gc_root(strlit412);
  }
// compiled string node returning strlit412 (depth = 2)
  adddatum2(obj402, strlit412, 2);
  sourceObject = obj402;
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num413 = alloc_Float64(1);
// compiled num node returning num413 (depth = 2)
  adddatum2(obj402, num413, 3);
  objclass402 = obj402->class;
  objclass402->definitionModule = modulename;
  objclass402->definitionLine = 181;
  (*(struct UserObject *)self).data[0] = lowerouter402;
  self = oldself402;
  selfslot = oldselfslot402;
  stackframe = oldstackframe402;
  gc_frame_end(frame);
  return obj402;
}
Object meth_lexer_415_colonToken(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "colonToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject416 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj416 = alloc_userobj2(3,4, objclass416);
  gc_frame_newslot(obj416);
  if (objclass416 == NULL) {
    glfree(obj416->class->name);
    obj416->class->name = "new.colonToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj416, self, 0);
  addmethodreal(obj416,"outer", &reader_lexer_outer_417);
  Object oldself416 = self;
  struct StackFrameObject *oldstackframe416 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe416);
  gc_frame_newslot((Object)stackframe);
  self = obj416;
  Object *oldselfslot416 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter416 = (*(struct UserObject *)self).data[0], lowerouter416 = thisouter416;
  if (inheritingObject416) {
    struct UserObject *inho416 = (struct UserObject *)inheritingObject416;
    while (inho416->super != GraceDefaultObject) inho416 = (struct UserObject *)inho416->super;
    inho416->super = obj416;
    self = inheritingObject416;
    *selfslot = self;
    lowerouter416 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter416;
  }
  if (objclass416 == NULL) {
  Method *reader418 = addmethodrealflags(obj416, "kind",&reader_lexer_kind_418, MFLAG_DEF);
  reader418->definitionModule = modulename;
  reader418->definitionLine = 189;
  }
  adddatum2(obj416, alloc_Undefined(), 1);
  if (objclass416 == NULL) {
  Method *reader419 = addmethodrealflags(obj416, "value",&reader_lexer_value_419, MFLAG_DEF);
  reader419->definitionModule = modulename;
  reader419->definitionLine = 190;
  }
  adddatum2(obj416, alloc_Undefined(), 2);
  if (objclass416 == NULL) {
  Method *reader420 = addmethodrealflags(obj416, "size",&reader_lexer_size_420, MFLAG_DEF);
  reader420->definitionModule = modulename;
  reader420->definitionLine = 191;
  }
  adddatum2(obj416, alloc_Undefined(), 3);
  sourceObject = obj416;
// Begin line 188
  setline(188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe421 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe422 = gc_frame_new();
// call case 3: self.outer request
  Object call423 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe422);
// compiled member node returning call423 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call424 = callmethodflags(call423, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe421);
// compiled call node returning call424 (depth = 2)
  struct UserObject *obj416_uo = (struct UserObject *)obj416;
  obj416_uo->super = call424;
  sourceObject = obj416;
// Begin line 189
  setline(189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit425 == NULL) {
    strlit425 = alloc_String("colon");
    gc_root(strlit425);
  }
// compiled string node returning strlit425 (depth = 2)
  adddatum2(obj416, strlit425, 1);
  sourceObject = obj416;
// Begin line 190
  setline(190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit426 == NULL) {
    strlit426 = alloc_String(":");
    gc_root(strlit426);
  }
// compiled string node returning strlit426 (depth = 2)
  adddatum2(obj416, strlit426, 2);
  sourceObject = obj416;
// Begin line 191
  setline(191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num427 = alloc_Float64(1);
// compiled num node returning num427 (depth = 2)
  adddatum2(obj416, num427, 3);
  objclass416 = obj416->class;
  objclass416->definitionModule = modulename;
  objclass416->definitionLine = 187;
  (*(struct UserObject *)self).data[0] = lowerouter416;
  self = oldself416;
  selfslot = oldselfslot416;
  stackframe = oldstackframe416;
  gc_frame_end(frame);
  return obj416;
}
Object meth_lexer_415_colonToken_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "colonToken$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject416 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj416 = alloc_userobj2(3,4, objclass416);
  gc_frame_newslot(obj416);
  if (objclass416 == NULL) {
    glfree(obj416->class->name);
    obj416->class->name = "new.colonToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj416, self, 0);
  addmethodreal(obj416,"outer", &reader_lexer_outer_417);
  Object oldself416 = self;
  struct StackFrameObject *oldstackframe416 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe416);
  gc_frame_newslot((Object)stackframe);
  self = obj416;
  Object *oldselfslot416 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter416 = (*(struct UserObject *)self).data[0], lowerouter416 = thisouter416;
  if (inheritingObject416) {
    struct UserObject *inho416 = (struct UserObject *)inheritingObject416;
    while (inho416->super != GraceDefaultObject) inho416 = (struct UserObject *)inho416->super;
    inho416->super = obj416;
    self = inheritingObject416;
    *selfslot = self;
    lowerouter416 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter416;
  }
  if (objclass416 == NULL) {
  Method *reader418 = addmethodrealflags(obj416, "kind",&reader_lexer_kind_418, MFLAG_DEF);
  reader418->definitionModule = modulename;
  reader418->definitionLine = 189;
  }
  adddatum2(obj416, alloc_Undefined(), 1);
  if (objclass416 == NULL) {
  Method *reader419 = addmethodrealflags(obj416, "value",&reader_lexer_value_419, MFLAG_DEF);
  reader419->definitionModule = modulename;
  reader419->definitionLine = 190;
  }
  adddatum2(obj416, alloc_Undefined(), 2);
  if (objclass416 == NULL) {
  Method *reader420 = addmethodrealflags(obj416, "size",&reader_lexer_size_420, MFLAG_DEF);
  reader420->definitionModule = modulename;
  reader420->definitionLine = 191;
  }
  adddatum2(obj416, alloc_Undefined(), 3);
  sourceObject = obj416;
// Begin line 188
  setline(188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe421 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe422 = gc_frame_new();
// call case 3: self.outer request
  Object call423 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe422);
// compiled member node returning call423 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call424 = callmethodflags(call423, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe421);
// compiled call node returning call424 (depth = 2)
  struct UserObject *obj416_uo = (struct UserObject *)obj416;
  obj416_uo->super = call424;
  sourceObject = obj416;
// Begin line 189
  setline(189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit425 == NULL) {
    strlit425 = alloc_String("colon");
    gc_root(strlit425);
  }
// compiled string node returning strlit425 (depth = 2)
  adddatum2(obj416, strlit425, 1);
  sourceObject = obj416;
// Begin line 190
  setline(190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit426 == NULL) {
    strlit426 = alloc_String(":");
    gc_root(strlit426);
  }
// compiled string node returning strlit426 (depth = 2)
  adddatum2(obj416, strlit426, 2);
  sourceObject = obj416;
// Begin line 191
  setline(191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num427 = alloc_Float64(1);
// compiled num node returning num427 (depth = 2)
  adddatum2(obj416, num427, 3);
  objclass416 = obj416->class;
  objclass416->definitionModule = modulename;
  objclass416->definitionLine = 187;
  (*(struct UserObject *)self).data[0] = lowerouter416;
  self = oldself416;
  selfslot = oldselfslot416;
  stackframe = oldstackframe416;
  gc_frame_end(frame);
  return obj416;
}
Object meth_lexer_429_dotToken(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "dotToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject430 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj430 = alloc_userobj2(3,4, objclass430);
  gc_frame_newslot(obj430);
  if (objclass430 == NULL) {
    glfree(obj430->class->name);
    obj430->class->name = "new.dotToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj430, self, 0);
  addmethodreal(obj430,"outer", &reader_lexer_outer_431);
  Object oldself430 = self;
  struct StackFrameObject *oldstackframe430 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe430);
  gc_frame_newslot((Object)stackframe);
  self = obj430;
  Object *oldselfslot430 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter430 = (*(struct UserObject *)self).data[0], lowerouter430 = thisouter430;
  if (inheritingObject430) {
    struct UserObject *inho430 = (struct UserObject *)inheritingObject430;
    while (inho430->super != GraceDefaultObject) inho430 = (struct UserObject *)inho430->super;
    inho430->super = obj430;
    self = inheritingObject430;
    *selfslot = self;
    lowerouter430 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter430;
  }
  if (objclass430 == NULL) {
  Method *reader432 = addmethodrealflags(obj430, "kind",&reader_lexer_kind_432, MFLAG_DEF);
  reader432->definitionModule = modulename;
  reader432->definitionLine = 195;
  }
  adddatum2(obj430, alloc_Undefined(), 1);
  if (objclass430 == NULL) {
  Method *reader433 = addmethodrealflags(obj430, "value",&reader_lexer_value_433, MFLAG_DEF);
  reader433->definitionModule = modulename;
  reader433->definitionLine = 196;
  }
  adddatum2(obj430, alloc_Undefined(), 2);
  if (objclass430 == NULL) {
  Method *reader434 = addmethodrealflags(obj430, "size",&reader_lexer_size_434, MFLAG_DEF);
  reader434->definitionModule = modulename;
  reader434->definitionLine = 197;
  }
  adddatum2(obj430, alloc_Undefined(), 3);
  sourceObject = obj430;
// Begin line 194
  setline(194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe435 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe436 = gc_frame_new();
// call case 3: self.outer request
  Object call437 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe436);
// compiled member node returning call437 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call438 = callmethodflags(call437, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe435);
// compiled call node returning call438 (depth = 2)
  struct UserObject *obj430_uo = (struct UserObject *)obj430;
  obj430_uo->super = call438;
  sourceObject = obj430;
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit439 == NULL) {
    strlit439 = alloc_String("dot");
    gc_root(strlit439);
  }
// compiled string node returning strlit439 (depth = 2)
  adddatum2(obj430, strlit439, 1);
  sourceObject = obj430;
// Begin line 196
  setline(196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit440 == NULL) {
    strlit440 = alloc_String(".");
    gc_root(strlit440);
  }
// compiled string node returning strlit440 (depth = 2)
  adddatum2(obj430, strlit440, 2);
  sourceObject = obj430;
// Begin line 197
  setline(197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num441 = alloc_Float64(1);
// compiled num node returning num441 (depth = 2)
  adddatum2(obj430, num441, 3);
  objclass430 = obj430->class;
  objclass430->definitionModule = modulename;
  objclass430->definitionLine = 193;
  (*(struct UserObject *)self).data[0] = lowerouter430;
  self = oldself430;
  selfslot = oldselfslot430;
  stackframe = oldstackframe430;
  gc_frame_end(frame);
  return obj430;
}
Object meth_lexer_429_dotToken_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "dotToken$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject430 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj430 = alloc_userobj2(3,4, objclass430);
  gc_frame_newslot(obj430);
  if (objclass430 == NULL) {
    glfree(obj430->class->name);
    obj430->class->name = "new.dotToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj430, self, 0);
  addmethodreal(obj430,"outer", &reader_lexer_outer_431);
  Object oldself430 = self;
  struct StackFrameObject *oldstackframe430 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe430);
  gc_frame_newslot((Object)stackframe);
  self = obj430;
  Object *oldselfslot430 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter430 = (*(struct UserObject *)self).data[0], lowerouter430 = thisouter430;
  if (inheritingObject430) {
    struct UserObject *inho430 = (struct UserObject *)inheritingObject430;
    while (inho430->super != GraceDefaultObject) inho430 = (struct UserObject *)inho430->super;
    inho430->super = obj430;
    self = inheritingObject430;
    *selfslot = self;
    lowerouter430 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter430;
  }
  if (objclass430 == NULL) {
  Method *reader432 = addmethodrealflags(obj430, "kind",&reader_lexer_kind_432, MFLAG_DEF);
  reader432->definitionModule = modulename;
  reader432->definitionLine = 195;
  }
  adddatum2(obj430, alloc_Undefined(), 1);
  if (objclass430 == NULL) {
  Method *reader433 = addmethodrealflags(obj430, "value",&reader_lexer_value_433, MFLAG_DEF);
  reader433->definitionModule = modulename;
  reader433->definitionLine = 196;
  }
  adddatum2(obj430, alloc_Undefined(), 2);
  if (objclass430 == NULL) {
  Method *reader434 = addmethodrealflags(obj430, "size",&reader_lexer_size_434, MFLAG_DEF);
  reader434->definitionModule = modulename;
  reader434->definitionLine = 197;
  }
  adddatum2(obj430, alloc_Undefined(), 3);
  sourceObject = obj430;
// Begin line 194
  setline(194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe435 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe436 = gc_frame_new();
// call case 3: self.outer request
  Object call437 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe436);
// compiled member node returning call437 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call438 = callmethodflags(call437, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe435);
// compiled call node returning call438 (depth = 2)
  struct UserObject *obj430_uo = (struct UserObject *)obj430;
  obj430_uo->super = call438;
  sourceObject = obj430;
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit439 == NULL) {
    strlit439 = alloc_String("dot");
    gc_root(strlit439);
  }
// compiled string node returning strlit439 (depth = 2)
  adddatum2(obj430, strlit439, 1);
  sourceObject = obj430;
// Begin line 196
  setline(196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit440 == NULL) {
    strlit440 = alloc_String(".");
    gc_root(strlit440);
  }
// compiled string node returning strlit440 (depth = 2)
  adddatum2(obj430, strlit440, 2);
  sourceObject = obj430;
// Begin line 197
  setline(197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num441 = alloc_Float64(1);
// compiled num node returning num441 (depth = 2)
  adddatum2(obj430, num441, 3);
  objclass430 = obj430->class;
  objclass430->definitionModule = modulename;
  objclass430->definitionLine = 193;
  (*(struct UserObject *)self).data[0] = lowerouter430;
  self = oldself430;
  selfslot = oldselfslot430;
  stackframe = oldstackframe430;
  gc_frame_end(frame);
  return obj430;
}
Object meth_lexer_443_numToken_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "numToken(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method numToken(_,_)");
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for numToken(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part numToken(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject444 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj444 = alloc_userobj2(4,5, objclass444);
  gc_frame_newslot(obj444);
  if (objclass444 == NULL) {
    glfree(obj444->class->name);
    obj444->class->name = "new.numToken(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj444, self, 0);
  addmethodreal(obj444,"outer", &reader_lexer_outer_445);
  Object oldself444 = self;
  struct StackFrameObject *oldstackframe444 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe444);
  gc_frame_newslot((Object)stackframe);
  self = obj444;
  Object *oldselfslot444 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter444 = (*(struct UserObject *)self).data[0], lowerouter444 = thisouter444;
  if (inheritingObject444) {
    struct UserObject *inho444 = (struct UserObject *)inheritingObject444;
    while (inho444->super != GraceDefaultObject) inho444 = (struct UserObject *)inho444->super;
    inho444->super = obj444;
    self = inheritingObject444;
    *selfslot = self;
    lowerouter444 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter444;
  }
  if (objclass444 == NULL) {
  Method *reader446 = addmethodrealflags(obj444, "kind",&reader_lexer_kind_446, MFLAG_DEF);
  reader446->definitionModule = modulename;
  reader446->definitionLine = 201;
  }
  adddatum2(obj444, alloc_Undefined(), 1);
  if (objclass444 == NULL) {
  Method *reader447 = addmethodrealflags(obj444, "value",&reader_lexer_value_447, MFLAG_DEF);
  reader447->definitionModule = modulename;
  reader447->definitionLine = 202;
  }
  adddatum2(obj444, alloc_Undefined(), 2);
  if (objclass444 == NULL) {
  Method *reader448 = addmethodrealflags(obj444, "base",&reader_lexer_base_448, MFLAG_DEF);
  reader448->definitionModule = modulename;
  reader448->definitionLine = 203;
  }
  adddatum2(obj444, alloc_Undefined(), 3);
  if (objclass444 == NULL) {
  Method *reader449 = addmethodrealflags(obj444, "size",&reader_lexer_size_449, MFLAG_DEF);
  reader449->definitionModule = modulename;
  reader449->definitionLine = 204;
  }
  adddatum2(obj444, alloc_Undefined(), 4);
  sourceObject = obj444;
// Begin line 200
  setline(200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe450 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe451 = gc_frame_new();
// call case 3: self.outer request
  Object call452 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe451);
// compiled member node returning call452 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call453 = callmethodflags(call452, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe450);
// compiled call node returning call453 (depth = 2)
  struct UserObject *obj444_uo = (struct UserObject *)obj444;
  obj444_uo->super = call453;
  sourceObject = obj444;
// Begin line 201
  setline(201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit454 == NULL) {
    strlit454 = alloc_String("num");
    gc_root(strlit454);
  }
// compiled string node returning strlit454 (depth = 2)
  adddatum2(obj444, strlit454, 1);
  sourceObject = obj444;
// Begin line 202
  setline(202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_v (depth = 2)
  adddatum2(obj444, *var_v, 2);
  sourceObject = obj444;
// Begin line 203
  setline(203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_b (depth = 2)
  adddatum2(obj444, *var_b, 3);
  sourceObject = obj444;
// Begin line 204
  setline(204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile num node (depth = 3)
  Object num456 = alloc_Float64(1);
// compiled num node returning num456 (depth = 3)
  int op_slot_right_455 = gc_frame_newslot(num456);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe459 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe460 = gc_frame_new();
// call case 3: self.outer request
  Object call461 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe460);
// compiled member node returning call461 (depth = 5)
  partcv[0] = 0;
  Object call462 = callmethodflags(call461, "startPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe459);
// compiled member node returning call462 (depth = 4)
  int op_slot_right_458 = gc_frame_newslot(call462);
// starting to compile member node (depth = 4)
  int callframe464 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe465 = gc_frame_new();
// call case 3: self.outer request
  Object call466 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe465);
// compiled member node returning call466 (depth = 5)
  partcv[0] = 0;
  Object call467 = callmethodflags(call466, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe464);
// compiled member node returning call467 (depth = 4)
  int op_slot_left_458 = gc_frame_newslot(call467);
  params[0] = call462;
  partcv[0] = 1;
  Object diff468 = callmethod(call467, "-(1)", 1, partcv, params);
// compiled op node returning diff468 (depth = 3)
  int op_slot_left_455 = gc_frame_newslot(diff468);
  params[0] = num456;
  partcv[0] = 1;
  Object sum469 = callmethod(diff468, "+(1)", 1, partcv, params);
// compiled op node returning sum469 (depth = 2)
  adddatum2(obj444, sum469, 4);
  objclass444 = obj444->class;
  objclass444->definitionModule = modulename;
  objclass444->definitionLine = 199;
  (*(struct UserObject *)self).data[0] = lowerouter444;
  self = oldself444;
  selfslot = oldselfslot444;
  stackframe = oldstackframe444;
  gc_frame_end(frame);
  return obj444;
}
Object meth_lexer_443_numToken_40_2_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "numToken(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method numToken(_,_)");
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for numToken(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part numToken(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject444 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj444 = alloc_userobj2(4,5, objclass444);
  gc_frame_newslot(obj444);
  if (objclass444 == NULL) {
    glfree(obj444->class->name);
    obj444->class->name = "new.numToken(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj444, self, 0);
  addmethodreal(obj444,"outer", &reader_lexer_outer_445);
  Object oldself444 = self;
  struct StackFrameObject *oldstackframe444 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe444);
  gc_frame_newslot((Object)stackframe);
  self = obj444;
  Object *oldselfslot444 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter444 = (*(struct UserObject *)self).data[0], lowerouter444 = thisouter444;
  if (inheritingObject444) {
    struct UserObject *inho444 = (struct UserObject *)inheritingObject444;
    while (inho444->super != GraceDefaultObject) inho444 = (struct UserObject *)inho444->super;
    inho444->super = obj444;
    self = inheritingObject444;
    *selfslot = self;
    lowerouter444 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter444;
  }
  if (objclass444 == NULL) {
  Method *reader446 = addmethodrealflags(obj444, "kind",&reader_lexer_kind_446, MFLAG_DEF);
  reader446->definitionModule = modulename;
  reader446->definitionLine = 201;
  }
  adddatum2(obj444, alloc_Undefined(), 1);
  if (objclass444 == NULL) {
  Method *reader447 = addmethodrealflags(obj444, "value",&reader_lexer_value_447, MFLAG_DEF);
  reader447->definitionModule = modulename;
  reader447->definitionLine = 202;
  }
  adddatum2(obj444, alloc_Undefined(), 2);
  if (objclass444 == NULL) {
  Method *reader448 = addmethodrealflags(obj444, "base",&reader_lexer_base_448, MFLAG_DEF);
  reader448->definitionModule = modulename;
  reader448->definitionLine = 203;
  }
  adddatum2(obj444, alloc_Undefined(), 3);
  if (objclass444 == NULL) {
  Method *reader449 = addmethodrealflags(obj444, "size",&reader_lexer_size_449, MFLAG_DEF);
  reader449->definitionModule = modulename;
  reader449->definitionLine = 204;
  }
  adddatum2(obj444, alloc_Undefined(), 4);
  sourceObject = obj444;
// Begin line 200
  setline(200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe450 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe451 = gc_frame_new();
// call case 3: self.outer request
  Object call452 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe451);
// compiled member node returning call452 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call453 = callmethodflags(call452, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe450);
// compiled call node returning call453 (depth = 2)
  struct UserObject *obj444_uo = (struct UserObject *)obj444;
  obj444_uo->super = call453;
  sourceObject = obj444;
// Begin line 201
  setline(201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit454 == NULL) {
    strlit454 = alloc_String("num");
    gc_root(strlit454);
  }
// compiled string node returning strlit454 (depth = 2)
  adddatum2(obj444, strlit454, 1);
  sourceObject = obj444;
// Begin line 202
  setline(202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_v (depth = 2)
  adddatum2(obj444, *var_v, 2);
  sourceObject = obj444;
// Begin line 203
  setline(203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_b (depth = 2)
  adddatum2(obj444, *var_b, 3);
  sourceObject = obj444;
// Begin line 204
  setline(204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile num node (depth = 3)
  Object num456 = alloc_Float64(1);
// compiled num node returning num456 (depth = 3)
  int op_slot_right_455 = gc_frame_newslot(num456);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe459 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe460 = gc_frame_new();
// call case 3: self.outer request
  Object call461 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe460);
// compiled member node returning call461 (depth = 5)
  partcv[0] = 0;
  Object call462 = callmethodflags(call461, "startPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe459);
// compiled member node returning call462 (depth = 4)
  int op_slot_right_458 = gc_frame_newslot(call462);
// starting to compile member node (depth = 4)
  int callframe464 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe465 = gc_frame_new();
// call case 3: self.outer request
  Object call466 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe465);
// compiled member node returning call466 (depth = 5)
  partcv[0] = 0;
  Object call467 = callmethodflags(call466, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe464);
// compiled member node returning call467 (depth = 4)
  int op_slot_left_458 = gc_frame_newslot(call467);
  params[0] = call462;
  partcv[0] = 1;
  Object diff468 = callmethod(call467, "-(1)", 1, partcv, params);
// compiled op node returning diff468 (depth = 3)
  int op_slot_left_455 = gc_frame_newslot(diff468);
  params[0] = num456;
  partcv[0] = 1;
  Object sum469 = callmethod(diff468, "+(1)", 1, partcv, params);
// compiled op node returning sum469 (depth = 2)
  adddatum2(obj444, sum469, 4);
  objclass444 = obj444->class;
  objclass444->definitionModule = modulename;
  objclass444->definitionLine = 199;
  (*(struct UserObject *)self).data[0] = lowerouter444;
  self = oldself444;
  selfslot = oldselfslot444;
  stackframe = oldstackframe444;
  gc_frame_end(frame);
  return obj444;
}
Object meth_lexer_471_keywordToken_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keywordToken(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keywordToken(_)");
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keywordToken(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keywordToken(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject472 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj472 = alloc_userobj2(3,4, objclass472);
  gc_frame_newslot(obj472);
  if (objclass472 == NULL) {
    glfree(obj472->class->name);
    obj472->class->name = "new.keywordToken(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj472, self, 0);
  addmethodreal(obj472,"outer", &reader_lexer_outer_473);
  Object oldself472 = self;
  struct StackFrameObject *oldstackframe472 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe472);
  gc_frame_newslot((Object)stackframe);
  self = obj472;
  Object *oldselfslot472 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter472 = (*(struct UserObject *)self).data[0], lowerouter472 = thisouter472;
  if (inheritingObject472) {
    struct UserObject *inho472 = (struct UserObject *)inheritingObject472;
    while (inho472->super != GraceDefaultObject) inho472 = (struct UserObject *)inho472->super;
    inho472->super = obj472;
    self = inheritingObject472;
    *selfslot = self;
    lowerouter472 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter472;
  }
  if (objclass472 == NULL) {
  Method *reader474 = addmethodrealflags(obj472, "kind",&reader_lexer_kind_474, MFLAG_DEF);
  reader474->definitionModule = modulename;
  reader474->definitionLine = 208;
  }
  adddatum2(obj472, alloc_Undefined(), 1);
  if (objclass472 == NULL) {
  Method *reader475 = addmethodrealflags(obj472, "value",&reader_lexer_value_475, MFLAG_DEF);
  reader475->definitionModule = modulename;
  reader475->definitionLine = 209;
  }
  adddatum2(obj472, alloc_Undefined(), 2);
  if (objclass472 == NULL) {
  Method *reader476 = addmethodrealflags(obj472, "size",&reader_lexer_size_476, MFLAG_DEF);
  reader476->definitionModule = modulename;
  reader476->definitionLine = 210;
  }
  adddatum2(obj472, alloc_Undefined(), 3);
  sourceObject = obj472;
// Begin line 207
  setline(207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe477 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe478 = gc_frame_new();
// call case 3: self.outer request
  Object call479 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe478);
// compiled member node returning call479 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call480 = callmethodflags(call479, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe477);
// compiled call node returning call480 (depth = 2)
  struct UserObject *obj472_uo = (struct UserObject *)obj472;
  obj472_uo->super = call480;
  sourceObject = obj472;
// Begin line 208
  setline(208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit481 == NULL) {
    strlit481 = alloc_String("keyword");
    gc_root(strlit481);
  }
// compiled string node returning strlit481 (depth = 2)
  adddatum2(obj472, strlit481, 1);
  sourceObject = obj472;
// Begin line 209
  setline(209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_v (depth = 2)
  adddatum2(obj472, *var_v, 2);
  sourceObject = obj472;
// Begin line 210
  setline(210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe482 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  partcv[0] = 0;
  Object call483 = callmethodflags(*var_v, "size", 1, partcv, params, 0);
  gc_frame_end(callframe482);
// compiled member node returning call483 (depth = 2)
  adddatum2(obj472, call483, 3);
  objclass472 = obj472->class;
  objclass472->definitionModule = modulename;
  objclass472->definitionLine = 206;
  (*(struct UserObject *)self).data[0] = lowerouter472;
  self = oldself472;
  selfslot = oldselfslot472;
  stackframe = oldstackframe472;
  gc_frame_end(frame);
  return obj472;
}
Object meth_lexer_471_keywordToken_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keywordToken(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method keywordToken(_)");
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keywordToken(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keywordToken(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject472 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj472 = alloc_userobj2(3,4, objclass472);
  gc_frame_newslot(obj472);
  if (objclass472 == NULL) {
    glfree(obj472->class->name);
    obj472->class->name = "new.keywordToken(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj472, self, 0);
  addmethodreal(obj472,"outer", &reader_lexer_outer_473);
  Object oldself472 = self;
  struct StackFrameObject *oldstackframe472 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe472);
  gc_frame_newslot((Object)stackframe);
  self = obj472;
  Object *oldselfslot472 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter472 = (*(struct UserObject *)self).data[0], lowerouter472 = thisouter472;
  if (inheritingObject472) {
    struct UserObject *inho472 = (struct UserObject *)inheritingObject472;
    while (inho472->super != GraceDefaultObject) inho472 = (struct UserObject *)inho472->super;
    inho472->super = obj472;
    self = inheritingObject472;
    *selfslot = self;
    lowerouter472 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter472;
  }
  if (objclass472 == NULL) {
  Method *reader474 = addmethodrealflags(obj472, "kind",&reader_lexer_kind_474, MFLAG_DEF);
  reader474->definitionModule = modulename;
  reader474->definitionLine = 208;
  }
  adddatum2(obj472, alloc_Undefined(), 1);
  if (objclass472 == NULL) {
  Method *reader475 = addmethodrealflags(obj472, "value",&reader_lexer_value_475, MFLAG_DEF);
  reader475->definitionModule = modulename;
  reader475->definitionLine = 209;
  }
  adddatum2(obj472, alloc_Undefined(), 2);
  if (objclass472 == NULL) {
  Method *reader476 = addmethodrealflags(obj472, "size",&reader_lexer_size_476, MFLAG_DEF);
  reader476->definitionModule = modulename;
  reader476->definitionLine = 210;
  }
  adddatum2(obj472, alloc_Undefined(), 3);
  sourceObject = obj472;
// Begin line 207
  setline(207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe477 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe478 = gc_frame_new();
// call case 3: self.outer request
  Object call479 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe478);
// compiled member node returning call479 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call480 = callmethodflags(call479, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe477);
// compiled call node returning call480 (depth = 2)
  struct UserObject *obj472_uo = (struct UserObject *)obj472;
  obj472_uo->super = call480;
  sourceObject = obj472;
// Begin line 208
  setline(208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit481 == NULL) {
    strlit481 = alloc_String("keyword");
    gc_root(strlit481);
  }
// compiled string node returning strlit481 (depth = 2)
  adddatum2(obj472, strlit481, 1);
  sourceObject = obj472;
// Begin line 209
  setline(209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_v (depth = 2)
  adddatum2(obj472, *var_v, 2);
  sourceObject = obj472;
// Begin line 210
  setline(210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe482 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  partcv[0] = 0;
  Object call483 = callmethodflags(*var_v, "size", 1, partcv, params, 0);
  gc_frame_end(callframe482);
// compiled member node returning call483 (depth = 2)
  adddatum2(obj472, call483, 3);
  objclass472 = obj472->class;
  objclass472->definitionModule = modulename;
  objclass472->definitionLine = 206;
  (*(struct UserObject *)self).data[0] = lowerouter472;
  self = oldself472;
  selfslot = oldselfslot472;
  stackframe = oldstackframe472;
  gc_frame_end(frame);
  return obj472;
}
Object meth_lexer_485_opToken_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "opToken(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method opToken(_)");
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for opToken(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part opToken(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject486 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj486 = alloc_userobj2(3,4, objclass486);
  gc_frame_newslot(obj486);
  if (objclass486 == NULL) {
    glfree(obj486->class->name);
    obj486->class->name = "new.opToken(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj486, self, 0);
  addmethodreal(obj486,"outer", &reader_lexer_outer_487);
  Object oldself486 = self;
  struct StackFrameObject *oldstackframe486 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe486);
  gc_frame_newslot((Object)stackframe);
  self = obj486;
  Object *oldselfslot486 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter486 = (*(struct UserObject *)self).data[0], lowerouter486 = thisouter486;
  if (inheritingObject486) {
    struct UserObject *inho486 = (struct UserObject *)inheritingObject486;
    while (inho486->super != GraceDefaultObject) inho486 = (struct UserObject *)inho486->super;
    inho486->super = obj486;
    self = inheritingObject486;
    *selfslot = self;
    lowerouter486 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter486;
  }
  if (objclass486 == NULL) {
  Method *reader488 = addmethodrealflags(obj486, "kind",&reader_lexer_kind_488, MFLAG_DEF);
  reader488->definitionModule = modulename;
  reader488->definitionLine = 214;
  }
  adddatum2(obj486, alloc_Undefined(), 1);
  if (objclass486 == NULL) {
  Method *reader489 = addmethodrealflags(obj486, "value",&reader_lexer_value_489, MFLAG_DEF);
  reader489->definitionModule = modulename;
  reader489->definitionLine = 215;
  }
  adddatum2(obj486, alloc_Undefined(), 2);
  if (objclass486 == NULL) {
  Method *reader490 = addmethodrealflags(obj486, "size",&reader_lexer_size_490, MFLAG_DEF);
  reader490->definitionModule = modulename;
  reader490->definitionLine = 216;
  }
  adddatum2(obj486, alloc_Undefined(), 3);
  sourceObject = obj486;
// Begin line 213
  setline(213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe491 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe492 = gc_frame_new();
// call case 3: self.outer request
  Object call493 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe492);
// compiled member node returning call493 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call494 = callmethodflags(call493, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe491);
// compiled call node returning call494 (depth = 2)
  struct UserObject *obj486_uo = (struct UserObject *)obj486;
  obj486_uo->super = call494;
  sourceObject = obj486;
// Begin line 214
  setline(214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit495 == NULL) {
    strlit495 = alloc_String("op");
    gc_root(strlit495);
  }
// compiled string node returning strlit495 (depth = 2)
  adddatum2(obj486, strlit495, 1);
  sourceObject = obj486;
// Begin line 215
  setline(215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_v (depth = 2)
  adddatum2(obj486, *var_v, 2);
  sourceObject = obj486;
// Begin line 216
  setline(216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe496 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  partcv[0] = 0;
  Object call497 = callmethodflags(*var_v, "size", 1, partcv, params, 0);
  gc_frame_end(callframe496);
// compiled member node returning call497 (depth = 2)
  adddatum2(obj486, call497, 3);
  objclass486 = obj486->class;
  objclass486->definitionModule = modulename;
  objclass486->definitionLine = 212;
  (*(struct UserObject *)self).data[0] = lowerouter486;
  self = oldself486;
  selfslot = oldselfslot486;
  stackframe = oldstackframe486;
  gc_frame_end(frame);
  return obj486;
}
Object meth_lexer_485_opToken_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "opToken(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method opToken(_)");
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for opToken(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part opToken(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject486 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj486 = alloc_userobj2(3,4, objclass486);
  gc_frame_newslot(obj486);
  if (objclass486 == NULL) {
    glfree(obj486->class->name);
    obj486->class->name = "new.opToken(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj486, self, 0);
  addmethodreal(obj486,"outer", &reader_lexer_outer_487);
  Object oldself486 = self;
  struct StackFrameObject *oldstackframe486 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe486);
  gc_frame_newslot((Object)stackframe);
  self = obj486;
  Object *oldselfslot486 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter486 = (*(struct UserObject *)self).data[0], lowerouter486 = thisouter486;
  if (inheritingObject486) {
    struct UserObject *inho486 = (struct UserObject *)inheritingObject486;
    while (inho486->super != GraceDefaultObject) inho486 = (struct UserObject *)inho486->super;
    inho486->super = obj486;
    self = inheritingObject486;
    *selfslot = self;
    lowerouter486 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter486;
  }
  if (objclass486 == NULL) {
  Method *reader488 = addmethodrealflags(obj486, "kind",&reader_lexer_kind_488, MFLAG_DEF);
  reader488->definitionModule = modulename;
  reader488->definitionLine = 214;
  }
  adddatum2(obj486, alloc_Undefined(), 1);
  if (objclass486 == NULL) {
  Method *reader489 = addmethodrealflags(obj486, "value",&reader_lexer_value_489, MFLAG_DEF);
  reader489->definitionModule = modulename;
  reader489->definitionLine = 215;
  }
  adddatum2(obj486, alloc_Undefined(), 2);
  if (objclass486 == NULL) {
  Method *reader490 = addmethodrealflags(obj486, "size",&reader_lexer_size_490, MFLAG_DEF);
  reader490->definitionModule = modulename;
  reader490->definitionLine = 216;
  }
  adddatum2(obj486, alloc_Undefined(), 3);
  sourceObject = obj486;
// Begin line 213
  setline(213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe491 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe492 = gc_frame_new();
// call case 3: self.outer request
  Object call493 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe492);
// compiled member node returning call493 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call494 = callmethodflags(call493, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe491);
// compiled call node returning call494 (depth = 2)
  struct UserObject *obj486_uo = (struct UserObject *)obj486;
  obj486_uo->super = call494;
  sourceObject = obj486;
// Begin line 214
  setline(214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit495 == NULL) {
    strlit495 = alloc_String("op");
    gc_root(strlit495);
  }
// compiled string node returning strlit495 (depth = 2)
  adddatum2(obj486, strlit495, 1);
  sourceObject = obj486;
// Begin line 215
  setline(215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_v (depth = 2)
  adddatum2(obj486, *var_v, 2);
  sourceObject = obj486;
// Begin line 216
  setline(216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe496 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  partcv[0] = 0;
  Object call497 = callmethodflags(*var_v, "size", 1, partcv, params, 0);
  gc_frame_end(callframe496);
// compiled member node returning call497 (depth = 2)
  adddatum2(obj486, call497, 3);
  objclass486 = obj486->class;
  objclass486->definitionModule = modulename;
  objclass486->definitionLine = 212;
  (*(struct UserObject *)self).data[0] = lowerouter486;
  self = oldself486;
  selfslot = oldselfslot486;
  stackframe = oldstackframe486;
  gc_frame_end(frame);
  return obj486;
}
Object meth_lexer_499_arrowToken(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "arrowToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject500 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj500 = alloc_userobj2(3,4, objclass500);
  gc_frame_newslot(obj500);
  if (objclass500 == NULL) {
    glfree(obj500->class->name);
    obj500->class->name = "new.arrowToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj500, self, 0);
  addmethodreal(obj500,"outer", &reader_lexer_outer_501);
  Object oldself500 = self;
  struct StackFrameObject *oldstackframe500 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe500);
  gc_frame_newslot((Object)stackframe);
  self = obj500;
  Object *oldselfslot500 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter500 = (*(struct UserObject *)self).data[0], lowerouter500 = thisouter500;
  if (inheritingObject500) {
    struct UserObject *inho500 = (struct UserObject *)inheritingObject500;
    while (inho500->super != GraceDefaultObject) inho500 = (struct UserObject *)inho500->super;
    inho500->super = obj500;
    self = inheritingObject500;
    *selfslot = self;
    lowerouter500 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter500;
  }
  if (objclass500 == NULL) {
  Method *reader502 = addmethodrealflags(obj500, "kind",&reader_lexer_kind_502, MFLAG_DEF);
  reader502->definitionModule = modulename;
  reader502->definitionLine = 220;
  }
  adddatum2(obj500, alloc_Undefined(), 1);
  if (objclass500 == NULL) {
  Method *reader503 = addmethodrealflags(obj500, "value",&reader_lexer_value_503, MFLAG_DEF);
  reader503->definitionModule = modulename;
  reader503->definitionLine = 221;
  }
  adddatum2(obj500, alloc_Undefined(), 2);
  if (objclass500 == NULL) {
  Method *reader504 = addmethodrealflags(obj500, "size",&reader_lexer_size_504, MFLAG_DEF);
  reader504->definitionModule = modulename;
  reader504->definitionLine = 222;
  }
  adddatum2(obj500, alloc_Undefined(), 3);
  sourceObject = obj500;
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe505 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe506 = gc_frame_new();
// call case 3: self.outer request
  Object call507 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe506);
// compiled member node returning call507 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call508 = callmethodflags(call507, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe505);
// compiled call node returning call508 (depth = 2)
  struct UserObject *obj500_uo = (struct UserObject *)obj500;
  obj500_uo->super = call508;
  sourceObject = obj500;
// Begin line 220
  setline(220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit509 == NULL) {
    strlit509 = alloc_String("arrow");
    gc_root(strlit509);
  }
// compiled string node returning strlit509 (depth = 2)
  adddatum2(obj500, strlit509, 1);
  sourceObject = obj500;
// Begin line 221
  setline(221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit510 == NULL) {
    strlit510 = alloc_String("""\xe2""""\x86""""\x92""");
    gc_root(strlit510);
  }
// compiled string node returning strlit510 (depth = 2)
  adddatum2(obj500, strlit510, 2);
  sourceObject = obj500;
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num511 = alloc_Float64(1);
// compiled num node returning num511 (depth = 2)
  adddatum2(obj500, num511, 3);
  objclass500 = obj500->class;
  objclass500->definitionModule = modulename;
  objclass500->definitionLine = 218;
  (*(struct UserObject *)self).data[0] = lowerouter500;
  self = oldself500;
  selfslot = oldselfslot500;
  stackframe = oldstackframe500;
  gc_frame_end(frame);
  return obj500;
}
Object meth_lexer_499_arrowToken_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "arrowToken$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject500 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj500 = alloc_userobj2(3,4, objclass500);
  gc_frame_newslot(obj500);
  if (objclass500 == NULL) {
    glfree(obj500->class->name);
    obj500->class->name = "new.arrowToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj500, self, 0);
  addmethodreal(obj500,"outer", &reader_lexer_outer_501);
  Object oldself500 = self;
  struct StackFrameObject *oldstackframe500 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe500);
  gc_frame_newslot((Object)stackframe);
  self = obj500;
  Object *oldselfslot500 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter500 = (*(struct UserObject *)self).data[0], lowerouter500 = thisouter500;
  if (inheritingObject500) {
    struct UserObject *inho500 = (struct UserObject *)inheritingObject500;
    while (inho500->super != GraceDefaultObject) inho500 = (struct UserObject *)inho500->super;
    inho500->super = obj500;
    self = inheritingObject500;
    *selfslot = self;
    lowerouter500 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter500;
  }
  if (objclass500 == NULL) {
  Method *reader502 = addmethodrealflags(obj500, "kind",&reader_lexer_kind_502, MFLAG_DEF);
  reader502->definitionModule = modulename;
  reader502->definitionLine = 220;
  }
  adddatum2(obj500, alloc_Undefined(), 1);
  if (objclass500 == NULL) {
  Method *reader503 = addmethodrealflags(obj500, "value",&reader_lexer_value_503, MFLAG_DEF);
  reader503->definitionModule = modulename;
  reader503->definitionLine = 221;
  }
  adddatum2(obj500, alloc_Undefined(), 2);
  if (objclass500 == NULL) {
  Method *reader504 = addmethodrealflags(obj500, "size",&reader_lexer_size_504, MFLAG_DEF);
  reader504->definitionModule = modulename;
  reader504->definitionLine = 222;
  }
  adddatum2(obj500, alloc_Undefined(), 3);
  sourceObject = obj500;
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe505 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe506 = gc_frame_new();
// call case 3: self.outer request
  Object call507 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe506);
// compiled member node returning call507 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call508 = callmethodflags(call507, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe505);
// compiled call node returning call508 (depth = 2)
  struct UserObject *obj500_uo = (struct UserObject *)obj500;
  obj500_uo->super = call508;
  sourceObject = obj500;
// Begin line 220
  setline(220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit509 == NULL) {
    strlit509 = alloc_String("arrow");
    gc_root(strlit509);
  }
// compiled string node returning strlit509 (depth = 2)
  adddatum2(obj500, strlit509, 1);
  sourceObject = obj500;
// Begin line 221
  setline(221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit510 == NULL) {
    strlit510 = alloc_String("""\xe2""""\x86""""\x92""");
    gc_root(strlit510);
  }
// compiled string node returning strlit510 (depth = 2)
  adddatum2(obj500, strlit510, 2);
  sourceObject = obj500;
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num511 = alloc_Float64(1);
// compiled num node returning num511 (depth = 2)
  adddatum2(obj500, num511, 3);
  objclass500 = obj500->class;
  objclass500->definitionModule = modulename;
  objclass500->definitionLine = 218;
  (*(struct UserObject *)self).data[0] = lowerouter500;
  self = oldself500;
  selfslot = oldselfslot500;
  stackframe = oldstackframe500;
  gc_frame_end(frame);
  return obj500;
}
Object meth_lexer_513_bindToken(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "bindToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject514 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj514 = alloc_userobj2(3,4, objclass514);
  gc_frame_newslot(obj514);
  if (objclass514 == NULL) {
    glfree(obj514->class->name);
    obj514->class->name = "new.bindToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj514, self, 0);
  addmethodreal(obj514,"outer", &reader_lexer_outer_515);
  Object oldself514 = self;
  struct StackFrameObject *oldstackframe514 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe514);
  gc_frame_newslot((Object)stackframe);
  self = obj514;
  Object *oldselfslot514 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter514 = (*(struct UserObject *)self).data[0], lowerouter514 = thisouter514;
  if (inheritingObject514) {
    struct UserObject *inho514 = (struct UserObject *)inheritingObject514;
    while (inho514->super != GraceDefaultObject) inho514 = (struct UserObject *)inho514->super;
    inho514->super = obj514;
    self = inheritingObject514;
    *selfslot = self;
    lowerouter514 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter514;
  }
  if (objclass514 == NULL) {
  Method *reader516 = addmethodrealflags(obj514, "kind",&reader_lexer_kind_516, MFLAG_DEF);
  reader516->definitionModule = modulename;
  reader516->definitionLine = 226;
  }
  adddatum2(obj514, alloc_Undefined(), 1);
  if (objclass514 == NULL) {
  Method *reader517 = addmethodrealflags(obj514, "value",&reader_lexer_value_517, MFLAG_DEF);
  reader517->definitionModule = modulename;
  reader517->definitionLine = 227;
  }
  adddatum2(obj514, alloc_Undefined(), 2);
  if (objclass514 == NULL) {
  Method *reader518 = addmethodrealflags(obj514, "size",&reader_lexer_size_518, MFLAG_DEF);
  reader518->definitionModule = modulename;
  reader518->definitionLine = 228;
  }
  adddatum2(obj514, alloc_Undefined(), 3);
  sourceObject = obj514;
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe519 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe520 = gc_frame_new();
// call case 3: self.outer request
  Object call521 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe520);
// compiled member node returning call521 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call522 = callmethodflags(call521, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe519);
// compiled call node returning call522 (depth = 2)
  struct UserObject *obj514_uo = (struct UserObject *)obj514;
  obj514_uo->super = call522;
  sourceObject = obj514;
// Begin line 226
  setline(226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit523 == NULL) {
    strlit523 = alloc_String("bind");
    gc_root(strlit523);
  }
// compiled string node returning strlit523 (depth = 2)
  adddatum2(obj514, strlit523, 1);
  sourceObject = obj514;
// Begin line 227
  setline(227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit524 == NULL) {
    strlit524 = alloc_String(":=");
    gc_root(strlit524);
  }
// compiled string node returning strlit524 (depth = 2)
  adddatum2(obj514, strlit524, 2);
  sourceObject = obj514;
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num525 = alloc_Float64(2);
// compiled num node returning num525 (depth = 2)
  adddatum2(obj514, num525, 3);
  objclass514 = obj514->class;
  objclass514->definitionModule = modulename;
  objclass514->definitionLine = 224;
  (*(struct UserObject *)self).data[0] = lowerouter514;
  self = oldself514;
  selfslot = oldselfslot514;
  stackframe = oldstackframe514;
  gc_frame_end(frame);
  return obj514;
}
Object meth_lexer_513_bindToken_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "bindToken$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject514 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj514 = alloc_userobj2(3,4, objclass514);
  gc_frame_newslot(obj514);
  if (objclass514 == NULL) {
    glfree(obj514->class->name);
    obj514->class->name = "new.bindToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj514, self, 0);
  addmethodreal(obj514,"outer", &reader_lexer_outer_515);
  Object oldself514 = self;
  struct StackFrameObject *oldstackframe514 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe514);
  gc_frame_newslot((Object)stackframe);
  self = obj514;
  Object *oldselfslot514 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter514 = (*(struct UserObject *)self).data[0], lowerouter514 = thisouter514;
  if (inheritingObject514) {
    struct UserObject *inho514 = (struct UserObject *)inheritingObject514;
    while (inho514->super != GraceDefaultObject) inho514 = (struct UserObject *)inho514->super;
    inho514->super = obj514;
    self = inheritingObject514;
    *selfslot = self;
    lowerouter514 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter514;
  }
  if (objclass514 == NULL) {
  Method *reader516 = addmethodrealflags(obj514, "kind",&reader_lexer_kind_516, MFLAG_DEF);
  reader516->definitionModule = modulename;
  reader516->definitionLine = 226;
  }
  adddatum2(obj514, alloc_Undefined(), 1);
  if (objclass514 == NULL) {
  Method *reader517 = addmethodrealflags(obj514, "value",&reader_lexer_value_517, MFLAG_DEF);
  reader517->definitionModule = modulename;
  reader517->definitionLine = 227;
  }
  adddatum2(obj514, alloc_Undefined(), 2);
  if (objclass514 == NULL) {
  Method *reader518 = addmethodrealflags(obj514, "size",&reader_lexer_size_518, MFLAG_DEF);
  reader518->definitionModule = modulename;
  reader518->definitionLine = 228;
  }
  adddatum2(obj514, alloc_Undefined(), 3);
  sourceObject = obj514;
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe519 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe520 = gc_frame_new();
// call case 3: self.outer request
  Object call521 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe520);
// compiled member node returning call521 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call522 = callmethodflags(call521, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe519);
// compiled call node returning call522 (depth = 2)
  struct UserObject *obj514_uo = (struct UserObject *)obj514;
  obj514_uo->super = call522;
  sourceObject = obj514;
// Begin line 226
  setline(226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit523 == NULL) {
    strlit523 = alloc_String("bind");
    gc_root(strlit523);
  }
// compiled string node returning strlit523 (depth = 2)
  adddatum2(obj514, strlit523, 1);
  sourceObject = obj514;
// Begin line 227
  setline(227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit524 == NULL) {
    strlit524 = alloc_String(":=");
    gc_root(strlit524);
  }
// compiled string node returning strlit524 (depth = 2)
  adddatum2(obj514, strlit524, 2);
  sourceObject = obj514;
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num525 = alloc_Float64(2);
// compiled num node returning num525 (depth = 2)
  adddatum2(obj514, num525, 3);
  objclass514 = obj514->class;
  objclass514->definitionModule = modulename;
  objclass514->definitionLine = 224;
  (*(struct UserObject *)self).data[0] = lowerouter514;
  self = oldself514;
  selfslot = oldselfslot514;
  stackframe = oldstackframe514;
  gc_frame_end(frame);
  return obj514;
}
Object meth_lexer_527_semicolonToken(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "semicolonToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject528 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj528 = alloc_userobj2(3,4, objclass528);
  gc_frame_newslot(obj528);
  if (objclass528 == NULL) {
    glfree(obj528->class->name);
    obj528->class->name = "new.semicolonToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj528, self, 0);
  addmethodreal(obj528,"outer", &reader_lexer_outer_529);
  Object oldself528 = self;
  struct StackFrameObject *oldstackframe528 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe528);
  gc_frame_newslot((Object)stackframe);
  self = obj528;
  Object *oldselfslot528 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter528 = (*(struct UserObject *)self).data[0], lowerouter528 = thisouter528;
  if (inheritingObject528) {
    struct UserObject *inho528 = (struct UserObject *)inheritingObject528;
    while (inho528->super != GraceDefaultObject) inho528 = (struct UserObject *)inho528->super;
    inho528->super = obj528;
    self = inheritingObject528;
    *selfslot = self;
    lowerouter528 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter528;
  }
  if (objclass528 == NULL) {
  Method *reader530 = addmethodrealflags(obj528, "kind",&reader_lexer_kind_530, MFLAG_DEF);
  reader530->definitionModule = modulename;
  reader530->definitionLine = 232;
  }
  adddatum2(obj528, alloc_Undefined(), 1);
  if (objclass528 == NULL) {
  Method *reader531 = addmethodrealflags(obj528, "value",&reader_lexer_value_531, MFLAG_DEF);
  reader531->definitionModule = modulename;
  reader531->definitionLine = 233;
  }
  adddatum2(obj528, alloc_Undefined(), 2);
  if (objclass528 == NULL) {
  Method *reader532 = addmethodrealflags(obj528, "size",&reader_lexer_size_532, MFLAG_DEF);
  reader532->definitionModule = modulename;
  reader532->definitionLine = 234;
  }
  adddatum2(obj528, alloc_Undefined(), 3);
  sourceObject = obj528;
// Begin line 231
  setline(231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe533 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe534 = gc_frame_new();
// call case 3: self.outer request
  Object call535 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe534);
// compiled member node returning call535 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call536 = callmethodflags(call535, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe533);
// compiled call node returning call536 (depth = 2)
  struct UserObject *obj528_uo = (struct UserObject *)obj528;
  obj528_uo->super = call536;
  sourceObject = obj528;
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit537 == NULL) {
    strlit537 = alloc_String("semicolon");
    gc_root(strlit537);
  }
// compiled string node returning strlit537 (depth = 2)
  adddatum2(obj528, strlit537, 1);
  sourceObject = obj528;
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit538 == NULL) {
    strlit538 = alloc_String(";");
    gc_root(strlit538);
  }
// compiled string node returning strlit538 (depth = 2)
  adddatum2(obj528, strlit538, 2);
  sourceObject = obj528;
// Begin line 234
  setline(234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num539 = alloc_Float64(1);
// compiled num node returning num539 (depth = 2)
  adddatum2(obj528, num539, 3);
  objclass528 = obj528->class;
  objclass528->definitionModule = modulename;
  objclass528->definitionLine = 230;
  (*(struct UserObject *)self).data[0] = lowerouter528;
  self = oldself528;
  selfslot = oldselfslot528;
  stackframe = oldstackframe528;
  gc_frame_end(frame);
  return obj528;
}
Object meth_lexer_527_semicolonToken_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "semicolonToken$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject528 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj528 = alloc_userobj2(3,4, objclass528);
  gc_frame_newslot(obj528);
  if (objclass528 == NULL) {
    glfree(obj528->class->name);
    obj528->class->name = "new.semicolonToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj528, self, 0);
  addmethodreal(obj528,"outer", &reader_lexer_outer_529);
  Object oldself528 = self;
  struct StackFrameObject *oldstackframe528 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe528);
  gc_frame_newslot((Object)stackframe);
  self = obj528;
  Object *oldselfslot528 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter528 = (*(struct UserObject *)self).data[0], lowerouter528 = thisouter528;
  if (inheritingObject528) {
    struct UserObject *inho528 = (struct UserObject *)inheritingObject528;
    while (inho528->super != GraceDefaultObject) inho528 = (struct UserObject *)inho528->super;
    inho528->super = obj528;
    self = inheritingObject528;
    *selfslot = self;
    lowerouter528 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter528;
  }
  if (objclass528 == NULL) {
  Method *reader530 = addmethodrealflags(obj528, "kind",&reader_lexer_kind_530, MFLAG_DEF);
  reader530->definitionModule = modulename;
  reader530->definitionLine = 232;
  }
  adddatum2(obj528, alloc_Undefined(), 1);
  if (objclass528 == NULL) {
  Method *reader531 = addmethodrealflags(obj528, "value",&reader_lexer_value_531, MFLAG_DEF);
  reader531->definitionModule = modulename;
  reader531->definitionLine = 233;
  }
  adddatum2(obj528, alloc_Undefined(), 2);
  if (objclass528 == NULL) {
  Method *reader532 = addmethodrealflags(obj528, "size",&reader_lexer_size_532, MFLAG_DEF);
  reader532->definitionModule = modulename;
  reader532->definitionLine = 234;
  }
  adddatum2(obj528, alloc_Undefined(), 3);
  sourceObject = obj528;
// Begin line 231
  setline(231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe533 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe534 = gc_frame_new();
// call case 3: self.outer request
  Object call535 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe534);
// compiled member node returning call535 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call536 = callmethodflags(call535, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe533);
// compiled call node returning call536 (depth = 2)
  struct UserObject *obj528_uo = (struct UserObject *)obj528;
  obj528_uo->super = call536;
  sourceObject = obj528;
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit537 == NULL) {
    strlit537 = alloc_String("semicolon");
    gc_root(strlit537);
  }
// compiled string node returning strlit537 (depth = 2)
  adddatum2(obj528, strlit537, 1);
  sourceObject = obj528;
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit538 == NULL) {
    strlit538 = alloc_String(";");
    gc_root(strlit538);
  }
// compiled string node returning strlit538 (depth = 2)
  adddatum2(obj528, strlit538, 2);
  sourceObject = obj528;
// Begin line 234
  setline(234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num539 = alloc_Float64(1);
// compiled num node returning num539 (depth = 2)
  adddatum2(obj528, num539, 3);
  objclass528 = obj528->class;
  objclass528->definitionModule = modulename;
  objclass528->definitionLine = 230;
  (*(struct UserObject *)self).data[0] = lowerouter528;
  self = oldself528;
  selfslot = oldselfslot528;
  stackframe = oldstackframe528;
  gc_frame_end(frame);
  return obj528;
}
Object meth_lexer_541_lGenericToken(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "lGenericToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject542 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj542 = alloc_userobj2(3,4, objclass542);
  gc_frame_newslot(obj542);
  if (objclass542 == NULL) {
    glfree(obj542->class->name);
    obj542->class->name = "new.lGenericToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj542, self, 0);
  addmethodreal(obj542,"outer", &reader_lexer_outer_543);
  Object oldself542 = self;
  struct StackFrameObject *oldstackframe542 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe542);
  gc_frame_newslot((Object)stackframe);
  self = obj542;
  Object *oldselfslot542 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter542 = (*(struct UserObject *)self).data[0], lowerouter542 = thisouter542;
  if (inheritingObject542) {
    struct UserObject *inho542 = (struct UserObject *)inheritingObject542;
    while (inho542->super != GraceDefaultObject) inho542 = (struct UserObject *)inho542->super;
    inho542->super = obj542;
    self = inheritingObject542;
    *selfslot = self;
    lowerouter542 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter542;
  }
  if (objclass542 == NULL) {
  Method *reader544 = addmethodrealflags(obj542, "kind",&reader_lexer_kind_544, MFLAG_DEF);
  reader544->definitionModule = modulename;
  reader544->definitionLine = 238;
  }
  adddatum2(obj542, alloc_Undefined(), 1);
  if (objclass542 == NULL) {
  Method *reader545 = addmethodrealflags(obj542, "value",&reader_lexer_value_545, MFLAG_DEF);
  reader545->definitionModule = modulename;
  reader545->definitionLine = 239;
  }
  adddatum2(obj542, alloc_Undefined(), 2);
  if (objclass542 == NULL) {
  Method *reader546 = addmethodrealflags(obj542, "size",&reader_lexer_size_546, MFLAG_DEF);
  reader546->definitionModule = modulename;
  reader546->definitionLine = 240;
  }
  adddatum2(obj542, alloc_Undefined(), 3);
  sourceObject = obj542;
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe547 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe548 = gc_frame_new();
// call case 3: self.outer request
  Object call549 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe548);
// compiled member node returning call549 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call550 = callmethodflags(call549, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe547);
// compiled call node returning call550 (depth = 2)
  struct UserObject *obj542_uo = (struct UserObject *)obj542;
  obj542_uo->super = call550;
  sourceObject = obj542;
// Begin line 238
  setline(238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit551 == NULL) {
    strlit551 = alloc_String("lgeneric");
    gc_root(strlit551);
  }
// compiled string node returning strlit551 (depth = 2)
  adddatum2(obj542, strlit551, 1);
  sourceObject = obj542;
// Begin line 239
  setline(239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit552 == NULL) {
    strlit552 = alloc_String("""\xe2""""\x9f""""\xa6""");
    gc_root(strlit552);
  }
// compiled string node returning strlit552 (depth = 2)
  adddatum2(obj542, strlit552, 2);
  sourceObject = obj542;
// Begin line 240
  setline(240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num553 = alloc_Float64(1);
// compiled num node returning num553 (depth = 2)
  adddatum2(obj542, num553, 3);
  objclass542 = obj542->class;
  objclass542->definitionModule = modulename;
  objclass542->definitionLine = 236;
  (*(struct UserObject *)self).data[0] = lowerouter542;
  self = oldself542;
  selfslot = oldselfslot542;
  stackframe = oldstackframe542;
  gc_frame_end(frame);
  return obj542;
}
Object meth_lexer_541_lGenericToken_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "lGenericToken$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject542 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj542 = alloc_userobj2(3,4, objclass542);
  gc_frame_newslot(obj542);
  if (objclass542 == NULL) {
    glfree(obj542->class->name);
    obj542->class->name = "new.lGenericToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj542, self, 0);
  addmethodreal(obj542,"outer", &reader_lexer_outer_543);
  Object oldself542 = self;
  struct StackFrameObject *oldstackframe542 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe542);
  gc_frame_newslot((Object)stackframe);
  self = obj542;
  Object *oldselfslot542 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter542 = (*(struct UserObject *)self).data[0], lowerouter542 = thisouter542;
  if (inheritingObject542) {
    struct UserObject *inho542 = (struct UserObject *)inheritingObject542;
    while (inho542->super != GraceDefaultObject) inho542 = (struct UserObject *)inho542->super;
    inho542->super = obj542;
    self = inheritingObject542;
    *selfslot = self;
    lowerouter542 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter542;
  }
  if (objclass542 == NULL) {
  Method *reader544 = addmethodrealflags(obj542, "kind",&reader_lexer_kind_544, MFLAG_DEF);
  reader544->definitionModule = modulename;
  reader544->definitionLine = 238;
  }
  adddatum2(obj542, alloc_Undefined(), 1);
  if (objclass542 == NULL) {
  Method *reader545 = addmethodrealflags(obj542, "value",&reader_lexer_value_545, MFLAG_DEF);
  reader545->definitionModule = modulename;
  reader545->definitionLine = 239;
  }
  adddatum2(obj542, alloc_Undefined(), 2);
  if (objclass542 == NULL) {
  Method *reader546 = addmethodrealflags(obj542, "size",&reader_lexer_size_546, MFLAG_DEF);
  reader546->definitionModule = modulename;
  reader546->definitionLine = 240;
  }
  adddatum2(obj542, alloc_Undefined(), 3);
  sourceObject = obj542;
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe547 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe548 = gc_frame_new();
// call case 3: self.outer request
  Object call549 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe548);
// compiled member node returning call549 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call550 = callmethodflags(call549, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe547);
// compiled call node returning call550 (depth = 2)
  struct UserObject *obj542_uo = (struct UserObject *)obj542;
  obj542_uo->super = call550;
  sourceObject = obj542;
// Begin line 238
  setline(238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit551 == NULL) {
    strlit551 = alloc_String("lgeneric");
    gc_root(strlit551);
  }
// compiled string node returning strlit551 (depth = 2)
  adddatum2(obj542, strlit551, 1);
  sourceObject = obj542;
// Begin line 239
  setline(239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit552 == NULL) {
    strlit552 = alloc_String("""\xe2""""\x9f""""\xa6""");
    gc_root(strlit552);
  }
// compiled string node returning strlit552 (depth = 2)
  adddatum2(obj542, strlit552, 2);
  sourceObject = obj542;
// Begin line 240
  setline(240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num553 = alloc_Float64(1);
// compiled num node returning num553 (depth = 2)
  adddatum2(obj542, num553, 3);
  objclass542 = obj542->class;
  objclass542->definitionModule = modulename;
  objclass542->definitionLine = 236;
  (*(struct UserObject *)self).data[0] = lowerouter542;
  self = oldself542;
  selfslot = oldselfslot542;
  stackframe = oldstackframe542;
  gc_frame_end(frame);
  return obj542;
}
Object meth_lexer_555_rGenericToken(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "rGenericToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject556 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj556 = alloc_userobj2(3,4, objclass556);
  gc_frame_newslot(obj556);
  if (objclass556 == NULL) {
    glfree(obj556->class->name);
    obj556->class->name = "new.rGenericToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj556, self, 0);
  addmethodreal(obj556,"outer", &reader_lexer_outer_557);
  Object oldself556 = self;
  struct StackFrameObject *oldstackframe556 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe556);
  gc_frame_newslot((Object)stackframe);
  self = obj556;
  Object *oldselfslot556 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter556 = (*(struct UserObject *)self).data[0], lowerouter556 = thisouter556;
  if (inheritingObject556) {
    struct UserObject *inho556 = (struct UserObject *)inheritingObject556;
    while (inho556->super != GraceDefaultObject) inho556 = (struct UserObject *)inho556->super;
    inho556->super = obj556;
    self = inheritingObject556;
    *selfslot = self;
    lowerouter556 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter556;
  }
  if (objclass556 == NULL) {
  Method *reader558 = addmethodrealflags(obj556, "kind",&reader_lexer_kind_558, MFLAG_DEF);
  reader558->definitionModule = modulename;
  reader558->definitionLine = 244;
  }
  adddatum2(obj556, alloc_Undefined(), 1);
  if (objclass556 == NULL) {
  Method *reader559 = addmethodrealflags(obj556, "value",&reader_lexer_value_559, MFLAG_DEF);
  reader559->definitionModule = modulename;
  reader559->definitionLine = 245;
  }
  adddatum2(obj556, alloc_Undefined(), 2);
  if (objclass556 == NULL) {
  Method *reader560 = addmethodrealflags(obj556, "size",&reader_lexer_size_560, MFLAG_DEF);
  reader560->definitionModule = modulename;
  reader560->definitionLine = 246;
  }
  adddatum2(obj556, alloc_Undefined(), 3);
  sourceObject = obj556;
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe561 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe562 = gc_frame_new();
// call case 3: self.outer request
  Object call563 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe562);
// compiled member node returning call563 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call564 = callmethodflags(call563, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe561);
// compiled call node returning call564 (depth = 2)
  struct UserObject *obj556_uo = (struct UserObject *)obj556;
  obj556_uo->super = call564;
  sourceObject = obj556;
// Begin line 244
  setline(244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit565 == NULL) {
    strlit565 = alloc_String("rgeneric");
    gc_root(strlit565);
  }
// compiled string node returning strlit565 (depth = 2)
  adddatum2(obj556, strlit565, 1);
  sourceObject = obj556;
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit566 == NULL) {
    strlit566 = alloc_String("""\xe2""""\x9f""""\xa7""");
    gc_root(strlit566);
  }
// compiled string node returning strlit566 (depth = 2)
  adddatum2(obj556, strlit566, 2);
  sourceObject = obj556;
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num567 = alloc_Float64(1);
// compiled num node returning num567 (depth = 2)
  adddatum2(obj556, num567, 3);
  objclass556 = obj556->class;
  objclass556->definitionModule = modulename;
  objclass556->definitionLine = 242;
  (*(struct UserObject *)self).data[0] = lowerouter556;
  self = oldself556;
  selfslot = oldselfslot556;
  stackframe = oldstackframe556;
  gc_frame_end(frame);
  return obj556;
}
Object meth_lexer_555_rGenericToken_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "rGenericToken$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject556 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj556 = alloc_userobj2(3,4, objclass556);
  gc_frame_newslot(obj556);
  if (objclass556 == NULL) {
    glfree(obj556->class->name);
    obj556->class->name = "new.rGenericToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj556, self, 0);
  addmethodreal(obj556,"outer", &reader_lexer_outer_557);
  Object oldself556 = self;
  struct StackFrameObject *oldstackframe556 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe556);
  gc_frame_newslot((Object)stackframe);
  self = obj556;
  Object *oldselfslot556 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter556 = (*(struct UserObject *)self).data[0], lowerouter556 = thisouter556;
  if (inheritingObject556) {
    struct UserObject *inho556 = (struct UserObject *)inheritingObject556;
    while (inho556->super != GraceDefaultObject) inho556 = (struct UserObject *)inho556->super;
    inho556->super = obj556;
    self = inheritingObject556;
    *selfslot = self;
    lowerouter556 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter556;
  }
  if (objclass556 == NULL) {
  Method *reader558 = addmethodrealflags(obj556, "kind",&reader_lexer_kind_558, MFLAG_DEF);
  reader558->definitionModule = modulename;
  reader558->definitionLine = 244;
  }
  adddatum2(obj556, alloc_Undefined(), 1);
  if (objclass556 == NULL) {
  Method *reader559 = addmethodrealflags(obj556, "value",&reader_lexer_value_559, MFLAG_DEF);
  reader559->definitionModule = modulename;
  reader559->definitionLine = 245;
  }
  adddatum2(obj556, alloc_Undefined(), 2);
  if (objclass556 == NULL) {
  Method *reader560 = addmethodrealflags(obj556, "size",&reader_lexer_size_560, MFLAG_DEF);
  reader560->definitionModule = modulename;
  reader560->definitionLine = 246;
  }
  adddatum2(obj556, alloc_Undefined(), 3);
  sourceObject = obj556;
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe561 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe562 = gc_frame_new();
// call case 3: self.outer request
  Object call563 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe562);
// compiled member node returning call563 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call564 = callmethodflags(call563, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe561);
// compiled call node returning call564 (depth = 2)
  struct UserObject *obj556_uo = (struct UserObject *)obj556;
  obj556_uo->super = call564;
  sourceObject = obj556;
// Begin line 244
  setline(244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit565 == NULL) {
    strlit565 = alloc_String("rgeneric");
    gc_root(strlit565);
  }
// compiled string node returning strlit565 (depth = 2)
  adddatum2(obj556, strlit565, 1);
  sourceObject = obj556;
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit566 == NULL) {
    strlit566 = alloc_String("""\xe2""""\x9f""""\xa7""");
    gc_root(strlit566);
  }
// compiled string node returning strlit566 (depth = 2)
  adddatum2(obj556, strlit566, 2);
  sourceObject = obj556;
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num567 = alloc_Float64(1);
// compiled num node returning num567 (depth = 2)
  adddatum2(obj556, num567, 3);
  objclass556 = obj556->class;
  objclass556->definitionModule = modulename;
  objclass556->definitionLine = 242;
  (*(struct UserObject *)self).data[0] = lowerouter556;
  self = oldself556;
  selfslot = oldselfslot556;
  stackframe = oldstackframe556;
  gc_frame_end(frame);
  return obj556;
}
Object meth_lexer_569_eofToken(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "eofToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject570 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj570 = alloc_userobj2(3,4, objclass570);
  gc_frame_newslot(obj570);
  if (objclass570 == NULL) {
    glfree(obj570->class->name);
    obj570->class->name = "new.eofToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj570, self, 0);
  addmethodreal(obj570,"outer", &reader_lexer_outer_571);
  Object oldself570 = self;
  struct StackFrameObject *oldstackframe570 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe570);
  gc_frame_newslot((Object)stackframe);
  self = obj570;
  Object *oldselfslot570 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter570 = (*(struct UserObject *)self).data[0], lowerouter570 = thisouter570;
  if (inheritingObject570) {
    struct UserObject *inho570 = (struct UserObject *)inheritingObject570;
    while (inho570->super != GraceDefaultObject) inho570 = (struct UserObject *)inho570->super;
    inho570->super = obj570;
    self = inheritingObject570;
    *selfslot = self;
    lowerouter570 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter570;
  }
  if (objclass570 == NULL) {
  Method *reader572 = addmethodrealflags(obj570, "kind",&reader_lexer_kind_572, MFLAG_DEF);
  reader572->definitionModule = modulename;
  reader572->definitionLine = 250;
  }
  adddatum2(obj570, alloc_Undefined(), 1);
  if (objclass570 == NULL) {
  Method *reader573 = addmethodrealflags(obj570, "value",&reader_lexer_value_573, MFLAG_DEF);
  reader573->definitionModule = modulename;
  reader573->definitionLine = 251;
  }
  adddatum2(obj570, alloc_Undefined(), 2);
  if (objclass570 == NULL) {
  Method *reader574 = addmethodrealflags(obj570, "size",&reader_lexer_size_574, MFLAG_DEF);
  reader574->definitionModule = modulename;
  reader574->definitionLine = 252;
  }
  adddatum2(obj570, alloc_Undefined(), 3);
  sourceObject = obj570;
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe575 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe576 = gc_frame_new();
// call case 3: self.outer request
  Object call577 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe576);
// compiled member node returning call577 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call578 = callmethodflags(call577, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe575);
// compiled call node returning call578 (depth = 2)
  struct UserObject *obj570_uo = (struct UserObject *)obj570;
  obj570_uo->super = call578;
  sourceObject = obj570;
// Begin line 250
  setline(250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit579 == NULL) {
    strlit579 = alloc_String("eof");
    gc_root(strlit579);
  }
// compiled string node returning strlit579 (depth = 2)
  adddatum2(obj570, strlit579, 1);
  sourceObject = obj570;
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit580 == NULL) {
    strlit580 = alloc_String("");
    gc_root(strlit580);
  }
// compiled string node returning strlit580 (depth = 2)
  adddatum2(obj570, strlit580, 2);
  sourceObject = obj570;
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num581 = alloc_Float64(0);
// compiled num node returning num581 (depth = 2)
  adddatum2(obj570, num581, 3);
  objclass570 = obj570->class;
  objclass570->definitionModule = modulename;
  objclass570->definitionLine = 248;
  (*(struct UserObject *)self).data[0] = lowerouter570;
  self = oldself570;
  selfslot = oldselfslot570;
  stackframe = oldstackframe570;
  gc_frame_end(frame);
  return obj570;
}
Object meth_lexer_569_eofToken_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "eofToken$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject570 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj570 = alloc_userobj2(3,4, objclass570);
  gc_frame_newslot(obj570);
  if (objclass570 == NULL) {
    glfree(obj570->class->name);
    obj570->class->name = "new.eofToken";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj570, self, 0);
  addmethodreal(obj570,"outer", &reader_lexer_outer_571);
  Object oldself570 = self;
  struct StackFrameObject *oldstackframe570 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe570);
  gc_frame_newslot((Object)stackframe);
  self = obj570;
  Object *oldselfslot570 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter570 = (*(struct UserObject *)self).data[0], lowerouter570 = thisouter570;
  if (inheritingObject570) {
    struct UserObject *inho570 = (struct UserObject *)inheritingObject570;
    while (inho570->super != GraceDefaultObject) inho570 = (struct UserObject *)inho570->super;
    inho570->super = obj570;
    self = inheritingObject570;
    *selfslot = self;
    lowerouter570 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter570;
  }
  if (objclass570 == NULL) {
  Method *reader572 = addmethodrealflags(obj570, "kind",&reader_lexer_kind_572, MFLAG_DEF);
  reader572->definitionModule = modulename;
  reader572->definitionLine = 250;
  }
  adddatum2(obj570, alloc_Undefined(), 1);
  if (objclass570 == NULL) {
  Method *reader573 = addmethodrealflags(obj570, "value",&reader_lexer_value_573, MFLAG_DEF);
  reader573->definitionModule = modulename;
  reader573->definitionLine = 251;
  }
  adddatum2(obj570, alloc_Undefined(), 2);
  if (objclass570 == NULL) {
  Method *reader574 = addmethodrealflags(obj570, "size",&reader_lexer_size_574, MFLAG_DEF);
  reader574->definitionModule = modulename;
  reader574->definitionLine = 252;
  }
  adddatum2(obj570, alloc_Undefined(), 3);
  sourceObject = obj570;
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe575 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe576 = gc_frame_new();
// call case 3: self.outer request
  Object call577 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe576);
// compiled member node returning call577 (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call578 = callmethodflags(call577, "token$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe575);
// compiled call node returning call578 (depth = 2)
  struct UserObject *obj570_uo = (struct UserObject *)obj570;
  obj570_uo->super = call578;
  sourceObject = obj570;
// Begin line 250
  setline(250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit579 == NULL) {
    strlit579 = alloc_String("eof");
    gc_root(strlit579);
  }
// compiled string node returning strlit579 (depth = 2)
  adddatum2(obj570, strlit579, 1);
  sourceObject = obj570;
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit580 == NULL) {
    strlit580 = alloc_String("");
    gc_root(strlit580);
  }
// compiled string node returning strlit580 (depth = 2)
  adddatum2(obj570, strlit580, 2);
  sourceObject = obj570;
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num581 = alloc_Float64(0);
// compiled num node returning num581 (depth = 2)
  adddatum2(obj570, num581, 3);
  objclass570 = obj570->class;
  objclass570->definitionModule = modulename;
  objclass570->definitionLine = 248;
  (*(struct UserObject *)self).data[0] = lowerouter570;
  self = oldself570;
  selfslot = oldselfslot570;
  stackframe = oldstackframe570;
  gc_frame_end(frame);
  return obj570;
}
Object meth_lexer_590_advanceTo_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "advanceTo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method advanceTo(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for advanceTo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part advanceTo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 264
  setline(264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe591 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_newslot(*var_s);
// call case 4: self request
  params[0] = *var_s;
  partcv[0] = 1;
  Object call592 = callmethodflags(self, "state:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe591);
// compiled call node returning call592 (depth = 2)
  gc_frame_end(frame);
  return call592;
}
Object meth_lexer_593_emit_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "emit(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method emit(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for emit(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part emit(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 266
  setline(266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe594 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe595 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call596 = callmethodflags(self, "tokens", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe595);
// compiled member node returning call596 (depth = 3)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call597 = callmethodflags(call596, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe594);
// compiled call node returning call597 (depth = 2)
// Begin line 267
  setline(267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe598 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit599 == NULL) {
    strlit599 = alloc_String("");
    gc_root(strlit599);
  }
// compiled string node returning strlit599 (depth = 3)
  gc_frame_newslot(strlit599);
// call case 4: self request
  params[0] = strlit599;
  partcv[0] = 1;
  Object call600 = callmethodflags(self, "accum:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe598);
// compiled call node returning call600 (depth = 2)
  gc_frame_end(frame);
  return call600;
}
Object meth_lexer_601_store_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "store(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method store(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for store(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part store(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 269
  setline(269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe602 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_right_603 = gc_frame_newslot(*var_c);
// starting to compile member node (depth = 4)
  int callframe605 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call606 = callmethodflags(self, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe605);
// compiled member node returning call606 (depth = 4)
  int op_slot_left_603 = gc_frame_newslot(call606);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult607 = callmethod(call606, "++(1)", 1, partcv, params);
// compiled op node returning opresult607 (depth = 3)
  gc_frame_newslot(opresult607);
// call case 4: self request
  params[0] = opresult607;
  partcv[0] = 1;
  Object call608 = callmethodflags(self, "accum:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe602);
// compiled call node returning call608 (depth = 2)
  gc_frame_end(frame);
  return call608;
}
Object meth_lexer_652__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_line = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit654 == NULL) {
    strlit654 = alloc_String("{");
    gc_root(strlit654);
  }
// compiled string node returning strlit654 (depth = 6)
  int op_slot_right_653 = gc_frame_newslot(strlit654);
// starting to compile call node (depth = 6)
  int callframe656 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe657 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  gc_frame_newslot(*var_line);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe658 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_util (depth = 9)
  partcv[0] = 0;
  Object call659 = callmethodflags(*var_util, "lines", 1, partcv, params, 0);
  gc_frame_end(callframe658);
// compiled member node returning call659 (depth = 8)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call660 = callmethodflags(call659, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe657);
// compiled call node returning call660 (depth = 7)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call661 = callmethodflags(call660, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe656);
// compiled call node returning call661 (depth = 6)
  int op_slot_left_653 = gc_frame_newslot(call661);
  params[0] = strlit654;
  partcv[0] = 1;
  Object opresult662 = callmethod(call661, "≠(1)", 1, partcv, params);
// compiled op node returning opresult662 (depth = 5)
  gc_frame_end(frame);
  return opresult662;
}
Object meth_lexer_665__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_line = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 809
  setline(809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num667 = alloc_Float64(1);
// compiled num node returning num667 (depth = 7)
  int op_slot_right_666 = gc_frame_newslot(num667);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  int op_slot_left_666 = gc_frame_newslot(*var_i);
  params[0] = num667;
  partcv[0] = 1;
  Object diff669 = callmethod(*var_i, "-(1)", 1, partcv, params);
// compiled op node returning diff669 (depth = 6)
  *var_i = diff669;
  if (diff669 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 810
  setline(810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num673 = alloc_Float64(0);
// compiled num node returning num673 (depth = 7)
  int op_slot_right_672 = gc_frame_newslot(num673);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  int op_slot_left_672 = gc_frame_newslot(*var_i);
  params[0] = num673;
  partcv[0] = 1;
  Object opresult675 = callmethod(*var_i, "==(1)", 1, partcv, params);
// compiled op node returning opresult675 (depth = 6)
  Object if671 = done;
  if (istrue(opresult675)) {
// Begin line 811
  setline(811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe676 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num678 = alloc_Float64(1);
// compiled num node returning num678 (depth = 8)
  int op_slot_right_677 = gc_frame_newslot(num678);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  int op_slot_left_677 = gc_frame_newslot(*var_line);
  params[0] = num678;
  partcv[0] = 1;
  Object diff680 = callmethod(*var_line, "-(1)", 1, partcv, params);
// compiled op node returning diff680 (depth = 7)
  gc_frame_newslot(diff680);
// call case 4: self request
  params[0] = diff680;
  partcv[0] = 1;
  Object call681 = callmethodflags(self, "lineNumber:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe676);
// compiled call node returning call681 (depth = 6)
// Begin line 812
  setline(812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe682 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 8)
  int callframe683 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_line (depth = 9)
  gc_frame_newslot(*var_line);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe684 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_util (depth = 10)
  partcv[0] = 0;
  Object call685 = callmethodflags(*var_util, "lines", 1, partcv, params, 0);
  gc_frame_end(callframe684);
// compiled member node returning call685 (depth = 9)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call686 = callmethodflags(call685, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe683);
// compiled call node returning call686 (depth = 8)
  partcv[0] = 0;
  Object call687 = callmethodflags(call686, "size", 1, partcv, params, 0);
  gc_frame_end(callframe682);
// compiled member node returning call687 (depth = 7)
  *var_i = call687;
  if (call687 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if671 = done;
  } else {
  }
// compiled if node returning if671 (depth = 5)
  gc_frame_end(frame);
  return if671;
}
Object meth_lexer_800__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextLine = getfromclosure(closure, 0);
  Object *var_i = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe802 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextLine (depth = 7)
  partcv[0] = 0;
  Object call803 = callmethodflags(*var_nextLine, "size", 1, partcv, params, 0);
  gc_frame_end(callframe802);
// compiled member node returning call803 (depth = 6)
  int op_slot_right_801 = gc_frame_newslot(call803);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_801 = gc_frame_newslot(*var_i);
  params[0] = call803;
  partcv[0] = 1;
  Object opresult805 = callmethod(*var_i, "≤(1)", 1, partcv, params);
// compiled op node returning opresult805 (depth = 5)
  gc_frame_end(frame);
  return opresult805;
}
Object meth_lexer_808__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_nextLine = getfromclosure(closure, 1);
  Object *var_count = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 840
  setline(840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit811 == NULL) {
    strlit811 = alloc_String("""\x22""");
    gc_root(strlit811);
  }
// compiled string node returning strlit811 (depth = 7)
  int op_slot_right_810 = gc_frame_newslot(strlit811);
// starting to compile call node (depth = 7)
  int callframe813 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextLine (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call814 = callmethodflags(*var_nextLine, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe813);
// compiled call node returning call814 (depth = 7)
  int op_slot_left_810 = gc_frame_newslot(call814);
  params[0] = strlit811;
  partcv[0] = 1;
  Object opresult815 = callmethod(call814, "==(1)", 1, partcv, params);
// compiled op node returning opresult815 (depth = 6)
  Object if809 = done;
  if (istrue(opresult815)) {
// Begin line 841
  setline(841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num817 = alloc_Float64(1);
// compiled num node returning num817 (depth = 8)
  int op_slot_right_816 = gc_frame_newslot(num817);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_count (depth = 8)
  int op_slot_left_816 = gc_frame_newslot(*var_count);
  params[0] = num817;
  partcv[0] = 1;
  Object sum819 = callmethod(*var_count, "+(1)", 1, partcv, params);
// compiled op node returning sum819 (depth = 7)
  *var_count = sum819;
  if (sum819 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if809 = done;
  } else {
// Begin line 847
  setline(847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 843
  setline(843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit823 == NULL) {
    strlit823 = alloc_String("\\");
    gc_root(strlit823);
  }
// compiled string node returning strlit823 (depth = 8)
  int op_slot_right_822 = gc_frame_newslot(strlit823);
// starting to compile call node (depth = 8)
  int callframe825 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextLine (depth = 9)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call826 = callmethodflags(*var_nextLine, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe825);
// compiled call node returning call826 (depth = 8)
  int op_slot_left_822 = gc_frame_newslot(call826);
  params[0] = strlit823;
  partcv[0] = 1;
  Object opresult827 = callmethod(call826, "==(1)", 1, partcv, params);
// compiled op node returning opresult827 (depth = 7)
  Object if821 = done;
  if (istrue(opresult827)) {
// Begin line 845
  setline(845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num829 = alloc_Float64(1);
// compiled num node returning num829 (depth = 9)
  int op_slot_right_828 = gc_frame_newslot(num829);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_left_828 = gc_frame_newslot(*var_i);
  params[0] = num829;
  partcv[0] = 1;
  Object sum831 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum831 (depth = 8)
  *var_i = sum831;
  if (sum831 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if821 = done;
  } else {
  }
// compiled if node returning if821 (depth = 6)
    gc_frame_newslot(if821);
    if809 = if821;
  }
// compiled if node returning if809 (depth = 5)
// Begin line 847
  setline(847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num834 = alloc_Float64(1);
// compiled num node returning num834 (depth = 7)
  int op_slot_right_833 = gc_frame_newslot(num834);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  int op_slot_left_833 = gc_frame_newslot(*var_i);
  params[0] = num834;
  partcv[0] = 1;
  Object sum836 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum836 (depth = 6)
  *var_i = sum836;
  if (sum836 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer_634_newLineError(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 67, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(12, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "newLineError");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_line = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "line");
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
// definebindings:
// definebindings:
// definebindings:
  Object *var_errorLine = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "errorLine");
  Object *var_nextLine = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "nextLine");
  Object *var_count = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "count");
// definebindings:
// definebindings:
// Begin line 804
  setline(804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num637 = alloc_Float64(0);
// compiled num node returning num637 (depth = 4)
  int op_slot_right_636 = gc_frame_newslot(num637);
// starting to compile member node (depth = 4)
  int callframe639 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call640 = callmethodflags(self, "interpdepth", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe639);
// compiled member node returning call640 (depth = 4)
  int op_slot_left_636 = gc_frame_newslot(call640);
  params[0] = num637;
  partcv[0] = 1;
  Object opresult641 = callmethod(call640, ">(1)", 1, partcv, params);
// compiled op node returning opresult641 (depth = 3)
  Object if635 = done;
  if (istrue(opresult641)) {
// Begin line 806
  setline(806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe642 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call643 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe642);
// compiled member node returning call643 (depth = 4)
  *var_line = call643;
  if (call643 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 807
  setline(807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe644 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe645 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_line (depth = 6)
  gc_frame_newslot(*var_line);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe646 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call647 = callmethodflags(*var_util, "lines", 1, partcv, params, 0);
  gc_frame_end(callframe646);
// compiled member node returning call647 (depth = 6)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call648 = callmethodflags(call647, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe645);
// compiled call node returning call648 (depth = 5)
  partcv[0] = 0;
  Object call649 = callmethodflags(call648, "size", 1, partcv, params, 0);
  gc_frame_end(callframe644);
// compiled member node returning call649 (depth = 4)
  *var_i = call649;
  if (call649 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 808
  setline(808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe650 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block651 = alloc_Block(NULL, NULL, "lexer", 808);
  gc_frame_newslot(block651);
// method "_apply"
  block_savedest(block651);
  Object closure652 = createclosure(4, "_apply");
  setclosureframe(closure652, stackframe);
  addtoclosure(closure652, var_i);
  addtoclosure(closure652, var_line);
  addtoclosure(closure652, var_util);
  addtoclosure(closure652, selfslot);
  struct UserObject *uo652 = (struct UserObject*)block651;
  uo652->data[0] = (Object)closure652;
  Method *meth_meth_lexer_652__apply = addmethod2pos(block651, "_apply", &meth_lexer_652__apply, 0);
  int argcv_meth_lexer_652__apply[] = {0};
  meth_meth_lexer_652__apply->type = alloc_MethodType(1, argcv_meth_lexer_652__apply);
  meth_meth_lexer_652__apply->definitionModule = modulename;
  meth_meth_lexer_652__apply->definitionLine = 1145;
// compiled block node returning block651 (depth = 4)
  gc_frame_newslot(block651);
// starting to compile block node (depth = 4)
  Object block664 = alloc_Block(NULL, NULL, "lexer", 808);
  gc_frame_newslot(block664);
// method "_apply"
  block_savedest(block664);
  Object closure665 = createclosure(4, "_apply");
  setclosureframe(closure665, stackframe);
  addtoclosure(closure665, var_i);
  addtoclosure(closure665, var_line);
  addtoclosure(closure665, var_util);
  addtoclosure(closure665, selfslot);
  struct UserObject *uo665 = (struct UserObject*)block664;
  uo665->data[0] = (Object)closure665;
  Method *meth_meth_lexer_665__apply = addmethod2pos(block664, "_apply", &meth_lexer_665__apply, 0);
  int argcv_meth_lexer_665__apply[] = {0};
  meth_meth_lexer_665__apply->type = alloc_MethodType(1, argcv_meth_lexer_665__apply);
  meth_meth_lexer_665__apply->definitionModule = modulename;
  meth_meth_lexer_665__apply->definitionLine = 1145;
// compiled block node returning block664 (depth = 4)
  gc_frame_newslot(block664);
// call case 5: prelude request
  params[0] = block651;
  params[1] = block664;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call690 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe650);
// compiled call node returning call690 (depth = 3)
// Begin line 815
  setline(815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array691 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array691 (depth = 4)
  *var_suggestions = array691;
  if (array691 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 816
  setline(816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe692 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe693 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  partcv[0] = 0;
  Object call694 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe693);
// compiled member node returning call694 (depth = 5)
  partcv[0] = 0;
  Object call695 = callmethodflags(call694, "new", 1, partcv, params, 0);
  gc_frame_end(callframe692);
// compiled member node returning call695 (depth = 4)
  *var_suggestion = call695;
  if (call695 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 817
  setline(817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe696 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit697 == NULL) {
    strlit697 = alloc_String("\\");
    gc_root(strlit697);
  }
// compiled string node returning strlit697 (depth = 4)
  gc_frame_newslot(strlit697);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_i (depth = 4)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_line (depth = 4)
  gc_frame_newslot(*var_line);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit697;
  params[1] = *var_i;
  params[2] = *var_line;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call698 = callmethodflags(*var_suggestion, "insert(1)atPosition(1)onLine(1)", 3, partcv, params, 0);
  gc_frame_end(callframe696);
// compiled call node returning call698 (depth = 3)
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe699 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call700 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe699);
// compiled call node returning call700 (depth = 3)
// Begin line 819
  setline(819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num705 = alloc_Float64(2);
// compiled num node returning num705 (depth = 7)
  int op_slot_right_704 = gc_frame_newslot(num705);
// starting to compile member node (depth = 7)
  int callframe707 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call708 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe707);
// compiled member node returning call708 (depth = 7)
  int op_slot_left_704 = gc_frame_newslot(call708);
  params[0] = num705;
  partcv[0] = 1;
  Object diff709 = callmethod(call708, "-(1)", 1, partcv, params);
// compiled op node returning diff709 (depth = 6)
  int op_slot_right_703 = gc_frame_newslot(diff709);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_703 = gc_frame_newslot(*var_i);
  params[0] = diff709;
  partcv[0] = 1;
  Object opresult711 = callmethod(*var_i, "==(1)", 1, partcv, params);
// compiled op node returning opresult711 (depth = 5)
  int op_slot_right_702 = gc_frame_newslot(opresult711);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe714 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call715 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe714);
// compiled member node returning call715 (depth = 6)
  int op_slot_right_713 = gc_frame_newslot(call715);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_line (depth = 6)
  int op_slot_left_713 = gc_frame_newslot(*var_line);
  params[0] = call715;
  partcv[0] = 1;
  Object opresult717 = callmethod(*var_line, "==(1)", 1, partcv, params);
// compiled op node returning opresult717 (depth = 5)
  int op_slot_left_702 = gc_frame_newslot(opresult717);
  params[0] = opresult711;
  partcv[0] = 1;
  Object opresult718 = callmethod(opresult717, "&&(1)", 1, partcv, params);
// compiled op node returning opresult718 (depth = 4)
  Object if701 = done;
  if (istrue(opresult718)) {
// Begin line 820
  setline(820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe719 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit720 == NULL) {
    strlit720 = alloc_String("for a '{' character in a string use '\\{'.");
    gc_root(strlit720);
  }
// compiled string node returning strlit720 (depth = 5)
  gc_frame_newslot(strlit720);
// Begin line 821
  setline(821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_line (depth = 5)
  gc_frame_newslot(*var_line);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 820
  setline(820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit720;
  params[1] = *var_line;
  params[2] = *var_i;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call721 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe719);
// compiled call node returning call721 (depth = 4)
    gc_frame_newslot(call721);
    if701 = call721;
  } else {
// Begin line 823
  setline(823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe722 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe723 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call724 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe723);
// compiled member node returning call724 (depth = 6)
  partcv[0] = 0;
  Object call725 = callmethodflags(call724, "new", 1, partcv, params, 0);
  gc_frame_end(callframe722);
// compiled member node returning call725 (depth = 5)
  *var_suggestion = call725;
  if (call725 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 824
  setline(824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe727 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit728 == NULL) {
    strlit728 = alloc_String("}");
    gc_root(strlit728);
  }
// compiled string node returning strlit728 (depth = 5)
  gc_frame_newslot(strlit728);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num730 = alloc_Float64(1);
// compiled num node returning num730 (depth = 6)
  int op_slot_right_729 = gc_frame_newslot(num730);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe733 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe734 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call735 = callmethodflags(self, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe734);
// compiled member node returning call735 (depth = 8)
  partcv[0] = 0;
  Object call736 = callmethodflags(call735, "size", 1, partcv, params, 0);
  gc_frame_end(callframe733);
// compiled member node returning call736 (depth = 7)
  int op_slot_right_732 = gc_frame_newslot(call736);
// starting to compile member node (depth = 7)
  int callframe738 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call739 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe738);
// compiled member node returning call739 (depth = 7)
  int op_slot_left_732 = gc_frame_newslot(call739);
  params[0] = call736;
  partcv[0] = 1;
  Object diff740 = callmethod(call739, "-(1)", 1, partcv, params);
// compiled op node returning diff740 (depth = 6)
  int op_slot_left_729 = gc_frame_newslot(diff740);
  params[0] = num730;
  partcv[0] = 1;
  Object diff741 = callmethod(diff740, "-(1)", 1, partcv, params);
// compiled op node returning diff741 (depth = 5)
  gc_frame_newslot(diff741);
// starting to compile member node (depth = 5)
  int callframe742 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call743 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe742);
// compiled member node returning call743 (depth = 5)
  gc_frame_newslot(call743);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit728;
  params[1] = diff741;
  params[2] = call743;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call744 = callmethodflags(*var_suggestion, "insert(1)atPosition(1)onLine(1)", 3, partcv, params, 0);
  gc_frame_end(callframe727);
// compiled call node returning call744 (depth = 4)
// Begin line 825
  setline(825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe745 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call746 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe745);
// compiled call node returning call746 (depth = 4)
// Begin line 826
  setline(826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe747 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit748 == NULL) {
    strlit748 = alloc_String("a string interpolation must end with a '}'. For a '{' character in a string use '\\{'.");
    gc_root(strlit748);
  }
// compiled string node returning strlit748 (depth = 5)
  gc_frame_newslot(strlit748);
// Begin line 827
  setline(827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe749 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call750 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe749);
// compiled member node returning call750 (depth = 5)
  gc_frame_newslot(call750);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num752 = alloc_Float64(1);
// compiled num node returning num752 (depth = 6)
  int op_slot_right_751 = gc_frame_newslot(num752);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe755 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe756 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call757 = callmethodflags(self, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe756);
// compiled member node returning call757 (depth = 8)
  partcv[0] = 0;
  Object call758 = callmethodflags(call757, "size", 1, partcv, params, 0);
  gc_frame_end(callframe755);
// compiled member node returning call758 (depth = 7)
  int op_slot_right_754 = gc_frame_newslot(call758);
// starting to compile member node (depth = 7)
  int callframe760 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call761 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe760);
// compiled member node returning call761 (depth = 7)
  int op_slot_left_754 = gc_frame_newslot(call761);
  params[0] = call758;
  partcv[0] = 1;
  Object diff762 = callmethod(call761, "-(1)", 1, partcv, params);
// compiled op node returning diff762 (depth = 6)
  int op_slot_left_751 = gc_frame_newslot(diff762);
  params[0] = num752;
  partcv[0] = 1;
  Object diff763 = callmethod(diff762, "-(1)", 1, partcv, params);
// compiled op node returning diff763 (depth = 5)
  gc_frame_newslot(diff763);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 826
  setline(826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit748;
  params[1] = call750;
  params[2] = diff763;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call764 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe747);
// compiled call node returning call764 (depth = 4)
    gc_frame_newslot(call764);
    if701 = call764;
  }
// compiled if node returning if701 (depth = 3)
    gc_frame_newslot(if701);
    if635 = if701;
  } else {
// Begin line 830
  setline(830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe765 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe766 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call767 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe766);
// compiled member node returning call767 (depth = 5)
  gc_frame_newslot(call767);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe768 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call769 = callmethodflags(*var_util, "lines", 1, partcv, params, 0);
  gc_frame_end(callframe768);
// compiled member node returning call769 (depth = 5)
  params[0] = call767;
  partcv[0] = 1;
  Object call770 = callmethodflags(call769, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe765);
// compiled call node returning call770 (depth = 4)
  *var_errorLine = call770;
  if (call770 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 831
  setline(831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num774 = alloc_Float64(1);
// compiled num node returning num774 (depth = 7)
  int op_slot_right_773 = gc_frame_newslot(num774);
// starting to compile member node (depth = 7)
  int callframe776 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call777 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe776);
// compiled member node returning call777 (depth = 7)
  int op_slot_left_773 = gc_frame_newslot(call777);
  params[0] = num774;
  partcv[0] = 1;
  Object sum778 = callmethod(call777, "+(1)", 1, partcv, params);
// compiled op node returning sum778 (depth = 6)
  int op_slot_right_772 = gc_frame_newslot(sum778);
// starting to compile member node (depth = 6)
  int callframe780 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe781 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_util (depth = 8)
  partcv[0] = 0;
  Object call782 = callmethodflags(*var_util, "lines", 1, partcv, params, 0);
  gc_frame_end(callframe781);
// compiled member node returning call782 (depth = 7)
  partcv[0] = 0;
  Object call783 = callmethodflags(call782, "size", 1, partcv, params, 0);
  gc_frame_end(callframe780);
// compiled member node returning call783 (depth = 6)
  int op_slot_left_772 = gc_frame_newslot(call783);
  params[0] = sum778;
  partcv[0] = 1;
  Object opresult784 = callmethod(call783, "≥(1)", 1, partcv, params);
// compiled op node returning opresult784 (depth = 5)
  Object if771 = done;
struct StackFrameObject *iftmpstackframe771 = stackframe;
  if (istrue(opresult784)) {
stackframe = alloc_StackFrame(0, iftmpstackframe771);
gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 832
  setline(832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe785 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num787 = alloc_Float64(1);
// compiled num node returning num787 (depth = 7)
  int op_slot_right_786 = gc_frame_newslot(num787);
// starting to compile member node (depth = 7)
  int callframe789 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call790 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe789);
// compiled member node returning call790 (depth = 7)
  int op_slot_left_786 = gc_frame_newslot(call790);
  params[0] = num787;
  partcv[0] = 1;
  Object sum791 = callmethod(call790, "+(1)", 1, partcv, params);
// compiled op node returning sum791 (depth = 6)
  gc_frame_newslot(sum791);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe792 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call793 = callmethodflags(*var_util, "lines", 1, partcv, params, 0);
  gc_frame_end(callframe792);
// compiled member node returning call793 (depth = 6)
  params[0] = sum791;
  partcv[0] = 1;
  Object call794 = callmethodflags(call793, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe785);
// compiled call node returning call794 (depth = 5)
    gc_frame_newslot(call794);
    if771 = call794;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe771);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 834
  setline(834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit795 == NULL) {
    strlit795 = alloc_String("");
    gc_root(strlit795);
  }
// compiled string node returning strlit795 (depth = 5)
    gc_frame_newslot(strlit795);
    if771 = strlit795;
  }
stackframe = iftmpstackframe771;
// compiled if node returning if771 (depth = 4)
  *var_nextLine = if771;
  if (if771 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 837
  setline(837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile num node (depth = 4)
  Object num796 = alloc_Float64(1);
// compiled num node returning num796 (depth = 4)
  *var_i = num796;
  if (num796 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 838
  setline(838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile num node (depth = 4)
  Object num797 = alloc_Float64(0);
// compiled num node returning num797 (depth = 4)
  *var_count = num797;
  if (num797 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 839
  setline(839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe798 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block799 = alloc_Block(NULL, NULL, "lexer", 839);
  gc_frame_newslot(block799);
// method "_apply"
  block_savedest(block799);
  Object closure800 = createclosure(3, "_apply");
  setclosureframe(closure800, stackframe);
  addtoclosure(closure800, var_nextLine);
  addtoclosure(closure800, var_i);
  addtoclosure(closure800, selfslot);
  struct UserObject *uo800 = (struct UserObject*)block799;
  uo800->data[0] = (Object)closure800;
  Method *meth_meth_lexer_800__apply = addmethod2pos(block799, "_apply", &meth_lexer_800__apply, 0);
  int argcv_meth_lexer_800__apply[] = {0};
  meth_meth_lexer_800__apply->type = alloc_MethodType(1, argcv_meth_lexer_800__apply);
  meth_meth_lexer_800__apply->definitionModule = modulename;
  meth_meth_lexer_800__apply->definitionLine = 1145;
// compiled block node returning block799 (depth = 4)
  gc_frame_newslot(block799);
// starting to compile block node (depth = 4)
  Object block807 = alloc_Block(NULL, NULL, "lexer", 839);
  gc_frame_newslot(block807);
// method "_apply"
  block_savedest(block807);
  Object closure808 = createclosure(4, "_apply");
  setclosureframe(closure808, stackframe);
  addtoclosure(closure808, var_i);
  addtoclosure(closure808, var_nextLine);
  addtoclosure(closure808, var_count);
  addtoclosure(closure808, selfslot);
  struct UserObject *uo808 = (struct UserObject*)block807;
  uo808->data[0] = (Object)closure808;
  Method *meth_meth_lexer_808__apply = addmethod2pos(block807, "_apply", &meth_lexer_808__apply, 0);
  int argcv_meth_lexer_808__apply[] = {0};
  meth_meth_lexer_808__apply->type = alloc_MethodType(1, argcv_meth_lexer_808__apply);
  meth_meth_lexer_808__apply->definitionModule = modulename;
  meth_meth_lexer_808__apply->definitionLine = 1145;
// compiled block node returning block807 (depth = 4)
  gc_frame_newslot(block807);
// call case 5: prelude request
  params[0] = block799;
  params[1] = block807;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call839 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe798);
// compiled call node returning call839 (depth = 3)
// Begin line 849
  setline(849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num842 = alloc_Float64(1);
// compiled num node returning num842 (depth = 5)
  int op_slot_right_841 = gc_frame_newslot(num842);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num845 = alloc_Float64(2);
// compiled num node returning num845 (depth = 6)
  int op_slot_right_844 = gc_frame_newslot(num845);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_count (depth = 6)
  int op_slot_left_844 = gc_frame_newslot(*var_count);
  params[0] = num845;
  partcv[0] = 1;
  Object modulus847 = callmethod(*var_count, "%(1)", 1, partcv, params);
// compiled op node returning modulus847 (depth = 5)
  int op_slot_left_841 = gc_frame_newslot(modulus847);
  params[0] = num842;
  partcv[0] = 1;
  Object opresult848 = callmethod(modulus847, "==(1)", 1, partcv, params);
// compiled op node returning opresult848 (depth = 4)
  Object if840 = done;
  if (istrue(opresult848)) {
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array849 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array849 (depth = 5)
  *var_suggestions = array849;
  if (array849 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 851
  setline(851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe850 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe851 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call852 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe851);
// compiled member node returning call852 (depth = 6)
  partcv[0] = 0;
  Object call853 = callmethodflags(call852, "new", 1, partcv, params, 0);
  gc_frame_end(callframe850);
// compiled member node returning call853 (depth = 5)
  *var_suggestion = call853;
  if (call853 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe854 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe855 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call856 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe855);
// compiled member node returning call856 (depth = 5)
  gc_frame_newslot(call856);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextLine (depth = 6)
  int op_slot_right_857 = gc_frame_newslot(*var_nextLine);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errorLine (depth = 6)
  int op_slot_left_857 = gc_frame_newslot(*var_errorLine);
  params[0] = *var_nextLine;
  partcv[0] = 1;
  Object opresult859 = callmethod(*var_errorLine, "++(1)", 1, partcv, params);
// compiled op node returning opresult859 (depth = 5)
  gc_frame_newslot(opresult859);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = call856;
  params[1] = opresult859;
  partcv[0] = 2;
  Object call860 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe854);
// compiled call node returning call860 (depth = 4)
// Begin line 853
  setline(853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe861 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num863 = alloc_Float64(1);
// compiled num node returning num863 (depth = 6)
  int op_slot_right_862 = gc_frame_newslot(num863);
// starting to compile member node (depth = 6)
  int callframe865 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call866 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe865);
// compiled member node returning call866 (depth = 6)
  int op_slot_left_862 = gc_frame_newslot(call866);
  params[0] = num863;
  partcv[0] = 1;
  Object sum867 = callmethod(call866, "+(1)", 1, partcv, params);
// compiled op node returning sum867 (depth = 5)
  gc_frame_newslot(sum867);
// starting to compile string node (depth = 5)
  if (strlit868 == NULL) {
    strlit868 = alloc_String("");
    gc_root(strlit868);
  }
// compiled string node returning strlit868 (depth = 5)
  gc_frame_newslot(strlit868);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = sum867;
  params[1] = strlit868;
  partcv[0] = 2;
  Object call869 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe861);
// compiled call node returning call869 (depth = 4)
// Begin line 854
  setline(854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe870 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call871 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe870);
// compiled call node returning call871 (depth = 4)
// Begin line 855
  setline(855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe872 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe873 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call874 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe873);
// compiled member node returning call874 (depth = 6)
  partcv[0] = 0;
  Object call875 = callmethodflags(call874, "new", 1, partcv, params, 0);
  gc_frame_end(callframe872);
// compiled member node returning call875 (depth = 5)
  *var_suggestion = call875;
  if (call875 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 856
  setline(856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe877 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe878 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call879 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe878);
// compiled member node returning call879 (depth = 5)
  gc_frame_newslot(call879);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit881 == NULL) {
    strlit881 = alloc_String("""\x22""");
    gc_root(strlit881);
  }
// compiled string node returning strlit881 (depth = 6)
  int op_slot_right_880 = gc_frame_newslot(strlit881);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errorLine (depth = 6)
  int op_slot_left_880 = gc_frame_newslot(*var_errorLine);
  params[0] = strlit881;
  partcv[0] = 1;
  Object opresult883 = callmethod(*var_errorLine, "++(1)", 1, partcv, params);
// compiled op node returning opresult883 (depth = 5)
  gc_frame_newslot(opresult883);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = call879;
  params[1] = opresult883;
  partcv[0] = 2;
  Object call884 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe877);
// compiled call node returning call884 (depth = 4)
// Begin line 857
  setline(857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe885 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num887 = alloc_Float64(1);
// compiled num node returning num887 (depth = 6)
  int op_slot_right_886 = gc_frame_newslot(num887);
// starting to compile member node (depth = 6)
  int callframe889 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call890 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe889);
// compiled member node returning call890 (depth = 6)
  int op_slot_left_886 = gc_frame_newslot(call890);
  params[0] = num887;
  partcv[0] = 1;
  Object sum891 = callmethod(call890, "+(1)", 1, partcv, params);
// compiled op node returning sum891 (depth = 5)
  gc_frame_newslot(sum891);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextLine (depth = 6)
  int op_slot_right_892 = gc_frame_newslot(*var_nextLine);
// starting to compile string node (depth = 6)
  if (strlit894 == NULL) {
    strlit894 = alloc_String("    ++ ""\x22""");
    gc_root(strlit894);
  }
// compiled string node returning strlit894 (depth = 6)
  int op_slot_left_892 = gc_frame_newslot(strlit894);
  params[0] = *var_nextLine;
  partcv[0] = 1;
  Object opresult895 = callmethod(strlit894, "++(1)", 1, partcv, params);
// compiled op node returning opresult895 (depth = 5)
  gc_frame_newslot(opresult895);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = sum891;
  params[1] = opresult895;
  partcv[0] = 2;
  Object call896 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe885);
// compiled call node returning call896 (depth = 4)
// Begin line 858
  setline(858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe897 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call898 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe897);
// compiled call node returning call898 (depth = 4)
// Begin line 859
  setline(859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe899 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe900 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call901 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe900);
// compiled member node returning call901 (depth = 6)
  partcv[0] = 0;
  Object call902 = callmethodflags(call901, "new", 1, partcv, params, 0);
  gc_frame_end(callframe899);
// compiled member node returning call902 (depth = 5)
  *var_suggestion = call902;
  if (call902 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 860
  setline(860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe904 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe905 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call906 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe905);
// compiled member node returning call906 (depth = 5)
  gc_frame_newslot(call906);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextLine (depth = 6)
  int op_slot_right_907 = gc_frame_newslot(*var_nextLine);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit910 == NULL) {
    strlit910 = alloc_String("\\n");
    gc_root(strlit910);
  }
// compiled string node returning strlit910 (depth = 7)
  int op_slot_right_909 = gc_frame_newslot(strlit910);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errorLine (depth = 7)
  int op_slot_left_909 = gc_frame_newslot(*var_errorLine);
  params[0] = strlit910;
  partcv[0] = 1;
  Object opresult912 = callmethod(*var_errorLine, "++(1)", 1, partcv, params);
// compiled op node returning opresult912 (depth = 6)
  int op_slot_left_907 = gc_frame_newslot(opresult912);
  params[0] = *var_nextLine;
  partcv[0] = 1;
  Object opresult913 = callmethod(opresult912, "++(1)", 1, partcv, params);
// compiled op node returning opresult913 (depth = 5)
  gc_frame_newslot(opresult913);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = call906;
  params[1] = opresult913;
  partcv[0] = 2;
  Object call914 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe904);
// compiled call node returning call914 (depth = 4)
// Begin line 861
  setline(861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe915 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num917 = alloc_Float64(1);
// compiled num node returning num917 (depth = 6)
  int op_slot_right_916 = gc_frame_newslot(num917);
// starting to compile member node (depth = 6)
  int callframe919 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call920 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe919);
// compiled member node returning call920 (depth = 6)
  int op_slot_left_916 = gc_frame_newslot(call920);
  params[0] = num917;
  partcv[0] = 1;
  Object sum921 = callmethod(call920, "+(1)", 1, partcv, params);
// compiled op node returning sum921 (depth = 5)
  gc_frame_newslot(sum921);
// starting to compile string node (depth = 5)
  if (strlit922 == NULL) {
    strlit922 = alloc_String("");
    gc_root(strlit922);
  }
// compiled string node returning strlit922 (depth = 5)
  gc_frame_newslot(strlit922);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = sum921;
  params[1] = strlit922;
  partcv[0] = 2;
  Object call923 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe915);
// compiled call node returning call923 (depth = 4)
// Begin line 862
  setline(862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe924 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call925 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe924);
// compiled call node returning call925 (depth = 4)
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe926 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit927 == NULL) {
    strlit927 = alloc_String("a string must be terminated by a ""\x22"" before the end of the line. To insert a newline in a string, use '\\n'. To split a string over multiple lines, use '++' to join strings together.");
    gc_root(strlit927);
  }
// compiled string node returning strlit927 (depth = 5)
  gc_frame_newslot(strlit927);
// Begin line 864
  setline(864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe928 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call929 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe928);
// compiled member node returning call929 (depth = 5)
  gc_frame_newslot(call929);
// starting to compile member node (depth = 5)
  int callframe930 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call931 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe930);
// compiled member node returning call931 (depth = 5)
  gc_frame_newslot(call931);
// starting to compile member node (depth = 5)
  int callframe932 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call933 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe932);
// compiled member node returning call933 (depth = 5)
  gc_frame_newslot(call933);
// Begin line 865
  setline(865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit927;
  params[1] = call929;
  params[2] = call931;
  params[3] = call933;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call934 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe926);
// compiled call node returning call934 (depth = 4)
    gc_frame_newslot(call934);
    if840 = call934;
  } else {
// Begin line 867
  setline(867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe935 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe936 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call937 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe936);
// compiled member node returning call937 (depth = 6)
  partcv[0] = 0;
  Object call938 = callmethodflags(call937, "new", 1, partcv, params, 0);
  gc_frame_end(callframe935);
// compiled member node returning call938 (depth = 5)
  *var_suggestion = call938;
  if (call938 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 868
  setline(868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe939 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe940 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call941 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe940);
// compiled member node returning call941 (depth = 5)
  gc_frame_newslot(call941);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit943 == NULL) {
    strlit943 = alloc_String("""\x22""");
    gc_root(strlit943);
  }
// compiled string node returning strlit943 (depth = 6)
  int op_slot_right_942 = gc_frame_newslot(strlit943);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errorLine (depth = 6)
  int op_slot_left_942 = gc_frame_newslot(*var_errorLine);
  params[0] = strlit943;
  partcv[0] = 1;
  Object opresult945 = callmethod(*var_errorLine, "++(1)", 1, partcv, params);
// compiled op node returning opresult945 (depth = 5)
  gc_frame_newslot(opresult945);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = call941;
  params[1] = opresult945;
  partcv[0] = 2;
  Object call946 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe939);
// compiled call node returning call946 (depth = 4)
// Begin line 869
  setline(869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe947 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 870
  setline(870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit949 == NULL) {
    strlit949 = alloc_String("by a ""\x22"" before the end of the line.");
    gc_root(strlit949);
  }
// compiled string node returning strlit949 (depth = 6)
  int op_slot_right_948 = gc_frame_newslot(strlit949);
// Begin line 869
  setline(869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit951 == NULL) {
    strlit951 = alloc_String("a string must be terminated ");
    gc_root(strlit951);
  }
// compiled string node returning strlit951 (depth = 6)
  int op_slot_left_948 = gc_frame_newslot(strlit951);
  params[0] = strlit949;
  partcv[0] = 1;
  Object opresult952 = callmethod(strlit951, "++(1)", 1, partcv, params);
// compiled op node returning opresult952 (depth = 5)
  gc_frame_newslot(opresult952);
// Begin line 871
  setline(871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe953 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call954 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe953);
// compiled member node returning call954 (depth = 5)
  gc_frame_newslot(call954);
// starting to compile member node (depth = 5)
  int callframe955 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call956 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe955);
// compiled member node returning call956 (depth = 5)
  gc_frame_newslot(call956);
// Begin line 872
  setline(872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 869
  setline(869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult952;
  params[1] = call954;
  params[2] = call956;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call957 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe947);
// compiled call node returning call957 (depth = 4)
    gc_frame_newslot(call957);
    if840 = call957;
  }
// compiled if node returning if840 (depth = 3)
    gc_frame_newslot(if840);
    if635 = if840;
  }
// compiled if node returning if635 (depth = 2)
  gc_frame_end(frame);
  return if635;
}
Object meth_lexer_958_isSpaceChar_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 68, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "isSpaceChar(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method isSpaceChar(_)");
  Object params[1];
  int partcv[1];
  Object *var_spaceChars = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isSpaceChar(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part isSpaceChar(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 878
  setline(878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe959 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_spaceChars (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call960 = callmethodflags(*var_spaceChars, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe959);
// compiled call node returning call960 (depth = 2)
  gc_frame_end(frame);
  return call960;
}
Object meth_lexer_961_checkSeparatorString_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 69, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkSeparatorString(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method checkSeparatorString(_)");
  Object params[5];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_unicode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for checkSeparatorString(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part checkSeparatorString(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_ordval = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ordval");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 881
  setline(881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe962 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  partcv[0] = 0;
  Object call963 = callmethodflags(*var_c, "ord", 1, partcv, params, 0);
  gc_frame_end(callframe962);
// compiled member node returning call963 (depth = 3)
  *var_ordval = call963;
  if (call963 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 882
  setline(882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe965 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_lexer (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call966 = callmethodflags(module_lexer, "isBadSeparator(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe965);
// compiled call node returning call966 (depth = 3)
  Object if964 = done;
  if (istrue(call966)) {
// Begin line 886
  setline(886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe967 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe968 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  partcv[0] = 0;
  Object call969 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe968);
// compiled member node returning call969 (depth = 5)
  partcv[0] = 0;
  Object call970 = callmethodflags(call969, "new", 1, partcv, params, 0);
  gc_frame_end(callframe967);
// compiled member node returning call970 (depth = 4)
  *var_suggestion = call970;
  if (call970 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 887
  setline(887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe971 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe972 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call973 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe972);
// compiled member node returning call973 (depth = 4)
  gc_frame_newslot(call973);
// starting to compile string node (depth = 4)
  if (strlit974 == NULL) {
    strlit974 = alloc_String(" ");
    gc_root(strlit974);
  }
// compiled string node returning strlit974 (depth = 4)
  gc_frame_newslot(strlit974);
// starting to compile member node (depth = 4)
  int callframe975 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call976 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe975);
// compiled member node returning call976 (depth = 4)
  gc_frame_newslot(call976);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = call973;
  params[1] = strlit974;
  params[2] = call976;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call977 = callmethodflags(*var_suggestion, "replaceChar(1)with(1)onLine(1)", 3, partcv, params, 0);
  gc_frame_end(callframe971);
// compiled call node returning call977 (depth = 3)
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num980 = alloc_Float64(9);
// compiled num node returning num980 (depth = 5)
  int op_slot_right_979 = gc_frame_newslot(num980);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ordval (depth = 5)
  int op_slot_left_979 = gc_frame_newslot(*var_ordval);
  params[0] = num980;
  partcv[0] = 1;
  Object opresult982 = callmethod(*var_ordval, "==(1)", 1, partcv, params);
// compiled op node returning opresult982 (depth = 4)
  Object if978 = done;
  if (istrue(opresult982)) {
// Begin line 889
  setline(889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe983 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe984 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call985 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe984);
// compiled member node returning call985 (depth = 5)
  gc_frame_newslot(call985);
// starting to compile member node (depth = 5)
  int callframe986 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call987 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe986);
// compiled member node returning call987 (depth = 5)
  gc_frame_newslot(call987);
// Begin line 890
  setline(890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit988 == NULL) {
    strlit988 = alloc_String("\\t");
    gc_root(strlit988);
  }
// compiled string node returning strlit988 (depth = 5)
  gc_frame_newslot(strlit988);
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe989 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call990 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe989);
// compiled member node returning call990 (depth = 5)
  gc_frame_newslot(call990);
// call case 6: other requests
// Begin line 889
  setline(889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = call985;
  params[1] = call987;
  params[2] = strlit988;
  params[3] = call990;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call991 = callmethodflags(*var_suggestion, "replaceRange(2)with(1)onLine(1)", 3, partcv, params, 0);
  gc_frame_end(callframe983);
// compiled call node returning call991 (depth = 4)
// Begin line 892
  setline(892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe992 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 894
  setline(894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit994 == NULL) {
    strlit994 = alloc_String("use the string escape \\t instead");
    gc_root(strlit994);
  }
// compiled string node returning strlit994 (depth = 6)
  int op_slot_right_993 = gc_frame_newslot(strlit994);
// Begin line 892
  setline(892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 893
  setline(893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit997 == NULL) {
    strlit997 = alloc_String("written in the source code; ");
    gc_root(strlit997);
  }
// compiled string node returning strlit997 (depth = 7)
  int op_slot_right_996 = gc_frame_newslot(strlit997);
// Begin line 892
  setline(892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit999 == NULL) {
    strlit999 = alloc_String("tabs cannot be ");
    gc_root(strlit999);
  }
// compiled string node returning strlit999 (depth = 7)
  int op_slot_left_996 = gc_frame_newslot(strlit999);
  params[0] = strlit997;
  partcv[0] = 1;
  Object opresult1000 = callmethod(strlit999, "++(1)", 1, partcv, params);
// compiled op node returning opresult1000 (depth = 6)
  int op_slot_left_993 = gc_frame_newslot(opresult1000);
  params[0] = strlit994;
  partcv[0] = 1;
  Object opresult1001 = callmethod(opresult1000, "++(1)", 1, partcv, params);
// compiled op node returning opresult1001 (depth = 5)
  gc_frame_newslot(opresult1001);
// Begin line 895
  setline(895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1002 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1003 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1002);
// compiled member node returning call1003 (depth = 5)
  gc_frame_newslot(call1003);
// starting to compile member node (depth = 5)
  int callframe1004 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1005 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1004);
// compiled member node returning call1005 (depth = 5)
  gc_frame_newslot(call1005);
// starting to compile member node (depth = 5)
  int callframe1006 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1007 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1006);
// compiled member node returning call1007 (depth = 5)
  gc_frame_newslot(call1007);
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 892
  setline(892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult1001;
  params[1] = call1003;
  params[2] = call1005;
  params[3] = call1007;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1008 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe992);
// compiled call node returning call1008 (depth = 4)
// Begin line 897
  setline(897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1009 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1010 == NULL) {
    strlit1010 = alloc_String("tabs are not allowed; use spaces instead.");
    gc_root(strlit1010);
  }
// compiled string node returning strlit1010 (depth = 5)
  gc_frame_newslot(strlit1010);
// starting to compile member node (depth = 5)
  int callframe1011 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1012 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1011);
// compiled member node returning call1012 (depth = 5)
  gc_frame_newslot(call1012);
// Begin line 898
  setline(898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1013 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1014 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1013);
// compiled member node returning call1014 (depth = 5)
  gc_frame_newslot(call1014);
// starting to compile member node (depth = 5)
  int callframe1015 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1016 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1015);
// compiled member node returning call1016 (depth = 5)
  gc_frame_newslot(call1016);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 897
  setline(897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit1010;
  params[1] = call1012;
  params[2] = call1014;
  params[3] = call1016;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1017 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1009);
// compiled call node returning call1017 (depth = 4)
    gc_frame_newslot(call1017);
    if978 = call1017;
  } else {
// Begin line 900
  setline(900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1018 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1019 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1020 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1019);
// compiled member node returning call1020 (depth = 5)
  gc_frame_newslot(call1020);
// starting to compile member node (depth = 5)
  int callframe1021 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1022 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1021);
// compiled member node returning call1022 (depth = 5)
  gc_frame_newslot(call1022);
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1024 == NULL) {
    strlit1024 = alloc_String("");
    gc_root(strlit1024);
  }
// compiled string node returning strlit1024 (depth = 6)
  int op_slot_right_1023 = gc_frame_newslot(strlit1024);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1027 = gc_frame_new();
// starting to compile call node (depth = 8)
  int callframe1028 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num1029 = alloc_Float64(16);
// compiled num node returning num1029 (depth = 9)
  gc_frame_newslot(num1029);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ordval (depth = 9)
  params[0] = num1029;
  partcv[0] = 1;
  Object call1030 = callmethodflags(*var_ordval, "inBase(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1028);
// compiled call node returning call1030 (depth = 8)
  gc_frame_newslot(call1030);
// starting to compile num node (depth = 8)
  Object num1031 = alloc_Float64(4);
// compiled num node returning num1031 (depth = 8)
  gc_frame_newslot(num1031);
// starting to compile string node (depth = 8)
  if (strlit1032 == NULL) {
    strlit1032 = alloc_String("0");
    gc_root(strlit1032);
  }
// compiled string node returning strlit1032 (depth = 8)
  gc_frame_newslot(strlit1032);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_lexer (depth = 8)
  params[0] = call1030;
  params[1] = num1031;
  params[2] = strlit1032;
  partcv[0] = 3;
  Object call1033 = callmethodflags(module_lexer, "padl(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1027);
// compiled call node returning call1033 (depth = 7)
  int op_slot_right_1026 = gc_frame_newslot(call1033);
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit1035 == NULL) {
    strlit1035 = alloc_String("\\u");
    gc_root(strlit1035);
  }
// compiled string node returning strlit1035 (depth = 7)
  int op_slot_left_1026 = gc_frame_newslot(strlit1035);
  params[0] = call1033;
  partcv[0] = 1;
  Object opresult1036 = callmethod(strlit1035, "++(1)", 1, partcv, params);
// compiled op node returning opresult1036 (depth = 6)
  int op_slot_left_1023 = gc_frame_newslot(opresult1036);
  params[0] = strlit1024;
  partcv[0] = 1;
  Object opresult1037 = callmethod(opresult1036, "++(1)", 1, partcv, params);
// compiled op node returning opresult1037 (depth = 5)
  gc_frame_newslot(opresult1037);
// Begin line 902
  setline(902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1038 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1039 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1038);
// compiled member node returning call1039 (depth = 5)
  gc_frame_newslot(call1039);
// call case 6: other requests
// Begin line 900
  setline(900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = call1020;
  params[1] = call1022;
  params[2] = opresult1037;
  params[3] = call1039;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1040 = callmethodflags(*var_suggestion, "replaceRange(2)with(1)onLine(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1018);
// compiled call node returning call1040 (depth = 4)
// Begin line 903
  setline(903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1041 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 909
  setline(909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1043 == NULL) {
    strlit1043 = alloc_String(" instead");
    gc_root(strlit1043);
  }
// compiled string node returning strlit1043 (depth = 6)
  int op_slot_right_1042 = gc_frame_newslot(strlit1043);
// Begin line 903
  setline(903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 908
  setline(908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1046 = gc_frame_new();
// starting to compile call node (depth = 8)
  int callframe1047 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num1048 = alloc_Float64(16);
// compiled num node returning num1048 (depth = 9)
  gc_frame_newslot(num1048);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ordval (depth = 9)
  params[0] = num1048;
  partcv[0] = 1;
  Object call1049 = callmethodflags(*var_ordval, "inBase(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1047);
// compiled call node returning call1049 (depth = 8)
  gc_frame_newslot(call1049);
// starting to compile num node (depth = 8)
  Object num1050 = alloc_Float64(4);
// compiled num node returning num1050 (depth = 8)
  gc_frame_newslot(num1050);
// starting to compile string node (depth = 8)
  if (strlit1051 == NULL) {
    strlit1051 = alloc_String("0");
    gc_root(strlit1051);
  }
// compiled string node returning strlit1051 (depth = 8)
  gc_frame_newslot(strlit1051);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_lexer (depth = 8)
  params[0] = call1049;
  params[1] = num1050;
  params[2] = strlit1051;
  partcv[0] = 3;
  Object call1052 = callmethodflags(module_lexer, "padl(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1046);
// compiled call node returning call1052 (depth = 7)
  int op_slot_right_1045 = gc_frame_newslot(call1052);
// Begin line 903
  setline(903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// Begin line 907
  setline(907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit1055 == NULL) {
    strlit1055 = alloc_String("use the Unicode escape \\u");
    gc_root(strlit1055);
  }
// compiled string node returning strlit1055 (depth = 8)
  int op_slot_right_1054 = gc_frame_newslot(strlit1055);
// Begin line 903
  setline(903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 906
  setline(906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit1058 == NULL) {
    strlit1058 = alloc_String("written in the source code; ");
    gc_root(strlit1058);
  }
// compiled string node returning strlit1058 (depth = 9)
  int op_slot_right_1057 = gc_frame_newslot(strlit1058);
// Begin line 903
  setline(903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// Begin line 905
  setline(905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit1061 == NULL) {
    strlit1061 = alloc_String(" and cannot be ");
    gc_root(strlit1061);
  }
// compiled string node returning strlit1061 (depth = 10)
  int op_slot_right_1060 = gc_frame_newslot(strlit1061);
// Begin line 903
  setline(903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// Begin line 904
  setline(904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 11)
  if (strlit1064 == NULL) {
    strlit1064 = alloc_String("is not a valid whitespace character");
    gc_root(strlit1064);
  }
// compiled string node returning strlit1064 (depth = 11)
  int op_slot_right_1063 = gc_frame_newslot(strlit1064);
// Begin line 903
  setline(903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1067 == NULL) {
    strlit1067 = alloc_String(") ");
    gc_root(strlit1067);
  }
// compiled string node returning strlit1067 (depth = 12)
  int op_slot_right_1066 = gc_frame_newslot(strlit1067);
// starting to compile op node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1070 = gc_frame_new();
// starting to compile call node (depth = 14)
  int callframe1071 = gc_frame_new();
// starting to compile num node (depth = 15)
  Object num1072 = alloc_Float64(16);
// compiled num node returning num1072 (depth = 15)
  gc_frame_newslot(num1072);
// call case 6: other requests
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_ordval (depth = 15)
  params[0] = num1072;
  partcv[0] = 1;
  Object call1073 = callmethodflags(*var_ordval, "inBase(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1071);
// compiled call node returning call1073 (depth = 14)
  gc_frame_newslot(call1073);
// starting to compile num node (depth = 14)
  Object num1074 = alloc_Float64(4);
// compiled num node returning num1074 (depth = 14)
  gc_frame_newslot(num1074);
// starting to compile string node (depth = 14)
  if (strlit1075 == NULL) {
    strlit1075 = alloc_String("0");
    gc_root(strlit1075);
  }
// compiled string node returning strlit1075 (depth = 14)
  gc_frame_newslot(strlit1075);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning module_lexer (depth = 14)
  params[0] = call1073;
  params[1] = num1074;
  params[2] = strlit1075;
  partcv[0] = 3;
  Object call1076 = callmethodflags(module_lexer, "padl(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1070);
// compiled call node returning call1076 (depth = 13)
  int op_slot_right_1069 = gc_frame_newslot(call1076);
// Begin line 903
  setline(903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit1079 == NULL) {
    strlit1079 = alloc_String(" (U+");
    gc_root(strlit1079);
  }
// compiled string node returning strlit1079 (depth = 14)
  int op_slot_right_1078 = gc_frame_newslot(strlit1079);
// starting to compile op node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe1082 = gc_frame_new();
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_c (depth = 16)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_unicode (depth = 16)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call1083 = callmethodflags(*var_unicode, "name(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1082);
// compiled call node returning call1083 (depth = 15)
  int op_slot_right_1081 = gc_frame_newslot(call1083);
// starting to compile string node (depth = 15)
  if (strlit1085 == NULL) {
    strlit1085 = alloc_String("");
    gc_root(strlit1085);
  }
// compiled string node returning strlit1085 (depth = 15)
  int op_slot_left_1081 = gc_frame_newslot(strlit1085);
  params[0] = call1083;
  partcv[0] = 1;
  Object opresult1086 = callmethod(strlit1085, "++(1)", 1, partcv, params);
// compiled op node returning opresult1086 (depth = 14)
  int op_slot_left_1078 = gc_frame_newslot(opresult1086);
  params[0] = strlit1079;
  partcv[0] = 1;
  Object opresult1087 = callmethod(opresult1086, "++(1)", 1, partcv, params);
// compiled op node returning opresult1087 (depth = 13)
  int op_slot_left_1069 = gc_frame_newslot(opresult1087);
  params[0] = call1076;
  partcv[0] = 1;
  Object opresult1088 = callmethod(opresult1087, "++(1)", 1, partcv, params);
// compiled op node returning opresult1088 (depth = 12)
  int op_slot_left_1066 = gc_frame_newslot(opresult1088);
  params[0] = strlit1067;
  partcv[0] = 1;
  Object opresult1089 = callmethod(opresult1088, "++(1)", 1, partcv, params);
// compiled op node returning opresult1089 (depth = 11)
  int op_slot_left_1063 = gc_frame_newslot(opresult1089);
  params[0] = strlit1064;
  partcv[0] = 1;
  Object opresult1090 = callmethod(opresult1089, "++(1)", 1, partcv, params);
// compiled op node returning opresult1090 (depth = 10)
  int op_slot_left_1060 = gc_frame_newslot(opresult1090);
  params[0] = strlit1061;
  partcv[0] = 1;
  Object opresult1091 = callmethod(opresult1090, "++(1)", 1, partcv, params);
// compiled op node returning opresult1091 (depth = 9)
  int op_slot_left_1057 = gc_frame_newslot(opresult1091);
  params[0] = strlit1058;
  partcv[0] = 1;
  Object opresult1092 = callmethod(opresult1091, "++(1)", 1, partcv, params);
// compiled op node returning opresult1092 (depth = 8)
  int op_slot_left_1054 = gc_frame_newslot(opresult1092);
  params[0] = strlit1055;
  partcv[0] = 1;
  Object opresult1093 = callmethod(opresult1092, "++(1)", 1, partcv, params);
// compiled op node returning opresult1093 (depth = 7)
  int op_slot_left_1045 = gc_frame_newslot(opresult1093);
  params[0] = call1052;
  partcv[0] = 1;
  Object opresult1094 = callmethod(opresult1093, "++(1)", 1, partcv, params);
// compiled op node returning opresult1094 (depth = 6)
  int op_slot_left_1042 = gc_frame_newslot(opresult1094);
  params[0] = strlit1043;
  partcv[0] = 1;
  Object opresult1095 = callmethod(opresult1094, "++(1)", 1, partcv, params);
// compiled op node returning opresult1095 (depth = 5)
  gc_frame_newslot(opresult1095);
// Begin line 910
  setline(910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1096 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1097 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1096);
// compiled member node returning call1097 (depth = 5)
  gc_frame_newslot(call1097);
// starting to compile member node (depth = 5)
  int callframe1098 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1099 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1098);
// compiled member node returning call1099 (depth = 5)
  gc_frame_newslot(call1099);
// starting to compile member node (depth = 5)
  int callframe1100 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1101 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1100);
// compiled member node returning call1101 (depth = 5)
  gc_frame_newslot(call1101);
// Begin line 911
  setline(911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 903
  setline(903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult1095;
  params[1] = call1097;
  params[2] = call1099;
  params[3] = call1101;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1102 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1041);
// compiled call node returning call1102 (depth = 4)
// Begin line 912
  setline(912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1103 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 913
  setline(913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1105 == NULL) {
    strlit1105 = alloc_String("is not a valid whitespace character; use spaces instead.");
    gc_root(strlit1105);
  }
// compiled string node returning strlit1105 (depth = 6)
  int op_slot_right_1104 = gc_frame_newslot(strlit1105);
// Begin line 912
  setline(912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1108 == NULL) {
    strlit1108 = alloc_String(") ");
    gc_root(strlit1108);
  }
// compiled string node returning strlit1108 (depth = 7)
  int op_slot_right_1107 = gc_frame_newslot(strlit1108);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1111 = gc_frame_new();
// starting to compile call node (depth = 9)
  int callframe1112 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num1113 = alloc_Float64(16);
// compiled num node returning num1113 (depth = 10)
  gc_frame_newslot(num1113);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ordval (depth = 10)
  params[0] = num1113;
  partcv[0] = 1;
  Object call1114 = callmethodflags(*var_ordval, "inBase(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1112);
// compiled call node returning call1114 (depth = 9)
  gc_frame_newslot(call1114);
// starting to compile num node (depth = 9)
  Object num1115 = alloc_Float64(4);
// compiled num node returning num1115 (depth = 9)
  gc_frame_newslot(num1115);
// starting to compile string node (depth = 9)
  if (strlit1116 == NULL) {
    strlit1116 = alloc_String("0");
    gc_root(strlit1116);
  }
// compiled string node returning strlit1116 (depth = 9)
  gc_frame_newslot(strlit1116);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_lexer (depth = 9)
  params[0] = call1114;
  params[1] = num1115;
  params[2] = strlit1116;
  partcv[0] = 3;
  Object call1117 = callmethodflags(module_lexer, "padl(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1111);
// compiled call node returning call1117 (depth = 8)
  int op_slot_right_1110 = gc_frame_newslot(call1117);
// Begin line 912
  setline(912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1120 == NULL) {
    strlit1120 = alloc_String(" (U+");
    gc_root(strlit1120);
  }
// compiled string node returning strlit1120 (depth = 9)
  int op_slot_right_1119 = gc_frame_newslot(strlit1120);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1123 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_unicode (depth = 11)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call1124 = callmethodflags(*var_unicode, "name(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1123);
// compiled call node returning call1124 (depth = 10)
  int op_slot_right_1122 = gc_frame_newslot(call1124);
// starting to compile string node (depth = 10)
  if (strlit1126 == NULL) {
    strlit1126 = alloc_String("");
    gc_root(strlit1126);
  }
// compiled string node returning strlit1126 (depth = 10)
  int op_slot_left_1122 = gc_frame_newslot(strlit1126);
  params[0] = call1124;
  partcv[0] = 1;
  Object opresult1127 = callmethod(strlit1126, "++(1)", 1, partcv, params);
// compiled op node returning opresult1127 (depth = 9)
  int op_slot_left_1119 = gc_frame_newslot(opresult1127);
  params[0] = strlit1120;
  partcv[0] = 1;
  Object opresult1128 = callmethod(opresult1127, "++(1)", 1, partcv, params);
// compiled op node returning opresult1128 (depth = 8)
  int op_slot_left_1110 = gc_frame_newslot(opresult1128);
  params[0] = call1117;
  partcv[0] = 1;
  Object opresult1129 = callmethod(opresult1128, "++(1)", 1, partcv, params);
// compiled op node returning opresult1129 (depth = 7)
  int op_slot_left_1107 = gc_frame_newslot(opresult1129);
  params[0] = strlit1108;
  partcv[0] = 1;
  Object opresult1130 = callmethod(opresult1129, "++(1)", 1, partcv, params);
// compiled op node returning opresult1130 (depth = 6)
  int op_slot_left_1104 = gc_frame_newslot(opresult1130);
  params[0] = strlit1105;
  partcv[0] = 1;
  Object opresult1131 = callmethod(opresult1130, "++(1)", 1, partcv, params);
// compiled op node returning opresult1131 (depth = 5)
  gc_frame_newslot(opresult1131);
// Begin line 913
  setline(913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1132 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1133 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1132);
// compiled member node returning call1133 (depth = 5)
  gc_frame_newslot(call1133);
// Begin line 914
  setline(914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1134 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1135 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1134);
// compiled member node returning call1135 (depth = 5)
  gc_frame_newslot(call1135);
// starting to compile member node (depth = 5)
  int callframe1136 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1137 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1136);
// compiled member node returning call1137 (depth = 5)
  gc_frame_newslot(call1137);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 912
  setline(912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult1131;
  params[1] = call1133;
  params[2] = call1135;
  params[3] = call1137;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1138 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1103);
// compiled call node returning call1138 (depth = 4)
    gc_frame_newslot(call1138);
    if978 = call1138;
  }
// compiled if node returning if978 (depth = 3)
    gc_frame_newslot(if978);
    if964 = if978;
  } else {
// Begin line 936
  setline(936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 916
  setline(916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1140 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_lexer (depth = 5)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call1141 = callmethodflags(module_lexer, "isBadControl(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1140);
// compiled call node returning call1141 (depth = 4)
  Object if1139 = done;
  if (istrue(call1141)) {
// Begin line 919
  setline(919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1142 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1143 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call1144 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe1143);
// compiled member node returning call1144 (depth = 6)
  partcv[0] = 0;
  Object call1145 = callmethodflags(call1144, "new", 1, partcv, params, 0);
  gc_frame_end(callframe1142);
// compiled member node returning call1145 (depth = 5)
  *var_suggestion = call1145;
  if (call1145 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1146 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1147 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1148 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1147);
// compiled member node returning call1148 (depth = 5)
  gc_frame_newslot(call1148);
// starting to compile member node (depth = 5)
  int callframe1149 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1150 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1149);
// compiled member node returning call1150 (depth = 5)
  gc_frame_newslot(call1150);
// Begin line 921
  setline(921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1152 == NULL) {
    strlit1152 = alloc_String("");
    gc_root(strlit1152);
  }
// compiled string node returning strlit1152 (depth = 6)
  int op_slot_right_1151 = gc_frame_newslot(strlit1152);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1155 = gc_frame_new();
// starting to compile call node (depth = 8)
  int callframe1156 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num1157 = alloc_Float64(16);
// compiled num node returning num1157 (depth = 9)
  gc_frame_newslot(num1157);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ordval (depth = 9)
  params[0] = num1157;
  partcv[0] = 1;
  Object call1158 = callmethodflags(*var_ordval, "inBase(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1156);
// compiled call node returning call1158 (depth = 8)
  gc_frame_newslot(call1158);
// starting to compile num node (depth = 8)
  Object num1159 = alloc_Float64(4);
// compiled num node returning num1159 (depth = 8)
  gc_frame_newslot(num1159);
// starting to compile string node (depth = 8)
  if (strlit1160 == NULL) {
    strlit1160 = alloc_String("0");
    gc_root(strlit1160);
  }
// compiled string node returning strlit1160 (depth = 8)
  gc_frame_newslot(strlit1160);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_lexer (depth = 8)
  params[0] = call1158;
  params[1] = num1159;
  params[2] = strlit1160;
  partcv[0] = 3;
  Object call1161 = callmethodflags(module_lexer, "padl(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1155);
// compiled call node returning call1161 (depth = 7)
  int op_slot_right_1154 = gc_frame_newslot(call1161);
// Begin line 921
  setline(921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit1163 == NULL) {
    strlit1163 = alloc_String("\\u");
    gc_root(strlit1163);
  }
// compiled string node returning strlit1163 (depth = 7)
  int op_slot_left_1154 = gc_frame_newslot(strlit1163);
  params[0] = call1161;
  partcv[0] = 1;
  Object opresult1164 = callmethod(strlit1163, "++(1)", 1, partcv, params);
// compiled op node returning opresult1164 (depth = 6)
  int op_slot_left_1151 = gc_frame_newslot(opresult1164);
  params[0] = strlit1152;
  partcv[0] = 1;
  Object opresult1165 = callmethod(opresult1164, "++(1)", 1, partcv, params);
// compiled op node returning opresult1165 (depth = 5)
  gc_frame_newslot(opresult1165);
// Begin line 922
  setline(922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1166 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1167 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1166);
// compiled member node returning call1167 (depth = 5)
  gc_frame_newslot(call1167);
// call case 6: other requests
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = call1148;
  params[1] = call1150;
  params[2] = opresult1165;
  params[3] = call1167;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1168 = callmethodflags(*var_suggestion, "replaceRange(2)with(1)onLine(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1146);
// compiled call node returning call1168 (depth = 4)
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1169 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1171 == NULL) {
    strlit1171 = alloc_String(" instead");
    gc_root(strlit1171);
  }
// compiled string node returning strlit1171 (depth = 6)
  int op_slot_right_1170 = gc_frame_newslot(strlit1171);
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 927
  setline(927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1174 = gc_frame_new();
// starting to compile call node (depth = 8)
  int callframe1175 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num1176 = alloc_Float64(16);
// compiled num node returning num1176 (depth = 9)
  gc_frame_newslot(num1176);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ordval (depth = 9)
  params[0] = num1176;
  partcv[0] = 1;
  Object call1177 = callmethodflags(*var_ordval, "inBase(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1175);
// compiled call node returning call1177 (depth = 8)
  gc_frame_newslot(call1177);
// starting to compile num node (depth = 8)
  Object num1178 = alloc_Float64(4);
// compiled num node returning num1178 (depth = 8)
  gc_frame_newslot(num1178);
// starting to compile string node (depth = 8)
  if (strlit1179 == NULL) {
    strlit1179 = alloc_String("0");
    gc_root(strlit1179);
  }
// compiled string node returning strlit1179 (depth = 8)
  gc_frame_newslot(strlit1179);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_lexer (depth = 8)
  params[0] = call1177;
  params[1] = num1178;
  params[2] = strlit1179;
  partcv[0] = 3;
  Object call1180 = callmethodflags(module_lexer, "padl(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1174);
// compiled call node returning call1180 (depth = 7)
  int op_slot_right_1173 = gc_frame_newslot(call1180);
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// Begin line 926
  setline(926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit1183 == NULL) {
    strlit1183 = alloc_String("use the Unicode escape \\u");
    gc_root(strlit1183);
  }
// compiled string node returning strlit1183 (depth = 8)
  int op_slot_right_1182 = gc_frame_newslot(strlit1183);
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 925
  setline(925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit1186 == NULL) {
    strlit1186 = alloc_String("written in the source code; ");
    gc_root(strlit1186);
  }
// compiled string node returning strlit1186 (depth = 9)
  int op_slot_right_1185 = gc_frame_newslot(strlit1186);
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// Begin line 924
  setline(924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit1189 == NULL) {
    strlit1189 = alloc_String("is a control character and cannot be ");
    gc_root(strlit1189);
  }
// compiled string node returning strlit1189 (depth = 10)
  int op_slot_right_1188 = gc_frame_newslot(strlit1189);
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1192 == NULL) {
    strlit1192 = alloc_String(") ");
    gc_root(strlit1192);
  }
// compiled string node returning strlit1192 (depth = 11)
  int op_slot_right_1191 = gc_frame_newslot(strlit1192);
// starting to compile op node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1195 = gc_frame_new();
// starting to compile call node (depth = 13)
  int callframe1196 = gc_frame_new();
// starting to compile num node (depth = 14)
  Object num1197 = alloc_Float64(16);
// compiled num node returning num1197 (depth = 14)
  gc_frame_newslot(num1197);
// call case 6: other requests
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_ordval (depth = 14)
  params[0] = num1197;
  partcv[0] = 1;
  Object call1198 = callmethodflags(*var_ordval, "inBase(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1196);
// compiled call node returning call1198 (depth = 13)
  gc_frame_newslot(call1198);
// starting to compile num node (depth = 13)
  Object num1199 = alloc_Float64(4);
// compiled num node returning num1199 (depth = 13)
  gc_frame_newslot(num1199);
// starting to compile string node (depth = 13)
  if (strlit1200 == NULL) {
    strlit1200 = alloc_String("0");
    gc_root(strlit1200);
  }
// compiled string node returning strlit1200 (depth = 13)
  gc_frame_newslot(strlit1200);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning module_lexer (depth = 13)
  params[0] = call1198;
  params[1] = num1199;
  params[2] = strlit1200;
  partcv[0] = 3;
  Object call1201 = callmethodflags(module_lexer, "padl(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1195);
// compiled call node returning call1201 (depth = 12)
  int op_slot_right_1194 = gc_frame_newslot(call1201);
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit1204 == NULL) {
    strlit1204 = alloc_String(" (U+");
    gc_root(strlit1204);
  }
// compiled string node returning strlit1204 (depth = 13)
  int op_slot_right_1203 = gc_frame_newslot(strlit1204);
// starting to compile op node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe1207 = gc_frame_new();
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_c (depth = 15)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_unicode (depth = 15)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call1208 = callmethodflags(*var_unicode, "name(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1207);
// compiled call node returning call1208 (depth = 14)
  int op_slot_right_1206 = gc_frame_newslot(call1208);
// starting to compile string node (depth = 14)
  if (strlit1210 == NULL) {
    strlit1210 = alloc_String("");
    gc_root(strlit1210);
  }
// compiled string node returning strlit1210 (depth = 14)
  int op_slot_left_1206 = gc_frame_newslot(strlit1210);
  params[0] = call1208;
  partcv[0] = 1;
  Object opresult1211 = callmethod(strlit1210, "++(1)", 1, partcv, params);
// compiled op node returning opresult1211 (depth = 13)
  int op_slot_left_1203 = gc_frame_newslot(opresult1211);
  params[0] = strlit1204;
  partcv[0] = 1;
  Object opresult1212 = callmethod(opresult1211, "++(1)", 1, partcv, params);
// compiled op node returning opresult1212 (depth = 12)
  int op_slot_left_1194 = gc_frame_newslot(opresult1212);
  params[0] = call1201;
  partcv[0] = 1;
  Object opresult1213 = callmethod(opresult1212, "++(1)", 1, partcv, params);
// compiled op node returning opresult1213 (depth = 11)
  int op_slot_left_1191 = gc_frame_newslot(opresult1213);
  params[0] = strlit1192;
  partcv[0] = 1;
  Object opresult1214 = callmethod(opresult1213, "++(1)", 1, partcv, params);
// compiled op node returning opresult1214 (depth = 10)
  int op_slot_left_1188 = gc_frame_newslot(opresult1214);
  params[0] = strlit1189;
  partcv[0] = 1;
  Object opresult1215 = callmethod(opresult1214, "++(1)", 1, partcv, params);
// compiled op node returning opresult1215 (depth = 9)
  int op_slot_left_1185 = gc_frame_newslot(opresult1215);
  params[0] = strlit1186;
  partcv[0] = 1;
  Object opresult1216 = callmethod(opresult1215, "++(1)", 1, partcv, params);
// compiled op node returning opresult1216 (depth = 8)
  int op_slot_left_1182 = gc_frame_newslot(opresult1216);
  params[0] = strlit1183;
  partcv[0] = 1;
  Object opresult1217 = callmethod(opresult1216, "++(1)", 1, partcv, params);
// compiled op node returning opresult1217 (depth = 7)
  int op_slot_left_1173 = gc_frame_newslot(opresult1217);
  params[0] = call1180;
  partcv[0] = 1;
  Object opresult1218 = callmethod(opresult1217, "++(1)", 1, partcv, params);
// compiled op node returning opresult1218 (depth = 6)
  int op_slot_left_1170 = gc_frame_newslot(opresult1218);
  params[0] = strlit1171;
  partcv[0] = 1;
  Object opresult1219 = callmethod(opresult1218, "++(1)", 1, partcv, params);
// compiled op node returning opresult1219 (depth = 5)
  gc_frame_newslot(opresult1219);
// Begin line 929
  setline(929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1220 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1221 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1220);
// compiled member node returning call1221 (depth = 5)
  gc_frame_newslot(call1221);
// starting to compile member node (depth = 5)
  int callframe1222 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1223 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1222);
// compiled member node returning call1223 (depth = 5)
  gc_frame_newslot(call1223);
// starting to compile member node (depth = 5)
  int callframe1224 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1225 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1224);
// compiled member node returning call1225 (depth = 5)
  gc_frame_newslot(call1225);
// Begin line 930
  setline(930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult1219;
  params[1] = call1221;
  params[2] = call1223;
  params[3] = call1225;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1226 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1169);
// compiled call node returning call1226 (depth = 4)
// Begin line 931
  setline(931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1227 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1228 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1229 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1228);
// compiled member node returning call1229 (depth = 5)
  gc_frame_newslot(call1229);
// starting to compile member node (depth = 5)
  int callframe1230 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1231 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1230);
// compiled member node returning call1231 (depth = 5)
  gc_frame_newslot(call1231);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = call1229;
  params[1] = call1231;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1232 = callmethodflags(*var_suggestion, "deleteChar(1)onLine(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1227);
// compiled call node returning call1232 (depth = 4)
// Begin line 932
  setline(932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1233 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 933
  setline(933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1235 == NULL) {
    strlit1235 = alloc_String("is a control character and cannot be written in the source code; consider using spaces instead.");
    gc_root(strlit1235);
  }
// compiled string node returning strlit1235 (depth = 6)
  int op_slot_right_1234 = gc_frame_newslot(strlit1235);
// Begin line 932
  setline(932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1238 == NULL) {
    strlit1238 = alloc_String(") ");
    gc_root(strlit1238);
  }
// compiled string node returning strlit1238 (depth = 7)
  int op_slot_right_1237 = gc_frame_newslot(strlit1238);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1241 = gc_frame_new();
// starting to compile call node (depth = 9)
  int callframe1242 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num1243 = alloc_Float64(16);
// compiled num node returning num1243 (depth = 10)
  gc_frame_newslot(num1243);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ordval (depth = 10)
  params[0] = num1243;
  partcv[0] = 1;
  Object call1244 = callmethodflags(*var_ordval, "inBase(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1242);
// compiled call node returning call1244 (depth = 9)
  gc_frame_newslot(call1244);
// starting to compile num node (depth = 9)
  Object num1245 = alloc_Float64(4);
// compiled num node returning num1245 (depth = 9)
  gc_frame_newslot(num1245);
// starting to compile string node (depth = 9)
  if (strlit1246 == NULL) {
    strlit1246 = alloc_String("0");
    gc_root(strlit1246);
  }
// compiled string node returning strlit1246 (depth = 9)
  gc_frame_newslot(strlit1246);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_lexer (depth = 9)
  params[0] = call1244;
  params[1] = num1245;
  params[2] = strlit1246;
  partcv[0] = 3;
  Object call1247 = callmethodflags(module_lexer, "padl(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1241);
// compiled call node returning call1247 (depth = 8)
  int op_slot_right_1240 = gc_frame_newslot(call1247);
// Begin line 932
  setline(932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1250 == NULL) {
    strlit1250 = alloc_String(" (U+");
    gc_root(strlit1250);
  }
// compiled string node returning strlit1250 (depth = 9)
  int op_slot_right_1249 = gc_frame_newslot(strlit1250);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1253 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_unicode (depth = 11)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call1254 = callmethodflags(*var_unicode, "name(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1253);
// compiled call node returning call1254 (depth = 10)
  int op_slot_right_1252 = gc_frame_newslot(call1254);
// starting to compile string node (depth = 10)
  if (strlit1256 == NULL) {
    strlit1256 = alloc_String("");
    gc_root(strlit1256);
  }
// compiled string node returning strlit1256 (depth = 10)
  int op_slot_left_1252 = gc_frame_newslot(strlit1256);
  params[0] = call1254;
  partcv[0] = 1;
  Object opresult1257 = callmethod(strlit1256, "++(1)", 1, partcv, params);
// compiled op node returning opresult1257 (depth = 9)
  int op_slot_left_1249 = gc_frame_newslot(opresult1257);
  params[0] = strlit1250;
  partcv[0] = 1;
  Object opresult1258 = callmethod(opresult1257, "++(1)", 1, partcv, params);
// compiled op node returning opresult1258 (depth = 8)
  int op_slot_left_1240 = gc_frame_newslot(opresult1258);
  params[0] = call1247;
  partcv[0] = 1;
  Object opresult1259 = callmethod(opresult1258, "++(1)", 1, partcv, params);
// compiled op node returning opresult1259 (depth = 7)
  int op_slot_left_1237 = gc_frame_newslot(opresult1259);
  params[0] = strlit1238;
  partcv[0] = 1;
  Object opresult1260 = callmethod(opresult1259, "++(1)", 1, partcv, params);
// compiled op node returning opresult1260 (depth = 6)
  int op_slot_left_1234 = gc_frame_newslot(opresult1260);
  params[0] = strlit1235;
  partcv[0] = 1;
  Object opresult1261 = callmethod(opresult1260, "++(1)", 1, partcv, params);
// compiled op node returning opresult1261 (depth = 5)
  gc_frame_newslot(opresult1261);
// Begin line 933
  setline(933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1262 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1263 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1262);
// compiled member node returning call1263 (depth = 5)
  gc_frame_newslot(call1263);
// Begin line 934
  setline(934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1264 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1265 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1264);
// compiled member node returning call1265 (depth = 5)
  gc_frame_newslot(call1265);
// starting to compile member node (depth = 5)
  int callframe1266 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1267 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1266);
// compiled member node returning call1267 (depth = 5)
  gc_frame_newslot(call1267);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 932
  setline(932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult1261;
  params[1] = call1263;
  params[2] = call1265;
  params[3] = call1267;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1268 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1233);
// compiled call node returning call1268 (depth = 4)
    gc_frame_newslot(call1268);
    if1139 = call1268;
  } else {
  }
// compiled if node returning if1139 (depth = 3)
    gc_frame_newslot(if1139);
    if964 = if1139;
  }
// compiled if node returning if964 (depth = 2)
  gc_frame_end(frame);
  return if964;
}
Object meth_lexer_1269_checkSeparator_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 70, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkSeparator(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method checkSeparator(_)");
  Object params[5];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_unicode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for checkSeparator(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part checkSeparator(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_ordval = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ordval");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 939
  setline(939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1270 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  partcv[0] = 0;
  Object call1271 = callmethodflags(*var_c, "ord", 1, partcv, params, 0);
  gc_frame_end(callframe1270);
// compiled member node returning call1271 (depth = 3)
  *var_ordval = call1271;
  if (call1271 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1273 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_lexer (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call1274 = callmethodflags(module_lexer, "isBadSeparator(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1273);
// compiled call node returning call1274 (depth = 3)
  Object if1272 = done;
  if (istrue(call1274)) {
// Begin line 944
  setline(944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1275 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1276 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  partcv[0] = 0;
  Object call1277 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe1276);
// compiled member node returning call1277 (depth = 5)
  partcv[0] = 0;
  Object call1278 = callmethodflags(call1277, "new", 1, partcv, params, 0);
  gc_frame_end(callframe1275);
// compiled member node returning call1278 (depth = 4)
  *var_suggestion = call1278;
  if (call1278 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 945
  setline(945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1279 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1280 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1281 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1280);
// compiled member node returning call1281 (depth = 4)
  gc_frame_newslot(call1281);
// starting to compile string node (depth = 4)
  if (strlit1282 == NULL) {
    strlit1282 = alloc_String(" ");
    gc_root(strlit1282);
  }
// compiled string node returning strlit1282 (depth = 4)
  gc_frame_newslot(strlit1282);
// starting to compile member node (depth = 4)
  int callframe1283 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1284 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1283);
// compiled member node returning call1284 (depth = 4)
  gc_frame_newslot(call1284);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = call1281;
  params[1] = strlit1282;
  params[2] = call1284;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1285 = callmethodflags(*var_suggestion, "replaceChar(1)with(1)onLine(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1279);
// compiled call node returning call1285 (depth = 3)
// Begin line 946
  setline(946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1288 = alloc_Float64(9);
// compiled num node returning num1288 (depth = 5)
  int op_slot_right_1287 = gc_frame_newslot(num1288);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ordval (depth = 5)
  int op_slot_left_1287 = gc_frame_newslot(*var_ordval);
  params[0] = num1288;
  partcv[0] = 1;
  Object opresult1290 = callmethod(*var_ordval, "==(1)", 1, partcv, params);
// compiled op node returning opresult1290 (depth = 4)
  Object if1286 = done;
  if (istrue(opresult1290)) {
// Begin line 947
  setline(947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1291 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1292 == NULL) {
    strlit1292 = alloc_String("tabs are not allowed; use spaces instead.");
    gc_root(strlit1292);
  }
// compiled string node returning strlit1292 (depth = 5)
  gc_frame_newslot(strlit1292);
// starting to compile member node (depth = 5)
  int callframe1293 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1294 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1293);
// compiled member node returning call1294 (depth = 5)
  gc_frame_newslot(call1294);
// Begin line 948
  setline(948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1295 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1296 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1295);
// compiled member node returning call1296 (depth = 5)
  gc_frame_newslot(call1296);
// starting to compile member node (depth = 5)
  int callframe1297 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1298 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1297);
// compiled member node returning call1298 (depth = 5)
  gc_frame_newslot(call1298);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 947
  setline(947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit1292;
  params[1] = call1294;
  params[2] = call1296;
  params[3] = call1298;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1299 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1291);
// compiled call node returning call1299 (depth = 4)
    gc_frame_newslot(call1299);
    if1286 = call1299;
  } else {
// Begin line 950
  setline(950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1300 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 951
  setline(951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1302 == NULL) {
    strlit1302 = alloc_String("is not a valid whitespace character; use spaces instead.");
    gc_root(strlit1302);
  }
// compiled string node returning strlit1302 (depth = 6)
  int op_slot_right_1301 = gc_frame_newslot(strlit1302);
// Begin line 950
  setline(950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1305 == NULL) {
    strlit1305 = alloc_String(") ");
    gc_root(strlit1305);
  }
// compiled string node returning strlit1305 (depth = 7)
  int op_slot_right_1304 = gc_frame_newslot(strlit1305);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1308 = gc_frame_new();
// starting to compile call node (depth = 9)
  int callframe1309 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num1310 = alloc_Float64(16);
// compiled num node returning num1310 (depth = 10)
  gc_frame_newslot(num1310);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ordval (depth = 10)
  params[0] = num1310;
  partcv[0] = 1;
  Object call1311 = callmethodflags(*var_ordval, "inBase(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1309);
// compiled call node returning call1311 (depth = 9)
  gc_frame_newslot(call1311);
// starting to compile num node (depth = 9)
  Object num1312 = alloc_Float64(4);
// compiled num node returning num1312 (depth = 9)
  gc_frame_newslot(num1312);
// starting to compile string node (depth = 9)
  if (strlit1313 == NULL) {
    strlit1313 = alloc_String("0");
    gc_root(strlit1313);
  }
// compiled string node returning strlit1313 (depth = 9)
  gc_frame_newslot(strlit1313);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_lexer (depth = 9)
  params[0] = call1311;
  params[1] = num1312;
  params[2] = strlit1313;
  partcv[0] = 3;
  Object call1314 = callmethodflags(module_lexer, "padl(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1308);
// compiled call node returning call1314 (depth = 8)
  int op_slot_right_1307 = gc_frame_newslot(call1314);
// Begin line 950
  setline(950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1317 == NULL) {
    strlit1317 = alloc_String(" (U+");
    gc_root(strlit1317);
  }
// compiled string node returning strlit1317 (depth = 9)
  int op_slot_right_1316 = gc_frame_newslot(strlit1317);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1320 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_unicode (depth = 11)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call1321 = callmethodflags(*var_unicode, "name(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1320);
// compiled call node returning call1321 (depth = 10)
  int op_slot_right_1319 = gc_frame_newslot(call1321);
// starting to compile string node (depth = 10)
  if (strlit1323 == NULL) {
    strlit1323 = alloc_String("");
    gc_root(strlit1323);
  }
// compiled string node returning strlit1323 (depth = 10)
  int op_slot_left_1319 = gc_frame_newslot(strlit1323);
  params[0] = call1321;
  partcv[0] = 1;
  Object opresult1324 = callmethod(strlit1323, "++(1)", 1, partcv, params);
// compiled op node returning opresult1324 (depth = 9)
  int op_slot_left_1316 = gc_frame_newslot(opresult1324);
  params[0] = strlit1317;
  partcv[0] = 1;
  Object opresult1325 = callmethod(opresult1324, "++(1)", 1, partcv, params);
// compiled op node returning opresult1325 (depth = 8)
  int op_slot_left_1307 = gc_frame_newslot(opresult1325);
  params[0] = call1314;
  partcv[0] = 1;
  Object opresult1326 = callmethod(opresult1325, "++(1)", 1, partcv, params);
// compiled op node returning opresult1326 (depth = 7)
  int op_slot_left_1304 = gc_frame_newslot(opresult1326);
  params[0] = strlit1305;
  partcv[0] = 1;
  Object opresult1327 = callmethod(opresult1326, "++(1)", 1, partcv, params);
// compiled op node returning opresult1327 (depth = 6)
  int op_slot_left_1301 = gc_frame_newslot(opresult1327);
  params[0] = strlit1302;
  partcv[0] = 1;
  Object opresult1328 = callmethod(opresult1327, "++(1)", 1, partcv, params);
// compiled op node returning opresult1328 (depth = 5)
  gc_frame_newslot(opresult1328);
// Begin line 951
  setline(951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1329 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1330 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1329);
// compiled member node returning call1330 (depth = 5)
  gc_frame_newslot(call1330);
// Begin line 952
  setline(952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1331 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1332 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1331);
// compiled member node returning call1332 (depth = 5)
  gc_frame_newslot(call1332);
// starting to compile member node (depth = 5)
  int callframe1333 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1334 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1333);
// compiled member node returning call1334 (depth = 5)
  gc_frame_newslot(call1334);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 950
  setline(950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult1328;
  params[1] = call1330;
  params[2] = call1332;
  params[3] = call1334;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1335 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1300);
// compiled call node returning call1335 (depth = 4)
    gc_frame_newslot(call1335);
    if1286 = call1335;
  }
// compiled if node returning if1286 (depth = 3)
    gc_frame_newslot(if1286);
    if1272 = if1286;
  } else {
// Begin line 963
  setline(963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 954
  setline(954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1337 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_lexer (depth = 5)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call1338 = callmethodflags(module_lexer, "isBadControl(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1337);
// compiled call node returning call1338 (depth = 4)
  Object if1336 = done;
  if (istrue(call1338)) {
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1339 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1340 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call1341 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe1340);
// compiled member node returning call1341 (depth = 6)
  partcv[0] = 0;
  Object call1342 = callmethodflags(call1341, "new", 1, partcv, params, 0);
  gc_frame_end(callframe1339);
// compiled member node returning call1342 (depth = 5)
  *var_suggestion = call1342;
  if (call1342 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1343 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1344 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1345 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1344);
// compiled member node returning call1345 (depth = 5)
  gc_frame_newslot(call1345);
// starting to compile member node (depth = 5)
  int callframe1346 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1347 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1346);
// compiled member node returning call1347 (depth = 5)
  gc_frame_newslot(call1347);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = call1345;
  params[1] = call1347;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1348 = callmethodflags(*var_suggestion, "deleteChar(1)onLine(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1343);
// compiled call node returning call1348 (depth = 4)
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1349 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 960
  setline(960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1351 == NULL) {
    strlit1351 = alloc_String("is a control character and cannot be written in the source code; consider using spaces instead.");
    gc_root(strlit1351);
  }
// compiled string node returning strlit1351 (depth = 6)
  int op_slot_right_1350 = gc_frame_newslot(strlit1351);
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1354 == NULL) {
    strlit1354 = alloc_String(") ");
    gc_root(strlit1354);
  }
// compiled string node returning strlit1354 (depth = 7)
  int op_slot_right_1353 = gc_frame_newslot(strlit1354);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1357 = gc_frame_new();
// starting to compile call node (depth = 9)
  int callframe1358 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num1359 = alloc_Float64(16);
// compiled num node returning num1359 (depth = 10)
  gc_frame_newslot(num1359);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ordval (depth = 10)
  params[0] = num1359;
  partcv[0] = 1;
  Object call1360 = callmethodflags(*var_ordval, "inBase(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1358);
// compiled call node returning call1360 (depth = 9)
  gc_frame_newslot(call1360);
// starting to compile num node (depth = 9)
  Object num1361 = alloc_Float64(4);
// compiled num node returning num1361 (depth = 9)
  gc_frame_newslot(num1361);
// starting to compile string node (depth = 9)
  if (strlit1362 == NULL) {
    strlit1362 = alloc_String("0");
    gc_root(strlit1362);
  }
// compiled string node returning strlit1362 (depth = 9)
  gc_frame_newslot(strlit1362);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_lexer (depth = 9)
  params[0] = call1360;
  params[1] = num1361;
  params[2] = strlit1362;
  partcv[0] = 3;
  Object call1363 = callmethodflags(module_lexer, "padl(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1357);
// compiled call node returning call1363 (depth = 8)
  int op_slot_right_1356 = gc_frame_newslot(call1363);
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1366 == NULL) {
    strlit1366 = alloc_String(" (U+");
    gc_root(strlit1366);
  }
// compiled string node returning strlit1366 (depth = 9)
  int op_slot_right_1365 = gc_frame_newslot(strlit1366);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1369 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_unicode (depth = 11)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call1370 = callmethodflags(*var_unicode, "name(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1369);
// compiled call node returning call1370 (depth = 10)
  int op_slot_right_1368 = gc_frame_newslot(call1370);
// starting to compile string node (depth = 10)
  if (strlit1372 == NULL) {
    strlit1372 = alloc_String("");
    gc_root(strlit1372);
  }
// compiled string node returning strlit1372 (depth = 10)
  int op_slot_left_1368 = gc_frame_newslot(strlit1372);
  params[0] = call1370;
  partcv[0] = 1;
  Object opresult1373 = callmethod(strlit1372, "++(1)", 1, partcv, params);
// compiled op node returning opresult1373 (depth = 9)
  int op_slot_left_1365 = gc_frame_newslot(opresult1373);
  params[0] = strlit1366;
  partcv[0] = 1;
  Object opresult1374 = callmethod(opresult1373, "++(1)", 1, partcv, params);
// compiled op node returning opresult1374 (depth = 8)
  int op_slot_left_1356 = gc_frame_newslot(opresult1374);
  params[0] = call1363;
  partcv[0] = 1;
  Object opresult1375 = callmethod(opresult1374, "++(1)", 1, partcv, params);
// compiled op node returning opresult1375 (depth = 7)
  int op_slot_left_1353 = gc_frame_newslot(opresult1375);
  params[0] = strlit1354;
  partcv[0] = 1;
  Object opresult1376 = callmethod(opresult1375, "++(1)", 1, partcv, params);
// compiled op node returning opresult1376 (depth = 6)
  int op_slot_left_1350 = gc_frame_newslot(opresult1376);
  params[0] = strlit1351;
  partcv[0] = 1;
  Object opresult1377 = callmethod(opresult1376, "++(1)", 1, partcv, params);
// compiled op node returning opresult1377 (depth = 5)
  gc_frame_newslot(opresult1377);
// Begin line 960
  setline(960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1378 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1379 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1378);
// compiled member node returning call1379 (depth = 5)
  gc_frame_newslot(call1379);
// Begin line 961
  setline(961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1380 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1381 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1380);
// compiled member node returning call1381 (depth = 5)
  gc_frame_newslot(call1381);
// starting to compile member node (depth = 5)
  int callframe1382 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1383 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1382);
// compiled member node returning call1383 (depth = 5)
  gc_frame_newslot(call1383);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult1377;
  params[1] = call1379;
  params[2] = call1381;
  params[3] = call1383;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1384 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1349);
// compiled call node returning call1384 (depth = 4)
    gc_frame_newslot(call1384);
    if1336 = call1384;
  } else {
  }
// compiled if node returning if1336 (depth = 3)
    gc_frame_newslot(if1336);
    if1272 = if1336;
  }
// compiled if node returning if1272 (depth = 2)
  gc_frame_end(frame);
  return if1272;
}
Object meth_lexer_1390__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[5];
  int partcv[3];
  Object *var_base = getfromclosure(closure, 0);
  Object *var_val = getfromclosure(closure, 1);
  Object *var_str = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_i = getfromclosure(closure, 4);
  Object *var_unicode = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "n");
  Object *var_inc = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "inc");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
// definebindings:
// definebindings:
// definebindings:
  Object *var_validDigits = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "validDigits");
// definebindings:
// Begin line 969
  setline(969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1391 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_c (depth = 6)
  partcv[0] = 0;
  Object call1392 = callmethodflags(*var_c, "ord", 1, partcv, params, 0);
  gc_frame_end(callframe1391);
// compiled member node returning call1392 (depth = 5)
  *var_n = call1392;
  if (call1392 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 970
  setline(970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_base (depth = 6)
  int op_slot_right_1393 = gc_frame_newslot(*var_base);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_val (depth = 6)
  int op_slot_left_1393 = gc_frame_newslot(*var_val);
  params[0] = *var_base;
  partcv[0] = 1;
  Object prod1395 = callmethod(*var_val, "*(1)", 1, partcv, params);
// compiled op node returning prod1395 (depth = 5)
  *var_val = prod1395;
  if (prod1395 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1397 = alloc_Float64(0);
// compiled num node returning num1397 (depth = 5)
  *var_inc = num1397;
  if (num1397 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1401 = alloc_Float64(57);
// compiled num node returning num1401 (depth = 7)
  int op_slot_right_1400 = gc_frame_newslot(num1401);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  int op_slot_left_1400 = gc_frame_newslot(*var_n);
  params[0] = num1401;
  partcv[0] = 1;
  Object opresult1403 = callmethod(*var_n, "≤(1)", 1, partcv, params);
// compiled op node returning opresult1403 (depth = 6)
  int op_slot_right_1399 = gc_frame_newslot(opresult1403);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1406 = alloc_Float64(48);
// compiled num node returning num1406 (depth = 7)
  int op_slot_right_1405 = gc_frame_newslot(num1406);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  int op_slot_left_1405 = gc_frame_newslot(*var_n);
  params[0] = num1406;
  partcv[0] = 1;
  Object opresult1408 = callmethod(*var_n, "≥(1)", 1, partcv, params);
// compiled op node returning opresult1408 (depth = 6)
  int op_slot_left_1399 = gc_frame_newslot(opresult1408);
  params[0] = opresult1403;
  partcv[0] = 1;
  Object opresult1409 = callmethod(opresult1408, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1409 (depth = 5)
  Object if1398 = done;
  if (istrue(opresult1409)) {
// Begin line 973
  setline(973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1411 = alloc_Float64(48);
// compiled num node returning num1411 (depth = 7)
  int op_slot_right_1410 = gc_frame_newslot(num1411);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  int op_slot_left_1410 = gc_frame_newslot(*var_n);
  params[0] = num1411;
  partcv[0] = 1;
  Object diff1413 = callmethod(*var_n, "-(1)", 1, partcv, params);
// compiled op node returning diff1413 (depth = 6)
  *var_inc = diff1413;
  if (diff1413 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1398 = done;
  } else {
// Begin line 976
  setline(976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 974
  setline(974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1418 = alloc_Float64(90);
// compiled num node returning num1418 (depth = 8)
  int op_slot_right_1417 = gc_frame_newslot(num1418);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_left_1417 = gc_frame_newslot(*var_n);
  params[0] = num1418;
  partcv[0] = 1;
  Object opresult1420 = callmethod(*var_n, "≤(1)", 1, partcv, params);
// compiled op node returning opresult1420 (depth = 7)
  int op_slot_right_1416 = gc_frame_newslot(opresult1420);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1423 = alloc_Float64(65);
// compiled num node returning num1423 (depth = 8)
  int op_slot_right_1422 = gc_frame_newslot(num1423);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_left_1422 = gc_frame_newslot(*var_n);
  params[0] = num1423;
  partcv[0] = 1;
  Object opresult1425 = callmethod(*var_n, "≥(1)", 1, partcv, params);
// compiled op node returning opresult1425 (depth = 7)
  int op_slot_left_1416 = gc_frame_newslot(opresult1425);
  params[0] = opresult1420;
  partcv[0] = 1;
  Object opresult1426 = callmethod(opresult1425, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1426 (depth = 6)
  Object if1415 = done;
  if (istrue(opresult1426)) {
// Begin line 975
  setline(975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1428 = alloc_Float64(55);
// compiled num node returning num1428 (depth = 8)
  int op_slot_right_1427 = gc_frame_newslot(num1428);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_left_1427 = gc_frame_newslot(*var_n);
  params[0] = num1428;
  partcv[0] = 1;
  Object diff1430 = callmethod(*var_n, "-(1)", 1, partcv, params);
// compiled op node returning diff1430 (depth = 7)
  *var_inc = diff1430;
  if (diff1430 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if1415 = done;
  } else {
// Begin line 977
  setline(977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1433 = alloc_Float64(87);
// compiled num node returning num1433 (depth = 8)
  int op_slot_right_1432 = gc_frame_newslot(num1433);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_left_1432 = gc_frame_newslot(*var_n);
  params[0] = num1433;
  partcv[0] = 1;
  Object diff1435 = callmethod(*var_n, "-(1)", 1, partcv, params);
// compiled op node returning diff1435 (depth = 7)
  *var_inc = diff1435;
  if (diff1435 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if1415 = done;
  }
// compiled if node returning if1415 (depth = 5)
    gc_frame_newslot(if1415);
    if1398 = if1415;
  }
// compiled if node returning if1398 (depth = 4)
// Begin line 979
  setline(979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_base (depth = 6)
  int op_slot_right_1438 = gc_frame_newslot(*var_base);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inc (depth = 6)
  int op_slot_left_1438 = gc_frame_newslot(*var_inc);
  params[0] = *var_base;
  partcv[0] = 1;
  Object opresult1440 = callmethod(*var_inc, "≥(1)", 1, partcv, params);
// compiled op node returning opresult1440 (depth = 5)
  Object if1437 = done;
  if (istrue(opresult1440)) {
// Begin line 980
  setline(980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1444 = alloc_Float64(16);
// compiled num node returning num1444 (depth = 8)
  int op_slot_right_1443 = gc_frame_newslot(num1444);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_inc (depth = 8)
  int op_slot_left_1443 = gc_frame_newslot(*var_inc);
  params[0] = num1444;
  partcv[0] = 1;
  Object opresult1446 = callmethod(*var_inc, "<(1)", 1, partcv, params);
// compiled op node returning opresult1446 (depth = 7)
  int op_slot_right_1442 = gc_frame_newslot(opresult1446);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1449 == NULL) {
    strlit1449 = alloc_String("0");
    gc_root(strlit1449);
  }
// compiled string node returning strlit1449 (depth = 8)
  int op_slot_right_1448 = gc_frame_newslot(strlit1449);
// starting to compile member node (depth = 8)
  int callframe1451 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_str (depth = 9)
  partcv[0] = 0;
  Object call1452 = callmethodflags(*var_str, "first", 1, partcv, params, 0);
  gc_frame_end(callframe1451);
// compiled member node returning call1452 (depth = 8)
  int op_slot_left_1448 = gc_frame_newslot(call1452);
  params[0] = strlit1449;
  partcv[0] = 1;
  Object opresult1453 = callmethod(call1452, "==(1)", 1, partcv, params);
// compiled op node returning opresult1453 (depth = 7)
  int op_slot_left_1442 = gc_frame_newslot(opresult1453);
  params[0] = opresult1446;
  partcv[0] = 1;
  Object opresult1454 = callmethod(opresult1453, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1454 (depth = 6)
  Object if1441 = done;
  if (istrue(opresult1454)) {
// Begin line 981
  setline(981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe1455 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1456 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call1457 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe1456);
// compiled member node returning call1457 (depth = 8)
  partcv[0] = 0;
  Object call1458 = callmethodflags(call1457, "new", 1, partcv, params, 0);
  gc_frame_end(callframe1455);
// compiled member node returning call1458 (depth = 7)
  *var_suggestion = call1458;
  if (call1458 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 982
  setline(982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1459 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1460 == NULL) {
    strlit1460 = alloc_String("x");
    gc_root(strlit1460);
  }
// compiled string node returning strlit1460 (depth = 7)
  gc_frame_newslot(strlit1460);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1462 = alloc_Float64(1);
// compiled num node returning num1462 (depth = 8)
  int op_slot_right_1461 = gc_frame_newslot(num1462);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe1465 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_str (depth = 10)
  partcv[0] = 0;
  Object call1466 = callmethodflags(*var_str, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1465);
// compiled member node returning call1466 (depth = 9)
  int op_slot_right_1464 = gc_frame_newslot(call1466);
// starting to compile member node (depth = 9)
  int callframe1468 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1469 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1468);
// compiled member node returning call1469 (depth = 9)
  int op_slot_left_1464 = gc_frame_newslot(call1469);
  params[0] = call1466;
  partcv[0] = 1;
  Object diff1470 = callmethod(call1469, "-(1)", 1, partcv, params);
// compiled op node returning diff1470 (depth = 8)
  int op_slot_left_1461 = gc_frame_newslot(diff1470);
  params[0] = num1462;
  partcv[0] = 1;
  Object sum1471 = callmethod(diff1470, "+(1)", 1, partcv, params);
// compiled op node returning sum1471 (depth = 7)
  gc_frame_newslot(sum1471);
// starting to compile member node (depth = 7)
  int callframe1472 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1473 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1472);
// compiled member node returning call1473 (depth = 7)
  gc_frame_newslot(call1473);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit1460;
  params[1] = sum1471;
  params[2] = call1473;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1474 = callmethodflags(*var_suggestion, "insert(1)atPosition(1)onLine(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1459);
// compiled call node returning call1474 (depth = 6)
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1475 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1476 == NULL) {
    strlit1476 = alloc_String("a number in base 16 must start with '0x'.");
    gc_root(strlit1476);
  }
// compiled string node returning strlit1476 (depth = 7)
  gc_frame_newslot(strlit1476);
// Begin line 984
  setline(984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe1477 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1478 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1477);
// compiled member node returning call1478 (depth = 7)
  gc_frame_newslot(call1478);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1480 = alloc_Float64(1);
// compiled num node returning num1480 (depth = 8)
  int op_slot_right_1479 = gc_frame_newslot(num1480);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe1483 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_str (depth = 10)
  partcv[0] = 0;
  Object call1484 = callmethodflags(*var_str, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1483);
// compiled member node returning call1484 (depth = 9)
  int op_slot_right_1482 = gc_frame_newslot(call1484);
// starting to compile member node (depth = 9)
  int callframe1486 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1487 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1486);
// compiled member node returning call1487 (depth = 9)
  int op_slot_left_1482 = gc_frame_newslot(call1487);
  params[0] = call1484;
  partcv[0] = 1;
  Object diff1488 = callmethod(call1487, "-(1)", 1, partcv, params);
// compiled op node returning diff1488 (depth = 8)
  int op_slot_left_1479 = gc_frame_newslot(diff1488);
  params[0] = num1480;
  partcv[0] = 1;
  Object sum1489 = callmethod(diff1488, "+(1)", 1, partcv, params);
// compiled op node returning sum1489 (depth = 7)
  gc_frame_newslot(sum1489);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit1476;
  params[1] = call1478;
  params[2] = sum1489;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1490 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1475);
// compiled call node returning call1490 (depth = 6)
    gc_frame_newslot(call1490);
    if1441 = call1490;
  } else {
// Begin line 986
  setline(986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe1491 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1492 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call1493 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe1492);
// compiled member node returning call1493 (depth = 8)
  partcv[0] = 0;
  Object call1494 = callmethodflags(call1493, "new", 1, partcv, params, 0);
  gc_frame_end(callframe1491);
// compiled member node returning call1494 (depth = 7)
  *var_suggestion = call1494;
  if (call1494 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 987
  setline(987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1497 = alloc_Float64(1);
// compiled num node returning num1497 (depth = 8)
  int op_slot_right_1496 = gc_frame_newslot(num1497);
// starting to compile member node (depth = 8)
  int callframe1499 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_str (depth = 9)
  partcv[0] = 0;
  Object call1500 = callmethodflags(*var_str, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1499);
// compiled member node returning call1500 (depth = 8)
  int op_slot_left_1496 = gc_frame_newslot(call1500);
  params[0] = num1497;
  partcv[0] = 1;
  Object opresult1501 = callmethod(call1500, "==(1)", 1, partcv, params);
// compiled op node returning opresult1501 (depth = 7)
  Object if1495 = done;
  if (istrue(opresult1501)) {
// Begin line 988
  setline(988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1502 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1504 = alloc_Float64(1);
// compiled num node returning num1504 (depth = 9)
  int op_slot_right_1503 = gc_frame_newslot(num1504);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe1507 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_str (depth = 11)
  partcv[0] = 0;
  Object call1508 = callmethodflags(*var_str, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1507);
// compiled member node returning call1508 (depth = 10)
  int op_slot_right_1506 = gc_frame_newslot(call1508);
// starting to compile member node (depth = 10)
  int callframe1510 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1511 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1510);
// compiled member node returning call1511 (depth = 10)
  int op_slot_left_1506 = gc_frame_newslot(call1511);
  params[0] = call1508;
  partcv[0] = 1;
  Object diff1512 = callmethod(call1511, "-(1)", 1, partcv, params);
// compiled op node returning diff1512 (depth = 9)
  int op_slot_left_1503 = gc_frame_newslot(diff1512);
  params[0] = num1504;
  partcv[0] = 1;
  Object diff1513 = callmethod(diff1512, "-(1)", 1, partcv, params);
// compiled op node returning diff1513 (depth = 8)
  gc_frame_newslot(diff1513);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1515 = alloc_Float64(1);
// compiled num node returning num1515 (depth = 9)
  int op_slot_right_1514 = gc_frame_newslot(num1515);
// starting to compile member node (depth = 9)
  int callframe1517 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1518 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1517);
// compiled member node returning call1518 (depth = 9)
  int op_slot_left_1514 = gc_frame_newslot(call1518);
  params[0] = num1515;
  partcv[0] = 1;
  Object diff1519 = callmethod(call1518, "-(1)", 1, partcv, params);
// compiled op node returning diff1519 (depth = 8)
  gc_frame_newslot(diff1519);
// starting to compile member node (depth = 8)
  int callframe1520 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1521 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1520);
// compiled member node returning call1521 (depth = 8)
  gc_frame_newslot(call1521);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = diff1513;
  params[1] = diff1519;
  params[2] = call1521;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1522 = callmethodflags(*var_suggestion, "deleteRange(2)onLine(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1502);
// compiled call node returning call1522 (depth = 7)
    gc_frame_newslot(call1522);
    if1495 = call1522;
  } else {
// Begin line 990
  setline(990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1523 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_right_1524 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe1527 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_str (depth = 11)
  partcv[0] = 0;
  Object call1528 = callmethodflags(*var_str, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1527);
// compiled member node returning call1528 (depth = 10)
  int op_slot_right_1526 = gc_frame_newslot(call1528);
// starting to compile member node (depth = 10)
  int callframe1530 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1531 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1530);
// compiled member node returning call1531 (depth = 10)
  int op_slot_left_1526 = gc_frame_newslot(call1531);
  params[0] = call1528;
  partcv[0] = 1;
  Object diff1532 = callmethod(call1531, "-(1)", 1, partcv, params);
// compiled op node returning diff1532 (depth = 9)
  int op_slot_left_1524 = gc_frame_newslot(diff1532);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1533 = callmethod(diff1532, "+(1)", 1, partcv, params);
// compiled op node returning sum1533 (depth = 8)
  gc_frame_newslot(sum1533);
// starting to compile member node (depth = 8)
  int callframe1534 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1535 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1534);
// compiled member node returning call1535 (depth = 8)
  gc_frame_newslot(call1535);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum1533;
  params[1] = call1535;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1536 = callmethodflags(*var_suggestion, "deleteChar(1)onLine(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1523);
// compiled call node returning call1536 (depth = 7)
    gc_frame_newslot(call1536);
    if1495 = call1536;
  }
// compiled if node returning if1495 (depth = 6)
// Begin line 992
  setline(992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1539 = alloc_Float64(10);
// compiled num node returning num1539 (depth = 9)
  int op_slot_right_1538 = gc_frame_newslot(num1539);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_base (depth = 9)
  int op_slot_left_1538 = gc_frame_newslot(*var_base);
  params[0] = num1539;
  partcv[0] = 1;
  Object opresult1541 = callmethod(*var_base, "≤(1)", 1, partcv, params);
// compiled op node returning opresult1541 (depth = 8)
  Object if1537 = done;
struct StackFrameObject *iftmpstackframe1537 = stackframe;
  if (istrue(opresult1541)) {
stackframe = alloc_StackFrame(0, iftmpstackframe1537);
gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 993
  setline(993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1543 == NULL) {
    strlit1543 = alloc_String("'");
    gc_root(strlit1543);
  }
// compiled string node returning strlit1543 (depth = 9)
  int op_slot_right_1542 = gc_frame_newslot(strlit1543);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num1547 = alloc_Float64(1);
// compiled num node returning num1547 (depth = 11)
  int op_slot_right_1546 = gc_frame_newslot(num1547);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_base (depth = 11)
  int op_slot_left_1546 = gc_frame_newslot(*var_base);
  params[0] = num1547;
  partcv[0] = 1;
  Object diff1549 = callmethod(*var_base, "-(1)", 1, partcv, params);
// compiled op node returning diff1549 (depth = 10)
  int op_slot_right_1545 = gc_frame_newslot(diff1549);
// starting to compile string node (depth = 10)
  if (strlit1551 == NULL) {
    strlit1551 = alloc_String("'0' to '");
    gc_root(strlit1551);
  }
// compiled string node returning strlit1551 (depth = 10)
  int op_slot_left_1545 = gc_frame_newslot(strlit1551);
  params[0] = diff1549;
  partcv[0] = 1;
  Object opresult1552 = callmethod(strlit1551, "++(1)", 1, partcv, params);
// compiled op node returning opresult1552 (depth = 9)
  int op_slot_left_1542 = gc_frame_newslot(opresult1552);
  params[0] = strlit1543;
  partcv[0] = 1;
  Object opresult1553 = callmethod(opresult1552, "++(1)", 1, partcv, params);
// compiled op node returning opresult1553 (depth = 8)
    gc_frame_newslot(opresult1553);
    if1537 = opresult1553;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe1537);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 995
  setline(995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1555 == NULL) {
    strlit1555 = alloc_String("'");
    gc_root(strlit1555);
  }
// compiled string node returning strlit1555 (depth = 9)
  int op_slot_right_1554 = gc_frame_newslot(strlit1555);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1558 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_base (depth = 12)
  int op_slot_right_1559 = gc_frame_newslot(*var_base);
// starting to compile num node (depth = 12)
  Object num1561 = alloc_Float64(87);
// compiled num node returning num1561 (depth = 12)
  int op_slot_left_1559 = gc_frame_newslot(num1561);
  params[0] = *var_base;
  partcv[0] = 1;
  Object sum1562 = callmethod(num1561, "+(1)", 1, partcv, params);
// compiled op node returning sum1562 (depth = 11)
  gc_frame_newslot(sum1562);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_unicode (depth = 11)
  params[0] = sum1562;
  partcv[0] = 1;
  Object call1563 = callmethodflags(*var_unicode, "create(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1558);
// compiled call node returning call1563 (depth = 10)
  int op_slot_right_1557 = gc_frame_newslot(call1563);
// starting to compile string node (depth = 10)
  if (strlit1565 == NULL) {
    strlit1565 = alloc_String("'0' to '9', 'a' to '");
    gc_root(strlit1565);
  }
// compiled string node returning strlit1565 (depth = 10)
  int op_slot_left_1557 = gc_frame_newslot(strlit1565);
  params[0] = call1563;
  partcv[0] = 1;
  Object opresult1566 = callmethod(strlit1565, "++(1)", 1, partcv, params);
// compiled op node returning opresult1566 (depth = 9)
  int op_slot_left_1554 = gc_frame_newslot(opresult1566);
  params[0] = strlit1555;
  partcv[0] = 1;
  Object opresult1567 = callmethod(opresult1566, "++(1)", 1, partcv, params);
// compiled op node returning opresult1567 (depth = 8)
    gc_frame_newslot(opresult1567);
    if1537 = opresult1567;
  }
stackframe = iftmpstackframe1537;
// compiled if node returning if1537 (depth = 7)
  *var_validDigits = if1537;
  if (if1537 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1568 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1570 == NULL) {
    strlit1570 = alloc_String(".");
    gc_root(strlit1570);
  }
// compiled string node returning strlit1570 (depth = 8)
  int op_slot_right_1569 = gc_frame_newslot(strlit1570);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_validDigits (depth = 9)
  int op_slot_right_1572 = gc_frame_newslot(*var_validDigits);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1575 == NULL) {
    strlit1575 = alloc_String(". Valid digits are ");
    gc_root(strlit1575);
  }
// compiled string node returning strlit1575 (depth = 10)
  int op_slot_right_1574 = gc_frame_newslot(strlit1575);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_base (depth = 11)
  int op_slot_right_1577 = gc_frame_newslot(*var_base);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1580 == NULL) {
    strlit1580 = alloc_String("' is not a valid digit in base ");
    gc_root(strlit1580);
  }
// compiled string node returning strlit1580 (depth = 12)
  int op_slot_right_1579 = gc_frame_newslot(strlit1580);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_c (depth = 13)
  int op_slot_right_1582 = gc_frame_newslot(*var_c);
// starting to compile string node (depth = 13)
  if (strlit1584 == NULL) {
    strlit1584 = alloc_String("'");
    gc_root(strlit1584);
  }
// compiled string node returning strlit1584 (depth = 13)
  int op_slot_left_1582 = gc_frame_newslot(strlit1584);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult1585 = callmethod(strlit1584, "++(1)", 1, partcv, params);
// compiled op node returning opresult1585 (depth = 12)
  int op_slot_left_1579 = gc_frame_newslot(opresult1585);
  params[0] = strlit1580;
  partcv[0] = 1;
  Object opresult1586 = callmethod(opresult1585, "++(1)", 1, partcv, params);
// compiled op node returning opresult1586 (depth = 11)
  int op_slot_left_1577 = gc_frame_newslot(opresult1586);
  params[0] = *var_base;
  partcv[0] = 1;
  Object opresult1587 = callmethod(opresult1586, "++(1)", 1, partcv, params);
// compiled op node returning opresult1587 (depth = 10)
  int op_slot_left_1574 = gc_frame_newslot(opresult1587);
  params[0] = strlit1575;
  partcv[0] = 1;
  Object opresult1588 = callmethod(opresult1587, "++(1)", 1, partcv, params);
// compiled op node returning opresult1588 (depth = 9)
  int op_slot_left_1572 = gc_frame_newslot(opresult1588);
  params[0] = *var_validDigits;
  partcv[0] = 1;
  Object opresult1589 = callmethod(opresult1588, "++(1)", 1, partcv, params);
// compiled op node returning opresult1589 (depth = 8)
  int op_slot_left_1569 = gc_frame_newslot(opresult1589);
  params[0] = strlit1570;
  partcv[0] = 1;
  Object opresult1590 = callmethod(opresult1589, "++(1)", 1, partcv, params);
// compiled op node returning opresult1590 (depth = 7)
  gc_frame_newslot(opresult1590);
// Begin line 998
  setline(998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe1591 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1592 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1591);
// compiled member node returning call1592 (depth = 7)
  gc_frame_newslot(call1592);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  int op_slot_right_1593 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe1596 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_str (depth = 10)
  partcv[0] = 0;
  Object call1597 = callmethodflags(*var_str, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1596);
// compiled member node returning call1597 (depth = 9)
  int op_slot_right_1595 = gc_frame_newslot(call1597);
// starting to compile member node (depth = 9)
  int callframe1599 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1600 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1599);
// compiled member node returning call1600 (depth = 9)
  int op_slot_left_1595 = gc_frame_newslot(call1600);
  params[0] = call1597;
  partcv[0] = 1;
  Object diff1601 = callmethod(call1600, "-(1)", 1, partcv, params);
// compiled op node returning diff1601 (depth = 8)
  int op_slot_left_1593 = gc_frame_newslot(diff1601);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1602 = callmethod(diff1601, "+(1)", 1, partcv, params);
// compiled op node returning sum1602 (depth = 7)
  gc_frame_newslot(sum1602);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  int op_slot_right_1603 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe1606 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_str (depth = 10)
  partcv[0] = 0;
  Object call1607 = callmethodflags(*var_str, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1606);
// compiled member node returning call1607 (depth = 9)
  int op_slot_right_1605 = gc_frame_newslot(call1607);
// starting to compile member node (depth = 9)
  int callframe1609 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1610 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1609);
// compiled member node returning call1610 (depth = 9)
  int op_slot_left_1605 = gc_frame_newslot(call1610);
  params[0] = call1607;
  partcv[0] = 1;
  Object diff1611 = callmethod(call1610, "-(1)", 1, partcv, params);
// compiled op node returning diff1611 (depth = 8)
  int op_slot_left_1603 = gc_frame_newslot(diff1611);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1612 = callmethod(diff1611, "+(1)", 1, partcv, params);
// compiled op node returning sum1612 (depth = 7)
  gc_frame_newslot(sum1612);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult1590;
  params[1] = call1592;
  params[2] = sum1602;
  params[3] = sum1612;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1613 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1568);
// compiled call node returning call1613 (depth = 6)
    gc_frame_newslot(call1613);
    if1441 = call1613;
  }
// compiled if node returning if1441 (depth = 5)
    gc_frame_newslot(if1441);
    if1437 = if1441;
  } else {
  }
// compiled if node returning if1437 (depth = 4)
// Begin line 1001
  setline(1001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inc (depth = 6)
  int op_slot_right_1614 = gc_frame_newslot(*var_inc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_val (depth = 6)
  int op_slot_left_1614 = gc_frame_newslot(*var_val);
  params[0] = *var_inc;
  partcv[0] = 1;
  Object sum1616 = callmethod(*var_val, "+(1)", 1, partcv, params);
// compiled op node returning sum1616 (depth = 5)
  *var_val = sum1616;
  if (sum1616 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1002
  setline(1002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1619 = alloc_Float64(1);
// compiled num node returning num1619 (depth = 6)
  int op_slot_right_1618 = gc_frame_newslot(num1619);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1618 = gc_frame_newslot(*var_i);
  params[0] = num1619;
  partcv[0] = 1;
  Object sum1621 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum1621 (depth = 5)
  *var_i = sum1621;
  if (sum1621 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer_1385_fromBase_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 71, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "fromBase(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method fromBase(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_unicode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for fromBase(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_str = &(stackframe->slots[0]);
  *var_str = args[curarg];
  curarg++;
  Object *var_base = &(stackframe->slots[1]);
  *var_base = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part fromBase(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_val = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "val");
  Object *var_i = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "i");
// Begin line 966
  setline(966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num1386 = alloc_Float64(0);
// compiled num node returning num1386 (depth = 3)
  *var_val = num1386;
  if (num1386 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 967
  setline(967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num1387 = alloc_Float64(0);
// compiled num node returning num1387 (depth = 3)
  *var_i = num1387;
  if (num1387 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 968
  setline(968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1388 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_str (depth = 3)
  gc_frame_newslot(*var_str);
// starting to compile block node (depth = 3)
  Object block1389 = alloc_Block(NULL, NULL, "lexer", 968);
  gc_frame_newslot(block1389);
// method "_apply(_)"
  block_savedest(block1389);
  Object closure1390 = createclosure(7, "_apply(1)");
  setclosureframe(closure1390, stackframe);
  addtoclosure(closure1390, var_base);
  addtoclosure(closure1390, var_val);
  addtoclosure(closure1390, var_str);
  addtoclosure(closure1390, var_errormessages);
  addtoclosure(closure1390, var_i);
  addtoclosure(closure1390, var_unicode);
  addtoclosure(closure1390, selfslot);
  struct UserObject *uo1390 = (struct UserObject*)block1389;
  uo1390->data[0] = (Object)closure1390;
  Method *meth_meth_lexer_1390__apply_40_1_41_ = addmethod2pos(block1389, "_apply(1)", &meth_lexer_1390__apply_40_1_41_, 0);
  int argcv_meth_lexer_1390__apply_40_1_41_[] = {1};
  meth_meth_lexer_1390__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_1390__apply_40_1_41_);
  meth_meth_lexer_1390__apply_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_1390__apply_40_1_41_->definitionLine = 1145;
// compiled block node returning block1389 (depth = 3)
  gc_frame_newslot(block1389);
// call case 5: prelude request
  params[0] = *var_str;
  params[1] = block1389;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1624 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1388);
// compiled call node returning call1624 (depth = 2)
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_val (depth = 2)
  gc_frame_end(frame);
  return *var_val;
}
Object meth_lexer_1625_hexdecchar_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 72, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hexdecchar(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method hexdecchar(_)");
  Object params[4];
  int partcv[2];
  Object *var_errormessages = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for hexdecchar(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part hexdecchar(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_AOrd = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "AOrd");
  Object *var_aOrd = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "aOrd");
  Object *var_zeroOrd = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "zeroOrd");
  Object *var_cOrd = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "cOrd");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1009
  setline(1009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1626 = gc_frame_new();
// call case 6: other requests
// starting to compile string node (depth = 4)
  if (strlit1627 == NULL) {
    strlit1627 = alloc_String("A");
    gc_root(strlit1627);
  }
// compiled string node returning strlit1627 (depth = 4)
  partcv[0] = 0;
  Object call1628 = callmethodflags(strlit1627, "ord", 1, partcv, params, 0);
  gc_frame_end(callframe1626);
// compiled member node returning call1628 (depth = 3)
  *var_AOrd = call1628;
  if (call1628 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1010
  setline(1010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1629 = gc_frame_new();
// call case 6: other requests
// starting to compile string node (depth = 4)
  if (strlit1630 == NULL) {
    strlit1630 = alloc_String("a");
    gc_root(strlit1630);
  }
// compiled string node returning strlit1630 (depth = 4)
  partcv[0] = 0;
  Object call1631 = callmethodflags(strlit1630, "ord", 1, partcv, params, 0);
  gc_frame_end(callframe1629);
// compiled member node returning call1631 (depth = 3)
  *var_aOrd = call1631;
  if (call1631 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1011
  setline(1011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1632 = gc_frame_new();
// call case 6: other requests
// starting to compile string node (depth = 4)
  if (strlit1633 == NULL) {
    strlit1633 = alloc_String("0");
    gc_root(strlit1633);
  }
// compiled string node returning strlit1633 (depth = 4)
  partcv[0] = 0;
  Object call1634 = callmethodflags(strlit1633, "ord", 1, partcv, params, 0);
  gc_frame_end(callframe1632);
// compiled member node returning call1634 (depth = 3)
  *var_zeroOrd = call1634;
  if (call1634 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1012
  setline(1012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1635 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  partcv[0] = 0;
  Object call1636 = callmethodflags(*var_c, "ord", 1, partcv, params, 0);
  gc_frame_end(callframe1635);
// compiled member node returning call1636 (depth = 3)
  *var_cOrd = call1636;
  if (call1636 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1013
  setline(1013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1640 = gc_frame_new();
// call case 6: other requests
// starting to compile string node (depth = 6)
  if (strlit1641 == NULL) {
    strlit1641 = alloc_String("F");
    gc_root(strlit1641);
  }
// compiled string node returning strlit1641 (depth = 6)
  partcv[0] = 0;
  Object call1642 = callmethodflags(strlit1641, "ord", 1, partcv, params, 0);
  gc_frame_end(callframe1640);
// compiled member node returning call1642 (depth = 5)
  int op_slot_right_1639 = gc_frame_newslot(call1642);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cOrd (depth = 5)
  int op_slot_left_1639 = gc_frame_newslot(*var_cOrd);
  params[0] = call1642;
  partcv[0] = 1;
  Object opresult1644 = callmethod(*var_cOrd, "≤(1)", 1, partcv, params);
// compiled op node returning opresult1644 (depth = 4)
  int op_slot_right_1638 = gc_frame_newslot(opresult1644);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_AOrd (depth = 5)
  int op_slot_right_1646 = gc_frame_newslot(*var_AOrd);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cOrd (depth = 5)
  int op_slot_left_1646 = gc_frame_newslot(*var_cOrd);
  params[0] = *var_AOrd;
  partcv[0] = 1;
  Object opresult1648 = callmethod(*var_cOrd, "≥(1)", 1, partcv, params);
// compiled op node returning opresult1648 (depth = 4)
  int op_slot_left_1638 = gc_frame_newslot(opresult1648);
  params[0] = opresult1644;
  partcv[0] = 1;
  Object opresult1649 = callmethod(opresult1648, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1649 (depth = 3)
  Object if1637 = done;
  if (istrue(opresult1649)) {
// Begin line 1014
  setline(1014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1651 = alloc_Float64(10);
// compiled num node returning num1651 (depth = 4)
  int op_slot_right_1650 = gc_frame_newslot(num1651);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_AOrd (depth = 5)
  int op_slot_right_1653 = gc_frame_newslot(*var_AOrd);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cOrd (depth = 5)
  int op_slot_left_1653 = gc_frame_newslot(*var_cOrd);
  params[0] = *var_AOrd;
  partcv[0] = 1;
  Object diff1655 = callmethod(*var_cOrd, "-(1)", 1, partcv, params);
// compiled op node returning diff1655 (depth = 4)
  int op_slot_left_1650 = gc_frame_newslot(diff1655);
  params[0] = num1651;
  partcv[0] = 1;
  Object sum1656 = callmethod(diff1655, "+(1)", 1, partcv, params);
// compiled op node returning sum1656 (depth = 3)
    gc_frame_newslot(sum1656);
    if1637 = sum1656;
  } else {
// Begin line 1017
  setline(1017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1660 = gc_frame_new();
// call case 6: other requests
// starting to compile string node (depth = 7)
  if (strlit1661 == NULL) {
    strlit1661 = alloc_String("f");
    gc_root(strlit1661);
  }
// compiled string node returning strlit1661 (depth = 7)
  partcv[0] = 0;
  Object call1662 = callmethodflags(strlit1661, "ord", 1, partcv, params, 0);
  gc_frame_end(callframe1660);
// compiled member node returning call1662 (depth = 6)
  int op_slot_right_1659 = gc_frame_newslot(call1662);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cOrd (depth = 6)
  int op_slot_left_1659 = gc_frame_newslot(*var_cOrd);
  params[0] = call1662;
  partcv[0] = 1;
  Object opresult1664 = callmethod(*var_cOrd, "≤(1)", 1, partcv, params);
// compiled op node returning opresult1664 (depth = 5)
  int op_slot_right_1658 = gc_frame_newslot(opresult1664);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_aOrd (depth = 6)
  int op_slot_right_1666 = gc_frame_newslot(*var_aOrd);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cOrd (depth = 6)
  int op_slot_left_1666 = gc_frame_newslot(*var_cOrd);
  params[0] = *var_aOrd;
  partcv[0] = 1;
  Object opresult1668 = callmethod(*var_cOrd, "≥(1)", 1, partcv, params);
// compiled op node returning opresult1668 (depth = 5)
  int op_slot_left_1658 = gc_frame_newslot(opresult1668);
  params[0] = opresult1664;
  partcv[0] = 1;
  Object opresult1669 = callmethod(opresult1668, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1669 (depth = 4)
  Object if1657 = done;
  if (istrue(opresult1669)) {
// Begin line 1016
  setline(1016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1671 = alloc_Float64(10);
// compiled num node returning num1671 (depth = 5)
  int op_slot_right_1670 = gc_frame_newslot(num1671);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_aOrd (depth = 6)
  int op_slot_right_1673 = gc_frame_newslot(*var_aOrd);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cOrd (depth = 6)
  int op_slot_left_1673 = gc_frame_newslot(*var_cOrd);
  params[0] = *var_aOrd;
  partcv[0] = 1;
  Object diff1675 = callmethod(*var_cOrd, "-(1)", 1, partcv, params);
// compiled op node returning diff1675 (depth = 5)
  int op_slot_left_1670 = gc_frame_newslot(diff1675);
  params[0] = num1671;
  partcv[0] = 1;
  Object sum1676 = callmethod(diff1675, "+(1)", 1, partcv, params);
// compiled op node returning sum1676 (depth = 4)
    gc_frame_newslot(sum1676);
    if1657 = sum1676;
  } else {
// Begin line 1019
  setline(1019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1017
  setline(1017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe1680 = gc_frame_new();
// call case 6: other requests
// starting to compile string node (depth = 8)
  if (strlit1681 == NULL) {
    strlit1681 = alloc_String("9");
    gc_root(strlit1681);
  }
// compiled string node returning strlit1681 (depth = 8)
  partcv[0] = 0;
  Object call1682 = callmethodflags(strlit1681, "ord", 1, partcv, params, 0);
  gc_frame_end(callframe1680);
// compiled member node returning call1682 (depth = 7)
  int op_slot_right_1679 = gc_frame_newslot(call1682);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_cOrd (depth = 7)
  int op_slot_left_1679 = gc_frame_newslot(*var_cOrd);
  params[0] = call1682;
  partcv[0] = 1;
  Object opresult1684 = callmethod(*var_cOrd, "≤(1)", 1, partcv, params);
// compiled op node returning opresult1684 (depth = 6)
  int op_slot_right_1678 = gc_frame_newslot(opresult1684);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_zeroOrd (depth = 7)
  int op_slot_right_1686 = gc_frame_newslot(*var_zeroOrd);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_cOrd (depth = 7)
  int op_slot_left_1686 = gc_frame_newslot(*var_cOrd);
  params[0] = *var_zeroOrd;
  partcv[0] = 1;
  Object opresult1688 = callmethod(*var_cOrd, "≥(1)", 1, partcv, params);
// compiled op node returning opresult1688 (depth = 6)
  int op_slot_left_1678 = gc_frame_newslot(opresult1688);
  params[0] = opresult1684;
  partcv[0] = 1;
  Object opresult1689 = callmethod(opresult1688, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1689 (depth = 5)
  Object if1677 = done;
  if (istrue(opresult1689)) {
// Begin line 1018
  setline(1018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_zeroOrd (depth = 6)
  int op_slot_right_1690 = gc_frame_newslot(*var_zeroOrd);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cOrd (depth = 6)
  int op_slot_left_1690 = gc_frame_newslot(*var_cOrd);
  params[0] = *var_zeroOrd;
  partcv[0] = 1;
  Object diff1692 = callmethod(*var_cOrd, "-(1)", 1, partcv, params);
// compiled op node returning diff1692 (depth = 5)
    gc_frame_newslot(diff1692);
    if1677 = diff1692;
  } else {
// Begin line 1020
  setline(1020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1693 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1695 == NULL) {
    strlit1695 = alloc_String("' must be a hexadecimal digit");
    gc_root(strlit1695);
  }
// compiled string node returning strlit1695 (depth = 7)
  int op_slot_right_1694 = gc_frame_newslot(strlit1695);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_right_1697 = gc_frame_newslot(*var_c);
// starting to compile string node (depth = 8)
  if (strlit1699 == NULL) {
    strlit1699 = alloc_String("the character '");
    gc_root(strlit1699);
  }
// compiled string node returning strlit1699 (depth = 8)
  int op_slot_left_1697 = gc_frame_newslot(strlit1699);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult1700 = callmethod(strlit1699, "++(1)", 1, partcv, params);
// compiled op node returning opresult1700 (depth = 7)
  int op_slot_left_1694 = gc_frame_newslot(opresult1700);
  params[0] = strlit1695;
  partcv[0] = 1;
  Object opresult1701 = callmethod(opresult1700, "++(1)", 1, partcv, params);
// compiled op node returning opresult1701 (depth = 6)
  gc_frame_newslot(opresult1701);
// Begin line 1021
  setline(1021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe1702 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1703 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1702);
// compiled member node returning call1703 (depth = 6)
  gc_frame_newslot(call1703);
// starting to compile member node (depth = 6)
  int callframe1704 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1705 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1704);
// compiled member node returning call1705 (depth = 6)
  gc_frame_newslot(call1705);
// starting to compile member node (depth = 6)
  int callframe1706 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1707 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1706);
// compiled member node returning call1707 (depth = 6)
  gc_frame_newslot(call1707);
// call case 6: other requests
// Begin line 1020
  setline(1020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult1701;
  params[1] = call1703;
  params[2] = call1705;
  params[3] = call1707;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call1708 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe1693);
// compiled call node returning call1708 (depth = 5)
    gc_frame_newslot(call1708);
    if1677 = call1708;
  }
// compiled if node returning if1677 (depth = 4)
    gc_frame_newslot(if1677);
    if1657 = if1677;
  }
// compiled if node returning if1657 (depth = 3)
    gc_frame_newslot(if1657);
    if1637 = if1657;
  }
// compiled if node returning if1637 (depth = 2)
  gc_frame_end(frame);
  return if1637;
}
Object meth_lexer_1725__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_line = getfromclosure(closure, 0);
  Object *var_lines = getfromclosure(closure, 1);
  Object *var_cLine = getfromclosure(closure, 2);
  Object *var_cLines = getfromclosure(closure, 3);
  Object *var_wasCR = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1036
  setline(1036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1728 == NULL) {
    strlit1728 = alloc_String("""\x0d""");
    gc_root(strlit1728);
  }
// compiled string node returning strlit1728 (depth = 6)
  int op_slot_right_1727 = gc_frame_newslot(strlit1728);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_c (depth = 6)
  int op_slot_left_1727 = gc_frame_newslot(*var_c);
  params[0] = strlit1728;
  partcv[0] = 1;
  Object opresult1730 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult1730 (depth = 5)
  Object if1726 = done;
  if (istrue(opresult1730)) {
// Begin line 1037
  setline(1037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1731 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_line (depth = 6)
  gc_frame_newslot(*var_line);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lines (depth = 6)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call1732 = callmethodflags(*var_lines, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1731);
// compiled call node returning call1732 (depth = 5)
// Begin line 1038
  setline(1038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1733 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cLine (depth = 6)
  gc_frame_newslot(*var_cLine);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cLines (depth = 6)
  params[0] = *var_cLine;
  partcv[0] = 1;
  Object call1734 = callmethodflags(*var_cLines, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1733);
// compiled call node returning call1734 (depth = 5)
// Begin line 1039
  setline(1039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1735 == NULL) {
    strlit1735 = alloc_String("");
    gc_root(strlit1735);
  }
// compiled string node returning strlit1735 (depth = 6)
  *var_line = strlit1735;
  if (strlit1735 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1737 == NULL) {
    strlit1737 = alloc_String("");
    gc_root(strlit1737);
  }
// compiled string node returning strlit1737 (depth = 6)
  *var_cLine = strlit1737;
  if (strlit1737 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1041
  setline(1041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1739 = alloc_Boolean(1);
// compiled identifier node returning bool1739 (depth = 6)
  *var_wasCR = bool1739;
  if (bool1739 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1726 = done;
  } else {
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1042
  setline(1042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1743 == NULL) {
    strlit1743 = alloc_String("""\x0a""");
    gc_root(strlit1743);
  }
// compiled string node returning strlit1743 (depth = 7)
  int op_slot_right_1742 = gc_frame_newslot(strlit1743);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_left_1742 = gc_frame_newslot(*var_c);
  params[0] = strlit1743;
  partcv[0] = 1;
  Object opresult1745 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult1745 (depth = 6)
  Object if1741 = done;
  if (istrue(opresult1745)) {
// Begin line 1043
  setline(1043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_wasCR (depth = 7)
  Object if1746 = done;
  if (istrue(*var_wasCR)) {
    gc_frame_newslot(done);
    if1746 = done;
  } else {
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1747 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  gc_frame_newslot(*var_line);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lines (depth = 8)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call1748 = callmethodflags(*var_lines, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1747);
// compiled call node returning call1748 (depth = 7)
// Begin line 1048
  setline(1048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1749 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_cLine (depth = 8)
  gc_frame_newslot(*var_cLine);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_cLines (depth = 8)
  params[0] = *var_cLine;
  partcv[0] = 1;
  Object call1750 = callmethodflags(*var_cLines, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1749);
// compiled call node returning call1750 (depth = 7)
// Begin line 1049
  setline(1049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1751 == NULL) {
    strlit1751 = alloc_String("");
    gc_root(strlit1751);
  }
// compiled string node returning strlit1751 (depth = 8)
  *var_line = strlit1751;
  if (strlit1751 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 1050
  setline(1050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1753 == NULL) {
    strlit1753 = alloc_String("");
    gc_root(strlit1753);
  }
// compiled string node returning strlit1753 (depth = 8)
  *var_cLine = strlit1753;
  if (strlit1753 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1746 = done;
  }
// compiled if node returning if1746 (depth = 6)
// Begin line 1052
  setline(1052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool1755 = alloc_Boolean(0);
// compiled identifier node returning bool1755 (depth = 7)
  *var_wasCR = bool1755;
  if (bool1755 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if1741 = done;
  } else {
// Begin line 1059
  setline(1059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1759 == NULL) {
    strlit1759 = alloc_String("""\xe2""""\x80""""\xa8""");
    gc_root(strlit1759);
  }
// compiled string node returning strlit1759 (depth = 8)
  int op_slot_right_1758 = gc_frame_newslot(strlit1759);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_1758 = gc_frame_newslot(*var_c);
  params[0] = strlit1759;
  partcv[0] = 1;
  Object opresult1761 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult1761 (depth = 7)
  Object if1757 = done;
  if (istrue(opresult1761)) {
// Begin line 1054
  setline(1054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1762 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  gc_frame_newslot(*var_line);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lines (depth = 8)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call1763 = callmethodflags(*var_lines, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1762);
// compiled call node returning call1763 (depth = 7)
// Begin line 1055
  setline(1055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1764 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_cLine (depth = 8)
  gc_frame_newslot(*var_cLine);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_cLines (depth = 8)
  params[0] = *var_cLine;
  partcv[0] = 1;
  Object call1765 = callmethodflags(*var_cLines, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1764);
// compiled call node returning call1765 (depth = 7)
// Begin line 1056
  setline(1056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1766 == NULL) {
    strlit1766 = alloc_String("");
    gc_root(strlit1766);
  }
// compiled string node returning strlit1766 (depth = 8)
  *var_line = strlit1766;
  if (strlit1766 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1768 == NULL) {
    strlit1768 = alloc_String("");
    gc_root(strlit1768);
  }
// compiled string node returning strlit1768 (depth = 8)
  *var_cLine = strlit1768;
  if (strlit1768 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 1058
  setline(1058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool1770 = alloc_Boolean(0);
// compiled identifier node returning bool1770 (depth = 8)
  *var_wasCR = bool1770;
  if (bool1770 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1757 = done;
  } else {
// Begin line 1063
  setline(1063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1059
  setline(1059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1774 == NULL) {
    strlit1774 = alloc_String("\\");
    gc_root(strlit1774);
  }
// compiled string node returning strlit1774 (depth = 9)
  int op_slot_right_1773 = gc_frame_newslot(strlit1774);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_1773 = gc_frame_newslot(*var_c);
  params[0] = strlit1774;
  partcv[0] = 1;
  Object opresult1776 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult1776 (depth = 8)
  Object if1772 = done;
  if (istrue(opresult1776)) {
// Begin line 1060
  setline(1060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_right_1777 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_line (depth = 10)
  int op_slot_left_1777 = gc_frame_newslot(*var_line);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult1779 = callmethod(*var_line, "++(1)", 1, partcv, params);
// compiled op node returning opresult1779 (depth = 9)
  *var_line = opresult1779;
  if (opresult1779 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 1061
  setline(1061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1782 == NULL) {
    strlit1782 = alloc_String("\\\\");
    gc_root(strlit1782);
  }
// compiled string node returning strlit1782 (depth = 10)
  int op_slot_right_1781 = gc_frame_newslot(strlit1782);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_cLine (depth = 10)
  int op_slot_left_1781 = gc_frame_newslot(*var_cLine);
  params[0] = strlit1782;
  partcv[0] = 1;
  Object opresult1784 = callmethod(*var_cLine, "++(1)", 1, partcv, params);
// compiled op node returning opresult1784 (depth = 9)
  *var_cLine = opresult1784;
  if (opresult1784 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 1062
  setline(1062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool1786 = alloc_Boolean(0);
// compiled identifier node returning bool1786 (depth = 9)
  *var_wasCR = bool1786;
  if (bool1786 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if1772 = done;
  } else {
// Begin line 1067
  setline(1067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 1063
  setline(1063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1790 == NULL) {
    strlit1790 = alloc_String("""\x22""");
    gc_root(strlit1790);
  }
// compiled string node returning strlit1790 (depth = 10)
  int op_slot_right_1789 = gc_frame_newslot(strlit1790);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_left_1789 = gc_frame_newslot(*var_c);
  params[0] = strlit1790;
  partcv[0] = 1;
  Object opresult1792 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult1792 (depth = 9)
  Object if1788 = done;
  if (istrue(opresult1792)) {
// Begin line 1064
  setline(1064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  int op_slot_right_1793 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_line (depth = 11)
  int op_slot_left_1793 = gc_frame_newslot(*var_line);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult1795 = callmethod(*var_line, "++(1)", 1, partcv, params);
// compiled op node returning opresult1795 (depth = 10)
  *var_line = opresult1795;
  if (opresult1795 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 9)
// Begin line 1065
  setline(1065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1798 == NULL) {
    strlit1798 = alloc_String("\\""\x22""");
    gc_root(strlit1798);
  }
// compiled string node returning strlit1798 (depth = 11)
  int op_slot_right_1797 = gc_frame_newslot(strlit1798);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_cLine (depth = 11)
  int op_slot_left_1797 = gc_frame_newslot(*var_cLine);
  params[0] = strlit1798;
  partcv[0] = 1;
  Object opresult1800 = callmethod(*var_cLine, "++(1)", 1, partcv, params);
// compiled op node returning opresult1800 (depth = 10)
  *var_cLine = opresult1800;
  if (opresult1800 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 9)
// Begin line 1066
  setline(1066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool1802 = alloc_Boolean(0);
// compiled identifier node returning bool1802 (depth = 10)
  *var_wasCR = bool1802;
  if (bool1802 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if1788 = done;
  } else {
// Begin line 1068
  setline(1068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  int op_slot_right_1804 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_line (depth = 11)
  int op_slot_left_1804 = gc_frame_newslot(*var_line);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult1806 = callmethod(*var_line, "++(1)", 1, partcv, params);
// compiled op node returning opresult1806 (depth = 10)
  *var_line = opresult1806;
  if (opresult1806 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 9)
// Begin line 1069
  setline(1069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  int op_slot_right_1808 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_cLine (depth = 11)
  int op_slot_left_1808 = gc_frame_newslot(*var_cLine);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult1810 = callmethod(*var_cLine, "++(1)", 1, partcv, params);
// compiled op node returning opresult1810 (depth = 10)
  *var_cLine = opresult1810;
  if (opresult1810 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 9)
// Begin line 1070
  setline(1070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool1812 = alloc_Boolean(0);
// compiled identifier node returning bool1812 (depth = 10)
  *var_wasCR = bool1812;
  if (bool1812 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if1788 = done;
  }
// compiled if node returning if1788 (depth = 8)
    gc_frame_newslot(if1788);
    if1772 = if1788;
  }
// compiled if node returning if1772 (depth = 7)
    gc_frame_newslot(if1772);
    if1757 = if1772;
  }
// compiled if node returning if1757 (depth = 6)
    gc_frame_newslot(if1757);
    if1741 = if1757;
  }
// compiled if node returning if1741 (depth = 5)
    gc_frame_newslot(if1741);
    if1726 = if1741;
  }
// compiled if node returning if1726 (depth = 4)
  gc_frame_end(frame);
  return if1726;
}
Object meth_lexer_1709_lexfile_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 73, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lexfile(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lexfile(_)");
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lexfile(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_file = &(stackframe->slots[0]);
  *var_file = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part lexfile(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_lines = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "lines");
  Object *var_cLines = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "cLines");
  Object *var_line = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "line");
  Object *var_cLine = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "cLine");
  Object *var_wasCR = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "wasCR");
// definebindings:
// definebindings:
// Begin line 1027
  setline(1027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1710 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1711 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  partcv[0] = 0;
  Object call1712 = callmethodflags(*var_util, "lines", 1, partcv, params, 0);
  gc_frame_end(callframe1711);
// compiled member node returning call1712 (depth = 4)
  partcv[0] = 0;
  Object call1713 = callmethodflags(call1712, "makeEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe1710);
// compiled member node returning call1713 (depth = 3)
  *var_lines = call1713;
  if (call1713 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1028
  setline(1028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1714 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1715 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  partcv[0] = 0;
  Object call1716 = callmethodflags(*var_util, "cLines", 1, partcv, params, 0);
  gc_frame_end(callframe1715);
// compiled member node returning call1716 (depth = 4)
  partcv[0] = 0;
  Object call1717 = callmethodflags(call1716, "makeEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe1714);
// compiled member node returning call1717 (depth = 3)
  *var_cLines = call1717;
  if (call1717 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1032
  setline(1032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1718 == NULL) {
    strlit1718 = alloc_String("");
    gc_root(strlit1718);
  }
// compiled string node returning strlit1718 (depth = 3)
  *var_line = strlit1718;
  if (strlit1718 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1033
  setline(1033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1719 == NULL) {
    strlit1719 = alloc_String("");
    gc_root(strlit1719);
  }
// compiled string node returning strlit1719 (depth = 3)
  *var_cLine = strlit1719;
  if (strlit1719 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1034
  setline(1034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool1720 = alloc_Boolean(0);
// compiled identifier node returning bool1720 (depth = 3)
  *var_wasCR = bool1720;
  if (bool1720 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1035
  setline(1035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1721 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe1722 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_file (depth = 4)
  partcv[0] = 0;
  Object call1723 = callmethodflags(*var_file, "read", 1, partcv, params, 0);
  gc_frame_end(callframe1722);
// compiled member node returning call1723 (depth = 3)
  gc_frame_newslot(call1723);
// starting to compile block node (depth = 3)
  Object block1724 = alloc_Block(NULL, NULL, "lexer", 1035);
  gc_frame_newslot(block1724);
// method "_apply(_)"
  block_savedest(block1724);
  Object closure1725 = createclosure(6, "_apply(1)");
  setclosureframe(closure1725, stackframe);
  addtoclosure(closure1725, var_line);
  addtoclosure(closure1725, var_lines);
  addtoclosure(closure1725, var_cLine);
  addtoclosure(closure1725, var_cLines);
  addtoclosure(closure1725, var_wasCR);
  addtoclosure(closure1725, selfslot);
  struct UserObject *uo1725 = (struct UserObject*)block1724;
  uo1725->data[0] = (Object)closure1725;
  Method *meth_meth_lexer_1725__apply_40_1_41_ = addmethod2pos(block1724, "_apply(1)", &meth_lexer_1725__apply_40_1_41_, 0);
  int argcv_meth_lexer_1725__apply_40_1_41_[] = {1};
  meth_meth_lexer_1725__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_1725__apply_40_1_41_);
  meth_meth_lexer_1725__apply_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_1725__apply_40_1_41_->definitionLine = 1145;
// compiled block node returning block1724 (depth = 3)
  gc_frame_newslot(block1724);
// call case 5: prelude request
  params[0] = call1723;
  params[1] = block1724;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1815 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1721);
// compiled call node returning call1815 (depth = 2)
// Begin line 1073
  setline(1073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1818 == NULL) {
    strlit1818 = alloc_String("");
    gc_root(strlit1818);
  }
// compiled string node returning strlit1818 (depth = 4)
  int op_slot_right_1817 = gc_frame_newslot(strlit1818);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_line (depth = 4)
  int op_slot_left_1817 = gc_frame_newslot(*var_line);
  params[0] = strlit1818;
  partcv[0] = 1;
  Object opresult1820 = callmethod(*var_line, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1820 (depth = 3)
  Object if1816 = done;
  if (istrue(opresult1820)) {
// Begin line 1075
  setline(1075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1821 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_line (depth = 4)
  gc_frame_newslot(*var_line);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lines (depth = 4)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call1822 = callmethodflags(*var_lines, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1821);
// compiled call node returning call1822 (depth = 3)
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1823 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cLine (depth = 4)
  gc_frame_newslot(*var_cLine);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cLines (depth = 4)
  params[0] = *var_cLine;
  partcv[0] = 1;
  Object call1824 = callmethodflags(*var_cLines, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1823);
// compiled call node returning call1824 (depth = 3)
    gc_frame_newslot(call1824);
    if1816 = call1824;
  } else {
  }
// compiled if node returning if1816 (depth = 2)
// Begin line 1078
  setline(1078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1825 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lines (depth = 3)
  gc_frame_newslot(*var_lines);
// call case 4: self request
  params[0] = *var_lines;
  partcv[0] = 1;
  Object call1826 = callmethodflags(self, "lexinput(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1825);
// compiled call node returning call1826 (depth = 2)
  gc_frame_end(frame);
  return call1826;
}
Object meth_lexer_1834_savePosition(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "savePosition");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1089
  setline(1089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile array node (depth = 5)
  Object array1835 = alloc_BuiltinList();
  gc_pause();
// starting to compile member node (depth = 6)
  int callframe1836 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1837 = callmethodflags(self, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1836);
// compiled member node returning call1837 (depth = 6)
  params[0] = call1837;
  partcv[0] = 1;
  callmethodflags(array1835, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile member node (depth = 6)
  int callframe1838 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1839 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1838);
// compiled member node returning call1839 (depth = 6)
  params[0] = call1839;
  partcv[0] = 1;
  callmethodflags(array1835, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile member node (depth = 6)
  int callframe1840 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1841 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1840);
// compiled member node returning call1841 (depth = 6)
  params[0] = call1841;
  partcv[0] = 1;
  callmethodflags(array1835, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array1835 (depth = 5)
  return array1835;
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_lexer_1842_restorePosition_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "restorePosition(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method restorePosition(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for restorePosition(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_saved = &(stackframe->slots[0]);
  *var_saved = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part restorePosition(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1093
  setline(1093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1843 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1844 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_saved (depth = 6)
  partcv[0] = 0;
  Object call1845 = callmethodflags(*var_saved, "first", 1, partcv, params, 0);
  gc_frame_end(callframe1844);
// compiled member node returning call1845 (depth = 5)
  gc_frame_newslot(call1845);
// call case 4: self request
  params[0] = call1845;
  partcv[0] = 1;
  Object call1846 = callmethodflags(self, "first:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1843);
// compiled call node returning call1846 (depth = 4)
// Begin line 1094
  setline(1094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1847 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1848 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_saved (depth = 6)
  partcv[0] = 0;
  Object call1849 = callmethodflags(*var_saved, "second", 1, partcv, params, 0);
  gc_frame_end(callframe1848);
// compiled member node returning call1849 (depth = 5)
  gc_frame_newslot(call1849);
// call case 4: self request
  params[0] = call1849;
  partcv[0] = 1;
  Object call1850 = callmethodflags(self, "last:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1847);
// compiled call node returning call1850 (depth = 4)
// Begin line 1095
  setline(1095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1851 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1852 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_saved (depth = 6)
  partcv[0] = 0;
  Object call1853 = callmethodflags(*var_saved, "third", 1, partcv, params, 0);
  gc_frame_end(callframe1852);
// compiled member node returning call1853 (depth = 5)
  gc_frame_newslot(call1853);
// call case 4: self request
  params[0] = call1853;
  partcv[0] = 1;
  Object call1854 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1851);
// compiled call node returning call1854 (depth = 4)
  gc_frame_end(frame);
  return call1854;
}
Object meth_lexer_1855_push_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(9, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "push(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method push(_)");
  Object params[4];
  int partcv[2];
  Object *var_errormessages = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for push(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part push(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_m1 = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "m1");
  Object *var_m2 = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "m2");
  Object *var_m3 = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "m3");
  Object *var_m4 = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "m4");
  Object *var_m5 = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "m5");
  Object *var_m6 = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "m6");
  Object *var_msg = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "msg");
// definebindings:
// Begin line 1099
  setline(1099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1858 = alloc_Boolean(0);
// compiled identifier node returning bool1858 (depth = 6)
  int op_slot_right_1857 = gc_frame_newslot(bool1858);
// starting to compile member node (depth = 6)
  int callframe1860 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1861 = callmethodflags(self, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1860);
// compiled member node returning call1861 (depth = 6)
  int op_slot_left_1857 = gc_frame_newslot(call1861);
  params[0] = bool1858;
  partcv[0] = 1;
  Object opresult1862 = callmethod(call1861, "==(1)", 1, partcv, params);
// compiled op node returning opresult1862 (depth = 5)
  Object if1856 = done;
  if (istrue(opresult1862)) {
// Begin line 1100
  setline(1100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1863 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 4: self request
  params[0] = *var_t;
  partcv[0] = 1;
  Object call1864 = callmethodflags(self, "first:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1863);
// compiled call node returning call1864 (depth = 5)
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1865 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 4: self request
  params[0] = *var_t;
  partcv[0] = 1;
  Object call1866 = callmethodflags(self, "last:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1865);
// compiled call node returning call1866 (depth = 5)
    gc_frame_newslot(call1866);
    if1856 = call1866;
  } else {
// Begin line 1103
  setline(1103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1867 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1868 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1869 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1868);
// compiled member node returning call1869 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call1870 = callmethodflags(call1869, "next:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1867);
// compiled call node returning call1870 (depth = 5)
// Begin line 1104
  setline(1104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1871 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe1872 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1873 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1872);
// compiled member node returning call1873 (depth = 6)
  gc_frame_newslot(call1873);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  params[0] = call1873;
  partcv[0] = 1;
  Object call1874 = callmethodflags(*var_t, "prev:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1871);
// compiled call node returning call1874 (depth = 5)
// Begin line 1105
  setline(1105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1877 = alloc_Float64(1);
// compiled num node returning num1877 (depth = 7)
  int op_slot_right_1876 = gc_frame_newslot(num1877);
// starting to compile member node (depth = 7)
  int callframe1879 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe1881 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe1882 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1883 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1882);
// compiled member node returning call1883 (depth = 10)
  partcv[0] = 0;
  Object call1884 = callmethodflags(call1883, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe1881);
// compiled member node returning call1884 (depth = 9)
  int op_slot_right_1880 = gc_frame_newslot(call1884);
// starting to compile member node (depth = 9)
  int callframe1886 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  partcv[0] = 0;
  Object call1887 = callmethodflags(*var_t, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe1886);
// compiled member node returning call1887 (depth = 9)
  int op_slot_left_1880 = gc_frame_newslot(call1887);
  params[0] = call1884;
  partcv[0] = 1;
  Object diff1888 = callmethod(call1887, "-(1)", 1, partcv, params);
// compiled op node returning diff1888 (depth = 8)
  partcv[0] = 0;
  Object call1889 = callmethodflags(diff1888, "abs", 1, partcv, params, 0);
  gc_frame_end(callframe1879);
// compiled member node returning call1889 (depth = 7)
  int op_slot_left_1876 = gc_frame_newslot(call1889);
  params[0] = num1877;
  partcv[0] = 1;
  Object opresult1890 = callmethod(call1889, "==(1)", 1, partcv, params);
// compiled op node returning opresult1890 (depth = 6)
  Object if1875 = done;
  if (istrue(opresult1890)) {
// Begin line 1106
  setline(1106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1891 == NULL) {
    strlit1891 = alloc_String("the indentation for this line can't differ ");
    gc_root(strlit1891);
  }
// compiled string node returning strlit1891 (depth = 7)
  *var_m1 = strlit1891;
  if (strlit1891 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1107
  setline(1107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1892 == NULL) {
    strlit1892 = alloc_String("from that of the previous line by 1.""\x0a""  To start a block, or ");
    gc_root(strlit1892);
  }
// compiled string node returning strlit1892 (depth = 7)
  *var_m2 = strlit1892;
  if (strlit1892 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1108
  setline(1108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1893 == NULL) {
    strlit1893 = alloc_String("continue a statement on the next line line, indent by 2 or more. ");
    gc_root(strlit1893);
  }
// compiled string node returning strlit1893 (depth = 7)
  *var_m3 = strlit1893;
  if (strlit1893 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1109
  setline(1109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1894 == NULL) {
    strlit1894 = alloc_String("To end a block, or end the continuation, decrease the indent ");
    gc_root(strlit1894);
  }
// compiled string node returning strlit1894 (depth = 7)
  *var_m4 = strlit1894;
  if (strlit1894 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1110
  setline(1110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1895 == NULL) {
    strlit1895 = alloc_String("to the prior level. ");
    gc_root(strlit1895);
  }
// compiled string node returning strlit1895 (depth = 7)
  *var_m5 = strlit1895;
  if (strlit1895 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1111
  setline(1111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1896 == NULL) {
    strlit1896 = alloc_String("Otherwise, use the same indentation as the previous line.");
    gc_root(strlit1896);
  }
// compiled string node returning strlit1896 (depth = 7)
  *var_m6 = strlit1896;
  if (strlit1896 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1112
  setline(1112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_m6 (depth = 8)
  int op_slot_right_1897 = gc_frame_newslot(*var_m6);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_m5 (depth = 9)
  int op_slot_right_1899 = gc_frame_newslot(*var_m5);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_m4 (depth = 10)
  int op_slot_right_1901 = gc_frame_newslot(*var_m4);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_m3 (depth = 11)
  int op_slot_right_1903 = gc_frame_newslot(*var_m3);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_m2 (depth = 12)
  int op_slot_right_1905 = gc_frame_newslot(*var_m2);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_m1 (depth = 12)
  int op_slot_left_1905 = gc_frame_newslot(*var_m1);
  params[0] = *var_m2;
  partcv[0] = 1;
  Object opresult1907 = callmethod(*var_m1, "++(1)", 1, partcv, params);
// compiled op node returning opresult1907 (depth = 11)
  int op_slot_left_1903 = gc_frame_newslot(opresult1907);
  params[0] = *var_m3;
  partcv[0] = 1;
  Object opresult1908 = callmethod(opresult1907, "++(1)", 1, partcv, params);
// compiled op node returning opresult1908 (depth = 10)
  int op_slot_left_1901 = gc_frame_newslot(opresult1908);
  params[0] = *var_m4;
  partcv[0] = 1;
  Object opresult1909 = callmethod(opresult1908, "++(1)", 1, partcv, params);
// compiled op node returning opresult1909 (depth = 9)
  int op_slot_left_1899 = gc_frame_newslot(opresult1909);
  params[0] = *var_m5;
  partcv[0] = 1;
  Object opresult1910 = callmethod(opresult1909, "++(1)", 1, partcv, params);
// compiled op node returning opresult1910 (depth = 8)
  int op_slot_left_1897 = gc_frame_newslot(opresult1910);
  params[0] = *var_m6;
  partcv[0] = 1;
  Object opresult1911 = callmethod(opresult1910, "++(1)", 1, partcv, params);
// compiled op node returning opresult1911 (depth = 7)
  *var_msg = opresult1911;
  if (opresult1911 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1113
  setline(1113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1912 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_msg (depth = 7)
  gc_frame_newslot(*var_msg);
// starting to compile member node (depth = 7)
  int callframe1913 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  partcv[0] = 0;
  Object call1914 = callmethodflags(*var_t, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1913);
// compiled member node returning call1914 (depth = 7)
  gc_frame_newslot(call1914);
// starting to compile num node (depth = 7)
  Object num1915 = alloc_Float64(1);
// compiled num node returning num1915 (depth = 7)
  gc_frame_newslot(num1915);
// starting to compile member node (depth = 7)
  int callframe1916 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  partcv[0] = 0;
  Object call1917 = callmethodflags(*var_t, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe1916);
// compiled member node returning call1917 (depth = 7)
  gc_frame_newslot(call1917);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = *var_msg;
  params[1] = call1914;
  params[2] = num1915;
  params[3] = call1917;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call1918 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe1912);
// compiled call node returning call1918 (depth = 6)
    gc_frame_newslot(call1918);
    if1875 = call1918;
  } else {
  }
// compiled if node returning if1875 (depth = 5)
// Begin line 1115
  setline(1115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1919 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 4: self request
  params[0] = *var_t;
  partcv[0] = 1;
  Object call1920 = callmethodflags(self, "last:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1919);
// compiled call node returning call1920 (depth = 5)
    gc_frame_newslot(call1920);
    if1856 = call1920;
  }
// compiled if node returning if1856 (depth = 4)
// Begin line 1117
  setline(1117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1921 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1923 = alloc_Float64(1);
// compiled num node returning num1923 (depth = 6)
  int op_slot_right_1922 = gc_frame_newslot(num1923);
// starting to compile member node (depth = 6)
  int callframe1925 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1926 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1925);
// compiled member node returning call1926 (depth = 6)
  int op_slot_left_1922 = gc_frame_newslot(call1926);
  params[0] = num1923;
  partcv[0] = 1;
  Object sum1927 = callmethod(call1926, "+(1)", 1, partcv, params);
// compiled op node returning sum1927 (depth = 5)
  gc_frame_newslot(sum1927);
// call case 4: self request
  params[0] = sum1927;
  partcv[0] = 1;
  Object call1928 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1921);
// compiled call node returning call1928 (depth = 4)
  gc_frame_end(frame);
  return call1928;
}
Object meth_lexer_1929_pop(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pop");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_popped = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "popped");
// definebindings:
// definebindings:
// definebindings:
// Begin line 1121
  setline(1121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1932 = alloc_Boolean(0);
// compiled identifier node returning bool1932 (depth = 6)
  int op_slot_right_1931 = gc_frame_newslot(bool1932);
// starting to compile member node (depth = 6)
  int callframe1934 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1935 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1934);
// compiled member node returning call1935 (depth = 6)
  int op_slot_left_1931 = gc_frame_newslot(call1935);
  params[0] = bool1932;
  partcv[0] = 1;
  Object opresult1936 = callmethod(call1935, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1936 (depth = 5)
  Object if1930 = done;
  if (istrue(opresult1936)) {
// Begin line 1122
  setline(1122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1937 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1938 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1937);
// compiled member node returning call1938 (depth = 6)
  *var_popped = call1938;
  if (call1938 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1123
  setline(1123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1939 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe1940 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1941 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1942 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1941);
// compiled member node returning call1942 (depth = 7)
  partcv[0] = 0;
  Object call1943 = callmethodflags(call1942, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe1940);
// compiled member node returning call1943 (depth = 6)
  gc_frame_newslot(call1943);
// call case 4: self request
  params[0] = call1943;
  partcv[0] = 1;
  Object call1944 = callmethodflags(self, "last:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1939);
// compiled call node returning call1944 (depth = 5)
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool1947 = alloc_Boolean(0);
// compiled identifier node returning bool1947 (depth = 7)
  int op_slot_right_1946 = gc_frame_newslot(bool1947);
// starting to compile member node (depth = 7)
  int callframe1949 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1950 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1949);
// compiled member node returning call1950 (depth = 7)
  int op_slot_left_1946 = gc_frame_newslot(call1950);
  params[0] = bool1947;
  partcv[0] = 1;
  Object opresult1951 = callmethod(call1950, "==(1)", 1, partcv, params);
// compiled op node returning opresult1951 (depth = 6)
  Object if1945 = done;
  if (istrue(opresult1951)) {
// Begin line 1125
  setline(1125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1952 = gc_frame_new();
// starting to compile identifier node (depth = 7)
  Object bool1953 = alloc_Boolean(0);
// compiled identifier node returning bool1953 (depth = 7)
  gc_frame_newslot(bool1953);
// call case 4: self request
  params[0] = bool1953;
  partcv[0] = 1;
  Object call1954 = callmethodflags(self, "first:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1952);
// compiled call node returning call1954 (depth = 6)
    gc_frame_newslot(call1954);
    if1945 = call1954;
  } else {
  }
// compiled if node returning if1945 (depth = 5)
// Begin line 1127
  setline(1127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1955 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1957 = alloc_Float64(1);
// compiled num node returning num1957 (depth = 7)
  int op_slot_right_1956 = gc_frame_newslot(num1957);
// starting to compile member node (depth = 7)
  int callframe1959 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1960 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1959);
// compiled member node returning call1960 (depth = 7)
  int op_slot_left_1956 = gc_frame_newslot(call1960);
  params[0] = num1957;
  partcv[0] = 1;
  Object diff1961 = callmethod(call1960, "-(1)", 1, partcv, params);
// compiled op node returning diff1961 (depth = 6)
  gc_frame_newslot(diff1961);
// call case 4: self request
  params[0] = diff1961;
  partcv[0] = 1;
  Object call1962 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1955);
// compiled call node returning call1962 (depth = 5)
// Begin line 1128
  setline(1128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_popped (depth = 5)
    gc_frame_newslot(*var_popped);
    if1930 = *var_popped;
  } else {
  }
// compiled if node returning if1930 (depth = 4)
  gc_frame_end(frame);
  return if1930;
}
Object meth_lexer_1963_poll(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "poll");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_polled = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "polled");
// definebindings:
// definebindings:
// definebindings:
// Begin line 1133
  setline(1133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1966 = alloc_Boolean(0);
// compiled identifier node returning bool1966 (depth = 6)
  int op_slot_right_1965 = gc_frame_newslot(bool1966);
// starting to compile member node (depth = 6)
  int callframe1968 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1969 = callmethodflags(self, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1968);
// compiled member node returning call1969 (depth = 6)
  int op_slot_left_1965 = gc_frame_newslot(call1969);
  params[0] = bool1966;
  partcv[0] = 1;
  Object opresult1970 = callmethod(call1969, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1970 (depth = 5)
  Object if1964 = done;
  if (istrue(opresult1970)) {
// Begin line 1134
  setline(1134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1971 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1972 = callmethodflags(self, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1971);
// compiled member node returning call1972 (depth = 6)
  *var_polled = call1972;
  if (call1972 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1135
  setline(1135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1973 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe1974 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1975 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1976 = callmethodflags(self, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1975);
// compiled member node returning call1976 (depth = 7)
  partcv[0] = 0;
  Object call1977 = callmethodflags(call1976, "next", 1, partcv, params, 0);
  gc_frame_end(callframe1974);
// compiled member node returning call1977 (depth = 6)
  gc_frame_newslot(call1977);
// call case 4: self request
  params[0] = call1977;
  partcv[0] = 1;
  Object call1978 = callmethodflags(self, "first:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1973);
// compiled call node returning call1978 (depth = 5)
// Begin line 1136
  setline(1136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool1981 = alloc_Boolean(0);
// compiled identifier node returning bool1981 (depth = 7)
  int op_slot_right_1980 = gc_frame_newslot(bool1981);
// starting to compile member node (depth = 7)
  int callframe1983 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1984 = callmethodflags(self, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1983);
// compiled member node returning call1984 (depth = 7)
  int op_slot_left_1980 = gc_frame_newslot(call1984);
  params[0] = bool1981;
  partcv[0] = 1;
  Object opresult1985 = callmethod(call1984, "==(1)", 1, partcv, params);
// compiled op node returning opresult1985 (depth = 6)
  Object if1979 = done;
  if (istrue(opresult1985)) {
// Begin line 1137
  setline(1137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1986 = gc_frame_new();
// starting to compile identifier node (depth = 7)
  Object bool1987 = alloc_Boolean(0);
// compiled identifier node returning bool1987 (depth = 7)
  gc_frame_newslot(bool1987);
// call case 4: self request
  params[0] = bool1987;
  partcv[0] = 1;
  Object call1988 = callmethodflags(self, "last:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1986);
// compiled call node returning call1988 (depth = 6)
    gc_frame_newslot(call1988);
    if1979 = call1988;
  } else {
  }
// compiled if node returning if1979 (depth = 5)
// Begin line 1139
  setline(1139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1989 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1991 = alloc_Float64(1);
// compiled num node returning num1991 (depth = 7)
  int op_slot_right_1990 = gc_frame_newslot(num1991);
// starting to compile member node (depth = 7)
  int callframe1993 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1994 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1993);
// compiled member node returning call1994 (depth = 7)
  int op_slot_left_1990 = gc_frame_newslot(call1994);
  params[0] = num1991;
  partcv[0] = 1;
  Object diff1995 = callmethod(call1994, "-(1)", 1, partcv, params);
// compiled op node returning diff1995 (depth = 6)
  gc_frame_newslot(diff1995);
// call case 4: self request
  params[0] = diff1995;
  partcv[0] = 1;
  Object call1996 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1989);
// compiled call node returning call1996 (depth = 5)
// Begin line 1140
  setline(1140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_polled (depth = 5)
    gc_frame_newslot(*var_polled);
    if1964 = *var_polled;
  } else {
  }
// compiled if node returning if1964 (depth = 4)
  gc_frame_end(frame);
  return if1964;
}
Object meth_lexer_2001_hasNext(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1147
  setline(1147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool2003 = alloc_Boolean(0);
// compiled identifier node returning bool2003 (depth = 5)
  int op_slot_right_2002 = gc_frame_newslot(bool2003);
// starting to compile member node (depth = 5)
  int callframe2005 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2006 = callmethodflags(self, "n", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2005);
// compiled member node returning call2006 (depth = 5)
  int op_slot_left_2002 = gc_frame_newslot(call2006);
  params[0] = bool2003;
  partcv[0] = 1;
  Object opresult2007 = callmethod(call2006, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2007 (depth = 4)
  gc_frame_end(frame);
  return opresult2007;
}
Object meth_lexer_2008_next(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_ret = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "ret");
// Begin line 1150
  setline(1150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2009 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2010 = callmethodflags(self, "n", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2009);
// compiled member node returning call2010 (depth = 5)
  *var_ret = call2010;
  if (call2010 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1151
  setline(1151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2011 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2012 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2013 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2014 = callmethodflags(self, "n", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2013);
// compiled member node returning call2014 (depth = 6)
  partcv[0] = 0;
  Object call2015 = callmethodflags(call2014, "next", 1, partcv, params, 0);
  gc_frame_end(callframe2012);
// compiled member node returning call2015 (depth = 5)
  gc_frame_newslot(call2015);
// call case 4: self request
  params[0] = call2015;
  partcv[0] = 1;
  Object call2016 = callmethodflags(self, "n:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2011);
// compiled call node returning call2016 (depth = 4)
// Begin line 1152
  setline(1152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ret (depth = 4)
  gc_frame_end(frame);
  return *var_ret;
}
Object meth_lexer_1997_iterator(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1998 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1998 = alloc_userobj2(4,4, objclass1998);
  gc_frame_newslot(obj1998);
  if (objclass1998 == NULL) {
    glfree(obj1998->class->name);
    obj1998->class->name = "iterator";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj1998, self, 0);
  addmethodreal(obj1998,"outer", &reader_lexer_outer_1999);
  Object oldself1998 = self;
  struct StackFrameObject *oldstackframe1998 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1998);
  gc_frame_newslot((Object)stackframe);
  self = obj1998;
  Object *oldselfslot1998 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1998 = (*(struct UserObject *)self).data[0], lowerouter1998 = thisouter1998;
  if (inheritingObject1998) {
    struct UserObject *inho1998 = (struct UserObject *)inheritingObject1998;
    while (inho1998->super != GraceDefaultObject) inho1998 = (struct UserObject *)inho1998->super;
    inho1998->super = obj1998;
    self = inheritingObject1998;
    *selfslot = self;
    lowerouter1998 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1998;
  }
  if (objclass1998 == NULL) {
    Method *reader2000 = addmethodrealflags(obj1998, "n", &reader_lexer_n_2000, MFLAG_CONFIDENTIAL);
    Method *writer2000 = addmethodrealflags(obj1998, "n:=(1)", &writer_lexer_n_2000, MFLAG_CONFIDENTIAL);
    reader2000->definitionModule = modulename;
    writer2000->definitionModule = modulename;
    reader2000->definitionLine = 1145;
    writer2000->definitionLine = 1145;
  }
  obj1998->flags |= OFLAG_MUTABLE;
  adddatum2(obj1998, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo2001 = (struct UserObject*)obj1998;
  uo2001->data[2] = emptyclosure;
  Method *meth_meth_lexer_2001_hasNext = addmethod2pos(obj1998, "hasNext", &meth_lexer_2001_hasNext, 2);
  int argcv_meth_lexer_2001_hasNext[] = {0};
  meth_meth_lexer_2001_hasNext->type = alloc_MethodType(1, argcv_meth_lexer_2001_hasNext);
  meth_meth_lexer_2001_hasNext->definitionModule = modulename;
  meth_meth_lexer_2001_hasNext->definitionLine = 1146;
// method "next"
  struct UserObject *uo2008 = (struct UserObject*)obj1998;
  uo2008->data[3] = emptyclosure;
  Method *meth_meth_lexer_2008_next = addmethod2pos(obj1998, "next", &meth_lexer_2008_next, 3);
  int argcv_meth_lexer_2008_next[] = {0};
  meth_meth_lexer_2008_next->type = alloc_MethodType(1, argcv_meth_lexer_2008_next);
  meth_meth_lexer_2008_next->definitionModule = modulename;
  meth_meth_lexer_2008_next->definitionLine = 1149;
  sourceObject = obj1998;
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe2017 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2018 = gc_frame_new();
// call case 3: self.outer request
  Object call2019 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2018);
// compiled member node returning call2019 (depth = 5)
  partcv[0] = 0;
  Object call2020 = callmethodflags(call2019, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2017);
// compiled member node returning call2020 (depth = 4)
  adddatum2(obj1998, call2020, 1);
  sourceObject = obj1998;
  sourceObject = obj1998;
  objclass1998 = obj1998->class;
  objclass1998->definitionModule = modulename;
  objclass1998->definitionLine = 1144;
  (*(struct UserObject *)self).data[0] = lowerouter1998;
  self = oldself1998;
  selfslot = oldselfslot1998;
  stackframe = oldstackframe1998;
  gc_frame_end(frame);
  return obj1998;
}
Object meth_lexer_1997_iterator_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1998 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1998 = alloc_userobj2(4,4, objclass1998);
  gc_frame_newslot(obj1998);
  if (objclass1998 == NULL) {
    glfree(obj1998->class->name);
    obj1998->class->name = "iterator";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj1998, self, 0);
  addmethodreal(obj1998,"outer", &reader_lexer_outer_1999);
  Object oldself1998 = self;
  struct StackFrameObject *oldstackframe1998 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1998);
  gc_frame_newslot((Object)stackframe);
  self = obj1998;
  Object *oldselfslot1998 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1998 = (*(struct UserObject *)self).data[0], lowerouter1998 = thisouter1998;
  if (inheritingObject1998) {
    struct UserObject *inho1998 = (struct UserObject *)inheritingObject1998;
    while (inho1998->super != GraceDefaultObject) inho1998 = (struct UserObject *)inho1998->super;
    inho1998->super = obj1998;
    self = inheritingObject1998;
    *selfslot = self;
    lowerouter1998 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1998;
  }
  if (objclass1998 == NULL) {
    Method *reader2000 = addmethodrealflags(obj1998, "n", &reader_lexer_n_2000, MFLAG_CONFIDENTIAL);
    Method *writer2000 = addmethodrealflags(obj1998, "n:=(1)", &writer_lexer_n_2000, MFLAG_CONFIDENTIAL);
    reader2000->definitionModule = modulename;
    writer2000->definitionModule = modulename;
    reader2000->definitionLine = 1145;
    writer2000->definitionLine = 1145;
  }
  obj1998->flags |= OFLAG_MUTABLE;
  adddatum2(obj1998, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo2001 = (struct UserObject*)obj1998;
  uo2001->data[2] = emptyclosure;
  Method *meth_meth_lexer_2001_hasNext = addmethod2pos(obj1998, "hasNext", &meth_lexer_2001_hasNext, 2);
  int argcv_meth_lexer_2001_hasNext[] = {0};
  meth_meth_lexer_2001_hasNext->type = alloc_MethodType(1, argcv_meth_lexer_2001_hasNext);
  meth_meth_lexer_2001_hasNext->definitionModule = modulename;
  meth_meth_lexer_2001_hasNext->definitionLine = 1146;
// method "next"
  struct UserObject *uo2008 = (struct UserObject*)obj1998;
  uo2008->data[3] = emptyclosure;
  Method *meth_meth_lexer_2008_next = addmethod2pos(obj1998, "next", &meth_lexer_2008_next, 3);
  int argcv_meth_lexer_2008_next[] = {0};
  meth_meth_lexer_2008_next->type = alloc_MethodType(1, argcv_meth_lexer_2008_next);
  meth_meth_lexer_2008_next->definitionModule = modulename;
  meth_meth_lexer_2008_next->definitionLine = 1149;
  sourceObject = obj1998;
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe2017 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2018 = gc_frame_new();
// call case 3: self.outer request
  Object call2019 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2018);
// compiled member node returning call2019 (depth = 5)
  partcv[0] = 0;
  Object call2020 = callmethodflags(call2019, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2017);
// compiled member node returning call2020 (depth = 4)
  adddatum2(obj1998, call2020, 1);
  sourceObject = obj1998;
  sourceObject = obj1998;
  objclass1998 = obj1998->class;
  objclass1998->definitionModule = modulename;
  objclass1998->definitionLine = 1144;
  (*(struct UserObject *)self).data[0] = lowerouter1998;
  self = oldself1998;
  selfslot = oldselfslot1998;
  stackframe = oldstackframe1998;
  gc_frame_end(frame);
  return obj1998;
}
Object meth_lexer_2027__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool2029 = alloc_Boolean(0);
// compiled identifier node returning bool2029 (depth = 7)
  int op_slot_right_2028 = gc_frame_newslot(bool2029);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  int op_slot_left_2028 = gc_frame_newslot(*var_n);
  params[0] = bool2029;
  partcv[0] = 1;
  Object opresult2031 = callmethod(*var_n, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2031 (depth = 6)
  gc_frame_end(frame);
  return opresult2031;
}
Object meth_lexer_2034__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_action = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1159
  setline(1159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2035 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_action (depth = 7)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2036 = callmethodflags(*var_action, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2035);
// compiled call node returning call2036 (depth = 6)
// Begin line 1160
  setline(1160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2037 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call2038 = callmethodflags(*var_n, "next", 1, partcv, params, 0);
  gc_frame_end(callframe2037);
// compiled member node returning call2038 (depth = 7)
  *var_n = call2038;
  if (call2038 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer_2022_do_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "n");
// Begin line 1157
  setline(1157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2023 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2024 = callmethodflags(self, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2023);
// compiled member node returning call2024 (depth = 5)
  *var_n = call2024;
  if (call2024 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1158
  setline(1158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2025 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2026 = alloc_Block(NULL, NULL, "lexer", 1158);
  gc_frame_newslot(block2026);
// method "_apply"
  block_savedest(block2026);
  Object closure2027 = createclosure(2, "_apply");
  setclosureframe(closure2027, stackframe);
  addtoclosure(closure2027, var_n);
  addtoclosure(closure2027, selfslot);
  struct UserObject *uo2027 = (struct UserObject*)block2026;
  uo2027->data[0] = (Object)closure2027;
  Method *meth_meth_lexer_2027__apply = addmethod2pos(block2026, "_apply", &meth_lexer_2027__apply, 0);
  int argcv_meth_lexer_2027__apply[] = {0};
  meth_meth_lexer_2027__apply->type = alloc_MethodType(1, argcv_meth_lexer_2027__apply);
  meth_meth_lexer_2027__apply->definitionModule = modulename;
  meth_meth_lexer_2027__apply->definitionLine = 1145;
// compiled block node returning block2026 (depth = 5)
  gc_frame_newslot(block2026);
// starting to compile block node (depth = 5)
  Object block2033 = alloc_Block(NULL, NULL, "lexer", 1158);
  gc_frame_newslot(block2033);
// method "_apply"
  block_savedest(block2033);
  Object closure2034 = createclosure(3, "_apply");
  setclosureframe(closure2034, stackframe);
  addtoclosure(closure2034, var_n);
  addtoclosure(closure2034, var_action);
  addtoclosure(closure2034, selfslot);
  struct UserObject *uo2034 = (struct UserObject*)block2033;
  uo2034->data[0] = (Object)closure2034;
  Method *meth_meth_lexer_2034__apply = addmethod2pos(block2033, "_apply", &meth_lexer_2034__apply, 0);
  int argcv_meth_lexer_2034__apply[] = {0};
  meth_meth_lexer_2034__apply->type = alloc_MethodType(1, argcv_meth_lexer_2034__apply);
  meth_meth_lexer_2034__apply->definitionModule = modulename;
  meth_meth_lexer_2034__apply->definitionLine = 1145;
// compiled block node returning block2033 (depth = 5)
  gc_frame_newslot(block2033);
// call case 5: prelude request
  params[0] = block2026;
  params[1] = block2033;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2041 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2025);
// compiled call node returning call2041 (depth = 4)
  gc_frame_end(frame);
  return call2041;
}
Object meth_lexer_2063__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_charS = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 6)
  int callframe2064 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_charS (depth = 7)
  partcv[0] = 0;
  Object call2065 = callmethodflags(*var_charS, "hasNext", 1, partcv, params, 0);
  gc_frame_end(callframe2064);
// compiled member node returning call2065 (depth = 6)
  gc_frame_end(frame);
  return call2065;
}
Object meth_lexer_2086__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ch = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 10)
  int callframe2087 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_ch (depth = 11)
  gc_frame_newslot(*var_ch);
// call case 6: other requests
// starting to compile string node (depth = 11)
  if (strlit2088 == NULL) {
    strlit2088 = alloc_String("><![]-");
    gc_root(strlit2088);
  }
// compiled string node returning strlit2088 (depth = 11)
  params[0] = *var_ch;
  partcv[0] = 1;
  Object call2089 = callmethodflags(strlit2088, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2087);
// compiled call node returning call2089 (depth = 10)
  gc_frame_end(frame);
  return call2089;
}
Object meth_lexer_2068__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_charS = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_ch = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "ch");
// definebindings:
  Object *var_nextCh = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextCh");
  Object *var_bigraph = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "bigraph");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1172
  setline(1172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2069 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_charS (depth = 8)
  partcv[0] = 0;
  Object call2070 = callmethodflags(*var_charS, "next", 1, partcv, params, 0);
  gc_frame_end(callframe2069);
// compiled member node returning call2070 (depth = 7)
  *var_ch = call2070;
  if (call2070 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1173
  setline(1173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2071 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2073 = alloc_Float64(1);
// compiled num node returning num2073 (depth = 8)
  int op_slot_right_2072 = gc_frame_newslot(num2073);
// starting to compile member node (depth = 8)
  int callframe2075 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2076 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2075);
// compiled member node returning call2076 (depth = 8)
  int op_slot_left_2072 = gc_frame_newslot(call2076);
  params[0] = num2073;
  partcv[0] = 1;
  Object sum2077 = callmethod(call2076, "+(1)", 1, partcv, params);
// compiled op node returning sum2077 (depth = 7)
  gc_frame_newslot(sum2077);
// call case 4: self request
  params[0] = sum2077;
  partcv[0] = 1;
  Object call2078 = callmethodflags(self, "linePosition:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2071);
// compiled call node returning call2078 (depth = 6)
// Begin line 1174
  setline(1174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2081 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_charS (depth = 9)
  partcv[0] = 0;
  Object call2082 = callmethodflags(*var_charS, "hasNext", 1, partcv, params, 0);
  gc_frame_end(callframe2081);
// compiled member node returning call2082 (depth = 8)
  int op_slot_right_2080 = gc_frame_newslot(call2082);
// starting to compile op node (depth = 8)
// starting to compile block node (depth = 9)
  Object block2085 = alloc_Block(NULL, NULL, "lexer", 1174);
  gc_frame_newslot(block2085);
// method "_apply"
  block_savedest(block2085);
  Object closure2086 = createclosure(2, "_apply");
  setclosureframe(closure2086, stackframe);
  addtoclosure(closure2086, var_ch);
  addtoclosure(closure2086, selfslot);
  struct UserObject *uo2086 = (struct UserObject*)block2085;
  uo2086->data[0] = (Object)closure2086;
  Method *meth_meth_lexer_2086__apply = addmethod2pos(block2085, "_apply", &meth_lexer_2086__apply, 0);
  int argcv_meth_lexer_2086__apply[] = {0};
  meth_meth_lexer_2086__apply->type = alloc_MethodType(1, argcv_meth_lexer_2086__apply);
  meth_meth_lexer_2086__apply->definitionModule = modulename;
  meth_meth_lexer_2086__apply->definitionLine = 1145;
// compiled block node returning block2085 (depth = 9)
  int op_slot_right_2084 = gc_frame_newslot(block2085);
// starting to compile member node (depth = 9)
  int callframe2092 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2093 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2094 = callmethodflags(self, "inStr", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2093);
// compiled member node returning call2094 (depth = 10)
  partcv[0] = 0;
  Object call2095 = callmethodflags(call2094, "not", 1, partcv, params, 0);
  gc_frame_end(callframe2092);
// compiled member node returning call2095 (depth = 9)
  int op_slot_left_2084 = gc_frame_newslot(call2095);
  params[0] = block2085;
  partcv[0] = 1;
  Object opresult2096 = callmethod(call2095, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2096 (depth = 8)
  int op_slot_left_2080 = gc_frame_newslot(opresult2096);
  params[0] = call2082;
  partcv[0] = 1;
  Object opresult2097 = callmethod(opresult2096, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2097 (depth = 7)
  Object if2079 = done;
  if (istrue(opresult2097)) {
// Begin line 1176
  setline(1176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2098 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_charS (depth = 9)
  partcv[0] = 0;
  Object call2099 = callmethodflags(*var_charS, "next", 1, partcv, params, 0);
  gc_frame_end(callframe2098);
// compiled member node returning call2099 (depth = 8)
  *var_nextCh = call2099;
  if (call2099 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1177
  setline(1177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2100 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2102 = alloc_Float64(1);
// compiled num node returning num2102 (depth = 9)
  int op_slot_right_2101 = gc_frame_newslot(num2102);
// starting to compile member node (depth = 9)
  int callframe2104 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2105 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2104);
// compiled member node returning call2105 (depth = 9)
  int op_slot_left_2101 = gc_frame_newslot(call2105);
  params[0] = num2102;
  partcv[0] = 1;
  Object sum2106 = callmethod(call2105, "+(1)", 1, partcv, params);
// compiled op node returning sum2106 (depth = 8)
  gc_frame_newslot(sum2106);
// call case 4: self request
  params[0] = sum2106;
  partcv[0] = 1;
  Object call2107 = callmethodflags(self, "linePosition:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2100);
// compiled call node returning call2107 (depth = 7)
// Begin line 1178
  setline(1178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextCh (depth = 9)
  int op_slot_right_2108 = gc_frame_newslot(*var_nextCh);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ch (depth = 9)
  int op_slot_left_2108 = gc_frame_newslot(*var_ch);
  params[0] = *var_nextCh;
  partcv[0] = 1;
  Object opresult2110 = callmethod(*var_ch, "++(1)", 1, partcv, params);
// compiled op node returning opresult2110 (depth = 8)
  *var_bigraph = opresult2110;
  if (opresult2110 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1179
  setline(1179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2113 == NULL) {
    strlit2113 = alloc_String(">=");
    gc_root(strlit2113);
  }
// compiled string node returning strlit2113 (depth = 9)
  int op_slot_right_2112 = gc_frame_newslot(strlit2113);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_bigraph (depth = 9)
  int op_slot_left_2112 = gc_frame_newslot(*var_bigraph);
  params[0] = strlit2113;
  partcv[0] = 1;
  Object opresult2115 = callmethod(*var_bigraph, "==(1)", 1, partcv, params);
// compiled op node returning opresult2115 (depth = 8)
  Object if2111 = done;
  if (istrue(opresult2115)) {
// starting to compile call node (depth = 8)
  int callframe2116 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2117 == NULL) {
    strlit2117 = alloc_String("""\xe2""""\x89""""\xa5""");
    gc_root(strlit2117);
  }
// compiled string node returning strlit2117 (depth = 9)
  gc_frame_newslot(strlit2117);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2118 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2119 = callmethodflags(self, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2118);
// compiled member node returning call2119 (depth = 9)
  params[0] = strlit2117;
  partcv[0] = 1;
  Object call2120 = callmethodflags(call2119, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2116);
// compiled call node returning call2120 (depth = 8)
    gc_frame_newslot(call2120);
    if2111 = call2120;
  } else {
// Begin line 1181
  setline(1181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2123 == NULL) {
    strlit2123 = alloc_String("<=");
    gc_root(strlit2123);
  }
// compiled string node returning strlit2123 (depth = 10)
  int op_slot_right_2122 = gc_frame_newslot(strlit2123);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_bigraph (depth = 10)
  int op_slot_left_2122 = gc_frame_newslot(*var_bigraph);
  params[0] = strlit2123;
  partcv[0] = 1;
  Object opresult2125 = callmethod(*var_bigraph, "==(1)", 1, partcv, params);
// compiled op node returning opresult2125 (depth = 9)
  Object if2121 = done;
  if (istrue(opresult2125)) {
// starting to compile call node (depth = 9)
  int callframe2126 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2127 == NULL) {
    strlit2127 = alloc_String("""\xe2""""\x89""""\xa4""");
    gc_root(strlit2127);
  }
// compiled string node returning strlit2127 (depth = 10)
  gc_frame_newslot(strlit2127);
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2128 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2129 = callmethodflags(self, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2128);
// compiled member node returning call2129 (depth = 10)
  params[0] = strlit2127;
  partcv[0] = 1;
  Object call2130 = callmethodflags(call2129, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2126);
// compiled call node returning call2130 (depth = 9)
    gc_frame_newslot(call2130);
    if2121 = call2130;
  } else {
// Begin line 1182
  setline(1182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 1181
  setline(1181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2133 == NULL) {
    strlit2133 = alloc_String("!=");
    gc_root(strlit2133);
  }
// compiled string node returning strlit2133 (depth = 11)
  int op_slot_right_2132 = gc_frame_newslot(strlit2133);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_bigraph (depth = 11)
  int op_slot_left_2132 = gc_frame_newslot(*var_bigraph);
  params[0] = strlit2133;
  partcv[0] = 1;
  Object opresult2135 = callmethod(*var_bigraph, "==(1)", 1, partcv, params);
// compiled op node returning opresult2135 (depth = 10)
  Object if2131 = done;
  if (istrue(opresult2135)) {
// starting to compile call node (depth = 10)
  int callframe2136 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2137 == NULL) {
    strlit2137 = alloc_String("""\xe2""""\x89""""\xa0""");
    gc_root(strlit2137);
  }
// compiled string node returning strlit2137 (depth = 11)
  gc_frame_newslot(strlit2137);
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe2138 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2139 = callmethodflags(self, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2138);
// compiled member node returning call2139 (depth = 11)
  params[0] = strlit2137;
  partcv[0] = 1;
  Object call2140 = callmethodflags(call2139, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2136);
// compiled call node returning call2140 (depth = 10)
    gc_frame_newslot(call2140);
    if2131 = call2140;
  } else {
// Begin line 1183
  setline(1183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 1182
  setline(1182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2143 == NULL) {
    strlit2143 = alloc_String("[[");
    gc_root(strlit2143);
  }
// compiled string node returning strlit2143 (depth = 12)
  int op_slot_right_2142 = gc_frame_newslot(strlit2143);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_bigraph (depth = 12)
  int op_slot_left_2142 = gc_frame_newslot(*var_bigraph);
  params[0] = strlit2143;
  partcv[0] = 1;
  Object opresult2145 = callmethod(*var_bigraph, "==(1)", 1, partcv, params);
// compiled op node returning opresult2145 (depth = 11)
  Object if2141 = done;
  if (istrue(opresult2145)) {
// starting to compile call node (depth = 11)
  int callframe2146 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2147 == NULL) {
    strlit2147 = alloc_String("""\xe2""""\x9f""""\xa6""");
    gc_root(strlit2147);
  }
// compiled string node returning strlit2147 (depth = 12)
  gc_frame_newslot(strlit2147);
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe2148 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2149 = callmethodflags(self, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2148);
// compiled member node returning call2149 (depth = 12)
  params[0] = strlit2147;
  partcv[0] = 1;
  Object call2150 = callmethodflags(call2149, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2146);
// compiled call node returning call2150 (depth = 11)
    gc_frame_newslot(call2150);
    if2141 = call2150;
  } else {
// Begin line 1184
  setline(1184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 1183
  setline(1183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit2153 == NULL) {
    strlit2153 = alloc_String("]]");
    gc_root(strlit2153);
  }
// compiled string node returning strlit2153 (depth = 13)
  int op_slot_right_2152 = gc_frame_newslot(strlit2153);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_bigraph (depth = 13)
  int op_slot_left_2152 = gc_frame_newslot(*var_bigraph);
  params[0] = strlit2153;
  partcv[0] = 1;
  Object opresult2155 = callmethod(*var_bigraph, "==(1)", 1, partcv, params);
// compiled op node returning opresult2155 (depth = 12)
  Object if2151 = done;
  if (istrue(opresult2155)) {
// starting to compile call node (depth = 12)
  int callframe2156 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit2157 == NULL) {
    strlit2157 = alloc_String("""\xe2""""\x9f""""\xa7""");
    gc_root(strlit2157);
  }
// compiled string node returning strlit2157 (depth = 13)
  gc_frame_newslot(strlit2157);
// call case 6: other requests
// starting to compile member node (depth = 13)
  int callframe2158 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2159 = callmethodflags(self, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2158);
// compiled member node returning call2159 (depth = 13)
  params[0] = strlit2157;
  partcv[0] = 1;
  Object call2160 = callmethodflags(call2159, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2156);
// compiled call node returning call2160 (depth = 12)
    gc_frame_newslot(call2160);
    if2151 = call2160;
  } else {
// Begin line 1185
  setline(1185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 1184
  setline(1184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit2163 == NULL) {
    strlit2163 = alloc_String("->");
    gc_root(strlit2163);
  }
// compiled string node returning strlit2163 (depth = 14)
  int op_slot_right_2162 = gc_frame_newslot(strlit2163);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_bigraph (depth = 14)
  int op_slot_left_2162 = gc_frame_newslot(*var_bigraph);
  params[0] = strlit2163;
  partcv[0] = 1;
  Object opresult2165 = callmethod(*var_bigraph, "==(1)", 1, partcv, params);
// compiled op node returning opresult2165 (depth = 13)
  Object if2161 = done;
  if (istrue(opresult2165)) {
// starting to compile call node (depth = 13)
  int callframe2166 = gc_frame_new();
// starting to compile string node (depth = 14)
  if (strlit2167 == NULL) {
    strlit2167 = alloc_String("""\xe2""""\x86""""\x92""");
    gc_root(strlit2167);
  }
// compiled string node returning strlit2167 (depth = 14)
  gc_frame_newslot(strlit2167);
// call case 6: other requests
// starting to compile member node (depth = 14)
  int callframe2168 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2169 = callmethodflags(self, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2168);
// compiled member node returning call2169 (depth = 14)
  params[0] = strlit2167;
  partcv[0] = 1;
  Object call2170 = callmethodflags(call2169, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2166);
// compiled call node returning call2170 (depth = 13)
    gc_frame_newslot(call2170);
    if2161 = call2170;
  } else {
// Begin line 1186
  setline(1186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe2171 = gc_frame_new();
// starting to compile op node (depth = 14)
// starting to compile num node (depth = 15)
  Object num2173 = alloc_Float64(1);
// compiled num node returning num2173 (depth = 15)
  int op_slot_right_2172 = gc_frame_newslot(num2173);
// starting to compile member node (depth = 15)
  int callframe2175 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2176 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2175);
// compiled member node returning call2176 (depth = 15)
  int op_slot_left_2172 = gc_frame_newslot(call2176);
  params[0] = num2173;
  partcv[0] = 1;
  Object diff2177 = callmethod(call2176, "-(1)", 1, partcv, params);
// compiled op node returning diff2177 (depth = 14)
  gc_frame_newslot(diff2177);
// call case 4: self request
  params[0] = diff2177;
  partcv[0] = 1;
  Object call2178 = callmethodflags(self, "linePosition:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2171);
// compiled call node returning call2178 (depth = 13)
// Begin line 1187
  setline(1187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe2179 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_ch (depth = 14)
  gc_frame_newslot(*var_ch);
// call case 6: other requests
// starting to compile member node (depth = 14)
  int callframe2180 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2181 = callmethodflags(self, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2180);
// compiled member node returning call2181 (depth = 14)
  params[0] = *var_ch;
  partcv[0] = 1;
  Object call2182 = callmethodflags(call2181, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2179);
// compiled call node returning call2182 (depth = 13)
// Begin line 1188
  setline(1188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe2183 = gc_frame_new();
// starting to compile op node (depth = 14)
// starting to compile num node (depth = 15)
  Object num2185 = alloc_Float64(1);
// compiled num node returning num2185 (depth = 15)
  int op_slot_right_2184 = gc_frame_newslot(num2185);
// starting to compile member node (depth = 15)
  int callframe2187 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2188 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2187);
// compiled member node returning call2188 (depth = 15)
  int op_slot_left_2184 = gc_frame_newslot(call2188);
  params[0] = num2185;
  partcv[0] = 1;
  Object sum2189 = callmethod(call2188, "+(1)", 1, partcv, params);
// compiled op node returning sum2189 (depth = 14)
  gc_frame_newslot(sum2189);
// call case 4: self request
  params[0] = sum2189;
  partcv[0] = 1;
  Object call2190 = callmethodflags(self, "linePosition:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2183);
// compiled call node returning call2190 (depth = 13)
// Begin line 1189
  setline(1189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe2191 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_nextCh (depth = 14)
  gc_frame_newslot(*var_nextCh);
// call case 6: other requests
// starting to compile member node (depth = 14)
  int callframe2192 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2193 = callmethodflags(self, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2192);
// compiled member node returning call2193 (depth = 14)
  params[0] = *var_nextCh;
  partcv[0] = 1;
  Object call2194 = callmethodflags(call2193, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2191);
// compiled call node returning call2194 (depth = 13)
    gc_frame_newslot(call2194);
    if2161 = call2194;
  }
// compiled if node returning if2161 (depth = 12)
    gc_frame_newslot(if2161);
    if2151 = if2161;
  }
// compiled if node returning if2151 (depth = 11)
    gc_frame_newslot(if2151);
    if2141 = if2151;
  }
// compiled if node returning if2141 (depth = 10)
    gc_frame_newslot(if2141);
    if2131 = if2141;
  }
// compiled if node returning if2131 (depth = 9)
    gc_frame_newslot(if2131);
    if2121 = if2131;
  }
// compiled if node returning if2121 (depth = 8)
    gc_frame_newslot(if2121);
    if2111 = if2121;
  }
// compiled if node returning if2111 (depth = 7)
    gc_frame_newslot(if2111);
    if2079 = if2111;
  } else {
// Begin line 1192
  setline(1192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2195 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ch (depth = 8)
  gc_frame_newslot(*var_ch);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe2196 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2197 = callmethodflags(self, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2196);
// compiled member node returning call2197 (depth = 8)
  params[0] = *var_ch;
  partcv[0] = 1;
  Object call2198 = callmethodflags(call2197, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2195);
// compiled call node returning call2198 (depth = 7)
    gc_frame_newslot(call2198);
    if2079 = call2198;
  }
// compiled if node returning if2079 (depth = 6)
  gc_frame_end(frame);
  return if2079;
}
Object meth_lexer_2058__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_eachLine = &(stackframe->slots[0]);
  *var_eachLine = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_charS = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "charS");
// Begin line 1170
  setline(1170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2059 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_eachLine (depth = 6)
  partcv[0] = 0;
  Object call2060 = callmethodflags(*var_eachLine, "iterator", 1, partcv, params, 0);
  gc_frame_end(callframe2059);
// compiled member node returning call2060 (depth = 5)
  *var_charS = call2060;
  if (call2060 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1171
  setline(1171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2061 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2062 = alloc_Block(NULL, NULL, "lexer", 1171);
  gc_frame_newslot(block2062);
// method "_apply"
  block_savedest(block2062);
  Object closure2063 = createclosure(2, "_apply");
  setclosureframe(closure2063, stackframe);
  addtoclosure(closure2063, var_charS);
  addtoclosure(closure2063, selfslot);
  struct UserObject *uo2063 = (struct UserObject*)block2062;
  uo2063->data[0] = (Object)closure2063;
  Method *meth_meth_lexer_2063__apply = addmethod2pos(block2062, "_apply", &meth_lexer_2063__apply, 0);
  int argcv_meth_lexer_2063__apply[] = {0};
  meth_meth_lexer_2063__apply->type = alloc_MethodType(1, argcv_meth_lexer_2063__apply);
  meth_meth_lexer_2063__apply->definitionModule = modulename;
  meth_meth_lexer_2063__apply->definitionLine = 1145;
// compiled block node returning block2062 (depth = 5)
  gc_frame_newslot(block2062);
// starting to compile block node (depth = 5)
  Object block2067 = alloc_Block(NULL, NULL, "lexer", 1171);
  gc_frame_newslot(block2067);
// method "_apply"
  block_savedest(block2067);
  Object closure2068 = createclosure(2, "_apply");
  setclosureframe(closure2068, stackframe);
  addtoclosure(closure2068, var_charS);
  addtoclosure(closure2068, selfslot);
  struct UserObject *uo2068 = (struct UserObject*)block2067;
  uo2068->data[0] = (Object)closure2068;
  Method *meth_meth_lexer_2068__apply = addmethod2pos(block2067, "_apply", &meth_lexer_2068__apply, 0);
  int argcv_meth_lexer_2068__apply[] = {0};
  meth_meth_lexer_2068__apply->type = alloc_MethodType(1, argcv_meth_lexer_2068__apply);
  meth_meth_lexer_2068__apply->definitionModule = modulename;
  meth_meth_lexer_2068__apply->definitionLine = 1145;
// compiled block node returning block2067 (depth = 5)
  gc_frame_newslot(block2067);
// call case 5: prelude request
  params[0] = block2062;
  params[1] = block2067;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2200 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2061);
// compiled call node returning call2200 (depth = 4)
// Begin line 1195
  setline(1195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2201 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit2202 == NULL) {
    strlit2202 = alloc_String("""\x0a""");
    gc_root(strlit2202);
  }
// compiled string node returning strlit2202 (depth = 5)
  gc_frame_newslot(strlit2202);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2203 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2204 = callmethodflags(self, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2203);
// compiled member node returning call2204 (depth = 5)
  params[0] = strlit2202;
  partcv[0] = 1;
  Object call2205 = callmethodflags(call2204, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2201);
// compiled call node returning call2205 (depth = 4)
// Begin line 1196
  setline(1196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2206 = gc_frame_new();
// starting to compile num node (depth = 5)
  Object num2207 = alloc_Float64(0);
// compiled num node returning num2207 (depth = 5)
  gc_frame_newslot(num2207);
// call case 4: self request
  params[0] = num2207;
  partcv[0] = 1;
  Object call2208 = callmethodflags(self, "linePosition:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2206);
// compiled call node returning call2208 (depth = 4)
// Begin line 1197
  setline(1197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2209 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2211 = alloc_Float64(1);
// compiled num node returning num2211 (depth = 6)
  int op_slot_right_2210 = gc_frame_newslot(num2211);
// starting to compile member node (depth = 6)
  int callframe2213 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2214 = callmethodflags(self, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2213);
// compiled member node returning call2214 (depth = 6)
  int op_slot_left_2210 = gc_frame_newslot(call2214);
  params[0] = num2211;
  partcv[0] = 1;
  Object sum2215 = callmethod(call2214, "+(1)", 1, partcv, params);
// compiled op node returning sum2215 (depth = 5)
  gc_frame_newslot(sum2215);
// call case 4: self request
  params[0] = sum2215;
  partcv[0] = 1;
  Object call2216 = callmethodflags(self, "lineNumber:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2209);
// compiled call node returning call2216 (depth = 4)
  gc_frame_end(frame);
  return call2216;
}
Object meth_lexer_1827_lexinput_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 74, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lexinput(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lexinput(_)");
  Object params[4];
  int partcv[2];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lexinput(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_inputLines = &(stackframe->slots[0]);
  *var_inputLines = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part lexinput(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1083
  setline(1083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1828 = gc_frame_new();
// starting to compile object node (depth = 3)
  Object inheritingObject1829 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1829 = alloc_userobj2(14,12, objclass1829);
  gc_frame_newslot(obj1829);
// OBJECT OUTER DEC outer
  adddatum2(obj1829, self, 0);
  addmethodreal(obj1829,"outer", &reader_lexer_outer_1830);
  Object oldself1829 = self;
  struct StackFrameObject *oldstackframe1829 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1829);
  gc_frame_newslot((Object)stackframe);
  self = obj1829;
  Object *oldselfslot1829 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1829 = (*(struct UserObject *)self).data[0], lowerouter1829 = thisouter1829;
  if (inheritingObject1829) {
    struct UserObject *inho1829 = (struct UserObject *)inheritingObject1829;
    while (inho1829->super != GraceDefaultObject) inho1829 = (struct UserObject *)inho1829->super;
    inho1829->super = obj1829;
    self = inheritingObject1829;
    *selfslot = self;
    lowerouter1829 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1829;
  }
  if (objclass1829 == NULL) {
    Method *reader1831 = addmethodrealflags(obj1829, "first", &reader_lexer_first_1831, 0);
    Method *writer1831 = addmethodrealflags(obj1829, "first:=(1)", &writer_lexer_first_1831, MFLAG_CONFIDENTIAL);
    reader1831->definitionModule = modulename;
    writer1831->definitionModule = modulename;
    reader1831->definitionLine = 1084;
    writer1831->definitionLine = 1084;
  }
  obj1829->flags |= OFLAG_MUTABLE;
  adddatum2(obj1829, alloc_Undefined(), 1);
  if (objclass1829 == NULL) {
    Method *reader1832 = addmethodrealflags(obj1829, "last", &reader_lexer_last_1832, 0);
    Method *writer1832 = addmethodrealflags(obj1829, "last:=(1)", &writer_lexer_last_1832, MFLAG_CONFIDENTIAL);
    reader1832->definitionModule = modulename;
    writer1832->definitionModule = modulename;
    reader1832->definitionLine = 1085;
    writer1832->definitionLine = 1085;
  }
  obj1829->flags |= OFLAG_MUTABLE;
  adddatum2(obj1829, alloc_Undefined(), 2);
  if (objclass1829 == NULL) {
    Method *reader1833 = addmethodrealflags(obj1829, "size", &reader_lexer_size_1833, 0);
    Method *writer1833 = addmethodrealflags(obj1829, "size:=(1)", &writer_lexer_size_1833, MFLAG_CONFIDENTIAL);
    reader1833->definitionModule = modulename;
    writer1833->definitionModule = modulename;
    reader1833->definitionLine = 1086;
    writer1833->definitionLine = 1086;
  }
  obj1829->flags |= OFLAG_MUTABLE;
  adddatum2(obj1829, alloc_Undefined(), 3);
// method "savePosition"
  struct UserObject *uo1834 = (struct UserObject*)obj1829;
  uo1834->data[4] = emptyclosure;
  Method *meth_meth_lexer_1834_savePosition = addmethod2pos(obj1829, "savePosition", &meth_lexer_1834_savePosition, 4);
  int argcv_meth_lexer_1834_savePosition[] = {0};
  meth_meth_lexer_1834_savePosition->type = alloc_MethodType(1, argcv_meth_lexer_1834_savePosition);
  meth_meth_lexer_1834_savePosition->definitionModule = modulename;
  meth_meth_lexer_1834_savePosition->definitionLine = 1088;
// method "restorePosition(_)"
  struct UserObject *uo1842 = (struct UserObject*)obj1829;
  uo1842->data[5] = emptyclosure;
  Method *meth_meth_lexer_1842_restorePosition_40_1_41_ = addmethod2pos(obj1829, "restorePosition(1)", &meth_lexer_1842_restorePosition_40_1_41_, 5);
  int argcv_meth_lexer_1842_restorePosition_40_1_41_[] = {1};
  meth_meth_lexer_1842_restorePosition_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_1842_restorePosition_40_1_41_);
  meth_meth_lexer_1842_restorePosition_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_1842_restorePosition_40_1_41_->definitionLine = 1092;
// method "push(_)"
  block_savedest(obj1829);
  Object closure1855 = createclosure(1, "push(1)");
  setclosureframe(closure1855, stackframe);
  addtoclosure(closure1855, var_errormessages);
  struct UserObject *uo1855 = (struct UserObject*)obj1829;
  uo1855->data[6] = (Object)closure1855;
  Method *meth_meth_lexer_1855_push_40_1_41_ = addmethod2pos(obj1829, "push(1)", &meth_lexer_1855_push_40_1_41_, 6);
  int argcv_meth_lexer_1855_push_40_1_41_[] = {1};
  meth_meth_lexer_1855_push_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_1855_push_40_1_41_);
  meth_meth_lexer_1855_push_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_1855_push_40_1_41_->definitionLine = 1098;
// method "pop"
  struct UserObject *uo1929 = (struct UserObject*)obj1829;
  uo1929->data[7] = emptyclosure;
  Method *meth_meth_lexer_1929_pop = addmethod2pos(obj1829, "pop", &meth_lexer_1929_pop, 7);
  int argcv_meth_lexer_1929_pop[] = {0};
  meth_meth_lexer_1929_pop->type = alloc_MethodType(1, argcv_meth_lexer_1929_pop);
  meth_meth_lexer_1929_pop->definitionModule = modulename;
  meth_meth_lexer_1929_pop->definitionLine = 1120;
// method "poll"
  struct UserObject *uo1963 = (struct UserObject*)obj1829;
  uo1963->data[8] = emptyclosure;
  Method *meth_meth_lexer_1963_poll = addmethod2pos(obj1829, "poll", &meth_lexer_1963_poll, 8);
  int argcv_meth_lexer_1963_poll[] = {0};
  meth_meth_lexer_1963_poll->type = alloc_MethodType(1, argcv_meth_lexer_1963_poll);
  meth_meth_lexer_1963_poll->definitionModule = modulename;
  meth_meth_lexer_1963_poll->definitionLine = 1132;
// method "iterator"
  struct UserObject *uo1997 = (struct UserObject*)obj1829;
  uo1997->data[9] = emptyclosure;
  Method *meth_meth_lexer_1997_iterator = addmethod2pos(obj1829, "iterator", &meth_lexer_1997_iterator, 9);
  int argcv_meth_lexer_1997_iterator[] = {0};
  meth_meth_lexer_1997_iterator->type = alloc_MethodType(1, argcv_meth_lexer_1997_iterator);
  meth_meth_lexer_1997_iterator->definitionModule = modulename;
  meth_meth_lexer_1997_iterator->definitionLine = 1144;
  Method *meth_meth_lexer_1997_iterator_object = addmethod2pos(obj1829, "iterator$object(1)", &meth_lexer_1997_iterator_object, 9);
  int argcv_meth_lexer_1997_iterator_object[] = {0};
  meth_meth_lexer_1997_iterator_object->type = alloc_MethodType(1, argcv_meth_lexer_1997_iterator_object);
  meth_meth_lexer_1997_iterator_object->definitionModule = modulename;
  meth_meth_lexer_1997_iterator_object->definitionLine = 1144;
// method "do(_)"
  struct UserObject *uo2022 = (struct UserObject*)obj1829;
  uo2022->data[10] = emptyclosure;
  Method *meth_meth_lexer_2022_do_40_1_41_ = addmethod2pos(obj1829, "do(1)", &meth_lexer_2022_do_40_1_41_, 10);
  int argcv_meth_lexer_2022_do_40_1_41_[] = {1};
  meth_meth_lexer_2022_do_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_2022_do_40_1_41_);
  meth_meth_lexer_2022_do_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_2022_do_40_1_41_->definitionLine = 1156;
  sourceObject = obj1829;
// Begin line 1084
  setline(1084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool2042 = alloc_Boolean(0);
// compiled identifier node returning bool2042 (depth = 4)
  adddatum2(obj1829, bool2042, 1);
  sourceObject = obj1829;
// Begin line 1085
  setline(1085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool2043 = alloc_Boolean(0);
// compiled identifier node returning bool2043 (depth = 4)
  adddatum2(obj1829, bool2043, 2);
  sourceObject = obj1829;
// Begin line 1086
  setline(1086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num2044 = alloc_Float64(0);
// compiled num node returning num2044 (depth = 4)
  adddatum2(obj1829, num2044, 3);
  sourceObject = obj1829;
  sourceObject = obj1829;
  sourceObject = obj1829;
  sourceObject = obj1829;
  sourceObject = obj1829;
  sourceObject = obj1829;
  sourceObject = obj1829;
  objclass1829 = obj1829->class;
  objclass1829->definitionModule = modulename;
  objclass1829->definitionLine = 1083;
  (*(struct UserObject *)self).data[0] = lowerouter1829;
  self = oldself1829;
  selfslot = oldselfslot1829;
  stackframe = oldstackframe1829;
// compiled object node returning obj1829 (depth = 3)
  gc_frame_newslot(obj1829);
// call case 4: self request
  params[0] = obj1829;
  partcv[0] = 1;
  Object call2045 = callmethodflags(self, "tokens:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1828);
// compiled call node returning call2045 (depth = 2)
// Begin line 1166
  setline(1166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2046 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num2047 = alloc_Float64(0);
// compiled num node returning num2047 (depth = 3)
  gc_frame_newslot(num2047);
// call case 4: self request
  params[0] = num2047;
  partcv[0] = 1;
  Object call2048 = callmethodflags(self, "linePosition:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2046);
// compiled call node returning call2048 (depth = 2)
// Begin line 1167
  setline(1167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2049 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit2050 == NULL) {
    strlit2050 = alloc_String("lexing.");
    gc_root(strlit2050);
  }
// compiled string node returning strlit2050 (depth = 3)
  gc_frame_newslot(strlit2050);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = strlit2050;
  partcv[0] = 1;
  Object call2051 = callmethodflags(*var_util, "log_verbose(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2049);
// compiled call node returning call2051 (depth = 2)
// Begin line 1168
  setline(1168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2052 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe2053 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2054 = callmethodflags(self, "startState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2053);
// compiled member node returning call2054 (depth = 3)
  gc_frame_newslot(call2054);
// call case 4: self request
  params[0] = call2054;
  partcv[0] = 1;
  Object call2055 = callmethodflags(self, "state:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2052);
// compiled call node returning call2055 (depth = 2)
// Begin line 1169
  setline(1169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2056 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_inputLines (depth = 3)
  gc_frame_newslot(*var_inputLines);
// starting to compile block node (depth = 3)
  Object block2057 = alloc_Block(NULL, NULL, "lexer", 1169);
  gc_frame_newslot(block2057);
// method "_apply(_)"
  block_savedest(block2057);
  Object closure2058 = createclosure(1, "_apply(1)");
  setclosureframe(closure2058, stackframe);
  addtoclosure(closure2058, selfslot);
  struct UserObject *uo2058 = (struct UserObject*)block2057;
  uo2058->data[0] = (Object)closure2058;
  Method *meth_meth_lexer_2058__apply_40_1_41_ = addmethod2pos(block2057, "_apply(1)", &meth_lexer_2058__apply_40_1_41_, 0);
  int argcv_meth_lexer_2058__apply_40_1_41_[] = {1};
  meth_meth_lexer_2058__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_2058__apply_40_1_41_);
  meth_meth_lexer_2058__apply_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_2058__apply_40_1_41_->definitionLine = 1145;
// compiled block node returning block2057 (depth = 3)
  gc_frame_newslot(block2057);
// call case 5: prelude request
  params[0] = *var_inputLines;
  params[1] = block2057;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2218 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2056);
// compiled call node returning call2218 (depth = 2)
// Begin line 1199
  setline(1199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2219 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2221 = alloc_Float64(1);
// compiled num node returning num2221 (depth = 4)
  int op_slot_right_2220 = gc_frame_newslot(num2221);
// starting to compile member node (depth = 4)
  int callframe2223 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2224 = callmethodflags(self, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2223);
// compiled member node returning call2224 (depth = 4)
  int op_slot_left_2220 = gc_frame_newslot(call2224);
  params[0] = num2221;
  partcv[0] = 1;
  Object sum2225 = callmethod(call2224, "+(1)", 1, partcv, params);
// compiled op node returning sum2225 (depth = 3)
  gc_frame_newslot(sum2225);
// call case 4: self request
  params[0] = sum2225;
  partcv[0] = 1;
  Object call2226 = callmethodflags(self, "linePosition:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2219);
// compiled call node returning call2226 (depth = 2)
// Begin line 1200
  setline(1200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2228 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2229 = callmethodflags(self, "inStr", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2228);
// compiled member node returning call2229 (depth = 3)
  Object if2227 = done;
  if (istrue(call2229)) {
// Begin line 1201
  setline(1201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2230 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1202
  setline(1202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2233 == NULL) {
    strlit2233 = alloc_String(" and unclosed at end of input.");
    gc_root(strlit2233);
  }
// compiled string node returning strlit2233 (depth = 6)
  int op_slot_right_2232 = gc_frame_newslot(strlit2233);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2236 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2237 = callmethodflags(self, "startLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2236);
// compiled member node returning call2237 (depth = 7)
  int op_slot_right_2235 = gc_frame_newslot(call2237);
// starting to compile string node (depth = 7)
  if (strlit2239 == NULL) {
    strlit2239 = alloc_String("String opened on line ");
    gc_root(strlit2239);
  }
// compiled string node returning strlit2239 (depth = 7)
  int op_slot_left_2235 = gc_frame_newslot(strlit2239);
  params[0] = call2237;
  partcv[0] = 1;
  Object opresult2240 = callmethod(strlit2239, "++(1)", 1, partcv, params);
// compiled op node returning opresult2240 (depth = 6)
  int op_slot_left_2232 = gc_frame_newslot(opresult2240);
  params[0] = strlit2233;
  partcv[0] = 1;
  Object opresult2241 = callmethod(opresult2240, "++(1)", 1, partcv, params);
// compiled op node returning opresult2241 (depth = 5)
  int op_slot_right_2231 = gc_frame_newslot(opresult2241);
// Begin line 1201
  setline(1201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit2243 == NULL) {
    strlit2243 = alloc_String("a multi-line string must end with a '""\xe2""""\x80""""\xba""'.""\x0a""");
    gc_root(strlit2243);
  }
// compiled string node returning strlit2243 (depth = 5)
  int op_slot_left_2231 = gc_frame_newslot(strlit2243);
  params[0] = opresult2241;
  partcv[0] = 1;
  Object opresult2244 = callmethod(strlit2243, "++(1)", 1, partcv, params);
// compiled op node returning opresult2244 (depth = 4)
  gc_frame_newslot(opresult2244);
// Begin line 1203
  setline(1203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe2245 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2246 = callmethodflags(self, "startLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2245);
// compiled member node returning call2246 (depth = 4)
  gc_frame_newslot(call2246);
// starting to compile member node (depth = 4)
  int callframe2247 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2248 = callmethodflags(self, "stringStart", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2247);
// compiled member node returning call2248 (depth = 4)
  gc_frame_newslot(call2248);
// starting to compile member node (depth = 4)
  int callframe2249 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe2250 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe2251 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2252 = callmethodflags(self, "startLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2251);
// compiled member node returning call2252 (depth = 6)
  gc_frame_newslot(call2252);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2253 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call2254 = callmethodflags(*var_util, "lines", 1, partcv, params, 0);
  gc_frame_end(callframe2253);
// compiled member node returning call2254 (depth = 6)
  params[0] = call2252;
  partcv[0] = 1;
  Object call2255 = callmethodflags(call2254, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2250);
// compiled call node returning call2255 (depth = 5)
  partcv[0] = 0;
  Object call2256 = callmethodflags(call2255, "size", 1, partcv, params, 0);
  gc_frame_end(callframe2249);
// compiled member node returning call2256 (depth = 4)
  gc_frame_newslot(call2256);
// call case 6: other requests
// Begin line 1201
  setline(1201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult2244;
  params[1] = call2246;
  params[2] = call2248;
  params[3] = call2256;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call2257 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe2230);
// compiled call node returning call2257 (depth = 3)
    gc_frame_newslot(call2257);
    if2227 = call2257;
  } else {
  }
// compiled if node returning if2227 (depth = 2)
// Begin line 1205
  setline(1205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2258 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe2259 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2260 = callmethodflags(self, "eofToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2259);
// compiled member node returning call2260 (depth = 3)
  gc_frame_newslot(call2260);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2261 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2262 = callmethodflags(self, "tokens", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2261);
// compiled member node returning call2262 (depth = 3)
  params[0] = call2260;
  partcv[0] = 1;
  Object call2263 = callmethodflags(call2262, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2258);
// compiled call node returning call2263 (depth = 2)
// Begin line 1206
  setline(1206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe2264 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2265 = callmethodflags(self, "tokens", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2264);
// compiled member node returning call2265 (depth = 2)
  gc_frame_end(frame);
  return call2265;
}
Object meth_lexer_2280_consume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "consume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method consume(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for consume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part consume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 273
  setline(273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2283 == NULL) {
    strlit2283 = alloc_String("#");
    gc_root(strlit2283);
  }
// compiled string node returning strlit2283 (depth = 4)
  int op_slot_right_2282 = gc_frame_newslot(strlit2283);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_left_2282 = gc_frame_newslot(*var_c);
  params[0] = strlit2283;
  partcv[0] = 1;
  Object opresult2285 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult2285 (depth = 3)
  Object if2281 = done;
  if (istrue(opresult2285)) {
// Begin line 274
  setline(274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2286 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2287 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2288 = gc_frame_new();
// call case 3: self.outer request
  Object call2289 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2288);
// compiled member node returning call2289 (depth = 5)
  partcv[0] = 0;
  Object call2290 = callmethodflags(call2289, "pragmaPrefixState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2287);
// compiled member node returning call2290 (depth = 4)
  gc_frame_newslot(call2290);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2291 = gc_frame_new();
// call case 3: self.outer request
  Object call2292 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2291);
// compiled member node returning call2292 (depth = 4)
  params[0] = call2290;
  partcv[0] = 1;
  Object call2293 = callmethodflags(call2292, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2286);
// compiled call node returning call2293 (depth = 3)
    gc_frame_newslot(call2293);
    if2281 = call2293;
  } else {
// Begin line 276
  setline(276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2294 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2295 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2296 = gc_frame_new();
// call case 3: self.outer request
  Object call2297 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2296);
// compiled member node returning call2297 (depth = 5)
  partcv[0] = 0;
  Object call2298 = callmethodflags(call2297, "defaultState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2295);
// compiled member node returning call2298 (depth = 4)
  gc_frame_newslot(call2298);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2299 = gc_frame_new();
// call case 3: self.outer request
  Object call2300 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2299);
// compiled member node returning call2300 (depth = 4)
  params[0] = call2298;
  partcv[0] = 1;
  Object call2301 = callmethodflags(call2300, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2294);
// compiled call node returning call2301 (depth = 3)
// Begin line 277
  setline(277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2302 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2303 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2304 = gc_frame_new();
// call case 3: self.outer request
  Object call2305 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2304);
// compiled member node returning call2305 (depth = 5)
  partcv[0] = 0;
  Object call2306 = callmethodflags(call2305, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2303);
// compiled member node returning call2306 (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2307 = callmethodflags(call2306, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2302);
// compiled call node returning call2307 (depth = 3)
    gc_frame_newslot(call2307);
    if2281 = call2307;
  }
// compiled if node returning if2281 (depth = 2)
  gc_frame_end(frame);
  return if2281;
}
Object meth_lexer_2314_consume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "consume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method consume(_)");
  Object params[4];
  int partcv[2];
  Object *var_errormessages = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for consume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part consume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2315 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2316 = gc_frame_new();
// call case 3: self.outer request
  Object call2317 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2316);
// compiled member node returning call2317 (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2318 = callmethodflags(call2317, "checkSeparator(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2315);
// compiled call node returning call2318 (depth = 2)
// Begin line 286
  setline(286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2321 == NULL) {
    strlit2321 = alloc_String("""\x0a""");
    gc_root(strlit2321);
  }
// compiled string node returning strlit2321 (depth = 4)
  int op_slot_right_2320 = gc_frame_newslot(strlit2321);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_left_2320 = gc_frame_newslot(*var_c);
  params[0] = strlit2321;
  partcv[0] = 1;
  Object opresult2323 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult2323 (depth = 3)
  Object if2319 = done;
  if (istrue(opresult2323)) {
// Begin line 287
  setline(287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2324 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit2325 == NULL) {
    strlit2325 = alloc_String("Incomplete pragma definition ");
    gc_root(strlit2325);
  }
// compiled string node returning strlit2325 (depth = 4)
  gc_frame_newslot(strlit2325);
// Begin line 288
  setline(288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe2326 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2327 = gc_frame_new();
// call case 3: self.outer request
  Object call2328 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2327);
// compiled member node returning call2328 (depth = 5)
  partcv[0] = 0;
  Object call2329 = callmethodflags(call2328, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2326);
// compiled member node returning call2329 (depth = 4)
  gc_frame_newslot(call2329);
// starting to compile member node (depth = 4)
  int callframe2330 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2331 = gc_frame_new();
// call case 3: self.outer request
  Object call2332 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2331);
// compiled member node returning call2332 (depth = 5)
  partcv[0] = 0;
  Object call2333 = callmethodflags(call2332, "startPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2330);
// compiled member node returning call2333 (depth = 4)
  gc_frame_newslot(call2333);
// starting to compile member node (depth = 4)
  int callframe2334 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2335 = gc_frame_new();
// call case 3: self.outer request
  Object call2336 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2335);
// compiled member node returning call2336 (depth = 5)
  partcv[0] = 0;
  Object call2337 = callmethodflags(call2336, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2334);
// compiled member node returning call2337 (depth = 4)
  gc_frame_newslot(call2337);
// call case 6: other requests
// Begin line 287
  setline(287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit2325;
  params[1] = call2329;
  params[2] = call2333;
  params[3] = call2337;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call2338 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe2324);
// compiled call node returning call2338 (depth = 3)
    gc_frame_newslot(call2338);
    if2319 = call2338;
  } else {
// Begin line 297
  setline(297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2340 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2341 = gc_frame_new();
// call case 3: self.outer request
  Object call2342 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2341);
// compiled member node returning call2342 (depth = 5)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2343 = callmethodflags(call2342, "isSpaceChar(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2340);
// compiled call node returning call2343 (depth = 4)
  Object if2339 = done;
  if (istrue(call2343)) {
// Begin line 290
  setline(290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2346 == NULL) {
    strlit2346 = alloc_String("pragma");
    gc_root(strlit2346);
  }
// compiled string node returning strlit2346 (depth = 6)
  int op_slot_right_2345 = gc_frame_newslot(strlit2346);
// starting to compile member node (depth = 6)
  int callframe2348 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2349 = gc_frame_new();
// call case 3: self.outer request
  Object call2350 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2349);
// compiled member node returning call2350 (depth = 7)
  partcv[0] = 0;
  Object call2351 = callmethodflags(call2350, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2348);
// compiled member node returning call2351 (depth = 6)
  int op_slot_left_2345 = gc_frame_newslot(call2351);
  params[0] = strlit2346;
  partcv[0] = 1;
  Object opresult2352 = callmethod(call2351, "==(1)", 1, partcv, params);
// compiled op node returning opresult2352 (depth = 5)
  Object if2344 = done;
  if (istrue(opresult2352)) {
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2353 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit2354 == NULL) {
    strlit2354 = alloc_String("");
    gc_root(strlit2354);
  }
// compiled string node returning strlit2354 (depth = 6)
  gc_frame_newslot(strlit2354);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2355 = gc_frame_new();
// call case 3: self.outer request
  Object call2356 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2355);
// compiled member node returning call2356 (depth = 6)
  params[0] = strlit2354;
  partcv[0] = 1;
  Object call2357 = callmethodflags(call2356, "accum:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2353);
// compiled call node returning call2357 (depth = 5)
// Begin line 292
  setline(292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2358 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe2359 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2360 = gc_frame_new();
// call case 3: self.outer request
  Object call2361 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2360);
// compiled member node returning call2361 (depth = 7)
  partcv[0] = 0;
  Object call2362 = callmethodflags(call2361, "pragmaBodyState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2359);
// compiled member node returning call2362 (depth = 6)
  gc_frame_newslot(call2362);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2363 = gc_frame_new();
// call case 3: self.outer request
  Object call2364 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2363);
// compiled member node returning call2364 (depth = 6)
  params[0] = call2362;
  partcv[0] = 1;
  Object call2365 = callmethodflags(call2364, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2358);
// compiled call node returning call2365 (depth = 5)
    gc_frame_newslot(call2365);
    if2344 = call2365;
  } else {
// Begin line 294
  setline(294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2366 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit2367 == NULL) {
    strlit2367 = alloc_String("Pragmas must start with #pragma ");
    gc_root(strlit2367);
  }
// compiled string node returning strlit2367 (depth = 6)
  gc_frame_newslot(strlit2367);
// Begin line 295
  setline(295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe2368 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2369 = gc_frame_new();
// call case 3: self.outer request
  Object call2370 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2369);
// compiled member node returning call2370 (depth = 7)
  partcv[0] = 0;
  Object call2371 = callmethodflags(call2370, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2368);
// compiled member node returning call2371 (depth = 6)
  gc_frame_newslot(call2371);
// starting to compile member node (depth = 6)
  int callframe2372 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2373 = gc_frame_new();
// call case 3: self.outer request
  Object call2374 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2373);
// compiled member node returning call2374 (depth = 7)
  partcv[0] = 0;
  Object call2375 = callmethodflags(call2374, "startPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2372);
// compiled member node returning call2375 (depth = 6)
  gc_frame_newslot(call2375);
// starting to compile member node (depth = 6)
  int callframe2376 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2377 = gc_frame_new();
// call case 3: self.outer request
  Object call2378 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2377);
// compiled member node returning call2378 (depth = 7)
  partcv[0] = 0;
  Object call2379 = callmethodflags(call2378, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2376);
// compiled member node returning call2379 (depth = 6)
  gc_frame_newslot(call2379);
// call case 6: other requests
// Begin line 294
  setline(294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit2367;
  params[1] = call2371;
  params[2] = call2375;
  params[3] = call2379;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call2380 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe2366);
// compiled call node returning call2380 (depth = 5)
    gc_frame_newslot(call2380);
    if2344 = call2380;
  }
// compiled if node returning if2344 (depth = 4)
    gc_frame_newslot(if2344);
    if2339 = if2344;
  } else {
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2381 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2382 = gc_frame_new();
// call case 3: self.outer request
  Object call2383 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2382);
// compiled member node returning call2383 (depth = 5)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2384 = callmethodflags(call2383, "store(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2381);
// compiled call node returning call2384 (depth = 4)
    gc_frame_newslot(call2384);
    if2339 = call2384;
  }
// compiled if node returning if2339 (depth = 3)
    gc_frame_newslot(if2339);
    if2319 = if2339;
  }
// compiled if node returning if2319 (depth = 2)
  gc_frame_end(frame);
  return if2319;
}
Object meth_lexer_2387_consume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "consume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method consume(_)");
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for consume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part consume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2388 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2389 = gc_frame_new();
// call case 3: self.outer request
  Object call2390 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2389);
// compiled member node returning call2390 (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2391 = callmethodflags(call2390, "checkSeparator(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2388);
// compiled call node returning call2391 (depth = 2)
// Begin line 306
  setline(306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2394 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2395 = gc_frame_new();
// call case 3: self.outer request
  Object call2396 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2395);
// compiled member node returning call2396 (depth = 5)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2397 = callmethodflags(call2396, "isSpaceChar(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2394);
// compiled call node returning call2397 (depth = 4)
  int op_slot_right_2393 = gc_frame_newslot(call2397);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2400 == NULL) {
    strlit2400 = alloc_String("""\x0a""");
    gc_root(strlit2400);
  }
// compiled string node returning strlit2400 (depth = 5)
  int op_slot_right_2399 = gc_frame_newslot(strlit2400);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  int op_slot_left_2399 = gc_frame_newslot(*var_c);
  params[0] = strlit2400;
  partcv[0] = 1;
  Object opresult2402 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult2402 (depth = 4)
  int op_slot_left_2393 = gc_frame_newslot(opresult2402);
  params[0] = call2397;
  partcv[0] = 1;
  Object opresult2403 = callmethod(opresult2402, "||(1)", 1, partcv, params);
// compiled op node returning opresult2403 (depth = 3)
  Object if2392 = done;
  if (istrue(opresult2403)) {
// Begin line 308
  setline(308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2404 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2405 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2406 = gc_frame_new();
// call case 3: self.outer request
  Object call2407 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2406);
// compiled member node returning call2407 (depth = 5)
  partcv[0] = 0;
  Object call2408 = callmethodflags(call2407, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2405);
// compiled member node returning call2408 (depth = 4)
  gc_frame_newslot(call2408);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call2408;
  partcv[0] = 1;
  Object call2409 = callmethodflags(*var_util, "processExtension(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2404);
// compiled call node returning call2409 (depth = 3)
// Begin line 309
  setline(309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2410 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit2411 == NULL) {
    strlit2411 = alloc_String("");
    gc_root(strlit2411);
  }
// compiled string node returning strlit2411 (depth = 4)
  gc_frame_newslot(strlit2411);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2412 = gc_frame_new();
// call case 3: self.outer request
  Object call2413 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2412);
// compiled member node returning call2413 (depth = 4)
  params[0] = strlit2411;
  partcv[0] = 1;
  Object call2414 = callmethodflags(call2413, "accum:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2410);
// compiled call node returning call2414 (depth = 3)
// Begin line 310
  setline(310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2415 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2416 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2417 = gc_frame_new();
// call case 3: self.outer request
  Object call2418 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2417);
// compiled member node returning call2418 (depth = 5)
  partcv[0] = 0;
  Object call2419 = callmethodflags(call2418, "pragmaTrailingWhitespaceState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2416);
// compiled member node returning call2419 (depth = 4)
  gc_frame_newslot(call2419);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2420 = gc_frame_new();
// call case 3: self.outer request
  Object call2421 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2420);
// compiled member node returning call2421 (depth = 4)
  params[0] = call2419;
  partcv[0] = 1;
  Object call2422 = callmethodflags(call2421, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2415);
// compiled call node returning call2422 (depth = 3)
// Begin line 311
  setline(311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2423 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2424 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2425 = gc_frame_new();
// call case 3: self.outer request
  Object call2426 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2425);
// compiled member node returning call2426 (depth = 5)
  partcv[0] = 0;
  Object call2427 = callmethodflags(call2426, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2424);
// compiled member node returning call2427 (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2428 = callmethodflags(call2427, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2423);
// compiled call node returning call2428 (depth = 3)
    gc_frame_newslot(call2428);
    if2392 = call2428;
  } else {
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2429 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2430 = gc_frame_new();
// call case 3: self.outer request
  Object call2431 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2430);
// compiled member node returning call2431 (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2432 = callmethodflags(call2431, "store(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2429);
// compiled call node returning call2432 (depth = 3)
    gc_frame_newslot(call2432);
    if2392 = call2432;
  }
// compiled if node returning if2392 (depth = 2)
  gc_frame_end(frame);
  return if2392;
}
Object meth_lexer_2435_consume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "consume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method consume(_)");
  Object params[4];
  int partcv[2];
  Object *var_errormessages = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for consume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part consume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 320
  setline(320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2436 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2437 = gc_frame_new();
// call case 3: self.outer request
  Object call2438 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2437);
// compiled member node returning call2438 (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2439 = callmethodflags(call2438, "checkSeparator(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2436);
// compiled call node returning call2439 (depth = 2)
// Begin line 321
  setline(321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2442 == NULL) {
    strlit2442 = alloc_String("""\x0a""");
    gc_root(strlit2442);
  }
// compiled string node returning strlit2442 (depth = 4)
  int op_slot_right_2441 = gc_frame_newslot(strlit2442);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_left_2441 = gc_frame_newslot(*var_c);
  params[0] = strlit2442;
  partcv[0] = 1;
  Object opresult2444 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult2444 (depth = 3)
  Object if2440 = done;
  if (istrue(opresult2444)) {
// Begin line 322
  setline(322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2445 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2446 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2447 = gc_frame_new();
// call case 3: self.outer request
  Object call2448 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2447);
// compiled member node returning call2448 (depth = 5)
  partcv[0] = 0;
  Object call2449 = callmethodflags(call2448, "startState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2446);
// compiled member node returning call2449 (depth = 4)
  gc_frame_newslot(call2449);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2450 = gc_frame_new();
// call case 3: self.outer request
  Object call2451 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2450);
// compiled member node returning call2451 (depth = 4)
  params[0] = call2449;
  partcv[0] = 1;
  Object call2452 = callmethodflags(call2451, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2445);
// compiled call node returning call2452 (depth = 3)
    gc_frame_newslot(call2452);
    if2440 = call2452;
  } else {
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 323
  setline(323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2454 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe2455 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_c (depth = 6)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2456 = gc_frame_new();
// call case 3: self.outer request
  Object call2457 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2456);
// compiled member node returning call2457 (depth = 6)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2458 = callmethodflags(call2457, "isSpaceChar(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2455);
// compiled call node returning call2458 (depth = 5)
  partcv[0] = 0;
  Object call2459 = callmethodflags(call2458, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe2454);
// compiled call node returning call2459 (depth = 4)
  Object if2453 = done;
  if (istrue(call2459)) {
// Begin line 324
  setline(324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2460 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit2461 == NULL) {
    strlit2461 = alloc_String("Pragmas must be a single word ");
    gc_root(strlit2461);
  }
// compiled string node returning strlit2461 (depth = 5)
  gc_frame_newslot(strlit2461);
// Begin line 325
  setline(325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe2462 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2463 = gc_frame_new();
// call case 3: self.outer request
  Object call2464 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2463);
// compiled member node returning call2464 (depth = 6)
  partcv[0] = 0;
  Object call2465 = callmethodflags(call2464, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2462);
// compiled member node returning call2465 (depth = 5)
  gc_frame_newslot(call2465);
// starting to compile member node (depth = 5)
  int callframe2466 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2467 = gc_frame_new();
// call case 3: self.outer request
  Object call2468 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2467);
// compiled member node returning call2468 (depth = 6)
  partcv[0] = 0;
  Object call2469 = callmethodflags(call2468, "startPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2466);
// compiled member node returning call2469 (depth = 5)
  gc_frame_newslot(call2469);
// starting to compile member node (depth = 5)
  int callframe2470 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2471 = gc_frame_new();
// call case 3: self.outer request
  Object call2472 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2471);
// compiled member node returning call2472 (depth = 6)
  partcv[0] = 0;
  Object call2473 = callmethodflags(call2472, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2470);
// compiled member node returning call2473 (depth = 5)
  gc_frame_newslot(call2473);
// call case 6: other requests
// Begin line 324
  setline(324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit2461;
  params[1] = call2465;
  params[2] = call2469;
  params[3] = call2473;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call2474 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe2460);
// compiled call node returning call2474 (depth = 4)
    gc_frame_newslot(call2474);
    if2453 = call2474;
  } else {
  }
// compiled if node returning if2453 (depth = 3)
    gc_frame_newslot(if2453);
    if2440 = if2453;
  }
// compiled if node returning if2440 (depth = 2)
  gc_frame_end(frame);
  return if2440;
}
Object meth_lexer_2561__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2563 == NULL) {
    strlit2563 = alloc_String("num");
    gc_root(strlit2563);
  }
// compiled string node returning strlit2563 (depth = 10)
  int op_slot_right_2562 = gc_frame_newslot(strlit2563);
// starting to compile member node (depth = 10)
  int callframe2565 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe2566 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe2567 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 13)
  int callframe2568 = gc_frame_new();
// call case 3: self.outer request
  Object call2569 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2568);
// compiled member node returning call2569 (depth = 13)
  partcv[0] = 0;
  Object call2570 = callmethodflags(call2569, "tokens", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2567);
// compiled member node returning call2570 (depth = 12)
  partcv[0] = 0;
  Object call2571 = callmethodflags(call2570, "last", 1, partcv, params, 0);
  gc_frame_end(callframe2566);
// compiled member node returning call2571 (depth = 11)
  partcv[0] = 0;
  Object call2572 = callmethodflags(call2571, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe2565);
// compiled member node returning call2572 (depth = 10)
  int op_slot_left_2562 = gc_frame_newslot(call2572);
  params[0] = strlit2563;
  partcv[0] = 1;
  Object opresult2573 = callmethod(call2572, "==(1)", 1, partcv, params);
// compiled op node returning opresult2573 (depth = 9)
  gc_frame_end(frame);
  return opresult2573;
}
Object meth_lexer_2810__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 18)
// starting to compile string node (depth = 19)
  if (strlit2812 == NULL) {
    strlit2812 = alloc_String("lparen");
    gc_root(strlit2812);
  }
// compiled string node returning strlit2812 (depth = 19)
  int op_slot_right_2811 = gc_frame_newslot(strlit2812);
// starting to compile member node (depth = 19)
  int callframe2814 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 20)
  int callframe2815 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 21)
  int callframe2816 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 22)
  int callframe2817 = gc_frame_new();
// call case 3: self.outer request
  Object call2818 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2817);
// compiled member node returning call2818 (depth = 22)
  partcv[0] = 0;
  Object call2819 = callmethodflags(call2818, "tokens", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2816);
// compiled member node returning call2819 (depth = 21)
  partcv[0] = 0;
  Object call2820 = callmethodflags(call2819, "last", 1, partcv, params, 0);
  gc_frame_end(callframe2815);
// compiled member node returning call2820 (depth = 20)
  partcv[0] = 0;
  Object call2821 = callmethodflags(call2820, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe2814);
// compiled member node returning call2821 (depth = 19)
  int op_slot_left_2811 = gc_frame_newslot(call2821);
  params[0] = strlit2812;
  partcv[0] = 1;
  Object opresult2822 = callmethod(call2821, "==(1)", 1, partcv, params);
// compiled op node returning opresult2822 (depth = 18)
  gc_frame_end(frame);
  return opresult2822;
}
Object meth_lexer_2477_consume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "consume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method consume(_)");
  Object params[5];
  int partcv[3];
  Object *var_spaceChars = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_unicode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for consume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part consume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_ordval = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ordval");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 332
  setline(332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2478 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  partcv[0] = 0;
  Object call2479 = callmethodflags(*var_c, "ord", 1, partcv, params, 0);
  gc_frame_end(callframe2478);
// compiled member node returning call2479 (depth = 3)
  *var_ordval = call2479;
  if (call2479 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 333
  setline(333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2480 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2481 = gc_frame_new();
// call case 3: self.outer request
  Object call2482 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2481);
// compiled member node returning call2482 (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2483 = callmethodflags(call2482, "checkSeparator(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2480);
// compiled call node returning call2483 (depth = 2)
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2484 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe2485 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2486 = gc_frame_new();
// call case 3: self.outer request
  Object call2487 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2486);
// compiled member node returning call2487 (depth = 4)
  partcv[0] = 0;
  Object call2488 = callmethodflags(call2487, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2485);
// compiled member node returning call2488 (depth = 3)
  gc_frame_newslot(call2488);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2489 = gc_frame_new();
// call case 3: self.outer request
  Object call2490 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2489);
// compiled member node returning call2490 (depth = 3)
  params[0] = call2488;
  partcv[0] = 1;
  Object call2491 = callmethodflags(call2490, "startPosition:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2484);
// compiled call node returning call2491 (depth = 2)
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2492 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe2493 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2494 = gc_frame_new();
// call case 3: self.outer request
  Object call2495 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2494);
// compiled member node returning call2495 (depth = 4)
  partcv[0] = 0;
  Object call2496 = callmethodflags(call2495, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2493);
// compiled member node returning call2496 (depth = 3)
  gc_frame_newslot(call2496);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2497 = gc_frame_new();
// call case 3: self.outer request
  Object call2498 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2497);
// compiled member node returning call2498 (depth = 3)
  params[0] = call2496;
  partcv[0] = 1;
  Object call2499 = callmethodflags(call2498, "startLine:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2492);
// compiled call node returning call2499 (depth = 2)
// Begin line 336
  setline(336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2501 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_spaceChars (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2502 = callmethodflags(*var_spaceChars, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2501);
// compiled call node returning call2502 (depth = 3)
  Object if2500 = done;
  if (istrue(call2502)) {
    gc_frame_newslot(done);
    if2500 = done;
  } else {
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 338
  setline(338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2505 == NULL) {
    strlit2505 = alloc_String("""\x22""");
    gc_root(strlit2505);
  }
// compiled string node returning strlit2505 (depth = 5)
  int op_slot_right_2504 = gc_frame_newslot(strlit2505);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  int op_slot_left_2504 = gc_frame_newslot(*var_c);
  params[0] = strlit2505;
  partcv[0] = 1;
  Object opresult2507 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult2507 (depth = 4)
  Object if2503 = done;
  if (istrue(opresult2507)) {
// Begin line 339
  setline(339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2508 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool2509 = alloc_Boolean(1);
// compiled identifier node returning bool2509 (depth = 5)
  gc_frame_newslot(bool2509);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2510 = gc_frame_new();
// call case 3: self.outer request
  Object call2511 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2510);
// compiled member node returning call2511 (depth = 5)
  params[0] = bool2509;
  partcv[0] = 1;
  Object call2512 = callmethodflags(call2511, "inStr:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2508);
// compiled call node returning call2512 (depth = 4)
// Begin line 340
  setline(340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2513 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2514 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2515 = gc_frame_new();
// call case 3: self.outer request
  Object call2516 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2515);
// compiled member node returning call2516 (depth = 6)
  partcv[0] = 0;
  Object call2517 = callmethodflags(call2516, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2514);
// compiled member node returning call2517 (depth = 5)
  gc_frame_newslot(call2517);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2518 = gc_frame_new();
// call case 3: self.outer request
  Object call2519 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2518);
// compiled member node returning call2519 (depth = 5)
  params[0] = call2517;
  partcv[0] = 1;
  Object call2520 = callmethodflags(call2519, "stringStart:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2513);
// compiled call node returning call2520 (depth = 4)
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2521 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2522 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2523 = gc_frame_new();
// call case 3: self.outer request
  Object call2524 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2523);
// compiled member node returning call2524 (depth = 6)
  partcv[0] = 0;
  Object call2525 = callmethodflags(call2524, "quotedStringState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2522);
// compiled member node returning call2525 (depth = 5)
  gc_frame_newslot(call2525);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2526 = gc_frame_new();
// call case 3: self.outer request
  Object call2527 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2526);
// compiled member node returning call2527 (depth = 5)
  params[0] = call2525;
  partcv[0] = 1;
  Object call2528 = callmethodflags(call2527, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2521);
// compiled call node returning call2528 (depth = 4)
    gc_frame_newslot(call2528);
    if2503 = call2528;
  } else {
// Begin line 346
  setline(346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2531 == NULL) {
    strlit2531 = alloc_String("""\xe2""""\x80""""\xb9""");
    gc_root(strlit2531);
  }
// compiled string node returning strlit2531 (depth = 6)
  int op_slot_right_2530 = gc_frame_newslot(strlit2531);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_c (depth = 6)
  int op_slot_left_2530 = gc_frame_newslot(*var_c);
  params[0] = strlit2531;
  partcv[0] = 1;
  Object opresult2533 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult2533 (depth = 5)
  Object if2529 = done;
  if (istrue(opresult2533)) {
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2534 = gc_frame_new();
// starting to compile identifier node (depth = 6)
  Object bool2535 = alloc_Boolean(1);
// compiled identifier node returning bool2535 (depth = 6)
  gc_frame_newslot(bool2535);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2536 = gc_frame_new();
// call case 3: self.outer request
  Object call2537 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2536);
// compiled member node returning call2537 (depth = 6)
  params[0] = bool2535;
  partcv[0] = 1;
  Object call2538 = callmethodflags(call2537, "inStr:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2534);
// compiled call node returning call2538 (depth = 5)
// Begin line 344
  setline(344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2539 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe2540 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2541 = gc_frame_new();
// call case 3: self.outer request
  Object call2542 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2541);
// compiled member node returning call2542 (depth = 7)
  partcv[0] = 0;
  Object call2543 = callmethodflags(call2542, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2540);
// compiled member node returning call2543 (depth = 6)
  gc_frame_newslot(call2543);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2544 = gc_frame_new();
// call case 3: self.outer request
  Object call2545 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2544);
// compiled member node returning call2545 (depth = 6)
  params[0] = call2543;
  partcv[0] = 1;
  Object call2546 = callmethodflags(call2545, "stringStart:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2539);
// compiled call node returning call2546 (depth = 5)
// Begin line 345
  setline(345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2547 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe2548 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2549 = gc_frame_new();
// call case 3: self.outer request
  Object call2550 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2549);
// compiled member node returning call2550 (depth = 7)
  partcv[0] = 0;
  Object call2551 = callmethodflags(call2550, "extendedStringState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2548);
// compiled member node returning call2551 (depth = 6)
  gc_frame_newslot(call2551);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2552 = gc_frame_new();
// call case 3: self.outer request
  Object call2553 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2552);
// compiled member node returning call2553 (depth = 6)
  params[0] = call2551;
  partcv[0] = 1;
  Object call2554 = callmethodflags(call2553, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2547);
// compiled call node returning call2554 (depth = 5)
    gc_frame_newslot(call2554);
    if2529 = call2554;
  } else {
// Begin line 356
  setline(356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 346
  setline(346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2556 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_lexer (depth = 7)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2557 = callmethodflags(module_lexer, "isDigit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2556);
// compiled call node returning call2557 (depth = 6)
  Object if2555 = done;
  if (istrue(call2557)) {
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile block node (depth = 8)
  Object block2560 = alloc_Block(NULL, NULL, "lexer", 347);
  gc_frame_newslot(block2560);
// method "_apply"
  block_savedest(block2560);
  Object closure2561 = createclosure(1, "_apply");
  setclosureframe(closure2561, stackframe);
  addtoclosure(closure2561, selfslot);
  struct UserObject *uo2561 = (struct UserObject*)block2560;
  uo2561->data[0] = (Object)closure2561;
  Method *meth_meth_lexer_2561__apply = addmethod2pos(block2560, "_apply", &meth_lexer_2561__apply, 0);
  int argcv_meth_lexer_2561__apply[] = {0};
  meth_meth_lexer_2561__apply->type = alloc_MethodType(1, argcv_meth_lexer_2561__apply);
  meth_meth_lexer_2561__apply->definitionModule = modulename;
  meth_meth_lexer_2561__apply->definitionLine = 1145;
// compiled block node returning block2560 (depth = 8)
  int op_slot_right_2559 = gc_frame_newslot(block2560);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2577 = alloc_Float64(0);
// compiled num node returning num2577 (depth = 9)
  int op_slot_right_2576 = gc_frame_newslot(num2577);
// starting to compile member node (depth = 9)
  int callframe2579 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2580 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe2581 = gc_frame_new();
// call case 3: self.outer request
  Object call2582 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2581);
// compiled member node returning call2582 (depth = 11)
  partcv[0] = 0;
  Object call2583 = callmethodflags(call2582, "tokens", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2580);
// compiled member node returning call2583 (depth = 10)
  partcv[0] = 0;
  Object call2584 = callmethodflags(call2583, "size", 1, partcv, params, 0);
  gc_frame_end(callframe2579);
// compiled member node returning call2584 (depth = 9)
  int op_slot_left_2576 = gc_frame_newslot(call2584);
  params[0] = num2577;
  partcv[0] = 1;
  Object opresult2585 = callmethod(call2584, ">(1)", 1, partcv, params);
// compiled op node returning opresult2585 (depth = 8)
  int op_slot_left_2559 = gc_frame_newslot(opresult2585);
  params[0] = block2560;
  partcv[0] = 1;
  Object opresult2586 = callmethod(opresult2585, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2586 (depth = 7)
  Object if2558 = done;
  if (istrue(opresult2586)) {
// Begin line 348
  setline(348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2587 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2588 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call2589 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe2588);
// compiled member node returning call2589 (depth = 9)
  partcv[0] = 0;
  Object call2590 = callmethodflags(call2589, "new", 1, partcv, params, 0);
  gc_frame_end(callframe2587);
// compiled member node returning call2590 (depth = 8)
  *var_suggestion = call2590;
  if (call2590 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2591 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe2593 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2594 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe2595 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe2596 = gc_frame_new();
// call case 3: self.outer request
  Object call2597 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2596);
// compiled member node returning call2597 (depth = 12)
  partcv[0] = 0;
  Object call2598 = callmethodflags(call2597, "tokens", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2595);
// compiled member node returning call2598 (depth = 11)
  partcv[0] = 0;
  Object call2599 = callmethodflags(call2598, "last", 1, partcv, params, 0);
  gc_frame_end(callframe2594);
// compiled member node returning call2599 (depth = 10)
  partcv[0] = 0;
  Object call2600 = callmethodflags(call2599, "size", 1, partcv, params, 0);
  gc_frame_end(callframe2593);
// compiled member node returning call2600 (depth = 9)
  int op_slot_right_2592 = gc_frame_newslot(call2600);
// starting to compile member node (depth = 9)
  int callframe2602 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2603 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe2604 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe2605 = gc_frame_new();
// call case 3: self.outer request
  Object call2606 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2605);
// compiled member node returning call2606 (depth = 12)
  partcv[0] = 0;
  Object call2607 = callmethodflags(call2606, "tokens", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2604);
// compiled member node returning call2607 (depth = 11)
  partcv[0] = 0;
  Object call2608 = callmethodflags(call2607, "last", 1, partcv, params, 0);
  gc_frame_end(callframe2603);
// compiled member node returning call2608 (depth = 10)
  partcv[0] = 0;
  Object call2609 = callmethodflags(call2608, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2602);
// compiled member node returning call2609 (depth = 9)
  int op_slot_left_2592 = gc_frame_newslot(call2609);
  params[0] = call2600;
  partcv[0] = 1;
  Object sum2610 = callmethod(call2609, "+(1)", 1, partcv, params);
// compiled op node returning sum2610 (depth = 8)
  gc_frame_newslot(sum2610);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2612 = alloc_Float64(1);
// compiled num node returning num2612 (depth = 9)
  int op_slot_right_2611 = gc_frame_newslot(num2612);
// starting to compile member node (depth = 9)
  int callframe2614 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2615 = gc_frame_new();
// call case 3: self.outer request
  Object call2616 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2615);
// compiled member node returning call2616 (depth = 10)
  partcv[0] = 0;
  Object call2617 = callmethodflags(call2616, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2614);
// compiled member node returning call2617 (depth = 9)
  int op_slot_left_2611 = gc_frame_newslot(call2617);
  params[0] = num2612;
  partcv[0] = 1;
  Object diff2618 = callmethod(call2617, "-(1)", 1, partcv, params);
// compiled op node returning diff2618 (depth = 8)
  gc_frame_newslot(diff2618);
// starting to compile member node (depth = 8)
  int callframe2619 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2620 = gc_frame_new();
// call case 3: self.outer request
  Object call2621 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2620);
// compiled member node returning call2621 (depth = 9)
  partcv[0] = 0;
  Object call2622 = callmethodflags(call2621, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2619);
// compiled member node returning call2622 (depth = 8)
  gc_frame_newslot(call2622);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum2610;
  params[1] = diff2618;
  params[2] = call2622;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2623 = callmethodflags(*var_suggestion, "deleteRange(2)onLine(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2591);
// compiled call node returning call2623 (depth = 7)
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2624 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2625 == NULL) {
    strlit2625 = alloc_String("Consecutive numbers are not allowed.");
    gc_root(strlit2625);
  }
// compiled string node returning strlit2625 (depth = 8)
  gc_frame_newslot(strlit2625);
// Begin line 351
  setline(351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe2626 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2627 = gc_frame_new();
// call case 3: self.outer request
  Object call2628 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2627);
// compiled member node returning call2628 (depth = 9)
  partcv[0] = 0;
  Object call2629 = callmethodflags(call2628, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2626);
// compiled member node returning call2629 (depth = 8)
  gc_frame_newslot(call2629);
// starting to compile member node (depth = 8)
  int callframe2630 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2631 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2632 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe2633 = gc_frame_new();
// call case 3: self.outer request
  Object call2634 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2633);
// compiled member node returning call2634 (depth = 11)
  partcv[0] = 0;
  Object call2635 = callmethodflags(call2634, "tokens", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2632);
// compiled member node returning call2635 (depth = 10)
  partcv[0] = 0;
  Object call2636 = callmethodflags(call2635, "last", 1, partcv, params, 0);
  gc_frame_end(callframe2631);
// compiled member node returning call2636 (depth = 9)
  partcv[0] = 0;
  Object call2637 = callmethodflags(call2636, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2630);
// compiled member node returning call2637 (depth = 8)
  gc_frame_newslot(call2637);
// starting to compile member node (depth = 8)
  int callframe2638 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2639 = gc_frame_new();
// call case 3: self.outer request
  Object call2640 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2639);
// compiled member node returning call2640 (depth = 9)
  partcv[0] = 0;
  Object call2641 = callmethodflags(call2640, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2638);
// compiled member node returning call2641 (depth = 8)
  gc_frame_newslot(call2641);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit2625;
  params[1] = call2629;
  params[2] = call2637;
  params[3] = call2641;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2642 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2624);
// compiled call node returning call2642 (depth = 7)
    gc_frame_newslot(call2642);
    if2558 = call2642;
  } else {
  }
// compiled if node returning if2558 (depth = 6)
// Begin line 353
  setline(353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2643 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe2644 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe2645 = gc_frame_new();
// call case 3: self.outer request
  Object call2646 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2645);
// compiled member node returning call2646 (depth = 8)
  partcv[0] = 0;
  Object call2647 = callmethodflags(call2646, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2644);
// compiled member node returning call2647 (depth = 7)
  gc_frame_newslot(call2647);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2648 = gc_frame_new();
// call case 3: self.outer request
  Object call2649 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2648);
// compiled member node returning call2649 (depth = 7)
  params[0] = call2647;
  partcv[0] = 1;
  Object call2650 = callmethodflags(call2649, "startPosition:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2643);
// compiled call node returning call2650 (depth = 6)
// Begin line 354
  setline(354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2651 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe2652 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe2653 = gc_frame_new();
// call case 3: self.outer request
  Object call2654 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2653);
// compiled member node returning call2654 (depth = 8)
  partcv[0] = 0;
  Object call2655 = callmethodflags(call2654, "numberStartState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2652);
// compiled member node returning call2655 (depth = 7)
  gc_frame_newslot(call2655);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2656 = gc_frame_new();
// call case 3: self.outer request
  Object call2657 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2656);
// compiled member node returning call2657 (depth = 7)
  params[0] = call2655;
  partcv[0] = 1;
  Object call2658 = callmethodflags(call2657, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2651);
// compiled call node returning call2658 (depth = 6)
// Begin line 355
  setline(355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2659 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2660 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe2661 = gc_frame_new();
// call case 3: self.outer request
  Object call2662 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2661);
// compiled member node returning call2662 (depth = 8)
  partcv[0] = 0;
  Object call2663 = callmethodflags(call2662, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2660);
// compiled member node returning call2663 (depth = 7)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2664 = callmethodflags(call2663, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2659);
// compiled call node returning call2664 (depth = 6)
    gc_frame_newslot(call2664);
    if2555 = call2664;
  } else {
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 356
  setline(356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2666 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_lexer (depth = 8)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2667 = callmethodflags(module_lexer, "isIdentifierChar(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2666);
// compiled call node returning call2667 (depth = 7)
  Object if2665 = done;
  if (istrue(call2667)) {
// Begin line 357
  setline(357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2668 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe2669 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2670 = gc_frame_new();
// call case 3: self.outer request
  Object call2671 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2670);
// compiled member node returning call2671 (depth = 9)
  partcv[0] = 0;
  Object call2672 = callmethodflags(call2671, "identifierState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2669);
// compiled member node returning call2672 (depth = 8)
  gc_frame_newslot(call2672);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe2673 = gc_frame_new();
// call case 3: self.outer request
  Object call2674 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2673);
// compiled member node returning call2674 (depth = 8)
  params[0] = call2672;
  partcv[0] = 1;
  Object call2675 = callmethodflags(call2674, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2668);
// compiled call node returning call2675 (depth = 7)
// Begin line 358
  setline(358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2676 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe2677 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2678 = gc_frame_new();
// call case 3: self.outer request
  Object call2679 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2678);
// compiled member node returning call2679 (depth = 9)
  partcv[0] = 0;
  Object call2680 = callmethodflags(call2679, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2677);
// compiled member node returning call2680 (depth = 8)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2681 = callmethodflags(call2680, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2676);
// compiled call node returning call2681 (depth = 7)
    gc_frame_newslot(call2681);
    if2665 = call2681;
  } else {
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2684 == NULL) {
    strlit2684 = alloc_String("/");
    gc_root(strlit2684);
  }
// compiled string node returning strlit2684 (depth = 9)
  int op_slot_right_2683 = gc_frame_newslot(strlit2684);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_2683 = gc_frame_newslot(*var_c);
  params[0] = strlit2684;
  partcv[0] = 1;
  Object opresult2686 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult2686 (depth = 8)
  Object if2682 = done;
  if (istrue(opresult2686)) {
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2687 = gc_frame_new();
// starting to compile member node (depth = 9)
  int callframe2688 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2689 = gc_frame_new();
// call case 3: self.outer request
  Object call2690 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2689);
// compiled member node returning call2690 (depth = 10)
  partcv[0] = 0;
  Object call2691 = callmethodflags(call2690, "slashState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2688);
// compiled member node returning call2691 (depth = 9)
  gc_frame_newslot(call2691);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2692 = gc_frame_new();
// call case 3: self.outer request
  Object call2693 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2692);
// compiled member node returning call2693 (depth = 9)
  params[0] = call2691;
  partcv[0] = 1;
  Object call2694 = callmethodflags(call2693, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2687);
// compiled call node returning call2694 (depth = 8)
// Begin line 361
  setline(361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2695 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2696 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2697 = gc_frame_new();
// call case 3: self.outer request
  Object call2698 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2697);
// compiled member node returning call2698 (depth = 10)
  partcv[0] = 0;
  Object call2699 = callmethodflags(call2698, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2696);
// compiled member node returning call2699 (depth = 9)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2700 = callmethodflags(call2699, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2695);
// compiled call node returning call2700 (depth = 8)
    gc_frame_newslot(call2700);
    if2682 = call2700;
  } else {
// Begin line 365
  setline(365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2703 == NULL) {
    strlit2703 = alloc_String(".");
    gc_root(strlit2703);
  }
// compiled string node returning strlit2703 (depth = 10)
  int op_slot_right_2702 = gc_frame_newslot(strlit2703);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_left_2702 = gc_frame_newslot(*var_c);
  params[0] = strlit2703;
  partcv[0] = 1;
  Object opresult2705 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult2705 (depth = 9)
  Object if2701 = done;
  if (istrue(opresult2705)) {
// Begin line 363
  setline(363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2706 = gc_frame_new();
// starting to compile member node (depth = 10)
  int callframe2707 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe2708 = gc_frame_new();
// call case 3: self.outer request
  Object call2709 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2708);
// compiled member node returning call2709 (depth = 11)
  partcv[0] = 0;
  Object call2710 = callmethodflags(call2709, "dotState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2707);
// compiled member node returning call2710 (depth = 10)
  gc_frame_newslot(call2710);
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2711 = gc_frame_new();
// call case 3: self.outer request
  Object call2712 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2711);
// compiled member node returning call2712 (depth = 10)
  params[0] = call2710;
  partcv[0] = 1;
  Object call2713 = callmethodflags(call2712, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2706);
// compiled call node returning call2713 (depth = 9)
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2714 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2715 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe2716 = gc_frame_new();
// call case 3: self.outer request
  Object call2717 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2716);
// compiled member node returning call2717 (depth = 11)
  partcv[0] = 0;
  Object call2718 = callmethodflags(call2717, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2715);
// compiled member node returning call2718 (depth = 10)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2719 = callmethodflags(call2718, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2714);
// compiled call node returning call2719 (depth = 9)
    gc_frame_newslot(call2719);
    if2701 = call2719;
  } else {
// Begin line 368
  setline(368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 365
  setline(365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2722 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_c (depth = 12)
  gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ordval (depth = 12)
  gc_frame_newslot(*var_ordval);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning module_lexer (depth = 12)
  params[0] = *var_c;
  params[1] = *var_ordval;
  partcv[0] = 2;
  Object call2723 = callmethodflags(module_lexer, "isOperatorChar(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2722);
// compiled call node returning call2723 (depth = 11)
  int op_slot_right_2721 = gc_frame_newslot(call2723);
// Begin line 365
  setline(365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2726 == NULL) {
    strlit2726 = alloc_String("<");
    gc_root(strlit2726);
  }
// compiled string node returning strlit2726 (depth = 12)
  int op_slot_right_2725 = gc_frame_newslot(strlit2726);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_c (depth = 12)
  int op_slot_left_2725 = gc_frame_newslot(*var_c);
  params[0] = strlit2726;
  partcv[0] = 1;
  Object opresult2728 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult2728 (depth = 11)
  int op_slot_left_2721 = gc_frame_newslot(opresult2728);
  params[0] = call2723;
  partcv[0] = 1;
  Object opresult2729 = callmethod(opresult2728, "||(1)", 1, partcv, params);
// compiled op node returning opresult2729 (depth = 10)
  Object if2720 = done;
  if (istrue(opresult2729)) {
// Begin line 366
  setline(366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2730 = gc_frame_new();
// starting to compile member node (depth = 11)
  int callframe2731 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe2732 = gc_frame_new();
// call case 3: self.outer request
  Object call2733 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2732);
// compiled member node returning call2733 (depth = 12)
  partcv[0] = 0;
  Object call2734 = callmethodflags(call2733, "operatorState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2731);
// compiled member node returning call2734 (depth = 11)
  gc_frame_newslot(call2734);
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe2735 = gc_frame_new();
// call case 3: self.outer request
  Object call2736 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2735);
// compiled member node returning call2736 (depth = 11)
  params[0] = call2734;
  partcv[0] = 1;
  Object call2737 = callmethodflags(call2736, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2730);
// compiled call node returning call2737 (depth = 10)
// Begin line 367
  setline(367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2738 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe2739 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe2740 = gc_frame_new();
// call case 3: self.outer request
  Object call2741 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2740);
// compiled member node returning call2741 (depth = 12)
  partcv[0] = 0;
  Object call2742 = callmethodflags(call2741, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2739);
// compiled member node returning call2742 (depth = 11)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2743 = callmethodflags(call2742, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2738);
// compiled call node returning call2743 (depth = 10)
    gc_frame_newslot(call2743);
    if2720 = call2743;
  } else {
// Begin line 370
  setline(370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 368
  setline(368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2746 == NULL) {
    strlit2746 = alloc_String(",");
    gc_root(strlit2746);
  }
// compiled string node returning strlit2746 (depth = 12)
  int op_slot_right_2745 = gc_frame_newslot(strlit2746);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_c (depth = 12)
  int op_slot_left_2745 = gc_frame_newslot(*var_c);
  params[0] = strlit2746;
  partcv[0] = 1;
  Object opresult2748 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult2748 (depth = 11)
  Object if2744 = done;
  if (istrue(opresult2748)) {
// Begin line 369
  setline(369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2749 = gc_frame_new();
// starting to compile member node (depth = 12)
  int callframe2750 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 13)
  int callframe2751 = gc_frame_new();
// call case 3: self.outer request
  Object call2752 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2751);
// compiled member node returning call2752 (depth = 13)
  partcv[0] = 0;
  Object call2753 = callmethodflags(call2752, "commaToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2750);
// compiled member node returning call2753 (depth = 12)
  gc_frame_newslot(call2753);
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe2754 = gc_frame_new();
// call case 3: self.outer request
  Object call2755 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2754);
// compiled member node returning call2755 (depth = 12)
  params[0] = call2753;
  partcv[0] = 1;
  Object call2756 = callmethodflags(call2755, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2749);
// compiled call node returning call2756 (depth = 11)
    gc_frame_newslot(call2756);
    if2744 = call2756;
  } else {
// Begin line 372
  setline(372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 370
  setline(370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit2759 == NULL) {
    strlit2759 = alloc_String("{");
    gc_root(strlit2759);
  }
// compiled string node returning strlit2759 (depth = 13)
  int op_slot_right_2758 = gc_frame_newslot(strlit2759);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_c (depth = 13)
  int op_slot_left_2758 = gc_frame_newslot(*var_c);
  params[0] = strlit2759;
  partcv[0] = 1;
  Object opresult2761 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult2761 (depth = 12)
  Object if2757 = done;
  if (istrue(opresult2761)) {
// Begin line 371
  setline(371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe2762 = gc_frame_new();
// starting to compile member node (depth = 13)
  int callframe2763 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 14)
  int callframe2764 = gc_frame_new();
// call case 3: self.outer request
  Object call2765 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2764);
// compiled member node returning call2765 (depth = 14)
  partcv[0] = 0;
  Object call2766 = callmethodflags(call2765, "lBraceToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2763);
// compiled member node returning call2766 (depth = 13)
  gc_frame_newslot(call2766);
// call case 6: other requests
// starting to compile member node (depth = 13)
  int callframe2767 = gc_frame_new();
// call case 3: self.outer request
  Object call2768 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2767);
// compiled member node returning call2768 (depth = 13)
  params[0] = call2766;
  partcv[0] = 1;
  Object call2769 = callmethodflags(call2768, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2762);
// compiled call node returning call2769 (depth = 12)
    gc_frame_newslot(call2769);
    if2757 = call2769;
  } else {
// Begin line 375
  setline(375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 372
  setline(372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit2772 == NULL) {
    strlit2772 = alloc_String("}");
    gc_root(strlit2772);
  }
// compiled string node returning strlit2772 (depth = 14)
  int op_slot_right_2771 = gc_frame_newslot(strlit2772);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_c (depth = 14)
  int op_slot_left_2771 = gc_frame_newslot(*var_c);
  params[0] = strlit2772;
  partcv[0] = 1;
  Object opresult2774 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult2774 (depth = 13)
  Object if2770 = done;
  if (istrue(opresult2774)) {
// Begin line 373
  setline(373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe2775 = gc_frame_new();
// starting to compile member node (depth = 14)
  int callframe2776 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 15)
  int callframe2777 = gc_frame_new();
// call case 3: self.outer request
  Object call2778 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2777);
// compiled member node returning call2778 (depth = 15)
  partcv[0] = 0;
  Object call2779 = callmethodflags(call2778, "rBraceState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2776);
// compiled member node returning call2779 (depth = 14)
  gc_frame_newslot(call2779);
// call case 6: other requests
// starting to compile member node (depth = 14)
  int callframe2780 = gc_frame_new();
// call case 3: self.outer request
  Object call2781 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2780);
// compiled member node returning call2781 (depth = 14)
  params[0] = call2779;
  partcv[0] = 1;
  Object call2782 = callmethodflags(call2781, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2775);
// compiled call node returning call2782 (depth = 13)
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe2783 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_c (depth = 14)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 14)
  int callframe2784 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 15)
  int callframe2785 = gc_frame_new();
// call case 3: self.outer request
  Object call2786 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2785);
// compiled member node returning call2786 (depth = 15)
  partcv[0] = 0;
  Object call2787 = callmethodflags(call2786, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2784);
// compiled member node returning call2787 (depth = 14)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2788 = callmethodflags(call2787, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2783);
// compiled call node returning call2788 (depth = 13)
    gc_frame_newslot(call2788);
    if2770 = call2788;
  } else {
// Begin line 377
  setline(377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 13)
// Begin line 375
  setline(375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit2791 == NULL) {
    strlit2791 = alloc_String("(");
    gc_root(strlit2791);
  }
// compiled string node returning strlit2791 (depth = 15)
  int op_slot_right_2790 = gc_frame_newslot(strlit2791);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_c (depth = 15)
  int op_slot_left_2790 = gc_frame_newslot(*var_c);
  params[0] = strlit2791;
  partcv[0] = 1;
  Object opresult2793 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult2793 (depth = 14)
  Object if2789 = done;
  if (istrue(opresult2793)) {
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 14)
  int callframe2794 = gc_frame_new();
// starting to compile member node (depth = 15)
  int callframe2795 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 16)
  int callframe2796 = gc_frame_new();
// call case 3: self.outer request
  Object call2797 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2796);
// compiled member node returning call2797 (depth = 16)
  partcv[0] = 0;
  Object call2798 = callmethodflags(call2797, "lParenToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2795);
// compiled member node returning call2798 (depth = 15)
  gc_frame_newslot(call2798);
// call case 6: other requests
// starting to compile member node (depth = 15)
  int callframe2799 = gc_frame_new();
// call case 3: self.outer request
  Object call2800 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2799);
// compiled member node returning call2800 (depth = 15)
  params[0] = call2798;
  partcv[0] = 1;
  Object call2801 = callmethodflags(call2800, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2794);
// compiled call node returning call2801 (depth = 14)
    gc_frame_newslot(call2801);
    if2789 = call2801;
  } else {
// Begin line 384
  setline(384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 14)
// Begin line 377
  setline(377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit2804 == NULL) {
    strlit2804 = alloc_String(")");
    gc_root(strlit2804);
  }
// compiled string node returning strlit2804 (depth = 16)
  int op_slot_right_2803 = gc_frame_newslot(strlit2804);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_c (depth = 16)
  int op_slot_left_2803 = gc_frame_newslot(*var_c);
  params[0] = strlit2804;
  partcv[0] = 1;
  Object opresult2806 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult2806 (depth = 15)
  Object if2802 = done;
  if (istrue(opresult2806)) {
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 15)
// starting to compile op node (depth = 16)
// starting to compile block node (depth = 17)
  Object block2809 = alloc_Block(NULL, NULL, "lexer", 378);
  gc_frame_newslot(block2809);
// method "_apply"
  block_savedest(block2809);
  Object closure2810 = createclosure(1, "_apply");
  setclosureframe(closure2810, stackframe);
  addtoclosure(closure2810, selfslot);
  struct UserObject *uo2810 = (struct UserObject*)block2809;
  uo2810->data[0] = (Object)closure2810;
  Method *meth_meth_lexer_2810__apply = addmethod2pos(block2809, "_apply", &meth_lexer_2810__apply, 0);
  int argcv_meth_lexer_2810__apply[] = {0};
  meth_meth_lexer_2810__apply->type = alloc_MethodType(1, argcv_meth_lexer_2810__apply);
  meth_meth_lexer_2810__apply->definitionModule = modulename;
  meth_meth_lexer_2810__apply->definitionLine = 1145;
// compiled block node returning block2809 (depth = 17)
  int op_slot_right_2808 = gc_frame_newslot(block2809);
// starting to compile op node (depth = 17)
// starting to compile num node (depth = 18)
  Object num2826 = alloc_Float64(0);
// compiled num node returning num2826 (depth = 18)
  int op_slot_right_2825 = gc_frame_newslot(num2826);
// starting to compile member node (depth = 18)
  int callframe2828 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 19)
  int callframe2829 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 20)
  int callframe2830 = gc_frame_new();
// call case 3: self.outer request
  Object call2831 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2830);
// compiled member node returning call2831 (depth = 20)
  partcv[0] = 0;
  Object call2832 = callmethodflags(call2831, "tokens", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2829);
// compiled member node returning call2832 (depth = 19)
  partcv[0] = 0;
  Object call2833 = callmethodflags(call2832, "size", 1, partcv, params, 0);
  gc_frame_end(callframe2828);
// compiled member node returning call2833 (depth = 18)
  int op_slot_left_2825 = gc_frame_newslot(call2833);
  params[0] = num2826;
  partcv[0] = 1;
  Object opresult2834 = callmethod(call2833, ">(1)", 1, partcv, params);
// compiled op node returning opresult2834 (depth = 17)
  int op_slot_left_2808 = gc_frame_newslot(opresult2834);
  params[0] = block2809;
  partcv[0] = 1;
  Object opresult2835 = callmethod(opresult2834, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2835 (depth = 16)
  Object if2807 = done;
  if (istrue(opresult2835)) {
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 16)
  int callframe2836 = gc_frame_new();
// starting to compile op node (depth = 17)
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 18)
  if (strlit2838 == NULL) {
    strlit2838 = alloc_String("Remove them, or put something between them.");
    gc_root(strlit2838);
  }
// compiled string node returning strlit2838 (depth = 18)
  int op_slot_right_2837 = gc_frame_newslot(strlit2838);
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 18)
  if (strlit2840 == NULL) {
    strlit2840 = alloc_String("empty parenthesis are not allowed. ");
    gc_root(strlit2840);
  }
// compiled string node returning strlit2840 (depth = 18)
  int op_slot_left_2837 = gc_frame_newslot(strlit2840);
  params[0] = strlit2838;
  partcv[0] = 1;
  Object opresult2841 = callmethod(strlit2840, "++(1)", 1, partcv, params);
// compiled op node returning opresult2841 (depth = 17)
  gc_frame_newslot(opresult2841);
// Begin line 381
  setline(381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 17)
  int callframe2842 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 18)
  int callframe2843 = gc_frame_new();
// call case 3: self.outer request
  Object call2844 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2843);
// compiled member node returning call2844 (depth = 18)
  partcv[0] = 0;
  Object call2845 = callmethodflags(call2844, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2842);
// compiled member node returning call2845 (depth = 17)
  gc_frame_newslot(call2845);
// starting to compile member node (depth = 17)
  int callframe2846 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 18)
  int callframe2847 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 19)
  int callframe2848 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 20)
  int callframe2849 = gc_frame_new();
// call case 3: self.outer request
  Object call2850 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2849);
// compiled member node returning call2850 (depth = 20)
  partcv[0] = 0;
  Object call2851 = callmethodflags(call2850, "tokens", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2848);
// compiled member node returning call2851 (depth = 19)
  partcv[0] = 0;
  Object call2852 = callmethodflags(call2851, "last", 1, partcv, params, 0);
  gc_frame_end(callframe2847);
// compiled member node returning call2852 (depth = 18)
  partcv[0] = 0;
  Object call2853 = callmethodflags(call2852, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2846);
// compiled member node returning call2853 (depth = 17)
  gc_frame_newslot(call2853);
// starting to compile member node (depth = 17)
  int callframe2854 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 18)
  int callframe2855 = gc_frame_new();
// call case 3: self.outer request
  Object call2856 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2855);
// compiled member node returning call2856 (depth = 18)
  partcv[0] = 0;
  Object call2857 = callmethodflags(call2856, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2854);
// compiled member node returning call2857 (depth = 17)
  gc_frame_newslot(call2857);
// call case 6: other requests
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_errormessages (depth = 17)
  params[0] = opresult2841;
  params[1] = call2845;
  params[2] = call2853;
  params[3] = call2857;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call2858 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe2836);
// compiled call node returning call2858 (depth = 16)
    gc_frame_newslot(call2858);
    if2807 = call2858;
  } else {
  }
// compiled if node returning if2807 (depth = 15)
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 15)
  int callframe2859 = gc_frame_new();
// starting to compile member node (depth = 16)
  int callframe2860 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 17)
  int callframe2861 = gc_frame_new();
// call case 3: self.outer request
  Object call2862 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2861);
// compiled member node returning call2862 (depth = 17)
  partcv[0] = 0;
  Object call2863 = callmethodflags(call2862, "rParenToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2860);
// compiled member node returning call2863 (depth = 16)
  gc_frame_newslot(call2863);
// call case 6: other requests
// starting to compile member node (depth = 16)
  int callframe2864 = gc_frame_new();
// call case 3: self.outer request
  Object call2865 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2864);
// compiled member node returning call2865 (depth = 16)
  params[0] = call2863;
  partcv[0] = 1;
  Object call2866 = callmethodflags(call2865, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2859);
// compiled call node returning call2866 (depth = 15)
    gc_frame_newslot(call2866);
    if2802 = call2866;
  } else {
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 15)
// Begin line 384
  setline(384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 16)
// starting to compile string node (depth = 17)
  if (strlit2869 == NULL) {
    strlit2869 = alloc_String("[");
    gc_root(strlit2869);
  }
// compiled string node returning strlit2869 (depth = 17)
  int op_slot_right_2868 = gc_frame_newslot(strlit2869);
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_c (depth = 17)
  int op_slot_left_2868 = gc_frame_newslot(*var_c);
  params[0] = strlit2869;
  partcv[0] = 1;
  Object opresult2871 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult2871 (depth = 16)
  Object if2867 = done;
  if (istrue(opresult2871)) {
// Begin line 385
  setline(385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 16)
  int callframe2872 = gc_frame_new();
// starting to compile member node (depth = 17)
  int callframe2873 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 18)
  int callframe2874 = gc_frame_new();
// call case 3: self.outer request
  Object call2875 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2874);
// compiled member node returning call2875 (depth = 18)
  partcv[0] = 0;
  Object call2876 = callmethodflags(call2875, "lSquareToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2873);
// compiled member node returning call2876 (depth = 17)
  gc_frame_newslot(call2876);
// call case 6: other requests
// starting to compile member node (depth = 17)
  int callframe2877 = gc_frame_new();
// call case 3: self.outer request
  Object call2878 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2877);
// compiled member node returning call2878 (depth = 17)
  params[0] = call2876;
  partcv[0] = 1;
  Object call2879 = callmethodflags(call2878, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2872);
// compiled call node returning call2879 (depth = 16)
    gc_frame_newslot(call2879);
    if2867 = call2879;
  } else {
// Begin line 388
  setline(388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 16)
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 17)
// starting to compile string node (depth = 18)
  if (strlit2882 == NULL) {
    strlit2882 = alloc_String("]");
    gc_root(strlit2882);
  }
// compiled string node returning strlit2882 (depth = 18)
  int op_slot_right_2881 = gc_frame_newslot(strlit2882);
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_c (depth = 18)
  int op_slot_left_2881 = gc_frame_newslot(*var_c);
  params[0] = strlit2882;
  partcv[0] = 1;
  Object opresult2884 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult2884 (depth = 17)
  Object if2880 = done;
  if (istrue(opresult2884)) {
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 17)
  int callframe2885 = gc_frame_new();
// starting to compile member node (depth = 18)
  int callframe2886 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 19)
  int callframe2887 = gc_frame_new();
// call case 3: self.outer request
  Object call2888 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2887);
// compiled member node returning call2888 (depth = 19)
  partcv[0] = 0;
  Object call2889 = callmethodflags(call2888, "rSquareToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2886);
// compiled member node returning call2889 (depth = 18)
  gc_frame_newslot(call2889);
// call case 6: other requests
// starting to compile member node (depth = 18)
  int callframe2890 = gc_frame_new();
// call case 3: self.outer request
  Object call2891 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2890);
// compiled member node returning call2891 (depth = 18)
  params[0] = call2889;
  partcv[0] = 1;
  Object call2892 = callmethodflags(call2891, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2885);
// compiled call node returning call2892 (depth = 17)
    gc_frame_newslot(call2892);
    if2880 = call2892;
  } else {
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 17)
// Begin line 388
  setline(388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 18)
// starting to compile string node (depth = 19)
  if (strlit2895 == NULL) {
    strlit2895 = alloc_String("""\xe2""""\x9f""""\xa6""");
    gc_root(strlit2895);
  }
// compiled string node returning strlit2895 (depth = 19)
  int op_slot_right_2894 = gc_frame_newslot(strlit2895);
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_c (depth = 19)
  int op_slot_left_2894 = gc_frame_newslot(*var_c);
  params[0] = strlit2895;
  partcv[0] = 1;
  Object opresult2897 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult2897 (depth = 18)
  Object if2893 = done;
  if (istrue(opresult2897)) {
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 18)
  int callframe2898 = gc_frame_new();
// starting to compile member node (depth = 19)
  int callframe2899 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 20)
  int callframe2900 = gc_frame_new();
// call case 3: self.outer request
  Object call2901 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2900);
// compiled member node returning call2901 (depth = 20)
  partcv[0] = 0;
  Object call2902 = callmethodflags(call2901, "lGenericToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2899);
// compiled member node returning call2902 (depth = 19)
  gc_frame_newslot(call2902);
// call case 6: other requests
// starting to compile member node (depth = 19)
  int callframe2903 = gc_frame_new();
// call case 3: self.outer request
  Object call2904 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2903);
// compiled member node returning call2904 (depth = 19)
  params[0] = call2902;
  partcv[0] = 1;
  Object call2905 = callmethodflags(call2904, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2898);
// compiled call node returning call2905 (depth = 18)
    gc_frame_newslot(call2905);
    if2893 = call2905;
  } else {
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 18)
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 19)
// starting to compile string node (depth = 20)
  if (strlit2908 == NULL) {
    strlit2908 = alloc_String("""\xe2""""\x9f""""\xa7""");
    gc_root(strlit2908);
  }
// compiled string node returning strlit2908 (depth = 20)
  int op_slot_right_2907 = gc_frame_newslot(strlit2908);
// starting to compile identifier node (depth = 20)
// compiled identifier node returning *var_c (depth = 20)
  int op_slot_left_2907 = gc_frame_newslot(*var_c);
  params[0] = strlit2908;
  partcv[0] = 1;
  Object opresult2910 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult2910 (depth = 19)
  Object if2906 = done;
  if (istrue(opresult2910)) {
// Begin line 391
  setline(391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 19)
  int callframe2911 = gc_frame_new();
// starting to compile member node (depth = 20)
  int callframe2912 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 21)
  int callframe2913 = gc_frame_new();
// call case 3: self.outer request
  Object call2914 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2913);
// compiled member node returning call2914 (depth = 21)
  partcv[0] = 0;
  Object call2915 = callmethodflags(call2914, "rGenericToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2912);
// compiled member node returning call2915 (depth = 20)
  gc_frame_newslot(call2915);
// call case 6: other requests
// starting to compile member node (depth = 20)
  int callframe2916 = gc_frame_new();
// call case 3: self.outer request
  Object call2917 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2916);
// compiled member node returning call2917 (depth = 20)
  params[0] = call2915;
  partcv[0] = 1;
  Object call2918 = callmethodflags(call2917, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2911);
// compiled call node returning call2918 (depth = 19)
    gc_frame_newslot(call2918);
    if2906 = call2918;
  } else {
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 19)
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 20)
// starting to compile string node (depth = 21)
  if (strlit2921 == NULL) {
    strlit2921 = alloc_String(";");
    gc_root(strlit2921);
  }
// compiled string node returning strlit2921 (depth = 21)
  int op_slot_right_2920 = gc_frame_newslot(strlit2921);
// starting to compile identifier node (depth = 21)
// compiled identifier node returning *var_c (depth = 21)
  int op_slot_left_2920 = gc_frame_newslot(*var_c);
  params[0] = strlit2921;
  partcv[0] = 1;
  Object opresult2923 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult2923 (depth = 20)
  Object if2919 = done;
  if (istrue(opresult2923)) {
// Begin line 393
  setline(393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 20)
  int callframe2924 = gc_frame_new();
// starting to compile member node (depth = 21)
  int callframe2925 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 22)
  int callframe2926 = gc_frame_new();
// call case 3: self.outer request
  Object call2927 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2926);
// compiled member node returning call2927 (depth = 22)
  partcv[0] = 0;
  Object call2928 = callmethodflags(call2927, "semicolonToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2925);
// compiled member node returning call2928 (depth = 21)
  gc_frame_newslot(call2928);
// call case 6: other requests
// starting to compile member node (depth = 21)
  int callframe2929 = gc_frame_new();
// call case 3: self.outer request
  Object call2930 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2929);
// compiled member node returning call2930 (depth = 21)
  params[0] = call2928;
  partcv[0] = 1;
  Object call2931 = callmethodflags(call2930, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2924);
// compiled call node returning call2931 (depth = 20)
    gc_frame_newslot(call2931);
    if2919 = call2931;
  } else {
// Begin line 397
  setline(397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 20)
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 21)
// starting to compile string node (depth = 22)
  if (strlit2934 == NULL) {
    strlit2934 = alloc_String("""\x0a""");
    gc_root(strlit2934);
  }
// compiled string node returning strlit2934 (depth = 22)
  int op_slot_right_2933 = gc_frame_newslot(strlit2934);
// starting to compile identifier node (depth = 22)
// compiled identifier node returning *var_c (depth = 22)
  int op_slot_left_2933 = gc_frame_newslot(*var_c);
  params[0] = strlit2934;
  partcv[0] = 1;
  Object opresult2936 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult2936 (depth = 21)
  Object if2932 = done;
  if (istrue(opresult2936)) {
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 21)
  int callframe2937 = gc_frame_new();
// starting to compile num node (depth = 22)
  Object num2938 = alloc_Float64(0);
// compiled num node returning num2938 (depth = 22)
  gc_frame_newslot(num2938);
// call case 6: other requests
// starting to compile member node (depth = 22)
  int callframe2939 = gc_frame_new();
// call case 3: self.outer request
  Object call2940 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2939);
// compiled member node returning call2940 (depth = 22)
  params[0] = num2938;
  partcv[0] = 1;
  Object call2941 = callmethodflags(call2940, "indentLevel:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2937);
// compiled call node returning call2941 (depth = 21)
// Begin line 396
  setline(396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 21)
  int callframe2942 = gc_frame_new();
// starting to compile member node (depth = 22)
  int callframe2943 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 23)
  int callframe2944 = gc_frame_new();
// call case 3: self.outer request
  Object call2945 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2944);
// compiled member node returning call2945 (depth = 23)
  partcv[0] = 0;
  Object call2946 = callmethodflags(call2945, "indentationState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2943);
// compiled member node returning call2946 (depth = 22)
  gc_frame_newslot(call2946);
// call case 6: other requests
// starting to compile member node (depth = 22)
  int callframe2947 = gc_frame_new();
// call case 3: self.outer request
  Object call2948 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2947);
// compiled member node returning call2948 (depth = 22)
  params[0] = call2946;
  partcv[0] = 1;
  Object call2949 = callmethodflags(call2948, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2942);
// compiled call node returning call2949 (depth = 21)
    gc_frame_newslot(call2949);
    if2932 = call2949;
  } else {
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 21)
// starting to compile op node (depth = 22)
// Begin line 402
  setline(402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 23)
// starting to compile num node (depth = 24)
  Object num2953 = alloc_Float64(32);
// compiled num node returning num2953 (depth = 24)
  int op_slot_right_2952 = gc_frame_newslot(num2953);
// starting to compile identifier node (depth = 24)
// compiled identifier node returning *var_ordval (depth = 24)
  int op_slot_left_2952 = gc_frame_newslot(*var_ordval);
  params[0] = num2953;
  partcv[0] = 1;
  Object opresult2955 = callmethod(*var_ordval, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2955 (depth = 23)
  int op_slot_right_2951 = gc_frame_newslot(opresult2955);
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 23)
// Begin line 401
  setline(401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 24)
// starting to compile num node (depth = 25)
  Object num2959 = alloc_Float64(13);
// compiled num node returning num2959 (depth = 25)
  int op_slot_right_2958 = gc_frame_newslot(num2959);
// starting to compile identifier node (depth = 25)
// compiled identifier node returning *var_ordval (depth = 25)
  int op_slot_left_2958 = gc_frame_newslot(*var_ordval);
  params[0] = num2959;
  partcv[0] = 1;
  Object opresult2961 = callmethod(*var_ordval, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2961 (depth = 24)
  int op_slot_right_2957 = gc_frame_newslot(opresult2961);
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 24)
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 25)
// starting to compile num node (depth = 26)
  Object num2965 = alloc_Float64(10);
// compiled num node returning num2965 (depth = 26)
  int op_slot_right_2964 = gc_frame_newslot(num2965);
// starting to compile identifier node (depth = 26)
// compiled identifier node returning *var_ordval (depth = 26)
  int op_slot_left_2964 = gc_frame_newslot(*var_ordval);
  params[0] = num2965;
  partcv[0] = 1;
  Object opresult2967 = callmethod(*var_ordval, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2967 (depth = 25)
  int op_slot_right_2963 = gc_frame_newslot(opresult2967);
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 25)
// Begin line 399
  setline(399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 26)
  int callframe2970 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 27)
  int callframe2971 = gc_frame_new();
// starting to compile identifier node (depth = 28)
// compiled identifier node returning *var_ordval (depth = 28)
  gc_frame_newslot(*var_ordval);
// call case 6: other requests
// starting to compile identifier node (depth = 28)
// compiled identifier node returning *var_unicode (depth = 28)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2972 = callmethodflags(*var_unicode, "isControl(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2971);
// compiled call node returning call2972 (depth = 27)
  partcv[0] = 0;
  Object call2973 = callmethodflags(call2972, "not", 1, partcv, params, 0);
  gc_frame_end(callframe2970);
// compiled member node returning call2973 (depth = 26)
  int op_slot_right_2969 = gc_frame_newslot(call2973);
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 26)
  int callframe2975 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 27)
  int callframe2976 = gc_frame_new();
// starting to compile identifier node (depth = 28)
// compiled identifier node returning *var_ordval (depth = 28)
  gc_frame_newslot(*var_ordval);
// call case 6: other requests
// starting to compile identifier node (depth = 28)
// compiled identifier node returning *var_unicode (depth = 28)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2977 = callmethodflags(*var_unicode, "isSeparator(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2976);
// compiled call node returning call2977 (depth = 27)
  partcv[0] = 0;
  Object call2978 = callmethodflags(call2977, "not", 1, partcv, params, 0);
  gc_frame_end(callframe2975);
// compiled member node returning call2978 (depth = 26)
  int op_slot_left_2969 = gc_frame_newslot(call2978);
  params[0] = call2973;
  partcv[0] = 1;
  Object opresult2979 = callmethod(call2978, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2979 (depth = 25)
  int op_slot_left_2963 = gc_frame_newslot(opresult2979);
  params[0] = opresult2967;
  partcv[0] = 1;
  Object opresult2980 = callmethod(opresult2979, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2980 (depth = 24)
  int op_slot_left_2957 = gc_frame_newslot(opresult2980);
  params[0] = opresult2961;
  partcv[0] = 1;
  Object opresult2981 = callmethod(opresult2980, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2981 (depth = 23)
  int op_slot_left_2951 = gc_frame_newslot(opresult2981);
  params[0] = opresult2955;
  partcv[0] = 1;
  Object opresult2982 = callmethod(opresult2981, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2982 (depth = 22)
  Object if2950 = done;
  if (istrue(opresult2982)) {
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 22)
  int callframe2983 = gc_frame_new();
// starting to compile op node (depth = 23)
// Begin line 404
  setline(404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 24)
  if (strlit2985 == NULL) {
    strlit2985 = alloc_String("is not a valid character; use spaces instead.");
    gc_root(strlit2985);
  }
// compiled string node returning strlit2985 (depth = 24)
  int op_slot_right_2984 = gc_frame_newslot(strlit2985);
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 24)
// starting to compile string node (depth = 25)
  if (strlit2988 == NULL) {
    strlit2988 = alloc_String(") ");
    gc_root(strlit2988);
  }
// compiled string node returning strlit2988 (depth = 25)
  int op_slot_right_2987 = gc_frame_newslot(strlit2988);
// starting to compile op node (depth = 25)
// starting to compile call node (depth = 26)
  int callframe2991 = gc_frame_new();
// starting to compile call node (depth = 27)
  int callframe2992 = gc_frame_new();
// starting to compile num node (depth = 28)
  Object num2993 = alloc_Float64(16);
// compiled num node returning num2993 (depth = 28)
  gc_frame_newslot(num2993);
// call case 6: other requests
// starting to compile identifier node (depth = 28)
// compiled identifier node returning *var_ordval (depth = 28)
  params[0] = num2993;
  partcv[0] = 1;
  Object call2994 = callmethodflags(*var_ordval, "inBase(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2992);
// compiled call node returning call2994 (depth = 27)
  gc_frame_newslot(call2994);
// starting to compile num node (depth = 27)
  Object num2995 = alloc_Float64(4);
// compiled num node returning num2995 (depth = 27)
  gc_frame_newslot(num2995);
// starting to compile string node (depth = 27)
  if (strlit2996 == NULL) {
    strlit2996 = alloc_String("0");
    gc_root(strlit2996);
  }
// compiled string node returning strlit2996 (depth = 27)
  gc_frame_newslot(strlit2996);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 27)
// compiled identifier node returning module_lexer (depth = 27)
  params[0] = call2994;
  params[1] = num2995;
  params[2] = strlit2996;
  partcv[0] = 3;
  Object call2997 = callmethodflags(module_lexer, "padl(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2991);
// compiled call node returning call2997 (depth = 26)
  int op_slot_right_2990 = gc_frame_newslot(call2997);
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 26)
// starting to compile string node (depth = 27)
  if (strlit3000 == NULL) {
    strlit3000 = alloc_String(" (U+");
    gc_root(strlit3000);
  }
// compiled string node returning strlit3000 (depth = 27)
  int op_slot_right_2999 = gc_frame_newslot(strlit3000);
// starting to compile op node (depth = 27)
// starting to compile call node (depth = 28)
  int callframe3003 = gc_frame_new();
// starting to compile identifier node (depth = 29)
// compiled identifier node returning *var_c (depth = 29)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile identifier node (depth = 29)
// compiled identifier node returning *var_unicode (depth = 29)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3004 = callmethodflags(*var_unicode, "name(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3003);
// compiled call node returning call3004 (depth = 28)
  int op_slot_right_3002 = gc_frame_newslot(call3004);
// starting to compile string node (depth = 28)
  if (strlit3006 == NULL) {
    strlit3006 = alloc_String("");
    gc_root(strlit3006);
  }
// compiled string node returning strlit3006 (depth = 28)
  int op_slot_left_3002 = gc_frame_newslot(strlit3006);
  params[0] = call3004;
  partcv[0] = 1;
  Object opresult3007 = callmethod(strlit3006, "++(1)", 1, partcv, params);
// compiled op node returning opresult3007 (depth = 27)
  int op_slot_left_2999 = gc_frame_newslot(opresult3007);
  params[0] = strlit3000;
  partcv[0] = 1;
  Object opresult3008 = callmethod(opresult3007, "++(1)", 1, partcv, params);
// compiled op node returning opresult3008 (depth = 26)
  int op_slot_left_2990 = gc_frame_newslot(opresult3008);
  params[0] = call2997;
  partcv[0] = 1;
  Object opresult3009 = callmethod(opresult3008, "++(1)", 1, partcv, params);
// compiled op node returning opresult3009 (depth = 25)
  int op_slot_left_2987 = gc_frame_newslot(opresult3009);
  params[0] = strlit2988;
  partcv[0] = 1;
  Object opresult3010 = callmethod(opresult3009, "++(1)", 1, partcv, params);
// compiled op node returning opresult3010 (depth = 24)
  int op_slot_left_2984 = gc_frame_newslot(opresult3010);
  params[0] = strlit2985;
  partcv[0] = 1;
  Object opresult3011 = callmethod(opresult3010, "++(1)", 1, partcv, params);
// compiled op node returning opresult3011 (depth = 23)
  gc_frame_newslot(opresult3011);
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 23)
  int callframe3012 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 24)
  int callframe3013 = gc_frame_new();
// call case 3: self.outer request
  Object call3014 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3013);
// compiled member node returning call3014 (depth = 24)
  partcv[0] = 0;
  Object call3015 = callmethodflags(call3014, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3012);
// compiled member node returning call3015 (depth = 23)
  gc_frame_newslot(call3015);
// starting to compile member node (depth = 23)
  int callframe3016 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 24)
  int callframe3017 = gc_frame_new();
// call case 3: self.outer request
  Object call3018 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3017);
// compiled member node returning call3018 (depth = 24)
  partcv[0] = 0;
  Object call3019 = callmethodflags(call3018, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3016);
// compiled member node returning call3019 (depth = 23)
  gc_frame_newslot(call3019);
// starting to compile member node (depth = 23)
  int callframe3020 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 24)
  int callframe3021 = gc_frame_new();
// call case 3: self.outer request
  Object call3022 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3021);
// compiled member node returning call3022 (depth = 24)
  partcv[0] = 0;
  Object call3023 = callmethodflags(call3022, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3020);
// compiled member node returning call3023 (depth = 23)
  gc_frame_newslot(call3023);
// call case 6: other requests
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 23)
// compiled identifier node returning *var_errormessages (depth = 23)
  params[0] = opresult3011;
  params[1] = call3015;
  params[2] = call3019;
  params[3] = call3023;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call3024 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe2983);
// compiled call node returning call3024 (depth = 22)
    gc_frame_newslot(call3024);
    if2950 = call3024;
  } else {
  }
// compiled if node returning if2950 (depth = 21)
    gc_frame_newslot(if2950);
    if2932 = if2950;
  }
// compiled if node returning if2932 (depth = 20)
    gc_frame_newslot(if2932);
    if2919 = if2932;
  }
// compiled if node returning if2919 (depth = 19)
    gc_frame_newslot(if2919);
    if2906 = if2919;
  }
// compiled if node returning if2906 (depth = 18)
    gc_frame_newslot(if2906);
    if2893 = if2906;
  }
// compiled if node returning if2893 (depth = 17)
    gc_frame_newslot(if2893);
    if2880 = if2893;
  }
// compiled if node returning if2880 (depth = 16)
    gc_frame_newslot(if2880);
    if2867 = if2880;
  }
// compiled if node returning if2867 (depth = 15)
    gc_frame_newslot(if2867);
    if2802 = if2867;
  }
// compiled if node returning if2802 (depth = 14)
    gc_frame_newslot(if2802);
    if2789 = if2802;
  }
// compiled if node returning if2789 (depth = 13)
    gc_frame_newslot(if2789);
    if2770 = if2789;
  }
// compiled if node returning if2770 (depth = 12)
    gc_frame_newslot(if2770);
    if2757 = if2770;
  }
// compiled if node returning if2757 (depth = 11)
    gc_frame_newslot(if2757);
    if2744 = if2757;
  }
// compiled if node returning if2744 (depth = 10)
    gc_frame_newslot(if2744);
    if2720 = if2744;
  }
// compiled if node returning if2720 (depth = 9)
    gc_frame_newslot(if2720);
    if2701 = if2720;
  }
// compiled if node returning if2701 (depth = 8)
    gc_frame_newslot(if2701);
    if2682 = if2701;
  }
// compiled if node returning if2682 (depth = 7)
    gc_frame_newslot(if2682);
    if2665 = if2682;
  }
// compiled if node returning if2665 (depth = 6)
    gc_frame_newslot(if2665);
    if2555 = if2665;
  }
// compiled if node returning if2555 (depth = 5)
    gc_frame_newslot(if2555);
    if2529 = if2555;
  }
// compiled if node returning if2529 (depth = 4)
    gc_frame_newslot(if2529);
    if2503 = if2529;
  }
// compiled if node returning if2503 (depth = 3)
    gc_frame_newslot(if2503);
    if2500 = if2503;
  }
// compiled if node returning if2500 (depth = 2)
  gc_frame_end(frame);
  return if2500;
}
Object meth_lexer_3027_consume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "consume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method consume(_)");
  Object params[5];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for consume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part consume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion1 = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion1");
  Object *var_suggestion2 = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion2");
// definebindings:
// definebindings:
// Begin line 413
  setline(413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3030 = alloc_Float64(0);
// compiled num node returning num3030 (depth = 4)
  int op_slot_right_3029 = gc_frame_newslot(num3030);
// starting to compile member node (depth = 4)
  int callframe3032 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3033 = gc_frame_new();
// call case 3: self.outer request
  Object call3034 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3033);
// compiled member node returning call3034 (depth = 5)
  partcv[0] = 0;
  Object call3035 = callmethodflags(call3034, "interpdepth", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3032);
// compiled member node returning call3035 (depth = 4)
  int op_slot_left_3029 = gc_frame_newslot(call3035);
  params[0] = num3030;
  partcv[0] = 1;
  Object opresult3036 = callmethod(call3035, ">(1)", 1, partcv, params);
// compiled op node returning opresult3036 (depth = 3)
  Object if3028 = done;
  if (istrue(opresult3036)) {
// Begin line 414
  setline(414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3039 == NULL) {
    strlit3039 = alloc_String("lparen");
    gc_root(strlit3039);
  }
// compiled string node returning strlit3039 (depth = 5)
  int op_slot_right_3038 = gc_frame_newslot(strlit3039);
// starting to compile member node (depth = 5)
  int callframe3041 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3042 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3043 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3044 = gc_frame_new();
// call case 3: self.outer request
  Object call3045 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3044);
// compiled member node returning call3045 (depth = 8)
  partcv[0] = 0;
  Object call3046 = callmethodflags(call3045, "tokens", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3043);
// compiled member node returning call3046 (depth = 7)
  partcv[0] = 0;
  Object call3047 = callmethodflags(call3046, "last", 1, partcv, params, 0);
  gc_frame_end(callframe3042);
// compiled member node returning call3047 (depth = 6)
  partcv[0] = 0;
  Object call3048 = callmethodflags(call3047, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe3041);
// compiled member node returning call3048 (depth = 5)
  int op_slot_left_3038 = gc_frame_newslot(call3048);
  params[0] = strlit3039;
  partcv[0] = 1;
  Object opresult3049 = callmethod(call3048, "==(1)", 1, partcv, params);
// compiled op node returning opresult3049 (depth = 4)
  Object if3037 = done;
  if (istrue(opresult3049)) {
// Begin line 415
  setline(415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3050 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3051 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call3052 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe3051);
// compiled member node returning call3052 (depth = 6)
  partcv[0] = 0;
  Object call3053 = callmethodflags(call3052, "new", 1, partcv, params, 0);
  gc_frame_end(callframe3050);
// compiled member node returning call3053 (depth = 5)
  *var_suggestion1 = call3053;
  if (call3053 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3054 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3055 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3056 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3057 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3058 = gc_frame_new();
// call case 3: self.outer request
  Object call3059 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3058);
// compiled member node returning call3059 (depth = 8)
  partcv[0] = 0;
  Object call3060 = callmethodflags(call3059, "tokens", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3057);
// compiled member node returning call3060 (depth = 7)
  partcv[0] = 0;
  Object call3061 = callmethodflags(call3060, "last", 1, partcv, params, 0);
  gc_frame_end(callframe3056);
// compiled member node returning call3061 (depth = 6)
  partcv[0] = 0;
  Object call3062 = callmethodflags(call3061, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe3055);
// compiled member node returning call3062 (depth = 5)
  gc_frame_newslot(call3062);
// starting to compile member node (depth = 5)
  int callframe3063 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3064 = gc_frame_new();
// call case 3: self.outer request
  Object call3065 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3064);
// compiled member node returning call3065 (depth = 6)
  partcv[0] = 0;
  Object call3066 = callmethodflags(call3065, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3063);
// compiled member node returning call3066 (depth = 5)
  gc_frame_newslot(call3066);
// Begin line 417
  setline(417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3067 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3068 = gc_frame_new();
// call case 3: self.outer request
  Object call3069 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3068);
// compiled member node returning call3069 (depth = 6)
  partcv[0] = 0;
  Object call3070 = callmethodflags(call3069, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3067);
// compiled member node returning call3070 (depth = 5)
  gc_frame_newslot(call3070);
// call case 6: other requests
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion1 (depth = 5)
  params[0] = call3062;
  params[1] = call3066;
  params[2] = call3070;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3071 = callmethodflags(*var_suggestion1, "deleteRange(2)onLine(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3054);
// compiled call node returning call3071 (depth = 4)
// Begin line 418
  setline(418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3072 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3073 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call3074 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe3073);
// compiled member node returning call3074 (depth = 6)
  partcv[0] = 0;
  Object call3075 = callmethodflags(call3074, "new", 1, partcv, params, 0);
  gc_frame_end(callframe3072);
// compiled member node returning call3075 (depth = 5)
  *var_suggestion2 = call3075;
  if (call3075 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3076 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3077 == NULL) {
    strlit3077 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3077);
  }
// compiled string node returning strlit3077 (depth = 5)
  gc_frame_newslot(strlit3077);
// Begin line 420
  setline(420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3079 = alloc_Float64(1);
// compiled num node returning num3079 (depth = 6)
  int op_slot_right_3078 = gc_frame_newslot(num3079);
// starting to compile member node (depth = 6)
  int callframe3081 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3082 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3083 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe3084 = gc_frame_new();
// call case 3: self.outer request
  Object call3085 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3084);
// compiled member node returning call3085 (depth = 9)
  partcv[0] = 0;
  Object call3086 = callmethodflags(call3085, "tokens", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3083);
// compiled member node returning call3086 (depth = 8)
  partcv[0] = 0;
  Object call3087 = callmethodflags(call3086, "last", 1, partcv, params, 0);
  gc_frame_end(callframe3082);
// compiled member node returning call3087 (depth = 7)
  partcv[0] = 0;
  Object call3088 = callmethodflags(call3087, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe3081);
// compiled member node returning call3088 (depth = 6)
  int op_slot_left_3078 = gc_frame_newslot(call3088);
  params[0] = num3079;
  partcv[0] = 1;
  Object sum3089 = callmethod(call3088, "+(1)", 1, partcv, params);
// compiled op node returning sum3089 (depth = 5)
  gc_frame_newslot(sum3089);
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3090 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3091 = gc_frame_new();
// call case 3: self.outer request
  Object call3092 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3091);
// compiled member node returning call3092 (depth = 6)
  partcv[0] = 0;
  Object call3093 = callmethodflags(call3092, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3090);
// compiled member node returning call3093 (depth = 5)
  gc_frame_newslot(call3093);
// call case 6: other requests
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion2 (depth = 5)
  params[0] = strlit3077;
  params[1] = sum3089;
  params[2] = call3093;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3094 = callmethodflags(*var_suggestion2, "insert(1)atPosition(1)onLine(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3076);
// compiled call node returning call3094 (depth = 4)
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3095 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3096 == NULL) {
    strlit3096 = alloc_String("a string interpolation cannot be empty.");
    gc_root(strlit3096);
  }
// compiled string node returning strlit3096 (depth = 5)
  gc_frame_newslot(strlit3096);
// Begin line 423
  setline(423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3097 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3098 = gc_frame_new();
// call case 3: self.outer request
  Object call3099 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3098);
// compiled member node returning call3099 (depth = 6)
  partcv[0] = 0;
  Object call3100 = callmethodflags(call3099, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3097);
// compiled member node returning call3100 (depth = 5)
  gc_frame_newslot(call3100);
// starting to compile member node (depth = 5)
  int callframe3101 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3102 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3103 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3104 = gc_frame_new();
// call case 3: self.outer request
  Object call3105 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3104);
// compiled member node returning call3105 (depth = 8)
  partcv[0] = 0;
  Object call3106 = callmethodflags(call3105, "tokens", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3103);
// compiled member node returning call3106 (depth = 7)
  partcv[0] = 0;
  Object call3107 = callmethodflags(call3106, "last", 1, partcv, params, 0);
  gc_frame_end(callframe3102);
// compiled member node returning call3107 (depth = 6)
  partcv[0] = 0;
  Object call3108 = callmethodflags(call3107, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe3101);
// compiled member node returning call3108 (depth = 5)
  gc_frame_newslot(call3108);
// starting to compile member node (depth = 5)
  int callframe3109 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3110 = gc_frame_new();
// call case 3: self.outer request
  Object call3111 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3110);
// compiled member node returning call3111 (depth = 6)
  partcv[0] = 0;
  Object call3112 = callmethodflags(call3111, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3109);
// compiled member node returning call3112 (depth = 5)
  gc_frame_newslot(call3112);
// Begin line 424
  setline(424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 5)
  Object array3113 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion1 (depth = 6)
  params[0] = *var_suggestion1;
  partcv[0] = 1;
  callmethodflags(array3113, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion2 (depth = 6)
  params[0] = *var_suggestion2;
  partcv[0] = 1;
  callmethodflags(array3113, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3113 (depth = 5)
  gc_frame_newslot(array3113);
// call case 6: other requests
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3096;
  params[1] = call3100;
  params[2] = call3108;
  params[3] = call3112;
  params[4] = array3113;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call3114 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3095);
// compiled call node returning call3114 (depth = 4)
    gc_frame_newslot(call3114);
    if3037 = call3114;
  } else {
  }
// compiled if node returning if3037 (depth = 3)
// Begin line 426
  setline(426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3115 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3116 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3117 = gc_frame_new();
// call case 3: self.outer request
  Object call3118 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3117);
// compiled member node returning call3118 (depth = 5)
  partcv[0] = 0;
  Object call3119 = callmethodflags(call3118, "rParenToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3116);
// compiled member node returning call3119 (depth = 4)
  gc_frame_newslot(call3119);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3120 = gc_frame_new();
// call case 3: self.outer request
  Object call3121 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3120);
// compiled member node returning call3121 (depth = 4)
  params[0] = call3119;
  partcv[0] = 1;
  Object call3122 = callmethodflags(call3121, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3115);
// compiled call node returning call3122 (depth = 3)
// Begin line 427
  setline(427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3123 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3124 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3125 == NULL) {
    strlit3125 = alloc_String("++");
    gc_root(strlit3125);
  }
// compiled string node returning strlit3125 (depth = 5)
  gc_frame_newslot(strlit3125);
// call case 6: other requests
// Begin line 426
  setline(426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3126 = gc_frame_new();
// call case 3: self.outer request
  Object call3127 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3126);
// compiled member node returning call3127 (depth = 5)
  params[0] = strlit3125;
  partcv[0] = 1;
  Object call3128 = callmethodflags(call3127, "opToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3124);
// compiled call node returning call3128 (depth = 4)
  gc_frame_newslot(call3128);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3129 = gc_frame_new();
// call case 3: self.outer request
  Object call3130 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3129);
// compiled member node returning call3130 (depth = 4)
  params[0] = call3128;
  partcv[0] = 1;
  Object call3131 = callmethodflags(call3130, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3123);
// compiled call node returning call3131 (depth = 3)
// Begin line 428
  setline(428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3132 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3134 = alloc_Float64(1);
// compiled num node returning num3134 (depth = 5)
  int op_slot_right_3133 = gc_frame_newslot(num3134);
// starting to compile member node (depth = 5)
  int callframe3136 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3137 = gc_frame_new();
// call case 3: self.outer request
  Object call3138 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3137);
// compiled member node returning call3138 (depth = 6)
  partcv[0] = 0;
  Object call3139 = callmethodflags(call3138, "interpdepth", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3136);
// compiled member node returning call3139 (depth = 5)
  int op_slot_left_3133 = gc_frame_newslot(call3139);
  params[0] = num3134;
  partcv[0] = 1;
  Object diff3140 = callmethod(call3139, "-(1)", 1, partcv, params);
// compiled op node returning diff3140 (depth = 4)
  gc_frame_newslot(diff3140);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3141 = gc_frame_new();
// call case 3: self.outer request
  Object call3142 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3141);
// compiled member node returning call3142 (depth = 4)
  params[0] = diff3140;
  partcv[0] = 1;
  Object call3143 = callmethodflags(call3142, "interpdepth:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3132);
// compiled call node returning call3143 (depth = 3)
// Begin line 429
  setline(429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3144 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool3145 = alloc_Boolean(1);
// compiled identifier node returning bool3145 (depth = 4)
  gc_frame_newslot(bool3145);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3146 = gc_frame_new();
// call case 3: self.outer request
  Object call3147 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3146);
// compiled member node returning call3147 (depth = 4)
  params[0] = bool3145;
  partcv[0] = 1;
  Object call3148 = callmethodflags(call3147, "inStr:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3144);
// compiled call node returning call3148 (depth = 3)
// Begin line 430
  setline(430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3149 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3150 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3151 = gc_frame_new();
// call case 3: self.outer request
  Object call3152 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3151);
// compiled member node returning call3152 (depth = 5)
  partcv[0] = 0;
  Object call3153 = callmethodflags(call3152, "quotedStringState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3150);
// compiled member node returning call3153 (depth = 4)
  gc_frame_newslot(call3153);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3154 = gc_frame_new();
// call case 3: self.outer request
  Object call3155 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3154);
// compiled member node returning call3155 (depth = 4)
  params[0] = call3153;
  partcv[0] = 1;
  Object call3156 = callmethodflags(call3155, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3149);
// compiled call node returning call3156 (depth = 3)
    gc_frame_newslot(call3156);
    if3028 = call3156;
  } else {
// Begin line 432
  setline(432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3157 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3158 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3159 = gc_frame_new();
// call case 3: self.outer request
  Object call3160 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3159);
// compiled member node returning call3160 (depth = 5)
  partcv[0] = 0;
  Object call3161 = callmethodflags(call3160, "rBraceToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3158);
// compiled member node returning call3161 (depth = 4)
  gc_frame_newslot(call3161);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3162 = gc_frame_new();
// call case 3: self.outer request
  Object call3163 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3162);
// compiled member node returning call3163 (depth = 4)
  params[0] = call3161;
  partcv[0] = 1;
  Object call3164 = callmethodflags(call3163, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3157);
// compiled call node returning call3164 (depth = 3)
// Begin line 433
  setline(433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3165 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3166 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3167 = gc_frame_new();
// call case 3: self.outer request
  Object call3168 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3167);
// compiled member node returning call3168 (depth = 5)
  partcv[0] = 0;
  Object call3169 = callmethodflags(call3168, "defaultState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3166);
// compiled member node returning call3169 (depth = 4)
  gc_frame_newslot(call3169);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3170 = gc_frame_new();
// call case 3: self.outer request
  Object call3171 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3170);
// compiled member node returning call3171 (depth = 4)
  params[0] = call3169;
  partcv[0] = 1;
  Object call3172 = callmethodflags(call3171, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3165);
// compiled call node returning call3172 (depth = 3)
    gc_frame_newslot(call3172);
    if3028 = call3172;
  }
// compiled if node returning if3028 (depth = 2)
  gc_frame_end(frame);
  return if3028;
}
Object meth_lexer_3175_consume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "consume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method consume(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for consume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part consume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 440
  setline(440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3176 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3177 = gc_frame_new();
// call case 3: self.outer request
  Object call3178 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3177);
// compiled member node returning call3178 (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3179 = callmethodflags(call3178, "checkSeparator(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3176);
// compiled call node returning call3179 (depth = 2)
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3182 == NULL) {
    strlit3182 = alloc_String("/");
    gc_root(strlit3182);
  }
// compiled string node returning strlit3182 (depth = 4)
  int op_slot_right_3181 = gc_frame_newslot(strlit3182);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_left_3181 = gc_frame_newslot(*var_c);
  params[0] = strlit3182;
  partcv[0] = 1;
  Object opresult3184 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult3184 (depth = 3)
  Object if3180 = done;
  if (istrue(opresult3184)) {
// Begin line 442
  setline(442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3185 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3186 = gc_frame_new();
// call case 3: self.outer request
  Object call3187 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3186);
// compiled member node returning call3187 (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3188 = callmethodflags(call3187, "store(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3185);
// compiled call node returning call3188 (depth = 3)
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3191 == NULL) {
    strlit3191 = alloc_String("//");
    gc_root(strlit3191);
  }
// compiled string node returning strlit3191 (depth = 5)
  int op_slot_right_3190 = gc_frame_newslot(strlit3191);
// starting to compile member node (depth = 5)
  int callframe3193 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3194 = gc_frame_new();
// call case 3: self.outer request
  Object call3195 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3194);
// compiled member node returning call3195 (depth = 6)
  partcv[0] = 0;
  Object call3196 = callmethodflags(call3195, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3193);
// compiled member node returning call3196 (depth = 5)
  int op_slot_left_3190 = gc_frame_newslot(call3196);
  params[0] = strlit3191;
  partcv[0] = 1;
  Object opresult3197 = callmethod(call3196, "==(1)", 1, partcv, params);
// compiled op node returning opresult3197 (depth = 4)
  Object if3189 = done;
  if (istrue(opresult3197)) {
// Begin line 444
  setline(444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3198 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3199 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3200 = gc_frame_new();
// call case 3: self.outer request
  Object call3201 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3200);
// compiled member node returning call3201 (depth = 6)
  partcv[0] = 0;
  Object call3202 = callmethodflags(call3201, "commentSpaceState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3199);
// compiled member node returning call3202 (depth = 5)
  gc_frame_newslot(call3202);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3203 = gc_frame_new();
// call case 3: self.outer request
  Object call3204 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3203);
// compiled member node returning call3204 (depth = 5)
  params[0] = call3202;
  partcv[0] = 1;
  Object call3205 = callmethodflags(call3204, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3198);
// compiled call node returning call3205 (depth = 4)
    gc_frame_newslot(call3205);
    if3189 = call3205;
  } else {
  }
// compiled if node returning if3189 (depth = 3)
    gc_frame_newslot(if3189);
    if3180 = if3189;
  } else {
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 446
  setline(446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3208 == NULL) {
    strlit3208 = alloc_String("/");
    gc_root(strlit3208);
  }
// compiled string node returning strlit3208 (depth = 5)
  int op_slot_right_3207 = gc_frame_newslot(strlit3208);
// starting to compile member node (depth = 5)
  int callframe3210 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3211 = gc_frame_new();
// call case 3: self.outer request
  Object call3212 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3211);
// compiled member node returning call3212 (depth = 6)
  partcv[0] = 0;
  Object call3213 = callmethodflags(call3212, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3210);
// compiled member node returning call3213 (depth = 5)
  int op_slot_left_3207 = gc_frame_newslot(call3213);
  params[0] = strlit3208;
  partcv[0] = 1;
  Object opresult3214 = callmethod(call3213, "==(1)", 1, partcv, params);
// compiled op node returning opresult3214 (depth = 4)
  Object if3206 = done;
  if (istrue(opresult3214)) {
// Begin line 447
  setline(447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3215 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3216 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3217 = gc_frame_new();
// call case 3: self.outer request
  Object call3218 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3217);
// compiled member node returning call3218 (depth = 6)
  partcv[0] = 0;
  Object call3219 = callmethodflags(call3218, "operatorState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3216);
// compiled member node returning call3219 (depth = 5)
  gc_frame_newslot(call3219);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3220 = gc_frame_new();
// call case 3: self.outer request
  Object call3221 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3220);
// compiled member node returning call3221 (depth = 5)
  params[0] = call3219;
  partcv[0] = 1;
  Object call3222 = callmethodflags(call3221, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3215);
// compiled call node returning call3222 (depth = 4)
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3223 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3224 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3225 = gc_frame_new();
// call case 3: self.outer request
  Object call3226 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3225);
// compiled member node returning call3226 (depth = 6)
  partcv[0] = 0;
  Object call3227 = callmethodflags(call3226, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3224);
// compiled member node returning call3227 (depth = 5)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3228 = callmethodflags(call3227, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3223);
// compiled call node returning call3228 (depth = 4)
    gc_frame_newslot(call3228);
    if3206 = call3228;
  } else {
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3229 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3230 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3231 = gc_frame_new();
// call case 3: self.outer request
  Object call3232 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3231);
// compiled member node returning call3232 (depth = 6)
  partcv[0] = 0;
  Object call3233 = callmethodflags(call3232, "defaultState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3230);
// compiled member node returning call3233 (depth = 5)
  gc_frame_newslot(call3233);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3234 = gc_frame_new();
// call case 3: self.outer request
  Object call3235 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3234);
// compiled member node returning call3235 (depth = 5)
  params[0] = call3233;
  partcv[0] = 1;
  Object call3236 = callmethodflags(call3235, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3229);
// compiled call node returning call3236 (depth = 4)
// Begin line 451
  setline(451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3237 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3238 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3239 = gc_frame_new();
// call case 3: self.outer request
  Object call3240 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3239);
// compiled member node returning call3240 (depth = 6)
  partcv[0] = 0;
  Object call3241 = callmethodflags(call3240, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3238);
// compiled member node returning call3241 (depth = 5)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3242 = callmethodflags(call3241, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3237);
// compiled call node returning call3242 (depth = 4)
    gc_frame_newslot(call3242);
    if3206 = call3242;
  }
// compiled if node returning if3206 (depth = 3)
    gc_frame_newslot(if3206);
    if3180 = if3206;
  }
// compiled if node returning if3180 (depth = 2)
  gc_frame_end(frame);
  return if3180;
}
Object meth_lexer_3245_consume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "consume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method consume(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for consume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part consume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3246 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3247 = gc_frame_new();
// call case 3: self.outer request
  Object call3248 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3247);
// compiled member node returning call3248 (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3249 = callmethodflags(call3248, "checkSeparator(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3246);
// compiled call node returning call3249 (depth = 2)
// Begin line 459
  setline(459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3252 == NULL) {
    strlit3252 = alloc_String(".");
    gc_root(strlit3252);
  }
// compiled string node returning strlit3252 (depth = 4)
  int op_slot_right_3251 = gc_frame_newslot(strlit3252);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_left_3251 = gc_frame_newslot(*var_c);
  params[0] = strlit3252;
  partcv[0] = 1;
  Object opresult3254 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult3254 (depth = 3)
  Object if3250 = done;
  if (istrue(opresult3254)) {
// Begin line 460
  setline(460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3255 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3256 = gc_frame_new();
// call case 3: self.outer request
  Object call3257 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3256);
// compiled member node returning call3257 (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3258 = callmethodflags(call3257, "store(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3255);
// compiled call node returning call3258 (depth = 3)
// Begin line 461
  setline(461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3261 == NULL) {
    strlit3261 = alloc_String("...");
    gc_root(strlit3261);
  }
// compiled string node returning strlit3261 (depth = 5)
  int op_slot_right_3260 = gc_frame_newslot(strlit3261);
// starting to compile member node (depth = 5)
  int callframe3263 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3264 = gc_frame_new();
// call case 3: self.outer request
  Object call3265 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3264);
// compiled member node returning call3265 (depth = 6)
  partcv[0] = 0;
  Object call3266 = callmethodflags(call3265, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3263);
// compiled member node returning call3266 (depth = 5)
  int op_slot_left_3260 = gc_frame_newslot(call3266);
  params[0] = strlit3261;
  partcv[0] = 1;
  Object opresult3267 = callmethod(call3266, "==(1)", 1, partcv, params);
// compiled op node returning opresult3267 (depth = 4)
  Object if3259 = done;
  if (istrue(opresult3267)) {
// Begin line 462
  setline(462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3268 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3269 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3270 = gc_frame_new();
// call case 3: self.outer request
  Object call3271 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3270);
// compiled member node returning call3271 (depth = 6)
  partcv[0] = 0;
  Object call3272 = callmethodflags(call3271, "identifierState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3269);
// compiled member node returning call3272 (depth = 5)
  gc_frame_newslot(call3272);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3273 = gc_frame_new();
// call case 3: self.outer request
  Object call3274 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3273);
// compiled member node returning call3274 (depth = 5)
  params[0] = call3272;
  partcv[0] = 1;
  Object call3275 = callmethodflags(call3274, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3268);
// compiled call node returning call3275 (depth = 4)
    gc_frame_newslot(call3275);
    if3259 = call3275;
  } else {
  }
// compiled if node returning if3259 (depth = 3)
    gc_frame_newslot(if3259);
    if3250 = if3259;
  } else {
// Begin line 467
  setline(467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 464
  setline(464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3278 == NULL) {
    strlit3278 = alloc_String("..");
    gc_root(strlit3278);
  }
// compiled string node returning strlit3278 (depth = 5)
  int op_slot_right_3277 = gc_frame_newslot(strlit3278);
// starting to compile member node (depth = 5)
  int callframe3280 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3281 = gc_frame_new();
// call case 3: self.outer request
  Object call3282 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3281);
// compiled member node returning call3282 (depth = 6)
  partcv[0] = 0;
  Object call3283 = callmethodflags(call3282, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3280);
// compiled member node returning call3283 (depth = 5)
  int op_slot_left_3277 = gc_frame_newslot(call3283);
  params[0] = strlit3278;
  partcv[0] = 1;
  Object opresult3284 = callmethod(call3283, "==(1)", 1, partcv, params);
// compiled op node returning opresult3284 (depth = 4)
  Object if3276 = done;
  if (istrue(opresult3284)) {
// Begin line 465
  setline(465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3285 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3286 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3287 = gc_frame_new();
// call case 3: self.outer request
  Object call3288 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3287);
// compiled member node returning call3288 (depth = 6)
  partcv[0] = 0;
  Object call3289 = callmethodflags(call3288, "operatorState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3286);
// compiled member node returning call3289 (depth = 5)
  gc_frame_newslot(call3289);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3290 = gc_frame_new();
// call case 3: self.outer request
  Object call3291 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3290);
// compiled member node returning call3291 (depth = 5)
  params[0] = call3289;
  partcv[0] = 1;
  Object call3292 = callmethodflags(call3291, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3285);
// compiled call node returning call3292 (depth = 4)
// Begin line 466
  setline(466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3293 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3294 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3295 = gc_frame_new();
// call case 3: self.outer request
  Object call3296 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3295);
// compiled member node returning call3296 (depth = 6)
  partcv[0] = 0;
  Object call3297 = callmethodflags(call3296, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3294);
// compiled member node returning call3297 (depth = 5)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3298 = callmethodflags(call3297, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3293);
// compiled call node returning call3298 (depth = 4)
    gc_frame_newslot(call3298);
    if3276 = call3298;
  } else {
// Begin line 472
  setline(472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 467
  setline(467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3300 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_c (depth = 6)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_lexer (depth = 6)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3301 = callmethodflags(module_lexer, "isDigit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3300);
// compiled call node returning call3301 (depth = 5)
  Object if3299 = done;
  if (istrue(call3301)) {
// Begin line 468
  setline(468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3302 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3303 == NULL) {
    strlit3303 = alloc_String("0.");
    gc_root(strlit3303);
  }
// compiled string node returning strlit3303 (depth = 6)
  gc_frame_newslot(strlit3303);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3304 = gc_frame_new();
// call case 3: self.outer request
  Object call3305 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3304);
// compiled member node returning call3305 (depth = 6)
  params[0] = strlit3303;
  partcv[0] = 1;
  Object call3306 = callmethodflags(call3305, "accum:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3302);
// compiled call node returning call3306 (depth = 5)
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3307 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe3308 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3309 = gc_frame_new();
// call case 3: self.outer request
  Object call3310 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3309);
// compiled member node returning call3310 (depth = 7)
  partcv[0] = 0;
  Object call3311 = callmethodflags(call3310, "numberFractionState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3308);
// compiled member node returning call3311 (depth = 6)
  gc_frame_newslot(call3311);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3312 = gc_frame_new();
// call case 3: self.outer request
  Object call3313 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3312);
// compiled member node returning call3313 (depth = 6)
  params[0] = call3311;
  partcv[0] = 1;
  Object call3314 = callmethodflags(call3313, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3307);
// compiled call node returning call3314 (depth = 5)
// Begin line 471
  setline(471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3315 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_c (depth = 6)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3316 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3317 = gc_frame_new();
// call case 3: self.outer request
  Object call3318 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3317);
// compiled member node returning call3318 (depth = 7)
  partcv[0] = 0;
  Object call3319 = callmethodflags(call3318, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3316);
// compiled member node returning call3319 (depth = 6)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3320 = callmethodflags(call3319, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3315);
// compiled call node returning call3320 (depth = 5)
    gc_frame_newslot(call3320);
    if3299 = call3320;
  } else {
// Begin line 473
  setline(473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3321 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe3322 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3323 = gc_frame_new();
// call case 3: self.outer request
  Object call3324 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3323);
// compiled member node returning call3324 (depth = 7)
  partcv[0] = 0;
  Object call3325 = callmethodflags(call3324, "dotToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3322);
// compiled member node returning call3325 (depth = 6)
  gc_frame_newslot(call3325);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3326 = gc_frame_new();
// call case 3: self.outer request
  Object call3327 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3326);
// compiled member node returning call3327 (depth = 6)
  params[0] = call3325;
  partcv[0] = 1;
  Object call3328 = callmethodflags(call3327, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3321);
// compiled call node returning call3328 (depth = 5)
// Begin line 474
  setline(474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3329 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe3330 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3331 = gc_frame_new();
// call case 3: self.outer request
  Object call3332 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3331);
// compiled member node returning call3332 (depth = 7)
  partcv[0] = 0;
  Object call3333 = callmethodflags(call3332, "defaultState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3330);
// compiled member node returning call3333 (depth = 6)
  gc_frame_newslot(call3333);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3334 = gc_frame_new();
// call case 3: self.outer request
  Object call3335 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3334);
// compiled member node returning call3335 (depth = 6)
  params[0] = call3333;
  partcv[0] = 1;
  Object call3336 = callmethodflags(call3335, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3329);
// compiled call node returning call3336 (depth = 5)
// Begin line 475
  setline(475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3337 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_c (depth = 6)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3338 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3339 = gc_frame_new();
// call case 3: self.outer request
  Object call3340 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3339);
// compiled member node returning call3340 (depth = 7)
  partcv[0] = 0;
  Object call3341 = callmethodflags(call3340, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3338);
// compiled member node returning call3341 (depth = 6)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3342 = callmethodflags(call3341, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3337);
// compiled call node returning call3342 (depth = 5)
    gc_frame_newslot(call3342);
    if3299 = call3342;
  }
// compiled if node returning if3299 (depth = 4)
    gc_frame_newslot(if3299);
    if3276 = if3299;
  }
// compiled if node returning if3276 (depth = 3)
    gc_frame_newslot(if3276);
    if3250 = if3276;
  }
// compiled if node returning if3250 (depth = 2)
  gc_frame_end(frame);
  return if3250;
}
Object meth_lexer_3345_consume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "consume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method consume(_)");
  Object params[4];
  int partcv[2];
  Object *var_keywords = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for consume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part consume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 482
  setline(482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3346 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3347 = gc_frame_new();
// call case 3: self.outer request
  Object call3348 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3347);
// compiled member node returning call3348 (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3349 = callmethodflags(call3348, "checkSeparator(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3346);
// compiled call node returning call3349 (depth = 2)
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3351 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe3352 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_lexer (depth = 5)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3353 = callmethodflags(module_lexer, "isIdentifierChar(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3352);
// compiled call node returning call3353 (depth = 4)
  partcv[0] = 0;
  Object call3354 = callmethodflags(call3353, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe3351);
// compiled call node returning call3354 (depth = 3)
  Object if3350 = done;
  if (istrue(call3354)) {
// Begin line 484
  setline(484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3356 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3357 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3358 = gc_frame_new();
// call case 3: self.outer request
  Object call3359 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3358);
// compiled member node returning call3359 (depth = 6)
  partcv[0] = 0;
  Object call3360 = callmethodflags(call3359, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3357);
// compiled member node returning call3360 (depth = 5)
  gc_frame_newslot(call3360);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_keywords (depth = 5)
  params[0] = call3360;
  partcv[0] = 1;
  Object call3361 = callmethodflags(*var_keywords, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3356);
// compiled call node returning call3361 (depth = 4)
  Object if3355 = done;
  if (istrue(call3361)) {
// Begin line 485
  setline(485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3364 == NULL) {
    strlit3364 = alloc_String("super");
    gc_root(strlit3364);
  }
// compiled string node returning strlit3364 (depth = 6)
  int op_slot_right_3363 = gc_frame_newslot(strlit3364);
// starting to compile member node (depth = 6)
  int callframe3366 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3367 = gc_frame_new();
// call case 3: self.outer request
  Object call3368 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3367);
// compiled member node returning call3368 (depth = 7)
  partcv[0] = 0;
  Object call3369 = callmethodflags(call3368, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3366);
// compiled member node returning call3369 (depth = 6)
  int op_slot_left_3363 = gc_frame_newslot(call3369);
  params[0] = strlit3364;
  partcv[0] = 1;
  Object opresult3370 = callmethod(call3369, "==(1)", 1, partcv, params);
// compiled op node returning opresult3370 (depth = 5)
  Object if3362 = done;
  if (istrue(opresult3370)) {
// Begin line 486
  setline(486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3371 = gc_frame_new();
// Begin line 487
  setline(487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 488
  setline(488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit3373 == NULL) {
    strlit3373 = alloc_String("Consider using an `alias` clause on the inherit statement.");
    gc_root(strlit3373);
  }
// compiled string node returning strlit3373 (depth = 7)
  int op_slot_right_3372 = gc_frame_newslot(strlit3373);
// Begin line 487
  setline(487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit3375 == NULL) {
    strlit3375 = alloc_String("`super` is no longer part of Grace.""\x0a""");
    gc_root(strlit3375);
  }
// compiled string node returning strlit3375 (depth = 7)
  int op_slot_left_3372 = gc_frame_newslot(strlit3375);
  params[0] = strlit3373;
  partcv[0] = 1;
  Object opresult3376 = callmethod(strlit3375, "++(1)", 1, partcv, params);
// compiled op node returning opresult3376 (depth = 6)
  gc_frame_newslot(opresult3376);
// Begin line 489
  setline(489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe3377 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3378 = gc_frame_new();
// call case 3: self.outer request
  Object call3379 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3378);
// compiled member node returning call3379 (depth = 7)
  partcv[0] = 0;
  Object call3380 = callmethodflags(call3379, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3377);
// compiled member node returning call3380 (depth = 6)
  gc_frame_newslot(call3380);
// starting to compile member node (depth = 6)
  int callframe3381 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3382 = gc_frame_new();
// call case 3: self.outer request
  Object call3383 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3382);
// compiled member node returning call3383 (depth = 7)
  partcv[0] = 0;
  Object call3384 = callmethodflags(call3383, "startPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3381);
// compiled member node returning call3384 (depth = 6)
  gc_frame_newslot(call3384);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3386 = alloc_Float64(1);
// compiled num node returning num3386 (depth = 7)
  int op_slot_right_3385 = gc_frame_newslot(num3386);
// starting to compile member node (depth = 7)
  int callframe3388 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3389 = gc_frame_new();
// call case 3: self.outer request
  Object call3390 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3389);
// compiled member node returning call3390 (depth = 8)
  partcv[0] = 0;
  Object call3391 = callmethodflags(call3390, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3388);
// compiled member node returning call3391 (depth = 7)
  int op_slot_left_3385 = gc_frame_newslot(call3391);
  params[0] = num3386;
  partcv[0] = 1;
  Object diff3392 = callmethod(call3391, "-(1)", 1, partcv, params);
// compiled op node returning diff3392 (depth = 6)
  gc_frame_newslot(diff3392);
// call case 6: other requests
// Begin line 486
  setline(486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult3376;
  params[1] = call3380;
  params[2] = call3384;
  params[3] = diff3392;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call3393 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe3371);
// compiled call node returning call3393 (depth = 5)
    gc_frame_newslot(call3393);
    if3362 = call3393;
  } else {
// Begin line 495
  setline(495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 490
  setline(490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3396 == NULL) {
    strlit3396 = alloc_String("inherits");
    gc_root(strlit3396);
  }
// compiled string node returning strlit3396 (depth = 7)
  int op_slot_right_3395 = gc_frame_newslot(strlit3396);
// starting to compile member node (depth = 7)
  int callframe3398 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3399 = gc_frame_new();
// call case 3: self.outer request
  Object call3400 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3399);
// compiled member node returning call3400 (depth = 8)
  partcv[0] = 0;
  Object call3401 = callmethodflags(call3400, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3398);
// compiled member node returning call3401 (depth = 7)
  int op_slot_left_3395 = gc_frame_newslot(call3401);
  params[0] = strlit3396;
  partcv[0] = 1;
  Object opresult3402 = callmethod(call3401, "==(1)", 1, partcv, params);
// compiled op node returning opresult3402 (depth = 6)
  Object if3394 = done;
  if (istrue(opresult3402)) {
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3403 = gc_frame_new();
// Begin line 492
  setline(492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit3404 == NULL) {
    strlit3404 = alloc_String("The reserved word `inherits` has been replaced by `inherit`.");
    gc_root(strlit3404);
  }
// compiled string node returning strlit3404 (depth = 7)
  gc_frame_newslot(strlit3404);
// Begin line 493
  setline(493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe3405 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3406 = gc_frame_new();
// call case 3: self.outer request
  Object call3407 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3406);
// compiled member node returning call3407 (depth = 8)
  partcv[0] = 0;
  Object call3408 = callmethodflags(call3407, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3405);
// compiled member node returning call3408 (depth = 7)
  gc_frame_newslot(call3408);
// starting to compile member node (depth = 7)
  int callframe3409 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3410 = gc_frame_new();
// call case 3: self.outer request
  Object call3411 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3410);
// compiled member node returning call3411 (depth = 8)
  partcv[0] = 0;
  Object call3412 = callmethodflags(call3411, "startPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3409);
// compiled member node returning call3412 (depth = 7)
  gc_frame_newslot(call3412);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3414 = alloc_Float64(1);
// compiled num node returning num3414 (depth = 8)
  int op_slot_right_3413 = gc_frame_newslot(num3414);
// starting to compile member node (depth = 8)
  int callframe3416 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe3417 = gc_frame_new();
// call case 3: self.outer request
  Object call3418 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3417);
// compiled member node returning call3418 (depth = 9)
  partcv[0] = 0;
  Object call3419 = callmethodflags(call3418, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3416);
// compiled member node returning call3419 (depth = 8)
  int op_slot_left_3413 = gc_frame_newslot(call3419);
  params[0] = num3414;
  partcv[0] = 1;
  Object diff3420 = callmethod(call3419, "-(1)", 1, partcv, params);
// compiled op node returning diff3420 (depth = 7)
  gc_frame_newslot(diff3420);
// call case 6: other requests
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit3404;
  params[1] = call3408;
  params[2] = call3412;
  params[3] = diff3420;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call3421 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe3403);
// compiled call node returning call3421 (depth = 6)
    gc_frame_newslot(call3421);
    if3394 = call3421;
  } else {
  }
// compiled if node returning if3394 (depth = 5)
    gc_frame_newslot(if3394);
    if3362 = if3394;
  }
// compiled if node returning if3362 (depth = 4)
// Begin line 495
  setline(495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3422 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe3423 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe3424 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3425 = gc_frame_new();
// call case 3: self.outer request
  Object call3426 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3425);
// compiled member node returning call3426 (depth = 7)
  partcv[0] = 0;
  Object call3427 = callmethodflags(call3426, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3424);
// compiled member node returning call3427 (depth = 6)
  gc_frame_newslot(call3427);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3428 = gc_frame_new();
// call case 3: self.outer request
  Object call3429 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3428);
// compiled member node returning call3429 (depth = 6)
  params[0] = call3427;
  partcv[0] = 1;
  Object call3430 = callmethodflags(call3429, "keywordToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3423);
// compiled call node returning call3430 (depth = 5)
  gc_frame_newslot(call3430);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3431 = gc_frame_new();
// call case 3: self.outer request
  Object call3432 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3431);
// compiled member node returning call3432 (depth = 5)
  params[0] = call3430;
  partcv[0] = 1;
  Object call3433 = callmethodflags(call3432, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3422);
// compiled call node returning call3433 (depth = 4)
    gc_frame_newslot(call3433);
    if3355 = call3433;
  } else {
// Begin line 497
  setline(497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3434 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe3435 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe3436 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3437 = gc_frame_new();
// call case 3: self.outer request
  Object call3438 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3437);
// compiled member node returning call3438 (depth = 7)
  partcv[0] = 0;
  Object call3439 = callmethodflags(call3438, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3436);
// compiled member node returning call3439 (depth = 6)
  gc_frame_newslot(call3439);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3440 = gc_frame_new();
// call case 3: self.outer request
  Object call3441 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3440);
// compiled member node returning call3441 (depth = 6)
  params[0] = call3439;
  partcv[0] = 1;
  Object call3442 = callmethodflags(call3441, "identifierToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3435);
// compiled call node returning call3442 (depth = 5)
  gc_frame_newslot(call3442);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3443 = gc_frame_new();
// call case 3: self.outer request
  Object call3444 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3443);
// compiled member node returning call3444 (depth = 5)
  params[0] = call3442;
  partcv[0] = 1;
  Object call3445 = callmethodflags(call3444, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3434);
// compiled call node returning call3445 (depth = 4)
    gc_frame_newslot(call3445);
    if3355 = call3445;
  }
// compiled if node returning if3355 (depth = 3)
// Begin line 499
  setline(499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3446 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3447 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3448 = gc_frame_new();
// call case 3: self.outer request
  Object call3449 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3448);
// compiled member node returning call3449 (depth = 5)
  partcv[0] = 0;
  Object call3450 = callmethodflags(call3449, "defaultState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3447);
// compiled member node returning call3450 (depth = 4)
  gc_frame_newslot(call3450);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3451 = gc_frame_new();
// call case 3: self.outer request
  Object call3452 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3451);
// compiled member node returning call3452 (depth = 4)
  params[0] = call3450;
  partcv[0] = 1;
  Object call3453 = callmethodflags(call3452, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3446);
// compiled call node returning call3453 (depth = 3)
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3454 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3455 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3456 = gc_frame_new();
// call case 3: self.outer request
  Object call3457 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3456);
// compiled member node returning call3457 (depth = 5)
  partcv[0] = 0;
  Object call3458 = callmethodflags(call3457, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3455);
// compiled member node returning call3458 (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3459 = callmethodflags(call3458, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3454);
// compiled call node returning call3459 (depth = 3)
    gc_frame_newslot(call3459);
    if3350 = call3459;
  } else {
// Begin line 502
  setline(502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3460 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3461 = gc_frame_new();
// call case 3: self.outer request
  Object call3462 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3461);
// compiled member node returning call3462 (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3463 = callmethodflags(call3462, "store(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3460);
// compiled call node returning call3463 (depth = 3)
    gc_frame_newslot(call3463);
    if3350 = call3463;
  }
// compiled if node returning if3350 (depth = 2)
  gc_frame_end(frame);
  return if3350;
}
Object meth_lexer_3466_consume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "consume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method consume(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for consume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part consume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_strToken = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "strToken");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 509
  setline(509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3467 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3468 = gc_frame_new();
// call case 3: self.outer request
  Object call3469 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3468);
// compiled member node returning call3469 (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3470 = callmethodflags(call3469, "checkSeparatorString(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3467);
// compiled call node returning call3470 (depth = 2)
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3473 == NULL) {
    strlit3473 = alloc_String("""\x22""");
    gc_root(strlit3473);
  }
// compiled string node returning strlit3473 (depth = 4)
  int op_slot_right_3472 = gc_frame_newslot(strlit3473);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_left_3472 = gc_frame_newslot(*var_c);
  params[0] = strlit3473;
  partcv[0] = 1;
  Object opresult3475 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult3475 (depth = 3)
  Object if3471 = done;
  if (istrue(opresult3475)) {
// Begin line 511
  setline(511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3476 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3477 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3478 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3479 = gc_frame_new();
// call case 3: self.outer request
  Object call3480 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3479);
// compiled member node returning call3480 (depth = 6)
  partcv[0] = 0;
  Object call3481 = callmethodflags(call3480, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3478);
// compiled member node returning call3481 (depth = 5)
  gc_frame_newslot(call3481);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3482 = gc_frame_new();
// call case 3: self.outer request
  Object call3483 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3482);
// compiled member node returning call3483 (depth = 5)
  params[0] = call3481;
  partcv[0] = 1;
  Object call3484 = callmethodflags(call3483, "stringToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3477);
// compiled call node returning call3484 (depth = 4)
  gc_frame_newslot(call3484);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3485 = gc_frame_new();
// call case 3: self.outer request
  Object call3486 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3485);
// compiled member node returning call3486 (depth = 4)
  params[0] = call3484;
  partcv[0] = 1;
  Object call3487 = callmethodflags(call3486, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3476);
// compiled call node returning call3487 (depth = 3)
// Begin line 512
  setline(512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3491 = alloc_Float64(0);
// compiled num node returning num3491 (depth = 6)
  int op_slot_right_3490 = gc_frame_newslot(num3491);
// starting to compile member node (depth = 6)
  int callframe3493 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3494 = gc_frame_new();
// call case 3: self.outer request
  Object call3495 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3494);
// compiled member node returning call3495 (depth = 7)
  partcv[0] = 0;
  Object call3496 = callmethodflags(call3495, "interpdepth", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3493);
// compiled member node returning call3496 (depth = 6)
  int op_slot_left_3490 = gc_frame_newslot(call3496);
  params[0] = num3491;
  partcv[0] = 1;
  Object opresult3497 = callmethod(call3496, "==(1)", 1, partcv, params);
// compiled op node returning opresult3497 (depth = 5)
  int op_slot_right_3489 = gc_frame_newslot(opresult3497);
// starting to compile member node (depth = 5)
  int callframe3499 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3500 = gc_frame_new();
// call case 3: self.outer request
  Object call3501 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3500);
// compiled member node returning call3501 (depth = 6)
  partcv[0] = 0;
  Object call3502 = callmethodflags(call3501, "interpString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3499);
// compiled member node returning call3502 (depth = 5)
  int op_slot_left_3489 = gc_frame_newslot(call3502);
  params[0] = opresult3497;
  partcv[0] = 1;
  Object opresult3503 = callmethod(call3502, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3503 (depth = 4)
  Object if3488 = done;
  if (istrue(opresult3503)) {
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3504 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3505 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3506 = gc_frame_new();
// call case 3: self.outer request
  Object call3507 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3506);
// compiled member node returning call3507 (depth = 6)
  partcv[0] = 0;
  Object call3508 = callmethodflags(call3507, "rParenToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3505);
// compiled member node returning call3508 (depth = 5)
  gc_frame_newslot(call3508);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3509 = gc_frame_new();
// call case 3: self.outer request
  Object call3510 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3509);
// compiled member node returning call3510 (depth = 5)
  params[0] = call3508;
  partcv[0] = 1;
  Object call3511 = callmethodflags(call3510, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3504);
// compiled call node returning call3511 (depth = 4)
// Begin line 514
  setline(514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3512 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool3513 = alloc_Boolean(0);
// compiled identifier node returning bool3513 (depth = 5)
  gc_frame_newslot(bool3513);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3514 = gc_frame_new();
// call case 3: self.outer request
  Object call3515 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3514);
// compiled member node returning call3515 (depth = 5)
  params[0] = bool3513;
  partcv[0] = 1;
  Object call3516 = callmethodflags(call3515, "interpString:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3512);
// compiled call node returning call3516 (depth = 4)
    gc_frame_newslot(call3516);
    if3488 = call3516;
  } else {
  }
// compiled if node returning if3488 (depth = 3)
// Begin line 516
  setline(516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3517 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3518 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3519 = gc_frame_new();
// call case 3: self.outer request
  Object call3520 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3519);
// compiled member node returning call3520 (depth = 5)
  partcv[0] = 0;
  Object call3521 = callmethodflags(call3520, "defaultState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3518);
// compiled member node returning call3521 (depth = 4)
  gc_frame_newslot(call3521);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3522 = gc_frame_new();
// call case 3: self.outer request
  Object call3523 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3522);
// compiled member node returning call3523 (depth = 4)
  params[0] = call3521;
  partcv[0] = 1;
  Object call3524 = callmethodflags(call3523, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3517);
// compiled call node returning call3524 (depth = 3)
// Begin line 517
  setline(517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3525 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool3526 = alloc_Boolean(0);
// compiled identifier node returning bool3526 (depth = 4)
  gc_frame_newslot(bool3526);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3527 = gc_frame_new();
// call case 3: self.outer request
  Object call3528 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3527);
// compiled member node returning call3528 (depth = 4)
  params[0] = bool3526;
  partcv[0] = 1;
  Object call3529 = callmethodflags(call3528, "inStr:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3525);
// compiled call node returning call3529 (depth = 3)
    gc_frame_newslot(call3529);
    if3471 = call3529;
  } else {
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 518
  setline(518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3532 == NULL) {
    strlit3532 = alloc_String("""\x0a""");
    gc_root(strlit3532);
  }
// compiled string node returning strlit3532 (depth = 5)
  int op_slot_right_3531 = gc_frame_newslot(strlit3532);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  int op_slot_left_3531 = gc_frame_newslot(*var_c);
  params[0] = strlit3532;
  partcv[0] = 1;
  Object opresult3534 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult3534 (depth = 4)
  Object if3530 = done;
  if (istrue(opresult3534)) {
// Begin line 519
  setline(519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3535 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3536 = gc_frame_new();
// call case 3: self.outer request
  Object call3537 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3536);
// compiled member node returning call3537 (depth = 5)
  partcv[0] = 0;
  Object call3538 = callmethodflags(call3537, "newLineError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3535);
// compiled member node returning call3538 (depth = 4)
    gc_frame_newslot(call3538);
    if3530 = call3538;
  } else {
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3541 == NULL) {
    strlit3541 = alloc_String("{");
    gc_root(strlit3541);
  }
// compiled string node returning strlit3541 (depth = 6)
  int op_slot_right_3540 = gc_frame_newslot(strlit3541);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_c (depth = 6)
  int op_slot_left_3540 = gc_frame_newslot(*var_c);
  params[0] = strlit3541;
  partcv[0] = 1;
  Object opresult3543 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult3543 (depth = 5)
  Object if3539 = done;
  if (istrue(opresult3543)) {
// Begin line 521
  setline(521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3544 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe3545 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3546 = gc_frame_new();
// call case 3: self.outer request
  Object call3547 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3546);
// compiled member node returning call3547 (depth = 8)
  partcv[0] = 0;
  Object call3548 = callmethodflags(call3547, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3545);
// compiled member node returning call3548 (depth = 7)
  gc_frame_newslot(call3548);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3549 = gc_frame_new();
// call case 3: self.outer request
  Object call3550 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3549);
// compiled member node returning call3550 (depth = 7)
  params[0] = call3548;
  partcv[0] = 1;
  Object call3551 = callmethodflags(call3550, "stringToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3544);
// compiled call node returning call3551 (depth = 6)
  *var_strToken = call3551;
  if (call3551 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 522
  setline(522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3552 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe3553 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3554 = gc_frame_new();
// call case 3: self.outer request
  Object call3555 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3554);
// compiled member node returning call3555 (depth = 7)
  partcv[0] = 0;
  Object call3556 = callmethodflags(call3555, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3553);
// compiled member node returning call3556 (depth = 6)
  gc_frame_newslot(call3556);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3557 = gc_frame_new();
// call case 3: self.outer request
  Object call3558 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3557);
// compiled member node returning call3558 (depth = 6)
  params[0] = call3556;
  partcv[0] = 1;
  Object call3559 = callmethodflags(call3558, "startPosition:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3552);
// compiled call node returning call3559 (depth = 5)
// Begin line 523
  setline(523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3561 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3562 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3563 = gc_frame_new();
// call case 3: self.outer request
  Object call3564 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3563);
// compiled member node returning call3564 (depth = 8)
  partcv[0] = 0;
  Object call3565 = callmethodflags(call3564, "interpString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3562);
// compiled member node returning call3565 (depth = 7)
  partcv[0] = 0;
  Object call3566 = callmethodflags(call3565, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe3561);
// compiled call node returning call3566 (depth = 6)
  Object if3560 = done;
  if (istrue(call3566)) {
// Begin line 524
  setline(524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3567 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe3568 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3569 = gc_frame_new();
// call case 3: self.outer request
  Object call3570 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3569);
// compiled member node returning call3570 (depth = 8)
  partcv[0] = 0;
  Object call3571 = callmethodflags(call3570, "lParenToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3568);
// compiled member node returning call3571 (depth = 7)
  gc_frame_newslot(call3571);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3572 = gc_frame_new();
// call case 3: self.outer request
  Object call3573 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3572);
// compiled member node returning call3573 (depth = 7)
  params[0] = call3571;
  partcv[0] = 1;
  Object call3574 = callmethodflags(call3573, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3567);
// compiled call node returning call3574 (depth = 6)
// Begin line 525
  setline(525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3575 = gc_frame_new();
// starting to compile identifier node (depth = 7)
  Object bool3576 = alloc_Boolean(1);
// compiled identifier node returning bool3576 (depth = 7)
  gc_frame_newslot(bool3576);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3577 = gc_frame_new();
// call case 3: self.outer request
  Object call3578 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3577);
// compiled member node returning call3578 (depth = 7)
  params[0] = bool3576;
  partcv[0] = 1;
  Object call3579 = callmethodflags(call3578, "interpString:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3575);
// compiled call node returning call3579 (depth = 6)
    gc_frame_newslot(call3579);
    if3560 = call3579;
  } else {
  }
// compiled if node returning if3560 (depth = 5)
// Begin line 527
  setline(527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3580 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_strToken (depth = 6)
  gc_frame_newslot(*var_strToken);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3581 = gc_frame_new();
// call case 3: self.outer request
  Object call3582 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3581);
// compiled member node returning call3582 (depth = 6)
  params[0] = *var_strToken;
  partcv[0] = 1;
  Object call3583 = callmethodflags(call3582, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3580);
// compiled call node returning call3583 (depth = 5)
// Begin line 528
  setline(528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3584 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe3585 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3586 == NULL) {
    strlit3586 = alloc_String("++");
    gc_root(strlit3586);
  }
// compiled string node returning strlit3586 (depth = 7)
  gc_frame_newslot(strlit3586);
// call case 6: other requests
// Begin line 527
  setline(527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe3587 = gc_frame_new();
// call case 3: self.outer request
  Object call3588 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3587);
// compiled member node returning call3588 (depth = 7)
  params[0] = strlit3586;
  partcv[0] = 1;
  Object call3589 = callmethodflags(call3588, "opToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3585);
// compiled call node returning call3589 (depth = 6)
  gc_frame_newslot(call3589);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3590 = gc_frame_new();
// call case 3: self.outer request
  Object call3591 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3590);
// compiled member node returning call3591 (depth = 6)
  params[0] = call3589;
  partcv[0] = 1;
  Object call3592 = callmethodflags(call3591, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3584);
// compiled call node returning call3592 (depth = 5)
// Begin line 529
  setline(529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3593 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe3594 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3595 = gc_frame_new();
// call case 3: self.outer request
  Object call3596 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3595);
// compiled member node returning call3596 (depth = 7)
  partcv[0] = 0;
  Object call3597 = callmethodflags(call3596, "lParenToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3594);
// compiled member node returning call3597 (depth = 6)
  gc_frame_newslot(call3597);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3598 = gc_frame_new();
// call case 3: self.outer request
  Object call3599 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3598);
// compiled member node returning call3599 (depth = 6)
  params[0] = call3597;
  partcv[0] = 1;
  Object call3600 = callmethodflags(call3599, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3593);
// compiled call node returning call3600 (depth = 5)
// Begin line 530
  setline(530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3601 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe3602 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3603 = gc_frame_new();
// call case 3: self.outer request
  Object call3604 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3603);
// compiled member node returning call3604 (depth = 7)
  partcv[0] = 0;
  Object call3605 = callmethodflags(call3604, "defaultState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3602);
// compiled member node returning call3605 (depth = 6)
  gc_frame_newslot(call3605);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3606 = gc_frame_new();
// call case 3: self.outer request
  Object call3607 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3606);
// compiled member node returning call3607 (depth = 6)
  params[0] = call3605;
  partcv[0] = 1;
  Object call3608 = callmethodflags(call3607, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3601);
// compiled call node returning call3608 (depth = 5)
// Begin line 531
  setline(531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3609 = gc_frame_new();
// starting to compile identifier node (depth = 6)
  Object bool3610 = alloc_Boolean(0);
// compiled identifier node returning bool3610 (depth = 6)
  gc_frame_newslot(bool3610);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3611 = gc_frame_new();
// call case 3: self.outer request
  Object call3612 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3611);
// compiled member node returning call3612 (depth = 6)
  params[0] = bool3610;
  partcv[0] = 1;
  Object call3613 = callmethodflags(call3612, "inStr:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3609);
// compiled call node returning call3613 (depth = 5)
// Begin line 532
  setline(532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3614 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3616 = alloc_Float64(1);
// compiled num node returning num3616 (depth = 7)
  int op_slot_right_3615 = gc_frame_newslot(num3616);
// starting to compile member node (depth = 7)
  int callframe3618 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3619 = gc_frame_new();
// call case 3: self.outer request
  Object call3620 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3619);
// compiled member node returning call3620 (depth = 8)
  partcv[0] = 0;
  Object call3621 = callmethodflags(call3620, "interpdepth", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3618);
// compiled member node returning call3621 (depth = 7)
  int op_slot_left_3615 = gc_frame_newslot(call3621);
  params[0] = num3616;
  partcv[0] = 1;
  Object sum3622 = callmethod(call3621, "+(1)", 1, partcv, params);
// compiled op node returning sum3622 (depth = 6)
  gc_frame_newslot(sum3622);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3623 = gc_frame_new();
// call case 3: self.outer request
  Object call3624 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3623);
// compiled member node returning call3624 (depth = 6)
  params[0] = sum3622;
  partcv[0] = 1;
  Object call3625 = callmethodflags(call3624, "interpdepth:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3614);
// compiled call node returning call3625 (depth = 5)
    gc_frame_newslot(call3625);
    if3539 = call3625;
  } else {
// Begin line 535
  setline(535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3628 == NULL) {
    strlit3628 = alloc_String("\\");
    gc_root(strlit3628);
  }
// compiled string node returning strlit3628 (depth = 7)
  int op_slot_right_3627 = gc_frame_newslot(strlit3628);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_left_3627 = gc_frame_newslot(*var_c);
  params[0] = strlit3628;
  partcv[0] = 1;
  Object opresult3630 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult3630 (depth = 6)
  Object if3626 = done;
  if (istrue(opresult3630)) {
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3631 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe3632 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3633 = gc_frame_new();
// call case 3: self.outer request
  Object call3634 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3633);
// compiled member node returning call3634 (depth = 8)
  partcv[0] = 0;
  Object call3635 = callmethodflags(call3634, "quotedStringEscapedState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3632);
// compiled member node returning call3635 (depth = 7)
  gc_frame_newslot(call3635);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3636 = gc_frame_new();
// call case 3: self.outer request
  Object call3637 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3636);
// compiled member node returning call3637 (depth = 7)
  params[0] = call3635;
  partcv[0] = 1;
  Object call3638 = callmethodflags(call3637, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3631);
// compiled call node returning call3638 (depth = 6)
    gc_frame_newslot(call3638);
    if3626 = call3638;
  } else {
// Begin line 536
  setline(536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3639 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3640 = gc_frame_new();
// call case 3: self.outer request
  Object call3641 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3640);
// compiled member node returning call3641 (depth = 7)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3642 = callmethodflags(call3641, "store(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3639);
// compiled call node returning call3642 (depth = 6)
    gc_frame_newslot(call3642);
    if3626 = call3642;
  }
// compiled if node returning if3626 (depth = 5)
    gc_frame_newslot(if3626);
    if3539 = if3626;
  }
// compiled if node returning if3539 (depth = 4)
    gc_frame_newslot(if3539);
    if3530 = if3539;
  }
// compiled if node returning if3530 (depth = 3)
    gc_frame_newslot(if3530);
    if3471 = if3530;
  }
// compiled if node returning if3471 (depth = 2)
  gc_frame_end(frame);
  return if3471;
}
Object meth_lexer_3645_consume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "consume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method consume(_)");
  Object params[1];
  int partcv[1];
  Object *var_unicode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for consume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part consume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 542
  setline(542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3646 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3648 = alloc_Float64(1);
// compiled num node returning num3648 (depth = 4)
  int op_slot_right_3647 = gc_frame_newslot(num3648);
// starting to compile member node (depth = 4)
  int callframe3650 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3651 = gc_frame_new();
// call case 3: self.outer request
  Object call3652 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3651);
// compiled member node returning call3652 (depth = 5)
  partcv[0] = 0;
  Object call3653 = callmethodflags(call3652, "unichars", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3650);
// compiled member node returning call3653 (depth = 4)
  int op_slot_left_3647 = gc_frame_newslot(call3653);
  params[0] = num3648;
  partcv[0] = 1;
  Object diff3654 = callmethod(call3653, "-(1)", 1, partcv, params);
// compiled op node returning diff3654 (depth = 3)
  gc_frame_newslot(diff3654);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3655 = gc_frame_new();
// call case 3: self.outer request
  Object call3656 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3655);
// compiled member node returning call3656 (depth = 3)
  params[0] = diff3654;
  partcv[0] = 1;
  Object call3657 = callmethodflags(call3656, "unichars:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3646);
// compiled call node returning call3657 (depth = 2)
// Begin line 543
  setline(543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3658 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3660 = alloc_Float64(16);
// compiled num node returning num3660 (depth = 4)
  int op_slot_right_3659 = gc_frame_newslot(num3660);
// starting to compile member node (depth = 4)
  int callframe3662 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3663 = gc_frame_new();
// call case 3: self.outer request
  Object call3664 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3663);
// compiled member node returning call3664 (depth = 5)
  partcv[0] = 0;
  Object call3665 = callmethodflags(call3664, "codepoint", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3662);
// compiled member node returning call3665 (depth = 4)
  int op_slot_left_3659 = gc_frame_newslot(call3665);
  params[0] = num3660;
  partcv[0] = 1;
  Object prod3666 = callmethod(call3665, "*(1)", 1, partcv, params);
// compiled op node returning prod3666 (depth = 3)
  gc_frame_newslot(prod3666);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3667 = gc_frame_new();
// call case 3: self.outer request
  Object call3668 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3667);
// compiled member node returning call3668 (depth = 3)
  params[0] = prod3666;
  partcv[0] = 1;
  Object call3669 = callmethodflags(call3668, "codepoint:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3658);
// compiled call node returning call3669 (depth = 2)
// Begin line 544
  setline(544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3670 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3672 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3673 = gc_frame_new();
// call case 3: self.outer request
  Object call3674 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3673);
// compiled member node returning call3674 (depth = 5)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3675 = callmethodflags(call3674, "hexdecchar(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3672);
// compiled call node returning call3675 (depth = 4)
  int op_slot_right_3671 = gc_frame_newslot(call3675);
// starting to compile member node (depth = 4)
  int callframe3677 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3678 = gc_frame_new();
// call case 3: self.outer request
  Object call3679 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3678);
// compiled member node returning call3679 (depth = 5)
  partcv[0] = 0;
  Object call3680 = callmethodflags(call3679, "codepoint", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3677);
// compiled member node returning call3680 (depth = 4)
  int op_slot_left_3671 = gc_frame_newslot(call3680);
  params[0] = call3675;
  partcv[0] = 1;
  Object sum3681 = callmethod(call3680, "+(1)", 1, partcv, params);
// compiled op node returning sum3681 (depth = 3)
  gc_frame_newslot(sum3681);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3682 = gc_frame_new();
// call case 3: self.outer request
  Object call3683 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3682);
// compiled member node returning call3683 (depth = 3)
  params[0] = sum3681;
  partcv[0] = 1;
  Object call3684 = callmethodflags(call3683, "codepoint:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3670);
// compiled call node returning call3684 (depth = 2)
// Begin line 546
  setline(546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3687 = alloc_Float64(0);
// compiled num node returning num3687 (depth = 4)
  int op_slot_right_3686 = gc_frame_newslot(num3687);
// starting to compile member node (depth = 4)
  int callframe3689 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3690 = gc_frame_new();
// call case 3: self.outer request
  Object call3691 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3690);
// compiled member node returning call3691 (depth = 5)
  partcv[0] = 0;
  Object call3692 = callmethodflags(call3691, "unichars", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3689);
// compiled member node returning call3692 (depth = 4)
  int op_slot_left_3686 = gc_frame_newslot(call3692);
  params[0] = num3687;
  partcv[0] = 1;
  Object opresult3693 = callmethod(call3692, "==(1)", 1, partcv, params);
// compiled op node returning opresult3693 (depth = 3)
  Object if3685 = done;
  if (istrue(opresult3693)) {
// Begin line 549
  setline(549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3694 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3695 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3696 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3697 = gc_frame_new();
// call case 3: self.outer request
  Object call3698 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3697);
// compiled member node returning call3698 (depth = 6)
  partcv[0] = 0;
  Object call3699 = callmethodflags(call3698, "codepoint", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3696);
// compiled member node returning call3699 (depth = 5)
  gc_frame_newslot(call3699);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = call3699;
  partcv[0] = 1;
  Object call3700 = callmethodflags(*var_unicode, "create(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3695);
// compiled call node returning call3700 (depth = 4)
  gc_frame_newslot(call3700);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3701 = gc_frame_new();
// call case 3: self.outer request
  Object call3702 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3701);
// compiled member node returning call3702 (depth = 4)
  params[0] = call3700;
  partcv[0] = 1;
  Object call3703 = callmethodflags(call3702, "store(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3694);
// compiled call node returning call3703 (depth = 3)
// Begin line 550
  setline(550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3704 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3705 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3706 = gc_frame_new();
// call case 3: self.outer request
  Object call3707 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3706);
// compiled member node returning call3707 (depth = 5)
  partcv[0] = 0;
  Object call3708 = callmethodflags(call3707, "quotedStringState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3705);
// compiled member node returning call3708 (depth = 4)
  gc_frame_newslot(call3708);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3709 = gc_frame_new();
// call case 3: self.outer request
  Object call3710 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3709);
// compiled member node returning call3710 (depth = 4)
  params[0] = call3708;
  partcv[0] = 1;
  Object call3711 = callmethodflags(call3710, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3704);
// compiled call node returning call3711 (depth = 3)
    gc_frame_newslot(call3711);
    if3685 = call3711;
  } else {
  }
// compiled if node returning if3685 (depth = 2)
  gc_frame_end(frame);
  return if3685;
}
Object meth_lexer_3714_consume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "consume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method consume(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for consume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part consume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 556
  setline(556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3715 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3716 = gc_frame_new();
// call case 3: self.outer request
  Object call3717 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3716);
// compiled member node returning call3717 (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3718 = callmethodflags(call3717, "checkSeparatorString(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3715);
// compiled call node returning call3718 (depth = 2)
// Begin line 557
  setline(557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3719 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe3720 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3721 = gc_frame_new();
// call case 3: self.outer request
  Object call3722 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3721);
// compiled member node returning call3722 (depth = 4)
  partcv[0] = 0;
  Object call3723 = callmethodflags(call3722, "quotedStringState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3720);
// compiled member node returning call3723 (depth = 3)
  gc_frame_newslot(call3723);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3724 = gc_frame_new();
// call case 3: self.outer request
  Object call3725 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3724);
// compiled member node returning call3725 (depth = 3)
  params[0] = call3723;
  partcv[0] = 1;
  Object call3726 = callmethodflags(call3725, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3719);
// compiled call node returning call3726 (depth = 2)
// Begin line 558
  setline(558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3729 == NULL) {
    strlit3729 = alloc_String("""\x0a""");
    gc_root(strlit3729);
  }
// compiled string node returning strlit3729 (depth = 4)
  int op_slot_right_3728 = gc_frame_newslot(strlit3729);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_left_3728 = gc_frame_newslot(*var_c);
  params[0] = strlit3729;
  partcv[0] = 1;
  Object opresult3731 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult3731 (depth = 3)
  Object if3727 = done;
  if (istrue(opresult3731)) {
// Begin line 559
  setline(559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3732 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3733 = gc_frame_new();
// call case 3: self.outer request
  Object call3734 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3733);
// compiled member node returning call3734 (depth = 4)
  partcv[0] = 0;
  Object call3735 = callmethodflags(call3734, "newLineError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3732);
// compiled member node returning call3735 (depth = 3)
    gc_frame_newslot(call3735);
    if3727 = call3735;
  } else {
// Begin line 563
  setline(563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 560
  setline(560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3738 == NULL) {
    strlit3738 = alloc_String("n");
    gc_root(strlit3738);
  }
// compiled string node returning strlit3738 (depth = 5)
  int op_slot_right_3737 = gc_frame_newslot(strlit3738);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  int op_slot_left_3737 = gc_frame_newslot(*var_c);
  params[0] = strlit3738;
  partcv[0] = 1;
  Object opresult3740 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult3740 (depth = 4)
  Object if3736 = done;
  if (istrue(opresult3740)) {
// Begin line 562
  setline(562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3741 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3743 == NULL) {
    strlit3743 = alloc_String("""\x0a""");
    gc_root(strlit3743);
  }
// compiled string node returning strlit3743 (depth = 6)
  int op_slot_right_3742 = gc_frame_newslot(strlit3743);
// starting to compile member node (depth = 6)
  int callframe3745 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3746 = gc_frame_new();
// call case 3: self.outer request
  Object call3747 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3746);
// compiled member node returning call3747 (depth = 7)
  partcv[0] = 0;
  Object call3748 = callmethodflags(call3747, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3745);
// compiled member node returning call3748 (depth = 6)
  int op_slot_left_3742 = gc_frame_newslot(call3748);
  params[0] = strlit3743;
  partcv[0] = 1;
  Object opresult3749 = callmethod(call3748, "++(1)", 1, partcv, params);
// compiled op node returning opresult3749 (depth = 5)
  gc_frame_newslot(opresult3749);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3750 = gc_frame_new();
// call case 3: self.outer request
  Object call3751 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3750);
// compiled member node returning call3751 (depth = 5)
  params[0] = opresult3749;
  partcv[0] = 1;
  Object call3752 = callmethodflags(call3751, "accum:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3741);
// compiled call node returning call3752 (depth = 4)
    gc_frame_newslot(call3752);
    if3736 = call3752;
  } else {
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 563
  setline(563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3755 == NULL) {
    strlit3755 = alloc_String("u");
    gc_root(strlit3755);
  }
// compiled string node returning strlit3755 (depth = 6)
  int op_slot_right_3754 = gc_frame_newslot(strlit3755);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_c (depth = 6)
  int op_slot_left_3754 = gc_frame_newslot(*var_c);
  params[0] = strlit3755;
  partcv[0] = 1;
  Object opresult3757 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult3757 (depth = 5)
  Object if3753 = done;
  if (istrue(opresult3757)) {
// Begin line 566
  setline(566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3758 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num3759 = alloc_Float64(4);
// compiled num node returning num3759 (depth = 6)
  gc_frame_newslot(num3759);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3760 = gc_frame_new();
// call case 3: self.outer request
  Object call3761 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3760);
// compiled member node returning call3761 (depth = 6)
  params[0] = num3759;
  partcv[0] = 1;
  Object call3762 = callmethodflags(call3761, "unichars:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3758);
// compiled call node returning call3762 (depth = 5)
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3763 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num3764 = alloc_Float64(0);
// compiled num node returning num3764 (depth = 6)
  gc_frame_newslot(num3764);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3765 = gc_frame_new();
// call case 3: self.outer request
  Object call3766 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3765);
// compiled member node returning call3766 (depth = 6)
  params[0] = num3764;
  partcv[0] = 1;
  Object call3767 = callmethodflags(call3766, "codepoint:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3763);
// compiled call node returning call3767 (depth = 5)
// Begin line 568
  setline(568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3768 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe3769 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3770 = gc_frame_new();
// call case 3: self.outer request
  Object call3771 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3770);
// compiled member node returning call3771 (depth = 7)
  partcv[0] = 0;
  Object call3772 = callmethodflags(call3771, "unicodeState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3769);
// compiled member node returning call3772 (depth = 6)
  gc_frame_newslot(call3772);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3773 = gc_frame_new();
// call case 3: self.outer request
  Object call3774 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3773);
// compiled member node returning call3774 (depth = 6)
  params[0] = call3772;
  partcv[0] = 1;
  Object call3775 = callmethodflags(call3774, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3768);
// compiled call node returning call3775 (depth = 5)
    gc_frame_newslot(call3775);
    if3753 = call3775;
  } else {
// Begin line 575
  setline(575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3778 == NULL) {
    strlit3778 = alloc_String("U");
    gc_root(strlit3778);
  }
// compiled string node returning strlit3778 (depth = 7)
  int op_slot_right_3777 = gc_frame_newslot(strlit3778);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_left_3777 = gc_frame_newslot(*var_c);
  params[0] = strlit3778;
  partcv[0] = 1;
  Object opresult3780 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult3780 (depth = 6)
  Object if3776 = done;
  if (istrue(opresult3780)) {
// Begin line 572
  setline(572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3781 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num3782 = alloc_Float64(6);
// compiled num node returning num3782 (depth = 7)
  gc_frame_newslot(num3782);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3783 = gc_frame_new();
// call case 3: self.outer request
  Object call3784 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3783);
// compiled member node returning call3784 (depth = 7)
  params[0] = num3782;
  partcv[0] = 1;
  Object call3785 = callmethodflags(call3784, "unichars:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3781);
// compiled call node returning call3785 (depth = 6)
// Begin line 573
  setline(573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3786 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num3787 = alloc_Float64(0);
// compiled num node returning num3787 (depth = 7)
  gc_frame_newslot(num3787);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3788 = gc_frame_new();
// call case 3: self.outer request
  Object call3789 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3788);
// compiled member node returning call3789 (depth = 7)
  params[0] = num3787;
  partcv[0] = 1;
  Object call3790 = callmethodflags(call3789, "codepoint:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3786);
// compiled call node returning call3790 (depth = 6)
// Begin line 574
  setline(574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3791 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe3792 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3793 = gc_frame_new();
// call case 3: self.outer request
  Object call3794 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3793);
// compiled member node returning call3794 (depth = 8)
  partcv[0] = 0;
  Object call3795 = callmethodflags(call3794, "unicodeState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3792);
// compiled member node returning call3795 (depth = 7)
  gc_frame_newslot(call3795);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3796 = gc_frame_new();
// call case 3: self.outer request
  Object call3797 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3796);
// compiled member node returning call3797 (depth = 7)
  params[0] = call3795;
  partcv[0] = 1;
  Object call3798 = callmethodflags(call3797, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3791);
// compiled call node returning call3798 (depth = 6)
    gc_frame_newslot(call3798);
    if3776 = call3798;
  } else {
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 575
  setline(575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3801 == NULL) {
    strlit3801 = alloc_String("t");
    gc_root(strlit3801);
  }
// compiled string node returning strlit3801 (depth = 8)
  int op_slot_right_3800 = gc_frame_newslot(strlit3801);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_3800 = gc_frame_newslot(*var_c);
  params[0] = strlit3801;
  partcv[0] = 1;
  Object opresult3803 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult3803 (depth = 7)
  Object if3799 = done;
  if (istrue(opresult3803)) {
// Begin line 577
  setline(577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3804 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3806 == NULL) {
    strlit3806 = alloc_String("""\x09""");
    gc_root(strlit3806);
  }
// compiled string node returning strlit3806 (depth = 9)
  int op_slot_right_3805 = gc_frame_newslot(strlit3806);
// starting to compile member node (depth = 9)
  int callframe3808 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe3809 = gc_frame_new();
// call case 3: self.outer request
  Object call3810 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3809);
// compiled member node returning call3810 (depth = 10)
  partcv[0] = 0;
  Object call3811 = callmethodflags(call3810, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3808);
// compiled member node returning call3811 (depth = 9)
  int op_slot_left_3805 = gc_frame_newslot(call3811);
  params[0] = strlit3806;
  partcv[0] = 1;
  Object opresult3812 = callmethod(call3811, "++(1)", 1, partcv, params);
// compiled op node returning opresult3812 (depth = 8)
  gc_frame_newslot(opresult3812);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3813 = gc_frame_new();
// call case 3: self.outer request
  Object call3814 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3813);
// compiled member node returning call3814 (depth = 8)
  params[0] = opresult3812;
  partcv[0] = 1;
  Object call3815 = callmethodflags(call3814, "accum:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3804);
// compiled call node returning call3815 (depth = 7)
    gc_frame_newslot(call3815);
    if3799 = call3815;
  } else {
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3818 == NULL) {
    strlit3818 = alloc_String("r");
    gc_root(strlit3818);
  }
// compiled string node returning strlit3818 (depth = 9)
  int op_slot_right_3817 = gc_frame_newslot(strlit3818);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_3817 = gc_frame_newslot(*var_c);
  params[0] = strlit3818;
  partcv[0] = 1;
  Object opresult3820 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult3820 (depth = 8)
  Object if3816 = done;
  if (istrue(opresult3820)) {
// Begin line 580
  setline(580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3821 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3823 == NULL) {
    strlit3823 = alloc_String("""\x0d""");
    gc_root(strlit3823);
  }
// compiled string node returning strlit3823 (depth = 10)
  int op_slot_right_3822 = gc_frame_newslot(strlit3823);
// starting to compile member node (depth = 10)
  int callframe3825 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe3826 = gc_frame_new();
// call case 3: self.outer request
  Object call3827 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3826);
// compiled member node returning call3827 (depth = 11)
  partcv[0] = 0;
  Object call3828 = callmethodflags(call3827, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3825);
// compiled member node returning call3828 (depth = 10)
  int op_slot_left_3822 = gc_frame_newslot(call3828);
  params[0] = strlit3823;
  partcv[0] = 1;
  Object opresult3829 = callmethod(call3828, "++(1)", 1, partcv, params);
// compiled op node returning opresult3829 (depth = 9)
  gc_frame_newslot(opresult3829);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe3830 = gc_frame_new();
// call case 3: self.outer request
  Object call3831 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3830);
// compiled member node returning call3831 (depth = 9)
  params[0] = opresult3829;
  partcv[0] = 1;
  Object call3832 = callmethodflags(call3831, "accum:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3821);
// compiled call node returning call3832 (depth = 8)
    gc_frame_newslot(call3832);
    if3816 = call3832;
  } else {
// Begin line 584
  setline(584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3835 == NULL) {
    strlit3835 = alloc_String("b");
    gc_root(strlit3835);
  }
// compiled string node returning strlit3835 (depth = 10)
  int op_slot_right_3834 = gc_frame_newslot(strlit3835);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_left_3834 = gc_frame_newslot(*var_c);
  params[0] = strlit3835;
  partcv[0] = 1;
  Object opresult3837 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult3837 (depth = 9)
  Object if3833 = done;
  if (istrue(opresult3837)) {
// Begin line 583
  setline(583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe3838 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3840 == NULL) {
    strlit3840 = alloc_String("""\x08""");
    gc_root(strlit3840);
  }
// compiled string node returning strlit3840 (depth = 11)
  int op_slot_right_3839 = gc_frame_newslot(strlit3840);
// starting to compile member node (depth = 11)
  int callframe3842 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe3843 = gc_frame_new();
// call case 3: self.outer request
  Object call3844 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3843);
// compiled member node returning call3844 (depth = 12)
  partcv[0] = 0;
  Object call3845 = callmethodflags(call3844, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3842);
// compiled member node returning call3845 (depth = 11)
  int op_slot_left_3839 = gc_frame_newslot(call3845);
  params[0] = strlit3840;
  partcv[0] = 1;
  Object opresult3846 = callmethod(call3845, "++(1)", 1, partcv, params);
// compiled op node returning opresult3846 (depth = 10)
  gc_frame_newslot(opresult3846);
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe3847 = gc_frame_new();
// call case 3: self.outer request
  Object call3848 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3847);
// compiled member node returning call3848 (depth = 10)
  params[0] = opresult3846;
  partcv[0] = 1;
  Object call3849 = callmethodflags(call3848, "accum:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3838);
// compiled call node returning call3849 (depth = 9)
    gc_frame_newslot(call3849);
    if3833 = call3849;
  } else {
// Begin line 587
  setline(587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 584
  setline(584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3852 == NULL) {
    strlit3852 = alloc_String("l");
    gc_root(strlit3852);
  }
// compiled string node returning strlit3852 (depth = 11)
  int op_slot_right_3851 = gc_frame_newslot(strlit3852);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  int op_slot_left_3851 = gc_frame_newslot(*var_c);
  params[0] = strlit3852;
  partcv[0] = 1;
  Object opresult3854 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult3854 (depth = 10)
  Object if3850 = done;
  if (istrue(opresult3854)) {
// Begin line 586
  setline(586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3855 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit3857 == NULL) {
    strlit3857 = alloc_String("""\xe2""""\x80""""\xa8""");
    gc_root(strlit3857);
  }
// compiled string node returning strlit3857 (depth = 12)
  int op_slot_right_3856 = gc_frame_newslot(strlit3857);
// starting to compile member node (depth = 12)
  int callframe3859 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 13)
  int callframe3860 = gc_frame_new();
// call case 3: self.outer request
  Object call3861 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3860);
// compiled member node returning call3861 (depth = 13)
  partcv[0] = 0;
  Object call3862 = callmethodflags(call3861, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3859);
// compiled member node returning call3862 (depth = 12)
  int op_slot_left_3856 = gc_frame_newslot(call3862);
  params[0] = strlit3857;
  partcv[0] = 1;
  Object opresult3863 = callmethod(call3862, "++(1)", 1, partcv, params);
// compiled op node returning opresult3863 (depth = 11)
  gc_frame_newslot(opresult3863);
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe3864 = gc_frame_new();
// call case 3: self.outer request
  Object call3865 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3864);
// compiled member node returning call3865 (depth = 11)
  params[0] = opresult3863;
  partcv[0] = 1;
  Object call3866 = callmethodflags(call3865, "accum:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3855);
// compiled call node returning call3866 (depth = 10)
    gc_frame_newslot(call3866);
    if3850 = call3866;
  } else {
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 587
  setline(587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit3869 == NULL) {
    strlit3869 = alloc_String("f");
    gc_root(strlit3869);
  }
// compiled string node returning strlit3869 (depth = 12)
  int op_slot_right_3868 = gc_frame_newslot(strlit3869);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_c (depth = 12)
  int op_slot_left_3868 = gc_frame_newslot(*var_c);
  params[0] = strlit3869;
  partcv[0] = 1;
  Object opresult3871 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult3871 (depth = 11)
  Object if3867 = done;
  if (istrue(opresult3871)) {
// Begin line 589
  setline(589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe3872 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit3874 == NULL) {
    strlit3874 = alloc_String("""\x0c""");
    gc_root(strlit3874);
  }
// compiled string node returning strlit3874 (depth = 13)
  int op_slot_right_3873 = gc_frame_newslot(strlit3874);
// starting to compile member node (depth = 13)
  int callframe3876 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 14)
  int callframe3877 = gc_frame_new();
// call case 3: self.outer request
  Object call3878 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3877);
// compiled member node returning call3878 (depth = 14)
  partcv[0] = 0;
  Object call3879 = callmethodflags(call3878, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3876);
// compiled member node returning call3879 (depth = 13)
  int op_slot_left_3873 = gc_frame_newslot(call3879);
  params[0] = strlit3874;
  partcv[0] = 1;
  Object opresult3880 = callmethod(call3879, "++(1)", 1, partcv, params);
// compiled op node returning opresult3880 (depth = 12)
  gc_frame_newslot(opresult3880);
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe3881 = gc_frame_new();
// call case 3: self.outer request
  Object call3882 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3881);
// compiled member node returning call3882 (depth = 12)
  params[0] = opresult3880;
  partcv[0] = 1;
  Object call3883 = callmethodflags(call3882, "accum:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3872);
// compiled call node returning call3883 (depth = 11)
    gc_frame_newslot(call3883);
    if3867 = call3883;
  } else {
// Begin line 593
  setline(593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit3886 == NULL) {
    strlit3886 = alloc_String("e");
    gc_root(strlit3886);
  }
// compiled string node returning strlit3886 (depth = 13)
  int op_slot_right_3885 = gc_frame_newslot(strlit3886);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_c (depth = 13)
  int op_slot_left_3885 = gc_frame_newslot(*var_c);
  params[0] = strlit3886;
  partcv[0] = 1;
  Object opresult3888 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult3888 (depth = 12)
  Object if3884 = done;
  if (istrue(opresult3888)) {
// Begin line 592
  setline(592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe3889 = gc_frame_new();
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit3891 == NULL) {
    strlit3891 = alloc_String("""\x1b""");
    gc_root(strlit3891);
  }
// compiled string node returning strlit3891 (depth = 14)
  int op_slot_right_3890 = gc_frame_newslot(strlit3891);
// starting to compile member node (depth = 14)
  int callframe3893 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 15)
  int callframe3894 = gc_frame_new();
// call case 3: self.outer request
  Object call3895 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3894);
// compiled member node returning call3895 (depth = 15)
  partcv[0] = 0;
  Object call3896 = callmethodflags(call3895, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3893);
// compiled member node returning call3896 (depth = 14)
  int op_slot_left_3890 = gc_frame_newslot(call3896);
  params[0] = strlit3891;
  partcv[0] = 1;
  Object opresult3897 = callmethod(call3896, "++(1)", 1, partcv, params);
// compiled op node returning opresult3897 (depth = 13)
  gc_frame_newslot(opresult3897);
// call case 6: other requests
// starting to compile member node (depth = 13)
  int callframe3898 = gc_frame_new();
// call case 3: self.outer request
  Object call3899 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3898);
// compiled member node returning call3899 (depth = 13)
  params[0] = opresult3897;
  partcv[0] = 1;
  Object call3900 = callmethodflags(call3899, "accum:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3889);
// compiled call node returning call3900 (depth = 12)
    gc_frame_newslot(call3900);
    if3884 = call3900;
  } else {
// Begin line 596
  setline(596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 593
  setline(593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit3903 == NULL) {
    strlit3903 = alloc_String("_");
    gc_root(strlit3903);
  }
// compiled string node returning strlit3903 (depth = 14)
  int op_slot_right_3902 = gc_frame_newslot(strlit3903);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_c (depth = 14)
  int op_slot_left_3902 = gc_frame_newslot(*var_c);
  params[0] = strlit3903;
  partcv[0] = 1;
  Object opresult3905 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult3905 (depth = 13)
  Object if3901 = done;
  if (istrue(opresult3905)) {
// Begin line 595
  setline(595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe3906 = gc_frame_new();
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit3908 == NULL) {
    strlit3908 = alloc_String("""\xc2""""\xa0""");
    gc_root(strlit3908);
  }
// compiled string node returning strlit3908 (depth = 15)
  int op_slot_right_3907 = gc_frame_newslot(strlit3908);
// starting to compile member node (depth = 15)
  int callframe3910 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 16)
  int callframe3911 = gc_frame_new();
// call case 3: self.outer request
  Object call3912 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3911);
// compiled member node returning call3912 (depth = 16)
  partcv[0] = 0;
  Object call3913 = callmethodflags(call3912, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3910);
// compiled member node returning call3913 (depth = 15)
  int op_slot_left_3907 = gc_frame_newslot(call3913);
  params[0] = strlit3908;
  partcv[0] = 1;
  Object opresult3914 = callmethod(call3913, "++(1)", 1, partcv, params);
// compiled op node returning opresult3914 (depth = 14)
  gc_frame_newslot(opresult3914);
// call case 6: other requests
// starting to compile member node (depth = 14)
  int callframe3915 = gc_frame_new();
// call case 3: self.outer request
  Object call3916 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3915);
// compiled member node returning call3916 (depth = 14)
  params[0] = opresult3914;
  partcv[0] = 1;
  Object call3917 = callmethodflags(call3916, "accum:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3906);
// compiled call node returning call3917 (depth = 13)
    gc_frame_newslot(call3917);
    if3901 = call3917;
  } else {
// Begin line 599
  setline(599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe3918 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_c (depth = 14)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 14)
  int callframe3919 = gc_frame_new();
// call case 3: self.outer request
  Object call3920 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3919);
// compiled member node returning call3920 (depth = 14)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3921 = callmethodflags(call3920, "store(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3918);
// compiled call node returning call3921 (depth = 13)
    gc_frame_newslot(call3921);
    if3901 = call3921;
  }
// compiled if node returning if3901 (depth = 12)
    gc_frame_newslot(if3901);
    if3884 = if3901;
  }
// compiled if node returning if3884 (depth = 11)
    gc_frame_newslot(if3884);
    if3867 = if3884;
  }
// compiled if node returning if3867 (depth = 10)
    gc_frame_newslot(if3867);
    if3850 = if3867;
  }
// compiled if node returning if3850 (depth = 9)
    gc_frame_newslot(if3850);
    if3833 = if3850;
  }
// compiled if node returning if3833 (depth = 8)
    gc_frame_newslot(if3833);
    if3816 = if3833;
  }
// compiled if node returning if3816 (depth = 7)
    gc_frame_newslot(if3816);
    if3799 = if3816;
  }
// compiled if node returning if3799 (depth = 6)
    gc_frame_newslot(if3799);
    if3776 = if3799;
  }
// compiled if node returning if3776 (depth = 5)
    gc_frame_newslot(if3776);
    if3753 = if3776;
  }
// compiled if node returning if3753 (depth = 4)
    gc_frame_newslot(if3753);
    if3736 = if3753;
  }
// compiled if node returning if3736 (depth = 3)
    gc_frame_newslot(if3736);
    if3727 = if3736;
  }
// compiled if node returning if3727 (depth = 2)
  gc_frame_end(frame);
  return if3727;
}
Object meth_lexer_3924_consume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "consume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method consume(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for consume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part consume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 607
  setline(607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3927 == NULL) {
    strlit3927 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit3927);
  }
// compiled string node returning strlit3927 (depth = 4)
  int op_slot_right_3926 = gc_frame_newslot(strlit3927);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_left_3926 = gc_frame_newslot(*var_c);
  params[0] = strlit3927;
  partcv[0] = 1;
  Object opresult3929 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult3929 (depth = 3)
  Object if3925 = done;
  if (istrue(opresult3929)) {
// Begin line 608
  setline(608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3930 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3931 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3932 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3933 = gc_frame_new();
// call case 3: self.outer request
  Object call3934 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3933);
// compiled member node returning call3934 (depth = 6)
  partcv[0] = 0;
  Object call3935 = callmethodflags(call3934, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3932);
// compiled member node returning call3935 (depth = 5)
  gc_frame_newslot(call3935);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3936 = gc_frame_new();
// call case 3: self.outer request
  Object call3937 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3936);
// compiled member node returning call3937 (depth = 5)
  params[0] = call3935;
  partcv[0] = 1;
  Object call3938 = callmethodflags(call3937, "multiLineStringToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3931);
// compiled call node returning call3938 (depth = 4)
  gc_frame_newslot(call3938);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3939 = gc_frame_new();
// call case 3: self.outer request
  Object call3940 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3939);
// compiled member node returning call3940 (depth = 4)
  params[0] = call3938;
  partcv[0] = 1;
  Object call3941 = callmethodflags(call3940, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3930);
// compiled call node returning call3941 (depth = 3)
// Begin line 609
  setline(609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3942 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool3943 = alloc_Boolean(0);
// compiled identifier node returning bool3943 (depth = 4)
  gc_frame_newslot(bool3943);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3944 = gc_frame_new();
// call case 3: self.outer request
  Object call3945 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3944);
// compiled member node returning call3945 (depth = 4)
  params[0] = bool3943;
  partcv[0] = 1;
  Object call3946 = callmethodflags(call3945, "inStr:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3942);
// compiled call node returning call3946 (depth = 3)
// Begin line 610
  setline(610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3947 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3948 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3949 = gc_frame_new();
// call case 3: self.outer request
  Object call3950 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3949);
// compiled member node returning call3950 (depth = 5)
  partcv[0] = 0;
  Object call3951 = callmethodflags(call3950, "defaultState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3948);
// compiled member node returning call3951 (depth = 4)
  gc_frame_newslot(call3951);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3952 = gc_frame_new();
// call case 3: self.outer request
  Object call3953 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3952);
// compiled member node returning call3953 (depth = 4)
  params[0] = call3951;
  partcv[0] = 1;
  Object call3954 = callmethodflags(call3953, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3947);
// compiled call node returning call3954 (depth = 3)
    gc_frame_newslot(call3954);
    if3925 = call3954;
  } else {
// Begin line 612
  setline(612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3955 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3956 = gc_frame_new();
// call case 3: self.outer request
  Object call3957 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3956);
// compiled member node returning call3957 (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3958 = callmethodflags(call3957, "store(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3955);
// compiled call node returning call3958 (depth = 3)
    gc_frame_newslot(call3958);
    if3925 = call3958;
  }
// compiled if node returning if3925 (depth = 2)
  gc_frame_end(frame);
  return if3925;
}
Object meth_lexer_3961_consume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "consume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method consume(_)");
  Object params[5];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for consume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part consume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// definebindings:
// definebindings:
// definebindings:
// Begin line 621
  setline(621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3962 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3963 = gc_frame_new();
// call case 3: self.outer request
  Object call3964 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3963);
// compiled member node returning call3964 (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3965 = callmethodflags(call3964, "checkSeparator(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3962);
// compiled call node returning call3965 (depth = 2)
// Begin line 622
  setline(622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3967 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_lexer (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3968 = callmethodflags(module_lexer, "isDigit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3967);
// compiled call node returning call3968 (depth = 3)
  Object if3966 = done;
  if (istrue(call3968)) {
// Begin line 623
  setline(623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3969 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3970 = gc_frame_new();
// call case 3: self.outer request
  Object call3971 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3970);
// compiled member node returning call3971 (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3972 = callmethodflags(call3971, "store(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3969);
// compiled call node returning call3972 (depth = 3)
    gc_frame_newslot(call3972);
    if3966 = call3972;
  } else {
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 624
  setline(624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3975 == NULL) {
    strlit3975 = alloc_String("x");
    gc_root(strlit3975);
  }
// compiled string node returning strlit3975 (depth = 5)
  int op_slot_right_3974 = gc_frame_newslot(strlit3975);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  int op_slot_left_3974 = gc_frame_newslot(*var_c);
  params[0] = strlit3975;
  partcv[0] = 1;
  Object opresult3977 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult3977 (depth = 4)
  Object if3973 = done;
  if (istrue(opresult3977)) {
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3978 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3979 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3980 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3981 = gc_frame_new();
// call case 3: self.outer request
  Object call3982 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3981);
// compiled member node returning call3982 (depth = 7)
  partcv[0] = 0;
  Object call3983 = callmethodflags(call3982, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3980);
// compiled member node returning call3983 (depth = 6)
  partcv[0] = 0;
  Object call3984 = callmethodflags(call3983, "asNumber", 1, partcv, params, 0);
  gc_frame_end(callframe3979);
// compiled member node returning call3984 (depth = 5)
  gc_frame_newslot(call3984);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3985 = gc_frame_new();
// call case 3: self.outer request
  Object call3986 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3985);
// compiled member node returning call3986 (depth = 5)
  params[0] = call3984;
  partcv[0] = 1;
  Object call3987 = callmethodflags(call3986, "tokenBase:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3978);
// compiled call node returning call3987 (depth = 4)
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3990 = alloc_Float64(0);
// compiled num node returning num3990 (depth = 6)
  int op_slot_right_3989 = gc_frame_newslot(num3990);
// starting to compile member node (depth = 6)
  int callframe3992 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3993 = gc_frame_new();
// call case 3: self.outer request
  Object call3994 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3993);
// compiled member node returning call3994 (depth = 7)
  partcv[0] = 0;
  Object call3995 = callmethodflags(call3994, "tokenBase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3992);
// compiled member node returning call3995 (depth = 6)
  int op_slot_left_3989 = gc_frame_newslot(call3995);
  params[0] = num3990;
  partcv[0] = 1;
  Object opresult3996 = callmethod(call3995, "==(1)", 1, partcv, params);
// compiled op node returning opresult3996 (depth = 5)
  Object if3988 = done;
  if (istrue(opresult3996)) {
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3997 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num3998 = alloc_Float64(16);
// compiled num node returning num3998 (depth = 6)
  gc_frame_newslot(num3998);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3999 = gc_frame_new();
// call case 3: self.outer request
  Object call4000 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3999);
// compiled member node returning call4000 (depth = 6)
  params[0] = num3998;
  partcv[0] = 1;
  Object call4001 = callmethodflags(call4000, "tokenBase:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3997);
// compiled call node returning call4001 (depth = 5)
    gc_frame_newslot(call4001);
    if3988 = call4001;
  } else {
  }
// compiled if node returning if3988 (depth = 4)
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4002 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4003 == NULL) {
    strlit4003 = alloc_String("");
    gc_root(strlit4003);
  }
// compiled string node returning strlit4003 (depth = 5)
  gc_frame_newslot(strlit4003);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4004 = gc_frame_new();
// call case 3: self.outer request
  Object call4005 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4004);
// compiled member node returning call4005 (depth = 5)
  params[0] = strlit4003;
  partcv[0] = 1;
  Object call4006 = callmethodflags(call4005, "accum:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4002);
// compiled call node returning call4006 (depth = 4)
// Begin line 630
  setline(630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4007 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4008 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4009 = gc_frame_new();
// call case 3: self.outer request
  Object call4010 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4009);
// compiled member node returning call4010 (depth = 6)
  partcv[0] = 0;
  Object call4011 = callmethodflags(call4010, "numberBaseState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4008);
// compiled member node returning call4011 (depth = 5)
  gc_frame_newslot(call4011);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4012 = gc_frame_new();
// call case 3: self.outer request
  Object call4013 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4012);
// compiled member node returning call4013 (depth = 5)
  params[0] = call4011;
  partcv[0] = 1;
  Object call4014 = callmethodflags(call4013, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4007);
// compiled call node returning call4014 (depth = 4)
    gc_frame_newslot(call4014);
    if3973 = call4014;
  } else {
// Begin line 635
  setline(635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4018 == NULL) {
    strlit4018 = alloc_String("E");
    gc_root(strlit4018);
  }
// compiled string node returning strlit4018 (depth = 7)
  int op_slot_right_4017 = gc_frame_newslot(strlit4018);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_left_4017 = gc_frame_newslot(*var_c);
  params[0] = strlit4018;
  partcv[0] = 1;
  Object opresult4020 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult4020 (depth = 6)
  int op_slot_right_4016 = gc_frame_newslot(opresult4020);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4023 == NULL) {
    strlit4023 = alloc_String("e");
    gc_root(strlit4023);
  }
// compiled string node returning strlit4023 (depth = 7)
  int op_slot_right_4022 = gc_frame_newslot(strlit4023);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_left_4022 = gc_frame_newslot(*var_c);
  params[0] = strlit4023;
  partcv[0] = 1;
  Object opresult4025 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult4025 (depth = 6)
  int op_slot_left_4016 = gc_frame_newslot(opresult4025);
  params[0] = opresult4020;
  partcv[0] = 1;
  Object opresult4026 = callmethod(opresult4025, "||(1)", 1, partcv, params);
// compiled op node returning opresult4026 (depth = 5)
  Object if4015 = done;
  if (istrue(opresult4026)) {
// Begin line 632
  setline(632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4027 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4028 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4029 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4030 = gc_frame_new();
// call case 3: self.outer request
  Object call4031 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4030);
// compiled member node returning call4031 (depth = 8)
  partcv[0] = 0;
  Object call4032 = callmethodflags(call4031, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4029);
// compiled member node returning call4032 (depth = 7)
  partcv[0] = 0;
  Object call4033 = callmethodflags(call4032, "asNumber", 1, partcv, params, 0);
  gc_frame_end(callframe4028);
// compiled member node returning call4033 (depth = 6)
  gc_frame_newslot(call4033);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4034 = gc_frame_new();
// call case 3: self.outer request
  Object call4035 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4034);
// compiled member node returning call4035 (depth = 6)
  params[0] = call4033;
  partcv[0] = 1;
  Object call4036 = callmethodflags(call4035, "mantissa:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4027);
// compiled call node returning call4036 (depth = 5)
// Begin line 633
  setline(633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4037 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4038 == NULL) {
    strlit4038 = alloc_String("");
    gc_root(strlit4038);
  }
// compiled string node returning strlit4038 (depth = 6)
  gc_frame_newslot(strlit4038);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4039 = gc_frame_new();
// call case 3: self.outer request
  Object call4040 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4039);
// compiled member node returning call4040 (depth = 6)
  params[0] = strlit4038;
  partcv[0] = 1;
  Object call4041 = callmethodflags(call4040, "accum:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4037);
// compiled call node returning call4041 (depth = 5)
// Begin line 634
  setline(634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4042 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4043 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4044 = gc_frame_new();
// call case 3: self.outer request
  Object call4045 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4044);
// compiled member node returning call4045 (depth = 7)
  partcv[0] = 0;
  Object call4046 = callmethodflags(call4045, "numberExponentSignState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4043);
// compiled member node returning call4046 (depth = 6)
  gc_frame_newslot(call4046);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4047 = gc_frame_new();
// call case 3: self.outer request
  Object call4048 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4047);
// compiled member node returning call4048 (depth = 6)
  params[0] = call4046;
  partcv[0] = 1;
  Object call4049 = callmethodflags(call4048, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4042);
// compiled call node returning call4049 (depth = 5)
    gc_frame_newslot(call4049);
    if4015 = call4049;
  } else {
// Begin line 640
  setline(640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 635
  setline(635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4051 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_lexer (depth = 7)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4052 = callmethodflags(module_lexer, "isLetter(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4051);
// compiled call node returning call4052 (depth = 6)
  Object if4050 = done;
  if (istrue(call4052)) {
// Begin line 636
  setline(636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4053 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4054 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call4055 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe4054);
// compiled member node returning call4055 (depth = 8)
  partcv[0] = 0;
  Object call4056 = callmethodflags(call4055, "new", 1, partcv, params, 0);
  gc_frame_end(callframe4053);
// compiled member node returning call4056 (depth = 7)
  *var_suggestion = call4056;
  if (call4056 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 637
  setline(637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4057 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4058 == NULL) {
    strlit4058 = alloc_String(".");
    gc_root(strlit4058);
  }
// compiled string node returning strlit4058 (depth = 7)
  gc_frame_newslot(strlit4058);
// starting to compile member node (depth = 7)
  int callframe4059 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4060 = gc_frame_new();
// call case 3: self.outer request
  Object call4061 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4060);
// compiled member node returning call4061 (depth = 8)
  partcv[0] = 0;
  Object call4062 = callmethodflags(call4061, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4059);
// compiled member node returning call4062 (depth = 7)
  gc_frame_newslot(call4062);
// starting to compile member node (depth = 7)
  int callframe4063 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4064 = gc_frame_new();
// call case 3: self.outer request
  Object call4065 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4064);
// compiled member node returning call4065 (depth = 8)
  partcv[0] = 0;
  Object call4066 = callmethodflags(call4065, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4063);
// compiled member node returning call4066 (depth = 7)
  gc_frame_newslot(call4066);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4058;
  params[1] = call4062;
  params[2] = call4066;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4067 = callmethodflags(*var_suggestion, "insert(1)atPosition(1)onLine(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4057);
// compiled call node returning call4067 (depth = 6)
// Begin line 638
  setline(638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4068 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4070 == NULL) {
    strlit4070 = alloc_String("' is not a valid digit in base 10. Valid digits are 0..9.");
    gc_root(strlit4070);
  }
// compiled string node returning strlit4070 (depth = 8)
  int op_slot_right_4069 = gc_frame_newslot(strlit4070);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_right_4072 = gc_frame_newslot(*var_c);
// starting to compile string node (depth = 9)
  if (strlit4074 == NULL) {
    strlit4074 = alloc_String("'");
    gc_root(strlit4074);
  }
// compiled string node returning strlit4074 (depth = 9)
  int op_slot_left_4072 = gc_frame_newslot(strlit4074);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult4075 = callmethod(strlit4074, "++(1)", 1, partcv, params);
// compiled op node returning opresult4075 (depth = 8)
  int op_slot_left_4069 = gc_frame_newslot(opresult4075);
  params[0] = strlit4070;
  partcv[0] = 1;
  Object opresult4076 = callmethod(opresult4075, "++(1)", 1, partcv, params);
// compiled op node returning opresult4076 (depth = 7)
  gc_frame_newslot(opresult4076);
// Begin line 639
  setline(639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe4077 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4078 = gc_frame_new();
// call case 3: self.outer request
  Object call4079 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4078);
// compiled member node returning call4079 (depth = 8)
  partcv[0] = 0;
  Object call4080 = callmethodflags(call4079, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4077);
// compiled member node returning call4080 (depth = 7)
  gc_frame_newslot(call4080);
// starting to compile member node (depth = 7)
  int callframe4081 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4082 = gc_frame_new();
// call case 3: self.outer request
  Object call4083 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4082);
// compiled member node returning call4083 (depth = 8)
  partcv[0] = 0;
  Object call4084 = callmethodflags(call4083, "startPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4081);
// compiled member node returning call4084 (depth = 7)
  gc_frame_newslot(call4084);
// starting to compile member node (depth = 7)
  int callframe4085 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4086 = gc_frame_new();
// call case 3: self.outer request
  Object call4087 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4086);
// compiled member node returning call4087 (depth = 8)
  partcv[0] = 0;
  Object call4088 = callmethodflags(call4087, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4085);
// compiled member node returning call4088 (depth = 7)
  gc_frame_newslot(call4088);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 638
  setline(638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult4076;
  params[1] = call4080;
  params[2] = call4084;
  params[3] = call4088;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call4089 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4068);
// compiled call node returning call4089 (depth = 6)
    gc_frame_newslot(call4089);
    if4050 = call4089;
  } else {
// Begin line 642
  setline(642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 640
  setline(640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4092 == NULL) {
    strlit4092 = alloc_String(".");
    gc_root(strlit4092);
  }
// compiled string node returning strlit4092 (depth = 8)
  int op_slot_right_4091 = gc_frame_newslot(strlit4092);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_4091 = gc_frame_newslot(*var_c);
  params[0] = strlit4092;
  partcv[0] = 1;
  Object opresult4094 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult4094 (depth = 7)
  Object if4090 = done;
  if (istrue(opresult4094)) {
// Begin line 641
  setline(641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4095 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe4096 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe4097 = gc_frame_new();
// call case 3: self.outer request
  Object call4098 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4097);
// compiled member node returning call4098 (depth = 9)
  partcv[0] = 0;
  Object call4099 = callmethodflags(call4098, "numberDotState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4096);
// compiled member node returning call4099 (depth = 8)
  gc_frame_newslot(call4099);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4100 = gc_frame_new();
// call case 3: self.outer request
  Object call4101 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4100);
// compiled member node returning call4101 (depth = 8)
  params[0] = call4099;
  partcv[0] = 1;
  Object call4102 = callmethodflags(call4101, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4095);
// compiled call node returning call4102 (depth = 7)
    gc_frame_newslot(call4102);
    if4090 = call4102;
  } else {
// Begin line 643
  setline(643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4103 = gc_frame_new();
// starting to compile call node (depth = 8)
  int callframe4104 = gc_frame_new();
// starting to compile member node (depth = 9)
  int callframe4105 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe4106 = gc_frame_new();
// call case 3: self.outer request
  Object call4107 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4106);
// compiled member node returning call4107 (depth = 10)
  partcv[0] = 0;
  Object call4108 = callmethodflags(call4107, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4105);
// compiled member node returning call4108 (depth = 9)
  gc_frame_newslot(call4108);
// starting to compile num node (depth = 9)
  Object num4109 = alloc_Float64(10);
// compiled num node returning num4109 (depth = 9)
  gc_frame_newslot(num4109);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe4110 = gc_frame_new();
// call case 3: self.outer request
  Object call4111 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4110);
// compiled member node returning call4111 (depth = 9)
  params[0] = call4108;
  params[1] = num4109;
  partcv[0] = 2;
  Object call4112 = callmethodflags(call4111, "numToken(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4104);
// compiled call node returning call4112 (depth = 8)
  gc_frame_newslot(call4112);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4113 = gc_frame_new();
// call case 3: self.outer request
  Object call4114 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4113);
// compiled member node returning call4114 (depth = 8)
  params[0] = call4112;
  partcv[0] = 1;
  Object call4115 = callmethodflags(call4114, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4103);
// compiled call node returning call4115 (depth = 7)
// Begin line 644
  setline(644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4116 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe4117 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe4118 = gc_frame_new();
// call case 3: self.outer request
  Object call4119 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4118);
// compiled member node returning call4119 (depth = 9)
  partcv[0] = 0;
  Object call4120 = callmethodflags(call4119, "defaultState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4117);
// compiled member node returning call4120 (depth = 8)
  gc_frame_newslot(call4120);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4121 = gc_frame_new();
// call case 3: self.outer request
  Object call4122 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4121);
// compiled member node returning call4122 (depth = 8)
  params[0] = call4120;
  partcv[0] = 1;
  Object call4123 = callmethodflags(call4122, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4116);
// compiled call node returning call4123 (depth = 7)
// Begin line 645
  setline(645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4124 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4125 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe4126 = gc_frame_new();
// call case 3: self.outer request
  Object call4127 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4126);
// compiled member node returning call4127 (depth = 9)
  partcv[0] = 0;
  Object call4128 = callmethodflags(call4127, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4125);
// compiled member node returning call4128 (depth = 8)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4129 = callmethodflags(call4128, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4124);
// compiled call node returning call4129 (depth = 7)
    gc_frame_newslot(call4129);
    if4090 = call4129;
  }
// compiled if node returning if4090 (depth = 6)
    gc_frame_newslot(if4090);
    if4050 = if4090;
  }
// compiled if node returning if4050 (depth = 5)
    gc_frame_newslot(if4050);
    if4015 = if4050;
  }
// compiled if node returning if4015 (depth = 4)
    gc_frame_newslot(if4015);
    if3973 = if4015;
  }
// compiled if node returning if3973 (depth = 3)
    gc_frame_newslot(if3973);
    if3966 = if3973;
  }
// compiled if node returning if3966 (depth = 2)
  gc_frame_end(frame);
  return if3966;
}
Object meth_lexer_4132_consume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "consume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method consume(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for consume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part consume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 651
  setline(651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4133 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4134 = gc_frame_new();
// call case 3: self.outer request
  Object call4135 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4134);
// compiled member node returning call4135 (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4136 = callmethodflags(call4135, "checkSeparator(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4133);
// compiled call node returning call4136 (depth = 2)
// Begin line 652
  setline(652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4139 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_lexer (depth = 5)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4140 = callmethodflags(module_lexer, "isLetter(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4139);
// compiled call node returning call4140 (depth = 4)
  int op_slot_right_4138 = gc_frame_newslot(call4140);
// Begin line 652
  setline(652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4142 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_lexer (depth = 5)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4143 = callmethodflags(module_lexer, "isDigit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4142);
// compiled call node returning call4143 (depth = 4)
  int op_slot_left_4138 = gc_frame_newslot(call4143);
  params[0] = call4140;
  partcv[0] = 1;
  Object opresult4144 = callmethod(call4143, "||(1)", 1, partcv, params);
// compiled op node returning opresult4144 (depth = 3)
  Object if4137 = done;
  if (istrue(opresult4144)) {
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4145 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4146 = gc_frame_new();
// call case 3: self.outer request
  Object call4147 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4146);
// compiled member node returning call4147 (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4148 = callmethodflags(call4147, "store(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4145);
// compiled call node returning call4148 (depth = 3)
    gc_frame_newslot(call4148);
    if4137 = call4148;
  } else {
// Begin line 656
  setline(656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4152 = alloc_Float64(10);
// compiled num node returning num4152 (depth = 6)
  int op_slot_right_4151 = gc_frame_newslot(num4152);
// starting to compile member node (depth = 6)
  int callframe4154 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4155 = gc_frame_new();
// call case 3: self.outer request
  Object call4156 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4155);
// compiled member node returning call4156 (depth = 7)
  partcv[0] = 0;
  Object call4157 = callmethodflags(call4156, "tokenBase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4154);
// compiled member node returning call4157 (depth = 6)
  int op_slot_left_4151 = gc_frame_newslot(call4157);
  params[0] = num4152;
  partcv[0] = 1;
  Object opresult4158 = callmethod(call4157, "==(1)", 1, partcv, params);
// compiled op node returning opresult4158 (depth = 5)
  int op_slot_right_4150 = gc_frame_newslot(opresult4158);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4161 == NULL) {
    strlit4161 = alloc_String(".");
    gc_root(strlit4161);
  }
// compiled string node returning strlit4161 (depth = 6)
  int op_slot_right_4160 = gc_frame_newslot(strlit4161);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_c (depth = 6)
  int op_slot_left_4160 = gc_frame_newslot(*var_c);
  params[0] = strlit4161;
  partcv[0] = 1;
  Object opresult4163 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult4163 (depth = 5)
  int op_slot_left_4150 = gc_frame_newslot(opresult4163);
  params[0] = opresult4158;
  partcv[0] = 1;
  Object opresult4164 = callmethod(opresult4163, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4164 (depth = 4)
  Object if4149 = done;
  if (istrue(opresult4164)) {
// Begin line 655
  setline(655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4165 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4166 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4167 = gc_frame_new();
// call case 3: self.outer request
  Object call4168 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4167);
// compiled member node returning call4168 (depth = 6)
  partcv[0] = 0;
  Object call4169 = callmethodflags(call4168, "numberDotState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4166);
// compiled member node returning call4169 (depth = 5)
  gc_frame_newslot(call4169);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4170 = gc_frame_new();
// call case 3: self.outer request
  Object call4171 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4170);
// compiled member node returning call4171 (depth = 5)
  params[0] = call4169;
  partcv[0] = 1;
  Object call4172 = callmethodflags(call4171, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4165);
// compiled call node returning call4172 (depth = 4)
    gc_frame_newslot(call4172);
    if4149 = call4172;
  } else {
// Begin line 657
  setline(657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4173 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe4174 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4175 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe4176 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe4177 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe4178 = gc_frame_new();
// call case 3: self.outer request
  Object call4179 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4178);
// compiled member node returning call4179 (depth = 9)
  partcv[0] = 0;
  Object call4180 = callmethodflags(call4179, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4177);
// compiled member node returning call4180 (depth = 8)
  gc_frame_newslot(call4180);
// starting to compile member node (depth = 8)
  int callframe4181 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe4182 = gc_frame_new();
// call case 3: self.outer request
  Object call4183 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4182);
// compiled member node returning call4183 (depth = 9)
  partcv[0] = 0;
  Object call4184 = callmethodflags(call4183, "tokenBase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4181);
// compiled member node returning call4184 (depth = 8)
  gc_frame_newslot(call4184);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4185 = gc_frame_new();
// call case 3: self.outer request
  Object call4186 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4185);
// compiled member node returning call4186 (depth = 8)
  params[0] = call4180;
  params[1] = call4184;
  partcv[0] = 2;
  Object call4187 = callmethodflags(call4186, "fromBase(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4176);
// compiled call node returning call4187 (depth = 7)
  partcv[0] = 0;
  Object call4188 = callmethodflags(call4187, "asString", 1, partcv, params, 0);
  gc_frame_end(callframe4175);
// compiled member node returning call4188 (depth = 6)
  gc_frame_newslot(call4188);
// starting to compile member node (depth = 6)
  int callframe4189 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4190 = gc_frame_new();
// call case 3: self.outer request
  Object call4191 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4190);
// compiled member node returning call4191 (depth = 7)
  partcv[0] = 0;
  Object call4192 = callmethodflags(call4191, "tokenBase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4189);
// compiled member node returning call4192 (depth = 6)
  gc_frame_newslot(call4192);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4193 = gc_frame_new();
// call case 3: self.outer request
  Object call4194 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4193);
// compiled member node returning call4194 (depth = 6)
  params[0] = call4188;
  params[1] = call4192;
  partcv[0] = 2;
  Object call4195 = callmethodflags(call4194, "numToken(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4174);
// compiled call node returning call4195 (depth = 5)
  gc_frame_newslot(call4195);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4196 = gc_frame_new();
// call case 3: self.outer request
  Object call4197 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4196);
// compiled member node returning call4197 (depth = 5)
  params[0] = call4195;
  partcv[0] = 1;
  Object call4198 = callmethodflags(call4197, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4173);
// compiled call node returning call4198 (depth = 4)
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4199 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4200 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4201 = gc_frame_new();
// call case 3: self.outer request
  Object call4202 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4201);
// compiled member node returning call4202 (depth = 6)
  partcv[0] = 0;
  Object call4203 = callmethodflags(call4202, "defaultState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4200);
// compiled member node returning call4203 (depth = 5)
  gc_frame_newslot(call4203);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4204 = gc_frame_new();
// call case 3: self.outer request
  Object call4205 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4204);
// compiled member node returning call4205 (depth = 5)
  params[0] = call4203;
  partcv[0] = 1;
  Object call4206 = callmethodflags(call4205, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4199);
// compiled call node returning call4206 (depth = 4)
// Begin line 659
  setline(659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4207 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4208 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4209 = gc_frame_new();
// call case 3: self.outer request
  Object call4210 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4209);
// compiled member node returning call4210 (depth = 6)
  partcv[0] = 0;
  Object call4211 = callmethodflags(call4210, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4208);
// compiled member node returning call4211 (depth = 5)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4212 = callmethodflags(call4211, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4207);
// compiled call node returning call4212 (depth = 4)
    gc_frame_newslot(call4212);
    if4149 = call4212;
  }
// compiled if node returning if4149 (depth = 3)
    gc_frame_newslot(if4149);
    if4137 = if4149;
  }
// compiled if node returning if4137 (depth = 2)
  gc_frame_end(frame);
  return if4137;
}
Object meth_lexer_4215_consume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "consume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method consume(_)");
  Object params[2];
  int partcv[1];
  Object *var_spaceChars = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for consume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part consume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4217 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_lexer (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4218 = callmethodflags(module_lexer, "isDigit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4217);
// compiled call node returning call4218 (depth = 3)
  Object if4216 = done;
  if (istrue(call4218)) {
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4219 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4220 == NULL) {
    strlit4220 = alloc_String(".");
    gc_root(strlit4220);
  }
// compiled string node returning strlit4220 (depth = 4)
  gc_frame_newslot(strlit4220);
// call case 6: other requests
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4221 = gc_frame_new();
// call case 3: self.outer request
  Object call4222 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4221);
// compiled member node returning call4222 (depth = 4)
  params[0] = strlit4220;
  partcv[0] = 1;
  Object call4223 = callmethodflags(call4222, "store(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4219);
// compiled call node returning call4223 (depth = 3)
// Begin line 669
  setline(669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4224 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4225 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4226 = gc_frame_new();
// call case 3: self.outer request
  Object call4227 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4226);
// compiled member node returning call4227 (depth = 5)
  partcv[0] = 0;
  Object call4228 = callmethodflags(call4227, "numberFractionState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4225);
// compiled member node returning call4228 (depth = 4)
  gc_frame_newslot(call4228);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4229 = gc_frame_new();
// call case 3: self.outer request
  Object call4230 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4229);
// compiled member node returning call4230 (depth = 4)
  params[0] = call4228;
  partcv[0] = 1;
  Object call4231 = callmethodflags(call4230, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4224);
// compiled call node returning call4231 (depth = 3)
// Begin line 670
  setline(670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4232 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4233 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4234 = gc_frame_new();
// call case 3: self.outer request
  Object call4235 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4234);
// compiled member node returning call4235 (depth = 5)
  partcv[0] = 0;
  Object call4236 = callmethodflags(call4235, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4233);
// compiled member node returning call4236 (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4237 = callmethodflags(call4236, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4232);
// compiled call node returning call4237 (depth = 3)
    gc_frame_newslot(call4237);
    if4216 = call4237;
  } else {
// Begin line 676
  setline(676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4239 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_spaceChars (depth = 5)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4240 = callmethodflags(*var_spaceChars, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4239);
// compiled call node returning call4240 (depth = 4)
  Object if4238 = done;
  if (istrue(call4240)) {
// Begin line 673
  setline(673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4241 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe4242 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4243 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4244 = gc_frame_new();
// call case 3: self.outer request
  Object call4245 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4244);
// compiled member node returning call4245 (depth = 7)
  partcv[0] = 0;
  Object call4246 = callmethodflags(call4245, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4243);
// compiled member node returning call4246 (depth = 6)
  gc_frame_newslot(call4246);
// starting to compile num node (depth = 6)
  Object num4247 = alloc_Float64(10);
// compiled num node returning num4247 (depth = 6)
  gc_frame_newslot(num4247);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4248 = gc_frame_new();
// call case 3: self.outer request
  Object call4249 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4248);
// compiled member node returning call4249 (depth = 6)
  params[0] = call4246;
  params[1] = num4247;
  partcv[0] = 2;
  Object call4250 = callmethodflags(call4249, "numToken(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4242);
// compiled call node returning call4250 (depth = 5)
  gc_frame_newslot(call4250);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4251 = gc_frame_new();
// call case 3: self.outer request
  Object call4252 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4251);
// compiled member node returning call4252 (depth = 5)
  params[0] = call4250;
  partcv[0] = 1;
  Object call4253 = callmethodflags(call4252, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4241);
// compiled call node returning call4253 (depth = 4)
// Begin line 674
  setline(674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4254 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4255 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4256 = gc_frame_new();
// call case 3: self.outer request
  Object call4257 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4256);
// compiled member node returning call4257 (depth = 6)
  partcv[0] = 0;
  Object call4258 = callmethodflags(call4257, "defaultState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4255);
// compiled member node returning call4258 (depth = 5)
  gc_frame_newslot(call4258);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4259 = gc_frame_new();
// call case 3: self.outer request
  Object call4260 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4259);
// compiled member node returning call4260 (depth = 5)
  params[0] = call4258;
  partcv[0] = 1;
  Object call4261 = callmethodflags(call4260, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4254);
// compiled call node returning call4261 (depth = 4)
// Begin line 675
  setline(675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4262 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4263 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4264 = gc_frame_new();
// call case 3: self.outer request
  Object call4265 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4264);
// compiled member node returning call4265 (depth = 6)
  partcv[0] = 0;
  Object call4266 = callmethodflags(call4265, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4263);
// compiled member node returning call4266 (depth = 5)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4267 = callmethodflags(call4266, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4262);
// compiled call node returning call4267 (depth = 4)
    gc_frame_newslot(call4267);
    if4238 = call4267;
  } else {
// Begin line 677
  setline(677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4268 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe4269 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4270 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4271 = gc_frame_new();
// call case 3: self.outer request
  Object call4272 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4271);
// compiled member node returning call4272 (depth = 7)
  partcv[0] = 0;
  Object call4273 = callmethodflags(call4272, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4270);
// compiled member node returning call4273 (depth = 6)
  gc_frame_newslot(call4273);
// starting to compile num node (depth = 6)
  Object num4274 = alloc_Float64(10);
// compiled num node returning num4274 (depth = 6)
  gc_frame_newslot(num4274);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4275 = gc_frame_new();
// call case 3: self.outer request
  Object call4276 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4275);
// compiled member node returning call4276 (depth = 6)
  params[0] = call4273;
  params[1] = num4274;
  partcv[0] = 2;
  Object call4277 = callmethodflags(call4276, "numToken(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4269);
// compiled call node returning call4277 (depth = 5)
  gc_frame_newslot(call4277);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4278 = gc_frame_new();
// call case 3: self.outer request
  Object call4279 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4278);
// compiled member node returning call4279 (depth = 5)
  params[0] = call4277;
  partcv[0] = 1;
  Object call4280 = callmethodflags(call4279, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4268);
// compiled call node returning call4280 (depth = 4)
// Begin line 678
  setline(678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4281 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4282 == NULL) {
    strlit4282 = alloc_String(".");
    gc_root(strlit4282);
  }
// compiled string node returning strlit4282 (depth = 5)
  gc_frame_newslot(strlit4282);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4283 = gc_frame_new();
// call case 3: self.outer request
  Object call4284 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4283);
// compiled member node returning call4284 (depth = 5)
  params[0] = strlit4282;
  partcv[0] = 1;
  Object call4285 = callmethodflags(call4284, "accum:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4281);
// compiled call node returning call4285 (depth = 4)
// Begin line 679
  setline(679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4286 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4287 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4288 = gc_frame_new();
// call case 3: self.outer request
  Object call4289 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4288);
// compiled member node returning call4289 (depth = 6)
  partcv[0] = 0;
  Object call4290 = callmethodflags(call4289, "dotState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4287);
// compiled member node returning call4290 (depth = 5)
  gc_frame_newslot(call4290);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4291 = gc_frame_new();
// call case 3: self.outer request
  Object call4292 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4291);
// compiled member node returning call4292 (depth = 5)
  params[0] = call4290;
  partcv[0] = 1;
  Object call4293 = callmethodflags(call4292, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4286);
// compiled call node returning call4293 (depth = 4)
// Begin line 680
  setline(680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4294 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4295 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4296 = gc_frame_new();
// call case 3: self.outer request
  Object call4297 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4296);
// compiled member node returning call4297 (depth = 6)
  partcv[0] = 0;
  Object call4298 = callmethodflags(call4297, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4295);
// compiled member node returning call4298 (depth = 5)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4299 = callmethodflags(call4298, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4294);
// compiled call node returning call4299 (depth = 4)
    gc_frame_newslot(call4299);
    if4238 = call4299;
  }
// compiled if node returning if4238 (depth = 3)
    gc_frame_newslot(if4238);
    if4216 = if4238;
  }
// compiled if node returning if4216 (depth = 2)
  gc_frame_end(frame);
  return if4216;
}
Object meth_lexer_4302_consume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "consume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method consume(_)");
  Object params[4];
  int partcv[2];
  Object *var_errormessages = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for consume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part consume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4303 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4304 = gc_frame_new();
// call case 3: self.outer request
  Object call4305 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4304);
// compiled member node returning call4305 (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4306 = callmethodflags(call4305, "checkSeparator(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4303);
// compiled call node returning call4306 (depth = 2)
// Begin line 687
  setline(687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4308 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_lexer (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4309 = callmethodflags(module_lexer, "isDigit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4308);
// compiled call node returning call4309 (depth = 3)
  Object if4307 = done;
  if (istrue(call4309)) {
// Begin line 688
  setline(688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4310 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4311 = gc_frame_new();
// call case 3: self.outer request
  Object call4312 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4311);
// compiled member node returning call4312 (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4313 = callmethodflags(call4312, "store(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4310);
// compiled call node returning call4313 (depth = 3)
    gc_frame_newslot(call4313);
    if4307 = call4313;
  } else {
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4317 == NULL) {
    strlit4317 = alloc_String("E");
    gc_root(strlit4317);
  }
// compiled string node returning strlit4317 (depth = 6)
  int op_slot_right_4316 = gc_frame_newslot(strlit4317);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_c (depth = 6)
  int op_slot_left_4316 = gc_frame_newslot(*var_c);
  params[0] = strlit4317;
  partcv[0] = 1;
  Object opresult4319 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult4319 (depth = 5)
  int op_slot_right_4315 = gc_frame_newslot(opresult4319);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4322 == NULL) {
    strlit4322 = alloc_String("e");
    gc_root(strlit4322);
  }
// compiled string node returning strlit4322 (depth = 6)
  int op_slot_right_4321 = gc_frame_newslot(strlit4322);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_c (depth = 6)
  int op_slot_left_4321 = gc_frame_newslot(*var_c);
  params[0] = strlit4322;
  partcv[0] = 1;
  Object opresult4324 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult4324 (depth = 5)
  int op_slot_left_4315 = gc_frame_newslot(opresult4324);
  params[0] = opresult4319;
  partcv[0] = 1;
  Object opresult4325 = callmethod(opresult4324, "||(1)", 1, partcv, params);
// compiled op node returning opresult4325 (depth = 4)
  Object if4314 = done;
  if (istrue(opresult4325)) {
// Begin line 690
  setline(690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4326 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4327 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4328 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4329 = gc_frame_new();
// call case 3: self.outer request
  Object call4330 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4329);
// compiled member node returning call4330 (depth = 7)
  partcv[0] = 0;
  Object call4331 = callmethodflags(call4330, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4328);
// compiled member node returning call4331 (depth = 6)
  partcv[0] = 0;
  Object call4332 = callmethodflags(call4331, "asNumber", 1, partcv, params, 0);
  gc_frame_end(callframe4327);
// compiled member node returning call4332 (depth = 5)
  gc_frame_newslot(call4332);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4333 = gc_frame_new();
// call case 3: self.outer request
  Object call4334 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4333);
// compiled member node returning call4334 (depth = 5)
  params[0] = call4332;
  partcv[0] = 1;
  Object call4335 = callmethodflags(call4334, "mantissa:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4326);
// compiled call node returning call4335 (depth = 4)
// Begin line 691
  setline(691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4336 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4337 == NULL) {
    strlit4337 = alloc_String("");
    gc_root(strlit4337);
  }
// compiled string node returning strlit4337 (depth = 5)
  gc_frame_newslot(strlit4337);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4338 = gc_frame_new();
// call case 3: self.outer request
  Object call4339 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4338);
// compiled member node returning call4339 (depth = 5)
  params[0] = strlit4337;
  partcv[0] = 1;
  Object call4340 = callmethodflags(call4339, "accum:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4336);
// compiled call node returning call4340 (depth = 4)
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4341 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4342 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4343 = gc_frame_new();
// call case 3: self.outer request
  Object call4344 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4343);
// compiled member node returning call4344 (depth = 6)
  partcv[0] = 0;
  Object call4345 = callmethodflags(call4344, "numberExponentSignState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4342);
// compiled member node returning call4345 (depth = 5)
  gc_frame_newslot(call4345);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4346 = gc_frame_new();
// call case 3: self.outer request
  Object call4347 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4346);
// compiled member node returning call4347 (depth = 5)
  params[0] = call4345;
  partcv[0] = 1;
  Object call4348 = callmethodflags(call4347, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4341);
// compiled call node returning call4348 (depth = 4)
    gc_frame_newslot(call4348);
    if4314 = call4348;
  } else {
// Begin line 696
  setline(696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4350 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_c (depth = 6)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_lexer (depth = 6)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4351 = callmethodflags(module_lexer, "isLetter(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4350);
// compiled call node returning call4351 (depth = 5)
  Object if4349 = done;
  if (istrue(call4351)) {
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4352 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4353 == NULL) {
    strlit4353 = alloc_String("the fractional part of a number must be in base 10.");
    gc_root(strlit4353);
  }
// compiled string node returning strlit4353 (depth = 6)
  gc_frame_newslot(strlit4353);
// Begin line 695
  setline(695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe4354 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4355 = gc_frame_new();
// call case 3: self.outer request
  Object call4356 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4355);
// compiled member node returning call4356 (depth = 7)
  partcv[0] = 0;
  Object call4357 = callmethodflags(call4356, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4354);
// compiled member node returning call4357 (depth = 6)
  gc_frame_newslot(call4357);
// starting to compile member node (depth = 6)
  int callframe4358 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4359 = gc_frame_new();
// call case 3: self.outer request
  Object call4360 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4359);
// compiled member node returning call4360 (depth = 7)
  partcv[0] = 0;
  Object call4361 = callmethodflags(call4360, "startPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4358);
// compiled member node returning call4361 (depth = 6)
  gc_frame_newslot(call4361);
// starting to compile member node (depth = 6)
  int callframe4362 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4363 = gc_frame_new();
// call case 3: self.outer request
  Object call4364 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4363);
// compiled member node returning call4364 (depth = 7)
  partcv[0] = 0;
  Object call4365 = callmethodflags(call4364, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4362);
// compiled member node returning call4365 (depth = 6)
  gc_frame_newslot(call4365);
// call case 6: other requests
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit4353;
  params[1] = call4357;
  params[2] = call4361;
  params[3] = call4365;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call4366 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe4352);
// compiled call node returning call4366 (depth = 5)
    gc_frame_newslot(call4366);
    if4349 = call4366;
  } else {
// Begin line 697
  setline(697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4367 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe4368 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe4369 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4370 = gc_frame_new();
// call case 3: self.outer request
  Object call4371 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4370);
// compiled member node returning call4371 (depth = 8)
  partcv[0] = 0;
  Object call4372 = callmethodflags(call4371, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4369);
// compiled member node returning call4372 (depth = 7)
  gc_frame_newslot(call4372);
// starting to compile num node (depth = 7)
  Object num4373 = alloc_Float64(10);
// compiled num node returning num4373 (depth = 7)
  gc_frame_newslot(num4373);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4374 = gc_frame_new();
// call case 3: self.outer request
  Object call4375 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4374);
// compiled member node returning call4375 (depth = 7)
  params[0] = call4372;
  params[1] = num4373;
  partcv[0] = 2;
  Object call4376 = callmethodflags(call4375, "numToken(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4368);
// compiled call node returning call4376 (depth = 6)
  gc_frame_newslot(call4376);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4377 = gc_frame_new();
// call case 3: self.outer request
  Object call4378 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4377);
// compiled member node returning call4378 (depth = 6)
  params[0] = call4376;
  partcv[0] = 1;
  Object call4379 = callmethodflags(call4378, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4367);
// compiled call node returning call4379 (depth = 5)
// Begin line 698
  setline(698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4380 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4381 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4382 = gc_frame_new();
// call case 3: self.outer request
  Object call4383 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4382);
// compiled member node returning call4383 (depth = 7)
  partcv[0] = 0;
  Object call4384 = callmethodflags(call4383, "defaultState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4381);
// compiled member node returning call4384 (depth = 6)
  gc_frame_newslot(call4384);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4385 = gc_frame_new();
// call case 3: self.outer request
  Object call4386 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4385);
// compiled member node returning call4386 (depth = 6)
  params[0] = call4384;
  partcv[0] = 1;
  Object call4387 = callmethodflags(call4386, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4380);
// compiled call node returning call4387 (depth = 5)
// Begin line 699
  setline(699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4388 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_c (depth = 6)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4389 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4390 = gc_frame_new();
// call case 3: self.outer request
  Object call4391 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4390);
// compiled member node returning call4391 (depth = 7)
  partcv[0] = 0;
  Object call4392 = callmethodflags(call4391, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4389);
// compiled member node returning call4392 (depth = 6)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4393 = callmethodflags(call4392, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4388);
// compiled call node returning call4393 (depth = 5)
    gc_frame_newslot(call4393);
    if4349 = call4393;
  }
// compiled if node returning if4349 (depth = 4)
    gc_frame_newslot(if4349);
    if4314 = if4349;
  }
// compiled if node returning if4314 (depth = 3)
    gc_frame_newslot(if4314);
    if4307 = if4314;
  }
// compiled if node returning if4307 (depth = 2)
  gc_frame_end(frame);
  return if4307;
}
Object meth_lexer_4396_consume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "consume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method consume(_)");
  Object params[4];
  int partcv[2];
  Object *var_errormessages = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for consume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part consume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 705
  setline(705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4397 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4398 = gc_frame_new();
// call case 3: self.outer request
  Object call4399 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4398);
// compiled member node returning call4399 (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4400 = callmethodflags(call4399, "checkSeparator(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4397);
// compiled call node returning call4400 (depth = 2)
// Begin line 706
  setline(706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4404 == NULL) {
    strlit4404 = alloc_String("-");
    gc_root(strlit4404);
  }
// compiled string node returning strlit4404 (depth = 5)
  int op_slot_right_4403 = gc_frame_newslot(strlit4404);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  int op_slot_left_4403 = gc_frame_newslot(*var_c);
  params[0] = strlit4404;
  partcv[0] = 1;
  Object opresult4406 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult4406 (depth = 4)
  int op_slot_right_4402 = gc_frame_newslot(opresult4406);
// starting to compile call node (depth = 4)
  int callframe4408 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_lexer (depth = 5)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4409 = callmethodflags(module_lexer, "isDigit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4408);
// compiled call node returning call4409 (depth = 4)
  int op_slot_left_4402 = gc_frame_newslot(call4409);
  params[0] = opresult4406;
  partcv[0] = 1;
  Object opresult4410 = callmethod(call4409, "||(1)", 1, partcv, params);
// compiled op node returning opresult4410 (depth = 3)
  Object if4401 = done;
  if (istrue(opresult4410)) {
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4411 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4412 = gc_frame_new();
// call case 3: self.outer request
  Object call4413 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4412);
// compiled member node returning call4413 (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4414 = callmethodflags(call4413, "store(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4411);
// compiled call node returning call4414 (depth = 3)
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4415 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4416 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4417 = gc_frame_new();
// call case 3: self.outer request
  Object call4418 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4417);
// compiled member node returning call4418 (depth = 5)
  partcv[0] = 0;
  Object call4419 = callmethodflags(call4418, "numberExponentState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4416);
// compiled member node returning call4419 (depth = 4)
  gc_frame_newslot(call4419);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4420 = gc_frame_new();
// call case 3: self.outer request
  Object call4421 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4420);
// compiled member node returning call4421 (depth = 4)
  params[0] = call4419;
  partcv[0] = 1;
  Object call4422 = callmethodflags(call4421, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4415);
// compiled call node returning call4422 (depth = 3)
    gc_frame_newslot(call4422);
    if4401 = call4422;
  } else {
// Begin line 712
  setline(712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 709
  setline(709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4424 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_lexer (depth = 5)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4425 = callmethodflags(module_lexer, "isLetter(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4424);
// compiled call node returning call4425 (depth = 4)
  Object if4423 = done;
  if (istrue(call4425)) {
// Begin line 710
  setline(710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4426 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4428 == NULL) {
    strlit4428 = alloc_String(" is not an allowed base-10 exponent character");
    gc_root(strlit4428);
  }
// compiled string node returning strlit4428 (depth = 6)
  int op_slot_right_4427 = gc_frame_newslot(strlit4428);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_right_4430 = gc_frame_newslot(*var_c);
// starting to compile string node (depth = 7)
  if (strlit4432 == NULL) {
    strlit4432 = alloc_String("");
    gc_root(strlit4432);
  }
// compiled string node returning strlit4432 (depth = 7)
  int op_slot_left_4430 = gc_frame_newslot(strlit4432);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult4433 = callmethod(strlit4432, "++(1)", 1, partcv, params);
// compiled op node returning opresult4433 (depth = 6)
  int op_slot_left_4427 = gc_frame_newslot(opresult4433);
  params[0] = strlit4428;
  partcv[0] = 1;
  Object opresult4434 = callmethod(opresult4433, "++(1)", 1, partcv, params);
// compiled op node returning opresult4434 (depth = 5)
  gc_frame_newslot(opresult4434);
// Begin line 711
  setline(711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4435 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4436 = gc_frame_new();
// call case 3: self.outer request
  Object call4437 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4436);
// compiled member node returning call4437 (depth = 6)
  partcv[0] = 0;
  Object call4438 = callmethodflags(call4437, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4435);
// compiled member node returning call4438 (depth = 5)
  gc_frame_newslot(call4438);
// starting to compile member node (depth = 5)
  int callframe4439 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4440 = gc_frame_new();
// call case 3: self.outer request
  Object call4441 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4440);
// compiled member node returning call4441 (depth = 6)
  partcv[0] = 0;
  Object call4442 = callmethodflags(call4441, "startPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4439);
// compiled member node returning call4442 (depth = 5)
  gc_frame_newslot(call4442);
// starting to compile member node (depth = 5)
  int callframe4443 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4444 = gc_frame_new();
// call case 3: self.outer request
  Object call4445 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4444);
// compiled member node returning call4445 (depth = 6)
  partcv[0] = 0;
  Object call4446 = callmethodflags(call4445, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4443);
// compiled member node returning call4446 (depth = 5)
  gc_frame_newslot(call4446);
// call case 6: other requests
// Begin line 710
  setline(710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult4434;
  params[1] = call4438;
  params[2] = call4442;
  params[3] = call4446;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call4447 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe4426);
// compiled call node returning call4447 (depth = 4)
    gc_frame_newslot(call4447);
    if4423 = call4447;
  } else {
// Begin line 713
  setline(713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4448 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4449 == NULL) {
    strlit4449 = alloc_String("exponents must have at least one digit");
    gc_root(strlit4449);
  }
// compiled string node returning strlit4449 (depth = 5)
  gc_frame_newslot(strlit4449);
// Begin line 714
  setline(714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4450 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4451 = gc_frame_new();
// call case 3: self.outer request
  Object call4452 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4451);
// compiled member node returning call4452 (depth = 6)
  partcv[0] = 0;
  Object call4453 = callmethodflags(call4452, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4450);
// compiled member node returning call4453 (depth = 5)
  gc_frame_newslot(call4453);
// starting to compile member node (depth = 5)
  int callframe4454 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4455 = gc_frame_new();
// call case 3: self.outer request
  Object call4456 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4455);
// compiled member node returning call4456 (depth = 6)
  partcv[0] = 0;
  Object call4457 = callmethodflags(call4456, "startPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4454);
// compiled member node returning call4457 (depth = 5)
  gc_frame_newslot(call4457);
// starting to compile member node (depth = 5)
  int callframe4458 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4459 = gc_frame_new();
// call case 3: self.outer request
  Object call4460 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4459);
// compiled member node returning call4460 (depth = 6)
  partcv[0] = 0;
  Object call4461 = callmethodflags(call4460, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4458);
// compiled member node returning call4461 (depth = 5)
  gc_frame_newslot(call4461);
// call case 6: other requests
// Begin line 713
  setline(713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit4449;
  params[1] = call4453;
  params[2] = call4457;
  params[3] = call4461;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call4462 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe4448);
// compiled call node returning call4462 (depth = 4)
    gc_frame_newslot(call4462);
    if4423 = call4462;
  }
// compiled if node returning if4423 (depth = 3)
    gc_frame_newslot(if4423);
    if4401 = if4423;
  }
// compiled if node returning if4401 (depth = 2)
  gc_frame_end(frame);
  return if4401;
}
Object meth_lexer_4543__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_absMultiplier = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 738
  setline(738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num4545 = alloc_Float64(10);
// compiled num node returning num4545 (depth = 8)
  int op_slot_right_4544 = gc_frame_newslot(num4545);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_absMultiplier (depth = 8)
  int op_slot_left_4544 = gc_frame_newslot(*var_absMultiplier);
  params[0] = num4545;
  partcv[0] = 1;
  Object prod4547 = callmethod(*var_absMultiplier, "*(1)", 1, partcv, params);
// compiled op node returning prod4547 (depth = 7)
  *var_absMultiplier = prod4547;
  if (prod4547 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer_4465_consume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "consume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method consume(_)");
  Object params[4];
  int partcv[2];
  Object *var_errormessages = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for consume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part consume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_exponent = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "exponent");
  Object *var_absExp = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "absExp");
// definebindings:
// definebindings:
  Object *var_absMultiplier = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "absMultiplier");
// definebindings:
// definebindings:
// Begin line 720
  setline(720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4466 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4467 = gc_frame_new();
// call case 3: self.outer request
  Object call4468 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4467);
// compiled member node returning call4468 (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4469 = callmethodflags(call4468, "checkSeparator(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4466);
// compiled call node returning call4469 (depth = 2)
// Begin line 721
  setline(721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4471 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_lexer (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4472 = callmethodflags(module_lexer, "isDigit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4471);
// compiled call node returning call4472 (depth = 3)
  Object if4470 = done;
  if (istrue(call4472)) {
// Begin line 722
  setline(722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4473 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4474 = gc_frame_new();
// call case 3: self.outer request
  Object call4475 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4474);
// compiled member node returning call4475 (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4476 = callmethodflags(call4475, "store(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4473);
// compiled call node returning call4476 (depth = 3)
    gc_frame_newslot(call4476);
    if4470 = call4476;
  } else {
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4478 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_lexer (depth = 5)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4479 = callmethodflags(module_lexer, "isLetter(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4478);
// compiled call node returning call4479 (depth = 4)
  Object if4477 = done;
  if (istrue(call4479)) {
// Begin line 724
  setline(724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4480 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4482 == NULL) {
    strlit4482 = alloc_String(" is not an allowed base-10 exponent character");
    gc_root(strlit4482);
  }
// compiled string node returning strlit4482 (depth = 6)
  int op_slot_right_4481 = gc_frame_newslot(strlit4482);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_right_4484 = gc_frame_newslot(*var_c);
// starting to compile string node (depth = 7)
  if (strlit4486 == NULL) {
    strlit4486 = alloc_String("");
    gc_root(strlit4486);
  }
// compiled string node returning strlit4486 (depth = 7)
  int op_slot_left_4484 = gc_frame_newslot(strlit4486);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult4487 = callmethod(strlit4486, "++(1)", 1, partcv, params);
// compiled op node returning opresult4487 (depth = 6)
  int op_slot_left_4481 = gc_frame_newslot(opresult4487);
  params[0] = strlit4482;
  partcv[0] = 1;
  Object opresult4488 = callmethod(opresult4487, "++(1)", 1, partcv, params);
// compiled op node returning opresult4488 (depth = 5)
  gc_frame_newslot(opresult4488);
// Begin line 725
  setline(725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4489 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4490 = gc_frame_new();
// call case 3: self.outer request
  Object call4491 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4490);
// compiled member node returning call4491 (depth = 6)
  partcv[0] = 0;
  Object call4492 = callmethodflags(call4491, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4489);
// compiled member node returning call4492 (depth = 5)
  gc_frame_newslot(call4492);
// starting to compile member node (depth = 5)
  int callframe4493 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4494 = gc_frame_new();
// call case 3: self.outer request
  Object call4495 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4494);
// compiled member node returning call4495 (depth = 6)
  partcv[0] = 0;
  Object call4496 = callmethodflags(call4495, "startPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4493);
// compiled member node returning call4496 (depth = 5)
  gc_frame_newslot(call4496);
// starting to compile member node (depth = 5)
  int callframe4497 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4498 = gc_frame_new();
// call case 3: self.outer request
  Object call4499 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4498);
// compiled member node returning call4499 (depth = 6)
  partcv[0] = 0;
  Object call4500 = callmethodflags(call4499, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4497);
// compiled member node returning call4500 (depth = 5)
  gc_frame_newslot(call4500);
// call case 6: other requests
// Begin line 724
  setline(724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult4488;
  params[1] = call4492;
  params[2] = call4496;
  params[3] = call4500;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call4501 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe4480);
// compiled call node returning call4501 (depth = 4)
    gc_frame_newslot(call4501);
    if4477 = call4501;
  } else {
// Begin line 727
  setline(727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4504 == NULL) {
    strlit4504 = alloc_String("-");
    gc_root(strlit4504);
  }
// compiled string node returning strlit4504 (depth = 6)
  int op_slot_right_4503 = gc_frame_newslot(strlit4504);
// starting to compile member node (depth = 6)
  int callframe4506 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4507 = gc_frame_new();
// call case 3: self.outer request
  Object call4508 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4507);
// compiled member node returning call4508 (depth = 7)
  partcv[0] = 0;
  Object call4509 = callmethodflags(call4508, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4506);
// compiled member node returning call4509 (depth = 6)
  int op_slot_left_4503 = gc_frame_newslot(call4509);
  params[0] = strlit4504;
  partcv[0] = 1;
  Object opresult4510 = callmethod(call4509, "==(1)", 1, partcv, params);
// compiled op node returning opresult4510 (depth = 5)
  Object if4502 = done;
  if (istrue(opresult4510)) {
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4511 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4512 == NULL) {
    strlit4512 = alloc_String("exponents must have at least one digit");
    gc_root(strlit4512);
  }
// compiled string node returning strlit4512 (depth = 6)
  gc_frame_newslot(strlit4512);
// Begin line 729
  setline(729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe4513 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4514 = gc_frame_new();
// call case 3: self.outer request
  Object call4515 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4514);
// compiled member node returning call4515 (depth = 7)
  partcv[0] = 0;
  Object call4516 = callmethodflags(call4515, "lineNumber", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4513);
// compiled member node returning call4516 (depth = 6)
  gc_frame_newslot(call4516);
// starting to compile member node (depth = 6)
  int callframe4517 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4518 = gc_frame_new();
// call case 3: self.outer request
  Object call4519 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4518);
// compiled member node returning call4519 (depth = 7)
  partcv[0] = 0;
  Object call4520 = callmethodflags(call4519, "startPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4517);
// compiled member node returning call4520 (depth = 6)
  gc_frame_newslot(call4520);
// starting to compile member node (depth = 6)
  int callframe4521 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4522 = gc_frame_new();
// call case 3: self.outer request
  Object call4523 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4522);
// compiled member node returning call4523 (depth = 7)
  partcv[0] = 0;
  Object call4524 = callmethodflags(call4523, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4521);
// compiled member node returning call4524 (depth = 6)
  gc_frame_newslot(call4524);
// call case 6: other requests
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit4512;
  params[1] = call4516;
  params[2] = call4520;
  params[3] = call4524;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call4525 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe4511);
// compiled call node returning call4525 (depth = 5)
    gc_frame_newslot(call4525);
    if4502 = call4525;
  } else {
  }
// compiled if node returning if4502 (depth = 4)
// Begin line 731
  setline(731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4526 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4527 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4528 = gc_frame_new();
// call case 3: self.outer request
  Object call4529 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4528);
// compiled member node returning call4529 (depth = 7)
  partcv[0] = 0;
  Object call4530 = callmethodflags(call4529, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4527);
// compiled member node returning call4530 (depth = 6)
  partcv[0] = 0;
  Object call4531 = callmethodflags(call4530, "asNumber", 1, partcv, params, 0);
  gc_frame_end(callframe4526);
// compiled member node returning call4531 (depth = 5)
  *var_exponent = call4531;
  if (call4531 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 732
  setline(732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_exponent (depth = 5)
  *var_absExp = *var_exponent;
  if (*var_exponent == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 733
  setline(733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4534 = alloc_Float64(0);
// compiled num node returning num4534 (depth = 6)
  int op_slot_right_4533 = gc_frame_newslot(num4534);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_exponent (depth = 6)
  int op_slot_left_4533 = gc_frame_newslot(*var_exponent);
  params[0] = num4534;
  partcv[0] = 1;
  Object opresult4536 = callmethod(*var_exponent, "<(1)", 1, partcv, params);
// compiled op node returning opresult4536 (depth = 5)
  Object if4532 = done;
  if (istrue(opresult4536)) {
// Begin line 734
  setline(734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 735
  setline(735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4537 = gc_frame_new();
// call case 6: other requests
// Begin line 734
  setline(734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_exponent (depth = 7)
  partcv[0] = 0;
  Object call4538 = callmethodflags(*var_exponent, "prefix-", 1, partcv, params, 0);
  gc_frame_end(callframe4537);
// compiled call node returning call4538 (depth = 6)
  *var_absExp = call4538;
  if (call4538 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if4532 = done;
  } else {
  }
// compiled if node returning if4532 (depth = 4)
// Begin line 736
  setline(736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4540 = alloc_Float64(1);
// compiled num node returning num4540 (depth = 5)
  *var_absMultiplier = num4540;
  if (num4540 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4541 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_absExp (depth = 5)
  gc_frame_newslot(*var_absExp);
// starting to compile block node (depth = 5)
  Object block4542 = alloc_Block(NULL, NULL, "lexer", 737);
  gc_frame_newslot(block4542);
// method "_apply"
  block_savedest(block4542);
  Object closure4543 = createclosure(2, "_apply");
  setclosureframe(closure4543, stackframe);
  addtoclosure(closure4543, var_absMultiplier);
  addtoclosure(closure4543, selfslot);
  struct UserObject *uo4543 = (struct UserObject*)block4542;
  uo4543->data[0] = (Object)closure4543;
  Method *meth_meth_lexer_4543__apply = addmethod2pos(block4542, "_apply", &meth_lexer_4543__apply, 0);
  int argcv_meth_lexer_4543__apply[] = {0};
  meth_meth_lexer_4543__apply->type = alloc_MethodType(1, argcv_meth_lexer_4543__apply);
  meth_meth_lexer_4543__apply->definitionModule = modulename;
  meth_meth_lexer_4543__apply->definitionLine = 1145;
// compiled block node returning block4542 (depth = 5)
  gc_frame_newslot(block4542);
// call case 5: prelude request
  params[0] = *var_absExp;
  params[1] = block4542;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4550 = callmethodflags(prelude, "repeat(1)times(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4541);
// compiled call node returning call4550 (depth = 4)
// Begin line 740
  setline(740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4553 = alloc_Float64(0);
// compiled num node returning num4553 (depth = 6)
  int op_slot_right_4552 = gc_frame_newslot(num4553);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_exponent (depth = 6)
  int op_slot_left_4552 = gc_frame_newslot(*var_exponent);
  params[0] = num4553;
  partcv[0] = 1;
  Object opresult4555 = callmethod(*var_exponent, "≥(1)", 1, partcv, params);
// compiled op node returning opresult4555 (depth = 5)
  Object if4551 = done;
  if (istrue(opresult4555)) {
// Begin line 741
  setline(741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4556 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe4557 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe4558 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_absMultiplier (depth = 9)
  int op_slot_right_4559 = gc_frame_newslot(*var_absMultiplier);
// starting to compile member node (depth = 9)
  int callframe4561 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe4562 = gc_frame_new();
// call case 3: self.outer request
  Object call4563 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4562);
// compiled member node returning call4563 (depth = 10)
  partcv[0] = 0;
  Object call4564 = callmethodflags(call4563, "mantissa", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4561);
// compiled member node returning call4564 (depth = 9)
  int op_slot_left_4559 = gc_frame_newslot(call4564);
  params[0] = *var_absMultiplier;
  partcv[0] = 1;
  Object prod4565 = callmethod(call4564, "*(1)", 1, partcv, params);
// compiled op node returning prod4565 (depth = 8)
  partcv[0] = 0;
  Object call4566 = callmethodflags(prod4565, "asString", 1, partcv, params, 0);
  gc_frame_end(callframe4558);
// compiled member node returning call4566 (depth = 7)
  gc_frame_newslot(call4566);
// starting to compile num node (depth = 7)
  Object num4567 = alloc_Float64(10);
// compiled num node returning num4567 (depth = 7)
  gc_frame_newslot(num4567);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4568 = gc_frame_new();
// call case 3: self.outer request
  Object call4569 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4568);
// compiled member node returning call4569 (depth = 7)
  params[0] = call4566;
  params[1] = num4567;
  partcv[0] = 2;
  Object call4570 = callmethodflags(call4569, "numToken(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4557);
// compiled call node returning call4570 (depth = 6)
  gc_frame_newslot(call4570);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4571 = gc_frame_new();
// call case 3: self.outer request
  Object call4572 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4571);
// compiled member node returning call4572 (depth = 6)
  params[0] = call4570;
  partcv[0] = 1;
  Object call4573 = callmethodflags(call4572, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4556);
// compiled call node returning call4573 (depth = 5)
    gc_frame_newslot(call4573);
    if4551 = call4573;
  } else {
// Begin line 743
  setline(743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4574 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe4575 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe4576 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_absMultiplier (depth = 9)
  int op_slot_right_4577 = gc_frame_newslot(*var_absMultiplier);
// starting to compile member node (depth = 9)
  int callframe4579 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe4580 = gc_frame_new();
// call case 3: self.outer request
  Object call4581 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4580);
// compiled member node returning call4581 (depth = 10)
  partcv[0] = 0;
  Object call4582 = callmethodflags(call4581, "mantissa", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4579);
// compiled member node returning call4582 (depth = 9)
  int op_slot_left_4577 = gc_frame_newslot(call4582);
  params[0] = *var_absMultiplier;
  partcv[0] = 1;
  Object quotient4583 = callmethod(call4582, "/(1)", 1, partcv, params);
// compiled op node returning quotient4583 (depth = 8)
  partcv[0] = 0;
  Object call4584 = callmethodflags(quotient4583, "asString", 1, partcv, params, 0);
  gc_frame_end(callframe4576);
// compiled member node returning call4584 (depth = 7)
  gc_frame_newslot(call4584);
// starting to compile num node (depth = 7)
  Object num4585 = alloc_Float64(10);
// compiled num node returning num4585 (depth = 7)
  gc_frame_newslot(num4585);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4586 = gc_frame_new();
// call case 3: self.outer request
  Object call4587 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4586);
// compiled member node returning call4587 (depth = 7)
  params[0] = call4584;
  params[1] = num4585;
  partcv[0] = 2;
  Object call4588 = callmethodflags(call4587, "numToken(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4575);
// compiled call node returning call4588 (depth = 6)
  gc_frame_newslot(call4588);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4589 = gc_frame_new();
// call case 3: self.outer request
  Object call4590 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4589);
// compiled member node returning call4590 (depth = 6)
  params[0] = call4588;
  partcv[0] = 1;
  Object call4591 = callmethodflags(call4590, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4574);
// compiled call node returning call4591 (depth = 5)
    gc_frame_newslot(call4591);
    if4551 = call4591;
  }
// compiled if node returning if4551 (depth = 4)
// Begin line 745
  setline(745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4592 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4593 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4594 = gc_frame_new();
// call case 3: self.outer request
  Object call4595 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4594);
// compiled member node returning call4595 (depth = 6)
  partcv[0] = 0;
  Object call4596 = callmethodflags(call4595, "defaultState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4593);
// compiled member node returning call4596 (depth = 5)
  gc_frame_newslot(call4596);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4597 = gc_frame_new();
// call case 3: self.outer request
  Object call4598 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4597);
// compiled member node returning call4598 (depth = 5)
  params[0] = call4596;
  partcv[0] = 1;
  Object call4599 = callmethodflags(call4598, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4592);
// compiled call node returning call4599 (depth = 4)
// Begin line 746
  setline(746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4600 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4601 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4602 = gc_frame_new();
// call case 3: self.outer request
  Object call4603 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4602);
// compiled member node returning call4603 (depth = 6)
  partcv[0] = 0;
  Object call4604 = callmethodflags(call4603, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4601);
// compiled member node returning call4604 (depth = 5)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4605 = callmethodflags(call4604, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4600);
// compiled call node returning call4605 (depth = 4)
    gc_frame_newslot(call4605);
    if4477 = call4605;
  }
// compiled if node returning if4477 (depth = 3)
    gc_frame_newslot(if4477);
    if4470 = if4477;
  }
// compiled if node returning if4470 (depth = 2)
  gc_frame_end(frame);
  return if4470;
}
Object meth_lexer_4608_consume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "consume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method consume(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for consume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part consume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 753
  setline(753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4609 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4610 = gc_frame_new();
// call case 3: self.outer request
  Object call4611 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4610);
// compiled member node returning call4611 (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4612 = callmethodflags(call4611, "checkSeparator(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4609);
// compiled call node returning call4612 (depth = 2)
// Begin line 754
  setline(754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4614 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// starting to compile member node (depth = 4)
  int callframe4615 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  partcv[0] = 0;
  Object call4616 = callmethodflags(*var_c, "ord", 1, partcv, params, 0);
  gc_frame_end(callframe4615);
// compiled member node returning call4616 (depth = 4)
  gc_frame_newslot(call4616);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_lexer (depth = 4)
  params[0] = *var_c;
  params[1] = call4616;
  partcv[0] = 2;
  Object call4617 = callmethodflags(module_lexer, "isOperatorChar(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4614);
// compiled call node returning call4617 (depth = 3)
  Object if4613 = done;
  if (istrue(call4617)) {
// Begin line 755
  setline(755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4618 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4619 = gc_frame_new();
// call case 3: self.outer request
  Object call4620 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4619);
// compiled member node returning call4620 (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4621 = callmethodflags(call4620, "store(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4618);
// compiled call node returning call4621 (depth = 3)
    gc_frame_newslot(call4621);
    if4613 = call4621;
  } else {
// Begin line 757
  setline(757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4624 == NULL) {
    strlit4624 = alloc_String("""\xe2""""\x86""""\x92""");
    gc_root(strlit4624);
  }
// compiled string node returning strlit4624 (depth = 5)
  int op_slot_right_4623 = gc_frame_newslot(strlit4624);
// starting to compile member node (depth = 5)
  int callframe4626 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4627 = gc_frame_new();
// call case 3: self.outer request
  Object call4628 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4627);
// compiled member node returning call4628 (depth = 6)
  partcv[0] = 0;
  Object call4629 = callmethodflags(call4628, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4626);
// compiled member node returning call4629 (depth = 5)
  int op_slot_left_4623 = gc_frame_newslot(call4629);
  params[0] = strlit4624;
  partcv[0] = 1;
  Object opresult4630 = callmethod(call4629, "==(1)", 1, partcv, params);
// compiled op node returning opresult4630 (depth = 4)
  Object if4622 = done;
  if (istrue(opresult4630)) {
// Begin line 758
  setline(758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4631 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4632 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4633 = gc_frame_new();
// call case 3: self.outer request
  Object call4634 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4633);
// compiled member node returning call4634 (depth = 6)
  partcv[0] = 0;
  Object call4635 = callmethodflags(call4634, "arrowToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4632);
// compiled member node returning call4635 (depth = 5)
  gc_frame_newslot(call4635);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4636 = gc_frame_new();
// call case 3: self.outer request
  Object call4637 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4636);
// compiled member node returning call4637 (depth = 5)
  params[0] = call4635;
  partcv[0] = 1;
  Object call4638 = callmethodflags(call4637, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4631);
// compiled call node returning call4638 (depth = 4)
    gc_frame_newslot(call4638);
    if4622 = call4638;
  } else {
// Begin line 761
  setline(761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 759
  setline(759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4641 == NULL) {
    strlit4641 = alloc_String(":=");
    gc_root(strlit4641);
  }
// compiled string node returning strlit4641 (depth = 6)
  int op_slot_right_4640 = gc_frame_newslot(strlit4641);
// starting to compile member node (depth = 6)
  int callframe4643 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4644 = gc_frame_new();
// call case 3: self.outer request
  Object call4645 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4644);
// compiled member node returning call4645 (depth = 7)
  partcv[0] = 0;
  Object call4646 = callmethodflags(call4645, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4643);
// compiled member node returning call4646 (depth = 6)
  int op_slot_left_4640 = gc_frame_newslot(call4646);
  params[0] = strlit4641;
  partcv[0] = 1;
  Object opresult4647 = callmethod(call4646, "==(1)", 1, partcv, params);
// compiled op node returning opresult4647 (depth = 5)
  Object if4639 = done;
  if (istrue(opresult4647)) {
// Begin line 760
  setline(760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4648 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4649 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4650 = gc_frame_new();
// call case 3: self.outer request
  Object call4651 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4650);
// compiled member node returning call4651 (depth = 7)
  partcv[0] = 0;
  Object call4652 = callmethodflags(call4651, "bindToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4649);
// compiled member node returning call4652 (depth = 6)
  gc_frame_newslot(call4652);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4653 = gc_frame_new();
// call case 3: self.outer request
  Object call4654 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4653);
// compiled member node returning call4654 (depth = 6)
  params[0] = call4652;
  partcv[0] = 1;
  Object call4655 = callmethodflags(call4654, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4648);
// compiled call node returning call4655 (depth = 5)
    gc_frame_newslot(call4655);
    if4639 = call4655;
  } else {
// Begin line 763
  setline(763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 761
  setline(761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4658 == NULL) {
    strlit4658 = alloc_String(":");
    gc_root(strlit4658);
  }
// compiled string node returning strlit4658 (depth = 7)
  int op_slot_right_4657 = gc_frame_newslot(strlit4658);
// starting to compile member node (depth = 7)
  int callframe4660 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4661 = gc_frame_new();
// call case 3: self.outer request
  Object call4662 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4661);
// compiled member node returning call4662 (depth = 8)
  partcv[0] = 0;
  Object call4663 = callmethodflags(call4662, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4660);
// compiled member node returning call4663 (depth = 7)
  int op_slot_left_4657 = gc_frame_newslot(call4663);
  params[0] = strlit4658;
  partcv[0] = 1;
  Object opresult4664 = callmethod(call4663, "==(1)", 1, partcv, params);
// compiled op node returning opresult4664 (depth = 6)
  Object if4656 = done;
  if (istrue(opresult4664)) {
// Begin line 762
  setline(762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4665 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe4666 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4667 = gc_frame_new();
// call case 3: self.outer request
  Object call4668 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4667);
// compiled member node returning call4668 (depth = 8)
  partcv[0] = 0;
  Object call4669 = callmethodflags(call4668, "colonToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4666);
// compiled member node returning call4669 (depth = 7)
  gc_frame_newslot(call4669);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4670 = gc_frame_new();
// call case 3: self.outer request
  Object call4671 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4670);
// compiled member node returning call4671 (depth = 7)
  params[0] = call4669;
  partcv[0] = 1;
  Object call4672 = callmethodflags(call4671, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4665);
// compiled call node returning call4672 (depth = 6)
    gc_frame_newslot(call4672);
    if4656 = call4672;
  } else {
// Begin line 764
  setline(764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4673 = gc_frame_new();
// starting to compile call node (depth = 7)
  int callframe4674 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe4675 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe4676 = gc_frame_new();
// call case 3: self.outer request
  Object call4677 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4676);
// compiled member node returning call4677 (depth = 9)
  partcv[0] = 0;
  Object call4678 = callmethodflags(call4677, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4675);
// compiled member node returning call4678 (depth = 8)
  gc_frame_newslot(call4678);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4679 = gc_frame_new();
// call case 3: self.outer request
  Object call4680 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4679);
// compiled member node returning call4680 (depth = 8)
  params[0] = call4678;
  partcv[0] = 1;
  Object call4681 = callmethodflags(call4680, "opToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4674);
// compiled call node returning call4681 (depth = 7)
  gc_frame_newslot(call4681);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4682 = gc_frame_new();
// call case 3: self.outer request
  Object call4683 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4682);
// compiled member node returning call4683 (depth = 7)
  params[0] = call4681;
  partcv[0] = 1;
  Object call4684 = callmethodflags(call4683, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4673);
// compiled call node returning call4684 (depth = 6)
    gc_frame_newslot(call4684);
    if4656 = call4684;
  }
// compiled if node returning if4656 (depth = 5)
    gc_frame_newslot(if4656);
    if4639 = if4656;
  }
// compiled if node returning if4639 (depth = 4)
    gc_frame_newslot(if4639);
    if4622 = if4639;
  }
// compiled if node returning if4622 (depth = 3)
// Begin line 766
  setline(766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4685 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4686 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4687 = gc_frame_new();
// call case 3: self.outer request
  Object call4688 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4687);
// compiled member node returning call4688 (depth = 5)
  partcv[0] = 0;
  Object call4689 = callmethodflags(call4688, "defaultState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4686);
// compiled member node returning call4689 (depth = 4)
  gc_frame_newslot(call4689);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4690 = gc_frame_new();
// call case 3: self.outer request
  Object call4691 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4690);
// compiled member node returning call4691 (depth = 4)
  params[0] = call4689;
  partcv[0] = 1;
  Object call4692 = callmethodflags(call4691, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4685);
// compiled call node returning call4692 (depth = 3)
// Begin line 767
  setline(767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4693 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4694 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4695 = gc_frame_new();
// call case 3: self.outer request
  Object call4696 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4695);
// compiled member node returning call4696 (depth = 5)
  partcv[0] = 0;
  Object call4697 = callmethodflags(call4696, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4694);
// compiled member node returning call4697 (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4698 = callmethodflags(call4697, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4693);
// compiled call node returning call4698 (depth = 3)
    gc_frame_newslot(call4698);
    if4613 = call4698;
  }
// compiled if node returning if4613 (depth = 2)
  gc_frame_end(frame);
  return if4613;
}
Object meth_lexer_4701_consume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "consume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method consume(_)");
  Object params[1];
  int partcv[1];
  Object *var_spaceChars = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for consume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part consume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 774
  setline(774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4703 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_spaceChars (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4704 = callmethodflags(*var_spaceChars, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4703);
// compiled call node returning call4704 (depth = 3)
  Object if4702 = done;
  if (istrue(call4704)) {
// Begin line 775
  setline(775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4705 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4706 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4707 = gc_frame_new();
// call case 3: self.outer request
  Object call4708 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4707);
// compiled member node returning call4708 (depth = 5)
  partcv[0] = 0;
  Object call4709 = callmethodflags(call4708, "linePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4706);
// compiled member node returning call4709 (depth = 4)
  gc_frame_newslot(call4709);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4710 = gc_frame_new();
// call case 3: self.outer request
  Object call4711 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4710);
// compiled member node returning call4711 (depth = 4)
  params[0] = call4709;
  partcv[0] = 1;
  Object call4712 = callmethodflags(call4711, "indentLevel:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4705);
// compiled call node returning call4712 (depth = 3)
    gc_frame_newslot(call4712);
    if4702 = call4712;
  } else {
// Begin line 777
  setline(777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4713 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4714 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4715 = gc_frame_new();
// call case 3: self.outer request
  Object call4716 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4715);
// compiled member node returning call4716 (depth = 5)
  partcv[0] = 0;
  Object call4717 = callmethodflags(call4716, "defaultState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4714);
// compiled member node returning call4717 (depth = 4)
  gc_frame_newslot(call4717);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4718 = gc_frame_new();
// call case 3: self.outer request
  Object call4719 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4718);
// compiled member node returning call4719 (depth = 4)
  params[0] = call4717;
  partcv[0] = 1;
  Object call4720 = callmethodflags(call4719, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4713);
// compiled call node returning call4720 (depth = 3)
// Begin line 778
  setline(778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4721 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4722 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4723 = gc_frame_new();
// call case 3: self.outer request
  Object call4724 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4723);
// compiled member node returning call4724 (depth = 5)
  partcv[0] = 0;
  Object call4725 = callmethodflags(call4724, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4722);
// compiled member node returning call4725 (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4726 = callmethodflags(call4725, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4721);
// compiled call node returning call4726 (depth = 3)
    gc_frame_newslot(call4726);
    if4702 = call4726;
  }
// compiled if node returning if4702 (depth = 2)
  gc_frame_end(frame);
  return if4702;
}
Object meth_lexer_4729_consume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "consume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method consume(_)");
  Object params[1];
  int partcv[1];
  Object *var_spaceChars = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for consume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part consume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 784
  setline(784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4731 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe4732 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_spaceChars (depth = 5)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4733 = callmethodflags(*var_spaceChars, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4732);
// compiled call node returning call4733 (depth = 4)
  partcv[0] = 0;
  Object call4734 = callmethodflags(call4733, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe4731);
// compiled call node returning call4734 (depth = 3)
  Object if4730 = done;
  if (istrue(call4734)) {
// Begin line 785
  setline(785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4735 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4736 == NULL) {
    strlit4736 = alloc_String("");
    gc_root(strlit4736);
  }
// compiled string node returning strlit4736 (depth = 4)
  gc_frame_newslot(strlit4736);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4737 = gc_frame_new();
// call case 3: self.outer request
  Object call4738 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4737);
// compiled member node returning call4738 (depth = 4)
  params[0] = strlit4736;
  partcv[0] = 1;
  Object call4739 = callmethodflags(call4738, "accum:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4735);
// compiled call node returning call4739 (depth = 3)
// Begin line 786
  setline(786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4740 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4741 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4742 = gc_frame_new();
// call case 3: self.outer request
  Object call4743 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4742);
// compiled member node returning call4743 (depth = 5)
  partcv[0] = 0;
  Object call4744 = callmethodflags(call4743, "commentState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4741);
// compiled member node returning call4744 (depth = 4)
  gc_frame_newslot(call4744);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4745 = gc_frame_new();
// call case 3: self.outer request
  Object call4746 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4745);
// compiled member node returning call4746 (depth = 4)
  params[0] = call4744;
  partcv[0] = 1;
  Object call4747 = callmethodflags(call4746, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4740);
// compiled call node returning call4747 (depth = 3)
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4748 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4749 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4750 = gc_frame_new();
// call case 3: self.outer request
  Object call4751 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4750);
// compiled member node returning call4751 (depth = 5)
  partcv[0] = 0;
  Object call4752 = callmethodflags(call4751, "state", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4749);
// compiled member node returning call4752 (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4753 = callmethodflags(call4752, "consume(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4748);
// compiled call node returning call4753 (depth = 3)
    gc_frame_newslot(call4753);
    if4730 = call4753;
  } else {
  }
// compiled if node returning if4730 (depth = 2)
  gc_frame_end(frame);
  return if4730;
}
Object meth_lexer_4756_consume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "consume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method consume(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for consume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part consume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 793
  setline(793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4759 == NULL) {
    strlit4759 = alloc_String("""\x0a""");
    gc_root(strlit4759);
  }
// compiled string node returning strlit4759 (depth = 4)
  int op_slot_right_4758 = gc_frame_newslot(strlit4759);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_left_4758 = gc_frame_newslot(*var_c);
  params[0] = strlit4759;
  partcv[0] = 1;
  Object opresult4761 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult4761 (depth = 3)
  Object if4757 = done;
  if (istrue(opresult4761)) {
// Begin line 794
  setline(794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4762 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4763 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4764 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4765 = gc_frame_new();
// call case 3: self.outer request
  Object call4766 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4765);
// compiled member node returning call4766 (depth = 6)
  partcv[0] = 0;
  Object call4767 = callmethodflags(call4766, "accum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4764);
// compiled member node returning call4767 (depth = 5)
  gc_frame_newslot(call4767);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4768 = gc_frame_new();
// call case 3: self.outer request
  Object call4769 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4768);
// compiled member node returning call4769 (depth = 5)
  params[0] = call4767;
  partcv[0] = 1;
  Object call4770 = callmethodflags(call4769, "commentToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4763);
// compiled call node returning call4770 (depth = 4)
  gc_frame_newslot(call4770);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4771 = gc_frame_new();
// call case 3: self.outer request
  Object call4772 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4771);
// compiled member node returning call4772 (depth = 4)
  params[0] = call4770;
  partcv[0] = 1;
  Object call4773 = callmethodflags(call4772, "emit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4762);
// compiled call node returning call4773 (depth = 3)
// Begin line 795
  setline(795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4774 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num4775 = alloc_Float64(0);
// compiled num node returning num4775 (depth = 4)
  gc_frame_newslot(num4775);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4776 = gc_frame_new();
// call case 3: self.outer request
  Object call4777 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4776);
// compiled member node returning call4777 (depth = 4)
  params[0] = num4775;
  partcv[0] = 1;
  Object call4778 = callmethodflags(call4777, "indentLevel:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4774);
// compiled call node returning call4778 (depth = 3)
// Begin line 796
  setline(796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4779 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4780 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4781 = gc_frame_new();
// call case 3: self.outer request
  Object call4782 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4781);
// compiled member node returning call4782 (depth = 5)
  partcv[0] = 0;
  Object call4783 = callmethodflags(call4782, "indentationState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4780);
// compiled member node returning call4783 (depth = 4)
  gc_frame_newslot(call4783);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4784 = gc_frame_new();
// call case 3: self.outer request
  Object call4785 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4784);
// compiled member node returning call4785 (depth = 4)
  params[0] = call4783;
  partcv[0] = 1;
  Object call4786 = callmethodflags(call4785, "advanceTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4779);
// compiled call node returning call4786 (depth = 3)
    gc_frame_newslot(call4786);
    if4757 = call4786;
  } else {
// Begin line 798
  setline(798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4787 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4788 = gc_frame_new();
// call case 3: self.outer request
  Object call4789 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4788);
// compiled member node returning call4789 (depth = 4)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4790 = callmethodflags(call4789, "store(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4787);
// compiled call node returning call4790 (depth = 3)
    gc_frame_newslot(call4790);
    if4757 = call4790;
  }
// compiled if node returning if4757 (depth = 2)
  gc_frame_end(frame);
  return if4757;
}
Object meth_lexer_97_new(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_spaceChars = getfromclosure(closure, 2);
  Object *var_unicode = getfromclosure(closure, 3);
  Object *var_keywords = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject98 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj98 = alloc_userobj2(115,99, objclass98);
  gc_frame_newslot(obj98);
  if (objclass98 == NULL) {
    glfree(obj98->class->name);
    obj98->class->name = "new";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj98, self, 0);
  addmethodreal(obj98,"outer", &reader_lexer_outer_99);
  Object oldself98 = self;
  struct StackFrameObject *oldstackframe98 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe98);
  gc_frame_newslot((Object)stackframe);
  self = obj98;
  Object *oldselfslot98 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter98 = (*(struct UserObject *)self).data[0], lowerouter98 = thisouter98;
  if (inheritingObject98) {
    struct UserObject *inho98 = (struct UserObject *)inheritingObject98;
    while (inho98->super != GraceDefaultObject) inho98 = (struct UserObject *)inho98->super;
    inho98->super = obj98;
    self = inheritingObject98;
    *selfslot = self;
    lowerouter98 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter98;
  }
  if (objclass98 == NULL) {
    Method *reader100 = addmethodrealflags(obj98, "tokens", &reader_lexer_tokens_100, MFLAG_CONFIDENTIAL);
    Method *writer100 = addmethodrealflags(obj98, "tokens:=(1)", &writer_lexer_tokens_100, MFLAG_CONFIDENTIAL);
    reader100->definitionModule = modulename;
    writer100->definitionModule = modulename;
    reader100->definitionLine = 84;
    writer100->definitionLine = 84;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 1);
  if (objclass98 == NULL) {
    Method *reader101 = addmethodrealflags(obj98, "lineNumber", &reader_lexer_lineNumber_101, MFLAG_CONFIDENTIAL);
    Method *writer101 = addmethodrealflags(obj98, "lineNumber:=(1)", &writer_lexer_lineNumber_101, MFLAG_CONFIDENTIAL);
    reader101->definitionModule = modulename;
    writer101->definitionModule = modulename;
    reader101->definitionLine = 85;
    writer101->definitionLine = 85;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 2);
  if (objclass98 == NULL) {
    Method *reader102 = addmethodrealflags(obj98, "linePosition", &reader_lexer_linePosition_102, MFLAG_CONFIDENTIAL);
    Method *writer102 = addmethodrealflags(obj98, "linePosition:=(1)", &writer_lexer_linePosition_102, MFLAG_CONFIDENTIAL);
    reader102->definitionModule = modulename;
    writer102->definitionModule = modulename;
    reader102->definitionLine = 86;
    writer102->definitionLine = 86;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 3);
  if (objclass98 == NULL) {
    Method *reader103 = addmethodrealflags(obj98, "startPosition", &reader_lexer_startPosition_103, MFLAG_CONFIDENTIAL);
    Method *writer103 = addmethodrealflags(obj98, "startPosition:=(1)", &writer_lexer_startPosition_103, MFLAG_CONFIDENTIAL);
    reader103->definitionModule = modulename;
    writer103->definitionModule = modulename;
    reader103->definitionLine = 87;
    writer103->definitionLine = 87;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 4);
  if (objclass98 == NULL) {
    Method *reader104 = addmethodrealflags(obj98, "indentLevel", &reader_lexer_indentLevel_104, MFLAG_CONFIDENTIAL);
    Method *writer104 = addmethodrealflags(obj98, "indentLevel:=(1)", &writer_lexer_indentLevel_104, MFLAG_CONFIDENTIAL);
    reader104->definitionModule = modulename;
    writer104->definitionModule = modulename;
    reader104->definitionLine = 88;
    writer104->definitionLine = 88;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 5);
  if (objclass98 == NULL) {
    Method *reader105 = addmethodrealflags(obj98, "startLine", &reader_lexer_startLine_105, MFLAG_CONFIDENTIAL);
    Method *writer105 = addmethodrealflags(obj98, "startLine:=(1)", &writer_lexer_startLine_105, MFLAG_CONFIDENTIAL);
    reader105->definitionModule = modulename;
    writer105->definitionModule = modulename;
    reader105->definitionLine = 89;
    writer105->definitionLine = 89;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 6);
  if (objclass98 == NULL) {
    Method *reader106 = addmethodrealflags(obj98, "stringStart", &reader_lexer_stringStart_106, MFLAG_CONFIDENTIAL);
    Method *writer106 = addmethodrealflags(obj98, "stringStart:=(1)", &writer_lexer_stringStart_106, MFLAG_CONFIDENTIAL);
    reader106->definitionModule = modulename;
    writer106->definitionModule = modulename;
    reader106->definitionLine = 90;
    writer106->definitionLine = 90;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 7);
  if (objclass98 == NULL) {
    Method *reader107 = addmethodrealflags(obj98, "unichars", &reader_lexer_unichars_107, MFLAG_CONFIDENTIAL);
    Method *writer107 = addmethodrealflags(obj98, "unichars:=(1)", &writer_lexer_unichars_107, MFLAG_CONFIDENTIAL);
    reader107->definitionModule = modulename;
    writer107->definitionModule = modulename;
    reader107->definitionLine = 91;
    writer107->definitionLine = 91;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 8);
// method "token"
  struct UserObject *uo108 = (struct UserObject*)obj98;
  uo108->data[9] = emptyclosure;
  Method *meth_meth_lexer_108_token = addmethod2pos(obj98, "token", &meth_lexer_108_token, 9);
  int argcv_meth_lexer_108_token[] = {0};
  meth_meth_lexer_108_token->type = alloc_MethodType(1, argcv_meth_lexer_108_token);
  meth_meth_lexer_108_token->definitionModule = modulename;
  meth_meth_lexer_108_token->definitionLine = 92;
  Method *meth_meth_lexer_108_token_object = addmethod2pos(obj98, "token$object(1)", &meth_lexer_108_token_object, 9);
  int argcv_meth_lexer_108_token_object[] = {0};
  meth_meth_lexer_108_token_object->type = alloc_MethodType(1, argcv_meth_lexer_108_token_object);
  meth_meth_lexer_108_token_object->definitionModule = modulename;
  meth_meth_lexer_108_token_object->definitionLine = 92;
// method "identifierToken(_)"
  struct UserObject *uo214 = (struct UserObject*)obj98;
  uo214->data[10] = emptyclosure;
  Method *meth_meth_lexer_214_identifierToken_40_1_41_ = addmethod2pos(obj98, "identifierToken(1)", &meth_lexer_214_identifierToken_40_1_41_, 10);
  int argcv_meth_lexer_214_identifierToken_40_1_41_[] = {1};
  meth_meth_lexer_214_identifierToken_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_214_identifierToken_40_1_41_);
  meth_meth_lexer_214_identifierToken_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_214_identifierToken_40_1_41_->definitionLine = 115;
  Method *meth_meth_lexer_214_identifierToken_40_1_41__object = addmethod2pos(obj98, "identifierToken(1)$object(1)", &meth_lexer_214_identifierToken_40_1_41__object, 10);
  int argcv_meth_lexer_214_identifierToken_40_1_41__object[] = {1};
  meth_meth_lexer_214_identifierToken_40_1_41__object->type = alloc_MethodType(1, argcv_meth_lexer_214_identifierToken_40_1_41__object);
  meth_meth_lexer_214_identifierToken_40_1_41__object->definitionModule = modulename;
  meth_meth_lexer_214_identifierToken_40_1_41__object->definitionLine = 115;
// method "stringToken(_)"
  struct UserObject *uo228 = (struct UserObject*)obj98;
  uo228->data[11] = emptyclosure;
  Method *meth_meth_lexer_228_stringToken_40_1_41_ = addmethod2pos(obj98, "stringToken(1)", &meth_lexer_228_stringToken_40_1_41_, 11);
  int argcv_meth_lexer_228_stringToken_40_1_41_[] = {1};
  meth_meth_lexer_228_stringToken_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_228_stringToken_40_1_41_);
  meth_meth_lexer_228_stringToken_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_228_stringToken_40_1_41_->definitionLine = 121;
  Method *meth_meth_lexer_228_stringToken_40_1_41__object = addmethod2pos(obj98, "stringToken(1)$object(1)", &meth_lexer_228_stringToken_40_1_41__object, 11);
  int argcv_meth_lexer_228_stringToken_40_1_41__object[] = {1};
  meth_meth_lexer_228_stringToken_40_1_41__object->type = alloc_MethodType(1, argcv_meth_lexer_228_stringToken_40_1_41__object);
  meth_meth_lexer_228_stringToken_40_1_41__object->definitionModule = modulename;
  meth_meth_lexer_228_stringToken_40_1_41__object->definitionLine = 121;
// method "multiLineStringToken(_)"
  struct UserObject *uo255 = (struct UserObject*)obj98;
  uo255->data[12] = emptyclosure;
  Method *meth_meth_lexer_255_multiLineStringToken_40_1_41_ = addmethod2pos(obj98, "multiLineStringToken(1)", &meth_lexer_255_multiLineStringToken_40_1_41_, 12);
  int argcv_meth_lexer_255_multiLineStringToken_40_1_41_[] = {1};
  meth_meth_lexer_255_multiLineStringToken_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_255_multiLineStringToken_40_1_41_);
  meth_meth_lexer_255_multiLineStringToken_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_255_multiLineStringToken_40_1_41_->definitionLine = 127;
  Method *meth_meth_lexer_255_multiLineStringToken_40_1_41__object = addmethod2pos(obj98, "multiLineStringToken(1)$object(1)", &meth_lexer_255_multiLineStringToken_40_1_41__object, 12);
  int argcv_meth_lexer_255_multiLineStringToken_40_1_41__object[] = {1};
  meth_meth_lexer_255_multiLineStringToken_40_1_41__object->type = alloc_MethodType(1, argcv_meth_lexer_255_multiLineStringToken_40_1_41__object);
  meth_meth_lexer_255_multiLineStringToken_40_1_41__object->definitionModule = modulename;
  meth_meth_lexer_255_multiLineStringToken_40_1_41__object->definitionLine = 127;
// method "commentToken(_)"
  struct UserObject *uo299 = (struct UserObject*)obj98;
  uo299->data[13] = emptyclosure;
  Method *meth_meth_lexer_299_commentToken_40_1_41_ = addmethod2pos(obj98, "commentToken(1)", &meth_lexer_299_commentToken_40_1_41_, 13);
  int argcv_meth_lexer_299_commentToken_40_1_41_[] = {1};
  meth_meth_lexer_299_commentToken_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_299_commentToken_40_1_41_);
  meth_meth_lexer_299_commentToken_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_299_commentToken_40_1_41_->definitionLine = 139;
  Method *meth_meth_lexer_299_commentToken_40_1_41__object = addmethod2pos(obj98, "commentToken(1)$object(1)", &meth_lexer_299_commentToken_40_1_41__object, 13);
  int argcv_meth_lexer_299_commentToken_40_1_41__object[] = {1};
  meth_meth_lexer_299_commentToken_40_1_41__object->type = alloc_MethodType(1, argcv_meth_lexer_299_commentToken_40_1_41__object);
  meth_meth_lexer_299_commentToken_40_1_41__object->definitionModule = modulename;
  meth_meth_lexer_299_commentToken_40_1_41__object->definitionLine = 139;
// method "lBraceToken"
  struct UserObject *uo317 = (struct UserObject*)obj98;
  uo317->data[14] = emptyclosure;
  Method *meth_meth_lexer_317_lBraceToken = addmethod2pos(obj98, "lBraceToken", &meth_lexer_317_lBraceToken, 14);
  int argcv_meth_lexer_317_lBraceToken[] = {0};
  meth_meth_lexer_317_lBraceToken->type = alloc_MethodType(1, argcv_meth_lexer_317_lBraceToken);
  meth_meth_lexer_317_lBraceToken->definitionModule = modulename;
  meth_meth_lexer_317_lBraceToken->definitionLine = 145;
  Method *meth_meth_lexer_317_lBraceToken_object = addmethod2pos(obj98, "lBraceToken$object(1)", &meth_lexer_317_lBraceToken_object, 14);
  int argcv_meth_lexer_317_lBraceToken_object[] = {0};
  meth_meth_lexer_317_lBraceToken_object->type = alloc_MethodType(1, argcv_meth_lexer_317_lBraceToken_object);
  meth_meth_lexer_317_lBraceToken_object->definitionModule = modulename;
  meth_meth_lexer_317_lBraceToken_object->definitionLine = 145;
// method "rBraceToken"
  struct UserObject *uo331 = (struct UserObject*)obj98;
  uo331->data[15] = emptyclosure;
  Method *meth_meth_lexer_331_rBraceToken = addmethod2pos(obj98, "rBraceToken", &meth_lexer_331_rBraceToken, 15);
  int argcv_meth_lexer_331_rBraceToken[] = {0};
  meth_meth_lexer_331_rBraceToken->type = alloc_MethodType(1, argcv_meth_lexer_331_rBraceToken);
  meth_meth_lexer_331_rBraceToken->definitionModule = modulename;
  meth_meth_lexer_331_rBraceToken->definitionLine = 151;
  Method *meth_meth_lexer_331_rBraceToken_object = addmethod2pos(obj98, "rBraceToken$object(1)", &meth_lexer_331_rBraceToken_object, 15);
  int argcv_meth_lexer_331_rBraceToken_object[] = {0};
  meth_meth_lexer_331_rBraceToken_object->type = alloc_MethodType(1, argcv_meth_lexer_331_rBraceToken_object);
  meth_meth_lexer_331_rBraceToken_object->definitionModule = modulename;
  meth_meth_lexer_331_rBraceToken_object->definitionLine = 151;
// method "lParenToken"
  struct UserObject *uo345 = (struct UserObject*)obj98;
  uo345->data[16] = emptyclosure;
  Method *meth_meth_lexer_345_lParenToken = addmethod2pos(obj98, "lParenToken", &meth_lexer_345_lParenToken, 16);
  int argcv_meth_lexer_345_lParenToken[] = {0};
  meth_meth_lexer_345_lParenToken->type = alloc_MethodType(1, argcv_meth_lexer_345_lParenToken);
  meth_meth_lexer_345_lParenToken->definitionModule = modulename;
  meth_meth_lexer_345_lParenToken->definitionLine = 157;
  Method *meth_meth_lexer_345_lParenToken_object = addmethod2pos(obj98, "lParenToken$object(1)", &meth_lexer_345_lParenToken_object, 16);
  int argcv_meth_lexer_345_lParenToken_object[] = {0};
  meth_meth_lexer_345_lParenToken_object->type = alloc_MethodType(1, argcv_meth_lexer_345_lParenToken_object);
  meth_meth_lexer_345_lParenToken_object->definitionModule = modulename;
  meth_meth_lexer_345_lParenToken_object->definitionLine = 157;
// method "rParenToken"
  struct UserObject *uo359 = (struct UserObject*)obj98;
  uo359->data[17] = emptyclosure;
  Method *meth_meth_lexer_359_rParenToken = addmethod2pos(obj98, "rParenToken", &meth_lexer_359_rParenToken, 17);
  int argcv_meth_lexer_359_rParenToken[] = {0};
  meth_meth_lexer_359_rParenToken->type = alloc_MethodType(1, argcv_meth_lexer_359_rParenToken);
  meth_meth_lexer_359_rParenToken->definitionModule = modulename;
  meth_meth_lexer_359_rParenToken->definitionLine = 163;
  Method *meth_meth_lexer_359_rParenToken_object = addmethod2pos(obj98, "rParenToken$object(1)", &meth_lexer_359_rParenToken_object, 17);
  int argcv_meth_lexer_359_rParenToken_object[] = {0};
  meth_meth_lexer_359_rParenToken_object->type = alloc_MethodType(1, argcv_meth_lexer_359_rParenToken_object);
  meth_meth_lexer_359_rParenToken_object->definitionModule = modulename;
  meth_meth_lexer_359_rParenToken_object->definitionLine = 163;
// method "lSquareToken"
  struct UserObject *uo373 = (struct UserObject*)obj98;
  uo373->data[18] = emptyclosure;
  Method *meth_meth_lexer_373_lSquareToken = addmethod2pos(obj98, "lSquareToken", &meth_lexer_373_lSquareToken, 18);
  int argcv_meth_lexer_373_lSquareToken[] = {0};
  meth_meth_lexer_373_lSquareToken->type = alloc_MethodType(1, argcv_meth_lexer_373_lSquareToken);
  meth_meth_lexer_373_lSquareToken->definitionModule = modulename;
  meth_meth_lexer_373_lSquareToken->definitionLine = 169;
  Method *meth_meth_lexer_373_lSquareToken_object = addmethod2pos(obj98, "lSquareToken$object(1)", &meth_lexer_373_lSquareToken_object, 18);
  int argcv_meth_lexer_373_lSquareToken_object[] = {0};
  meth_meth_lexer_373_lSquareToken_object->type = alloc_MethodType(1, argcv_meth_lexer_373_lSquareToken_object);
  meth_meth_lexer_373_lSquareToken_object->definitionModule = modulename;
  meth_meth_lexer_373_lSquareToken_object->definitionLine = 169;
// method "rSquareToken"
  struct UserObject *uo387 = (struct UserObject*)obj98;
  uo387->data[19] = emptyclosure;
  Method *meth_meth_lexer_387_rSquareToken = addmethod2pos(obj98, "rSquareToken", &meth_lexer_387_rSquareToken, 19);
  int argcv_meth_lexer_387_rSquareToken[] = {0};
  meth_meth_lexer_387_rSquareToken->type = alloc_MethodType(1, argcv_meth_lexer_387_rSquareToken);
  meth_meth_lexer_387_rSquareToken->definitionModule = modulename;
  meth_meth_lexer_387_rSquareToken->definitionLine = 175;
  Method *meth_meth_lexer_387_rSquareToken_object = addmethod2pos(obj98, "rSquareToken$object(1)", &meth_lexer_387_rSquareToken_object, 19);
  int argcv_meth_lexer_387_rSquareToken_object[] = {0};
  meth_meth_lexer_387_rSquareToken_object->type = alloc_MethodType(1, argcv_meth_lexer_387_rSquareToken_object);
  meth_meth_lexer_387_rSquareToken_object->definitionModule = modulename;
  meth_meth_lexer_387_rSquareToken_object->definitionLine = 175;
// method "commaToken"
  struct UserObject *uo401 = (struct UserObject*)obj98;
  uo401->data[20] = emptyclosure;
  Method *meth_meth_lexer_401_commaToken = addmethod2pos(obj98, "commaToken", &meth_lexer_401_commaToken, 20);
  int argcv_meth_lexer_401_commaToken[] = {0};
  meth_meth_lexer_401_commaToken->type = alloc_MethodType(1, argcv_meth_lexer_401_commaToken);
  meth_meth_lexer_401_commaToken->definitionModule = modulename;
  meth_meth_lexer_401_commaToken->definitionLine = 181;
  Method *meth_meth_lexer_401_commaToken_object = addmethod2pos(obj98, "commaToken$object(1)", &meth_lexer_401_commaToken_object, 20);
  int argcv_meth_lexer_401_commaToken_object[] = {0};
  meth_meth_lexer_401_commaToken_object->type = alloc_MethodType(1, argcv_meth_lexer_401_commaToken_object);
  meth_meth_lexer_401_commaToken_object->definitionModule = modulename;
  meth_meth_lexer_401_commaToken_object->definitionLine = 181;
// method "colonToken"
  struct UserObject *uo415 = (struct UserObject*)obj98;
  uo415->data[21] = emptyclosure;
  Method *meth_meth_lexer_415_colonToken = addmethod2pos(obj98, "colonToken", &meth_lexer_415_colonToken, 21);
  int argcv_meth_lexer_415_colonToken[] = {0};
  meth_meth_lexer_415_colonToken->type = alloc_MethodType(1, argcv_meth_lexer_415_colonToken);
  meth_meth_lexer_415_colonToken->definitionModule = modulename;
  meth_meth_lexer_415_colonToken->definitionLine = 187;
  Method *meth_meth_lexer_415_colonToken_object = addmethod2pos(obj98, "colonToken$object(1)", &meth_lexer_415_colonToken_object, 21);
  int argcv_meth_lexer_415_colonToken_object[] = {0};
  meth_meth_lexer_415_colonToken_object->type = alloc_MethodType(1, argcv_meth_lexer_415_colonToken_object);
  meth_meth_lexer_415_colonToken_object->definitionModule = modulename;
  meth_meth_lexer_415_colonToken_object->definitionLine = 187;
// method "dotToken"
  struct UserObject *uo429 = (struct UserObject*)obj98;
  uo429->data[22] = emptyclosure;
  Method *meth_meth_lexer_429_dotToken = addmethod2pos(obj98, "dotToken", &meth_lexer_429_dotToken, 22);
  int argcv_meth_lexer_429_dotToken[] = {0};
  meth_meth_lexer_429_dotToken->type = alloc_MethodType(1, argcv_meth_lexer_429_dotToken);
  meth_meth_lexer_429_dotToken->definitionModule = modulename;
  meth_meth_lexer_429_dotToken->definitionLine = 193;
  Method *meth_meth_lexer_429_dotToken_object = addmethod2pos(obj98, "dotToken$object(1)", &meth_lexer_429_dotToken_object, 22);
  int argcv_meth_lexer_429_dotToken_object[] = {0};
  meth_meth_lexer_429_dotToken_object->type = alloc_MethodType(1, argcv_meth_lexer_429_dotToken_object);
  meth_meth_lexer_429_dotToken_object->definitionModule = modulename;
  meth_meth_lexer_429_dotToken_object->definitionLine = 193;
// method "numToken(_,_)"
  struct UserObject *uo443 = (struct UserObject*)obj98;
  uo443->data[23] = emptyclosure;
  Method *meth_meth_lexer_443_numToken_40_2_41_ = addmethod2pos(obj98, "numToken(2)", &meth_lexer_443_numToken_40_2_41_, 23);
  int argcv_meth_lexer_443_numToken_40_2_41_[] = {2};
  meth_meth_lexer_443_numToken_40_2_41_->type = alloc_MethodType(1, argcv_meth_lexer_443_numToken_40_2_41_);
  meth_meth_lexer_443_numToken_40_2_41_->definitionModule = modulename;
  meth_meth_lexer_443_numToken_40_2_41_->definitionLine = 199;
  Method *meth_meth_lexer_443_numToken_40_2_41__object = addmethod2pos(obj98, "numToken(2)$object(1)", &meth_lexer_443_numToken_40_2_41__object, 23);
  int argcv_meth_lexer_443_numToken_40_2_41__object[] = {2};
  meth_meth_lexer_443_numToken_40_2_41__object->type = alloc_MethodType(1, argcv_meth_lexer_443_numToken_40_2_41__object);
  meth_meth_lexer_443_numToken_40_2_41__object->definitionModule = modulename;
  meth_meth_lexer_443_numToken_40_2_41__object->definitionLine = 199;
// method "keywordToken(_)"
  struct UserObject *uo471 = (struct UserObject*)obj98;
  uo471->data[24] = emptyclosure;
  Method *meth_meth_lexer_471_keywordToken_40_1_41_ = addmethod2pos(obj98, "keywordToken(1)", &meth_lexer_471_keywordToken_40_1_41_, 24);
  int argcv_meth_lexer_471_keywordToken_40_1_41_[] = {1};
  meth_meth_lexer_471_keywordToken_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_471_keywordToken_40_1_41_);
  meth_meth_lexer_471_keywordToken_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_471_keywordToken_40_1_41_->definitionLine = 206;
  Method *meth_meth_lexer_471_keywordToken_40_1_41__object = addmethod2pos(obj98, "keywordToken(1)$object(1)", &meth_lexer_471_keywordToken_40_1_41__object, 24);
  int argcv_meth_lexer_471_keywordToken_40_1_41__object[] = {1};
  meth_meth_lexer_471_keywordToken_40_1_41__object->type = alloc_MethodType(1, argcv_meth_lexer_471_keywordToken_40_1_41__object);
  meth_meth_lexer_471_keywordToken_40_1_41__object->definitionModule = modulename;
  meth_meth_lexer_471_keywordToken_40_1_41__object->definitionLine = 206;
// method "opToken(_)"
  struct UserObject *uo485 = (struct UserObject*)obj98;
  uo485->data[25] = emptyclosure;
  Method *meth_meth_lexer_485_opToken_40_1_41_ = addmethod2pos(obj98, "opToken(1)", &meth_lexer_485_opToken_40_1_41_, 25);
  int argcv_meth_lexer_485_opToken_40_1_41_[] = {1};
  meth_meth_lexer_485_opToken_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_485_opToken_40_1_41_);
  meth_meth_lexer_485_opToken_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_485_opToken_40_1_41_->definitionLine = 212;
  Method *meth_meth_lexer_485_opToken_40_1_41__object = addmethod2pos(obj98, "opToken(1)$object(1)", &meth_lexer_485_opToken_40_1_41__object, 25);
  int argcv_meth_lexer_485_opToken_40_1_41__object[] = {1};
  meth_meth_lexer_485_opToken_40_1_41__object->type = alloc_MethodType(1, argcv_meth_lexer_485_opToken_40_1_41__object);
  meth_meth_lexer_485_opToken_40_1_41__object->definitionModule = modulename;
  meth_meth_lexer_485_opToken_40_1_41__object->definitionLine = 212;
// method "arrowToken"
  struct UserObject *uo499 = (struct UserObject*)obj98;
  uo499->data[26] = emptyclosure;
  Method *meth_meth_lexer_499_arrowToken = addmethod2pos(obj98, "arrowToken", &meth_lexer_499_arrowToken, 26);
  int argcv_meth_lexer_499_arrowToken[] = {0};
  meth_meth_lexer_499_arrowToken->type = alloc_MethodType(1, argcv_meth_lexer_499_arrowToken);
  meth_meth_lexer_499_arrowToken->definitionModule = modulename;
  meth_meth_lexer_499_arrowToken->definitionLine = 218;
  Method *meth_meth_lexer_499_arrowToken_object = addmethod2pos(obj98, "arrowToken$object(1)", &meth_lexer_499_arrowToken_object, 26);
  int argcv_meth_lexer_499_arrowToken_object[] = {0};
  meth_meth_lexer_499_arrowToken_object->type = alloc_MethodType(1, argcv_meth_lexer_499_arrowToken_object);
  meth_meth_lexer_499_arrowToken_object->definitionModule = modulename;
  meth_meth_lexer_499_arrowToken_object->definitionLine = 218;
// method "bindToken"
  struct UserObject *uo513 = (struct UserObject*)obj98;
  uo513->data[27] = emptyclosure;
  Method *meth_meth_lexer_513_bindToken = addmethod2pos(obj98, "bindToken", &meth_lexer_513_bindToken, 27);
  int argcv_meth_lexer_513_bindToken[] = {0};
  meth_meth_lexer_513_bindToken->type = alloc_MethodType(1, argcv_meth_lexer_513_bindToken);
  meth_meth_lexer_513_bindToken->definitionModule = modulename;
  meth_meth_lexer_513_bindToken->definitionLine = 224;
  Method *meth_meth_lexer_513_bindToken_object = addmethod2pos(obj98, "bindToken$object(1)", &meth_lexer_513_bindToken_object, 27);
  int argcv_meth_lexer_513_bindToken_object[] = {0};
  meth_meth_lexer_513_bindToken_object->type = alloc_MethodType(1, argcv_meth_lexer_513_bindToken_object);
  meth_meth_lexer_513_bindToken_object->definitionModule = modulename;
  meth_meth_lexer_513_bindToken_object->definitionLine = 224;
// method "semicolonToken"
  struct UserObject *uo527 = (struct UserObject*)obj98;
  uo527->data[28] = emptyclosure;
  Method *meth_meth_lexer_527_semicolonToken = addmethod2pos(obj98, "semicolonToken", &meth_lexer_527_semicolonToken, 28);
  int argcv_meth_lexer_527_semicolonToken[] = {0};
  meth_meth_lexer_527_semicolonToken->type = alloc_MethodType(1, argcv_meth_lexer_527_semicolonToken);
  meth_meth_lexer_527_semicolonToken->definitionModule = modulename;
  meth_meth_lexer_527_semicolonToken->definitionLine = 230;
  Method *meth_meth_lexer_527_semicolonToken_object = addmethod2pos(obj98, "semicolonToken$object(1)", &meth_lexer_527_semicolonToken_object, 28);
  int argcv_meth_lexer_527_semicolonToken_object[] = {0};
  meth_meth_lexer_527_semicolonToken_object->type = alloc_MethodType(1, argcv_meth_lexer_527_semicolonToken_object);
  meth_meth_lexer_527_semicolonToken_object->definitionModule = modulename;
  meth_meth_lexer_527_semicolonToken_object->definitionLine = 230;
// method "lGenericToken"
  struct UserObject *uo541 = (struct UserObject*)obj98;
  uo541->data[29] = emptyclosure;
  Method *meth_meth_lexer_541_lGenericToken = addmethod2pos(obj98, "lGenericToken", &meth_lexer_541_lGenericToken, 29);
  int argcv_meth_lexer_541_lGenericToken[] = {0};
  meth_meth_lexer_541_lGenericToken->type = alloc_MethodType(1, argcv_meth_lexer_541_lGenericToken);
  meth_meth_lexer_541_lGenericToken->definitionModule = modulename;
  meth_meth_lexer_541_lGenericToken->definitionLine = 236;
  Method *meth_meth_lexer_541_lGenericToken_object = addmethod2pos(obj98, "lGenericToken$object(1)", &meth_lexer_541_lGenericToken_object, 29);
  int argcv_meth_lexer_541_lGenericToken_object[] = {0};
  meth_meth_lexer_541_lGenericToken_object->type = alloc_MethodType(1, argcv_meth_lexer_541_lGenericToken_object);
  meth_meth_lexer_541_lGenericToken_object->definitionModule = modulename;
  meth_meth_lexer_541_lGenericToken_object->definitionLine = 236;
// method "rGenericToken"
  struct UserObject *uo555 = (struct UserObject*)obj98;
  uo555->data[30] = emptyclosure;
  Method *meth_meth_lexer_555_rGenericToken = addmethod2pos(obj98, "rGenericToken", &meth_lexer_555_rGenericToken, 30);
  int argcv_meth_lexer_555_rGenericToken[] = {0};
  meth_meth_lexer_555_rGenericToken->type = alloc_MethodType(1, argcv_meth_lexer_555_rGenericToken);
  meth_meth_lexer_555_rGenericToken->definitionModule = modulename;
  meth_meth_lexer_555_rGenericToken->definitionLine = 242;
  Method *meth_meth_lexer_555_rGenericToken_object = addmethod2pos(obj98, "rGenericToken$object(1)", &meth_lexer_555_rGenericToken_object, 30);
  int argcv_meth_lexer_555_rGenericToken_object[] = {0};
  meth_meth_lexer_555_rGenericToken_object->type = alloc_MethodType(1, argcv_meth_lexer_555_rGenericToken_object);
  meth_meth_lexer_555_rGenericToken_object->definitionModule = modulename;
  meth_meth_lexer_555_rGenericToken_object->definitionLine = 242;
// method "eofToken"
  struct UserObject *uo569 = (struct UserObject*)obj98;
  uo569->data[31] = emptyclosure;
  Method *meth_meth_lexer_569_eofToken = addmethod2pos(obj98, "eofToken", &meth_lexer_569_eofToken, 31);
  int argcv_meth_lexer_569_eofToken[] = {0};
  meth_meth_lexer_569_eofToken->type = alloc_MethodType(1, argcv_meth_lexer_569_eofToken);
  meth_meth_lexer_569_eofToken->definitionModule = modulename;
  meth_meth_lexer_569_eofToken->definitionLine = 248;
  Method *meth_meth_lexer_569_eofToken_object = addmethod2pos(obj98, "eofToken$object(1)", &meth_lexer_569_eofToken_object, 31);
  int argcv_meth_lexer_569_eofToken_object[] = {0};
  meth_meth_lexer_569_eofToken_object->type = alloc_MethodType(1, argcv_meth_lexer_569_eofToken_object);
  meth_meth_lexer_569_eofToken_object->definitionModule = modulename;
  meth_meth_lexer_569_eofToken_object->definitionLine = 248;
  if (objclass98 == NULL) {
    Method *reader583 = addmethodrealflags(obj98, "state", &reader_lexer_state_583, MFLAG_CONFIDENTIAL);
    Method *writer583 = addmethodrealflags(obj98, "state:=(1)", &writer_lexer_state_583, MFLAG_CONFIDENTIAL);
    reader583->definitionModule = modulename;
    writer583->definitionModule = modulename;
    reader583->definitionLine = 255;
    writer583->definitionLine = 255;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 32);
  if (objclass98 == NULL) {
    Method *reader584 = addmethodrealflags(obj98, "accum", &reader_lexer_accum_584, MFLAG_CONFIDENTIAL);
    Method *writer584 = addmethodrealflags(obj98, "accum:=(1)", &writer_lexer_accum_584, MFLAG_CONFIDENTIAL);
    reader584->definitionModule = modulename;
    writer584->definitionModule = modulename;
    reader584->definitionLine = 256;
    writer584->definitionLine = 256;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 33);
  if (objclass98 == NULL) {
    Method *reader585 = addmethodrealflags(obj98, "inStr", &reader_lexer_inStr_585, MFLAG_CONFIDENTIAL);
    Method *writer585 = addmethodrealflags(obj98, "inStr:=(1)", &writer_lexer_inStr_585, MFLAG_CONFIDENTIAL);
    reader585->definitionModule = modulename;
    writer585->definitionModule = modulename;
    reader585->definitionLine = 258;
    writer585->definitionLine = 258;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 34);
  if (objclass98 == NULL) {
    Method *reader586 = addmethodrealflags(obj98, "escaped", &reader_lexer_escaped_586, MFLAG_CONFIDENTIAL);
    Method *writer586 = addmethodrealflags(obj98, "escaped:=(1)", &writer_lexer_escaped_586, MFLAG_CONFIDENTIAL);
    reader586->definitionModule = modulename;
    writer586->definitionModule = modulename;
    reader586->definitionLine = 259;
    writer586->definitionLine = 259;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 35);
  if (objclass98 == NULL) {
    Method *reader587 = addmethodrealflags(obj98, "codepoint", &reader_lexer_codepoint_587, MFLAG_CONFIDENTIAL);
    Method *writer587 = addmethodrealflags(obj98, "codepoint:=(1)", &writer_lexer_codepoint_587, MFLAG_CONFIDENTIAL);
    reader587->definitionModule = modulename;
    writer587->definitionModule = modulename;
    reader587->definitionLine = 260;
    writer587->definitionLine = 260;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 36);
  if (objclass98 == NULL) {
    Method *reader588 = addmethodrealflags(obj98, "interpdepth", &reader_lexer_interpdepth_588, MFLAG_CONFIDENTIAL);
    Method *writer588 = addmethodrealflags(obj98, "interpdepth:=(1)", &writer_lexer_interpdepth_588, MFLAG_CONFIDENTIAL);
    reader588->definitionModule = modulename;
    writer588->definitionModule = modulename;
    reader588->definitionLine = 261;
    writer588->definitionLine = 261;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 37);
  if (objclass98 == NULL) {
    Method *reader589 = addmethodrealflags(obj98, "interpString", &reader_lexer_interpString_589, MFLAG_CONFIDENTIAL);
    Method *writer589 = addmethodrealflags(obj98, "interpString:=(1)", &writer_lexer_interpString_589, MFLAG_CONFIDENTIAL);
    reader589->definitionModule = modulename;
    writer589->definitionModule = modulename;
    reader589->definitionLine = 262;
    writer589->definitionLine = 262;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 38);
// method "advanceTo(_)"
  struct UserObject *uo590 = (struct UserObject*)obj98;
  uo590->data[39] = emptyclosure;
  Method *meth_meth_lexer_590_advanceTo_40_1_41_ = addmethod2pos(obj98, "advanceTo(1)", &meth_lexer_590_advanceTo_40_1_41_, 39);
  int argcv_meth_lexer_590_advanceTo_40_1_41_[] = {1};
  meth_meth_lexer_590_advanceTo_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_590_advanceTo_40_1_41_);
  meth_meth_lexer_590_advanceTo_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_590_advanceTo_40_1_41_->definitionLine = 264;
// method "emit(_)"
  struct UserObject *uo593 = (struct UserObject*)obj98;
  uo593->data[40] = emptyclosure;
  Method *meth_meth_lexer_593_emit_40_1_41_ = addmethod2pos(obj98, "emit(1)", &meth_lexer_593_emit_40_1_41_, 40);
  int argcv_meth_lexer_593_emit_40_1_41_[] = {1};
  meth_meth_lexer_593_emit_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_593_emit_40_1_41_);
  meth_meth_lexer_593_emit_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_593_emit_40_1_41_->definitionLine = 265;
// method "store(_)"
  struct UserObject *uo601 = (struct UserObject*)obj98;
  uo601->data[41] = emptyclosure;
  Method *meth_meth_lexer_601_store_40_1_41_ = addmethod2pos(obj98, "store(1)", &meth_lexer_601_store_40_1_41_, 41);
  int argcv_meth_lexer_601_store_40_1_41_[] = {1};
  meth_meth_lexer_601_store_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_601_store_40_1_41_);
  meth_meth_lexer_601_store_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_601_store_40_1_41_->definitionLine = 269;
  if (objclass98 == NULL) {
  Method *reader609 = addmethodrealflags(obj98, "startState",&reader_lexer_startState_609, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader609->definitionModule = modulename;
  reader609->definitionLine = 271;
  }
  adddatum2(obj98, alloc_Undefined(), 42);
  if (objclass98 == NULL) {
  Method *reader610 = addmethodrealflags(obj98, "pragmaPrefixState",&reader_lexer_pragmaPrefixState_610, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader610->definitionModule = modulename;
  reader610->definitionLine = 283;
  }
  adddatum2(obj98, alloc_Undefined(), 43);
  if (objclass98 == NULL) {
  Method *reader611 = addmethodrealflags(obj98, "pragmaBodyState",&reader_lexer_pragmaBodyState_611, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader611->definitionModule = modulename;
  reader611->definitionLine = 303;
  }
  adddatum2(obj98, alloc_Undefined(), 44);
  if (objclass98 == NULL) {
  Method *reader612 = addmethodrealflags(obj98, "pragmaTrailingWhitespaceState",&reader_lexer_pragmaTrailingWhitespaceState_612, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader612->definitionModule = modulename;
  reader612->definitionLine = 318;
  }
  adddatum2(obj98, alloc_Undefined(), 45);
  if (objclass98 == NULL) {
  Method *reader613 = addmethodrealflags(obj98, "defaultState",&reader_lexer_defaultState_613, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader613->definitionModule = modulename;
  reader613->definitionLine = 330;
  }
  adddatum2(obj98, alloc_Undefined(), 46);
  if (objclass98 == NULL) {
  Method *reader614 = addmethodrealflags(obj98, "rBraceState",&reader_lexer_rBraceState_614, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader614->definitionModule = modulename;
  reader614->definitionLine = 411;
  }
  adddatum2(obj98, alloc_Undefined(), 47);
  if (objclass98 == NULL) {
  Method *reader615 = addmethodrealflags(obj98, "slashState",&reader_lexer_slashState_615, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader615->definitionModule = modulename;
  reader615->definitionLine = 438;
  }
  adddatum2(obj98, alloc_Undefined(), 48);
  if (objclass98 == NULL) {
  Method *reader616 = addmethodrealflags(obj98, "dotState",&reader_lexer_dotState_616, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader616->definitionModule = modulename;
  reader616->definitionLine = 456;
  }
  adddatum2(obj98, alloc_Undefined(), 49);
  if (objclass98 == NULL) {
  Method *reader617 = addmethodrealflags(obj98, "identifierState",&reader_lexer_identifierState_617, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader617->definitionModule = modulename;
  reader617->definitionLine = 480;
  }
  adddatum2(obj98, alloc_Undefined(), 50);
  if (objclass98 == NULL) {
  Method *reader618 = addmethodrealflags(obj98, "quotedStringState",&reader_lexer_quotedStringState_618, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader618->definitionModule = modulename;
  reader618->definitionLine = 506;
  }
  adddatum2(obj98, alloc_Undefined(), 51);
  if (objclass98 == NULL) {
  Method *reader619 = addmethodrealflags(obj98, "unicodeState",&reader_lexer_unicodeState_619, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader619->definitionModule = modulename;
  reader619->definitionLine = 540;
  }
  adddatum2(obj98, alloc_Undefined(), 52);
  if (objclass98 == NULL) {
  Method *reader620 = addmethodrealflags(obj98, "quotedStringEscapedState",&reader_lexer_quotedStringEscapedState_620, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader620->definitionModule = modulename;
  reader620->definitionLine = 554;
  }
  adddatum2(obj98, alloc_Undefined(), 53);
  if (objclass98 == NULL) {
  Method *reader621 = addmethodrealflags(obj98, "extendedStringState",&reader_lexer_extendedStringState_621, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader621->definitionModule = modulename;
  reader621->definitionLine = 604;
  }
  adddatum2(obj98, alloc_Undefined(), 54);
  if (objclass98 == NULL) {
    Method *reader622 = addmethodrealflags(obj98, "tokenBase", &reader_lexer_tokenBase_622, MFLAG_CONFIDENTIAL);
    Method *writer622 = addmethodrealflags(obj98, "tokenBase:=(1)", &writer_lexer_tokenBase_622, 0);
    reader622->definitionModule = modulename;
    writer622->definitionModule = modulename;
    reader622->definitionLine = 617;
    writer622->definitionLine = 617;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 55);
  if (objclass98 == NULL) {
    Method *reader623 = addmethodrealflags(obj98, "mantissa", &reader_lexer_mantissa_623, MFLAG_CONFIDENTIAL);
    Method *writer623 = addmethodrealflags(obj98, "mantissa:=(1)", &writer_lexer_mantissa_623, 0);
    reader623->definitionModule = modulename;
    writer623->definitionModule = modulename;
    reader623->definitionLine = 618;
    writer623->definitionLine = 618;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 56);
  if (objclass98 == NULL) {
  Method *reader624 = addmethodrealflags(obj98, "numberStartState",&reader_lexer_numberStartState_624, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader624->definitionModule = modulename;
  reader624->definitionLine = 619;
  }
  adddatum2(obj98, alloc_Undefined(), 57);
  if (objclass98 == NULL) {
  Method *reader625 = addmethodrealflags(obj98, "numberBaseState",&reader_lexer_numberBaseState_625, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader625->definitionModule = modulename;
  reader625->definitionLine = 649;
  }
  adddatum2(obj98, alloc_Undefined(), 58);
  if (objclass98 == NULL) {
  Method *reader626 = addmethodrealflags(obj98, "numberDotState",&reader_lexer_numberDotState_626, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader626->definitionModule = modulename;
  reader626->definitionLine = 665;
  }
  adddatum2(obj98, alloc_Undefined(), 59);
  if (objclass98 == NULL) {
  Method *reader627 = addmethodrealflags(obj98, "numberFractionState",&reader_lexer_numberFractionState_627, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader627->definitionModule = modulename;
  reader627->definitionLine = 684;
  }
  adddatum2(obj98, alloc_Undefined(), 60);
  if (objclass98 == NULL) {
  Method *reader628 = addmethodrealflags(obj98, "numberExponentSignState",&reader_lexer_numberExponentSignState_628, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader628->definitionModule = modulename;
  reader628->definitionLine = 703;
  }
  adddatum2(obj98, alloc_Undefined(), 61);
  if (objclass98 == NULL) {
  Method *reader629 = addmethodrealflags(obj98, "numberExponentState",&reader_lexer_numberExponentState_629, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader629->definitionModule = modulename;
  reader629->definitionLine = 718;
  }
  adddatum2(obj98, alloc_Undefined(), 62);
  if (objclass98 == NULL) {
  Method *reader630 = addmethodrealflags(obj98, "operatorState",&reader_lexer_operatorState_630, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader630->definitionModule = modulename;
  reader630->definitionLine = 751;
  }
  adddatum2(obj98, alloc_Undefined(), 63);
  if (objclass98 == NULL) {
  Method *reader631 = addmethodrealflags(obj98, "indentationState",&reader_lexer_indentationState_631, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader631->definitionModule = modulename;
  reader631->definitionLine = 772;
  }
  adddatum2(obj98, alloc_Undefined(), 64);
  if (objclass98 == NULL) {
  Method *reader632 = addmethodrealflags(obj98, "commentSpaceState",&reader_lexer_commentSpaceState_632, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader632->definitionModule = modulename;
  reader632->definitionLine = 782;
  }
  adddatum2(obj98, alloc_Undefined(), 65);
  if (objclass98 == NULL) {
  Method *reader633 = addmethodrealflags(obj98, "commentState",&reader_lexer_commentState_633, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader633->definitionModule = modulename;
  reader633->definitionLine = 791;
  }
  adddatum2(obj98, alloc_Undefined(), 66);
// method "newLineError"
  block_savedest(obj98);
  Object closure634 = createclosure(2, "newLineError");
  setclosureframe(closure634, stackframe);
  addtoclosure(closure634, var_util);
  addtoclosure(closure634, var_errormessages);
  struct UserObject *uo634 = (struct UserObject*)obj98;
  uo634->data[67] = (Object)closure634;
  Method *meth_meth_lexer_634_newLineError = addmethod2pos(obj98, "newLineError", &meth_lexer_634_newLineError, 67);
  int argcv_meth_lexer_634_newLineError[] = {0};
  meth_meth_lexer_634_newLineError->type = alloc_MethodType(1, argcv_meth_lexer_634_newLineError);
  meth_meth_lexer_634_newLineError->definitionModule = modulename;
  meth_meth_lexer_634_newLineError->definitionLine = 803;
// method "isSpaceChar(_)"
  block_savedest(obj98);
  Object closure958 = createclosure(1, "isSpaceChar(1)");
  setclosureframe(closure958, stackframe);
  addtoclosure(closure958, var_spaceChars);
  struct UserObject *uo958 = (struct UserObject*)obj98;
  uo958->data[68] = (Object)closure958;
  Method *meth_meth_lexer_958_isSpaceChar_40_1_41_ = addmethod2pos(obj98, "isSpaceChar(1)", &meth_lexer_958_isSpaceChar_40_1_41_, 68);
  int argcv_meth_lexer_958_isSpaceChar_40_1_41_[] = {1};
  meth_meth_lexer_958_isSpaceChar_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_958_isSpaceChar_40_1_41_);
  meth_meth_lexer_958_isSpaceChar_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_958_isSpaceChar_40_1_41_->definitionLine = 877;
// method "checkSeparatorString(_)"
  block_savedest(obj98);
  Object closure961 = createclosure(2, "checkSeparatorString(1)");
  setclosureframe(closure961, stackframe);
  addtoclosure(closure961, var_errormessages);
  addtoclosure(closure961, var_unicode);
  struct UserObject *uo961 = (struct UserObject*)obj98;
  uo961->data[69] = (Object)closure961;
  Method *meth_meth_lexer_961_checkSeparatorString_40_1_41_ = addmethod2pos(obj98, "checkSeparatorString(1)", &meth_lexer_961_checkSeparatorString_40_1_41_, 69);
  int argcv_meth_lexer_961_checkSeparatorString_40_1_41_[] = {1};
  meth_meth_lexer_961_checkSeparatorString_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_961_checkSeparatorString_40_1_41_);
  meth_meth_lexer_961_checkSeparatorString_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_961_checkSeparatorString_40_1_41_->definitionLine = 880;
// method "checkSeparator(_)"
  block_savedest(obj98);
  Object closure1269 = createclosure(2, "checkSeparator(1)");
  setclosureframe(closure1269, stackframe);
  addtoclosure(closure1269, var_errormessages);
  addtoclosure(closure1269, var_unicode);
  struct UserObject *uo1269 = (struct UserObject*)obj98;
  uo1269->data[70] = (Object)closure1269;
  Method *meth_meth_lexer_1269_checkSeparator_40_1_41_ = addmethod2pos(obj98, "checkSeparator(1)", &meth_lexer_1269_checkSeparator_40_1_41_, 70);
  int argcv_meth_lexer_1269_checkSeparator_40_1_41_[] = {1};
  meth_meth_lexer_1269_checkSeparator_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_1269_checkSeparator_40_1_41_);
  meth_meth_lexer_1269_checkSeparator_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_1269_checkSeparator_40_1_41_->definitionLine = 938;
// method "fromBase(_,_)"
  block_savedest(obj98);
  Object closure1385 = createclosure(2, "fromBase(2)");
  setclosureframe(closure1385, stackframe);
  addtoclosure(closure1385, var_errormessages);
  addtoclosure(closure1385, var_unicode);
  struct UserObject *uo1385 = (struct UserObject*)obj98;
  uo1385->data[71] = (Object)closure1385;
  Method *meth_meth_lexer_1385_fromBase_40_2_41_ = addmethod2pos(obj98, "fromBase(2)", &meth_lexer_1385_fromBase_40_2_41_, 71);
  int argcv_meth_lexer_1385_fromBase_40_2_41_[] = {2};
  meth_meth_lexer_1385_fromBase_40_2_41_->type = alloc_MethodType(1, argcv_meth_lexer_1385_fromBase_40_2_41_);
  meth_meth_lexer_1385_fromBase_40_2_41_->definitionModule = modulename;
  meth_meth_lexer_1385_fromBase_40_2_41_->definitionLine = 965;
// method "hexdecchar(_)"
  block_savedest(obj98);
  Object closure1625 = createclosure(1, "hexdecchar(1)");
  setclosureframe(closure1625, stackframe);
  addtoclosure(closure1625, var_errormessages);
  struct UserObject *uo1625 = (struct UserObject*)obj98;
  uo1625->data[72] = (Object)closure1625;
  Method *meth_meth_lexer_1625_hexdecchar_40_1_41_ = addmethod2pos(obj98, "hexdecchar(1)", &meth_lexer_1625_hexdecchar_40_1_41_, 72);
  int argcv_meth_lexer_1625_hexdecchar_40_1_41_[] = {1};
  meth_meth_lexer_1625_hexdecchar_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_1625_hexdecchar_40_1_41_);
  meth_meth_lexer_1625_hexdecchar_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_1625_hexdecchar_40_1_41_->definitionLine = 1007;
// method "lexfile(_)"
  block_savedest(obj98);
  Object closure1709 = createclosure(1, "lexfile(1)");
  setclosureframe(closure1709, stackframe);
  addtoclosure(closure1709, var_util);
  struct UserObject *uo1709 = (struct UserObject*)obj98;
  uo1709->data[73] = (Object)closure1709;
  Method *meth_meth_lexer_1709_lexfile_40_1_41_ = addmethod2pos(obj98, "lexfile(1)", &meth_lexer_1709_lexfile_40_1_41_, 73);
  int argcv_meth_lexer_1709_lexfile_40_1_41_[] = {1};
  meth_meth_lexer_1709_lexfile_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_1709_lexfile_40_1_41_);
  meth_meth_lexer_1709_lexfile_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_1709_lexfile_40_1_41_->definitionLine = 1026;
// method "lexinput(_)"
  block_savedest(obj98);
  Object closure1827 = createclosure(2, "lexinput(1)");
  setclosureframe(closure1827, stackframe);
  addtoclosure(closure1827, var_errormessages);
  addtoclosure(closure1827, var_util);
  struct UserObject *uo1827 = (struct UserObject*)obj98;
  uo1827->data[74] = (Object)closure1827;
  Method *meth_meth_lexer_1827_lexinput_40_1_41_ = addmethod2pos(obj98, "lexinput(1)", &meth_lexer_1827_lexinput_40_1_41_, 74);
  int argcv_meth_lexer_1827_lexinput_40_1_41_[] = {1};
  meth_meth_lexer_1827_lexinput_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_1827_lexinput_40_1_41_);
  meth_meth_lexer_1827_lexinput_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_1827_lexinput_40_1_41_->definitionLine = 1081;
  sourceObject = obj98;
  adddatum2(obj98, undefined, 1);
  sourceObject = obj98;
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2266 = alloc_Float64(1);
// compiled num node returning num2266 (depth = 2)
  adddatum2(obj98, num2266, 2);
  sourceObject = obj98;
// Begin line 86
  setline(86);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2267 = alloc_Float64(0);
// compiled num node returning num2267 (depth = 2)
  adddatum2(obj98, num2267, 3);
  sourceObject = obj98;
// Begin line 87
  setline(87);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2268 = alloc_Float64(1);
// compiled num node returning num2268 (depth = 2)
  adddatum2(obj98, num2268, 4);
  sourceObject = obj98;
// Begin line 88
  setline(88);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2269 = alloc_Float64(0);
// compiled num node returning num2269 (depth = 2)
  adddatum2(obj98, num2269, 5);
  sourceObject = obj98;
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2270 = alloc_Float64(1);
// compiled num node returning num2270 (depth = 2)
  adddatum2(obj98, num2270, 6);
  sourceObject = obj98;
  adddatum2(obj98, undefined, 7);
  sourceObject = obj98;
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2271 = alloc_Float64(0);
// compiled num node returning num2271 (depth = 2)
  adddatum2(obj98, num2271, 8);
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  adddatum2(obj98, undefined, 32);
  sourceObject = obj98;
// Begin line 256
  setline(256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit2272 == NULL) {
    strlit2272 = alloc_String("");
    gc_root(strlit2272);
  }
// compiled string node returning strlit2272 (depth = 2)
  adddatum2(obj98, strlit2272, 33);
  sourceObject = obj98;
// Begin line 258
  setline(258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool2273 = alloc_Boolean(0);
// compiled identifier node returning bool2273 (depth = 2)
  adddatum2(obj98, bool2273, 34);
  sourceObject = obj98;
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool2274 = alloc_Boolean(0);
// compiled identifier node returning bool2274 (depth = 2)
  adddatum2(obj98, bool2274, 35);
  sourceObject = obj98;
// Begin line 260
  setline(260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2275 = alloc_Float64(0);
// compiled num node returning num2275 (depth = 2)
  adddatum2(obj98, num2275, 36);
  sourceObject = obj98;
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2276 = alloc_Float64(0);
// compiled num node returning num2276 (depth = 2)
  adddatum2(obj98, num2276, 37);
  sourceObject = obj98;
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool2277 = alloc_Boolean(0);
// compiled identifier node returning bool2277 (depth = 2)
  adddatum2(obj98, bool2277, 38);
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  Object inheritingObject2278 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2278 = alloc_userobj2(1,2, objclass2278);
  gc_frame_newslot(obj2278);
  if (objclass2278 == NULL) {
    glfree(obj2278->class->name);
    obj2278->class->name = "startState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2278, obj98, 0);
  addmethodreal(obj2278,"outer", &reader_lexer_outer_2279);
  Object oldself2278 = self;
  struct StackFrameObject *oldstackframe2278 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2278);
  gc_frame_newslot((Object)stackframe);
  self = obj2278;
  Object *oldselfslot2278 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2278 = (*(struct UserObject *)self).data[0], lowerouter2278 = thisouter2278;
  if (inheritingObject2278) {
    struct UserObject *inho2278 = (struct UserObject *)inheritingObject2278;
    while (inho2278->super != GraceDefaultObject) inho2278 = (struct UserObject *)inho2278->super;
    inho2278->super = obj2278;
    self = inheritingObject2278;
    *selfslot = self;
    lowerouter2278 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2278;
  }
// method "consume(_)"
  struct UserObject *uo2280 = (struct UserObject*)obj2278;
  uo2280->data[1] = emptyclosure;
  Method *meth_meth_lexer_2280_consume_40_1_41_ = addmethod2pos(obj2278, "consume(1)", &meth_lexer_2280_consume_40_1_41_, 1);
  int argcv_meth_lexer_2280_consume_40_1_41_[] = {1};
  meth_meth_lexer_2280_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_2280_consume_40_1_41_);
  meth_meth_lexer_2280_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_2280_consume_40_1_41_->definitionLine = 272;
  sourceObject = obj2278;
  objclass2278 = obj2278->class;
  objclass2278->definitionModule = modulename;
  objclass2278->definitionLine = 271;
  (*(struct UserObject *)self).data[0] = lowerouter2278;
  self = oldself2278;
  selfslot = oldselfslot2278;
  stackframe = oldstackframe2278;
  adddatum2(obj98, obj2278, 42);
  sourceObject = obj98;
// Begin line 281
  setline(281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2308 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe2309 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2310 = callmethodflags(self, "startState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2309);
// compiled member node returning call2310 (depth = 3)
  gc_frame_newslot(call2310);
// call case 4: self request
  params[0] = call2310;
  partcv[0] = 1;
  Object call2311 = callmethodflags(self, "state:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2308);
// compiled call node returning call2311 (depth = 2)
  sourceObject = obj98;
  Object inheritingObject2312 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2312 = alloc_userobj2(1,2, objclass2312);
  gc_frame_newslot(obj2312);
  if (objclass2312 == NULL) {
    glfree(obj2312->class->name);
    obj2312->class->name = "pragmaPrefixState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2312, obj98, 0);
  addmethodreal(obj2312,"outer", &reader_lexer_outer_2313);
  Object oldself2312 = self;
  struct StackFrameObject *oldstackframe2312 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2312);
  gc_frame_newslot((Object)stackframe);
  self = obj2312;
  Object *oldselfslot2312 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2312 = (*(struct UserObject *)self).data[0], lowerouter2312 = thisouter2312;
  if (inheritingObject2312) {
    struct UserObject *inho2312 = (struct UserObject *)inheritingObject2312;
    while (inho2312->super != GraceDefaultObject) inho2312 = (struct UserObject *)inho2312->super;
    inho2312->super = obj2312;
    self = inheritingObject2312;
    *selfslot = self;
    lowerouter2312 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2312;
  }
// method "consume(_)"
  block_savedest(obj2312);
  Object closure2314 = createclosure(1, "consume(1)");
  setclosureframe(closure2314, stackframe);
  addtoclosure(closure2314, var_errormessages);
  struct UserObject *uo2314 = (struct UserObject*)obj2312;
  uo2314->data[1] = (Object)closure2314;
  Method *meth_meth_lexer_2314_consume_40_1_41_ = addmethod2pos(obj2312, "consume(1)", &meth_lexer_2314_consume_40_1_41_, 1);
  int argcv_meth_lexer_2314_consume_40_1_41_[] = {1};
  meth_meth_lexer_2314_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_2314_consume_40_1_41_);
  meth_meth_lexer_2314_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_2314_consume_40_1_41_->definitionLine = 284;
  sourceObject = obj2312;
  objclass2312 = obj2312->class;
  objclass2312->definitionModule = modulename;
  objclass2312->definitionLine = 283;
  (*(struct UserObject *)self).data[0] = lowerouter2312;
  self = oldself2312;
  selfslot = oldselfslot2312;
  stackframe = oldstackframe2312;
  adddatum2(obj98, obj2312, 43);
  sourceObject = obj98;
  Object inheritingObject2385 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2385 = alloc_userobj2(1,2, objclass2385);
  gc_frame_newslot(obj2385);
  if (objclass2385 == NULL) {
    glfree(obj2385->class->name);
    obj2385->class->name = "pragmaBodyState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2385, obj98, 0);
  addmethodreal(obj2385,"outer", &reader_lexer_outer_2386);
  Object oldself2385 = self;
  struct StackFrameObject *oldstackframe2385 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2385);
  gc_frame_newslot((Object)stackframe);
  self = obj2385;
  Object *oldselfslot2385 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2385 = (*(struct UserObject *)self).data[0], lowerouter2385 = thisouter2385;
  if (inheritingObject2385) {
    struct UserObject *inho2385 = (struct UserObject *)inheritingObject2385;
    while (inho2385->super != GraceDefaultObject) inho2385 = (struct UserObject *)inho2385->super;
    inho2385->super = obj2385;
    self = inheritingObject2385;
    *selfslot = self;
    lowerouter2385 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2385;
  }
// method "consume(_)"
  block_savedest(obj2385);
  Object closure2387 = createclosure(1, "consume(1)");
  setclosureframe(closure2387, stackframe);
  addtoclosure(closure2387, var_util);
  struct UserObject *uo2387 = (struct UserObject*)obj2385;
  uo2387->data[1] = (Object)closure2387;
  Method *meth_meth_lexer_2387_consume_40_1_41_ = addmethod2pos(obj2385, "consume(1)", &meth_lexer_2387_consume_40_1_41_, 1);
  int argcv_meth_lexer_2387_consume_40_1_41_[] = {1};
  meth_meth_lexer_2387_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_2387_consume_40_1_41_);
  meth_meth_lexer_2387_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_2387_consume_40_1_41_->definitionLine = 304;
  sourceObject = obj2385;
  objclass2385 = obj2385->class;
  objclass2385->definitionModule = modulename;
  objclass2385->definitionLine = 303;
  (*(struct UserObject *)self).data[0] = lowerouter2385;
  self = oldself2385;
  selfslot = oldselfslot2385;
  stackframe = oldstackframe2385;
  adddatum2(obj98, obj2385, 44);
  sourceObject = obj98;
  Object inheritingObject2433 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2433 = alloc_userobj2(1,2, objclass2433);
  gc_frame_newslot(obj2433);
  if (objclass2433 == NULL) {
    glfree(obj2433->class->name);
    obj2433->class->name = "pragmaTrailingWhitespaceState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2433, obj98, 0);
  addmethodreal(obj2433,"outer", &reader_lexer_outer_2434);
  Object oldself2433 = self;
  struct StackFrameObject *oldstackframe2433 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2433);
  gc_frame_newslot((Object)stackframe);
  self = obj2433;
  Object *oldselfslot2433 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2433 = (*(struct UserObject *)self).data[0], lowerouter2433 = thisouter2433;
  if (inheritingObject2433) {
    struct UserObject *inho2433 = (struct UserObject *)inheritingObject2433;
    while (inho2433->super != GraceDefaultObject) inho2433 = (struct UserObject *)inho2433->super;
    inho2433->super = obj2433;
    self = inheritingObject2433;
    *selfslot = self;
    lowerouter2433 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2433;
  }
// method "consume(_)"
  block_savedest(obj2433);
  Object closure2435 = createclosure(1, "consume(1)");
  setclosureframe(closure2435, stackframe);
  addtoclosure(closure2435, var_errormessages);
  struct UserObject *uo2435 = (struct UserObject*)obj2433;
  uo2435->data[1] = (Object)closure2435;
  Method *meth_meth_lexer_2435_consume_40_1_41_ = addmethod2pos(obj2433, "consume(1)", &meth_lexer_2435_consume_40_1_41_, 1);
  int argcv_meth_lexer_2435_consume_40_1_41_[] = {1};
  meth_meth_lexer_2435_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_2435_consume_40_1_41_);
  meth_meth_lexer_2435_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_2435_consume_40_1_41_->definitionLine = 319;
  sourceObject = obj2433;
  objclass2433 = obj2433->class;
  objclass2433->definitionModule = modulename;
  objclass2433->definitionLine = 318;
  (*(struct UserObject *)self).data[0] = lowerouter2433;
  self = oldself2433;
  selfslot = oldselfslot2433;
  stackframe = oldstackframe2433;
  adddatum2(obj98, obj2433, 45);
  sourceObject = obj98;
  Object inheritingObject2475 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2475 = alloc_userobj2(1,2, objclass2475);
  gc_frame_newslot(obj2475);
  if (objclass2475 == NULL) {
    glfree(obj2475->class->name);
    obj2475->class->name = "defaultState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2475, obj98, 0);
  addmethodreal(obj2475,"outer", &reader_lexer_outer_2476);
  Object oldself2475 = self;
  struct StackFrameObject *oldstackframe2475 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2475);
  gc_frame_newslot((Object)stackframe);
  self = obj2475;
  Object *oldselfslot2475 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2475 = (*(struct UserObject *)self).data[0], lowerouter2475 = thisouter2475;
  if (inheritingObject2475) {
    struct UserObject *inho2475 = (struct UserObject *)inheritingObject2475;
    while (inho2475->super != GraceDefaultObject) inho2475 = (struct UserObject *)inho2475->super;
    inho2475->super = obj2475;
    self = inheritingObject2475;
    *selfslot = self;
    lowerouter2475 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2475;
  }
// method "consume(_)"
  block_savedest(obj2475);
  Object closure2477 = createclosure(3, "consume(1)");
  setclosureframe(closure2477, stackframe);
  addtoclosure(closure2477, var_spaceChars);
  addtoclosure(closure2477, var_errormessages);
  addtoclosure(closure2477, var_unicode);
  struct UserObject *uo2477 = (struct UserObject*)obj2475;
  uo2477->data[1] = (Object)closure2477;
  Method *meth_meth_lexer_2477_consume_40_1_41_ = addmethod2pos(obj2475, "consume(1)", &meth_lexer_2477_consume_40_1_41_, 1);
  int argcv_meth_lexer_2477_consume_40_1_41_[] = {1};
  meth_meth_lexer_2477_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_2477_consume_40_1_41_);
  meth_meth_lexer_2477_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_2477_consume_40_1_41_->definitionLine = 331;
  sourceObject = obj2475;
  objclass2475 = obj2475->class;
  objclass2475->definitionModule = modulename;
  objclass2475->definitionLine = 330;
  (*(struct UserObject *)self).data[0] = lowerouter2475;
  self = oldself2475;
  selfslot = oldselfslot2475;
  stackframe = oldstackframe2475;
  adddatum2(obj98, obj2475, 46);
  sourceObject = obj98;
  Object inheritingObject3025 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3025 = alloc_userobj2(1,2, objclass3025);
  gc_frame_newslot(obj3025);
  if (objclass3025 == NULL) {
    glfree(obj3025->class->name);
    obj3025->class->name = "rBraceState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3025, obj98, 0);
  addmethodreal(obj3025,"outer", &reader_lexer_outer_3026);
  Object oldself3025 = self;
  struct StackFrameObject *oldstackframe3025 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3025);
  gc_frame_newslot((Object)stackframe);
  self = obj3025;
  Object *oldselfslot3025 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3025 = (*(struct UserObject *)self).data[0], lowerouter3025 = thisouter3025;
  if (inheritingObject3025) {
    struct UserObject *inho3025 = (struct UserObject *)inheritingObject3025;
    while (inho3025->super != GraceDefaultObject) inho3025 = (struct UserObject *)inho3025->super;
    inho3025->super = obj3025;
    self = inheritingObject3025;
    *selfslot = self;
    lowerouter3025 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3025;
  }
// method "consume(_)"
  block_savedest(obj3025);
  Object closure3027 = createclosure(1, "consume(1)");
  setclosureframe(closure3027, stackframe);
  addtoclosure(closure3027, var_errormessages);
  struct UserObject *uo3027 = (struct UserObject*)obj3025;
  uo3027->data[1] = (Object)closure3027;
  Method *meth_meth_lexer_3027_consume_40_1_41_ = addmethod2pos(obj3025, "consume(1)", &meth_lexer_3027_consume_40_1_41_, 1);
  int argcv_meth_lexer_3027_consume_40_1_41_[] = {1};
  meth_meth_lexer_3027_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_3027_consume_40_1_41_);
  meth_meth_lexer_3027_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_3027_consume_40_1_41_->definitionLine = 412;
  sourceObject = obj3025;
  objclass3025 = obj3025->class;
  objclass3025->definitionModule = modulename;
  objclass3025->definitionLine = 411;
  (*(struct UserObject *)self).data[0] = lowerouter3025;
  self = oldself3025;
  selfslot = oldselfslot3025;
  stackframe = oldstackframe3025;
  adddatum2(obj98, obj3025, 47);
  sourceObject = obj98;
  Object inheritingObject3173 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3173 = alloc_userobj2(1,2, objclass3173);
  gc_frame_newslot(obj3173);
  if (objclass3173 == NULL) {
    glfree(obj3173->class->name);
    obj3173->class->name = "slashState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3173, obj98, 0);
  addmethodreal(obj3173,"outer", &reader_lexer_outer_3174);
  Object oldself3173 = self;
  struct StackFrameObject *oldstackframe3173 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3173);
  gc_frame_newslot((Object)stackframe);
  self = obj3173;
  Object *oldselfslot3173 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3173 = (*(struct UserObject *)self).data[0], lowerouter3173 = thisouter3173;
  if (inheritingObject3173) {
    struct UserObject *inho3173 = (struct UserObject *)inheritingObject3173;
    while (inho3173->super != GraceDefaultObject) inho3173 = (struct UserObject *)inho3173->super;
    inho3173->super = obj3173;
    self = inheritingObject3173;
    *selfslot = self;
    lowerouter3173 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3173;
  }
// method "consume(_)"
  struct UserObject *uo3175 = (struct UserObject*)obj3173;
  uo3175->data[1] = emptyclosure;
  Method *meth_meth_lexer_3175_consume_40_1_41_ = addmethod2pos(obj3173, "consume(1)", &meth_lexer_3175_consume_40_1_41_, 1);
  int argcv_meth_lexer_3175_consume_40_1_41_[] = {1};
  meth_meth_lexer_3175_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_3175_consume_40_1_41_);
  meth_meth_lexer_3175_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_3175_consume_40_1_41_->definitionLine = 439;
  sourceObject = obj3173;
  objclass3173 = obj3173->class;
  objclass3173->definitionModule = modulename;
  objclass3173->definitionLine = 438;
  (*(struct UserObject *)self).data[0] = lowerouter3173;
  self = oldself3173;
  selfslot = oldselfslot3173;
  stackframe = oldstackframe3173;
  adddatum2(obj98, obj3173, 48);
  sourceObject = obj98;
  Object inheritingObject3243 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3243 = alloc_userobj2(1,2, objclass3243);
  gc_frame_newslot(obj3243);
  if (objclass3243 == NULL) {
    glfree(obj3243->class->name);
    obj3243->class->name = "dotState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3243, obj98, 0);
  addmethodreal(obj3243,"outer", &reader_lexer_outer_3244);
  Object oldself3243 = self;
  struct StackFrameObject *oldstackframe3243 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3243);
  gc_frame_newslot((Object)stackframe);
  self = obj3243;
  Object *oldselfslot3243 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3243 = (*(struct UserObject *)self).data[0], lowerouter3243 = thisouter3243;
  if (inheritingObject3243) {
    struct UserObject *inho3243 = (struct UserObject *)inheritingObject3243;
    while (inho3243->super != GraceDefaultObject) inho3243 = (struct UserObject *)inho3243->super;
    inho3243->super = obj3243;
    self = inheritingObject3243;
    *selfslot = self;
    lowerouter3243 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3243;
  }
// method "consume(_)"
  struct UserObject *uo3245 = (struct UserObject*)obj3243;
  uo3245->data[1] = emptyclosure;
  Method *meth_meth_lexer_3245_consume_40_1_41_ = addmethod2pos(obj3243, "consume(1)", &meth_lexer_3245_consume_40_1_41_, 1);
  int argcv_meth_lexer_3245_consume_40_1_41_[] = {1};
  meth_meth_lexer_3245_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_3245_consume_40_1_41_);
  meth_meth_lexer_3245_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_3245_consume_40_1_41_->definitionLine = 457;
  sourceObject = obj3243;
  objclass3243 = obj3243->class;
  objclass3243->definitionModule = modulename;
  objclass3243->definitionLine = 456;
  (*(struct UserObject *)self).data[0] = lowerouter3243;
  self = oldself3243;
  selfslot = oldselfslot3243;
  stackframe = oldstackframe3243;
  adddatum2(obj98, obj3243, 49);
  sourceObject = obj98;
  Object inheritingObject3343 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3343 = alloc_userobj2(1,2, objclass3343);
  gc_frame_newslot(obj3343);
  if (objclass3343 == NULL) {
    glfree(obj3343->class->name);
    obj3343->class->name = "identifierState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3343, obj98, 0);
  addmethodreal(obj3343,"outer", &reader_lexer_outer_3344);
  Object oldself3343 = self;
  struct StackFrameObject *oldstackframe3343 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3343);
  gc_frame_newslot((Object)stackframe);
  self = obj3343;
  Object *oldselfslot3343 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3343 = (*(struct UserObject *)self).data[0], lowerouter3343 = thisouter3343;
  if (inheritingObject3343) {
    struct UserObject *inho3343 = (struct UserObject *)inheritingObject3343;
    while (inho3343->super != GraceDefaultObject) inho3343 = (struct UserObject *)inho3343->super;
    inho3343->super = obj3343;
    self = inheritingObject3343;
    *selfslot = self;
    lowerouter3343 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3343;
  }
// method "consume(_)"
  block_savedest(obj3343);
  Object closure3345 = createclosure(2, "consume(1)");
  setclosureframe(closure3345, stackframe);
  addtoclosure(closure3345, var_keywords);
  addtoclosure(closure3345, var_errormessages);
  struct UserObject *uo3345 = (struct UserObject*)obj3343;
  uo3345->data[1] = (Object)closure3345;
  Method *meth_meth_lexer_3345_consume_40_1_41_ = addmethod2pos(obj3343, "consume(1)", &meth_lexer_3345_consume_40_1_41_, 1);
  int argcv_meth_lexer_3345_consume_40_1_41_[] = {1};
  meth_meth_lexer_3345_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_3345_consume_40_1_41_);
  meth_meth_lexer_3345_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_3345_consume_40_1_41_->definitionLine = 481;
  sourceObject = obj3343;
  objclass3343 = obj3343->class;
  objclass3343->definitionModule = modulename;
  objclass3343->definitionLine = 480;
  (*(struct UserObject *)self).data[0] = lowerouter3343;
  self = oldself3343;
  selfslot = oldselfslot3343;
  stackframe = oldstackframe3343;
  adddatum2(obj98, obj3343, 50);
  sourceObject = obj98;
  Object inheritingObject3464 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3464 = alloc_userobj2(1,2, objclass3464);
  gc_frame_newslot(obj3464);
  if (objclass3464 == NULL) {
    glfree(obj3464->class->name);
    obj3464->class->name = "quotedStringState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3464, obj98, 0);
  addmethodreal(obj3464,"outer", &reader_lexer_outer_3465);
  Object oldself3464 = self;
  struct StackFrameObject *oldstackframe3464 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3464);
  gc_frame_newslot((Object)stackframe);
  self = obj3464;
  Object *oldselfslot3464 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3464 = (*(struct UserObject *)self).data[0], lowerouter3464 = thisouter3464;
  if (inheritingObject3464) {
    struct UserObject *inho3464 = (struct UserObject *)inheritingObject3464;
    while (inho3464->super != GraceDefaultObject) inho3464 = (struct UserObject *)inho3464->super;
    inho3464->super = obj3464;
    self = inheritingObject3464;
    *selfslot = self;
    lowerouter3464 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3464;
  }
// method "consume(_)"
  struct UserObject *uo3466 = (struct UserObject*)obj3464;
  uo3466->data[1] = emptyclosure;
  Method *meth_meth_lexer_3466_consume_40_1_41_ = addmethod2pos(obj3464, "consume(1)", &meth_lexer_3466_consume_40_1_41_, 1);
  int argcv_meth_lexer_3466_consume_40_1_41_[] = {1};
  meth_meth_lexer_3466_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_3466_consume_40_1_41_);
  meth_meth_lexer_3466_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_3466_consume_40_1_41_->definitionLine = 507;
  sourceObject = obj3464;
  objclass3464 = obj3464->class;
  objclass3464->definitionModule = modulename;
  objclass3464->definitionLine = 506;
  (*(struct UserObject *)self).data[0] = lowerouter3464;
  self = oldself3464;
  selfslot = oldselfslot3464;
  stackframe = oldstackframe3464;
  adddatum2(obj98, obj3464, 51);
  sourceObject = obj98;
  Object inheritingObject3643 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3643 = alloc_userobj2(1,2, objclass3643);
  gc_frame_newslot(obj3643);
  if (objclass3643 == NULL) {
    glfree(obj3643->class->name);
    obj3643->class->name = "unicodeState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3643, obj98, 0);
  addmethodreal(obj3643,"outer", &reader_lexer_outer_3644);
  Object oldself3643 = self;
  struct StackFrameObject *oldstackframe3643 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3643);
  gc_frame_newslot((Object)stackframe);
  self = obj3643;
  Object *oldselfslot3643 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3643 = (*(struct UserObject *)self).data[0], lowerouter3643 = thisouter3643;
  if (inheritingObject3643) {
    struct UserObject *inho3643 = (struct UserObject *)inheritingObject3643;
    while (inho3643->super != GraceDefaultObject) inho3643 = (struct UserObject *)inho3643->super;
    inho3643->super = obj3643;
    self = inheritingObject3643;
    *selfslot = self;
    lowerouter3643 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3643;
  }
// method "consume(_)"
  block_savedest(obj3643);
  Object closure3645 = createclosure(1, "consume(1)");
  setclosureframe(closure3645, stackframe);
  addtoclosure(closure3645, var_unicode);
  struct UserObject *uo3645 = (struct UserObject*)obj3643;
  uo3645->data[1] = (Object)closure3645;
  Method *meth_meth_lexer_3645_consume_40_1_41_ = addmethod2pos(obj3643, "consume(1)", &meth_lexer_3645_consume_40_1_41_, 1);
  int argcv_meth_lexer_3645_consume_40_1_41_[] = {1};
  meth_meth_lexer_3645_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_3645_consume_40_1_41_);
  meth_meth_lexer_3645_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_3645_consume_40_1_41_->definitionLine = 541;
  sourceObject = obj3643;
  objclass3643 = obj3643->class;
  objclass3643->definitionModule = modulename;
  objclass3643->definitionLine = 540;
  (*(struct UserObject *)self).data[0] = lowerouter3643;
  self = oldself3643;
  selfslot = oldselfslot3643;
  stackframe = oldstackframe3643;
  adddatum2(obj98, obj3643, 52);
  sourceObject = obj98;
  Object inheritingObject3712 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3712 = alloc_userobj2(1,2, objclass3712);
  gc_frame_newslot(obj3712);
  if (objclass3712 == NULL) {
    glfree(obj3712->class->name);
    obj3712->class->name = "quotedStringEscapedState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3712, obj98, 0);
  addmethodreal(obj3712,"outer", &reader_lexer_outer_3713);
  Object oldself3712 = self;
  struct StackFrameObject *oldstackframe3712 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3712);
  gc_frame_newslot((Object)stackframe);
  self = obj3712;
  Object *oldselfslot3712 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3712 = (*(struct UserObject *)self).data[0], lowerouter3712 = thisouter3712;
  if (inheritingObject3712) {
    struct UserObject *inho3712 = (struct UserObject *)inheritingObject3712;
    while (inho3712->super != GraceDefaultObject) inho3712 = (struct UserObject *)inho3712->super;
    inho3712->super = obj3712;
    self = inheritingObject3712;
    *selfslot = self;
    lowerouter3712 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3712;
  }
// method "consume(_)"
  struct UserObject *uo3714 = (struct UserObject*)obj3712;
  uo3714->data[1] = emptyclosure;
  Method *meth_meth_lexer_3714_consume_40_1_41_ = addmethod2pos(obj3712, "consume(1)", &meth_lexer_3714_consume_40_1_41_, 1);
  int argcv_meth_lexer_3714_consume_40_1_41_[] = {1};
  meth_meth_lexer_3714_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_3714_consume_40_1_41_);
  meth_meth_lexer_3714_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_3714_consume_40_1_41_->definitionLine = 555;
  sourceObject = obj3712;
  objclass3712 = obj3712->class;
  objclass3712->definitionModule = modulename;
  objclass3712->definitionLine = 554;
  (*(struct UserObject *)self).data[0] = lowerouter3712;
  self = oldself3712;
  selfslot = oldselfslot3712;
  stackframe = oldstackframe3712;
  adddatum2(obj98, obj3712, 53);
  sourceObject = obj98;
  Object inheritingObject3922 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3922 = alloc_userobj2(1,2, objclass3922);
  gc_frame_newslot(obj3922);
  if (objclass3922 == NULL) {
    glfree(obj3922->class->name);
    obj3922->class->name = "extendedStringState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3922, obj98, 0);
  addmethodreal(obj3922,"outer", &reader_lexer_outer_3923);
  Object oldself3922 = self;
  struct StackFrameObject *oldstackframe3922 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3922);
  gc_frame_newslot((Object)stackframe);
  self = obj3922;
  Object *oldselfslot3922 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3922 = (*(struct UserObject *)self).data[0], lowerouter3922 = thisouter3922;
  if (inheritingObject3922) {
    struct UserObject *inho3922 = (struct UserObject *)inheritingObject3922;
    while (inho3922->super != GraceDefaultObject) inho3922 = (struct UserObject *)inho3922->super;
    inho3922->super = obj3922;
    self = inheritingObject3922;
    *selfslot = self;
    lowerouter3922 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3922;
  }
// method "consume(_)"
  struct UserObject *uo3924 = (struct UserObject*)obj3922;
  uo3924->data[1] = emptyclosure;
  Method *meth_meth_lexer_3924_consume_40_1_41_ = addmethod2pos(obj3922, "consume(1)", &meth_lexer_3924_consume_40_1_41_, 1);
  int argcv_meth_lexer_3924_consume_40_1_41_[] = {1};
  meth_meth_lexer_3924_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_3924_consume_40_1_41_);
  meth_meth_lexer_3924_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_3924_consume_40_1_41_->definitionLine = 605;
  sourceObject = obj3922;
  objclass3922 = obj3922->class;
  objclass3922->definitionModule = modulename;
  objclass3922->definitionLine = 604;
  (*(struct UserObject *)self).data[0] = lowerouter3922;
  self = oldself3922;
  selfslot = oldselfslot3922;
  stackframe = oldstackframe3922;
  adddatum2(obj98, obj3922, 54);
  sourceObject = obj98;
  adddatum2(obj98, undefined, 55);
  sourceObject = obj98;
  adddatum2(obj98, undefined, 56);
  sourceObject = obj98;
  Object inheritingObject3959 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3959 = alloc_userobj2(1,2, objclass3959);
  gc_frame_newslot(obj3959);
  if (objclass3959 == NULL) {
    glfree(obj3959->class->name);
    obj3959->class->name = "numberStartState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3959, obj98, 0);
  addmethodreal(obj3959,"outer", &reader_lexer_outer_3960);
  Object oldself3959 = self;
  struct StackFrameObject *oldstackframe3959 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3959);
  gc_frame_newslot((Object)stackframe);
  self = obj3959;
  Object *oldselfslot3959 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3959 = (*(struct UserObject *)self).data[0], lowerouter3959 = thisouter3959;
  if (inheritingObject3959) {
    struct UserObject *inho3959 = (struct UserObject *)inheritingObject3959;
    while (inho3959->super != GraceDefaultObject) inho3959 = (struct UserObject *)inho3959->super;
    inho3959->super = obj3959;
    self = inheritingObject3959;
    *selfslot = self;
    lowerouter3959 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3959;
  }
// method "consume(_)"
  block_savedest(obj3959);
  Object closure3961 = createclosure(1, "consume(1)");
  setclosureframe(closure3961, stackframe);
  addtoclosure(closure3961, var_errormessages);
  struct UserObject *uo3961 = (struct UserObject*)obj3959;
  uo3961->data[1] = (Object)closure3961;
  Method *meth_meth_lexer_3961_consume_40_1_41_ = addmethod2pos(obj3959, "consume(1)", &meth_lexer_3961_consume_40_1_41_, 1);
  int argcv_meth_lexer_3961_consume_40_1_41_[] = {1};
  meth_meth_lexer_3961_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_3961_consume_40_1_41_);
  meth_meth_lexer_3961_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_3961_consume_40_1_41_->definitionLine = 620;
  sourceObject = obj3959;
  objclass3959 = obj3959->class;
  objclass3959->definitionModule = modulename;
  objclass3959->definitionLine = 619;
  (*(struct UserObject *)self).data[0] = lowerouter3959;
  self = oldself3959;
  selfslot = oldselfslot3959;
  stackframe = oldstackframe3959;
  adddatum2(obj98, obj3959, 57);
  sourceObject = obj98;
  Object inheritingObject4130 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4130 = alloc_userobj2(1,2, objclass4130);
  gc_frame_newslot(obj4130);
  if (objclass4130 == NULL) {
    glfree(obj4130->class->name);
    obj4130->class->name = "numberBaseState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4130, obj98, 0);
  addmethodreal(obj4130,"outer", &reader_lexer_outer_4131);
  Object oldself4130 = self;
  struct StackFrameObject *oldstackframe4130 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4130);
  gc_frame_newslot((Object)stackframe);
  self = obj4130;
  Object *oldselfslot4130 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4130 = (*(struct UserObject *)self).data[0], lowerouter4130 = thisouter4130;
  if (inheritingObject4130) {
    struct UserObject *inho4130 = (struct UserObject *)inheritingObject4130;
    while (inho4130->super != GraceDefaultObject) inho4130 = (struct UserObject *)inho4130->super;
    inho4130->super = obj4130;
    self = inheritingObject4130;
    *selfslot = self;
    lowerouter4130 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4130;
  }
// method "consume(_)"
  struct UserObject *uo4132 = (struct UserObject*)obj4130;
  uo4132->data[1] = emptyclosure;
  Method *meth_meth_lexer_4132_consume_40_1_41_ = addmethod2pos(obj4130, "consume(1)", &meth_lexer_4132_consume_40_1_41_, 1);
  int argcv_meth_lexer_4132_consume_40_1_41_[] = {1};
  meth_meth_lexer_4132_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_4132_consume_40_1_41_);
  meth_meth_lexer_4132_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_4132_consume_40_1_41_->definitionLine = 650;
  sourceObject = obj4130;
  objclass4130 = obj4130->class;
  objclass4130->definitionModule = modulename;
  objclass4130->definitionLine = 649;
  (*(struct UserObject *)self).data[0] = lowerouter4130;
  self = oldself4130;
  selfslot = oldselfslot4130;
  stackframe = oldstackframe4130;
  adddatum2(obj98, obj4130, 58);
  sourceObject = obj98;
  Object inheritingObject4213 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4213 = alloc_userobj2(1,2, objclass4213);
  gc_frame_newslot(obj4213);
  if (objclass4213 == NULL) {
    glfree(obj4213->class->name);
    obj4213->class->name = "numberDotState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4213, obj98, 0);
  addmethodreal(obj4213,"outer", &reader_lexer_outer_4214);
  Object oldself4213 = self;
  struct StackFrameObject *oldstackframe4213 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4213);
  gc_frame_newslot((Object)stackframe);
  self = obj4213;
  Object *oldselfslot4213 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4213 = (*(struct UserObject *)self).data[0], lowerouter4213 = thisouter4213;
  if (inheritingObject4213) {
    struct UserObject *inho4213 = (struct UserObject *)inheritingObject4213;
    while (inho4213->super != GraceDefaultObject) inho4213 = (struct UserObject *)inho4213->super;
    inho4213->super = obj4213;
    self = inheritingObject4213;
    *selfslot = self;
    lowerouter4213 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4213;
  }
// method "consume(_)"
  block_savedest(obj4213);
  Object closure4215 = createclosure(1, "consume(1)");
  setclosureframe(closure4215, stackframe);
  addtoclosure(closure4215, var_spaceChars);
  struct UserObject *uo4215 = (struct UserObject*)obj4213;
  uo4215->data[1] = (Object)closure4215;
  Method *meth_meth_lexer_4215_consume_40_1_41_ = addmethod2pos(obj4213, "consume(1)", &meth_lexer_4215_consume_40_1_41_, 1);
  int argcv_meth_lexer_4215_consume_40_1_41_[] = {1};
  meth_meth_lexer_4215_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_4215_consume_40_1_41_);
  meth_meth_lexer_4215_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_4215_consume_40_1_41_->definitionLine = 666;
  sourceObject = obj4213;
  objclass4213 = obj4213->class;
  objclass4213->definitionModule = modulename;
  objclass4213->definitionLine = 665;
  (*(struct UserObject *)self).data[0] = lowerouter4213;
  self = oldself4213;
  selfslot = oldselfslot4213;
  stackframe = oldstackframe4213;
  adddatum2(obj98, obj4213, 59);
  sourceObject = obj98;
  Object inheritingObject4300 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4300 = alloc_userobj2(1,2, objclass4300);
  gc_frame_newslot(obj4300);
  if (objclass4300 == NULL) {
    glfree(obj4300->class->name);
    obj4300->class->name = "numberFractionState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4300, obj98, 0);
  addmethodreal(obj4300,"outer", &reader_lexer_outer_4301);
  Object oldself4300 = self;
  struct StackFrameObject *oldstackframe4300 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4300);
  gc_frame_newslot((Object)stackframe);
  self = obj4300;
  Object *oldselfslot4300 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4300 = (*(struct UserObject *)self).data[0], lowerouter4300 = thisouter4300;
  if (inheritingObject4300) {
    struct UserObject *inho4300 = (struct UserObject *)inheritingObject4300;
    while (inho4300->super != GraceDefaultObject) inho4300 = (struct UserObject *)inho4300->super;
    inho4300->super = obj4300;
    self = inheritingObject4300;
    *selfslot = self;
    lowerouter4300 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4300;
  }
// method "consume(_)"
  block_savedest(obj4300);
  Object closure4302 = createclosure(1, "consume(1)");
  setclosureframe(closure4302, stackframe);
  addtoclosure(closure4302, var_errormessages);
  struct UserObject *uo4302 = (struct UserObject*)obj4300;
  uo4302->data[1] = (Object)closure4302;
  Method *meth_meth_lexer_4302_consume_40_1_41_ = addmethod2pos(obj4300, "consume(1)", &meth_lexer_4302_consume_40_1_41_, 1);
  int argcv_meth_lexer_4302_consume_40_1_41_[] = {1};
  meth_meth_lexer_4302_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_4302_consume_40_1_41_);
  meth_meth_lexer_4302_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_4302_consume_40_1_41_->definitionLine = 685;
  sourceObject = obj4300;
  objclass4300 = obj4300->class;
  objclass4300->definitionModule = modulename;
  objclass4300->definitionLine = 684;
  (*(struct UserObject *)self).data[0] = lowerouter4300;
  self = oldself4300;
  selfslot = oldselfslot4300;
  stackframe = oldstackframe4300;
  adddatum2(obj98, obj4300, 60);
  sourceObject = obj98;
  Object inheritingObject4394 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4394 = alloc_userobj2(1,2, objclass4394);
  gc_frame_newslot(obj4394);
  if (objclass4394 == NULL) {
    glfree(obj4394->class->name);
    obj4394->class->name = "numberExponentSignState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4394, obj98, 0);
  addmethodreal(obj4394,"outer", &reader_lexer_outer_4395);
  Object oldself4394 = self;
  struct StackFrameObject *oldstackframe4394 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4394);
  gc_frame_newslot((Object)stackframe);
  self = obj4394;
  Object *oldselfslot4394 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4394 = (*(struct UserObject *)self).data[0], lowerouter4394 = thisouter4394;
  if (inheritingObject4394) {
    struct UserObject *inho4394 = (struct UserObject *)inheritingObject4394;
    while (inho4394->super != GraceDefaultObject) inho4394 = (struct UserObject *)inho4394->super;
    inho4394->super = obj4394;
    self = inheritingObject4394;
    *selfslot = self;
    lowerouter4394 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4394;
  }
// method "consume(_)"
  block_savedest(obj4394);
  Object closure4396 = createclosure(1, "consume(1)");
  setclosureframe(closure4396, stackframe);
  addtoclosure(closure4396, var_errormessages);
  struct UserObject *uo4396 = (struct UserObject*)obj4394;
  uo4396->data[1] = (Object)closure4396;
  Method *meth_meth_lexer_4396_consume_40_1_41_ = addmethod2pos(obj4394, "consume(1)", &meth_lexer_4396_consume_40_1_41_, 1);
  int argcv_meth_lexer_4396_consume_40_1_41_[] = {1};
  meth_meth_lexer_4396_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_4396_consume_40_1_41_);
  meth_meth_lexer_4396_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_4396_consume_40_1_41_->definitionLine = 704;
  sourceObject = obj4394;
  objclass4394 = obj4394->class;
  objclass4394->definitionModule = modulename;
  objclass4394->definitionLine = 703;
  (*(struct UserObject *)self).data[0] = lowerouter4394;
  self = oldself4394;
  selfslot = oldselfslot4394;
  stackframe = oldstackframe4394;
  adddatum2(obj98, obj4394, 61);
  sourceObject = obj98;
  Object inheritingObject4463 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4463 = alloc_userobj2(1,2, objclass4463);
  gc_frame_newslot(obj4463);
  if (objclass4463 == NULL) {
    glfree(obj4463->class->name);
    obj4463->class->name = "numberExponentState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4463, obj98, 0);
  addmethodreal(obj4463,"outer", &reader_lexer_outer_4464);
  Object oldself4463 = self;
  struct StackFrameObject *oldstackframe4463 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4463);
  gc_frame_newslot((Object)stackframe);
  self = obj4463;
  Object *oldselfslot4463 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4463 = (*(struct UserObject *)self).data[0], lowerouter4463 = thisouter4463;
  if (inheritingObject4463) {
    struct UserObject *inho4463 = (struct UserObject *)inheritingObject4463;
    while (inho4463->super != GraceDefaultObject) inho4463 = (struct UserObject *)inho4463->super;
    inho4463->super = obj4463;
    self = inheritingObject4463;
    *selfslot = self;
    lowerouter4463 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4463;
  }
// method "consume(_)"
  block_savedest(obj4463);
  Object closure4465 = createclosure(1, "consume(1)");
  setclosureframe(closure4465, stackframe);
  addtoclosure(closure4465, var_errormessages);
  struct UserObject *uo4465 = (struct UserObject*)obj4463;
  uo4465->data[1] = (Object)closure4465;
  Method *meth_meth_lexer_4465_consume_40_1_41_ = addmethod2pos(obj4463, "consume(1)", &meth_lexer_4465_consume_40_1_41_, 1);
  int argcv_meth_lexer_4465_consume_40_1_41_[] = {1};
  meth_meth_lexer_4465_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_4465_consume_40_1_41_);
  meth_meth_lexer_4465_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_4465_consume_40_1_41_->definitionLine = 719;
  sourceObject = obj4463;
  objclass4463 = obj4463->class;
  objclass4463->definitionModule = modulename;
  objclass4463->definitionLine = 718;
  (*(struct UserObject *)self).data[0] = lowerouter4463;
  self = oldself4463;
  selfslot = oldselfslot4463;
  stackframe = oldstackframe4463;
  adddatum2(obj98, obj4463, 62);
  sourceObject = obj98;
  Object inheritingObject4606 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4606 = alloc_userobj2(1,2, objclass4606);
  gc_frame_newslot(obj4606);
  if (objclass4606 == NULL) {
    glfree(obj4606->class->name);
    obj4606->class->name = "operatorState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4606, obj98, 0);
  addmethodreal(obj4606,"outer", &reader_lexer_outer_4607);
  Object oldself4606 = self;
  struct StackFrameObject *oldstackframe4606 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4606);
  gc_frame_newslot((Object)stackframe);
  self = obj4606;
  Object *oldselfslot4606 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4606 = (*(struct UserObject *)self).data[0], lowerouter4606 = thisouter4606;
  if (inheritingObject4606) {
    struct UserObject *inho4606 = (struct UserObject *)inheritingObject4606;
    while (inho4606->super != GraceDefaultObject) inho4606 = (struct UserObject *)inho4606->super;
    inho4606->super = obj4606;
    self = inheritingObject4606;
    *selfslot = self;
    lowerouter4606 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4606;
  }
// method "consume(_)"
  struct UserObject *uo4608 = (struct UserObject*)obj4606;
  uo4608->data[1] = emptyclosure;
  Method *meth_meth_lexer_4608_consume_40_1_41_ = addmethod2pos(obj4606, "consume(1)", &meth_lexer_4608_consume_40_1_41_, 1);
  int argcv_meth_lexer_4608_consume_40_1_41_[] = {1};
  meth_meth_lexer_4608_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_4608_consume_40_1_41_);
  meth_meth_lexer_4608_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_4608_consume_40_1_41_->definitionLine = 752;
  sourceObject = obj4606;
  objclass4606 = obj4606->class;
  objclass4606->definitionModule = modulename;
  objclass4606->definitionLine = 751;
  (*(struct UserObject *)self).data[0] = lowerouter4606;
  self = oldself4606;
  selfslot = oldselfslot4606;
  stackframe = oldstackframe4606;
  adddatum2(obj98, obj4606, 63);
  sourceObject = obj98;
  Object inheritingObject4699 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4699 = alloc_userobj2(1,2, objclass4699);
  gc_frame_newslot(obj4699);
  if (objclass4699 == NULL) {
    glfree(obj4699->class->name);
    obj4699->class->name = "indentationState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4699, obj98, 0);
  addmethodreal(obj4699,"outer", &reader_lexer_outer_4700);
  Object oldself4699 = self;
  struct StackFrameObject *oldstackframe4699 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4699);
  gc_frame_newslot((Object)stackframe);
  self = obj4699;
  Object *oldselfslot4699 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4699 = (*(struct UserObject *)self).data[0], lowerouter4699 = thisouter4699;
  if (inheritingObject4699) {
    struct UserObject *inho4699 = (struct UserObject *)inheritingObject4699;
    while (inho4699->super != GraceDefaultObject) inho4699 = (struct UserObject *)inho4699->super;
    inho4699->super = obj4699;
    self = inheritingObject4699;
    *selfslot = self;
    lowerouter4699 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4699;
  }
// method "consume(_)"
  block_savedest(obj4699);
  Object closure4701 = createclosure(1, "consume(1)");
  setclosureframe(closure4701, stackframe);
  addtoclosure(closure4701, var_spaceChars);
  struct UserObject *uo4701 = (struct UserObject*)obj4699;
  uo4701->data[1] = (Object)closure4701;
  Method *meth_meth_lexer_4701_consume_40_1_41_ = addmethod2pos(obj4699, "consume(1)", &meth_lexer_4701_consume_40_1_41_, 1);
  int argcv_meth_lexer_4701_consume_40_1_41_[] = {1};
  meth_meth_lexer_4701_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_4701_consume_40_1_41_);
  meth_meth_lexer_4701_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_4701_consume_40_1_41_->definitionLine = 773;
  sourceObject = obj4699;
  objclass4699 = obj4699->class;
  objclass4699->definitionModule = modulename;
  objclass4699->definitionLine = 772;
  (*(struct UserObject *)self).data[0] = lowerouter4699;
  self = oldself4699;
  selfslot = oldselfslot4699;
  stackframe = oldstackframe4699;
  adddatum2(obj98, obj4699, 64);
  sourceObject = obj98;
  Object inheritingObject4727 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4727 = alloc_userobj2(1,2, objclass4727);
  gc_frame_newslot(obj4727);
  if (objclass4727 == NULL) {
    glfree(obj4727->class->name);
    obj4727->class->name = "commentSpaceState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4727, obj98, 0);
  addmethodreal(obj4727,"outer", &reader_lexer_outer_4728);
  Object oldself4727 = self;
  struct StackFrameObject *oldstackframe4727 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4727);
  gc_frame_newslot((Object)stackframe);
  self = obj4727;
  Object *oldselfslot4727 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4727 = (*(struct UserObject *)self).data[0], lowerouter4727 = thisouter4727;
  if (inheritingObject4727) {
    struct UserObject *inho4727 = (struct UserObject *)inheritingObject4727;
    while (inho4727->super != GraceDefaultObject) inho4727 = (struct UserObject *)inho4727->super;
    inho4727->super = obj4727;
    self = inheritingObject4727;
    *selfslot = self;
    lowerouter4727 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4727;
  }
// method "consume(_)"
  block_savedest(obj4727);
  Object closure4729 = createclosure(1, "consume(1)");
  setclosureframe(closure4729, stackframe);
  addtoclosure(closure4729, var_spaceChars);
  struct UserObject *uo4729 = (struct UserObject*)obj4727;
  uo4729->data[1] = (Object)closure4729;
  Method *meth_meth_lexer_4729_consume_40_1_41_ = addmethod2pos(obj4727, "consume(1)", &meth_lexer_4729_consume_40_1_41_, 1);
  int argcv_meth_lexer_4729_consume_40_1_41_[] = {1};
  meth_meth_lexer_4729_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_4729_consume_40_1_41_);
  meth_meth_lexer_4729_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_4729_consume_40_1_41_->definitionLine = 783;
  sourceObject = obj4727;
  objclass4727 = obj4727->class;
  objclass4727->definitionModule = modulename;
  objclass4727->definitionLine = 782;
  (*(struct UserObject *)self).data[0] = lowerouter4727;
  self = oldself4727;
  selfslot = oldselfslot4727;
  stackframe = oldstackframe4727;
  adddatum2(obj98, obj4727, 65);
  sourceObject = obj98;
  Object inheritingObject4754 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4754 = alloc_userobj2(1,2, objclass4754);
  gc_frame_newslot(obj4754);
  if (objclass4754 == NULL) {
    glfree(obj4754->class->name);
    obj4754->class->name = "commentState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4754, obj98, 0);
  addmethodreal(obj4754,"outer", &reader_lexer_outer_4755);
  Object oldself4754 = self;
  struct StackFrameObject *oldstackframe4754 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4754);
  gc_frame_newslot((Object)stackframe);
  self = obj4754;
  Object *oldselfslot4754 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4754 = (*(struct UserObject *)self).data[0], lowerouter4754 = thisouter4754;
  if (inheritingObject4754) {
    struct UserObject *inho4754 = (struct UserObject *)inheritingObject4754;
    while (inho4754->super != GraceDefaultObject) inho4754 = (struct UserObject *)inho4754->super;
    inho4754->super = obj4754;
    self = inheritingObject4754;
    *selfslot = self;
    lowerouter4754 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4754;
  }
// method "consume(_)"
  struct UserObject *uo4756 = (struct UserObject*)obj4754;
  uo4756->data[1] = emptyclosure;
  Method *meth_meth_lexer_4756_consume_40_1_41_ = addmethod2pos(obj4754, "consume(1)", &meth_lexer_4756_consume_40_1_41_, 1);
  int argcv_meth_lexer_4756_consume_40_1_41_[] = {1};
  meth_meth_lexer_4756_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_4756_consume_40_1_41_);
  meth_meth_lexer_4756_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_4756_consume_40_1_41_->definitionLine = 792;
  sourceObject = obj4754;
  objclass4754 = obj4754->class;
  objclass4754->definitionModule = modulename;
  objclass4754->definitionLine = 791;
  (*(struct UserObject *)self).data[0] = lowerouter4754;
  self = oldself4754;
  selfslot = oldselfslot4754;
  stackframe = oldstackframe4754;
  adddatum2(obj98, obj4754, 66);
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  objclass98 = obj98->class;
  objclass98->definitionModule = modulename;
  objclass98->definitionLine = 83;
  (*(struct UserObject *)self).data[0] = lowerouter98;
  self = oldself98;
  selfslot = oldselfslot98;
  stackframe = oldstackframe98;
  gc_frame_end(frame);
  return obj98;
}
Object meth_lexer_97_new_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_spaceChars = getfromclosure(closure, 2);
  Object *var_unicode = getfromclosure(closure, 3);
  Object *var_keywords = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject98 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj98 = alloc_userobj2(115,99, objclass98);
  gc_frame_newslot(obj98);
  if (objclass98 == NULL) {
    glfree(obj98->class->name);
    obj98->class->name = "new";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj98, self, 0);
  addmethodreal(obj98,"outer", &reader_lexer_outer_99);
  Object oldself98 = self;
  struct StackFrameObject *oldstackframe98 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe98);
  gc_frame_newslot((Object)stackframe);
  self = obj98;
  Object *oldselfslot98 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter98 = (*(struct UserObject *)self).data[0], lowerouter98 = thisouter98;
  if (inheritingObject98) {
    struct UserObject *inho98 = (struct UserObject *)inheritingObject98;
    while (inho98->super != GraceDefaultObject) inho98 = (struct UserObject *)inho98->super;
    inho98->super = obj98;
    self = inheritingObject98;
    *selfslot = self;
    lowerouter98 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter98;
  }
  if (objclass98 == NULL) {
    Method *reader100 = addmethodrealflags(obj98, "tokens", &reader_lexer_tokens_100, MFLAG_CONFIDENTIAL);
    Method *writer100 = addmethodrealflags(obj98, "tokens:=(1)", &writer_lexer_tokens_100, MFLAG_CONFIDENTIAL);
    reader100->definitionModule = modulename;
    writer100->definitionModule = modulename;
    reader100->definitionLine = 84;
    writer100->definitionLine = 84;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 1);
  if (objclass98 == NULL) {
    Method *reader101 = addmethodrealflags(obj98, "lineNumber", &reader_lexer_lineNumber_101, MFLAG_CONFIDENTIAL);
    Method *writer101 = addmethodrealflags(obj98, "lineNumber:=(1)", &writer_lexer_lineNumber_101, MFLAG_CONFIDENTIAL);
    reader101->definitionModule = modulename;
    writer101->definitionModule = modulename;
    reader101->definitionLine = 85;
    writer101->definitionLine = 85;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 2);
  if (objclass98 == NULL) {
    Method *reader102 = addmethodrealflags(obj98, "linePosition", &reader_lexer_linePosition_102, MFLAG_CONFIDENTIAL);
    Method *writer102 = addmethodrealflags(obj98, "linePosition:=(1)", &writer_lexer_linePosition_102, MFLAG_CONFIDENTIAL);
    reader102->definitionModule = modulename;
    writer102->definitionModule = modulename;
    reader102->definitionLine = 86;
    writer102->definitionLine = 86;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 3);
  if (objclass98 == NULL) {
    Method *reader103 = addmethodrealflags(obj98, "startPosition", &reader_lexer_startPosition_103, MFLAG_CONFIDENTIAL);
    Method *writer103 = addmethodrealflags(obj98, "startPosition:=(1)", &writer_lexer_startPosition_103, MFLAG_CONFIDENTIAL);
    reader103->definitionModule = modulename;
    writer103->definitionModule = modulename;
    reader103->definitionLine = 87;
    writer103->definitionLine = 87;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 4);
  if (objclass98 == NULL) {
    Method *reader104 = addmethodrealflags(obj98, "indentLevel", &reader_lexer_indentLevel_104, MFLAG_CONFIDENTIAL);
    Method *writer104 = addmethodrealflags(obj98, "indentLevel:=(1)", &writer_lexer_indentLevel_104, MFLAG_CONFIDENTIAL);
    reader104->definitionModule = modulename;
    writer104->definitionModule = modulename;
    reader104->definitionLine = 88;
    writer104->definitionLine = 88;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 5);
  if (objclass98 == NULL) {
    Method *reader105 = addmethodrealflags(obj98, "startLine", &reader_lexer_startLine_105, MFLAG_CONFIDENTIAL);
    Method *writer105 = addmethodrealflags(obj98, "startLine:=(1)", &writer_lexer_startLine_105, MFLAG_CONFIDENTIAL);
    reader105->definitionModule = modulename;
    writer105->definitionModule = modulename;
    reader105->definitionLine = 89;
    writer105->definitionLine = 89;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 6);
  if (objclass98 == NULL) {
    Method *reader106 = addmethodrealflags(obj98, "stringStart", &reader_lexer_stringStart_106, MFLAG_CONFIDENTIAL);
    Method *writer106 = addmethodrealflags(obj98, "stringStart:=(1)", &writer_lexer_stringStart_106, MFLAG_CONFIDENTIAL);
    reader106->definitionModule = modulename;
    writer106->definitionModule = modulename;
    reader106->definitionLine = 90;
    writer106->definitionLine = 90;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 7);
  if (objclass98 == NULL) {
    Method *reader107 = addmethodrealflags(obj98, "unichars", &reader_lexer_unichars_107, MFLAG_CONFIDENTIAL);
    Method *writer107 = addmethodrealflags(obj98, "unichars:=(1)", &writer_lexer_unichars_107, MFLAG_CONFIDENTIAL);
    reader107->definitionModule = modulename;
    writer107->definitionModule = modulename;
    reader107->definitionLine = 91;
    writer107->definitionLine = 91;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 8);
// method "token"
  struct UserObject *uo108 = (struct UserObject*)obj98;
  uo108->data[9] = emptyclosure;
  Method *meth_meth_lexer_108_token = addmethod2pos(obj98, "token", &meth_lexer_108_token, 9);
  int argcv_meth_lexer_108_token[] = {0};
  meth_meth_lexer_108_token->type = alloc_MethodType(1, argcv_meth_lexer_108_token);
  meth_meth_lexer_108_token->definitionModule = modulename;
  meth_meth_lexer_108_token->definitionLine = 92;
  Method *meth_meth_lexer_108_token_object = addmethod2pos(obj98, "token$object(1)", &meth_lexer_108_token_object, 9);
  int argcv_meth_lexer_108_token_object[] = {0};
  meth_meth_lexer_108_token_object->type = alloc_MethodType(1, argcv_meth_lexer_108_token_object);
  meth_meth_lexer_108_token_object->definitionModule = modulename;
  meth_meth_lexer_108_token_object->definitionLine = 92;
// method "identifierToken(_)"
  struct UserObject *uo214 = (struct UserObject*)obj98;
  uo214->data[10] = emptyclosure;
  Method *meth_meth_lexer_214_identifierToken_40_1_41_ = addmethod2pos(obj98, "identifierToken(1)", &meth_lexer_214_identifierToken_40_1_41_, 10);
  int argcv_meth_lexer_214_identifierToken_40_1_41_[] = {1};
  meth_meth_lexer_214_identifierToken_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_214_identifierToken_40_1_41_);
  meth_meth_lexer_214_identifierToken_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_214_identifierToken_40_1_41_->definitionLine = 115;
  Method *meth_meth_lexer_214_identifierToken_40_1_41__object = addmethod2pos(obj98, "identifierToken(1)$object(1)", &meth_lexer_214_identifierToken_40_1_41__object, 10);
  int argcv_meth_lexer_214_identifierToken_40_1_41__object[] = {1};
  meth_meth_lexer_214_identifierToken_40_1_41__object->type = alloc_MethodType(1, argcv_meth_lexer_214_identifierToken_40_1_41__object);
  meth_meth_lexer_214_identifierToken_40_1_41__object->definitionModule = modulename;
  meth_meth_lexer_214_identifierToken_40_1_41__object->definitionLine = 115;
// method "stringToken(_)"
  struct UserObject *uo228 = (struct UserObject*)obj98;
  uo228->data[11] = emptyclosure;
  Method *meth_meth_lexer_228_stringToken_40_1_41_ = addmethod2pos(obj98, "stringToken(1)", &meth_lexer_228_stringToken_40_1_41_, 11);
  int argcv_meth_lexer_228_stringToken_40_1_41_[] = {1};
  meth_meth_lexer_228_stringToken_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_228_stringToken_40_1_41_);
  meth_meth_lexer_228_stringToken_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_228_stringToken_40_1_41_->definitionLine = 121;
  Method *meth_meth_lexer_228_stringToken_40_1_41__object = addmethod2pos(obj98, "stringToken(1)$object(1)", &meth_lexer_228_stringToken_40_1_41__object, 11);
  int argcv_meth_lexer_228_stringToken_40_1_41__object[] = {1};
  meth_meth_lexer_228_stringToken_40_1_41__object->type = alloc_MethodType(1, argcv_meth_lexer_228_stringToken_40_1_41__object);
  meth_meth_lexer_228_stringToken_40_1_41__object->definitionModule = modulename;
  meth_meth_lexer_228_stringToken_40_1_41__object->definitionLine = 121;
// method "multiLineStringToken(_)"
  struct UserObject *uo255 = (struct UserObject*)obj98;
  uo255->data[12] = emptyclosure;
  Method *meth_meth_lexer_255_multiLineStringToken_40_1_41_ = addmethod2pos(obj98, "multiLineStringToken(1)", &meth_lexer_255_multiLineStringToken_40_1_41_, 12);
  int argcv_meth_lexer_255_multiLineStringToken_40_1_41_[] = {1};
  meth_meth_lexer_255_multiLineStringToken_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_255_multiLineStringToken_40_1_41_);
  meth_meth_lexer_255_multiLineStringToken_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_255_multiLineStringToken_40_1_41_->definitionLine = 127;
  Method *meth_meth_lexer_255_multiLineStringToken_40_1_41__object = addmethod2pos(obj98, "multiLineStringToken(1)$object(1)", &meth_lexer_255_multiLineStringToken_40_1_41__object, 12);
  int argcv_meth_lexer_255_multiLineStringToken_40_1_41__object[] = {1};
  meth_meth_lexer_255_multiLineStringToken_40_1_41__object->type = alloc_MethodType(1, argcv_meth_lexer_255_multiLineStringToken_40_1_41__object);
  meth_meth_lexer_255_multiLineStringToken_40_1_41__object->definitionModule = modulename;
  meth_meth_lexer_255_multiLineStringToken_40_1_41__object->definitionLine = 127;
// method "commentToken(_)"
  struct UserObject *uo299 = (struct UserObject*)obj98;
  uo299->data[13] = emptyclosure;
  Method *meth_meth_lexer_299_commentToken_40_1_41_ = addmethod2pos(obj98, "commentToken(1)", &meth_lexer_299_commentToken_40_1_41_, 13);
  int argcv_meth_lexer_299_commentToken_40_1_41_[] = {1};
  meth_meth_lexer_299_commentToken_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_299_commentToken_40_1_41_);
  meth_meth_lexer_299_commentToken_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_299_commentToken_40_1_41_->definitionLine = 139;
  Method *meth_meth_lexer_299_commentToken_40_1_41__object = addmethod2pos(obj98, "commentToken(1)$object(1)", &meth_lexer_299_commentToken_40_1_41__object, 13);
  int argcv_meth_lexer_299_commentToken_40_1_41__object[] = {1};
  meth_meth_lexer_299_commentToken_40_1_41__object->type = alloc_MethodType(1, argcv_meth_lexer_299_commentToken_40_1_41__object);
  meth_meth_lexer_299_commentToken_40_1_41__object->definitionModule = modulename;
  meth_meth_lexer_299_commentToken_40_1_41__object->definitionLine = 139;
// method "lBraceToken"
  struct UserObject *uo317 = (struct UserObject*)obj98;
  uo317->data[14] = emptyclosure;
  Method *meth_meth_lexer_317_lBraceToken = addmethod2pos(obj98, "lBraceToken", &meth_lexer_317_lBraceToken, 14);
  int argcv_meth_lexer_317_lBraceToken[] = {0};
  meth_meth_lexer_317_lBraceToken->type = alloc_MethodType(1, argcv_meth_lexer_317_lBraceToken);
  meth_meth_lexer_317_lBraceToken->definitionModule = modulename;
  meth_meth_lexer_317_lBraceToken->definitionLine = 145;
  Method *meth_meth_lexer_317_lBraceToken_object = addmethod2pos(obj98, "lBraceToken$object(1)", &meth_lexer_317_lBraceToken_object, 14);
  int argcv_meth_lexer_317_lBraceToken_object[] = {0};
  meth_meth_lexer_317_lBraceToken_object->type = alloc_MethodType(1, argcv_meth_lexer_317_lBraceToken_object);
  meth_meth_lexer_317_lBraceToken_object->definitionModule = modulename;
  meth_meth_lexer_317_lBraceToken_object->definitionLine = 145;
// method "rBraceToken"
  struct UserObject *uo331 = (struct UserObject*)obj98;
  uo331->data[15] = emptyclosure;
  Method *meth_meth_lexer_331_rBraceToken = addmethod2pos(obj98, "rBraceToken", &meth_lexer_331_rBraceToken, 15);
  int argcv_meth_lexer_331_rBraceToken[] = {0};
  meth_meth_lexer_331_rBraceToken->type = alloc_MethodType(1, argcv_meth_lexer_331_rBraceToken);
  meth_meth_lexer_331_rBraceToken->definitionModule = modulename;
  meth_meth_lexer_331_rBraceToken->definitionLine = 151;
  Method *meth_meth_lexer_331_rBraceToken_object = addmethod2pos(obj98, "rBraceToken$object(1)", &meth_lexer_331_rBraceToken_object, 15);
  int argcv_meth_lexer_331_rBraceToken_object[] = {0};
  meth_meth_lexer_331_rBraceToken_object->type = alloc_MethodType(1, argcv_meth_lexer_331_rBraceToken_object);
  meth_meth_lexer_331_rBraceToken_object->definitionModule = modulename;
  meth_meth_lexer_331_rBraceToken_object->definitionLine = 151;
// method "lParenToken"
  struct UserObject *uo345 = (struct UserObject*)obj98;
  uo345->data[16] = emptyclosure;
  Method *meth_meth_lexer_345_lParenToken = addmethod2pos(obj98, "lParenToken", &meth_lexer_345_lParenToken, 16);
  int argcv_meth_lexer_345_lParenToken[] = {0};
  meth_meth_lexer_345_lParenToken->type = alloc_MethodType(1, argcv_meth_lexer_345_lParenToken);
  meth_meth_lexer_345_lParenToken->definitionModule = modulename;
  meth_meth_lexer_345_lParenToken->definitionLine = 157;
  Method *meth_meth_lexer_345_lParenToken_object = addmethod2pos(obj98, "lParenToken$object(1)", &meth_lexer_345_lParenToken_object, 16);
  int argcv_meth_lexer_345_lParenToken_object[] = {0};
  meth_meth_lexer_345_lParenToken_object->type = alloc_MethodType(1, argcv_meth_lexer_345_lParenToken_object);
  meth_meth_lexer_345_lParenToken_object->definitionModule = modulename;
  meth_meth_lexer_345_lParenToken_object->definitionLine = 157;
// method "rParenToken"
  struct UserObject *uo359 = (struct UserObject*)obj98;
  uo359->data[17] = emptyclosure;
  Method *meth_meth_lexer_359_rParenToken = addmethod2pos(obj98, "rParenToken", &meth_lexer_359_rParenToken, 17);
  int argcv_meth_lexer_359_rParenToken[] = {0};
  meth_meth_lexer_359_rParenToken->type = alloc_MethodType(1, argcv_meth_lexer_359_rParenToken);
  meth_meth_lexer_359_rParenToken->definitionModule = modulename;
  meth_meth_lexer_359_rParenToken->definitionLine = 163;
  Method *meth_meth_lexer_359_rParenToken_object = addmethod2pos(obj98, "rParenToken$object(1)", &meth_lexer_359_rParenToken_object, 17);
  int argcv_meth_lexer_359_rParenToken_object[] = {0};
  meth_meth_lexer_359_rParenToken_object->type = alloc_MethodType(1, argcv_meth_lexer_359_rParenToken_object);
  meth_meth_lexer_359_rParenToken_object->definitionModule = modulename;
  meth_meth_lexer_359_rParenToken_object->definitionLine = 163;
// method "lSquareToken"
  struct UserObject *uo373 = (struct UserObject*)obj98;
  uo373->data[18] = emptyclosure;
  Method *meth_meth_lexer_373_lSquareToken = addmethod2pos(obj98, "lSquareToken", &meth_lexer_373_lSquareToken, 18);
  int argcv_meth_lexer_373_lSquareToken[] = {0};
  meth_meth_lexer_373_lSquareToken->type = alloc_MethodType(1, argcv_meth_lexer_373_lSquareToken);
  meth_meth_lexer_373_lSquareToken->definitionModule = modulename;
  meth_meth_lexer_373_lSquareToken->definitionLine = 169;
  Method *meth_meth_lexer_373_lSquareToken_object = addmethod2pos(obj98, "lSquareToken$object(1)", &meth_lexer_373_lSquareToken_object, 18);
  int argcv_meth_lexer_373_lSquareToken_object[] = {0};
  meth_meth_lexer_373_lSquareToken_object->type = alloc_MethodType(1, argcv_meth_lexer_373_lSquareToken_object);
  meth_meth_lexer_373_lSquareToken_object->definitionModule = modulename;
  meth_meth_lexer_373_lSquareToken_object->definitionLine = 169;
// method "rSquareToken"
  struct UserObject *uo387 = (struct UserObject*)obj98;
  uo387->data[19] = emptyclosure;
  Method *meth_meth_lexer_387_rSquareToken = addmethod2pos(obj98, "rSquareToken", &meth_lexer_387_rSquareToken, 19);
  int argcv_meth_lexer_387_rSquareToken[] = {0};
  meth_meth_lexer_387_rSquareToken->type = alloc_MethodType(1, argcv_meth_lexer_387_rSquareToken);
  meth_meth_lexer_387_rSquareToken->definitionModule = modulename;
  meth_meth_lexer_387_rSquareToken->definitionLine = 175;
  Method *meth_meth_lexer_387_rSquareToken_object = addmethod2pos(obj98, "rSquareToken$object(1)", &meth_lexer_387_rSquareToken_object, 19);
  int argcv_meth_lexer_387_rSquareToken_object[] = {0};
  meth_meth_lexer_387_rSquareToken_object->type = alloc_MethodType(1, argcv_meth_lexer_387_rSquareToken_object);
  meth_meth_lexer_387_rSquareToken_object->definitionModule = modulename;
  meth_meth_lexer_387_rSquareToken_object->definitionLine = 175;
// method "commaToken"
  struct UserObject *uo401 = (struct UserObject*)obj98;
  uo401->data[20] = emptyclosure;
  Method *meth_meth_lexer_401_commaToken = addmethod2pos(obj98, "commaToken", &meth_lexer_401_commaToken, 20);
  int argcv_meth_lexer_401_commaToken[] = {0};
  meth_meth_lexer_401_commaToken->type = alloc_MethodType(1, argcv_meth_lexer_401_commaToken);
  meth_meth_lexer_401_commaToken->definitionModule = modulename;
  meth_meth_lexer_401_commaToken->definitionLine = 181;
  Method *meth_meth_lexer_401_commaToken_object = addmethod2pos(obj98, "commaToken$object(1)", &meth_lexer_401_commaToken_object, 20);
  int argcv_meth_lexer_401_commaToken_object[] = {0};
  meth_meth_lexer_401_commaToken_object->type = alloc_MethodType(1, argcv_meth_lexer_401_commaToken_object);
  meth_meth_lexer_401_commaToken_object->definitionModule = modulename;
  meth_meth_lexer_401_commaToken_object->definitionLine = 181;
// method "colonToken"
  struct UserObject *uo415 = (struct UserObject*)obj98;
  uo415->data[21] = emptyclosure;
  Method *meth_meth_lexer_415_colonToken = addmethod2pos(obj98, "colonToken", &meth_lexer_415_colonToken, 21);
  int argcv_meth_lexer_415_colonToken[] = {0};
  meth_meth_lexer_415_colonToken->type = alloc_MethodType(1, argcv_meth_lexer_415_colonToken);
  meth_meth_lexer_415_colonToken->definitionModule = modulename;
  meth_meth_lexer_415_colonToken->definitionLine = 187;
  Method *meth_meth_lexer_415_colonToken_object = addmethod2pos(obj98, "colonToken$object(1)", &meth_lexer_415_colonToken_object, 21);
  int argcv_meth_lexer_415_colonToken_object[] = {0};
  meth_meth_lexer_415_colonToken_object->type = alloc_MethodType(1, argcv_meth_lexer_415_colonToken_object);
  meth_meth_lexer_415_colonToken_object->definitionModule = modulename;
  meth_meth_lexer_415_colonToken_object->definitionLine = 187;
// method "dotToken"
  struct UserObject *uo429 = (struct UserObject*)obj98;
  uo429->data[22] = emptyclosure;
  Method *meth_meth_lexer_429_dotToken = addmethod2pos(obj98, "dotToken", &meth_lexer_429_dotToken, 22);
  int argcv_meth_lexer_429_dotToken[] = {0};
  meth_meth_lexer_429_dotToken->type = alloc_MethodType(1, argcv_meth_lexer_429_dotToken);
  meth_meth_lexer_429_dotToken->definitionModule = modulename;
  meth_meth_lexer_429_dotToken->definitionLine = 193;
  Method *meth_meth_lexer_429_dotToken_object = addmethod2pos(obj98, "dotToken$object(1)", &meth_lexer_429_dotToken_object, 22);
  int argcv_meth_lexer_429_dotToken_object[] = {0};
  meth_meth_lexer_429_dotToken_object->type = alloc_MethodType(1, argcv_meth_lexer_429_dotToken_object);
  meth_meth_lexer_429_dotToken_object->definitionModule = modulename;
  meth_meth_lexer_429_dotToken_object->definitionLine = 193;
// method "numToken(_,_)"
  struct UserObject *uo443 = (struct UserObject*)obj98;
  uo443->data[23] = emptyclosure;
  Method *meth_meth_lexer_443_numToken_40_2_41_ = addmethod2pos(obj98, "numToken(2)", &meth_lexer_443_numToken_40_2_41_, 23);
  int argcv_meth_lexer_443_numToken_40_2_41_[] = {2};
  meth_meth_lexer_443_numToken_40_2_41_->type = alloc_MethodType(1, argcv_meth_lexer_443_numToken_40_2_41_);
  meth_meth_lexer_443_numToken_40_2_41_->definitionModule = modulename;
  meth_meth_lexer_443_numToken_40_2_41_->definitionLine = 199;
  Method *meth_meth_lexer_443_numToken_40_2_41__object = addmethod2pos(obj98, "numToken(2)$object(1)", &meth_lexer_443_numToken_40_2_41__object, 23);
  int argcv_meth_lexer_443_numToken_40_2_41__object[] = {2};
  meth_meth_lexer_443_numToken_40_2_41__object->type = alloc_MethodType(1, argcv_meth_lexer_443_numToken_40_2_41__object);
  meth_meth_lexer_443_numToken_40_2_41__object->definitionModule = modulename;
  meth_meth_lexer_443_numToken_40_2_41__object->definitionLine = 199;
// method "keywordToken(_)"
  struct UserObject *uo471 = (struct UserObject*)obj98;
  uo471->data[24] = emptyclosure;
  Method *meth_meth_lexer_471_keywordToken_40_1_41_ = addmethod2pos(obj98, "keywordToken(1)", &meth_lexer_471_keywordToken_40_1_41_, 24);
  int argcv_meth_lexer_471_keywordToken_40_1_41_[] = {1};
  meth_meth_lexer_471_keywordToken_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_471_keywordToken_40_1_41_);
  meth_meth_lexer_471_keywordToken_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_471_keywordToken_40_1_41_->definitionLine = 206;
  Method *meth_meth_lexer_471_keywordToken_40_1_41__object = addmethod2pos(obj98, "keywordToken(1)$object(1)", &meth_lexer_471_keywordToken_40_1_41__object, 24);
  int argcv_meth_lexer_471_keywordToken_40_1_41__object[] = {1};
  meth_meth_lexer_471_keywordToken_40_1_41__object->type = alloc_MethodType(1, argcv_meth_lexer_471_keywordToken_40_1_41__object);
  meth_meth_lexer_471_keywordToken_40_1_41__object->definitionModule = modulename;
  meth_meth_lexer_471_keywordToken_40_1_41__object->definitionLine = 206;
// method "opToken(_)"
  struct UserObject *uo485 = (struct UserObject*)obj98;
  uo485->data[25] = emptyclosure;
  Method *meth_meth_lexer_485_opToken_40_1_41_ = addmethod2pos(obj98, "opToken(1)", &meth_lexer_485_opToken_40_1_41_, 25);
  int argcv_meth_lexer_485_opToken_40_1_41_[] = {1};
  meth_meth_lexer_485_opToken_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_485_opToken_40_1_41_);
  meth_meth_lexer_485_opToken_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_485_opToken_40_1_41_->definitionLine = 212;
  Method *meth_meth_lexer_485_opToken_40_1_41__object = addmethod2pos(obj98, "opToken(1)$object(1)", &meth_lexer_485_opToken_40_1_41__object, 25);
  int argcv_meth_lexer_485_opToken_40_1_41__object[] = {1};
  meth_meth_lexer_485_opToken_40_1_41__object->type = alloc_MethodType(1, argcv_meth_lexer_485_opToken_40_1_41__object);
  meth_meth_lexer_485_opToken_40_1_41__object->definitionModule = modulename;
  meth_meth_lexer_485_opToken_40_1_41__object->definitionLine = 212;
// method "arrowToken"
  struct UserObject *uo499 = (struct UserObject*)obj98;
  uo499->data[26] = emptyclosure;
  Method *meth_meth_lexer_499_arrowToken = addmethod2pos(obj98, "arrowToken", &meth_lexer_499_arrowToken, 26);
  int argcv_meth_lexer_499_arrowToken[] = {0};
  meth_meth_lexer_499_arrowToken->type = alloc_MethodType(1, argcv_meth_lexer_499_arrowToken);
  meth_meth_lexer_499_arrowToken->definitionModule = modulename;
  meth_meth_lexer_499_arrowToken->definitionLine = 218;
  Method *meth_meth_lexer_499_arrowToken_object = addmethod2pos(obj98, "arrowToken$object(1)", &meth_lexer_499_arrowToken_object, 26);
  int argcv_meth_lexer_499_arrowToken_object[] = {0};
  meth_meth_lexer_499_arrowToken_object->type = alloc_MethodType(1, argcv_meth_lexer_499_arrowToken_object);
  meth_meth_lexer_499_arrowToken_object->definitionModule = modulename;
  meth_meth_lexer_499_arrowToken_object->definitionLine = 218;
// method "bindToken"
  struct UserObject *uo513 = (struct UserObject*)obj98;
  uo513->data[27] = emptyclosure;
  Method *meth_meth_lexer_513_bindToken = addmethod2pos(obj98, "bindToken", &meth_lexer_513_bindToken, 27);
  int argcv_meth_lexer_513_bindToken[] = {0};
  meth_meth_lexer_513_bindToken->type = alloc_MethodType(1, argcv_meth_lexer_513_bindToken);
  meth_meth_lexer_513_bindToken->definitionModule = modulename;
  meth_meth_lexer_513_bindToken->definitionLine = 224;
  Method *meth_meth_lexer_513_bindToken_object = addmethod2pos(obj98, "bindToken$object(1)", &meth_lexer_513_bindToken_object, 27);
  int argcv_meth_lexer_513_bindToken_object[] = {0};
  meth_meth_lexer_513_bindToken_object->type = alloc_MethodType(1, argcv_meth_lexer_513_bindToken_object);
  meth_meth_lexer_513_bindToken_object->definitionModule = modulename;
  meth_meth_lexer_513_bindToken_object->definitionLine = 224;
// method "semicolonToken"
  struct UserObject *uo527 = (struct UserObject*)obj98;
  uo527->data[28] = emptyclosure;
  Method *meth_meth_lexer_527_semicolonToken = addmethod2pos(obj98, "semicolonToken", &meth_lexer_527_semicolonToken, 28);
  int argcv_meth_lexer_527_semicolonToken[] = {0};
  meth_meth_lexer_527_semicolonToken->type = alloc_MethodType(1, argcv_meth_lexer_527_semicolonToken);
  meth_meth_lexer_527_semicolonToken->definitionModule = modulename;
  meth_meth_lexer_527_semicolonToken->definitionLine = 230;
  Method *meth_meth_lexer_527_semicolonToken_object = addmethod2pos(obj98, "semicolonToken$object(1)", &meth_lexer_527_semicolonToken_object, 28);
  int argcv_meth_lexer_527_semicolonToken_object[] = {0};
  meth_meth_lexer_527_semicolonToken_object->type = alloc_MethodType(1, argcv_meth_lexer_527_semicolonToken_object);
  meth_meth_lexer_527_semicolonToken_object->definitionModule = modulename;
  meth_meth_lexer_527_semicolonToken_object->definitionLine = 230;
// method "lGenericToken"
  struct UserObject *uo541 = (struct UserObject*)obj98;
  uo541->data[29] = emptyclosure;
  Method *meth_meth_lexer_541_lGenericToken = addmethod2pos(obj98, "lGenericToken", &meth_lexer_541_lGenericToken, 29);
  int argcv_meth_lexer_541_lGenericToken[] = {0};
  meth_meth_lexer_541_lGenericToken->type = alloc_MethodType(1, argcv_meth_lexer_541_lGenericToken);
  meth_meth_lexer_541_lGenericToken->definitionModule = modulename;
  meth_meth_lexer_541_lGenericToken->definitionLine = 236;
  Method *meth_meth_lexer_541_lGenericToken_object = addmethod2pos(obj98, "lGenericToken$object(1)", &meth_lexer_541_lGenericToken_object, 29);
  int argcv_meth_lexer_541_lGenericToken_object[] = {0};
  meth_meth_lexer_541_lGenericToken_object->type = alloc_MethodType(1, argcv_meth_lexer_541_lGenericToken_object);
  meth_meth_lexer_541_lGenericToken_object->definitionModule = modulename;
  meth_meth_lexer_541_lGenericToken_object->definitionLine = 236;
// method "rGenericToken"
  struct UserObject *uo555 = (struct UserObject*)obj98;
  uo555->data[30] = emptyclosure;
  Method *meth_meth_lexer_555_rGenericToken = addmethod2pos(obj98, "rGenericToken", &meth_lexer_555_rGenericToken, 30);
  int argcv_meth_lexer_555_rGenericToken[] = {0};
  meth_meth_lexer_555_rGenericToken->type = alloc_MethodType(1, argcv_meth_lexer_555_rGenericToken);
  meth_meth_lexer_555_rGenericToken->definitionModule = modulename;
  meth_meth_lexer_555_rGenericToken->definitionLine = 242;
  Method *meth_meth_lexer_555_rGenericToken_object = addmethod2pos(obj98, "rGenericToken$object(1)", &meth_lexer_555_rGenericToken_object, 30);
  int argcv_meth_lexer_555_rGenericToken_object[] = {0};
  meth_meth_lexer_555_rGenericToken_object->type = alloc_MethodType(1, argcv_meth_lexer_555_rGenericToken_object);
  meth_meth_lexer_555_rGenericToken_object->definitionModule = modulename;
  meth_meth_lexer_555_rGenericToken_object->definitionLine = 242;
// method "eofToken"
  struct UserObject *uo569 = (struct UserObject*)obj98;
  uo569->data[31] = emptyclosure;
  Method *meth_meth_lexer_569_eofToken = addmethod2pos(obj98, "eofToken", &meth_lexer_569_eofToken, 31);
  int argcv_meth_lexer_569_eofToken[] = {0};
  meth_meth_lexer_569_eofToken->type = alloc_MethodType(1, argcv_meth_lexer_569_eofToken);
  meth_meth_lexer_569_eofToken->definitionModule = modulename;
  meth_meth_lexer_569_eofToken->definitionLine = 248;
  Method *meth_meth_lexer_569_eofToken_object = addmethod2pos(obj98, "eofToken$object(1)", &meth_lexer_569_eofToken_object, 31);
  int argcv_meth_lexer_569_eofToken_object[] = {0};
  meth_meth_lexer_569_eofToken_object->type = alloc_MethodType(1, argcv_meth_lexer_569_eofToken_object);
  meth_meth_lexer_569_eofToken_object->definitionModule = modulename;
  meth_meth_lexer_569_eofToken_object->definitionLine = 248;
  if (objclass98 == NULL) {
    Method *reader583 = addmethodrealflags(obj98, "state", &reader_lexer_state_583, MFLAG_CONFIDENTIAL);
    Method *writer583 = addmethodrealflags(obj98, "state:=(1)", &writer_lexer_state_583, MFLAG_CONFIDENTIAL);
    reader583->definitionModule = modulename;
    writer583->definitionModule = modulename;
    reader583->definitionLine = 255;
    writer583->definitionLine = 255;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 32);
  if (objclass98 == NULL) {
    Method *reader584 = addmethodrealflags(obj98, "accum", &reader_lexer_accum_584, MFLAG_CONFIDENTIAL);
    Method *writer584 = addmethodrealflags(obj98, "accum:=(1)", &writer_lexer_accum_584, MFLAG_CONFIDENTIAL);
    reader584->definitionModule = modulename;
    writer584->definitionModule = modulename;
    reader584->definitionLine = 256;
    writer584->definitionLine = 256;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 33);
  if (objclass98 == NULL) {
    Method *reader585 = addmethodrealflags(obj98, "inStr", &reader_lexer_inStr_585, MFLAG_CONFIDENTIAL);
    Method *writer585 = addmethodrealflags(obj98, "inStr:=(1)", &writer_lexer_inStr_585, MFLAG_CONFIDENTIAL);
    reader585->definitionModule = modulename;
    writer585->definitionModule = modulename;
    reader585->definitionLine = 258;
    writer585->definitionLine = 258;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 34);
  if (objclass98 == NULL) {
    Method *reader586 = addmethodrealflags(obj98, "escaped", &reader_lexer_escaped_586, MFLAG_CONFIDENTIAL);
    Method *writer586 = addmethodrealflags(obj98, "escaped:=(1)", &writer_lexer_escaped_586, MFLAG_CONFIDENTIAL);
    reader586->definitionModule = modulename;
    writer586->definitionModule = modulename;
    reader586->definitionLine = 259;
    writer586->definitionLine = 259;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 35);
  if (objclass98 == NULL) {
    Method *reader587 = addmethodrealflags(obj98, "codepoint", &reader_lexer_codepoint_587, MFLAG_CONFIDENTIAL);
    Method *writer587 = addmethodrealflags(obj98, "codepoint:=(1)", &writer_lexer_codepoint_587, MFLAG_CONFIDENTIAL);
    reader587->definitionModule = modulename;
    writer587->definitionModule = modulename;
    reader587->definitionLine = 260;
    writer587->definitionLine = 260;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 36);
  if (objclass98 == NULL) {
    Method *reader588 = addmethodrealflags(obj98, "interpdepth", &reader_lexer_interpdepth_588, MFLAG_CONFIDENTIAL);
    Method *writer588 = addmethodrealflags(obj98, "interpdepth:=(1)", &writer_lexer_interpdepth_588, MFLAG_CONFIDENTIAL);
    reader588->definitionModule = modulename;
    writer588->definitionModule = modulename;
    reader588->definitionLine = 261;
    writer588->definitionLine = 261;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 37);
  if (objclass98 == NULL) {
    Method *reader589 = addmethodrealflags(obj98, "interpString", &reader_lexer_interpString_589, MFLAG_CONFIDENTIAL);
    Method *writer589 = addmethodrealflags(obj98, "interpString:=(1)", &writer_lexer_interpString_589, MFLAG_CONFIDENTIAL);
    reader589->definitionModule = modulename;
    writer589->definitionModule = modulename;
    reader589->definitionLine = 262;
    writer589->definitionLine = 262;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 38);
// method "advanceTo(_)"
  struct UserObject *uo590 = (struct UserObject*)obj98;
  uo590->data[39] = emptyclosure;
  Method *meth_meth_lexer_590_advanceTo_40_1_41_ = addmethod2pos(obj98, "advanceTo(1)", &meth_lexer_590_advanceTo_40_1_41_, 39);
  int argcv_meth_lexer_590_advanceTo_40_1_41_[] = {1};
  meth_meth_lexer_590_advanceTo_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_590_advanceTo_40_1_41_);
  meth_meth_lexer_590_advanceTo_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_590_advanceTo_40_1_41_->definitionLine = 264;
// method "emit(_)"
  struct UserObject *uo593 = (struct UserObject*)obj98;
  uo593->data[40] = emptyclosure;
  Method *meth_meth_lexer_593_emit_40_1_41_ = addmethod2pos(obj98, "emit(1)", &meth_lexer_593_emit_40_1_41_, 40);
  int argcv_meth_lexer_593_emit_40_1_41_[] = {1};
  meth_meth_lexer_593_emit_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_593_emit_40_1_41_);
  meth_meth_lexer_593_emit_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_593_emit_40_1_41_->definitionLine = 265;
// method "store(_)"
  struct UserObject *uo601 = (struct UserObject*)obj98;
  uo601->data[41] = emptyclosure;
  Method *meth_meth_lexer_601_store_40_1_41_ = addmethod2pos(obj98, "store(1)", &meth_lexer_601_store_40_1_41_, 41);
  int argcv_meth_lexer_601_store_40_1_41_[] = {1};
  meth_meth_lexer_601_store_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_601_store_40_1_41_);
  meth_meth_lexer_601_store_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_601_store_40_1_41_->definitionLine = 269;
  if (objclass98 == NULL) {
  Method *reader609 = addmethodrealflags(obj98, "startState",&reader_lexer_startState_609, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader609->definitionModule = modulename;
  reader609->definitionLine = 271;
  }
  adddatum2(obj98, alloc_Undefined(), 42);
  if (objclass98 == NULL) {
  Method *reader610 = addmethodrealflags(obj98, "pragmaPrefixState",&reader_lexer_pragmaPrefixState_610, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader610->definitionModule = modulename;
  reader610->definitionLine = 283;
  }
  adddatum2(obj98, alloc_Undefined(), 43);
  if (objclass98 == NULL) {
  Method *reader611 = addmethodrealflags(obj98, "pragmaBodyState",&reader_lexer_pragmaBodyState_611, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader611->definitionModule = modulename;
  reader611->definitionLine = 303;
  }
  adddatum2(obj98, alloc_Undefined(), 44);
  if (objclass98 == NULL) {
  Method *reader612 = addmethodrealflags(obj98, "pragmaTrailingWhitespaceState",&reader_lexer_pragmaTrailingWhitespaceState_612, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader612->definitionModule = modulename;
  reader612->definitionLine = 318;
  }
  adddatum2(obj98, alloc_Undefined(), 45);
  if (objclass98 == NULL) {
  Method *reader613 = addmethodrealflags(obj98, "defaultState",&reader_lexer_defaultState_613, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader613->definitionModule = modulename;
  reader613->definitionLine = 330;
  }
  adddatum2(obj98, alloc_Undefined(), 46);
  if (objclass98 == NULL) {
  Method *reader614 = addmethodrealflags(obj98, "rBraceState",&reader_lexer_rBraceState_614, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader614->definitionModule = modulename;
  reader614->definitionLine = 411;
  }
  adddatum2(obj98, alloc_Undefined(), 47);
  if (objclass98 == NULL) {
  Method *reader615 = addmethodrealflags(obj98, "slashState",&reader_lexer_slashState_615, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader615->definitionModule = modulename;
  reader615->definitionLine = 438;
  }
  adddatum2(obj98, alloc_Undefined(), 48);
  if (objclass98 == NULL) {
  Method *reader616 = addmethodrealflags(obj98, "dotState",&reader_lexer_dotState_616, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader616->definitionModule = modulename;
  reader616->definitionLine = 456;
  }
  adddatum2(obj98, alloc_Undefined(), 49);
  if (objclass98 == NULL) {
  Method *reader617 = addmethodrealflags(obj98, "identifierState",&reader_lexer_identifierState_617, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader617->definitionModule = modulename;
  reader617->definitionLine = 480;
  }
  adddatum2(obj98, alloc_Undefined(), 50);
  if (objclass98 == NULL) {
  Method *reader618 = addmethodrealflags(obj98, "quotedStringState",&reader_lexer_quotedStringState_618, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader618->definitionModule = modulename;
  reader618->definitionLine = 506;
  }
  adddatum2(obj98, alloc_Undefined(), 51);
  if (objclass98 == NULL) {
  Method *reader619 = addmethodrealflags(obj98, "unicodeState",&reader_lexer_unicodeState_619, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader619->definitionModule = modulename;
  reader619->definitionLine = 540;
  }
  adddatum2(obj98, alloc_Undefined(), 52);
  if (objclass98 == NULL) {
  Method *reader620 = addmethodrealflags(obj98, "quotedStringEscapedState",&reader_lexer_quotedStringEscapedState_620, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader620->definitionModule = modulename;
  reader620->definitionLine = 554;
  }
  adddatum2(obj98, alloc_Undefined(), 53);
  if (objclass98 == NULL) {
  Method *reader621 = addmethodrealflags(obj98, "extendedStringState",&reader_lexer_extendedStringState_621, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader621->definitionModule = modulename;
  reader621->definitionLine = 604;
  }
  adddatum2(obj98, alloc_Undefined(), 54);
  if (objclass98 == NULL) {
    Method *reader622 = addmethodrealflags(obj98, "tokenBase", &reader_lexer_tokenBase_622, MFLAG_CONFIDENTIAL);
    Method *writer622 = addmethodrealflags(obj98, "tokenBase:=(1)", &writer_lexer_tokenBase_622, 0);
    reader622->definitionModule = modulename;
    writer622->definitionModule = modulename;
    reader622->definitionLine = 617;
    writer622->definitionLine = 617;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 55);
  if (objclass98 == NULL) {
    Method *reader623 = addmethodrealflags(obj98, "mantissa", &reader_lexer_mantissa_623, MFLAG_CONFIDENTIAL);
    Method *writer623 = addmethodrealflags(obj98, "mantissa:=(1)", &writer_lexer_mantissa_623, 0);
    reader623->definitionModule = modulename;
    writer623->definitionModule = modulename;
    reader623->definitionLine = 618;
    writer623->definitionLine = 618;
  }
  obj98->flags |= OFLAG_MUTABLE;
  adddatum2(obj98, alloc_Undefined(), 56);
  if (objclass98 == NULL) {
  Method *reader624 = addmethodrealflags(obj98, "numberStartState",&reader_lexer_numberStartState_624, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader624->definitionModule = modulename;
  reader624->definitionLine = 619;
  }
  adddatum2(obj98, alloc_Undefined(), 57);
  if (objclass98 == NULL) {
  Method *reader625 = addmethodrealflags(obj98, "numberBaseState",&reader_lexer_numberBaseState_625, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader625->definitionModule = modulename;
  reader625->definitionLine = 649;
  }
  adddatum2(obj98, alloc_Undefined(), 58);
  if (objclass98 == NULL) {
  Method *reader626 = addmethodrealflags(obj98, "numberDotState",&reader_lexer_numberDotState_626, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader626->definitionModule = modulename;
  reader626->definitionLine = 665;
  }
  adddatum2(obj98, alloc_Undefined(), 59);
  if (objclass98 == NULL) {
  Method *reader627 = addmethodrealflags(obj98, "numberFractionState",&reader_lexer_numberFractionState_627, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader627->definitionModule = modulename;
  reader627->definitionLine = 684;
  }
  adddatum2(obj98, alloc_Undefined(), 60);
  if (objclass98 == NULL) {
  Method *reader628 = addmethodrealflags(obj98, "numberExponentSignState",&reader_lexer_numberExponentSignState_628, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader628->definitionModule = modulename;
  reader628->definitionLine = 703;
  }
  adddatum2(obj98, alloc_Undefined(), 61);
  if (objclass98 == NULL) {
  Method *reader629 = addmethodrealflags(obj98, "numberExponentState",&reader_lexer_numberExponentState_629, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader629->definitionModule = modulename;
  reader629->definitionLine = 718;
  }
  adddatum2(obj98, alloc_Undefined(), 62);
  if (objclass98 == NULL) {
  Method *reader630 = addmethodrealflags(obj98, "operatorState",&reader_lexer_operatorState_630, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader630->definitionModule = modulename;
  reader630->definitionLine = 751;
  }
  adddatum2(obj98, alloc_Undefined(), 63);
  if (objclass98 == NULL) {
  Method *reader631 = addmethodrealflags(obj98, "indentationState",&reader_lexer_indentationState_631, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader631->definitionModule = modulename;
  reader631->definitionLine = 772;
  }
  adddatum2(obj98, alloc_Undefined(), 64);
  if (objclass98 == NULL) {
  Method *reader632 = addmethodrealflags(obj98, "commentSpaceState",&reader_lexer_commentSpaceState_632, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader632->definitionModule = modulename;
  reader632->definitionLine = 782;
  }
  adddatum2(obj98, alloc_Undefined(), 65);
  if (objclass98 == NULL) {
  Method *reader633 = addmethodrealflags(obj98, "commentState",&reader_lexer_commentState_633, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader633->definitionModule = modulename;
  reader633->definitionLine = 791;
  }
  adddatum2(obj98, alloc_Undefined(), 66);
// method "newLineError"
  block_savedest(obj98);
  Object closure634 = createclosure(2, "newLineError");
  setclosureframe(closure634, stackframe);
  addtoclosure(closure634, var_util);
  addtoclosure(closure634, var_errormessages);
  struct UserObject *uo634 = (struct UserObject*)obj98;
  uo634->data[67] = (Object)closure634;
  Method *meth_meth_lexer_634_newLineError = addmethod2pos(obj98, "newLineError", &meth_lexer_634_newLineError, 67);
  int argcv_meth_lexer_634_newLineError[] = {0};
  meth_meth_lexer_634_newLineError->type = alloc_MethodType(1, argcv_meth_lexer_634_newLineError);
  meth_meth_lexer_634_newLineError->definitionModule = modulename;
  meth_meth_lexer_634_newLineError->definitionLine = 803;
// method "isSpaceChar(_)"
  block_savedest(obj98);
  Object closure958 = createclosure(1, "isSpaceChar(1)");
  setclosureframe(closure958, stackframe);
  addtoclosure(closure958, var_spaceChars);
  struct UserObject *uo958 = (struct UserObject*)obj98;
  uo958->data[68] = (Object)closure958;
  Method *meth_meth_lexer_958_isSpaceChar_40_1_41_ = addmethod2pos(obj98, "isSpaceChar(1)", &meth_lexer_958_isSpaceChar_40_1_41_, 68);
  int argcv_meth_lexer_958_isSpaceChar_40_1_41_[] = {1};
  meth_meth_lexer_958_isSpaceChar_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_958_isSpaceChar_40_1_41_);
  meth_meth_lexer_958_isSpaceChar_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_958_isSpaceChar_40_1_41_->definitionLine = 877;
// method "checkSeparatorString(_)"
  block_savedest(obj98);
  Object closure961 = createclosure(2, "checkSeparatorString(1)");
  setclosureframe(closure961, stackframe);
  addtoclosure(closure961, var_errormessages);
  addtoclosure(closure961, var_unicode);
  struct UserObject *uo961 = (struct UserObject*)obj98;
  uo961->data[69] = (Object)closure961;
  Method *meth_meth_lexer_961_checkSeparatorString_40_1_41_ = addmethod2pos(obj98, "checkSeparatorString(1)", &meth_lexer_961_checkSeparatorString_40_1_41_, 69);
  int argcv_meth_lexer_961_checkSeparatorString_40_1_41_[] = {1};
  meth_meth_lexer_961_checkSeparatorString_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_961_checkSeparatorString_40_1_41_);
  meth_meth_lexer_961_checkSeparatorString_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_961_checkSeparatorString_40_1_41_->definitionLine = 880;
// method "checkSeparator(_)"
  block_savedest(obj98);
  Object closure1269 = createclosure(2, "checkSeparator(1)");
  setclosureframe(closure1269, stackframe);
  addtoclosure(closure1269, var_errormessages);
  addtoclosure(closure1269, var_unicode);
  struct UserObject *uo1269 = (struct UserObject*)obj98;
  uo1269->data[70] = (Object)closure1269;
  Method *meth_meth_lexer_1269_checkSeparator_40_1_41_ = addmethod2pos(obj98, "checkSeparator(1)", &meth_lexer_1269_checkSeparator_40_1_41_, 70);
  int argcv_meth_lexer_1269_checkSeparator_40_1_41_[] = {1};
  meth_meth_lexer_1269_checkSeparator_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_1269_checkSeparator_40_1_41_);
  meth_meth_lexer_1269_checkSeparator_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_1269_checkSeparator_40_1_41_->definitionLine = 938;
// method "fromBase(_,_)"
  block_savedest(obj98);
  Object closure1385 = createclosure(2, "fromBase(2)");
  setclosureframe(closure1385, stackframe);
  addtoclosure(closure1385, var_errormessages);
  addtoclosure(closure1385, var_unicode);
  struct UserObject *uo1385 = (struct UserObject*)obj98;
  uo1385->data[71] = (Object)closure1385;
  Method *meth_meth_lexer_1385_fromBase_40_2_41_ = addmethod2pos(obj98, "fromBase(2)", &meth_lexer_1385_fromBase_40_2_41_, 71);
  int argcv_meth_lexer_1385_fromBase_40_2_41_[] = {2};
  meth_meth_lexer_1385_fromBase_40_2_41_->type = alloc_MethodType(1, argcv_meth_lexer_1385_fromBase_40_2_41_);
  meth_meth_lexer_1385_fromBase_40_2_41_->definitionModule = modulename;
  meth_meth_lexer_1385_fromBase_40_2_41_->definitionLine = 965;
// method "hexdecchar(_)"
  block_savedest(obj98);
  Object closure1625 = createclosure(1, "hexdecchar(1)");
  setclosureframe(closure1625, stackframe);
  addtoclosure(closure1625, var_errormessages);
  struct UserObject *uo1625 = (struct UserObject*)obj98;
  uo1625->data[72] = (Object)closure1625;
  Method *meth_meth_lexer_1625_hexdecchar_40_1_41_ = addmethod2pos(obj98, "hexdecchar(1)", &meth_lexer_1625_hexdecchar_40_1_41_, 72);
  int argcv_meth_lexer_1625_hexdecchar_40_1_41_[] = {1};
  meth_meth_lexer_1625_hexdecchar_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_1625_hexdecchar_40_1_41_);
  meth_meth_lexer_1625_hexdecchar_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_1625_hexdecchar_40_1_41_->definitionLine = 1007;
// method "lexfile(_)"
  block_savedest(obj98);
  Object closure1709 = createclosure(1, "lexfile(1)");
  setclosureframe(closure1709, stackframe);
  addtoclosure(closure1709, var_util);
  struct UserObject *uo1709 = (struct UserObject*)obj98;
  uo1709->data[73] = (Object)closure1709;
  Method *meth_meth_lexer_1709_lexfile_40_1_41_ = addmethod2pos(obj98, "lexfile(1)", &meth_lexer_1709_lexfile_40_1_41_, 73);
  int argcv_meth_lexer_1709_lexfile_40_1_41_[] = {1};
  meth_meth_lexer_1709_lexfile_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_1709_lexfile_40_1_41_);
  meth_meth_lexer_1709_lexfile_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_1709_lexfile_40_1_41_->definitionLine = 1026;
// method "lexinput(_)"
  block_savedest(obj98);
  Object closure1827 = createclosure(2, "lexinput(1)");
  setclosureframe(closure1827, stackframe);
  addtoclosure(closure1827, var_errormessages);
  addtoclosure(closure1827, var_util);
  struct UserObject *uo1827 = (struct UserObject*)obj98;
  uo1827->data[74] = (Object)closure1827;
  Method *meth_meth_lexer_1827_lexinput_40_1_41_ = addmethod2pos(obj98, "lexinput(1)", &meth_lexer_1827_lexinput_40_1_41_, 74);
  int argcv_meth_lexer_1827_lexinput_40_1_41_[] = {1};
  meth_meth_lexer_1827_lexinput_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_1827_lexinput_40_1_41_);
  meth_meth_lexer_1827_lexinput_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_1827_lexinput_40_1_41_->definitionLine = 1081;
  sourceObject = obj98;
  adddatum2(obj98, undefined, 1);
  sourceObject = obj98;
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2266 = alloc_Float64(1);
// compiled num node returning num2266 (depth = 2)
  adddatum2(obj98, num2266, 2);
  sourceObject = obj98;
// Begin line 86
  setline(86);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2267 = alloc_Float64(0);
// compiled num node returning num2267 (depth = 2)
  adddatum2(obj98, num2267, 3);
  sourceObject = obj98;
// Begin line 87
  setline(87);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2268 = alloc_Float64(1);
// compiled num node returning num2268 (depth = 2)
  adddatum2(obj98, num2268, 4);
  sourceObject = obj98;
// Begin line 88
  setline(88);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2269 = alloc_Float64(0);
// compiled num node returning num2269 (depth = 2)
  adddatum2(obj98, num2269, 5);
  sourceObject = obj98;
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2270 = alloc_Float64(1);
// compiled num node returning num2270 (depth = 2)
  adddatum2(obj98, num2270, 6);
  sourceObject = obj98;
  adddatum2(obj98, undefined, 7);
  sourceObject = obj98;
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2271 = alloc_Float64(0);
// compiled num node returning num2271 (depth = 2)
  adddatum2(obj98, num2271, 8);
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  adddatum2(obj98, undefined, 32);
  sourceObject = obj98;
// Begin line 256
  setline(256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit2272 == NULL) {
    strlit2272 = alloc_String("");
    gc_root(strlit2272);
  }
// compiled string node returning strlit2272 (depth = 2)
  adddatum2(obj98, strlit2272, 33);
  sourceObject = obj98;
// Begin line 258
  setline(258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool2273 = alloc_Boolean(0);
// compiled identifier node returning bool2273 (depth = 2)
  adddatum2(obj98, bool2273, 34);
  sourceObject = obj98;
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool2274 = alloc_Boolean(0);
// compiled identifier node returning bool2274 (depth = 2)
  adddatum2(obj98, bool2274, 35);
  sourceObject = obj98;
// Begin line 260
  setline(260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2275 = alloc_Float64(0);
// compiled num node returning num2275 (depth = 2)
  adddatum2(obj98, num2275, 36);
  sourceObject = obj98;
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2276 = alloc_Float64(0);
// compiled num node returning num2276 (depth = 2)
  adddatum2(obj98, num2276, 37);
  sourceObject = obj98;
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool2277 = alloc_Boolean(0);
// compiled identifier node returning bool2277 (depth = 2)
  adddatum2(obj98, bool2277, 38);
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  Object inheritingObject2278 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2278 = alloc_userobj2(1,2, objclass2278);
  gc_frame_newslot(obj2278);
  if (objclass2278 == NULL) {
    glfree(obj2278->class->name);
    obj2278->class->name = "startState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2278, obj98, 0);
  addmethodreal(obj2278,"outer", &reader_lexer_outer_2279);
  Object oldself2278 = self;
  struct StackFrameObject *oldstackframe2278 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2278);
  gc_frame_newslot((Object)stackframe);
  self = obj2278;
  Object *oldselfslot2278 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2278 = (*(struct UserObject *)self).data[0], lowerouter2278 = thisouter2278;
  if (inheritingObject2278) {
    struct UserObject *inho2278 = (struct UserObject *)inheritingObject2278;
    while (inho2278->super != GraceDefaultObject) inho2278 = (struct UserObject *)inho2278->super;
    inho2278->super = obj2278;
    self = inheritingObject2278;
    *selfslot = self;
    lowerouter2278 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2278;
  }
// method "consume(_)"
  struct UserObject *uo2280 = (struct UserObject*)obj2278;
  uo2280->data[1] = emptyclosure;
  Method *meth_meth_lexer_2280_consume_40_1_41_ = addmethod2pos(obj2278, "consume(1)", &meth_lexer_2280_consume_40_1_41_, 1);
  int argcv_meth_lexer_2280_consume_40_1_41_[] = {1};
  meth_meth_lexer_2280_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_2280_consume_40_1_41_);
  meth_meth_lexer_2280_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_2280_consume_40_1_41_->definitionLine = 272;
  sourceObject = obj2278;
  objclass2278 = obj2278->class;
  objclass2278->definitionModule = modulename;
  objclass2278->definitionLine = 271;
  (*(struct UserObject *)self).data[0] = lowerouter2278;
  self = oldself2278;
  selfslot = oldselfslot2278;
  stackframe = oldstackframe2278;
  adddatum2(obj98, obj2278, 42);
  sourceObject = obj98;
// Begin line 281
  setline(281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2308 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe2309 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2310 = callmethodflags(self, "startState", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2309);
// compiled member node returning call2310 (depth = 3)
  gc_frame_newslot(call2310);
// call case 4: self request
  params[0] = call2310;
  partcv[0] = 1;
  Object call2311 = callmethodflags(self, "state:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2308);
// compiled call node returning call2311 (depth = 2)
  sourceObject = obj98;
  Object inheritingObject2312 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2312 = alloc_userobj2(1,2, objclass2312);
  gc_frame_newslot(obj2312);
  if (objclass2312 == NULL) {
    glfree(obj2312->class->name);
    obj2312->class->name = "pragmaPrefixState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2312, obj98, 0);
  addmethodreal(obj2312,"outer", &reader_lexer_outer_2313);
  Object oldself2312 = self;
  struct StackFrameObject *oldstackframe2312 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2312);
  gc_frame_newslot((Object)stackframe);
  self = obj2312;
  Object *oldselfslot2312 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2312 = (*(struct UserObject *)self).data[0], lowerouter2312 = thisouter2312;
  if (inheritingObject2312) {
    struct UserObject *inho2312 = (struct UserObject *)inheritingObject2312;
    while (inho2312->super != GraceDefaultObject) inho2312 = (struct UserObject *)inho2312->super;
    inho2312->super = obj2312;
    self = inheritingObject2312;
    *selfslot = self;
    lowerouter2312 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2312;
  }
// method "consume(_)"
  block_savedest(obj2312);
  Object closure2314 = createclosure(1, "consume(1)");
  setclosureframe(closure2314, stackframe);
  addtoclosure(closure2314, var_errormessages);
  struct UserObject *uo2314 = (struct UserObject*)obj2312;
  uo2314->data[1] = (Object)closure2314;
  Method *meth_meth_lexer_2314_consume_40_1_41_ = addmethod2pos(obj2312, "consume(1)", &meth_lexer_2314_consume_40_1_41_, 1);
  int argcv_meth_lexer_2314_consume_40_1_41_[] = {1};
  meth_meth_lexer_2314_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_2314_consume_40_1_41_);
  meth_meth_lexer_2314_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_2314_consume_40_1_41_->definitionLine = 284;
  sourceObject = obj2312;
  objclass2312 = obj2312->class;
  objclass2312->definitionModule = modulename;
  objclass2312->definitionLine = 283;
  (*(struct UserObject *)self).data[0] = lowerouter2312;
  self = oldself2312;
  selfslot = oldselfslot2312;
  stackframe = oldstackframe2312;
  adddatum2(obj98, obj2312, 43);
  sourceObject = obj98;
  Object inheritingObject2385 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2385 = alloc_userobj2(1,2, objclass2385);
  gc_frame_newslot(obj2385);
  if (objclass2385 == NULL) {
    glfree(obj2385->class->name);
    obj2385->class->name = "pragmaBodyState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2385, obj98, 0);
  addmethodreal(obj2385,"outer", &reader_lexer_outer_2386);
  Object oldself2385 = self;
  struct StackFrameObject *oldstackframe2385 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2385);
  gc_frame_newslot((Object)stackframe);
  self = obj2385;
  Object *oldselfslot2385 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2385 = (*(struct UserObject *)self).data[0], lowerouter2385 = thisouter2385;
  if (inheritingObject2385) {
    struct UserObject *inho2385 = (struct UserObject *)inheritingObject2385;
    while (inho2385->super != GraceDefaultObject) inho2385 = (struct UserObject *)inho2385->super;
    inho2385->super = obj2385;
    self = inheritingObject2385;
    *selfslot = self;
    lowerouter2385 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2385;
  }
// method "consume(_)"
  block_savedest(obj2385);
  Object closure2387 = createclosure(1, "consume(1)");
  setclosureframe(closure2387, stackframe);
  addtoclosure(closure2387, var_util);
  struct UserObject *uo2387 = (struct UserObject*)obj2385;
  uo2387->data[1] = (Object)closure2387;
  Method *meth_meth_lexer_2387_consume_40_1_41_ = addmethod2pos(obj2385, "consume(1)", &meth_lexer_2387_consume_40_1_41_, 1);
  int argcv_meth_lexer_2387_consume_40_1_41_[] = {1};
  meth_meth_lexer_2387_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_2387_consume_40_1_41_);
  meth_meth_lexer_2387_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_2387_consume_40_1_41_->definitionLine = 304;
  sourceObject = obj2385;
  objclass2385 = obj2385->class;
  objclass2385->definitionModule = modulename;
  objclass2385->definitionLine = 303;
  (*(struct UserObject *)self).data[0] = lowerouter2385;
  self = oldself2385;
  selfslot = oldselfslot2385;
  stackframe = oldstackframe2385;
  adddatum2(obj98, obj2385, 44);
  sourceObject = obj98;
  Object inheritingObject2433 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2433 = alloc_userobj2(1,2, objclass2433);
  gc_frame_newslot(obj2433);
  if (objclass2433 == NULL) {
    glfree(obj2433->class->name);
    obj2433->class->name = "pragmaTrailingWhitespaceState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2433, obj98, 0);
  addmethodreal(obj2433,"outer", &reader_lexer_outer_2434);
  Object oldself2433 = self;
  struct StackFrameObject *oldstackframe2433 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2433);
  gc_frame_newslot((Object)stackframe);
  self = obj2433;
  Object *oldselfslot2433 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2433 = (*(struct UserObject *)self).data[0], lowerouter2433 = thisouter2433;
  if (inheritingObject2433) {
    struct UserObject *inho2433 = (struct UserObject *)inheritingObject2433;
    while (inho2433->super != GraceDefaultObject) inho2433 = (struct UserObject *)inho2433->super;
    inho2433->super = obj2433;
    self = inheritingObject2433;
    *selfslot = self;
    lowerouter2433 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2433;
  }
// method "consume(_)"
  block_savedest(obj2433);
  Object closure2435 = createclosure(1, "consume(1)");
  setclosureframe(closure2435, stackframe);
  addtoclosure(closure2435, var_errormessages);
  struct UserObject *uo2435 = (struct UserObject*)obj2433;
  uo2435->data[1] = (Object)closure2435;
  Method *meth_meth_lexer_2435_consume_40_1_41_ = addmethod2pos(obj2433, "consume(1)", &meth_lexer_2435_consume_40_1_41_, 1);
  int argcv_meth_lexer_2435_consume_40_1_41_[] = {1};
  meth_meth_lexer_2435_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_2435_consume_40_1_41_);
  meth_meth_lexer_2435_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_2435_consume_40_1_41_->definitionLine = 319;
  sourceObject = obj2433;
  objclass2433 = obj2433->class;
  objclass2433->definitionModule = modulename;
  objclass2433->definitionLine = 318;
  (*(struct UserObject *)self).data[0] = lowerouter2433;
  self = oldself2433;
  selfslot = oldselfslot2433;
  stackframe = oldstackframe2433;
  adddatum2(obj98, obj2433, 45);
  sourceObject = obj98;
  Object inheritingObject2475 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2475 = alloc_userobj2(1,2, objclass2475);
  gc_frame_newslot(obj2475);
  if (objclass2475 == NULL) {
    glfree(obj2475->class->name);
    obj2475->class->name = "defaultState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2475, obj98, 0);
  addmethodreal(obj2475,"outer", &reader_lexer_outer_2476);
  Object oldself2475 = self;
  struct StackFrameObject *oldstackframe2475 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2475);
  gc_frame_newslot((Object)stackframe);
  self = obj2475;
  Object *oldselfslot2475 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2475 = (*(struct UserObject *)self).data[0], lowerouter2475 = thisouter2475;
  if (inheritingObject2475) {
    struct UserObject *inho2475 = (struct UserObject *)inheritingObject2475;
    while (inho2475->super != GraceDefaultObject) inho2475 = (struct UserObject *)inho2475->super;
    inho2475->super = obj2475;
    self = inheritingObject2475;
    *selfslot = self;
    lowerouter2475 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2475;
  }
// method "consume(_)"
  block_savedest(obj2475);
  Object closure2477 = createclosure(3, "consume(1)");
  setclosureframe(closure2477, stackframe);
  addtoclosure(closure2477, var_spaceChars);
  addtoclosure(closure2477, var_errormessages);
  addtoclosure(closure2477, var_unicode);
  struct UserObject *uo2477 = (struct UserObject*)obj2475;
  uo2477->data[1] = (Object)closure2477;
  Method *meth_meth_lexer_2477_consume_40_1_41_ = addmethod2pos(obj2475, "consume(1)", &meth_lexer_2477_consume_40_1_41_, 1);
  int argcv_meth_lexer_2477_consume_40_1_41_[] = {1};
  meth_meth_lexer_2477_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_2477_consume_40_1_41_);
  meth_meth_lexer_2477_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_2477_consume_40_1_41_->definitionLine = 331;
  sourceObject = obj2475;
  objclass2475 = obj2475->class;
  objclass2475->definitionModule = modulename;
  objclass2475->definitionLine = 330;
  (*(struct UserObject *)self).data[0] = lowerouter2475;
  self = oldself2475;
  selfslot = oldselfslot2475;
  stackframe = oldstackframe2475;
  adddatum2(obj98, obj2475, 46);
  sourceObject = obj98;
  Object inheritingObject3025 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3025 = alloc_userobj2(1,2, objclass3025);
  gc_frame_newslot(obj3025);
  if (objclass3025 == NULL) {
    glfree(obj3025->class->name);
    obj3025->class->name = "rBraceState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3025, obj98, 0);
  addmethodreal(obj3025,"outer", &reader_lexer_outer_3026);
  Object oldself3025 = self;
  struct StackFrameObject *oldstackframe3025 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3025);
  gc_frame_newslot((Object)stackframe);
  self = obj3025;
  Object *oldselfslot3025 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3025 = (*(struct UserObject *)self).data[0], lowerouter3025 = thisouter3025;
  if (inheritingObject3025) {
    struct UserObject *inho3025 = (struct UserObject *)inheritingObject3025;
    while (inho3025->super != GraceDefaultObject) inho3025 = (struct UserObject *)inho3025->super;
    inho3025->super = obj3025;
    self = inheritingObject3025;
    *selfslot = self;
    lowerouter3025 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3025;
  }
// method "consume(_)"
  block_savedest(obj3025);
  Object closure3027 = createclosure(1, "consume(1)");
  setclosureframe(closure3027, stackframe);
  addtoclosure(closure3027, var_errormessages);
  struct UserObject *uo3027 = (struct UserObject*)obj3025;
  uo3027->data[1] = (Object)closure3027;
  Method *meth_meth_lexer_3027_consume_40_1_41_ = addmethod2pos(obj3025, "consume(1)", &meth_lexer_3027_consume_40_1_41_, 1);
  int argcv_meth_lexer_3027_consume_40_1_41_[] = {1};
  meth_meth_lexer_3027_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_3027_consume_40_1_41_);
  meth_meth_lexer_3027_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_3027_consume_40_1_41_->definitionLine = 412;
  sourceObject = obj3025;
  objclass3025 = obj3025->class;
  objclass3025->definitionModule = modulename;
  objclass3025->definitionLine = 411;
  (*(struct UserObject *)self).data[0] = lowerouter3025;
  self = oldself3025;
  selfslot = oldselfslot3025;
  stackframe = oldstackframe3025;
  adddatum2(obj98, obj3025, 47);
  sourceObject = obj98;
  Object inheritingObject3173 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3173 = alloc_userobj2(1,2, objclass3173);
  gc_frame_newslot(obj3173);
  if (objclass3173 == NULL) {
    glfree(obj3173->class->name);
    obj3173->class->name = "slashState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3173, obj98, 0);
  addmethodreal(obj3173,"outer", &reader_lexer_outer_3174);
  Object oldself3173 = self;
  struct StackFrameObject *oldstackframe3173 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3173);
  gc_frame_newslot((Object)stackframe);
  self = obj3173;
  Object *oldselfslot3173 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3173 = (*(struct UserObject *)self).data[0], lowerouter3173 = thisouter3173;
  if (inheritingObject3173) {
    struct UserObject *inho3173 = (struct UserObject *)inheritingObject3173;
    while (inho3173->super != GraceDefaultObject) inho3173 = (struct UserObject *)inho3173->super;
    inho3173->super = obj3173;
    self = inheritingObject3173;
    *selfslot = self;
    lowerouter3173 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3173;
  }
// method "consume(_)"
  struct UserObject *uo3175 = (struct UserObject*)obj3173;
  uo3175->data[1] = emptyclosure;
  Method *meth_meth_lexer_3175_consume_40_1_41_ = addmethod2pos(obj3173, "consume(1)", &meth_lexer_3175_consume_40_1_41_, 1);
  int argcv_meth_lexer_3175_consume_40_1_41_[] = {1};
  meth_meth_lexer_3175_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_3175_consume_40_1_41_);
  meth_meth_lexer_3175_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_3175_consume_40_1_41_->definitionLine = 439;
  sourceObject = obj3173;
  objclass3173 = obj3173->class;
  objclass3173->definitionModule = modulename;
  objclass3173->definitionLine = 438;
  (*(struct UserObject *)self).data[0] = lowerouter3173;
  self = oldself3173;
  selfslot = oldselfslot3173;
  stackframe = oldstackframe3173;
  adddatum2(obj98, obj3173, 48);
  sourceObject = obj98;
  Object inheritingObject3243 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3243 = alloc_userobj2(1,2, objclass3243);
  gc_frame_newslot(obj3243);
  if (objclass3243 == NULL) {
    glfree(obj3243->class->name);
    obj3243->class->name = "dotState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3243, obj98, 0);
  addmethodreal(obj3243,"outer", &reader_lexer_outer_3244);
  Object oldself3243 = self;
  struct StackFrameObject *oldstackframe3243 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3243);
  gc_frame_newslot((Object)stackframe);
  self = obj3243;
  Object *oldselfslot3243 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3243 = (*(struct UserObject *)self).data[0], lowerouter3243 = thisouter3243;
  if (inheritingObject3243) {
    struct UserObject *inho3243 = (struct UserObject *)inheritingObject3243;
    while (inho3243->super != GraceDefaultObject) inho3243 = (struct UserObject *)inho3243->super;
    inho3243->super = obj3243;
    self = inheritingObject3243;
    *selfslot = self;
    lowerouter3243 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3243;
  }
// method "consume(_)"
  struct UserObject *uo3245 = (struct UserObject*)obj3243;
  uo3245->data[1] = emptyclosure;
  Method *meth_meth_lexer_3245_consume_40_1_41_ = addmethod2pos(obj3243, "consume(1)", &meth_lexer_3245_consume_40_1_41_, 1);
  int argcv_meth_lexer_3245_consume_40_1_41_[] = {1};
  meth_meth_lexer_3245_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_3245_consume_40_1_41_);
  meth_meth_lexer_3245_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_3245_consume_40_1_41_->definitionLine = 457;
  sourceObject = obj3243;
  objclass3243 = obj3243->class;
  objclass3243->definitionModule = modulename;
  objclass3243->definitionLine = 456;
  (*(struct UserObject *)self).data[0] = lowerouter3243;
  self = oldself3243;
  selfslot = oldselfslot3243;
  stackframe = oldstackframe3243;
  adddatum2(obj98, obj3243, 49);
  sourceObject = obj98;
  Object inheritingObject3343 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3343 = alloc_userobj2(1,2, objclass3343);
  gc_frame_newslot(obj3343);
  if (objclass3343 == NULL) {
    glfree(obj3343->class->name);
    obj3343->class->name = "identifierState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3343, obj98, 0);
  addmethodreal(obj3343,"outer", &reader_lexer_outer_3344);
  Object oldself3343 = self;
  struct StackFrameObject *oldstackframe3343 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3343);
  gc_frame_newslot((Object)stackframe);
  self = obj3343;
  Object *oldselfslot3343 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3343 = (*(struct UserObject *)self).data[0], lowerouter3343 = thisouter3343;
  if (inheritingObject3343) {
    struct UserObject *inho3343 = (struct UserObject *)inheritingObject3343;
    while (inho3343->super != GraceDefaultObject) inho3343 = (struct UserObject *)inho3343->super;
    inho3343->super = obj3343;
    self = inheritingObject3343;
    *selfslot = self;
    lowerouter3343 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3343;
  }
// method "consume(_)"
  block_savedest(obj3343);
  Object closure3345 = createclosure(2, "consume(1)");
  setclosureframe(closure3345, stackframe);
  addtoclosure(closure3345, var_keywords);
  addtoclosure(closure3345, var_errormessages);
  struct UserObject *uo3345 = (struct UserObject*)obj3343;
  uo3345->data[1] = (Object)closure3345;
  Method *meth_meth_lexer_3345_consume_40_1_41_ = addmethod2pos(obj3343, "consume(1)", &meth_lexer_3345_consume_40_1_41_, 1);
  int argcv_meth_lexer_3345_consume_40_1_41_[] = {1};
  meth_meth_lexer_3345_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_3345_consume_40_1_41_);
  meth_meth_lexer_3345_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_3345_consume_40_1_41_->definitionLine = 481;
  sourceObject = obj3343;
  objclass3343 = obj3343->class;
  objclass3343->definitionModule = modulename;
  objclass3343->definitionLine = 480;
  (*(struct UserObject *)self).data[0] = lowerouter3343;
  self = oldself3343;
  selfslot = oldselfslot3343;
  stackframe = oldstackframe3343;
  adddatum2(obj98, obj3343, 50);
  sourceObject = obj98;
  Object inheritingObject3464 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3464 = alloc_userobj2(1,2, objclass3464);
  gc_frame_newslot(obj3464);
  if (objclass3464 == NULL) {
    glfree(obj3464->class->name);
    obj3464->class->name = "quotedStringState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3464, obj98, 0);
  addmethodreal(obj3464,"outer", &reader_lexer_outer_3465);
  Object oldself3464 = self;
  struct StackFrameObject *oldstackframe3464 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3464);
  gc_frame_newslot((Object)stackframe);
  self = obj3464;
  Object *oldselfslot3464 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3464 = (*(struct UserObject *)self).data[0], lowerouter3464 = thisouter3464;
  if (inheritingObject3464) {
    struct UserObject *inho3464 = (struct UserObject *)inheritingObject3464;
    while (inho3464->super != GraceDefaultObject) inho3464 = (struct UserObject *)inho3464->super;
    inho3464->super = obj3464;
    self = inheritingObject3464;
    *selfslot = self;
    lowerouter3464 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3464;
  }
// method "consume(_)"
  struct UserObject *uo3466 = (struct UserObject*)obj3464;
  uo3466->data[1] = emptyclosure;
  Method *meth_meth_lexer_3466_consume_40_1_41_ = addmethod2pos(obj3464, "consume(1)", &meth_lexer_3466_consume_40_1_41_, 1);
  int argcv_meth_lexer_3466_consume_40_1_41_[] = {1};
  meth_meth_lexer_3466_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_3466_consume_40_1_41_);
  meth_meth_lexer_3466_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_3466_consume_40_1_41_->definitionLine = 507;
  sourceObject = obj3464;
  objclass3464 = obj3464->class;
  objclass3464->definitionModule = modulename;
  objclass3464->definitionLine = 506;
  (*(struct UserObject *)self).data[0] = lowerouter3464;
  self = oldself3464;
  selfslot = oldselfslot3464;
  stackframe = oldstackframe3464;
  adddatum2(obj98, obj3464, 51);
  sourceObject = obj98;
  Object inheritingObject3643 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3643 = alloc_userobj2(1,2, objclass3643);
  gc_frame_newslot(obj3643);
  if (objclass3643 == NULL) {
    glfree(obj3643->class->name);
    obj3643->class->name = "unicodeState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3643, obj98, 0);
  addmethodreal(obj3643,"outer", &reader_lexer_outer_3644);
  Object oldself3643 = self;
  struct StackFrameObject *oldstackframe3643 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3643);
  gc_frame_newslot((Object)stackframe);
  self = obj3643;
  Object *oldselfslot3643 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3643 = (*(struct UserObject *)self).data[0], lowerouter3643 = thisouter3643;
  if (inheritingObject3643) {
    struct UserObject *inho3643 = (struct UserObject *)inheritingObject3643;
    while (inho3643->super != GraceDefaultObject) inho3643 = (struct UserObject *)inho3643->super;
    inho3643->super = obj3643;
    self = inheritingObject3643;
    *selfslot = self;
    lowerouter3643 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3643;
  }
// method "consume(_)"
  block_savedest(obj3643);
  Object closure3645 = createclosure(1, "consume(1)");
  setclosureframe(closure3645, stackframe);
  addtoclosure(closure3645, var_unicode);
  struct UserObject *uo3645 = (struct UserObject*)obj3643;
  uo3645->data[1] = (Object)closure3645;
  Method *meth_meth_lexer_3645_consume_40_1_41_ = addmethod2pos(obj3643, "consume(1)", &meth_lexer_3645_consume_40_1_41_, 1);
  int argcv_meth_lexer_3645_consume_40_1_41_[] = {1};
  meth_meth_lexer_3645_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_3645_consume_40_1_41_);
  meth_meth_lexer_3645_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_3645_consume_40_1_41_->definitionLine = 541;
  sourceObject = obj3643;
  objclass3643 = obj3643->class;
  objclass3643->definitionModule = modulename;
  objclass3643->definitionLine = 540;
  (*(struct UserObject *)self).data[0] = lowerouter3643;
  self = oldself3643;
  selfslot = oldselfslot3643;
  stackframe = oldstackframe3643;
  adddatum2(obj98, obj3643, 52);
  sourceObject = obj98;
  Object inheritingObject3712 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3712 = alloc_userobj2(1,2, objclass3712);
  gc_frame_newslot(obj3712);
  if (objclass3712 == NULL) {
    glfree(obj3712->class->name);
    obj3712->class->name = "quotedStringEscapedState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3712, obj98, 0);
  addmethodreal(obj3712,"outer", &reader_lexer_outer_3713);
  Object oldself3712 = self;
  struct StackFrameObject *oldstackframe3712 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3712);
  gc_frame_newslot((Object)stackframe);
  self = obj3712;
  Object *oldselfslot3712 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3712 = (*(struct UserObject *)self).data[0], lowerouter3712 = thisouter3712;
  if (inheritingObject3712) {
    struct UserObject *inho3712 = (struct UserObject *)inheritingObject3712;
    while (inho3712->super != GraceDefaultObject) inho3712 = (struct UserObject *)inho3712->super;
    inho3712->super = obj3712;
    self = inheritingObject3712;
    *selfslot = self;
    lowerouter3712 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3712;
  }
// method "consume(_)"
  struct UserObject *uo3714 = (struct UserObject*)obj3712;
  uo3714->data[1] = emptyclosure;
  Method *meth_meth_lexer_3714_consume_40_1_41_ = addmethod2pos(obj3712, "consume(1)", &meth_lexer_3714_consume_40_1_41_, 1);
  int argcv_meth_lexer_3714_consume_40_1_41_[] = {1};
  meth_meth_lexer_3714_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_3714_consume_40_1_41_);
  meth_meth_lexer_3714_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_3714_consume_40_1_41_->definitionLine = 555;
  sourceObject = obj3712;
  objclass3712 = obj3712->class;
  objclass3712->definitionModule = modulename;
  objclass3712->definitionLine = 554;
  (*(struct UserObject *)self).data[0] = lowerouter3712;
  self = oldself3712;
  selfslot = oldselfslot3712;
  stackframe = oldstackframe3712;
  adddatum2(obj98, obj3712, 53);
  sourceObject = obj98;
  Object inheritingObject3922 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3922 = alloc_userobj2(1,2, objclass3922);
  gc_frame_newslot(obj3922);
  if (objclass3922 == NULL) {
    glfree(obj3922->class->name);
    obj3922->class->name = "extendedStringState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3922, obj98, 0);
  addmethodreal(obj3922,"outer", &reader_lexer_outer_3923);
  Object oldself3922 = self;
  struct StackFrameObject *oldstackframe3922 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3922);
  gc_frame_newslot((Object)stackframe);
  self = obj3922;
  Object *oldselfslot3922 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3922 = (*(struct UserObject *)self).data[0], lowerouter3922 = thisouter3922;
  if (inheritingObject3922) {
    struct UserObject *inho3922 = (struct UserObject *)inheritingObject3922;
    while (inho3922->super != GraceDefaultObject) inho3922 = (struct UserObject *)inho3922->super;
    inho3922->super = obj3922;
    self = inheritingObject3922;
    *selfslot = self;
    lowerouter3922 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3922;
  }
// method "consume(_)"
  struct UserObject *uo3924 = (struct UserObject*)obj3922;
  uo3924->data[1] = emptyclosure;
  Method *meth_meth_lexer_3924_consume_40_1_41_ = addmethod2pos(obj3922, "consume(1)", &meth_lexer_3924_consume_40_1_41_, 1);
  int argcv_meth_lexer_3924_consume_40_1_41_[] = {1};
  meth_meth_lexer_3924_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_3924_consume_40_1_41_);
  meth_meth_lexer_3924_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_3924_consume_40_1_41_->definitionLine = 605;
  sourceObject = obj3922;
  objclass3922 = obj3922->class;
  objclass3922->definitionModule = modulename;
  objclass3922->definitionLine = 604;
  (*(struct UserObject *)self).data[0] = lowerouter3922;
  self = oldself3922;
  selfslot = oldselfslot3922;
  stackframe = oldstackframe3922;
  adddatum2(obj98, obj3922, 54);
  sourceObject = obj98;
  adddatum2(obj98, undefined, 55);
  sourceObject = obj98;
  adddatum2(obj98, undefined, 56);
  sourceObject = obj98;
  Object inheritingObject3959 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3959 = alloc_userobj2(1,2, objclass3959);
  gc_frame_newslot(obj3959);
  if (objclass3959 == NULL) {
    glfree(obj3959->class->name);
    obj3959->class->name = "numberStartState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3959, obj98, 0);
  addmethodreal(obj3959,"outer", &reader_lexer_outer_3960);
  Object oldself3959 = self;
  struct StackFrameObject *oldstackframe3959 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3959);
  gc_frame_newslot((Object)stackframe);
  self = obj3959;
  Object *oldselfslot3959 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3959 = (*(struct UserObject *)self).data[0], lowerouter3959 = thisouter3959;
  if (inheritingObject3959) {
    struct UserObject *inho3959 = (struct UserObject *)inheritingObject3959;
    while (inho3959->super != GraceDefaultObject) inho3959 = (struct UserObject *)inho3959->super;
    inho3959->super = obj3959;
    self = inheritingObject3959;
    *selfslot = self;
    lowerouter3959 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3959;
  }
// method "consume(_)"
  block_savedest(obj3959);
  Object closure3961 = createclosure(1, "consume(1)");
  setclosureframe(closure3961, stackframe);
  addtoclosure(closure3961, var_errormessages);
  struct UserObject *uo3961 = (struct UserObject*)obj3959;
  uo3961->data[1] = (Object)closure3961;
  Method *meth_meth_lexer_3961_consume_40_1_41_ = addmethod2pos(obj3959, "consume(1)", &meth_lexer_3961_consume_40_1_41_, 1);
  int argcv_meth_lexer_3961_consume_40_1_41_[] = {1};
  meth_meth_lexer_3961_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_3961_consume_40_1_41_);
  meth_meth_lexer_3961_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_3961_consume_40_1_41_->definitionLine = 620;
  sourceObject = obj3959;
  objclass3959 = obj3959->class;
  objclass3959->definitionModule = modulename;
  objclass3959->definitionLine = 619;
  (*(struct UserObject *)self).data[0] = lowerouter3959;
  self = oldself3959;
  selfslot = oldselfslot3959;
  stackframe = oldstackframe3959;
  adddatum2(obj98, obj3959, 57);
  sourceObject = obj98;
  Object inheritingObject4130 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4130 = alloc_userobj2(1,2, objclass4130);
  gc_frame_newslot(obj4130);
  if (objclass4130 == NULL) {
    glfree(obj4130->class->name);
    obj4130->class->name = "numberBaseState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4130, obj98, 0);
  addmethodreal(obj4130,"outer", &reader_lexer_outer_4131);
  Object oldself4130 = self;
  struct StackFrameObject *oldstackframe4130 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4130);
  gc_frame_newslot((Object)stackframe);
  self = obj4130;
  Object *oldselfslot4130 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4130 = (*(struct UserObject *)self).data[0], lowerouter4130 = thisouter4130;
  if (inheritingObject4130) {
    struct UserObject *inho4130 = (struct UserObject *)inheritingObject4130;
    while (inho4130->super != GraceDefaultObject) inho4130 = (struct UserObject *)inho4130->super;
    inho4130->super = obj4130;
    self = inheritingObject4130;
    *selfslot = self;
    lowerouter4130 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4130;
  }
// method "consume(_)"
  struct UserObject *uo4132 = (struct UserObject*)obj4130;
  uo4132->data[1] = emptyclosure;
  Method *meth_meth_lexer_4132_consume_40_1_41_ = addmethod2pos(obj4130, "consume(1)", &meth_lexer_4132_consume_40_1_41_, 1);
  int argcv_meth_lexer_4132_consume_40_1_41_[] = {1};
  meth_meth_lexer_4132_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_4132_consume_40_1_41_);
  meth_meth_lexer_4132_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_4132_consume_40_1_41_->definitionLine = 650;
  sourceObject = obj4130;
  objclass4130 = obj4130->class;
  objclass4130->definitionModule = modulename;
  objclass4130->definitionLine = 649;
  (*(struct UserObject *)self).data[0] = lowerouter4130;
  self = oldself4130;
  selfslot = oldselfslot4130;
  stackframe = oldstackframe4130;
  adddatum2(obj98, obj4130, 58);
  sourceObject = obj98;
  Object inheritingObject4213 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4213 = alloc_userobj2(1,2, objclass4213);
  gc_frame_newslot(obj4213);
  if (objclass4213 == NULL) {
    glfree(obj4213->class->name);
    obj4213->class->name = "numberDotState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4213, obj98, 0);
  addmethodreal(obj4213,"outer", &reader_lexer_outer_4214);
  Object oldself4213 = self;
  struct StackFrameObject *oldstackframe4213 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4213);
  gc_frame_newslot((Object)stackframe);
  self = obj4213;
  Object *oldselfslot4213 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4213 = (*(struct UserObject *)self).data[0], lowerouter4213 = thisouter4213;
  if (inheritingObject4213) {
    struct UserObject *inho4213 = (struct UserObject *)inheritingObject4213;
    while (inho4213->super != GraceDefaultObject) inho4213 = (struct UserObject *)inho4213->super;
    inho4213->super = obj4213;
    self = inheritingObject4213;
    *selfslot = self;
    lowerouter4213 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4213;
  }
// method "consume(_)"
  block_savedest(obj4213);
  Object closure4215 = createclosure(1, "consume(1)");
  setclosureframe(closure4215, stackframe);
  addtoclosure(closure4215, var_spaceChars);
  struct UserObject *uo4215 = (struct UserObject*)obj4213;
  uo4215->data[1] = (Object)closure4215;
  Method *meth_meth_lexer_4215_consume_40_1_41_ = addmethod2pos(obj4213, "consume(1)", &meth_lexer_4215_consume_40_1_41_, 1);
  int argcv_meth_lexer_4215_consume_40_1_41_[] = {1};
  meth_meth_lexer_4215_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_4215_consume_40_1_41_);
  meth_meth_lexer_4215_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_4215_consume_40_1_41_->definitionLine = 666;
  sourceObject = obj4213;
  objclass4213 = obj4213->class;
  objclass4213->definitionModule = modulename;
  objclass4213->definitionLine = 665;
  (*(struct UserObject *)self).data[0] = lowerouter4213;
  self = oldself4213;
  selfslot = oldselfslot4213;
  stackframe = oldstackframe4213;
  adddatum2(obj98, obj4213, 59);
  sourceObject = obj98;
  Object inheritingObject4300 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4300 = alloc_userobj2(1,2, objclass4300);
  gc_frame_newslot(obj4300);
  if (objclass4300 == NULL) {
    glfree(obj4300->class->name);
    obj4300->class->name = "numberFractionState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4300, obj98, 0);
  addmethodreal(obj4300,"outer", &reader_lexer_outer_4301);
  Object oldself4300 = self;
  struct StackFrameObject *oldstackframe4300 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4300);
  gc_frame_newslot((Object)stackframe);
  self = obj4300;
  Object *oldselfslot4300 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4300 = (*(struct UserObject *)self).data[0], lowerouter4300 = thisouter4300;
  if (inheritingObject4300) {
    struct UserObject *inho4300 = (struct UserObject *)inheritingObject4300;
    while (inho4300->super != GraceDefaultObject) inho4300 = (struct UserObject *)inho4300->super;
    inho4300->super = obj4300;
    self = inheritingObject4300;
    *selfslot = self;
    lowerouter4300 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4300;
  }
// method "consume(_)"
  block_savedest(obj4300);
  Object closure4302 = createclosure(1, "consume(1)");
  setclosureframe(closure4302, stackframe);
  addtoclosure(closure4302, var_errormessages);
  struct UserObject *uo4302 = (struct UserObject*)obj4300;
  uo4302->data[1] = (Object)closure4302;
  Method *meth_meth_lexer_4302_consume_40_1_41_ = addmethod2pos(obj4300, "consume(1)", &meth_lexer_4302_consume_40_1_41_, 1);
  int argcv_meth_lexer_4302_consume_40_1_41_[] = {1};
  meth_meth_lexer_4302_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_4302_consume_40_1_41_);
  meth_meth_lexer_4302_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_4302_consume_40_1_41_->definitionLine = 685;
  sourceObject = obj4300;
  objclass4300 = obj4300->class;
  objclass4300->definitionModule = modulename;
  objclass4300->definitionLine = 684;
  (*(struct UserObject *)self).data[0] = lowerouter4300;
  self = oldself4300;
  selfslot = oldselfslot4300;
  stackframe = oldstackframe4300;
  adddatum2(obj98, obj4300, 60);
  sourceObject = obj98;
  Object inheritingObject4394 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4394 = alloc_userobj2(1,2, objclass4394);
  gc_frame_newslot(obj4394);
  if (objclass4394 == NULL) {
    glfree(obj4394->class->name);
    obj4394->class->name = "numberExponentSignState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4394, obj98, 0);
  addmethodreal(obj4394,"outer", &reader_lexer_outer_4395);
  Object oldself4394 = self;
  struct StackFrameObject *oldstackframe4394 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4394);
  gc_frame_newslot((Object)stackframe);
  self = obj4394;
  Object *oldselfslot4394 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4394 = (*(struct UserObject *)self).data[0], lowerouter4394 = thisouter4394;
  if (inheritingObject4394) {
    struct UserObject *inho4394 = (struct UserObject *)inheritingObject4394;
    while (inho4394->super != GraceDefaultObject) inho4394 = (struct UserObject *)inho4394->super;
    inho4394->super = obj4394;
    self = inheritingObject4394;
    *selfslot = self;
    lowerouter4394 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4394;
  }
// method "consume(_)"
  block_savedest(obj4394);
  Object closure4396 = createclosure(1, "consume(1)");
  setclosureframe(closure4396, stackframe);
  addtoclosure(closure4396, var_errormessages);
  struct UserObject *uo4396 = (struct UserObject*)obj4394;
  uo4396->data[1] = (Object)closure4396;
  Method *meth_meth_lexer_4396_consume_40_1_41_ = addmethod2pos(obj4394, "consume(1)", &meth_lexer_4396_consume_40_1_41_, 1);
  int argcv_meth_lexer_4396_consume_40_1_41_[] = {1};
  meth_meth_lexer_4396_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_4396_consume_40_1_41_);
  meth_meth_lexer_4396_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_4396_consume_40_1_41_->definitionLine = 704;
  sourceObject = obj4394;
  objclass4394 = obj4394->class;
  objclass4394->definitionModule = modulename;
  objclass4394->definitionLine = 703;
  (*(struct UserObject *)self).data[0] = lowerouter4394;
  self = oldself4394;
  selfslot = oldselfslot4394;
  stackframe = oldstackframe4394;
  adddatum2(obj98, obj4394, 61);
  sourceObject = obj98;
  Object inheritingObject4463 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4463 = alloc_userobj2(1,2, objclass4463);
  gc_frame_newslot(obj4463);
  if (objclass4463 == NULL) {
    glfree(obj4463->class->name);
    obj4463->class->name = "numberExponentState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4463, obj98, 0);
  addmethodreal(obj4463,"outer", &reader_lexer_outer_4464);
  Object oldself4463 = self;
  struct StackFrameObject *oldstackframe4463 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4463);
  gc_frame_newslot((Object)stackframe);
  self = obj4463;
  Object *oldselfslot4463 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4463 = (*(struct UserObject *)self).data[0], lowerouter4463 = thisouter4463;
  if (inheritingObject4463) {
    struct UserObject *inho4463 = (struct UserObject *)inheritingObject4463;
    while (inho4463->super != GraceDefaultObject) inho4463 = (struct UserObject *)inho4463->super;
    inho4463->super = obj4463;
    self = inheritingObject4463;
    *selfslot = self;
    lowerouter4463 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4463;
  }
// method "consume(_)"
  block_savedest(obj4463);
  Object closure4465 = createclosure(1, "consume(1)");
  setclosureframe(closure4465, stackframe);
  addtoclosure(closure4465, var_errormessages);
  struct UserObject *uo4465 = (struct UserObject*)obj4463;
  uo4465->data[1] = (Object)closure4465;
  Method *meth_meth_lexer_4465_consume_40_1_41_ = addmethod2pos(obj4463, "consume(1)", &meth_lexer_4465_consume_40_1_41_, 1);
  int argcv_meth_lexer_4465_consume_40_1_41_[] = {1};
  meth_meth_lexer_4465_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_4465_consume_40_1_41_);
  meth_meth_lexer_4465_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_4465_consume_40_1_41_->definitionLine = 719;
  sourceObject = obj4463;
  objclass4463 = obj4463->class;
  objclass4463->definitionModule = modulename;
  objclass4463->definitionLine = 718;
  (*(struct UserObject *)self).data[0] = lowerouter4463;
  self = oldself4463;
  selfslot = oldselfslot4463;
  stackframe = oldstackframe4463;
  adddatum2(obj98, obj4463, 62);
  sourceObject = obj98;
  Object inheritingObject4606 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4606 = alloc_userobj2(1,2, objclass4606);
  gc_frame_newslot(obj4606);
  if (objclass4606 == NULL) {
    glfree(obj4606->class->name);
    obj4606->class->name = "operatorState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4606, obj98, 0);
  addmethodreal(obj4606,"outer", &reader_lexer_outer_4607);
  Object oldself4606 = self;
  struct StackFrameObject *oldstackframe4606 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4606);
  gc_frame_newslot((Object)stackframe);
  self = obj4606;
  Object *oldselfslot4606 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4606 = (*(struct UserObject *)self).data[0], lowerouter4606 = thisouter4606;
  if (inheritingObject4606) {
    struct UserObject *inho4606 = (struct UserObject *)inheritingObject4606;
    while (inho4606->super != GraceDefaultObject) inho4606 = (struct UserObject *)inho4606->super;
    inho4606->super = obj4606;
    self = inheritingObject4606;
    *selfslot = self;
    lowerouter4606 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4606;
  }
// method "consume(_)"
  struct UserObject *uo4608 = (struct UserObject*)obj4606;
  uo4608->data[1] = emptyclosure;
  Method *meth_meth_lexer_4608_consume_40_1_41_ = addmethod2pos(obj4606, "consume(1)", &meth_lexer_4608_consume_40_1_41_, 1);
  int argcv_meth_lexer_4608_consume_40_1_41_[] = {1};
  meth_meth_lexer_4608_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_4608_consume_40_1_41_);
  meth_meth_lexer_4608_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_4608_consume_40_1_41_->definitionLine = 752;
  sourceObject = obj4606;
  objclass4606 = obj4606->class;
  objclass4606->definitionModule = modulename;
  objclass4606->definitionLine = 751;
  (*(struct UserObject *)self).data[0] = lowerouter4606;
  self = oldself4606;
  selfslot = oldselfslot4606;
  stackframe = oldstackframe4606;
  adddatum2(obj98, obj4606, 63);
  sourceObject = obj98;
  Object inheritingObject4699 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4699 = alloc_userobj2(1,2, objclass4699);
  gc_frame_newslot(obj4699);
  if (objclass4699 == NULL) {
    glfree(obj4699->class->name);
    obj4699->class->name = "indentationState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4699, obj98, 0);
  addmethodreal(obj4699,"outer", &reader_lexer_outer_4700);
  Object oldself4699 = self;
  struct StackFrameObject *oldstackframe4699 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4699);
  gc_frame_newslot((Object)stackframe);
  self = obj4699;
  Object *oldselfslot4699 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4699 = (*(struct UserObject *)self).data[0], lowerouter4699 = thisouter4699;
  if (inheritingObject4699) {
    struct UserObject *inho4699 = (struct UserObject *)inheritingObject4699;
    while (inho4699->super != GraceDefaultObject) inho4699 = (struct UserObject *)inho4699->super;
    inho4699->super = obj4699;
    self = inheritingObject4699;
    *selfslot = self;
    lowerouter4699 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4699;
  }
// method "consume(_)"
  block_savedest(obj4699);
  Object closure4701 = createclosure(1, "consume(1)");
  setclosureframe(closure4701, stackframe);
  addtoclosure(closure4701, var_spaceChars);
  struct UserObject *uo4701 = (struct UserObject*)obj4699;
  uo4701->data[1] = (Object)closure4701;
  Method *meth_meth_lexer_4701_consume_40_1_41_ = addmethod2pos(obj4699, "consume(1)", &meth_lexer_4701_consume_40_1_41_, 1);
  int argcv_meth_lexer_4701_consume_40_1_41_[] = {1};
  meth_meth_lexer_4701_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_4701_consume_40_1_41_);
  meth_meth_lexer_4701_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_4701_consume_40_1_41_->definitionLine = 773;
  sourceObject = obj4699;
  objclass4699 = obj4699->class;
  objclass4699->definitionModule = modulename;
  objclass4699->definitionLine = 772;
  (*(struct UserObject *)self).data[0] = lowerouter4699;
  self = oldself4699;
  selfslot = oldselfslot4699;
  stackframe = oldstackframe4699;
  adddatum2(obj98, obj4699, 64);
  sourceObject = obj98;
  Object inheritingObject4727 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4727 = alloc_userobj2(1,2, objclass4727);
  gc_frame_newslot(obj4727);
  if (objclass4727 == NULL) {
    glfree(obj4727->class->name);
    obj4727->class->name = "commentSpaceState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4727, obj98, 0);
  addmethodreal(obj4727,"outer", &reader_lexer_outer_4728);
  Object oldself4727 = self;
  struct StackFrameObject *oldstackframe4727 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4727);
  gc_frame_newslot((Object)stackframe);
  self = obj4727;
  Object *oldselfslot4727 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4727 = (*(struct UserObject *)self).data[0], lowerouter4727 = thisouter4727;
  if (inheritingObject4727) {
    struct UserObject *inho4727 = (struct UserObject *)inheritingObject4727;
    while (inho4727->super != GraceDefaultObject) inho4727 = (struct UserObject *)inho4727->super;
    inho4727->super = obj4727;
    self = inheritingObject4727;
    *selfslot = self;
    lowerouter4727 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4727;
  }
// method "consume(_)"
  block_savedest(obj4727);
  Object closure4729 = createclosure(1, "consume(1)");
  setclosureframe(closure4729, stackframe);
  addtoclosure(closure4729, var_spaceChars);
  struct UserObject *uo4729 = (struct UserObject*)obj4727;
  uo4729->data[1] = (Object)closure4729;
  Method *meth_meth_lexer_4729_consume_40_1_41_ = addmethod2pos(obj4727, "consume(1)", &meth_lexer_4729_consume_40_1_41_, 1);
  int argcv_meth_lexer_4729_consume_40_1_41_[] = {1};
  meth_meth_lexer_4729_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_4729_consume_40_1_41_);
  meth_meth_lexer_4729_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_4729_consume_40_1_41_->definitionLine = 783;
  sourceObject = obj4727;
  objclass4727 = obj4727->class;
  objclass4727->definitionModule = modulename;
  objclass4727->definitionLine = 782;
  (*(struct UserObject *)self).data[0] = lowerouter4727;
  self = oldself4727;
  selfslot = oldselfslot4727;
  stackframe = oldstackframe4727;
  adddatum2(obj98, obj4727, 65);
  sourceObject = obj98;
  Object inheritingObject4754 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4754 = alloc_userobj2(1,2, objclass4754);
  gc_frame_newslot(obj4754);
  if (objclass4754 == NULL) {
    glfree(obj4754->class->name);
    obj4754->class->name = "commentState";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4754, obj98, 0);
  addmethodreal(obj4754,"outer", &reader_lexer_outer_4755);
  Object oldself4754 = self;
  struct StackFrameObject *oldstackframe4754 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4754);
  gc_frame_newslot((Object)stackframe);
  self = obj4754;
  Object *oldselfslot4754 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4754 = (*(struct UserObject *)self).data[0], lowerouter4754 = thisouter4754;
  if (inheritingObject4754) {
    struct UserObject *inho4754 = (struct UserObject *)inheritingObject4754;
    while (inho4754->super != GraceDefaultObject) inho4754 = (struct UserObject *)inho4754->super;
    inho4754->super = obj4754;
    self = inheritingObject4754;
    *selfslot = self;
    lowerouter4754 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4754;
  }
// method "consume(_)"
  struct UserObject *uo4756 = (struct UserObject*)obj4754;
  uo4756->data[1] = emptyclosure;
  Method *meth_meth_lexer_4756_consume_40_1_41_ = addmethod2pos(obj4754, "consume(1)", &meth_lexer_4756_consume_40_1_41_, 1);
  int argcv_meth_lexer_4756_consume_40_1_41_[] = {1};
  meth_meth_lexer_4756_consume_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_4756_consume_40_1_41_);
  meth_meth_lexer_4756_consume_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_4756_consume_40_1_41_->definitionLine = 792;
  sourceObject = obj4754;
  objclass4754 = obj4754->class;
  objclass4754->definitionModule = modulename;
  objclass4754->definitionLine = 791;
  (*(struct UserObject *)self).data[0] = lowerouter4754;
  self = oldself4754;
  selfslot = oldselfslot4754;
  stackframe = oldstackframe4754;
  adddatum2(obj98, obj4754, 66);
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  objclass98 = obj98->class;
  objclass98->definitionModule = modulename;
  objclass98->definitionLine = 83;
  (*(struct UserObject *)self).data[0] = lowerouter98;
  self = oldself98;
  selfslot = oldselfslot98;
  stackframe = oldstackframe98;
  gc_frame_end(frame);
  return obj98;
}
Object meth_lexer_4794_keywords(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "keywords");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_keywords = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_keywords (depth = 3)
  gc_frame_end(frame);
  return *var_keywords;
}
Object meth_lexer_4868_operatorChars(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "operatorChars");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_operatorChars = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_operatorChars (depth = 3)
  gc_frame_end(frame);
  return *var_operatorChars;
}
Object meth_lexer_4870_spaceChars(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "spaceChars");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spaceChars = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 35
  setline(35);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_spaceChars (depth = 3)
  gc_frame_end(frame);
  return *var_spaceChars;
}
Object meth_lexer_4872_tab(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tab");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tab = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tab (depth = 3)
  gc_frame_end(frame);
  return *var_tab;
}
Object meth_lexer_4874_nl_cr(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "nl_cr");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nl_cr = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 43
  setline(43);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_nl_cr (depth = 3)
  gc_frame_end(frame);
  return *var_nl_cr;
}
Object meth_lexer_4876_selfModes(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "selfModes");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfModes = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 49
  setline(49);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_selfModes (depth = 3)
  gc_frame_end(frame);
  return *var_selfModes;
}
Object meth_lexer_4878_brackets(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "brackets");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_brackets = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 52
  setline(52);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_brackets (depth = 3)
  gc_frame_end(frame);
  return *var_brackets;
}
Object meth_lexer_4880_alphaNums(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "alphaNums");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_alphaNums = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_alphaNums (depth = 3)
  gc_frame_end(frame);
  return *var_alphaNums;
}
Object meth_lexer_4882_digits(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "digits");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_digits = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 62
  setline(62);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_digits (depth = 3)
  gc_frame_end(frame);
  return *var_digits;
}
Object meth_lexer_4884_asciiLetters(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asciiLetters");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_asciiLetters = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_asciiLetters (depth = 3)
  gc_frame_end(frame);
  return *var_asciiLetters;
}
Object module_lexer_init() {
  if (module_lexer) return module_lexer;
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(27, 27);
  module_lexer = self;
  self->class->definitionModule = "lexer";
  gc_root(self);
  prelude = module_standardGrace_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule("lexer");
  setsource(originalSourceLines);
  setclassname(self, "Module<lexer>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(27, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
// end of preamble
  Object params[2];
  int partcv[1];
// definebindings:
  Object *var_util = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "util");
  Object *var_unicode = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "unicode");
  Object *var_errormessages = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "errormessages");
  Object *var_map = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "map");
  Object *var_keywords = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "keywords");
  Object *var_operatorChars = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "operatorChars");
  Object *var_spaceChars = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "spaceChars");
  Object *var_tab = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "tab");
  Object *var_nl_cr = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "nl_cr");
  Object *var_selfModes = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "selfModes");
  Object *var_brackets = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "brackets");
  Object *var_alphaNums = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "alphaNums");
  Object *var_digits = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "digits");
  Object *var_asciiLetters = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "asciiLetters");
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "isOperatorChar(_,_)"
  block_savedest(self);
  Object closure1 = createclosure(2, "isOperatorChar(2)");
  setclosureframe(closure1, stackframe);
  addtoclosure(closure1, var_operatorChars);
  addtoclosure(closure1, var_unicode);
  struct UserObject *uo1 = (struct UserObject*)self;
  uo1->data[1] = (Object)closure1;
  Method *meth_meth_lexer_1_isOperatorChar_40_2_41_ = addmethod2pos(self, "isOperatorChar(2)", &meth_lexer_1_isOperatorChar_40_2_41_, 1);
  int argcv_meth_lexer_1_isOperatorChar_40_2_41_[] = {2};
  meth_meth_lexer_1_isOperatorChar_40_2_41_->type = alloc_MethodType(1, argcv_meth_lexer_1_isOperatorChar_40_2_41_);
  meth_meth_lexer_1_isOperatorChar_40_2_41_->definitionModule = modulename;
  meth_meth_lexer_1_isOperatorChar_40_2_41_->definitionLine = 28;
// compiled method node returning  (depth = 1)
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "isBadSeparator(_)"
  block_savedest(self);
  Object closure16 = createclosure(3, "isBadSeparator(1)");
  setclosureframe(closure16, stackframe);
  addtoclosure(closure16, var_spaceChars);
  addtoclosure(closure16, var_tab);
  addtoclosure(closure16, var_unicode);
  struct UserObject *uo16 = (struct UserObject*)self;
  uo16->data[2] = (Object)closure16;
  Method *meth_meth_lexer_16_isBadSeparator_40_1_41_ = addmethod2pos(self, "isBadSeparator(1)", &meth_lexer_16_isBadSeparator_40_1_41_, 2);
  int argcv_meth_lexer_16_isBadSeparator_40_1_41_[] = {1};
  meth_meth_lexer_16_isBadSeparator_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_16_isBadSeparator_40_1_41_);
  meth_meth_lexer_16_isBadSeparator_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_16_isBadSeparator_40_1_41_->definitionLine = 37;
// compiled method node returning  (depth = 1)
// Begin line 44
  setline(44);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "isBadControl(_)"
  block_savedest(self);
  Object closure29 = createclosure(2, "isBadControl(1)");
  setclosureframe(closure29, stackframe);
  addtoclosure(closure29, var_nl_cr);
  addtoclosure(closure29, var_unicode);
  struct UserObject *uo29 = (struct UserObject*)self;
  uo29->data[3] = (Object)closure29;
  Method *meth_meth_lexer_29_isBadControl_40_1_41_ = addmethod2pos(self, "isBadControl(1)", &meth_lexer_29_isBadControl_40_1_41_, 3);
  int argcv_meth_lexer_29_isBadControl_40_1_41_[] = {1};
  meth_meth_lexer_29_isBadControl_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_29_isBadControl_40_1_41_);
  meth_meth_lexer_29_isBadControl_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_29_isBadControl_40_1_41_->definitionLine = 44;
// compiled method node returning  (depth = 1)
// Begin line 50
  setline(50);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "isSelfMode(_)"
  block_savedest(self);
  Object closure37 = createclosure(1, "isSelfMode(1)");
  setclosureframe(closure37, stackframe);
  addtoclosure(closure37, var_selfModes);
  struct UserObject *uo37 = (struct UserObject*)self;
  uo37->data[4] = (Object)closure37;
  Method *meth_meth_lexer_37_isSelfMode_40_1_41_ = addmethod2pos(self, "isSelfMode(1)", &meth_lexer_37_isSelfMode_40_1_41_, 4);
  int argcv_meth_lexer_37_isSelfMode_40_1_41_[] = {1};
  meth_meth_lexer_37_isSelfMode_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_37_isSelfMode_40_1_41_);
  meth_meth_lexer_37_isSelfMode_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_37_isSelfMode_40_1_41_->definitionLine = 50;
// compiled method node returning  (depth = 1)
// Begin line 53
  setline(53);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "isBracket(_)"
  block_savedest(self);
  Object closure40 = createclosure(1, "isBracket(1)");
  setclosureframe(closure40, stackframe);
  addtoclosure(closure40, var_brackets);
  struct UserObject *uo40 = (struct UserObject*)self;
  uo40->data[5] = (Object)closure40;
  Method *meth_meth_lexer_40_isBracket_40_1_41_ = addmethod2pos(self, "isBracket(1)", &meth_lexer_40_isBracket_40_1_41_, 5);
  int argcv_meth_lexer_40_isBracket_40_1_41_[] = {1};
  meth_meth_lexer_40_isBracket_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_40_isBracket_40_1_41_);
  meth_meth_lexer_40_isBracket_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_40_isBracket_40_1_41_->definitionLine = 53;
// compiled method node returning  (depth = 1)
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "isIdentifierChar(_)"
  block_savedest(self);
  Object closure43 = createclosure(2, "isIdentifierChar(1)");
  setclosureframe(closure43, stackframe);
  addtoclosure(closure43, var_alphaNums);
  addtoclosure(closure43, var_unicode);
  struct UserObject *uo43 = (struct UserObject*)self;
  uo43->data[6] = (Object)closure43;
  Method *meth_meth_lexer_43_isIdentifierChar_40_1_41_ = addmethod2pos(self, "isIdentifierChar(1)", &meth_lexer_43_isIdentifierChar_40_1_41_, 6);
  int argcv_meth_lexer_43_isIdentifierChar_40_1_41_[] = {1};
  meth_meth_lexer_43_isIdentifierChar_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_43_isIdentifierChar_40_1_41_);
  meth_meth_lexer_43_isIdentifierChar_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_43_isIdentifierChar_40_1_41_->definitionLine = 56;
// compiled method node returning  (depth = 1)
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "isDigit(_)"
  block_savedest(self);
  Object closure59 = createclosure(1, "isDigit(1)");
  setclosureframe(closure59, stackframe);
  addtoclosure(closure59, var_digits);
  struct UserObject *uo59 = (struct UserObject*)self;
  uo59->data[7] = (Object)closure59;
  Method *meth_meth_lexer_59_isDigit_40_1_41_ = addmethod2pos(self, "isDigit(1)", &meth_lexer_59_isDigit_40_1_41_, 7);
  int argcv_meth_lexer_59_isDigit_40_1_41_[] = {1};
  meth_meth_lexer_59_isDigit_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_59_isDigit_40_1_41_);
  meth_meth_lexer_59_isDigit_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_59_isDigit_40_1_41_->definitionLine = 63;
// compiled method node returning  (depth = 1)
// Begin line 66
  setline(66);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "isLetter(_)"
  block_savedest(self);
  Object closure62 = createclosure(2, "isLetter(1)");
  setclosureframe(closure62, stackframe);
  addtoclosure(closure62, var_asciiLetters);
  addtoclosure(closure62, var_unicode);
  struct UserObject *uo62 = (struct UserObject*)self;
  uo62->data[8] = (Object)closure62;
  Method *meth_meth_lexer_62_isLetter_40_1_41_ = addmethod2pos(self, "isLetter(1)", &meth_lexer_62_isLetter_40_1_41_, 8);
  int argcv_meth_lexer_62_isLetter_40_1_41_[] = {1};
  meth_meth_lexer_62_isLetter_40_1_41_->type = alloc_MethodType(1, argcv_meth_lexer_62_isLetter_40_1_41_);
  meth_meth_lexer_62_isLetter_40_1_41_->definitionModule = modulename;
  meth_meth_lexer_62_isLetter_40_1_41_->definitionLine = 66;
// compiled method node returning  (depth = 1)
// Begin line 72
  setline(72);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "padl(_,_,_)"
  struct UserObject *uo73 = (struct UserObject*)self;
  uo73->data[9] = emptyclosure;
  Method *meth_meth_lexer_73_padl_40_3_41_ = addmethod2pos(self, "padl(3)", &meth_lexer_73_padl_40_3_41_, 9);
  int argcv_meth_lexer_73_padl_40_3_41_[] = {3};
  meth_meth_lexer_73_padl_40_3_41_->type = alloc_MethodType(1, argcv_meth_lexer_73_padl_40_3_41_);
  meth_meth_lexer_73_padl_40_3_41_->definitionModule = modulename;
  meth_meth_lexer_73_padl_40_3_41_->definitionLine = 72;
// compiled method node returning  (depth = 1)
// Begin line 83
  setline(83);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "new"
  block_savedest(self);
  Object closure97 = createclosure(5, "new");
  setclosureframe(closure97, stackframe);
  addtoclosure(closure97, var_util);
  addtoclosure(closure97, var_errormessages);
  addtoclosure(closure97, var_spaceChars);
  addtoclosure(closure97, var_unicode);
  addtoclosure(closure97, var_keywords);
  struct UserObject *uo97 = (struct UserObject*)self;
  uo97->data[10] = (Object)closure97;
  Method *meth_meth_lexer_97_new = addmethod2pos(self, "new", &meth_lexer_97_new, 10);
  int argcv_meth_lexer_97_new[] = {0};
  meth_meth_lexer_97_new->type = alloc_MethodType(1, argcv_meth_lexer_97_new);
  meth_meth_lexer_97_new->definitionModule = modulename;
  meth_meth_lexer_97_new->definitionLine = 83;
  block_savedest(self);
  Object closure4791 = createclosure(5, "new$object(1)");
  setclosureframe(closure4791, stackframe);
  addtoclosure(closure4791, var_util);
  addtoclosure(closure4791, var_errormessages);
  addtoclosure(closure4791, var_spaceChars);
  addtoclosure(closure4791, var_unicode);
  addtoclosure(closure4791, var_keywords);
  Method *meth_meth_lexer_97_new_object = addmethod2pos(self, "new$object(1)", &meth_lexer_97_new_object, 10);
  meth_meth_lexer_97_new_object->definitionModule = modulename;
  meth_meth_lexer_97_new_object->definitionLine = 83;
// compiled method node returning  (depth = 1)
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of util as util
  if (module_util == NULL)
    module_util = LOAD_MODULE(util);
  *var_util = module_util;
// compiled import node returning done (depth = 1)
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of unicode as unicode
  if (module_unicode == NULL)
    module_unicode = dlmodule("unicode");
  *var_unicode = module_unicode;
// compiled import node returning done (depth = 1)
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of errormessages as errormessages
  if (module_errormessages == NULL)
    module_errormessages = LOAD_MODULE(errormessages);
  *var_errormessages = module_errormessages;
// compiled import node returning done (depth = 1)
// Begin line 5
  setline(5);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of stringMap as map
  if (module_stringMap == NULL)
    module_stringMap = LOAD_MODULE(stringMap);
  *var_map = module_stringMap;
// compiled import node returning done (depth = 1)
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile member node (depth = 2)
  int callframe4792 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_map (depth = 3)
  partcv[0] = 0;
  Object call4793 = callmethodflags(*var_map, "new", 1, partcv, params, 0);
  gc_frame_end(callframe4792);
// compiled member node returning call4793 (depth = 2)
  *var_keywords = call4793;
  if (call4793 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "keywords"
  block_savedest(self);
  Object closure4794 = createclosure(1, "keywords");
  setclosureframe(closure4794, stackframe);
  addtoclosure(closure4794, var_keywords);
  struct UserObject *uo4794 = (struct UserObject*)self;
  uo4794->data[11] = (Object)closure4794;
  Method *meth_meth_lexer_4794_keywords = addmethod2pos(self, "keywords", &meth_lexer_4794_keywords, 11);
  int argcv_meth_lexer_4794_keywords[] = {0};
  meth_meth_lexer_4794_keywords->type = alloc_MethodType(1, argcv_meth_lexer_4794_keywords);
  meth_meth_lexer_4794_keywords->definitionModule = modulename;
  meth_meth_lexer_4794_keywords->definitionLine = 1145;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 1)
  int callframe4795 = gc_frame_new();
// starting to compile string node (depth = 2)
  if (strlit4796 == NULL) {
    strlit4796 = alloc_String("alias");
    gc_root(strlit4796);
  }
// compiled string node returning strlit4796 (depth = 2)
  gc_frame_newslot(strlit4796);
// starting to compile identifier node (depth = 2)
  Object bool4797 = alloc_Boolean(1);
// compiled identifier node returning bool4797 (depth = 2)
  gc_frame_newslot(bool4797);
// call case 6: other requests
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_keywords (depth = 2)
  params[0] = strlit4796;
  params[1] = bool4797;
  partcv[0] = 2;
  Object call4798 = callmethodflags(*var_keywords, "put(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4795);
// compiled call node returning call4798 (depth = 1)
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 1)
  int callframe4799 = gc_frame_new();
// starting to compile string node (depth = 2)
  if (strlit4800 == NULL) {
    strlit4800 = alloc_String("class");
    gc_root(strlit4800);
  }
// compiled string node returning strlit4800 (depth = 2)
  gc_frame_newslot(strlit4800);
// starting to compile identifier node (depth = 2)
  Object bool4801 = alloc_Boolean(1);
// compiled identifier node returning bool4801 (depth = 2)
  gc_frame_newslot(bool4801);
// call case 6: other requests
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_keywords (depth = 2)
  params[0] = strlit4800;
  params[1] = bool4801;
  partcv[0] = 2;
  Object call4802 = callmethodflags(*var_keywords, "put(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4799);
// compiled call node returning call4802 (depth = 1)
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 1)
  int callframe4803 = gc_frame_new();
// starting to compile string node (depth = 2)
  if (strlit4804 == NULL) {
    strlit4804 = alloc_String("def");
    gc_root(strlit4804);
  }
// compiled string node returning strlit4804 (depth = 2)
  gc_frame_newslot(strlit4804);
// starting to compile identifier node (depth = 2)
  Object bool4805 = alloc_Boolean(1);
// compiled identifier node returning bool4805 (depth = 2)
  gc_frame_newslot(bool4805);
// call case 6: other requests
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_keywords (depth = 2)
  params[0] = strlit4804;
  params[1] = bool4805;
  partcv[0] = 2;
  Object call4806 = callmethodflags(*var_keywords, "put(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4803);
// compiled call node returning call4806 (depth = 1)
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 1)
  int callframe4807 = gc_frame_new();
// starting to compile string node (depth = 2)
  if (strlit4808 == NULL) {
    strlit4808 = alloc_String("dialect");
    gc_root(strlit4808);
  }
// compiled string node returning strlit4808 (depth = 2)
  gc_frame_newslot(strlit4808);
// starting to compile identifier node (depth = 2)
  Object bool4809 = alloc_Boolean(1);
// compiled identifier node returning bool4809 (depth = 2)
  gc_frame_newslot(bool4809);
// call case 6: other requests
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_keywords (depth = 2)
  params[0] = strlit4808;
  params[1] = bool4809;
  partcv[0] = 2;
  Object call4810 = callmethodflags(*var_keywords, "put(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4807);
// compiled call node returning call4810 (depth = 1)
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 1)
  int callframe4811 = gc_frame_new();
// starting to compile string node (depth = 2)
  if (strlit4812 == NULL) {
    strlit4812 = alloc_String("exclude");
    gc_root(strlit4812);
  }
// compiled string node returning strlit4812 (depth = 2)
  gc_frame_newslot(strlit4812);
// starting to compile identifier node (depth = 2)
  Object bool4813 = alloc_Boolean(1);
// compiled identifier node returning bool4813 (depth = 2)
  gc_frame_newslot(bool4813);
// call case 6: other requests
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_keywords (depth = 2)
  params[0] = strlit4812;
  params[1] = bool4813;
  partcv[0] = 2;
  Object call4814 = callmethodflags(*var_keywords, "put(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4811);
// compiled call node returning call4814 (depth = 1)
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 1)
  int callframe4815 = gc_frame_new();
// starting to compile string node (depth = 2)
  if (strlit4816 == NULL) {
    strlit4816 = alloc_String("factory");
    gc_root(strlit4816);
  }
// compiled string node returning strlit4816 (depth = 2)
  gc_frame_newslot(strlit4816);
// starting to compile identifier node (depth = 2)
  Object bool4817 = alloc_Boolean(1);
// compiled identifier node returning bool4817 (depth = 2)
  gc_frame_newslot(bool4817);
// call case 6: other requests
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_keywords (depth = 2)
  params[0] = strlit4816;
  params[1] = bool4817;
  partcv[0] = 2;
  Object call4818 = callmethodflags(*var_keywords, "put(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4815);
// compiled call node returning call4818 (depth = 1)
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 1)
  int callframe4819 = gc_frame_new();
// starting to compile string node (depth = 2)
  if (strlit4820 == NULL) {
    strlit4820 = alloc_String("import");
    gc_root(strlit4820);
  }
// compiled string node returning strlit4820 (depth = 2)
  gc_frame_newslot(strlit4820);
// starting to compile identifier node (depth = 2)
  Object bool4821 = alloc_Boolean(1);
// compiled identifier node returning bool4821 (depth = 2)
  gc_frame_newslot(bool4821);
// call case 6: other requests
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_keywords (depth = 2)
  params[0] = strlit4820;
  params[1] = bool4821;
  partcv[0] = 2;
  Object call4822 = callmethodflags(*var_keywords, "put(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4819);
// compiled call node returning call4822 (depth = 1)
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 1)
  int callframe4823 = gc_frame_new();
// starting to compile string node (depth = 2)
  if (strlit4824 == NULL) {
    strlit4824 = alloc_String("inherit");
    gc_root(strlit4824);
  }
// compiled string node returning strlit4824 (depth = 2)
  gc_frame_newslot(strlit4824);
// starting to compile identifier node (depth = 2)
  Object bool4825 = alloc_Boolean(1);
// compiled identifier node returning bool4825 (depth = 2)
  gc_frame_newslot(bool4825);
// call case 6: other requests
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_keywords (depth = 2)
  params[0] = strlit4824;
  params[1] = bool4825;
  partcv[0] = 2;
  Object call4826 = callmethodflags(*var_keywords, "put(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4823);
// compiled call node returning call4826 (depth = 1)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 1)
  int callframe4827 = gc_frame_new();
// starting to compile string node (depth = 2)
  if (strlit4828 == NULL) {
    strlit4828 = alloc_String("interface");
    gc_root(strlit4828);
  }
// compiled string node returning strlit4828 (depth = 2)
  gc_frame_newslot(strlit4828);
// starting to compile identifier node (depth = 2)
  Object bool4829 = alloc_Boolean(1);
// compiled identifier node returning bool4829 (depth = 2)
  gc_frame_newslot(bool4829);
// call case 6: other requests
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_keywords (depth = 2)
  params[0] = strlit4828;
  params[1] = bool4829;
  partcv[0] = 2;
  Object call4830 = callmethodflags(*var_keywords, "put(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4827);
// compiled call node returning call4830 (depth = 1)
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 1)
  int callframe4831 = gc_frame_new();
// starting to compile string node (depth = 2)
  if (strlit4832 == NULL) {
    strlit4832 = alloc_String("is");
    gc_root(strlit4832);
  }
// compiled string node returning strlit4832 (depth = 2)
  gc_frame_newslot(strlit4832);
// starting to compile identifier node (depth = 2)
  Object bool4833 = alloc_Boolean(1);
// compiled identifier node returning bool4833 (depth = 2)
  gc_frame_newslot(bool4833);
// call case 6: other requests
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_keywords (depth = 2)
  params[0] = strlit4832;
  params[1] = bool4833;
  partcv[0] = 2;
  Object call4834 = callmethodflags(*var_keywords, "put(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4831);
// compiled call node returning call4834 (depth = 1)
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 1)
  int callframe4835 = gc_frame_new();
// starting to compile string node (depth = 2)
  if (strlit4836 == NULL) {
    strlit4836 = alloc_String("method");
    gc_root(strlit4836);
  }
// compiled string node returning strlit4836 (depth = 2)
  gc_frame_newslot(strlit4836);
// starting to compile identifier node (depth = 2)
  Object bool4837 = alloc_Boolean(1);
// compiled identifier node returning bool4837 (depth = 2)
  gc_frame_newslot(bool4837);
// call case 6: other requests
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_keywords (depth = 2)
  params[0] = strlit4836;
  params[1] = bool4837;
  partcv[0] = 2;
  Object call4838 = callmethodflags(*var_keywords, "put(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4835);
// compiled call node returning call4838 (depth = 1)
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 1)
  int callframe4839 = gc_frame_new();
// starting to compile string node (depth = 2)
  if (strlit4840 == NULL) {
    strlit4840 = alloc_String("object");
    gc_root(strlit4840);
  }
// compiled string node returning strlit4840 (depth = 2)
  gc_frame_newslot(strlit4840);
// starting to compile identifier node (depth = 2)
  Object bool4841 = alloc_Boolean(1);
// compiled identifier node returning bool4841 (depth = 2)
  gc_frame_newslot(bool4841);
// call case 6: other requests
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_keywords (depth = 2)
  params[0] = strlit4840;
  params[1] = bool4841;
  partcv[0] = 2;
  Object call4842 = callmethodflags(*var_keywords, "put(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4839);
// compiled call node returning call4842 (depth = 1)
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 1)
  int callframe4843 = gc_frame_new();
// starting to compile string node (depth = 2)
  if (strlit4844 == NULL) {
    strlit4844 = alloc_String("return");
    gc_root(strlit4844);
  }
// compiled string node returning strlit4844 (depth = 2)
  gc_frame_newslot(strlit4844);
// starting to compile identifier node (depth = 2)
  Object bool4845 = alloc_Boolean(1);
// compiled identifier node returning bool4845 (depth = 2)
  gc_frame_newslot(bool4845);
// call case 6: other requests
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_keywords (depth = 2)
  params[0] = strlit4844;
  params[1] = bool4845;
  partcv[0] = 2;
  Object call4846 = callmethodflags(*var_keywords, "put(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4843);
// compiled call node returning call4846 (depth = 1)
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 1)
  int callframe4847 = gc_frame_new();
// starting to compile string node (depth = 2)
  if (strlit4848 == NULL) {
    strlit4848 = alloc_String("super");
    gc_root(strlit4848);
  }
// compiled string node returning strlit4848 (depth = 2)
  gc_frame_newslot(strlit4848);
// starting to compile identifier node (depth = 2)
  Object bool4849 = alloc_Boolean(1);
// compiled identifier node returning bool4849 (depth = 2)
  gc_frame_newslot(bool4849);
// call case 6: other requests
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_keywords (depth = 2)
  params[0] = strlit4848;
  params[1] = bool4849;
  partcv[0] = 2;
  Object call4850 = callmethodflags(*var_keywords, "put(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4847);
// compiled call node returning call4850 (depth = 1)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 1)
  int callframe4851 = gc_frame_new();
// starting to compile string node (depth = 2)
  if (strlit4852 == NULL) {
    strlit4852 = alloc_String("trait");
    gc_root(strlit4852);
  }
// compiled string node returning strlit4852 (depth = 2)
  gc_frame_newslot(strlit4852);
// starting to compile identifier node (depth = 2)
  Object bool4853 = alloc_Boolean(1);
// compiled identifier node returning bool4853 (depth = 2)
  gc_frame_newslot(bool4853);
// call case 6: other requests
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_keywords (depth = 2)
  params[0] = strlit4852;
  params[1] = bool4853;
  partcv[0] = 2;
  Object call4854 = callmethodflags(*var_keywords, "put(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4851);
// compiled call node returning call4854 (depth = 1)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 1)
  int callframe4855 = gc_frame_new();
// starting to compile string node (depth = 2)
  if (strlit4856 == NULL) {
    strlit4856 = alloc_String("type");
    gc_root(strlit4856);
  }
// compiled string node returning strlit4856 (depth = 2)
  gc_frame_newslot(strlit4856);
// starting to compile identifier node (depth = 2)
  Object bool4857 = alloc_Boolean(1);
// compiled identifier node returning bool4857 (depth = 2)
  gc_frame_newslot(bool4857);
// call case 6: other requests
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_keywords (depth = 2)
  params[0] = strlit4856;
  params[1] = bool4857;
  partcv[0] = 2;
  Object call4858 = callmethodflags(*var_keywords, "put(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4855);
// compiled call node returning call4858 (depth = 1)
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 1)
  int callframe4859 = gc_frame_new();
// starting to compile string node (depth = 2)
  if (strlit4860 == NULL) {
    strlit4860 = alloc_String("use");
    gc_root(strlit4860);
  }
// compiled string node returning strlit4860 (depth = 2)
  gc_frame_newslot(strlit4860);
// starting to compile identifier node (depth = 2)
  Object bool4861 = alloc_Boolean(1);
// compiled identifier node returning bool4861 (depth = 2)
  gc_frame_newslot(bool4861);
// call case 6: other requests
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_keywords (depth = 2)
  params[0] = strlit4860;
  params[1] = bool4861;
  partcv[0] = 2;
  Object call4862 = callmethodflags(*var_keywords, "put(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4859);
// compiled call node returning call4862 (depth = 1)
// Begin line 25
  setline(25);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 1)
  int callframe4863 = gc_frame_new();
// starting to compile string node (depth = 2)
  if (strlit4864 == NULL) {
    strlit4864 = alloc_String("var");
    gc_root(strlit4864);
  }
// compiled string node returning strlit4864 (depth = 2)
  gc_frame_newslot(strlit4864);
// starting to compile identifier node (depth = 2)
  Object bool4865 = alloc_Boolean(1);
// compiled identifier node returning bool4865 (depth = 2)
  gc_frame_newslot(bool4865);
// call case 6: other requests
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_keywords (depth = 2)
  params[0] = strlit4864;
  params[1] = bool4865;
  partcv[0] = 2;
  Object call4866 = callmethodflags(*var_keywords, "put(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4863);
// compiled call node returning call4866 (depth = 1)
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile string node (depth = 2)
  if (strlit4867 == NULL) {
    strlit4867 = alloc_String("-&|:$#\\%^@?*/+!~");
    gc_root(strlit4867);
  }
// compiled string node returning strlit4867 (depth = 2)
  *var_operatorChars = strlit4867;
  if (strlit4867 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "operatorChars"
  block_savedest(self);
  Object closure4868 = createclosure(1, "operatorChars");
  setclosureframe(closure4868, stackframe);
  addtoclosure(closure4868, var_operatorChars);
  struct UserObject *uo4868 = (struct UserObject*)self;
  uo4868->data[12] = (Object)closure4868;
  Method *meth_meth_lexer_4868_operatorChars = addmethod2pos(self, "operatorChars", &meth_lexer_4868_operatorChars, 12);
  int argcv_meth_lexer_4868_operatorChars[] = {0};
  meth_meth_lexer_4868_operatorChars->type = alloc_MethodType(1, argcv_meth_lexer_4868_operatorChars);
  meth_meth_lexer_4868_operatorChars->definitionModule = modulename;
  meth_meth_lexer_4868_operatorChars->definitionLine = 1145;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 35
  setline(35);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile string node (depth = 2)
  if (strlit4869 == NULL) {
    strlit4869 = alloc_String(" ""\xc2""""\xa0""");
    gc_root(strlit4869);
  }
// compiled string node returning strlit4869 (depth = 2)
  *var_spaceChars = strlit4869;
  if (strlit4869 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "spaceChars"
  block_savedest(self);
  Object closure4870 = createclosure(1, "spaceChars");
  setclosureframe(closure4870, stackframe);
  addtoclosure(closure4870, var_spaceChars);
  struct UserObject *uo4870 = (struct UserObject*)self;
  uo4870->data[13] = (Object)closure4870;
  Method *meth_meth_lexer_4870_spaceChars = addmethod2pos(self, "spaceChars", &meth_lexer_4870_spaceChars, 13);
  int argcv_meth_lexer_4870_spaceChars[] = {0};
  meth_meth_lexer_4870_spaceChars->type = alloc_MethodType(1, argcv_meth_lexer_4870_spaceChars);
  meth_meth_lexer_4870_spaceChars->definitionModule = modulename;
  meth_meth_lexer_4870_spaceChars->definitionLine = 1145;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile string node (depth = 2)
  if (strlit4871 == NULL) {
    strlit4871 = alloc_String("""\x09""");
    gc_root(strlit4871);
  }
// compiled string node returning strlit4871 (depth = 2)
  *var_tab = strlit4871;
  if (strlit4871 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "tab"
  block_savedest(self);
  Object closure4872 = createclosure(1, "tab");
  setclosureframe(closure4872, stackframe);
  addtoclosure(closure4872, var_tab);
  struct UserObject *uo4872 = (struct UserObject*)self;
  uo4872->data[14] = (Object)closure4872;
  Method *meth_meth_lexer_4872_tab = addmethod2pos(self, "tab", &meth_lexer_4872_tab, 14);
  int argcv_meth_lexer_4872_tab[] = {0};
  meth_meth_lexer_4872_tab->type = alloc_MethodType(1, argcv_meth_lexer_4872_tab);
  meth_meth_lexer_4872_tab->definitionModule = modulename;
  meth_meth_lexer_4872_tab->definitionLine = 1145;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 43
  setline(43);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile string node (depth = 2)
  if (strlit4873 == NULL) {
    strlit4873 = alloc_String("""\x0a""""\x0d""");
    gc_root(strlit4873);
  }
// compiled string node returning strlit4873 (depth = 2)
  *var_nl_cr = strlit4873;
  if (strlit4873 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "nl_cr"
  block_savedest(self);
  Object closure4874 = createclosure(1, "nl_cr");
  setclosureframe(closure4874, stackframe);
  addtoclosure(closure4874, var_nl_cr);
  struct UserObject *uo4874 = (struct UserObject*)self;
  uo4874->data[15] = (Object)closure4874;
  Method *meth_meth_lexer_4874_nl_cr = addmethod2pos(self, "nl_cr", &meth_lexer_4874_nl_cr, 15);
  int argcv_meth_lexer_4874_nl_cr[] = {0};
  meth_meth_lexer_4874_nl_cr->type = alloc_MethodType(1, argcv_meth_lexer_4874_nl_cr);
  meth_meth_lexer_4874_nl_cr->definitionModule = modulename;
  meth_meth_lexer_4874_nl_cr->definitionLine = 1145;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 49
  setline(49);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile string node (depth = 2)
  if (strlit4875 == NULL) {
    strlit4875 = alloc_String("(),{}[];""\xe2""""\x9f""""\xa6""""\xe2""""\x9f""""\xa7""");
    gc_root(strlit4875);
  }
// compiled string node returning strlit4875 (depth = 2)
  *var_selfModes = strlit4875;
  if (strlit4875 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "selfModes"
  block_savedest(self);
  Object closure4876 = createclosure(1, "selfModes");
  setclosureframe(closure4876, stackframe);
  addtoclosure(closure4876, var_selfModes);
  struct UserObject *uo4876 = (struct UserObject*)self;
  uo4876->data[16] = (Object)closure4876;
  Method *meth_meth_lexer_4876_selfModes = addmethod2pos(self, "selfModes", &meth_lexer_4876_selfModes, 16);
  int argcv_meth_lexer_4876_selfModes[] = {0};
  meth_meth_lexer_4876_selfModes->type = alloc_MethodType(1, argcv_meth_lexer_4876_selfModes);
  meth_meth_lexer_4876_selfModes->definitionModule = modulename;
  meth_meth_lexer_4876_selfModes->definitionLine = 1145;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 52
  setline(52);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile string node (depth = 2)
  if (strlit4877 == NULL) {
    strlit4877 = alloc_String("(){}[]""\xe2""""\x9f""""\xa6""""\xe2""""\x9f""""\xa7""");
    gc_root(strlit4877);
  }
// compiled string node returning strlit4877 (depth = 2)
  *var_brackets = strlit4877;
  if (strlit4877 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "brackets"
  block_savedest(self);
  Object closure4878 = createclosure(1, "brackets");
  setclosureframe(closure4878, stackframe);
  addtoclosure(closure4878, var_brackets);
  struct UserObject *uo4878 = (struct UserObject*)self;
  uo4878->data[17] = (Object)closure4878;
  Method *meth_meth_lexer_4878_brackets = addmethod2pos(self, "brackets", &meth_lexer_4878_brackets, 17);
  int argcv_meth_lexer_4878_brackets[] = {0};
  meth_meth_lexer_4878_brackets->type = alloc_MethodType(1, argcv_meth_lexer_4878_brackets);
  meth_meth_lexer_4878_brackets->definitionModule = modulename;
  meth_meth_lexer_4878_brackets->definitionLine = 1145;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile string node (depth = 2)
  if (strlit4879 == NULL) {
    strlit4879 = alloc_String("_'0123456789abcdefghijklmnopqrstuvwzyzABCDEFGHIJKLMNOPQRSTUVWXYZ");
    gc_root(strlit4879);
  }
// compiled string node returning strlit4879 (depth = 2)
  *var_alphaNums = strlit4879;
  if (strlit4879 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "alphaNums"
  block_savedest(self);
  Object closure4880 = createclosure(1, "alphaNums");
  setclosureframe(closure4880, stackframe);
  addtoclosure(closure4880, var_alphaNums);
  struct UserObject *uo4880 = (struct UserObject*)self;
  uo4880->data[18] = (Object)closure4880;
  Method *meth_meth_lexer_4880_alphaNums = addmethod2pos(self, "alphaNums", &meth_lexer_4880_alphaNums, 18);
  int argcv_meth_lexer_4880_alphaNums[] = {0};
  meth_meth_lexer_4880_alphaNums->type = alloc_MethodType(1, argcv_meth_lexer_4880_alphaNums);
  meth_meth_lexer_4880_alphaNums->definitionModule = modulename;
  meth_meth_lexer_4880_alphaNums->definitionLine = 1145;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 62
  setline(62);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile string node (depth = 2)
  if (strlit4881 == NULL) {
    strlit4881 = alloc_String("0123456789");
    gc_root(strlit4881);
  }
// compiled string node returning strlit4881 (depth = 2)
  *var_digits = strlit4881;
  if (strlit4881 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "digits"
  block_savedest(self);
  Object closure4882 = createclosure(1, "digits");
  setclosureframe(closure4882, stackframe);
  addtoclosure(closure4882, var_digits);
  struct UserObject *uo4882 = (struct UserObject*)self;
  uo4882->data[19] = (Object)closure4882;
  Method *meth_meth_lexer_4882_digits = addmethod2pos(self, "digits", &meth_lexer_4882_digits, 19);
  int argcv_meth_lexer_4882_digits[] = {0};
  meth_meth_lexer_4882_digits->type = alloc_MethodType(1, argcv_meth_lexer_4882_digits);
  meth_meth_lexer_4882_digits->definitionModule = modulename;
  meth_meth_lexer_4882_digits->definitionLine = 1145;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile string node (depth = 2)
  if (strlit4883 == NULL) {
    strlit4883 = alloc_String("abcdefghijklmnopqrstuvwzyzABCDEFGHIJKLMNOPQRSTUVWXYZ");
    gc_root(strlit4883);
  }
// compiled string node returning strlit4883 (depth = 2)
  *var_asciiLetters = strlit4883;
  if (strlit4883 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "asciiLetters"
  block_savedest(self);
  Object closure4884 = createclosure(1, "asciiLetters");
  setclosureframe(closure4884, stackframe);
  addtoclosure(closure4884, var_asciiLetters);
  struct UserObject *uo4884 = (struct UserObject*)self;
  uo4884->data[20] = (Object)closure4884;
  Method *meth_meth_lexer_4884_asciiLetters = addmethod2pos(self, "asciiLetters", &meth_lexer_4884_asciiLetters, 20);
  int argcv_meth_lexer_4884_asciiLetters[] = {0};
  meth_meth_lexer_4884_asciiLetters->type = alloc_MethodType(1, argcv_meth_lexer_4884_asciiLetters);
  meth_meth_lexer_4884_asciiLetters->definitionModule = modulename;
  meth_meth_lexer_4884_asciiLetters->definitionLine = 1145;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
  gc_frame_end(frame);
  return self;
}
